{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module System.Console.ANSI.Curry_Codes
  ( d_C_cursorPos
  , d_C_cursorHome
  , d_C_cursorUp
  , d_C_cursorDown
  , d_C_cursorFwd
  , d_C_cursorBack
  , d_C_saveCursor
  , d_C_restoreCursor
  , d_C_clear
  , d_C_eraseLine
  , d_C_normal
  , d_C_bold
  , d_C_faint
  , d_C_italic
  , d_C_underline
  , d_C_blinkSlow
  , d_C_blinkRapid
  , d_C_inverse
  , d_C_concealed
  , d_C_crossedout
  , d_C_black
  , d_C_red
  , d_C_green
  , d_C_yellow
  , d_C_blue
  , d_C_magenta
  , d_C_cyan
  , d_C_white
  , d_C_fgDefault
  , d_C_bgBlack
  , d_C_bgRed
  , d_C_bgGreen
  , d_C_bgYellow
  , d_C_bgBlue
  , d_C_bgMagenta
  , d_C_bgCyan
  , d_C_bgWhite
  , d_C_bgDefault )
  where

import Basics
import qualified Data.Curry_List
import qualified Curry_Prelude


d_C_cursorPos :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_cursorPos x1 x2 cd cs = d_C_cmd (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs) x1 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  ";") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs) x2 cd cs) (Curry_Prelude.toCurryString "H") cd cs) cd cs) cd cs) cd cs

d_C_cursorHome :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_cursorHome cd cs = d_C_cmd (Curry_Prelude.toCurryString "H") cd cs

d_C_cursorUp :: Cover -> ConstStore -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_cursorUp cd cs = d_C_moveCursor (Curry_Prelude.toCurryString "A")

d_C_cursorDown :: Cover -> ConstStore -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_cursorDown cd cs = d_C_moveCursor (Curry_Prelude.toCurryString "B")

d_C_cursorFwd :: Cover -> ConstStore -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_cursorFwd cd cs = d_C_moveCursor (Curry_Prelude.toCurryString "C")

d_C_cursorBack :: Cover -> ConstStore -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_cursorBack cd cs = d_C_moveCursor (Curry_Prelude.toCurryString "D")

d_C_saveCursor :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_saveCursor cd cs = d_C_cmd (Curry_Prelude.toCurryString "s") cd cs

d_C_restoreCursor :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_restoreCursor cd cs = d_C_cmd (Curry_Prelude.toCurryString "u") cd cs

d_C_clear :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_clear cd cs = d_C_cmd (Curry_Prelude.toCurryString "2J") cd cs

d_C_eraseLine :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_eraseLine cd cs = d_C_cmd (Curry_Prelude.toCurryString "K") cd cs

d_C_normal :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_normal cd cs = d_C_mode (Curry_Prelude.C_Int (0))

d_C_bold :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_bold cd cs = d_C_mode (Curry_Prelude.C_Int (1))

d_C_faint :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_faint cd cs = d_C_mode (Curry_Prelude.C_Int (2))

d_C_italic :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_italic cd cs = d_C_mode (Curry_Prelude.C_Int (3))

d_C_underline :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_underline cd cs = d_C_mode (Curry_Prelude.C_Int (4))

d_C_blinkSlow :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_blinkSlow cd cs = d_C_mode (Curry_Prelude.C_Int (5))

d_C_blinkRapid :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_blinkRapid cd cs = d_C_mode (Curry_Prelude.C_Int (6))

d_C_inverse :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_inverse cd cs = d_C_mode (Curry_Prelude.C_Int (7))

d_C_concealed :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_concealed cd cs = d_C_mode (Curry_Prelude.C_Int (8))

d_C_crossedout :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_crossedout cd cs = d_C_mode (Curry_Prelude.C_Int (9))

d_C_black :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_black cd cs = d_C_mode (Curry_Prelude.C_Int (30))

d_C_red :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_red cd cs = d_C_mode (Curry_Prelude.C_Int (31))

d_C_green :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_green cd cs = d_C_mode (Curry_Prelude.C_Int (32))

d_C_yellow :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_yellow cd cs = d_C_mode (Curry_Prelude.C_Int (33))

d_C_blue :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_blue cd cs = d_C_mode (Curry_Prelude.C_Int (34))

d_C_magenta :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_magenta cd cs = d_C_mode (Curry_Prelude.C_Int (35))

d_C_cyan :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_cyan cd cs = d_C_mode (Curry_Prelude.C_Int (36))

d_C_white :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_white cd cs = d_C_mode (Curry_Prelude.C_Int (37))

d_C_fgDefault :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_fgDefault cd cs = d_C_mode (Curry_Prelude.C_Int (39))

d_C_bgBlack :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_bgBlack cd cs = d_C_mode (Curry_Prelude.C_Int (40))

d_C_bgRed :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_bgRed cd cs = d_C_mode (Curry_Prelude.C_Int (41))

d_C_bgGreen :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_bgGreen cd cs = d_C_mode (Curry_Prelude.C_Int (42))

d_C_bgYellow :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_bgYellow cd cs = d_C_mode (Curry_Prelude.C_Int (43))

d_C_bgBlue :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_bgBlue cd cs = d_C_mode (Curry_Prelude.C_Int (44))

d_C_bgMagenta :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_bgMagenta cd cs = d_C_mode (Curry_Prelude.C_Int (45))

d_C_bgCyan :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_bgCyan cd cs = d_C_mode (Curry_Prelude.C_Int (46))

d_C_bgWhite :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_bgWhite cd cs = d_C_mode (Curry_Prelude.C_Int (47))

d_C_bgDefault :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_bgDefault cd cs = d_C_mode (Curry_Prelude.C_Int (49))

d_C_moveCursor :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_moveCursor x1 x2 cd cs = d_C_cmd (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs) x2 cd cs) x1 cd cs) cd cs

d_C_mode :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_mode x1 x2 cd cs = let x3 = d_C_cmd (Curry_Prelude.toCurryString "0m") cd cs
  in Curry_Prelude.d_OP_plus_plus (d_C_cmd (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs) x1 cd cs) (Curry_Prelude.toCurryString "m") cd cs) cd cs)
  (Curry_Prelude.d_OP_plus_plus x2 (d_C__case_0 x2 x3
  (Data.Curry_List.d_C_isSuffixOf
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x3 x2 cd cs) cd cs) cd cs) cd cs

d_C_cmd :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_cmd x1 cd cs = Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '\ESC'#)
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '['#) x1)

d_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_0 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> x3
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x2 x3 l cd cs)
    (d_C__case_0 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x2 x3
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "System.Console.ANSI.Codes._case_0" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "System.Console.ANSI.Codes._case_0" (showCons x4))

