{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Test.Benchmark.Curry_Goodies
  ( C_PlotStyle (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
  , d_C_showF2
  , d_C_benchInputsResultsAsTable
  , d_C_benchResultsAsTable
  , d_C_toTableRow
  , d_C_plotResults
  , nd_C_plotResults )
  where

import Basics
import qualified Data.Curry_List
import qualified Curry_Prelude
import qualified System.Curry_FilePath
import qualified System.Curry_Process


data C_PlotStyle
  = C_Lines
  | C_Histogram
  | C_Title (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_XLabel (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_YLabel (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_XTicsRotate Curry_Prelude.C_Int
  | Choice_C_PlotStyle Cover ID C_PlotStyle C_PlotStyle
  | Choices_C_PlotStyle Cover ID [C_PlotStyle]
  | Fail_C_PlotStyle Cover FailInfo
  | Guard_C_PlotStyle Cover Constraints C_PlotStyle

instance Show C_PlotStyle where
  showsPrec d (Choice_C_PlotStyle cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_PlotStyle cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_PlotStyle cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_PlotStyle cd info) = showChar '!'
  showsPrec _ C_Lines = showString "Lines"
  showsPrec _ C_Histogram = showString "Histogram"
  showsPrec _ (C_Title x1) = showString "(Title" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_XLabel x1) = showString "(XLabel" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_YLabel x1) = showString "(YLabel" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_XTicsRotate x1) = showString "(XTicsRotate" . (showChar ' ' .
    (shows x1 . showChar ')'))

instance Read C_PlotStyle where
  readsPrec d s = readParen False (\r -> [(C_Lines, r0) | (_, r0) <-
    readQualified "Test.Benchmark.Goodies" "Lines" r]) s ++ (readParen False
    (\r -> [(C_Histogram, r0) | (_, r0) <- readQualified
    "Test.Benchmark.Goodies" "Histogram" r]) s ++ (readParen ((>) d 10) (\r ->
    [(C_Title x1, r1) | (_, r0) <- readQualified "Test.Benchmark.Goodies"
    "Title" r, (x1, r1) <- readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r ->
    [(C_XLabel x1, r1) | (_, r0) <- readQualified "Test.Benchmark.Goodies"
    "XLabel" r, (x1, r1) <- readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r ->
    [(C_YLabel x1, r1) | (_, r0) <- readQualified "Test.Benchmark.Goodies"
    "YLabel" r, (x1, r1) <- readsPrec 11 r0]) s ++ readParen ((>) d 10) (\r ->
    [(C_XTicsRotate x1, r1) | (_, r0) <- readQualified "Test.Benchmark.Goodies"
    "XTicsRotate" r, (x1, r1) <- readsPrec 11 r0]) s))))

instance NonDet C_PlotStyle where
  choiceCons = Choice_C_PlotStyle
  choicesCons = Choices_C_PlotStyle
  failCons = Fail_C_PlotStyle
  guardCons = Guard_C_PlotStyle
  try (Choice_C_PlotStyle cd i x y) = tryChoice cd i x y
  try (Choices_C_PlotStyle cd i xs) = tryChoices cd i xs
  try (Fail_C_PlotStyle cd info) = Fail cd info
  try (Guard_C_PlotStyle cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_PlotStyle cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_PlotStyle cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_PlotStyle cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_PlotStyle cd i _) = error
    ("Test.Benchmark.Goodies.PlotStyle.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_PlotStyle cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_PlotStyle cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_PlotStyle where
  generate s c = Choices_C_PlotStyle c (freeID [0, 0, 1, 1, 1, 1] s) [C_Lines
    , C_Histogram, C_Title (generate (leftSupply s) c), C_XLabel (generate
    (leftSupply s) c), C_YLabel (generate (leftSupply s) c), C_XTicsRotate
    (generate (leftSupply s) c)]

instance NormalForm C_PlotStyle where
  ($!!) cont C_Lines d cs = cont C_Lines d cs
  ($!!) cont C_Histogram d cs = cont C_Histogram d cs
  ($!!) cont (C_Title x1) d cs = ($!!) (\y1 d cs -> cont (C_Title y1) d cs) x1 d
    cs
  ($!!) cont (C_XLabel x1) d cs = ($!!) (\y1 d cs -> cont (C_XLabel y1) d cs) x1
    d cs
  ($!!) cont (C_YLabel x1) d cs = ($!!) (\y1 d cs -> cont (C_YLabel y1) d cs) x1
    d cs
  ($!!) cont (C_XTicsRotate x1) d cs = ($!!) (\y1 d cs -> cont (C_XTicsRotate
    y1) d cs) x1 d cs
  ($!!) cont (Choice_C_PlotStyle cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_PlotStyle cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_PlotStyle cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_PlotStyle cd info) _ _ = failCons cd info
  ($##) cont C_Lines d cs = cont C_Lines d cs
  ($##) cont C_Histogram d cs = cont C_Histogram d cs
  ($##) cont (C_Title x1) d cs = ($##) (\y1 d cs -> cont (C_Title y1) d cs) x1 d
    cs
  ($##) cont (C_XLabel x1) d cs = ($##) (\y1 d cs -> cont (C_XLabel y1) d cs) x1
    d cs
  ($##) cont (C_YLabel x1) d cs = ($##) (\y1 d cs -> cont (C_YLabel y1) d cs) x1
    d cs
  ($##) cont (C_XTicsRotate x1) d cs = ($##) (\y1 d cs -> cont (C_XTicsRotate
    y1) d cs) x1 d cs
  ($##) cont (Choice_C_PlotStyle cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_PlotStyle cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_PlotStyle cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_PlotStyle cd info) _ _ = failCons cd info
  showCons C_Lines = "Test.Benchmark.Goodies.Lines"
  showCons C_Histogram = "Test.Benchmark.Goodies.Histogram"
  showCons (C_Title _) = "Test.Benchmark.Goodies.Title _"
  showCons (C_XLabel _) = "Test.Benchmark.Goodies.XLabel _"
  showCons (C_YLabel _) = "Test.Benchmark.Goodies.YLabel _"
  showCons (C_XTicsRotate _) = "Test.Benchmark.Goodies.XTicsRotate _"
  showCons x = error
    ("Test.Benchmark.Goodies.PlotStyle.showCons: no constructor: " ++ show x)
  searchNF _ cont C_Lines = cont C_Lines
  searchNF _ cont C_Histogram = cont C_Histogram
  searchNF search cont (C_Title x1) = search (\y1 -> cont (C_Title y1)) x1
  searchNF search cont (C_XLabel x1) = search (\y1 -> cont (C_XLabel y1)) x1
  searchNF search cont (C_YLabel x1) = search (\y1 -> cont (C_YLabel y1)) x1
  searchNF search cont (C_XTicsRotate x1) = search (\y1 -> cont (C_XTicsRotate
    y1)) x1
  searchNF _ _ x = error
    ("Test.Benchmark.Goodies.PlotStyle.searchNF: no constructor: " ++ show x)

instance Unifiable C_PlotStyle where
  (=.=) C_Lines C_Lines d cs = C_True
  (=.=) C_Histogram C_Histogram d cs = C_True
  (=.=) (C_Title x1) (C_Title y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_XLabel x1) (C_XLabel y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_YLabel x1) (C_YLabel y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_XTicsRotate x1) (C_XTicsRotate y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_Lines C_Lines d cs = C_True
  (=.<=) C_Histogram C_Histogram d cs = C_True
  (=.<=) (C_Title x1) (C_Title y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_XLabel x1) (C_XLabel y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_YLabel x1) (C_YLabel y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_XTicsRotate x1) (C_XTicsRotate y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_Lines = (i :=: ChooseN 0 0) : concat []
  bind cd i C_Histogram = (i :=: ChooseN 1 0) : concat []
  bind cd i (C_Title x3) = (i :=: ChooseN 2 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_XLabel x3) = (i :=: ChooseN 3 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_YLabel x3) = (i :=: ChooseN 4 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_XTicsRotate x3) = (i :=: ChooseN 5 1) : concat [bind cd (leftID
    i) x3]
  bind d i (Choice_C_PlotStyle cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_PlotStyle cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_PlotStyle cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_PlotStyle cd i _) = error
    ("Test.Benchmark.Goodies.PlotStyle.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_PlotStyle cd info) = [Unsolvable info]
  bind d i (Guard_C_PlotStyle cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_Lines = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_Histogram = (i :=: ChooseN 1 0) : []
  lazyBind cd i (C_Title x3) = (i :=: ChooseN 2 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_XLabel x3) = (i :=: ChooseN 3 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_YLabel x3) = (i :=: ChooseN 4 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_XTicsRotate x3) = (i :=: ChooseN 5 1) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_PlotStyle cd j x y) = [ConstraintChoice cd j (lazyBind
    d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_PlotStyle cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_PlotStyle cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_PlotStyle cd i _) = error
    ("Test.Benchmark.Goodies.PlotStyle.lazyBind: Choices with ChoiceID: " ++
    show i)
  lazyBind _ _ (Fail_C_PlotStyle cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_PlotStyle cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_PlotStyle where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_PlotStyle
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._inst#Prelude.Data#Test.Benchmark.Goodies.PlotStyle#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Test.Benchmark.Goodies._inst#Prelude.Data#Test.Benchmark.Goodies.PlotStyle#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash :: C_PlotStyle
  -> C_PlotStyle -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash x1 x2 s cd cs =
  case x1 of
  C_Lines -> d_C__case_18 x2 cd cs
  C_Histogram -> d_C__case_17 x2 cd cs
  C_Title x11 -> let s0 = s in s0 `seq` nd_C__case_16 x11 x2 s0 cd cs
  C_XLabel x16 -> let s0 = s in s0 `seq` nd_C__case_15 x16 x2 s0 cd cs
  C_YLabel x21 -> let s0 = s in s0 `seq` nd_C__case_14 x21 x2 s0 cd cs
  C_XTicsRotate x26 -> d_C__case_13 x26 x2 cd cs
  Choice_C_PlotStyle d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    r x2 s cd cs)
  Choices_C_PlotStyle d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    z x2 s cd cs) xs
  Guard_C_PlotStyle d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_PlotStyle d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._impl#===#Prelude.Data#Test.Benchmark.Goodies.PlotStyle#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Test.Benchmark.Goodies._impl#===#Prelude.Data#Test.Benchmark.Goodies.PlotStyle#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash :: IDSupply
  -> Cover -> ConstStore -> C_PlotStyle
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash s cd cs =
  let s15 = s
  in s15 `seq` (let s14 = leftSupply s15
                    s16 = rightSupply s15
                    s11 = leftSupply s16
                    s13 = rightSupply s16
  in s14 `seq` (s16 `seq` (s11 `seq` (s13 `seq` choice (let s10 = leftSupply s11
                                                            s12 = rightSupply
                                                              s11
                                                            s7 = leftSupply s12
                                                            s9 = rightSupply s12
  in s10 `seq` (s12 `seq` (s7 `seq` (s9 `seq` choice (let s6 = leftSupply s7
                                                          s8 = rightSupply s7
                                                          s3 = leftSupply s8
                                                          s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` choice (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` choice (choice C_Lines C_Histogram
  s0 cd cs) (C_Title
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s1 cd cs)) s2 cd cs)))) (C_XLabel
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s5 cd cs)) s6 cd cs)))) (C_YLabel
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s9 cd cs)) s10 cd cs)))) (C_XTicsRotate
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s13 cd cs)) s14 cd cs))))

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_PlotStyle
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._inst#Prelude.Eq#Test.Benchmark.Goodies.PlotStyle#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Test.Benchmark.Goodies._inst#Prelude.Eq#Test.Benchmark.Goodies.PlotStyle#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_PlotStyle
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._inst#Prelude.Eq#Test.Benchmark.Goodies.PlotStyle#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Test.Benchmark.Goodies._inst#Prelude.Eq#Test.Benchmark.Goodies.PlotStyle#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash :: C_PlotStyle
  -> C_PlotStyle -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash x1 x2 cd cs =
  case x1 of
  C_Lines -> d_C__case_12 x2 cd cs
  C_Histogram -> d_C__case_11 x2 cd cs
  C_Title x11 -> d_C__case_10 x11 x2 cd cs
  C_XLabel x16 -> d_C__case_9 x16 x2 cd cs
  C_YLabel x21 -> d_C__case_8 x21 x2 cd cs
  C_XTicsRotate x26 -> d_C__case_7 x26 x2 cd cs
  Choice_C_PlotStyle d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    r x2 cd cs)
  Choices_C_PlotStyle d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    z x2 cd cs) xs
  Guard_C_PlotStyle d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_PlotStyle d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._impl#==#Prelude.Eq#Test.Benchmark.Goodies.PlotStyle#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Test.Benchmark.Goodies._impl#==#Prelude.Eq#Test.Benchmark.Goodies.PlotStyle#"
    (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash :: Cover
  -> ConstStore -> C_PlotStyle -> Cover -> ConstStore -> C_PlotStyle -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash)

d_C_showF2 :: Curry_Prelude.C_Float -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showF2 x1 cd cs = let x2 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_break
                            (Curry_Prelude.d_C_flip (acceptCs id
                            Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                            (Curry_Prelude.C_Char '.'#)) cd cs)
                            (Curry_Prelude.d_C_apply
                            (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Float_hash
                            cd cs) x1 cd cs) cd cs
                          x3 = d_OP_showF2_dot_uscore_hash_selFP2_hash_xs x2 cd
                            cs
                          x4 = d_OP_showF2_dot_uscore_hash_selFP3_hash_ys x2 cd
                            cs
  in d_C__case_6 x4 x3 (Curry_Prelude.d_C_null x4 cd cs) cd cs

d_OP_showF2_dot_uscore_hash_selFP2_hash_xs :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_showF2_dot_uscore_hash_selFP2_hash_xs x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_showF2_dot_uscore_hash_selFP2_hash_xs l cd cs)
    (d_OP_showF2_dot_uscore_hash_selFP2_hash_xs r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_showF2_dot_uscore_hash_selFP2_hash_xs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_showF2_dot_uscore_hash_selFP2_hash_xs e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Test.Benchmark.Goodies.showF2._#selFP2#xs" [show x1] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies.showF2._#selFP2#xs"
    (showCons x1))

d_OP_showF2_dot_uscore_hash_selFP3_hash_ys :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_showF2_dot_uscore_hash_selFP3_hash_ys x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_showF2_dot_uscore_hash_selFP3_hash_ys l cd cs)
    (d_OP_showF2_dot_uscore_hash_selFP3_hash_ys r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_showF2_dot_uscore_hash_selFP3_hash_ys z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_showF2_dot_uscore_hash_selFP3_hash_ys e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Test.Benchmark.Goodies.showF2._#selFP3#ys" [show x1] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies.showF2._#selFP3#ys"
    (showCons x1))

d_C_benchInputsResultsAsTable :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_benchInputsResultsAsTable x1 x2 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\begin{tabular}{|l|")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_concat cd cs) (Curry_Prelude.d_C_take
    (Curry_Prelude.d_C_length x2 cd cs) (Curry_Prelude.d_C_repeat
    (Curry_Prelude.toCurryString "c|") cd cs) cd cs) cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "}\n")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\\hline\n")
    (Curry_Prelude.d_OP_plus_plus (d_C_toTableRow (Curry_Prelude.OP_Cons x3
    (Curry_Prelude.d_C_map
    d_OP_benchInputsResultsAsTable_dot_uscore_hash_lambda1 x2 cd cs)) cd cs)
    (Curry_Prelude.d_OP_plus_plus (d_C_toTableRow (Curry_Prelude.OP_Cons x4
    (Curry_Prelude.d_C_map
    d_OP_benchInputsResultsAsTable_dot_uscore_hash_lambda2 x2 cd cs)) cd cs)
    (Curry_Prelude.toCurryString "\\hline\n\\end{tabular}\n") cd cs) cd cs) cd
    cs) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_C_benchInputsResultsAsTable l x2 cd cs) (d_C_benchInputsResultsAsTable r
    x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_C_benchInputsResultsAsTable z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_C_benchInputsResultsAsTable e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Test.Benchmark.Goodies.benchInputsResultsAsTable" [show x1, show x2] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies.benchInputsResultsAsTable"
    (showCons x1))

d_OP_benchInputsResultsAsTable_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_benchInputsResultsAsTable_dot_uscore_hash_lambda1 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_benchInputsResultsAsTable_dot_uscore_hash_lambda1 l cd cs)
    (d_OP_benchInputsResultsAsTable_dot_uscore_hash_lambda1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_benchInputsResultsAsTable_dot_uscore_hash_lambda1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_benchInputsResultsAsTable_dot_uscore_hash_lambda1 e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Test.Benchmark.Goodies.benchInputsResultsAsTable._#lambda1" [show x1] info)
  _ -> failCons cd (consFail
    "Test.Benchmark.Goodies.benchInputsResultsAsTable._#lambda1" (showCons x1))

d_OP_benchInputsResultsAsTable_dot_uscore_hash_lambda2 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_benchInputsResultsAsTable_dot_uscore_hash_lambda2 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_benchInputsResultsAsTable_dot_uscore_hash_lambda2 l cd cs)
    (d_OP_benchInputsResultsAsTable_dot_uscore_hash_lambda2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_benchInputsResultsAsTable_dot_uscore_hash_lambda2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_benchInputsResultsAsTable_dot_uscore_hash_lambda2 e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Test.Benchmark.Goodies.benchInputsResultsAsTable._#lambda2" [show x1] info)
  _ -> failCons cd (consFail
    "Test.Benchmark.Goodies.benchInputsResultsAsTable._#lambda2" (showCons x1))

d_C_benchResultsAsTable :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_benchResultsAsTable x1 x2 cd cs = Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\\begin{tabular}{|")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_concat cd cs) (Curry_Prelude.d_C_take
  (Curry_Prelude.d_C_length x1 cd cs) (Curry_Prelude.d_C_repeat
  (Curry_Prelude.toCurryString "r|") cd cs) cd cs) cd cs)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "}\n")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\\hline\n")
  (Curry_Prelude.d_OP_plus_plus (d_C_toTableRow x1 cd cs)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\\hline\n")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_concatMap d_C_toTableRow cd cs) x2 cd cs)
  (Curry_Prelude.toCurryString "\\hline\n\\end{tabular}\n") cd cs) cd cs) cd cs)
  cd cs) cd cs) cd cs) cd cs

d_C_toTableRow :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_toTableRow x1 cd cs = Curry_Prelude.d_OP_plus_plus
  (Data.Curry_List.d_C_intercalate (Curry_Prelude.toCurryString " & ") x1 cd cs)
  (Curry_Prelude.toCurryString " \\\\\n") cd cs

d_C_plotStyle2GP :: C_PlotStyle -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_plotStyle2GP x1 cd cs = case x1 of
  C_Lines -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "set style data linespoints\n") (Curry_Prelude.toCurryString
    "set key right bottom") cd cs
  C_Histogram -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "set style histogram clustered\n") (Curry_Prelude.toCurryString
    "set style data histograms") cd cs
  C_Title x2 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "set title \"") (Curry_Prelude.d_OP_plus_plus x2
    (Curry_Prelude.toCurryString "\"") cd cs) cd cs
  C_XLabel x3 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "set xlabel \"") (Curry_Prelude.d_OP_plus_plus x3
    (Curry_Prelude.toCurryString "\"") cd cs) cd cs
  C_YLabel x4 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "set ylabel \"") (Curry_Prelude.d_OP_plus_plus x4
    (Curry_Prelude.toCurryString "\"") cd cs) cd cs
  C_XTicsRotate x5 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "set xtics rotate by ") (d_C_showInt x5 cd cs) cd cs
  Choice_C_PlotStyle d i l r -> narrow d i (d_C_plotStyle2GP l cd cs)
    (d_C_plotStyle2GP r cd cs)
  Choices_C_PlotStyle d i xs -> narrows cs d i (\z -> d_C_plotStyle2GP z cd cs)
    xs
  Guard_C_PlotStyle d c e -> guardCons d c ((\x -> d_C_plotStyle2GP e cd x) $!
    addCs c cs)
  Fail_C_PlotStyle d info -> failCons d (traceFail
    "Test.Benchmark.Goodies.plotStyle2GP" [show x1] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies.plotStyle2GP" (showCons
    x1))

d_C_showInt :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showInt x1 cd cs = d_C__case_5 x1 (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) x1 cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs

d_C_plotResults :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  C_PlotStyle -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 t0))) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_C_plotResults x1 x2 x3 x4 x5 cd cs = let x6 = Curry_Prelude.d_C_apply
                                             (System.Curry_FilePath.d_C_dropExtension
                                             cd cs) x3 cd cs
                                           x7 = Curry_Prelude.d_C_apply
                                             (System.Curry_FilePath.d_C_takeExtension
                                             cd cs) x3 cd cs
                                           x8 = Curry_Prelude.d_OP_plus_plus x6
                                             (Curry_Prelude.toCurryString "_")
                                             cd cs
                                           x9 = Curry_Prelude.d_OP_plus_plus x6
                                             (Curry_Prelude.toCurryString
                                             ".gpscript") cd cs
                                           x10 = d_C__case_4 x7
                                             (Curry_Prelude.d_C_eqString x7
                                             (Curry_Prelude.toCurryString
                                             ".pdf") cd cs) cd cs
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_mapM
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  (d_C_writeDataFile
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  x1 x2 x8) cd cs) (Curry_Prelude.d_C_zip
  (Curry_Prelude.d_OP_uscore_impl_hash_enumFrom_hash_Prelude_dot_Enum_hash_Prelude_dot_Int_hash
  (Curry_Prelude.C_Int (1)) cd cs) x5 cd cs) cd cs) cd cs)
  (d_OP_plotResults_dot_uscore_hash_lambda5 x3 x9 x10 x4) cd cs

nd_C_plotResults :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  C_PlotStyle -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 t0))) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_C_plotResults x1 x2 x3 x4 x5 s cd cs = let s11 = s
  in s11 `seq` (let s0 = leftSupply s11
                    s12 = rightSupply s11
                    s1 = leftSupply s12
                    s10 = rightSupply s12
  in s0 `seq` (s12 `seq` (s1 `seq` (s10 `seq` (let x6 = Curry_Prelude.nd_C_apply
                                                     (wrapDX id
                                                     (System.Curry_FilePath.d_C_dropExtension
                                                     cd cs)) x3 s0 cd cs
                                                   x7 = Curry_Prelude.nd_C_apply
                                                     (wrapDX id
                                                     (System.Curry_FilePath.d_C_takeExtension
                                                     cd cs)) x3 s1 cd cs
                                                   x8 = Curry_Prelude.d_OP_plus_plus
                                                     x6
                                                     (Curry_Prelude.toCurryString
                                                     "_") cd cs
                                                   x9 = Curry_Prelude.d_OP_plus_plus
                                                     x6
                                                     (Curry_Prelude.toCurryString
                                                     ".gpscript") cd cs
                                                   x10 = d_C__case_4 x7
                                                     (Curry_Prelude.d_C_eqString
                                                     x7
                                                     (Curry_Prelude.toCurryString
                                                     ".pdf") cd cs) cd cs
  in let s9 = leftSupply s10
         s7 = rightSupply s10
  in s9 `seq` (s7 `seq` Curry_Prelude.nd_C_apply (let s6 = leftSupply s7
                                                      s8 = rightSupply s7
                                                      s2 = leftSupply s8
                                                      s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s2 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s2 cd cs) (let s4 = leftSupply s5
                 s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_mapM
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash)
  (wrapNX id (nd_C_writeDataFile (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)
  x1 x2 x8)) s3 cd cs) (Curry_Prelude.d_C_zip
  (Curry_Prelude.d_OP_uscore_impl_hash_enumFrom_hash_Prelude_dot_Enum_hash_Prelude_dot_Int_hash
  (Curry_Prelude.C_Int (1)) cd cs) x5 cd cs) s4 cd cs)) s6 cd cs)))) (wrapDX id
  (d_OP_plotResults_dot_uscore_hash_lambda5 x3 x9 x10 x4)) s9 cd cs))))))

d_OP_plotResults_dot_plotCmd_dot_30 :: Curry_Prelude.OP_List C_PlotStyle
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_plotResults_dot_plotCmd_dot_30 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\"") (Curry_Prelude.d_OP_plus_plus x4
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\" ")
    (Curry_Prelude.d_OP_plus_plus (d_C__case_2 x1 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_elem
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Test_dot_Benchmark_dot_Goodies_dot_PlotStyle_hash
    C_Histogram cd cs) x1 cd cs) cd cs) (d_C__case_1 x3 (Curry_Prelude.d_C_null
    x3 cd cs) cd cs) cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_plotResults_dot_plotCmd_dot_30 x1 l cd cs)
    (d_OP_plotResults_dot_plotCmd_dot_30 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_plotResults_dot_plotCmd_dot_30 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_plotResults_dot_plotCmd_dot_30 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Test.Benchmark.Goodies.plotResults.plotCmd.30" [show x1, show x2] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies.plotResults.plotCmd.30"
    (showCons x2))

d_OP_plotResults_dot_uscore_hash_lambda5 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  C_PlotStyle -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_OP_plotResults_dot_uscore_hash_lambda5 x1 x2 x3 x4 x5 cd cs = let x6 = x5
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_writeFile x2)
  (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_unlines cd cs)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons x3 (Curry_Prelude.OP_Cons
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "set output '")
  (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString "'") cd cs) cd
  cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "set tics nomirror")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString
  "set style fill solid border") Curry_Prelude.OP_List))))
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_map d_C_plotStyle2GP x4 cd
  cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "plot ") (Data.Curry_List.d_C_intercalate
  (Curry_Prelude.toCurryString " , ") (Curry_Prelude.d_C_map
  (d_OP_plotResults_dot_plotCmd_dot_30 x4) x6 cd cs) cd cs) cd cs)
  Curry_Prelude.OP_List) cd cs) cd cs) cd cs) cd cs) cd cs)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar System.Curry_Process.d_C_system
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "gnuplot ") x2 cd
  cs) cd cs) cd cs) (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Data plotted to '") (Curry_Prelude.d_OP_plus_plus x1
  (Curry_Prelude.toCurryString "'") cd cs) cd cs) cd cs) cd cs) cd cs

d_C_writeDataFile :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t2) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t3) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 t3 (Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0))) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_writeDataFile x1 x2 x3 x4 x5 cd cs = case x5 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> d_C__case_0 x6 x1 x4 x2 x3 x7 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_writeDataFile x1 x2
    x3 x4 l cd cs) (d_C_writeDataFile x1 x2 x3 x4 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_C_writeDataFile x1 x2 x3 x4 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C_writeDataFile
    x1 x2 x3 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Test.Benchmark.Goodies.writeDataFile" [show x1, show x2, show x3, show x4
    , show x5] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies.writeDataFile" (showCons
    x5))

nd_C_writeDataFile :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t2) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t3)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 t3
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1
  t0))) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_C_writeDataFile x1 x2 x3 x4 x5 s cd cs = case x5 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s0 = s
    in s0 `seq` nd_C__case_0 x6 x1 x4 x2 x3 x7 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_writeDataFile x1 x2
    x3 x4 l s cd cs) (nd_C_writeDataFile x1 x2 x3 x4 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_C_writeDataFile x1 x2 x3 x4 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_C_writeDataFile x1 x2 x3 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Test.Benchmark.Goodies.writeDataFile" [show x1, show x2, show x3, show x4
    , show x5] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies.writeDataFile" (showCons
    x5))

d_OP_writeDataFile_dot_uscore_hash_lambda7 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> Curry_Prelude.OP_Tuple2 t1 t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_writeDataFile_dot_uscore_hash_lambda7 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_show x2 cd cs) x4 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\t")
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_show x1 cd cs) x5 cd cs) cd cs)
    cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_writeDataFile_dot_uscore_hash_lambda7 x1 x2 l cd cs)
    (d_OP_writeDataFile_dot_uscore_hash_lambda7 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_writeDataFile_dot_uscore_hash_lambda7 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_writeDataFile_dot_uscore_hash_lambda7 x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Test.Benchmark.Goodies.writeDataFile._#lambda7" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies.writeDataFile._#lambda7"
    (showCons x3))

nd_OP_writeDataFile_dot_uscore_hash_lambda7 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> Curry_Prelude.OP_Tuple2 t1 t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_OP_writeDataFile_dot_uscore_hash_lambda7 x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s6 = s
    in s6 `seq` (let s2 = leftSupply s6
                     s5 = rightSupply s6
    in s2 `seq` (s5 `seq` Curry_Prelude.d_OP_plus_plus (let s1 = leftSupply s2
                                                            s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x2
    s0 cd cs) x4 s1 cd cs)) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\t") (let s4 = leftSupply s5
                                            s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x1
    s3 cd cs) x5 s4 cd cs)) cd cs) cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_writeDataFile_dot_uscore_hash_lambda7 x1 x2 l s cd cs)
    (nd_OP_writeDataFile_dot_uscore_hash_lambda7 x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_writeDataFile_dot_uscore_hash_lambda7 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_writeDataFile_dot_uscore_hash_lambda7 x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Test.Benchmark.Goodies.writeDataFile._#lambda7" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies.writeDataFile._#lambda7"
    (showCons x3))

d_C_test1 :: Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_test1 cd cs = d_C_plotResults
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Float_hash
  (Curry_Prelude.toCurryString "xxx.jpg") (Curry_Prelude.OP_Cons C_Lines
  (Curry_Prelude.OP_Cons (C_Title (Curry_Prelude.toCurryString
  "nrev run times")) (Curry_Prelude.OP_Cons (C_XLabel
  (Curry_Prelude.toCurryString "list length")) (Curry_Prelude.OP_Cons (C_YLabel
  (Curry_Prelude.toCurryString "run time (seconds)")) Curry_Prelude.OP_List))))
  (Curry_Prelude.OP_Cons (d_C_data1 cd cs) (Curry_Prelude.OP_Cons (d_C_data2 cd
  cs) Curry_Prelude.OP_List)) cd cs

d_C_test2 :: Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_test2 cd cs = d_C_plotResults
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Float_hash
  (Curry_Prelude.toCurryString "xxx.pdf") (Curry_Prelude.OP_Cons C_Histogram
  (Curry_Prelude.OP_Cons (C_Title (Curry_Prelude.toCurryString
  "nrev run times")) (Curry_Prelude.OP_Cons (C_XLabel
  (Curry_Prelude.toCurryString " ")) (Curry_Prelude.OP_Cons (C_XTicsRotate
  (Curry_Prelude.d_OP_uscore_impl_hash_negate_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.C_Int (45)) cd cs)) (Curry_Prelude.OP_Cons (C_YLabel
  (Curry_Prelude.toCurryString "run time (seconds)")) Curry_Prelude.OP_List)))))
  (Curry_Prelude.OP_Cons (d_C_data1 cd cs) (Curry_Prelude.OP_Cons (d_C_data2 cd
  cs) Curry_Prelude.OP_List)) cd cs

d_C_data1 :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_Prelude.C_Float))
d_C_data1 cd cs = Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "pakcs")
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int (500))
  (Curry_Prelude.C_Float 9.666666666666668e-2##)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int (1000)) (Curry_Prelude.C_Float
  0.3433333333333333##)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.C_Int (1500)) (Curry_Prelude.C_Float 0.8533333333333334##))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int (2000))
  (Curry_Prelude.C_Float 1.6899999999999995##)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int (2500)) (Curry_Prelude.C_Float
  3.0066666666666664##)) Curry_Prelude.OP_List)))))

d_C_data2 :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_Prelude.C_Float))
d_C_data2 cd cs = Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "kics2")
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int (500))
  (Curry_Prelude.C_Float 0.0##)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.C_Int (1000)) (Curry_Prelude.C_Float 1.0e-2##))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int (1500))
  (Curry_Prelude.C_Float 2.0e-2##)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int (2000)) (Curry_Prelude.C_Float
  3.0e-2##)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.C_Int (2500)) (Curry_Prelude.C_Float 5.666666666666666e-2##))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int (3000))
  (Curry_Prelude.C_Float 8.333333333333333e-2##)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int (3500)) (Curry_Prelude.C_Float
  0.12##)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int
  (4000)) (Curry_Prelude.C_Float 0.17##)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int (4500)) (Curry_Prelude.C_Float
  0.22##)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int
  (5000)) (Curry_Prelude.C_Float 0.28##)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int (5500)) (Curry_Prelude.C_Float
  0.36000000000000004##)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.C_Int (6000)) (Curry_Prelude.C_Float 0.44##))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int (6500))
  (Curry_Prelude.C_Float 0.53##)) Curry_Prelude.OP_List)))))))))))))

d_C__case_13 :: Curry_Prelude.C_Int -> C_PlotStyle -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_13 x26 x2 cd cs = case x2 of
  C_Lines -> Curry_Prelude.C_False
  C_Histogram -> Curry_Prelude.C_False
  C_Title x27 -> Curry_Prelude.C_False
  C_XLabel x28 -> Curry_Prelude.C_False
  C_YLabel x29 -> Curry_Prelude.C_False
  C_XTicsRotate x30 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs) x26 cd cs) x30 cd cs
  Choice_C_PlotStyle d i l r -> narrow d i (d_C__case_13 x26 l cd cs)
    (d_C__case_13 x26 r cd cs)
  Choices_C_PlotStyle d i xs -> narrows cs d i (\z -> d_C__case_13 x26 z cd cs)
    xs
  Guard_C_PlotStyle d c e -> guardCons d c ((\x -> d_C__case_13 x26 e cd x) $!
    addCs c cs)
  Fail_C_PlotStyle d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_13" [show x26, show x2] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_13" (showCons x2))

nd_C__case_14 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_PlotStyle
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_14 x21 x2 s cd cs = case x2 of
  C_Lines -> Curry_Prelude.C_False
  C_Histogram -> Curry_Prelude.C_False
  C_Title x22 -> Curry_Prelude.C_False
  C_XLabel x23 -> Curry_Prelude.C_False
  C_YLabel x24 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x21 x24 s0 cd cs
  C_XTicsRotate x25 -> Curry_Prelude.C_False
  Choice_C_PlotStyle d i l r -> narrow d i (nd_C__case_14 x21 l s cd cs)
    (nd_C__case_14 x21 r s cd cs)
  Choices_C_PlotStyle d i xs -> narrows cs d i (\z -> nd_C__case_14 x21 z s cd
    cs) xs
  Guard_C_PlotStyle d c e -> guardCons d c ((\x -> nd_C__case_14 x21 e s cd
    x) $! addCs c cs)
  Fail_C_PlotStyle d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_14" [show x21, show x2] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_14" (showCons x2))

nd_C__case_15 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_PlotStyle
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_15 x16 x2 s cd cs = case x2 of
  C_Lines -> Curry_Prelude.C_False
  C_Histogram -> Curry_Prelude.C_False
  C_Title x17 -> Curry_Prelude.C_False
  C_XLabel x18 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x16 x18 s0 cd cs
  C_YLabel x19 -> Curry_Prelude.C_False
  C_XTicsRotate x20 -> Curry_Prelude.C_False
  Choice_C_PlotStyle d i l r -> narrow d i (nd_C__case_15 x16 l s cd cs)
    (nd_C__case_15 x16 r s cd cs)
  Choices_C_PlotStyle d i xs -> narrows cs d i (\z -> nd_C__case_15 x16 z s cd
    cs) xs
  Guard_C_PlotStyle d c e -> guardCons d c ((\x -> nd_C__case_15 x16 e s cd
    x) $! addCs c cs)
  Fail_C_PlotStyle d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_15" [show x16, show x2] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_15" (showCons x2))

nd_C__case_16 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_PlotStyle
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_16 x11 x2 s cd cs = case x2 of
  C_Lines -> Curry_Prelude.C_False
  C_Histogram -> Curry_Prelude.C_False
  C_Title x12 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x11 x12 s0 cd cs
  C_XLabel x13 -> Curry_Prelude.C_False
  C_YLabel x14 -> Curry_Prelude.C_False
  C_XTicsRotate x15 -> Curry_Prelude.C_False
  Choice_C_PlotStyle d i l r -> narrow d i (nd_C__case_16 x11 l s cd cs)
    (nd_C__case_16 x11 r s cd cs)
  Choices_C_PlotStyle d i xs -> narrows cs d i (\z -> nd_C__case_16 x11 z s cd
    cs) xs
  Guard_C_PlotStyle d c e -> guardCons d c ((\x -> nd_C__case_16 x11 e s cd
    x) $! addCs c cs)
  Fail_C_PlotStyle d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_16" [show x11, show x2] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_16" (showCons x2))

d_C__case_17 :: C_PlotStyle -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_17 x2 cd cs = case x2 of
  C_Lines -> Curry_Prelude.C_False
  C_Histogram -> Curry_Prelude.C_True
  C_Title x7 -> Curry_Prelude.C_False
  C_XLabel x8 -> Curry_Prelude.C_False
  C_YLabel x9 -> Curry_Prelude.C_False
  C_XTicsRotate x10 -> Curry_Prelude.C_False
  Choice_C_PlotStyle d i l r -> narrow d i (d_C__case_17 l cd cs) (d_C__case_17
    r cd cs)
  Choices_C_PlotStyle d i xs -> narrows cs d i (\z -> d_C__case_17 z cd cs) xs
  Guard_C_PlotStyle d c e -> guardCons d c ((\x -> d_C__case_17 e cd x) $! addCs
    c cs)
  Fail_C_PlotStyle d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_17" [show x2] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_17" (showCons x2))

d_C__case_18 :: C_PlotStyle -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_18 x2 cd cs = case x2 of
  C_Lines -> Curry_Prelude.C_True
  C_Histogram -> Curry_Prelude.C_False
  C_Title x3 -> Curry_Prelude.C_False
  C_XLabel x4 -> Curry_Prelude.C_False
  C_YLabel x5 -> Curry_Prelude.C_False
  C_XTicsRotate x6 -> Curry_Prelude.C_False
  Choice_C_PlotStyle d i l r -> narrow d i (d_C__case_18 l cd cs) (d_C__case_18
    r cd cs)
  Choices_C_PlotStyle d i xs -> narrows cs d i (\z -> d_C__case_18 z cd cs) xs
  Guard_C_PlotStyle d c e -> guardCons d c ((\x -> d_C__case_18 e cd x) $! addCs
    c cs)
  Fail_C_PlotStyle d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_18" [show x2] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_18" (showCons x2))

d_C__case_7 :: Curry_Prelude.C_Int -> C_PlotStyle -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_7 x26 x2 cd cs = case x2 of
  C_Lines -> Curry_Prelude.C_False
  C_Histogram -> Curry_Prelude.C_False
  C_Title x27 -> Curry_Prelude.C_False
  C_XLabel x28 -> Curry_Prelude.C_False
  C_YLabel x29 -> Curry_Prelude.C_False
  C_XTicsRotate x30 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x26 x30 cd cs
  Choice_C_PlotStyle d i l r -> narrow d i (d_C__case_7 x26 l cd cs)
    (d_C__case_7 x26 r cd cs)
  Choices_C_PlotStyle d i xs -> narrows cs d i (\z -> d_C__case_7 x26 z cd cs)
    xs
  Guard_C_PlotStyle d c e -> guardCons d c ((\x -> d_C__case_7 x26 e cd x) $!
    addCs c cs)
  Fail_C_PlotStyle d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_7" [show x26, show x2] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_7" (showCons x2))

d_C__case_8 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_PlotStyle
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_8 x21 x2 cd cs = case x2 of
  C_Lines -> Curry_Prelude.C_False
  C_Histogram -> Curry_Prelude.C_False
  C_Title x22 -> Curry_Prelude.C_False
  C_XLabel x23 -> Curry_Prelude.C_False
  C_YLabel x24 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x21 x24 cd cs
  C_XTicsRotate x25 -> Curry_Prelude.C_False
  Choice_C_PlotStyle d i l r -> narrow d i (d_C__case_8 x21 l cd cs)
    (d_C__case_8 x21 r cd cs)
  Choices_C_PlotStyle d i xs -> narrows cs d i (\z -> d_C__case_8 x21 z cd cs)
    xs
  Guard_C_PlotStyle d c e -> guardCons d c ((\x -> d_C__case_8 x21 e cd x) $!
    addCs c cs)
  Fail_C_PlotStyle d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_8" [show x21, show x2] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_8" (showCons x2))

d_C__case_9 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_PlotStyle
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_9 x16 x2 cd cs = case x2 of
  C_Lines -> Curry_Prelude.C_False
  C_Histogram -> Curry_Prelude.C_False
  C_Title x17 -> Curry_Prelude.C_False
  C_XLabel x18 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x16 x18 cd cs
  C_YLabel x19 -> Curry_Prelude.C_False
  C_XTicsRotate x20 -> Curry_Prelude.C_False
  Choice_C_PlotStyle d i l r -> narrow d i (d_C__case_9 x16 l cd cs)
    (d_C__case_9 x16 r cd cs)
  Choices_C_PlotStyle d i xs -> narrows cs d i (\z -> d_C__case_9 x16 z cd cs)
    xs
  Guard_C_PlotStyle d c e -> guardCons d c ((\x -> d_C__case_9 x16 e cd x) $!
    addCs c cs)
  Fail_C_PlotStyle d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_9" [show x16, show x2] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_9" (showCons x2))

d_C__case_10 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_PlotStyle
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_10 x11 x2 cd cs = case x2 of
  C_Lines -> Curry_Prelude.C_False
  C_Histogram -> Curry_Prelude.C_False
  C_Title x12 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x11 x12 cd cs
  C_XLabel x13 -> Curry_Prelude.C_False
  C_YLabel x14 -> Curry_Prelude.C_False
  C_XTicsRotate x15 -> Curry_Prelude.C_False
  Choice_C_PlotStyle d i l r -> narrow d i (d_C__case_10 x11 l cd cs)
    (d_C__case_10 x11 r cd cs)
  Choices_C_PlotStyle d i xs -> narrows cs d i (\z -> d_C__case_10 x11 z cd cs)
    xs
  Guard_C_PlotStyle d c e -> guardCons d c ((\x -> d_C__case_10 x11 e cd x) $!
    addCs c cs)
  Fail_C_PlotStyle d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_10" [show x11, show x2] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_10" (showCons x2))

d_C__case_11 :: C_PlotStyle -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_11 x2 cd cs = case x2 of
  C_Lines -> Curry_Prelude.C_False
  C_Histogram -> Curry_Prelude.C_True
  C_Title x7 -> Curry_Prelude.C_False
  C_XLabel x8 -> Curry_Prelude.C_False
  C_YLabel x9 -> Curry_Prelude.C_False
  C_XTicsRotate x10 -> Curry_Prelude.C_False
  Choice_C_PlotStyle d i l r -> narrow d i (d_C__case_11 l cd cs) (d_C__case_11
    r cd cs)
  Choices_C_PlotStyle d i xs -> narrows cs d i (\z -> d_C__case_11 z cd cs) xs
  Guard_C_PlotStyle d c e -> guardCons d c ((\x -> d_C__case_11 e cd x) $! addCs
    c cs)
  Fail_C_PlotStyle d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_11" [show x2] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_11" (showCons x2))

d_C__case_12 :: C_PlotStyle -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_12 x2 cd cs = case x2 of
  C_Lines -> Curry_Prelude.C_True
  C_Histogram -> Curry_Prelude.C_False
  C_Title x3 -> Curry_Prelude.C_False
  C_XLabel x4 -> Curry_Prelude.C_False
  C_YLabel x5 -> Curry_Prelude.C_False
  C_XTicsRotate x6 -> Curry_Prelude.C_False
  Choice_C_PlotStyle d i l r -> narrow d i (d_C__case_12 l cd cs) (d_C__case_12
    r cd cs)
  Choices_C_PlotStyle d i xs -> narrows cs d i (\z -> d_C__case_12 z cd cs) xs
  Guard_C_PlotStyle d c e -> guardCons d c ((\x -> d_C__case_12 e cd x) $! addCs
    c cs)
  Fail_C_PlotStyle d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_12" [show x2] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_12" (showCons x2))

d_C__case_6 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_6 x4 x3 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus x3
    (Curry_Prelude.toCurryString ".00") cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_plus_plus x3
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString ".")
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (2))
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_tail x4 cd cs)
    (Curry_Prelude.d_C_repeat (Curry_Prelude.C_Char '0'#) cd cs) cd cs) cd cs)
    cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x4 x3 l cd cs)
    (d_C__case_6 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x4 x3
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x4 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_6" [show x4, show x3, show x5] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_6" (showCons x5))

d_C__case_5 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_5 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '-'#)
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_negate_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 cd cs) cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x1 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x1 l cd cs)
    (d_C__case_5 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_5" [show x1, show x2] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_5" (showCons x2))

d_C__case_4 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_4 x7 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString
    "set terminal pdf enhanced"
  Curry_Prelude.C_False -> d_C__case_3 x7 (Curry_Prelude.d_C_eqString x7
    (Curry_Prelude.toCurryString ".jpg") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x7 l cd cs)
    (d_C__case_4 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x7 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x7 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_4" [show x7, show x8] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_4" (showCons x8))

d_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_3 x7 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString
    "set terminal jpeg nocrop enhanced"
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_error
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "plotResults: unsupported out file format: ") x7 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x7 l cd cs)
    (d_C__case_3 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x7 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x7 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_3" [show x7, show x8] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_3" (showCons x8))

d_C__case_1 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_1 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "notitle"
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "title \"") (Curry_Prelude.d_OP_plus_plus x3
    (Curry_Prelude.toCurryString "\"") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x3 l cd cs)
    (d_C__case_1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x3 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_1" [show x3, show x4] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_1" (showCons x4))

d_C__case_2 :: Curry_Prelude.OP_List C_PlotStyle -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_2 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "using 2:xtic(1) "
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x1 l cd cs)
    (d_C__case_2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_2" [show x1, show x2] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_2" (showCons x2))

d_C__case_0 :: forall t3 t1 t0 t2 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry t2) => t3
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t3) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t1 t0)) -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2
  t2 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_0 x6 x1 x4 x2 x3 x7 cd cs = case x7 of
  Curry_Prelude.OP_Tuple2 x8 x9 -> let x10 = Curry_Prelude.d_OP_plus_plus x4
                                         (Curry_Prelude.d_OP_plus_plus
                                         (Curry_Prelude.d_C_apply
                                         (Curry_Prelude.d_C_show x1 cd cs) x6 cd
                                         cs) (Curry_Prelude.toCurryString
                                         ".dat") cd cs) cd cs
    in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Curry_Prelude.d_C_writeFile x10 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_unlines cd cs) (Curry_Prelude.d_C_map
    (d_OP_writeDataFile_dot_uscore_hash_lambda7 x3 x2) x9 cd cs) cd cs) cd cs)
    cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Curry_Prelude.OP_Tuple2 x8 x10) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_0 x6 x1 x4 x2
    x3 l cd cs) (d_C__case_0 x6 x1 x4 x2 x3 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_0 x6
    x1 x4 x2 x3 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_0 x6 x1
    x4 x2 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_0" [show x6, show x1, show x4, show x2, show
    x3, show x7] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_0" (showCons x7))

nd_C__case_0 :: forall t3 t1 t0 t2 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t2) => t3 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t3) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_C__case_0 x6 x1 x4 x2 x3 x7 s cd cs = case x7 of
  Curry_Prelude.OP_Tuple2 x8 x9 -> let s16 = s
    in s16 `seq` (let s2 = leftSupply s16
                      s14 = rightSupply s16
    in s2 `seq` (s14 `seq` (let x10 = Curry_Prelude.d_OP_plus_plus x4
                                  (Curry_Prelude.d_OP_plus_plus
                                  (let s1 = leftSupply s2
                                       s0 = rightSupply s2
                                  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
                                  (Curry_Prelude.nd_C_show x1 s0 cd cs) x6 s1 cd
                                  cs)) (Curry_Prelude.toCurryString ".dat") cd
                                  cs) cd cs
    in let s13 = leftSupply s14
           s15 = rightSupply s14
           s8 = leftSupply s15
           s12 = rightSupply s15
    in s13 `seq` (s15 `seq` (s8 `seq` (s12 `seq` Curry_Prelude.nd_C_apply
    (let s7 = leftSupply s8
         s9 = rightSupply s8
         s3 = leftSupply s9
         s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s3 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    s3 cd cs) (Curry_Prelude.d_C_writeFile x10 (let s5 = leftSupply s6
                                                    s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (wrapDX id
    (Curry_Prelude.d_C_unlines cd cs)) (Curry_Prelude.nd_C_map (wrapNX id
    (nd_OP_writeDataFile_dot_uscore_hash_lambda7 x3 x2)) x9 s4 cd cs) s5 cd cs))
    cd cs) s7 cd cs)))) (let s11 = leftSupply s12
                             s10 = rightSupply s12
    in s11 `seq` (s10 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    s10 cd cs) (Curry_Prelude.OP_Tuple2 x8 x10) s11 cd cs)) s13 cd cs))))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_0 x6 x1 x4 x2
    x3 l s cd cs) (nd_C__case_0 x6 x1 x4 x2 x3 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_0
    x6 x1 x4 x2 x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_0 x6
    x1 x4 x2 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Test.Benchmark.Goodies._case_0" [show x6, show x1, show x4, show x2, show
    x3, show x7] info)
  _ -> failCons cd (consFail "Test.Benchmark.Goodies._case_0" (showCons x7))

