{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif
{-# LANGUAGE MultiParamTypeClasses #-}

module System.IO.Curry_BinaryFile
  ( d_C_openBinaryFile, d_C_hGetByte, d_C_hPutByte, d_C_hGetBinaryContents )
  where

import Basics
import qualified Curry_Prelude
import qualified System.Curry_IO

import Data.Char ( chr, ord )
import System.IO
import Curry_IO

d_C_openBinaryFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> System.Curry_IO.C_IOMode -> Cover -> ConstStore -> Curry_Prelude.C_IO
  System.Curry_IO.C_Handle
d_C_openBinaryFile x1 x2 cd cs = Curry_Prelude.d_OP_dollar_hash
  (Curry_Prelude.d_OP_dollar_hash_hash (acceptCs id d_C_prim_openBinaryFile) x1
  cd cs) x2 cd cs

d_C_hGetByte :: System.Curry_IO.C_Handle -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.C_Int
d_C_hGetByte x1 cd cs = Curry_Prelude.d_OP_dollar_hash d_C_prim_hGetByte x1 cd
  cs

d_C_hPutByte :: System.Curry_IO.C_Handle -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_hPutByte x1 x2 cd cs = Curry_Prelude.d_OP_dollar_hash_hash
  (Curry_Prelude.d_OP_dollar_hash (acceptCs id d_C_prim_hPutByte) x1 cd cs) x2
  cd cs

d_C_hGetBinaryContents :: System.Curry_IO.C_Handle -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Int)
d_C_hGetBinaryContents x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_IO.d_C_hIsEOF x1 cd cs) cd cs)
  (d_OP_hGetBinaryContents_dot_uscore_hash_lambda2 x1) cd cs

d_OP_hGetBinaryContents_dot_uscore_hash_lambda2 :: System.Curry_IO.C_Handle
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)
d_OP_hGetBinaryContents_dot_uscore_hash_lambda2 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_IO.d_C_hClose x1 cd cs) cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) Curry_Prelude.OP_List cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (d_C_hGetByte x1 cd cs) cd cs)
    (d_OP_hGetBinaryContents_dot_uscore_hash_lambda2_dot_uscore_hash_lambda6 x1)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (d_OP_hGetBinaryContents_dot_uscore_hash_lambda2 x1 l cd cs)
    (d_OP_hGetBinaryContents_dot_uscore_hash_lambda2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_OP_hGetBinaryContents_dot_uscore_hash_lambda2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x ->
    d_OP_hGetBinaryContents_dot_uscore_hash_lambda2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "System.IO.BinaryFile.hGetBinaryContents._#lambda2" [show x1, show x2] info)
  _ -> failCons cd (consFail "System.IO.BinaryFile.hGetBinaryContents._#lambda2"
    (showCons x2))

d_OP_hGetBinaryContents_dot_uscore_hash_lambda2_dot_uscore_hash_lambda6 :: System.Curry_IO.C_Handle
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)
d_OP_hGetBinaryContents_dot_uscore_hash_lambda2_dot_uscore_hash_lambda6 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_hGetBinaryContents x1 cd cs) cd cs)
  (d_OP_hGetBinaryContents_dot_uscore_hash_lambda2_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8
  x3) cd cs

d_OP_hGetBinaryContents_dot_uscore_hash_lambda2_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8 :: Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Int)
d_OP_hGetBinaryContents_dot_uscore_hash_lambda2_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.OP_Cons x1 x3) cd cs

d_C_prim_openBinaryFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> System.Curry_IO.C_IOMode -> Cover -> ConstStore -> Curry_Prelude.C_IO
  System.Curry_IO.C_Handle
d_C_prim_openBinaryFile x1 x2 cd cs = external_d_C_prim_openBinaryFile x1 x2 cd
  cs

d_C_prim_hGetByte :: System.Curry_IO.C_Handle -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.C_Int
d_C_prim_hGetByte x1 cd cs = external_d_C_prim_hGetByte x1 cd cs

d_C_prim_hPutByte :: System.Curry_IO.C_Handle -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_prim_hPutByte x1 x2 cd cs = external_d_C_prim_hPutByte x1 x2 cd cs

external_d_C_prim_openBinaryFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> C_IOMode -> Cover -> ConstStore -> Curry_Prelude.C_IO C_Handle
external_d_C_prim_openBinaryFile fn  mode _ _ =
  toCurry (\s m -> openFile s m >>= \h -> hSetBinaryMode h True
                                >> return (OneHandle h))
          fn mode

external_d_C_prim_hGetByte :: C_Handle -> Cover -> ConstStore
                           -> Curry_Prelude.C_IO Curry_Prelude.C_Int
external_d_C_prim_hGetByte h _ _ =
 toCurry (\h -> hGetChar (inputHandle h) >>= return . ord) h

external_d_C_prim_hPutByte :: C_Handle -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
external_d_C_prim_hPutByte h c _ _ =
 toCurry (\h b -> hPutChar (outputHandle h) (chr b)) h c

