{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_BPMN2BPEL
  ( C_BPMNComp (..)
  , C_BPMNInterKind (..)
  , C_BPELComp (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash
  , d_C_ex
  , nd_C_processS
  , nd_C_flowS
  , nd_C_flElemS
  , d_C_bpel2xml
  , d_C_seq2xml
  , d_C_bpelComp2xml
  , d_C_indent )
  where

import Basics
import qualified Curry_Grappa
import qualified Curry_Prelude


data C_BPMNComp
  = C_BPMNStart
  | C_BPMNEnd
  | C_BPMNPGW
  | C_BPMNXGW (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_BPMNActivity (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_BPMNInter C_BPMNInterKind (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | Choice_C_BPMNComp Cover ID C_BPMNComp C_BPMNComp
  | Choices_C_BPMNComp Cover ID [C_BPMNComp]
  | Fail_C_BPMNComp Cover FailInfo
  | Guard_C_BPMNComp Cover Constraints C_BPMNComp

instance Show C_BPMNComp where
  showsPrec d (Choice_C_BPMNComp cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_BPMNComp cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_BPMNComp cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_BPMNComp cd info) = showChar '!'
  showsPrec _ C_BPMNStart = showString "BPMNStart"
  showsPrec _ C_BPMNEnd = showString "BPMNEnd"
  showsPrec _ C_BPMNPGW = showString "BPMNPGW"
  showsPrec _ (C_BPMNXGW x1 x2) = showString "(BPMNXGW" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_BPMNActivity x1) = showString "(BPMNActivity" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (C_BPMNInter x1 x2) = showString "(BPMNInter" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))

instance Read C_BPMNComp where
  readsPrec d s = readParen False (\r -> [(C_BPMNStart, r0) | (_, r0) <-
    readQualified "BPMN2BPEL" "BPMNStart" r]) s ++ (readParen False (\r ->
    [(C_BPMNEnd, r0) | (_, r0) <- readQualified "BPMN2BPEL" "BPMNEnd" r]) s ++
    (readParen False (\r -> [(C_BPMNPGW, r0) | (_, r0) <- readQualified
    "BPMN2BPEL" "BPMNPGW" r]) s ++ (readParen ((>) d 10) (\r -> [(C_BPMNXGW x1
    x2, r2) | (_, r0) <- readQualified "BPMN2BPEL" "BPMNXGW" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ (readParen ((>) d 10)
    (\r -> [(C_BPMNActivity x1, r1) | (_, r0) <- readQualified "BPMN2BPEL"
    "BPMNActivity" r, (x1, r1) <- readsPrec 11 r0]) s ++ readParen ((>) d 10)
    (\r -> [(C_BPMNInter x1 x2, r2) | (_, r0) <- readQualified "BPMN2BPEL"
    "BPMNInter" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1])
    s))))

instance NonDet C_BPMNComp where
  choiceCons = Choice_C_BPMNComp
  choicesCons = Choices_C_BPMNComp
  failCons = Fail_C_BPMNComp
  guardCons = Guard_C_BPMNComp
  try (Choice_C_BPMNComp cd i x y) = tryChoice cd i x y
  try (Choices_C_BPMNComp cd i xs) = tryChoices cd i xs
  try (Fail_C_BPMNComp cd info) = Fail cd info
  try (Guard_C_BPMNComp cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_BPMNComp cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_BPMNComp cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_BPMNComp cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_BPMNComp cd i _) = error
    ("BPMN2BPEL.BPMNComp.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_BPMNComp cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_BPMNComp cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_BPMNComp where
  generate s c = Choices_C_BPMNComp c (freeID [0, 0, 0, 2, 1, 2] s) [C_BPMNStart
    , C_BPMNEnd, C_BPMNPGW, C_BPMNXGW (generate (leftSupply s) c) (generate
    (rightSupply s) c), C_BPMNActivity (generate (leftSupply s) c), C_BPMNInter
    (generate (leftSupply s) c) (generate (rightSupply s) c)]

instance NormalForm C_BPMNComp where
  ($!!) cont C_BPMNStart d cs = cont C_BPMNStart d cs
  ($!!) cont C_BPMNEnd d cs = cont C_BPMNEnd d cs
  ($!!) cont C_BPMNPGW d cs = cont C_BPMNPGW d cs
  ($!!) cont (C_BPMNXGW x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_BPMNXGW y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_BPMNActivity x1) d cs = ($!!) (\y1 d cs -> cont (C_BPMNActivity
    y1) d cs) x1 d cs
  ($!!) cont (C_BPMNInter x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_BPMNInter y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_BPMNComp cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_BPMNComp cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_BPMNComp cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_BPMNComp cd info) _ _ = failCons cd info
  ($##) cont C_BPMNStart d cs = cont C_BPMNStart d cs
  ($##) cont C_BPMNEnd d cs = cont C_BPMNEnd d cs
  ($##) cont C_BPMNPGW d cs = cont C_BPMNPGW d cs
  ($##) cont (C_BPMNXGW x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_BPMNXGW y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_BPMNActivity x1) d cs = ($##) (\y1 d cs -> cont (C_BPMNActivity
    y1) d cs) x1 d cs
  ($##) cont (C_BPMNInter x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_BPMNInter y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_BPMNComp cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_BPMNComp cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_BPMNComp cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_BPMNComp cd info) _ _ = failCons cd info
  showCons C_BPMNStart = "BPMN2BPEL.BPMNStart"
  showCons C_BPMNEnd = "BPMN2BPEL.BPMNEnd"
  showCons C_BPMNPGW = "BPMN2BPEL.BPMNPGW"
  showCons (C_BPMNXGW _ _) = "BPMN2BPEL.BPMNXGW _ _"
  showCons (C_BPMNActivity _) = "BPMN2BPEL.BPMNActivity _"
  showCons (C_BPMNInter _ _) = "BPMN2BPEL.BPMNInter _ _"
  showCons x = error ("BPMN2BPEL.BPMNComp.showCons: no constructor: " ++ show x)
  searchNF _ cont C_BPMNStart = cont C_BPMNStart
  searchNF _ cont C_BPMNEnd = cont C_BPMNEnd
  searchNF _ cont C_BPMNPGW = cont C_BPMNPGW
  searchNF search cont (C_BPMNXGW x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_BPMNXGW y1 y2)) x2) x1
  searchNF search cont (C_BPMNActivity x1) = search (\y1 -> cont (C_BPMNActivity
    y1)) x1
  searchNF search cont (C_BPMNInter x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_BPMNInter y1 y2)) x2) x1
  searchNF _ _ x = error ("BPMN2BPEL.BPMNComp.searchNF: no constructor: " ++
    show x)

instance Unifiable C_BPMNComp where
  (=.=) C_BPMNStart C_BPMNStart d cs = C_True
  (=.=) C_BPMNEnd C_BPMNEnd d cs = C_True
  (=.=) C_BPMNPGW C_BPMNPGW d cs = C_True
  (=.=) (C_BPMNXGW x1 x2) (C_BPMNXGW y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=)
    x2 y2 d cs) d cs
  (=.=) (C_BPMNActivity x1) (C_BPMNActivity y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_BPMNInter x1 x2) (C_BPMNInter y1 y2) d cs = (&) ((=:=) x1 y1 d cs)
    ((=:=) x2 y2 d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_BPMNStart C_BPMNStart d cs = C_True
  (=.<=) C_BPMNEnd C_BPMNEnd d cs = C_True
  (=.<=) C_BPMNPGW C_BPMNPGW d cs = C_True
  (=.<=) (C_BPMNXGW x1 x2) (C_BPMNXGW y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_BPMNActivity x1) (C_BPMNActivity y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_BPMNInter x1 x2) (C_BPMNInter y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_BPMNStart = (i :=: ChooseN 0 0) : concat []
  bind cd i C_BPMNEnd = (i :=: ChooseN 1 0) : concat []
  bind cd i C_BPMNPGW = (i :=: ChooseN 2 0) : concat []
  bind cd i (C_BPMNXGW x3 x4) = (i :=: ChooseN 3 2) : concat [bind cd (leftID i)
    x3, bind cd (rightID i) x4]
  bind cd i (C_BPMNActivity x3) = (i :=: ChooseN 4 1) : concat [bind cd (leftID
    i) x3]
  bind cd i (C_BPMNInter x3 x4) = (i :=: ChooseN 5 2) : concat [bind cd (leftID
    i) x3, bind cd (rightID i) x4]
  bind d i (Choice_C_BPMNComp cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_BPMNComp cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_BPMNComp cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_BPMNComp cd i _) = error
    ("BPMN2BPEL.BPMNComp.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_BPMNComp cd info) = [Unsolvable info]
  bind d i (Guard_C_BPMNComp cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_BPMNStart = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_BPMNEnd = (i :=: ChooseN 1 0) : []
  lazyBind cd i C_BPMNPGW = (i :=: ChooseN 2 0) : []
  lazyBind cd i (C_BPMNXGW x3 x4) = (i :=: ChooseN 3 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (C_BPMNActivity x3) = (i :=: ChooseN 4 1) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_BPMNInter x3 x4) = (i :=: ChooseN 5 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind d i (Choice_C_BPMNComp cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_BPMNComp cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_BPMNComp cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_BPMNComp cd i _) = error
    ("BPMN2BPEL.BPMNComp.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_BPMNComp cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_BPMNComp cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_BPMNComp where

data C_BPMNInterKind
  = C_BPMNWait
  | C_BPMNReceive
  | Choice_C_BPMNInterKind Cover ID C_BPMNInterKind C_BPMNInterKind
  | Choices_C_BPMNInterKind Cover ID [C_BPMNInterKind]
  | Fail_C_BPMNInterKind Cover FailInfo
  | Guard_C_BPMNInterKind Cover Constraints C_BPMNInterKind

instance Show C_BPMNInterKind where
  showsPrec d (Choice_C_BPMNInterKind cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_BPMNInterKind cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_BPMNInterKind cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_BPMNInterKind cd info) = showChar '!'
  showsPrec _ C_BPMNWait = showString "BPMNWait"
  showsPrec _ C_BPMNReceive = showString "BPMNReceive"

instance Read C_BPMNInterKind where
  readsPrec _ s = readParen False (\r -> [(C_BPMNWait, r0) | (_, r0) <-
    readQualified "BPMN2BPEL" "BPMNWait" r]) s ++ readParen False (\r ->
    [(C_BPMNReceive, r0) | (_, r0) <- readQualified "BPMN2BPEL" "BPMNReceive"
    r]) s

instance NonDet C_BPMNInterKind where
  choiceCons = Choice_C_BPMNInterKind
  choicesCons = Choices_C_BPMNInterKind
  failCons = Fail_C_BPMNInterKind
  guardCons = Guard_C_BPMNInterKind
  try (Choice_C_BPMNInterKind cd i x y) = tryChoice cd i x y
  try (Choices_C_BPMNInterKind cd i xs) = tryChoices cd i xs
  try (Fail_C_BPMNInterKind cd info) = Fail cd info
  try (Guard_C_BPMNInterKind cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_BPMNInterKind cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_BPMNInterKind cd i@(NarrowedID _ _) xs) = f cd i
    xs
  match _ _ f _ _ _ (Choices_C_BPMNInterKind cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_BPMNInterKind cd i _) = error
    ("BPMN2BPEL.BPMNInterKind.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_BPMNInterKind cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_BPMNInterKind cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_BPMNInterKind where
  generate s c = Choices_C_BPMNInterKind c (freeID [0, 0] s) [C_BPMNWait
    , C_BPMNReceive]

instance NormalForm C_BPMNInterKind where
  ($!!) cont C_BPMNWait d cs = cont C_BPMNWait d cs
  ($!!) cont C_BPMNReceive d cs = cont C_BPMNReceive d cs
  ($!!) cont (Choice_C_BPMNInterKind cd i x y) d cs = nfChoice cont cd i x y cd
    cs
  ($!!) cont (Choices_C_BPMNInterKind cd i xs) d cs = nfChoices cont cd i xs d
    cs
  ($!!) cont (Guard_C_BPMNInterKind cd c e) d cs = guardCons cd c (($!!) cont e
    d (addCs c cs))
  ($!!) _ (Fail_C_BPMNInterKind cd info) _ _ = failCons cd info
  ($##) cont C_BPMNWait d cs = cont C_BPMNWait d cs
  ($##) cont C_BPMNReceive d cs = cont C_BPMNReceive d cs
  ($##) cont (Choice_C_BPMNInterKind cd i x y) d cs = gnfChoice cont cd i x y cd
    cs
  ($##) cont (Choices_C_BPMNInterKind cd i xs) d cs = gnfChoices cont cd i xs d
    cs
  ($##) cont (Guard_C_BPMNInterKind cd c e) d cs = guardCons cd c (($##) cont e
    d (addCs c cs))
  ($##) _ (Fail_C_BPMNInterKind cd info) _ _ = failCons cd info
  showCons C_BPMNWait = "BPMN2BPEL.BPMNWait"
  showCons C_BPMNReceive = "BPMN2BPEL.BPMNReceive"
  showCons x = error ("BPMN2BPEL.BPMNInterKind.showCons: no constructor: " ++
    show x)
  searchNF _ cont C_BPMNWait = cont C_BPMNWait
  searchNF _ cont C_BPMNReceive = cont C_BPMNReceive
  searchNF _ _ x = error
    ("BPMN2BPEL.BPMNInterKind.searchNF: no constructor: " ++ show x)

instance Unifiable C_BPMNInterKind where
  (=.=) C_BPMNWait C_BPMNWait d cs = C_True
  (=.=) C_BPMNReceive C_BPMNReceive d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_BPMNWait C_BPMNWait d cs = C_True
  (=.<=) C_BPMNReceive C_BPMNReceive d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_BPMNWait = (i :=: ChooseN 0 0) : concat []
  bind cd i C_BPMNReceive = (i :=: ChooseN 1 0) : concat []
  bind d i (Choice_C_BPMNInterKind cd j x y) = [ConstraintChoice cd j (bind d i
    x) (bind d i y)]
  bind d i (Choices_C_BPMNInterKind cd j@(FreeID _ _) xs) = bindOrNarrow d i cd
    j xs
  bind d i (Choices_C_BPMNInterKind cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_BPMNInterKind cd i _) = error
    ("BPMN2BPEL.BPMNInterKind.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_BPMNInterKind cd info) = [Unsolvable info]
  bind d i (Guard_C_BPMNInterKind cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_BPMNWait = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_BPMNReceive = (i :=: ChooseN 1 0) : []
  lazyBind d i (Choice_C_BPMNInterKind cd j x y) = [ConstraintChoice cd j
    (lazyBind d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_BPMNInterKind cd j@(FreeID _ _) xs) = lazyBindOrNarrow
    d i cd j xs
  lazyBind d i (Choices_C_BPMNInterKind cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_BPMNInterKind cd i _) = error
    ("BPMN2BPEL.BPMNInterKind.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_BPMNInterKind cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_BPMNInterKind cd c e) = getConstrList c ++ [i :=:
    LazyBind (lazyBind d i e)]

instance Curry C_BPMNInterKind where

data C_BPELComp
  = C_Invoke (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_Wait (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_Receive (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_Flow (Curry_Prelude.OP_List C_BPELComp) (Curry_Prelude.OP_List C_BPELComp)
  | C_Switch (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) (Curry_Prelude.OP_List C_BPELComp)
    (Curry_Prelude.OP_List C_BPELComp)
  | Choice_C_BPELComp Cover ID C_BPELComp C_BPELComp
  | Choices_C_BPELComp Cover ID [C_BPELComp]
  | Fail_C_BPELComp Cover FailInfo
  | Guard_C_BPELComp Cover Constraints C_BPELComp

instance Show C_BPELComp where
  showsPrec d (Choice_C_BPELComp cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_BPELComp cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_BPELComp cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_BPELComp cd info) = showChar '!'
  showsPrec _ (C_Invoke x1) = showString "(Invoke" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_Wait x1) = showString "(Wait" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_Receive x1) = showString "(Receive" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_Flow x1 x2) = showString "(Flow" . (showChar ' ' . (shows x1 .
    (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_Switch x1 x2 x3 x4) = showString "(Switch" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 .
    (showChar ' ' . (shows x4 . showChar ')'))))))))

instance Read C_BPELComp where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Invoke x1, r1) | (_, r0) <-
    readQualified "BPMN2BPEL" "Invoke" r, (x1, r1) <- readsPrec 11 r0]) s ++
    (readParen ((>) d 10) (\r -> [(C_Wait x1, r1) | (_, r0) <- readQualified
    "BPMN2BPEL" "Wait" r, (x1, r1) <- readsPrec 11 r0]) s ++ (readParen ((>) d
    10) (\r -> [(C_Receive x1, r1) | (_, r0) <- readQualified "BPMN2BPEL"
    "Receive" r, (x1, r1) <- readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r ->
    [(C_Flow x1 x2, r2) | (_, r0) <- readQualified "BPMN2BPEL" "Flow" r, (x1
    , r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ readParen ((>)
    d 10) (\r -> [(C_Switch x1 x2 x3 x4, r4) | (_, r0) <- readQualified
    "BPMN2BPEL" "Switch" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec
    11 r1, (x3, r3) <- readsPrec 11 r2, (x4, r4) <- readsPrec 11 r3]) s)))

instance NonDet C_BPELComp where
  choiceCons = Choice_C_BPELComp
  choicesCons = Choices_C_BPELComp
  failCons = Fail_C_BPELComp
  guardCons = Guard_C_BPELComp
  try (Choice_C_BPELComp cd i x y) = tryChoice cd i x y
  try (Choices_C_BPELComp cd i xs) = tryChoices cd i xs
  try (Fail_C_BPELComp cd info) = Fail cd info
  try (Guard_C_BPELComp cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_BPELComp cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_BPELComp cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_BPELComp cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_BPELComp cd i _) = error
    ("BPMN2BPEL.BPELComp.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_BPELComp cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_BPELComp cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_BPELComp where
  generate s c = Choices_C_BPELComp c (freeID [1, 1, 1, 2, 4] s) [C_Invoke
    (generate (leftSupply s) c), C_Wait (generate (leftSupply s) c), C_Receive
    (generate (leftSupply s) c), C_Flow (generate (leftSupply s) c) (generate
    (rightSupply s) c), C_Switch (generate (leftSupply (leftSupply s)) c)
    (generate (rightSupply (leftSupply s)) c) (generate (leftSupply (rightSupply
    s)) c) (generate (rightSupply (rightSupply s)) c)]

instance NormalForm C_BPELComp where
  ($!!) cont (C_Invoke x1) d cs = ($!!) (\y1 d cs -> cont (C_Invoke y1) d cs) x1
    d cs
  ($!!) cont (C_Wait x1) d cs = ($!!) (\y1 d cs -> cont (C_Wait y1) d cs) x1 d
    cs
  ($!!) cont (C_Receive x1) d cs = ($!!) (\y1 d cs -> cont (C_Receive y1) d cs)
    x1 d cs
  ($!!) cont (C_Flow x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Flow y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_Switch x1 x2 x3 x4) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> cont (C_Switch y1 y2 y3 y4) d cs) x4 d
    cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_BPELComp cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_BPELComp cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_BPELComp cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_BPELComp cd info) _ _ = failCons cd info
  ($##) cont (C_Invoke x1) d cs = ($##) (\y1 d cs -> cont (C_Invoke y1) d cs) x1
    d cs
  ($##) cont (C_Wait x1) d cs = ($##) (\y1 d cs -> cont (C_Wait y1) d cs) x1 d
    cs
  ($##) cont (C_Receive x1) d cs = ($##) (\y1 d cs -> cont (C_Receive y1) d cs)
    x1 d cs
  ($##) cont (C_Flow x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Flow y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_Switch x1 x2 x3 x4) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> ($##) (\y4 d cs -> cont (C_Switch y1 y2 y3 y4) d cs) x4 d
    cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_BPELComp cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_BPELComp cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_BPELComp cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_BPELComp cd info) _ _ = failCons cd info
  showCons (C_Invoke _) = "BPMN2BPEL.Invoke _"
  showCons (C_Wait _) = "BPMN2BPEL.Wait _"
  showCons (C_Receive _) = "BPMN2BPEL.Receive _"
  showCons (C_Flow _ _) = "BPMN2BPEL.Flow _ _"
  showCons (C_Switch _ _ _ _) = "BPMN2BPEL.Switch _ _ _ _"
  showCons x = error ("BPMN2BPEL.BPELComp.showCons: no constructor: " ++ show x)
  searchNF search cont (C_Invoke x1) = search (\y1 -> cont (C_Invoke y1)) x1
  searchNF search cont (C_Wait x1) = search (\y1 -> cont (C_Wait y1)) x1
  searchNF search cont (C_Receive x1) = search (\y1 -> cont (C_Receive y1)) x1
  searchNF search cont (C_Flow x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Flow y1 y2)) x2) x1
  searchNF search cont (C_Switch x1 x2 x3 x4) = search (\y1 -> search (\y2 ->
    search (\y3 -> search (\y4 -> cont (C_Switch y1 y2 y3 y4)) x4) x3) x2) x1
  searchNF _ _ x = error ("BPMN2BPEL.BPELComp.searchNF: no constructor: " ++
    show x)

instance Unifiable C_BPELComp where
  (=.=) (C_Invoke x1) (C_Invoke y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Wait x1) (C_Wait y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Receive x1) (C_Receive y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Flow x1 x2) (C_Flow y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2
    d cs) d cs
  (=.=) (C_Switch x1 x2 x3 x4) (C_Switch y1 y2 y3 y4) d cs = (&) ((=:=) x1 y1 d
    cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((=:=) x4 y4 d cs) d cs)
    d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Invoke x1) (C_Invoke y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Wait x1) (C_Wait y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Receive x1) (C_Receive y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Flow x1 x2) (C_Flow y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=) x2
    y2 d cs) d cs
  (=.<=) (C_Switch x1 x2 x3 x4) (C_Switch y1 y2 y3 y4) d cs = (&) ((=:<=) x1 y1
    d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs) ((=:<=) x4 y4 d cs)
    d cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Invoke x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_Wait x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_Receive x3) = (i :=: ChooseN 2 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_Flow x3 x4) = (i :=: ChooseN 3 2) : concat [bind cd (leftID i) x3
    , bind cd (rightID i) x4]
  bind cd i (C_Switch x3 x4 x5 x6) = (i :=: ChooseN 4 4) : concat [bind cd
    (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (leftID
    (rightID i)) x5, bind cd (rightID (rightID i)) x6]
  bind d i (Choice_C_BPELComp cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_BPELComp cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_BPELComp cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_BPELComp cd i _) = error
    ("BPMN2BPEL.BPELComp.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_BPELComp cd info) = [Unsolvable info]
  bind d i (Guard_C_BPELComp cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Invoke x3) = (i :=: ChooseN 0 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Wait x3) = (i :=: ChooseN 1 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Receive x3) = (i :=: ChooseN 2 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Flow x3 x4) = (i :=: ChooseN 3 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (C_Switch x3 x4 x5 x6) = (i :=: ChooseN 4 4) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), leftID (rightID i) :=:
    LazyBind (lazyBind cd (leftID (rightID i)) x5), rightID (rightID i) :=:
    LazyBind (lazyBind cd (rightID (rightID i)) x6)]
  lazyBind d i (Choice_C_BPELComp cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_BPELComp cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_BPELComp cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_BPELComp cd i _) = error
    ("BPMN2BPEL.BPELComp.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_BPELComp cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_BPELComp cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_BPELComp where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_BPMNComp
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash l
    s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash r
    s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "BPMN2BPEL._inst#Prelude.Data#BPMN2BPEL.BPMNComp#" [show x1] info)
  _ -> failCons cd (consFail "BPMN2BPEL._inst#Prelude.Data#BPMN2BPEL.BPMNComp#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash :: C_BPMNComp
  -> C_BPMNComp -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash x1 x2 s cd cs =
  case x1 of
  C_BPMNStart -> d_C__case_13 x2 cd cs
  C_BPMNEnd -> d_C__case_12 x2 cd cs
  C_BPMNPGW -> d_C__case_11 x2 cd cs
  C_BPMNXGW x18 x19 -> let s0 = s in s0 `seq` nd_C__case_10 x19 x18 x2 s0 cd cs
  C_BPMNActivity x25 -> let s0 = s in s0 `seq` nd_C__case_9 x25 x2 s0 cd cs
  C_BPMNInter x31 x32 -> let s0 = s in s0 `seq` nd_C__case_8 x32 x31 x2 s0 cd cs
  Choice_C_BPMNComp d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash
    r x2 s cd cs)
  Choices_C_BPMNComp d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash
    z x2 s cd cs) xs
  Guard_C_BPMNComp d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_BPMNComp d info -> failCons d (traceFail
    "BPMN2BPEL._impl#===#Prelude.Data#BPMN2BPEL.BPMNComp#" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "BPMN2BPEL._impl#===#Prelude.Data#BPMN2BPEL.BPMNComp#" (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash :: IDSupply
  -> Cover -> ConstStore -> C_BPMNComp
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash s cd cs =
  let s17 = s
  in s17 `seq` (let s16 = leftSupply s17
                    s18 = rightSupply s17
                    s11 = leftSupply s18
                    s15 = rightSupply s18
  in s16 `seq` (s18 `seq` (s11 `seq` (s15 `seq` choice (let s10 = leftSupply s11
                                                            s12 = rightSupply
                                                              s11
                                                            s7 = leftSupply s12
                                                            s9 = rightSupply s12
  in s10 `seq` (s12 `seq` (s7 `seq` (s9 `seq` choice (let s6 = leftSupply s7
                                                          s8 = rightSupply s7
                                                          s2 = leftSupply s8
                                                          s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s2 `seq` (s5 `seq` choice (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
  in s1 `seq` (s0 `seq` choice (choice C_BPMNStart C_BPMNEnd s0 cd cs) C_BPMNPGW
  s1 cd cs)) (let s3 = leftSupply s5
                  s4 = rightSupply s5
  in s3 `seq` (s4 `seq` C_BPMNXGW
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s3 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s4 cd cs))) s6 cd cs)))) (C_BPMNActivity
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s9 cd cs)) s10 cd cs)))) (let s13 = leftSupply s15
                                s14 = rightSupply s15
  in s13 `seq` (s14 `seq` C_BPMNInter
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash
  s13 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s14 cd cs))) s16 cd cs))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_BPMNInterKind
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "BPMN2BPEL._inst#Prelude.Data#BPMN2BPEL.BPMNInterKind#" [show x1] info)
  _ -> failCons cd (consFail
    "BPMN2BPEL._inst#Prelude.Data#BPMN2BPEL.BPMNInterKind#" (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash :: C_BPMNInterKind
  -> C_BPMNInterKind -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash x1 x2 cd cs =
  case x1 of
  C_BPMNWait -> d_C__case_7 x2 cd cs
  C_BPMNReceive -> d_C__case_6 x2 cd cs
  Choice_C_BPMNInterKind d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash
    r x2 cd cs)
  Choices_C_BPMNInterKind d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash
    z x2 cd cs) xs
  Guard_C_BPMNInterKind d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_BPMNInterKind d info -> failCons d (traceFail
    "BPMN2BPEL._impl#===#Prelude.Data#BPMN2BPEL.BPMNInterKind#" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "BPMN2BPEL._impl#===#Prelude.Data#BPMN2BPEL.BPMNInterKind#" (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash :: IDSupply
  -> Cover -> ConstStore -> C_BPMNInterKind
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash s cd cs =
  let s0 = s in s0 `seq` choice C_BPMNWait C_BPMNReceive s0 cd cs

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_BPELComp
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash l
    s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash r
    s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "BPMN2BPEL._inst#Prelude.Data#BPMN2BPEL.BPELComp#" [show x1] info)
  _ -> failCons cd (consFail "BPMN2BPEL._inst#Prelude.Data#BPMN2BPEL.BPELComp#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash :: C_BPELComp
  -> C_BPELComp -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash x1 x2 s cd cs =
  case x1 of
  C_Invoke x3 -> let s0 = s in s0 `seq` nd_C__case_5 x3 x2 s0 cd cs
  C_Wait x13 -> let s0 = s in s0 `seq` nd_C__case_4 x13 x2 s0 cd cs
  C_Receive x23 -> let s0 = s in s0 `seq` nd_C__case_3 x23 x2 s0 cd cs
  C_Flow x33 x34 -> let s0 = s in s0 `seq` nd_C__case_2 x34 x33 x2 s0 cd cs
  C_Switch x44 x45 x46 x47 -> let s0 = s
    in s0 `seq` nd_C__case_1 x47 x46 x45 x44 x2 s0 cd cs
  Choice_C_BPELComp d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash
    r x2 s cd cs)
  Choices_C_BPELComp d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash
    z x2 s cd cs) xs
  Guard_C_BPELComp d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_BPELComp d info -> failCons d (traceFail
    "BPMN2BPEL._impl#===#Prelude.Data#BPMN2BPEL.BPELComp#" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "BPMN2BPEL._impl#===#Prelude.Data#BPMN2BPEL.BPELComp#" (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash :: IDSupply
  -> Cover -> ConstStore -> C_BPELComp
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash s cd cs =
  let s23 = s
  in s23 `seq` (let s22 = leftSupply s23
                    s24 = rightSupply s23
                    s13 = leftSupply s24
                    s19 = rightSupply s24
  in s22 `seq` (s24 `seq` (s13 `seq` (s19 `seq` choice (let s12 = leftSupply s13
                                                            s14 = rightSupply
                                                              s13
                                                            s7 = leftSupply s14
                                                            s11 = rightSupply
                                                              s14
  in s12 `seq` (s14 `seq` (s7 `seq` (s11 `seq` choice (let s6 = leftSupply s7
                                                           s8 = rightSupply s7
                                                           s3 = leftSupply s8
                                                           s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` choice (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` choice (C_Invoke
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)) (C_Wait
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s1 cd cs)) s2 cd cs)))) (C_Receive
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s5 cd cs)) s6 cd cs)))) (let s9 = leftSupply s11
                               s10 = rightSupply s11
  in s9 `seq` (s10 `seq` C_Flow
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash) s9
  cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash) s10
  cd cs))) s12 cd cs)))) (let s20 = leftSupply s19
                              s21 = rightSupply s19
                              s15 = leftSupply s20
                              s16 = rightSupply s20
                              s17 = leftSupply s21
                              s18 = rightSupply s21
  in s20 `seq` (s21 `seq` (s15 `seq` (s16 `seq` (s17 `seq` (s18 `seq` C_Switch
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s15 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s16 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash) s17
  cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash) s18
  cd cs))))))) s22 cd cs))))

d_C_ex :: Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_BPMNComp (Curry_Prelude.OP_List Curry_Prelude.C_Int))
d_C_ex cd cs = Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 C_BPMNStart
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1)) Curry_Prelude.OP_List))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 C_BPMNPGW
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (2)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (4))
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (3)) Curry_Prelude.OP_List)))))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (C_BPMNActivity
  (Curry_Prelude.toCurryString "act1")) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (2)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (6))
  Curry_Prelude.OP_List))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (C_BPMNActivity (Curry_Prelude.toCurryString "act2")) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (6)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (10))
  Curry_Prelude.OP_List))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  C_BPMNPGW (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (15))
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (16)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (18)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (17))
  Curry_Prelude.OP_List))))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (C_BPMNActivity (Curry_Prelude.toCurryString "act3")) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (3)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (5))
  Curry_Prelude.OP_List))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (C_BPMNXGW (Curry_Prelude.toCurryString "cond1") (Curry_Prelude.toCurryString
  "cond2")) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (5))
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (7)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (9)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (8))
  Curry_Prelude.OP_List))))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (C_BPMNActivity (Curry_Prelude.toCurryString "act4")) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (7)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (11))
  Curry_Prelude.OP_List))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (C_BPMNActivity (Curry_Prelude.toCurryString "act5")) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (8)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (14))
  Curry_Prelude.OP_List))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (C_BPMNInter C_BPMNWait (Curry_Prelude.toCurryString "ev2"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (11)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (13)) Curry_Prelude.OP_List))) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (C_BPMNXGW Curry_Prelude.OP_List
  Curry_Prelude.OP_List) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (12))
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (13)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (17)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (14))
  Curry_Prelude.OP_List))))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (C_BPMNInter C_BPMNReceive (Curry_Prelude.toCurryString "ev1"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (10)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (16)) Curry_Prelude.OP_List))) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 C_BPMNEnd (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int
  (18)) Curry_Prelude.OP_List)) Curry_Prelude.OP_List))))))))))))

nd_C_processS :: IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_BPMNComp (Curry_Prelude.OP_List
  Curry_Prelude.C_Int))) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  C_BPELComp) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_BPMNComp
  (Curry_Prelude.OP_List Curry_Prelude.C_Int))))
nd_C_processS s cd cs = let s7 = s
  in s7 `seq` (let s0 = leftSupply s7
                   s8 = rightSupply s7
                   s1 = leftSupply s8
                   s6 = rightSupply s8
  in s0 `seq` (s8 `seq` (s1 `seq` (s6 `seq` (let x1 = generate s0 cd
                                                 x2 = generate s1 cd
  in let s5 = leftSupply s6
         s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Grappa.nd_OP_lt_star (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Grappa.nd_OP_star_gt (wrapNX id
  (Curry_Grappa.nd_C_edge (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash)
  (Curry_Prelude.OP_Tuple2 C_BPMNStart (Curry_Prelude.OP_Cons x1
  Curry_Prelude.OP_List)))) (nd_C_flowS (Curry_Prelude.OP_Tuple2 x1 x2) s2 cd
  cs) s3 cd cs)) (wrapNX id (Curry_Grappa.nd_C_edge (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash)
  (Curry_Prelude.OP_Tuple2 C_BPMNEnd (Curry_Prelude.OP_Cons x2
  Curry_Prelude.OP_List)))) s5 cd cs))))))

nd_C_flowS :: Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_Prelude.C_Int
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_BPMNComp (Curry_Prelude.OP_List
  Curry_Prelude.C_Int))) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  C_BPELComp) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_BPMNComp
  (Curry_Prelude.OP_List Curry_Prelude.C_Int))))
nd_C_flowS x1 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s11 = s
    in s11 `seq` (let s10 = leftSupply s11
                      s12 = rightSupply s11
                      s2 = leftSupply s12
                      s9 = rightSupply s12
    in s10 `seq` (s12 `seq` (s2 `seq` (s9 `seq` choice (let s1 = leftSupply s2
                                                            s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Grappa.nd_OP_lt_dollar_gt (wrapNX id
    (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs (acceptCs id)
    Curry_Prelude.OP_Cons)) Curry_Prelude.OP_List)) (nd_C_flElemS
    (Curry_Prelude.OP_Tuple2 x2 x3) s0 cd cs) s1 cd cs)) (let s3 = leftSupply s9
                                                              s8 = rightSupply
                                                                s9
    in s3 `seq` (s8 `seq` (let x4 = generate s3 cd
    in let s6 = leftSupply s8
           s7 = rightSupply s8
    in s6 `seq` (s7 `seq` wrapNX id (Curry_Grappa.nd_OP_lt_star_gt
    (let s5 = leftSupply s6
         s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Grappa.nd_OP_lt_dollar_gt (wrapDX (wrapDX id)
    (acceptCs (acceptCs id) Curry_Prelude.OP_Cons)) (nd_C_flElemS
    (Curry_Prelude.OP_Tuple2 x2 x4) s4 cd cs) s5 cd cs)) (nd_C_flowS
    (Curry_Prelude.OP_Tuple2 x4 x3) s7 cd cs)))))) s10 cd cs))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_flowS l s cd cs)
    (nd_C_flowS r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_flowS z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C_flowS e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "BPMN2BPEL.flowS"
    [show x1] info)
  _ -> failCons cd (consFail "BPMN2BPEL.flowS" (showCons x1))

nd_C_flElemS :: Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_Prelude.C_Int
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_BPMNComp (Curry_Prelude.OP_List
  Curry_Prelude.C_Int))) (Curry_Prelude.OP_Tuple2 C_BPELComp
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_BPMNComp
  (Curry_Prelude.OP_List Curry_Prelude.C_Int))))
nd_C_flElemS x1 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s67 = s
    in s67 `seq` (let s66 = leftSupply s67
                      s68 = rightSupply s67
                      s35 = leftSupply s68
                      s56 = rightSupply s68
    in s66 `seq` (s68 `seq` (s35 `seq` (s56 `seq` choice (let s34 = leftSupply
                                                                s35
                                                              s36 = rightSupply
                                                                s35
                                                              s11 = leftSupply
                                                                s36
                                                              s28 = rightSupply
                                                                s36
    in s34 `seq` (s36 `seq` (s11 `seq` (s28 `seq` choice (let s10 = leftSupply
                                                                s11
                                                              s12 = rightSupply
                                                                s11
                                                              s5 = leftSupply
                                                                s12
                                                              s9 = rightSupply
                                                                s12
    in s10 `seq` (s12 `seq` (s5 `seq` (s9 `seq` choice (let s0 = leftSupply s5
                                                            s6 = rightSupply s5
                                                            s1 = leftSupply s6
                                                            s4 = rightSupply s6
    in s0 `seq` (s6 `seq` (s1 `seq` (s4 `seq` (let x4 = generate s0 cd
                                                   x5 = generate s1 cd
    in let s3 = leftSupply s4
           s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Grappa.nd_OP_lt_dollar (Curry_Prelude.nd_C_apply
    (wrapDX id (d_OP_flElemS_dot_translateInter_dot_10 x4 cd cs)) x5 s2 cd cs)
    (wrapNX id (Curry_Grappa.nd_C_edge (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash)
    (Curry_Prelude.OP_Tuple2 (C_BPMNInter x4 x5) (Curry_Prelude.OP_Cons x2
    (Curry_Prelude.OP_Cons x3 Curry_Prelude.OP_List))))) s3 cd cs))))))
    (let s7 = leftSupply s9
         s8 = rightSupply s9
    in s7 `seq` (s8 `seq` (let x6 = generate s7 cd
    in Curry_Grappa.nd_OP_lt_dollar (C_Invoke x6) (wrapNX id
    (Curry_Grappa.nd_C_edge (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash)
    (Curry_Prelude.OP_Tuple2 (C_BPMNActivity x6) (Curry_Prelude.OP_Cons x2
    (Curry_Prelude.OP_Cons x3 Curry_Prelude.OP_List))))) s8 cd cs))) s10 cd
    cs)))) (let s29 = leftSupply s28
                s31 = rightSupply s28
                s13 = leftSupply s29
                s30 = rightSupply s29
                s14 = leftSupply s30
                s15 = rightSupply s30
                s32 = leftSupply s31
                s33 = rightSupply s31
                s16 = leftSupply s32
                s17 = rightSupply s32
                s18 = leftSupply s33
                s27 = rightSupply s33
    in s29 `seq` (s31 `seq` (s13 `seq` (s30 `seq` (s14 `seq` (s15 `seq`
    (s32 `seq` (s33 `seq` (s16 `seq` (s17 `seq` (s18 `seq` (s27 `seq`
    (let x7 = generate s13 cd
         x8 = generate s14 cd
         x9 = generate s15 cd
         x10 = generate s16 cd
         x11 = generate s17 cd
         x12 = generate s18 cd
    in let s26 = leftSupply s27
           s25 = rightSupply s27
    in s26 `seq` (s25 `seq` Curry_Grappa.nd_OP_lt_star (let s24 = leftSupply s25
                                                            s23 = rightSupply
                                                              s25
    in s24 `seq` (s23 `seq` Curry_Grappa.nd_OP_star_gt (wrapNX id
    (Curry_Grappa.nd_C_edge (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash)
    (Curry_Prelude.OP_Tuple2 C_BPMNPGW (Curry_Prelude.OP_Cons x2
    (Curry_Prelude.OP_Cons x7 (Curry_Prelude.OP_Cons x8 (Curry_Prelude.OP_Cons
    x9 Curry_Prelude.OP_List))))))) (let s21 = leftSupply s23
                                         s22 = rightSupply s23
    in s21 `seq` (s22 `seq` wrapNX id (Curry_Grappa.nd_OP_lt_star_gt
    (let s20 = leftSupply s21
         s19 = rightSupply s21
    in s20 `seq` (s19 `seq` Curry_Grappa.nd_OP_lt_dollar_gt (wrapDX (wrapDX id)
    (acceptCs (acceptCs id) C_Flow)) (nd_C_flowS (Curry_Prelude.OP_Tuple2 x7
    x11) s19 cd cs) s20 cd cs)) (nd_C_flowS (Curry_Prelude.OP_Tuple2 x9 x12) s22
    cd cs)))) s24 cd cs)) (wrapNX id (Curry_Grappa.nd_C_edge (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash)
    (Curry_Prelude.OP_Tuple2 C_BPMNPGW (Curry_Prelude.OP_Cons x10
    (Curry_Prelude.OP_Cons x11 (Curry_Prelude.OP_Cons x3 (Curry_Prelude.OP_Cons
    x12 Curry_Prelude.OP_List))))))) s26 cd cs)))))))))))))) s34 cd cs))))
    (let s57 = leftSupply s56
         s61 = rightSupply s56
         s58 = leftSupply s57
         s59 = rightSupply s57
         s37 = leftSupply s58
         s38 = rightSupply s58
         s39 = leftSupply s59
         s60 = rightSupply s59
         s40 = leftSupply s60
         s41 = rightSupply s60
         s62 = leftSupply s61
         s64 = rightSupply s61
         s42 = leftSupply s62
         s63 = rightSupply s62
         s43 = leftSupply s63
         s44 = rightSupply s63
         s45 = leftSupply s64
         s65 = rightSupply s64
         s46 = leftSupply s65
         s55 = rightSupply s65
    in s57 `seq` (s61 `seq` (s58 `seq` (s59 `seq` (s37 `seq` (s38 `seq`
    (s39 `seq` (s60 `seq` (s40 `seq` (s41 `seq` (s62 `seq` (s64 `seq` (s42 `seq`
    (s63 `seq` (s43 `seq` (s44 `seq` (s45 `seq` (s65 `seq` (s46 `seq` (s55 `seq`
    (let x13 = generate s37 cd
         x14 = generate s38 cd
         x15 = generate s39 cd
         x16 = generate s40 cd
         x17 = generate s41 cd
         x18 = generate s42 cd
         x19 = generate s43 cd
         x20 = generate s44 cd
         x21 = generate s45 cd
         x22 = generate s46 cd
    in let s54 = leftSupply s55
           s53 = rightSupply s55
    in s54 `seq` (s53 `seq` Curry_Grappa.nd_OP_lt_star (let s52 = leftSupply s53
                                                            s51 = rightSupply
                                                              s53
    in s52 `seq` (s51 `seq` Curry_Grappa.nd_OP_star_gt (wrapNX id
    (Curry_Grappa.nd_C_edge (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash)
    (Curry_Prelude.OP_Tuple2 (C_BPMNXGW x13 x14) (Curry_Prelude.OP_Cons x2
    (Curry_Prelude.OP_Cons x17 (Curry_Prelude.OP_Cons x18 (Curry_Prelude.OP_Cons
    x19 Curry_Prelude.OP_List))))))) (let s49 = leftSupply s51
                                          s50 = rightSupply s51
    in s49 `seq` (s50 `seq` wrapNX id (Curry_Grappa.nd_OP_lt_star_gt
    (let s48 = leftSupply s49
         s47 = rightSupply s49
    in s48 `seq` (s47 `seq` Curry_Grappa.nd_OP_lt_dollar_gt (wrapDX (wrapDX id)
    (acceptCs (acceptCs id) (C_Switch x13 x14))) (nd_C_flowS
    (Curry_Prelude.OP_Tuple2 x17 x21) s47 cd cs) s48 cd cs)) (nd_C_flowS
    (Curry_Prelude.OP_Tuple2 x19 x22) s50 cd cs)))) s52 cd cs)) (wrapNX id
    (Curry_Grappa.nd_C_edge (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNComp_hash)
    (Curry_Prelude.OP_Tuple2 (C_BPMNXGW x15 x16) (Curry_Prelude.OP_Cons x20
    (Curry_Prelude.OP_Cons x21 (Curry_Prelude.OP_Cons x3 (Curry_Prelude.OP_Cons
    x22 Curry_Prelude.OP_List))))))) s54 cd cs)))))))))))))))))))))) s66 cd
    cs))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_flElemS l s cd cs)
    (nd_C_flElemS r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_flElemS z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C_flElemS e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "BPMN2BPEL.flElemS" [show x1] info)
  _ -> failCons cd (consFail "BPMN2BPEL.flElemS" (showCons x1))

d_OP_flElemS_dot_translateInter_dot_10 :: C_BPMNInterKind -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> C_BPELComp
d_OP_flElemS_dot_translateInter_dot_10 x1 cd cs = case x1 of
  C_BPMNWait -> acceptCs id C_Wait
  C_BPMNReceive -> acceptCs id C_Receive
  Choice_C_BPMNInterKind d i l r -> narrow d i
    (d_OP_flElemS_dot_translateInter_dot_10 l cd cs)
    (d_OP_flElemS_dot_translateInter_dot_10 r cd cs)
  Choices_C_BPMNInterKind d i xs -> narrows cs d i (\z ->
    d_OP_flElemS_dot_translateInter_dot_10 z cd cs) xs
  Guard_C_BPMNInterKind d c e -> guardCons d c ((\x ->
    d_OP_flElemS_dot_translateInter_dot_10 e cd x) $! addCs c cs)
  Fail_C_BPMNInterKind d info -> failCons d (traceFail
    "BPMN2BPEL.flElemS.translateInter.10" [show x1] info)
  _ -> failCons cd (consFail "BPMN2BPEL.flElemS.translateInter.10" (showCons
    x1))

d_C_bpel2xml :: Curry_Prelude.OP_List C_BPELComp -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_bpel2xml x1 cd cs = Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "<process>\n") (Curry_Prelude.d_OP_plus_plus
  (d_C_indent (Curry_Prelude.C_Int (1)) (d_C_seq2xml x1 cd cs) cd cs)
  (Curry_Prelude.toCurryString "</process>\n") cd cs) cd cs

d_C_seq2xml :: Curry_Prelude.OP_List C_BPELComp -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_seq2xml x1 cd cs = case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_0 x1 x2 x3 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_seq2xml l cd cs)
    (d_C_seq2xml r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_seq2xml z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_seq2xml e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "BPMN2BPEL.seq2xml"
    [show x1] info)
  _ -> failCons cd (consFail "BPMN2BPEL.seq2xml" (showCons x1))

d_C_bpelComp2xml :: C_BPELComp -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_bpelComp2xml x1 cd cs = case x1 of
  C_Invoke x2 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "<invoke name=\"") (Curry_Prelude.d_OP_plus_plus x2
    (Curry_Prelude.toCurryString "\"/>\n") cd cs) cd cs
  C_Wait x3 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "<wait name=\"") (Curry_Prelude.d_OP_plus_plus x3
    (Curry_Prelude.toCurryString "\"/>\n") cd cs) cd cs
  C_Receive x4 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "<receive name=\"") (Curry_Prelude.d_OP_plus_plus x4
    (Curry_Prelude.toCurryString "\"/>\n") cd cs) cd cs
  C_Flow x5 x6 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "<flow>\n") (Curry_Prelude.d_OP_plus_plus (d_C_indent (Curry_Prelude.C_Int
    (1)) (d_C_seq2xml x5 cd cs) cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_indent
    (Curry_Prelude.C_Int (1)) (d_C_seq2xml x6 cd cs) cd cs)
    (Curry_Prelude.toCurryString "</flow>\n") cd cs) cd cs) cd cs
  C_Switch x7 x8 x9 x10 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "<switch>\n") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " <case cond=\"") (Curry_Prelude.d_OP_plus_plus
    x7 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\">\n")
    (Curry_Prelude.d_OP_plus_plus (d_C_indent (Curry_Prelude.C_Int (1))
    (d_C_seq2xml x9 cd cs) cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " </case>\n") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " <case cond=\"") (Curry_Prelude.d_OP_plus_plus
    x8 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\">\n")
    (Curry_Prelude.d_OP_plus_plus (d_C_indent (Curry_Prelude.C_Int (1))
    (d_C_seq2xml x10 cd cs) cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " </case>\n") (Curry_Prelude.toCurryString
    "</switch>\n") cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd
    cs) cd cs) cd cs
  Choice_C_BPELComp d i l r -> narrow d i (d_C_bpelComp2xml l cd cs)
    (d_C_bpelComp2xml r cd cs)
  Choices_C_BPELComp d i xs -> narrows cs d i (\z -> d_C_bpelComp2xml z cd cs)
    xs
  Guard_C_BPELComp d c e -> guardCons d c ((\x -> d_C_bpelComp2xml e cd x) $!
    addCs c cs)
  Fail_C_BPELComp d info -> failCons d (traceFail "BPMN2BPEL.bpelComp2xml" [show
    x1] info)
  _ -> failCons cd (consFail "BPMN2BPEL.bpelComp2xml" (showCons x1))

d_C_indent :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_indent x1 x2 cd cs = let x3 = Curry_Prelude.d_C_take x1
                               (Curry_Prelude.d_C_repeat (Curry_Prelude.C_Char
                               ' '#) cd cs) cd cs
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_unlines cd cs)
  (Curry_Prelude.d_C_map (Curry_Prelude.d_OP_plus_plus x3)
  (Curry_Prelude.d_C_lines x2 cd cs) cd cs) cd cs

nd_C__case_8 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_BPMNInterKind
  -> C_BPMNComp -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_8 x32 x31 x2 s cd cs = case x2 of
  C_BPMNStart -> Curry_Prelude.C_False
  C_BPMNEnd -> Curry_Prelude.C_False
  C_BPMNPGW -> Curry_Prelude.C_False
  C_BPMNXGW x33 x34 -> Curry_Prelude.C_False
  C_BPMNActivity x35 -> Curry_Prelude.C_False
  C_BPMNInter x36 x37 -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_amp_amp
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPMNInterKind_hash
    x31 x36 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x32 x37 s0 cd cs) cd cs
  Choice_C_BPMNComp d i l r -> narrow d i (nd_C__case_8 x32 x31 l s cd cs)
    (nd_C__case_8 x32 x31 r s cd cs)
  Choices_C_BPMNComp d i xs -> narrows cs d i (\z -> nd_C__case_8 x32 x31 z s cd
    cs) xs
  Guard_C_BPMNComp d c e -> guardCons d c ((\x -> nd_C__case_8 x32 x31 e s cd
    x) $! addCs c cs)
  Fail_C_BPMNComp d info -> failCons d (traceFail "BPMN2BPEL._case_8" [show x32
    , show x31, show x2] info)
  _ -> failCons cd (consFail "BPMN2BPEL._case_8" (showCons x2))

nd_C__case_9 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_BPMNComp
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_9 x25 x2 s cd cs = case x2 of
  C_BPMNStart -> Curry_Prelude.C_False
  C_BPMNEnd -> Curry_Prelude.C_False
  C_BPMNPGW -> Curry_Prelude.C_False
  C_BPMNXGW x26 x27 -> Curry_Prelude.C_False
  C_BPMNActivity x28 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x25 x28 s0 cd cs
  C_BPMNInter x29 x30 -> Curry_Prelude.C_False
  Choice_C_BPMNComp d i l r -> narrow d i (nd_C__case_9 x25 l s cd cs)
    (nd_C__case_9 x25 r s cd cs)
  Choices_C_BPMNComp d i xs -> narrows cs d i (\z -> nd_C__case_9 x25 z s cd cs)
    xs
  Guard_C_BPMNComp d c e -> guardCons d c ((\x -> nd_C__case_9 x25 e s cd x) $!
    addCs c cs)
  Fail_C_BPMNComp d info -> failCons d (traceFail "BPMN2BPEL._case_9" [show x25
    , show x2] info)
  _ -> failCons cd (consFail "BPMN2BPEL._case_9" (showCons x2))

nd_C__case_10 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_BPMNComp -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_10 x19 x18 x2 s cd cs = case x2 of
  C_BPMNStart -> Curry_Prelude.C_False
  C_BPMNEnd -> Curry_Prelude.C_False
  C_BPMNPGW -> Curry_Prelude.C_False
  C_BPMNXGW x20 x21 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x18 x20 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x19 x21 s1 cd cs) cd cs))
  C_BPMNActivity x22 -> Curry_Prelude.C_False
  C_BPMNInter x23 x24 -> Curry_Prelude.C_False
  Choice_C_BPMNComp d i l r -> narrow d i (nd_C__case_10 x19 x18 l s cd cs)
    (nd_C__case_10 x19 x18 r s cd cs)
  Choices_C_BPMNComp d i xs -> narrows cs d i (\z -> nd_C__case_10 x19 x18 z s
    cd cs) xs
  Guard_C_BPMNComp d c e -> guardCons d c ((\x -> nd_C__case_10 x19 x18 e s cd
    x) $! addCs c cs)
  Fail_C_BPMNComp d info -> failCons d (traceFail "BPMN2BPEL._case_10" [show x19
    , show x18, show x2] info)
  _ -> failCons cd (consFail "BPMN2BPEL._case_10" (showCons x2))

d_C__case_11 :: C_BPMNComp -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_11 x2 cd cs = case x2 of
  C_BPMNStart -> Curry_Prelude.C_False
  C_BPMNEnd -> Curry_Prelude.C_False
  C_BPMNPGW -> Curry_Prelude.C_True
  C_BPMNXGW x13 x14 -> Curry_Prelude.C_False
  C_BPMNActivity x15 -> Curry_Prelude.C_False
  C_BPMNInter x16 x17 -> Curry_Prelude.C_False
  Choice_C_BPMNComp d i l r -> narrow d i (d_C__case_11 l cd cs) (d_C__case_11 r
    cd cs)
  Choices_C_BPMNComp d i xs -> narrows cs d i (\z -> d_C__case_11 z cd cs) xs
  Guard_C_BPMNComp d c e -> guardCons d c ((\x -> d_C__case_11 e cd x) $! addCs
    c cs)
  Fail_C_BPMNComp d info -> failCons d (traceFail "BPMN2BPEL._case_11" [show x2]
    info)
  _ -> failCons cd (consFail "BPMN2BPEL._case_11" (showCons x2))

d_C__case_12 :: C_BPMNComp -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_12 x2 cd cs = case x2 of
  C_BPMNStart -> Curry_Prelude.C_False
  C_BPMNEnd -> Curry_Prelude.C_True
  C_BPMNPGW -> Curry_Prelude.C_False
  C_BPMNXGW x8 x9 -> Curry_Prelude.C_False
  C_BPMNActivity x10 -> Curry_Prelude.C_False
  C_BPMNInter x11 x12 -> Curry_Prelude.C_False
  Choice_C_BPMNComp d i l r -> narrow d i (d_C__case_12 l cd cs) (d_C__case_12 r
    cd cs)
  Choices_C_BPMNComp d i xs -> narrows cs d i (\z -> d_C__case_12 z cd cs) xs
  Guard_C_BPMNComp d c e -> guardCons d c ((\x -> d_C__case_12 e cd x) $! addCs
    c cs)
  Fail_C_BPMNComp d info -> failCons d (traceFail "BPMN2BPEL._case_12" [show x2]
    info)
  _ -> failCons cd (consFail "BPMN2BPEL._case_12" (showCons x2))

d_C__case_13 :: C_BPMNComp -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_13 x2 cd cs = case x2 of
  C_BPMNStart -> Curry_Prelude.C_True
  C_BPMNEnd -> Curry_Prelude.C_False
  C_BPMNPGW -> Curry_Prelude.C_False
  C_BPMNXGW x3 x4 -> Curry_Prelude.C_False
  C_BPMNActivity x5 -> Curry_Prelude.C_False
  C_BPMNInter x6 x7 -> Curry_Prelude.C_False
  Choice_C_BPMNComp d i l r -> narrow d i (d_C__case_13 l cd cs) (d_C__case_13 r
    cd cs)
  Choices_C_BPMNComp d i xs -> narrows cs d i (\z -> d_C__case_13 z cd cs) xs
  Guard_C_BPMNComp d c e -> guardCons d c ((\x -> d_C__case_13 e cd x) $! addCs
    c cs)
  Fail_C_BPMNComp d info -> failCons d (traceFail "BPMN2BPEL._case_13" [show x2]
    info)
  _ -> failCons cd (consFail "BPMN2BPEL._case_13" (showCons x2))

d_C__case_6 :: C_BPMNInterKind -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_6 x2 cd cs = case x2 of
  C_BPMNWait -> Curry_Prelude.C_False
  C_BPMNReceive -> Curry_Prelude.C_True
  Choice_C_BPMNInterKind d i l r -> narrow d i (d_C__case_6 l cd cs)
    (d_C__case_6 r cd cs)
  Choices_C_BPMNInterKind d i xs -> narrows cs d i (\z -> d_C__case_6 z cd cs)
    xs
  Guard_C_BPMNInterKind d c e -> guardCons d c ((\x -> d_C__case_6 e cd x) $!
    addCs c cs)
  Fail_C_BPMNInterKind d info -> failCons d (traceFail "BPMN2BPEL._case_6" [show
    x2] info)
  _ -> failCons cd (consFail "BPMN2BPEL._case_6" (showCons x2))

d_C__case_7 :: C_BPMNInterKind -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_7 x2 cd cs = case x2 of
  C_BPMNWait -> Curry_Prelude.C_True
  C_BPMNReceive -> Curry_Prelude.C_False
  Choice_C_BPMNInterKind d i l r -> narrow d i (d_C__case_7 l cd cs)
    (d_C__case_7 r cd cs)
  Choices_C_BPMNInterKind d i xs -> narrows cs d i (\z -> d_C__case_7 z cd cs)
    xs
  Guard_C_BPMNInterKind d c e -> guardCons d c ((\x -> d_C__case_7 e cd x) $!
    addCs c cs)
  Fail_C_BPMNInterKind d info -> failCons d (traceFail "BPMN2BPEL._case_7" [show
    x2] info)
  _ -> failCons cd (consFail "BPMN2BPEL._case_7" (showCons x2))

nd_C__case_1 :: Curry_Prelude.OP_List C_BPELComp -> Curry_Prelude.OP_List
  C_BPELComp -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_BPELComp -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_1 x47 x46 x45 x44 x2 s cd cs = case x2 of
  C_Invoke x48 -> Curry_Prelude.C_False
  C_Wait x49 -> Curry_Prelude.C_False
  C_Receive x50 -> Curry_Prelude.C_False
  C_Flow x51 x52 -> Curry_Prelude.C_False
  C_Switch x53 x54 x55 x56 -> let s6 = s
    in s6 `seq` (let s4 = leftSupply s6
                     s5 = rightSupply s6
    in s4 `seq` (s5 `seq` Curry_Prelude.d_OP_amp_amp (let s2 = leftSupply s4
                                                          s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x44 x53 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x45 x54 s1 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash)
    x46 x55 s3 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash)
    x47 x56 s5 cd cs) cd cs))
  Choice_C_BPELComp d i l r -> narrow d i (nd_C__case_1 x47 x46 x45 x44 l s cd
    cs) (nd_C__case_1 x47 x46 x45 x44 r s cd cs)
  Choices_C_BPELComp d i xs -> narrows cs d i (\z -> nd_C__case_1 x47 x46 x45
    x44 z s cd cs) xs
  Guard_C_BPELComp d c e -> guardCons d c ((\x -> nd_C__case_1 x47 x46 x45 x44 e
    s cd x) $! addCs c cs)
  Fail_C_BPELComp d info -> failCons d (traceFail "BPMN2BPEL._case_1" [show x47
    , show x46, show x45, show x44, show x2] info)
  _ -> failCons cd (consFail "BPMN2BPEL._case_1" (showCons x2))

nd_C__case_2 :: Curry_Prelude.OP_List C_BPELComp -> Curry_Prelude.OP_List
  C_BPELComp -> C_BPELComp -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_2 x34 x33 x2 s cd cs = case x2 of
  C_Invoke x35 -> Curry_Prelude.C_False
  C_Wait x36 -> Curry_Prelude.C_False
  C_Receive x37 -> Curry_Prelude.C_False
  C_Flow x38 x39 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash)
    x33 x38 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_BPMN2BPEL_dot_BPELComp_hash)
    x34 x39 s1 cd cs) cd cs))
  C_Switch x40 x41 x42 x43 -> Curry_Prelude.C_False
  Choice_C_BPELComp d i l r -> narrow d i (nd_C__case_2 x34 x33 l s cd cs)
    (nd_C__case_2 x34 x33 r s cd cs)
  Choices_C_BPELComp d i xs -> narrows cs d i (\z -> nd_C__case_2 x34 x33 z s cd
    cs) xs
  Guard_C_BPELComp d c e -> guardCons d c ((\x -> nd_C__case_2 x34 x33 e s cd
    x) $! addCs c cs)
  Fail_C_BPELComp d info -> failCons d (traceFail "BPMN2BPEL._case_2" [show x34
    , show x33, show x2] info)
  _ -> failCons cd (consFail "BPMN2BPEL._case_2" (showCons x2))

nd_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_BPELComp
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_3 x23 x2 s cd cs = case x2 of
  C_Invoke x24 -> Curry_Prelude.C_False
  C_Wait x25 -> Curry_Prelude.C_False
  C_Receive x26 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x23 x26 s0 cd cs
  C_Flow x27 x28 -> Curry_Prelude.C_False
  C_Switch x29 x30 x31 x32 -> Curry_Prelude.C_False
  Choice_C_BPELComp d i l r -> narrow d i (nd_C__case_3 x23 l s cd cs)
    (nd_C__case_3 x23 r s cd cs)
  Choices_C_BPELComp d i xs -> narrows cs d i (\z -> nd_C__case_3 x23 z s cd cs)
    xs
  Guard_C_BPELComp d c e -> guardCons d c ((\x -> nd_C__case_3 x23 e s cd x) $!
    addCs c cs)
  Fail_C_BPELComp d info -> failCons d (traceFail "BPMN2BPEL._case_3" [show x23
    , show x2] info)
  _ -> failCons cd (consFail "BPMN2BPEL._case_3" (showCons x2))

nd_C__case_4 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_BPELComp
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_4 x13 x2 s cd cs = case x2 of
  C_Invoke x14 -> Curry_Prelude.C_False
  C_Wait x15 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x13 x15 s0 cd cs
  C_Receive x16 -> Curry_Prelude.C_False
  C_Flow x17 x18 -> Curry_Prelude.C_False
  C_Switch x19 x20 x21 x22 -> Curry_Prelude.C_False
  Choice_C_BPELComp d i l r -> narrow d i (nd_C__case_4 x13 l s cd cs)
    (nd_C__case_4 x13 r s cd cs)
  Choices_C_BPELComp d i xs -> narrows cs d i (\z -> nd_C__case_4 x13 z s cd cs)
    xs
  Guard_C_BPELComp d c e -> guardCons d c ((\x -> nd_C__case_4 x13 e s cd x) $!
    addCs c cs)
  Fail_C_BPELComp d info -> failCons d (traceFail "BPMN2BPEL._case_4" [show x13
    , show x2] info)
  _ -> failCons cd (consFail "BPMN2BPEL._case_4" (showCons x2))

nd_C__case_5 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_BPELComp
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_5 x3 x2 s cd cs = case x2 of
  C_Invoke x4 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x4 s0 cd cs
  C_Wait x5 -> Curry_Prelude.C_False
  C_Receive x6 -> Curry_Prelude.C_False
  C_Flow x7 x8 -> Curry_Prelude.C_False
  C_Switch x9 x10 x11 x12 -> Curry_Prelude.C_False
  Choice_C_BPELComp d i l r -> narrow d i (nd_C__case_5 x3 l s cd cs)
    (nd_C__case_5 x3 r s cd cs)
  Choices_C_BPELComp d i xs -> narrows cs d i (\z -> nd_C__case_5 x3 z s cd cs)
    xs
  Guard_C_BPELComp d c e -> guardCons d c ((\x -> nd_C__case_5 x3 e s cd x) $!
    addCs c cs)
  Fail_C_BPELComp d info -> failCons d (traceFail "BPMN2BPEL._case_5" [show x3
    , show x2] info)
  _ -> failCons cd (consFail "BPMN2BPEL._case_5" (showCons x2))

d_C__case_0 :: Curry_Prelude.OP_List C_BPELComp -> C_BPELComp
  -> Curry_Prelude.OP_List C_BPELComp -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_0 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> d_C_bpelComp2xml x2 cd cs
  Curry_Prelude.OP_Cons x4 x5 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "<sequence>\n") (Curry_Prelude.d_OP_plus_plus
    (d_C_indent (Curry_Prelude.C_Int (1)) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_concatMap d_C_bpelComp2xml cd cs) x1 cd cs) cd cs)
    (Curry_Prelude.toCurryString "</sequence>\n") cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_0 x1 x2 l cd cs)
    (d_C__case_0 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_0 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_0 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "BPMN2BPEL._case_0"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "BPMN2BPEL._case_0" (showCons x3))

