{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_BPMNParser
  ( nd_C_process, nd_C_flow, nd_C_flElem, d_C_ex_sm )
  where

import Basics
import qualified Curry_Grappa
import qualified Curry_Prelude


nd_C_process :: IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Int))) (Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Int))))
nd_C_process s cd cs = let s7 = s
  in s7 `seq` (let s0 = leftSupply s7
                   s8 = rightSupply s7
                   s1 = leftSupply s8
                   s6 = rightSupply s8
  in s0 `seq` (s8 `seq` (s1 `seq` (s6 `seq` (let x1 = generate s0 cd
                                                 x2 = generate s1 cd
  in let s5 = leftSupply s6
         s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Grappa.nd_OP_star_gt (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Grappa.nd_OP_star_gt (wrapNX id
  (Curry_Grappa.nd_C_edge (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "start")
  (Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List)))) (nd_C_flow
  (Curry_Prelude.OP_Tuple2 x1 x2) s2 cd cs) s3 cd cs)) (wrapNX id
  (Curry_Grappa.nd_C_edge (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "end")
  (Curry_Prelude.OP_Cons x2 Curry_Prelude.OP_List)))) s5 cd cs))))))

nd_C_flow :: Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_Prelude.C_Int
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Int))) (Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Int))))
nd_C_flow x1 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s0 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s0 `seq` (s7 `seq` choice (nd_C_flElem
    (Curry_Prelude.OP_Tuple2 x2 x3) s0 cd cs) (let s1 = leftSupply s7
                                                   s5 = rightSupply s7
    in s1 `seq` (s5 `seq` (let x4 = generate s1 cd
    in let s4 = leftSupply s5
           s6 = rightSupply s5
           s2 = leftSupply s6
           s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Grappa.nd_OP_star_gt
    (nd_C_flElem (Curry_Prelude.OP_Tuple2 x2 x4) s2 cd cs) (nd_C_flow
    (Curry_Prelude.OP_Tuple2 x4 x3) s3 cd cs) s4 cd cs)))))) s8 cd cs))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_flow l s cd cs)
    (nd_C_flow r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_flow z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C_flow e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "BPMNParser.flow"
    [show x1] info)
  _ -> failCons cd (consFail "BPMNParser.flow" (showCons x1))

nd_C_flElem :: Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_Prelude.C_Int
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Int))) (Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Int))))
nd_C_flElem x1 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s47 = s
    in s47 `seq` (let s46 = leftSupply s47
                      s48 = rightSupply s47
                      s23 = leftSupply s48
                      s40 = rightSupply s48
    in s46 `seq` (s48 `seq` (s23 `seq` (s40 `seq` choice (let s22 = leftSupply
                                                                s23
                                                              s24 = rightSupply
                                                                s23
                                                              s0 = leftSupply
                                                                s24
                                                              s16 = rightSupply
                                                                s24
    in s22 `seq` (s24 `seq` (s0 `seq` (s16 `seq` choice (choice (wrapNX id
    (Curry_Grappa.nd_C_edge (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "act")
    (Curry_Prelude.OP_Cons x2 (Curry_Prelude.OP_Cons x3
    Curry_Prelude.OP_List))))) (wrapNX id (Curry_Grappa.nd_C_edge (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "inter")
    (Curry_Prelude.OP_Cons x2 (Curry_Prelude.OP_Cons x3
    Curry_Prelude.OP_List))))) s0 cd cs) (let s17 = leftSupply s16
                                              s19 = rightSupply s16
                                              s1 = leftSupply s17
                                              s18 = rightSupply s17
                                              s2 = leftSupply s18
                                              s3 = rightSupply s18
                                              s20 = leftSupply s19
                                              s21 = rightSupply s19
                                              s4 = leftSupply s20
                                              s5 = rightSupply s20
                                              s6 = leftSupply s21
                                              s14 = rightSupply s21
    in s17 `seq` (s19 `seq` (s1 `seq` (s18 `seq` (s2 `seq` (s3 `seq` (s20 `seq`
    (s21 `seq` (s4 `seq` (s5 `seq` (s6 `seq` (s14 `seq` (let x4 = generate s1 cd
                                                             x5 = generate s2 cd
                                                             x6 = generate s3 cd
                                                             x7 = generate s4 cd
                                                             x8 = generate s5 cd
                                                             x9 = generate s6 cd
    in let s13 = leftSupply s14
           s15 = rightSupply s14
           s11 = leftSupply s15
           s12 = rightSupply s15
    in s13 `seq` (s15 `seq` (s11 `seq` (s12 `seq` Curry_Grappa.nd_OP_star_gt
    (let s10 = leftSupply s11
         s9 = rightSupply s11
    in s10 `seq` (s9 `seq` Curry_Grappa.nd_OP_star_gt (let s8 = leftSupply s9
                                                           s7 = rightSupply s9
    in s8 `seq` (s7 `seq` Curry_Grappa.nd_OP_star_gt (wrapNX id
    (Curry_Grappa.nd_C_edge (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "pgw")
    (Curry_Prelude.OP_Cons x2 (Curry_Prelude.OP_Cons x4 (Curry_Prelude.OP_Cons
    x5 (Curry_Prelude.OP_Cons x6 Curry_Prelude.OP_List))))))) (nd_C_flow
    (Curry_Prelude.OP_Tuple2 x4 x8) s7 cd cs) s8 cd cs)) (wrapNX id
    (Curry_Grappa.nd_C_edge (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "pgw")
    (Curry_Prelude.OP_Cons x7 (Curry_Prelude.OP_Cons x8 (Curry_Prelude.OP_Cons
    x3 (Curry_Prelude.OP_Cons x9 Curry_Prelude.OP_List))))))) s10 cd cs))
    (nd_C_flow (Curry_Prelude.OP_Tuple2 x6 x9) s12 cd cs) s13 cd
    cs)))))))))))))))) s22 cd cs)))) (let s41 = leftSupply s40
                                          s43 = rightSupply s40
                                          s25 = leftSupply s41
                                          s42 = rightSupply s41
                                          s26 = leftSupply s42
                                          s27 = rightSupply s42
                                          s44 = leftSupply s43
                                          s45 = rightSupply s43
                                          s28 = leftSupply s44
                                          s29 = rightSupply s44
                                          s30 = leftSupply s45
                                          s38 = rightSupply s45
    in s41 `seq` (s43 `seq` (s25 `seq` (s42 `seq` (s26 `seq` (s27 `seq`
    (s44 `seq` (s45 `seq` (s28 `seq` (s29 `seq` (s30 `seq` (s38 `seq`
    (let x10 = generate s25 cd
         x11 = generate s26 cd
         x12 = generate s27 cd
         x13 = generate s28 cd
         x14 = generate s29 cd
         x15 = generate s30 cd
    in let s37 = leftSupply s38
           s39 = rightSupply s38
           s35 = leftSupply s39
           s36 = rightSupply s39
    in s37 `seq` (s39 `seq` (s35 `seq` (s36 `seq` Curry_Grappa.nd_OP_star_gt
    (let s34 = leftSupply s35
         s33 = rightSupply s35
    in s34 `seq` (s33 `seq` Curry_Grappa.nd_OP_star_gt (let s32 = leftSupply s33
                                                            s31 = rightSupply
                                                              s33
    in s32 `seq` (s31 `seq` Curry_Grappa.nd_OP_star_gt (wrapNX id
    (Curry_Grappa.nd_C_edge (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "xgw")
    (Curry_Prelude.OP_Cons x2 (Curry_Prelude.OP_Cons x10 (Curry_Prelude.OP_Cons
    x11 (Curry_Prelude.OP_Cons x12 Curry_Prelude.OP_List))))))) (nd_C_flow
    (Curry_Prelude.OP_Tuple2 x10 x14) s31 cd cs) s32 cd cs)) (wrapNX id
    (Curry_Grappa.nd_C_edge (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "xgw")
    (Curry_Prelude.OP_Cons x13 (Curry_Prelude.OP_Cons x14 (Curry_Prelude.OP_Cons
    x3 (Curry_Prelude.OP_Cons x15 Curry_Prelude.OP_List))))))) s34 cd cs))
    (nd_C_flow (Curry_Prelude.OP_Tuple2 x12 x15) s36 cd cs) s37 cd
    cs)))))))))))))))) s46 cd cs))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_flElem l s cd cs)
    (nd_C_flElem r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_flElem z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C_flElem e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "BPMNParser.flElem" [show x1] info)
  _ -> failCons cd (consFail "BPMNParser.flElem" (showCons x1))

d_C_ex_sm :: Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Int))
d_C_ex_sm cd cs = Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "start") (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (1)) Curry_Prelude.OP_List)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "pgw")
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (2)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (4))
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (3)) Curry_Prelude.OP_List)))))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "act") (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (2)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (6)) Curry_Prelude.OP_List))) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "act")
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (3)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (7)) Curry_Prelude.OP_List))) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "pgw")
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (5)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (6)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (8))
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (7)) Curry_Prelude.OP_List)))))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "end") (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (8))
  Curry_Prelude.OP_List)) Curry_Prelude.OP_List)))))

