{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_Grappa
  ( d_C_getSemRep
  , d_C_pSucceed
  , d_C_eoi
  , nd_C_edge
  , nd_OP_lt_bar_gt
  , d_OP_lt_star_gt
  , nd_OP_lt_star_gt
  , d_OP_lt_dollar_gt
  , nd_OP_lt_dollar_gt
  , d_OP_lt_dollar
  , nd_OP_lt_dollar
  , d_OP_lt_star
  , nd_OP_lt_star
  , d_OP_star_gt
  , nd_OP_star_gt
  , nd_C_chain )
  where

import Basics
import qualified Curry_Prelude


d_C_getSemRep :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))
  -> Cover -> ConstStore -> t0
d_C_getSemRep x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_getSemRep l cd cs)
    (d_C_getSemRep r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_getSemRep
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C_getSemRep e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Grappa.getSemRep" [show x1] info)
  _ -> failCons cd (consFail "Grappa.getSemRep" (showCons x1))

d_C_pSucceed :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => t0 -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t1 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))
d_C_pSucceed x1 x2 cd cs = Curry_Prelude.OP_Tuple2 x1 x2

d_C_eoi :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Int))
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)))
d_C_eoi x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_eoi l cd cs) (d_C_eoi
    r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_eoi z cd cs)
    xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_eoi e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Grappa.eoi" [show
    x1] info)
  _ -> failCons cd (consFail "Grappa.eoi" (showCons x1))

nd_C_edge :: forall t0 . (Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Int) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Int))
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)))
nd_C_edge x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` (let x4 = generate s0 cd
                             x5 = generate s1 cd
  in d_C__case_2 x5 x2 x4 x3 (Curry_Prelude.d_OP_eq_colon_eq x3
  (Curry_Prelude.d_OP_plus_plus x4 (Curry_Prelude.OP_Cons x2 x5) cd cs) cd cs)
  cd cs)))

nd_OP_lt_bar_gt :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List Curry_Prelude.C_Int))) (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)))) -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)))) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Int))
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)))
nd_OP_lt_bar_gt x1 x2 x3 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` choice (Curry_Prelude.nd_C_apply x1
  x3 s0 cd cs) (Curry_Prelude.nd_C_apply x2 x3 s1 cd cs) s2 cd cs))))

d_OP_lt_star_gt :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int))
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (t1 -> Cover -> ConstStore
  -> t0) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)))) -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int))
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int))))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)))
d_OP_lt_star_gt x1 x2 x3 cd cs = d_C__case_1 x3 x1 x2 (Curry_Prelude.d_C_apply
  x1 x3 cd cs) cd cs

nd_OP_lt_star_gt :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int))) (Curry_Prelude.OP_Tuple2 (Func t1 t0)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)))) -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)))) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int))
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)))
nd_OP_lt_star_gt x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_1 x3 x1 x2 (Curry_Prelude.nd_C_apply x1 x3 s0
  cd cs) s1 cd cs))

d_OP_lt_dollar_gt :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => (t2 -> Cover
  -> ConstStore -> t1) -> (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t0 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)))
d_OP_lt_dollar_gt x1 x2 cd cs = d_OP_lt_star_gt (d_C_pSucceed x1) x2

nd_OP_lt_dollar_gt :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func t2 t1 -> Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int))) (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Int))))
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Int))))
nd_OP_lt_dollar_gt x1 x2 s cd cs = wrapNX id (nd_OP_lt_star_gt (wrapDX id
  (d_C_pSucceed x1)) x2)

d_OP_lt_dollar :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => t2 -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Int))
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Int))))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t1 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))
d_OP_lt_dollar x1 x2 cd cs = d_OP_lt_dollar_gt (Curry_Prelude.d_C_const x1) x2
  cd cs

nd_OP_lt_dollar :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t2 -> Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int))) (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Int))))
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List Curry_Prelude.C_Int))))
nd_OP_lt_dollar x1 x2 s cd cs = let s0 = s
  in s0 `seq` nd_OP_lt_dollar_gt (wrapDX id (Curry_Prelude.d_C_const x1)) x2 s0
  cd cs

d_OP_lt_star :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))) -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int))
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int))))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))
d_OP_lt_star x1 x2 cd cs = d_OP_lt_star_gt (d_OP_lt_dollar_gt (acceptCs id
  d_OP_lt_star_dot_uscore_hash_lambda3) x1 cd cs) x2

nd_OP_lt_star :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)))) -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)))) -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int))) (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int))))
nd_OP_lt_star x1 x2 s cd cs = let s0 = s
  in s0 `seq` wrapNX id (nd_OP_lt_star_gt (nd_OP_lt_dollar_gt (wrapDX (wrapDX
  id) (acceptCs id d_OP_lt_star_dot_uscore_hash_lambda3)) x1 s0 cd cs) x2)

d_OP_lt_star_dot_uscore_hash_lambda3 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t1 -> t0 -> Cover -> ConstStore -> t1
d_OP_lt_star_dot_uscore_hash_lambda3 x1 x2 cd cs = x1

d_OP_star_gt :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))) -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int))
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int))))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))
d_OP_star_gt x1 x2 cd cs = d_OP_lt_star_gt (d_OP_lt_dollar_gt (acceptCs id
  d_OP_star_gt_dot_uscore_hash_lambda4) x1 cd cs) x2

nd_OP_star_gt :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)))) -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)))) -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int))) (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int))))
nd_OP_star_gt x1 x2 s cd cs = let s0 = s
  in s0 `seq` wrapNX id (nd_OP_lt_star_gt (nd_OP_lt_dollar_gt (wrapDX (wrapDX
  id) (acceptCs id d_OP_star_gt_dot_uscore_hash_lambda4)) x1 s0 cd cs) x2)

d_OP_star_gt_dot_uscore_hash_lambda4 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t1 -> t0 -> Cover -> ConstStore -> t0
d_OP_star_gt_dot_uscore_hash_lambda4 x1 x2 cd cs = x2

nd_C_chain :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_Prelude.C_Int)
  (Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List Curry_Prelude.C_Int))) (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int))))) -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int))) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int))))
nd_C_chain x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s11 = s
    in s11 `seq` (let s10 = leftSupply s11
                      s12 = rightSupply s11
                      s2 = leftSupply s12
                      s9 = rightSupply s12
    in s10 `seq` (s12 `seq` (s2 `seq` (s9 `seq` choice (let s1 = leftSupply s2
                                                            s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_OP_lt_dollar_gt (wrapNX id (Curry_Prelude.nd_C_flip
    (wrapDX (wrapDX id) (acceptCs (acceptCs id) Curry_Prelude.OP_Cons))
    Curry_Prelude.OP_List)) (Curry_Prelude.nd_C_apply x1
    (Curry_Prelude.OP_Tuple2 x3 x4) s0 cd cs) s1 cd cs)) (let s3 = leftSupply s9
                                                              s8 = rightSupply
                                                                s9
    in s3 `seq` (s8 `seq` (let x5 = generate s3 cd
    in let s6 = leftSupply s8
           s7 = rightSupply s8
    in s6 `seq` (s7 `seq` wrapNX id (nd_OP_lt_star_gt (let s5 = leftSupply s6
                                                           s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_OP_lt_dollar_gt (wrapDX (wrapDX id) (acceptCs
    (acceptCs id) Curry_Prelude.OP_Cons)) (Curry_Prelude.nd_C_apply x1
    (Curry_Prelude.OP_Tuple2 x3 x5) s4 cd cs) s5 cd cs)) (nd_C_chain x1
    (Curry_Prelude.OP_Tuple2 x5 x4) s7 cd cs)))))) s10 cd cs))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_chain x1 l s cd cs)
    (nd_C_chain x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_chain x1
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C_chain x1 e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Grappa.chain"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Grappa.chain" (showCons x2))

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Int)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)))
d_C__case_2 x5 x2 x4 x3 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit
    (Curry_Prelude.d_OP_plus_plus x4 x5 cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x5 x2 x4 x3 l
    cd cs) (d_C__case_2 x5 x2 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x5 x2
    x4 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x5 x2 x4
    x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Grappa._case_2"
    [show x5, show x2, show x4, show x3, show x6] info)
  _ -> failCons cd (consFail "Grappa._case_2" (showCons x6))

d_C__case_1 :: forall t2 t1 t0 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)) -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int))
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (t1 -> Cover -> ConstStore
  -> t0) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)))) -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int))
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int))))
  -> Curry_Prelude.OP_Tuple2 (t1 -> Cover -> ConstStore -> t0)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int))) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)))
d_C__case_1 x3 x1 x2 x6 cd cs = case x6 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_0 x5 x2 x4 (Curry_Prelude.d_C_apply
    x2 x5 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_1 x3 x1 x2 l
    cd cs) (d_C__case_1 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_1 x3
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_1 x3 x1
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Grappa._case_1"
    [show x3, show x1, show x2, show x6] info)
  _ -> failCons cd (consFail "Grappa._case_1" (showCons x6))

nd_C__case_1 :: forall t2 t1 t0 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int)) -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))
  (Curry_Prelude.OP_Tuple2 (Func t1 t0) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int))))
  -> Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int))) (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)))) -> Curry_Prelude.OP_Tuple2 (Func t1 t0)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int))) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))
nd_C__case_1 x3 x1 x2 x6 s cd cs = case x6 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_0 x5 x2 x4 (Curry_Prelude.nd_C_apply x2 x5
    s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_1 x3 x1 x2 l
    s cd cs) (nd_C__case_1 x3 x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_1
    x3 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_1 x3
    x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Grappa._case_1"
    [show x3, show x1, show x2, show x6] info)
  _ -> failCons cd (consFail "Grappa._case_1" (showCons x6))

d_C__case_0 :: forall t2 t1 t0 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)) -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int))
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int))))
  -> (t1 -> Cover -> ConstStore -> t0) -> Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int))) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)))
d_C__case_0 x5 x2 x4 x8 cd cs = case x8 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_C_apply x4 x6 cd cs) x7
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_0 x5 x2 x4 l
    cd cs) (d_C__case_0 x5 x2 x4 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_0 x5
    x2 x4 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_0 x5 x2
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Grappa._case_0"
    [show x5, show x2, show x4, show x8] info)
  _ -> failCons cd (consFail "Grappa._case_0" (showCons x8))

nd_C__case_0 :: forall t2 t1 t0 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int)) -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)))) -> Func t1 t0
  -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int))) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_List Curry_Prelude.C_Int)))
nd_C__case_0 x5 x2 x4 x8 s cd cs = case x8 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_apply x4 x6 s0 cd
    cs) x7
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_0 x5 x2 x4 l
    s cd cs) (nd_C__case_0 x5 x2 x4 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_0
    x5 x2 x4 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_0 x5
    x2 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Grappa._case_0"
    [show x5, show x2, show x4, show x8] info)
  _ -> failCons cd (consFail "Grappa._case_0" (showCons x8))

