{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_Names
  ( d_C_genCorrectIdentifier
  , d_C_showOpChar
  , d_C_replaceNonIdChars
  , d_C_separateAndReplace
  , nd_C_separateAndReplace )
  where

import Basics
import qualified Data.Curry_List
import qualified Curry_Prelude


d_C_genCorrectIdentifier :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_genCorrectIdentifier x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "genCorrectIdentifier: empty identifier") cd cs
  Curry_Prelude.OP_Cons x2 x3 -> let x4 = Curry_Prelude.d_C_flip
                                       (Curry_Prelude.d_C_elem
                                       Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                       (Curry_Prelude.toCurryString
                                       "!#$%&*+./<=>?@\\^|-~")
    in d_C__case_34 x3 x2 x4 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_all x4
    cd cs) (Curry_Prelude.OP_Cons x2 x3) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_genCorrectIdentifier l
    cd cs) (d_C_genCorrectIdentifier r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_genCorrectIdentifier z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_C_genCorrectIdentifier e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Names.genCorrectIdentifier" [show x1] info)
  _ -> failCons cd (consFail "Names.genCorrectIdentifier" (showCons x1))

d_C_showOpChar :: Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showOpChar x1 cd cs = d_C__case_32 x1
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.C_Char '_'#) cd cs) cd cs

d_C_replaceNonIdChars :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_replaceNonIdChars x1 x2 x3 cd cs = let x4 = d_C_separateAndReplace
                                             d_OP_replaceNonIdChars_dot_isIdentChar_dot_66
                                             d_C_showOpChar x3 cd cs
  in d_C__case_5 x2 x3 x1 x4 cd cs

d_OP_replaceNonIdChars_dot_isIdentChar_dot_66 :: Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_replaceNonIdChars_dot_isIdentChar_dot_66 x1 cd cs =
  Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_C_isAlphaNum x1 cd cs)
  (Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.C_Char '_'#) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.C_Char '\''#) cd cs) cd cs) cd cs

d_C_separateAndReplace :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0) -> Curry_Prelude.OP_List t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
d_C_separateAndReplace x1 x2 x3 cd cs = let x4 = Curry_Prelude.d_C_apply
                                              (Curry_Prelude.d_C_break
                                              (Curry_Prelude.d_OP_dot
                                              Curry_Prelude.d_C_not x1 cd cs) cd
                                              cs) x3 cd cs
                                            x5 = d_OP_separateAndReplace_dot_uscore_hash_selFP2_hash_sep
                                              x4 cd cs
                                            x6 = d_OP_separateAndReplace_dot_uscore_hash_selFP3_hash_rest
                                              x4 cd cs
  in d_C__case_2 x5 x2 x1 x6 cd cs

nd_C_separateAndReplace :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  Curry_Prelude.C_Bool -> Func t0 (Curry_Prelude.OP_List t0)
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
nd_C_separateAndReplace x1 x2 x3 s cd cs = let s6 = s
  in s6 `seq` (let s4 = leftSupply s6
                   s5 = rightSupply s6
  in s4 `seq` (s5 `seq` (let x4 = let s3 = leftSupply s4
                                      s2 = rightSupply s4
                               in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
                               (let s1 = leftSupply s2
                                    s0 = rightSupply s2
                               in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_break
                               (Curry_Prelude.nd_OP_dot (wrapDX id
                               Curry_Prelude.d_C_not) x1 s0 cd cs) s1 cd cs)) x3
                               s3 cd cs)
                             x5 = d_OP_separateAndReplace_dot_uscore_hash_selFP2_hash_sep
                               x4 cd cs
                             x6 = d_OP_separateAndReplace_dot_uscore_hash_selFP3_hash_rest
                               x4 cd cs
  in nd_C__case_2 x5 x2 x1 x6 s5 cd cs)))

d_OP_separateAndReplace_dot_uscore_hash_selFP2_hash_sep :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_separateAndReplace_dot_uscore_hash_selFP2_hash_sep x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_separateAndReplace_dot_uscore_hash_selFP2_hash_sep l cd cs)
    (d_OP_separateAndReplace_dot_uscore_hash_selFP2_hash_sep r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_separateAndReplace_dot_uscore_hash_selFP2_hash_sep z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_separateAndReplace_dot_uscore_hash_selFP2_hash_sep e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Names.separateAndReplace._#selFP2#sep" [show x1] info)
  _ -> failCons cd (consFail "Names.separateAndReplace._#selFP2#sep" (showCons
    x1))

d_OP_separateAndReplace_dot_uscore_hash_selFP3_hash_rest :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_separateAndReplace_dot_uscore_hash_selFP3_hash_rest x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_separateAndReplace_dot_uscore_hash_selFP3_hash_rest l cd cs)
    (d_OP_separateAndReplace_dot_uscore_hash_selFP3_hash_rest r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_separateAndReplace_dot_uscore_hash_selFP3_hash_rest z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_separateAndReplace_dot_uscore_hash_selFP3_hash_rest e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Names.separateAndReplace._#selFP3#rest" [show x1] info)
  _ -> failCons cd (consFail "Names.separateAndReplace._#selFP3#rest" (showCons
    x1))

d_C__case_34 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> (Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_34 x3 x2 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x2 x3
  Curry_Prelude.C_False -> d_C__case_33 x3 x2 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_34 x3 x2 x4 l cd
    cs) (d_C__case_34 x3 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_34 x3
    x2 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_34 x3 x2
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_34"
    [show x3, show x2, show x4, show x5] info)
  _ -> failCons cd (consFail "Names._case_34" (showCons x5))

nd_C__case_34 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Func Curry_Prelude.C_Char Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_34 x3 x2 x4 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x2 x3
  Curry_Prelude.C_False -> d_C__case_33 x3 x2 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_34 x3 x2 x4 l s
    cd cs) (nd_C__case_34 x3 x2 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_34 x3
    x2 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_34 x3 x2
    x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_34"
    [show x3, show x2, show x4, show x5] info)
  _ -> failCons cd (consFail "Names._case_34" (showCons x5))

d_C__case_33 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_33 x3 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> d_C_replaceNonIdChars Curry_Prelude.OP_List
    Curry_Prelude.OP_List (Curry_Prelude.OP_Cons x2 x3) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_33 x3 x2 l cd cs)
    (d_C__case_33 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_33 x3
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_33 x3 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_33"
    [show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "Names._case_33" (showCons x4))

d_C__case_32 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_32 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "_"
  Curry_Prelude.C_False -> d_C__case_31 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '~'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_32 x1 l cd cs)
    (d_C__case_32 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_32 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_32 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_32"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_32" (showCons x2))

d_C__case_31 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_31 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "tilde"
  Curry_Prelude.C_False -> d_C__case_30 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '!'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_31 x1 l cd cs)
    (d_C__case_31 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_31 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_31 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_31"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_31" (showCons x2))

d_C__case_30 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_30 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "bang"
  Curry_Prelude.C_False -> d_C__case_29 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '@'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_30 x1 l cd cs)
    (d_C__case_30 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_30 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_30 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_30"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_30" (showCons x2))

d_C__case_29 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_29 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "at"
  Curry_Prelude.C_False -> d_C__case_28 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '#'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_29 x1 l cd cs)
    (d_C__case_29 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_29 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_29 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_29"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_29" (showCons x2))

d_C__case_28 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_28 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "hash"
  Curry_Prelude.C_False -> d_C__case_27 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '$'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_28 x1 l cd cs)
    (d_C__case_28 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_28 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_28 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_28"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_28" (showCons x2))

d_C__case_27 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_27 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "dollar"
  Curry_Prelude.C_False -> d_C__case_26 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '%'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_27 x1 l cd cs)
    (d_C__case_27 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_27 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_27 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_27"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_27" (showCons x2))

d_C__case_26 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_26 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "percent"
  Curry_Prelude.C_False -> d_C__case_25 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '^'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_26 x1 l cd cs)
    (d_C__case_26 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_26 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_26 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_26"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_26" (showCons x2))

d_C__case_25 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_25 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "caret"
  Curry_Prelude.C_False -> d_C__case_24 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '&'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_25 x1 l cd cs)
    (d_C__case_25 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_25 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_25 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_25"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_25" (showCons x2))

d_C__case_24 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_24 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "ampersand"
  Curry_Prelude.C_False -> d_C__case_23 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '*'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_24 x1 l cd cs)
    (d_C__case_24 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_24 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_24 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_24"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_24" (showCons x2))

d_C__case_23 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_23 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "star"
  Curry_Prelude.C_False -> d_C__case_22 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '+'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_23 x1 l cd cs)
    (d_C__case_23 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_23 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_23 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_23"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_23" (showCons x2))

d_C__case_22 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_22 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "plus"
  Curry_Prelude.C_False -> d_C__case_21 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '-'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_22 x1 l cd cs)
    (d_C__case_22 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_22 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_22 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_22"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_22" (showCons x2))

d_C__case_21 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_21 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "minus"
  Curry_Prelude.C_False -> d_C__case_20 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '='#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_21 x1 l cd cs)
    (d_C__case_21 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_21 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_21 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_21"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_21" (showCons x2))

d_C__case_20 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_20 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "eq"
  Curry_Prelude.C_False -> d_C__case_19 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '<'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_20 x1 l cd cs)
    (d_C__case_20 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_20 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_20 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_20"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_20" (showCons x2))

d_C__case_19 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_19 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "lt"
  Curry_Prelude.C_False -> d_C__case_18 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '>'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_19 x1 l cd cs)
    (d_C__case_19 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_19 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_19 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_19"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_19" (showCons x2))

d_C__case_18 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_18 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "gt"
  Curry_Prelude.C_False -> d_C__case_17 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '?'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_18 x1 l cd cs)
    (d_C__case_18 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_18 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_18 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_18"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_18" (showCons x2))

d_C__case_17 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_17 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "qmark"
  Curry_Prelude.C_False -> d_C__case_16 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '.'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_17 x1 l cd cs)
    (d_C__case_17 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_17 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_17 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_17"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_17" (showCons x2))

d_C__case_16 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_16 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "dot"
  Curry_Prelude.C_False -> d_C__case_15 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '/'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_16 x1 l cd cs)
    (d_C__case_16 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_16 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_16 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_16"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_16" (showCons x2))

d_C__case_15 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_15 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "slash"
  Curry_Prelude.C_False -> d_C__case_14 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '|'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_15 x1 l cd cs)
    (d_C__case_15 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_15 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_15 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_15"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_15" (showCons x2))

d_C__case_14 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_14 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "bar"
  Curry_Prelude.C_False -> d_C__case_13 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '\\'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_14 x1 l cd cs)
    (d_C__case_14 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_14 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_14 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_14"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_14" (showCons x2))

d_C__case_13 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_13 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "backslash"
  Curry_Prelude.C_False -> d_C__case_12 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char ':'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_13 x1 l cd cs)
    (d_C__case_13 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_13 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_13 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_13"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_13" (showCons x2))

d_C__case_12 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_12 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "colon"
  Curry_Prelude.C_False -> d_C__case_11 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '('#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_12 x1 l cd cs)
    (d_C__case_12 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_12 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_12 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_12"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_12" (showCons x2))

d_C__case_11 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_11 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "oparen"
  Curry_Prelude.C_False -> d_C__case_10 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char ')'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_11 x1 l cd cs)
    (d_C__case_11 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_11 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_11 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_11"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_11" (showCons x2))

d_C__case_10 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_10 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "cparen"
  Curry_Prelude.C_False -> d_C__case_9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '['#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_10 x1 l cd cs)
    (d_C__case_10 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_10 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_10 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_10"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_10" (showCons x2))

d_C__case_9 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_9 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "obracket"
  Curry_Prelude.C_False -> d_C__case_8 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char ']'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_9 x1 l cd cs)
    (d_C__case_9 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_9 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_9 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_9"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_9" (showCons x2))

d_C__case_8 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_8 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "cbracket"
  Curry_Prelude.C_False -> d_C__case_7 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char ','#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x1 l cd cs)
    (d_C__case_8 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_8 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_8"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_8" (showCons x2))

d_C__case_7 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_7 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "comma"
  Curry_Prelude.C_False -> d_C__case_6 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '\''#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x1 l cd cs)
    (d_C__case_7 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_7 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_7"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_7" (showCons x2))

d_C__case_6 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_6 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "tick"
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_error
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "unexpected symbol: ") (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash
    cd cs) x1 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x1 l cd cs)
    (d_C__case_6 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_6"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Names._case_6" (showCons x2))

d_C__case_5 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_5 x2 x3 x1 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "replaceNonIdChars: empty identifier") cd cs
  Curry_Prelude.OP_Cons x5 x6 -> d_C__case_4 x4 x2 x3 x5 x1 x6 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_5 x2 x3 x1 l cd
    cs) (d_C__case_5 x2 x3 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_5 x2
    x3 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_5 x2 x3
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Names._case_5"
    [show x2, show x3, show x1, show x4] info)
  _ -> failCons cd (consFail "Names._case_5" (showCons x4))

d_C__case_4 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_4 x4 x2 x3 x5 x1 x6 cd cs = case x6 of
  Curry_Prelude.OP_List -> d_C__case_3 x3 x5 x2 x1 (Curry_Prelude.d_C_isAlphaNum
    (Curry_Prelude.d_C_head x3 cd cs) cd cs) cd cs
  Curry_Prelude.OP_Cons x7 x8 -> Curry_Prelude.d_OP_plus_plus x2
    (Data.Curry_List.d_C_intercalate (Curry_Prelude.toCurryString "_") x4 cd cs)
    cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_4 x4 x2 x3 x5 x1
    l cd cs) (d_C__case_4 x4 x2 x3 x5 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_4 x4
    x2 x3 x5 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_4 x4 x2
    x3 x5 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Names._case_4"
    [show x4, show x2, show x3, show x5, show x1, show x6] info)
  _ -> failCons cd (consFail "Names._case_4" (showCons x6))

d_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_3 x3 x5 x2 x1 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus x1 x5 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_plus_plus x2 x5 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x3 x5 x2 x1 l
    cd cs) (d_C__case_3 x3 x5 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x3 x5
    x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x3 x5 x2
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Names._case_3"
    [show x3, show x5, show x2, show x1, show x6] info)
  _ -> failCons cd (consFail "Names._case_3" (showCons x6))

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> (t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0) -> (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
d_C__case_2 x5 x2 x1 x6 cd cs = case x6 of
  Curry_Prelude.OP_List -> d_C__case_1 x5 cd cs
  Curry_Prelude.OP_Cons x9 x10 -> d_C__case_0 x10 x2 x1 x9 x5 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_2 x5 x2 x1 l cd
    cs) (d_C__case_2 x5 x2 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_2 x5
    x2 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_2 x5 x2
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Names._case_2"
    [show x5, show x2, show x1, show x6] info)
  _ -> failCons cd (consFail "Names._case_2" (showCons x6))

nd_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Func t0 (Curry_Prelude.OP_List t0) -> Func t0 Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
nd_C__case_2 x5 x2 x1 x6 s cd cs = case x6 of
  Curry_Prelude.OP_List -> d_C__case_1 x5 cd cs
  Curry_Prelude.OP_Cons x9 x10 -> let s0 = s
    in s0 `seq` nd_C__case_0 x10 x2 x1 x9 x5 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_2 x5 x2 x1 l s
    cd cs) (nd_C__case_2 x5 x2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_2 x5
    x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_2 x5 x2
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Names._case_2"
    [show x5, show x2, show x1, show x6] info)
  _ -> failCons cd (consFail "Names._case_2" (showCons x6))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> (t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0) -> (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> t0 -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
d_C__case_0 x10 x2 x1 x9 x5 cd cs = case x5 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply x2 x9
    cd cs) (d_C_separateAndReplace x1 x2 x10 cd cs)
  Curry_Prelude.OP_Cons x11 x12 -> Curry_Prelude.OP_Cons x5
    (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply x2 x9 cd cs)
    (d_C_separateAndReplace x1 x2 x10 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_0 x10 x2 x1 x9 l
    cd cs) (d_C__case_0 x10 x2 x1 x9 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_0 x10
    x2 x1 x9 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_0 x10 x2
    x1 x9 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Names._case_0"
    [show x10, show x2, show x1, show x9, show x5] info)
  _ -> failCons cd (consFail "Names._case_0" (showCons x5))

nd_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Func t0 (Curry_Prelude.OP_List t0) -> Func t0 Curry_Prelude.C_Bool -> t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
nd_C__case_0 x10 x2 x1 x9 x5 s cd cs = case x5 of
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.OP_Cons (Curry_Prelude.nd_C_apply x2 x9
    s0 cd cs) (nd_C_separateAndReplace x1 x2 x10 s1 cd cs)))
  Curry_Prelude.OP_Cons x11 x12 -> let s2 = s
    in s2 `seq` Curry_Prelude.OP_Cons x5 (let s0 = leftSupply s2
                                              s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.OP_Cons (Curry_Prelude.nd_C_apply x2 x9
    s0 cd cs) (nd_C_separateAndReplace x1 x2 x10 s1 cd cs)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_0 x10 x2 x1 x9
    l s cd cs) (nd_C__case_0 x10 x2 x1 x9 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_0 x10
    x2 x1 x9 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_0 x10 x2
    x1 x9 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Names._case_0"
    [show x10, show x2, show x1, show x9, show x5] info)
  _ -> failCons cd (consFail "Names._case_0" (showCons x5))

d_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
d_C__case_1 x5 cd cs = case x5 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x7 x8 -> Curry_Prelude.OP_Cons x5 Curry_Prelude.OP_List
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_1 l cd cs)
    (d_C__case_1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_1 z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Names._case_1"
    [show x5] info)
  _ -> failCons cd (consFail "Names._case_1" (showCons x5))

