{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_Overlapping ( d_C_isOverlappingFunction, d_C_orInExpr ) where

import Basics
import qualified FlatCurry.Curry_Types
import qualified Curry_Prelude


d_C_isOverlappingFunction :: FlatCurry.Curry_Types.C_FuncDecl -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C_isOverlappingFunction x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Func x2 x3 x4 x5 x6 -> d_C__case_0 x6 cd cs
  FlatCurry.Curry_Types.Choice_C_FuncDecl d i l r -> narrow d i
    (d_C_isOverlappingFunction l cd cs) (d_C_isOverlappingFunction r cd cs)
  FlatCurry.Curry_Types.Choices_C_FuncDecl d i xs -> narrows cs d i (\z ->
    d_C_isOverlappingFunction z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_FuncDecl d c e -> guardCons d c ((\x ->
    d_C_isOverlappingFunction e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_FuncDecl d info -> failCons d (traceFail
    "Overlapping.isOverlappingFunction" [show x1] info)
  _ -> failCons cd (consFail "Overlapping.isOverlappingFunction" (showCons x1))

d_C_orInExpr :: FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_orInExpr x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Var x2 -> Curry_Prelude.C_False
  FlatCurry.Curry_Types.C_Lit x3 -> Curry_Prelude.C_False
  FlatCurry.Curry_Types.C_Comb x4 x5 x6 -> Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x5 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString "?")) cd cs) (Curry_Prelude.d_C_foldr (acceptCs
    id Curry_Prelude.d_OP_bar_bar) Curry_Prelude.C_False (Curry_Prelude.d_C_map
    d_C_orInExpr x6 cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_Free x7 x8 -> d_C_orInExpr x8 cd cs
  FlatCurry.Curry_Types.C_Let x9 x10 -> Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_any d_C_orInExpr cd cs)
    (Curry_Prelude.d_C_map Curry_Prelude.d_C_snd x9 cd cs) cd cs) (d_C_orInExpr
    x10 cd cs) cd cs
  FlatCurry.Curry_Types.C_Or x11 x12 -> Curry_Prelude.C_True
  FlatCurry.Curry_Types.C_Case x13 x14 x15 -> Curry_Prelude.d_OP_bar_bar
    (d_C_orInExpr x14 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_any
    d_OP_orInExpr_dot_orInBranch_dot_35 cd cs) x15 cd cs) cd cs
  FlatCurry.Curry_Types.C_Typed x16 x17 -> Curry_Prelude.d_C_failed cd cs
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (d_C_orInExpr l cd
    cs) (d_C_orInExpr r cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    d_C_orInExpr z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x -> d_C_orInExpr
    e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "Overlapping.orInExpr" [show x1] info)
  _ -> failCons cd (consFail "Overlapping.orInExpr" (showCons x1))

d_OP_orInExpr_dot_orInBranch_dot_35 :: FlatCurry.Curry_Types.C_BranchExpr
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_orInExpr_dot_orInBranch_dot_35 x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Branch x2 x3 -> d_C_orInExpr x3 cd cs
  FlatCurry.Curry_Types.Choice_C_BranchExpr d i l r -> narrow d i
    (d_OP_orInExpr_dot_orInBranch_dot_35 l cd cs)
    (d_OP_orInExpr_dot_orInBranch_dot_35 r cd cs)
  FlatCurry.Curry_Types.Choices_C_BranchExpr d i xs -> narrows cs d i (\z ->
    d_OP_orInExpr_dot_orInBranch_dot_35 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_BranchExpr d c e -> guardCons d c ((\x ->
    d_OP_orInExpr_dot_orInBranch_dot_35 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_BranchExpr d info -> failCons d (traceFail
    "Overlapping.orInExpr.orInBranch.35" [show x1] info)
  _ -> failCons cd (consFail "Overlapping.orInExpr.orInBranch.35" (showCons x1))

d_C__case_0 :: FlatCurry.Curry_Types.C_Rule -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_0 x6 cd cs = case x6 of
  FlatCurry.Curry_Types.C_Rule x7 x8 -> d_C_orInExpr x8 cd cs
  FlatCurry.Curry_Types.C_External x9 -> Curry_Prelude.C_False
  FlatCurry.Curry_Types.Choice_C_Rule d i l r -> narrow d i (d_C__case_0 l cd
    cs) (d_C__case_0 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Rule d i xs -> narrows cs d i (\z ->
    d_C__case_0 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Rule d c e -> guardCons d c ((\x -> d_C__case_0
    e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Rule d info -> failCons d (traceFail
    "Overlapping._case_0" [show x6] info)
  _ -> failCons cd (consFail "Overlapping._case_0" (showCons x6))

