{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif
{-# LANGUAGE CPP, MultiParamTypeClasses #-}

module Debug.Curry_Profile
  ( C_ProcessInfo (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Debug_dot_Profile_dot_ProcessInfo_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Debug_dot_Profile_dot_ProcessInfo_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Debug_dot_Profile_dot_ProcessInfo_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
  , d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
  , d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
  , d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
  , d_C_showMemInfo
  , d_C_printMemInfo
  , d_C_profileTime
  , nd_C_profileTime
  , d_C_getTimings
  , nd_C_getTimings
  , d_C_getTimingsNF
  , d_C_getElapsedTimeNF
  , nd_C_getElapsedTimeNF
  , d_C_profileTimeNF
  , d_C_profileSpace
  , nd_C_profileSpace
  , d_C_profileSpaceNF
  , d_C_getProcessInfos
  , d_C_garbageCollectorOff
  , d_C_garbageCollectorOn
  , d_C_garbageCollect )
  where

import Basics
import qualified Data.Curry_List
import qualified Curry_Prelude

import System.CPUTime
import System.Mem (performGC)

#if __GLASGOW_HASKELL__ > 702
import GHC.Stats
#endif

data C_ProcessInfo
  = C_RunTime
  | C_ElapsedTime
  | C_Memory
  | C_Code
  | C_Stack
  | C_Heap
  | C_Choices
  | C_GarbageCollections
  | Choice_C_ProcessInfo Cover ID C_ProcessInfo C_ProcessInfo
  | Choices_C_ProcessInfo Cover ID [C_ProcessInfo]
  | Fail_C_ProcessInfo Cover FailInfo
  | Guard_C_ProcessInfo Cover Constraints C_ProcessInfo

instance Show C_ProcessInfo where
  showsPrec d (Choice_C_ProcessInfo cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_ProcessInfo cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_ProcessInfo cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_ProcessInfo cd info) = showChar '!'
  showsPrec _ C_RunTime = showString "RunTime"
  showsPrec _ C_ElapsedTime = showString "ElapsedTime"
  showsPrec _ C_Memory = showString "Memory"
  showsPrec _ C_Code = showString "Code"
  showsPrec _ C_Stack = showString "Stack"
  showsPrec _ C_Heap = showString "Heap"
  showsPrec _ C_Choices = showString "Choices"
  showsPrec _ C_GarbageCollections = showString "GarbageCollections"

instance Read C_ProcessInfo where
  readsPrec _ s = readParen False (\r -> [(C_RunTime, r0) | (_, r0) <-
    readQualified "Debug.Profile" "RunTime" r]) s ++ (readParen False (\r ->
    [(C_ElapsedTime, r0) | (_, r0) <- readQualified "Debug.Profile"
    "ElapsedTime" r]) s ++ (readParen False (\r -> [(C_Memory, r0) | (_, r0) <-
    readQualified "Debug.Profile" "Memory" r]) s ++ (readParen False (\r ->
    [(C_Code, r0) | (_, r0) <- readQualified "Debug.Profile" "Code" r]) s ++
    (readParen False (\r -> [(C_Stack, r0) | (_, r0) <- readQualified
    "Debug.Profile" "Stack" r]) s ++ (readParen False (\r -> [(C_Heap, r0) | (_
    , r0) <- readQualified "Debug.Profile" "Heap" r]) s ++ (readParen False
    (\r -> [(C_Choices, r0) | (_, r0) <- readQualified "Debug.Profile" "Choices"
    r]) s ++ readParen False (\r -> [(C_GarbageCollections, r0) | (_, r0) <-
    readQualified "Debug.Profile" "GarbageCollections" r]) s))))))

instance NonDet C_ProcessInfo where
  choiceCons = Choice_C_ProcessInfo
  choicesCons = Choices_C_ProcessInfo
  failCons = Fail_C_ProcessInfo
  guardCons = Guard_C_ProcessInfo
  try (Choice_C_ProcessInfo cd i x y) = tryChoice cd i x y
  try (Choices_C_ProcessInfo cd i xs) = tryChoices cd i xs
  try (Fail_C_ProcessInfo cd info) = Fail cd info
  try (Guard_C_ProcessInfo cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_ProcessInfo cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_ProcessInfo cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_ProcessInfo cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_ProcessInfo cd i _) = error
    ("Debug.Profile.ProcessInfo.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_ProcessInfo cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_ProcessInfo cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_ProcessInfo where
  generate s c = Choices_C_ProcessInfo c (freeID [0, 0, 0, 0, 0, 0, 0, 0] s)
    [C_RunTime, C_ElapsedTime, C_Memory, C_Code, C_Stack, C_Heap, C_Choices
    , C_GarbageCollections]

instance NormalForm C_ProcessInfo where
  ($!!) cont C_RunTime d cs = cont C_RunTime d cs
  ($!!) cont C_ElapsedTime d cs = cont C_ElapsedTime d cs
  ($!!) cont C_Memory d cs = cont C_Memory d cs
  ($!!) cont C_Code d cs = cont C_Code d cs
  ($!!) cont C_Stack d cs = cont C_Stack d cs
  ($!!) cont C_Heap d cs = cont C_Heap d cs
  ($!!) cont C_Choices d cs = cont C_Choices d cs
  ($!!) cont C_GarbageCollections d cs = cont C_GarbageCollections d cs
  ($!!) cont (Choice_C_ProcessInfo cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_ProcessInfo cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_ProcessInfo cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_ProcessInfo cd info) _ _ = failCons cd info
  ($##) cont C_RunTime d cs = cont C_RunTime d cs
  ($##) cont C_ElapsedTime d cs = cont C_ElapsedTime d cs
  ($##) cont C_Memory d cs = cont C_Memory d cs
  ($##) cont C_Code d cs = cont C_Code d cs
  ($##) cont C_Stack d cs = cont C_Stack d cs
  ($##) cont C_Heap d cs = cont C_Heap d cs
  ($##) cont C_Choices d cs = cont C_Choices d cs
  ($##) cont C_GarbageCollections d cs = cont C_GarbageCollections d cs
  ($##) cont (Choice_C_ProcessInfo cd i x y) d cs = gnfChoice cont cd i x y cd
    cs
  ($##) cont (Choices_C_ProcessInfo cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_ProcessInfo cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_ProcessInfo cd info) _ _ = failCons cd info
  showCons C_RunTime = "Debug.Profile.RunTime"
  showCons C_ElapsedTime = "Debug.Profile.ElapsedTime"
  showCons C_Memory = "Debug.Profile.Memory"
  showCons C_Code = "Debug.Profile.Code"
  showCons C_Stack = "Debug.Profile.Stack"
  showCons C_Heap = "Debug.Profile.Heap"
  showCons C_Choices = "Debug.Profile.Choices"
  showCons C_GarbageCollections = "Debug.Profile.GarbageCollections"
  showCons x = error ("Debug.Profile.ProcessInfo.showCons: no constructor: " ++
    show x)
  searchNF _ cont C_RunTime = cont C_RunTime
  searchNF _ cont C_ElapsedTime = cont C_ElapsedTime
  searchNF _ cont C_Memory = cont C_Memory
  searchNF _ cont C_Code = cont C_Code
  searchNF _ cont C_Stack = cont C_Stack
  searchNF _ cont C_Heap = cont C_Heap
  searchNF _ cont C_Choices = cont C_Choices
  searchNF _ cont C_GarbageCollections = cont C_GarbageCollections
  searchNF _ _ x = error
    ("Debug.Profile.ProcessInfo.searchNF: no constructor: " ++ show x)

instance Unifiable C_ProcessInfo where
  (=.=) C_RunTime C_RunTime d cs = C_True
  (=.=) C_ElapsedTime C_ElapsedTime d cs = C_True
  (=.=) C_Memory C_Memory d cs = C_True
  (=.=) C_Code C_Code d cs = C_True
  (=.=) C_Stack C_Stack d cs = C_True
  (=.=) C_Heap C_Heap d cs = C_True
  (=.=) C_Choices C_Choices d cs = C_True
  (=.=) C_GarbageCollections C_GarbageCollections d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_RunTime C_RunTime d cs = C_True
  (=.<=) C_ElapsedTime C_ElapsedTime d cs = C_True
  (=.<=) C_Memory C_Memory d cs = C_True
  (=.<=) C_Code C_Code d cs = C_True
  (=.<=) C_Stack C_Stack d cs = C_True
  (=.<=) C_Heap C_Heap d cs = C_True
  (=.<=) C_Choices C_Choices d cs = C_True
  (=.<=) C_GarbageCollections C_GarbageCollections d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_RunTime = (i :=: ChooseN 0 0) : concat []
  bind cd i C_ElapsedTime = (i :=: ChooseN 1 0) : concat []
  bind cd i C_Memory = (i :=: ChooseN 2 0) : concat []
  bind cd i C_Code = (i :=: ChooseN 3 0) : concat []
  bind cd i C_Stack = (i :=: ChooseN 4 0) : concat []
  bind cd i C_Heap = (i :=: ChooseN 5 0) : concat []
  bind cd i C_Choices = (i :=: ChooseN 6 0) : concat []
  bind cd i C_GarbageCollections = (i :=: ChooseN 7 0) : concat []
  bind d i (Choice_C_ProcessInfo cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_ProcessInfo cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j
    xs
  bind d i (Choices_C_ProcessInfo cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_ProcessInfo cd i _) = error
    ("Debug.Profile.ProcessInfo.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_ProcessInfo cd info) = [Unsolvable info]
  bind d i (Guard_C_ProcessInfo cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_RunTime = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_ElapsedTime = (i :=: ChooseN 1 0) : []
  lazyBind cd i C_Memory = (i :=: ChooseN 2 0) : []
  lazyBind cd i C_Code = (i :=: ChooseN 3 0) : []
  lazyBind cd i C_Stack = (i :=: ChooseN 4 0) : []
  lazyBind cd i C_Heap = (i :=: ChooseN 5 0) : []
  lazyBind cd i C_Choices = (i :=: ChooseN 6 0) : []
  lazyBind cd i C_GarbageCollections = (i :=: ChooseN 7 0) : []
  lazyBind d i (Choice_C_ProcessInfo cd j x y) = [ConstraintChoice cd j
    (lazyBind d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_ProcessInfo cd j@(FreeID _ _) xs) = lazyBindOrNarrow d
    i cd j xs
  lazyBind d i (Choices_C_ProcessInfo cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_ProcessInfo cd i _) = error
    ("Debug.Profile.ProcessInfo.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_ProcessInfo cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_ProcessInfo cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_ProcessInfo where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Debug_dot_Profile_dot_ProcessInfo_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_ProcessInfo
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Debug_dot_Profile_dot_ProcessInfo_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Debug_dot_Profile_dot_ProcessInfo_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Debug.Profile._inst#Prelude.Data#Debug.Profile.ProcessInfo#" [show x1]
    info)
  _ -> failCons cd (consFail
    "Debug.Profile._inst#Prelude.Data#Debug.Profile.ProcessInfo#" (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Debug_dot_Profile_dot_ProcessInfo_hash :: C_ProcessInfo
  -> C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Debug_dot_Profile_dot_ProcessInfo_hash x1 x2 cd cs =
  case x1 of
  C_RunTime -> d_C__case_16 x2 cd cs
  C_ElapsedTime -> d_C__case_15 x2 cd cs
  C_Memory -> d_C__case_14 x2 cd cs
  C_Code -> d_C__case_13 x2 cd cs
  C_Stack -> d_C__case_12 x2 cd cs
  C_Heap -> d_C__case_11 x2 cd cs
  C_Choices -> d_C__case_10 x2 cd cs
  C_GarbageCollections -> d_C__case_9 x2 cd cs
  Choice_C_ProcessInfo d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    r x2 cd cs)
  Choices_C_ProcessInfo d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    z x2 cd cs) xs
  Guard_C_ProcessInfo d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_ProcessInfo d info -> failCons d (traceFail
    "Debug.Profile._impl#===#Prelude.Data#Debug.Profile.ProcessInfo#" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "Debug.Profile._impl#===#Prelude.Data#Debug.Profile.ProcessInfo#" (showCons
    x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Debug_dot_Profile_dot_ProcessInfo_hash :: IDSupply
  -> Cover -> ConstStore -> C_ProcessInfo
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Debug_dot_Profile_dot_ProcessInfo_hash s cd cs =
  let s12 = s
  in s12 `seq` (let s11 = leftSupply s12
                    s10 = rightSupply s12
  in s11 `seq` (s10 `seq` choice (let s9 = leftSupply s10
                                      s8 = rightSupply s10
  in s9 `seq` (s8 `seq` choice (let s7 = leftSupply s8
                                    s6 = rightSupply s8
  in s7 `seq` (s6 `seq` choice (let s5 = leftSupply s6
                                    s4 = rightSupply s6
  in s5 `seq` (s4 `seq` choice (let s3 = leftSupply s4
                                    s2 = rightSupply s4
  in s3 `seq` (s2 `seq` choice (let s1 = leftSupply s2
                                    s0 = rightSupply s2
  in s1 `seq` (s0 `seq` choice (choice C_RunTime C_ElapsedTime s0 cd cs)
  C_Memory s1 cd cs)) C_Code s3 cd cs)) C_Stack s5 cd cs)) C_Heap s7 cd cs))
  C_Choices s9 cd cs)) C_GarbageCollections s11 cd cs))

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_ProcessInfo
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Debug.Profile._inst#Prelude.Eq#Debug.Profile.ProcessInfo#" [show x1] info)
  _ -> failCons cd (consFail
    "Debug.Profile._inst#Prelude.Eq#Debug.Profile.ProcessInfo#" (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_ProcessInfo
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Debug.Profile._inst#Prelude.Eq#Debug.Profile.ProcessInfo#" [show x1] info)
  _ -> failCons cd (consFail
    "Debug.Profile._inst#Prelude.Eq#Debug.Profile.ProcessInfo#" (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash :: C_ProcessInfo
  -> C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash x1 x2 cd cs =
  case x1 of
  C_RunTime -> d_C__case_8 x2 cd cs
  C_ElapsedTime -> d_C__case_7 x2 cd cs
  C_Memory -> d_C__case_6 x2 cd cs
  C_Code -> d_C__case_5 x2 cd cs
  C_Stack -> d_C__case_4 x2 cd cs
  C_Heap -> d_C__case_3 x2 cd cs
  C_Choices -> d_C__case_2 x2 cd cs
  C_GarbageCollections -> d_C__case_1 x2 cd cs
  Choice_C_ProcessInfo d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    r x2 cd cs)
  Choices_C_ProcessInfo d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    z x2 cd cs) xs
  Guard_C_ProcessInfo d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_ProcessInfo d info -> failCons d (traceFail
    "Debug.Profile._impl#==#Prelude.Eq#Debug.Profile.ProcessInfo#" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "Debug.Profile._impl#==#Prelude.Eq#Debug.Profile.ProcessInfo#" (showCons
    x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash :: Cover
  -> ConstStore -> C_ProcessInfo -> Cover -> ConstStore -> C_ProcessInfo
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash)

d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show C_ProcessInfo
d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Show
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    cd cs) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Debug.Profile._inst#Prelude.Show#Debug.Profile.ProcessInfo#" [show x1]
    info)
  _ -> failCons cd (consFail
    "Debug.Profile._inst#Prelude.Show#Debug.Profile.ProcessInfo#" (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  C_ProcessInfo
nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Show (wrapDX id
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    cd cs)) (wrapDX (wrapDX (wrapDX id)) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Debug.Profile._inst#Prelude.Show#Debug.Profile.ProcessInfo#" [show x1]
    info)
  _ -> failCons cd (consFail
    "Debug.Profile._inst#Prelude.Show#Debug.Profile.ProcessInfo#" (showCons x1))

d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash :: Cover
  -> ConstStore -> C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash

d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash :: Curry_Prelude.C_Int
  -> C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash x1 x2 cd cs =
  case x2 of
  C_RunTime -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "RunTime")
  C_ElapsedTime -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "ElapsedTime")
  C_Memory -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "Memory")
  C_Code -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "Code")
  C_Stack -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "Stack")
  C_Heap -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "Heap")
  C_Choices -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "Choices")
  C_GarbageCollections -> Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString "GarbageCollections")
  Choice_C_ProcessInfo d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    x1 l cd cs)
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    x1 r cd cs)
  Choices_C_ProcessInfo d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    x1 z cd cs) xs
  Guard_C_ProcessInfo d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
    x1 e cd x) $! addCs c cs)
  Fail_C_ProcessInfo d info -> failCons d (traceFail
    "Debug.Profile._impl#showsPrec#Prelude.Show#Debug.Profile.ProcessInfo#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Debug.Profile._impl#showsPrec#Prelude.Show#Debug.Profile.ProcessInfo#"
    (showCons x2))

d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List C_ProcessInfo -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Debug_dot_Profile_dot_ProcessInfo_hash
  cd cs

d_C_showMemInfo :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_ProcessInfo
  Curry_Prelude.C_Int) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_showMemInfo x1 cd cs = Curry_Prelude.d_OP_dollar
  (Data.Curry_List.d_C_intercalate (Curry_Prelude.toCurryString ", "))
  (Curry_Prelude.d_OP_plus_plus (d_OP_showMemInfo_dot_formatItem_dot_2 x1
  C_Memory (Curry_Prelude.toCurryString "Memory: ") cd cs)
  (Curry_Prelude.d_OP_plus_plus (d_OP_showMemInfo_dot_formatItem_dot_2 x1 C_Code
  (Curry_Prelude.toCurryString "Code: ") cd cs) (Curry_Prelude.d_OP_plus_plus
  (d_OP_showMemInfo_dot_formatItem_dot_2 x1 C_Stack (Curry_Prelude.toCurryString
  "Stack: ") cd cs) (Curry_Prelude.d_OP_plus_plus
  (d_OP_showMemInfo_dot_formatItem_dot_2 x1 C_Choices
  (Curry_Prelude.toCurryString "Choices: ") cd cs)
  (d_OP_showMemInfo_dot_formatItem_dot_2 x1 C_Heap (Curry_Prelude.toCurryString
  "Heap: ") cd cs) cd cs) cd cs) cd cs) cd cs) cd cs

d_OP_showMemInfo_dot_showBytes_dot_2 :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Integral t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showMemInfo_dot_showBytes_dot_2 x1 x2 x3 cd cs = d_C__case_0 x1 x3 x2
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_lt
  (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Ord_hash_0_hash
  (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
  x1 cd cs) cd cs) cd cs) x3 cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_fromInt
  (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
  (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
  x1 cd cs) cd cs) cd cs) (Curry_Prelude.C_Int (10000)) cd cs) cd cs) cd cs

nd_OP_showMemInfo_dot_showBytes_dot_2 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Integral
  t0) -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_OP_showMemInfo_dot_showBytes_dot_2 x1 x2 x3 s cd cs = let s18 = s
  in s18 `seq` (let s17 = leftSupply s18
                    s15 = rightSupply s18
  in s17 `seq` (s15 `seq` nd_C__case_0 x1 x3 x2 (let s14 = leftSupply s15
                                                     s16 = rightSupply s15
                                                     s6 = leftSupply s16
                                                     s13 = rightSupply s16
  in s14 `seq` (s16 `seq` (s6 `seq` (s13 `seq` Curry_Prelude.nd_C_apply
  (let s5 = leftSupply s6
       s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                      s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_lt (let s1 = leftSupply s2
                                                    s0 = rightSupply s2
  in s1 `seq` (s0 `seq`
  Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Ord_hash_0_hash
  (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
  x1 s0 cd cs) s1 cd cs)) s3 cd cs)) x3 s5 cd cs)) (let s12 = leftSupply s13
                                                        s11 = rightSupply s13
  in s12 `seq` (s11 `seq` Curry_Prelude.nd_C_apply (let s10 = leftSupply s11
                                                        s9 = rightSupply s11
  in s10 `seq` (s9 `seq` Curry_Prelude.nd_C_fromInt (let s8 = leftSupply s9
                                                         s7 = rightSupply s9
  in s8 `seq` (s7 `seq`
  Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
  (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
  x1 s7 cd cs) s8 cd cs)) s10 cd cs)) (Curry_Prelude.C_Int (10000)) s12 cd cs))
  s14 cd cs)))) s17 cd cs))

d_OP_showMemInfo_dot_formatItem_dot_2 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_ProcessInfo Curry_Prelude.C_Int) -> C_ProcessInfo
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_showMemInfo_dot_formatItem_dot_2 x1 x2 x3 cd cs = Curry_Prelude.d_C_maybe
  Curry_Prelude.OP_List
  (d_OP_showMemInfo_dot_formatItem_dot_2_dot_uscore_hash_lambda1 x3)
  (Curry_Prelude.d_C_lookup
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
  x2 x1 cd cs) cd cs

d_OP_showMemInfo_dot_formatItem_dot_2_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_showMemInfo_dot_formatItem_dot_2_dot_uscore_hash_lambda1 x1 x2 cd cs =
  Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x1
  (d_OP_showMemInfo_dot_showBytes_dot_2
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  x2 cd cs) cd cs) Curry_Prelude.OP_List

d_C_printMemInfo :: Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_C_printMemInfo cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_getProcessInfos cd cs) cd cs) (Curry_Prelude.d_OP_dot
  Curry_Prelude.d_C_putStrLn d_C_showMemInfo cd cs) cd cs

d_C_profileTime :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_IO t0
  -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
d_C_profileTime x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_getTimings x1 cd cs) cd cs)
  d_OP_profileTime_dot_uscore_hash_lambda3 cd cs

nd_C_profileTime :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_IO
  t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
nd_C_profileTime x1 s cd cs = let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s3 = rightSupply s6
  in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                      s4 = rightSupply s3
                                                      s0 = leftSupply s4
                                                      s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (nd_C_getTimings x1 s1 cd cs) s2 cd cs)))) (wrapDX id
  d_OP_profileTime_dot_uscore_hash_lambda3) s5 cd cs))

d_OP_profileTime_dot_uscore_hash_lambda3 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple4 t0 Curry_Prelude.C_Int Curry_Prelude.C_Int
  Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
d_OP_profileTime_dot_uscore_hash_lambda3 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "Run time:            ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x3 cd cs) (Curry_Prelude.toCurryString " msec.") cd cs) cd cs) cd cs)
    cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "Elapsed time:        ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x4 cd cs) (Curry_Prelude.toCurryString " msec.") cd cs) cd cs) cd cs)
    cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "Garbage collections: ") (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x5 cd cs) cd cs) cd cs) cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) x2 cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_profileTime_dot_uscore_hash_lambda3 l cd cs)
    (d_OP_profileTime_dot_uscore_hash_lambda3 r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_profileTime_dot_uscore_hash_lambda3 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c ((\x ->
    d_OP_profileTime_dot_uscore_hash_lambda3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "Debug.Profile.profileTime._#lambda3" [show x1] info)
  _ -> failCons cd (consFail "Debug.Profile.profileTime._#lambda3" (showCons
    x1))

d_C_getTimings :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_IO t0
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple4 t0
  Curry_Prelude.C_Int Curry_Prelude.C_Int Curry_Prelude.C_Int)
d_C_getTimings x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_garbageCollect cd cs) cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_getProcessInfos cd cs) cd cs)
  (d_OP_getTimings_dot_uscore_hash_lambda8 x1) cd cs) cd cs

nd_C_getTimings :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_IO t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_Tuple4 t0 Curry_Prelude.C_Int Curry_Prelude.C_Int
  Curry_Prelude.C_Int)
nd_C_getTimings x1 s cd cs = let s9 = s
  in s9 `seq` (let s8 = leftSupply s9
                   s10 = rightSupply s9
                   s2 = leftSupply s10
                   s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s2 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (d_C_garbageCollect cd cs) s1 cd cs)) (let s6 = leftSupply s7
                                                       s5 = rightSupply s7
  in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                      s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s3 cd cs) (d_C_getProcessInfos cd cs) s4 cd cs)) (wrapNX id
  (nd_OP_getTimings_dot_uscore_hash_lambda8 x1)) s6 cd cs)) s8 cd cs))))

d_OP_getTimings_dot_uscore_hash_lambda8 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_IO t0 -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_ProcessInfo Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple4 t0 Curry_Prelude.C_Int
  Curry_Prelude.C_Int Curry_Prelude.C_Int)
d_OP_getTimings_dot_uscore_hash_lambda8 x1 x2 cd cs = let x3 = x2
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) x1 cd cs)
  (d_OP_getTimings_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 x3) cd cs

nd_OP_getTimings_dot_uscore_hash_lambda8 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_IO t0 -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_ProcessInfo Curry_Prelude.C_Int) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple4 t0 Curry_Prelude.C_Int
  Curry_Prelude.C_Int Curry_Prelude.C_Int)
nd_OP_getTimings_dot_uscore_hash_lambda8 x1 x2 s cd cs = let s4 = s
  in s4 `seq` (let x3 = x2
  in let s3 = leftSupply s4
         s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) x1 s1 cd cs)) (wrapDX id
  (d_OP_getTimings_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 x3)) s3 cd
  cs))

d_OP_getTimings_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_ProcessInfo
  Curry_Prelude.C_Int) -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_Tuple4 t0 Curry_Prelude.C_Int Curry_Prelude.C_Int
  Curry_Prelude.C_Int)
d_OP_getTimings_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_getProcessInfos cd cs) cd cs)
  (d_OP_getTimings_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10_dot_uscore_hash_lambda12
  x3 x1) cd cs

d_OP_getTimings_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10_dot_uscore_hash_lambda12 :: forall t0 . (Curry_Prelude.Curry
  t0) => t0 -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_ProcessInfo
  Curry_Prelude.C_Int) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_ProcessInfo Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple4 t0 Curry_Prelude.C_Int
  Curry_Prelude.C_Int Curry_Prelude.C_Int)
d_OP_getTimings_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10_dot_uscore_hash_lambda12 x1 x2 x3 cd cs =
  let x4 = x3
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.OP_Tuple4 x1 (d_C_infoDiff x2 x4 C_RunTime cd cs)
  (d_C_infoDiff x2 x4 C_ElapsedTime cd cs) (d_C_infoDiff x2 x4
  C_GarbageCollections cd cs)) cd cs

d_C_getTimingsNF :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple3
  Curry_Prelude.C_Int Curry_Prelude.C_Int Curry_Prelude.C_Int)
d_C_getTimingsNF x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_getTimings (Curry_Prelude.d_C_seq
  (Curry_Prelude.d_OP_dollar_bang_bang Curry_Prelude.d_C_id x1 cd cs)
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) Curry_Prelude.OP_Unit cd cs) cd cs) cd cs) cd cs)
  d_OP_getTimingsNF_dot_uscore_hash_lambda15 cd cs

d_OP_getTimingsNF_dot_uscore_hash_lambda15 :: Curry_Prelude.OP_Tuple4
  Curry_Prelude.OP_Unit Curry_Prelude.C_Int Curry_Prelude.C_Int
  Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_Tuple3 Curry_Prelude.C_Int Curry_Prelude.C_Int
  Curry_Prelude.C_Int)
d_OP_getTimingsNF_dot_uscore_hash_lambda15 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Curry_Prelude.OP_Tuple3 x3 x4 x5) cd cs
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_getTimingsNF_dot_uscore_hash_lambda15 l cd cs)
    (d_OP_getTimingsNF_dot_uscore_hash_lambda15 r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_getTimingsNF_dot_uscore_hash_lambda15 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c ((\x ->
    d_OP_getTimingsNF_dot_uscore_hash_lambda15 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "Debug.Profile.getTimingsNF._#lambda15" [show x1] info)
  _ -> failCons cd (consFail "Debug.Profile.getTimingsNF._#lambda15" (showCons
    x1))

d_C_getElapsedTimeNF :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_IO t0 -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_Tuple2 t0 Curry_Prelude.C_Int)
d_C_getElapsedTimeNF x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_garbageCollect cd cs) cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_getProcessInfos cd cs) cd cs)
  (d_OP_getElapsedTimeNF_dot_uscore_hash_lambda20 x1) cd cs) cd cs

nd_C_getElapsedTimeNF :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_IO t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 t0 Curry_Prelude.C_Int)
nd_C_getElapsedTimeNF x1 s cd cs = let s9 = s
  in s9 `seq` (let s8 = leftSupply s9
                   s10 = rightSupply s9
                   s2 = leftSupply s10
                   s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s2 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (d_C_garbageCollect cd cs) s1 cd cs)) (let s6 = leftSupply s7
                                                       s5 = rightSupply s7
  in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                      s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s3 cd cs) (d_C_getProcessInfos cd cs) s4 cd cs)) (wrapNX id
  (nd_OP_getElapsedTimeNF_dot_uscore_hash_lambda20 x1)) s6 cd cs)) s8 cd cs))))

d_OP_getElapsedTimeNF_dot_uscore_hash_lambda20 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_IO t0 -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_ProcessInfo Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 t0 Curry_Prelude.C_Int)
d_OP_getElapsedTimeNF_dot_uscore_hash_lambda20 x1 x2 cd cs = let x3 = x2
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) x1 cd cs) (Curry_Prelude.d_OP_dollar_bang_bang
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs)) cd cs) cd cs)
  (d_OP_getElapsedTimeNF_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22 x3)
  cd cs

nd_OP_getElapsedTimeNF_dot_uscore_hash_lambda20 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_IO t0 -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_ProcessInfo Curry_Prelude.C_Int) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 t0 Curry_Prelude.C_Int)
nd_OP_getElapsedTimeNF_dot_uscore_hash_lambda20 x1 x2 s cd cs = let s12 = s
  in s12 `seq` (let x3 = x2
  in let s11 = leftSupply s12
         s9 = rightSupply s12
  in s11 `seq` (s9 `seq` Curry_Prelude.nd_C_apply (let s8 = leftSupply s9
                                                       s10 = rightSupply s9
                                                       s0 = leftSupply s10
                                                       s6 = rightSupply s10
  in s8 `seq` (s10 `seq` (s0 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (let s5 = leftSupply s6
                 s7 = rightSupply s6
                 s3 = leftSupply s7
                 s4 = rightSupply s7
  in s5 `seq` (s7 `seq` (s3 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
  (let s2 = leftSupply s3
       s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s1 cd cs) x1 s2 cd cs)) (wrapNX id (Curry_Prelude.nd_OP_dollar_bang_bang
  (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s4 cd cs))) s5 cd cs)))) s8 cd cs)))) (wrapDX id
  (d_OP_getElapsedTimeNF_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22 x3))
  s11 cd cs))

d_OP_getElapsedTimeNF_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_ProcessInfo
  Curry_Prelude.C_Int) -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_Tuple2 t0 Curry_Prelude.C_Int)
d_OP_getElapsedTimeNF_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_getProcessInfos cd cs) cd cs)
  (d_OP_getElapsedTimeNF_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22_dot_uscore_hash_lambda24
  x3 x1) cd cs

d_OP_getElapsedTimeNF_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22_dot_uscore_hash_lambda24 :: forall t0 . (Curry_Prelude.Curry
  t0) => t0 -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_ProcessInfo
  Curry_Prelude.C_Int) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_ProcessInfo Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 t0 Curry_Prelude.C_Int)
d_OP_getElapsedTimeNF_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22_dot_uscore_hash_lambda24 x1 x2 x3 cd cs =
  let x4 = x3
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.OP_Tuple2 x1 (d_C_infoDiff x2 x4 C_ElapsedTime cd cs))
  cd cs

d_C_profileTimeNF :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_profileTimeNF x1 cd cs = d_C_profileTime (Curry_Prelude.d_C_seq
  (Curry_Prelude.d_OP_dollar_bang_bang Curry_Prelude.d_C_id x1 cd cs)
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) Curry_Prelude.OP_Unit cd cs) cd cs) cd cs

d_C_profileSpace :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_IO
  t0 -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
d_C_profileSpace x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_garbageCollect cd cs) cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_garbageCollectorOff cd cs) cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_getProcessInfos cd cs) cd cs)
  (d_OP_profileSpace_dot_uscore_hash_lambda29 x1) cd cs) cd cs) cd cs

nd_C_profileSpace :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_IO
  t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
nd_C_profileSpace x1 s cd cs = let s15 = s
  in s15 `seq` (let s14 = leftSupply s15
                    s16 = rightSupply s15
                    s2 = leftSupply s16
                    s12 = rightSupply s16
  in s14 `seq` (s16 `seq` (s2 `seq` (s12 `seq` Curry_Prelude.nd_C_apply
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (d_C_garbageCollect cd cs) s1 cd cs)) (let s11 = leftSupply s12
                                                       s13 = rightSupply s12
                                                       s5 = leftSupply s13
                                                       s10 = rightSupply s13
  in s11 `seq` (s13 `seq` (s5 `seq` (s10 `seq` Curry_Prelude.nd_C_apply
  (let s4 = leftSupply s5
       s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s3 cd cs) (d_C_garbageCollectorOff cd cs) s4 cd cs)) (let s9 = leftSupply s10
                                                            s8 = rightSupply s10
  in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (let s7 = leftSupply s8
                                                      s6 = rightSupply s8
  in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s6 cd cs) (d_C_getProcessInfos cd cs) s7 cd cs)) (wrapNX id
  (nd_OP_profileSpace_dot_uscore_hash_lambda29 x1)) s9 cd cs)) s11 cd cs)))) s14
  cd cs))))

d_OP_profileSpace_dot_uscore_hash_lambda29 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_IO t0 -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_ProcessInfo Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO t0
d_OP_profileSpace_dot_uscore_hash_lambda29 x1 x2 cd cs = let x3 = x2
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) x1 cd cs)
  (d_OP_profileSpace_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31 x3) cd cs

nd_OP_profileSpace_dot_uscore_hash_lambda29 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_IO t0 -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_ProcessInfo Curry_Prelude.C_Int) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO t0
nd_OP_profileSpace_dot_uscore_hash_lambda29 x1 x2 s cd cs = let s4 = s
  in s4 `seq` (let x3 = x2
  in let s3 = leftSupply s4
         s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) x1 s1 cd cs)) (wrapDX id
  (d_OP_profileSpace_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31 x3)) s3
  cd cs))

d_OP_profileSpace_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_ProcessInfo
  Curry_Prelude.C_Int) -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
d_OP_profileSpace_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_getProcessInfos cd cs) cd cs)
  (d_OP_profileSpace_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31_dot_uscore_hash_lambda33
  x3 x1) cd cs

d_OP_profileSpace_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31_dot_uscore_hash_lambda33 :: forall t0 . (Curry_Prelude.Curry
  t0) => t0 -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_ProcessInfo
  Curry_Prelude.C_Int) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_ProcessInfo Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO t0
d_OP_profileSpace_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31_dot_uscore_hash_lambda33 x1 x2 x3 cd cs =
  let x4 = x3
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_garbageCollectorOn cd cs) cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Run time:            ") (Curry_Prelude.d_OP_plus_plus (d_C_showInfoDiff x2 x4
  C_RunTime cd cs) (Curry_Prelude.toCurryString " msec.") cd cs) cd cs) cd cs)
  cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Elapsed time:        ") (Curry_Prelude.d_OP_plus_plus (d_C_showInfoDiff x2 x4
  C_ElapsedTime cd cs) (Curry_Prelude.toCurryString " msec.") cd cs) cd cs) cd
  cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Garbage collections: ") (d_C_showInfoDiff x2 x4 C_GarbageCollections cd cs)
  cd cs) cd cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Heap usage:          ") (Curry_Prelude.d_OP_plus_plus (d_C_showInfoDiff x2 x4
  C_Heap cd cs) (Curry_Prelude.toCurryString " bytes") cd cs) cd cs) cd cs) cd
  cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Stack usage:         ") (Curry_Prelude.d_OP_plus_plus (d_C_showInfoDiff x2 x4
  C_Stack cd cs) (Curry_Prelude.toCurryString " bytes") cd cs) cd cs) cd cs) cd
  cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) x1 cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs

d_C_profileSpaceNF :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_profileSpaceNF x1 cd cs = d_C_profileSpace (Curry_Prelude.d_C_seq
  (Curry_Prelude.d_OP_dollar_bang_bang Curry_Prelude.d_C_id x1 cd cs)
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) Curry_Prelude.OP_Unit cd cs) cd cs) cd cs

d_C_showInfoDiff :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_ProcessInfo
  Curry_Prelude.C_Int) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_ProcessInfo Curry_Prelude.C_Int) -> C_ProcessInfo -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showInfoDiff x1 x2 x3 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_maybe (Curry_Prelude.C_Int (0)) Curry_Prelude.d_C_id
  (Curry_Prelude.d_C_lookup
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
  x3 x2 cd cs) cd cs) (Curry_Prelude.d_C_maybe (Curry_Prelude.C_Int (0))
  Curry_Prelude.d_C_id (Curry_Prelude.d_C_lookup
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
  x3 x1 cd cs) cd cs) cd cs) cd cs

d_C_infoDiff :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_ProcessInfo
  Curry_Prelude.C_Int) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_ProcessInfo Curry_Prelude.C_Int) -> C_ProcessInfo -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_C_infoDiff x1 x2 x3 cd cs =
  Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_maybe (Curry_Prelude.C_Int (0)) Curry_Prelude.d_C_id
  (Curry_Prelude.d_C_lookup
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
  x3 x2 cd cs) cd cs) (Curry_Prelude.d_C_maybe (Curry_Prelude.C_Int (0))
  Curry_Prelude.d_C_id (Curry_Prelude.d_C_lookup
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Debug_dot_Profile_dot_ProcessInfo_hash
  x3 x1 cd cs) cd cs) cd cs

d_C_getProcessInfos :: Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_ProcessInfo
  Curry_Prelude.C_Int))
d_C_getProcessInfos cd cs = external_d_C_getProcessInfos cd cs

d_C_garbageCollectorOff :: Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_C_garbageCollectorOff cd cs = external_d_C_garbageCollectorOff cd cs

d_C_garbageCollectorOn :: Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_C_garbageCollectorOn cd cs = external_d_C_garbageCollectorOn cd cs

d_C_garbageCollect :: Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_C_garbageCollect cd cs = external_d_C_garbageCollect cd cs

d_C__case_9 :: C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_9 x2 cd cs = case x2 of
  C_RunTime -> Curry_Prelude.C_False
  C_ElapsedTime -> Curry_Prelude.C_False
  C_Memory -> Curry_Prelude.C_False
  C_Code -> Curry_Prelude.C_False
  C_Stack -> Curry_Prelude.C_False
  C_Heap -> Curry_Prelude.C_False
  C_Choices -> Curry_Prelude.C_False
  C_GarbageCollections -> Curry_Prelude.C_True
  Choice_C_ProcessInfo d i l r -> narrow d i (d_C__case_9 l cd cs) (d_C__case_9
    r cd cs)
  Choices_C_ProcessInfo d i xs -> narrows cs d i (\z -> d_C__case_9 z cd cs) xs
  Guard_C_ProcessInfo d c e -> guardCons d c ((\x -> d_C__case_9 e cd x) $!
    addCs c cs)
  Fail_C_ProcessInfo d info -> failCons d (traceFail "Debug.Profile._case_9"
    [show x2] info)
  _ -> failCons cd (consFail "Debug.Profile._case_9" (showCons x2))

d_C__case_10 :: C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_10 x2 cd cs = case x2 of
  C_RunTime -> Curry_Prelude.C_False
  C_ElapsedTime -> Curry_Prelude.C_False
  C_Memory -> Curry_Prelude.C_False
  C_Code -> Curry_Prelude.C_False
  C_Stack -> Curry_Prelude.C_False
  C_Heap -> Curry_Prelude.C_False
  C_Choices -> Curry_Prelude.C_True
  C_GarbageCollections -> Curry_Prelude.C_False
  Choice_C_ProcessInfo d i l r -> narrow d i (d_C__case_10 l cd cs)
    (d_C__case_10 r cd cs)
  Choices_C_ProcessInfo d i xs -> narrows cs d i (\z -> d_C__case_10 z cd cs) xs
  Guard_C_ProcessInfo d c e -> guardCons d c ((\x -> d_C__case_10 e cd x) $!
    addCs c cs)
  Fail_C_ProcessInfo d info -> failCons d (traceFail "Debug.Profile._case_10"
    [show x2] info)
  _ -> failCons cd (consFail "Debug.Profile._case_10" (showCons x2))

d_C__case_11 :: C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_11 x2 cd cs = case x2 of
  C_RunTime -> Curry_Prelude.C_False
  C_ElapsedTime -> Curry_Prelude.C_False
  C_Memory -> Curry_Prelude.C_False
  C_Code -> Curry_Prelude.C_False
  C_Stack -> Curry_Prelude.C_False
  C_Heap -> Curry_Prelude.C_True
  C_Choices -> Curry_Prelude.C_False
  C_GarbageCollections -> Curry_Prelude.C_False
  Choice_C_ProcessInfo d i l r -> narrow d i (d_C__case_11 l cd cs)
    (d_C__case_11 r cd cs)
  Choices_C_ProcessInfo d i xs -> narrows cs d i (\z -> d_C__case_11 z cd cs) xs
  Guard_C_ProcessInfo d c e -> guardCons d c ((\x -> d_C__case_11 e cd x) $!
    addCs c cs)
  Fail_C_ProcessInfo d info -> failCons d (traceFail "Debug.Profile._case_11"
    [show x2] info)
  _ -> failCons cd (consFail "Debug.Profile._case_11" (showCons x2))

d_C__case_12 :: C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_12 x2 cd cs = case x2 of
  C_RunTime -> Curry_Prelude.C_False
  C_ElapsedTime -> Curry_Prelude.C_False
  C_Memory -> Curry_Prelude.C_False
  C_Code -> Curry_Prelude.C_False
  C_Stack -> Curry_Prelude.C_True
  C_Heap -> Curry_Prelude.C_False
  C_Choices -> Curry_Prelude.C_False
  C_GarbageCollections -> Curry_Prelude.C_False
  Choice_C_ProcessInfo d i l r -> narrow d i (d_C__case_12 l cd cs)
    (d_C__case_12 r cd cs)
  Choices_C_ProcessInfo d i xs -> narrows cs d i (\z -> d_C__case_12 z cd cs) xs
  Guard_C_ProcessInfo d c e -> guardCons d c ((\x -> d_C__case_12 e cd x) $!
    addCs c cs)
  Fail_C_ProcessInfo d info -> failCons d (traceFail "Debug.Profile._case_12"
    [show x2] info)
  _ -> failCons cd (consFail "Debug.Profile._case_12" (showCons x2))

d_C__case_13 :: C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_13 x2 cd cs = case x2 of
  C_RunTime -> Curry_Prelude.C_False
  C_ElapsedTime -> Curry_Prelude.C_False
  C_Memory -> Curry_Prelude.C_False
  C_Code -> Curry_Prelude.C_True
  C_Stack -> Curry_Prelude.C_False
  C_Heap -> Curry_Prelude.C_False
  C_Choices -> Curry_Prelude.C_False
  C_GarbageCollections -> Curry_Prelude.C_False
  Choice_C_ProcessInfo d i l r -> narrow d i (d_C__case_13 l cd cs)
    (d_C__case_13 r cd cs)
  Choices_C_ProcessInfo d i xs -> narrows cs d i (\z -> d_C__case_13 z cd cs) xs
  Guard_C_ProcessInfo d c e -> guardCons d c ((\x -> d_C__case_13 e cd x) $!
    addCs c cs)
  Fail_C_ProcessInfo d info -> failCons d (traceFail "Debug.Profile._case_13"
    [show x2] info)
  _ -> failCons cd (consFail "Debug.Profile._case_13" (showCons x2))

d_C__case_14 :: C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_14 x2 cd cs = case x2 of
  C_RunTime -> Curry_Prelude.C_False
  C_ElapsedTime -> Curry_Prelude.C_False
  C_Memory -> Curry_Prelude.C_True
  C_Code -> Curry_Prelude.C_False
  C_Stack -> Curry_Prelude.C_False
  C_Heap -> Curry_Prelude.C_False
  C_Choices -> Curry_Prelude.C_False
  C_GarbageCollections -> Curry_Prelude.C_False
  Choice_C_ProcessInfo d i l r -> narrow d i (d_C__case_14 l cd cs)
    (d_C__case_14 r cd cs)
  Choices_C_ProcessInfo d i xs -> narrows cs d i (\z -> d_C__case_14 z cd cs) xs
  Guard_C_ProcessInfo d c e -> guardCons d c ((\x -> d_C__case_14 e cd x) $!
    addCs c cs)
  Fail_C_ProcessInfo d info -> failCons d (traceFail "Debug.Profile._case_14"
    [show x2] info)
  _ -> failCons cd (consFail "Debug.Profile._case_14" (showCons x2))

d_C__case_15 :: C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_15 x2 cd cs = case x2 of
  C_RunTime -> Curry_Prelude.C_False
  C_ElapsedTime -> Curry_Prelude.C_True
  C_Memory -> Curry_Prelude.C_False
  C_Code -> Curry_Prelude.C_False
  C_Stack -> Curry_Prelude.C_False
  C_Heap -> Curry_Prelude.C_False
  C_Choices -> Curry_Prelude.C_False
  C_GarbageCollections -> Curry_Prelude.C_False
  Choice_C_ProcessInfo d i l r -> narrow d i (d_C__case_15 l cd cs)
    (d_C__case_15 r cd cs)
  Choices_C_ProcessInfo d i xs -> narrows cs d i (\z -> d_C__case_15 z cd cs) xs
  Guard_C_ProcessInfo d c e -> guardCons d c ((\x -> d_C__case_15 e cd x) $!
    addCs c cs)
  Fail_C_ProcessInfo d info -> failCons d (traceFail "Debug.Profile._case_15"
    [show x2] info)
  _ -> failCons cd (consFail "Debug.Profile._case_15" (showCons x2))

d_C__case_16 :: C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_16 x2 cd cs = case x2 of
  C_RunTime -> Curry_Prelude.C_True
  C_ElapsedTime -> Curry_Prelude.C_False
  C_Memory -> Curry_Prelude.C_False
  C_Code -> Curry_Prelude.C_False
  C_Stack -> Curry_Prelude.C_False
  C_Heap -> Curry_Prelude.C_False
  C_Choices -> Curry_Prelude.C_False
  C_GarbageCollections -> Curry_Prelude.C_False
  Choice_C_ProcessInfo d i l r -> narrow d i (d_C__case_16 l cd cs)
    (d_C__case_16 r cd cs)
  Choices_C_ProcessInfo d i xs -> narrows cs d i (\z -> d_C__case_16 z cd cs) xs
  Guard_C_ProcessInfo d c e -> guardCons d c ((\x -> d_C__case_16 e cd x) $!
    addCs c cs)
  Fail_C_ProcessInfo d info -> failCons d (traceFail "Debug.Profile._case_16"
    [show x2] info)
  _ -> failCons cd (consFail "Debug.Profile._case_16" (showCons x2))

d_C__case_1 :: C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_1 x2 cd cs = case x2 of
  C_RunTime -> Curry_Prelude.C_False
  C_ElapsedTime -> Curry_Prelude.C_False
  C_Memory -> Curry_Prelude.C_False
  C_Code -> Curry_Prelude.C_False
  C_Stack -> Curry_Prelude.C_False
  C_Heap -> Curry_Prelude.C_False
  C_Choices -> Curry_Prelude.C_False
  C_GarbageCollections -> Curry_Prelude.C_True
  Choice_C_ProcessInfo d i l r -> narrow d i (d_C__case_1 l cd cs) (d_C__case_1
    r cd cs)
  Choices_C_ProcessInfo d i xs -> narrows cs d i (\z -> d_C__case_1 z cd cs) xs
  Guard_C_ProcessInfo d c e -> guardCons d c ((\x -> d_C__case_1 e cd x) $!
    addCs c cs)
  Fail_C_ProcessInfo d info -> failCons d (traceFail "Debug.Profile._case_1"
    [show x2] info)
  _ -> failCons cd (consFail "Debug.Profile._case_1" (showCons x2))

d_C__case_2 :: C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_2 x2 cd cs = case x2 of
  C_RunTime -> Curry_Prelude.C_False
  C_ElapsedTime -> Curry_Prelude.C_False
  C_Memory -> Curry_Prelude.C_False
  C_Code -> Curry_Prelude.C_False
  C_Stack -> Curry_Prelude.C_False
  C_Heap -> Curry_Prelude.C_False
  C_Choices -> Curry_Prelude.C_True
  C_GarbageCollections -> Curry_Prelude.C_False
  Choice_C_ProcessInfo d i l r -> narrow d i (d_C__case_2 l cd cs) (d_C__case_2
    r cd cs)
  Choices_C_ProcessInfo d i xs -> narrows cs d i (\z -> d_C__case_2 z cd cs) xs
  Guard_C_ProcessInfo d c e -> guardCons d c ((\x -> d_C__case_2 e cd x) $!
    addCs c cs)
  Fail_C_ProcessInfo d info -> failCons d (traceFail "Debug.Profile._case_2"
    [show x2] info)
  _ -> failCons cd (consFail "Debug.Profile._case_2" (showCons x2))

d_C__case_3 :: C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_3 x2 cd cs = case x2 of
  C_RunTime -> Curry_Prelude.C_False
  C_ElapsedTime -> Curry_Prelude.C_False
  C_Memory -> Curry_Prelude.C_False
  C_Code -> Curry_Prelude.C_False
  C_Stack -> Curry_Prelude.C_False
  C_Heap -> Curry_Prelude.C_True
  C_Choices -> Curry_Prelude.C_False
  C_GarbageCollections -> Curry_Prelude.C_False
  Choice_C_ProcessInfo d i l r -> narrow d i (d_C__case_3 l cd cs) (d_C__case_3
    r cd cs)
  Choices_C_ProcessInfo d i xs -> narrows cs d i (\z -> d_C__case_3 z cd cs) xs
  Guard_C_ProcessInfo d c e -> guardCons d c ((\x -> d_C__case_3 e cd x) $!
    addCs c cs)
  Fail_C_ProcessInfo d info -> failCons d (traceFail "Debug.Profile._case_3"
    [show x2] info)
  _ -> failCons cd (consFail "Debug.Profile._case_3" (showCons x2))

d_C__case_4 :: C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_4 x2 cd cs = case x2 of
  C_RunTime -> Curry_Prelude.C_False
  C_ElapsedTime -> Curry_Prelude.C_False
  C_Memory -> Curry_Prelude.C_False
  C_Code -> Curry_Prelude.C_False
  C_Stack -> Curry_Prelude.C_True
  C_Heap -> Curry_Prelude.C_False
  C_Choices -> Curry_Prelude.C_False
  C_GarbageCollections -> Curry_Prelude.C_False
  Choice_C_ProcessInfo d i l r -> narrow d i (d_C__case_4 l cd cs) (d_C__case_4
    r cd cs)
  Choices_C_ProcessInfo d i xs -> narrows cs d i (\z -> d_C__case_4 z cd cs) xs
  Guard_C_ProcessInfo d c e -> guardCons d c ((\x -> d_C__case_4 e cd x) $!
    addCs c cs)
  Fail_C_ProcessInfo d info -> failCons d (traceFail "Debug.Profile._case_4"
    [show x2] info)
  _ -> failCons cd (consFail "Debug.Profile._case_4" (showCons x2))

d_C__case_5 :: C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_5 x2 cd cs = case x2 of
  C_RunTime -> Curry_Prelude.C_False
  C_ElapsedTime -> Curry_Prelude.C_False
  C_Memory -> Curry_Prelude.C_False
  C_Code -> Curry_Prelude.C_True
  C_Stack -> Curry_Prelude.C_False
  C_Heap -> Curry_Prelude.C_False
  C_Choices -> Curry_Prelude.C_False
  C_GarbageCollections -> Curry_Prelude.C_False
  Choice_C_ProcessInfo d i l r -> narrow d i (d_C__case_5 l cd cs) (d_C__case_5
    r cd cs)
  Choices_C_ProcessInfo d i xs -> narrows cs d i (\z -> d_C__case_5 z cd cs) xs
  Guard_C_ProcessInfo d c e -> guardCons d c ((\x -> d_C__case_5 e cd x) $!
    addCs c cs)
  Fail_C_ProcessInfo d info -> failCons d (traceFail "Debug.Profile._case_5"
    [show x2] info)
  _ -> failCons cd (consFail "Debug.Profile._case_5" (showCons x2))

d_C__case_6 :: C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_6 x2 cd cs = case x2 of
  C_RunTime -> Curry_Prelude.C_False
  C_ElapsedTime -> Curry_Prelude.C_False
  C_Memory -> Curry_Prelude.C_True
  C_Code -> Curry_Prelude.C_False
  C_Stack -> Curry_Prelude.C_False
  C_Heap -> Curry_Prelude.C_False
  C_Choices -> Curry_Prelude.C_False
  C_GarbageCollections -> Curry_Prelude.C_False
  Choice_C_ProcessInfo d i l r -> narrow d i (d_C__case_6 l cd cs) (d_C__case_6
    r cd cs)
  Choices_C_ProcessInfo d i xs -> narrows cs d i (\z -> d_C__case_6 z cd cs) xs
  Guard_C_ProcessInfo d c e -> guardCons d c ((\x -> d_C__case_6 e cd x) $!
    addCs c cs)
  Fail_C_ProcessInfo d info -> failCons d (traceFail "Debug.Profile._case_6"
    [show x2] info)
  _ -> failCons cd (consFail "Debug.Profile._case_6" (showCons x2))

d_C__case_7 :: C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_7 x2 cd cs = case x2 of
  C_RunTime -> Curry_Prelude.C_False
  C_ElapsedTime -> Curry_Prelude.C_True
  C_Memory -> Curry_Prelude.C_False
  C_Code -> Curry_Prelude.C_False
  C_Stack -> Curry_Prelude.C_False
  C_Heap -> Curry_Prelude.C_False
  C_Choices -> Curry_Prelude.C_False
  C_GarbageCollections -> Curry_Prelude.C_False
  Choice_C_ProcessInfo d i l r -> narrow d i (d_C__case_7 l cd cs) (d_C__case_7
    r cd cs)
  Choices_C_ProcessInfo d i xs -> narrows cs d i (\z -> d_C__case_7 z cd cs) xs
  Guard_C_ProcessInfo d c e -> guardCons d c ((\x -> d_C__case_7 e cd x) $!
    addCs c cs)
  Fail_C_ProcessInfo d info -> failCons d (traceFail "Debug.Profile._case_7"
    [show x2] info)
  _ -> failCons cd (consFail "Debug.Profile._case_7" (showCons x2))

d_C__case_8 :: C_ProcessInfo -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_8 x2 cd cs = case x2 of
  C_RunTime -> Curry_Prelude.C_True
  C_ElapsedTime -> Curry_Prelude.C_False
  C_Memory -> Curry_Prelude.C_False
  C_Code -> Curry_Prelude.C_False
  C_Stack -> Curry_Prelude.C_False
  C_Heap -> Curry_Prelude.C_False
  C_Choices -> Curry_Prelude.C_False
  C_GarbageCollections -> Curry_Prelude.C_False
  Choice_C_ProcessInfo d i l r -> narrow d i (d_C__case_8 l cd cs) (d_C__case_8
    r cd cs)
  Choices_C_ProcessInfo d i xs -> narrows cs d i (\z -> d_C__case_8 z cd cs) xs
  Guard_C_ProcessInfo d c e -> guardCons d c ((\x -> d_C__case_8 e cd x) $!
    addCs c cs)
  Fail_C_ProcessInfo d info -> failCons d (traceFail "Debug.Profile._case_8"
    [show x2] info)
  _ -> failCons cd (consFail "Debug.Profile._case_8" (showCons x2))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Integral t0) -> t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_0 x1 x3 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_show x2 cd
    cs) x3 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_show x2 cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_div x1 cd cs) x3 cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_fromInt
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 cd cs) cd cs) cd cs) (Curry_Prelude.C_Int (1000)) cd cs) cd cs) cd cs)
    (Curry_Prelude.toCurryString " kb") cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x1 x3 x2 l cd
    cs) (d_C__case_0 x1 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x1 x3
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x1 x3 x2
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Debug.Profile._case_0" [show x1, show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "Debug.Profile._case_0" (showCons x4))

nd_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Integral t0) -> t0
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_0 x1 x3 x2 x4 s cd cs = case x4 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x2
    s0 cd cs) x3 s1 cd cs))
  Curry_Prelude.C_False -> let s15 = s
    in s15 `seq` Curry_Prelude.d_OP_plus_plus (let s14 = leftSupply s15
                                                   s16 = rightSupply s15
                                                   s0 = leftSupply s16
                                                   s12 = rightSupply s16
    in s14 `seq` (s16 `seq` (s0 `seq` (s12 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_show x2 s0 cd cs) (let s11 = leftSupply s12
                                               s13 = rightSupply s12
                                               s3 = leftSupply s13
                                               s10 = rightSupply s13
    in s11 `seq` (s13 `seq` (s3 `seq` (s10 `seq` Curry_Prelude.nd_C_apply
    (let s2 = leftSupply s3
         s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_div x1 s1
    cd cs) x3 s2 cd cs)) (let s9 = leftSupply s10
                              s8 = rightSupply s10
    in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (let s7 = leftSupply s8
                                                        s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_fromInt (let s5 = leftSupply s6
                                                          s4 = rightSupply s6
    in s5 `seq` (s4 `seq`
    Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 s4 cd cs) s5 cd cs)) s7 cd cs)) (Curry_Prelude.C_Int (1000)) s9 cd cs))
    s11 cd cs)))) s14 cd cs)))) (Curry_Prelude.toCurryString " kb") cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_0 x1 x3 x2 l s
    cd cs) (nd_C__case_0 x1 x3 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_0 x1
    x3 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_0 x1 x3
    x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Debug.Profile._case_0" [show x1, show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "Debug.Profile._case_0" (showCons x4))

-- #endimport - do not remove this line!

instance ConvertCurryHaskell C_ProcessInfo C_ProcessInfo where
  toCurry   = id
  fromCurry = id

getProcessInfos :: IO [(C_ProcessInfo, Int)]
#if __GLASGOW_HASKELL__ > 802
getProcessInfos = do
  stats <- getRTSStats
  return [ (C_RunTime           , fromIntegral (mutator_cpu_ns      stats `div` (10^6)))
         , (C_ElapsedTime       , fromIntegral (mutator_elapsed_ns  stats `div` (10^6)))
         , (C_Heap              , fromIntegral (max_live_bytes      stats))
         , (C_Memory            , fromIntegral (max_live_bytes      stats))
         , (C_GarbageCollections, fromIntegral (gcs                 stats))
         ]
#elif __GLASGOW_HASKELL__ > 702
getProcessInfos = do
  stats <- getGCStats
  return [ (C_RunTime           , floor (mutatorCpuSeconds   stats * 1000))
         , (C_ElapsedTime       , floor (mutatorWallSeconds  stats * 1000))
         , (C_Heap              , fromIntegral (maxBytesUsed stats))
         , (C_Memory            , fromIntegral (maxBytesUsed stats))
         , (C_GarbageCollections, fromIntegral (numGcs       stats))
         ]
#else
getProcessInfos = do
  t <- getCPUTime
  return [(C_RunTime, t `div` (10^9)]
#endif

external_d_C_getProcessInfos :: Cover -> ConstStore ->
   Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_ProcessInfo Curry_Prelude.C_Int))
external_d_C_getProcessInfos _ _ = toCurry getProcessInfos

external_d_C_garbageCollectorOff :: Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
external_d_C_garbageCollectorOff _ _ = toCurry (return () :: IO ()) -- not supported

external_d_C_garbageCollectorOn :: Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
external_d_C_garbageCollectorOn _ _ = toCurry (return () :: IO ()) -- not supported

external_d_C_garbageCollect :: Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
external_d_C_garbageCollect _ _ = toCurry performGC
