{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Analysis.Curry_Demandedness
  ( C_DemandDomain (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
  , d_C_showDemand
  , d_C_lub
  , d_C_demandAnalysis
  , nd_C_demandAnalysis
  , d_C_daFunc
  , d_C_daFuncRule
  , d_C_prelude )
  where

import Basics
import qualified Analysis.Curry_Types
import qualified Data.Curry_List
import qualified FlatCurry.Curry_Types
import qualified Curry_Prelude


data C_DemandDomain
  = C_Bot
  | C_Top
  | Choice_C_DemandDomain Cover ID C_DemandDomain C_DemandDomain
  | Choices_C_DemandDomain Cover ID [C_DemandDomain]
  | Fail_C_DemandDomain Cover FailInfo
  | Guard_C_DemandDomain Cover Constraints C_DemandDomain

instance Show C_DemandDomain where
  showsPrec d (Choice_C_DemandDomain cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_DemandDomain cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_DemandDomain cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_DemandDomain cd info) = showChar '!'
  showsPrec _ C_Bot = showString "Bot"
  showsPrec _ C_Top = showString "Top"

instance Read C_DemandDomain where
  readsPrec _ s = readParen False (\r -> [(C_Bot, r0) | (_, r0) <- readQualified
    "Analysis.Demandedness" "Bot" r]) s ++ readParen False (\r -> [(C_Top
    , r0) | (_, r0) <- readQualified "Analysis.Demandedness" "Top" r]) s

instance NonDet C_DemandDomain where
  choiceCons = Choice_C_DemandDomain
  choicesCons = Choices_C_DemandDomain
  failCons = Fail_C_DemandDomain
  guardCons = Guard_C_DemandDomain
  try (Choice_C_DemandDomain cd i x y) = tryChoice cd i x y
  try (Choices_C_DemandDomain cd i xs) = tryChoices cd i xs
  try (Fail_C_DemandDomain cd info) = Fail cd info
  try (Guard_C_DemandDomain cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_DemandDomain cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_DemandDomain cd i@(NarrowedID _ _) xs) = f cd i
    xs
  match _ _ f _ _ _ (Choices_C_DemandDomain cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_DemandDomain cd i _) = error
    ("Analysis.Demandedness.DemandDomain.match: Choices with ChoiceID " ++ show
    i)
  match _ _ _ f _ _ (Fail_C_DemandDomain cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_DemandDomain cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_DemandDomain where
  generate s c = Choices_C_DemandDomain c (freeID [0, 0] s) [C_Bot, C_Top]

instance NormalForm C_DemandDomain where
  ($!!) cont C_Bot d cs = cont C_Bot d cs
  ($!!) cont C_Top d cs = cont C_Top d cs
  ($!!) cont (Choice_C_DemandDomain cd i x y) d cs = nfChoice cont cd i x y cd
    cs
  ($!!) cont (Choices_C_DemandDomain cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_DemandDomain cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_DemandDomain cd info) _ _ = failCons cd info
  ($##) cont C_Bot d cs = cont C_Bot d cs
  ($##) cont C_Top d cs = cont C_Top d cs
  ($##) cont (Choice_C_DemandDomain cd i x y) d cs = gnfChoice cont cd i x y cd
    cs
  ($##) cont (Choices_C_DemandDomain cd i xs) d cs = gnfChoices cont cd i xs d
    cs
  ($##) cont (Guard_C_DemandDomain cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_DemandDomain cd info) _ _ = failCons cd info
  showCons C_Bot = "Analysis.Demandedness.Bot"
  showCons C_Top = "Analysis.Demandedness.Top"
  showCons x = error
    ("Analysis.Demandedness.DemandDomain.showCons: no constructor: " ++ show x)
  searchNF _ cont C_Bot = cont C_Bot
  searchNF _ cont C_Top = cont C_Top
  searchNF _ _ x = error
    ("Analysis.Demandedness.DemandDomain.searchNF: no constructor: " ++ show x)

instance Unifiable C_DemandDomain where
  (=.=) C_Bot C_Bot d cs = C_True
  (=.=) C_Top C_Top d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_Bot C_Bot d cs = C_True
  (=.<=) C_Top C_Top d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_Bot = (i :=: ChooseN 0 0) : concat []
  bind cd i C_Top = (i :=: ChooseN 1 0) : concat []
  bind d i (Choice_C_DemandDomain cd j x y) = [ConstraintChoice cd j (bind d i
    x) (bind d i y)]
  bind d i (Choices_C_DemandDomain cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j
    xs
  bind d i (Choices_C_DemandDomain cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_DemandDomain cd i _) = error
    ("Analysis.Demandedness.DemandDomain.bind: Choices with ChoiceID: " ++ show
    i)
  bind _ _ (Fail_C_DemandDomain cd info) = [Unsolvable info]
  bind d i (Guard_C_DemandDomain cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_Bot = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_Top = (i :=: ChooseN 1 0) : []
  lazyBind d i (Choice_C_DemandDomain cd j x y) = [ConstraintChoice cd j
    (lazyBind d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_DemandDomain cd j@(FreeID _ _) xs) = lazyBindOrNarrow
    d i cd j xs
  lazyBind d i (Choices_C_DemandDomain cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_DemandDomain cd i _) = error
    ("Analysis.Demandedness.DemandDomain.lazyBind: Choices with ChoiceID: " ++
    show i)
  lazyBind _ _ (Fail_C_DemandDomain cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_DemandDomain cd c e) = getConstrList c ++ [i :=:
    LazyBind (lazyBind d i e)]

instance Curry C_DemandDomain where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_DemandDomain
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.Demandedness._inst#Prelude.Data#Analysis.Demandedness.DemandDomain#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Demandedness._inst#Prelude.Data#Analysis.Demandedness.DemandDomain#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash :: C_DemandDomain
  -> C_DemandDomain -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash x1 x2 cd cs =
  case x1 of
  C_Bot -> d_C__case_17 x2 cd cs
  C_Top -> d_C__case_16 x2 cd cs
  Choice_C_DemandDomain d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    r x2 cd cs)
  Choices_C_DemandDomain d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    z x2 cd cs) xs
  Guard_C_DemandDomain d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_DemandDomain d info -> failCons d (traceFail
    "Analysis.Demandedness._impl#===#Prelude.Data#Analysis.Demandedness.DemandDomain#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Analysis.Demandedness._impl#===#Prelude.Data#Analysis.Demandedness.DemandDomain#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash :: IDSupply
  -> Cover -> ConstStore -> C_DemandDomain
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash s cd cs =
  let s0 = s in s0 `seq` choice C_Bot C_Top s0 cd cs

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_DemandDomain
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.Demandedness._inst#Prelude.Eq#Analysis.Demandedness.DemandDomain#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Demandedness._inst#Prelude.Eq#Analysis.Demandedness.DemandDomain#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_DemandDomain
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.Demandedness._inst#Prelude.Eq#Analysis.Demandedness.DemandDomain#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Demandedness._inst#Prelude.Eq#Analysis.Demandedness.DemandDomain#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash :: C_DemandDomain
  -> C_DemandDomain -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash x1 x2 cd cs =
  case x1 of
  C_Bot -> d_C__case_15 x2 cd cs
  C_Top -> d_C__case_14 x2 cd cs
  Choice_C_DemandDomain d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    r x2 cd cs)
  Choices_C_DemandDomain d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    z x2 cd cs) xs
  Guard_C_DemandDomain d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_DemandDomain d info -> failCons d (traceFail
    "Analysis.Demandedness._impl#==#Prelude.Eq#Analysis.Demandedness.DemandDomain#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Analysis.Demandedness._impl#==#Prelude.Eq#Analysis.Demandedness.DemandDomain#"
    (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash :: Cover
  -> ConstStore -> C_DemandDomain -> Cover -> ConstStore -> C_DemandDomain
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash)

d_C_showDemand :: Analysis.Curry_Types.C_AOutFormat -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_showDemand x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> d_C__case_13 x1 cd cs
  Curry_Prelude.OP_Cons x3 x4 -> Curry_Prelude.d_OP_plus_plus (d_C__case_12 x1
    (Analysis.Curry_Types.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash
    x1 Analysis.Curry_Types.C_AText cd cs) cd cs)
    (Data.Curry_List.d_C_intercalate (Curry_Prelude.toCurryString ",")
    (Curry_Prelude.d_C_map
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.OP_Cons x3 x4) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_showDemand x1 l cd cs)
    (d_C_showDemand x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_showDemand
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_showDemand x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Analysis.Demandedness.showDemand" [show x1, show x2] info)
  _ -> failCons cd (consFail "Analysis.Demandedness.showDemand" (showCons x2))

d_C_lub :: C_DemandDomain -> C_DemandDomain -> Cover -> ConstStore
  -> C_DemandDomain
d_C_lub x1 x2 cd cs = case x1 of
  C_Bot -> x2
  C_Top -> C_Top
  Choice_C_DemandDomain d i l r -> narrow d i (d_C_lub l x2 cd cs) (d_C_lub r x2
    cd cs)
  Choices_C_DemandDomain d i xs -> narrows cs d i (\z -> d_C_lub z x2 cd cs) xs
  Guard_C_DemandDomain d c e -> guardCons d c ((\x -> d_C_lub e x2 cd x) $!
    addCs c cs)
  Fail_C_DemandDomain d info -> failCons d (traceFail
    "Analysis.Demandedness.lub" [show x1, show x2] info)
  _ -> failCons cd (consFail "Analysis.Demandedness.lub" (showCons x1))

d_C_demandAnalysis :: Cover -> ConstStore -> Analysis.Curry_Types.C_Analysis
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)
d_C_demandAnalysis cd cs = Analysis.Curry_Types.d_C_dependencyFuncAnalysis
  (Curry_Prelude.toCurryString "Demand")
  (Curry_Prelude.d_OP_uscore_impl_hash_enumFrom_hash_Prelude_dot_Enum_hash_Prelude_dot_Int_hash
  (Curry_Prelude.C_Int (1)) cd cs) (acceptCs id d_C_daFunc) cd cs

nd_C_demandAnalysis :: IDSupply -> Cover -> ConstStore
  -> Analysis.Curry_Types.C_Analysis (Curry_Prelude.OP_List Curry_Prelude.C_Int)
nd_C_demandAnalysis s cd cs = let s0 = s
  in s0 `seq` Analysis.Curry_Types.nd_C_dependencyFuncAnalysis
  (Curry_Prelude.toCurryString "Demand")
  (Curry_Prelude.d_OP_uscore_impl_hash_enumFrom_hash_Prelude_dot_Enum_hash_Prelude_dot_Int_hash
  (Curry_Prelude.C_Int (1)) cd cs) (wrapDX (wrapDX id) (acceptCs id d_C_daFunc))
  s0 cd cs

d_C_daFunc :: FlatCurry.Curry_Types.C_FuncDecl -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int
d_C_daFunc x1 x2 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Func x3 x4 x5 x6 x7 -> d_C__case_11 x7 x2 x3 cd cs
  FlatCurry.Curry_Types.Choice_C_FuncDecl d i l r -> narrow d i (d_C_daFunc l x2
    cd cs) (d_C_daFunc r x2 cd cs)
  FlatCurry.Curry_Types.Choices_C_FuncDecl d i xs -> narrows cs d i (\z ->
    d_C_daFunc z x2 cd cs) xs
  FlatCurry.Curry_Types.Guard_C_FuncDecl d c e -> guardCons d c ((\x ->
    d_C_daFunc e x2 cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_FuncDecl d info -> failCons d (traceFail
    "Analysis.Demandedness.daFunc" [show x1, show x2] info)
  _ -> failCons cd (consFail "Analysis.Demandedness.daFunc" (showCons x1))

d_C_daFuncRule :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)) -> FlatCurry.Curry_Types.C_Rule -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int
d_C_daFuncRule x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_External x3 -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Rule x4 x5 -> Curry_Prelude.d_C_map
    Curry_Prelude.d_C_fst (Curry_Prelude.d_C_filter (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_flip (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash)
    C_Bot) Curry_Prelude.d_C_snd cd cs) (Curry_Prelude.d_C_map
    (d_OP_daFuncRule_dot_uscore_hash_lambda3 x5 x1) x4 cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Rule d i l r -> narrow d i (d_C_daFuncRule x1 l
    cd cs) (d_C_daFuncRule x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Rule d i xs -> narrows cs d i (\z ->
    d_C_daFuncRule x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Rule d c e -> guardCons d c ((\x ->
    d_C_daFuncRule x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Rule d info -> failCons d (traceFail
    "Analysis.Demandedness.daFuncRule" [show x1, show x2] info)
  _ -> failCons cd (consFail "Analysis.Demandedness.daFuncRule" (showCons x2))

d_OP_daFuncRule_dot_absEvalExpr_dot_26 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)) -> FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> Cover -> ConstStore
  -> C_DemandDomain
d_OP_daFuncRule_dot_absEvalExpr_dot_26 x1 x2 x3 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Var x4 -> d_C__case_7 x3 x4 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_elem
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x4 cd cs) x3 cd cs) cd cs
  FlatCurry.Curry_Types.C_Lit x5 -> C_Top
  FlatCurry.Curry_Types.C_Comb x6 x7 x8 -> d_C__case_6 x6 x7 x1 x3 x8
    (FlatCurry.Curry_Types.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Types_dot_CombType_hash
    x6 FlatCurry.Curry_Types.C_FuncCall cd cs) cd cs
  FlatCurry.Curry_Types.C_Free x9 x10 -> d_OP_daFuncRule_dot_absEvalExpr_dot_26
    x1 x10 x3 cd cs
  FlatCurry.Curry_Types.C_Let x11 x12 -> d_OP_daFuncRule_dot_absEvalExpr_dot_26
    x1 x12 (d_OP_daFuncRule_dot_absEvalBindings_dot_26 x1 x11 x3 cd cs) cd cs
  FlatCurry.Curry_Types.C_Or x13 x14 -> d_C_lub
    (d_OP_daFuncRule_dot_absEvalExpr_dot_26 x1 x13 x3 cd cs)
    (d_OP_daFuncRule_dot_absEvalExpr_dot_26 x1 x14 x3 cd cs) cd cs
  FlatCurry.Curry_Types.C_Case x15 x16 x17 -> d_C__case_3 x3 x16 x1 x17
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    (d_OP_daFuncRule_dot_absEvalExpr_dot_26 x1 x16 x3 cd cs) C_Bot cd cs) cd cs
  FlatCurry.Curry_Types.C_Typed x18 x19 -> d_OP_daFuncRule_dot_absEvalExpr_dot_26
    x1 x18 x3 cd cs
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i
    (d_OP_daFuncRule_dot_absEvalExpr_dot_26 x1 l x3 cd cs)
    (d_OP_daFuncRule_dot_absEvalExpr_dot_26 x1 r x3 cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    d_OP_daFuncRule_dot_absEvalExpr_dot_26 x1 z x3 cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x ->
    d_OP_daFuncRule_dot_absEvalExpr_dot_26 x1 e x3 cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "Analysis.Demandedness.daFuncRule.absEvalExpr.26" [show x1, show x2, show
    x3] info)
  _ -> failCons cd (consFail "Analysis.Demandedness.daFuncRule.absEvalExpr.26"
    (showCons x2))

d_OP_daFuncRule_dot_absEvalExpr_dot_26_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> Cover -> ConstStore
  -> C_DemandDomain
d_OP_daFuncRule_dot_absEvalExpr_dot_26_dot_uscore_hash_lambda1 x1 x2 x3 x4 cd cs =
  let x5 = Curry_Prelude.d_C_map
        (d_OP_daFuncRule_dot_absEvalExpr_dot_26_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2
        x2 x3) (Curry_Prelude.d_C_zip
        (Curry_Prelude.d_OP_uscore_impl_hash_enumFrom_hash_Prelude_dot_Enum_hash_Prelude_dot_Int_hash
        (Curry_Prelude.C_Int (1)) cd cs) x1 cd cs) cd cs
      x6 = Data.Curry_List.d_OP_backslash_backslash
        Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
        x4 (Curry_Prelude.d_C_map Curry_Prelude.d_C_fst
        (Curry_Prelude.d_C_filter (Curry_Prelude.d_OP_dot
        (Curry_Prelude.d_C_flip
        (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
        cd cs) C_Bot) Curry_Prelude.d_C_snd cd cs) x5 cd cs) cd cs) cd cs
  in d_C__case_2 x6 (Curry_Prelude.d_C_null x6 cd cs) cd cs

d_OP_daFuncRule_dot_absEvalExpr_dot_26_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)) -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int C_DemandDomain
d_OP_daFuncRule_dot_absEvalExpr_dot_26_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 x3 cd cs =
  case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.OP_Tuple2 x4
    (d_OP_daFuncRule_dot_absEvalExpr_dot_26 x2 x5 x1 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_daFuncRule_dot_absEvalExpr_dot_26_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2
    x1 x2 l cd cs)
    (d_OP_daFuncRule_dot_absEvalExpr_dot_26_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2
    x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_daFuncRule_dot_absEvalExpr_dot_26_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_daFuncRule_dot_absEvalExpr_dot_26_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2
    x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Demandedness.daFuncRule.absEvalExpr.26._#lambda1._#lambda2" [show
    x1, show x2, show x3] info)
  _ -> failCons cd (consFail
    "Analysis.Demandedness.daFuncRule.absEvalExpr.26._#lambda1._#lambda2"
    (showCons x3))

d_OP_daFuncRule_dot_absEvalExpr_dot_26_dot_absEvalBranch_dot_49 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)) -> FlatCurry.Curry_Types.C_BranchExpr -> Cover
  -> ConstStore -> C_DemandDomain
d_OP_daFuncRule_dot_absEvalExpr_dot_26_dot_absEvalBranch_dot_49 x1 x2 x3 cd cs =
  case x3 of
  FlatCurry.Curry_Types.C_Branch x4 x5 -> d_OP_daFuncRule_dot_absEvalExpr_dot_26
    x2 x5 x1 cd cs
  FlatCurry.Curry_Types.Choice_C_BranchExpr d i l r -> narrow d i
    (d_OP_daFuncRule_dot_absEvalExpr_dot_26_dot_absEvalBranch_dot_49 x1 x2 l cd
    cs) (d_OP_daFuncRule_dot_absEvalExpr_dot_26_dot_absEvalBranch_dot_49 x1 x2 r
    cd cs)
  FlatCurry.Curry_Types.Choices_C_BranchExpr d i xs -> narrows cs d i (\z ->
    d_OP_daFuncRule_dot_absEvalExpr_dot_26_dot_absEvalBranch_dot_49 x1 x2 z cd
    cs) xs
  FlatCurry.Curry_Types.Guard_C_BranchExpr d c e -> guardCons d c ((\x ->
    d_OP_daFuncRule_dot_absEvalExpr_dot_26_dot_absEvalBranch_dot_49 x1 x2 e cd
    x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_BranchExpr d info -> failCons d (traceFail
    "Analysis.Demandedness.daFuncRule.absEvalExpr.26.absEvalBranch.49" [show x1
    , show x2, show x3] info)
  _ -> failCons cd (consFail
    "Analysis.Demandedness.daFuncRule.absEvalExpr.26.absEvalBranch.49" (showCons
    x3))

d_OP_daFuncRule_dot_absEvalBindings_dot_26 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Expr)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int
d_OP_daFuncRule_dot_absEvalBindings_dot_26 x1 x2 x3 cd cs = case x2 of
  Curry_Prelude.OP_List -> x3
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_1 x3 x1 x5 x4 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_daFuncRule_dot_absEvalBindings_dot_26 x1 l x3 cd cs)
    (d_OP_daFuncRule_dot_absEvalBindings_dot_26 x1 r x3 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_daFuncRule_dot_absEvalBindings_dot_26 x1 z x3 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_daFuncRule_dot_absEvalBindings_dot_26 x1 e x3 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Analysis.Demandedness.daFuncRule.absEvalBindings.26" [show x1, show x2
    , show x3] info)
  _ -> failCons cd (consFail
    "Analysis.Demandedness.daFuncRule.absEvalBindings.26" (showCons x2))

d_OP_daFuncRule_dot_uscore_hash_lambda3 :: FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Int))
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int C_DemandDomain
d_OP_daFuncRule_dot_uscore_hash_lambda3 x1 x2 x3 cd cs = Curry_Prelude.OP_Tuple2
  x3 (d_OP_daFuncRule_dot_absEvalExpr_dot_26 x2 x1 (Curry_Prelude.OP_Cons x3
  Curry_Prelude.OP_List) cd cs)

d_C_prelude :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_prelude cd cs = Curry_Prelude.toCurryString "Prelude"

d_C__case_16 :: C_DemandDomain -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_16 x2 cd cs = case x2 of
  C_Bot -> Curry_Prelude.C_False
  C_Top -> Curry_Prelude.C_True
  Choice_C_DemandDomain d i l r -> narrow d i (d_C__case_16 l cd cs)
    (d_C__case_16 r cd cs)
  Choices_C_DemandDomain d i xs -> narrows cs d i (\z -> d_C__case_16 z cd cs)
    xs
  Guard_C_DemandDomain d c e -> guardCons d c ((\x -> d_C__case_16 e cd x) $!
    addCs c cs)
  Fail_C_DemandDomain d info -> failCons d (traceFail
    "Analysis.Demandedness._case_16" [show x2] info)
  _ -> failCons cd (consFail "Analysis.Demandedness._case_16" (showCons x2))

d_C__case_17 :: C_DemandDomain -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_17 x2 cd cs = case x2 of
  C_Bot -> Curry_Prelude.C_True
  C_Top -> Curry_Prelude.C_False
  Choice_C_DemandDomain d i l r -> narrow d i (d_C__case_17 l cd cs)
    (d_C__case_17 r cd cs)
  Choices_C_DemandDomain d i xs -> narrows cs d i (\z -> d_C__case_17 z cd cs)
    xs
  Guard_C_DemandDomain d c e -> guardCons d c ((\x -> d_C__case_17 e cd x) $!
    addCs c cs)
  Fail_C_DemandDomain d info -> failCons d (traceFail
    "Analysis.Demandedness._case_17" [show x2] info)
  _ -> failCons cd (consFail "Analysis.Demandedness._case_17" (showCons x2))

d_C__case_14 :: C_DemandDomain -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_14 x2 cd cs = case x2 of
  C_Bot -> Curry_Prelude.C_False
  C_Top -> Curry_Prelude.C_True
  Choice_C_DemandDomain d i l r -> narrow d i (d_C__case_14 l cd cs)
    (d_C__case_14 r cd cs)
  Choices_C_DemandDomain d i xs -> narrows cs d i (\z -> d_C__case_14 z cd cs)
    xs
  Guard_C_DemandDomain d c e -> guardCons d c ((\x -> d_C__case_14 e cd x) $!
    addCs c cs)
  Fail_C_DemandDomain d info -> failCons d (traceFail
    "Analysis.Demandedness._case_14" [show x2] info)
  _ -> failCons cd (consFail "Analysis.Demandedness._case_14" (showCons x2))

d_C__case_15 :: C_DemandDomain -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_15 x2 cd cs = case x2 of
  C_Bot -> Curry_Prelude.C_True
  C_Top -> Curry_Prelude.C_False
  Choice_C_DemandDomain d i l r -> narrow d i (d_C__case_15 l cd cs)
    (d_C__case_15 r cd cs)
  Choices_C_DemandDomain d i xs -> narrows cs d i (\z -> d_C__case_15 z cd cs)
    xs
  Guard_C_DemandDomain d c e -> guardCons d c ((\x -> d_C__case_15 e cd x) $!
    addCs c cs)
  Fail_C_DemandDomain d info -> failCons d (traceFail
    "Analysis.Demandedness._case_15" [show x2] info)
  _ -> failCons cd (consFail "Analysis.Demandedness._case_15" (showCons x2))

d_C__case_12 :: Analysis.Curry_Types.C_AOutFormat -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_12 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "demanded arguments: "
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_12 x1 l cd cs)
    (d_C__case_12 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_12 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_12 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Demandedness._case_12" [show x1, show x2] info)
  _ -> failCons cd (consFail "Analysis.Demandedness._case_12" (showCons x2))

d_C__case_13 :: Analysis.Curry_Types.C_AOutFormat -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_13 x1 cd cs = case x1 of
  Analysis.Curry_Types.C_AText -> Curry_Prelude.toCurryString
    "no demanded arguments"
  Analysis.Curry_Types.C_ANote -> Curry_Prelude.OP_List
  Analysis.Curry_Types.Choice_C_AOutFormat d i l r -> narrow d i (d_C__case_13 l
    cd cs) (d_C__case_13 r cd cs)
  Analysis.Curry_Types.Choices_C_AOutFormat d i xs -> narrows cs d i (\z ->
    d_C__case_13 z cd cs) xs
  Analysis.Curry_Types.Guard_C_AOutFormat d c e -> guardCons d c ((\x ->
    d_C__case_13 e cd x) $! addCs c cs)
  Analysis.Curry_Types.Fail_C_AOutFormat d info -> failCons d (traceFail
    "Analysis.Demandedness._case_13" [show x1] info)
  _ -> failCons cd (consFail "Analysis.Demandedness._case_13" (showCons x1))

d_C__case_11 :: FlatCurry.Curry_Types.C_Rule -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int
d_C__case_11 x7 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x8 x9 -> let x10 = Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "==")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "=:=")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "compare")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "<=")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "$#")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "$##")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "$!")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "$!!")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "+")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "-")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "*")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "div")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "mod")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "divMod")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "quot")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "rem")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "quotRem")
                                         Curry_Prelude.OP_List))))))))))))))))
                                       x11 = Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "seq")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString
                                         "ensureNotFree") (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "apply")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "cond")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "=:<=")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString
                                         "negateFloat")
                                         Curry_Prelude.OP_List)))))
    in d_C__case_10 x10 x9 x8 x11 x7 x2 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x8 (d_C_prelude cd cs) cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_elem
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x9 cd cs) x10 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_11 x7 x2 l cd
    cs) (d_C__case_11 x7 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_11
    x7 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_11 x7
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Demandedness._case_11" [show x7, show x2, show x3] info)
  _ -> failCons cd (consFail "Analysis.Demandedness._case_11" (showCons x3))

d_C__case_10 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_Rule
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Int))
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int
d_C__case_10 x10 x9 x8 x11 x7 x2 x12 cd cs = case x12 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1))
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (2)) Curry_Prelude.OP_List)
  Curry_Prelude.C_False -> d_C__case_9 x11 x9 x8 x7 x2
    (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x8 (d_C_prelude cd cs) cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_elem
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x9 cd cs) x11 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_10 x10 x9 x8 x11
    x7 x2 l cd cs) (d_C__case_10 x10 x9 x8 x11 x7 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_10 x10
    x9 x8 x11 x7 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_10 x10 x9
    x8 x11 x7 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Demandedness._case_10" [show x10, show x9, show x8, show x11, show
    x7, show x2, show x12] info)
  _ -> failCons cd (consFail "Analysis.Demandedness._case_10" (showCons x12))

d_C__case_9 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> FlatCurry.Curry_Types.C_Rule
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Int))
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int
d_C__case_9 x11 x9 x8 x7 x2 x12 cd cs = case x12 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1))
    Curry_Prelude.OP_List
  Curry_Prelude.C_False -> d_C__case_8 x7 x2 (Curry_Prelude.d_C_otherwise cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_9 x11 x9 x8 x7 x2
    l cd cs) (d_C__case_9 x11 x9 x8 x7 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_9 x11
    x9 x8 x7 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_9 x11 x9
    x8 x7 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Demandedness._case_9" [show x11, show x9, show x8, show x7, show
    x2, show x12] info)
  _ -> failCons cd (consFail "Analysis.Demandedness._case_9" (showCons x12))

d_C__case_8 :: FlatCurry.Curry_Types.C_Rule -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Int
d_C__case_8 x7 x2 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_C_daFuncRule x2 x7 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x7 x2 l cd cs)
    (d_C__case_8 x7 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x7 x2
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_8 x7 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Demandedness._case_8" [show x7, show x2, show x8] info)
  _ -> failCons cd (consFail "Analysis.Demandedness._case_8" (showCons x8))

d_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)) -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_BranchExpr -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_DemandDomain
d_C__case_3 x3 x16 x1 x17 x18 cd cs = case x18 of
  Curry_Prelude.C_True -> C_Bot
  Curry_Prelude.C_False -> Curry_Prelude.d_C_foldr (acceptCs id d_C_lub) C_Bot
    (Curry_Prelude.d_C_map
    (d_OP_daFuncRule_dot_absEvalExpr_dot_26_dot_absEvalBranch_dot_49 x3 x1) x17
    cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x3 x16 x1 x17 l
    cd cs) (d_C__case_3 x3 x16 x1 x17 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x3
    x16 x1 x17 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x3 x16
    x1 x17 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Demandedness._case_3" [show x3, show x16, show x1, show x17, show
    x18] info)
  _ -> failCons cd (consFail "Analysis.Demandedness._case_3" (showCons x18))

d_C__case_6 :: FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)) -> Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> C_DemandDomain
d_C__case_6 x6 x7 x1 x3 x8 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> d_C__case_5 x7 x1 x3 x8
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x7 (Curry_Prelude.OP_Tuple2 (d_C_prelude cd cs) (Curry_Prelude.toCurryString
    "failed")) cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_4 (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x6 x7 x1 x3 x8
    l cd cs) (d_C__case_6 x6 x7 x1 x3 x8 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x6 x7
    x1 x3 x8 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x6 x7 x1
    x3 x8 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Demandedness._case_6" [show x6, show x7, show x1, show x3, show x8
    , show x9] info)
  _ -> failCons cd (consFail "Analysis.Demandedness._case_6" (showCons x9))

d_C__case_4 :: Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_DemandDomain
d_C__case_4 x1 cd cs = case x1 of
  Curry_Prelude.C_True -> C_Top
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 l cd cs)
    (d_C__case_4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 z cd
    cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Demandedness._case_4" [show x1] info)
  _ -> failCons cd (consFail "Analysis.Demandedness._case_4" (showCons x1))

d_C__case_5 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> C_DemandDomain
d_C__case_5 x7 x1 x3 x8 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> C_Bot
  Curry_Prelude.C_False -> Curry_Prelude.d_C_maybe (Curry_Prelude.d_OP_dollar
    Curry_Prelude.d_C_error (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Abstract value of ")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    cd cs) x7 cd cs) (Curry_Prelude.toCurryString " not found!") cd cs) cd cs)
    cd cs) (d_OP_daFuncRule_dot_absEvalExpr_dot_26_dot_uscore_hash_lambda1 x8 x3
    x1) (Curry_Prelude.d_C_lookup
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
    x7 x1 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x7 x1 x3 x8 l
    cd cs) (d_C__case_5 x7 x1 x3 x8 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x7 x1
    x3 x8 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x7 x1 x3
    x8 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Demandedness._case_5" [show x7, show x1, show x3, show x8, show
    x9] info)
  _ -> failCons cd (consFail "Analysis.Demandedness._case_5" (showCons x9))

d_C__case_7 :: Curry_Prelude.OP_List Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_DemandDomain
d_C__case_7 x3 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> C_Bot
  Curry_Prelude.C_False -> C_Top
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x3 x4 l cd cs)
    (d_C__case_7 x3 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x3 x4
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_7 x3 x4 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Demandedness._case_7" [show x3, show x4, show x5] info)
  _ -> failCons cd (consFail "Analysis.Demandedness._case_7" (showCons x5))

d_C__case_2 :: Curry_Prelude.OP_List Curry_Prelude.C_Int -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> C_DemandDomain
d_C__case_2 x6 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> C_Top
  Curry_Prelude.C_False -> C_Bot
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x6 l cd cs)
    (d_C__case_2 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x6 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x6 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Demandedness._case_2" [show x6, show x7] info)
  _ -> failCons cd (consFail "Analysis.Demandedness._case_2" (showCons x7))

d_C__case_1 :: Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_Expr) -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int
d_C__case_1 x3 x1 x5 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let x8 = d_OP_daFuncRule_dot_absEvalExpr_dot_26
                                         x1 x7 x3 cd cs
    in d_C__case_0 x8 x3 x5 x1 x6
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Demandedness_dot_DemandDomain_hash
    x8 C_Bot cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_1 x3 x1 x5 l
    cd cs) (d_C__case_1 x3 x1 x5 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_1 x3
    x1 x5 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_1 x3 x1
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Demandedness._case_1" [show x3, show x1, show x5, show x4] info)
  _ -> failCons cd (consFail "Analysis.Demandedness._case_1" (showCons x4))

d_C__case_0 :: C_DemandDomain -> Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_Expr) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Int)) -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int
d_C__case_0 x8 x3 x5 x1 x6 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> d_OP_daFuncRule_dot_absEvalBindings_dot_26 x1 x5
    (Curry_Prelude.OP_Cons x6 x3) cd cs
  Curry_Prelude.C_False -> d_OP_daFuncRule_dot_absEvalBindings_dot_26 x1 x5 x3
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x8 x3 x5 x1 x6
    l cd cs) (d_C__case_0 x8 x3 x5 x1 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x8 x3
    x5 x1 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x8 x3 x5
    x1 x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Demandedness._case_0" [show x8, show x3, show x5, show x1, show x6
    , show x9] info)
  _ -> failCons cd (consFail "Analysis.Demandedness._case_0" (showCons x9))

