{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_Combinatorial
  ( nd_C_permute
  , nd_C_subset
  , nd_C_allSubsets
  , nd_C_splitSet
  , nd_C_sizedSubset
  , nd_C_partition )
  where

import Basics
import qualified Control.Search.Curry_SetFunctions
import qualified Data.Curry_List
import qualified Curry_Prelude
import qualified Test.Curry_Prop
import qualified Test.Prop.Curry_Types


nd_C_permute :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_permute x1 s cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_OP_permute_dot_ndinsert_dot_4 x2 (nd_C_permute x3
    s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_permute l s cd cs)
    (nd_C_permute r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_permute z s
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_permute e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Combinatorial.permute" [show x1] info)
  _ -> failCons cd (consFail "Combinatorial.permute" (showCons x1))

nd_OP_permute_dot_ndinsert_dot_4 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_OP_permute_dot_ndinsert_dot_4 x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` choice (nd_C__case_1 x1 x2 s0 cd cs)
  (Curry_Prelude.OP_Cons x1 x2) s1 cd cs))

nd_C_permute1234 :: IDSupply -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
nd_C_permute1234 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Test.Curry_Prop.nd_OP_tilde_gt (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)))
  (nd_C_permute (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1))
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (2)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (3)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (4))
  Curry_Prelude.OP_List)))) s0 cd cs) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (1)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (3))
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (4)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (2)) Curry_Prelude.OP_List)))) s1 cd cs))

nd_C_permLength :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> IDSupply -> Cover -> ConstStore -> Test.Prop.Curry_Types.C_Prop
nd_C_permLength x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Test.Curry_Prop.nd_OP_lt_tilde_gt (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash)
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)
  (Curry_Prelude.d_C_length (nd_C_permute x1 s0 cd cs) cd cs)
  (Curry_Prelude.d_C_length x1 cd cs) s1 cd cs))

nd_C_permElems :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
nd_C_permElems x1 x2 x3 s cd cs = let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s2 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Test.Curry_Prop.nd_OP_lt_tilde_gt x1
  x2 (let s1 = leftSupply s2
          s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_anyOf (nd_C_permute x3 s0 cd cs) s1
  cd cs)) (Curry_Prelude.nd_C_anyOf x3 s3 cd cs) s4 cd cs))))

nd_C_subset :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_subset x1 s cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` choice (Curry_Prelude.OP_Cons x2
    (nd_C_subset x3 s0 cd cs)) (nd_C_subset x3 s1 cd cs) s2 cd cs))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_subset l s cd cs)
    (nd_C_subset r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_subset z s
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_subset e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Combinatorial.subset" [show x1] info)
  _ -> failCons cd (consFail "Combinatorial.subset" (showCons x1))

nd_C_subset1234 :: IDSupply -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
nd_C_subset1234 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Test.Curry_Prop.nd_OP_tilde_gt (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)))
  (nd_C_subset (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1))
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (2)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (3)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (4))
  Curry_Prelude.OP_List)))) s0 cd cs) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (1)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (3))
  Curry_Prelude.OP_List)) s1 cd cs))

nd_C_subset123 :: IDSupply -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
nd_C_subset123 s cd cs = let s15 = s
  in s15 `seq` (let s14 = leftSupply s15
                    s16 = rightSupply s15
                    s0 = leftSupply s16
                    s13 = rightSupply s16
  in s14 `seq` (s16 `seq` (s0 `seq` (s13 `seq` Test.Curry_Prop.nd_OP_lt_tilde_gt
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)))
  (nd_C_subset (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1))
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (2)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (3)) Curry_Prelude.OP_List))) s0 cd cs)
  (let s12 = leftSupply s13
       s11 = rightSupply s13
  in s12 `seq` (s11 `seq` Curry_Prelude.nd_OP_qmark (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (1)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (2))
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (3)) Curry_Prelude.OP_List)))
  (let s10 = leftSupply s11
       s9 = rightSupply s11
  in s10 `seq` (s9 `seq` Curry_Prelude.nd_OP_qmark (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (1)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (2))
  Curry_Prelude.OP_List)) (let s8 = leftSupply s9
                               s7 = rightSupply s9
  in s8 `seq` (s7 `seq` Curry_Prelude.nd_OP_qmark (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (1)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (3))
  Curry_Prelude.OP_List)) (let s6 = leftSupply s7
                               s5 = rightSupply s7
  in s6 `seq` (s5 `seq` Curry_Prelude.nd_OP_qmark (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (1)) Curry_Prelude.OP_List) (let s4 = leftSupply s5
                                                        s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_OP_qmark (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (2)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (3))
  Curry_Prelude.OP_List)) (let s2 = leftSupply s3
                               s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_OP_qmark (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (2)) Curry_Prelude.OP_List) (Curry_Prelude.nd_OP_qmark
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (3)) Curry_Prelude.OP_List)
  Curry_Prelude.OP_List s1 cd cs) s2 cd cs)) s4 cd cs)) s6 cd cs)) s8 cd cs))
  s10 cd cs)) s12 cd cs)) s14 cd cs))))

nd_C_subsetElems :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
nd_C_subsetElems x1 x2 x3 s cd cs = let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s2 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Test.Curry_Prop.nd_OP_lt_tilde x1 x2
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_anyOf (nd_C_subset x3 s0 cd cs) s1 cd
  cs)) (Curry_Prelude.nd_C_anyOf x3 s3 cd cs) s4 cd cs))))

nd_C_allSubsets :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
nd_C_allSubsets x1 x2 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Control.Search.Curry_SetFunctions.nd_C_sortValues (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_lbracket_rbracket_hash_0_hash_hash
  x1)) s0 cd cs) (Control.Search.Curry_SetFunctions.nd_C_set1 (wrapNX id
  nd_C_subset) x2 s1 cd cs) s2 cd cs))))

nd_C_allSubsets123 :: IDSupply -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
nd_C_allSubsets123 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Test.Curry_Prop.nd_OP_minus_eq_minus (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash)))))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)))))
  (nd_C_allSubsets (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash)
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (2)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (3))
  Curry_Prelude.OP_List))) s0 cd cs) (Curry_Prelude.OP_Cons
  Curry_Prelude.OP_List (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (1)) Curry_Prelude.OP_List) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (2)) Curry_Prelude.OP_List)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (2)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (3))
  Curry_Prelude.OP_List))) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (1)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (3))
  Curry_Prelude.OP_List)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (2)) Curry_Prelude.OP_List) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (2)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (3)) Curry_Prelude.OP_List)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (3)) Curry_Prelude.OP_List)
  Curry_Prelude.OP_List)))))))) s1 cd cs))

nd_C_splitSet :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0)
nd_C_splitSet x1 s cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` (let x4 = nd_C_splitSet x3 s0 cd cs
                               x5 = d_OP_splitSet_dot_uscore_hash_selFP2_hash_u
                                 x4 cd cs
                               x6 = d_OP_splitSet_dot_uscore_hash_selFP3_hash_v
                                 x4 cd cs
    in Curry_Prelude.nd_OP_qmark (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons
    x2 x5) x6) (Curry_Prelude.OP_Tuple2 x5 (Curry_Prelude.OP_Cons x2 x6)) s1 cd
    cs)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_splitSet l s cd cs)
    (nd_C_splitSet r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_splitSet z
    s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_splitSet e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Combinatorial.splitSet" [show x1] info)
  _ -> failCons cd (consFail "Combinatorial.splitSet" (showCons x1))

d_OP_splitSet_dot_uscore_hash_selFP2_hash_u :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_splitSet_dot_uscore_hash_selFP2_hash_u x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_splitSet_dot_uscore_hash_selFP2_hash_u l cd cs)
    (d_OP_splitSet_dot_uscore_hash_selFP2_hash_u r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_splitSet_dot_uscore_hash_selFP2_hash_u z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_splitSet_dot_uscore_hash_selFP2_hash_u e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Combinatorial.splitSet._#selFP2#u" [show x1] info)
  _ -> failCons cd (consFail "Combinatorial.splitSet._#selFP2#u" (showCons x1))

d_OP_splitSet_dot_uscore_hash_selFP3_hash_v :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_splitSet_dot_uscore_hash_selFP3_hash_v x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_splitSet_dot_uscore_hash_selFP3_hash_v l cd cs)
    (d_OP_splitSet_dot_uscore_hash_selFP3_hash_v r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_splitSet_dot_uscore_hash_selFP3_hash_v z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_splitSet_dot_uscore_hash_selFP3_hash_v e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Combinatorial.splitSet._#selFP3#v" [show x1] info)
  _ -> failCons cd (consFail "Combinatorial.splitSet._#selFP3#v" (showCons x1))

nd_C_splitSet1234 :: IDSupply -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
nd_C_splitSet1234 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Test.Curry_Prop.nd_OP_tilde_gt (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash)))))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)))))
  (nd_C_splitSet (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1))
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (2)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (3)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (4))
  Curry_Prelude.OP_List)))) s0 cd cs) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (3)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (4))
  Curry_Prelude.OP_List))) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (2))
  Curry_Prelude.OP_List)) s1 cd cs))

nd_C_splitSetLengths :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
nd_C_splitSetLengths x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Test.Curry_Prop.nd_OP_lt_tilde_gt (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash)
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)
  (d_OP_splitSetLengths_dot_uscore_hash_lambda1 (nd_C_splitSet x1 s0 cd cs) cd
  cs) (Curry_Prelude.d_C_length x1 cd cs) s1 cd cs))

d_OP_splitSetLengths_dot_uscore_hash_lambda1 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_OP_splitSetLengths_dot_uscore_hash_lambda1 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_C_length x2 cd cs) (Curry_Prelude.d_C_length x3 cd cs) cd
    cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_splitSetLengths_dot_uscore_hash_lambda1 l cd cs)
    (d_OP_splitSetLengths_dot_uscore_hash_lambda1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_splitSetLengths_dot_uscore_hash_lambda1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_splitSetLengths_dot_uscore_hash_lambda1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Combinatorial.splitSetLengths._#lambda1" [show x1] info)
  _ -> failCons cd (consFail "Combinatorial.splitSetLengths._#lambda1" (showCons
    x1))

nd_C_splitSetElems :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
nd_C_splitSetElems x1 x2 x3 s cd cs = let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s2 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Test.Curry_Prop.nd_OP_lt_tilde_gt x1
  x2 (let s1 = leftSupply s2
          s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_splitSetElems_dot_uscore_hash_lambda2
  (nd_C_splitSet x3 s0 cd cs) s1 cd cs)) (Curry_Prelude.nd_C_anyOf x3 s3 cd cs)
  s4 cd cs))))

nd_OP_splitSetElems_dot_uscore_hash_lambda2 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0) -> IDSupply -> Cover -> ConstStore -> t0
nd_OP_splitSetElems_dot_uscore_hash_lambda2 x1 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_OP_qmark
    (Curry_Prelude.nd_C_anyOf x2 s0 cd cs) (Curry_Prelude.nd_C_anyOf x3 s1 cd
    cs) s2 cd cs))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_splitSetElems_dot_uscore_hash_lambda2 l s cd cs)
    (nd_OP_splitSetElems_dot_uscore_hash_lambda2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_splitSetElems_dot_uscore_hash_lambda2 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_splitSetElems_dot_uscore_hash_lambda2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Combinatorial.splitSetElems._#lambda2" [show x1] info)
  _ -> failCons cd (consFail "Combinatorial.splitSetElems._#lambda2" (showCons
    x1))

nd_C_sizedSubset :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C_sizedSubset x1 x2 s cd cs = let s0 = s
  in s0 `seq` nd_C__case_0 x1 x2
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  x1 (Curry_Prelude.C_Int (0)) cd cs) s0 cd cs

nd_OP_sizedSubset_dot_aux_dot_47 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
nd_OP_sizedSubset_dot_aux_dot_47 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_OP_qmark
    (Curry_Prelude.OP_Cons x3 (nd_C_sizedSubset
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 (Curry_Prelude.C_Int (1)) cd cs) x4 s0 cd cs)) (nd_C_sizedSubset x1 x4 s1
    cd cs) s2 cd cs))))
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (nd_OP_sizedSubset_dot_aux_dot_47 x1 l s cd cs)
    (nd_OP_sizedSubset_dot_aux_dot_47 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_OP_sizedSubset_dot_aux_dot_47 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    nd_OP_sizedSubset_dot_aux_dot_47 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Combinatorial.sizedSubset.aux.47" [show x1, show x2] info)
  _ -> failCons cd (consFail "Combinatorial.sizedSubset.aux.47" (showCons x2))

d_C_sizedSubset'pre :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_sizedSubset'pre x1 x2 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) x1 cd cs) (Curry_Prelude.C_Int (0)) cd cs

nd_C_sizedSubsetLength :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Test.Prop.Curry_Types.C_Prop
nd_C_sizedSubsetLength x1 x2 s cd cs = let s10 = s
  in s10 `seq` (let s6 = leftSupply s10
                    s9 = rightSupply s10
  in s6 `seq` (s9 `seq` Test.Curry_Prop.d_OP_eq_eq_gt (let s2 = leftSupply s6
                                                           s5 = rightSupply s6
  in s2 `seq` (s5 `seq` Curry_Prelude.d_OP_amp_amp (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
  (wrapDX (wrapDX id)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs)) x1 s0 cd cs) (Curry_Prelude.C_Int (0)) s1 cd cs)) (let s4 = leftSupply
                                                                   s5
                                                                 s3 = rightSupply
                                                                   s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
  (wrapDX (wrapDX id)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs)) (Curry_Prelude.d_C_length x2 cd cs) s3 cd cs) x1 s4 cd cs)) cd cs))
  (let s8 = leftSupply s9
       s7 = rightSupply s9
  in s8 `seq` (s7 `seq` Test.Curry_Prop.nd_OP_lt_tilde_gt (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash)
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)
  (Curry_Prelude.d_C_length (nd_C_sizedSubset x1 x2 s7 cd cs) cd cs) x1 s8 cd
  cs)) cd cs))

nd_C_sizedSubsetLengthTooSmall :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Test.Prop.Curry_Types.C_Prop
nd_C_sizedSubsetLengthTooSmall x1 x2 x3 s cd cs = let s10 = s
  in s10 `seq` (let s6 = leftSupply s10
                    s9 = rightSupply s10
  in s6 `seq` (s9 `seq` Test.Curry_Prop.d_OP_eq_eq_gt (let s2 = leftSupply s6
                                                           s5 = rightSupply s6
  in s2 `seq` (s5 `seq` Curry_Prelude.d_OP_amp_amp (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
  (wrapDX (wrapDX id)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs)) x2 s0 cd cs) (Curry_Prelude.C_Int (0)) s1 cd cs)) (let s4 = leftSupply
                                                                   s5
                                                                 s3 = rightSupply
                                                                   s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
  (wrapDX (wrapDX id)
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs)) (Curry_Prelude.d_C_length x3 cd cs) s3 cd cs) x2 s4 cd cs)) cd cs))
  (let s8 = leftSupply s9
       s7 = rightSupply s9
  in s8 `seq` (s7 `seq` Test.Curry_Prop.nd_C_failing (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  x1)) (nd_C_sizedSubset x2 x3 s7 cd cs) s8 cd cs)) cd cs))

nd_C_partition :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)
nd_C_partition x1 s cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_OP_partition_dot_insert_dot_60 x2 (nd_C_partition
    x3 s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_partition l s cd cs)
    (nd_C_partition r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_partition z
    s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_partition e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Combinatorial.partition" [show x1] info)
  _ -> failCons cd (consFail "Combinatorial.partition" (showCons x1))

nd_OP_partition_dot_insert_dot_60 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
nd_OP_partition_dot_insert_dot_60 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons x1
    Curry_Prelude.OP_List) Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_qmark (Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Cons x1 x3) x4) (Curry_Prelude.OP_Cons x3
    (nd_OP_partition_dot_insert_dot_60 x1 x4 s0 cd cs)) s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (nd_OP_partition_dot_insert_dot_60 x1 l s cd cs)
    (nd_OP_partition_dot_insert_dot_60 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_OP_partition_dot_insert_dot_60 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    nd_OP_partition_dot_insert_dot_60 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Combinatorial.partition.insert.60" [show x1, show x2] info)
  _ -> failCons cd (consFail "Combinatorial.partition.insert.60" (showCons x2))

nd_C_partition1234 :: IDSupply -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
nd_C_partition1234 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Test.Curry_Prop.nd_OP_tilde_gt (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash)))))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)))))
  (nd_C_partition (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1))
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (2)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (3)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (4))
  Curry_Prelude.OP_List)))) s0 cd cs) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (4)) Curry_Prelude.OP_List)
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (2))
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (3)) Curry_Prelude.OP_List))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1))
  Curry_Prelude.OP_List) Curry_Prelude.OP_List))) s1 cd cs))

nd_C_partition123 :: IDSupply -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
nd_C_partition123 s cd cs = let s9 = s
  in s9 `seq` (let s8 = leftSupply s9
                   s10 = rightSupply s9
                   s0 = leftSupply s10
                   s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s0 `seq` (s7 `seq` Test.Curry_Prop.nd_OP_lt_tilde_gt
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash)))))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)))))
  (nd_C_partition (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1))
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (2)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (3)) Curry_Prelude.OP_List))) s0 cd cs)
  (let s6 = leftSupply s7
       s5 = rightSupply s7
  in s6 `seq` (s5 `seq` Curry_Prelude.nd_OP_qmark (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (2)) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (3))
  Curry_Prelude.OP_List))) Curry_Prelude.OP_List) (let s4 = leftSupply s5
                                                       s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_OP_qmark (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (2)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (3)) Curry_Prelude.OP_List)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1)) Curry_Prelude.OP_List)
  Curry_Prelude.OP_List)) (let s2 = leftSupply s3
                               s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_OP_qmark (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (3)) Curry_Prelude.OP_List)) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (2)) Curry_Prelude.OP_List)
  Curry_Prelude.OP_List)) (Curry_Prelude.nd_OP_qmark (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (3)) Curry_Prelude.OP_List)
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1))
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (2)) Curry_Prelude.OP_List))
  Curry_Prelude.OP_List)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Int (3)) Curry_Prelude.OP_List) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (2)) Curry_Prelude.OP_List)
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons (Curry_Prelude.C_Int (1))
  Curry_Prelude.OP_List) Curry_Prelude.OP_List))) s1 cd cs) s2 cd cs)) s4 cd
  cs)) s6 cd cs)) s8 cd cs))))

nd_C_partitionLengths :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
nd_C_partitionLengths x1 s cd cs = let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Test.Curry_Prop.nd_OP_lt_tilde_gt (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash)
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)
  (let s3 = leftSupply s4
       s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Data.Curry_List.nd_C_sum (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash)
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_map (wrapDX id
  Curry_Prelude.d_C_length) (nd_C_partition x1 s0 cd cs) s1 cd cs)) s3 cd cs))
  (Curry_Prelude.d_C_length x1 cd cs) s5 cd cs))

nd_C_partitionElems :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
nd_C_partitionElems x1 x2 x3 s cd cs = let s7 = s
  in s7 `seq` (let s6 = leftSupply s7
                   s8 = rightSupply s7
                   s4 = leftSupply s8
                   s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s4 `seq` (s5 `seq` Test.Curry_Prop.nd_OP_lt_tilde_gt x1
  x2 (let s3 = leftSupply s4
          s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_anyOf (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_map (wrapNX id
  Curry_Prelude.nd_C_anyOf) (nd_C_partition x3 s0 cd cs) s1 cd cs)) s3 cd cs))
  (Curry_Prelude.nd_C_anyOf x3 s5 cd cs) s6 cd cs))))

nd_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C__case_1 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons x3 (nd_OP_permute_dot_ndinsert_dot_4 x1 x4
    s0 cd cs)
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_1 x1 l s cd cs)
    (nd_C__case_1 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_1 x1
    z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_1 x1 e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Combinatorial._case_1" [show x1, show x2] info)
  _ -> failCons cd (consFail "Combinatorial._case_1" (showCons x2))

nd_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
nd_C__case_0 x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_OP_sizedSubset_dot_aux_dot_47 x1 x2 s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_0 x1 x2 l s cd
    cs) (nd_C__case_0 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_0 x1
    x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_0 x1 x2 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Combinatorial._case_0" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Combinatorial._case_0" (showCons x3))

