{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Text.Curry_CSV
  ( d_C_writeCSVFile
  , d_C_showCSV
  , d_C_readCSVFile
  , d_C_readCSVFileWithDelims
  , d_C_readCSV
  , d_C_readCSVWithDelims )
  where

import Basics
import qualified Data.Curry_List
import qualified Curry_Prelude


d_C_writeCSVFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_C_writeCSVFile x1 x2 cd cs = Curry_Prelude.d_C_writeFile x1 (d_C_showCSV x2 cd
  cs) cd cs

d_C_showCSV :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showCSV x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap
  d_C_showCSVLine cd cs) x1 cd cs

d_C_showCSVLine :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_showCSVLine x1 cd cs = Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_concat cd cs) (Data.Curry_List.d_C_intersperse
  (Curry_Prelude.toCurryString ",") (Curry_Prelude.d_C_map
  d_OP_showCSVLine_dot_convert_dot_6 x1 cd cs) cd cs) cd cs)
  (Curry_Prelude.toCurryString "\n") cd cs

d_OP_showCSVLine_dot_convert_dot_6 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showCSVLine_dot_convert_dot_6 x1 cd cs = d_C__case_8 x1
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_any
  d_OP_showCSVLine_dot_convert_dot_6_dot_uscore_hash_lambda1 cd cs) x1 cd cs) cd
  cs

d_OP_showCSVLine_dot_convert_dot_6_dot_uscore_hash_lambda1 :: Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_showCSVLine_dot_convert_dot_6_dot_uscore_hash_lambda1 x1 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 cd cs) (Curry_Prelude.toCurryString "\",;:\n") cd cs

d_OP_showCSVLine_dot_convert_dot_6_dot_uscore_hash_lambda2 :: Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showCSVLine_dot_convert_dot_6_dot_uscore_hash_lambda2 x1 cd cs =
  d_C__case_7 x1
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.C_Char '"'#) cd cs) cd cs

d_C_readCSVFile :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))
d_C_readCSVFile cd cs = d_C_readCSVFileWithDelims (Curry_Prelude.toCurryString
  ",")

d_C_readCSVFileWithDelims :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_C_readCSVFileWithDelims x1 x2 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_readFile x2 cd cs) cd cs)
  (d_OP_readCSVFileWithDelims_dot_uscore_hash_lambda4 x1) cd cs

d_OP_readCSVFileWithDelims_dot_uscore_hash_lambda4 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_OP_readCSVFileWithDelims_dot_uscore_hash_lambda4 x1 x2 cd cs = let x3 = x2
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_readCSVWithDelims x1 x3 cd cs) cd cs

d_C_readCSV :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_readCSV cd cs = d_C_readCSVWithDelims (Curry_Prelude.toCurryString ",")

d_C_readCSVWithDelims :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_readCSVWithDelims x1 x2 cd cs = Curry_Prelude.d_C_map (d_C_components x1)
  (Curry_Prelude.d_C_lines x2 cd cs) cd cs

d_C_components :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_components x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons Curry_Prelude.OP_List
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> let x5 = Curry_Prelude.d_C_error
                                       (Curry_Prelude.toCurryString
                                       "Missing closing delimiter in CSV record!")
                                       cd cs
    in d_C__case_6 x3 x4 x1 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.C_Char '"'#) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_components x1 l cd cs)
    (d_C_components x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_components
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_components x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.CSV.components" [show x1, show x2] info)
  _ -> failCons cd (consFail "Text.CSV.components" (showCons x2))

d_OP_components_dot_breakString_dot_24 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_components_dot_breakString_dot_24 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> x2
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_4 x4 x1 x2 x5 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_components_dot_breakString_dot_24 x1 x2 l cd cs)
    (d_OP_components_dot_breakString_dot_24 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_components_dot_breakString_dot_24 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_components_dot_breakString_dot_24 x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.CSV.components.breakString.24" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Text.CSV.components.breakString.24" (showCons x3))

d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP2_hash_b :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP2_hash_b x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> x2
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP2_hash_b l cd
    cs) (d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP2_hash_b r
    cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP2_hash_b z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP2_hash_b e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.CSV.components.breakString.24._#selFP2#b" [show x1] info)
  _ -> failCons cd (consFail "Text.CSV.components.breakString.24._#selFP2#b"
    (showCons x1))

d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP3_hash_bs :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP3_hash_bs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> x3
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP3_hash_bs l cd
    cs) (d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP3_hash_bs r
    cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP3_hash_bs z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP3_hash_bs e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.CSV.components.breakString.24._#selFP3#bs" [show x1] info)
  _ -> failCons cd (consFail "Text.CSV.components.breakString.24._#selFP3#bs"
    (showCons x1))

d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP5_hash_b :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP5_hash_b x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> x2
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP5_hash_b l cd
    cs) (d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP5_hash_b r
    cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP5_hash_b z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP5_hash_b e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.CSV.components.breakString.24._#selFP5#b" [show x1] info)
  _ -> failCons cd (consFail "Text.CSV.components.breakString.24._#selFP5#b"
    (showCons x1))

d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP6_hash_bs :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP6_hash_bs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> x3
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP6_hash_bs l cd
    cs) (d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP6_hash_bs r
    cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP6_hash_bs z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP6_hash_bs e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.CSV.components.breakString.24._#selFP6#bs" [show x1] info)
  _ -> failCons cd (consFail "Text.CSV.components.breakString.24._#selFP6#bs"
    (showCons x1))

d_OP_components_dot_uscore_hash_selFP8_hash_e :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_components_dot_uscore_hash_selFP8_hash_e x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_components_dot_uscore_hash_selFP8_hash_e l cd cs)
    (d_OP_components_dot_uscore_hash_selFP8_hash_e r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_components_dot_uscore_hash_selFP8_hash_e z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_components_dot_uscore_hash_selFP8_hash_e e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.CSV.components._#selFP8#e" [show x1] info)
  _ -> failCons cd (consFail "Text.CSV.components._#selFP8#e" (showCons x1))

d_OP_components_dot_uscore_hash_selFP9_hash_s :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_components_dot_uscore_hash_selFP9_hash_s x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_components_dot_uscore_hash_selFP9_hash_s l cd cs)
    (d_OP_components_dot_uscore_hash_selFP9_hash_s r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_components_dot_uscore_hash_selFP9_hash_s z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_components_dot_uscore_hash_selFP9_hash_s e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.CSV.components._#selFP9#s" [show x1] info)
  _ -> failCons cd (consFail "Text.CSV.components._#selFP9#s" (showCons x1))

d_C__case_8 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_8 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '"'#)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_concatMap
    d_OP_showCSVLine_dot_convert_dot_6_dot_uscore_hash_lambda2 cd cs) x1 cd cs)
    (Curry_Prelude.toCurryString "\"") cd cs)
  Curry_Prelude.C_False -> x1
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x1 l cd cs)
    (d_C__case_8 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_8 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Text.CSV._case_8"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Text.CSV._case_8" (showCons x2))

d_C__case_7 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_7 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x1 (Curry_Prelude.OP_Cons x1
    Curry_Prelude.OP_List)
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x1 l cd cs)
    (d_C__case_7 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_7 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Text.CSV._case_7"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Text.CSV._case_7" (showCons x2))

d_C__case_6 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_6 x3 x4 x1 x5 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> d_OP_components_dot_breakString_dot_24 x1 x5 x4 cd cs
  Curry_Prelude.C_False -> let x6 = Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_break
                                 (Curry_Prelude.d_C_flip (Curry_Prelude.d_C_elem
                                 Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                 x1) cd cs) (Curry_Prelude.OP_Cons x3 x4) cd cs
                               x7 = d_OP_components_dot_uscore_hash_selFP8_hash_e
                                 x6 cd cs
                               x8 = d_OP_components_dot_uscore_hash_selFP9_hash_s
                                 x6 cd cs
    in Curry_Prelude.OP_Cons x7 (d_C__case_5 x8 x1 (Curry_Prelude.d_C_null x8 cd
    cs) cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x3 x4 x1 x5 l
    cd cs) (d_C__case_6 x3 x4 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x3 x4
    x1 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x3 x4 x1
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Text.CSV._case_6"
    [show x3, show x4, show x1, show x5, show x9] info)
  _ -> failCons cd (consFail "Text.CSV._case_6" (showCons x9))

d_C__case_5 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_5 x8 x1 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> d_C_components x1 (Curry_Prelude.d_C_tail x8 cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x8 x1 l cd cs)
    (d_C__case_5 x8 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x8 x1
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x8 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Text.CSV._case_5"
    [show x8, show x1, show x9] info)
  _ -> failCons cd (consFail "Text.CSV._case_5" (showCons x9))

d_C__case_4 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_4 x4 x1 x2 x5 cd cs = case x5 of
  Curry_Prelude.OP_List -> d_C__case_3 x4 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x4 (Curry_Prelude.C_Char '"'#) cd cs) cd cs
  Curry_Prelude.OP_Cons x6 x7 -> d_C__case_2 x6 x4 x1 x7 x2
    (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x4 (Curry_Prelude.C_Char '"'#) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x6 (Curry_Prelude.C_Char '"'#) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_4 x4 x1 x2 l cd
    cs) (d_C__case_4 x4 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_4 x4
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_4 x4 x1
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Text.CSV._case_4"
    [show x4, show x1, show x2, show x5] info)
  _ -> failCons cd (consFail "Text.CSV._case_4" (showCons x5))

d_C__case_2 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_2 x6 x4 x1 x7 x2 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> let x8 = d_OP_components_dot_breakString_dot_24 x1 x2
                                x7 cd cs
                              x9 = d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP2_hash_b
                                x8 cd cs
                              x10 = d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP3_hash_bs
                                x8 cd cs
    in Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons x4 x9) x10
  Curry_Prelude.C_False -> d_C__case_1 x1 x6 x4 x7 x2
    (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x4 (Curry_Prelude.C_Char '"'#) cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_elem
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x6 cd cs) x1 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x6 x4 x1 x7 x2
    l cd cs) (d_C__case_2 x6 x4 x1 x7 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x6 x4
    x1 x7 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x6 x4 x1
    x7 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Text.CSV._case_2"
    [show x6, show x4, show x1, show x7, show x2, show x11] info)
  _ -> failCons cd (consFail "Text.CSV._case_2" (showCons x11))

d_C__case_1 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_1 x1 x6 x4 x7 x2 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons Curry_Prelude.OP_List
    (d_C_components x1 x7 cd cs)
  Curry_Prelude.C_False -> d_C__case_0 x7 x6 x2 x1 x4
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x1 x6 x4 x7 x2
    l cd cs) (d_C__case_1 x1 x6 x4 x7 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x1 x6
    x4 x7 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x1 x6 x4
    x7 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Text.CSV._case_1"
    [show x1, show x6, show x4, show x7, show x2, show x8] info)
  _ -> failCons cd (consFail "Text.CSV._case_1" (showCons x8))

d_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_0 x7 x6 x2 x1 x4 x14 cd cs = case x14 of
  Curry_Prelude.C_True -> let x11 = d_OP_components_dot_breakString_dot_24 x1 x2
                                (Curry_Prelude.OP_Cons x6 x7) cd cs
                              x12 = d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP5_hash_b
                                x11 cd cs
                              x13 = d_OP_components_dot_breakString_dot_24_dot_uscore_hash_selFP6_hash_bs
                                x11 cd cs
    in Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons x4 x12) x13
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x7 x6 x2 x1 x4
    l cd cs) (d_C__case_0 x7 x6 x2 x1 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x7 x6
    x2 x1 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x7 x6 x2
    x1 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Text.CSV._case_0"
    [show x7, show x6, show x2, show x1, show x4, show x14] info)
  _ -> failCons cd (consFail "Text.CSV._case_0" (showCons x14))

d_C__case_3 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_3 x4 x2 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons Curry_Prelude.OP_List
    Curry_Prelude.OP_List
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x4 x2 l cd cs)
    (d_C__case_3 x4 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x4 x2
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x4 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Text.CSV._case_3"
    [show x4, show x2, show x5] info)
  _ -> failCons cd (consFail "Text.CSV._case_3" (showCons x5))

