{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Language.Curry.Curry_Resources
  ( d_C_curryHomeURL
  , d_C_masalaHomeURL
  , d_C_cpmHomeURL
  , d_C_curryPackagesURL
  , d_C_curryPackageBaseURL
  , d_C_curryPackageLatestURL
  , d_C_curryPackageURL
  , d_C_baseLibsURL
  , d_C_curryPackagesDocURL
  , d_C_curryPackageDocURL
  , d_C_currygleURL
  , d_C_curryWikiURL
  , d_C_pakcsURL
  , d_C_kics2URL
  , d_C_curry2goURL )
  where

import Basics
import qualified Curry_Prelude


d_C_curryHomeURL :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_curryHomeURL cd cs = Curry_Prelude.toCurryString "http://www.curry-lang.org"

d_C_masalaHomeURL :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_masalaHomeURL cd cs = Curry_Prelude.toCurryString
  "https://cpm.curry-lang.org/masala/"

d_C_cpmHomeURL :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_cpmHomeURL cd cs = Curry_Prelude.toCurryString
  "http://www.curry-lang.org/tools/cpm"

d_C_curryPackagesURL :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_curryPackagesURL cd cs = Curry_Prelude.toCurryString
  "https://cpm.curry-lang.org/"

d_C_curryPackageBaseURL :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_curryPackageBaseURL cd cs = Curry_Prelude.d_OP_plus_plus
  (d_C_curryPackagesURL cd cs) (Curry_Prelude.toCurryString "pkgs/") cd cs

d_C_curryPackageLatestURL :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_curryPackageLatestURL x1 cd cs = Curry_Prelude.d_OP_plus_plus
  (d_C_curryPackageBaseURL cd cs) (Curry_Prelude.d_OP_plus_plus x1
  (Curry_Prelude.toCurryString ".html") cd cs) cd cs

d_C_curryPackageURL :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_curryPackageURL x1 x2 cd cs = Curry_Prelude.d_OP_plus_plus
  (d_C_curryPackageBaseURL cd cs) (Curry_Prelude.d_OP_plus_plus x1
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "-")
  (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.toCurryString ".html") cd cs)
  cd cs) cd cs) cd cs

d_C_baseLibsURL :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_baseLibsURL cd cs = d_C_curryPackageLatestURL (Curry_Prelude.toCurryString
  "base") cd cs

d_C_curryPackagesDocURL :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_curryPackagesDocURL cd cs = Curry_Prelude.d_OP_plus_plus
  (d_C_curryPackagesURL cd cs) (Curry_Prelude.toCurryString "DOC/") cd cs

d_C_curryPackageDocURL :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_curryPackageDocURL x1 x2 cd cs = Curry_Prelude.d_OP_plus_plus
  (d_C_curryPackagesDocURL cd cs) (Curry_Prelude.d_OP_plus_plus x1
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "-") x2 cd cs) cd
  cs) cd cs

d_C_currygleURL :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_currygleURL cd cs = Curry_Prelude.toCurryString
  "https://www-ps.informatik.uni-kiel.de/kics2/currygle/"

d_C_curryWikiURL :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_curryWikiURL cd cs = Curry_Prelude.toCurryString
  "https://www-ps.informatik.uni-kiel.de/currywiki"

d_C_pakcsURL :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_pakcsURL cd cs = Curry_Prelude.toCurryString
  "https://www.curry-lang.org/pakcs/"

d_C_kics2URL :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_kics2URL cd cs = Curry_Prelude.toCurryString
  "https://www.curry-lang.org/kics2/"

d_C_curry2goURL :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_curry2goURL cd cs = Curry_Prelude.toCurryString
  "https://www.curry-lang.org/curry2go/"

