{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Language.Curry.Curry_CheckDetUsage
  ( d_C_containsDetOperations, d_C_checkDetUse )
  where

import Basics
import qualified AbstractCurry.Curry_Select
import qualified AbstractCurry.Curry_Types
import qualified Curry_Prelude


d_C_containsDetOperations :: AbstractCurry.Curry_Types.C_CurryProg -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C_containsDetOperations x1 cd cs = case x1 of
  AbstractCurry.Curry_Types.C_CurryProg x2 x3 x4 x5 x6 x7 x8 x9 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_any (Curry_Prelude.d_OP_dot
    d_OP_containsDetOperations_dot_detInTopLevelType_dot_9
    (Curry_Prelude.d_OP_dot AbstractCurry.Curry_Select.d_C_typeOfQualType
    AbstractCurry.Curry_Select.d_C_funcType cd cs) cd cs) cd cs) x8 cd cs
  AbstractCurry.Curry_Types.Choice_C_CurryProg d i l r -> narrow d i
    (d_C_containsDetOperations l cd cs) (d_C_containsDetOperations r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CurryProg d i xs -> narrows cs d i (\z ->
    d_C_containsDetOperations z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CurryProg d c e -> guardCons d c ((\x ->
    d_C_containsDetOperations e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CurryProg d info -> failCons d (traceFail
    "Language.Curry.CheckDetUsage.containsDetOperations" [show x1] info)
  _ -> failCons cd (consFail
    "Language.Curry.CheckDetUsage.containsDetOperations" (showCons x1))

d_OP_containsDetOperations_dot_detInTopLevelType_dot_9 :: AbstractCurry.Curry_Types.C_CTypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_containsDetOperations_dot_detInTopLevelType_dot_9 x1 cd cs = case x1 of
  AbstractCurry.Curry_Types.C_CTVar x2 -> Curry_Prelude.C_False
  AbstractCurry.Curry_Types.C_CTCons x3 -> Curry_Prelude.C_False
  AbstractCurry.Curry_Types.C_CFuncType x4 x5 -> d_OP_containsDetOperations_dot_detInTopLevelType_dot_9
    x5 cd cs
  AbstractCurry.Curry_Types.C_CTApply x6 x7 -> AbstractCurry.Curry_Types.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_AbstractCurry_dot_Types_dot_CTypeExpr_hash
    x6 (AbstractCurry.Curry_Types.C_CTCons (AbstractCurry.Curry_Types.d_C_pre
    (Curry_Prelude.toCurryString "DET") cd cs)) cd cs
  AbstractCurry.Curry_Types.Choice_C_CTypeExpr d i l r -> narrow d i
    (d_OP_containsDetOperations_dot_detInTopLevelType_dot_9 l cd cs)
    (d_OP_containsDetOperations_dot_detInTopLevelType_dot_9 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CTypeExpr d i xs -> narrows cs d i (\z ->
    d_OP_containsDetOperations_dot_detInTopLevelType_dot_9 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CTypeExpr d c e -> guardCons d c ((\x ->
    d_OP_containsDetOperations_dot_detInTopLevelType_dot_9 e cd x) $! addCs c
    cs)
  AbstractCurry.Curry_Types.Fail_C_CTypeExpr d info -> failCons d (traceFail
    "Language.Curry.CheckDetUsage.containsDetOperations.detInTopLevelType.9"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.Curry.CheckDetUsage.containsDetOperations.detInTopLevelType.9"
    (showCons x1))

d_C_checkDetUse :: AbstractCurry.Curry_Types.C_CurryProg -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_checkDetUse x1 cd cs = case x1 of
  AbstractCurry.Curry_Types.C_CurryProg x2 x3 x4 x5 x6 x7 x8 x9 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_concatMap (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_map
    d_OP_checkDetUse_dot_showDetError_dot_30) d_C_checkDetUseInFDecl cd cs) cd
    cs) x8 cd cs
  AbstractCurry.Curry_Types.Choice_C_CurryProg d i l r -> narrow d i
    (d_C_checkDetUse l cd cs) (d_C_checkDetUse r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CurryProg d i xs -> narrows cs d i (\z ->
    d_C_checkDetUse z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CurryProg d c e -> guardCons d c ((\x ->
    d_C_checkDetUse e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CurryProg d info -> failCons d (traceFail
    "Language.Curry.CheckDetUsage.checkDetUse" [show x1] info)
  _ -> failCons cd (consFail "Language.Curry.CheckDetUsage.checkDetUse"
    (showCons x1))

d_OP_checkDetUse_dot_showDetError_dot_30 :: forall t0 . (Curry_Prelude.Curry
  t0) => t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_checkDetUse_dot_showDetError_dot_30 x1 cd cs = Curry_Prelude.OP_Tuple2 x1
  (Curry_Prelude.toCurryString "wrong use of DET type synonym!")

d_C_checkDetUseInFDecl :: AbstractCurry.Curry_Types.C_CFuncDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_checkDetUseInFDecl x1 cd cs = case x1 of
  AbstractCurry.Curry_Types.C_CFunc x2 x3 x4 x5 x6 -> d_C__case_1 x6 x5 x2
    (Curry_Prelude.d_OP_bar_bar (d_C_checkDetInTopLevelType
    (AbstractCurry.Curry_Select.d_C_typeOfQualType x5 cd cs) cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_any d_C_detInRule cd cs) x6 cd
    cs) cd cs) cd cs
  AbstractCurry.Curry_Types.C_CmtFunc x7 x8 x9 x10 x11 x12 -> d_C_checkDetUseInFDecl
    (AbstractCurry.Curry_Types.C_CFunc x8 x9 x10 x11 x12) cd cs
  AbstractCurry.Curry_Types.Choice_C_CFuncDecl d i l r -> narrow d i
    (d_C_checkDetUseInFDecl l cd cs) (d_C_checkDetUseInFDecl r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CFuncDecl d i xs -> narrows cs d i (\z ->
    d_C_checkDetUseInFDecl z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CFuncDecl d c e -> guardCons d c ((\x ->
    d_C_checkDetUseInFDecl e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CFuncDecl d info -> failCons d (traceFail
    "Language.Curry.CheckDetUsage.checkDetUseInFDecl" [show x1] info)
  _ -> failCons cd (consFail "Language.Curry.CheckDetUsage.checkDetUseInFDecl"
    (showCons x1))

d_C_checkDetInTopLevelType :: AbstractCurry.Curry_Types.C_CTypeExpr -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C_checkDetInTopLevelType x1 cd cs = case x1 of
  AbstractCurry.Curry_Types.C_CTVar x2 -> Curry_Prelude.C_False
  AbstractCurry.Curry_Types.C_CTCons x3 -> Curry_Prelude.C_False
  AbstractCurry.Curry_Types.C_CFuncType x4 x5 -> Curry_Prelude.d_OP_bar_bar
    (d_C_detInTypeExpr x4 cd cs) (d_C_checkDetInTopLevelType x5 cd cs) cd cs
  AbstractCurry.Curry_Types.C_CTApply x6 x7 -> d_C_detInTypeExpr x7 cd cs
  AbstractCurry.Curry_Types.Choice_C_CTypeExpr d i l r -> narrow d i
    (d_C_checkDetInTopLevelType l cd cs) (d_C_checkDetInTopLevelType r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CTypeExpr d i xs -> narrows cs d i (\z ->
    d_C_checkDetInTopLevelType z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CTypeExpr d c e -> guardCons d c ((\x ->
    d_C_checkDetInTopLevelType e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CTypeExpr d info -> failCons d (traceFail
    "Language.Curry.CheckDetUsage.checkDetInTopLevelType" [show x1] info)
  _ -> failCons cd (consFail
    "Language.Curry.CheckDetUsage.checkDetInTopLevelType" (showCons x1))

d_C_detInTypeExpr :: AbstractCurry.Curry_Types.C_CTypeExpr -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C_detInTypeExpr x1 cd cs = case x1 of
  AbstractCurry.Curry_Types.C_CTVar x2 -> Curry_Prelude.C_False
  AbstractCurry.Curry_Types.C_CTCons x3 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (AbstractCurry.Curry_Types.d_C_pre (Curry_Prelude.toCurryString "DET") cd
    cs) cd cs
  AbstractCurry.Curry_Types.C_CFuncType x4 x5 -> Curry_Prelude.d_OP_bar_bar
    (d_C_detInTypeExpr x4 cd cs) (d_C_detInTypeExpr x5 cd cs) cd cs
  AbstractCurry.Curry_Types.C_CTApply x6 x7 -> Curry_Prelude.d_OP_bar_bar
    (d_C_detInTypeExpr x6 cd cs) (d_C_detInTypeExpr x7 cd cs) cd cs
  AbstractCurry.Curry_Types.Choice_C_CTypeExpr d i l r -> narrow d i
    (d_C_detInTypeExpr l cd cs) (d_C_detInTypeExpr r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CTypeExpr d i xs -> narrows cs d i (\z ->
    d_C_detInTypeExpr z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CTypeExpr d c e -> guardCons d c ((\x ->
    d_C_detInTypeExpr e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CTypeExpr d info -> failCons d (traceFail
    "Language.Curry.CheckDetUsage.detInTypeExpr" [show x1] info)
  _ -> failCons cd (consFail "Language.Curry.CheckDetUsage.detInTypeExpr"
    (showCons x1))

d_C_detInRule :: AbstractCurry.Curry_Types.C_CRule -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_detInRule x1 cd cs = case x1 of
  AbstractCurry.Curry_Types.C_CRule x2 x3 -> d_C_detInRhs x3 cd cs
  AbstractCurry.Curry_Types.Choice_C_CRule d i l r -> narrow d i (d_C_detInRule
    l cd cs) (d_C_detInRule r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CRule d i xs -> narrows cs d i (\z ->
    d_C_detInRule z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CRule d c e -> guardCons d c ((\x ->
    d_C_detInRule e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CRule d info -> failCons d (traceFail
    "Language.Curry.CheckDetUsage.detInRule" [show x1] info)
  _ -> failCons cd (consFail "Language.Curry.CheckDetUsage.detInRule" (showCons
    x1))

d_C_detInRhs :: AbstractCurry.Curry_Types.C_CRhs -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_detInRhs x1 cd cs = case x1 of
  AbstractCurry.Curry_Types.C_CSimpleRhs x2 x3 -> Curry_Prelude.d_OP_bar_bar
    (d_C_detInExp x2 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_any
    d_C_detInLocalDecl cd cs) x3 cd cs) cd cs
  AbstractCurry.Curry_Types.C_CGuardedRhs x4 x5 -> Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_any
    d_OP_detInRhs_dot_detInGuard_dot_66 cd cs) x4 cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_any d_C_detInLocalDecl cd cs) x5
    cd cs) cd cs
  AbstractCurry.Curry_Types.Choice_C_CRhs d i l r -> narrow d i (d_C_detInRhs l
    cd cs) (d_C_detInRhs r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CRhs d i xs -> narrows cs d i (\z ->
    d_C_detInRhs z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CRhs d c e -> guardCons d c ((\x ->
    d_C_detInRhs e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CRhs d info -> failCons d (traceFail
    "Language.Curry.CheckDetUsage.detInRhs" [show x1] info)
  _ -> failCons cd (consFail "Language.Curry.CheckDetUsage.detInRhs" (showCons
    x1))

d_OP_detInRhs_dot_detInGuard_dot_66 :: Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CExpr AbstractCurry.Curry_Types.C_CExpr -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_detInRhs_dot_detInGuard_dot_66 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_OP_bar_bar (d_C_detInExp x2
    cd cs) (d_C_detInExp x3 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_detInRhs_dot_detInGuard_dot_66 l cd cs)
    (d_OP_detInRhs_dot_detInGuard_dot_66 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_detInRhs_dot_detInGuard_dot_66 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_detInRhs_dot_detInGuard_dot_66 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.CheckDetUsage.detInRhs.detInGuard.66" [show x1] info)
  _ -> failCons cd (consFail
    "Language.Curry.CheckDetUsage.detInRhs.detInGuard.66" (showCons x1))

d_C_detInLocalDecl :: AbstractCurry.Curry_Types.C_CLocalDecl -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C_detInLocalDecl x1 cd cs = case x1 of
  AbstractCurry.Curry_Types.C_CLocalFunc x2 -> d_C__case_0 x2 cd cs
  AbstractCurry.Curry_Types.C_CLocalPat x14 x15 -> d_C_detInRhs x15 cd cs
  AbstractCurry.Curry_Types.C_CLocalVars x16 -> Curry_Prelude.C_False
  AbstractCurry.Curry_Types.Choice_C_CLocalDecl d i l r -> narrow d i
    (d_C_detInLocalDecl l cd cs) (d_C_detInLocalDecl r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CLocalDecl d i xs -> narrows cs d i (\z ->
    d_C_detInLocalDecl z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CLocalDecl d c e -> guardCons d c ((\x ->
    d_C_detInLocalDecl e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CLocalDecl d info -> failCons d (traceFail
    "Language.Curry.CheckDetUsage.detInLocalDecl" [show x1] info)
  _ -> failCons cd (consFail "Language.Curry.CheckDetUsage.detInLocalDecl"
    (showCons x1))

d_C_detInExp :: AbstractCurry.Curry_Types.C_CExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_detInExp x1 cd cs = case x1 of
  AbstractCurry.Curry_Types.C_CVar x2 -> Curry_Prelude.C_False
  AbstractCurry.Curry_Types.C_CLit x3 -> Curry_Prelude.C_False
  AbstractCurry.Curry_Types.C_CSymbol x4 -> Curry_Prelude.C_False
  AbstractCurry.Curry_Types.C_CApply x5 x6 -> Curry_Prelude.d_OP_bar_bar
    (d_C_detInExp x5 cd cs) (d_C_detInExp x6 cd cs) cd cs
  AbstractCurry.Curry_Types.C_CLambda x7 x8 -> d_C_detInExp x8 cd cs
  AbstractCurry.Curry_Types.C_CLetDecl x9 x10 -> Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_any d_C_detInLocalDecl cd cs) x9
    cd cs) (d_C_detInExp x10 cd cs) cd cs
  AbstractCurry.Curry_Types.C_CDoExpr x11 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_any d_C_detInStatement cd cs) x11 cd cs
  AbstractCurry.Curry_Types.C_CListComp x12 x13 -> Curry_Prelude.d_OP_bar_bar
    (d_C_detInExp x12 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_any
    d_C_detInStatement cd cs) x13 cd cs) cd cs
  AbstractCurry.Curry_Types.C_CCase x14 x15 x16 -> Curry_Prelude.d_OP_bar_bar
    (d_C_detInExp x15 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_any
    (Curry_Prelude.d_OP_dot d_C_detInRhs Curry_Prelude.d_C_snd cd cs) cd cs) x16
    cd cs) cd cs
  AbstractCurry.Curry_Types.C_CTyped x17 x18 -> Curry_Prelude.d_OP_bar_bar
    (d_C_detInExp x17 cd cs) (d_C_detInTypeExpr
    (AbstractCurry.Curry_Select.d_C_typeOfQualType x18 cd cs) cd cs) cd cs
  AbstractCurry.Curry_Types.C_CRecConstr x19 x20 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_any (Curry_Prelude.d_OP_dot d_C_detInExp
    Curry_Prelude.d_C_snd cd cs) cd cs) x20 cd cs
  AbstractCurry.Curry_Types.C_CRecUpdate x21 x22 -> Curry_Prelude.d_OP_bar_bar
    (d_C_detInExp x21 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_any
    (Curry_Prelude.d_OP_dot d_C_detInExp Curry_Prelude.d_C_snd cd cs) cd cs) x22
    cd cs) cd cs
  AbstractCurry.Curry_Types.Choice_C_CExpr d i l r -> narrow d i (d_C_detInExp l
    cd cs) (d_C_detInExp r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CExpr d i xs -> narrows cs d i (\z ->
    d_C_detInExp z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CExpr d c e -> guardCons d c ((\x ->
    d_C_detInExp e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CExpr d info -> failCons d (traceFail
    "Language.Curry.CheckDetUsage.detInExp" [show x1] info)
  _ -> failCons cd (consFail "Language.Curry.CheckDetUsage.detInExp" (showCons
    x1))

d_C_detInStatement :: AbstractCurry.Curry_Types.C_CStatement -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C_detInStatement x1 cd cs = case x1 of
  AbstractCurry.Curry_Types.C_CSExpr x2 -> d_C_detInExp x2 cd cs
  AbstractCurry.Curry_Types.C_CSPat x3 x4 -> d_C_detInExp x4 cd cs
  AbstractCurry.Curry_Types.C_CSLet x5 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_any d_C_detInLocalDecl cd cs) x5 cd cs
  AbstractCurry.Curry_Types.Choice_C_CStatement d i l r -> narrow d i
    (d_C_detInStatement l cd cs) (d_C_detInStatement r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CStatement d i xs -> narrows cs d i (\z ->
    d_C_detInStatement z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CStatement d c e -> guardCons d c ((\x ->
    d_C_detInStatement e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CStatement d info -> failCons d (traceFail
    "Language.Curry.CheckDetUsage.detInStatement" [show x1] info)
  _ -> failCons cd (consFail "Language.Curry.CheckDetUsage.detInStatement"
    (showCons x1))

d_C__case_1 :: Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CRule
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_1 x6 x5 x2 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x2 Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x6 x5 x2 l cd
    cs) (d_C__case_1 x6 x5 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x6 x5
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x6 x5 x2
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckDetUsage._case_1" [show x6, show x5, show x2, show x7]
    info)
  _ -> failCons cd (consFail "Language.Curry.CheckDetUsage._case_1" (showCons
    x7))

d_C__case_0 :: AbstractCurry.Curry_Types.C_CFuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_0 x2 cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CFunc x3 x4 x5 x6 x7 -> Curry_Prelude.d_OP_bar_bar
    (d_C_detInTypeExpr (AbstractCurry.Curry_Select.d_C_typeOfQualType x6 cd cs)
    cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_any d_C_detInRule cd cs)
    x7 cd cs) cd cs
  AbstractCurry.Curry_Types.C_CmtFunc x8 x9 x10 x11 x12 x13 -> Curry_Prelude.d_OP_bar_bar
    (d_C_detInTypeExpr (AbstractCurry.Curry_Select.d_C_typeOfQualType x12 cd cs)
    cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_any d_C_detInRule cd cs)
    x13 cd cs) cd cs
  AbstractCurry.Curry_Types.Choice_C_CFuncDecl d i l r -> narrow d i
    (d_C__case_0 l cd cs) (d_C__case_0 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CFuncDecl d i xs -> narrows cs d i (\z ->
    d_C__case_0 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CFuncDecl d c e -> guardCons d c ((\x ->
    d_C__case_0 e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CFuncDecl d info -> failCons d (traceFail
    "Language.Curry.CheckDetUsage._case_0" [show x2] info)
  _ -> failCons cd (consFail "Language.Curry.CheckDetUsage._case_0" (showCons
    x2))

