{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Language.Curry.Curry_CheckOperations
  ( nd_C_checkSetUse, nd_C_checkBlacklistUse )
  where

import Basics
import qualified AbstractCurry.Curry_Match
import qualified AbstractCurry.Curry_Types
import qualified Control.Search.Curry_SetFunctions
import qualified FlatCurry.Curry_Match
import qualified FlatCurry.Curry_Types
import qualified Curry_Numeric
import qualified Curry_Prelude


nd_C_checkSetUse :: FlatCurry.Curry_Types.C_Prog -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
nd_C_checkSetUse x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_Prog x2 x3 x4 x5 x6 -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s3 = rightSupply s6
    in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    s0 cd cs) (Control.Search.Curry_SetFunctions.d_C_values2list
    (Control.Search.Curry_SetFunctions.nd_C_set1 (wrapNX id nd_C_setUse) x5 s1
    cd cs) cd cs) s2 cd cs)))) (wrapDX id
    d_OP_checkSetUse_dot_uscore_hash_lambda2) s5 cd cs))
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i (nd_C_checkSetUse l
    s cd cs) (nd_C_checkSetUse r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    nd_C_checkSetUse z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c ((\x ->
    nd_C_checkSetUse e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "Language.Curry.CheckOperations.checkSetUse" [show x1] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations.checkSetUse"
    (showCons x1))

d_OP_checkSetUse_dot_showSetError_dot_6 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple3 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_checkSetUse_dot_showSetError_dot_6 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> Curry_Prelude.OP_Tuple2 x2
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "wrong use of set function `set") (Curry_Prelude.d_OP_plus_plus x3
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "': ")
    (Curry_Prelude.d_OP_plus_plus x4 (Curry_Prelude.toCurryString "!") cd cs) cd
    cs) cd cs) cd cs)
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_checkSetUse_dot_showSetError_dot_6 l cd cs)
    (d_OP_checkSetUse_dot_showSetError_dot_6 r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_checkSetUse_dot_showSetError_dot_6 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_checkSetUse_dot_showSetError_dot_6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Language.Curry.CheckOperations.checkSetUse.showSetError.6" [show x1] info)
  _ -> failCons cd (consFail
    "Language.Curry.CheckOperations.checkSetUse.showSetError.6" (showCons x1))

d_OP_checkSetUse_dot_uscore_hash_lambda2 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_OP_checkSetUse_dot_uscore_hash_lambda2 x1 cd cs = let x2 = x1
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_map d_OP_checkSetUse_dot_showSetError_dot_6 x2 cd
  cs) cd cs

nd_C_setUse :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_FuncDecl
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C_setUse x1 s cd cs = let s13 = s
  in s13 `seq` (let s14 = leftSupply s13
                    s15 = rightSupply s13
                    s0 = leftSupply s14
                    s1 = rightSupply s14
                    s2 = leftSupply s15
                    s16 = rightSupply s15
                    s3 = leftSupply s16
                    s12 = rightSupply s16
  in s14 `seq` (s15 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s16 `seq` (s3 `seq`
  (s12 `seq` (let x2 = generate s0 cd
                  x3 = generate s1 cd
                  x4 = generate s2 cd
                  x5 = generate s3 cd
  in d_C___cond_0_setUse x2 x3 x4 x5 (Curry_Prelude.d_OP_eq_colon_lt_eq
  (let s4 = leftSupply s12
       s11 = rightSupply s12
  in s4 `seq` (s11 `seq` Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_FuncDecl_hash)))
  s4 cd cs) (let s8 = leftSupply s11
                 s10 = rightSupply s11
  in s8 `seq` (s10 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
  (let s7 = leftSupply s8
       s9 = rightSupply s8
       s5 = leftSupply s9
       s6 = rightSupply s9
  in s7 `seq` (s9 `seq` (s5 `seq` (s6 `seq`
  FlatCurry.Curry_Match.nd_C_funWithinExp x2 (Curry_Prelude.nd_C_unknown (wrapNX
  id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  s5 cd cs) (Curry_Prelude.nd_C_unknown (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  s6 cd cs) (FlatCurry.Curry_Types.C_Comb x3 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "Control.Search.SetFunctions")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "set") x4 cd cs))
  x5) s7 cd cs)))) Curry_Prelude.OP_List) (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_FuncDecl_hash)))
  s10 cd cs) cd cs)) cd cs)) x1 cd cs) cd cs)))))))))

d_C___cond_0_setUse :: forall . Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C___cond_0_setUse x1 x2 x3 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> d_C_invalidSetFunCall x1 x2 x3 x4 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C___cond_0_setUse x1 x2
    x3 x4 l cd cs) (d_C___cond_0_setUse x1 x2 x3 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_C___cond_0_setUse x1 x2 x3 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C___cond_0_setUse
    x1 x2 x3 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckOperations.__cond_0_setUse" [show x1, show x2, show x3
    , show x4, show x5] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations.__cond_0_setUse"
    (showCons x5))

d_C_invalidSetFunCall :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_invalidSetFunCall x1 x2 x3 x4 cd cs = let x5 = d_C__case_19 x3
                                                (Curry_Numeric.d_C_readNat x3 cd
                                                cs) cd cs
  in d_C__case_24 x3 x4 x2 x1 x5 (Curry_Prelude.d_C_not (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_all Curry_Prelude.d_C_isDigit cd cs) x3 cd cs) cd cs) cd cs

d_OP_invalidSetFunCall_dot_isID_dot_17 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_invalidSetFunCall_dot_isID_dot_17 x1 cd cs =
  let x2 = Curry_Prelude.toCurryString "~!@#$%^&*+-=<>?./|\\:"
  in Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_all
  (Curry_Prelude.d_C_flip (Curry_Prelude.d_C_elem
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  x2) cd cs) x1 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_notElem
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  (Curry_Prelude.C_Char '.'#) cd cs) x1 cd cs) cd cs

d_OP_invalidSetFunCall_dot_checkTopLevelID_dot_17 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_invalidSetFunCall_dot_checkTopLevelID_dot_17 x1 x2 x3 cd cs = d_C__case_15
  x3 x1 x2 (d_OP_invalidSetFunCall_dot_isID_dot_17 x3 cd cs) cd cs

d_OP_invalidSetFunCall_dot_showArity_dot_17 :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Num t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_invalidSetFunCall_dot_showArity_dot_17 x1 x2 x3 x4 cd cs = d_C__case_13 x2
  x4 x1 x3 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_eq_eq x1 cd cs) x4 cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_fromInt x2 cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs)
  cd cs

nd_OP_invalidSetFunCall_dot_showArity_dot_17 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Num t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_OP_invalidSetFunCall_dot_showArity_dot_17 x1 x2 x3 x4 s cd cs = let s10 = s
  in s10 `seq` (let s9 = leftSupply s10
                    s7 = rightSupply s10
  in s9 `seq` (s7 `seq` nd_C__case_13 x2 x4 x1 x3 (let s6 = leftSupply s7
                                                       s8 = rightSupply s7
                                                       s2 = leftSupply s8
                                                       s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s2 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq x1
  s0 cd cs) x4 s1 cd cs)) (let s4 = leftSupply s5
                               s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_fromInt x2
  s3 cd cs) (Curry_Prelude.C_Int (0)) s4 cd cs)) s6 cd cs)))) s9 cd cs))

d_OP_invalidSetFunCall_dot_arityError_dot_17 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Num t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_invalidSetFunCall_dot_arityError_dot_17 x1 x2 x3 x4 x5 x6 cd cs =
  Curry_Prelude.OP_Tuple3 x2 x1 (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "set function not applied to ")
  (Curry_Prelude.d_OP_plus_plus (d_OP_invalidSetFunCall_dot_showArity_dot_17 x3
  x4 x5 x6 cd cs) (Curry_Prelude.toCurryString " top-level function") cd cs) cd
  cs)

nd_OP_invalidSetFunCall_dot_arityError_dot_17 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Num t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_OP_invalidSetFunCall_dot_arityError_dot_17 x1 x2 x3 x4 x5 x6 s cd cs =
  let s0 = s
  in s0 `seq` Curry_Prelude.OP_Tuple3 x2 x1 (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "set function not applied to ")
  (Curry_Prelude.d_OP_plus_plus (nd_OP_invalidSetFunCall_dot_showArity_dot_17 x3
  x4 x5 x6 s0 cd cs) (Curry_Prelude.toCurryString " top-level function") cd cs)
  cd cs)

d_OP_invalidSetFunCall_dot_isFuncCall_dot_17 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_invalidSetFunCall_dot_isFuncCall_dot_17 x1 x2 x3 cd cs =
  let x4 = d_OP_invalidSetFunCall_dot_arityError_dot_17 x1 x2
        Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
        Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
        Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
        (Curry_Prelude.C_Int (0)) cd cs
  in d_C__case_9 x4 x2 x1 x3 cd cs

d_OP_invalidSetFunCall_dot_isFuncPartCall_dot_17 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Int -> FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_invalidSetFunCall_dot_isFuncPartCall_dot_17 x1 x2 x3 x4 cd cs =
  let x5 = d_OP_invalidSetFunCall_dot_arityError_dot_17 x1 x2
        Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
        Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
        Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
        x3 cd cs
  in d_C__case_5 x5 x3 x2 x1 x4 cd cs

nd_C_checkBlacklistUse :: AbstractCurry.Curry_Types.C_CurryProg -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
nd_C_checkBlacklistUse x1 s cd cs = case x1 of
  AbstractCurry.Curry_Types.C_CurryProg x2 x3 x4 x5 x6 x7 x8 x9 -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s3 = rightSupply s6
    in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    s0 cd cs) (Control.Search.Curry_SetFunctions.d_C_values2list
    (Control.Search.Curry_SetFunctions.nd_C_set1 (wrapNX id nd_C_blacklistUsage)
    x8 s1 cd cs) cd cs) s2 cd cs)))) (wrapDX id
    d_OP_checkBlacklistUse_dot_uscore_hash_lambda9) s5 cd cs))
  AbstractCurry.Curry_Types.Choice_C_CurryProg d i l r -> narrow d i
    (nd_C_checkBlacklistUse l s cd cs) (nd_C_checkBlacklistUse r s cd cs)
  AbstractCurry.Curry_Types.Choices_C_CurryProg d i xs -> narrows cs d i (\z ->
    nd_C_checkBlacklistUse z s cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CurryProg d c e -> guardCons d c ((\x ->
    nd_C_checkBlacklistUse e s cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CurryProg d info -> failCons d (traceFail
    "Language.Curry.CheckOperations.checkBlacklistUse" [show x1] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations.checkBlacklistUse"
    (showCons x1))

d_OP_checkBlacklistUse_dot_showBlacklistError_dot_58 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_checkBlacklistUse_dot_showBlacklistError_dot_58 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_1 x2 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_checkBlacklistUse_dot_showBlacklistError_dot_58 l cd cs)
    (d_OP_checkBlacklistUse_dot_showBlacklistError_dot_58 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_checkBlacklistUse_dot_showBlacklistError_dot_58 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_checkBlacklistUse_dot_showBlacklistError_dot_58 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.CheckOperations.checkBlacklistUse.showBlacklistError.58"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.Curry.CheckOperations.checkBlacklistUse.showBlacklistError.58"
    (showCons x1))

d_OP_checkBlacklistUse_dot_uscore_hash_lambda9 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))
d_OP_checkBlacklistUse_dot_uscore_hash_lambda9 x1 cd cs = let x2 = x1
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_map
  d_OP_checkBlacklistUse_dot_showBlacklistError_dot_58 x2 cd cs) cd cs

nd_C_blacklistUsage :: Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_C_blacklistUsage x1 s cd cs = let s7 = s
  in s7 `seq` (let s0 = leftSupply s7
                   s8 = rightSupply s7
                   s1 = leftSupply s8
                   s6 = rightSupply s8
  in s0 `seq` (s8 `seq` (s1 `seq` (s6 `seq` (let x2 = generate s0 cd
                                                 x3 = generate s1 cd
  in d_C___cond_0_blacklistUsage x3 x2 (Curry_Prelude.d_OP_eq_colon_lt_eq
  (let s2 = leftSupply s6
       s5 = rightSupply s6
  in s2 `seq` (s5 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_unknown
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  AbstractCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_AbstractCurry_dot_Types_dot_CFuncDecl_hash)))
  s2 cd cs) (let s3 = leftSupply s5
                 s4 = rightSupply s5
  in s3 `seq` (s4 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
  (AbstractCurry.Curry_Match.nd_C_cfunWithExp x2
  (AbstractCurry.Curry_Types.C_CSymbol x3) s3 cd cs) Curry_Prelude.OP_List)
  (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  AbstractCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_AbstractCurry_dot_Types_dot_CFuncDecl_hash)))
  s4 cd cs) cd cs)) cd cs)) x1 cd cs) cd cs)))))

d_C___cond_0_blacklistUsage :: forall . Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C___cond_0_blacklistUsage x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> d_C__case_0 x1 x2 (d_C_isBlacklistedOperation x1 cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C___cond_0_blacklistUsage
    x1 x2 l cd cs) (d_C___cond_0_blacklistUsage x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_C___cond_0_blacklistUsage x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x ->
    d_C___cond_0_blacklistUsage x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckOperations.__cond_0_blacklistUsage" [show x1, show x2
    , show x3] info)
  _ -> failCons cd (consFail
    "Language.Curry.CheckOperations.__cond_0_blacklistUsage" (showCons x3))

d_C_isBlacklistedOperation :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C_isBlacklistedOperation x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (AbstractCurry.Curry_Types.d_C_preludeName cd cs) cd cs)
    (Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (5)) x3 cd cs)
    (Curry_Prelude.toCurryString "prim_") cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_elem
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "=:<=")
    (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "=:<<=")
    Curry_Prelude.OP_List)) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_C_isBlacklistedOperation l cd cs) (d_C_isBlacklistedOperation r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_C_isBlacklistedOperation z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_C_isBlacklistedOperation e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.CheckOperations.isBlacklistedOperation" [show x1] info)
  _ -> failCons cd (consFail
    "Language.Curry.CheckOperations.isBlacklistedOperation" (showCons x1))

d_C__case_19 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_C__case_19 x3 x8 cd cs = case x8 of
  Curry_Prelude.OP_Cons x6 x7 -> d_C__case_18 x7 x6 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "UsageCheck.validSetFunCall: illegal number!") cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_19 x3 l cd cs)
    (d_C__case_19 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_19 x3
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_19 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_19" [show x3, show x8] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_19" (showCons
    x8))

d_C__case_18 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C__case_18 x7 x6 cd cs = case x6 of
  Curry_Prelude.OP_Tuple2 x8 x9 -> d_C__case_17 x7 x8 x9 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_18 x7 l cd cs)
    (d_C__case_18 x7 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_18
    x7 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_18 x7 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_18" [show x7, show x6] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_18" (showCons
    x6))

d_C__case_17 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Int
d_C__case_17 x7 x8 x9 cd cs = case x9 of
  Curry_Prelude.OP_List -> d_C__case_16 x8 x7 cd cs
  Curry_Prelude.OP_Cons x12 x13 -> Curry_Prelude.d_C_error
    (Curry_Prelude.toCurryString "UsageCheck.validSetFunCall: illegal number!")
    cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_17 x7 x8 l cd
    cs) (d_C__case_17 x7 x8 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_17 x7
    x8 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_17 x7 x8
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_17" [show x7, show x8, show x9] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_17" (showCons
    x9))

d_C__case_16 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C__case_16 x8 x7 cd cs = case x7 of
  Curry_Prelude.OP_List -> x8
  Curry_Prelude.OP_Cons x10 x11 -> Curry_Prelude.d_C_error
    (Curry_Prelude.toCurryString "UsageCheck.validSetFunCall: illegal number!")
    cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_16 x8 l cd cs)
    (d_C__case_16 x8 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_16 x8
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_16 x8 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_16" [show x8, show x7] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_16" (showCons
    x7))

d_C__case_24 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_24 x3 x4 x2 x1 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple3 x1 x3
    (Curry_Prelude.toCurryString "suffix of set function is not a number")
  Curry_Prelude.C_False -> d_C__case_23 x4 x2 x3 x1 x5
    (Curry_Prelude.d_OP_amp_amp
    (FlatCurry.Curry_Types.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Types_dot_CombType_hash
    x2 FlatCurry.Curry_Types.C_FuncCall cd cs) (Curry_Prelude.d_C_null x4 cd cs)
    cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_24 x3 x4 x2 x1 x5
    l cd cs) (d_C__case_24 x3 x4 x2 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_24 x3
    x4 x2 x1 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_24 x3 x4
    x2 x1 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_24" [show x3, show x4, show x2, show
    x1, show x5, show x6] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_24" (showCons
    x6))

d_C__case_23 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_23 x4 x2 x3 x1 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple3 x1 x3
    (Curry_Prelude.toCurryString "missing function argument")
  Curry_Prelude.C_False -> d_C__case_22 x2 x3 x1 x5 x4
    (FlatCurry.Curry_Types.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Types_dot_CombType_hash
    x2 FlatCurry.Curry_Types.C_FuncCall cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_23 x4 x2 x3 x1 x5
    l cd cs) (d_C__case_23 x4 x2 x3 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_23 x4
    x2 x3 x1 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_23 x4 x2
    x3 x1 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_23" [show x4, show x2, show x3, show
    x1, show x5, show x6] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_23" (showCons
    x6))

d_C__case_22 :: FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_22 x2 x3 x1 x5 x4 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C__case_21 x5 x4 x1 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x5 (Curry_Prelude.C_Int (0)) cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_20 x3 x1 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_22 x2 x3 x1 x5 x4
    l cd cs) (d_C__case_22 x2 x3 x1 x5 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_22 x2
    x3 x1 x5 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_22 x2 x3
    x1 x5 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_22" [show x2, show x3, show x1, show
    x5, show x4, show x6] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_22" (showCons
    x6))

d_C__case_20 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_20 x3 x1 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple3 x1 x3
    (Curry_Prelude.toCurryString "partial application of set function")
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_20 x3 x1 l cd cs)
    (d_C__case_20 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_20 x3
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_20 x3 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_20" [show x3, show x1, show x4] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_20" (showCons
    x4))

d_C__case_21 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_21 x5 x4 x1 x3 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_OP_invalidSetFunCall_dot_isFuncCall_dot_17 x3 x1
    (Curry_Prelude.d_C_head x4 cd cs) cd cs
  Curry_Prelude.C_False -> d_OP_invalidSetFunCall_dot_isFuncPartCall_dot_17 x3
    x1 x5 (Curry_Prelude.d_C_head x4 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_21 x5 x4 x1 x3 l
    cd cs) (d_C__case_21 x5 x4 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_21 x5
    x4 x1 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_21 x5 x4
    x1 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_21" [show x5, show x4, show x1, show
    x3, show x6] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_21" (showCons
    x6))

d_C__case_15 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_15 x3 x1 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.C_False -> d_C__case_14 x1 x2 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_15 x3 x1 x2 l cd
    cs) (d_C__case_15 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_15 x3
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_15 x3 x1
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_15" [show x3, show x1, show x2, show
    x4] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_15" (showCons
    x4))

d_C__case_14 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_14 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple3 x2 x1
    (Curry_Prelude.toCurryString "set function not applied to top-level name")
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_14 x1 x2 l cd cs)
    (d_C__case_14 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_14 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_14 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_14" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_14" (showCons
    x3))

d_C__case_13 :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Num t0) -> t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_13 x2 x4 x1 x3 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "0-ary"
  Curry_Prelude.C_False -> d_C__case_12 x2 x4 x1 x3 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq x1 cd cs) x4 cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_fromInt x2 cd cs)
    (Curry_Prelude.C_Int (1)) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_13 x2 x4 x1 x3 l
    cd cs) (d_C__case_13 x2 x4 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_13 x2
    x4 x1 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_13 x2 x4
    x1 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_13" [show x2, show x4, show x1, show
    x3, show x5] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_13" (showCons
    x5))

nd_C__case_13 :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Num t0) -> t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_13 x2 x4 x1 x3 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "0-ary"
  Curry_Prelude.C_False -> let s10 = s
    in s10 `seq` (let s9 = leftSupply s10
                      s7 = rightSupply s10
    in s9 `seq` (s7 `seq` nd_C__case_12 x2 x4 x1 x3 (let s6 = leftSupply s7
                                                         s8 = rightSupply s7
                                                         s2 = leftSupply s8
                                                         s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s2 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq x1
    s0 cd cs) x4 s1 cd cs)) (let s4 = leftSupply s5
                                 s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_fromInt
    x2 s3 cd cs) (Curry_Prelude.C_Int (1)) s4 cd cs)) s6 cd cs)))) s9 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_13 x2 x4 x1 x3 l
    s cd cs) (nd_C__case_13 x2 x4 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_13 x2
    x4 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_13 x2 x4
    x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_13" [show x2, show x4, show x1, show
    x3, show x5] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_13" (showCons
    x5))

d_C__case_12 :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Num t0) -> t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_12 x2 x4 x1 x3 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "unary"
  Curry_Prelude.C_False -> d_C__case_11 x2 x4 x1 x3 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq x1 cd cs) x4 cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_fromInt x2 cd cs)
    (Curry_Prelude.C_Int (2)) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_12 x2 x4 x1 x3 l
    cd cs) (d_C__case_12 x2 x4 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_12 x2
    x4 x1 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_12 x2 x4
    x1 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_12" [show x2, show x4, show x1, show
    x3, show x5] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_12" (showCons
    x5))

nd_C__case_12 :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Num t0) -> t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_12 x2 x4 x1 x3 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "unary"
  Curry_Prelude.C_False -> let s10 = s
    in s10 `seq` (let s9 = leftSupply s10
                      s7 = rightSupply s10
    in s9 `seq` (s7 `seq` nd_C__case_11 x2 x4 x1 x3 (let s6 = leftSupply s7
                                                         s8 = rightSupply s7
                                                         s2 = leftSupply s8
                                                         s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s2 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq x1
    s0 cd cs) x4 s1 cd cs)) (let s4 = leftSupply s5
                                 s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_fromInt
    x2 s3 cd cs) (Curry_Prelude.C_Int (2)) s4 cd cs)) s6 cd cs)))) s9 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_12 x2 x4 x1 x3 l
    s cd cs) (nd_C__case_12 x2 x4 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_12 x2
    x4 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_12 x2 x4
    x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_12" [show x2, show x4, show x1, show
    x3, show x5] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_12" (showCons
    x5))

d_C__case_11 :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Num t0) -> t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_11 x2 x4 x1 x3 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "binary"
  Curry_Prelude.C_False -> d_C__case_10 x4 x3 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_11 x2 x4 x1 x3 l
    cd cs) (d_C__case_11 x2 x4 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_11 x2
    x4 x1 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_11 x2 x4
    x1 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_11" [show x2, show x4, show x1, show
    x3, show x5] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_11" (showCons
    x5))

nd_C__case_11 :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Num t0) -> t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_11 x2 x4 x1 x3 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "binary"
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_10 x4 x3 (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_11 x2 x4 x1 x3 l
    s cd cs) (nd_C__case_11 x2 x4 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_11 x2
    x4 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_11 x2 x4
    x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_11" [show x2, show x4, show x1, show
    x3, show x5] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_11" (showCons
    x5))

d_C__case_10 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_10 x4 x3 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_show x3 cd cs) x4 cd cs) (Curry_Prelude.toCurryString
    "-ary") cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_10 x4 x3 l cd cs)
    (d_C__case_10 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_10 x4
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_10 x4 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_10" [show x4, show x3, show x5] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_10" (showCons
    x5))

nd_C__case_10 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_10 x4 x3 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` Curry_Prelude.d_OP_plus_plus (let s1 = leftSupply s2
                                                  s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x3
    s0 cd cs) x4 s1 cd cs)) (Curry_Prelude.toCurryString "-ary") cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_10 x4 x3 l s cd
    cs) (nd_C__case_10 x4 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_10 x4
    x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_10 x4 x3
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_10" [show x4, show x3, show x5] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_10" (showCons
    x5))

d_C__case_9 :: Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_9 x4 x2 x1 x3 cd cs = case x3 of
  FlatCurry.Curry_Types.C_Comb x5 x6 x7 -> let x8 = d_OP_invalidSetFunCall_dot_arityError_dot_17
                                                 x1 x2
                                                 Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
                                                 Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
                                                 Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
                                                 (Curry_Prelude.C_Int (0)) cd cs
    in d_C__case_8 x8 x6 x7 x2 x1 x5 cd cs
  FlatCurry.Curry_Types.C_Var x15 -> x4
  FlatCurry.Curry_Types.C_Lit x16 -> x4
  FlatCurry.Curry_Types.C_Let x17 x18 -> x4
  FlatCurry.Curry_Types.C_Free x19 x20 -> x4
  FlatCurry.Curry_Types.C_Or x21 x22 -> x4
  FlatCurry.Curry_Types.C_Case x23 x24 x25 -> x4
  FlatCurry.Curry_Types.C_Typed x26 x27 -> x4
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (d_C__case_9 x4 x2
    x1 l cd cs) (d_C__case_9 x4 x2 x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    d_C__case_9 x4 x2 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x -> d_C__case_9
    x4 x2 x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_9" [show x4, show x2, show x1, show
    x3] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_9" (showCons
    x3))

d_C__case_8 :: Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> FlatCurry.Curry_Types.C_CombType -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_8 x8 x6 x7 x2 x1 x5 cd cs = case x5 of
  FlatCurry.Curry_Types.C_FuncCall -> d_C__case_7 x7 x2 x1 x6 cd cs
  FlatCurry.Curry_Types.C_ConsCall -> x8
  FlatCurry.Curry_Types.C_FuncPartCall x13 -> x8
  FlatCurry.Curry_Types.C_ConsPartCall x14 -> x8
  FlatCurry.Curry_Types.Choice_C_CombType d i l r -> narrow d i (d_C__case_8 x8
    x6 x7 x2 x1 l cd cs) (d_C__case_8 x8 x6 x7 x2 x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_CombType d i xs -> narrows cs d i (\z ->
    d_C__case_8 x8 x6 x7 x2 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_CombType d c e -> guardCons d c ((\x ->
    d_C__case_8 x8 x6 x7 x2 x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_CombType d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_8" [show x8, show x6, show x7, show x2
    , show x1, show x5] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_8" (showCons
    x5))

d_C__case_7 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_7 x7 x2 x1 x6 cd cs = case x6 of
  Curry_Prelude.OP_Tuple2 x9 x10 -> d_C__case_6 x2 x1 x10 x7 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_7 x7 x2 x1 l
    cd cs) (d_C__case_7 x7 x2 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_7 x7
    x2 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_7 x7 x2
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_7" [show x7, show x2, show x1, show
    x6] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_7" (showCons
    x6))

d_C__case_6 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_6 x2 x1 x10 x7 cd cs = case x7 of
  Curry_Prelude.OP_List -> d_OP_invalidSetFunCall_dot_checkTopLevelID_dot_17 x1
    x2 x10 cd cs
  Curry_Prelude.OP_Cons x11 x12 -> d_OP_invalidSetFunCall_dot_arityError_dot_17
    x1 x2
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (0)) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_6 x2 x1 x10 l cd
    cs) (d_C__case_6 x2 x1 x10 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_6 x2
    x1 x10 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_6 x2 x1
    x10 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_6" [show x2, show x1, show x10, show
    x7] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_6" (showCons
    x7))

d_C__case_5 :: Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_5 x5 x3 x2 x1 x4 cd cs = case x4 of
  FlatCurry.Curry_Types.C_Comb x6 x7 x8 -> let x9 = d_OP_invalidSetFunCall_dot_arityError_dot_17
                                                 x1 x2
                                                 Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
                                                 Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
                                                 Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
                                                 x3 cd cs
    in d_C__case_4 x9 x7 x3 x2 x1 x6 cd cs
  FlatCurry.Curry_Types.C_Var x14 -> x5
  FlatCurry.Curry_Types.C_Lit x15 -> x5
  FlatCurry.Curry_Types.C_Let x16 x17 -> x5
  FlatCurry.Curry_Types.C_Free x18 x19 -> x5
  FlatCurry.Curry_Types.C_Or x20 x21 -> x5
  FlatCurry.Curry_Types.C_Case x22 x23 x24 -> x5
  FlatCurry.Curry_Types.C_Typed x25 x26 -> x5
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (d_C__case_5 x5 x3
    x2 x1 l cd cs) (d_C__case_5 x5 x3 x2 x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    d_C__case_5 x5 x3 x2 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x -> d_C__case_5
    x5 x3 x2 x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_5" [show x5, show x3, show x2, show x1
    , show x4] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_5" (showCons
    x4))

d_C__case_4 :: Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> FlatCurry.Curry_Types.C_CombType -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_4 x9 x7 x3 x2 x1 x6 cd cs = case x6 of
  FlatCurry.Curry_Types.C_FuncPartCall x10 -> d_C__case_3 x3 x10 x2 x1 x7 cd cs
  FlatCurry.Curry_Types.C_FuncCall -> x9
  FlatCurry.Curry_Types.C_ConsCall -> x9
  FlatCurry.Curry_Types.C_ConsPartCall x13 -> x9
  FlatCurry.Curry_Types.Choice_C_CombType d i l r -> narrow d i (d_C__case_4 x9
    x7 x3 x2 x1 l cd cs) (d_C__case_4 x9 x7 x3 x2 x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_CombType d i xs -> narrows cs d i (\z ->
    d_C__case_4 x9 x7 x3 x2 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_CombType d c e -> guardCons d c ((\x ->
    d_C__case_4 x9 x7 x3 x2 x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_CombType d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_4" [show x9, show x7, show x3, show x2
    , show x1, show x6] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_4" (showCons
    x6))

d_C__case_3 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_3 x3 x10 x2 x1 x7 cd cs = case x7 of
  Curry_Prelude.OP_Tuple2 x11 x12 -> d_C__case_2 x3 x10 x2 x1 x12
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x10 x3 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_3 x3 x10 x2 x1
    l cd cs) (d_C__case_3 x3 x10 x2 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_3 x3
    x10 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_3 x3
    x10 x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_3" [show x3, show x10, show x2, show
    x1, show x7] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_3" (showCons
    x7))

d_C__case_2 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_2 x3 x10 x2 x1 x12 x13 cd cs = case x13 of
  Curry_Prelude.C_True -> d_OP_invalidSetFunCall_dot_checkTopLevelID_dot_17 x1
    x2 x12 cd cs
  Curry_Prelude.C_False -> d_OP_invalidSetFunCall_dot_arityError_dot_17 x1 x2
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    x3 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x3 x10 x2 x1
    x12 l cd cs) (d_C__case_2 x3 x10 x2 x1 x12 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x3
    x10 x2 x1 x12 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x3 x10
    x2 x1 x12 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_2" [show x3, show x10, show x2, show
    x1, show x12, show x13] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_2" (showCons
    x13))

d_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.OP_Tuple2 x2
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "direct use of `") (Curry_Prelude.d_OP_plus_plus x4
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString ".")
    (Curry_Prelude.d_OP_plus_plus x5 (Curry_Prelude.toCurryString
    "' not allowed!") cd cs) cd cs) cd cs) cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_1 x2 l cd cs)
    (d_C__case_1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_1 x2
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_1" [show x2, show x3] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_1" (showCons
    x3))

d_C__case_0 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_0 x3 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 x2 x3
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x3 x2 l cd cs)
    (d_C__case_0 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x3 x2
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x3 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.CheckOperations._case_0" [show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "Language.Curry.CheckOperations._case_0" (showCons
    x4))

