{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Analysis.Curry_Files
  ( d_C_getAnalysisBaseFile
  , d_C_getAnalysisPublicFile
  , d_C_getAnalysisPrivateFile
  , d_C_getAnalysisDirectory
  , d_C_getInterfaceInfos
  , nd_C_getInterfaceInfos
  , d_C_loadDefaultAnalysisValues
  , nd_C_loadDefaultAnalysisValues
  , d_C_loadCompleteAnalysis
  , nd_C_loadCompleteAnalysis
  , d_C_loadPublicAnalysis
  , nd_C_loadPublicAnalysis
  , d_C_storeImportModuleList
  , d_C_getImportModuleListFile
  , d_C_storeAnalysisResult
  , nd_C_storeAnalysisResult
  , d_C_createDirectoryR
  , d_C_deleteAllAnalysisFiles
  , d_C_findModuleSourceInLoadPath
  , d_C_getImports
  , d_C_getSourceFileTime
  , d_C_getFlatCurryFileTime
  , d_C_flatCurryFileNewer
  , d_C_readNewestFlatCurry
  , d_C_readNewestFlatCurryInt
  , d_C_flat2intName )
  where

import Basics
import qualified Analysis.Curry_Logging
import qualified Analysis.Curry_ProgInfo
import qualified Control.Curry_Applicative
import qualified Control.Curry_Monad
import qualified Curry.Compiler.Curry_Distribution
import qualified Data.Curry_List
import qualified Data.Curry_Time
import qualified FlatCurry.Curry_Files
import qualified FlatCurry.Curry_Goodies
import qualified FlatCurry.Curry_Types
import qualified Curry_Prelude
import qualified RW.Curry_Base
import qualified System.Curry_CurryPath
import qualified System.Curry_Directory
import qualified System.Curry_FilePath


d_C_getAnalysisBaseFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_getAnalysisBaseFile x1 x2 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_getAnalysisDirectory cd cs) cd cs)
  (d_OP_getAnalysisBaseFile_dot_uscore_hash_lambda4 x2 x1) cd cs

d_OP_getAnalysisBaseFile_dot_uscore_hash_lambda4 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_getAnalysisBaseFile_dot_uscore_hash_lambda4 x1 x2 x3 cd cs = let x4 = x3
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_Directory.d_C_getCurrentDirectory cd cs) cd cs)
  (Curry_Prelude.d_OP_dot
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_FilePath.d_C_dropDrive cd cs) cd cs) cd cs) cd cs)
  (d_OP_getAnalysisBaseFile_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6 x1
  x4 x2) cd cs

d_OP_getAnalysisBaseFile_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_getAnalysisBaseFile_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6 x1 x2 x3 x4 cd cs =
  let x5 = x4
      x6 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
        (System.Curry_FilePath.d_OP_lt_dot_gt cd cs) x3 cd cs) x1 cd cs
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_findModuleSourceInLoadPath x3 cd cs) cd cs)
  (d_OP_getAnalysisBaseFile_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8
  x2 x5 x6) cd cs

d_OP_getAnalysisBaseFile_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_getAnalysisBaseFile_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8 x1 x2 x3 x4 cd cs =
  case x4 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> d_C__case_3 x5 x3 x2 x1
    (Curry_Prelude.d_C_apply (System.Curry_FilePath.d_C_isAbsolute cd cs) x5 cd
    cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_getAnalysisBaseFile_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8
    x1 x2 x3 l cd cs)
    (d_OP_getAnalysisBaseFile_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8
    x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_getAnalysisBaseFile_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8
    x1 x2 x3 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_getAnalysisBaseFile_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8
    x1 x2 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Files.getAnalysisBaseFile._#lambda4._#lambda6._#lambda8" [show x1
    , show x2, show x3, show x4] info)
  _ -> failCons cd (consFail
    "Analysis.Files.getAnalysisBaseFile._#lambda4._#lambda6._#lambda8" (showCons
    x4))

d_C_getAnalysisPublicFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_getAnalysisPublicFile x1 x2 cd cs = Curry_Prelude.d_OP_dollar
  (Curry_Prelude.d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Prelude_dot_IO_hash
  (Curry_Prelude.d_C_flip (System.Curry_FilePath.d_OP_lt_dot_gt cd cs)
  (Curry_Prelude.toCurryString "pub"))) (d_C_getAnalysisBaseFile x1 x2 cd cs) cd
  cs

d_C_getAnalysisPrivateFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_getAnalysisPrivateFile x1 x2 cd cs = Curry_Prelude.d_OP_dollar
  (Curry_Prelude.d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Prelude_dot_IO_hash
  (Curry_Prelude.d_C_flip (System.Curry_FilePath.d_OP_lt_dot_gt cd cs)
  (Curry_Prelude.toCurryString "priv"))) (d_C_getAnalysisBaseFile x1 x2 cd cs)
  cd cs

d_C_getAnalysisDirectory :: Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_getAnalysisDirectory cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_Directory.d_C_getHomeDirectory cd cs) cd cs)
  d_OP_getAnalysisDirectory_dot_uscore_hash_lambda12 cd cs

d_OP_getAnalysisDirectory_dot_uscore_hash_lambda12 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_getAnalysisDirectory_dot_uscore_hash_lambda12 x1 cd cs = let x2 = x1
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_Directory.d_C_doesDirectoryExist x2 cd cs) cd cs)
  (d_OP_getAnalysisDirectory_dot_uscore_hash_lambda12_dot_uscore_hash_lambda14
  x2) cd cs

d_OP_getAnalysisDirectory_dot_uscore_hash_lambda12_dot_uscore_hash_lambda14 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_getAnalysisDirectory_dot_uscore_hash_lambda12_dot_uscore_hash_lambda14 x1 x2 cd cs =
  let x3 = x2
      x4 = d_C__case_2 x1 x3 cd cs
  in Curry_Prelude.d_OP_dollar
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (System.Curry_FilePath.d_OP_lt_slash_gt cd cs) x4 cd cs)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (System.Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Prelude.toCurryString
  ".curry_analysis_cache") cd cs) (System.Curry_FilePath.d_C_joinPath
  (Curry_Prelude.d_C_tail (System.Curry_FilePath.d_C_splitDirectories
  (System.Curry_CurryPath.d_C_currySubdir cd cs) cd cs) cd cs) cd cs) cd cs) cd
  cs) cd cs

d_C_getInterfaceInfos :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Analysis.Curry_ProgInfo.C_ProgInfo t0)
d_C_getInterfaceInfos x1 x2 x3 x4 x5 cd cs = case x5 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Analysis.Curry_ProgInfo.d_C_emptyProgInfo cd cs) cd cs
  Curry_Prelude.OP_Cons x6 x7 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (d_C_loadPublicAnalysis x1 x2 x3 x4 x6 cd cs) cd cs)
    (d_OP_getInterfaceInfos_dot_uscore_hash_lambda18 x3 x4 x7 x1 x2) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_getInterfaceInfos x1
    x2 x3 x4 l cd cs) (d_C_getInterfaceInfos x1 x2 x3 x4 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_getInterfaceInfos x1 x2 x3 x4 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_C_getInterfaceInfos x1 x2 x3 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Analysis.Files.getInterfaceInfos" [show x1, show x2, show x3, show x4, show
    x5] info)
  _ -> failCons cd (consFail "Analysis.Files.getInterfaceInfos" (showCons x5))

nd_C_getInterfaceInfos :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func
  Curry_Prelude.OP_Unit (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Analysis.Curry_ProgInfo.C_ProgInfo t0)
nd_C_getInterfaceInfos x1 x2 x3 x4 x5 s cd cs = case x5 of
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    s0 cd cs) (Analysis.Curry_ProgInfo.d_C_emptyProgInfo cd cs) s1 cd cs))
  Curry_Prelude.OP_Cons x6 x7 -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s3 = rightSupply s6
    in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    s0 cd cs) (nd_C_loadPublicAnalysis x1 x2 x3 x4 x6 s1 cd cs) s2 cd cs))))
    (wrapNX id (nd_OP_getInterfaceInfos_dot_uscore_hash_lambda18 x3 x4 x7 x1
    x2)) s5 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_getInterfaceInfos x1
    x2 x3 x4 l s cd cs) (nd_C_getInterfaceInfos x1 x2 x3 x4 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_C_getInterfaceInfos x1 x2 x3 x4 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    nd_C_getInterfaceInfos x1 x2 x3 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Analysis.Files.getInterfaceInfos" [show x1, show x2, show x3, show x4, show
    x5] info)
  _ -> failCons cd (consFail "Analysis.Files.getInterfaceInfos" (showCons x5))

d_OP_getInterfaceInfos_dot_uscore_hash_lambda18 :: forall t0 . (Curry_Prelude.Curry
  t0) => Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Analysis.Curry_ProgInfo.C_ProgInfo t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Analysis.Curry_ProgInfo.C_ProgInfo t0)
d_OP_getInterfaceInfos_dot_uscore_hash_lambda18 x1 x2 x3 x4 x5 x6 cd cs =
  let x7 = x6
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_getInterfaceInfos x4 x5 x1 x2 x3 cd cs) cd cs)
  (d_OP_getInterfaceInfos_dot_uscore_hash_lambda18_dot_uscore_hash_lambda20 x7)
  cd cs

nd_OP_getInterfaceInfos_dot_uscore_hash_lambda18 :: forall t0 . (Curry_Prelude.Curry
  t0) => Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func Curry_Prelude.OP_Unit
  (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Analysis.Curry_ProgInfo.C_ProgInfo t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Analysis.Curry_ProgInfo.C_ProgInfo t0)
nd_OP_getInterfaceInfos_dot_uscore_hash_lambda18 x1 x2 x3 x4 x5 x6 s cd cs =
  let s6 = s
  in s6 `seq` (let x7 = x6
  in let s5 = leftSupply s6
         s3 = rightSupply s6
  in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                      s4 = rightSupply s3
                                                      s0 = leftSupply s4
                                                      s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (nd_C_getInterfaceInfos x4 x5 x1 x2 x3 s1 cd cs) s2 cd cs))))
  (wrapDX id
  (d_OP_getInterfaceInfos_dot_uscore_hash_lambda18_dot_uscore_hash_lambda20 x7))
  s5 cd cs))

d_OP_getInterfaceInfos_dot_uscore_hash_lambda18_dot_uscore_hash_lambda20 :: forall t0 . (Curry_Prelude.Curry
  t0) => Analysis.Curry_ProgInfo.C_ProgInfo t0
  -> Analysis.Curry_ProgInfo.C_ProgInfo t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Analysis.Curry_ProgInfo.C_ProgInfo t0)
d_OP_getInterfaceInfos_dot_uscore_hash_lambda18_dot_uscore_hash_lambda20 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Analysis.Curry_ProgInfo.d_C_combineProgInfo x1 x3 cd cs) cd cs

d_C_loadDefaultAnalysisValues :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0))
d_C_loadDefaultAnalysisValues x1 x2 x3 x4 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_findModuleSourceInLoadPath x4 cd cs) cd cs)
  (d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24 x2 x3 x4 x1) cd cs

nd_C_loadDefaultAnalysisValues :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0))
nd_C_loadDefaultAnalysisValues x1 x2 x3 x4 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (d_C_findModuleSourceInLoadPath x4 cd cs) s1 cd cs)) (wrapNX id
  (nd_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24 x2 x3 x4 x1)) s3 cd
  cs))

d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24 :: forall t0 . (Curry_Prelude.Curry
  t0) => Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0))
d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24 x1 x2 x3 x4 x5 cd cs =
  case x5 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let x8 = Curry_Prelude.d_OP_plus_plus
                                         (System.Curry_CurryPath.d_C_stripCurrySuffix
                                         x7 cd cs) (Curry_Prelude.d_OP_plus_plus
                                         (Curry_Prelude.toCurryString
                                         ".defaults.") x2 cd cs) cd cs
    in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_Directory.d_C_doesFileExist x8 cd cs) cd cs)
    (d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26
    x1 x8 x3 x4) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24 x1 x2 x3 x4 l cd
    cs) (d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24 x1 x2 x3 x4 r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24 x1 x2 x3 x4 z cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24 x1 x2 x3 x4 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Files.loadDefaultAnalysisValues._#lambda24" [show x1, show x2
    , show x3, show x4, show x5] info)
  _ -> failCons cd (consFail
    "Analysis.Files.loadDefaultAnalysisValues._#lambda24" (showCons x5))

nd_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24 :: forall t0 . (Curry_Prelude.Curry
  t0) => Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0))
nd_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24 x1 x2 x3 x4 x5 s cd cs =
  case x5 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s4 = s
    in s4 `seq` (let x8 = Curry_Prelude.d_OP_plus_plus
                       (System.Curry_CurryPath.d_C_stripCurrySuffix x7 cd cs)
                       (Curry_Prelude.d_OP_plus_plus
                       (Curry_Prelude.toCurryString ".defaults.") x2 cd cs) cd
                       cs
    in let s3 = leftSupply s4
           s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    s0 cd cs) (System.Curry_Directory.d_C_doesFileExist x8 cd cs) s1 cd cs))
    (wrapNX id
    (nd_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26
    x1 x8 x3 x4)) s3 cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24 x1 x2 x3 x4 l s cd
    cs) (nd_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24 x1 x2 x3 x4 r
    s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24 x1 x2 x3 x4 z s cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24 x1 x2 x3 x4 e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Files.loadDefaultAnalysisValues._#lambda24" [show x1, show x2
    , show x3, show x4, show x5] info)
  _ -> failCons cd (consFail
    "Analysis.Files.loadDefaultAnalysisValues._#lambda24" (showCons x5))

d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26 :: forall t0 . (Curry_Prelude.Curry
  t0) => Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0))
d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26 x1 x2 x3 x4 x5 cd cs =
  case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Analysis.Curry_Logging.d_C_debugMessage x1 (Curry_Prelude.C_Int (3))
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "Load default values from ") x2 cd cs) cd cs) cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Curry_Prelude.d_C_readFile x2 cd cs) cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Curry_Prelude.d_C_read
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_lbracket_rbracket_hash_0_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Prelude_dot_Char_hash)
    x4))) cd cs) cd cs) cd cs)
    (d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26_dot_uscore_hash_lambda29
    x3) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) Curry_Prelude.OP_List cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26
    x1 x2 x3 x4 l cd cs)
    (d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26
    x1 x2 x3 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26
    x1 x2 x3 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x ->
    d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26
    x1 x2 x3 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Files.loadDefaultAnalysisValues._#lambda24._#lambda26" [show x1
    , show x2, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail
    "Analysis.Files.loadDefaultAnalysisValues._#lambda24._#lambda26" (showCons
    x5))

nd_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26 :: forall t0 . (Curry_Prelude.Curry
  t0) => Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0))
nd_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26 x1 x2 x3 x4 x5 s cd cs =
  case x5 of
  Curry_Prelude.C_True -> let s19 = s
    in s19 `seq` (let s18 = leftSupply s19
                      s20 = rightSupply s19
                      s2 = leftSupply s20
                      s17 = rightSupply s20
    in s18 `seq` (s20 `seq` (s2 `seq` (s17 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    s0 cd cs) (Analysis.Curry_Logging.d_C_debugMessage x1 (Curry_Prelude.C_Int
    (3)) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "Load default values from ") x2 cd cs) cd cs) s1 cd cs))
    (let s16 = leftSupply s17
         s14 = rightSupply s17
    in s16 `seq` (s14 `seq` Curry_Prelude.nd_C_apply (let s13 = leftSupply s14
                                                          s15 = rightSupply s14
                                                          s3 = leftSupply s15
                                                          s11 = rightSupply s15
    in s13 `seq` (s15 `seq` (s3 `seq` (s11 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    s3 cd cs) (let s10 = leftSupply s11
                   s12 = rightSupply s11
                   s6 = leftSupply s12
                   s9 = rightSupply s12
    in s10 `seq` (s12 `seq` (s6 `seq` (s9 `seq` Curry_Prelude.nd_C_apply
    (let s5 = leftSupply s6
         s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    s4 cd cs) (Curry_Prelude.d_C_readFile x2 cd cs) s5 cd cs))
    (let s8 = leftSupply s9
         s7 = rightSupply s9
    in s8 `seq` (s7 `seq` Curry_Prelude.nd_OP_dot
    (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    s7 cd cs) (wrapNX id (Curry_Prelude.nd_C_read (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Prelude_dot_Char_hash)))
    x4)))))) s8 cd cs)) s10 cd cs)))) s13 cd cs)))) (wrapDX id
    (d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26_dot_uscore_hash_lambda29
    x3)) s16 cd cs)) s18 cd cs))))
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    s0 cd cs) Curry_Prelude.OP_List s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (nd_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26
    x1 x2 x3 x4 l s cd cs)
    (nd_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26
    x1 x2 x3 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    nd_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26
    x1 x2 x3 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x ->
    nd_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26
    x1 x2 x3 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Files.loadDefaultAnalysisValues._#lambda24._#lambda26" [show x1
    , show x2, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail
    "Analysis.Files.loadDefaultAnalysisValues._#lambda24._#lambda26" (showCons
    x5))

d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26_dot_uscore_hash_lambda29 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0)
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0))
d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26_dot_uscore_hash_lambda29 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_map
  (d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31
  x1) x3 cd cs) cd cs

d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0
d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31 x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_Tuple2 x1 x3) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31
    x1 l cd cs)
    (d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31
    x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_loadDefaultAnalysisValues_dot_uscore_hash_lambda24_dot_uscore_hash_lambda26_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Files.loadDefaultAnalysisValues._#lambda24._#lambda26._#lambda29._#lambda31"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Analysis.Files.loadDefaultAnalysisValues._#lambda24._#lambda26._#lambda29._#lambda31"
    (showCons x2))

d_C_loadCompleteAnalysis :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Analysis.Curry_ProgInfo.C_ProgInfo t0)
d_C_loadCompleteAnalysis x1 x2 x3 x4 x5 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_getAnalysisBaseFile x5 x4 cd cs) cd cs)
  (Analysis.Curry_ProgInfo.d_C_readAnalysisFiles x1 x2 x3) cd cs

nd_C_loadCompleteAnalysis :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func
  Curry_Prelude.OP_Unit (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Analysis.Curry_ProgInfo.C_ProgInfo t0)
nd_C_loadCompleteAnalysis x1 x2 x3 x4 x5 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (d_C_getAnalysisBaseFile x5 x4 cd cs) s1 cd cs)) (wrapNX id
  (Analysis.Curry_ProgInfo.nd_C_readAnalysisFiles x1 x2 x3)) s3 cd cs))

d_C_loadPublicAnalysis :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Analysis.Curry_ProgInfo.C_ProgInfo t0)
d_C_loadPublicAnalysis x1 x2 x3 x4 x5 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_getAnalysisPublicFile x5 x4 cd cs) cd cs)
  (Analysis.Curry_ProgInfo.d_C_readAnalysisPublicFile x1 x2 x3) cd cs

nd_C_loadPublicAnalysis :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func
  Curry_Prelude.OP_Unit (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Analysis.Curry_ProgInfo.C_ProgInfo t0)
nd_C_loadPublicAnalysis x1 x2 x3 x4 x5 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (d_C_getAnalysisPublicFile x5 x4 cd cs) s1 cd cs)) (wrapNX id
  (Analysis.Curry_ProgInfo.nd_C_readAnalysisPublicFile x1 x2 x3)) s3 cd cs))

d_C_storeImportModuleList :: Analysis.Curry_Logging.C_DLevel
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_storeImportModuleList x1 x2 x3 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_getAnalysisBaseFile x2 (Curry_Prelude.toCurryString "IMPORTLIST")
  cd cs) cd cs) (d_OP_storeImportModuleList_dot_uscore_hash_lambda33 x1 x3) cd
  cs

d_OP_storeImportModuleList_dot_uscore_hash_lambda33 :: Analysis.Curry_Logging.C_DLevel
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_storeImportModuleList_dot_uscore_hash_lambda33 x1 x2 x3 cd cs = let x4 = x3
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_createDirectoryR x1 (Curry_Prelude.d_C_apply
  (System.Curry_FilePath.d_C_dropFileName cd cs) x4 cd cs) cd cs) cd cs)
  (Curry_Prelude.d_C_writeFile x4 (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
  cd cs) x2 cd cs) cd cs) cd cs

d_C_getImportModuleListFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_getImportModuleListFile x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_getAnalysisBaseFile x1 (Curry_Prelude.toCurryString "IMPORTLIST")
  cd cs) cd cs) d_OP_getImportModuleListFile_dot_uscore_hash_lambda37 cd cs

d_OP_getImportModuleListFile_dot_uscore_hash_lambda37 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_getImportModuleListFile_dot_uscore_hash_lambda37 x1 cd cs = let x2 = x1
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_Directory.d_C_doesFileExist x2 cd cs) cd cs)
  (d_OP_getImportModuleListFile_dot_uscore_hash_lambda37_dot_uscore_hash_lambda39
  x2) cd cs

d_OP_getImportModuleListFile_dot_uscore_hash_lambda37_dot_uscore_hash_lambda39 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_getImportModuleListFile_dot_uscore_hash_lambda37_dot_uscore_hash_lambda39 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_OP_dollar
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C__case_1 x1 x3 cd cs) cd cs

d_C_storeAnalysisResult :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Analysis.Curry_ProgInfo.C_ProgInfo t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_storeAnalysisResult x1 x2 x3 x4 x5 x6 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_getAnalysisBaseFile x5 x4 cd cs) cd cs)
  (d_OP_storeAnalysisResult_dot_uscore_hash_lambda42 x3 x6 x1 x2) cd cs

nd_C_storeAnalysisResult :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Func
  Curry_Prelude.OP_Unit (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Analysis.Curry_ProgInfo.C_ProgInfo t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_C_storeAnalysisResult x1 x2 x3 x4 x5 x6 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (d_C_getAnalysisBaseFile x5 x4 cd cs) s1 cd cs)) (wrapNX id
  (nd_OP_storeAnalysisResult_dot_uscore_hash_lambda42 x3 x6 x1 x2)) s3 cd cs))

d_OP_storeAnalysisResult_dot_uscore_hash_lambda42 :: forall t0 . (Curry_Prelude.Curry
  t0) => Analysis.Curry_Logging.C_DLevel -> Analysis.Curry_ProgInfo.C_ProgInfo
  t0 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_storeAnalysisResult_dot_uscore_hash_lambda42 x1 x2 x3 x4 x5 cd cs =
  let x6 = x5
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_createDirectoryR x1 (Curry_Prelude.d_C_apply
  (System.Curry_FilePath.d_C_dropFileName cd cs) x6 cd cs) cd cs) cd cs)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Analysis.Curry_Logging.d_C_debugMessage x1 (Curry_Prelude.C_Int (4))
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Analysis result: ") (Analysis.Curry_ProgInfo.d_C_showProgInfo x3 x2 cd cs) cd
  cs) cd cs) cd cs) (Analysis.Curry_ProgInfo.d_C_writeAnalysisFiles x4 x3 x1 x6
  x2 cd cs) cd cs) cd cs

nd_OP_storeAnalysisResult_dot_uscore_hash_lambda42 :: forall t0 . (Curry_Prelude.Curry
  t0) => Analysis.Curry_Logging.C_DLevel -> Analysis.Curry_ProgInfo.C_ProgInfo
  t0 -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Func Curry_Prelude.OP_Unit (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_OP_storeAnalysisResult_dot_uscore_hash_lambda42 x1 x2 x3 x4 x5 s cd cs =
  let s15 = s
  in s15 `seq` (let x6 = x5
  in let s14 = leftSupply s15
         s16 = rightSupply s15
         s3 = leftSupply s16
         s12 = rightSupply s16
  in s14 `seq` (s16 `seq` (s3 `seq` (s12 `seq` Curry_Prelude.nd_C_apply
  (let s2 = leftSupply s3
       s4 = rightSupply s3
       s0 = leftSupply s4
       s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (d_C_createDirectoryR x1 (Curry_Prelude.nd_C_apply (wrapDX id
  (System.Curry_FilePath.d_C_dropFileName cd cs)) x6 s1 cd cs) cd cs) s2 cd
  cs)))) (let s11 = leftSupply s12
              s13 = rightSupply s12
              s8 = leftSupply s13
              s10 = rightSupply s13
  in s11 `seq` (s13 `seq` (s8 `seq` (s10 `seq` Curry_Prelude.nd_C_apply
  (let s7 = leftSupply s8
       s9 = rightSupply s8
       s5 = leftSupply s9
       s6 = rightSupply s9
  in s7 `seq` (s9 `seq` (s5 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s5 cd cs) (Analysis.Curry_Logging.d_C_debugMessage x1 (Curry_Prelude.C_Int
  (4)) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Analysis result: ") (Analysis.Curry_ProgInfo.nd_C_showProgInfo x3 x2 s6 cd
  cs) cd cs) cd cs) s7 cd cs))))
  (Analysis.Curry_ProgInfo.nd_C_writeAnalysisFiles x4 x3 x1 x6 x2 s10 cd cs) s11
  cd cs)))) s14 cd cs))))

d_C_createDirectoryR :: Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_C_createDirectoryR x1 x2 cd cs = let x3 = System.Curry_FilePath.d_C_splitDrive
                                         x2 cd cs
                                       x4 = d_OP_createDirectoryR_dot_uscore_hash_selFP2_hash_drv
                                         x3 cd cs
                                       x5 = d_OP_createDirectoryR_dot_uscore_hash_selFP3_hash_dir
                                         x3 cd cs
  in d_OP_createDirectoryR_dot_createDirectories_dot_51 x1 x4
  (System.Curry_FilePath.d_C_splitDirectories x5 cd cs) cd cs

d_OP_createDirectoryR_dot_createDirectories_dot_51 :: Analysis.Curry_Logging.C_DLevel
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_createDirectoryR_dot_createDirectories_dot_51 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) Curry_Prelude.OP_Unit cd cs
  Curry_Prelude.OP_Cons x4 x5 -> let x6 = Curry_Prelude.d_C_apply
                                       (Curry_Prelude.d_C_apply
                                       (System.Curry_FilePath.d_OP_lt_slash_gt
                                       cd cs) x2 cd cs) x4 cd cs
    in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_Directory.d_C_doesDirectoryExist x6 cd cs) cd cs)
    (d_OP_createDirectoryR_dot_createDirectories_dot_51_dot_uscore_hash_lambda45
    x1 x6 x5) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_createDirectoryR_dot_createDirectories_dot_51 x1 x2 l cd cs)
    (d_OP_createDirectoryR_dot_createDirectories_dot_51 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_createDirectoryR_dot_createDirectories_dot_51 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_createDirectoryR_dot_createDirectories_dot_51 x1 x2 e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Analysis.Files.createDirectoryR.createDirectories.51" [show x1, show x2
    , show x3] info)
  _ -> failCons cd (consFail
    "Analysis.Files.createDirectoryR.createDirectories.51" (showCons x3))

d_OP_createDirectoryR_dot_createDirectories_dot_51_dot_uscore_hash_lambda45 :: Analysis.Curry_Logging.C_DLevel
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_createDirectoryR_dot_createDirectories_dot_51_dot_uscore_hash_lambda45 x1 x2 x3 x4 cd cs =
  let x5 = x4
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar (Control.Curry_Monad.d_C_unless
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_Prelude_dot_IO_hash
  x5) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Analysis.Curry_Logging.d_C_debugMessage x1 (Curry_Prelude.C_Int (3))
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Creating directory '") (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "'...") cd cs) cd cs) cd cs) cd cs)
  (System.Curry_Directory.d_C_createDirectory x2 cd cs) cd cs) cd cs) cd cs)
  (d_OP_createDirectoryR_dot_createDirectories_dot_51 x1 x2 x3 cd cs) cd cs

d_OP_createDirectoryR_dot_uscore_hash_selFP2_hash_drv :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_createDirectoryR_dot_uscore_hash_selFP2_hash_drv x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_createDirectoryR_dot_uscore_hash_selFP2_hash_drv l cd cs)
    (d_OP_createDirectoryR_dot_uscore_hash_selFP2_hash_drv r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_createDirectoryR_dot_uscore_hash_selFP2_hash_drv z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_createDirectoryR_dot_uscore_hash_selFP2_hash_drv e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Files.createDirectoryR._#selFP2#drv" [show x1] info)
  _ -> failCons cd (consFail "Analysis.Files.createDirectoryR._#selFP2#drv"
    (showCons x1))

d_OP_createDirectoryR_dot_uscore_hash_selFP3_hash_dir :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_createDirectoryR_dot_uscore_hash_selFP3_hash_dir x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_createDirectoryR_dot_uscore_hash_selFP3_hash_dir l cd cs)
    (d_OP_createDirectoryR_dot_uscore_hash_selFP3_hash_dir r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_createDirectoryR_dot_uscore_hash_selFP3_hash_dir z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_createDirectoryR_dot_uscore_hash_selFP3_hash_dir e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Files.createDirectoryR._#selFP3#dir" [show x1] info)
  _ -> failCons cd (consFail "Analysis.Files.createDirectoryR._#selFP3#dir"
    (showCons x1))

d_C_deleteAllAnalysisFiles :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_deleteAllAnalysisFiles x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_getAnalysisDirectory cd cs) cd cs)
  (d_OP_deleteAllAnalysisFiles_dot_uscore_hash_lambda54 x1) cd cs

d_OP_deleteAllAnalysisFiles_dot_deleteAllInDir_dot_63 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_deleteAllAnalysisFiles_dot_deleteAllInDir_dot_63 x1 x2 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_Directory.d_C_getDirectoryContents x2 cd cs) cd cs)
  (d_OP_deleteAllAnalysisFiles_dot_deleteAllInDir_dot_63_dot_uscore_hash_lambda51
  x1 x2) cd cs

d_OP_deleteAllAnalysisFiles_dot_deleteAllInDir_dot_63_dot_isAnaFile_dot_65 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_deleteAllAnalysisFiles_dot_deleteAllInDir_dot_63_dot_isAnaFile_dot_65 x1 x2 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_any
  (d_OP_deleteAllAnalysisFiles_dot_deleteAllInDir_dot_63_dot_isAnaFile_dot_65_dot_hasAnaSuffix_dot_72
  x1 x2) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ".pub")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ".priv")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ".pub.rw")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ".priv.rw")
  Curry_Prelude.OP_List)))) cd cs

d_OP_deleteAllAnalysisFiles_dot_deleteAllInDir_dot_63_dot_isAnaFile_dot_65_dot_hasAnaSuffix_dot_72 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_OP_deleteAllAnalysisFiles_dot_deleteAllInDir_dot_63_dot_isAnaFile_dot_65_dot_hasAnaSuffix_dot_72 x1 x2 x3 cd cs =
  Curry_Prelude.d_OP_amp_amp (Data.Curry_List.d_C_isSuffixOf
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x3 x2 cd cs) (Data.Curry_List.d_C_isSuffixOf
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '.'#) x1) (Curry_Prelude.d_C_take
  (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_length x2 cd cs) (Curry_Prelude.d_C_length x3 cd cs) cd cs)
  x2 cd cs) cd cs) cd cs

d_OP_deleteAllAnalysisFiles_dot_deleteAllInDir_dot_63_dot_processDirElem_dot_65 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_deleteAllAnalysisFiles_dot_deleteAllInDir_dot_63_dot_processDirElem_dot_65 x1 x2 x3 cd cs =
  let x4 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
        (System.Curry_FilePath.d_OP_lt_slash_gt cd cs) x2 cd cs) x3 cd cs
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar (Control.Curry_Applicative.d_C_when
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_Prelude_dot_IO_hash
  (d_OP_deleteAllAnalysisFiles_dot_deleteAllInDir_dot_63_dot_isAnaFile_dot_65 x1
  x3 cd cs)) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_putStrLn (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "DELETE: ") x4 cd cs) cd cs) cd cs)
  (System.Curry_Directory.d_C_removeFile x4 cd cs) cd cs) cd cs) cd cs)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_Directory.d_C_doesDirectoryExist x4 cd cs) cd cs)
  (d_OP_deleteAllAnalysisFiles_dot_deleteAllInDir_dot_63_dot_processDirElem_dot_65_dot_uscore_hash_lambda48
  x1 x4) cd cs) cd cs

d_OP_deleteAllAnalysisFiles_dot_deleteAllInDir_dot_63_dot_processDirElem_dot_65_dot_uscore_hash_lambda48 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_OP_deleteAllAnalysisFiles_dot_deleteAllInDir_dot_63_dot_processDirElem_dot_65_dot_uscore_hash_lambda48 x1 x2 x3 cd cs =
  let x4 = x3
  in Curry_Prelude.d_OP_dollar (Control.Curry_Applicative.d_C_when
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_Prelude_dot_IO_hash
  x4) (d_OP_deleteAllAnalysisFiles_dot_deleteAllInDir_dot_63 x1 x2 cd cs) cd cs

d_OP_deleteAllAnalysisFiles_dot_deleteAllInDir_dot_63_dot_uscore_hash_lambda51 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_deleteAllAnalysisFiles_dot_deleteAllInDir_dot_63_dot_uscore_hash_lambda51 x1 x2 x3 cd cs =
  let x4 = x3
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_mapM_
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  (d_OP_deleteAllAnalysisFiles_dot_deleteAllInDir_dot_63_dot_processDirElem_dot_65
  x1 x2) cd cs) (Curry_Prelude.d_C_filter (Curry_Prelude.d_OP_dot
  Curry_Prelude.d_C_not (Data.Curry_List.d_C_isPrefixOf
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  (Curry_Prelude.toCurryString ".")) cd cs) x4 cd cs) cd cs

d_OP_deleteAllAnalysisFiles_dot_uscore_hash_lambda54 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_deleteAllAnalysisFiles_dot_uscore_hash_lambda54 x1 x2 cd cs = let x3 = x2
  in d_OP_deleteAllAnalysisFiles_dot_deleteAllInDir_dot_63 x1 x3 cd cs

d_C_findModuleSourceInLoadPath :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_findModuleSourceInLoadPath x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_CurryPath.d_C_lookupModuleSourceInLoadPath x1 cd cs) cd
  cs) (Curry_Prelude.d_C_maybe (Curry_Prelude.d_OP_dollar
  Curry_Prelude.d_C_error (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "Source file for module '")
  (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString "' not found!")
  cd cs) cd cs) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs)) cd cs

d_C_getImports :: Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_getImports x1 x2 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar (Analysis.Curry_Logging.d_C_debugMessage x1
  (Curry_Prelude.C_Int (3))) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "Reading interface of module ") x2 cd cs) cd cs)
  cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_readNewestFlatCurryInt x2 cd cs) cd cs) (Curry_Prelude.d_OP_dot
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (FlatCurry.Curry_Goodies.d_C_progImports cd cs) cd cs) cd cs) cd cs

d_C_getSourceFileTime :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Data.Curry_Time.C_ClockTime)
d_C_getSourceFileTime x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_findModuleSourceInLoadPath x1 cd cs) cd cs)
  (d_OP_getSourceFileTime_dot_uscore_hash_lambda58 x1) cd cs

d_OP_getSourceFileTime_dot_uscore_hash_lambda58 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Data.Curry_Time.C_ClockTime)
d_OP_getSourceFileTime_dot_uscore_hash_lambda58 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_Directory.d_C_getModificationTime x4 cd cs) cd cs)
    (d_OP_getSourceFileTime_dot_uscore_hash_lambda58_dot_uscore_hash_lambda60
    x1) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_getSourceFileTime_dot_uscore_hash_lambda58 x1 l cd cs)
    (d_OP_getSourceFileTime_dot_uscore_hash_lambda58 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_getSourceFileTime_dot_uscore_hash_lambda58 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_getSourceFileTime_dot_uscore_hash_lambda58 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Files.getSourceFileTime._#lambda58" [show x1, show x2] info)
  _ -> failCons cd (consFail "Analysis.Files.getSourceFileTime._#lambda58"
    (showCons x2))

d_OP_getSourceFileTime_dot_uscore_hash_lambda58_dot_uscore_hash_lambda60 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Data.Curry_Time.C_ClockTime -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Data.Curry_Time.C_ClockTime)
d_OP_getSourceFileTime_dot_uscore_hash_lambda58_dot_uscore_hash_lambda60 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.OP_Tuple2 x1 x3) cd cs

d_C_getFlatCurryFileTime :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  Data.Curry_Time.C_ClockTime))
d_C_getFlatCurryFileTime x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (FlatCurry.Curry_Files.d_C_lookupFlatCurryFileInLoadPath x1 cd cs) cd
  cs) (Curry_Prelude.d_C_maybe (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.OP_Tuple2 x1 Curry_Prelude.C_Nothing) cd cs)
  (d_OP_getFlatCurryFileTime_dot_uscore_hash_lambda62 x1)) cd cs

d_OP_getFlatCurryFileTime_dot_uscore_hash_lambda62 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  Data.Curry_Time.C_ClockTime))
d_OP_getFlatCurryFileTime_dot_uscore_hash_lambda62 x1 x2 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_Directory.d_C_getModificationTime x2 cd cs) cd cs)
  (d_OP_getFlatCurryFileTime_dot_uscore_hash_lambda62_dot_uscore_hash_lambda64
  x1) cd cs

d_OP_getFlatCurryFileTime_dot_uscore_hash_lambda62_dot_uscore_hash_lambda64 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Data.Curry_Time.C_ClockTime -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe Data.Curry_Time.C_ClockTime))
d_OP_getFlatCurryFileTime_dot_uscore_hash_lambda62_dot_uscore_hash_lambda64 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.OP_Tuple2 x1 (Curry_Prelude.C_Just x3)) cd cs

d_C_flatCurryFileNewer :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_flatCurryFileNewer x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_findModuleSourceInLoadPath x1 cd cs) cd cs)
  (d_OP_flatCurryFileNewer_dot_uscore_hash_lambda68 x1) cd cs

d_OP_flatCurryFileNewer_dot_uscore_hash_lambda68 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_flatCurryFileNewer_dot_uscore_hash_lambda68 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_Directory.d_C_getModificationTime x4 cd cs) cd cs)
    (d_OP_flatCurryFileNewer_dot_uscore_hash_lambda68_dot_uscore_hash_lambda70
    x1) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_flatCurryFileNewer_dot_uscore_hash_lambda68 x1 l cd cs)
    (d_OP_flatCurryFileNewer_dot_uscore_hash_lambda68 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_flatCurryFileNewer_dot_uscore_hash_lambda68 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_flatCurryFileNewer_dot_uscore_hash_lambda68 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Analysis.Files.flatCurryFileNewer._#lambda68" [show x1, show x2] info)
  _ -> failCons cd (consFail "Analysis.Files.flatCurryFileNewer._#lambda68"
    (showCons x2))

d_OP_flatCurryFileNewer_dot_uscore_hash_lambda68_dot_uscore_hash_lambda70 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Data.Curry_Time.C_ClockTime -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_flatCurryFileNewer_dot_uscore_hash_lambda68_dot_uscore_hash_lambda70 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (FlatCurry.Curry_Files.d_C_lookupFlatCurryFileInLoadPath x1 cd cs) cd
  cs) (Curry_Prelude.d_C_maybe (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) Curry_Prelude.C_Nothing cd cs)
  (d_OP_flatCurryFileNewer_dot_uscore_hash_lambda68_dot_uscore_hash_lambda70_dot_uscore_hash_lambda72
  x3)) cd cs

d_OP_flatCurryFileNewer_dot_uscore_hash_lambda68_dot_uscore_hash_lambda70_dot_uscore_hash_lambda72 :: Data.Curry_Time.C_ClockTime
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_flatCurryFileNewer_dot_uscore_hash_lambda68_dot_uscore_hash_lambda70_dot_uscore_hash_lambda72 x1 x2 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_Directory.d_C_getModificationTime x2 cd cs) cd cs)
  (d_OP_flatCurryFileNewer_dot_uscore_hash_lambda68_dot_uscore_hash_lambda70_dot_uscore_hash_lambda72_dot_uscore_hash_lambda74
  x1 x2) cd cs

d_OP_flatCurryFileNewer_dot_uscore_hash_lambda68_dot_uscore_hash_lambda70_dot_uscore_hash_lambda72_dot_uscore_hash_lambda74 :: Data.Curry_Time.C_ClockTime
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Data.Curry_Time.C_ClockTime
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_flatCurryFileNewer_dot_uscore_hash_lambda68_dot_uscore_hash_lambda70_dot_uscore_hash_lambda72_dot_uscore_hash_lambda74 x1 x2 x3 cd cs =
  let x4 = x3
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C__case_0 x1 x4 x2 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Data.Curry_Time.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Data_dot_Time_dot_ClockTime_hash
  cd cs) x4 cd cs) x1 cd cs) cd cs) cd cs

d_C_readNewestFlatCurry :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO FlatCurry.Curry_Types.C_Prog
d_C_readNewestFlatCurry x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_flatCurryFileNewer x1 cd cs) cd cs) (Curry_Prelude.d_C_maybe
  (FlatCurry.Curry_Files.d_C_readFlatCurry x1 cd cs)
  FlatCurry.Curry_Files.d_C_readFlatCurryFile) cd cs

d_C_readNewestFlatCurryInt :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.C_IO FlatCurry.Curry_Types.C_Prog
d_C_readNewestFlatCurryInt x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_flatCurryFileNewer x1 cd cs) cd cs) (Curry_Prelude.d_C_maybe
  (FlatCurry.Curry_Files.d_C_readFlatCurryInt x1 cd cs) (Curry_Prelude.d_OP_dot
  FlatCurry.Curry_Files.d_C_readFlatCurryFile d_C_flat2intName cd cs)) cd cs

d_C_flat2intName :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_flat2intName x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_reverse
  cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "tnif")
  (Curry_Prelude.d_C_drop (Curry_Prelude.C_Int (3)) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_reverse cd cs) x1 cd cs) cd cs) cd cs) cd cs

d_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_3 x5 x3 x2 x1 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (System.Curry_FilePath.d_OP_lt_slash_gt cd cs) x1 cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (System.Curry_FilePath.d_OP_lt_slash_gt cd cs) (Curry_Prelude.d_C_apply
    (System.Curry_FilePath.d_C_dropDrive cd cs) x5 cd cs) cd cs) x3 cd cs) cd
    cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (System.Curry_FilePath.d_OP_lt_slash_gt cd cs) x1 cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (System.Curry_FilePath.d_OP_lt_slash_gt cd cs) x2 cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (System.Curry_FilePath.d_OP_lt_slash_gt cd cs) x5 cd cs) x3 cd cs) cd cs) cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x5 x3 x2 x1 l
    cd cs) (d_C__case_3 x5 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x5 x3
    x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x5 x3 x2
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Files._case_3" [show x5, show x3, show x2, show x1, show x6] info)
  _ -> failCons cd (consFail "Analysis.Files._case_3" (showCons x6))

d_C__case_2 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> x1
  Curry_Prelude.C_False -> Curry.Compiler.Curry_Distribution.d_C_installDir cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x1 l cd cs)
    (d_C__case_2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Files._case_2" [show x1, show x3] info)
  _ -> failCons cd (consFail "Analysis.Files._case_2" (showCons x3))

d_C__case_1 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_1 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.C_Just x1
  Curry_Prelude.C_False -> Curry_Prelude.C_Nothing
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x1 l cd cs)
    (d_C__case_1 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Files._case_1" [show x1, show x3] info)
  _ -> failCons cd (consFail "Analysis.Files._case_1" (showCons x3))

d_C__case_0 :: Data.Curry_Time.C_ClockTime -> Data.Curry_Time.C_ClockTime
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_0 x1 x4 x2 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.C_Just x2
  Curry_Prelude.C_False -> Curry_Prelude.C_Nothing
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x1 x4 x2 l cd
    cs) (d_C__case_0 x1 x4 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x1 x4
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x1 x4 x2
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Files._case_0" [show x1, show x4, show x2, show x5] info)
  _ -> failCons cd (consFail "Analysis.Files._case_0" (showCons x5))

