{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Analysis.Curry_Logging
  ( C_DLevel (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Logging_dot_DLevel_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Logging_dot_DLevel_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_Logging_dot_DLevel_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
  , d_OP_uscore_impl_hash_succ_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
  , d_OP_uscore_impl_hash_pred_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
  , d_OP_uscore_impl_hash_toEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
  , d_OP_uscore_impl_hash_fromEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
  , d_OP_uscore_impl_hash_enumFrom_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
  , d_OP_uscore_impl_hash_enumFromThen_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
  , d_OP_uscore_impl_hash_enumFromTo_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
  , d_OP_uscore_impl_hash_enumFromThenTo_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
  , d_C_debugMessage
  , d_C_debugString )
  where

import Basics
import qualified Control.Curry_Applicative
import qualified Curry_Prelude
import qualified System.Curry_IO


data C_DLevel
  = C_Quiet
  | C_Timing
  | C_Communicate
  | C_Storage
  | C_AllData
  | Choice_C_DLevel Cover ID C_DLevel C_DLevel
  | Choices_C_DLevel Cover ID [C_DLevel]
  | Fail_C_DLevel Cover FailInfo
  | Guard_C_DLevel Cover Constraints C_DLevel

instance Show C_DLevel where
  showsPrec d (Choice_C_DLevel cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_DLevel cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_DLevel cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_DLevel cd info) = showChar '!'
  showsPrec _ C_Quiet = showString "Quiet"
  showsPrec _ C_Timing = showString "Timing"
  showsPrec _ C_Communicate = showString "Communicate"
  showsPrec _ C_Storage = showString "Storage"
  showsPrec _ C_AllData = showString "AllData"

instance Read C_DLevel where
  readsPrec _ s = readParen False (\r -> [(C_Quiet, r0) | (_, r0) <-
    readQualified "Analysis.Logging" "Quiet" r]) s ++ (readParen False (\r ->
    [(C_Timing, r0) | (_, r0) <- readQualified "Analysis.Logging" "Timing" r])
    s ++ (readParen False (\r -> [(C_Communicate, r0) | (_, r0) <- readQualified
    "Analysis.Logging" "Communicate" r]) s ++ (readParen False (\r ->
    [(C_Storage, r0) | (_, r0) <- readQualified "Analysis.Logging" "Storage" r])
    s ++ readParen False (\r -> [(C_AllData, r0) | (_, r0) <- readQualified
    "Analysis.Logging" "AllData" r]) s)))

instance NonDet C_DLevel where
  choiceCons = Choice_C_DLevel
  choicesCons = Choices_C_DLevel
  failCons = Fail_C_DLevel
  guardCons = Guard_C_DLevel
  try (Choice_C_DLevel cd i x y) = tryChoice cd i x y
  try (Choices_C_DLevel cd i xs) = tryChoices cd i xs
  try (Fail_C_DLevel cd info) = Fail cd info
  try (Guard_C_DLevel cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_DLevel cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_DLevel cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_DLevel cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_DLevel cd i _) = error
    ("Analysis.Logging.DLevel.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_DLevel cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_DLevel cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_DLevel where
  generate s c = Choices_C_DLevel c (freeID [0, 0, 0, 0, 0] s) [C_Quiet
    , C_Timing, C_Communicate, C_Storage, C_AllData]

instance NormalForm C_DLevel where
  ($!!) cont C_Quiet d cs = cont C_Quiet d cs
  ($!!) cont C_Timing d cs = cont C_Timing d cs
  ($!!) cont C_Communicate d cs = cont C_Communicate d cs
  ($!!) cont C_Storage d cs = cont C_Storage d cs
  ($!!) cont C_AllData d cs = cont C_AllData d cs
  ($!!) cont (Choice_C_DLevel cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_DLevel cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_DLevel cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_DLevel cd info) _ _ = failCons cd info
  ($##) cont C_Quiet d cs = cont C_Quiet d cs
  ($##) cont C_Timing d cs = cont C_Timing d cs
  ($##) cont C_Communicate d cs = cont C_Communicate d cs
  ($##) cont C_Storage d cs = cont C_Storage d cs
  ($##) cont C_AllData d cs = cont C_AllData d cs
  ($##) cont (Choice_C_DLevel cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_DLevel cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_DLevel cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_DLevel cd info) _ _ = failCons cd info
  showCons C_Quiet = "Analysis.Logging.Quiet"
  showCons C_Timing = "Analysis.Logging.Timing"
  showCons C_Communicate = "Analysis.Logging.Communicate"
  showCons C_Storage = "Analysis.Logging.Storage"
  showCons C_AllData = "Analysis.Logging.AllData"
  showCons x = error ("Analysis.Logging.DLevel.showCons: no constructor: " ++
    show x)
  searchNF _ cont C_Quiet = cont C_Quiet
  searchNF _ cont C_Timing = cont C_Timing
  searchNF _ cont C_Communicate = cont C_Communicate
  searchNF _ cont C_Storage = cont C_Storage
  searchNF _ cont C_AllData = cont C_AllData
  searchNF _ _ x = error
    ("Analysis.Logging.DLevel.searchNF: no constructor: " ++ show x)

instance Unifiable C_DLevel where
  (=.=) C_Quiet C_Quiet d cs = C_True
  (=.=) C_Timing C_Timing d cs = C_True
  (=.=) C_Communicate C_Communicate d cs = C_True
  (=.=) C_Storage C_Storage d cs = C_True
  (=.=) C_AllData C_AllData d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_Quiet C_Quiet d cs = C_True
  (=.<=) C_Timing C_Timing d cs = C_True
  (=.<=) C_Communicate C_Communicate d cs = C_True
  (=.<=) C_Storage C_Storage d cs = C_True
  (=.<=) C_AllData C_AllData d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_Quiet = (i :=: ChooseN 0 0) : concat []
  bind cd i C_Timing = (i :=: ChooseN 1 0) : concat []
  bind cd i C_Communicate = (i :=: ChooseN 2 0) : concat []
  bind cd i C_Storage = (i :=: ChooseN 3 0) : concat []
  bind cd i C_AllData = (i :=: ChooseN 4 0) : concat []
  bind d i (Choice_C_DLevel cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_DLevel cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_DLevel cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_DLevel cd i _) = error
    ("Analysis.Logging.DLevel.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_DLevel cd info) = [Unsolvable info]
  bind d i (Guard_C_DLevel cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_Quiet = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_Timing = (i :=: ChooseN 1 0) : []
  lazyBind cd i C_Communicate = (i :=: ChooseN 2 0) : []
  lazyBind cd i C_Storage = (i :=: ChooseN 3 0) : []
  lazyBind cd i C_AllData = (i :=: ChooseN 4 0) : []
  lazyBind d i (Choice_C_DLevel cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_DLevel cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_DLevel cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_DLevel cd i _) = error
    ("Analysis.Logging.DLevel.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_DLevel cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_DLevel cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_DLevel where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Logging_dot_DLevel_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_DLevel
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Logging_dot_DLevel_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Logging_dot_DLevel_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_Logging_dot_DLevel_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Logging_dot_DLevel_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Logging_dot_DLevel_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Logging_dot_DLevel_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Logging_dot_DLevel_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.Logging._inst#Prelude.Data#Analysis.Logging.DLevel#" [show x1]
    info)
  _ -> failCons cd (consFail
    "Analysis.Logging._inst#Prelude.Data#Analysis.Logging.DLevel#" (showCons
    x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Logging_dot_DLevel_hash :: C_DLevel
  -> C_DLevel -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Logging_dot_DLevel_hash x1 x2 cd cs =
  case x1 of
  C_Quiet -> d_C__case_5 x2 cd cs
  C_Timing -> d_C__case_4 x2 cd cs
  C_Communicate -> d_C__case_3 x2 cd cs
  C_Storage -> d_C__case_2 x2 cd cs
  C_AllData -> d_C__case_1 x2 cd cs
  Choice_C_DLevel d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Logging_dot_DLevel_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Logging_dot_DLevel_hash
    r x2 cd cs)
  Choices_C_DLevel d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Logging_dot_DLevel_hash
    z x2 cd cs) xs
  Guard_C_DLevel d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Logging_dot_DLevel_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_DLevel d info -> failCons d (traceFail
    "Analysis.Logging._impl#===#Prelude.Data#Analysis.Logging.DLevel#" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "Analysis.Logging._impl#===#Prelude.Data#Analysis.Logging.DLevel#" (showCons
    x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_Logging_dot_DLevel_hash :: IDSupply
  -> Cover -> ConstStore -> C_DLevel
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_Logging_dot_DLevel_hash s cd cs =
  let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s4 = rightSupply s6
  in s5 `seq` (s4 `seq` choice (let s3 = leftSupply s4
                                    s2 = rightSupply s4
  in s3 `seq` (s2 `seq` choice (let s1 = leftSupply s2
                                    s0 = rightSupply s2
  in s1 `seq` (s0 `seq` choice (choice C_Quiet C_Timing s0 cd cs) C_Communicate
  s1 cd cs)) C_Storage s3 cd cs)) C_AllData s5 cd cs))

d_OP_uscore_inst_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Enum C_DLevel
d_OP_uscore_inst_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Enum
    d_OP_uscore_impl_hash_succ_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    d_OP_uscore_impl_hash_pred_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    d_OP_uscore_impl_hash_toEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    d_OP_uscore_impl_hash_fromEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    d_OP_uscore_impl_hash_enumFrom_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    (acceptCs id
    d_OP_uscore_impl_hash_enumFromThen_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash)
    (d_OP_uscore_impl_hash_enumFromTo_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    cd cs)
    (d_OP_uscore_impl_hash_enumFromThenTo_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.Logging._inst#Prelude.Enum#Analysis.Logging.DLevel#" [show x1]
    info)
  _ -> failCons cd (consFail
    "Analysis.Logging._inst#Prelude.Enum#Analysis.Logging.DLevel#" (showCons
    x1))

nd_OP_uscore_inst_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Enum
  C_DLevel
nd_OP_uscore_inst_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Enum (wrapDX id
    d_OP_uscore_impl_hash_succ_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash)
    (wrapDX id
    d_OP_uscore_impl_hash_pred_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash)
    (wrapDX id
    d_OP_uscore_impl_hash_toEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash)
    (wrapDX id
    d_OP_uscore_impl_hash_fromEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash)
    (wrapDX id
    d_OP_uscore_impl_hash_enumFrom_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash)
    (wrapDX (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_enumFromThen_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_enumFromTo_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    cd cs)) (wrapDX (wrapDX (wrapDX id))
    (d_OP_uscore_impl_hash_enumFromThenTo_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.Logging._inst#Prelude.Enum#Analysis.Logging.DLevel#" [show x1]
    info)
  _ -> failCons cd (consFail
    "Analysis.Logging._inst#Prelude.Enum#Analysis.Logging.DLevel#" (showCons
    x1))

d_OP_uscore_impl_hash_succ_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash :: C_DLevel
  -> Cover -> ConstStore -> C_DLevel
d_OP_uscore_impl_hash_succ_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash x1 cd cs =
  case x1 of
  C_Quiet -> C_Timing
  C_Timing -> C_Communicate
  C_Communicate -> C_Storage
  C_Storage -> C_AllData
  C_AllData -> Curry_Prelude.d_C_failed cd cs
  Choice_C_DLevel d i l r -> narrow d i
    (d_OP_uscore_impl_hash_succ_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    l cd cs)
    (d_OP_uscore_impl_hash_succ_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    r cd cs)
  Choices_C_DLevel d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_succ_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    z cd cs) xs
  Guard_C_DLevel d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_succ_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    e cd x) $! addCs c cs)
  Fail_C_DLevel d info -> failCons d (traceFail
    "Analysis.Logging._impl#succ#Prelude.Enum#Analysis.Logging.DLevel#" [show
    x1] info)
  _ -> failCons cd (consFail
    "Analysis.Logging._impl#succ#Prelude.Enum#Analysis.Logging.DLevel#"
    (showCons x1))

d_OP_uscore_impl_hash_pred_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash :: C_DLevel
  -> Cover -> ConstStore -> C_DLevel
d_OP_uscore_impl_hash_pred_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash x1 cd cs =
  case x1 of
  C_Timing -> C_Quiet
  C_Communicate -> C_Timing
  C_Storage -> C_Communicate
  C_AllData -> C_Storage
  C_Quiet -> Curry_Prelude.d_C_failed cd cs
  Choice_C_DLevel d i l r -> narrow d i
    (d_OP_uscore_impl_hash_pred_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    l cd cs)
    (d_OP_uscore_impl_hash_pred_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    r cd cs)
  Choices_C_DLevel d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_pred_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    z cd cs) xs
  Guard_C_DLevel d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_pred_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    e cd x) $! addCs c cs)
  Fail_C_DLevel d info -> failCons d (traceFail
    "Analysis.Logging._impl#pred#Prelude.Enum#Analysis.Logging.DLevel#" [show
    x1] info)
  _ -> failCons cd (consFail
    "Analysis.Logging._impl#pred#Prelude.Enum#Analysis.Logging.DLevel#"
    (showCons x1))

d_OP_uscore_impl_hash_toEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash :: Curry_Prelude.C_Int
  -> Cover -> ConstStore -> C_DLevel
d_OP_uscore_impl_hash_toEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash x1 cd cs =
  case x1 of
  (Curry_Prelude.C_Int (0)) -> C_Quiet
  (Curry_Prelude.C_Int (1)) -> C_Timing
  (Curry_Prelude.C_Int (2)) -> C_Communicate
  (Curry_Prelude.C_Int (3)) -> C_Storage
  (Curry_Prelude.C_Int (4)) -> C_AllData
  Curry_Prelude.C_CurryInt l -> matchInteger [(0, C_Quiet), (1, C_Timing), (2
    , C_Communicate), (3, C_Storage), (4, C_AllData)] l cd cs
  Curry_Prelude.Choice_C_Int d i l r -> narrow d i
    (d_OP_uscore_impl_hash_toEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    l cd cs)
    (d_OP_uscore_impl_hash_toEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    r cd cs)
  Curry_Prelude.Choices_C_Int d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_toEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    z cd cs) xs
  Curry_Prelude.Guard_C_Int d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_toEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Int d info -> failCons d (traceFail
    "Analysis.Logging._impl#toEnum#Prelude.Enum#Analysis.Logging.DLevel#" [show
    x1] info)
  _ -> failCons cd (consFail
    "Analysis.Logging._impl#toEnum#Prelude.Enum#Analysis.Logging.DLevel#"
    (showCons x1))

d_OP_uscore_impl_hash_fromEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash :: C_DLevel
  -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_OP_uscore_impl_hash_fromEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash x1 cd cs =
  case x1 of
  C_Quiet -> Curry_Prelude.C_Int (0)
  C_Timing -> Curry_Prelude.C_Int (1)
  C_Communicate -> Curry_Prelude.C_Int (2)
  C_Storage -> Curry_Prelude.C_Int (3)
  C_AllData -> Curry_Prelude.C_Int (4)
  Choice_C_DLevel d i l r -> narrow d i
    (d_OP_uscore_impl_hash_fromEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    l cd cs)
    (d_OP_uscore_impl_hash_fromEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    r cd cs)
  Choices_C_DLevel d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_fromEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    z cd cs) xs
  Guard_C_DLevel d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_fromEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
    e cd x) $! addCs c cs)
  Fail_C_DLevel d info -> failCons d (traceFail
    "Analysis.Logging._impl#fromEnum#Prelude.Enum#Analysis.Logging.DLevel#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Logging._impl#fromEnum#Prelude.Enum#Analysis.Logging.DLevel#"
    (showCons x1))

d_OP_uscore_impl_hash_enumFrom_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash :: C_DLevel
  -> Cover -> ConstStore -> Curry_Prelude.OP_List C_DLevel
d_OP_uscore_impl_hash_enumFrom_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash x1 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (d_OP_uscore_impl_hash_enumFromTo_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
  cd cs) x1 cd cs) C_AllData cd cs

d_OP_uscore_impl_hash_enumFromThen_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash :: C_DLevel
  -> C_DLevel -> Cover -> ConstStore -> Curry_Prelude.OP_List C_DLevel
d_OP_uscore_impl_hash_enumFromThen_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash x1 x2 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (d_OP_uscore_impl_hash_enumFromThenTo_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
  cd cs) x1 cd cs) x2 cd cs) (d_C__case_0 x2 x1
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  (d_OP_uscore_impl_hash_fromEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
  x1 cd cs)
  (d_OP_uscore_impl_hash_fromEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
  x2 cd cs) cd cs) cd cs) cd cs

d_OP_uscore_impl_hash_enumFromTo_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash :: Cover
  -> ConstStore -> C_DLevel -> Cover -> ConstStore -> C_DLevel -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_DLevel
d_OP_uscore_impl_hash_enumFromTo_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash cd cs =
  acceptCs id
  (Curry_Prelude.d_OP_uscore_def_hash_enumFromTo_hash_Prelude_dot_Enum
  d_OP_uscore_inst_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash)

d_OP_uscore_impl_hash_enumFromThenTo_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash :: Cover
  -> ConstStore -> C_DLevel -> Cover -> ConstStore -> C_DLevel -> Cover
  -> ConstStore -> C_DLevel -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_DLevel
d_OP_uscore_impl_hash_enumFromThenTo_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash cd cs =
  acceptCs (acceptCs id)
  (Curry_Prelude.d_OP_uscore_def_hash_enumFromThenTo_hash_Prelude_dot_Enum
  d_OP_uscore_inst_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash)

d_C_debugMessage :: C_DLevel -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_C_debugMessage x1 x2 x3 cd cs = d_C_debugString x1 x2
  (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.toCurryString "\n") cd cs) cd
  cs

d_C_debugString :: C_DLevel -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_C_debugString x1 x2 x3 cd cs = Curry_Prelude.d_OP_dollar
  (Control.Curry_Applicative.d_C_when
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_Prelude_dot_IO_hash
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs)
  (d_OP_uscore_impl_hash_fromEnum_hash_Prelude_dot_Enum_hash_Analysis_dot_Logging_dot_DLevel_hash
  x1 cd cs) cd cs) x2 cd cs)) (System.Curry_IO.d_C_hPutStr
  (System.Curry_IO.d_C_stderr cd cs) x3 cd cs) cd cs

d_C__case_1 :: C_DLevel -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_1 x2 cd cs = case x2 of
  C_Quiet -> Curry_Prelude.C_False
  C_Timing -> Curry_Prelude.C_False
  C_Communicate -> Curry_Prelude.C_False
  C_Storage -> Curry_Prelude.C_False
  C_AllData -> Curry_Prelude.C_True
  Choice_C_DLevel d i l r -> narrow d i (d_C__case_1 l cd cs) (d_C__case_1 r cd
    cs)
  Choices_C_DLevel d i xs -> narrows cs d i (\z -> d_C__case_1 z cd cs) xs
  Guard_C_DLevel d c e -> guardCons d c ((\x -> d_C__case_1 e cd x) $! addCs c
    cs)
  Fail_C_DLevel d info -> failCons d (traceFail "Analysis.Logging._case_1" [show
    x2] info)
  _ -> failCons cd (consFail "Analysis.Logging._case_1" (showCons x2))

d_C__case_2 :: C_DLevel -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_2 x2 cd cs = case x2 of
  C_Quiet -> Curry_Prelude.C_False
  C_Timing -> Curry_Prelude.C_False
  C_Communicate -> Curry_Prelude.C_False
  C_Storage -> Curry_Prelude.C_True
  C_AllData -> Curry_Prelude.C_False
  Choice_C_DLevel d i l r -> narrow d i (d_C__case_2 l cd cs) (d_C__case_2 r cd
    cs)
  Choices_C_DLevel d i xs -> narrows cs d i (\z -> d_C__case_2 z cd cs) xs
  Guard_C_DLevel d c e -> guardCons d c ((\x -> d_C__case_2 e cd x) $! addCs c
    cs)
  Fail_C_DLevel d info -> failCons d (traceFail "Analysis.Logging._case_2" [show
    x2] info)
  _ -> failCons cd (consFail "Analysis.Logging._case_2" (showCons x2))

d_C__case_3 :: C_DLevel -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_3 x2 cd cs = case x2 of
  C_Quiet -> Curry_Prelude.C_False
  C_Timing -> Curry_Prelude.C_False
  C_Communicate -> Curry_Prelude.C_True
  C_Storage -> Curry_Prelude.C_False
  C_AllData -> Curry_Prelude.C_False
  Choice_C_DLevel d i l r -> narrow d i (d_C__case_3 l cd cs) (d_C__case_3 r cd
    cs)
  Choices_C_DLevel d i xs -> narrows cs d i (\z -> d_C__case_3 z cd cs) xs
  Guard_C_DLevel d c e -> guardCons d c ((\x -> d_C__case_3 e cd x) $! addCs c
    cs)
  Fail_C_DLevel d info -> failCons d (traceFail "Analysis.Logging._case_3" [show
    x2] info)
  _ -> failCons cd (consFail "Analysis.Logging._case_3" (showCons x2))

d_C__case_4 :: C_DLevel -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_4 x2 cd cs = case x2 of
  C_Quiet -> Curry_Prelude.C_False
  C_Timing -> Curry_Prelude.C_True
  C_Communicate -> Curry_Prelude.C_False
  C_Storage -> Curry_Prelude.C_False
  C_AllData -> Curry_Prelude.C_False
  Choice_C_DLevel d i l r -> narrow d i (d_C__case_4 l cd cs) (d_C__case_4 r cd
    cs)
  Choices_C_DLevel d i xs -> narrows cs d i (\z -> d_C__case_4 z cd cs) xs
  Guard_C_DLevel d c e -> guardCons d c ((\x -> d_C__case_4 e cd x) $! addCs c
    cs)
  Fail_C_DLevel d info -> failCons d (traceFail "Analysis.Logging._case_4" [show
    x2] info)
  _ -> failCons cd (consFail "Analysis.Logging._case_4" (showCons x2))

d_C__case_5 :: C_DLevel -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_5 x2 cd cs = case x2 of
  C_Quiet -> Curry_Prelude.C_True
  C_Timing -> Curry_Prelude.C_False
  C_Communicate -> Curry_Prelude.C_False
  C_Storage -> Curry_Prelude.C_False
  C_AllData -> Curry_Prelude.C_False
  Choice_C_DLevel d i l r -> narrow d i (d_C__case_5 l cd cs) (d_C__case_5 r cd
    cs)
  Choices_C_DLevel d i xs -> narrows cs d i (\z -> d_C__case_5 z cd cs) xs
  Guard_C_DLevel d c e -> guardCons d c ((\x -> d_C__case_5 e cd x) $! addCs c
    cs)
  Fail_C_DLevel d info -> failCons d (traceFail "Analysis.Logging._case_5" [show
    x2] info)
  _ -> failCons cd (consFail "Analysis.Logging._case_5" (showCons x2))

d_C__case_0 :: C_DLevel -> C_DLevel -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_DLevel
d_C__case_0 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> C_AllData
  Curry_Prelude.C_False -> C_Quiet
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x2 x1 l cd cs)
    (d_C__case_0 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x2 x1
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Analysis.Logging._case_0" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "Analysis.Logging._case_0" (showCons x3))

