{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module CurryDoc.Curry_AnaInfo
  ( C_AnaInfo (..)
  , d_C_getNondetInfo
  , nd_C_getNondetInfo
  , d_C_getCompleteInfo
  , nd_C_getCompleteInfo
  , d_C_getIndetInfo
  , nd_C_getIndetInfo
  , d_C_getOpCompleteInfo
  , nd_C_getOpCompleteInfo
  , d_C_getFunctionInfo )
  where

import Basics
import qualified Analysis.Curry_TotallyDefined
import qualified Curry_Prelude


data C_AnaInfo
  = C_AnaInfo (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
    -> ConstStore -> Curry_Prelude.C_Bool) (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) -> Cover -> ConstStore
    -> Analysis.Curry_TotallyDefined.C_Completeness) (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_Bool)
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
    -> Curry_Prelude.C_Bool)
  | HO_C_AnaInfo (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
    Curry_Prelude.C_Bool) (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
    Analysis.Curry_TotallyDefined.C_Completeness) (Func (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char)) Curry_Prelude.C_Bool) (Func (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char)) Curry_Prelude.C_Bool)
  | Choice_C_AnaInfo Cover ID C_AnaInfo C_AnaInfo
  | Choices_C_AnaInfo Cover ID [C_AnaInfo]
  | Fail_C_AnaInfo Cover FailInfo
  | Guard_C_AnaInfo Cover Constraints C_AnaInfo

instance Show C_AnaInfo where
  showsPrec d (Choice_C_AnaInfo cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_AnaInfo cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_AnaInfo cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_AnaInfo cd info) = showChar '!'
  showsPrec _ (C_AnaInfo x1 x2 x3 x4) = showString "(AnaInfo" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 .
    (showChar ' ' . (shows x4 . showChar ')'))))))))
  showsPrec _ (HO_C_AnaInfo x1 x2 x3 x4) = showString "(AnaInfo" . (showChar
    ' ' . (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 .
    (showChar ' ' . (shows x4 . showChar ')'))))))))

instance Read C_AnaInfo where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_AnaInfo x1 x2 x3 x4, r4) | (_
    , r0) <- readQualified "CurryDoc.AnaInfo" "AnaInfo" r, (x1, r1) <- readsPrec
    11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2, (x4, r4) <-
    readsPrec 11 r3]) s

instance NonDet C_AnaInfo where
  choiceCons = Choice_C_AnaInfo
  choicesCons = Choices_C_AnaInfo
  failCons = Fail_C_AnaInfo
  guardCons = Guard_C_AnaInfo
  try (Choice_C_AnaInfo cd i x y) = tryChoice cd i x y
  try (Choices_C_AnaInfo cd i xs) = tryChoices cd i xs
  try (Fail_C_AnaInfo cd info) = Fail cd info
  try (Guard_C_AnaInfo cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_AnaInfo cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_AnaInfo cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_AnaInfo cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_AnaInfo cd i _) = error
    ("CurryDoc.AnaInfo.AnaInfo.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_AnaInfo cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_AnaInfo cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_AnaInfo where
  generate s c = Choices_C_AnaInfo c (freeID [4] s) [HO_C_AnaInfo (generate
    (leftSupply (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c)
    (generate (leftSupply (rightSupply s)) c) (generate (rightSupply
    (rightSupply s)) c)]

instance NormalForm C_AnaInfo where
  ($!!) cont (C_AnaInfo x1 x2 x3 x4) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> cont (C_AnaInfo y1 y2 y3
    y4) d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (HO_C_AnaInfo x1 x2 x3 x4) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> cont (HO_C_AnaInfo y1 y2
    y3 y4) d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_AnaInfo cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_AnaInfo cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_AnaInfo cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_AnaInfo cd info) _ _ = failCons cd info
  ($##) cont (C_AnaInfo x1 x2 x3 x4) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> ($##) (\y3 d cs -> ($##) (\y4 d cs -> cont (C_AnaInfo y1 y2 y3
    y4) d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (HO_C_AnaInfo x1 x2 x3 x4) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> ($##) (\y3 d cs -> ($##) (\y4 d cs -> cont (HO_C_AnaInfo y1 y2
    y3 y4) d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_AnaInfo cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_AnaInfo cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_AnaInfo cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_AnaInfo cd info) _ _ = failCons cd info
  showCons (C_AnaInfo _ _ _ _) = "CurryDoc.AnaInfo.AnaInfo _ _ _ _"
  showCons (HO_C_AnaInfo _ _ _ _) = "CurryDoc.AnaInfo.AnaInfo _ _ _ _"
  showCons x = error ("CurryDoc.AnaInfo.AnaInfo.showCons: no constructor: " ++
    show x)
  searchNF search cont (C_AnaInfo x1 x2 x3 x4) = search (\y1 -> search (\y2 ->
    search (\y3 -> search (\y4 -> cont (C_AnaInfo y1 y2 y3 y4)) x4) x3) x2) x1
  searchNF search cont (HO_C_AnaInfo x1 x2 x3 x4) = search (\y1 -> search
    (\y2 -> search (\y3 -> search (\y4 -> cont (HO_C_AnaInfo y1 y2 y3 y4)) x4)
    x3) x2) x1
  searchNF _ _ x = error
    ("CurryDoc.AnaInfo.AnaInfo.searchNF: no constructor: " ++ show x)

instance Unifiable C_AnaInfo where
  (=.=) (C_AnaInfo x1 x2 x3 x4) (C_AnaInfo y1 y2 y3 y4) d cs = (&) ((=:=) x1 y1
    d cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((=:=) x4 y4 d cs) d
    cs) d cs) d cs
  (=.=) (HO_C_AnaInfo x1 x2 x3 x4) (HO_C_AnaInfo y1 y2 y3 y4) d cs = (&) ((=:=)
    x1 y1 d cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((=:=) x4 y4 d
    cs) d cs) d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_AnaInfo x1 x2 x3 x4) (C_AnaInfo y1 y2 y3 y4) d cs = (&) ((=:<=) x1
    y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs) ((=:<=) x4 y4 d
    cs) d cs) d cs) d cs
  (=.<=) (HO_C_AnaInfo x1 x2 x3 x4) (HO_C_AnaInfo y1 y2 y3 y4) d cs = (&)
    ((=:<=) x1 y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs)
    ((=:<=) x4 y4 d cs) d cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_AnaInfo x3 x4 x5 x6) = (i :=: ChooseN 0 4) : concat [bind cd
    (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (leftID
    (rightID i)) x5, bind cd (rightID (rightID i)) x6]
  bind cd i (HO_C_AnaInfo x3 x4 x5 x6) = (i :=: ChooseN 0 4) : concat [bind cd
    (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (leftID
    (rightID i)) x5, bind cd (rightID (rightID i)) x6]
  bind d i (Choice_C_AnaInfo cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_AnaInfo cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_AnaInfo cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_AnaInfo cd i _) = error
    ("CurryDoc.AnaInfo.AnaInfo.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_AnaInfo cd info) = [Unsolvable info]
  bind d i (Guard_C_AnaInfo cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_AnaInfo x3 x4 x5 x6) = (i :=: ChooseN 0 4) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), leftID (rightID i) :=:
    LazyBind (lazyBind cd (leftID (rightID i)) x5), rightID (rightID i) :=:
    LazyBind (lazyBind cd (rightID (rightID i)) x6)]
  lazyBind cd i (HO_C_AnaInfo x3 x4 x5 x6) = (i :=: ChooseN 0 4) : [leftID
    (leftID i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID
    (leftID i) :=: LazyBind (lazyBind cd (rightID (leftID i)) x4), leftID
    (rightID i) :=: LazyBind (lazyBind cd (leftID (rightID i)) x5), rightID
    (rightID i) :=: LazyBind (lazyBind cd (rightID (rightID i)) x6)]
  lazyBind d i (Choice_C_AnaInfo cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_AnaInfo cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_AnaInfo cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_AnaInfo cd i _) = error
    ("CurryDoc.AnaInfo.AnaInfo.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_AnaInfo cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_AnaInfo cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_AnaInfo where

d_C_getNondetInfo :: C_AnaInfo -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_getNondetInfo x1 cd cs = case x1 of
  C_AnaInfo x2 x3 x4 x5 -> x2
  Choice_C_AnaInfo d i l r -> narrow d i (d_C_getNondetInfo l cd cs)
    (d_C_getNondetInfo r cd cs)
  Choices_C_AnaInfo d i xs -> narrows cs d i (\z -> d_C_getNondetInfo z cd cs)
    xs
  Guard_C_AnaInfo d c e -> guardCons d c ((\x -> d_C_getNondetInfo e cd x) $!
    addCs c cs)
  Fail_C_AnaInfo d info -> failCons d (traceFail
    "CurryDoc.AnaInfo.getNondetInfo" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.AnaInfo.getNondetInfo" (showCons x1))

nd_C_getNondetInfo :: C_AnaInfo -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Prelude.C_Bool
nd_C_getNondetInfo x1 s cd cs = case x1 of
  HO_C_AnaInfo x2 x3 x4 x5 -> x2
  Choice_C_AnaInfo d i l r -> narrow d i (nd_C_getNondetInfo l s cd cs)
    (nd_C_getNondetInfo r s cd cs)
  Choices_C_AnaInfo d i xs -> narrows cs d i (\z -> nd_C_getNondetInfo z s cd
    cs) xs
  Guard_C_AnaInfo d c e -> guardCons d c ((\x -> nd_C_getNondetInfo e s cd x) $!
    addCs c cs)
  Fail_C_AnaInfo d info -> failCons d (traceFail
    "CurryDoc.AnaInfo.getNondetInfo" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.AnaInfo.getNondetInfo" (showCons x1))

d_C_getCompleteInfo :: C_AnaInfo -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Analysis.Curry_TotallyDefined.C_Completeness
d_C_getCompleteInfo x1 cd cs = case x1 of
  C_AnaInfo x2 x3 x4 x5 -> x3
  Choice_C_AnaInfo d i l r -> narrow d i (d_C_getCompleteInfo l cd cs)
    (d_C_getCompleteInfo r cd cs)
  Choices_C_AnaInfo d i xs -> narrows cs d i (\z -> d_C_getCompleteInfo z cd cs)
    xs
  Guard_C_AnaInfo d c e -> guardCons d c ((\x -> d_C_getCompleteInfo e cd x) $!
    addCs c cs)
  Fail_C_AnaInfo d info -> failCons d (traceFail
    "CurryDoc.AnaInfo.getCompleteInfo" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.AnaInfo.getCompleteInfo" (showCons x1))

nd_C_getCompleteInfo :: C_AnaInfo -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Analysis.Curry_TotallyDefined.C_Completeness
nd_C_getCompleteInfo x1 s cd cs = case x1 of
  HO_C_AnaInfo x2 x3 x4 x5 -> x3
  Choice_C_AnaInfo d i l r -> narrow d i (nd_C_getCompleteInfo l s cd cs)
    (nd_C_getCompleteInfo r s cd cs)
  Choices_C_AnaInfo d i xs -> narrows cs d i (\z -> nd_C_getCompleteInfo z s cd
    cs) xs
  Guard_C_AnaInfo d c e -> guardCons d c ((\x -> nd_C_getCompleteInfo e s cd
    x) $! addCs c cs)
  Fail_C_AnaInfo d info -> failCons d (traceFail
    "CurryDoc.AnaInfo.getCompleteInfo" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.AnaInfo.getCompleteInfo" (showCons x1))

d_C_getIndetInfo :: C_AnaInfo -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_getIndetInfo x1 cd cs = case x1 of
  C_AnaInfo x2 x3 x4 x5 -> x4
  Choice_C_AnaInfo d i l r -> narrow d i (d_C_getIndetInfo l cd cs)
    (d_C_getIndetInfo r cd cs)
  Choices_C_AnaInfo d i xs -> narrows cs d i (\z -> d_C_getIndetInfo z cd cs) xs
  Guard_C_AnaInfo d c e -> guardCons d c ((\x -> d_C_getIndetInfo e cd x) $!
    addCs c cs)
  Fail_C_AnaInfo d info -> failCons d (traceFail "CurryDoc.AnaInfo.getIndetInfo"
    [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.AnaInfo.getIndetInfo" (showCons x1))

nd_C_getIndetInfo :: C_AnaInfo -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Prelude.C_Bool
nd_C_getIndetInfo x1 s cd cs = case x1 of
  HO_C_AnaInfo x2 x3 x4 x5 -> x4
  Choice_C_AnaInfo d i l r -> narrow d i (nd_C_getIndetInfo l s cd cs)
    (nd_C_getIndetInfo r s cd cs)
  Choices_C_AnaInfo d i xs -> narrows cs d i (\z -> nd_C_getIndetInfo z s cd cs)
    xs
  Guard_C_AnaInfo d c e -> guardCons d c ((\x -> nd_C_getIndetInfo e s cd x) $!
    addCs c cs)
  Fail_C_AnaInfo d info -> failCons d (traceFail "CurryDoc.AnaInfo.getIndetInfo"
    [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.AnaInfo.getIndetInfo" (showCons x1))

d_C_getOpCompleteInfo :: C_AnaInfo -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_getOpCompleteInfo x1 cd cs = case x1 of
  C_AnaInfo x2 x3 x4 x5 -> x5
  Choice_C_AnaInfo d i l r -> narrow d i (d_C_getOpCompleteInfo l cd cs)
    (d_C_getOpCompleteInfo r cd cs)
  Choices_C_AnaInfo d i xs -> narrows cs d i (\z -> d_C_getOpCompleteInfo z cd
    cs) xs
  Guard_C_AnaInfo d c e -> guardCons d c ((\x -> d_C_getOpCompleteInfo e cd
    x) $! addCs c cs)
  Fail_C_AnaInfo d info -> failCons d (traceFail
    "CurryDoc.AnaInfo.getOpCompleteInfo" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.AnaInfo.getOpCompleteInfo" (showCons x1))

nd_C_getOpCompleteInfo :: C_AnaInfo -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Prelude.C_Bool
nd_C_getOpCompleteInfo x1 s cd cs = case x1 of
  HO_C_AnaInfo x2 x3 x4 x5 -> x5
  Choice_C_AnaInfo d i l r -> narrow d i (nd_C_getOpCompleteInfo l s cd cs)
    (nd_C_getOpCompleteInfo r s cd cs)
  Choices_C_AnaInfo d i xs -> narrows cs d i (\z -> nd_C_getOpCompleteInfo z s
    cd cs) xs
  Guard_C_AnaInfo d c e -> guardCons d c ((\x -> nd_C_getOpCompleteInfo e s cd
    x) $! addCs c cs)
  Fail_C_AnaInfo d info -> failCons d (traceFail
    "CurryDoc.AnaInfo.getOpCompleteInfo" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.AnaInfo.getOpCompleteInfo" (showCons x1))

d_C_getFunctionInfo :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> t0
d_C_getFunctionInfo x1 x2 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "No analysis result for function ")
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    cd cs) x2 cd cs) cd cs) cd cs
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_1 x2 x4 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_getFunctionInfo l x2
    cd cs) (d_C_getFunctionInfo r x2 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_getFunctionInfo z x2 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_getFunctionInfo
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CurryDoc.AnaInfo.getFunctionInfo" [show x1, show x2] info)
  _ -> failCons cd (consFail "CurryDoc.AnaInfo.getFunctionInfo" (showCons x1))

d_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0 -> Cover -> ConstStore -> t0
d_C__case_1 x2 x4 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> d_C__case_0 x2 x5 x4 x6
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x5 x2 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_1 x2 x4 l cd
    cs) (d_C__case_1 x2 x4 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_1 x2
    x4 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_1 x2 x4
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CurryDoc.AnaInfo._case_1" [show x2, show x4, show x3] info)
  _ -> failCons cd (consFail "CurryDoc.AnaInfo._case_1" (showCons x3))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0) -> t0 -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> t0
d_C__case_0 x2 x5 x4 x6 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> x6
  Curry_Prelude.C_False -> d_C_getFunctionInfo x4 x2 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x2 x5 x4 x6 l
    cd cs) (d_C__case_0 x2 x5 x4 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x2 x5
    x4 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x2 x5 x4
    x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.AnaInfo._case_0" [show x2, show x5, show x4, show x6, show x7]
    info)
  _ -> failCons cd (consFail "CurryDoc.AnaInfo._case_0" (showCons x7))

