{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module CurryDoc.Curry_Config
  ( d_C_currydocVersion
  , d_C_styleBaseURL
  , d_C_currySystemURL
  , d_C_currySystem
  , d_C_curryDocURL )
  where

import Basics
import qualified Curry.Compiler.Curry_Distribution
import qualified CurryDoc.Curry_PackageConfig
import qualified Language.Curry.Curry_Resources
import qualified Curry_Prelude


d_C_currydocVersion :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_currydocVersion cd cs = Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "Version ") (Curry_Prelude.d_OP_plus_plus
  (CurryDoc.Curry_PackageConfig.d_C_packageVersion cd cs)
  (Curry_Prelude.toCurryString " of September 25, 2024") cd cs) cd cs

d_C_styleBaseURL :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_styleBaseURL cd cs = Curry_Prelude.toCurryString "bt4"

d_C_currySystemURL :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_currySystemURL cd cs = d_C__case_3
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  (Curry.Compiler.Curry_Distribution.d_C_curryCompiler cd cs)
  (Curry_Prelude.toCurryString "pakcs") cd cs) cd cs

d_C_currySystem :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_currySystem cd cs = d_C__case_2
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  (Curry.Compiler.Curry_Distribution.d_C_curryCompiler cd cs)
  (Curry_Prelude.toCurryString "pakcs") cd cs) cd cs

d_C_curryDocURL :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_curryDocURL cd cs = Curry_Prelude.d_OP_plus_plus
  (Language.Curry.Curry_Resources.d_C_curryWikiURL cd cs)
  (Curry_Prelude.toCurryString "/tools/currydoc") cd cs

d_C__case_3 :: Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_3 x1 cd cs = case x1 of
  Curry_Prelude.C_True -> Language.Curry.Curry_Resources.d_C_pakcsURL cd cs
  Curry_Prelude.C_False -> Language.Curry.Curry_Resources.d_C_kics2URL cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 l cd cs)
    (d_C__case_3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 z cd
    cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Config._case_3" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Config._case_3" (showCons x1))

d_C__case_2 :: Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_2 x1 cd cs = case x1 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "PAKCS"
  Curry_Prelude.C_False -> d_C__case_1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry.Compiler.Curry_Distribution.d_C_curryCompiler cd cs)
    (Curry_Prelude.toCurryString "kics2") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 l cd cs)
    (d_C__case_2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 z cd
    cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Config._case_2" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Config._case_2" (showCons x1))

d_C__case_1 :: Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_1 x1 cd cs = case x1 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "KiCS2"
  Curry_Prelude.C_False -> d_C__case_0 (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 l cd cs)
    (d_C__case_1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 z cd
    cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Config._case_1" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Config._case_1" (showCons x1))

d_C__case_0 :: Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_0 x1 cd cs = case x1 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "???"
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 l cd cs)
    (d_C__case_0 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 z cd
    cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Config._case_0" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Config._case_0" (showCons x1))

