{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module CurryDoc.Curry_Options
  ( C_DocType (..)
  , C_DocOptions (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Options_dot_DocType_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Options_dot_DocType_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CurryDoc_dot_Options_dot_DocType_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash
  , d_C_docType
  , nd_C_docType
  , d_C_withIndex
  , nd_C_withIndex
  , d_C_withMarkdown
  , nd_C_withMarkdown
  , d_C_mainTitle
  , nd_C_mainTitle
  , d_C_useDirURL
  , nd_C_useDirURL
  , d_C_docMods
  , nd_C_docMods
  , d_C_docURL
  , nd_C_docURL
  , d_C_defaultCurryDocOptions
  , nd_C_defaultCurryDocOptions )
  where

import Basics
import qualified Curry_Prelude


data C_DocType
  = C_HtmlDoc
  | C_TexDoc
  | C_CDoc
  | Choice_C_DocType Cover ID C_DocType C_DocType
  | Choices_C_DocType Cover ID [C_DocType]
  | Fail_C_DocType Cover FailInfo
  | Guard_C_DocType Cover Constraints C_DocType

instance Show C_DocType where
  showsPrec d (Choice_C_DocType cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_DocType cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_DocType cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_DocType cd info) = showChar '!'
  showsPrec _ C_HtmlDoc = showString "HtmlDoc"
  showsPrec _ C_TexDoc = showString "TexDoc"
  showsPrec _ C_CDoc = showString "CDoc"

instance Read C_DocType where
  readsPrec _ s = readParen False (\r -> [(C_HtmlDoc, r0) | (_, r0) <-
    readQualified "CurryDoc.Options" "HtmlDoc" r]) s ++ (readParen False (\r ->
    [(C_TexDoc, r0) | (_, r0) <- readQualified "CurryDoc.Options" "TexDoc" r])
    s ++ readParen False (\r -> [(C_CDoc, r0) | (_, r0) <- readQualified
    "CurryDoc.Options" "CDoc" r]) s)

instance NonDet C_DocType where
  choiceCons = Choice_C_DocType
  choicesCons = Choices_C_DocType
  failCons = Fail_C_DocType
  guardCons = Guard_C_DocType
  try (Choice_C_DocType cd i x y) = tryChoice cd i x y
  try (Choices_C_DocType cd i xs) = tryChoices cd i xs
  try (Fail_C_DocType cd info) = Fail cd info
  try (Guard_C_DocType cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_DocType cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_DocType cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_DocType cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_DocType cd i _) = error
    ("CurryDoc.Options.DocType.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_DocType cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_DocType cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_DocType where
  generate s c = Choices_C_DocType c (freeID [0, 0, 0] s) [C_HtmlDoc, C_TexDoc
    , C_CDoc]

instance NormalForm C_DocType where
  ($!!) cont C_HtmlDoc d cs = cont C_HtmlDoc d cs
  ($!!) cont C_TexDoc d cs = cont C_TexDoc d cs
  ($!!) cont C_CDoc d cs = cont C_CDoc d cs
  ($!!) cont (Choice_C_DocType cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_DocType cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_DocType cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_DocType cd info) _ _ = failCons cd info
  ($##) cont C_HtmlDoc d cs = cont C_HtmlDoc d cs
  ($##) cont C_TexDoc d cs = cont C_TexDoc d cs
  ($##) cont C_CDoc d cs = cont C_CDoc d cs
  ($##) cont (Choice_C_DocType cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_DocType cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_DocType cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_DocType cd info) _ _ = failCons cd info
  showCons C_HtmlDoc = "CurryDoc.Options.HtmlDoc"
  showCons C_TexDoc = "CurryDoc.Options.TexDoc"
  showCons C_CDoc = "CurryDoc.Options.CDoc"
  showCons x = error ("CurryDoc.Options.DocType.showCons: no constructor: " ++
    show x)
  searchNF _ cont C_HtmlDoc = cont C_HtmlDoc
  searchNF _ cont C_TexDoc = cont C_TexDoc
  searchNF _ cont C_CDoc = cont C_CDoc
  searchNF _ _ x = error
    ("CurryDoc.Options.DocType.searchNF: no constructor: " ++ show x)

instance Unifiable C_DocType where
  (=.=) C_HtmlDoc C_HtmlDoc d cs = C_True
  (=.=) C_TexDoc C_TexDoc d cs = C_True
  (=.=) C_CDoc C_CDoc d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_HtmlDoc C_HtmlDoc d cs = C_True
  (=.<=) C_TexDoc C_TexDoc d cs = C_True
  (=.<=) C_CDoc C_CDoc d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_HtmlDoc = (i :=: ChooseN 0 0) : concat []
  bind cd i C_TexDoc = (i :=: ChooseN 1 0) : concat []
  bind cd i C_CDoc = (i :=: ChooseN 2 0) : concat []
  bind d i (Choice_C_DocType cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_DocType cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_DocType cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_DocType cd i _) = error
    ("CurryDoc.Options.DocType.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_DocType cd info) = [Unsolvable info]
  bind d i (Guard_C_DocType cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_HtmlDoc = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_TexDoc = (i :=: ChooseN 1 0) : []
  lazyBind cd i C_CDoc = (i :=: ChooseN 2 0) : []
  lazyBind d i (Choice_C_DocType cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_DocType cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_DocType cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_DocType cd i _) = error
    ("CurryDoc.Options.DocType.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_DocType cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_DocType cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_DocType where

data C_DocOptions
  = C_DocOptions C_DocType Curry_Prelude.C_Bool Curry_Prelude.C_Bool
    (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
    Curry_Prelude.C_Char)
  | HO_C_DocOptions C_DocType Curry_Prelude.C_Bool Curry_Prelude.C_Bool
    (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  | Choice_C_DocOptions Cover ID C_DocOptions C_DocOptions
  | Choices_C_DocOptions Cover ID [C_DocOptions]
  | Fail_C_DocOptions Cover FailInfo
  | Guard_C_DocOptions Cover Constraints C_DocOptions

instance Show C_DocOptions where
  showsPrec d (Choice_C_DocOptions cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_DocOptions cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_DocOptions cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_DocOptions cd info) = showChar '!'
  showsPrec _ (C_DocOptions x1 x2 x3 x4 x5 x6 x7) = showString "(DocOptions" .
    (showChar ' ' . (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' .
    (shows x3 . (showChar ' ' . (shows x4 . (showChar ' ' . (shows x5 .
    (showChar ' ' . (shows x6 . (showChar ' ' . (shows x7 . showChar
    ')'))))))))))))))
  showsPrec _ (HO_C_DocOptions x1 x2 x3 x4 x5 x6 x7) = showString
    "(DocOptions" . (showChar ' ' . (shows x1 . (showChar ' ' . (shows x2 .
    (showChar ' ' . (shows x3 . (showChar ' ' . (shows x4 . (showChar ' ' .
    (shows x5 . (showChar ' ' . (shows x6 . (showChar ' ' . (shows x7 . showChar
    ')'))))))))))))))

instance Read C_DocOptions where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_DocOptions x1 x2 x3 x4 x5 x6
    x7, r7) | (_, r0) <- readQualified "CurryDoc.Options" "DocOptions" r, (x1
    , r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec
    11 r2, (x4, r4) <- readsPrec 11 r3, (x5, r5) <- readsPrec 11 r4, (x6, r6) <-
    readsPrec 11 r5, (x7, r7) <- readsPrec 11 r6]) s

instance NonDet C_DocOptions where
  choiceCons = Choice_C_DocOptions
  choicesCons = Choices_C_DocOptions
  failCons = Fail_C_DocOptions
  guardCons = Guard_C_DocOptions
  try (Choice_C_DocOptions cd i x y) = tryChoice cd i x y
  try (Choices_C_DocOptions cd i xs) = tryChoices cd i xs
  try (Fail_C_DocOptions cd info) = Fail cd info
  try (Guard_C_DocOptions cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_DocOptions cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_DocOptions cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_DocOptions cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_DocOptions cd i _) = error
    ("CurryDoc.Options.DocOptions.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_DocOptions cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_DocOptions cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_DocOptions where
  generate s c = Choices_C_DocOptions c (freeID [7] s) [HO_C_DocOptions
    (generate (leftSupply (leftSupply (leftSupply s))) c) (generate (rightSupply
    (leftSupply (leftSupply s))) c) (generate (leftSupply (rightSupply
    (leftSupply s))) c) (generate (rightSupply (rightSupply (leftSupply s))) c)
    (generate (leftSupply (leftSupply (rightSupply s))) c) (generate
    (rightSupply (leftSupply (rightSupply s))) c) (generate (rightSupply
    (rightSupply s)) c)]

instance NormalForm C_DocOptions where
  ($!!) cont (C_DocOptions x1 x2 x3 x4 x5 x6 x7) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> ($!!) (\y5 d cs -> ($!!)
    (\y6 d cs -> ($!!) (\y7 d cs -> cont (C_DocOptions y1 y2 y3 y4 y5 y6 y7) d
    cs) x7 d cs) x6 d cs) x5 d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (HO_C_DocOptions x1 x2 x3 x4 x5 x6 x7) d cs = ($!!) (\y1 d cs ->
    ($!!) (\y2 d cs -> ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> ($!!) (\y5 d cs ->
    ($!!) (\y6 d cs -> ($!!) (\y7 d cs -> cont (HO_C_DocOptions y1 y2 y3 y4 y5
    y6 y7) d cs) x7 d cs) x6 d cs) x5 d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_DocOptions cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_DocOptions cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_DocOptions cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_DocOptions cd info) _ _ = failCons cd info
  ($##) cont (C_DocOptions x1 x2 x3 x4 x5 x6 x7) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> ($##) (\y3 d cs -> ($##) (\y4 d cs -> ($##) (\y5 d cs -> ($##)
    (\y6 d cs -> ($##) (\y7 d cs -> cont (C_DocOptions y1 y2 y3 y4 y5 y6 y7) d
    cs) x7 d cs) x6 d cs) x5 d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (HO_C_DocOptions x1 x2 x3 x4 x5 x6 x7) d cs = ($##) (\y1 d cs ->
    ($##) (\y2 d cs -> ($##) (\y3 d cs -> ($##) (\y4 d cs -> ($##) (\y5 d cs ->
    ($##) (\y6 d cs -> ($##) (\y7 d cs -> cont (HO_C_DocOptions y1 y2 y3 y4 y5
    y6 y7) d cs) x7 d cs) x6 d cs) x5 d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_DocOptions cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_DocOptions cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_DocOptions cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_DocOptions cd info) _ _ = failCons cd info
  showCons (C_DocOptions _ _ _ _ _ _ _) =
    "CurryDoc.Options.DocOptions _ _ _ _ _ _ _"
  showCons (HO_C_DocOptions _ _ _ _ _ _ _) =
    "CurryDoc.Options.DocOptions _ _ _ _ _ _ _"
  showCons x = error
    ("CurryDoc.Options.DocOptions.showCons: no constructor: " ++ show x)
  searchNF search cont (C_DocOptions x1 x2 x3 x4 x5 x6 x7) = search (\y1 ->
    search (\y2 -> search (\y3 -> search (\y4 -> search (\y5 -> search (\y6 ->
    search (\y7 -> cont (C_DocOptions y1 y2 y3 y4 y5 y6 y7)) x7) x6) x5) x4) x3)
    x2) x1
  searchNF search cont (HO_C_DocOptions x1 x2 x3 x4 x5 x6 x7) = search (\y1 ->
    search (\y2 -> search (\y3 -> search (\y4 -> search (\y5 -> search (\y6 ->
    search (\y7 -> cont (HO_C_DocOptions y1 y2 y3 y4 y5 y6 y7)) x7) x6) x5) x4)
    x3) x2) x1
  searchNF _ _ x = error
    ("CurryDoc.Options.DocOptions.searchNF: no constructor: " ++ show x)

instance Unifiable C_DocOptions where
  (=.=) (C_DocOptions x1 x2 x3 x4 x5 x6 x7) (C_DocOptions y1 y2 y3 y4 y5 y6 y7) d cs =
    (&) ((=:=) x1 y1 d cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((&)
    ((=:=) x4 y4 d cs) ((&) ((=:=) x5 y5 d cs) ((&) ((=:=) x6 y6 d cs) ((=:=) x7
    y7 d cs) d cs) d cs) d cs) d cs) d cs) d cs
  (=.=) (HO_C_DocOptions x1 x2 x3 x4 x5 x6 x7) (HO_C_DocOptions y1 y2 y3 y4 y5 y6 y7) d cs =
    (&) ((=:=) x1 y1 d cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((&)
    ((=:=) x4 y4 d cs) ((&) ((=:=) x5 y5 d cs) ((&) ((=:=) x6 y6 d cs) ((=:=) x7
    y7 d cs) d cs) d cs) d cs) d cs) d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_DocOptions x1 x2 x3 x4 x5 x6 x7) (C_DocOptions y1 y2 y3 y4 y5 y6 y7) d cs =
    (&) ((=:<=) x1 y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs)
    ((&) ((=:<=) x4 y4 d cs) ((&) ((=:<=) x5 y5 d cs) ((&) ((=:<=) x6 y6 d cs)
    ((=:<=) x7 y7 d cs) d cs) d cs) d cs) d cs) d cs) d cs
  (=.<=) (HO_C_DocOptions x1 x2 x3 x4 x5 x6 x7) (HO_C_DocOptions y1 y2 y3 y4 y5 y6 y7) d cs =
    (&) ((=:<=) x1 y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs)
    ((&) ((=:<=) x4 y4 d cs) ((&) ((=:<=) x5 y5 d cs) ((&) ((=:<=) x6 y6 d cs)
    ((=:<=) x7 y7 d cs) d cs) d cs) d cs) d cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_DocOptions x3 x4 x5 x6 x7 x8 x9) = (i :=: ChooseN 0 7) : concat
    [bind cd (leftID (leftID (leftID i))) x3, bind cd (rightID (leftID (leftID
    i))) x4, bind cd (leftID (rightID (leftID i))) x5, bind cd (rightID (rightID
    (leftID i))) x6, bind cd (leftID (leftID (rightID i))) x7, bind cd (rightID
    (leftID (rightID i))) x8, bind cd (rightID (rightID i)) x9]
  bind cd i (HO_C_DocOptions x3 x4 x5 x6 x7 x8 x9) = (i :=: ChooseN 0 7) :
    concat [bind cd (leftID (leftID (leftID i))) x3, bind cd (rightID (leftID
    (leftID i))) x4, bind cd (leftID (rightID (leftID i))) x5, bind cd (rightID
    (rightID (leftID i))) x6, bind cd (leftID (leftID (rightID i))) x7, bind cd
    (rightID (leftID (rightID i))) x8, bind cd (rightID (rightID i)) x9]
  bind d i (Choice_C_DocOptions cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_DocOptions cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j
    xs
  bind d i (Choices_C_DocOptions cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_DocOptions cd i _) = error
    ("CurryDoc.Options.DocOptions.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_DocOptions cd info) = [Unsolvable info]
  bind d i (Guard_C_DocOptions cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_DocOptions x3 x4 x5 x6 x7 x8 x9) = (i :=: ChooseN 0 7) :
    [leftID (leftID (leftID i)) :=: LazyBind (lazyBind cd (leftID (leftID
    (leftID i))) x3), rightID (leftID (leftID i)) :=: LazyBind (lazyBind cd
    (rightID (leftID (leftID i))) x4), leftID (rightID (leftID i)) :=: LazyBind
    (lazyBind cd (leftID (rightID (leftID i))) x5), rightID (rightID (leftID
    i)) :=: LazyBind (lazyBind cd (rightID (rightID (leftID i))) x6), leftID
    (leftID (rightID i)) :=: LazyBind (lazyBind cd (leftID (leftID (rightID i)))
    x7), rightID (leftID (rightID i)) :=: LazyBind (lazyBind cd (rightID (leftID
    (rightID i))) x8), rightID (rightID i) :=: LazyBind (lazyBind cd (rightID
    (rightID i)) x9)]
  lazyBind cd i (HO_C_DocOptions x3 x4 x5 x6 x7 x8 x9) = (i :=: ChooseN 0 7) :
    [leftID (leftID (leftID i)) :=: LazyBind (lazyBind cd (leftID (leftID
    (leftID i))) x3), rightID (leftID (leftID i)) :=: LazyBind (lazyBind cd
    (rightID (leftID (leftID i))) x4), leftID (rightID (leftID i)) :=: LazyBind
    (lazyBind cd (leftID (rightID (leftID i))) x5), rightID (rightID (leftID
    i)) :=: LazyBind (lazyBind cd (rightID (rightID (leftID i))) x6), leftID
    (leftID (rightID i)) :=: LazyBind (lazyBind cd (leftID (leftID (rightID i)))
    x7), rightID (leftID (rightID i)) :=: LazyBind (lazyBind cd (rightID (leftID
    (rightID i))) x8), rightID (rightID i) :=: LazyBind (lazyBind cd (rightID
    (rightID i)) x9)]
  lazyBind d i (Choice_C_DocOptions cd j x y) = [ConstraintChoice cd j (lazyBind
    d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_DocOptions cd j@(FreeID _ _) xs) = lazyBindOrNarrow d
    i cd j xs
  lazyBind d i (Choices_C_DocOptions cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_DocOptions cd i _) = error
    ("CurryDoc.Options.DocOptions.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_DocOptions cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_DocOptions cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_DocOptions where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Options_dot_DocType_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_DocType
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Options_dot_DocType_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Options_dot_DocType_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CurryDoc_dot_Options_dot_DocType_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Options_dot_DocType_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Options_dot_DocType_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Options_dot_DocType_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Options_dot_DocType_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CurryDoc.Options._inst#Prelude.Data#CurryDoc.Options.DocType#" [show x1]
    info)
  _ -> failCons cd (consFail
    "CurryDoc.Options._inst#Prelude.Data#CurryDoc.Options.DocType#" (showCons
    x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Options_dot_DocType_hash :: C_DocType
  -> C_DocType -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Options_dot_DocType_hash x1 x2 cd cs =
  case x1 of
  C_HtmlDoc -> d_C__case_5 x2 cd cs
  C_TexDoc -> d_C__case_4 x2 cd cs
  C_CDoc -> d_C__case_3 x2 cd cs
  Choice_C_DocType d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Options_dot_DocType_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Options_dot_DocType_hash
    r x2 cd cs)
  Choices_C_DocType d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Options_dot_DocType_hash
    z x2 cd cs) xs
  Guard_C_DocType d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Options_dot_DocType_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_DocType d info -> failCons d (traceFail
    "CurryDoc.Options._impl#===#Prelude.Data#CurryDoc.Options.DocType#" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "CurryDoc.Options._impl#===#Prelude.Data#CurryDoc.Options.DocType#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CurryDoc_dot_Options_dot_DocType_hash :: IDSupply
  -> Cover -> ConstStore -> C_DocType
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CurryDoc_dot_Options_dot_DocType_hash s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` choice (choice C_HtmlDoc C_TexDoc s0 cd cs) C_CDoc s1 cd
  cs))

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_DocType
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CurryDoc.Options._inst#Prelude.Eq#CurryDoc.Options.DocType#" [show x1]
    info)
  _ -> failCons cd (consFail
    "CurryDoc.Options._inst#Prelude.Eq#CurryDoc.Options.DocType#" (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_DocType
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CurryDoc.Options._inst#Prelude.Eq#CurryDoc.Options.DocType#" [show x1]
    info)
  _ -> failCons cd (consFail
    "CurryDoc.Options._inst#Prelude.Eq#CurryDoc.Options.DocType#" (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash :: C_DocType
  -> C_DocType -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash x1 x2 cd cs =
  case x1 of
  C_HtmlDoc -> d_C__case_2 x2 cd cs
  C_TexDoc -> d_C__case_1 x2 cd cs
  C_CDoc -> d_C__case_0 x2 cd cs
  Choice_C_DocType d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash
    r x2 cd cs)
  Choices_C_DocType d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash
    z x2 cd cs) xs
  Guard_C_DocType d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_DocType d info -> failCons d (traceFail
    "CurryDoc.Options._impl#==#Prelude.Eq#CurryDoc.Options.DocType#" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "CurryDoc.Options._impl#==#Prelude.Eq#CurryDoc.Options.DocType#" (showCons
    x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash :: Cover
  -> ConstStore -> C_DocType -> Cover -> ConstStore -> C_DocType -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Options_dot_DocType_hash)

d_C_docType :: C_DocOptions -> Cover -> ConstStore -> C_DocType
d_C_docType x1 cd cs = case x1 of
  C_DocOptions x2 x3 x4 x5 x6 x7 x8 -> x2
  Choice_C_DocOptions d i l r -> narrow d i (d_C_docType l cd cs) (d_C_docType r
    cd cs)
  Choices_C_DocOptions d i xs -> narrows cs d i (\z -> d_C_docType z cd cs) xs
  Guard_C_DocOptions d c e -> guardCons d c ((\x -> d_C_docType e cd x) $! addCs
    c cs)
  Fail_C_DocOptions d info -> failCons d (traceFail "CurryDoc.Options.docType"
    [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Options.docType" (showCons x1))

nd_C_docType :: C_DocOptions -> IDSupply -> Cover -> ConstStore -> C_DocType
nd_C_docType x1 s cd cs = case x1 of
  HO_C_DocOptions x2 x3 x4 x5 x6 x7 x8 -> x2
  Choice_C_DocOptions d i l r -> narrow d i (nd_C_docType l s cd cs)
    (nd_C_docType r s cd cs)
  Choices_C_DocOptions d i xs -> narrows cs d i (\z -> nd_C_docType z s cd cs)
    xs
  Guard_C_DocOptions d c e -> guardCons d c ((\x -> nd_C_docType e s cd x) $!
    addCs c cs)
  Fail_C_DocOptions d info -> failCons d (traceFail "CurryDoc.Options.docType"
    [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Options.docType" (showCons x1))

d_C_withIndex :: C_DocOptions -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_withIndex x1 cd cs = case x1 of
  C_DocOptions x2 x3 x4 x5 x6 x7 x8 -> x3
  Choice_C_DocOptions d i l r -> narrow d i (d_C_withIndex l cd cs)
    (d_C_withIndex r cd cs)
  Choices_C_DocOptions d i xs -> narrows cs d i (\z -> d_C_withIndex z cd cs) xs
  Guard_C_DocOptions d c e -> guardCons d c ((\x -> d_C_withIndex e cd x) $!
    addCs c cs)
  Fail_C_DocOptions d info -> failCons d (traceFail "CurryDoc.Options.withIndex"
    [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Options.withIndex" (showCons x1))

nd_C_withIndex :: C_DocOptions -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C_withIndex x1 s cd cs = case x1 of
  HO_C_DocOptions x2 x3 x4 x5 x6 x7 x8 -> x3
  Choice_C_DocOptions d i l r -> narrow d i (nd_C_withIndex l s cd cs)
    (nd_C_withIndex r s cd cs)
  Choices_C_DocOptions d i xs -> narrows cs d i (\z -> nd_C_withIndex z s cd cs)
    xs
  Guard_C_DocOptions d c e -> guardCons d c ((\x -> nd_C_withIndex e s cd x) $!
    addCs c cs)
  Fail_C_DocOptions d info -> failCons d (traceFail "CurryDoc.Options.withIndex"
    [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Options.withIndex" (showCons x1))

d_C_withMarkdown :: C_DocOptions -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_withMarkdown x1 cd cs = case x1 of
  C_DocOptions x2 x3 x4 x5 x6 x7 x8 -> x4
  Choice_C_DocOptions d i l r -> narrow d i (d_C_withMarkdown l cd cs)
    (d_C_withMarkdown r cd cs)
  Choices_C_DocOptions d i xs -> narrows cs d i (\z -> d_C_withMarkdown z cd cs)
    xs
  Guard_C_DocOptions d c e -> guardCons d c ((\x -> d_C_withMarkdown e cd x) $!
    addCs c cs)
  Fail_C_DocOptions d info -> failCons d (traceFail
    "CurryDoc.Options.withMarkdown" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Options.withMarkdown" (showCons x1))

nd_C_withMarkdown :: C_DocOptions -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C_withMarkdown x1 s cd cs = case x1 of
  HO_C_DocOptions x2 x3 x4 x5 x6 x7 x8 -> x4
  Choice_C_DocOptions d i l r -> narrow d i (nd_C_withMarkdown l s cd cs)
    (nd_C_withMarkdown r s cd cs)
  Choices_C_DocOptions d i xs -> narrows cs d i (\z -> nd_C_withMarkdown z s cd
    cs) xs
  Guard_C_DocOptions d c e -> guardCons d c ((\x -> nd_C_withMarkdown e s cd
    x) $! addCs c cs)
  Fail_C_DocOptions d info -> failCons d (traceFail
    "CurryDoc.Options.withMarkdown" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Options.withMarkdown" (showCons x1))

d_C_mainTitle :: C_DocOptions -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_mainTitle x1 cd cs = case x1 of
  C_DocOptions x2 x3 x4 x5 x6 x7 x8 -> x5
  Choice_C_DocOptions d i l r -> narrow d i (d_C_mainTitle l cd cs)
    (d_C_mainTitle r cd cs)
  Choices_C_DocOptions d i xs -> narrows cs d i (\z -> d_C_mainTitle z cd cs) xs
  Guard_C_DocOptions d c e -> guardCons d c ((\x -> d_C_mainTitle e cd x) $!
    addCs c cs)
  Fail_C_DocOptions d info -> failCons d (traceFail "CurryDoc.Options.mainTitle"
    [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Options.mainTitle" (showCons x1))

nd_C_mainTitle :: C_DocOptions -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C_mainTitle x1 s cd cs = case x1 of
  HO_C_DocOptions x2 x3 x4 x5 x6 x7 x8 -> x5
  Choice_C_DocOptions d i l r -> narrow d i (nd_C_mainTitle l s cd cs)
    (nd_C_mainTitle r s cd cs)
  Choices_C_DocOptions d i xs -> narrows cs d i (\z -> nd_C_mainTitle z s cd cs)
    xs
  Guard_C_DocOptions d c e -> guardCons d c ((\x -> nd_C_mainTitle e s cd x) $!
    addCs c cs)
  Fail_C_DocOptions d info -> failCons d (traceFail "CurryDoc.Options.mainTitle"
    [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Options.mainTitle" (showCons x1))

d_C_useDirURL :: C_DocOptions -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_useDirURL x1 cd cs = case x1 of
  C_DocOptions x2 x3 x4 x5 x6 x7 x8 -> x6
  Choice_C_DocOptions d i l r -> narrow d i (d_C_useDirURL l cd cs)
    (d_C_useDirURL r cd cs)
  Choices_C_DocOptions d i xs -> narrows cs d i (\z -> d_C_useDirURL z cd cs) xs
  Guard_C_DocOptions d c e -> guardCons d c ((\x -> d_C_useDirURL e cd x) $!
    addCs c cs)
  Fail_C_DocOptions d info -> failCons d (traceFail "CurryDoc.Options.useDirURL"
    [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Options.useDirURL" (showCons x1))

nd_C_useDirURL :: C_DocOptions -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_C_useDirURL x1 s cd cs = case x1 of
  HO_C_DocOptions x2 x3 x4 x5 x6 x7 x8 -> x6
  Choice_C_DocOptions d i l r -> narrow d i (nd_C_useDirURL l s cd cs)
    (nd_C_useDirURL r s cd cs)
  Choices_C_DocOptions d i xs -> narrows cs d i (\z -> nd_C_useDirURL z s cd cs)
    xs
  Guard_C_DocOptions d c e -> guardCons d c ((\x -> nd_C_useDirURL e s cd x) $!
    addCs c cs)
  Fail_C_DocOptions d info -> failCons d (traceFail "CurryDoc.Options.useDirURL"
    [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Options.useDirURL" (showCons x1))

d_C_docMods :: C_DocOptions -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_docMods x1 cd cs = case x1 of
  C_DocOptions x2 x3 x4 x5 x6 x7 x8 -> x7
  Choice_C_DocOptions d i l r -> narrow d i (d_C_docMods l cd cs) (d_C_docMods r
    cd cs)
  Choices_C_DocOptions d i xs -> narrows cs d i (\z -> d_C_docMods z cd cs) xs
  Guard_C_DocOptions d c e -> guardCons d c ((\x -> d_C_docMods e cd x) $! addCs
    c cs)
  Fail_C_DocOptions d info -> failCons d (traceFail "CurryDoc.Options.docMods"
    [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Options.docMods" (showCons x1))

nd_C_docMods :: C_DocOptions -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C_docMods x1 s cd cs = case x1 of
  HO_C_DocOptions x2 x3 x4 x5 x6 x7 x8 -> x7
  Choice_C_DocOptions d i l r -> narrow d i (nd_C_docMods l s cd cs)
    (nd_C_docMods r s cd cs)
  Choices_C_DocOptions d i xs -> narrows cs d i (\z -> nd_C_docMods z s cd cs)
    xs
  Guard_C_DocOptions d c e -> guardCons d c ((\x -> nd_C_docMods e s cd x) $!
    addCs c cs)
  Fail_C_DocOptions d info -> failCons d (traceFail "CurryDoc.Options.docMods"
    [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Options.docMods" (showCons x1))

d_C_docURL :: C_DocOptions -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_docURL x1 cd cs = case x1 of
  C_DocOptions x2 x3 x4 x5 x6 x7 x8 -> x8
  Choice_C_DocOptions d i l r -> narrow d i (d_C_docURL l cd cs) (d_C_docURL r
    cd cs)
  Choices_C_DocOptions d i xs -> narrows cs d i (\z -> d_C_docURL z cd cs) xs
  Guard_C_DocOptions d c e -> guardCons d c ((\x -> d_C_docURL e cd x) $! addCs
    c cs)
  Fail_C_DocOptions d info -> failCons d (traceFail "CurryDoc.Options.docURL"
    [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Options.docURL" (showCons x1))

nd_C_docURL :: C_DocOptions -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_C_docURL x1 s cd cs = case x1 of
  HO_C_DocOptions x2 x3 x4 x5 x6 x7 x8 -> x8
  Choice_C_DocOptions d i l r -> narrow d i (nd_C_docURL l s cd cs) (nd_C_docURL
    r s cd cs)
  Choices_C_DocOptions d i xs -> narrows cs d i (\z -> nd_C_docURL z s cd cs) xs
  Guard_C_DocOptions d c e -> guardCons d c ((\x -> nd_C_docURL e s cd x) $!
    addCs c cs)
  Fail_C_DocOptions d info -> failCons d (traceFail "CurryDoc.Options.docURL"
    [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Options.docURL" (showCons x1))

d_C_defaultCurryDocOptions :: Cover -> ConstStore -> C_DocOptions
d_C_defaultCurryDocOptions cd cs = C_DocOptions C_HtmlDoc Curry_Prelude.C_True
  Curry_Prelude.C_True Curry_Prelude.OP_List Curry_Prelude.OP_List
  Curry_Prelude.OP_List Curry_Prelude.d_C_id

nd_C_defaultCurryDocOptions :: IDSupply -> Cover -> ConstStore -> C_DocOptions
nd_C_defaultCurryDocOptions s cd cs = HO_C_DocOptions C_HtmlDoc
  Curry_Prelude.C_True Curry_Prelude.C_True Curry_Prelude.OP_List
  Curry_Prelude.OP_List Curry_Prelude.OP_List (wrapDX id Curry_Prelude.d_C_id)

d_C__case_3 :: C_DocType -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_3 x2 cd cs = case x2 of
  C_HtmlDoc -> Curry_Prelude.C_False
  C_TexDoc -> Curry_Prelude.C_False
  C_CDoc -> Curry_Prelude.C_True
  Choice_C_DocType d i l r -> narrow d i (d_C__case_3 l cd cs) (d_C__case_3 r cd
    cs)
  Choices_C_DocType d i xs -> narrows cs d i (\z -> d_C__case_3 z cd cs) xs
  Guard_C_DocType d c e -> guardCons d c ((\x -> d_C__case_3 e cd x) $! addCs c
    cs)
  Fail_C_DocType d info -> failCons d (traceFail "CurryDoc.Options._case_3"
    [show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Options._case_3" (showCons x2))

d_C__case_4 :: C_DocType -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_4 x2 cd cs = case x2 of
  C_HtmlDoc -> Curry_Prelude.C_False
  C_TexDoc -> Curry_Prelude.C_True
  C_CDoc -> Curry_Prelude.C_False
  Choice_C_DocType d i l r -> narrow d i (d_C__case_4 l cd cs) (d_C__case_4 r cd
    cs)
  Choices_C_DocType d i xs -> narrows cs d i (\z -> d_C__case_4 z cd cs) xs
  Guard_C_DocType d c e -> guardCons d c ((\x -> d_C__case_4 e cd x) $! addCs c
    cs)
  Fail_C_DocType d info -> failCons d (traceFail "CurryDoc.Options._case_4"
    [show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Options._case_4" (showCons x2))

d_C__case_5 :: C_DocType -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_5 x2 cd cs = case x2 of
  C_HtmlDoc -> Curry_Prelude.C_True
  C_TexDoc -> Curry_Prelude.C_False
  C_CDoc -> Curry_Prelude.C_False
  Choice_C_DocType d i l r -> narrow d i (d_C__case_5 l cd cs) (d_C__case_5 r cd
    cs)
  Choices_C_DocType d i xs -> narrows cs d i (\z -> d_C__case_5 z cd cs) xs
  Guard_C_DocType d c e -> guardCons d c ((\x -> d_C__case_5 e cd x) $! addCs c
    cs)
  Fail_C_DocType d info -> failCons d (traceFail "CurryDoc.Options._case_5"
    [show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Options._case_5" (showCons x2))

d_C__case_0 :: C_DocType -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_0 x2 cd cs = case x2 of
  C_HtmlDoc -> Curry_Prelude.C_False
  C_TexDoc -> Curry_Prelude.C_False
  C_CDoc -> Curry_Prelude.C_True
  Choice_C_DocType d i l r -> narrow d i (d_C__case_0 l cd cs) (d_C__case_0 r cd
    cs)
  Choices_C_DocType d i xs -> narrows cs d i (\z -> d_C__case_0 z cd cs) xs
  Guard_C_DocType d c e -> guardCons d c ((\x -> d_C__case_0 e cd x) $! addCs c
    cs)
  Fail_C_DocType d info -> failCons d (traceFail "CurryDoc.Options._case_0"
    [show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Options._case_0" (showCons x2))

d_C__case_1 :: C_DocType -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_1 x2 cd cs = case x2 of
  C_HtmlDoc -> Curry_Prelude.C_False
  C_TexDoc -> Curry_Prelude.C_True
  C_CDoc -> Curry_Prelude.C_False
  Choice_C_DocType d i l r -> narrow d i (d_C__case_1 l cd cs) (d_C__case_1 r cd
    cs)
  Choices_C_DocType d i xs -> narrows cs d i (\z -> d_C__case_1 z cd cs) xs
  Guard_C_DocType d c e -> guardCons d c ((\x -> d_C__case_1 e cd x) $! addCs c
    cs)
  Fail_C_DocType d info -> failCons d (traceFail "CurryDoc.Options._case_1"
    [show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Options._case_1" (showCons x2))

d_C__case_2 :: C_DocType -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_2 x2 cd cs = case x2 of
  C_HtmlDoc -> Curry_Prelude.C_True
  C_TexDoc -> Curry_Prelude.C_False
  C_CDoc -> Curry_Prelude.C_False
  Choice_C_DocType d i l r -> narrow d i (d_C__case_2 l cd cs) (d_C__case_2 r cd
    cs)
  Choices_C_DocType d i xs -> narrows cs d i (\z -> d_C__case_2 z cd cs) xs
  Guard_C_DocType d c e -> guardCons d c ((\x -> d_C__case_2 e cd x) $! addCs c
    cs)
  Fail_C_DocType d info -> failCons d (traceFail "CurryDoc.Options._case_2"
    [show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Options._case_2" (showCons x2))

