{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module CPP.ICode.Curry_ParsePos
  ( C_Pos (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
  , d_C_tw
  , d_C_unknown_fname
  , d_C_setPos
  , d_C_initPos
  , d_C_getFilename
  , d_C_setFilename
  , d_C_getAbs
  , d_C_setAbs
  , d_C_moveAbs
  , d_C_getLn
  , d_C_setLn
  , d_C_moveLn
  , d_C_getCol
  , d_C_setCol
  , d_C_moveCol
  , d_C_lnDifference
  , d_C_colDifference
  , d_C_absDifference
  , d_C_fullDifference
  , d_C_movePosByChar
  , d_C_movePosByString
  , d_C_toSimplePos
  , d_C_fromSimplePos
  , d_C_fromSimplePosWithFname )
  where

import Basics
import qualified Curry_Prelude


data C_Pos
  = C_Pos (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Int
    Curry_Prelude.C_Int Curry_Prelude.C_Int
  | Choice_C_Pos Cover ID C_Pos C_Pos
  | Choices_C_Pos Cover ID [C_Pos]
  | Fail_C_Pos Cover FailInfo
  | Guard_C_Pos Cover Constraints C_Pos

instance Show C_Pos where
  showsPrec d (Choice_C_Pos cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Pos cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Pos cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Pos cd info) = showChar '!'
  showsPrec _ (C_Pos x1 x2 x3 x4) = showString "(Pos" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . (showChar ' ' .
    (shows x4 . showChar ')'))))))))

instance Read C_Pos where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Pos x1 x2 x3 x4, r4) | (_, r0)
    <- readQualified "CPP.ICode.ParsePos" "Pos" r, (x1, r1) <- readsPrec 11 r0,
    (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2, (x4, r4) <-
    readsPrec 11 r3]) s

instance NonDet C_Pos where
  choiceCons = Choice_C_Pos
  choicesCons = Choices_C_Pos
  failCons = Fail_C_Pos
  guardCons = Guard_C_Pos
  try (Choice_C_Pos cd i x y) = tryChoice cd i x y
  try (Choices_C_Pos cd i xs) = tryChoices cd i xs
  try (Fail_C_Pos cd info) = Fail cd info
  try (Guard_C_Pos cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Pos cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Pos cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Pos cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Pos cd i _) = error
    ("CPP.ICode.ParsePos.Pos.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Pos cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Pos cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Pos where
  generate s c = Choices_C_Pos c (freeID [4] s) [C_Pos (generate (leftSupply
    (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c) (generate
    (leftSupply (rightSupply s)) c) (generate (rightSupply (rightSupply s)) c)]

instance NormalForm C_Pos where
  ($!!) cont (C_Pos x1 x2 x3 x4) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> cont (C_Pos y1 y2 y3 y4) d cs) x4 d
    cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_Pos cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Pos cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Pos cd c e) d cs = guardCons cd c (($!!) cont e d (addCs c
    cs))
  ($!!) _ (Fail_C_Pos cd info) _ _ = failCons cd info
  ($##) cont (C_Pos x1 x2 x3 x4) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> ($##) (\y4 d cs -> cont (C_Pos y1 y2 y3 y4) d cs) x4 d
    cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_Pos cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Pos cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Pos cd c e) d cs = guardCons cd c (($##) cont e d (addCs c
    cs))
  ($##) _ (Fail_C_Pos cd info) _ _ = failCons cd info
  showCons (C_Pos _ _ _ _) = "CPP.ICode.ParsePos.Pos _ _ _ _"
  showCons x = error ("CPP.ICode.ParsePos.Pos.showCons: no constructor: " ++
    show x)
  searchNF search cont (C_Pos x1 x2 x3 x4) = search (\y1 -> search (\y2 ->
    search (\y3 -> search (\y4 -> cont (C_Pos y1 y2 y3 y4)) x4) x3) x2) x1
  searchNF _ _ x = error ("CPP.ICode.ParsePos.Pos.searchNF: no constructor: " ++
    show x)

instance Unifiable C_Pos where
  (=.=) (C_Pos x1 x2 x3 x4) (C_Pos y1 y2 y3 y4) d cs = (&) ((=:=) x1 y1 d cs)
    ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((=:=) x4 y4 d cs) d cs) d
    cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Pos x1 x2 x3 x4) (C_Pos y1 y2 y3 y4) d cs = (&) ((=:<=) x1 y1 d cs)
    ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs) ((=:<=) x4 y4 d cs) d cs)
    d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Pos x3 x4 x5 x6) = (i :=: ChooseN 0 4) : concat [bind cd (leftID
    (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (leftID (rightID
    i)) x5, bind cd (rightID (rightID i)) x6]
  bind d i (Choice_C_Pos cd j x y) = [ConstraintChoice cd j (bind d i x) (bind d
    i y)]
  bind d i (Choices_C_Pos cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Pos cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Pos cd i _) = error
    ("CPP.ICode.ParsePos.Pos.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Pos cd info) = [Unsolvable info]
  bind d i (Guard_C_Pos cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Pos x3 x4 x5 x6) = (i :=: ChooseN 0 4) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), leftID (rightID i) :=:
    LazyBind (lazyBind cd (leftID (rightID i)) x5), rightID (rightID i) :=:
    LazyBind (lazyBind cd (rightID (rightID i)) x6)]
  lazyBind d i (Choice_C_Pos cd j x y) = [ConstraintChoice cd j (lazyBind d i x)
    (lazyBind d i y)]
  lazyBind d i (Choices_C_Pos cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j
    xs
  lazyBind d i (Choices_C_Pos cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Pos cd i _) = error
    ("CPP.ICode.ParsePos.Pos.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Pos cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Pos cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Pos where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Pos
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CPP.ICode.ParsePos._inst#Prelude.Data#CPP.ICode.ParsePos.Pos#" [show x1]
    info)
  _ -> failCons cd (consFail
    "CPP.ICode.ParsePos._inst#Prelude.Data#CPP.ICode.ParsePos.Pos#" (showCons
    x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash :: C_Pos
  -> C_Pos -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash x1 x2 s cd cs =
  case x1 of
  C_Pos x3 x4 x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_3 x6 x5 x4 x3 x2 s0 cd cs
  Choice_C_Pos d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
    r x2 s cd cs)
  Choices_C_Pos d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
    z x2 s cd cs) xs
  Guard_C_Pos d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_Pos d info -> failCons d (traceFail
    "CPP.ICode.ParsePos._impl#===#Prelude.Data#CPP.ICode.ParsePos.Pos#" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ParsePos._impl#===#Prelude.Data#CPP.ICode.ParsePos.Pos#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash :: IDSupply
  -> Cover -> ConstStore -> C_Pos
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash s cd cs =
  let s4 = s
  in s4 `seq` (let s5 = leftSupply s4
                   s6 = rightSupply s4
                   s0 = leftSupply s5
                   s1 = rightSupply s5
                   s2 = leftSupply s6
                   s3 = rightSupply s6
  in s5 `seq` (s6 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s3 `seq` C_Pos
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s1 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s2 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s3 cd cs)))))))

d_C_tw :: Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_tw cd cs = Curry_Prelude.C_Int (8)

d_C_unknown_fname :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_unknown_fname cd cs = Curry_Prelude.toCurryString "Unknown file"

d_C_setPos :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Cover -> ConstStore -> C_Pos
d_C_setPos x1 x2 x3 x4 cd cs = C_Pos x1 x2 x3 x4

d_C_initPos :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> C_Pos
d_C_initPos x1 cd cs = C_Pos x1 (Curry_Prelude.C_Int (0)) (Curry_Prelude.C_Int
  (1)) (Curry_Prelude.C_Int (1))

d_C_getFilename :: C_Pos -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_getFilename x1 cd cs = case x1 of
  C_Pos x2 x3 x4 x5 -> x2
  Choice_C_Pos d i l r -> narrow d i (d_C_getFilename l cd cs) (d_C_getFilename
    r cd cs)
  Choices_C_Pos d i xs -> narrows cs d i (\z -> d_C_getFilename z cd cs) xs
  Guard_C_Pos d c e -> guardCons d c ((\x -> d_C_getFilename e cd x) $! addCs c
    cs)
  Fail_C_Pos d info -> failCons d (traceFail "CPP.ICode.ParsePos.getFilename"
    [show x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ParsePos.getFilename" (showCons x1))

d_C_setFilename :: C_Pos -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> C_Pos
d_C_setFilename x1 x2 cd cs = case x1 of
  C_Pos x3 x4 x5 x6 -> C_Pos x2 x4 x5 x6
  Choice_C_Pos d i l r -> narrow d i (d_C_setFilename l x2 cd cs)
    (d_C_setFilename r x2 cd cs)
  Choices_C_Pos d i xs -> narrows cs d i (\z -> d_C_setFilename z x2 cd cs) xs
  Guard_C_Pos d c e -> guardCons d c ((\x -> d_C_setFilename e x2 cd x) $! addCs
    c cs)
  Fail_C_Pos d info -> failCons d (traceFail "CPP.ICode.ParsePos.setFilename"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "CPP.ICode.ParsePos.setFilename" (showCons x1))

d_C_getAbs :: C_Pos -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_getAbs x1 cd cs = case x1 of
  C_Pos x2 x3 x4 x5 -> x3
  Choice_C_Pos d i l r -> narrow d i (d_C_getAbs l cd cs) (d_C_getAbs r cd cs)
  Choices_C_Pos d i xs -> narrows cs d i (\z -> d_C_getAbs z cd cs) xs
  Guard_C_Pos d c e -> guardCons d c ((\x -> d_C_getAbs e cd x) $! addCs c cs)
  Fail_C_Pos d info -> failCons d (traceFail "CPP.ICode.ParsePos.getAbs" [show
    x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ParsePos.getAbs" (showCons x1))

d_C_setAbs :: C_Pos -> Curry_Prelude.C_Int -> Cover -> ConstStore -> C_Pos
d_C_setAbs x1 x2 cd cs = case x1 of
  C_Pos x3 x4 x5 x6 -> C_Pos x3 x2 x5 x6
  Choice_C_Pos d i l r -> narrow d i (d_C_setAbs l x2 cd cs) (d_C_setAbs r x2 cd
    cs)
  Choices_C_Pos d i xs -> narrows cs d i (\z -> d_C_setAbs z x2 cd cs) xs
  Guard_C_Pos d c e -> guardCons d c ((\x -> d_C_setAbs e x2 cd x) $! addCs c
    cs)
  Fail_C_Pos d info -> failCons d (traceFail "CPP.ICode.ParsePos.setAbs" [show
    x1, show x2] info)
  _ -> failCons cd (consFail "CPP.ICode.ParsePos.setAbs" (showCons x1))

d_C_moveAbs :: C_Pos -> Curry_Prelude.C_Int -> Cover -> ConstStore -> C_Pos
d_C_moveAbs x1 x2 cd cs = case x1 of
  C_Pos x3 x4 x5 x6 -> C_Pos x3
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x4 x2 cd cs) x5 x6
  Choice_C_Pos d i l r -> narrow d i (d_C_moveAbs l x2 cd cs) (d_C_moveAbs r x2
    cd cs)
  Choices_C_Pos d i xs -> narrows cs d i (\z -> d_C_moveAbs z x2 cd cs) xs
  Guard_C_Pos d c e -> guardCons d c ((\x -> d_C_moveAbs e x2 cd x) $! addCs c
    cs)
  Fail_C_Pos d info -> failCons d (traceFail "CPP.ICode.ParsePos.moveAbs" [show
    x1, show x2] info)
  _ -> failCons cd (consFail "CPP.ICode.ParsePos.moveAbs" (showCons x1))

d_C_getLn :: C_Pos -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_getLn x1 cd cs = case x1 of
  C_Pos x2 x3 x4 x5 -> x4
  Choice_C_Pos d i l r -> narrow d i (d_C_getLn l cd cs) (d_C_getLn r cd cs)
  Choices_C_Pos d i xs -> narrows cs d i (\z -> d_C_getLn z cd cs) xs
  Guard_C_Pos d c e -> guardCons d c ((\x -> d_C_getLn e cd x) $! addCs c cs)
  Fail_C_Pos d info -> failCons d (traceFail "CPP.ICode.ParsePos.getLn" [show
    x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ParsePos.getLn" (showCons x1))

d_C_setLn :: C_Pos -> Curry_Prelude.C_Int -> Cover -> ConstStore -> C_Pos
d_C_setLn x1 x2 cd cs = case x1 of
  C_Pos x3 x4 x5 x6 -> C_Pos x3 x4 x2 x6
  Choice_C_Pos d i l r -> narrow d i (d_C_setLn l x2 cd cs) (d_C_setLn r x2 cd
    cs)
  Choices_C_Pos d i xs -> narrows cs d i (\z -> d_C_setLn z x2 cd cs) xs
  Guard_C_Pos d c e -> guardCons d c ((\x -> d_C_setLn e x2 cd x) $! addCs c cs)
  Fail_C_Pos d info -> failCons d (traceFail "CPP.ICode.ParsePos.setLn" [show x1
    , show x2] info)
  _ -> failCons cd (consFail "CPP.ICode.ParsePos.setLn" (showCons x1))

d_C_moveLn :: C_Pos -> Curry_Prelude.C_Int -> Cover -> ConstStore -> C_Pos
d_C_moveLn x1 x2 cd cs = case x1 of
  C_Pos x3 x4 x5 x6 -> C_Pos x3 x4
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x5 x2 cd cs) x6
  Choice_C_Pos d i l r -> narrow d i (d_C_moveLn l x2 cd cs) (d_C_moveLn r x2 cd
    cs)
  Choices_C_Pos d i xs -> narrows cs d i (\z -> d_C_moveLn z x2 cd cs) xs
  Guard_C_Pos d c e -> guardCons d c ((\x -> d_C_moveLn e x2 cd x) $! addCs c
    cs)
  Fail_C_Pos d info -> failCons d (traceFail "CPP.ICode.ParsePos.moveLn" [show
    x1, show x2] info)
  _ -> failCons cd (consFail "CPP.ICode.ParsePos.moveLn" (showCons x1))

d_C_getCol :: C_Pos -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_getCol x1 cd cs = case x1 of
  C_Pos x2 x3 x4 x5 -> x5
  Choice_C_Pos d i l r -> narrow d i (d_C_getCol l cd cs) (d_C_getCol r cd cs)
  Choices_C_Pos d i xs -> narrows cs d i (\z -> d_C_getCol z cd cs) xs
  Guard_C_Pos d c e -> guardCons d c ((\x -> d_C_getCol e cd x) $! addCs c cs)
  Fail_C_Pos d info -> failCons d (traceFail "CPP.ICode.ParsePos.getCol" [show
    x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ParsePos.getCol" (showCons x1))

d_C_setCol :: C_Pos -> Curry_Prelude.C_Int -> Cover -> ConstStore -> C_Pos
d_C_setCol x1 x2 cd cs = case x1 of
  C_Pos x3 x4 x5 x6 -> C_Pos x3 x4 x5 x2
  Choice_C_Pos d i l r -> narrow d i (d_C_setCol l x2 cd cs) (d_C_setCol r x2 cd
    cs)
  Choices_C_Pos d i xs -> narrows cs d i (\z -> d_C_setCol z x2 cd cs) xs
  Guard_C_Pos d c e -> guardCons d c ((\x -> d_C_setCol e x2 cd x) $! addCs c
    cs)
  Fail_C_Pos d info -> failCons d (traceFail "CPP.ICode.ParsePos.setCol" [show
    x1, show x2] info)
  _ -> failCons cd (consFail "CPP.ICode.ParsePos.setCol" (showCons x1))

d_C_moveCol :: C_Pos -> Curry_Prelude.C_Int -> Cover -> ConstStore -> C_Pos
d_C_moveCol x1 x2 cd cs = case x1 of
  C_Pos x3 x4 x5 x6 -> C_Pos x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x6 x2 cd cs)
  Choice_C_Pos d i l r -> narrow d i (d_C_moveCol l x2 cd cs) (d_C_moveCol r x2
    cd cs)
  Choices_C_Pos d i xs -> narrows cs d i (\z -> d_C_moveCol z x2 cd cs) xs
  Guard_C_Pos d c e -> guardCons d c ((\x -> d_C_moveCol e x2 cd x) $! addCs c
    cs)
  Fail_C_Pos d info -> failCons d (traceFail "CPP.ICode.ParsePos.moveCol" [show
    x1, show x2] info)
  _ -> failCons cd (consFail "CPP.ICode.ParsePos.moveCol" (showCons x1))

d_C_lnDifference :: C_Pos -> C_Pos -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_lnDifference x1 x2 cd cs =
  Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (d_C_getLn x2 cd cs) (d_C_getLn x1 cd cs) cd cs

d_C_colDifference :: C_Pos -> C_Pos -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_C_colDifference x1 x2 cd cs =
  Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (d_C_getCol x2 cd cs) (d_C_getCol x1 cd cs) cd cs

d_C_absDifference :: C_Pos -> C_Pos -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_C_absDifference x1 x2 cd cs =
  Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (d_C_getAbs x2 cd cs) (d_C_getAbs x1 cd cs) cd cs

d_C_fullDifference :: C_Pos -> C_Pos -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_Prelude.C_Int
d_C_fullDifference x1 x2 cd cs = Curry_Prelude.OP_Tuple2 (d_C_lnDifference x1 x2
  cd cs) (d_C_colDifference x1 x2 cd cs)

d_C_movePosByChar :: C_Pos -> Curry_Prelude.C_Char -> Cover -> ConstStore
  -> C_Pos
d_C_movePosByChar x1 x2 cd cs = case x1 of
  C_Pos x3 x4 x5 x6 -> d_C__case_2 x2 x6 x5 x4 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '\n'#) cd cs) cd cs
  Choice_C_Pos d i l r -> narrow d i (d_C_movePosByChar l x2 cd cs)
    (d_C_movePosByChar r x2 cd cs)
  Choices_C_Pos d i xs -> narrows cs d i (\z -> d_C_movePosByChar z x2 cd cs) xs
  Guard_C_Pos d c e -> guardCons d c ((\x -> d_C_movePosByChar e x2 cd x) $!
    addCs c cs)
  Fail_C_Pos d info -> failCons d (traceFail "CPP.ICode.ParsePos.movePosByChar"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "CPP.ICode.ParsePos.movePosByChar" (showCons x1))

d_C_movePosByString :: C_Pos -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> C_Pos
d_C_movePosByString x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> x1
  Curry_Prelude.OP_Cons x3 x4 -> d_C_movePosByString (d_C_movePosByChar x1 x3 cd
    cs) x4 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_movePosByString x1 l
    cd cs) (d_C_movePosByString x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_movePosByString x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_movePosByString
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ParsePos.movePosByString" [show x1, show x2] info)
  _ -> failCons cd (consFail "CPP.ICode.ParsePos.movePosByString" (showCons x2))

d_C_toSimplePos :: C_Pos -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int Curry_Prelude.C_Int
d_C_toSimplePos x1 cd cs = Curry_Prelude.OP_Tuple2 (d_C_getLn x1 cd cs)
  (d_C_getCol x1 cd cs)

d_C_fromSimplePos :: Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  Curry_Prelude.C_Int -> Cover -> ConstStore -> C_Pos
d_C_fromSimplePos x1 cd cs = d_C_fromSimplePosWithFname x1 (d_C_unknown_fname cd
  cs) cd cs

d_C_fromSimplePosWithFname :: Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> C_Pos
d_C_fromSimplePosWithFname x1 x2 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C_setPos x2
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x3 x4 cd cs) x3 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_C_fromSimplePosWithFname l x2 cd cs) (d_C_fromSimplePosWithFname r x2 cd
    cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_C_fromSimplePosWithFname z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_C_fromSimplePosWithFname e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CPP.ICode.ParsePos.fromSimplePosWithFname" [show x1, show x2] info)
  _ -> failCons cd (consFail "CPP.ICode.ParsePos.fromSimplePosWithFname"
    (showCons x1))

nd_C__case_3 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Pos
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_3 x6 x5 x4 x3 x2 s cd cs = case x2 of
  C_Pos x7 x8 x9 x10 -> let s12 = s
    in s12 `seq` (let s8 = leftSupply s12
                      s11 = rightSupply s12
    in s8 `seq` (s11 `seq` Curry_Prelude.d_OP_amp_amp (let s4 = leftSupply s8
                                                           s7 = rightSupply s8
    in s4 `seq` (s7 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s4
                                                          s3 = rightSupply s4
    in s0 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x7 s0 cd cs) (let s2 = leftSupply s3
                         s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs)) x4 s1 cd cs) x8 s2 cd cs)) cd cs)) (let s6 = leftSupply s7
                                                    s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs)) x5 s5 cd cs) x9 s6 cd cs)) cd cs)) (let s10 = leftSupply s11
                                                    s9 = rightSupply s11
    in s10 `seq` (s9 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs)) x6 s9 cd cs) x10 s10 cd cs)) cd cs))
  Choice_C_Pos d i l r -> narrow d i (nd_C__case_3 x6 x5 x4 x3 l s cd cs)
    (nd_C__case_3 x6 x5 x4 x3 r s cd cs)
  Choices_C_Pos d i xs -> narrows cs d i (\z -> nd_C__case_3 x6 x5 x4 x3 z s cd
    cs) xs
  Guard_C_Pos d c e -> guardCons d c ((\x -> nd_C__case_3 x6 x5 x4 x3 e s cd
    x) $! addCs c cs)
  Fail_C_Pos d info -> failCons d (traceFail "CPP.ICode.ParsePos._case_3" [show
    x6, show x5, show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "CPP.ICode.ParsePos._case_3" (showCons x2))

d_C__case_2 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Pos
d_C__case_2 x2 x6 x5 x4 x3 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> C_Pos x3
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x4 (Curry_Prelude.C_Int (1)) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x5 (Curry_Prelude.C_Int (1)) cd cs) (Curry_Prelude.C_Int (1))
  Curry_Prelude.C_False -> d_C__case_1 x2 x6 x5 x4 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '\t'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x2 x6 x5 x4 x3
    l cd cs) (d_C__case_2 x2 x6 x5 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x2 x6
    x5 x4 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x2 x6 x5
    x4 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ParsePos._case_2" [show x2, show x6, show x5, show x4, show x3
    , show x7] info)
  _ -> failCons cd (consFail "CPP.ICode.ParsePos._case_2" (showCons x7))

d_C__case_1 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Pos
d_C__case_1 x2 x6 x5 x4 x3 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> C_Pos x3
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x4 (Curry_Prelude.C_Int (1)) cd cs) x5
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x6 (d_C_tw cd cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_mod_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
    cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x6 (Curry_Prelude.C_Int (1)) cd cs) cd cs) (d_C_tw cd cs) cd cs) cd cs)
  Curry_Prelude.C_False -> d_C__case_0 x6 x5 x4 x3 (Curry_Prelude.d_C_otherwise
    cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x2 x6 x5 x4 x3
    l cd cs) (d_C__case_1 x2 x6 x5 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x2 x6
    x5 x4 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x2 x6 x5
    x4 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ParsePos._case_1" [show x2, show x6, show x5, show x4, show x3
    , show x7] info)
  _ -> failCons cd (consFail "CPP.ICode.ParsePos._case_1" (showCons x7))

d_C__case_0 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Pos
d_C__case_0 x6 x5 x4 x3 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> C_Pos x3
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x4 (Curry_Prelude.C_Int (1)) cd cs) x5
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x6 (Curry_Prelude.C_Int (1)) cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x6 x5 x4 x3 l
    cd cs) (d_C__case_0 x6 x5 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x6 x5
    x4 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x6 x5 x4
    x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ParsePos._case_0" [show x6, show x5, show x4, show x3, show x7]
    info)
  _ -> failCons cd (consFail "CPP.ICode.ParsePos._case_0" (showCons x7))

