{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module CPP.ICode.Curry_ParseTypes
  ( C_StandardToken (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseTypes_dot_StandardToken_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseTypes_dot_StandardToken_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseTypes_dot_StandardToken_hash
  , d_C_getIdentPos
  , d_C_getCodePos
  , d_C_getOffset
  , d_C_getLangtag
  , d_C_getCode
  , d_C_containsDSL )
  where

import Basics
import qualified CPP.ICode.Curry_ParsePos
import qualified Curry_Prelude


data C_StandardToken
  = C_StTk CPP.ICode.Curry_ParsePos.C_Pos CPP.ICode.Curry_ParsePos.C_Pos
    (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char))
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | Choice_C_StandardToken Cover ID C_StandardToken C_StandardToken
  | Choices_C_StandardToken Cover ID [C_StandardToken]
  | Fail_C_StandardToken Cover FailInfo
  | Guard_C_StandardToken Cover Constraints C_StandardToken

instance Show C_StandardToken where
  showsPrec d (Choice_C_StandardToken cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_StandardToken cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_StandardToken cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_StandardToken cd info) = showChar '!'
  showsPrec _ (C_StTk x1 x2 x3 x4) = showString "(StTk" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . (showChar ' ' .
    (shows x4 . showChar ')'))))))))

instance Read C_StandardToken where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_StTk x1 x2 x3 x4, r4) | (_
    , r0) <- readQualified "CPP.ICode.ParseTypes" "StTk" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2,
    (x4, r4) <- readsPrec 11 r3]) s

instance NonDet C_StandardToken where
  choiceCons = Choice_C_StandardToken
  choicesCons = Choices_C_StandardToken
  failCons = Fail_C_StandardToken
  guardCons = Guard_C_StandardToken
  try (Choice_C_StandardToken cd i x y) = tryChoice cd i x y
  try (Choices_C_StandardToken cd i xs) = tryChoices cd i xs
  try (Fail_C_StandardToken cd info) = Fail cd info
  try (Guard_C_StandardToken cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_StandardToken cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_StandardToken cd i@(NarrowedID _ _) xs) = f cd i
    xs
  match _ _ f _ _ _ (Choices_C_StandardToken cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_StandardToken cd i _) = error
    ("CPP.ICode.ParseTypes.StandardToken.match: Choices with ChoiceID " ++ show
    i)
  match _ _ _ f _ _ (Fail_C_StandardToken cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_StandardToken cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_StandardToken where
  generate s c = Choices_C_StandardToken c (freeID [4] s) [C_StTk (generate
    (leftSupply (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c)
    (generate (leftSupply (rightSupply s)) c) (generate (rightSupply
    (rightSupply s)) c)]

instance NormalForm C_StandardToken where
  ($!!) cont (C_StTk x1 x2 x3 x4) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> cont (C_StTk y1 y2 y3 y4) d cs) x4 d
    cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_StandardToken cd i x y) d cs = nfChoice cont cd i x y cd
    cs
  ($!!) cont (Choices_C_StandardToken cd i xs) d cs = nfChoices cont cd i xs d
    cs
  ($!!) cont (Guard_C_StandardToken cd c e) d cs = guardCons cd c (($!!) cont e
    d (addCs c cs))
  ($!!) _ (Fail_C_StandardToken cd info) _ _ = failCons cd info
  ($##) cont (C_StTk x1 x2 x3 x4) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> ($##) (\y4 d cs -> cont (C_StTk y1 y2 y3 y4) d cs) x4 d
    cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_StandardToken cd i x y) d cs = gnfChoice cont cd i x y cd
    cs
  ($##) cont (Choices_C_StandardToken cd i xs) d cs = gnfChoices cont cd i xs d
    cs
  ($##) cont (Guard_C_StandardToken cd c e) d cs = guardCons cd c (($##) cont e
    d (addCs c cs))
  ($##) _ (Fail_C_StandardToken cd info) _ _ = failCons cd info
  showCons (C_StTk _ _ _ _) = "CPP.ICode.ParseTypes.StTk _ _ _ _"
  showCons x = error
    ("CPP.ICode.ParseTypes.StandardToken.showCons: no constructor: " ++ show x)
  searchNF search cont (C_StTk x1 x2 x3 x4) = search (\y1 -> search (\y2 ->
    search (\y3 -> search (\y4 -> cont (C_StTk y1 y2 y3 y4)) x4) x3) x2) x1
  searchNF _ _ x = error
    ("CPP.ICode.ParseTypes.StandardToken.searchNF: no constructor: " ++ show x)

instance Unifiable C_StandardToken where
  (=.=) (C_StTk x1 x2 x3 x4) (C_StTk y1 y2 y3 y4) d cs = (&) ((=:=) x1 y1 d cs)
    ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((=:=) x4 y4 d cs) d cs) d
    cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_StTk x1 x2 x3 x4) (C_StTk y1 y2 y3 y4) d cs = (&) ((=:<=) x1 y1 d
    cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs) ((=:<=) x4 y4 d cs) d
    cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_StTk x3 x4 x5 x6) = (i :=: ChooseN 0 4) : concat [bind cd (leftID
    (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (leftID (rightID
    i)) x5, bind cd (rightID (rightID i)) x6]
  bind d i (Choice_C_StandardToken cd j x y) = [ConstraintChoice cd j (bind d i
    x) (bind d i y)]
  bind d i (Choices_C_StandardToken cd j@(FreeID _ _) xs) = bindOrNarrow d i cd
    j xs
  bind d i (Choices_C_StandardToken cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_StandardToken cd i _) = error
    ("CPP.ICode.ParseTypes.StandardToken.bind: Choices with ChoiceID: " ++ show
    i)
  bind _ _ (Fail_C_StandardToken cd info) = [Unsolvable info]
  bind d i (Guard_C_StandardToken cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_StTk x3 x4 x5 x6) = (i :=: ChooseN 0 4) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), leftID (rightID i) :=:
    LazyBind (lazyBind cd (leftID (rightID i)) x5), rightID (rightID i) :=:
    LazyBind (lazyBind cd (rightID (rightID i)) x6)]
  lazyBind d i (Choice_C_StandardToken cd j x y) = [ConstraintChoice cd j
    (lazyBind d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_StandardToken cd j@(FreeID _ _) xs) = lazyBindOrNarrow
    d i cd j xs
  lazyBind d i (Choices_C_StandardToken cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_StandardToken cd i _) = error
    ("CPP.ICode.ParseTypes.StandardToken.lazyBind: Choices with ChoiceID: " ++
    show i)
  lazyBind _ _ (Fail_C_StandardToken cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_StandardToken cd c e) = getConstrList c ++ [i :=:
    LazyBind (lazyBind d i e)]

instance Curry C_StandardToken where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseTypes_dot_StandardToken_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_StandardToken
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseTypes_dot_StandardToken_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseTypes_dot_StandardToken_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseTypes_dot_StandardToken_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseTypes_dot_StandardToken_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseTypes_dot_StandardToken_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseTypes_dot_StandardToken_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseTypes_dot_StandardToken_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CPP.ICode.ParseTypes._inst#Prelude.Data#CPP.ICode.ParseTypes.StandardToken#"
    [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ParseTypes._inst#Prelude.Data#CPP.ICode.ParseTypes.StandardToken#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseTypes_dot_StandardToken_hash :: C_StandardToken
  -> C_StandardToken -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseTypes_dot_StandardToken_hash x1 x2 s cd cs =
  case x1 of
  C_StTk x3 x4 x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_1 x6 x5 x4 x3 x2 s0 cd cs
  Choice_C_StandardToken d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseTypes_dot_StandardToken_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseTypes_dot_StandardToken_hash
    r x2 s cd cs)
  Choices_C_StandardToken d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseTypes_dot_StandardToken_hash
    z x2 s cd cs) xs
  Guard_C_StandardToken d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseTypes_dot_StandardToken_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_StandardToken d info -> failCons d (traceFail
    "CPP.ICode.ParseTypes._impl#===#Prelude.Data#CPP.ICode.ParseTypes.StandardToken#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ParseTypes._impl#===#Prelude.Data#CPP.ICode.ParseTypes.StandardToken#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseTypes_dot_StandardToken_hash :: IDSupply
  -> Cover -> ConstStore -> C_StandardToken
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParseTypes_dot_StandardToken_hash s cd cs =
  let s4 = s
  in s4 `seq` (let s5 = leftSupply s4
                   s6 = rightSupply s4
                   s0 = leftSupply s5
                   s1 = rightSupply s5
                   s2 = leftSupply s6
                   s3 = rightSupply s6
  in s5 `seq` (s6 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s3 `seq` C_StTk
  (CPP.ICode.Curry_ParsePos.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
  s0 cd cs)
  (CPP.ICode.Curry_ParsePos.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
  s1 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s2 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s3 cd cs)))))))

d_C_getIdentPos :: C_StandardToken -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParsePos.C_Pos
d_C_getIdentPos x1 cd cs = case x1 of
  C_StTk x2 x3 x4 x5 -> x2
  Choice_C_StandardToken d i l r -> narrow d i (d_C_getIdentPos l cd cs)
    (d_C_getIdentPos r cd cs)
  Choices_C_StandardToken d i xs -> narrows cs d i (\z -> d_C_getIdentPos z cd
    cs) xs
  Guard_C_StandardToken d c e -> guardCons d c ((\x -> d_C_getIdentPos e cd
    x) $! addCs c cs)
  Fail_C_StandardToken d info -> failCons d (traceFail
    "CPP.ICode.ParseTypes.getIdentPos" [show x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ParseTypes.getIdentPos" (showCons x1))

d_C_getCodePos :: C_StandardToken -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParsePos.C_Pos
d_C_getCodePos x1 cd cs = case x1 of
  C_StTk x2 x3 x4 x5 -> x3
  Choice_C_StandardToken d i l r -> narrow d i (d_C_getCodePos l cd cs)
    (d_C_getCodePos r cd cs)
  Choices_C_StandardToken d i xs -> narrows cs d i (\z -> d_C_getCodePos z cd
    cs) xs
  Guard_C_StandardToken d c e -> guardCons d c ((\x -> d_C_getCodePos e cd x) $!
    addCs c cs)
  Fail_C_StandardToken d info -> failCons d (traceFail
    "CPP.ICode.ParseTypes.getCodePos" [show x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ParseTypes.getCodePos" (showCons x1))

d_C_getOffset :: Cover -> ConstStore -> C_StandardToken -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_C_getOffset cd cs = Curry_Prelude.d_OP_dot CPP.ICode.Curry_ParsePos.d_C_getCol
  d_C_getCodePos cd cs

d_C_getLangtag :: C_StandardToken -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_getLangtag x1 cd cs = case x1 of
  C_StTk x2 x3 x4 x5 -> x4
  Choice_C_StandardToken d i l r -> narrow d i (d_C_getLangtag l cd cs)
    (d_C_getLangtag r cd cs)
  Choices_C_StandardToken d i xs -> narrows cs d i (\z -> d_C_getLangtag z cd
    cs) xs
  Guard_C_StandardToken d c e -> guardCons d c ((\x -> d_C_getLangtag e cd x) $!
    addCs c cs)
  Fail_C_StandardToken d info -> failCons d (traceFail
    "CPP.ICode.ParseTypes.getLangtag" [show x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ParseTypes.getLangtag" (showCons x1))

d_C_getCode :: C_StandardToken -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_getCode x1 cd cs = case x1 of
  C_StTk x2 x3 x4 x5 -> x5
  Choice_C_StandardToken d i l r -> narrow d i (d_C_getCode l cd cs)
    (d_C_getCode r cd cs)
  Choices_C_StandardToken d i xs -> narrows cs d i (\z -> d_C_getCode z cd cs)
    xs
  Guard_C_StandardToken d c e -> guardCons d c ((\x -> d_C_getCode e cd x) $!
    addCs c cs)
  Fail_C_StandardToken d info -> failCons d (traceFail
    "CPP.ICode.ParseTypes.getCode" [show x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ParseTypes.getCode" (showCons x1))

d_C_containsDSL :: C_StandardToken -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_containsDSL x1 cd cs = case x1 of
  C_StTk x2 x3 x4 x5 -> d_C__case_0 x4 cd cs
  Choice_C_StandardToken d i l r -> narrow d i (d_C_containsDSL l cd cs)
    (d_C_containsDSL r cd cs)
  Choices_C_StandardToken d i xs -> narrows cs d i (\z -> d_C_containsDSL z cd
    cs) xs
  Guard_C_StandardToken d c e -> guardCons d c ((\x -> d_C_containsDSL e cd
    x) $! addCs c cs)
  Fail_C_StandardToken d info -> failCons d (traceFail
    "CPP.ICode.ParseTypes.containsDSL" [show x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ParseTypes.containsDSL" (showCons x1))

nd_C__case_1 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> CPP.ICode.Curry_ParsePos.C_Pos -> CPP.ICode.Curry_ParsePos.C_Pos
  -> C_StandardToken -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_1 x6 x5 x4 x3 x2 s cd cs = case x2 of
  C_StTk x7 x8 x9 x10 -> let s6 = s
    in s6 `seq` (let s4 = leftSupply s6
                     s5 = rightSupply s6
    in s4 `seq` (s5 `seq` Curry_Prelude.d_OP_amp_amp (let s2 = leftSupply s4
                                                          s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (CPP.ICode.Curry_ParsePos.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
    x3 x7 s0 cd cs)
    (CPP.ICode.Curry_ParsePos.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
    x4 x8 s1 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Maybe_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    x5 x9 s3 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x6 x10 s5 cd cs) cd cs))
  Choice_C_StandardToken d i l r -> narrow d i (nd_C__case_1 x6 x5 x4 x3 l s cd
    cs) (nd_C__case_1 x6 x5 x4 x3 r s cd cs)
  Choices_C_StandardToken d i xs -> narrows cs d i (\z -> nd_C__case_1 x6 x5 x4
    x3 z s cd cs) xs
  Guard_C_StandardToken d c e -> guardCons d c ((\x -> nd_C__case_1 x6 x5 x4 x3
    e s cd x) $! addCs c cs)
  Fail_C_StandardToken d info -> failCons d (traceFail
    "CPP.ICode.ParseTypes._case_1" [show x6, show x5, show x4, show x3, show x2]
    info)
  _ -> failCons cd (consFail "CPP.ICode.ParseTypes._case_1" (showCons x2))

d_C__case_0 :: Curry_Prelude.C_Maybe (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_0 x4 cd cs = case x4 of
  Curry_Prelude.C_Just x6 -> Curry_Prelude.C_True
  Curry_Prelude.C_Nothing -> Curry_Prelude.C_False
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (d_C__case_0 l cd cs)
    (d_C__case_0 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> d_C__case_0 z cd
    cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x -> d_C__case_0 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "CPP.ICode.ParseTypes._case_0" [show x4] info)
  _ -> failCons cd (consFail "CPP.ICode.ParseTypes._case_0" (showCons x4))

