{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_DetParse
  ( d_C_parse
  , nd_C_parse
  , d_C_failure
  , nd_C_failure
  , d_C_yield
  , d_C_empty
  , d_C_anyChar
  , d_C_check
  , nd_C_check
  , d_C_char
  , d_C_word
  , d_OP_lt_bar_gt
  , nd_OP_lt_bar_gt
  , d_OP_lt_bang_gt
  , nd_OP_lt_bang_gt
  , d_OP_lt_dollar_gt
  , nd_OP_lt_dollar_gt
  , d_OP_lt_star_gt
  , nd_OP_lt_star_gt
  , d_OP_lt_star
  , nd_OP_lt_star
  , d_OP_star_gt
  , nd_OP_star_gt
  , d_OP_star_gt_eq
  , nd_OP_star_gt_eq
  , d_C_many
  , nd_C_many
  , d_C_some
  , nd_C_some )
  where

import Basics
import qualified Curry_Prelude


d_C_parse :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe t0
d_C_parse x1 x2 cd cs = d_C__case_2 x2 x1 (Curry_Prelude.d_OP_dollar
  (Curry_Prelude.d_C_filter (Curry_Prelude.d_OP_dot Curry_Prelude.d_C_null
  Curry_Prelude.d_C_snd cd cs)) (Curry_Prelude.d_C_apply x1 x2 cd cs) cd cs) cd
  cs

nd_C_parse :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Maybe t0
nd_C_parse x1 x2 s cd cs = let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s3 = rightSupply s6
  in s5 `seq` (s3 `seq` nd_C__case_2 x2 x1 (let s2 = leftSupply s3
                                                s4 = rightSupply s3
                                                s0 = leftSupply s4
                                                s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_OP_dollar (wrapNX
  id (Curry_Prelude.nd_C_filter (Curry_Prelude.nd_OP_dot (wrapDX id
  Curry_Prelude.d_C_null) (wrapDX id Curry_Prelude.d_C_snd) s0 cd cs)))
  (Curry_Prelude.nd_C_apply x1 x2 s1 cd cs) s2 cd cs)))) s5 cd cs))

d_C_failure :: Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_failure cd cs = d_OP_failure_dot_uscore_hash_lambda2

nd_C_failure :: IDSupply -> Cover -> ConstStore
  -> forall t0 . (Curry_Prelude.Curry t0) => Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
nd_C_failure s cd cs = wrapDX id d_OP_failure_dot_uscore_hash_lambda2

d_OP_failure_dot_uscore_hash_lambda2 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_failure_dot_uscore_hash_lambda2 x1 cd cs = Curry_Prelude.OP_List

d_C_yield :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_yield x1 cd cs = d_OP_yield_dot_uscore_hash_lambda3 x1

d_OP_yield_dot_uscore_hash_lambda3 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_yield_dot_uscore_hash_lambda3 x1 x2 cd cs = Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 x1 x2) Curry_Prelude.OP_List

d_C_empty :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_empty cd cs = d_C_yield Curry_Prelude.OP_Unit cd cs

d_C_anyChar :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Char (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_anyChar cd cs = d_OP_anyChar_dot_uscore_hash_lambda4

d_OP_anyChar_dot_uscore_hash_lambda4 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Char (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_anyChar_dot_uscore_hash_lambda4 x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    x2 x3) Curry_Prelude.OP_List
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_anyChar_dot_uscore_hash_lambda4 l cd cs)
    (d_OP_anyChar_dot_uscore_hash_lambda4 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_anyChar_dot_uscore_hash_lambda4 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_anyChar_dot_uscore_hash_lambda4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "DetParse.anyChar._#lambda4" [show x1] info)
  _ -> failCons cd (consFail "DetParse.anyChar._#lambda4" (showCons x1))

d_C_check :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool) -> (Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_check x1 x2 cd cs = Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_filter
  (Curry_Prelude.d_OP_dot x1 Curry_Prelude.d_C_fst cd cs)) x2 cd cs

nd_C_check :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  Curry_Prelude.C_Bool -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
nd_C_check x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (wrapNX id
  (Curry_Prelude.nd_C_filter (Curry_Prelude.nd_OP_dot x1 (wrapDX id
  Curry_Prelude.d_C_fst) s0 cd cs))) x2 s1 cd cs))

d_C_char :: Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_char x1 cd cs = d_OP_star_gt (d_C_check
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1) (d_C_anyChar cd cs) cd cs) (d_C_yield Curry_Prelude.OP_Unit cd cs) cd cs

d_C_word :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_word x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> d_C_empty cd cs
  Curry_Prelude.OP_Cons x2 x3 -> d_OP_star_gt (d_C_char x2 cd cs) (d_C_word x3
    cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_word l cd cs)
    (d_C_word r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_word z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_word e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "DetParse.word"
    [show x1] info)
  _ -> failCons cd (consFail "DetParse.word" (showCons x1))

d_OP_lt_bar_gt :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_lt_bar_gt x1 x2 cd cs = d_OP_lt_bar_gt_dot_uscore_hash_lambda6 x1 x2

nd_OP_lt_bar_gt :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
nd_OP_lt_bar_gt x1 x2 s cd cs = wrapNX id
  (nd_OP_lt_bar_gt_dot_uscore_hash_lambda6 x1 x2)

d_OP_lt_bar_gt_dot_uscore_hash_lambda6 :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> (Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_lt_bar_gt_dot_uscore_hash_lambda6 x1 x2 x3 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply x1 x3 cd cs)
  (Curry_Prelude.d_C_apply x2 x3 cd cs) cd cs

nd_OP_lt_bar_gt_dot_uscore_hash_lambda6 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_OP_lt_bar_gt_dot_uscore_hash_lambda6 x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_apply
  x1 x3 s0 cd cs) (Curry_Prelude.nd_C_apply x2 x3 s1 cd cs) cd cs))

d_OP_lt_bang_gt :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> (Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_lt_bang_gt x1 x2 cd cs = d_OP_lt_bang_gt_dot_uscore_hash_lambda7 x1 x2

nd_OP_lt_bang_gt :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
nd_OP_lt_bang_gt x1 x2 s cd cs = wrapNX id
  (nd_OP_lt_bang_gt_dot_uscore_hash_lambda7 x1 x2)

d_OP_lt_bang_gt_dot_uscore_hash_lambda7 :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> (Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_lt_bang_gt_dot_uscore_hash_lambda7 x1 x2 x3 cd cs =
  let x4 = Curry_Prelude.d_C_apply x1 x3 cd cs in d_C__case_0 x3 x2 x4 cd cs

nd_OP_lt_bang_gt_dot_uscore_hash_lambda7 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_OP_lt_bang_gt_dot_uscore_hash_lambda7 x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` (let x4 = Curry_Prelude.nd_C_apply x1 x3 s0 cd cs
  in nd_C__case_0 x3 x2 x4 s1 cd cs)))

d_OP_lt_dollar_gt :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (t1 -> Cover -> ConstStore -> t0) -> (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_lt_dollar_gt x1 x2 cd cs = Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_map
  (d_OP_lt_dollar_gt_dot_uscore_hash_lambda9 x1)) x2 cd cs

nd_OP_lt_dollar_gt :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func t1 t0 -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))
nd_OP_lt_dollar_gt x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapNX id (Curry_Prelude.nd_C_map (wrapNX
  id (nd_OP_lt_dollar_gt_dot_uscore_hash_lambda9 x1)))) x2 s0 cd cs

d_OP_lt_dollar_gt_dot_uscore_hash_lambda9 :: forall t0 t1 . (Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => (t1 -> Cover -> ConstStore -> t0)
  -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_lt_dollar_gt_dot_uscore_hash_lambda9 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_C_apply x1 x3 cd cs) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_lt_dollar_gt_dot_uscore_hash_lambda9 x1 l cd cs)
    (d_OP_lt_dollar_gt_dot_uscore_hash_lambda9 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_lt_dollar_gt_dot_uscore_hash_lambda9 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_lt_dollar_gt_dot_uscore_hash_lambda9 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParse.<$>._#lambda9" [show x1, show x2] info)
  _ -> failCons cd (consFail "DetParse.<$>._#lambda9" (showCons x2))

nd_OP_lt_dollar_gt_dot_uscore_hash_lambda9 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func t1 t0
  -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_OP_lt_dollar_gt_dot_uscore_hash_lambda9 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_apply x1 x3 s0 cd
    cs) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_lt_dollar_gt_dot_uscore_hash_lambda9 x1 l s cd cs)
    (nd_OP_lt_dollar_gt_dot_uscore_hash_lambda9 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_lt_dollar_gt_dot_uscore_hash_lambda9 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_lt_dollar_gt_dot_uscore_hash_lambda9 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParse.<$>._#lambda9" [show x1, show x2] info)
  _ -> failCons cd (consFail "DetParse.<$>._#lambda9" (showCons x2))

d_OP_lt_star_gt :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (t1 -> Cover -> ConstStore
  -> t0) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_lt_star_gt x1 x2 cd cs = d_OP_lt_star_gt_dot_uscore_hash_lambda10 x2 x1

nd_OP_lt_star_gt :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Func t1 t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))
nd_OP_lt_star_gt x1 x2 s cd cs = wrapNX id
  (nd_OP_lt_star_gt_dot_uscore_hash_lambda10 x2 x1)

d_OP_lt_star_gt_dot_uscore_hash_lambda10 :: forall t0 t1 . (Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (t1 -> Cover -> ConstStore -> t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_lt_star_gt_dot_uscore_hash_lambda10 x1 x2 x3 cd cs =
  Curry_Prelude.d_C_foldr (acceptCs id
  (d_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13 x1))
  Curry_Prelude.OP_List (Curry_Prelude.d_C_apply x2 x3 cd cs) cd cs

nd_OP_lt_star_gt_dot_uscore_hash_lambda10 :: forall t0 t1 . (Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Func t1
  t0) (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
nd_OP_lt_star_gt_dot_uscore_hash_lambda10 x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs
  id (nd_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13 x1)))
  Curry_Prelude.OP_List (Curry_Prelude.nd_C_apply x2 x3 s0 cd cs) s1 cd cs))

d_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Curry_Prelude.OP_Tuple2 (t1 -> Cover -> ConstStore
  -> t0) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13 x1 x2 x3 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_foldr (acceptCs id
    (d_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x4)) Curry_Prelude.OP_List (Curry_Prelude.d_C_apply x1 x5 cd cs) cd cs) x3
    cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13 x1 l x3
    cd cs) (d_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13 x1
    r x3 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13 x1 z x3 cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13 x1 e x3 cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParse.<*>._#lambda10._#lambda13" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "DetParse.<*>._#lambda10._#lambda13" (showCons x2))

nd_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> Curry_Prelude.OP_Tuple2 (Func t1 t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13 x1 x2 x3 s cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s2 = s
    in s2 `seq` Curry_Prelude.d_OP_plus_plus (let s1 = leftSupply s2
                                                  s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs
    id
    (nd_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x4))) Curry_Prelude.OP_List (Curry_Prelude.nd_C_apply x1 x5 s0 cd cs) s1 cd
    cs)) x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13 x1 l x3
    s cd cs) (nd_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13
    x1 r x3 s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13 x1 z x3 s
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13 x1 e x3 s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParse.<*>._#lambda10._#lambda13" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "DetParse.<*>._#lambda10._#lambda13" (showCons x2))

d_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => (t1 -> Cover
  -> ConstStore -> t0) -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17 x1 x2 x3 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_apply x1 x4 cd cs) x5) x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x1 l x3 cd cs)
    (d_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x1 r x3 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x1 z x3 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x1 e x3 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParse.<*>._#lambda10._#lambda13._#lambda17" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "DetParse.<*>._#lambda10._#lambda13._#lambda17"
    (showCons x2))

nd_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func t1 t0
  -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
nd_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17 x1 x2 x3 s cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.nd_C_apply x1 x4 s0 cd cs) x5) x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x1 l x3 s cd cs)
    (nd_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x1 r x3 s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x1 z x3 s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_lt_star_gt_dot_uscore_hash_lambda10_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x1 e x3 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParse.<*>._#lambda10._#lambda13._#lambda17" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "DetParse.<*>._#lambda10._#lambda13._#lambda17"
    (showCons x2))

d_OP_lt_star :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> (Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_lt_star x1 x2 cd cs = d_OP_lt_star_gt (d_OP_lt_dollar_gt (acceptCs id
  d_OP_lt_star_dot_uscore_hash_lambda19) x1 cd cs) x2 cd cs

nd_OP_lt_star :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
nd_OP_lt_star x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_lt_star_gt (nd_OP_lt_dollar_gt (wrapDX (wrapDX id)
  (acceptCs id d_OP_lt_star_dot_uscore_hash_lambda19)) x1 s0 cd cs) x2 s1 cd
  cs))

d_OP_lt_star_dot_uscore_hash_lambda19 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t1 -> t0 -> Cover -> ConstStore -> t1
d_OP_lt_star_dot_uscore_hash_lambda19 x1 x2 cd cs = x1

d_OP_star_gt :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> (Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_star_gt x1 x2 cd cs = d_OP_lt_star_gt (d_OP_lt_dollar_gt (acceptCs id
  d_OP_star_gt_dot_uscore_hash_lambda20) x1 cd cs) x2 cd cs

nd_OP_star_gt :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
nd_OP_star_gt x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_lt_star_gt (nd_OP_lt_dollar_gt (wrapDX (wrapDX id)
  (acceptCs id d_OP_star_gt_dot_uscore_hash_lambda20)) x1 s0 cd cs) x2 s1 cd
  cs))

d_OP_star_gt_dot_uscore_hash_lambda20 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t1 -> t0 -> Cover -> ConstStore -> t0
d_OP_star_gt_dot_uscore_hash_lambda20 x1 x2 cd cs = x2

d_OP_star_gt_eq :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> (t1 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_star_gt_eq x1 x2 cd cs = d_OP_star_gt_eq_dot_uscore_hash_lambda21 x2 x1

nd_OP_star_gt_eq :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Func t1 (Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))) -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))
nd_OP_star_gt_eq x1 x2 s cd cs = wrapNX id
  (nd_OP_star_gt_eq_dot_uscore_hash_lambda21 x2 x1)

d_OP_star_gt_eq_dot_uscore_hash_lambda21 :: forall t0 t1 . (Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => (t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> (Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_star_gt_eq_dot_uscore_hash_lambda21 x1 x2 x3 cd cs =
  Curry_Prelude.d_C_foldr (acceptCs id
  (d_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24 x1))
  Curry_Prelude.OP_List (Curry_Prelude.d_C_apply x2 x3 cd cs) cd cs

nd_OP_star_gt_eq_dot_uscore_hash_lambda21 :: forall t0 t1 . (Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Func t1 (Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))) -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
nd_OP_star_gt_eq_dot_uscore_hash_lambda21 x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs
  id (nd_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24 x1)))
  Curry_Prelude.OP_List (Curry_Prelude.nd_C_apply x2 x3 s0 cd cs) s1 cd cs))

d_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => (t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24 x1 x2 x3 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_foldr (acceptCs id
    d_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24_dot_uscore_hash_lambda28)
    Curry_Prelude.OP_List (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x1
    x4 cd cs) x5 cd cs) cd cs) x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24 x1 l x3
    cd cs) (d_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24 x1
    r x3 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24 x1 z x3 cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24 x1 e x3 cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParse.*>=._#lambda21._#lambda24" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "DetParse.*>=._#lambda21._#lambda24" (showCons x2))

nd_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func t1 (Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
  -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
nd_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24 x1 x2 x3 s cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s4 = s
    in s4 `seq` Curry_Prelude.d_OP_plus_plus (let s3 = leftSupply s4
                                                  s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_foldr (wrapDX (wrapDX id) (acceptCs
    id
    d_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24_dot_uscore_hash_lambda28))
    Curry_Prelude.OP_List (let s1 = leftSupply s2
                               s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x4 s0 cd cs) x5 s1 cd cs)) s3 cd cs)) x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24 x1 l x3
    s cd cs) (nd_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24
    x1 r x3 s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24 x1 z x3 s
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24 x1 e x3 s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParse.*>=._#lambda21._#lambda24" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "DetParse.*>=._#lambda21._#lambda24" (showCons x2))

d_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24_dot_uscore_hash_lambda28 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24_dot_uscore_hash_lambda28 x1 x2 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 x3 x4) x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24_dot_uscore_hash_lambda28
    l x2 cd cs)
    (d_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24_dot_uscore_hash_lambda28
    r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24_dot_uscore_hash_lambda28
    z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_star_gt_eq_dot_uscore_hash_lambda21_dot_uscore_hash_lambda24_dot_uscore_hash_lambda28
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParse.*>=._#lambda21._#lambda24._#lambda28" [show x1, show x2] info)
  _ -> failCons cd (consFail "DetParse.*>=._#lambda21._#lambda24._#lambda28"
    (showCons x1))

d_C_many :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_many x1 cd cs = d_OP_lt_bar_gt (d_C_some x1 cd cs) (d_C_yield
  Curry_Prelude.OP_List cd cs) cd cs

nd_C_many :: forall t0 . (Curry_Prelude.Curry t0) => Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
nd_C_many x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_lt_bar_gt (nd_C_some x1 s0 cd cs) (wrapDX id
  (d_C_yield Curry_Prelude.OP_List cd cs)) s1 cd cs))

d_C_some :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_some x1 cd cs = d_OP_lt_star_gt (d_OP_lt_dollar_gt (acceptCs (acceptCs id)
  Curry_Prelude.OP_Cons) x1 cd cs) (d_C_many x1 cd cs) cd cs

nd_C_some :: forall t0 . (Curry_Prelude.Curry t0) => Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
nd_C_some x1 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` nd_OP_lt_star_gt (nd_OP_lt_dollar_gt
  (wrapDX (wrapDX id) (acceptCs (acceptCs id) Curry_Prelude.OP_Cons)) x1 s0 cd
  cs) (nd_C_many x1 s1 cd cs) s2 cd cs))))

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Cover -> ConstStore -> Curry_Prelude.C_Maybe t0
d_C__case_2 x2 x1 x5 cd cs = case x5 of
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_1 x3 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.C_Nothing
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_2 x2 x1 l cd cs)
    (d_C__case_2 x2 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_2 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_2 x2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "DetParse._case_2"
    [show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "DetParse._case_2" (showCons x5))

nd_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Maybe t0
nd_C__case_2 x2 x1 x5 s cd cs = case x5 of
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_1 x3 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.C_Nothing
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_2 x2 x1 l s cd
    cs) (nd_C__case_2 x2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_2 x2
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_2 x2 x1
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "DetParse._case_2"
    [show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "DetParse._case_2" (showCons x5))

d_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe t0
d_C__case_1 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> Curry_Prelude.C_Just x5
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_1 l cd cs)
    (d_C__case_1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_1 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParse._case_1" [show x3] info)
  _ -> failCons cd (consFail "DetParse._case_1" (showCons x3))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_0 x3 x2 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_apply x2 x3 cd cs
  Curry_Prelude.OP_Cons x5 x6 -> x4
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_0 x3 x2 l cd cs)
    (d_C__case_0 x3 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_0 x3
    x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_0 x3 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "DetParse._case_0"
    [show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "DetParse._case_0" (showCons x4))

nd_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_C__case_0 x3 x2 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x2 x3 s0 cd cs
  Curry_Prelude.OP_Cons x5 x6 -> x4
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_0 x3 x2 l s cd
    cs) (nd_C__case_0 x3 x2 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_0 x3
    x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_0 x3 x2
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "DetParse._case_0"
    [show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "DetParse._case_0" (showCons x4))

