{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_DetParser
  ( d_OP_lt_star
  , nd_OP_lt_star
  , d_OP_star_gt
  , nd_OP_star_gt
  , d_OP_lt_star_gt
  , nd_OP_lt_star_gt
  , d_OP_lt_bar_gt
  , nd_OP_lt_bar_gt
  , d_OP_lt_dollar_gt
  , nd_OP_lt_dollar_gt
  , d_C_liftP2
  , nd_C_liftP2
  , d_C_yield
  , d_C_terminal
  , nd_C_terminal
  , d_C_eof
  , d_C_unexpected
  , nd_C_unexpected
  , d_C_star
  , nd_C_star
  , d_C_some
  , nd_C_some )
  where

import Basics
import qualified Curry_Prelude


d_OP_lt_star :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List t2 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t1))
  -> (Curry_Prelude.OP_List t2 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t2) t0)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t2 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t2) t1)
d_OP_lt_star x1 x2 cd cs = d_OP_lt_star_gt (d_OP_lt_dollar_gt (acceptCs id
  Curry_Prelude.d_C_const) x1 cd cs) x2 cd cs

nd_OP_lt_star :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Func (Curry_Prelude.OP_List t2)
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t1)) -> Func
  (Curry_Prelude.OP_List t2) (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t0))
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List t2)
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t1))
nd_OP_lt_star x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_lt_star_gt (nd_OP_lt_dollar_gt (wrapDX (wrapDX id)
  (acceptCs id Curry_Prelude.d_C_const)) x1 s0 cd cs) x2 s1 cd cs))

d_OP_star_gt :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List t2 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t1))
  -> (Curry_Prelude.OP_List t2 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t2) t0)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t2 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t2) t0)
d_OP_star_gt x1 x2 cd cs = d_OP_lt_star_gt (d_OP_lt_dollar_gt
  (Curry_Prelude.d_C_const Curry_Prelude.d_C_id) x1 cd cs) x2 cd cs

nd_OP_star_gt :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Func (Curry_Prelude.OP_List t2)
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t1)) -> Func
  (Curry_Prelude.OP_List t2) (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t0))
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List t2)
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t0))
nd_OP_star_gt x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_lt_star_gt (nd_OP_lt_dollar_gt (wrapDX id
  (Curry_Prelude.d_C_const (wrapDX id Curry_Prelude.d_C_id))) x1 s0 cd cs) x2 s1
  cd cs))

d_OP_lt_star_gt :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List t2
  -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) (t1
  -> Cover -> ConstStore -> t0))) -> (Curry_Prelude.OP_List t2 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t1))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t2 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t0)
d_OP_lt_star_gt x1 x2 cd cs = d_OP_lt_star_gt_dot_uscore_hash_lambda1 x2 x1

nd_OP_lt_star_gt :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_List t2) (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2)
  (Func t1 t0))) -> Func (Curry_Prelude.OP_List t2) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t2) t1)) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List t2) (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t0))
nd_OP_lt_star_gt x1 x2 s cd cs = wrapNX id
  (nd_OP_lt_star_gt_dot_uscore_hash_lambda1 x2 x1)

d_OP_lt_star_gt_dot_uscore_hash_lambda1 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_List t2 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t1))
  -> (Curry_Prelude.OP_List t2 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t2) (t1 -> Cover -> ConstStore -> t0)))
  -> Curry_Prelude.OP_List t2 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t2) t0)
d_OP_lt_star_gt_dot_uscore_hash_lambda1 x1 x2 x3 cd cs = d_C__case_16 x3 x2 x1
  (Curry_Prelude.d_C_apply x2 x3 cd cs) cd cs

nd_OP_lt_star_gt_dot_uscore_hash_lambda1 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func (Curry_Prelude.OP_List t2) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t2) t1)) -> Func (Curry_Prelude.OP_List t2)
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) (Func t1 t0)))
  -> Curry_Prelude.OP_List t2 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t0)
nd_OP_lt_star_gt_dot_uscore_hash_lambda1 x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_16 x3 x2 x1 (Curry_Prelude.nd_C_apply x2 x3
  s0 cd cs) s1 cd cs))

d_OP_lt_bar_gt :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_List t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0))
  -> (Curry_Prelude.OP_List t1 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) t0)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t1 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) t0)
d_OP_lt_bar_gt x1 x2 cd cs = d_OP_lt_bar_gt_dot_uscore_hash_lambda4 x1 x2

nd_OP_lt_bar_gt :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func (Curry_Prelude.OP_List t1) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) t0)) -> Func (Curry_Prelude.OP_List t1)
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0)) -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List t1) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) t0))
nd_OP_lt_bar_gt x1 x2 s cd cs = wrapNX id
  (nd_OP_lt_bar_gt_dot_uscore_hash_lambda4 x1 x2)

d_OP_lt_bar_gt_dot_uscore_hash_lambda4 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0))
  -> (Curry_Prelude.OP_List t1 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) t0)) -> Curry_Prelude.OP_List t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0)
d_OP_lt_bar_gt_dot_uscore_hash_lambda4 x1 x2 x3 cd cs = d_C__case_12 x3 x1 x2
  (Curry_Prelude.d_C_apply x1 x3 cd cs) cd cs

nd_OP_lt_bar_gt_dot_uscore_hash_lambda4 :: forall t0 t1 . (Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Func (Curry_Prelude.OP_List t1)
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0)) -> Func
  (Curry_Prelude.OP_List t1) (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0))
  -> Curry_Prelude.OP_List t1 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0)
nd_OP_lt_bar_gt_dot_uscore_hash_lambda4 x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_12 x3 x1 x2 (Curry_Prelude.nd_C_apply x1 x3
  s0 cd cs) s1 cd cs))

d_OP_lt_dollar_gt :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => (t2 -> Cover
  -> ConstStore -> t1) -> (Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t2)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t1)
d_OP_lt_dollar_gt x1 x2 cd cs = d_OP_lt_star_gt (d_C_yield x1) x2 cd cs

nd_OP_lt_dollar_gt :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func t2 t1 -> Func
  (Curry_Prelude.OP_List t0) (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t2))
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List t0)
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t1))
nd_OP_lt_dollar_gt x1 x2 s cd cs = let s0 = s
  in s0 `seq` nd_OP_lt_star_gt (wrapDX id (d_C_yield x1)) x2 s0 cd cs

d_C_liftP2 :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry t3) => (t2 -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> (Curry_Prelude.OP_List t3
  -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t2))
  -> (Curry_Prelude.OP_List t3 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t3) t1)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t3 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t3) t0)
d_C_liftP2 x1 x2 x3 cd cs = d_OP_liftP2_dot_uscore_hash_lambda7 x1 x3 x2

nd_C_liftP2 :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry t3) => Func t2 (Func t1 t0)
  -> Func (Curry_Prelude.OP_List t3) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t3) t2)) -> Func (Curry_Prelude.OP_List t3)
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t1)) -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List t3) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t3) t0))
nd_C_liftP2 x1 x2 x3 s cd cs = wrapNX id (nd_OP_liftP2_dot_uscore_hash_lambda7
  x1 x3 x2)

d_OP_liftP2_dot_uscore_hash_lambda7 :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t3) => (t2 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_List t3 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t3) t1)) -> (Curry_Prelude.OP_List t3 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t2))
  -> Curry_Prelude.OP_List t3 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t3) t0)
d_OP_liftP2_dot_uscore_hash_lambda7 x1 x2 x3 x4 cd cs = d_C__case_8 x4 x3 x2 x1
  (Curry_Prelude.d_C_apply x3 x4 cd cs) cd cs

nd_OP_liftP2_dot_uscore_hash_lambda7 :: forall t0 t1 t2
  t3 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t3) => Func t2 (Func t1 t0) -> Func
  (Curry_Prelude.OP_List t3) (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t1))
  -> Func (Curry_Prelude.OP_List t3) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t3) t2)) -> Curry_Prelude.OP_List t3 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t0)
nd_OP_liftP2_dot_uscore_hash_lambda7 x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_8 x4 x3 x2 x1 (Curry_Prelude.nd_C_apply x3 x4
  s0 cd cs) s1 cd cs))

d_C_yield :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => t0 -> Curry_Prelude.OP_List t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0)
d_C_yield x1 x2 cd cs = Curry_Prelude.C_Right (Curry_Prelude.OP_Tuple2 x2 x1)

d_C_terminal :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> t0 -> Curry_Prelude.OP_List
  t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  Curry_Prelude.OP_Unit)
d_C_terminal x1 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> d_C_eof Curry_Prelude.OP_List cd cs
  Curry_Prelude.OP_Cons x5 x6 -> d_C__case_4 x5 x3 x1 x6 x2
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq
    x1 cd cs) x3 cd cs) x5 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_terminal x1 x2 x3 l cd
    cs) (d_C_terminal x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_terminal x1
    x2 x3 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_terminal x1 x2
    x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "DetParser.terminal" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "DetParser.terminal" (showCons x4))

nd_C_terminal :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) Curry_Prelude.OP_Unit)
nd_C_terminal x1 x2 x3 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> d_C_eof Curry_Prelude.OP_List cd cs
  Curry_Prelude.OP_Cons x5 x6 -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_4 x5 x3 x1 x6 x2 (let s3 = leftSupply s4
                                                           s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq x1
    s0 cd cs) x3 s1 cd cs)) x5 s3 cd cs)) s5 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_terminal x1 x2 x3 l s
    cd cs) (nd_C_terminal x1 x2 x3 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_terminal x1
    x2 x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_terminal x1 x2
    x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "DetParser.terminal" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "DetParser.terminal" (showCons x4))

d_C_eof :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0)
d_C_eof x1 cd cs = Curry_Prelude.C_Left (Curry_Prelude.toCurryString
  "unexpected end-of-file")

d_C_unexpected :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> t0 -> Curry_Prelude.OP_List
  t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t1)
d_C_unexpected x1 x2 x3 cd cs = Curry_Prelude.d_OP_dollar (acceptCs id
  Curry_Prelude.C_Left) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "unexpected token ") (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_show x1 cd cs) x2 cd cs) cd cs) cd cs

nd_C_unexpected :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> t0 -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t1)
nd_C_unexpected x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id (acceptCs id
  Curry_Prelude.C_Left)) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "unexpected token ") (let s1 = leftSupply s2
                                                         s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x1 s0
  cd cs) x2 s1 cd cs)) cd cs) s3 cd cs))

d_C_star :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_List t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List
  t0))
d_C_star x1 cd cs = d_OP_lt_bar_gt (d_OP_star_dot_uscore_hash_lambda11 x1)
  (d_C_yield Curry_Prelude.OP_List) cd cs

nd_C_star :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func (Curry_Prelude.OP_List t1) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) t0)) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List t1) (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1)
  (Curry_Prelude.OP_List t0)))
nd_C_star x1 s cd cs = let s0 = s
  in s0 `seq` nd_OP_lt_bar_gt (wrapNX id (nd_OP_star_dot_uscore_hash_lambda11
  x1)) (wrapDX id (d_C_yield Curry_Prelude.OP_List)) s0 cd cs

d_OP_star_dot_uscore_hash_lambda11 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0))
  -> Curry_Prelude.OP_List t1 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List t0))
d_OP_star_dot_uscore_hash_lambda11 x1 x2 cd cs = d_C__case_3 x2 x1
  (Curry_Prelude.d_C_apply x1 x2 cd cs) cd cs

nd_OP_star_dot_uscore_hash_lambda11 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func (Curry_Prelude.OP_List t1)
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0))
  -> Curry_Prelude.OP_List t1 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List
  t0))
nd_OP_star_dot_uscore_hash_lambda11 x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_3 x2 x1 (Curry_Prelude.nd_C_apply x1 x2 s0 cd
  cs) s1 cd cs))

d_C_some :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t1)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t1))
d_C_some x1 cd cs = d_OP_some_dot_uscore_hash_lambda13 x1

nd_C_some :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Func (Curry_Prelude.OP_List t0) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) t1)) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List t0) (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t1)))
nd_C_some x1 s cd cs = wrapNX id (nd_OP_some_dot_uscore_hash_lambda13 x1)

d_OP_some_dot_uscore_hash_lambda13 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => (Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t1))
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t1))
d_OP_some_dot_uscore_hash_lambda13 x1 x2 cd cs = d_C__case_1 x2 x1
  (Curry_Prelude.d_C_apply x1 x2 cd cs) cd cs

nd_OP_some_dot_uscore_hash_lambda13 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Func (Curry_Prelude.OP_List t0)
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t1))
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t1))
nd_OP_some_dot_uscore_hash_lambda13 x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_1 x2 x1 (Curry_Prelude.nd_C_apply x1 x2 s0 cd
  cs) s1 cd cs))

d_C__case_16 :: forall t2 t1 t0 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t2
  -> (Curry_Prelude.OP_List t2 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t2) (t1 -> Cover -> ConstStore -> t0)))
  -> (Curry_Prelude.OP_List t2 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t2) t1)) -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t2) (t1 -> Cover -> ConstStore -> t0)) -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t0)
d_C__case_16 x3 x2 x1 x6 cd cs = case x6 of
  Curry_Prelude.C_Left x4 -> Curry_Prelude.C_Left x4
  Curry_Prelude.C_Right x5 -> d_C__case_15 x1 x5 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C__case_16 x3 x2 x1 l
    cd cs) (d_C__case_16 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C__case_16 x3
    x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c ((\x -> d_C__case_16 x3 x2
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "DetParser._case_16" [show x3, show x2, show x1, show x6] info)
  _ -> failCons cd (consFail "DetParser._case_16" (showCons x6))

nd_C__case_16 :: forall t2 t1 t0 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t2 -> Func
  (Curry_Prelude.OP_List t2) (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2)
  (Func t1 t0))) -> Func (Curry_Prelude.OP_List t2) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t2) t1)) -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t2) (Func t1 t0)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t0)
nd_C__case_16 x3 x2 x1 x6 s cd cs = case x6 of
  Curry_Prelude.C_Left x4 -> Curry_Prelude.C_Left x4
  Curry_Prelude.C_Right x5 -> let s0 = s
    in s0 `seq` nd_C__case_15 x1 x5 s0 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (nd_C__case_16 x3 x2 x1 l
    s cd cs) (nd_C__case_16 x3 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> nd_C__case_16
    x3 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c ((\x -> nd_C__case_16 x3
    x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "DetParser._case_16" [show x3, show x2, show x1, show x6] info)
  _ -> failCons cd (consFail "DetParser._case_16" (showCons x6))

d_C__case_15 :: forall t2 t1 t0 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List t2 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t1))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) (t1 -> Cover
  -> ConstStore -> t0) -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t2) t0)
d_C__case_15 x1 x5 cd cs = case x5 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> d_C__case_14 x6 x1 x7
    (Curry_Prelude.d_C_apply x1 x6 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_15 x1 l cd cs)
    (d_C__case_15 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_15
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_15 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParser._case_15" [show x1, show x5] info)
  _ -> failCons cd (consFail "DetParser._case_15" (showCons x5))

nd_C__case_15 :: forall t2 t1 t0 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Func (Curry_Prelude.OP_List t2)
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t1))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) (Func t1 t0) -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t0)
nd_C__case_15 x1 x5 s cd cs = case x5 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_14 x6 x1 x7 (Curry_Prelude.nd_C_apply x1 x6
    s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_15 x1 l s cd
    cs) (nd_C__case_15 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_15
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_15 x1
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParser._case_15" [show x1, show x5] info)
  _ -> failCons cd (consFail "DetParser._case_15" (showCons x5))

d_C__case_14 :: forall t2 t1 t0 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t2
  -> (Curry_Prelude.OP_List t2 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t2) t1)) -> (t1 -> Cover -> ConstStore -> t0)
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t1) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t0)
d_C__case_14 x6 x1 x7 x10 cd cs = case x10 of
  Curry_Prelude.C_Left x8 -> Curry_Prelude.C_Left x8
  Curry_Prelude.C_Right x9 -> d_C__case_13 x7 x9 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C__case_14 x6 x1 x7 l
    cd cs) (d_C__case_14 x6 x1 x7 r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C__case_14 x6
    x1 x7 z cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c ((\x -> d_C__case_14 x6 x1
    x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "DetParser._case_14" [show x6, show x1, show x7, show x10] info)
  _ -> failCons cd (consFail "DetParser._case_14" (showCons x10))

nd_C__case_14 :: forall t2 t1 t0 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t2 -> Func
  (Curry_Prelude.OP_List t2) (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t1))
  -> Func t1 t0 -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t1)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t2) t0)
nd_C__case_14 x6 x1 x7 x10 s cd cs = case x10 of
  Curry_Prelude.C_Left x8 -> Curry_Prelude.C_Left x8
  Curry_Prelude.C_Right x9 -> let s0 = s
    in s0 `seq` nd_C__case_13 x7 x9 s0 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (nd_C__case_14 x6 x1 x7 l
    s cd cs) (nd_C__case_14 x6 x1 x7 r s cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> nd_C__case_14
    x6 x1 x7 z s cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c ((\x -> nd_C__case_14 x6
    x1 x7 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "DetParser._case_14" [show x6, show x1, show x7, show x10] info)
  _ -> failCons cd (consFail "DetParser._case_14" (showCons x10))

d_C__case_13 :: forall t1 t0 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t2) => (t1 -> Cover -> ConstStore -> t0)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t0)
d_C__case_13 x7 x9 cd cs = case x9 of
  Curry_Prelude.OP_Tuple2 x10 x11 -> Curry_Prelude.C_Right
    (Curry_Prelude.OP_Tuple2 x10 (Curry_Prelude.d_C_apply x7 x11 cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_13 x7 l cd cs)
    (d_C__case_13 x7 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_13
    x7 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_13 x7 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParser._case_13" [show x7, show x9] info)
  _ -> failCons cd (consFail "DetParser._case_13" (showCons x9))

nd_C__case_13 :: forall t1 t0 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t2) => Func t1 t0 -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t2) t1 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t2) t0)
nd_C__case_13 x7 x9 s cd cs = case x9 of
  Curry_Prelude.OP_Tuple2 x10 x11 -> let s0 = s
    in s0 `seq` Curry_Prelude.C_Right (Curry_Prelude.OP_Tuple2 x10
    (Curry_Prelude.nd_C_apply x7 x11 s0 cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_13 x7 l s cd
    cs) (nd_C__case_13 x7 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_13
    x7 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_13 x7
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParser._case_13" [show x7, show x9] info)
  _ -> failCons cd (consFail "DetParser._case_13" (showCons x9))

d_C__case_12 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t1 -> (Curry_Prelude.OP_List t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0))
  -> (Curry_Prelude.OP_List t1 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) t0)) -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) t0) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0)
d_C__case_12 x3 x1 x2 x8 cd cs = case x8 of
  Curry_Prelude.C_Right x4 -> d_C__case_11 x4 cd cs
  Curry_Prelude.C_Left x7 -> d_C__case_10 x3 x2 x7 (Curry_Prelude.d_C_apply x2
    x3 cd cs) cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C__case_12 x3 x1 x2 l
    cd cs) (d_C__case_12 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C__case_12 x3
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c ((\x -> d_C__case_12 x3 x1
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "DetParser._case_12" [show x3, show x1, show x2, show x8] info)
  _ -> failCons cd (consFail "DetParser._case_12" (showCons x8))

nd_C__case_12 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t1 -> Func (Curry_Prelude.OP_List t1)
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0)) -> Func
  (Curry_Prelude.OP_List t1) (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0))
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0)
nd_C__case_12 x3 x1 x2 x8 s cd cs = case x8 of
  Curry_Prelude.C_Right x4 -> d_C__case_11 x4 cd cs
  Curry_Prelude.C_Left x7 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_10 x3 x2 x7 (Curry_Prelude.nd_C_apply x2 x3
    s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (nd_C__case_12 x3 x1 x2 l
    s cd cs) (nd_C__case_12 x3 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> nd_C__case_12
    x3 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c ((\x -> nd_C__case_12 x3
    x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "DetParser._case_12" [show x3, show x1, show x2, show x8] info)
  _ -> failCons cd (consFail "DetParser._case_12" (showCons x8))

d_C__case_10 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t1 -> (Curry_Prelude.OP_List t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) t0) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0)
d_C__case_10 x3 x2 x7 x10 cd cs = case x10 of
  Curry_Prelude.C_Left x8 -> Curry_Prelude.d_OP_dollar (acceptCs id
    Curry_Prelude.C_Left) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "parse error: ") (Curry_Prelude.d_OP_plus_plus
    x8 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " | ") x7 cd
    cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_Right x9 -> d_C__case_9 x9 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C__case_10 x3 x2 x7 l
    cd cs) (d_C__case_10 x3 x2 x7 r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C__case_10 x3
    x2 x7 z cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c ((\x -> d_C__case_10 x3 x2
    x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "DetParser._case_10" [show x3, show x2, show x7, show x10] info)
  _ -> failCons cd (consFail "DetParser._case_10" (showCons x10))

nd_C__case_10 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t1 -> Func (Curry_Prelude.OP_List t1)
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) t0) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0)
nd_C__case_10 x3 x2 x7 x10 s cd cs = case x10 of
  Curry_Prelude.C_Left x8 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id (acceptCs id
    Curry_Prelude.C_Left)) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "parse error: ") (Curry_Prelude.d_OP_plus_plus
    x8 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " | ") x7 cd
    cs) cd cs) cd cs) s0 cd cs
  Curry_Prelude.C_Right x9 -> d_C__case_9 x9 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (nd_C__case_10 x3 x2 x7 l
    s cd cs) (nd_C__case_10 x3 x2 x7 r s cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> nd_C__case_10
    x3 x2 x7 z s cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c ((\x -> nd_C__case_10 x3
    x2 x7 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "DetParser._case_10" [show x3, show x2, show x7, show x10] info)
  _ -> failCons cd (consFail "DetParser._case_10" (showCons x10))

d_C__case_9 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0)
d_C__case_9 x9 cd cs = case x9 of
  Curry_Prelude.OP_Tuple2 x10 x11 -> Curry_Prelude.C_Right
    (Curry_Prelude.OP_Tuple2 x10 x11)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_9 l cd cs)
    (d_C__case_9 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_9 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_9 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParser._case_9" [show x9] info)
  _ -> failCons cd (consFail "DetParser._case_9" (showCons x9))

d_C__case_11 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0)
d_C__case_11 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> Curry_Prelude.C_Right
    (Curry_Prelude.OP_Tuple2 x5 x6)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_11 l cd cs)
    (d_C__case_11 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_11 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_11 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParser._case_11" [show x4] info)
  _ -> failCons cd (consFail "DetParser._case_11" (showCons x4))

d_C__case_8 :: forall t3 t2 t1 t0 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t3 -> (Curry_Prelude.OP_List t3 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t2))
  -> (Curry_Prelude.OP_List t3 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t3) t1)) -> (t2 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> t0) -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t2)
  -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t0)
d_C__case_8 x4 x3 x2 x1 x7 cd cs = case x7 of
  Curry_Prelude.C_Left x5 -> Curry_Prelude.C_Left x5
  Curry_Prelude.C_Right x6 -> d_C__case_7 x2 x1 x6 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C__case_8 x4 x3 x2 x1 l
    cd cs) (d_C__case_8 x4 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C__case_8 x4
    x3 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c ((\x -> d_C__case_8 x4 x3
    x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "DetParser._case_8" [show x4, show x3, show x2, show x1, show x7] info)
  _ -> failCons cd (consFail "DetParser._case_8" (showCons x7))

nd_C__case_8 :: forall t3 t2 t1 t0 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t3 -> Func (Curry_Prelude.OP_List t3)
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t2)) -> Func
  (Curry_Prelude.OP_List t3) (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t1))
  -> Func t2 (Func t1 t0) -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t2)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t3) t0)
nd_C__case_8 x4 x3 x2 x1 x7 s cd cs = case x7 of
  Curry_Prelude.C_Left x5 -> Curry_Prelude.C_Left x5
  Curry_Prelude.C_Right x6 -> let s0 = s
    in s0 `seq` nd_C__case_7 x2 x1 x6 s0 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (nd_C__case_8 x4 x3 x2 x1
    l s cd cs) (nd_C__case_8 x4 x3 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> nd_C__case_8 x4
    x3 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c ((\x -> nd_C__case_8 x4 x3
    x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "DetParser._case_8" [show x4, show x3, show x2, show x1, show x7] info)
  _ -> failCons cd (consFail "DetParser._case_8" (showCons x7))

d_C__case_7 :: forall t3 t1 t2 t0 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List
  t3 -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t1))
  -> (t2 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t2 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t0)
d_C__case_7 x2 x1 x6 cd cs = case x6 of
  Curry_Prelude.OP_Tuple2 x7 x8 -> d_C__case_6 x7 x2 x8 x1
    (Curry_Prelude.d_C_apply x2 x7 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_7 x2 x1 l cd
    cs) (d_C__case_7 x2 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_7 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_7 x2 x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParser._case_7" [show x2, show x1, show x6] info)
  _ -> failCons cd (consFail "DetParser._case_7" (showCons x6))

nd_C__case_7 :: forall t3 t1 t2 t0 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0) => Func (Curry_Prelude.OP_List t3) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t3) t1)) -> Func t2 (Func t1 t0)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t2 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t0)
nd_C__case_7 x2 x1 x6 s cd cs = case x6 of
  Curry_Prelude.OP_Tuple2 x7 x8 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_6 x7 x2 x8 x1 (Curry_Prelude.nd_C_apply x2
    x7 s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_7 x2 x1 l s
    cd cs) (nd_C__case_7 x2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_7
    x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_7 x2
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParser._case_7" [show x2, show x1, show x6] info)
  _ -> failCons cd (consFail "DetParser._case_7" (showCons x6))

d_C__case_6 :: forall t3 t1 t2 t0 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t3 -> (Curry_Prelude.OP_List t3 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t1)) -> t2 -> (t2 -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t3) t1) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t0)
d_C__case_6 x7 x2 x8 x1 x11 cd cs = case x11 of
  Curry_Prelude.C_Left x9 -> Curry_Prelude.C_Left x9
  Curry_Prelude.C_Right x10 -> d_C__case_5 x8 x1 x10 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C__case_6 x7 x2 x8 x1 l
    cd cs) (d_C__case_6 x7 x2 x8 x1 r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C__case_6 x7
    x2 x8 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c ((\x -> d_C__case_6 x7 x2
    x8 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "DetParser._case_6" [show x7, show x2, show x8, show x1, show x11] info)
  _ -> failCons cd (consFail "DetParser._case_6" (showCons x11))

nd_C__case_6 :: forall t3 t1 t2 t0 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t3 -> Func (Curry_Prelude.OP_List t3)
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t1)) -> t2 -> Func t2
  (Func t1 t0) -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t1)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t3) t0)
nd_C__case_6 x7 x2 x8 x1 x11 s cd cs = case x11 of
  Curry_Prelude.C_Left x9 -> Curry_Prelude.C_Left x9
  Curry_Prelude.C_Right x10 -> let s0 = s
    in s0 `seq` nd_C__case_5 x8 x1 x10 s0 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (nd_C__case_6 x7 x2 x8 x1
    l s cd cs) (nd_C__case_6 x7 x2 x8 x1 r s cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> nd_C__case_6 x7
    x2 x8 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c ((\x -> nd_C__case_6 x7 x2
    x8 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "DetParser._case_6" [show x7, show x2, show x8, show x1, show x11] info)
  _ -> failCons cd (consFail "DetParser._case_6" (showCons x11))

d_C__case_5 :: forall t2 t1 t0 t3 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry t3) => t2 -> (t2 -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t3) t1 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t3) t0)
d_C__case_5 x8 x1 x10 cd cs = case x10 of
  Curry_Prelude.OP_Tuple2 x11 x12 -> Curry_Prelude.C_Right
    (Curry_Prelude.OP_Tuple2 x11 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x1 x8 cd cs) x12 cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_5 x8 x1 l cd
    cs) (d_C__case_5 x8 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_5 x8
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_5 x8 x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParser._case_5" [show x8, show x1, show x10] info)
  _ -> failCons cd (consFail "DetParser._case_5" (showCons x10))

nd_C__case_5 :: forall t2 t1 t0 t3 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t3) => t2 -> Func t2 (Func t1 t0) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t3) t1 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t3) t0)
nd_C__case_5 x8 x1 x10 s cd cs = case x10 of
  Curry_Prelude.OP_Tuple2 x11 x12 -> let s2 = s
    in s2 `seq` Curry_Prelude.C_Right (Curry_Prelude.OP_Tuple2 x11
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x8 s0 cd cs) x12 s1 cd cs)))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_5 x8 x1 l s
    cd cs) (nd_C__case_5 x8 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_5
    x8 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_5 x8
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParser._case_5" [show x8, show x1, show x10] info)
  _ -> failCons cd (consFail "DetParser._case_5" (showCons x10))

d_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Curry_Prelude.OP_List t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  Curry_Prelude.OP_Unit)
d_C__case_4 x5 x3 x1 x6 x2 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.C_Right (Curry_Prelude.OP_Tuple2 x6
    Curry_Prelude.OP_Unit)
  Curry_Prelude.C_False -> d_C_unexpected x2 x5 x6 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x5 x3 x1 x6 x2
    l cd cs) (d_C__case_4 x5 x3 x1 x6 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x5 x3
    x1 x6 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x5 x3 x1
    x6 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "DetParser._case_4"
    [show x5, show x3, show x1, show x6, show x2, show x7] info)
  _ -> failCons cd (consFail "DetParser._case_4" (showCons x7))

nd_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Curry_Prelude.OP_List t0 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) Curry_Prelude.OP_Unit)
nd_C__case_4 x5 x3 x1 x6 x2 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.C_Right (Curry_Prelude.OP_Tuple2 x6
    Curry_Prelude.OP_Unit)
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C_unexpected x2 x5 x6 s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_4 x5 x3 x1 x6 x2
    l s cd cs) (nd_C__case_4 x5 x3 x1 x6 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_4 x5
    x3 x1 x6 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_4 x5 x3
    x1 x6 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "DetParser._case_4"
    [show x5, show x3, show x1, show x6, show x2, show x7] info)
  _ -> failCons cd (consFail "DetParser._case_4" (showCons x7))

d_C__case_3 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t1 -> (Curry_Prelude.OP_List t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0))
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List
  t0))
d_C__case_3 x2 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_Left x3 -> Curry_Prelude.C_Left x3
  Curry_Prelude.C_Right x4 -> d_C__case_2 x1 x4 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C__case_3 x2 x1 l cd
    cs) (d_C__case_3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C__case_3 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c ((\x -> d_C__case_3 x2 x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "DetParser._case_3" [show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "DetParser._case_3" (showCons x5))

nd_C__case_3 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t1 -> Func (Curry_Prelude.OP_List t1)
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0))
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1)
  (Curry_Prelude.OP_List t0))
nd_C__case_3 x2 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_Left x3 -> Curry_Prelude.C_Left x3
  Curry_Prelude.C_Right x4 -> let s0 = s in s0 `seq` nd_C__case_2 x1 x4 s0 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (nd_C__case_3 x2 x1 l s cd
    cs) (nd_C__case_3 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> nd_C__case_3 x2
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c ((\x -> nd_C__case_3 x2 x1
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "DetParser._case_3" [show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "DetParser._case_3" (showCons x5))

d_C__case_2 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_List t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1)
  (Curry_Prelude.OP_List t0))
d_C__case_2 x1 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> Curry_Prelude.d_OP_dollar (d_OP_lt_dollar_gt
    (acceptCs id (Curry_Prelude.OP_Cons x6)) (d_C_star x1 cd cs) cd cs) x5 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_2 x1 l cd cs)
    (d_C__case_2 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_2 x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParser._case_2" [show x1, show x4] info)
  _ -> failCons cd (consFail "DetParser._case_2" (showCons x4))

nd_C__case_2 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func (Curry_Prelude.OP_List t1) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) t0)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List
  t0))
nd_C__case_2 x1 x4 s cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dollar (let s1 = leftSupply s2
                                                          s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_OP_lt_dollar_gt (wrapDX id (acceptCs id
    (Curry_Prelude.OP_Cons x6))) (nd_C_star x1 s0 cd cs) s1 cd cs)) x5 s3 cd
    cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_2 x1 l s cd
    cs) (nd_C__case_2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_2
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_2 x1 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParser._case_2" [show x1, show x4] info)
  _ -> failCons cd (consFail "DetParser._case_2" (showCons x4))

d_C__case_1 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_List t0 -> (Curry_Prelude.OP_List t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t1))
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t1) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t1))
d_C__case_1 x2 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_Left x3 -> Curry_Prelude.C_Left x3
  Curry_Prelude.C_Right x4 -> d_C__case_0 x1 x4 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C__case_1 x2 x1 l cd
    cs) (d_C__case_1 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C__case_1 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c ((\x -> d_C__case_1 x2 x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "DetParser._case_1" [show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "DetParser._case_1" (showCons x5))

nd_C__case_1 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_List t0 -> Func (Curry_Prelude.OP_List t0)
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t1))
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t1) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t1))
nd_C__case_1 x2 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_Left x3 -> Curry_Prelude.C_Left x3
  Curry_Prelude.C_Right x4 -> let s0 = s in s0 `seq` nd_C__case_0 x1 x4 s0 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (nd_C__case_1 x2 x1 l s cd
    cs) (nd_C__case_1 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> nd_C__case_1 x2
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c ((\x -> nd_C__case_1 x2 x1
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "DetParser._case_1" [show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "DetParser._case_1" (showCons x5))

d_C__case_0 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t1))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t1))
d_C__case_0 x1 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> Curry_Prelude.d_OP_dollar (d_OP_lt_dollar_gt
    (acceptCs id (Curry_Prelude.OP_Cons x6)) (d_C_star x1 cd cs) cd cs) x5 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_0 x1 l cd cs)
    (d_C__case_0 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_0 x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_0 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParser._case_0" [show x1, show x4] info)
  _ -> failCons cd (consFail "DetParser._case_0" (showCons x4))

nd_C__case_0 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Func (Curry_Prelude.OP_List t0) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) t1)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) t1 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t1))
nd_C__case_0 x1 x4 s cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dollar (let s1 = leftSupply s2
                                                          s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_OP_lt_dollar_gt (wrapDX id (acceptCs id
    (Curry_Prelude.OP_Cons x6))) (nd_C_star x1 s0 cd cs) s1 cd cs)) x5 s3 cd
    cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_0 x1 l s cd
    cs) (nd_C__case_0 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_0
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_0 x1 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DetParser._case_0" [show x1, show x4] info)
  _ -> failCons cd (consFail "DetParser._case_0" (showCons x4))

