{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Dimacs.Curry_Pretty
  ( d_C_showDimacs, d_C_prettyDimacs, d_C_prettySolution )
  where

import Basics
import qualified Dimacs.Curry_Build
import qualified Dimacs.Curry_Types
import qualified Curry_Prelude
import qualified Text.Curry_Pretty
import qualified Text.Curry_PrettyImpl


d_C_showDimacs :: Dimacs.Curry_Types.C_Boolean -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showDimacs x1 cd cs = Curry_Prelude.d_C_apply (d_C_prettyDimacs
  (Dimacs.Curry_Types.d_C_maxVar x1 cd cs) cd cs) x1 cd cs

d_C_prettyDimacs :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Dimacs.Curry_Types.C_Boolean -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_prettyDimacs x1 cd cs = Curry_Prelude.d_OP_dot (Text.Curry_Pretty.d_C_pPrint
  cd cs) (Curry_Prelude.d_OP_dot (d_C_ppDimacs x1) (Dimacs.Curry_Build.d_C_toCNF
  cd cs) cd cs) cd cs

d_C_prettySolution :: Cover -> ConstStore -> Dimacs.Curry_Types.C_Boolean
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_prettySolution cd cs = Curry_Prelude.d_OP_dot (Text.Curry_Pretty.d_C_pPrint
  cd cs) (Curry_Prelude.d_OP_dot (Text.Curry_Pretty.d_OP_lt_gt
  (Text.Curry_Pretty.d_C_line cd cs)) d_C_ppCNF cd cs) cd cs

d_C_ppDimacs :: Curry_Prelude.C_Int -> Dimacs.Curry_Types.C_Boolean -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppDimacs x1 x2 cd cs = let x3 = let x4 = Curry_Prelude.d_C_error
                                          (Curry_Prelude.toCurryString
                                          "Dimacs.Pretty: need formula in CNF")
                                          cd cs
                                 in d_C__case_0 x4 x2 cd cs
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Text.Curry_Pretty.d_OP_dollar_dollar cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Text.Curry_Pretty.d_C_text
  (Curry_Prelude.toCurryString "p cnf") cd cs) cd cs) (Text.Curry_Pretty.d_C_int
  x1 cd cs) cd cs) cd cs) (Text.Curry_Pretty.d_C_int x3 cd cs) cd cs) cd cs)
  (d_C_ppCNF x2 cd cs) cd cs

nd_C_ppDimacs :: Curry_Prelude.C_Int -> Dimacs.Curry_Types.C_Boolean -> IDSupply
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppDimacs x1 x2 s cd cs = let s23 = s
  in s23 `seq` (let x3 = let x4 = Curry_Prelude.d_C_error
                               (Curry_Prelude.toCurryString
                               "Dimacs.Pretty: need formula in CNF") cd cs
                      in d_C__case_0 x4 x2 cd cs
  in let s22 = leftSupply s23
         s24 = rightSupply s23
         s19 = leftSupply s24
         s21 = rightSupply s24
  in s22 `seq` (s24 `seq` (s19 `seq` (s21 `seq` Curry_Prelude.nd_C_apply
  (let s18 = leftSupply s19
       s20 = rightSupply s19
       s0 = leftSupply s20
       s16 = rightSupply s20
  in s18 `seq` (s20 `seq` (s0 `seq` (s16 `seq` Curry_Prelude.nd_C_apply
  (Text.Curry_Pretty.nd_OP_dollar_dollar s0 cd cs) (let s15 = leftSupply s16
                                                        s17 = rightSupply s16
                                                        s12 = leftSupply s17
                                                        s14 = rightSupply s17
  in s15 `seq` (s17 `seq` (s12 `seq` (s14 `seq` Curry_Prelude.nd_C_apply
  (let s11 = leftSupply s12
       s13 = rightSupply s12
       s1 = leftSupply s13
       s9 = rightSupply s13
  in s11 `seq` (s13 `seq` (s1 `seq` (s9 `seq` Curry_Prelude.nd_C_apply
  (Text.Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (let s8 = leftSupply s9
                                                     s10 = rightSupply s9
                                                     s5 = leftSupply s10
                                                     s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
  (let s4 = leftSupply s5
       s6 = rightSupply s5
       s2 = leftSupply s6
       s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (Text.Curry_Pretty.nd_OP_lt_plus_gt s2 cd cs) (Text.Curry_Pretty.nd_C_text
  (Curry_Prelude.toCurryString "p cnf") s3 cd cs) s4 cd cs))))
  (Text.Curry_Pretty.nd_C_int x1 s7 cd cs) s8 cd cs)))) s11 cd cs))))
  (Text.Curry_Pretty.nd_C_int x3 s14 cd cs) s15 cd cs)))) s18 cd cs))))
  (nd_C_ppCNF x2 s21 cd cs) s22 cd cs))))

d_C_ppCNF :: Dimacs.Curry_Types.C_Boolean -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C_ppCNF x1 cd cs = case x1 of
  Dimacs.Curry_Types.C_Var x2 -> Text.Curry_Pretty.d_C_int x2 cd cs
  Dimacs.Curry_Types.C_Not x3 -> Text.Curry_Pretty.d_OP_lt_gt
    (Text.Curry_Pretty.d_C_text (Curry_Prelude.toCurryString "-") cd cs)
    (d_C_ppCNF x3 cd cs) cd cs
  Dimacs.Curry_Types.C_And x4 -> Curry_Prelude.d_OP_dollar
    (Text.Curry_Pretty.d_C_vsep cd cs) (Curry_Prelude.d_C_map d_C_ppCNF x4 cd
    cs) cd cs
  Dimacs.Curry_Types.C_Or x5 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Prelude.d_OP_dollar
    (Text.Curry_Pretty.d_C_hsep cd cs) (Curry_Prelude.d_C_map d_C_ppCNF x5 cd
    cs) cd cs) cd cs) (Text.Curry_Pretty.d_C_text (Curry_Prelude.toCurryString
    "0") cd cs) cd cs
  Dimacs.Curry_Types.Choice_C_Boolean d i l r -> narrow d i (d_C_ppCNF l cd cs)
    (d_C_ppCNF r cd cs)
  Dimacs.Curry_Types.Choices_C_Boolean d i xs -> narrows cs d i (\z -> d_C_ppCNF
    z cd cs) xs
  Dimacs.Curry_Types.Guard_C_Boolean d c e -> guardCons d c ((\x -> d_C_ppCNF e
    cd x) $! addCs c cs)
  Dimacs.Curry_Types.Fail_C_Boolean d info -> failCons d (traceFail
    "Dimacs.Pretty.ppCNF" [show x1] info)
  _ -> failCons cd (consFail "Dimacs.Pretty.ppCNF" (showCons x1))

nd_C_ppCNF :: Dimacs.Curry_Types.C_Boolean -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppCNF x1 s cd cs = case x1 of
  Dimacs.Curry_Types.C_Var x2 -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_int x2 s0 cd cs
  Dimacs.Curry_Types.C_Not x3 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Text.Curry_Pretty.nd_OP_lt_gt
    (Text.Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString "-") s0 cd cs)
    (nd_C_ppCNF x3 s1 cd cs) s2 cd cs))))
  Dimacs.Curry_Types.C_And x4 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_OP_dollar
    (Text.Curry_Pretty.nd_C_vsep s0 cd cs) (Curry_Prelude.nd_C_map (wrapNX id
    nd_C_ppCNF) x4 s1 cd cs) s2 cd cs))))
  Dimacs.Curry_Types.C_Or x5 -> let s11 = s
    in s11 `seq` (let s10 = leftSupply s11
                      s12 = rightSupply s11
                      s7 = leftSupply s12
                      s9 = rightSupply s12
    in s10 `seq` (s12 `seq` (s7 `seq` (s9 `seq` Curry_Prelude.nd_C_apply
    (let s6 = leftSupply s7
         s8 = rightSupply s7
         s0 = leftSupply s8
         s4 = rightSupply s8
    in s6 `seq` (s8 `seq` (s0 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (let s3 = leftSupply s4
                                                       s5 = rightSupply s4
                                                       s1 = leftSupply s5
                                                       s2 = rightSupply s5
    in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_OP_dollar
    (Text.Curry_Pretty.nd_C_hsep s1 cd cs) (Curry_Prelude.nd_C_map (wrapNX id
    nd_C_ppCNF) x5 s2 cd cs) s3 cd cs)))) s6 cd cs))))
    (Text.Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString "0") s9 cd cs) s10
    cd cs))))
  Dimacs.Curry_Types.Choice_C_Boolean d i l r -> narrow d i (nd_C_ppCNF l s cd
    cs) (nd_C_ppCNF r s cd cs)
  Dimacs.Curry_Types.Choices_C_Boolean d i xs -> narrows cs d i (\z ->
    nd_C_ppCNF z s cd cs) xs
  Dimacs.Curry_Types.Guard_C_Boolean d c e -> guardCons d c ((\x -> nd_C_ppCNF e
    s cd x) $! addCs c cs)
  Dimacs.Curry_Types.Fail_C_Boolean d info -> failCons d (traceFail
    "Dimacs.Pretty.ppCNF" [show x1] info)
  _ -> failCons cd (consFail "Dimacs.Pretty.ppCNF" (showCons x1))

d_C__case_0 :: Curry_Prelude.C_Int -> Dimacs.Curry_Types.C_Boolean -> Cover
  -> ConstStore -> Curry_Prelude.C_Int
d_C__case_0 x4 x2 cd cs = case x2 of
  Dimacs.Curry_Types.C_Or x5 -> Curry_Prelude.C_Int (1)
  Dimacs.Curry_Types.C_And x6 -> Curry_Prelude.d_C_length x6 cd cs
  Dimacs.Curry_Types.C_Var x7 -> x4
  Dimacs.Curry_Types.C_Not x8 -> x4
  Dimacs.Curry_Types.Choice_C_Boolean d i l r -> narrow d i (d_C__case_0 x4 l cd
    cs) (d_C__case_0 x4 r cd cs)
  Dimacs.Curry_Types.Choices_C_Boolean d i xs -> narrows cs d i (\z ->
    d_C__case_0 x4 z cd cs) xs
  Dimacs.Curry_Types.Guard_C_Boolean d c e -> guardCons d c ((\x -> d_C__case_0
    x4 e cd x) $! addCs c cs)
  Dimacs.Curry_Types.Fail_C_Boolean d info -> failCons d (traceFail
    "Dimacs.Pretty._case_0" [show x4, show x2] info)
  _ -> failCons cd (consFail "Dimacs.Pretty._case_0" (showCons x2))

