{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Dimacs.Curry_Scanner
  ( C_Token (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Dimacs_dot_Scanner_dot_Token_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Dimacs_dot_Scanner_dot_Token_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Dimacs_dot_Scanner_dot_Token_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
  , d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
  , d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
  , d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
  , d_C_keywords
  , d_C_keyword
  , d_C_scan
  , d_C_scanKeyword
  , d_C_scanNum )
  where

import Basics
import qualified Data.Curry_Char
import qualified Curry_Numeric
import qualified Curry_Prelude


data C_Token
  = C_KW_sat
  | C_KW_unsat
  | C_VarNum Curry_Prelude.C_Int
  | C_VarNot
  | C_EOF
  | Choice_C_Token Cover ID C_Token C_Token
  | Choices_C_Token Cover ID [C_Token]
  | Fail_C_Token Cover FailInfo
  | Guard_C_Token Cover Constraints C_Token

instance Show C_Token where
  showsPrec d (Choice_C_Token cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Token cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Token cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Token cd info) = showChar '!'
  showsPrec _ C_KW_sat = showString "KW_sat"
  showsPrec _ C_KW_unsat = showString "KW_unsat"
  showsPrec _ (C_VarNum x1) = showString "(VarNum" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ C_VarNot = showString "VarNot"
  showsPrec _ C_EOF = showString "EOF"

instance Read C_Token where
  readsPrec d s = readParen False (\r -> [(C_KW_sat, r0) | (_, r0) <-
    readQualified "Dimacs.Scanner" "KW_sat" r]) s ++ (readParen False (\r ->
    [(C_KW_unsat, r0) | (_, r0) <- readQualified "Dimacs.Scanner" "KW_unsat" r])
    s ++ (readParen ((>) d 10) (\r -> [(C_VarNum x1, r1) | (_, r0) <-
    readQualified "Dimacs.Scanner" "VarNum" r, (x1, r1) <- readsPrec 11 r0])
    s ++ (readParen False (\r -> [(C_VarNot, r0) | (_, r0) <- readQualified
    "Dimacs.Scanner" "VarNot" r]) s ++ readParen False (\r -> [(C_EOF, r0) | (_
    , r0) <- readQualified "Dimacs.Scanner" "EOF" r]) s)))

instance NonDet C_Token where
  choiceCons = Choice_C_Token
  choicesCons = Choices_C_Token
  failCons = Fail_C_Token
  guardCons = Guard_C_Token
  try (Choice_C_Token cd i x y) = tryChoice cd i x y
  try (Choices_C_Token cd i xs) = tryChoices cd i xs
  try (Fail_C_Token cd info) = Fail cd info
  try (Guard_C_Token cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Token cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Token cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Token cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Token cd i _) = error
    ("Dimacs.Scanner.Token.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Token cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Token cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Token where
  generate s c = Choices_C_Token c (freeID [0, 0, 1, 0, 0] s) [C_KW_sat
    , C_KW_unsat, C_VarNum (generate (leftSupply s) c), C_VarNot, C_EOF]

instance NormalForm C_Token where
  ($!!) cont C_KW_sat d cs = cont C_KW_sat d cs
  ($!!) cont C_KW_unsat d cs = cont C_KW_unsat d cs
  ($!!) cont (C_VarNum x1) d cs = ($!!) (\y1 d cs -> cont (C_VarNum y1) d cs) x1
    d cs
  ($!!) cont C_VarNot d cs = cont C_VarNot d cs
  ($!!) cont C_EOF d cs = cont C_EOF d cs
  ($!!) cont (Choice_C_Token cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Token cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Token cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_Token cd info) _ _ = failCons cd info
  ($##) cont C_KW_sat d cs = cont C_KW_sat d cs
  ($##) cont C_KW_unsat d cs = cont C_KW_unsat d cs
  ($##) cont (C_VarNum x1) d cs = ($##) (\y1 d cs -> cont (C_VarNum y1) d cs) x1
    d cs
  ($##) cont C_VarNot d cs = cont C_VarNot d cs
  ($##) cont C_EOF d cs = cont C_EOF d cs
  ($##) cont (Choice_C_Token cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Token cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Token cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_Token cd info) _ _ = failCons cd info
  showCons C_KW_sat = "Dimacs.Scanner.KW_sat"
  showCons C_KW_unsat = "Dimacs.Scanner.KW_unsat"
  showCons (C_VarNum _) = "Dimacs.Scanner.VarNum _"
  showCons C_VarNot = "Dimacs.Scanner.VarNot"
  showCons C_EOF = "Dimacs.Scanner.EOF"
  showCons x = error ("Dimacs.Scanner.Token.showCons: no constructor: " ++ show
    x)
  searchNF _ cont C_KW_sat = cont C_KW_sat
  searchNF _ cont C_KW_unsat = cont C_KW_unsat
  searchNF search cont (C_VarNum x1) = search (\y1 -> cont (C_VarNum y1)) x1
  searchNF _ cont C_VarNot = cont C_VarNot
  searchNF _ cont C_EOF = cont C_EOF
  searchNF _ _ x = error ("Dimacs.Scanner.Token.searchNF: no constructor: " ++
    show x)

instance Unifiable C_Token where
  (=.=) C_KW_sat C_KW_sat d cs = C_True
  (=.=) C_KW_unsat C_KW_unsat d cs = C_True
  (=.=) (C_VarNum x1) (C_VarNum y1) d cs = (=:=) x1 y1 d cs
  (=.=) C_VarNot C_VarNot d cs = C_True
  (=.=) C_EOF C_EOF d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_KW_sat C_KW_sat d cs = C_True
  (=.<=) C_KW_unsat C_KW_unsat d cs = C_True
  (=.<=) (C_VarNum x1) (C_VarNum y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) C_VarNot C_VarNot d cs = C_True
  (=.<=) C_EOF C_EOF d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_KW_sat = (i :=: ChooseN 0 0) : concat []
  bind cd i C_KW_unsat = (i :=: ChooseN 1 0) : concat []
  bind cd i (C_VarNum x3) = (i :=: ChooseN 2 1) : concat [bind cd (leftID i) x3]
  bind cd i C_VarNot = (i :=: ChooseN 3 0) : concat []
  bind cd i C_EOF = (i :=: ChooseN 4 0) : concat []
  bind d i (Choice_C_Token cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_Token cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Token cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Token cd i _) = error
    ("Dimacs.Scanner.Token.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Token cd info) = [Unsolvable info]
  bind d i (Guard_C_Token cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_KW_sat = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_KW_unsat = (i :=: ChooseN 1 0) : []
  lazyBind cd i (C_VarNum x3) = (i :=: ChooseN 2 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i C_VarNot = (i :=: ChooseN 3 0) : []
  lazyBind cd i C_EOF = (i :=: ChooseN 4 0) : []
  lazyBind d i (Choice_C_Token cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Token cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_Token cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Token cd i _) = error
    ("Dimacs.Scanner.Token.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Token cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Token cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Token where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Dimacs_dot_Scanner_dot_Token_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Token
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Dimacs_dot_Scanner_dot_Token_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Dimacs_dot_Scanner_dot_Token_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Dimacs_dot_Scanner_dot_Token_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Dimacs_dot_Scanner_dot_Token_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Dimacs_dot_Scanner_dot_Token_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Dimacs_dot_Scanner_dot_Token_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Dimacs_dot_Scanner_dot_Token_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Dimacs.Scanner._inst#Prelude.Data#Dimacs.Scanner.Token#" [show x1] info)
  _ -> failCons cd (consFail
    "Dimacs.Scanner._inst#Prelude.Data#Dimacs.Scanner.Token#" (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Dimacs_dot_Scanner_dot_Token_hash :: C_Token
  -> C_Token -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Dimacs_dot_Scanner_dot_Token_hash x1 x2 cd cs =
  case x1 of
  C_KW_sat -> d_C__case_26 x2 cd cs
  C_KW_unsat -> d_C__case_25 x2 cd cs
  C_VarNum x5 -> d_C__case_24 x5 x2 cd cs
  C_VarNot -> d_C__case_23 x2 cd cs
  C_EOF -> d_C__case_22 x2 cd cs
  Choice_C_Token d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Dimacs_dot_Scanner_dot_Token_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Dimacs_dot_Scanner_dot_Token_hash
    r x2 cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Dimacs_dot_Scanner_dot_Token_hash
    z x2 cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Dimacs_dot_Scanner_dot_Token_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Dimacs.Scanner._impl#===#Prelude.Data#Dimacs.Scanner.Token#" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "Dimacs.Scanner._impl#===#Prelude.Data#Dimacs.Scanner.Token#" (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Dimacs_dot_Scanner_dot_Token_hash :: IDSupply
  -> Cover -> ConstStore -> C_Token
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Dimacs_dot_Scanner_dot_Token_hash s cd cs =
  let s8 = s
  in s8 `seq` (let s7 = leftSupply s8
                   s6 = rightSupply s8
  in s7 `seq` (s6 `seq` choice (let s5 = leftSupply s6
                                    s3 = rightSupply s6
  in s5 `seq` (s3 `seq` choice (let s2 = leftSupply s3
                                    s4 = rightSupply s3
                                    s0 = leftSupply s4
                                    s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` choice (choice C_KW_sat C_KW_unsat
  s0 cd cs) (C_VarNum
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s1 cd cs)) s2 cd cs)))) C_VarNot s5 cd cs)) C_EOF s7 cd cs))

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_Token
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Dimacs.Scanner._inst#Prelude.Eq#Dimacs.Scanner.Token#" [show x1] info)
  _ -> failCons cd (consFail
    "Dimacs.Scanner._inst#Prelude.Eq#Dimacs.Scanner.Token#" (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_Token
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Dimacs.Scanner._inst#Prelude.Eq#Dimacs.Scanner.Token#" [show x1] info)
  _ -> failCons cd (consFail
    "Dimacs.Scanner._inst#Prelude.Eq#Dimacs.Scanner.Token#" (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash :: C_Token
  -> C_Token -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash x1 x2 cd cs =
  case x1 of
  C_KW_sat -> d_C__case_21 x2 cd cs
  C_KW_unsat -> d_C__case_20 x2 cd cs
  C_VarNum x5 -> d_C__case_19 x5 x2 cd cs
  C_VarNot -> d_C__case_18 x2 cd cs
  C_EOF -> d_C__case_17 x2 cd cs
  Choice_C_Token d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash
    r x2 cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash
    z x2 cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Dimacs.Scanner._impl#==#Prelude.Eq#Dimacs.Scanner.Token#" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "Dimacs.Scanner._impl#==#Prelude.Eq#Dimacs.Scanner.Token#" (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash :: Cover
  -> ConstStore -> C_Token -> Cover -> ConstStore -> C_Token -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Scanner_dot_Token_hash)

d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show C_Token
d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Show
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
    cd cs) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Dimacs.Scanner._inst#Prelude.Show#Dimacs.Scanner.Token#" [show x1] info)
  _ -> failCons cd (consFail
    "Dimacs.Scanner._inst#Prelude.Show#Dimacs.Scanner.Token#" (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  C_Token
nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Show (wrapDX id
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
    cd cs)) (wrapDX (wrapDX (wrapDX id)) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Dimacs.Scanner._inst#Prelude.Show#Dimacs.Scanner.Token#" [show x1] info)
  _ -> failCons cd (consFail
    "Dimacs.Scanner._inst#Prelude.Show#Dimacs.Scanner.Token#" (showCons x1))

d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash :: Cover
  -> ConstStore -> C_Token -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash

d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash :: Curry_Prelude.C_Int
  -> C_Token -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash x1 x2 cd cs =
  case x2 of
  C_KW_sat -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "KW_sat")
  C_KW_unsat -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "KW_unsat")
  C_VarNum x3 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "VarNum "))
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (11)) cd cs) x3 cd cs) cd cs) cd cs
  C_VarNot -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "VarNot")
  C_EOF -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "EOF")
  Choice_C_Token d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
    x1 l cd cs)
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
    x1 r cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
    x1 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
    x1 e cd x) $! addCs c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Dimacs.Scanner._impl#showsPrec#Prelude.Show#Dimacs.Scanner.Token#" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "Dimacs.Scanner._impl#showsPrec#Prelude.Show#Dimacs.Scanner.Token#"
    (showCons x2))

d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Scanner_dot_Token_hash
  cd cs

d_C_keywords :: Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) C_Token)
d_C_keywords cd cs = Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "sat") C_KW_sat) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "satisfiable") C_KW_sat)
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "unsat") C_KW_unsat) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "unsatisfiable") C_KW_unsat)
  Curry_Prelude.OP_List)))

d_C_keyword :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> C_Token
d_C_keyword x1 cd cs = Curry_Prelude.d_C_maybe (Curry_Prelude.d_OP_dollar
  Curry_Prelude.d_C_error (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "unknown keyword: ") x1 cd cs) cd cs)
  Curry_Prelude.d_C_id (Curry_Prelude.d_C_lookup
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_C_map Data.Curry_Char.d_C_toLower x1 cd cs) (d_C_keywords cd
  cs) cd cs) cd cs

d_C_scan :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
d_C_scan x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons C_EOF Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_16 x2 x1 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '-'#) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_scan l cd cs)
    (d_C_scan r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_scan z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_scan e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Dimacs.Scanner.scan" [show x1] info)
  _ -> failCons cd (consFail "Dimacs.Scanner.scan" (showCons x1))

d_OP_scan_dot_scan_tick_dot_6 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
d_OP_scan_dot_scan_tick_dot_6 x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons C_EOF Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_5 x2 x3 x1 (Curry_Prelude.d_C_isDigit
    x2 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_scan_dot_scan_tick_dot_6 l cd cs) (d_OP_scan_dot_scan_tick_dot_6 r cd
    cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_scan_dot_scan_tick_dot_6 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_scan_dot_scan_tick_dot_6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Dimacs.Scanner.scan.scan'.6" [show x1] info)
  _ -> failCons cd (consFail "Dimacs.Scanner.scan.scan'.6" (showCons x1))

d_OP_scan_dot_uscore_hash_lambda2 :: Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_OP_scan_dot_uscore_hash_lambda2 x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  cd cs) x1 cd cs) (Curry_Prelude.C_Char '\n'#) cd cs

d_C_scanKeyword :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
d_C_scanKeyword x1 cd cs = let x2 = Curry_Prelude.d_C_span
                                 Curry_Prelude.d_C_isAlpha x1 cd cs
                               x3 = d_OP_scanKeyword_dot_uscore_hash_selFP2_hash_key
                                 x2 cd cs
                               x4 = d_OP_scanKeyword_dot_uscore_hash_selFP3_hash_rest
                                 x2 cd cs
  in Curry_Prelude.OP_Cons (d_C_keyword x3 cd cs) (d_C_scan x4 cd cs)

d_OP_scanKeyword_dot_uscore_hash_selFP2_hash_key :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_scanKeyword_dot_uscore_hash_selFP2_hash_key x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_scanKeyword_dot_uscore_hash_selFP2_hash_key l cd cs)
    (d_OP_scanKeyword_dot_uscore_hash_selFP2_hash_key r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_scanKeyword_dot_uscore_hash_selFP2_hash_key z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_scanKeyword_dot_uscore_hash_selFP2_hash_key e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Dimacs.Scanner.scanKeyword._#selFP2#key" [show x1] info)
  _ -> failCons cd (consFail "Dimacs.Scanner.scanKeyword._#selFP2#key" (showCons
    x1))

d_OP_scanKeyword_dot_uscore_hash_selFP3_hash_rest :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_scanKeyword_dot_uscore_hash_selFP3_hash_rest x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_scanKeyword_dot_uscore_hash_selFP3_hash_rest l cd cs)
    (d_OP_scanKeyword_dot_uscore_hash_selFP3_hash_rest r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_scanKeyword_dot_uscore_hash_selFP3_hash_rest z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_scanKeyword_dot_uscore_hash_selFP3_hash_rest e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Dimacs.Scanner.scanKeyword._#selFP3#rest" [show x1] info)
  _ -> failCons cd (consFail "Dimacs.Scanner.scanKeyword._#selFP3#rest"
    (showCons x1))

d_C_scanNum :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
d_C_scanNum x1 cd cs = let x2 = Curry_Numeric.d_C_readInt x1 cd cs
  in d_C__case_2 x2 cd cs

d_C__case_22 :: C_Token -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_22 x2 cd cs = case x2 of
  C_KW_sat -> Curry_Prelude.C_False
  C_KW_unsat -> Curry_Prelude.C_False
  C_VarNum x8 -> Curry_Prelude.C_False
  C_VarNot -> Curry_Prelude.C_False
  C_EOF -> Curry_Prelude.C_True
  Choice_C_Token d i l r -> narrow d i (d_C__case_22 l cd cs) (d_C__case_22 r cd
    cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_22 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_22 e cd x) $! addCs c
    cs)
  Fail_C_Token d info -> failCons d (traceFail "Dimacs.Scanner._case_22" [show
    x2] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_22" (showCons x2))

d_C__case_23 :: C_Token -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_23 x2 cd cs = case x2 of
  C_KW_sat -> Curry_Prelude.C_False
  C_KW_unsat -> Curry_Prelude.C_False
  C_VarNum x7 -> Curry_Prelude.C_False
  C_VarNot -> Curry_Prelude.C_True
  C_EOF -> Curry_Prelude.C_False
  Choice_C_Token d i l r -> narrow d i (d_C__case_23 l cd cs) (d_C__case_23 r cd
    cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_23 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_23 e cd x) $! addCs c
    cs)
  Fail_C_Token d info -> failCons d (traceFail "Dimacs.Scanner._case_23" [show
    x2] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_23" (showCons x2))

d_C__case_24 :: Curry_Prelude.C_Int -> C_Token -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_24 x5 x2 cd cs = case x2 of
  C_KW_sat -> Curry_Prelude.C_False
  C_KW_unsat -> Curry_Prelude.C_False
  C_VarNum x6 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs) x5 cd cs) x6 cd cs
  C_VarNot -> Curry_Prelude.C_False
  C_EOF -> Curry_Prelude.C_False
  Choice_C_Token d i l r -> narrow d i (d_C__case_24 x5 l cd cs) (d_C__case_24
    x5 r cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_24 x5 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_24 x5 e cd x) $! addCs
    c cs)
  Fail_C_Token d info -> failCons d (traceFail "Dimacs.Scanner._case_24" [show
    x5, show x2] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_24" (showCons x2))

d_C__case_25 :: C_Token -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_25 x2 cd cs = case x2 of
  C_KW_sat -> Curry_Prelude.C_False
  C_KW_unsat -> Curry_Prelude.C_True
  C_VarNum x4 -> Curry_Prelude.C_False
  C_VarNot -> Curry_Prelude.C_False
  C_EOF -> Curry_Prelude.C_False
  Choice_C_Token d i l r -> narrow d i (d_C__case_25 l cd cs) (d_C__case_25 r cd
    cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_25 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_25 e cd x) $! addCs c
    cs)
  Fail_C_Token d info -> failCons d (traceFail "Dimacs.Scanner._case_25" [show
    x2] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_25" (showCons x2))

d_C__case_26 :: C_Token -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_26 x2 cd cs = case x2 of
  C_KW_sat -> Curry_Prelude.C_True
  C_KW_unsat -> Curry_Prelude.C_False
  C_VarNum x3 -> Curry_Prelude.C_False
  C_VarNot -> Curry_Prelude.C_False
  C_EOF -> Curry_Prelude.C_False
  Choice_C_Token d i l r -> narrow d i (d_C__case_26 l cd cs) (d_C__case_26 r cd
    cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_26 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_26 e cd x) $! addCs c
    cs)
  Fail_C_Token d info -> failCons d (traceFail "Dimacs.Scanner._case_26" [show
    x2] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_26" (showCons x2))

d_C__case_17 :: C_Token -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_17 x2 cd cs = case x2 of
  C_KW_sat -> Curry_Prelude.C_False
  C_KW_unsat -> Curry_Prelude.C_False
  C_VarNum x8 -> Curry_Prelude.C_False
  C_VarNot -> Curry_Prelude.C_False
  C_EOF -> Curry_Prelude.C_True
  Choice_C_Token d i l r -> narrow d i (d_C__case_17 l cd cs) (d_C__case_17 r cd
    cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_17 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_17 e cd x) $! addCs c
    cs)
  Fail_C_Token d info -> failCons d (traceFail "Dimacs.Scanner._case_17" [show
    x2] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_17" (showCons x2))

d_C__case_18 :: C_Token -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_18 x2 cd cs = case x2 of
  C_KW_sat -> Curry_Prelude.C_False
  C_KW_unsat -> Curry_Prelude.C_False
  C_VarNum x7 -> Curry_Prelude.C_False
  C_VarNot -> Curry_Prelude.C_True
  C_EOF -> Curry_Prelude.C_False
  Choice_C_Token d i l r -> narrow d i (d_C__case_18 l cd cs) (d_C__case_18 r cd
    cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_18 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_18 e cd x) $! addCs c
    cs)
  Fail_C_Token d info -> failCons d (traceFail "Dimacs.Scanner._case_18" [show
    x2] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_18" (showCons x2))

d_C__case_19 :: Curry_Prelude.C_Int -> C_Token -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_19 x5 x2 cd cs = case x2 of
  C_KW_sat -> Curry_Prelude.C_False
  C_KW_unsat -> Curry_Prelude.C_False
  C_VarNum x6 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x5 x6 cd cs
  C_VarNot -> Curry_Prelude.C_False
  C_EOF -> Curry_Prelude.C_False
  Choice_C_Token d i l r -> narrow d i (d_C__case_19 x5 l cd cs) (d_C__case_19
    x5 r cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_19 x5 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_19 x5 e cd x) $! addCs
    c cs)
  Fail_C_Token d info -> failCons d (traceFail "Dimacs.Scanner._case_19" [show
    x5, show x2] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_19" (showCons x2))

d_C__case_20 :: C_Token -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_20 x2 cd cs = case x2 of
  C_KW_sat -> Curry_Prelude.C_False
  C_KW_unsat -> Curry_Prelude.C_True
  C_VarNum x4 -> Curry_Prelude.C_False
  C_VarNot -> Curry_Prelude.C_False
  C_EOF -> Curry_Prelude.C_False
  Choice_C_Token d i l r -> narrow d i (d_C__case_20 l cd cs) (d_C__case_20 r cd
    cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_20 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_20 e cd x) $! addCs c
    cs)
  Fail_C_Token d info -> failCons d (traceFail "Dimacs.Scanner._case_20" [show
    x2] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_20" (showCons x2))

d_C__case_21 :: C_Token -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_21 x2 cd cs = case x2 of
  C_KW_sat -> Curry_Prelude.C_True
  C_KW_unsat -> Curry_Prelude.C_False
  C_VarNum x3 -> Curry_Prelude.C_False
  C_VarNot -> Curry_Prelude.C_False
  C_EOF -> Curry_Prelude.C_False
  Choice_C_Token d i l r -> narrow d i (d_C__case_21 l cd cs) (d_C__case_21 r cd
    cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_21 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_21 e cd x) $! addCs c
    cs)
  Fail_C_Token d info -> failCons d (traceFail "Dimacs.Scanner._case_21" [show
    x2] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_21" (showCons x2))

d_C__case_16 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Token
d_C__case_16 x2 x1 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons C_VarNot (d_C_scan x3 cd cs)
  Curry_Prelude.C_False -> d_C__case_15 x2 x1 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '0'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_16 x2 x1 x3 l cd
    cs) (d_C__case_16 x2 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_16 x2
    x1 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_16 x2 x1
    x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Dimacs.Scanner._case_16" [show x2, show x1, show x3, show x4] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_16" (showCons x4))

d_C__case_15 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Token
d_C__case_15 x2 x1 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> d_C_scan x3 cd cs
  Curry_Prelude.C_False -> d_C__case_14 x2 x1 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char 's'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_15 x2 x1 x3 l cd
    cs) (d_C__case_15 x2 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_15 x2
    x1 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_15 x2 x1
    x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Dimacs.Scanner._case_15" [show x2, show x1, show x3, show x4] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_15" (showCons x4))

d_C__case_14 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Token
d_C__case_14 x2 x1 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> d_C__case_13 x1 x3 cd cs
  Curry_Prelude.C_False -> d_C__case_11 x2 x1 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char 'v'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_14 x2 x1 x3 l cd
    cs) (d_C__case_14 x2 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_14 x2
    x1 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_14 x2 x1
    x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Dimacs.Scanner._case_14" [show x2, show x1, show x3, show x4] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_14" (showCons x4))

d_C__case_11 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Token
d_C__case_11 x2 x1 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> d_C__case_10 x1 x3 cd cs
  Curry_Prelude.C_False -> d_C__case_8 x2 x1 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char 'c'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_11 x2 x1 x3 l cd
    cs) (d_C__case_11 x2 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_11 x2
    x1 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_11 x2 x1
    x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Dimacs.Scanner._case_11" [show x2, show x1, show x3, show x4] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_11" (showCons x4))

d_C__case_8 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Token
d_C__case_8 x2 x1 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> d_C__case_7 x1 x3 cd cs
  Curry_Prelude.C_False -> d_OP_scan_dot_scan_tick_dot_6 x1 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x2 x1 x3 l cd
    cs) (d_C__case_8 x2 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x2 x1
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_8 x2 x1 x3
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Dimacs.Scanner._case_8" [show x2, show x1, show x3, show x4] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_8" (showCons x4))

d_C__case_7 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
d_C__case_7 x1 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x8 x9 -> d_C__case_6 x8 x1 x9
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x8 (Curry_Prelude.C_Char ' '#) cd cs) cd cs
  Curry_Prelude.OP_List -> d_OP_scan_dot_scan_tick_dot_6 x1 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_7 x1 l cd cs)
    (d_C__case_7 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_7 x1 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_7 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Dimacs.Scanner._case_7" [show x1, show x3] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_7" (showCons x3))

d_C__case_6 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Token
d_C__case_6 x8 x1 x9 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar d_C_scan
    (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_tail
    (Curry_Prelude.d_C_dropWhile d_OP_scan_dot_uscore_hash_lambda2 x9 cd cs) cd
    cs) cd cs
  Curry_Prelude.C_False -> d_OP_scan_dot_scan_tick_dot_6 x1 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x8 x1 x9 l cd
    cs) (d_C__case_6 x8 x1 x9 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x8 x1
    x9 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x8 x1 x9
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Dimacs.Scanner._case_6" [show x8, show x1, show x9, show x10] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_6" (showCons x10))

d_C__case_10 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
d_C__case_10 x1 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x6 x7 -> d_C__case_9 x6 x1 x7
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x6 (Curry_Prelude.C_Char ' '#) cd cs) cd cs
  Curry_Prelude.OP_List -> d_OP_scan_dot_scan_tick_dot_6 x1 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_10 x1 l cd cs)
    (d_C__case_10 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_10 x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_10 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Dimacs.Scanner._case_10" [show x1, show x3] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_10" (showCons x3))

d_C__case_9 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Token
d_C__case_9 x6 x1 x7 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_C_scan x7 cd cs
  Curry_Prelude.C_False -> d_OP_scan_dot_scan_tick_dot_6 x1 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_9 x6 x1 x7 l cd
    cs) (d_C__case_9 x6 x1 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_9 x6 x1
    x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_9 x6 x1 x7
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Dimacs.Scanner._case_9" [show x6, show x1, show x7, show x8] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_9" (showCons x8))

d_C__case_13 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
d_C__case_13 x1 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_12 x4 x1 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x4 (Curry_Prelude.C_Char ' '#) cd cs) cd cs
  Curry_Prelude.OP_List -> d_OP_scan_dot_scan_tick_dot_6 x1 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_13 x1 l cd cs)
    (d_C__case_13 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_13 x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_13 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Dimacs.Scanner._case_13" [show x1, show x3] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_13" (showCons x3))

d_C__case_12 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Token
d_C__case_12 x4 x1 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_scan x5 cd cs
  Curry_Prelude.C_False -> d_OP_scan_dot_scan_tick_dot_6 x1 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_12 x4 x1 x5 l cd
    cs) (d_C__case_12 x4 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_12 x4
    x1 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_12 x4 x1
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Dimacs.Scanner._case_12" [show x4, show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_12" (showCons x6))

d_C__case_5 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Token
d_C__case_5 x2 x3 x1 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> d_C_scanNum x1 cd cs
  Curry_Prelude.C_False -> d_C__case_4 x2 x3 x1 (Curry_Prelude.d_C_isAlpha x2 cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x2 x3 x1 l cd
    cs) (d_C__case_5 x2 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x2 x3
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x2 x3 x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Dimacs.Scanner._case_5" [show x2, show x3, show x1, show x4] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_5" (showCons x4))

d_C__case_4 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Token
d_C__case_4 x2 x3 x1 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> d_C_scanKeyword x1 cd cs
  Curry_Prelude.C_False -> d_C__case_3 x3 (Curry_Prelude.d_C_otherwise cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x2 x3 x1 l cd
    cs) (d_C__case_4 x2 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x2 x3
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x2 x3 x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Dimacs.Scanner._case_4" [show x2, show x3, show x1, show x4] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_4" (showCons x4))

d_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Token
d_C__case_3 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> d_C_scan x3 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x3 l cd cs)
    (d_C__case_3 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x3 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Dimacs.Scanner._case_3" [show x3, show x4] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_3" (showCons x4))

d_C__case_2 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
d_C__case_2 x2 cd cs = case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_1 x4 x3 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "should not be possible") cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_2 l cd cs)
    (d_C__case_2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_2 z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_2 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Dimacs.Scanner._case_2" [show x2] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_2" (showCons x2))

d_C__case_1 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
d_C__case_1 x4 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> d_C__case_0 x6 x5 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_1 x4 l cd cs)
    (d_C__case_1 x4 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_1 x4
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_1 x4 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Dimacs.Scanner._case_1" [show x4, show x3] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_1" (showCons x3))

d_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
d_C__case_0 x6 x5 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons (C_VarNum x5) (d_C_scan x6 cd
    cs)
  Curry_Prelude.OP_Cons x7 x8 -> Curry_Prelude.d_C_error
    (Curry_Prelude.toCurryString "should not be possible") cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_0 x6 x5 l cd cs)
    (d_C__case_0 x6 x5 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_0 x6
    x5 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_0 x6 x5 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Dimacs.Scanner._case_0" [show x6, show x5, show x4] info)
  _ -> failCons cd (consFail "Dimacs.Scanner._case_0" (showCons x4))

