{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Dimacs.Curry_Types
  ( C_Boolean (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
  , d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
  , d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
  , d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
  , d_C_maxVar )
  where

import Basics
import qualified Data.Curry_List
import qualified Curry_Prelude


data C_Boolean
  = C_Var Curry_Prelude.C_Int
  | C_Not C_Boolean
  | C_And (Curry_Prelude.OP_List C_Boolean)
  | C_Or (Curry_Prelude.OP_List C_Boolean)
  | Choice_C_Boolean Cover ID C_Boolean C_Boolean
  | Choices_C_Boolean Cover ID [C_Boolean]
  | Fail_C_Boolean Cover FailInfo
  | Guard_C_Boolean Cover Constraints C_Boolean

instance Show C_Boolean where
  showsPrec d (Choice_C_Boolean cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Boolean cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Boolean cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Boolean cd info) = showChar '!'
  showsPrec _ (C_Var x1) = showString "(Var" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_Not x1) = showString "(Not" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_And x1) = showString "(And" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_Or x1) = showString "(Or" . (showChar ' ' . (shows x1 .
    showChar ')'))

instance Read C_Boolean where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Var x1, r1) | (_, r0) <-
    readQualified "Dimacs.Types" "Var" r, (x1, r1) <- readsPrec 11 r0]) s ++
    (readParen ((>) d 10) (\r -> [(C_Not x1, r1) | (_, r0) <- readQualified
    "Dimacs.Types" "Not" r, (x1, r1) <- readsPrec 11 r0]) s ++ (readParen ((>) d
    10) (\r -> [(C_And x1, r1) | (_, r0) <- readQualified "Dimacs.Types" "And"
    r, (x1, r1) <- readsPrec 11 r0]) s ++ readParen ((>) d 10) (\r -> [(C_Or x1
    , r1) | (_, r0) <- readQualified "Dimacs.Types" "Or" r, (x1, r1) <-
    readsPrec 11 r0]) s))

instance NonDet C_Boolean where
  choiceCons = Choice_C_Boolean
  choicesCons = Choices_C_Boolean
  failCons = Fail_C_Boolean
  guardCons = Guard_C_Boolean
  try (Choice_C_Boolean cd i x y) = tryChoice cd i x y
  try (Choices_C_Boolean cd i xs) = tryChoices cd i xs
  try (Fail_C_Boolean cd info) = Fail cd info
  try (Guard_C_Boolean cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Boolean cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Boolean cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Boolean cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Boolean cd i _) = error
    ("Dimacs.Types.Boolean.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Boolean cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Boolean cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Boolean where
  generate s c = Choices_C_Boolean c (freeID [1, 1, 1, 1] s) [C_Var (generate
    (leftSupply s) c), C_Not (generate (leftSupply s) c), C_And (generate
    (leftSupply s) c), C_Or (generate (leftSupply s) c)]

instance NormalForm C_Boolean where
  ($!!) cont (C_Var x1) d cs = ($!!) (\y1 d cs -> cont (C_Var y1) d cs) x1 d cs
  ($!!) cont (C_Not x1) d cs = ($!!) (\y1 d cs -> cont (C_Not y1) d cs) x1 d cs
  ($!!) cont (C_And x1) d cs = ($!!) (\y1 d cs -> cont (C_And y1) d cs) x1 d cs
  ($!!) cont (C_Or x1) d cs = ($!!) (\y1 d cs -> cont (C_Or y1) d cs) x1 d cs
  ($!!) cont (Choice_C_Boolean cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Boolean cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Boolean cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_Boolean cd info) _ _ = failCons cd info
  ($##) cont (C_Var x1) d cs = ($##) (\y1 d cs -> cont (C_Var y1) d cs) x1 d cs
  ($##) cont (C_Not x1) d cs = ($##) (\y1 d cs -> cont (C_Not y1) d cs) x1 d cs
  ($##) cont (C_And x1) d cs = ($##) (\y1 d cs -> cont (C_And y1) d cs) x1 d cs
  ($##) cont (C_Or x1) d cs = ($##) (\y1 d cs -> cont (C_Or y1) d cs) x1 d cs
  ($##) cont (Choice_C_Boolean cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Boolean cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Boolean cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_Boolean cd info) _ _ = failCons cd info
  showCons (C_Var _) = "Dimacs.Types.Var _"
  showCons (C_Not _) = "Dimacs.Types.Not _"
  showCons (C_And _) = "Dimacs.Types.And _"
  showCons (C_Or _) = "Dimacs.Types.Or _"
  showCons x = error ("Dimacs.Types.Boolean.showCons: no constructor: " ++ show
    x)
  searchNF search cont (C_Var x1) = search (\y1 -> cont (C_Var y1)) x1
  searchNF search cont (C_Not x1) = search (\y1 -> cont (C_Not y1)) x1
  searchNF search cont (C_And x1) = search (\y1 -> cont (C_And y1)) x1
  searchNF search cont (C_Or x1) = search (\y1 -> cont (C_Or y1)) x1
  searchNF _ _ x = error ("Dimacs.Types.Boolean.searchNF: no constructor: " ++
    show x)

instance Unifiable C_Boolean where
  (=.=) (C_Var x1) (C_Var y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Not x1) (C_Not y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_And x1) (C_And y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Or x1) (C_Or y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Var x1) (C_Var y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Not x1) (C_Not y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_And x1) (C_And y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Or x1) (C_Or y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Var x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_Not x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_And x3) = (i :=: ChooseN 2 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_Or x3) = (i :=: ChooseN 3 1) : concat [bind cd (leftID i) x3]
  bind d i (Choice_C_Boolean cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_Boolean cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Boolean cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_Boolean cd i _) = error
    ("Dimacs.Types.Boolean.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Boolean cd info) = [Unsolvable info]
  bind d i (Guard_C_Boolean cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Var x3) = (i :=: ChooseN 0 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Not x3) = (i :=: ChooseN 1 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_And x3) = (i :=: ChooseN 2 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Or x3) = (i :=: ChooseN 3 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_Boolean cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Boolean cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_Boolean cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Boolean cd i _) = error
    ("Dimacs.Types.Boolean.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Boolean cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Boolean cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Boolean where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Boolean
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Dimacs.Types._inst#Prelude.Data#Dimacs.Types.Boolean#" [show x1] info)
  _ -> failCons cd (consFail
    "Dimacs.Types._inst#Prelude.Data#Dimacs.Types.Boolean#" (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash :: C_Boolean
  -> C_Boolean -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash x1 x2 s cd cs =
  case x1 of
  C_Var x3 -> d_C__case_9 x3 x2 cd cs
  C_Not x8 -> let s0 = s in s0 `seq` nd_C__case_8 x8 x2 s0 cd cs
  C_And x13 -> let s0 = s in s0 `seq` nd_C__case_7 x13 x2 s0 cd cs
  C_Or x18 -> let s0 = s in s0 `seq` nd_C__case_6 x18 x2 s0 cd cs
  Choice_C_Boolean d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash
    r x2 s cd cs)
  Choices_C_Boolean d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash
    z x2 s cd cs) xs
  Guard_C_Boolean d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_Boolean d info -> failCons d (traceFail
    "Dimacs.Types._impl#===#Prelude.Data#Dimacs.Types.Boolean#" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "Dimacs.Types._impl#===#Prelude.Data#Dimacs.Types.Boolean#" (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash :: IDSupply
  -> Cover -> ConstStore -> C_Boolean
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash s cd cs =
  let s11 = s
  in s11 `seq` (let s10 = leftSupply s11
                    s12 = rightSupply s11
                    s7 = leftSupply s12
                    s9 = rightSupply s12
  in s10 `seq` (s12 `seq` (s7 `seq` (s9 `seq` choice (let s6 = leftSupply s7
                                                          s8 = rightSupply s7
                                                          s3 = leftSupply s8
                                                          s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` choice (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` choice (C_Var
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s0 cd cs)) (C_Not
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash
  s1 cd cs)) s2 cd cs)))) (C_And
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash)
  s5 cd cs)) s6 cd cs)))) (C_Or
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash)
  s9 cd cs)) s10 cd cs))))

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_Boolean
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Dimacs.Types._inst#Prelude.Eq#Dimacs.Types.Boolean#" [show x1] info)
  _ -> failCons cd (consFail
    "Dimacs.Types._inst#Prelude.Eq#Dimacs.Types.Boolean#" (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_Boolean
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Dimacs.Types._inst#Prelude.Eq#Dimacs.Types.Boolean#" [show x1] info)
  _ -> failCons cd (consFail
    "Dimacs.Types._inst#Prelude.Eq#Dimacs.Types.Boolean#" (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash :: C_Boolean
  -> C_Boolean -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash x1 x2 cd cs =
  case x1 of
  C_Var x3 -> d_C__case_5 x3 x2 cd cs
  C_Not x8 -> d_C__case_4 x8 x2 cd cs
  C_And x13 -> d_C__case_3 x13 x2 cd cs
  C_Or x18 -> d_C__case_2 x18 x2 cd cs
  Choice_C_Boolean d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
    r x2 cd cs)
  Choices_C_Boolean d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
    z x2 cd cs) xs
  Guard_C_Boolean d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Boolean d info -> failCons d (traceFail
    "Dimacs.Types._impl#==#Prelude.Eq#Dimacs.Types.Boolean#" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "Dimacs.Types._impl#==#Prelude.Eq#Dimacs.Types.Boolean#" (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash :: Cover
  -> ConstStore -> C_Boolean -> Cover -> ConstStore -> C_Boolean -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash)

d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show C_Boolean
d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Show
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
    cd cs) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Dimacs.Types._inst#Prelude.Show#Dimacs.Types.Boolean#" [show x1] info)
  _ -> failCons cd (consFail
    "Dimacs.Types._inst#Prelude.Show#Dimacs.Types.Boolean#" (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  C_Boolean
nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Show (wrapDX id
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
    cd cs)) (wrapDX (wrapDX (wrapDX id)) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Dimacs.Types._inst#Prelude.Show#Dimacs.Types.Boolean#" [show x1] info)
  _ -> failCons cd (consFail
    "Dimacs.Types._inst#Prelude.Show#Dimacs.Types.Boolean#" (showCons x1))

d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash :: Cover
  -> ConstStore -> C_Boolean -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash

d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash :: Curry_Prelude.C_Int
  -> C_Boolean -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash x1 x2 cd cs =
  case x2 of
  C_Var x3 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "Var "))
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (11)) cd cs) x3 cd cs) cd cs) cd cs
  C_Not x4 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "Not "))
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
    (Curry_Prelude.C_Int (11)) x4 cd cs) cd cs) cd cs
  C_And x5 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "And "))
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
    (Curry_Prelude.C_Int (11)) cd cs) x5 cd cs) cd cs) cd cs
  C_Or x6 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "Or "))
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
    (Curry_Prelude.C_Int (11)) cd cs) x6 cd cs) cd cs) cd cs
  Choice_C_Boolean d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
    x1 l cd cs)
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
    x1 r cd cs)
  Choices_C_Boolean d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
    x1 z cd cs) xs
  Guard_C_Boolean d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
    x1 e cd x) $! addCs c cs)
  Fail_C_Boolean d info -> failCons d (traceFail
    "Dimacs.Types._impl#showsPrec#Prelude.Show#Dimacs.Types.Boolean#" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "Dimacs.Types._impl#showsPrec#Prelude.Show#Dimacs.Types.Boolean#" (showCons
    x2))

d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Boolean -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Dimacs_dot_Types_dot_Boolean_hash
  cd cs

d_C_maxVar :: C_Boolean -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_maxVar x1 cd cs = case x1 of
  C_Var x2 -> x2
  C_Not x3 -> d_C_maxVar x3 cd cs
  C_And x4 -> d_C__case_1 x4 (Curry_Prelude.d_C_null x4 cd cs) cd cs
  C_Or x5 -> d_C__case_0 x5 (Curry_Prelude.d_C_null x5 cd cs) cd cs
  Choice_C_Boolean d i l r -> narrow d i (d_C_maxVar l cd cs) (d_C_maxVar r cd
    cs)
  Choices_C_Boolean d i xs -> narrows cs d i (\z -> d_C_maxVar z cd cs) xs
  Guard_C_Boolean d c e -> guardCons d c ((\x -> d_C_maxVar e cd x) $! addCs c
    cs)
  Fail_C_Boolean d info -> failCons d (traceFail "Dimacs.Types.maxVar" [show x1]
    info)
  _ -> failCons cd (consFail "Dimacs.Types.maxVar" (showCons x1))

nd_C__case_6 :: Curry_Prelude.OP_List C_Boolean -> C_Boolean -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_6 x18 x2 s cd cs = case x2 of
  C_Var x19 -> Curry_Prelude.C_False
  C_Not x20 -> Curry_Prelude.C_False
  C_And x21 -> Curry_Prelude.C_False
  C_Or x22 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash)
    x18 x22 s0 cd cs
  Choice_C_Boolean d i l r -> narrow d i (nd_C__case_6 x18 l s cd cs)
    (nd_C__case_6 x18 r s cd cs)
  Choices_C_Boolean d i xs -> narrows cs d i (\z -> nd_C__case_6 x18 z s cd cs)
    xs
  Guard_C_Boolean d c e -> guardCons d c ((\x -> nd_C__case_6 x18 e s cd x) $!
    addCs c cs)
  Fail_C_Boolean d info -> failCons d (traceFail "Dimacs.Types._case_6" [show
    x18, show x2] info)
  _ -> failCons cd (consFail "Dimacs.Types._case_6" (showCons x2))

nd_C__case_7 :: Curry_Prelude.OP_List C_Boolean -> C_Boolean -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_7 x13 x2 s cd cs = case x2 of
  C_Var x14 -> Curry_Prelude.C_False
  C_Not x15 -> Curry_Prelude.C_False
  C_And x16 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash)
    x13 x16 s0 cd cs
  C_Or x17 -> Curry_Prelude.C_False
  Choice_C_Boolean d i l r -> narrow d i (nd_C__case_7 x13 l s cd cs)
    (nd_C__case_7 x13 r s cd cs)
  Choices_C_Boolean d i xs -> narrows cs d i (\z -> nd_C__case_7 x13 z s cd cs)
    xs
  Guard_C_Boolean d c e -> guardCons d c ((\x -> nd_C__case_7 x13 e s cd x) $!
    addCs c cs)
  Fail_C_Boolean d info -> failCons d (traceFail "Dimacs.Types._case_7" [show
    x13, show x2] info)
  _ -> failCons cd (consFail "Dimacs.Types._case_7" (showCons x2))

nd_C__case_8 :: C_Boolean -> C_Boolean -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_8 x8 x2 s cd cs = case x2 of
  C_Var x9 -> Curry_Prelude.C_False
  C_Not x10 -> let s0 = s
    in s0 `seq`
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Dimacs_dot_Types_dot_Boolean_hash
    x8 x10 s0 cd cs
  C_And x11 -> Curry_Prelude.C_False
  C_Or x12 -> Curry_Prelude.C_False
  Choice_C_Boolean d i l r -> narrow d i (nd_C__case_8 x8 l s cd cs)
    (nd_C__case_8 x8 r s cd cs)
  Choices_C_Boolean d i xs -> narrows cs d i (\z -> nd_C__case_8 x8 z s cd cs)
    xs
  Guard_C_Boolean d c e -> guardCons d c ((\x -> nd_C__case_8 x8 e s cd x) $!
    addCs c cs)
  Fail_C_Boolean d info -> failCons d (traceFail "Dimacs.Types._case_8" [show x8
    , show x2] info)
  _ -> failCons cd (consFail "Dimacs.Types._case_8" (showCons x2))

d_C__case_9 :: Curry_Prelude.C_Int -> C_Boolean -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_9 x3 x2 cd cs = case x2 of
  C_Var x4 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs) x3 cd cs) x4 cd cs
  C_Not x5 -> Curry_Prelude.C_False
  C_And x6 -> Curry_Prelude.C_False
  C_Or x7 -> Curry_Prelude.C_False
  Choice_C_Boolean d i l r -> narrow d i (d_C__case_9 x3 l cd cs) (d_C__case_9
    x3 r cd cs)
  Choices_C_Boolean d i xs -> narrows cs d i (\z -> d_C__case_9 x3 z cd cs) xs
  Guard_C_Boolean d c e -> guardCons d c ((\x -> d_C__case_9 x3 e cd x) $! addCs
    c cs)
  Fail_C_Boolean d info -> failCons d (traceFail "Dimacs.Types._case_9" [show x3
    , show x2] info)
  _ -> failCons cd (consFail "Dimacs.Types._case_9" (showCons x2))

d_C__case_2 :: Curry_Prelude.OP_List C_Boolean -> C_Boolean -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_2 x18 x2 cd cs = case x2 of
  C_Var x19 -> Curry_Prelude.C_False
  C_Not x20 -> Curry_Prelude.C_False
  C_And x21 -> Curry_Prelude.C_False
  C_Or x22 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
    x18 x22 cd cs
  Choice_C_Boolean d i l r -> narrow d i (d_C__case_2 x18 l cd cs) (d_C__case_2
    x18 r cd cs)
  Choices_C_Boolean d i xs -> narrows cs d i (\z -> d_C__case_2 x18 z cd cs) xs
  Guard_C_Boolean d c e -> guardCons d c ((\x -> d_C__case_2 x18 e cd x) $!
    addCs c cs)
  Fail_C_Boolean d info -> failCons d (traceFail "Dimacs.Types._case_2" [show
    x18, show x2] info)
  _ -> failCons cd (consFail "Dimacs.Types._case_2" (showCons x2))

d_C__case_3 :: Curry_Prelude.OP_List C_Boolean -> C_Boolean -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_3 x13 x2 cd cs = case x2 of
  C_Var x14 -> Curry_Prelude.C_False
  C_Not x15 -> Curry_Prelude.C_False
  C_And x16 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
    x13 x16 cd cs
  C_Or x17 -> Curry_Prelude.C_False
  Choice_C_Boolean d i l r -> narrow d i (d_C__case_3 x13 l cd cs) (d_C__case_3
    x13 r cd cs)
  Choices_C_Boolean d i xs -> narrows cs d i (\z -> d_C__case_3 x13 z cd cs) xs
  Guard_C_Boolean d c e -> guardCons d c ((\x -> d_C__case_3 x13 e cd x) $!
    addCs c cs)
  Fail_C_Boolean d info -> failCons d (traceFail "Dimacs.Types._case_3" [show
    x13, show x2] info)
  _ -> failCons cd (consFail "Dimacs.Types._case_3" (showCons x2))

d_C__case_4 :: C_Boolean -> C_Boolean -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_4 x8 x2 cd cs = case x2 of
  C_Var x9 -> Curry_Prelude.C_False
  C_Not x10 -> d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Dimacs_dot_Types_dot_Boolean_hash
    x8 x10 cd cs
  C_And x11 -> Curry_Prelude.C_False
  C_Or x12 -> Curry_Prelude.C_False
  Choice_C_Boolean d i l r -> narrow d i (d_C__case_4 x8 l cd cs) (d_C__case_4
    x8 r cd cs)
  Choices_C_Boolean d i xs -> narrows cs d i (\z -> d_C__case_4 x8 z cd cs) xs
  Guard_C_Boolean d c e -> guardCons d c ((\x -> d_C__case_4 x8 e cd x) $! addCs
    c cs)
  Fail_C_Boolean d info -> failCons d (traceFail "Dimacs.Types._case_4" [show x8
    , show x2] info)
  _ -> failCons cd (consFail "Dimacs.Types._case_4" (showCons x2))

d_C__case_5 :: Curry_Prelude.C_Int -> C_Boolean -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_5 x3 x2 cd cs = case x2 of
  C_Var x4 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x3 x4 cd cs
  C_Not x5 -> Curry_Prelude.C_False
  C_And x6 -> Curry_Prelude.C_False
  C_Or x7 -> Curry_Prelude.C_False
  Choice_C_Boolean d i l r -> narrow d i (d_C__case_5 x3 l cd cs) (d_C__case_5
    x3 r cd cs)
  Choices_C_Boolean d i xs -> narrows cs d i (\z -> d_C__case_5 x3 z cd cs) xs
  Guard_C_Boolean d c e -> guardCons d c ((\x -> d_C__case_5 x3 e cd x) $! addCs
    c cs)
  Fail_C_Boolean d info -> failCons d (traceFail "Dimacs.Types._case_5" [show x3
    , show x2] info)
  _ -> failCons cd (consFail "Dimacs.Types._case_5" (showCons x2))

d_C__case_0 :: Curry_Prelude.OP_List C_Boolean -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_Int
d_C__case_0 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.C_Int (0)
  Curry_Prelude.C_False -> Data.Curry_List.d_C_maximum
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_C_map d_C_maxVar x5 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x5 l cd cs)
    (d_C__case_0 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x5 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x5 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Dimacs.Types._case_0" [show x5, show x6] info)
  _ -> failCons cd (consFail "Dimacs.Types._case_0" (showCons x6))

d_C__case_1 :: Curry_Prelude.OP_List C_Boolean -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_Int
d_C__case_1 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.C_Int (0)
  Curry_Prelude.C_False -> Data.Curry_List.d_C_maximum
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_C_map d_C_maxVar x4 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x4 l cd cs)
    (d_C__case_1 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x4 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x4 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Dimacs.Types._case_1" [show x4, show x5] info)
  _ -> failCons cd (consFail "Dimacs.Types._case_1" (showCons x5))

