{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Data.Curry_Global
  ( C_GlobalT (..)
  , C_GlobalP (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Global_dot_GlobalP_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Global_dot_GlobalP_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Global_dot_GlobalP_hash_0_hash_hash
  , d_C_globalT
  , d_C_readGlobalT
  , d_C_writeGlobalT
  , d_C_globalP
  , nd_C_globalP
  , d_C_globalPersistent
  , nd_C_globalPersistent
  , d_C_readGlobalP
  , nd_C_readGlobalP
  , d_C_safeReadGlobalP
  , nd_C_safeReadGlobalP
  , d_C_writeGlobalP
  , nd_C_writeGlobalP )
  where

import Basics
import qualified Control.Curry_Monad
import qualified Curry_Prelude
import qualified System.Curry_Directory
import qualified System.Curry_IO
import qualified System.IO.Curry_Unsafe
import qualified System.Curry_IOExts

import Data.IORef
import System.IO
import System.IO.Unsafe

-- Implementation of Globals in Curry. We use Haskell's IORefs for temporary
-- globals where Curry values are stored in the IORefs

data C_GlobalP t0
  = C_GlobalP (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | Choice_C_GlobalP Cover ID (C_GlobalP t0) (C_GlobalP t0)
  | Choices_C_GlobalP Cover ID [C_GlobalP t0]
  | Fail_C_GlobalP Cover FailInfo
  | Guard_C_GlobalP Cover Constraints (C_GlobalP t0)

instance (Curry t0) => Show (C_GlobalP t0) where
  showsPrec d (Choice_C_GlobalP cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_GlobalP cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_GlobalP cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_GlobalP cd info) = showChar '!'
  showsPrec _ (C_GlobalP x1) = showString "(GlobalP" . (showChar ' ' . (shows
    x1 . showChar ')'))

instance (Curry t0) => Read (C_GlobalP t0) where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_GlobalP x1, r1) | (_, r0) <-
    readQualified "Data.Global" "GlobalP" r, (x1, r1) <- readsPrec 11 r0]) s

instance NonDet (C_GlobalP t0) where
  choiceCons = Choice_C_GlobalP
  choicesCons = Choices_C_GlobalP
  failCons = Fail_C_GlobalP
  guardCons = Guard_C_GlobalP
  try (Choice_C_GlobalP cd i x y) = tryChoice cd i x y
  try (Choices_C_GlobalP cd i xs) = tryChoices cd i xs
  try (Fail_C_GlobalP cd info) = Fail cd info
  try (Guard_C_GlobalP cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_GlobalP cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_GlobalP cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_GlobalP cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_GlobalP cd i _) = error
    ("Data.Global.GlobalP.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_GlobalP cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_GlobalP cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance (Curry t0) => Generable (C_GlobalP t0) where
  generate s c = Choices_C_GlobalP c (freeID [1] s) [C_GlobalP (generate
    (leftSupply s) c)]

instance (Curry t0) => NormalForm (C_GlobalP t0) where
  ($!!) cont (C_GlobalP x1) d cs = ($!!) (\y1 d cs -> cont (C_GlobalP y1) d cs)
    x1 d cs
  ($!!) cont (Choice_C_GlobalP cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_GlobalP cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_GlobalP cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_GlobalP cd info) _ _ = failCons cd info
  ($##) cont (C_GlobalP x1) d cs = ($##) (\y1 d cs -> cont (C_GlobalP y1) d cs)
    x1 d cs
  ($##) cont (Choice_C_GlobalP cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_GlobalP cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_GlobalP cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_GlobalP cd info) _ _ = failCons cd info
  showCons (C_GlobalP _) = "Data.Global.GlobalP _"
  showCons x = error ("Data.Global.GlobalP.showCons: no constructor: " ++ show
    x)
  searchNF search cont (C_GlobalP x1) = search (\y1 -> cont (C_GlobalP y1)) x1
  searchNF _ _ x = error ("Data.Global.GlobalP.searchNF: no constructor: " ++
    show x)

instance (Curry t0) => Unifiable (C_GlobalP t0) where
  (=.=) (C_GlobalP x1) (C_GlobalP y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_GlobalP x1) (C_GlobalP y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_GlobalP x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID i)
    x3]
  bind d i (Choice_C_GlobalP cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_GlobalP cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_GlobalP cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_GlobalP cd i _) = error
    ("Data.Global.GlobalP.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_GlobalP cd info) = [Unsolvable info]
  bind d i (Guard_C_GlobalP cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_GlobalP x3) = (i :=: ChooseN 0 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_GlobalP cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_GlobalP cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_GlobalP cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_GlobalP cd i _) = error
    ("Data.Global.GlobalP.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_GlobalP cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_GlobalP cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance (Curry t0) => Curry (C_GlobalP t0) where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Global_dot_GlobalP_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Unit -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data (C_GlobalP t0)
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Global_dot_GlobalP_hash_0_hash_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Global_dot_GlobalP_hash_0_hash_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Global_dot_GlobalP_hash_0_hash_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Global_dot_GlobalP_hash_0_hash_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Global_dot_GlobalP_hash_0_hash_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Global_dot_GlobalP_hash_0_hash_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Global_dot_GlobalP_hash_0_hash_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Global._inst#Prelude.Data#Data.Global.GlobalP#0##" [show x1] info)
  _ -> failCons cd (consFail
    "Data.Global._inst#Prelude.Data#Data.Global.GlobalP#0##" (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Global_dot_GlobalP_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => C_GlobalP t0 -> C_GlobalP t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Global_dot_GlobalP_hash_0_hash_hash x1 x2 s cd cs =
  case x1 of
  C_GlobalP x3 -> let s0 = s in s0 `seq` nd_C__case_3 x3 x2 s0 cd cs
  Choice_C_GlobalP d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Global_dot_GlobalP_hash_0_hash_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Global_dot_GlobalP_hash_0_hash_hash
    r x2 s cd cs)
  Choices_C_GlobalP d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Global_dot_GlobalP_hash_0_hash_hash
    z x2 s cd cs) xs
  Guard_C_GlobalP d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Global_dot_GlobalP_hash_0_hash_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_GlobalP d info -> failCons d (traceFail
    "Data.Global._impl#===#Prelude.Data#Data.Global.GlobalP#0##" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "Data.Global._impl#===#Prelude.Data#Data.Global.GlobalP#0##" (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Global_dot_GlobalP_hash_0_hash_hash :: IDSupply
  -> Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry t0) => C_GlobalP t0
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Global_dot_GlobalP_hash_0_hash_hash s cd cs =
  let s0 = s
  in s0 `seq` C_GlobalP
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)

d_C_globalT :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> t0 -> Cover -> ConstStore -> C_GlobalT t0
d_C_globalT x1 x2 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_dollar_hash_hash (acceptCs id d_C_prim_globalT) x1 cd cs)
  x2 cd cs

d_C_readGlobalT :: forall t0 . (Curry_Prelude.Curry t0) => C_GlobalT t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_IO t0
d_C_readGlobalT x1 cd cs = Curry_Prelude.d_OP_dollar_hash d_C_prim_readGlobalT
  x1 cd cs

d_C_writeGlobalT :: forall t0 . (Curry_Prelude.Curry t0) => C_GlobalT t0 -> t0
  -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_writeGlobalT x1 x2 cd cs = Curry_Prelude.d_OP_dollar_hash_hash
  (Curry_Prelude.d_OP_dollar_hash (acceptCs id d_C_prim_writeGlobalT) x1 cd cs)
  x2 cd cs

d_C_globalP :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> t0 -> Cover -> ConstStore -> C_GlobalP t0
d_C_globalP x1 x2 x3 x4 cd cs = Curry_Prelude.d_OP_dollar
  System.IO.Curry_Unsafe.d_C_unsafePerformIO (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_Directory.d_C_doesFileExist x3 cd cs) cd cs)
  (d_OP_globalP_dot_uscore_hash_lambda2 x4 x3 x2) cd cs) cd cs

nd_C_globalP :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> t0 -> IDSupply -> Cover
  -> ConstStore -> C_GlobalP t0
nd_C_globalP x1 x2 x3 x4 s cd cs = let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
  System.IO.Curry_Unsafe.nd_C_unsafePerformIO) (let s3 = leftSupply s4
                                                    s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (System.Curry_Directory.d_C_doesFileExist x3 cd cs) s1 cd cs))
  (wrapNX id (nd_OP_globalP_dot_uscore_hash_lambda2 x4 x3 x2)) s3 cd cs)) s5 cd
  cs))

d_OP_globalP_dot_uscore_hash_lambda2 :: forall t0 . (Curry_Prelude.Curry
  t0) => t0 -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (C_GlobalP t0)
d_OP_globalP_dot_uscore_hash_lambda2 x1 x2 x3 x4 cd cs = let x5 = x4
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar (Control.Curry_Monad.d_C_unless
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_Prelude_dot_IO_hash
  x5) (d_C_writeGlobalP x3 (C_GlobalP x2) x1 cd cs) cd cs) cd cs)
  (Curry_Prelude.d_OP_dollar
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (C_GlobalP x2) cd cs) cd cs

nd_OP_globalP_dot_uscore_hash_lambda2 :: forall t0 . (Curry_Prelude.Curry
  t0) => t0 -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (C_GlobalP t0)
nd_OP_globalP_dot_uscore_hash_lambda2 x1 x2 x3 x4 s cd cs = let s11 = s
  in s11 `seq` (let x5 = x4
  in let s10 = leftSupply s11
         s12 = rightSupply s11
         s5 = leftSupply s12
         s9 = rightSupply s12
  in s10 `seq` (s12 `seq` (s5 `seq` (s9 `seq` Curry_Prelude.nd_C_apply
  (let s4 = leftSupply s5
       s6 = rightSupply s5
       s0 = leftSupply s6
       s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (let s2 = leftSupply s3
                 s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
  (Control.Curry_Monad.nd_C_unless (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_Prelude_dot_IO_hash)
  x5)) (nd_C_writeGlobalP x3 (C_GlobalP x2) x1 s1 cd cs) s2 cd cs)) s4 cd cs))))
  (let s8 = leftSupply s9
       s7 = rightSupply s9
  in s8 `seq` (s7 `seq` Curry_Prelude.nd_OP_dollar
  (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s7 cd cs) (C_GlobalP x2) s8 cd cs)) s10 cd cs))))

d_C_globalPersistent :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> C_GlobalP t0
d_C_globalPersistent x1 x2 cd cs = acceptCs id (d_C_globalP x1 x2)

nd_C_globalPersistent :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> IDSupply
  -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Func t0 (C_GlobalP t0))
nd_C_globalPersistent x1 x2 s cd cs = wrapDX (wrapNX id) (acceptCs id
  (nd_C_globalP x1 x2))

d_C_readGlobalP :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> C_GlobalP t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_IO t0
d_C_readGlobalP x1 x2 cd cs = case x2 of
  C_GlobalP x3 -> Curry_Prelude.d_OP_dollar (System.Curry_IOExts.d_C_exclusiveIO
    (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.toCurryString ".LOCK") cd
    cs)) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_IO.d_C_openFile x3 System.Curry_IO.C_ReadMode cd cs) cd
    cs) System.Curry_IO.d_C_hGetContents cd cs) cd cs)
    (d_OP_readGlobalP_dot_uscore_hash_lambda5 x3 x1) cd cs) cd cs
  Choice_C_GlobalP d i l r -> narrow d i (d_C_readGlobalP x1 l cd cs)
    (d_C_readGlobalP x1 r cd cs)
  Choices_C_GlobalP d i xs -> narrows cs d i (\z -> d_C_readGlobalP x1 z cd cs)
    xs
  Guard_C_GlobalP d c e -> guardCons d c ((\x -> d_C_readGlobalP x1 e cd x) $!
    addCs c cs)
  Fail_C_GlobalP d info -> failCons d (traceFail "Data.Global.readGlobalP" [show
    x1, show x2] info)
  _ -> failCons cd (consFail "Data.Global.readGlobalP" (showCons x2))

nd_C_readGlobalP :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> C_GlobalP
  t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
nd_C_readGlobalP x1 x2 s cd cs = case x2 of
  C_GlobalP x3 -> let s12 = s
    in s12 `seq` (let s11 = leftSupply s12
                      s10 = rightSupply s12
    in s11 `seq` (s10 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    (System.Curry_IOExts.nd_C_exclusiveIO (Curry_Prelude.d_OP_plus_plus x3
    (Curry_Prelude.toCurryString ".LOCK") cd cs))) (let s9 = leftSupply s10
                                                        s7 = rightSupply s10
    in s9 `seq` (s7 `seq` Curry_Prelude.nd_C_apply (let s6 = leftSupply s7
                                                        s8 = rightSupply s7
                                                        s0 = leftSupply s8
                                                        s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s0 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    s0 cd cs) (let s4 = leftSupply s5
                   s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                        s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    s1 cd cs) (System.Curry_IO.d_C_openFile x3 System.Curry_IO.C_ReadMode cd cs)
    s2 cd cs)) (wrapDX id System.Curry_IO.d_C_hGetContents) s4 cd cs)) s6 cd
    cs)))) (wrapNX id (nd_OP_readGlobalP_dot_uscore_hash_lambda5 x3 x1)) s9 cd
    cs)) s11 cd cs))
  Choice_C_GlobalP d i l r -> narrow d i (nd_C_readGlobalP x1 l s cd cs)
    (nd_C_readGlobalP x1 r s cd cs)
  Choices_C_GlobalP d i xs -> narrows cs d i (\z -> nd_C_readGlobalP x1 z s cd
    cs) xs
  Guard_C_GlobalP d c e -> guardCons d c ((\x -> nd_C_readGlobalP x1 e s cd
    x) $! addCs c cs)
  Fail_C_GlobalP d info -> failCons d (traceFail "Data.Global.readGlobalP" [show
    x1, show x2] info)
  _ -> failCons cd (consFail "Data.Global.readGlobalP" (showCons x2))

d_OP_readGlobalP_dot_uscore_hash_lambda5 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO t0
d_OP_readGlobalP_dot_uscore_hash_lambda5 x1 x2 x3 cd cs = let x4 = x3
  in d_C__case_2 x4 x2 x1 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_reads x2
  cd cs) x4 cd cs) cd cs

nd_OP_readGlobalP_dot_uscore_hash_lambda5 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO t0
nd_OP_readGlobalP_dot_uscore_hash_lambda5 x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let x4 = x3
  in let s3 = leftSupply s4
         s2 = rightSupply s4
  in s3 `seq` (s2 `seq` nd_C__case_2 x4 x2 x1 (let s1 = leftSupply s2
                                                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_reads x2 s0
  cd cs) x4 s1 cd cs)) s3 cd cs))

d_C_safeReadGlobalP :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> C_GlobalP t0 -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
d_C_safeReadGlobalP x1 x2 x3 x4 cd cs = Curry_Prelude.d_C_catch (d_C_readGlobalP
  x1 x3 cd cs) (d_OP_safeReadGlobalP_dot_uscore_hash_lambda8 x4 x3 x2) cd cs

nd_C_safeReadGlobalP :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> C_GlobalP
  t0 -> t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
nd_C_safeReadGlobalP x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_catch (nd_C_readGlobalP x1 x3 s0 cd
  cs) (wrapNX id (nd_OP_safeReadGlobalP_dot_uscore_hash_lambda8 x4 x3 x2)) s1 cd
  cs))

d_OP_safeReadGlobalP_dot_uscore_hash_lambda8 :: forall t0 . (Curry_Prelude.Curry
  t0) => t0 -> C_GlobalP t0 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.C_IOError
  -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
d_OP_safeReadGlobalP_dot_uscore_hash_lambda8 x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar (System.Curry_IO.d_C_hPutStrLn
  (System.Curry_IO.d_C_stderr cd cs)) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "Error caught in 'safeReadGlobalP':\n")
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_IOError_hash
  x4 cd cs) cd cs) cd cs) cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_writeGlobalP x3 x2 x1 cd cs) cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) x1 cd cs) cd cs) cd cs

nd_OP_safeReadGlobalP_dot_uscore_hash_lambda8 :: forall t0 . (Curry_Prelude.Curry
  t0) => t0 -> C_GlobalP t0 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.C_IOError
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
nd_OP_safeReadGlobalP_dot_uscore_hash_lambda8 x1 x2 x3 x4 s cd cs = let s17 = s
  in s17 `seq` (let s16 = leftSupply s17
                    s18 = rightSupply s17
                    s3 = leftSupply s18
                    s14 = rightSupply s18
  in s16 `seq` (s18 `seq` (s3 `seq` (s14 `seq` Curry_Prelude.nd_C_apply
  (let s2 = leftSupply s3
       s4 = rightSupply s3
       s0 = leftSupply s4
       s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (Curry_Prelude.nd_OP_dollar (wrapDX id
  (System.Curry_IO.d_C_hPutStrLn (System.Curry_IO.d_C_stderr cd cs)))
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Error caught in 'safeReadGlobalP':\n")
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_IOError_hash
  x4 cd cs) cd cs) s1 cd cs) s2 cd cs)))) (let s13 = leftSupply s14
                                               s15 = rightSupply s14
                                               s8 = leftSupply s15
                                               s12 = rightSupply s15
  in s13 `seq` (s15 `seq` (s8 `seq` (s12 `seq` Curry_Prelude.nd_C_apply
  (let s7 = leftSupply s8
       s9 = rightSupply s8
       s5 = leftSupply s9
       s6 = rightSupply s9
  in s7 `seq` (s9 `seq` (s5 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s5 cd cs) (nd_C_writeGlobalP x3 x2 x1 s6 cd cs) s7 cd cs))))
  (let s11 = leftSupply s12
       s10 = rightSupply s12
  in s11 `seq` (s10 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s10 cd cs) x1 s11 cd cs)) s13 cd cs)))) s16 cd cs))))

d_C_writeGlobalP :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> C_GlobalP t0 -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_writeGlobalP x1 x2 x3 cd cs = case x2 of
  C_GlobalP x4 -> Curry_Prelude.d_OP_dollar (System.Curry_IOExts.d_C_exclusiveIO
    (Curry_Prelude.d_OP_plus_plus x4 (Curry_Prelude.toCurryString ".LOCK") cd
    cs)) (Curry_Prelude.d_C_writeFile x4 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_show x1 cd cs) x3 cd cs)
    (Curry_Prelude.toCurryString "\n") cd cs) cd cs) cd cs
  Choice_C_GlobalP d i l r -> narrow d i (d_C_writeGlobalP x1 l x3 cd cs)
    (d_C_writeGlobalP x1 r x3 cd cs)
  Choices_C_GlobalP d i xs -> narrows cs d i (\z -> d_C_writeGlobalP x1 z x3 cd
    cs) xs
  Guard_C_GlobalP d c e -> guardCons d c ((\x -> d_C_writeGlobalP x1 e x3 cd
    x) $! addCs c cs)
  Fail_C_GlobalP d info -> failCons d (traceFail "Data.Global.writeGlobalP"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Global.writeGlobalP" (showCons x2))

nd_C_writeGlobalP :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> C_GlobalP
  t0 -> t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
nd_C_writeGlobalP x1 x2 x3 s cd cs = case x2 of
  C_GlobalP x4 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    (System.Curry_IOExts.nd_C_exclusiveIO (Curry_Prelude.d_OP_plus_plus x4
    (Curry_Prelude.toCurryString ".LOCK") cd cs))) (Curry_Prelude.d_C_writeFile
    x4 (Curry_Prelude.d_OP_plus_plus (let s1 = leftSupply s2
                                          s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x1
    s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "\n") cd cs) cd cs) s3
    cd cs))
  Choice_C_GlobalP d i l r -> narrow d i (nd_C_writeGlobalP x1 l x3 s cd cs)
    (nd_C_writeGlobalP x1 r x3 s cd cs)
  Choices_C_GlobalP d i xs -> narrows cs d i (\z -> nd_C_writeGlobalP x1 z x3 s
    cd cs) xs
  Guard_C_GlobalP d c e -> guardCons d c ((\x -> nd_C_writeGlobalP x1 e x3 s cd
    x) $! addCs c cs)
  Fail_C_GlobalP d info -> failCons d (traceFail "Data.Global.writeGlobalP"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Global.writeGlobalP" (showCons x2))

d_C_prim_globalT :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> t0 -> Cover -> ConstStore
  -> C_GlobalT t0
d_C_prim_globalT x1 x2 cd cs = external_d_C_prim_globalT x1 x2 cd cs

d_C_prim_readGlobalT :: forall t0 . (Curry_Prelude.Curry t0) => C_GlobalT t0
  -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
d_C_prim_readGlobalT x1 cd cs = external_d_C_prim_readGlobalT x1 cd cs

d_C_prim_writeGlobalT :: forall t0 . (Curry_Prelude.Curry t0) => C_GlobalT t0
  -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_prim_writeGlobalT x1 x2 cd cs = external_d_C_prim_writeGlobalT x1 x2 cd cs

nd_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_GlobalP t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_3 x3 x2 s cd cs = case x2 of
  C_GlobalP x4 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x4 s0 cd cs
  Choice_C_GlobalP d i l r -> narrow d i (nd_C__case_3 x3 l s cd cs)
    (nd_C__case_3 x3 r s cd cs)
  Choices_C_GlobalP d i xs -> narrows cs d i (\z -> nd_C__case_3 x3 z s cd cs)
    xs
  Guard_C_GlobalP d c e -> guardCons d c ((\x -> nd_C__case_3 x3 e s cd x) $!
    addCs c cs)
  Fail_C_GlobalP d info -> failCons d (traceFail "Data.Global._case_3" [show x3
    , show x2] info)
  _ -> failCons cd (consFail "Data.Global._case_3" (showCons x2))

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO t0
d_C__case_2 x4 x2 x1 x7 cd cs = case x7 of
  Curry_Prelude.OP_Cons x5 x6 -> d_C__case_1 x6 x4 x1 x5 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_error
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "Cannot read persistent global entity in file: ")
    (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\nFile contents:\n") x4 cd cs) cd cs) cd cs)
    cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_2 x4 x2 x1 l cd
    cs) (d_C__case_2 x4 x2 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_2 x4
    x2 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_2 x4 x2
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.Global._case_2" [show x4, show x2, show x1, show x7] info)
  _ -> failCons cd (consFail "Data.Global._case_2" (showCons x7))

nd_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO t0
nd_C__case_2 x4 x2 x1 x7 s cd cs = case x7 of
  Curry_Prelude.OP_Cons x5 x6 -> d_C__case_1 x6 x4 x1 x5 cd cs
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id Curry_Prelude.d_C_error)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "Cannot read persistent global entity in file: ")
    (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\nFile contents:\n") x4 cd cs) cd cs) cd cs)
    s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_2 x4 x2 x1 l s
    cd cs) (nd_C__case_2 x4 x2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_2 x4
    x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_2 x4 x2
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.Global._case_2" [show x4, show x2, show x1, show x7] info)
  _ -> failCons cd (consFail "Data.Global._case_2" (showCons x7))

d_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
d_C__case_1 x6 x4 x1 x5 cd cs = case x5 of
  Curry_Prelude.OP_Tuple2 x7 x8 -> d_C__case_0 x4 x1 x7 x6 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_1 x6 x4 x1 l
    cd cs) (d_C__case_1 x6 x4 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_1 x6
    x4 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_1 x6 x4
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Global._case_1" [show x6, show x4, show x1, show x5] info)
  _ -> failCons cd (consFail "Data.Global._case_1" (showCons x5))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> t0
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO t0
d_C__case_0 x4 x1 x7 x6 cd cs = case x6 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) x7 cd cs
  Curry_Prelude.OP_Cons x9 x10 -> Curry_Prelude.d_OP_dollar
    Curry_Prelude.d_C_error (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString
    "Cannot read persistent global entity in file: ")
    (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\nFile contents:\n") x4 cd cs) cd cs) cd cs)
    cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_0 x4 x1 x7 l cd
    cs) (d_C__case_0 x4 x1 x7 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_0 x4
    x1 x7 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_0 x4 x1
    x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.Global._case_0" [show x4, show x1, show x7, show x6] info)
  _ -> failCons cd (consFail "Data.Global._case_0" (showCons x6))

data C_GlobalT a
     = Choice_C_GlobalT Cover ID (C_GlobalT a) (C_GlobalT a)
     | Choices_C_GlobalT Cover ID ([C_GlobalT a])
     | Fail_C_GlobalT Cover FailInfo
     | Guard_C_GlobalT Cover Constraints (C_GlobalT a)
     | C_GlobalT (IORef a)    -- a temporary global with a given (unique) name

instance Show (C_GlobalT a) where
  show = error "ERROR: no show for GlobalT"

instance Read (C_GlobalT a) where
  readsPrec = error "ERROR: no read for GlobalT"

instance NonDet (C_GlobalT a) where
  choiceCons = Choice_C_GlobalT
  choicesCons = Choices_C_GlobalT
  failCons = Fail_C_GlobalT
  guardCons = Guard_C_GlobalT
  try (Choice_C_GlobalT cd i x y) = tryChoice cd i x y
  try (Choices_C_GlobalT cd i xs) = tryChoices cd i xs
  try (Fail_C_GlobalT cd info) = Fail cd info
  try (Guard_C_GlobalT cd c e) = Guard cd c e
  try x = Val x
  match choiceF _ _ _ _ _ (Choice_C_GlobalT cd i x y) = choiceF cd i x y
  match _ narrF _ _ _ _   (Choices_C_GlobalT cd i@(NarrowedID _ _) xs)
   = narrF cd i xs
  match _ _ freeF _ _ _   (Choices_C_GlobalT cd i@(FreeID _ _) xs)
   = freeF cd i xs
  match _ _ _ failF _ _   (Fail_C_GlobalT cd info) = failF cd info
  match _ _ _ _ guardF _  (Guard_C_GlobalT cd c e) = guardF cd c e
  match _ _ _ _ _ valF    x                    = valF x

instance Generable (C_GlobalT a) where
  generate _ _ = error "ERROR: no generator for Global"

instance NormalForm (C_GlobalT a) where
  ($!!) cont g@(C_GlobalT _)             cd cs = cont g cd cs
  ($!!) cont (Choice_C_GlobalT d i g1 g2) cd cs = nfChoice cont d i g1 g2 cd cs
  ($!!) cont (Choices_C_GlobalT d i gs)   cd cs = nfChoices cont d i gs cd cs
  ($!!) cont (Guard_C_GlobalT d c g)      cd cs = guardCons d c ((cont $!! g) cd
                                                    $! (addCs c cs))
  ($!!) _    (Fail_C_GlobalT d info)      _  _  = failCons d info
  ($##) cont g@(C_GlobalT _)             cd cs = cont g cd cs
  ($##) cont (Choice_C_GlobalT d i g1 g2) cd cs = gnfChoice cont d i g1 g2 cd cs
  ($##) cont (Choices_C_GlobalT d i gs)   cd cs = gnfChoices cont d i gs cd cs
  ($##) cont (Guard_C_GlobalT d c g)      cd cs = guardCons d c ((cont $## g) cd
                                                    $!  (addCs c cs))
  ($##) _    (Fail_C_GlobalT cd info)     _  _  = failCons cd info
  searchNF _ cont g@(C_GlobalT _)              = cont g

instance Unifiable (C_GlobalT a) where
  (=.=) (C_GlobalT f1) (C_GlobalT f2) _ _
    | f1 == f2  = C_True
  (=.=) _ _ cd _ = Fail_C_Bool cd defFailInfo
  (=.<=) = (=.=)
  bind cd i (Choice_C_GlobalT d j l r)
    = [(ConstraintChoice d j (bind cd i l) (bind cd i r))]
  bind cd i (Choices_C_GlobalT d j@(FreeID _ _) xs) = bindOrNarrow cd i d j xs
  bind cd i (Choices_C_GlobalT d j@(NarrowedID _ _) xs)
    = [(ConstraintChoices d j (map (bind cd i) xs))]
  bind _ _ (Fail_C_GlobalT _ info) = [Unsolvable info]
  bind cd i (Guard_C_GlobalT _ cs e) = (getConstrList cs) ++ (bind cd i e)
  lazyBind cd i (Choice_C_GlobalT d j l r)
    = [(ConstraintChoice d j (lazyBind cd i l) (lazyBind cd i r))]
  lazyBind cd i (Choices_C_GlobalT d j@(FreeID _ _) xs) = lazyBindOrNarrow cd i d j xs
  lazyBind cd i (Choices_C_GlobalT d j@(NarrowedID _ _) xs)
    = [(ConstraintChoices d j (map (lazyBind cd i) xs))]
  lazyBind _ _ (Fail_C_GlobalT cd info) = [Unsolvable info]
  lazyBind cd i (Guard_C_GlobalT _ cs e)
    = (getConstrList cs) ++ [(i :=: (LazyBind (lazyBind cd i e)))]

instance Curry_Prelude.Curry a => Curry_Prelude.Curry (C_GlobalT a)


external_d_C_prim_globalT :: Curry_Prelude.Curry a =>
     Curry_Prelude.OP_List Curry_Prelude.C_Char -> a -> Cover -> ConstStore
                    -> C_GlobalT a
external_d_C_prim_globalT _ val _ _ = ref `seq` (C_GlobalT ref)
  where ref = unsafePerformIO (newIORef val)

external_d_C_prim_readGlobalT :: Curry_Prelude.Curry a => C_GlobalT a -> Cover -> ConstStore
                             -> Curry_Prelude.C_IO a
external_d_C_prim_readGlobalT (C_GlobalT ref) _ _ = fromIO (readIORef ref)

external_d_C_prim_writeGlobalT :: Curry_Prelude.Curry a => C_GlobalT a -> a
                               -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
external_d_C_prim_writeGlobalT (C_GlobalT ref) val _ _ =
  toCurry (writeIORef ref val)
