{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Control.Monad.Curry_Extra
  ( d_C_concatMapM, nd_C_concatMapM, d_C_mapAccumM, nd_C_mapAccumM )
  where

import Basics
import qualified Curry_Prelude


d_C_concatMapM :: forall t0 t1 t2 . (forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t0 x0), Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t2) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Monad t0) -> (t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Apply t0 (Curry_Prelude.OP_List t2))
  -> Curry_Prelude.OP_List t1 -> Cover -> ConstStore -> Curry_Prelude.C_Apply t0
  (Curry_Prelude.OP_List t2)
d_C_concatMapM x1 x2 x3 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_lt_dollar_gt
  (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Applicative_hash_Prelude_dot_Functor_hash_0_hash
  (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Monad_hash_Prelude_dot_Applicative_hash_0_hash
  x1 cd cs) cd cs) cd cs) (Curry_Prelude.d_C_concat cd cs) cd cs)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_mapM x1 x2 cd cs) x3 cd cs) cd cs

nd_C_concatMapM :: forall t0 t1 t2 . (forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t0 x0), Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t2) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Monad t0) -> Func t1 (Curry_Prelude.C_Apply
  t0 (Curry_Prelude.OP_List t2)) -> Curry_Prelude.OP_List t1 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Apply t0 (Curry_Prelude.OP_List t2)
nd_C_concatMapM x1 x2 x3 s cd cs = let s13 = s
  in s13 `seq` (let s12 = leftSupply s13
                    s14 = rightSupply s13
                    s7 = leftSupply s14
                    s11 = rightSupply s14
  in s12 `seq` (s14 `seq` (s7 `seq` (s11 `seq` Curry_Prelude.nd_C_apply
  (let s6 = leftSupply s7
       s8 = rightSupply s7
       s4 = leftSupply s8
       s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s4 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
  (let s3 = leftSupply s4
       s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_lt_dollar_gt (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq`
  Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Applicative_hash_Prelude_dot_Functor_hash_0_hash
  (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Monad_hash_Prelude_dot_Applicative_hash_0_hash
  x1 s0 cd cs) s1 cd cs)) s3 cd cs)) (Curry_Prelude.nd_C_concat s5 cd cs) s6 cd
  cs)))) (let s10 = leftSupply s11
              s9 = rightSupply s11
  in s10 `seq` (s9 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_mapM x1 x2
  s9 cd cs) x3 s10 cd cs)) s12 cd cs))))

d_C_mapAccumM :: forall t0 t1 t2 t3 . (forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t0 x0), Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t3, Curry_Prelude.Curry t2) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Monad t0) -> (t1
  -> Cover -> ConstStore -> t3 -> Cover -> ConstStore -> Curry_Prelude.C_Apply
  t0 (Curry_Prelude.OP_Tuple2 t1 t2)) -> t1 -> Curry_Prelude.OP_List t3 -> Cover
  -> ConstStore -> Curry_Prelude.C_Apply t0 (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List t2))
d_C_mapAccumM x1 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_return x1
    cd cs) (Curry_Prelude.OP_Tuple2 x3 Curry_Prelude.OP_List) cd cs
  Curry_Prelude.OP_Cons x5 x6 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_gt_gt_eq x1 cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x2 x3 cd cs) x5 cd cs) cd
    cs) (d_OP_mapAccumM_dot_uscore_hash_lambda1 x6 x1 x2) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_mapAccumM x1 x2 x3 l
    cd cs) (d_C_mapAccumM x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_mapAccumM x1
    x2 x3 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_mapAccumM x1 x2
    x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Control.Monad.Extra.mapAccumM" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Control.Monad.Extra.mapAccumM" (showCons x4))

nd_C_mapAccumM :: forall t0 t1 t2 t3 . (forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t0 x0), Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t3, Curry_Prelude.Curry t2) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Monad t0) -> Func t1
  (Func t3 (Curry_Prelude.C_Apply t0 (Curry_Prelude.OP_Tuple2 t1 t2))) -> t1
  -> Curry_Prelude.OP_List t3 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Apply t0 (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  t2))
nd_C_mapAccumM x1 x2 x3 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_return x1
    s0 cd cs) (Curry_Prelude.OP_Tuple2 x3 Curry_Prelude.OP_List) s1 cd cs))
  Curry_Prelude.OP_Cons x5 x6 -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s5 = rightSupply s8
    in s7 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                        s6 = rightSupply s5
                                                        s0 = leftSupply s6
                                                        s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_gt_gt_eq x1 s0 cd cs) (let s2 = leftSupply s3
                                                    s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2
    x3 s1 cd cs) x5 s2 cd cs)) s4 cd cs)))) (wrapNX id
    (nd_OP_mapAccumM_dot_uscore_hash_lambda1 x6 x1 x2)) s7 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_mapAccumM x1 x2 x3 l
    s cd cs) (nd_C_mapAccumM x1 x2 x3 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_mapAccumM
    x1 x2 x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_mapAccumM x1
    x2 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Control.Monad.Extra.mapAccumM" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Control.Monad.Extra.mapAccumM" (showCons x4))

d_OP_mapAccumM_dot_uscore_hash_lambda1 :: forall t0 t1 t2
  t3 . (Curry_Prelude.Curry t3, forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t0 x0), Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t2) => Curry_Prelude.OP_List t3
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Monad t0) -> (t1 -> Cover -> ConstStore
  -> t3 -> Cover -> ConstStore -> Curry_Prelude.C_Apply t0
  (Curry_Prelude.OP_Tuple2 t1 t2)) -> Curry_Prelude.OP_Tuple2 t1 t2 -> Cover
  -> ConstStore -> Curry_Prelude.C_Apply t0 (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List t2))
d_OP_mapAccumM_dot_uscore_hash_lambda1 x1 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_gt_gt_eq x2 cd cs)
    (d_C_mapAccumM x2 x3 x5 x1 cd cs) cd cs)
    (d_OP_mapAccumM_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x6 x2) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_mapAccumM_dot_uscore_hash_lambda1 x1 x2 x3 l cd cs)
    (d_OP_mapAccumM_dot_uscore_hash_lambda1 x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_mapAccumM_dot_uscore_hash_lambda1 x1 x2 x3 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_mapAccumM_dot_uscore_hash_lambda1 x1 x2 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Control.Monad.Extra.mapAccumM._#lambda1" [show x1, show x2, show x3, show
    x4] info)
  _ -> failCons cd (consFail "Control.Monad.Extra.mapAccumM._#lambda1" (showCons
    x4))

nd_OP_mapAccumM_dot_uscore_hash_lambda1 :: forall t0 t1 t2
  t3 . (Curry_Prelude.Curry t3, forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t0 x0), Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t2) => Curry_Prelude.OP_List t3 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Monad t0) -> Func t1
  (Func t3 (Curry_Prelude.C_Apply t0 (Curry_Prelude.OP_Tuple2 t1 t2)))
  -> Curry_Prelude.OP_Tuple2 t1 t2 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Apply t0 (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  t2))
nd_OP_mapAccumM_dot_uscore_hash_lambda1 x1 x2 x3 x4 s cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s3 = rightSupply s6
    in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_gt_gt_eq x2 s0 cd cs) (nd_C_mapAccumM x2 x3 x5 x1 s1 cd
    cs) s2 cd cs)))) (wrapNX id
    (nd_OP_mapAccumM_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x6 x2)) s5
    cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_mapAccumM_dot_uscore_hash_lambda1 x1 x2 x3 l s cd cs)
    (nd_OP_mapAccumM_dot_uscore_hash_lambda1 x1 x2 x3 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_mapAccumM_dot_uscore_hash_lambda1 x1 x2 x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_mapAccumM_dot_uscore_hash_lambda1 x1 x2 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Control.Monad.Extra.mapAccumM._#lambda1" [show x1, show x2, show x3, show
    x4] info)
  _ -> failCons cd (consFail "Control.Monad.Extra.mapAccumM._#lambda1" (showCons
    x4))

d_OP_mapAccumM_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t2, forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t0 x0), Curry_Prelude.Curry
  t1) => t2 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Monad t0) -> Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List t2) -> Cover -> ConstStore -> Curry_Prelude.C_Apply t0
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List t2))
d_OP_mapAccumM_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 x3 cd cs =
  case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_return x2 cd cs) (Curry_Prelude.OP_Tuple2 x4
    (Curry_Prelude.OP_Cons x1 x5)) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_mapAccumM_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 l cd
    cs) (d_OP_mapAccumM_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_mapAccumM_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 z cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_mapAccumM_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Control.Monad.Extra.mapAccumM._#lambda1._#lambda2" [show x1, show x2, show
    x3] info)
  _ -> failCons cd (consFail "Control.Monad.Extra.mapAccumM._#lambda1._#lambda2"
    (showCons x3))

nd_OP_mapAccumM_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t2, forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t0 x0), Curry_Prelude.Curry
  t1) => t2 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Monad t0) -> Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List t2) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Apply t0 (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  t2))
nd_OP_mapAccumM_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 x3 s cd cs =
  case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_return x2
    s0 cd cs) (Curry_Prelude.OP_Tuple2 x4 (Curry_Prelude.OP_Cons x1 x5)) s1 cd
    cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_mapAccumM_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 l s
    cd cs) (nd_OP_mapAccumM_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1
    x2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_mapAccumM_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 z s cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_mapAccumM_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Control.Monad.Extra.mapAccumM._#lambda1._#lambda2" [show x1, show x2, show
    x3] info)
  _ -> failCons cd (consFail "Control.Monad.Extra.mapAccumM._#lambda1._#lambda2"
    (showCons x3))

