{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_Parser
  ( nd_OP_lt_bar_gt
  , nd_OP_lt_bar_bar_gt
  , nd_OP_lt_star_gt
  , nd_OP_gt_gt_gt
  , d_C_empty
  , d_C_terminal
  , nd_C_terminal
  , d_C_satisfy
  , nd_C_satisfy
  , nd_C_star
  , nd_C_some )
  where

import Basics
import qualified Curry_Prelude


nd_OP_lt_bar_gt :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0) -> Func
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0) -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0)
nd_OP_lt_bar_gt x1 x2 s cd cs = wrapNX id
  (nd_OP_lt_bar_gt_dot_uscore_hash_lambda1 x1 x2)

nd_OP_lt_bar_gt_dot_uscore_hash_lambda1 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0) -> Func
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0) -> Curry_Prelude.OP_List
  t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_OP_lt_bar_gt_dot_uscore_hash_lambda1 x1 x2 x3 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_OP_qmark
  (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs) (Curry_Prelude.nd_C_apply x2 x3 s1
  cd cs) s2 cd cs))))

nd_OP_lt_bar_bar_gt :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func t1 (Func (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0)) -> Func t1 (Func (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0)) -> IDSupply -> Cover -> ConstStore -> Func t1
  (Func (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0))
nd_OP_lt_bar_bar_gt x1 x2 s cd cs = wrapNX id
  (nd_OP_lt_bar_bar_gt_dot_uscore_hash_lambda2 x1 x2)

nd_OP_lt_bar_bar_gt_dot_uscore_hash_lambda2 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func t1 (Func
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0)) -> Func t1 (Func
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0)) -> t1 -> IDSupply
  -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0)
nd_OP_lt_bar_bar_gt_dot_uscore_hash_lambda2 x1 x2 x3 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` nd_OP_lt_bar_gt
  (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs) (Curry_Prelude.nd_C_apply x2 x3 s1
  cd cs) s2 cd cs))))

nd_OP_lt_star_gt :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0) -> Func
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0) -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0)
nd_OP_lt_star_gt x1 x2 x3 s cd cs = wrapNX id (nd_OP_lt_star_gt_dot_seq_dot_8 x2
  x3)

nd_OP_lt_star_gt_dot_seq_dot_8 :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0) -> Func
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0) -> Curry_Prelude.OP_List
  t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_OP_lt_star_gt_dot_seq_dot_8 x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s0 = leftSupply s4
                   s3 = rightSupply s4
  in s0 `seq` (s3 `seq` (let x4 = generate s0 cd
  in let s2 = leftSupply s3
         s1 = rightSupply s3
  in s2 `seq` (s1 `seq` nd_C__case_3 x4 x3 x1 x2 (Curry_Prelude.d_OP_eq_colon_eq
  (Curry_Prelude.nd_C_apply x1 x3 s1 cd cs) x4 cd cs) s2 cd cs))))

nd_OP_gt_gt_gt :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Func (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List t1) -> t0
  -> IDSupply -> Cover -> ConstStore -> Func t0 (Func (Curry_Prelude.OP_List t1)
  (Curry_Prelude.OP_List t1))
nd_OP_gt_gt_gt x1 x2 x3 x4 s cd cs = wrapDX (wrapNX id) (acceptCs id
  (nd_OP_gt_gt_gt_dot_attach_dot_12 x4 x3))

nd_OP_gt_gt_gt_dot_attach_dot_12 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => t0 -> Func (Curry_Prelude.OP_List t1)
  (Curry_Prelude.OP_List t1) -> t0 -> Curry_Prelude.OP_List t1 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t1
nd_OP_gt_gt_gt_dot_attach_dot_12 x1 x2 x3 x4 s cd cs = let s4 = s
  in s4 `seq` (let s0 = leftSupply s4
                   s3 = rightSupply s4
  in s0 `seq` (s3 `seq` (let x5 = generate s0 cd
  in let s2 = leftSupply s3
         s1 = rightSupply s3
  in s2 `seq` (s1 `seq` nd_C__case_2 x3 x1 x5 x4 x2 (Curry_Prelude.d_OP_amp_gt
  (Curry_Prelude.d_OP_eq_colon_eq (Curry_Prelude.nd_C_apply x2 x4 s1 cd cs) x5
  cd cs) (Curry_Prelude.d_OP_eq_colon_eq x1 x3 cd cs) cd cs) s2 cd cs))))

d_C_empty :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_empty x1 cd cs = x1

d_C_terminal :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_terminal x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_1 x4 x2 x5
    (Curry_Prelude.d_OP_eq_colon_eq x2 x4 cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_terminal x1 x2 l cd
    cs) (d_C_terminal x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_terminal x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_terminal x1 x2
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Parser.terminal"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Parser.terminal" (showCons x3))

nd_C_terminal :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C_terminal x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_1 x4 x2 x5
    (Curry_Prelude.d_OP_eq_colon_eq x2 x4 cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_terminal x1 x2 l s cd
    cs) (nd_C_terminal x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_terminal x1
    x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_terminal x1 x2
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Parser.terminal"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Parser.terminal" (showCons x3))

d_C_satisfy :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> (t0
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool) -> t0 -> Curry_Prelude.OP_List
  t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_satisfy x1 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.OP_Cons x5 x6 -> d_C__case_0 x5 x3 x2 x6 (Curry_Prelude.d_OP_amp
    (Curry_Prelude.d_OP_eq_colon_eq (Curry_Prelude.d_C_apply x2 x5 cd cs)
    Curry_Prelude.C_True cd cs) (Curry_Prelude.d_OP_eq_colon_eq x3 x5 cd cs) cd
    cs) cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_satisfy x1 x2 x3 l cd
    cs) (d_C_satisfy x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_satisfy x1
    x2 x3 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_satisfy x1 x2
    x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Parser.satisfy"
    [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Parser.satisfy" (showCons x4))

nd_C_satisfy :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func t0
  Curry_Prelude.C_Bool -> t0 -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_satisfy x1 x2 x3 x4 s cd cs = case x4 of
  Curry_Prelude.OP_Cons x5 x6 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_0 x5 x3 x2 x6 (Curry_Prelude.d_OP_amp
    (Curry_Prelude.d_OP_eq_colon_eq (Curry_Prelude.nd_C_apply x2 x5 s0 cd cs)
    Curry_Prelude.C_True cd cs) (Curry_Prelude.d_OP_eq_colon_eq x3 x5 cd cs) cd
    cs) s1 cd cs))
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_satisfy x1 x2 x3 l s
    cd cs) (nd_C_satisfy x1 x2 x3 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_satisfy x1
    x2 x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_satisfy x1 x2
    x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Parser.satisfy"
    [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Parser.satisfy" (showCons x4))

nd_C_star :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Func t0 (Func (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List t1))
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List t0) (Func
  (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List t1))
nd_C_star x1 x2 x3 s cd cs = let s15 = s
  in s15 `seq` (let s0 = leftSupply s15
                    s16 = rightSupply s15
                    s1 = leftSupply s16
                    s13 = rightSupply s16
  in s0 `seq` (s16 `seq` (s1 `seq` (s13 `seq` (let x4 = generate s0 cd
                                                   x5 = generate s1 cd
  in let s12 = leftSupply s13
         s14 = rightSupply s13
         s10 = leftSupply s14
         s11 = rightSupply s14
  in s12 `seq` (s14 `seq` (s10 `seq` (s11 `seq` nd_OP_lt_bar_bar_gt
  (let s9 = leftSupply s10
       s7 = rightSupply s10
  in s9 `seq` (s7 `seq` nd_OP_gt_gt_gt x1 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  x2)) (let s6 = leftSupply s7
            s8 = rightSupply s7
            s2 = leftSupply s8
            s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s2 `seq` (s5 `seq` nd_OP_lt_star_gt x1
  (Curry_Prelude.nd_C_apply x3 x4 s2 cd cs) (let s4 = leftSupply s5
                                                 s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (nd_C_star x1 x2 x3 s3 cd cs)
  x5 s4 cd cs)) s6 cd cs)))) (Curry_Prelude.OP_Cons x4 x5) s9 cd cs))
  (nd_OP_gt_gt_gt x1 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  x2)) (wrapDX id d_C_empty) Curry_Prelude.OP_List s11 cd cs) s12 cd cs))))))))

nd_C_some :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t1)
  -> Func t1 (Func (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0))
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List t1) (Func
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0))
nd_C_some x1 x2 x3 s cd cs = let s11 = s
  in s11 `seq` (let s0 = leftSupply s11
                    s12 = rightSupply s11
                    s1 = leftSupply s12
                    s10 = rightSupply s12
  in s0 `seq` (s12 `seq` (s1 `seq` (s10 `seq` (let x4 = generate s0 cd
                                                   x5 = generate s1 cd
  in let s9 = leftSupply s10
         s7 = rightSupply s10
  in s9 `seq` (s7 `seq` nd_OP_gt_gt_gt x1 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  x2)) (let s6 = leftSupply s7
            s8 = rightSupply s7
            s2 = leftSupply s8
            s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s2 `seq` (s5 `seq` nd_OP_lt_star_gt x1
  (Curry_Prelude.nd_C_apply x3 x4 s2 cd cs) (let s4 = leftSupply s5
                                                 s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (nd_C_star x1 x2 x3 s3 cd cs)
  x5 s4 cd cs)) s6 cd cs)))) (Curry_Prelude.OP_Cons x4 x5) s9 cd cs))))))

d_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> (Curry_Prelude.OP_List t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0) -> (Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_3 x4 x3 x1 x2 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply x2 x4 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x4 x3 x1 x2 l
    cd cs) (d_C__case_3 x4 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x4 x3
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x4 x3 x1
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Parser._case_3"
    [show x4, show x3, show x1, show x2, show x5] info)
  _ -> failCons cd (consFail "Parser._case_3" (showCons x5))

nd_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Func (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0) -> Func (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
nd_C__case_3 x4 x3 x1 x2 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x2 x4 s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_3 x4 x3 x1 x2 l
    s cd cs) (nd_C__case_3 x4 x3 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_3 x4
    x3 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_3 x4 x3
    x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Parser._case_3"
    [show x4, show x3, show x1, show x2, show x5] info)
  _ -> failCons cd (consFail "Parser._case_3" (showCons x5))

d_C__case_2 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => t0 -> t0 -> Curry_Prelude.OP_List t1 -> Curry_Prelude.OP_List t1
  -> (Curry_Prelude.OP_List t1 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  t1) -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List t1
d_C__case_2 x3 x1 x5 x4 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> x5
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x3 x1 x5 x4 x2
    l cd cs) (d_C__case_2 x3 x1 x5 x4 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x3 x1
    x5 x4 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x3 x1 x5
    x4 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Parser._case_2"
    [show x3, show x1, show x5, show x4, show x2, show x6] info)
  _ -> failCons cd (consFail "Parser._case_2" (showCons x6))

nd_C__case_2 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => t0 -> t0 -> Curry_Prelude.OP_List t1 -> Curry_Prelude.OP_List t1
  -> Func (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List t1)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t1
nd_C__case_2 x3 x1 x5 x4 x2 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> x5
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_2 x3 x1 x5 x4 x2
    l s cd cs) (nd_C__case_2 x3 x1 x5 x4 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_2 x3
    x1 x5 x4 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_2 x3 x1
    x5 x4 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Parser._case_2"
    [show x3, show x1, show x5, show x4, show x2, show x6] info)
  _ -> failCons cd (consFail "Parser._case_2" (showCons x6))

d_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C__case_1 x4 x2 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> x5
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x4 x2 x5 l cd
    cs) (d_C__case_1 x4 x2 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x4 x2
    x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x4 x2 x5
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Parser._case_1"
    [show x4, show x2, show x5, show x6] info)
  _ -> failCons cd (consFail "Parser._case_1" (showCons x6))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_0 x5 x3 x2 x6 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> x6
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x5 x3 x2 x6 l
    cd cs) (d_C__case_0 x5 x3 x2 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x5 x3
    x2 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x5 x3 x2
    x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Parser._case_0"
    [show x5, show x3, show x2, show x6, show x7] info)
  _ -> failCons cd (consFail "Parser._case_0" (showCons x7))

nd_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> Func t0
  Curry_Prelude.C_Bool -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C__case_0 x5 x3 x2 x6 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> x6
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_0 x5 x3 x2 x6 l
    s cd cs) (nd_C__case_0 x5 x3 x2 x6 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_0 x5
    x3 x2 x6 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_0 x5 x3
    x2 x6 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Parser._case_0"
    [show x5, show x3, show x2, show x6, show x7] info)
  _ -> failCons cd (consFail "Parser._case_0" (showCons x7))

