{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module FlatCurry.Curry_Normalize
  ( C_TransInfo (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Normalize_dot_TransInfo_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Normalize_dot_TransInfo_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_FlatCurry_dot_Normalize_dot_TransInfo_hash
  , d_C_normalizeTypeExpr )
  where

import Basics
import qualified Control.Monad.Trans.Curry_State
import qualified Data.Functor.Curry_Identity
import qualified FlatCurry.Curry_Types
import qualified Curry_Prelude


data C_TransInfo
  = C_TransInfo Curry_Prelude.C_Int (Curry_Prelude.OP_List
    (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_Prelude.C_Int))
  | Choice_C_TransInfo Cover ID C_TransInfo C_TransInfo
  | Choices_C_TransInfo Cover ID [C_TransInfo]
  | Fail_C_TransInfo Cover FailInfo
  | Guard_C_TransInfo Cover Constraints C_TransInfo

instance Show C_TransInfo where
  showsPrec d (Choice_C_TransInfo cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_TransInfo cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_TransInfo cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_TransInfo cd info) = showChar '!'
  showsPrec _ (C_TransInfo x1 x2) = showString "(TransInfo" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))

instance Read C_TransInfo where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_TransInfo x1 x2, r2) | (_, r0)
    <- readQualified "FlatCurry.Normalize" "TransInfo" r, (x1, r1) <- readsPrec
    11 r0, (x2, r2) <- readsPrec 11 r1]) s

instance NonDet C_TransInfo where
  choiceCons = Choice_C_TransInfo
  choicesCons = Choices_C_TransInfo
  failCons = Fail_C_TransInfo
  guardCons = Guard_C_TransInfo
  try (Choice_C_TransInfo cd i x y) = tryChoice cd i x y
  try (Choices_C_TransInfo cd i xs) = tryChoices cd i xs
  try (Fail_C_TransInfo cd info) = Fail cd info
  try (Guard_C_TransInfo cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_TransInfo cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_TransInfo cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_TransInfo cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_TransInfo cd i _) = error
    ("FlatCurry.Normalize.TransInfo.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_TransInfo cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_TransInfo cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_TransInfo where
  generate s c = Choices_C_TransInfo c (freeID [2] s) [C_TransInfo (generate
    (leftSupply s) c) (generate (rightSupply s) c)]

instance NormalForm C_TransInfo where
  ($!!) cont (C_TransInfo x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_TransInfo y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_TransInfo cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_TransInfo cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_TransInfo cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_TransInfo cd info) _ _ = failCons cd info
  ($##) cont (C_TransInfo x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_TransInfo y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_TransInfo cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_TransInfo cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_TransInfo cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_TransInfo cd info) _ _ = failCons cd info
  showCons (C_TransInfo _ _) = "FlatCurry.Normalize.TransInfo _ _"
  showCons x = error
    ("FlatCurry.Normalize.TransInfo.showCons: no constructor: " ++ show x)
  searchNF search cont (C_TransInfo x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_TransInfo y1 y2)) x2) x1
  searchNF _ _ x = error
    ("FlatCurry.Normalize.TransInfo.searchNF: no constructor: " ++ show x)

instance Unifiable C_TransInfo where
  (=.=) (C_TransInfo x1 x2) (C_TransInfo y1 y2) d cs = (&) ((=:=) x1 y1 d cs)
    ((=:=) x2 y2 d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_TransInfo x1 x2) (C_TransInfo y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_TransInfo x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID
    i) x3, bind cd (rightID i) x4]
  bind d i (Choice_C_TransInfo cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_TransInfo cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_TransInfo cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_TransInfo cd i _) = error
    ("FlatCurry.Normalize.TransInfo.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_TransInfo cd info) = [Unsolvable info]
  bind d i (Guard_C_TransInfo cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_TransInfo x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind d i (Choice_C_TransInfo cd j x y) = [ConstraintChoice cd j (lazyBind
    d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_TransInfo cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_TransInfo cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_TransInfo cd i _) = error
    ("FlatCurry.Normalize.TransInfo.lazyBind: Choices with ChoiceID: " ++ show
    i)
  lazyBind _ _ (Fail_C_TransInfo cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_TransInfo cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_TransInfo where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Normalize_dot_TransInfo_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_TransInfo
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Normalize_dot_TransInfo_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Normalize_dot_TransInfo_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_FlatCurry_dot_Normalize_dot_TransInfo_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Normalize_dot_TransInfo_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Normalize_dot_TransInfo_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Normalize_dot_TransInfo_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Normalize_dot_TransInfo_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "FlatCurry.Normalize._inst#Prelude.Data#FlatCurry.Normalize.TransInfo#"
    [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Normalize._inst#Prelude.Data#FlatCurry.Normalize.TransInfo#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Normalize_dot_TransInfo_hash :: C_TransInfo
  -> C_TransInfo -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Normalize_dot_TransInfo_hash x1 x2 s cd cs =
  case x1 of
  C_TransInfo x3 x4 -> let s0 = s in s0 `seq` nd_C__case_1 x4 x3 x2 s0 cd cs
  Choice_C_TransInfo d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Normalize_dot_TransInfo_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Normalize_dot_TransInfo_hash
    r x2 s cd cs)
  Choices_C_TransInfo d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Normalize_dot_TransInfo_hash
    z x2 s cd cs) xs
  Guard_C_TransInfo d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Normalize_dot_TransInfo_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_TransInfo d info -> failCons d (traceFail
    "FlatCurry.Normalize._impl#===#Prelude.Data#FlatCurry.Normalize.TransInfo#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Normalize._impl#===#Prelude.Data#FlatCurry.Normalize.TransInfo#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_FlatCurry_dot_Normalize_dot_TransInfo_hash :: IDSupply
  -> Cover -> ConstStore -> C_TransInfo
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_FlatCurry_dot_Normalize_dot_TransInfo_hash s cd cs =
  let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_TransInfo
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)))
  s1 cd cs)))

d_C_currNr :: C_TransInfo -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_currNr x1 cd cs = case x1 of
  C_TransInfo x2 x3 -> x2
  Choice_C_TransInfo d i l r -> narrow d i (d_C_currNr l cd cs) (d_C_currNr r cd
    cs)
  Choices_C_TransInfo d i xs -> narrows cs d i (\z -> d_C_currNr z cd cs) xs
  Guard_C_TransInfo d c e -> guardCons d c ((\x -> d_C_currNr e cd x) $! addCs c
    cs)
  Fail_C_TransInfo d info -> failCons d (traceFail "FlatCurry.Normalize.currNr"
    [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Normalize.currNr" (showCons x1))

d_C_tvarMap :: C_TransInfo -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_Prelude.C_Int)
d_C_tvarMap x1 cd cs = case x1 of
  C_TransInfo x2 x3 -> x3
  Choice_C_TransInfo d i l r -> narrow d i (d_C_tvarMap l cd cs) (d_C_tvarMap r
    cd cs)
  Choices_C_TransInfo d i xs -> narrows cs d i (\z -> d_C_tvarMap z cd cs) xs
  Guard_C_TransInfo d c e -> guardCons d c ((\x -> d_C_tvarMap e cd x) $! addCs
    c cs)
  Fail_C_TransInfo d info -> failCons d (traceFail "FlatCurry.Normalize.tvarMap"
    [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Normalize.tvarMap" (showCons x1))

d_C_initState :: Cover -> ConstStore -> C_TransInfo
d_C_initState cd cs = C_TransInfo (Curry_Prelude.C_Int (0))
  Curry_Prelude.OP_List

d_C_getTVarIndex :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Control.Monad.Trans.Curry_State.C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity Curry_Prelude.C_Int
d_C_getTVarIndex x1 cd cs =
  Control.Monad.Trans.Curry_State.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash
  (Control.Monad.Trans.Curry_State.d_C_get
  Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash
  cd cs) (d_OP_getTVarIndex_dot_uscore_hash_lambda6 x1) cd cs

nd_C_getTVarIndex :: Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore
  -> Control.Monad.Trans.Curry_State.HO_C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity Curry_Prelude.C_Int
nd_C_getTVarIndex x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq`
  Control.Monad.Trans.Curry_State.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
  (Control.Monad.Trans.Curry_State.nd_C_get (wrapNX id
  Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
  s0 cd cs) (wrapNX id (nd_OP_getTVarIndex_dot_uscore_hash_lambda6 x1)) s1 cd
  cs))

d_OP_getTVarIndex_dot_uscore_hash_lambda6 :: Curry_Prelude.C_Int -> C_TransInfo
  -> Cover -> ConstStore -> Control.Monad.Trans.Curry_State.C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity Curry_Prelude.C_Int
d_OP_getTVarIndex_dot_uscore_hash_lambda6 x1 x2 cd cs = let x3 = x2
  in Curry_Prelude.d_C_maybe (let x4 = d_C_currNr x3 cd cs
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Control.Monad.Trans.Curry_State.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash
  cd cs) (Control.Monad.Trans.Curry_State.d_C_put
  Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash
  (d_C__case_0 x4 x1 x3 cd cs) cd cs) cd cs) (Curry_Prelude.d_C_apply
  (Control.Monad.Trans.Curry_State.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash
  cd cs) x4 cd cs) cd cs)
  (Control.Monad.Trans.Curry_State.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash
  cd cs) (Curry_Prelude.d_C_lookup
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  x1 (d_C_tvarMap x3 cd cs) cd cs) cd cs

nd_OP_getTVarIndex_dot_uscore_hash_lambda6 :: Curry_Prelude.C_Int -> C_TransInfo
  -> IDSupply -> Cover -> ConstStore
  -> Control.Monad.Trans.Curry_State.HO_C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity Curry_Prelude.C_Int
nd_OP_getTVarIndex_dot_uscore_hash_lambda6 x1 x2 s cd cs = let s14 = s
  in s14 `seq` (let x3 = x2
  in let s15 = leftSupply s14
         s16 = rightSupply s14
         s13 = leftSupply s15
         s9 = rightSupply s15
         s11 = leftSupply s16
         s12 = rightSupply s16
  in s15 `seq` (s16 `seq` (s13 `seq` (s9 `seq` (s11 `seq` (s12 `seq`
  Curry_Prelude.nd_C_maybe (let x4 = d_C_currNr x3 cd cs
  in let s8 = leftSupply s9
         s10 = rightSupply s9
         s3 = leftSupply s10
         s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s3 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
  (let s2 = leftSupply s3
       s4 = rightSupply s3
       s0 = leftSupply s4
       s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Control.Monad.Trans.Curry_State.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
  s0 cd cs) (Control.Monad.Trans.Curry_State.nd_C_put (wrapNX id
  Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
  (d_C__case_0 x4 x1 x3 cd cs) s1 cd cs) s2 cd cs)))) (let s6 = leftSupply s7
                                                           s5 = rightSupply s7
  in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
  (Control.Monad.Trans.Curry_State.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
  s5 cd cs) x4 s6 cd cs)) s8 cd cs))))
  (Control.Monad.Trans.Curry_State.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
  s11 cd cs) (Curry_Prelude.nd_C_lookup (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash)
  x1 (d_C_tvarMap x3 cd cs) s12 cd cs) s13 cd cs))))))

d_C_normalizeTypeExpr :: FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeExpr
d_C_normalizeTypeExpr x1 cd cs = Curry_Prelude.d_C_apply
  (Control.Monad.Trans.Curry_State.d_C_evalState (d_C_normTExp x1 cd cs) cd cs)
  (d_C_initState cd cs) cd cs

d_C_normTExp :: FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Control.Monad.Trans.Curry_State.C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity FlatCurry.Curry_Types.C_TypeExpr
d_C_normTExp x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_TVar x2 -> Control.Monad.Trans.Curry_State.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
    Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash
    (d_C_getTVarIndex x2 cd cs) d_OP_normTExp_dot_uscore_hash_lambda16 cd cs
  FlatCurry.Curry_Types.C_FuncType x3 x4 -> Control.Monad.Trans.Curry_State.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
    Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash
    (d_C_normTExp x3 cd cs) (d_OP_normTExp_dot_uscore_hash_lambda20 x4) cd cs
  FlatCurry.Curry_Types.C_TCons x5 x6 -> Control.Monad.Trans.Curry_State.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
    Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_mapM
    (Control.Monad.Trans.Curry_State.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
    Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
    d_C_normTExp cd cs) x6 cd cs) (d_OP_normTExp_dot_uscore_hash_lambda25 x5) cd
    cs
  FlatCurry.Curry_Types.C_ForallType x7 x8 -> Control.Monad.Trans.Curry_State.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
    Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_mapM
    (Control.Monad.Trans.Curry_State.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
    Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
    d_OP_normTExp_dot_normTVarWithKind_dot_11 cd cs) x7 cd cs)
    (d_OP_normTExp_dot_uscore_hash_lambda29 x8) cd cs
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i (d_C_normTExp l
    cd cs) (d_C_normTExp r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    d_C_normTExp z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c ((\x ->
    d_C_normTExp e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Normalize.normTExp" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Normalize.normTExp" (showCons x1))

nd_C_normTExp :: FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover
  -> ConstStore -> Control.Monad.Trans.Curry_State.HO_C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity FlatCurry.Curry_Types.C_TypeExpr
nd_C_normTExp x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_TVar x2 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq`
    Control.Monad.Trans.Curry_State.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
    (nd_C_getTVarIndex x2 s0 cd cs) (wrapNX id
    nd_OP_normTExp_dot_uscore_hash_lambda16) s1 cd cs))
  FlatCurry.Curry_Types.C_FuncType x3 x4 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq`
    Control.Monad.Trans.Curry_State.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
    (nd_C_normTExp x3 s0 cd cs) (wrapNX id
    (nd_OP_normTExp_dot_uscore_hash_lambda20 x4)) s1 cd cs))
  FlatCurry.Curry_Types.C_TCons x5 x6 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq`
    Control.Monad.Trans.Curry_State.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_mapM
    (wrapNX id
    (Control.Monad.Trans.Curry_State.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)))
    (wrapNX id nd_C_normTExp) s0 cd cs) x6 s1 cd cs)) (wrapNX id
    (nd_OP_normTExp_dot_uscore_hash_lambda25 x5)) s3 cd cs))
  FlatCurry.Curry_Types.C_ForallType x7 x8 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq`
    Control.Monad.Trans.Curry_State.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_mapM
    (wrapNX id
    (Control.Monad.Trans.Curry_State.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)))
    (wrapNX id nd_OP_normTExp_dot_normTVarWithKind_dot_11) s0 cd cs) x7 s1 cd
    cs)) (wrapNX id (nd_OP_normTExp_dot_uscore_hash_lambda29 x8)) s3 cd cs))
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i (nd_C_normTExp l
    s cd cs) (nd_C_normTExp r s cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    nd_C_normTExp z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c ((\x ->
    nd_C_normTExp e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Normalize.normTExp" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Normalize.normTExp" (showCons x1))

d_OP_normTExp_dot_normTVarWithKind_dot_11 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0 -> Cover -> ConstStore
  -> Control.Monad.Trans.Curry_State.C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t0)
d_OP_normTExp_dot_normTVarWithKind_dot_11 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Control.Monad.Trans.Curry_State.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
    Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash
    (d_C_getTVarIndex x2 cd cs)
    (d_OP_normTExp_dot_normTVarWithKind_dot_11_dot_uscore_hash_lambda12 x3) cd
    cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_normTExp_dot_normTVarWithKind_dot_11 l cd cs)
    (d_OP_normTExp_dot_normTVarWithKind_dot_11 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_normTExp_dot_normTVarWithKind_dot_11 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_normTExp_dot_normTVarWithKind_dot_11 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Normalize.normTExp.normTVarWithKind.11" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Normalize.normTExp.normTVarWithKind.11"
    (showCons x1))

nd_OP_normTExp_dot_normTVarWithKind_dot_11 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0 -> IDSupply -> Cover
  -> ConstStore -> Control.Monad.Trans.Curry_State.HO_C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t0)
nd_OP_normTExp_dot_normTVarWithKind_dot_11 x1 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq`
    Control.Monad.Trans.Curry_State.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
    (nd_C_getTVarIndex x2 s0 cd cs) (wrapNX id
    (nd_OP_normTExp_dot_normTVarWithKind_dot_11_dot_uscore_hash_lambda12 x3)) s1
    cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_normTExp_dot_normTVarWithKind_dot_11 l s cd cs)
    (nd_OP_normTExp_dot_normTVarWithKind_dot_11 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_normTExp_dot_normTVarWithKind_dot_11 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_normTExp_dot_normTVarWithKind_dot_11 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Normalize.normTExp.normTVarWithKind.11" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Normalize.normTExp.normTVarWithKind.11"
    (showCons x1))

d_OP_normTExp_dot_normTVarWithKind_dot_11_dot_uscore_hash_lambda12 :: forall t0 . (Curry_Prelude.Curry
  t0) => t0 -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Control.Monad.Trans.Curry_State.C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t0)
d_OP_normTExp_dot_normTVarWithKind_dot_11_dot_uscore_hash_lambda12 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_C_apply
  (Control.Monad.Trans.Curry_State.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash
  cd cs) (Curry_Prelude.OP_Tuple2 x3 x1) cd cs

nd_OP_normTExp_dot_normTVarWithKind_dot_11_dot_uscore_hash_lambda12 :: forall t0 . (Curry_Prelude.Curry
  t0) => t0 -> Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore
  -> Control.Monad.Trans.Curry_State.HO_C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t0)
nd_OP_normTExp_dot_normTVarWithKind_dot_11_dot_uscore_hash_lambda12 x1 x2 s cd cs =
  let s2 = s
  in s2 `seq` (let x3 = x2
  in let s1 = leftSupply s2
         s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Control.Monad.Trans.Curry_State.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
  s0 cd cs) (Curry_Prelude.OP_Tuple2 x3 x1) s1 cd cs))

d_OP_normTExp_dot_uscore_hash_lambda16 :: Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Control.Monad.Trans.Curry_State.C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity FlatCurry.Curry_Types.C_TypeExpr
d_OP_normTExp_dot_uscore_hash_lambda16 x1 cd cs = let x2 = x1
  in Curry_Prelude.d_OP_dollar
  (Control.Monad.Trans.Curry_State.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash
  cd cs) (FlatCurry.Curry_Types.C_TVar x2) cd cs

nd_OP_normTExp_dot_uscore_hash_lambda16 :: Curry_Prelude.C_Int -> IDSupply
  -> Cover -> ConstStore -> Control.Monad.Trans.Curry_State.HO_C_StateT
  C_TransInfo Data.Functor.Curry_Identity.C_Identity
  FlatCurry.Curry_Types.C_TypeExpr
nd_OP_normTExp_dot_uscore_hash_lambda16 x1 s cd cs = let s2 = s
  in s2 `seq` (let x2 = x1
  in let s1 = leftSupply s2
         s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar
  (Control.Monad.Trans.Curry_State.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
  s0 cd cs) (FlatCurry.Curry_Types.C_TVar x2) s1 cd cs))

d_OP_normTExp_dot_uscore_hash_lambda20 :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Control.Monad.Trans.Curry_State.C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity FlatCurry.Curry_Types.C_TypeExpr
d_OP_normTExp_dot_uscore_hash_lambda20 x1 x2 cd cs = let x3 = x2
  in Control.Monad.Trans.Curry_State.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash
  (d_C_normTExp x1 cd cs)
  (d_OP_normTExp_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22 x3) cd cs

nd_OP_normTExp_dot_uscore_hash_lambda20 :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Control.Monad.Trans.Curry_State.HO_C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity FlatCurry.Curry_Types.C_TypeExpr
nd_OP_normTExp_dot_uscore_hash_lambda20 x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let x3 = x2
  in let s1 = leftSupply s2
         s0 = rightSupply s2
  in s1 `seq` (s0 `seq`
  Control.Monad.Trans.Curry_State.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
  (nd_C_normTExp x1 s0 cd cs) (wrapNX id
  (nd_OP_normTExp_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22 x3)) s1 cd
  cs))

d_OP_normTExp_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22 :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Control.Monad.Trans.Curry_State.C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity FlatCurry.Curry_Types.C_TypeExpr
d_OP_normTExp_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_C_apply
  (Control.Monad.Trans.Curry_State.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash
  cd cs) (FlatCurry.Curry_Types.C_FuncType x1 x3) cd cs

nd_OP_normTExp_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22 :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Control.Monad.Trans.Curry_State.HO_C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity FlatCurry.Curry_Types.C_TypeExpr
nd_OP_normTExp_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22 x1 x2 s cd cs =
  let s2 = s
  in s2 `seq` (let x3 = x2
  in let s1 = leftSupply s2
         s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Control.Monad.Trans.Curry_State.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
  s0 cd cs) (FlatCurry.Curry_Types.C_FuncType x1 x3) s1 cd cs))

d_OP_normTExp_dot_uscore_hash_lambda25 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Control.Monad.Trans.Curry_State.C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity FlatCurry.Curry_Types.C_TypeExpr
d_OP_normTExp_dot_uscore_hash_lambda25 x1 x2 cd cs = let x3 = x2
  in Curry_Prelude.d_OP_dollar
  (Control.Monad.Trans.Curry_State.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash
  cd cs) (FlatCurry.Curry_Types.C_TCons x1 x3) cd cs

nd_OP_normTExp_dot_uscore_hash_lambda25 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Control.Monad.Trans.Curry_State.HO_C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity FlatCurry.Curry_Types.C_TypeExpr
nd_OP_normTExp_dot_uscore_hash_lambda25 x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let x3 = x2
  in let s1 = leftSupply s2
         s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar
  (Control.Monad.Trans.Curry_State.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
  s0 cd cs) (FlatCurry.Curry_Types.C_TCons x1 x3) s1 cd cs))

d_OP_normTExp_dot_uscore_hash_lambda29 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_Kind) -> Cover -> ConstStore
  -> Control.Monad.Trans.Curry_State.C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity FlatCurry.Curry_Types.C_TypeExpr
d_OP_normTExp_dot_uscore_hash_lambda29 x1 x2 cd cs = let x3 = x2
  in Control.Monad.Trans.Curry_State.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash
  (d_C_normTExp x1 cd cs)
  (d_OP_normTExp_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31 x3) cd cs

nd_OP_normTExp_dot_uscore_hash_lambda29 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_Kind) -> IDSupply -> Cover -> ConstStore
  -> Control.Monad.Trans.Curry_State.HO_C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity FlatCurry.Curry_Types.C_TypeExpr
nd_OP_normTExp_dot_uscore_hash_lambda29 x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let x3 = x2
  in let s1 = leftSupply s2
         s0 = rightSupply s2
  in s1 `seq` (s0 `seq`
  Control.Monad.Trans.Curry_State.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
  (nd_C_normTExp x1 s0 cd cs) (wrapNX id
  (nd_OP_normTExp_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31 x3)) s1 cd
  cs))

d_OP_normTExp_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Kind)
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Control.Monad.Trans.Curry_State.C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity FlatCurry.Curry_Types.C_TypeExpr
d_OP_normTExp_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_OP_dollar
  (Control.Monad.Trans.Curry_State.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  Data.Functor.Curry_Identity.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash
  cd cs) (FlatCurry.Curry_Types.C_ForallType x1 x3) cd cs

nd_OP_normTExp_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Kind)
  -> FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Control.Monad.Trans.Curry_State.HO_C_StateT C_TransInfo
  Data.Functor.Curry_Identity.C_Identity FlatCurry.Curry_Types.C_TypeExpr
nd_OP_normTExp_dot_uscore_hash_lambda29_dot_uscore_hash_lambda31 x1 x2 s cd cs =
  let s2 = s
  in s2 `seq` (let x3 = x2
  in let s1 = leftSupply s2
         s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar
  (Control.Monad.Trans.Curry_State.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Control_dot_Monad_dot_Trans_dot_State_dot_StateT_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Data.Functor.Curry_Identity.nd_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Data_dot_Functor_dot_Identity_dot_Identity_hash)
  s0 cd cs) (FlatCurry.Curry_Types.C_ForallType x1 x3) s1 cd cs))

nd_C__case_1 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Curry_Prelude.C_Int -> C_TransInfo
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_1 x4 x3 x2 s cd cs = case x2 of
  C_TransInfo x5 x6 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s1 = leftSupply s2
                                                          s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs)) x3 s0 cd cs) x5 s1 cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)))
    x4 x6 s3 cd cs) cd cs))
  Choice_C_TransInfo d i l r -> narrow d i (nd_C__case_1 x4 x3 l s cd cs)
    (nd_C__case_1 x4 x3 r s cd cs)
  Choices_C_TransInfo d i xs -> narrows cs d i (\z -> nd_C__case_1 x4 x3 z s cd
    cs) xs
  Guard_C_TransInfo d c e -> guardCons d c ((\x -> nd_C__case_1 x4 x3 e s cd
    x) $! addCs c cs)
  Fail_C_TransInfo d info -> failCons d (traceFail "FlatCurry.Normalize._case_1"
    [show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Normalize._case_1" (showCons x2))

d_C__case_0 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> C_TransInfo
  -> Cover -> ConstStore -> C_TransInfo
d_C__case_0 x4 x1 x3 cd cs = case x3 of
  C_TransInfo x5 x6 -> C_TransInfo
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x4 (Curry_Prelude.C_Int (1)) cd cs) (Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 x1 x4) (d_C_tvarMap x3 cd cs))
  Choice_C_TransInfo d i l r -> narrow d i (d_C__case_0 x4 x1 l cd cs)
    (d_C__case_0 x4 x1 r cd cs)
  Choices_C_TransInfo d i xs -> narrows cs d i (\z -> d_C__case_0 x4 x1 z cd cs)
    xs
  Guard_C_TransInfo d c e -> guardCons d c ((\x -> d_C__case_0 x4 x1 e cd x) $!
    addCs c cs)
  Fail_C_TransInfo d info -> failCons d (traceFail "FlatCurry.Normalize._case_0"
    [show x4, show x1, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Normalize._case_0" (showCons x3))

