{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module FlatCurry.Curry_Read
  ( d_C_readFlatCurryInPath
  , d_C_readFlatCurryWithImports
  , d_C_readFlatCurryWithImportsInPath
  , d_C_readFlatCurryIntWithImports
  , d_C_readFlatCurryIntWithImportsInPath )
  where

import Basics
import qualified Control.Curry_Applicative
import qualified Data.Curry_List
import qualified Data.Curry_Time
import qualified FlatCurry.Curry_Files
import qualified FlatCurry.Curry_Types
import qualified Curry_Prelude
import qualified System.Curry_CurryPath
import qualified System.Curry_Directory
import qualified System.Curry_FilePath
import qualified System.Curry_FrontendExec


d_C_readFlatCurryInPath :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO FlatCurry.Curry_Types.C_Prog
d_C_readFlatCurryInPath x1 x2 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_readFlatCurryFileInPath Curry_Prelude.C_False
  Curry_Prelude.C_False x1 x2 (Curry_Prelude.OP_Cons
  (Curry_Prelude.toCurryString ".fcy") Curry_Prelude.OP_List) cd cs) cd cs)
  d_OP_readFlatCurryInPath_dot_uscore_hash_lambda2 cd cs

d_OP_readFlatCurryInPath_dot_uscore_hash_lambda2 :: Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore -> Curry_Prelude.C_IO
  FlatCurry.Curry_Types.C_Prog
d_OP_readFlatCurryInPath_dot_uscore_hash_lambda2 x1 cd cs = case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_5 x2 x3 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_uscore_impl_hash_fail_hash_Prelude_dot_MonadFail_hash_Prelude_dot_IO_hash
    (Curry_Prelude.toCurryString "Pattern match failed!") cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_readFlatCurryInPath_dot_uscore_hash_lambda2 l cd cs)
    (d_OP_readFlatCurryInPath_dot_uscore_hash_lambda2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_readFlatCurryInPath_dot_uscore_hash_lambda2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_readFlatCurryInPath_dot_uscore_hash_lambda2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Read.readFlatCurryInPath._#lambda2" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Read.readFlatCurryInPath._#lambda2"
    (showCons x1))

d_C_readFlatCurryWithImports :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Prog)
d_C_readFlatCurryWithImports x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_CurryPath.d_C_getLoadPathForModule x1 cd cs) cd cs)
  (d_OP_readFlatCurryWithImports_dot_uscore_hash_lambda5 x1) cd cs

d_OP_readFlatCurryWithImports_dot_uscore_hash_lambda5 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Prog)
d_OP_readFlatCurryWithImports_dot_uscore_hash_lambda5 x1 x2 cd cs = let x3 = x2
  in d_C_readFlatCurryFileInPath Curry_Prelude.C_True Curry_Prelude.C_False x3
  (Curry_Prelude.d_C_apply (System.Curry_FilePath.d_C_takeFileName cd cs) x1 cd
  cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ".fcy")
  Curry_Prelude.OP_List) cd cs

d_C_readFlatCurryWithImportsInPath :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Prog)
d_C_readFlatCurryWithImportsInPath x1 x2 cd cs = d_C_readFlatCurryFileInPath
  Curry_Prelude.C_True Curry_Prelude.C_False x1 x2 (Curry_Prelude.OP_Cons
  (Curry_Prelude.toCurryString ".fcy") Curry_Prelude.OP_List) cd cs

d_C_readFlatCurryIntWithImports :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Prog)
d_C_readFlatCurryIntWithImports x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_CurryPath.d_C_getLoadPathForModule x1 cd cs) cd cs)
  (d_OP_readFlatCurryIntWithImports_dot_uscore_hash_lambda8 x1) cd cs

d_OP_readFlatCurryIntWithImports_dot_uscore_hash_lambda8 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Prog)
d_OP_readFlatCurryIntWithImports_dot_uscore_hash_lambda8 x1 x2 cd cs =
  let x3 = x2
  in d_C_readFlatCurryFileInPath Curry_Prelude.C_True Curry_Prelude.C_False x3
  (Curry_Prelude.d_C_apply (System.Curry_FilePath.d_C_takeFileName cd cs) x1 cd
  cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ".fint")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString ".fcy")
  Curry_Prelude.OP_List)) cd cs

d_C_readFlatCurryIntWithImportsInPath :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Prog)
d_C_readFlatCurryIntWithImportsInPath x1 x2 cd cs = d_C_readFlatCurryFileInPath
  Curry_Prelude.C_True Curry_Prelude.C_False x1 x2 (Curry_Prelude.OP_Cons
  (Curry_Prelude.toCurryString ".fint") (Curry_Prelude.OP_Cons
  (Curry_Prelude.toCurryString ".fcy") Curry_Prelude.OP_List)) cd cs

d_C_readFlatCurryFileInPath :: Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Prog)
d_C_readFlatCurryFileInPath x1 x2 x3 x4 x5 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar (Control.Curry_Applicative.d_C_when
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_Prelude_dot_IO_hash
  x2) (Curry_Prelude.d_C_putStr (Curry_Prelude.toCurryString
  "Reading FlatCurry files ") cd cs) cd cs) cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_tryReadFlatCurryFile x1 x2 x3 x4 x5 cd cs) cd cs)
  (d_OP_readFlatCurryFileInPath_dot_uscore_hash_lambda11 x2 x1 x4 x3 x5) cd cs)
  cd cs

d_OP_readFlatCurryFileInPath_dot_uscore_hash_lambda11 :: Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Prog)
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Prog)
d_OP_readFlatCurryFileInPath_dot_uscore_hash_lambda11 x1 x2 x3 x4 x5 x6 cd cs =
  let x7 = x6
  in Curry_Prelude.d_C_either
  (d_OP_readFlatCurryFileInPath_dot_uscore_hash_lambda11_dot_uscore_hash_lambda13
  x1 x2 x3 x4 x5)
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) x7 cd cs

d_OP_readFlatCurryFileInPath_dot_uscore_hash_lambda11_dot_uscore_hash_lambda13 :: Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Prog)
d_OP_readFlatCurryFileInPath_dot_uscore_hash_lambda11_dot_uscore_hash_lambda13 x1 x2 x3 x4 x5 x6 cd cs =
  d_C_parseFlatCurryFile x2 x1 x4 x3 x5 cd cs

d_C_parseFlatCurryFile :: Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Prog)
d_C_parseFlatCurryFile x1 x2 x3 x4 x5 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar (Control.Curry_Applicative.d_C_when
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_Prelude_dot_IO_hash
  x2) (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  ">>>>> FlatCurry files not up-to-date, parsing module \"")
  (Curry_Prelude.d_OP_plus_plus x4 (Curry_Prelude.toCurryString "\"...") cd cs)
  cd cs) cd cs) cd cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_FrontendExec.d_C_callFrontendWithParams
  System.Curry_FrontendExec.C_FCY (System.Curry_FrontendExec.d_C_setQuiet
  Curry_Prelude.C_True (System.Curry_FrontendExec.d_C_setFullPath x3
  (System.Curry_FrontendExec.d_C_defaultParams cd cs) cd cs) cd cs) x4 cd cs) cd
  cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar (Control.Curry_Applicative.d_C_when
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_Prelude_dot_IO_hash
  x2) (Curry_Prelude.d_C_putStr (Curry_Prelude.toCurryString
  "Reading FlatCurry files ") cd cs) cd cs) cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_tryReadFlatCurryFile x1 x2 x3 x4 x5 cd cs) cd cs)
  (d_OP_parseFlatCurryFile_dot_uscore_hash_lambda15 x3) cd cs) cd cs) cd cs) cd
  cs

d_OP_parseFlatCurryFile_dot_notFound_dot_20 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_parseFlatCurryFile_dot_notFound_dot_20 x1 x2 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "FlatCurry file not found for the following module(s): ")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_unwords x2 cd cs)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\nin load path: ")
  (Data.Curry_List.d_C_intercalate (Curry_Prelude.OP_Cons
  (System.Curry_FilePath.d_C_searchPathSeparator cd cs) Curry_Prelude.OP_List)
  x1 cd cs) cd cs) cd cs) cd cs

d_OP_parseFlatCurryFile_dot_uscore_hash_lambda15 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Prog) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Prog)
d_OP_parseFlatCurryFile_dot_uscore_hash_lambda15 x1 x2 cd cs = let x3 = x2
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_either (Curry_Prelude.d_OP_dot
  Curry_Prelude.d_C_error (d_OP_parseFlatCurryFile_dot_notFound_dot_20 x1) cd
  cs) Curry_Prelude.d_C_id x3 cd cs) cd cs

d_C_tryReadFlatCurryFile :: Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Prog))
d_C_tryReadFlatCurryFile x1 x2 x3 x4 x5 cd cs = case x1 of
  Curry_Prelude.C_True -> d_C_tryReadFlatCurryFileWithImports x2 x3 x4 x5 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (d_C_tryReadFlatCurry x2 x3 x4 x5 cd cs) cd cs)
    (d_OP_tryReadFlatCurryFile_dot_uscore_hash_lambda18 x4) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C_tryReadFlatCurryFile l
    x2 x3 x4 x5 cd cs) (d_C_tryReadFlatCurryFile r x2 x3 x4 x5 cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_C_tryReadFlatCurryFile z x2 x3 x4 x5 cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x ->
    d_C_tryReadFlatCurryFile e x2 x3 x4 x5 cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Read.tryReadFlatCurryFile" [show x1, show x2, show x3, show x4
    , show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Read.tryReadFlatCurryFile" (showCons
    x1))

d_OP_tryReadFlatCurryFile_dot_uscore_hash_lambda18 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe FlatCurry.Curry_Types.C_Prog
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Prog))
d_OP_tryReadFlatCurryFile_dot_uscore_hash_lambda18 x1 x2 cd cs = let x3 = x2
  in Curry_Prelude.d_OP_dollar
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_maybe (Curry_Prelude.C_Left (Curry_Prelude.OP_Cons
  x1 Curry_Prelude.OP_List)) (Curry_Prelude.d_OP_dot (acceptCs id
  Curry_Prelude.C_Right) (Curry_Prelude.d_C_flip (acceptCs (acceptCs id)
  Curry_Prelude.OP_Cons) Curry_Prelude.OP_List) cd cs) x3 cd cs) cd cs

d_C_tryReadFlatCurryFileWithImports :: Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Prog))
d_C_tryReadFlatCurryFileWithImports x1 x2 x3 x4 cd cs =
  d_OP_tryReadFlatCurryFileWithImports_dot_collect_dot_28 x1 x2 x4
  (Curry_Prelude.OP_Cons x3 Curry_Prelude.OP_List) Curry_Prelude.OP_List cd cs

d_OP_tryReadFlatCurryFileWithImports_dot_collect_dot_28 :: Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Prog))
d_OP_tryReadFlatCurryFileWithImports_dot_collect_dot_28 x1 x2 x3 x4 x5 cd cs =
  case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Control.Curry_Applicative.d_C_when
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_Prelude_dot_IO_hash
    x1 (Curry_Prelude.d_C_putStrLn (Curry_Prelude.toCurryString "done") cd cs)
    cd cs) cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Curry_Prelude.C_Right Curry_Prelude.OP_List) cd cs) cd cs
  Curry_Prelude.OP_Cons x6 x7 -> d_C__case_4 x5 x6 x3 x7 x2 x1
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x6 cd cs) x5 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_tryReadFlatCurryFileWithImports_dot_collect_dot_28 x1 x2 x3 l x5 cd
    cs) (d_OP_tryReadFlatCurryFileWithImports_dot_collect_dot_28 x1 x2 x3 r x5
    cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_tryReadFlatCurryFileWithImports_dot_collect_dot_28 x1 x2 x3 z x5 cd cs)
    xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_tryReadFlatCurryFileWithImports_dot_collect_dot_28 x1 x2 x3 e x5 cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Read.tryReadFlatCurryFileWithImports.collect.28" [show x1, show
    x2, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail
    "FlatCurry.Read.tryReadFlatCurryFileWithImports.collect.28" (showCons x4))

d_OP_tryReadFlatCurryFileWithImports_dot_collect_dot_28_dot_uscore_hash_lambda21 :: Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Maybe
  FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Prog))
d_OP_tryReadFlatCurryFileWithImports_dot_collect_dot_28_dot_uscore_hash_lambda21 x1 x2 x3 x4 x5 x6 x7 cd cs =
  case x7 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Curry_Prelude.C_Left (Curry_Prelude.OP_Cons x2
    Curry_Prelude.OP_List)) cd cs
  Curry_Prelude.C_Just x8 -> d_C__case_2 x3 x2 x5 x6 x4 x1 x8 cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (d_OP_tryReadFlatCurryFileWithImports_dot_collect_dot_28_dot_uscore_hash_lambda21
    x1 x2 x3 x4 x5 x6 l cd cs)
    (d_OP_tryReadFlatCurryFileWithImports_dot_collect_dot_28_dot_uscore_hash_lambda21
    x1 x2 x3 x4 x5 x6 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    d_OP_tryReadFlatCurryFileWithImports_dot_collect_dot_28_dot_uscore_hash_lambda21
    x1 x2 x3 x4 x5 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x ->
    d_OP_tryReadFlatCurryFileWithImports_dot_collect_dot_28_dot_uscore_hash_lambda21
    x1 x2 x3 x4 x5 x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "FlatCurry.Read.tryReadFlatCurryFileWithImports.collect.28._#lambda21" [show
    x1, show x2, show x3, show x4, show x5, show x6, show x7] info)
  _ -> failCons cd (consFail
    "FlatCurry.Read.tryReadFlatCurryFileWithImports.collect.28._#lambda21"
    (showCons x7))

d_OP_tryReadFlatCurryFileWithImports_dot_collect_dot_28_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25 :: FlatCurry.Curry_Types.C_Prog
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Prog)
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Prog))
d_OP_tryReadFlatCurryFileWithImports_dot_collect_dot_28_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_either (acceptCs id Curry_Prelude.C_Left)
  (Curry_Prelude.d_OP_dot (acceptCs id Curry_Prelude.C_Right) (acceptCs id
  (Curry_Prelude.OP_Cons x1)) cd cs) x3 cd cs) cd cs

d_C_tryReadFlatCurry :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe FlatCurry.Curry_Types.C_Prog)
d_C_tryReadFlatCurry x1 x2 x3 x4 cd cs = let x5 = Curry_Prelude.d_C_apply
                                               (System.Curry_FilePath.d_C_dropExtension
                                               cd cs)
                                               (FlatCurry.Curry_Files.d_C_flatCurryFileName
                                               x3 cd cs) cd cs
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_CurryPath.d_C_lookupModuleSource x2 x3 cd cs) cd cs)
  (d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28 x1 x5 x2 x4) cd cs

d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28 :: Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe FlatCurry.Curry_Types.C_Prog)
d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28 x1 x2 x3 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_Directory.d_C_findFileWithSuffix x2 x4 x3 cd cs) cd cs)
    (Curry_Prelude.d_C_maybe (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) Curry_Prelude.C_Nothing cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Prelude_dot_IO_hash
    (acceptCs id Curry_Prelude.C_Just))
    FlatCurry.Curry_Files.d_C_readFlatCurryFile cd cs)) cd cs
  Curry_Prelude.C_Just x6 -> d_C__case_1 x1 x3 x4 x2 x6 cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28 x1 x2 x3 x4 l cd cs)
    (d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28 x1 x2 x3 x4 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28 x1 x2 x3 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x ->
    d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28 x1 x2 x3 x4 e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "FlatCurry.Read.tryReadFlatCurry._#lambda28" [show x1, show x2, show x3
    , show x4, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Read.tryReadFlatCurry._#lambda28"
    (showCons x5))

d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28_dot_uscore_hash_lambda32 :: Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe FlatCurry.Curry_Types.C_Prog)
d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28_dot_uscore_hash_lambda32 x1 x2 x3 cd cs =
  case x3 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) Curry_Prelude.C_Nothing cd cs
  Curry_Prelude.C_Just x4 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_Directory.d_C_getModificationTime x2 cd cs) cd cs)
    (d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28_dot_uscore_hash_lambda32_dot_uscore_hash_lambda37
    x1 x4) cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28_dot_uscore_hash_lambda32 x1
    x2 l cd cs)
    (d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28_dot_uscore_hash_lambda32 x1
    x2 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28_dot_uscore_hash_lambda32 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x ->
    d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28_dot_uscore_hash_lambda32 x1
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "FlatCurry.Read.tryReadFlatCurry._#lambda28._#lambda32" [show x1, show x2
    , show x3] info)
  _ -> failCons cd (consFail
    "FlatCurry.Read.tryReadFlatCurry._#lambda28._#lambda32" (showCons x3))

d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28_dot_uscore_hash_lambda32_dot_uscore_hash_lambda37 :: Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Data.Curry_Time.C_ClockTime
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  FlatCurry.Curry_Types.C_Prog)
d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28_dot_uscore_hash_lambda32_dot_uscore_hash_lambda37 x1 x2 x3 cd cs =
  let x4 = x3
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_Directory.d_C_getModificationTime x2 cd cs) cd cs)
  (d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28_dot_uscore_hash_lambda32_dot_uscore_hash_lambda37_dot_uscore_hash_lambda39
  x4 x1 x2) cd cs

d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28_dot_uscore_hash_lambda32_dot_uscore_hash_lambda37_dot_uscore_hash_lambda39 :: Data.Curry_Time.C_ClockTime
  -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Data.Curry_Time.C_ClockTime -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe FlatCurry.Curry_Types.C_Prog)
d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28_dot_uscore_hash_lambda32_dot_uscore_hash_lambda37_dot_uscore_hash_lambda39 x1 x2 x3 x4 cd cs =
  let x5 = x4
  in d_C__case_0 x5 x1 x3 x2 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Data.Curry_Time.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Data_dot_Time_dot_ClockTime_hash
  cd cs) x1 cd cs) x5 cd cs) cd cs

d_C__case_5 :: FlatCurry.Curry_Types.C_Prog -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore -> Curry_Prelude.C_IO
  FlatCurry.Curry_Types.C_Prog
d_C__case_5 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) x2 cd cs
  Curry_Prelude.OP_Cons x4 x5 -> Curry_Prelude.d_OP_uscore_impl_hash_fail_hash_Prelude_dot_MonadFail_hash_Prelude_dot_IO_hash
    (Curry_Prelude.toCurryString "Pattern match failed!") cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_5 x2 l cd cs)
    (d_C__case_5 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_5 x2 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_5 x2 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Read._case_5" [show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Read._case_5" (showCons x3))

d_C__case_4 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Prog))
d_C__case_4 x5 x6 x3 x7 x2 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_OP_tryReadFlatCurryFileWithImports_dot_collect_dot_28
    x1 x2 x3 x7 x5 cd cs
  Curry_Prelude.C_False -> d_C__case_3 x3 x7 x2 x5 x6 x1
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x5 x6 x3 x7 x2
    x1 l cd cs) (d_C__case_4 x5 x6 x3 x7 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x5 x6
    x3 x7 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x5 x6 x3
    x7 x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Read._case_4" [show x5, show x6, show x3, show x7, show x2, show
    x1, show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Read._case_4" (showCons x8))

d_C__case_3 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Prog))
d_C__case_3 x3 x7 x2 x5 x6 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (d_C_tryReadFlatCurry x1 x2 x6 x3 cd cs) cd cs)
    (d_OP_tryReadFlatCurryFileWithImports_dot_collect_dot_28_dot_uscore_hash_lambda21
    x1 x6 x5 x2 x7 x3) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x3 x7 x2 x5 x6
    x1 l cd cs) (d_C__case_3 x3 x7 x2 x5 x6 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x3 x7
    x2 x5 x6 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x3 x7 x2
    x5 x6 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Read._case_3" [show x3, show x7, show x2, show x5, show x6, show
    x1, show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Read._case_3" (showCons x8))

d_C__case_2 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Prog))
d_C__case_2 x3 x2 x5 x6 x4 x1 x8 cd cs = case x8 of
  FlatCurry.Curry_Types.C_Prog x9 x10 x11 x12 x13 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (d_OP_tryReadFlatCurryFileWithImports_dot_collect_dot_28 x1 x4 x6
    (Curry_Prelude.d_OP_plus_plus x5 x10 cd cs) (Curry_Prelude.OP_Cons x2 x3) cd
    cs) cd cs)
    (d_OP_tryReadFlatCurryFileWithImports_dot_collect_dot_28_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25
    x8) cd cs
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i (d_C__case_2 x3 x2
    x5 x6 x4 x1 l cd cs) (d_C__case_2 x3 x2 x5 x6 x4 x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C__case_2 x3 x2 x5 x6 x4 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c ((\x -> d_C__case_2
    x3 x2 x5 x6 x4 x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "FlatCurry.Read._case_2" [show x3, show x2, show x5, show x6, show x4, show
    x1, show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Read._case_2" (showCons x8))

d_C__case_1 :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  FlatCurry.Curry_Types.C_Prog)
d_C__case_1 x1 x3 x4 x2 x6 cd cs = case x6 of
  Curry_Prelude.OP_Tuple2 x7 x8 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_Directory.d_C_findFileWithSuffix x2 x4 x3 cd cs) cd cs)
    (d_OP_tryReadFlatCurry_dot_uscore_hash_lambda28_dot_uscore_hash_lambda32 x1
    x8) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_1 x1 x3 x4 x2
    l cd cs) (d_C__case_1 x1 x3 x4 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_1 x1
    x3 x4 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_1 x1 x3
    x4 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Read._case_1" [show x1, show x3, show x4, show x2, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Read._case_1" (showCons x6))

d_C__case_0 :: Data.Curry_Time.C_ClockTime -> Data.Curry_Time.C_ClockTime
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe FlatCurry.Curry_Types.C_Prog)
d_C__case_0 x5 x1 x3 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) Curry_Prelude.C_Nothing cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Curry_Prelude.d_OP_dollar (Control.Curry_Applicative.d_C_when
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Applicative_hash_Prelude_dot_IO_hash
    x2) (Curry_Prelude.d_C_putStr (Curry_Prelude.d_OP_plus_plus
    (System.Curry_FilePath.d_C_normalise x3 cd cs) (Curry_Prelude.toCurryString
    " ") cd cs) cd cs) cd cs) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_fmap_hash_Prelude_dot_Functor_hash_Prelude_dot_IO_hash
    (acceptCs id Curry_Prelude.C_Just)
    (FlatCurry.Curry_Files.d_C_readFlatCurryFile x3 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x5 x1 x3 x2 l
    cd cs) (d_C__case_0 x5 x1 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x5 x1
    x3 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x5 x1 x3
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Read._case_0" [show x5, show x1, show x3, show x2, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Read._case_0" (showCons x6))

