{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module FlatCurry.Curry_XML
  ( nd_C_flatCurry2XmlFile
  , nd_C_flatCurry2Xml
  , nd_C_xmlFile2FlatCurry
  , nd_C_xml2FlatCurry )
  where

import Basics
import qualified FlatCurry.Curry_Types
import qualified Curry_Prelude
import qualified Curry_XML
import qualified Curry_XmlConv


d_C_flatCurryDtd :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_flatCurryDtd cd cs = Curry_Prelude.toCurryString
  "http://www.curry-lang.org/docs/flatcurry.dtd"

nd_C_flatCurry2XmlFile :: FlatCurry.Curry_Types.C_Prog -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
nd_C_flatCurry2XmlFile x1 x2 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
  (Curry_Prelude.d_C_writeFile x2)) (Curry_XML.d_C_showXmlDocWithParams
  (Curry_Prelude.OP_Cons (Curry_XML.C_DtdUrl (d_C_flatCurryDtd cd cs))
  Curry_Prelude.OP_List) (let s1 = leftSupply s2
                              s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_flatCurry2Xml s0 cd cs)
  x1 s1 cd cs)) cd cs) s3 cd cs))

nd_C_flatCurry2Xml :: IDSupply -> Cover -> ConstStore -> Func
  FlatCurry.Curry_Types.C_Prog Curry_XML.C_XmlExp
nd_C_flatCurry2Xml s cd cs = let s0 = s
  in s0 `seq` wrapNX id (Curry_XmlConv.nd_C_xmlShow (nd_C_cProg s0 cd cs))

nd_C_xmlFile2FlatCurry :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO FlatCurry.Curry_Types.C_Prog
nd_C_xmlFile2FlatCurry x1 s cd cs = let s9 = s
  in s9 `seq` (let s8 = leftSupply s9
                   s10 = rightSupply s9
                   s2 = leftSupply s10
                   s6 = rightSupply s10
  in s8 `seq` (s10 `seq` (s2 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (Curry_XML.d_C_readXmlFile x1 cd cs) s1 cd cs)) (let s5 = leftSupply
                                                                   s6
                                                                 s7 = rightSupply
                                                                   s6
                                                                 s3 = leftSupply
                                                                   s7
                                                                 s4 = rightSupply
                                                                   s7
  in s5 `seq` (s7 `seq` (s3 `seq` (s4 `seq` Curry_Prelude.nd_OP_dot
  (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s3 cd cs) (nd_C_xml2FlatCurry s4 cd cs) s5 cd cs)))) s8 cd cs))))

nd_C_xml2FlatCurry :: IDSupply -> Cover -> ConstStore -> Func Curry_XML.C_XmlExp
  FlatCurry.Curry_Types.C_Prog
nd_C_xml2FlatCurry s cd cs = let s0 = s
  in s0 `seq` wrapNX id (Curry_XmlConv.nd_C_xmlRead (nd_C_cProg s0 cd cs))

nd_C_cProg :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem FlatCurry.Curry_Types.C_Prog
nd_C_cProg s cd cs = let s6 = s
  in s6 `seq` (let s7 = leftSupply s6
                   s9 = rightSupply s6
                   s5 = leftSupply s7
                   s8 = rightSupply s7
                   s0 = leftSupply s8
                   s1 = rightSupply s8
                   s2 = leftSupply s9
                   s10 = rightSupply s9
                   s3 = leftSupply s10
                   s4 = rightSupply s10
  in s7 `seq` (s9 `seq` (s5 `seq` (s8 `seq` (s0 `seq` (s1 `seq` (s2 `seq`
  (s10 `seq` (s3 `seq` (s4 `seq` Curry_XmlConv.nd_C_eSeq5 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeDecl_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_FuncDecl_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_OpDecl_hash)))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Prog_hash)
  (Curry_Prelude.toCurryString "prog") (wrapDX (wrapDX (wrapDX (wrapDX (wrapDX
  id)))) (acceptCs (acceptCs (acceptCs (acceptCs (acceptCs id))))
  FlatCurry.Curry_Types.C_Prog)) (nd_C_cModname s0 cd cs) (nd_C_cImports s1 cd
  cs) (nd_C_cTypes s2 cd cs) (nd_C_cFuncs s3 cd cs) (nd_C_cOps s4 cd cs) s5 cd
  cs))))))))))

nd_C_cModname :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_C_cModname s cd cs = let s0 = s
  in s0 `seq` Curry_XmlConv.nd_C_eString (Curry_Prelude.toCurryString "module")
  s0 cd cs

nd_C_cImports :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_C_cImports s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_XmlConv.nd_C_eRep (Curry_Prelude.toCurryString
  "import") (Curry_XmlConv.nd_C_eString (Curry_Prelude.toCurryString "module")
  s0 cd cs) s1 cd cs))

nd_C_cTypes :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl)
nd_C_cTypes s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_XmlConv.nd_C_eRep (Curry_Prelude.toCurryString
  "types") (nd_C_cType s0 cd cs) s1 cd cs))

nd_C_cType :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem
  FlatCurry.Curry_Types.C_TypeDecl
nd_C_cType s cd cs = let s33 = s
  in s33 `seq` (let s32 = leftSupply s33
                    s34 = rightSupply s33
                    s7 = leftSupply s34
                    s30 = rightSupply s34
  in s32 `seq` (s34 `seq` (s7 `seq` (s30 `seq` Curry_XmlConv.nd_OP_bang
  (let s8 = leftSupply s7
       s9 = rightSupply s7
       s6 = leftSupply s8
       s0 = rightSupply s8
       s1 = leftSupply s9
       s10 = rightSupply s9
       s2 = leftSupply s10
       s5 = rightSupply s10
  in s8 `seq` (s9 `seq` (s6 `seq` (s0 `seq` (s1 `seq` (s10 `seq` (s2 `seq`
  (s5 `seq` Curry_XmlConv.nd_C_eSeq4 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Visibility_hash)
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Kind_hash)))))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_ConsDecl_hash)))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeDecl_hash)
  (Curry_Prelude.toCurryString "type") (wrapDX (wrapDX (wrapDX (wrapDX id)))
  (acceptCs (acceptCs (acceptCs (acceptCs id))) FlatCurry.Curry_Types.C_Type))
  (nd_C_cQName s0 cd cs) (nd_C_cVis s1 cd cs) (nd_C_cTParams s2 cd cs)
  (let s4 = leftSupply s5
       s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_XmlConv.nd_C_rep (nd_C_cConsDecl s3 cd cs) s4 cd
  cs)) s6 cd cs)))))))) (let s29 = leftSupply s30
                             s31 = rightSupply s30
                             s16 = leftSupply s31
                             s25 = rightSupply s31
  in s29 `seq` (s31 `seq` (s16 `seq` (s25 `seq` Curry_XmlConv.nd_OP_bang
  (let s17 = leftSupply s16
       s18 = rightSupply s16
       s15 = leftSupply s17
       s11 = rightSupply s17
       s12 = leftSupply s18
       s19 = rightSupply s18
       s13 = leftSupply s19
       s14 = rightSupply s19
  in s17 `seq` (s18 `seq` (s15 `seq` (s11 `seq` (s12 `seq` (s19 `seq` (s13 `seq`
  (s14 `seq` Curry_XmlConv.nd_C_eSeq4 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Visibility_hash)
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Kind_hash)))))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeExpr_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeDecl_hash)
  (Curry_Prelude.toCurryString "typesyn") (wrapDX (wrapDX (wrapDX (wrapDX id)))
  (acceptCs (acceptCs (acceptCs (acceptCs id)))
  FlatCurry.Curry_Types.C_TypeSyn)) (nd_C_cQName s11 cd cs) (nd_C_cVis s12 cd
  cs) (nd_C_cTParams s13 cd cs) (nd_C_cTypeExpr s14 cd cs) s15 cd cs))))))))
  (let s26 = leftSupply s25
       s27 = rightSupply s25
       s24 = leftSupply s26
       s20 = rightSupply s26
       s21 = leftSupply s27
       s28 = rightSupply s27
       s22 = leftSupply s28
       s23 = rightSupply s28
  in s26 `seq` (s27 `seq` (s24 `seq` (s20 `seq` (s21 `seq` (s28 `seq` (s22 `seq`
  (s23 `seq` Curry_XmlConv.nd_C_eSeq4 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Visibility_hash)
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Kind_hash)))))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_NewConsDecl_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeDecl_hash)
  (Curry_Prelude.toCurryString "typenew") (wrapDX (wrapDX (wrapDX (wrapDX id)))
  (acceptCs (acceptCs (acceptCs (acceptCs id)))
  FlatCurry.Curry_Types.C_TypeNew)) (nd_C_cQName s20 cd cs) (nd_C_cVis s21 cd
  cs) (nd_C_cTParams s22 cd cs) (nd_C_cNewConsDecl s23 cd cs) s24 cd cs))))))))
  s29 cd cs)))) s32 cd cs))))

nd_C_cQName :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_NotRepeatable Curry_XmlConv.C_NoElem (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
nd_C_cQName s cd cs = let s9 = s
  in s9 `seq` (let s8 = leftSupply s9
                   s10 = rightSupply s9
                   s5 = leftSupply s10
                   s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
  (let s4 = leftSupply s5
       s6 = rightSupply s5
       s2 = leftSupply s6
       s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_XmlConv.nd_C_seq2
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  s0 cd cs) (wrapDX (wrapDX id) (acceptCs id
  d_OP_cQName_dot_uscore_hash_lambda1)) s1 cd cs)) (Curry_XmlConv.nd_C_aString
  (Curry_Prelude.toCurryString "module") s3 cd cs) s4 cd cs))))
  (Curry_XmlConv.nd_C_aString (Curry_Prelude.toCurryString "name") s7 cd cs) s8
  cd cs))))

d_OP_cQName_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_cQName_dot_uscore_hash_lambda1 x1 x2 cd cs = Curry_Prelude.OP_Tuple2 x1 x2

d_C_cVis :: Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_NotRepeatable Curry_XmlConv.C_NoElem
  FlatCurry.Curry_Types.C_Visibility
d_C_cVis cd cs = Curry_XmlConv.d_C_adapt (Curry_Prelude.OP_Tuple2 d_C_b2v
  d_C_v2b) (Curry_XmlConv.d_C_aBool (Curry_Prelude.toCurryString "visibility")
  (Curry_Prelude.toCurryString "public") (Curry_Prelude.toCurryString "private")
  cd cs) cd cs

nd_C_cVis :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_NotRepeatable Curry_XmlConv.C_NoElem
  FlatCurry.Curry_Types.C_Visibility
nd_C_cVis s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_XmlConv.nd_C_adapt (Curry_Prelude.OP_Tuple2
  (wrapDX id d_C_b2v) (wrapDX id d_C_v2b)) (Curry_XmlConv.nd_C_aBool
  (Curry_Prelude.toCurryString "visibility") (Curry_Prelude.toCurryString
  "public") (Curry_Prelude.toCurryString "private") s0 cd cs) s1 cd cs))

d_C_b2v :: Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Visibility
d_C_b2v x1 cd cs = case x1 of
  Curry_Prelude.C_True -> FlatCurry.Curry_Types.C_Public
  Curry_Prelude.C_False -> FlatCurry.Curry_Types.C_Private
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C_b2v l cd cs) (d_C_b2v r
    cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C_b2v z cd cs)
    xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C_b2v e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "FlatCurry.XML.b2v"
    [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.XML.b2v" (showCons x1))

d_C_v2b :: FlatCurry.Curry_Types.C_Visibility -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_v2b x1 cd cs =
  FlatCurry.Curry_Types.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Types_dot_Visibility_hash
  x1 FlatCurry.Curry_Types.C_Public cd cs

nd_C_cTParams :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Kind))
nd_C_cTParams s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_XmlConv.nd_C_eRep (Curry_Prelude.toCurryString
  "params") (nd_C_cTVarWithKind s0 cd cs) s1 cd cs))

nd_C_cConsDecl :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem
  FlatCurry.Curry_Types.C_ConsDecl
nd_C_cConsDecl s cd cs = let s7 = s
  in s7 `seq` (let s8 = leftSupply s7
                   s9 = rightSupply s7
                   s6 = leftSupply s8
                   s0 = rightSupply s8
                   s1 = leftSupply s9
                   s10 = rightSupply s9
                   s2 = leftSupply s10
                   s5 = rightSupply s10
  in s8 `seq` (s9 `seq` (s6 `seq` (s0 `seq` (s1 `seq` (s10 `seq` (s2 `seq`
  (s5 `seq` Curry_XmlConv.nd_C_eSeq4 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Visibility_hash)
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeExpr_hash)))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_ConsDecl_hash)
  (Curry_Prelude.toCurryString "cons") (wrapDX (wrapDX (wrapDX (wrapDX id)))
  (acceptCs (acceptCs (acceptCs (acceptCs id))) FlatCurry.Curry_Types.C_Cons))
  (nd_C_cQName s0 cd cs) (nd_C_cArity s1 cd cs) (nd_C_cVis s2 cd cs)
  (let s4 = leftSupply s5
       s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_XmlConv.nd_C_rep (nd_C_cTypeExpr s3 cd cs) s4 cd
  cs)) s6 cd cs))))))))

nd_C_cNewConsDecl :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem
  FlatCurry.Curry_Types.C_NewConsDecl
nd_C_cNewConsDecl s cd cs = let s4 = s
  in s4 `seq` (let s5 = leftSupply s4
                   s6 = rightSupply s4
                   s3 = leftSupply s5
                   s0 = rightSupply s5
                   s1 = leftSupply s6
                   s2 = rightSupply s6
  in s5 `seq` (s6 `seq` (s3 `seq` (s0 `seq` (s1 `seq` (s2 `seq`
  Curry_XmlConv.nd_C_eSeq3 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Visibility_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeExpr_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_NewConsDecl_hash)
  (Curry_Prelude.toCurryString "newcons") (wrapDX (wrapDX (wrapDX id)) (acceptCs
  (acceptCs (acceptCs id)) FlatCurry.Curry_Types.C_NewCons)) (nd_C_cQName s0 cd
  cs) (nd_C_cVis s1 cd cs) (nd_C_cTypeExpr s2 cd cs) s3 cd cs))))))

d_C_cArity :: Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_NotRepeatable Curry_XmlConv.C_NoElem Curry_Prelude.C_Int
d_C_cArity cd cs = Curry_XmlConv.d_C_aInt (Curry_Prelude.toCurryString "arity")
  cd cs

nd_C_cArity :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_NotRepeatable Curry_XmlConv.C_NoElem Curry_Prelude.C_Int
nd_C_cArity s cd cs = let s0 = s
  in s0 `seq` Curry_XmlConv.nd_C_aInt (Curry_Prelude.toCurryString "arity") s0
  cd cs

nd_C_cTypeExpr :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem
  FlatCurry.Curry_Types.C_TypeExpr
nd_C_cTypeExpr s cd cs = let s27 = s
  in s27 `seq` (let s26 = leftSupply s27
                    s28 = rightSupply s27
                    s3 = leftSupply s28
                    s24 = rightSupply s28
  in s26 `seq` (s28 `seq` (s3 `seq` (s24 `seq` Curry_XmlConv.nd_OP_bang
  (let s2 = leftSupply s3
       s4 = rightSupply s3
       s0 = leftSupply s4
       s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_XmlConv.nd_C_eSeq2 (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeExpr_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeExpr_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeExpr_hash)
  (Curry_Prelude.toCurryString "functype") (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Curry_Types.C_FuncType)) (nd_C_cTypeExpr s0 cd cs)
  (nd_C_cTypeExpr s1 cd cs) s2 cd cs)))) (let s23 = leftSupply s24
                                              s25 = rightSupply s24
                                              s10 = leftSupply s25
                                              s21 = rightSupply s25
  in s23 `seq` (s25 `seq` (s10 `seq` (s21 `seq` Curry_XmlConv.nd_OP_bang
  (let s9 = leftSupply s10
       s11 = rightSupply s10
       s5 = leftSupply s11
       s8 = rightSupply s11
  in s9 `seq` (s11 `seq` (s5 `seq` (s8 `seq` Curry_XmlConv.nd_C_eSeq2 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeExpr_hash)))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeExpr_hash)
  (Curry_Prelude.toCurryString "tcons") (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Curry_Types.C_TCons)) (nd_C_cQName s5 cd cs)
  (let s7 = leftSupply s8
       s6 = rightSupply s8
  in s7 `seq` (s6 `seq` Curry_XmlConv.nd_C_rep (nd_C_cTypeExpr s6 cd cs) s7 cd
  cs)) s9 cd cs)))) (let s20 = leftSupply s21
                         s22 = rightSupply s21
                         s14 = leftSupply s22
                         s18 = rightSupply s22
  in s20 `seq` (s22 `seq` (s14 `seq` (s18 `seq` Curry_XmlConv.nd_OP_bang
  (let s13 = leftSupply s14
       s12 = rightSupply s14
  in s13 `seq` (s12 `seq` Curry_XmlConv.nd_C_eSeq1 (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeExpr_hash)
  (Curry_Prelude.toCurryString "tvar") (wrapDX id (acceptCs id
  FlatCurry.Curry_Types.C_TVar)) (Curry_XmlConv.nd_C_int s12 cd cs) s13 cd cs))
  (let s17 = leftSupply s18
       s19 = rightSupply s18
       s15 = leftSupply s19
       s16 = rightSupply s19
  in s17 `seq` (s19 `seq` (s15 `seq` (s16 `seq` Curry_XmlConv.nd_C_eSeq2 (wrapNX
  id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Kind_hash)))))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeExpr_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeExpr_hash)
  (Curry_Prelude.toCurryString "forall") (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Curry_Types.C_ForallType)) (nd_C_cTParams s15 cd cs)
  (nd_C_cTypeExpr s16 cd cs) s17 cd cs)))) s20 cd cs)))) s23 cd cs)))) s26 cd
  cs))))

nd_C_cTVarWithKind :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Kind)
nd_C_cTVarWithKind s cd cs = let s7 = s
  in s7 `seq` (let s6 = leftSupply s7
                   s8 = rightSupply s7
                   s4 = leftSupply s8
                   s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s4 `seq` (s5 `seq` Curry_XmlConv.nd_C_eSeq2 (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Kind_hash)
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Kind_hash)))
  (Curry_Prelude.toCurryString "tvarwithkind") (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) Curry_Prelude.OP_Tuple2)) (let s3 = leftSupply s4
                                               s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_XmlConv.nd_C_adapt (Curry_Prelude.OP_Tuple2
  (wrapDX id d_C_fromTVar) (wrapDX id (acceptCs id
  FlatCurry.Curry_Types.C_TVar))) (let s1 = leftSupply s2
                                       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_XmlConv.nd_C_eSeq1 (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeExpr_hash)
  (Curry_Prelude.toCurryString "tvar") (wrapDX id (acceptCs id
  FlatCurry.Curry_Types.C_TVar)) (Curry_XmlConv.nd_C_int s0 cd cs) s1 cd cs)) s3
  cd cs)) (nd_C_cKind s5 cd cs) s6 cd cs))))

d_C_fromTVar :: FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_C_fromTVar x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_TVar x2 -> x2
  FlatCurry.Curry_Types.C_FuncType x3 x4 -> Curry_Prelude.d_C_failed cd cs
  FlatCurry.Curry_Types.C_TCons x5 x6 -> Curry_Prelude.d_C_failed cd cs
  FlatCurry.Curry_Types.C_ForallType x7 x8 -> Curry_Prelude.d_C_failed cd cs
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i (d_C_fromTVar l
    cd cs) (d_C_fromTVar r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    d_C_fromTVar z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c ((\x ->
    d_C_fromTVar e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.XML.fromTVar" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.XML.fromTVar" (showCons x1))

nd_C_cKind :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem FlatCurry.Curry_Types.C_Kind
nd_C_cKind s cd cs = let s7 = s
  in s7 `seq` (let s6 = leftSupply s7
                   s8 = rightSupply s7
                   s0 = leftSupply s8
                   s4 = rightSupply s8
  in s6 `seq` (s8 `seq` (s0 `seq` (s4 `seq` Curry_XmlConv.nd_OP_bang
  (Curry_XmlConv.nd_C_eEmpty (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Kind_hash)
  (Curry_Prelude.toCurryString "kstar") FlatCurry.Curry_Types.C_KStar s0 cd cs)
  (let s3 = leftSupply s4
       s5 = rightSupply s4
       s1 = leftSupply s5
       s2 = rightSupply s5
  in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_XmlConv.nd_C_eSeq2 (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Kind_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Kind_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Kind_hash)
  (Curry_Prelude.toCurryString "karrow") (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Curry_Types.C_KArrow)) (nd_C_cKind s1 cd cs) (nd_C_cKind s2 cd
  cs) s3 cd cs)))) s6 cd cs))))

nd_C_cFuncs :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_FuncDecl)
nd_C_cFuncs s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_XmlConv.nd_C_eRep (Curry_Prelude.toCurryString
  "functions") (nd_C_cFunc s0 cd cs) s1 cd cs))

nd_C_cFunc :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem
  FlatCurry.Curry_Types.C_FuncDecl
nd_C_cFunc s cd cs = let s6 = s
  in s6 `seq` (let s7 = leftSupply s6
                   s9 = rightSupply s6
                   s5 = leftSupply s7
                   s8 = rightSupply s7
                   s0 = leftSupply s8
                   s1 = rightSupply s8
                   s2 = leftSupply s9
                   s10 = rightSupply s9
                   s3 = leftSupply s10
                   s4 = rightSupply s10
  in s7 `seq` (s9 `seq` (s5 `seq` (s8 `seq` (s0 `seq` (s1 `seq` (s2 `seq`
  (s10 `seq` (s3 `seq` (s4 `seq` Curry_XmlConv.nd_C_eSeq5 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Visibility_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeExpr_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Rule_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_FuncDecl_hash)
  (Curry_Prelude.toCurryString "func") (wrapDX (wrapDX (wrapDX (wrapDX (wrapDX
  id)))) (acceptCs (acceptCs (acceptCs (acceptCs (acceptCs id))))
  FlatCurry.Curry_Types.C_Func)) (nd_C_cQName s0 cd cs) (nd_C_cArity s1 cd cs)
  (nd_C_cVis s2 cd cs) (nd_C_cTypeExpr s3 cd cs) (nd_C_cRule s4 cd cs) s5 cd
  cs))))))))))

nd_C_cRule :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem FlatCurry.Curry_Types.C_Rule
nd_C_cRule s cd cs = let s9 = s
  in s9 `seq` (let s8 = leftSupply s9
                   s10 = rightSupply s9
                   s3 = leftSupply s10
                   s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s3 `seq` (s7 `seq` Curry_XmlConv.nd_OP_bang
  (let s2 = leftSupply s3
       s4 = rightSupply s3
       s0 = leftSupply s4
       s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_XmlConv.nd_C_eSeq2 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Rule_hash)
  (Curry_Prelude.toCurryString "rule") (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Curry_Types.C_Rule)) (nd_C_cLHS s0 cd cs) (nd_C_cRHS s1 cd cs)
  s2 cd cs)))) (let s6 = leftSupply s7
                    s5 = rightSupply s7
  in s6 `seq` (s5 `seq` Curry_XmlConv.nd_C_eSeq1 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Rule_hash)
  (Curry_Prelude.toCurryString "external") (wrapDX id (acceptCs id
  FlatCurry.Curry_Types.C_External)) (Curry_XmlConv.nd_C_string s5 cd cs) s6 cd
  cs)) s8 cd cs))))

nd_C_cLHS :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)
nd_C_cLHS s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_XmlConv.nd_C_element (Curry_Prelude.toCurryString
  "lhs") (nd_C_cVars s0 cd cs) s1 cd cs))

nd_C_cRHS :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem FlatCurry.Curry_Types.C_Expr
nd_C_cRHS s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_XmlConv.nd_C_element (Curry_Prelude.toCurryString
  "rhs") (nd_C_cExpr s0 cd cs) s1 cd cs))

nd_C_cVars :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_NotRepeatable Curry_XmlConv.C_NoElem (Curry_Prelude.OP_List
  Curry_Prelude.C_Int)
nd_C_cVars s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_XmlConv.nd_C_rep (nd_C_cVar s0 cd cs) s1 cd cs))

d_C_cVar :: Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem Curry_Prelude.C_Int
d_C_cVar cd cs = Curry_XmlConv.d_C_eInt (Curry_Prelude.toCurryString "var") cd
  cs

nd_C_cVar :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem Curry_Prelude.C_Int
nd_C_cVar s cd cs = let s0 = s
  in s0 `seq` Curry_XmlConv.nd_C_eInt (Curry_Prelude.toCurryString "var") s0 cd
  cs

nd_C_cExpr :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem FlatCurry.Curry_Types.C_Expr
nd_C_cExpr s cd cs = let s99 = s
  in s99 `seq` (let s98 = leftSupply s99
                    s100 = rightSupply s99
                    s2 = leftSupply s100
                    s96 = rightSupply s100
  in s98 `seq` (s100 `seq` (s2 `seq` (s96 `seq` Curry_XmlConv.nd_OP_bang
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_XmlConv.nd_C_eSeq1 (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (Curry_Prelude.toCurryString "var") (wrapDX id (acceptCs id
  FlatCurry.Curry_Types.C_Var)) (Curry_XmlConv.nd_C_int s0 cd cs) s1 cd cs))
  (let s95 = leftSupply s96
       s97 = rightSupply s96
       s5 = leftSupply s97
       s93 = rightSupply s97
  in s95 `seq` (s97 `seq` (s5 `seq` (s93 `seq` Curry_XmlConv.nd_OP_bang
  (let s4 = leftSupply s5
       s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_XmlConv.nd_C_eSeq1 (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Literal_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (Curry_Prelude.toCurryString "lit") (wrapDX id (acceptCs id
  FlatCurry.Curry_Types.C_Lit)) (nd_C_cLit s3 cd cs) s4 cd cs))
  (let s92 = leftSupply s93
       s94 = rightSupply s93
       s9 = leftSupply s94
       s90 = rightSupply s94
  in s92 `seq` (s94 `seq` (s9 `seq` (s90 `seq` Curry_XmlConv.nd_OP_bang
  (let s8 = leftSupply s9
       s10 = rightSupply s9
       s6 = leftSupply s10
       s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s6 `seq` (s7 `seq` Curry_XmlConv.nd_C_eSeq2 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (Curry_Prelude.toCurryString "funccall") (wrapDX (wrapDX id) (d_C_fc cd cs))
  (nd_C_cQName s6 cd cs) (nd_C_cExps s7 cd cs) s8 cd cs))))
  (let s89 = leftSupply s90
       s91 = rightSupply s90
       s14 = leftSupply s91
       s87 = rightSupply s91
  in s89 `seq` (s91 `seq` (s14 `seq` (s87 `seq` Curry_XmlConv.nd_OP_bang
  (let s13 = leftSupply s14
       s15 = rightSupply s14
       s11 = leftSupply s15
       s12 = rightSupply s15
  in s13 `seq` (s15 `seq` (s11 `seq` (s12 `seq` Curry_XmlConv.nd_C_eSeq2 (wrapNX
  id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (Curry_Prelude.toCurryString "conscall") (wrapDX (wrapDX id) (d_C_cc cd cs))
  (nd_C_cQName s11 cd cs) (nd_C_cExps s12 cd cs) s13 cd cs))))
  (let s86 = leftSupply s87
       s88 = rightSupply s87
       s20 = leftSupply s88
       s84 = rightSupply s88
  in s86 `seq` (s88 `seq` (s20 `seq` (s84 `seq` Curry_XmlConv.nd_OP_bang
  (let s21 = leftSupply s20
       s22 = rightSupply s20
       s19 = leftSupply s21
       s16 = rightSupply s21
       s17 = leftSupply s22
       s18 = rightSupply s22
  in s21 `seq` (s22 `seq` (s19 `seq` (s16 `seq` (s17 `seq` (s18 `seq`
  Curry_XmlConv.nd_C_eSeq3 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (Curry_Prelude.toCurryString "funcpartcall") (wrapDX (wrapDX (wrapDX id))
  (acceptCs id d_C_pfc)) (nd_C_cQName s16 cd cs) (nd_C_cMissing s17 cd cs)
  (nd_C_cExps s18 cd cs) s19 cd cs)))))) (let s83 = leftSupply s84
                                              s85 = rightSupply s84
                                              s27 = leftSupply s85
                                              s81 = rightSupply s85
  in s83 `seq` (s85 `seq` (s27 `seq` (s81 `seq` Curry_XmlConv.nd_OP_bang
  (let s28 = leftSupply s27
       s29 = rightSupply s27
       s26 = leftSupply s28
       s23 = rightSupply s28
       s24 = leftSupply s29
       s25 = rightSupply s29
  in s28 `seq` (s29 `seq` (s26 `seq` (s23 `seq` (s24 `seq` (s25 `seq`
  Curry_XmlConv.nd_C_eSeq3 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (Curry_Prelude.toCurryString "conspartcall") (wrapDX (wrapDX (wrapDX id))
  (acceptCs id d_C_pcc)) (nd_C_cQName s23 cd cs) (nd_C_cMissing s24 cd cs)
  (nd_C_cExps s25 cd cs) s26 cd cs)))))) (let s80 = leftSupply s81
                                              s82 = rightSupply s81
                                              s35 = leftSupply s82
                                              s78 = rightSupply s82
  in s80 `seq` (s82 `seq` (s35 `seq` (s78 `seq` Curry_XmlConv.nd_OP_bang
  (let s34 = leftSupply s35
       s36 = rightSupply s35
       s32 = leftSupply s36
       s33 = rightSupply s36
  in s34 `seq` (s36 `seq` (s32 `seq` (s33 `seq` Curry_XmlConv.nd_C_eSeq2 (wrapNX
  id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (Curry_Prelude.toCurryString "free") (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Curry_Types.C_Free)) (let s31 = leftSupply s32
                                          s30 = rightSupply s32
  in s31 `seq` (s30 `seq` Curry_XmlConv.nd_C_element
  (Curry_Prelude.toCurryString "freevars") (nd_C_cVars s30 cd cs) s31 cd cs))
  (nd_C_cExpr s33 cd cs) s34 cd cs)))) (let s77 = leftSupply s78
                                            s79 = rightSupply s78
                                            s40 = leftSupply s79
                                            s75 = rightSupply s79
  in s77 `seq` (s79 `seq` (s40 `seq` (s75 `seq` Curry_XmlConv.nd_OP_bang
  (let s39 = leftSupply s40
       s41 = rightSupply s40
       s37 = leftSupply s41
       s38 = rightSupply s41
  in s39 `seq` (s41 `seq` (s37 `seq` (s38 `seq` Curry_XmlConv.nd_C_eSeq2 (wrapNX
  id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (Curry_Prelude.toCurryString "or") (wrapDX (wrapDX id) (acceptCs (acceptCs id)
  FlatCurry.Curry_Types.C_Or)) (nd_C_cExpr s37 cd cs) (nd_C_cExpr s38 cd cs) s39
  cd cs)))) (let s74 = leftSupply s75
                 s76 = rightSupply s75
                 s47 = leftSupply s76
                 s72 = rightSupply s76
  in s74 `seq` (s76 `seq` (s47 `seq` (s72 `seq` Curry_XmlConv.nd_OP_bang
  (let s46 = leftSupply s47
       s48 = rightSupply s47
       s42 = leftSupply s48
       s45 = rightSupply s48
  in s46 `seq` (s48 `seq` (s42 `seq` (s45 `seq` Curry_XmlConv.nd_C_eSeq2 (wrapNX
  id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_BranchExpr_hash)))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (Curry_Prelude.toCurryString "case") (wrapDX (wrapDX id) (d_C_cr cd cs))
  (nd_C_cExpr s42 cd cs) (let s44 = leftSupply s45
                              s43 = rightSupply s45
  in s44 `seq` (s43 `seq` Curry_XmlConv.nd_C_rep (nd_C_cBranch s43 cd cs) s44 cd
  cs)) s46 cd cs)))) (let s71 = leftSupply s72
                          s73 = rightSupply s72
                          s54 = leftSupply s73
                          s69 = rightSupply s73
  in s71 `seq` (s73 `seq` (s54 `seq` (s69 `seq` Curry_XmlConv.nd_OP_bang
  (let s53 = leftSupply s54
       s55 = rightSupply s54
       s49 = leftSupply s55
       s52 = rightSupply s55
  in s53 `seq` (s55 `seq` (s49 `seq` (s52 `seq` Curry_XmlConv.nd_C_eSeq2 (wrapNX
  id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_BranchExpr_hash)))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (Curry_Prelude.toCurryString "fcase") (wrapDX (wrapDX id) (d_C_cf cd cs))
  (nd_C_cExpr s49 cd cs) (let s51 = leftSupply s52
                              s50 = rightSupply s52
  in s51 `seq` (s50 `seq` Curry_XmlConv.nd_C_rep (nd_C_cBranch s50 cd cs) s51 cd
  cs)) s53 cd cs)))) (let s68 = leftSupply s69
                          s70 = rightSupply s69
                          s61 = leftSupply s70
                          s66 = rightSupply s70
  in s68 `seq` (s70 `seq` (s61 `seq` (s66 `seq` Curry_XmlConv.nd_OP_bang
  (let s60 = leftSupply s61
       s62 = rightSupply s61
       s58 = leftSupply s62
       s59 = rightSupply s62
  in s60 `seq` (s62 `seq` (s58 `seq` (s59 `seq` Curry_XmlConv.nd_C_eSeq2 (wrapNX
  id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)))))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (Curry_Prelude.toCurryString "letrec") (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Curry_Types.C_Let)) (let s57 = leftSupply s58
                                         s56 = rightSupply s58
  in s57 `seq` (s56 `seq` Curry_XmlConv.nd_C_rep (nd_C_cBind s56 cd cs) s57 cd
  cs)) (nd_C_cExpr s59 cd cs) s60 cd cs)))) (let s65 = leftSupply s66
                                                 s67 = rightSupply s66
                                                 s63 = leftSupply s67
                                                 s64 = rightSupply s67
  in s65 `seq` (s67 `seq` (s63 `seq` (s64 `seq` Curry_XmlConv.nd_C_eSeq2 (wrapNX
  id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_TypeExpr_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (Curry_Prelude.toCurryString "typed") (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Curry_Types.C_Typed)) (nd_C_cExpr s63 cd cs) (nd_C_cTypeExpr s64
  cd cs) s65 cd cs)))) s68 cd cs)))) s71 cd cs)))) s74 cd cs)))) s77 cd cs))))
  s80 cd cs)))) s83 cd cs)))) s86 cd cs)))) s89 cd cs)))) s92 cd cs)))) s95 cd
  cs)))) s98 cd cs))))

nd_C_cLit :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem
  FlatCurry.Curry_Types.C_Literal
nd_C_cLit s cd cs = let s15 = s
  in s15 `seq` (let s14 = leftSupply s15
                    s16 = rightSupply s15
                    s2 = leftSupply s16
                    s12 = rightSupply s16
  in s14 `seq` (s16 `seq` (s2 `seq` (s12 `seq` Curry_XmlConv.nd_OP_bang
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_XmlConv.nd_C_eSeq1 (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Literal_hash)
  (Curry_Prelude.toCurryString "intc") (wrapDX id (acceptCs id
  FlatCurry.Curry_Types.C_Intc)) (Curry_XmlConv.nd_C_int s0 cd cs) s1 cd cs))
  (let s11 = leftSupply s12
       s13 = rightSupply s12
       s5 = leftSupply s13
       s10 = rightSupply s13
  in s11 `seq` (s13 `seq` (s5 `seq` (s10 `seq` Curry_XmlConv.nd_OP_bang
  (let s4 = leftSupply s5
       s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_XmlConv.nd_C_eSeq1 (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Float_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Literal_hash)
  (Curry_Prelude.toCurryString "floatc") (wrapDX id (acceptCs id
  FlatCurry.Curry_Types.C_Floatc)) (Curry_XmlConv.nd_C_float s3 cd cs) s4 cd
  cs)) (let s9 = leftSupply s10
            s8 = rightSupply s10
  in s9 `seq` (s8 `seq` Curry_XmlConv.nd_C_eSeq1 (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Literal_hash)
  (Curry_Prelude.toCurryString "charc") (wrapDX id (acceptCs id
  FlatCurry.Curry_Types.C_Charc)) (let s7 = leftSupply s8
                                       s6 = rightSupply s8
  in s7 `seq` (s6 `seq` Curry_XmlConv.nd_C_adapt (Curry_Prelude.OP_Tuple2
  (wrapDX id Curry_Prelude.d_C_chr) (wrapDX id Curry_Prelude.d_C_ord))
  (Curry_XmlConv.nd_C_int s6 cd cs) s7 cd cs)) s9 cd cs)) s11 cd cs)))) s14 cd
  cs))))

d_C_fc :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Cover
  -> ConstStore -> FlatCurry.Curry_Types.C_Expr
d_C_fc cd cs = acceptCs (acceptCs id) (FlatCurry.Curry_Types.C_Comb
  FlatCurry.Curry_Types.C_FuncCall)

d_C_cc :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Cover
  -> ConstStore -> FlatCurry.Curry_Types.C_Expr
d_C_cc cd cs = acceptCs (acceptCs id) (FlatCurry.Curry_Types.C_Comb
  FlatCurry.Curry_Types.C_ConsCall)

d_C_pfc :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Cover
  -> ConstStore -> FlatCurry.Curry_Types.C_Expr
d_C_pfc x1 x2 cd cs = acceptCs id (FlatCurry.Curry_Types.C_Comb
  (FlatCurry.Curry_Types.C_FuncPartCall x2) x1)

d_C_pcc :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Cover
  -> ConstStore -> FlatCurry.Curry_Types.C_Expr
d_C_pcc x1 x2 cd cs = acceptCs id (FlatCurry.Curry_Types.C_Comb
  (FlatCurry.Curry_Types.C_ConsPartCall x2) x1)

nd_C_cExps :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_NotRepeatable Curry_XmlConv.C_NoElem (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr)
nd_C_cExps s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_XmlConv.nd_C_rep (nd_C_cExpr s0 cd cs) s1 cd cs))

d_C_cMissing :: Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_NotRepeatable Curry_XmlConv.C_NoElem Curry_Prelude.C_Int
d_C_cMissing cd cs = Curry_XmlConv.d_C_aInt (Curry_Prelude.toCurryString
  "missing") cd cs

nd_C_cMissing :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_NotRepeatable Curry_XmlConv.C_NoElem Curry_Prelude.C_Int
nd_C_cMissing s cd cs = let s0 = s
  in s0 `seq` Curry_XmlConv.nd_C_aInt (Curry_Prelude.toCurryString "missing") s0
  cd cs

d_C_cr :: Cover -> ConstStore -> FlatCurry.Curry_Types.C_Expr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_BranchExpr
  -> Cover -> ConstStore -> FlatCurry.Curry_Types.C_Expr
d_C_cr cd cs = acceptCs (acceptCs id) (FlatCurry.Curry_Types.C_Case
  FlatCurry.Curry_Types.C_Rigid)

d_C_cf :: Cover -> ConstStore -> FlatCurry.Curry_Types.C_Expr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_BranchExpr
  -> Cover -> ConstStore -> FlatCurry.Curry_Types.C_Expr
d_C_cf cd cs = acceptCs (acceptCs id) (FlatCurry.Curry_Types.C_Case
  FlatCurry.Curry_Types.C_Flex)

nd_C_cBranch :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem
  FlatCurry.Curry_Types.C_BranchExpr
nd_C_cBranch s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_XmlConv.nd_C_eSeq2 (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Pattern_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_BranchExpr_hash)
  (Curry_Prelude.toCurryString "branch") (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Curry_Types.C_Branch)) (nd_C_cPat s0 cd cs) (nd_C_cExpr s1 cd
  cs) s2 cd cs))))

nd_C_cPat :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem
  FlatCurry.Curry_Types.C_Pattern
nd_C_cPat s cd cs = let s9 = s
  in s9 `seq` (let s8 = leftSupply s9
                   s10 = rightSupply s9
                   s3 = leftSupply s10
                   s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s3 `seq` (s7 `seq` Curry_XmlConv.nd_OP_bang
  (let s2 = leftSupply s3
       s4 = rightSupply s3
       s0 = leftSupply s4
       s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_XmlConv.nd_C_eSeq2 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Pattern_hash)
  (Curry_Prelude.toCurryString "pattern") (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Curry_Types.C_Pattern)) (nd_C_cQName s0 cd cs)
  (nd_C_cVars s1 cd cs) s2 cd cs)))) (let s6 = leftSupply s7
                                          s5 = rightSupply s7
  in s6 `seq` (s5 `seq` Curry_XmlConv.nd_C_eSeq1 (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Literal_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Pattern_hash)
  (Curry_Prelude.toCurryString "lpattern") (wrapDX id (acceptCs id
  FlatCurry.Curry_Types.C_LPattern)) (nd_C_cLit s5 cd cs) s6 cd cs)) s8 cd
  cs))))

nd_C_cBind :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Expr)
nd_C_cBind s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_XmlConv.nd_C_eSeq2 (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Expr_hash)))
  (Curry_Prelude.toCurryString "binding") (wrapDX (wrapDX id) (acceptCs id
  d_OP_cBind_dot_uscore_hash_lambda2)) (nd_C_cVar s0 cd cs) (nd_C_cExpr s1 cd
  cs) s2 cd cs))))

d_OP_cBind_dot_uscore_hash_lambda2 :: Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Expr
d_OP_cBind_dot_uscore_hash_lambda2 x1 x2 cd cs = Curry_Prelude.OP_Tuple2 x1 x2

nd_C_cOps :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl)
nd_C_cOps s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_XmlConv.nd_C_eRep (Curry_Prelude.toCurryString
  "operators") (nd_C_cOp s0 cd cs) s1 cd cs))

nd_C_cOp :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_Repeatable Curry_XmlConv.C_Elem FlatCurry.Curry_Types.C_OpDecl
nd_C_cOp s cd cs = let s4 = s
  in s4 `seq` (let s5 = leftSupply s4
                   s6 = rightSupply s4
                   s3 = leftSupply s5
                   s0 = rightSupply s5
                   s1 = leftSupply s6
                   s2 = rightSupply s6
  in s5 `seq` (s6 `seq` (s3 `seq` (s0 `seq` (s1 `seq` (s2 `seq`
  Curry_XmlConv.nd_C_eSeq3 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_Fixity_hash)
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Types_dot_OpDecl_hash)
  (Curry_Prelude.toCurryString "op") (wrapDX (wrapDX (wrapDX id)) (acceptCs
  (acceptCs (acceptCs id)) FlatCurry.Curry_Types.C_Op)) (nd_C_cQName s0 cd cs)
  (nd_C_cFixity s1 cd cs) (Curry_XmlConv.nd_C_aInt (Curry_Prelude.toCurryString
  "prec") s2 cd cs) s3 cd cs))))))

d_C_cFixity :: Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_NotRepeatable Curry_XmlConv.C_NoElem
  FlatCurry.Curry_Types.C_Fixity
d_C_cFixity cd cs = Curry_XmlConv.d_C_adapt (Curry_Prelude.OP_Tuple2 d_C_rf
  (FlatCurry.Curry_Types.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_FlatCurry_dot_Types_dot_Fixity_hash
  cd cs)) (Curry_XmlConv.d_C_aString (Curry_Prelude.toCurryString "fixity") cd
  cs) cd cs

nd_C_cFixity :: IDSupply -> Cover -> ConstStore -> Curry_XmlConv.C_XmlConv
  Curry_XmlConv.C_NotRepeatable Curry_XmlConv.C_NoElem
  FlatCurry.Curry_Types.C_Fixity
nd_C_cFixity s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_XmlConv.nd_C_adapt (Curry_Prelude.OP_Tuple2
  (wrapDX id d_C_rf) (wrapDX id
  (FlatCurry.Curry_Types.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_FlatCurry_dot_Types_dot_Fixity_hash
  cd cs))) (Curry_XmlConv.nd_C_aString (Curry_Prelude.toCurryString "fixity") s0
  cd cs) s1 cd cs))

d_C_rf :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Fixity
d_C_rf x1 cd cs = case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_23 x3 x2 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_rf l cd cs) (d_C_rf r
    cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_rf z cd cs)
    xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_rf e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "FlatCurry.XML.rf"
    [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.XML.rf" (showCons x1))

d_C__case_23 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Fixity
d_C__case_23 x3 x2 cd cs = case x2 of
  (Curry_Prelude.C_Char 'I'#) -> d_C__case_22 x3 cd cs
  Curry_Prelude.CurryChar l -> matchChar [('I', d_C__case_22 x3 cd cs)] l cd cs
  Curry_Prelude.Choice_C_Char d i l r -> narrow d i (d_C__case_23 x3 l cd cs)
    (d_C__case_23 x3 r cd cs)
  Curry_Prelude.Choices_C_Char d i xs -> narrows cs d i (\z -> d_C__case_23 x3 z
    cd cs) xs
  Curry_Prelude.Guard_C_Char d c e -> guardCons d c ((\x -> d_C__case_23 x3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Char d info -> failCons d (traceFail
    "FlatCurry.XML._case_23" [show x3, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_23" (showCons x2))

d_C__case_22 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> FlatCurry.Curry_Types.C_Fixity
d_C__case_22 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_21 x5 x4 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_22 l cd cs)
    (d_C__case_22 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_22 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_22 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.XML._case_22" [show x3] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_22" (showCons x3))

d_C__case_21 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Fixity
d_C__case_21 x5 x4 cd cs = case x4 of
  (Curry_Prelude.C_Char 'n'#) -> d_C__case_20 x5 cd cs
  Curry_Prelude.CurryChar l -> matchChar [('n', d_C__case_20 x5 cd cs)] l cd cs
  Curry_Prelude.Choice_C_Char d i l r -> narrow d i (d_C__case_21 x5 l cd cs)
    (d_C__case_21 x5 r cd cs)
  Curry_Prelude.Choices_C_Char d i xs -> narrows cs d i (\z -> d_C__case_21 x5 z
    cd cs) xs
  Curry_Prelude.Guard_C_Char d c e -> guardCons d c ((\x -> d_C__case_21 x5 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Char d info -> failCons d (traceFail
    "FlatCurry.XML._case_21" [show x5, show x4] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_21" (showCons x4))

d_C__case_20 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> FlatCurry.Curry_Types.C_Fixity
d_C__case_20 x5 cd cs = case x5 of
  Curry_Prelude.OP_Cons x6 x7 -> d_C__case_19 x7 x6 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_20 l cd cs)
    (d_C__case_20 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_20 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_20 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.XML._case_20" [show x5] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_20" (showCons x5))

d_C__case_19 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Fixity
d_C__case_19 x7 x6 cd cs = case x6 of
  (Curry_Prelude.C_Char 'f'#) -> d_C__case_18 x7 cd cs
  Curry_Prelude.CurryChar l -> matchChar [('f', d_C__case_18 x7 cd cs)] l cd cs
  Curry_Prelude.Choice_C_Char d i l r -> narrow d i (d_C__case_19 x7 l cd cs)
    (d_C__case_19 x7 r cd cs)
  Curry_Prelude.Choices_C_Char d i xs -> narrows cs d i (\z -> d_C__case_19 x7 z
    cd cs) xs
  Curry_Prelude.Guard_C_Char d c e -> guardCons d c ((\x -> d_C__case_19 x7 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Char d info -> failCons d (traceFail
    "FlatCurry.XML._case_19" [show x7, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_19" (showCons x6))

d_C__case_18 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> FlatCurry.Curry_Types.C_Fixity
d_C__case_18 x7 cd cs = case x7 of
  Curry_Prelude.OP_Cons x8 x9 -> d_C__case_17 x9 x8 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_18 l cd cs)
    (d_C__case_18 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_18 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_18 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.XML._case_18" [show x7] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_18" (showCons x7))

d_C__case_17 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Fixity
d_C__case_17 x9 x8 cd cs = case x8 of
  (Curry_Prelude.C_Char 'i'#) -> d_C__case_16 x9 cd cs
  Curry_Prelude.CurryChar l -> matchChar [('i', d_C__case_16 x9 cd cs)] l cd cs
  Curry_Prelude.Choice_C_Char d i l r -> narrow d i (d_C__case_17 x9 l cd cs)
    (d_C__case_17 x9 r cd cs)
  Curry_Prelude.Choices_C_Char d i xs -> narrows cs d i (\z -> d_C__case_17 x9 z
    cd cs) xs
  Curry_Prelude.Guard_C_Char d c e -> guardCons d c ((\x -> d_C__case_17 x9 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Char d info -> failCons d (traceFail
    "FlatCurry.XML._case_17" [show x9, show x8] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_17" (showCons x8))

d_C__case_16 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> FlatCurry.Curry_Types.C_Fixity
d_C__case_16 x9 cd cs = case x9 of
  Curry_Prelude.OP_Cons x10 x11 -> d_C__case_15 x11 x10 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_16 l cd cs)
    (d_C__case_16 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_16 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_16 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.XML._case_16" [show x9] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_16" (showCons x9))

d_C__case_15 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Fixity
d_C__case_15 x11 x10 cd cs = case x10 of
  (Curry_Prelude.C_Char 'x'#) -> d_C__case_14 x11 cd cs
  Curry_Prelude.CurryChar l -> matchChar [('x', d_C__case_14 x11 cd cs)] l cd cs
  Curry_Prelude.Choice_C_Char d i l r -> narrow d i (d_C__case_15 x11 l cd cs)
    (d_C__case_15 x11 r cd cs)
  Curry_Prelude.Choices_C_Char d i xs -> narrows cs d i (\z -> d_C__case_15 x11
    z cd cs) xs
  Curry_Prelude.Guard_C_Char d c e -> guardCons d c ((\x -> d_C__case_15 x11 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Char d info -> failCons d (traceFail
    "FlatCurry.XML._case_15" [show x11, show x10] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_15" (showCons x10))

d_C__case_14 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> FlatCurry.Curry_Types.C_Fixity
d_C__case_14 x11 cd cs = case x11 of
  Curry_Prelude.OP_Cons x12 x13 -> d_C__case_13 x13 x12 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_14 l cd cs)
    (d_C__case_14 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_14 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_14 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.XML._case_14" [show x11] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_14" (showCons x11))

d_C__case_13 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Fixity
d_C__case_13 x13 x12 cd cs = case x12 of
  (Curry_Prelude.C_Char 'O'#) -> d_C__case_12 x13 cd cs
  (Curry_Prelude.C_Char 'l'#) -> d_C__case_9 x13 cd cs
  (Curry_Prelude.C_Char 'r'#) -> d_C__case_4 x13 cd cs
  Curry_Prelude.CurryChar l -> matchChar [('O', d_C__case_12 x13 cd cs), ('l'
    , d_C__case_9 x13 cd cs), ('r', d_C__case_4 x13 cd cs)] l cd cs
  Curry_Prelude.Choice_C_Char d i l r -> narrow d i (d_C__case_13 x13 l cd cs)
    (d_C__case_13 x13 r cd cs)
  Curry_Prelude.Choices_C_Char d i xs -> narrows cs d i (\z -> d_C__case_13 x13
    z cd cs) xs
  Curry_Prelude.Guard_C_Char d c e -> guardCons d c ((\x -> d_C__case_13 x13 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Char d info -> failCons d (traceFail
    "FlatCurry.XML._case_13" [show x13, show x12] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_13" (showCons x12))

d_C__case_4 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Fixity
d_C__case_4 x13 cd cs = case x13 of
  Curry_Prelude.OP_Cons x24 x25 -> d_C__case_3 x25 x24 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_4 l cd cs)
    (d_C__case_4 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_4 z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_4 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.XML._case_4" [show x13] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_4" (showCons x13))

d_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Fixity
d_C__case_3 x25 x24 cd cs = case x24 of
  (Curry_Prelude.C_Char 'O'#) -> d_C__case_2 x25 cd cs
  Curry_Prelude.CurryChar l -> matchChar [('O', d_C__case_2 x25 cd cs)] l cd cs
  Curry_Prelude.Choice_C_Char d i l r -> narrow d i (d_C__case_3 x25 l cd cs)
    (d_C__case_3 x25 r cd cs)
  Curry_Prelude.Choices_C_Char d i xs -> narrows cs d i (\z -> d_C__case_3 x25 z
    cd cs) xs
  Curry_Prelude.Guard_C_Char d c e -> guardCons d c ((\x -> d_C__case_3 x25 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Char d info -> failCons d (traceFail
    "FlatCurry.XML._case_3" [show x25, show x24] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_3" (showCons x24))

d_C__case_2 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Fixity
d_C__case_2 x25 cd cs = case x25 of
  Curry_Prelude.OP_Cons x26 x27 -> d_C__case_1 x27 x26 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_2 l cd cs)
    (d_C__case_2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_2 z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_2 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.XML._case_2" [show x25] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_2" (showCons x25))

d_C__case_1 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Fixity
d_C__case_1 x27 x26 cd cs = case x26 of
  (Curry_Prelude.C_Char 'p'#) -> d_C__case_0 x27 cd cs
  Curry_Prelude.CurryChar l -> matchChar [('p', d_C__case_0 x27 cd cs)] l cd cs
  Curry_Prelude.Choice_C_Char d i l r -> narrow d i (d_C__case_1 x27 l cd cs)
    (d_C__case_1 x27 r cd cs)
  Curry_Prelude.Choices_C_Char d i xs -> narrows cs d i (\z -> d_C__case_1 x27 z
    cd cs) xs
  Curry_Prelude.Guard_C_Char d c e -> guardCons d c ((\x -> d_C__case_1 x27 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Char d info -> failCons d (traceFail
    "FlatCurry.XML._case_1" [show x27, show x26] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_1" (showCons x26))

d_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Fixity
d_C__case_0 x27 cd cs = case x27 of
  Curry_Prelude.OP_List -> FlatCurry.Curry_Types.C_InfixrOp
  Curry_Prelude.OP_Cons x28 x29 -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_0 l cd cs)
    (d_C__case_0 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_0 z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_0 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.XML._case_0" [show x27] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_0" (showCons x27))

d_C__case_9 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Fixity
d_C__case_9 x13 cd cs = case x13 of
  Curry_Prelude.OP_Cons x18 x19 -> d_C__case_8 x19 x18 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_9 l cd cs)
    (d_C__case_9 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_9 z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_9 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.XML._case_9" [show x13] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_9" (showCons x13))

d_C__case_8 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Fixity
d_C__case_8 x19 x18 cd cs = case x18 of
  (Curry_Prelude.C_Char 'O'#) -> d_C__case_7 x19 cd cs
  Curry_Prelude.CurryChar l -> matchChar [('O', d_C__case_7 x19 cd cs)] l cd cs
  Curry_Prelude.Choice_C_Char d i l r -> narrow d i (d_C__case_8 x19 l cd cs)
    (d_C__case_8 x19 r cd cs)
  Curry_Prelude.Choices_C_Char d i xs -> narrows cs d i (\z -> d_C__case_8 x19 z
    cd cs) xs
  Curry_Prelude.Guard_C_Char d c e -> guardCons d c ((\x -> d_C__case_8 x19 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Char d info -> failCons d (traceFail
    "FlatCurry.XML._case_8" [show x19, show x18] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_8" (showCons x18))

d_C__case_7 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Fixity
d_C__case_7 x19 cd cs = case x19 of
  Curry_Prelude.OP_Cons x20 x21 -> d_C__case_6 x21 x20 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_7 l cd cs)
    (d_C__case_7 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_7 z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_7 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.XML._case_7" [show x19] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_7" (showCons x19))

d_C__case_6 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Fixity
d_C__case_6 x21 x20 cd cs = case x20 of
  (Curry_Prelude.C_Char 'p'#) -> d_C__case_5 x21 cd cs
  Curry_Prelude.CurryChar l -> matchChar [('p', d_C__case_5 x21 cd cs)] l cd cs
  Curry_Prelude.Choice_C_Char d i l r -> narrow d i (d_C__case_6 x21 l cd cs)
    (d_C__case_6 x21 r cd cs)
  Curry_Prelude.Choices_C_Char d i xs -> narrows cs d i (\z -> d_C__case_6 x21 z
    cd cs) xs
  Curry_Prelude.Guard_C_Char d c e -> guardCons d c ((\x -> d_C__case_6 x21 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Char d info -> failCons d (traceFail
    "FlatCurry.XML._case_6" [show x21, show x20] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_6" (showCons x20))

d_C__case_5 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Fixity
d_C__case_5 x21 cd cs = case x21 of
  Curry_Prelude.OP_List -> FlatCurry.Curry_Types.C_InfixlOp
  Curry_Prelude.OP_Cons x22 x23 -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_5 l cd cs)
    (d_C__case_5 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_5 z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_5 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.XML._case_5" [show x21] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_5" (showCons x21))

d_C__case_12 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> FlatCurry.Curry_Types.C_Fixity
d_C__case_12 x13 cd cs = case x13 of
  Curry_Prelude.OP_Cons x14 x15 -> d_C__case_11 x15 x14 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_12 l cd cs)
    (d_C__case_12 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_12 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_12 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.XML._case_12" [show x13] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_12" (showCons x13))

d_C__case_11 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Fixity
d_C__case_11 x15 x14 cd cs = case x14 of
  (Curry_Prelude.C_Char 'p'#) -> d_C__case_10 x15 cd cs
  Curry_Prelude.CurryChar l -> matchChar [('p', d_C__case_10 x15 cd cs)] l cd cs
  Curry_Prelude.Choice_C_Char d i l r -> narrow d i (d_C__case_11 x15 l cd cs)
    (d_C__case_11 x15 r cd cs)
  Curry_Prelude.Choices_C_Char d i xs -> narrows cs d i (\z -> d_C__case_11 x15
    z cd cs) xs
  Curry_Prelude.Guard_C_Char d c e -> guardCons d c ((\x -> d_C__case_11 x15 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Char d info -> failCons d (traceFail
    "FlatCurry.XML._case_11" [show x15, show x14] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_11" (showCons x14))

d_C__case_10 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> FlatCurry.Curry_Types.C_Fixity
d_C__case_10 x15 cd cs = case x15 of
  Curry_Prelude.OP_List -> FlatCurry.Curry_Types.C_InfixOp
  Curry_Prelude.OP_Cons x16 x17 -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_10 l cd cs)
    (d_C__case_10 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_10 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_10 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.XML._case_10" [show x15] info)
  _ -> failCons cd (consFail "FlatCurry.XML._case_10" (showCons x15))

