{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module FlatCurry.Curry_Names2SMT ( d_C_unaryPrimOps, d_C_binaryPrimOps ) where

import Basics
import qualified Curry_Prelude


d_C_unaryPrimOps :: Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_unaryPrimOps cd cs = Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "_impl#negate#Prelude.Num#Prelude.Int#")
  (Curry_Prelude.toCurryString "-")) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#sqrt#Prelude.Floating#Prelude.Float#") (Curry_Prelude.toCurryString
  "sqrt")) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "not") (Curry_Prelude.toCurryString "not"))
  Curry_Prelude.OP_List))

d_C_binaryPrimOps :: Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_binaryPrimOps cd cs = Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "&&") (Curry_Prelude.toCurryString "and"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "||") (Curry_Prelude.toCurryString "or")) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "==")
  (Curry_Prelude.toCurryString "=")) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "constrEq")
  (Curry_Prelude.toCurryString "=")) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#==#Prelude.Eq#Prelude.Int#") (Curry_Prelude.toCurryString "="))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#==#Prelude.Eq#Prelude.Float#") (Curry_Prelude.toCurryString "="))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#==#Prelude.Eq#Prelude.Char#") (Curry_Prelude.toCurryString "="))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "/=") (Curry_Prelude.toCurryString "/=")) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#/=#Prelude.Eq#Prelude.Int#") (Curry_Prelude.toCurryString "/="))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#/=#Prelude.Eq#Prelude.Float#") (Curry_Prelude.toCurryString "/="))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#/=#Prelude.Eq#Prelude.Char#") (Curry_Prelude.toCurryString "/="))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#+#Prelude.Num#Prelude.Int#") (Curry_Prelude.toCurryString "+"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#-#Prelude.Num#Prelude.Int#") (Curry_Prelude.toCurryString "-"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#*#Prelude.Num#Prelude.Int#") (Curry_Prelude.toCurryString "*"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#negate#Prelude.Num#Prelude.Int#") (Curry_Prelude.toCurryString "-"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#div#Prelude.Integral#Prelude.Int#") (Curry_Prelude.toCurryString
  "div")) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "_impl#mod#Prelude.Integral#Prelude.Int#")
  (Curry_Prelude.toCurryString "mod")) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#rem#Prelude.Integral#Prelude.Int#") (Curry_Prelude.toCurryString
  "rem")) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "_impl#>#Prelude.Ord#Prelude.Int#")
  (Curry_Prelude.toCurryString ">")) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#<#Prelude.Ord#Prelude.Int#") (Curry_Prelude.toCurryString "<"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#>=#Prelude.Ord#Prelude.Int#") (Curry_Prelude.toCurryString ">="))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#<=#Prelude.Ord#Prelude.Int#") (Curry_Prelude.toCurryString "<="))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#+#Prelude.Num#Prelude.Float#") (Curry_Prelude.toCurryString "+"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#-#Prelude.Num#Prelude.Float#") (Curry_Prelude.toCurryString "-"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#*#Prelude.Num#Prelude.Float#") (Curry_Prelude.toCurryString "*"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#/#Prelude.Num#Prelude.Float#") (Curry_Prelude.toCurryString "/"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#>#Prelude.Ord#Prelude.Float#") (Curry_Prelude.toCurryString ">"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#<#Prelude.Ord#Prelude.Float#") (Curry_Prelude.toCurryString "<"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#>=#Prelude.Ord#Prelude.Float#") (Curry_Prelude.toCurryString ">="))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#<=#Prelude.Ord#Prelude.Float#") (Curry_Prelude.toCurryString "<="))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#>#Prelude.Ord#Prelude.Char#") (Curry_Prelude.toCurryString ">"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#<#Prelude.Ord#Prelude.Char#") (Curry_Prelude.toCurryString "<"))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#>=#Prelude.Ord#Prelude.Char#") (Curry_Prelude.toCurryString ">="))
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "_impl#<=#Prelude.Ord#Prelude.Char#") (Curry_Prelude.toCurryString "<="))
  Curry_Prelude.OP_List)))))))))))))))))))))))))))))))))

