{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Language.Go.Curry_ShowS
  ( d_C_showGoProg, d_C_showGoStat, d_C_showGoExpr )
  where

import Basics
import qualified Language.Go.Curry_Types
import qualified Curry_Prelude


d_C_showGoProg :: Language.Go.Curry_Types.C_GoProg -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showGoProg x1 cd cs = case x1 of
  Language.Go.Curry_Types.C_GoProg x2 x3 x4 -> Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "package "))
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString x2)
    (Curry_Prelude.d_OP_dot (d_C_showLn cd cs) (Curry_Prelude.d_OP_dot
    (d_C_showLn cd cs) (Curry_Prelude.d_OP_dot (d_C_showGoImports x3 cd cs)
    (d_C_mapS d_OP_showGoProg_dot_uscore_hash_lambda1 x4 cd cs) cd cs) cd cs) cd
    cs) cd cs) cd cs
  Language.Go.Curry_Types.Choice_C_GoProg d i l r -> narrow d i (d_C_showGoProg
    l cd cs) (d_C_showGoProg r cd cs)
  Language.Go.Curry_Types.Choices_C_GoProg d i xs -> narrows cs d i (\z ->
    d_C_showGoProg z cd cs) xs
  Language.Go.Curry_Types.Guard_C_GoProg d c e -> guardCons d c ((\x ->
    d_C_showGoProg e cd x) $! addCs c cs)
  Language.Go.Curry_Types.Fail_C_GoProg d info -> failCons d (traceFail
    "Language.Go.ShowS.showGoProg" [show x1] info)
  _ -> failCons cd (consFail "Language.Go.ShowS.showGoProg" (showCons x1))

d_OP_showGoProg_dot_uscore_hash_lambda1 :: Language.Go.Curry_Types.C_GoTopLevelDecl
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showGoProg_dot_uscore_hash_lambda1 x1 cd cs = Curry_Prelude.d_OP_dot
  (d_C_showGoTopLevelDecl x1 cd cs) (d_C_showLn cd cs) cd cs

d_C_showGoImports :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_showGoImports x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> d_C_showLn cd cs
  Curry_Prelude.OP_Cons x2 x3 -> Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "import "))
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_shows
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    cd cs) x2 cd cs) (Curry_Prelude.d_OP_dot (d_C_showLn cd cs)
    (d_C_showGoImports x3 cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_showGoImports l cd cs)
    (d_C_showGoImports r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_showGoImports z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_showGoImports e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Go.ShowS.showGoImports" [show x1] info)
  _ -> failCons cd (consFail "Language.Go.ShowS.showGoImports" (showCons x1))

d_C_showGoTopLevelDecl :: Language.Go.Curry_Types.C_GoTopLevelDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showGoTopLevelDecl x1 cd cs = case x1 of
  Language.Go.Curry_Types.C_GoTopLevelDecl x2 -> d_C_showGoStat
    (Curry_Prelude.C_Int (0)) x2 cd cs
  Language.Go.Curry_Types.C_GoTopLevelFuncDecl x3 -> d_C_showGoFuncDecl x3 cd cs
  Language.Go.Curry_Types.Choice_C_GoTopLevelDecl d i l r -> narrow d i
    (d_C_showGoTopLevelDecl l cd cs) (d_C_showGoTopLevelDecl r cd cs)
  Language.Go.Curry_Types.Choices_C_GoTopLevelDecl d i xs -> narrows cs d i
    (\z -> d_C_showGoTopLevelDecl z cd cs) xs
  Language.Go.Curry_Types.Guard_C_GoTopLevelDecl d c e -> guardCons d c ((\x ->
    d_C_showGoTopLevelDecl e cd x) $! addCs c cs)
  Language.Go.Curry_Types.Fail_C_GoTopLevelDecl d info -> failCons d (traceFail
    "Language.Go.ShowS.showGoTopLevelDecl" [show x1] info)
  _ -> failCons cd (consFail "Language.Go.ShowS.showGoTopLevelDecl" (showCons
    x1))

d_C_showGoFuncDecl :: Language.Go.Curry_Types.C_GoFuncDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showGoFuncDecl x1 cd cs = case x1 of
  Language.Go.Curry_Types.C_GoFuncDecl x2 x3 x4 x5 -> Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "func "))
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString x2)
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString "( ")) (Curry_Prelude.d_OP_dot
    (d_C_showGoCommaList d_C_showGoParam x3 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " )( "))
    (Curry_Prelude.d_OP_dot (d_C_showGoCommaList d_C_showGoParam x4 cd cs)
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString " ){\n")) (Curry_Prelude.d_OP_dot (d_C_mapS
    (d_C_showGoStat (Curry_Prelude.C_Int (1))) x5 cd cs)
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "}\n")) cd cs) cd
    cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs
  Language.Go.Curry_Types.Choice_C_GoFuncDecl d i l r -> narrow d i
    (d_C_showGoFuncDecl l cd cs) (d_C_showGoFuncDecl r cd cs)
  Language.Go.Curry_Types.Choices_C_GoFuncDecl d i xs -> narrows cs d i (\z ->
    d_C_showGoFuncDecl z cd cs) xs
  Language.Go.Curry_Types.Guard_C_GoFuncDecl d c e -> guardCons d c ((\x ->
    d_C_showGoFuncDecl e cd x) $! addCs c cs)
  Language.Go.Curry_Types.Fail_C_GoFuncDecl d info -> failCons d (traceFail
    "Language.Go.ShowS.showGoFuncDecl" [show x1] info)
  _ -> failCons cd (consFail "Language.Go.ShowS.showGoFuncDecl" (showCons x1))

d_C_showGoStat :: Curry_Prelude.C_Int -> Language.Go.Curry_Types.C_GoStat
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showGoStat x1 x2 cd cs = case x2 of
  Language.Go.Curry_Types.C_GoConstDecl x3 x4 x5 -> d_C__case_5 x4 x3 x1 x5 cd
    cs
  Language.Go.Curry_Types.C_GoVarDecl x8 x9 x10 -> d_C__case_4 x9 x8 x1 x10 cd
    cs
  Language.Go.Curry_Types.C_GoShortVarDecl x13 x14 -> Curry_Prelude.d_OP_dot
    (d_C_indent x1 cd cs) (Curry_Prelude.d_OP_dot (d_C_showGoCommaList (acceptCs
    id Curry_Prelude.d_C_showString) x13 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " := "))
    (Curry_Prelude.d_OP_dot (d_C_showGoCommaList d_C_showGoExpr x14 cd cs)
    (d_C_showLn cd cs) cd cs) cd cs) cd cs) cd cs
  Language.Go.Curry_Types.C_GoExprStat x15 -> Curry_Prelude.d_OP_dot (d_C_indent
    x1 cd cs) (Curry_Prelude.d_OP_dot (d_C_showGoExpr x15 cd cs) (d_C_showLn cd
    cs) cd cs) cd cs
  Language.Go.Curry_Types.C_GoAssign x16 x17 x18 -> Curry_Prelude.d_OP_dot
    (d_C_indent x1 cd cs) (Curry_Prelude.d_OP_dot (d_C_showGoCommaList
    d_C_showGoExpr x16 cd cs) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_showChar cd cs) (Curry_Prelude.C_Char ' '#) cd cs)
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString x17)
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_showChar
    cd cs) (Curry_Prelude.C_Char ' '#) cd cs) (Curry_Prelude.d_OP_dot
    (d_C_showGoCommaList d_C_showGoExpr x18 cd cs) (d_C_showLn cd cs) cd cs) cd
    cs) cd cs) cd cs) cd cs) cd cs
  Language.Go.Curry_Types.C_GoEmpty -> d_C_showLn cd cs
  Language.Go.Curry_Types.C_GoReturn x19 -> d_C__case_3 x1 x19 cd cs
  Language.Go.Curry_Types.C_GoBreak -> Curry_Prelude.d_OP_dot (d_C_indent x1 cd
    cs) (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "break\n"))
    cd cs
  Language.Go.Curry_Types.C_GoContinue -> Curry_Prelude.d_OP_dot (d_C_indent x1
    cd cs) (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "continue\n")) cd cs
  Language.Go.Curry_Types.C_GoBlock x22 -> Curry_Prelude.d_OP_dot (d_C_indent x1
    cd cs) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString "{\n")) (Curry_Prelude.d_OP_dot (d_C_mapS
    (d_C_showGoStat
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 (Curry_Prelude.C_Int (1)) cd cs)) x22 cd cs) (Curry_Prelude.d_OP_dot
    (d_C_indent x1 cd cs) (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString "}\n")) cd cs) cd cs) cd cs) cd cs
  Language.Go.Curry_Types.C_GoIf x23 x24 x25 -> Curry_Prelude.d_OP_dot
    (d_C_indent x1 cd cs) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString "if( ")) (Curry_Prelude.d_OP_dot
    (d_C_showGoExpr x23 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " ){\n"))
    (Curry_Prelude.d_OP_dot (d_C_mapS (d_C_showGoStat
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 (Curry_Prelude.C_Int (1)) cd cs)) x24 cd cs) (Curry_Prelude.d_OP_dot
    (d_C_indent x1 cd cs) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString "}else {\n")) (Curry_Prelude.d_OP_dot (d_C_mapS
    (d_C_showGoStat
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 (Curry_Prelude.C_Int (1)) cd cs)) x25 cd cs) (Curry_Prelude.d_OP_dot
    (d_C_indent x1 cd cs) (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString "}\n")) cd cs) cd cs) cd cs) cd cs) cd cs) cd
    cs) cd cs) cd cs) cd cs
  Language.Go.Curry_Types.C_GoExprSwitch x26 x27 -> Curry_Prelude.d_OP_dot
    (d_C_indent x1 cd cs) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString "switch ")) (Curry_Prelude.d_OP_dot
    (d_C_showGoExpr x26 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "{\n"))
    (Curry_Prelude.d_OP_dot (d_C_mapS (d_C_goShowExprBranch
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 (Curry_Prelude.C_Int (1)) cd cs)) x27 cd cs) (Curry_Prelude.d_OP_dot
    (d_C_indent x1 cd cs) (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString "}\n")) cd cs) cd cs) cd cs) cd cs) cd cs) cd
    cs
  Language.Go.Curry_Types.Choice_C_GoStat d i l r -> narrow d i (d_C_showGoStat
    x1 l cd cs) (d_C_showGoStat x1 r cd cs)
  Language.Go.Curry_Types.Choices_C_GoStat d i xs -> narrows cs d i (\z ->
    d_C_showGoStat x1 z cd cs) xs
  Language.Go.Curry_Types.Guard_C_GoStat d c e -> guardCons d c ((\x ->
    d_C_showGoStat x1 e cd x) $! addCs c cs)
  Language.Go.Curry_Types.Fail_C_GoStat d info -> failCons d (traceFail
    "Language.Go.ShowS.showGoStat" [show x1, show x2] info)
  _ -> failCons cd (consFail "Language.Go.ShowS.showGoStat" (showCons x2))

d_C_showGoExpr :: Language.Go.Curry_Types.C_GoExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showGoExpr x1 cd cs = case x1 of
  Language.Go.Curry_Types.C_GoBoolLit x2 -> Curry_Prelude.d_OP_dollar (acceptCs
    id Curry_Prelude.d_C_showString) (d_C__case_2 x2 cd cs) cd cs
  Language.Go.Curry_Types.C_GoIntLit x3 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_shows
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x3 cd cs
  Language.Go.Curry_Types.C_GoFloatLit x4 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_shows
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Float_hash
    cd cs) x4 cd cs
  Language.Go.Curry_Types.C_GoStringLit x5 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_shows
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    cd cs) x5 cd cs
  Language.Go.Curry_Types.C_GoByteLit x6 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_shows
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash
    cd cs) x6 cd cs
  Language.Go.Curry_Types.C_GoCompositeLit x7 x8 -> Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString x7) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "{ "))
    (Curry_Prelude.d_OP_dot (d_C_showGoCommaList d_C_showGoExpr x8 cd cs)
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " }")) cd cs) cd
    cs) cd cs
  Language.Go.Curry_Types.C_GoOpName x9 -> Curry_Prelude.d_C_showString x9
  Language.Go.Curry_Types.C_GoOpExpr x10 -> Curry_Prelude.d_C_showParen
    Curry_Prelude.C_True (d_C_showGoExpr x10 cd cs) cd cs
  Language.Go.Curry_Types.C_GoConversion x11 x12 -> Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString x11) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "( "))
    (Curry_Prelude.d_OP_dot (d_C_showGoExpr x12 cd cs)
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " )")) cd cs) cd
    cs) cd cs
  Language.Go.Curry_Types.C_GoSelector x13 x14 -> Curry_Prelude.d_OP_dot
    (d_C_showGoExpr x13 cd cs) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_showChar cd cs) (Curry_Prelude.C_Char '.'#) cd cs)
    (Curry_Prelude.d_C_showString x14) cd cs) cd cs
  Language.Go.Curry_Types.C_GoIndex x15 x16 -> Curry_Prelude.d_OP_dot
    (d_C_showGoExpr x15 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "[ "))
    (Curry_Prelude.d_OP_dot (d_C_showGoExpr x16 cd cs)
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " ]")) cd cs) cd
    cs) cd cs
  Language.Go.Curry_Types.C_GoSlice x17 x18 x19 -> Curry_Prelude.d_OP_dot
    (d_C_showGoExpr x17 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "[ "))
    (Curry_Prelude.d_OP_dot (d_C_showGoExpr x18 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " : "))
    (Curry_Prelude.d_OP_dot (d_C_showGoExpr x19 cd cs)
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " ]")) cd cs) cd
    cs) cd cs) cd cs) cd cs
  Language.Go.Curry_Types.C_GoVariadic x20 -> Curry_Prelude.d_OP_dot
    (d_C_showGoExpr x20 cd cs) (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString "...")) cd cs
  Language.Go.Curry_Types.C_GoCall x21 x22 -> Curry_Prelude.d_OP_dot
    (d_C_showGoExpr x21 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "( "))
    (Curry_Prelude.d_OP_dot (d_C_showGoCommaList d_C_showGoExpr x22 cd cs)
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " )")) cd cs) cd
    cs) cd cs
  Language.Go.Curry_Types.C_GoUnaryExpr x23 x24 -> Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString x23) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_showChar cd cs)
    (Curry_Prelude.C_Char ' '#) cd cs) (d_C_showGoExpr x24 cd cs) cd cs) cd cs
  Language.Go.Curry_Types.C_GoBinaryExpr x25 x26 x27 -> Curry_Prelude.d_OP_dot
    (d_C_showGoExpr x25 cd cs) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_showChar cd cs) (Curry_Prelude.C_Char ' '#) cd cs)
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString x26)
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_showChar
    cd cs) (Curry_Prelude.C_Char ' '#) cd cs) (d_C_showGoExpr x27 cd cs) cd cs)
    cd cs) cd cs) cd cs
  Language.Go.Curry_Types.Choice_C_GoExpr d i l r -> narrow d i (d_C_showGoExpr
    l cd cs) (d_C_showGoExpr r cd cs)
  Language.Go.Curry_Types.Choices_C_GoExpr d i xs -> narrows cs d i (\z ->
    d_C_showGoExpr z cd cs) xs
  Language.Go.Curry_Types.Guard_C_GoExpr d c e -> guardCons d c ((\x ->
    d_C_showGoExpr e cd x) $! addCs c cs)
  Language.Go.Curry_Types.Fail_C_GoExpr d info -> failCons d (traceFail
    "Language.Go.ShowS.showGoExpr" [show x1] info)
  _ -> failCons cd (consFail "Language.Go.ShowS.showGoExpr" (showCons x1))

d_C_goShowExprBranch :: Curry_Prelude.C_Int
  -> Language.Go.Curry_Types.C_GoExprBranch -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_goShowExprBranch x1 x2 cd cs = case x2 of
  Language.Go.Curry_Types.C_GoExprDefault x3 -> Curry_Prelude.d_OP_dot
    (d_C_indent x1 cd cs) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString "default:\n")) (d_C_mapS (d_C_showGoStat
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 (Curry_Prelude.C_Int (1)) cd cs)) x3 cd cs) cd cs) cd cs
  Language.Go.Curry_Types.C_GoExprBranch x4 x5 -> Curry_Prelude.d_OP_dot
    (d_C_indent x1 cd cs) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString "case ")) (Curry_Prelude.d_OP_dot
    (d_C_showGoCommaList d_C_showGoExpr x4 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString ":\n")) (d_C_mapS
    (d_C_showGoStat
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 (Curry_Prelude.C_Int (1)) cd cs)) x5 cd cs) cd cs) cd cs) cd cs) cd cs
  Language.Go.Curry_Types.Choice_C_GoExprBranch d i l r -> narrow d i
    (d_C_goShowExprBranch x1 l cd cs) (d_C_goShowExprBranch x1 r cd cs)
  Language.Go.Curry_Types.Choices_C_GoExprBranch d i xs -> narrows cs d i (\z ->
    d_C_goShowExprBranch x1 z cd cs) xs
  Language.Go.Curry_Types.Guard_C_GoExprBranch d c e -> guardCons d c ((\x ->
    d_C_goShowExprBranch x1 e cd x) $! addCs c cs)
  Language.Go.Curry_Types.Fail_C_GoExprBranch d info -> failCons d (traceFail
    "Language.Go.ShowS.goShowExprBranch" [show x1, show x2] info)
  _ -> failCons cd (consFail "Language.Go.ShowS.goShowExprBranch" (showCons x2))

d_C_showGoParam :: Language.Go.Curry_Types.C_GoParam -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showGoParam x1 cd cs = case x1 of
  Language.Go.Curry_Types.C_GoParam x2 x3 -> d_C__case_1 x3 x2 cd cs
  Language.Go.Curry_Types.Choice_C_GoParam d i l r -> narrow d i
    (d_C_showGoParam l cd cs) (d_C_showGoParam r cd cs)
  Language.Go.Curry_Types.Choices_C_GoParam d i xs -> narrows cs d i (\z ->
    d_C_showGoParam z cd cs) xs
  Language.Go.Curry_Types.Guard_C_GoParam d c e -> guardCons d c ((\x ->
    d_C_showGoParam e cd x) $! addCs c cs)
  Language.Go.Curry_Types.Fail_C_GoParam d info -> failCons d (traceFail
    "Language.Go.ShowS.showGoParam" [show x1] info)
  _ -> failCons cd (consFail "Language.Go.ShowS.showGoParam" (showCons x1))

d_C_showGoCommaList :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_showGoCommaList x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_id
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_0 x1 x3 x4 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_showGoCommaList x1 l
    cd cs) (d_C_showGoCommaList x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_showGoCommaList x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_showGoCommaList
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Go.ShowS.showGoCommaList" [show x1, show x2] info)
  _ -> failCons cd (consFail "Language.Go.ShowS.showGoCommaList" (showCons x2))

nd_C_showGoCommaList :: forall t0 . (Curry_Prelude.Curry t0) => Func t0 (Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C_showGoCommaList x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_List -> wrapDX id Curry_Prelude.d_C_id
  Curry_Prelude.OP_Cons x3 x4 -> let s0 = s
    in s0 `seq` nd_C__case_0 x1 x3 x4 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_showGoCommaList x1 l
    s cd cs) (nd_C_showGoCommaList x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_C_showGoCommaList x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    nd_C_showGoCommaList x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Go.ShowS.showGoCommaList" [show x1, show x2] info)
  _ -> failCons cd (consFail "Language.Go.ShowS.showGoCommaList" (showCons x2))

d_C_indent :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_indent x1 cd cs = Curry_Prelude.d_C_showString (Curry_Prelude.d_C_replicate
  (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.C_Int (4)) x1 cd cs) (Curry_Prelude.C_Char ' '#) cd cs)

d_C_mapS :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_mapS x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_id
  Curry_Prelude.OP_Cons x3 x4 -> Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply
    x1 x3 cd cs) (d_C_mapS x1 x4 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_mapS x1 l cd cs)
    (d_C_mapS x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_mapS x1 z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_mapS x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Go.ShowS.mapS" [show x1, show x2] info)
  _ -> failCons cd (consFail "Language.Go.ShowS.mapS" (showCons x2))

nd_C_mapS :: forall t0 . (Curry_Prelude.Curry t0) => Func t0 (Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C_mapS x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_List -> wrapDX id Curry_Prelude.d_C_id
  Curry_Prelude.OP_Cons x3 x4 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_OP_dot
    (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs) (nd_C_mapS x1 x4 s1 cd cs) s2 cd
    cs))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_mapS x1 l s cd cs)
    (nd_C_mapS x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_mapS x1 z s
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_mapS x1 e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Go.ShowS.mapS" [show x1, show x2] info)
  _ -> failCons cd (consFail "Language.Go.ShowS.mapS" (showCons x2))

d_C_showLn :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showLn cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_showChar cd cs)
  (Curry_Prelude.C_Char '\n'#) cd cs

d_C__case_3 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Language.Go.Curry_Types.C_GoExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_3 x1 x19 cd cs = case x19 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_dot (d_C_indent x1 cd cs)
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "return\n")) cd
    cs
  Curry_Prelude.OP_Cons x20 x21 -> Curry_Prelude.d_OP_dot (d_C_indent x1 cd cs)
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString "return( ")) (Curry_Prelude.d_OP_dot
    (d_C_showGoCommaList d_C_showGoExpr x19 cd cs) (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString " )\n")) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_3 x1 l cd cs)
    (d_C__case_3 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_3 x1 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_3 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Go.ShowS._case_3" [show x1, show x19] info)
  _ -> failCons cd (consFail "Language.Go.ShowS._case_3" (showCons x19))

d_C__case_4 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Language.Go.Curry_Types.C_GoExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_4 x9 x8 x1 x10 cd cs = case x10 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_dot (d_C_indent x1 cd cs)
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString "var ")) (Curry_Prelude.d_OP_dot
    (d_C_showGoCommaList (acceptCs id Curry_Prelude.d_C_showString) x8 cd cs)
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_showChar
    cd cs) (Curry_Prelude.C_Char ' '#) cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString x9) (d_C_showLn cd cs) cd cs) cd cs) cd cs) cd
    cs) cd cs
  Curry_Prelude.OP_Cons x11 x12 -> Curry_Prelude.d_OP_dot (d_C_indent x1 cd cs)
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString "var ")) (Curry_Prelude.d_OP_dot
    (d_C_showGoCommaList (acceptCs id Curry_Prelude.d_C_showString) x8 cd cs)
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_showChar
    cd cs) (Curry_Prelude.C_Char ' '#) cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString x9) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " = "))
    (Curry_Prelude.d_OP_dot (d_C_showGoCommaList d_C_showGoExpr x10 cd cs)
    (d_C_showLn cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_4 x9 x8 x1 l cd
    cs) (d_C__case_4 x9 x8 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_4 x9
    x8 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_4 x9 x8
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Go.ShowS._case_4" [show x9, show x8, show x1, show x10] info)
  _ -> failCons cd (consFail "Language.Go.ShowS._case_4" (showCons x10))

d_C__case_5 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Language.Go.Curry_Types.C_GoExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_5 x4 x3 x1 x5 cd cs = case x5 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_dot (d_C_indent x1 cd cs)
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString "const ")) (Curry_Prelude.d_OP_dot
    (d_C_showGoCommaList (acceptCs id Curry_Prelude.d_C_showString) x3 cd cs)
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_showChar
    cd cs) (Curry_Prelude.C_Char ' '#) cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString x4) (d_C_showLn cd cs) cd cs) cd cs) cd cs) cd
    cs) cd cs
  Curry_Prelude.OP_Cons x6 x7 -> Curry_Prelude.d_OP_dot (d_C_indent x1 cd cs)
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString "const ")) (Curry_Prelude.d_OP_dot
    (d_C_showGoCommaList (acceptCs id Curry_Prelude.d_C_showString) x3 cd cs)
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_showChar
    cd cs) (Curry_Prelude.C_Char ' '#) cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString x4) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " = "))
    (Curry_Prelude.d_OP_dot (d_C_showGoCommaList d_C_showGoExpr x5 cd cs)
    (d_C_showLn cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_5 x4 x3 x1 l cd
    cs) (d_C__case_5 x4 x3 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_5 x4
    x3 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_5 x4 x3
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Go.ShowS._case_5" [show x4, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "Language.Go.ShowS._case_5" (showCons x5))

d_C__case_2 :: Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_2 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "true"
  Curry_Prelude.C_False -> Curry_Prelude.toCurryString "false"
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 l cd cs)
    (d_C__case_2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 z cd
    cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Go.ShowS._case_2" [show x2] info)
  _ -> failCons cd (consFail "Language.Go.ShowS._case_2" (showCons x2))

d_C__case_1 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_1 x3 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_showString x3
  Curry_Prelude.OP_Cons x4 x5 -> Curry_Prelude.d_OP_dot (d_C_showGoCommaList
    (acceptCs id Curry_Prelude.d_C_showString) x2 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_showChar cd cs)
    (Curry_Prelude.C_Char ' '#) cd cs) (Curry_Prelude.d_C_showString x3) cd cs)
    cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_1 x3 l cd cs)
    (d_C__case_1 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_1 x3 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_1 x3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Go.ShowS._case_1" [show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Go.ShowS._case_1" (showCons x2))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_0 x1 x3 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_apply x1 x3 cd cs
  Curry_Prelude.OP_Cons x5 x6 -> Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply
    x1 x3 cd cs) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString ", ")) (d_C_showGoCommaList x1 x4 cd cs) cd cs)
    cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_0 x1 x3 l cd cs)
    (d_C__case_0 x1 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_0 x1
    x3 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_0 x1 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Go.ShowS._case_0" [show x1, show x3, show x4] info)
  _ -> failCons cd (consFail "Language.Go.ShowS._case_0" (showCons x4))

nd_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Func t0 (Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> t0 -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C__case_0 x1 x3 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x1 x3 s0 cd cs
  Curry_Prelude.OP_Cons x5 x6 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_OP_dot
    (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs) (let s2 = leftSupply s3
                                                   s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString ", ")))
    (nd_C_showGoCommaList x1 x4 s1 cd cs) s2 cd cs)) s4 cd cs))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_0 x1 x3 l s cd
    cs) (nd_C__case_0 x1 x3 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_0 x1
    x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_0 x1 x3
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Go.ShowS._case_0" [show x1, show x3, show x4] info)
  _ -> failCons cd (consFail "Language.Go.ShowS._case_0" (showCons x4))

