{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module HTML.Curry_Parser
  ( C_HtmlToken (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_HTML_dot_Parser_dot_HtmlToken_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_HTML_dot_Parser_dot_HtmlToken_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_HTML_dot_Parser_dot_HtmlToken_hash
  , d_C_readHtmlFile
  , nd_C_readHtmlFile
  , d_C_parseHtmlString
  , nd_C_parseHtmlString )
  where

import Basics
import qualified Data.Curry_Char
import qualified HTML.Curry_Base
import qualified Curry_Prelude


data C_HtmlToken
  = C_HTText (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_HTElem (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  | Choice_C_HtmlToken Cover ID C_HtmlToken C_HtmlToken
  | Choices_C_HtmlToken Cover ID [C_HtmlToken]
  | Fail_C_HtmlToken Cover FailInfo
  | Guard_C_HtmlToken Cover Constraints C_HtmlToken

instance Show C_HtmlToken where
  showsPrec d (Choice_C_HtmlToken cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_HtmlToken cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_HtmlToken cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_HtmlToken cd info) = showChar '!'
  showsPrec _ (C_HTText x1) = showString "(HTText" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_HTElem x1 x2) = showString "(HTElem" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))

instance Read C_HtmlToken where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_HTText x1, r1) | (_, r0) <-
    readQualified "HTML.Parser" "HTText" r, (x1, r1) <- readsPrec 11 r0]) s ++
    readParen ((>) d 10) (\r -> [(C_HTElem x1 x2, r2) | (_, r0) <- readQualified
    "HTML.Parser" "HTElem" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec
    11 r1]) s

instance NonDet C_HtmlToken where
  choiceCons = Choice_C_HtmlToken
  choicesCons = Choices_C_HtmlToken
  failCons = Fail_C_HtmlToken
  guardCons = Guard_C_HtmlToken
  try (Choice_C_HtmlToken cd i x y) = tryChoice cd i x y
  try (Choices_C_HtmlToken cd i xs) = tryChoices cd i xs
  try (Fail_C_HtmlToken cd info) = Fail cd info
  try (Guard_C_HtmlToken cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_HtmlToken cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_HtmlToken cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_HtmlToken cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_HtmlToken cd i _) = error
    ("HTML.Parser.HtmlToken.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_HtmlToken cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_HtmlToken cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_HtmlToken where
  generate s c = Choices_C_HtmlToken c (freeID [1, 2] s) [C_HTText (generate
    (leftSupply s) c), C_HTElem (generate (leftSupply s) c) (generate
    (rightSupply s) c)]

instance NormalForm C_HtmlToken where
  ($!!) cont (C_HTText x1) d cs = ($!!) (\y1 d cs -> cont (C_HTText y1) d cs) x1
    d cs
  ($!!) cont (C_HTElem x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_HTElem y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_HtmlToken cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_HtmlToken cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_HtmlToken cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_HtmlToken cd info) _ _ = failCons cd info
  ($##) cont (C_HTText x1) d cs = ($##) (\y1 d cs -> cont (C_HTText y1) d cs) x1
    d cs
  ($##) cont (C_HTElem x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_HTElem y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_HtmlToken cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_HtmlToken cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_HtmlToken cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_HtmlToken cd info) _ _ = failCons cd info
  showCons (C_HTText _) = "HTML.Parser.HTText _"
  showCons (C_HTElem _ _) = "HTML.Parser.HTElem _ _"
  showCons x = error ("HTML.Parser.HtmlToken.showCons: no constructor: " ++ show
    x)
  searchNF search cont (C_HTText x1) = search (\y1 -> cont (C_HTText y1)) x1
  searchNF search cont (C_HTElem x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_HTElem y1 y2)) x2) x1
  searchNF _ _ x = error ("HTML.Parser.HtmlToken.searchNF: no constructor: " ++
    show x)

instance Unifiable C_HtmlToken where
  (=.=) (C_HTText x1) (C_HTText y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_HTElem x1 x2) (C_HTElem y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=)
    x2 y2 d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_HTText x1) (C_HTText y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_HTElem x1 x2) (C_HTElem y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_HTText x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_HTElem x3 x4) = (i :=: ChooseN 1 2) : concat [bind cd (leftID i)
    x3, bind cd (rightID i) x4]
  bind d i (Choice_C_HtmlToken cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_HtmlToken cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_HtmlToken cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_HtmlToken cd i _) = error
    ("HTML.Parser.HtmlToken.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_HtmlToken cd info) = [Unsolvable info]
  bind d i (Guard_C_HtmlToken cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_HTText x3) = (i :=: ChooseN 0 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_HTElem x3 x4) = (i :=: ChooseN 1 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind d i (Choice_C_HtmlToken cd j x y) = [ConstraintChoice cd j (lazyBind
    d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_HtmlToken cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_HtmlToken cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_HtmlToken cd i _) = error
    ("HTML.Parser.HtmlToken.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_HtmlToken cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_HtmlToken cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_HtmlToken where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_HTML_dot_Parser_dot_HtmlToken_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_HtmlToken
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_HTML_dot_Parser_dot_HtmlToken_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_HTML_dot_Parser_dot_HtmlToken_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_HTML_dot_Parser_dot_HtmlToken_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_HTML_dot_Parser_dot_HtmlToken_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_HTML_dot_Parser_dot_HtmlToken_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_HTML_dot_Parser_dot_HtmlToken_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_HTML_dot_Parser_dot_HtmlToken_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "HTML.Parser._inst#Prelude.Data#HTML.Parser.HtmlToken#" [show x1] info)
  _ -> failCons cd (consFail
    "HTML.Parser._inst#Prelude.Data#HTML.Parser.HtmlToken#" (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_HTML_dot_Parser_dot_HtmlToken_hash :: C_HtmlToken
  -> C_HtmlToken -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_HTML_dot_Parser_dot_HtmlToken_hash x1 x2 s cd cs =
  case x1 of
  C_HTText x3 -> let s0 = s in s0 `seq` nd_C__case_28 x3 x2 s0 cd cs
  C_HTElem x7 x8 -> let s0 = s in s0 `seq` nd_C__case_27 x8 x7 x2 s0 cd cs
  Choice_C_HtmlToken d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_HTML_dot_Parser_dot_HtmlToken_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_HTML_dot_Parser_dot_HtmlToken_hash
    r x2 s cd cs)
  Choices_C_HtmlToken d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_HTML_dot_Parser_dot_HtmlToken_hash
    z x2 s cd cs) xs
  Guard_C_HtmlToken d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_HTML_dot_Parser_dot_HtmlToken_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_HtmlToken d info -> failCons d (traceFail
    "HTML.Parser._impl#===#Prelude.Data#HTML.Parser.HtmlToken#" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "HTML.Parser._impl#===#Prelude.Data#HTML.Parser.HtmlToken#" (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_HTML_dot_Parser_dot_HtmlToken_hash :: IDSupply
  -> Cover -> ConstStore -> C_HtmlToken
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_HTML_dot_Parser_dot_HtmlToken_hash s cd cs =
  let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s0 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` choice (C_HTText
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)) (let s1 = leftSupply s3
                  s2 = rightSupply s3
  in s1 `seq` (s2 `seq` C_HTElem
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s1 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  s2 cd cs))) s4 cd cs))))

d_C_readHtmlFile :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List t0)
d_C_readHtmlFile x1 x2 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_readFile x2 cd cs) cd cs) (Curry_Prelude.d_OP_dot
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C_parseHtmlString x1 cd cs) cd cs) cd cs

nd_C_readHtmlFile :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List t0)
nd_C_readHtmlFile x1 x2 s cd cs = let s9 = s
  in s9 `seq` (let s8 = leftSupply s9
                   s10 = rightSupply s9
                   s2 = leftSupply s10
                   s6 = rightSupply s10
  in s8 `seq` (s10 `seq` (s2 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (Curry_Prelude.d_C_readFile x2 cd cs) s1 cd cs))
  (let s5 = leftSupply s6
       s7 = rightSupply s6
       s3 = leftSupply s7
       s4 = rightSupply s7
  in s5 `seq` (s7 `seq` (s3 `seq` (s4 `seq` Curry_Prelude.nd_OP_dot
  (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s3 cd cs) (nd_C_parseHtmlString x1 s4 cd cs) s5 cd cs)))) s8 cd cs))))

d_C_parseHtmlString :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C_parseHtmlString x1 cd cs = Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_map
  (HTML.Curry_Base.d_C_fromStaticHtml x1)) d_C_parseHtml cd cs

nd_C_parseHtmlString :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List t0)
nd_C_parseHtmlString x1 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapNX id (Curry_Prelude.nd_C_map (wrapNX
  id (HTML.Curry_Base.nd_C_fromStaticHtml x1)))) (wrapDX id d_C_parseHtml) s0 cd
  cs

d_C_parseHtml :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml
d_C_parseHtml x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_reverse cd
  cs) (d_C_parseHtmlTokens Curry_Prelude.OP_List (d_C_scanHtmlString x1 cd cs)
  cd cs) cd cs

d_C_parseHtmlTokens :: Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml
  -> Curry_Prelude.OP_List C_HtmlToken -> Cover -> ConstStore
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml
d_C_parseHtmlTokens x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> x1
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_26 x4 x1 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_parseHtmlTokens x1 l
    cd cs) (d_C_parseHtmlTokens x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_parseHtmlTokens x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_parseHtmlTokens
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "HTML.Parser.parseHtmlTokens" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.Parser.parseHtmlTokens" (showCons x2))

d_OP_parseHtmlTokens_dot_uscore_hash_selFP2_hash_structargs :: Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_parseHtmlTokens_dot_uscore_hash_selFP2_hash_structargs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x2
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_parseHtmlTokens_dot_uscore_hash_selFP2_hash_structargs l cd cs)
    (d_OP_parseHtmlTokens_dot_uscore_hash_selFP2_hash_structargs r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_parseHtmlTokens_dot_uscore_hash_selFP2_hash_structargs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_parseHtmlTokens_dot_uscore_hash_selFP2_hash_structargs e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "HTML.Parser.parseHtmlTokens._#selFP2#structargs" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.parseHtmlTokens._#selFP2#structargs"
    (showCons x1))

d_OP_parseHtmlTokens_dot_uscore_hash_selFP3_hash_elems :: Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml
d_OP_parseHtmlTokens_dot_uscore_hash_selFP3_hash_elems x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x3
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_parseHtmlTokens_dot_uscore_hash_selFP3_hash_elems l cd cs)
    (d_OP_parseHtmlTokens_dot_uscore_hash_selFP3_hash_elems r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_parseHtmlTokens_dot_uscore_hash_selFP3_hash_elems z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_parseHtmlTokens_dot_uscore_hash_selFP3_hash_elems e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "HTML.Parser.parseHtmlTokens._#selFP3#elems" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.parseHtmlTokens._#selFP3#elems"
    (showCons x1))

d_OP_parseHtmlTokens_dot_uscore_hash_selFP4_hash_rest :: Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml
d_OP_parseHtmlTokens_dot_uscore_hash_selFP4_hash_rest x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x4
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_parseHtmlTokens_dot_uscore_hash_selFP4_hash_rest l cd cs)
    (d_OP_parseHtmlTokens_dot_uscore_hash_selFP4_hash_rest r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_parseHtmlTokens_dot_uscore_hash_selFP4_hash_rest z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_parseHtmlTokens_dot_uscore_hash_selFP4_hash_rest e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "HTML.Parser.parseHtmlTokens._#selFP4#rest" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.parseHtmlTokens._#selFP4#rest"
    (showCons x1))

d_C_splitHtmlElems :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml)
  (Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml)
d_C_splitHtmlElems x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple3 Curry_Prelude.OP_List
    Curry_Prelude.OP_List Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_23 x1 x4 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_splitHtmlElems x1 l cd
    cs) (d_C_splitHtmlElems x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_splitHtmlElems x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_splitHtmlElems
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "HTML.Parser.splitHtmlElems" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.Parser.splitHtmlElems" (showCons x2))

d_OP_splitHtmlElems_dot_uscore_hash_selFP6_hash_largs :: Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_splitHtmlElems_dot_uscore_hash_selFP6_hash_largs x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x2
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_splitHtmlElems_dot_uscore_hash_selFP6_hash_largs l cd cs)
    (d_OP_splitHtmlElems_dot_uscore_hash_selFP6_hash_largs r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_splitHtmlElems_dot_uscore_hash_selFP6_hash_largs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_splitHtmlElems_dot_uscore_hash_selFP6_hash_largs e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "HTML.Parser.splitHtmlElems._#selFP6#largs" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.splitHtmlElems._#selFP6#largs"
    (showCons x1))

d_OP_splitHtmlElems_dot_uscore_hash_selFP7_hash_elems :: Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml
d_OP_splitHtmlElems_dot_uscore_hash_selFP7_hash_elems x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x3
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_splitHtmlElems_dot_uscore_hash_selFP7_hash_elems l cd cs)
    (d_OP_splitHtmlElems_dot_uscore_hash_selFP7_hash_elems r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_splitHtmlElems_dot_uscore_hash_selFP7_hash_elems z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_splitHtmlElems_dot_uscore_hash_selFP7_hash_elems e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "HTML.Parser.splitHtmlElems._#selFP7#elems" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.splitHtmlElems._#selFP7#elems"
    (showCons x1))

d_OP_splitHtmlElems_dot_uscore_hash_selFP8_hash_rest :: Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml
d_OP_splitHtmlElems_dot_uscore_hash_selFP8_hash_rest x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x4
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_splitHtmlElems_dot_uscore_hash_selFP8_hash_rest l cd cs)
    (d_OP_splitHtmlElems_dot_uscore_hash_selFP8_hash_rest r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_splitHtmlElems_dot_uscore_hash_selFP8_hash_rest z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_splitHtmlElems_dot_uscore_hash_selFP8_hash_rest e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "HTML.Parser.splitHtmlElems._#selFP8#rest" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.splitHtmlElems._#selFP8#rest"
    (showCons x1))

d_OP_splitHtmlElems_dot_uscore_hash_selFP10_hash_largs :: Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_splitHtmlElems_dot_uscore_hash_selFP10_hash_largs x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x2
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_splitHtmlElems_dot_uscore_hash_selFP10_hash_largs l cd cs)
    (d_OP_splitHtmlElems_dot_uscore_hash_selFP10_hash_largs r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_splitHtmlElems_dot_uscore_hash_selFP10_hash_largs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_splitHtmlElems_dot_uscore_hash_selFP10_hash_largs e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "HTML.Parser.splitHtmlElems._#selFP10#largs" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.splitHtmlElems._#selFP10#largs"
    (showCons x1))

d_OP_splitHtmlElems_dot_uscore_hash_selFP11_hash_elems :: Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml
d_OP_splitHtmlElems_dot_uscore_hash_selFP11_hash_elems x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x3
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_splitHtmlElems_dot_uscore_hash_selFP11_hash_elems l cd cs)
    (d_OP_splitHtmlElems_dot_uscore_hash_selFP11_hash_elems r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_splitHtmlElems_dot_uscore_hash_selFP11_hash_elems z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_splitHtmlElems_dot_uscore_hash_selFP11_hash_elems e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "HTML.Parser.splitHtmlElems._#selFP11#elems" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.splitHtmlElems._#selFP11#elems"
    (showCons x1))

d_OP_splitHtmlElems_dot_uscore_hash_selFP12_hash_rest :: Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml
d_OP_splitHtmlElems_dot_uscore_hash_selFP12_hash_rest x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x4
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_splitHtmlElems_dot_uscore_hash_selFP12_hash_rest l cd cs)
    (d_OP_splitHtmlElems_dot_uscore_hash_selFP12_hash_rest r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_splitHtmlElems_dot_uscore_hash_selFP12_hash_rest z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_splitHtmlElems_dot_uscore_hash_selFP12_hash_rest e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "HTML.Parser.splitHtmlElems._#selFP12#rest" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.splitHtmlElems._#selFP12#rest"
    (showCons x1))

d_OP_splitHtmlElems_dot_uscore_hash_selFP14_hash_largs :: Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_splitHtmlElems_dot_uscore_hash_selFP14_hash_largs x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x2
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_splitHtmlElems_dot_uscore_hash_selFP14_hash_largs l cd cs)
    (d_OP_splitHtmlElems_dot_uscore_hash_selFP14_hash_largs r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_splitHtmlElems_dot_uscore_hash_selFP14_hash_largs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_splitHtmlElems_dot_uscore_hash_selFP14_hash_largs e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "HTML.Parser.splitHtmlElems._#selFP14#largs" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.splitHtmlElems._#selFP14#largs"
    (showCons x1))

d_OP_splitHtmlElems_dot_uscore_hash_selFP15_hash_elems :: Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml
d_OP_splitHtmlElems_dot_uscore_hash_selFP15_hash_elems x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x3
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_splitHtmlElems_dot_uscore_hash_selFP15_hash_elems l cd cs)
    (d_OP_splitHtmlElems_dot_uscore_hash_selFP15_hash_elems r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_splitHtmlElems_dot_uscore_hash_selFP15_hash_elems z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_splitHtmlElems_dot_uscore_hash_selFP15_hash_elems e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "HTML.Parser.splitHtmlElems._#selFP15#elems" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.splitHtmlElems._#selFP15#elems"
    (showCons x1))

d_OP_splitHtmlElems_dot_uscore_hash_selFP16_hash_rest :: Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml
d_OP_splitHtmlElems_dot_uscore_hash_selFP16_hash_rest x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x4
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_splitHtmlElems_dot_uscore_hash_selFP16_hash_rest l cd cs)
    (d_OP_splitHtmlElems_dot_uscore_hash_selFP16_hash_rest r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_splitHtmlElems_dot_uscore_hash_selFP16_hash_rest z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_splitHtmlElems_dot_uscore_hash_selFP16_hash_rest e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "HTML.Parser.splitHtmlElems._#selFP16#rest" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.splitHtmlElems._#selFP16#rest"
    (showCons x1))

d_C_scanHtmlString :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_HtmlToken
d_C_scanHtmlString x1 cd cs = d_OP_scanHtmlString_dot_scanHtml_dot_38 x1 cd cs

d_OP_scanHtmlString_dot_scanHtml_dot_38 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_HtmlToken
d_OP_scanHtmlString_dot_scanHtml_dot_38 x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_20 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '<'#) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_scanHtmlString_dot_scanHtml_dot_38 l cd cs)
    (d_OP_scanHtmlString_dot_scanHtml_dot_38 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_scanHtmlString_dot_scanHtml_dot_38 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_scanHtmlString_dot_scanHtml_dot_38 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "HTML.Parser.scanHtmlString.scanHtml.38" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.scanHtmlString.scanHtml.38" (showCons
    x1))

d_OP_scanHtmlString_dot_scanHtml_dot_38_dot_uscore_hash_selFP18_hash_initxt :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_scanHtmlString_dot_scanHtml_dot_38_dot_uscore_hash_selFP18_hash_initxt x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_scanHtmlString_dot_scanHtml_dot_38_dot_uscore_hash_selFP18_hash_initxt
    l cd cs)
    (d_OP_scanHtmlString_dot_scanHtml_dot_38_dot_uscore_hash_selFP18_hash_initxt
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_scanHtmlString_dot_scanHtml_dot_38_dot_uscore_hash_selFP18_hash_initxt
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_scanHtmlString_dot_scanHtml_dot_38_dot_uscore_hash_selFP18_hash_initxt
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.Parser.scanHtmlString.scanHtml.38._#selFP18#initxt" [show x1] info)
  _ -> failCons cd (consFail
    "HTML.Parser.scanHtmlString.scanHtml.38._#selFP18#initxt" (showCons x1))

d_OP_scanHtmlString_dot_scanHtml_dot_38_dot_uscore_hash_selFP19_hash_remtag :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_scanHtmlString_dot_scanHtml_dot_38_dot_uscore_hash_selFP19_hash_remtag x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_scanHtmlString_dot_scanHtml_dot_38_dot_uscore_hash_selFP19_hash_remtag
    l cd cs)
    (d_OP_scanHtmlString_dot_scanHtml_dot_38_dot_uscore_hash_selFP19_hash_remtag
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_scanHtmlString_dot_scanHtml_dot_38_dot_uscore_hash_selFP19_hash_remtag
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_scanHtmlString_dot_scanHtml_dot_38_dot_uscore_hash_selFP19_hash_remtag
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.Parser.scanHtmlString.scanHtml.38._#selFP19#remtag" [show x1] info)
  _ -> failCons cd (consFail
    "HTML.Parser.scanHtmlString.scanHtml.38._#selFP19#remtag" (showCons x1))

d_C_scanHtmlElem :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_HtmlToken
d_C_scanHtmlElem x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons (C_HTText
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "&lt;") x1 cd
    cs)) Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_17 x3 x4 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.C_Char '>'#) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_scanHtmlElem x1 l cd
    cs) (d_C_scanHtmlElem x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_scanHtmlElem
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_scanHtmlElem x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "HTML.Parser.scanHtmlElem" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.Parser.scanHtmlElem" (showCons x2))

d_OP_scanHtmlElem_dot_uscore_hash_selFP21_hash_args :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_scanHtmlElem_dot_uscore_hash_selFP21_hash_args x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_scanHtmlElem_dot_uscore_hash_selFP21_hash_args l cd cs)
    (d_OP_scanHtmlElem_dot_uscore_hash_selFP21_hash_args r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_scanHtmlElem_dot_uscore_hash_selFP21_hash_args z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_scanHtmlElem_dot_uscore_hash_selFP21_hash_args e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.Parser.scanHtmlElem._#selFP21#args" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.scanHtmlElem._#selFP21#args" (showCons
    x1))

d_OP_scanHtmlElem_dot_uscore_hash_selFP22_hash_rest :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_scanHtmlElem_dot_uscore_hash_selFP22_hash_rest x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_scanHtmlElem_dot_uscore_hash_selFP22_hash_rest l cd cs)
    (d_OP_scanHtmlElem_dot_uscore_hash_selFP22_hash_rest r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_scanHtmlElem_dot_uscore_hash_selFP22_hash_rest z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_scanHtmlElem_dot_uscore_hash_selFP22_hash_rest e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.Parser.scanHtmlElem._#selFP22#rest" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.scanHtmlElem._#selFP22#rest" (showCons
    x1))

d_C_scanHtmlComment :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_HtmlToken
d_C_scanHtmlComment x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_10 x3 x2 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '-'#) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (2)) x3 cd cs)
    (Curry_Prelude.toCurryString "->") cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_scanHtmlComment l cd
    cs) (d_C_scanHtmlComment r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_scanHtmlComment z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_scanHtmlComment
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "HTML.Parser.scanHtmlComment" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.scanHtmlComment" (showCons x1))

d_C_scanHtmlPre :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_HtmlToken
d_C_scanHtmlPre x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_9 x4 x3 x1
    (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.C_Char '<'#) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (5)) (Curry_Prelude.d_C_map
    Data.Curry_Char.d_C_toLower x4 cd cs) cd cs) (Curry_Prelude.toCurryString
    "/pre>") cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_scanHtmlPre x1 l cd
    cs) (d_C_scanHtmlPre x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_scanHtmlPre
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_scanHtmlPre x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "HTML.Parser.scanHtmlPre" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.Parser.scanHtmlPre" (showCons x2))

d_C_string2args :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_string2args x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> let x4 = d_C_splitAtElement
                                       Curry_Prelude.d_C_isSpace
                                       (Curry_Prelude.OP_Cons x2 x3) cd cs
                                     x5 = d_OP_string2args_dot_uscore_hash_selFP24_hash_arg1
                                       x4 cd cs
                                     x6 = d_OP_string2args_dot_uscore_hash_selFP25_hash_rest
                                       x4 cd cs
    in Curry_Prelude.OP_Cons (d_C_deleteApo (d_C_splitAtElement
    (Curry_Prelude.d_C_flip (acceptCs id
    Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.C_Char '='#)) x5 cd cs) cd cs) (d_C_string2args
    (Curry_Prelude.d_C_dropWhile Curry_Prelude.d_C_isSpace x6 cd cs) cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_string2args l cd cs)
    (d_C_string2args r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_string2args
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_string2args e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "HTML.Parser.string2args" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.string2args" (showCons x1))

d_OP_string2args_dot_uscore_hash_selFP24_hash_arg1 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_string2args_dot_uscore_hash_selFP24_hash_arg1 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_string2args_dot_uscore_hash_selFP24_hash_arg1 l cd cs)
    (d_OP_string2args_dot_uscore_hash_selFP24_hash_arg1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_string2args_dot_uscore_hash_selFP24_hash_arg1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_string2args_dot_uscore_hash_selFP24_hash_arg1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.Parser.string2args._#selFP24#arg1" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.string2args._#selFP24#arg1" (showCons
    x1))

d_OP_string2args_dot_uscore_hash_selFP25_hash_rest :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_string2args_dot_uscore_hash_selFP25_hash_rest x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_string2args_dot_uscore_hash_selFP25_hash_rest l cd cs)
    (d_OP_string2args_dot_uscore_hash_selFP25_hash_rest r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_string2args_dot_uscore_hash_selFP25_hash_rest z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_string2args_dot_uscore_hash_selFP25_hash_rest e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.Parser.string2args._#selFP25#rest" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.string2args._#selFP25#rest" (showCons
    x1))

d_C_deleteApo :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_deleteApo x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_8 x2 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_deleteApo l cd cs)
    (d_C_deleteApo r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_deleteApo
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C_deleteApo e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.Parser.deleteApo" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.deleteApo" (showCons x1))

d_C_deleteLastApo :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_deleteLastApo x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_4 x2 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_deleteLastApo l cd cs)
    (d_C_deleteLastApo r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_deleteLastApo z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_deleteLastApo e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "HTML.Parser.deleteLastApo" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.deleteLastApo" (showCons x1))

d_C_splitAtElement :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0)
d_C_splitAtElement x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_2 x3 x1 x4 (Curry_Prelude.d_C_apply
    x1 x3 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_splitAtElement x1 l cd
    cs) (d_C_splitAtElement x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_splitAtElement x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_splitAtElement
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "HTML.Parser.splitAtElement" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.Parser.splitAtElement" (showCons x2))

nd_C_splitAtElement :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  Curry_Prelude.C_Bool -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0)
nd_C_splitAtElement x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_2 x3 x1 x4 (Curry_Prelude.nd_C_apply x1 x3
    s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_splitAtElement x1 l s
    cd cs) (nd_C_splitAtElement x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_C_splitAtElement x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_splitAtElement
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "HTML.Parser.splitAtElement" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.Parser.splitAtElement" (showCons x2))

d_OP_splitAtElement_dot_uscore_hash_selFP27_hash_first :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_splitAtElement_dot_uscore_hash_selFP27_hash_first x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_splitAtElement_dot_uscore_hash_selFP27_hash_first l cd cs)
    (d_OP_splitAtElement_dot_uscore_hash_selFP27_hash_first r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_splitAtElement_dot_uscore_hash_selFP27_hash_first z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_splitAtElement_dot_uscore_hash_selFP27_hash_first e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.Parser.splitAtElement._#selFP27#first" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.splitAtElement._#selFP27#first"
    (showCons x1))

d_OP_splitAtElement_dot_uscore_hash_selFP28_hash_rest :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_splitAtElement_dot_uscore_hash_selFP28_hash_rest x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_splitAtElement_dot_uscore_hash_selFP28_hash_rest l cd cs)
    (d_OP_splitAtElement_dot_uscore_hash_selFP28_hash_rest r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_splitAtElement_dot_uscore_hash_selFP28_hash_rest z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_splitAtElement_dot_uscore_hash_selFP28_hash_rest e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.Parser.splitAtElement._#selFP28#rest" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.splitAtElement._#selFP28#rest"
    (showCons x1))

d_C_skipFirstNewLine :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_skipFirstNewLine x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_1 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '\n'#) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_skipFirstNewLine l cd
    cs) (d_C_skipFirstNewLine r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_skipFirstNewLine z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_C_skipFirstNewLine e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "HTML.Parser.skipFirstNewLine" [show x1] info)
  _ -> failCons cd (consFail "HTML.Parser.skipFirstNewLine" (showCons x1))

nd_C__case_27 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> C_HtmlToken -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_27 x8 x7 x2 s cd cs = case x2 of
  C_HTText x9 -> Curry_Prelude.C_False
  C_HTElem x10 x11 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x7 x10 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
    x8 x11 s1 cd cs) cd cs))
  Choice_C_HtmlToken d i l r -> narrow d i (nd_C__case_27 x8 x7 l s cd cs)
    (nd_C__case_27 x8 x7 r s cd cs)
  Choices_C_HtmlToken d i xs -> narrows cs d i (\z -> nd_C__case_27 x8 x7 z s cd
    cs) xs
  Guard_C_HtmlToken d c e -> guardCons d c ((\x -> nd_C__case_27 x8 x7 e s cd
    x) $! addCs c cs)
  Fail_C_HtmlToken d info -> failCons d (traceFail "HTML.Parser._case_27" [show
    x8, show x7, show x2] info)
  _ -> failCons cd (consFail "HTML.Parser._case_27" (showCons x2))

nd_C__case_28 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_HtmlToken
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_28 x3 x2 s cd cs = case x2 of
  C_HTText x4 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x4 s0 cd cs
  C_HTElem x5 x6 -> Curry_Prelude.C_False
  Choice_C_HtmlToken d i l r -> narrow d i (nd_C__case_28 x3 l s cd cs)
    (nd_C__case_28 x3 r s cd cs)
  Choices_C_HtmlToken d i xs -> narrows cs d i (\z -> nd_C__case_28 x3 z s cd
    cs) xs
  Guard_C_HtmlToken d c e -> guardCons d c ((\x -> nd_C__case_28 x3 e s cd x) $!
    addCs c cs)
  Fail_C_HtmlToken d info -> failCons d (traceFail "HTML.Parser._case_28" [show
    x3, show x2] info)
  _ -> failCons cd (consFail "HTML.Parser._case_28" (showCons x2))

d_C__case_26 :: Curry_Prelude.OP_List C_HtmlToken -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml -> C_HtmlToken -> Cover -> ConstStore
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml
d_C__case_26 x4 x1 x3 cd cs = case x3 of
  C_HTText x5 -> d_C_parseHtmlTokens (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.C_HText x5) x1) x4 cd cs
  C_HTElem x6 x7 -> d_C__case_25 x4 x1 x7 x6 cd cs
  Choice_C_HtmlToken d i l r -> narrow d i (d_C__case_26 x4 x1 l cd cs)
    (d_C__case_26 x4 x1 r cd cs)
  Choices_C_HtmlToken d i xs -> narrows cs d i (\z -> d_C__case_26 x4 x1 z cd
    cs) xs
  Guard_C_HtmlToken d c e -> guardCons d c ((\x -> d_C__case_26 x4 x1 e cd x) $!
    addCs c cs)
  Fail_C_HtmlToken d info -> failCons d (traceFail "HTML.Parser._case_26" [show
    x4, show x1, show x3] info)
  _ -> failCons cd (consFail "HTML.Parser._case_26" (showCons x3))

d_C__case_25 :: Curry_Prelude.OP_List C_HtmlToken -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml
d_C__case_25 x4 x1 x7 x6 cd cs = case x6 of
  Curry_Prelude.OP_Cons x8 x9 -> d_C__case_24 x8 x4 x1 x7 x9
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x8 (Curry_Prelude.C_Char '/'#) cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Internal error in HTML.Parser.parseHtmlTokens: empty list in HTElem") cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_25 x4 x1 x7 l cd
    cs) (d_C__case_25 x4 x1 x7 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_25 x4
    x1 x7 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_25 x4 x1
    x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "HTML.Parser._case_25" [show x4, show x1, show x7, show x6] info)
  _ -> failCons cd (consFail "HTML.Parser._case_25" (showCons x6))

d_C__case_24 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List C_HtmlToken
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml
d_C__case_24 x8 x4 x1 x7 x9 x14 cd cs = case x14 of
  Curry_Prelude.C_True -> let x10 = d_C_splitHtmlElems x9 x1 cd cs
                              x11 = d_OP_parseHtmlTokens_dot_uscore_hash_selFP2_hash_structargs
                                x10 cd cs
                              x12 = d_OP_parseHtmlTokens_dot_uscore_hash_selFP3_hash_elems
                                x10 cd cs
                              x13 = d_OP_parseHtmlTokens_dot_uscore_hash_selFP4_hash_rest
                                x10 cd cs
    in d_C_parseHtmlTokens (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.C_HStruct x9 x11 x12) Curry_Prelude.OP_List) x13 cd cs) x4
    cd cs
  Curry_Prelude.C_False -> d_C_parseHtmlTokens (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.C_HStruct (Curry_Prelude.OP_Cons x8 x9) x7
    Curry_Prelude.OP_List) x1) x4 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_24 x8 x4 x1 x7 x9
    l cd cs) (d_C__case_24 x8 x4 x1 x7 x9 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_24 x8
    x4 x1 x7 x9 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_24 x8 x4
    x1 x7 x9 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_24" [show x8, show x4, show x1, show x7, show x9, show
    x14] info)
  _ -> failCons cd (consFail "HTML.Parser._case_24" (showCons x14))

d_C__case_23 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml
  -> HTML.Curry_Base.C_StaticHtml -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml)
  (Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml)
d_C__case_23 x1 x4 x3 cd cs = case x3 of
  HTML.Curry_Base.C_HText x5 -> let x6 = d_C_splitHtmlElems x1 x4 cd cs
                                    x7 = d_OP_splitHtmlElems_dot_uscore_hash_selFP6_hash_largs
                                      x6 cd cs
                                    x8 = d_OP_splitHtmlElems_dot_uscore_hash_selFP7_hash_elems
                                      x6 cd cs
                                    x9 = d_OP_splitHtmlElems_dot_uscore_hash_selFP8_hash_rest
                                      x6 cd cs
    in Curry_Prelude.OP_Tuple3 x7 (Curry_Prelude.d_OP_plus_plus x8
    (Curry_Prelude.OP_Cons (HTML.Curry_Base.C_HText x5) Curry_Prelude.OP_List)
    cd cs) x9
  HTML.Curry_Base.C_HStruct x10 x11 x12 -> d_C__case_22 x10 x1 x4 x11 x12 cd cs
  HTML.Curry_Base.Choice_C_StaticHtml d i l r -> narrow d i (d_C__case_23 x1 x4
    l cd cs) (d_C__case_23 x1 x4 r cd cs)
  HTML.Curry_Base.Choices_C_StaticHtml d i xs -> narrows cs d i (\z ->
    d_C__case_23 x1 x4 z cd cs) xs
  HTML.Curry_Base.Guard_C_StaticHtml d c e -> guardCons d c ((\x -> d_C__case_23
    x1 x4 e cd x) $! addCs c cs)
  HTML.Curry_Base.Fail_C_StaticHtml d info -> failCons d (traceFail
    "HTML.Parser._case_23" [show x1, show x4, show x3] info)
  _ -> failCons cd (consFail "HTML.Parser._case_23" (showCons x3))

d_C__case_22 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml)
d_C__case_22 x10 x1 x4 x11 x12 cd cs = case x12 of
  Curry_Prelude.OP_Cons x13 x14 -> let x15 = d_C_splitHtmlElems x1 x4 cd cs
                                       x16 = d_OP_splitHtmlElems_dot_uscore_hash_selFP10_hash_largs
                                         x15 cd cs
                                       x17 = d_OP_splitHtmlElems_dot_uscore_hash_selFP11_hash_elems
                                         x15 cd cs
                                       x18 = d_OP_splitHtmlElems_dot_uscore_hash_selFP12_hash_rest
                                         x15 cd cs
    in Curry_Prelude.OP_Tuple3 x16 (Curry_Prelude.d_OP_plus_plus x17
    (Curry_Prelude.OP_Cons (HTML.Curry_Base.C_HStruct x10 x11 x12)
    Curry_Prelude.OP_List) cd cs) x18
  Curry_Prelude.OP_List -> d_C__case_21 x10 x1 x4 x11
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 x10 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_22 x10 x1 x4 x11
    l cd cs) (d_C__case_22 x10 x1 x4 x11 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_22 x10
    x1 x4 x11 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_22 x10 x1
    x4 x11 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "HTML.Parser._case_22" [show x10, show x1, show x4, show x11, show x12]
    info)
  _ -> failCons cd (consFail "HTML.Parser._case_22" (showCons x12))

d_C__case_21 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_StaticHtml -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml)
  (Curry_Prelude.OP_List HTML.Curry_Base.C_StaticHtml)
d_C__case_21 x10 x1 x4 x11 x23 cd cs = case x23 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple3 x11 Curry_Prelude.OP_List x4
  Curry_Prelude.C_False -> let x19 = d_C_splitHtmlElems x1 x4 cd cs
                               x20 = d_OP_splitHtmlElems_dot_uscore_hash_selFP14_hash_largs
                                 x19 cd cs
                               x21 = d_OP_splitHtmlElems_dot_uscore_hash_selFP15_hash_elems
                                 x19 cd cs
                               x22 = d_OP_splitHtmlElems_dot_uscore_hash_selFP16_hash_rest
                                 x19 cd cs
    in Curry_Prelude.OP_Tuple3 x20 (Curry_Prelude.d_OP_plus_plus x21
    (Curry_Prelude.OP_Cons (HTML.Curry_Base.C_HStruct x10 x11
    Curry_Prelude.OP_List) Curry_Prelude.OP_List) cd cs) x22
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_21 x10 x1 x4 x11
    l cd cs) (d_C__case_21 x10 x1 x4 x11 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_21 x10
    x1 x4 x11 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_21 x10 x1
    x4 x11 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_21" [show x10, show x1, show x4, show x11, show x23]
    info)
  _ -> failCons cd (consFail "HTML.Parser._case_21" (showCons x23))

d_C__case_20 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_HtmlToken
d_C__case_20 x2 x3 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> d_C__case_19 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (3)) x3 cd cs)
    (Curry_Prelude.toCurryString "!--") cd cs) cd cs
  Curry_Prelude.C_False -> let x4 = Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_break
                                 (Curry_Prelude.d_C_flip (acceptCs id
                                 Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                 (Curry_Prelude.C_Char '<'#)) cd cs)
                                 (Curry_Prelude.OP_Cons x2 x3) cd cs
                               x5 = d_OP_scanHtmlString_dot_scanHtml_dot_38_dot_uscore_hash_selFP18_hash_initxt
                                 x4 cd cs
                               x6 = d_OP_scanHtmlString_dot_scanHtml_dot_38_dot_uscore_hash_selFP19_hash_remtag
                                 x4 cd cs
    in Curry_Prelude.OP_Cons (C_HTText x5)
    (d_OP_scanHtmlString_dot_scanHtml_dot_38 x6 cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_20 x2 x3 l cd cs)
    (d_C__case_20 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_20 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_20 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_20" [show x2, show x3, show x7] info)
  _ -> failCons cd (consFail "HTML.Parser._case_20" (showCons x7))

d_C__case_19 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_HtmlToken
d_C__case_19 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> d_C_scanHtmlComment x3 cd cs
  Curry_Prelude.C_False -> d_C__case_18 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (4)) (Curry_Prelude.d_C_map
    Data.Curry_Char.d_C_toLower x3 cd cs) cd cs) (Curry_Prelude.toCurryString
    "pre>") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_19 x3 l cd cs)
    (d_C__case_19 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_19 x3 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_19 x3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_19" [show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.Parser._case_19" (showCons x4))

d_C__case_18 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_HtmlToken
d_C__case_18 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> d_C_scanHtmlPre Curry_Prelude.OP_List
    (d_C_skipFirstNewLine (Curry_Prelude.d_C_drop (Curry_Prelude.C_Int (4)) x3
    cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> d_C_scanHtmlElem Curry_Prelude.OP_List x3 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_18 x3 l cd cs)
    (d_C__case_18 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_18 x3 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_18 x3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_18" [show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.Parser._case_18" (showCons x4))

d_C__case_17 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_HtmlToken
d_C__case_17 x3 x4 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (d_C__case_16 x1
    (Curry_Prelude.d_C_null x1 cd cs) cd cs) (d_C_scanHtmlString x4 cd cs)
  Curry_Prelude.C_False -> d_C__case_15 x3 x4 x1 (Curry_Prelude.d_C_isSpace x3
    cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_17 x3 x4 x1 l cd
    cs) (d_C__case_17 x3 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_17 x3
    x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_17 x3 x4
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_17" [show x3, show x4, show x1, show x5] info)
  _ -> failCons cd (consFail "HTML.Parser._case_17" (showCons x5))

d_C__case_15 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_HtmlToken
d_C__case_15 x3 x4 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> d_C__case_14 x1 x4 (Curry_Prelude.d_C_null x1 cd cs)
    cd cs
  Curry_Prelude.C_False -> d_C__case_12 x4 x3 x1 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.C_Char '/'#) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_head x4 cd cs) (Curry_Prelude.C_Char '>'#) cd cs) cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_15 x3 x4 x1 l cd
    cs) (d_C__case_15 x3 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_15 x3
    x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_15 x3 x4
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_15" [show x3, show x4, show x1, show x5] info)
  _ -> failCons cd (consFail "HTML.Parser._case_15" (showCons x5))

d_C__case_12 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_HtmlToken
d_C__case_12 x4 x3 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (C_HTElem x1
    Curry_Prelude.OP_List) (Curry_Prelude.OP_Cons (C_HTElem
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '/'#) x1)
    Curry_Prelude.OP_List) (d_C_scanHtmlString (Curry_Prelude.d_C_tail x4 cd cs)
    cd cs))
  Curry_Prelude.C_False -> d_C__case_11 x4 x3 x1 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_12 x4 x3 x1 l cd
    cs) (d_C__case_12 x4 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_12 x4
    x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_12 x4 x3
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_12" [show x4, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "HTML.Parser._case_12" (showCons x5))

d_C__case_11 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_HtmlToken
d_C__case_11 x4 x3 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> d_C_scanHtmlElem (Curry_Prelude.d_OP_plus_plus x1
    (Curry_Prelude.OP_Cons (Data.Curry_Char.d_C_toLower x3 cd cs)
    Curry_Prelude.OP_List) cd cs) x4 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_11 x4 x3 x1 l cd
    cs) (d_C__case_11 x4 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_11 x4
    x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_11 x4 x3
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_11" [show x4, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "HTML.Parser._case_11" (showCons x5))

d_C__case_14 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_HtmlToken
d_C__case_14 x1 x4 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (C_HTText
    (Curry_Prelude.toCurryString "&lt; ")) (d_C_scanHtmlString x4 cd cs)
  Curry_Prelude.C_False -> let x5 = d_C_splitAtElement (Curry_Prelude.d_C_flip
                                 (acceptCs id
                                 Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                 (Curry_Prelude.C_Char '>'#))
                                 (Curry_Prelude.d_C_dropWhile
                                 Curry_Prelude.d_C_isSpace x4 cd cs) cd cs
                               x6 = d_OP_scanHtmlElem_dot_uscore_hash_selFP21_hash_args
                                 x5 cd cs
                               x7 = d_OP_scanHtmlElem_dot_uscore_hash_selFP22_hash_rest
                                 x5 cd cs
                               x8 = Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_reverse cd cs) x6 cd cs
    in d_C__case_13 x8 x6 x7 x1 (Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.d_C_null x6 cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    cd cs) (Curry_Prelude.d_C_head x8 cd cs) cd cs) (Curry_Prelude.C_Char '/'#)
    cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_14 x1 x4 l cd cs)
    (d_C__case_14 x1 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_14 x1
    x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_14 x1 x4 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_14" [show x1, show x4, show x9] info)
  _ -> failCons cd (consFail "HTML.Parser._case_14" (showCons x9))

d_C__case_13 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_HtmlToken
d_C__case_13 x8 x6 x7 x1 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (C_HTElem x1 (d_C_string2args x6
    cd cs)) (d_C_scanHtmlString x7 cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (C_HTElem x1 (d_C_string2args
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_reverse cd cs)
    (Curry_Prelude.d_C_tail x8 cd cs) cd cs) cd cs)) (Curry_Prelude.OP_Cons
    (C_HTElem (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '/'#) x1)
    Curry_Prelude.OP_List) (d_C_scanHtmlString x7 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_13 x8 x6 x7 x1 l
    cd cs) (d_C__case_13 x8 x6 x7 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_13 x8
    x6 x7 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_13 x8 x6
    x7 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_13" [show x8, show x6, show x7, show x1, show x9] info)
  _ -> failCons cd (consFail "HTML.Parser._case_13" (showCons x9))

d_C__case_16 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_HtmlToken
d_C__case_16 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> C_HTText (Curry_Prelude.toCurryString "&lt;&gt;")
  Curry_Prelude.C_False -> C_HTElem x1 Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_16 x1 l cd cs)
    (d_C__case_16 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_16 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_16 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_16" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.Parser._case_16" (showCons x2))

d_C__case_10 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_HtmlToken
d_C__case_10 x3 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> d_C_scanHtmlString (Curry_Prelude.d_C_drop
    (Curry_Prelude.C_Int (2)) x3 cd cs) cd cs
  Curry_Prelude.C_False -> d_C_scanHtmlComment x3 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_10 x3 x2 l cd cs)
    (d_C__case_10 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_10 x3
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_10 x3 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_10" [show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "HTML.Parser._case_10" (showCons x4))

d_C__case_9 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_HtmlToken
d_C__case_9 x4 x3 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (C_HTElem
    (Curry_Prelude.toCurryString "pre") Curry_Prelude.OP_List)
    (Curry_Prelude.OP_Cons (C_HTText (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_reverse cd cs) x1 cd cs)) (Curry_Prelude.OP_Cons
    (C_HTElem (Curry_Prelude.toCurryString "/pre") Curry_Prelude.OP_List)
    (d_C_scanHtmlString (Curry_Prelude.d_C_drop (Curry_Prelude.C_Int (5)) x4 cd
    cs) cd cs)))
  Curry_Prelude.C_False -> d_C_scanHtmlPre (Curry_Prelude.OP_Cons x3 x1) x4 cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_9 x4 x3 x1 l cd
    cs) (d_C__case_9 x4 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_9 x4 x3
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_9 x4 x3 x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_9" [show x4, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "HTML.Parser._case_9" (showCons x5))

d_C__case_8 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_8 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_map
    Data.Curry_Char.d_C_toLower x2 cd cs) Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_7 x4 x5 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x4 (Curry_Prelude.C_Char '"'#) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_8 x2 l cd cs)
    (d_C__case_8 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_8 x2 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_8 x2 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "HTML.Parser._case_8" [show x2, show x3] info)
  _ -> failCons cd (consFail "HTML.Parser._case_8" (showCons x3))

d_C__case_7 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_7 x4 x5 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_map
    Data.Curry_Char.d_C_toLower x2 cd cs) (d_C_deleteLastApo x5 cd cs)
  Curry_Prelude.C_False -> d_C__case_6 x4 x5 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x4 (Curry_Prelude.C_Char '\''#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x4 x5 x2 l cd
    cs) (d_C__case_7 x4 x5 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x4 x5
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_7 x4 x5 x2
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_7" [show x4, show x5, show x2, show x6] info)
  _ -> failCons cd (consFail "HTML.Parser._case_7" (showCons x6))

d_C__case_6 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_6 x4 x5 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_map
    Data.Curry_Char.d_C_toLower x2 cd cs) (d_C_deleteLastApo x5 cd cs)
  Curry_Prelude.C_False -> d_C__case_5 x5 x4 x2 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x4 x5 x2 l cd
    cs) (d_C__case_6 x4 x5 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x4 x5
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x4 x5 x2
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_6" [show x4, show x5, show x2, show x6] info)
  _ -> failCons cd (consFail "HTML.Parser._case_6" (showCons x6))

d_C__case_5 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_5 x5 x4 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_map
    Data.Curry_Char.d_C_toLower x2 cd cs) (Curry_Prelude.OP_Cons x4 x5)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x5 x4 x2 l cd
    cs) (d_C__case_5 x5 x4 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x5 x4
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x5 x4 x2
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_5" [show x5, show x4, show x2, show x6] info)
  _ -> failCons cd (consFail "HTML.Parser._case_5" (showCons x6))

d_C__case_4 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_4 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> d_C__case_3 x2 (Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '"'#) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '\''#) cd cs) cd cs) cd cs
  Curry_Prelude.OP_Cons x4 x5 -> Curry_Prelude.OP_Cons x2 (d_C_deleteLastApo
    (Curry_Prelude.OP_Cons x4 x5) cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_4 x2 l cd cs)
    (d_C__case_4 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_4 x2 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_4 x2 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "HTML.Parser._case_4" [show x2, show x3] info)
  _ -> failCons cd (consFail "HTML.Parser._case_4" (showCons x3))

d_C__case_3 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_3 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons x2 Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x2 l cd cs)
    (d_C__case_3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x2 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x2 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_3" [show x2, show x3] info)
  _ -> failCons cd (consFail "HTML.Parser._case_3" (showCons x3))

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0)
d_C__case_2 x3 x1 x4 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List x4
  Curry_Prelude.C_False -> let x5 = d_C_splitAtElement x1 x4 cd cs
                               x6 = d_OP_splitAtElement_dot_uscore_hash_selFP27_hash_first
                                 x5 cd cs
                               x7 = d_OP_splitAtElement_dot_uscore_hash_selFP28_hash_rest
                                 x5 cd cs
    in Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons x3 x6) x7
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x3 x1 x4 l cd
    cs) (d_C__case_2 x3 x1 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x3 x1
    x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x3 x1 x4
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_2" [show x3, show x1, show x4, show x8] info)
  _ -> failCons cd (consFail "HTML.Parser._case_2" (showCons x8))

nd_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Func t0
  Curry_Prelude.C_Bool -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0)
nd_C__case_2 x3 x1 x4 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List x4
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` (let x5 = nd_C_splitAtElement x1 x4 s0 cd cs
                     x6 = d_OP_splitAtElement_dot_uscore_hash_selFP27_hash_first
                       x5 cd cs
                     x7 = d_OP_splitAtElement_dot_uscore_hash_selFP28_hash_rest
                       x5 cd cs
    in Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons x3 x6) x7)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_2 x3 x1 x4 l s
    cd cs) (nd_C__case_2 x3 x1 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_2 x3
    x1 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_2 x3 x1
    x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_2" [show x3, show x1, show x4, show x8] info)
  _ -> failCons cd (consFail "HTML.Parser._case_2" (showCons x8))

d_C__case_1 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_1 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> x3
  Curry_Prelude.C_False -> d_C__case_0 x2 x3 (Curry_Prelude.d_C_isSpace x2 cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x2 x3 l cd cs)
    (d_C__case_1 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x2 x3
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_1" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.Parser._case_1" (showCons x4))

d_C__case_0 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_0 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> d_C_skipFirstNewLine x3 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons x2 x3
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x2 x3 l cd cs)
    (d_C__case_0 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x2 x3
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Parser._case_0" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.Parser._case_0" (showCons x4))

