{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module HTML.Styles.Curry_Bootstrap3
  ( d_C_bootstrapPage
  , nd_C_bootstrapPage
  , d_C_titledSideMenu
  , nd_C_titledSideMenu
  , nd_C_defaultButton
  , nd_C_smallButton
  , nd_C_primButton
  , d_C_hrefDefaultButton
  , nd_C_hrefDefaultButton
  , d_C_hrefSmallButton
  , nd_C_hrefSmallButton
  , d_C_hrefButton
  , nd_C_hrefButton
  , d_C_hrefPrimButton
  , nd_C_hrefPrimButton
  , d_C_hrefInfoButton
  , nd_C_hrefInfoButton
  , d_C_hrefSuccessButton
  , nd_C_hrefSuccessButton
  , d_C_hrefWarningButton
  , nd_C_hrefWarningButton
  , d_C_hrefDangerButton
  , nd_C_hrefDangerButton
  , d_C_hrefBlock
  , nd_C_hrefBlock
  , d_C_hrefInfoBlock
  , nd_C_hrefInfoBlock
  , d_C_glyphicon
  , nd_C_glyphicon
  , d_C_homeIcon
  , nd_C_homeIcon
  , d_C_userIcon
  , nd_C_userIcon
  , d_C_loginIcon
  , nd_C_loginIcon
  , d_C_logoutIcon
  , nd_C_logoutIcon )
  where

import Basics
import qualified HTML.Curry_Base
import qualified Curry_Prelude


d_C_bootstrapPage :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml) -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml -> Cover -> ConstStore
  -> HTML.Curry_Base.C_HtmlPage
d_C_bootstrapPage x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 cd cs =
  let x12 = Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_pageMetaInfo cd cs)
        (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
        (Curry_Prelude.toCurryString "name") (Curry_Prelude.toCurryString
        "viewport")) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
        (Curry_Prelude.toCurryString "content") (Curry_Prelude.toCurryString
        "width=device-width, initial-scale=1.0")) Curry_Prelude.OP_List)) cd cs
      x13 = Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_pageLinkInfo cd cs)
        (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
        (Curry_Prelude.toCurryString "rel") (Curry_Prelude.toCurryString
        "shortcut icon")) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
        (Curry_Prelude.toCurryString "href") (Curry_Prelude.d_OP_plus_plus x1
        (Curry_Prelude.toCurryString "/favicon.ico") cd cs))
        Curry_Prelude.OP_List)) cd cs
  in HTML.Curry_Base.C_HtmlPage x3 (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_pageEnc
  cd cs) (Curry_Prelude.toCurryString "utf-8") cd cs) (Curry_Prelude.OP_Cons x12
  (Curry_Prelude.OP_Cons x13 Curry_Prelude.OP_List))) (Curry_Prelude.d_C_map
  (d_OP_bootstrapPage_dot_uscore_hash_lambda1 x1) x2 cd cs) cd cs)
  (d_C_bootstrapBody
  HTML.Curry_Base.d_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_BaseHtml_hash
  x1 x4 x5 x6 x7 x8 x9 x10 x11 cd cs)

nd_C_bootstrapPage :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml) -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml -> IDSupply -> Cover -> ConstStore
  -> HTML.Curry_Base.C_HtmlPage
nd_C_bootstrapPage x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 s cd cs = let s13 = s
  in s13 `seq` (let s2 = leftSupply s13
                    s14 = rightSupply s13
                    s5 = leftSupply s14
                    s12 = rightSupply s14
  in s2 `seq` (s14 `seq` (s5 `seq` (s12 `seq` (let x12 = let s1 = leftSupply s2
                                                             s0 = rightSupply s2
                                                     in s1 `seq` (s0 `seq`
                                                     Curry_Prelude.nd_C_apply
                                                     (HTML.Curry_Base.nd_C_pageMetaInfo
                                                     s0 cd cs)
                                                     (Curry_Prelude.OP_Cons
                                                     (Curry_Prelude.OP_Tuple2
                                                     (Curry_Prelude.toCurryString
                                                     "name")
                                                     (Curry_Prelude.toCurryString
                                                     "viewport"))
                                                     (Curry_Prelude.OP_Cons
                                                     (Curry_Prelude.OP_Tuple2
                                                     (Curry_Prelude.toCurryString
                                                     "content")
                                                     (Curry_Prelude.toCurryString
                                                     "width=device-width, initial-scale=1.0"))
                                                     Curry_Prelude.OP_List)) s1
                                                     cd cs)
                                                   x13 = let s4 = leftSupply s5
                                                             s3 = rightSupply s5
                                                     in s4 `seq` (s3 `seq`
                                                     Curry_Prelude.nd_C_apply
                                                     (HTML.Curry_Base.nd_C_pageLinkInfo
                                                     s3 cd cs)
                                                     (Curry_Prelude.OP_Cons
                                                     (Curry_Prelude.OP_Tuple2
                                                     (Curry_Prelude.toCurryString
                                                     "rel")
                                                     (Curry_Prelude.toCurryString
                                                     "shortcut icon"))
                                                     (Curry_Prelude.OP_Cons
                                                     (Curry_Prelude.OP_Tuple2
                                                     (Curry_Prelude.toCurryString
                                                     "href")
                                                     (Curry_Prelude.d_OP_plus_plus
                                                     x1
                                                     (Curry_Prelude.toCurryString
                                                     "/favicon.ico") cd cs))
                                                     Curry_Prelude.OP_List)) s4
                                                     cd cs)
  in let s10 = leftSupply s12
         s11 = rightSupply s12
  in s10 `seq` (s11 `seq` HTML.Curry_Base.C_HtmlPage x3 (let s8 = leftSupply s10
                                                             s9 = rightSupply
                                                               s10
  in s8 `seq` (s9 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
  (let s7 = leftSupply s8
       s6 = rightSupply s8
  in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_pageEnc
  s6 cd cs) (Curry_Prelude.toCurryString "utf-8") s7 cd cs))
  (Curry_Prelude.OP_Cons x12 (Curry_Prelude.OP_Cons x13 Curry_Prelude.OP_List)))
  (Curry_Prelude.nd_C_map (wrapNX id
  (nd_OP_bootstrapPage_dot_uscore_hash_lambda1 x1)) x2 s9 cd cs) cd cs))
  (nd_C_bootstrapBody (wrapNX id
  HTML.Curry_Base.nd_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_BaseHtml_hash)
  x1 x4 x5 x6 x7 x8 x9 x10 x11 s11 cd cs)))))))

d_OP_bootstrapPage_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> HTML.Curry_Base.C_PageParam
d_OP_bootstrapPage_dot_uscore_hash_lambda1 x1 x2 cd cs = Curry_Prelude.d_C_apply
  (HTML.Curry_Base.d_C_pageCSS cd cs) (Curry_Prelude.d_OP_plus_plus x1
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "/css/")
  (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.toCurryString ".css") cd cs)
  cd cs) cd cs) cd cs

nd_OP_bootstrapPage_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> HTML.Curry_Base.C_PageParam
nd_OP_bootstrapPage_dot_uscore_hash_lambda1 x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_pageCSS
  s0 cd cs) (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "/css/") (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString ".css") cd cs) cd cs) cd cs) s1 cd cs))

d_C_bootstrapBody :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C_bootstrapBody x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 cd cs = let x11 = d_C__case_2
                                                               x8 x1
                                                               (Curry_Prelude.d_C_null
                                                               x8 cd cs) cd cs
  in Curry_Prelude.d_OP_plus_plus (d_C_topNavigationBar x1 x3 x4 x5 cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
  (HTML.Curry_Base.d_C_blockstyle x1 (Curry_Prelude.toCurryString
  "container-fluid") cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_blockstyle x1
  (Curry_Prelude.toCurryString "row") cd cs) (d_C__case_4 x6 x9 x11 x1 x7
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  x6 (Curry_Prelude.C_Int (0)) cd cs) cd cs) cd cs) Curry_Prelude.OP_List)
  (d_C__case_3 x10 x1 (Curry_Prelude.d_C_null x10 cd cs) cd cs) cd cs) cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_htmlStruct x1 cd cs)
  (Curry_Prelude.toCurryString "script") cd cs) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "src")
  (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.toCurryString
  "/js/jquery.min.js") cd cs)) Curry_Prelude.OP_List) cd cs)
  Curry_Prelude.OP_List cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (HTML.Curry_Base.d_C_htmlStruct x1 cd cs) (Curry_Prelude.toCurryString
  "script") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "src") (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/js/bootstrap.min.js") cd cs))
  Curry_Prelude.OP_List) cd cs) Curry_Prelude.OP_List cd cs)
  Curry_Prelude.OP_List))) cd cs

nd_C_bootstrapBody :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0) -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C_bootstrapBody x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 s cd cs = let s30 = s
  in s30 `seq` (let s0 = leftSupply s30
                    s29 = rightSupply s30
  in s0 `seq` (s29 `seq` (let x11 = nd_C__case_2 x8 x1 (Curry_Prelude.d_C_null
                                x8 cd cs) s0 cd cs
  in let s1 = leftSupply s29
         s28 = rightSupply s29
  in s1 `seq` (s28 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_topNavigationBar x1
  x3 x4 x5 s1 cd cs) (let s11 = leftSupply s28
                          s27 = rightSupply s28
  in s11 `seq` (s27 `seq` Curry_Prelude.OP_Cons (let s10 = leftSupply s11
                                                     s12 = rightSupply s11
                                                     s2 = leftSupply s12
                                                     s9 = rightSupply s12
  in s10 `seq` (s12 `seq` (s2 `seq` (s9 `seq` Curry_Prelude.nd_C_apply
  (HTML.Curry_Base.nd_C_blockstyle x1 (Curry_Prelude.toCurryString
  "container-fluid") s2 cd cs) (let s6 = leftSupply s9
                                    s8 = rightSupply s9
  in s6 `seq` (s8 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
  (let s5 = leftSupply s6
       s7 = rightSupply s6
       s3 = leftSupply s7
       s4 = rightSupply s7
  in s5 `seq` (s7 `seq` (s3 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
  (HTML.Curry_Base.nd_C_blockstyle x1 (Curry_Prelude.toCurryString "row") s3 cd
  cs) (nd_C__case_4 x6 x9 x11 x1 x7
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  x6 (Curry_Prelude.C_Int (0)) cd cs) s4 cd cs) s5 cd cs))))
  Curry_Prelude.OP_List) (nd_C__case_3 x10 x1 (Curry_Prelude.d_C_null x10 cd cs)
  s8 cd cs) cd cs)) s10 cd cs)))) (let s19 = leftSupply s27
                                       s26 = rightSupply s27
  in s19 `seq` (s26 `seq` Curry_Prelude.OP_Cons (let s18 = leftSupply s19
                                                     s17 = rightSupply s19
  in s18 `seq` (s17 `seq` Curry_Prelude.nd_C_apply (let s16 = leftSupply s17
                                                        s15 = rightSupply s17
  in s16 `seq` (s15 `seq` Curry_Prelude.nd_C_apply (let s14 = leftSupply s15
                                                        s13 = rightSupply s15
  in s14 `seq` (s13 `seq` Curry_Prelude.nd_C_apply
  (HTML.Curry_Base.nd_C_htmlStruct x1 s13 cd cs) (Curry_Prelude.toCurryString
  "script") s14 cd cs)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "src") (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/js/jquery.min.js") cd cs))
  Curry_Prelude.OP_List) s16 cd cs)) Curry_Prelude.OP_List s18 cd cs))
  (Curry_Prelude.OP_Cons (let s25 = leftSupply s26
                              s24 = rightSupply s26
  in s25 `seq` (s24 `seq` Curry_Prelude.nd_C_apply (let s23 = leftSupply s24
                                                        s22 = rightSupply s24
  in s23 `seq` (s22 `seq` Curry_Prelude.nd_C_apply (let s21 = leftSupply s22
                                                        s20 = rightSupply s22
  in s21 `seq` (s20 `seq` Curry_Prelude.nd_C_apply
  (HTML.Curry_Base.nd_C_htmlStruct x1 s20 cd cs) (Curry_Prelude.toCurryString
  "script") s21 cd cs)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "src") (Curry_Prelude.d_OP_plus_plus x2
  (Curry_Prelude.toCurryString "/js/bootstrap.min.js") cd cs))
  Curry_Prelude.OP_List) s23 cd cs)) Curry_Prelude.OP_List s25 cd cs))
  Curry_Prelude.OP_List))))) cd cs))))

d_OP_bootstrapBody_dot_bsCols_dot_7 :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_bootstrapBody_dot_bsCols_dot_7 x1 x2 cd cs = Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "col-sm-") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_show x1 cd cs) x2 cd cs)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "col-md-")
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_show x1 cd cs) x2 cd cs) cd cs) cd
  cs) cd cs) cd cs

nd_OP_bootstrapBody_dot_bsCols_dot_7 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_OP_bootstrapBody_dot_bsCols_dot_7 x1 x2 s cd cs = let s6 = s
  in s6 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "col-sm-") (let s2 = leftSupply s6
                  s5 = rightSupply s6
  in s2 `seq` (s5 `seq` Curry_Prelude.d_OP_plus_plus (let s1 = leftSupply s2
                                                          s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x1 s0
  cd cs) x2 s1 cd cs)) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString " ") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "col-md-") (let s4 = leftSupply s5
                                               s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x1 s3
  cd cs) x2 s4 cd cs)) cd cs) cd cs) cd cs)) cd cs

d_C_topNavigationBar :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_topNavigationBar x1 x2 x3 x4 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> Curry_Prelude.OP_Cons
    (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_blockstyle x1
    (Curry_Prelude.toCurryString "navbar navbar-inverse navbar-fixed-top") cd
    cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_blockstyle x1 (Curry_Prelude.toCurryString
    "container-fluid") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_blockstyle x1 (Curry_Prelude.toCurryString
    "navbar-header") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_htmlStruct x1 cd cs) (Curry_Prelude.toCurryString
    "button") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "type") (Curry_Prelude.toCurryString "button"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "class") (Curry_Prelude.toCurryString "navbar-toggle collapsed"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "data-toggle") (Curry_Prelude.toCurryString "collapse"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "data-target") (Curry_Prelude.toCurryString "#topnavbar"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "aria-expanded") (Curry_Prelude.toCurryString "false"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "aria-controls") (Curry_Prelude.toCurryString "topnavbar"))
    Curry_Prelude.OP_List)))))) cd cs) (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.d_C_textstyle x1 (Curry_Prelude.toCurryString "sr-only")
    (Curry_Prelude.toCurryString "Toggle navigation") cd cs)
    (Curry_Prelude.OP_Cons (HTML.Curry_Base.d_C_textstyle x1
    (Curry_Prelude.toCurryString "icon-bar") Curry_Prelude.OP_List cd cs)
    (Curry_Prelude.OP_Cons (HTML.Curry_Base.d_C_textstyle x1
    (Curry_Prelude.toCurryString "icon-bar") Curry_Prelude.OP_List cd cs)
    (Curry_Prelude.OP_Cons (HTML.Curry_Base.d_C_textstyle x1
    (Curry_Prelude.toCurryString "icon-bar") Curry_Prelude.OP_List cd cs)
    Curry_Prelude.OP_List)))) cd cs) (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.d_C_addClass x1 (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_href x1 x5 cd cs) x6 cd cs)
    (Curry_Prelude.toCurryString "navbar-brand") cd cs) Curry_Prelude.OP_List))
    cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_htmlStruct x1 cd cs) (Curry_Prelude.toCurryString
    "div") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "id") (Curry_Prelude.toCurryString
    "topnavbar")) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
    "collapse navbar-collapse")) Curry_Prelude.OP_List)) cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.d_C_addClass x1 (HTML.Curry_Base.d_C_ulist x1 x3 cd cs)
    (Curry_Prelude.toCurryString "nav navbar-nav") cd cs) Curry_Prelude.OP_List)
    (d_C__case_1 x4 x1 (Curry_Prelude.d_C_null x4 cd cs) cd cs) cd cs) cd cs)
    Curry_Prelude.OP_List)) cd cs) Curry_Prelude.OP_List) cd cs)
    Curry_Prelude.OP_List
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_topNavigationBar x1
    l x3 x4 cd cs) (d_C_topNavigationBar x1 r x3 x4 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_C_topNavigationBar x1 z x3 x4 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_C_topNavigationBar x1 e x3 x4 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap3.topNavigationBar" [show x1, show x2, show x3, show
    x4] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap3.topNavigationBar" (showCons
    x2))

nd_C_topNavigationBar :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List t0) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_topNavigationBar x1 x2 x3 x4 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> let s45 = s
    in s45 `seq` Curry_Prelude.OP_Cons (let s44 = leftSupply s45
                                            s46 = rightSupply s45
                                            s0 = leftSupply s46
                                            s42 = rightSupply s46
    in s44 `seq` (s46 `seq` (s0 `seq` (s42 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_blockstyle x1 (Curry_Prelude.toCurryString
    "navbar navbar-inverse navbar-fixed-top") s0 cd cs) (Curry_Prelude.OP_Cons
    (let s41 = leftSupply s42
         s43 = rightSupply s42
         s1 = leftSupply s43
         s40 = rightSupply s43
    in s41 `seq` (s43 `seq` (s1 `seq` (s40 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_blockstyle x1 (Curry_Prelude.toCurryString
    "container-fluid") s1 cd cs) (let s25 = leftSupply s40
                                      s38 = rightSupply s40
    in s25 `seq` (s38 `seq` Curry_Prelude.OP_Cons (let s24 = leftSupply s25
                                                       s26 = rightSupply s25
                                                       s2 = leftSupply s26
                                                       s23 = rightSupply s26
    in s24 `seq` (s26 `seq` (s2 `seq` (s23 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_blockstyle x1 (Curry_Prelude.toCurryString
    "navbar-header") s2 cd cs) (let s16 = leftSupply s23
                                    s22 = rightSupply s23
    in s16 `seq` (s22 `seq` Curry_Prelude.OP_Cons (let s15 = leftSupply s16
                                                       s17 = rightSupply s16
                                                       s7 = leftSupply s17
                                                       s14 = rightSupply s17
    in s15 `seq` (s17 `seq` (s7 `seq` (s14 `seq` Curry_Prelude.nd_C_apply
    (let s6 = leftSupply s7
         s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                        s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_htmlStruct x1 s3 cd cs) (Curry_Prelude.toCurryString
    "button") s4 cd cs)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "type") (Curry_Prelude.toCurryString "button"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "class") (Curry_Prelude.toCurryString "navbar-toggle collapsed"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "data-toggle") (Curry_Prelude.toCurryString "collapse"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "data-target") (Curry_Prelude.toCurryString "#topnavbar"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "aria-expanded") (Curry_Prelude.toCurryString "false"))
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
    "aria-controls") (Curry_Prelude.toCurryString "topnavbar"))
    Curry_Prelude.OP_List)))))) s6 cd cs)) (let s8 = leftSupply s14
                                                s13 = rightSupply s14
    in s8 `seq` (s13 `seq` Curry_Prelude.OP_Cons (HTML.Curry_Base.nd_C_textstyle
    x1 (Curry_Prelude.toCurryString "sr-only") (Curry_Prelude.toCurryString
    "Toggle navigation") s8 cd cs) (let s9 = leftSupply s13
                                        s12 = rightSupply s13
    in s9 `seq` (s12 `seq` Curry_Prelude.OP_Cons (HTML.Curry_Base.nd_C_textstyle
    x1 (Curry_Prelude.toCurryString "icon-bar") Curry_Prelude.OP_List s9 cd cs)
    (let s10 = leftSupply s12
         s11 = rightSupply s12
    in s10 `seq` (s11 `seq` Curry_Prelude.OP_Cons
    (HTML.Curry_Base.nd_C_textstyle x1 (Curry_Prelude.toCurryString "icon-bar")
    Curry_Prelude.OP_List s10 cd cs) (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.nd_C_textstyle x1 (Curry_Prelude.toCurryString "icon-bar")
    Curry_Prelude.OP_List s11 cd cs) Curry_Prelude.OP_List))))))) s15 cd cs))))
    (Curry_Prelude.OP_Cons (let s21 = leftSupply s22
                                s20 = rightSupply s22
    in s21 `seq` (s20 `seq` HTML.Curry_Base.nd_C_addClass x1
    (let s19 = leftSupply s20
         s18 = rightSupply s20
    in s19 `seq` (s18 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href
    x1 x5 s18 cd cs) x6 s19 cd cs)) (Curry_Prelude.toCurryString "navbar-brand")
    s21 cd cs)) Curry_Prelude.OP_List))) s24 cd cs)))) (Curry_Prelude.OP_Cons
    (let s37 = leftSupply s38
         s39 = rightSupply s38
         s31 = leftSupply s39
         s36 = rightSupply s39
    in s37 `seq` (s39 `seq` (s31 `seq` (s36 `seq` Curry_Prelude.nd_C_apply
    (let s30 = leftSupply s31
         s29 = rightSupply s31
    in s30 `seq` (s29 `seq` Curry_Prelude.nd_C_apply (let s28 = leftSupply s29
                                                          s27 = rightSupply s29
    in s28 `seq` (s27 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_htmlStruct x1 s27 cd cs) (Curry_Prelude.toCurryString
    "div") s28 cd cs)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "id") (Curry_Prelude.toCurryString
    "topnavbar")) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
    "collapse navbar-collapse")) Curry_Prelude.OP_List)) s30 cd cs))
    (let s34 = leftSupply s36
         s35 = rightSupply s36
    in s34 `seq` (s35 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
    (let s33 = leftSupply s34
         s32 = rightSupply s34
    in s33 `seq` (s32 `seq` HTML.Curry_Base.nd_C_addClass x1
    (HTML.Curry_Base.nd_C_ulist x1 x3 s32 cd cs) (Curry_Prelude.toCurryString
    "nav navbar-nav") s33 cd cs)) Curry_Prelude.OP_List) (nd_C__case_1 x4 x1
    (Curry_Prelude.d_C_null x4 cd cs) s35 cd cs) cd cs)) s37 cd cs))))
    Curry_Prelude.OP_List))) s41 cd cs)))) Curry_Prelude.OP_List) s44 cd cs))))
    Curry_Prelude.OP_List
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_topNavigationBar x1
    l x3 x4 s cd cs) (nd_C_topNavigationBar x1 r x3 x4 s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_C_topNavigationBar x1 z x3 x4 s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_C_topNavigationBar x1 e x3 x4 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap3.topNavigationBar" [show x1, show x2, show x3, show
    x4] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap3.topNavigationBar" (showCons
    x2))

d_C_titledSideMenu :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_titledSideMenu x1 x2 x3 cd cs = Curry_Prelude.d_OP_plus_plus (d_C__case_0 x2
  x1 (Curry_Prelude.d_C_null x2 cd cs) cd cs) (Curry_Prelude.OP_Cons
  (HTML.Curry_Base.d_C_addClass x1 (HTML.Curry_Base.d_C_ulist x1 x3 cd cs)
  (Curry_Prelude.toCurryString "nav nav-sidebar") cd cs) Curry_Prelude.OP_List)
  cd cs

nd_C_titledSideMenu :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C_titledSideMenu x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s0 = leftSupply s4
                   s3 = rightSupply s4
  in s0 `seq` (s3 `seq` Curry_Prelude.d_OP_plus_plus (nd_C__case_0 x2 x1
  (Curry_Prelude.d_C_null x2 cd cs) s0 cd cs) (Curry_Prelude.OP_Cons
  (let s2 = leftSupply s3
       s1 = rightSupply s3
  in s2 `seq` (s1 `seq` HTML.Curry_Base.nd_C_addClass x1
  (HTML.Curry_Base.nd_C_ulist x1 x3 s1 cd cs) (Curry_Prelude.toCurryString
  "nav nav-sidebar") s2 cd cs)) Curry_Prelude.OP_List) cd cs))

nd_C_defaultButton :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func (Func
  HTML.Curry_Base.C_HtmlRef (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.C_IO HTML.Curry_Base.C_HtmlPage) -> IDSupply -> Cover
  -> ConstStore -> HTML.Curry_Base.C_HtmlExp
nd_C_defaultButton x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` HTML.Curry_Base.nd_C_addClass (wrapNX id
  HTML.Curry_Base.nd_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_HtmlExp_hash)
  (HTML.Curry_Base.nd_C_button x1 x2 s0 cd cs) (Curry_Prelude.toCurryString
  "btn btn-default") s1 cd cs))

nd_C_smallButton :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func (Func
  HTML.Curry_Base.C_HtmlRef (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.C_IO HTML.Curry_Base.C_HtmlPage) -> IDSupply -> Cover
  -> ConstStore -> HTML.Curry_Base.C_HtmlExp
nd_C_smallButton x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` HTML.Curry_Base.nd_C_addClass (wrapNX id
  HTML.Curry_Base.nd_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_HtmlExp_hash)
  (HTML.Curry_Base.nd_C_button x1 x2 s0 cd cs) (Curry_Prelude.toCurryString
  "btn btn-sm btn-default") s1 cd cs))

nd_C_primButton :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func (Func
  HTML.Curry_Base.C_HtmlRef (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.C_IO HTML.Curry_Base.C_HtmlPage) -> IDSupply -> Cover
  -> ConstStore -> HTML.Curry_Base.C_HtmlExp
nd_C_primButton x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` HTML.Curry_Base.nd_C_addClass (wrapNX id
  HTML.Curry_Base.nd_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_HtmlExp_hash)
  (HTML.Curry_Base.nd_C_button x1 x2 s0 cd cs) (Curry_Prelude.toCurryString
  "btn btn-primary") s1 cd cs))

d_C_hrefDefaultButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefDefaultButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-default") cd cs

nd_C_hrefDefaultButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefDefaultButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "btn btn-default") s3
  cd cs))

d_C_hrefSmallButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefSmallButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-sm btn-default") cd cs

nd_C_hrefSmallButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefSmallButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString
  "btn btn-sm btn-default") s3 cd cs))

d_C_hrefButton :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefButton x1 cd cs = acceptCs id (d_C_hrefSmallButton x1)

nd_C_hrefButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Func (Curry_Prelude.OP_List t0) t0)
nd_C_hrefButton x1 s cd cs = wrapDX (wrapNX id) (acceptCs id
  (nd_C_hrefSmallButton x1))

d_C_hrefPrimButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefPrimButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-primary") cd cs

nd_C_hrefPrimButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefPrimButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "btn btn-primary") s3
  cd cs))

d_C_hrefInfoButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefInfoButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-info") cd cs

nd_C_hrefInfoButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefInfoButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "btn btn-info") s3 cd
  cs))

d_C_hrefSuccessButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefSuccessButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-success") cd cs

nd_C_hrefSuccessButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefSuccessButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "btn btn-success") s3
  cd cs))

d_C_hrefWarningButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefWarningButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-warning") cd cs

nd_C_hrefWarningButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefWarningButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "btn btn-warning") s3
  cd cs))

d_C_hrefDangerButton :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefDangerButton x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-danger") cd cs

nd_C_hrefDangerButton :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefDangerButton x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString "btn btn-danger") s3
  cd cs))

d_C_hrefBlock :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> t0
d_C_hrefBlock x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-sm btn-block") cd cs

nd_C_hrefBlock :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefBlock x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString
  "btn btn-sm btn-block") s3 cd cs))

d_C_hrefInfoBlock :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0
d_C_hrefInfoBlock x1 x2 x3 cd cs = HTML.Curry_Base.d_C_addClass x1
  (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1 x2 cd cs) x3 cd cs)
  (Curry_Prelude.toCurryString "btn btn-info btn-block") cd cs

nd_C_hrefInfoBlock :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_hrefInfoBlock x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` HTML.Curry_Base.nd_C_addClass x1 (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_href x1
  x2 s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.toCurryString
  "btn btn-info btn-block") s3 cd cs))

d_C_glyphicon :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> t0
d_C_glyphicon x1 x2 cd cs = HTML.Curry_Base.d_C_textstyle x1
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "glyphicon glyphicon-") x2 cd cs) Curry_Prelude.OP_List cd cs

nd_C_glyphicon :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> t0
nd_C_glyphicon x1 x2 s cd cs = let s0 = s
  in s0 `seq` HTML.Curry_Base.nd_C_textstyle x1 (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "glyphicon glyphicon-") x2 cd cs)
  Curry_Prelude.OP_List s0 cd cs

d_C_homeIcon :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Cover -> ConstStore -> t0
d_C_homeIcon x1 cd cs = d_C_glyphicon x1 (Curry_Prelude.toCurryString "home") cd
  cs

nd_C_homeIcon :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_homeIcon x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_glyphicon x1 (Curry_Prelude.toCurryString "home") s0 cd cs

d_C_userIcon :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Cover -> ConstStore -> t0
d_C_userIcon x1 cd cs = d_C_glyphicon x1 (Curry_Prelude.toCurryString "user") cd
  cs

nd_C_userIcon :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_userIcon x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_glyphicon x1 (Curry_Prelude.toCurryString "user") s0 cd cs

d_C_loginIcon :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Cover -> ConstStore -> t0
d_C_loginIcon x1 cd cs = d_C_glyphicon x1 (Curry_Prelude.toCurryString "log-in")
  cd cs

nd_C_loginIcon :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_loginIcon x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_glyphicon x1 (Curry_Prelude.toCurryString "log-in") s0 cd cs

d_C_logoutIcon :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Cover -> ConstStore -> t0
d_C_logoutIcon x1 cd cs = d_C_glyphicon x1 (Curry_Prelude.toCurryString
  "log-out") cd cs

nd_C_logoutIcon :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_logoutIcon x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_glyphicon x1 (Curry_Prelude.toCurryString "log-out") s0 cd cs

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_2 x8 x1 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_htmlStruct x1 cd cs) (Curry_Prelude.toCurryString
    "header") cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
    "jumbotron")) Curry_Prelude.OP_List) cd cs) x8 cd cs) Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x8 x1 l cd cs)
    (d_C__case_2 x8 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x8 x1
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x8 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap3._case_2" [show x8, show x1, show x9] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap3._case_2" (showCons x9))

nd_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Func Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C__case_2 x8 x1 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> let s6 = s
    in s6 `seq` Curry_Prelude.OP_Cons (let s5 = leftSupply s6
                                           s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_htmlStruct x1 s0 cd cs) (Curry_Prelude.toCurryString
    "header") s1 cd cs)) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.toCurryString "class") (Curry_Prelude.toCurryString
    "jumbotron")) Curry_Prelude.OP_List) s3 cd cs)) x8 s5 cd cs))
    Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_2 x8 x1 l s cd
    cs) (nd_C__case_2 x8 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_2 x8
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_2 x8 x1 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap3._case_2" [show x8, show x1, show x9] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap3._case_2" (showCons x9))

d_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_3 x10 x1 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (HTML.Curry_Base.d_C_hrule x1
    cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_footer x1 cd cs) x10 cd cs) Curry_Prelude.OP_List)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x10 x1 l cd cs)
    (d_C__case_3 x10 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x10
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x10 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap3._case_3" [show x10, show x1, show x11] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap3._case_3" (showCons x11))

nd_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Func Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C__case_3 x10 x1 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> let s4 = s
    in s4 `seq` (let s0 = leftSupply s4
                     s3 = rightSupply s4
    in s0 `seq` (s3 `seq` Curry_Prelude.OP_Cons (HTML.Curry_Base.nd_C_hrule x1
    s0 cd cs) (Curry_Prelude.OP_Cons (let s2 = leftSupply s3
                                          s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_footer
    x1 s1 cd cs) x10 s2 cd cs)) Curry_Prelude.OP_List)))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_3 x10 x1 l s cd
    cs) (nd_C__case_3 x10 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_3 x10
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_3 x10 x1
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap3._case_3" [show x10, show x1, show x11] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap3._case_3" (showCons x11))

d_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_4 x6 x9 x11 x1 x7 x12 cd cs = case x12 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_blockstyle x1 (d_OP_bootstrapBody_dot_bsCols_dot_7
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (12)) cd cs) cd cs) (Curry_Prelude.d_OP_plus_plus x11
    x9 cd cs) cd cs) Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_blockstyle x1 (d_OP_bootstrapBody_dot_bsCols_dot_7
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    x6 cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_blockstyle x1 (Curry_Prelude.toCurryString
    "well nav-sidebar") cd cs) x7 cd cs) Curry_Prelude.OP_List) cd cs)
    (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_blockstyle x1 (d_OP_bootstrapBody_dot_bsCols_dot_7
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (12)) x6 cd cs) cd cs) cd cs)
    (Curry_Prelude.d_OP_plus_plus x11 x9 cd cs) cd cs) Curry_Prelude.OP_List)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x6 x9 x11 x1 x7
    l cd cs) (d_C__case_4 x6 x9 x11 x1 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x6 x9
    x11 x1 x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x6 x9
    x11 x1 x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap3._case_4" [show x6, show x9, show x11, show x1, show
    x7, show x12] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap3._case_4" (showCons x12))

nd_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0 -> Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
nd_C__case_4 x6 x9 x11 x1 x7 x12 s cd cs = case x12 of
  Curry_Prelude.C_True -> let s4 = s
    in s4 `seq` Curry_Prelude.OP_Cons (let s3 = leftSupply s4
                                           s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` HTML.Curry_Base.nd_C_blockstyle x1
    (nd_OP_bootstrapBody_dot_bsCols_dot_7 (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)
    (Curry_Prelude.C_Int (12)) s0 cd cs) s1 cd cs))
    (Curry_Prelude.d_OP_plus_plus x11 x9 cd cs) s3 cd cs)) Curry_Prelude.OP_List
  Curry_Prelude.C_False -> let s14 = s
    in s14 `seq` (let s7 = leftSupply s14
                      s13 = rightSupply s14
    in s7 `seq` (s13 `seq` Curry_Prelude.OP_Cons (let s6 = leftSupply s7
                                                      s8 = rightSupply s7
                                                      s2 = leftSupply s8
                                                      s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s2 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` HTML.Curry_Base.nd_C_blockstyle x1
    (nd_OP_bootstrapBody_dot_bsCols_dot_7 (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)
    x6 s0 cd cs) s1 cd cs)) (Curry_Prelude.OP_Cons (let s4 = leftSupply s5
                                                        s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_blockstyle x1 (Curry_Prelude.toCurryString
    "well nav-sidebar") s3 cd cs) x7 s4 cd cs)) Curry_Prelude.OP_List) s6 cd
    cs)))) (Curry_Prelude.OP_Cons (let s12 = leftSupply s13
                                       s11 = rightSupply s13
    in s12 `seq` (s11 `seq` Curry_Prelude.nd_C_apply (let s10 = leftSupply s11
                                                          s9 = rightSupply s11
    in s10 `seq` (s9 `seq` HTML.Curry_Base.nd_C_blockstyle x1
    (nd_OP_bootstrapBody_dot_bsCols_dot_7 (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (12)) x6 cd cs) s9 cd cs) s10 cd cs))
    (Curry_Prelude.d_OP_plus_plus x11 x9 cd cs) s12 cd cs))
    Curry_Prelude.OP_List)))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_4 x6 x9 x11 x1
    x7 l s cd cs) (nd_C__case_4 x6 x9 x11 x1 x7 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_4 x6
    x9 x11 x1 x7 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_4 x6 x9
    x11 x1 x7 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap3._case_4" [show x6, show x9, show x11, show x1, show
    x7, show x12] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap3._case_4" (showCons x12))

d_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0) -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_1 x4 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (HTML.Curry_Base.d_C_addClass
    x1 (HTML.Curry_Base.d_C_ulist x1 x4 cd cs) (Curry_Prelude.toCurryString
    "nav navbar-nav navbar-right") cd cs) Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x4 x1 l cd cs)
    (d_C__case_1 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x4 x1
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x4 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap3._case_1" [show x4, show x1, show x5] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap3._case_1" (showCons x5))

nd_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0) -> Func Curry_Prelude.OP_Unit
  (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C__case_1 x4 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` Curry_Prelude.OP_Cons (let s1 = leftSupply s2
                                           s0 = rightSupply s2
    in s1 `seq` (s0 `seq` HTML.Curry_Base.nd_C_addClass x1
    (HTML.Curry_Base.nd_C_ulist x1 x4 s0 cd cs) (Curry_Prelude.toCurryString
    "nav navbar-nav navbar-right") s1 cd cs)) Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_1 x4 x1 l s cd
    cs) (nd_C__case_1 x4 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_1 x4
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_1 x4 x1 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap3._case_1" [show x4, show x1, show x5] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap3._case_1" (showCons x5))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_0 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_htmlStruct x1 cd cs) (Curry_Prelude.toCurryString
    "small") cd cs) Curry_Prelude.OP_List cd cs) (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.d_C_htxt x1 x2 cd cs) Curry_Prelude.OP_List) cd cs)
    Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x2 x1 l cd cs)
    (d_C__case_0 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x2 x1
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap3._case_0" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap3._case_0" (showCons x3))

nd_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func Curry_Prelude.OP_Unit
  (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C__case_0 x2 x1 x3 s cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> let s7 = s
    in s7 `seq` Curry_Prelude.OP_Cons (let s6 = leftSupply s7
                                           s8 = rightSupply s7
                                           s4 = leftSupply s8
                                           s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s4 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (let s3 = leftSupply s4
         s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_htmlStruct x1 s0 cd cs) (Curry_Prelude.toCurryString
    "small") s1 cd cs)) Curry_Prelude.OP_List s3 cd cs)) (Curry_Prelude.OP_Cons
    (HTML.Curry_Base.nd_C_htxt x1 x2 s5 cd cs) Curry_Prelude.OP_List) s6 cd
    cs)))) Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_0 x2 x1 l s cd
    cs) (nd_C__case_0 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_0 x2
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_0 x2 x1 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.Styles.Bootstrap3._case_0" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "HTML.Styles.Bootstrap3._case_0" (showCons x3))

