{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module JSON.Curry_Data
  ( C_JValue (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
  , d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
  , d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
  , d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash )
  where

import Basics
import qualified Curry_Prelude


data C_JValue
  = C_JTrue
  | C_JFalse
  | C_JNull
  | C_JString (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_JNumber Curry_Prelude.C_Float
  | C_JArray (Curry_Prelude.OP_List C_JValue)
  | C_JObject (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_List Curry_Prelude.C_Char) C_JValue))
  | Choice_C_JValue Cover ID C_JValue C_JValue
  | Choices_C_JValue Cover ID [C_JValue]
  | Fail_C_JValue Cover FailInfo
  | Guard_C_JValue Cover Constraints C_JValue

instance Show C_JValue where
  showsPrec d (Choice_C_JValue cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_JValue cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_JValue cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_JValue cd info) = showChar '!'
  showsPrec _ C_JTrue = showString "JTrue"
  showsPrec _ C_JFalse = showString "JFalse"
  showsPrec _ C_JNull = showString "JNull"
  showsPrec _ (C_JString x1) = showString "(JString" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_JNumber x1) = showString "(JNumber" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_JArray x1) = showString "(JArray" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_JObject x1) = showString "(JObject" . (showChar ' ' . (shows
    x1 . showChar ')'))

instance Read C_JValue where
  readsPrec d s = readParen False (\r -> [(C_JTrue, r0) | (_, r0) <-
    readQualified "JSON.Data" "JTrue" r]) s ++ (readParen False (\r ->
    [(C_JFalse, r0) | (_, r0) <- readQualified "JSON.Data" "JFalse" r]) s ++
    (readParen False (\r -> [(C_JNull, r0) | (_, r0) <- readQualified
    "JSON.Data" "JNull" r]) s ++ (readParen ((>) d 10) (\r -> [(C_JString x1
    , r1) | (_, r0) <- readQualified "JSON.Data" "JString" r, (x1, r1) <-
    readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_JNumber x1, r1) | (_
    , r0) <- readQualified "JSON.Data" "JNumber" r, (x1, r1) <- readsPrec 11
    r0]) s ++ (readParen ((>) d 10) (\r -> [(C_JArray x1, r1) | (_, r0) <-
    readQualified "JSON.Data" "JArray" r, (x1, r1) <- readsPrec 11 r0]) s ++
    readParen ((>) d 10) (\r -> [(C_JObject x1, r1) | (_, r0) <- readQualified
    "JSON.Data" "JObject" r, (x1, r1) <- readsPrec 11 r0]) s)))))

instance NonDet C_JValue where
  choiceCons = Choice_C_JValue
  choicesCons = Choices_C_JValue
  failCons = Fail_C_JValue
  guardCons = Guard_C_JValue
  try (Choice_C_JValue cd i x y) = tryChoice cd i x y
  try (Choices_C_JValue cd i xs) = tryChoices cd i xs
  try (Fail_C_JValue cd info) = Fail cd info
  try (Guard_C_JValue cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_JValue cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_JValue cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_JValue cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_JValue cd i _) = error
    ("JSON.Data.JValue.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_JValue cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_JValue cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_JValue where
  generate s c = Choices_C_JValue c (freeID [0, 0, 0, 1, 1, 1, 1] s) [C_JTrue
    , C_JFalse, C_JNull, C_JString (generate (leftSupply s) c), C_JNumber
    (generate (leftSupply s) c), C_JArray (generate (leftSupply s) c), C_JObject
    (generate (leftSupply s) c)]

instance NormalForm C_JValue where
  ($!!) cont C_JTrue d cs = cont C_JTrue d cs
  ($!!) cont C_JFalse d cs = cont C_JFalse d cs
  ($!!) cont C_JNull d cs = cont C_JNull d cs
  ($!!) cont (C_JString x1) d cs = ($!!) (\y1 d cs -> cont (C_JString y1) d cs)
    x1 d cs
  ($!!) cont (C_JNumber x1) d cs = ($!!) (\y1 d cs -> cont (C_JNumber y1) d cs)
    x1 d cs
  ($!!) cont (C_JArray x1) d cs = ($!!) (\y1 d cs -> cont (C_JArray y1) d cs) x1
    d cs
  ($!!) cont (C_JObject x1) d cs = ($!!) (\y1 d cs -> cont (C_JObject y1) d cs)
    x1 d cs
  ($!!) cont (Choice_C_JValue cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_JValue cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_JValue cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_JValue cd info) _ _ = failCons cd info
  ($##) cont C_JTrue d cs = cont C_JTrue d cs
  ($##) cont C_JFalse d cs = cont C_JFalse d cs
  ($##) cont C_JNull d cs = cont C_JNull d cs
  ($##) cont (C_JString x1) d cs = ($##) (\y1 d cs -> cont (C_JString y1) d cs)
    x1 d cs
  ($##) cont (C_JNumber x1) d cs = ($##) (\y1 d cs -> cont (C_JNumber y1) d cs)
    x1 d cs
  ($##) cont (C_JArray x1) d cs = ($##) (\y1 d cs -> cont (C_JArray y1) d cs) x1
    d cs
  ($##) cont (C_JObject x1) d cs = ($##) (\y1 d cs -> cont (C_JObject y1) d cs)
    x1 d cs
  ($##) cont (Choice_C_JValue cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_JValue cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_JValue cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_JValue cd info) _ _ = failCons cd info
  showCons C_JTrue = "JSON.Data.JTrue"
  showCons C_JFalse = "JSON.Data.JFalse"
  showCons C_JNull = "JSON.Data.JNull"
  showCons (C_JString _) = "JSON.Data.JString _"
  showCons (C_JNumber _) = "JSON.Data.JNumber _"
  showCons (C_JArray _) = "JSON.Data.JArray _"
  showCons (C_JObject _) = "JSON.Data.JObject _"
  showCons x = error ("JSON.Data.JValue.showCons: no constructor: " ++ show x)
  searchNF _ cont C_JTrue = cont C_JTrue
  searchNF _ cont C_JFalse = cont C_JFalse
  searchNF _ cont C_JNull = cont C_JNull
  searchNF search cont (C_JString x1) = search (\y1 -> cont (C_JString y1)) x1
  searchNF search cont (C_JNumber x1) = search (\y1 -> cont (C_JNumber y1)) x1
  searchNF search cont (C_JArray x1) = search (\y1 -> cont (C_JArray y1)) x1
  searchNF search cont (C_JObject x1) = search (\y1 -> cont (C_JObject y1)) x1
  searchNF _ _ x = error ("JSON.Data.JValue.searchNF: no constructor: " ++ show
    x)

instance Unifiable C_JValue where
  (=.=) C_JTrue C_JTrue d cs = C_True
  (=.=) C_JFalse C_JFalse d cs = C_True
  (=.=) C_JNull C_JNull d cs = C_True
  (=.=) (C_JString x1) (C_JString y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JNumber x1) (C_JNumber y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JArray x1) (C_JArray y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JObject x1) (C_JObject y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_JTrue C_JTrue d cs = C_True
  (=.<=) C_JFalse C_JFalse d cs = C_True
  (=.<=) C_JNull C_JNull d cs = C_True
  (=.<=) (C_JString x1) (C_JString y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JNumber x1) (C_JNumber y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JArray x1) (C_JArray y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JObject x1) (C_JObject y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_JTrue = (i :=: ChooseN 0 0) : concat []
  bind cd i C_JFalse = (i :=: ChooseN 1 0) : concat []
  bind cd i C_JNull = (i :=: ChooseN 2 0) : concat []
  bind cd i (C_JString x3) = (i :=: ChooseN 3 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_JNumber x3) = (i :=: ChooseN 4 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_JArray x3) = (i :=: ChooseN 5 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_JObject x3) = (i :=: ChooseN 6 1) : concat [bind cd (leftID i)
    x3]
  bind d i (Choice_C_JValue cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_JValue cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_JValue cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_JValue cd i _) = error
    ("JSON.Data.JValue.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_JValue cd info) = [Unsolvable info]
  bind d i (Guard_C_JValue cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_JTrue = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_JFalse = (i :=: ChooseN 1 0) : []
  lazyBind cd i C_JNull = (i :=: ChooseN 2 0) : []
  lazyBind cd i (C_JString x3) = (i :=: ChooseN 3 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JNumber x3) = (i :=: ChooseN 4 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JArray x3) = (i :=: ChooseN 5 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JObject x3) = (i :=: ChooseN 6 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_JValue cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_JValue cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_JValue cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_JValue cd i _) = error
    ("JSON.Data.JValue.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_JValue cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_JValue cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_JValue where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_JValue
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "JSON.Data._inst#Prelude.Data#JSON.Data.JValue#" [show x1] info)
  _ -> failCons cd (consFail "JSON.Data._inst#Prelude.Data#JSON.Data.JValue#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash :: C_JValue
  -> C_JValue -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash x1 x2 s cd cs =
  case x1 of
  C_JTrue -> d_C__case_13 x2 cd cs
  C_JFalse -> d_C__case_12 x2 cd cs
  C_JNull -> d_C__case_11 x2 cd cs
  C_JString x15 -> let s0 = s in s0 `seq` nd_C__case_10 x15 x2 s0 cd cs
  C_JNumber x20 -> d_C__case_9 x20 x2 cd cs
  C_JArray x25 -> let s0 = s in s0 `seq` nd_C__case_8 x25 x2 s0 cd cs
  C_JObject x30 -> let s0 = s in s0 `seq` nd_C__case_7 x30 x2 s0 cd cs
  Choice_C_JValue d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
    r x2 s cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
    z x2 s cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_JValue d info -> failCons d (traceFail
    "JSON.Data._impl#===#Prelude.Data#JSON.Data.JValue#" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "JSON.Data._impl#===#Prelude.Data#JSON.Data.JValue#" (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash :: IDSupply
  -> Cover -> ConstStore -> C_JValue
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash s cd cs =
  let s17 = s
  in s17 `seq` (let s16 = leftSupply s17
                    s18 = rightSupply s17
                    s13 = leftSupply s18
                    s15 = rightSupply s18
  in s16 `seq` (s18 `seq` (s13 `seq` (s15 `seq` choice (let s12 = leftSupply s13
                                                            s14 = rightSupply
                                                              s13
                                                            s9 = leftSupply s14
                                                            s11 = rightSupply
                                                              s14
  in s12 `seq` (s14 `seq` (s9 `seq` (s11 `seq` choice (let s8 = leftSupply s9
                                                           s10 = rightSupply s9
                                                           s5 = leftSupply s10
                                                           s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` choice (let s4 = leftSupply s5
                                                         s6 = rightSupply s5
                                                         s2 = leftSupply s6
                                                         s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` choice (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
  in s1 `seq` (s0 `seq` choice (choice C_JTrue C_JFalse s0 cd cs) C_JNull s1 cd
  cs)) (C_JString
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s3 cd cs)) s4 cd cs)))) (C_JNumber
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Float_hash
  s7 cd cs)) s8 cd cs)))) (C_JArray
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash)
  s11 cd cs)) s12 cd cs)))) (C_JObject
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash)))
  s15 cd cs)) s16 cd cs))))

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_JValue
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash l
    cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash r
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash z cd
    cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "JSON.Data._inst#Prelude.Eq#JSON.Data.JValue#" [show x1] info)
  _ -> failCons cd (consFail "JSON.Data._inst#Prelude.Eq#JSON.Data.JValue#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_JValue
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash l
    s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash r
    s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "JSON.Data._inst#Prelude.Eq#JSON.Data.JValue#" [show x1] info)
  _ -> failCons cd (consFail "JSON.Data._inst#Prelude.Eq#JSON.Data.JValue#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash :: C_JValue
  -> C_JValue -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash x1 x2 cd cs =
  case x1 of
  C_JTrue -> d_C__case_6 x2 cd cs
  C_JFalse -> d_C__case_5 x2 cd cs
  C_JNull -> d_C__case_4 x2 cd cs
  C_JString x15 -> d_C__case_3 x15 x2 cd cs
  C_JNumber x20 -> d_C__case_2 x20 x2 cd cs
  C_JArray x25 -> d_C__case_1 x25 x2 cd cs
  C_JObject x30 -> d_C__case_0 x30 x2 cd cs
  Choice_C_JValue d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
    r x2 cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
    z x2 cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_JValue d info -> failCons d (traceFail
    "JSON.Data._impl#==#Prelude.Eq#JSON.Data.JValue#" [show x1, show x2] info)
  _ -> failCons cd (consFail "JSON.Data._impl#==#Prelude.Eq#JSON.Data.JValue#"
    (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash :: Cover
  -> ConstStore -> C_JValue -> Cover -> ConstStore -> C_JValue -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash)

d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show C_JValue
d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Show
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    cd cs) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash l
    cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash r
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash z
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "JSON.Data._inst#Prelude.Show#JSON.Data.JValue#" [show x1] info)
  _ -> failCons cd (consFail "JSON.Data._inst#Prelude.Show#JSON.Data.JValue#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  C_JValue
nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Show (wrapDX id
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    cd cs)) (wrapDX (wrapDX (wrapDX id)) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "JSON.Data._inst#Prelude.Show#JSON.Data.JValue#" [show x1] info)
  _ -> failCons cd (consFail "JSON.Data._inst#Prelude.Show#JSON.Data.JValue#"
    (showCons x1))

d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash :: Cover
  -> ConstStore -> C_JValue -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash

d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash :: Curry_Prelude.C_Int
  -> C_JValue -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash x1 x2 cd cs =
  case x2 of
  C_JTrue -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "JTrue")
  C_JFalse -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "JFalse")
  C_JNull -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "JNull")
  C_JString x3 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "JString "))
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash
    (Curry_Prelude.C_Int (11)) cd cs) x3 cd cs) cd cs) cd cs
  C_JNumber x4 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "JNumber "))
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Prelude_dot_Float_hash
    cd cs) (Curry_Prelude.C_Int (11)) cd cs) x4 cd cs) cd cs) cd cs
  C_JArray x5 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "JArray "))
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    (Curry_Prelude.C_Int (11)) cd cs) x5 cd cs) cd cs) cd cs
  C_JObject x6 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "JObject "))
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash)
    (Curry_Prelude.C_Int (11)) cd cs) x6 cd cs) cd cs) cd cs
  Choice_C_JValue d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    x1 l cd cs)
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    x1 r cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    x1 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    x1 e cd x) $! addCs c cs)
  Fail_C_JValue d info -> failCons d (traceFail
    "JSON.Data._impl#showsPrec#Prelude.Show#JSON.Data.JValue#" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "JSON.Data._impl#showsPrec#Prelude.Show#JSON.Data.JValue#" (showCons x2))

d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List C_JValue -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash cd
  cs

nd_C__case_7 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) C_JValue) -> C_JValue -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_7 x30 x2 s cd cs = case x2 of
  C_JTrue -> Curry_Prelude.C_False
  C_JFalse -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x31 -> Curry_Prelude.C_False
  C_JNumber x32 -> Curry_Prelude.C_False
  C_JArray x33 -> Curry_Prelude.C_False
  C_JObject x34 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash)))
    x30 x34 s0 cd cs
  Choice_C_JValue d i l r -> narrow d i (nd_C__case_7 x30 l s cd cs)
    (nd_C__case_7 x30 r s cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> nd_C__case_7 x30 z s cd cs)
    xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> nd_C__case_7 x30 e s cd x) $!
    addCs c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_7" [show x30
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_7" (showCons x2))

nd_C__case_8 :: Curry_Prelude.OP_List C_JValue -> C_JValue -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_8 x25 x2 s cd cs = case x2 of
  C_JTrue -> Curry_Prelude.C_False
  C_JFalse -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x26 -> Curry_Prelude.C_False
  C_JNumber x27 -> Curry_Prelude.C_False
  C_JArray x28 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash)
    x25 x28 s0 cd cs
  C_JObject x29 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (nd_C__case_8 x25 l s cd cs)
    (nd_C__case_8 x25 r s cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> nd_C__case_8 x25 z s cd cs)
    xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> nd_C__case_8 x25 e s cd x) $!
    addCs c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_8" [show x25
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_8" (showCons x2))

d_C__case_9 :: Curry_Prelude.C_Float -> C_JValue -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_9 x20 x2 cd cs = case x2 of
  C_JTrue -> Curry_Prelude.C_False
  C_JFalse -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x21 -> Curry_Prelude.C_False
  C_JNumber x22 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Float_hash
    cd cs) x20 cd cs) x22 cd cs
  C_JArray x23 -> Curry_Prelude.C_False
  C_JObject x24 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_9 x20 l cd cs) (d_C__case_9
    x20 r cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_9 x20 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_9 x20 e cd x) $! addCs
    c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_9" [show x20
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_9" (showCons x2))

nd_C__case_10 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_JValue
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_10 x15 x2 s cd cs = case x2 of
  C_JTrue -> Curry_Prelude.C_False
  C_JFalse -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x16 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x15 x16 s0 cd cs
  C_JNumber x17 -> Curry_Prelude.C_False
  C_JArray x18 -> Curry_Prelude.C_False
  C_JObject x19 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (nd_C__case_10 x15 l s cd cs)
    (nd_C__case_10 x15 r s cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> nd_C__case_10 x15 z s cd cs)
    xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> nd_C__case_10 x15 e s cd x) $!
    addCs c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_10" [show x15
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_10" (showCons x2))

d_C__case_11 :: C_JValue -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_11 x2 cd cs = case x2 of
  C_JTrue -> Curry_Prelude.C_False
  C_JFalse -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_True
  C_JString x11 -> Curry_Prelude.C_False
  C_JNumber x12 -> Curry_Prelude.C_False
  C_JArray x13 -> Curry_Prelude.C_False
  C_JObject x14 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_11 l cd cs) (d_C__case_11 r
    cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_11 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_11 e cd x) $! addCs c
    cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_11" [show x2]
    info)
  _ -> failCons cd (consFail "JSON.Data._case_11" (showCons x2))

d_C__case_12 :: C_JValue -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_12 x2 cd cs = case x2 of
  C_JTrue -> Curry_Prelude.C_False
  C_JFalse -> Curry_Prelude.C_True
  C_JNull -> Curry_Prelude.C_False
  C_JString x7 -> Curry_Prelude.C_False
  C_JNumber x8 -> Curry_Prelude.C_False
  C_JArray x9 -> Curry_Prelude.C_False
  C_JObject x10 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_12 l cd cs) (d_C__case_12 r
    cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_12 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_12 e cd x) $! addCs c
    cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_12" [show x2]
    info)
  _ -> failCons cd (consFail "JSON.Data._case_12" (showCons x2))

d_C__case_13 :: C_JValue -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_13 x2 cd cs = case x2 of
  C_JTrue -> Curry_Prelude.C_True
  C_JFalse -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x3 -> Curry_Prelude.C_False
  C_JNumber x4 -> Curry_Prelude.C_False
  C_JArray x5 -> Curry_Prelude.C_False
  C_JObject x6 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_13 l cd cs) (d_C__case_13 r
    cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_13 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_13 e cd x) $! addCs c
    cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_13" [show x2]
    info)
  _ -> failCons cd (consFail "JSON.Data._case_13" (showCons x2))

d_C__case_0 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) C_JValue) -> C_JValue -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_0 x30 x2 cd cs = case x2 of
  C_JTrue -> Curry_Prelude.C_False
  C_JFalse -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x31 -> Curry_Prelude.C_False
  C_JNumber x32 -> Curry_Prelude.C_False
  C_JArray x33 -> Curry_Prelude.C_False
  C_JObject x34 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash) x30
    x34 cd cs
  Choice_C_JValue d i l r -> narrow d i (d_C__case_0 x30 l cd cs) (d_C__case_0
    x30 r cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_0 x30 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_0 x30 e cd x) $! addCs
    c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_0" [show x30
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_0" (showCons x2))

d_C__case_1 :: Curry_Prelude.OP_List C_JValue -> C_JValue -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_1 x25 x2 cd cs = case x2 of
  C_JTrue -> Curry_Prelude.C_False
  C_JFalse -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x26 -> Curry_Prelude.C_False
  C_JNumber x27 -> Curry_Prelude.C_False
  C_JArray x28 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash x25
    x28 cd cs
  C_JObject x29 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_1 x25 l cd cs) (d_C__case_1
    x25 r cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_1 x25 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_1 x25 e cd x) $! addCs
    c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_1" [show x25
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_1" (showCons x2))

d_C__case_2 :: Curry_Prelude.C_Float -> C_JValue -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_2 x20 x2 cd cs = case x2 of
  C_JTrue -> Curry_Prelude.C_False
  C_JFalse -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x21 -> Curry_Prelude.C_False
  C_JNumber x22 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Float_hash
    x20 x22 cd cs
  C_JArray x23 -> Curry_Prelude.C_False
  C_JObject x24 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_2 x20 l cd cs) (d_C__case_2
    x20 r cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_2 x20 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_2 x20 e cd x) $! addCs
    c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_2" [show x20
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_2" (showCons x2))

d_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_JValue -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_3 x15 x2 cd cs = case x2 of
  C_JTrue -> Curry_Prelude.C_False
  C_JFalse -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x16 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x15 x16 cd cs
  C_JNumber x17 -> Curry_Prelude.C_False
  C_JArray x18 -> Curry_Prelude.C_False
  C_JObject x19 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_3 x15 l cd cs) (d_C__case_3
    x15 r cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_3 x15 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_3 x15 e cd x) $! addCs
    c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_3" [show x15
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_3" (showCons x2))

d_C__case_4 :: C_JValue -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_4 x2 cd cs = case x2 of
  C_JTrue -> Curry_Prelude.C_False
  C_JFalse -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_True
  C_JString x11 -> Curry_Prelude.C_False
  C_JNumber x12 -> Curry_Prelude.C_False
  C_JArray x13 -> Curry_Prelude.C_False
  C_JObject x14 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_4 l cd cs) (d_C__case_4 r cd
    cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_4 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_4 e cd x) $! addCs c
    cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_4" [show x2]
    info)
  _ -> failCons cd (consFail "JSON.Data._case_4" (showCons x2))

d_C__case_5 :: C_JValue -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_5 x2 cd cs = case x2 of
  C_JTrue -> Curry_Prelude.C_False
  C_JFalse -> Curry_Prelude.C_True
  C_JNull -> Curry_Prelude.C_False
  C_JString x7 -> Curry_Prelude.C_False
  C_JNumber x8 -> Curry_Prelude.C_False
  C_JArray x9 -> Curry_Prelude.C_False
  C_JObject x10 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_5 l cd cs) (d_C__case_5 r cd
    cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_5 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_5 e cd x) $! addCs c
    cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_5" [show x2]
    info)
  _ -> failCons cd (consFail "JSON.Data._case_5" (showCons x2))

d_C__case_6 :: C_JValue -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_6 x2 cd cs = case x2 of
  C_JTrue -> Curry_Prelude.C_True
  C_JFalse -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x3 -> Curry_Prelude.C_False
  C_JNumber x4 -> Curry_Prelude.C_False
  C_JArray x5 -> Curry_Prelude.C_False
  C_JObject x6 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_6 l cd cs) (d_C__case_6 r cd
    cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_6 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_6 e cd x) $! addCs c
    cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_6" [show x2]
    info)
  _ -> failCons cd (consFail "JSON.Data._case_6" (showCons x2))

