{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module JSON.Curry_Parser ( d_C_parseJSON ) where

import Basics
import qualified Data.Curry_Char
import qualified Curry_DetParse
import qualified JSON.Curry_Data
import qualified Curry_Prelude
import qualified Test.Curry_Prop
import qualified Test.Prop.Curry_Types


d_C_parseJSON :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Maybe
  JSON.Curry_Data.C_JValue
d_C_parseJSON cd cs = Curry_DetParse.d_C_parse (Curry_DetParse.d_OP_star_gt
  d_C_pWhitespace (d_C_pJValue cd cs) cd cs)

d_C_pJValue :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  JSON.Curry_Data.C_JValue (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_pJValue cd cs = Curry_DetParse.d_OP_lt_star (Curry_DetParse.d_OP_lt_bang_gt
  (Curry_DetParse.d_OP_lt_bang_gt (Curry_DetParse.d_OP_lt_bang_gt
  (Curry_DetParse.d_OP_lt_bang_gt (Curry_DetParse.d_OP_lt_bang_gt
  (Curry_DetParse.d_OP_lt_bang_gt (d_C_pTrue cd cs) (d_C_pFalse cd cs) cd cs)
  (d_C_pNull cd cs) cd cs) (d_C_pJString cd cs) cd cs) (d_C_pJNumber cd cs) cd
  cs) (d_C_pArray cd cs) cd cs) (d_C_pObject cd cs) cd cs) d_C_pWhitespace cd cs

d_C_pObject :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  JSON.Curry_Data.C_JValue (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_pObject cd cs = Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_OP_star_gt
  (Curry_DetParse.d_C_char (Curry_Prelude.C_Char '{'#) cd cs) d_C_pWhitespace cd
  cs) (d_C_pObjectNB cd cs) cd cs

d_C_pObjectNB :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 JSON.Curry_Data.C_JValue (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_pObjectNB cd cs = Curry_DetParse.d_OP_lt_dollar_gt (acceptCs id
  JSON.Curry_Data.C_JObject) (Curry_DetParse.d_OP_lt_bang_gt
  (Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_C_char (Curry_Prelude.C_Char
  '}'#) cd cs) (Curry_DetParse.d_C_yield Curry_Prelude.OP_List cd cs) cd cs)
  (Curry_DetParse.d_OP_lt_star (d_C_pObjectFields cd cs)
  (Curry_DetParse.d_C_char (Curry_Prelude.C_Char '}'#) cd cs) cd cs) cd cs) cd
  cs

d_C_pObjectFields :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) JSON.Curry_Data.C_JValue))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_pObjectFields cd cs = Curry_DetParse.d_OP_lt_star_gt
  (Curry_DetParse.d_OP_lt_dollar_gt (acceptCs (acceptCs id)
  Curry_Prelude.OP_Cons) (d_C_pKeyValuePair cd cs) cd cs)
  (Curry_DetParse.d_OP_lt_bang_gt (Curry_DetParse.d_OP_star_gt
  (Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_C_char (Curry_Prelude.C_Char
  ','#) cd cs) d_C_pWhitespace cd cs) (d_C_pObjectFields cd cs) cd cs)
  (Curry_DetParse.d_C_yield Curry_Prelude.OP_List cd cs) cd cs) cd cs

d_C_pKeyValuePair :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) JSON.Curry_Data.C_JValue) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_pKeyValuePair cd cs = Curry_DetParse.d_OP_lt_star_gt
  (Curry_DetParse.d_OP_lt_dollar_gt (acceptCs (acceptCs id)
  Curry_Prelude.OP_Tuple2) (d_C_pString cd cs) cd cs)
  (Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_OP_star_gt
  (Curry_DetParse.d_OP_star_gt d_C_pWhitespace (Curry_DetParse.d_C_char
  (Curry_Prelude.C_Char ':'#) cd cs) cd cs) d_C_pWhitespace cd cs) (d_C_pJValue
  cd cs) cd cs) cd cs

d_C_test_pObject_empty :: Cover -> ConstStore -> Test.Prop.Curry_Types.C_Prop
d_C_test_pObject_empty cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  JSON.Curry_Data.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  JSON.Curry_Data.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash)
  (Curry_DetParse.d_C_parse (d_C_pObject cd cs) (Curry_Prelude.toCurryString
  "{}") cd cs) (Curry_Prelude.C_Just (JSON.Curry_Data.C_JObject
  Curry_Prelude.OP_List)) cd cs

d_C_test_pObject_onlyStringKeys :: Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_test_pObject_onlyStringKeys cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  JSON.Curry_Data.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  JSON.Curry_Data.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash)
  (Curry_DetParse.d_C_parse (d_C_pObject cd cs) (Curry_Prelude.toCurryString
  "{1: 2}") cd cs) Curry_Prelude.C_Nothing cd cs

d_C_test_pObject_simple :: Cover -> ConstStore -> Test.Prop.Curry_Types.C_Prop
d_C_test_pObject_simple cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  JSON.Curry_Data.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  JSON.Curry_Data.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash)
  (Curry_DetParse.d_C_parse (d_C_pObject cd cs) (Curry_Prelude.toCurryString
  "{\"test\": 1, \"test2\": false}") cd cs) (Curry_Prelude.C_Just
  (JSON.Curry_Data.C_JObject (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "test") (JSON.Curry_Data.C_JNumber
  (Curry_Prelude.C_Float 1.0##))) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "test2")
  JSON.Curry_Data.C_JFalse) Curry_Prelude.OP_List)))) cd cs

d_C_test_pObject_whitespace :: Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_test_pObject_whitespace cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  JSON.Curry_Data.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  JSON.Curry_Data.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash)
  (Curry_DetParse.d_C_parse (d_C_pObject cd cs) (Curry_Prelude.toCurryString
  "{\n \"test\": 1,\n \"test2\": false\n}") cd cs) (Curry_Prelude.C_Just
  (JSON.Curry_Data.C_JObject (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "test") (JSON.Curry_Data.C_JNumber
  (Curry_Prelude.C_Float 1.0##))) (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "test2")
  JSON.Curry_Data.C_JFalse) Curry_Prelude.OP_List)))) cd cs

d_C_test_pObject_nested :: Cover -> ConstStore -> Test.Prop.Curry_Types.C_Prop
d_C_test_pObject_nested cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  JSON.Curry_Data.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  JSON.Curry_Data.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash)
  (Curry_DetParse.d_C_parse (d_C_pObject cd cs) (Curry_Prelude.toCurryString
  "{\"test\": {\"hello\": \"world\"}}") cd cs) (Curry_Prelude.C_Just
  (JSON.Curry_Data.C_JObject (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "test") (JSON.Curry_Data.C_JObject
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "hello") (JSON.Curry_Data.C_JString (Curry_Prelude.toCurryString "world")))
  Curry_Prelude.OP_List))) Curry_Prelude.OP_List))) cd cs

d_C_pArray :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  JSON.Curry_Data.C_JValue (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_pArray cd cs = Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_OP_star_gt
  (Curry_DetParse.d_C_char (Curry_Prelude.C_Char '['#) cd cs) d_C_pWhitespace cd
  cs) (d_C_pArrayNB cd cs) cd cs

d_C_pArrayNB :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 JSON.Curry_Data.C_JValue (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_pArrayNB cd cs = Curry_DetParse.d_OP_lt_dollar_gt (acceptCs id
  JSON.Curry_Data.C_JArray) (Curry_DetParse.d_OP_lt_bang_gt
  (Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_C_char (Curry_Prelude.C_Char
  ']'#) cd cs) (Curry_DetParse.d_C_yield Curry_Prelude.OP_List cd cs) cd cs)
  (Curry_DetParse.d_OP_lt_star (d_C_pArrayElems cd cs) (Curry_DetParse.d_C_char
  (Curry_Prelude.C_Char ']'#) cd cs) cd cs) cd cs) cd cs

d_C_pArrayElems :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List JSON.Curry_Data.C_JValue)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_pArrayElems cd cs = Curry_DetParse.d_OP_lt_star_gt
  (Curry_DetParse.d_OP_lt_dollar_gt (acceptCs (acceptCs id)
  Curry_Prelude.OP_Cons) (d_C_pJValue cd cs) cd cs)
  (Curry_DetParse.d_OP_lt_bang_gt (Curry_DetParse.d_OP_star_gt
  (Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_C_char (Curry_Prelude.C_Char
  ','#) cd cs) d_C_pWhitespace cd cs) (d_C_pArrayElems cd cs) cd cs)
  (Curry_DetParse.d_C_yield Curry_Prelude.OP_List cd cs) cd cs) cd cs

d_C_test_pArray_empty :: Cover -> ConstStore -> Test.Prop.Curry_Types.C_Prop
d_C_test_pArray_empty cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  JSON.Curry_Data.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  JSON.Curry_Data.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash)
  (Curry_DetParse.d_C_parse (d_C_pArray cd cs) (Curry_Prelude.toCurryString
  "[]") cd cs) (Curry_Prelude.C_Just (JSON.Curry_Data.C_JArray
  Curry_Prelude.OP_List)) cd cs

d_C_test_pArray_single :: Cover -> ConstStore -> Test.Prop.Curry_Types.C_Prop
d_C_test_pArray_single cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  JSON.Curry_Data.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  JSON.Curry_Data.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash)
  (Curry_DetParse.d_C_parse (d_C_pArray cd cs) (Curry_Prelude.toCurryString
  "[1]") cd cs) (Curry_Prelude.C_Just (JSON.Curry_Data.C_JArray
  (Curry_Prelude.OP_Cons (JSON.Curry_Data.C_JNumber (Curry_Prelude.C_Float
  1.0##)) Curry_Prelude.OP_List))) cd cs

d_C_test_pArray_multi :: Cover -> ConstStore -> Test.Prop.Curry_Types.C_Prop
d_C_test_pArray_multi cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  JSON.Curry_Data.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  JSON.Curry_Data.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash)
  (Curry_DetParse.d_C_parse (d_C_pArray cd cs) (Curry_Prelude.toCurryString
  "[true, false, null]") cd cs) (Curry_Prelude.C_Just (JSON.Curry_Data.C_JArray
  (Curry_Prelude.OP_Cons JSON.Curry_Data.C_JTrue (Curry_Prelude.OP_Cons
  JSON.Curry_Data.C_JFalse (Curry_Prelude.OP_Cons JSON.Curry_Data.C_JNull
  Curry_Prelude.OP_List))))) cd cs

d_C_test_pArray_nested :: Cover -> ConstStore -> Test.Prop.Curry_Types.C_Prop
d_C_test_pArray_nested cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  JSON.Curry_Data.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  JSON.Curry_Data.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash)
  (Curry_DetParse.d_C_parse (d_C_pArray cd cs) (Curry_Prelude.toCurryString
  "[true, [false], [[null]]]") cd cs) (Curry_Prelude.C_Just
  (JSON.Curry_Data.C_JArray (Curry_Prelude.OP_Cons JSON.Curry_Data.C_JTrue
  (Curry_Prelude.OP_Cons (JSON.Curry_Data.C_JArray (Curry_Prelude.OP_Cons
  JSON.Curry_Data.C_JFalse Curry_Prelude.OP_List)) (Curry_Prelude.OP_Cons
  (JSON.Curry_Data.C_JArray (Curry_Prelude.OP_Cons (JSON.Curry_Data.C_JArray
  (Curry_Prelude.OP_Cons JSON.Curry_Data.C_JNull Curry_Prelude.OP_List))
  Curry_Prelude.OP_List)) Curry_Prelude.OP_List))))) cd cs

d_C_pWhitespace :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_pWhitespace x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    Curry_Prelude.OP_Unit Curry_Prelude.OP_List) Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_2 x2 x1 x3 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_elem
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 cd cs) (Curry_Prelude.toCurryString " \n\r\t") cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_pWhitespace l cd cs)
    (d_C_pWhitespace r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_pWhitespace
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_pWhitespace e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "JSON.Parser.pWhitespace" [show x1] info)
  _ -> failCons cd (consFail "JSON.Parser.pWhitespace" (showCons x1))

d_C_pTrue :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  JSON.Curry_Data.C_JValue (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_pTrue cd cs = Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_C_word
  (Curry_Prelude.toCurryString "true") cd cs) (Curry_DetParse.d_C_yield
  JSON.Curry_Data.C_JTrue cd cs) cd cs

d_C_pFalse :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  JSON.Curry_Data.C_JValue (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_pFalse cd cs = Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_C_word
  (Curry_Prelude.toCurryString "false") cd cs) (Curry_DetParse.d_C_yield
  JSON.Curry_Data.C_JFalse cd cs) cd cs

d_C_pNull :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  JSON.Curry_Data.C_JValue (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_pNull cd cs = Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_C_word
  (Curry_Prelude.toCurryString "null") cd cs) (Curry_DetParse.d_C_yield
  JSON.Curry_Data.C_JNull cd cs) cd cs

d_C_pJString :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 JSON.Curry_Data.C_JValue (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_pJString cd cs = Curry_DetParse.d_OP_lt_dollar_gt (acceptCs id
  JSON.Curry_Data.C_JString) (d_C_pString cd cs) cd cs

d_C_pString :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_pString cd cs = Curry_DetParse.d_OP_lt_star (Curry_DetParse.d_OP_star_gt
  (Curry_DetParse.d_C_char (Curry_Prelude.C_Char '"'#) cd cs) (d_C_pCharSequence
  cd cs) cd cs) (Curry_DetParse.d_C_char (Curry_Prelude.C_Char '"'#) cd cs) cd
  cs

d_C_pCharSequence :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_pCharSequence cd cs = Curry_DetParse.d_OP_lt_bang_gt
  (Curry_DetParse.d_OP_lt_bang_gt (Curry_DetParse.d_OP_lt_star_gt
  (Curry_DetParse.d_OP_lt_dollar_gt (acceptCs id Curry_Prelude.d_OP_plus_plus)
  (Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_C_char (Curry_Prelude.C_Char
  '\\'#) cd cs) (Curry_DetParse.d_OP_lt_bang_gt (d_C_pEscaped cd cs)
  (Curry_DetParse.d_C_failure cd cs) cd cs) cd cs) cd cs) (d_C_pCharSequence cd
  cs) cd cs) (Curry_DetParse.d_OP_lt_star_gt (Curry_DetParse.d_OP_lt_dollar_gt
  (acceptCs (acceptCs id) Curry_Prelude.OP_Cons) (Curry_DetParse.d_C_check
  d_OP_pCharSequence_dot_uscore_hash_lambda1 (Curry_DetParse.d_C_anyChar cd cs)
  cd cs) cd cs) (d_C_pCharSequence cd cs) cd cs) cd cs)
  (Curry_DetParse.d_C_yield Curry_Prelude.OP_List cd cs) cd cs

d_OP_pCharSequence_dot_uscore_hash_lambda1 :: Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_pCharSequence_dot_uscore_hash_lambda1 x1 cd cs = Curry_Prelude.d_OP_amp_amp
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  cd cs) x1 cd cs) (Curry_Prelude.C_Char '"'#) cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  cd cs) x1 cd cs) (Curry_Prelude.C_Char '\\'#) cd cs) cd cs

d_C_pEscaped :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_pEscaped cd cs = Curry_DetParse.d_OP_lt_bang_gt
  (Curry_DetParse.d_OP_lt_bang_gt (Curry_DetParse.d_OP_lt_bang_gt
  (Curry_DetParse.d_OP_lt_bang_gt (Curry_DetParse.d_OP_lt_bang_gt
  (Curry_DetParse.d_OP_lt_bang_gt (Curry_DetParse.d_OP_lt_bang_gt
  (Curry_DetParse.d_OP_lt_bang_gt (Curry_DetParse.d_OP_star_gt
  (Curry_DetParse.d_C_char (Curry_Prelude.C_Char '"'#) cd cs)
  (Curry_DetParse.d_C_yield (Curry_Prelude.toCurryString "\"") cd cs) cd cs)
  (Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_C_char (Curry_Prelude.C_Char
  '\\'#) cd cs) (Curry_DetParse.d_C_yield (Curry_Prelude.toCurryString "\\") cd
  cs) cd cs) cd cs) (Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_C_char
  (Curry_Prelude.C_Char '/'#) cd cs) (Curry_DetParse.d_C_yield
  (Curry_Prelude.toCurryString "/") cd cs) cd cs) cd cs)
  (Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_C_char (Curry_Prelude.C_Char
  'b'#) cd cs) (Curry_DetParse.d_C_yield (Curry_Prelude.toCurryString "\b") cd
  cs) cd cs) cd cs) (Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_C_char
  (Curry_Prelude.C_Char 'f'#) cd cs) (Curry_DetParse.d_C_yield
  (Curry_Prelude.toCurryString "\f") cd cs) cd cs) cd cs)
  (Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_C_char (Curry_Prelude.C_Char
  'n'#) cd cs) (Curry_DetParse.d_C_yield (Curry_Prelude.toCurryString "\n") cd
  cs) cd cs) cd cs) (Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_C_char
  (Curry_Prelude.C_Char 'r'#) cd cs) (Curry_DetParse.d_C_yield
  (Curry_Prelude.toCurryString "\r") cd cs) cd cs) cd cs)
  (Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_C_char (Curry_Prelude.C_Char
  't'#) cd cs) (Curry_DetParse.d_C_yield (Curry_Prelude.toCurryString "\t") cd
  cs) cd cs) cd cs) (Curry_DetParse.d_OP_lt_dollar_gt (Curry_Prelude.d_OP_dot
  (Curry_Prelude.d_C_flip (acceptCs (acceptCs id) Curry_Prelude.OP_Cons)
  Curry_Prelude.OP_List) Curry_Prelude.d_C_chr cd cs)
  (Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_C_char (Curry_Prelude.C_Char
  'u'#) cd cs) (d_C_pTwoByteHex cd cs) cd cs) cd cs) cd cs

d_C_pTwoByteHex :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_pTwoByteHex cd cs = let x1 = Curry_DetParse.d_C_check
                              Curry_Prelude.d_C_isHexDigit
                              (Curry_DetParse.d_C_anyChar cd cs) cd cs
  in Curry_DetParse.d_OP_lt_dollar_gt d_C_hexToInt
  (Curry_DetParse.d_OP_lt_star_gt (Curry_DetParse.d_OP_lt_dollar_gt (acceptCs
  (acceptCs id) Curry_Prelude.OP_Cons) x1 cd cs) (Curry_DetParse.d_OP_lt_star_gt
  (Curry_DetParse.d_OP_lt_dollar_gt (acceptCs (acceptCs id)
  Curry_Prelude.OP_Cons) x1 cd cs) (Curry_DetParse.d_OP_lt_star_gt
  (Curry_DetParse.d_OP_lt_dollar_gt (acceptCs (acceptCs id)
  Curry_Prelude.OP_Cons) x1 cd cs) (Curry_DetParse.d_OP_lt_dollar_gt
  (Curry_Prelude.d_C_flip (acceptCs (acceptCs id) Curry_Prelude.OP_Cons)
  Curry_Prelude.OP_List) x1 cd cs) cd cs) cd cs) cd cs) cd cs

d_C_hexToInt :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Int
d_C_hexToInt x1 cd cs = Curry_Prelude.d_C_foldl1 (Curry_Prelude.d_OP_dot
  (acceptCs id
  Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash)
  (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.C_Int (16))) cd cs) (Curry_Prelude.d_C_map
  Data.Curry_Char.d_C_digitToInt x1 cd cs) cd cs

d_C_test_pCharSequence_simple :: Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_test_pCharSequence_simple cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash))
  (Curry_DetParse.d_C_parse (d_C_pCharSequence cd cs)
  (Curry_Prelude.toCurryString "test") cd cs) (Curry_Prelude.C_Just
  (Curry_Prelude.toCurryString "test")) cd cs

d_C_test_pCharSequence_noDoubleQuote :: Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_test_pCharSequence_noDoubleQuote cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash))
  (Curry_DetParse.d_C_parse (d_C_pCharSequence cd cs)
  (Curry_Prelude.toCurryString "te\"st") cd cs) Curry_Prelude.C_Nothing cd cs

d_C_test_pCharSequence_noStandaloneBackslash :: Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_test_pCharSequence_noStandaloneBackslash cd cs =
  Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash))
  (Curry_DetParse.d_C_parse (d_C_pCharSequence cd cs)
  (Curry_Prelude.toCurryString "He\\world") cd cs) Curry_Prelude.C_Nothing cd cs

d_C_test_pCharSequence_escapedDoubleQuote :: Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_test_pCharSequence_escapedDoubleQuote cd cs =
  Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash))
  (Curry_DetParse.d_C_parse (d_C_pCharSequence cd cs)
  (Curry_Prelude.toCurryString "Hello \\\"World\\\"") cd cs)
  (Curry_Prelude.C_Just (Curry_Prelude.toCurryString "Hello \"World\"")) cd cs

d_C_test_pCharSequence_escapedBackslash :: Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_test_pCharSequence_escapedBackslash cd cs =
  Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash))
  (Curry_DetParse.d_C_parse (d_C_pCharSequence cd cs)
  (Curry_Prelude.toCurryString "He\\\\world") cd cs) (Curry_Prelude.C_Just
  (Curry_Prelude.toCurryString "He\\world")) cd cs

d_C_test_pCharSequence_escapedSlash :: Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_test_pCharSequence_escapedSlash cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash))
  (Curry_DetParse.d_C_parse (d_C_pCharSequence cd cs)
  (Curry_Prelude.toCurryString "He\\/world") cd cs) (Curry_Prelude.C_Just
  (Curry_Prelude.toCurryString "He/world")) cd cs

d_C_test_pCharSequence_escapedBackspace :: Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_test_pCharSequence_escapedBackspace cd cs =
  Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash))
  (Curry_DetParse.d_C_parse (d_C_pCharSequence cd cs)
  (Curry_Prelude.toCurryString "He\\bworld") cd cs) (Curry_Prelude.C_Just
  (Curry_Prelude.toCurryString "He\bworld")) cd cs

d_C_test_pCharSequence_escapedFormFeed :: Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_test_pCharSequence_escapedFormFeed cd cs =
  Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash))
  (Curry_DetParse.d_C_parse (d_C_pCharSequence cd cs)
  (Curry_Prelude.toCurryString "He\\fworld") cd cs) (Curry_Prelude.C_Just
  (Curry_Prelude.toCurryString "He\fworld")) cd cs

d_C_test_pCharSequence_escapedNewline :: Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_test_pCharSequence_escapedNewline cd cs =
  Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash))
  (Curry_DetParse.d_C_parse (d_C_pCharSequence cd cs)
  (Curry_Prelude.toCurryString "He\\nworld") cd cs) (Curry_Prelude.C_Just
  (Curry_Prelude.toCurryString "He\nworld")) cd cs

d_C_test_pCharSequence_escapedCarriageReturn :: Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_test_pCharSequence_escapedCarriageReturn cd cs =
  Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash))
  (Curry_DetParse.d_C_parse (d_C_pCharSequence cd cs)
  (Curry_Prelude.toCurryString "He\\rworld") cd cs) (Curry_Prelude.C_Just
  (Curry_Prelude.toCurryString "He\rworld")) cd cs

d_C_test_pCharSequence_escapedTab :: Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_test_pCharSequence_escapedTab cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash))
  (Curry_DetParse.d_C_parse (d_C_pCharSequence cd cs)
  (Curry_Prelude.toCurryString "He\\tworld") cd cs) (Curry_Prelude.C_Just
  (Curry_Prelude.toCurryString "He\tworld")) cd cs

d_C_test_pCharSequence_twoEscapes :: Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_test_pCharSequence_twoEscapes cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash))
  (Curry_DetParse.d_C_parse (d_C_pCharSequence cd cs)
  (Curry_Prelude.toCurryString "He\\r\\nWorld") cd cs) (Curry_Prelude.C_Just
  (Curry_Prelude.toCurryString "He\r\nWorld")) cd cs

d_C_test_pCharSequence_escapedUnicodeChar :: Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_test_pCharSequence_escapedUnicodeChar cd cs =
  Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash))
  (Curry_DetParse.d_C_parse (d_C_pCharSequence cd cs)
  (Curry_Prelude.toCurryString "Hello \\u2603 World") cd cs)
  (Curry_Prelude.C_Just (Curry_Prelude.toCurryString "Hello \9731 World")) cd cs

d_C_test_pCharSequence_escapedUnicodeRequiresFourDigits :: Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_test_pCharSequence_escapedUnicodeRequiresFourDigits cd cs =
  Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash))
  (Curry_DetParse.d_C_parse (d_C_pCharSequence cd cs)
  (Curry_Prelude.toCurryString "Hello \\u26 World") cd cs)
  Curry_Prelude.C_Nothing cd cs

d_C_test_pString_simple :: Cover -> ConstStore -> Test.Prop.Curry_Types.C_Prop
d_C_test_pString_simple cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash))
  (Curry_DetParse.d_C_parse (d_C_pString cd cs) (Curry_Prelude.toCurryString
  "\"Hello, World\"") cd cs) (Curry_Prelude.C_Just (Curry_Prelude.toCurryString
  "Hello, World")) cd cs

d_C_test_pString_complex :: Cover -> ConstStore -> Test.Prop.Curry_Types.C_Prop
d_C_test_pString_complex cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash))
  (Curry_DetParse.d_C_parse (d_C_pString cd cs) (Curry_Prelude.toCurryString
  "\"Hello \\r\\n \\u2603 World\"") cd cs) (Curry_Prelude.C_Just
  (Curry_Prelude.toCurryString "Hello \r\n \9731 World")) cd cs

d_C_pJNumber :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 JSON.Curry_Data.C_JValue (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_pJNumber cd cs = Curry_DetParse.d_OP_lt_dollar_gt (acceptCs id
  JSON.Curry_Data.C_JNumber) (d_C_pNumber cd cs) cd cs

d_C_pNumber :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Float (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_pNumber cd cs = Curry_DetParse.d_OP_lt_bang_gt
  (Curry_DetParse.d_OP_lt_dollar_gt
  (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Float_hash
  (Curry_Prelude.C_Float 0.0##)) (Curry_DetParse.d_OP_star_gt
  (Curry_DetParse.d_C_char (Curry_Prelude.C_Char '-'#) cd cs)
  (d_C_pPositiveFloat cd cs) cd cs) cd cs) (d_C_pPositiveFloat cd cs) cd cs

d_C_toFloat :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Cover -> ConstStore -> Curry_Prelude.C_Float
d_C_toFloat x1 x2 x3 cd cs =
  Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Float_hash
  (Curry_Prelude.d_OP_uscore_impl_hash_fromInt_hash_Prelude_dot_Num_hash_Prelude_dot_Float_hash
  x1 cd cs) (d_OP_toFloat_dot_exp_dot_98
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Fractional_hash_Prelude_dot_Float_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
  (Curry_Prelude.C_Float 10.0##)
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  x2 x3 cd cs) cd cs) cd cs

d_OP_toFloat_dot_exp_dot_98 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Fractional t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Integral t0) -> t1
  -> t0 -> Cover -> ConstStore -> t1
d_OP_toFloat_dot_exp_dot_98 x1 x2 x3 x4 cd cs = d_C__case_0 x2 x4 x3 x1
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_lt
  (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Ord_hash_0_hash
  (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
  x2 cd cs) cd cs) cd cs) x4 cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_fromInt
  (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
  (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
  x2 cd cs) cd cs) cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs) cd cs

nd_OP_toFloat_dot_exp_dot_98 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Fractional t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Integral t0) -> t1
  -> t0 -> IDSupply -> Cover -> ConstStore -> t1
nd_OP_toFloat_dot_exp_dot_98 x1 x2 x3 x4 s cd cs = let s18 = s
  in s18 `seq` (let s17 = leftSupply s18
                    s15 = rightSupply s18
  in s17 `seq` (s15 `seq` nd_C__case_0 x2 x4 x3 x1 (let s14 = leftSupply s15
                                                        s16 = rightSupply s15
                                                        s6 = leftSupply s16
                                                        s13 = rightSupply s16
  in s14 `seq` (s16 `seq` (s6 `seq` (s13 `seq` Curry_Prelude.nd_C_apply
  (let s5 = leftSupply s6
       s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                      s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_lt (let s1 = leftSupply s2
                                                    s0 = rightSupply s2
  in s1 `seq` (s0 `seq`
  Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Ord_hash_0_hash
  (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
  x2 s0 cd cs) s1 cd cs)) s3 cd cs)) x4 s5 cd cs)) (let s12 = leftSupply s13
                                                        s11 = rightSupply s13
  in s12 `seq` (s11 `seq` Curry_Prelude.nd_C_apply (let s10 = leftSupply s11
                                                        s9 = rightSupply s11
  in s10 `seq` (s9 `seq` Curry_Prelude.nd_C_fromInt (let s8 = leftSupply s9
                                                         s7 = rightSupply s9
  in s8 `seq` (s7 `seq`
  Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
  (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
  x2 s7 cd cs) s8 cd cs)) s10 cd cs)) (Curry_Prelude.C_Int (0)) s12 cd cs)) s14
  cd cs)))) s17 cd cs))

d_C_pPositiveFloat :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Float (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_pPositiveFloat cd cs = Curry_DetParse.d_OP_lt_star_gt
  (Curry_DetParse.d_OP_lt_dollar_gt (Curry_Prelude.d_C_uncurry (acceptCs
  (acceptCs id) d_C_toFloat)) (d_C_pWithDecimalPoint cd cs) cd cs)
  (d_C_pExponent cd cs) cd cs

d_C_pExponent :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_pExponent cd cs = Curry_DetParse.d_OP_lt_bang_gt
  (Curry_DetParse.d_OP_lt_star_gt (Curry_DetParse.d_OP_star_gt
  (Curry_DetParse.d_OP_lt_bang_gt (Curry_DetParse.d_C_char (Curry_Prelude.C_Char
  'e'#) cd cs) (Curry_DetParse.d_C_char (Curry_Prelude.C_Char 'E'#) cd cs) cd
  cs) (Curry_DetParse.d_OP_lt_bang_gt (Curry_DetParse.d_OP_lt_bang_gt
  (Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_C_char (Curry_Prelude.C_Char
  '-'#) cd cs) (Curry_DetParse.d_C_yield
  Curry_Prelude.d_OP_uscore_impl_hash_negate_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  cd cs) cd cs) (Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_C_char
  (Curry_Prelude.C_Char '+'#) cd cs) (Curry_DetParse.d_C_yield
  Curry_Prelude.d_C_id cd cs) cd cs) cd cs) (Curry_DetParse.d_C_yield
  Curry_Prelude.d_C_id cd cs) cd cs) cd cs) (d_C_pInt cd cs) cd cs)
  (Curry_DetParse.d_C_yield (Curry_Prelude.C_Int (0)) cd cs) cd cs

d_C_pWithDecimalPoint :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  Curry_Prelude.C_Int) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_pWithDecimalPoint cd cs = Curry_DetParse.d_OP_lt_star_gt
  (Curry_DetParse.d_OP_lt_dollar_gt (acceptCs id
  d_OP_pWithDecimalPoint_dot_combine_dot_106) (Curry_DetParse.d_C_some
  (d_C_pDigit cd cs) cd cs) cd cs) (Curry_DetParse.d_OP_lt_bang_gt
  (Curry_DetParse.d_OP_star_gt (Curry_DetParse.d_C_char (Curry_Prelude.C_Char
  '.'#) cd cs) (Curry_DetParse.d_C_some (d_C_pDigit cd cs) cd cs) cd cs)
  (Curry_DetParse.d_C_yield Curry_Prelude.OP_List cd cs) cd cs) cd cs

d_OP_pWithDecimalPoint_dot_s2i_dot_106 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_OP_pWithDecimalPoint_dot_s2i_dot_106 x1 cd cs = Curry_Prelude.d_C_foldl1
  (Curry_Prelude.d_OP_dot (acceptCs id
  Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash)
  (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.C_Int (10))) cd cs) (Curry_Prelude.d_C_map
  d_OP_pWithDecimalPoint_dot_s2i_dot_106_dot_uscore_hash_lambda2 x1 cd cs) cd cs

d_OP_pWithDecimalPoint_dot_s2i_dot_106_dot_uscore_hash_lambda2 :: Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_OP_pWithDecimalPoint_dot_s2i_dot_106_dot_uscore_hash_lambda2 x1 cd cs =
  Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_ord x1 cd cs) (Curry_Prelude.d_C_ord (Curry_Prelude.C_Char
  '0'#) cd cs) cd cs

d_OP_pWithDecimalPoint_dot_combine_dot_106 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  Curry_Prelude.C_Int
d_OP_pWithDecimalPoint_dot_combine_dot_106 x1 x2 cd cs = Curry_Prelude.OP_Tuple2
  (d_OP_pWithDecimalPoint_dot_s2i_dot_106 (Curry_Prelude.d_OP_plus_plus x1 x2 cd
  cs) cd cs) (Curry_Prelude.d_OP_dollar
  Curry_Prelude.d_OP_uscore_impl_hash_negate_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_length x2 cd cs) cd cs)

d_C_pInt :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_pInt cd cs = Curry_DetParse.d_OP_lt_dollar_gt
  d_OP_pInt_dot_uscore_hash_lambda3 (Curry_DetParse.d_C_some (d_C_pDigit cd cs)
  cd cs) cd cs

d_OP_pInt_dot_uscore_hash_lambda3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_OP_pInt_dot_uscore_hash_lambda3 x1 cd cs = Curry_Prelude.d_C_foldl1
  (Curry_Prelude.d_OP_dot (acceptCs id
  Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash)
  (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.C_Int (10))) cd cs) (Curry_Prelude.d_C_map
  d_OP_pInt_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 x1 cd cs) cd cs

d_OP_pInt_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 :: Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_OP_pInt_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 x1 cd cs =
  Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_ord x1 cd cs) (Curry_Prelude.d_C_ord (Curry_Prelude.C_Char
  '0'#) cd cs) cd cs

d_C_pDigit :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Char (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_pDigit cd cs = Curry_DetParse.d_C_check Curry_Prelude.d_C_isDigit
  (Curry_DetParse.d_C_anyChar cd cs) cd cs

d_C__case_2 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C__case_2 x2 x1 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> d_C_pWhitespace x3 cd cs
  Curry_Prelude.C_False -> d_C__case_1 x1 (Curry_Prelude.d_C_otherwise cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x2 x1 x3 l cd
    cs) (d_C__case_2 x2 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x2 x1
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x2 x1 x3
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "JSON.Parser._case_2" [show x2, show x1, show x3, show x4] info)
  _ -> failCons cd (consFail "JSON.Parser._case_2" (showCons x4))

d_C__case_1 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C__case_1 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    Curry_Prelude.OP_Unit x1) Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x1 l cd cs)
    (d_C__case_1 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "JSON.Parser._case_1" [show x1, show x2] info)
  _ -> failCons cd (consFail "JSON.Parser._case_1" (showCons x2))

d_C__case_0 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Integral t0) -> t0 -> t1
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Fractional t1) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> t1
d_C__case_0 x2 x4 x3 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_slash x1 cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_fromInt
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 cd cs) cd cs) (Curry_Prelude.C_Int (1)) cd cs) cd cs)
    (Curry_Prelude.d_OP_caret
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 cd cs) x2 x3 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_minus
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x2 cd cs) cd cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_fromInt
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x2 cd cs) cd cs) cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs) x4 cd cs) cd
    cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_caret
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 cd cs) x2 x3 x4 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x2 x4 x3 x1 l
    cd cs) (d_C__case_0 x2 x4 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x2 x4
    x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x2 x4 x3
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "JSON.Parser._case_0" [show x2, show x4, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "JSON.Parser._case_0" (showCons x5))

nd_C__case_0 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Integral
  t0) -> t0 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Fractional t1) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> t1
nd_C__case_0 x2 x4 x3 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s31 = s
    in s31 `seq` (let s30 = leftSupply s31
                      s32 = rightSupply s31
                      s7 = leftSupply s32
                      s28 = rightSupply s32
    in s30 `seq` (s32 `seq` (s7 `seq` (s28 `seq` Curry_Prelude.nd_C_apply
    (let s6 = leftSupply s7
         s8 = rightSupply s7
         s0 = leftSupply s8
         s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s0 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_OP_slash x1 s0 cd cs) (let s4 = leftSupply s5
                                                 s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                        s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_fromInt
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 s1 cd cs) s2 cd cs)) (Curry_Prelude.C_Int (1)) s4 cd cs)) s6 cd cs))))
    (let s27 = leftSupply s28
         s29 = rightSupply s28
         s9 = leftSupply s29
         s26 = rightSupply s29
    in s27 `seq` (s29 `seq` (s9 `seq` (s26 `seq` Curry_Prelude.nd_OP_caret
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 s9 cd cs) x2 x3 (let s25 = leftSupply s26
                            s23 = rightSupply s26
    in s25 `seq` (s23 `seq` Curry_Prelude.nd_C_apply (let s22 = leftSupply s23
                                                          s24 = rightSupply s23
                                                          s14 = leftSupply s24
                                                          s21 = rightSupply s24
    in s22 `seq` (s24 `seq` (s14 `seq` (s21 `seq` Curry_Prelude.nd_C_apply
    (let s13 = leftSupply s14
         s12 = rightSupply s14
    in s13 `seq` (s12 `seq` Curry_Prelude.nd_OP_minus (let s11 = leftSupply s12
                                                           s10 = rightSupply s12
    in s11 `seq` (s10 `seq`
    Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x2 s10 cd cs) s11 cd cs)) s13 cd cs)) (let s20 = leftSupply s21
                                               s19 = rightSupply s21
    in s20 `seq` (s19 `seq` Curry_Prelude.nd_C_apply (let s18 = leftSupply s19
                                                          s17 = rightSupply s19
    in s18 `seq` (s17 `seq` Curry_Prelude.nd_C_fromInt (let s16 = leftSupply s17
                                                            s15 = rightSupply
                                                              s17
    in s16 `seq` (s15 `seq`
    Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x2 s15 cd cs) s16 cd cs)) s18 cd cs)) (Curry_Prelude.C_Int (0)) s20 cd cs))
    s22 cd cs)))) x4 s25 cd cs)) s27 cd cs)))) s30 cd cs))))
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_caret
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 s0 cd cs) x2 x3 x4 s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_0 x2 x4 x3 x1 l
    s cd cs) (nd_C__case_0 x2 x4 x3 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_0 x2
    x4 x3 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_0 x2 x4
    x3 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "JSON.Parser._case_0" [show x2, show x4, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "JSON.Parser._case_0" (showCons x5))

