{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module JSON.Curry_Data
  ( C_JValue (..)
  , C_JObject (..)
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JObject_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JObject_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JObject_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
  , d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
  , d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
  , d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash
  , d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash
  , d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash
  , d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash
  , d_C_fromJObject
  , d_C_toJObject
  , d_C_lookupName
  , d_C_insertField )
  where

import Basics
import qualified Data.Curry_List
import qualified Curry_Prelude


data C_JValue
  = C_JBool Curry_Prelude.C_Bool
  | C_JNull
  | C_JString (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_JInt Curry_Prelude.C_Int
  | C_JNumber Curry_Prelude.C_Float
  | C_JArray (Curry_Prelude.OP_List C_JValue)
  | C_JObject C_JObject
  | Choice_C_JValue Cover ID C_JValue C_JValue
  | Choices_C_JValue Cover ID [C_JValue]
  | Fail_C_JValue Cover FailInfo
  | Guard_C_JValue Cover Constraints C_JValue

instance Show C_JValue where
  showsPrec d (Choice_C_JValue cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_JValue cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_JValue cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_JValue cd info) = showChar '!'
  showsPrec _ (C_JBool x1) = showString "(JBool" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ C_JNull = showString "JNull"
  showsPrec _ (C_JString x1) = showString "(JString" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_JInt x1) = showString "(JInt" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_JNumber x1) = showString "(JNumber" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_JArray x1) = showString "(JArray" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_JObject x1) = showString "(JObject" . (showChar ' ' . (shows
    x1 . showChar ')'))

instance Read C_JValue where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_JBool x1, r1) | (_, r0) <-
    readQualified "JSON.Data" "JBool" r, (x1, r1) <- readsPrec 11 r0]) s ++
    (readParen False (\r -> [(C_JNull, r0) | (_, r0) <- readQualified
    "JSON.Data" "JNull" r]) s ++ (readParen ((>) d 10) (\r -> [(C_JString x1
    , r1) | (_, r0) <- readQualified "JSON.Data" "JString" r, (x1, r1) <-
    readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_JInt x1, r1) | (_
    , r0) <- readQualified "JSON.Data" "JInt" r, (x1, r1) <- readsPrec 11 r0])
    s ++ (readParen ((>) d 10) (\r -> [(C_JNumber x1, r1) | (_, r0) <-
    readQualified "JSON.Data" "JNumber" r, (x1, r1) <- readsPrec 11 r0]) s ++
    (readParen ((>) d 10) (\r -> [(C_JArray x1, r1) | (_, r0) <- readQualified
    "JSON.Data" "JArray" r, (x1, r1) <- readsPrec 11 r0]) s ++ readParen ((>) d
    10) (\r -> [(C_JObject x1, r1) | (_, r0) <- readQualified "JSON.Data"
    "JObject" r, (x1, r1) <- readsPrec 11 r0]) s)))))

instance NonDet C_JValue where
  choiceCons = Choice_C_JValue
  choicesCons = Choices_C_JValue
  failCons = Fail_C_JValue
  guardCons = Guard_C_JValue
  try (Choice_C_JValue cd i x y) = tryChoice cd i x y
  try (Choices_C_JValue cd i xs) = tryChoices cd i xs
  try (Fail_C_JValue cd info) = Fail cd info
  try (Guard_C_JValue cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_JValue cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_JValue cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_JValue cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_JValue cd i _) = error
    ("JSON.Data.JValue.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_JValue cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_JValue cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_JValue where
  generate s c = Choices_C_JValue c (freeID [1, 0, 1, 1, 1, 1, 1] s) [C_JBool
    (generate (leftSupply s) c), C_JNull, C_JString (generate (leftSupply s) c)
    , C_JInt (generate (leftSupply s) c), C_JNumber (generate (leftSupply s) c)
    , C_JArray (generate (leftSupply s) c), C_JObject (generate (leftSupply s)
    c)]

instance NormalForm C_JValue where
  ($!!) cont (C_JBool x1) d cs = ($!!) (\y1 d cs -> cont (C_JBool y1) d cs) x1 d
    cs
  ($!!) cont C_JNull d cs = cont C_JNull d cs
  ($!!) cont (C_JString x1) d cs = ($!!) (\y1 d cs -> cont (C_JString y1) d cs)
    x1 d cs
  ($!!) cont (C_JInt x1) d cs = ($!!) (\y1 d cs -> cont (C_JInt y1) d cs) x1 d
    cs
  ($!!) cont (C_JNumber x1) d cs = ($!!) (\y1 d cs -> cont (C_JNumber y1) d cs)
    x1 d cs
  ($!!) cont (C_JArray x1) d cs = ($!!) (\y1 d cs -> cont (C_JArray y1) d cs) x1
    d cs
  ($!!) cont (C_JObject x1) d cs = ($!!) (\y1 d cs -> cont (C_JObject y1) d cs)
    x1 d cs
  ($!!) cont (Choice_C_JValue cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_JValue cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_JValue cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_JValue cd info) _ _ = failCons cd info
  ($##) cont (C_JBool x1) d cs = ($##) (\y1 d cs -> cont (C_JBool y1) d cs) x1 d
    cs
  ($##) cont C_JNull d cs = cont C_JNull d cs
  ($##) cont (C_JString x1) d cs = ($##) (\y1 d cs -> cont (C_JString y1) d cs)
    x1 d cs
  ($##) cont (C_JInt x1) d cs = ($##) (\y1 d cs -> cont (C_JInt y1) d cs) x1 d
    cs
  ($##) cont (C_JNumber x1) d cs = ($##) (\y1 d cs -> cont (C_JNumber y1) d cs)
    x1 d cs
  ($##) cont (C_JArray x1) d cs = ($##) (\y1 d cs -> cont (C_JArray y1) d cs) x1
    d cs
  ($##) cont (C_JObject x1) d cs = ($##) (\y1 d cs -> cont (C_JObject y1) d cs)
    x1 d cs
  ($##) cont (Choice_C_JValue cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_JValue cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_JValue cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_JValue cd info) _ _ = failCons cd info
  showCons (C_JBool _) = "JSON.Data.JBool _"
  showCons C_JNull = "JSON.Data.JNull"
  showCons (C_JString _) = "JSON.Data.JString _"
  showCons (C_JInt _) = "JSON.Data.JInt _"
  showCons (C_JNumber _) = "JSON.Data.JNumber _"
  showCons (C_JArray _) = "JSON.Data.JArray _"
  showCons (C_JObject _) = "JSON.Data.JObject _"
  showCons x = error ("JSON.Data.JValue.showCons: no constructor: " ++ show x)
  searchNF search cont (C_JBool x1) = search (\y1 -> cont (C_JBool y1)) x1
  searchNF _ cont C_JNull = cont C_JNull
  searchNF search cont (C_JString x1) = search (\y1 -> cont (C_JString y1)) x1
  searchNF search cont (C_JInt x1) = search (\y1 -> cont (C_JInt y1)) x1
  searchNF search cont (C_JNumber x1) = search (\y1 -> cont (C_JNumber y1)) x1
  searchNF search cont (C_JArray x1) = search (\y1 -> cont (C_JArray y1)) x1
  searchNF search cont (C_JObject x1) = search (\y1 -> cont (C_JObject y1)) x1
  searchNF _ _ x = error ("JSON.Data.JValue.searchNF: no constructor: " ++ show
    x)

instance Unifiable C_JValue where
  (=.=) (C_JBool x1) (C_JBool y1) d cs = (=:=) x1 y1 d cs
  (=.=) C_JNull C_JNull d cs = C_True
  (=.=) (C_JString x1) (C_JString y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JInt x1) (C_JInt y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JNumber x1) (C_JNumber y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JArray x1) (C_JArray y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JObject x1) (C_JObject y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_JBool x1) (C_JBool y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) C_JNull C_JNull d cs = C_True
  (=.<=) (C_JString x1) (C_JString y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JInt x1) (C_JInt y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JNumber x1) (C_JNumber y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JArray x1) (C_JArray y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JObject x1) (C_JObject y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_JBool x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID i) x3]
  bind cd i C_JNull = (i :=: ChooseN 1 0) : concat []
  bind cd i (C_JString x3) = (i :=: ChooseN 2 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_JInt x3) = (i :=: ChooseN 3 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_JNumber x3) = (i :=: ChooseN 4 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_JArray x3) = (i :=: ChooseN 5 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_JObject x3) = (i :=: ChooseN 6 1) : concat [bind cd (leftID i)
    x3]
  bind d i (Choice_C_JValue cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_JValue cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_JValue cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_JValue cd i _) = error
    ("JSON.Data.JValue.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_JValue cd info) = [Unsolvable info]
  bind d i (Guard_C_JValue cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_JBool x3) = (i :=: ChooseN 0 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i C_JNull = (i :=: ChooseN 1 0) : []
  lazyBind cd i (C_JString x3) = (i :=: ChooseN 2 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JInt x3) = (i :=: ChooseN 3 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JNumber x3) = (i :=: ChooseN 4 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JArray x3) = (i :=: ChooseN 5 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JObject x3) = (i :=: ChooseN 6 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_JValue cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_JValue cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_JValue cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_JValue cd i _) = error
    ("JSON.Data.JValue.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_JValue cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_JValue cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_JValue where

newtype C_JObject = C_JSONObject (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_List Curry_Prelude.C_Char) C_JValue))

instance Show C_JObject where
  showsPrec _ (C_JSONObject x1) = showString "(JSONObject" . (showChar ' ' .
    (shows x1 . showChar ')'))

instance Read C_JObject where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_JSONObject x1, r1) | (_, r0)
    <- readQualified "JSON.Data" "JSONObject" r, (x1, r1) <- readsPrec 11 r0]) s

instance NonDet C_JObject where
  choiceCons cd i (C_JSONObject x) (C_JSONObject y) = C_JSONObject (choiceCons
    cd i x y)
  choicesCons cd i xs = C_JSONObject (choicesCons cd i (map
    (\(C_JSONObject v) -> v) xs))
  failCons cd info = C_JSONObject (failCons cd info)
  guardCons cd c (C_JSONObject e) = C_JSONObject (guardCons cd c e)
  match chc nrwd fr fl grd vl (C_JSONObject v) = match (\cd i x y -> chc cd i
    (C_JSONObject x) (C_JSONObject y)) (\cd i xs -> nrwd cd i (map C_JSONObject
    xs)) (\cd i xs -> fr cd i (map C_JSONObject xs)) fl (\cd cs e -> grd cd cs
    (C_JSONObject e)) (vl . C_JSONObject) v

instance Generable C_JObject where
  generate s c = C_JSONObject (generate s c)

instance NormalForm C_JObject where
  ($!!) cont (C_JSONObject x) = ($!!) (\y -> cont (C_JSONObject y)) x
  ($##) cont (C_JSONObject x) = ($##) (\y -> cont (C_JSONObject y)) x
  searchNF s cont (C_JSONObject x) = searchNF s (cont . C_JSONObject) x

instance Unifiable C_JObject where
  (=.=) (C_JSONObject x) (C_JSONObject y) = (=.=) x y
  (=.<=) (C_JSONObject x) (C_JSONObject y) = (=.<=) x y
  bind cd i (C_JSONObject x) = bind cd i x
  lazyBind cd i (C_JSONObject x) = lazyBind cd i x

instance Curry C_JObject where

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_JObject
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash l
    cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash r
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash z
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "JSON.Data._inst#Prelude.Eq#JSON.Data.JObject#" [show x1] info)
  _ -> failCons cd (consFail "JSON.Data._inst#Prelude.Eq#JSON.Data.JObject#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_JObject
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash l
    s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash r
    s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "JSON.Data._inst#Prelude.Eq#JSON.Data.JObject#" [show x1] info)
  _ -> failCons cd (consFail "JSON.Data._inst#Prelude.Eq#JSON.Data.JObject#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash :: C_JObject
  -> C_JObject -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash x1 x2 cd cs =
  case x1 of
  C_JSONObject x3 -> d_C__case_24 x3 x2 cd cs

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0) -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18 x1 x2 x3 x4 cd cs =
  case x3 of
  Curry_Prelude.OP_List -> d_C__case_23 x4 cd cs
  Curry_Prelude.OP_Cons x7 x8 -> d_C__case_22 x4 x2 x8 x1 x7 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18
    x1 x2 l x4 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18
    x1 x2 r x4 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18
    x1 x2 z x4 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18
    x1 x2 e x4 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "JSON.Data._impl#==#Prelude.Eq#JSON.Data.JObject#.eqJObject.18" [show x1
    , show x2, show x3, show x4] info)
  _ -> failCons cd (consFail
    "JSON.Data._impl#==#Prelude.Eq#JSON.Data.JObject#.eqJObject.18" (showCons
    x3))

nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18 x1 x2 x3 x4 s cd cs =
  case x3 of
  Curry_Prelude.OP_List -> d_C__case_23 x4 cd cs
  Curry_Prelude.OP_Cons x7 x8 -> let s0 = s
    in s0 `seq` nd_C__case_22 x4 x2 x8 x1 x7 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18
    x1 x2 l x4 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18
    x1 x2 r x4 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18
    x1 x2 z x4 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18
    x1 x2 e x4 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "JSON.Data._impl#==#Prelude.Eq#JSON.Data.JObject#.eqJObject.18" [show x1
    , show x2, show x3, show x4] info)
  _ -> failCons cd (consFail
    "JSON.Data._impl#==#Prelude.Eq#JSON.Data.JObject#.eqJObject.18" (showCons
    x3))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18_dot_uscore_hash_selFP2_hash_eqk :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t1 t0)) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18_dot_uscore_hash_selFP2_hash_eqk x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18_dot_uscore_hash_selFP2_hash_eqk
    l cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18_dot_uscore_hash_selFP2_hash_eqk
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18_dot_uscore_hash_selFP2_hash_eqk
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18_dot_uscore_hash_selFP2_hash_eqk
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "JSON.Data._impl#==#Prelude.Eq#JSON.Data.JObject#.eqJObject.18._#selFP2#eqk"
    [show x1] info)
  _ -> failCons cd (consFail
    "JSON.Data._impl#==#Prelude.Eq#JSON.Data.JObject#.eqJObject.18._#selFP2#eqk"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18_dot_uscore_hash_selFP3_hash_neqk :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t1 t0)) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18_dot_uscore_hash_selFP3_hash_neqk x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18_dot_uscore_hash_selFP3_hash_neqk
    l cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18_dot_uscore_hash_selFP3_hash_neqk
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18_dot_uscore_hash_selFP3_hash_neqk
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18_dot_uscore_hash_selFP3_hash_neqk
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "JSON.Data._impl#==#Prelude.Eq#JSON.Data.JObject#.eqJObject.18._#selFP3#neqk"
    [show x1] info)
  _ -> failCons cd (consFail
    "JSON.Data._impl#==#Prelude.Eq#JSON.Data.JObject#.eqJObject.18._#selFP3#neqk"
    (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash :: Cover
  -> ConstStore -> C_JObject -> Cover -> ConstStore -> C_JObject -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash)

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_JValue
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "JSON.Data._inst#Prelude.Data#JSON.Data.JValue#" [show x1] info)
  _ -> failCons cd (consFail "JSON.Data._inst#Prelude.Data#JSON.Data.JValue#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash :: C_JValue
  -> C_JValue -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash x1 x2 s cd cs =
  case x1 of
  C_JBool x3 -> d_C__case_18 x3 x2 cd cs
  C_JNull -> d_C__case_17 x2 cd cs
  C_JString x16 -> let s0 = s in s0 `seq` nd_C__case_16 x16 x2 s0 cd cs
  C_JInt x23 -> d_C__case_15 x23 x2 cd cs
  C_JNumber x30 -> d_C__case_14 x30 x2 cd cs
  C_JArray x37 -> let s0 = s in s0 `seq` nd_C__case_13 x37 x2 s0 cd cs
  C_JObject x44 -> let s0 = s in s0 `seq` nd_C__case_12 x44 x2 s0 cd cs
  Choice_C_JValue d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
    r x2 s cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
    z x2 s cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_JValue d info -> failCons d (traceFail
    "JSON.Data._impl#===#Prelude.Data#JSON.Data.JValue#" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "JSON.Data._impl#===#Prelude.Data#JSON.Data.JValue#" (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash :: IDSupply
  -> Cover -> ConstStore -> C_JValue
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash s cd cs =
  let s21 = s
  in s21 `seq` (let s20 = leftSupply s21
                    s22 = rightSupply s21
                    s17 = leftSupply s22
                    s19 = rightSupply s22
  in s20 `seq` (s22 `seq` (s17 `seq` (s19 `seq` choice (let s16 = leftSupply s17
                                                            s18 = rightSupply
                                                              s17
                                                            s13 = leftSupply s18
                                                            s15 = rightSupply
                                                              s18
  in s16 `seq` (s18 `seq` (s13 `seq` (s15 `seq` choice (let s12 = leftSupply s13
                                                            s14 = rightSupply
                                                              s13
                                                            s9 = leftSupply s14
                                                            s11 = rightSupply
                                                              s14
  in s12 `seq` (s14 `seq` (s9 `seq` (s11 `seq` choice (let s8 = leftSupply s9
                                                           s10 = rightSupply s9
                                                           s5 = leftSupply s10
                                                           s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` choice (let s4 = leftSupply s5
                                                         s6 = rightSupply s5
                                                         s2 = leftSupply s6
                                                         s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` choice (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
  in s1 `seq` (s0 `seq` choice (C_JBool
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
  s0 cd cs)) C_JNull s1 cd cs)) (C_JString
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s3 cd cs)) s4 cd cs)))) (C_JInt
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s7 cd cs)) s8 cd cs)))) (C_JNumber
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Float_hash
  s11 cd cs)) s12 cd cs)))) (C_JArray
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash)
  s15 cd cs)) s16 cd cs)))) (C_JObject
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JObject_hash
  s19 cd cs)) s20 cd cs))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JObject_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_JObject
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JObject_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JObject_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JObject_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JObject_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JObject_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JObject_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JObject_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "JSON.Data._inst#Prelude.Data#JSON.Data.JObject#" [show x1] info)
  _ -> failCons cd (consFail "JSON.Data._inst#Prelude.Data#JSON.Data.JObject#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JObject_hash :: C_JObject
  -> C_JObject -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JObject_hash x1 x2 s cd cs =
  case x1 of
  C_JSONObject x3 -> let s0 = s in s0 `seq` nd_C__case_11 x3 x2 s0 cd cs

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JObject_hash :: IDSupply
  -> Cover -> ConstStore -> C_JObject
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JObject_hash s cd cs =
  let s0 = s
  in s0 `seq` C_JSONObject
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash)))
  s0 cd cs)

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_JValue
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash l
    cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash r
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash z cd
    cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "JSON.Data._inst#Prelude.Eq#JSON.Data.JValue#" [show x1] info)
  _ -> failCons cd (consFail "JSON.Data._inst#Prelude.Eq#JSON.Data.JValue#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_JValue
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash l
    s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash r
    s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "JSON.Data._inst#Prelude.Eq#JSON.Data.JValue#" [show x1] info)
  _ -> failCons cd (consFail "JSON.Data._inst#Prelude.Eq#JSON.Data.JValue#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash :: C_JValue
  -> C_JValue -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash x1 x2 cd cs =
  case x1 of
  C_JBool x3 -> d_C__case_10 x3 x2 cd cs
  C_JNull -> d_C__case_9 x2 cd cs
  C_JString x16 -> d_C__case_8 x16 x2 cd cs
  C_JInt x23 -> d_C__case_7 x23 x2 cd cs
  C_JNumber x30 -> d_C__case_6 x30 x2 cd cs
  C_JArray x37 -> d_C__case_5 x37 x2 cd cs
  C_JObject x44 -> d_C__case_4 x44 x2 cd cs
  Choice_C_JValue d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
    r x2 cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
    z x2 cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_JValue d info -> failCons d (traceFail
    "JSON.Data._impl#==#Prelude.Eq#JSON.Data.JValue#" [show x1, show x2] info)
  _ -> failCons cd (consFail "JSON.Data._impl#==#Prelude.Eq#JSON.Data.JValue#"
    (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash :: Cover
  -> ConstStore -> C_JValue -> Cover -> ConstStore -> C_JValue -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash)

d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show C_JValue
d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Show
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    cd cs) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash l
    cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash r
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash z
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "JSON.Data._inst#Prelude.Show#JSON.Data.JValue#" [show x1] info)
  _ -> failCons cd (consFail "JSON.Data._inst#Prelude.Show#JSON.Data.JValue#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  C_JValue
nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Show (wrapDX id
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    cd cs)) (wrapDX (wrapDX (wrapDX id)) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "JSON.Data._inst#Prelude.Show#JSON.Data.JValue#" [show x1] info)
  _ -> failCons cd (consFail "JSON.Data._inst#Prelude.Show#JSON.Data.JValue#"
    (showCons x1))

d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash :: Cover
  -> ConstStore -> C_JValue -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash

d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash :: Curry_Prelude.C_Int
  -> C_JValue -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash x1 x2 cd cs =
  case x2 of
  C_JBool x3 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "JBool "))
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Prelude_dot_Bool_hash
    (Curry_Prelude.C_Int (11)) x3 cd cs) cd cs) cd cs
  C_JNull -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "JNull")
  C_JString x4 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "JString "))
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash
    (Curry_Prelude.C_Int (11)) cd cs) x4 cd cs) cd cs) cd cs
  C_JInt x5 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "JInt "))
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (11)) cd cs) x5 cd cs) cd cs) cd cs
  C_JNumber x6 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "JNumber "))
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Prelude_dot_Float_hash
    cd cs) (Curry_Prelude.C_Int (11)) cd cs) x6 cd cs) cd cs) cd cs
  C_JArray x7 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "JArray "))
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    (Curry_Prelude.C_Int (11)) cd cs) x7 cd cs) cd cs) cd cs
  C_JObject x8 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "JObject "))
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash
    (Curry_Prelude.C_Int (11)) x8 cd cs) cd cs) cd cs
  Choice_C_JValue d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    x1 l cd cs)
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    x1 r cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    x1 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash
    x1 e cd x) $! addCs c cs)
  Fail_C_JValue d info -> failCons d (traceFail
    "JSON.Data._impl#showsPrec#Prelude.Show#JSON.Data.JValue#" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "JSON.Data._impl#showsPrec#Prelude.Show#JSON.Data.JValue#" (showCons x2))

d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List C_JValue -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash cd
  cs

d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show C_JObject
d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Show
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash
    cd cs) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash z
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "JSON.Data._inst#Prelude.Show#JSON.Data.JObject#" [show x1] info)
  _ -> failCons cd (consFail "JSON.Data._inst#Prelude.Show#JSON.Data.JObject#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  C_JObject
nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Show (wrapDX id
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash
    cd cs)) (wrapDX (wrapDX (wrapDX id)) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "JSON.Data._inst#Prelude.Show#JSON.Data.JObject#" [show x1] info)
  _ -> failCons cd (consFail "JSON.Data._inst#Prelude.Show#JSON.Data.JObject#"
    (showCons x1))

d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash :: Cover
  -> ConstStore -> C_JObject -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash

d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash :: Curry_Prelude.C_Int
  -> C_JObject -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash x1 x2 cd cs =
  case x2 of
  C_JSONObject x3 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "JSONObject "))
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JValue_hash)
    (Curry_Prelude.C_Int (11)) cd cs) x3 cd cs) cd cs) cd cs

d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List C_JObject -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_JSON_dot_Data_dot_JObject_hash cd
  cs

d_C_fromJObject :: C_JObject -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  C_JValue)
d_C_fromJObject x1 cd cs = case x1 of
  C_JSONObject x2 -> x2

d_C_toJObject :: Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  C_JValue) -> Cover -> ConstStore -> C_JObject
d_C_toJObject cd cs = Curry_Prelude.d_OP_dot (acceptCs id C_JSONObject)
  (Data.Curry_List.d_C_nubBy (acceptCs id
  d_OP_toJObject_dot_uscore_hash_lambda2)) cd cs

d_OP_toJObject_dot_uscore_hash_lambda2 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) C_JValue
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  C_JValue -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_toJObject_dot_uscore_hash_lambda2 x1 x2 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_3 x3 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_toJObject_dot_uscore_hash_lambda2 l x2 cd cs)
    (d_OP_toJObject_dot_uscore_hash_lambda2 r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_toJObject_dot_uscore_hash_lambda2 z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_toJObject_dot_uscore_hash_lambda2 e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "JSON.Data.toJObject._#lambda2" [show x1, show x2] info)
  _ -> failCons cd (consFail "JSON.Data.toJObject._#lambda2" (showCons x1))

d_C_lookupName :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_JObject
  -> Cover -> ConstStore -> Curry_Prelude.C_Maybe C_JValue
d_C_lookupName x1 x2 cd cs = case x2 of
  C_JSONObject x3 -> Curry_Prelude.d_C_lookup
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x1 x3 cd cs

d_C_insertField :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_JValue
  -> C_JObject -> Cover -> ConstStore -> C_JObject
d_C_insertField x1 x2 x3 cd cs = case x3 of
  C_JSONObject x4 -> C_JSONObject (d_OP_insertField_dot_insert_dot_11 x2 x1 x4
    cd cs)

d_OP_insertField_dot_insert_dot_11 :: C_JValue -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) C_JValue) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) C_JValue)
d_OP_insertField_dot_insert_dot_11 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x2 x1)
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_2 x2 x5 x1 x4 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_insertField_dot_insert_dot_11 x1 x2 l cd cs)
    (d_OP_insertField_dot_insert_dot_11 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_insertField_dot_insert_dot_11 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_insertField_dot_insert_dot_11 x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "JSON.Data.insertField.insert.11" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "JSON.Data.insertField.insert.11" (showCons x3))

d_C__case_24 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) C_JValue) -> C_JObject -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_24 x3 x2 cd cs = case x2 of
  C_JSONObject x4 -> d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 x4 cd cs

d_C__case_22 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 t0) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Curry_Prelude.OP_Tuple2 t1 t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_22 x4 x2 x8 x1 x7 cd cs = case x7 of
  Curry_Prelude.OP_Tuple2 x9 x10 -> let x11 = Data.Curry_List.d_C_partition
                                          (Curry_Prelude.d_OP_dot
                                          (Curry_Prelude.d_C_flip
                                          (Curry_Prelude.d_OP_eq_eq x2 cd cs)
                                          x9) Curry_Prelude.d_C_fst cd cs) x4 cd
                                          cs
                                        x12 = d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18_dot_uscore_hash_selFP2_hash_eqk
                                          x11 cd cs
                                        x13 = d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18_dot_uscore_hash_selFP3_hash_neqk
                                          x11 cd cs
    in d_C__case_21 x13 x8 x2 x1 x10 x12 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_22 x4 x2 x8 x1
    l cd cs) (d_C__case_22 x4 x2 x8 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_22
    x4 x2 x8 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_22 x4
    x2 x8 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "JSON.Data._case_22" [show x4, show x2, show x8, show x1, show x7] info)
  _ -> failCons cd (consFail "JSON.Data._case_22" (showCons x7))

nd_C__case_22 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Curry_Prelude.OP_Tuple2 t1 t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_22 x4 x2 x8 x1 x7 s cd cs = case x7 of
  Curry_Prelude.OP_Tuple2 x9 x10 -> let s6 = s
    in s6 `seq` (let s4 = leftSupply s6
                     s5 = rightSupply s6
    in s4 `seq` (s5 `seq` (let x11 = let s3 = leftSupply s4
                                         s2 = rightSupply s4
                                 in s3 `seq` (s2 `seq`
                                 Data.Curry_List.nd_C_partition
                                 (let s1 = leftSupply s2
                                      s0 = rightSupply s2
                                 in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot
                                 (wrapNX id (Curry_Prelude.nd_C_flip
                                 (Curry_Prelude.nd_OP_eq_eq x2 s0 cd cs) x9))
                                 (wrapDX id Curry_Prelude.d_C_fst) s1 cd cs)) x4
                                 s3 cd cs)
                               x12 = d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18_dot_uscore_hash_selFP2_hash_eqk
                                 x11 cd cs
                               x13 = d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18_dot_uscore_hash_selFP3_hash_neqk
                                 x11 cd cs
    in nd_C__case_21 x13 x8 x2 x1 x10 x12 s5 cd cs)))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_22 x4 x2 x8
    x1 l s cd cs) (nd_C__case_22 x4 x2 x8 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_22
    x4 x2 x8 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_22 x4
    x2 x8 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "JSON.Data._case_22" [show x4, show x2, show x8, show x1, show x7] info)
  _ -> failCons cd (consFail "JSON.Data._case_22" (showCons x7))

d_C__case_21 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> t0
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0) -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_21 x13 x8 x2 x1 x10 x12 cd cs = case x12 of
  Curry_Prelude.OP_Cons x14 x15 -> d_C__case_20 x15 x13 x8 x2 x1 x10 x14 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.C_False
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_21 x13 x8 x2 x1
    x10 l cd cs) (d_C__case_21 x13 x8 x2 x1 x10 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_21 x13
    x8 x2 x1 x10 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_21 x13 x8
    x2 x1 x10 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "JSON.Data._case_21" [show x13, show x8, show x2, show x1, show x10, show
    x12] info)
  _ -> failCons cd (consFail "JSON.Data._case_21" (showCons x12))

nd_C__case_21 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> t0
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_21 x13 x8 x2 x1 x10 x12 s cd cs = case x12 of
  Curry_Prelude.OP_Cons x14 x15 -> let s0 = s
    in s0 `seq` nd_C__case_20 x15 x13 x8 x2 x1 x10 x14 s0 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.C_False
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_21 x13 x8 x2 x1
    x10 l s cd cs) (nd_C__case_21 x13 x8 x2 x1 x10 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_21
    x13 x8 x2 x1 x10 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_21 x13
    x8 x2 x1 x10 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "JSON.Data._case_21" [show x13, show x8, show x2, show x1, show x10, show
    x12] info)
  _ -> failCons cd (consFail "JSON.Data._case_21" (showCons x12))

d_C__case_20 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> t0
  -> Curry_Prelude.OP_Tuple2 t1 t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_20 x15 x13 x8 x2 x1 x10 x14 cd cs = case x14 of
  Curry_Prelude.OP_Tuple2 x16 x17 -> d_C__case_19 x13 x8 x2 x1 x17 x10 x15 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_20 x15 x13 x8
    x2 x1 x10 l cd cs) (d_C__case_20 x15 x13 x8 x2 x1 x10 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_20
    x15 x13 x8 x2 x1 x10 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_20 x15
    x13 x8 x2 x1 x10 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "JSON.Data._case_20" [show x15, show x13, show x8, show x2, show x1, show
    x10, show x14] info)
  _ -> failCons cd (consFail "JSON.Data._case_20" (showCons x14))

nd_C__case_20 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> t0
  -> Curry_Prelude.OP_Tuple2 t1 t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_20 x15 x13 x8 x2 x1 x10 x14 s cd cs = case x14 of
  Curry_Prelude.OP_Tuple2 x16 x17 -> let s0 = s
    in s0 `seq` nd_C__case_19 x13 x8 x2 x1 x17 x10 x15 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_20 x15 x13 x8
    x2 x1 x10 l s cd cs) (nd_C__case_20 x15 x13 x8 x2 x1 x10 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_20
    x15 x13 x8 x2 x1 x10 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_20 x15
    x13 x8 x2 x1 x10 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "JSON.Data._case_20" [show x15, show x13, show x8, show x2, show x1, show
    x10, show x14] info)
  _ -> failCons cd (consFail "JSON.Data._case_20" (showCons x14))

d_C__case_19 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> t0 -> t0
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0) -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_19 x13 x8 x2 x1 x17 x10 x15 cd cs = case x15 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq x1 cd cs) x10 cd cs) x17
    cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18
    x1 x2 x8 x13 cd cs) cd cs
  Curry_Prelude.OP_Cons x18 x19 -> Curry_Prelude.C_False
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_19 x13 x8 x2 x1
    x17 x10 l cd cs) (d_C__case_19 x13 x8 x2 x1 x17 x10 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_19 x13
    x8 x2 x1 x17 x10 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_19 x13 x8
    x2 x1 x17 x10 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "JSON.Data._case_19" [show x13, show x8, show x2, show x1, show x17, show
    x10, show x15] info)
  _ -> failCons cd (consFail "JSON.Data._case_19" (showCons x15))

nd_C__case_19 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> t0 -> t0
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_19 x13 x8 x2 x1 x17 x10 x15 s cd cs = case x15 of
  Curry_Prelude.OP_List -> let s6 = s
    in s6 `seq` (let s4 = leftSupply s6
                     s5 = rightSupply s6
    in s4 `seq` (s5 `seq` Curry_Prelude.d_OP_amp_amp (let s3 = leftSupply s4
                                                          s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq x1
    s0 cd cs) x10 s1 cd cs)) x17 s3 cd cs))
    (nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash_dot_eqJObject_dot_18
    x1 x2 x8 x13 s5 cd cs) cd cs))
  Curry_Prelude.OP_Cons x18 x19 -> Curry_Prelude.C_False
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_19 x13 x8 x2 x1
    x17 x10 l s cd cs) (nd_C__case_19 x13 x8 x2 x1 x17 x10 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_19
    x13 x8 x2 x1 x17 x10 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_19 x13
    x8 x2 x1 x17 x10 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "JSON.Data._case_19" [show x13, show x8, show x2, show x1, show x17, show
    x10, show x15] info)
  _ -> failCons cd (consFail "JSON.Data._case_19" (showCons x15))

d_C__case_23 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0) -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_23 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.C_True
  Curry_Prelude.OP_Cons x5 x6 -> Curry_Prelude.C_False
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_23 l cd cs)
    (d_C__case_23 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_23 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_23 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "JSON.Data._case_23" [show x4] info)
  _ -> failCons cd (consFail "JSON.Data._case_23" (showCons x4))

nd_C__case_12 :: C_JObject -> C_JValue -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_12 x44 x2 s cd cs = case x2 of
  C_JBool x45 -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x46 -> Curry_Prelude.C_False
  C_JInt x47 -> Curry_Prelude.C_False
  C_JNumber x48 -> Curry_Prelude.C_False
  C_JArray x49 -> Curry_Prelude.C_False
  C_JObject x50 -> let s0 = s
    in s0 `seq`
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JObject_hash
    x44 x50 s0 cd cs
  Choice_C_JValue d i l r -> narrow d i (nd_C__case_12 x44 l s cd cs)
    (nd_C__case_12 x44 r s cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> nd_C__case_12 x44 z s cd cs)
    xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> nd_C__case_12 x44 e s cd x) $!
    addCs c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_12" [show x44
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_12" (showCons x2))

nd_C__case_13 :: Curry_Prelude.OP_List C_JValue -> C_JValue -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_13 x37 x2 s cd cs = case x2 of
  C_JBool x38 -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x39 -> Curry_Prelude.C_False
  C_JInt x40 -> Curry_Prelude.C_False
  C_JNumber x41 -> Curry_Prelude.C_False
  C_JArray x42 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash)
    x37 x42 s0 cd cs
  C_JObject x43 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (nd_C__case_13 x37 l s cd cs)
    (nd_C__case_13 x37 r s cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> nd_C__case_13 x37 z s cd cs)
    xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> nd_C__case_13 x37 e s cd x) $!
    addCs c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_13" [show x37
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_13" (showCons x2))

d_C__case_14 :: Curry_Prelude.C_Float -> C_JValue -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_14 x30 x2 cd cs = case x2 of
  C_JBool x31 -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x32 -> Curry_Prelude.C_False
  C_JInt x33 -> Curry_Prelude.C_False
  C_JNumber x34 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Float_hash
    cd cs) x30 cd cs) x34 cd cs
  C_JArray x35 -> Curry_Prelude.C_False
  C_JObject x36 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_14 x30 l cd cs) (d_C__case_14
    x30 r cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_14 x30 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_14 x30 e cd x) $!
    addCs c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_14" [show x30
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_14" (showCons x2))

d_C__case_15 :: Curry_Prelude.C_Int -> C_JValue -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_15 x23 x2 cd cs = case x2 of
  C_JBool x24 -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x25 -> Curry_Prelude.C_False
  C_JInt x26 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs) x23 cd cs) x26 cd cs
  C_JNumber x27 -> Curry_Prelude.C_False
  C_JArray x28 -> Curry_Prelude.C_False
  C_JObject x29 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_15 x23 l cd cs) (d_C__case_15
    x23 r cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_15 x23 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_15 x23 e cd x) $!
    addCs c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_15" [show x23
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_15" (showCons x2))

nd_C__case_16 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_JValue
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_16 x16 x2 s cd cs = case x2 of
  C_JBool x17 -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x18 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x16 x18 s0 cd cs
  C_JInt x19 -> Curry_Prelude.C_False
  C_JNumber x20 -> Curry_Prelude.C_False
  C_JArray x21 -> Curry_Prelude.C_False
  C_JObject x22 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (nd_C__case_16 x16 l s cd cs)
    (nd_C__case_16 x16 r s cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> nd_C__case_16 x16 z s cd cs)
    xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> nd_C__case_16 x16 e s cd x) $!
    addCs c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_16" [show x16
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_16" (showCons x2))

d_C__case_17 :: C_JValue -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_17 x2 cd cs = case x2 of
  C_JBool x10 -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_True
  C_JString x11 -> Curry_Prelude.C_False
  C_JInt x12 -> Curry_Prelude.C_False
  C_JNumber x13 -> Curry_Prelude.C_False
  C_JArray x14 -> Curry_Prelude.C_False
  C_JObject x15 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_17 l cd cs) (d_C__case_17 r
    cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_17 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_17 e cd x) $! addCs c
    cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_17" [show x2]
    info)
  _ -> failCons cd (consFail "JSON.Data._case_17" (showCons x2))

d_C__case_18 :: Curry_Prelude.C_Bool -> C_JValue -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_18 x3 x2 cd cs = case x2 of
  C_JBool x4 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
    x3 x4 cd cs
  C_JNull -> Curry_Prelude.C_False
  C_JString x5 -> Curry_Prelude.C_False
  C_JInt x6 -> Curry_Prelude.C_False
  C_JNumber x7 -> Curry_Prelude.C_False
  C_JArray x8 -> Curry_Prelude.C_False
  C_JObject x9 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_18 x3 l cd cs) (d_C__case_18
    x3 r cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_18 x3 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_18 x3 e cd x) $! addCs
    c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_18" [show x3
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_18" (showCons x2))

nd_C__case_11 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) C_JValue) -> C_JObject
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_11 x3 x2 s cd cs = case x2 of
  C_JSONObject x4 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_JSON_dot_Data_dot_JValue_hash)))
    x3 x4 s0 cd cs

d_C__case_4 :: C_JObject -> C_JValue -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_4 x44 x2 cd cs = case x2 of
  C_JBool x45 -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x46 -> Curry_Prelude.C_False
  C_JInt x47 -> Curry_Prelude.C_False
  C_JNumber x48 -> Curry_Prelude.C_False
  C_JArray x49 -> Curry_Prelude.C_False
  C_JObject x50 -> d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JObject_hash
    x44 x50 cd cs
  Choice_C_JValue d i l r -> narrow d i (d_C__case_4 x44 l cd cs) (d_C__case_4
    x44 r cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_4 x44 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_4 x44 e cd x) $! addCs
    c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_4" [show x44
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_4" (showCons x2))

d_C__case_5 :: Curry_Prelude.OP_List C_JValue -> C_JValue -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_5 x37 x2 cd cs = case x2 of
  C_JBool x38 -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x39 -> Curry_Prelude.C_False
  C_JInt x40 -> Curry_Prelude.C_False
  C_JNumber x41 -> Curry_Prelude.C_False
  C_JArray x42 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_JSON_dot_Data_dot_JValue_hash x37
    x42 cd cs
  C_JObject x43 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_5 x37 l cd cs) (d_C__case_5
    x37 r cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_5 x37 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_5 x37 e cd x) $! addCs
    c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_5" [show x37
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_5" (showCons x2))

d_C__case_6 :: Curry_Prelude.C_Float -> C_JValue -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_6 x30 x2 cd cs = case x2 of
  C_JBool x31 -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x32 -> Curry_Prelude.C_False
  C_JInt x33 -> Curry_Prelude.C_False
  C_JNumber x34 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Float_hash
    x30 x34 cd cs
  C_JArray x35 -> Curry_Prelude.C_False
  C_JObject x36 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_6 x30 l cd cs) (d_C__case_6
    x30 r cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_6 x30 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_6 x30 e cd x) $! addCs
    c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_6" [show x30
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_6" (showCons x2))

d_C__case_7 :: Curry_Prelude.C_Int -> C_JValue -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_7 x23 x2 cd cs = case x2 of
  C_JBool x24 -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x25 -> Curry_Prelude.C_False
  C_JInt x26 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x23 x26 cd cs
  C_JNumber x27 -> Curry_Prelude.C_False
  C_JArray x28 -> Curry_Prelude.C_False
  C_JObject x29 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_7 x23 l cd cs) (d_C__case_7
    x23 r cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_7 x23 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_7 x23 e cd x) $! addCs
    c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_7" [show x23
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_7" (showCons x2))

d_C__case_8 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_JValue -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_8 x16 x2 cd cs = case x2 of
  C_JBool x17 -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_False
  C_JString x18 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x16 x18 cd cs
  C_JInt x19 -> Curry_Prelude.C_False
  C_JNumber x20 -> Curry_Prelude.C_False
  C_JArray x21 -> Curry_Prelude.C_False
  C_JObject x22 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_8 x16 l cd cs) (d_C__case_8
    x16 r cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_8 x16 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_8 x16 e cd x) $! addCs
    c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_8" [show x16
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_8" (showCons x2))

d_C__case_9 :: C_JValue -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_9 x2 cd cs = case x2 of
  C_JBool x10 -> Curry_Prelude.C_False
  C_JNull -> Curry_Prelude.C_True
  C_JString x11 -> Curry_Prelude.C_False
  C_JInt x12 -> Curry_Prelude.C_False
  C_JNumber x13 -> Curry_Prelude.C_False
  C_JArray x14 -> Curry_Prelude.C_False
  C_JObject x15 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_9 l cd cs) (d_C__case_9 r cd
    cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_9 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_9 e cd x) $! addCs c
    cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_9" [show x2]
    info)
  _ -> failCons cd (consFail "JSON.Data._case_9" (showCons x2))

d_C__case_10 :: Curry_Prelude.C_Bool -> C_JValue -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_10 x3 x2 cd cs = case x2 of
  C_JBool x4 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Bool_hash
    x3 x4 cd cs
  C_JNull -> Curry_Prelude.C_False
  C_JString x5 -> Curry_Prelude.C_False
  C_JInt x6 -> Curry_Prelude.C_False
  C_JNumber x7 -> Curry_Prelude.C_False
  C_JArray x8 -> Curry_Prelude.C_False
  C_JObject x9 -> Curry_Prelude.C_False
  Choice_C_JValue d i l r -> narrow d i (d_C__case_10 x3 l cd cs) (d_C__case_10
    x3 r cd cs)
  Choices_C_JValue d i xs -> narrows cs d i (\z -> d_C__case_10 x3 z cd cs) xs
  Guard_C_JValue d c e -> guardCons d c ((\x -> d_C__case_10 x3 e cd x) $! addCs
    c cs)
  Fail_C_JValue d info -> failCons d (traceFail "JSON.Data._case_10" [show x3
    , show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_10" (showCons x2))

d_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  C_JValue -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_3 x3 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 x5 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_3 x3 l cd cs)
    (d_C__case_3 x3 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_3 x3
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_3 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "JSON.Data._case_3" [show x3, show x2] info)
  _ -> failCons cd (consFail "JSON.Data._case_3" (showCons x2))

d_C__case_2 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) C_JValue) -> C_JValue -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) C_JValue -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) C_JValue)
d_C__case_2 x2 x5 x1 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> d_C__case_1 x2 x6 x5 x1 x7
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x6 x2 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_2 x2 x5 x1 l
    cd cs) (d_C__case_2 x2 x5 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_2 x2
    x5 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_2 x2 x5
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "JSON.Data._case_2" [show x2, show x5, show x1, show x4] info)
  _ -> failCons cd (consFail "JSON.Data._case_2" (showCons x4))

d_C__case_1 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  C_JValue) -> C_JValue -> C_JValue -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) C_JValue)
d_C__case_1 x2 x6 x5 x1 x7 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x2 x1)
    x5
  Curry_Prelude.C_False -> d_C__case_0 x5 x2 x1 x7 x6
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x2 x6 x5 x1 x7
    l cd cs) (d_C__case_1 x2 x6 x5 x1 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x2 x6
    x5 x1 x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x2 x6 x5
    x1 x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "JSON.Data._case_1"
    [show x2, show x6, show x5, show x1, show x7, show x8] info)
  _ -> failCons cd (consFail "JSON.Data._case_1" (showCons x8))

d_C__case_0 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) C_JValue)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_JValue -> C_JValue
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) C_JValue)
d_C__case_0 x5 x2 x1 x7 x6 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x6 x7)
    (d_OP_insertField_dot_insert_dot_11 x1 x2 x5 cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x5 x2 x1 x7 x6
    l cd cs) (d_C__case_0 x5 x2 x1 x7 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x5 x2
    x1 x7 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x5 x2 x1
    x7 x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "JSON.Data._case_0"
    [show x5, show x2, show x1, show x7, show x6, show x8] info)
  _ -> failCons cd (consFail "JSON.Data._case_0" (showCons x8))

