{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Language.Julia.Curry_Types
  ( C_JLType (..)
  , C_JLExp (..)
  , C_JLStm (..)
  , C_JLTop (..)
  , C_JLModule (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLModule_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLModule_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLModule_hash )
  where

import Basics
import qualified Curry_Prelude


data C_JLType
  = C_JLBoolType
  | C_JLInt32
  | C_JLInt64
  | C_JLFloat64
  | C_JLStringType
  | C_JLStruct (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_JLArray (Curry_Prelude.OP_List C_JLType)
  | Choice_C_JLType Cover ID C_JLType C_JLType
  | Choices_C_JLType Cover ID [C_JLType]
  | Fail_C_JLType Cover FailInfo
  | Guard_C_JLType Cover Constraints C_JLType

instance Show C_JLType where
  showsPrec d (Choice_C_JLType cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_JLType cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_JLType cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_JLType cd info) = showChar '!'
  showsPrec _ C_JLBoolType = showString "JLBoolType"
  showsPrec _ C_JLInt32 = showString "JLInt32"
  showsPrec _ C_JLInt64 = showString "JLInt64"
  showsPrec _ C_JLFloat64 = showString "JLFloat64"
  showsPrec _ C_JLStringType = showString "JLStringType"
  showsPrec _ (C_JLStruct x1) = showString "(JLStruct" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_JLArray x1) = showString "(JLArray" . (showChar ' ' . (shows
    x1 . showChar ')'))

instance Read C_JLType where
  readsPrec d s = readParen False (\r -> [(C_JLBoolType, r0) | (_, r0) <-
    readQualified "Language.Julia.Types" "JLBoolType" r]) s ++ (readParen False
    (\r -> [(C_JLInt32, r0) | (_, r0) <- readQualified "Language.Julia.Types"
    "JLInt32" r]) s ++ (readParen False (\r -> [(C_JLInt64, r0) | (_, r0) <-
    readQualified "Language.Julia.Types" "JLInt64" r]) s ++ (readParen False
    (\r -> [(C_JLFloat64, r0) | (_, r0) <- readQualified "Language.Julia.Types"
    "JLFloat64" r]) s ++ (readParen False (\r -> [(C_JLStringType, r0) | (_, r0)
    <- readQualified "Language.Julia.Types" "JLStringType" r]) s ++ (readParen
    ((>) d 10) (\r -> [(C_JLStruct x1, r1) | (_, r0) <- readQualified
    "Language.Julia.Types" "JLStruct" r, (x1, r1) <- readsPrec 11 r0]) s ++
    readParen ((>) d 10) (\r -> [(C_JLArray x1, r1) | (_, r0) <- readQualified
    "Language.Julia.Types" "JLArray" r, (x1, r1) <- readsPrec 11 r0]) s)))))

instance NonDet C_JLType where
  choiceCons = Choice_C_JLType
  choicesCons = Choices_C_JLType
  failCons = Fail_C_JLType
  guardCons = Guard_C_JLType
  try (Choice_C_JLType cd i x y) = tryChoice cd i x y
  try (Choices_C_JLType cd i xs) = tryChoices cd i xs
  try (Fail_C_JLType cd info) = Fail cd info
  try (Guard_C_JLType cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_JLType cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_JLType cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_JLType cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_JLType cd i _) = error
    ("Language.Julia.Types.JLType.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_JLType cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_JLType cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_JLType where
  generate s c = Choices_C_JLType c (freeID [0, 0, 0, 0, 0, 1, 1] s)
    [C_JLBoolType, C_JLInt32, C_JLInt64, C_JLFloat64, C_JLStringType, C_JLStruct
    (generate (leftSupply s) c), C_JLArray (generate (leftSupply s) c)]

instance NormalForm C_JLType where
  ($!!) cont C_JLBoolType d cs = cont C_JLBoolType d cs
  ($!!) cont C_JLInt32 d cs = cont C_JLInt32 d cs
  ($!!) cont C_JLInt64 d cs = cont C_JLInt64 d cs
  ($!!) cont C_JLFloat64 d cs = cont C_JLFloat64 d cs
  ($!!) cont C_JLStringType d cs = cont C_JLStringType d cs
  ($!!) cont (C_JLStruct x1) d cs = ($!!) (\y1 d cs -> cont (C_JLStruct y1) d
    cs) x1 d cs
  ($!!) cont (C_JLArray x1) d cs = ($!!) (\y1 d cs -> cont (C_JLArray y1) d cs)
    x1 d cs
  ($!!) cont (Choice_C_JLType cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_JLType cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_JLType cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_JLType cd info) _ _ = failCons cd info
  ($##) cont C_JLBoolType d cs = cont C_JLBoolType d cs
  ($##) cont C_JLInt32 d cs = cont C_JLInt32 d cs
  ($##) cont C_JLInt64 d cs = cont C_JLInt64 d cs
  ($##) cont C_JLFloat64 d cs = cont C_JLFloat64 d cs
  ($##) cont C_JLStringType d cs = cont C_JLStringType d cs
  ($##) cont (C_JLStruct x1) d cs = ($##) (\y1 d cs -> cont (C_JLStruct y1) d
    cs) x1 d cs
  ($##) cont (C_JLArray x1) d cs = ($##) (\y1 d cs -> cont (C_JLArray y1) d cs)
    x1 d cs
  ($##) cont (Choice_C_JLType cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_JLType cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_JLType cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_JLType cd info) _ _ = failCons cd info
  showCons C_JLBoolType = "Language.Julia.Types.JLBoolType"
  showCons C_JLInt32 = "Language.Julia.Types.JLInt32"
  showCons C_JLInt64 = "Language.Julia.Types.JLInt64"
  showCons C_JLFloat64 = "Language.Julia.Types.JLFloat64"
  showCons C_JLStringType = "Language.Julia.Types.JLStringType"
  showCons (C_JLStruct _) = "Language.Julia.Types.JLStruct _"
  showCons (C_JLArray _) = "Language.Julia.Types.JLArray _"
  showCons x = error
    ("Language.Julia.Types.JLType.showCons: no constructor: " ++ show x)
  searchNF _ cont C_JLBoolType = cont C_JLBoolType
  searchNF _ cont C_JLInt32 = cont C_JLInt32
  searchNF _ cont C_JLInt64 = cont C_JLInt64
  searchNF _ cont C_JLFloat64 = cont C_JLFloat64
  searchNF _ cont C_JLStringType = cont C_JLStringType
  searchNF search cont (C_JLStruct x1) = search (\y1 -> cont (C_JLStruct y1)) x1
  searchNF search cont (C_JLArray x1) = search (\y1 -> cont (C_JLArray y1)) x1
  searchNF _ _ x = error
    ("Language.Julia.Types.JLType.searchNF: no constructor: " ++ show x)

instance Unifiable C_JLType where
  (=.=) C_JLBoolType C_JLBoolType d cs = C_True
  (=.=) C_JLInt32 C_JLInt32 d cs = C_True
  (=.=) C_JLInt64 C_JLInt64 d cs = C_True
  (=.=) C_JLFloat64 C_JLFloat64 d cs = C_True
  (=.=) C_JLStringType C_JLStringType d cs = C_True
  (=.=) (C_JLStruct x1) (C_JLStruct y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JLArray x1) (C_JLArray y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_JLBoolType C_JLBoolType d cs = C_True
  (=.<=) C_JLInt32 C_JLInt32 d cs = C_True
  (=.<=) C_JLInt64 C_JLInt64 d cs = C_True
  (=.<=) C_JLFloat64 C_JLFloat64 d cs = C_True
  (=.<=) C_JLStringType C_JLStringType d cs = C_True
  (=.<=) (C_JLStruct x1) (C_JLStruct y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JLArray x1) (C_JLArray y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_JLBoolType = (i :=: ChooseN 0 0) : concat []
  bind cd i C_JLInt32 = (i :=: ChooseN 1 0) : concat []
  bind cd i C_JLInt64 = (i :=: ChooseN 2 0) : concat []
  bind cd i C_JLFloat64 = (i :=: ChooseN 3 0) : concat []
  bind cd i C_JLStringType = (i :=: ChooseN 4 0) : concat []
  bind cd i (C_JLStruct x3) = (i :=: ChooseN 5 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_JLArray x3) = (i :=: ChooseN 6 1) : concat [bind cd (leftID i)
    x3]
  bind d i (Choice_C_JLType cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_JLType cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_JLType cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_JLType cd i _) = error
    ("Language.Julia.Types.JLType.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_JLType cd info) = [Unsolvable info]
  bind d i (Guard_C_JLType cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_JLBoolType = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_JLInt32 = (i :=: ChooseN 1 0) : []
  lazyBind cd i C_JLInt64 = (i :=: ChooseN 2 0) : []
  lazyBind cd i C_JLFloat64 = (i :=: ChooseN 3 0) : []
  lazyBind cd i C_JLStringType = (i :=: ChooseN 4 0) : []
  lazyBind cd i (C_JLStruct x3) = (i :=: ChooseN 5 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JLArray x3) = (i :=: ChooseN 6 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_JLType cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_JLType cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_JLType cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_JLType cd i _) = error
    ("Language.Julia.Types.JLType.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_JLType cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_JLType cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_JLType where

data C_JLExp
  = C_JLBool Curry_Prelude.C_Bool
  | C_JLInt Curry_Prelude.C_Int
  | C_JLFloat Curry_Prelude.C_Float
  | C_JLString (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_JLIVar Curry_Prelude.C_Int
  | C_JLSVar (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_JLArrayAcc C_JLExp C_JLExp
  | C_JLArrayInit (Curry_Prelude.OP_List C_JLExp)
  | C_JLStructAcc C_JLExp (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_JLOp (Curry_Prelude.OP_List Curry_Prelude.C_Char) C_JLExp C_JLExp
  | C_JLFCall (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List C_JLExp)
  | Choice_C_JLExp Cover ID C_JLExp C_JLExp
  | Choices_C_JLExp Cover ID [C_JLExp]
  | Fail_C_JLExp Cover FailInfo
  | Guard_C_JLExp Cover Constraints C_JLExp

instance Show C_JLExp where
  showsPrec d (Choice_C_JLExp cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_JLExp cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_JLExp cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_JLExp cd info) = showChar '!'
  showsPrec _ (C_JLBool x1) = showString "(JLBool" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_JLInt x1) = showString "(JLInt" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_JLFloat x1) = showString "(JLFloat" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_JLString x1) = showString "(JLString" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_JLIVar x1) = showString "(JLIVar" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_JLSVar x1) = showString "(JLSVar" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_JLArrayAcc x1 x2) = showString "(JLArrayAcc" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_JLArrayInit x1) = showString "(JLArrayInit" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (C_JLStructAcc x1 x2) = showString "(JLStructAcc" . (showChar
    ' ' . (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_JLOp x1 x2 x3) = showString "(JLOp" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . showChar
    ')'))))))
  showsPrec _ (C_JLFCall x1 x2) = showString "(JLFCall" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))

instance Read C_JLExp where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_JLBool x1, r1) | (_, r0) <-
    readQualified "Language.Julia.Types" "JLBool" r, (x1, r1) <- readsPrec 11
    r0]) s ++ (readParen ((>) d 10) (\r -> [(C_JLInt x1, r1) | (_, r0) <-
    readQualified "Language.Julia.Types" "JLInt" r, (x1, r1) <- readsPrec 11
    r0]) s ++ (readParen ((>) d 10) (\r -> [(C_JLFloat x1, r1) | (_, r0) <-
    readQualified "Language.Julia.Types" "JLFloat" r, (x1, r1) <- readsPrec 11
    r0]) s ++ (readParen ((>) d 10) (\r -> [(C_JLString x1, r1) | (_, r0) <-
    readQualified "Language.Julia.Types" "JLString" r, (x1, r1) <- readsPrec 11
    r0]) s ++ (readParen ((>) d 10) (\r -> [(C_JLIVar x1, r1) | (_, r0) <-
    readQualified "Language.Julia.Types" "JLIVar" r, (x1, r1) <- readsPrec 11
    r0]) s ++ (readParen ((>) d 10) (\r -> [(C_JLSVar x1, r1) | (_, r0) <-
    readQualified "Language.Julia.Types" "JLSVar" r, (x1, r1) <- readsPrec 11
    r0]) s ++ (readParen ((>) d 10) (\r -> [(C_JLArrayAcc x1 x2, r2) | (_, r0)
    <- readQualified "Language.Julia.Types" "JLArrayAcc" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ (readParen ((>) d 10)
    (\r -> [(C_JLArrayInit x1, r1) | (_, r0) <- readQualified
    "Language.Julia.Types" "JLArrayInit" r, (x1, r1) <- readsPrec 11 r0]) s ++
    (readParen ((>) d 10) (\r -> [(C_JLStructAcc x1 x2, r2) | (_, r0) <-
    readQualified "Language.Julia.Types" "JLStructAcc" r, (x1, r1) <- readsPrec
    11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ (readParen ((>) d 10) (\r ->
    [(C_JLOp x1 x2 x3, r3) | (_, r0) <- readQualified "Language.Julia.Types"
    "JLOp" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3)
    <- readsPrec 11 r2]) s ++ readParen ((>) d 10) (\r -> [(C_JLFCall x1 x2
    , r2) | (_, r0) <- readQualified "Language.Julia.Types" "JLFCall" r, (x1
    , r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1]) s)))))))))

instance NonDet C_JLExp where
  choiceCons = Choice_C_JLExp
  choicesCons = Choices_C_JLExp
  failCons = Fail_C_JLExp
  guardCons = Guard_C_JLExp
  try (Choice_C_JLExp cd i x y) = tryChoice cd i x y
  try (Choices_C_JLExp cd i xs) = tryChoices cd i xs
  try (Fail_C_JLExp cd info) = Fail cd info
  try (Guard_C_JLExp cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_JLExp cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_JLExp cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_JLExp cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_JLExp cd i _) = error
    ("Language.Julia.Types.JLExp.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_JLExp cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_JLExp cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_JLExp where
  generate s c = Choices_C_JLExp c (freeID [1, 1, 1, 1, 1, 1, 2, 1, 2, 3, 2] s)
    [C_JLBool (generate (leftSupply s) c), C_JLInt (generate (leftSupply s) c)
    , C_JLFloat (generate (leftSupply s) c), C_JLString (generate (leftSupply s)
    c), C_JLIVar (generate (leftSupply s) c), C_JLSVar (generate (leftSupply s)
    c), C_JLArrayAcc (generate (leftSupply s) c) (generate (rightSupply s) c)
    , C_JLArrayInit (generate (leftSupply s) c), C_JLStructAcc (generate
    (leftSupply s) c) (generate (rightSupply s) c), C_JLOp (generate (leftSupply
    (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c) (generate
    (rightSupply s) c), C_JLFCall (generate (leftSupply s) c) (generate
    (rightSupply s) c)]

instance NormalForm C_JLExp where
  ($!!) cont (C_JLBool x1) d cs = ($!!) (\y1 d cs -> cont (C_JLBool y1) d cs) x1
    d cs
  ($!!) cont (C_JLInt x1) d cs = ($!!) (\y1 d cs -> cont (C_JLInt y1) d cs) x1 d
    cs
  ($!!) cont (C_JLFloat x1) d cs = ($!!) (\y1 d cs -> cont (C_JLFloat y1) d cs)
    x1 d cs
  ($!!) cont (C_JLString x1) d cs = ($!!) (\y1 d cs -> cont (C_JLString y1) d
    cs) x1 d cs
  ($!!) cont (C_JLIVar x1) d cs = ($!!) (\y1 d cs -> cont (C_JLIVar y1) d cs) x1
    d cs
  ($!!) cont (C_JLSVar x1) d cs = ($!!) (\y1 d cs -> cont (C_JLSVar y1) d cs) x1
    d cs
  ($!!) cont (C_JLArrayAcc x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_JLArrayAcc y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_JLArrayInit x1) d cs = ($!!) (\y1 d cs -> cont (C_JLArrayInit
    y1) d cs) x1 d cs
  ($!!) cont (C_JLStructAcc x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_JLStructAcc y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_JLOp x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> cont (C_JLOp y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (C_JLFCall x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_JLFCall y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_JLExp cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_JLExp cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_JLExp cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_JLExp cd info) _ _ = failCons cd info
  ($##) cont (C_JLBool x1) d cs = ($##) (\y1 d cs -> cont (C_JLBool y1) d cs) x1
    d cs
  ($##) cont (C_JLInt x1) d cs = ($##) (\y1 d cs -> cont (C_JLInt y1) d cs) x1 d
    cs
  ($##) cont (C_JLFloat x1) d cs = ($##) (\y1 d cs -> cont (C_JLFloat y1) d cs)
    x1 d cs
  ($##) cont (C_JLString x1) d cs = ($##) (\y1 d cs -> cont (C_JLString y1) d
    cs) x1 d cs
  ($##) cont (C_JLIVar x1) d cs = ($##) (\y1 d cs -> cont (C_JLIVar y1) d cs) x1
    d cs
  ($##) cont (C_JLSVar x1) d cs = ($##) (\y1 d cs -> cont (C_JLSVar y1) d cs) x1
    d cs
  ($##) cont (C_JLArrayAcc x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_JLArrayAcc y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_JLArrayInit x1) d cs = ($##) (\y1 d cs -> cont (C_JLArrayInit
    y1) d cs) x1 d cs
  ($##) cont (C_JLStructAcc x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_JLStructAcc y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_JLOp x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> cont (C_JLOp y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (C_JLFCall x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_JLFCall y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_JLExp cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_JLExp cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_JLExp cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_JLExp cd info) _ _ = failCons cd info
  showCons (C_JLBool _) = "Language.Julia.Types.JLBool _"
  showCons (C_JLInt _) = "Language.Julia.Types.JLInt _"
  showCons (C_JLFloat _) = "Language.Julia.Types.JLFloat _"
  showCons (C_JLString _) = "Language.Julia.Types.JLString _"
  showCons (C_JLIVar _) = "Language.Julia.Types.JLIVar _"
  showCons (C_JLSVar _) = "Language.Julia.Types.JLSVar _"
  showCons (C_JLArrayAcc _ _) = "Language.Julia.Types.JLArrayAcc _ _"
  showCons (C_JLArrayInit _) = "Language.Julia.Types.JLArrayInit _"
  showCons (C_JLStructAcc _ _) = "Language.Julia.Types.JLStructAcc _ _"
  showCons (C_JLOp _ _ _) = "Language.Julia.Types.JLOp _ _ _"
  showCons (C_JLFCall _ _) = "Language.Julia.Types.JLFCall _ _"
  showCons x = error ("Language.Julia.Types.JLExp.showCons: no constructor: " ++
    show x)
  searchNF search cont (C_JLBool x1) = search (\y1 -> cont (C_JLBool y1)) x1
  searchNF search cont (C_JLInt x1) = search (\y1 -> cont (C_JLInt y1)) x1
  searchNF search cont (C_JLFloat x1) = search (\y1 -> cont (C_JLFloat y1)) x1
  searchNF search cont (C_JLString x1) = search (\y1 -> cont (C_JLString y1)) x1
  searchNF search cont (C_JLIVar x1) = search (\y1 -> cont (C_JLIVar y1)) x1
  searchNF search cont (C_JLSVar x1) = search (\y1 -> cont (C_JLSVar y1)) x1
  searchNF search cont (C_JLArrayAcc x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_JLArrayAcc y1 y2)) x2) x1
  searchNF search cont (C_JLArrayInit x1) = search (\y1 -> cont (C_JLArrayInit
    y1)) x1
  searchNF search cont (C_JLStructAcc x1 x2) = search (\y1 -> search (\y2 ->
    cont (C_JLStructAcc y1 y2)) x2) x1
  searchNF search cont (C_JLOp x1 x2 x3) = search (\y1 -> search (\y2 -> search
    (\y3 -> cont (C_JLOp y1 y2 y3)) x3) x2) x1
  searchNF search cont (C_JLFCall x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_JLFCall y1 y2)) x2) x1
  searchNF _ _ x = error
    ("Language.Julia.Types.JLExp.searchNF: no constructor: " ++ show x)

instance Unifiable C_JLExp where
  (=.=) (C_JLBool x1) (C_JLBool y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JLInt x1) (C_JLInt y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JLFloat x1) (C_JLFloat y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JLString x1) (C_JLString y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JLIVar x1) (C_JLIVar y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JLSVar x1) (C_JLSVar y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JLArrayAcc x1 x2) (C_JLArrayAcc y1 y2) d cs = (&) ((=:=) x1 y1 d cs)
    ((=:=) x2 y2 d cs) d cs
  (=.=) (C_JLArrayInit x1) (C_JLArrayInit y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JLStructAcc x1 x2) (C_JLStructAcc y1 y2) d cs = (&) ((=:=) x1 y1 d
    cs) ((=:=) x2 y2 d cs) d cs
  (=.=) (C_JLOp x1 x2 x3) (C_JLOp y1 y2 y3) d cs = (&) ((=:=) x1 y1 d cs) ((&)
    ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) (C_JLFCall x1 x2) (C_JLFCall y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=)
    x2 y2 d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_JLBool x1) (C_JLBool y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JLInt x1) (C_JLInt y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JLFloat x1) (C_JLFloat y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JLString x1) (C_JLString y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JLIVar x1) (C_JLIVar y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JLSVar x1) (C_JLSVar y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JLArrayAcc x1 x2) (C_JLArrayAcc y1 y2) d cs = (&) ((=:<=) x1 y1 d
    cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_JLArrayInit x1) (C_JLArrayInit y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JLStructAcc x1 x2) (C_JLStructAcc y1 y2) d cs = (&) ((=:<=) x1 y1 d
    cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_JLOp x1 x2 x3) (C_JLOp y1 y2 y3) d cs = (&) ((=:<=) x1 y1 d cs) ((&)
    ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d cs
  (=.<=) (C_JLFCall x1 x2) (C_JLFCall y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_JLBool x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_JLInt x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_JLFloat x3) = (i :=: ChooseN 2 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_JLString x3) = (i :=: ChooseN 3 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_JLIVar x3) = (i :=: ChooseN 4 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_JLSVar x3) = (i :=: ChooseN 5 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_JLArrayAcc x3 x4) = (i :=: ChooseN 6 2) : concat [bind cd (leftID
    i) x3, bind cd (rightID i) x4]
  bind cd i (C_JLArrayInit x3) = (i :=: ChooseN 7 1) : concat [bind cd (leftID
    i) x3]
  bind cd i (C_JLStructAcc x3 x4) = (i :=: ChooseN 8 2) : concat [bind cd
    (leftID i) x3, bind cd (rightID i) x4]
  bind cd i (C_JLOp x3 x4 x5) = (i :=: ChooseN 9 3) : concat [bind cd (leftID
    (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (rightID i) x5]
  bind cd i (C_JLFCall x3 x4) = (i :=: ChooseN 10 2) : concat [bind cd (leftID
    i) x3, bind cd (rightID i) x4]
  bind d i (Choice_C_JLExp cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_JLExp cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_JLExp cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_JLExp cd i _) = error
    ("Language.Julia.Types.JLExp.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_JLExp cd info) = [Unsolvable info]
  bind d i (Guard_C_JLExp cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_JLBool x3) = (i :=: ChooseN 0 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JLInt x3) = (i :=: ChooseN 1 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JLFloat x3) = (i :=: ChooseN 2 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JLString x3) = (i :=: ChooseN 3 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JLIVar x3) = (i :=: ChooseN 4 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JLSVar x3) = (i :=: ChooseN 5 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JLArrayAcc x3 x4) = (i :=: ChooseN 6 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind cd i (C_JLArrayInit x3) = (i :=: ChooseN 7 1) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JLStructAcc x3 x4) = (i :=: ChooseN 8 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind cd i (C_JLOp x3 x4 x5) = (i :=: ChooseN 9 3) : [leftID (leftID i) :=:
    LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x5)]
  lazyBind cd i (C_JLFCall x3 x4) = (i :=: ChooseN 10 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind d i (Choice_C_JLExp cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_JLExp cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_JLExp cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_JLExp cd i _) = error
    ("Language.Julia.Types.JLExp.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_JLExp cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_JLExp cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_JLExp where

data C_JLStm
  = C_JLAssign C_JLExp C_JLExp
  | C_JLIf C_JLExp (Curry_Prelude.OP_List C_JLStm) (Curry_Prelude.OP_List
    C_JLStm)
  | C_JLWhile C_JLExp (Curry_Prelude.OP_List C_JLStm)
  | C_JLFor Curry_Prelude.C_Int C_JLExp C_JLExp (Curry_Prelude.OP_List C_JLStm)
  | C_JLPCall (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List C_JLExp)
  | C_JLReturn C_JLExp
  | Choice_C_JLStm Cover ID C_JLStm C_JLStm
  | Choices_C_JLStm Cover ID [C_JLStm]
  | Fail_C_JLStm Cover FailInfo
  | Guard_C_JLStm Cover Constraints C_JLStm

instance Show C_JLStm where
  showsPrec d (Choice_C_JLStm cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_JLStm cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_JLStm cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_JLStm cd info) = showChar '!'
  showsPrec _ (C_JLAssign x1 x2) = showString "(JLAssign" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_JLIf x1 x2 x3) = showString "(JLIf" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . showChar
    ')'))))))
  showsPrec _ (C_JLWhile x1 x2) = showString "(JLWhile" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_JLFor x1 x2 x3 x4) = showString "(JLFor" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 .
    (showChar ' ' . (shows x4 . showChar ')'))))))))
  showsPrec _ (C_JLPCall x1 x2) = showString "(JLPCall" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_JLReturn x1) = showString "(JLReturn" . (showChar ' ' . (shows
    x1 . showChar ')'))

instance Read C_JLStm where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_JLAssign x1 x2, r2) | (_, r0)
    <- readQualified "Language.Julia.Types" "JLAssign" r, (x1, r1) <- readsPrec
    11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ (readParen ((>) d 10) (\r ->
    [(C_JLIf x1 x2 x3, r3) | (_, r0) <- readQualified "Language.Julia.Types"
    "JLIf" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3)
    <- readsPrec 11 r2]) s ++ (readParen ((>) d 10) (\r -> [(C_JLWhile x1 x2
    , r2) | (_, r0) <- readQualified "Language.Julia.Types" "JLWhile" r, (x1
    , r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ (readParen ((>)
    d 10) (\r -> [(C_JLFor x1 x2 x3 x4, r4) | (_, r0) <- readQualified
    "Language.Julia.Types" "JLFor" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <-
    readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2, (x4, r4) <- readsPrec 11 r3])
    s ++ (readParen ((>) d 10) (\r -> [(C_JLPCall x1 x2, r2) | (_, r0) <-
    readQualified "Language.Julia.Types" "JLPCall" r, (x1, r1) <- readsPrec 11
    r0, (x2, r2) <- readsPrec 11 r1]) s ++ readParen ((>) d 10) (\r ->
    [(C_JLReturn x1, r1) | (_, r0) <- readQualified "Language.Julia.Types"
    "JLReturn" r, (x1, r1) <- readsPrec 11 r0]) s))))

instance NonDet C_JLStm where
  choiceCons = Choice_C_JLStm
  choicesCons = Choices_C_JLStm
  failCons = Fail_C_JLStm
  guardCons = Guard_C_JLStm
  try (Choice_C_JLStm cd i x y) = tryChoice cd i x y
  try (Choices_C_JLStm cd i xs) = tryChoices cd i xs
  try (Fail_C_JLStm cd info) = Fail cd info
  try (Guard_C_JLStm cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_JLStm cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_JLStm cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_JLStm cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_JLStm cd i _) = error
    ("Language.Julia.Types.JLStm.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_JLStm cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_JLStm cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_JLStm where
  generate s c = Choices_C_JLStm c (freeID [2, 3, 2, 4, 2, 1] s) [C_JLAssign
    (generate (leftSupply s) c) (generate (rightSupply s) c), C_JLIf (generate
    (leftSupply (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c)
    (generate (rightSupply s) c), C_JLWhile (generate (leftSupply s) c)
    (generate (rightSupply s) c), C_JLFor (generate (leftSupply (leftSupply s))
    c) (generate (rightSupply (leftSupply s)) c) (generate (leftSupply
    (rightSupply s)) c) (generate (rightSupply (rightSupply s)) c), C_JLPCall
    (generate (leftSupply s) c) (generate (rightSupply s) c), C_JLReturn
    (generate (leftSupply s) c)]

instance NormalForm C_JLStm where
  ($!!) cont (C_JLAssign x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_JLAssign y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_JLIf x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> cont (C_JLIf y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (C_JLWhile x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_JLWhile y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_JLFor x1 x2 x3 x4) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> cont (C_JLFor y1 y2 y3 y4) d cs) x4 d
    cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (C_JLPCall x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_JLPCall y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_JLReturn x1) d cs = ($!!) (\y1 d cs -> cont (C_JLReturn y1) d
    cs) x1 d cs
  ($!!) cont (Choice_C_JLStm cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_JLStm cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_JLStm cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_JLStm cd info) _ _ = failCons cd info
  ($##) cont (C_JLAssign x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_JLAssign y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_JLIf x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> cont (C_JLIf y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (C_JLWhile x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_JLWhile y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_JLFor x1 x2 x3 x4) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> ($##) (\y4 d cs -> cont (C_JLFor y1 y2 y3 y4) d cs) x4 d
    cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (C_JLPCall x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_JLPCall y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_JLReturn x1) d cs = ($##) (\y1 d cs -> cont (C_JLReturn y1) d
    cs) x1 d cs
  ($##) cont (Choice_C_JLStm cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_JLStm cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_JLStm cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_JLStm cd info) _ _ = failCons cd info
  showCons (C_JLAssign _ _) = "Language.Julia.Types.JLAssign _ _"
  showCons (C_JLIf _ _ _) = "Language.Julia.Types.JLIf _ _ _"
  showCons (C_JLWhile _ _) = "Language.Julia.Types.JLWhile _ _"
  showCons (C_JLFor _ _ _ _) = "Language.Julia.Types.JLFor _ _ _ _"
  showCons (C_JLPCall _ _) = "Language.Julia.Types.JLPCall _ _"
  showCons (C_JLReturn _) = "Language.Julia.Types.JLReturn _"
  showCons x = error ("Language.Julia.Types.JLStm.showCons: no constructor: " ++
    show x)
  searchNF search cont (C_JLAssign x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_JLAssign y1 y2)) x2) x1
  searchNF search cont (C_JLIf x1 x2 x3) = search (\y1 -> search (\y2 -> search
    (\y3 -> cont (C_JLIf y1 y2 y3)) x3) x2) x1
  searchNF search cont (C_JLWhile x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_JLWhile y1 y2)) x2) x1
  searchNF search cont (C_JLFor x1 x2 x3 x4) = search (\y1 -> search (\y2 ->
    search (\y3 -> search (\y4 -> cont (C_JLFor y1 y2 y3 y4)) x4) x3) x2) x1
  searchNF search cont (C_JLPCall x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_JLPCall y1 y2)) x2) x1
  searchNF search cont (C_JLReturn x1) = search (\y1 -> cont (C_JLReturn y1)) x1
  searchNF _ _ x = error
    ("Language.Julia.Types.JLStm.searchNF: no constructor: " ++ show x)

instance Unifiable C_JLStm where
  (=.=) (C_JLAssign x1 x2) (C_JLAssign y1 y2) d cs = (&) ((=:=) x1 y1 d cs)
    ((=:=) x2 y2 d cs) d cs
  (=.=) (C_JLIf x1 x2 x3) (C_JLIf y1 y2 y3) d cs = (&) ((=:=) x1 y1 d cs) ((&)
    ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) (C_JLWhile x1 x2) (C_JLWhile y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=)
    x2 y2 d cs) d cs
  (=.=) (C_JLFor x1 x2 x3 x4) (C_JLFor y1 y2 y3 y4) d cs = (&) ((=:=) x1 y1 d
    cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((=:=) x4 y4 d cs) d cs)
    d cs) d cs
  (=.=) (C_JLPCall x1 x2) (C_JLPCall y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=)
    x2 y2 d cs) d cs
  (=.=) (C_JLReturn x1) (C_JLReturn y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_JLAssign x1 x2) (C_JLAssign y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_JLIf x1 x2 x3) (C_JLIf y1 y2 y3) d cs = (&) ((=:<=) x1 y1 d cs) ((&)
    ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d cs
  (=.<=) (C_JLWhile x1 x2) (C_JLWhile y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_JLFor x1 x2 x3 x4) (C_JLFor y1 y2 y3 y4) d cs = (&) ((=:<=) x1 y1 d
    cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs) ((=:<=) x4 y4 d cs) d
    cs) d cs) d cs
  (=.<=) (C_JLPCall x1 x2) (C_JLPCall y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_JLReturn x1) (C_JLReturn y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_JLAssign x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID
    i) x3, bind cd (rightID i) x4]
  bind cd i (C_JLIf x3 x4 x5) = (i :=: ChooseN 1 3) : concat [bind cd (leftID
    (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (rightID i) x5]
  bind cd i (C_JLWhile x3 x4) = (i :=: ChooseN 2 2) : concat [bind cd (leftID i)
    x3, bind cd (rightID i) x4]
  bind cd i (C_JLFor x3 x4 x5 x6) = (i :=: ChooseN 3 4) : concat [bind cd
    (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (leftID
    (rightID i)) x5, bind cd (rightID (rightID i)) x6]
  bind cd i (C_JLPCall x3 x4) = (i :=: ChooseN 4 2) : concat [bind cd (leftID i)
    x3, bind cd (rightID i) x4]
  bind cd i (C_JLReturn x3) = (i :=: ChooseN 5 1) : concat [bind cd (leftID i)
    x3]
  bind d i (Choice_C_JLStm cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_JLStm cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_JLStm cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_JLStm cd i _) = error
    ("Language.Julia.Types.JLStm.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_JLStm cd info) = [Unsolvable info]
  bind d i (Guard_C_JLStm cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_JLAssign x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind cd i (C_JLIf x3 x4 x5) = (i :=: ChooseN 1 3) : [leftID (leftID i) :=:
    LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x5)]
  lazyBind cd i (C_JLWhile x3 x4) = (i :=: ChooseN 2 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (C_JLFor x3 x4 x5 x6) = (i :=: ChooseN 3 4) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), leftID (rightID i) :=:
    LazyBind (lazyBind cd (leftID (rightID i)) x5), rightID (rightID i) :=:
    LazyBind (lazyBind cd (rightID (rightID i)) x6)]
  lazyBind cd i (C_JLPCall x3 x4) = (i :=: ChooseN 4 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (C_JLReturn x3) = (i :=: ChooseN 5 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_JLStm cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_JLStm cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_JLStm cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_JLStm cd i _) = error
    ("Language.Julia.Types.JLStm.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_JLStm cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_JLStm cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_JLStm where

data C_JLTop
  = C_JLFDecl (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
    (Curry_Prelude.C_Maybe C_JLType))) (Curry_Prelude.C_Maybe C_JLType)
    (Curry_Prelude.OP_List C_JLStm)
  | C_JLStat C_JLStm
  | Choice_C_JLTop Cover ID C_JLTop C_JLTop
  | Choices_C_JLTop Cover ID [C_JLTop]
  | Fail_C_JLTop Cover FailInfo
  | Guard_C_JLTop Cover Constraints C_JLTop

instance Show C_JLTop where
  showsPrec d (Choice_C_JLTop cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_JLTop cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_JLTop cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_JLTop cd info) = showChar '!'
  showsPrec _ (C_JLFDecl x1 x2 x3 x4) = showString "(JLFDecl" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 .
    (showChar ' ' . (shows x4 . showChar ')'))))))))
  showsPrec _ (C_JLStat x1) = showString "(JLStat" . (showChar ' ' . (shows x1 .
    showChar ')'))

instance Read C_JLTop where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_JLFDecl x1 x2 x3 x4, r4) | (_
    , r0) <- readQualified "Language.Julia.Types" "JLFDecl" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2,
    (x4, r4) <- readsPrec 11 r3]) s ++ readParen ((>) d 10) (\r -> [(C_JLStat x1
    , r1) | (_, r0) <- readQualified "Language.Julia.Types" "JLStat" r, (x1, r1)
    <- readsPrec 11 r0]) s

instance NonDet C_JLTop where
  choiceCons = Choice_C_JLTop
  choicesCons = Choices_C_JLTop
  failCons = Fail_C_JLTop
  guardCons = Guard_C_JLTop
  try (Choice_C_JLTop cd i x y) = tryChoice cd i x y
  try (Choices_C_JLTop cd i xs) = tryChoices cd i xs
  try (Fail_C_JLTop cd info) = Fail cd info
  try (Guard_C_JLTop cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_JLTop cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_JLTop cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_JLTop cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_JLTop cd i _) = error
    ("Language.Julia.Types.JLTop.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_JLTop cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_JLTop cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_JLTop where
  generate s c = Choices_C_JLTop c (freeID [4, 1] s) [C_JLFDecl (generate
    (leftSupply (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c)
    (generate (leftSupply (rightSupply s)) c) (generate (rightSupply
    (rightSupply s)) c), C_JLStat (generate (leftSupply s) c)]

instance NormalForm C_JLTop where
  ($!!) cont (C_JLFDecl x1 x2 x3 x4) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> cont (C_JLFDecl y1 y2 y3
    y4) d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (C_JLStat x1) d cs = ($!!) (\y1 d cs -> cont (C_JLStat y1) d cs) x1
    d cs
  ($!!) cont (Choice_C_JLTop cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_JLTop cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_JLTop cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_JLTop cd info) _ _ = failCons cd info
  ($##) cont (C_JLFDecl x1 x2 x3 x4) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> ($##) (\y3 d cs -> ($##) (\y4 d cs -> cont (C_JLFDecl y1 y2 y3
    y4) d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (C_JLStat x1) d cs = ($##) (\y1 d cs -> cont (C_JLStat y1) d cs) x1
    d cs
  ($##) cont (Choice_C_JLTop cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_JLTop cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_JLTop cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_JLTop cd info) _ _ = failCons cd info
  showCons (C_JLFDecl _ _ _ _) = "Language.Julia.Types.JLFDecl _ _ _ _"
  showCons (C_JLStat _) = "Language.Julia.Types.JLStat _"
  showCons x = error ("Language.Julia.Types.JLTop.showCons: no constructor: " ++
    show x)
  searchNF search cont (C_JLFDecl x1 x2 x3 x4) = search (\y1 -> search (\y2 ->
    search (\y3 -> search (\y4 -> cont (C_JLFDecl y1 y2 y3 y4)) x4) x3) x2) x1
  searchNF search cont (C_JLStat x1) = search (\y1 -> cont (C_JLStat y1)) x1
  searchNF _ _ x = error
    ("Language.Julia.Types.JLTop.searchNF: no constructor: " ++ show x)

instance Unifiable C_JLTop where
  (=.=) (C_JLFDecl x1 x2 x3 x4) (C_JLFDecl y1 y2 y3 y4) d cs = (&) ((=:=) x1 y1
    d cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((=:=) x4 y4 d cs) d
    cs) d cs) d cs
  (=.=) (C_JLStat x1) (C_JLStat y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_JLFDecl x1 x2 x3 x4) (C_JLFDecl y1 y2 y3 y4) d cs = (&) ((=:<=) x1
    y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs) ((=:<=) x4 y4 d
    cs) d cs) d cs) d cs
  (=.<=) (C_JLStat x1) (C_JLStat y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_JLFDecl x3 x4 x5 x6) = (i :=: ChooseN 0 4) : concat [bind cd
    (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (leftID
    (rightID i)) x5, bind cd (rightID (rightID i)) x6]
  bind cd i (C_JLStat x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID i) x3]
  bind d i (Choice_C_JLTop cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_JLTop cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_JLTop cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_JLTop cd i _) = error
    ("Language.Julia.Types.JLTop.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_JLTop cd info) = [Unsolvable info]
  bind d i (Guard_C_JLTop cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_JLFDecl x3 x4 x5 x6) = (i :=: ChooseN 0 4) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), leftID (rightID i) :=:
    LazyBind (lazyBind cd (leftID (rightID i)) x5), rightID (rightID i) :=:
    LazyBind (lazyBind cd (rightID (rightID i)) x6)]
  lazyBind cd i (C_JLStat x3) = (i :=: ChooseN 1 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_JLTop cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_JLTop cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_JLTop cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_JLTop cd i _) = error
    ("Language.Julia.Types.JLTop.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_JLTop cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_JLTop cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_JLTop where

data C_JLModule
  = C_JLModule (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
    (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
    (Curry_Prelude.OP_List C_JLTop)
  | Choice_C_JLModule Cover ID C_JLModule C_JLModule
  | Choices_C_JLModule Cover ID [C_JLModule]
  | Fail_C_JLModule Cover FailInfo
  | Guard_C_JLModule Cover Constraints C_JLModule

instance Show C_JLModule where
  showsPrec d (Choice_C_JLModule cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_JLModule cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_JLModule cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_JLModule cd info) = showChar '!'
  showsPrec _ (C_JLModule x1 x2 x3 x4) = showString "(JLModule" . (showChar
    ' ' . (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 .
    (showChar ' ' . (shows x4 . showChar ')'))))))))

instance Read C_JLModule where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_JLModule x1 x2 x3 x4, r4) | (_
    , r0) <- readQualified "Language.Julia.Types" "JLModule" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2,
    (x4, r4) <- readsPrec 11 r3]) s

instance NonDet C_JLModule where
  choiceCons = Choice_C_JLModule
  choicesCons = Choices_C_JLModule
  failCons = Fail_C_JLModule
  guardCons = Guard_C_JLModule
  try (Choice_C_JLModule cd i x y) = tryChoice cd i x y
  try (Choices_C_JLModule cd i xs) = tryChoices cd i xs
  try (Fail_C_JLModule cd info) = Fail cd info
  try (Guard_C_JLModule cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_JLModule cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_JLModule cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_JLModule cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_JLModule cd i _) = error
    ("Language.Julia.Types.JLModule.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_JLModule cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_JLModule cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_JLModule where
  generate s c = Choices_C_JLModule c (freeID [4] s) [C_JLModule (generate
    (leftSupply (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c)
    (generate (leftSupply (rightSupply s)) c) (generate (rightSupply
    (rightSupply s)) c)]

instance NormalForm C_JLModule where
  ($!!) cont (C_JLModule x1 x2 x3 x4) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> cont (C_JLModule y1 y2 y3
    y4) d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_JLModule cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_JLModule cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_JLModule cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_JLModule cd info) _ _ = failCons cd info
  ($##) cont (C_JLModule x1 x2 x3 x4) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> ($##) (\y3 d cs -> ($##) (\y4 d cs -> cont (C_JLModule y1 y2 y3
    y4) d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_JLModule cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_JLModule cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_JLModule cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_JLModule cd info) _ _ = failCons cd info
  showCons (C_JLModule _ _ _ _) = "Language.Julia.Types.JLModule _ _ _ _"
  showCons x = error
    ("Language.Julia.Types.JLModule.showCons: no constructor: " ++ show x)
  searchNF search cont (C_JLModule x1 x2 x3 x4) = search (\y1 -> search (\y2 ->
    search (\y3 -> search (\y4 -> cont (C_JLModule y1 y2 y3 y4)) x4) x3) x2) x1
  searchNF _ _ x = error
    ("Language.Julia.Types.JLModule.searchNF: no constructor: " ++ show x)

instance Unifiable C_JLModule where
  (=.=) (C_JLModule x1 x2 x3 x4) (C_JLModule y1 y2 y3 y4) d cs = (&) ((=:=) x1
    y1 d cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((=:=) x4 y4 d cs)
    d cs) d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_JLModule x1 x2 x3 x4) (C_JLModule y1 y2 y3 y4) d cs = (&) ((=:<=) x1
    y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs) ((=:<=) x4 y4 d
    cs) d cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_JLModule x3 x4 x5 x6) = (i :=: ChooseN 0 4) : concat [bind cd
    (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (leftID
    (rightID i)) x5, bind cd (rightID (rightID i)) x6]
  bind d i (Choice_C_JLModule cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_JLModule cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_JLModule cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_JLModule cd i _) = error
    ("Language.Julia.Types.JLModule.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_JLModule cd info) = [Unsolvable info]
  bind d i (Guard_C_JLModule cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_JLModule x3 x4 x5 x6) = (i :=: ChooseN 0 4) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), leftID (rightID i) :=:
    LazyBind (lazyBind cd (leftID (rightID i)) x5), rightID (rightID i) :=:
    LazyBind (lazyBind cd (rightID (rightID i)) x6)]
  lazyBind d i (Choice_C_JLModule cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_JLModule cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_JLModule cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_JLModule cd i _) = error
    ("Language.Julia.Types.JLModule.lazyBind: Choices with ChoiceID: " ++ show
    i)
  lazyBind _ _ (Fail_C_JLModule cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_JLModule cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_JLModule where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_JLType
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Julia.Types._inst#Prelude.Data#Language.Julia.Types.JLType#" [show
    x1] info)
  _ -> failCons cd (consFail
    "Language.Julia.Types._inst#Prelude.Data#Language.Julia.Types.JLType#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash :: C_JLType
  -> C_JLType -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash x1 x2 s cd cs =
  case x1 of
  C_JLBoolType -> d_C__case_26 x2 cd cs
  C_JLInt32 -> d_C__case_25 x2 cd cs
  C_JLInt64 -> d_C__case_24 x2 cd cs
  C_JLFloat64 -> d_C__case_23 x2 cd cs
  C_JLStringType -> d_C__case_22 x2 cd cs
  C_JLStruct x13 -> let s0 = s in s0 `seq` nd_C__case_21 x13 x2 s0 cd cs
  C_JLArray x16 -> let s0 = s in s0 `seq` nd_C__case_20 x16 x2 s0 cd cs
  Choice_C_JLType d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash
    r x2 s cd cs)
  Choices_C_JLType d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash
    z x2 s cd cs) xs
  Guard_C_JLType d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_JLType d info -> failCons d (traceFail
    "Language.Julia.Types._impl#===#Prelude.Data#Language.Julia.Types.JLType#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.Julia.Types._impl#===#Prelude.Data#Language.Julia.Types.JLType#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash :: IDSupply
  -> Cover -> ConstStore -> C_JLType
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash s cd cs =
  let s13 = s
  in s13 `seq` (let s12 = leftSupply s13
                    s14 = rightSupply s13
                    s9 = leftSupply s14
                    s11 = rightSupply s14
  in s12 `seq` (s14 `seq` (s9 `seq` (s11 `seq` choice (let s8 = leftSupply s9
                                                           s10 = rightSupply s9
                                                           s6 = leftSupply s10
                                                           s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s6 `seq` (s7 `seq` choice (let s5 = leftSupply s6
                                                         s4 = rightSupply s6
  in s5 `seq` (s4 `seq` choice (let s3 = leftSupply s4
                                    s2 = rightSupply s4
  in s3 `seq` (s2 `seq` choice (let s1 = leftSupply s2
                                    s0 = rightSupply s2
  in s1 `seq` (s0 `seq` choice (choice C_JLBoolType C_JLInt32 s0 cd cs)
  C_JLInt64 s1 cd cs)) C_JLFloat64 s3 cd cs)) C_JLStringType s5 cd cs))
  (C_JLStruct
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s7 cd cs)) s8 cd cs)))) (C_JLArray
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash)
  s11 cd cs)) s12 cd cs))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_JLExp
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Julia.Types._inst#Prelude.Data#Language.Julia.Types.JLExp#" [show
    x1] info)
  _ -> failCons cd (consFail
    "Language.Julia.Types._inst#Prelude.Data#Language.Julia.Types.JLExp#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash :: C_JLExp
  -> C_JLExp -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash x1 x2 s cd cs =
  case x1 of
  C_JLBool x3 -> d_C__case_19 x3 x2 cd cs
  C_JLInt x20 -> d_C__case_18 x20 x2 cd cs
  C_JLFloat x37 -> d_C__case_17 x37 x2 cd cs
  C_JLString x54 -> let s0 = s in s0 `seq` nd_C__case_16 x54 x2 s0 cd cs
  C_JLIVar x71 -> d_C__case_15 x71 x2 cd cs
  C_JLSVar x88 -> let s0 = s in s0 `seq` nd_C__case_14 x88 x2 s0 cd cs
  C_JLArrayAcc x105 x106 -> let s0 = s
    in s0 `seq` nd_C__case_13 x106 x105 x2 s0 cd cs
  C_JLArrayInit x123 -> let s0 = s in s0 `seq` nd_C__case_12 x123 x2 s0 cd cs
  C_JLStructAcc x140 x141 -> let s0 = s
    in s0 `seq` nd_C__case_11 x141 x140 x2 s0 cd cs
  C_JLOp x158 x159 x160 -> let s0 = s
    in s0 `seq` nd_C__case_10 x160 x159 x158 x2 s0 cd cs
  C_JLFCall x177 x178 -> let s0 = s
    in s0 `seq` nd_C__case_9 x178 x177 x2 s0 cd cs
  Choice_C_JLExp d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    r x2 s cd cs)
  Choices_C_JLExp d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    z x2 s cd cs) xs
  Guard_C_JLExp d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_JLExp d info -> failCons d (traceFail
    "Language.Julia.Types._impl#===#Prelude.Data#Language.Julia.Types.JLExp#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.Julia.Types._impl#===#Prelude.Data#Language.Julia.Types.JLExp#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash :: IDSupply
  -> Cover -> ConstStore -> C_JLExp
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash s cd cs =
  let s49 = s
  in s49 `seq` (let s48 = leftSupply s49
                    s50 = rightSupply s49
                    s43 = leftSupply s50
                    s47 = rightSupply s50
  in s48 `seq` (s50 `seq` (s43 `seq` (s47 `seq` choice (let s42 = leftSupply s43
                                                            s44 = rightSupply
                                                              s43
                                                            s35 = leftSupply s44
                                                            s40 = rightSupply
                                                              s44
  in s42 `seq` (s44 `seq` (s35 `seq` (s40 `seq` choice (let s34 = leftSupply s35
                                                            s36 = rightSupply
                                                              s35
                                                            s29 = leftSupply s36
                                                            s33 = rightSupply
                                                              s36
  in s34 `seq` (s36 `seq` (s29 `seq` (s33 `seq` choice (let s28 = leftSupply s29
                                                            s30 = rightSupply
                                                              s29
                                                            s25 = leftSupply s30
                                                            s27 = rightSupply
                                                              s30
  in s28 `seq` (s30 `seq` (s25 `seq` (s27 `seq` choice (let s24 = leftSupply s25
                                                            s26 = rightSupply
                                                              s25
                                                            s19 = leftSupply s26
                                                            s23 = rightSupply
                                                              s26
  in s24 `seq` (s26 `seq` (s19 `seq` (s23 `seq` choice (let s18 = leftSupply s19
                                                            s20 = rightSupply
                                                              s19
                                                            s15 = leftSupply s20
                                                            s17 = rightSupply
                                                              s20
  in s18 `seq` (s20 `seq` (s15 `seq` (s17 `seq` choice (let s14 = leftSupply s15
                                                            s16 = rightSupply
                                                              s15
                                                            s11 = leftSupply s16
                                                            s13 = rightSupply
                                                              s16
  in s14 `seq` (s16 `seq` (s11 `seq` (s13 `seq` choice (let s10 = leftSupply s11
                                                            s12 = rightSupply
                                                              s11
                                                            s7 = leftSupply s12
                                                            s9 = rightSupply s12
  in s10 `seq` (s12 `seq` (s7 `seq` (s9 `seq` choice (let s6 = leftSupply s7
                                                          s8 = rightSupply s7
                                                          s3 = leftSupply s8
                                                          s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` choice (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` choice (C_JLBool
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
  s0 cd cs)) (C_JLInt
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s1 cd cs)) s2 cd cs)))) (C_JLFloat
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Float_hash
  s5 cd cs)) s6 cd cs)))) (C_JLString
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s9 cd cs)) s10 cd cs)))) (C_JLIVar
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s13 cd cs)) s14 cd cs)))) (C_JLSVar
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s17 cd cs)) s18 cd cs)))) (let s21 = leftSupply s23
                                 s22 = rightSupply s23
  in s21 `seq` (s22 `seq` C_JLArrayAcc
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
  s21 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
  s22 cd cs))) s24 cd cs)))) (C_JLArrayInit
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash)
  s27 cd cs)) s28 cd cs)))) (let s31 = leftSupply s33
                                 s32 = rightSupply s33
  in s31 `seq` (s32 `seq` C_JLStructAcc
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
  s31 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s32 cd cs))) s34 cd cs)))) (let s37 = leftSupply s40
                                  s41 = rightSupply s40
                                  s38 = leftSupply s41
                                  s39 = rightSupply s41
  in s37 `seq` (s41 `seq` (s38 `seq` (s39 `seq` C_JLOp
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s37 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
  s38 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
  s39 cd cs))))) s42 cd cs)))) (let s45 = leftSupply s47
                                    s46 = rightSupply s47
  in s45 `seq` (s46 `seq` C_JLFCall
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s45 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash)
  s46 cd cs))) s48 cd cs))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_JLStm
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Julia.Types._inst#Prelude.Data#Language.Julia.Types.JLStm#" [show
    x1] info)
  _ -> failCons cd (consFail
    "Language.Julia.Types._inst#Prelude.Data#Language.Julia.Types.JLStm#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash :: C_JLStm
  -> C_JLStm -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash x1 x2 s cd cs =
  case x1 of
  C_JLAssign x3 x4 -> let s0 = s in s0 `seq` nd_C__case_8 x4 x3 x2 s0 cd cs
  C_JLIf x19 x20 x21 -> let s0 = s
    in s0 `seq` nd_C__case_7 x21 x20 x19 x2 s0 cd cs
  C_JLWhile x36 x37 -> let s0 = s in s0 `seq` nd_C__case_6 x37 x36 x2 s0 cd cs
  C_JLFor x52 x53 x54 x55 -> let s0 = s
    in s0 `seq` nd_C__case_5 x55 x54 x53 x52 x2 s0 cd cs
  C_JLPCall x70 x71 -> let s0 = s in s0 `seq` nd_C__case_4 x71 x70 x2 s0 cd cs
  C_JLReturn x86 -> let s0 = s in s0 `seq` nd_C__case_3 x86 x2 s0 cd cs
  Choice_C_JLStm d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash
    r x2 s cd cs)
  Choices_C_JLStm d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash
    z x2 s cd cs) xs
  Guard_C_JLStm d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_JLStm d info -> failCons d (traceFail
    "Language.Julia.Types._impl#===#Prelude.Data#Language.Julia.Types.JLStm#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.Julia.Types._impl#===#Prelude.Data#Language.Julia.Types.JLStm#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash :: IDSupply
  -> Cover -> ConstStore -> C_JLStm
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash s cd cs =
  let s35 = s
  in s35 `seq` (let s34 = leftSupply s35
                    s36 = rightSupply s35
                    s31 = leftSupply s36
                    s33 = rightSupply s36
  in s34 `seq` (s36 `seq` (s31 `seq` (s33 `seq` choice (let s30 = leftSupply s31
                                                            s32 = rightSupply
                                                              s31
                                                            s25 = leftSupply s32
                                                            s29 = rightSupply
                                                              s32
  in s30 `seq` (s32 `seq` (s25 `seq` (s29 `seq` choice (let s24 = leftSupply s25
                                                            s26 = rightSupply
                                                              s25
                                                            s15 = leftSupply s26
                                                            s21 = rightSupply
                                                              s26
  in s24 `seq` (s26 `seq` (s15 `seq` (s21 `seq` choice (let s14 = leftSupply s15
                                                            s16 = rightSupply
                                                              s15
                                                            s9 = leftSupply s16
                                                            s13 = rightSupply
                                                              s16
  in s14 `seq` (s16 `seq` (s9 `seq` (s13 `seq` choice (let s8 = leftSupply s9
                                                           s10 = rightSupply s9
                                                           s2 = leftSupply s10
                                                           s6 = rightSupply s10
  in s8 `seq` (s10 `seq` (s2 `seq` (s6 `seq` choice (let s0 = leftSupply s2
                                                         s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_JLAssign
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
  s0 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
  s1 cd cs))) (let s3 = leftSupply s6
                   s7 = rightSupply s6
                   s4 = leftSupply s7
                   s5 = rightSupply s7
  in s3 `seq` (s7 `seq` (s4 `seq` (s5 `seq` C_JLIf
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
  s3 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash)
  s4 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash)
  s5 cd cs))))) s8 cd cs)))) (let s11 = leftSupply s13
                                  s12 = rightSupply s13
  in s11 `seq` (s12 `seq` C_JLWhile
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
  s11 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash)
  s12 cd cs))) s14 cd cs)))) (let s22 = leftSupply s21
                                  s23 = rightSupply s21
                                  s17 = leftSupply s22
                                  s18 = rightSupply s22
                                  s19 = leftSupply s23
                                  s20 = rightSupply s23
  in s22 `seq` (s23 `seq` (s17 `seq` (s18 `seq` (s19 `seq` (s20 `seq` C_JLFor
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s17 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
  s18 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
  s19 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash)
  s20 cd cs))))))) s24 cd cs)))) (let s27 = leftSupply s29
                                      s28 = rightSupply s29
  in s27 `seq` (s28 `seq` C_JLPCall
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s27 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash)
  s28 cd cs))) s30 cd cs)))) (C_JLReturn
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
  s33 cd cs)) s34 cd cs))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_JLTop
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Julia.Types._inst#Prelude.Data#Language.Julia.Types.JLTop#" [show
    x1] info)
  _ -> failCons cd (consFail
    "Language.Julia.Types._inst#Prelude.Data#Language.Julia.Types.JLTop#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash :: C_JLTop
  -> C_JLTop -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash x1 x2 s cd cs =
  case x1 of
  C_JLFDecl x3 x4 x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_2 x6 x5 x4 x3 x2 s0 cd cs
  C_JLStat x12 -> let s0 = s in s0 `seq` nd_C__case_1 x12 x2 s0 cd cs
  Choice_C_JLTop d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash
    r x2 s cd cs)
  Choices_C_JLTop d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash
    z x2 s cd cs) xs
  Guard_C_JLTop d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_JLTop d info -> failCons d (traceFail
    "Language.Julia.Types._impl#===#Prelude.Data#Language.Julia.Types.JLTop#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.Julia.Types._impl#===#Prelude.Data#Language.Julia.Types.JLTop#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash :: IDSupply
  -> Cover -> ConstStore -> C_JLTop
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash s cd cs =
  let s9 = s
  in s9 `seq` (let s8 = leftSupply s9
                   s10 = rightSupply s9
                   s4 = leftSupply s10
                   s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s4 `seq` (s7 `seq` choice (let s5 = leftSupply s4
                                                         s6 = rightSupply s4
                                                         s0 = leftSupply s5
                                                         s1 = rightSupply s5
                                                         s2 = leftSupply s6
                                                         s3 = rightSupply s6
  in s5 `seq` (s6 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s3 `seq` C_JLFDecl
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash)))))
  s1 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Maybe_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash)
  s2 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash)
  s3 cd cs))))))) (C_JLStat
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash
  s7 cd cs)) s8 cd cs))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLModule_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_JLModule
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLModule_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLModule_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLModule_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLModule_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLModule_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLModule_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLModule_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Julia.Types._inst#Prelude.Data#Language.Julia.Types.JLModule#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.Julia.Types._inst#Prelude.Data#Language.Julia.Types.JLModule#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLModule_hash :: C_JLModule
  -> C_JLModule -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLModule_hash x1 x2 s cd cs =
  case x1 of
  C_JLModule x3 x4 x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_0 x6 x5 x4 x3 x2 s0 cd cs
  Choice_C_JLModule d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLModule_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLModule_hash
    r x2 s cd cs)
  Choices_C_JLModule d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLModule_hash
    z x2 s cd cs) xs
  Guard_C_JLModule d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLModule_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_JLModule d info -> failCons d (traceFail
    "Language.Julia.Types._impl#===#Prelude.Data#Language.Julia.Types.JLModule#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.Julia.Types._impl#===#Prelude.Data#Language.Julia.Types.JLModule#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLModule_hash :: IDSupply
  -> Cover -> ConstStore -> C_JLModule
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLModule_hash s cd cs =
  let s4 = s
  in s4 `seq` (let s5 = leftSupply s4
                   s6 = rightSupply s4
                   s0 = leftSupply s5
                   s1 = rightSupply s5
                   s2 = leftSupply s6
                   s3 = rightSupply s6
  in s5 `seq` (s6 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s3 `seq` C_JLModule
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s1 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s2 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash)
  s3 cd cs)))))))

nd_C__case_20 :: Curry_Prelude.OP_List C_JLType -> C_JLType -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_20 x16 x2 s cd cs = case x2 of
  C_JLBoolType -> Curry_Prelude.C_False
  C_JLInt32 -> Curry_Prelude.C_False
  C_JLInt64 -> Curry_Prelude.C_False
  C_JLFloat64 -> Curry_Prelude.C_False
  C_JLStringType -> Curry_Prelude.C_False
  C_JLStruct x17 -> Curry_Prelude.C_False
  C_JLArray x18 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash)
    x16 x18 s0 cd cs
  Choice_C_JLType d i l r -> narrow d i (nd_C__case_20 x16 l s cd cs)
    (nd_C__case_20 x16 r s cd cs)
  Choices_C_JLType d i xs -> narrows cs d i (\z -> nd_C__case_20 x16 z s cd cs)
    xs
  Guard_C_JLType d c e -> guardCons d c ((\x -> nd_C__case_20 x16 e s cd x) $!
    addCs c cs)
  Fail_C_JLType d info -> failCons d (traceFail "Language.Julia.Types._case_20"
    [show x16, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_20" (showCons x2))

nd_C__case_21 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_JLType
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_21 x13 x2 s cd cs = case x2 of
  C_JLBoolType -> Curry_Prelude.C_False
  C_JLInt32 -> Curry_Prelude.C_False
  C_JLInt64 -> Curry_Prelude.C_False
  C_JLFloat64 -> Curry_Prelude.C_False
  C_JLStringType -> Curry_Prelude.C_False
  C_JLStruct x14 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x13 x14 s0 cd cs
  C_JLArray x15 -> Curry_Prelude.C_False
  Choice_C_JLType d i l r -> narrow d i (nd_C__case_21 x13 l s cd cs)
    (nd_C__case_21 x13 r s cd cs)
  Choices_C_JLType d i xs -> narrows cs d i (\z -> nd_C__case_21 x13 z s cd cs)
    xs
  Guard_C_JLType d c e -> guardCons d c ((\x -> nd_C__case_21 x13 e s cd x) $!
    addCs c cs)
  Fail_C_JLType d info -> failCons d (traceFail "Language.Julia.Types._case_21"
    [show x13, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_21" (showCons x2))

d_C__case_22 :: C_JLType -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_22 x2 cd cs = case x2 of
  C_JLBoolType -> Curry_Prelude.C_False
  C_JLInt32 -> Curry_Prelude.C_False
  C_JLInt64 -> Curry_Prelude.C_False
  C_JLFloat64 -> Curry_Prelude.C_False
  C_JLStringType -> Curry_Prelude.C_True
  C_JLStruct x11 -> Curry_Prelude.C_False
  C_JLArray x12 -> Curry_Prelude.C_False
  Choice_C_JLType d i l r -> narrow d i (d_C__case_22 l cd cs) (d_C__case_22 r
    cd cs)
  Choices_C_JLType d i xs -> narrows cs d i (\z -> d_C__case_22 z cd cs) xs
  Guard_C_JLType d c e -> guardCons d c ((\x -> d_C__case_22 e cd x) $! addCs c
    cs)
  Fail_C_JLType d info -> failCons d (traceFail "Language.Julia.Types._case_22"
    [show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_22" (showCons x2))

d_C__case_23 :: C_JLType -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_23 x2 cd cs = case x2 of
  C_JLBoolType -> Curry_Prelude.C_False
  C_JLInt32 -> Curry_Prelude.C_False
  C_JLInt64 -> Curry_Prelude.C_False
  C_JLFloat64 -> Curry_Prelude.C_True
  C_JLStringType -> Curry_Prelude.C_False
  C_JLStruct x9 -> Curry_Prelude.C_False
  C_JLArray x10 -> Curry_Prelude.C_False
  Choice_C_JLType d i l r -> narrow d i (d_C__case_23 l cd cs) (d_C__case_23 r
    cd cs)
  Choices_C_JLType d i xs -> narrows cs d i (\z -> d_C__case_23 z cd cs) xs
  Guard_C_JLType d c e -> guardCons d c ((\x -> d_C__case_23 e cd x) $! addCs c
    cs)
  Fail_C_JLType d info -> failCons d (traceFail "Language.Julia.Types._case_23"
    [show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_23" (showCons x2))

d_C__case_24 :: C_JLType -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_24 x2 cd cs = case x2 of
  C_JLBoolType -> Curry_Prelude.C_False
  C_JLInt32 -> Curry_Prelude.C_False
  C_JLInt64 -> Curry_Prelude.C_True
  C_JLFloat64 -> Curry_Prelude.C_False
  C_JLStringType -> Curry_Prelude.C_False
  C_JLStruct x7 -> Curry_Prelude.C_False
  C_JLArray x8 -> Curry_Prelude.C_False
  Choice_C_JLType d i l r -> narrow d i (d_C__case_24 l cd cs) (d_C__case_24 r
    cd cs)
  Choices_C_JLType d i xs -> narrows cs d i (\z -> d_C__case_24 z cd cs) xs
  Guard_C_JLType d c e -> guardCons d c ((\x -> d_C__case_24 e cd x) $! addCs c
    cs)
  Fail_C_JLType d info -> failCons d (traceFail "Language.Julia.Types._case_24"
    [show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_24" (showCons x2))

d_C__case_25 :: C_JLType -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_25 x2 cd cs = case x2 of
  C_JLBoolType -> Curry_Prelude.C_False
  C_JLInt32 -> Curry_Prelude.C_True
  C_JLInt64 -> Curry_Prelude.C_False
  C_JLFloat64 -> Curry_Prelude.C_False
  C_JLStringType -> Curry_Prelude.C_False
  C_JLStruct x5 -> Curry_Prelude.C_False
  C_JLArray x6 -> Curry_Prelude.C_False
  Choice_C_JLType d i l r -> narrow d i (d_C__case_25 l cd cs) (d_C__case_25 r
    cd cs)
  Choices_C_JLType d i xs -> narrows cs d i (\z -> d_C__case_25 z cd cs) xs
  Guard_C_JLType d c e -> guardCons d c ((\x -> d_C__case_25 e cd x) $! addCs c
    cs)
  Fail_C_JLType d info -> failCons d (traceFail "Language.Julia.Types._case_25"
    [show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_25" (showCons x2))

d_C__case_26 :: C_JLType -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_26 x2 cd cs = case x2 of
  C_JLBoolType -> Curry_Prelude.C_True
  C_JLInt32 -> Curry_Prelude.C_False
  C_JLInt64 -> Curry_Prelude.C_False
  C_JLFloat64 -> Curry_Prelude.C_False
  C_JLStringType -> Curry_Prelude.C_False
  C_JLStruct x3 -> Curry_Prelude.C_False
  C_JLArray x4 -> Curry_Prelude.C_False
  Choice_C_JLType d i l r -> narrow d i (d_C__case_26 l cd cs) (d_C__case_26 r
    cd cs)
  Choices_C_JLType d i xs -> narrows cs d i (\z -> d_C__case_26 z cd cs) xs
  Guard_C_JLType d c e -> guardCons d c ((\x -> d_C__case_26 e cd x) $! addCs c
    cs)
  Fail_C_JLType d info -> failCons d (traceFail "Language.Julia.Types._case_26"
    [show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_26" (showCons x2))

nd_C__case_9 :: Curry_Prelude.OP_List C_JLExp -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_JLExp -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_9 x178 x177 x2 s cd cs = case x2 of
  C_JLBool x179 -> Curry_Prelude.C_False
  C_JLInt x180 -> Curry_Prelude.C_False
  C_JLFloat x181 -> Curry_Prelude.C_False
  C_JLString x182 -> Curry_Prelude.C_False
  C_JLIVar x183 -> Curry_Prelude.C_False
  C_JLSVar x184 -> Curry_Prelude.C_False
  C_JLArrayAcc x185 x186 -> Curry_Prelude.C_False
  C_JLArrayInit x187 -> Curry_Prelude.C_False
  C_JLStructAcc x188 x189 -> Curry_Prelude.C_False
  C_JLOp x190 x191 x192 -> Curry_Prelude.C_False
  C_JLFCall x193 x194 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x177 x193 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash)
    x178 x194 s1 cd cs) cd cs))
  Choice_C_JLExp d i l r -> narrow d i (nd_C__case_9 x178 x177 l s cd cs)
    (nd_C__case_9 x178 x177 r s cd cs)
  Choices_C_JLExp d i xs -> narrows cs d i (\z -> nd_C__case_9 x178 x177 z s cd
    cs) xs
  Guard_C_JLExp d c e -> guardCons d c ((\x -> nd_C__case_9 x178 x177 e s cd
    x) $! addCs c cs)
  Fail_C_JLExp d info -> failCons d (traceFail "Language.Julia.Types._case_9"
    [show x178, show x177, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_9" (showCons x2))

nd_C__case_10 :: C_JLExp -> C_JLExp -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_JLExp -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_10 x160 x159 x158 x2 s cd cs = case x2 of
  C_JLBool x161 -> Curry_Prelude.C_False
  C_JLInt x162 -> Curry_Prelude.C_False
  C_JLFloat x163 -> Curry_Prelude.C_False
  C_JLString x164 -> Curry_Prelude.C_False
  C_JLIVar x165 -> Curry_Prelude.C_False
  C_JLSVar x166 -> Curry_Prelude.C_False
  C_JLArrayAcc x167 x168 -> Curry_Prelude.C_False
  C_JLArrayInit x169 -> Curry_Prelude.C_False
  C_JLStructAcc x170 x171 -> Curry_Prelude.C_False
  C_JLOp x172 x173 x174 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x158 x172 s0 cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    x159 x173 s1 cd cs) cd cs))
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    x160 x174 s3 cd cs) cd cs))
  C_JLFCall x175 x176 -> Curry_Prelude.C_False
  Choice_C_JLExp d i l r -> narrow d i (nd_C__case_10 x160 x159 x158 l s cd cs)
    (nd_C__case_10 x160 x159 x158 r s cd cs)
  Choices_C_JLExp d i xs -> narrows cs d i (\z -> nd_C__case_10 x160 x159 x158 z
    s cd cs) xs
  Guard_C_JLExp d c e -> guardCons d c ((\x -> nd_C__case_10 x160 x159 x158 e s
    cd x) $! addCs c cs)
  Fail_C_JLExp d info -> failCons d (traceFail "Language.Julia.Types._case_10"
    [show x160, show x159, show x158, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_10" (showCons x2))

nd_C__case_11 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_JLExp
  -> C_JLExp -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_11 x141 x140 x2 s cd cs = case x2 of
  C_JLBool x142 -> Curry_Prelude.C_False
  C_JLInt x143 -> Curry_Prelude.C_False
  C_JLFloat x144 -> Curry_Prelude.C_False
  C_JLString x145 -> Curry_Prelude.C_False
  C_JLIVar x146 -> Curry_Prelude.C_False
  C_JLSVar x147 -> Curry_Prelude.C_False
  C_JLArrayAcc x148 x149 -> Curry_Prelude.C_False
  C_JLArrayInit x150 -> Curry_Prelude.C_False
  C_JLStructAcc x151 x152 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    x140 x151 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x141 x152 s1 cd cs) cd cs))
  C_JLOp x153 x154 x155 -> Curry_Prelude.C_False
  C_JLFCall x156 x157 -> Curry_Prelude.C_False
  Choice_C_JLExp d i l r -> narrow d i (nd_C__case_11 x141 x140 l s cd cs)
    (nd_C__case_11 x141 x140 r s cd cs)
  Choices_C_JLExp d i xs -> narrows cs d i (\z -> nd_C__case_11 x141 x140 z s cd
    cs) xs
  Guard_C_JLExp d c e -> guardCons d c ((\x -> nd_C__case_11 x141 x140 e s cd
    x) $! addCs c cs)
  Fail_C_JLExp d info -> failCons d (traceFail "Language.Julia.Types._case_11"
    [show x141, show x140, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_11" (showCons x2))

nd_C__case_12 :: Curry_Prelude.OP_List C_JLExp -> C_JLExp -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_12 x123 x2 s cd cs = case x2 of
  C_JLBool x124 -> Curry_Prelude.C_False
  C_JLInt x125 -> Curry_Prelude.C_False
  C_JLFloat x126 -> Curry_Prelude.C_False
  C_JLString x127 -> Curry_Prelude.C_False
  C_JLIVar x128 -> Curry_Prelude.C_False
  C_JLSVar x129 -> Curry_Prelude.C_False
  C_JLArrayAcc x130 x131 -> Curry_Prelude.C_False
  C_JLArrayInit x132 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash)
    x123 x132 s0 cd cs
  C_JLStructAcc x133 x134 -> Curry_Prelude.C_False
  C_JLOp x135 x136 x137 -> Curry_Prelude.C_False
  C_JLFCall x138 x139 -> Curry_Prelude.C_False
  Choice_C_JLExp d i l r -> narrow d i (nd_C__case_12 x123 l s cd cs)
    (nd_C__case_12 x123 r s cd cs)
  Choices_C_JLExp d i xs -> narrows cs d i (\z -> nd_C__case_12 x123 z s cd cs)
    xs
  Guard_C_JLExp d c e -> guardCons d c ((\x -> nd_C__case_12 x123 e s cd x) $!
    addCs c cs)
  Fail_C_JLExp d info -> failCons d (traceFail "Language.Julia.Types._case_12"
    [show x123, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_12" (showCons x2))

nd_C__case_13 :: C_JLExp -> C_JLExp -> C_JLExp -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_13 x106 x105 x2 s cd cs = case x2 of
  C_JLBool x107 -> Curry_Prelude.C_False
  C_JLInt x108 -> Curry_Prelude.C_False
  C_JLFloat x109 -> Curry_Prelude.C_False
  C_JLString x110 -> Curry_Prelude.C_False
  C_JLIVar x111 -> Curry_Prelude.C_False
  C_JLSVar x112 -> Curry_Prelude.C_False
  C_JLArrayAcc x113 x114 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    x105 x113 s0 cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    x106 x114 s1 cd cs) cd cs))
  C_JLArrayInit x115 -> Curry_Prelude.C_False
  C_JLStructAcc x116 x117 -> Curry_Prelude.C_False
  C_JLOp x118 x119 x120 -> Curry_Prelude.C_False
  C_JLFCall x121 x122 -> Curry_Prelude.C_False
  Choice_C_JLExp d i l r -> narrow d i (nd_C__case_13 x106 x105 l s cd cs)
    (nd_C__case_13 x106 x105 r s cd cs)
  Choices_C_JLExp d i xs -> narrows cs d i (\z -> nd_C__case_13 x106 x105 z s cd
    cs) xs
  Guard_C_JLExp d c e -> guardCons d c ((\x -> nd_C__case_13 x106 x105 e s cd
    x) $! addCs c cs)
  Fail_C_JLExp d info -> failCons d (traceFail "Language.Julia.Types._case_13"
    [show x106, show x105, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_13" (showCons x2))

nd_C__case_14 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_JLExp
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_14 x88 x2 s cd cs = case x2 of
  C_JLBool x89 -> Curry_Prelude.C_False
  C_JLInt x90 -> Curry_Prelude.C_False
  C_JLFloat x91 -> Curry_Prelude.C_False
  C_JLString x92 -> Curry_Prelude.C_False
  C_JLIVar x93 -> Curry_Prelude.C_False
  C_JLSVar x94 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x88 x94 s0 cd cs
  C_JLArrayAcc x95 x96 -> Curry_Prelude.C_False
  C_JLArrayInit x97 -> Curry_Prelude.C_False
  C_JLStructAcc x98 x99 -> Curry_Prelude.C_False
  C_JLOp x100 x101 x102 -> Curry_Prelude.C_False
  C_JLFCall x103 x104 -> Curry_Prelude.C_False
  Choice_C_JLExp d i l r -> narrow d i (nd_C__case_14 x88 l s cd cs)
    (nd_C__case_14 x88 r s cd cs)
  Choices_C_JLExp d i xs -> narrows cs d i (\z -> nd_C__case_14 x88 z s cd cs)
    xs
  Guard_C_JLExp d c e -> guardCons d c ((\x -> nd_C__case_14 x88 e s cd x) $!
    addCs c cs)
  Fail_C_JLExp d info -> failCons d (traceFail "Language.Julia.Types._case_14"
    [show x88, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_14" (showCons x2))

d_C__case_15 :: Curry_Prelude.C_Int -> C_JLExp -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_15 x71 x2 cd cs = case x2 of
  C_JLBool x72 -> Curry_Prelude.C_False
  C_JLInt x73 -> Curry_Prelude.C_False
  C_JLFloat x74 -> Curry_Prelude.C_False
  C_JLString x75 -> Curry_Prelude.C_False
  C_JLIVar x76 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs) x71 cd cs) x76 cd cs
  C_JLSVar x77 -> Curry_Prelude.C_False
  C_JLArrayAcc x78 x79 -> Curry_Prelude.C_False
  C_JLArrayInit x80 -> Curry_Prelude.C_False
  C_JLStructAcc x81 x82 -> Curry_Prelude.C_False
  C_JLOp x83 x84 x85 -> Curry_Prelude.C_False
  C_JLFCall x86 x87 -> Curry_Prelude.C_False
  Choice_C_JLExp d i l r -> narrow d i (d_C__case_15 x71 l cd cs) (d_C__case_15
    x71 r cd cs)
  Choices_C_JLExp d i xs -> narrows cs d i (\z -> d_C__case_15 x71 z cd cs) xs
  Guard_C_JLExp d c e -> guardCons d c ((\x -> d_C__case_15 x71 e cd x) $! addCs
    c cs)
  Fail_C_JLExp d info -> failCons d (traceFail "Language.Julia.Types._case_15"
    [show x71, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_15" (showCons x2))

nd_C__case_16 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_JLExp
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_16 x54 x2 s cd cs = case x2 of
  C_JLBool x55 -> Curry_Prelude.C_False
  C_JLInt x56 -> Curry_Prelude.C_False
  C_JLFloat x57 -> Curry_Prelude.C_False
  C_JLString x58 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x54 x58 s0 cd cs
  C_JLIVar x59 -> Curry_Prelude.C_False
  C_JLSVar x60 -> Curry_Prelude.C_False
  C_JLArrayAcc x61 x62 -> Curry_Prelude.C_False
  C_JLArrayInit x63 -> Curry_Prelude.C_False
  C_JLStructAcc x64 x65 -> Curry_Prelude.C_False
  C_JLOp x66 x67 x68 -> Curry_Prelude.C_False
  C_JLFCall x69 x70 -> Curry_Prelude.C_False
  Choice_C_JLExp d i l r -> narrow d i (nd_C__case_16 x54 l s cd cs)
    (nd_C__case_16 x54 r s cd cs)
  Choices_C_JLExp d i xs -> narrows cs d i (\z -> nd_C__case_16 x54 z s cd cs)
    xs
  Guard_C_JLExp d c e -> guardCons d c ((\x -> nd_C__case_16 x54 e s cd x) $!
    addCs c cs)
  Fail_C_JLExp d info -> failCons d (traceFail "Language.Julia.Types._case_16"
    [show x54, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_16" (showCons x2))

d_C__case_17 :: Curry_Prelude.C_Float -> C_JLExp -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_17 x37 x2 cd cs = case x2 of
  C_JLBool x38 -> Curry_Prelude.C_False
  C_JLInt x39 -> Curry_Prelude.C_False
  C_JLFloat x40 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Float_hash
    cd cs) x37 cd cs) x40 cd cs
  C_JLString x41 -> Curry_Prelude.C_False
  C_JLIVar x42 -> Curry_Prelude.C_False
  C_JLSVar x43 -> Curry_Prelude.C_False
  C_JLArrayAcc x44 x45 -> Curry_Prelude.C_False
  C_JLArrayInit x46 -> Curry_Prelude.C_False
  C_JLStructAcc x47 x48 -> Curry_Prelude.C_False
  C_JLOp x49 x50 x51 -> Curry_Prelude.C_False
  C_JLFCall x52 x53 -> Curry_Prelude.C_False
  Choice_C_JLExp d i l r -> narrow d i (d_C__case_17 x37 l cd cs) (d_C__case_17
    x37 r cd cs)
  Choices_C_JLExp d i xs -> narrows cs d i (\z -> d_C__case_17 x37 z cd cs) xs
  Guard_C_JLExp d c e -> guardCons d c ((\x -> d_C__case_17 x37 e cd x) $! addCs
    c cs)
  Fail_C_JLExp d info -> failCons d (traceFail "Language.Julia.Types._case_17"
    [show x37, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_17" (showCons x2))

d_C__case_18 :: Curry_Prelude.C_Int -> C_JLExp -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_18 x20 x2 cd cs = case x2 of
  C_JLBool x21 -> Curry_Prelude.C_False
  C_JLInt x22 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs) x20 cd cs) x22 cd cs
  C_JLFloat x23 -> Curry_Prelude.C_False
  C_JLString x24 -> Curry_Prelude.C_False
  C_JLIVar x25 -> Curry_Prelude.C_False
  C_JLSVar x26 -> Curry_Prelude.C_False
  C_JLArrayAcc x27 x28 -> Curry_Prelude.C_False
  C_JLArrayInit x29 -> Curry_Prelude.C_False
  C_JLStructAcc x30 x31 -> Curry_Prelude.C_False
  C_JLOp x32 x33 x34 -> Curry_Prelude.C_False
  C_JLFCall x35 x36 -> Curry_Prelude.C_False
  Choice_C_JLExp d i l r -> narrow d i (d_C__case_18 x20 l cd cs) (d_C__case_18
    x20 r cd cs)
  Choices_C_JLExp d i xs -> narrows cs d i (\z -> d_C__case_18 x20 z cd cs) xs
  Guard_C_JLExp d c e -> guardCons d c ((\x -> d_C__case_18 x20 e cd x) $! addCs
    c cs)
  Fail_C_JLExp d info -> failCons d (traceFail "Language.Julia.Types._case_18"
    [show x20, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_18" (showCons x2))

d_C__case_19 :: Curry_Prelude.C_Bool -> C_JLExp -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_19 x3 x2 cd cs = case x2 of
  C_JLBool x4 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
    x3 x4 cd cs
  C_JLInt x5 -> Curry_Prelude.C_False
  C_JLFloat x6 -> Curry_Prelude.C_False
  C_JLString x7 -> Curry_Prelude.C_False
  C_JLIVar x8 -> Curry_Prelude.C_False
  C_JLSVar x9 -> Curry_Prelude.C_False
  C_JLArrayAcc x10 x11 -> Curry_Prelude.C_False
  C_JLArrayInit x12 -> Curry_Prelude.C_False
  C_JLStructAcc x13 x14 -> Curry_Prelude.C_False
  C_JLOp x15 x16 x17 -> Curry_Prelude.C_False
  C_JLFCall x18 x19 -> Curry_Prelude.C_False
  Choice_C_JLExp d i l r -> narrow d i (d_C__case_19 x3 l cd cs) (d_C__case_19
    x3 r cd cs)
  Choices_C_JLExp d i xs -> narrows cs d i (\z -> d_C__case_19 x3 z cd cs) xs
  Guard_C_JLExp d c e -> guardCons d c ((\x -> d_C__case_19 x3 e cd x) $! addCs
    c cs)
  Fail_C_JLExp d info -> failCons d (traceFail "Language.Julia.Types._case_19"
    [show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_19" (showCons x2))

nd_C__case_3 :: C_JLExp -> C_JLStm -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_3 x86 x2 s cd cs = case x2 of
  C_JLAssign x87 x88 -> Curry_Prelude.C_False
  C_JLIf x89 x90 x91 -> Curry_Prelude.C_False
  C_JLWhile x92 x93 -> Curry_Prelude.C_False
  C_JLFor x94 x95 x96 x97 -> Curry_Prelude.C_False
  C_JLPCall x98 x99 -> Curry_Prelude.C_False
  C_JLReturn x100 -> let s0 = s
    in s0 `seq`
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    x86 x100 s0 cd cs
  Choice_C_JLStm d i l r -> narrow d i (nd_C__case_3 x86 l s cd cs)
    (nd_C__case_3 x86 r s cd cs)
  Choices_C_JLStm d i xs -> narrows cs d i (\z -> nd_C__case_3 x86 z s cd cs) xs
  Guard_C_JLStm d c e -> guardCons d c ((\x -> nd_C__case_3 x86 e s cd x) $!
    addCs c cs)
  Fail_C_JLStm d info -> failCons d (traceFail "Language.Julia.Types._case_3"
    [show x86, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_3" (showCons x2))

nd_C__case_4 :: Curry_Prelude.OP_List C_JLExp -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_JLStm -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_4 x71 x70 x2 s cd cs = case x2 of
  C_JLAssign x72 x73 -> Curry_Prelude.C_False
  C_JLIf x74 x75 x76 -> Curry_Prelude.C_False
  C_JLWhile x77 x78 -> Curry_Prelude.C_False
  C_JLFor x79 x80 x81 x82 -> Curry_Prelude.C_False
  C_JLPCall x83 x84 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x70 x83 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash)
    x71 x84 s1 cd cs) cd cs))
  C_JLReturn x85 -> Curry_Prelude.C_False
  Choice_C_JLStm d i l r -> narrow d i (nd_C__case_4 x71 x70 l s cd cs)
    (nd_C__case_4 x71 x70 r s cd cs)
  Choices_C_JLStm d i xs -> narrows cs d i (\z -> nd_C__case_4 x71 x70 z s cd
    cs) xs
  Guard_C_JLStm d c e -> guardCons d c ((\x -> nd_C__case_4 x71 x70 e s cd x) $!
    addCs c cs)
  Fail_C_JLStm d info -> failCons d (traceFail "Language.Julia.Types._case_4"
    [show x71, show x70, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_4" (showCons x2))

nd_C__case_5 :: Curry_Prelude.OP_List C_JLStm -> C_JLExp -> C_JLExp
  -> Curry_Prelude.C_Int -> C_JLStm -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_5 x55 x54 x53 x52 x2 s cd cs = case x2 of
  C_JLAssign x56 x57 -> Curry_Prelude.C_False
  C_JLIf x58 x59 x60 -> Curry_Prelude.C_False
  C_JLWhile x61 x62 -> Curry_Prelude.C_False
  C_JLFor x63 x64 x65 x66 -> let s8 = s
    in s8 `seq` (let s6 = leftSupply s8
                     s7 = rightSupply s8
    in s6 `seq` (s7 `seq` Curry_Prelude.d_OP_amp_amp (let s4 = leftSupply s6
                                                          s5 = rightSupply s6
    in s4 `seq` (s5 `seq` Curry_Prelude.d_OP_amp_amp (let s2 = leftSupply s4
                                                          s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s1 = leftSupply s2
                                                          s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs)) x52 s0 cd cs) x63 s1 cd cs))
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    x53 x64 s3 cd cs) cd cs))
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    x54 x65 s5 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash)
    x55 x66 s7 cd cs) cd cs))
  C_JLPCall x67 x68 -> Curry_Prelude.C_False
  C_JLReturn x69 -> Curry_Prelude.C_False
  Choice_C_JLStm d i l r -> narrow d i (nd_C__case_5 x55 x54 x53 x52 l s cd cs)
    (nd_C__case_5 x55 x54 x53 x52 r s cd cs)
  Choices_C_JLStm d i xs -> narrows cs d i (\z -> nd_C__case_5 x55 x54 x53 x52 z
    s cd cs) xs
  Guard_C_JLStm d c e -> guardCons d c ((\x -> nd_C__case_5 x55 x54 x53 x52 e s
    cd x) $! addCs c cs)
  Fail_C_JLStm d info -> failCons d (traceFail "Language.Julia.Types._case_5"
    [show x55, show x54, show x53, show x52, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_5" (showCons x2))

nd_C__case_6 :: Curry_Prelude.OP_List C_JLStm -> C_JLExp -> C_JLStm -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_6 x37 x36 x2 s cd cs = case x2 of
  C_JLAssign x38 x39 -> Curry_Prelude.C_False
  C_JLIf x40 x41 x42 -> Curry_Prelude.C_False
  C_JLWhile x43 x44 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    x36 x43 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash)
    x37 x44 s1 cd cs) cd cs))
  C_JLFor x45 x46 x47 x48 -> Curry_Prelude.C_False
  C_JLPCall x49 x50 -> Curry_Prelude.C_False
  C_JLReturn x51 -> Curry_Prelude.C_False
  Choice_C_JLStm d i l r -> narrow d i (nd_C__case_6 x37 x36 l s cd cs)
    (nd_C__case_6 x37 x36 r s cd cs)
  Choices_C_JLStm d i xs -> narrows cs d i (\z -> nd_C__case_6 x37 x36 z s cd
    cs) xs
  Guard_C_JLStm d c e -> guardCons d c ((\x -> nd_C__case_6 x37 x36 e s cd x) $!
    addCs c cs)
  Fail_C_JLStm d info -> failCons d (traceFail "Language.Julia.Types._case_6"
    [show x37, show x36, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_6" (showCons x2))

nd_C__case_7 :: Curry_Prelude.OP_List C_JLStm -> Curry_Prelude.OP_List C_JLStm
  -> C_JLExp -> C_JLStm -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_7 x21 x20 x19 x2 s cd cs = case x2 of
  C_JLAssign x22 x23 -> Curry_Prelude.C_False
  C_JLIf x24 x25 x26 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    x19 x24 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash)
    x20 x25 s1 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash)
    x21 x26 s3 cd cs) cd cs))
  C_JLWhile x27 x28 -> Curry_Prelude.C_False
  C_JLFor x29 x30 x31 x32 -> Curry_Prelude.C_False
  C_JLPCall x33 x34 -> Curry_Prelude.C_False
  C_JLReturn x35 -> Curry_Prelude.C_False
  Choice_C_JLStm d i l r -> narrow d i (nd_C__case_7 x21 x20 x19 l s cd cs)
    (nd_C__case_7 x21 x20 x19 r s cd cs)
  Choices_C_JLStm d i xs -> narrows cs d i (\z -> nd_C__case_7 x21 x20 x19 z s
    cd cs) xs
  Guard_C_JLStm d c e -> guardCons d c ((\x -> nd_C__case_7 x21 x20 x19 e s cd
    x) $! addCs c cs)
  Fail_C_JLStm d info -> failCons d (traceFail "Language.Julia.Types._case_7"
    [show x21, show x20, show x19, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_7" (showCons x2))

nd_C__case_8 :: C_JLExp -> C_JLExp -> C_JLStm -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_8 x4 x3 x2 s cd cs = case x2 of
  C_JLAssign x5 x6 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    x3 x5 s0 cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLExp_hash
    x4 x6 s1 cd cs) cd cs))
  C_JLIf x7 x8 x9 -> Curry_Prelude.C_False
  C_JLWhile x10 x11 -> Curry_Prelude.C_False
  C_JLFor x12 x13 x14 x15 -> Curry_Prelude.C_False
  C_JLPCall x16 x17 -> Curry_Prelude.C_False
  C_JLReturn x18 -> Curry_Prelude.C_False
  Choice_C_JLStm d i l r -> narrow d i (nd_C__case_8 x4 x3 l s cd cs)
    (nd_C__case_8 x4 x3 r s cd cs)
  Choices_C_JLStm d i xs -> narrows cs d i (\z -> nd_C__case_8 x4 x3 z s cd cs)
    xs
  Guard_C_JLStm d c e -> guardCons d c ((\x -> nd_C__case_8 x4 x3 e s cd x) $!
    addCs c cs)
  Fail_C_JLStm d info -> failCons d (traceFail "Language.Julia.Types._case_8"
    [show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_8" (showCons x2))

nd_C__case_1 :: C_JLStm -> C_JLTop -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_1 x12 x2 s cd cs = case x2 of
  C_JLFDecl x13 x14 x15 x16 -> Curry_Prelude.C_False
  C_JLStat x17 -> let s0 = s
    in s0 `seq`
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash
    x12 x17 s0 cd cs
  Choice_C_JLTop d i l r -> narrow d i (nd_C__case_1 x12 l s cd cs)
    (nd_C__case_1 x12 r s cd cs)
  Choices_C_JLTop d i xs -> narrows cs d i (\z -> nd_C__case_1 x12 z s cd cs) xs
  Guard_C_JLTop d c e -> guardCons d c ((\x -> nd_C__case_1 x12 e s cd x) $!
    addCs c cs)
  Fail_C_JLTop d info -> failCons d (traceFail "Language.Julia.Types._case_1"
    [show x12, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_1" (showCons x2))

nd_C__case_2 :: Curry_Prelude.OP_List C_JLStm -> Curry_Prelude.C_Maybe C_JLType
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.C_Maybe C_JLType)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_JLTop -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_2 x6 x5 x4 x3 x2 s cd cs = case x2 of
  C_JLFDecl x7 x8 x9 x10 -> let s6 = s
    in s6 `seq` (let s4 = leftSupply s6
                     s5 = rightSupply s6
    in s4 `seq` (s5 `seq` Curry_Prelude.d_OP_amp_amp (let s2 = leftSupply s4
                                                          s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x7 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Maybe_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash)))))
    x4 x8 s1 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Maybe_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLType_hash)
    x5 x9 s3 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLStm_hash)
    x6 x10 s5 cd cs) cd cs))
  C_JLStat x11 -> Curry_Prelude.C_False
  Choice_C_JLTop d i l r -> narrow d i (nd_C__case_2 x6 x5 x4 x3 l s cd cs)
    (nd_C__case_2 x6 x5 x4 x3 r s cd cs)
  Choices_C_JLTop d i xs -> narrows cs d i (\z -> nd_C__case_2 x6 x5 x4 x3 z s
    cd cs) xs
  Guard_C_JLTop d c e -> guardCons d c ((\x -> nd_C__case_2 x6 x5 x4 x3 e s cd
    x) $! addCs c cs)
  Fail_C_JLTop d info -> failCons d (traceFail "Language.Julia.Types._case_2"
    [show x6, show x5, show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_2" (showCons x2))

nd_C__case_0 :: Curry_Prelude.OP_List C_JLTop -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_JLModule -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_0 x6 x5 x4 x3 x2 s cd cs = case x2 of
  C_JLModule x7 x8 x9 x10 -> let s6 = s
    in s6 `seq` (let s4 = leftSupply s6
                     s5 = rightSupply s6
    in s4 `seq` (s5 `seq` Curry_Prelude.d_OP_amp_amp (let s2 = leftSupply s4
                                                          s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x7 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    x4 x8 s1 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    x5 x9 s3 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Julia_dot_Types_dot_JLTop_hash)
    x6 x10 s5 cd cs) cd cs))
  Choice_C_JLModule d i l r -> narrow d i (nd_C__case_0 x6 x5 x4 x3 l s cd cs)
    (nd_C__case_0 x6 x5 x4 x3 r s cd cs)
  Choices_C_JLModule d i xs -> narrows cs d i (\z -> nd_C__case_0 x6 x5 x4 x3 z
    s cd cs) xs
  Guard_C_JLModule d c e -> guardCons d c ((\x -> nd_C__case_0 x6 x5 x4 x3 e s
    cd x) $! addCs c cs)
  Fail_C_JLModule d info -> failCons d (traceFail "Language.Julia.Types._case_0"
    [show x6, show x5, show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Julia.Types._case_0" (showCons x2))

