{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Ninja.Curry_Types
  ( C_File (..)
  , C_Decl (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_File_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_File_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_File_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash )
  where

import Basics
import qualified Curry_Prelude


data C_File
  = C_File (Curry_Prelude.OP_List C_Decl)
  | Choice_C_File Cover ID C_File C_File
  | Choices_C_File Cover ID [C_File]
  | Fail_C_File Cover FailInfo
  | Guard_C_File Cover Constraints C_File

instance Show C_File where
  showsPrec d (Choice_C_File cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_File cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_File cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_File cd info) = showChar '!'
  showsPrec _ (C_File x1) = showString "(File" . (showChar ' ' . (shows x1 .
    showChar ')'))

instance Read C_File where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_File x1, r1) | (_, r0) <-
    readQualified "Ninja.Types" "File" r, (x1, r1) <- readsPrec 11 r0]) s

instance NonDet C_File where
  choiceCons = Choice_C_File
  choicesCons = Choices_C_File
  failCons = Fail_C_File
  guardCons = Guard_C_File
  try (Choice_C_File cd i x y) = tryChoice cd i x y
  try (Choices_C_File cd i xs) = tryChoices cd i xs
  try (Fail_C_File cd info) = Fail cd info
  try (Guard_C_File cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_File cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_File cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_File cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_File cd i _) = error
    ("Ninja.Types.File.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_File cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_File cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_File where
  generate s c = Choices_C_File c (freeID [1] s) [C_File (generate (leftSupply
    s) c)]

instance NormalForm C_File where
  ($!!) cont (C_File x1) d cs = ($!!) (\y1 d cs -> cont (C_File y1) d cs) x1 d
    cs
  ($!!) cont (Choice_C_File cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_File cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_File cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_File cd info) _ _ = failCons cd info
  ($##) cont (C_File x1) d cs = ($##) (\y1 d cs -> cont (C_File y1) d cs) x1 d
    cs
  ($##) cont (Choice_C_File cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_File cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_File cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_File cd info) _ _ = failCons cd info
  showCons (C_File _) = "Ninja.Types.File _"
  showCons x = error ("Ninja.Types.File.showCons: no constructor: " ++ show x)
  searchNF search cont (C_File x1) = search (\y1 -> cont (C_File y1)) x1
  searchNF _ _ x = error ("Ninja.Types.File.searchNF: no constructor: " ++ show
    x)

instance Unifiable C_File where
  (=.=) (C_File x1) (C_File y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_File x1) (C_File y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_File x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID i) x3]
  bind d i (Choice_C_File cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_File cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_File cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_File cd i _) = error
    ("Ninja.Types.File.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_File cd info) = [Unsolvable info]
  bind d i (Guard_C_File cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_File x3) = (i :=: ChooseN 0 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_File cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_File cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j
    xs
  lazyBind d i (Choices_C_File cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_File cd i _) = error
    ("Ninja.Types.File.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_File cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_File cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_File where

data C_Decl
  = C_Rule (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  | C_Edge (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  | C_Var (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  | C_Default (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_Subninja (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_Include (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_Pool (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  | Choice_C_Decl Cover ID C_Decl C_Decl
  | Choices_C_Decl Cover ID [C_Decl]
  | Fail_C_Decl Cover FailInfo
  | Guard_C_Decl Cover Constraints C_Decl

instance Show C_Decl where
  showsPrec d (Choice_C_Decl cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Decl cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Decl cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Decl cd info) = showChar '!'
  showsPrec _ (C_Rule x1 x2) = showString "(Rule" . (showChar ' ' . (shows x1 .
    (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_Edge x1 x2 x3 x4 x5 x6 x7) = showString "(Edge" . (showChar
    ' ' . (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 .
    (showChar ' ' . (shows x4 . (showChar ' ' . (shows x5 . (showChar ' ' .
    (shows x6 . (showChar ' ' . (shows x7 . showChar ')'))))))))))))))
  showsPrec _ (C_Var x1) = showString "(Var" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_Default x1) = showString "(Default" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_Subninja x1) = showString "(Subninja" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_Include x1) = showString "(Include" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_Pool x1 x2) = showString "(Pool" . (showChar ' ' . (shows x1 .
    (showChar ' ' . (shows x2 . showChar ')'))))

instance Read C_Decl where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Rule x1 x2, r2) | (_, r0) <-
    readQualified "Ninja.Types" "Rule" r, (x1, r1) <- readsPrec 11 r0, (x2, r2)
    <- readsPrec 11 r1]) s ++ (readParen ((>) d 10) (\r -> [(C_Edge x1 x2 x3 x4
    x5 x6 x7, r7) | (_, r0) <- readQualified "Ninja.Types" "Edge" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2,
    (x4, r4) <- readsPrec 11 r3, (x5, r5) <- readsPrec 11 r4, (x6, r6) <-
    readsPrec 11 r5, (x7, r7) <- readsPrec 11 r6]) s ++ (readParen ((>) d 10)
    (\r -> [(C_Var x1, r1) | (_, r0) <- readQualified "Ninja.Types" "Var" r, (x1
    , r1) <- readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_Default x1
    , r1) | (_, r0) <- readQualified "Ninja.Types" "Default" r, (x1, r1) <-
    readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_Subninja x1
    , r1) | (_, r0) <- readQualified "Ninja.Types" "Subninja" r, (x1, r1) <-
    readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_Include x1, r1) | (_
    , r0) <- readQualified "Ninja.Types" "Include" r, (x1, r1) <- readsPrec 11
    r0]) s ++ readParen ((>) d 10) (\r -> [(C_Pool x1 x2, r2) | (_, r0) <-
    readQualified "Ninja.Types" "Pool" r, (x1, r1) <- readsPrec 11 r0, (x2, r2)
    <- readsPrec 11 r1]) s)))))

instance NonDet C_Decl where
  choiceCons = Choice_C_Decl
  choicesCons = Choices_C_Decl
  failCons = Fail_C_Decl
  guardCons = Guard_C_Decl
  try (Choice_C_Decl cd i x y) = tryChoice cd i x y
  try (Choices_C_Decl cd i xs) = tryChoices cd i xs
  try (Fail_C_Decl cd info) = Fail cd info
  try (Guard_C_Decl cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Decl cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Decl cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Decl cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Decl cd i _) = error
    ("Ninja.Types.Decl.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Decl cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Decl cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Decl where
  generate s c = Choices_C_Decl c (freeID [2, 7, 1, 1, 1, 1, 2] s) [C_Rule
    (generate (leftSupply s) c) (generate (rightSupply s) c), C_Edge (generate
    (leftSupply (leftSupply (leftSupply s))) c) (generate (rightSupply
    (leftSupply (leftSupply s))) c) (generate (leftSupply (rightSupply
    (leftSupply s))) c) (generate (rightSupply (rightSupply (leftSupply s))) c)
    (generate (leftSupply (leftSupply (rightSupply s))) c) (generate
    (rightSupply (leftSupply (rightSupply s))) c) (generate (rightSupply
    (rightSupply s)) c), C_Var (generate (leftSupply s) c), C_Default (generate
    (leftSupply s) c), C_Subninja (generate (leftSupply s) c), C_Include
    (generate (leftSupply s) c), C_Pool (generate (leftSupply s) c) (generate
    (rightSupply s) c)]

instance NormalForm C_Decl where
  ($!!) cont (C_Rule x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Rule y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_Edge x1 x2 x3 x4 x5 x6 x7) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> ($!!) (\y5 d cs -> ($!!)
    (\y6 d cs -> ($!!) (\y7 d cs -> cont (C_Edge y1 y2 y3 y4 y5 y6 y7) d cs) x7
    d cs) x6 d cs) x5 d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (C_Var x1) d cs = ($!!) (\y1 d cs -> cont (C_Var y1) d cs) x1 d cs
  ($!!) cont (C_Default x1) d cs = ($!!) (\y1 d cs -> cont (C_Default y1) d cs)
    x1 d cs
  ($!!) cont (C_Subninja x1) d cs = ($!!) (\y1 d cs -> cont (C_Subninja y1) d
    cs) x1 d cs
  ($!!) cont (C_Include x1) d cs = ($!!) (\y1 d cs -> cont (C_Include y1) d cs)
    x1 d cs
  ($!!) cont (C_Pool x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Pool y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_Decl cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Decl cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Decl cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_Decl cd info) _ _ = failCons cd info
  ($##) cont (C_Rule x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Rule y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_Edge x1 x2 x3 x4 x5 x6 x7) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> ($##) (\y3 d cs -> ($##) (\y4 d cs -> ($##) (\y5 d cs -> ($##)
    (\y6 d cs -> ($##) (\y7 d cs -> cont (C_Edge y1 y2 y3 y4 y5 y6 y7) d cs) x7
    d cs) x6 d cs) x5 d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (C_Var x1) d cs = ($##) (\y1 d cs -> cont (C_Var y1) d cs) x1 d cs
  ($##) cont (C_Default x1) d cs = ($##) (\y1 d cs -> cont (C_Default y1) d cs)
    x1 d cs
  ($##) cont (C_Subninja x1) d cs = ($##) (\y1 d cs -> cont (C_Subninja y1) d
    cs) x1 d cs
  ($##) cont (C_Include x1) d cs = ($##) (\y1 d cs -> cont (C_Include y1) d cs)
    x1 d cs
  ($##) cont (C_Pool x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Pool y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_Decl cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Decl cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Decl cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_Decl cd info) _ _ = failCons cd info
  showCons (C_Rule _ _) = "Ninja.Types.Rule _ _"
  showCons (C_Edge _ _ _ _ _ _ _) = "Ninja.Types.Edge _ _ _ _ _ _ _"
  showCons (C_Var _) = "Ninja.Types.Var _"
  showCons (C_Default _) = "Ninja.Types.Default _"
  showCons (C_Subninja _) = "Ninja.Types.Subninja _"
  showCons (C_Include _) = "Ninja.Types.Include _"
  showCons (C_Pool _ _) = "Ninja.Types.Pool _ _"
  showCons x = error ("Ninja.Types.Decl.showCons: no constructor: " ++ show x)
  searchNF search cont (C_Rule x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Rule y1 y2)) x2) x1
  searchNF search cont (C_Edge x1 x2 x3 x4 x5 x6 x7) = search (\y1 -> search
    (\y2 -> search (\y3 -> search (\y4 -> search (\y5 -> search (\y6 -> search
    (\y7 -> cont (C_Edge y1 y2 y3 y4 y5 y6 y7)) x7) x6) x5) x4) x3) x2) x1
  searchNF search cont (C_Var x1) = search (\y1 -> cont (C_Var y1)) x1
  searchNF search cont (C_Default x1) = search (\y1 -> cont (C_Default y1)) x1
  searchNF search cont (C_Subninja x1) = search (\y1 -> cont (C_Subninja y1)) x1
  searchNF search cont (C_Include x1) = search (\y1 -> cont (C_Include y1)) x1
  searchNF search cont (C_Pool x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Pool y1 y2)) x2) x1
  searchNF _ _ x = error ("Ninja.Types.Decl.searchNF: no constructor: " ++ show
    x)

instance Unifiable C_Decl where
  (=.=) (C_Rule x1 x2) (C_Rule y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2
    d cs) d cs
  (=.=) (C_Edge x1 x2 x3 x4 x5 x6 x7) (C_Edge y1 y2 y3 y4 y5 y6 y7) d cs = (&)
    ((=:=) x1 y1 d cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((&)
    ((=:=) x4 y4 d cs) ((&) ((=:=) x5 y5 d cs) ((&) ((=:=) x6 y6 d cs) ((=:=) x7
    y7 d cs) d cs) d cs) d cs) d cs) d cs) d cs
  (=.=) (C_Var x1) (C_Var y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Default x1) (C_Default y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Subninja x1) (C_Subninja y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Include x1) (C_Include y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Pool x1 x2) (C_Pool y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2
    d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Rule x1 x2) (C_Rule y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=) x2
    y2 d cs) d cs
  (=.<=) (C_Edge x1 x2 x3 x4 x5 x6 x7) (C_Edge y1 y2 y3 y4 y5 y6 y7) d cs = (&)
    ((=:<=) x1 y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs) ((&)
    ((=:<=) x4 y4 d cs) ((&) ((=:<=) x5 y5 d cs) ((&) ((=:<=) x6 y6 d cs)
    ((=:<=) x7 y7 d cs) d cs) d cs) d cs) d cs) d cs) d cs
  (=.<=) (C_Var x1) (C_Var y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Default x1) (C_Default y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Subninja x1) (C_Subninja y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Include x1) (C_Include y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Pool x1 x2) (C_Pool y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=) x2
    y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Rule x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID i) x3
    , bind cd (rightID i) x4]
  bind cd i (C_Edge x3 x4 x5 x6 x7 x8 x9) = (i :=: ChooseN 1 7) : concat [bind
    cd (leftID (leftID (leftID i))) x3, bind cd (rightID (leftID (leftID i))) x4
    , bind cd (leftID (rightID (leftID i))) x5, bind cd (rightID (rightID
    (leftID i))) x6, bind cd (leftID (leftID (rightID i))) x7, bind cd (rightID
    (leftID (rightID i))) x8, bind cd (rightID (rightID i)) x9]
  bind cd i (C_Var x3) = (i :=: ChooseN 2 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_Default x3) = (i :=: ChooseN 3 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_Subninja x3) = (i :=: ChooseN 4 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_Include x3) = (i :=: ChooseN 5 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_Pool x3 x4) = (i :=: ChooseN 6 2) : concat [bind cd (leftID i) x3
    , bind cd (rightID i) x4]
  bind d i (Choice_C_Decl cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_Decl cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Decl cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Decl cd i _) = error
    ("Ninja.Types.Decl.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Decl cd info) = [Unsolvable info]
  bind d i (Guard_C_Decl cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Rule x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (C_Edge x3 x4 x5 x6 x7 x8 x9) = (i :=: ChooseN 1 7) : [leftID
    (leftID (leftID i)) :=: LazyBind (lazyBind cd (leftID (leftID (leftID i)))
    x3), rightID (leftID (leftID i)) :=: LazyBind (lazyBind cd (rightID (leftID
    (leftID i))) x4), leftID (rightID (leftID i)) :=: LazyBind (lazyBind cd
    (leftID (rightID (leftID i))) x5), rightID (rightID (leftID i)) :=: LazyBind
    (lazyBind cd (rightID (rightID (leftID i))) x6), leftID (leftID (rightID
    i)) :=: LazyBind (lazyBind cd (leftID (leftID (rightID i))) x7), rightID
    (leftID (rightID i)) :=: LazyBind (lazyBind cd (rightID (leftID (rightID
    i))) x8), rightID (rightID i) :=: LazyBind (lazyBind cd (rightID (rightID
    i)) x9)]
  lazyBind cd i (C_Var x3) = (i :=: ChooseN 2 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Default x3) = (i :=: ChooseN 3 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Subninja x3) = (i :=: ChooseN 4 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Include x3) = (i :=: ChooseN 5 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Pool x3 x4) = (i :=: ChooseN 6 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind d i (Choice_C_Decl cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Decl cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j
    xs
  lazyBind d i (Choices_C_Decl cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Decl cd i _) = error
    ("Ninja.Types.Decl.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Decl cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Decl cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Decl where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_File_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_File
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_File_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_File_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_File_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_File_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_File_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_File_hash z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_File_hash e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Ninja.Types._inst#Prelude.Data#Ninja.Types.File#" [show x1] info)
  _ -> failCons cd (consFail "Ninja.Types._inst#Prelude.Data#Ninja.Types.File#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_File_hash :: C_File
  -> C_File -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_File_hash x1 x2 s cd cs =
  case x1 of
  C_File x3 -> let s0 = s in s0 `seq` nd_C__case_7 x3 x2 s0 cd cs
  Choice_C_File d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_File_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_File_hash
    r x2 s cd cs)
  Choices_C_File d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_File_hash
    z x2 s cd cs) xs
  Guard_C_File d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_File_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_File d info -> failCons d (traceFail
    "Ninja.Types._impl#===#Prelude.Data#Ninja.Types.File#" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "Ninja.Types._impl#===#Prelude.Data#Ninja.Types.File#" (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_File_hash :: IDSupply
  -> Cover -> ConstStore -> C_File
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_File_hash s cd cs =
  let s0 = s
  in s0 `seq` C_File
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash) s0
  cd cs)

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Decl
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Ninja.Types._inst#Prelude.Data#Ninja.Types.Decl#" [show x1] info)
  _ -> failCons cd (consFail "Ninja.Types._inst#Prelude.Data#Ninja.Types.Decl#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash :: C_Decl
  -> C_Decl -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash x1 x2 s cd cs =
  case x1 of
  C_Rule x3 x4 -> let s0 = s in s0 `seq` nd_C__case_6 x4 x3 x2 s0 cd cs
  C_Edge x20 x21 x22 x23 x24 x25 x26 -> let s0 = s
    in s0 `seq` nd_C__case_5 x26 x25 x24 x23 x22 x21 x20 x2 s0 cd cs
  C_Var x42 -> let s0 = s in s0 `seq` nd_C__case_4 x42 x2 s0 cd cs
  C_Default x58 -> let s0 = s in s0 `seq` nd_C__case_3 x58 x2 s0 cd cs
  C_Subninja x74 -> let s0 = s in s0 `seq` nd_C__case_2 x74 x2 s0 cd cs
  C_Include x90 -> let s0 = s in s0 `seq` nd_C__case_1 x90 x2 s0 cd cs
  C_Pool x106 x107 -> let s0 = s in s0 `seq` nd_C__case_0 x107 x106 x2 s0 cd cs
  Choice_C_Decl d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash
    r x2 s cd cs)
  Choices_C_Decl d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash
    z x2 s cd cs) xs
  Guard_C_Decl d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_Decl d info -> failCons d (traceFail
    "Ninja.Types._impl#===#Prelude.Data#Ninja.Types.Decl#" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "Ninja.Types._impl#===#Prelude.Data#Ninja.Types.Decl#" (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash :: IDSupply
  -> Cover -> ConstStore -> C_Decl
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash s cd cs =
  let s39 = s
  in s39 `seq` (let s38 = leftSupply s39
                    s40 = rightSupply s39
                    s33 = leftSupply s40
                    s37 = rightSupply s40
  in s38 `seq` (s40 `seq` (s33 `seq` (s37 `seq` choice (let s32 = leftSupply s33
                                                            s34 = rightSupply
                                                              s33
                                                            s29 = leftSupply s34
                                                            s31 = rightSupply
                                                              s34
  in s32 `seq` (s34 `seq` (s29 `seq` (s31 `seq` choice (let s28 = leftSupply s29
                                                            s30 = rightSupply
                                                              s29
                                                            s25 = leftSupply s30
                                                            s27 = rightSupply
                                                              s30
  in s28 `seq` (s30 `seq` (s25 `seq` (s27 `seq` choice (let s24 = leftSupply s25
                                                            s26 = rightSupply
                                                              s25
                                                            s21 = leftSupply s26
                                                            s23 = rightSupply
                                                              s26
  in s24 `seq` (s26 `seq` (s21 `seq` (s23 `seq` choice (let s20 = leftSupply s21
                                                            s22 = rightSupply
                                                              s21
                                                            s17 = leftSupply s22
                                                            s19 = rightSupply
                                                              s22
  in s20 `seq` (s22 `seq` (s17 `seq` (s19 `seq` choice (let s16 = leftSupply s17
                                                            s18 = rightSupply
                                                              s17
                                                            s2 = leftSupply s18
                                                            s10 = rightSupply
                                                              s18
  in s16 `seq` (s18 `seq` (s2 `seq` (s10 `seq` choice (let s0 = leftSupply s2
                                                           s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_Rule
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  s1 cd cs))) (let s11 = leftSupply s10
                   s13 = rightSupply s10
                   s3 = leftSupply s11
                   s12 = rightSupply s11
                   s4 = leftSupply s12
                   s5 = rightSupply s12
                   s14 = leftSupply s13
                   s15 = rightSupply s13
                   s6 = leftSupply s14
                   s7 = rightSupply s14
                   s8 = leftSupply s15
                   s9 = rightSupply s15
  in s11 `seq` (s13 `seq` (s3 `seq` (s12 `seq` (s4 `seq` (s5 `seq` (s14 `seq`
  (s15 `seq` (s6 `seq` (s7 `seq` (s8 `seq` (s9 `seq` C_Edge
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s3 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s4 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s5 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s6 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s7 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s8 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  s9 cd cs))))))))))))) s16 cd cs)))) (C_Var
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s19 cd cs)) s20 cd cs)))) (C_Default
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s23 cd cs)) s24 cd cs)))) (C_Subninja
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s27 cd cs)) s28 cd cs)))) (C_Include
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s31 cd cs)) s32 cd cs)))) (let s35 = leftSupply s37
                                 s36 = rightSupply s37
  in s35 `seq` (s36 `seq` C_Pool
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s35 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
  s36 cd cs))) s38 cd cs))))

nd_C__case_7 :: Curry_Prelude.OP_List C_Decl -> C_File -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_7 x3 x2 s cd cs = case x2 of
  C_File x4 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Ninja_dot_Types_dot_Decl_hash)
    x3 x4 s0 cd cs
  Choice_C_File d i l r -> narrow d i (nd_C__case_7 x3 l s cd cs) (nd_C__case_7
    x3 r s cd cs)
  Choices_C_File d i xs -> narrows cs d i (\z -> nd_C__case_7 x3 z s cd cs) xs
  Guard_C_File d c e -> guardCons d c ((\x -> nd_C__case_7 x3 e s cd x) $! addCs
    c cs)
  Fail_C_File d info -> failCons d (traceFail "Ninja.Types._case_7" [show x3
    , show x2] info)
  _ -> failCons cd (consFail "Ninja.Types._case_7" (showCons x2))

nd_C__case_0 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Decl
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_0 x107 x106 x2 s cd cs = case x2 of
  C_Rule x108 x109 -> Curry_Prelude.C_False
  C_Edge x110 x111 x112 x113 x114 x115 x116 -> Curry_Prelude.C_False
  C_Var x117 -> Curry_Prelude.C_False
  C_Default x118 -> Curry_Prelude.C_False
  C_Subninja x119 -> Curry_Prelude.C_False
  C_Include x120 -> Curry_Prelude.C_False
  C_Pool x121 x122 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x106 x121 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
    x107 x122 s1 cd cs) cd cs))
  Choice_C_Decl d i l r -> narrow d i (nd_C__case_0 x107 x106 l s cd cs)
    (nd_C__case_0 x107 x106 r s cd cs)
  Choices_C_Decl d i xs -> narrows cs d i (\z -> nd_C__case_0 x107 x106 z s cd
    cs) xs
  Guard_C_Decl d c e -> guardCons d c ((\x -> nd_C__case_0 x107 x106 e s cd
    x) $! addCs c cs)
  Fail_C_Decl d info -> failCons d (traceFail "Ninja.Types._case_0" [show x107
    , show x106, show x2] info)
  _ -> failCons cd (consFail "Ninja.Types._case_0" (showCons x2))

nd_C__case_1 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Decl -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_1 x90 x2 s cd cs = case x2 of
  C_Rule x91 x92 -> Curry_Prelude.C_False
  C_Edge x93 x94 x95 x96 x97 x98 x99 -> Curry_Prelude.C_False
  C_Var x100 -> Curry_Prelude.C_False
  C_Default x101 -> Curry_Prelude.C_False
  C_Subninja x102 -> Curry_Prelude.C_False
  C_Include x103 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x90 x103 s0 cd cs
  C_Pool x104 x105 -> Curry_Prelude.C_False
  Choice_C_Decl d i l r -> narrow d i (nd_C__case_1 x90 l s cd cs) (nd_C__case_1
    x90 r s cd cs)
  Choices_C_Decl d i xs -> narrows cs d i (\z -> nd_C__case_1 x90 z s cd cs) xs
  Guard_C_Decl d c e -> guardCons d c ((\x -> nd_C__case_1 x90 e s cd x) $!
    addCs c cs)
  Fail_C_Decl d info -> failCons d (traceFail "Ninja.Types._case_1" [show x90
    , show x2] info)
  _ -> failCons cd (consFail "Ninja.Types._case_1" (showCons x2))

nd_C__case_2 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Decl -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_2 x74 x2 s cd cs = case x2 of
  C_Rule x75 x76 -> Curry_Prelude.C_False
  C_Edge x77 x78 x79 x80 x81 x82 x83 -> Curry_Prelude.C_False
  C_Var x84 -> Curry_Prelude.C_False
  C_Default x85 -> Curry_Prelude.C_False
  C_Subninja x86 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x74 x86 s0 cd cs
  C_Include x87 -> Curry_Prelude.C_False
  C_Pool x88 x89 -> Curry_Prelude.C_False
  Choice_C_Decl d i l r -> narrow d i (nd_C__case_2 x74 l s cd cs) (nd_C__case_2
    x74 r s cd cs)
  Choices_C_Decl d i xs -> narrows cs d i (\z -> nd_C__case_2 x74 z s cd cs) xs
  Guard_C_Decl d c e -> guardCons d c ((\x -> nd_C__case_2 x74 e s cd x) $!
    addCs c cs)
  Fail_C_Decl d info -> failCons d (traceFail "Ninja.Types._case_2" [show x74
    , show x2] info)
  _ -> failCons cd (consFail "Ninja.Types._case_2" (showCons x2))

nd_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Decl -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_3 x58 x2 s cd cs = case x2 of
  C_Rule x59 x60 -> Curry_Prelude.C_False
  C_Edge x61 x62 x63 x64 x65 x66 x67 -> Curry_Prelude.C_False
  C_Var x68 -> Curry_Prelude.C_False
  C_Default x69 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x58 x69 s0 cd cs
  C_Subninja x70 -> Curry_Prelude.C_False
  C_Include x71 -> Curry_Prelude.C_False
  C_Pool x72 x73 -> Curry_Prelude.C_False
  Choice_C_Decl d i l r -> narrow d i (nd_C__case_3 x58 l s cd cs) (nd_C__case_3
    x58 r s cd cs)
  Choices_C_Decl d i xs -> narrows cs d i (\z -> nd_C__case_3 x58 z s cd cs) xs
  Guard_C_Decl d c e -> guardCons d c ((\x -> nd_C__case_3 x58 e s cd x) $!
    addCs c cs)
  Fail_C_Decl d info -> failCons d (traceFail "Ninja.Types._case_3" [show x58
    , show x2] info)
  _ -> failCons cd (consFail "Ninja.Types._case_3" (showCons x2))

nd_C__case_4 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Decl
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_4 x42 x2 s cd cs = case x2 of
  C_Rule x43 x44 -> Curry_Prelude.C_False
  C_Edge x45 x46 x47 x48 x49 x50 x51 -> Curry_Prelude.C_False
  C_Var x52 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    x42 x52 s0 cd cs
  C_Default x53 -> Curry_Prelude.C_False
  C_Subninja x54 -> Curry_Prelude.C_False
  C_Include x55 -> Curry_Prelude.C_False
  C_Pool x56 x57 -> Curry_Prelude.C_False
  Choice_C_Decl d i l r -> narrow d i (nd_C__case_4 x42 l s cd cs) (nd_C__case_4
    x42 r s cd cs)
  Choices_C_Decl d i xs -> narrows cs d i (\z -> nd_C__case_4 x42 z s cd cs) xs
  Guard_C_Decl d c e -> guardCons d c ((\x -> nd_C__case_4 x42 e s cd x) $!
    addCs c cs)
  Fail_C_Decl d info -> failCons d (traceFail "Ninja.Types._case_4" [show x42
    , show x2] info)
  _ -> failCons cd (consFail "Ninja.Types._case_4" (showCons x2))

nd_C__case_5 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Decl
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_5 x26 x25 x24 x23 x22 x21 x20 x2 s cd cs = case x2 of
  C_Rule x27 x28 -> Curry_Prelude.C_False
  C_Edge x29 x30 x31 x32 x33 x34 x35 -> let s12 = s
    in s12 `seq` (let s10 = leftSupply s12
                      s11 = rightSupply s12
    in s10 `seq` (s11 `seq` Curry_Prelude.d_OP_amp_amp (let s8 = leftSupply s10
                                                            s9 = rightSupply s10
    in s8 `seq` (s9 `seq` Curry_Prelude.d_OP_amp_amp (let s6 = leftSupply s8
                                                          s7 = rightSupply s8
    in s6 `seq` (s7 `seq` Curry_Prelude.d_OP_amp_amp (let s4 = leftSupply s6
                                                          s5 = rightSupply s6
    in s4 `seq` (s5 `seq` Curry_Prelude.d_OP_amp_amp (let s2 = leftSupply s4
                                                          s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x20 x29 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    x21 x30 s1 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    x22 x31 s3 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    x23 x32 s5 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    x24 x33 s7 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    x25 x34 s9 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
    x26 x35 s11 cd cs) cd cs))
  C_Var x36 -> Curry_Prelude.C_False
  C_Default x37 -> Curry_Prelude.C_False
  C_Subninja x38 -> Curry_Prelude.C_False
  C_Include x39 -> Curry_Prelude.C_False
  C_Pool x40 x41 -> Curry_Prelude.C_False
  Choice_C_Decl d i l r -> narrow d i (nd_C__case_5 x26 x25 x24 x23 x22 x21 x20
    l s cd cs) (nd_C__case_5 x26 x25 x24 x23 x22 x21 x20 r s cd cs)
  Choices_C_Decl d i xs -> narrows cs d i (\z -> nd_C__case_5 x26 x25 x24 x23
    x22 x21 x20 z s cd cs) xs
  Guard_C_Decl d c e -> guardCons d c ((\x -> nd_C__case_5 x26 x25 x24 x23 x22
    x21 x20 e s cd x) $! addCs c cs)
  Fail_C_Decl d info -> failCons d (traceFail "Ninja.Types._case_5" [show x26
    , show x25, show x24, show x23, show x22, show x21, show x20, show x2] info)
  _ -> failCons cd (consFail "Ninja.Types._case_5" (showCons x2))

nd_C__case_6 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Decl
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_6 x4 x3 x2 s cd cs = case x2 of
  C_Rule x5 x6 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x5 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))
    x4 x6 s1 cd cs) cd cs))
  C_Edge x7 x8 x9 x10 x11 x12 x13 -> Curry_Prelude.C_False
  C_Var x14 -> Curry_Prelude.C_False
  C_Default x15 -> Curry_Prelude.C_False
  C_Subninja x16 -> Curry_Prelude.C_False
  C_Include x17 -> Curry_Prelude.C_False
  C_Pool x18 x19 -> Curry_Prelude.C_False
  Choice_C_Decl d i l r -> narrow d i (nd_C__case_6 x4 x3 l s cd cs)
    (nd_C__case_6 x4 x3 r s cd cs)
  Choices_C_Decl d i xs -> narrows cs d i (\z -> nd_C__case_6 x4 x3 z s cd cs)
    xs
  Guard_C_Decl d c e -> guardCons d c ((\x -> nd_C__case_6 x4 x3 e s cd x) $!
    addCs c cs)
  Fail_C_Decl d info -> failCons d (traceFail "Ninja.Types._case_6" [show x4
    , show x3, show x2] info)
  _ -> failCons cd (consFail "Ninja.Types._case_6" (showCons x2))

