{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Data.Curry_Nat
  ( C_Nat (..)
  , d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash
  , d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash
  , d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash
  , d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash
  , d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash
  , d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash
  , d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash
  , nd_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash
  , d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash
  , nd_OP_uscore_impl_hash_negate_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash
  , d_OP_uscore_impl_hash_abs_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash
  , d_OP_uscore_impl_hash_signum_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash
  , d_OP_uscore_impl_hash_fromInt_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash
  , d_C_fromNat
  , d_C_toNat
  , d_C_add
  , nd_C_sub
  , d_C_mul
  , d_C_leq )
  where

import Basics
import qualified Curry_Prelude
import qualified Test.Curry_Prop
import qualified Test.Prop.Curry_Types


data C_Nat
  = C_Z
  | C_S C_Nat
  | Choice_C_Nat Cover ID C_Nat C_Nat
  | Choices_C_Nat Cover ID [C_Nat]
  | Fail_C_Nat Cover FailInfo
  | Guard_C_Nat Cover Constraints C_Nat

instance Show C_Nat where
  showsPrec d (Choice_C_Nat cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Nat cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Nat cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Nat cd info) = showChar '!'
  showsPrec _ C_Z = showString "Z"
  showsPrec _ (C_S x1) = showString "(S" . (showChar ' ' . (shows x1 . showChar
    ')'))

instance Read C_Nat where
  readsPrec d s = readParen False (\r -> [(C_Z, r0) | (_, r0) <- readQualified
    "Data.Nat" "Z" r]) s ++ readParen ((>) d 10) (\r -> [(C_S x1, r1) | (_, r0)
    <- readQualified "Data.Nat" "S" r, (x1, r1) <- readsPrec 11 r0]) s

instance NonDet C_Nat where
  choiceCons = Choice_C_Nat
  choicesCons = Choices_C_Nat
  failCons = Fail_C_Nat
  guardCons = Guard_C_Nat
  try (Choice_C_Nat cd i x y) = tryChoice cd i x y
  try (Choices_C_Nat cd i xs) = tryChoices cd i xs
  try (Fail_C_Nat cd info) = Fail cd info
  try (Guard_C_Nat cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Nat cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Nat cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Nat cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Nat cd i _) = error
    ("Data.Nat.Nat.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Nat cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Nat cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Nat where
  generate s c = Choices_C_Nat c (freeID [0, 1] s) [C_Z, C_S (generate
    (leftSupply s) c)]

instance NormalForm C_Nat where
  ($!!) cont C_Z d cs = cont C_Z d cs
  ($!!) cont (C_S x1) d cs = ($!!) (\y1 d cs -> cont (C_S y1) d cs) x1 d cs
  ($!!) cont (Choice_C_Nat cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Nat cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Nat cd c e) d cs = guardCons cd c (($!!) cont e d (addCs c
    cs))
  ($!!) _ (Fail_C_Nat cd info) _ _ = failCons cd info
  ($##) cont C_Z d cs = cont C_Z d cs
  ($##) cont (C_S x1) d cs = ($##) (\y1 d cs -> cont (C_S y1) d cs) x1 d cs
  ($##) cont (Choice_C_Nat cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Nat cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Nat cd c e) d cs = guardCons cd c (($##) cont e d (addCs c
    cs))
  ($##) _ (Fail_C_Nat cd info) _ _ = failCons cd info
  showCons C_Z = "Data.Nat.Z"
  showCons (C_S _) = "Data.Nat.S _"
  showCons x = error ("Data.Nat.Nat.showCons: no constructor: " ++ show x)
  searchNF _ cont C_Z = cont C_Z
  searchNF search cont (C_S x1) = search (\y1 -> cont (C_S y1)) x1
  searchNF _ _ x = error ("Data.Nat.Nat.searchNF: no constructor: " ++ show x)

instance Unifiable C_Nat where
  (=.=) C_Z C_Z d cs = C_True
  (=.=) (C_S x1) (C_S y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_Z C_Z d cs = C_True
  (=.<=) (C_S x1) (C_S y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_Z = (i :=: ChooseN 0 0) : concat []
  bind cd i (C_S x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID i) x3]
  bind d i (Choice_C_Nat cd j x y) = [ConstraintChoice cd j (bind d i x) (bind d
    i y)]
  bind d i (Choices_C_Nat cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Nat cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Nat cd i _) = error
    ("Data.Nat.Nat.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Nat cd info) = [Unsolvable info]
  bind d i (Guard_C_Nat cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_Z = (i :=: ChooseN 0 0) : []
  lazyBind cd i (C_S x3) = (i :=: ChooseN 1 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_Nat cd j x y) = [ConstraintChoice cd j (lazyBind d i x)
    (lazyBind d i y)]
  lazyBind d i (Choices_C_Nat cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j
    xs
  lazyBind d i (Choices_C_Nat cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Nat cd i _) = error
    ("Data.Nat.Nat.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Nat cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Nat cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Nat where

d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show C_Nat
d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Show
    d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash
    cd cs)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash l cd
    cs) (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash r
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash z cd
    cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Nat._inst#Prelude.Show#Data.Nat.Nat#" [show x1] info)
  _ -> failCons cd (consFail "Data.Nat._inst#Prelude.Show#Data.Nat.Nat#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  C_Nat
nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Show (wrapDX id
    d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash)
    (wrapDX (wrapDX (wrapDX id))
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash
    cd cs)) (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash l s
    cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash r s
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Nat._inst#Prelude.Show#Data.Nat.Nat#" [show x1] info)
  _ -> failCons cd (consFail "Data.Nat._inst#Prelude.Show#Data.Nat.Nat#"
    (showCons x1))

d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash :: C_Nat
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash x1 cd cs =
  Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs) (d_C_fromNat x1 cd cs) cd cs

d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash :: Cover
  -> ConstStore -> Curry_Prelude.C_Int -> Cover -> ConstStore -> C_Nat -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash cd cs =
  acceptCs (acceptCs id)
  (Curry_Prelude.d_OP_uscore_def_hash_showsPrec_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash)

d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Nat -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash cd cs

d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read C_Nat
d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Read (acceptCs id
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash)
    (d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash l cd
    cs) (d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash r
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash z cd
    cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Nat._inst#Prelude.Read#Data.Nat.Nat#" [show x1] info)
  _ -> failCons cd (consFail "Data.Nat._inst#Prelude.Read#Data.Nat.Nat#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read
  C_Nat
nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Read (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash))
    (wrapDX id
    (d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash l s
    cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash r s
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Nat._inst#Prelude.Read#Data.Nat.Nat#" [show x1] info)
  _ -> failCons cd (consFail "Data.Nat._inst#Prelude.Read#Data.Nat.Nat#"
    (showCons x1))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash :: Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Nat (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash x1 x2 cd cs =
  Curry_Prelude.d_C_map
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash_dot_uscore_hash_lambda1
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Prelude_dot_Int_hash
  x1 cd cs) x2 cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 C_Nat (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash_dot_uscore_hash_lambda1 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.OP_Tuple2 (d_C_toNat x2 cd cs)
    x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash_dot_uscore_hash_lambda1
    l cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash_dot_uscore_hash_lambda1
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash_dot_uscore_hash_lambda1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash_dot_uscore_hash_lambda1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Nat._impl#readsPrec#Prelude.Read#Data.Nat.Nat#._#lambda1" [show x1]
    info)
  _ -> failCons cd (consFail
    "Data.Nat._impl#readsPrec#Prelude.Read#Data.Nat.Nat#._#lambda1" (showCons
    x1))

d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List C_Nat) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_readList_hash_Prelude_dot_Read
  d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Nat_dot_Nat_hash cd cs

nd_OP_uscore_inst_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Num
  C_Nat
nd_OP_uscore_inst_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Num (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash))
    (wrapDX (wrapNX id) (acceptCs id
    nd_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash))
    (wrapDX (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash))
    (wrapNX id
    nd_OP_uscore_impl_hash_negate_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash)
    (wrapDX id
    d_OP_uscore_impl_hash_abs_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash)
    (wrapDX id
    d_OP_uscore_impl_hash_signum_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash)
    (wrapDX id
    d_OP_uscore_impl_hash_fromInt_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash l s
    cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash r s
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash z s cd
    cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Nat._inst#Prelude.Num#Data.Nat.Nat#" [show x1] info)
  _ -> failCons cd (consFail "Data.Nat._inst#Prelude.Num#Data.Nat.Nat#"
    (showCons x1))

d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash :: C_Nat
  -> C_Nat -> Cover -> ConstStore -> C_Nat
d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash x1 x2 cd cs =
  d_C_add x1 x2 cd cs

nd_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash :: C_Nat
  -> C_Nat -> IDSupply -> Cover -> ConstStore -> C_Nat
nd_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash x1 x2 s cd cs =
  let s0 = s in s0 `seq` nd_C_sub x1 x2 s0 cd cs

d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash :: C_Nat
  -> C_Nat -> Cover -> ConstStore -> C_Nat
d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash x1 x2 cd cs =
  d_C_mul x1 x2 cd cs

nd_OP_uscore_impl_hash_negate_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash :: C_Nat
  -> IDSupply -> Cover -> ConstStore -> C_Nat
nd_OP_uscore_impl_hash_negate_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash x1 s cd cs =
  let s0 = s in s0 `seq` nd_C_sub C_Z x1 s0 cd cs

d_OP_uscore_impl_hash_abs_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash :: C_Nat
  -> Cover -> ConstStore -> C_Nat
d_OP_uscore_impl_hash_abs_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash x1 cd cs =
  x1

d_OP_uscore_impl_hash_signum_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash :: C_Nat
  -> Cover -> ConstStore -> C_Nat
d_OP_uscore_impl_hash_signum_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash x1 cd cs =
  case x1 of
  C_Z -> C_Z
  C_S x2 -> C_S C_Z
  Choice_C_Nat d i l r -> narrow d i
    (d_OP_uscore_impl_hash_signum_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash
    l cd cs)
    (d_OP_uscore_impl_hash_signum_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash
    r cd cs)
  Choices_C_Nat d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_signum_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash
    z cd cs) xs
  Guard_C_Nat d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_signum_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash
    e cd x) $! addCs c cs)
  Fail_C_Nat d info -> failCons d (traceFail
    "Data.Nat._impl#signum#Prelude.Num#Data.Nat.Nat#" [show x1] info)
  _ -> failCons cd (consFail "Data.Nat._impl#signum#Prelude.Num#Data.Nat.Nat#"
    (showCons x1))

d_OP_uscore_impl_hash_fromInt_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash :: Curry_Prelude.C_Int
  -> Cover -> ConstStore -> C_Nat
d_OP_uscore_impl_hash_fromInt_hash_Prelude_dot_Num_hash_Data_dot_Nat_dot_Nat_hash x1 cd cs =
  d_C_toNat x1 cd cs

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Nat
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash l s
    cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash r s
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Nat._inst#Prelude.Data#Data.Nat.Nat#" [show x1] info)
  _ -> failCons cd (consFail "Data.Nat._inst#Prelude.Data#Data.Nat.Nat#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash :: C_Nat
  -> C_Nat -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash x1 x2 cd cs =
  case x1 of
  C_Z -> d_C__case_7 x2 cd cs
  C_S x4 -> d_C__case_6 x4 x2 cd cs
  Choice_C_Nat d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash
    r x2 cd cs)
  Choices_C_Nat d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash
    z x2 cd cs) xs
  Guard_C_Nat d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Nat d info -> failCons d (traceFail
    "Data.Nat._impl#===#Prelude.Data#Data.Nat.Nat#" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Nat._impl#===#Prelude.Data#Data.Nat.Nat#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash :: IDSupply
  -> Cover -> ConstStore -> C_Nat
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` choice C_Z (C_S
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash
  s0 cd cs)) s1 cd cs))

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_Nat
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash l cd
    cs) (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash r
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash z cd cs)
    xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Nat._inst#Prelude.Eq#Data.Nat.Nat#" [show x1] info)
  _ -> failCons cd (consFail "Data.Nat._inst#Prelude.Eq#Data.Nat.Nat#" (showCons
    x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_Nat
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash l s cd
    cs) (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash r
    s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash z s cd
    cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Nat._inst#Prelude.Eq#Data.Nat.Nat#" [show x1] info)
  _ -> failCons cd (consFail "Data.Nat._inst#Prelude.Eq#Data.Nat.Nat#" (showCons
    x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash :: C_Nat
  -> C_Nat -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash x1 x2 cd cs =
  case x1 of
  C_Z -> d_C__case_5 x2 cd cs
  C_S x4 -> d_C__case_4 x4 x2 cd cs
  Choice_C_Nat d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash
    r x2 cd cs)
  Choices_C_Nat d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash
    z x2 cd cs) xs
  Guard_C_Nat d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Nat d info -> failCons d (traceFail
    "Data.Nat._impl#==#Prelude.Eq#Data.Nat.Nat#" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Nat._impl#==#Prelude.Eq#Data.Nat.Nat#"
    (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash :: Cover
  -> ConstStore -> C_Nat -> Cover -> ConstStore -> C_Nat -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash)

d_C_fromNat :: C_Nat -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_fromNat x1 cd cs = case x1 of
  C_Z -> Curry_Prelude.C_Int (0)
  C_S x2 -> Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (1)) (d_C_fromNat x2 cd cs) cd cs
  Choice_C_Nat d i l r -> narrow d i (d_C_fromNat l cd cs) (d_C_fromNat r cd cs)
  Choices_C_Nat d i xs -> narrows cs d i (\z -> d_C_fromNat z cd cs) xs
  Guard_C_Nat d c e -> guardCons d c ((\x -> d_C_fromNat e cd x) $! addCs c cs)
  Fail_C_Nat d info -> failCons d (traceFail "Data.Nat.fromNat" [show x1] info)
  _ -> failCons cd (consFail "Data.Nat.fromNat" (showCons x1))

d_C_fromNat'post :: C_Nat -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_fromNat'post x1 x2 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) x2 cd cs) (Curry_Prelude.C_Int (0)) cd cs

d_C_toNat :: Curry_Prelude.C_Int -> Cover -> ConstStore -> C_Nat
d_C_toNat x1 cd cs = d_C__case_3 x1
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  x1 (Curry_Prelude.C_Int (0)) cd cs) cd cs

d_C_toNat'pre :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_toNat'pre x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) x1 cd cs) (Curry_Prelude.C_Int (0)) cd cs

d_C_fromToNat :: C_Nat -> Cover -> ConstStore -> Test.Prop.Curry_Types.C_Prop
d_C_fromToNat x1 cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash
  (d_C_toNat (d_C_fromNat x1 cd cs) cd cs) x1 cd cs

d_C_toFromNat :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_toFromNat x1 cd cs = Test.Curry_Prop.d_OP_eq_eq_gt (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) x1 cd cs) (Curry_Prelude.C_Int (0)) cd cs)
  (Test.Curry_Prop.d_OP_minus_eq_minus
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  (d_C_fromNat (d_C_toNat x1 cd cs) cd cs) x1 cd cs) cd cs

d_C_add :: C_Nat -> C_Nat -> Cover -> ConstStore -> C_Nat
d_C_add x1 x2 cd cs = case x1 of
  C_Z -> x2
  C_S x3 -> C_S (d_C_add x3 x2 cd cs)
  Choice_C_Nat d i l r -> narrow d i (d_C_add l x2 cd cs) (d_C_add r x2 cd cs)
  Choices_C_Nat d i xs -> narrows cs d i (\z -> d_C_add z x2 cd cs) xs
  Guard_C_Nat d c e -> guardCons d c ((\x -> d_C_add e x2 cd x) $! addCs c cs)
  Fail_C_Nat d info -> failCons d (traceFail "Data.Nat.add" [show x1, show x2]
    info)
  _ -> failCons cd (consFail "Data.Nat.add" (showCons x1))

d_C_addIsCommutative :: C_Nat -> C_Nat -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_addIsCommutative x1 x2 cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash (d_C_add
  x1 x2 cd cs) (d_C_add x2 x1 cd cs) cd cs

d_C_addIsAssociative :: C_Nat -> C_Nat -> C_Nat -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_addIsAssociative x1 x2 x3 cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash (d_C_add
  (d_C_add x1 x2 cd cs) x3 cd cs) (d_C_add x1 (d_C_add x2 x3 cd cs) cd cs) cd cs

nd_C_sub :: C_Nat -> C_Nat -> IDSupply -> Cover -> ConstStore -> C_Nat
nd_C_sub x1 x2 s cd cs = let s0 = s
  in s0 `seq` (let x3 = generate s0 cd
  in d_C__case_1 x1 x3 x2
  (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash
  (d_C_add x2 x3 cd cs) x1 cd cs) cd cs)

nd_C_subAddL :: C_Nat -> C_Nat -> IDSupply -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
nd_C_subAddL x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Test.Curry_Prop.nd_OP_minus_eq_minus (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash) (wrapNX
  id nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash)
  (nd_C_sub (d_C_add x1 x2 cd cs) x1 s0 cd cs) x2 s1 cd cs))

nd_C_subAddR :: C_Nat -> C_Nat -> IDSupply -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
nd_C_subAddR x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Test.Curry_Prop.nd_OP_minus_eq_minus (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash) (wrapNX
  id nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash)
  (nd_C_sub (d_C_add x1 x2 cd cs) x2 s0 cd cs) x1 s1 cd cs))

d_C_mul :: C_Nat -> C_Nat -> Cover -> ConstStore -> C_Nat
d_C_mul x1 x2 cd cs = case x1 of
  C_Z -> C_Z
  C_S x3 -> d_C_add x2 (d_C_mul x3 x2 cd cs) cd cs
  Choice_C_Nat d i l r -> narrow d i (d_C_mul l x2 cd cs) (d_C_mul r x2 cd cs)
  Choices_C_Nat d i xs -> narrows cs d i (\z -> d_C_mul z x2 cd cs) xs
  Guard_C_Nat d c e -> guardCons d c ((\x -> d_C_mul e x2 cd x) $! addCs c cs)
  Fail_C_Nat d info -> failCons d (traceFail "Data.Nat.mul" [show x1, show x2]
    info)
  _ -> failCons cd (consFail "Data.Nat.mul" (showCons x1))

d_C_mulIsCommutative :: C_Nat -> C_Nat -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_mulIsCommutative x1 x2 cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash (d_C_mul
  x1 x2 cd cs) (d_C_mul x2 x1 cd cs) cd cs

d_C_mulIsAssociative :: C_Nat -> C_Nat -> C_Nat -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_mulIsAssociative x1 x2 x3 cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash (d_C_mul
  (d_C_mul x1 x2 cd cs) x3 cd cs) (d_C_mul x1 (d_C_mul x2 x3 cd cs) cd cs) cd cs

d_C_distMulAddL :: C_Nat -> C_Nat -> C_Nat -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_distMulAddL x1 x2 x3 cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash (d_C_mul
  x1 (d_C_add x2 x3 cd cs) cd cs) (d_C_add (d_C_mul x1 x2 cd cs) (d_C_mul x1 x3
  cd cs) cd cs) cd cs

d_C_distMulAddR :: C_Nat -> C_Nat -> C_Nat -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_distMulAddR x1 x2 x3 cd cs = Test.Curry_Prop.d_OP_minus_eq_minus
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Nat_dot_Nat_hash (d_C_mul
  (d_C_add x2 x3 cd cs) x1 cd cs) (d_C_add (d_C_mul x2 x1 cd cs) (d_C_mul x3 x1
  cd cs) cd cs) cd cs

d_C_leq :: C_Nat -> C_Nat -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_leq x1 x2 cd cs = case x1 of
  C_Z -> Curry_Prelude.C_True
  C_S x3 -> d_C__case_0 x3 x2 cd cs
  Choice_C_Nat d i l r -> narrow d i (d_C_leq l x2 cd cs) (d_C_leq r x2 cd cs)
  Choices_C_Nat d i xs -> narrows cs d i (\z -> d_C_leq z x2 cd cs) xs
  Guard_C_Nat d c e -> guardCons d c ((\x -> d_C_leq e x2 cd x) $! addCs c cs)
  Fail_C_Nat d info -> failCons d (traceFail "Data.Nat.leq" [show x1, show x2]
    info)
  _ -> failCons cd (consFail "Data.Nat.leq" (showCons x1))

d_C_leqAdd :: C_Nat -> C_Nat -> Cover -> ConstStore
  -> Test.Prop.Curry_Types.C_Prop
d_C_leqAdd x1 x2 cd cs = Curry_Prelude.d_OP_dollar Test.Curry_Prop.d_C_always
  (d_C_leq x1 (d_C_add x1 x2 cd cs) cd cs) cd cs

d_C__case_6 :: C_Nat -> C_Nat -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_6 x4 x2 cd cs = case x2 of
  C_Z -> Curry_Prelude.C_False
  C_S x5 -> d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Nat_dot_Nat_hash
    x4 x5 cd cs
  Choice_C_Nat d i l r -> narrow d i (d_C__case_6 x4 l cd cs) (d_C__case_6 x4 r
    cd cs)
  Choices_C_Nat d i xs -> narrows cs d i (\z -> d_C__case_6 x4 z cd cs) xs
  Guard_C_Nat d c e -> guardCons d c ((\x -> d_C__case_6 x4 e cd x) $! addCs c
    cs)
  Fail_C_Nat d info -> failCons d (traceFail "Data.Nat._case_6" [show x4, show
    x2] info)
  _ -> failCons cd (consFail "Data.Nat._case_6" (showCons x2))

d_C__case_7 :: C_Nat -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_7 x2 cd cs = case x2 of
  C_Z -> Curry_Prelude.C_True
  C_S x3 -> Curry_Prelude.C_False
  Choice_C_Nat d i l r -> narrow d i (d_C__case_7 l cd cs) (d_C__case_7 r cd cs)
  Choices_C_Nat d i xs -> narrows cs d i (\z -> d_C__case_7 z cd cs) xs
  Guard_C_Nat d c e -> guardCons d c ((\x -> d_C__case_7 e cd x) $! addCs c cs)
  Fail_C_Nat d info -> failCons d (traceFail "Data.Nat._case_7" [show x2] info)
  _ -> failCons cd (consFail "Data.Nat._case_7" (showCons x2))

d_C__case_4 :: C_Nat -> C_Nat -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_4 x4 x2 cd cs = case x2 of
  C_Z -> Curry_Prelude.C_False
  C_S x5 -> d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Nat_dot_Nat_hash
    x4 x5 cd cs
  Choice_C_Nat d i l r -> narrow d i (d_C__case_4 x4 l cd cs) (d_C__case_4 x4 r
    cd cs)
  Choices_C_Nat d i xs -> narrows cs d i (\z -> d_C__case_4 x4 z cd cs) xs
  Guard_C_Nat d c e -> guardCons d c ((\x -> d_C__case_4 x4 e cd x) $! addCs c
    cs)
  Fail_C_Nat d info -> failCons d (traceFail "Data.Nat._case_4" [show x4, show
    x2] info)
  _ -> failCons cd (consFail "Data.Nat._case_4" (showCons x2))

d_C__case_5 :: C_Nat -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_5 x2 cd cs = case x2 of
  C_Z -> Curry_Prelude.C_True
  C_S x3 -> Curry_Prelude.C_False
  Choice_C_Nat d i l r -> narrow d i (d_C__case_5 l cd cs) (d_C__case_5 r cd cs)
  Choices_C_Nat d i xs -> narrows cs d i (\z -> d_C__case_5 z cd cs) xs
  Guard_C_Nat d c e -> guardCons d c ((\x -> d_C__case_5 e cd x) $! addCs c cs)
  Fail_C_Nat d info -> failCons d (traceFail "Data.Nat._case_5" [show x2] info)
  _ -> failCons cd (consFail "Data.Nat._case_5" (showCons x2))

d_C__case_3 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Nat
d_C__case_3 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> C_Z
  Curry_Prelude.C_False -> d_C__case_2 x1 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x1 cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x1 l cd cs)
    (d_C__case_3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Nat._case_3"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Nat._case_3" (showCons x2))

d_C__case_2 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Nat
d_C__case_2 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> C_S (d_C_toNat
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 (Curry_Prelude.C_Int (1)) cd cs) cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x1 l cd cs)
    (d_C__case_2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Nat._case_2"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Nat._case_2" (showCons x2))

d_C__case_1 :: C_Nat -> C_Nat -> C_Nat -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Nat
d_C__case_1 x1 x3 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> x3
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x1 x3 x2 l cd
    cs) (d_C__case_1 x1 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x1 x3
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x1 x3 x2
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Nat._case_1"
    [show x1, show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "Data.Nat._case_1" (showCons x4))

d_C__case_0 :: C_Nat -> C_Nat -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_0 x3 x2 cd cs = case x2 of
  C_Z -> Curry_Prelude.C_False
  C_S x4 -> d_C_leq x3 x4 cd cs
  Choice_C_Nat d i l r -> narrow d i (d_C__case_0 x3 l cd cs) (d_C__case_0 x3 r
    cd cs)
  Choices_C_Nat d i xs -> narrows cs d i (\z -> d_C__case_0 x3 z cd cs) xs
  Guard_C_Nat d c e -> guardCons d c ((\x -> d_C__case_0 x3 e cd x) $! addCs c
    cs)
  Fail_C_Nat d info -> failCons d (traceFail "Data.Nat._case_0" [show x3, show
    x2] info)
  _ -> failCons cd (consFail "Data.Nat._case_0" (showCons x2))

