{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Language.Curry.Curry_Plural
  ( C_PluralArg (..), d_C_plural, nd_C_plural )
  where

import Basics
import qualified Curry_Prelude


data C_PluralArg t0
  = C_PluralArg (Curry_Prelude.OP_Unit -> Cover -> ConstStore -> t0)
  | HO_C_PluralArg (Func Curry_Prelude.OP_Unit t0)
  | Choice_C_PluralArg Cover ID (C_PluralArg t0) (C_PluralArg t0)
  | Choices_C_PluralArg Cover ID [C_PluralArg t0]
  | Fail_C_PluralArg Cover FailInfo
  | Guard_C_PluralArg Cover Constraints (C_PluralArg t0)

instance (Curry t0) => Show (C_PluralArg t0) where
  showsPrec d (Choice_C_PluralArg cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_PluralArg cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_PluralArg cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_PluralArg cd info) = showChar '!'
  showsPrec _ (C_PluralArg x1) = showString "(PluralArg" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (HO_C_PluralArg x1) = showString "(PluralArg" . (showChar ' ' .
    (shows x1 . showChar ')'))

instance (Curry t0) => Read (C_PluralArg t0) where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_PluralArg x1, r1) | (_, r0) <-
    readQualified "Language.Curry.Plural" "PluralArg" r, (x1, r1) <- readsPrec
    11 r0]) s

instance NonDet (C_PluralArg t0) where
  choiceCons = Choice_C_PluralArg
  choicesCons = Choices_C_PluralArg
  failCons = Fail_C_PluralArg
  guardCons = Guard_C_PluralArg
  try (Choice_C_PluralArg cd i x y) = tryChoice cd i x y
  try (Choices_C_PluralArg cd i xs) = tryChoices cd i xs
  try (Fail_C_PluralArg cd info) = Fail cd info
  try (Guard_C_PluralArg cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_PluralArg cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_PluralArg cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_PluralArg cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_PluralArg cd i _) = error
    ("Language.Curry.Plural.PluralArg.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_PluralArg cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_PluralArg cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance (Curry t0) => Generable (C_PluralArg t0) where
  generate s c = Choices_C_PluralArg c (freeID [1] s) [HO_C_PluralArg (generate
    (leftSupply s) c)]

instance (Curry t0) => NormalForm (C_PluralArg t0) where
  ($!!) cont (C_PluralArg x1) d cs = ($!!) (\y1 d cs -> cont (C_PluralArg y1) d
    cs) x1 d cs
  ($!!) cont (HO_C_PluralArg x1) d cs = ($!!) (\y1 d cs -> cont (HO_C_PluralArg
    y1) d cs) x1 d cs
  ($!!) cont (Choice_C_PluralArg cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_PluralArg cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_PluralArg cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_PluralArg cd info) _ _ = failCons cd info
  ($##) cont (C_PluralArg x1) d cs = ($##) (\y1 d cs -> cont (C_PluralArg y1) d
    cs) x1 d cs
  ($##) cont (HO_C_PluralArg x1) d cs = ($##) (\y1 d cs -> cont (HO_C_PluralArg
    y1) d cs) x1 d cs
  ($##) cont (Choice_C_PluralArg cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_PluralArg cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_PluralArg cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_PluralArg cd info) _ _ = failCons cd info
  showCons (C_PluralArg _) = "Language.Curry.Plural.PluralArg _"
  showCons (HO_C_PluralArg _) = "Language.Curry.Plural.PluralArg _"
  showCons x = error
    ("Language.Curry.Plural.PluralArg.showCons: no constructor: " ++ show x)
  searchNF search cont (C_PluralArg x1) = search (\y1 -> cont (C_PluralArg y1))
    x1
  searchNF search cont (HO_C_PluralArg x1) = search (\y1 -> cont (HO_C_PluralArg
    y1)) x1
  searchNF _ _ x = error
    ("Language.Curry.Plural.PluralArg.searchNF: no constructor: " ++ show x)

instance (Curry t0) => Unifiable (C_PluralArg t0) where
  (=.=) (C_PluralArg x1) (C_PluralArg y1) d cs = (=:=) x1 y1 d cs
  (=.=) (HO_C_PluralArg x1) (HO_C_PluralArg y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_PluralArg x1) (C_PluralArg y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (HO_C_PluralArg x1) (HO_C_PluralArg y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_PluralArg x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (HO_C_PluralArg x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID
    i) x3]
  bind d i (Choice_C_PluralArg cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_PluralArg cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_PluralArg cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_PluralArg cd i _) = error
    ("Language.Curry.Plural.PluralArg.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_PluralArg cd info) = [Unsolvable info]
  bind d i (Guard_C_PluralArg cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_PluralArg x3) = (i :=: ChooseN 0 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (HO_C_PluralArg x3) = (i :=: ChooseN 0 1) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_PluralArg cd j x y) = [ConstraintChoice cd j (lazyBind
    d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_PluralArg cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_PluralArg cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_PluralArg cd i _) = error
    ("Language.Curry.Plural.PluralArg.lazyBind: Choices with ChoiceID: " ++ show
    i)
  lazyBind _ _ (Fail_C_PluralArg cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_PluralArg cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance (Curry t0) => Curry (C_PluralArg t0) where

d_C_plural :: forall t0 . (Curry_Prelude.Curry t0) => C_PluralArg t0 -> Cover
  -> ConstStore -> t0
d_C_plural x1 cd cs = case x1 of
  C_PluralArg x2 -> Curry_Prelude.d_C_apply x2 Curry_Prelude.OP_Unit cd cs
  Choice_C_PluralArg d i l r -> narrow d i (d_C_plural l cd cs) (d_C_plural r cd
    cs)
  Choices_C_PluralArg d i xs -> narrows cs d i (\z -> d_C_plural z cd cs) xs
  Guard_C_PluralArg d c e -> guardCons d c ((\x -> d_C_plural e cd x) $! addCs c
    cs)
  Fail_C_PluralArg d info -> failCons d (traceFail
    "Language.Curry.Plural.plural" [show x1] info)
  _ -> failCons cd (consFail "Language.Curry.Plural.plural" (showCons x1))

nd_C_plural :: forall t0 . (Curry_Prelude.Curry t0) => C_PluralArg t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_plural x1 s cd cs = case x1 of
  HO_C_PluralArg x2 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x2 Curry_Prelude.OP_Unit s0 cd cs
  Choice_C_PluralArg d i l r -> narrow d i (nd_C_plural l s cd cs) (nd_C_plural
    r s cd cs)
  Choices_C_PluralArg d i xs -> narrows cs d i (\z -> nd_C_plural z s cd cs) xs
  Guard_C_PluralArg d c e -> guardCons d c ((\x -> nd_C_plural e s cd x) $!
    addCs c cs)
  Fail_C_PluralArg d info -> failCons d (traceFail
    "Language.Curry.Plural.plural" [show x1] info)
  _ -> failCons cd (consFail "Language.Curry.Plural.plural" (showCons x1))

