{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Language.Prolog.Curry_Show
  ( d_C_showPlProg
  , d_C_showPlClause
  , d_C_showPlGoals
  , d_C_showPlGoal
  , d_C_showPlTerm )
  where

import Basics
import qualified Data.Curry_List
import qualified Language.Prolog.Curry_Types
import qualified Curry_Prelude


d_C_showPlProg :: Curry_Prelude.OP_List Language.Prolog.Curry_Types.C_PlClause
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showPlProg x1 cd cs = Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_unlines
  cd cs) (Curry_Prelude.d_C_map (Curry_Prelude.d_OP_dot d_C_showPlClause
  d_C_optimizeClause cd cs) x1 cd cs) cd cs

d_C_showPlClause :: Language.Prolog.Curry_Types.C_PlClause -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showPlClause x1 cd cs = case x1 of
  Language.Prolog.Curry_Types.C_PlClause x2 x3 x4 -> d_C__case_23 x3 x2 x4 cd cs
  Language.Prolog.Curry_Types.C_PlDirective x7 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString ":- ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showPlGoals x7 cd cs) (Curry_Prelude.toCurryString ".") cd cs) cd cs
  Language.Prolog.Curry_Types.C_PlQuery x8 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "?- ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showPlGoals x8 cd cs) (Curry_Prelude.toCurryString ".") cd cs) cd cs
  Language.Prolog.Curry_Types.Choice_C_PlClause d i l r -> narrow d i
    (d_C_showPlClause l cd cs) (d_C_showPlClause r cd cs)
  Language.Prolog.Curry_Types.Choices_C_PlClause d i xs -> narrows cs d i (\z ->
    d_C_showPlClause z cd cs) xs
  Language.Prolog.Curry_Types.Guard_C_PlClause d c e -> guardCons d c ((\x ->
    d_C_showPlClause e cd x) $! addCs c cs)
  Language.Prolog.Curry_Types.Fail_C_PlClause d info -> failCons d (traceFail
    "Language.Prolog.Show.showPlClause" [show x1] info)
  _ -> failCons cd (consFail "Language.Prolog.Show.showPlClause" (showCons x1))

d_C_showPlGoals :: Curry_Prelude.OP_List Language.Prolog.Curry_Types.C_PlGoal
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showPlGoals x1 cd cs = Data.Curry_List.d_C_intercalate
  (Curry_Prelude.toCurryString ", ") (Curry_Prelude.d_C_map d_C_showPlGoal x1 cd
  cs) cd cs

d_C_showSimpleGoals :: Curry_Prelude.OP_List
  Language.Prolog.Curry_Types.C_PlGoal -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showSimpleGoals x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.toCurryString "true"
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_22 x1 x2 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_showSimpleGoals l cd
    cs) (d_C_showSimpleGoals r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_showSimpleGoals z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_showSimpleGoals
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Prolog.Show.showSimpleGoals" [show x1] info)
  _ -> failCons cd (consFail "Language.Prolog.Show.showSimpleGoals" (showCons
    x1))

d_C_showPlGoal :: Language.Prolog.Curry_Types.C_PlGoal -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showPlGoal x1 cd cs = case x1 of
  Language.Prolog.Curry_Types.C_PlLit x2 x3 -> d_C__case_21 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.toCurryString "=") cd cs) cd cs
  Language.Prolog.Curry_Types.C_PlNeg x4 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\+") (d_C_showSimpleGoals x4 cd cs) cd cs
  Language.Prolog.Curry_Types.C_PlCond x5 x6 x7 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(") (Curry_Prelude.d_OP_plus_plus
    (d_C_showSimpleGoals x5 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " -> ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showPlGoals x6 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " ; ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showPlGoals x7 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs)
    cd cs) cd cs) cd cs) cd cs
  Language.Prolog.Curry_Types.Choice_C_PlGoal d i l r -> narrow d i
    (d_C_showPlGoal l cd cs) (d_C_showPlGoal r cd cs)
  Language.Prolog.Curry_Types.Choices_C_PlGoal d i xs -> narrows cs d i (\z ->
    d_C_showPlGoal z cd cs) xs
  Language.Prolog.Curry_Types.Guard_C_PlGoal d c e -> guardCons d c ((\x ->
    d_C_showPlGoal e cd x) $! addCs c cs)
  Language.Prolog.Curry_Types.Fail_C_PlGoal d info -> failCons d (traceFail
    "Language.Prolog.Show.showPlGoal" [show x1] info)
  _ -> failCons cd (consFail "Language.Prolog.Show.showPlGoal" (showCons x1))

d_C_showPlTerm :: Language.Prolog.Curry_Types.C_PlTerm -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showPlTerm x1 cd cs = case x1 of
  Language.Prolog.Curry_Types.C_PlVar x2 -> x2
  Language.Prolog.Curry_Types.C_PlAtom x3 -> d_C_showPlAtom x3 cd cs
  Language.Prolog.Curry_Types.C_PlInt x4 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x4 cd cs
  Language.Prolog.Curry_Types.C_PlFloat x5 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Float_hash
    cd cs) x5 cd cs
  Language.Prolog.Curry_Types.C_PlStruct x6 x7 -> d_C__case_18 x6 x7 cd cs
  Language.Prolog.Curry_Types.Choice_C_PlTerm d i l r -> narrow d i
    (d_C_showPlTerm l cd cs) (d_C_showPlTerm r cd cs)
  Language.Prolog.Curry_Types.Choices_C_PlTerm d i xs -> narrows cs d i (\z ->
    d_C_showPlTerm z cd cs) xs
  Language.Prolog.Curry_Types.Guard_C_PlTerm d c e -> guardCons d c ((\x ->
    d_C_showPlTerm e cd x) $! addCs c cs)
  Language.Prolog.Curry_Types.Fail_C_PlTerm d info -> failCons d (traceFail
    "Language.Prolog.Show.showPlTerm" [show x1] info)
  _ -> failCons cd (consFail "Language.Prolog.Show.showPlTerm" (showCons x1))

d_C_showPlListElems :: Language.Prolog.Curry_Types.C_PlTerm -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showPlListElems x1 cd cs = let x2 = Curry_Prelude.d_OP_plus_plus
                                     (Curry_Prelude.toCurryString "|")
                                     (d_C_showPlTerm x1 cd cs) cd cs
  in d_C__case_14 x2 x1 cd cs

d_C_showPlAtom :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showPlAtom x1 cd cs = d_C__case_8 x1 (Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.toCurryString "[]") cd cs) (Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_all
  d_OP_showPlAtom_dot_uscore_hash_lambda2 cd cs) x1 cd cs)
  (Curry_Prelude.d_C_isLower (Curry_Prelude.d_C_head x1 cd cs) cd cs) cd cs)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_all (Curry_Prelude.d_C_flip
  (Curry_Prelude.d_C_elem
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (d_C_specialChars cd cs)) cd cs) x1 cd cs) cd cs) cd cs) cd cs

d_OP_showPlAtom_dot_uscore_hash_lambda2 :: Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_showPlAtom_dot_uscore_hash_lambda2 x1 cd cs = Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_C_isAlphaNum x1 cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.C_Char '_'#) cd cs) cd cs

d_OP_showPlAtom_dot_uscore_hash_lambda3 :: Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showPlAtom_dot_uscore_hash_lambda3 x1 cd cs = d_C__case_7 x1
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.C_Char '\''#) cd cs) cd cs

d_C_specialChars :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_specialChars cd cs = Curry_Prelude.toCurryString "+-*/<=>`\\:.?@#$&^~"

d_C_optimizeClause :: Language.Prolog.Curry_Types.C_PlClause -> Cover
  -> ConstStore -> Language.Prolog.Curry_Types.C_PlClause
d_C_optimizeClause x1 cd cs = case x1 of
  Language.Prolog.Curry_Types.C_PlClause x2 x3 x4 -> Language.Prolog.Curry_Types.C_PlClause
    x2 x3 (d_C_optimizeBody (Curry_Prelude.d_C_apply (d_C_unionMap
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    d_C_varsOf cd cs) x3 cd cs) x4 cd cs)
  Language.Prolog.Curry_Types.C_PlDirective x5 -> Language.Prolog.Curry_Types.C_PlDirective
    (d_C_optimizeBody Curry_Prelude.OP_List x5 cd cs)
  Language.Prolog.Curry_Types.C_PlQuery x6 -> Language.Prolog.Curry_Types.C_PlQuery
    (d_C_optimizeBody Curry_Prelude.OP_List x6 cd cs)
  Language.Prolog.Curry_Types.Choice_C_PlClause d i l r -> narrow d i
    (d_C_optimizeClause l cd cs) (d_C_optimizeClause r cd cs)
  Language.Prolog.Curry_Types.Choices_C_PlClause d i xs -> narrows cs d i (\z ->
    d_C_optimizeClause z cd cs) xs
  Language.Prolog.Curry_Types.Guard_C_PlClause d c e -> guardCons d c ((\x ->
    d_C_optimizeClause e cd x) $! addCs c cs)
  Language.Prolog.Curry_Types.Fail_C_PlClause d info -> failCons d (traceFail
    "Language.Prolog.Show.optimizeClause" [show x1] info)
  _ -> failCons cd (consFail "Language.Prolog.Show.optimizeClause" (showCons
    x1))

d_C_optimizeBody :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Language.Prolog.Curry_Types.C_PlGoal -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Language.Prolog.Curry_Types.C_PlGoal
d_C_optimizeBody x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_6 x1 x4 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_optimizeBody x1 l cd
    cs) (d_C_optimizeBody x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_optimizeBody
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_optimizeBody x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Prolog.Show.optimizeBody" [show x1, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Show.optimizeBody" (showCons x2))

d_C_replaceInLit :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Language.Prolog.Curry_Types.C_PlTerm
  -> Language.Prolog.Curry_Types.C_PlGoal -> Cover -> ConstStore
  -> Language.Prolog.Curry_Types.C_PlGoal
d_C_replaceInLit x1 x2 x3 cd cs = case x3 of
  Language.Prolog.Curry_Types.C_PlLit x4 x5 -> Language.Prolog.Curry_Types.C_PlLit
    x4 (Curry_Prelude.d_C_map (d_C_replaceInTerm x1 x2) x5 cd cs)
  Language.Prolog.Curry_Types.C_PlNeg x6 -> Language.Prolog.Curry_Types.C_PlNeg
    (Curry_Prelude.d_C_map (d_C_replaceInLit x1 x2) x6 cd cs)
  Language.Prolog.Curry_Types.C_PlCond x7 x8 x9 -> Language.Prolog.Curry_Types.C_PlCond
    (Curry_Prelude.d_C_map (d_C_replaceInLit x1 x2) x7 cd cs)
    (Curry_Prelude.d_C_map (d_C_replaceInLit x1 x2) x8 cd cs)
    (Curry_Prelude.d_C_map (d_C_replaceInLit x1 x2) x9 cd cs)
  Language.Prolog.Curry_Types.Choice_C_PlGoal d i l r -> narrow d i
    (d_C_replaceInLit x1 x2 l cd cs) (d_C_replaceInLit x1 x2 r cd cs)
  Language.Prolog.Curry_Types.Choices_C_PlGoal d i xs -> narrows cs d i (\z ->
    d_C_replaceInLit x1 x2 z cd cs) xs
  Language.Prolog.Curry_Types.Guard_C_PlGoal d c e -> guardCons d c ((\x ->
    d_C_replaceInLit x1 x2 e cd x) $! addCs c cs)
  Language.Prolog.Curry_Types.Fail_C_PlGoal d info -> failCons d (traceFail
    "Language.Prolog.Show.replaceInLit" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Language.Prolog.Show.replaceInLit" (showCons x3))

d_C_replaceInTerm :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Language.Prolog.Curry_Types.C_PlTerm
  -> Language.Prolog.Curry_Types.C_PlTerm -> Cover -> ConstStore
  -> Language.Prolog.Curry_Types.C_PlTerm
d_C_replaceInTerm x1 x2 x3 cd cs = case x3 of
  Language.Prolog.Curry_Types.C_PlVar x4 -> d_C__case_2 x4 x1 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 x4 cd cs) cd cs
  Language.Prolog.Curry_Types.C_PlAtom x5 -> Language.Prolog.Curry_Types.C_PlAtom
    x5
  Language.Prolog.Curry_Types.C_PlInt x6 -> Language.Prolog.Curry_Types.C_PlInt
    x6
  Language.Prolog.Curry_Types.C_PlFloat x7 -> Language.Prolog.Curry_Types.C_PlFloat
    x7
  Language.Prolog.Curry_Types.C_PlStruct x8 x9 -> Language.Prolog.Curry_Types.C_PlStruct
    x8 (Curry_Prelude.d_C_map (d_C_replaceInTerm x1 x2) x9 cd cs)
  Language.Prolog.Curry_Types.Choice_C_PlTerm d i l r -> narrow d i
    (d_C_replaceInTerm x1 x2 l cd cs) (d_C_replaceInTerm x1 x2 r cd cs)
  Language.Prolog.Curry_Types.Choices_C_PlTerm d i xs -> narrows cs d i (\z ->
    d_C_replaceInTerm x1 x2 z cd cs) xs
  Language.Prolog.Curry_Types.Guard_C_PlTerm d c e -> guardCons d c ((\x ->
    d_C_replaceInTerm x1 x2 e cd x) $! addCs c cs)
  Language.Prolog.Curry_Types.Fail_C_PlTerm d info -> failCons d (traceFail
    "Language.Prolog.Show.replaceInTerm" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Language.Prolog.Show.replaceInTerm" (showCons x3))

d_C_varsOfLit :: Language.Prolog.Curry_Types.C_PlGoal -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_varsOfLit x1 cd cs = case x1 of
  Language.Prolog.Curry_Types.C_PlLit x2 x3 -> Curry_Prelude.d_C_apply
    (d_C_unionMap
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    d_C_varsOf cd cs) x3 cd cs
  Language.Prolog.Curry_Types.C_PlNeg x4 -> Curry_Prelude.d_C_apply
    (d_C_unionMap
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    d_C_varsOfLit cd cs) x4 cd cs
  Language.Prolog.Curry_Types.C_PlCond x5 x6 x7 -> Curry_Prelude.d_C_apply
    (d_C_unionMap
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    d_C_varsOfLit cd cs) (Curry_Prelude.d_OP_plus_plus x5
    (Curry_Prelude.d_OP_plus_plus x6 x7 cd cs) cd cs) cd cs
  Language.Prolog.Curry_Types.Choice_C_PlGoal d i l r -> narrow d i
    (d_C_varsOfLit l cd cs) (d_C_varsOfLit r cd cs)
  Language.Prolog.Curry_Types.Choices_C_PlGoal d i xs -> narrows cs d i (\z ->
    d_C_varsOfLit z cd cs) xs
  Language.Prolog.Curry_Types.Guard_C_PlGoal d c e -> guardCons d c ((\x ->
    d_C_varsOfLit e cd x) $! addCs c cs)
  Language.Prolog.Curry_Types.Fail_C_PlGoal d info -> failCons d (traceFail
    "Language.Prolog.Show.varsOfLit" [show x1] info)
  _ -> failCons cd (consFail "Language.Prolog.Show.varsOfLit" (showCons x1))

d_C_varsOf :: Language.Prolog.Curry_Types.C_PlTerm -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_varsOf x1 cd cs = case x1 of
  Language.Prolog.Curry_Types.C_PlVar x2 -> Curry_Prelude.OP_Cons x2
    Curry_Prelude.OP_List
  Language.Prolog.Curry_Types.C_PlAtom x3 -> Curry_Prelude.OP_List
  Language.Prolog.Curry_Types.C_PlInt x4 -> Curry_Prelude.OP_List
  Language.Prolog.Curry_Types.C_PlFloat x5 -> Curry_Prelude.OP_List
  Language.Prolog.Curry_Types.C_PlStruct x6 x7 -> Curry_Prelude.d_C_apply
    (d_C_unionMap
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    d_C_varsOf cd cs) x7 cd cs
  Language.Prolog.Curry_Types.Choice_C_PlTerm d i l r -> narrow d i (d_C_varsOf
    l cd cs) (d_C_varsOf r cd cs)
  Language.Prolog.Curry_Types.Choices_C_PlTerm d i xs -> narrows cs d i (\z ->
    d_C_varsOf z cd cs) xs
  Language.Prolog.Curry_Types.Guard_C_PlTerm d c e -> guardCons d c ((\x ->
    d_C_varsOf e cd x) $! addCs c cs)
  Language.Prolog.Curry_Types.Fail_C_PlTerm d info -> failCons d (traceFail
    "Language.Prolog.Show.varsOf" [show x1] info)
  _ -> failCons cd (consFail "Language.Prolog.Show.varsOf" (showCons x1))

d_C_isPlVar :: Language.Prolog.Curry_Types.C_PlTerm -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isPlVar x1 cd cs = let x2 = Curry_Prelude.C_False in d_C__case_1 x2 x1 cd cs

d_C_varOf :: Language.Prolog.Curry_Types.C_PlTerm -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_varOf x1 cd cs = let x2 = Curry_Prelude.d_C_error
                           (Curry_Prelude.toCurryString
                           "Internal error in Prolog.Show.varOf: not a variable")
                           cd cs
  in d_C__case_0 x2 x1 cd cs

d_C_unionMap :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t1) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t1
d_C_unionMap x1 x2 cd cs = Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_foldr
  (acceptCs id (Data.Curry_List.d_C_union x1)) Curry_Prelude.OP_List)
  (Curry_Prelude.d_C_map x2) cd cs

nd_C_unionMap :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> Func t0 (Curry_Prelude.OP_List t1) -> IDSupply -> Cover -> ConstStore
  -> Func (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t1)
nd_C_unionMap x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapNX id (Curry_Prelude.nd_C_foldr
  (wrapDX (wrapNX id) (acceptCs id (Data.Curry_List.nd_C_union x1)))
  Curry_Prelude.OP_List)) (wrapNX id (Curry_Prelude.nd_C_map x2)) s0 cd cs

d_C__case_23 :: Curry_Prelude.OP_List Language.Prolog.Curry_Types.C_PlTerm
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Language.Prolog.Curry_Types.C_PlGoal -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_23 x3 x2 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_plus_plus (d_C_showPlGoal
    (Language.Prolog.Curry_Types.C_PlLit x2 x3) cd cs)
    (Curry_Prelude.toCurryString ".") cd cs
  Curry_Prelude.OP_Cons x5 x6 -> Curry_Prelude.d_OP_plus_plus (d_C_showPlGoal
    (Language.Prolog.Curry_Types.C_PlLit x2 x3) cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " :- ")
    (Curry_Prelude.d_OP_plus_plus (d_C_showPlGoals x4 cd cs)
    (Curry_Prelude.toCurryString ".") cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_23 x3 x2 l cd
    cs) (d_C__case_23 x3 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_23 x3
    x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_23 x3 x2
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Prolog.Show._case_23" [show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_23" (showCons x4))

d_C__case_22 :: Curry_Prelude.OP_List Language.Prolog.Curry_Types.C_PlGoal
  -> Language.Prolog.Curry_Types.C_PlGoal -> Curry_Prelude.OP_List
  Language.Prolog.Curry_Types.C_PlGoal -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_22 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> d_C_showPlGoal x2 cd cs
  Curry_Prelude.OP_Cons x4 x5 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(") (Curry_Prelude.d_OP_plus_plus
    (Data.Curry_List.d_C_intercalate (Curry_Prelude.toCurryString ", ")
    (Curry_Prelude.d_C_map d_C_showPlGoal x1 cd cs) cd cs)
    (Curry_Prelude.toCurryString ")") cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_22 x1 x2 l cd
    cs) (d_C__case_22 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_22 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_22 x1 x2
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Prolog.Show._case_22" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_22" (showCons x3))

d_C__case_21 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Language.Prolog.Curry_Types.C_PlTerm
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_21 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus (d_C_showPlTerm
    (Curry_Prelude.d_OP_bang_bang x3 (Curry_Prelude.C_Int (0)) cd cs) cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "=")
    (d_C_showPlTerm (Curry_Prelude.d_OP_bang_bang x3 (Curry_Prelude.C_Int (1))
    cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_20 x3 x2 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.toCurryString "!") cd cs) (Curry_Prelude.d_C_null x3 cd
    cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_21 x2 x3 l cd cs)
    (d_C__case_21 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_21 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_21 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Prolog.Show._case_21" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_21" (showCons x4))

d_C__case_20 :: Curry_Prelude.OP_List Language.Prolog.Curry_Types.C_PlTerm
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_20 x3 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "!"
  Curry_Prelude.C_False -> d_C__case_19 x3 x2 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_20 x3 x2 l cd cs)
    (d_C__case_20 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_20 x3
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_20 x3 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Prolog.Show._case_20" [show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_20" (showCons x4))

d_C__case_19 :: Curry_Prelude.OP_List Language.Prolog.Curry_Types.C_PlTerm
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_19 x3 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> d_C_showPlTerm (Language.Prolog.Curry_Types.C_PlStruct
    x2 x3) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_19 x3 x2 l cd cs)
    (d_C__case_19 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_19 x3
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_19 x3 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Prolog.Show._case_19" [show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_19" (showCons x4))

d_C__case_18 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Language.Prolog.Curry_Types.C_PlTerm -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_18 x6 x7 cd cs = case x7 of
  Curry_Prelude.OP_List -> d_C_showPlAtom x6 cd cs
  Curry_Prelude.OP_Cons x8 x9 -> d_C__case_17 x7 x6 x9 x8
    (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x6 (Curry_Prelude.toCurryString ".") cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_C_length x7 cd cs) (Curry_Prelude.C_Int (2)) cd cs) cd cs)
    cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_18 x6 l cd cs)
    (d_C__case_18 x6 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_18 x6
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_18 x6 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Prolog.Show._case_18" [show x6, show x7] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_18" (showCons x7))

d_C__case_17 :: Curry_Prelude.OP_List Language.Prolog.Curry_Types.C_PlTerm
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Language.Prolog.Curry_Types.C_PlTerm -> Language.Prolog.Curry_Types.C_PlTerm
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_17 x7 x6 x9 x8 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "[") (Curry_Prelude.d_OP_plus_plus
    (d_C_showPlTerm x8 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showPlListElems
    (Curry_Prelude.d_C_head x9 cd cs) cd cs) (Curry_Prelude.toCurryString "]")
    cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_16 x7 x6 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x6 (Curry_Prelude.toCurryString ",") cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_all (Curry_Prelude.d_C_flip (Curry_Prelude.d_C_elem
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (d_C_specialChars cd cs)) cd cs) x6 cd cs) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_C_length x7 cd cs) (Curry_Prelude.C_Int (2)) cd cs) cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_17 x7 x6 x9 x8 l
    cd cs) (d_C__case_17 x7 x6 x9 x8 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_17 x7
    x6 x9 x8 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_17 x7 x6
    x9 x8 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Prolog.Show._case_17" [show x7, show x6, show x9, show x8, show
    x10] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_17" (showCons x10))

d_C__case_16 :: Curry_Prelude.OP_List Language.Prolog.Curry_Types.C_PlTerm
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_16 x7 x6 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(") (Curry_Prelude.d_OP_plus_plus
    (d_C_showPlTerm (Curry_Prelude.d_OP_bang_bang x7 (Curry_Prelude.C_Int (0))
    cd cs) cd cs) (Curry_Prelude.d_OP_plus_plus x6 (Curry_Prelude.d_OP_plus_plus
    (d_C_showPlTerm (Curry_Prelude.d_OP_bang_bang x7 (Curry_Prelude.C_Int (1))
    cd cs) cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_15 x7 x6 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_16 x7 x6 l cd cs)
    (d_C__case_16 x7 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_16 x7
    x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_16 x7 x6 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Prolog.Show._case_16" [show x7, show x6, show x8] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_16" (showCons x8))

d_C__case_15 :: Curry_Prelude.OP_List Language.Prolog.Curry_Types.C_PlTerm
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_15 x7 x6 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus (d_C_showPlAtom x6 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "(")
    (Curry_Prelude.d_OP_plus_plus (Data.Curry_List.d_C_intercalate
    (Curry_Prelude.toCurryString ",") (Curry_Prelude.d_C_map d_C_showPlTerm x7
    cd cs) cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_15 x7 x6 l cd cs)
    (d_C__case_15 x7 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_15 x7
    x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_15 x7 x6 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Prolog.Show._case_15" [show x7, show x6, show x8] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_15" (showCons x8))

d_C__case_14 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Language.Prolog.Curry_Types.C_PlTerm -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_14 x2 x1 cd cs = case x1 of
  Language.Prolog.Curry_Types.C_PlAtom x3 -> d_C__case_13 x3 x1
    (Curry_Prelude.d_C_eqString x3 (Curry_Prelude.toCurryString "[]") cd cs) cd
    cs
  Language.Prolog.Curry_Types.C_PlStruct x4 x5 -> d_C__case_12 x1 x4 x5 cd cs
  Language.Prolog.Curry_Types.C_PlVar x12 -> x2
  Language.Prolog.Curry_Types.C_PlInt x13 -> x2
  Language.Prolog.Curry_Types.C_PlFloat x14 -> x2
  Language.Prolog.Curry_Types.Choice_C_PlTerm d i l r -> narrow d i
    (d_C__case_14 x2 l cd cs) (d_C__case_14 x2 r cd cs)
  Language.Prolog.Curry_Types.Choices_C_PlTerm d i xs -> narrows cs d i (\z ->
    d_C__case_14 x2 z cd cs) xs
  Language.Prolog.Curry_Types.Guard_C_PlTerm d c e -> guardCons d c ((\x ->
    d_C__case_14 x2 e cd x) $! addCs c cs)
  Language.Prolog.Curry_Types.Fail_C_PlTerm d info -> failCons d (traceFail
    "Language.Prolog.Show._case_14" [show x2, show x1] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_14" (showCons x1))

d_C__case_12 :: Language.Prolog.Curry_Types.C_PlTerm -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Language.Prolog.Curry_Types.C_PlTerm -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_12 x1 x4 x5 cd cs = case x5 of
  Curry_Prelude.OP_Cons x6 x7 -> d_C__case_11 x1 x4 x6 x7 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "|") (d_C_showPlTerm x1 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_12 x1 x4 l cd
    cs) (d_C__case_12 x1 x4 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_12 x1
    x4 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_12 x1 x4
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Prolog.Show._case_12" [show x1, show x4, show x5] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_12" (showCons x5))

d_C__case_11 :: Language.Prolog.Curry_Types.C_PlTerm -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Language.Prolog.Curry_Types.C_PlTerm
  -> Curry_Prelude.OP_List Language.Prolog.Curry_Types.C_PlTerm -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_11 x1 x4 x6 x7 cd cs = case x7 of
  Curry_Prelude.OP_Cons x8 x9 -> d_C__case_10 x1 x4 x8 x6 x9 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "|") (d_C_showPlTerm x1 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_11 x1 x4 x6 l cd
    cs) (d_C__case_11 x1 x4 x6 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_11 x1
    x4 x6 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_11 x1 x4
    x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Prolog.Show._case_11" [show x1, show x4, show x6, show x7] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_11" (showCons x7))

d_C__case_10 :: Language.Prolog.Curry_Types.C_PlTerm -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Language.Prolog.Curry_Types.C_PlTerm
  -> Language.Prolog.Curry_Types.C_PlTerm -> Curry_Prelude.OP_List
  Language.Prolog.Curry_Types.C_PlTerm -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_10 x1 x4 x8 x6 x9 cd cs = case x9 of
  Curry_Prelude.OP_List -> d_C__case_9 x4 x8 x6
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x4 (Curry_Prelude.toCurryString ".") cd cs) cd cs
  Curry_Prelude.OP_Cons x10 x11 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "|") (d_C_showPlTerm x1 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_10 x1 x4 x8 x6 l
    cd cs) (d_C__case_10 x1 x4 x8 x6 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_10 x1
    x4 x8 x6 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_10 x1 x4
    x8 x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Prolog.Show._case_10" [show x1, show x4, show x8, show x6, show
    x9] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_10" (showCons x9))

d_C__case_9 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Language.Prolog.Curry_Types.C_PlTerm
  -> Language.Prolog.Curry_Types.C_PlTerm -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_9 x4 x8 x6 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString ",") (Curry_Prelude.d_OP_plus_plus
    (d_C_showPlTerm x6 cd cs) (d_C_showPlListElems x8 cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "|") (d_C_showPlTerm x8 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_9 x4 x8 x6 l cd
    cs) (d_C__case_9 x4 x8 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_9 x4 x8
    x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_9 x4 x8 x6
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Prolog.Show._case_9" [show x4, show x8, show x6, show x9] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_9" (showCons x9))

d_C__case_13 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Language.Prolog.Curry_Types.C_PlTerm -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_13 x3 x1 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "|") (d_C_showPlTerm x1 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_13 x3 x1 l cd cs)
    (d_C__case_13 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_13 x3
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_13 x3 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Prolog.Show._case_13" [show x3, show x1, show x4] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_13" (showCons x4))

d_C__case_8 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_8 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> x1
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '\''#)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_concatMap d_OP_showPlAtom_dot_uscore_hash_lambda3 cd cs)
    x1 cd cs) (Curry_Prelude.toCurryString "'") cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x1 l cd cs)
    (d_C__case_8 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_8 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Prolog.Show._case_8" [show x1, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_8" (showCons x2))

d_C__case_7 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_7 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "\\'"
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x1 l cd cs)
    (d_C__case_7 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_7 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Prolog.Show._case_7" [show x1, show x2] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_7" (showCons x2))

d_C__case_6 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Language.Prolog.Curry_Types.C_PlGoal -> Language.Prolog.Curry_Types.C_PlGoal
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Language.Prolog.Curry_Types.C_PlGoal
d_C__case_6 x1 x4 x3 cd cs = case x3 of
  Language.Prolog.Curry_Types.C_PlNeg x5 -> Curry_Prelude.OP_Cons
    (Language.Prolog.Curry_Types.C_PlNeg x5) (d_C_optimizeBody
    (Data.Curry_List.d_C_union
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x1 (Curry_Prelude.d_C_apply (d_C_unionMap
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    d_C_varsOfLit cd cs) x5 cd cs) cd cs) x4 cd cs)
  Language.Prolog.Curry_Types.C_PlCond x6 x7 x8 -> let x9 = d_C_optimizeBody x1
                                                         x6 cd cs
                                                       x10 = Data.Curry_List.d_C_union
                                                         (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
                                                         Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                                         x1
                                                         (Curry_Prelude.d_C_apply
                                                         (d_C_unionMap
                                                         (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
                                                         Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                                         d_C_varsOfLit cd cs) x6
                                                         cd cs) cd cs
                                                       x11 = d_C_optimizeBody
                                                         x10 x7 cd cs
                                                       x12 = d_C_optimizeBody
                                                         x10 x8 cd cs
    in Curry_Prelude.OP_Cons (Language.Prolog.Curry_Types.C_PlCond x9 x11 x12)
    (d_C_optimizeBody (Data.Curry_List.d_C_union
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x10 (Curry_Prelude.d_C_apply (d_C_unionMap
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    d_C_varsOfLit cd cs) (Curry_Prelude.d_OP_plus_plus x11 x12 cd cs) cd cs) cd
    cs) x4 cd cs)
  Language.Prolog.Curry_Types.C_PlLit x13 x14 -> d_C__case_5 x1 x14 x13 x4
    (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x13 (Curry_Prelude.toCurryString "=") cd cs) (Curry_Prelude.d_OP_amp_amp
    (d_C_isPlVar (Curry_Prelude.d_C_head x14 cd cs) cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_notElem
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (d_C_varOf (Curry_Prelude.d_C_head x14 cd cs) cd cs) cd cs) x1 cd cs) cd cs)
    cd cs) cd cs
  Language.Prolog.Curry_Types.Choice_C_PlGoal d i l r -> narrow d i (d_C__case_6
    x1 x4 l cd cs) (d_C__case_6 x1 x4 r cd cs)
  Language.Prolog.Curry_Types.Choices_C_PlGoal d i xs -> narrows cs d i (\z ->
    d_C__case_6 x1 x4 z cd cs) xs
  Language.Prolog.Curry_Types.Guard_C_PlGoal d c e -> guardCons d c ((\x ->
    d_C__case_6 x1 x4 e cd x) $! addCs c cs)
  Language.Prolog.Curry_Types.Fail_C_PlGoal d info -> failCons d (traceFail
    "Language.Prolog.Show._case_6" [show x1, show x4, show x3] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_6" (showCons x3))

d_C__case_5 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Language.Prolog.Curry_Types.C_PlTerm -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Language.Prolog.Curry_Types.C_PlGoal -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Language.Prolog.Curry_Types.C_PlGoal
d_C__case_5 x1 x14 x13 x4 x15 cd cs = case x15 of
  Curry_Prelude.C_True -> d_C_optimizeBody (Data.Curry_List.d_C_union
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x1 (d_C_varsOf (Curry_Prelude.d_OP_bang_bang x14 (Curry_Prelude.C_Int (1))
    cd cs) cd cs) cd cs) (Curry_Prelude.d_C_map (d_C_replaceInLit (d_C_varOf
    (Curry_Prelude.d_C_head x14 cd cs) cd cs) (Curry_Prelude.d_OP_bang_bang x14
    (Curry_Prelude.C_Int (1)) cd cs)) x4 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_4 x1 x14 x13 x4 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x13 (Curry_Prelude.toCurryString "=") cd cs) (Curry_Prelude.d_OP_amp_amp
    (d_C_isPlVar (Curry_Prelude.d_OP_bang_bang x14 (Curry_Prelude.C_Int (1)) cd
    cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_notElem
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (d_C_varOf (Curry_Prelude.d_OP_bang_bang x14 (Curry_Prelude.C_Int (1)) cd
    cs) cd cs) cd cs) x1 cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x1 x14 x13 x4 l
    cd cs) (d_C__case_5 x1 x14 x13 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x1
    x14 x13 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x1 x14
    x13 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Prolog.Show._case_5" [show x1, show x14, show x13, show x4, show
    x15] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_5" (showCons x15))

d_C__case_4 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Language.Prolog.Curry_Types.C_PlTerm -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Language.Prolog.Curry_Types.C_PlGoal -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Language.Prolog.Curry_Types.C_PlGoal
d_C__case_4 x1 x14 x13 x4 x15 cd cs = case x15 of
  Curry_Prelude.C_True -> d_C_optimizeBody (Data.Curry_List.d_C_union
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x1 (d_C_varsOf (Curry_Prelude.d_OP_bang_bang x14 (Curry_Prelude.C_Int (0))
    cd cs) cd cs) cd cs) (Curry_Prelude.d_C_map (d_C_replaceInLit (d_C_varOf
    (Curry_Prelude.d_OP_bang_bang x14 (Curry_Prelude.C_Int (1)) cd cs) cd cs)
    (Curry_Prelude.d_OP_bang_bang x14 (Curry_Prelude.C_Int (0)) cd cs)) x4 cd
    cs) cd cs
  Curry_Prelude.C_False -> d_C__case_3 x4 x14 x1 x13
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x1 x14 x13 x4 l
    cd cs) (d_C__case_4 x1 x14 x13 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x1
    x14 x13 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x1 x14
    x13 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Prolog.Show._case_4" [show x1, show x14, show x13, show x4, show
    x15] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_4" (showCons x15))

d_C__case_3 :: Curry_Prelude.OP_List Language.Prolog.Curry_Types.C_PlGoal
  -> Curry_Prelude.OP_List Language.Prolog.Curry_Types.C_PlTerm
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Language.Prolog.Curry_Types.C_PlGoal
d_C__case_3 x4 x14 x1 x13 x15 cd cs = case x15 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons
    (Language.Prolog.Curry_Types.C_PlLit x13 x14) (d_C_optimizeBody
    (Data.Curry_List.d_C_union
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x1 (Curry_Prelude.d_C_apply (d_C_unionMap
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    d_C_varsOf cd cs) x14 cd cs) cd cs) x4 cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x4 x14 x1 x13 l
    cd cs) (d_C__case_3 x4 x14 x1 x13 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x4
    x14 x1 x13 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x4 x14
    x1 x13 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Prolog.Show._case_3" [show x4, show x14, show x1, show x13, show
    x15] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_3" (showCons x15))

d_C__case_2 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Language.Prolog.Curry_Types.C_PlTerm -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Language.Prolog.Curry_Types.C_PlTerm
d_C__case_2 x4 x1 x2 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> x2
  Curry_Prelude.C_False -> Language.Prolog.Curry_Types.C_PlVar x4
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x4 x1 x2 l cd
    cs) (d_C__case_2 x4 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x4 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x4 x1 x2
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Prolog.Show._case_2" [show x4, show x1, show x2, show x5] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_2" (showCons x5))

d_C__case_1 :: Curry_Prelude.C_Bool -> Language.Prolog.Curry_Types.C_PlTerm
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_1 x2 x1 cd cs = case x1 of
  Language.Prolog.Curry_Types.C_PlVar x3 -> Curry_Prelude.C_True
  Language.Prolog.Curry_Types.C_PlAtom x4 -> x2
  Language.Prolog.Curry_Types.C_PlInt x5 -> x2
  Language.Prolog.Curry_Types.C_PlFloat x6 -> x2
  Language.Prolog.Curry_Types.C_PlStruct x7 x8 -> x2
  Language.Prolog.Curry_Types.Choice_C_PlTerm d i l r -> narrow d i (d_C__case_1
    x2 l cd cs) (d_C__case_1 x2 r cd cs)
  Language.Prolog.Curry_Types.Choices_C_PlTerm d i xs -> narrows cs d i (\z ->
    d_C__case_1 x2 z cd cs) xs
  Language.Prolog.Curry_Types.Guard_C_PlTerm d c e -> guardCons d c ((\x ->
    d_C__case_1 x2 e cd x) $! addCs c cs)
  Language.Prolog.Curry_Types.Fail_C_PlTerm d info -> failCons d (traceFail
    "Language.Prolog.Show._case_1" [show x2, show x1] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_1" (showCons x1))

d_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Language.Prolog.Curry_Types.C_PlTerm -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_0 x2 x1 cd cs = case x1 of
  Language.Prolog.Curry_Types.C_PlVar x3 -> x3
  Language.Prolog.Curry_Types.C_PlAtom x4 -> x2
  Language.Prolog.Curry_Types.C_PlInt x5 -> x2
  Language.Prolog.Curry_Types.C_PlFloat x6 -> x2
  Language.Prolog.Curry_Types.C_PlStruct x7 x8 -> x2
  Language.Prolog.Curry_Types.Choice_C_PlTerm d i l r -> narrow d i (d_C__case_0
    x2 l cd cs) (d_C__case_0 x2 r cd cs)
  Language.Prolog.Curry_Types.Choices_C_PlTerm d i xs -> narrows cs d i (\z ->
    d_C__case_0 x2 z cd cs) xs
  Language.Prolog.Curry_Types.Guard_C_PlTerm d c e -> guardCons d c ((\x ->
    d_C__case_0 x2 e cd x) $! addCs c cs)
  Language.Prolog.Curry_Types.Fail_C_PlTerm d info -> failCons d (traceFail
    "Language.Prolog.Show._case_0" [show x2, show x1] info)
  _ -> failCons cd (consFail "Language.Prolog.Show._case_0" (showCons x1))

