{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Data.Table.Curry_RBTree
  ( d_C_empty
  , nd_C_empty
  , d_C_isEmpty
  , nd_C_isEmpty
  , d_C_lookup
  , nd_C_lookup
  , d_C_update
  , nd_C_update
  , d_C_toList
  , nd_C_toList
  , d_C_delete
  , nd_C_delete )
  where

import Basics
import qualified Data.Curry_RedBlackTree
import qualified Curry_Prelude


d_C_empty :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (t1 -> Cover -> ConstStore
  -> t1 -> Cover -> ConstStore -> Curry_Prelude.C_Bool) -> Cover -> ConstStore
  -> Data.Curry_RedBlackTree.C_RedBlackTree (Curry_Prelude.OP_Tuple2 t1 t0)
d_C_empty x1 x2 cd cs = Data.Curry_RedBlackTree.d_C_empty (acceptCs id
  (d_OP_empty_dot_uscore_hash_lambda1 x1)) (acceptCs id
  (d_OP_empty_dot_uscore_hash_lambda2 x1)) (acceptCs id
  (d_OP_empty_dot_uscore_hash_lambda3 x2)) cd cs

nd_C_empty :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> Func t1 (Func t1 Curry_Prelude.C_Bool) -> IDSupply -> Cover -> ConstStore
  -> Data.Curry_RedBlackTree.C_RedBlackTree (Curry_Prelude.OP_Tuple2 t1 t0)
nd_C_empty x1 x2 s cd cs = let s0 = s
  in s0 `seq` Data.Curry_RedBlackTree.nd_C_empty (wrapDX (wrapNX id) (acceptCs
  id (nd_OP_empty_dot_uscore_hash_lambda1 x1))) (wrapDX (wrapNX id) (acceptCs id
  (nd_OP_empty_dot_uscore_hash_lambda2 x1))) (wrapDX (wrapNX id) (acceptCs id
  (nd_OP_empty_dot_uscore_hash_lambda3 x2))) s0 cd cs

d_OP_empty_dot_uscore_hash_lambda1 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Curry_Prelude.OP_Tuple2 t1 t0
  -> Curry_Prelude.OP_Tuple2 t1 t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_OP_empty_dot_uscore_hash_lambda1 x1 x2 x3 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq x1 cd cs)
  (Curry_Prelude.d_C_fst x2 cd cs) cd cs) (Curry_Prelude.d_C_fst x3 cd cs) cd cs

nd_OP_empty_dot_uscore_hash_lambda1 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Curry_Prelude.OP_Tuple2 t1 t0
  -> Curry_Prelude.OP_Tuple2 t1 t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_OP_empty_dot_uscore_hash_lambda1 x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq x1
  s0 cd cs) (Curry_Prelude.d_C_fst x2 cd cs) s1 cd cs)) (Curry_Prelude.d_C_fst
  x3 cd cs) s3 cd cs))

d_OP_empty_dot_uscore_hash_lambda2 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Curry_Prelude.OP_Tuple2 t1 t0
  -> Curry_Prelude.OP_Tuple2 t1 t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_OP_empty_dot_uscore_hash_lambda2 x1 x2 x3 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq x1 cd cs)
  (Curry_Prelude.d_C_fst x2 cd cs) cd cs) (Curry_Prelude.d_C_fst x3 cd cs) cd cs

nd_OP_empty_dot_uscore_hash_lambda2 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Curry_Prelude.OP_Tuple2 t1 t0
  -> Curry_Prelude.OP_Tuple2 t1 t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_OP_empty_dot_uscore_hash_lambda2 x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq x1
  s0 cd cs) (Curry_Prelude.d_C_fst x2 cd cs) s1 cd cs)) (Curry_Prelude.d_C_fst
  x3 cd cs) s3 cd cs))

d_OP_empty_dot_uscore_hash_lambda3 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (t1 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Curry_Prelude.OP_Tuple2 t1 t0
  -> Curry_Prelude.OP_Tuple2 t1 t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_OP_empty_dot_uscore_hash_lambda3 x1 x2 x3 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply x1 (Curry_Prelude.d_C_fst x2 cd cs) cd cs)
  (Curry_Prelude.d_C_fst x3 cd cs) cd cs

nd_OP_empty_dot_uscore_hash_lambda3 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func t1 (Func t1 Curry_Prelude.C_Bool)
  -> Curry_Prelude.OP_Tuple2 t1 t0 -> Curry_Prelude.OP_Tuple2 t1 t0 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_empty_dot_uscore_hash_lambda3 x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
  (Curry_Prelude.d_C_fst x2 cd cs) s0 cd cs) (Curry_Prelude.d_C_fst x3 cd cs) s1
  cd cs))

d_C_isEmpty :: Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Data.Curry_RedBlackTree.C_RedBlackTree
  (Curry_Prelude.OP_Tuple2 t1 t0) -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isEmpty cd cs = Data.Curry_RedBlackTree.d_C_isEmpty

nd_C_isEmpty :: IDSupply -> Cover -> ConstStore -> forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  (Data.Curry_RedBlackTree.C_RedBlackTree (Curry_Prelude.OP_Tuple2 t1 t0))
  Curry_Prelude.C_Bool
nd_C_isEmpty s cd cs = wrapNX id Data.Curry_RedBlackTree.nd_C_isEmpty

d_C_lookup :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> Cover -> ConstStore -> Data.Curry_RedBlackTree.C_RedBlackTree
  (Curry_Prelude.OP_Tuple2 t1 t0) -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe t0
d_C_lookup x1 cd cs = Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_maybe
  Curry_Prelude.C_Nothing (Curry_Prelude.d_OP_dot (acceptCs id
  Curry_Prelude.C_Just) Curry_Prelude.d_C_snd cd cs))
  (Data.Curry_RedBlackTree.d_C_lookup (Curry_Prelude.OP_Tuple2 x1
  (Curry_Prelude.d_C_failed cd cs))) cd cs

nd_C_lookup :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> IDSupply -> Cover -> ConstStore -> Func
  (Data.Curry_RedBlackTree.C_RedBlackTree (Curry_Prelude.OP_Tuple2 t1 t0))
  (Curry_Prelude.C_Maybe t0)
nd_C_lookup x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (wrapNX id
  (Curry_Prelude.nd_C_maybe Curry_Prelude.C_Nothing (Curry_Prelude.nd_OP_dot
  (wrapDX id (acceptCs id Curry_Prelude.C_Just)) (wrapDX id
  Curry_Prelude.d_C_snd) s0 cd cs))) (wrapNX id
  (Data.Curry_RedBlackTree.nd_C_lookup (Curry_Prelude.OP_Tuple2 x1
  (Curry_Prelude.d_C_failed cd cs)))) s1 cd cs))

d_C_update :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t0 -> Cover -> ConstStore
  -> Data.Curry_RedBlackTree.C_RedBlackTree (Curry_Prelude.OP_Tuple2 t1 t0)
  -> Cover -> ConstStore -> Data.Curry_RedBlackTree.C_RedBlackTree
  (Curry_Prelude.OP_Tuple2 t1 t0)
d_C_update x1 x2 cd cs = Data.Curry_RedBlackTree.d_C_update
  (Curry_Prelude.OP_Tuple2 x1 x2)

nd_C_update :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t0 -> IDSupply -> Cover -> ConstStore -> Func
  (Data.Curry_RedBlackTree.C_RedBlackTree (Curry_Prelude.OP_Tuple2 t1 t0))
  (Data.Curry_RedBlackTree.C_RedBlackTree (Curry_Prelude.OP_Tuple2 t1 t0))
nd_C_update x1 x2 s cd cs = wrapNX id (Data.Curry_RedBlackTree.nd_C_update
  (Curry_Prelude.OP_Tuple2 x1 x2))

d_C_toList :: Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Data.Curry_RedBlackTree.C_RedBlackTree
  (Curry_Prelude.OP_Tuple2 t1 t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
d_C_toList cd cs = Data.Curry_RedBlackTree.d_C_toList

nd_C_toList :: IDSupply -> Cover -> ConstStore -> forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  (Data.Curry_RedBlackTree.C_RedBlackTree (Curry_Prelude.OP_Tuple2 t1 t0))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0))
nd_C_toList s cd cs = wrapNX id Data.Curry_RedBlackTree.nd_C_toList

d_C_delete :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> Cover -> ConstStore -> Data.Curry_RedBlackTree.C_RedBlackTree
  (Curry_Prelude.OP_Tuple2 t1 t0) -> Cover -> ConstStore
  -> Data.Curry_RedBlackTree.C_RedBlackTree (Curry_Prelude.OP_Tuple2 t1 t0)
d_C_delete x1 cd cs = Data.Curry_RedBlackTree.d_C_delete
  (Curry_Prelude.OP_Tuple2 x1 (Curry_Prelude.d_C_failed cd cs))

nd_C_delete :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> IDSupply -> Cover -> ConstStore -> Func
  (Data.Curry_RedBlackTree.C_RedBlackTree (Curry_Prelude.OP_Tuple2 t1 t0))
  (Data.Curry_RedBlackTree.C_RedBlackTree (Curry_Prelude.OP_Tuple2 t1 t0))
nd_C_delete x1 s cd cs = wrapNX id (Data.Curry_RedBlackTree.nd_C_delete
  (Curry_Prelude.OP_Tuple2 x1 (Curry_Prelude.d_C_failed cd cs)))

