{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_RegExpSem
  ( C_RE (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
  , d_C_plus
  , nd_C_sem
  , nd_C_match
  , nd_C_grep
  , nd_C_grepShow
  , nd_C_grepPos )
  where

import Basics
import qualified Curry_Prelude


data C_RE t0
  = C_Lit t0
  | C_Alt (C_RE t0) (C_RE t0)
  | C_Conc (C_RE t0) (C_RE t0)
  | C_Star (C_RE t0)
  | Choice_C_RE Cover ID (C_RE t0) (C_RE t0)
  | Choices_C_RE Cover ID [C_RE t0]
  | Fail_C_RE Cover FailInfo
  | Guard_C_RE Cover Constraints (C_RE t0)

instance (Curry t0) => Show (C_RE t0) where
  showsPrec d (Choice_C_RE cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_RE cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_RE cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_RE cd info) = showChar '!'
  showsPrec _ (C_Lit x1) = showString "(Lit" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_Alt x1 x2) = showString "(Alt" . (showChar ' ' . (shows x1 .
    (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_Conc x1 x2) = showString "(Conc" . (showChar ' ' . (shows x1 .
    (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_Star x1) = showString "(Star" . (showChar ' ' . (shows x1 .
    showChar ')'))

instance (Curry t0) => Read (C_RE t0) where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Lit x1, r1) | (_, r0) <-
    readQualified "RegExpSem" "Lit" r, (x1, r1) <- readsPrec 11 r0]) s ++
    (readParen ((>) d 10) (\r -> [(C_Alt x1 x2, r2) | (_, r0) <- readQualified
    "RegExpSem" "Alt" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11
    r1]) s ++ (readParen ((>) d 10) (\r -> [(C_Conc x1 x2, r2) | (_, r0) <-
    readQualified "RegExpSem" "Conc" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <-
    readsPrec 11 r1]) s ++ readParen ((>) d 10) (\r -> [(C_Star x1, r1) | (_
    , r0) <- readQualified "RegExpSem" "Star" r, (x1, r1) <- readsPrec 11 r0])
    s))

instance NonDet (C_RE t0) where
  choiceCons = Choice_C_RE
  choicesCons = Choices_C_RE
  failCons = Fail_C_RE
  guardCons = Guard_C_RE
  try (Choice_C_RE cd i x y) = tryChoice cd i x y
  try (Choices_C_RE cd i xs) = tryChoices cd i xs
  try (Fail_C_RE cd info) = Fail cd info
  try (Guard_C_RE cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_RE cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_RE cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_RE cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_RE cd i _) = error
    ("RegExpSem.RE.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_RE cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_RE cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance (Curry t0) => Generable (C_RE t0) where
  generate s c = Choices_C_RE c (freeID [1, 2, 2, 1] s) [C_Lit (generate
    (leftSupply s) c), C_Alt (generate (leftSupply s) c) (generate (rightSupply
    s) c), C_Conc (generate (leftSupply s) c) (generate (rightSupply s) c)
    , C_Star (generate (leftSupply s) c)]

instance (Curry t0) => NormalForm (C_RE t0) where
  ($!!) cont (C_Lit x1) d cs = ($!!) (\y1 d cs -> cont (C_Lit y1) d cs) x1 d cs
  ($!!) cont (C_Alt x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Alt y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_Conc x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Conc y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_Star x1) d cs = ($!!) (\y1 d cs -> cont (C_Star y1) d cs) x1 d
    cs
  ($!!) cont (Choice_C_RE cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_RE cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_RE cd c e) d cs = guardCons cd c (($!!) cont e d (addCs c
    cs))
  ($!!) _ (Fail_C_RE cd info) _ _ = failCons cd info
  ($##) cont (C_Lit x1) d cs = ($##) (\y1 d cs -> cont (C_Lit y1) d cs) x1 d cs
  ($##) cont (C_Alt x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Alt y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_Conc x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Conc y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_Star x1) d cs = ($##) (\y1 d cs -> cont (C_Star y1) d cs) x1 d
    cs
  ($##) cont (Choice_C_RE cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_RE cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_RE cd c e) d cs = guardCons cd c (($##) cont e d (addCs c
    cs))
  ($##) _ (Fail_C_RE cd info) _ _ = failCons cd info
  showCons (C_Lit _) = "RegExpSem.Lit _"
  showCons (C_Alt _ _) = "RegExpSem.Alt _ _"
  showCons (C_Conc _ _) = "RegExpSem.Conc _ _"
  showCons (C_Star _) = "RegExpSem.Star _"
  showCons x = error ("RegExpSem.RE.showCons: no constructor: " ++ show x)
  searchNF search cont (C_Lit x1) = search (\y1 -> cont (C_Lit y1)) x1
  searchNF search cont (C_Alt x1 x2) = search (\y1 -> search (\y2 -> cont (C_Alt
    y1 y2)) x2) x1
  searchNF search cont (C_Conc x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Conc y1 y2)) x2) x1
  searchNF search cont (C_Star x1) = search (\y1 -> cont (C_Star y1)) x1
  searchNF _ _ x = error ("RegExpSem.RE.searchNF: no constructor: " ++ show x)

instance (Curry t0) => Unifiable (C_RE t0) where
  (=.=) (C_Lit x1) (C_Lit y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Alt x1 x2) (C_Alt y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2 d
    cs) d cs
  (=.=) (C_Conc x1 x2) (C_Conc y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2
    d cs) d cs
  (=.=) (C_Star x1) (C_Star y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Lit x1) (C_Lit y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Alt x1 x2) (C_Alt y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=) x2
    y2 d cs) d cs
  (=.<=) (C_Conc x1 x2) (C_Conc y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=) x2
    y2 d cs) d cs
  (=.<=) (C_Star x1) (C_Star y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Lit x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_Alt x3 x4) = (i :=: ChooseN 1 2) : concat [bind cd (leftID i) x3
    , bind cd (rightID i) x4]
  bind cd i (C_Conc x3 x4) = (i :=: ChooseN 2 2) : concat [bind cd (leftID i) x3
    , bind cd (rightID i) x4]
  bind cd i (C_Star x3) = (i :=: ChooseN 3 1) : concat [bind cd (leftID i) x3]
  bind d i (Choice_C_RE cd j x y) = [ConstraintChoice cd j (bind d i x) (bind d
    i y)]
  bind d i (Choices_C_RE cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_RE cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_RE cd i _) = error
    ("RegExpSem.RE.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_RE cd info) = [Unsolvable info]
  bind d i (Guard_C_RE cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Lit x3) = (i :=: ChooseN 0 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Alt x3 x4) = (i :=: ChooseN 1 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (C_Conc x3 x4) = (i :=: ChooseN 2 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (C_Star x3) = (i :=: ChooseN 3 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_RE cd j x y) = [ConstraintChoice cd j (lazyBind d i x)
    (lazyBind d i y)]
  lazyBind d i (Choices_C_RE cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j
    xs
  lazyBind d i (Choices_C_RE cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_RE cd i _) = error
    ("RegExpSem.RE.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_RE cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_RE cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance (Curry t0) => Curry (C_RE t0) where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_Unit -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data (C_RE t0)
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1)))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "RegExpSem._inst#Prelude.Data#RegExpSem.RE#0##" [show x1, show x2] info)
  _ -> failCons cd (consFail "RegExpSem._inst#Prelude.Data#RegExpSem.RE#0##"
    (showCons x2))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_RE t0 -> C_RE t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash x1 x2 x3 cd cs =
  case x2 of
  C_Lit x4 -> d_C__case_5 x4 x1 x3 cd cs
  C_Alt x11 x12 -> d_C__case_4 x12 x1 x11 x3 cd cs
  C_Conc x19 x20 -> d_C__case_3 x20 x1 x19 x3 cd cs
  C_Star x27 -> d_C__case_2 x27 x1 x3 cd cs
  Choice_C_RE d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 l x3 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 r x3 cd cs)
  Choices_C_RE d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 z x3 cd cs) xs
  Guard_C_RE d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 e x3 cd x) $! addCs c cs)
  Fail_C_RE d info -> failCons d (traceFail
    "RegExpSem._impl#===#Prelude.Data#RegExpSem.RE#0##" [show x1, show x2, show
    x3] info)
  _ -> failCons cd (consFail "RegExpSem._impl#===#Prelude.Data#RegExpSem.RE#0##"
    (showCons x2))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> C_RE t0 -> C_RE t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash x1 x2 x3 s cd cs =
  case x2 of
  C_Lit x4 -> let s0 = s in s0 `seq` nd_C__case_5 x4 x1 x3 s0 cd cs
  C_Alt x11 x12 -> let s0 = s in s0 `seq` nd_C__case_4 x12 x1 x11 x3 s0 cd cs
  C_Conc x19 x20 -> let s0 = s in s0 `seq` nd_C__case_3 x20 x1 x19 x3 s0 cd cs
  C_Star x27 -> let s0 = s in s0 `seq` nd_C__case_2 x27 x1 x3 s0 cd cs
  Choice_C_RE d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 l x3 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 r x3 s cd cs)
  Choices_C_RE d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 z x3 s cd cs) xs
  Guard_C_RE d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 e x3 s cd x) $! addCs c cs)
  Fail_C_RE d info -> failCons d (traceFail
    "RegExpSem._impl#===#Prelude.Data#RegExpSem.RE#0##" [show x1, show x2, show
    x3] info)
  _ -> failCons cd (consFail "RegExpSem._impl#===#Prelude.Data#RegExpSem.RE#0##"
    (showCons x2))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> IDSupply -> Cover -> ConstStore -> C_RE t0
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash x1 s cd cs =
  let s15 = s
  in s15 `seq` (let s14 = leftSupply s15
                    s16 = rightSupply s15
                    s11 = leftSupply s16
                    s13 = rightSupply s16
  in s14 `seq` (s16 `seq` (s11 `seq` (s13 `seq` choice (let s10 = leftSupply s11
                                                            s12 = rightSupply
                                                              s11
                                                            s5 = leftSupply s12
                                                            s9 = rightSupply s12
  in s10 `seq` (s12 `seq` (s5 `seq` (s9 `seq` choice (let s4 = leftSupply s5
                                                          s6 = rightSupply s5
                                                          s0 = leftSupply s6
                                                          s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` choice (C_Lit
  (Curry_Prelude.nd_C_aValue x1 s0 cd cs)) (let s1 = leftSupply s3
                                                s2 = rightSupply s3
  in s1 `seq` (s2 `seq` C_Alt
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
  x1 s1 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
  x1 s2 cd cs))) s4 cd cs)))) (let s7 = leftSupply s9
                                   s8 = rightSupply s9
  in s7 `seq` (s8 `seq` C_Conc
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
  x1 s7 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
  x1 s8 cd cs))) s10 cd cs)))) (C_Star
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
  x1 s13 cd cs)) s14 cd cs))))

d_C_plus :: forall t0 . (Curry_Prelude.Curry t0) => C_RE t0 -> Cover
  -> ConstStore -> C_RE t0
d_C_plus x1 cd cs = C_Conc x1 (C_Star x1)

nd_C_sem :: forall t0 . (Curry_Prelude.Curry t0) => C_RE t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_sem x1 s cd cs = case x1 of
  C_Lit x2 -> Curry_Prelude.OP_Cons x2 Curry_Prelude.OP_List
  C_Alt x3 x4 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_OP_qmark
    (nd_C_sem x3 s0 cd cs) (nd_C_sem x4 s1 cd cs) s2 cd cs))))
  C_Conc x5 x6 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_sem x5 s0 cd cs)
    (nd_C_sem x6 s1 cd cs) cd cs))
  C_Star x7 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_qmark Curry_Prelude.OP_List
    (nd_C_sem (C_Conc x7 (C_Star x7)) s0 cd cs) s1 cd cs))
  Choice_C_RE d i l r -> narrow d i (nd_C_sem l s cd cs) (nd_C_sem r s cd cs)
  Choices_C_RE d i xs -> narrows cs d i (\z -> nd_C_sem z s cd cs) xs
  Guard_C_RE d c e -> guardCons d c ((\x -> nd_C_sem e s cd x) $! addCs c cs)
  Fail_C_RE d info -> failCons d (traceFail "RegExpSem.sem" [show x1] info)
  _ -> failCons cd (consFail "RegExpSem.sem" (showCons x1))

nd_C_match :: forall t0 . (Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_RE t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C_match x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.d_OP_eq_colon_eq (nd_C_sem x2 s0 cd cs) x3 cd cs

nd_C_grep :: forall t0 . (Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_RE t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C_grep x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` Curry_Prelude.d_OP_eq_colon_eq (let s0 = leftSupply s4
                                                  s3 = rightSupply s4
  in s0 `seq` (s3 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_unknown
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  x1)) s0 cd cs) (let s1 = leftSupply s3
                      s2 = rightSupply s3
  in s1 `seq` (s2 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_sem x2 s1 cd cs)
  (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  x1)) s2 cd cs) cd cs)) cd cs)) x3 cd cs

nd_C_grepShow :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_RE t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C_grepShow x1 x2 x3 s cd cs = let s6 = s
  in s6 `seq` (let s0 = leftSupply s6
                   s5 = rightSupply s6
  in s0 `seq` (s5 `seq` (let x4 = generate s0 cd
  in let s4 = leftSupply s5
         s3 = rightSupply s5
  in s4 `seq` (s3 `seq` nd_C__case_1 x3 x1 x2 x4 (Curry_Prelude.d_OP_eq_colon_eq
  (Curry_Prelude.d_OP_plus_plus x4 (let s1 = leftSupply s3
                                        s2 = rightSupply s3
  in s1 `seq` (s2 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_sem x2 s1 cd cs)
  (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  x1)) s2 cd cs) cd cs)) cd cs) x3 cd cs) s4 cd cs))))

nd_C_grepPos :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_RE t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
nd_C_grepPos x1 x2 x3 s cd cs = let s3 = s
  in s3 `seq` (let s0 = leftSupply s3
                   s4 = rightSupply s3
                   s1 = leftSupply s4
                   s2 = rightSupply s4
  in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` (let x4 = generate s0 cd
                                                 x5 = generate s1 cd
  in d_C__case_0 x3 x5 x2 x4 (Curry_Prelude.d_OP_eq_colon_eq
  (Curry_Prelude.d_OP_plus_plus x4 (Curry_Prelude.d_OP_plus_plus (nd_C_sem x2 s2
  cd cs) x5 cd cs) cd cs) x3 cd cs) cd cs)))))

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => C_RE t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_RE t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_2 x27 x1 x3 cd cs = case x3 of
  C_Lit x28 -> Curry_Prelude.C_False
  C_Alt x29 x30 -> Curry_Prelude.C_False
  C_Conc x31 x32 -> Curry_Prelude.C_False
  C_Star x33 -> d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 x27 x33 cd cs
  Choice_C_RE d i l r -> narrow d i (d_C__case_2 x27 x1 l cd cs) (d_C__case_2
    x27 x1 r cd cs)
  Choices_C_RE d i xs -> narrows cs d i (\z -> d_C__case_2 x27 x1 z cd cs) xs
  Guard_C_RE d c e -> guardCons d c ((\x -> d_C__case_2 x27 x1 e cd x) $! addCs
    c cs)
  Fail_C_RE d info -> failCons d (traceFail "RegExpSem._case_2" [show x27, show
    x1, show x3] info)
  _ -> failCons cd (consFail "RegExpSem._case_2" (showCons x3))

nd_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => C_RE t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_RE t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_2 x27 x1 x3 s cd cs = case x3 of
  C_Lit x28 -> Curry_Prelude.C_False
  C_Alt x29 x30 -> Curry_Prelude.C_False
  C_Conc x31 x32 -> Curry_Prelude.C_False
  C_Star x33 -> let s0 = s
    in s0 `seq`
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 x27 x33 s0 cd cs
  Choice_C_RE d i l r -> narrow d i (nd_C__case_2 x27 x1 l s cd cs)
    (nd_C__case_2 x27 x1 r s cd cs)
  Choices_C_RE d i xs -> narrows cs d i (\z -> nd_C__case_2 x27 x1 z s cd cs) xs
  Guard_C_RE d c e -> guardCons d c ((\x -> nd_C__case_2 x27 x1 e s cd x) $!
    addCs c cs)
  Fail_C_RE d info -> failCons d (traceFail "RegExpSem._case_2" [show x27, show
    x1, show x3] info)
  _ -> failCons cd (consFail "RegExpSem._case_2" (showCons x3))

d_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => C_RE t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_RE t0 -> C_RE t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_3 x20 x1 x19 x3 cd cs = case x3 of
  C_Lit x21 -> Curry_Prelude.C_False
  C_Alt x22 x23 -> Curry_Prelude.C_False
  C_Conc x24 x25 -> Curry_Prelude.d_OP_amp_amp
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 x19 x24 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 x20 x25 cd cs) cd cs
  C_Star x26 -> Curry_Prelude.C_False
  Choice_C_RE d i l r -> narrow d i (d_C__case_3 x20 x1 x19 l cd cs)
    (d_C__case_3 x20 x1 x19 r cd cs)
  Choices_C_RE d i xs -> narrows cs d i (\z -> d_C__case_3 x20 x1 x19 z cd cs)
    xs
  Guard_C_RE d c e -> guardCons d c ((\x -> d_C__case_3 x20 x1 x19 e cd x) $!
    addCs c cs)
  Fail_C_RE d info -> failCons d (traceFail "RegExpSem._case_3" [show x20, show
    x1, show x19, show x3] info)
  _ -> failCons cd (consFail "RegExpSem._case_3" (showCons x3))

nd_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => C_RE t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_RE t0
  -> C_RE t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_3 x20 x1 x19 x3 s cd cs = case x3 of
  C_Lit x21 -> Curry_Prelude.C_False
  C_Alt x22 x23 -> Curry_Prelude.C_False
  C_Conc x24 x25 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 x19 x24 s0 cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 x20 x25 s1 cd cs) cd cs))
  C_Star x26 -> Curry_Prelude.C_False
  Choice_C_RE d i l r -> narrow d i (nd_C__case_3 x20 x1 x19 l s cd cs)
    (nd_C__case_3 x20 x1 x19 r s cd cs)
  Choices_C_RE d i xs -> narrows cs d i (\z -> nd_C__case_3 x20 x1 x19 z s cd
    cs) xs
  Guard_C_RE d c e -> guardCons d c ((\x -> nd_C__case_3 x20 x1 x19 e s cd x) $!
    addCs c cs)
  Fail_C_RE d info -> failCons d (traceFail "RegExpSem._case_3" [show x20, show
    x1, show x19, show x3] info)
  _ -> failCons cd (consFail "RegExpSem._case_3" (showCons x3))

d_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => C_RE t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_RE t0 -> C_RE t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_4 x12 x1 x11 x3 cd cs = case x3 of
  C_Lit x13 -> Curry_Prelude.C_False
  C_Alt x14 x15 -> Curry_Prelude.d_OP_amp_amp
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 x11 x14 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 x12 x15 cd cs) cd cs
  C_Conc x16 x17 -> Curry_Prelude.C_False
  C_Star x18 -> Curry_Prelude.C_False
  Choice_C_RE d i l r -> narrow d i (d_C__case_4 x12 x1 x11 l cd cs)
    (d_C__case_4 x12 x1 x11 r cd cs)
  Choices_C_RE d i xs -> narrows cs d i (\z -> d_C__case_4 x12 x1 x11 z cd cs)
    xs
  Guard_C_RE d c e -> guardCons d c ((\x -> d_C__case_4 x12 x1 x11 e cd x) $!
    addCs c cs)
  Fail_C_RE d info -> failCons d (traceFail "RegExpSem._case_4" [show x12, show
    x1, show x11, show x3] info)
  _ -> failCons cd (consFail "RegExpSem._case_4" (showCons x3))

nd_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => C_RE t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_RE t0
  -> C_RE t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_4 x12 x1 x11 x3 s cd cs = case x3 of
  C_Lit x13 -> Curry_Prelude.C_False
  C_Alt x14 x15 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 x11 x14 s0 cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExpSem_dot_RE_hash_0_hash_hash
    x1 x12 x15 s1 cd cs) cd cs))
  C_Conc x16 x17 -> Curry_Prelude.C_False
  C_Star x18 -> Curry_Prelude.C_False
  Choice_C_RE d i l r -> narrow d i (nd_C__case_4 x12 x1 x11 l s cd cs)
    (nd_C__case_4 x12 x1 x11 r s cd cs)
  Choices_C_RE d i xs -> narrows cs d i (\z -> nd_C__case_4 x12 x1 x11 z s cd
    cs) xs
  Guard_C_RE d c e -> guardCons d c ((\x -> nd_C__case_4 x12 x1 x11 e s cd x) $!
    addCs c cs)
  Fail_C_RE d info -> failCons d (traceFail "RegExpSem._case_4" [show x12, show
    x1, show x11, show x3] info)
  _ -> failCons cd (consFail "RegExpSem._case_4" (showCons x3))

d_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_RE t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_5 x4 x1 x3 cd cs = case x3 of
  C_Lit x5 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_eq_eq_eq x1 cd cs) x4 cd cs) x5 cd cs
  C_Alt x6 x7 -> Curry_Prelude.C_False
  C_Conc x8 x9 -> Curry_Prelude.C_False
  C_Star x10 -> Curry_Prelude.C_False
  Choice_C_RE d i l r -> narrow d i (d_C__case_5 x4 x1 l cd cs) (d_C__case_5 x4
    x1 r cd cs)
  Choices_C_RE d i xs -> narrows cs d i (\z -> d_C__case_5 x4 x1 z cd cs) xs
  Guard_C_RE d c e -> guardCons d c ((\x -> d_C__case_5 x4 x1 e cd x) $! addCs c
    cs)
  Fail_C_RE d info -> failCons d (traceFail "RegExpSem._case_5" [show x4, show
    x1, show x3] info)
  _ -> failCons cd (consFail "RegExpSem._case_5" (showCons x3))

nd_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_RE t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_5 x4 x1 x3 s cd cs = case x3 of
  C_Lit x5 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq_eq
    x1 s0 cd cs) x4 s1 cd cs)) x5 s3 cd cs))
  C_Alt x6 x7 -> Curry_Prelude.C_False
  C_Conc x8 x9 -> Curry_Prelude.C_False
  C_Star x10 -> Curry_Prelude.C_False
  Choice_C_RE d i l r -> narrow d i (nd_C__case_5 x4 x1 l s cd cs) (nd_C__case_5
    x4 x1 r s cd cs)
  Choices_C_RE d i xs -> narrows cs d i (\z -> nd_C__case_5 x4 x1 z s cd cs) xs
  Guard_C_RE d c e -> guardCons d c ((\x -> nd_C__case_5 x4 x1 e s cd x) $!
    addCs c cs)
  Fail_C_RE d info -> failCons d (traceFail "RegExpSem._case_5" [show x4, show
    x1, show x3] info)
  _ -> failCons cd (consFail "RegExpSem._case_5" (showCons x3))

d_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_RE t0
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C__case_1 x3 x1 x2 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_drop (Curry_Prelude.d_C_length x4 cd
    cs) x3 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x3 x1 x2 x4 l
    cd cs) (d_C__case_1 x3 x1 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x3 x1
    x2 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x3 x1 x2
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExpSem._case_1"
    [show x3, show x1, show x2, show x4, show x5] info)
  _ -> failCons cd (consFail "RegExpSem._case_1" (showCons x5))

nd_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> C_RE t0 -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C__case_1 x3 x1 x2 x4 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_drop (Curry_Prelude.d_C_length x4 cd
    cs) x3 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_1 x3 x1 x2 x4 l
    s cd cs) (nd_C__case_1 x3 x1 x2 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_1 x3
    x1 x2 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_1 x3 x1
    x2 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExpSem._case_1"
    [show x3, show x1, show x2, show x4, show x5] info)
  _ -> failCons cd (consFail "RegExpSem._case_1" (showCons x5))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> C_RE t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C__case_0 x3 x5 x2 x4 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_length x4 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x3 x5 x2 x4 l
    cd cs) (d_C__case_0 x3 x5 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x3 x5
    x2 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x3 x5 x2
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExpSem._case_0"
    [show x3, show x5, show x2, show x4, show x6] info)
  _ -> failCons cd (consFail "RegExpSem._case_0" (showCons x6))

