{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Control.Search.SearchTree.Curry_Generators
  ( d_OP_bar_bar_bar
  , d_C_genCons0
  , nd_C_genCons0
  , d_C_genCons1
  , nd_C_genCons1
  , d_C_genCons2
  , nd_C_genCons2
  , d_C_genCons3
  , nd_C_genCons3
  , d_C_genCons4
  , nd_C_genCons4
  , d_C_genCons5
  , nd_C_genCons5
  , d_C_genNat
  , d_C_genInt
  , d_C_genFloat
  , d_C_genBool
  , d_C_genChar
  , d_C_genList
  , d_C_genMaybe
  , d_C_genEither
  , d_C_genUnit
  , d_C_genPair
  , nd_C_genPair
  , d_C_genTriple
  , nd_C_genTriple
  , d_C_genTuple4
  , nd_C_genTuple4
  , d_C_genTuple5
  , nd_C_genTuple5
  , d_C_genOrdering )
  where

import Basics
import qualified Control.Search.Curry_SearchTree
import qualified Curry_Prelude


d_C_valsTo :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Control.Search.Curry_SearchTree.C_SearchTree t1 -> (t1 -> Cover
  -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree t0) -> Cover
  -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree t0
d_C_valsTo x1 x2 cd cs = case x1 of
  Control.Search.Curry_SearchTree.C_Value x3 -> Curry_Prelude.d_C_apply x2 x3 cd
    cs
  Control.Search.Curry_SearchTree.C_Fail x4 -> Control.Search.Curry_SearchTree.C_Fail
    x4
  Control.Search.Curry_SearchTree.C_Or x5 x6 -> Control.Search.Curry_SearchTree.C_Or
    (d_C_valsTo x5 x2 cd cs) (d_C_valsTo x6 x2 cd cs)
  Control.Search.Curry_SearchTree.Choice_C_SearchTree d i l r -> narrow d i
    (d_C_valsTo l x2 cd cs) (d_C_valsTo r x2 cd cs)
  Control.Search.Curry_SearchTree.Choices_C_SearchTree d i xs -> narrows cs d i
    (\z -> d_C_valsTo z x2 cd cs) xs
  Control.Search.Curry_SearchTree.Guard_C_SearchTree d c e -> guardCons d c
    ((\x -> d_C_valsTo e x2 cd x) $! addCs c cs)
  Control.Search.Curry_SearchTree.Fail_C_SearchTree d info -> failCons d
    (traceFail "Control.Search.SearchTree.Generators.valsTo" [show x1, show x2]
    info)
  _ -> failCons cd (consFail "Control.Search.SearchTree.Generators.valsTo"
    (showCons x1))

nd_C_valsTo :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Control.Search.Curry_SearchTree.C_SearchTree t1 -> Func t1
  (Control.Search.Curry_SearchTree.C_SearchTree t0) -> IDSupply -> Cover
  -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_C_valsTo x1 x2 s cd cs = case x1 of
  Control.Search.Curry_SearchTree.C_Value x3 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x2 x3 s0 cd cs
  Control.Search.Curry_SearchTree.C_Fail x4 -> Control.Search.Curry_SearchTree.C_Fail
    x4
  Control.Search.Curry_SearchTree.C_Or x5 x6 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Control.Search.Curry_SearchTree.C_Or (nd_C_valsTo x5
    x2 s0 cd cs) (nd_C_valsTo x6 x2 s1 cd cs)))
  Control.Search.Curry_SearchTree.Choice_C_SearchTree d i l r -> narrow d i
    (nd_C_valsTo l x2 s cd cs) (nd_C_valsTo r x2 s cd cs)
  Control.Search.Curry_SearchTree.Choices_C_SearchTree d i xs -> narrows cs d i
    (\z -> nd_C_valsTo z x2 s cd cs) xs
  Control.Search.Curry_SearchTree.Guard_C_SearchTree d c e -> guardCons d c
    ((\x -> nd_C_valsTo e x2 s cd x) $! addCs c cs)
  Control.Search.Curry_SearchTree.Fail_C_SearchTree d info -> failCons d
    (traceFail "Control.Search.SearchTree.Generators.valsTo" [show x1, show x2]
    info)
  _ -> failCons cd (consFail "Control.Search.SearchTree.Generators.valsTo"
    (showCons x1))

d_OP_bar_bar_bar :: forall t0 . (Curry_Prelude.Curry
  t0) => Control.Search.Curry_SearchTree.C_SearchTree t0
  -> Control.Search.Curry_SearchTree.C_SearchTree t0 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
d_OP_bar_bar_bar x1 x2 cd cs = Control.Search.Curry_SearchTree.C_Or x1 x2

d_C_genCons0 :: Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry
  t0) => t0 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
d_C_genCons0 cd cs = acceptCs id Control.Search.Curry_SearchTree.C_Value

nd_C_genCons0 :: IDSupply -> Cover -> ConstStore
  -> forall t0 . (Curry_Prelude.Curry t0) => Func t0
  (Control.Search.Curry_SearchTree.C_SearchTree t0)
nd_C_genCons0 s cd cs = wrapDX id (acceptCs id
  Control.Search.Curry_SearchTree.C_Value)

d_C_genCons1 :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (t1 -> Cover -> ConstStore -> t0)
  -> Control.Search.Curry_SearchTree.C_SearchTree t1 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
d_C_genCons1 x1 x2 cd cs = d_C_valsTo x2 (Curry_Prelude.d_OP_dot (acceptCs id
  Control.Search.Curry_SearchTree.C_Value) x1 cd cs) cd cs

nd_C_genCons1 :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func t1 t0 -> Control.Search.Curry_SearchTree.C_SearchTree t1
  -> IDSupply -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_C_genCons1 x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_valsTo x2 (Curry_Prelude.nd_OP_dot (wrapDX id
  (acceptCs id Control.Search.Curry_SearchTree.C_Value)) x1 s0 cd cs) s1 cd cs))

d_C_genCons2 :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => (t2 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> t0) -> Control.Search.Curry_SearchTree.C_SearchTree t2
  -> Control.Search.Curry_SearchTree.C_SearchTree t1 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
d_C_genCons2 x1 x2 x3 cd cs = d_C_valsTo x2
  (d_OP_genCons2_dot_uscore_hash_lambda1 x3 x1) cd cs

nd_C_genCons2 :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Func t2 (Func t1 t0)
  -> Control.Search.Curry_SearchTree.C_SearchTree t2
  -> Control.Search.Curry_SearchTree.C_SearchTree t1 -> IDSupply -> Cover
  -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_C_genCons2 x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` nd_C_valsTo x2 (wrapNX id (nd_OP_genCons2_dot_uscore_hash_lambda1
  x3 x1)) s0 cd cs

d_OP_genCons2_dot_uscore_hash_lambda1 :: forall t0 t1 t2 . (Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0) => Control.Search.Curry_SearchTree.C_SearchTree t1 -> (t2 -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> t2 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
d_OP_genCons2_dot_uscore_hash_lambda1 x1 x2 x3 cd cs = d_C_valsTo x1
  (d_OP_genCons2_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x3 x2) cd cs

nd_OP_genCons2_dot_uscore_hash_lambda1 :: forall t0 t1 t2 . (Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0) => Control.Search.Curry_SearchTree.C_SearchTree t1 -> Func t2 (Func t1 t0)
  -> t2 -> IDSupply -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_OP_genCons2_dot_uscore_hash_lambda1 x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` nd_C_valsTo x1 (wrapNX id
  (nd_OP_genCons2_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x3 x2)) s0 cd
  cs

d_OP_genCons2_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t2 -> (t2 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0)
  -> t1 -> Cover -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree
  t0
d_OP_genCons2_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 x3 cd cs =
  Control.Search.Curry_SearchTree.C_Value (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply x2 x1 cd cs) x3 cd cs)

nd_OP_genCons2_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t2 -> Func t2 (Func t1 t0) -> t1 -> IDSupply -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_OP_genCons2_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 x3 s cd cs =
  let s2 = s
  in s2 `seq` Control.Search.Curry_SearchTree.C_Value (let s1 = leftSupply s2
                                                           s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2 x1
  s0 cd cs) x3 s1 cd cs))

d_C_genCons3 :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (t3 -> Cover -> ConstStore -> t2 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> t0) -> Control.Search.Curry_SearchTree.C_SearchTree t3
  -> Control.Search.Curry_SearchTree.C_SearchTree t2
  -> Control.Search.Curry_SearchTree.C_SearchTree t1 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
d_C_genCons3 x1 x2 x3 x4 cd cs = d_C_valsTo x2
  (d_OP_genCons3_dot_uscore_hash_lambda3 x4 x3 x1) cd cs

nd_C_genCons3 :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func t3 (Func t2 (Func t1 t0))
  -> Control.Search.Curry_SearchTree.C_SearchTree t3
  -> Control.Search.Curry_SearchTree.C_SearchTree t2
  -> Control.Search.Curry_SearchTree.C_SearchTree t1 -> IDSupply -> Cover
  -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_C_genCons3 x1 x2 x3 x4 s cd cs = let s0 = s
  in s0 `seq` nd_C_valsTo x2 (wrapNX id (nd_OP_genCons3_dot_uscore_hash_lambda3
  x4 x3 x1)) s0 cd cs

d_OP_genCons3_dot_uscore_hash_lambda3 :: forall t0 t1 t2
  t3 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t0) => Control.Search.Curry_SearchTree.C_SearchTree t1
  -> Control.Search.Curry_SearchTree.C_SearchTree t2 -> (t3 -> Cover
  -> ConstStore -> t2 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0)
  -> t3 -> Cover -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree
  t0
d_OP_genCons3_dot_uscore_hash_lambda3 x1 x2 x3 x4 cd cs = d_C_valsTo x2
  (d_OP_genCons3_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 x4 x1 x3) cd cs

nd_OP_genCons3_dot_uscore_hash_lambda3 :: forall t0 t1 t2
  t3 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t0) => Control.Search.Curry_SearchTree.C_SearchTree t1
  -> Control.Search.Curry_SearchTree.C_SearchTree t2 -> Func t3 (Func t2 (Func
  t1 t0)) -> t3 -> IDSupply -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_OP_genCons3_dot_uscore_hash_lambda3 x1 x2 x3 x4 s cd cs = let s0 = s
  in s0 `seq` nd_C_valsTo x2 (wrapNX id
  (nd_OP_genCons3_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 x4 x1 x3)) s0
  cd cs

d_OP_genCons3_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 :: forall t0 t1 t2
  t3 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t0) => t3
  -> Control.Search.Curry_SearchTree.C_SearchTree t1 -> (t3 -> Cover
  -> ConstStore -> t2 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0)
  -> t2 -> Cover -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree
  t0
d_OP_genCons3_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 x1 x2 x3 x4 cd cs =
  d_C_valsTo x2
  (d_OP_genCons3_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5
  x4 x1 x3) cd cs

nd_OP_genCons3_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 :: forall t0 t1
  t2 t3 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t0) => t3
  -> Control.Search.Curry_SearchTree.C_SearchTree t1 -> Func t3 (Func t2 (Func
  t1 t0)) -> t2 -> IDSupply -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_OP_genCons3_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 x1 x2 x3 x4 s cd cs =
  let s0 = s
  in s0 `seq` nd_C_valsTo x2 (wrapNX id
  (nd_OP_genCons3_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5
  x4 x1 x3)) s0 cd cs

d_OP_genCons3_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5 :: forall t0
  t1 t2 t3 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t2 -> t3 -> (t3 -> Cover
  -> ConstStore -> t2 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0)
  -> t1 -> Cover -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree
  t0
d_OP_genCons3_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5 x1 x2 x3 x4 cd cs =
  Control.Search.Curry_SearchTree.C_Value (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x3 x2 cd cs) x1 cd cs) x4 cd
  cs)

nd_OP_genCons3_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5 :: forall t0
  t1 t2 t3 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t2 -> t3 -> Func t3 (Func
  t2 (Func t1 t0)) -> t1 -> IDSupply -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_OP_genCons3_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5 x1 x2 x3 x4 s cd cs =
  let s4 = s
  in s4 `seq` Control.Search.Curry_SearchTree.C_Value (let s3 = leftSupply s4
                                                           s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x3 x2
  s0 cd cs) x1 s1 cd cs)) x4 s3 cd cs))

d_C_genCons4 :: forall t0 t1 t2 t3 t4 . (Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (t4 -> Cover -> ConstStore -> t3 -> Cover
  -> ConstStore -> t2 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0)
  -> Control.Search.Curry_SearchTree.C_SearchTree t4
  -> Control.Search.Curry_SearchTree.C_SearchTree t3
  -> Control.Search.Curry_SearchTree.C_SearchTree t2
  -> Control.Search.Curry_SearchTree.C_SearchTree t1 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
d_C_genCons4 x1 x2 x3 x4 x5 cd cs = d_C_valsTo x2
  (d_OP_genCons4_dot_uscore_hash_lambda6 x5 x4 x3 x1) cd cs

nd_C_genCons4 :: forall t0 t1 t2 t3 t4 . (Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func t4 (Func t3 (Func t2 (Func t1 t0)))
  -> Control.Search.Curry_SearchTree.C_SearchTree t4
  -> Control.Search.Curry_SearchTree.C_SearchTree t3
  -> Control.Search.Curry_SearchTree.C_SearchTree t2
  -> Control.Search.Curry_SearchTree.C_SearchTree t1 -> IDSupply -> Cover
  -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_C_genCons4 x1 x2 x3 x4 x5 s cd cs = let s0 = s
  in s0 `seq` nd_C_valsTo x2 (wrapNX id (nd_OP_genCons4_dot_uscore_hash_lambda6
  x5 x4 x3 x1)) s0 cd cs

d_OP_genCons4_dot_uscore_hash_lambda6 :: forall t0 t1 t2 t3
  t4 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry
  t0) => Control.Search.Curry_SearchTree.C_SearchTree t1
  -> Control.Search.Curry_SearchTree.C_SearchTree t2
  -> Control.Search.Curry_SearchTree.C_SearchTree t3 -> (t4 -> Cover
  -> ConstStore -> t3 -> Cover -> ConstStore -> t2 -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> t0) -> t4 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
d_OP_genCons4_dot_uscore_hash_lambda6 x1 x2 x3 x4 x5 cd cs = d_C_valsTo x3
  (d_OP_genCons4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7 x5 x1 x2 x4) cd
  cs

nd_OP_genCons4_dot_uscore_hash_lambda6 :: forall t0 t1 t2 t3
  t4 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry
  t0) => Control.Search.Curry_SearchTree.C_SearchTree t1
  -> Control.Search.Curry_SearchTree.C_SearchTree t2
  -> Control.Search.Curry_SearchTree.C_SearchTree t3 -> Func t4 (Func t3 (Func
  t2 (Func t1 t0))) -> t4 -> IDSupply -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_OP_genCons4_dot_uscore_hash_lambda6 x1 x2 x3 x4 x5 s cd cs = let s0 = s
  in s0 `seq` nd_C_valsTo x3 (wrapNX id
  (nd_OP_genCons4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7 x5 x1 x2 x4))
  s0 cd cs

d_OP_genCons4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7 :: forall t0 t1 t2
  t3 t4 . (Curry_Prelude.Curry t4, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t3, Curry_Prelude.Curry t0) => t4
  -> Control.Search.Curry_SearchTree.C_SearchTree t1
  -> Control.Search.Curry_SearchTree.C_SearchTree t2 -> (t4 -> Cover
  -> ConstStore -> t3 -> Cover -> ConstStore -> t2 -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> t0) -> t3 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
d_OP_genCons4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7 x1 x2 x3 x4 x5 cd cs =
  d_C_valsTo x3
  (d_OP_genCons4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7_dot_uscore_hash_lambda8
  x5 x1 x2 x4) cd cs

nd_OP_genCons4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7 :: forall t0 t1
  t2 t3 t4 . (Curry_Prelude.Curry t4, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t0) => t4 -> Control.Search.Curry_SearchTree.C_SearchTree t1
  -> Control.Search.Curry_SearchTree.C_SearchTree t2 -> Func t4 (Func t3 (Func
  t2 (Func t1 t0))) -> t3 -> IDSupply -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_OP_genCons4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7 x1 x2 x3 x4 x5 s cd cs =
  let s0 = s
  in s0 `seq` nd_C_valsTo x3 (wrapNX id
  (nd_OP_genCons4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7_dot_uscore_hash_lambda8
  x5 x1 x2 x4)) s0 cd cs

d_OP_genCons4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7_dot_uscore_hash_lambda8 :: forall t0
  t1 t2 t3 t4 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0) => t3 -> t4 -> Control.Search.Curry_SearchTree.C_SearchTree t1 -> (t4
  -> Cover -> ConstStore -> t3 -> Cover -> ConstStore -> t2 -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> t2 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
d_OP_genCons4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7_dot_uscore_hash_lambda8 x1 x2 x3 x4 x5 cd cs =
  d_C_valsTo x3
  (d_OP_genCons4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9
  x5 x1 x2 x4) cd cs

nd_OP_genCons4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7_dot_uscore_hash_lambda8 :: forall t0
  t1 t2 t3 t4 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0) => t3 -> t4 -> Control.Search.Curry_SearchTree.C_SearchTree t1 -> Func t4
  (Func t3 (Func t2 (Func t1 t0))) -> t2 -> IDSupply -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_OP_genCons4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7_dot_uscore_hash_lambda8 x1 x2 x3 x4 x5 s cd cs =
  let s0 = s
  in s0 `seq` nd_C_valsTo x3 (wrapNX id
  (nd_OP_genCons4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9
  x5 x1 x2 x4)) s0 cd cs

d_OP_genCons4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 :: forall t0
  t1 t2 t3 t4 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t2 -> t3 -> t4 -> (t4 -> Cover -> ConstStore -> t3 -> Cover
  -> ConstStore -> t2 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0)
  -> t1 -> Cover -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree
  t0
d_OP_genCons4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 x1 x2 x3 x4 x5 cd cs =
  Control.Search.Curry_SearchTree.C_Value (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x4
  x3 cd cs) x2 cd cs) x1 cd cs) x5 cd cs)

nd_OP_genCons4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 :: forall t0
  t1 t2 t3 t4 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t2 -> t3 -> t4 -> Func t4 (Func t3 (Func t2 (Func t1 t0))) -> t1
  -> IDSupply -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_OP_genCons4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 x1 x2 x3 x4 x5 s cd cs =
  let s6 = s
  in s6 `seq` Control.Search.Curry_SearchTree.C_Value (let s5 = leftSupply s6
                                                           s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                      s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x4 x3
  s0 cd cs) x2 s1 cd cs)) x1 s3 cd cs)) x5 s5 cd cs))

d_C_genCons5 :: forall t0 t1 t2 t3 t4 t5 . (Curry_Prelude.Curry t5
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t3, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => (t5 -> Cover
  -> ConstStore -> t4 -> Cover -> ConstStore -> t3 -> Cover -> ConstStore -> t2
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0)
  -> Control.Search.Curry_SearchTree.C_SearchTree t5
  -> Control.Search.Curry_SearchTree.C_SearchTree t4
  -> Control.Search.Curry_SearchTree.C_SearchTree t3
  -> Control.Search.Curry_SearchTree.C_SearchTree t2
  -> Control.Search.Curry_SearchTree.C_SearchTree t1 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
d_C_genCons5 x1 x2 x3 x4 x5 x6 cd cs = d_C_valsTo x2
  (d_OP_genCons5_dot_uscore_hash_lambda10 x6 x5 x4 x3 x1) cd cs

nd_C_genCons5 :: forall t0 t1 t2 t3 t4 t5 . (Curry_Prelude.Curry t5
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t3, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func t5 (Func t4 (Func t3
  (Func t2 (Func t1 t0)))) -> Control.Search.Curry_SearchTree.C_SearchTree t5
  -> Control.Search.Curry_SearchTree.C_SearchTree t4
  -> Control.Search.Curry_SearchTree.C_SearchTree t3
  -> Control.Search.Curry_SearchTree.C_SearchTree t2
  -> Control.Search.Curry_SearchTree.C_SearchTree t1 -> IDSupply -> Cover
  -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_C_genCons5 x1 x2 x3 x4 x5 x6 s cd cs = let s0 = s
  in s0 `seq` nd_C_valsTo x2 (wrapNX id (nd_OP_genCons5_dot_uscore_hash_lambda10
  x6 x5 x4 x3 x1)) s0 cd cs

d_OP_genCons5_dot_uscore_hash_lambda10 :: forall t0 t1 t2 t3 t4
  t5 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t5, Curry_Prelude.Curry
  t0) => Control.Search.Curry_SearchTree.C_SearchTree t1
  -> Control.Search.Curry_SearchTree.C_SearchTree t2
  -> Control.Search.Curry_SearchTree.C_SearchTree t3
  -> Control.Search.Curry_SearchTree.C_SearchTree t4 -> (t5 -> Cover
  -> ConstStore -> t4 -> Cover -> ConstStore -> t3 -> Cover -> ConstStore -> t2
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> t5 -> Cover
  -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree t0
d_OP_genCons5_dot_uscore_hash_lambda10 x1 x2 x3 x4 x5 x6 cd cs = d_C_valsTo x4
  (d_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x6 x1 x2 x3
  x5) cd cs

nd_OP_genCons5_dot_uscore_hash_lambda10 :: forall t0 t1 t2 t3 t4
  t5 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t5, Curry_Prelude.Curry
  t0) => Control.Search.Curry_SearchTree.C_SearchTree t1
  -> Control.Search.Curry_SearchTree.C_SearchTree t2
  -> Control.Search.Curry_SearchTree.C_SearchTree t3
  -> Control.Search.Curry_SearchTree.C_SearchTree t4 -> Func t5 (Func t4 (Func
  t3 (Func t2 (Func t1 t0)))) -> t5 -> IDSupply -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_OP_genCons5_dot_uscore_hash_lambda10 x1 x2 x3 x4 x5 x6 s cd cs = let s0 = s
  in s0 `seq` nd_C_valsTo x4 (wrapNX id
  (nd_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x6 x1 x2 x3
  x5)) s0 cd cs

d_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 :: forall t0 t1
  t2 t3 t4 t5 . (Curry_Prelude.Curry t5, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t3, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t0) => t5
  -> Control.Search.Curry_SearchTree.C_SearchTree t1
  -> Control.Search.Curry_SearchTree.C_SearchTree t2
  -> Control.Search.Curry_SearchTree.C_SearchTree t3 -> (t5 -> Cover
  -> ConstStore -> t4 -> Cover -> ConstStore -> t3 -> Cover -> ConstStore -> t2
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> t4 -> Cover
  -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree t0
d_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x1 x2 x3 x4 x5 x6 cd cs =
  d_C_valsTo x4
  (d_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12
  x6 x1 x2 x3 x5) cd cs

nd_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 :: forall t0 t1
  t2 t3 t4 t5 . (Curry_Prelude.Curry t5, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t3, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t0) => t5
  -> Control.Search.Curry_SearchTree.C_SearchTree t1
  -> Control.Search.Curry_SearchTree.C_SearchTree t2
  -> Control.Search.Curry_SearchTree.C_SearchTree t3 -> Func t5 (Func t4 (Func
  t3 (Func t2 (Func t1 t0)))) -> t4 -> IDSupply -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x1 x2 x3 x4 x5 x6 s cd cs =
  let s0 = s
  in s0 `seq` nd_C_valsTo x4 (wrapNX id
  (nd_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12
  x6 x1 x2 x3 x5)) s0 cd cs

d_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12 :: forall t0
  t1 t2 t3 t4 t5 . (Curry_Prelude.Curry t4, Curry_Prelude.Curry t5
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t0) => t4 -> t5
  -> Control.Search.Curry_SearchTree.C_SearchTree t1
  -> Control.Search.Curry_SearchTree.C_SearchTree t2 -> (t5 -> Cover
  -> ConstStore -> t4 -> Cover -> ConstStore -> t3 -> Cover -> ConstStore -> t2
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> t3 -> Cover
  -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree t0
d_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12 x1 x2 x3 x4 x5 x6 cd cs =
  d_C_valsTo x4
  (d_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12_dot_uscore_hash_lambda13
  x6 x1 x2 x3 x5) cd cs

nd_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12 :: forall t0
  t1 t2 t3 t4 t5 . (Curry_Prelude.Curry t4, Curry_Prelude.Curry t5
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t0) => t4 -> t5
  -> Control.Search.Curry_SearchTree.C_SearchTree t1
  -> Control.Search.Curry_SearchTree.C_SearchTree t2 -> Func t5 (Func t4 (Func
  t3 (Func t2 (Func t1 t0)))) -> t3 -> IDSupply -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12 x1 x2 x3 x4 x5 x6 s cd cs =
  let s0 = s
  in s0 `seq` nd_C_valsTo x4 (wrapNX id
  (nd_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12_dot_uscore_hash_lambda13
  x6 x1 x2 x3 x5)) s0 cd cs

d_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12_dot_uscore_hash_lambda13 :: forall t0
  t1 t2 t3 t4 t5 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t5, Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t0) => t3 -> t4 -> t5
  -> Control.Search.Curry_SearchTree.C_SearchTree t1 -> (t5 -> Cover
  -> ConstStore -> t4 -> Cover -> ConstStore -> t3 -> Cover -> ConstStore -> t2
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> t2 -> Cover
  -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree t0
d_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12_dot_uscore_hash_lambda13 x1 x2 x3 x4 x5 x6 cd cs =
  d_C_valsTo x4
  (d_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14
  x6 x1 x2 x3 x5) cd cs

nd_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12_dot_uscore_hash_lambda13 :: forall t0
  t1 t2 t3 t4 t5 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t5, Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t0) => t3 -> t4 -> t5
  -> Control.Search.Curry_SearchTree.C_SearchTree t1 -> Func t5 (Func t4 (Func
  t3 (Func t2 (Func t1 t0)))) -> t2 -> IDSupply -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12_dot_uscore_hash_lambda13 x1 x2 x3 x4 x5 x6 s cd cs =
  let s0 = s
  in s0 `seq` nd_C_valsTo x4 (wrapNX id
  (nd_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14
  x6 x1 x2 x3 x5)) s0 cd cs

d_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14 :: forall t0
  t1 t2 t3 t4 t5 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t5, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t2 -> t3 -> t4 -> t5 -> (t5 -> Cover
  -> ConstStore -> t4 -> Cover -> ConstStore -> t3 -> Cover -> ConstStore -> t2
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> t1 -> Cover
  -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree t0
d_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14 x1 x2 x3 x4 x5 x6 cd cs =
  Control.Search.Curry_SearchTree.C_Value (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply x5 x4 cd cs) x3 cd cs) x2 cd cs) x1 cd cs) x6 cd cs)

nd_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14 :: forall t0
  t1 t2 t3 t4 t5 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t5, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t2 -> t3 -> t4 -> t5 -> Func t5 (Func t4 (Func t3
  (Func t2 (Func t1 t0)))) -> t1 -> IDSupply -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_OP_genCons5_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14 x1 x2 x3 x4 x5 x6 s cd cs =
  let s8 = s
  in s8 `seq` Control.Search.Curry_SearchTree.C_Value (let s7 = leftSupply s8
                                                           s6 = rightSupply s8
  in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                      s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                      s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x5 x4
  s0 cd cs) x3 s1 cd cs)) x2 s3 cd cs)) x1 s5 cd cs)) x6 s7 cd cs))

d_C_genNat :: Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree Curry_Prelude.C_Int
d_C_genNat cd cs = Control.Search.Curry_SearchTree.C_Or
  (Control.Search.Curry_SearchTree.C_Value (Curry_Prelude.C_Int (1)))
  (Control.Search.Curry_SearchTree.C_Or (d_C_valsTo (d_C_genNat cd cs)
  d_OP_genNat_dot_uscore_hash_lambda15 cd cs) (d_C_valsTo (d_C_genNat cd cs)
  d_OP_genNat_dot_uscore_hash_lambda16 cd cs))

d_OP_genNat_dot_uscore_hash_lambda15 :: Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree
  Curry_Prelude.C_Int
d_OP_genNat_dot_uscore_hash_lambda15 x1 cd cs =
  Control.Search.Curry_SearchTree.C_Value
  (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.C_Int (2)) x1 cd cs)

d_OP_genNat_dot_uscore_hash_lambda16 :: Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree
  Curry_Prelude.C_Int
d_OP_genNat_dot_uscore_hash_lambda16 x1 cd cs =
  Control.Search.Curry_SearchTree.C_Value
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.C_Int (2)) x1 cd cs) (Curry_Prelude.C_Int (1)) cd cs)

d_C_genInt :: Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree Curry_Prelude.C_Int
d_C_genInt cd cs = Control.Search.Curry_SearchTree.C_Or (d_C_genNat cd cs)
  (Control.Search.Curry_SearchTree.C_Or (Control.Search.Curry_SearchTree.C_Value
  (Curry_Prelude.C_Int (0))) (d_C_valsTo (d_C_genNat cd cs)
  (Curry_Prelude.d_OP_dot (acceptCs id Control.Search.Curry_SearchTree.C_Value)
  (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.C_Int (0))) cd cs) cd cs))

d_C_genFloat :: Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree Curry_Prelude.C_Float
d_C_genFloat cd cs = Control.Search.Curry_SearchTree.C_Or (d_C_genPosFloat cd
  cs) (Control.Search.Curry_SearchTree.C_Or
  (Control.Search.Curry_SearchTree.C_Value (Curry_Prelude.C_Float 0.0##))
  (d_C_valsTo (d_C_genPosFloat cd cs) (Curry_Prelude.d_OP_dot (acceptCs id
  Control.Search.Curry_SearchTree.C_Value)
  (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Float_hash
  (Curry_Prelude.C_Float 0.0##)) cd cs) cd cs))

d_C_genPosFloat :: Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree Curry_Prelude.C_Float
d_C_genPosFloat cd cs = d_C_valsTo (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (d_C_genPair cd cs) (d_C_genNat cd cs) cd cs)
  (d_C_genNat cd cs) cd cs) (d_OP_genPosFloat_dot_ii2f_dot_45
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Fractional_hash_Prelude_dot_Float_hash)
  cd cs

d_OP_genPosFloat_dot_nat2float_dot_45 :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Fractional t0) -> t0
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> t0
d_OP_genPosFloat_dot_nat2float_dot_45 x1 x2 x3 cd cs = d_C__case_0 x3 x1 x2
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  x3 (Curry_Prelude.C_Int (0)) cd cs) cd cs

nd_OP_genPosFloat_dot_nat2float_dot_45 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Fractional t0) -> t0 -> Curry_Prelude.C_Int
  -> IDSupply -> Cover -> ConstStore -> t0
nd_OP_genPosFloat_dot_nat2float_dot_45 x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` nd_C__case_0 x3 x1 x2
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  x3 (Curry_Prelude.C_Int (0)) cd cs) s0 cd cs

d_OP_genPosFloat_dot_ii2f_dot_45 :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Fractional t0) -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
d_OP_genPosFloat_dot_ii2f_dot_45 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Control.Search.Curry_SearchTree.C_Value
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_plus
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 cd cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_fromInt
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 cd cs) cd cs) x3 cd cs) cd cs) (d_OP_genPosFloat_dot_nat2float_dot_45 x1
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_fromFloat x1 cd cs)
    (Curry_Prelude.C_Float 0.1##) cd cs) x4 cd cs) cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_genPosFloat_dot_ii2f_dot_45 x1 l cd cs)
    (d_OP_genPosFloat_dot_ii2f_dot_45 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_genPosFloat_dot_ii2f_dot_45 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_genPosFloat_dot_ii2f_dot_45 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Control.Search.SearchTree.Generators.genPosFloat.ii2f.45" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "Control.Search.SearchTree.Generators.genPosFloat.ii2f.45" (showCons x2))

nd_OP_genPosFloat_dot_ii2f_dot_45 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Fractional t0) -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0
nd_OP_genPosFloat_dot_ii2f_dot_45 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s17 = s
    in s17 `seq` Control.Search.Curry_SearchTree.C_Value (let s16 = leftSupply
                                                                s17
                                                              s18 = rightSupply
                                                                s17
                                                              s9 = leftSupply
                                                                s18
                                                              s15 = rightSupply
                                                                s18
    in s16 `seq` (s18 `seq` (s9 `seq` (s15 `seq` Curry_Prelude.nd_C_apply
    (let s8 = leftSupply s9
         s10 = rightSupply s9
         s2 = leftSupply s10
         s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s2 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_plus
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 s0 cd cs) s1 cd cs)) (let s6 = leftSupply s7
                                 s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                        s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_fromInt
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 s3 cd cs) s4 cd cs)) x3 s6 cd cs)) s8 cd cs)))) (let s14 = leftSupply s15
                                                            s13 = rightSupply
                                                              s15
    in s14 `seq` (s13 `seq` nd_OP_genPosFloat_dot_nat2float_dot_45 x1
    (let s12 = leftSupply s13
         s11 = rightSupply s13
    in s12 `seq` (s11 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_fromFloat x1 s11 cd cs) (Curry_Prelude.C_Float 0.1##)
    s12 cd cs)) x4 s14 cd cs)) s16 cd cs))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_genPosFloat_dot_ii2f_dot_45 x1 l s cd cs)
    (nd_OP_genPosFloat_dot_ii2f_dot_45 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_genPosFloat_dot_ii2f_dot_45 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_genPosFloat_dot_ii2f_dot_45 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Control.Search.SearchTree.Generators.genPosFloat.ii2f.45" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "Control.Search.SearchTree.Generators.genPosFloat.ii2f.45" (showCons x2))

d_C_genBool :: Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree Curry_Prelude.C_Bool
d_C_genBool cd cs = Control.Search.Curry_SearchTree.C_Or
  (Control.Search.Curry_SearchTree.C_Value Curry_Prelude.C_False)
  (Control.Search.Curry_SearchTree.C_Value Curry_Prelude.C_True)

d_C_genChar :: Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree Curry_Prelude.C_Char
d_C_genChar cd cs = let x1 = Curry_Prelude.d_C_map Curry_Prelude.d_C_chr
                          (Curry_Prelude.d_OP_plus_plus
                          (Curry_Prelude.d_OP_uscore_impl_hash_enumFromTo_hash_Prelude_dot_Enum_hash_Prelude_dot_Int_hash
                          (Curry_Prelude.C_Int (65)) (Curry_Prelude.C_Int (90))
                          cd cs) (Curry_Prelude.d_OP_plus_plus
                          (Curry_Prelude.d_OP_uscore_impl_hash_enumFromTo_hash_Prelude_dot_Enum_hash_Prelude_dot_Int_hash
                          (Curry_Prelude.C_Int (97)) (Curry_Prelude.C_Int (122))
                          cd cs)
                          (Curry_Prelude.d_OP_uscore_impl_hash_enumFromTo_hash_Prelude_dot_Enum_hash_Prelude_dot_Int_hash
                          (Curry_Prelude.C_Int (48)) (Curry_Prelude.C_Int (57))
                          cd cs) cd cs) cd cs) cd cs
  in Curry_Prelude.d_C_foldr1 (acceptCs (acceptCs id)
  Control.Search.Curry_SearchTree.C_Or) (Curry_Prelude.d_C_map (acceptCs id
  Control.Search.Curry_SearchTree.C_Value) x1 cd cs) cd cs

d_C_genList :: forall t0 . (Curry_Prelude.Curry
  t0) => Control.Search.Curry_SearchTree.C_SearchTree t0 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree (Curry_Prelude.OP_List t0)
d_C_genList x1 cd cs = Control.Search.Curry_SearchTree.C_Or
  (Control.Search.Curry_SearchTree.C_Value Curry_Prelude.OP_List) (d_C_genCons2
  (acceptCs (acceptCs id) Curry_Prelude.OP_Cons) x1 (d_C_genList x1 cd cs) cd
  cs)

d_C_genMaybe :: forall t0 . (Curry_Prelude.Curry
  t0) => Control.Search.Curry_SearchTree.C_SearchTree t0 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree (Curry_Prelude.C_Maybe t0)
d_C_genMaybe x1 cd cs = d_OP_bar_bar_bar
  (Control.Search.Curry_SearchTree.C_Value Curry_Prelude.C_Nothing)
  (d_C_genCons1 (acceptCs id Curry_Prelude.C_Just) x1 cd cs) cd cs

d_C_genEither :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Control.Search.Curry_SearchTree.C_SearchTree t1
  -> Control.Search.Curry_SearchTree.C_SearchTree t0 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree (Curry_Prelude.C_Either t1 t0)
d_C_genEither x1 x2 cd cs = d_OP_bar_bar_bar (d_C_genCons1 (acceptCs id
  Curry_Prelude.C_Left) x1 cd cs) (d_C_genCons1 (acceptCs id
  Curry_Prelude.C_Right) x2 cd cs) cd cs

d_C_genUnit :: Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree Curry_Prelude.OP_Unit
d_C_genUnit cd cs = Control.Search.Curry_SearchTree.C_Value
  Curry_Prelude.OP_Unit

d_C_genPair :: Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Control.Search.Curry_SearchTree.C_SearchTree t1
  -> Cover -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree t0
  -> Cover -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree
  (Curry_Prelude.OP_Tuple2 t1 t0)
d_C_genPair cd cs = acceptCs id (d_C_genCons2 (acceptCs id
  d_OP_genPair_dot_uscore_hash_lambda17))

nd_C_genPair :: IDSupply -> Cover -> ConstStore -> forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  (Control.Search.Curry_SearchTree.C_SearchTree t1) (Func
  (Control.Search.Curry_SearchTree.C_SearchTree t0)
  (Control.Search.Curry_SearchTree.C_SearchTree (Curry_Prelude.OP_Tuple2 t1
  t0)))
nd_C_genPair s cd cs = wrapDX (wrapNX id) (acceptCs id (nd_C_genCons2 (wrapDX
  (wrapDX id) (acceptCs id d_OP_genPair_dot_uscore_hash_lambda17))))

d_OP_genPair_dot_uscore_hash_lambda17 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t1 -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 t0
d_OP_genPair_dot_uscore_hash_lambda17 x1 x2 cd cs = Curry_Prelude.OP_Tuple2 x1
  x2

d_C_genTriple :: Cover -> ConstStore -> forall t0 t1 t2 . (Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Control.Search.Curry_SearchTree.C_SearchTree t2 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t1 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree (Curry_Prelude.OP_Tuple3 t2 t1
  t0)
d_C_genTriple cd cs = acceptCs (acceptCs id) (d_C_genCons3 (acceptCs (acceptCs
  id) d_OP_genTriple_dot_uscore_hash_lambda18))

nd_C_genTriple :: IDSupply -> Cover -> ConstStore -> forall t0 t1
  t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func (Control.Search.Curry_SearchTree.C_SearchTree t2) (Func
  (Control.Search.Curry_SearchTree.C_SearchTree t1) (Func
  (Control.Search.Curry_SearchTree.C_SearchTree t0)
  (Control.Search.Curry_SearchTree.C_SearchTree (Curry_Prelude.OP_Tuple3 t2 t1
  t0))))
nd_C_genTriple s cd cs = wrapDX (wrapDX (wrapNX id)) (acceptCs (acceptCs id)
  (nd_C_genCons3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs id)
  d_OP_genTriple_dot_uscore_hash_lambda18))))

d_OP_genTriple_dot_uscore_hash_lambda18 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t2 -> t1 -> t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 t2 t1
  t0
d_OP_genTriple_dot_uscore_hash_lambda18 x1 x2 x3 cd cs = Curry_Prelude.OP_Tuple3
  x1 x2 x3

d_C_genTuple4 :: Cover -> ConstStore -> forall t0 t1 t2
  t3 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Control.Search.Curry_SearchTree.C_SearchTree t3
  -> Cover -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree t2
  -> Cover -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree t1
  -> Cover -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree t0
  -> Cover -> ConstStore -> Control.Search.Curry_SearchTree.C_SearchTree
  (Curry_Prelude.OP_Tuple4 t3 t2 t1 t0)
d_C_genTuple4 cd cs = acceptCs (acceptCs (acceptCs id)) (d_C_genCons4 (acceptCs
  (acceptCs (acceptCs id)) d_OP_genTuple4_dot_uscore_hash_lambda19))

nd_C_genTuple4 :: IDSupply -> Cover -> ConstStore -> forall t0 t1 t2
  t3 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func
  (Control.Search.Curry_SearchTree.C_SearchTree t3) (Func
  (Control.Search.Curry_SearchTree.C_SearchTree t2) (Func
  (Control.Search.Curry_SearchTree.C_SearchTree t1) (Func
  (Control.Search.Curry_SearchTree.C_SearchTree t0)
  (Control.Search.Curry_SearchTree.C_SearchTree (Curry_Prelude.OP_Tuple4 t3 t2
  t1 t0)))))
nd_C_genTuple4 s cd cs = wrapDX (wrapDX (wrapDX (wrapNX id))) (acceptCs
  (acceptCs (acceptCs id)) (nd_C_genCons4 (wrapDX (wrapDX (wrapDX (wrapDX id)))
  (acceptCs (acceptCs (acceptCs id)) d_OP_genTuple4_dot_uscore_hash_lambda19))))

d_OP_genTuple4_dot_uscore_hash_lambda19 :: forall t0 t1 t2
  t3 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t3 -> t2 -> t1 -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 t3 t2 t1 t0
d_OP_genTuple4_dot_uscore_hash_lambda19 x1 x2 x3 x4 cd cs =
  Curry_Prelude.OP_Tuple4 x1 x2 x3 x4

d_C_genTuple5 :: Cover -> ConstStore -> forall t0 t1 t2 t3
  t4 . (Curry_Prelude.Curry t4, Curry_Prelude.Curry t3, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Control.Search.Curry_SearchTree.C_SearchTree t4 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t3 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t2 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t1 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree t0 -> Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree (Curry_Prelude.OP_Tuple5 t4 t3
  t2 t1 t0)
d_C_genTuple5 cd cs = acceptCs (acceptCs (acceptCs (acceptCs id))) (d_C_genCons5
  (acceptCs (acceptCs (acceptCs (acceptCs id)))
  d_OP_genTuple5_dot_uscore_hash_lambda20))

nd_C_genTuple5 :: IDSupply -> Cover -> ConstStore -> forall t0 t1 t2 t3
  t4 . (Curry_Prelude.Curry t4, Curry_Prelude.Curry t3, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  (Control.Search.Curry_SearchTree.C_SearchTree t4) (Func
  (Control.Search.Curry_SearchTree.C_SearchTree t3) (Func
  (Control.Search.Curry_SearchTree.C_SearchTree t2) (Func
  (Control.Search.Curry_SearchTree.C_SearchTree t1) (Func
  (Control.Search.Curry_SearchTree.C_SearchTree t0)
  (Control.Search.Curry_SearchTree.C_SearchTree (Curry_Prelude.OP_Tuple5 t4 t3
  t2 t1 t0))))))
nd_C_genTuple5 s cd cs = wrapDX (wrapDX (wrapDX (wrapDX (wrapNX id)))) (acceptCs
  (acceptCs (acceptCs (acceptCs id))) (nd_C_genCons5 (wrapDX (wrapDX (wrapDX
  (wrapDX (wrapDX id)))) (acceptCs (acceptCs (acceptCs (acceptCs id)))
  d_OP_genTuple5_dot_uscore_hash_lambda20))))

d_OP_genTuple5_dot_uscore_hash_lambda20 :: forall t0 t1 t2 t3
  t4 . (Curry_Prelude.Curry t4, Curry_Prelude.Curry t3, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t4 -> t3 -> t2 -> t1
  -> t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple5 t4 t3 t2 t1 t0
d_OP_genTuple5_dot_uscore_hash_lambda20 x1 x2 x3 x4 x5 cd cs =
  Curry_Prelude.OP_Tuple5 x1 x2 x3 x4 x5

d_C_genOrdering :: Cover -> ConstStore
  -> Control.Search.Curry_SearchTree.C_SearchTree Curry_Prelude.C_Ordering
d_C_genOrdering cd cs = Control.Search.Curry_SearchTree.C_Or
  (Control.Search.Curry_SearchTree.C_Value Curry_Prelude.C_LT)
  (Control.Search.Curry_SearchTree.C_Or (Control.Search.Curry_SearchTree.C_Value
  Curry_Prelude.C_EQ) (Control.Search.Curry_SearchTree.C_Value
  Curry_Prelude.C_GT))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Fractional t0) -> t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> t0
d_C__case_0 x3 x1 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_fromInt
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 cd cs) cd cs) (Curry_Prelude.C_Int (0)) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_plus
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 cd cs) cd cs) (d_OP_genPosFloat_dot_nat2float_dot_45 x1
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_slash
    x1 cd cs) x2 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_fromInt
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 cd cs) cd cs) (Curry_Prelude.C_Int (10)) cd cs) cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_div_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
    cd cs) x3 cd cs) (Curry_Prelude.C_Int (10)) cd cs) cd cs) cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_star
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 cd cs) cd cs) x2 cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_fromInt
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 cd cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_mod_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
    cd cs) x3 cd cs) (Curry_Prelude.C_Int (10)) cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x3 x1 x2 l cd
    cs) (d_C__case_0 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x3 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x3 x1 x2
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Control.Search.SearchTree.Generators._case_0" [show x3, show x1, show x2
    , show x4] info)
  _ -> failCons cd (consFail "Control.Search.SearchTree.Generators._case_0"
    (showCons x4))

nd_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Fractional
  t0) -> t0 -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> t0
nd_C__case_0 x3 x1 x2 x4 s cd cs = case x4 of
  Curry_Prelude.C_True -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_fromInt
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 s0 cd cs) s1 cd cs)) (Curry_Prelude.C_Int (0)) s3 cd cs))
  Curry_Prelude.C_False -> let s41 = s
    in s41 `seq` (let s40 = leftSupply s41
                      s42 = rightSupply s41
                      s21 = leftSupply s42
                      s38 = rightSupply s42
    in s40 `seq` (s42 `seq` (s21 `seq` (s38 `seq` Curry_Prelude.nd_C_apply
    (let s20 = leftSupply s21
         s22 = rightSupply s21
         s2 = leftSupply s22
         s18 = rightSupply s22
    in s20 `seq` (s22 `seq` (s2 `seq` (s18 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_plus
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 s0 cd cs) s1 cd cs)) (let s17 = leftSupply s18
                                 s19 = rightSupply s18
                                 s12 = leftSupply s19
                                 s16 = rightSupply s19
    in s17 `seq` (s19 `seq` (s12 `seq` (s16 `seq`
    nd_OP_genPosFloat_dot_nat2float_dot_45 x1 (let s11 = leftSupply s12
                                                   s13 = rightSupply s12
                                                   s5 = leftSupply s13
                                                   s10 = rightSupply s13
    in s11 `seq` (s13 `seq` (s5 `seq` (s10 `seq` Curry_Prelude.nd_C_apply
    (let s4 = leftSupply s5
         s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_slash x1
    s3 cd cs) x2 s4 cd cs)) (let s9 = leftSupply s10
                                 s8 = rightSupply s10
    in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (let s7 = leftSupply s8
                                                        s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_fromInt
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 s6 cd cs) s7 cd cs)) (Curry_Prelude.C_Int (10)) s9 cd cs)) s11 cd cs))))
    (let s15 = leftSupply s16
         s14 = rightSupply s16
    in s15 `seq` (s14 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_div_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
    cd cs)) x3 s14 cd cs) (Curry_Prelude.C_Int (10)) s15 cd cs)) s17 cd cs))))
    s20 cd cs)))) (let s37 = leftSupply s38
                       s39 = rightSupply s38
                       s27 = leftSupply s39
                       s35 = rightSupply s39
    in s37 `seq` (s39 `seq` (s27 `seq` (s35 `seq` Curry_Prelude.nd_C_apply
    (let s26 = leftSupply s27
         s25 = rightSupply s27
    in s26 `seq` (s25 `seq` Curry_Prelude.nd_C_apply (let s24 = leftSupply s25
                                                          s23 = rightSupply s25
    in s24 `seq` (s23 `seq` Curry_Prelude.nd_OP_star
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 s23 cd cs) s24 cd cs)) x2 s26 cd cs)) (let s34 = leftSupply s35
                                                  s36 = rightSupply s35
                                                  s30 = leftSupply s36
                                                  s33 = rightSupply s36
    in s34 `seq` (s36 `seq` (s30 `seq` (s33 `seq` Curry_Prelude.nd_C_apply
    (let s29 = leftSupply s30
         s28 = rightSupply s30
    in s29 `seq` (s28 `seq` Curry_Prelude.nd_C_fromInt
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Fractional_hash_Prelude_dot_Num_hash_0_hash
    x1 s28 cd cs) s29 cd cs)) (let s32 = leftSupply s33
                                   s31 = rightSupply s33
    in s32 `seq` (s31 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_mod_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
    cd cs)) x3 s31 cd cs) (Curry_Prelude.C_Int (10)) s32 cd cs)) s34 cd cs))))
    s37 cd cs)))) s40 cd cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_0 x3 x1 x2 l s
    cd cs) (nd_C__case_0 x3 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_0 x3
    x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_0 x3 x1
    x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Control.Search.SearchTree.Generators._case_0" [show x3, show x1, show x2
    , show x4] info)
  _ -> failCons cd (consFail "Control.Search.SearchTree.Generators._case_0"
    (showCons x4))

