{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Solver.SMTLIB.Curry_Types
  ( C_SMTSolver (..)
  , C_SMTOpts (..)
  , C_SMTError (..)
  , d_OP_uscore_inst_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
  , nd_OP_uscore_inst_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
  , d_OP_uscore_impl_hash_pretty_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
  , nd_OP_uscore_impl_hash_pretty_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
  , d_OP_uscore_impl_hash_prettyList_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
  , nd_OP_uscore_impl_hash_prettyList_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTSolver_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTSolver_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTSolver_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTOpts_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTOpts_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTOpts_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
  , d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
  , d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
  , d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
  , d_C_executable
  , d_C_flags
  , d_C_incremental
  , d_C_quiet
  , d_C_tracing
  , d_C_globalCmds )
  where

import Basics
import qualified Language.SMTLIB.Curry_Types
import qualified Curry_Prelude
import qualified Text.Curry_Pretty
import qualified Text.Curry_PrettyImpl


data C_SMTSolver
  = C_SMTSolver (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  | Choice_C_SMTSolver Cover ID C_SMTSolver C_SMTSolver
  | Choices_C_SMTSolver Cover ID [C_SMTSolver]
  | Fail_C_SMTSolver Cover FailInfo
  | Guard_C_SMTSolver Cover Constraints C_SMTSolver

instance Show C_SMTSolver where
  showsPrec d (Choice_C_SMTSolver cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_SMTSolver cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_SMTSolver cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_SMTSolver cd info) = showChar '!'
  showsPrec _ (C_SMTSolver x1 x2) = showString "(SMTSolver" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))

instance Read C_SMTSolver where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_SMTSolver x1 x2, r2) | (_, r0)
    <- readQualified "Solver.SMTLIB.Types" "SMTSolver" r, (x1, r1) <- readsPrec
    11 r0, (x2, r2) <- readsPrec 11 r1]) s

instance NonDet C_SMTSolver where
  choiceCons = Choice_C_SMTSolver
  choicesCons = Choices_C_SMTSolver
  failCons = Fail_C_SMTSolver
  guardCons = Guard_C_SMTSolver
  try (Choice_C_SMTSolver cd i x y) = tryChoice cd i x y
  try (Choices_C_SMTSolver cd i xs) = tryChoices cd i xs
  try (Fail_C_SMTSolver cd info) = Fail cd info
  try (Guard_C_SMTSolver cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_SMTSolver cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_SMTSolver cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_SMTSolver cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_SMTSolver cd i _) = error
    ("Solver.SMTLIB.Types.SMTSolver.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_SMTSolver cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_SMTSolver cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_SMTSolver where
  generate s c = Choices_C_SMTSolver c (freeID [2] s) [C_SMTSolver (generate
    (leftSupply s) c) (generate (rightSupply s) c)]

instance NormalForm C_SMTSolver where
  ($!!) cont (C_SMTSolver x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_SMTSolver y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_SMTSolver cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_SMTSolver cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_SMTSolver cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_SMTSolver cd info) _ _ = failCons cd info
  ($##) cont (C_SMTSolver x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_SMTSolver y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_SMTSolver cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_SMTSolver cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_SMTSolver cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_SMTSolver cd info) _ _ = failCons cd info
  showCons (C_SMTSolver _ _) = "Solver.SMTLIB.Types.SMTSolver _ _"
  showCons x = error
    ("Solver.SMTLIB.Types.SMTSolver.showCons: no constructor: " ++ show x)
  searchNF search cont (C_SMTSolver x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_SMTSolver y1 y2)) x2) x1
  searchNF _ _ x = error
    ("Solver.SMTLIB.Types.SMTSolver.searchNF: no constructor: " ++ show x)

instance Unifiable C_SMTSolver where
  (=.=) (C_SMTSolver x1 x2) (C_SMTSolver y1 y2) d cs = (&) ((=:=) x1 y1 d cs)
    ((=:=) x2 y2 d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_SMTSolver x1 x2) (C_SMTSolver y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_SMTSolver x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID
    i) x3, bind cd (rightID i) x4]
  bind d i (Choice_C_SMTSolver cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_SMTSolver cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_SMTSolver cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_SMTSolver cd i _) = error
    ("Solver.SMTLIB.Types.SMTSolver.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_SMTSolver cd info) = [Unsolvable info]
  bind d i (Guard_C_SMTSolver cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_SMTSolver x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind d i (Choice_C_SMTSolver cd j x y) = [ConstraintChoice cd j (lazyBind
    d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_SMTSolver cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_SMTSolver cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_SMTSolver cd i _) = error
    ("Solver.SMTLIB.Types.SMTSolver.lazyBind: Choices with ChoiceID: " ++ show
    i)
  lazyBind _ _ (Fail_C_SMTSolver cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_SMTSolver cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_SMTSolver where

data C_SMTOpts
  = C_SMTOpts Curry_Prelude.C_Bool Curry_Prelude.C_Bool Curry_Prelude.C_Bool
    (Curry_Prelude.OP_List Language.SMTLIB.Curry_Types.C_Command)
  | Choice_C_SMTOpts Cover ID C_SMTOpts C_SMTOpts
  | Choices_C_SMTOpts Cover ID [C_SMTOpts]
  | Fail_C_SMTOpts Cover FailInfo
  | Guard_C_SMTOpts Cover Constraints C_SMTOpts

instance Show C_SMTOpts where
  showsPrec d (Choice_C_SMTOpts cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_SMTOpts cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_SMTOpts cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_SMTOpts cd info) = showChar '!'
  showsPrec _ (C_SMTOpts x1 x2 x3 x4) = showString "(SMTOpts" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 .
    (showChar ' ' . (shows x4 . showChar ')'))))))))

instance Read C_SMTOpts where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_SMTOpts x1 x2 x3 x4, r4) | (_
    , r0) <- readQualified "Solver.SMTLIB.Types" "SMTOpts" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2,
    (x4, r4) <- readsPrec 11 r3]) s

instance NonDet C_SMTOpts where
  choiceCons = Choice_C_SMTOpts
  choicesCons = Choices_C_SMTOpts
  failCons = Fail_C_SMTOpts
  guardCons = Guard_C_SMTOpts
  try (Choice_C_SMTOpts cd i x y) = tryChoice cd i x y
  try (Choices_C_SMTOpts cd i xs) = tryChoices cd i xs
  try (Fail_C_SMTOpts cd info) = Fail cd info
  try (Guard_C_SMTOpts cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_SMTOpts cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_SMTOpts cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_SMTOpts cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_SMTOpts cd i _) = error
    ("Solver.SMTLIB.Types.SMTOpts.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_SMTOpts cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_SMTOpts cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_SMTOpts where
  generate s c = Choices_C_SMTOpts c (freeID [4] s) [C_SMTOpts (generate
    (leftSupply (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c)
    (generate (leftSupply (rightSupply s)) c) (generate (rightSupply
    (rightSupply s)) c)]

instance NormalForm C_SMTOpts where
  ($!!) cont (C_SMTOpts x1 x2 x3 x4) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> cont (C_SMTOpts y1 y2 y3
    y4) d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_SMTOpts cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_SMTOpts cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_SMTOpts cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_SMTOpts cd info) _ _ = failCons cd info
  ($##) cont (C_SMTOpts x1 x2 x3 x4) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> ($##) (\y3 d cs -> ($##) (\y4 d cs -> cont (C_SMTOpts y1 y2 y3
    y4) d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_SMTOpts cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_SMTOpts cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_SMTOpts cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_SMTOpts cd info) _ _ = failCons cd info
  showCons (C_SMTOpts _ _ _ _) = "Solver.SMTLIB.Types.SMTOpts _ _ _ _"
  showCons x = error
    ("Solver.SMTLIB.Types.SMTOpts.showCons: no constructor: " ++ show x)
  searchNF search cont (C_SMTOpts x1 x2 x3 x4) = search (\y1 -> search (\y2 ->
    search (\y3 -> search (\y4 -> cont (C_SMTOpts y1 y2 y3 y4)) x4) x3) x2) x1
  searchNF _ _ x = error
    ("Solver.SMTLIB.Types.SMTOpts.searchNF: no constructor: " ++ show x)

instance Unifiable C_SMTOpts where
  (=.=) (C_SMTOpts x1 x2 x3 x4) (C_SMTOpts y1 y2 y3 y4) d cs = (&) ((=:=) x1 y1
    d cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((=:=) x4 y4 d cs) d
    cs) d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_SMTOpts x1 x2 x3 x4) (C_SMTOpts y1 y2 y3 y4) d cs = (&) ((=:<=) x1
    y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs) ((=:<=) x4 y4 d
    cs) d cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_SMTOpts x3 x4 x5 x6) = (i :=: ChooseN 0 4) : concat [bind cd
    (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (leftID
    (rightID i)) x5, bind cd (rightID (rightID i)) x6]
  bind d i (Choice_C_SMTOpts cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_SMTOpts cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_SMTOpts cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_SMTOpts cd i _) = error
    ("Solver.SMTLIB.Types.SMTOpts.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_SMTOpts cd info) = [Unsolvable info]
  bind d i (Guard_C_SMTOpts cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_SMTOpts x3 x4 x5 x6) = (i :=: ChooseN 0 4) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), leftID (rightID i) :=:
    LazyBind (lazyBind cd (leftID (rightID i)) x5), rightID (rightID i) :=:
    LazyBind (lazyBind cd (rightID (rightID i)) x6)]
  lazyBind d i (Choice_C_SMTOpts cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_SMTOpts cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_SMTOpts cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_SMTOpts cd i _) = error
    ("Solver.SMTLIB.Types.SMTOpts.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_SMTOpts cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_SMTOpts cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_SMTOpts where

data C_SMTError
  = C_SolverError (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_ParserError (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_OtherError (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | Choice_C_SMTError Cover ID C_SMTError C_SMTError
  | Choices_C_SMTError Cover ID [C_SMTError]
  | Fail_C_SMTError Cover FailInfo
  | Guard_C_SMTError Cover Constraints C_SMTError

instance Show C_SMTError where
  showsPrec d (Choice_C_SMTError cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_SMTError cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_SMTError cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_SMTError cd info) = showChar '!'
  showsPrec _ (C_SolverError x1) = showString "(SolverError" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (C_ParserError x1) = showString "(ParserError" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (C_OtherError x1) = showString "(OtherError" . (showChar ' ' .
    (shows x1 . showChar ')'))

instance Read C_SMTError where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_SolverError x1, r1) | (_, r0)
    <- readQualified "Solver.SMTLIB.Types" "SolverError" r, (x1, r1) <-
    readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_ParserError x1
    , r1) | (_, r0) <- readQualified "Solver.SMTLIB.Types" "ParserError" r, (x1
    , r1) <- readsPrec 11 r0]) s ++ readParen ((>) d 10) (\r -> [(C_OtherError
    x1, r1) | (_, r0) <- readQualified "Solver.SMTLIB.Types" "OtherError" r, (x1
    , r1) <- readsPrec 11 r0]) s)

instance NonDet C_SMTError where
  choiceCons = Choice_C_SMTError
  choicesCons = Choices_C_SMTError
  failCons = Fail_C_SMTError
  guardCons = Guard_C_SMTError
  try (Choice_C_SMTError cd i x y) = tryChoice cd i x y
  try (Choices_C_SMTError cd i xs) = tryChoices cd i xs
  try (Fail_C_SMTError cd info) = Fail cd info
  try (Guard_C_SMTError cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_SMTError cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_SMTError cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_SMTError cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_SMTError cd i _) = error
    ("Solver.SMTLIB.Types.SMTError.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_SMTError cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_SMTError cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_SMTError where
  generate s c = Choices_C_SMTError c (freeID [1, 1, 1] s) [C_SolverError
    (generate (leftSupply s) c), C_ParserError (generate (leftSupply s) c)
    , C_OtherError (generate (leftSupply s) c)]

instance NormalForm C_SMTError where
  ($!!) cont (C_SolverError x1) d cs = ($!!) (\y1 d cs -> cont (C_SolverError
    y1) d cs) x1 d cs
  ($!!) cont (C_ParserError x1) d cs = ($!!) (\y1 d cs -> cont (C_ParserError
    y1) d cs) x1 d cs
  ($!!) cont (C_OtherError x1) d cs = ($!!) (\y1 d cs -> cont (C_OtherError y1)
    d cs) x1 d cs
  ($!!) cont (Choice_C_SMTError cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_SMTError cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_SMTError cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_SMTError cd info) _ _ = failCons cd info
  ($##) cont (C_SolverError x1) d cs = ($##) (\y1 d cs -> cont (C_SolverError
    y1) d cs) x1 d cs
  ($##) cont (C_ParserError x1) d cs = ($##) (\y1 d cs -> cont (C_ParserError
    y1) d cs) x1 d cs
  ($##) cont (C_OtherError x1) d cs = ($##) (\y1 d cs -> cont (C_OtherError y1)
    d cs) x1 d cs
  ($##) cont (Choice_C_SMTError cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_SMTError cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_SMTError cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_SMTError cd info) _ _ = failCons cd info
  showCons (C_SolverError _) = "Solver.SMTLIB.Types.SolverError _"
  showCons (C_ParserError _) = "Solver.SMTLIB.Types.ParserError _"
  showCons (C_OtherError _) = "Solver.SMTLIB.Types.OtherError _"
  showCons x = error
    ("Solver.SMTLIB.Types.SMTError.showCons: no constructor: " ++ show x)
  searchNF search cont (C_SolverError x1) = search (\y1 -> cont (C_SolverError
    y1)) x1
  searchNF search cont (C_ParserError x1) = search (\y1 -> cont (C_ParserError
    y1)) x1
  searchNF search cont (C_OtherError x1) = search (\y1 -> cont (C_OtherError
    y1)) x1
  searchNF _ _ x = error
    ("Solver.SMTLIB.Types.SMTError.searchNF: no constructor: " ++ show x)

instance Unifiable C_SMTError where
  (=.=) (C_SolverError x1) (C_SolverError y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_ParserError x1) (C_ParserError y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_OtherError x1) (C_OtherError y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_SolverError x1) (C_SolverError y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_ParserError x1) (C_ParserError y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_OtherError x1) (C_OtherError y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_SolverError x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID
    i) x3]
  bind cd i (C_ParserError x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID
    i) x3]
  bind cd i (C_OtherError x3) = (i :=: ChooseN 2 1) : concat [bind cd (leftID i)
    x3]
  bind d i (Choice_C_SMTError cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_SMTError cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_SMTError cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_SMTError cd i _) = error
    ("Solver.SMTLIB.Types.SMTError.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_SMTError cd info) = [Unsolvable info]
  bind d i (Guard_C_SMTError cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_SolverError x3) = (i :=: ChooseN 0 1) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_ParserError x3) = (i :=: ChooseN 1 1) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_OtherError x3) = (i :=: ChooseN 2 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_SMTError cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_SMTError cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_SMTError cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_SMTError cd i _) = error
    ("Solver.SMTLIB.Types.SMTError.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_SMTError cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_SMTError cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_SMTError where

d_OP_uscore_inst_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Text.Curry_Pretty.OP_uscore_Dict_hash_Pretty
  C_SMTError
d_OP_uscore_inst_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Text.Curry_Pretty.OP_uscore_Dict_hash_Pretty
    d_OP_uscore_impl_hash_pretty_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    (d_OP_uscore_impl_hash_prettyList_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Solver.SMTLIB.Types._inst#Text.Pretty.Pretty#Solver.SMTLIB.Types.SMTError#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Solver.SMTLIB.Types._inst#Text.Pretty.Pretty#Solver.SMTLIB.Types.SMTError#"
    (showCons x1))

nd_OP_uscore_inst_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_Pretty.OP_uscore_Dict_hash_Pretty C_SMTError
nd_OP_uscore_inst_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.HO_OP_uscore_Dict_hash_Pretty (wrapNX id
    nd_OP_uscore_impl_hash_pretty_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash)
    (nd_OP_uscore_impl_hash_prettyList_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Solver.SMTLIB.Types._inst#Text.Pretty.Pretty#Solver.SMTLIB.Types.SMTError#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Solver.SMTLIB.Types._inst#Text.Pretty.Pretty#Solver.SMTLIB.Types.SMTError#"
    (showCons x1))

d_OP_uscore_impl_hash_pretty_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash :: C_SMTError
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_OP_uscore_impl_hash_pretty_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash x1 cd cs =
  case x1 of
  C_SolverError x2 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "Solver Error:") cd cs) cd cs)
    (Text.Curry_Pretty.d_C_text x2 cd cs) cd cs
  C_ParserError x3 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "Parser Error:") cd cs) cd cs)
    (Text.Curry_Pretty.d_C_text x3 cd cs) cd cs
  C_OtherError x4 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "Error:") cd cs) cd cs)
    (Text.Curry_Pretty.d_C_text x4 cd cs) cd cs
  Choice_C_SMTError d i l r -> narrow d i
    (d_OP_uscore_impl_hash_pretty_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    l cd cs)
    (d_OP_uscore_impl_hash_pretty_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    r cd cs)
  Choices_C_SMTError d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_pretty_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    z cd cs) xs
  Guard_C_SMTError d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_pretty_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    e cd x) $! addCs c cs)
  Fail_C_SMTError d info -> failCons d (traceFail
    "Solver.SMTLIB.Types._impl#pretty#Text.Pretty.Pretty#Solver.SMTLIB.Types.SMTError#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Solver.SMTLIB.Types._impl#pretty#Text.Pretty.Pretty#Solver.SMTLIB.Types.SMTError#"
    (showCons x1))

nd_OP_uscore_impl_hash_pretty_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash :: C_SMTError
  -> IDSupply -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_OP_uscore_impl_hash_pretty_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash x1 s cd cs =
  case x1 of
  C_SolverError x2 -> let s7 = s
    in s7 `seq` (let s6 = leftSupply s7
                     s8 = rightSupply s7
                     s3 = leftSupply s8
                     s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (Text.Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "Solver Error:") s1 cd cs) s2 cd cs))))
    (Text.Curry_Pretty.nd_C_text x2 s5 cd cs) s6 cd cs))))
  C_ParserError x3 -> let s7 = s
    in s7 `seq` (let s6 = leftSupply s7
                     s8 = rightSupply s7
                     s3 = leftSupply s8
                     s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (Text.Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "Parser Error:") s1 cd cs) s2 cd cs))))
    (Text.Curry_Pretty.nd_C_text x3 s5 cd cs) s6 cd cs))))
  C_OtherError x4 -> let s7 = s
    in s7 `seq` (let s6 = leftSupply s7
                     s8 = rightSupply s7
                     s3 = leftSupply s8
                     s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (Text.Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "Error:") s1 cd cs) s2 cd cs))))
    (Text.Curry_Pretty.nd_C_text x4 s5 cd cs) s6 cd cs))))
  Choice_C_SMTError d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_pretty_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    l s cd cs)
    (nd_OP_uscore_impl_hash_pretty_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    r s cd cs)
  Choices_C_SMTError d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_pretty_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    z s cd cs) xs
  Guard_C_SMTError d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_pretty_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    e s cd x) $! addCs c cs)
  Fail_C_SMTError d info -> failCons d (traceFail
    "Solver.SMTLIB.Types._impl#pretty#Text.Pretty.Pretty#Solver.SMTLIB.Types.SMTError#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Solver.SMTLIB.Types._impl#pretty#Text.Pretty.Pretty#Solver.SMTLIB.Types.SMTError#"
    (showCons x1))

d_OP_uscore_impl_hash_prettyList_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List C_SMTError -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_OP_uscore_impl_hash_prettyList_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash cd cs =
  Text.Curry_Pretty.d_OP_uscore_def_hash_prettyList_hash_Text_dot_Pretty_dot_Pretty
  d_OP_uscore_inst_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
  cd cs

nd_OP_uscore_impl_hash_prettyList_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash :: IDSupply
  -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List C_SMTError)
  Text.Curry_PrettyImpl.C_Doc
nd_OP_uscore_impl_hash_prettyList_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash s cd cs =
  let s0 = s
  in s0 `seq`
  Text.Curry_Pretty.nd_OP_uscore_def_hash_prettyList_hash_Text_dot_Pretty_dot_Pretty
  (wrapNX id
  nd_OP_uscore_inst_hash_Text_dot_Pretty_dot_Pretty_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash)
  s0 cd cs

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTSolver_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_SMTSolver
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTSolver_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTSolver_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTSolver_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTSolver_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTSolver_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTSolver_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTSolver_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Solver.SMTLIB.Types._inst#Prelude.Data#Solver.SMTLIB.Types.SMTSolver#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Solver.SMTLIB.Types._inst#Prelude.Data#Solver.SMTLIB.Types.SMTSolver#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTSolver_hash :: C_SMTSolver
  -> C_SMTSolver -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTSolver_hash x1 x2 s cd cs =
  case x1 of
  C_SMTSolver x3 x4 -> let s0 = s in s0 `seq` nd_C__case_4 x4 x3 x2 s0 cd cs
  Choice_C_SMTSolver d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTSolver_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTSolver_hash
    r x2 s cd cs)
  Choices_C_SMTSolver d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTSolver_hash
    z x2 s cd cs) xs
  Guard_C_SMTSolver d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTSolver_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_SMTSolver d info -> failCons d (traceFail
    "Solver.SMTLIB.Types._impl#===#Prelude.Data#Solver.SMTLIB.Types.SMTSolver#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Solver.SMTLIB.Types._impl#===#Prelude.Data#Solver.SMTLIB.Types.SMTSolver#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTSolver_hash :: IDSupply
  -> Cover -> ConstStore -> C_SMTSolver
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTSolver_hash s cd cs =
  let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_SMTSolver
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s1 cd cs)))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTOpts_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_SMTOpts
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTOpts_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTOpts_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTOpts_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTOpts_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTOpts_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTOpts_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTOpts_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Solver.SMTLIB.Types._inst#Prelude.Data#Solver.SMTLIB.Types.SMTOpts#" [show
    x1] info)
  _ -> failCons cd (consFail
    "Solver.SMTLIB.Types._inst#Prelude.Data#Solver.SMTLIB.Types.SMTOpts#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTOpts_hash :: C_SMTOpts
  -> C_SMTOpts -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTOpts_hash x1 x2 s cd cs =
  case x1 of
  C_SMTOpts x3 x4 x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_3 x6 x5 x4 x3 x2 s0 cd cs
  Choice_C_SMTOpts d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTOpts_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTOpts_hash
    r x2 s cd cs)
  Choices_C_SMTOpts d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTOpts_hash
    z x2 s cd cs) xs
  Guard_C_SMTOpts d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTOpts_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_SMTOpts d info -> failCons d (traceFail
    "Solver.SMTLIB.Types._impl#===#Prelude.Data#Solver.SMTLIB.Types.SMTOpts#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Solver.SMTLIB.Types._impl#===#Prelude.Data#Solver.SMTLIB.Types.SMTOpts#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTOpts_hash :: IDSupply
  -> Cover -> ConstStore -> C_SMTOpts
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTOpts_hash s cd cs =
  let s4 = s
  in s4 `seq` (let s5 = leftSupply s4
                   s6 = rightSupply s4
                   s0 = leftSupply s5
                   s1 = rightSupply s5
                   s2 = leftSupply s6
                   s3 = rightSupply s6
  in s5 `seq` (s6 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s3 `seq` C_SMTOpts
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
  s1 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
  s2 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Language.SMTLIB.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_SMTLIB_dot_Types_dot_Command_hash)
  s3 cd cs)))))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_SMTError
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Solver.SMTLIB.Types._inst#Prelude.Data#Solver.SMTLIB.Types.SMTError#" [show
    x1] info)
  _ -> failCons cd (consFail
    "Solver.SMTLIB.Types._inst#Prelude.Data#Solver.SMTLIB.Types.SMTError#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash :: C_SMTError
  -> C_SMTError -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash x1 x2 s cd cs =
  case x1 of
  C_SolverError x3 -> let s0 = s in s0 `seq` nd_C__case_2 x3 x2 s0 cd cs
  C_ParserError x7 -> let s0 = s in s0 `seq` nd_C__case_1 x7 x2 s0 cd cs
  C_OtherError x11 -> let s0 = s in s0 `seq` nd_C__case_0 x11 x2 s0 cd cs
  Choice_C_SMTError d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    r x2 s cd cs)
  Choices_C_SMTError d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    z x2 s cd cs) xs
  Guard_C_SMTError d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_SMTError d info -> failCons d (traceFail
    "Solver.SMTLIB.Types._impl#===#Prelude.Data#Solver.SMTLIB.Types.SMTError#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Solver.SMTLIB.Types._impl#===#Prelude.Data#Solver.SMTLIB.Types.SMTError#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash :: IDSupply
  -> Cover -> ConstStore -> C_SMTError
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash s cd cs =
  let s7 = s
  in s7 `seq` (let s6 = leftSupply s7
                   s8 = rightSupply s7
                   s3 = leftSupply s8
                   s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` choice (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` choice (C_SolverError
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)) (C_ParserError
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s1 cd cs)) s2 cd cs)))) (C_OtherError
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s5 cd cs)) s6 cd cs))))

d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show C_SMTError
d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Show
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    cd cs) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Solver.SMTLIB.Types._inst#Prelude.Show#Solver.SMTLIB.Types.SMTError#" [show
    x1] info)
  _ -> failCons cd (consFail
    "Solver.SMTLIB.Types._inst#Prelude.Show#Solver.SMTLIB.Types.SMTError#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  C_SMTError
nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Show (wrapDX id
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    cd cs)) (wrapDX (wrapDX (wrapDX id)) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Solver.SMTLIB.Types._inst#Prelude.Show#Solver.SMTLIB.Types.SMTError#" [show
    x1] info)
  _ -> failCons cd (consFail
    "Solver.SMTLIB.Types._inst#Prelude.Show#Solver.SMTLIB.Types.SMTError#"
    (showCons x1))

d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash :: Cover
  -> ConstStore -> C_SMTError -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash

d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash :: Curry_Prelude.C_Int
  -> C_SMTError -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash x1 x2 cd cs =
  case x2 of
  C_SolverError x3 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "SolverError "))
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash
    (Curry_Prelude.C_Int (11)) cd cs) x3 cd cs) cd cs) cd cs
  C_ParserError x4 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "ParserError "))
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash
    (Curry_Prelude.C_Int (11)) cd cs) x4 cd cs) cd cs) cd cs
  C_OtherError x5 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "OtherError "))
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash
    (Curry_Prelude.C_Int (11)) cd cs) x5 cd cs) cd cs) cd cs
  Choice_C_SMTError d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    x1 l cd cs)
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    x1 r cd cs)
  Choices_C_SMTError d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    x1 z cd cs) xs
  Guard_C_SMTError d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
    x1 e cd x) $! addCs c cs)
  Fail_C_SMTError d info -> failCons d (traceFail
    "Solver.SMTLIB.Types._impl#showsPrec#Prelude.Show#Solver.SMTLIB.Types.SMTError#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Solver.SMTLIB.Types._impl#showsPrec#Prelude.Show#Solver.SMTLIB.Types.SMTError#"
    (showCons x2))

d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List C_SMTError -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Solver_dot_SMTLIB_dot_Types_dot_SMTError_hash
  cd cs

d_C_executable :: C_SMTSolver -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_executable x1 cd cs = case x1 of
  C_SMTSolver x2 x3 -> x2
  Choice_C_SMTSolver d i l r -> narrow d i (d_C_executable l cd cs)
    (d_C_executable r cd cs)
  Choices_C_SMTSolver d i xs -> narrows cs d i (\z -> d_C_executable z cd cs) xs
  Guard_C_SMTSolver d c e -> guardCons d c ((\x -> d_C_executable e cd x) $!
    addCs c cs)
  Fail_C_SMTSolver d info -> failCons d (traceFail
    "Solver.SMTLIB.Types.executable" [show x1] info)
  _ -> failCons cd (consFail "Solver.SMTLIB.Types.executable" (showCons x1))

d_C_flags :: C_SMTSolver -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_flags x1 cd cs = case x1 of
  C_SMTSolver x2 x3 -> x3
  Choice_C_SMTSolver d i l r -> narrow d i (d_C_flags l cd cs) (d_C_flags r cd
    cs)
  Choices_C_SMTSolver d i xs -> narrows cs d i (\z -> d_C_flags z cd cs) xs
  Guard_C_SMTSolver d c e -> guardCons d c ((\x -> d_C_flags e cd x) $! addCs c
    cs)
  Fail_C_SMTSolver d info -> failCons d (traceFail "Solver.SMTLIB.Types.flags"
    [show x1] info)
  _ -> failCons cd (consFail "Solver.SMTLIB.Types.flags" (showCons x1))

d_C_incremental :: C_SMTOpts -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_incremental x1 cd cs = case x1 of
  C_SMTOpts x2 x3 x4 x5 -> x2
  Choice_C_SMTOpts d i l r -> narrow d i (d_C_incremental l cd cs)
    (d_C_incremental r cd cs)
  Choices_C_SMTOpts d i xs -> narrows cs d i (\z -> d_C_incremental z cd cs) xs
  Guard_C_SMTOpts d c e -> guardCons d c ((\x -> d_C_incremental e cd x) $!
    addCs c cs)
  Fail_C_SMTOpts d info -> failCons d (traceFail
    "Solver.SMTLIB.Types.incremental" [show x1] info)
  _ -> failCons cd (consFail "Solver.SMTLIB.Types.incremental" (showCons x1))

d_C_quiet :: C_SMTOpts -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_quiet x1 cd cs = case x1 of
  C_SMTOpts x2 x3 x4 x5 -> x3
  Choice_C_SMTOpts d i l r -> narrow d i (d_C_quiet l cd cs) (d_C_quiet r cd cs)
  Choices_C_SMTOpts d i xs -> narrows cs d i (\z -> d_C_quiet z cd cs) xs
  Guard_C_SMTOpts d c e -> guardCons d c ((\x -> d_C_quiet e cd x) $! addCs c
    cs)
  Fail_C_SMTOpts d info -> failCons d (traceFail "Solver.SMTLIB.Types.quiet"
    [show x1] info)
  _ -> failCons cd (consFail "Solver.SMTLIB.Types.quiet" (showCons x1))

d_C_tracing :: C_SMTOpts -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_tracing x1 cd cs = case x1 of
  C_SMTOpts x2 x3 x4 x5 -> x4
  Choice_C_SMTOpts d i l r -> narrow d i (d_C_tracing l cd cs) (d_C_tracing r cd
    cs)
  Choices_C_SMTOpts d i xs -> narrows cs d i (\z -> d_C_tracing z cd cs) xs
  Guard_C_SMTOpts d c e -> guardCons d c ((\x -> d_C_tracing e cd x) $! addCs c
    cs)
  Fail_C_SMTOpts d info -> failCons d (traceFail "Solver.SMTLIB.Types.tracing"
    [show x1] info)
  _ -> failCons cd (consFail "Solver.SMTLIB.Types.tracing" (showCons x1))

d_C_globalCmds :: C_SMTOpts -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Language.SMTLIB.Curry_Types.C_Command
d_C_globalCmds x1 cd cs = case x1 of
  C_SMTOpts x2 x3 x4 x5 -> x5
  Choice_C_SMTOpts d i l r -> narrow d i (d_C_globalCmds l cd cs)
    (d_C_globalCmds r cd cs)
  Choices_C_SMTOpts d i xs -> narrows cs d i (\z -> d_C_globalCmds z cd cs) xs
  Guard_C_SMTOpts d c e -> guardCons d c ((\x -> d_C_globalCmds e cd x) $! addCs
    c cs)
  Fail_C_SMTOpts d info -> failCons d (traceFail
    "Solver.SMTLIB.Types.globalCmds" [show x1] info)
  _ -> failCons cd (consFail "Solver.SMTLIB.Types.globalCmds" (showCons x1))

nd_C__case_4 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> C_SMTSolver -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_4 x4 x3 x2 s cd cs = case x2 of
  C_SMTSolver x5 x6 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x5 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    x4 x6 s1 cd cs) cd cs))
  Choice_C_SMTSolver d i l r -> narrow d i (nd_C__case_4 x4 x3 l s cd cs)
    (nd_C__case_4 x4 x3 r s cd cs)
  Choices_C_SMTSolver d i xs -> narrows cs d i (\z -> nd_C__case_4 x4 x3 z s cd
    cs) xs
  Guard_C_SMTSolver d c e -> guardCons d c ((\x -> nd_C__case_4 x4 x3 e s cd
    x) $! addCs c cs)
  Fail_C_SMTSolver d info -> failCons d (traceFail "Solver.SMTLIB.Types._case_4"
    [show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Solver.SMTLIB.Types._case_4" (showCons x2))

nd_C__case_3 :: Curry_Prelude.OP_List Language.SMTLIB.Curry_Types.C_Command
  -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> C_SMTOpts -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_3 x6 x5 x4 x3 x2 s cd cs = case x2 of
  C_SMTOpts x7 x8 x9 x10 -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
    x3 x7 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
    x4 x8 cd cs) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
    x5 x9 cd cs) cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Language.SMTLIB.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_SMTLIB_dot_Types_dot_Command_hash)
    x6 x10 s0 cd cs) cd cs
  Choice_C_SMTOpts d i l r -> narrow d i (nd_C__case_3 x6 x5 x4 x3 l s cd cs)
    (nd_C__case_3 x6 x5 x4 x3 r s cd cs)
  Choices_C_SMTOpts d i xs -> narrows cs d i (\z -> nd_C__case_3 x6 x5 x4 x3 z s
    cd cs) xs
  Guard_C_SMTOpts d c e -> guardCons d c ((\x -> nd_C__case_3 x6 x5 x4 x3 e s cd
    x) $! addCs c cs)
  Fail_C_SMTOpts d info -> failCons d (traceFail "Solver.SMTLIB.Types._case_3"
    [show x6, show x5, show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Solver.SMTLIB.Types._case_3" (showCons x2))

nd_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_SMTError
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_0 x11 x2 s cd cs = case x2 of
  C_SolverError x12 -> Curry_Prelude.C_False
  C_ParserError x13 -> Curry_Prelude.C_False
  C_OtherError x14 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x11 x14 s0 cd cs
  Choice_C_SMTError d i l r -> narrow d i (nd_C__case_0 x11 l s cd cs)
    (nd_C__case_0 x11 r s cd cs)
  Choices_C_SMTError d i xs -> narrows cs d i (\z -> nd_C__case_0 x11 z s cd cs)
    xs
  Guard_C_SMTError d c e -> guardCons d c ((\x -> nd_C__case_0 x11 e s cd x) $!
    addCs c cs)
  Fail_C_SMTError d info -> failCons d (traceFail "Solver.SMTLIB.Types._case_0"
    [show x11, show x2] info)
  _ -> failCons cd (consFail "Solver.SMTLIB.Types._case_0" (showCons x2))

nd_C__case_1 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_SMTError
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_1 x7 x2 s cd cs = case x2 of
  C_SolverError x8 -> Curry_Prelude.C_False
  C_ParserError x9 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x7 x9 s0 cd cs
  C_OtherError x10 -> Curry_Prelude.C_False
  Choice_C_SMTError d i l r -> narrow d i (nd_C__case_1 x7 l s cd cs)
    (nd_C__case_1 x7 r s cd cs)
  Choices_C_SMTError d i xs -> narrows cs d i (\z -> nd_C__case_1 x7 z s cd cs)
    xs
  Guard_C_SMTError d c e -> guardCons d c ((\x -> nd_C__case_1 x7 e s cd x) $!
    addCs c cs)
  Fail_C_SMTError d info -> failCons d (traceFail "Solver.SMTLIB.Types._case_1"
    [show x7, show x2] info)
  _ -> failCons cd (consFail "Solver.SMTLIB.Types._case_1" (showCons x2))

nd_C__case_2 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_SMTError
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_2 x3 x2 s cd cs = case x2 of
  C_SolverError x4 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x4 s0 cd cs
  C_ParserError x5 -> Curry_Prelude.C_False
  C_OtherError x6 -> Curry_Prelude.C_False
  Choice_C_SMTError d i l r -> narrow d i (nd_C__case_2 x3 l s cd cs)
    (nd_C__case_2 x3 r s cd cs)
  Choices_C_SMTError d i xs -> narrows cs d i (\z -> nd_C__case_2 x3 z s cd cs)
    xs
  Guard_C_SMTError d c e -> guardCons d c ((\x -> nd_C__case_2 x3 e s cd x) $!
    addCs c cs)
  Fail_C_SMTError d info -> failCons d (traceFail "Solver.SMTLIB.Types._case_2"
    [show x3, show x2] info)
  _ -> failCons cd (consFail "Solver.SMTLIB.Types._case_2" (showCons x2))

