{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry.Curry_Span
  ( C_Span (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Curry_dot_Span_dot_Span_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Curry_dot_Span_dot_Span_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Curry_dot_Span_dot_Span_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash
  , d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash
  , d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash
  , d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash
  , d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash
  , d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash
  , d_C_start
  , d_C_end
  , d_C_isSpan
  , d_C_isNoSpan
  , d_C_fromPosition
  , d_C_stripStart
  , d_C_vertDist
  , d_C_isAfter
  , d_C_isBefore
  , d_C_isBeforeList
  , d_C_span2Pos
  , d_C_combineSpans
  , d_C_addSpan
  , d_C_spanLength )
  where

import Basics
import qualified Curry.Curry_Position
import qualified Curry_Prelude


data C_Span
  = C_Span Curry.Curry_Position.C_Position Curry.Curry_Position.C_Position
  | C_NoSpan
  | Choice_C_Span Cover ID C_Span C_Span
  | Choices_C_Span Cover ID [C_Span]
  | Fail_C_Span Cover FailInfo
  | Guard_C_Span Cover Constraints C_Span

instance Show C_Span where
  showsPrec d (Choice_C_Span cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Span cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Span cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Span cd info) = showChar '!'
  showsPrec _ (C_Span x1 x2) = showString "(Span" . (showChar ' ' . (shows x1 .
    (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ C_NoSpan = showString "NoSpan"

instance Read C_Span where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Span x1 x2, r2) | (_, r0) <-
    readQualified "Curry.Span" "Span" r, (x1, r1) <- readsPrec 11 r0, (x2, r2)
    <- readsPrec 11 r1]) s ++ readParen False (\r -> [(C_NoSpan, r0) | (_, r0)
    <- readQualified "Curry.Span" "NoSpan" r]) s

instance NonDet C_Span where
  choiceCons = Choice_C_Span
  choicesCons = Choices_C_Span
  failCons = Fail_C_Span
  guardCons = Guard_C_Span
  try (Choice_C_Span cd i x y) = tryChoice cd i x y
  try (Choices_C_Span cd i xs) = tryChoices cd i xs
  try (Fail_C_Span cd info) = Fail cd info
  try (Guard_C_Span cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Span cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Span cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Span cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Span cd i _) = error
    ("Curry.Span.Span.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Span cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Span cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Span where
  generate s c = Choices_C_Span c (freeID [2, 0] s) [C_Span (generate
    (leftSupply s) c) (generate (rightSupply s) c), C_NoSpan]

instance NormalForm C_Span where
  ($!!) cont (C_Span x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Span y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont C_NoSpan d cs = cont C_NoSpan d cs
  ($!!) cont (Choice_C_Span cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Span cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Span cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_Span cd info) _ _ = failCons cd info
  ($##) cont (C_Span x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Span y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont C_NoSpan d cs = cont C_NoSpan d cs
  ($##) cont (Choice_C_Span cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Span cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Span cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_Span cd info) _ _ = failCons cd info
  showCons (C_Span _ _) = "Curry.Span.Span _ _"
  showCons C_NoSpan = "Curry.Span.NoSpan"
  showCons x = error ("Curry.Span.Span.showCons: no constructor: " ++ show x)
  searchNF search cont (C_Span x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Span y1 y2)) x2) x1
  searchNF _ cont C_NoSpan = cont C_NoSpan
  searchNF _ _ x = error ("Curry.Span.Span.searchNF: no constructor: " ++ show
    x)

instance Unifiable C_Span where
  (=.=) (C_Span x1 x2) (C_Span y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2
    d cs) d cs
  (=.=) C_NoSpan C_NoSpan d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Span x1 x2) (C_Span y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=) x2
    y2 d cs) d cs
  (=.<=) C_NoSpan C_NoSpan d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Span x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID i) x3
    , bind cd (rightID i) x4]
  bind cd i C_NoSpan = (i :=: ChooseN 1 0) : concat []
  bind d i (Choice_C_Span cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_Span cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Span cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Span cd i _) = error
    ("Curry.Span.Span.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Span cd info) = [Unsolvable info]
  bind d i (Guard_C_Span cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Span x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i C_NoSpan = (i :=: ChooseN 1 0) : []
  lazyBind d i (Choice_C_Span cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Span cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j
    xs
  lazyBind d i (Choices_C_Span cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Span cd i _) = error
    ("Curry.Span.Span.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Span cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Span cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Span where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Curry_dot_Span_dot_Span_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Span
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Curry_dot_Span_dot_Span_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Curry_dot_Span_dot_Span_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Curry_dot_Span_dot_Span_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Curry_dot_Span_dot_Span_hash l
    s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Curry_dot_Span_dot_Span_hash r
    s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Curry_dot_Span_dot_Span_hash z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Curry_dot_Span_dot_Span_hash e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Curry.Span._inst#Prelude.Data#Curry.Span.Span#" [show x1] info)
  _ -> failCons cd (consFail "Curry.Span._inst#Prelude.Data#Curry.Span.Span#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Curry_dot_Span_dot_Span_hash :: C_Span
  -> C_Span -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Curry_dot_Span_dot_Span_hash x1 x2 cd cs =
  case x1 of
  C_Span x3 x4 -> d_C__case_16 x4 x3 x2 cd cs
  C_NoSpan -> d_C__case_15 x2 cd cs
  Choice_C_Span d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Curry_dot_Span_dot_Span_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Curry_dot_Span_dot_Span_hash
    r x2 cd cs)
  Choices_C_Span d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Curry_dot_Span_dot_Span_hash
    z x2 cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Curry_dot_Span_dot_Span_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Span d info -> failCons d (traceFail
    "Curry.Span._impl#===#Prelude.Data#Curry.Span.Span#" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "Curry.Span._impl#===#Prelude.Data#Curry.Span.Span#" (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Curry_dot_Span_dot_Span_hash :: IDSupply
  -> Cover -> ConstStore -> C_Span
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Curry_dot_Span_dot_Span_hash s cd cs =
  let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` choice (let s0 = leftSupply s2
                                    s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_Span
  (Curry.Curry_Position.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash
  s0 cd cs)
  (Curry.Curry_Position.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash
  s1 cd cs))) C_NoSpan s3 cd cs))

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_Span
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash l cd
    cs) (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash z cd
    cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Curry.Span._inst#Prelude.Eq#Curry.Span.Span#" [show x1] info)
  _ -> failCons cd (consFail "Curry.Span._inst#Prelude.Eq#Curry.Span.Span#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_Span
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash l s
    cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash r s
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Curry.Span._inst#Prelude.Eq#Curry.Span.Span#" [show x1] info)
  _ -> failCons cd (consFail "Curry.Span._inst#Prelude.Eq#Curry.Span.Span#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash :: C_Span
  -> C_Span -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash x1 x2 cd cs =
  case x1 of
  C_Span x3 x4 -> d_C__case_14 x4 x3 x2 cd cs
  C_NoSpan -> d_C__case_13 x2 cd cs
  Choice_C_Span d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash
    r x2 cd cs)
  Choices_C_Span d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash
    z x2 cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Span d info -> failCons d (traceFail
    "Curry.Span._impl#==#Prelude.Eq#Curry.Span.Span#" [show x1, show x2] info)
  _ -> failCons cd (consFail "Curry.Span._impl#==#Prelude.Eq#Curry.Span.Span#"
    (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash :: Cover
  -> ConstStore -> C_Span -> Cover -> ConstStore -> C_Span -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Curry_dot_Span_dot_Span_hash)

d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show C_Span
d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Show
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash
    cd cs) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash l
    cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash r
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash z
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Curry.Span._inst#Prelude.Show#Curry.Span.Span#" [show x1] info)
  _ -> failCons cd (consFail "Curry.Span._inst#Prelude.Show#Curry.Span.Span#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show
  C_Span
nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Show (wrapDX id
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash
    cd cs)) (wrapDX (wrapDX (wrapDX id)) (acceptCs id
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash l
    s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash r
    s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Curry.Span._inst#Prelude.Show#Curry.Span.Span#" [show x1] info)
  _ -> failCons cd (consFail "Curry.Span._inst#Prelude.Show#Curry.Span.Span#"
    (showCons x1))

d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash :: Cover
  -> ConstStore -> C_Span -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash

d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash :: Curry_Prelude.C_Int
  -> C_Span -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash x1 x2 cd cs =
  case x2 of
  C_Span x3 x4 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "Span "))
    (Curry_Prelude.d_OP_dot
    (Curry.Curry_Position.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
    (Curry_Prelude.C_Int (11)) x3 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " "))
    (Curry.Curry_Position.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Position_dot_Position_hash
    (Curry_Prelude.C_Int (11)) x4 cd cs) cd cs) cd cs) cd cs) cd cs
  C_NoSpan -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "NoSpan")
  Choice_C_Span d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash
    x1 l cd cs)
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash
    x1 r cd cs)
  Choices_C_Span d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash
    x1 z cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash
    x1 e cd x) $! addCs c cs)
  Fail_C_Span d info -> failCons d (traceFail
    "Curry.Span._impl#showsPrec#Prelude.Show#Curry.Span.Span#" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "Curry.Span._impl#showsPrec#Prelude.Show#Curry.Span.Span#" (showCons x2))

d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Span -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Curry_dot_Span_dot_Span_hash cd cs

d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read C_Span
d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Read (acceptCs id
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash)
    (d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash l
    cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash r
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash z
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Curry.Span._inst#Prelude.Read#Curry.Span.Span#" [show x1] info)
  _ -> failCons cd (consFail "Curry.Span._inst#Prelude.Read#Curry.Span.Span#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read
  C_Span
nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Read (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash))
    (wrapDX id
    (d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash l
    s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash r
    s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Curry.Span._inst#Prelude.Read#Curry.Span.Span#" [show x1] info)
  _ -> failCons cd (consFail "Curry.Span._inst#Prelude.Read#Curry.Span.Span#"
    (showCons x1))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash :: Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Span
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash x1 x2 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_readParen (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) (Curry_Prelude.C_Int (10)) cd cs) x1 cd cs)
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1
  cd cs) x2 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_readParen
  Curry_Prelude.C_False
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda14
  cd cs) x2 cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_Span (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1 x1 cd cs =
  Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4)
  Curry_Prelude.OP_List (Curry_Prelude.d_C_lex x1 cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Span
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Span
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4 x1 x2 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_12 x3 x2 x4
    (Curry_Prelude.d_C_eqString x3 (Curry_Prelude.toCurryString "Span") cd cs)
    cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    l x2 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Curry.Span._impl#readsPrec#Prelude.Read#Curry.Span.Span#._#lambda1._#lambda4"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Curry.Span._impl#readsPrec#Prelude.Read#Curry.Span.Span#._#lambda1._#lambda4"
    (showCons x1))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8 :: Curry_Prelude.OP_Tuple2
  Curry.Curry_Position.C_Position (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Span
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Span
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8 x1 x2 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_foldr (acceptCs id
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8_dot_uscore_hash_lambda12
    x3)) Curry_Prelude.OP_List
    (Curry.Curry_Position.d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash
    (Curry_Prelude.C_Int (11)) x4 cd cs) cd cs) x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8
    l x2 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8
    r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8
    z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Curry.Span._impl#readsPrec#Prelude.Read#Curry.Span.Span#._#lambda1._#lambda4._#lambda8"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Curry.Span._impl#readsPrec#Prelude.Read#Curry.Span.Span#._#lambda1._#lambda4._#lambda8"
    (showCons x1))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8_dot_uscore_hash_lambda12 :: Curry.Curry_Position.C_Position
  -> Curry_Prelude.OP_Tuple2 Curry.Curry_Position.C_Position
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_Span (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_Span (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8_dot_uscore_hash_lambda12 x1 x2 x3 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 (C_Span x1 x4) x5) x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8_dot_uscore_hash_lambda12
    x1 l x3 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8_dot_uscore_hash_lambda12
    x1 r x3 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8_dot_uscore_hash_lambda12
    x1 z x3 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8_dot_uscore_hash_lambda12
    x1 e x3 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Curry.Span._impl#readsPrec#Prelude.Read#Curry.Span.Span#._#lambda1._#lambda4._#lambda8._#lambda12"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail
    "Curry.Span._impl#readsPrec#Prelude.Read#Curry.Span.Span#._#lambda1._#lambda4._#lambda8._#lambda12"
    (showCons x2))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda14 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_Span (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda14 x1 cd cs =
  Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda14_dot_uscore_hash_lambda17)
  Curry_Prelude.OP_List (Curry_Prelude.d_C_lex x1 cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda14_dot_uscore_hash_lambda17 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Span
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Span
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda14_dot_uscore_hash_lambda17 x1 x2 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_11 x3 x2 x4
    (Curry_Prelude.d_C_eqString x3 (Curry_Prelude.toCurryString "NoSpan") cd cs)
    cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda14_dot_uscore_hash_lambda17
    l x2 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda14_dot_uscore_hash_lambda17
    r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda14_dot_uscore_hash_lambda17
    z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda14_dot_uscore_hash_lambda17
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Curry.Span._impl#readsPrec#Prelude.Read#Curry.Span.Span#._#lambda14._#lambda17"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Curry.Span._impl#readsPrec#Prelude.Read#Curry.Span.Span#._#lambda14._#lambda17"
    (showCons x1))

d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash :: Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List C_Span) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_readList_hash_Prelude_dot_Read
  d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash cd cs

d_C_start :: C_Span -> Cover -> ConstStore -> Curry.Curry_Position.C_Position
d_C_start x1 cd cs = case x1 of
  C_Span x2 x3 -> x2
  C_NoSpan -> Curry_Prelude.d_C_failed cd cs
  Choice_C_Span d i l r -> narrow d i (d_C_start l cd cs) (d_C_start r cd cs)
  Choices_C_Span d i xs -> narrows cs d i (\z -> d_C_start z cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x -> d_C_start e cd x) $! addCs c cs)
  Fail_C_Span d info -> failCons d (traceFail "Curry.Span.start" [show x1] info)
  _ -> failCons cd (consFail "Curry.Span.start" (showCons x1))

d_C_end :: C_Span -> Cover -> ConstStore -> Curry.Curry_Position.C_Position
d_C_end x1 cd cs = case x1 of
  C_Span x2 x3 -> x3
  C_NoSpan -> Curry_Prelude.d_C_failed cd cs
  Choice_C_Span d i l r -> narrow d i (d_C_end l cd cs) (d_C_end r cd cs)
  Choices_C_Span d i xs -> narrows cs d i (\z -> d_C_end z cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x -> d_C_end e cd x) $! addCs c cs)
  Fail_C_Span d info -> failCons d (traceFail "Curry.Span.end" [show x1] info)
  _ -> failCons cd (consFail "Curry.Span.end" (showCons x1))

d_C_isSpan :: C_Span -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isSpan x1 cd cs = case x1 of
  C_Span x2 x3 -> Curry_Prelude.C_True
  C_NoSpan -> Curry_Prelude.C_False
  Choice_C_Span d i l r -> narrow d i (d_C_isSpan l cd cs) (d_C_isSpan r cd cs)
  Choices_C_Span d i xs -> narrows cs d i (\z -> d_C_isSpan z cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x -> d_C_isSpan e cd x) $! addCs c cs)
  Fail_C_Span d info -> failCons d (traceFail "Curry.Span.isSpan" [show x1]
    info)
  _ -> failCons cd (consFail "Curry.Span.isSpan" (showCons x1))

d_C_isNoSpan :: C_Span -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isNoSpan x1 cd cs = case x1 of
  C_Span x2 x3 -> Curry_Prelude.C_False
  C_NoSpan -> Curry_Prelude.C_True
  Choice_C_Span d i l r -> narrow d i (d_C_isNoSpan l cd cs) (d_C_isNoSpan r cd
    cs)
  Choices_C_Span d i xs -> narrows cs d i (\z -> d_C_isNoSpan z cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x -> d_C_isNoSpan e cd x) $! addCs c
    cs)
  Fail_C_Span d info -> failCons d (traceFail "Curry.Span.isNoSpan" [show x1]
    info)
  _ -> failCons cd (consFail "Curry.Span.isNoSpan" (showCons x1))

d_C_fromPosition :: Curry.Curry_Position.C_Position -> Cover -> ConstStore
  -> C_Span
d_C_fromPosition x1 cd cs = case x1 of
  Curry.Curry_Position.C_NoPos -> C_NoSpan
  Curry.Curry_Position.C_Position x2 x3 -> C_Span x1 x1
  Curry.Curry_Position.Choice_C_Position d i l r -> narrow d i (d_C_fromPosition
    l cd cs) (d_C_fromPosition r cd cs)
  Curry.Curry_Position.Choices_C_Position d i xs -> narrows cs d i (\z ->
    d_C_fromPosition z cd cs) xs
  Curry.Curry_Position.Guard_C_Position d c e -> guardCons d c ((\x ->
    d_C_fromPosition e cd x) $! addCs c cs)
  Curry.Curry_Position.Fail_C_Position d info -> failCons d (traceFail
    "Curry.Span.fromPosition" [show x1] info)
  _ -> failCons cd (consFail "Curry.Span.fromPosition" (showCons x1))

d_C_stripStart :: Cover -> ConstStore -> C_Span -> Cover -> ConstStore -> C_Span
d_C_stripStart cd cs = Curry_Prelude.d_OP_dot d_C_fromPosition d_C_end cd cs

d_C_vertDist :: C_Span -> C_Span -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_vertDist x1 x2 cd cs = case x1 of
  C_NoSpan -> d_C__case_10 x2 cd cs
  C_Span x5 x6 -> d_C__case_9 x6 x5 x2 cd cs
  Choice_C_Span d i l r -> narrow d i (d_C_vertDist l x2 cd cs) (d_C_vertDist r
    x2 cd cs)
  Choices_C_Span d i xs -> narrows cs d i (\z -> d_C_vertDist z x2 cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x -> d_C_vertDist e x2 cd x) $! addCs c
    cs)
  Fail_C_Span d info -> failCons d (traceFail "Curry.Span.vertDist" [show x1
    , show x2] info)
  _ -> failCons cd (consFail "Curry.Span.vertDist" (showCons x1))

d_C_isAfter :: C_Span -> C_Span -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isAfter x1 x2 cd cs = case x1 of
  C_NoSpan -> d_C__case_5 x2 cd cs
  C_Span x5 x6 -> d_C__case_4 x5 x2 cd cs
  Choice_C_Span d i l r -> narrow d i (d_C_isAfter l x2 cd cs) (d_C_isAfter r x2
    cd cs)
  Choices_C_Span d i xs -> narrows cs d i (\z -> d_C_isAfter z x2 cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x -> d_C_isAfter e x2 cd x) $! addCs c
    cs)
  Fail_C_Span d info -> failCons d (traceFail "Curry.Span.isAfter" [show x1
    , show x2] info)
  _ -> failCons cd (consFail "Curry.Span.isAfter" (showCons x1))

d_C_isBefore :: C_Span -> C_Span -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isBefore x1 x2 cd cs = case x1 of
  C_NoSpan -> d_C__case_3 x2 cd cs
  C_Span x5 x6 -> d_C__case_2 x6 x2 cd cs
  Choice_C_Span d i l r -> narrow d i (d_C_isBefore l x2 cd cs) (d_C_isBefore r
    x2 cd cs)
  Choices_C_Span d i xs -> narrows cs d i (\z -> d_C_isBefore z x2 cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x -> d_C_isBefore e x2 cd x) $! addCs c
    cs)
  Fail_C_Span d info -> failCons d (traceFail "Curry.Span.isBefore" [show x1
    , show x2] info)
  _ -> failCons cd (consFail "Curry.Span.isBefore" (showCons x1))

d_C_isBeforeList :: C_Span -> Curry_Prelude.OP_List C_Span -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C_isBeforeList x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.C_True
  Curry_Prelude.OP_Cons x3 x4 -> d_C_isBefore x1 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_isBeforeList x1 l cd
    cs) (d_C_isBeforeList x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_isBeforeList
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_isBeforeList x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Curry.Span.isBeforeList" [show x1, show x2] info)
  _ -> failCons cd (consFail "Curry.Span.isBeforeList" (showCons x2))

d_C_span2Pos :: C_Span -> Cover -> ConstStore -> Curry.Curry_Position.C_Position
d_C_span2Pos x1 cd cs = case x1 of
  C_Span x2 x3 -> x2
  C_NoSpan -> Curry.Curry_Position.C_NoPos
  Choice_C_Span d i l r -> narrow d i (d_C_span2Pos l cd cs) (d_C_span2Pos r cd
    cs)
  Choices_C_Span d i xs -> narrows cs d i (\z -> d_C_span2Pos z cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x -> d_C_span2Pos e cd x) $! addCs c
    cs)
  Fail_C_Span d info -> failCons d (traceFail "Curry.Span.span2Pos" [show x1]
    info)
  _ -> failCons cd (consFail "Curry.Span.span2Pos" (showCons x1))

d_C_combineSpans :: C_Span -> C_Span -> Cover -> ConstStore -> C_Span
d_C_combineSpans x1 x2 cd cs = let x3 = d_C_start x1 cd cs
                                   x4 = d_C_end x2 cd cs
  in C_Span x3 x4

d_C_addSpan :: forall t0 . (Curry_Prelude.Curry t0) => C_Span
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List C_Span) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List C_Span)
d_C_addSpan x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2 x3
    (Curry_Prelude.OP_Cons x1 x4)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_addSpan x1 l cd cs)
    (d_C_addSpan x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_addSpan x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C_addSpan x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Curry.Span.addSpan" [show x1, show x2] info)
  _ -> failCons cd (consFail "Curry.Span.addSpan" (showCons x2))

d_C_spanLength :: C_Span -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int Curry_Prelude.C_Int
d_C_spanLength x1 cd cs = case x1 of
  C_Span x2 x3 -> d_C__case_1 x3 x2 cd cs
  C_NoSpan -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int (0))
    (Curry_Prelude.C_Int (0))
  Choice_C_Span d i l r -> narrow d i (d_C_spanLength l cd cs) (d_C_spanLength r
    cd cs)
  Choices_C_Span d i xs -> narrows cs d i (\z -> d_C_spanLength z cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x -> d_C_spanLength e cd x) $! addCs c
    cs)
  Fail_C_Span d info -> failCons d (traceFail "Curry.Span.spanLength" [show x1]
    info)
  _ -> failCons cd (consFail "Curry.Span.spanLength" (showCons x1))

d_C__case_15 :: C_Span -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_15 x2 cd cs = case x2 of
  C_Span x7 x8 -> Curry_Prelude.C_False
  C_NoSpan -> Curry_Prelude.C_True
  Choice_C_Span d i l r -> narrow d i (d_C__case_15 l cd cs) (d_C__case_15 r cd
    cs)
  Choices_C_Span d i xs -> narrows cs d i (\z -> d_C__case_15 z cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x -> d_C__case_15 e cd x) $! addCs c
    cs)
  Fail_C_Span d info -> failCons d (traceFail "Curry.Span._case_15" [show x2]
    info)
  _ -> failCons cd (consFail "Curry.Span._case_15" (showCons x2))

d_C__case_16 :: Curry.Curry_Position.C_Position
  -> Curry.Curry_Position.C_Position -> C_Span -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_16 x4 x3 x2 cd cs = case x2 of
  C_Span x5 x6 -> Curry_Prelude.d_OP_amp_amp
    (Curry.Curry_Position.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash
    x3 x5 cd cs)
    (Curry.Curry_Position.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Curry_dot_Position_dot_Position_hash
    x4 x6 cd cs) cd cs
  C_NoSpan -> Curry_Prelude.C_False
  Choice_C_Span d i l r -> narrow d i (d_C__case_16 x4 x3 l cd cs) (d_C__case_16
    x4 x3 r cd cs)
  Choices_C_Span d i xs -> narrows cs d i (\z -> d_C__case_16 x4 x3 z cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x -> d_C__case_16 x4 x3 e cd x) $!
    addCs c cs)
  Fail_C_Span d info -> failCons d (traceFail "Curry.Span._case_16" [show x4
    , show x3, show x2] info)
  _ -> failCons cd (consFail "Curry.Span._case_16" (showCons x2))

d_C__case_13 :: C_Span -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_13 x2 cd cs = case x2 of
  C_Span x7 x8 -> Curry_Prelude.C_False
  C_NoSpan -> Curry_Prelude.C_True
  Choice_C_Span d i l r -> narrow d i (d_C__case_13 l cd cs) (d_C__case_13 r cd
    cs)
  Choices_C_Span d i xs -> narrows cs d i (\z -> d_C__case_13 z cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x -> d_C__case_13 e cd x) $! addCs c
    cs)
  Fail_C_Span d info -> failCons d (traceFail "Curry.Span._case_13" [show x2]
    info)
  _ -> failCons cd (consFail "Curry.Span._case_13" (showCons x2))

d_C__case_14 :: Curry.Curry_Position.C_Position
  -> Curry.Curry_Position.C_Position -> C_Span -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_14 x4 x3 x2 cd cs = case x2 of
  C_Span x5 x6 -> Curry_Prelude.d_OP_amp_amp
    (Curry.Curry_Position.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
    x3 x5 cd cs)
    (Curry.Curry_Position.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Curry_dot_Position_dot_Position_hash
    x4 x6 cd cs) cd cs
  C_NoSpan -> Curry_Prelude.C_False
  Choice_C_Span d i l r -> narrow d i (d_C__case_14 x4 x3 l cd cs) (d_C__case_14
    x4 x3 r cd cs)
  Choices_C_Span d i xs -> narrows cs d i (\z -> d_C__case_14 x4 x3 z cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x -> d_C__case_14 x4 x3 e cd x) $!
    addCs c cs)
  Fail_C_Span d info -> failCons d (traceFail "Curry.Span._case_14" [show x4
    , show x3, show x2] info)
  _ -> failCons cd (consFail "Curry.Span._case_14" (showCons x2))

d_C__case_12 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Span
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Span
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_12 x3 x2 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_foldr
    (acceptCs id
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Span_dot_Span_hash_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4_dot_uscore_hash_lambda8)
    Curry_Prelude.OP_List
    (Curry.Curry_Position.d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Curry_dot_Position_dot_Position_hash
    (Curry_Prelude.C_Int (11)) x4 cd cs) cd cs) x2 cd cs
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_12 x3 x2 x4 l cd
    cs) (d_C__case_12 x3 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_12 x3
    x2 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_12 x3 x2
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Curry.Span._case_12" [show x3, show x2, show x4, show x5] info)
  _ -> failCons cd (consFail "Curry.Span._case_12" (showCons x5))

d_C__case_11 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Span
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Span
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_11 x3 x2 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    C_NoSpan x4) x2
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_11 x3 x2 x4 l cd
    cs) (d_C__case_11 x3 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_11 x3
    x2 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_11 x3 x2
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Curry.Span._case_11" [show x3, show x2, show x4, show x5] info)
  _ -> failCons cd (consFail "Curry.Span._case_11" (showCons x5))

d_C__case_9 :: Curry.Curry_Position.C_Position
  -> Curry.Curry_Position.C_Position -> C_Span -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_C__case_9 x6 x5 x2 cd cs = case x2 of
  C_NoSpan -> Curry_Prelude.C_Int (0)
  C_Span x7 x8 -> let x9 = Curry.Curry_Position.d_C_rowDist x6 x7 cd cs
    in d_C__case_8 x9 x8 x6 x5 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x9 cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs
  Choice_C_Span d i l r -> narrow d i (d_C__case_9 x6 x5 l cd cs) (d_C__case_9
    x6 x5 r cd cs)
  Choices_C_Span d i xs -> narrows cs d i (\z -> d_C__case_9 x6 x5 z cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x -> d_C__case_9 x6 x5 e cd x) $! addCs
    c cs)
  Fail_C_Span d info -> failCons d (traceFail "Curry.Span._case_9" [show x6
    , show x5, show x2] info)
  _ -> failCons cd (consFail "Curry.Span._case_9" (showCons x2))

d_C__case_8 :: Curry_Prelude.C_Int -> Curry.Curry_Position.C_Position
  -> Curry.Curry_Position.C_Position -> Curry.Curry_Position.C_Position
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C__case_8 x9 x8 x6 x5 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> x9
  Curry_Prelude.C_False -> d_C__case_7 x8 x6 x5
    (Curry.Curry_Position.d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    x6 x8 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x9 x8 x6 x5 l
    cd cs) (d_C__case_8 x9 x8 x6 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x9 x8
    x6 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_8 x9 x8 x6
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Curry.Span._case_8"
    [show x9, show x8, show x6, show x5, show x10] info)
  _ -> failCons cd (consFail "Curry.Span._case_8" (showCons x10))

d_C__case_7 :: Curry.Curry_Position.C_Position
  -> Curry.Curry_Position.C_Position -> Curry.Curry_Position.C_Position
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C__case_7 x8 x6 x5 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.C_Int (0)
  Curry_Prelude.C_False -> d_C__case_6 x5 x8 (Curry_Prelude.d_C_otherwise cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x8 x6 x5 l cd
    cs) (d_C__case_7 x8 x6 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x8 x6
    x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_7 x8 x6 x5
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Curry.Span._case_7"
    [show x8, show x6, show x5, show x9] info)
  _ -> failCons cd (consFail "Curry.Span._case_7" (showCons x9))

d_C__case_6 :: Curry.Curry_Position.C_Position
  -> Curry.Curry_Position.C_Position -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_Int
d_C__case_6 x5 x8 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_uscore_impl_hash_negate_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (Curry.Curry_Position.d_C_rowDist x8 x5 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x5 x8 l cd cs)
    (d_C__case_6 x5 x8 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x5 x8
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x5 x8 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Curry.Span._case_6"
    [show x5, show x8, show x9] info)
  _ -> failCons cd (consFail "Curry.Span._case_6" (showCons x9))

d_C__case_10 :: C_Span -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C__case_10 x2 cd cs = case x2 of
  C_NoSpan -> Curry_Prelude.C_Int (0)
  C_Span x3 x4 -> Curry_Prelude.C_Int (0)
  Choice_C_Span d i l r -> narrow d i (d_C__case_10 l cd cs) (d_C__case_10 r cd
    cs)
  Choices_C_Span d i xs -> narrows cs d i (\z -> d_C__case_10 z cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x -> d_C__case_10 e cd x) $! addCs c
    cs)
  Fail_C_Span d info -> failCons d (traceFail "Curry.Span._case_10" [show x2]
    info)
  _ -> failCons cd (consFail "Curry.Span._case_10" (showCons x2))

d_C__case_4 :: Curry.Curry_Position.C_Position -> C_Span -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_4 x5 x2 cd cs = case x2 of
  C_NoSpan -> Curry_Prelude.C_False
  C_Span x7 x8 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry.Curry_Position.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    cd cs) x5 cd cs) x8 cd cs
  Choice_C_Span d i l r -> narrow d i (d_C__case_4 x5 l cd cs) (d_C__case_4 x5 r
    cd cs)
  Choices_C_Span d i xs -> narrows cs d i (\z -> d_C__case_4 x5 z cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x -> d_C__case_4 x5 e cd x) $! addCs c
    cs)
  Fail_C_Span d info -> failCons d (traceFail "Curry.Span._case_4" [show x5
    , show x2] info)
  _ -> failCons cd (consFail "Curry.Span._case_4" (showCons x2))

d_C__case_5 :: C_Span -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_5 x2 cd cs = case x2 of
  C_NoSpan -> Curry_Prelude.C_False
  C_Span x3 x4 -> Curry_Prelude.C_False
  Choice_C_Span d i l r -> narrow d i (d_C__case_5 l cd cs) (d_C__case_5 r cd
    cs)
  Choices_C_Span d i xs -> narrows cs d i (\z -> d_C__case_5 z cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x -> d_C__case_5 e cd x) $! addCs c cs)
  Fail_C_Span d info -> failCons d (traceFail "Curry.Span._case_5" [show x2]
    info)
  _ -> failCons cd (consFail "Curry.Span._case_5" (showCons x2))

d_C__case_2 :: Curry.Curry_Position.C_Position -> C_Span -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_2 x6 x2 cd cs = case x2 of
  C_NoSpan -> Curry_Prelude.C_False
  C_Span x7 x8 -> Curry.Curry_Position.d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Curry_dot_Position_dot_Position_hash
    x6 x7 cd cs
  Choice_C_Span d i l r -> narrow d i (d_C__case_2 x6 l cd cs) (d_C__case_2 x6 r
    cd cs)
  Choices_C_Span d i xs -> narrows cs d i (\z -> d_C__case_2 x6 z cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x -> d_C__case_2 x6 e cd x) $! addCs c
    cs)
  Fail_C_Span d info -> failCons d (traceFail "Curry.Span._case_2" [show x6
    , show x2] info)
  _ -> failCons cd (consFail "Curry.Span._case_2" (showCons x2))

d_C__case_3 :: C_Span -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_3 x2 cd cs = case x2 of
  C_NoSpan -> Curry_Prelude.C_False
  C_Span x3 x4 -> Curry_Prelude.C_False
  Choice_C_Span d i l r -> narrow d i (d_C__case_3 l cd cs) (d_C__case_3 r cd
    cs)
  Choices_C_Span d i xs -> narrows cs d i (\z -> d_C__case_3 z cd cs) xs
  Guard_C_Span d c e -> guardCons d c ((\x -> d_C__case_3 e cd x) $! addCs c cs)
  Fail_C_Span d info -> failCons d (traceFail "Curry.Span._case_3" [show x2]
    info)
  _ -> failCons cd (consFail "Curry.Span._case_3" (showCons x2))

d_C__case_1 :: Curry.Curry_Position.C_Position
  -> Curry.Curry_Position.C_Position -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_Prelude.C_Int
d_C__case_1 x3 x2 cd cs = case x2 of
  Curry.Curry_Position.C_Position x4 x5 -> d_C__case_0 x5 x4 x3 cd cs
  Curry.Curry_Position.C_NoPos -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int
    (0)) (Curry_Prelude.C_Int (0))
  Curry.Curry_Position.Choice_C_Position d i l r -> narrow d i (d_C__case_1 x3 l
    cd cs) (d_C__case_1 x3 r cd cs)
  Curry.Curry_Position.Choices_C_Position d i xs -> narrows cs d i (\z ->
    d_C__case_1 x3 z cd cs) xs
  Curry.Curry_Position.Guard_C_Position d c e -> guardCons d c ((\x ->
    d_C__case_1 x3 e cd x) $! addCs c cs)
  Curry.Curry_Position.Fail_C_Position d info -> failCons d (traceFail
    "Curry.Span._case_1" [show x3, show x2] info)
  _ -> failCons cd (consFail "Curry.Span._case_1" (showCons x2))

d_C__case_0 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry.Curry_Position.C_Position -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_Prelude.C_Int
d_C__case_0 x5 x4 x3 cd cs = case x3 of
  Curry.Curry_Position.C_Position x6 x7 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x6 x4 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x7 x5 cd cs)
  Curry.Curry_Position.C_NoPos -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int
    (0)) (Curry_Prelude.C_Int (0))
  Curry.Curry_Position.Choice_C_Position d i l r -> narrow d i (d_C__case_0 x5
    x4 l cd cs) (d_C__case_0 x5 x4 r cd cs)
  Curry.Curry_Position.Choices_C_Position d i xs -> narrows cs d i (\z ->
    d_C__case_0 x5 x4 z cd cs) xs
  Curry.Curry_Position.Guard_C_Position d c e -> guardCons d c ((\x ->
    d_C__case_0 x5 x4 e cd x) $! addCs c cs)
  Curry.Curry_Position.Fail_C_Position d info -> failCons d (traceFail
    "Curry.Span._case_0" [show x5, show x4, show x3] info)
  _ -> failCons cd (consFail "Curry.Span._case_0" (showCons x3))

