{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Data.Curry_Traversal
  ( d_C_noChildren
  , nd_C_noChildren
  , d_C_children
  , nd_C_children
  , d_C_replaceChildren
  , nd_C_replaceChildren
  , d_C_mapChildren
  , nd_C_mapChildren
  , d_C_family
  , nd_C_family
  , d_C_childFamilies
  , nd_C_childFamilies
  , d_C_mapFamily
  , nd_C_mapFamily
  , d_C_mapChildFamilies
  , nd_C_mapChildFamilies
  , d_C_evalFamily
  , nd_C_evalFamily
  , d_C_evalChildFamilies
  , nd_C_evalChildFamilies
  , d_C_fold
  , nd_C_fold
  , d_C_foldChildren
  , nd_C_foldChildren
  , d_C_replaceChildrenM
  , nd_C_replaceChildrenM
  , d_C_mapChildrenM
  , nd_C_mapChildrenM
  , d_C_mapFamilyM
  , nd_C_mapFamilyM
  , d_C_mapChildFamiliesM
  , nd_C_mapChildFamiliesM
  , d_C_evalFamilyM
  , nd_C_evalFamilyM
  , d_C_evalChildFamiliesM
  , nd_C_evalChildFamiliesM )
  where

import Basics
import qualified Curry_Prelude


d_C_noChildren :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> t1)
d_C_noChildren x1 cd cs = Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List
  (Curry_Prelude.d_C_const x1)

nd_C_noChildren :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Func (Curry_Prelude.OP_List t0) t1)
nd_C_noChildren x1 s cd cs = Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List
  (wrapDX id (Curry_Prelude.d_C_const x1))

d_C_children :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List t1 -> Cover -> ConstStore
  -> t0)) -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t1
d_C_children x1 cd cs = Curry_Prelude.d_OP_dot Curry_Prelude.d_C_fst x1 cd cs

nd_C_children :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Func t0 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) (Func
  (Curry_Prelude.OP_List t1) t0)) -> IDSupply -> Cover -> ConstStore -> Func t0
  (Curry_Prelude.OP_List t1)
nd_C_children x1 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX id Curry_Prelude.d_C_fst) x1 s0 cd
  cs

d_C_replaceChildren :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List
  t1 -> Cover -> ConstStore -> t0)) -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t1 -> Cover -> ConstStore -> t0
d_C_replaceChildren x1 cd cs = Curry_Prelude.d_OP_dot Curry_Prelude.d_C_snd x1
  cd cs

nd_C_replaceChildren :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Func t0 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) (Func (Curry_Prelude.OP_List t1) t0)) -> IDSupply
  -> Cover -> ConstStore -> Func t0 (Func (Curry_Prelude.OP_List t1) t0)
nd_C_replaceChildren x1 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX id Curry_Prelude.d_C_snd) x1 s0 cd
  cs

d_C_mapChildren :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> t1)) -> (t0 -> Cover -> ConstStore -> t0) -> t1 -> Cover -> ConstStore
  -> t1
d_C_mapChildren x1 x2 x3 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (d_C_replaceChildren x1 cd cs) x3 cd cs)
  (Curry_Prelude.d_C_map x2 (Curry_Prelude.d_C_apply (d_C_children x1 cd cs) x3
  cd cs) cd cs) cd cs

nd_C_mapChildren :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Func
  (Curry_Prelude.OP_List t0) t1)) -> Func t0 t0 -> t1 -> IDSupply -> Cover
  -> ConstStore -> t1
nd_C_mapChildren x1 x2 x3 s cd cs = let s9 = s
  in s9 `seq` (let s8 = leftSupply s9
                   s10 = rightSupply s9
                   s2 = leftSupply s10
                   s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s2 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_replaceChildren x1 s0 cd
  cs) x3 s1 cd cs)) (let s6 = leftSupply s7
                         s5 = rightSupply s7
  in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_map x2 (let s4 = leftSupply s5
                                                       s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (nd_C_children x1 s3 cd cs) x3
  s4 cd cs)) s6 cd cs)) s8 cd cs))))

d_C_family :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t0 -> Cover -> ConstStore -> t0)) -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C_family x1 x2 cd cs = d_C_familyFL x1 x2 Curry_Prelude.OP_List cd cs

nd_C_family :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Func
  (Curry_Prelude.OP_List t0) t0)) -> t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C_family x1 x2 s cd cs = let s0 = s
  in s0 `seq` nd_C_familyFL x1 x2 Curry_Prelude.OP_List s0 cd cs

d_C_childFamilies :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> t1)) -> (t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> t0)) -> t1 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_childFamilies x1 x2 x3 cd cs = d_C_childFamiliesFL x1 x2 x3
  Curry_Prelude.OP_List cd cs

nd_C_childFamilies :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func t1 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Func (Curry_Prelude.OP_List t0) t1)) -> Func t0
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Func
  (Curry_Prelude.OP_List t0) t0)) -> t1 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C_childFamilies x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` nd_C_childFamiliesFL x1 x2 x3 Curry_Prelude.OP_List s0 cd cs

d_C_mapFamily :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0)) -> (t0 -> Cover
  -> ConstStore -> t0) -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t0
d_C_mapFamily x1 x2 cd cs = Curry_Prelude.d_OP_dot x2 (Curry_Prelude.d_C_apply
  (d_C_mapChildFamilies x1 x1 cd cs) x2 cd cs) cd cs

nd_C_mapFamily :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Func
  (Curry_Prelude.OP_List t0) t0)) -> Func t0 t0 -> IDSupply -> Cover
  -> ConstStore -> Func t0 t0
nd_C_mapFamily x1 x2 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dot x2 (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_mapChildFamilies x1 x1 s0
  cd cs) x2 s1 cd cs)) s3 cd cs))

d_C_mapChildFamilies :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t0 -> Cover -> ConstStore -> t1)) -> (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t0 -> Cover -> ConstStore -> t0)) -> Cover -> ConstStore -> (t0 -> Cover
  -> ConstStore -> t0) -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t1
d_C_mapChildFamilies x1 x2 cd cs = Curry_Prelude.d_OP_dot (acceptCs id
  (d_C_mapChildren x1)) (d_C_mapFamily x2) cd cs

nd_C_mapChildFamilies :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func t1 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Func (Curry_Prelude.OP_List t0) t1)) -> Func t0
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Func
  (Curry_Prelude.OP_List t0) t0)) -> IDSupply -> Cover -> ConstStore -> Func
  (Func t0 t0) (Func t1 t1)
nd_C_mapChildFamilies x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX (wrapNX id) (acceptCs id
  (nd_C_mapChildren x1))) (wrapNX id (nd_C_mapFamily x2)) s0 cd cs

d_C_evalFamily :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0)) -> (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Maybe t0) -> Cover -> ConstStore -> t0
  -> Cover -> ConstStore -> t0
d_C_evalFamily x1 x2 cd cs = d_C_mapFamily x1 (d_OP_evalFamily_dot_g_dot_18 x2
  x1) cd cs

nd_C_evalFamily :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Func
  (Curry_Prelude.OP_List t0) t0)) -> Func t0 (Curry_Prelude.C_Maybe t0)
  -> IDSupply -> Cover -> ConstStore -> Func t0 t0
nd_C_evalFamily x1 x2 s cd cs = let s0 = s
  in s0 `seq` nd_C_mapFamily x1 (wrapNX id (nd_OP_evalFamily_dot_g_dot_18 x2
  x1)) s0 cd cs

d_OP_evalFamily_dot_g_dot_18 :: forall t0 . (Curry_Prelude.Curry t0) => (t0
  -> Cover -> ConstStore -> Curry_Prelude.C_Maybe t0) -> (t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0)) -> t0 -> Cover
  -> ConstStore -> t0
d_OP_evalFamily_dot_g_dot_18 x1 x2 x3 cd cs = Curry_Prelude.d_C_maybe x3
  (d_C_mapFamily x2 (d_OP_evalFamily_dot_g_dot_18 x1 x2) cd cs)
  (Curry_Prelude.d_C_apply x1 x3 cd cs) cd cs

nd_OP_evalFamily_dot_g_dot_18 :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  (Curry_Prelude.C_Maybe t0) -> Func t0 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Func (Curry_Prelude.OP_List t0) t0)) -> t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_OP_evalFamily_dot_g_dot_18 x1 x2 x3 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_maybe x3
  (nd_C_mapFamily x2 (wrapNX id (nd_OP_evalFamily_dot_g_dot_18 x1 x2)) s0 cd cs)
  (Curry_Prelude.nd_C_apply x1 x3 s1 cd cs) s2 cd cs))))

d_C_evalChildFamilies :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t0 -> Cover -> ConstStore -> t1)) -> (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t0 -> Cover -> ConstStore -> t0)) -> Cover -> ConstStore -> (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Maybe t0) -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> t1
d_C_evalChildFamilies x1 x2 cd cs = Curry_Prelude.d_OP_dot (acceptCs id
  (d_C_mapChildren x1)) (d_C_evalFamily x2) cd cs

nd_C_evalChildFamilies :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func t1 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Func (Curry_Prelude.OP_List t0) t1)) -> Func t0
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Func
  (Curry_Prelude.OP_List t0) t0)) -> IDSupply -> Cover -> ConstStore -> Func
  (Func t0 (Curry_Prelude.C_Maybe t0)) (Func t1 t1)
nd_C_evalChildFamilies x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX (wrapNX id) (acceptCs id
  (nd_C_mapChildren x1))) (wrapNX id (nd_C_evalFamily x2)) s0 cd cs

d_C_fold :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List t1 -> Cover -> ConstStore
  -> t1)) -> (t1 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0 -> Cover
  -> ConstStore -> t0) -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0
d_C_fold x1 x2 cd cs = d_C_foldChildren x1 x1 x2 x2

nd_C_fold :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) (Func
  (Curry_Prelude.OP_List t1) t1)) -> Func t1 (Func (Curry_Prelude.OP_List t0)
  t0) -> IDSupply -> Cover -> ConstStore -> Func t1 t0
nd_C_fold x1 x2 s cd cs = wrapNX id (nd_C_foldChildren x1 x1 x2 x2)

d_C_foldChildren :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2) => (t3 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> t3)) -> (t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> t0)) -> (t3 -> Cover -> ConstStore -> Curry_Prelude.OP_List t1 -> Cover
  -> ConstStore -> t2) -> (t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t1
  -> Cover -> ConstStore -> t1) -> t3 -> Cover -> ConstStore -> t2
d_C_foldChildren x1 x2 x3 x4 x5 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply x3 x5 cd cs) (Curry_Prelude.d_C_map (d_C_fold x2 x4
  cd cs) (Curry_Prelude.d_C_apply (d_C_children x1 cd cs) x5 cd cs) cd cs) cd cs

nd_C_foldChildren :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2) => Func t3 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Func
  (Curry_Prelude.OP_List t0) t3)) -> Func t0 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Func (Curry_Prelude.OP_List t0) t0)) -> Func t3
  (Func (Curry_Prelude.OP_List t1) t2) -> Func t0 (Func (Curry_Prelude.OP_List
  t1) t1) -> t3 -> IDSupply -> Cover -> ConstStore -> t2
nd_C_foldChildren x1 x2 x3 x4 x5 s cd cs = let s9 = s
  in s9 `seq` (let s8 = leftSupply s9
                   s10 = rightSupply s9
                   s0 = leftSupply s10
                   s6 = rightSupply s10
  in s8 `seq` (s10 `seq` (s0 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_C_apply x3 x5 s0 cd cs) (let s5 = leftSupply s6
                                                 s7 = rightSupply s6
                                                 s1 = leftSupply s7
                                                 s4 = rightSupply s7
  in s5 `seq` (s7 `seq` (s1 `seq` (s4 `seq` Curry_Prelude.nd_C_map (nd_C_fold x2
  x4 s1 cd cs) (let s3 = leftSupply s4
                    s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (nd_C_children x1 s2 cd cs) x5
  s3 cd cs)) s5 cd cs)))) s8 cd cs))))

d_C_replaceChildrenM :: forall t0 t1 t2 . (forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t2 x0), Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Monad t2) -> (t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t0 -> Cover -> ConstStore -> t1)) -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_Apply t2 (Curry_Prelude.OP_List t0) -> Cover
  -> ConstStore -> Curry_Prelude.C_Apply t2 t1
d_C_replaceChildrenM x1 x2 cd cs = Curry_Prelude.d_OP_dot
  (Curry_Prelude.d_C_fmap
  (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Applicative_hash_Prelude_dot_Functor_hash_0_hash
  (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Monad_hash_Prelude_dot_Applicative_hash_0_hash
  x1 cd cs) cd cs) cd cs) (d_C_replaceChildren x2 cd cs) cd cs

nd_C_replaceChildrenM :: forall t0 t1 t2 . (forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t2 x0), Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Monad t2) -> Func t1
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Func
  (Curry_Prelude.OP_List t0) t1)) -> IDSupply -> Cover -> ConstStore -> Func t1
  (Func (Curry_Prelude.C_Apply t2 (Curry_Prelude.OP_List t0))
  (Curry_Prelude.C_Apply t2 t1))
nd_C_replaceChildrenM x1 x2 s cd cs = let s7 = s
  in s7 `seq` (let s6 = leftSupply s7
                   s8 = rightSupply s7
                   s4 = leftSupply s8
                   s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s4 `seq` (s5 `seq` Curry_Prelude.nd_OP_dot
  (let s3 = leftSupply s4
       s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_fmap (let s1 = leftSupply s2
                                                     s0 = rightSupply s2
  in s1 `seq` (s0 `seq`
  Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Applicative_hash_Prelude_dot_Functor_hash_0_hash
  (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Monad_hash_Prelude_dot_Applicative_hash_0_hash
  x1 s0 cd cs) s1 cd cs)) s3 cd cs)) (nd_C_replaceChildren x2 s5 cd cs) s6 cd
  cs))))

d_C_mapChildrenM :: forall t0 t1 t2 . (forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t1 x0), Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Monad t1) -> (t2 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t0 -> Cover -> ConstStore -> t2)) -> (t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Apply t1 t0) -> t2 -> Cover -> ConstStore
  -> Curry_Prelude.C_Apply t1 t2
d_C_mapChildrenM x1 x2 x3 x4 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (d_C_replaceChildrenM x1 x2 cd cs) x4 cd cs)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_mapM x1 x3 cd cs)
  (Curry_Prelude.d_C_apply (d_C_children x2 cd cs) x4 cd cs) cd cs) cd cs

nd_C_mapChildrenM :: forall t0 t1 t2 . (forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t1 x0), Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Monad t1) -> Func t2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Func
  (Curry_Prelude.OP_List t0) t2)) -> Func t0 (Curry_Prelude.C_Apply t1 t0) -> t2
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Apply t1 t2
nd_C_mapChildrenM x1 x2 x3 x4 s cd cs = let s11 = s
  in s11 `seq` (let s10 = leftSupply s11
                    s12 = rightSupply s11
                    s2 = leftSupply s12
                    s8 = rightSupply s12
  in s10 `seq` (s12 `seq` (s2 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_replaceChildrenM x1 x2 s0
  cd cs) x4 s1 cd cs)) (let s7 = leftSupply s8
                            s9 = rightSupply s8
                            s3 = leftSupply s9
                            s6 = rightSupply s9
  in s7 `seq` (s9 `seq` (s3 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_C_mapM x1 x3 s3 cd cs) (let s5 = leftSupply s6
                                                s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (nd_C_children x2 s4 cd cs) x4
  s5 cd cs)) s7 cd cs)))) s10 cd cs))))

d_C_mapFamilyM :: forall t0 t1 . (forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t0 x0), Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Monad t0) -> (t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List
  t1 -> Cover -> ConstStore -> t1)) -> (t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Apply t0 t1) -> t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Apply t0 t1
d_C_mapFamilyM x1 x2 x3 x4 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_gt_gt_eq x1 cd cs)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_C_mapChildFamiliesM x1 x2
  x2 cd cs) x3 cd cs) x4 cd cs) cd cs) x3 cd cs

nd_C_mapFamilyM :: forall t0 t1 . (forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t0 x0), Curry_Prelude.Curry
  t1) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Monad t0)
  -> Func t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) (Func
  (Curry_Prelude.OP_List t1) t1)) -> Func t1 (Curry_Prelude.C_Apply t0 t1) -> t1
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Apply t0 t1
nd_C_mapFamilyM x1 x2 x3 x4 s cd cs = let s10 = s
  in s10 `seq` (let s9 = leftSupply s10
                    s7 = rightSupply s10
  in s9 `seq` (s7 `seq` Curry_Prelude.nd_C_apply (let s6 = leftSupply s7
                                                      s8 = rightSupply s7
                                                      s0 = leftSupply s8
                                                      s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s0 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_gt_gt_eq x1 s0 cd cs) (let s4 = leftSupply s5
                                                  s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                      s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (nd_C_mapChildFamiliesM x1 x2
  x2 s1 cd cs) x3 s2 cd cs)) x4 s4 cd cs)) s6 cd cs)))) x3 s9 cd cs))

d_C_mapChildFamiliesM :: forall t0 t1 t2 . (forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t0 x0), Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Monad t0) -> (t2 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List
  t1 -> Cover -> ConstStore -> t2)) -> (t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List
  t1 -> Cover -> ConstStore -> t1)) -> Cover -> ConstStore -> (t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_Apply t0 t1) -> Cover -> ConstStore -> t2
  -> Cover -> ConstStore -> Curry_Prelude.C_Apply t0 t2
d_C_mapChildFamiliesM x1 x2 x3 cd cs = Curry_Prelude.d_OP_dot (acceptCs id
  (d_C_mapChildrenM x1 x2)) (acceptCs id (d_C_mapFamilyM x1 x3)) cd cs

nd_C_mapChildFamiliesM :: forall t0 t1 t2 . (forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t0 x0), Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t1) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Monad t0) -> Func t2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) (Func
  (Curry_Prelude.OP_List t1) t2)) -> Func t1 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) (Func (Curry_Prelude.OP_List t1) t1)) -> IDSupply
  -> Cover -> ConstStore -> Func (Func t1 (Curry_Prelude.C_Apply t0 t1)) (Func
  t2 (Curry_Prelude.C_Apply t0 t2))
nd_C_mapChildFamiliesM x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX (wrapNX id) (acceptCs id
  (nd_C_mapChildrenM x1 x2))) (wrapDX (wrapNX id) (acceptCs id (nd_C_mapFamilyM
  x1 x3))) s0 cd cs

d_C_evalFamilyM :: forall t0 t1 . (forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t0 x0), Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Monad t0) -> (t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List
  t1 -> Cover -> ConstStore -> t1)) -> (t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Apply t0 (Curry_Prelude.C_Maybe t1)) -> Cover -> ConstStore
  -> t1 -> Cover -> ConstStore -> Curry_Prelude.C_Apply t0 t1
d_C_evalFamilyM x1 x2 x3 cd cs = d_C_mapFamilyM x1 x2
  (d_OP_evalFamilyM_dot_g_dot_36 x1 x3 x2)

nd_C_evalFamilyM :: forall t0 t1 . (forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t0 x0), Curry_Prelude.Curry
  t1) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Monad t0)
  -> Func t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) (Func
  (Curry_Prelude.OP_List t1) t1)) -> Func t1 (Curry_Prelude.C_Apply t0
  (Curry_Prelude.C_Maybe t1)) -> IDSupply -> Cover -> ConstStore -> Func t1
  (Curry_Prelude.C_Apply t0 t1)
nd_C_evalFamilyM x1 x2 x3 s cd cs = wrapNX id (nd_C_mapFamilyM x1 x2 (wrapNX id
  (nd_OP_evalFamilyM_dot_g_dot_36 x1 x3 x2)))

d_OP_evalFamilyM_dot_g_dot_36 :: forall t0
  t1 . (forall x0 . (Curry_Prelude.Curry x0) => Curry_Prelude.Curry
  (Curry_Prelude.C_Apply t0 x0), Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Monad t0) -> (t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Apply t0 (Curry_Prelude.C_Maybe t1)) -> (t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1)
  (Curry_Prelude.OP_List t1 -> Cover -> ConstStore -> t1)) -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_Apply t0 t1
d_OP_evalFamilyM_dot_g_dot_36 x1 x2 x3 x4 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_gt_gt_eq x1 cd cs)
  (Curry_Prelude.d_C_apply x2 x4 cd cs) cd cs) (Curry_Prelude.d_C_maybe
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_return x1 cd cs) x4 cd cs)
  (d_C_mapFamilyM x1 x3 (d_OP_evalFamilyM_dot_g_dot_36 x1 x2 x3))) cd cs

nd_OP_evalFamilyM_dot_g_dot_36 :: forall t0
  t1 . (forall x0 . (Curry_Prelude.Curry x0) => Curry_Prelude.Curry
  (Curry_Prelude.C_Apply t0 x0), Curry_Prelude.Curry t1) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Monad t0) -> Func t1
  (Curry_Prelude.C_Apply t0 (Curry_Prelude.C_Maybe t1)) -> Func t1
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) (Func
  (Curry_Prelude.OP_List t1) t1)) -> t1 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Apply t0 t1
nd_OP_evalFamilyM_dot_g_dot_36 x1 x2 x3 x4 s cd cs = let s9 = s
  in s9 `seq` (let s8 = leftSupply s9
                   s10 = rightSupply s9
                   s3 = leftSupply s10
                   s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s3 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
  (let s2 = leftSupply s3
       s4 = rightSupply s3
       s0 = leftSupply s4
       s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_gt_gt_eq x1 s0 cd cs) (Curry_Prelude.nd_C_apply x2 x4 s1
  cd cs) s2 cd cs)))) (wrapNX id (Curry_Prelude.nd_C_maybe (let s6 = leftSupply
                                                                  s7
                                                                s5 = rightSupply
                                                                  s7
  in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_return x1
  s5 cd cs) x4 s6 cd cs)) (wrapNX id (nd_C_mapFamilyM x1 x3 (wrapNX id
  (nd_OP_evalFamilyM_dot_g_dot_36 x1 x2 x3)))))) s8 cd cs))))

d_C_evalChildFamiliesM :: forall t0 t1 t2 . (forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t0 x0), Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Monad t0) -> (t2 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List
  t1 -> Cover -> ConstStore -> t2)) -> (t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List
  t1 -> Cover -> ConstStore -> t1)) -> Cover -> ConstStore -> (t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_Apply t0 (Curry_Prelude.C_Maybe t1)) -> Cover
  -> ConstStore -> t2 -> Cover -> ConstStore -> Curry_Prelude.C_Apply t0 t2
d_C_evalChildFamiliesM x1 x2 x3 cd cs = Curry_Prelude.d_OP_dot (acceptCs id
  (d_C_mapChildrenM x1 x2)) (d_C_evalFamilyM x1 x3) cd cs

nd_C_evalChildFamiliesM :: forall t0 t1 t2 . (forall x0 . (Curry_Prelude.Curry
  x0) => Curry_Prelude.Curry (Curry_Prelude.C_Apply t0 x0), Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t1) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Monad t0) -> Func t2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t1) (Func
  (Curry_Prelude.OP_List t1) t2)) -> Func t1 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t1) (Func (Curry_Prelude.OP_List t1) t1)) -> IDSupply
  -> Cover -> ConstStore -> Func (Func t1 (Curry_Prelude.C_Apply t0
  (Curry_Prelude.C_Maybe t1))) (Func t2 (Curry_Prelude.C_Apply t0 t2))
nd_C_evalChildFamiliesM x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX (wrapNX id) (acceptCs id
  (nd_C_mapChildrenM x1 x2))) (wrapNX id (nd_C_evalFamilyM x1 x3)) s0 cd cs

d_C_concatFL :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0)
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_concatFL x1 x2 cd cs = case x1 of
  Curry_Prelude.OP_List -> x2
  Curry_Prelude.OP_Cons x3 x4 -> Curry_Prelude.d_C_apply x3 (d_C_concatFL x4 x2
    cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_concatFL l x2 cd cs)
    (d_C_concatFL r x2 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_concatFL z
    x2 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_concatFL e x2
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.Traversal.concatFL" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Traversal.concatFL" (showCons x1))

nd_C_concatFL :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Func (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0))
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C_concatFL x1 x2 s cd cs = case x1 of
  Curry_Prelude.OP_List -> x2
  Curry_Prelude.OP_Cons x3 x4 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply x3 (nd_C_concatFL x4 x2 s0 cd
    cs) s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_concatFL l x2 s cd
    cs) (nd_C_concatFL r x2 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_concatFL z
    x2 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_concatFL e x2
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.Traversal.concatFL" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Traversal.concatFL" (showCons x1))

d_C_familyFL :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0)) -> t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_familyFL x1 x2 x3 cd cs = Curry_Prelude.OP_Cons x2 (d_C_childFamiliesFL x1
  x1 x2 x3 cd cs)

nd_C_familyFL :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Func
  (Curry_Prelude.OP_List t0) t0)) -> t0 -> Curry_Prelude.OP_List t0 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_familyFL x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.OP_Cons x2 (nd_C_childFamiliesFL x1 x1 x2 x3 s0 cd
  cs)

d_C_childFamiliesFL :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t0 -> Cover -> ConstStore -> t1)) -> (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t0 -> Cover -> ConstStore -> t0)) -> t1 -> Curry_Prelude.OP_List t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
d_C_childFamiliesFL x1 x2 x3 x4 cd cs = d_C_concatFL (Curry_Prelude.d_C_map
  (acceptCs id (d_C_familyFL x2)) (Curry_Prelude.d_C_apply (d_C_children x1 cd
  cs) x3 cd cs) cd cs) x4 cd cs

nd_C_childFamiliesFL :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func t1 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Func (Curry_Prelude.OP_List t0) t1)) -> Func t0
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Func
  (Curry_Prelude.OP_List t0) t0)) -> t1 -> Curry_Prelude.OP_List t0 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_childFamiliesFL x1 x2 x3 x4 s cd cs = let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s4 = rightSupply s6
  in s5 `seq` (s4 `seq` nd_C_concatFL (let s3 = leftSupply s4
                                           s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_map (wrapDX (wrapNX id) (acceptCs id
  (nd_C_familyFL x2))) (let s1 = leftSupply s2
                            s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_children x1 s0 cd cs) x3
  s1 cd cs)) s3 cd cs)) x4 s5 cd cs))

