{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Crypto.Curry_Hash
  ( d_C_getHash, d_C_getHashWith, d_C_randomString )
  where

import Basics
import qualified Curry_Prelude
import qualified System.Curry_IO
import qualified System.Curry_IOExts
import qualified System.Curry_Random


d_C_getHash :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C_getHash cd cs = d_C_getHashWith (Curry_Prelude.toCurryString "md5sum")

d_C_getHashWith :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_getHashWith x1 x2 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_IOExts.d_C_execCmd x1 cd cs) cd cs)
  (d_OP_getHashWith_dot_uscore_hash_lambda3 x2) cd cs

d_OP_getHashWith_dot_uscore_hash_lambda3 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple3 System.Curry_IO.C_Handle
  System.Curry_IO.C_Handle System.Curry_IO.C_Handle -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_getHashWith_dot_uscore_hash_lambda3 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple3 x3 x4 x5 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_IO.d_C_hPutStrLn x3 x1 cd cs) cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_IO.d_C_hClose x3 cd cs) cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_IO.d_C_hGetLine x4 cd cs) cd cs)
    d_OP_getHashWith_dot_uscore_hash_lambda3_dot_uscore_hash_lambda5 cd cs) cd
    cs) cd cs
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_getHashWith_dot_uscore_hash_lambda3 x1 l cd cs)
    (d_OP_getHashWith_dot_uscore_hash_lambda3 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_getHashWith_dot_uscore_hash_lambda3 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_getHashWith_dot_uscore_hash_lambda3 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Crypto.Hash.getHashWith._#lambda3" [show x1, show x2] info)
  _ -> failCons cd (consFail "Crypto.Hash.getHashWith._#lambda3" (showCons x2))

d_OP_getHashWith_dot_uscore_hash_lambda3_dot_uscore_hash_lambda5 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_getHashWith_dot_uscore_hash_lambda3_dot_uscore_hash_lambda5 x1 cd cs =
  let x2 = x1
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_head (Curry_Prelude.d_C_words x2 cd cs) cd cs) cd cs

d_C_randomString :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_randomString x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_Random.d_C_getRandomSeed cd cs) cd cs)
  (d_OP_randomString_dot_uscore_hash_lambda9 x1) cd cs

d_OP_randomString_dot_uscore_hash_lambda9 :: Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_randomString_dot_uscore_hash_lambda9 x1 x2 cd cs = let x3 = x2
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_apply (d_C_getHash cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs) (Curry_Prelude.d_OP_bang_bang (System.Curry_Random.d_C_nextInt x3 cd
  cs) (Curry_Prelude.C_Int (3)) cd cs) cd cs) cd cs) cd cs)
  (d_OP_randomString_dot_uscore_hash_lambda9_dot_uscore_hash_lambda11 x1) cd cs

d_OP_randomString_dot_uscore_hash_lambda9_dot_uscore_hash_lambda11 :: Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_randomString_dot_uscore_hash_lambda9_dot_uscore_hash_lambda11 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_take x1 x3 cd cs) cd cs

