{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Data.Function.Curry_Inversion
  ( nd_C_invf1, nd_C_invf2, nd_C_invf3, nd_C_invf4, nd_C_invf5 )
  where

import Basics
import qualified Curry_Prelude


nd_C_invf1 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t1)
  -> Func t0 t1 -> t1 -> IDSupply -> Cover -> ConstStore -> t0
nd_C_invf1 x1 x2 x3 x4 s cd cs = let s4 = s
  in s4 `seq` (let s0 = leftSupply s4
                   s3 = rightSupply s4
  in s0 `seq` (s3 `seq` (let x5 = generate s0 cd
  in let s2 = leftSupply s3
         s1 = rightSupply s3
  in s2 `seq` (s1 `seq` nd_C__case_4 x4 x5 x3 (Curry_Prelude.d_OP_eq_colon_lt_eq
  (Curry_Prelude.nd_C_apply x3 x5 s1 cd cs) x4 cd cs) s2 cd cs))))

nd_C_invf2 :: forall t0 t1 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t2) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t2) -> Func t1 (Func t0 t2) -> t2
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t0
nd_C_invf2 x1 x2 x3 x4 x5 s cd cs = let s7 = s
  in s7 `seq` (let s0 = leftSupply s7
                   s8 = rightSupply s7
                   s1 = leftSupply s8
                   s6 = rightSupply s8
  in s0 `seq` (s8 `seq` (s1 `seq` (s6 `seq` (let x6 = generate s0 cd
                                                 x7 = generate s1 cd
  in let s5 = leftSupply s6
         s4 = rightSupply s6
  in s5 `seq` (s4 `seq` nd_C__case_3 x5 x7 x6 x4
  (Curry_Prelude.d_OP_eq_colon_lt_eq (let s3 = leftSupply s4
                                          s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x4 x6
  s2 cd cs) x7 s3 cd cs)) x5 cd cs) s5 cd cs))))))

nd_C_invf3 :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry t3) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t2) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t3) -> Func t2
  (Func t1 (Func t0 t3)) -> t3 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 t2 t1 t0
nd_C_invf3 x1 x2 x3 x4 x5 x6 s cd cs = let s10 = s
  in s10 `seq` (let s11 = leftSupply s10
                    s12 = rightSupply s10
                    s0 = leftSupply s11
                    s1 = rightSupply s11
                    s2 = leftSupply s12
                    s9 = rightSupply s12
  in s11 `seq` (s12 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s9 `seq`
  (let x7 = generate s0 cd
       x8 = generate s1 cd
       x9 = generate s2 cd
  in let s8 = leftSupply s9
         s7 = rightSupply s9
  in s8 `seq` (s7 `seq` nd_C__case_2 x6 x9 x8 x7 x5
  (Curry_Prelude.d_OP_eq_colon_lt_eq (let s6 = leftSupply s7
                                          s5 = rightSupply s7
  in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                      s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x5 x7
  s3 cd cs) x8 s4 cd cs)) x9 s6 cd cs)) x6 cd cs) s8 cd cs))))))))

nd_C_invf4 :: forall t0 t1 t2 t3 t4 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t4) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t3) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t2) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t4) -> Func t3 (Func t2 (Func t1 (Func
  t0 t4))) -> t4 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple4
  t3 t2 t1 t0
nd_C_invf4 x1 x2 x3 x4 x5 x6 x7 s cd cs = let s13 = s
  in s13 `seq` (let s14 = leftSupply s13
                    s15 = rightSupply s13
                    s0 = leftSupply s14
                    s1 = rightSupply s14
                    s2 = leftSupply s15
                    s16 = rightSupply s15
                    s3 = leftSupply s16
                    s12 = rightSupply s16
  in s14 `seq` (s15 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s16 `seq` (s3 `seq`
  (s12 `seq` (let x8 = generate s0 cd
                  x9 = generate s1 cd
                  x10 = generate s2 cd
                  x11 = generate s3 cd
  in let s11 = leftSupply s12
         s10 = rightSupply s12
  in s11 `seq` (s10 `seq` nd_C__case_1 x7 x11 x10 x9 x8 x6
  (Curry_Prelude.d_OP_eq_colon_lt_eq (let s9 = leftSupply s10
                                          s8 = rightSupply s10
  in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (let s7 = leftSupply s8
                                                      s6 = rightSupply s8
  in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                      s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x6 x8
  s4 cd cs) x9 s5 cd cs)) x10 s7 cd cs)) x11 s9 cd cs)) x7 cd cs) s11 cd
  cs))))))))))

nd_C_invf5 :: forall t0 t1 t2 t3 t4 t5 . (Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t5) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t4) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t3) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t2) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t5) -> Func t4
  (Func t3 (Func t2 (Func t1 (Func t0 t5)))) -> t5 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple5 t4 t3 t2 t1 t0
nd_C_invf5 x1 x2 x3 x4 x5 x6 x7 x8 s cd cs = let s16 = s
  in s16 `seq` (let s17 = leftSupply s16
                    s19 = rightSupply s16
                    s0 = leftSupply s17
                    s18 = rightSupply s17
                    s1 = leftSupply s18
                    s2 = rightSupply s18
                    s3 = leftSupply s19
                    s20 = rightSupply s19
                    s4 = leftSupply s20
                    s15 = rightSupply s20
  in s17 `seq` (s19 `seq` (s0 `seq` (s18 `seq` (s1 `seq` (s2 `seq` (s3 `seq`
  (s20 `seq` (s4 `seq` (s15 `seq` (let x9 = generate s0 cd
                                       x10 = generate s1 cd
                                       x11 = generate s2 cd
                                       x12 = generate s3 cd
                                       x13 = generate s4 cd
  in let s14 = leftSupply s15
         s13 = rightSupply s15
  in s14 `seq` (s13 `seq` nd_C__case_0 x8 x13 x12 x11 x10 x9 x7
  (Curry_Prelude.d_OP_eq_colon_lt_eq (let s12 = leftSupply s13
                                          s11 = rightSupply s13
  in s12 `seq` (s11 `seq` Curry_Prelude.nd_C_apply (let s10 = leftSupply s11
                                                        s9 = rightSupply s11
  in s10 `seq` (s9 `seq` Curry_Prelude.nd_C_apply (let s8 = leftSupply s9
                                                       s7 = rightSupply s9
  in s8 `seq` (s7 `seq` Curry_Prelude.nd_C_apply (let s6 = leftSupply s7
                                                      s5 = rightSupply s7
  in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x7 x9
  s5 cd cs) x10 s6 cd cs)) x11 s8 cd cs)) x12 s10 cd cs)) x13 s12 cd cs)) x8 cd
  cs) s14 cd cs))))))))))))

d_C__case_4 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t0 -> (t0 -> Cover -> ConstStore -> t1) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> t0
d_C__case_4 x4 x5 x3 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> x5
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x4 x5 x3 l cd
    cs) (d_C__case_4 x4 x5 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x4 x5
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x4 x5 x3
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Function.Inversion._case_4" [show x4, show x5, show x3, show x6] info)
  _ -> failCons cd (consFail "Data.Function.Inversion._case_4" (showCons x6))

nd_C__case_4 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t0 -> Func t0 t1 -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> t0
nd_C__case_4 x4 x5 x3 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> x5
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_4 x4 x5 x3 l s
    cd cs) (nd_C__case_4 x4 x5 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_4 x4
    x5 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_4 x4 x5
    x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Function.Inversion._case_4" [show x4, show x5, show x3, show x6] info)
  _ -> failCons cd (consFail "Data.Function.Inversion._case_4" (showCons x6))

d_C__case_3 :: forall t2 t0 t1 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => t2 -> t0 -> t1 -> (t1 -> Cover -> ConstStore
  -> t0 -> Cover -> ConstStore -> t2) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t0
d_C__case_3 x5 x7 x6 x4 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 x6 x7
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x5 x7 x6 x4 l
    cd cs) (d_C__case_3 x5 x7 x6 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x5 x7
    x6 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x5 x7 x6
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Function.Inversion._case_3" [show x5, show x7, show x6, show x4, show
    x8] info)
  _ -> failCons cd (consFail "Data.Function.Inversion._case_3" (showCons x8))

nd_C__case_3 :: forall t2 t0 t1 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t1) => t2 -> t0 -> t1 -> Func t1 (Func t0 t2)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 t0
nd_C__case_3 x5 x7 x6 x4 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 x6 x7
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_3 x5 x7 x6 x4 l
    s cd cs) (nd_C__case_3 x5 x7 x6 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_3 x5
    x7 x6 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_3 x5 x7
    x6 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Function.Inversion._case_3" [show x5, show x7, show x6, show x4, show
    x8] info)
  _ -> failCons cd (consFail "Data.Function.Inversion._case_3" (showCons x8))

d_C__case_2 :: forall t3 t0 t1 t2 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry t2) => t3 -> t0 -> t1 -> t2
  -> (t2 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> t3) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 t2 t1 t0
d_C__case_2 x6 x9 x8 x7 x5 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple3 x7 x8 x9
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x6 x9 x8 x7 x5
    l cd cs) (d_C__case_2 x6 x9 x8 x7 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x6 x9
    x8 x7 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x6 x9 x8
    x7 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Function.Inversion._case_2" [show x6, show x9, show x8, show x7, show
    x5, show x10] info)
  _ -> failCons cd (consFail "Data.Function.Inversion._case_2" (showCons x10))

nd_C__case_2 :: forall t3 t0 t1 t2 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2) => t3 -> t0 -> t1 -> t2 -> Func t2 (Func t1 (Func t0 t3))
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 t2 t1 t0
nd_C__case_2 x6 x9 x8 x7 x5 x10 s cd cs = case x10 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple3 x7 x8 x9
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_2 x6 x9 x8 x7 x5
    l s cd cs) (nd_C__case_2 x6 x9 x8 x7 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_2 x6
    x9 x8 x7 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_2 x6 x9
    x8 x7 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Function.Inversion._case_2" [show x6, show x9, show x8, show x7, show
    x5, show x10] info)
  _ -> failCons cd (consFail "Data.Function.Inversion._case_2" (showCons x10))

d_C__case_1 :: forall t4 t0 t1 t2 t3 . (Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3) => t4 -> t0 -> t1 -> t2 -> t3 -> (t3 -> Cover
  -> ConstStore -> t2 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0
  -> Cover -> ConstStore -> t4) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 t3 t2 t1 t0
d_C__case_1 x7 x11 x10 x9 x8 x6 x12 cd cs = case x12 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple4 x8 x9 x10 x11
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x7 x11 x10 x9
    x8 x6 l cd cs) (d_C__case_1 x7 x11 x10 x9 x8 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x7
    x11 x10 x9 x8 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x7 x11
    x10 x9 x8 x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Function.Inversion._case_1" [show x7, show x11, show x10, show x9
    , show x8, show x6, show x12] info)
  _ -> failCons cd (consFail "Data.Function.Inversion._case_1" (showCons x12))

nd_C__case_1 :: forall t4 t0 t1 t2 t3 . (Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3) => t4 -> t0 -> t1 -> t2 -> t3 -> Func t3 (Func t2
  (Func t1 (Func t0 t4))) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 t3 t2 t1 t0
nd_C__case_1 x7 x11 x10 x9 x8 x6 x12 s cd cs = case x12 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple4 x8 x9 x10 x11
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_1 x7 x11 x10 x9
    x8 x6 l s cd cs) (nd_C__case_1 x7 x11 x10 x9 x8 x6 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_1 x7
    x11 x10 x9 x8 x6 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_1 x7 x11
    x10 x9 x8 x6 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Function.Inversion._case_1" [show x7, show x11, show x10, show x9
    , show x8, show x6, show x12] info)
  _ -> failCons cd (consFail "Data.Function.Inversion._case_1" (showCons x12))

d_C__case_0 :: forall t5 t0 t1 t2 t3 t4 . (Curry_Prelude.Curry t5
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t4) => t5 -> t0 -> t1 -> t2
  -> t3 -> t4 -> (t4 -> Cover -> ConstStore -> t3 -> Cover -> ConstStore -> t2
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> t5) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple5 t4 t3 t2 t1 t0
d_C__case_0 x8 x13 x12 x11 x10 x9 x7 x14 cd cs = case x14 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple5 x9 x10 x11 x12 x13
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x8 x13 x12 x11
    x10 x9 x7 l cd cs) (d_C__case_0 x8 x13 x12 x11 x10 x9 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x8
    x13 x12 x11 x10 x9 x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x8 x13
    x12 x11 x10 x9 x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Function.Inversion._case_0" [show x8, show x13, show x12, show x11
    , show x10, show x9, show x7, show x14] info)
  _ -> failCons cd (consFail "Data.Function.Inversion._case_0" (showCons x14))

nd_C__case_0 :: forall t5 t0 t1 t2 t3 t4 . (Curry_Prelude.Curry t5
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t4) => t5 -> t0 -> t1 -> t2
  -> t3 -> t4 -> Func t4 (Func t3 (Func t2 (Func t1 (Func t0 t5))))
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple5 t4 t3 t2 t1 t0
nd_C__case_0 x8 x13 x12 x11 x10 x9 x7 x14 s cd cs = case x14 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple5 x9 x10 x11 x12 x13
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_0 x8 x13 x12 x11
    x10 x9 x7 l s cd cs) (nd_C__case_0 x8 x13 x12 x11 x10 x9 x7 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_0 x8
    x13 x12 x11 x10 x9 x7 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_0 x8 x13
    x12 x11 x10 x9 x7 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Function.Inversion._case_0" [show x8, show x13, show x12, show x11
    , show x10, show x9, show x7, show x14] info)
  _ -> failCons cd (consFail "Data.Function.Inversion._case_0" (showCons x14))

