{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module System.Curry_Random
  ( d_C_nextInt
  , d_C_nextIntRange
  , d_C_nextBoolean
  , d_C_getRandomSeed
  , d_C_shuffle )
  where

import Basics
import qualified Data.Curry_Time
import qualified Curry_Prelude
import qualified System.Curry_CPUTime


d_C_zfact :: Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_zfact cd cs = Curry_Prelude.C_Int (36969)

d_C_wfact :: Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_wfact cd cs = Curry_Prelude.C_Int (18000)

d_C_two16 :: Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_two16 cd cs = Curry_Prelude.C_Int (65536)

d_C_large :: Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_large cd cs = Curry_Prelude.C_Int (536870911)

d_C_nextInt :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int
d_C_nextInt x1 cd cs = let x2 = d_C__case_7 x1
                             (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
                             x1 (Curry_Prelude.C_Int (0)) cd cs) cd cs
  in d_OP_nextInt_dot_next2_dot_11 x2 x2 cd cs

d_OP_nextInt_dot_next2_dot_11 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Int
d_OP_nextInt_dot_next2_dot_11 x1 x2 cd cs =
  let x3 = Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
        (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
        (d_C_zfact cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
        (Curry_Prelude.d_OP_uscore_impl_hash_mod_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
        cd cs) x2 cd cs) (d_C_two16 cd cs) cd cs) cd cs)
        (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
        x2 (d_C_two16 cd cs) cd cs) cd cs
      x4 = Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
        (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
        (d_C_wfact cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
        (Curry_Prelude.d_OP_uscore_impl_hash_mod_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
        cd cs) x1 cd cs) (d_C_two16 cd cs) cd cs) cd cs)
        (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
        x1 (d_C_two16 cd cs) cd cs) cd cs
      x5 = Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
        (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
        (Curry_Prelude.d_OP_uscore_impl_hash_div_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
        cd cs) x3 cd cs) (d_C_two16 cd cs) cd cs) x4 cd cs
      x6 = d_C__case_6 x5 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
        (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
        cd cs) x5 cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs
  in Curry_Prelude.OP_Cons x6 (d_OP_nextInt_dot_next2_dot_11 x4 x3 cd cs)

d_C_nextIntRange :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Int
d_C_nextIntRange x1 x2 cd cs = d_C__case_5 x2 x1 (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) x2 cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs

d_OP_nextIntRange_dot_uscore_hash_lambda1 :: Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_OP_nextIntRange_dot_uscore_hash_lambda1 x1 x2 cd cs =
  Curry_Prelude.d_OP_uscore_impl_hash_abs_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_mod_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
  cd cs) x2 cd cs) x1 cd cs) cd cs

d_C_nextBoolean :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Bool
d_C_nextBoolean x1 cd cs = Curry_Prelude.d_C_map (Curry_Prelude.d_C_flip
  (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  cd cs) (Curry_Prelude.C_Int (0))) (d_C_nextInt x1 cd cs) cd cs

d_C_getRandomSeed :: Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.C_Int
d_C_getRandomSeed cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Data.Curry_Time.d_C_getClockTime cd cs) cd cs)
  d_OP_getRandomSeed_dot_uscore_hash_lambda2 cd cs

d_OP_getRandomSeed_dot_uscore_hash_lambda2 :: Data.Curry_Time.C_ClockTime
  -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Int
d_OP_getRandomSeed_dot_uscore_hash_lambda2 x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_CPUTime.d_C_getCPUTime cd cs) cd cs)
  (d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3 x1) cd cs

d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3 :: Data.Curry_Time.C_ClockTime
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.C_Int
d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3 x1 x2 cd cs =
  let x3 = Data.Curry_Time.d_C_toUTCTime x1 cd cs
      x4 = d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP2_hash_y
        x3 cd cs
      x5 = d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP3_hash_mo
        x3 cd cs
      x6 = d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP4_hash_d
        x3 cd cs
      x7 = d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP5_hash_h
        x3 cd cs
      x8 = d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP6_hash_m
        x3 cd cs
      x9 = d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP7_hash_s
        x3 cd cs
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_mod_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
  cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  x4 x5 cd cs) x6 cd cs) x7 cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  x8 (Curry_Prelude.C_Int (1)) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  x9 (Curry_Prelude.C_Int (1)) cd cs) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  x2 (Curry_Prelude.C_Int (1)) cd cs) cd cs) cd cs) cd cs) (d_C_two16 cd cs) cd
  cs) cd cs

d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP2_hash_y :: Data.Curry_Time.C_CalendarTime
  -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP2_hash_y x1 cd cs =
  case x1 of
  Data.Curry_Time.C_CalendarTime x2 x3 x4 x5 x6 x7 x8 -> x2
  Data.Curry_Time.Choice_C_CalendarTime d i l r -> narrow d i
    (d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP2_hash_y
    l cd cs)
    (d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP2_hash_y
    r cd cs)
  Data.Curry_Time.Choices_C_CalendarTime d i xs -> narrows cs d i (\z ->
    d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP2_hash_y
    z cd cs) xs
  Data.Curry_Time.Guard_C_CalendarTime d c e -> guardCons d c ((\x ->
    d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP2_hash_y
    e cd x) $! addCs c cs)
  Data.Curry_Time.Fail_C_CalendarTime d info -> failCons d (traceFail
    "System.Random.getRandomSeed._#lambda2._#lambda3._#selFP2#y" [show x1] info)
  _ -> failCons cd (consFail
    "System.Random.getRandomSeed._#lambda2._#lambda3._#selFP2#y" (showCons x1))

d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP3_hash_mo :: Data.Curry_Time.C_CalendarTime
  -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP3_hash_mo x1 cd cs =
  case x1 of
  Data.Curry_Time.C_CalendarTime x2 x3 x4 x5 x6 x7 x8 -> x3
  Data.Curry_Time.Choice_C_CalendarTime d i l r -> narrow d i
    (d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP3_hash_mo
    l cd cs)
    (d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP3_hash_mo
    r cd cs)
  Data.Curry_Time.Choices_C_CalendarTime d i xs -> narrows cs d i (\z ->
    d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP3_hash_mo
    z cd cs) xs
  Data.Curry_Time.Guard_C_CalendarTime d c e -> guardCons d c ((\x ->
    d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP3_hash_mo
    e cd x) $! addCs c cs)
  Data.Curry_Time.Fail_C_CalendarTime d info -> failCons d (traceFail
    "System.Random.getRandomSeed._#lambda2._#lambda3._#selFP3#mo" [show x1]
    info)
  _ -> failCons cd (consFail
    "System.Random.getRandomSeed._#lambda2._#lambda3._#selFP3#mo" (showCons x1))

d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP4_hash_d :: Data.Curry_Time.C_CalendarTime
  -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP4_hash_d x1 cd cs =
  case x1 of
  Data.Curry_Time.C_CalendarTime x2 x3 x4 x5 x6 x7 x8 -> x4
  Data.Curry_Time.Choice_C_CalendarTime d i l r -> narrow d i
    (d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP4_hash_d
    l cd cs)
    (d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP4_hash_d
    r cd cs)
  Data.Curry_Time.Choices_C_CalendarTime d i xs -> narrows cs d i (\z ->
    d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP4_hash_d
    z cd cs) xs
  Data.Curry_Time.Guard_C_CalendarTime d c e -> guardCons d c ((\x ->
    d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP4_hash_d
    e cd x) $! addCs c cs)
  Data.Curry_Time.Fail_C_CalendarTime d info -> failCons d (traceFail
    "System.Random.getRandomSeed._#lambda2._#lambda3._#selFP4#d" [show x1] info)
  _ -> failCons cd (consFail
    "System.Random.getRandomSeed._#lambda2._#lambda3._#selFP4#d" (showCons x1))

d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP5_hash_h :: Data.Curry_Time.C_CalendarTime
  -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP5_hash_h x1 cd cs =
  case x1 of
  Data.Curry_Time.C_CalendarTime x2 x3 x4 x5 x6 x7 x8 -> x5
  Data.Curry_Time.Choice_C_CalendarTime d i l r -> narrow d i
    (d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP5_hash_h
    l cd cs)
    (d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP5_hash_h
    r cd cs)
  Data.Curry_Time.Choices_C_CalendarTime d i xs -> narrows cs d i (\z ->
    d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP5_hash_h
    z cd cs) xs
  Data.Curry_Time.Guard_C_CalendarTime d c e -> guardCons d c ((\x ->
    d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP5_hash_h
    e cd x) $! addCs c cs)
  Data.Curry_Time.Fail_C_CalendarTime d info -> failCons d (traceFail
    "System.Random.getRandomSeed._#lambda2._#lambda3._#selFP5#h" [show x1] info)
  _ -> failCons cd (consFail
    "System.Random.getRandomSeed._#lambda2._#lambda3._#selFP5#h" (showCons x1))

d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP6_hash_m :: Data.Curry_Time.C_CalendarTime
  -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP6_hash_m x1 cd cs =
  case x1 of
  Data.Curry_Time.C_CalendarTime x2 x3 x4 x5 x6 x7 x8 -> x6
  Data.Curry_Time.Choice_C_CalendarTime d i l r -> narrow d i
    (d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP6_hash_m
    l cd cs)
    (d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP6_hash_m
    r cd cs)
  Data.Curry_Time.Choices_C_CalendarTime d i xs -> narrows cs d i (\z ->
    d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP6_hash_m
    z cd cs) xs
  Data.Curry_Time.Guard_C_CalendarTime d c e -> guardCons d c ((\x ->
    d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP6_hash_m
    e cd x) $! addCs c cs)
  Data.Curry_Time.Fail_C_CalendarTime d info -> failCons d (traceFail
    "System.Random.getRandomSeed._#lambda2._#lambda3._#selFP6#m" [show x1] info)
  _ -> failCons cd (consFail
    "System.Random.getRandomSeed._#lambda2._#lambda3._#selFP6#m" (showCons x1))

d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP7_hash_s :: Data.Curry_Time.C_CalendarTime
  -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP7_hash_s x1 cd cs =
  case x1 of
  Data.Curry_Time.C_CalendarTime x2 x3 x4 x5 x6 x7 x8 -> x7
  Data.Curry_Time.Choice_C_CalendarTime d i l r -> narrow d i
    (d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP7_hash_s
    l cd cs)
    (d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP7_hash_s
    r cd cs)
  Data.Curry_Time.Choices_C_CalendarTime d i xs -> narrows cs d i (\z ->
    d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP7_hash_s
    z cd cs) xs
  Data.Curry_Time.Guard_C_CalendarTime d c e -> guardCons d c ((\x ->
    d_OP_getRandomSeed_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3_dot_uscore_hash_selFP7_hash_s
    e cd x) $! addCs c cs)
  Data.Curry_Time.Fail_C_CalendarTime d info -> failCons d (traceFail
    "System.Random.getRandomSeed._#lambda2._#lambda3._#selFP7#s" [show x1] info)
  _ -> failCons cd (consFail
    "System.Random.getRandomSeed._#lambda2._#lambda3._#selFP7#s" (showCons x1))

d_C_shuffle :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_shuffle x1 x2 cd cs = d_C_shuffleWithLen (d_C_nextInt x1 cd cs)
  (Curry_Prelude.d_C_length x2 cd cs) x2 cd cs

d_C_shuffleWithLen :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_shuffleWithLen x1 x2 x3 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Internal error in Random.shuffleWithLen") cd cs
  Curry_Prelude.OP_Cons x4 x5 -> let x6 = Curry_Prelude.d_C_splitAt
                                       (Curry_Prelude.d_C_apply
                                       (Curry_Prelude.d_C_apply
                                       (Curry_Prelude.d_OP_uscore_impl_hash_mod_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
                                       cd cs)
                                       (Curry_Prelude.d_OP_uscore_impl_hash_abs_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
                                       x4 cd cs) cd cs) x2 cd cs) x3 cd cs
                                     x7 = d_OP_shuffleWithLen_dot_uscore_hash_selFP9_hash_ys
                                       x6 cd cs
                                     x8 = d_OP_shuffleWithLen_dot_uscore_hash_selFP10_hash_z
                                       x6 cd cs
                                     x9 = d_OP_shuffleWithLen_dot_uscore_hash_selFP11_hash_zs
                                       x6 cd cs
    in d_C__case_4 x2 x9 x7 x5 x8
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x2 (Curry_Prelude.C_Int (0)) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_shuffleWithLen l x2 x3
    cd cs) (d_C_shuffleWithLen r x2 x3 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_shuffleWithLen z x2 x3 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_shuffleWithLen
    e x2 x3 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "System.Random.shuffleWithLen" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "System.Random.shuffleWithLen" (showCons x1))

d_OP_shuffleWithLen_dot_uscore_hash_selFP9_hash_ys :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_shuffleWithLen_dot_uscore_hash_selFP9_hash_ys x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_2 x2 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_shuffleWithLen_dot_uscore_hash_selFP9_hash_ys l cd cs)
    (d_OP_shuffleWithLen_dot_uscore_hash_selFP9_hash_ys r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_shuffleWithLen_dot_uscore_hash_selFP9_hash_ys z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_shuffleWithLen_dot_uscore_hash_selFP9_hash_ys e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "System.Random.shuffleWithLen._#selFP9#ys" [show x1] info)
  _ -> failCons cd (consFail "System.Random.shuffleWithLen._#selFP9#ys"
    (showCons x1))

d_OP_shuffleWithLen_dot_uscore_hash_selFP10_hash_z :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> t0
d_OP_shuffleWithLen_dot_uscore_hash_selFP10_hash_z x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_1 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_shuffleWithLen_dot_uscore_hash_selFP10_hash_z l cd cs)
    (d_OP_shuffleWithLen_dot_uscore_hash_selFP10_hash_z r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_shuffleWithLen_dot_uscore_hash_selFP10_hash_z z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_shuffleWithLen_dot_uscore_hash_selFP10_hash_z e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "System.Random.shuffleWithLen._#selFP10#z" [show x1] info)
  _ -> failCons cd (consFail "System.Random.shuffleWithLen._#selFP10#z"
    (showCons x1))

d_OP_shuffleWithLen_dot_uscore_hash_selFP11_hash_zs :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_shuffleWithLen_dot_uscore_hash_selFP11_hash_zs x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_0 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_shuffleWithLen_dot_uscore_hash_selFP11_hash_zs l cd cs)
    (d_OP_shuffleWithLen_dot_uscore_hash_selFP11_hash_zs r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_shuffleWithLen_dot_uscore_hash_selFP11_hash_zs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_shuffleWithLen_dot_uscore_hash_selFP11_hash_zs e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "System.Random.shuffleWithLen._#selFP11#zs" [show x1] info)
  _ -> failCons cd (consFail "System.Random.shuffleWithLen._#selFP11#zs"
    (showCons x1))

d_C__case_7 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_Int
d_C__case_7 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.C_Int (1)
  Curry_Prelude.C_False -> x1
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x1 l cd cs)
    (d_C__case_7 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_7 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "System.Random._case_7" [show x1, show x2] info)
  _ -> failCons cd (consFail "System.Random._case_7" (showCons x2))

d_C__case_6 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_Int
d_C__case_6 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x5 (d_C_large cd cs) cd cs
  Curry_Prelude.C_False -> x5
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x5 l cd cs)
    (d_C__case_6 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x5 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x5 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "System.Random._case_6" [show x5, show x6] info)
  _ -> failCons cd (consFail "System.Random._case_6" (showCons x6))

d_C__case_5 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int
d_C__case_5 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_map
    (d_OP_nextIntRange_dot_uscore_hash_lambda1 x2) (d_C_nextInt x1 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x2 x1 l cd cs)
    (d_C__case_5 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x2 x1
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "System.Random._case_5" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "System.Random._case_5" (showCons x3))

d_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> t0 -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_4 x2 x9 x7 x5 x8 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> d_C__case_3 x9 x7 x2 x5 x8
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x2 x9 x7 x5 x8
    l cd cs) (d_C__case_4 x2 x9 x7 x5 x8 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x2 x9
    x7 x5 x8 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x2 x9 x7
    x5 x8 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "System.Random._case_4" [show x2, show x9, show x7, show x5, show x8, show
    x10] info)
  _ -> failCons cd (consFail "System.Random._case_4" (showCons x10))

d_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C__case_3 x9 x7 x2 x5 x8 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x8 (d_C_shuffleWithLen x5
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x2 (Curry_Prelude.C_Int (1)) cd cs) (Curry_Prelude.d_OP_plus_plus x7 x9 cd
    cs) cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x9 x7 x2 x5 x8
    l cd cs) (d_C__case_3 x9 x7 x2 x5 x8 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x9 x7
    x2 x5 x8 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x9 x7 x2
    x5 x8 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "System.Random._case_3" [show x9, show x7, show x2, show x5, show x8, show
    x10] info)
  _ -> failCons cd (consFail "System.Random._case_3" (showCons x10))

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_2 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x4 x5 -> x2
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_2 x2 l cd cs)
    (d_C__case_2 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_2 x2 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_2 x2 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "System.Random._case_2" [show x2, show x3] info)
  _ -> failCons cd (consFail "System.Random._case_2" (showCons x3))

d_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> t0
d_C__case_1 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x4 x5 -> x4
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_1 l cd cs)
    (d_C__case_1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_1 z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "System.Random._case_1" [show x3] info)
  _ -> failCons cd (consFail "System.Random._case_1" (showCons x3))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_0 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x4 x5 -> x5
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_0 l cd cs)
    (d_C__case_0 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_0 z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_0 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "System.Random._case_0" [show x3] info)
  _ -> failCons cd (consFail "System.Random._case_0" (showCons x3))

