{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_XCuery
  ( nd_C_with
  , nd_C_xml'
  , nd_C_anyorder
  , nd_C_deepXml
  , nd_C_deepXml'
  , nd_C_deepXElem
  , d_C_noTagOf
  , nd_C_withOthers
  , d_C_optXml )
  where

import Basics
import qualified Curry_Prelude
import qualified Curry_XML


nd_C_with :: forall t0 . (Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_with x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_unknown (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    x1)) s0 cd cs
  Curry_Prelude.OP_Cons x3 x4 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.nd_C_unknown (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    x1)) s0 cd cs) (Curry_Prelude.OP_Cons x3 (nd_C_with x1 x4 s1 cd cs)) cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_with x1 l s cd cs)
    (nd_C_with x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_with x1 z s
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_with x1 e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XCuery.with" [show
    x1, show x2] info)
  _ -> failCons cd (consFail "XCuery.with" (showCons x2))

nd_C_xml' :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_XML.C_XmlExp -> IDSupply -> Cover -> ConstStore -> Curry_XML.C_XmlExp
nd_C_xml' x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_XML.C_XElem x1 (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))))))
  s0 cd cs) x2

nd_C_anyorder :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_anyorder x1 s cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_OP_anyorder_dot_insert_dot_10 x2 (nd_C_anyorder x3
    s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_anyorder l s cd cs)
    (nd_C_anyorder r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_anyorder z
    s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_anyorder e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XCuery.anyorder"
    [show x1] info)
  _ -> failCons cd (consFail "XCuery.anyorder" (showCons x1))

nd_OP_anyorder_dot_insert_dot_10 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_OP_anyorder_dot_insert_dot_10 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_qmark (Curry_Prelude.OP_Cons x1
    (Curry_Prelude.OP_Cons x3 x4)) (Curry_Prelude.OP_Cons x3
    (nd_OP_anyorder_dot_insert_dot_10 x1 x4 s0 cd cs)) s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (nd_OP_anyorder_dot_insert_dot_10 x1 l s cd cs)
    (nd_OP_anyorder_dot_insert_dot_10 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_OP_anyorder_dot_insert_dot_10 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    nd_OP_anyorder_dot_insert_dot_10 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "XCuery.anyorder.insert.10" [show x1, show x2] info)
  _ -> failCons cd (consFail "XCuery.anyorder.insert.10" (showCons x2))

nd_C_deepXml :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_XML.C_XmlExp -> IDSupply -> Cover -> ConstStore
  -> Curry_XML.C_XmlExp
nd_C_deepXml x1 x2 s cd cs = let s10 = s
  in s10 `seq` (let s9 = leftSupply s10
                    s7 = rightSupply s10
  in s9 `seq` (s7 `seq` choice (Curry_XML.d_C_xml x1 x2 cd cs)
  (let s6 = leftSupply s7
       s8 = rightSupply s7
       s0 = leftSupply s8
       s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s0 `seq` (s5 `seq` nd_C_xml'
  (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s0 cd cs) (let s1 = leftSupply s5
                 s4 = rightSupply s5
  in s1 `seq` (s4 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_unknown
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_XML.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XML_dot_XmlExp_hash)))
  s1 cd cs) (let s2 = leftSupply s4
                 s3 = rightSupply s4
  in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
  (nd_C_deepXml x1 x2 s2 cd cs) Curry_Prelude.OP_List)
  (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_XML.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XML_dot_XmlExp_hash)))
  s3 cd cs) cd cs)) cd cs)) s6 cd cs)))) s9 cd cs))

nd_C_deepXml' :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_XML.C_XmlExp -> IDSupply -> Cover -> ConstStore
  -> Curry_XML.C_XmlExp
nd_C_deepXml' x1 x2 s cd cs = let s11 = s
  in s11 `seq` (let s10 = leftSupply s11
                    s12 = rightSupply s11
                    s0 = leftSupply s12
                    s8 = rightSupply s12
  in s10 `seq` (s12 `seq` (s0 `seq` (s8 `seq` choice (nd_C_xml' x1 x2 s0 cd cs)
  (let s7 = leftSupply s8
       s9 = rightSupply s8
       s1 = leftSupply s9
       s6 = rightSupply s9
  in s7 `seq` (s9 `seq` (s1 `seq` (s6 `seq` nd_C_xml'
  (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s1 cd cs) (let s2 = leftSupply s6
                 s5 = rightSupply s6
  in s2 `seq` (s5 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_unknown
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_XML.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XML_dot_XmlExp_hash)))
  s2 cd cs) (let s3 = leftSupply s5
                 s4 = rightSupply s5
  in s3 `seq` (s4 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
  (nd_C_deepXml' x1 x2 s3 cd cs) Curry_Prelude.OP_List)
  (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_XML.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XML_dot_XmlExp_hash)))
  s4 cd cs) cd cs)) cd cs)) s7 cd cs)))) s10 cd cs))))

nd_C_deepXElem :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List Curry_XML.C_XmlExp -> IDSupply -> Cover -> ConstStore
  -> Curry_XML.C_XmlExp
nd_C_deepXElem x1 x2 x3 s cd cs = let s10 = s
  in s10 `seq` (let s9 = leftSupply s10
                    s7 = rightSupply s10
  in s9 `seq` (s7 `seq` choice (Curry_XML.C_XElem x1 x2 x3) (let s6 = leftSupply
                                                                   s7
                                                                 s8 = rightSupply
                                                                   s7
                                                                 s0 = leftSupply
                                                                   s8
                                                                 s5 = rightSupply
                                                                   s8
  in s6 `seq` (s8 `seq` (s0 `seq` (s5 `seq` nd_C_xml'
  (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s0 cd cs) (let s1 = leftSupply s5
                 s4 = rightSupply s5
  in s1 `seq` (s4 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_unknown
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_XML.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XML_dot_XmlExp_hash)))
  s1 cd cs) (let s2 = leftSupply s4
                 s3 = rightSupply s4
  in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
  (nd_C_deepXElem x1 x2 x3 s2 cd cs) Curry_Prelude.OP_List)
  (Curry_Prelude.nd_C_unknown (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_XML.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XML_dot_XmlExp_hash)))
  s3 cd cs) cd cs)) cd cs)) s6 cd cs)))) s9 cd cs))

d_C_noTagOf :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_noTagOf x1 cd cs = Curry_Prelude.d_C_all (Curry_Prelude.d_OP_dot
  (Curry_Prelude.d_C_flip
  (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  cd cs) x1) Curry_XML.d_C_tagOf cd cs) cd cs

nd_C_withOthers :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
nd_C_withOthers x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` nd_OP_withOthers_dot_withAcc_dot_30 x1 Curry_Prelude.OP_List x2 x3
  s0 cd cs

nd_OP_withOthers_dot_withAcc_dot_30 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_OP_withOthers_dot_withAcc_dot_30 x1 x2 x3 x4 s cd cs = case x3 of
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` (let x5 = generate s0 cd
    in d_C__case_1 x5 x2 x4 (Curry_Prelude.d_OP_eq_colon_eq x4
    (Curry_Prelude.d_OP_plus_plus x2 x5 cd cs) cd cs) cd cs)
  Curry_Prelude.OP_Cons x6 x7 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` (let x8 = generate s0 cd
    in Curry_Prelude.d_OP_plus_plus x8 (Curry_Prelude.OP_Cons x6
    (nd_OP_withOthers_dot_withAcc_dot_30 x1 (Curry_Prelude.d_OP_plus_plus x2 x8
    cd cs) x7 x4 s1 cd cs)) cd cs)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (nd_OP_withOthers_dot_withAcc_dot_30 x1 x2 l x4 s cd cs)
    (nd_OP_withOthers_dot_withAcc_dot_30 x1 x2 r x4 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_OP_withOthers_dot_withAcc_dot_30 x1 x2 z x4 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    nd_OP_withOthers_dot_withAcc_dot_30 x1 x2 e x4 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "XCuery.withOthers.withAcc.30" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "XCuery.withOthers.withAcc.30" (showCons x3))

d_C_optXml :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Curry_Prelude.OP_List
  Curry_XML.C_XmlExp -> Cover -> ConstStore -> Curry_XML.C_XmlExp
d_C_optXml x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_XML.d_C_xml x1 x2 cd cs
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_0 x4 x1 x5 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_XML.d_C_tagOf x4 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_optXml x1 x2 l cd cs)
    (d_C_optXml x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_optXml x1 x2
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_optXml x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XCuery.optXml"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "XCuery.optXml" (showCons x3))

d_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_1 x5 x2 x4 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> x5
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x5 x2 x4 l cd
    cs) (d_C__case_1 x5 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x5 x2
    x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x5 x2 x4
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "XCuery._case_1"
    [show x5, show x2, show x4, show x6] info)
  _ -> failCons cd (consFail "XCuery._case_1" (showCons x6))

d_C__case_0 :: Curry_XML.C_XmlExp -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Curry_Prelude.OP_List
  Curry_XML.C_XmlExp -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_XML.C_XmlExp
d_C__case_0 x4 x1 x5 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> x4
  Curry_Prelude.C_False -> d_C_optXml x1 x2 x5 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x4 x1 x5 x2 l
    cd cs) (d_C__case_0 x4 x1 x5 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x4 x1
    x5 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x4 x1 x5
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "XCuery._case_0"
    [show x4, show x1, show x5, show x2, show x6] info)
  _ -> failCons cd (consFail "XCuery._case_0" (showCons x6))

