{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module AbstractCurry.Curry_Transform
  ( d_C_trCProg
  , nd_C_trCProg
  , d_C_updCProg
  , nd_C_updCProg
  , d_C_updCProgName
  , nd_C_updCProgName
  , d_C_trCDefaultDecl
  , nd_C_trCDefaultDecl
  , d_C_updCDefaultDecl
  , nd_C_updCDefaultDecl
  , d_C_trCContext
  , nd_C_trCContext
  , d_C_updCContext
  , nd_C_updCContext
  , d_C_trCClassDecl
  , nd_C_trCClassDecl
  , d_C_updCClassDecl
  , nd_C_updCClassDecl
  , d_C_trCInstanceDecl
  , nd_C_trCInstanceDecl
  , d_C_updCInstanceDecl
  , nd_C_updCInstanceDecl
  , d_C_trCTypeDecl
  , nd_C_trCTypeDecl
  , d_C_updCTypeDecl
  , nd_C_updCTypeDecl
  , d_C_updCTypeDeclName
  , nd_C_updCTypeDeclName
  , d_C_trCConsDecl
  , nd_C_trCConsDecl
  , d_C_updCConsDecl
  , nd_C_updCConsDecl
  , d_C_updCConsDeclName
  , nd_C_updCConsDeclName
  , d_C_trCFieldDecl
  , nd_C_trCFieldDecl
  , d_C_updCFieldDecl
  , nd_C_updCFieldDecl
  , d_C_updCFieldDeclName
  , nd_C_updCFieldDeclName
  , d_C_trCQualTypeExpr
  , nd_C_trCQualTypeExpr
  , d_C_updCQualTypeExpr
  , nd_C_updCQualTypeExpr
  , d_C_trCTypeExpr
  , nd_C_trCTypeExpr
  , d_C_updTConsApp
  , nd_C_updTConsApp
  , d_C_trCOpDecl
  , nd_C_trCOpDecl
  , d_C_updCOpDecl
  , nd_C_updCOpDecl
  , d_C_updCOpName
  , nd_C_updCOpName
  , d_C_trCFuncDecl
  , nd_C_trCFuncDecl
  , d_C_updCFuncDecl
  , nd_C_updCFuncDecl
  , d_C_trCRule
  , nd_C_trCRule
  , d_C_updCRule
  , nd_C_updCRule
  , d_C_trCRhs
  , nd_C_trCRhs
  , d_C_updCRhs
  , nd_C_updCRhs
  , d_C_trCLocalDecl
  , nd_C_trCLocalDecl
  , d_C_updCLocalDecl
  , nd_C_updCLocalDecl
  , d_C_trCPattern
  , nd_C_trCPattern
  , d_C_updCPattern
  , nd_C_updCPattern
  , d_C_trExpr
  , nd_C_trExpr
  , d_C_trCStatement
  , nd_C_trCStatement
  , d_C_updCStatement
  , nd_C_updCStatement
  , d_C_renameCurryModule
  , d_C_updQNamesInCProg
  , nd_C_updQNamesInCProg
  , d_C_updQNamesInCDefaultDecl
  , nd_C_updQNamesInCDefaultDecl
  , d_C_updQNamesInCClassDecl
  , nd_C_updQNamesInCClassDecl
  , d_C_updQNamesInCInstanceDecl
  , nd_C_updQNamesInCInstanceDecl
  , d_C_updQNamesInCTypeDecl
  , nd_C_updQNamesInCTypeDecl
  , d_C_updQNamesInCConsDecl
  , nd_C_updQNamesInCConsDecl
  , d_C_updQNamesInCContext
  , nd_C_updQNamesInCContext
  , d_C_updQNamesInCFieldDecl
  , nd_C_updQNamesInCFieldDecl
  , d_C_updQNamesInCQualTypeExpr
  , nd_C_updQNamesInCQualTypeExpr
  , d_C_updQNamesInCTypeExpr
  , nd_C_updQNamesInCTypeExpr
  , d_C_updQNamesInCFuncDecl
  , nd_C_updQNamesInCFuncDecl
  , d_C_updQNamesInCRule
  , nd_C_updQNamesInCRule
  , d_C_updQNamesInCRhs
  , nd_C_updQNamesInCRhs
  , d_C_updQNamesInCLocalDecl
  , nd_C_updQNamesInCLocalDecl
  , d_C_updQNamesInCPattern
  , nd_C_updQNamesInCPattern
  , d_C_updQNamesInCStatement
  , nd_C_updQNamesInCStatement
  , d_C_updQNamesInCExpr
  , nd_C_updQNamesInCExpr
  , d_C_typesOfCurryProg
  , d_C_typesOfCClassDecl
  , d_C_typesOfCInstanceDecl
  , d_C_typesOfCTypeDecl
  , d_C_typesOfConsDecl
  , d_C_typesOfFieldDecl
  , d_C_typesOfContext
  , d_C_typesOfTypeExpr
  , d_C_typesOfQualTypeExpr
  , d_C_typesOfCFuncDecl
  , d_C_unionMap
  , nd_C_unionMap
  , d_C_funcsOfCurryProg
  , d_C_funcsOfCClassDecl
  , d_C_funcsOfCInstanceDecl
  , d_C_funcsOfCTypeDecl
  , d_C_funcsOfConsDecl
  , d_C_funcsOfFieldDecl
  , d_C_funcsOfCFuncDecl
  , d_C_funcsOfCRule
  , d_C_funcsOfCRhs
  , d_C_funcsOfLDecl
  , d_C_funcsOfExpr
  , d_C_funcsOfStat )
  where

import Basics
import qualified AbstractCurry.Curry_Select
import qualified AbstractCurry.Curry_Types
import qualified Data.Curry_List
import qualified Curry_Prelude


d_C_trCProg :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CDefaultDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CClassDecl
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CInstanceDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_COpDecl -> Cover -> ConstStore -> t0)
  -> AbstractCurry.Curry_Types.C_CurryProg -> Cover -> ConstStore -> t0
d_C_trCProg x1 x2 cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CurryProg x3 x4 x5 x6 x7 x8 x9 x10 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x1 x3 cd cs) x4 cd cs) x5 cd cs) x6 cd cs) x7 cd
    cs) x8 cd cs) x9 cd cs) x10 cd cs
  AbstractCurry.Curry_Types.Choice_C_CurryProg d i l r -> narrow d i
    (d_C_trCProg x1 l cd cs) (d_C_trCProg x1 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CurryProg d i xs -> narrows cs d i (\z ->
    d_C_trCProg x1 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CurryProg d c e -> guardCons d c ((\x ->
    d_C_trCProg x1 e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CurryProg d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCProg" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCProg" (showCons x2))

nd_C_trCProg :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CDefaultDecl) (Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CClassDecl) (Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CInstanceDecl) (Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeDecl) (Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl) (Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_COpDecl) t0)))))))
  -> AbstractCurry.Curry_Types.C_CurryProg -> IDSupply -> Cover -> ConstStore
  -> t0
nd_C_trCProg x1 x2 s cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CurryProg x3 x4 x5 x6 x7 x8 x9 x10 -> let s14 = s
    in s14 `seq` (let s13 = leftSupply s14
                      s12 = rightSupply s14
    in s13 `seq` (s12 `seq` Curry_Prelude.nd_C_apply (let s11 = leftSupply s12
                                                          s10 = rightSupply s12
    in s11 `seq` (s10 `seq` Curry_Prelude.nd_C_apply (let s9 = leftSupply s10
                                                          s8 = rightSupply s10
    in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (let s7 = leftSupply s8
                                                        s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                        s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x3 s0 cd cs) x4 s1 cd cs)) x5 s3 cd cs)) x6 s5 cd cs)) x7 s7 cd cs)) x8 s9
    cd cs)) x9 s11 cd cs)) x10 s13 cd cs))
  AbstractCurry.Curry_Types.Choice_C_CurryProg d i l r -> narrow d i
    (nd_C_trCProg x1 l s cd cs) (nd_C_trCProg x1 r s cd cs)
  AbstractCurry.Curry_Types.Choices_C_CurryProg d i xs -> narrows cs d i (\z ->
    nd_C_trCProg x1 z s cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CurryProg d c e -> guardCons d c ((\x ->
    nd_C_trCProg x1 e s cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CurryProg d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCProg" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCProg" (showCons x2))

d_C_updCProg :: (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CDefaultDecl -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CDefaultDecl)
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CClassDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CClassDecl)
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CInstanceDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CInstanceDecl) -> (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeDecl)
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl)
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_COpDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_COpDecl)
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CurryProg -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CurryProg
d_C_updCProg x1 x2 x3 x4 x5 x6 x7 x8 cd cs = d_C_trCProg (acceptCs (acceptCs
  (acceptCs (acceptCs (acceptCs (acceptCs (acceptCs id))))))
  (d_OP_updCProg_dot_prog_dot_4 x4 x7 x5 x8 x6 x1 x2 x3))

nd_C_updCProg :: Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Func (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CDefaultDecl) (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CDefaultDecl) -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CClassDecl) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CClassDecl) -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CInstanceDecl) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CInstanceDecl) -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeDecl) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeDecl) -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl) -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_COpDecl) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_COpDecl) -> IDSupply -> Cover -> ConstStore
  -> Func AbstractCurry.Curry_Types.C_CurryProg
  AbstractCurry.Curry_Types.C_CurryProg
nd_C_updCProg x1 x2 x3 x4 x5 x6 x7 x8 s cd cs = wrapNX id (nd_C_trCProg (wrapDX
  (wrapDX (wrapDX (wrapDX (wrapDX (wrapDX (wrapDX (wrapNX id))))))) (acceptCs
  (acceptCs (acceptCs (acceptCs (acceptCs (acceptCs (acceptCs id))))))
  (nd_OP_updCProg_dot_prog_dot_4 x4 x7 x5 x8 x6 x1 x2 x3))))

d_OP_updCProg_dot_prog_dot_4 :: (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CClassDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CClassDecl)
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl)
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CInstanceDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CInstanceDecl) -> (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_COpDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_COpDecl)
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeDecl)
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CDefaultDecl -> Cover
  -> ConstStore -> Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CDefaultDecl) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CDefaultDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CClassDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CInstanceDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_COpDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CurryProg
d_OP_updCProg_dot_prog_dot_4 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 cd cs =
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.d_C_apply x6 x9 cd cs)
  (Curry_Prelude.d_C_apply x7 x10 cd cs) (Curry_Prelude.d_C_apply x8 x11 cd cs)
  (Curry_Prelude.d_C_apply x1 x12 cd cs) (Curry_Prelude.d_C_apply x3 x13 cd cs)
  (Curry_Prelude.d_C_apply x5 x14 cd cs) (Curry_Prelude.d_C_apply x2 x15 cd cs)
  (Curry_Prelude.d_C_apply x4 x16 cd cs)

nd_OP_updCProg_dot_prog_dot_4 :: Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CClassDecl) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CClassDecl) -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl) -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CInstanceDecl) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CInstanceDecl) -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_COpDecl) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_COpDecl) -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeDecl) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeDecl) -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Func
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CDefaultDecl)
  (Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CDefaultDecl)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CDefaultDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CClassDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CInstanceDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_COpDecl -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CurryProg
nd_OP_updCProg_dot_prog_dot_4 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 s cd cs =
  let s8 = s
  in s8 `seq` (let s9 = leftSupply s8
                   s12 = rightSupply s8
                   s10 = leftSupply s9
                   s11 = rightSupply s9
                   s0 = leftSupply s10
                   s1 = rightSupply s10
                   s2 = leftSupply s11
                   s3 = rightSupply s11
                   s13 = leftSupply s12
                   s14 = rightSupply s12
                   s4 = leftSupply s13
                   s5 = rightSupply s13
                   s6 = leftSupply s14
                   s7 = rightSupply s14
  in s9 `seq` (s12 `seq` (s10 `seq` (s11 `seq` (s0 `seq` (s1 `seq` (s2 `seq`
  (s3 `seq` (s13 `seq` (s14 `seq` (s4 `seq` (s5 `seq` (s6 `seq` (s7 `seq`
  AbstractCurry.Curry_Types.C_CurryProg (Curry_Prelude.nd_C_apply x6 x9 s0 cd
  cs) (Curry_Prelude.nd_C_apply x7 x10 s1 cd cs) (Curry_Prelude.nd_C_apply x8
  x11 s2 cd cs) (Curry_Prelude.nd_C_apply x1 x12 s3 cd cs)
  (Curry_Prelude.nd_C_apply x3 x13 s4 cd cs) (Curry_Prelude.nd_C_apply x5 x14 s5
  cd cs) (Curry_Prelude.nd_C_apply x2 x15 s6 cd cs) (Curry_Prelude.nd_C_apply x4
  x16 s7 cd cs)))))))))))))))

d_C_updCProgName :: (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CurryProg -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CurryProg
d_C_updCProgName x1 cd cs = d_C_updCProg x1 Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id Curry_Prelude.d_C_id cd cs

nd_C_updCProgName :: Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover
  -> ConstStore -> Func AbstractCurry.Curry_Types.C_CurryProg
  AbstractCurry.Curry_Types.C_CurryProg
nd_C_updCProgName x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updCProg x1 (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) s0 cd cs

d_C_trCDefaultDecl :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr -> Cover
  -> ConstStore -> t0) -> AbstractCurry.Curry_Types.C_CDefaultDecl -> Cover
  -> ConstStore -> t0
d_C_trCDefaultDecl x1 x2 cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CDefaultDecl x3 -> Curry_Prelude.d_C_apply x1 x3
    cd cs
  AbstractCurry.Curry_Types.Choice_C_CDefaultDecl d i l r -> narrow d i
    (d_C_trCDefaultDecl x1 l cd cs) (d_C_trCDefaultDecl x1 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CDefaultDecl d i xs -> narrows cs d i
    (\z -> d_C_trCDefaultDecl x1 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CDefaultDecl d c e -> guardCons d c ((\x ->
    d_C_trCDefaultDecl x1 e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CDefaultDecl d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCDefaultDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCDefaultDecl" (showCons
    x2))

nd_C_trCDefaultDecl :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr) t0
  -> AbstractCurry.Curry_Types.C_CDefaultDecl -> IDSupply -> Cover -> ConstStore
  -> t0
nd_C_trCDefaultDecl x1 x2 s cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CDefaultDecl x3 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x1 x3 s0 cd cs
  AbstractCurry.Curry_Types.Choice_C_CDefaultDecl d i l r -> narrow d i
    (nd_C_trCDefaultDecl x1 l s cd cs) (nd_C_trCDefaultDecl x1 r s cd cs)
  AbstractCurry.Curry_Types.Choices_C_CDefaultDecl d i xs -> narrows cs d i
    (\z -> nd_C_trCDefaultDecl x1 z s cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CDefaultDecl d c e -> guardCons d c ((\x ->
    nd_C_trCDefaultDecl x1 e s cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CDefaultDecl d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCDefaultDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCDefaultDecl" (showCons
    x2))

d_C_updCDefaultDecl :: (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CDefaultDecl -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CDefaultDecl
d_C_updCDefaultDecl x1 cd cs = d_C_trCDefaultDecl
  (d_OP_updCDefaultDecl_dot_uscore_hash_lambda1 x1)

nd_C_updCDefaultDecl :: Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr) -> IDSupply -> Cover -> ConstStore
  -> Func AbstractCurry.Curry_Types.C_CDefaultDecl
  AbstractCurry.Curry_Types.C_CDefaultDecl
nd_C_updCDefaultDecl x1 s cd cs = wrapNX id (nd_C_trCDefaultDecl (wrapNX id
  (nd_OP_updCDefaultDecl_dot_uscore_hash_lambda1 x1)))

d_OP_updCDefaultDecl_dot_uscore_hash_lambda1 :: (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr)
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CDefaultDecl
d_OP_updCDefaultDecl_dot_uscore_hash_lambda1 x1 x2 cd cs =
  AbstractCurry.Curry_Types.C_CDefaultDecl (Curry_Prelude.d_C_apply x1 x2 cd cs)

nd_OP_updCDefaultDecl_dot_uscore_hash_lambda1 :: Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CDefaultDecl
nd_OP_updCDefaultDecl_dot_uscore_hash_lambda1 x1 x2 s cd cs = let s0 = s
  in s0 `seq` AbstractCurry.Curry_Types.C_CDefaultDecl (Curry_Prelude.nd_C_apply
  x1 x2 s0 cd cs)

d_C_trCContext :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr)) -> Cover
  -> ConstStore -> t0) -> AbstractCurry.Curry_Types.C_CContext -> Cover
  -> ConstStore -> t0
d_C_trCContext x1 x2 cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CContext x3 -> Curry_Prelude.d_C_apply x1 x3 cd cs
  AbstractCurry.Curry_Types.Choice_C_CContext d i l r -> narrow d i
    (d_C_trCContext x1 l cd cs) (d_C_trCContext x1 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CContext d i xs -> narrows cs d i (\z ->
    d_C_trCContext x1 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CContext d c e -> guardCons d c ((\x ->
    d_C_trCContext x1 e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CContext d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCContext" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCContext" (showCons x2))

nd_C_trCContext :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr))) t0
  -> AbstractCurry.Curry_Types.C_CContext -> IDSupply -> Cover -> ConstStore
  -> t0
nd_C_trCContext x1 x2 s cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CContext x3 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x1 x3 s0 cd cs
  AbstractCurry.Curry_Types.Choice_C_CContext d i l r -> narrow d i
    (nd_C_trCContext x1 l s cd cs) (nd_C_trCContext x1 r s cd cs)
  AbstractCurry.Curry_Types.Choices_C_CContext d i xs -> narrows cs d i (\z ->
    nd_C_trCContext x1 z s cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CContext d c e -> guardCons d c ((\x ->
    nd_C_trCContext x1 e s cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CContext d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCContext" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCContext" (showCons x2))

d_C_updCContext :: (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr))) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CContext -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CContext
d_C_updCContext x1 cd cs = d_C_trCContext
  (d_OP_updCContext_dot_uscore_hash_lambda2 x1)

nd_C_updCContext :: Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr))) -> IDSupply
  -> Cover -> ConstStore -> Func AbstractCurry.Curry_Types.C_CContext
  AbstractCurry.Curry_Types.C_CContext
nd_C_updCContext x1 s cd cs = wrapNX id (nd_C_trCContext (wrapNX id
  (nd_OP_updCContext_dot_uscore_hash_lambda2 x1)))

d_OP_updCContext_dot_uscore_hash_lambda2 :: (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr))) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CContext
d_OP_updCContext_dot_uscore_hash_lambda2 x1 x2 cd cs =
  AbstractCurry.Curry_Types.C_CContext (Curry_Prelude.d_C_apply x1 x2 cd cs)

nd_OP_updCContext_dot_uscore_hash_lambda2 :: Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr)))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr))) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr)) -> IDSupply
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CContext
nd_OP_updCContext_dot_uscore_hash_lambda2 x1 x2 s cd cs = let s0 = s
  in s0 `seq` AbstractCurry.Curry_Types.C_CContext (Curry_Prelude.nd_C_apply x1
  x2 s0 cd cs)

d_C_trCClassDecl :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CVisibility -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CContext -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)))) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl
  -> Cover -> ConstStore -> t0) -> AbstractCurry.Curry_Types.C_CClassDecl
  -> Cover -> ConstStore -> t0
d_C_trCClassDecl x1 x2 cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CClass x3 x4 x5 x6 x7 x8 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x1 x3 cd cs) x4 cd cs) x5
    cd cs) x6 cd cs) x7 cd cs) x8 cd cs
  AbstractCurry.Curry_Types.Choice_C_CClassDecl d i l r -> narrow d i
    (d_C_trCClassDecl x1 l cd cs) (d_C_trCClassDecl x1 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CClassDecl d i xs -> narrows cs d i (\z ->
    d_C_trCClassDecl x1 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CClassDecl d c e -> guardCons d c ((\x ->
    d_C_trCClassDecl x1 e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CClassDecl d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCClassDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCClassDecl" (showCons
    x2))

nd_C_trCClassDecl :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func
  AbstractCurry.Curry_Types.C_CVisibility (Func
  AbstractCurry.Curry_Types.C_CContext (Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))))) (Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl) t0)))))
  -> AbstractCurry.Curry_Types.C_CClassDecl -> IDSupply -> Cover -> ConstStore
  -> t0
nd_C_trCClassDecl x1 x2 s cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CClass x3 x4 x5 x6 x7 x8 -> let s10 = s
    in s10 `seq` (let s9 = leftSupply s10
                      s8 = rightSupply s10
    in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (let s7 = leftSupply s8
                                                        s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                        s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x3 s0 cd cs) x4 s1 cd cs)) x5 s3 cd cs)) x6 s5 cd cs)) x7 s7 cd cs)) x8 s9
    cd cs))
  AbstractCurry.Curry_Types.Choice_C_CClassDecl d i l r -> narrow d i
    (nd_C_trCClassDecl x1 l s cd cs) (nd_C_trCClassDecl x1 r s cd cs)
  AbstractCurry.Curry_Types.Choices_C_CClassDecl d i xs -> narrows cs d i (\z ->
    nd_C_trCClassDecl x1 z s cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CClassDecl d c e -> guardCons d c ((\x ->
    nd_C_trCClassDecl x1 e s cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CClassDecl d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCClassDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCClassDecl" (showCons
    x2))

d_C_updCClassDecl :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> (AbstractCurry.Curry_Types.C_CVisibility -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CVisibility)
  -> (AbstractCurry.Curry_Types.C_CContext -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CContext) -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))))) -> (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CClassDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CClassDecl
d_C_updCClassDecl x1 x2 x3 x4 x5 x6 cd cs = d_C_trCClassDecl (acceptCs (acceptCs
  (acceptCs (acceptCs (acceptCs id)))) (d_OP_updCClassDecl_dot_cls_dot_22 x3 x2
  x6 x4 x5 x1))

nd_C_updCClassDecl :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Func
  AbstractCurry.Curry_Types.C_CVisibility
  AbstractCurry.Curry_Types.C_CVisibility -> Func
  AbstractCurry.Curry_Types.C_CContext AbstractCurry.Curry_Types.C_CContext
  -> Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))))) -> Func
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl)
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl) -> IDSupply
  -> Cover -> ConstStore -> Func AbstractCurry.Curry_Types.C_CClassDecl
  AbstractCurry.Curry_Types.C_CClassDecl
nd_C_updCClassDecl x1 x2 x3 x4 x5 x6 s cd cs = wrapNX id (nd_C_trCClassDecl
  (wrapDX (wrapDX (wrapDX (wrapDX (wrapDX (wrapNX id))))) (acceptCs (acceptCs
  (acceptCs (acceptCs (acceptCs id)))) (nd_OP_updCClassDecl_dot_cls_dot_22 x3 x2
  x6 x4 x5 x1))))

d_OP_updCClassDecl_dot_cls_dot_22 :: (AbstractCurry.Curry_Types.C_CContext
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CContext)
  -> (AbstractCurry.Curry_Types.C_CVisibility -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CVisibility) -> (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl)
  -> (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)))))
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CVisibility
  -> AbstractCurry.Curry_Types.C_CContext -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CClassDecl
d_OP_updCClassDecl_dot_cls_dot_22 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 cd cs =
  AbstractCurry.Curry_Types.C_CClass (Curry_Prelude.d_C_apply x6 x7 cd cs)
  (Curry_Prelude.d_C_apply x2 x8 cd cs) (Curry_Prelude.d_C_apply x1 x9 cd cs)
  (Curry_Prelude.d_C_apply x4 x10 cd cs) (Curry_Prelude.d_C_apply x5 x11 cd cs)
  (Curry_Prelude.d_C_apply x3 x12 cd cs)

nd_OP_updCClassDecl_dot_cls_dot_22 :: Func AbstractCurry.Curry_Types.C_CContext
  AbstractCurry.Curry_Types.C_CContext -> Func
  AbstractCurry.Curry_Types.C_CVisibility
  AbstractCurry.Curry_Types.C_CVisibility -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl) -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)))))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))))) -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> AbstractCurry.Curry_Types.C_CVisibility
  -> AbstractCurry.Curry_Types.C_CContext -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CClassDecl
nd_OP_updCClassDecl_dot_cls_dot_22 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 s cd cs =
  let s6 = s
  in s6 `seq` (let s7 = leftSupply s6
                   s9 = rightSupply s6
                   s0 = leftSupply s7
                   s8 = rightSupply s7
                   s1 = leftSupply s8
                   s2 = rightSupply s8
                   s3 = leftSupply s9
                   s10 = rightSupply s9
                   s4 = leftSupply s10
                   s5 = rightSupply s10
  in s7 `seq` (s9 `seq` (s0 `seq` (s8 `seq` (s1 `seq` (s2 `seq` (s3 `seq`
  (s10 `seq` (s4 `seq` (s5 `seq` AbstractCurry.Curry_Types.C_CClass
  (Curry_Prelude.nd_C_apply x6 x7 s0 cd cs) (Curry_Prelude.nd_C_apply x2 x8 s1
  cd cs) (Curry_Prelude.nd_C_apply x1 x9 s2 cd cs) (Curry_Prelude.nd_C_apply x4
  x10 s3 cd cs) (Curry_Prelude.nd_C_apply x5 x11 s4 cd cs)
  (Curry_Prelude.nd_C_apply x3 x12 s5 cd cs)))))))))))

d_C_trCInstanceDecl :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CContext -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl
  -> Cover -> ConstStore -> t0) -> AbstractCurry.Curry_Types.C_CInstanceDecl
  -> Cover -> ConstStore -> t0
d_C_trCInstanceDecl x1 x2 cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CInstance x3 x4 x5 x6 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    x1 x3 cd cs) x4 cd cs) x5 cd cs) x6 cd cs
  AbstractCurry.Curry_Types.Choice_C_CInstanceDecl d i l r -> narrow d i
    (d_C_trCInstanceDecl x1 l cd cs) (d_C_trCInstanceDecl x1 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CInstanceDecl d i xs -> narrows cs d i
    (\z -> d_C_trCInstanceDecl x1 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CInstanceDecl d c e -> guardCons d c ((\x ->
    d_C_trCInstanceDecl x1 e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CInstanceDecl d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCInstanceDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCInstanceDecl" (showCons
    x2))

nd_C_trCInstanceDecl :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func
  AbstractCurry.Curry_Types.C_CContext (Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr) (Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl) t0)))
  -> AbstractCurry.Curry_Types.C_CInstanceDecl -> IDSupply -> Cover
  -> ConstStore -> t0
nd_C_trCInstanceDecl x1 x2 s cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CInstance x3 x4 x5 x6 -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x3 s0 cd cs) x4 s1 cd cs)) x5 s3 cd cs)) x6 s5 cd cs))
  AbstractCurry.Curry_Types.Choice_C_CInstanceDecl d i l r -> narrow d i
    (nd_C_trCInstanceDecl x1 l s cd cs) (nd_C_trCInstanceDecl x1 r s cd cs)
  AbstractCurry.Curry_Types.Choices_C_CInstanceDecl d i xs -> narrows cs d i
    (\z -> nd_C_trCInstanceDecl x1 z s cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CInstanceDecl d c e -> guardCons d c ((\x ->
    nd_C_trCInstanceDecl x1 e s cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CInstanceDecl d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCInstanceDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCInstanceDecl" (showCons
    x2))

d_C_updCInstanceDecl :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> (AbstractCurry.Curry_Types.C_CContext -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CContext) -> (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr)
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl)
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CInstanceDecl -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CInstanceDecl
d_C_updCInstanceDecl x1 x2 x3 x4 cd cs = d_C_trCInstanceDecl (acceptCs (acceptCs
  (acceptCs id)) (d_OP_updCInstanceDecl_dot_inst_dot_28 x2 x4 x3 x1))

nd_C_updCInstanceDecl :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Func
  AbstractCurry.Curry_Types.C_CContext AbstractCurry.Curry_Types.C_CContext
  -> Func (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr)
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr) -> Func
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl)
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl) -> IDSupply
  -> Cover -> ConstStore -> Func AbstractCurry.Curry_Types.C_CInstanceDecl
  AbstractCurry.Curry_Types.C_CInstanceDecl
nd_C_updCInstanceDecl x1 x2 x3 x4 s cd cs = wrapNX id (nd_C_trCInstanceDecl
  (wrapDX (wrapDX (wrapDX (wrapNX id))) (acceptCs (acceptCs (acceptCs id))
  (nd_OP_updCInstanceDecl_dot_inst_dot_28 x2 x4 x3 x1))))

d_OP_updCInstanceDecl_dot_inst_dot_28 :: (AbstractCurry.Curry_Types.C_CContext
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CContext)
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl)
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CContext
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CInstanceDecl
d_OP_updCInstanceDecl_dot_inst_dot_28 x1 x2 x3 x4 x5 x6 x7 x8 cd cs =
  AbstractCurry.Curry_Types.C_CInstance (Curry_Prelude.d_C_apply x4 x5 cd cs)
  (Curry_Prelude.d_C_apply x1 x6 cd cs) (Curry_Prelude.d_C_apply x3 x7 cd cs)
  (Curry_Prelude.d_C_apply x2 x8 cd cs)

nd_OP_updCInstanceDecl_dot_inst_dot_28 :: Func
  AbstractCurry.Curry_Types.C_CContext AbstractCurry.Curry_Types.C_CContext
  -> Func (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl)
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl) -> Func
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr)
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr) -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> AbstractCurry.Curry_Types.C_CContext -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CInstanceDecl
nd_OP_updCInstanceDecl_dot_inst_dot_28 x1 x2 x3 x4 x5 x6 x7 x8 s cd cs =
  let s4 = s
  in s4 `seq` (let s5 = leftSupply s4
                   s6 = rightSupply s4
                   s0 = leftSupply s5
                   s1 = rightSupply s5
                   s2 = leftSupply s6
                   s3 = rightSupply s6
  in s5 `seq` (s6 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s3 `seq`
  AbstractCurry.Curry_Types.C_CInstance (Curry_Prelude.nd_C_apply x4 x5 s0 cd
  cs) (Curry_Prelude.nd_C_apply x1 x6 s1 cd cs) (Curry_Prelude.nd_C_apply x3 x7
  s2 cd cs) (Curry_Prelude.nd_C_apply x2 x8 s3 cd cs)))))))

d_C_trCTypeDecl :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CVisibility -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CConsDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CVisibility -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CVisibility -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CConsDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> t0) -> AbstractCurry.Curry_Types.C_CTypeDecl -> Cover
  -> ConstStore -> t0
d_C_trCTypeDecl x1 x2 x3 x4 cd cs = case x4 of
  AbstractCurry.Curry_Types.C_CType x5 x6 x7 x8 x9 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x1 x5 cd cs) x6 cd cs) x7 cd cs) x8 cd cs) x9 cd cs
  AbstractCurry.Curry_Types.C_CTypeSyn x10 x11 x12 x13 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    x2 x10 cd cs) x11 cd cs) x12 cd cs) x13 cd cs
  AbstractCurry.Curry_Types.C_CNewType x14 x15 x16 x17 x18 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x3 x14 cd cs) x15 cd cs) x16 cd cs) x17 cd cs) x18
    cd cs
  AbstractCurry.Curry_Types.Choice_C_CTypeDecl d i l r -> narrow d i
    (d_C_trCTypeDecl x1 x2 x3 l cd cs) (d_C_trCTypeDecl x1 x2 x3 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CTypeDecl d i xs -> narrows cs d i (\z ->
    d_C_trCTypeDecl x1 x2 x3 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CTypeDecl d c e -> guardCons d c ((\x ->
    d_C_trCTypeDecl x1 x2 x3 e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CTypeDecl d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCTypeDecl" [show x1, show x2, show x3, show x4]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCTypeDecl" (showCons
    x4))

nd_C_trCTypeDecl :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func
  AbstractCurry.Curry_Types.C_CVisibility (Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CConsDecl) (Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) t0)))) -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func
  AbstractCurry.Curry_Types.C_CVisibility (Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Func AbstractCurry.Curry_Types.C_CTypeExpr t0)))
  -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func
  AbstractCurry.Curry_Types.C_CVisibility (Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Func AbstractCurry.Curry_Types.C_CConsDecl (Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))) t0))))
  -> AbstractCurry.Curry_Types.C_CTypeDecl -> IDSupply -> Cover -> ConstStore
  -> t0
nd_C_trCTypeDecl x1 x2 x3 x4 s cd cs = case x4 of
  AbstractCurry.Curry_Types.C_CType x5 x6 x7 x8 x9 -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                        s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x5 s0 cd cs) x6 s1 cd cs)) x7 s3 cd cs)) x8 s5 cd cs)) x9 s7 cd cs))
  AbstractCurry.Curry_Types.C_CTypeSyn x10 x11 x12 x13 -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2
    x10 s0 cd cs) x11 s1 cd cs)) x12 s3 cd cs)) x13 s5 cd cs))
  AbstractCurry.Curry_Types.C_CNewType x14 x15 x16 x17 x18 -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                        s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x3
    x14 s0 cd cs) x15 s1 cd cs)) x16 s3 cd cs)) x17 s5 cd cs)) x18 s7 cd cs))
  AbstractCurry.Curry_Types.Choice_C_CTypeDecl d i l r -> narrow d i
    (nd_C_trCTypeDecl x1 x2 x3 l s cd cs) (nd_C_trCTypeDecl x1 x2 x3 r s cd cs)
  AbstractCurry.Curry_Types.Choices_C_CTypeDecl d i xs -> narrows cs d i (\z ->
    nd_C_trCTypeDecl x1 x2 x3 z s cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CTypeDecl d c e -> guardCons d c ((\x ->
    nd_C_trCTypeDecl x1 x2 x3 e s cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CTypeDecl d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCTypeDecl" [show x1, show x2, show x3, show x4]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCTypeDecl" (showCons
    x4))

d_C_updCTypeDecl :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> (AbstractCurry.Curry_Types.C_CVisibility -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CVisibility) -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CConsDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CConsDecl)
  -> (AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CTypeExpr)
  -> (AbstractCurry.Curry_Types.C_CConsDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CConsDecl) -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CTypeDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CTypeDecl
d_C_updCTypeDecl x1 x2 x3 x4 x5 x6 x7 cd cs = d_C_trCTypeDecl (acceptCs
  (acceptCs (acceptCs (acceptCs id))) (d_OP_updCTypeDecl_dot_typ_dot_44 x2 x4 x3
  x7 x1)) (acceptCs (acceptCs (acceptCs id)) (d_OP_updCTypeDecl_dot_tsyn_dot_44
  x5 x2 x3 x1)) (acceptCs (acceptCs (acceptCs (acceptCs id)))
  (d_OP_updCTypeDecl_dot_tntyp_dot_44 x6 x2 x3 x7 x1))

nd_C_updCTypeDecl :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Func
  AbstractCurry.Curry_Types.C_CVisibility
  AbstractCurry.Curry_Types.C_CVisibility -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Func
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CConsDecl)
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CConsDecl) -> Func
  AbstractCurry.Curry_Types.C_CTypeExpr AbstractCurry.Curry_Types.C_CTypeExpr
  -> Func AbstractCurry.Curry_Types.C_CConsDecl
  AbstractCurry.Curry_Types.C_CConsDecl -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> IDSupply -> Cover
  -> ConstStore -> Func AbstractCurry.Curry_Types.C_CTypeDecl
  AbstractCurry.Curry_Types.C_CTypeDecl
nd_C_updCTypeDecl x1 x2 x3 x4 x5 x6 x7 s cd cs = wrapNX id (nd_C_trCTypeDecl
  (wrapDX (wrapDX (wrapDX (wrapDX (wrapNX id)))) (acceptCs (acceptCs (acceptCs
  (acceptCs id))) (nd_OP_updCTypeDecl_dot_typ_dot_44 x2 x4 x3 x7 x1))) (wrapDX
  (wrapDX (wrapDX (wrapNX id))) (acceptCs (acceptCs (acceptCs id))
  (nd_OP_updCTypeDecl_dot_tsyn_dot_44 x5 x2 x3 x1))) (wrapDX (wrapDX (wrapDX
  (wrapDX (wrapNX id)))) (acceptCs (acceptCs (acceptCs (acceptCs id)))
  (nd_OP_updCTypeDecl_dot_tntyp_dot_44 x6 x2 x3 x7 x1))))

d_OP_updCTypeDecl_dot_typ_dot_44 :: (AbstractCurry.Curry_Types.C_CVisibility
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CVisibility)
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CConsDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CConsDecl)
  -> (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CVisibility
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CConsDecl -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CTypeDecl
d_OP_updCTypeDecl_dot_typ_dot_44 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 cd cs =
  AbstractCurry.Curry_Types.C_CType (Curry_Prelude.d_C_apply x5 x6 cd cs)
  (Curry_Prelude.d_C_apply x1 x7 cd cs) (Curry_Prelude.d_C_apply x3 x8 cd cs)
  (Curry_Prelude.d_C_apply x2 x9 cd cs) (Curry_Prelude.d_C_apply x4 x10 cd cs)

nd_OP_updCTypeDecl_dot_typ_dot_44 :: Func
  AbstractCurry.Curry_Types.C_CVisibility
  AbstractCurry.Curry_Types.C_CVisibility -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CConsDecl) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CConsDecl) -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> AbstractCurry.Curry_Types.C_CVisibility -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CConsDecl -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CTypeDecl
nd_OP_updCTypeDecl_dot_typ_dot_44 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 s cd cs =
  let s5 = s
  in s5 `seq` (let s6 = leftSupply s5
                   s7 = rightSupply s5
                   s0 = leftSupply s6
                   s1 = rightSupply s6
                   s2 = leftSupply s7
                   s8 = rightSupply s7
                   s3 = leftSupply s8
                   s4 = rightSupply s8
  in s6 `seq` (s7 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s8 `seq` (s3 `seq`
  (s4 `seq` AbstractCurry.Curry_Types.C_CType (Curry_Prelude.nd_C_apply x5 x6 s0
  cd cs) (Curry_Prelude.nd_C_apply x1 x7 s1 cd cs) (Curry_Prelude.nd_C_apply x3
  x8 s2 cd cs) (Curry_Prelude.nd_C_apply x2 x9 s3 cd cs)
  (Curry_Prelude.nd_C_apply x4 x10 s4 cd cs)))))))))

d_OP_updCTypeDecl_dot_tsyn_dot_44 :: (AbstractCurry.Curry_Types.C_CTypeExpr
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CTypeExpr)
  -> (AbstractCurry.Curry_Types.C_CVisibility -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CVisibility) -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> AbstractCurry.Curry_Types.C_CVisibility -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> AbstractCurry.Curry_Types.C_CTypeExpr -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CTypeDecl
d_OP_updCTypeDecl_dot_tsyn_dot_44 x1 x2 x3 x4 x5 x6 x7 x8 cd cs =
  AbstractCurry.Curry_Types.C_CTypeSyn (Curry_Prelude.d_C_apply x4 x5 cd cs)
  (Curry_Prelude.d_C_apply x2 x6 cd cs) (Curry_Prelude.d_C_apply x3 x7 cd cs)
  (Curry_Prelude.d_C_apply x1 x8 cd cs)

nd_OP_updCTypeDecl_dot_tsyn_dot_44 :: Func AbstractCurry.Curry_Types.C_CTypeExpr
  AbstractCurry.Curry_Types.C_CTypeExpr -> Func
  AbstractCurry.Curry_Types.C_CVisibility
  AbstractCurry.Curry_Types.C_CVisibility -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> AbstractCurry.Curry_Types.C_CVisibility -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> AbstractCurry.Curry_Types.C_CTypeExpr -> IDSupply
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CTypeDecl
nd_OP_updCTypeDecl_dot_tsyn_dot_44 x1 x2 x3 x4 x5 x6 x7 x8 s cd cs = let s4 = s
  in s4 `seq` (let s5 = leftSupply s4
                   s6 = rightSupply s4
                   s0 = leftSupply s5
                   s1 = rightSupply s5
                   s2 = leftSupply s6
                   s3 = rightSupply s6
  in s5 `seq` (s6 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s3 `seq`
  AbstractCurry.Curry_Types.C_CTypeSyn (Curry_Prelude.nd_C_apply x4 x5 s0 cd cs)
  (Curry_Prelude.nd_C_apply x2 x6 s1 cd cs) (Curry_Prelude.nd_C_apply x3 x7 s2
  cd cs) (Curry_Prelude.nd_C_apply x1 x8 s3 cd cs)))))))

d_OP_updCTypeDecl_dot_tntyp_dot_44 :: (AbstractCurry.Curry_Types.C_CConsDecl
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CConsDecl)
  -> (AbstractCurry.Curry_Types.C_CVisibility -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CVisibility) -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> AbstractCurry.Curry_Types.C_CVisibility -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> AbstractCurry.Curry_Types.C_CConsDecl
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CTypeDecl
d_OP_updCTypeDecl_dot_tntyp_dot_44 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 cd cs =
  AbstractCurry.Curry_Types.C_CNewType (Curry_Prelude.d_C_apply x5 x6 cd cs)
  (Curry_Prelude.d_C_apply x2 x7 cd cs) (Curry_Prelude.d_C_apply x3 x8 cd cs)
  (Curry_Prelude.d_C_apply x1 x9 cd cs) (Curry_Prelude.d_C_apply x4 x10 cd cs)

nd_OP_updCTypeDecl_dot_tntyp_dot_44 :: Func
  AbstractCurry.Curry_Types.C_CConsDecl AbstractCurry.Curry_Types.C_CConsDecl
  -> Func AbstractCurry.Curry_Types.C_CVisibility
  AbstractCurry.Curry_Types.C_CVisibility -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> AbstractCurry.Curry_Types.C_CVisibility -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> AbstractCurry.Curry_Types.C_CConsDecl
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> IDSupply -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CTypeDecl
nd_OP_updCTypeDecl_dot_tntyp_dot_44 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 s cd cs =
  let s5 = s
  in s5 `seq` (let s6 = leftSupply s5
                   s7 = rightSupply s5
                   s0 = leftSupply s6
                   s1 = rightSupply s6
                   s2 = leftSupply s7
                   s8 = rightSupply s7
                   s3 = leftSupply s8
                   s4 = rightSupply s8
  in s6 `seq` (s7 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s8 `seq` (s3 `seq`
  (s4 `seq` AbstractCurry.Curry_Types.C_CNewType (Curry_Prelude.nd_C_apply x5 x6
  s0 cd cs) (Curry_Prelude.nd_C_apply x2 x7 s1 cd cs) (Curry_Prelude.nd_C_apply
  x3 x8 s2 cd cs) (Curry_Prelude.nd_C_apply x1 x9 s3 cd cs)
  (Curry_Prelude.nd_C_apply x4 x10 s4 cd cs)))))))))

d_C_updCTypeDeclName :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CTypeDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CTypeDecl
d_C_updCTypeDeclName x1 cd cs = d_C_updCTypeDecl x1 Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id cd cs

nd_C_updCTypeDeclName :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Func AbstractCurry.Curry_Types.C_CTypeDecl
  AbstractCurry.Curry_Types.C_CTypeDecl
nd_C_updCTypeDeclName x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updCTypeDecl x1 (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) s0 cd cs

d_C_trCConsDecl :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CVisibility -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr -> Cover
  -> ConstStore -> t0) -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CVisibility -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFieldDecl
  -> Cover -> ConstStore -> t0) -> AbstractCurry.Curry_Types.C_CConsDecl
  -> Cover -> ConstStore -> t0
d_C_trCConsDecl x1 x2 x3 cd cs = case x3 of
  AbstractCurry.Curry_Types.C_CCons x4 x5 x6 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x1 x4 cd cs) x5 cd cs) x6
    cd cs
  AbstractCurry.Curry_Types.C_CRecord x7 x8 x9 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x2 x7 cd cs) x8 cd cs) x9
    cd cs
  AbstractCurry.Curry_Types.Choice_C_CConsDecl d i l r -> narrow d i
    (d_C_trCConsDecl x1 x2 l cd cs) (d_C_trCConsDecl x1 x2 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CConsDecl d i xs -> narrows cs d i (\z ->
    d_C_trCConsDecl x1 x2 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CConsDecl d c e -> guardCons d c ((\x ->
    d_C_trCConsDecl x1 x2 e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CConsDecl d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCConsDecl" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCConsDecl" (showCons
    x3))

nd_C_trCConsDecl :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func
  AbstractCurry.Curry_Types.C_CVisibility (Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr) t0)) -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Func AbstractCurry.Curry_Types.C_CVisibility (Func
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFieldDecl) t0))
  -> AbstractCurry.Curry_Types.C_CConsDecl -> IDSupply -> Cover -> ConstStore
  -> t0
nd_C_trCConsDecl x1 x2 x3 s cd cs = case x3 of
  AbstractCurry.Curry_Types.C_CCons x4 x5 x6 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x4 s0 cd cs) x5 s1 cd cs)) x6 s3 cd cs))
  AbstractCurry.Curry_Types.C_CRecord x7 x8 x9 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2
    x7 s0 cd cs) x8 s1 cd cs)) x9 s3 cd cs))
  AbstractCurry.Curry_Types.Choice_C_CConsDecl d i l r -> narrow d i
    (nd_C_trCConsDecl x1 x2 l s cd cs) (nd_C_trCConsDecl x1 x2 r s cd cs)
  AbstractCurry.Curry_Types.Choices_C_CConsDecl d i xs -> narrows cs d i (\z ->
    nd_C_trCConsDecl x1 x2 z s cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CConsDecl d c e -> guardCons d c ((\x ->
    nd_C_trCConsDecl x1 x2 e s cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CConsDecl d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCConsDecl" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCConsDecl" (showCons
    x3))

d_C_updCConsDecl :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> (AbstractCurry.Curry_Types.C_CVisibility -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CVisibility) -> (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr)
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFieldDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFieldDecl)
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CConsDecl -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CConsDecl
d_C_updCConsDecl x1 x2 x3 x4 cd cs = d_C_trCConsDecl (acceptCs (acceptCs id)
  (d_OP_updCConsDecl_dot_cons_dot_60 x2 x3 x1)) (acceptCs (acceptCs id)
  (d_OP_updCConsDecl_dot_rec_dot_60 x2 x4 x1))

nd_C_updCConsDecl :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Func
  AbstractCurry.Curry_Types.C_CVisibility
  AbstractCurry.Curry_Types.C_CVisibility -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr) -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFieldDecl) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFieldDecl) -> IDSupply -> Cover -> ConstStore
  -> Func AbstractCurry.Curry_Types.C_CConsDecl
  AbstractCurry.Curry_Types.C_CConsDecl
nd_C_updCConsDecl x1 x2 x3 x4 s cd cs = wrapNX id (nd_C_trCConsDecl (wrapDX
  (wrapDX (wrapNX id)) (acceptCs (acceptCs id)
  (nd_OP_updCConsDecl_dot_cons_dot_60 x2 x3 x1))) (wrapDX (wrapDX (wrapNX id))
  (acceptCs (acceptCs id) (nd_OP_updCConsDecl_dot_rec_dot_60 x2 x4 x1))))

d_OP_updCConsDecl_dot_cons_dot_60 :: (AbstractCurry.Curry_Types.C_CVisibility
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CVisibility)
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CVisibility
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CConsDecl
d_OP_updCConsDecl_dot_cons_dot_60 x1 x2 x3 x4 x5 x6 cd cs =
  AbstractCurry.Curry_Types.C_CCons (Curry_Prelude.d_C_apply x3 x4 cd cs)
  (Curry_Prelude.d_C_apply x1 x5 cd cs) (Curry_Prelude.d_C_apply x2 x6 cd cs)

nd_OP_updCConsDecl_dot_cons_dot_60 :: Func
  AbstractCurry.Curry_Types.C_CVisibility
  AbstractCurry.Curry_Types.C_CVisibility -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr) -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> AbstractCurry.Curry_Types.C_CVisibility -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CConsDecl
nd_OP_updCConsDecl_dot_cons_dot_60 x1 x2 x3 x4 x5 x6 s cd cs = let s3 = s
  in s3 `seq` (let s0 = leftSupply s3
                   s4 = rightSupply s3
                   s1 = leftSupply s4
                   s2 = rightSupply s4
  in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` AbstractCurry.Curry_Types.C_CCons
  (Curry_Prelude.nd_C_apply x3 x4 s0 cd cs) (Curry_Prelude.nd_C_apply x1 x5 s1
  cd cs) (Curry_Prelude.nd_C_apply x2 x6 s2 cd cs)))))

d_OP_updCConsDecl_dot_rec_dot_60 :: (AbstractCurry.Curry_Types.C_CVisibility
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CVisibility)
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFieldDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFieldDecl)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CVisibility
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFieldDecl -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CConsDecl
d_OP_updCConsDecl_dot_rec_dot_60 x1 x2 x3 x4 x5 x6 cd cs =
  AbstractCurry.Curry_Types.C_CRecord (Curry_Prelude.d_C_apply x3 x4 cd cs)
  (Curry_Prelude.d_C_apply x1 x5 cd cs) (Curry_Prelude.d_C_apply x2 x6 cd cs)

nd_OP_updCConsDecl_dot_rec_dot_60 :: Func
  AbstractCurry.Curry_Types.C_CVisibility
  AbstractCurry.Curry_Types.C_CVisibility -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFieldDecl) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFieldDecl) -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> AbstractCurry.Curry_Types.C_CVisibility -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFieldDecl -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CConsDecl
nd_OP_updCConsDecl_dot_rec_dot_60 x1 x2 x3 x4 x5 x6 s cd cs = let s3 = s
  in s3 `seq` (let s0 = leftSupply s3
                   s4 = rightSupply s3
                   s1 = leftSupply s4
                   s2 = rightSupply s4
  in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` AbstractCurry.Curry_Types.C_CRecord
  (Curry_Prelude.nd_C_apply x3 x4 s0 cd cs) (Curry_Prelude.nd_C_apply x1 x5 s1
  cd cs) (Curry_Prelude.nd_C_apply x2 x6 s2 cd cs)))))

d_C_updCConsDeclName :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CConsDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CConsDecl
d_C_updCConsDeclName x1 cd cs = d_C_updCConsDecl x1 Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id cd cs

nd_C_updCConsDeclName :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Func AbstractCurry.Curry_Types.C_CConsDecl
  AbstractCurry.Curry_Types.C_CConsDecl
nd_C_updCConsDeclName x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updCConsDecl x1 (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) s0 cd cs

d_C_trCFieldDecl :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CVisibility -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore -> t0)
  -> AbstractCurry.Curry_Types.C_CFieldDecl -> Cover -> ConstStore -> t0
d_C_trCFieldDecl x1 x2 cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CField x3 x4 x5 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x1 x3 cd cs) x4 cd cs) x5
    cd cs
  AbstractCurry.Curry_Types.Choice_C_CFieldDecl d i l r -> narrow d i
    (d_C_trCFieldDecl x1 l cd cs) (d_C_trCFieldDecl x1 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CFieldDecl d i xs -> narrows cs d i (\z ->
    d_C_trCFieldDecl x1 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CFieldDecl d c e -> guardCons d c ((\x ->
    d_C_trCFieldDecl x1 e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CFieldDecl d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCFieldDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCFieldDecl" (showCons
    x2))

nd_C_trCFieldDecl :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func
  AbstractCurry.Curry_Types.C_CVisibility (Func
  AbstractCurry.Curry_Types.C_CTypeExpr t0))
  -> AbstractCurry.Curry_Types.C_CFieldDecl -> IDSupply -> Cover -> ConstStore
  -> t0
nd_C_trCFieldDecl x1 x2 s cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CField x3 x4 x5 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x3 s0 cd cs) x4 s1 cd cs)) x5 s3 cd cs))
  AbstractCurry.Curry_Types.Choice_C_CFieldDecl d i l r -> narrow d i
    (nd_C_trCFieldDecl x1 l s cd cs) (nd_C_trCFieldDecl x1 r s cd cs)
  AbstractCurry.Curry_Types.Choices_C_CFieldDecl d i xs -> narrows cs d i (\z ->
    nd_C_trCFieldDecl x1 z s cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CFieldDecl d c e -> guardCons d c ((\x ->
    nd_C_trCFieldDecl x1 e s cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CFieldDecl d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCFieldDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCFieldDecl" (showCons
    x2))

d_C_updCFieldDecl :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> (AbstractCurry.Curry_Types.C_CVisibility -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CVisibility)
  -> (AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CTypeExpr) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CFieldDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CFieldDecl
d_C_updCFieldDecl x1 x2 x3 cd cs = d_C_trCFieldDecl (acceptCs (acceptCs id)
  (d_OP_updCFieldDecl_dot_field_dot_70 x3 x2 x1))

nd_C_updCFieldDecl :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Func
  AbstractCurry.Curry_Types.C_CVisibility
  AbstractCurry.Curry_Types.C_CVisibility -> Func
  AbstractCurry.Curry_Types.C_CTypeExpr AbstractCurry.Curry_Types.C_CTypeExpr
  -> IDSupply -> Cover -> ConstStore -> Func
  AbstractCurry.Curry_Types.C_CFieldDecl AbstractCurry.Curry_Types.C_CFieldDecl
nd_C_updCFieldDecl x1 x2 x3 s cd cs = wrapNX id (nd_C_trCFieldDecl (wrapDX
  (wrapDX (wrapNX id)) (acceptCs (acceptCs id)
  (nd_OP_updCFieldDecl_dot_field_dot_70 x3 x2 x1))))

d_OP_updCFieldDecl_dot_field_dot_70 :: (AbstractCurry.Curry_Types.C_CTypeExpr
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CTypeExpr)
  -> (AbstractCurry.Curry_Types.C_CVisibility -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CVisibility) -> (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> AbstractCurry.Curry_Types.C_CVisibility
  -> AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CFieldDecl
d_OP_updCFieldDecl_dot_field_dot_70 x1 x2 x3 x4 x5 x6 cd cs =
  AbstractCurry.Curry_Types.C_CField (Curry_Prelude.d_C_apply x3 x4 cd cs)
  (Curry_Prelude.d_C_apply x2 x5 cd cs) (Curry_Prelude.d_C_apply x1 x6 cd cs)

nd_OP_updCFieldDecl_dot_field_dot_70 :: Func
  AbstractCurry.Curry_Types.C_CTypeExpr AbstractCurry.Curry_Types.C_CTypeExpr
  -> Func AbstractCurry.Curry_Types.C_CVisibility
  AbstractCurry.Curry_Types.C_CVisibility -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> AbstractCurry.Curry_Types.C_CVisibility
  -> AbstractCurry.Curry_Types.C_CTypeExpr -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CFieldDecl
nd_OP_updCFieldDecl_dot_field_dot_70 x1 x2 x3 x4 x5 x6 s cd cs = let s3 = s
  in s3 `seq` (let s0 = leftSupply s3
                   s4 = rightSupply s3
                   s1 = leftSupply s4
                   s2 = rightSupply s4
  in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` AbstractCurry.Curry_Types.C_CField
  (Curry_Prelude.nd_C_apply x3 x4 s0 cd cs) (Curry_Prelude.nd_C_apply x2 x5 s1
  cd cs) (Curry_Prelude.nd_C_apply x1 x6 s2 cd cs)))))

d_C_updCFieldDeclName :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CFieldDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CFieldDecl
d_C_updCFieldDeclName x1 cd cs = d_C_updCFieldDecl x1 Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id cd cs

nd_C_updCFieldDeclName :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Func AbstractCurry.Curry_Types.C_CFieldDecl
  AbstractCurry.Curry_Types.C_CFieldDecl
nd_C_updCFieldDeclName x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updCFieldDecl x1 (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) s0 cd cs

d_C_trCQualTypeExpr :: forall t0 . (Curry_Prelude.Curry
  t0) => (AbstractCurry.Curry_Types.C_CContext -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore -> t0)
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr -> Cover -> ConstStore -> t0
d_C_trCQualTypeExpr x1 x2 cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CQualType x3 x4 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x1 x3 cd cs) x4 cd cs
  AbstractCurry.Curry_Types.Choice_C_CQualTypeExpr d i l r -> narrow d i
    (d_C_trCQualTypeExpr x1 l cd cs) (d_C_trCQualTypeExpr x1 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CQualTypeExpr d i xs -> narrows cs d i
    (\z -> d_C_trCQualTypeExpr x1 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CQualTypeExpr d c e -> guardCons d c ((\x ->
    d_C_trCQualTypeExpr x1 e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CQualTypeExpr d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCQualTypeExpr" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCQualTypeExpr" (showCons
    x2))

nd_C_trCQualTypeExpr :: forall t0 . (Curry_Prelude.Curry t0) => Func
  AbstractCurry.Curry_Types.C_CContext (Func
  AbstractCurry.Curry_Types.C_CTypeExpr t0)
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr -> IDSupply -> Cover
  -> ConstStore -> t0
nd_C_trCQualTypeExpr x1 x2 s cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CQualType x3 x4 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x3 s0 cd cs) x4 s1 cd cs))
  AbstractCurry.Curry_Types.Choice_C_CQualTypeExpr d i l r -> narrow d i
    (nd_C_trCQualTypeExpr x1 l s cd cs) (nd_C_trCQualTypeExpr x1 r s cd cs)
  AbstractCurry.Curry_Types.Choices_C_CQualTypeExpr d i xs -> narrows cs d i
    (\z -> nd_C_trCQualTypeExpr x1 z s cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CQualTypeExpr d c e -> guardCons d c ((\x ->
    nd_C_trCQualTypeExpr x1 e s cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CQualTypeExpr d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCQualTypeExpr" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCQualTypeExpr" (showCons
    x2))

d_C_updCQualTypeExpr :: (AbstractCurry.Curry_Types.C_CContext -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CContext)
  -> (AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CTypeExpr) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr
d_C_updCQualTypeExpr x1 x2 cd cs = d_C_trCQualTypeExpr (acceptCs id
  (d_OP_updCQualTypeExpr_dot_uscore_hash_lambda3 x1 x2))

nd_C_updCQualTypeExpr :: Func AbstractCurry.Curry_Types.C_CContext
  AbstractCurry.Curry_Types.C_CContext -> Func
  AbstractCurry.Curry_Types.C_CTypeExpr AbstractCurry.Curry_Types.C_CTypeExpr
  -> IDSupply -> Cover -> ConstStore -> Func
  AbstractCurry.Curry_Types.C_CQualTypeExpr
  AbstractCurry.Curry_Types.C_CQualTypeExpr
nd_C_updCQualTypeExpr x1 x2 s cd cs = wrapNX id (nd_C_trCQualTypeExpr (wrapDX
  (wrapNX id) (acceptCs id (nd_OP_updCQualTypeExpr_dot_uscore_hash_lambda3 x1
  x2))))

d_OP_updCQualTypeExpr_dot_uscore_hash_lambda3 :: (AbstractCurry.Curry_Types.C_CContext
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CContext)
  -> (AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CTypeExpr)
  -> AbstractCurry.Curry_Types.C_CContext
  -> AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr
d_OP_updCQualTypeExpr_dot_uscore_hash_lambda3 x1 x2 x3 x4 cd cs =
  AbstractCurry.Curry_Types.C_CQualType (Curry_Prelude.d_C_apply x1 x3 cd cs)
  (Curry_Prelude.d_C_apply x2 x4 cd cs)

nd_OP_updCQualTypeExpr_dot_uscore_hash_lambda3 :: Func
  AbstractCurry.Curry_Types.C_CContext AbstractCurry.Curry_Types.C_CContext
  -> Func AbstractCurry.Curry_Types.C_CTypeExpr
  AbstractCurry.Curry_Types.C_CTypeExpr -> AbstractCurry.Curry_Types.C_CContext
  -> AbstractCurry.Curry_Types.C_CTypeExpr -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr
nd_OP_updCQualTypeExpr_dot_uscore_hash_lambda3 x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` AbstractCurry.Curry_Types.C_CQualType
  (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs) (Curry_Prelude.nd_C_apply x2 x4 s1
  cd cs)))

d_C_trCTypeExpr :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> t0)
  -> (t0 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t0) -> (t0
  -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t0)
  -> AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore -> t0
d_C_trCTypeExpr x1 x2 x3 x4 x5 cd cs = d_OP_trCTypeExpr_dot_trTE_dot_81 x4 x3 x1
  x2 x5 cd cs

nd_C_trCTypeExpr :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0 -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0 -> Func t0 (Func t0 t0) -> Func t0 (Func t0 t0)
  -> AbstractCurry.Curry_Types.C_CTypeExpr -> IDSupply -> Cover -> ConstStore
  -> t0
nd_C_trCTypeExpr x1 x2 x3 x4 x5 s cd cs = let s0 = s
  in s0 `seq` nd_OP_trCTypeExpr_dot_trTE_dot_81 x4 x3 x1 x2 x5 s0 cd cs

d_OP_trCTypeExpr_dot_trTE_dot_81 :: forall t0 . (Curry_Prelude.Curry t0) => (t0
  -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t0) -> (t0 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> t0) -> (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> t0) -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> t0) -> AbstractCurry.Curry_Types.C_CTypeExpr -> Cover
  -> ConstStore -> t0
d_OP_trCTypeExpr_dot_trTE_dot_81 x1 x2 x3 x4 x5 cd cs = case x5 of
  AbstractCurry.Curry_Types.C_CTVar x6 -> Curry_Prelude.d_C_apply x3 x6 cd cs
  AbstractCurry.Curry_Types.C_CTCons x7 -> Curry_Prelude.d_C_apply x4 x7 cd cs
  AbstractCurry.Curry_Types.C_CFuncType x8 x9 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x2 (d_OP_trCTypeExpr_dot_trTE_dot_81 x1 x2 x3 x4 x8
    cd cs) cd cs) (d_OP_trCTypeExpr_dot_trTE_dot_81 x1 x2 x3 x4 x9 cd cs) cd cs
  AbstractCurry.Curry_Types.C_CTApply x10 x11 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x1 (d_OP_trCTypeExpr_dot_trTE_dot_81 x1 x2 x3 x4
    x10 cd cs) cd cs) (d_OP_trCTypeExpr_dot_trTE_dot_81 x1 x2 x3 x4 x11 cd cs)
    cd cs
  AbstractCurry.Curry_Types.Choice_C_CTypeExpr d i l r -> narrow d i
    (d_OP_trCTypeExpr_dot_trTE_dot_81 x1 x2 x3 x4 l cd cs)
    (d_OP_trCTypeExpr_dot_trTE_dot_81 x1 x2 x3 x4 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CTypeExpr d i xs -> narrows cs d i (\z ->
    d_OP_trCTypeExpr_dot_trTE_dot_81 x1 x2 x3 x4 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CTypeExpr d c e -> guardCons d c ((\x ->
    d_OP_trCTypeExpr_dot_trTE_dot_81 x1 x2 x3 x4 e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CTypeExpr d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCTypeExpr.trTE.81" [show x1, show x2, show x3
    , show x4, show x5] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCTypeExpr.trTE.81"
    (showCons x5))

nd_OP_trCTypeExpr_dot_trTE_dot_81 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func t0 (Func t0 t0) -> Func t0 (Func t0 t0) -> Func
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0 -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0 -> AbstractCurry.Curry_Types.C_CTypeExpr -> IDSupply
  -> Cover -> ConstStore -> t0
nd_OP_trCTypeExpr_dot_trTE_dot_81 x1 x2 x3 x4 x5 s cd cs = case x5 of
  AbstractCurry.Curry_Types.C_CTVar x6 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x3 x6 s0 cd cs
  AbstractCurry.Curry_Types.C_CTCons x7 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x4 x7 s0 cd cs
  AbstractCurry.Curry_Types.C_CFuncType x8 x9 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s2 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply x2
    (nd_OP_trCTypeExpr_dot_trTE_dot_81 x1 x2 x3 x4 x8 s0 cd cs) s1 cd cs))
    (nd_OP_trCTypeExpr_dot_trTE_dot_81 x1 x2 x3 x4 x9 s3 cd cs) s4 cd cs))))
  AbstractCurry.Curry_Types.C_CTApply x10 x11 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s2 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply x1
    (nd_OP_trCTypeExpr_dot_trTE_dot_81 x1 x2 x3 x4 x10 s0 cd cs) s1 cd cs))
    (nd_OP_trCTypeExpr_dot_trTE_dot_81 x1 x2 x3 x4 x11 s3 cd cs) s4 cd cs))))
  AbstractCurry.Curry_Types.Choice_C_CTypeExpr d i l r -> narrow d i
    (nd_OP_trCTypeExpr_dot_trTE_dot_81 x1 x2 x3 x4 l s cd cs)
    (nd_OP_trCTypeExpr_dot_trTE_dot_81 x1 x2 x3 x4 r s cd cs)
  AbstractCurry.Curry_Types.Choices_C_CTypeExpr d i xs -> narrows cs d i (\z ->
    nd_OP_trCTypeExpr_dot_trTE_dot_81 x1 x2 x3 x4 z s cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CTypeExpr d c e -> guardCons d c ((\x ->
    nd_OP_trCTypeExpr_dot_trTE_dot_81 x1 x2 x3 x4 e s cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CTypeExpr d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCTypeExpr.trTE.81" [show x1, show x2, show x3
    , show x4, show x5] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCTypeExpr.trTE.81"
    (showCons x5))

d_C_updTConsApp :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CTypeExpr) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CTypeExpr
d_C_updTConsApp x1 cd cs = d_C_trCTypeExpr (acceptCs id
  AbstractCurry.Curry_Types.C_CTVar) x1 (acceptCs (acceptCs id)
  AbstractCurry.Curry_Types.C_CFuncType) (acceptCs (acceptCs id)
  AbstractCurry.Curry_Types.C_CTApply)

nd_C_updTConsApp :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  AbstractCurry.Curry_Types.C_CTypeExpr -> IDSupply -> Cover -> ConstStore
  -> Func AbstractCurry.Curry_Types.C_CTypeExpr
  AbstractCurry.Curry_Types.C_CTypeExpr
nd_C_updTConsApp x1 s cd cs = wrapNX id (nd_C_trCTypeExpr (wrapDX id (acceptCs
  id AbstractCurry.Curry_Types.C_CTVar)) x1 (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) AbstractCurry.Curry_Types.C_CFuncType)) (wrapDX (wrapDX id)
  (acceptCs (acceptCs id) AbstractCurry.Curry_Types.C_CTApply)))

d_C_trCOpDecl :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CFixity -> Cover -> ConstStore
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> t0)
  -> AbstractCurry.Curry_Types.C_COpDecl -> Cover -> ConstStore -> t0
d_C_trCOpDecl x1 x2 cd cs = case x2 of
  AbstractCurry.Curry_Types.C_COp x3 x4 x5 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x1 x3 cd cs) x4 cd cs) x5
    cd cs
  AbstractCurry.Curry_Types.Choice_C_COpDecl d i l r -> narrow d i
    (d_C_trCOpDecl x1 l cd cs) (d_C_trCOpDecl x1 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_COpDecl d i xs -> narrows cs d i (\z ->
    d_C_trCOpDecl x1 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_COpDecl d c e -> guardCons d c ((\x ->
    d_C_trCOpDecl x1 e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_COpDecl d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCOpDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCOpDecl" (showCons x2))

nd_C_trCOpDecl :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func
  AbstractCurry.Curry_Types.C_CFixity (Func Curry_Prelude.C_Int t0))
  -> AbstractCurry.Curry_Types.C_COpDecl -> IDSupply -> Cover -> ConstStore
  -> t0
nd_C_trCOpDecl x1 x2 s cd cs = case x2 of
  AbstractCurry.Curry_Types.C_COp x3 x4 x5 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x3 s0 cd cs) x4 s1 cd cs)) x5 s3 cd cs))
  AbstractCurry.Curry_Types.Choice_C_COpDecl d i l r -> narrow d i
    (nd_C_trCOpDecl x1 l s cd cs) (nd_C_trCOpDecl x1 r s cd cs)
  AbstractCurry.Curry_Types.Choices_C_COpDecl d i xs -> narrows cs d i (\z ->
    nd_C_trCOpDecl x1 z s cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_COpDecl d c e -> guardCons d c ((\x ->
    nd_C_trCOpDecl x1 e s cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_COpDecl d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCOpDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCOpDecl" (showCons x2))

d_C_updCOpDecl :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> (AbstractCurry.Curry_Types.C_CFixity -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CFixity) -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_COpDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_COpDecl
d_C_updCOpDecl x1 x2 x3 cd cs = d_C_trCOpDecl (acceptCs (acceptCs id)
  (d_OP_updCOpDecl_dot_op_dot_95 x2 x3 x1))

nd_C_updCOpDecl :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Func
  AbstractCurry.Curry_Types.C_CFixity AbstractCurry.Curry_Types.C_CFixity
  -> Func Curry_Prelude.C_Int Curry_Prelude.C_Int -> IDSupply -> Cover
  -> ConstStore -> Func AbstractCurry.Curry_Types.C_COpDecl
  AbstractCurry.Curry_Types.C_COpDecl
nd_C_updCOpDecl x1 x2 x3 s cd cs = wrapNX id (nd_C_trCOpDecl (wrapDX (wrapDX
  (wrapNX id)) (acceptCs (acceptCs id) (nd_OP_updCOpDecl_dot_op_dot_95 x2 x3
  x1))))

d_OP_updCOpDecl_dot_op_dot_95 :: (AbstractCurry.Curry_Types.C_CFixity -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CFixity) -> (Curry_Prelude.C_Int
  -> Cover -> ConstStore -> Curry_Prelude.C_Int) -> (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> AbstractCurry.Curry_Types.C_CFixity -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_COpDecl
d_OP_updCOpDecl_dot_op_dot_95 x1 x2 x3 x4 x5 x6 cd cs =
  AbstractCurry.Curry_Types.C_COp (Curry_Prelude.d_C_apply x3 x4 cd cs)
  (Curry_Prelude.d_C_apply x1 x5 cd cs) (Curry_Prelude.d_C_apply x2 x6 cd cs)

nd_OP_updCOpDecl_dot_op_dot_95 :: Func AbstractCurry.Curry_Types.C_CFixity
  AbstractCurry.Curry_Types.C_CFixity -> Func Curry_Prelude.C_Int
  Curry_Prelude.C_Int -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CFixity
  -> Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_COpDecl
nd_OP_updCOpDecl_dot_op_dot_95 x1 x2 x3 x4 x5 x6 s cd cs = let s3 = s
  in s3 `seq` (let s0 = leftSupply s3
                   s4 = rightSupply s3
                   s1 = leftSupply s4
                   s2 = rightSupply s4
  in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` AbstractCurry.Curry_Types.C_COp
  (Curry_Prelude.nd_C_apply x3 x4 s0 cd cs) (Curry_Prelude.nd_C_apply x1 x5 s1
  cd cs) (Curry_Prelude.nd_C_apply x2 x6 s2 cd cs)))))

d_C_updCOpName :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_COpDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_COpDecl
d_C_updCOpName x1 cd cs = d_C_updCOpDecl x1 Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id cd cs

nd_C_updCOpName :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Func AbstractCurry.Curry_Types.C_COpDecl
  AbstractCurry.Curry_Types.C_COpDecl
nd_C_updCOpName x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updCOpDecl x1 (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) s0 cd cs

d_C_trCFuncDecl :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CVisibility -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CRule -> Cover
  -> ConstStore -> t0) -> AbstractCurry.Curry_Types.C_CFuncDecl -> Cover
  -> ConstStore -> t0
d_C_trCFuncDecl x1 x2 cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CFunc x3 x4 x5 x6 x7 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x1 Curry_Prelude.OP_List
    cd cs) x3 cd cs) x4 cd cs) x5 cd cs) x6 cd cs) x7 cd cs
  AbstractCurry.Curry_Types.C_CmtFunc x8 x9 x10 x11 x12 x13 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x1 x8 cd cs) x9 cd cs) x10
    cd cs) x11 cd cs) x12 cd cs) x13 cd cs
  AbstractCurry.Curry_Types.Choice_C_CFuncDecl d i l r -> narrow d i
    (d_C_trCFuncDecl x1 l cd cs) (d_C_trCFuncDecl x1 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CFuncDecl d i xs -> narrows cs d i (\z ->
    d_C_trCFuncDecl x1 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CFuncDecl d c e -> guardCons d c ((\x ->
    d_C_trCFuncDecl x1 e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CFuncDecl d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCFuncDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCFuncDecl" (showCons
    x2))

nd_C_trCFuncDecl :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Func Curry_Prelude.C_Int (Func
  AbstractCurry.Curry_Types.C_CVisibility (Func
  AbstractCurry.Curry_Types.C_CQualTypeExpr (Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CRule) t0)))))
  -> AbstractCurry.Curry_Types.C_CFuncDecl -> IDSupply -> Cover -> ConstStore
  -> t0
nd_C_trCFuncDecl x1 x2 s cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CFunc x3 x4 x5 x6 x7 -> let s10 = s
    in s10 `seq` (let s9 = leftSupply s10
                      s8 = rightSupply s10
    in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (let s7 = leftSupply s8
                                                        s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                        s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    Curry_Prelude.OP_List s0 cd cs) x3 s1 cd cs)) x4 s3 cd cs)) x5 s5 cd cs)) x6
    s7 cd cs)) x7 s9 cd cs))
  AbstractCurry.Curry_Types.C_CmtFunc x8 x9 x10 x11 x12 x13 -> let s10 = s
    in s10 `seq` (let s9 = leftSupply s10
                      s8 = rightSupply s10
    in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (let s7 = leftSupply s8
                                                        s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                        s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x8 s0 cd cs) x9 s1 cd cs)) x10 s3 cd cs)) x11 s5 cd cs)) x12 s7 cd cs)) x13
    s9 cd cs))
  AbstractCurry.Curry_Types.Choice_C_CFuncDecl d i l r -> narrow d i
    (nd_C_trCFuncDecl x1 l s cd cs) (nd_C_trCFuncDecl x1 r s cd cs)
  AbstractCurry.Curry_Types.Choices_C_CFuncDecl d i xs -> narrows cs d i (\z ->
    nd_C_trCFuncDecl x1 z s cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CFuncDecl d c e -> guardCons d c ((\x ->
    nd_C_trCFuncDecl x1 e s cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CFuncDecl d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCFuncDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCFuncDecl" (showCons
    x2))

d_C_updCFuncDecl :: (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.C_Int)
  -> (AbstractCurry.Curry_Types.C_CVisibility -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CVisibility)
  -> (AbstractCurry.Curry_Types.C_CQualTypeExpr -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr) -> (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CRule -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CRule) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CFuncDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CFuncDecl
d_C_updCFuncDecl x1 x2 x3 x4 x5 x6 cd cs = d_C_trCFuncDecl (acceptCs (acceptCs
  (acceptCs (acceptCs (acceptCs id)))) (d_OP_updCFuncDecl_dot_func_dot_105 x5 x4
  x3 x6 x1 x2))

nd_C_updCFuncDecl :: Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Func
  Curry_Prelude.C_Int Curry_Prelude.C_Int -> Func
  AbstractCurry.Curry_Types.C_CVisibility
  AbstractCurry.Curry_Types.C_CVisibility -> Func
  AbstractCurry.Curry_Types.C_CQualTypeExpr
  AbstractCurry.Curry_Types.C_CQualTypeExpr -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CRule) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CRule) -> IDSupply -> Cover -> ConstStore -> Func
  AbstractCurry.Curry_Types.C_CFuncDecl AbstractCurry.Curry_Types.C_CFuncDecl
nd_C_updCFuncDecl x1 x2 x3 x4 x5 x6 s cd cs = wrapNX id (nd_C_trCFuncDecl
  (wrapDX (wrapDX (wrapDX (wrapDX (wrapDX (wrapNX id))))) (acceptCs (acceptCs
  (acceptCs (acceptCs (acceptCs id)))) (nd_OP_updCFuncDecl_dot_func_dot_105 x5
  x4 x3 x6 x1 x2))))

d_OP_updCFuncDecl_dot_func_dot_105 :: (AbstractCurry.Curry_Types.C_CQualTypeExpr
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CQualTypeExpr)
  -> (AbstractCurry.Curry_Types.C_CVisibility -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CVisibility) -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.C_Int) -> (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CRule -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CRule)
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> AbstractCurry.Curry_Types.C_CVisibility
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CRule -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CFuncDecl
d_OP_updCFuncDecl_dot_func_dot_105 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 cd cs =
  d_C__case_3 x7 x12 x4 x11 x1 x10 x2 x9 x3 x8 x6 x5 (Curry_Prelude.d_C_null x7
  cd cs) cd cs

nd_OP_updCFuncDecl_dot_func_dot_105 :: Func
  AbstractCurry.Curry_Types.C_CQualTypeExpr
  AbstractCurry.Curry_Types.C_CQualTypeExpr -> Func
  AbstractCurry.Curry_Types.C_CVisibility
  AbstractCurry.Curry_Types.C_CVisibility -> Func Curry_Prelude.C_Int
  Curry_Prelude.C_Int -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CRule) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CRule) -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> AbstractCurry.Curry_Types.C_CVisibility
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CRule -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CFuncDecl
nd_OP_updCFuncDecl_dot_func_dot_105 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 s cd cs =
  let s0 = s
  in s0 `seq` nd_C__case_3 x7 x12 x4 x11 x1 x10 x2 x9 x3 x8 x6 x5
  (Curry_Prelude.d_C_null x7 cd cs) s0 cd cs

d_C_trCRule :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CPattern -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CRhs -> Cover -> ConstStore -> t0)
  -> AbstractCurry.Curry_Types.C_CRule -> Cover -> ConstStore -> t0
d_C_trCRule x1 x2 cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CRule x3 x4 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x1 x3 cd cs) x4 cd cs
  AbstractCurry.Curry_Types.Choice_C_CRule d i l r -> narrow d i (d_C_trCRule x1
    l cd cs) (d_C_trCRule x1 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CRule d i xs -> narrows cs d i (\z ->
    d_C_trCRule x1 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CRule d c e -> guardCons d c ((\x ->
    d_C_trCRule x1 e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CRule d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCRule" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCRule" (showCons x2))

nd_C_trCRule :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CPattern) (Func
  AbstractCurry.Curry_Types.C_CRhs t0) -> AbstractCurry.Curry_Types.C_CRule
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_trCRule x1 x2 s cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CRule x3 x4 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x3 s0 cd cs) x4 s1 cd cs))
  AbstractCurry.Curry_Types.Choice_C_CRule d i l r -> narrow d i (nd_C_trCRule
    x1 l s cd cs) (nd_C_trCRule x1 r s cd cs)
  AbstractCurry.Curry_Types.Choices_C_CRule d i xs -> narrows cs d i (\z ->
    nd_C_trCRule x1 z s cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CRule d c e -> guardCons d c ((\x ->
    nd_C_trCRule x1 e s cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CRule d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCRule" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCRule" (showCons x2))

d_C_updCRule :: (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CPattern
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CPattern) -> (AbstractCurry.Curry_Types.C_CRhs
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CRhs) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CRule -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CRule
d_C_updCRule x1 x2 cd cs = d_C_trCRule (acceptCs id
  (d_OP_updCRule_dot_rule_dot_111 x2 x1))

nd_C_updCRule :: Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CPattern) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CPattern) -> Func AbstractCurry.Curry_Types.C_CRhs
  AbstractCurry.Curry_Types.C_CRhs -> IDSupply -> Cover -> ConstStore -> Func
  AbstractCurry.Curry_Types.C_CRule AbstractCurry.Curry_Types.C_CRule
nd_C_updCRule x1 x2 s cd cs = wrapNX id (nd_C_trCRule (wrapDX (wrapNX id)
  (acceptCs id (nd_OP_updCRule_dot_rule_dot_111 x2 x1))))

d_OP_updCRule_dot_rule_dot_111 :: (AbstractCurry.Curry_Types.C_CRhs -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CRhs) -> (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CPattern -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CPattern)
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CPattern
  -> AbstractCurry.Curry_Types.C_CRhs -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CRule
d_OP_updCRule_dot_rule_dot_111 x1 x2 x3 x4 cd cs =
  AbstractCurry.Curry_Types.C_CRule (Curry_Prelude.d_C_apply x2 x3 cd cs)
  (Curry_Prelude.d_C_apply x1 x4 cd cs)

nd_OP_updCRule_dot_rule_dot_111 :: Func AbstractCurry.Curry_Types.C_CRhs
  AbstractCurry.Curry_Types.C_CRhs -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CPattern) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CPattern) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CPattern -> AbstractCurry.Curry_Types.C_CRhs
  -> IDSupply -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CRule
nd_OP_updCRule_dot_rule_dot_111 x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` AbstractCurry.Curry_Types.C_CRule
  (Curry_Prelude.nd_C_apply x2 x3 s0 cd cs) (Curry_Prelude.nd_C_apply x1 x4 s1
  cd cs)))

d_C_trCRhs :: forall t0 . (Curry_Prelude.Curry
  t0) => (AbstractCurry.Curry_Types.C_CExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl -> Cover
  -> ConstStore -> t0) -> (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CExpr AbstractCurry.Curry_Types.C_CExpr) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl
  -> Cover -> ConstStore -> t0) -> AbstractCurry.Curry_Types.C_CRhs -> Cover
  -> ConstStore -> t0
d_C_trCRhs x1 x2 x3 cd cs = case x3 of
  AbstractCurry.Curry_Types.C_CSimpleRhs x4 x5 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x1 x4 cd cs) x5 cd cs
  AbstractCurry.Curry_Types.C_CGuardedRhs x6 x7 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x2 x6 cd cs) x7 cd cs
  AbstractCurry.Curry_Types.Choice_C_CRhs d i l r -> narrow d i (d_C_trCRhs x1
    x2 l cd cs) (d_C_trCRhs x1 x2 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CRhs d i xs -> narrows cs d i (\z ->
    d_C_trCRhs x1 x2 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CRhs d c e -> guardCons d c ((\x ->
    d_C_trCRhs x1 x2 e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CRhs d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCRhs" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCRhs" (showCons x3))

nd_C_trCRhs :: forall t0 . (Curry_Prelude.Curry t0) => Func
  AbstractCurry.Curry_Types.C_CExpr (Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CLocalDecl) t0) -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 AbstractCurry.Curry_Types.C_CExpr
  AbstractCurry.Curry_Types.C_CExpr)) (Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CLocalDecl) t0)
  -> AbstractCurry.Curry_Types.C_CRhs -> IDSupply -> Cover -> ConstStore -> t0
nd_C_trCRhs x1 x2 x3 s cd cs = case x3 of
  AbstractCurry.Curry_Types.C_CSimpleRhs x4 x5 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x4 s0 cd cs) x5 s1 cd cs))
  AbstractCurry.Curry_Types.C_CGuardedRhs x6 x7 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2
    x6 s0 cd cs) x7 s1 cd cs))
  AbstractCurry.Curry_Types.Choice_C_CRhs d i l r -> narrow d i (nd_C_trCRhs x1
    x2 l s cd cs) (nd_C_trCRhs x1 x2 r s cd cs)
  AbstractCurry.Curry_Types.Choices_C_CRhs d i xs -> narrows cs d i (\z ->
    nd_C_trCRhs x1 x2 z s cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CRhs d c e -> guardCons d c ((\x ->
    nd_C_trCRhs x1 x2 e s cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CRhs d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCRhs" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCRhs" (showCons x3))

d_C_updCRhs :: (AbstractCurry.Curry_Types.C_CExpr -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CExpr) -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 AbstractCurry.Curry_Types.C_CExpr
  AbstractCurry.Curry_Types.C_CExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CExpr AbstractCurry.Curry_Types.C_CExpr))
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl)
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CRhs -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CRhs
d_C_updCRhs x1 x2 x3 cd cs = d_C_trCRhs (acceptCs id
  (d_OP_updCRhs_dot_srhs_dot_121 x1 x3)) (acceptCs id
  (d_OP_updCRhs_dot_grhs_dot_121 x3 x2))

nd_C_updCRhs :: Func AbstractCurry.Curry_Types.C_CExpr
  AbstractCurry.Curry_Types.C_CExpr -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 AbstractCurry.Curry_Types.C_CExpr
  AbstractCurry.Curry_Types.C_CExpr)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 AbstractCurry.Curry_Types.C_CExpr
  AbstractCurry.Curry_Types.C_CExpr)) -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CLocalDecl) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CLocalDecl) -> IDSupply -> Cover -> ConstStore
  -> Func AbstractCurry.Curry_Types.C_CRhs AbstractCurry.Curry_Types.C_CRhs
nd_C_updCRhs x1 x2 x3 s cd cs = wrapNX id (nd_C_trCRhs (wrapDX (wrapNX id)
  (acceptCs id (nd_OP_updCRhs_dot_srhs_dot_121 x1 x3))) (wrapDX (wrapNX id)
  (acceptCs id (nd_OP_updCRhs_dot_grhs_dot_121 x3 x2))))

d_OP_updCRhs_dot_srhs_dot_121 :: (AbstractCurry.Curry_Types.C_CExpr -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CExpr) -> (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CLocalDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl)
  -> AbstractCurry.Curry_Types.C_CExpr -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CLocalDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CRhs
d_OP_updCRhs_dot_srhs_dot_121 x1 x2 x3 x4 cd cs =
  AbstractCurry.Curry_Types.C_CSimpleRhs (Curry_Prelude.d_C_apply x1 x3 cd cs)
  (Curry_Prelude.d_C_apply x2 x4 cd cs)

nd_OP_updCRhs_dot_srhs_dot_121 :: Func AbstractCurry.Curry_Types.C_CExpr
  AbstractCurry.Curry_Types.C_CExpr -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CLocalDecl) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CLocalDecl) -> AbstractCurry.Curry_Types.C_CExpr
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl -> IDSupply
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CRhs
nd_OP_updCRhs_dot_srhs_dot_121 x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` AbstractCurry.Curry_Types.C_CSimpleRhs
  (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs) (Curry_Prelude.nd_C_apply x2 x4 s1
  cd cs)))

d_OP_updCRhs_dot_grhs_dot_121 :: (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CLocalDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl)
  -> (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CExpr AbstractCurry.Curry_Types.C_CExpr) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CExpr AbstractCurry.Curry_Types.C_CExpr))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CExpr AbstractCurry.Curry_Types.C_CExpr)
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CRhs
d_OP_updCRhs_dot_grhs_dot_121 x1 x2 x3 x4 cd cs =
  AbstractCurry.Curry_Types.C_CGuardedRhs (Curry_Prelude.d_C_apply x2 x3 cd cs)
  (Curry_Prelude.d_C_apply x1 x4 cd cs)

nd_OP_updCRhs_dot_grhs_dot_121 :: Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CLocalDecl) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CLocalDecl) -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 AbstractCurry.Curry_Types.C_CExpr
  AbstractCurry.Curry_Types.C_CExpr)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 AbstractCurry.Curry_Types.C_CExpr
  AbstractCurry.Curry_Types.C_CExpr)) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 AbstractCurry.Curry_Types.C_CExpr
  AbstractCurry.Curry_Types.C_CExpr) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CLocalDecl -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CRhs
nd_OP_updCRhs_dot_grhs_dot_121 x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` AbstractCurry.Curry_Types.C_CGuardedRhs
  (Curry_Prelude.nd_C_apply x2 x3 s0 cd cs) (Curry_Prelude.nd_C_apply x1 x4 s1
  cd cs)))

d_C_trCLocalDecl :: forall t0 . (Curry_Prelude.Curry
  t0) => (AbstractCurry.Curry_Types.C_CFuncDecl -> Cover -> ConstStore -> t0)
  -> (AbstractCurry.Curry_Types.C_CPattern -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CRhs -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore -> t0)
  -> AbstractCurry.Curry_Types.C_CLocalDecl -> Cover -> ConstStore -> t0
d_C_trCLocalDecl x1 x2 x3 x4 cd cs = case x4 of
  AbstractCurry.Curry_Types.C_CLocalFunc x5 -> Curry_Prelude.d_C_apply x1 x5 cd
    cs
  AbstractCurry.Curry_Types.C_CLocalPat x6 x7 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x2 x6 cd cs) x7 cd cs
  AbstractCurry.Curry_Types.C_CLocalVars x8 -> Curry_Prelude.d_C_apply x3 x8 cd
    cs
  AbstractCurry.Curry_Types.Choice_C_CLocalDecl d i l r -> narrow d i
    (d_C_trCLocalDecl x1 x2 x3 l cd cs) (d_C_trCLocalDecl x1 x2 x3 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CLocalDecl d i xs -> narrows cs d i (\z ->
    d_C_trCLocalDecl x1 x2 x3 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CLocalDecl d c e -> guardCons d c ((\x ->
    d_C_trCLocalDecl x1 x2 x3 e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CLocalDecl d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCLocalDecl" [show x1, show x2, show x3, show x4]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCLocalDecl" (showCons
    x4))

nd_C_trCLocalDecl :: forall t0 . (Curry_Prelude.Curry t0) => Func
  AbstractCurry.Curry_Types.C_CFuncDecl t0 -> Func
  AbstractCurry.Curry_Types.C_CPattern (Func AbstractCurry.Curry_Types.C_CRhs
  t0) -> Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))) t0
  -> AbstractCurry.Curry_Types.C_CLocalDecl -> IDSupply -> Cover -> ConstStore
  -> t0
nd_C_trCLocalDecl x1 x2 x3 x4 s cd cs = case x4 of
  AbstractCurry.Curry_Types.C_CLocalFunc x5 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x1 x5 s0 cd cs
  AbstractCurry.Curry_Types.C_CLocalPat x6 x7 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2
    x6 s0 cd cs) x7 s1 cd cs))
  AbstractCurry.Curry_Types.C_CLocalVars x8 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x3 x8 s0 cd cs
  AbstractCurry.Curry_Types.Choice_C_CLocalDecl d i l r -> narrow d i
    (nd_C_trCLocalDecl x1 x2 x3 l s cd cs) (nd_C_trCLocalDecl x1 x2 x3 r s cd
    cs)
  AbstractCurry.Curry_Types.Choices_C_CLocalDecl d i xs -> narrows cs d i (\z ->
    nd_C_trCLocalDecl x1 x2 x3 z s cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CLocalDecl d c e -> guardCons d c ((\x ->
    nd_C_trCLocalDecl x1 x2 x3 e s cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CLocalDecl d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCLocalDecl" [show x1, show x2, show x3, show x4]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCLocalDecl" (showCons
    x4))

d_C_updCLocalDecl :: (AbstractCurry.Curry_Types.C_CFuncDecl -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CFuncDecl)
  -> (AbstractCurry.Curry_Types.C_CPattern -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CPattern) -> (AbstractCurry.Curry_Types.C_CRhs
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CRhs)
  -> (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CLocalDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CLocalDecl
d_C_updCLocalDecl x1 x2 x3 x4 cd cs = d_C_trCLocalDecl
  (d_OP_updCLocalDecl_dot_lfun_dot_139 x1) (acceptCs id
  (d_OP_updCLocalDecl_dot_lpat_dot_139 x2 x3))
  (d_OP_updCLocalDecl_dot_lvars_dot_139 x4)

nd_C_updCLocalDecl :: Func AbstractCurry.Curry_Types.C_CFuncDecl
  AbstractCurry.Curry_Types.C_CFuncDecl -> Func
  AbstractCurry.Curry_Types.C_CPattern AbstractCurry.Curry_Types.C_CPattern
  -> Func AbstractCurry.Curry_Types.C_CRhs AbstractCurry.Curry_Types.C_CRhs
  -> Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> IDSupply -> Cover -> ConstStore -> Func
  AbstractCurry.Curry_Types.C_CLocalDecl AbstractCurry.Curry_Types.C_CLocalDecl
nd_C_updCLocalDecl x1 x2 x3 x4 s cd cs = wrapNX id (nd_C_trCLocalDecl (wrapNX id
  (nd_OP_updCLocalDecl_dot_lfun_dot_139 x1)) (wrapDX (wrapNX id) (acceptCs id
  (nd_OP_updCLocalDecl_dot_lpat_dot_139 x2 x3))) (wrapNX id
  (nd_OP_updCLocalDecl_dot_lvars_dot_139 x4)))

d_OP_updCLocalDecl_dot_lfun_dot_139 :: (AbstractCurry.Curry_Types.C_CFuncDecl
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CFuncDecl)
  -> AbstractCurry.Curry_Types.C_CFuncDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CLocalDecl
d_OP_updCLocalDecl_dot_lfun_dot_139 x1 x2 cd cs =
  AbstractCurry.Curry_Types.C_CLocalFunc (Curry_Prelude.d_C_apply x1 x2 cd cs)

nd_OP_updCLocalDecl_dot_lfun_dot_139 :: Func
  AbstractCurry.Curry_Types.C_CFuncDecl AbstractCurry.Curry_Types.C_CFuncDecl
  -> AbstractCurry.Curry_Types.C_CFuncDecl -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CLocalDecl
nd_OP_updCLocalDecl_dot_lfun_dot_139 x1 x2 s cd cs = let s0 = s
  in s0 `seq` AbstractCurry.Curry_Types.C_CLocalFunc (Curry_Prelude.nd_C_apply
  x1 x2 s0 cd cs)

d_OP_updCLocalDecl_dot_lpat_dot_139 :: (AbstractCurry.Curry_Types.C_CPattern
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CPattern)
  -> (AbstractCurry.Curry_Types.C_CRhs -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CRhs) -> AbstractCurry.Curry_Types.C_CPattern
  -> AbstractCurry.Curry_Types.C_CRhs -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CLocalDecl
d_OP_updCLocalDecl_dot_lpat_dot_139 x1 x2 x3 x4 cd cs =
  AbstractCurry.Curry_Types.C_CLocalPat (Curry_Prelude.d_C_apply x1 x3 cd cs)
  (Curry_Prelude.d_C_apply x2 x4 cd cs)

nd_OP_updCLocalDecl_dot_lpat_dot_139 :: Func
  AbstractCurry.Curry_Types.C_CPattern AbstractCurry.Curry_Types.C_CPattern
  -> Func AbstractCurry.Curry_Types.C_CRhs AbstractCurry.Curry_Types.C_CRhs
  -> AbstractCurry.Curry_Types.C_CPattern -> AbstractCurry.Curry_Types.C_CRhs
  -> IDSupply -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CLocalDecl
nd_OP_updCLocalDecl_dot_lpat_dot_139 x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` AbstractCurry.Curry_Types.C_CLocalPat
  (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs) (Curry_Prelude.nd_C_apply x2 x4 s1
  cd cs)))

d_OP_updCLocalDecl_dot_lvars_dot_139 :: (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CLocalDecl
d_OP_updCLocalDecl_dot_lvars_dot_139 x1 x2 cd cs =
  AbstractCurry.Curry_Types.C_CLocalVars (Curry_Prelude.d_C_apply x1 x2 cd cs)

nd_OP_updCLocalDecl_dot_lvars_dot_139 :: Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CLocalDecl
nd_OP_updCLocalDecl_dot_lvars_dot_139 x1 x2 s cd cs = let s0 = s
  in s0 `seq` AbstractCurry.Curry_Types.C_CLocalVars (Curry_Prelude.nd_C_apply
  x1 x2 s0 cd cs)

d_C_trCPattern :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> t0)
  -> (AbstractCurry.Curry_Types.C_CLiteral -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> t0) -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0) -> Cover -> ConstStore -> t0)
  -> AbstractCurry.Curry_Types.C_CPattern -> Cover -> ConstStore -> t0
d_C_trCPattern x1 x2 x3 x4 x5 x6 x7 cd cs = d_OP_trCPattern_dot_trP_dot_147 x2
  x1 x4 x3 x5 x6 x7 cd cs

nd_C_trCPattern :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0 -> Func AbstractCurry.Curry_Types.C_CLiteral t0
  -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func (Curry_Prelude.OP_List t0)
  t0) -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func t0 t0) -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func (Curry_Prelude.OP_List t0)
  t0) -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0)) t0) -> AbstractCurry.Curry_Types.C_CPattern
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_trCPattern x1 x2 x3 x4 x5 x6 x7 s cd cs = let s0 = s
  in s0 `seq` nd_OP_trCPattern_dot_trP_dot_147 x2 x1 x4 x3 x5 x6 x7 s0 cd cs

d_OP_trCPattern_dot_trP_dot_147 :: forall t0 . (Curry_Prelude.Curry
  t0) => (AbstractCurry.Curry_Types.C_CLiteral -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> t0) -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0) -> Cover -> ConstStore -> t0)
  -> AbstractCurry.Curry_Types.C_CPattern -> Cover -> ConstStore -> t0
d_OP_trCPattern_dot_trP_dot_147 x1 x2 x3 x4 x5 x6 x7 cd cs = case x7 of
  AbstractCurry.Curry_Types.C_CPVar x8 -> Curry_Prelude.d_C_apply x2 x8 cd cs
  AbstractCurry.Curry_Types.C_CPLit x9 -> Curry_Prelude.d_C_apply x1 x9 cd cs
  AbstractCurry.Curry_Types.C_CPComb x10 x11 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x4 x10 cd cs) (Curry_Prelude.d_C_map
    (d_OP_trCPattern_dot_trP_dot_147 x1 x2 x3 x4 x5 x6) x11 cd cs) cd cs
  AbstractCurry.Curry_Types.C_CPAs x12 x13 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x3 x12 cd cs) (d_OP_trCPattern_dot_trP_dot_147 x1
    x2 x3 x4 x5 x6 x13 cd cs) cd cs
  AbstractCurry.Curry_Types.C_CPFuncComb x14 x15 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x5 x14 cd cs) (Curry_Prelude.d_C_map
    (d_OP_trCPattern_dot_trP_dot_147 x1 x2 x3 x4 x5 x6) x15 cd cs) cd cs
  AbstractCurry.Curry_Types.C_CPLazy x16 -> d_OP_trCPattern_dot_trP_dot_147 x1
    x2 x3 x4 x5 x6 x16 cd cs
  AbstractCurry.Curry_Types.C_CPRecord x17 x18 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x6 x17 cd cs) (Curry_Prelude.d_C_map
    (d_OP_trCPattern_dot_trP_dot_147_dot_uscore_hash_lambda4 x1 x2 x3 x4 x5 x6)
    x18 cd cs) cd cs
  AbstractCurry.Curry_Types.Choice_C_CPattern d i l r -> narrow d i
    (d_OP_trCPattern_dot_trP_dot_147 x1 x2 x3 x4 x5 x6 l cd cs)
    (d_OP_trCPattern_dot_trP_dot_147 x1 x2 x3 x4 x5 x6 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CPattern d i xs -> narrows cs d i (\z ->
    d_OP_trCPattern_dot_trP_dot_147 x1 x2 x3 x4 x5 x6 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CPattern d c e -> guardCons d c ((\x ->
    d_OP_trCPattern_dot_trP_dot_147 x1 x2 x3 x4 x5 x6 e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CPattern d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCPattern.trP.147" [show x1, show x2, show x3
    , show x4, show x5, show x6, show x7] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCPattern.trP.147"
    (showCons x7))

nd_OP_trCPattern_dot_trP_dot_147 :: forall t0 . (Curry_Prelude.Curry t0) => Func
  AbstractCurry.Curry_Types.C_CLiteral t0 -> Func (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0 -> Func
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Func t0 t0) -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Func (Curry_Prelude.OP_List t0) t0) -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func (Curry_Prelude.OP_List t0)
  t0) -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0)) t0) -> AbstractCurry.Curry_Types.C_CPattern
  -> IDSupply -> Cover -> ConstStore -> t0
nd_OP_trCPattern_dot_trP_dot_147 x1 x2 x3 x4 x5 x6 x7 s cd cs = case x7 of
  AbstractCurry.Curry_Types.C_CPVar x8 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x2 x8 s0 cd cs
  AbstractCurry.Curry_Types.C_CPLit x9 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x1 x9 s0 cd cs
  AbstractCurry.Curry_Types.C_CPComb x10 x11 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_apply x4 x10 s0 cd cs) (Curry_Prelude.nd_C_map (wrapNX
    id (nd_OP_trCPattern_dot_trP_dot_147 x1 x2 x3 x4 x5 x6)) x11 s1 cd cs) s2 cd
    cs))))
  AbstractCurry.Curry_Types.C_CPAs x12 x13 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_apply x3 x12 s0 cd cs) (nd_OP_trCPattern_dot_trP_dot_147
    x1 x2 x3 x4 x5 x6 x13 s1 cd cs) s2 cd cs))))
  AbstractCurry.Curry_Types.C_CPFuncComb x14 x15 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_apply x5 x14 s0 cd cs) (Curry_Prelude.nd_C_map (wrapNX
    id (nd_OP_trCPattern_dot_trP_dot_147 x1 x2 x3 x4 x5 x6)) x15 s1 cd cs) s2 cd
    cs))))
  AbstractCurry.Curry_Types.C_CPLazy x16 -> let s0 = s
    in s0 `seq` nd_OP_trCPattern_dot_trP_dot_147 x1 x2 x3 x4 x5 x6 x16 s0 cd cs
  AbstractCurry.Curry_Types.C_CPRecord x17 x18 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_apply x6 x17 s0 cd cs) (Curry_Prelude.nd_C_map (wrapNX
    id (nd_OP_trCPattern_dot_trP_dot_147_dot_uscore_hash_lambda4 x1 x2 x3 x4 x5
    x6)) x18 s1 cd cs) s2 cd cs))))
  AbstractCurry.Curry_Types.Choice_C_CPattern d i l r -> narrow d i
    (nd_OP_trCPattern_dot_trP_dot_147 x1 x2 x3 x4 x5 x6 l s cd cs)
    (nd_OP_trCPattern_dot_trP_dot_147 x1 x2 x3 x4 x5 x6 r s cd cs)
  AbstractCurry.Curry_Types.Choices_C_CPattern d i xs -> narrows cs d i (\z ->
    nd_OP_trCPattern_dot_trP_dot_147 x1 x2 x3 x4 x5 x6 z s cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CPattern d c e -> guardCons d c ((\x ->
    nd_OP_trCPattern_dot_trP_dot_147 x1 x2 x3 x4 x5 x6 e s cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CPattern d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCPattern.trP.147" [show x1, show x2, show x3
    , show x4, show x5, show x6, show x7] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCPattern.trP.147"
    (showCons x7))

d_OP_trCPattern_dot_trP_dot_147_dot_uscore_hash_lambda4 :: forall t0 . (Curry_Prelude.Curry
  t0) => (AbstractCurry.Curry_Types.C_CLiteral -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> t0) -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0) -> Cover -> ConstStore -> t0)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  AbstractCurry.Curry_Types.C_CPattern -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0
d_OP_trCPattern_dot_trP_dot_147_dot_uscore_hash_lambda4 x1 x2 x3 x4 x5 x6 x7 cd cs =
  case x7 of
  Curry_Prelude.OP_Tuple2 x8 x9 -> Curry_Prelude.OP_Tuple2 x8
    (d_OP_trCPattern_dot_trP_dot_147 x1 x2 x3 x4 x5 x6 x9 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_trCPattern_dot_trP_dot_147_dot_uscore_hash_lambda4 x1 x2 x3 x4 x5 x6 l
    cd cs) (d_OP_trCPattern_dot_trP_dot_147_dot_uscore_hash_lambda4 x1 x2 x3 x4
    x5 x6 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_trCPattern_dot_trP_dot_147_dot_uscore_hash_lambda4 x1 x2 x3 x4 x5 x6 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_trCPattern_dot_trP_dot_147_dot_uscore_hash_lambda4 x1 x2 x3 x4 x5 x6 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCPattern.trP.147._#lambda4" [show x1, show x2
    , show x3, show x4, show x5, show x6, show x7] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Transform.trCPattern.trP.147._#lambda4" (showCons x7))

nd_OP_trCPattern_dot_trP_dot_147_dot_uscore_hash_lambda4 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func AbstractCurry.Curry_Types.C_CLiteral t0 -> Func
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0 -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func t0 t0) -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func (Curry_Prelude.OP_List t0)
  t0) -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func
  (Curry_Prelude.OP_List t0) t0) -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0)) t0)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  AbstractCurry.Curry_Types.C_CPattern -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0
nd_OP_trCPattern_dot_trP_dot_147_dot_uscore_hash_lambda4 x1 x2 x3 x4 x5 x6 x7 s cd cs =
  case x7 of
  Curry_Prelude.OP_Tuple2 x8 x9 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 x8 (nd_OP_trCPattern_dot_trP_dot_147 x1
    x2 x3 x4 x5 x6 x9 s0 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_trCPattern_dot_trP_dot_147_dot_uscore_hash_lambda4 x1 x2 x3 x4 x5 x6
    l s cd cs) (nd_OP_trCPattern_dot_trP_dot_147_dot_uscore_hash_lambda4 x1 x2
    x3 x4 x5 x6 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_trCPattern_dot_trP_dot_147_dot_uscore_hash_lambda4 x1 x2 x3 x4 x5 x6 z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_trCPattern_dot_trP_dot_147_dot_uscore_hash_lambda4 x1 x2 x3 x4 x5 x6 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCPattern.trP.147._#lambda4" [show x1, show x2
    , show x3, show x4, show x5, show x6, show x7] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Transform.trCPattern.trP.147._#lambda4" (showCons x7))

d_C_updCPattern :: (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> (AbstractCurry.Curry_Types.C_CLiteral -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CLiteral)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CPattern -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CPattern
d_C_updCPattern x1 x2 x3 cd cs = d_C_trCPattern
  (d_OP_updCPattern_dot_pvar_dot_164 x1) (d_OP_updCPattern_dot_plit_dot_164 x2)
  (acceptCs id (d_OP_updCPattern_dot_pcomb_dot_164 x2 x1 x3)) (acceptCs id
  (d_OP_updCPattern_dot_pas_dot_164 x2 x1 x3)) (acceptCs id
  (d_OP_updCPattern_dot_pfcomb_dot_164 x2 x1 x3)) (acceptCs id
  (d_OP_updCPattern_dot_prec_dot_164 x2 x1 x3))

nd_C_updCPattern :: Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Func
  AbstractCurry.Curry_Types.C_CLiteral AbstractCurry.Curry_Types.C_CLiteral
  -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore -> Func
  AbstractCurry.Curry_Types.C_CPattern AbstractCurry.Curry_Types.C_CPattern
nd_C_updCPattern x1 x2 x3 s cd cs = wrapNX id (nd_C_trCPattern (wrapNX id
  (nd_OP_updCPattern_dot_pvar_dot_164 x1)) (wrapNX id
  (nd_OP_updCPattern_dot_plit_dot_164 x2)) (wrapDX (wrapNX id) (acceptCs id
  (nd_OP_updCPattern_dot_pcomb_dot_164 x2 x1 x3))) (wrapDX (wrapNX id) (acceptCs
  id (nd_OP_updCPattern_dot_pas_dot_164 x2 x1 x3))) (wrapDX (wrapNX id)
  (acceptCs id (nd_OP_updCPattern_dot_pfcomb_dot_164 x2 x1 x3))) (wrapDX (wrapNX
  id) (acceptCs id (nd_OP_updCPattern_dot_prec_dot_164 x2 x1 x3))))

d_OP_updCPattern_dot_pvar_dot_164 :: (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CPattern
d_OP_updCPattern_dot_pvar_dot_164 x1 x2 cd cs =
  AbstractCurry.Curry_Types.C_CPVar (Curry_Prelude.d_C_apply x1 x2 cd cs)

nd_OP_updCPattern_dot_pvar_dot_164 :: Func (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CPattern
nd_OP_updCPattern_dot_pvar_dot_164 x1 x2 s cd cs = let s0 = s
  in s0 `seq` AbstractCurry.Curry_Types.C_CPVar (Curry_Prelude.nd_C_apply x1 x2
  s0 cd cs)

d_OP_updCPattern_dot_plit_dot_164 :: (AbstractCurry.Curry_Types.C_CLiteral
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CLiteral)
  -> AbstractCurry.Curry_Types.C_CLiteral -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CPattern
d_OP_updCPattern_dot_plit_dot_164 x1 x2 cd cs =
  AbstractCurry.Curry_Types.C_CPLit (Curry_Prelude.d_C_apply x1 x2 cd cs)

nd_OP_updCPattern_dot_plit_dot_164 :: Func AbstractCurry.Curry_Types.C_CLiteral
  AbstractCurry.Curry_Types.C_CLiteral -> AbstractCurry.Curry_Types.C_CLiteral
  -> IDSupply -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CPattern
nd_OP_updCPattern_dot_plit_dot_164 x1 x2 s cd cs = let s0 = s
  in s0 `seq` AbstractCurry.Curry_Types.C_CPLit (Curry_Prelude.nd_C_apply x1 x2
  s0 cd cs)

d_OP_updCPattern_dot_pcomb_dot_164 :: (AbstractCurry.Curry_Types.C_CLiteral
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CLiteral)
  -> (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CPattern -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CPattern
d_OP_updCPattern_dot_pcomb_dot_164 x1 x2 x3 x4 x5 cd cs =
  AbstractCurry.Curry_Types.C_CPComb (Curry_Prelude.d_C_apply x3 x4 cd cs)
  (Curry_Prelude.d_C_map (d_C_updCPattern x2 x1 x3 cd cs) x5 cd cs)

nd_OP_updCPattern_dot_pcomb_dot_164 :: Func AbstractCurry.Curry_Types.C_CLiteral
  AbstractCurry.Curry_Types.C_CLiteral -> Func (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CPattern -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CPattern
nd_OP_updCPattern_dot_pcomb_dot_164 x1 x2 x3 x4 x5 s cd cs = let s4 = s
  in s4 `seq` (let s0 = leftSupply s4
                   s3 = rightSupply s4
  in s0 `seq` (s3 `seq` AbstractCurry.Curry_Types.C_CPComb
  (Curry_Prelude.nd_C_apply x3 x4 s0 cd cs) (let s2 = leftSupply s3
                                                 s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_map (nd_C_updCPattern x2 x1 x3 s1 cd
  cs) x5 s2 cd cs))))

d_OP_updCPattern_dot_pas_dot_164 :: (AbstractCurry.Curry_Types.C_CLiteral
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CLiteral)
  -> (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> AbstractCurry.Curry_Types.C_CPattern -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CPattern
d_OP_updCPattern_dot_pas_dot_164 x1 x2 x3 x4 x5 cd cs =
  AbstractCurry.Curry_Types.C_CPAs (Curry_Prelude.d_C_apply x2 x4 cd cs)
  (Curry_Prelude.d_C_apply (d_C_updCPattern x2 x1 x3 cd cs) x5 cd cs)

nd_OP_updCPattern_dot_pas_dot_164 :: Func AbstractCurry.Curry_Types.C_CLiteral
  AbstractCurry.Curry_Types.C_CLiteral -> Func (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> AbstractCurry.Curry_Types.C_CPattern -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CPattern
nd_OP_updCPattern_dot_pas_dot_164 x1 x2 x3 x4 x5 s cd cs = let s4 = s
  in s4 `seq` (let s0 = leftSupply s4
                   s3 = rightSupply s4
  in s0 `seq` (s3 `seq` AbstractCurry.Curry_Types.C_CPAs
  (Curry_Prelude.nd_C_apply x2 x4 s0 cd cs) (let s2 = leftSupply s3
                                                 s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (nd_C_updCPattern x2 x1 x3 s1
  cd cs) x5 s2 cd cs))))

d_OP_updCPattern_dot_pfcomb_dot_164 :: (AbstractCurry.Curry_Types.C_CLiteral
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CLiteral)
  -> (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CPattern -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CPattern
d_OP_updCPattern_dot_pfcomb_dot_164 x1 x2 x3 x4 x5 cd cs =
  AbstractCurry.Curry_Types.C_CPFuncComb (Curry_Prelude.d_C_apply x3 x4 cd cs)
  (Curry_Prelude.d_C_map (d_C_updCPattern x2 x1 x3 cd cs) x5 cd cs)

nd_OP_updCPattern_dot_pfcomb_dot_164 :: Func
  AbstractCurry.Curry_Types.C_CLiteral AbstractCurry.Curry_Types.C_CLiteral
  -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CPattern -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CPattern
nd_OP_updCPattern_dot_pfcomb_dot_164 x1 x2 x3 x4 x5 s cd cs = let s4 = s
  in s4 `seq` (let s0 = leftSupply s4
                   s3 = rightSupply s4
  in s0 `seq` (s3 `seq` AbstractCurry.Curry_Types.C_CPFuncComb
  (Curry_Prelude.nd_C_apply x3 x4 s0 cd cs) (let s2 = leftSupply s3
                                                 s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_map (nd_C_updCPattern x2 x1 x3 s1 cd
  cs) x5 s2 cd cs))))

d_OP_updCPattern_dot_prec_dot_164 :: (AbstractCurry.Curry_Types.C_CLiteral
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CLiteral)
  -> (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  AbstractCurry.Curry_Types.C_CPattern) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CPattern
d_OP_updCPattern_dot_prec_dot_164 x1 x2 x3 x4 x5 cd cs =
  AbstractCurry.Curry_Types.C_CPRecord (Curry_Prelude.d_C_apply x3 x4 cd cs)
  (Curry_Prelude.d_C_map
  (d_OP_updCPattern_dot_prec_dot_164_dot_uscore_hash_lambda5 x1 x2 x3) x5 cd cs)

nd_OP_updCPattern_dot_prec_dot_164 :: Func AbstractCurry.Curry_Types.C_CLiteral
  AbstractCurry.Curry_Types.C_CLiteral -> Func (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  AbstractCurry.Curry_Types.C_CPattern) -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CPattern
nd_OP_updCPattern_dot_prec_dot_164 x1 x2 x3 x4 x5 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` AbstractCurry.Curry_Types.C_CPRecord
  (Curry_Prelude.nd_C_apply x3 x4 s0 cd cs) (Curry_Prelude.nd_C_map (wrapNX id
  (nd_OP_updCPattern_dot_prec_dot_164_dot_uscore_hash_lambda5 x1 x2 x3)) x5 s1
  cd cs)))

d_OP_updCPattern_dot_prec_dot_164_dot_uscore_hash_lambda5 :: (AbstractCurry.Curry_Types.C_CLiteral
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CLiteral)
  -> (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  AbstractCurry.Curry_Types.C_CPattern -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  AbstractCurry.Curry_Types.C_CPattern
d_OP_updCPattern_dot_prec_dot_164_dot_uscore_hash_lambda5 x1 x2 x3 x4 cd cs =
  case x4 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_C_apply x3 x5 cd cs) (Curry_Prelude.d_C_apply
    (d_C_updCPattern x2 x1 x3 cd cs) x6 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_updCPattern_dot_prec_dot_164_dot_uscore_hash_lambda5 x1 x2 x3 l cd cs)
    (d_OP_updCPattern_dot_prec_dot_164_dot_uscore_hash_lambda5 x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_updCPattern_dot_prec_dot_164_dot_uscore_hash_lambda5 x1 x2 x3 z cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_updCPattern_dot_prec_dot_164_dot_uscore_hash_lambda5 x1 x2 x3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.updCPattern.prec.164._#lambda5" [show x1, show x2
    , show x3, show x4] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Transform.updCPattern.prec.164._#lambda5" (showCons x4))

nd_OP_updCPattern_dot_prec_dot_164_dot_uscore_hash_lambda5 :: Func
  AbstractCurry.Curry_Types.C_CLiteral AbstractCurry.Curry_Types.C_CLiteral
  -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  AbstractCurry.Curry_Types.C_CPattern -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  AbstractCurry.Curry_Types.C_CPattern
nd_OP_updCPattern_dot_prec_dot_164_dot_uscore_hash_lambda5 x1 x2 x3 x4 s cd cs =
  case x4 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> let s4 = s
    in s4 `seq` (let s0 = leftSupply s4
                     s3 = rightSupply s4
    in s0 `seq` (s3 `seq` Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_apply x3
    x5 s0 cd cs) (let s2 = leftSupply s3
                      s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (nd_C_updCPattern x2 x1 x3 s1
    cd cs) x6 s2 cd cs))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_updCPattern_dot_prec_dot_164_dot_uscore_hash_lambda5 x1 x2 x3 l s cd
    cs) (nd_OP_updCPattern_dot_prec_dot_164_dot_uscore_hash_lambda5 x1 x2 x3 r s
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_updCPattern_dot_prec_dot_164_dot_uscore_hash_lambda5 x1 x2 x3 z s cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_updCPattern_dot_prec_dot_164_dot_uscore_hash_lambda5 x1 x2 x3 e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.updCPattern.prec.164._#lambda5" [show x1, show x2
    , show x3, show x4] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Transform.updCPattern.prec.164._#lambda5" (showCons x4))

d_C_trExpr :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> t0) -> (AbstractCurry.Curry_Types.C_CLiteral -> Cover
  -> ConstStore -> t0) -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> t0) -> (t0 -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> t0) -> (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CPattern -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> t0) -> (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CLocalDecl -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> t0) -> (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CStatement -> Cover -> ConstStore -> t0) -> (t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CStatement -> Cover -> ConstStore -> t0)
  -> (AbstractCurry.Curry_Types.C_CCaseType -> Cover -> ConstStore -> t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CPattern AbstractCurry.Curry_Types.C_CRhs)
  -> Cover -> ConstStore -> t0) -> (t0 -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0) -> Cover -> ConstStore -> t0) -> (t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0) -> Cover -> ConstStore
  -> t0) -> AbstractCurry.Curry_Types.C_CExpr -> Cover -> ConstStore -> t0
d_C_trExpr x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 cd cs =
  d_OP_trExpr_dot_trE_dot_179 x9 x2 x10 x4 x8 x12 x6 x5 x7 x1 x3 x11 x13 cd cs

nd_C_trExpr :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0 -> Func AbstractCurry.Curry_Types.C_CLiteral t0
  -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0 -> Func t0 (Func t0 t0)
  -> Func (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CPattern) (Func t0
  t0) -> Func (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl)
  (Func t0 t0) -> Func (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CStatement) t0 -> Func t0 (Func
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CStatement) t0) -> Func
  AbstractCurry.Curry_Types.C_CCaseType (Func t0 (Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 AbstractCurry.Curry_Types.C_CPattern
  AbstractCurry.Curry_Types.C_CRhs)) t0)) -> Func t0 (Func
  AbstractCurry.Curry_Types.C_CQualTypeExpr t0) -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0)) t0) -> Func t0 (Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0)) t0) -> AbstractCurry.Curry_Types.C_CExpr
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_trExpr x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 s cd cs = let s0 = s
  in s0 `seq` nd_OP_trExpr_dot_trE_dot_179 x9 x2 x10 x4 x8 x12 x6 x5 x7 x1 x3
  x11 x13 s0 cd cs

d_OP_trExpr_dot_trE_dot_179 :: forall t0 . (Curry_Prelude.Curry
  t0) => (AbstractCurry.Curry_Types.C_CCaseType -> Cover -> ConstStore -> t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CPattern AbstractCurry.Curry_Types.C_CRhs)
  -> Cover -> ConstStore -> t0) -> (AbstractCurry.Curry_Types.C_CLiteral
  -> Cover -> ConstStore -> t0) -> (t0 -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr -> Cover -> ConstStore -> t0)
  -> (t0 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t0) -> (t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CStatement -> Cover -> ConstStore -> t0) -> (t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0) -> Cover -> ConstStore
  -> t0) -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl
  -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CPattern -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> t0) -> (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CStatement -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0) -> Cover -> ConstStore -> t0)
  -> AbstractCurry.Curry_Types.C_CExpr -> Cover -> ConstStore -> t0
d_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 cd cs =
  case x13 of
  AbstractCurry.Curry_Types.C_CVar x14 -> Curry_Prelude.d_C_apply x10 x14 cd cs
  AbstractCurry.Curry_Types.C_CLit x15 -> Curry_Prelude.d_C_apply x2 x15 cd cs
  AbstractCurry.Curry_Types.C_CSymbol x16 -> Curry_Prelude.d_C_apply x11 x16 cd
    cs
  AbstractCurry.Curry_Types.C_CApply x17 x18 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x4 (d_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6
    x7 x8 x9 x10 x11 x12 x17 cd cs) cd cs) (d_OP_trExpr_dot_trE_dot_179 x1 x2 x3
    x4 x5 x6 x7 x8 x9 x10 x11 x12 x18 cd cs) cd cs
  AbstractCurry.Curry_Types.C_CLambda x19 x20 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x8 x19 cd cs) (d_OP_trExpr_dot_trE_dot_179 x1 x2 x3
    x4 x5 x6 x7 x8 x9 x10 x11 x12 x20 cd cs) cd cs
  AbstractCurry.Curry_Types.C_CLetDecl x21 x22 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x7 x21 cd cs) (d_OP_trExpr_dot_trE_dot_179 x1 x2 x3
    x4 x5 x6 x7 x8 x9 x10 x11 x12 x22 cd cs) cd cs
  AbstractCurry.Curry_Types.C_CDoExpr x23 -> Curry_Prelude.d_C_apply x9 x23 cd
    cs
  AbstractCurry.Curry_Types.C_CListComp x24 x25 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x5 (d_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6
    x7 x8 x9 x10 x11 x12 x24 cd cs) cd cs) x25 cd cs
  AbstractCurry.Curry_Types.C_CCase x26 x27 x28 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x1 x26 cd cs)
    (d_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x27 cd
    cs) cd cs) x28 cd cs
  AbstractCurry.Curry_Types.C_CTyped x29 x30 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x3 (d_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6
    x7 x8 x9 x10 x11 x12 x29 cd cs) cd cs) x30 cd cs
  AbstractCurry.Curry_Types.C_CRecConstr x31 x32 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x12 x31 cd cs) (Curry_Prelude.d_C_map
    (d_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda6 x1 x2 x3 x4 x5 x6 x7 x8
    x9 x10 x11 x12) x32 cd cs) cd cs
  AbstractCurry.Curry_Types.C_CRecUpdate x33 x34 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x6 (d_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6
    x7 x8 x9 x10 x11 x12 x33 cd cs) cd cs) (Curry_Prelude.d_C_map
    (d_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda7 x1 x2 x3 x4 x5 x6 x7 x8
    x9 x10 x11 x12) x34 cd cs) cd cs
  AbstractCurry.Curry_Types.Choice_C_CExpr d i l r -> narrow d i
    (d_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 l cd cs)
    (d_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CExpr d i xs -> narrows cs d i (\z ->
    d_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 z cd cs)
    xs
  AbstractCurry.Curry_Types.Guard_C_CExpr d c e -> guardCons d c ((\x ->
    d_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 e cd
    x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CExpr d info -> failCons d (traceFail
    "AbstractCurry.Transform.trExpr.trE.179" [show x1, show x2, show x3, show x4
    , show x5, show x6, show x7, show x8, show x9, show x10, show x11, show x12
    , show x13] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trExpr.trE.179" (showCons
    x13))

nd_OP_trExpr_dot_trE_dot_179 :: forall t0 . (Curry_Prelude.Curry t0) => Func
  AbstractCurry.Curry_Types.C_CCaseType (Func t0 (Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 AbstractCurry.Curry_Types.C_CPattern
  AbstractCurry.Curry_Types.C_CRhs)) t0)) -> Func
  AbstractCurry.Curry_Types.C_CLiteral t0 -> Func t0 (Func
  AbstractCurry.Curry_Types.C_CQualTypeExpr t0) -> Func t0 (Func t0 t0) -> Func
  t0 (Func (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CStatement) t0)
  -> Func t0 (Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0)) t0) -> Func
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl) (Func t0 t0)
  -> Func (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CPattern) (Func t0
  t0) -> Func (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CStatement) t0
  -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0 -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0 -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0)) t0)
  -> AbstractCurry.Curry_Types.C_CExpr -> IDSupply -> Cover -> ConstStore -> t0
nd_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 s cd cs =
  case x13 of
  AbstractCurry.Curry_Types.C_CVar x14 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x10 x14 s0 cd cs
  AbstractCurry.Curry_Types.C_CLit x15 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x2 x15 s0 cd cs
  AbstractCurry.Curry_Types.C_CSymbol x16 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x11 x16 s0 cd cs
  AbstractCurry.Curry_Types.C_CApply x17 x18 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s2 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply x4
    (nd_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x17 s0
    cd cs) s1 cd cs)) (nd_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6 x7 x8 x9
    x10 x11 x12 x18 s3 cd cs) s4 cd cs))))
  AbstractCurry.Curry_Types.C_CLambda x19 x20 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_apply x8 x19 s0 cd cs) (nd_OP_trExpr_dot_trE_dot_179 x1
    x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x20 s1 cd cs) s2 cd cs))))
  AbstractCurry.Curry_Types.C_CLetDecl x21 x22 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_apply x7 x21 s0 cd cs) (nd_OP_trExpr_dot_trE_dot_179 x1
    x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x22 s1 cd cs) s2 cd cs))))
  AbstractCurry.Curry_Types.C_CDoExpr x23 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x9 x23 s0 cd cs
  AbstractCurry.Curry_Types.C_CListComp x24 x25 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply x5
    (nd_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x24 s0
    cd cs) s1 cd cs)) x25 s3 cd cs))
  AbstractCurry.Curry_Types.C_CCase x26 x27 x28 -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s3 = rightSupply s6
    in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_apply x1 x26 s0 cd cs) (nd_OP_trExpr_dot_trE_dot_179 x1
    x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x27 s1 cd cs) s2 cd cs)))) x28 s5 cd
    cs))
  AbstractCurry.Curry_Types.C_CTyped x29 x30 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply x3
    (nd_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x29 s0
    cd cs) s1 cd cs)) x30 s3 cd cs))
  AbstractCurry.Curry_Types.C_CRecConstr x31 x32 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_apply x12 x31 s0 cd cs) (Curry_Prelude.nd_C_map (wrapNX
    id (nd_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda6 x1 x2 x3 x4 x5 x6
    x7 x8 x9 x10 x11 x12)) x32 s1 cd cs) s2 cd cs))))
  AbstractCurry.Curry_Types.C_CRecUpdate x33 x34 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s2 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply x6
    (nd_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x33 s0
    cd cs) s1 cd cs)) (Curry_Prelude.nd_C_map (wrapNX id
    (nd_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda7 x1 x2 x3 x4 x5 x6 x7
    x8 x9 x10 x11 x12)) x34 s3 cd cs) s4 cd cs))))
  AbstractCurry.Curry_Types.Choice_C_CExpr d i l r -> narrow d i
    (nd_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 l s cd
    cs) (nd_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 r s
    cd cs)
  AbstractCurry.Curry_Types.Choices_C_CExpr d i xs -> narrows cs d i (\z ->
    nd_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 z s cd
    cs) xs
  AbstractCurry.Curry_Types.Guard_C_CExpr d c e -> guardCons d c ((\x ->
    nd_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 e s cd
    x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CExpr d info -> failCons d (traceFail
    "AbstractCurry.Transform.trExpr.trE.179" [show x1, show x2, show x3, show x4
    , show x5, show x6, show x7, show x8, show x9, show x10, show x11, show x12
    , show x13] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trExpr.trE.179" (showCons
    x13))

d_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda6 :: forall t0 . (Curry_Prelude.Curry
  t0) => (AbstractCurry.Curry_Types.C_CCaseType -> Cover -> ConstStore -> t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CPattern AbstractCurry.Curry_Types.C_CRhs)
  -> Cover -> ConstStore -> t0) -> (AbstractCurry.Curry_Types.C_CLiteral
  -> Cover -> ConstStore -> t0) -> (t0 -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr -> Cover -> ConstStore -> t0)
  -> (t0 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t0) -> (t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CStatement -> Cover -> ConstStore -> t0) -> (t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0) -> Cover -> ConstStore
  -> t0) -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl
  -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CPattern -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> t0) -> (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CStatement -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0) -> Cover -> ConstStore -> t0)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  AbstractCurry.Curry_Types.C_CExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0
d_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda6 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 cd cs =
  case x13 of
  Curry_Prelude.OP_Tuple2 x14 x15 -> Curry_Prelude.OP_Tuple2 x14
    (d_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x15 cd
    cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda6 x1 x2 x3 x4 x5 x6 x7 x8
    x9 x10 x11 x12 l cd cs) (d_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda6
    x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda6 x1 x2 x3 x4 x5 x6 x7 x8
    x9 x10 x11 x12 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda6 x1 x2 x3 x4 x5 x6 x7 x8
    x9 x10 x11 x12 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.trExpr.trE.179._#lambda6" [show x1, show x2, show
    x3, show x4, show x5, show x6, show x7, show x8, show x9, show x10, show x11
    , show x12, show x13] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trExpr.trE.179._#lambda6"
    (showCons x13))

nd_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda6 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func AbstractCurry.Curry_Types.C_CCaseType (Func t0 (Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CPattern AbstractCurry.Curry_Types.C_CRhs)) t0))
  -> Func AbstractCurry.Curry_Types.C_CLiteral t0 -> Func t0 (Func
  AbstractCurry.Curry_Types.C_CQualTypeExpr t0) -> Func t0 (Func t0 t0) -> Func
  t0 (Func (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CStatement) t0)
  -> Func t0 (Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0)) t0) -> Func
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl) (Func t0 t0)
  -> Func (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CPattern) (Func t0
  t0) -> Func (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CStatement) t0
  -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0 -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0 -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0)) t0)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  AbstractCurry.Curry_Types.C_CExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0
nd_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda6 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 s cd cs =
  case x13 of
  Curry_Prelude.OP_Tuple2 x14 x15 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 x14 (nd_OP_trExpr_dot_trE_dot_179 x1 x2
    x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x15 s0 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda6 x1 x2 x3 x4 x5 x6 x7
    x8 x9 x10 x11 x12 l s cd cs)
    (nd_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda6 x1 x2 x3 x4 x5 x6 x7
    x8 x9 x10 x11 x12 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda6 x1 x2 x3 x4 x5 x6 x7 x8
    x9 x10 x11 x12 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda6 x1 x2 x3 x4 x5 x6 x7 x8
    x9 x10 x11 x12 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.trExpr.trE.179._#lambda6" [show x1, show x2, show
    x3, show x4, show x5, show x6, show x7, show x8, show x9, show x10, show x11
    , show x12, show x13] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trExpr.trE.179._#lambda6"
    (showCons x13))

d_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda7 :: forall t0 . (Curry_Prelude.Curry
  t0) => (AbstractCurry.Curry_Types.C_CCaseType -> Cover -> ConstStore -> t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CPattern AbstractCurry.Curry_Types.C_CRhs)
  -> Cover -> ConstStore -> t0) -> (AbstractCurry.Curry_Types.C_CLiteral
  -> Cover -> ConstStore -> t0) -> (t0 -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr -> Cover -> ConstStore -> t0)
  -> (t0 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t0) -> (t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CStatement -> Cover -> ConstStore -> t0) -> (t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0) -> Cover -> ConstStore
  -> t0) -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl
  -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CPattern -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> t0) -> (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CStatement -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0) -> Cover -> ConstStore -> t0)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  AbstractCurry.Curry_Types.C_CExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0
d_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda7 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 cd cs =
  case x13 of
  Curry_Prelude.OP_Tuple2 x14 x15 -> Curry_Prelude.OP_Tuple2 x14
    (d_OP_trExpr_dot_trE_dot_179 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x15 cd
    cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda7 x1 x2 x3 x4 x5 x6 x7 x8
    x9 x10 x11 x12 l cd cs) (d_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda7
    x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda7 x1 x2 x3 x4 x5 x6 x7 x8
    x9 x10 x11 x12 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda7 x1 x2 x3 x4 x5 x6 x7 x8
    x9 x10 x11 x12 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.trExpr.trE.179._#lambda7" [show x1, show x2, show
    x3, show x4, show x5, show x6, show x7, show x8, show x9, show x10, show x11
    , show x12, show x13] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trExpr.trE.179._#lambda7"
    (showCons x13))

nd_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda7 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func AbstractCurry.Curry_Types.C_CCaseType (Func t0 (Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CPattern AbstractCurry.Curry_Types.C_CRhs)) t0))
  -> Func AbstractCurry.Curry_Types.C_CLiteral t0 -> Func t0 (Func
  AbstractCurry.Curry_Types.C_CQualTypeExpr t0) -> Func t0 (Func t0 t0) -> Func
  t0 (Func (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CStatement) t0)
  -> Func t0 (Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0)) t0) -> Func
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl) (Func t0 t0)
  -> Func (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CPattern) (Func t0
  t0) -> Func (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CStatement) t0
  -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0 -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0 -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0)) t0)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  AbstractCurry.Curry_Types.C_CExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0
nd_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda7 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 s cd cs =
  case x13 of
  Curry_Prelude.OP_Tuple2 x14 x15 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 x14 (nd_OP_trExpr_dot_trE_dot_179 x1 x2
    x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x15 s0 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda7 x1 x2 x3 x4 x5 x6 x7
    x8 x9 x10 x11 x12 l s cd cs)
    (nd_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda7 x1 x2 x3 x4 x5 x6 x7
    x8 x9 x10 x11 x12 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda7 x1 x2 x3 x4 x5 x6 x7 x8
    x9 x10 x11 x12 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_trExpr_dot_trE_dot_179_dot_uscore_hash_lambda7 x1 x2 x3 x4 x5 x6 x7 x8
    x9 x10 x11 x12 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.trExpr.trE.179._#lambda7" [show x1, show x2, show
    x3, show x4, show x5, show x6, show x7, show x8, show x9, show x10, show x11
    , show x12, show x13] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trExpr.trE.179._#lambda7"
    (showCons x13))

d_C_trCStatement :: forall t0 . (Curry_Prelude.Curry
  t0) => (AbstractCurry.Curry_Types.C_CExpr -> Cover -> ConstStore -> t0)
  -> (AbstractCurry.Curry_Types.C_CPattern -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CExpr -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl -> Cover
  -> ConstStore -> t0) -> AbstractCurry.Curry_Types.C_CStatement -> Cover
  -> ConstStore -> t0
d_C_trCStatement x1 x2 x3 x4 cd cs = case x4 of
  AbstractCurry.Curry_Types.C_CSExpr x5 -> Curry_Prelude.d_C_apply x1 x5 cd cs
  AbstractCurry.Curry_Types.C_CSPat x6 x7 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x2 x6 cd cs) x7 cd cs
  AbstractCurry.Curry_Types.C_CSLet x8 -> Curry_Prelude.d_C_apply x3 x8 cd cs
  AbstractCurry.Curry_Types.Choice_C_CStatement d i l r -> narrow d i
    (d_C_trCStatement x1 x2 x3 l cd cs) (d_C_trCStatement x1 x2 x3 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CStatement d i xs -> narrows cs d i (\z ->
    d_C_trCStatement x1 x2 x3 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CStatement d c e -> guardCons d c ((\x ->
    d_C_trCStatement x1 x2 x3 e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CStatement d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCStatement" [show x1, show x2, show x3, show x4]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCStatement" (showCons
    x4))

nd_C_trCStatement :: forall t0 . (Curry_Prelude.Curry t0) => Func
  AbstractCurry.Curry_Types.C_CExpr t0 -> Func
  AbstractCurry.Curry_Types.C_CPattern (Func AbstractCurry.Curry_Types.C_CExpr
  t0) -> Func (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl) t0
  -> AbstractCurry.Curry_Types.C_CStatement -> IDSupply -> Cover -> ConstStore
  -> t0
nd_C_trCStatement x1 x2 x3 x4 s cd cs = case x4 of
  AbstractCurry.Curry_Types.C_CSExpr x5 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x1 x5 s0 cd cs
  AbstractCurry.Curry_Types.C_CSPat x6 x7 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2
    x6 s0 cd cs) x7 s1 cd cs))
  AbstractCurry.Curry_Types.C_CSLet x8 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x3 x8 s0 cd cs
  AbstractCurry.Curry_Types.Choice_C_CStatement d i l r -> narrow d i
    (nd_C_trCStatement x1 x2 x3 l s cd cs) (nd_C_trCStatement x1 x2 x3 r s cd
    cs)
  AbstractCurry.Curry_Types.Choices_C_CStatement d i xs -> narrows cs d i (\z ->
    nd_C_trCStatement x1 x2 x3 z s cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CStatement d c e -> guardCons d c ((\x ->
    nd_C_trCStatement x1 x2 x3 e s cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CStatement d info -> failCons d (traceFail
    "AbstractCurry.Transform.trCStatement" [show x1, show x2, show x3, show x4]
    info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.trCStatement" (showCons
    x4))

d_C_updCStatement :: (AbstractCurry.Curry_Types.C_CExpr -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CExpr) -> (AbstractCurry.Curry_Types.C_CPattern
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CPattern)
  -> (AbstractCurry.Curry_Types.C_CLocalDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CLocalDecl) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CStatement -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CStatement
d_C_updCStatement x1 x2 x3 cd cs = d_C_trCStatement
  (d_OP_updCStatement_dot_sexp_dot_219 x1) (acceptCs id
  (d_OP_updCStatement_dot_spat_dot_219 x1 x2))
  (d_OP_updCStatement_dot_slet_dot_219 x3)

nd_C_updCStatement :: Func AbstractCurry.Curry_Types.C_CExpr
  AbstractCurry.Curry_Types.C_CExpr -> Func AbstractCurry.Curry_Types.C_CPattern
  AbstractCurry.Curry_Types.C_CPattern -> Func
  AbstractCurry.Curry_Types.C_CLocalDecl AbstractCurry.Curry_Types.C_CLocalDecl
  -> IDSupply -> Cover -> ConstStore -> Func
  AbstractCurry.Curry_Types.C_CStatement AbstractCurry.Curry_Types.C_CStatement
nd_C_updCStatement x1 x2 x3 s cd cs = wrapNX id (nd_C_trCStatement (wrapNX id
  (nd_OP_updCStatement_dot_sexp_dot_219 x1)) (wrapDX (wrapNX id) (acceptCs id
  (nd_OP_updCStatement_dot_spat_dot_219 x1 x2))) (wrapNX id
  (nd_OP_updCStatement_dot_slet_dot_219 x3)))

d_OP_updCStatement_dot_sexp_dot_219 :: (AbstractCurry.Curry_Types.C_CExpr
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CExpr)
  -> AbstractCurry.Curry_Types.C_CExpr -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CStatement
d_OP_updCStatement_dot_sexp_dot_219 x1 x2 cd cs =
  AbstractCurry.Curry_Types.C_CSExpr (Curry_Prelude.d_C_apply x1 x2 cd cs)

nd_OP_updCStatement_dot_sexp_dot_219 :: Func AbstractCurry.Curry_Types.C_CExpr
  AbstractCurry.Curry_Types.C_CExpr -> AbstractCurry.Curry_Types.C_CExpr
  -> IDSupply -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CStatement
nd_OP_updCStatement_dot_sexp_dot_219 x1 x2 s cd cs = let s0 = s
  in s0 `seq` AbstractCurry.Curry_Types.C_CSExpr (Curry_Prelude.nd_C_apply x1 x2
  s0 cd cs)

d_OP_updCStatement_dot_spat_dot_219 :: (AbstractCurry.Curry_Types.C_CExpr
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CExpr)
  -> (AbstractCurry.Curry_Types.C_CPattern -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CPattern)
  -> AbstractCurry.Curry_Types.C_CPattern -> AbstractCurry.Curry_Types.C_CExpr
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CStatement
d_OP_updCStatement_dot_spat_dot_219 x1 x2 x3 x4 cd cs =
  AbstractCurry.Curry_Types.C_CSPat (Curry_Prelude.d_C_apply x2 x3 cd cs)
  (Curry_Prelude.d_C_apply x1 x4 cd cs)

nd_OP_updCStatement_dot_spat_dot_219 :: Func AbstractCurry.Curry_Types.C_CExpr
  AbstractCurry.Curry_Types.C_CExpr -> Func AbstractCurry.Curry_Types.C_CPattern
  AbstractCurry.Curry_Types.C_CPattern -> AbstractCurry.Curry_Types.C_CPattern
  -> AbstractCurry.Curry_Types.C_CExpr -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CStatement
nd_OP_updCStatement_dot_spat_dot_219 x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` AbstractCurry.Curry_Types.C_CSPat
  (Curry_Prelude.nd_C_apply x2 x3 s0 cd cs) (Curry_Prelude.nd_C_apply x1 x4 s1
  cd cs)))

d_OP_updCStatement_dot_slet_dot_219 :: (AbstractCurry.Curry_Types.C_CLocalDecl
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CLocalDecl)
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CStatement
d_OP_updCStatement_dot_slet_dot_219 x1 x2 cd cs =
  AbstractCurry.Curry_Types.C_CSLet (Curry_Prelude.d_C_map x1 x2 cd cs)

nd_OP_updCStatement_dot_slet_dot_219 :: Func
  AbstractCurry.Curry_Types.C_CLocalDecl AbstractCurry.Curry_Types.C_CLocalDecl
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl -> IDSupply
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CStatement
nd_OP_updCStatement_dot_slet_dot_219 x1 x2 s cd cs = let s0 = s
  in s0 `seq` AbstractCurry.Curry_Types.C_CSLet (Curry_Prelude.nd_C_map x1 x2 s0
  cd cs)

d_C_renameCurryModule :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> AbstractCurry.Curry_Types.C_CurryProg -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CurryProg
d_C_renameCurryModule x1 x2 cd cs = Curry_Prelude.d_C_apply (d_C_updCProgName
  (Curry_Prelude.d_C_const x1) cd cs) (Curry_Prelude.d_C_apply
  (d_C_updQNamesInCProg (d_OP_renameCurryModule_dot_rnm_dot_227 x2 x1) cd cs) x2
  cd cs) cd cs

d_OP_renameCurryModule_dot_rnm_dot_227 :: forall t0 . (Curry_Prelude.Curry
  t0) => AbstractCurry.Curry_Types.C_CurryProg -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0
d_OP_renameCurryModule_dot_rnm_dot_227 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_2 x1 x4 x3 x5 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x4 (AbstractCurry.Curry_Select.d_C_progName x1 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_renameCurryModule_dot_rnm_dot_227 x1 x2 l cd cs)
    (d_OP_renameCurryModule_dot_rnm_dot_227 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_renameCurryModule_dot_rnm_dot_227 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_renameCurryModule_dot_rnm_dot_227 x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.renameCurryModule.rnm.227" [show x1, show x2, show
    x3] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.renameCurryModule.rnm.227"
    (showCons x3))

d_C_updQNamesInCProg :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CurryProg -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CurryProg
d_C_updQNamesInCProg x1 cd cs = d_C_updCProg Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id (d_C_updQNamesInCDefaultDecl x1 cd cs)
  (Curry_Prelude.d_C_map (d_C_updQNamesInCClassDecl x1 cd cs))
  (Curry_Prelude.d_C_map (d_C_updQNamesInCInstanceDecl x1 cd cs))
  (Curry_Prelude.d_C_map (d_C_updQNamesInCTypeDecl x1 cd cs))
  (Curry_Prelude.d_C_map (d_C_updQNamesInCFuncDecl x1 cd cs))
  (Curry_Prelude.d_C_map (d_C_updCOpName x1 cd cs)) cd cs

nd_C_updQNamesInCProg :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Func AbstractCurry.Curry_Types.C_CurryProg
  AbstractCurry.Curry_Types.C_CurryProg
nd_C_updQNamesInCProg x1 s cd cs = let s7 = s
  in s7 `seq` (let s8 = leftSupply s7
                   s10 = rightSupply s7
                   s6 = leftSupply s8
                   s9 = rightSupply s8
                   s0 = leftSupply s9
                   s1 = rightSupply s9
                   s11 = leftSupply s10
                   s12 = rightSupply s10
                   s2 = leftSupply s11
                   s3 = rightSupply s11
                   s4 = leftSupply s12
                   s5 = rightSupply s12
  in s8 `seq` (s10 `seq` (s6 `seq` (s9 `seq` (s0 `seq` (s1 `seq` (s11 `seq`
  (s12 `seq` (s2 `seq` (s3 `seq` (s4 `seq` (s5 `seq` nd_C_updCProg (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id)
  (nd_C_updQNamesInCDefaultDecl x1 s0 cd cs) (wrapNX id (Curry_Prelude.nd_C_map
  (nd_C_updQNamesInCClassDecl x1 s1 cd cs))) (wrapNX id (Curry_Prelude.nd_C_map
  (nd_C_updQNamesInCInstanceDecl x1 s2 cd cs))) (wrapNX id
  (Curry_Prelude.nd_C_map (nd_C_updQNamesInCTypeDecl x1 s3 cd cs))) (wrapNX id
  (Curry_Prelude.nd_C_map (nd_C_updQNamesInCFuncDecl x1 s4 cd cs))) (wrapNX id
  (Curry_Prelude.nd_C_map (nd_C_updCOpName x1 s5 cd cs))) s6 cd cs))))))))))))

d_C_updQNamesInCDefaultDecl :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CDefaultDecl -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CDefaultDecl
d_C_updQNamesInCDefaultDecl x1 cd cs =
  d_OP_updQNamesInCDefaultDecl_dot_updateDefltDecl_dot_233 x1

nd_C_updQNamesInCDefaultDecl :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CDefaultDecl) (Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CDefaultDecl)
nd_C_updQNamesInCDefaultDecl x1 s cd cs = wrapNX id
  (nd_OP_updQNamesInCDefaultDecl_dot_updateDefltDecl_dot_233 x1)

d_OP_updQNamesInCDefaultDecl_dot_updateDefltDecl_dot_233 :: (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CDefaultDecl -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CDefaultDecl
d_OP_updQNamesInCDefaultDecl_dot_updateDefltDecl_dot_233 x1 x2 cd cs =
  case x2 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.C_Nothing
  Curry_Prelude.C_Just x3 -> Curry_Prelude.C_Just (Curry_Prelude.d_C_apply
    (d_C_updCDefaultDecl (Curry_Prelude.d_C_map (d_C_updQNamesInCTypeExpr x1 cd
    cs)) cd cs) x3 cd cs)
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (d_OP_updQNamesInCDefaultDecl_dot_updateDefltDecl_dot_233 x1 l cd cs)
    (d_OP_updQNamesInCDefaultDecl_dot_updateDefltDecl_dot_233 x1 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    d_OP_updQNamesInCDefaultDecl_dot_updateDefltDecl_dot_233 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x ->
    d_OP_updQNamesInCDefaultDecl_dot_updateDefltDecl_dot_233 x1 e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "AbstractCurry.Transform.updQNamesInCDefaultDecl.updateDefltDecl.233" [show
    x1, show x2] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Transform.updQNamesInCDefaultDecl.updateDefltDecl.233"
    (showCons x2))

nd_OP_updQNamesInCDefaultDecl_dot_updateDefltDecl_dot_233 :: Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CDefaultDecl -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe AbstractCurry.Curry_Types.C_CDefaultDecl
nd_OP_updQNamesInCDefaultDecl_dot_updateDefltDecl_dot_233 x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.C_Nothing
  Curry_Prelude.C_Just x3 -> let s4 = s
    in s4 `seq` Curry_Prelude.C_Just (let s3 = leftSupply s4
                                          s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C_updCDefaultDecl (wrapNX id
    (Curry_Prelude.nd_C_map (nd_C_updQNamesInCTypeExpr x1 s0 cd cs))) s1 cd cs))
    x3 s3 cd cs))
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (nd_OP_updQNamesInCDefaultDecl_dot_updateDefltDecl_dot_233 x1 l s cd cs)
    (nd_OP_updQNamesInCDefaultDecl_dot_updateDefltDecl_dot_233 x1 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    nd_OP_updQNamesInCDefaultDecl_dot_updateDefltDecl_dot_233 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x ->
    nd_OP_updQNamesInCDefaultDecl_dot_updateDefltDecl_dot_233 x1 e s cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "AbstractCurry.Transform.updQNamesInCDefaultDecl.updateDefltDecl.233" [show
    x1, show x2] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Transform.updQNamesInCDefaultDecl.updateDefltDecl.233"
    (showCons x2))

d_C_updQNamesInCClassDecl :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CClassDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CClassDecl
d_C_updQNamesInCClassDecl x1 cd cs = d_C_updCClassDecl x1 Curry_Prelude.d_C_id
  (d_C_updQNamesInCContext x1 cd cs) Curry_Prelude.d_C_id Curry_Prelude.d_C_id
  (Curry_Prelude.d_C_map (d_C_updQNamesInCFuncDecl x1 cd cs)) cd cs

nd_C_updQNamesInCClassDecl :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> IDSupply -> Cover -> ConstStore -> Func
  AbstractCurry.Curry_Types.C_CClassDecl AbstractCurry.Curry_Types.C_CClassDecl
nd_C_updQNamesInCClassDecl x1 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` nd_C_updCClassDecl x1 (wrapDX id
  Curry_Prelude.d_C_id) (nd_C_updQNamesInCContext x1 s0 cd cs) (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) (wrapNX id
  (Curry_Prelude.nd_C_map (nd_C_updQNamesInCFuncDecl x1 s1 cd cs))) s2 cd cs))))

d_C_updQNamesInCInstanceDecl :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CInstanceDecl -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CInstanceDecl
d_C_updQNamesInCInstanceDecl x1 cd cs = d_C_updCInstanceDecl x1
  (d_C_updQNamesInCContext x1 cd cs) (Curry_Prelude.d_C_map
  (d_C_updQNamesInCTypeExpr x1 cd cs)) (Curry_Prelude.d_C_map
  (d_C_updQNamesInCFuncDecl x1 cd cs)) cd cs

nd_C_updQNamesInCInstanceDecl :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> IDSupply -> Cover -> ConstStore -> Func
  AbstractCurry.Curry_Types.C_CInstanceDecl
  AbstractCurry.Curry_Types.C_CInstanceDecl
nd_C_updQNamesInCInstanceDecl x1 s cd cs = let s4 = s
  in s4 `seq` (let s5 = leftSupply s4
                   s6 = rightSupply s4
                   s3 = leftSupply s5
                   s0 = rightSupply s5
                   s1 = leftSupply s6
                   s2 = rightSupply s6
  in s5 `seq` (s6 `seq` (s3 `seq` (s0 `seq` (s1 `seq` (s2 `seq`
  nd_C_updCInstanceDecl x1 (nd_C_updQNamesInCContext x1 s0 cd cs) (wrapNX id
  (Curry_Prelude.nd_C_map (nd_C_updQNamesInCTypeExpr x1 s1 cd cs))) (wrapNX id
  (Curry_Prelude.nd_C_map (nd_C_updQNamesInCFuncDecl x1 s2 cd cs))) s3 cd
  cs))))))

d_C_updQNamesInCTypeDecl :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CTypeDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CTypeDecl
d_C_updQNamesInCTypeDecl x1 cd cs = d_C_updCTypeDecl x1 Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id (Curry_Prelude.d_C_map (d_C_updQNamesInCConsDecl x1 cd
  cs)) (d_C_updQNamesInCTypeExpr x1 cd cs) (d_C_updQNamesInCConsDecl x1 cd cs)
  (Curry_Prelude.d_C_map x1) cd cs

nd_C_updQNamesInCTypeDecl :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> IDSupply -> Cover -> ConstStore -> Func
  AbstractCurry.Curry_Types.C_CTypeDecl AbstractCurry.Curry_Types.C_CTypeDecl
nd_C_updQNamesInCTypeDecl x1 s cd cs = let s4 = s
  in s4 `seq` (let s5 = leftSupply s4
                   s6 = rightSupply s4
                   s3 = leftSupply s5
                   s0 = rightSupply s5
                   s1 = leftSupply s6
                   s2 = rightSupply s6
  in s5 `seq` (s6 `seq` (s3 `seq` (s0 `seq` (s1 `seq` (s2 `seq`
  nd_C_updCTypeDecl x1 (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) (wrapNX id (Curry_Prelude.nd_C_map
  (nd_C_updQNamesInCConsDecl x1 s0 cd cs))) (nd_C_updQNamesInCTypeExpr x1 s1 cd
  cs) (nd_C_updQNamesInCConsDecl x1 s2 cd cs) (wrapNX id (Curry_Prelude.nd_C_map
  x1)) s3 cd cs))))))

d_C_updQNamesInCConsDecl :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CConsDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CConsDecl
d_C_updQNamesInCConsDecl x1 cd cs = d_C_updCConsDecl x1 Curry_Prelude.d_C_id
  (Curry_Prelude.d_C_map (d_C_updQNamesInCTypeExpr x1 cd cs))
  (Curry_Prelude.d_C_map (d_C_updQNamesInCFieldDecl x1 cd cs)) cd cs

nd_C_updQNamesInCConsDecl :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> IDSupply -> Cover -> ConstStore -> Func
  AbstractCurry.Curry_Types.C_CConsDecl AbstractCurry.Curry_Types.C_CConsDecl
nd_C_updQNamesInCConsDecl x1 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` nd_C_updCConsDecl x1 (wrapDX id
  Curry_Prelude.d_C_id) (wrapNX id (Curry_Prelude.nd_C_map
  (nd_C_updQNamesInCTypeExpr x1 s0 cd cs))) (wrapNX id (Curry_Prelude.nd_C_map
  (nd_C_updQNamesInCFieldDecl x1 s1 cd cs))) s2 cd cs))))

d_C_updQNamesInCContext :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CContext -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CContext
d_C_updQNamesInCContext x1 cd cs = d_C_updCContext (Curry_Prelude.d_C_map
  (d_OP_updQNamesInCContext_dot_updConstr_dot_247 x1)) cd cs

nd_C_updQNamesInCContext :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Func AbstractCurry.Curry_Types.C_CContext
  AbstractCurry.Curry_Types.C_CContext
nd_C_updQNamesInCContext x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updCContext (wrapNX id (Curry_Prelude.nd_C_map (wrapNX id
  (nd_OP_updQNamesInCContext_dot_updConstr_dot_247 x1)))) s0 cd cs

d_OP_updQNamesInCContext_dot_updConstr_dot_247 :: (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr)
d_OP_updQNamesInCContext_dot_updConstr_dot_247 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_C_apply x1 x3 cd cs) (Curry_Prelude.d_C_map
    (d_C_updQNamesInCTypeExpr x1 cd cs) x4 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_updQNamesInCContext_dot_updConstr_dot_247 x1 l cd cs)
    (d_OP_updQNamesInCContext_dot_updConstr_dot_247 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_updQNamesInCContext_dot_updConstr_dot_247 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_updQNamesInCContext_dot_updConstr_dot_247 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.updQNamesInCContext.updConstr.247" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Transform.updQNamesInCContext.updConstr.247" (showCons x2))

nd_OP_updQNamesInCContext_dot_updConstr_dot_247 :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr) -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeExpr)
nd_OP_updQNamesInCContext_dot_updConstr_dot_247 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s4 = s
    in s4 `seq` (let s0 = leftSupply s4
                     s3 = rightSupply s4
    in s0 `seq` (s3 `seq` Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_apply x1
    x3 s0 cd cs) (let s2 = leftSupply s3
                      s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_map (nd_C_updQNamesInCTypeExpr x1
    s1 cd cs) x4 s2 cd cs))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_updQNamesInCContext_dot_updConstr_dot_247 x1 l s cd cs)
    (nd_OP_updQNamesInCContext_dot_updConstr_dot_247 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_updQNamesInCContext_dot_updConstr_dot_247 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_updQNamesInCContext_dot_updConstr_dot_247 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.updQNamesInCContext.updConstr.247" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Transform.updQNamesInCContext.updConstr.247" (showCons x2))

d_C_updQNamesInCFieldDecl :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CFieldDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CFieldDecl
d_C_updQNamesInCFieldDecl x1 cd cs = d_C_updCFieldDecl x1 Curry_Prelude.d_C_id
  (d_C_updQNamesInCTypeExpr x1 cd cs) cd cs

nd_C_updQNamesInCFieldDecl :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> IDSupply -> Cover -> ConstStore -> Func
  AbstractCurry.Curry_Types.C_CFieldDecl AbstractCurry.Curry_Types.C_CFieldDecl
nd_C_updQNamesInCFieldDecl x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_updCFieldDecl x1 (wrapDX id Curry_Prelude.d_C_id)
  (nd_C_updQNamesInCTypeExpr x1 s0 cd cs) s1 cd cs))

d_C_updQNamesInCQualTypeExpr :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CQualTypeExpr -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CQualTypeExpr
d_C_updQNamesInCQualTypeExpr x1 cd cs = d_C_updCQualTypeExpr
  (d_C_updQNamesInCContext x1 cd cs) (d_C_updQNamesInCTypeExpr x1 cd cs) cd cs

nd_C_updQNamesInCQualTypeExpr :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> IDSupply -> Cover -> ConstStore -> Func
  AbstractCurry.Curry_Types.C_CQualTypeExpr
  AbstractCurry.Curry_Types.C_CQualTypeExpr
nd_C_updQNamesInCQualTypeExpr x1 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` nd_C_updCQualTypeExpr
  (nd_C_updQNamesInCContext x1 s0 cd cs) (nd_C_updQNamesInCTypeExpr x1 s1 cd cs)
  s2 cd cs))))

d_C_updQNamesInCTypeExpr :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CTypeExpr
d_C_updQNamesInCTypeExpr x1 cd cs = d_C_updTConsApp (Curry_Prelude.d_OP_dot
  (acceptCs id AbstractCurry.Curry_Types.C_CTCons) x1 cd cs) cd cs

nd_C_updQNamesInCTypeExpr :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> IDSupply -> Cover -> ConstStore -> Func
  AbstractCurry.Curry_Types.C_CTypeExpr AbstractCurry.Curry_Types.C_CTypeExpr
nd_C_updQNamesInCTypeExpr x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_updTConsApp (Curry_Prelude.nd_OP_dot (wrapDX id
  (acceptCs id AbstractCurry.Curry_Types.C_CTCons)) x1 s0 cd cs) s1 cd cs))

d_C_updQNamesInCFuncDecl :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CFuncDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CFuncDecl
d_C_updQNamesInCFuncDecl x1 cd cs = d_C_updCFuncDecl Curry_Prelude.d_C_id x1
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id (d_C_updQNamesInCQualTypeExpr x1 cd
  cs) (Curry_Prelude.d_C_map (d_C_updQNamesInCRule x1 cd cs)) cd cs

nd_C_updQNamesInCFuncDecl :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> IDSupply -> Cover -> ConstStore -> Func
  AbstractCurry.Curry_Types.C_CFuncDecl AbstractCurry.Curry_Types.C_CFuncDecl
nd_C_updQNamesInCFuncDecl x1 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` nd_C_updCFuncDecl (wrapDX id
  Curry_Prelude.d_C_id) x1 (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) (nd_C_updQNamesInCQualTypeExpr x1 s0 cd cs) (wrapNX id
  (Curry_Prelude.nd_C_map (nd_C_updQNamesInCRule x1 s1 cd cs))) s2 cd cs))))

d_C_updQNamesInCRule :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CRule -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CRule
d_C_updQNamesInCRule x1 cd cs = d_C_updCRule (Curry_Prelude.d_C_map
  (d_C_updQNamesInCPattern x1 cd cs)) (d_C_updQNamesInCRhs x1 cd cs) cd cs

nd_C_updQNamesInCRule :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Func AbstractCurry.Curry_Types.C_CRule
  AbstractCurry.Curry_Types.C_CRule
nd_C_updQNamesInCRule x1 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` nd_C_updCRule (wrapNX id
  (Curry_Prelude.nd_C_map (nd_C_updQNamesInCPattern x1 s0 cd cs)))
  (nd_C_updQNamesInCRhs x1 s1 cd cs) s2 cd cs))))

d_C_updQNamesInCRhs :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CRhs -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CRhs
d_C_updQNamesInCRhs x1 cd cs = d_C_updCRhs (d_C_updQNamesInCExpr x1 cd cs)
  (Curry_Prelude.d_C_map (d_OP_updQNamesInCRhs_dot_uscore_hash_lambda8 x1))
  (Curry_Prelude.d_C_map (d_C_updQNamesInCLocalDecl x1 cd cs)) cd cs

nd_C_updQNamesInCRhs :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Func AbstractCurry.Curry_Types.C_CRhs
  AbstractCurry.Curry_Types.C_CRhs
nd_C_updQNamesInCRhs x1 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` nd_C_updCRhs (nd_C_updQNamesInCExpr
  x1 s0 cd cs) (wrapNX id (Curry_Prelude.nd_C_map (wrapNX id
  (nd_OP_updQNamesInCRhs_dot_uscore_hash_lambda8 x1)))) (wrapNX id
  (Curry_Prelude.nd_C_map (nd_C_updQNamesInCLocalDecl x1 s1 cd cs))) s2 cd
  cs))))

d_OP_updQNamesInCRhs_dot_uscore_hash_lambda8 :: (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CExpr AbstractCurry.Curry_Types.C_CExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 AbstractCurry.Curry_Types.C_CExpr
  AbstractCurry.Curry_Types.C_CExpr
d_OP_updQNamesInCRhs_dot_uscore_hash_lambda8 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_C_apply (d_C_updQNamesInCExpr x1 cd cs) x3 cd cs)
    (Curry_Prelude.d_C_apply (d_C_updQNamesInCExpr x1 cd cs) x4 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_updQNamesInCRhs_dot_uscore_hash_lambda8 x1 l cd cs)
    (d_OP_updQNamesInCRhs_dot_uscore_hash_lambda8 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_updQNamesInCRhs_dot_uscore_hash_lambda8 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_updQNamesInCRhs_dot_uscore_hash_lambda8 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.updQNamesInCRhs._#lambda8" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.updQNamesInCRhs._#lambda8"
    (showCons x2))

nd_OP_updQNamesInCRhs_dot_uscore_hash_lambda8 :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_Tuple2 AbstractCurry.Curry_Types.C_CExpr
  AbstractCurry.Curry_Types.C_CExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 AbstractCurry.Curry_Types.C_CExpr
  AbstractCurry.Curry_Types.C_CExpr
nd_OP_updQNamesInCRhs_dot_uscore_hash_lambda8 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s6 = s
    in s6 `seq` (let s2 = leftSupply s6
                     s5 = rightSupply s6
    in s2 `seq` (s5 `seq` Curry_Prelude.OP_Tuple2 (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_updQNamesInCExpr x1 s0
    cd cs) x3 s1 cd cs)) (let s4 = leftSupply s5
                              s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (nd_C_updQNamesInCExpr x1 s3
    cd cs) x4 s4 cd cs))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_updQNamesInCRhs_dot_uscore_hash_lambda8 x1 l s cd cs)
    (nd_OP_updQNamesInCRhs_dot_uscore_hash_lambda8 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_updQNamesInCRhs_dot_uscore_hash_lambda8 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_updQNamesInCRhs_dot_uscore_hash_lambda8 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.updQNamesInCRhs._#lambda8" [show x1, show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform.updQNamesInCRhs._#lambda8"
    (showCons x2))

d_C_updQNamesInCLocalDecl :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CLocalDecl -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CLocalDecl
d_C_updQNamesInCLocalDecl x1 cd cs = d_C_updCLocalDecl (d_C_updQNamesInCFuncDecl
  x1 cd cs) (d_C_updQNamesInCPattern x1 cd cs) (d_C_updQNamesInCRhs x1 cd cs)
  Curry_Prelude.d_C_id cd cs

nd_C_updQNamesInCLocalDecl :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> IDSupply -> Cover -> ConstStore -> Func
  AbstractCurry.Curry_Types.C_CLocalDecl AbstractCurry.Curry_Types.C_CLocalDecl
nd_C_updQNamesInCLocalDecl x1 s cd cs = let s4 = s
  in s4 `seq` (let s5 = leftSupply s4
                   s6 = rightSupply s4
                   s3 = leftSupply s5
                   s0 = rightSupply s5
                   s1 = leftSupply s6
                   s2 = rightSupply s6
  in s5 `seq` (s6 `seq` (s3 `seq` (s0 `seq` (s1 `seq` (s2 `seq`
  nd_C_updCLocalDecl (nd_C_updQNamesInCFuncDecl x1 s0 cd cs)
  (nd_C_updQNamesInCPattern x1 s1 cd cs) (nd_C_updQNamesInCRhs x1 s2 cd cs)
  (wrapDX id Curry_Prelude.d_C_id) s3 cd cs))))))

d_C_updQNamesInCPattern :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CPattern -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CPattern
d_C_updQNamesInCPattern x1 cd cs = d_C_updCPattern Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id x1 cd cs

nd_C_updQNamesInCPattern :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Func AbstractCurry.Curry_Types.C_CPattern
  AbstractCurry.Curry_Types.C_CPattern
nd_C_updQNamesInCPattern x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updCPattern (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) x1 s0 cd cs

d_C_updQNamesInCStatement :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CStatement -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CStatement
d_C_updQNamesInCStatement x1 cd cs = d_C_updCStatement (d_C_updQNamesInCExpr x1
  cd cs) (d_C_updQNamesInCPattern x1 cd cs) (d_C_updQNamesInCLocalDecl x1 cd cs)
  cd cs

nd_C_updQNamesInCStatement :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> IDSupply -> Cover -> ConstStore -> Func
  AbstractCurry.Curry_Types.C_CStatement AbstractCurry.Curry_Types.C_CStatement
nd_C_updQNamesInCStatement x1 s cd cs = let s4 = s
  in s4 `seq` (let s5 = leftSupply s4
                   s6 = rightSupply s4
                   s3 = leftSupply s5
                   s0 = rightSupply s5
                   s1 = leftSupply s6
                   s2 = rightSupply s6
  in s5 `seq` (s6 `seq` (s3 `seq` (s0 `seq` (s1 `seq` (s2 `seq`
  nd_C_updCStatement (nd_C_updQNamesInCExpr x1 s0 cd cs)
  (nd_C_updQNamesInCPattern x1 s1 cd cs) (nd_C_updQNamesInCLocalDecl x1 s2 cd
  cs) s3 cd cs))))))

d_C_updQNamesInCExpr :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CExpr -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CExpr
d_C_updQNamesInCExpr x1 cd cs = d_C_trExpr (acceptCs id
  AbstractCurry.Curry_Types.C_CVar) (acceptCs id
  AbstractCurry.Curry_Types.C_CLit) (Curry_Prelude.d_OP_dot (acceptCs id
  AbstractCurry.Curry_Types.C_CSymbol) x1 cd cs) (acceptCs (acceptCs id)
  AbstractCurry.Curry_Types.C_CApply) (acceptCs id
  (d_OP_updQNamesInCExpr_dot_lam_dot_270 x1)) (acceptCs id
  (d_OP_updQNamesInCExpr_dot_ldecl_dot_270 x1))
  (d_OP_updQNamesInCExpr_dot_doexp_dot_270 x1) (acceptCs id
  (d_OP_updQNamesInCExpr_dot_lcomp_dot_270 x1)) (acceptCs (acceptCs id)
  (d_OP_updQNamesInCExpr_dot_ccase_dot_270 x1)) (acceptCs id
  (d_OP_updQNamesInCExpr_dot_ctyped_dot_270 x1)) (acceptCs id
  (d_OP_updQNamesInCExpr_dot_reccon_dot_270 x1)) (acceptCs id
  (d_OP_updQNamesInCExpr_dot_recupd_dot_270 x1))

nd_C_updQNamesInCExpr :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Func AbstractCurry.Curry_Types.C_CExpr
  AbstractCurry.Curry_Types.C_CExpr
nd_C_updQNamesInCExpr x1 s cd cs = let s0 = s
  in s0 `seq` wrapNX id (nd_C_trExpr (wrapDX id (acceptCs id
  AbstractCurry.Curry_Types.C_CVar)) (wrapDX id (acceptCs id
  AbstractCurry.Curry_Types.C_CLit)) (Curry_Prelude.nd_OP_dot (wrapDX id
  (acceptCs id AbstractCurry.Curry_Types.C_CSymbol)) x1 s0 cd cs) (wrapDX
  (wrapDX id) (acceptCs (acceptCs id) AbstractCurry.Curry_Types.C_CApply))
  (wrapDX (wrapNX id) (acceptCs id (nd_OP_updQNamesInCExpr_dot_lam_dot_270 x1)))
  (wrapDX (wrapNX id) (acceptCs id (nd_OP_updQNamesInCExpr_dot_ldecl_dot_270
  x1))) (wrapNX id (nd_OP_updQNamesInCExpr_dot_doexp_dot_270 x1)) (wrapDX
  (wrapNX id) (acceptCs id (nd_OP_updQNamesInCExpr_dot_lcomp_dot_270 x1)))
  (wrapDX (wrapDX (wrapNX id)) (acceptCs (acceptCs id)
  (nd_OP_updQNamesInCExpr_dot_ccase_dot_270 x1))) (wrapDX (wrapNX id) (acceptCs
  id (nd_OP_updQNamesInCExpr_dot_ctyped_dot_270 x1))) (wrapDX (wrapNX id)
  (acceptCs id (nd_OP_updQNamesInCExpr_dot_reccon_dot_270 x1))) (wrapDX (wrapNX
  id) (acceptCs id (nd_OP_updQNamesInCExpr_dot_recupd_dot_270 x1))))

d_OP_updQNamesInCExpr_dot_lam_dot_270 :: (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CPattern -> AbstractCurry.Curry_Types.C_CExpr
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CExpr
d_OP_updQNamesInCExpr_dot_lam_dot_270 x1 x2 x3 cd cs =
  AbstractCurry.Curry_Types.C_CLambda (Curry_Prelude.d_C_map
  (d_C_updQNamesInCPattern x1 cd cs) x2 cd cs) x3

nd_OP_updQNamesInCExpr_dot_lam_dot_270 :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CPattern
  -> AbstractCurry.Curry_Types.C_CExpr -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CExpr
nd_OP_updQNamesInCExpr_dot_lam_dot_270 x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` AbstractCurry.Curry_Types.C_CLambda (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_map (nd_C_updQNamesInCPattern x1 s0
  cd cs) x2 s1 cd cs)) x3

d_OP_updQNamesInCExpr_dot_ldecl_dot_270 :: (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CLocalDecl -> AbstractCurry.Curry_Types.C_CExpr
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CExpr
d_OP_updQNamesInCExpr_dot_ldecl_dot_270 x1 x2 x3 cd cs =
  AbstractCurry.Curry_Types.C_CLetDecl (Curry_Prelude.d_C_map
  (d_C_updQNamesInCLocalDecl x1 cd cs) x2 cd cs) x3

nd_OP_updQNamesInCExpr_dot_ldecl_dot_270 :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl
  -> AbstractCurry.Curry_Types.C_CExpr -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CExpr
nd_OP_updQNamesInCExpr_dot_ldecl_dot_270 x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` AbstractCurry.Curry_Types.C_CLetDecl (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_map (nd_C_updQNamesInCLocalDecl x1 s0
  cd cs) x2 s1 cd cs)) x3

d_OP_updQNamesInCExpr_dot_doexp_dot_270 :: (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CStatement -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CExpr
d_OP_updQNamesInCExpr_dot_doexp_dot_270 x1 x2 cd cs =
  AbstractCurry.Curry_Types.C_CDoExpr (Curry_Prelude.d_C_map
  (d_C_updQNamesInCStatement x1 cd cs) x2 cd cs)

nd_OP_updQNamesInCExpr_dot_doexp_dot_270 :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CStatement -> IDSupply
  -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CExpr
nd_OP_updQNamesInCExpr_dot_doexp_dot_270 x1 x2 s cd cs = let s2 = s
  in s2 `seq` AbstractCurry.Curry_Types.C_CDoExpr (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_map (nd_C_updQNamesInCStatement x1 s0
  cd cs) x2 s1 cd cs))

d_OP_updQNamesInCExpr_dot_lcomp_dot_270 :: (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> AbstractCurry.Curry_Types.C_CExpr
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CStatement -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CExpr
d_OP_updQNamesInCExpr_dot_lcomp_dot_270 x1 x2 x3 cd cs =
  AbstractCurry.Curry_Types.C_CListComp x2 (Curry_Prelude.d_C_map
  (d_C_updQNamesInCStatement x1 cd cs) x3 cd cs)

nd_OP_updQNamesInCExpr_dot_lcomp_dot_270 :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> AbstractCurry.Curry_Types.C_CExpr -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CStatement -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CExpr
nd_OP_updQNamesInCExpr_dot_lcomp_dot_270 x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` AbstractCurry.Curry_Types.C_CListComp x2 (let s1 = leftSupply s2
                                                            s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_map (nd_C_updQNamesInCStatement x1 s0
  cd cs) x3 s1 cd cs))

d_OP_updQNamesInCExpr_dot_ccase_dot_270 :: (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> AbstractCurry.Curry_Types.C_CCaseType
  -> AbstractCurry.Curry_Types.C_CExpr -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 AbstractCurry.Curry_Types.C_CPattern
  AbstractCurry.Curry_Types.C_CRhs) -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CExpr
d_OP_updQNamesInCExpr_dot_ccase_dot_270 x1 x2 x3 x4 cd cs =
  AbstractCurry.Curry_Types.C_CCase x2 x3 (Curry_Prelude.d_C_map
  (d_OP_updQNamesInCExpr_dot_ccase_dot_270_dot_uscore_hash_lambda9 x1) x4 cd cs)

nd_OP_updQNamesInCExpr_dot_ccase_dot_270 :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> AbstractCurry.Curry_Types.C_CCaseType -> AbstractCurry.Curry_Types.C_CExpr
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CPattern AbstractCurry.Curry_Types.C_CRhs)
  -> IDSupply -> Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CExpr
nd_OP_updQNamesInCExpr_dot_ccase_dot_270 x1 x2 x3 x4 s cd cs = let s0 = s
  in s0 `seq` AbstractCurry.Curry_Types.C_CCase x2 x3 (Curry_Prelude.nd_C_map
  (wrapNX id (nd_OP_updQNamesInCExpr_dot_ccase_dot_270_dot_uscore_hash_lambda9
  x1)) x4 s0 cd cs)

d_OP_updQNamesInCExpr_dot_ccase_dot_270_dot_uscore_hash_lambda9 :: (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CPattern AbstractCurry.Curry_Types.C_CRhs -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 AbstractCurry.Curry_Types.C_CPattern
  AbstractCurry.Curry_Types.C_CRhs
d_OP_updQNamesInCExpr_dot_ccase_dot_270_dot_uscore_hash_lambda9 x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_C_apply (d_C_updQNamesInCPattern x1 cd cs) x3 cd cs)
    (Curry_Prelude.d_C_apply (d_C_updQNamesInCRhs x1 cd cs) x4 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_updQNamesInCExpr_dot_ccase_dot_270_dot_uscore_hash_lambda9 x1 l cd cs)
    (d_OP_updQNamesInCExpr_dot_ccase_dot_270_dot_uscore_hash_lambda9 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_updQNamesInCExpr_dot_ccase_dot_270_dot_uscore_hash_lambda9 x1 z cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_updQNamesInCExpr_dot_ccase_dot_270_dot_uscore_hash_lambda9 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.updQNamesInCExpr.ccase.270._#lambda9" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Transform.updQNamesInCExpr.ccase.270._#lambda9" (showCons
    x2))

nd_OP_updQNamesInCExpr_dot_ccase_dot_270_dot_uscore_hash_lambda9 :: Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CPattern AbstractCurry.Curry_Types.C_CRhs
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CPattern AbstractCurry.Curry_Types.C_CRhs
nd_OP_updQNamesInCExpr_dot_ccase_dot_270_dot_uscore_hash_lambda9 x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s6 = s
    in s6 `seq` (let s2 = leftSupply s6
                     s5 = rightSupply s6
    in s2 `seq` (s5 `seq` Curry_Prelude.OP_Tuple2 (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_updQNamesInCPattern x1
    s0 cd cs) x3 s1 cd cs)) (let s4 = leftSupply s5
                                 s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (nd_C_updQNamesInCRhs x1 s3
    cd cs) x4 s4 cd cs))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_updQNamesInCExpr_dot_ccase_dot_270_dot_uscore_hash_lambda9 x1 l s cd
    cs) (nd_OP_updQNamesInCExpr_dot_ccase_dot_270_dot_uscore_hash_lambda9 x1 r s
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_updQNamesInCExpr_dot_ccase_dot_270_dot_uscore_hash_lambda9 x1 z s cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_updQNamesInCExpr_dot_ccase_dot_270_dot_uscore_hash_lambda9 x1 e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.updQNamesInCExpr.ccase.270._#lambda9" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Transform.updQNamesInCExpr.ccase.270._#lambda9" (showCons
    x2))

d_OP_updQNamesInCExpr_dot_ctyped_dot_270 :: (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> AbstractCurry.Curry_Types.C_CExpr
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CExpr
d_OP_updQNamesInCExpr_dot_ctyped_dot_270 x1 x2 x3 cd cs =
  AbstractCurry.Curry_Types.C_CTyped x2 (Curry_Prelude.d_C_apply
  (d_C_updQNamesInCQualTypeExpr x1 cd cs) x3 cd cs)

nd_OP_updQNamesInCExpr_dot_ctyped_dot_270 :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> AbstractCurry.Curry_Types.C_CExpr
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr -> IDSupply -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CExpr
nd_OP_updQNamesInCExpr_dot_ctyped_dot_270 x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` AbstractCurry.Curry_Types.C_CTyped x2 (let s1 = leftSupply s2
                                                         s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_updQNamesInCQualTypeExpr
  x1 s0 cd cs) x3 s1 cd cs))

d_OP_updQNamesInCExpr_dot_reccon_dot_270 :: (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) AbstractCurry.Curry_Types.C_CExpr) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CExpr
d_OP_updQNamesInCExpr_dot_reccon_dot_270 x1 x2 x3 cd cs =
  AbstractCurry.Curry_Types.C_CRecConstr (Curry_Prelude.d_C_apply x1 x2 cd cs)
  (Curry_Prelude.d_C_map
  (d_OP_updQNamesInCExpr_dot_reccon_dot_270_dot_uscore_hash_lambda10 x1) x3 cd
  cs)

nd_OP_updQNamesInCExpr_dot_reccon_dot_270 :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  AbstractCurry.Curry_Types.C_CExpr) -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CExpr
nd_OP_updQNamesInCExpr_dot_reccon_dot_270 x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` AbstractCurry.Curry_Types.C_CRecConstr
  (Curry_Prelude.nd_C_apply x1 x2 s0 cd cs) (Curry_Prelude.nd_C_map (wrapNX id
  (nd_OP_updQNamesInCExpr_dot_reccon_dot_270_dot_uscore_hash_lambda10 x1)) x3 s1
  cd cs)))

d_OP_updQNamesInCExpr_dot_reccon_dot_270_dot_uscore_hash_lambda10 :: (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) AbstractCurry.Curry_Types.C_CExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) AbstractCurry.Curry_Types.C_CExpr
d_OP_updQNamesInCExpr_dot_reccon_dot_270_dot_uscore_hash_lambda10 x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_C_apply x1 x3 cd cs) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_updQNamesInCExpr_dot_reccon_dot_270_dot_uscore_hash_lambda10 x1 l cd
    cs) (d_OP_updQNamesInCExpr_dot_reccon_dot_270_dot_uscore_hash_lambda10 x1 r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_updQNamesInCExpr_dot_reccon_dot_270_dot_uscore_hash_lambda10 x1 z cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_updQNamesInCExpr_dot_reccon_dot_270_dot_uscore_hash_lambda10 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.updQNamesInCExpr.reccon.270._#lambda10" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Transform.updQNamesInCExpr.reccon.270._#lambda10" (showCons
    x2))

nd_OP_updQNamesInCExpr_dot_reccon_dot_270_dot_uscore_hash_lambda10 :: Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) AbstractCurry.Curry_Types.C_CExpr -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) AbstractCurry.Curry_Types.C_CExpr
nd_OP_updQNamesInCExpr_dot_reccon_dot_270_dot_uscore_hash_lambda10 x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_apply x1 x3 s0 cd
    cs) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_updQNamesInCExpr_dot_reccon_dot_270_dot_uscore_hash_lambda10 x1 l s
    cd cs) (nd_OP_updQNamesInCExpr_dot_reccon_dot_270_dot_uscore_hash_lambda10
    x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_updQNamesInCExpr_dot_reccon_dot_270_dot_uscore_hash_lambda10 x1 z s cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_updQNamesInCExpr_dot_reccon_dot_270_dot_uscore_hash_lambda10 x1 e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.updQNamesInCExpr.reccon.270._#lambda10" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Transform.updQNamesInCExpr.reccon.270._#lambda10" (showCons
    x2))

d_OP_updQNamesInCExpr_dot_recupd_dot_270 :: (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> AbstractCurry.Curry_Types.C_CExpr
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) AbstractCurry.Curry_Types.C_CExpr) -> Cover
  -> ConstStore -> AbstractCurry.Curry_Types.C_CExpr
d_OP_updQNamesInCExpr_dot_recupd_dot_270 x1 x2 x3 cd cs =
  AbstractCurry.Curry_Types.C_CRecUpdate x2 (Curry_Prelude.d_C_map
  (d_OP_updQNamesInCExpr_dot_recupd_dot_270_dot_uscore_hash_lambda11 x1) x3 cd
  cs)

nd_OP_updQNamesInCExpr_dot_recupd_dot_270 :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> AbstractCurry.Curry_Types.C_CExpr -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  AbstractCurry.Curry_Types.C_CExpr) -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CExpr
nd_OP_updQNamesInCExpr_dot_recupd_dot_270 x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` AbstractCurry.Curry_Types.C_CRecUpdate x2 (Curry_Prelude.nd_C_map
  (wrapNX id (nd_OP_updQNamesInCExpr_dot_recupd_dot_270_dot_uscore_hash_lambda11
  x1)) x3 s0 cd cs)

d_OP_updQNamesInCExpr_dot_recupd_dot_270_dot_uscore_hash_lambda11 :: (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) AbstractCurry.Curry_Types.C_CExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) AbstractCurry.Curry_Types.C_CExpr
d_OP_updQNamesInCExpr_dot_recupd_dot_270_dot_uscore_hash_lambda11 x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_C_apply x1 x3 cd cs) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_updQNamesInCExpr_dot_recupd_dot_270_dot_uscore_hash_lambda11 x1 l cd
    cs) (d_OP_updQNamesInCExpr_dot_recupd_dot_270_dot_uscore_hash_lambda11 x1 r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_updQNamesInCExpr_dot_recupd_dot_270_dot_uscore_hash_lambda11 x1 z cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_updQNamesInCExpr_dot_recupd_dot_270_dot_uscore_hash_lambda11 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.updQNamesInCExpr.recupd.270._#lambda11" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Transform.updQNamesInCExpr.recupd.270._#lambda11" (showCons
    x2))

nd_OP_updQNamesInCExpr_dot_recupd_dot_270_dot_uscore_hash_lambda11 :: Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) AbstractCurry.Curry_Types.C_CExpr -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) AbstractCurry.Curry_Types.C_CExpr
nd_OP_updQNamesInCExpr_dot_recupd_dot_270_dot_uscore_hash_lambda11 x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_apply x1 x3 s0 cd
    cs) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_updQNamesInCExpr_dot_recupd_dot_270_dot_uscore_hash_lambda11 x1 l s
    cd cs) (nd_OP_updQNamesInCExpr_dot_recupd_dot_270_dot_uscore_hash_lambda11
    x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_updQNamesInCExpr_dot_recupd_dot_270_dot_uscore_hash_lambda11 x1 z s cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_updQNamesInCExpr_dot_recupd_dot_270_dot_uscore_hash_lambda11 x1 e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.updQNamesInCExpr.recupd.270._#lambda11" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Transform.updQNamesInCExpr.recupd.270._#lambda11" (showCons
    x2))

d_C_typesOfCurryProg :: Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CurryProg -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_typesOfCurryProg cd cs = d_C_trCProg (acceptCs (acceptCs (acceptCs (acceptCs
  (acceptCs (acceptCs (acceptCs id))))))
  d_OP_typesOfCurryProg_dot_uscore_hash_lambda12)

d_OP_typesOfCurryProg_dot_typesOfDefault_dot_291 :: Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CDefaultDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_typesOfCurryProg_dot_typesOfDefault_dot_291 x1 cd cs = case x1 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.OP_List
  Curry_Prelude.C_Just x2 -> d_C__case_0 x2 cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (d_OP_typesOfCurryProg_dot_typesOfDefault_dot_291 l cd cs)
    (d_OP_typesOfCurryProg_dot_typesOfDefault_dot_291 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    d_OP_typesOfCurryProg_dot_typesOfDefault_dot_291 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x ->
    d_OP_typesOfCurryProg_dot_typesOfDefault_dot_291 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "AbstractCurry.Transform.typesOfCurryProg.typesOfDefault.291" [show x1]
    info)
  _ -> failCons cd (consFail
    "AbstractCurry.Transform.typesOfCurryProg.typesOfDefault.291" (showCons x1))

d_OP_typesOfCurryProg_dot_uscore_hash_lambda12 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CDefaultDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CClassDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CInstanceDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_COpDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_typesOfCurryProg_dot_uscore_hash_lambda12 x1 x2 x3 x4 x5 x6 x7 x8 cd cs =
  Curry_Prelude.d_OP_plus_plus (d_OP_typesOfCurryProg_dot_typesOfDefault_dot_291
  x3 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply (d_C_unionMap
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (d_C_typesOfCClassDecl cd cs) cd cs) x4 cd cs) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.d_C_apply (d_C_unionMap
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (d_C_typesOfCInstanceDecl cd cs) cd cs) x5 cd cs)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply (d_C_unionMap
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (d_C_typesOfCTypeDecl cd cs) cd cs) x6 cd cs) (Curry_Prelude.d_C_apply
  (d_C_unionMap
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (d_C_typesOfCFuncDecl cd cs) cd cs) x7 cd cs) cd cs) cd cs) cd cs) cd cs

d_C_typesOfCClassDecl :: Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CClassDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_typesOfCClassDecl cd cs = d_C_trCClassDecl (acceptCs (acceptCs (acceptCs
  (acceptCs (acceptCs id)))) d_OP_typesOfCClassDecl_dot_uscore_hash_lambda13)

d_OP_typesOfCClassDecl_dot_uscore_hash_lambda13 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CVisibility
  -> AbstractCurry.Curry_Types.C_CContext -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_typesOfCClassDecl_dot_uscore_hash_lambda13 x1 x2 x3 x4 x5 x6 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply (d_C_typesOfContext cd
  cs) x3 cd cs) (Curry_Prelude.d_C_apply (d_C_unionMap
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (d_C_typesOfCFuncDecl cd cs) cd cs) x6 cd cs) cd cs

d_C_typesOfCInstanceDecl :: Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CInstanceDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_typesOfCInstanceDecl cd cs = d_C_trCInstanceDecl (acceptCs (acceptCs
  (acceptCs id)) d_OP_typesOfCInstanceDecl_dot_uscore_hash_lambda14)

d_OP_typesOfCInstanceDecl_dot_uscore_hash_lambda14 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CContext
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_typesOfCInstanceDecl_dot_uscore_hash_lambda14 x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply (d_C_typesOfContext cd
  cs) x2 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_concatMap (d_C_typesOfTypeExpr cd cs) cd cs) x3 cd cs)
  (Curry_Prelude.d_C_apply (d_C_unionMap
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (d_C_typesOfCFuncDecl cd cs) cd cs) x4 cd cs) cd cs) cd cs

d_C_typesOfCTypeDecl :: Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CTypeDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_typesOfCTypeDecl cd cs = d_C_trCTypeDecl (acceptCs (acceptCs (acceptCs
  (acceptCs id))) d_OP_typesOfCTypeDecl_dot_uscore_hash_lambda15) (acceptCs
  (acceptCs (acceptCs id)) d_OP_typesOfCTypeDecl_dot_uscore_hash_lambda16)
  (acceptCs (acceptCs (acceptCs (acceptCs id)))
  d_OP_typesOfCTypeDecl_dot_uscore_hash_lambda17)

d_OP_typesOfCTypeDecl_dot_uscore_hash_lambda15 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CVisibility
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CConsDecl -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_typesOfCTypeDecl_dot_uscore_hash_lambda15 x1 x2 x3 x4 x5 cd cs =
  Curry_Prelude.OP_Cons x1 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap
  (d_C_typesOfConsDecl cd cs) cd cs) x4 cd cs)

d_OP_typesOfCTypeDecl_dot_uscore_hash_lambda16 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CVisibility
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_typesOfCTypeDecl_dot_uscore_hash_lambda16 x1 x2 x3 x4 cd cs =
  Curry_Prelude.OP_Cons x1 (Curry_Prelude.d_C_apply (d_C_typesOfTypeExpr cd cs)
  x4 cd cs)

d_OP_typesOfCTypeDecl_dot_uscore_hash_lambda17 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CVisibility
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> AbstractCurry.Curry_Types.C_CConsDecl -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_typesOfCTypeDecl_dot_uscore_hash_lambda17 x1 x2 x3 x4 x5 cd cs =
  Curry_Prelude.OP_Cons x1 (Curry_Prelude.d_C_apply (d_C_typesOfConsDecl cd cs)
  x4 cd cs)

d_C_typesOfConsDecl :: Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CConsDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_typesOfConsDecl cd cs = d_C_trCConsDecl (acceptCs (acceptCs id)
  d_OP_typesOfConsDecl_dot_uscore_hash_lambda18) (acceptCs (acceptCs id)
  d_OP_typesOfConsDecl_dot_uscore_hash_lambda19)

d_OP_typesOfConsDecl_dot_uscore_hash_lambda18 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CVisibility
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_typesOfConsDecl_dot_uscore_hash_lambda18 x1 x2 x3 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap (d_C_typesOfTypeExpr cd
  cs) cd cs) x3 cd cs

d_OP_typesOfConsDecl_dot_uscore_hash_lambda19 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CVisibility
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFieldDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_typesOfConsDecl_dot_uscore_hash_lambda19 x1 x2 x3 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap (d_C_typesOfFieldDecl cd
  cs) cd cs) x3 cd cs

d_C_typesOfFieldDecl :: Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CFieldDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_typesOfFieldDecl cd cs = d_C_trCFieldDecl (acceptCs (acceptCs id)
  d_OP_typesOfFieldDecl_dot_uscore_hash_lambda20)

d_OP_typesOfFieldDecl_dot_uscore_hash_lambda20 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CVisibility
  -> AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_typesOfFieldDecl_dot_uscore_hash_lambda20 x1 x2 x3 cd cs =
  Curry_Prelude.d_C_apply (d_C_typesOfTypeExpr cd cs) x3 cd cs

d_C_typesOfContext :: Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CContext -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_typesOfContext cd cs = d_C_trCContext (Curry_Prelude.d_C_concatMap
  (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_concatMap (d_C_typesOfTypeExpr cd
  cs) cd cs) Curry_Prelude.d_C_snd cd cs) cd cs)

d_C_typesOfTypeExpr :: Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_typesOfTypeExpr cd cs = d_C_trCTypeExpr
  d_OP_typesOfTypeExpr_dot_uscore_hash_lambda21
  d_OP_typesOfTypeExpr_dot_uscore_hash_lambda22 (acceptCs id
  Curry_Prelude.d_OP_plus_plus) (acceptCs id Curry_Prelude.d_OP_plus_plus)

d_OP_typesOfTypeExpr_dot_uscore_hash_lambda21 :: Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_typesOfTypeExpr_dot_uscore_hash_lambda21 x1 cd cs = Curry_Prelude.OP_List

d_OP_typesOfTypeExpr_dot_uscore_hash_lambda22 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_typesOfTypeExpr_dot_uscore_hash_lambda22 x1 cd cs = Curry_Prelude.OP_Cons
  x1 Curry_Prelude.OP_List

d_C_typesOfQualTypeExpr :: Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_typesOfQualTypeExpr cd cs = d_C_trCQualTypeExpr (acceptCs id
  d_OP_typesOfQualTypeExpr_dot_uscore_hash_lambda23)

d_OP_typesOfQualTypeExpr_dot_uscore_hash_lambda23 :: AbstractCurry.Curry_Types.C_CContext
  -> AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_typesOfQualTypeExpr_dot_uscore_hash_lambda23 x1 x2 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply (d_C_typesOfContext cd
  cs) x1 cd cs) (Curry_Prelude.d_C_apply (d_C_typesOfTypeExpr cd cs) x2 cd cs)
  cd cs

d_C_typesOfCFuncDecl :: Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CFuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_typesOfCFuncDecl cd cs = d_C_trCFuncDecl (acceptCs (acceptCs (acceptCs
  (acceptCs (acceptCs id)))) d_OP_typesOfCFuncDecl_dot_uscore_hash_lambda24)

d_OP_typesOfCFuncDecl_dot_uscore_hash_lambda24 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Int -> AbstractCurry.Curry_Types.C_CVisibility
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CRule -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_typesOfCFuncDecl_dot_uscore_hash_lambda24 x1 x2 x3 x4 x5 x6 cd cs =
  Curry_Prelude.d_C_apply (d_C_typesOfQualTypeExpr cd cs) x5 cd cs

d_C_unionMap :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> (t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  t1 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_unionMap x1 x2 cd cs = Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_foldr
  (acceptCs id (Data.Curry_List.d_C_union x1)) Curry_Prelude.OP_List)
  (Curry_Prelude.d_C_map (Curry_Prelude.d_OP_dot (Data.Curry_List.d_C_nub x1) x2
  cd cs)) cd cs

nd_C_unionMap :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Func t1 (Curry_Prelude.OP_List t0) -> IDSupply -> Cover -> ConstStore
  -> Func (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List t0)
nd_C_unionMap x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (wrapNX id
  (Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs id
  (Data.Curry_List.nd_C_union x1))) Curry_Prelude.OP_List)) (wrapNX id
  (Curry_Prelude.nd_C_map (Curry_Prelude.nd_OP_dot (wrapNX id
  (Data.Curry_List.nd_C_nub x1)) x2 s0 cd cs))) s1 cd cs))

d_C_funcsOfCurryProg :: Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CurryProg -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_funcsOfCurryProg cd cs = d_C_trCProg (acceptCs (acceptCs (acceptCs (acceptCs
  (acceptCs (acceptCs (acceptCs id))))))
  d_OP_funcsOfCurryProg_dot_uscore_hash_lambda25)

d_OP_funcsOfCurryProg_dot_uscore_hash_lambda25 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Maybe
  AbstractCurry.Curry_Types.C_CDefaultDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CClassDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CInstanceDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CTypeDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_COpDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_funcsOfCurryProg_dot_uscore_hash_lambda25 x1 x2 x3 x4 x5 x6 x7 x8 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply (d_C_unionMap
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (d_C_funcsOfCClassDecl cd cs) cd cs) x4 cd cs) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.d_C_apply (d_C_unionMap
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (d_C_funcsOfCInstanceDecl cd cs) cd cs) x5 cd cs)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply (d_C_unionMap
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (d_C_funcsOfCTypeDecl cd cs) cd cs) x6 cd cs) (Curry_Prelude.d_C_apply
  (d_C_unionMap
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (d_C_funcsOfCFuncDecl cd cs) cd cs) x7 cd cs) cd cs) cd cs) cd cs

d_C_funcsOfCClassDecl :: Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CClassDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_funcsOfCClassDecl cd cs = d_C_trCClassDecl (acceptCs (acceptCs (acceptCs
  (acceptCs (acceptCs id)))) d_OP_funcsOfCClassDecl_dot_uscore_hash_lambda26)

d_OP_funcsOfCClassDecl_dot_uscore_hash_lambda26 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CVisibility
  -> AbstractCurry.Curry_Types.C_CContext -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CFuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_funcsOfCClassDecl_dot_uscore_hash_lambda26 x1 x2 x3 x4 x5 x6 cd cs =
  Curry_Prelude.d_C_apply (d_C_unionMap
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (d_C_funcsOfCFuncDecl cd cs) cd cs) x6 cd cs

d_C_funcsOfCInstanceDecl :: Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CInstanceDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_funcsOfCInstanceDecl cd cs = d_C_trCInstanceDecl (acceptCs (acceptCs
  (acceptCs id)) d_OP_funcsOfCInstanceDecl_dot_uscore_hash_lambda27)

d_OP_funcsOfCInstanceDecl_dot_uscore_hash_lambda27 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CContext
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFuncDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_funcsOfCInstanceDecl_dot_uscore_hash_lambda27 x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_C_apply (d_C_unionMap
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
  (d_C_funcsOfCFuncDecl cd cs) cd cs) x4 cd cs

d_C_funcsOfCTypeDecl :: Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CTypeDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_funcsOfCTypeDecl cd cs = d_C_trCTypeDecl (acceptCs (acceptCs (acceptCs
  (acceptCs id))) d_OP_funcsOfCTypeDecl_dot_uscore_hash_lambda28) (acceptCs
  (acceptCs (acceptCs id)) d_OP_funcsOfCTypeDecl_dot_uscore_hash_lambda29)
  (acceptCs (acceptCs (acceptCs (acceptCs id)))
  d_OP_funcsOfCTypeDecl_dot_uscore_hash_lambda30)

d_OP_funcsOfCTypeDecl_dot_uscore_hash_lambda28 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CVisibility
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CConsDecl -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_funcsOfCTypeDecl_dot_uscore_hash_lambda28 x1 x2 x3 x4 x5 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap (d_C_funcsOfConsDecl cd
  cs) cd cs) x4 cd cs

d_OP_funcsOfCTypeDecl_dot_uscore_hash_lambda29 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CVisibility
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_funcsOfCTypeDecl_dot_uscore_hash_lambda29 x1 x2 x3 x4 cd cs =
  Curry_Prelude.OP_List

d_OP_funcsOfCTypeDecl_dot_uscore_hash_lambda30 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CVisibility
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> AbstractCurry.Curry_Types.C_CConsDecl -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_funcsOfCTypeDecl_dot_uscore_hash_lambda30 x1 x2 x3 x4 x5 cd cs =
  Curry_Prelude.d_C_apply (d_C_funcsOfConsDecl cd cs) x4 cd cs

d_C_funcsOfConsDecl :: Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CConsDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_funcsOfConsDecl cd cs = d_C_trCConsDecl (acceptCs (acceptCs id)
  d_OP_funcsOfConsDecl_dot_uscore_hash_lambda31) (acceptCs (acceptCs id)
  d_OP_funcsOfConsDecl_dot_uscore_hash_lambda32)

d_OP_funcsOfConsDecl_dot_uscore_hash_lambda31 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CVisibility
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CTypeExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_funcsOfConsDecl_dot_uscore_hash_lambda31 x1 x2 x3 cd cs =
  Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List

d_OP_funcsOfConsDecl_dot_uscore_hash_lambda32 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CVisibility
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CFieldDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_funcsOfConsDecl_dot_uscore_hash_lambda32 x1 x2 x3 cd cs =
  Curry_Prelude.OP_Cons x1 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap
  (d_C_funcsOfFieldDecl cd cs) cd cs) x3 cd cs)

d_C_funcsOfFieldDecl :: Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CFieldDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_funcsOfFieldDecl cd cs = d_C_trCFieldDecl (acceptCs (acceptCs id)
  d_OP_funcsOfFieldDecl_dot_uscore_hash_lambda33)

d_OP_funcsOfFieldDecl_dot_uscore_hash_lambda33 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> AbstractCurry.Curry_Types.C_CVisibility
  -> AbstractCurry.Curry_Types.C_CTypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_funcsOfFieldDecl_dot_uscore_hash_lambda33 x1 x2 x3 cd cs =
  Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List

d_C_funcsOfCFuncDecl :: Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CFuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_funcsOfCFuncDecl cd cs = d_C_trCFuncDecl (acceptCs (acceptCs (acceptCs
  (acceptCs (acceptCs id)))) d_OP_funcsOfCFuncDecl_dot_uscore_hash_lambda34)

d_OP_funcsOfCFuncDecl_dot_uscore_hash_lambda34 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Int -> AbstractCurry.Curry_Types.C_CVisibility
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CRule -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_funcsOfCFuncDecl_dot_uscore_hash_lambda34 x1 x2 x3 x4 x5 x6 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap (d_C_funcsOfCRule cd cs)
  cd cs) x6 cd cs

d_C_funcsOfCRule :: Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CRule
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_funcsOfCRule cd cs = d_C_trCRule (acceptCs id
  d_OP_funcsOfCRule_dot_uscore_hash_lambda35)

d_OP_funcsOfCRule_dot_uscore_hash_lambda35 :: Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CPattern -> AbstractCurry.Curry_Types.C_CRhs
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_funcsOfCRule_dot_uscore_hash_lambda35 x1 x2 cd cs = Curry_Prelude.d_C_apply
  (d_C_funcsOfCRhs cd cs) x2 cd cs

d_C_funcsOfCRhs :: Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CRhs
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_funcsOfCRhs cd cs = d_C_trCRhs (acceptCs id
  d_OP_funcsOfCRhs_dot_uscore_hash_lambda36) (acceptCs id
  d_OP_funcsOfCRhs_dot_uscore_hash_lambda37)

d_OP_funcsOfCRhs_dot_uscore_hash_lambda36 :: AbstractCurry.Curry_Types.C_CExpr
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CLocalDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_funcsOfCRhs_dot_uscore_hash_lambda36 x1 x2 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply (d_C_funcsOfExpr cd cs)
  x1 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap
  (d_C_funcsOfLDecl cd cs) cd cs) x2 cd cs) cd cs

d_OP_funcsOfCRhs_dot_uscore_hash_lambda37 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 AbstractCurry.Curry_Types.C_CExpr
  AbstractCurry.Curry_Types.C_CExpr) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CLocalDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_funcsOfCRhs_dot_uscore_hash_lambda37 x1 x2 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_concatMap
  d_OP_funcsOfCRhs_dot_uscore_hash_lambda37_dot_uscore_hash_lambda38 cd cs) x1
  cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap (d_C_funcsOfLDecl
  cd cs) cd cs) x2 cd cs) cd cs

d_OP_funcsOfCRhs_dot_uscore_hash_lambda37_dot_uscore_hash_lambda38 :: Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CExpr AbstractCurry.Curry_Types.C_CExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_funcsOfCRhs_dot_uscore_hash_lambda37_dot_uscore_hash_lambda38 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply (d_C_funcsOfExpr cd cs) x2 cd cs)
    (Curry_Prelude.d_C_apply (d_C_funcsOfExpr cd cs) x3 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_funcsOfCRhs_dot_uscore_hash_lambda37_dot_uscore_hash_lambda38 l cd cs)
    (d_OP_funcsOfCRhs_dot_uscore_hash_lambda37_dot_uscore_hash_lambda38 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_funcsOfCRhs_dot_uscore_hash_lambda37_dot_uscore_hash_lambda38 z cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_funcsOfCRhs_dot_uscore_hash_lambda37_dot_uscore_hash_lambda38 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "AbstractCurry.Transform.funcsOfCRhs._#lambda37._#lambda38" [show x1] info)
  _ -> failCons cd (consFail
    "AbstractCurry.Transform.funcsOfCRhs._#lambda37._#lambda38" (showCons x1))

d_C_funcsOfLDecl :: Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CLocalDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_funcsOfLDecl cd cs = d_C_trCLocalDecl (d_C_funcsOfCFuncDecl cd cs)
  (Curry_Prelude.d_C_const (d_C_funcsOfCRhs cd cs)) (Curry_Prelude.d_C_const
  Curry_Prelude.OP_List)

d_C_funcsOfExpr :: Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_funcsOfExpr cd cs = d_C_trExpr (Curry_Prelude.d_C_const
  Curry_Prelude.OP_List) (Curry_Prelude.d_C_const Curry_Prelude.OP_List)
  d_OP_funcsOfExpr_dot_uscore_hash_lambda39 (acceptCs id
  Curry_Prelude.d_OP_plus_plus) (Curry_Prelude.d_C_const Curry_Prelude.d_C_id)
  (acceptCs id d_OP_funcsOfExpr_dot_uscore_hash_lambda40)
  (Curry_Prelude.d_C_concatMap (d_C_funcsOfStat cd cs) cd cs) (acceptCs id
  d_OP_funcsOfExpr_dot_uscore_hash_lambda41) (acceptCs (acceptCs id)
  d_OP_funcsOfExpr_dot_uscore_hash_lambda42) (acceptCs id
  d_OP_funcsOfExpr_dot_uscore_hash_lambda43) (acceptCs id
  d_OP_funcsOfExpr_dot_uscore_hash_lambda44) (acceptCs id
  d_OP_funcsOfExpr_dot_uscore_hash_lambda45)

d_OP_funcsOfExpr_dot_uscore_hash_lambda39 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_funcsOfExpr_dot_uscore_hash_lambda39 x1 cd cs = Curry_Prelude.OP_Cons x1
  Curry_Prelude.OP_List

d_OP_funcsOfExpr_dot_uscore_hash_lambda40 :: Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CLocalDecl -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_funcsOfExpr_dot_uscore_hash_lambda40 x1 x2 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_concatMap (d_C_funcsOfLDecl cd cs) cd cs) x1 cd cs) x2 cd
  cs

d_OP_funcsOfExpr_dot_uscore_hash_lambda41 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  AbstractCurry.Curry_Types.C_CStatement -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_funcsOfExpr_dot_uscore_hash_lambda41 x1 x2 cd cs =
  Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_concatMap (d_C_funcsOfStat cd cs) cd cs) x2 cd cs) cd cs

d_OP_funcsOfExpr_dot_uscore_hash_lambda42 :: AbstractCurry.Curry_Types.C_CCaseType
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  AbstractCurry.Curry_Types.C_CPattern AbstractCurry.Curry_Types.C_CRhs)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_funcsOfExpr_dot_uscore_hash_lambda42 x1 x2 x3 cd cs =
  Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_concatMap (Curry_Prelude.d_OP_dot (d_C_funcsOfCRhs cd cs)
  Curry_Prelude.d_C_snd cd cs) cd cs) x3 cd cs) cd cs

d_OP_funcsOfExpr_dot_uscore_hash_lambda43 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_funcsOfExpr_dot_uscore_hash_lambda43 x1 x2 cd cs = x1

d_OP_funcsOfExpr_dot_uscore_hash_lambda44 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_funcsOfExpr_dot_uscore_hash_lambda44 x1 x2 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_concatMap Curry_Prelude.d_C_snd cd cs) x2 cd cs

d_OP_funcsOfExpr_dot_uscore_hash_lambda45 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_funcsOfExpr_dot_uscore_hash_lambda45 x1 x2 cd cs =
  Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_concatMap Curry_Prelude.d_C_snd cd cs) x2 cd cs) cd cs

d_C_funcsOfStat :: Cover -> ConstStore -> AbstractCurry.Curry_Types.C_CStatement
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_funcsOfStat cd cs = d_C_trCStatement (d_C_funcsOfExpr cd cs)
  (Curry_Prelude.d_C_const (d_C_funcsOfExpr cd cs)) (Curry_Prelude.d_C_concatMap
  (d_C_funcsOfLDecl cd cs) cd cs)

d_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CRule
  -> (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CRule -> Cover
  -> ConstStore -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CRule)
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr
  -> (AbstractCurry.Curry_Types.C_CQualTypeExpr -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr)
  -> AbstractCurry.Curry_Types.C_CVisibility
  -> (AbstractCurry.Curry_Types.C_CVisibility -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CVisibility) -> Curry_Prelude.C_Int
  -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_Int)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CFuncDecl
d_C__case_3 x7 x12 x4 x11 x1 x10 x2 x9 x3 x8 x6 x5 x13 cd cs = case x13 of
  Curry_Prelude.C_True -> AbstractCurry.Curry_Types.C_CFunc
    (Curry_Prelude.d_C_apply x6 x8 cd cs) (Curry_Prelude.d_C_apply x3 x9 cd cs)
    (Curry_Prelude.d_C_apply x2 x10 cd cs) (Curry_Prelude.d_C_apply x1 x11 cd
    cs) (Curry_Prelude.d_C_apply x4 x12 cd cs)
  Curry_Prelude.C_False -> AbstractCurry.Curry_Types.C_CmtFunc
    (Curry_Prelude.d_C_apply x5 x7 cd cs) (Curry_Prelude.d_C_apply x6 x8 cd cs)
    (Curry_Prelude.d_C_apply x3 x9 cd cs) (Curry_Prelude.d_C_apply x2 x10 cd cs)
    (Curry_Prelude.d_C_apply x1 x11 cd cs) (Curry_Prelude.d_C_apply x4 x12 cd
    cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x7 x12 x4 x11
    x1 x10 x2 x9 x3 x8 x6 x5 l cd cs) (d_C__case_3 x7 x12 x4 x11 x1 x10 x2 x9 x3
    x8 x6 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x7
    x12 x4 x11 x1 x10 x2 x9 x3 x8 x6 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x7 x12
    x4 x11 x1 x10 x2 x9 x3 x8 x6 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Transform._case_3" [show x7, show x12, show x4, show x11
    , show x1, show x10, show x2, show x9, show x3, show x8, show x6, show x5
    , show x13] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform._case_3" (showCons x13))

nd_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CRule -> Func
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CRule)
  (Curry_Prelude.OP_List AbstractCurry.Curry_Types.C_CRule)
  -> AbstractCurry.Curry_Types.C_CQualTypeExpr -> Func
  AbstractCurry.Curry_Types.C_CQualTypeExpr
  AbstractCurry.Curry_Types.C_CQualTypeExpr
  -> AbstractCurry.Curry_Types.C_CVisibility -> Func
  AbstractCurry.Curry_Types.C_CVisibility
  AbstractCurry.Curry_Types.C_CVisibility -> Curry_Prelude.C_Int -> Func
  Curry_Prelude.C_Int Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> AbstractCurry.Curry_Types.C_CFuncDecl
nd_C__case_3 x7 x12 x4 x11 x1 x10 x2 x9 x3 x8 x6 x5 x13 s cd cs = case x13 of
  Curry_Prelude.C_True -> let s5 = s
    in s5 `seq` (let s6 = leftSupply s5
                     s7 = rightSupply s5
                     s0 = leftSupply s6
                     s1 = rightSupply s6
                     s2 = leftSupply s7
                     s8 = rightSupply s7
                     s3 = leftSupply s8
                     s4 = rightSupply s8
    in s6 `seq` (s7 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s8 `seq` (s3 `seq`
    (s4 `seq` AbstractCurry.Curry_Types.C_CFunc (Curry_Prelude.nd_C_apply x6 x8
    s0 cd cs) (Curry_Prelude.nd_C_apply x3 x9 s1 cd cs)
    (Curry_Prelude.nd_C_apply x2 x10 s2 cd cs) (Curry_Prelude.nd_C_apply x1 x11
    s3 cd cs) (Curry_Prelude.nd_C_apply x4 x12 s4 cd cs)))))))))
  Curry_Prelude.C_False -> let s6 = s
    in s6 `seq` (let s7 = leftSupply s6
                     s9 = rightSupply s6
                     s0 = leftSupply s7
                     s8 = rightSupply s7
                     s1 = leftSupply s8
                     s2 = rightSupply s8
                     s3 = leftSupply s9
                     s10 = rightSupply s9
                     s4 = leftSupply s10
                     s5 = rightSupply s10
    in s7 `seq` (s9 `seq` (s0 `seq` (s8 `seq` (s1 `seq` (s2 `seq` (s3 `seq`
    (s10 `seq` (s4 `seq` (s5 `seq` AbstractCurry.Curry_Types.C_CmtFunc
    (Curry_Prelude.nd_C_apply x5 x7 s0 cd cs) (Curry_Prelude.nd_C_apply x6 x8 s1
    cd cs) (Curry_Prelude.nd_C_apply x3 x9 s2 cd cs) (Curry_Prelude.nd_C_apply
    x2 x10 s3 cd cs) (Curry_Prelude.nd_C_apply x1 x11 s4 cd cs)
    (Curry_Prelude.nd_C_apply x4 x12 s5 cd cs)))))))))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_3 x7 x12 x4 x11
    x1 x10 x2 x9 x3 x8 x6 x5 l s cd cs) (nd_C__case_3 x7 x12 x4 x11 x1 x10 x2 x9
    x3 x8 x6 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_3 x7
    x12 x4 x11 x1 x10 x2 x9 x3 x8 x6 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_3 x7 x12
    x4 x11 x1 x10 x2 x9 x3 x8 x6 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Transform._case_3" [show x7, show x12, show x4, show x11
    , show x1, show x10, show x2, show x9, show x3, show x8, show x6, show x5
    , show x13] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform._case_3" (showCons x13))

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry
  t0) => AbstractCurry.Curry_Types.C_CurryProg -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0 -> t0 -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0
d_C__case_2 x1 x4 x3 x5 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 x2 x5
  Curry_Prelude.C_False -> d_C__case_1 x3 (Curry_Prelude.d_C_otherwise cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x1 x4 x3 x5 x2
    l cd cs) (d_C__case_2 x1 x4 x3 x5 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x1 x4
    x3 x5 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x1 x4 x3
    x5 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Transform._case_2" [show x1, show x4, show x3, show x5, show
    x2, show x6] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform._case_2" (showCons x6))

d_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0 -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0
d_C__case_1 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> x3
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x3 l cd cs)
    (d_C__case_1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x3 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "AbstractCurry.Transform._case_1" [show x3, show x4] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform._case_1" (showCons x4))

d_C__case_0 :: AbstractCurry.Curry_Types.C_CDefaultDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_0 x2 cd cs = case x2 of
  AbstractCurry.Curry_Types.C_CDefaultDecl x3 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_concatMap (d_C_typesOfTypeExpr cd cs) cd cs) x3 cd cs
  AbstractCurry.Curry_Types.Choice_C_CDefaultDecl d i l r -> narrow d i
    (d_C__case_0 l cd cs) (d_C__case_0 r cd cs)
  AbstractCurry.Curry_Types.Choices_C_CDefaultDecl d i xs -> narrows cs d i
    (\z -> d_C__case_0 z cd cs) xs
  AbstractCurry.Curry_Types.Guard_C_CDefaultDecl d c e -> guardCons d c ((\x ->
    d_C__case_0 e cd x) $! addCs c cs)
  AbstractCurry.Curry_Types.Fail_C_CDefaultDecl d info -> failCons d (traceFail
    "AbstractCurry.Transform._case_0" [show x2] info)
  _ -> failCons cd (consFail "AbstractCurry.Transform._case_0" (showCons x2))

