{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_Boxes
  ( C_Box (..)
  , C_Alignment (..)
  , C_Content (..)
  , C_Para (..)
  , C_ParaContent (..)
  , C_Line (..)
  , C_Word (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Para_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Para_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Para_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash
  , d_C_rows
  , d_C_cols
  , d_C_content
  , d_C_top
  , d_C_bottom
  , d_C_left
  , d_C_right
  , d_C_center1
  , d_C_center2
  , d_C_nullBox
  , d_C_emptyBox
  , d_C_char
  , d_C_text
  , d_OP_lt_gt
  , d_OP_lt_plus_gt
  , d_OP_slash_slash
  , d_OP_slash_plus_slash
  , d_C_hcat
  , d_C_hsep
  , d_C_vcat
  , d_C_sumMax
  , nd_C_sumMax
  , d_C_vsep
  , d_C_punctuateH
  , d_C_punctuateV
  , d_C_paraFill
  , d_C_mkParaBoxFill
  , d_C_para
  , d_C_columns
  , d_C_mkParaBox
  , d_C_flow
  , d_C_paraWidth
  , d_C_paraContent
  , d_C_fullLines
  , d_C_lastLine
  , d_C_emptyPara
  , d_C_getLines
  , d_C_lLen
  , d_C_getWords
  , d_C_mkLine
  , d_C_startLine
  , d_C_wLen
  , d_C_getWord
  , d_C_mkWord
  , d_C_addWordP
  , d_C_addWordL
  , d_C_wordFits
  , d_C_alignHoriz
  , d_C_alignVert
  , d_C_align
  , d_C_moveUp
  , d_C_moveDown
  , d_C_moveLeft
  , d_C_moveRight
  , d_C_table
  , d_C_render
  , d_C_takeP
  , d_C_fReverse
  , d_OP_star_star_star
  , nd_OP_star_star_star
  , d_C_takePA
  , d_C_blanks
  , d_C_renderBox
  , d_C_renderBoxWithRows
  , d_C_renderBoxWithCols
  , d_C_resizeBox
  , d_C_resizeBoxAligned
  , d_C_printBox
  , d_C_chunksOf
  , d_C_sum )
  where

import Basics
import qualified Data.Curry_List
import qualified Curry_Prelude


data C_Box
  = C_Box Curry_Prelude.C_Int Curry_Prelude.C_Int C_Content
  | Choice_C_Box Cover ID C_Box C_Box
  | Choices_C_Box Cover ID [C_Box]
  | Fail_C_Box Cover FailInfo
  | Guard_C_Box Cover Constraints C_Box

instance Show C_Box where
  showsPrec d (Choice_C_Box cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Box cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Box cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Box cd info) = showChar '!'
  showsPrec _ (C_Box x1 x2 x3) = showString "(Box" . (showChar ' ' . (shows x1 .
    (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . showChar ')'))))))

instance Read C_Box where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Box x1 x2 x3, r3) | (_, r0) <-
    readQualified "Boxes" "Box" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <-
    readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2]) s

instance NonDet C_Box where
  choiceCons = Choice_C_Box
  choicesCons = Choices_C_Box
  failCons = Fail_C_Box
  guardCons = Guard_C_Box
  try (Choice_C_Box cd i x y) = tryChoice cd i x y
  try (Choices_C_Box cd i xs) = tryChoices cd i xs
  try (Fail_C_Box cd info) = Fail cd info
  try (Guard_C_Box cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Box cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Box cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Box cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Box cd i _) = error
    ("Boxes.Box.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Box cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Box cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Box where
  generate s c = Choices_C_Box c (freeID [3] s) [C_Box (generate (leftSupply
    (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c) (generate
    (rightSupply s) c)]

instance NormalForm C_Box where
  ($!!) cont (C_Box x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> ($!!)
    (\y3 d cs -> cont (C_Box y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_Box cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Box cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Box cd c e) d cs = guardCons cd c (($!!) cont e d (addCs c
    cs))
  ($!!) _ (Fail_C_Box cd info) _ _ = failCons cd info
  ($##) cont (C_Box x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> ($##)
    (\y3 d cs -> cont (C_Box y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_Box cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Box cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Box cd c e) d cs = guardCons cd c (($##) cont e d (addCs c
    cs))
  ($##) _ (Fail_C_Box cd info) _ _ = failCons cd info
  showCons (C_Box _ _ _) = "Boxes.Box _ _ _"
  showCons x = error ("Boxes.Box.showCons: no constructor: " ++ show x)
  searchNF search cont (C_Box x1 x2 x3) = search (\y1 -> search (\y2 -> search
    (\y3 -> cont (C_Box y1 y2 y3)) x3) x2) x1
  searchNF _ _ x = error ("Boxes.Box.searchNF: no constructor: " ++ show x)

instance Unifiable C_Box where
  (=.=) (C_Box x1 x2 x3) (C_Box y1 y2 y3) d cs = (&) ((=:=) x1 y1 d cs) ((&)
    ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Box x1 x2 x3) (C_Box y1 y2 y3) d cs = (&) ((=:<=) x1 y1 d cs) ((&)
    ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Box x3 x4 x5) = (i :=: ChooseN 0 3) : concat [bind cd (leftID
    (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (rightID i) x5]
  bind d i (Choice_C_Box cd j x y) = [ConstraintChoice cd j (bind d i x) (bind d
    i y)]
  bind d i (Choices_C_Box cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Box cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Box cd i _) = error
    ("Boxes.Box.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Box cd info) = [Unsolvable info]
  bind d i (Guard_C_Box cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Box x3 x4 x5) = (i :=: ChooseN 0 3) : [leftID (leftID i) :=:
    LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x5)]
  lazyBind d i (Choice_C_Box cd j x y) = [ConstraintChoice cd j (lazyBind d i x)
    (lazyBind d i y)]
  lazyBind d i (Choices_C_Box cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j
    xs
  lazyBind d i (Choices_C_Box cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Box cd i _) = error
    ("Boxes.Box.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Box cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Box cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Box where

data C_Alignment
  = C_AlignFirst
  | C_AlignCenter1
  | C_AlignCenter2
  | C_AlignLast
  | Choice_C_Alignment Cover ID C_Alignment C_Alignment
  | Choices_C_Alignment Cover ID [C_Alignment]
  | Fail_C_Alignment Cover FailInfo
  | Guard_C_Alignment Cover Constraints C_Alignment

instance Show C_Alignment where
  showsPrec d (Choice_C_Alignment cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Alignment cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Alignment cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Alignment cd info) = showChar '!'
  showsPrec _ C_AlignFirst = showString "AlignFirst"
  showsPrec _ C_AlignCenter1 = showString "AlignCenter1"
  showsPrec _ C_AlignCenter2 = showString "AlignCenter2"
  showsPrec _ C_AlignLast = showString "AlignLast"

instance Read C_Alignment where
  readsPrec _ s = readParen False (\r -> [(C_AlignFirst, r0) | (_, r0) <-
    readQualified "Boxes" "AlignFirst" r]) s ++ (readParen False (\r ->
    [(C_AlignCenter1, r0) | (_, r0) <- readQualified "Boxes" "AlignCenter1" r])
    s ++ (readParen False (\r -> [(C_AlignCenter2, r0) | (_, r0) <-
    readQualified "Boxes" "AlignCenter2" r]) s ++ readParen False (\r ->
    [(C_AlignLast, r0) | (_, r0) <- readQualified "Boxes" "AlignLast" r]) s))

instance NonDet C_Alignment where
  choiceCons = Choice_C_Alignment
  choicesCons = Choices_C_Alignment
  failCons = Fail_C_Alignment
  guardCons = Guard_C_Alignment
  try (Choice_C_Alignment cd i x y) = tryChoice cd i x y
  try (Choices_C_Alignment cd i xs) = tryChoices cd i xs
  try (Fail_C_Alignment cd info) = Fail cd info
  try (Guard_C_Alignment cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Alignment cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Alignment cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Alignment cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Alignment cd i _) = error
    ("Boxes.Alignment.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Alignment cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Alignment cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Alignment where
  generate s c = Choices_C_Alignment c (freeID [0, 0, 0, 0] s) [C_AlignFirst
    , C_AlignCenter1, C_AlignCenter2, C_AlignLast]

instance NormalForm C_Alignment where
  ($!!) cont C_AlignFirst d cs = cont C_AlignFirst d cs
  ($!!) cont C_AlignCenter1 d cs = cont C_AlignCenter1 d cs
  ($!!) cont C_AlignCenter2 d cs = cont C_AlignCenter2 d cs
  ($!!) cont C_AlignLast d cs = cont C_AlignLast d cs
  ($!!) cont (Choice_C_Alignment cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Alignment cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Alignment cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_Alignment cd info) _ _ = failCons cd info
  ($##) cont C_AlignFirst d cs = cont C_AlignFirst d cs
  ($##) cont C_AlignCenter1 d cs = cont C_AlignCenter1 d cs
  ($##) cont C_AlignCenter2 d cs = cont C_AlignCenter2 d cs
  ($##) cont C_AlignLast d cs = cont C_AlignLast d cs
  ($##) cont (Choice_C_Alignment cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Alignment cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Alignment cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_Alignment cd info) _ _ = failCons cd info
  showCons C_AlignFirst = "Boxes.AlignFirst"
  showCons C_AlignCenter1 = "Boxes.AlignCenter1"
  showCons C_AlignCenter2 = "Boxes.AlignCenter2"
  showCons C_AlignLast = "Boxes.AlignLast"
  showCons x = error ("Boxes.Alignment.showCons: no constructor: " ++ show x)
  searchNF _ cont C_AlignFirst = cont C_AlignFirst
  searchNF _ cont C_AlignCenter1 = cont C_AlignCenter1
  searchNF _ cont C_AlignCenter2 = cont C_AlignCenter2
  searchNF _ cont C_AlignLast = cont C_AlignLast
  searchNF _ _ x = error ("Boxes.Alignment.searchNF: no constructor: " ++ show
    x)

instance Unifiable C_Alignment where
  (=.=) C_AlignFirst C_AlignFirst d cs = C_True
  (=.=) C_AlignCenter1 C_AlignCenter1 d cs = C_True
  (=.=) C_AlignCenter2 C_AlignCenter2 d cs = C_True
  (=.=) C_AlignLast C_AlignLast d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_AlignFirst C_AlignFirst d cs = C_True
  (=.<=) C_AlignCenter1 C_AlignCenter1 d cs = C_True
  (=.<=) C_AlignCenter2 C_AlignCenter2 d cs = C_True
  (=.<=) C_AlignLast C_AlignLast d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_AlignFirst = (i :=: ChooseN 0 0) : concat []
  bind cd i C_AlignCenter1 = (i :=: ChooseN 1 0) : concat []
  bind cd i C_AlignCenter2 = (i :=: ChooseN 2 0) : concat []
  bind cd i C_AlignLast = (i :=: ChooseN 3 0) : concat []
  bind d i (Choice_C_Alignment cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_Alignment cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Alignment cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_Alignment cd i _) = error
    ("Boxes.Alignment.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Alignment cd info) = [Unsolvable info]
  bind d i (Guard_C_Alignment cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_AlignFirst = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_AlignCenter1 = (i :=: ChooseN 1 0) : []
  lazyBind cd i C_AlignCenter2 = (i :=: ChooseN 2 0) : []
  lazyBind cd i C_AlignLast = (i :=: ChooseN 3 0) : []
  lazyBind d i (Choice_C_Alignment cd j x y) = [ConstraintChoice cd j (lazyBind
    d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Alignment cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_Alignment cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Alignment cd i _) = error
    ("Boxes.Alignment.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Alignment cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Alignment cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Alignment where

data C_Content
  = C_Blank
  | C_Text (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_Row (Curry_Prelude.OP_List C_Box)
  | C_Col (Curry_Prelude.OP_List C_Box)
  | C_SubBox C_Alignment C_Alignment C_Box
  | Choice_C_Content Cover ID C_Content C_Content
  | Choices_C_Content Cover ID [C_Content]
  | Fail_C_Content Cover FailInfo
  | Guard_C_Content Cover Constraints C_Content

instance Show C_Content where
  showsPrec d (Choice_C_Content cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Content cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Content cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Content cd info) = showChar '!'
  showsPrec _ C_Blank = showString "Blank"
  showsPrec _ (C_Text x1) = showString "(Text" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_Row x1) = showString "(Row" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_Col x1) = showString "(Col" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_SubBox x1 x2 x3) = showString "(SubBox" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . showChar
    ')'))))))

instance Read C_Content where
  readsPrec d s = readParen False (\r -> [(C_Blank, r0) | (_, r0) <-
    readQualified "Boxes" "Blank" r]) s ++ (readParen ((>) d 10) (\r -> [(C_Text
    x1, r1) | (_, r0) <- readQualified "Boxes" "Text" r, (x1, r1) <- readsPrec
    11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_Row x1, r1) | (_, r0) <-
    readQualified "Boxes" "Row" r, (x1, r1) <- readsPrec 11 r0]) s ++ (readParen
    ((>) d 10) (\r -> [(C_Col x1, r1) | (_, r0) <- readQualified "Boxes" "Col"
    r, (x1, r1) <- readsPrec 11 r0]) s ++ readParen ((>) d 10) (\r -> [(C_SubBox
    x1 x2 x3, r3) | (_, r0) <- readQualified "Boxes" "SubBox" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2])
    s)))

instance NonDet C_Content where
  choiceCons = Choice_C_Content
  choicesCons = Choices_C_Content
  failCons = Fail_C_Content
  guardCons = Guard_C_Content
  try (Choice_C_Content cd i x y) = tryChoice cd i x y
  try (Choices_C_Content cd i xs) = tryChoices cd i xs
  try (Fail_C_Content cd info) = Fail cd info
  try (Guard_C_Content cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Content cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Content cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Content cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Content cd i _) = error
    ("Boxes.Content.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Content cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Content cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Content where
  generate s c = Choices_C_Content c (freeID [0, 1, 1, 1, 3] s) [C_Blank, C_Text
    (generate (leftSupply s) c), C_Row (generate (leftSupply s) c), C_Col
    (generate (leftSupply s) c), C_SubBox (generate (leftSupply (leftSupply s))
    c) (generate (rightSupply (leftSupply s)) c) (generate (rightSupply s) c)]

instance NormalForm C_Content where
  ($!!) cont C_Blank d cs = cont C_Blank d cs
  ($!!) cont (C_Text x1) d cs = ($!!) (\y1 d cs -> cont (C_Text y1) d cs) x1 d
    cs
  ($!!) cont (C_Row x1) d cs = ($!!) (\y1 d cs -> cont (C_Row y1) d cs) x1 d cs
  ($!!) cont (C_Col x1) d cs = ($!!) (\y1 d cs -> cont (C_Col y1) d cs) x1 d cs
  ($!!) cont (C_SubBox x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> cont (C_SubBox y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_Content cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Content cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Content cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_Content cd info) _ _ = failCons cd info
  ($##) cont C_Blank d cs = cont C_Blank d cs
  ($##) cont (C_Text x1) d cs = ($##) (\y1 d cs -> cont (C_Text y1) d cs) x1 d
    cs
  ($##) cont (C_Row x1) d cs = ($##) (\y1 d cs -> cont (C_Row y1) d cs) x1 d cs
  ($##) cont (C_Col x1) d cs = ($##) (\y1 d cs -> cont (C_Col y1) d cs) x1 d cs
  ($##) cont (C_SubBox x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> cont (C_SubBox y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_Content cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Content cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Content cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_Content cd info) _ _ = failCons cd info
  showCons C_Blank = "Boxes.Blank"
  showCons (C_Text _) = "Boxes.Text _"
  showCons (C_Row _) = "Boxes.Row _"
  showCons (C_Col _) = "Boxes.Col _"
  showCons (C_SubBox _ _ _) = "Boxes.SubBox _ _ _"
  showCons x = error ("Boxes.Content.showCons: no constructor: " ++ show x)
  searchNF _ cont C_Blank = cont C_Blank
  searchNF search cont (C_Text x1) = search (\y1 -> cont (C_Text y1)) x1
  searchNF search cont (C_Row x1) = search (\y1 -> cont (C_Row y1)) x1
  searchNF search cont (C_Col x1) = search (\y1 -> cont (C_Col y1)) x1
  searchNF search cont (C_SubBox x1 x2 x3) = search (\y1 -> search (\y2 ->
    search (\y3 -> cont (C_SubBox y1 y2 y3)) x3) x2) x1
  searchNF _ _ x = error ("Boxes.Content.searchNF: no constructor: " ++ show x)

instance Unifiable C_Content where
  (=.=) C_Blank C_Blank d cs = C_True
  (=.=) (C_Text x1) (C_Text y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Row x1) (C_Row y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Col x1) (C_Col y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_SubBox x1 x2 x3) (C_SubBox y1 y2 y3) d cs = (&) ((=:=) x1 y1 d cs)
    ((&) ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_Blank C_Blank d cs = C_True
  (=.<=) (C_Text x1) (C_Text y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Row x1) (C_Row y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Col x1) (C_Col y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_SubBox x1 x2 x3) (C_SubBox y1 y2 y3) d cs = (&) ((=:<=) x1 y1 d cs)
    ((&) ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_Blank = (i :=: ChooseN 0 0) : concat []
  bind cd i (C_Text x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_Row x3) = (i :=: ChooseN 2 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_Col x3) = (i :=: ChooseN 3 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_SubBox x3 x4 x5) = (i :=: ChooseN 4 3) : concat [bind cd (leftID
    (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (rightID i) x5]
  bind d i (Choice_C_Content cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_Content cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Content cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_Content cd i _) = error
    ("Boxes.Content.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Content cd info) = [Unsolvable info]
  bind d i (Guard_C_Content cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_Blank = (i :=: ChooseN 0 0) : []
  lazyBind cd i (C_Text x3) = (i :=: ChooseN 1 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Row x3) = (i :=: ChooseN 2 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Col x3) = (i :=: ChooseN 3 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_SubBox x3 x4 x5) = (i :=: ChooseN 4 3) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x5)]
  lazyBind d i (Choice_C_Content cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Content cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_Content cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Content cd i _) = error
    ("Boxes.Content.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Content cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Content cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Content where

data C_Para
  = C_Para Curry_Prelude.C_Int C_ParaContent
  | Choice_C_Para Cover ID C_Para C_Para
  | Choices_C_Para Cover ID [C_Para]
  | Fail_C_Para Cover FailInfo
  | Guard_C_Para Cover Constraints C_Para

instance Show C_Para where
  showsPrec d (Choice_C_Para cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Para cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Para cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Para cd info) = showChar '!'
  showsPrec _ (C_Para x1 x2) = showString "(Para" . (showChar ' ' . (shows x1 .
    (showChar ' ' . (shows x2 . showChar ')'))))

instance Read C_Para where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Para x1 x2, r2) | (_, r0) <-
    readQualified "Boxes" "Para" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <-
    readsPrec 11 r1]) s

instance NonDet C_Para where
  choiceCons = Choice_C_Para
  choicesCons = Choices_C_Para
  failCons = Fail_C_Para
  guardCons = Guard_C_Para
  try (Choice_C_Para cd i x y) = tryChoice cd i x y
  try (Choices_C_Para cd i xs) = tryChoices cd i xs
  try (Fail_C_Para cd info) = Fail cd info
  try (Guard_C_Para cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Para cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Para cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Para cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Para cd i _) = error
    ("Boxes.Para.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Para cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Para cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Para where
  generate s c = Choices_C_Para c (freeID [2] s) [C_Para (generate (leftSupply
    s) c) (generate (rightSupply s) c)]

instance NormalForm C_Para where
  ($!!) cont (C_Para x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Para y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_Para cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Para cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Para cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_Para cd info) _ _ = failCons cd info
  ($##) cont (C_Para x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Para y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_Para cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Para cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Para cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_Para cd info) _ _ = failCons cd info
  showCons (C_Para _ _) = "Boxes.Para _ _"
  showCons x = error ("Boxes.Para.showCons: no constructor: " ++ show x)
  searchNF search cont (C_Para x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Para y1 y2)) x2) x1
  searchNF _ _ x = error ("Boxes.Para.searchNF: no constructor: " ++ show x)

instance Unifiable C_Para where
  (=.=) (C_Para x1 x2) (C_Para y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2
    d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Para x1 x2) (C_Para y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=) x2
    y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Para x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID i) x3
    , bind cd (rightID i) x4]
  bind d i (Choice_C_Para cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_Para cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Para cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Para cd i _) = error
    ("Boxes.Para.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Para cd info) = [Unsolvable info]
  bind d i (Guard_C_Para cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Para x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind d i (Choice_C_Para cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Para cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j
    xs
  lazyBind d i (Choices_C_Para cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Para cd i _) = error
    ("Boxes.Para.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Para cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Para cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Para where

data C_ParaContent
  = C_Block (Curry_Prelude.OP_List C_Line) C_Line
  | Choice_C_ParaContent Cover ID C_ParaContent C_ParaContent
  | Choices_C_ParaContent Cover ID [C_ParaContent]
  | Fail_C_ParaContent Cover FailInfo
  | Guard_C_ParaContent Cover Constraints C_ParaContent

instance Show C_ParaContent where
  showsPrec d (Choice_C_ParaContent cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_ParaContent cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_ParaContent cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_ParaContent cd info) = showChar '!'
  showsPrec _ (C_Block x1 x2) = showString "(Block" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))

instance Read C_ParaContent where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Block x1 x2, r2) | (_, r0) <-
    readQualified "Boxes" "Block" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <-
    readsPrec 11 r1]) s

instance NonDet C_ParaContent where
  choiceCons = Choice_C_ParaContent
  choicesCons = Choices_C_ParaContent
  failCons = Fail_C_ParaContent
  guardCons = Guard_C_ParaContent
  try (Choice_C_ParaContent cd i x y) = tryChoice cd i x y
  try (Choices_C_ParaContent cd i xs) = tryChoices cd i xs
  try (Fail_C_ParaContent cd info) = Fail cd info
  try (Guard_C_ParaContent cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_ParaContent cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_ParaContent cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_ParaContent cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_ParaContent cd i _) = error
    ("Boxes.ParaContent.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_ParaContent cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_ParaContent cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_ParaContent where
  generate s c = Choices_C_ParaContent c (freeID [2] s) [C_Block (generate
    (leftSupply s) c) (generate (rightSupply s) c)]

instance NormalForm C_ParaContent where
  ($!!) cont (C_Block x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Block y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_ParaContent cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_ParaContent cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_ParaContent cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_ParaContent cd info) _ _ = failCons cd info
  ($##) cont (C_Block x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Block y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_ParaContent cd i x y) d cs = gnfChoice cont cd i x y cd
    cs
  ($##) cont (Choices_C_ParaContent cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_ParaContent cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_ParaContent cd info) _ _ = failCons cd info
  showCons (C_Block _ _) = "Boxes.Block _ _"
  showCons x = error ("Boxes.ParaContent.showCons: no constructor: " ++ show x)
  searchNF search cont (C_Block x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Block y1 y2)) x2) x1
  searchNF _ _ x = error ("Boxes.ParaContent.searchNF: no constructor: " ++ show
    x)

instance Unifiable C_ParaContent where
  (=.=) (C_Block x1 x2) (C_Block y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2
    y2 d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Block x1 x2) (C_Block y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=)
    x2 y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Block x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID i)
    x3, bind cd (rightID i) x4]
  bind d i (Choice_C_ParaContent cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_ParaContent cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j
    xs
  bind d i (Choices_C_ParaContent cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_ParaContent cd i _) = error
    ("Boxes.ParaContent.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_ParaContent cd info) = [Unsolvable info]
  bind d i (Guard_C_ParaContent cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Block x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind d i (Choice_C_ParaContent cd j x y) = [ConstraintChoice cd j
    (lazyBind d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_ParaContent cd j@(FreeID _ _) xs) = lazyBindOrNarrow d
    i cd j xs
  lazyBind d i (Choices_C_ParaContent cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_ParaContent cd i _) = error
    ("Boxes.ParaContent.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_ParaContent cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_ParaContent cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_ParaContent where

data C_Line
  = C_Line Curry_Prelude.C_Int (Curry_Prelude.OP_List C_Word)
  | Choice_C_Line Cover ID C_Line C_Line
  | Choices_C_Line Cover ID [C_Line]
  | Fail_C_Line Cover FailInfo
  | Guard_C_Line Cover Constraints C_Line

instance Show C_Line where
  showsPrec d (Choice_C_Line cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Line cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Line cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Line cd info) = showChar '!'
  showsPrec _ (C_Line x1 x2) = showString "(Line" . (showChar ' ' . (shows x1 .
    (showChar ' ' . (shows x2 . showChar ')'))))

instance Read C_Line where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Line x1 x2, r2) | (_, r0) <-
    readQualified "Boxes" "Line" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <-
    readsPrec 11 r1]) s

instance NonDet C_Line where
  choiceCons = Choice_C_Line
  choicesCons = Choices_C_Line
  failCons = Fail_C_Line
  guardCons = Guard_C_Line
  try (Choice_C_Line cd i x y) = tryChoice cd i x y
  try (Choices_C_Line cd i xs) = tryChoices cd i xs
  try (Fail_C_Line cd info) = Fail cd info
  try (Guard_C_Line cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Line cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Line cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Line cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Line cd i _) = error
    ("Boxes.Line.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Line cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Line cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Line where
  generate s c = Choices_C_Line c (freeID [2] s) [C_Line (generate (leftSupply
    s) c) (generate (rightSupply s) c)]

instance NormalForm C_Line where
  ($!!) cont (C_Line x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Line y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_Line cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Line cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Line cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_Line cd info) _ _ = failCons cd info
  ($##) cont (C_Line x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Line y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_Line cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Line cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Line cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_Line cd info) _ _ = failCons cd info
  showCons (C_Line _ _) = "Boxes.Line _ _"
  showCons x = error ("Boxes.Line.showCons: no constructor: " ++ show x)
  searchNF search cont (C_Line x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Line y1 y2)) x2) x1
  searchNF _ _ x = error ("Boxes.Line.searchNF: no constructor: " ++ show x)

instance Unifiable C_Line where
  (=.=) (C_Line x1 x2) (C_Line y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2
    d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Line x1 x2) (C_Line y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=) x2
    y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Line x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID i) x3
    , bind cd (rightID i) x4]
  bind d i (Choice_C_Line cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_Line cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Line cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Line cd i _) = error
    ("Boxes.Line.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Line cd info) = [Unsolvable info]
  bind d i (Guard_C_Line cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Line x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind d i (Choice_C_Line cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Line cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j
    xs
  lazyBind d i (Choices_C_Line cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Line cd i _) = error
    ("Boxes.Line.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Line cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Line cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Line where

data C_Word
  = C_Word Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | Choice_C_Word Cover ID C_Word C_Word
  | Choices_C_Word Cover ID [C_Word]
  | Fail_C_Word Cover FailInfo
  | Guard_C_Word Cover Constraints C_Word

instance Show C_Word where
  showsPrec d (Choice_C_Word cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Word cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Word cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Word cd info) = showChar '!'
  showsPrec _ (C_Word x1 x2) = showString "(Word" . (showChar ' ' . (shows x1 .
    (showChar ' ' . (shows x2 . showChar ')'))))

instance Read C_Word where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Word x1 x2, r2) | (_, r0) <-
    readQualified "Boxes" "Word" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <-
    readsPrec 11 r1]) s

instance NonDet C_Word where
  choiceCons = Choice_C_Word
  choicesCons = Choices_C_Word
  failCons = Fail_C_Word
  guardCons = Guard_C_Word
  try (Choice_C_Word cd i x y) = tryChoice cd i x y
  try (Choices_C_Word cd i xs) = tryChoices cd i xs
  try (Fail_C_Word cd info) = Fail cd info
  try (Guard_C_Word cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Word cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Word cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Word cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Word cd i _) = error
    ("Boxes.Word.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Word cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Word cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Word where
  generate s c = Choices_C_Word c (freeID [2] s) [C_Word (generate (leftSupply
    s) c) (generate (rightSupply s) c)]

instance NormalForm C_Word where
  ($!!) cont (C_Word x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Word y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_Word cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Word cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Word cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_Word cd info) _ _ = failCons cd info
  ($##) cont (C_Word x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Word y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_Word cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Word cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Word cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_Word cd info) _ _ = failCons cd info
  showCons (C_Word _ _) = "Boxes.Word _ _"
  showCons x = error ("Boxes.Word.showCons: no constructor: " ++ show x)
  searchNF search cont (C_Word x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Word y1 y2)) x2) x1
  searchNF _ _ x = error ("Boxes.Word.searchNF: no constructor: " ++ show x)

instance Unifiable C_Word where
  (=.=) (C_Word x1 x2) (C_Word y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2
    d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Word x1 x2) (C_Word y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=) x2
    y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Word x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID i) x3
    , bind cd (rightID i) x4]
  bind d i (Choice_C_Word cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_Word cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Word cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Word cd i _) = error
    ("Boxes.Word.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Word cd info) = [Unsolvable info]
  bind d i (Guard_C_Word cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Word x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind d i (Choice_C_Word cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Word cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j
    xs
  lazyBind d i (Choices_C_Word cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Word cd i _) = error
    ("Boxes.Word.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Word cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Word cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Word where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Box
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash z s cd cs)
    xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash e s cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Boxes._inst#Prelude.Data#Boxes.Box#" [show x1] info)
  _ -> failCons cd (consFail "Boxes._inst#Prelude.Data#Boxes.Box#" (showCons
    x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash :: C_Box
  -> C_Box -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash x1 x2 s cd cs =
  case x1 of
  C_Box x3 x4 x5 -> let s0 = s in s0 `seq` nd_C__case_26 x5 x4 x3 x2 s0 cd cs
  Choice_C_Box d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash
    r x2 s cd cs)
  Choices_C_Box d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash
    z x2 s cd cs) xs
  Guard_C_Box d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_Box d info -> failCons d (traceFail
    "Boxes._impl#===#Prelude.Data#Boxes.Box#" [show x1, show x2] info)
  _ -> failCons cd (consFail "Boxes._impl#===#Prelude.Data#Boxes.Box#" (showCons
    x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash :: IDSupply
  -> Cover -> ConstStore -> C_Box
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash s cd cs =
  let s3 = s
  in s3 `seq` (let s0 = leftSupply s3
                   s4 = rightSupply s3
                   s1 = leftSupply s4
                   s2 = rightSupply s4
  in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` C_Box
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s1 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash
  s2 cd cs)))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Alignment
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash l s
    cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash r s
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash z s cd
    cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Boxes._inst#Prelude.Data#Boxes.Alignment#" [show x1] info)
  _ -> failCons cd (consFail "Boxes._inst#Prelude.Data#Boxes.Alignment#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash :: C_Alignment
  -> C_Alignment -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash x1 x2 cd cs =
  case x1 of
  C_AlignFirst -> d_C__case_25 x2 cd cs
  C_AlignCenter1 -> d_C__case_24 x2 cd cs
  C_AlignCenter2 -> d_C__case_23 x2 cd cs
  C_AlignLast -> d_C__case_22 x2 cd cs
  Choice_C_Alignment d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash
    r x2 cd cs)
  Choices_C_Alignment d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash
    z x2 cd cs) xs
  Guard_C_Alignment d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Alignment d info -> failCons d (traceFail
    "Boxes._impl#===#Prelude.Data#Boxes.Alignment#" [show x1, show x2] info)
  _ -> failCons cd (consFail "Boxes._impl#===#Prelude.Data#Boxes.Alignment#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash :: IDSupply
  -> Cover -> ConstStore -> C_Alignment
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash s cd cs =
  let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` choice (let s1 = leftSupply s2
                                    s0 = rightSupply s2
  in s1 `seq` (s0 `seq` choice (choice C_AlignFirst C_AlignCenter1 s0 cd cs)
  C_AlignCenter2 s1 cd cs)) C_AlignLast s3 cd cs))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Content
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash l s cd
    cs) (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash r s
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash z s cd
    cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Boxes._inst#Prelude.Data#Boxes.Content#" [show x1] info)
  _ -> failCons cd (consFail "Boxes._inst#Prelude.Data#Boxes.Content#" (showCons
    x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash :: C_Content
  -> C_Content -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash x1 x2 s cd cs =
  case x1 of
  C_Blank -> d_C__case_21 x2 cd cs
  C_Text x9 -> let s0 = s in s0 `seq` nd_C__case_20 x9 x2 s0 cd cs
  C_Row x16 -> let s0 = s in s0 `seq` nd_C__case_19 x16 x2 s0 cd cs
  C_Col x23 -> let s0 = s in s0 `seq` nd_C__case_18 x23 x2 s0 cd cs
  C_SubBox x30 x31 x32 -> let s0 = s
    in s0 `seq` nd_C__case_17 x32 x31 x30 x2 s0 cd cs
  Choice_C_Content d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash
    r x2 s cd cs)
  Choices_C_Content d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash
    z x2 s cd cs) xs
  Guard_C_Content d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_Content d info -> failCons d (traceFail
    "Boxes._impl#===#Prelude.Data#Boxes.Content#" [show x1, show x2] info)
  _ -> failCons cd (consFail "Boxes._impl#===#Prelude.Data#Boxes.Content#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash :: IDSupply
  -> Cover -> ConstStore -> C_Content
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash s cd cs =
  let s17 = s
  in s17 `seq` (let s16 = leftSupply s17
                    s18 = rightSupply s17
                    s9 = leftSupply s18
                    s14 = rightSupply s18
  in s16 `seq` (s18 `seq` (s9 `seq` (s14 `seq` choice (let s8 = leftSupply s9
                                                           s10 = rightSupply s9
                                                           s5 = leftSupply s10
                                                           s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` choice (let s4 = leftSupply s5
                                                         s6 = rightSupply s5
                                                         s2 = leftSupply s6
                                                         s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` choice (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
  in s1 `seq` (s0 `seq` choice C_Blank (C_Text
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)) s1 cd cs)) (C_Row
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash) s3
  cd cs)) s4 cd cs)))) (C_Col
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash) s7
  cd cs)) s8 cd cs)))) (let s11 = leftSupply s14
                            s15 = rightSupply s14
                            s12 = leftSupply s15
                            s13 = rightSupply s15
  in s11 `seq` (s15 `seq` (s12 `seq` (s13 `seq` C_SubBox
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash
  s11 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash
  s12 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash
  s13 cd cs))))) s16 cd cs))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Para_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Para
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Para_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Para_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Para_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Para_hash l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Para_hash r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Para_hash z s cd cs)
    xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Para_hash e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Boxes._inst#Prelude.Data#Boxes.Para#" [show x1] info)
  _ -> failCons cd (consFail "Boxes._inst#Prelude.Data#Boxes.Para#" (showCons
    x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Para_hash :: C_Para
  -> C_Para -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Para_hash x1 x2 s cd cs =
  case x1 of
  C_Para x3 x4 -> let s0 = s in s0 `seq` nd_C__case_16 x4 x3 x2 s0 cd cs
  Choice_C_Para d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Para_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Para_hash
    r x2 s cd cs)
  Choices_C_Para d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Para_hash
    z x2 s cd cs) xs
  Guard_C_Para d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Para_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_Para d info -> failCons d (traceFail
    "Boxes._impl#===#Prelude.Data#Boxes.Para#" [show x1, show x2] info)
  _ -> failCons cd (consFail "Boxes._impl#===#Prelude.Data#Boxes.Para#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Para_hash :: IDSupply
  -> Cover -> ConstStore -> C_Para
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Para_hash s cd cs =
  let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_Para
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s0 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash
  s1 cd cs)))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_ParaContent
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash l s
    cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash r s
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Boxes._inst#Prelude.Data#Boxes.ParaContent#" [show x1] info)
  _ -> failCons cd (consFail "Boxes._inst#Prelude.Data#Boxes.ParaContent#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash :: C_ParaContent
  -> C_ParaContent -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash x1 x2 s cd cs =
  case x1 of
  C_Block x3 x4 -> let s0 = s in s0 `seq` nd_C__case_15 x4 x3 x2 s0 cd cs
  Choice_C_ParaContent d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash
    r x2 s cd cs)
  Choices_C_ParaContent d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash
    z x2 s cd cs) xs
  Guard_C_ParaContent d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_ParaContent d info -> failCons d (traceFail
    "Boxes._impl#===#Prelude.Data#Boxes.ParaContent#" [show x1, show x2] info)
  _ -> failCons cd (consFail "Boxes._impl#===#Prelude.Data#Boxes.ParaContent#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash :: IDSupply
  -> Cover -> ConstStore -> C_ParaContent
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash s cd cs =
  let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_Block
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash)
  s0 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash
  s1 cd cs)))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Line
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash z s cd cs)
    xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Boxes._inst#Prelude.Data#Boxes.Line#" [show x1] info)
  _ -> failCons cd (consFail "Boxes._inst#Prelude.Data#Boxes.Line#" (showCons
    x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash :: C_Line
  -> C_Line -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash x1 x2 s cd cs =
  case x1 of
  C_Line x3 x4 -> let s0 = s in s0 `seq` nd_C__case_14 x4 x3 x2 s0 cd cs
  Choice_C_Line d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash
    r x2 s cd cs)
  Choices_C_Line d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash
    z x2 s cd cs) xs
  Guard_C_Line d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_Line d info -> failCons d (traceFail
    "Boxes._impl#===#Prelude.Data#Boxes.Line#" [show x1, show x2] info)
  _ -> failCons cd (consFail "Boxes._impl#===#Prelude.Data#Boxes.Line#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash :: IDSupply
  -> Cover -> ConstStore -> C_Line
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash s cd cs =
  let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_Line
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash)
  s1 cd cs)))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Word
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash z s cd cs)
    xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Boxes._inst#Prelude.Data#Boxes.Word#" [show x1] info)
  _ -> failCons cd (consFail "Boxes._inst#Prelude.Data#Boxes.Word#" (showCons
    x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash :: C_Word
  -> C_Word -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash x1 x2 s cd cs =
  case x1 of
  C_Word x3 x4 -> let s0 = s in s0 `seq` nd_C__case_13 x4 x3 x2 s0 cd cs
  Choice_C_Word d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash
    r x2 s cd cs)
  Choices_C_Word d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash
    z x2 s cd cs) xs
  Guard_C_Word d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_Word d info -> failCons d (traceFail
    "Boxes._impl#===#Prelude.Data#Boxes.Word#" [show x1, show x2] info)
  _ -> failCons cd (consFail "Boxes._impl#===#Prelude.Data#Boxes.Word#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash :: IDSupply
  -> Cover -> ConstStore -> C_Word
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash s cd cs =
  let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_Word
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s1 cd cs)))

d_C_rows :: C_Box -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_rows x1 cd cs = case x1 of
  C_Box x2 x3 x4 -> x2
  Choice_C_Box d i l r -> narrow d i (d_C_rows l cd cs) (d_C_rows r cd cs)
  Choices_C_Box d i xs -> narrows cs d i (\z -> d_C_rows z cd cs) xs
  Guard_C_Box d c e -> guardCons d c ((\x -> d_C_rows e cd x) $! addCs c cs)
  Fail_C_Box d info -> failCons d (traceFail "Boxes.rows" [show x1] info)
  _ -> failCons cd (consFail "Boxes.rows" (showCons x1))

d_C_cols :: C_Box -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_cols x1 cd cs = case x1 of
  C_Box x2 x3 x4 -> x3
  Choice_C_Box d i l r -> narrow d i (d_C_cols l cd cs) (d_C_cols r cd cs)
  Choices_C_Box d i xs -> narrows cs d i (\z -> d_C_cols z cd cs) xs
  Guard_C_Box d c e -> guardCons d c ((\x -> d_C_cols e cd x) $! addCs c cs)
  Fail_C_Box d info -> failCons d (traceFail "Boxes.cols" [show x1] info)
  _ -> failCons cd (consFail "Boxes.cols" (showCons x1))

d_C_content :: C_Box -> Cover -> ConstStore -> C_Content
d_C_content x1 cd cs = case x1 of
  C_Box x2 x3 x4 -> x4
  Choice_C_Box d i l r -> narrow d i (d_C_content l cd cs) (d_C_content r cd cs)
  Choices_C_Box d i xs -> narrows cs d i (\z -> d_C_content z cd cs) xs
  Guard_C_Box d c e -> guardCons d c ((\x -> d_C_content e cd x) $! addCs c cs)
  Fail_C_Box d info -> failCons d (traceFail "Boxes.content" [show x1] info)
  _ -> failCons cd (consFail "Boxes.content" (showCons x1))

d_C_top :: Cover -> ConstStore -> C_Alignment
d_C_top cd cs = C_AlignFirst

d_C_bottom :: Cover -> ConstStore -> C_Alignment
d_C_bottom cd cs = C_AlignLast

d_C_left :: Cover -> ConstStore -> C_Alignment
d_C_left cd cs = C_AlignFirst

d_C_right :: Cover -> ConstStore -> C_Alignment
d_C_right cd cs = C_AlignLast

d_C_center1 :: Cover -> ConstStore -> C_Alignment
d_C_center1 cd cs = C_AlignCenter1

d_C_center2 :: Cover -> ConstStore -> C_Alignment
d_C_center2 cd cs = C_AlignCenter2

d_C_nullBox :: Cover -> ConstStore -> C_Box
d_C_nullBox cd cs = d_C_emptyBox (Curry_Prelude.C_Int (0)) (Curry_Prelude.C_Int
  (0)) cd cs

d_C_emptyBox :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> C_Box
d_C_emptyBox x1 x2 cd cs = C_Box x1 x2 C_Blank

d_C_char :: Curry_Prelude.C_Char -> Cover -> ConstStore -> C_Box
d_C_char x1 cd cs = C_Box (Curry_Prelude.C_Int (1)) (Curry_Prelude.C_Int (1))
  (C_Text (Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List))

d_C_text :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> C_Box
d_C_text x1 cd cs = C_Box (Curry_Prelude.C_Int (1)) (Curry_Prelude.d_C_length x1
  cd cs) (C_Text x1)

d_OP_lt_gt :: C_Box -> C_Box -> Cover -> ConstStore -> C_Box
d_OP_lt_gt x1 x2 cd cs = d_C_hcat (d_C_top cd cs) (Curry_Prelude.OP_Cons x1
  (Curry_Prelude.OP_Cons x2 Curry_Prelude.OP_List)) cd cs

d_OP_lt_plus_gt :: C_Box -> C_Box -> Cover -> ConstStore -> C_Box
d_OP_lt_plus_gt x1 x2 cd cs = d_C_hcat (d_C_top cd cs) (Curry_Prelude.OP_Cons x1
  (Curry_Prelude.OP_Cons (d_C_emptyBox (Curry_Prelude.C_Int (0))
  (Curry_Prelude.C_Int (1)) cd cs) (Curry_Prelude.OP_Cons x2
  Curry_Prelude.OP_List))) cd cs

d_OP_slash_slash :: C_Box -> C_Box -> Cover -> ConstStore -> C_Box
d_OP_slash_slash x1 x2 cd cs = d_C_vcat (d_C_left cd cs) (Curry_Prelude.OP_Cons
  x1 (Curry_Prelude.OP_Cons x2 Curry_Prelude.OP_List)) cd cs

d_OP_slash_plus_slash :: C_Box -> C_Box -> Cover -> ConstStore -> C_Box
d_OP_slash_plus_slash x1 x2 cd cs = d_C_vcat (d_C_left cd cs)
  (Curry_Prelude.OP_Cons x1 (Curry_Prelude.OP_Cons (d_C_emptyBox
  (Curry_Prelude.C_Int (1)) (Curry_Prelude.C_Int (0)) cd cs)
  (Curry_Prelude.OP_Cons x2 Curry_Prelude.OP_List))) cd cs

d_C_hcat :: C_Alignment -> Curry_Prelude.OP_List C_Box -> Cover -> ConstStore
  -> C_Box
d_C_hcat x1 x2 cd cs = let x3 = d_C_sumMax
                             Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
                             d_C_cols (Curry_Prelude.C_Int (0)) d_C_rows x2 cd
                             cs
                           x4 = d_OP_hcat_dot_uscore_hash_selFP2_hash_w x3 cd cs
                           x5 = d_OP_hcat_dot_uscore_hash_selFP3_hash_h x3 cd cs
  in C_Box x5 x4 (Curry_Prelude.d_OP_dollar (acceptCs id C_Row)
  (Curry_Prelude.d_C_map (d_C_alignVert x1 x5) x2 cd cs) cd cs)

d_OP_hcat_dot_uscore_hash_selFP2_hash_w :: Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_OP_hcat_dot_uscore_hash_selFP2_hash_w x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_hcat_dot_uscore_hash_selFP2_hash_w l cd cs)
    (d_OP_hcat_dot_uscore_hash_selFP2_hash_w r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_hcat_dot_uscore_hash_selFP2_hash_w z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_hcat_dot_uscore_hash_selFP2_hash_w e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Boxes.hcat._#selFP2#w" [show x1] info)
  _ -> failCons cd (consFail "Boxes.hcat._#selFP2#w" (showCons x1))

d_OP_hcat_dot_uscore_hash_selFP3_hash_h :: Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_OP_hcat_dot_uscore_hash_selFP3_hash_h x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_hcat_dot_uscore_hash_selFP3_hash_h l cd cs)
    (d_OP_hcat_dot_uscore_hash_selFP3_hash_h r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_hcat_dot_uscore_hash_selFP3_hash_h z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_hcat_dot_uscore_hash_selFP3_hash_h e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Boxes.hcat._#selFP3#h" [show x1] info)
  _ -> failCons cd (consFail "Boxes.hcat._#selFP3#h" (showCons x1))

d_C_hsep :: Curry_Prelude.C_Int -> C_Alignment -> Curry_Prelude.OP_List C_Box
  -> Cover -> ConstStore -> C_Box
d_C_hsep x1 x2 x3 cd cs = d_C_punctuateH x2 (d_C_emptyBox (Curry_Prelude.C_Int
  (0)) x1 cd cs) x3 cd cs

d_C_vcat :: C_Alignment -> Curry_Prelude.OP_List C_Box -> Cover -> ConstStore
  -> C_Box
d_C_vcat x1 x2 cd cs = let x3 = d_C_sumMax
                             Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
                             d_C_rows (Curry_Prelude.C_Int (0)) d_C_cols x2 cd
                             cs
                           x4 = d_OP_vcat_dot_uscore_hash_selFP5_hash_h x3 cd cs
                           x5 = d_OP_vcat_dot_uscore_hash_selFP6_hash_w x3 cd cs
  in C_Box x4 x5 (Curry_Prelude.d_OP_dollar (acceptCs id C_Col)
  (Curry_Prelude.d_C_map (d_C_alignHoriz x1 x5) x2 cd cs) cd cs)

d_OP_vcat_dot_uscore_hash_selFP5_hash_h :: Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_OP_vcat_dot_uscore_hash_selFP5_hash_h x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_vcat_dot_uscore_hash_selFP5_hash_h l cd cs)
    (d_OP_vcat_dot_uscore_hash_selFP5_hash_h r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_vcat_dot_uscore_hash_selFP5_hash_h z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_vcat_dot_uscore_hash_selFP5_hash_h e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Boxes.vcat._#selFP5#h" [show x1] info)
  _ -> failCons cd (consFail "Boxes.vcat._#selFP5#h" (showCons x1))

d_OP_vcat_dot_uscore_hash_selFP6_hash_w :: Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_OP_vcat_dot_uscore_hash_selFP6_hash_w x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_vcat_dot_uscore_hash_selFP6_hash_w l cd cs)
    (d_OP_vcat_dot_uscore_hash_selFP6_hash_w r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_vcat_dot_uscore_hash_selFP6_hash_w z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_vcat_dot_uscore_hash_selFP6_hash_w e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Boxes.vcat._#selFP6#w" [show x1] info)
  _ -> failCons cd (consFail "Boxes.vcat._#selFP6#w" (showCons x1))

d_C_sumMax :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> (t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Int) -> t1 -> (t0 -> Cover -> ConstStore -> t1)
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t1
d_C_sumMax x1 x2 x3 x4 x5 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_foldr (acceptCs (acceptCs
  (acceptCs id)) (d_OP_sumMax_dot_go_dot_38 x1 x2 x4)) (acceptCs (acceptCs id)
  Curry_Prelude.OP_Tuple2) x5 cd cs) (Curry_Prelude.C_Int (0)) cd cs) x3 cd cs

nd_C_sumMax :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> Func t0 Curry_Prelude.C_Int -> t1 -> Func t0 t1 -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t1
nd_C_sumMax x1 x2 x3 x4 x5 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_foldr
  (wrapDX (wrapDX (wrapDX (wrapNX id))) (acceptCs (acceptCs (acceptCs id))
  (nd_OP_sumMax_dot_go_dot_38 x1 x2 x4))) (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) Curry_Prelude.OP_Tuple2)) x5 s0 cd cs) (Curry_Prelude.C_Int (0))
  s1 cd cs)) x3 s3 cd cs))

d_OP_sumMax_dot_go_dot_38 :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord t2) -> (t1
  -> Cover -> ConstStore -> Curry_Prelude.C_Int) -> (t1 -> Cover -> ConstStore
  -> t2) -> t1 -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t2 -> Cover
  -> ConstStore -> t0) -> Curry_Prelude.C_Int -> t2 -> Cover -> ConstStore -> t0
d_OP_sumMax_dot_go_dot_38 x1 x2 x3 x4 x5 x6 x7 cd cs =
  Curry_Prelude.d_OP_dollar_bang (Curry_Prelude.d_OP_dollar_bang x5
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_apply x2 x4 cd cs) x6 cd cs) cd cs)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_max x1 cd
  cs) (Curry_Prelude.d_C_apply x3 x4 cd cs) cd cs) x7 cd cs) cd cs

nd_OP_sumMax_dot_go_dot_38 :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t2) -> Func t1
  Curry_Prelude.C_Int -> Func t1 t2 -> t1 -> Func Curry_Prelude.C_Int (Func t2
  t0) -> Curry_Prelude.C_Int -> t2 -> IDSupply -> Cover -> ConstStore -> t0
nd_OP_sumMax_dot_go_dot_38 x1 x2 x3 x4 x5 x6 x7 s cd cs = let s11 = s
  in s11 `seq` (let s10 = leftSupply s11
                    s12 = rightSupply s11
                    s2 = leftSupply s12
                    s9 = rightSupply s12
  in s10 `seq` (s12 `seq` (s2 `seq` (s9 `seq` Curry_Prelude.nd_OP_dollar_bang
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar_bang x5
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.nd_C_apply x2 x4 s0 cd cs) x6 cd cs) s1 cd cs))
  (let s8 = leftSupply s9
       s6 = rightSupply s9
  in s8 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                      s7 = rightSupply s6
                                                      s3 = leftSupply s7
                                                      s4 = rightSupply s7
  in s5 `seq` (s7 `seq` (s3 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_C_max x1 s3 cd cs) (Curry_Prelude.nd_C_apply x3 x4 s4 cd cs)
  s5 cd cs)))) x7 s8 cd cs)) s10 cd cs))))

d_C_vsep :: Curry_Prelude.C_Int -> C_Alignment -> Curry_Prelude.OP_List C_Box
  -> Cover -> ConstStore -> C_Box
d_C_vsep x1 x2 x3 cd cs = d_C_punctuateV x2 (d_C_emptyBox x1
  (Curry_Prelude.C_Int (0)) cd cs) x3 cd cs

d_C_punctuateH :: C_Alignment -> C_Box -> Curry_Prelude.OP_List C_Box -> Cover
  -> ConstStore -> C_Box
d_C_punctuateH x1 x2 x3 cd cs = d_C_hcat x1 (Data.Curry_List.d_C_intersperse x2
  x3 cd cs) cd cs

d_C_punctuateV :: C_Alignment -> C_Box -> Curry_Prelude.OP_List C_Box -> Cover
  -> ConstStore -> C_Box
d_C_punctuateV x1 x2 x3 cd cs = d_C_vcat x1 (Data.Curry_List.d_C_intersperse x2
  x3 cd cs) cd cs

d_C_paraFill :: C_Alignment -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> C_Box
d_C_paraFill x1 x2 x3 cd cs = Curry_Prelude.d_OP_dollar
  (d_OP_paraFill_dot_uscore_hash_lambda26 x1 x2) (d_C_flow x2 x3 cd cs) cd cs

d_OP_paraFill_dot_uscore_hash_lambda26 :: C_Alignment -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> C_Box
d_OP_paraFill_dot_uscore_hash_lambda26 x1 x2 x3 cd cs = Curry_Prelude.d_C_apply
  (d_C_mkParaBoxFill x1 (Curry_Prelude.d_C_length x3 cd cs) x2 cd cs) x3 cd cs

d_C_mkParaBoxFill :: C_Alignment -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> C_Box
d_C_mkParaBoxFill x1 x2 x3 cd cs = Curry_Prelude.d_OP_dot (d_C_align
  C_AlignFirst x1 x2 x3 cd cs) (Curry_Prelude.d_OP_dot (d_C_vcat x1)
  (Curry_Prelude.d_C_map d_C_text) cd cs) cd cs

d_C_para :: C_Alignment -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> C_Box
d_C_para x1 x2 x3 cd cs = Curry_Prelude.d_OP_dollar
  (d_OP_para_dot_uscore_hash_lambda27 x1) (d_C_flow x2 x3 cd cs) cd cs

d_OP_para_dot_uscore_hash_lambda27 :: C_Alignment -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> C_Box
d_OP_para_dot_uscore_hash_lambda27 x1 x2 cd cs = Curry_Prelude.d_C_apply
  (d_C_mkParaBox x1 (Curry_Prelude.d_C_length x2 cd cs) cd cs) x2 cd cs

d_C_columns :: C_Alignment -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Box
d_C_columns x1 x2 x3 x4 cd cs = Curry_Prelude.d_OP_dollar
  (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_map (d_C_mkParaBox x1 x3 cd cs))
  (d_C_chunksOf x3) cd cs) (d_C_flow x2 x4 cd cs) cd cs

d_C_mkParaBox :: C_Alignment -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> C_Box
d_C_mkParaBox x1 x2 cd cs = Curry_Prelude.d_OP_dot (d_C_alignVert (d_C_top cd
  cs) x2) (Curry_Prelude.d_OP_dot (d_C_vcat x1) (Curry_Prelude.d_C_map d_C_text)
  cd cs) cd cs

d_C_flow :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C_flow x1 x2 cd cs = Curry_Prelude.d_OP_dollar (Curry_Prelude.d_OP_dot
  (Curry_Prelude.d_C_map (Curry_Prelude.d_C_take x1)) d_C_getLines cd cs)
  (Curry_Prelude.d_C_foldl (acceptCs id d_C_addWordP) (d_C_emptyPara x1 cd cs)
  (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_map
  d_C_mkWord) Curry_Prelude.d_C_words cd cs) x2 cd cs) cd cs) cd cs

d_C_paraWidth :: C_Para -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_paraWidth x1 cd cs = case x1 of
  C_Para x2 x3 -> x2
  Choice_C_Para d i l r -> narrow d i (d_C_paraWidth l cd cs) (d_C_paraWidth r
    cd cs)
  Choices_C_Para d i xs -> narrows cs d i (\z -> d_C_paraWidth z cd cs) xs
  Guard_C_Para d c e -> guardCons d c ((\x -> d_C_paraWidth e cd x) $! addCs c
    cs)
  Fail_C_Para d info -> failCons d (traceFail "Boxes.paraWidth" [show x1] info)
  _ -> failCons cd (consFail "Boxes.paraWidth" (showCons x1))

d_C_paraContent :: C_Para -> Cover -> ConstStore -> C_ParaContent
d_C_paraContent x1 cd cs = case x1 of
  C_Para x2 x3 -> x3
  Choice_C_Para d i l r -> narrow d i (d_C_paraContent l cd cs) (d_C_paraContent
    r cd cs)
  Choices_C_Para d i xs -> narrows cs d i (\z -> d_C_paraContent z cd cs) xs
  Guard_C_Para d c e -> guardCons d c ((\x -> d_C_paraContent e cd x) $! addCs c
    cs)
  Fail_C_Para d info -> failCons d (traceFail "Boxes.paraContent" [show x1]
    info)
  _ -> failCons cd (consFail "Boxes.paraContent" (showCons x1))

d_C_fullLines :: C_ParaContent -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Line
d_C_fullLines x1 cd cs = case x1 of
  C_Block x2 x3 -> x2
  Choice_C_ParaContent d i l r -> narrow d i (d_C_fullLines l cd cs)
    (d_C_fullLines r cd cs)
  Choices_C_ParaContent d i xs -> narrows cs d i (\z -> d_C_fullLines z cd cs)
    xs
  Guard_C_ParaContent d c e -> guardCons d c ((\x -> d_C_fullLines e cd x) $!
    addCs c cs)
  Fail_C_ParaContent d info -> failCons d (traceFail "Boxes.fullLines" [show x1]
    info)
  _ -> failCons cd (consFail "Boxes.fullLines" (showCons x1))

d_C_lastLine :: C_ParaContent -> Cover -> ConstStore -> C_Line
d_C_lastLine x1 cd cs = case x1 of
  C_Block x2 x3 -> x3
  Choice_C_ParaContent d i l r -> narrow d i (d_C_lastLine l cd cs)
    (d_C_lastLine r cd cs)
  Choices_C_ParaContent d i xs -> narrows cs d i (\z -> d_C_lastLine z cd cs) xs
  Guard_C_ParaContent d c e -> guardCons d c ((\x -> d_C_lastLine e cd x) $!
    addCs c cs)
  Fail_C_ParaContent d info -> failCons d (traceFail "Boxes.lastLine" [show x1]
    info)
  _ -> failCons cd (consFail "Boxes.lastLine" (showCons x1))

d_C_emptyPara :: Curry_Prelude.C_Int -> Cover -> ConstStore -> C_Para
d_C_emptyPara x1 cd cs = C_Para x1 (C_Block Curry_Prelude.OP_List (C_Line
  (Curry_Prelude.C_Int (0)) Curry_Prelude.OP_List))

d_C_getLines :: C_Para -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_getLines x1 cd cs = case x1 of
  C_Para x2 x3 -> d_C__case_12 x3 cd cs
  Choice_C_Para d i l r -> narrow d i (d_C_getLines l cd cs) (d_C_getLines r cd
    cs)
  Choices_C_Para d i xs -> narrows cs d i (\z -> d_C_getLines z cd cs) xs
  Guard_C_Para d c e -> guardCons d c ((\x -> d_C_getLines e cd x) $! addCs c
    cs)
  Fail_C_Para d info -> failCons d (traceFail "Boxes.getLines" [show x1] info)
  _ -> failCons cd (consFail "Boxes.getLines" (showCons x1))

d_C_lLen :: C_Line -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_lLen x1 cd cs = case x1 of
  C_Line x2 x3 -> x2
  Choice_C_Line d i l r -> narrow d i (d_C_lLen l cd cs) (d_C_lLen r cd cs)
  Choices_C_Line d i xs -> narrows cs d i (\z -> d_C_lLen z cd cs) xs
  Guard_C_Line d c e -> guardCons d c ((\x -> d_C_lLen e cd x) $! addCs c cs)
  Fail_C_Line d info -> failCons d (traceFail "Boxes.lLen" [show x1] info)
  _ -> failCons cd (consFail "Boxes.lLen" (showCons x1))

d_C_getWords :: C_Line -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Word
d_C_getWords x1 cd cs = case x1 of
  C_Line x2 x3 -> x3
  Choice_C_Line d i l r -> narrow d i (d_C_getWords l cd cs) (d_C_getWords r cd
    cs)
  Choices_C_Line d i xs -> narrows cs d i (\z -> d_C_getWords z cd cs) xs
  Guard_C_Line d c e -> guardCons d c ((\x -> d_C_getWords e cd x) $! addCs c
    cs)
  Fail_C_Line d info -> failCons d (traceFail "Boxes.getWords" [show x1] info)
  _ -> failCons cd (consFail "Boxes.getWords" (showCons x1))

d_C_mkLine :: Curry_Prelude.OP_List C_Word -> Cover -> ConstStore -> C_Line
d_C_mkLine x1 cd cs = C_Line
  (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_apply (d_C_sum cd cs) (Curry_Prelude.d_C_map
  (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_flip (acceptCs id
  Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash)
  (Curry_Prelude.C_Int (1))) d_C_wLen cd cs) x1 cd cs) cd cs)
  (Curry_Prelude.C_Int (1)) cd cs) x1

d_C_startLine :: Cover -> ConstStore -> C_Word -> Cover -> ConstStore -> C_Line
d_C_startLine cd cs = Curry_Prelude.d_OP_dot d_C_mkLine (Curry_Prelude.d_C_flip
  (acceptCs (acceptCs id) Curry_Prelude.OP_Cons) Curry_Prelude.OP_List) cd cs

d_C_wLen :: C_Word -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_wLen x1 cd cs = case x1 of
  C_Word x2 x3 -> x2
  Choice_C_Word d i l r -> narrow d i (d_C_wLen l cd cs) (d_C_wLen r cd cs)
  Choices_C_Word d i xs -> narrows cs d i (\z -> d_C_wLen z cd cs) xs
  Guard_C_Word d c e -> guardCons d c ((\x -> d_C_wLen e cd x) $! addCs c cs)
  Fail_C_Word d info -> failCons d (traceFail "Boxes.wLen" [show x1] info)
  _ -> failCons cd (consFail "Boxes.wLen" (showCons x1))

d_C_getWord :: C_Word -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_getWord x1 cd cs = case x1 of
  C_Word x2 x3 -> x3
  Choice_C_Word d i l r -> narrow d i (d_C_getWord l cd cs) (d_C_getWord r cd
    cs)
  Choices_C_Word d i xs -> narrows cs d i (\z -> d_C_getWord z cd cs) xs
  Guard_C_Word d c e -> guardCons d c ((\x -> d_C_getWord e cd x) $! addCs c cs)
  Fail_C_Word d info -> failCons d (traceFail "Boxes.getWord" [show x1] info)
  _ -> failCons cd (consFail "Boxes.getWord" (showCons x1))

d_C_mkWord :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> C_Word
d_C_mkWord x1 cd cs = C_Word (Curry_Prelude.d_C_length x1 cd cs) x1

d_C_addWordP :: C_Para -> C_Word -> Cover -> ConstStore -> C_Para
d_C_addWordP x1 x2 cd cs = case x1 of
  C_Para x3 x4 -> d_C__case_9 x2 x3 x4 cd cs
  Choice_C_Para d i l r -> narrow d i (d_C_addWordP l x2 cd cs) (d_C_addWordP r
    x2 cd cs)
  Choices_C_Para d i xs -> narrows cs d i (\z -> d_C_addWordP z x2 cd cs) xs
  Guard_C_Para d c e -> guardCons d c ((\x -> d_C_addWordP e x2 cd x) $! addCs c
    cs)
  Fail_C_Para d info -> failCons d (traceFail "Boxes.addWordP" [show x1, show
    x2] info)
  _ -> failCons cd (consFail "Boxes.addWordP" (showCons x1))

d_C_addWordL :: C_Word -> C_Line -> Cover -> ConstStore -> C_Line
d_C_addWordL x1 x2 cd cs = case x2 of
  C_Line x3 x4 -> C_Line
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x3 (d_C_wLen x1 cd cs) cd cs) (Curry_Prelude.C_Int (1)) cd cs)
    (Curry_Prelude.OP_Cons x1 x4)
  Choice_C_Line d i l r -> narrow d i (d_C_addWordL x1 l cd cs) (d_C_addWordL x1
    r cd cs)
  Choices_C_Line d i xs -> narrows cs d i (\z -> d_C_addWordL x1 z cd cs) xs
  Guard_C_Line d c e -> guardCons d c ((\x -> d_C_addWordL x1 e cd x) $! addCs c
    cs)
  Fail_C_Line d info -> failCons d (traceFail "Boxes.addWordL" [show x1, show
    x2] info)
  _ -> failCons cd (consFail "Boxes.addWordL" (showCons x2))

d_C_wordFits :: Curry_Prelude.C_Int -> C_Word -> C_Line -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_wordFits x1 x2 x3 cd cs = Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  (d_C_lLen x3 cd cs) (Curry_Prelude.C_Int (0)) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (d_C_lLen x3 cd cs) (d_C_wLen x2 cd cs) cd cs) (Curry_Prelude.C_Int (1)) cd
  cs) x1 cd cs) cd cs

d_C_alignHoriz :: C_Alignment -> Curry_Prelude.C_Int -> C_Box -> Cover
  -> ConstStore -> C_Box
d_C_alignHoriz x1 x2 x3 cd cs = Curry_Prelude.d_C_apply (d_C_align x1
  C_AlignFirst (d_C_rows x3 cd cs) x2 cd cs) x3 cd cs

d_C_alignVert :: C_Alignment -> Curry_Prelude.C_Int -> C_Box -> Cover
  -> ConstStore -> C_Box
d_C_alignVert x1 x2 x3 cd cs = Curry_Prelude.d_C_apply (d_C_align C_AlignFirst
  x1 x2 (d_C_cols x3 cd cs) cd cs) x3 cd cs

d_C_align :: C_Alignment -> C_Alignment -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> C_Box -> Cover -> ConstStore
  -> C_Box
d_C_align x1 x2 x3 x4 cd cs = Curry_Prelude.d_OP_dot (acceptCs id (C_Box x3 x4))
  (acceptCs id (C_SubBox x1 x2)) cd cs

d_C_moveUp :: Curry_Prelude.C_Int -> C_Box -> Cover -> ConstStore -> C_Box
d_C_moveUp x1 x2 cd cs = d_C_alignVert (d_C_top cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (d_C_rows x2 cd cs) x1 cd cs) x2 cd cs

d_C_moveDown :: Curry_Prelude.C_Int -> C_Box -> Cover -> ConstStore -> C_Box
d_C_moveDown x1 x2 cd cs = d_C_alignVert (d_C_bottom cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (d_C_rows x2 cd cs) x1 cd cs) x2 cd cs

d_C_moveLeft :: Curry_Prelude.C_Int -> C_Box -> Cover -> ConstStore -> C_Box
d_C_moveLeft x1 x2 cd cs = d_C_alignHoriz (d_C_left cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (d_C_cols x2 cd cs) x1 cd cs) x2 cd cs

d_C_moveRight :: Curry_Prelude.C_Int -> C_Box -> Cover -> ConstStore -> C_Box
d_C_moveRight x1 x2 cd cs = d_C_alignHoriz (d_C_right cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (d_C_cols x2 cd cs) x1 cd cs) x2 cd cs

d_C_table :: Curry_Prelude.OP_List (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> Cover
  -> ConstStore -> C_Box
d_C_table x1 x2 cd cs = let x3 = Curry_Prelude.d_C_map (Curry_Prelude.d_C_zip
                              x2) x1 cd cs
  in Curry_Prelude.d_OP_dollar (d_C_vcat (d_C_left cd cs))
  (Curry_Prelude.d_C_map (Curry_Prelude.d_OP_dot (d_C_hcat (d_C_left cd cs))
  (Curry_Prelude.d_C_map (Curry_Prelude.d_OP_dollar (acceptCs id
  Curry_Prelude.d_C_uncurry) (acceptCs id (d_C_paraFill (d_C_left cd cs))) cd
  cs)) cd cs) x3 cd cs) cd cs

d_C_render :: Cover -> ConstStore -> C_Box -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_render cd cs = Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_unlines cd cs)
  d_C_renderBox cd cs

d_C_takeP :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_takeP x1 x2 x3 cd cs = d_C__case_6 x2 x3 x1
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  x2 (Curry_Prelude.C_Int (0)) cd cs) cd cs

d_C_fReverse :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t1
d_C_fReverse x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_reverse cd cs) x2 cd cs) x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_fReverse l cd cs)
    (d_C_fReverse r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_fReverse z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C_fReverse e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Boxes.fReverse"
    [show x1] info)
  _ -> failCons cd (consFail "Boxes.fReverse" (showCons x1))

d_OP_star_star_star :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0) => (t3 -> Cover -> ConstStore -> t1) -> (t2 -> Cover -> ConstStore -> t0)
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t3 t2 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 t0
d_OP_star_star_star x1 x2 cd cs = d_OP_star_star_star_dot_uscore_hash_lambda29
  x2 x1

nd_OP_star_star_star :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0) => Func t3 t1 -> Func t2 t0 -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 t3 t2) (Curry_Prelude.OP_Tuple2 t1 t0)
nd_OP_star_star_star x1 x2 s cd cs = wrapNX id
  (nd_OP_star_star_star_dot_uscore_hash_lambda29 x2 x1)

d_OP_star_star_star_dot_uscore_hash_lambda29 :: forall t0 t1 t2
  t3 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t0, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t1) => (t2 -> Cover -> ConstStore -> t0) -> (t3 -> Cover
  -> ConstStore -> t1) -> Curry_Prelude.OP_Tuple2 t3 t2 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 t0
d_OP_star_star_star_dot_uscore_hash_lambda29 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_C_apply x2 x4 cd cs) (Curry_Prelude.d_C_apply x1 x5 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_star_star_star_dot_uscore_hash_lambda29 x1 x2 l cd cs)
    (d_OP_star_star_star_dot_uscore_hash_lambda29 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_star_star_star_dot_uscore_hash_lambda29 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_star_star_star_dot_uscore_hash_lambda29 x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Boxes.***._#lambda29" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Boxes.***._#lambda29" (showCons x3))

nd_OP_star_star_star_dot_uscore_hash_lambda29 :: forall t0 t1 t2
  t3 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t0, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t1) => Func t2 t0 -> Func t3 t1
  -> Curry_Prelude.OP_Tuple2 t3 t2 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 t0
nd_OP_star_star_star_dot_uscore_hash_lambda29 x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_apply x2
    x4 s0 cd cs) (Curry_Prelude.nd_C_apply x1 x5 s1 cd cs)))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_star_star_star_dot_uscore_hash_lambda29 x1 x2 l s cd cs)
    (nd_OP_star_star_star_dot_uscore_hash_lambda29 x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_star_star_star_dot_uscore_hash_lambda29 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_star_star_star_dot_uscore_hash_lambda29 x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Boxes.***._#lambda29" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Boxes.***._#lambda29" (showCons x3))

d_C_takePA :: forall t0 . (Curry_Prelude.Curry t0) => C_Alignment -> t0
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_takePA x1 x2 x3 cd cs = let x4 = Curry_Prelude.d_OP_dot
                                  (Curry_Prelude.d_C_uncurry (acceptCs id
                                  Curry_Prelude.d_OP_plus_plus)) d_C_fReverse cd
                                  cs
  in Curry_Prelude.d_OP_dot x4 (Curry_Prelude.d_OP_dot (d_OP_star_star_star
  (d_C_takeP x2 (d_OP_takePA_dot_numRev_dot_110
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
  x1 x3 cd cs)) (d_C_takeP x2 (d_OP_takePA_dot_numFwd_dot_110
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
  x1 x3 cd cs)) cd cs) (d_OP_takePA_dot_split_dot_110 x1) cd cs) cd cs

d_OP_takePA_dot_numRev_dot_110 :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Integral t0) -> C_Alignment -> t0
  -> Cover -> ConstStore -> t0
d_OP_takePA_dot_numRev_dot_110 x1 x2 x3 cd cs = case x2 of
  C_AlignFirst -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_fromInt
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 cd cs) cd cs) cd cs) (Curry_Prelude.C_Int (0)) cd cs
  C_AlignLast -> x3
  C_AlignCenter1 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_div x1 cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_plus
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 cd cs) cd cs) cd cs) x3 cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_fromInt
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 cd cs) cd cs) cd cs) (Curry_Prelude.C_Int (1)) cd cs) cd cs) cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_fromInt
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 cd cs) cd cs) cd cs) (Curry_Prelude.C_Int (2)) cd cs) cd cs
  C_AlignCenter2 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_div x1 cd cs) x3 cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_fromInt
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 cd cs) cd cs) cd cs) (Curry_Prelude.C_Int (2)) cd cs) cd cs
  Choice_C_Alignment d i l r -> narrow d i (d_OP_takePA_dot_numRev_dot_110 x1 l
    x3 cd cs) (d_OP_takePA_dot_numRev_dot_110 x1 r x3 cd cs)
  Choices_C_Alignment d i xs -> narrows cs d i (\z ->
    d_OP_takePA_dot_numRev_dot_110 x1 z x3 cd cs) xs
  Guard_C_Alignment d c e -> guardCons d c ((\x ->
    d_OP_takePA_dot_numRev_dot_110 x1 e x3 cd x) $! addCs c cs)
  Fail_C_Alignment d info -> failCons d (traceFail "Boxes.takePA.numRev.110"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Boxes.takePA.numRev.110" (showCons x2))

nd_OP_takePA_dot_numRev_dot_110 :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Integral t0)
  -> C_Alignment -> t0 -> IDSupply -> Cover -> ConstStore -> t0
nd_OP_takePA_dot_numRev_dot_110 x1 x2 x3 s cd cs = case x2 of
  C_AlignFirst -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_fromInt (let s1 = leftSupply s2
                                                          s0 = rightSupply s2
    in s1 `seq` (s0 `seq`
    Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 s0 cd cs) s1 cd cs)) s3 cd cs)) (Curry_Prelude.C_Int (0)) s5 cd cs))
  C_AlignLast -> x3
  C_AlignCenter1 -> let s29 = s
    in s29 `seq` (let s28 = leftSupply s29
                      s30 = rightSupply s29
                      s19 = leftSupply s30
                      s27 = rightSupply s30
    in s28 `seq` (s30 `seq` (s19 `seq` (s27 `seq` Curry_Prelude.nd_C_apply
    (let s18 = leftSupply s19
         s20 = rightSupply s19
         s0 = leftSupply s20
         s16 = rightSupply s20
    in s18 `seq` (s20 `seq` (s0 `seq` (s16 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_div x1 s0 cd cs) (let s15 = leftSupply s16
                                              s17 = rightSupply s16
                                              s7 = leftSupply s17
                                              s14 = rightSupply s17
    in s15 `seq` (s17 `seq` (s7 `seq` (s14 `seq` Curry_Prelude.nd_C_apply
    (let s6 = leftSupply s7
         s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                        s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_OP_plus (let s2 = leftSupply s3
                                                        s1 = rightSupply s3
    in s2 `seq` (s1 `seq`
    Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 s1 cd cs) s2 cd cs)) s4 cd cs)) x3 s6 cd cs)) (let s13 = leftSupply s14
                                                          s12 = rightSupply s14
    in s13 `seq` (s12 `seq` Curry_Prelude.nd_C_apply (let s11 = leftSupply s12
                                                          s10 = rightSupply s12
    in s11 `seq` (s10 `seq` Curry_Prelude.nd_C_fromInt (let s9 = leftSupply s10
                                                            s8 = rightSupply s10
    in s9 `seq` (s8 `seq`
    Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 s8 cd cs) s9 cd cs)) s11 cd cs)) (Curry_Prelude.C_Int (1)) s13 cd cs))
    s15 cd cs)))) s18 cd cs)))) (let s26 = leftSupply s27
                                     s25 = rightSupply s27
    in s26 `seq` (s25 `seq` Curry_Prelude.nd_C_apply (let s24 = leftSupply s25
                                                          s23 = rightSupply s25
    in s24 `seq` (s23 `seq` Curry_Prelude.nd_C_fromInt (let s22 = leftSupply s23
                                                            s21 = rightSupply
                                                              s23
    in s22 `seq` (s21 `seq`
    Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 s21 cd cs) s22 cd cs)) s24 cd cs)) (Curry_Prelude.C_Int (2)) s26 cd cs))
    s28 cd cs))))
  C_AlignCenter2 -> let s11 = s
    in s11 `seq` (let s10 = leftSupply s11
                      s12 = rightSupply s11
                      s2 = leftSupply s12
                      s9 = rightSupply s12
    in s10 `seq` (s12 `seq` (s2 `seq` (s9 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_div x1 s0
    cd cs) x3 s1 cd cs)) (let s8 = leftSupply s9
                              s7 = rightSupply s9
    in s8 `seq` (s7 `seq` Curry_Prelude.nd_C_apply (let s6 = leftSupply s7
                                                        s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_fromInt (let s4 = leftSupply s5
                                                          s3 = rightSupply s5
    in s4 `seq` (s3 `seq`
    Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 s3 cd cs) s4 cd cs)) s6 cd cs)) (Curry_Prelude.C_Int (2)) s8 cd cs)) s10
    cd cs))))
  Choice_C_Alignment d i l r -> narrow d i (nd_OP_takePA_dot_numRev_dot_110 x1 l
    x3 s cd cs) (nd_OP_takePA_dot_numRev_dot_110 x1 r x3 s cd cs)
  Choices_C_Alignment d i xs -> narrows cs d i (\z ->
    nd_OP_takePA_dot_numRev_dot_110 x1 z x3 s cd cs) xs
  Guard_C_Alignment d c e -> guardCons d c ((\x ->
    nd_OP_takePA_dot_numRev_dot_110 x1 e x3 s cd x) $! addCs c cs)
  Fail_C_Alignment d info -> failCons d (traceFail "Boxes.takePA.numRev.110"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Boxes.takePA.numRev.110" (showCons x2))

d_OP_takePA_dot_split_dot_110 :: forall t0 . (Curry_Prelude.Curry
  t0) => C_Alignment -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t0)
d_OP_takePA_dot_split_dot_110 x1 x2 cd cs = Curry_Prelude.d_OP_dollar
  (Curry_Prelude.d_OP_dot d_C_fReverse (Curry_Prelude.d_C_splitAt
  (d_OP_takePA_dot_numRev_dot_110
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
  x1 (Curry_Prelude.d_C_length x2 cd cs) cd cs)) cd cs) x2 cd cs

d_OP_takePA_dot_numFwd_dot_110 :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Integral t0) -> C_Alignment -> t0
  -> Cover -> ConstStore -> t0
d_OP_takePA_dot_numFwd_dot_110 x1 x2 x3 cd cs = case x2 of
  C_AlignFirst -> x3
  C_AlignLast -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_fromInt
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 cd cs) cd cs) cd cs) (Curry_Prelude.C_Int (0)) cd cs
  C_AlignCenter1 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_div x1 cd cs) x3 cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_fromInt
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 cd cs) cd cs) cd cs) (Curry_Prelude.C_Int (2)) cd cs) cd cs
  C_AlignCenter2 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_div x1 cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_plus
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 cd cs) cd cs) cd cs) x3 cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_fromInt
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 cd cs) cd cs) cd cs) (Curry_Prelude.C_Int (1)) cd cs) cd cs) cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_fromInt
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 cd cs) cd cs) cd cs) (Curry_Prelude.C_Int (2)) cd cs) cd cs
  Choice_C_Alignment d i l r -> narrow d i (d_OP_takePA_dot_numFwd_dot_110 x1 l
    x3 cd cs) (d_OP_takePA_dot_numFwd_dot_110 x1 r x3 cd cs)
  Choices_C_Alignment d i xs -> narrows cs d i (\z ->
    d_OP_takePA_dot_numFwd_dot_110 x1 z x3 cd cs) xs
  Guard_C_Alignment d c e -> guardCons d c ((\x ->
    d_OP_takePA_dot_numFwd_dot_110 x1 e x3 cd x) $! addCs c cs)
  Fail_C_Alignment d info -> failCons d (traceFail "Boxes.takePA.numFwd.110"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Boxes.takePA.numFwd.110" (showCons x2))

nd_OP_takePA_dot_numFwd_dot_110 :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Integral t0)
  -> C_Alignment -> t0 -> IDSupply -> Cover -> ConstStore -> t0
nd_OP_takePA_dot_numFwd_dot_110 x1 x2 x3 s cd cs = case x2 of
  C_AlignFirst -> x3
  C_AlignLast -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_fromInt (let s1 = leftSupply s2
                                                          s0 = rightSupply s2
    in s1 `seq` (s0 `seq`
    Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 s0 cd cs) s1 cd cs)) s3 cd cs)) (Curry_Prelude.C_Int (0)) s5 cd cs))
  C_AlignCenter1 -> let s11 = s
    in s11 `seq` (let s10 = leftSupply s11
                      s12 = rightSupply s11
                      s2 = leftSupply s12
                      s9 = rightSupply s12
    in s10 `seq` (s12 `seq` (s2 `seq` (s9 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_div x1 s0
    cd cs) x3 s1 cd cs)) (let s8 = leftSupply s9
                              s7 = rightSupply s9
    in s8 `seq` (s7 `seq` Curry_Prelude.nd_C_apply (let s6 = leftSupply s7
                                                        s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_fromInt (let s4 = leftSupply s5
                                                          s3 = rightSupply s5
    in s4 `seq` (s3 `seq`
    Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 s3 cd cs) s4 cd cs)) s6 cd cs)) (Curry_Prelude.C_Int (2)) s8 cd cs)) s10
    cd cs))))
  C_AlignCenter2 -> let s29 = s
    in s29 `seq` (let s28 = leftSupply s29
                      s30 = rightSupply s29
                      s19 = leftSupply s30
                      s27 = rightSupply s30
    in s28 `seq` (s30 `seq` (s19 `seq` (s27 `seq` Curry_Prelude.nd_C_apply
    (let s18 = leftSupply s19
         s20 = rightSupply s19
         s0 = leftSupply s20
         s16 = rightSupply s20
    in s18 `seq` (s20 `seq` (s0 `seq` (s16 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_div x1 s0 cd cs) (let s15 = leftSupply s16
                                              s17 = rightSupply s16
                                              s7 = leftSupply s17
                                              s14 = rightSupply s17
    in s15 `seq` (s17 `seq` (s7 `seq` (s14 `seq` Curry_Prelude.nd_C_apply
    (let s6 = leftSupply s7
         s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                        s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_OP_plus (let s2 = leftSupply s3
                                                        s1 = rightSupply s3
    in s2 `seq` (s1 `seq`
    Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 s1 cd cs) s2 cd cs)) s4 cd cs)) x3 s6 cd cs)) (let s13 = leftSupply s14
                                                          s12 = rightSupply s14
    in s13 `seq` (s12 `seq` Curry_Prelude.nd_C_apply (let s11 = leftSupply s12
                                                          s10 = rightSupply s12
    in s11 `seq` (s10 `seq` Curry_Prelude.nd_C_fromInt (let s9 = leftSupply s10
                                                            s8 = rightSupply s10
    in s9 `seq` (s8 `seq`
    Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 s8 cd cs) s9 cd cs)) s11 cd cs)) (Curry_Prelude.C_Int (1)) s13 cd cs))
    s15 cd cs)))) s18 cd cs)))) (let s26 = leftSupply s27
                                     s25 = rightSupply s27
    in s26 `seq` (s25 `seq` Curry_Prelude.nd_C_apply (let s24 = leftSupply s25
                                                          s23 = rightSupply s25
    in s24 `seq` (s23 `seq` Curry_Prelude.nd_C_fromInt (let s22 = leftSupply s23
                                                            s21 = rightSupply
                                                              s23
    in s22 `seq` (s21 `seq`
    Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x1 s21 cd cs) s22 cd cs)) s24 cd cs)) (Curry_Prelude.C_Int (2)) s26 cd cs))
    s28 cd cs))))
  Choice_C_Alignment d i l r -> narrow d i (nd_OP_takePA_dot_numFwd_dot_110 x1 l
    x3 s cd cs) (nd_OP_takePA_dot_numFwd_dot_110 x1 r x3 s cd cs)
  Choices_C_Alignment d i xs -> narrows cs d i (\z ->
    nd_OP_takePA_dot_numFwd_dot_110 x1 z x3 s cd cs) xs
  Guard_C_Alignment d c e -> guardCons d c ((\x ->
    nd_OP_takePA_dot_numFwd_dot_110 x1 e x3 s cd x) $! addCs c cs)
  Fail_C_Alignment d info -> failCons d (traceFail "Boxes.takePA.numFwd.110"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Boxes.takePA.numFwd.110" (showCons x2))

d_C_blanks :: Cover -> ConstStore -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_blanks cd cs = Curry_Prelude.d_C_flip (acceptCs id
  Curry_Prelude.d_C_replicate) (Curry_Prelude.C_Char ' '#)

d_C_renderBox :: C_Box -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_renderBox x1 cd cs = case x1 of
  C_Box x2 x3 x4 -> d_C__case_3 x3 x2 x4 cd cs
  Choice_C_Box d i l r -> narrow d i (d_C_renderBox l cd cs) (d_C_renderBox r cd
    cs)
  Choices_C_Box d i xs -> narrows cs d i (\z -> d_C_renderBox z cd cs) xs
  Guard_C_Box d c e -> guardCons d c ((\x -> d_C_renderBox e cd x) $! addCs c
    cs)
  Fail_C_Box d info -> failCons d (traceFail "Boxes.renderBox" [show x1] info)
  _ -> failCons cd (consFail "Boxes.renderBox" (showCons x1))

d_C_renderBoxWithRows :: Curry_Prelude.C_Int -> C_Box -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_renderBoxWithRows x1 x2 cd cs = d_C_renderBox (d_C__case_2 x1 x2 cd cs) cd
  cs

d_C_renderBoxWithCols :: Curry_Prelude.C_Int -> C_Box -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_renderBoxWithCols x1 x2 cd cs = d_C_renderBox (d_C__case_1 x1 x2 cd cs) cd
  cs

d_C_resizeBox :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_resizeBox x1 x2 cd cs = Curry_Prelude.d_OP_dot (d_C_takeP
  (Curry_Prelude.d_C_apply (d_C_blanks cd cs) x2 cd cs) x1)
  (Curry_Prelude.d_C_map (d_C_takeP (Curry_Prelude.C_Char ' '#) x2)) cd cs

d_C_resizeBoxAligned :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> C_Alignment -> C_Alignment -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_resizeBoxAligned x1 x2 x3 x4 cd cs = Curry_Prelude.d_OP_dot (d_C_takePA x4
  (Curry_Prelude.d_C_apply (d_C_blanks cd cs) x2 cd cs) x1 cd cs)
  (Curry_Prelude.d_C_map (d_C_takePA x3 (Curry_Prelude.C_Char ' '#) x2 cd cs))
  cd cs

d_C_printBox :: Cover -> ConstStore -> C_Box -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_printBox cd cs = Curry_Prelude.d_OP_dot Curry_Prelude.d_C_putStr (d_C_render
  cd cs) cd cs

d_C_chunksOf :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)
d_C_chunksOf x1 x2 cd cs = Curry_Prelude.d_C_map (Curry_Prelude.d_C_take x1)
  (Curry_Prelude.OP_Cons x2 (d_OP_chunksOf_dot_partials_dot_156 x1 x2 cd cs)) cd
  cs

d_OP_chunksOf_dot_partials_dot_156 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
d_OP_chunksOf_dot_partials_dot_156 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> let x5 = Curry_Prelude.d_C_drop x1 x2 cd cs
    in d_C__case_0 x1 x5 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_chunksOf_dot_partials_dot_156 x1 l cd cs)
    (d_OP_chunksOf_dot_partials_dot_156 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_chunksOf_dot_partials_dot_156 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_chunksOf_dot_partials_dot_156 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Boxes.chunksOf.partials.156" [show x1, show x2] info)
  _ -> failCons cd (consFail "Boxes.chunksOf.partials.156" (showCons x2))

d_C_sum :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_sum cd cs = Curry_Prelude.d_C_foldl (acceptCs id
  Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash)
  (Curry_Prelude.C_Int (0))

nd_C__case_26 :: C_Content -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> C_Box -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_26 x5 x4 x3 x2 s cd cs = case x2 of
  C_Box x6 x7 x8 -> let s8 = s
    in s8 `seq` (let s6 = leftSupply s8
                     s7 = rightSupply s8
    in s6 `seq` (s7 `seq` Curry_Prelude.d_OP_amp_amp (let s2 = leftSupply s6
                                                          s5 = rightSupply s6
    in s2 `seq` (s5 `seq` Curry_Prelude.d_OP_amp_amp (let s1 = leftSupply s2
                                                          s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs)) x3 s0 cd cs) x6 s1 cd cs)) (let s4 = leftSupply s5
                                            s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs)) x4 s3 cd cs) x7 s4 cd cs)) cd cs))
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Content_hash
    x5 x8 s7 cd cs) cd cs))
  Choice_C_Box d i l r -> narrow d i (nd_C__case_26 x5 x4 x3 l s cd cs)
    (nd_C__case_26 x5 x4 x3 r s cd cs)
  Choices_C_Box d i xs -> narrows cs d i (\z -> nd_C__case_26 x5 x4 x3 z s cd
    cs) xs
  Guard_C_Box d c e -> guardCons d c ((\x -> nd_C__case_26 x5 x4 x3 e s cd x) $!
    addCs c cs)
  Fail_C_Box d info -> failCons d (traceFail "Boxes._case_26" [show x5, show x4
    , show x3, show x2] info)
  _ -> failCons cd (consFail "Boxes._case_26" (showCons x2))

d_C__case_22 :: C_Alignment -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_22 x2 cd cs = case x2 of
  C_AlignFirst -> Curry_Prelude.C_False
  C_AlignCenter1 -> Curry_Prelude.C_False
  C_AlignCenter2 -> Curry_Prelude.C_False
  C_AlignLast -> Curry_Prelude.C_True
  Choice_C_Alignment d i l r -> narrow d i (d_C__case_22 l cd cs) (d_C__case_22
    r cd cs)
  Choices_C_Alignment d i xs -> narrows cs d i (\z -> d_C__case_22 z cd cs) xs
  Guard_C_Alignment d c e -> guardCons d c ((\x -> d_C__case_22 e cd x) $! addCs
    c cs)
  Fail_C_Alignment d info -> failCons d (traceFail "Boxes._case_22" [show x2]
    info)
  _ -> failCons cd (consFail "Boxes._case_22" (showCons x2))

d_C__case_23 :: C_Alignment -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_23 x2 cd cs = case x2 of
  C_AlignFirst -> Curry_Prelude.C_False
  C_AlignCenter1 -> Curry_Prelude.C_False
  C_AlignCenter2 -> Curry_Prelude.C_True
  C_AlignLast -> Curry_Prelude.C_False
  Choice_C_Alignment d i l r -> narrow d i (d_C__case_23 l cd cs) (d_C__case_23
    r cd cs)
  Choices_C_Alignment d i xs -> narrows cs d i (\z -> d_C__case_23 z cd cs) xs
  Guard_C_Alignment d c e -> guardCons d c ((\x -> d_C__case_23 e cd x) $! addCs
    c cs)
  Fail_C_Alignment d info -> failCons d (traceFail "Boxes._case_23" [show x2]
    info)
  _ -> failCons cd (consFail "Boxes._case_23" (showCons x2))

d_C__case_24 :: C_Alignment -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_24 x2 cd cs = case x2 of
  C_AlignFirst -> Curry_Prelude.C_False
  C_AlignCenter1 -> Curry_Prelude.C_True
  C_AlignCenter2 -> Curry_Prelude.C_False
  C_AlignLast -> Curry_Prelude.C_False
  Choice_C_Alignment d i l r -> narrow d i (d_C__case_24 l cd cs) (d_C__case_24
    r cd cs)
  Choices_C_Alignment d i xs -> narrows cs d i (\z -> d_C__case_24 z cd cs) xs
  Guard_C_Alignment d c e -> guardCons d c ((\x -> d_C__case_24 e cd x) $! addCs
    c cs)
  Fail_C_Alignment d info -> failCons d (traceFail "Boxes._case_24" [show x2]
    info)
  _ -> failCons cd (consFail "Boxes._case_24" (showCons x2))

d_C__case_25 :: C_Alignment -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_25 x2 cd cs = case x2 of
  C_AlignFirst -> Curry_Prelude.C_True
  C_AlignCenter1 -> Curry_Prelude.C_False
  C_AlignCenter2 -> Curry_Prelude.C_False
  C_AlignLast -> Curry_Prelude.C_False
  Choice_C_Alignment d i l r -> narrow d i (d_C__case_25 l cd cs) (d_C__case_25
    r cd cs)
  Choices_C_Alignment d i xs -> narrows cs d i (\z -> d_C__case_25 z cd cs) xs
  Guard_C_Alignment d c e -> guardCons d c ((\x -> d_C__case_25 e cd x) $! addCs
    c cs)
  Fail_C_Alignment d info -> failCons d (traceFail "Boxes._case_25" [show x2]
    info)
  _ -> failCons cd (consFail "Boxes._case_25" (showCons x2))

nd_C__case_17 :: C_Box -> C_Alignment -> C_Alignment -> C_Content -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_17 x32 x31 x30 x2 s cd cs = case x2 of
  C_Blank -> Curry_Prelude.C_False
  C_Text x33 -> Curry_Prelude.C_False
  C_Row x34 -> Curry_Prelude.C_False
  C_Col x35 -> Curry_Prelude.C_False
  C_SubBox x36 x37 x38 -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_amp_amp
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash
    x30 x36 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Alignment_hash
    x31 x37 cd cs) cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash
    x32 x38 s0 cd cs) cd cs
  Choice_C_Content d i l r -> narrow d i (nd_C__case_17 x32 x31 x30 l s cd cs)
    (nd_C__case_17 x32 x31 x30 r s cd cs)
  Choices_C_Content d i xs -> narrows cs d i (\z -> nd_C__case_17 x32 x31 x30 z
    s cd cs) xs
  Guard_C_Content d c e -> guardCons d c ((\x -> nd_C__case_17 x32 x31 x30 e s
    cd x) $! addCs c cs)
  Fail_C_Content d info -> failCons d (traceFail "Boxes._case_17" [show x32
    , show x31, show x30, show x2] info)
  _ -> failCons cd (consFail "Boxes._case_17" (showCons x2))

nd_C__case_18 :: Curry_Prelude.OP_List C_Box -> C_Content -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_18 x23 x2 s cd cs = case x2 of
  C_Blank -> Curry_Prelude.C_False
  C_Text x24 -> Curry_Prelude.C_False
  C_Row x25 -> Curry_Prelude.C_False
  C_Col x26 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash)
    x23 x26 s0 cd cs
  C_SubBox x27 x28 x29 -> Curry_Prelude.C_False
  Choice_C_Content d i l r -> narrow d i (nd_C__case_18 x23 l s cd cs)
    (nd_C__case_18 x23 r s cd cs)
  Choices_C_Content d i xs -> narrows cs d i (\z -> nd_C__case_18 x23 z s cd cs)
    xs
  Guard_C_Content d c e -> guardCons d c ((\x -> nd_C__case_18 x23 e s cd x) $!
    addCs c cs)
  Fail_C_Content d info -> failCons d (traceFail "Boxes._case_18" [show x23
    , show x2] info)
  _ -> failCons cd (consFail "Boxes._case_18" (showCons x2))

nd_C__case_19 :: Curry_Prelude.OP_List C_Box -> C_Content -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_19 x16 x2 s cd cs = case x2 of
  C_Blank -> Curry_Prelude.C_False
  C_Text x17 -> Curry_Prelude.C_False
  C_Row x18 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Box_hash)
    x16 x18 s0 cd cs
  C_Col x19 -> Curry_Prelude.C_False
  C_SubBox x20 x21 x22 -> Curry_Prelude.C_False
  Choice_C_Content d i l r -> narrow d i (nd_C__case_19 x16 l s cd cs)
    (nd_C__case_19 x16 r s cd cs)
  Choices_C_Content d i xs -> narrows cs d i (\z -> nd_C__case_19 x16 z s cd cs)
    xs
  Guard_C_Content d c e -> guardCons d c ((\x -> nd_C__case_19 x16 e s cd x) $!
    addCs c cs)
  Fail_C_Content d info -> failCons d (traceFail "Boxes._case_19" [show x16
    , show x2] info)
  _ -> failCons cd (consFail "Boxes._case_19" (showCons x2))

nd_C__case_20 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Content
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_20 x9 x2 s cd cs = case x2 of
  C_Blank -> Curry_Prelude.C_False
  C_Text x10 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x9 x10 s0 cd cs
  C_Row x11 -> Curry_Prelude.C_False
  C_Col x12 -> Curry_Prelude.C_False
  C_SubBox x13 x14 x15 -> Curry_Prelude.C_False
  Choice_C_Content d i l r -> narrow d i (nd_C__case_20 x9 l s cd cs)
    (nd_C__case_20 x9 r s cd cs)
  Choices_C_Content d i xs -> narrows cs d i (\z -> nd_C__case_20 x9 z s cd cs)
    xs
  Guard_C_Content d c e -> guardCons d c ((\x -> nd_C__case_20 x9 e s cd x) $!
    addCs c cs)
  Fail_C_Content d info -> failCons d (traceFail "Boxes._case_20" [show x9, show
    x2] info)
  _ -> failCons cd (consFail "Boxes._case_20" (showCons x2))

d_C__case_21 :: C_Content -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_21 x2 cd cs = case x2 of
  C_Blank -> Curry_Prelude.C_True
  C_Text x3 -> Curry_Prelude.C_False
  C_Row x4 -> Curry_Prelude.C_False
  C_Col x5 -> Curry_Prelude.C_False
  C_SubBox x6 x7 x8 -> Curry_Prelude.C_False
  Choice_C_Content d i l r -> narrow d i (d_C__case_21 l cd cs) (d_C__case_21 r
    cd cs)
  Choices_C_Content d i xs -> narrows cs d i (\z -> d_C__case_21 z cd cs) xs
  Guard_C_Content d c e -> guardCons d c ((\x -> d_C__case_21 e cd x) $! addCs c
    cs)
  Fail_C_Content d info -> failCons d (traceFail "Boxes._case_21" [show x2]
    info)
  _ -> failCons cd (consFail "Boxes._case_21" (showCons x2))

nd_C__case_16 :: C_ParaContent -> Curry_Prelude.C_Int -> C_Para -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_16 x4 x3 x2 s cd cs = case x2 of
  C_Para x5 x6 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s1 = leftSupply s2
                                                          s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs)) x3 s0 cd cs) x5 s1 cd cs))
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_ParaContent_hash
    x4 x6 s3 cd cs) cd cs))
  Choice_C_Para d i l r -> narrow d i (nd_C__case_16 x4 x3 l s cd cs)
    (nd_C__case_16 x4 x3 r s cd cs)
  Choices_C_Para d i xs -> narrows cs d i (\z -> nd_C__case_16 x4 x3 z s cd cs)
    xs
  Guard_C_Para d c e -> guardCons d c ((\x -> nd_C__case_16 x4 x3 e s cd x) $!
    addCs c cs)
  Fail_C_Para d info -> failCons d (traceFail "Boxes._case_16" [show x4, show x3
    , show x2] info)
  _ -> failCons cd (consFail "Boxes._case_16" (showCons x2))

nd_C__case_15 :: C_Line -> Curry_Prelude.OP_List C_Line -> C_ParaContent
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_15 x4 x3 x2 s cd cs = case x2 of
  C_Block x5 x6 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash)
    x3 x5 s0 cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Boxes_dot_Line_hash
    x4 x6 s1 cd cs) cd cs))
  Choice_C_ParaContent d i l r -> narrow d i (nd_C__case_15 x4 x3 l s cd cs)
    (nd_C__case_15 x4 x3 r s cd cs)
  Choices_C_ParaContent d i xs -> narrows cs d i (\z -> nd_C__case_15 x4 x3 z s
    cd cs) xs
  Guard_C_ParaContent d c e -> guardCons d c ((\x -> nd_C__case_15 x4 x3 e s cd
    x) $! addCs c cs)
  Fail_C_ParaContent d info -> failCons d (traceFail "Boxes._case_15" [show x4
    , show x3, show x2] info)
  _ -> failCons cd (consFail "Boxes._case_15" (showCons x2))

nd_C__case_14 :: Curry_Prelude.OP_List C_Word -> Curry_Prelude.C_Int -> C_Line
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_14 x4 x3 x2 s cd cs = case x2 of
  C_Line x5 x6 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s1 = leftSupply s2
                                                          s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs)) x3 s0 cd cs) x5 s1 cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Boxes_dot_Word_hash)
    x4 x6 s3 cd cs) cd cs))
  Choice_C_Line d i l r -> narrow d i (nd_C__case_14 x4 x3 l s cd cs)
    (nd_C__case_14 x4 x3 r s cd cs)
  Choices_C_Line d i xs -> narrows cs d i (\z -> nd_C__case_14 x4 x3 z s cd cs)
    xs
  Guard_C_Line d c e -> guardCons d c ((\x -> nd_C__case_14 x4 x3 e s cd x) $!
    addCs c cs)
  Fail_C_Line d info -> failCons d (traceFail "Boxes._case_14" [show x4, show x3
    , show x2] info)
  _ -> failCons cd (consFail "Boxes._case_14" (showCons x2))

nd_C__case_13 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> C_Word -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_13 x4 x3 x2 s cd cs = case x2 of
  C_Word x5 x6 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s1 = leftSupply s2
                                                          s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs)) x3 s0 cd cs) x5 s1 cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x4 x6 s3 cd cs) cd cs))
  Choice_C_Word d i l r -> narrow d i (nd_C__case_13 x4 x3 l s cd cs)
    (nd_C__case_13 x4 x3 r s cd cs)
  Choices_C_Word d i xs -> narrows cs d i (\z -> nd_C__case_13 x4 x3 z s cd cs)
    xs
  Guard_C_Word d c e -> guardCons d c ((\x -> nd_C__case_13 x4 x3 e s cd x) $!
    addCs c cs)
  Fail_C_Word d info -> failCons d (traceFail "Boxes._case_13" [show x4, show x3
    , show x2] info)
  _ -> failCons cd (consFail "Boxes._case_13" (showCons x2))

d_C__case_12 :: C_ParaContent -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_12 x3 cd cs = case x3 of
  C_Block x4 x5 -> let x6 = Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_map
                         (Curry_Prelude.d_OP_dot Curry_Prelude.d_C_unwords
                         (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_reverse cd
                         cs) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_map
                         d_C_getWord) d_C_getWords cd cs) cd cs) cd cs))
                         (Curry_Prelude.d_C_reverse cd cs) cd cs
    in d_C__case_11 x5 x4 x6
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    (d_C_lLen x5 cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs
  Choice_C_ParaContent d i l r -> narrow d i (d_C__case_12 l cd cs)
    (d_C__case_12 r cd cs)
  Choices_C_ParaContent d i xs -> narrows cs d i (\z -> d_C__case_12 z cd cs) xs
  Guard_C_ParaContent d c e -> guardCons d c ((\x -> d_C__case_12 e cd x) $!
    addCs c cs)
  Fail_C_ParaContent d info -> failCons d (traceFail "Boxes._case_12" [show x3]
    info)
  _ -> failCons cd (consFail "Boxes._case_12" (showCons x3))

d_C__case_11 :: C_Line -> Curry_Prelude.OP_List C_Line -> (Curry_Prelude.OP_List
  C_Line -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_11 x5 x4 x6 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply x6 x4 cd cs
  Curry_Prelude.C_False -> d_C__case_10 x4 x5 x6 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_11 x5 x4 x6 l cd
    cs) (d_C__case_11 x5 x4 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_11 x5
    x4 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_11 x5 x4
    x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Boxes._case_11"
    [show x5, show x4, show x6, show x7] info)
  _ -> failCons cd (consFail "Boxes._case_11" (showCons x7))

nd_C__case_11 :: C_Line -> Curry_Prelude.OP_List C_Line -> Func
  (Curry_Prelude.OP_List C_Line) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_C__case_11 x5 x4 x6 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x6 x4 s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_10 x4 x5 x6 (Curry_Prelude.d_C_otherwise cd cs) s0 cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_11 x5 x4 x6 l s
    cd cs) (nd_C__case_11 x5 x4 x6 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_11 x5
    x4 x6 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_11 x5 x4
    x6 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Boxes._case_11"
    [show x5, show x4, show x6, show x7] info)
  _ -> failCons cd (consFail "Boxes._case_11" (showCons x7))

d_C__case_10 :: Curry_Prelude.OP_List C_Line -> C_Line -> (Curry_Prelude.OP_List
  C_Line -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_10 x4 x5 x6 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply x6 (Curry_Prelude.OP_Cons x5
    x4) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_10 x4 x5 x6 l cd
    cs) (d_C__case_10 x4 x5 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_10 x4
    x5 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_10 x4 x5
    x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Boxes._case_10"
    [show x4, show x5, show x6, show x7] info)
  _ -> failCons cd (consFail "Boxes._case_10" (showCons x7))

nd_C__case_10 :: Curry_Prelude.OP_List C_Line -> C_Line -> Func
  (Curry_Prelude.OP_List C_Line) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_C__case_10 x4 x5 x6 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x6 (Curry_Prelude.OP_Cons x5 x4) s0 cd
    cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_10 x4 x5 x6 l s
    cd cs) (nd_C__case_10 x4 x5 x6 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_10 x4
    x5 x6 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_10 x4 x5
    x6 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Boxes._case_10"
    [show x4, show x5, show x6, show x7] info)
  _ -> failCons cd (consFail "Boxes._case_10" (showCons x7))

d_C__case_9 :: C_Word -> Curry_Prelude.C_Int -> C_ParaContent -> Cover
  -> ConstStore -> C_Para
d_C__case_9 x2 x3 x4 cd cs = case x4 of
  C_Block x5 x6 -> d_C__case_8 x6 x2 x3 x5 (d_C_wordFits x3 x2 x6 cd cs) cd cs
  Choice_C_ParaContent d i l r -> narrow d i (d_C__case_9 x2 x3 l cd cs)
    (d_C__case_9 x2 x3 r cd cs)
  Choices_C_ParaContent d i xs -> narrows cs d i (\z -> d_C__case_9 x2 x3 z cd
    cs) xs
  Guard_C_ParaContent d c e -> guardCons d c ((\x -> d_C__case_9 x2 x3 e cd
    x) $! addCs c cs)
  Fail_C_ParaContent d info -> failCons d (traceFail "Boxes._case_9" [show x2
    , show x3, show x4] info)
  _ -> failCons cd (consFail "Boxes._case_9" (showCons x4))

d_C__case_8 :: C_Line -> C_Word -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  C_Line -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Para
d_C__case_8 x6 x2 x3 x5 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> C_Para x3 (C_Block x5 (d_C_addWordL x2 x6 cd cs))
  Curry_Prelude.C_False -> d_C__case_7 x2 x5 x6 x3 (Curry_Prelude.d_C_otherwise
    cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x6 x2 x3 x5 l
    cd cs) (d_C__case_8 x6 x2 x3 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x6 x2
    x3 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_8 x6 x2 x3
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Boxes._case_8"
    [show x6, show x2, show x3, show x5, show x7] info)
  _ -> failCons cd (consFail "Boxes._case_8" (showCons x7))

d_C__case_7 :: C_Word -> Curry_Prelude.OP_List C_Line -> C_Line
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> C_Para
d_C__case_7 x2 x5 x6 x3 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> C_Para x3 (C_Block (Curry_Prelude.OP_Cons x6 x5)
    (Curry_Prelude.d_C_apply (d_C_startLine cd cs) x2 cd cs))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x2 x5 x6 x3 l
    cd cs) (d_C__case_7 x2 x5 x6 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x2 x5
    x6 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_7 x2 x5 x6
    x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Boxes._case_7"
    [show x2, show x5, show x6, show x3, show x7] info)
  _ -> failCons cd (consFail "Boxes._case_7" (showCons x7))

d_C__case_6 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> t0 -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_6 x2 x3 x1 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> d_C__case_5 x3 x2 x1 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x2 x3 x1 l cd
    cs) (d_C__case_6 x2 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x2 x3
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x2 x3 x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Boxes._case_6"
    [show x2, show x3, show x1, show x4] info)
  _ -> failCons cd (consFail "Boxes._case_6" (showCons x4))

d_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Int -> t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C__case_5 x3 x2 x1 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> d_C__case_4 x2 x1 x3 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x3 x2 x1 l cd
    cs) (d_C__case_5 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x3 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x3 x2 x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Boxes._case_5"
    [show x3, show x2, show x1, show x4] info)
  _ -> failCons cd (consFail "Boxes._case_5" (showCons x4))

d_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int -> t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_4 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_replicate x2 x1 cd cs
  Curry_Prelude.OP_Cons x4 x5 -> Curry_Prelude.OP_Cons x4 (d_C_takeP x1
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x2 (Curry_Prelude.C_Int (1)) cd cs) x5 cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_4 x2 x1 l cd cs)
    (d_C__case_4 x2 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_4 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_4 x2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Boxes._case_4"
    [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "Boxes._case_4" (showCons x3))

d_C__case_3 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> C_Content -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_3 x3 x2 x4 cd cs = case x4 of
  C_Blank -> Curry_Prelude.d_C_apply (d_C_resizeBox x2 x3 cd cs)
    (Curry_Prelude.OP_Cons Curry_Prelude.OP_List Curry_Prelude.OP_List) cd cs
  C_Text x5 -> Curry_Prelude.d_C_apply (d_C_resizeBox x2 x3 cd cs)
    (Curry_Prelude.OP_Cons x5 Curry_Prelude.OP_List) cd cs
  C_Row x6 -> let x7 = Curry_Prelude.d_C_foldr (acceptCs id
                    (Curry_Prelude.d_C_zipWith (acceptCs id
                    Curry_Prelude.d_OP_plus_plus))) (Curry_Prelude.d_C_repeat
                    Curry_Prelude.OP_List cd cs)
    in Curry_Prelude.d_OP_dollar (Curry_Prelude.d_OP_dot (d_C_resizeBox x2 x3 cd
    cs) (Curry_Prelude.d_OP_dot x7 (Curry_Prelude.d_C_map (d_C_renderBoxWithRows
    x2)) cd cs) cd cs) x6 cd cs
  C_Col x8 -> Curry_Prelude.d_OP_dollar (Curry_Prelude.d_OP_dot (d_C_resizeBox
    x2 x3 cd cs) (Curry_Prelude.d_C_concatMap (d_C_renderBoxWithCols x3) cd cs)
    cd cs) x8 cd cs
  C_SubBox x9 x10 x11 -> Curry_Prelude.d_OP_dollar (Curry_Prelude.d_OP_dot
    (d_C_resizeBoxAligned x2 x3 x9 x10 cd cs) d_C_renderBox cd cs) x11 cd cs
  Choice_C_Content d i l r -> narrow d i (d_C__case_3 x3 x2 l cd cs)
    (d_C__case_3 x3 x2 r cd cs)
  Choices_C_Content d i xs -> narrows cs d i (\z -> d_C__case_3 x3 x2 z cd cs)
    xs
  Guard_C_Content d c e -> guardCons d c ((\x -> d_C__case_3 x3 x2 e cd x) $!
    addCs c cs)
  Fail_C_Content d info -> failCons d (traceFail "Boxes._case_3" [show x3, show
    x2, show x4] info)
  _ -> failCons cd (consFail "Boxes._case_3" (showCons x4))

d_C__case_2 :: Curry_Prelude.C_Int -> C_Box -> Cover -> ConstStore -> C_Box
d_C__case_2 x1 x2 cd cs = case x2 of
  C_Box x3 x4 x5 -> C_Box x1 x4 x5
  Choice_C_Box d i l r -> narrow d i (d_C__case_2 x1 l cd cs) (d_C__case_2 x1 r
    cd cs)
  Choices_C_Box d i xs -> narrows cs d i (\z -> d_C__case_2 x1 z cd cs) xs
  Guard_C_Box d c e -> guardCons d c ((\x -> d_C__case_2 x1 e cd x) $! addCs c
    cs)
  Fail_C_Box d info -> failCons d (traceFail "Boxes._case_2" [show x1, show x2]
    info)
  _ -> failCons cd (consFail "Boxes._case_2" (showCons x2))

d_C__case_1 :: Curry_Prelude.C_Int -> C_Box -> Cover -> ConstStore -> C_Box
d_C__case_1 x1 x2 cd cs = case x2 of
  C_Box x3 x4 x5 -> C_Box x3 x1 x5
  Choice_C_Box d i l r -> narrow d i (d_C__case_1 x1 l cd cs) (d_C__case_1 x1 r
    cd cs)
  Choices_C_Box d i xs -> narrows cs d i (\z -> d_C__case_1 x1 z cd cs) xs
  Guard_C_Box d c e -> guardCons d c ((\x -> d_C__case_1 x1 e cd x) $! addCs c
    cs)
  Fail_C_Box d info -> failCons d (traceFail "Boxes._case_1" [show x1, show x2]
    info)
  _ -> failCons cd (consFail "Boxes._case_1" (showCons x2))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)
d_C__case_0 x1 x5 cd cs = case x5 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x6 x7 -> Curry_Prelude.OP_Cons x5
    (d_OP_chunksOf_dot_partials_dot_156 x1 x5 cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_0 x1 l cd cs)
    (d_C__case_0 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_0 x1 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_0 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Boxes._case_0"
    [show x1, show x5] info)
  _ -> failCons cd (consFail "Boxes._case_0" (showCons x5))

