{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Analysis.Curry_Types
  ( C_Analysis (..)
  , C_AOutFormat (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Types_dot_AOutFormat_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Types_dot_AOutFormat_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_Types_dot_AOutFormat_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash
  , d_C_simpleFuncAnalysis
  , nd_C_simpleFuncAnalysis
  , d_C_simpleTypeAnalysis
  , nd_C_simpleTypeAnalysis
  , d_C_simpleConstructorAnalysis
  , nd_C_simpleConstructorAnalysis
  , d_C_dependencyFuncAnalysis
  , nd_C_dependencyFuncAnalysis
  , d_C_dependencyTypeAnalysis
  , nd_C_dependencyTypeAnalysis
  , d_C_combinedSimpleFuncAnalysis
  , nd_C_combinedSimpleFuncAnalysis
  , d_C_combined2SimpleFuncAnalysis
  , nd_C_combined2SimpleFuncAnalysis
  , d_C_combinedSimpleTypeAnalysis
  , nd_C_combinedSimpleTypeAnalysis
  , d_C_combinedDependencyFuncAnalysis
  , nd_C_combinedDependencyFuncAnalysis
  , d_C_combinedDependencyTypeAnalysis
  , nd_C_combinedDependencyTypeAnalysis
  , d_C_simpleModuleAnalysis
  , nd_C_simpleModuleAnalysis
  , d_C_dependencyModuleAnalysis
  , nd_C_dependencyModuleAnalysis
  , d_C_isSimpleAnalysis
  , nd_C_isSimpleAnalysis
  , d_C_isCombinedAnalysis
  , nd_C_isCombinedAnalysis
  , d_C_isFunctionAnalysis
  , nd_C_isFunctionAnalysis
  , d_C_isTypeAnalysis
  , nd_C_isTypeAnalysis
  , d_C_analysisName
  , nd_C_analysisName
  , d_C_baseAnalysisNames
  , nd_C_baseAnalysisNames
  , d_C_startValue
  , nd_C_startValue )
  where

import Basics
import qualified Analysis.Curry_Files
import qualified Analysis.Curry_Logging
import qualified Analysis.Curry_ProgInfo
import qualified FlatCurry.Curry_Types
import qualified Curry_Prelude
import qualified RW.Curry_Base


data C_Analysis t0
  = C_SimpleFuncAnalysis (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (FlatCurry.Curry_Types.C_FuncDecl -> Cover -> ConstStore -> t0)
  | HO_C_SimpleFuncAnalysis (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func
    FlatCurry.Curry_Types.C_FuncDecl t0)
  | C_SimpleTypeAnalysis (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (FlatCurry.Curry_Types.C_TypeDecl -> Cover -> ConstStore -> t0)
  | HO_C_SimpleTypeAnalysis (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func
    FlatCurry.Curry_Types.C_TypeDecl t0)
  | C_SimpleConstructorAnalysis (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (FlatCurry.Curry_Types.C_ConsDecl -> Cover -> ConstStore
    -> FlatCurry.Curry_Types.C_TypeDecl -> Cover -> ConstStore -> t0)
  | HO_C_SimpleConstructorAnalysis (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Func FlatCurry.Curry_Types.C_ConsDecl (Func
    FlatCurry.Curry_Types.C_TypeDecl t0))
  | C_DependencyFuncAnalysis (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0
    (FlatCurry.Curry_Types.C_FuncDecl -> Cover -> ConstStore
    -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char)) t0) -> Cover -> ConstStore -> t0)
  | HO_C_DependencyFuncAnalysis (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0
    (Func FlatCurry.Curry_Types.C_FuncDecl (Func (Curry_Prelude.OP_List
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0))
    t0))
  | C_DependencyTypeAnalysis (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0
    (FlatCurry.Curry_Types.C_TypeDecl -> Cover -> ConstStore
    -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char)) t0) -> Cover -> ConstStore -> t0)
  | HO_C_DependencyTypeAnalysis (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0
    (Func FlatCurry.Curry_Types.C_TypeDecl (Func (Curry_Prelude.OP_List
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0))
    t0))
  | C_CombinedSimpleFuncAnalysis (Curry_Prelude.OP_List (Curry_Prelude.OP_List
    Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    Curry_Prelude.C_Bool (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
    -> ConstStore -> Curry_Prelude.C_IO (FlatCurry.Curry_Types.C_FuncDecl
    -> Cover -> ConstStore -> t0))
  | HO_C_CombinedSimpleFuncAnalysis (Curry_Prelude.OP_List
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) Curry_Prelude.C_Bool (Func (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Func
    FlatCurry.Curry_Types.C_FuncDecl t0)))
  | C_CombinedSimpleTypeAnalysis (Curry_Prelude.OP_List (Curry_Prelude.OP_List
    Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    Curry_Prelude.C_Bool (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
    -> ConstStore -> Curry_Prelude.C_IO (FlatCurry.Curry_Types.C_TypeDecl
    -> Cover -> ConstStore -> t0))
  | HO_C_CombinedSimpleTypeAnalysis (Curry_Prelude.OP_List
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) Curry_Prelude.C_Bool (Func (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Func
    FlatCurry.Curry_Types.C_TypeDecl t0)))
  | C_CombinedDependencyFuncAnalysis (Curry_Prelude.OP_List
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) Curry_Prelude.C_Bool t0 (Curry_Prelude.OP_List
    Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
    (FlatCurry.Curry_Types.C_FuncDecl -> Cover -> ConstStore
    -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char)) t0) -> Cover -> ConstStore -> t0))
  | HO_C_CombinedDependencyFuncAnalysis (Curry_Prelude.OP_List
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) Curry_Prelude.C_Bool t0 (Func (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Func
    FlatCurry.Curry_Types.C_FuncDecl (Func (Curry_Prelude.OP_List
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0))
    t0))))
  | C_CombinedDependencyTypeAnalysis (Curry_Prelude.OP_List
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) Curry_Prelude.C_Bool t0 (Curry_Prelude.OP_List
    Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
    (FlatCurry.Curry_Types.C_TypeDecl -> Cover -> ConstStore
    -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char)) t0) -> Cover -> ConstStore -> t0))
  | HO_C_CombinedDependencyTypeAnalysis (Curry_Prelude.OP_List
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) Curry_Prelude.C_Bool t0 (Func (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Func
    FlatCurry.Curry_Types.C_TypeDecl (Func (Curry_Prelude.OP_List
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0))
    t0))))
  | C_SimpleModuleAnalysis (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore -> t0)
  | HO_C_SimpleModuleAnalysis (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func
    FlatCurry.Curry_Types.C_Prog t0)
  | C_DependencyModuleAnalysis (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore
    -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) t0) -> Cover -> ConstStore -> t0)
  | HO_C_DependencyModuleAnalysis (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Func FlatCurry.Curry_Types.C_Prog (Func (Curry_Prelude.OP_List
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0))
    t0))
  | Choice_C_Analysis Cover ID (C_Analysis t0) (C_Analysis t0)
  | Choices_C_Analysis Cover ID [C_Analysis t0]
  | Fail_C_Analysis Cover FailInfo
  | Guard_C_Analysis Cover Constraints (C_Analysis t0)

instance (Curry t0) => Show (C_Analysis t0) where
  showsPrec d (Choice_C_Analysis cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Analysis cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Analysis cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Analysis cd info) = showChar '!'
  showsPrec _ (C_SimpleFuncAnalysis x1 x2) = showString "(SimpleFuncAnalysis" .
    (showChar ' ' . (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (HO_C_SimpleFuncAnalysis x1 x2) = showString
    "(SimpleFuncAnalysis" . (showChar ' ' . (shows x1 . (showChar ' ' . (shows
    x2 . showChar ')'))))
  showsPrec _ (C_SimpleTypeAnalysis x1 x2) = showString "(SimpleTypeAnalysis" .
    (showChar ' ' . (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (HO_C_SimpleTypeAnalysis x1 x2) = showString
    "(SimpleTypeAnalysis" . (showChar ' ' . (shows x1 . (showChar ' ' . (shows
    x2 . showChar ')'))))
  showsPrec _ (C_SimpleConstructorAnalysis x1 x2) = showString
    "(SimpleConstructorAnalysis" . (showChar ' ' . (shows x1 . (showChar ' ' .
    (shows x2 . showChar ')'))))
  showsPrec _ (HO_C_SimpleConstructorAnalysis x1 x2) = showString
    "(SimpleConstructorAnalysis" . (showChar ' ' . (shows x1 . (showChar ' ' .
    (shows x2 . showChar ')'))))
  showsPrec _ (C_DependencyFuncAnalysis x1 x2 x3) = showString
    "(DependencyFuncAnalysis" . (showChar ' ' . (shows x1 . (showChar ' ' .
    (shows x2 . (showChar ' ' . (shows x3 . showChar ')'))))))
  showsPrec _ (HO_C_DependencyFuncAnalysis x1 x2 x3) = showString
    "(DependencyFuncAnalysis" . (showChar ' ' . (shows x1 . (showChar ' ' .
    (shows x2 . (showChar ' ' . (shows x3 . showChar ')'))))))
  showsPrec _ (C_DependencyTypeAnalysis x1 x2 x3) = showString
    "(DependencyTypeAnalysis" . (showChar ' ' . (shows x1 . (showChar ' ' .
    (shows x2 . (showChar ' ' . (shows x3 . showChar ')'))))))
  showsPrec _ (HO_C_DependencyTypeAnalysis x1 x2 x3) = showString
    "(DependencyTypeAnalysis" . (showChar ' ' . (shows x1 . (showChar ' ' .
    (shows x2 . (showChar ' ' . (shows x3 . showChar ')'))))))
  showsPrec _ (C_CombinedSimpleFuncAnalysis x1 x2 x3 x4) = showString
    "(CombinedSimpleFuncAnalysis" . (showChar ' ' . (shows x1 . (showChar ' ' .
    (shows x2 . (showChar ' ' . (shows x3 . (showChar ' ' . (shows x4 . showChar
    ')'))))))))
  showsPrec _ (HO_C_CombinedSimpleFuncAnalysis x1 x2 x3 x4) = showString
    "(CombinedSimpleFuncAnalysis" . (showChar ' ' . (shows x1 . (showChar ' ' .
    (shows x2 . (showChar ' ' . (shows x3 . (showChar ' ' . (shows x4 . showChar
    ')'))))))))
  showsPrec _ (C_CombinedSimpleTypeAnalysis x1 x2 x3 x4) = showString
    "(CombinedSimpleTypeAnalysis" . (showChar ' ' . (shows x1 . (showChar ' ' .
    (shows x2 . (showChar ' ' . (shows x3 . (showChar ' ' . (shows x4 . showChar
    ')'))))))))
  showsPrec _ (HO_C_CombinedSimpleTypeAnalysis x1 x2 x3 x4) = showString
    "(CombinedSimpleTypeAnalysis" . (showChar ' ' . (shows x1 . (showChar ' ' .
    (shows x2 . (showChar ' ' . (shows x3 . (showChar ' ' . (shows x4 . showChar
    ')'))))))))
  showsPrec _ (C_CombinedDependencyFuncAnalysis x1 x2 x3 x4 x5) = showString
    "(CombinedDependencyFuncAnalysis" . (showChar ' ' . (shows x1 . (showChar
    ' ' . (shows x2 . (showChar ' ' . (shows x3 . (showChar ' ' . (shows x4 .
    (showChar ' ' . (shows x5 . showChar ')'))))))))))
  showsPrec _ (HO_C_CombinedDependencyFuncAnalysis x1 x2 x3 x4 x5) = showString
    "(CombinedDependencyFuncAnalysis" . (showChar ' ' . (shows x1 . (showChar
    ' ' . (shows x2 . (showChar ' ' . (shows x3 . (showChar ' ' . (shows x4 .
    (showChar ' ' . (shows x5 . showChar ')'))))))))))
  showsPrec _ (C_CombinedDependencyTypeAnalysis x1 x2 x3 x4 x5) = showString
    "(CombinedDependencyTypeAnalysis" . (showChar ' ' . (shows x1 . (showChar
    ' ' . (shows x2 . (showChar ' ' . (shows x3 . (showChar ' ' . (shows x4 .
    (showChar ' ' . (shows x5 . showChar ')'))))))))))
  showsPrec _ (HO_C_CombinedDependencyTypeAnalysis x1 x2 x3 x4 x5) = showString
    "(CombinedDependencyTypeAnalysis" . (showChar ' ' . (shows x1 . (showChar
    ' ' . (shows x2 . (showChar ' ' . (shows x3 . (showChar ' ' . (shows x4 .
    (showChar ' ' . (shows x5 . showChar ')'))))))))))
  showsPrec _ (C_SimpleModuleAnalysis x1 x2) = showString
    "(SimpleModuleAnalysis" . (showChar ' ' . (shows x1 . (showChar ' ' . (shows
    x2 . showChar ')'))))
  showsPrec _ (HO_C_SimpleModuleAnalysis x1 x2) = showString
    "(SimpleModuleAnalysis" . (showChar ' ' . (shows x1 . (showChar ' ' . (shows
    x2 . showChar ')'))))
  showsPrec _ (C_DependencyModuleAnalysis x1 x2) = showString
    "(DependencyModuleAnalysis" . (showChar ' ' . (shows x1 . (showChar ' ' .
    (shows x2 . showChar ')'))))
  showsPrec _ (HO_C_DependencyModuleAnalysis x1 x2) = showString
    "(DependencyModuleAnalysis" . (showChar ' ' . (shows x1 . (showChar ' ' .
    (shows x2 . showChar ')'))))

instance (Curry t0) => Read (C_Analysis t0) where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_SimpleFuncAnalysis x1 x2
    , r2) | (_, r0) <- readQualified "Analysis.Types" "SimpleFuncAnalysis" r,
    (x1, r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ (readParen
    ((>) d 10) (\r -> [(C_SimpleTypeAnalysis x1 x2, r2) | (_, r0) <-
    readQualified "Analysis.Types" "SimpleTypeAnalysis" r, (x1, r1) <- readsPrec
    11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ (readParen ((>) d 10) (\r ->
    [(C_SimpleConstructorAnalysis x1 x2, r2) | (_, r0) <- readQualified
    "Analysis.Types" "SimpleConstructorAnalysis" r, (x1, r1) <- readsPrec 11 r0,
    (x2, r2) <- readsPrec 11 r1]) s ++ (readParen ((>) d 10) (\r ->
    [(C_DependencyFuncAnalysis x1 x2 x3, r3) | (_, r0) <- readQualified
    "Analysis.Types" "DependencyFuncAnalysis" r, (x1, r1) <- readsPrec 11 r0,
    (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2]) s ++ (readParen
    ((>) d 10) (\r -> [(C_DependencyTypeAnalysis x1 x2 x3, r3) | (_, r0) <-
    readQualified "Analysis.Types" "DependencyTypeAnalysis" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2])
    s ++ (readParen ((>) d 10) (\r -> [(C_CombinedSimpleFuncAnalysis x1 x2 x3 x4
    , r4) | (_, r0) <- readQualified "Analysis.Types"
    "CombinedSimpleFuncAnalysis" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <-
    readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2, (x4, r4) <- readsPrec 11 r3])
    s ++ (readParen ((>) d 10) (\r -> [(C_CombinedSimpleTypeAnalysis x1 x2 x3 x4
    , r4) | (_, r0) <- readQualified "Analysis.Types"
    "CombinedSimpleTypeAnalysis" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <-
    readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2, (x4, r4) <- readsPrec 11 r3])
    s ++ (readParen ((>) d 10) (\r -> [(C_CombinedDependencyFuncAnalysis x1 x2
    x3 x4 x5, r5) | (_, r0) <- readQualified "Analysis.Types"
    "CombinedDependencyFuncAnalysis" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <-
    readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2, (x4, r4) <- readsPrec 11 r3,
    (x5, r5) <- readsPrec 11 r4]) s ++ (readParen ((>) d 10) (\r ->
    [(C_CombinedDependencyTypeAnalysis x1 x2 x3 x4 x5, r5) | (_, r0) <-
    readQualified "Analysis.Types" "CombinedDependencyTypeAnalysis" r, (x1, r1)
    <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11
    r2, (x4, r4) <- readsPrec 11 r3, (x5, r5) <- readsPrec 11 r4]) s ++
    (readParen ((>) d 10) (\r -> [(C_SimpleModuleAnalysis x1 x2, r2) | (_, r0)
    <- readQualified "Analysis.Types" "SimpleModuleAnalysis" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ readParen ((>) d 10)
    (\r -> [(C_DependencyModuleAnalysis x1 x2, r2) | (_, r0) <- readQualified
    "Analysis.Types" "DependencyModuleAnalysis" r, (x1, r1) <- readsPrec 11 r0,
    (x2, r2) <- readsPrec 11 r1]) s)))))))))

instance NonDet (C_Analysis t0) where
  choiceCons = Choice_C_Analysis
  choicesCons = Choices_C_Analysis
  failCons = Fail_C_Analysis
  guardCons = Guard_C_Analysis
  try (Choice_C_Analysis cd i x y) = tryChoice cd i x y
  try (Choices_C_Analysis cd i xs) = tryChoices cd i xs
  try (Fail_C_Analysis cd info) = Fail cd info
  try (Guard_C_Analysis cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Analysis cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Analysis cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Analysis cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Analysis cd i _) = error
    ("Analysis.Types.Analysis.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Analysis cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Analysis cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance (Curry t0) => Generable (C_Analysis t0) where
  generate s c = Choices_C_Analysis c (freeID [2, 2, 2, 3, 3, 4, 4, 5, 5, 2, 2]
    s) [HO_C_SimpleFuncAnalysis (generate (leftSupply s) c) (generate
    (rightSupply s) c), HO_C_SimpleTypeAnalysis (generate (leftSupply s) c)
    (generate (rightSupply s) c), HO_C_SimpleConstructorAnalysis (generate
    (leftSupply s) c) (generate (rightSupply s) c), HO_C_DependencyFuncAnalysis
    (generate (leftSupply (leftSupply s)) c) (generate (rightSupply (leftSupply
    s)) c) (generate (rightSupply s) c), HO_C_DependencyTypeAnalysis (generate
    (leftSupply (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c)
    (generate (rightSupply s) c), HO_C_CombinedSimpleFuncAnalysis (generate
    (leftSupply (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c)
    (generate (leftSupply (rightSupply s)) c) (generate (rightSupply
    (rightSupply s)) c), HO_C_CombinedSimpleTypeAnalysis (generate (leftSupply
    (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c) (generate
    (leftSupply (rightSupply s)) c) (generate (rightSupply (rightSupply s)) c)
    , HO_C_CombinedDependencyFuncAnalysis (generate (leftSupply (leftSupply
    (leftSupply s))) c) (generate (rightSupply (leftSupply (leftSupply s))) c)
    (generate (rightSupply (leftSupply s)) c) (generate (leftSupply (rightSupply
    s)) c) (generate (rightSupply (rightSupply s)) c)
    , HO_C_CombinedDependencyTypeAnalysis (generate (leftSupply (leftSupply
    (leftSupply s))) c) (generate (rightSupply (leftSupply (leftSupply s))) c)
    (generate (rightSupply (leftSupply s)) c) (generate (leftSupply (rightSupply
    s)) c) (generate (rightSupply (rightSupply s)) c), HO_C_SimpleModuleAnalysis
    (generate (leftSupply s) c) (generate (rightSupply s) c)
    , HO_C_DependencyModuleAnalysis (generate (leftSupply s) c) (generate
    (rightSupply s) c)]

instance (Curry t0) => NormalForm (C_Analysis t0) where
  ($!!) cont (C_SimpleFuncAnalysis x1 x2) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> cont (C_SimpleFuncAnalysis y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (HO_C_SimpleFuncAnalysis x1 x2) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> cont (HO_C_SimpleFuncAnalysis y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_SimpleTypeAnalysis x1 x2) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> cont (C_SimpleTypeAnalysis y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (HO_C_SimpleTypeAnalysis x1 x2) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> cont (HO_C_SimpleTypeAnalysis y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_SimpleConstructorAnalysis x1 x2) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> cont (C_SimpleConstructorAnalysis y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (HO_C_SimpleConstructorAnalysis x1 x2) d cs = ($!!) (\y1 d cs ->
    ($!!) (\y2 d cs -> cont (HO_C_SimpleConstructorAnalysis y1 y2) d cs) x2 d
    cs) x1 d cs
  ($!!) cont (C_DependencyFuncAnalysis x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> ($!!) (\y3 d cs -> cont (C_DependencyFuncAnalysis y1 y2 y3) d
    cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (HO_C_DependencyFuncAnalysis x1 x2 x3) d cs = ($!!) (\y1 d cs ->
    ($!!) (\y2 d cs -> ($!!) (\y3 d cs -> cont (HO_C_DependencyFuncAnalysis y1
    y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (C_DependencyTypeAnalysis x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> ($!!) (\y3 d cs -> cont (C_DependencyTypeAnalysis y1 y2 y3) d
    cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (HO_C_DependencyTypeAnalysis x1 x2 x3) d cs = ($!!) (\y1 d cs ->
    ($!!) (\y2 d cs -> ($!!) (\y3 d cs -> cont (HO_C_DependencyTypeAnalysis y1
    y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (C_CombinedSimpleFuncAnalysis x1 x2 x3 x4) d cs = ($!!)
    (\y1 d cs -> ($!!) (\y2 d cs -> ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> cont
    (C_CombinedSimpleFuncAnalysis y1 y2 y3 y4) d cs) x4 d cs) x3 d cs) x2 d cs)
    x1 d cs
  ($!!) cont (HO_C_CombinedSimpleFuncAnalysis x1 x2 x3 x4) d cs = ($!!)
    (\y1 d cs -> ($!!) (\y2 d cs -> ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> cont
    (HO_C_CombinedSimpleFuncAnalysis y1 y2 y3 y4) d cs) x4 d cs) x3 d cs) x2 d
    cs) x1 d cs
  ($!!) cont (C_CombinedSimpleTypeAnalysis x1 x2 x3 x4) d cs = ($!!)
    (\y1 d cs -> ($!!) (\y2 d cs -> ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> cont
    (C_CombinedSimpleTypeAnalysis y1 y2 y3 y4) d cs) x4 d cs) x3 d cs) x2 d cs)
    x1 d cs
  ($!!) cont (HO_C_CombinedSimpleTypeAnalysis x1 x2 x3 x4) d cs = ($!!)
    (\y1 d cs -> ($!!) (\y2 d cs -> ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> cont
    (HO_C_CombinedSimpleTypeAnalysis y1 y2 y3 y4) d cs) x4 d cs) x3 d cs) x2 d
    cs) x1 d cs
  ($!!) cont (C_CombinedDependencyFuncAnalysis x1 x2 x3 x4 x5) d cs = ($!!)
    (\y1 d cs -> ($!!) (\y2 d cs -> ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> ($!!)
    (\y5 d cs -> cont (C_CombinedDependencyFuncAnalysis y1 y2 y3 y4 y5) d cs) x5
    d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (HO_C_CombinedDependencyFuncAnalysis x1 x2 x3 x4 x5) d cs = ($!!)
    (\y1 d cs -> ($!!) (\y2 d cs -> ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> ($!!)
    (\y5 d cs -> cont (HO_C_CombinedDependencyFuncAnalysis y1 y2 y3 y4 y5) d cs)
    x5 d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (C_CombinedDependencyTypeAnalysis x1 x2 x3 x4 x5) d cs = ($!!)
    (\y1 d cs -> ($!!) (\y2 d cs -> ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> ($!!)
    (\y5 d cs -> cont (C_CombinedDependencyTypeAnalysis y1 y2 y3 y4 y5) d cs) x5
    d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (HO_C_CombinedDependencyTypeAnalysis x1 x2 x3 x4 x5) d cs = ($!!)
    (\y1 d cs -> ($!!) (\y2 d cs -> ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> ($!!)
    (\y5 d cs -> cont (HO_C_CombinedDependencyTypeAnalysis y1 y2 y3 y4 y5) d cs)
    x5 d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (C_SimpleModuleAnalysis x1 x2) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> cont (C_SimpleModuleAnalysis y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (HO_C_SimpleModuleAnalysis x1 x2) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> cont (HO_C_SimpleModuleAnalysis y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_DependencyModuleAnalysis x1 x2) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> cont (C_DependencyModuleAnalysis y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (HO_C_DependencyModuleAnalysis x1 x2) d cs = ($!!) (\y1 d cs ->
    ($!!) (\y2 d cs -> cont (HO_C_DependencyModuleAnalysis y1 y2) d cs) x2 d cs)
    x1 d cs
  ($!!) cont (Choice_C_Analysis cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Analysis cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Analysis cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_Analysis cd info) _ _ = failCons cd info
  ($##) cont (C_SimpleFuncAnalysis x1 x2) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> cont (C_SimpleFuncAnalysis y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (HO_C_SimpleFuncAnalysis x1 x2) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> cont (HO_C_SimpleFuncAnalysis y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_SimpleTypeAnalysis x1 x2) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> cont (C_SimpleTypeAnalysis y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (HO_C_SimpleTypeAnalysis x1 x2) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> cont (HO_C_SimpleTypeAnalysis y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_SimpleConstructorAnalysis x1 x2) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> cont (C_SimpleConstructorAnalysis y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (HO_C_SimpleConstructorAnalysis x1 x2) d cs = ($##) (\y1 d cs ->
    ($##) (\y2 d cs -> cont (HO_C_SimpleConstructorAnalysis y1 y2) d cs) x2 d
    cs) x1 d cs
  ($##) cont (C_DependencyFuncAnalysis x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> ($##) (\y3 d cs -> cont (C_DependencyFuncAnalysis y1 y2 y3) d
    cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (HO_C_DependencyFuncAnalysis x1 x2 x3) d cs = ($##) (\y1 d cs ->
    ($##) (\y2 d cs -> ($##) (\y3 d cs -> cont (HO_C_DependencyFuncAnalysis y1
    y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (C_DependencyTypeAnalysis x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> ($##) (\y3 d cs -> cont (C_DependencyTypeAnalysis y1 y2 y3) d
    cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (HO_C_DependencyTypeAnalysis x1 x2 x3) d cs = ($##) (\y1 d cs ->
    ($##) (\y2 d cs -> ($##) (\y3 d cs -> cont (HO_C_DependencyTypeAnalysis y1
    y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (C_CombinedSimpleFuncAnalysis x1 x2 x3 x4) d cs = ($##)
    (\y1 d cs -> ($##) (\y2 d cs -> ($##) (\y3 d cs -> ($##) (\y4 d cs -> cont
    (C_CombinedSimpleFuncAnalysis y1 y2 y3 y4) d cs) x4 d cs) x3 d cs) x2 d cs)
    x1 d cs
  ($##) cont (HO_C_CombinedSimpleFuncAnalysis x1 x2 x3 x4) d cs = ($##)
    (\y1 d cs -> ($##) (\y2 d cs -> ($##) (\y3 d cs -> ($##) (\y4 d cs -> cont
    (HO_C_CombinedSimpleFuncAnalysis y1 y2 y3 y4) d cs) x4 d cs) x3 d cs) x2 d
    cs) x1 d cs
  ($##) cont (C_CombinedSimpleTypeAnalysis x1 x2 x3 x4) d cs = ($##)
    (\y1 d cs -> ($##) (\y2 d cs -> ($##) (\y3 d cs -> ($##) (\y4 d cs -> cont
    (C_CombinedSimpleTypeAnalysis y1 y2 y3 y4) d cs) x4 d cs) x3 d cs) x2 d cs)
    x1 d cs
  ($##) cont (HO_C_CombinedSimpleTypeAnalysis x1 x2 x3 x4) d cs = ($##)
    (\y1 d cs -> ($##) (\y2 d cs -> ($##) (\y3 d cs -> ($##) (\y4 d cs -> cont
    (HO_C_CombinedSimpleTypeAnalysis y1 y2 y3 y4) d cs) x4 d cs) x3 d cs) x2 d
    cs) x1 d cs
  ($##) cont (C_CombinedDependencyFuncAnalysis x1 x2 x3 x4 x5) d cs = ($##)
    (\y1 d cs -> ($##) (\y2 d cs -> ($##) (\y3 d cs -> ($##) (\y4 d cs -> ($##)
    (\y5 d cs -> cont (C_CombinedDependencyFuncAnalysis y1 y2 y3 y4 y5) d cs) x5
    d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (HO_C_CombinedDependencyFuncAnalysis x1 x2 x3 x4 x5) d cs = ($##)
    (\y1 d cs -> ($##) (\y2 d cs -> ($##) (\y3 d cs -> ($##) (\y4 d cs -> ($##)
    (\y5 d cs -> cont (HO_C_CombinedDependencyFuncAnalysis y1 y2 y3 y4 y5) d cs)
    x5 d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (C_CombinedDependencyTypeAnalysis x1 x2 x3 x4 x5) d cs = ($##)
    (\y1 d cs -> ($##) (\y2 d cs -> ($##) (\y3 d cs -> ($##) (\y4 d cs -> ($##)
    (\y5 d cs -> cont (C_CombinedDependencyTypeAnalysis y1 y2 y3 y4 y5) d cs) x5
    d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (HO_C_CombinedDependencyTypeAnalysis x1 x2 x3 x4 x5) d cs = ($##)
    (\y1 d cs -> ($##) (\y2 d cs -> ($##) (\y3 d cs -> ($##) (\y4 d cs -> ($##)
    (\y5 d cs -> cont (HO_C_CombinedDependencyTypeAnalysis y1 y2 y3 y4 y5) d cs)
    x5 d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (C_SimpleModuleAnalysis x1 x2) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> cont (C_SimpleModuleAnalysis y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (HO_C_SimpleModuleAnalysis x1 x2) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> cont (HO_C_SimpleModuleAnalysis y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_DependencyModuleAnalysis x1 x2) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> cont (C_DependencyModuleAnalysis y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (HO_C_DependencyModuleAnalysis x1 x2) d cs = ($##) (\y1 d cs ->
    ($##) (\y2 d cs -> cont (HO_C_DependencyModuleAnalysis y1 y2) d cs) x2 d cs)
    x1 d cs
  ($##) cont (Choice_C_Analysis cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Analysis cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Analysis cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_Analysis cd info) _ _ = failCons cd info
  showCons (C_SimpleFuncAnalysis _ _) = "Analysis.Types.SimpleFuncAnalysis _ _"
  showCons (HO_C_SimpleFuncAnalysis _ _) =
    "Analysis.Types.SimpleFuncAnalysis _ _"
  showCons (C_SimpleTypeAnalysis _ _) = "Analysis.Types.SimpleTypeAnalysis _ _"
  showCons (HO_C_SimpleTypeAnalysis _ _) =
    "Analysis.Types.SimpleTypeAnalysis _ _"
  showCons (C_SimpleConstructorAnalysis _ _) =
    "Analysis.Types.SimpleConstructorAnalysis _ _"
  showCons (HO_C_SimpleConstructorAnalysis _ _) =
    "Analysis.Types.SimpleConstructorAnalysis _ _"
  showCons (C_DependencyFuncAnalysis _ _ _) =
    "Analysis.Types.DependencyFuncAnalysis _ _ _"
  showCons (HO_C_DependencyFuncAnalysis _ _ _) =
    "Analysis.Types.DependencyFuncAnalysis _ _ _"
  showCons (C_DependencyTypeAnalysis _ _ _) =
    "Analysis.Types.DependencyTypeAnalysis _ _ _"
  showCons (HO_C_DependencyTypeAnalysis _ _ _) =
    "Analysis.Types.DependencyTypeAnalysis _ _ _"
  showCons (C_CombinedSimpleFuncAnalysis _ _ _ _) =
    "Analysis.Types.CombinedSimpleFuncAnalysis _ _ _ _"
  showCons (HO_C_CombinedSimpleFuncAnalysis _ _ _ _) =
    "Analysis.Types.CombinedSimpleFuncAnalysis _ _ _ _"
  showCons (C_CombinedSimpleTypeAnalysis _ _ _ _) =
    "Analysis.Types.CombinedSimpleTypeAnalysis _ _ _ _"
  showCons (HO_C_CombinedSimpleTypeAnalysis _ _ _ _) =
    "Analysis.Types.CombinedSimpleTypeAnalysis _ _ _ _"
  showCons (C_CombinedDependencyFuncAnalysis _ _ _ _ _) =
    "Analysis.Types.CombinedDependencyFuncAnalysis _ _ _ _ _"
  showCons (HO_C_CombinedDependencyFuncAnalysis _ _ _ _ _) =
    "Analysis.Types.CombinedDependencyFuncAnalysis _ _ _ _ _"
  showCons (C_CombinedDependencyTypeAnalysis _ _ _ _ _) =
    "Analysis.Types.CombinedDependencyTypeAnalysis _ _ _ _ _"
  showCons (HO_C_CombinedDependencyTypeAnalysis _ _ _ _ _) =
    "Analysis.Types.CombinedDependencyTypeAnalysis _ _ _ _ _"
  showCons (C_SimpleModuleAnalysis _ _) =
    "Analysis.Types.SimpleModuleAnalysis _ _"
  showCons (HO_C_SimpleModuleAnalysis _ _) =
    "Analysis.Types.SimpleModuleAnalysis _ _"
  showCons (C_DependencyModuleAnalysis _ _) =
    "Analysis.Types.DependencyModuleAnalysis _ _"
  showCons (HO_C_DependencyModuleAnalysis _ _) =
    "Analysis.Types.DependencyModuleAnalysis _ _"
  showCons x = error ("Analysis.Types.Analysis.showCons: no constructor: " ++
    show x)
  searchNF search cont (C_SimpleFuncAnalysis x1 x2) = search (\y1 -> search
    (\y2 -> cont (C_SimpleFuncAnalysis y1 y2)) x2) x1
  searchNF search cont (HO_C_SimpleFuncAnalysis x1 x2) = search (\y1 -> search
    (\y2 -> cont (HO_C_SimpleFuncAnalysis y1 y2)) x2) x1
  searchNF search cont (C_SimpleTypeAnalysis x1 x2) = search (\y1 -> search
    (\y2 -> cont (C_SimpleTypeAnalysis y1 y2)) x2) x1
  searchNF search cont (HO_C_SimpleTypeAnalysis x1 x2) = search (\y1 -> search
    (\y2 -> cont (HO_C_SimpleTypeAnalysis y1 y2)) x2) x1
  searchNF search cont (C_SimpleConstructorAnalysis x1 x2) = search (\y1 ->
    search (\y2 -> cont (C_SimpleConstructorAnalysis y1 y2)) x2) x1
  searchNF search cont (HO_C_SimpleConstructorAnalysis x1 x2) = search (\y1 ->
    search (\y2 -> cont (HO_C_SimpleConstructorAnalysis y1 y2)) x2) x1
  searchNF search cont (C_DependencyFuncAnalysis x1 x2 x3) = search (\y1 ->
    search (\y2 -> search (\y3 -> cont (C_DependencyFuncAnalysis y1 y2 y3)) x3)
    x2) x1
  searchNF search cont (HO_C_DependencyFuncAnalysis x1 x2 x3) = search (\y1 ->
    search (\y2 -> search (\y3 -> cont (HO_C_DependencyFuncAnalysis y1 y2 y3))
    x3) x2) x1
  searchNF search cont (C_DependencyTypeAnalysis x1 x2 x3) = search (\y1 ->
    search (\y2 -> search (\y3 -> cont (C_DependencyTypeAnalysis y1 y2 y3)) x3)
    x2) x1
  searchNF search cont (HO_C_DependencyTypeAnalysis x1 x2 x3) = search (\y1 ->
    search (\y2 -> search (\y3 -> cont (HO_C_DependencyTypeAnalysis y1 y2 y3))
    x3) x2) x1
  searchNF search cont (C_CombinedSimpleFuncAnalysis x1 x2 x3 x4) = search
    (\y1 -> search (\y2 -> search (\y3 -> search (\y4 -> cont
    (C_CombinedSimpleFuncAnalysis y1 y2 y3 y4)) x4) x3) x2) x1
  searchNF search cont (HO_C_CombinedSimpleFuncAnalysis x1 x2 x3 x4) = search
    (\y1 -> search (\y2 -> search (\y3 -> search (\y4 -> cont
    (HO_C_CombinedSimpleFuncAnalysis y1 y2 y3 y4)) x4) x3) x2) x1
  searchNF search cont (C_CombinedSimpleTypeAnalysis x1 x2 x3 x4) = search
    (\y1 -> search (\y2 -> search (\y3 -> search (\y4 -> cont
    (C_CombinedSimpleTypeAnalysis y1 y2 y3 y4)) x4) x3) x2) x1
  searchNF search cont (HO_C_CombinedSimpleTypeAnalysis x1 x2 x3 x4) = search
    (\y1 -> search (\y2 -> search (\y3 -> search (\y4 -> cont
    (HO_C_CombinedSimpleTypeAnalysis y1 y2 y3 y4)) x4) x3) x2) x1
  searchNF search cont (C_CombinedDependencyFuncAnalysis x1 x2 x3 x4 x5) =
    search (\y1 -> search (\y2 -> search (\y3 -> search (\y4 -> search (\y5 ->
    cont (C_CombinedDependencyFuncAnalysis y1 y2 y3 y4 y5)) x5) x4) x3) x2) x1
  searchNF search cont (HO_C_CombinedDependencyFuncAnalysis x1 x2 x3 x4 x5) =
    search (\y1 -> search (\y2 -> search (\y3 -> search (\y4 -> search (\y5 ->
    cont (HO_C_CombinedDependencyFuncAnalysis y1 y2 y3 y4 y5)) x5) x4) x3) x2)
    x1
  searchNF search cont (C_CombinedDependencyTypeAnalysis x1 x2 x3 x4 x5) =
    search (\y1 -> search (\y2 -> search (\y3 -> search (\y4 -> search (\y5 ->
    cont (C_CombinedDependencyTypeAnalysis y1 y2 y3 y4 y5)) x5) x4) x3) x2) x1
  searchNF search cont (HO_C_CombinedDependencyTypeAnalysis x1 x2 x3 x4 x5) =
    search (\y1 -> search (\y2 -> search (\y3 -> search (\y4 -> search (\y5 ->
    cont (HO_C_CombinedDependencyTypeAnalysis y1 y2 y3 y4 y5)) x5) x4) x3) x2)
    x1
  searchNF search cont (C_SimpleModuleAnalysis x1 x2) = search (\y1 -> search
    (\y2 -> cont (C_SimpleModuleAnalysis y1 y2)) x2) x1
  searchNF search cont (HO_C_SimpleModuleAnalysis x1 x2) = search (\y1 -> search
    (\y2 -> cont (HO_C_SimpleModuleAnalysis y1 y2)) x2) x1
  searchNF search cont (C_DependencyModuleAnalysis x1 x2) = search (\y1 ->
    search (\y2 -> cont (C_DependencyModuleAnalysis y1 y2)) x2) x1
  searchNF search cont (HO_C_DependencyModuleAnalysis x1 x2) = search (\y1 ->
    search (\y2 -> cont (HO_C_DependencyModuleAnalysis y1 y2)) x2) x1
  searchNF _ _ x = error
    ("Analysis.Types.Analysis.searchNF: no constructor: " ++ show x)

instance (Curry t0) => Unifiable (C_Analysis t0) where
  (=.=) (C_SimpleFuncAnalysis x1 x2) (C_SimpleFuncAnalysis y1 y2) d cs = (&)
    ((=:=) x1 y1 d cs) ((=:=) x2 y2 d cs) d cs
  (=.=) (HO_C_SimpleFuncAnalysis x1 x2) (HO_C_SimpleFuncAnalysis y1 y2) d cs =
    (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2 d cs) d cs
  (=.=) (C_SimpleTypeAnalysis x1 x2) (C_SimpleTypeAnalysis y1 y2) d cs = (&)
    ((=:=) x1 y1 d cs) ((=:=) x2 y2 d cs) d cs
  (=.=) (HO_C_SimpleTypeAnalysis x1 x2) (HO_C_SimpleTypeAnalysis y1 y2) d cs =
    (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2 d cs) d cs
  (=.=) (C_SimpleConstructorAnalysis x1 x2) (C_SimpleConstructorAnalysis y1 y2) d cs =
    (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2 d cs) d cs
  (=.=) (HO_C_SimpleConstructorAnalysis x1 x2) (HO_C_SimpleConstructorAnalysis y1 y2) d cs =
    (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2 d cs) d cs
  (=.=) (C_DependencyFuncAnalysis x1 x2 x3) (C_DependencyFuncAnalysis y1 y2 y3) d cs =
    (&) ((=:=) x1 y1 d cs) ((&) ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) (HO_C_DependencyFuncAnalysis x1 x2 x3) (HO_C_DependencyFuncAnalysis y1 y2 y3) d cs =
    (&) ((=:=) x1 y1 d cs) ((&) ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) (C_DependencyTypeAnalysis x1 x2 x3) (C_DependencyTypeAnalysis y1 y2 y3) d cs =
    (&) ((=:=) x1 y1 d cs) ((&) ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) (HO_C_DependencyTypeAnalysis x1 x2 x3) (HO_C_DependencyTypeAnalysis y1 y2 y3) d cs =
    (&) ((=:=) x1 y1 d cs) ((&) ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) (C_CombinedSimpleFuncAnalysis x1 x2 x3 x4) (C_CombinedSimpleFuncAnalysis y1 y2 y3 y4) d cs =
    (&) ((=:=) x1 y1 d cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs)
    ((=:=) x4 y4 d cs) d cs) d cs) d cs
  (=.=) (HO_C_CombinedSimpleFuncAnalysis x1 x2 x3 x4) (HO_C_CombinedSimpleFuncAnalysis y1 y2 y3 y4) d cs =
    (&) ((=:=) x1 y1 d cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs)
    ((=:=) x4 y4 d cs) d cs) d cs) d cs
  (=.=) (C_CombinedSimpleTypeAnalysis x1 x2 x3 x4) (C_CombinedSimpleTypeAnalysis y1 y2 y3 y4) d cs =
    (&) ((=:=) x1 y1 d cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs)
    ((=:=) x4 y4 d cs) d cs) d cs) d cs
  (=.=) (HO_C_CombinedSimpleTypeAnalysis x1 x2 x3 x4) (HO_C_CombinedSimpleTypeAnalysis y1 y2 y3 y4) d cs =
    (&) ((=:=) x1 y1 d cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs)
    ((=:=) x4 y4 d cs) d cs) d cs) d cs
  (=.=) (C_CombinedDependencyFuncAnalysis x1 x2 x3 x4 x5) (C_CombinedDependencyFuncAnalysis y1 y2 y3 y4 y5) d cs =
    (&) ((=:=) x1 y1 d cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((&)
    ((=:=) x4 y4 d cs) ((=:=) x5 y5 d cs) d cs) d cs) d cs) d cs
  (=.=) (HO_C_CombinedDependencyFuncAnalysis x1 x2 x3 x4 x5) (HO_C_CombinedDependencyFuncAnalysis y1 y2 y3 y4 y5) d cs =
    (&) ((=:=) x1 y1 d cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((&)
    ((=:=) x4 y4 d cs) ((=:=) x5 y5 d cs) d cs) d cs) d cs) d cs
  (=.=) (C_CombinedDependencyTypeAnalysis x1 x2 x3 x4 x5) (C_CombinedDependencyTypeAnalysis y1 y2 y3 y4 y5) d cs =
    (&) ((=:=) x1 y1 d cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((&)
    ((=:=) x4 y4 d cs) ((=:=) x5 y5 d cs) d cs) d cs) d cs) d cs
  (=.=) (HO_C_CombinedDependencyTypeAnalysis x1 x2 x3 x4 x5) (HO_C_CombinedDependencyTypeAnalysis y1 y2 y3 y4 y5) d cs =
    (&) ((=:=) x1 y1 d cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((&)
    ((=:=) x4 y4 d cs) ((=:=) x5 y5 d cs) d cs) d cs) d cs) d cs
  (=.=) (C_SimpleModuleAnalysis x1 x2) (C_SimpleModuleAnalysis y1 y2) d cs = (&)
    ((=:=) x1 y1 d cs) ((=:=) x2 y2 d cs) d cs
  (=.=) (HO_C_SimpleModuleAnalysis x1 x2) (HO_C_SimpleModuleAnalysis y1 y2) d cs =
    (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2 d cs) d cs
  (=.=) (C_DependencyModuleAnalysis x1 x2) (C_DependencyModuleAnalysis y1 y2) d cs =
    (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2 d cs) d cs
  (=.=) (HO_C_DependencyModuleAnalysis x1 x2) (HO_C_DependencyModuleAnalysis y1 y2) d cs =
    (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2 d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_SimpleFuncAnalysis x1 x2) (C_SimpleFuncAnalysis y1 y2) d cs = (&)
    ((=:<=) x1 y1 d cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) (HO_C_SimpleFuncAnalysis x1 x2) (HO_C_SimpleFuncAnalysis y1 y2) d cs =
    (&) ((=:<=) x1 y1 d cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_SimpleTypeAnalysis x1 x2) (C_SimpleTypeAnalysis y1 y2) d cs = (&)
    ((=:<=) x1 y1 d cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) (HO_C_SimpleTypeAnalysis x1 x2) (HO_C_SimpleTypeAnalysis y1 y2) d cs =
    (&) ((=:<=) x1 y1 d cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_SimpleConstructorAnalysis x1 x2) (C_SimpleConstructorAnalysis y1 y2) d cs =
    (&) ((=:<=) x1 y1 d cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) (HO_C_SimpleConstructorAnalysis x1 x2) (HO_C_SimpleConstructorAnalysis y1 y2) d cs =
    (&) ((=:<=) x1 y1 d cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_DependencyFuncAnalysis x1 x2 x3) (C_DependencyFuncAnalysis y1 y2 y3) d cs =
    (&) ((=:<=) x1 y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d
    cs
  (=.<=) (HO_C_DependencyFuncAnalysis x1 x2 x3) (HO_C_DependencyFuncAnalysis y1 y2 y3) d cs =
    (&) ((=:<=) x1 y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d
    cs
  (=.<=) (C_DependencyTypeAnalysis x1 x2 x3) (C_DependencyTypeAnalysis y1 y2 y3) d cs =
    (&) ((=:<=) x1 y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d
    cs
  (=.<=) (HO_C_DependencyTypeAnalysis x1 x2 x3) (HO_C_DependencyTypeAnalysis y1 y2 y3) d cs =
    (&) ((=:<=) x1 y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d
    cs
  (=.<=) (C_CombinedSimpleFuncAnalysis x1 x2 x3 x4) (C_CombinedSimpleFuncAnalysis y1 y2 y3 y4) d cs =
    (&) ((=:<=) x1 y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs)
    ((=:<=) x4 y4 d cs) d cs) d cs) d cs
  (=.<=) (HO_C_CombinedSimpleFuncAnalysis x1 x2 x3 x4) (HO_C_CombinedSimpleFuncAnalysis y1 y2 y3 y4) d cs =
    (&) ((=:<=) x1 y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs)
    ((=:<=) x4 y4 d cs) d cs) d cs) d cs
  (=.<=) (C_CombinedSimpleTypeAnalysis x1 x2 x3 x4) (C_CombinedSimpleTypeAnalysis y1 y2 y3 y4) d cs =
    (&) ((=:<=) x1 y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs)
    ((=:<=) x4 y4 d cs) d cs) d cs) d cs
  (=.<=) (HO_C_CombinedSimpleTypeAnalysis x1 x2 x3 x4) (HO_C_CombinedSimpleTypeAnalysis y1 y2 y3 y4) d cs =
    (&) ((=:<=) x1 y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs)
    ((=:<=) x4 y4 d cs) d cs) d cs) d cs
  (=.<=) (C_CombinedDependencyFuncAnalysis x1 x2 x3 x4 x5) (C_CombinedDependencyFuncAnalysis y1 y2 y3 y4 y5) d cs =
    (&) ((=:<=) x1 y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs)
    ((&) ((=:<=) x4 y4 d cs) ((=:<=) x5 y5 d cs) d cs) d cs) d cs) d cs
  (=.<=) (HO_C_CombinedDependencyFuncAnalysis x1 x2 x3 x4 x5) (HO_C_CombinedDependencyFuncAnalysis y1 y2 y3 y4 y5) d cs =
    (&) ((=:<=) x1 y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs)
    ((&) ((=:<=) x4 y4 d cs) ((=:<=) x5 y5 d cs) d cs) d cs) d cs) d cs
  (=.<=) (C_CombinedDependencyTypeAnalysis x1 x2 x3 x4 x5) (C_CombinedDependencyTypeAnalysis y1 y2 y3 y4 y5) d cs =
    (&) ((=:<=) x1 y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs)
    ((&) ((=:<=) x4 y4 d cs) ((=:<=) x5 y5 d cs) d cs) d cs) d cs) d cs
  (=.<=) (HO_C_CombinedDependencyTypeAnalysis x1 x2 x3 x4 x5) (HO_C_CombinedDependencyTypeAnalysis y1 y2 y3 y4 y5) d cs =
    (&) ((=:<=) x1 y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs)
    ((&) ((=:<=) x4 y4 d cs) ((=:<=) x5 y5 d cs) d cs) d cs) d cs) d cs
  (=.<=) (C_SimpleModuleAnalysis x1 x2) (C_SimpleModuleAnalysis y1 y2) d cs =
    (&) ((=:<=) x1 y1 d cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) (HO_C_SimpleModuleAnalysis x1 x2) (HO_C_SimpleModuleAnalysis y1 y2) d cs =
    (&) ((=:<=) x1 y1 d cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_DependencyModuleAnalysis x1 x2) (C_DependencyModuleAnalysis y1 y2) d cs =
    (&) ((=:<=) x1 y1 d cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) (HO_C_DependencyModuleAnalysis x1 x2) (HO_C_DependencyModuleAnalysis y1 y2) d cs =
    (&) ((=:<=) x1 y1 d cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_SimpleFuncAnalysis x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd
    (leftID i) x3, bind cd (rightID i) x4]
  bind cd i (HO_C_SimpleFuncAnalysis x3 x4) = (i :=: ChooseN 0 2) : concat [bind
    cd (leftID i) x3, bind cd (rightID i) x4]
  bind cd i (C_SimpleTypeAnalysis x3 x4) = (i :=: ChooseN 1 2) : concat [bind cd
    (leftID i) x3, bind cd (rightID i) x4]
  bind cd i (HO_C_SimpleTypeAnalysis x3 x4) = (i :=: ChooseN 1 2) : concat [bind
    cd (leftID i) x3, bind cd (rightID i) x4]
  bind cd i (C_SimpleConstructorAnalysis x3 x4) = (i :=: ChooseN 2 2) : concat
    [bind cd (leftID i) x3, bind cd (rightID i) x4]
  bind cd i (HO_C_SimpleConstructorAnalysis x3 x4) = (i :=: ChooseN 2 2) :
    concat [bind cd (leftID i) x3, bind cd (rightID i) x4]
  bind cd i (C_DependencyFuncAnalysis x3 x4 x5) = (i :=: ChooseN 3 3) : concat
    [bind cd (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd
    (rightID i) x5]
  bind cd i (HO_C_DependencyFuncAnalysis x3 x4 x5) = (i :=: ChooseN 3 3) :
    concat [bind cd (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4
    , bind cd (rightID i) x5]
  bind cd i (C_DependencyTypeAnalysis x3 x4 x5) = (i :=: ChooseN 4 3) : concat
    [bind cd (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd
    (rightID i) x5]
  bind cd i (HO_C_DependencyTypeAnalysis x3 x4 x5) = (i :=: ChooseN 4 3) :
    concat [bind cd (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4
    , bind cd (rightID i) x5]
  bind cd i (C_CombinedSimpleFuncAnalysis x3 x4 x5 x6) = (i :=: ChooseN 5 4) :
    concat [bind cd (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4
    , bind cd (leftID (rightID i)) x5, bind cd (rightID (rightID i)) x6]
  bind cd i (HO_C_CombinedSimpleFuncAnalysis x3 x4 x5 x6) = (i :=: ChooseN 5
    4) : concat [bind cd (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4
    , bind cd (leftID (rightID i)) x5, bind cd (rightID (rightID i)) x6]
  bind cd i (C_CombinedSimpleTypeAnalysis x3 x4 x5 x6) = (i :=: ChooseN 6 4) :
    concat [bind cd (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4
    , bind cd (leftID (rightID i)) x5, bind cd (rightID (rightID i)) x6]
  bind cd i (HO_C_CombinedSimpleTypeAnalysis x3 x4 x5 x6) = (i :=: ChooseN 6
    4) : concat [bind cd (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4
    , bind cd (leftID (rightID i)) x5, bind cd (rightID (rightID i)) x6]
  bind cd i (C_CombinedDependencyFuncAnalysis x3 x4 x5 x6 x7) = (i :=: ChooseN 7
    5) : concat [bind cd (leftID (leftID (leftID i))) x3, bind cd (rightID
    (leftID (leftID i))) x4, bind cd (rightID (leftID i)) x5, bind cd (leftID
    (rightID i)) x6, bind cd (rightID (rightID i)) x7]
  bind cd i (HO_C_CombinedDependencyFuncAnalysis x3 x4 x5 x6 x7) = (i :=:
    ChooseN 7 5) : concat [bind cd (leftID (leftID (leftID i))) x3, bind cd
    (rightID (leftID (leftID i))) x4, bind cd (rightID (leftID i)) x5, bind cd
    (leftID (rightID i)) x6, bind cd (rightID (rightID i)) x7]
  bind cd i (C_CombinedDependencyTypeAnalysis x3 x4 x5 x6 x7) = (i :=: ChooseN 8
    5) : concat [bind cd (leftID (leftID (leftID i))) x3, bind cd (rightID
    (leftID (leftID i))) x4, bind cd (rightID (leftID i)) x5, bind cd (leftID
    (rightID i)) x6, bind cd (rightID (rightID i)) x7]
  bind cd i (HO_C_CombinedDependencyTypeAnalysis x3 x4 x5 x6 x7) = (i :=:
    ChooseN 8 5) : concat [bind cd (leftID (leftID (leftID i))) x3, bind cd
    (rightID (leftID (leftID i))) x4, bind cd (rightID (leftID i)) x5, bind cd
    (leftID (rightID i)) x6, bind cd (rightID (rightID i)) x7]
  bind cd i (C_SimpleModuleAnalysis x3 x4) = (i :=: ChooseN 9 2) : concat [bind
    cd (leftID i) x3, bind cd (rightID i) x4]
  bind cd i (HO_C_SimpleModuleAnalysis x3 x4) = (i :=: ChooseN 9 2) : concat
    [bind cd (leftID i) x3, bind cd (rightID i) x4]
  bind cd i (C_DependencyModuleAnalysis x3 x4) = (i :=: ChooseN 10 2) : concat
    [bind cd (leftID i) x3, bind cd (rightID i) x4]
  bind cd i (HO_C_DependencyModuleAnalysis x3 x4) = (i :=: ChooseN 10 2) :
    concat [bind cd (leftID i) x3, bind cd (rightID i) x4]
  bind d i (Choice_C_Analysis cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_Analysis cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Analysis cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_Analysis cd i _) = error
    ("Analysis.Types.Analysis.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Analysis cd info) = [Unsolvable info]
  bind d i (Guard_C_Analysis cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_SimpleFuncAnalysis x3 x4) = (i :=: ChooseN 0 2) : [leftID
    i :=: LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind
    cd (rightID i) x4)]
  lazyBind cd i (HO_C_SimpleFuncAnalysis x3 x4) = (i :=: ChooseN 0 2) : [leftID
    i :=: LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind
    cd (rightID i) x4)]
  lazyBind cd i (C_SimpleTypeAnalysis x3 x4) = (i :=: ChooseN 1 2) : [leftID
    i :=: LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind
    cd (rightID i) x4)]
  lazyBind cd i (HO_C_SimpleTypeAnalysis x3 x4) = (i :=: ChooseN 1 2) : [leftID
    i :=: LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind
    cd (rightID i) x4)]
  lazyBind cd i (C_SimpleConstructorAnalysis x3 x4) = (i :=: ChooseN 2 2) :
    [leftID i :=: LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x4)]
  lazyBind cd i (HO_C_SimpleConstructorAnalysis x3 x4) = (i :=: ChooseN 2 2) :
    [leftID i :=: LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x4)]
  lazyBind cd i (C_DependencyFuncAnalysis x3 x4 x5) = (i :=: ChooseN 3 3) :
    [leftID (leftID i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3)
    , rightID (leftID i) :=: LazyBind (lazyBind cd (rightID (leftID i)) x4)
    , rightID i :=: LazyBind (lazyBind cd (rightID i) x5)]
  lazyBind cd i (HO_C_DependencyFuncAnalysis x3 x4 x5) = (i :=: ChooseN 3 3) :
    [leftID (leftID i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3)
    , rightID (leftID i) :=: LazyBind (lazyBind cd (rightID (leftID i)) x4)
    , rightID i :=: LazyBind (lazyBind cd (rightID i) x5)]
  lazyBind cd i (C_DependencyTypeAnalysis x3 x4 x5) = (i :=: ChooseN 4 3) :
    [leftID (leftID i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3)
    , rightID (leftID i) :=: LazyBind (lazyBind cd (rightID (leftID i)) x4)
    , rightID i :=: LazyBind (lazyBind cd (rightID i) x5)]
  lazyBind cd i (HO_C_DependencyTypeAnalysis x3 x4 x5) = (i :=: ChooseN 4 3) :
    [leftID (leftID i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3)
    , rightID (leftID i) :=: LazyBind (lazyBind cd (rightID (leftID i)) x4)
    , rightID i :=: LazyBind (lazyBind cd (rightID i) x5)]
  lazyBind cd i (C_CombinedSimpleFuncAnalysis x3 x4 x5 x6) = (i :=: ChooseN 5
    4) : [leftID (leftID i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3)
    , rightID (leftID i) :=: LazyBind (lazyBind cd (rightID (leftID i)) x4)
    , leftID (rightID i) :=: LazyBind (lazyBind cd (leftID (rightID i)) x5)
    , rightID (rightID i) :=: LazyBind (lazyBind cd (rightID (rightID i)) x6)]
  lazyBind cd i (HO_C_CombinedSimpleFuncAnalysis x3 x4 x5 x6) = (i :=: ChooseN 5
    4) : [leftID (leftID i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3)
    , rightID (leftID i) :=: LazyBind (lazyBind cd (rightID (leftID i)) x4)
    , leftID (rightID i) :=: LazyBind (lazyBind cd (leftID (rightID i)) x5)
    , rightID (rightID i) :=: LazyBind (lazyBind cd (rightID (rightID i)) x6)]
  lazyBind cd i (C_CombinedSimpleTypeAnalysis x3 x4 x5 x6) = (i :=: ChooseN 6
    4) : [leftID (leftID i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3)
    , rightID (leftID i) :=: LazyBind (lazyBind cd (rightID (leftID i)) x4)
    , leftID (rightID i) :=: LazyBind (lazyBind cd (leftID (rightID i)) x5)
    , rightID (rightID i) :=: LazyBind (lazyBind cd (rightID (rightID i)) x6)]
  lazyBind cd i (HO_C_CombinedSimpleTypeAnalysis x3 x4 x5 x6) = (i :=: ChooseN 6
    4) : [leftID (leftID i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3)
    , rightID (leftID i) :=: LazyBind (lazyBind cd (rightID (leftID i)) x4)
    , leftID (rightID i) :=: LazyBind (lazyBind cd (leftID (rightID i)) x5)
    , rightID (rightID i) :=: LazyBind (lazyBind cd (rightID (rightID i)) x6)]
  lazyBind cd i (C_CombinedDependencyFuncAnalysis x3 x4 x5 x6 x7) = (i :=:
    ChooseN 7 5) : [leftID (leftID (leftID i)) :=: LazyBind (lazyBind cd (leftID
    (leftID (leftID i))) x3), rightID (leftID (leftID i)) :=: LazyBind (lazyBind
    cd (rightID (leftID (leftID i))) x4), rightID (leftID i) :=: LazyBind
    (lazyBind cd (rightID (leftID i)) x5), leftID (rightID i) :=: LazyBind
    (lazyBind cd (leftID (rightID i)) x6), rightID (rightID i) :=: LazyBind
    (lazyBind cd (rightID (rightID i)) x7)]
  lazyBind cd i (HO_C_CombinedDependencyFuncAnalysis x3 x4 x5 x6 x7) = (i :=:
    ChooseN 7 5) : [leftID (leftID (leftID i)) :=: LazyBind (lazyBind cd (leftID
    (leftID (leftID i))) x3), rightID (leftID (leftID i)) :=: LazyBind (lazyBind
    cd (rightID (leftID (leftID i))) x4), rightID (leftID i) :=: LazyBind
    (lazyBind cd (rightID (leftID i)) x5), leftID (rightID i) :=: LazyBind
    (lazyBind cd (leftID (rightID i)) x6), rightID (rightID i) :=: LazyBind
    (lazyBind cd (rightID (rightID i)) x7)]
  lazyBind cd i (C_CombinedDependencyTypeAnalysis x3 x4 x5 x6 x7) = (i :=:
    ChooseN 8 5) : [leftID (leftID (leftID i)) :=: LazyBind (lazyBind cd (leftID
    (leftID (leftID i))) x3), rightID (leftID (leftID i)) :=: LazyBind (lazyBind
    cd (rightID (leftID (leftID i))) x4), rightID (leftID i) :=: LazyBind
    (lazyBind cd (rightID (leftID i)) x5), leftID (rightID i) :=: LazyBind
    (lazyBind cd (leftID (rightID i)) x6), rightID (rightID i) :=: LazyBind
    (lazyBind cd (rightID (rightID i)) x7)]
  lazyBind cd i (HO_C_CombinedDependencyTypeAnalysis x3 x4 x5 x6 x7) = (i :=:
    ChooseN 8 5) : [leftID (leftID (leftID i)) :=: LazyBind (lazyBind cd (leftID
    (leftID (leftID i))) x3), rightID (leftID (leftID i)) :=: LazyBind (lazyBind
    cd (rightID (leftID (leftID i))) x4), rightID (leftID i) :=: LazyBind
    (lazyBind cd (rightID (leftID i)) x5), leftID (rightID i) :=: LazyBind
    (lazyBind cd (leftID (rightID i)) x6), rightID (rightID i) :=: LazyBind
    (lazyBind cd (rightID (rightID i)) x7)]
  lazyBind cd i (C_SimpleModuleAnalysis x3 x4) = (i :=: ChooseN 9 2) : [leftID
    i :=: LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind
    cd (rightID i) x4)]
  lazyBind cd i (HO_C_SimpleModuleAnalysis x3 x4) = (i :=: ChooseN 9 2) :
    [leftID i :=: LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x4)]
  lazyBind cd i (C_DependencyModuleAnalysis x3 x4) = (i :=: ChooseN 10 2) :
    [leftID i :=: LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x4)]
  lazyBind cd i (HO_C_DependencyModuleAnalysis x3 x4) = (i :=: ChooseN 10 2) :
    [leftID i :=: LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x4)]
  lazyBind d i (Choice_C_Analysis cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Analysis cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_Analysis cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Analysis cd i _) = error
    ("Analysis.Types.Analysis.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Analysis cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Analysis cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance (Curry t0) => Curry (C_Analysis t0) where

data C_AOutFormat
  = C_AText
  | C_ANote
  | Choice_C_AOutFormat Cover ID C_AOutFormat C_AOutFormat
  | Choices_C_AOutFormat Cover ID [C_AOutFormat]
  | Fail_C_AOutFormat Cover FailInfo
  | Guard_C_AOutFormat Cover Constraints C_AOutFormat

instance Show C_AOutFormat where
  showsPrec d (Choice_C_AOutFormat cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_AOutFormat cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_AOutFormat cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_AOutFormat cd info) = showChar '!'
  showsPrec _ C_AText = showString "AText"
  showsPrec _ C_ANote = showString "ANote"

instance Read C_AOutFormat where
  readsPrec _ s = readParen False (\r -> [(C_AText, r0) | (_, r0) <-
    readQualified "Analysis.Types" "AText" r]) s ++ readParen False (\r ->
    [(C_ANote, r0) | (_, r0) <- readQualified "Analysis.Types" "ANote" r]) s

instance NonDet C_AOutFormat where
  choiceCons = Choice_C_AOutFormat
  choicesCons = Choices_C_AOutFormat
  failCons = Fail_C_AOutFormat
  guardCons = Guard_C_AOutFormat
  try (Choice_C_AOutFormat cd i x y) = tryChoice cd i x y
  try (Choices_C_AOutFormat cd i xs) = tryChoices cd i xs
  try (Fail_C_AOutFormat cd info) = Fail cd info
  try (Guard_C_AOutFormat cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_AOutFormat cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_AOutFormat cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_AOutFormat cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_AOutFormat cd i _) = error
    ("Analysis.Types.AOutFormat.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_AOutFormat cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_AOutFormat cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_AOutFormat where
  generate s c = Choices_C_AOutFormat c (freeID [0, 0] s) [C_AText, C_ANote]

instance NormalForm C_AOutFormat where
  ($!!) cont C_AText d cs = cont C_AText d cs
  ($!!) cont C_ANote d cs = cont C_ANote d cs
  ($!!) cont (Choice_C_AOutFormat cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_AOutFormat cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_AOutFormat cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_AOutFormat cd info) _ _ = failCons cd info
  ($##) cont C_AText d cs = cont C_AText d cs
  ($##) cont C_ANote d cs = cont C_ANote d cs
  ($##) cont (Choice_C_AOutFormat cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_AOutFormat cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_AOutFormat cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_AOutFormat cd info) _ _ = failCons cd info
  showCons C_AText = "Analysis.Types.AText"
  showCons C_ANote = "Analysis.Types.ANote"
  showCons x = error ("Analysis.Types.AOutFormat.showCons: no constructor: " ++
    show x)
  searchNF _ cont C_AText = cont C_AText
  searchNF _ cont C_ANote = cont C_ANote
  searchNF _ _ x = error
    ("Analysis.Types.AOutFormat.searchNF: no constructor: " ++ show x)

instance Unifiable C_AOutFormat where
  (=.=) C_AText C_AText d cs = C_True
  (=.=) C_ANote C_ANote d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_AText C_AText d cs = C_True
  (=.<=) C_ANote C_ANote d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_AText = (i :=: ChooseN 0 0) : concat []
  bind cd i C_ANote = (i :=: ChooseN 1 0) : concat []
  bind d i (Choice_C_AOutFormat cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_AOutFormat cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j
    xs
  bind d i (Choices_C_AOutFormat cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_AOutFormat cd i _) = error
    ("Analysis.Types.AOutFormat.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_AOutFormat cd info) = [Unsolvable info]
  bind d i (Guard_C_AOutFormat cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_AText = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_ANote = (i :=: ChooseN 1 0) : []
  lazyBind d i (Choice_C_AOutFormat cd j x y) = [ConstraintChoice cd j (lazyBind
    d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_AOutFormat cd j@(FreeID _ _) xs) = lazyBindOrNarrow d
    i cd j xs
  lazyBind d i (Choices_C_AOutFormat cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_AOutFormat cd i _) = error
    ("Analysis.Types.AOutFormat.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_AOutFormat cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_AOutFormat cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_AOutFormat where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Types_dot_AOutFormat_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_AOutFormat
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Types_dot_AOutFormat_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Types_dot_AOutFormat_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_Types_dot_AOutFormat_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Types_dot_AOutFormat_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Types_dot_AOutFormat_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Types_dot_AOutFormat_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Analysis_dot_Types_dot_AOutFormat_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.Types._inst#Prelude.Data#Analysis.Types.AOutFormat#" [show x1]
    info)
  _ -> failCons cd (consFail
    "Analysis.Types._inst#Prelude.Data#Analysis.Types.AOutFormat#" (showCons
    x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Types_dot_AOutFormat_hash :: C_AOutFormat
  -> C_AOutFormat -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Types_dot_AOutFormat_hash x1 x2 cd cs =
  case x1 of
  C_AText -> d_C__case_9 x2 cd cs
  C_ANote -> d_C__case_8 x2 cd cs
  Choice_C_AOutFormat d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Types_dot_AOutFormat_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Types_dot_AOutFormat_hash
    r x2 cd cs)
  Choices_C_AOutFormat d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Types_dot_AOutFormat_hash
    z x2 cd cs) xs
  Guard_C_AOutFormat d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Analysis_dot_Types_dot_AOutFormat_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_AOutFormat d info -> failCons d (traceFail
    "Analysis.Types._impl#===#Prelude.Data#Analysis.Types.AOutFormat#" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "Analysis.Types._impl#===#Prelude.Data#Analysis.Types.AOutFormat#" (showCons
    x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_Types_dot_AOutFormat_hash :: IDSupply
  -> Cover -> ConstStore -> C_AOutFormat
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Analysis_dot_Types_dot_AOutFormat_hash s cd cs =
  let s0 = s in s0 `seq` choice C_AText C_ANote s0 cd cs

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_AOutFormat
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.Types._inst#Prelude.Eq#Analysis.Types.AOutFormat#" [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Types._inst#Prelude.Eq#Analysis.Types.AOutFormat#" (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_AOutFormat
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Analysis.Types._inst#Prelude.Eq#Analysis.Types.AOutFormat#" [show x1] info)
  _ -> failCons cd (consFail
    "Analysis.Types._inst#Prelude.Eq#Analysis.Types.AOutFormat#" (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash :: C_AOutFormat
  -> C_AOutFormat -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash x1 x2 cd cs =
  case x1 of
  C_AText -> d_C__case_7 x2 cd cs
  C_ANote -> d_C__case_6 x2 cd cs
  Choice_C_AOutFormat d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash
    r x2 cd cs)
  Choices_C_AOutFormat d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash
    z x2 cd cs) xs
  Guard_C_AOutFormat d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_AOutFormat d info -> failCons d (traceFail
    "Analysis.Types._impl#==#Prelude.Eq#Analysis.Types.AOutFormat#" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "Analysis.Types._impl#==#Prelude.Eq#Analysis.Types.AOutFormat#" (showCons
    x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash :: Cover
  -> ConstStore -> C_AOutFormat -> Cover -> ConstStore -> C_AOutFormat -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Analysis_dot_Types_dot_AOutFormat_hash)

d_C_simpleFuncAnalysis :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (FlatCurry.Curry_Types.C_FuncDecl -> Cover -> ConstStore -> t0) -> Cover
  -> ConstStore -> C_Analysis t0
d_C_simpleFuncAnalysis x1 x2 cd cs = C_SimpleFuncAnalysis x1 x2

nd_C_simpleFuncAnalysis :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  FlatCurry.Curry_Types.C_FuncDecl t0 -> IDSupply -> Cover -> ConstStore
  -> C_Analysis t0
nd_C_simpleFuncAnalysis x1 x2 s cd cs = HO_C_SimpleFuncAnalysis x1 x2

d_C_simpleTypeAnalysis :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (FlatCurry.Curry_Types.C_TypeDecl -> Cover -> ConstStore -> t0) -> Cover
  -> ConstStore -> C_Analysis t0
d_C_simpleTypeAnalysis x1 x2 cd cs = C_SimpleTypeAnalysis x1 x2

nd_C_simpleTypeAnalysis :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  FlatCurry.Curry_Types.C_TypeDecl t0 -> IDSupply -> Cover -> ConstStore
  -> C_Analysis t0
nd_C_simpleTypeAnalysis x1 x2 s cd cs = HO_C_SimpleTypeAnalysis x1 x2

d_C_simpleConstructorAnalysis :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (FlatCurry.Curry_Types.C_ConsDecl -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeDecl -> Cover -> ConstStore -> t0) -> Cover
  -> ConstStore -> C_Analysis t0
d_C_simpleConstructorAnalysis x1 x2 cd cs = C_SimpleConstructorAnalysis x1 x2

nd_C_simpleConstructorAnalysis :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  FlatCurry.Curry_Types.C_ConsDecl (Func FlatCurry.Curry_Types.C_TypeDecl t0)
  -> IDSupply -> Cover -> ConstStore -> C_Analysis t0
nd_C_simpleConstructorAnalysis x1 x2 s cd cs = HO_C_SimpleConstructorAnalysis x1
  x2

d_C_dependencyFuncAnalysis :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> t0
  -> (FlatCurry.Curry_Types.C_FuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0) -> Cover -> ConstStore -> t0) -> Cover
  -> ConstStore -> C_Analysis t0
d_C_dependencyFuncAnalysis x1 x2 x3 cd cs = C_DependencyFuncAnalysis x1 x2 x3

nd_C_dependencyFuncAnalysis :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> t0 -> Func
  FlatCurry.Curry_Types.C_FuncDecl (Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0)) t0)
  -> IDSupply -> Cover -> ConstStore -> C_Analysis t0
nd_C_dependencyFuncAnalysis x1 x2 x3 s cd cs = HO_C_DependencyFuncAnalysis x1 x2
  x3

d_C_dependencyTypeAnalysis :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> t0
  -> (FlatCurry.Curry_Types.C_TypeDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0) -> Cover -> ConstStore -> t0) -> Cover
  -> ConstStore -> C_Analysis t0
d_C_dependencyTypeAnalysis x1 x2 x3 cd cs = C_DependencyTypeAnalysis x1 x2 x3

nd_C_dependencyTypeAnalysis :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> t0 -> Func
  FlatCurry.Curry_Types.C_TypeDecl (Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0)) t0)
  -> IDSupply -> Cover -> ConstStore -> C_Analysis t0
nd_C_dependencyTypeAnalysis x1 x2 x3 s cd cs = HO_C_DependencyTypeAnalysis x1 x2
  x3

d_C_combinedSimpleFuncAnalysis :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t1)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Analysis t1
  -> (Analysis.Curry_ProgInfo.C_ProgInfo t1 -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_FuncDecl -> Cover -> ConstStore -> t0) -> Cover
  -> ConstStore -> C_Analysis t0
d_C_combinedSimpleFuncAnalysis x1 x2 x3 x4 x5 cd cs =
  C_CombinedSimpleFuncAnalysis (Curry_Prelude.OP_Cons (d_C_analysisName x4 cd
  cs) Curry_Prelude.OP_List) x3 Curry_Prelude.C_True (d_C_runWithBaseAnalysis x1
  x2 Analysis.Curry_Logging.C_Quiet x4 x5)

nd_C_combinedSimpleFuncAnalysis :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> Func Curry_Prelude.OP_Unit
  (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t1) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_Analysis t1 -> Func
  (Analysis.Curry_ProgInfo.C_ProgInfo t1) (Func FlatCurry.Curry_Types.C_FuncDecl
  t0) -> IDSupply -> Cover -> ConstStore -> C_Analysis t0
nd_C_combinedSimpleFuncAnalysis x1 x2 x3 x4 x5 s cd cs = let s0 = s
  in s0 `seq` HO_C_CombinedSimpleFuncAnalysis (Curry_Prelude.OP_Cons
  (nd_C_analysisName x4 s0 cd cs) Curry_Prelude.OP_List) x3 Curry_Prelude.C_True
  (wrapNX id (nd_C_runWithBaseAnalysis x1 x2 Analysis.Curry_Logging.C_Quiet x4
  x5))

d_C_combined2SimpleFuncAnalysis :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t2)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t2)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t1) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_Analysis t2 -> C_Analysis t1
  -> (Analysis.Curry_ProgInfo.C_ProgInfo t2 -> Cover -> ConstStore
  -> Analysis.Curry_ProgInfo.C_ProgInfo t1 -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_FuncDecl -> Cover -> ConstStore -> t0) -> Cover
  -> ConstStore -> C_Analysis t0
d_C_combined2SimpleFuncAnalysis x1 x2 x3 x4 x5 x6 x7 x8 cd cs =
  C_CombinedSimpleFuncAnalysis (Curry_Prelude.OP_Cons (d_C_analysisName x6 cd
  cs) (Curry_Prelude.OP_Cons (d_C_analysisName x7 cd cs) Curry_Prelude.OP_List))
  x5 Curry_Prelude.C_True (d_C_runWith2BaseAnalyses x1 x2 x3 x4
  Analysis.Curry_Logging.C_Quiet x6 x7 x8)

nd_C_combined2SimpleFuncAnalysis :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t2) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> Func
  Curry_Prelude.OP_Unit (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t2) -> Func
  Curry_Prelude.OP_Unit (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t1)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Analysis t2 -> C_Analysis
  t1 -> Func (Analysis.Curry_ProgInfo.C_ProgInfo t2) (Func
  (Analysis.Curry_ProgInfo.C_ProgInfo t1) (Func FlatCurry.Curry_Types.C_FuncDecl
  t0)) -> IDSupply -> Cover -> ConstStore -> C_Analysis t0
nd_C_combined2SimpleFuncAnalysis x1 x2 x3 x4 x5 x6 x7 x8 s cd cs = let s2 = s
  in s2 `seq` HO_C_CombinedSimpleFuncAnalysis (let s0 = leftSupply s2
                                                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` Curry_Prelude.OP_Cons (nd_C_analysisName x6 s0 cd cs)
  (Curry_Prelude.OP_Cons (nd_C_analysisName x7 s1 cd cs)
  Curry_Prelude.OP_List))) x5 Curry_Prelude.C_True (wrapNX id
  (nd_C_runWith2BaseAnalyses x1 x2 x3 x4 Analysis.Curry_Logging.C_Quiet x6 x7
  x8))

d_C_combinedSimpleTypeAnalysis :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t1)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Analysis t1
  -> (Analysis.Curry_ProgInfo.C_ProgInfo t1 -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeDecl -> Cover -> ConstStore -> t0) -> Cover
  -> ConstStore -> C_Analysis t0
d_C_combinedSimpleTypeAnalysis x1 x2 x3 x4 x5 cd cs =
  C_CombinedSimpleTypeAnalysis (Curry_Prelude.OP_Cons (d_C_analysisName x4 cd
  cs) Curry_Prelude.OP_List) x3 Curry_Prelude.C_True (d_C_runWithBaseAnalysis x1
  x2 Analysis.Curry_Logging.C_Quiet x4 x5)

nd_C_combinedSimpleTypeAnalysis :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> Func Curry_Prelude.OP_Unit
  (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t1) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_Analysis t1 -> Func
  (Analysis.Curry_ProgInfo.C_ProgInfo t1) (Func FlatCurry.Curry_Types.C_TypeDecl
  t0) -> IDSupply -> Cover -> ConstStore -> C_Analysis t0
nd_C_combinedSimpleTypeAnalysis x1 x2 x3 x4 x5 s cd cs = let s0 = s
  in s0 `seq` HO_C_CombinedSimpleTypeAnalysis (Curry_Prelude.OP_Cons
  (nd_C_analysisName x4 s0 cd cs) Curry_Prelude.OP_List) x3 Curry_Prelude.C_True
  (wrapNX id (nd_C_runWithBaseAnalysis x1 x2 Analysis.Curry_Logging.C_Quiet x4
  x5))

d_C_combinedDependencyFuncAnalysis :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Analysis t0 -> t1
  -> (Analysis.Curry_ProgInfo.C_ProgInfo t0 -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_FuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t1) -> Cover -> ConstStore -> t1) -> Cover
  -> ConstStore -> C_Analysis t1
d_C_combinedDependencyFuncAnalysis x1 x2 x3 x4 x5 x6 cd cs =
  C_CombinedDependencyFuncAnalysis (Curry_Prelude.OP_Cons (d_C_analysisName x4
  cd cs) Curry_Prelude.OP_List) x3 Curry_Prelude.C_True x5
  (d_C_runWithBaseAnalysis x1 x2 Analysis.Curry_Logging.C_Quiet x4 x6)

nd_C_combinedDependencyFuncAnalysis :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func Curry_Prelude.OP_Unit
  (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_Analysis t0 -> t1 -> Func
  (Analysis.Curry_ProgInfo.C_ProgInfo t0) (Func FlatCurry.Curry_Types.C_FuncDecl
  (Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t1)) t1)) -> IDSupply -> Cover -> ConstStore
  -> C_Analysis t1
nd_C_combinedDependencyFuncAnalysis x1 x2 x3 x4 x5 x6 s cd cs = let s0 = s
  in s0 `seq` HO_C_CombinedDependencyFuncAnalysis (Curry_Prelude.OP_Cons
  (nd_C_analysisName x4 s0 cd cs) Curry_Prelude.OP_List) x3 Curry_Prelude.C_True
  x5 (wrapNX id (nd_C_runWithBaseAnalysis x1 x2 Analysis.Curry_Logging.C_Quiet
  x4 x6))

d_C_combinedDependencyTypeAnalysis :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Analysis t0 -> t1
  -> (Analysis.Curry_ProgInfo.C_ProgInfo t0 -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t1) -> Cover -> ConstStore -> t1) -> Cover
  -> ConstStore -> C_Analysis t1
d_C_combinedDependencyTypeAnalysis x1 x2 x3 x4 x5 x6 cd cs =
  C_CombinedDependencyTypeAnalysis (Curry_Prelude.OP_Cons (d_C_analysisName x4
  cd cs) Curry_Prelude.OP_List) x3 Curry_Prelude.C_True x5
  (d_C_runWithBaseAnalysis x1 x2 Analysis.Curry_Logging.C_Quiet x4 x6)

nd_C_combinedDependencyTypeAnalysis :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func Curry_Prelude.OP_Unit
  (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_Analysis t0 -> t1 -> Func
  (Analysis.Curry_ProgInfo.C_ProgInfo t0) (Func FlatCurry.Curry_Types.C_TypeDecl
  (Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t1)) t1)) -> IDSupply -> Cover -> ConstStore
  -> C_Analysis t1
nd_C_combinedDependencyTypeAnalysis x1 x2 x3 x4 x5 x6 s cd cs = let s0 = s
  in s0 `seq` HO_C_CombinedDependencyTypeAnalysis (Curry_Prelude.OP_Cons
  (nd_C_analysisName x4 s0 cd cs) Curry_Prelude.OP_List) x3 Curry_Prelude.C_True
  x5 (wrapNX id (nd_C_runWithBaseAnalysis x1 x2 Analysis.Curry_Logging.C_Quiet
  x4 x6))

d_C_simpleModuleAnalysis :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore -> t0) -> Cover
  -> ConstStore -> C_Analysis t0
d_C_simpleModuleAnalysis x1 x2 cd cs = C_SimpleModuleAnalysis x1 x2

nd_C_simpleModuleAnalysis :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  FlatCurry.Curry_Types.C_Prog t0 -> IDSupply -> Cover -> ConstStore
  -> C_Analysis t0
nd_C_simpleModuleAnalysis x1 x2 s cd cs = HO_C_SimpleModuleAnalysis x1 x2

d_C_dependencyModuleAnalysis :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0) -> Cover -> ConstStore -> t0) -> Cover -> ConstStore
  -> C_Analysis t0
d_C_dependencyModuleAnalysis x1 x2 cd cs = C_DependencyModuleAnalysis x1 x2

nd_C_dependencyModuleAnalysis :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  FlatCurry.Curry_Types.C_Prog (Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0)) t0)
  -> IDSupply -> Cover -> ConstStore -> C_Analysis t0
nd_C_dependencyModuleAnalysis x1 x2 s cd cs = HO_C_DependencyModuleAnalysis x1
  x2

d_C_isSimpleAnalysis :: forall t0 . (Curry_Prelude.Curry t0) => C_Analysis t0
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isSimpleAnalysis x1 cd cs = let x2 = Curry_Prelude.C_False
  in d_C__case_5 x2 x1 cd cs

nd_C_isSimpleAnalysis :: forall t0 . (Curry_Prelude.Curry t0) => C_Analysis t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C_isSimpleAnalysis x1 s cd cs = let s0 = s
  in s0 `seq` (let x2 = Curry_Prelude.C_False in nd_C__case_5 x2 x1 s0 cd cs)

d_C_isCombinedAnalysis :: forall t0 . (Curry_Prelude.Curry t0) => C_Analysis t0
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isCombinedAnalysis x1 cd cs = let x2 = Curry_Prelude.C_False
  in d_C__case_4 x2 x1 cd cs

nd_C_isCombinedAnalysis :: forall t0 . (Curry_Prelude.Curry t0) => C_Analysis t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C_isCombinedAnalysis x1 s cd cs = let s0 = s
  in s0 `seq` (let x2 = Curry_Prelude.C_False in nd_C__case_4 x2 x1 s0 cd cs)

d_C_isFunctionAnalysis :: forall t0 . (Curry_Prelude.Curry t0) => C_Analysis t0
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isFunctionAnalysis x1 cd cs = let x2 = Curry_Prelude.C_False
  in d_C__case_3 x2 x1 cd cs

nd_C_isFunctionAnalysis :: forall t0 . (Curry_Prelude.Curry t0) => C_Analysis t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C_isFunctionAnalysis x1 s cd cs = let s0 = s
  in s0 `seq` (let x2 = Curry_Prelude.C_False in nd_C__case_3 x2 x1 s0 cd cs)

d_C_isTypeAnalysis :: forall t0 . (Curry_Prelude.Curry t0) => C_Analysis t0
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isTypeAnalysis x1 cd cs = let x2 = Curry_Prelude.C_False
  in d_C__case_2 x2 x1 cd cs

nd_C_isTypeAnalysis :: forall t0 . (Curry_Prelude.Curry t0) => C_Analysis t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C_isTypeAnalysis x1 s cd cs = let s0 = s
  in s0 `seq` (let x2 = Curry_Prelude.C_False in nd_C__case_2 x2 x1 s0 cd cs)

d_C_analysisName :: forall t0 . (Curry_Prelude.Curry t0) => C_Analysis t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_analysisName x1 cd cs = case x1 of
  C_SimpleFuncAnalysis x2 x3 -> x2
  C_SimpleTypeAnalysis x4 x5 -> x4
  C_SimpleConstructorAnalysis x6 x7 -> x6
  C_DependencyFuncAnalysis x8 x9 x10 -> x8
  C_DependencyTypeAnalysis x11 x12 x13 -> x11
  C_CombinedSimpleFuncAnalysis x14 x15 x16 x17 -> x15
  C_CombinedSimpleTypeAnalysis x18 x19 x20 x21 -> x19
  C_CombinedDependencyFuncAnalysis x22 x23 x24 x25 x26 -> x23
  C_CombinedDependencyTypeAnalysis x27 x28 x29 x30 x31 -> x28
  C_SimpleModuleAnalysis x32 x33 -> x32
  C_DependencyModuleAnalysis x34 x35 -> x34
  Choice_C_Analysis d i l r -> narrow d i (d_C_analysisName l cd cs)
    (d_C_analysisName r cd cs)
  Choices_C_Analysis d i xs -> narrows cs d i (\z -> d_C_analysisName z cd cs)
    xs
  Guard_C_Analysis d c e -> guardCons d c ((\x -> d_C_analysisName e cd x) $!
    addCs c cs)
  Fail_C_Analysis d info -> failCons d (traceFail "Analysis.Types.analysisName"
    [show x1] info)
  _ -> failCons cd (consFail "Analysis.Types.analysisName" (showCons x1))

nd_C_analysisName :: forall t0 . (Curry_Prelude.Curry t0) => C_Analysis t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C_analysisName x1 s cd cs = case x1 of
  HO_C_SimpleFuncAnalysis x2 x3 -> x2
  HO_C_SimpleTypeAnalysis x4 x5 -> x4
  HO_C_SimpleConstructorAnalysis x6 x7 -> x6
  HO_C_DependencyFuncAnalysis x8 x9 x10 -> x8
  HO_C_DependencyTypeAnalysis x11 x12 x13 -> x11
  HO_C_CombinedSimpleFuncAnalysis x14 x15 x16 x17 -> x15
  HO_C_CombinedSimpleTypeAnalysis x18 x19 x20 x21 -> x19
  HO_C_CombinedDependencyFuncAnalysis x22 x23 x24 x25 x26 -> x23
  HO_C_CombinedDependencyTypeAnalysis x27 x28 x29 x30 x31 -> x28
  HO_C_SimpleModuleAnalysis x32 x33 -> x32
  HO_C_DependencyModuleAnalysis x34 x35 -> x34
  Choice_C_Analysis d i l r -> narrow d i (nd_C_analysisName l s cd cs)
    (nd_C_analysisName r s cd cs)
  Choices_C_Analysis d i xs -> narrows cs d i (\z -> nd_C_analysisName z s cd
    cs) xs
  Guard_C_Analysis d c e -> guardCons d c ((\x -> nd_C_analysisName e s cd x) $!
    addCs c cs)
  Fail_C_Analysis d info -> failCons d (traceFail "Analysis.Types.analysisName"
    [show x1] info)
  _ -> failCons cd (consFail "Analysis.Types.analysisName" (showCons x1))

d_C_baseAnalysisNames :: forall t0 . (Curry_Prelude.Curry t0) => C_Analysis t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C_baseAnalysisNames x1 cd cs = let x2 = Curry_Prelude.OP_List
  in d_C__case_1 x2 x1 cd cs

nd_C_baseAnalysisNames :: forall t0 . (Curry_Prelude.Curry t0) => C_Analysis t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C_baseAnalysisNames x1 s cd cs = let s0 = s
  in s0 `seq` (let x2 = Curry_Prelude.OP_List in nd_C__case_1 x2 x1 s0 cd cs)

d_C_startValue :: forall t0 . (Curry_Prelude.Curry t0) => C_Analysis t0 -> Cover
  -> ConstStore -> t0
d_C_startValue x1 cd cs = let x2 = Curry_Prelude.d_C_error
                                (Curry_Prelude.toCurryString
                                "Internal error in Analysis.startValue") cd cs
  in d_C__case_0 x2 x1 cd cs

nd_C_startValue :: forall t0 . (Curry_Prelude.Curry t0) => C_Analysis t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_startValue x1 s cd cs = let s0 = s
  in s0 `seq` (let x2 = Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
                     "Internal error in Analysis.startValue") cd cs
  in nd_C__case_0 x2 x1 s0 cd cs)

d_C_runWithBaseAnalysis :: forall t0 t1 t2 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Analysis.Curry_Logging.C_DLevel -> C_Analysis t0
  -> (Analysis.Curry_ProgInfo.C_ProgInfo t0 -> Cover -> ConstStore -> t2
  -> Cover -> ConstStore -> t1) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (t2 -> Cover -> ConstStore -> t1)
d_C_runWithBaseAnalysis x1 x2 x3 x4 x5 x6 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Analysis.Curry_Files.d_C_getImports x3 x6 cd cs) cd cs)
  (d_OP_runWithBaseAnalysis_dot_uscore_hash_lambda10 x3 x6 x4 x1 x2 x5) cd cs

nd_C_runWithBaseAnalysis :: forall t0 t1 t2 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func
  Curry_Prelude.OP_Unit (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Analysis.Curry_Logging.C_DLevel -> C_Analysis t0 -> Func
  (Analysis.Curry_ProgInfo.C_ProgInfo t0) (Func t2 t1) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Func t2 t1)
nd_C_runWithBaseAnalysis x1 x2 x3 x4 x5 x6 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (Analysis.Curry_Files.d_C_getImports x3 x6 cd cs) s1 cd cs)) (wrapNX
  id (nd_OP_runWithBaseAnalysis_dot_uscore_hash_lambda10 x3 x6 x4 x1 x2 x5)) s3
  cd cs))

d_OP_runWithBaseAnalysis_dot_uscore_hash_lambda10 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1) => Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_Analysis t0 -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> (Analysis.Curry_ProgInfo.C_ProgInfo t0 -> Cover -> ConstStore -> t2
  -> Cover -> ConstStore -> t1) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO (t2
  -> Cover -> ConstStore -> t1)
d_OP_runWithBaseAnalysis_dot_uscore_hash_lambda10 x1 x2 x3 x4 x5 x6 x7 cd cs =
  let x8 = x7
      x9 = d_C_analysisName x3 cd cs
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Analysis.Curry_Files.d_C_getInterfaceInfos x4 x5 x1 x9 x8 cd cs) cd
  cs)
  (d_OP_runWithBaseAnalysis_dot_uscore_hash_lambda10_dot_uscore_hash_lambda12 x1
  x9 x2 x4 x5 x6) cd cs

nd_OP_runWithBaseAnalysis_dot_uscore_hash_lambda10 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1) => Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_Analysis t0 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func Curry_Prelude.OP_Unit
  (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0) -> Func
  (Analysis.Curry_ProgInfo.C_ProgInfo t0) (Func t2 t1) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Func t2 t1)
nd_OP_runWithBaseAnalysis_dot_uscore_hash_lambda10 x1 x2 x3 x4 x5 x6 x7 s cd cs =
  let s8 = s
  in s8 `seq` (let s0 = leftSupply s8
                   s7 = rightSupply s8
  in s0 `seq` (s7 `seq` (let x8 = x7
                             x9 = nd_C_analysisName x3 s0 cd cs
  in let s6 = leftSupply s7
         s4 = rightSupply s7
  in s6 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                      s5 = rightSupply s4
                                                      s1 = leftSupply s5
                                                      s2 = rightSupply s5
  in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s1 cd cs) (Analysis.Curry_Files.nd_C_getInterfaceInfos x4 x5 x1 x9 x8 s2 cd
  cs) s3 cd cs)))) (wrapNX id
  (nd_OP_runWithBaseAnalysis_dot_uscore_hash_lambda10_dot_uscore_hash_lambda12
  x1 x9 x2 x4 x5 x6)) s6 cd cs))))

d_OP_runWithBaseAnalysis_dot_uscore_hash_lambda10_dot_uscore_hash_lambda12 :: forall t0
  t1 t2 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1) => Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> (Analysis.Curry_ProgInfo.C_ProgInfo t0 -> Cover -> ConstStore -> t2
  -> Cover -> ConstStore -> t1) -> Analysis.Curry_ProgInfo.C_ProgInfo t0
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (t2 -> Cover -> ConstStore -> t1)
d_OP_runWithBaseAnalysis_dot_uscore_hash_lambda10_dot_uscore_hash_lambda12 x1 x2 x3 x4 x5 x6 x7 cd cs =
  let x8 = x7
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Analysis.Curry_Files.d_C_loadCompleteAnalysis x4 x5 x1 x2 x3 cd cs) cd
  cs)
  (d_OP_runWithBaseAnalysis_dot_uscore_hash_lambda10_dot_uscore_hash_lambda12_dot_uscore_hash_lambda14
  x8 x6) cd cs

nd_OP_runWithBaseAnalysis_dot_uscore_hash_lambda10_dot_uscore_hash_lambda12 :: forall t0
  t1 t2 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1) => Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func
  Curry_Prelude.OP_Unit (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0) -> Func
  (Analysis.Curry_ProgInfo.C_ProgInfo t0) (Func t2 t1)
  -> Analysis.Curry_ProgInfo.C_ProgInfo t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Func t2 t1)
nd_OP_runWithBaseAnalysis_dot_uscore_hash_lambda10_dot_uscore_hash_lambda12 x1 x2 x3 x4 x5 x6 x7 s cd cs =
  let s6 = s
  in s6 `seq` (let x8 = x7
  in let s5 = leftSupply s6
         s3 = rightSupply s6
  in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                      s4 = rightSupply s3
                                                      s0 = leftSupply s4
                                                      s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (Analysis.Curry_Files.nd_C_loadCompleteAnalysis x4 x5 x1 x2 x3 s1 cd
  cs) s2 cd cs)))) (wrapNX id
  (nd_OP_runWithBaseAnalysis_dot_uscore_hash_lambda10_dot_uscore_hash_lambda12_dot_uscore_hash_lambda14
  x8 x6)) s5 cd cs))

d_OP_runWithBaseAnalysis_dot_uscore_hash_lambda10_dot_uscore_hash_lambda12_dot_uscore_hash_lambda14 :: forall t0
  t1 t2 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1) => Analysis.Curry_ProgInfo.C_ProgInfo t0
  -> (Analysis.Curry_ProgInfo.C_ProgInfo t0 -> Cover -> ConstStore -> t2
  -> Cover -> ConstStore -> t1) -> Analysis.Curry_ProgInfo.C_ProgInfo t0
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (t2 -> Cover -> ConstStore -> t1)
d_OP_runWithBaseAnalysis_dot_uscore_hash_lambda10_dot_uscore_hash_lambda12_dot_uscore_hash_lambda14 x1 x2 x3 cd cs =
  let x4 = x3
      x5 = Analysis.Curry_ProgInfo.d_C_combineProgInfo x1 x4 cd cs
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_apply x2 x5 cd cs) cd cs

nd_OP_runWithBaseAnalysis_dot_uscore_hash_lambda10_dot_uscore_hash_lambda12_dot_uscore_hash_lambda14 :: forall t0
  t1 t2 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1) => Analysis.Curry_ProgInfo.C_ProgInfo t0 -> Func
  (Analysis.Curry_ProgInfo.C_ProgInfo t0) (Func t2 t1)
  -> Analysis.Curry_ProgInfo.C_ProgInfo t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Func t2 t1)
nd_OP_runWithBaseAnalysis_dot_uscore_hash_lambda10_dot_uscore_hash_lambda12_dot_uscore_hash_lambda14 x1 x2 x3 s cd cs =
  let s3 = s
  in s3 `seq` (let x4 = x3
                   x5 = Analysis.Curry_ProgInfo.d_C_combineProgInfo x1 x4 cd cs
  in let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (Curry_Prelude.nd_C_apply x2 x5 s1 cd cs) s2 cd cs))))

d_C_runWith2BaseAnalyses :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t2) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Analysis.Curry_Logging.C_DLevel -> C_Analysis t1 -> C_Analysis t0
  -> (Analysis.Curry_ProgInfo.C_ProgInfo t1 -> Cover -> ConstStore
  -> Analysis.Curry_ProgInfo.C_ProgInfo t0 -> Cover -> ConstStore -> t3 -> Cover
  -> ConstStore -> t2) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (t3 -> Cover -> ConstStore -> t2)
d_C_runWith2BaseAnalyses x1 x2 x3 x4 x5 x6 x7 x8 x9 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Analysis.Curry_Files.d_C_getImports x5 x9 cd cs) cd cs)
  (d_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21 x5 x9 x7 x6 x2 x1 x4 x3
  x8) cd cs

nd_C_runWith2BaseAnalyses :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t2) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> Func Curry_Prelude.OP_Unit (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t1)
  -> Func Curry_Prelude.OP_Unit (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Analysis.Curry_Logging.C_DLevel -> C_Analysis t1 -> C_Analysis t0 -> Func
  (Analysis.Curry_ProgInfo.C_ProgInfo t1) (Func
  (Analysis.Curry_ProgInfo.C_ProgInfo t0) (Func t3 t2)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Func t3 t2)
nd_C_runWith2BaseAnalyses x1 x2 x3 x4 x5 x6 x7 x8 x9 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (Analysis.Curry_Files.d_C_getImports x5 x9 cd cs) s1 cd cs)) (wrapNX
  id (nd_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21 x5 x9 x7 x6 x2 x1 x4
  x3 x8)) s3 cd cs))

d_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21 :: forall t0 t1 t2
  t3 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2) => Analysis.Curry_Logging.C_DLevel
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Analysis t0 -> C_Analysis
  t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t1)
  -> (Analysis.Curry_ProgInfo.C_ProgInfo t1 -> Cover -> ConstStore
  -> Analysis.Curry_ProgInfo.C_ProgInfo t0 -> Cover -> ConstStore -> t3 -> Cover
  -> ConstStore -> t2) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO (t3
  -> Cover -> ConstStore -> t2)
d_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 cd cs =
  let x11 = x10
      x12 = d_C_analysisName x4 cd cs
      x13 = d_C_analysisName x3 cd cs
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Analysis.Curry_Files.d_C_getInterfaceInfos x6 x8 x1 x12 x11 cd cs) cd
  cs)
  (d_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23
  x1 x12 x13 x2 x11 x5 x6 x7 x8 x9) cd cs

nd_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21 :: forall t0 t1 t2
  t3 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2) => Analysis.Curry_Logging.C_DLevel
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Analysis t0 -> C_Analysis
  t1 -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> Func Curry_Prelude.OP_Unit (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Func Curry_Prelude.OP_Unit (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t1)
  -> Func (Analysis.Curry_ProgInfo.C_ProgInfo t1) (Func
  (Analysis.Curry_ProgInfo.C_ProgInfo t0) (Func t3 t2)) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Func t3 t2)
nd_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 s cd cs =
  let s9 = s
  in s9 `seq` (let s0 = leftSupply s9
                   s10 = rightSupply s9
                   s1 = leftSupply s10
                   s8 = rightSupply s10
  in s0 `seq` (s10 `seq` (s1 `seq` (s8 `seq` (let x11 = x10
                                                  x12 = nd_C_analysisName x4 s0
                                                    cd cs
                                                  x13 = nd_C_analysisName x3 s1
                                                    cd cs
  in let s7 = leftSupply s8
         s5 = rightSupply s8
  in s7 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                      s6 = rightSupply s5
                                                      s2 = leftSupply s6
                                                      s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s2 cd cs) (Analysis.Curry_Files.nd_C_getInterfaceInfos x6 x8 x1 x12 x11 s3 cd
  cs) s4 cd cs)))) (wrapNX id
  (nd_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23
  x1 x12 x13 x2 x11 x5 x6 x7 x8 x9)) s7 cd cs))))))

d_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23 :: forall t0
  t1 t2 t3 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t2) => Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t1)
  -> (Analysis.Curry_ProgInfo.C_ProgInfo t1 -> Cover -> ConstStore
  -> Analysis.Curry_ProgInfo.C_ProgInfo t0 -> Cover -> ConstStore -> t3 -> Cover
  -> ConstStore -> t2) -> Analysis.Curry_ProgInfo.C_ProgInfo t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (t3 -> Cover -> ConstStore -> t2)
d_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 cd cs =
  let x12 = x11
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Analysis.Curry_Files.d_C_loadCompleteAnalysis x7 x9 x1 x2 x4 cd cs) cd
  cs)
  (d_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23_dot_uscore_hash_lambda25
  x1 x3 x4 x5 x12 x6 x8 x10) cd cs

nd_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23 :: forall t0
  t1 t2 t3 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t2) => Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> Func Curry_Prelude.OP_Unit
  (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0) -> Func Curry_Prelude.OP_Unit
  (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t1) -> Func
  (Analysis.Curry_ProgInfo.C_ProgInfo t1) (Func
  (Analysis.Curry_ProgInfo.C_ProgInfo t0) (Func t3 t2))
  -> Analysis.Curry_ProgInfo.C_ProgInfo t1 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Func t3 t2)
nd_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 s cd cs =
  let s6 = s
  in s6 `seq` (let x12 = x11
  in let s5 = leftSupply s6
         s3 = rightSupply s6
  in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                      s4 = rightSupply s3
                                                      s0 = leftSupply s4
                                                      s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (Analysis.Curry_Files.nd_C_loadCompleteAnalysis x7 x9 x1 x2 x4 s1 cd
  cs) s2 cd cs)))) (wrapNX id
  (nd_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23_dot_uscore_hash_lambda25
  x1 x3 x4 x5 x12 x6 x8 x10)) s5 cd cs))

d_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23_dot_uscore_hash_lambda25 :: forall t0
  t1 t2 t3 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t2) => Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Analysis.Curry_ProgInfo.C_ProgInfo t1 -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> (Analysis.Curry_ProgInfo.C_ProgInfo t1 -> Cover -> ConstStore
  -> Analysis.Curry_ProgInfo.C_ProgInfo t0 -> Cover -> ConstStore -> t3 -> Cover
  -> ConstStore -> t2) -> Analysis.Curry_ProgInfo.C_ProgInfo t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (t3 -> Cover -> ConstStore -> t2)
d_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23_dot_uscore_hash_lambda25 x1 x2 x3 x4 x5 x6 x7 x8 x9 cd cs =
  let x10 = x9
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Analysis.Curry_Files.d_C_getInterfaceInfos x6 x7 x1 x2 x4 cd cs) cd
  cs)
  (d_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23_dot_uscore_hash_lambda25_dot_uscore_hash_lambda27
  x1 x2 x3 x5 x10 x6 x7 x8) cd cs

nd_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23_dot_uscore_hash_lambda25 :: forall t0
  t1 t2 t3 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t2) => Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Analysis.Curry_ProgInfo.C_ProgInfo t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func Curry_Prelude.OP_Unit
  (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0) -> Func
  (Analysis.Curry_ProgInfo.C_ProgInfo t1) (Func
  (Analysis.Curry_ProgInfo.C_ProgInfo t0) (Func t3 t2))
  -> Analysis.Curry_ProgInfo.C_ProgInfo t1 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Func t3 t2)
nd_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23_dot_uscore_hash_lambda25 x1 x2 x3 x4 x5 x6 x7 x8 x9 s cd cs =
  let s6 = s
  in s6 `seq` (let x10 = x9
  in let s5 = leftSupply s6
         s3 = rightSupply s6
  in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                      s4 = rightSupply s3
                                                      s0 = leftSupply s4
                                                      s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (Analysis.Curry_Files.nd_C_getInterfaceInfos x6 x7 x1 x2 x4 s1 cd
  cs) s2 cd cs)))) (wrapNX id
  (nd_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23_dot_uscore_hash_lambda25_dot_uscore_hash_lambda27
  x1 x2 x3 x5 x10 x6 x7 x8)) s5 cd cs))

d_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23_dot_uscore_hash_lambda25_dot_uscore_hash_lambda27 :: forall t0
  t1 t2 t3 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t2) => Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Analysis.Curry_ProgInfo.C_ProgInfo t1 -> Analysis.Curry_ProgInfo.C_ProgInfo
  t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> (Analysis.Curry_ProgInfo.C_ProgInfo t1 -> Cover -> ConstStore
  -> Analysis.Curry_ProgInfo.C_ProgInfo t0 -> Cover -> ConstStore -> t3 -> Cover
  -> ConstStore -> t2) -> Analysis.Curry_ProgInfo.C_ProgInfo t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (t3 -> Cover -> ConstStore -> t2)
d_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23_dot_uscore_hash_lambda25_dot_uscore_hash_lambda27 x1 x2 x3 x4 x5 x6 x7 x8 x9 cd cs =
  let x10 = x9
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Analysis.Curry_Files.d_C_loadCompleteAnalysis x6 x7 x1 x2 x3 cd cs) cd
  cs)
  (d_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23_dot_uscore_hash_lambda25_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29
  x10 x4 x5 x8) cd cs

nd_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23_dot_uscore_hash_lambda25_dot_uscore_hash_lambda27 :: forall t0
  t1 t2 t3 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t2) => Analysis.Curry_Logging.C_DLevel -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Analysis.Curry_ProgInfo.C_ProgInfo t1 -> Analysis.Curry_ProgInfo.C_ProgInfo
  t1 -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> Func Curry_Prelude.OP_Unit (RW.Curry_Base.OP_uscore_Dict_hash_ReadWrite t0)
  -> Func (Analysis.Curry_ProgInfo.C_ProgInfo t1) (Func
  (Analysis.Curry_ProgInfo.C_ProgInfo t0) (Func t3 t2))
  -> Analysis.Curry_ProgInfo.C_ProgInfo t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Func t3 t2)
nd_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23_dot_uscore_hash_lambda25_dot_uscore_hash_lambda27 x1 x2 x3 x4 x5 x6 x7 x8 x9 s cd cs =
  let s6 = s
  in s6 `seq` (let x10 = x9
  in let s5 = leftSupply s6
         s3 = rightSupply s6
  in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                      s4 = rightSupply s3
                                                      s0 = leftSupply s4
                                                      s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (Analysis.Curry_Files.nd_C_loadCompleteAnalysis x6 x7 x1 x2 x3 s1 cd
  cs) s2 cd cs)))) (wrapNX id
  (nd_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23_dot_uscore_hash_lambda25_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29
  x10 x4 x5 x8)) s5 cd cs))

d_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23_dot_uscore_hash_lambda25_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29 :: forall t0
  t1 t2 t3 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t2) => Analysis.Curry_ProgInfo.C_ProgInfo t0
  -> Analysis.Curry_ProgInfo.C_ProgInfo t1 -> Analysis.Curry_ProgInfo.C_ProgInfo
  t1 -> (Analysis.Curry_ProgInfo.C_ProgInfo t1 -> Cover -> ConstStore
  -> Analysis.Curry_ProgInfo.C_ProgInfo t0 -> Cover -> ConstStore -> t3 -> Cover
  -> ConstStore -> t2) -> Analysis.Curry_ProgInfo.C_ProgInfo t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (t3 -> Cover -> ConstStore -> t2)
d_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23_dot_uscore_hash_lambda25_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29 x1 x2 x3 x4 x5 cd cs =
  let x6 = x5
      x7 = Analysis.Curry_ProgInfo.d_C_combineProgInfo x2 x3 cd cs
      x8 = Analysis.Curry_ProgInfo.d_C_combineProgInfo x1 x6 cd cs
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x4 x7 cd cs) x8 cd
  cs) cd cs

nd_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23_dot_uscore_hash_lambda25_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29 :: forall t0
  t1 t2 t3 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t2) => Analysis.Curry_ProgInfo.C_ProgInfo t0
  -> Analysis.Curry_ProgInfo.C_ProgInfo t1 -> Analysis.Curry_ProgInfo.C_ProgInfo
  t1 -> Func (Analysis.Curry_ProgInfo.C_ProgInfo t1) (Func
  (Analysis.Curry_ProgInfo.C_ProgInfo t0) (Func t3 t2))
  -> Analysis.Curry_ProgInfo.C_ProgInfo t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Func t3 t2)
nd_OP_runWith2BaseAnalyses_dot_uscore_hash_lambda21_dot_uscore_hash_lambda23_dot_uscore_hash_lambda25_dot_uscore_hash_lambda27_dot_uscore_hash_lambda29 x1 x2 x3 x4 x5 s cd cs =
  let s5 = s
  in s5 `seq` (let x6 = x5
                   x7 = Analysis.Curry_ProgInfo.d_C_combineProgInfo x2 x3 cd cs
                   x8 = Analysis.Curry_ProgInfo.d_C_combineProgInfo x1 x6 cd cs
  in let s4 = leftSupply s5
         s6 = rightSupply s5
         s0 = leftSupply s6
         s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (let s2 = leftSupply s3
                 s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x4 x7
  s1 cd cs) x8 s2 cd cs)) s4 cd cs))))

d_C__case_8 :: C_AOutFormat -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_8 x2 cd cs = case x2 of
  C_AText -> Curry_Prelude.C_False
  C_ANote -> Curry_Prelude.C_True
  Choice_C_AOutFormat d i l r -> narrow d i (d_C__case_8 l cd cs) (d_C__case_8 r
    cd cs)
  Choices_C_AOutFormat d i xs -> narrows cs d i (\z -> d_C__case_8 z cd cs) xs
  Guard_C_AOutFormat d c e -> guardCons d c ((\x -> d_C__case_8 e cd x) $! addCs
    c cs)
  Fail_C_AOutFormat d info -> failCons d (traceFail "Analysis.Types._case_8"
    [show x2] info)
  _ -> failCons cd (consFail "Analysis.Types._case_8" (showCons x2))

d_C__case_9 :: C_AOutFormat -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_9 x2 cd cs = case x2 of
  C_AText -> Curry_Prelude.C_True
  C_ANote -> Curry_Prelude.C_False
  Choice_C_AOutFormat d i l r -> narrow d i (d_C__case_9 l cd cs) (d_C__case_9 r
    cd cs)
  Choices_C_AOutFormat d i xs -> narrows cs d i (\z -> d_C__case_9 z cd cs) xs
  Guard_C_AOutFormat d c e -> guardCons d c ((\x -> d_C__case_9 e cd x) $! addCs
    c cs)
  Fail_C_AOutFormat d info -> failCons d (traceFail "Analysis.Types._case_9"
    [show x2] info)
  _ -> failCons cd (consFail "Analysis.Types._case_9" (showCons x2))

d_C__case_6 :: C_AOutFormat -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_6 x2 cd cs = case x2 of
  C_AText -> Curry_Prelude.C_False
  C_ANote -> Curry_Prelude.C_True
  Choice_C_AOutFormat d i l r -> narrow d i (d_C__case_6 l cd cs) (d_C__case_6 r
    cd cs)
  Choices_C_AOutFormat d i xs -> narrows cs d i (\z -> d_C__case_6 z cd cs) xs
  Guard_C_AOutFormat d c e -> guardCons d c ((\x -> d_C__case_6 e cd x) $! addCs
    c cs)
  Fail_C_AOutFormat d info -> failCons d (traceFail "Analysis.Types._case_6"
    [show x2] info)
  _ -> failCons cd (consFail "Analysis.Types._case_6" (showCons x2))

d_C__case_7 :: C_AOutFormat -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_7 x2 cd cs = case x2 of
  C_AText -> Curry_Prelude.C_True
  C_ANote -> Curry_Prelude.C_False
  Choice_C_AOutFormat d i l r -> narrow d i (d_C__case_7 l cd cs) (d_C__case_7 r
    cd cs)
  Choices_C_AOutFormat d i xs -> narrows cs d i (\z -> d_C__case_7 z cd cs) xs
  Guard_C_AOutFormat d c e -> guardCons d c ((\x -> d_C__case_7 e cd x) $! addCs
    c cs)
  Fail_C_AOutFormat d info -> failCons d (traceFail "Analysis.Types._case_7"
    [show x2] info)
  _ -> failCons cd (consFail "Analysis.Types._case_7" (showCons x2))

d_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Bool
  -> C_Analysis t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_5 x2 x1 cd cs = case x1 of
  C_SimpleFuncAnalysis x3 x4 -> Curry_Prelude.C_True
  C_SimpleTypeAnalysis x5 x6 -> Curry_Prelude.C_True
  C_SimpleConstructorAnalysis x7 x8 -> Curry_Prelude.C_True
  C_CombinedSimpleFuncAnalysis x9 x10 x11 x12 -> Curry_Prelude.C_True
  C_CombinedSimpleTypeAnalysis x13 x14 x15 x16 -> Curry_Prelude.C_True
  C_DependencyFuncAnalysis x17 x18 x19 -> x2
  C_DependencyTypeAnalysis x20 x21 x22 -> x2
  C_CombinedDependencyFuncAnalysis x23 x24 x25 x26 x27 -> x2
  C_CombinedDependencyTypeAnalysis x28 x29 x30 x31 x32 -> x2
  C_SimpleModuleAnalysis x33 x34 -> x2
  C_DependencyModuleAnalysis x35 x36 -> x2
  Choice_C_Analysis d i l r -> narrow d i (d_C__case_5 x2 l cd cs) (d_C__case_5
    x2 r cd cs)
  Choices_C_Analysis d i xs -> narrows cs d i (\z -> d_C__case_5 x2 z cd cs) xs
  Guard_C_Analysis d c e -> guardCons d c ((\x -> d_C__case_5 x2 e cd x) $!
    addCs c cs)
  Fail_C_Analysis d info -> failCons d (traceFail "Analysis.Types._case_5" [show
    x2, show x1] info)
  _ -> failCons cd (consFail "Analysis.Types._case_5" (showCons x1))

nd_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Bool
  -> C_Analysis t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_5 x2 x1 s cd cs = case x1 of
  HO_C_SimpleFuncAnalysis x3 x4 -> Curry_Prelude.C_True
  HO_C_SimpleTypeAnalysis x5 x6 -> Curry_Prelude.C_True
  HO_C_SimpleConstructorAnalysis x7 x8 -> Curry_Prelude.C_True
  HO_C_CombinedSimpleFuncAnalysis x9 x10 x11 x12 -> Curry_Prelude.C_True
  HO_C_CombinedSimpleTypeAnalysis x13 x14 x15 x16 -> Curry_Prelude.C_True
  HO_C_DependencyFuncAnalysis x17 x18 x19 -> x2
  HO_C_DependencyTypeAnalysis x20 x21 x22 -> x2
  HO_C_CombinedDependencyFuncAnalysis x23 x24 x25 x26 x27 -> x2
  HO_C_CombinedDependencyTypeAnalysis x28 x29 x30 x31 x32 -> x2
  HO_C_SimpleModuleAnalysis x33 x34 -> x2
  HO_C_DependencyModuleAnalysis x35 x36 -> x2
  Choice_C_Analysis d i l r -> narrow d i (nd_C__case_5 x2 l s cd cs)
    (nd_C__case_5 x2 r s cd cs)
  Choices_C_Analysis d i xs -> narrows cs d i (\z -> nd_C__case_5 x2 z s cd cs)
    xs
  Guard_C_Analysis d c e -> guardCons d c ((\x -> nd_C__case_5 x2 e s cd x) $!
    addCs c cs)
  Fail_C_Analysis d info -> failCons d (traceFail "Analysis.Types._case_5" [show
    x2, show x1] info)
  _ -> failCons cd (consFail "Analysis.Types._case_5" (showCons x1))

d_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Bool
  -> C_Analysis t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_4 x2 x1 cd cs = case x1 of
  C_CombinedSimpleFuncAnalysis x3 x4 x5 x6 -> Curry_Prelude.C_True
  C_CombinedSimpleTypeAnalysis x7 x8 x9 x10 -> Curry_Prelude.C_True
  C_CombinedDependencyFuncAnalysis x11 x12 x13 x14 x15 -> Curry_Prelude.C_True
  C_CombinedDependencyTypeAnalysis x16 x17 x18 x19 x20 -> Curry_Prelude.C_True
  C_SimpleFuncAnalysis x21 x22 -> x2
  C_SimpleTypeAnalysis x23 x24 -> x2
  C_SimpleConstructorAnalysis x25 x26 -> x2
  C_DependencyFuncAnalysis x27 x28 x29 -> x2
  C_DependencyTypeAnalysis x30 x31 x32 -> x2
  C_SimpleModuleAnalysis x33 x34 -> x2
  C_DependencyModuleAnalysis x35 x36 -> x2
  Choice_C_Analysis d i l r -> narrow d i (d_C__case_4 x2 l cd cs) (d_C__case_4
    x2 r cd cs)
  Choices_C_Analysis d i xs -> narrows cs d i (\z -> d_C__case_4 x2 z cd cs) xs
  Guard_C_Analysis d c e -> guardCons d c ((\x -> d_C__case_4 x2 e cd x) $!
    addCs c cs)
  Fail_C_Analysis d info -> failCons d (traceFail "Analysis.Types._case_4" [show
    x2, show x1] info)
  _ -> failCons cd (consFail "Analysis.Types._case_4" (showCons x1))

nd_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Bool
  -> C_Analysis t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_4 x2 x1 s cd cs = case x1 of
  HO_C_CombinedSimpleFuncAnalysis x3 x4 x5 x6 -> Curry_Prelude.C_True
  HO_C_CombinedSimpleTypeAnalysis x7 x8 x9 x10 -> Curry_Prelude.C_True
  HO_C_CombinedDependencyFuncAnalysis x11 x12 x13 x14 x15 -> Curry_Prelude.C_True
  HO_C_CombinedDependencyTypeAnalysis x16 x17 x18 x19 x20 -> Curry_Prelude.C_True
  HO_C_SimpleFuncAnalysis x21 x22 -> x2
  HO_C_SimpleTypeAnalysis x23 x24 -> x2
  HO_C_SimpleConstructorAnalysis x25 x26 -> x2
  HO_C_DependencyFuncAnalysis x27 x28 x29 -> x2
  HO_C_DependencyTypeAnalysis x30 x31 x32 -> x2
  HO_C_SimpleModuleAnalysis x33 x34 -> x2
  HO_C_DependencyModuleAnalysis x35 x36 -> x2
  Choice_C_Analysis d i l r -> narrow d i (nd_C__case_4 x2 l s cd cs)
    (nd_C__case_4 x2 r s cd cs)
  Choices_C_Analysis d i xs -> narrows cs d i (\z -> nd_C__case_4 x2 z s cd cs)
    xs
  Guard_C_Analysis d c e -> guardCons d c ((\x -> nd_C__case_4 x2 e s cd x) $!
    addCs c cs)
  Fail_C_Analysis d info -> failCons d (traceFail "Analysis.Types._case_4" [show
    x2, show x1] info)
  _ -> failCons cd (consFail "Analysis.Types._case_4" (showCons x1))

d_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Bool
  -> C_Analysis t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_3 x2 x1 cd cs = case x1 of
  C_SimpleFuncAnalysis x3 x4 -> Curry_Prelude.C_True
  C_DependencyFuncAnalysis x5 x6 x7 -> Curry_Prelude.C_True
  C_CombinedSimpleFuncAnalysis x8 x9 x10 x11 -> Curry_Prelude.C_True
  C_CombinedDependencyFuncAnalysis x12 x13 x14 x15 x16 -> Curry_Prelude.C_True
  C_SimpleTypeAnalysis x17 x18 -> x2
  C_SimpleConstructorAnalysis x19 x20 -> x2
  C_DependencyTypeAnalysis x21 x22 x23 -> x2
  C_CombinedSimpleTypeAnalysis x24 x25 x26 x27 -> x2
  C_CombinedDependencyTypeAnalysis x28 x29 x30 x31 x32 -> x2
  C_SimpleModuleAnalysis x33 x34 -> x2
  C_DependencyModuleAnalysis x35 x36 -> x2
  Choice_C_Analysis d i l r -> narrow d i (d_C__case_3 x2 l cd cs) (d_C__case_3
    x2 r cd cs)
  Choices_C_Analysis d i xs -> narrows cs d i (\z -> d_C__case_3 x2 z cd cs) xs
  Guard_C_Analysis d c e -> guardCons d c ((\x -> d_C__case_3 x2 e cd x) $!
    addCs c cs)
  Fail_C_Analysis d info -> failCons d (traceFail "Analysis.Types._case_3" [show
    x2, show x1] info)
  _ -> failCons cd (consFail "Analysis.Types._case_3" (showCons x1))

nd_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Bool
  -> C_Analysis t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_3 x2 x1 s cd cs = case x1 of
  HO_C_SimpleFuncAnalysis x3 x4 -> Curry_Prelude.C_True
  HO_C_DependencyFuncAnalysis x5 x6 x7 -> Curry_Prelude.C_True
  HO_C_CombinedSimpleFuncAnalysis x8 x9 x10 x11 -> Curry_Prelude.C_True
  HO_C_CombinedDependencyFuncAnalysis x12 x13 x14 x15 x16 -> Curry_Prelude.C_True
  HO_C_SimpleTypeAnalysis x17 x18 -> x2
  HO_C_SimpleConstructorAnalysis x19 x20 -> x2
  HO_C_DependencyTypeAnalysis x21 x22 x23 -> x2
  HO_C_CombinedSimpleTypeAnalysis x24 x25 x26 x27 -> x2
  HO_C_CombinedDependencyTypeAnalysis x28 x29 x30 x31 x32 -> x2
  HO_C_SimpleModuleAnalysis x33 x34 -> x2
  HO_C_DependencyModuleAnalysis x35 x36 -> x2
  Choice_C_Analysis d i l r -> narrow d i (nd_C__case_3 x2 l s cd cs)
    (nd_C__case_3 x2 r s cd cs)
  Choices_C_Analysis d i xs -> narrows cs d i (\z -> nd_C__case_3 x2 z s cd cs)
    xs
  Guard_C_Analysis d c e -> guardCons d c ((\x -> nd_C__case_3 x2 e s cd x) $!
    addCs c cs)
  Fail_C_Analysis d info -> failCons d (traceFail "Analysis.Types._case_3" [show
    x2, show x1] info)
  _ -> failCons cd (consFail "Analysis.Types._case_3" (showCons x1))

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Bool
  -> C_Analysis t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_2 x2 x1 cd cs = case x1 of
  C_SimpleTypeAnalysis x3 x4 -> Curry_Prelude.C_True
  C_DependencyTypeAnalysis x5 x6 x7 -> Curry_Prelude.C_True
  C_CombinedSimpleTypeAnalysis x8 x9 x10 x11 -> Curry_Prelude.C_True
  C_CombinedDependencyTypeAnalysis x12 x13 x14 x15 x16 -> Curry_Prelude.C_True
  C_SimpleFuncAnalysis x17 x18 -> x2
  C_SimpleConstructorAnalysis x19 x20 -> x2
  C_DependencyFuncAnalysis x21 x22 x23 -> x2
  C_CombinedSimpleFuncAnalysis x24 x25 x26 x27 -> x2
  C_CombinedDependencyFuncAnalysis x28 x29 x30 x31 x32 -> x2
  C_SimpleModuleAnalysis x33 x34 -> x2
  C_DependencyModuleAnalysis x35 x36 -> x2
  Choice_C_Analysis d i l r -> narrow d i (d_C__case_2 x2 l cd cs) (d_C__case_2
    x2 r cd cs)
  Choices_C_Analysis d i xs -> narrows cs d i (\z -> d_C__case_2 x2 z cd cs) xs
  Guard_C_Analysis d c e -> guardCons d c ((\x -> d_C__case_2 x2 e cd x) $!
    addCs c cs)
  Fail_C_Analysis d info -> failCons d (traceFail "Analysis.Types._case_2" [show
    x2, show x1] info)
  _ -> failCons cd (consFail "Analysis.Types._case_2" (showCons x1))

nd_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Bool
  -> C_Analysis t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_2 x2 x1 s cd cs = case x1 of
  HO_C_SimpleTypeAnalysis x3 x4 -> Curry_Prelude.C_True
  HO_C_DependencyTypeAnalysis x5 x6 x7 -> Curry_Prelude.C_True
  HO_C_CombinedSimpleTypeAnalysis x8 x9 x10 x11 -> Curry_Prelude.C_True
  HO_C_CombinedDependencyTypeAnalysis x12 x13 x14 x15 x16 -> Curry_Prelude.C_True
  HO_C_SimpleFuncAnalysis x17 x18 -> x2
  HO_C_SimpleConstructorAnalysis x19 x20 -> x2
  HO_C_DependencyFuncAnalysis x21 x22 x23 -> x2
  HO_C_CombinedSimpleFuncAnalysis x24 x25 x26 x27 -> x2
  HO_C_CombinedDependencyFuncAnalysis x28 x29 x30 x31 x32 -> x2
  HO_C_SimpleModuleAnalysis x33 x34 -> x2
  HO_C_DependencyModuleAnalysis x35 x36 -> x2
  Choice_C_Analysis d i l r -> narrow d i (nd_C__case_2 x2 l s cd cs)
    (nd_C__case_2 x2 r s cd cs)
  Choices_C_Analysis d i xs -> narrows cs d i (\z -> nd_C__case_2 x2 z s cd cs)
    xs
  Guard_C_Analysis d c e -> guardCons d c ((\x -> nd_C__case_2 x2 e s cd x) $!
    addCs c cs)
  Fail_C_Analysis d info -> failCons d (traceFail "Analysis.Types._case_2" [show
    x2, show x1] info)
  _ -> failCons cd (consFail "Analysis.Types._case_2" (showCons x1))

d_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Analysis t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_1 x2 x1 cd cs = case x1 of
  C_CombinedSimpleFuncAnalysis x3 x4 x5 x6 -> x3
  C_CombinedSimpleTypeAnalysis x7 x8 x9 x10 -> x7
  C_CombinedDependencyFuncAnalysis x11 x12 x13 x14 x15 -> x11
  C_CombinedDependencyTypeAnalysis x16 x17 x18 x19 x20 -> x16
  C_SimpleFuncAnalysis x21 x22 -> x2
  C_SimpleTypeAnalysis x23 x24 -> x2
  C_SimpleConstructorAnalysis x25 x26 -> x2
  C_DependencyFuncAnalysis x27 x28 x29 -> x2
  C_DependencyTypeAnalysis x30 x31 x32 -> x2
  C_SimpleModuleAnalysis x33 x34 -> x2
  C_DependencyModuleAnalysis x35 x36 -> x2
  Choice_C_Analysis d i l r -> narrow d i (d_C__case_1 x2 l cd cs) (d_C__case_1
    x2 r cd cs)
  Choices_C_Analysis d i xs -> narrows cs d i (\z -> d_C__case_1 x2 z cd cs) xs
  Guard_C_Analysis d c e -> guardCons d c ((\x -> d_C__case_1 x2 e cd x) $!
    addCs c cs)
  Fail_C_Analysis d info -> failCons d (traceFail "Analysis.Types._case_1" [show
    x2, show x1] info)
  _ -> failCons cd (consFail "Analysis.Types._case_1" (showCons x1))

nd_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Analysis t0 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_C__case_1 x2 x1 s cd cs = case x1 of
  HO_C_CombinedSimpleFuncAnalysis x3 x4 x5 x6 -> x3
  HO_C_CombinedSimpleTypeAnalysis x7 x8 x9 x10 -> x7
  HO_C_CombinedDependencyFuncAnalysis x11 x12 x13 x14 x15 -> x11
  HO_C_CombinedDependencyTypeAnalysis x16 x17 x18 x19 x20 -> x16
  HO_C_SimpleFuncAnalysis x21 x22 -> x2
  HO_C_SimpleTypeAnalysis x23 x24 -> x2
  HO_C_SimpleConstructorAnalysis x25 x26 -> x2
  HO_C_DependencyFuncAnalysis x27 x28 x29 -> x2
  HO_C_DependencyTypeAnalysis x30 x31 x32 -> x2
  HO_C_SimpleModuleAnalysis x33 x34 -> x2
  HO_C_DependencyModuleAnalysis x35 x36 -> x2
  Choice_C_Analysis d i l r -> narrow d i (nd_C__case_1 x2 l s cd cs)
    (nd_C__case_1 x2 r s cd cs)
  Choices_C_Analysis d i xs -> narrows cs d i (\z -> nd_C__case_1 x2 z s cd cs)
    xs
  Guard_C_Analysis d c e -> guardCons d c ((\x -> nd_C__case_1 x2 e s cd x) $!
    addCs c cs)
  Fail_C_Analysis d info -> failCons d (traceFail "Analysis.Types._case_1" [show
    x2, show x1] info)
  _ -> failCons cd (consFail "Analysis.Types._case_1" (showCons x1))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> C_Analysis t0
  -> Cover -> ConstStore -> t0
d_C__case_0 x2 x1 cd cs = case x1 of
  C_DependencyFuncAnalysis x3 x4 x5 -> x4
  C_DependencyTypeAnalysis x6 x7 x8 -> x7
  C_CombinedDependencyFuncAnalysis x9 x10 x11 x12 x13 -> x12
  C_CombinedDependencyTypeAnalysis x14 x15 x16 x17 x18 -> x17
  C_SimpleFuncAnalysis x19 x20 -> x2
  C_SimpleTypeAnalysis x21 x22 -> x2
  C_SimpleConstructorAnalysis x23 x24 -> x2
  C_CombinedSimpleFuncAnalysis x25 x26 x27 x28 -> x2
  C_CombinedSimpleTypeAnalysis x29 x30 x31 x32 -> x2
  C_SimpleModuleAnalysis x33 x34 -> x2
  C_DependencyModuleAnalysis x35 x36 -> x2
  Choice_C_Analysis d i l r -> narrow d i (d_C__case_0 x2 l cd cs) (d_C__case_0
    x2 r cd cs)
  Choices_C_Analysis d i xs -> narrows cs d i (\z -> d_C__case_0 x2 z cd cs) xs
  Guard_C_Analysis d c e -> guardCons d c ((\x -> d_C__case_0 x2 e cd x) $!
    addCs c cs)
  Fail_C_Analysis d info -> failCons d (traceFail "Analysis.Types._case_0" [show
    x2, show x1] info)
  _ -> failCons cd (consFail "Analysis.Types._case_0" (showCons x1))

nd_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> C_Analysis t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C__case_0 x2 x1 s cd cs = case x1 of
  HO_C_DependencyFuncAnalysis x3 x4 x5 -> x4
  HO_C_DependencyTypeAnalysis x6 x7 x8 -> x7
  HO_C_CombinedDependencyFuncAnalysis x9 x10 x11 x12 x13 -> x12
  HO_C_CombinedDependencyTypeAnalysis x14 x15 x16 x17 x18 -> x17
  HO_C_SimpleFuncAnalysis x19 x20 -> x2
  HO_C_SimpleTypeAnalysis x21 x22 -> x2
  HO_C_SimpleConstructorAnalysis x23 x24 -> x2
  HO_C_CombinedSimpleFuncAnalysis x25 x26 x27 x28 -> x2
  HO_C_CombinedSimpleTypeAnalysis x29 x30 x31 x32 -> x2
  HO_C_SimpleModuleAnalysis x33 x34 -> x2
  HO_C_DependencyModuleAnalysis x35 x36 -> x2
  Choice_C_Analysis d i l r -> narrow d i (nd_C__case_0 x2 l s cd cs)
    (nd_C__case_0 x2 r s cd cs)
  Choices_C_Analysis d i xs -> narrows cs d i (\z -> nd_C__case_0 x2 z s cd cs)
    xs
  Guard_C_Analysis d c e -> guardCons d c ((\x -> nd_C__case_0 x2 e s cd x) $!
    addCs c cs)
  Fail_C_Analysis d info -> failCons d (traceFail "Analysis.Types._case_0" [show
    x2, show x1] info)
  _ -> failCons cd (consFail "Analysis.Types._case_0" (showCons x1))

