{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Language.Curry.Curry_StringClassifier
  ( C_Token (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Curry_dot_StringClassifier_dot_Token_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Curry_dot_StringClassifier_dot_Token_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Curry_dot_StringClassifier_dot_Token_hash
  , d_C_isSmallComment
  , d_C_isBigComment
  , d_C_isComment
  , d_C_isText
  , d_C_isLetter
  , d_C_isCode
  , d_C_isModuleHead
  , d_C_isMeta
  , nd_C_scan
  , d_C_plainCode
  , d_C_unscan
  , nd_C_readScan
  , nd_C_testScan )
  where

import Basics
import qualified Curry_Prelude


data C_Token
  = C_SmallComment (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_BigComment (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_Text (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_Letter (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_Code (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_ModuleHead (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_Meta (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | Choice_C_Token Cover ID C_Token C_Token
  | Choices_C_Token Cover ID [C_Token]
  | Fail_C_Token Cover FailInfo
  | Guard_C_Token Cover Constraints C_Token

instance Show C_Token where
  showsPrec d (Choice_C_Token cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Token cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Token cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Token cd info) = showChar '!'
  showsPrec _ (C_SmallComment x1) = showString "(SmallComment" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (C_BigComment x1) = showString "(BigComment" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (C_Text x1) = showString "(Text" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_Letter x1) = showString "(Letter" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_Code x1) = showString "(Code" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_ModuleHead x1) = showString "(ModuleHead" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (C_Meta x1) = showString "(Meta" . (showChar ' ' . (shows x1 .
    showChar ')'))

instance Read C_Token where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_SmallComment x1, r1) | (_, r0)
    <- readQualified "Language.Curry.StringClassifier" "SmallComment" r, (x1
    , r1) <- readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_BigComment
    x1, r1) | (_, r0) <- readQualified "Language.Curry.StringClassifier"
    "BigComment" r, (x1, r1) <- readsPrec 11 r0]) s ++ (readParen ((>) d 10)
    (\r -> [(C_Text x1, r1) | (_, r0) <- readQualified
    "Language.Curry.StringClassifier" "Text" r, (x1, r1) <- readsPrec 11 r0])
    s ++ (readParen ((>) d 10) (\r -> [(C_Letter x1, r1) | (_, r0) <-
    readQualified "Language.Curry.StringClassifier" "Letter" r, (x1, r1) <-
    readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_Code x1, r1) | (_
    , r0) <- readQualified "Language.Curry.StringClassifier" "Code" r, (x1, r1)
    <- readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_ModuleHead x1
    , r1) | (_, r0) <- readQualified "Language.Curry.StringClassifier"
    "ModuleHead" r, (x1, r1) <- readsPrec 11 r0]) s ++ readParen ((>) d 10)
    (\r -> [(C_Meta x1, r1) | (_, r0) <- readQualified
    "Language.Curry.StringClassifier" "Meta" r, (x1, r1) <- readsPrec 11 r0])
    s)))))

instance NonDet C_Token where
  choiceCons = Choice_C_Token
  choicesCons = Choices_C_Token
  failCons = Fail_C_Token
  guardCons = Guard_C_Token
  try (Choice_C_Token cd i x y) = tryChoice cd i x y
  try (Choices_C_Token cd i xs) = tryChoices cd i xs
  try (Fail_C_Token cd info) = Fail cd info
  try (Guard_C_Token cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Token cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Token cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Token cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Token cd i _) = error
    ("Language.Curry.StringClassifier.Token.match: Choices with ChoiceID " ++
    show i)
  match _ _ _ f _ _ (Fail_C_Token cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Token cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Token where
  generate s c = Choices_C_Token c (freeID [1, 1, 1, 1, 1, 1, 1] s)
    [C_SmallComment (generate (leftSupply s) c), C_BigComment (generate
    (leftSupply s) c), C_Text (generate (leftSupply s) c), C_Letter (generate
    (leftSupply s) c), C_Code (generate (leftSupply s) c), C_ModuleHead
    (generate (leftSupply s) c), C_Meta (generate (leftSupply s) c)]

instance NormalForm C_Token where
  ($!!) cont (C_SmallComment x1) d cs = ($!!) (\y1 d cs -> cont (C_SmallComment
    y1) d cs) x1 d cs
  ($!!) cont (C_BigComment x1) d cs = ($!!) (\y1 d cs -> cont (C_BigComment y1)
    d cs) x1 d cs
  ($!!) cont (C_Text x1) d cs = ($!!) (\y1 d cs -> cont (C_Text y1) d cs) x1 d
    cs
  ($!!) cont (C_Letter x1) d cs = ($!!) (\y1 d cs -> cont (C_Letter y1) d cs) x1
    d cs
  ($!!) cont (C_Code x1) d cs = ($!!) (\y1 d cs -> cont (C_Code y1) d cs) x1 d
    cs
  ($!!) cont (C_ModuleHead x1) d cs = ($!!) (\y1 d cs -> cont (C_ModuleHead y1)
    d cs) x1 d cs
  ($!!) cont (C_Meta x1) d cs = ($!!) (\y1 d cs -> cont (C_Meta y1) d cs) x1 d
    cs
  ($!!) cont (Choice_C_Token cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Token cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Token cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_Token cd info) _ _ = failCons cd info
  ($##) cont (C_SmallComment x1) d cs = ($##) (\y1 d cs -> cont (C_SmallComment
    y1) d cs) x1 d cs
  ($##) cont (C_BigComment x1) d cs = ($##) (\y1 d cs -> cont (C_BigComment y1)
    d cs) x1 d cs
  ($##) cont (C_Text x1) d cs = ($##) (\y1 d cs -> cont (C_Text y1) d cs) x1 d
    cs
  ($##) cont (C_Letter x1) d cs = ($##) (\y1 d cs -> cont (C_Letter y1) d cs) x1
    d cs
  ($##) cont (C_Code x1) d cs = ($##) (\y1 d cs -> cont (C_Code y1) d cs) x1 d
    cs
  ($##) cont (C_ModuleHead x1) d cs = ($##) (\y1 d cs -> cont (C_ModuleHead y1)
    d cs) x1 d cs
  ($##) cont (C_Meta x1) d cs = ($##) (\y1 d cs -> cont (C_Meta y1) d cs) x1 d
    cs
  ($##) cont (Choice_C_Token cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Token cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Token cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_Token cd info) _ _ = failCons cd info
  showCons (C_SmallComment _) = "Language.Curry.StringClassifier.SmallComment _"
  showCons (C_BigComment _) = "Language.Curry.StringClassifier.BigComment _"
  showCons (C_Text _) = "Language.Curry.StringClassifier.Text _"
  showCons (C_Letter _) = "Language.Curry.StringClassifier.Letter _"
  showCons (C_Code _) = "Language.Curry.StringClassifier.Code _"
  showCons (C_ModuleHead _) = "Language.Curry.StringClassifier.ModuleHead _"
  showCons (C_Meta _) = "Language.Curry.StringClassifier.Meta _"
  showCons x = error
    ("Language.Curry.StringClassifier.Token.showCons: no constructor: " ++ show
    x)
  searchNF search cont (C_SmallComment x1) = search (\y1 -> cont (C_SmallComment
    y1)) x1
  searchNF search cont (C_BigComment x1) = search (\y1 -> cont (C_BigComment
    y1)) x1
  searchNF search cont (C_Text x1) = search (\y1 -> cont (C_Text y1)) x1
  searchNF search cont (C_Letter x1) = search (\y1 -> cont (C_Letter y1)) x1
  searchNF search cont (C_Code x1) = search (\y1 -> cont (C_Code y1)) x1
  searchNF search cont (C_ModuleHead x1) = search (\y1 -> cont (C_ModuleHead
    y1)) x1
  searchNF search cont (C_Meta x1) = search (\y1 -> cont (C_Meta y1)) x1
  searchNF _ _ x = error
    ("Language.Curry.StringClassifier.Token.searchNF: no constructor: " ++ show
    x)

instance Unifiable C_Token where
  (=.=) (C_SmallComment x1) (C_SmallComment y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_BigComment x1) (C_BigComment y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Text x1) (C_Text y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Letter x1) (C_Letter y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Code x1) (C_Code y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_ModuleHead x1) (C_ModuleHead y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Meta x1) (C_Meta y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_SmallComment x1) (C_SmallComment y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_BigComment x1) (C_BigComment y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Text x1) (C_Text y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Letter x1) (C_Letter y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Code x1) (C_Code y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_ModuleHead x1) (C_ModuleHead y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Meta x1) (C_Meta y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_SmallComment x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID
    i) x3]
  bind cd i (C_BigComment x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_Text x3) = (i :=: ChooseN 2 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_Letter x3) = (i :=: ChooseN 3 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_Code x3) = (i :=: ChooseN 4 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_ModuleHead x3) = (i :=: ChooseN 5 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_Meta x3) = (i :=: ChooseN 6 1) : concat [bind cd (leftID i) x3]
  bind d i (Choice_C_Token cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_Token cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Token cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Token cd i _) = error
    ("Language.Curry.StringClassifier.Token.bind: Choices with ChoiceID: " ++
    show i)
  bind _ _ (Fail_C_Token cd info) = [Unsolvable info]
  bind d i (Guard_C_Token cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_SmallComment x3) = (i :=: ChooseN 0 1) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_BigComment x3) = (i :=: ChooseN 1 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Text x3) = (i :=: ChooseN 2 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Letter x3) = (i :=: ChooseN 3 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Code x3) = (i :=: ChooseN 4 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_ModuleHead x3) = (i :=: ChooseN 5 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Meta x3) = (i :=: ChooseN 6 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_Token cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Token cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_Token cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Token cd i _) = error
    ("Language.Curry.StringClassifier.Token.lazyBind: Choices with ChoiceID: " ++
    show i)
  lazyBind _ _ (Fail_C_Token cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Token cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Token where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Curry_dot_StringClassifier_dot_Token_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Token
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Curry_dot_StringClassifier_dot_Token_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Curry_dot_StringClassifier_dot_Token_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Curry_dot_StringClassifier_dot_Token_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Curry_dot_StringClassifier_dot_Token_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Curry_dot_StringClassifier_dot_Token_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Curry_dot_StringClassifier_dot_Token_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Curry_dot_StringClassifier_dot_Token_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._inst#Prelude.Data#Language.Curry.StringClassifier.Token#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.Curry.StringClassifier._inst#Prelude.Data#Language.Curry.StringClassifier.Token#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Curry_dot_StringClassifier_dot_Token_hash :: C_Token
  -> C_Token -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Curry_dot_StringClassifier_dot_Token_hash x1 x2 s cd cs =
  case x1 of
  C_SmallComment x3 -> let s0 = s in s0 `seq` nd_C__case_85 x3 x2 s0 cd cs
  C_BigComment x11 -> let s0 = s in s0 `seq` nd_C__case_84 x11 x2 s0 cd cs
  C_Text x19 -> let s0 = s in s0 `seq` nd_C__case_83 x19 x2 s0 cd cs
  C_Letter x27 -> let s0 = s in s0 `seq` nd_C__case_82 x27 x2 s0 cd cs
  C_Code x35 -> let s0 = s in s0 `seq` nd_C__case_81 x35 x2 s0 cd cs
  C_ModuleHead x43 -> let s0 = s in s0 `seq` nd_C__case_80 x43 x2 s0 cd cs
  C_Meta x51 -> let s0 = s in s0 `seq` nd_C__case_79 x51 x2 s0 cd cs
  Choice_C_Token d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Curry_dot_StringClassifier_dot_Token_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Curry_dot_StringClassifier_dot_Token_hash
    r x2 s cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Curry_dot_StringClassifier_dot_Token_hash
    z x2 s cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Curry_dot_StringClassifier_dot_Token_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._impl#===#Prelude.Data#Language.Curry.StringClassifier.Token#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.Curry.StringClassifier._impl#===#Prelude.Data#Language.Curry.StringClassifier.Token#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Curry_dot_StringClassifier_dot_Token_hash :: IDSupply
  -> Cover -> ConstStore -> C_Token
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Curry_dot_StringClassifier_dot_Token_hash s cd cs =
  let s23 = s
  in s23 `seq` (let s22 = leftSupply s23
                    s24 = rightSupply s23
                    s19 = leftSupply s24
                    s21 = rightSupply s24
  in s22 `seq` (s24 `seq` (s19 `seq` (s21 `seq` choice (let s18 = leftSupply s19
                                                            s20 = rightSupply
                                                              s19
                                                            s15 = leftSupply s20
                                                            s17 = rightSupply
                                                              s20
  in s18 `seq` (s20 `seq` (s15 `seq` (s17 `seq` choice (let s14 = leftSupply s15
                                                            s16 = rightSupply
                                                              s15
                                                            s11 = leftSupply s16
                                                            s13 = rightSupply
                                                              s16
  in s14 `seq` (s16 `seq` (s11 `seq` (s13 `seq` choice (let s10 = leftSupply s11
                                                            s12 = rightSupply
                                                              s11
                                                            s7 = leftSupply s12
                                                            s9 = rightSupply s12
  in s10 `seq` (s12 `seq` (s7 `seq` (s9 `seq` choice (let s6 = leftSupply s7
                                                          s8 = rightSupply s7
                                                          s3 = leftSupply s8
                                                          s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` choice (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` choice (C_SmallComment
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)) (C_BigComment
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s1 cd cs)) s2 cd cs)))) (C_Text
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s5 cd cs)) s6 cd cs)))) (C_Letter
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s9 cd cs)) s10 cd cs)))) (C_Code
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s13 cd cs)) s14 cd cs)))) (C_ModuleHead
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s17 cd cs)) s18 cd cs)))) (C_Meta
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s21 cd cs)) s22 cd cs))))

d_C_isSmallComment :: C_Token -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isSmallComment x1 cd cs = let x2 = Curry_Prelude.C_False
  in d_C__case_78 x2 x1 cd cs

d_C_isBigComment :: C_Token -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isBigComment x1 cd cs = let x2 = Curry_Prelude.C_False
  in d_C__case_77 x2 x1 cd cs

d_C_isComment :: C_Token -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isComment x1 cd cs = Curry_Prelude.d_OP_bar_bar (d_C_isSmallComment x1 cd
  cs) (d_C_isBigComment x1 cd cs) cd cs

d_C_isText :: C_Token -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isText x1 cd cs = let x2 = Curry_Prelude.C_False in d_C__case_76 x2 x1 cd cs

d_C_isLetter :: C_Token -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isLetter x1 cd cs = let x2 = Curry_Prelude.C_False
  in d_C__case_75 x2 x1 cd cs

d_C_isCode :: C_Token -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isCode x1 cd cs = let x2 = Curry_Prelude.C_False in d_C__case_74 x2 x1 cd cs

d_C_isModuleHead :: C_Token -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isModuleHead x1 cd cs = let x2 = Curry_Prelude.C_False
  in d_C__case_73 x2 x1 cd cs

d_C_isMeta :: C_Token -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isMeta x1 cd cs = let x2 = Curry_Prelude.C_False in d_C__case_72 x2 x1 cd cs

d_C_weaveIntoCode :: (Curry_Prelude.OP_List C_Token -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token) -> Curry_Prelude.OP_List C_Token -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
d_C_weaveIntoCode x1 x2 cd cs = let x3 = d_C_unweaveCode x2 cd cs
                                    x4 = d_OP_weaveIntoCode_dot_uscore_hash_selFP2_hash_cs
                                      x3 cd cs
                                    x5 = d_OP_weaveIntoCode_dot_uscore_hash_selFP3_hash_ncs
                                      x3 cd cs
  in d_C_weave (Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_apply x1 x4 cd cs)
  x5) cd cs

nd_C_weaveIntoCode :: Func (Curry_Prelude.OP_List C_Token)
  (Curry_Prelude.OP_List C_Token) -> Curry_Prelude.OP_List C_Token -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C_weaveIntoCode x1 x2 s cd cs = let s0 = s
  in s0 `seq` (let x3 = d_C_unweaveCode x2 cd cs
                   x4 = d_OP_weaveIntoCode_dot_uscore_hash_selFP2_hash_cs x3 cd
                     cs
                   x5 = d_OP_weaveIntoCode_dot_uscore_hash_selFP3_hash_ncs x3 cd
                     cs
  in d_C_weave (Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_apply x1 x4 s0 cd
  cs) x5) cd cs)

d_OP_weaveIntoCode_dot_uscore_hash_selFP2_hash_cs :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List C_Token) (Curry_Prelude.OP_List C_Token) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
d_OP_weaveIntoCode_dot_uscore_hash_selFP2_hash_cs x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_weaveIntoCode_dot_uscore_hash_selFP2_hash_cs l cd cs)
    (d_OP_weaveIntoCode_dot_uscore_hash_selFP2_hash_cs r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_weaveIntoCode_dot_uscore_hash_selFP2_hash_cs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_weaveIntoCode_dot_uscore_hash_selFP2_hash_cs e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.StringClassifier.weaveIntoCode._#selFP2#cs" [show x1] info)
  _ -> failCons cd (consFail
    "Language.Curry.StringClassifier.weaveIntoCode._#selFP2#cs" (showCons x1))

d_OP_weaveIntoCode_dot_uscore_hash_selFP3_hash_ncs :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List C_Token) (Curry_Prelude.OP_List C_Token) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
d_OP_weaveIntoCode_dot_uscore_hash_selFP3_hash_ncs x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_weaveIntoCode_dot_uscore_hash_selFP3_hash_ncs l cd cs)
    (d_OP_weaveIntoCode_dot_uscore_hash_selFP3_hash_ncs r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_weaveIntoCode_dot_uscore_hash_selFP3_hash_ncs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_weaveIntoCode_dot_uscore_hash_selFP3_hash_ncs e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.StringClassifier.weaveIntoCode._#selFP3#ncs" [show x1] info)
  _ -> failCons cd (consFail
    "Language.Curry.StringClassifier.weaveIntoCode._#selFP3#ncs" (showCons x1))

d_C_unweaveCode :: Curry_Prelude.OP_List C_Token -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List C_Token)
  (Curry_Prelude.OP_List C_Token)
d_C_unweaveCode x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> let x4 = d_C_unweaveCode x3 cd cs
                                     x5 = d_OP_unweaveCode_dot_uscore_hash_selFP5_hash_cs
                                       x4 cd cs
                                     x6 = d_OP_unweaveCode_dot_uscore_hash_selFP6_hash_ncs
                                       x4 cd cs
    in d_C__case_71 x2 x6 x5 (d_C_isCode x2 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_unweaveCode l cd cs)
    (d_C_unweaveCode r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_unweaveCode
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_unweaveCode e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier.unweaveCode" [show x1] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier.unweaveCode"
    (showCons x1))

d_OP_unweaveCode_dot_uscore_hash_selFP5_hash_cs :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List C_Token) (Curry_Prelude.OP_List C_Token) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
d_OP_unweaveCode_dot_uscore_hash_selFP5_hash_cs x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_unweaveCode_dot_uscore_hash_selFP5_hash_cs l cd cs)
    (d_OP_unweaveCode_dot_uscore_hash_selFP5_hash_cs r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_unweaveCode_dot_uscore_hash_selFP5_hash_cs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_unweaveCode_dot_uscore_hash_selFP5_hash_cs e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.StringClassifier.unweaveCode._#selFP5#cs" [show x1] info)
  _ -> failCons cd (consFail
    "Language.Curry.StringClassifier.unweaveCode._#selFP5#cs" (showCons x1))

d_OP_unweaveCode_dot_uscore_hash_selFP6_hash_ncs :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List C_Token) (Curry_Prelude.OP_List C_Token) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
d_OP_unweaveCode_dot_uscore_hash_selFP6_hash_ncs x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_unweaveCode_dot_uscore_hash_selFP6_hash_ncs l cd cs)
    (d_OP_unweaveCode_dot_uscore_hash_selFP6_hash_ncs r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_unweaveCode_dot_uscore_hash_selFP6_hash_ncs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_unweaveCode_dot_uscore_hash_selFP6_hash_ncs e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.StringClassifier.unweaveCode._#selFP6#ncs" [show x1] info)
  _ -> failCons cd (consFail
    "Language.Curry.StringClassifier.unweaveCode._#selFP6#ncs" (showCons x1))

d_C_weave :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C_weave x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_70 x3 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_weave l cd cs)
    (d_C_weave r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_weave z cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C_weave e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.StringClassifier.weave" [show x1] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier.weave" (showCons
    x1))

nd_C_scan :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C_scan x1 s cd cs = let s4 = s
  in s4 `seq` (let s0 = leftSupply s4
                   s3 = rightSupply s4
  in s0 `seq` (s3 `seq` (let x2 = generate s0 cd
  in let s2 = leftSupply s3
         s1 = rightSupply s3
  in s2 `seq` (s1 `seq` nd_C_modHead (wrapDX id Curry_Prelude.d_C_id)
  (nd_C_stateScan (Curry_Prelude.C_Int (1)) (C_Code x2) x2 x1 s1 cd cs) s2 cd
  cs))))

nd_C_stateScan :: Curry_Prelude.C_Int -> C_Token -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C_stateScan x1 x2 x3 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> d_C__case_64 x3 x2 (Curry_Prelude.d_OP_eq_colon_eq x3
    Curry_Prelude.OP_List cd cs) cd cs
  Curry_Prelude.OP_Cons x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_63 x6 x5 x1 x3 x2 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_stateScan x1 x2 x3 l
    s cd cs) (nd_C_stateScan x1 x2 x3 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_stateScan
    x1 x2 x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_stateScan x1
    x2 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier.stateScan" [show x1, show x2, show x3, show
    x4] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier.stateScan"
    (showCons x4))

d_OP_stateScan_dot_uscore_hash_selFP8_hash_comment :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_stateScan_dot_uscore_hash_selFP8_hash_comment x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_stateScan_dot_uscore_hash_selFP8_hash_comment l cd cs)
    (d_OP_stateScan_dot_uscore_hash_selFP8_hash_comment r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_stateScan_dot_uscore_hash_selFP8_hash_comment z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_stateScan_dot_uscore_hash_selFP8_hash_comment e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.StringClassifier.stateScan._#selFP8#comment" [show x1] info)
  _ -> failCons cd (consFail
    "Language.Curry.StringClassifier.stateScan._#selFP8#comment" (showCons x1))

d_OP_stateScan_dot_uscore_hash_selFP9_hash_rest :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_stateScan_dot_uscore_hash_selFP9_hash_rest x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_stateScan_dot_uscore_hash_selFP9_hash_rest l cd cs)
    (d_OP_stateScan_dot_uscore_hash_selFP9_hash_rest r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_stateScan_dot_uscore_hash_selFP9_hash_rest z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_stateScan_dot_uscore_hash_selFP9_hash_rest e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.StringClassifier.stateScan._#selFP9#rest" [show x1] info)
  _ -> failCons cd (consFail
    "Language.Curry.StringClassifier.stateScan._#selFP9#rest" (showCons x1))

d_C_modHead :: (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List C_Token -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
d_C_modHead x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_21 x4 x1 x3 cd cs
  Curry_Prelude.OP_List -> d_C_maybeMo (Curry_Prelude.d_C_apply x1
    Curry_Prelude.OP_List cd cs) Curry_Prelude.OP_List cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_modHead x1 l cd cs)
    (d_C_modHead x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_modHead x1 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_modHead x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier.modHead" [show x1, show x2] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier.modHead" (showCons
    x2))

nd_C_modHead :: Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List C_Token
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C_modHead x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> let s0 = s
    in s0 `seq` nd_C__case_21 x4 x1 x3 s0 cd cs
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` d_C_maybeMo (Curry_Prelude.nd_C_apply x1 Curry_Prelude.OP_List
    s0 cd cs) Curry_Prelude.OP_List cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_modHead x1 l s cd cs)
    (nd_C_modHead x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_modHead x1
    z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_modHead x1 e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier.modHead" [show x1, show x2] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier.modHead" (showCons
    x2))

d_OP_modHead_dot_uscore_hash_lambda10 :: Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_modHead_dot_uscore_hash_lambda10 x1 cd cs = Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.C_Char '\n'#) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.C_Char '\r'#) cd cs) cd cs

d_C_modHeadInLine :: (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List C_Token -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
d_C_modHeadInLine x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> d_C_maybeMo (Curry_Prelude.d_C_apply x1
    Curry_Prelude.OP_List cd cs) Curry_Prelude.OP_List cd cs
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_14 x4 x1 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_modHeadInLine x1 l cd
    cs) (d_C_modHeadInLine x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_modHeadInLine x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_modHeadInLine
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier.modHeadInLine" [show x1, show x2] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier.modHeadInLine"
    (showCons x2))

nd_C_modHeadInLine :: Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List C_Token
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C_modHeadInLine x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` d_C_maybeMo (Curry_Prelude.nd_C_apply x1 Curry_Prelude.OP_List
    s0 cd cs) Curry_Prelude.OP_List cd cs
  Curry_Prelude.OP_Cons x3 x4 -> let s0 = s
    in s0 `seq` nd_C__case_14 x4 x1 x3 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_modHeadInLine x1 l s
    cd cs) (nd_C_modHeadInLine x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_C_modHeadInLine x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_modHeadInLine
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier.modHeadInLine" [show x1, show x2] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier.modHeadInLine"
    (showCons x2))

d_OP_modHeadInLine_dot_uscore_hash_lambda12 :: Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_modHeadInLine_dot_uscore_hash_lambda12 x1 cd cs =
  Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.C_Char '\n'#) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.C_Char '\r'#) cd cs) cd cs

d_C_headers :: Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_headers cd cs = Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString " ")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "import")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "infix")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "infixl")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "infixr")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "module")
  Curry_Prelude.OP_List)))))

d_C_lineBeginsWith :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_lineBeginsWith x1 x2 cd cs = let x3 = Curry_Prelude.d_C_length x2 cd cs
  in d_C__case_11 x3 x1 x2 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) (Curry_Prelude.d_C_length x1 cd cs) cd cs) x3 cd cs) cd cs

d_OP_lineBeginsWith_dot_uscore_hash_selFP11_hash_s_tick :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_lineBeginsWith_dot_uscore_hash_selFP11_hash_s_tick x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_lineBeginsWith_dot_uscore_hash_selFP11_hash_s_tick l cd cs)
    (d_OP_lineBeginsWith_dot_uscore_hash_selFP11_hash_s_tick r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_lineBeginsWith_dot_uscore_hash_selFP11_hash_s_tick z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_lineBeginsWith_dot_uscore_hash_selFP11_hash_s_tick e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.StringClassifier.lineBeginsWith._#selFP11#s'" [show x1]
    info)
  _ -> failCons cd (consFail
    "Language.Curry.StringClassifier.lineBeginsWith._#selFP11#s'" (showCons x1))

d_OP_lineBeginsWith_dot_uscore_hash_selFP12_hash_rest :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_lineBeginsWith_dot_uscore_hash_selFP12_hash_rest x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_lineBeginsWith_dot_uscore_hash_selFP12_hash_rest l cd cs)
    (d_OP_lineBeginsWith_dot_uscore_hash_selFP12_hash_rest r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_lineBeginsWith_dot_uscore_hash_selFP12_hash_rest z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_lineBeginsWith_dot_uscore_hash_selFP12_hash_rest e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.StringClassifier.lineBeginsWith._#selFP12#rest" [show x1]
    info)
  _ -> failCons cd (consFail
    "Language.Curry.StringClassifier.lineBeginsWith._#selFP12#rest" (showCons
    x1))

d_C_isSep :: Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isSep x1 cd cs = Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_C_isSpace x1 cd
  cs) (Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_elem
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 cd cs) (d_C_infixIDs cd cs) cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_elem
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 cd cs) (Curry_Prelude.toCurryString "([{") cd cs) cd cs) cd cs

d_C_infixIDs :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_infixIDs cd cs = Curry_Prelude.toCurryString "~!@#$%^&*+-=<>?./|\\:"

d_C_delimiters :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_delimiters cd cs = Curry_Prelude.toCurryString " ([{,}])"

d_C_toBeEscaped :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_toBeEscaped cd cs = Curry_Prelude.toCurryString "\\\n\r\t\""

d_C_maybeCode :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_Token -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
d_C_maybeCode x1 x2 cd cs = Curry_Prelude.OP_Cons (C_Code x1) x2

d_C_maybeMo :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_Token -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
d_C_maybeMo x1 x2 cd cs = d_C__case_9 x1 x2
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 Curry_Prelude.OP_List cd cs) cd cs

d_C_plainCode :: Curry_Prelude.OP_List C_Token -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_plainCode x1 cd cs = case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_6 x3 x2 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_plainCode l cd cs)
    (d_C_plainCode r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_plainCode z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_plainCode e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier.plainCode" [show x1] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier.plainCode"
    (showCons x1))

d_C_unscan :: Curry_Prelude.OP_List C_Token -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_unscan x1 cd cs = case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_3 x3 x2 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_unscan l cd cs)
    (d_C_unscan r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_unscan z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_unscan e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier.unscan" [show x1] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier.unscan" (showCons
    x1))

nd_C_readScan :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List C_Token)
nd_C_readScan x1 s cd cs = let s7 = s
  in s7 `seq` (let s6 = leftSupply s7
                   s8 = rightSupply s7
                   s2 = leftSupply s8
                   s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s2 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (Curry_Prelude.d_C_readFile x1 cd cs) s1 cd cs))
  (let s4 = leftSupply s5
       s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_OP_dot
  (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s3 cd cs) (wrapNX id nd_C_scan) s4 cd cs)) s6 cd cs))))

nd_C_testScan :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_C_testScan x1 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (Curry_Prelude.d_C_readFile x1 cd cs) s1 cd cs)) (wrapNX id
  nd_OP_testScan_dot_uscore_hash_lambda18) s3 cd cs))

nd_OP_testScan_dot_uscore_hash_lambda18 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
nd_OP_testScan_dot_uscore_hash_lambda18 x1 s cd cs = let s5 = s
  in s5 `seq` (let x2 = x1
  in let s4 = leftSupply s5
         s6 = rightSupply s5
         s0 = leftSupply s6
         s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_C_print (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Bool_hash)
  s0 cd cs) (let s2 = leftSupply s3
                 s1 = rightSupply s3
  in s2 `seq` (s1 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (d_C_unscan (nd_C_scan x2 s1 cd cs) cd cs) x2 s2 cd cs)) s4 cd cs))))

nd_C_testWeave :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_C_testWeave x1 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (Curry_Prelude.d_C_readFile x1 cd cs) s1 cd cs)) (wrapNX id
  nd_OP_testWeave_dot_uscore_hash_lambda21) s3 cd cs))

nd_OP_testWeave_dot_uscore_hash_lambda21 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
nd_OP_testWeave_dot_uscore_hash_lambda21 x1 s cd cs = let s5 = s
  in s5 `seq` (let x2 = x1
  in let s4 = leftSupply s5
         s6 = rightSupply s5
         s0 = leftSupply s6
         s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_C_print (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Bool_hash)
  s0 cd cs) (let s2 = leftSupply s3
                 s1 = rightSupply s3
  in s2 `seq` (s1 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (d_C_unscan (d_C_weave (d_C_unweaveCode (nd_C_scan x2 s1 cd cs) cd cs) cd cs)
  cd cs) x2 s2 cd cs)) s4 cd cs))))

nd_C__case_79 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Token
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_79 x51 x2 s cd cs = case x2 of
  C_SmallComment x52 -> Curry_Prelude.C_False
  C_BigComment x53 -> Curry_Prelude.C_False
  C_Text x54 -> Curry_Prelude.C_False
  C_Letter x55 -> Curry_Prelude.C_False
  C_Code x56 -> Curry_Prelude.C_False
  C_ModuleHead x57 -> Curry_Prelude.C_False
  C_Meta x58 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x51 x58 s0 cd cs
  Choice_C_Token d i l r -> narrow d i (nd_C__case_79 x51 l s cd cs)
    (nd_C__case_79 x51 r s cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> nd_C__case_79 x51 z s cd cs)
    xs
  Guard_C_Token d c e -> guardCons d c ((\x -> nd_C__case_79 x51 e s cd x) $!
    addCs c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_79" [show x51, show x2] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_79"
    (showCons x2))

nd_C__case_80 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Token
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_80 x43 x2 s cd cs = case x2 of
  C_SmallComment x44 -> Curry_Prelude.C_False
  C_BigComment x45 -> Curry_Prelude.C_False
  C_Text x46 -> Curry_Prelude.C_False
  C_Letter x47 -> Curry_Prelude.C_False
  C_Code x48 -> Curry_Prelude.C_False
  C_ModuleHead x49 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x43 x49 s0 cd cs
  C_Meta x50 -> Curry_Prelude.C_False
  Choice_C_Token d i l r -> narrow d i (nd_C__case_80 x43 l s cd cs)
    (nd_C__case_80 x43 r s cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> nd_C__case_80 x43 z s cd cs)
    xs
  Guard_C_Token d c e -> guardCons d c ((\x -> nd_C__case_80 x43 e s cd x) $!
    addCs c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_80" [show x43, show x2] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_80"
    (showCons x2))

nd_C__case_81 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Token
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_81 x35 x2 s cd cs = case x2 of
  C_SmallComment x36 -> Curry_Prelude.C_False
  C_BigComment x37 -> Curry_Prelude.C_False
  C_Text x38 -> Curry_Prelude.C_False
  C_Letter x39 -> Curry_Prelude.C_False
  C_Code x40 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x35 x40 s0 cd cs
  C_ModuleHead x41 -> Curry_Prelude.C_False
  C_Meta x42 -> Curry_Prelude.C_False
  Choice_C_Token d i l r -> narrow d i (nd_C__case_81 x35 l s cd cs)
    (nd_C__case_81 x35 r s cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> nd_C__case_81 x35 z s cd cs)
    xs
  Guard_C_Token d c e -> guardCons d c ((\x -> nd_C__case_81 x35 e s cd x) $!
    addCs c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_81" [show x35, show x2] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_81"
    (showCons x2))

nd_C__case_82 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Token
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_82 x27 x2 s cd cs = case x2 of
  C_SmallComment x28 -> Curry_Prelude.C_False
  C_BigComment x29 -> Curry_Prelude.C_False
  C_Text x30 -> Curry_Prelude.C_False
  C_Letter x31 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x27 x31 s0 cd cs
  C_Code x32 -> Curry_Prelude.C_False
  C_ModuleHead x33 -> Curry_Prelude.C_False
  C_Meta x34 -> Curry_Prelude.C_False
  Choice_C_Token d i l r -> narrow d i (nd_C__case_82 x27 l s cd cs)
    (nd_C__case_82 x27 r s cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> nd_C__case_82 x27 z s cd cs)
    xs
  Guard_C_Token d c e -> guardCons d c ((\x -> nd_C__case_82 x27 e s cd x) $!
    addCs c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_82" [show x27, show x2] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_82"
    (showCons x2))

nd_C__case_83 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Token
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_83 x19 x2 s cd cs = case x2 of
  C_SmallComment x20 -> Curry_Prelude.C_False
  C_BigComment x21 -> Curry_Prelude.C_False
  C_Text x22 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x19 x22 s0 cd cs
  C_Letter x23 -> Curry_Prelude.C_False
  C_Code x24 -> Curry_Prelude.C_False
  C_ModuleHead x25 -> Curry_Prelude.C_False
  C_Meta x26 -> Curry_Prelude.C_False
  Choice_C_Token d i l r -> narrow d i (nd_C__case_83 x19 l s cd cs)
    (nd_C__case_83 x19 r s cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> nd_C__case_83 x19 z s cd cs)
    xs
  Guard_C_Token d c e -> guardCons d c ((\x -> nd_C__case_83 x19 e s cd x) $!
    addCs c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_83" [show x19, show x2] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_83"
    (showCons x2))

nd_C__case_84 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Token
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_84 x11 x2 s cd cs = case x2 of
  C_SmallComment x12 -> Curry_Prelude.C_False
  C_BigComment x13 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x11 x13 s0 cd cs
  C_Text x14 -> Curry_Prelude.C_False
  C_Letter x15 -> Curry_Prelude.C_False
  C_Code x16 -> Curry_Prelude.C_False
  C_ModuleHead x17 -> Curry_Prelude.C_False
  C_Meta x18 -> Curry_Prelude.C_False
  Choice_C_Token d i l r -> narrow d i (nd_C__case_84 x11 l s cd cs)
    (nd_C__case_84 x11 r s cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> nd_C__case_84 x11 z s cd cs)
    xs
  Guard_C_Token d c e -> guardCons d c ((\x -> nd_C__case_84 x11 e s cd x) $!
    addCs c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_84" [show x11, show x2] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_84"
    (showCons x2))

nd_C__case_85 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Token
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_85 x3 x2 s cd cs = case x2 of
  C_SmallComment x4 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x4 s0 cd cs
  C_BigComment x5 -> Curry_Prelude.C_False
  C_Text x6 -> Curry_Prelude.C_False
  C_Letter x7 -> Curry_Prelude.C_False
  C_Code x8 -> Curry_Prelude.C_False
  C_ModuleHead x9 -> Curry_Prelude.C_False
  C_Meta x10 -> Curry_Prelude.C_False
  Choice_C_Token d i l r -> narrow d i (nd_C__case_85 x3 l s cd cs)
    (nd_C__case_85 x3 r s cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> nd_C__case_85 x3 z s cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> nd_C__case_85 x3 e s cd x) $!
    addCs c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_85" [show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_85"
    (showCons x2))

d_C__case_78 :: Curry_Prelude.C_Bool -> C_Token -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_78 x2 x1 cd cs = case x1 of
  C_SmallComment x3 -> Curry_Prelude.C_True
  C_BigComment x4 -> x2
  C_Text x5 -> x2
  C_Letter x6 -> x2
  C_Code x7 -> x2
  C_ModuleHead x8 -> x2
  C_Meta x9 -> x2
  Choice_C_Token d i l r -> narrow d i (d_C__case_78 x2 l cd cs) (d_C__case_78
    x2 r cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_78 x2 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_78 x2 e cd x) $! addCs
    c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_78" [show x2, show x1] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_78"
    (showCons x1))

d_C__case_77 :: Curry_Prelude.C_Bool -> C_Token -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_77 x2 x1 cd cs = case x1 of
  C_BigComment x3 -> Curry_Prelude.C_True
  C_SmallComment x4 -> x2
  C_Text x5 -> x2
  C_Letter x6 -> x2
  C_Code x7 -> x2
  C_ModuleHead x8 -> x2
  C_Meta x9 -> x2
  Choice_C_Token d i l r -> narrow d i (d_C__case_77 x2 l cd cs) (d_C__case_77
    x2 r cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_77 x2 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_77 x2 e cd x) $! addCs
    c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_77" [show x2, show x1] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_77"
    (showCons x1))

d_C__case_76 :: Curry_Prelude.C_Bool -> C_Token -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_76 x2 x1 cd cs = case x1 of
  C_Text x3 -> Curry_Prelude.C_True
  C_SmallComment x4 -> x2
  C_BigComment x5 -> x2
  C_Letter x6 -> x2
  C_Code x7 -> x2
  C_ModuleHead x8 -> x2
  C_Meta x9 -> x2
  Choice_C_Token d i l r -> narrow d i (d_C__case_76 x2 l cd cs) (d_C__case_76
    x2 r cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_76 x2 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_76 x2 e cd x) $! addCs
    c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_76" [show x2, show x1] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_76"
    (showCons x1))

d_C__case_75 :: Curry_Prelude.C_Bool -> C_Token -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_75 x2 x1 cd cs = case x1 of
  C_Letter x3 -> Curry_Prelude.C_True
  C_SmallComment x4 -> x2
  C_BigComment x5 -> x2
  C_Text x6 -> x2
  C_Code x7 -> x2
  C_ModuleHead x8 -> x2
  C_Meta x9 -> x2
  Choice_C_Token d i l r -> narrow d i (d_C__case_75 x2 l cd cs) (d_C__case_75
    x2 r cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_75 x2 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_75 x2 e cd x) $! addCs
    c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_75" [show x2, show x1] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_75"
    (showCons x1))

d_C__case_74 :: Curry_Prelude.C_Bool -> C_Token -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_74 x2 x1 cd cs = case x1 of
  C_Code x3 -> Curry_Prelude.C_True
  C_SmallComment x4 -> x2
  C_BigComment x5 -> x2
  C_Text x6 -> x2
  C_Letter x7 -> x2
  C_ModuleHead x8 -> x2
  C_Meta x9 -> x2
  Choice_C_Token d i l r -> narrow d i (d_C__case_74 x2 l cd cs) (d_C__case_74
    x2 r cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_74 x2 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_74 x2 e cd x) $! addCs
    c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_74" [show x2, show x1] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_74"
    (showCons x1))

d_C__case_73 :: Curry_Prelude.C_Bool -> C_Token -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_73 x2 x1 cd cs = case x1 of
  C_ModuleHead x3 -> Curry_Prelude.C_True
  C_SmallComment x4 -> x2
  C_BigComment x5 -> x2
  C_Text x6 -> x2
  C_Letter x7 -> x2
  C_Code x8 -> x2
  C_Meta x9 -> x2
  Choice_C_Token d i l r -> narrow d i (d_C__case_73 x2 l cd cs) (d_C__case_73
    x2 r cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_73 x2 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_73 x2 e cd x) $! addCs
    c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_73" [show x2, show x1] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_73"
    (showCons x1))

d_C__case_72 :: Curry_Prelude.C_Bool -> C_Token -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_72 x2 x1 cd cs = case x1 of
  C_Meta x3 -> Curry_Prelude.C_True
  C_SmallComment x4 -> x2
  C_BigComment x5 -> x2
  C_Text x6 -> x2
  C_Letter x7 -> x2
  C_Code x8 -> x2
  C_ModuleHead x9 -> x2
  Choice_C_Token d i l r -> narrow d i (d_C__case_72 x2 l cd cs) (d_C__case_72
    x2 r cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_72 x2 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_72 x2 e cd x) $! addCs
    c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_72" [show x2, show x1] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_72"
    (showCons x1))

d_C__case_71 :: C_Token -> Curry_Prelude.OP_List C_Token
  -> Curry_Prelude.OP_List C_Token -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List C_Token)
  (Curry_Prelude.OP_List C_Token)
d_C__case_71 x2 x6 x5 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons x2 x5)
    x6
  Curry_Prelude.C_False -> Curry_Prelude.OP_Tuple2 x5 (Curry_Prelude.OP_Cons x2
    x6)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_71 x2 x6 x5 l cd
    cs) (d_C__case_71 x2 x6 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_71 x2
    x6 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_71 x2 x6
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_71" [show x2, show x6, show x5, show
    x7] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_71"
    (showCons x7))

d_C__case_70 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_70 x3 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> d_C__case_69 x3 cd cs
  Curry_Prelude.OP_Cons x8 x9 -> d_C__case_67 x3 x8 x9 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_70 x3 l cd cs)
    (d_C__case_70 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_70 x3
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_70 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_70" [show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_70"
    (showCons x2))

d_C__case_67 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> t0 -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C__case_67 x3 x8 x9 cd cs = case x9 of
  Curry_Prelude.OP_List -> d_C__case_66 x9 x8 x3 cd cs
  Curry_Prelude.OP_Cons x12 x13 -> d_C__case_65 x9 x8 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_67 x3 x8 l cd
    cs) (d_C__case_67 x3 x8 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_67 x3
    x8 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_67 x3 x8
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_67" [show x3, show x8, show x9] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_67"
    (showCons x9))

d_C__case_65 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> t0 -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C__case_65 x9 x8 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x14 x15 -> Curry_Prelude.OP_Cons x8
    (Curry_Prelude.OP_Cons x14 (d_C_weave (Curry_Prelude.OP_Tuple2 x9 x15) cd
    cs))
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_65 x9 x8 l cd
    cs) (d_C__case_65 x9 x8 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_65 x9
    x8 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_65 x9 x8
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_65" [show x9, show x8, show x3] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_65"
    (showCons x3))

d_C__case_66 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> t0 -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C__case_66 x9 x8 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons x8 Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x10 x11 -> Curry_Prelude.OP_Cons x8
    (Curry_Prelude.OP_Cons x10 (d_C_weave (Curry_Prelude.OP_Tuple2 x9 x11) cd
    cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_66 x9 x8 l cd
    cs) (d_C__case_66 x9 x8 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_66 x9
    x8 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_66 x9 x8
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_66" [show x9, show x8, show x3] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_66"
    (showCons x3))

d_C__case_69 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_69 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_68 x4 x5 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_69 l cd cs)
    (d_C__case_69 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_69 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_69 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_69" [show x3] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_69"
    (showCons x3))

d_C__case_68 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_68 x4 x5 cd cs = case x5 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons x4 Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x6 x7 -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_68 x4 l cd cs)
    (d_C__case_68 x4 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_68 x4
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_68 x4 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_68" [show x4, show x5] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_68"
    (showCons x5))

nd_C__case_63 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_Token -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_63 x6 x5 x1 x3 x2 s cd cs = case x2 of
  C_Code x7 -> let s0 = s in s0 `seq` nd_C__case_62 x5 x7 x1 x3 x6 s0 cd cs
  C_Text x26 -> let s0 = s in s0 `seq` nd_C__case_38 x5 x26 x1 x3 x6 s0 cd cs
  C_BigComment x30 -> let s0 = s
    in s0 `seq` nd_C__case_31 x5 x30 x1 x3 x6 s0 cd cs
  C_Meta x34 -> let s0 = s in s0 `seq` nd_C__case_26 x5 x34 x1 x3 x6 s0 cd cs
  C_SmallComment x38 -> Curry_Prelude.d_C_failed cd cs
  C_Letter x39 -> Curry_Prelude.d_C_failed cd cs
  C_ModuleHead x40 -> Curry_Prelude.d_C_failed cd cs
  Choice_C_Token d i l r -> narrow d i (nd_C__case_63 x6 x5 x1 x3 l s cd cs)
    (nd_C__case_63 x6 x5 x1 x3 r s cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> nd_C__case_63 x6 x5 x1 x3 z s
    cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> nd_C__case_63 x6 x5 x1 x3 e s cd
    x) $! addCs c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_63" [show x6, show x5, show x1, show
    x3, show x2] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_63"
    (showCons x2))

nd_C__case_26 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_26 x5 x34 x1 x3 x6 s cd cs = case x6 of
  Curry_Prelude.OP_List -> d_C__case_25 x3 (Curry_Prelude.d_OP_eq_colon_eq x3
    Curry_Prelude.OP_List cd cs) cd cs
  Curry_Prelude.OP_Cons x35 x36 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` (let x37 = generate s0 cd
    in nd_C__case_24 x35 x5 x36 x37 x34 x1 x3 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x5 (Curry_Prelude.C_Char '+'#) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x35 (Curry_Prelude.C_Char '}'#) cd cs) cd cs) s1 cd cs)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_26 x5 x34 x1 x3
    l s cd cs) (nd_C__case_26 x5 x34 x1 x3 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_26 x5
    x34 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_26 x5
    x34 x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_26" [show x5, show x34, show x1, show
    x3, show x6] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_26"
    (showCons x6))

nd_C__case_24 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_24 x35 x5 x36 x37 x34 x1 x3 x38 s cd cs = case x38 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_amp_gt (Curry_Prelude.d_OP_eq_colon_eq x3
    Curry_Prelude.OP_List cd cs) (Curry_Prelude.OP_Cons (C_Meta x34)
    (nd_C_stateScan x1 (C_Code x37) x37 x36 s0 cd cs)) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_23 x5 x36 x35 x37 x34 x1 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x5 (Curry_Prelude.C_Char '\n'#) cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_24 x35 x5 x36
    x37 x34 x1 x3 l s cd cs) (nd_C__case_24 x35 x5 x36 x37 x34 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_24 x35
    x5 x36 x37 x34 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_24 x35 x5
    x36 x37 x34 x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_24" [show x35, show x5, show x36
    , show x37, show x34, show x1, show x3, show x38] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_24"
    (showCons x38))

nd_C__case_23 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_23 x5 x36 x35 x37 x34 x1 x3 x38 s cd cs = case x38 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_amp_gt (Curry_Prelude.d_OP_eq_colon_eq x3
    (Curry_Prelude.OP_Cons x5 x37) cd cs) (nd_C_stateScan
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 (Curry_Prelude.C_Int (1)) cd cs) (C_Meta x34) x37 (Curry_Prelude.OP_Cons
    x35 x36) s0 cd cs) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_22 x36 x35 x37 x34 x1 x5 x3
    (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_23 x5 x36 x35
    x37 x34 x1 x3 l s cd cs) (nd_C__case_23 x5 x36 x35 x37 x34 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_23 x5
    x36 x35 x37 x34 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_23 x5 x36
    x35 x37 x34 x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_23" [show x5, show x36, show x35
    , show x37, show x34, show x1, show x3, show x38] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_23"
    (showCons x38))

nd_C__case_22 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_22 x36 x35 x37 x34 x1 x5 x3 x38 s cd cs = case x38 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_amp_gt (Curry_Prelude.d_OP_eq_colon_eq x3
    (Curry_Prelude.OP_Cons x5 x37) cd cs) (nd_C_stateScan x1 (C_Meta x34) x37
    (Curry_Prelude.OP_Cons x35 x36) s0 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_22 x36 x35 x37
    x34 x1 x5 x3 l s cd cs) (nd_C__case_22 x36 x35 x37 x34 x1 x5 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_22 x36
    x35 x37 x34 x1 x5 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_22 x36
    x35 x37 x34 x1 x5 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_22" [show x36, show x35, show x37
    , show x34, show x1, show x5, show x3, show x38] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_22"
    (showCons x38))

d_C__case_25 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Token
d_C__case_25 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "File ended while expecting +}") cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_25 x3 l cd cs)
    (d_C__case_25 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_25 x3 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_25 x3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_25" [show x3, show x4] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_25"
    (showCons x4))

nd_C__case_31 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_31 x5 x30 x1 x3 x6 s cd cs = case x6 of
  Curry_Prelude.OP_List -> d_C__case_30 x3 (Curry_Prelude.d_OP_eq_colon_eq x3
    Curry_Prelude.OP_List cd cs) cd cs
  Curry_Prelude.OP_Cons x31 x32 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` (let x33 = generate s0 cd
    in nd_C__case_29 x31 x5 x32 x33 x30 x1 x3 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x5 (Curry_Prelude.C_Char '-'#) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x31 (Curry_Prelude.C_Char '}'#) cd cs) cd cs) s1 cd cs)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_31 x5 x30 x1 x3
    l s cd cs) (nd_C__case_31 x5 x30 x1 x3 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_31 x5
    x30 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_31 x5
    x30 x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_31" [show x5, show x30, show x1, show
    x3, show x6] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_31"
    (showCons x6))

nd_C__case_29 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_29 x31 x5 x32 x33 x30 x1 x3 x34 s cd cs = case x34 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_amp_gt (Curry_Prelude.d_OP_eq_colon_eq x3
    Curry_Prelude.OP_List cd cs) (Curry_Prelude.OP_Cons (C_BigComment x30)
    (nd_C_stateScan x1 (C_Code x33) x33 x32 s0 cd cs)) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_28 x5 x32 x31 x33 x30 x1 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x5 (Curry_Prelude.C_Char '\n'#) cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_29 x31 x5 x32
    x33 x30 x1 x3 l s cd cs) (nd_C__case_29 x31 x5 x32 x33 x30 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_29 x31
    x5 x32 x33 x30 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_29 x31 x5
    x32 x33 x30 x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_29" [show x31, show x5, show x32
    , show x33, show x30, show x1, show x3, show x34] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_29"
    (showCons x34))

nd_C__case_28 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_28 x5 x32 x31 x33 x30 x1 x3 x34 s cd cs = case x34 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_amp_gt (Curry_Prelude.d_OP_eq_colon_eq x3
    (Curry_Prelude.OP_Cons x5 x33) cd cs) (nd_C_stateScan
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 (Curry_Prelude.C_Int (1)) cd cs) (C_BigComment x30) x33
    (Curry_Prelude.OP_Cons x31 x32) s0 cd cs) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_27 x32 x31 x33 x30 x1 x5 x3
    (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_28 x5 x32 x31
    x33 x30 x1 x3 l s cd cs) (nd_C__case_28 x5 x32 x31 x33 x30 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_28 x5
    x32 x31 x33 x30 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_28 x5 x32
    x31 x33 x30 x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_28" [show x5, show x32, show x31
    , show x33, show x30, show x1, show x3, show x34] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_28"
    (showCons x34))

nd_C__case_27 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_27 x32 x31 x33 x30 x1 x5 x3 x34 s cd cs = case x34 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_amp_gt (Curry_Prelude.d_OP_eq_colon_eq x3
    (Curry_Prelude.OP_Cons x5 x33) cd cs) (nd_C_stateScan x1 (C_BigComment x30)
    x33 (Curry_Prelude.OP_Cons x31 x32) s0 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_27 x32 x31 x33
    x30 x1 x5 x3 l s cd cs) (nd_C__case_27 x32 x31 x33 x30 x1 x5 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_27 x32
    x31 x33 x30 x1 x5 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_27 x32
    x31 x33 x30 x1 x5 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_27" [show x32, show x31, show x33
    , show x30, show x1, show x5, show x3, show x34] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_27"
    (showCons x34))

d_C__case_30 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Token
d_C__case_30 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "File ended while expecting -}") cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_30 x3 l cd cs)
    (d_C__case_30 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_30 x3 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_30 x3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_30" [show x3, show x4] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_30"
    (showCons x4))

nd_C__case_38 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_38 x5 x26 x1 x3 x6 s cd cs = case x6 of
  Curry_Prelude.OP_List -> d_C__case_37 x3 x5 x26
    (Curry_Prelude.d_OP_eq_colon_eq x3 Curry_Prelude.OP_List cd cs) cd cs
  Curry_Prelude.OP_Cons x27 x28 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` (let x29 = generate s0 cd
    in nd_C__case_35 x5 x28 x27 x29 x26 x1 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x5 (Curry_Prelude.C_Char '"'#) cd cs) s1 cd cs)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_38 x5 x26 x1 x3
    l s cd cs) (nd_C__case_38 x5 x26 x1 x3 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_38 x5
    x26 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_38 x5
    x26 x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_38" [show x5, show x26, show x1, show
    x3, show x6] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_38"
    (showCons x6))

nd_C__case_35 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_35 x5 x28 x27 x29 x26 x1 x3 x30 s cd cs = case x30 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_amp_gt (Curry_Prelude.d_OP_eq_colon_eq x3
    Curry_Prelude.OP_List cd cs) (Curry_Prelude.OP_Cons (C_Text x26)
    (nd_C_stateScan x1 (C_Code x29) x29 (Curry_Prelude.OP_Cons x27 x28) s0 cd
    cs)) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_34 x5 x28 x27 x29 x26 x1 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x5 (Curry_Prelude.C_Char '\\'#) cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_35 x5 x28 x27
    x29 x26 x1 x3 l s cd cs) (nd_C__case_35 x5 x28 x27 x29 x26 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_35 x5
    x28 x27 x29 x26 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_35 x5 x28
    x27 x29 x26 x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_35" [show x5, show x28, show x27
    , show x29, show x26, show x1, show x3, show x30] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_35"
    (showCons x30))

nd_C__case_34 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_34 x5 x28 x27 x29 x26 x1 x3 x30 s cd cs = case x30 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_amp_gt (Curry_Prelude.d_OP_eq_colon_eq x3
    (Curry_Prelude.OP_Cons x5 (Curry_Prelude.OP_Cons x27 x29)) cd cs)
    (nd_C_stateScan x1 (C_Text x26) x29 x28 s0 cd cs) cd cs
  Curry_Prelude.C_False -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_33 x5 x28 x27 x29 x26 x1 x3
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_elem
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x5 s0 cd cs) (d_C_toBeEscaped cd cs) s1 cd cs)) s3 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_34 x5 x28 x27
    x29 x26 x1 x3 l s cd cs) (nd_C__case_34 x5 x28 x27 x29 x26 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_34 x5
    x28 x27 x29 x26 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_34 x5 x28
    x27 x29 x26 x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_34" [show x5, show x28, show x27
    , show x29, show x26, show x1, show x3, show x30] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_34"
    (showCons x30))

nd_C__case_33 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_33 x5 x28 x27 x29 x26 x1 x3 x30 s cd cs = case x30 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Curry_Prelude.d_C_error) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "unescaped ") (Curry_Prelude.OP_Cons x5
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " encountered in line ") (Curry_Prelude.nd_C_apply (wrapDX id
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs)) x1 s0 cd cs) cd cs)) cd cs) s1 cd cs))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_32 x28 x27 x29 x26 x1 x5 x3
    (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_33 x5 x28 x27
    x29 x26 x1 x3 l s cd cs) (nd_C__case_33 x5 x28 x27 x29 x26 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_33 x5
    x28 x27 x29 x26 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_33 x5 x28
    x27 x29 x26 x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_33" [show x5, show x28, show x27
    , show x29, show x26, show x1, show x3, show x30] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_33"
    (showCons x30))

nd_C__case_32 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_32 x28 x27 x29 x26 x1 x5 x3 x30 s cd cs = case x30 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_amp_gt (Curry_Prelude.d_OP_eq_colon_eq x3
    (Curry_Prelude.OP_Cons x5 x29) cd cs) (nd_C_stateScan x1 (C_Text x26) x29
    (Curry_Prelude.OP_Cons x27 x28) s0 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_32 x28 x27 x29
    x26 x1 x5 x3 l s cd cs) (nd_C__case_32 x28 x27 x29 x26 x1 x5 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_32 x28
    x27 x29 x26 x1 x5 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_32 x28
    x27 x29 x26 x1 x5 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_32" [show x28, show x27, show x29
    , show x26, show x1, show x5, show x3, show x30] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_32"
    (showCons x30))

d_C__case_37 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Token
d_C__case_37 x3 x5 x26 x27 cd cs = case x27 of
  Curry_Prelude.C_True -> d_C__case_36 x5 x26
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x5 (Curry_Prelude.C_Char '"'#) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_37 x3 x5 x26 l cd
    cs) (d_C__case_37 x3 x5 x26 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_37 x3
    x5 x26 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_37 x3 x5
    x26 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_37" [show x3, show x5, show x26, show
    x27] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_37"
    (showCons x27))

d_C__case_36 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
d_C__case_36 x5 x26 x27 cd cs = case x27 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (C_Text x26)
    Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "File ended while scanning string.") cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_36 x5 x26 l cd
    cs) (d_C__case_36 x5 x26 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_36 x5
    x26 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_36 x5 x26
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_36" [show x5, show x26, show x27]
    info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_36"
    (showCons x27))

nd_C__case_62 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_62 x5 x7 x1 x3 x6 s cd cs = case x6 of
  Curry_Prelude.OP_List -> d_C__case_61 x5 x3 x7 (Curry_Prelude.d_OP_eq_colon_eq
    x3 (Curry_Prelude.OP_Cons x5 Curry_Prelude.OP_List) cd cs) cd cs
  Curry_Prelude.OP_Cons x8 x9 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` (let x10 = generate s0 cd
    in nd_C__case_60 x5 x8 x9 x10 x7 x1 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x5 (Curry_Prelude.C_Char '"'#) cd cs) s1 cd cs)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_62 x5 x7 x1 x3
    l s cd cs) (nd_C__case_62 x5 x7 x1 x3 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_62 x5
    x7 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_62 x5 x7
    x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_62" [show x5, show x7, show x1, show
    x3, show x6] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_62"
    (showCons x6))

nd_C__case_60 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_60 x5 x8 x9 x10 x7 x1 x3 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_amp_gt (Curry_Prelude.d_OP_eq_colon_eq x3
    Curry_Prelude.OP_List cd cs) (d_C_maybeCode x7 (nd_C_stateScan x1 (C_Text
    x10) x10 (Curry_Prelude.OP_Cons x8 x9) s0 cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_59 x8 x5 x9 x10 x7 x1 x3 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x5 (Curry_Prelude.C_Char '-'#) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x8 (Curry_Prelude.C_Char '-'#) cd cs) cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_60 x5 x8 x9 x10
    x7 x1 x3 l s cd cs) (nd_C__case_60 x5 x8 x9 x10 x7 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_60 x5
    x8 x9 x10 x7 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_60 x5 x8
    x9 x10 x7 x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_60" [show x5, show x8, show x9, show
    x10, show x7, show x1, show x3, show x11] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_60"
    (showCons x11))

nd_C__case_59 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_59 x8 x5 x9 x10 x7 x1 x3 x14 s cd cs = case x14 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` (let x11 = Curry_Prelude.nd_C_span (wrapNX id
                                 (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id)
                                 (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
                                 cd cs)) (Curry_Prelude.C_Char '\n'#))) x9 s0 cd
                                 cs
                               x12 = d_OP_stateScan_dot_uscore_hash_selFP8_hash_comment
                                 x11 cd cs
                               x13 = d_OP_stateScan_dot_uscore_hash_selFP9_hash_rest
                                 x11 cd cs
    in Curry_Prelude.d_OP_amp_gt (Curry_Prelude.d_OP_eq_colon_eq x3
    Curry_Prelude.OP_List cd cs) (d_C_maybeCode x7 (Curry_Prelude.OP_Cons
    (C_SmallComment x12) (nd_C_stateScan x1 (C_Code x10) x10 x13 s1 cd cs)) cd
    cs) cd cs)))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_58 x8 x5 x9 x10 x7 x1 x3 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x5 (Curry_Prelude.C_Char '{'#) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x8 (Curry_Prelude.C_Char '-'#) cd cs) cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_59 x8 x5 x9 x10
    x7 x1 x3 l s cd cs) (nd_C__case_59 x8 x5 x9 x10 x7 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_59 x8
    x5 x9 x10 x7 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_59 x8 x5
    x9 x10 x7 x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_59" [show x8, show x5, show x9, show
    x10, show x7, show x1, show x3, show x14] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_59"
    (showCons x14))

nd_C__case_58 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_58 x8 x5 x9 x10 x7 x1 x3 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_amp_gt (Curry_Prelude.d_OP_eq_colon_eq x3
    Curry_Prelude.OP_List cd cs) (d_C_maybeCode x7 (nd_C_stateScan x1
    (C_BigComment x10) x10 x9 s0 cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_57 x8 x5 x9 x10 x7 x1 x3 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x5 (Curry_Prelude.C_Char '{'#) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x8 (Curry_Prelude.C_Char '+'#) cd cs) cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_58 x8 x5 x9 x10
    x7 x1 x3 l s cd cs) (nd_C__case_58 x8 x5 x9 x10 x7 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_58 x8
    x5 x9 x10 x7 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_58 x8 x5
    x9 x10 x7 x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_58" [show x8, show x5, show x9, show
    x10, show x7, show x1, show x3, show x11] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_58"
    (showCons x11))

nd_C__case_57 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_57 x8 x5 x9 x10 x7 x1 x3 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_amp_gt (Curry_Prelude.d_OP_eq_colon_eq x3
    Curry_Prelude.OP_List cd cs) (d_C_maybeCode x7 (nd_C_stateScan x1 (C_Meta
    x10) x10 x9 s0 cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_56 x5 x8 x9 x10 x7 x1 x3
    (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x8 (Curry_Prelude.C_Char '\''#) cd cs) (let s1 = leftSupply s2
                                                s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_elem
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x5 s0 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_infixIDs cd cs)
    (d_C_delimiters cd cs) cd cs) s1 cd cs)) cd cs) s3 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_57 x8 x5 x9 x10
    x7 x1 x3 l s cd cs) (nd_C__case_57 x8 x5 x9 x10 x7 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_57 x8
    x5 x9 x10 x7 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_57 x8 x5
    x9 x10 x7 x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_57" [show x8, show x5, show x9, show
    x10, show x7, show x1, show x3, show x11] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_57"
    (showCons x11))

nd_C__case_56 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_56 x5 x8 x9 x10 x7 x1 x3 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` Curry_Prelude.d_OP_amp_gt (Curry_Prelude.d_OP_eq_colon_eq x3
    (Curry_Prelude.OP_Cons x5 Curry_Prelude.OP_List) cd cs) (let s1 = leftSupply
                                                                   s2
                                                                 s0 = rightSupply
                                                                   s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id (d_C_maybeCode
    x7)) (nd_C__case_55 x1 x10 x9 s0 cd cs) s1 cd cs)) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_40 x5 x9 x8 x10 x7 x1 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x5 (Curry_Prelude.C_Char '\n'#) cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_56 x5 x8 x9 x10
    x7 x1 x3 l s cd cs) (nd_C__case_56 x5 x8 x9 x10 x7 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_56 x5
    x8 x9 x10 x7 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_56 x5 x8
    x9 x10 x7 x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_56" [show x5, show x8, show x9, show
    x10, show x7, show x1, show x3, show x11] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_56"
    (showCons x11))

nd_C__case_40 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_40 x5 x9 x8 x10 x7 x1 x3 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_amp_gt (Curry_Prelude.d_OP_eq_colon_eq x3
    (Curry_Prelude.OP_Cons x5 x10) cd cs) (nd_C_stateScan
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 (Curry_Prelude.C_Int (1)) cd cs) (C_Code x7) x10 (Curry_Prelude.OP_Cons
    x8 x9) s0 cd cs) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_39 x9 x8 x10 x7 x1 x5 x3 (Curry_Prelude.d_C_otherwise
    cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_40 x5 x9 x8 x10
    x7 x1 x3 l s cd cs) (nd_C__case_40 x5 x9 x8 x10 x7 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_40 x5
    x9 x8 x10 x7 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_40 x5 x9
    x8 x10 x7 x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_40" [show x5, show x9, show x8, show
    x10, show x7, show x1, show x3, show x11] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_40"
    (showCons x11))

nd_C__case_39 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_39 x9 x8 x10 x7 x1 x5 x3 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_amp_gt (Curry_Prelude.d_OP_eq_colon_eq x3
    (Curry_Prelude.OP_Cons x5 x10) cd cs) (nd_C_stateScan x1 (C_Code x7) x10
    (Curry_Prelude.OP_Cons x8 x9) s0 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_39 x9 x8 x10 x7
    x1 x5 x3 l s cd cs) (nd_C__case_39 x9 x8 x10 x7 x1 x5 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_39 x9
    x8 x10 x7 x1 x5 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_39 x9 x8
    x10 x7 x1 x5 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_39" [show x9, show x8, show x10, show
    x7, show x1, show x5, show x3, show x11] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_39"
    (showCons x11))

nd_C__case_55 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_55 x1 x10 x9 s cd cs = case x9 of
  Curry_Prelude.OP_Cons x14 x15 -> let s0 = s
    in s0 `seq` nd_C__case_54 x14 x15 x1 x10
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x14 (Curry_Prelude.C_Char '\\'#) cd cs) s0 cd cs
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Curry_Prelude.d_C_error) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Improperly terminated character in line ")
    (Curry_Prelude.nd_C_apply (wrapDX id
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs)) x1 s0 cd cs) cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_55 x1 x10 l s
    cd cs) (nd_C__case_55 x1 x10 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_55 x1
    x10 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_55 x1
    x10 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_55" [show x1, show x10, show x9]
    info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_55"
    (showCons x9))

nd_C__case_54 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_54 x14 x15 x1 x10 x16 s cd cs = case x16 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C__case_53 x1 x10 x14 x15 s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_42 x1 x10 x14 x15 s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_54 x14 x15 x1
    x10 l s cd cs) (nd_C__case_54 x14 x15 x1 x10 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_54 x14
    x15 x1 x10 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_54 x14
    x15 x1 x10 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_54" [show x14, show x15, show x1
    , show x10, show x16] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_54"
    (showCons x16))

nd_C__case_42 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_42 x1 x10 x14 x15 s cd cs = case x15 of
  Curry_Prelude.OP_Cons x24 x25 -> let s0 = s
    in s0 `seq` nd_C__case_41 x24 x1 x25 x10 x14
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x24 (Curry_Prelude.C_Char '\''#) cd cs) s0 cd cs
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Curry_Prelude.d_C_error) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Improperly terminated character in line ")
    (Curry_Prelude.nd_C_apply (wrapDX id
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs)) x1 s0 cd cs) cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_42 x1 x10 x14 l
    s cd cs) (nd_C__case_42 x1 x10 x14 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_42 x1
    x10 x14 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_42 x1
    x10 x14 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_42" [show x1, show x10, show x14
    , show x15] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_42"
    (showCons x15))

nd_C__case_41 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_41 x24 x1 x25 x10 x14 x26 s cd cs = case x26 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons (C_Letter (Curry_Prelude.OP_Cons x14
    Curry_Prelude.OP_List)) (nd_C_stateScan x1 (C_Code x10) x10 x25 s0 cd cs)
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Curry_Prelude.d_C_error) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Improperly terminated character in line ")
    (Curry_Prelude.nd_C_apply (wrapDX id
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs)) x1 s0 cd cs) cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_41 x24 x1 x25
    x10 x14 l s cd cs) (nd_C__case_41 x24 x1 x25 x10 x14 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_41 x24
    x1 x25 x10 x14 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_41 x24 x1
    x25 x10 x14 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_41" [show x24, show x1, show x25
    , show x10, show x14, show x26] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_41"
    (showCons x26))

nd_C__case_53 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_53 x1 x10 x14 x15 s cd cs = case x15 of
  Curry_Prelude.OP_Cons x16 x17 -> let s0 = s
    in s0 `seq` nd_C__case_52 x16 x1 x10 x14 x17 s0 cd cs
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Curry_Prelude.d_C_error) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Improperly terminated character in line ")
    (Curry_Prelude.nd_C_apply (wrapDX id
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs)) x1 s0 cd cs) cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_53 x1 x10 x14 l
    s cd cs) (nd_C__case_53 x1 x10 x14 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_53 x1
    x10 x14 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_53 x1
    x10 x14 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_53" [show x1, show x10, show x14
    , show x15] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_53"
    (showCons x15))

nd_C__case_52 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_52 x16 x1 x10 x14 x17 s cd cs = case x17 of
  Curry_Prelude.OP_Cons x18 x19 -> let s0 = s
    in s0 `seq` nd_C__case_51 x18 x19 x16 x1 x17 x10 x14
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x18 (Curry_Prelude.C_Char '\''#) cd cs) s0 cd cs
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` nd_C__case_43 x16 x1 x17 x10 x14
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x16 (Curry_Prelude.C_Char '\''#) cd cs) s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_52 x16 x1 x10
    x14 l s cd cs) (nd_C__case_52 x16 x1 x10 x14 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_52
    x16 x1 x10 x14 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_52 x16
    x1 x10 x14 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_52" [show x16, show x1, show x10
    , show x14, show x17] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_52"
    (showCons x17))

nd_C__case_43 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_43 x16 x1 x17 x10 x14 x18 s cd cs = case x18 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons (C_Letter (Curry_Prelude.OP_Cons x14
    Curry_Prelude.OP_List)) (nd_C_stateScan x1 (C_Code x10) x10 x17 s0 cd cs)
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Curry_Prelude.d_C_error) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Improperly terminated character in line ")
    (Curry_Prelude.nd_C_apply (wrapDX id
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs)) x1 s0 cd cs) cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_43 x16 x1 x17
    x10 x14 l s cd cs) (nd_C__case_43 x16 x1 x17 x10 x14 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_43 x16
    x1 x17 x10 x14 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_43 x16 x1
    x17 x10 x14 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_43" [show x16, show x1, show x17
    , show x10, show x14, show x18] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_43"
    (showCons x18))

nd_C__case_51 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_51 x18 x19 x16 x1 x17 x10 x14 x20 s cd cs = case x20 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons (C_Letter (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '\\'#) (Curry_Prelude.OP_Cons x16
    Curry_Prelude.OP_List))) (nd_C_stateScan x1 (C_Code x10) x10 x19 s0 cd cs)
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_50 x16 x1 x17 x10 x14 x18 x19 s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_51 x18 x19 x16
    x1 x17 x10 x14 l s cd cs) (nd_C__case_51 x18 x19 x16 x1 x17 x10 x14 r s cd
    cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_51 x18
    x19 x16 x1 x17 x10 x14 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_51 x18
    x19 x16 x1 x17 x10 x14 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_51" [show x18, show x19, show x16
    , show x1, show x17, show x10, show x14, show x20] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_51"
    (showCons x20))

nd_C__case_50 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_50 x16 x1 x17 x10 x14 x18 x19 s cd cs = case x19 of
  Curry_Prelude.OP_Cons x20 x21 -> let s0 = s
    in s0 `seq` nd_C__case_49 x16 x1 x17 x10 x14 x20 x18 x21 s0 cd cs
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` nd_C__case_44 x16 x1 x17 x10 x14
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x16 (Curry_Prelude.C_Char '\''#) cd cs) s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_50 x16 x1 x17
    x10 x14 x18 l s cd cs) (nd_C__case_50 x16 x1 x17 x10 x14 x18 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_50
    x16 x1 x17 x10 x14 x18 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_50 x16
    x1 x17 x10 x14 x18 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_50" [show x16, show x1, show x17
    , show x10, show x14, show x18, show x19] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_50"
    (showCons x19))

nd_C__case_44 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_44 x16 x1 x17 x10 x14 x18 s cd cs = case x18 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons (C_Letter (Curry_Prelude.OP_Cons x14
    Curry_Prelude.OP_List)) (nd_C_stateScan x1 (C_Code x10) x10 x17 s0 cd cs)
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Curry_Prelude.d_C_error) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Improperly terminated character in line ")
    (Curry_Prelude.nd_C_apply (wrapDX id
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs)) x1 s0 cd cs) cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_44 x16 x1 x17
    x10 x14 l s cd cs) (nd_C__case_44 x16 x1 x17 x10 x14 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_44 x16
    x1 x17 x10 x14 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_44 x16 x1
    x17 x10 x14 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_44" [show x16, show x1, show x17
    , show x10, show x14, show x18] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_44"
    (showCons x18))

nd_C__case_49 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_49 x16 x1 x17 x10 x14 x20 x18 x21 s cd cs = case x21 of
  Curry_Prelude.OP_Cons x22 x23 -> let s0 = s
    in s0 `seq` nd_C__case_48 x22 x16 x1 x17 x10 x14 x20 x18 x23
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x22 (Curry_Prelude.C_Char '\''#) cd cs) s0 cd cs
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` nd_C__case_45 x16 x1 x17 x10 x14
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x16 (Curry_Prelude.C_Char '\''#) cd cs) s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_49 x16 x1 x17
    x10 x14 x20 x18 l s cd cs) (nd_C__case_49 x16 x1 x17 x10 x14 x20 x18 r s cd
    cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_49
    x16 x1 x17 x10 x14 x20 x18 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_49 x16
    x1 x17 x10 x14 x20 x18 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_49" [show x16, show x1, show x17
    , show x10, show x14, show x20, show x18, show x21] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_49"
    (showCons x21))

nd_C__case_45 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_45 x16 x1 x17 x10 x14 x18 s cd cs = case x18 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons (C_Letter (Curry_Prelude.OP_Cons x14
    Curry_Prelude.OP_List)) (nd_C_stateScan x1 (C_Code x10) x10 x17 s0 cd cs)
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Curry_Prelude.d_C_error) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Improperly terminated character in line ")
    (Curry_Prelude.nd_C_apply (wrapDX id
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs)) x1 s0 cd cs) cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_45 x16 x1 x17
    x10 x14 l s cd cs) (nd_C__case_45 x16 x1 x17 x10 x14 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_45 x16
    x1 x17 x10 x14 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_45 x16 x1
    x17 x10 x14 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_45" [show x16, show x1, show x17
    , show x10, show x14, show x18] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_45"
    (showCons x18))

nd_C__case_48 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_48 x22 x16 x1 x17 x10 x14 x20 x18 x23 x24 s cd cs = case x24 of
  Curry_Prelude.C_True -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_47 x20 x18 x16 x1 x23 x10
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_all
    (wrapDX id Curry_Prelude.d_C_isDigit) s0 cd cs) (Curry_Prelude.OP_Cons x16
    (Curry_Prelude.OP_Cons x18 (Curry_Prelude.OP_Cons x20
    Curry_Prelude.OP_List))) s1 cd cs)) s3 cd cs))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_46 x16 x1 x17 x10 x14
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x16 (Curry_Prelude.C_Char '\''#) cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_48 x22 x16 x1
    x17 x10 x14 x20 x18 x23 l s cd cs) (nd_C__case_48 x22 x16 x1 x17 x10 x14 x20
    x18 x23 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_48 x22
    x16 x1 x17 x10 x14 x20 x18 x23 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_48 x22
    x16 x1 x17 x10 x14 x20 x18 x23 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_48" [show x22, show x16, show x1
    , show x17, show x10, show x14, show x20, show x18, show x23, show x24]
    info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_48"
    (showCons x24))

nd_C__case_46 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_46 x16 x1 x17 x10 x14 x18 s cd cs = case x18 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons (C_Letter (Curry_Prelude.OP_Cons x14
    Curry_Prelude.OP_List)) (nd_C_stateScan x1 (C_Code x10) x10 x17 s0 cd cs)
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Curry_Prelude.d_C_error) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Improperly terminated character in line ")
    (Curry_Prelude.nd_C_apply (wrapDX id
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs)) x1 s0 cd cs) cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_46 x16 x1 x17
    x10 x14 l s cd cs) (nd_C__case_46 x16 x1 x17 x10 x14 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_46 x16
    x1 x17 x10 x14 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_46 x16 x1
    x17 x10 x14 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_46" [show x16, show x1, show x17
    , show x10, show x14, show x18] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_46"
    (showCons x18))

nd_C__case_47 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
nd_C__case_47 x20 x18 x16 x1 x23 x10 x24 s cd cs = case x24 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons (C_Letter (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '\\'#) (Curry_Prelude.OP_Cons x16
    (Curry_Prelude.OP_Cons x18 (Curry_Prelude.OP_Cons x20
    Curry_Prelude.OP_List))))) (nd_C_stateScan x1 (C_Code x10) x10 x23 s0 cd cs)
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Curry_Prelude.d_C_error) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString
    "Improperly terminated character found in line ") (Curry_Prelude.nd_C_apply
    (wrapDX id
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs)) x1 s0 cd cs) cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_47 x20 x18 x16
    x1 x23 x10 l s cd cs) (nd_C__case_47 x20 x18 x16 x1 x23 x10 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_47 x20
    x18 x16 x1 x23 x10 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_47 x20
    x18 x16 x1 x23 x10 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_47" [show x20, show x18, show x16
    , show x1, show x23, show x10, show x24] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_47"
    (showCons x24))

d_C__case_61 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Token
d_C__case_61 x5 x3 x7 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_C_maybeCode x7 Curry_Prelude.OP_List cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_61 x5 x3 x7 l cd
    cs) (d_C__case_61 x5 x3 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_61 x5
    x3 x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_61 x5 x3
    x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_61" [show x5, show x3, show x7, show
    x8] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_61"
    (showCons x8))

d_C__case_64 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Token
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_Token
d_C__case_64 x3 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x2 Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_64 x3 x2 l cd cs)
    (d_C__case_64 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_64 x3
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_64 x3 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_64" [show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_64"
    (showCons x4))

d_C__case_21 :: Curry_Prelude.OP_List C_Token -> (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> C_Token -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
d_C__case_21 x4 x1 x3 cd cs = case x3 of
  C_Code x5 -> d_C__case_20 x5 x4 x1 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_break d_OP_modHead_dot_uscore_hash_lambda10 cd cs) x5 cd
    cs) cd cs
  C_BigComment x14 -> d_C_maybeMo (Curry_Prelude.d_C_apply x1
    Curry_Prelude.OP_List cd cs) (Curry_Prelude.OP_Cons (C_BigComment x14)
    (d_C_modHead Curry_Prelude.d_C_id x4 cd cs)) cd cs
  C_SmallComment x15 -> d_C_maybeMo (Curry_Prelude.d_C_apply x1
    Curry_Prelude.OP_List cd cs) (Curry_Prelude.OP_Cons (C_SmallComment x15)
    (d_C_modHead Curry_Prelude.d_C_id x4 cd cs)) cd cs
  C_Meta x16 -> d_C_maybeMo (Curry_Prelude.d_C_apply x1 Curry_Prelude.OP_List cd
    cs) (Curry_Prelude.OP_Cons (C_Meta x16) x4) cd cs
  C_Text x17 -> Curry_Prelude.d_C_failed cd cs
  C_Letter x18 -> Curry_Prelude.d_C_failed cd cs
  C_ModuleHead x19 -> Curry_Prelude.d_C_failed cd cs
  Choice_C_Token d i l r -> narrow d i (d_C__case_21 x4 x1 l cd cs)
    (d_C__case_21 x4 x1 r cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_21 x4 x1 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_21 x4 x1 e cd x) $!
    addCs c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_21" [show x4, show x1, show x3] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_21"
    (showCons x3))

nd_C__case_21 :: Curry_Prelude.OP_List C_Token -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Token
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_21 x4 x1 x3 s cd cs = case x3 of
  C_Code x5 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_20 x5 x4 x1 (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_break
    (wrapDX id d_OP_modHead_dot_uscore_hash_lambda10) s0 cd cs) x5 s1 cd cs)) s3
    cd cs))
  C_BigComment x14 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` d_C_maybeMo (Curry_Prelude.nd_C_apply x1
    Curry_Prelude.OP_List s0 cd cs) (Curry_Prelude.OP_Cons (C_BigComment x14)
    (nd_C_modHead (wrapDX id Curry_Prelude.d_C_id) x4 s1 cd cs)) cd cs))
  C_SmallComment x15 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` d_C_maybeMo (Curry_Prelude.nd_C_apply x1
    Curry_Prelude.OP_List s0 cd cs) (Curry_Prelude.OP_Cons (C_SmallComment x15)
    (nd_C_modHead (wrapDX id Curry_Prelude.d_C_id) x4 s1 cd cs)) cd cs))
  C_Meta x16 -> let s0 = s
    in s0 `seq` d_C_maybeMo (Curry_Prelude.nd_C_apply x1 Curry_Prelude.OP_List
    s0 cd cs) (Curry_Prelude.OP_Cons (C_Meta x16) x4) cd cs
  C_Text x17 -> Curry_Prelude.d_C_failed cd cs
  C_Letter x18 -> Curry_Prelude.d_C_failed cd cs
  C_ModuleHead x19 -> Curry_Prelude.d_C_failed cd cs
  Choice_C_Token d i l r -> narrow d i (nd_C__case_21 x4 x1 l s cd cs)
    (nd_C__case_21 x4 x1 r s cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> nd_C__case_21 x4 x1 z s cd cs)
    xs
  Guard_C_Token d c e -> guardCons d c ((\x -> nd_C__case_21 x4 x1 e s cd x) $!
    addCs c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_21" [show x4, show x1, show x3] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_21"
    (showCons x3))

d_C__case_20 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_Token -> (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
d_C__case_20 x5 x4 x1 x8 cd cs = case x8 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> d_C__case_19 x7 x4 x5 x1 x6 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_20 x5 x4 x1 l
    cd cs) (d_C__case_20 x5 x4 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_20
    x5 x4 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_20 x5
    x4 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_20" [show x5, show x4, show x1, show
    x8] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_20"
    (showCons x8))

nd_C__case_20 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_Token -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_20 x5 x4 x1 x8 s cd cs = case x8 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s0 = s
    in s0 `seq` nd_C__case_19 x7 x4 x5 x1 x6 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_20 x5 x4 x1 l
    s cd cs) (nd_C__case_20 x5 x4 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_20
    x5 x4 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_20 x5
    x4 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_20" [show x5, show x4, show x1, show
    x8] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_20"
    (showCons x8))

d_C__case_19 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_Token -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
d_C__case_19 x7 x4 x5 x1 x6 cd cs = case x6 of
  Curry_Prelude.OP_List -> d_C__case_18 x4 x1 x7 cd cs
  Curry_Prelude.OP_Cons x10 x11 -> d_C__case_17 x6 x4 x5 x1 x7 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_19 x7 x4 x5 x1 l
    cd cs) (d_C__case_19 x7 x4 x5 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_19 x7
    x4 x5 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_19 x7 x4
    x5 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_19" [show x7, show x4, show x5, show
    x1, show x6] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_19"
    (showCons x6))

nd_C__case_19 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_Token -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_19 x7 x4 x5 x1 x6 s cd cs = case x6 of
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` nd_C__case_18 x4 x1 x7 s0 cd cs
  Curry_Prelude.OP_Cons x10 x11 -> let s0 = s
    in s0 `seq` nd_C__case_17 x6 x4 x5 x1 x7 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_19 x7 x4 x5 x1
    l s cd cs) (nd_C__case_19 x7 x4 x5 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_19 x7
    x4 x5 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_19 x7 x4
    x5 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_19" [show x7, show x4, show x5, show
    x1, show x6] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_19"
    (showCons x6))

d_C__case_17 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_Token -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
d_C__case_17 x6 x4 x5 x1 x7 cd cs = case x7 of
  Curry_Prelude.OP_List -> d_C__case_16 x6 x4 x5 x1 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_any (d_C_lineBeginsWith x6) cd cs) (d_C_headers cd cs) cd
    cs) cd cs
  Curry_Prelude.OP_Cons x12 x13 -> d_C__case_15 x6 x4 x5 x1 x13 x12
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_any (d_C_lineBeginsWith x6) cd
    cs) (d_C_headers cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_17 x6 x4 x5 x1 l
    cd cs) (d_C__case_17 x6 x4 x5 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_17 x6
    x4 x5 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_17 x6 x4
    x5 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_17" [show x6, show x4, show x5, show
    x1, show x7] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_17"
    (showCons x7))

nd_C__case_17 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_Token -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_17 x6 x4 x5 x1 x7 s cd cs = case x7 of
  Curry_Prelude.OP_List -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_16 x6 x4 x5 x1 (let s1 = leftSupply s2
                                                         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_any
    (wrapDX id (d_C_lineBeginsWith x6)) s0 cd cs) (d_C_headers cd cs) s1 cd cs))
    s3 cd cs))
  Curry_Prelude.OP_Cons x12 x13 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_15 x6 x4 x5 x1 x13 x12 (let s1 = leftSupply
                                                                   s2
                                                                 s0 = rightSupply
                                                                   s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_any
    (wrapDX id (d_C_lineBeginsWith x6)) s0 cd cs) (d_C_headers cd cs) s1 cd cs))
    s3 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_17 x6 x4 x5 x1
    l s cd cs) (nd_C__case_17 x6 x4 x5 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_17 x6
    x4 x5 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_17 x6 x4
    x5 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_17" [show x6, show x4, show x5, show
    x1, show x7] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_17"
    (showCons x7))

d_C__case_15 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_Token -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
d_C__case_15 x6 x4 x5 x1 x13 x12 x14 cd cs = case x14 of
  Curry_Prelude.C_True -> d_C_modHead (Curry_Prelude.d_OP_dot x1
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_OP_plus_plus x6) (acceptCs id
    (Curry_Prelude.OP_Cons x12)) cd cs) cd cs) (Curry_Prelude.OP_Cons (C_Code
    x13) x4) cd cs
  Curry_Prelude.C_False -> d_C_maybeMo (Curry_Prelude.d_C_apply x1
    Curry_Prelude.OP_List cd cs) (Curry_Prelude.OP_Cons (C_Code x5) x4) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_15 x6 x4 x5 x1
    x13 x12 l cd cs) (d_C__case_15 x6 x4 x5 x1 x13 x12 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_15 x6
    x4 x5 x1 x13 x12 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_15 x6 x4
    x5 x1 x13 x12 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_15" [show x6, show x4, show x5, show
    x1, show x13, show x12, show x14] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_15"
    (showCons x14))

nd_C__case_15 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_Token -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_15 x6 x4 x5 x1 x13 x12 x14 s cd cs = case x14 of
  Curry_Prelude.C_True -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C_modHead (let s1 = leftSupply s2
                                            s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot x1 (Curry_Prelude.nd_OP_dot
    (wrapDX id (Curry_Prelude.d_OP_plus_plus x6)) (wrapDX id (acceptCs id
    (Curry_Prelude.OP_Cons x12))) s0 cd cs) s1 cd cs)) (Curry_Prelude.OP_Cons
    (C_Code x13) x4) s3 cd cs))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` d_C_maybeMo (Curry_Prelude.nd_C_apply x1 Curry_Prelude.OP_List
    s0 cd cs) (Curry_Prelude.OP_Cons (C_Code x5) x4) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_15 x6 x4 x5 x1
    x13 x12 l s cd cs) (nd_C__case_15 x6 x4 x5 x1 x13 x12 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_15 x6
    x4 x5 x1 x13 x12 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_15 x6 x4
    x5 x1 x13 x12 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_15" [show x6, show x4, show x5, show
    x1, show x13, show x12, show x14] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_15"
    (showCons x14))

d_C__case_16 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_Token -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
d_C__case_16 x6 x4 x5 x1 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (C_ModuleHead
    (Curry_Prelude.d_C_apply x1 x6 cd cs)) (d_C_modHeadInLine
    Curry_Prelude.d_C_id x4 cd cs)
  Curry_Prelude.C_False -> d_C_maybeMo (Curry_Prelude.d_C_apply x1
    Curry_Prelude.OP_List cd cs) (Curry_Prelude.OP_Cons (C_Code x5) x4) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_16 x6 x4 x5 x1 l
    cd cs) (d_C__case_16 x6 x4 x5 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_16 x6
    x4 x5 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_16 x6 x4
    x5 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_16" [show x6, show x4, show x5, show
    x1, show x7] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_16"
    (showCons x7))

nd_C__case_16 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_Token -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_16 x6 x4 x5 x1 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.OP_Cons (C_ModuleHead
    (Curry_Prelude.nd_C_apply x1 x6 s0 cd cs)) (nd_C_modHeadInLine (wrapDX id
    Curry_Prelude.d_C_id) x4 s1 cd cs)))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` d_C_maybeMo (Curry_Prelude.nd_C_apply x1 Curry_Prelude.OP_List
    s0 cd cs) (Curry_Prelude.OP_Cons (C_Code x5) x4) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_16 x6 x4 x5 x1 l
    s cd cs) (nd_C__case_16 x6 x4 x5 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_16 x6
    x4 x5 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_16 x6 x4
    x5 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_16" [show x6, show x4, show x5, show
    x1, show x7] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_16"
    (showCons x7))

d_C__case_18 :: Curry_Prelude.OP_List C_Token -> (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
d_C__case_18 x4 x1 x7 cd cs = case x7 of
  Curry_Prelude.OP_List -> d_C_modHead x1 x4 cd cs
  Curry_Prelude.OP_Cons x8 x9 -> d_C_modHead (Curry_Prelude.d_OP_dot x1
    (acceptCs id (Curry_Prelude.OP_Cons x8)) cd cs) (Curry_Prelude.OP_Cons
    (C_Code x9) x4) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_18 x4 x1 l cd
    cs) (d_C__case_18 x4 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_18 x4
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_18 x4 x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_18" [show x4, show x1, show x7] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_18"
    (showCons x7))

nd_C__case_18 :: Curry_Prelude.OP_List C_Token -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_18 x4 x1 x7 s cd cs = case x7 of
  Curry_Prelude.OP_List -> let s0 = s in s0 `seq` nd_C_modHead x1 x4 s0 cd cs
  Curry_Prelude.OP_Cons x8 x9 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C_modHead (Curry_Prelude.nd_OP_dot x1 (wrapDX id
    (acceptCs id (Curry_Prelude.OP_Cons x8))) s0 cd cs) (Curry_Prelude.OP_Cons
    (C_Code x9) x4) s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_18 x4 x1 l s cd
    cs) (nd_C__case_18 x4 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_18 x4
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_18 x4 x1
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_18" [show x4, show x1, show x7] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_18"
    (showCons x7))

d_C__case_14 :: Curry_Prelude.OP_List C_Token -> (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> C_Token -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
d_C__case_14 x4 x1 x3 cd cs = case x3 of
  C_Code x5 -> d_C__case_13 x5 x4 x1 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_break d_OP_modHeadInLine_dot_uscore_hash_lambda12 cd cs)
    x5 cd cs) cd cs
  C_BigComment x10 -> d_C_maybeMo (Curry_Prelude.d_C_apply x1
    Curry_Prelude.OP_List cd cs) (Curry_Prelude.OP_Cons (C_BigComment x10)
    (d_C_modHeadInLine Curry_Prelude.d_C_id x4 cd cs)) cd cs
  C_SmallComment x11 -> d_C_maybeMo (Curry_Prelude.d_C_apply x1
    Curry_Prelude.OP_List cd cs) (Curry_Prelude.OP_Cons (C_SmallComment x11)
    (d_C_modHeadInLine Curry_Prelude.d_C_id x4 cd cs)) cd cs
  C_Meta x12 -> d_C_maybeMo (Curry_Prelude.d_C_apply x1 Curry_Prelude.OP_List cd
    cs) (Curry_Prelude.OP_Cons (C_Meta x12) x4) cd cs
  C_Text x13 -> Curry_Prelude.d_C_failed cd cs
  C_Letter x14 -> Curry_Prelude.d_C_failed cd cs
  C_ModuleHead x15 -> Curry_Prelude.d_C_failed cd cs
  Choice_C_Token d i l r -> narrow d i (d_C__case_14 x4 x1 l cd cs)
    (d_C__case_14 x4 x1 r cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_14 x4 x1 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_14 x4 x1 e cd x) $!
    addCs c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_14" [show x4, show x1, show x3] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_14"
    (showCons x3))

nd_C__case_14 :: Curry_Prelude.OP_List C_Token -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Token
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_14 x4 x1 x3 s cd cs = case x3 of
  C_Code x5 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_13 x5 x4 x1 (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_break
    (wrapDX id d_OP_modHeadInLine_dot_uscore_hash_lambda12) s0 cd cs) x5 s1 cd
    cs)) s3 cd cs))
  C_BigComment x10 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` d_C_maybeMo (Curry_Prelude.nd_C_apply x1
    Curry_Prelude.OP_List s0 cd cs) (Curry_Prelude.OP_Cons (C_BigComment x10)
    (nd_C_modHeadInLine (wrapDX id Curry_Prelude.d_C_id) x4 s1 cd cs)) cd cs))
  C_SmallComment x11 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` d_C_maybeMo (Curry_Prelude.nd_C_apply x1
    Curry_Prelude.OP_List s0 cd cs) (Curry_Prelude.OP_Cons (C_SmallComment x11)
    (nd_C_modHeadInLine (wrapDX id Curry_Prelude.d_C_id) x4 s1 cd cs)) cd cs))
  C_Meta x12 -> let s0 = s
    in s0 `seq` d_C_maybeMo (Curry_Prelude.nd_C_apply x1 Curry_Prelude.OP_List
    s0 cd cs) (Curry_Prelude.OP_Cons (C_Meta x12) x4) cd cs
  C_Text x13 -> Curry_Prelude.d_C_failed cd cs
  C_Letter x14 -> Curry_Prelude.d_C_failed cd cs
  C_ModuleHead x15 -> Curry_Prelude.d_C_failed cd cs
  Choice_C_Token d i l r -> narrow d i (nd_C__case_14 x4 x1 l s cd cs)
    (nd_C__case_14 x4 x1 r s cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> nd_C__case_14 x4 x1 z s cd cs)
    xs
  Guard_C_Token d c e -> guardCons d c ((\x -> nd_C__case_14 x4 x1 e s cd x) $!
    addCs c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_14" [show x4, show x1, show x3] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_14"
    (showCons x3))

d_C__case_13 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_Token -> (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
d_C__case_13 x5 x4 x1 x8 cd cs = case x8 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> d_C__case_12 x4 x5 x1 x6 x7 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_13 x5 x4 x1 l
    cd cs) (d_C__case_13 x5 x4 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_13
    x5 x4 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_13 x5
    x4 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_13" [show x5, show x4, show x1, show
    x8] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_13"
    (showCons x8))

nd_C__case_13 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_Token -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_13 x5 x4 x1 x8 s cd cs = case x8 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s0 = s
    in s0 `seq` nd_C__case_12 x4 x5 x1 x6 x7 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_13 x5 x4 x1 l
    s cd cs) (nd_C__case_13 x5 x4 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_13
    x5 x4 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_13 x5
    x4 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_13" [show x5, show x4, show x1, show
    x8] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_13"
    (showCons x8))

d_C__case_12 :: Curry_Prelude.OP_List C_Token -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
d_C__case_12 x4 x5 x1 x6 x7 cd cs = case x7 of
  Curry_Prelude.OP_Cons x8 x9 -> d_C_modHead (Curry_Prelude.d_OP_dot x1
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_OP_plus_plus x6) (acceptCs id
    (Curry_Prelude.OP_Cons x8)) cd cs) cd cs) (Curry_Prelude.OP_Cons (C_Code x9)
    x4) cd cs
  Curry_Prelude.OP_List -> d_C_modHead x1 (Curry_Prelude.OP_Cons (C_Code x5) x4)
    cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_12 x4 x5 x1 x6 l
    cd cs) (d_C__case_12 x4 x5 x1 x6 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_12 x4
    x5 x1 x6 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_12 x4 x5
    x1 x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_12" [show x4, show x5, show x1, show
    x6, show x7] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_12"
    (showCons x7))

nd_C__case_12 :: Curry_Prelude.OP_List C_Token -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
nd_C__case_12 x4 x5 x1 x6 x7 s cd cs = case x7 of
  Curry_Prelude.OP_Cons x8 x9 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C_modHead (let s1 = leftSupply s2
                                            s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot x1 (Curry_Prelude.nd_OP_dot
    (wrapDX id (Curry_Prelude.d_OP_plus_plus x6)) (wrapDX id (acceptCs id
    (Curry_Prelude.OP_Cons x8))) s0 cd cs) s1 cd cs)) (Curry_Prelude.OP_Cons
    (C_Code x9) x4) s3 cd cs))
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` nd_C_modHead x1 (Curry_Prelude.OP_Cons (C_Code x5) x4) s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_12 x4 x5 x1 x6
    l s cd cs) (nd_C__case_12 x4 x5 x1 x6 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_12 x4
    x5 x1 x6 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_12 x4 x5
    x1 x6 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_12" [show x4, show x5, show x1, show
    x6, show x7] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_12"
    (showCons x7))

d_C__case_11 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_11 x3 x1 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.C_False
  Curry_Prelude.C_False -> d_C__case_10 x1 x2 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_11 x3 x1 x2 l cd
    cs) (d_C__case_11 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_11 x3
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_11 x3 x1
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_11" [show x3, show x1, show x2, show
    x4] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_11"
    (showCons x4))

d_C__case_10 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_10 x1 x2 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 x2 cd cs) (let x4 = Curry_Prelude.d_C_splitAt (Curry_Prelude.d_C_length
                        x2 cd cs) x1 cd cs
                      x5 = d_OP_lineBeginsWith_dot_uscore_hash_selFP11_hash_s_tick
                        x4 cd cs
                      x6 = d_OP_lineBeginsWith_dot_uscore_hash_selFP12_hash_rest
                        x4 cd cs
    in Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 x5 cd cs) (Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_C_null x6 cd cs)
    (d_C_isSep (Curry_Prelude.d_C_head x6 cd cs) cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_10 x1 x2 l cd cs)
    (d_C__case_10 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_10 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_10 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_10" [show x1, show x2, show x7] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_10"
    (showCons x7))

d_C__case_9 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_Token -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_Token
d_C__case_9 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> x2
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (C_ModuleHead x1) (d_C__case_8
    x2 cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_9 x1 x2 l cd cs)
    (d_C__case_9 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_9 x1 x2
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_9 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_9" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_9" (showCons
    x3))

d_C__case_8 :: Curry_Prelude.OP_List C_Token -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_Token
d_C__case_8 x2 cd cs = case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_7 x2 x4 x3 cd cs
  Curry_Prelude.OP_List -> x2
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_8 l cd cs)
    (d_C__case_8 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_8 z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_8 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_8" [show x2] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_8" (showCons
    x2))

d_C__case_7 :: Curry_Prelude.OP_List C_Token -> Curry_Prelude.OP_List C_Token
  -> C_Token -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Token
d_C__case_7 x2 x4 x3 cd cs = case x3 of
  C_Code x5 -> Curry_Prelude.OP_Cons (C_Code (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '\n'#) x5)) x4
  C_SmallComment x6 -> x2
  C_BigComment x7 -> x2
  C_Text x8 -> x2
  C_Letter x9 -> x2
  C_ModuleHead x10 -> x2
  C_Meta x11 -> x2
  Choice_C_Token d i l r -> narrow d i (d_C__case_7 x2 x4 l cd cs) (d_C__case_7
    x2 x4 r cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_7 x2 x4 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_7 x2 x4 e cd x) $!
    addCs c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_7" [show x2, show x4, show x3] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_7" (showCons
    x3))

d_C__case_6 :: Curry_Prelude.OP_List C_Token -> C_Token -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_6 x3 x2 cd cs = case x2 of
  C_ModuleHead x4 -> d_C__case_5 x4 x3 cd cs
  C_Code x15 -> Curry_Prelude.d_OP_plus_plus x15 (d_C_plainCode x3 cd cs) cd cs
  C_Text x16 -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '"'#)
    (Curry_Prelude.d_OP_plus_plus x16 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '"'#) (d_C_plainCode x3 cd cs)) cd cs)
  C_Letter x17 -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '\''#)
    (Curry_Prelude.d_OP_plus_plus x17 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '\''#) (d_C_plainCode x3 cd cs)) cd cs)
  C_BigComment x18 -> d_C_plainCode x3 cd cs
  C_SmallComment x19 -> d_C_plainCode x3 cd cs
  C_Meta x20 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{+")
    (Curry_Prelude.d_OP_plus_plus x20 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "+}") (d_C_plainCode x3 cd cs) cd cs) cd cs) cd
    cs
  Choice_C_Token d i l r -> narrow d i (d_C__case_6 x3 l cd cs) (d_C__case_6 x3
    r cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_6 x3 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_6 x3 e cd x) $! addCs c
    cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_6" [show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_6" (showCons
    x2))

d_C__case_5 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_Token -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_5 x4 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x5 x6 -> let x7 = Curry_Prelude.d_OP_plus_plus x4
                                       (d_C_plainCode x3 cd cs) cd cs
    in d_C__case_4 x7 x6 x4 x5 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_plus_plus x4 (d_C_plainCode x3 cd
    cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_5 x4 l cd cs)
    (d_C__case_5 x4 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_5 x4 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_5 x4 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_5" [show x4, show x3] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_5" (showCons
    x3))

d_C__case_4 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_Token -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> C_Token -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_4 x7 x6 x4 x5 cd cs = case x5 of
  C_Code x8 -> Curry_Prelude.d_OP_plus_plus x4 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_drop (Curry_Prelude.C_Int (1)) x8 cd cs) (d_C_plainCode
    x6 cd cs) cd cs) cd cs
  C_SmallComment x9 -> x7
  C_BigComment x10 -> x7
  C_Text x11 -> x7
  C_Letter x12 -> x7
  C_ModuleHead x13 -> x7
  C_Meta x14 -> x7
  Choice_C_Token d i l r -> narrow d i (d_C__case_4 x7 x6 x4 l cd cs)
    (d_C__case_4 x7 x6 x4 r cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_4 x7 x6 x4 z cd cs)
    xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_4 x7 x6 x4 e cd x) $!
    addCs c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_4" [show x7, show x6, show x4, show
    x5] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_4" (showCons
    x5))

d_C__case_3 :: Curry_Prelude.OP_List C_Token -> C_Token -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_3 x3 x2 cd cs = case x2 of
  C_ModuleHead x4 -> Curry_Prelude.d_OP_plus_plus x4 (d_C__case_2 x3 cd cs) cd
    cs
  C_Code x17 -> Curry_Prelude.d_OP_plus_plus x17 (d_C_unscan x3 cd cs) cd cs
  C_Text x18 -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '"'#)
    (Curry_Prelude.d_OP_plus_plus x18 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '"'#) (d_C_unscan x3 cd cs)) cd cs)
  C_Letter x19 -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '\''#)
    (Curry_Prelude.d_OP_plus_plus x19 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '\''#) (d_C_unscan x3 cd cs)) cd cs)
  C_BigComment x20 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "{-") (Curry_Prelude.d_OP_plus_plus x20 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "-}") (d_C_unscan x3 cd cs) cd cs) cd cs) cd cs
  C_SmallComment x21 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "--") (Curry_Prelude.d_OP_plus_plus x21
    (d_C_unscan x3 cd cs) cd cs) cd cs
  C_Meta x22 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{+")
    (Curry_Prelude.d_OP_plus_plus x22 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "+}") (d_C_unscan x3 cd cs) cd cs) cd cs) cd cs
  Choice_C_Token d i l r -> narrow d i (d_C__case_3 x3 l cd cs) (d_C__case_3 x3
    r cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_3 x3 z cd cs) xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_3 x3 e cd x) $! addCs c
    cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_3" [show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_3" (showCons
    x2))

d_C__case_2 :: Curry_Prelude.OP_List C_Token -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x5 x6 -> let x7 = d_C_unscan x3 cd cs
    in d_C__case_1 x7 x3 x6 x5 cd cs
  Curry_Prelude.OP_List -> d_C_unscan x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_2 l cd cs)
    (d_C__case_2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_2 z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_2 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_2" [show x3] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_2" (showCons
    x3))

d_C__case_1 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_Token -> Curry_Prelude.OP_List C_Token -> C_Token
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_1 x7 x3 x6 x5 cd cs = case x5 of
  C_Code x8 -> d_C__case_0 x3 x6 x8 cd cs
  C_SmallComment x11 -> x7
  C_BigComment x12 -> x7
  C_Text x13 -> x7
  C_Letter x14 -> x7
  C_ModuleHead x15 -> x7
  C_Meta x16 -> x7
  Choice_C_Token d i l r -> narrow d i (d_C__case_1 x7 x3 x6 l cd cs)
    (d_C__case_1 x7 x3 x6 r cd cs)
  Choices_C_Token d i xs -> narrows cs d i (\z -> d_C__case_1 x7 x3 x6 z cd cs)
    xs
  Guard_C_Token d c e -> guardCons d c ((\x -> d_C__case_1 x7 x3 x6 e cd x) $!
    addCs c cs)
  Fail_C_Token d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_1" [show x7, show x3, show x6, show
    x5] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_1" (showCons
    x5))

d_C__case_0 :: Curry_Prelude.OP_List C_Token -> Curry_Prelude.OP_List C_Token
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_0 x3 x6 x8 cd cs = case x8 of
  Curry_Prelude.OP_Cons x9 x10 -> d_C_unscan (Curry_Prelude.OP_Cons (C_Code x10)
    x6) cd cs
  Curry_Prelude.OP_List -> d_C_unscan x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_0 x3 x6 l cd cs)
    (d_C__case_0 x3 x6 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_0 x3
    x6 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_0 x3 x6 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Language.Curry.StringClassifier._case_0" [show x3, show x6, show x8] info)
  _ -> failCons cd (consFail "Language.Curry.StringClassifier._case_0" (showCons
    x8))

