{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module HTML.Curry_LaTeX
  ( d_C_showLatexExps
  , nd_C_showLatexExps
  , d_C_showLatexExp
  , nd_C_showLatexExp
  , d_C_htmlSpecialChars2tex
  , d_C_showLatexDoc
  , nd_C_showLatexDoc
  , d_C_showLatexDocWithPackages
  , nd_C_showLatexDocWithPackages
  , d_C_showLatexDocs
  , nd_C_showLatexDocs
  , d_C_showLatexDocsWithPackages
  , nd_C_showLatexDocsWithPackages
  , d_C_germanLatexDoc
  , nd_C_germanLatexDoc )
  where

import Basics
import qualified Data.Curry_List
import qualified HTML.Curry_Base
import qualified Curry_Prelude


d_C_showLatexExps :: Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showLatexExps x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concat
  cd cs) (Curry_Prelude.d_C_map d_C_showLatexExp x1 cd cs) cd cs

nd_C_showLatexExps :: Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C_showLatexExps x1 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_C_concat s0 cd cs) (Curry_Prelude.nd_C_map (wrapNX id
  nd_C_showLatexExp) x1 s1 cd cs) s2 cd cs))))

d_C_showLatexExp :: HTML.Curry_Base.C_BaseHtml -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showLatexExp x1 cd cs = case x1 of
  HTML.Curry_Base.C_BaseText x2 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply (d_C_specialchars2tex cd cs) x2 cd cs)
    (Curry_Prelude.toCurryString "}") cd cs) cd cs
  HTML.Curry_Base.C_BaseStruct x3 x4 x5 -> d_C__case_134 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "html") cd cs) cd cs
  HTML.Curry_Base.C_BaseAction x7 -> Curry_Prelude.d_C_error
    (Curry_Prelude.toCurryString "HTML.LaTeX.showLatexExp: BaseAction") cd cs
  HTML.Curry_Base.Choice_C_BaseHtml d i l r -> narrow d i (d_C_showLatexExp l cd
    cs) (d_C_showLatexExp r cd cs)
  HTML.Curry_Base.Choices_C_BaseHtml d i xs -> narrows cs d i (\z ->
    d_C_showLatexExp z cd cs) xs
  HTML.Curry_Base.Guard_C_BaseHtml d c e -> guardCons d c ((\x ->
    d_C_showLatexExp e cd x) $! addCs c cs)
  HTML.Curry_Base.Fail_C_BaseHtml d info -> failCons d (traceFail
    "HTML.LaTeX.showLatexExp" [show x1] info)
  _ -> failCons cd (consFail "HTML.LaTeX.showLatexExp" (showCons x1))

nd_C_showLatexExp :: HTML.Curry_Base.C_BaseHtml -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C_showLatexExp x1 s cd cs = case x1 of
  HTML.Curry_Base.C_BaseText x2 -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_apply (wrapDX id
    (d_C_specialchars2tex cd cs)) x2 s0 cd cs) (Curry_Prelude.toCurryString "}")
    cd cs) cd cs
  HTML.Curry_Base.C_BaseStruct x3 x4 x5 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_134 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "html") s0 cd cs) s1 cd cs))
  HTML.Curry_Base.C_BaseAction x7 -> Curry_Prelude.d_C_error
    (Curry_Prelude.toCurryString "HTML.LaTeX.showLatexExp: BaseAction") cd cs
  HTML.Curry_Base.Choice_C_BaseHtml d i l r -> narrow d i (nd_C_showLatexExp l s
    cd cs) (nd_C_showLatexExp r s cd cs)
  HTML.Curry_Base.Choices_C_BaseHtml d i xs -> narrows cs d i (\z ->
    nd_C_showLatexExp z s cd cs) xs
  HTML.Curry_Base.Guard_C_BaseHtml d c e -> guardCons d c ((\x ->
    nd_C_showLatexExp e s cd x) $! addCs c cs)
  HTML.Curry_Base.Fail_C_BaseHtml d info -> failCons d (traceFail
    "HTML.LaTeX.showLatexExp" [show x1] info)
  _ -> failCons cd (consFail "HTML.LaTeX.showLatexExp" (showCons x1))

d_OP_showLatexExp_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_showLatexExp_dot_uscore_hash_lambda1 x1 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\\footnote{\\tt ")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply (d_C_specialchars2tex
  cd cs) x1 cd cs) (Curry_Prelude.toCurryString "}\n") cd cs) cd cs

d_C_latexEnvironment :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_latexEnvironment x1 x2 cd cs = d_C_attrLatexEnv x1 Curry_Prelude.OP_List x2
  cd cs

d_C_attrLatexEnv :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_attrLatexEnv x1 x2 x3 cd cs = Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\\begin{") (Curry_Prelude.d_OP_plus_plus x1
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "}")
  (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\n") (Curry_Prelude.d_OP_plus_plus x3
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\n\\end{")
  (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString "}\n") cd cs) cd
  cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs

d_C_latexTabFormat :: Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_latexTabFormat x1 cd cs = let x2 = Curry_Prelude.d_C_foldl
                                    (Curry_Prelude.d_OP_uscore_impl_hash_max_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
                                    cd cs) (Curry_Prelude.C_Int (0))
                                    (Curry_Prelude.d_C_map d_C_getBreadth x1 cd
                                    cs) cd cs
  in Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_replicate x2
  (Curry_Prelude.C_Char 'l'#) cd cs) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "}") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\\setcounter{LTchunksize}{")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_length x1 cd cs) (Curry_Prelude.C_Int (5)) cd cs) cd cs)
  (Curry_Prelude.toCurryString "}%") cd cs) cd cs) cd cs) cd cs) cd cs

nd_C_latexTabFormat :: Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C_latexTabFormat x1 s cd cs = let s4 = s
  in s4 `seq` (let s2 = leftSupply s4
                   s3 = rightSupply s4
  in s2 `seq` (s3 `seq` (let x2 = let s1 = leftSupply s2
                                      s0 = rightSupply s2
                               in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_foldl
                               (wrapDX (wrapDX id)
                               (Curry_Prelude.d_OP_uscore_impl_hash_max_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
                               cd cs)) (Curry_Prelude.C_Int (0))
                               (Curry_Prelude.nd_C_map (wrapNX id
                               nd_C_getBreadth) x1 s0 cd cs) s1 cd cs)
  in Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_replicate x2
  (Curry_Prelude.C_Char 'l'#) cd cs) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "}") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\\setcounter{LTchunksize}{")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_apply (wrapDX id
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs))
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_length x1 cd cs) (Curry_Prelude.C_Int (5)) cd cs) s3 cd cs)
  (Curry_Prelude.toCurryString "}%") cd cs) cd cs) cd cs) cd cs) cd cs)))

d_C_getBreadth :: HTML.Curry_Base.C_BaseHtml -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_C_getBreadth x1 cd cs = let x2 = Curry_Prelude.d_C_error
                                (Curry_Prelude.toCurryString
                                "getBreadth: no row given") cd cs
  in d_C__case_97 x2 x1 cd cs

nd_C_getBreadth :: HTML.Curry_Base.C_BaseHtml -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
nd_C_getBreadth x1 s cd cs = let s0 = s
  in s0 `seq` (let x2 = Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
                     "getBreadth: no row given") cd cs
  in nd_C__case_97 x2 x1 s0 cd cs)

d_C_showLatexTableContents :: Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showLatexTableContents x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_concatMap d_C_showLatexTableContent cd cs) x1 cd cs

nd_C_showLatexTableContents :: Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C_showLatexTableContents x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_concatMap
  (wrapNX id nd_C_showLatexTableContent) s0 cd cs) x1 s1 cd cs))

d_C_showLatexTableContent :: HTML.Curry_Base.C_BaseHtml -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showLatexTableContent x1 cd cs = case x1 of
  HTML.Curry_Base.C_BaseText x2 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply (d_C_specialchars2tex cd cs) x2 cd cs)
    (Curry_Prelude.toCurryString "}") cd cs) cd cs
  HTML.Curry_Base.C_BaseStruct x3 x4 x5 -> d_C__case_95 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "html") cd cs) cd cs
  HTML.Curry_Base.C_BaseAction x7 -> Curry_Prelude.d_C_error
    (Curry_Prelude.toCurryString "HTML.LaTeX.showLatexTableContent: BaseAction")
    cd cs
  HTML.Curry_Base.Choice_C_BaseHtml d i l r -> narrow d i
    (d_C_showLatexTableContent l cd cs) (d_C_showLatexTableContent r cd cs)
  HTML.Curry_Base.Choices_C_BaseHtml d i xs -> narrows cs d i (\z ->
    d_C_showLatexTableContent z cd cs) xs
  HTML.Curry_Base.Guard_C_BaseHtml d c e -> guardCons d c ((\x ->
    d_C_showLatexTableContent e cd x) $! addCs c cs)
  HTML.Curry_Base.Fail_C_BaseHtml d info -> failCons d (traceFail
    "HTML.LaTeX.showLatexTableContent" [show x1] info)
  _ -> failCons cd (consFail "HTML.LaTeX.showLatexTableContent" (showCons x1))

nd_C_showLatexTableContent :: HTML.Curry_Base.C_BaseHtml -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C_showLatexTableContent x1 s cd cs = case x1 of
  HTML.Curry_Base.C_BaseText x2 -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_apply (wrapDX id
    (d_C_specialchars2tex cd cs)) x2 s0 cd cs) (Curry_Prelude.toCurryString "}")
    cd cs) cd cs
  HTML.Curry_Base.C_BaseStruct x3 x4 x5 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_95 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "html") s0 cd cs) s1 cd cs))
  HTML.Curry_Base.C_BaseAction x7 -> Curry_Prelude.d_C_error
    (Curry_Prelude.toCurryString "HTML.LaTeX.showLatexTableContent: BaseAction")
    cd cs
  HTML.Curry_Base.Choice_C_BaseHtml d i l r -> narrow d i
    (nd_C_showLatexTableContent l s cd cs) (nd_C_showLatexTableContent r s cd
    cs)
  HTML.Curry_Base.Choices_C_BaseHtml d i xs -> narrows cs d i (\z ->
    nd_C_showLatexTableContent z s cd cs) xs
  HTML.Curry_Base.Guard_C_BaseHtml d c e -> guardCons d c ((\x ->
    nd_C_showLatexTableContent e s cd x) $! addCs c cs)
  HTML.Curry_Base.Fail_C_BaseHtml d info -> failCons d (traceFail
    "HTML.LaTeX.showLatexTableContent" [show x1] info)
  _ -> failCons cd (consFail "HTML.LaTeX.showLatexTableContent" (showCons x1))

d_OP_showLatexTableContent_dot_uscore_hash_lambda3 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_showLatexTableContent_dot_uscore_hash_lambda3 x1 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\\footnote{\\tt ")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply (d_C_specialchars2tex
  cd cs) x1 cd cs) (Curry_Prelude.toCurryString "}\n") cd cs) cd cs

d_C_findHtmlAttr :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C_findHtmlAttr x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.C_Nothing
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_75 x1 x4 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_findHtmlAttr x1 l cd
    cs) (d_C_findHtmlAttr x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_findHtmlAttr
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_findHtmlAttr x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "HTML.LaTeX.findHtmlAttr" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX.findHtmlAttr" (showCons x2))

d_C_specialchars2tex :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_specialchars2tex cd cs = Curry_Prelude.d_OP_dot d_C_htmlSpecialChars2tex
  d_C_escapeLaTeXSpecials cd cs

d_C_escapeLaTeXSpecials :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_escapeLaTeXSpecials x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_73 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '^'#) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_escapeLaTeXSpecials l
    cd cs) (d_C_escapeLaTeXSpecials r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_escapeLaTeXSpecials z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_C_escapeLaTeXSpecials e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "HTML.LaTeX.escapeLaTeXSpecials" [show x1] info)
  _ -> failCons cd (consFail "HTML.LaTeX.escapeLaTeXSpecials" (showCons x1))

d_C_htmlSpecialChars2tex :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_htmlSpecialChars2tex x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_61 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.d_C_chr (Curry_Prelude.C_Int (228)) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_htmlSpecialChars2tex l
    cd cs) (d_C_htmlSpecialChars2tex r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_htmlSpecialChars2tex z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_C_htmlSpecialChars2tex e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "HTML.LaTeX.htmlSpecialChars2tex" [show x1] info)
  _ -> failCons cd (consFail "HTML.LaTeX.htmlSpecialChars2tex" (showCons x1))

d_OP_htmlSpecialChars2tex_dot_uscore_hash_selFP2_hash_special :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_htmlSpecialChars2tex_dot_uscore_hash_selFP2_hash_special x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_htmlSpecialChars2tex_dot_uscore_hash_selFP2_hash_special l cd cs)
    (d_OP_htmlSpecialChars2tex_dot_uscore_hash_selFP2_hash_special r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_htmlSpecialChars2tex_dot_uscore_hash_selFP2_hash_special z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_htmlSpecialChars2tex_dot_uscore_hash_selFP2_hash_special e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.LaTeX.htmlSpecialChars2tex._#selFP2#special" [show x1] info)
  _ -> failCons cd (consFail "HTML.LaTeX.htmlSpecialChars2tex._#selFP2#special"
    (showCons x1))

d_OP_htmlSpecialChars2tex_dot_uscore_hash_selFP3_hash_rest :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_htmlSpecialChars2tex_dot_uscore_hash_selFP3_hash_rest x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_htmlSpecialChars2tex_dot_uscore_hash_selFP3_hash_rest l cd cs)
    (d_OP_htmlSpecialChars2tex_dot_uscore_hash_selFP3_hash_rest r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_htmlSpecialChars2tex_dot_uscore_hash_selFP3_hash_rest z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_htmlSpecialChars2tex_dot_uscore_hash_selFP3_hash_rest e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.LaTeX.htmlSpecialChars2tex._#selFP3#rest" [show x1] info)
  _ -> failCons cd (consFail "HTML.LaTeX.htmlSpecialChars2tex._#selFP3#rest"
    (showCons x1))

d_C_htmlspecial2tex :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_htmlspecial2tex x1 cd cs = d_C__case_51 x1
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.toCurryString "Auml") cd cs) cd cs

d_C_showLatexDoc :: Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showLatexDoc x1 cd cs = d_C_showLatexDocs (Curry_Prelude.OP_Cons x1
  Curry_Prelude.OP_List) cd cs

nd_C_showLatexDoc :: Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C_showLatexDoc x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_showLatexDocs (Curry_Prelude.OP_Cons x1
  Curry_Prelude.OP_List) s0 cd cs

d_C_showLatexDocWithPackages :: Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showLatexDocWithPackages x1 x2 cd cs = d_C_showLatexDocsWithPackages
  (Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List) x2 cd cs

nd_C_showLatexDocWithPackages :: Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C_showLatexDocWithPackages x1 x2 s cd cs = let s0 = s
  in s0 `seq` nd_C_showLatexDocsWithPackages (Curry_Prelude.OP_Cons x1
  Curry_Prelude.OP_List) x2 s0 cd cs

d_C_showLatexDocs :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_showLatexDocs x1 cd cs = d_C_showLatexDocsWithPackages x1
  Curry_Prelude.OP_List cd cs

nd_C_showLatexDocs :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C_showLatexDocs x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_showLatexDocsWithPackages x1 Curry_Prelude.OP_List s0 cd cs

d_C_showLatexDocsWithPackages :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_showLatexDocsWithPackages x1 x2 cd cs = Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\\documentclass[12pt]{article}\n")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_concatMap
  d_OP_showLatexDocsWithPackages_dot_uscore_hash_lambda4 cd cs) x2 cd cs)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "\\usepackage{longtable}") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\\nonstopmode\n") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\\setlength{\\topmargin}{ -1.5cm}\n")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "\\setlength{\\oddsidemargin}{0.0cm}\n") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\\setlength{\\evensidemargin}{0.0cm}\n")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "\\setlength{\\marginparwidth}{0.0cm}\n") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\\setlength{\\marginparsep}{0.0cm}\n")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "\\setlength{\\textwidth}{16.5cm}\n") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\\setlength{\\textheight}{24.0cm}\n")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "\\pagestyle{empty}\n") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\\begin{document}\n\\sloppy\n")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "\\addtolength{\\baselineskip}{0.0ex}\n") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\\setlength{\\parindent}{0.0ex}\n")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "\\addtolength{\\parskip}{0.5ex}\n") (Curry_Prelude.d_OP_plus_plus
  (Data.Curry_List.d_C_intercalate (Curry_Prelude.toCurryString "\\newpage\n")
  (Curry_Prelude.d_C_map d_C_showLatexExps x1 cd cs) cd cs)
  (Curry_Prelude.toCurryString "\\end{document}\n") cd cs) cd cs) cd cs) cd cs)
  cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs)
  cd cs) cd cs

nd_C_showLatexDocsWithPackages :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C_showLatexDocsWithPackages x1 x2 s cd cs = let s4 = s
  in s4 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "\\documentclass[12pt]{article}\n") (let s2 = leftSupply s4
                                           s3 = rightSupply s4
  in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_plus_plus (let s1 = leftSupply s2
                                                          s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_concatMap
  (wrapDX id d_OP_showLatexDocsWithPackages_dot_uscore_hash_lambda4) s0 cd cs)
  x2 s1 cd cs)) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "\\usepackage{longtable}") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\\nonstopmode\n") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\\setlength{\\topmargin}{ -1.5cm}\n")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "\\setlength{\\oddsidemargin}{0.0cm}\n") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\\setlength{\\evensidemargin}{0.0cm}\n")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "\\setlength{\\marginparwidth}{0.0cm}\n") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\\setlength{\\marginparsep}{0.0cm}\n")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "\\setlength{\\textwidth}{16.5cm}\n") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\\setlength{\\textheight}{24.0cm}\n")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "\\pagestyle{empty}\n") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\\begin{document}\n\\sloppy\n")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "\\addtolength{\\baselineskip}{0.0ex}\n") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\\setlength{\\parindent}{0.0ex}\n")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "\\addtolength{\\parskip}{0.5ex}\n") (Curry_Prelude.d_OP_plus_plus
  (Data.Curry_List.d_C_intercalate (Curry_Prelude.toCurryString "\\newpage\n")
  (Curry_Prelude.nd_C_map (wrapNX id nd_C_showLatexExps) x1 s3 cd cs) cd cs)
  (Curry_Prelude.toCurryString "\\end{document}\n") cd cs) cd cs) cd cs) cd cs)
  cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs)
  cd cs)) cd cs

d_OP_showLatexDocsWithPackages_dot_uscore_hash_lambda4 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_showLatexDocsWithPackages_dot_uscore_hash_lambda4 x1 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\\usepackage{")
  (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString "}\n") cd cs) cd
  cs

d_C_germanLatexDoc :: Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_germanLatexDoc x1 cd cs = d_C_showLatexDocWithPackages x1
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "ngerman")
  Curry_Prelude.OP_List) cd cs

nd_C_germanLatexDoc :: Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C_germanLatexDoc x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_showLatexDocWithPackages x1 (Curry_Prelude.OP_Cons
  (Curry_Prelude.toCurryString "ngerman") Curry_Prelude.OP_List) s0 cd cs

d_C__case_134 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_134 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_showLatexExps x5 cd cs
  Curry_Prelude.C_False -> d_C__case_133 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "head") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_134 x3 x4 x5 l cd
    cs) (d_C__case_134 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_134 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_134 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_134" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_134" (showCons x6))

nd_C__case_134 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_134 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C_showLatexExps x5 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_133 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "head") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_134 x3 x4 x5 l s
    cd cs) (nd_C__case_134 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_134 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_134 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_134" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_134" (showCons x6))

d_C__case_133 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_133 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> d_C__case_132 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "body") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_133 x3 x4 x5 l cd
    cs) (d_C__case_133 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_133 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_133 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_133" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_133" (showCons x6))

nd_C__case_133 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_133 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_132 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "body") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_133 x3 x4 x5 l s
    cd cs) (nd_C__case_133 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_133 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_133 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_133" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_133" (showCons x6))

d_C__case_132 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_132 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_showLatexExps x5 cd cs
  Curry_Prelude.C_False -> d_C__case_131 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "form") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_132 x3 x4 x5 l cd
    cs) (d_C__case_132 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_132 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_132 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_132" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_132" (showCons x6))

nd_C__case_132 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_132 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C_showLatexExps x5 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_131 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "form") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_132 x3 x4 x5 l s
    cd cs) (nd_C__case_132 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_132 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_132 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_132" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_132" (showCons x6))

d_C__case_131 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_131 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_showLatexExps x5 cd cs
  Curry_Prelude.C_False -> d_C__case_130 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "h1") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_131 x3 x4 x5 l cd
    cs) (d_C__case_131 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_131 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_131 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_131" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_131" (showCons x6))

nd_C__case_131 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_131 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C_showLatexExps x5 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_130 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "h1") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_131 x3 x4 x5 l s
    cd cs) (nd_C__case_131 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_131 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_131 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_131" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_131" (showCons x6))

d_C__case_130 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_130 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\section*{") (Curry_Prelude.d_OP_plus_plus
    (d_C_showLatexExps x5 cd cs) (Curry_Prelude.toCurryString "}\n") cd cs) cd
    cs
  Curry_Prelude.C_False -> d_C__case_129 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "h2") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_130 x3 x4 x5 l cd
    cs) (d_C__case_130 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_130 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_130 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_130" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_130" (showCons x6))

nd_C__case_130 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_130 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\section*{") (Curry_Prelude.d_OP_plus_plus (nd_C_showLatexExps x5 s0 cd
    cs) (Curry_Prelude.toCurryString "}\n") cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_129 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "h2") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_130 x3 x4 x5 l s
    cd cs) (nd_C__case_130 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_130 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_130 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_130" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_130" (showCons x6))

d_C__case_129 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_129 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\subsection*{") (Curry_Prelude.d_OP_plus_plus
    (d_C_showLatexExps x5 cd cs) (Curry_Prelude.toCurryString "}\n") cd cs) cd
    cs
  Curry_Prelude.C_False -> d_C__case_128 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "h3") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_129 x3 x4 x5 l cd
    cs) (d_C__case_129 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_129 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_129 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_129" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_129" (showCons x6))

nd_C__case_129 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_129 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\subsection*{") (Curry_Prelude.d_OP_plus_plus (nd_C_showLatexExps x5 s0 cd
    cs) (Curry_Prelude.toCurryString "}\n") cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_128 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "h3") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_129 x3 x4 x5 l s
    cd cs) (nd_C__case_129 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_129 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_129 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_129" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_129" (showCons x6))

d_C__case_128 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_128 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\subsubsection*{")
    (Curry_Prelude.d_OP_plus_plus (d_C_showLatexExps x5 cd cs)
    (Curry_Prelude.toCurryString "}\n") cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_127 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "h4") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_128 x3 x4 x5 l cd
    cs) (d_C__case_128 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_128 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_128 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_128" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_128" (showCons x6))

nd_C__case_128 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_128 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\subsubsection*{") (Curry_Prelude.d_OP_plus_plus (nd_C_showLatexExps x5 s0
    cd cs) (Curry_Prelude.toCurryString "}\n") cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_127 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "h4") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_128 x3 x4 x5 l s
    cd cs) (nd_C__case_128 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_128 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_128 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_128" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_128" (showCons x6))

d_C__case_127 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_127 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\paragraph*{") (Curry_Prelude.d_OP_plus_plus
    (d_C_showLatexExps x5 cd cs) (Curry_Prelude.toCurryString "}\n") cd cs) cd
    cs
  Curry_Prelude.C_False -> d_C__case_126 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "h5") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_127 x3 x4 x5 l cd
    cs) (d_C__case_127 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_127 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_127 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_127" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_127" (showCons x6))

nd_C__case_127 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_127 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\paragraph*{") (Curry_Prelude.d_OP_plus_plus (nd_C_showLatexExps x5 s0 cd
    cs) (Curry_Prelude.toCurryString "}\n") cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_126 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "h5") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_127 x3 x4 x5 l s
    cd cs) (nd_C__case_127 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_127 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_127 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_127" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_127" (showCons x6))

d_C__case_126 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_126 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\subparagraph*{")
    (Curry_Prelude.d_OP_plus_plus (d_C_showLatexExps x5 cd cs)
    (Curry_Prelude.toCurryString "}\n") cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_125 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "p") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_126 x3 x4 x5 l cd
    cs) (d_C__case_126 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_126 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_126 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_126" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_126" (showCons x6))

nd_C__case_126 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_126 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\subparagraph*{") (Curry_Prelude.d_OP_plus_plus (nd_C_showLatexExps x5 s0
    cd cs) (Curry_Prelude.toCurryString "}\n") cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_125 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "p") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_126 x3 x4 x5 l s
    cd cs) (nd_C__case_126 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_126 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_126 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_126" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_126" (showCons x6))

d_C__case_125 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_125 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus (d_C_showLatexExps x5 cd
    cs) (Curry_Prelude.toCurryString "\\par\n") cd cs
  Curry_Prelude.C_False -> d_C__case_124 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "b") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_125 x3 x4 x5 l cd
    cs) (d_C__case_125 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_125 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_125 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_125" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_125" (showCons x6))

nd_C__case_125 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_125 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_showLatexExps x5 s0 cd cs)
    (Curry_Prelude.toCurryString "\\par\n") cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_124 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "b") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_125 x3 x4 x5 l s
    cd cs) (nd_C__case_125 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_125 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_125 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_125" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_125" (showCons x6))

d_C__case_124 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_124 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\bf ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showLatexExps x5 cd cs) (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_123 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "em") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_124 x3 x4 x5 l cd
    cs) (d_C__case_124 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_124 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_124 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_124" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_124" (showCons x6))

nd_C__case_124 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_124 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "{\\bf ") (Curry_Prelude.d_OP_plus_plus (nd_C_showLatexExps x5 s0 cd cs)
    (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_123 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "em") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_124 x3 x4 x5 l s
    cd cs) (nd_C__case_124 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_124 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_124 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_124" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_124" (showCons x6))

d_C__case_123 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_123 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\emph{") (Curry_Prelude.d_OP_plus_plus
    (d_C_showLatexExps x5 cd cs) (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_122 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "i") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_123 x3 x4 x5 l cd
    cs) (d_C__case_123 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_123 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_123 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_123" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_123" (showCons x6))

nd_C__case_123 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_123 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\emph{") (Curry_Prelude.d_OP_plus_plus (nd_C_showLatexExps x5 s0 cd cs)
    (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_122 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "i") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_123 x3 x4 x5 l s
    cd cs) (nd_C__case_123 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_123 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_123 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_123" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_123" (showCons x6))

d_C__case_122 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_122 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\it ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showLatexExps x5 cd cs) (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_121 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "tt") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_122 x3 x4 x5 l cd
    cs) (d_C__case_122 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_122 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_122 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_122" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_122" (showCons x6))

nd_C__case_122 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_122 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "{\\it ") (Curry_Prelude.d_OP_plus_plus (nd_C_showLatexExps x5 s0 cd cs)
    (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_121 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "tt") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_122 x3 x4 x5 l s
    cd cs) (nd_C__case_122 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_122 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_122 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_122" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_122" (showCons x6))

d_C__case_121 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_121 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\tt ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showLatexExps x5 cd cs) (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_120 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "code") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_121 x3 x4 x5 l cd
    cs) (d_C__case_121 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_121 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_121 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_121" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_121" (showCons x6))

nd_C__case_121 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_121 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "{\\tt ") (Curry_Prelude.d_OP_plus_plus (nd_C_showLatexExps x5 s0 cd cs)
    (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_120 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "code") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_121 x3 x4 x5 l s
    cd cs) (nd_C__case_121 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_121 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_121 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_121" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_121" (showCons x6))

d_C__case_120 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_120 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\tt ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showLatexExps x5 cd cs) (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_119 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "center") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_120 x3 x4 x5 l cd
    cs) (d_C__case_120 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_120 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_120 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_120" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_120" (showCons x6))

nd_C__case_120 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_120 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "{\\tt ") (Curry_Prelude.d_OP_plus_plus (nd_C_showLatexExps x5 s0 cd cs)
    (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_119 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "center") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_120 x3 x4 x5 l s
    cd cs) (nd_C__case_120 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_120 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_120 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_120" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_120" (showCons x6))

d_C__case_119 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_119 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_latexEnvironment (Curry_Prelude.toCurryString
    "center") (d_C_showLatexExps x5 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_118 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "pre") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_119 x3 x4 x5 l cd
    cs) (d_C__case_119 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_119 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_119 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_119" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_119" (showCons x6))

nd_C__case_119 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_119 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` d_C_latexEnvironment (Curry_Prelude.toCurryString "center")
    (nd_C_showLatexExps x5 s0 cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_118 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "pre") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_119 x3 x4 x5 l s
    cd cs) (nd_C__case_119 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_119 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_119 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_119" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_119" (showCons x6))

d_C__case_118 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_118 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_latexEnvironment (Curry_Prelude.toCurryString
    "verbatim") (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_textOf
    HTML.Curry_Base.d_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_BaseHtml_hash
    cd cs) x5 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_117 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "font") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_118 x3 x4 x5 l cd
    cs) (d_C__case_118 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_118 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_118 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_118" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_118" (showCons x6))

nd_C__case_118 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_118 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` d_C_latexEnvironment (Curry_Prelude.toCurryString "verbatim")
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (HTML.Curry_Base.nd_C_textOf
    (wrapNX id
    HTML.Curry_Base.nd_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_BaseHtml_hash)
    s0 cd cs) x5 s1 cd cs)) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_117 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "font") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_118 x3 x4 x5 l s
    cd cs) (nd_C__case_118 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_118 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_118 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_118" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_118" (showCons x6))

d_C__case_117 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_117 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_showLatexExps x5 cd cs
  Curry_Prelude.C_False -> d_C__case_116 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "address") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_117 x3 x4 x5 l cd
    cs) (d_C__case_117 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_117 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_117 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_117" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_117" (showCons x6))

nd_C__case_117 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_117 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C_showLatexExps x5 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_116 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "address") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_117 x3 x4 x5 l s
    cd cs) (nd_C__case_117 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_117 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_117 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_117" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_117" (showCons x6))

d_C__case_116 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_116 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_showLatexExps x5 cd cs
  Curry_Prelude.C_False -> d_C__case_115 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "blink") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_116 x3 x4 x5 l cd
    cs) (d_C__case_116 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_116 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_116 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_116" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_116" (showCons x6))

nd_C__case_116 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_116 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C_showLatexExps x5 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_115 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "blink") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_116 x3 x4 x5 l s
    cd cs) (nd_C__case_116 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_116 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_116 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_116" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_116" (showCons x6))

d_C__case_115 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_115 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_showLatexExps x5 cd cs
  Curry_Prelude.C_False -> d_C__case_114 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "sub") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_115 x3 x4 x5 l cd
    cs) (d_C__case_115 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_115 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_115 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_115" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_115" (showCons x6))

nd_C__case_115 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_115 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C_showLatexExps x5 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_114 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "sub") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_115 x3 x4 x5 l s
    cd cs) (nd_C__case_115 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_115 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_115 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_115" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_115" (showCons x6))

d_C__case_114 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_114 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "$_{\\mbox{") (Curry_Prelude.d_OP_plus_plus
    (d_C_showLatexExps x5 cd cs) (Curry_Prelude.toCurryString "}}$") cd cs) cd
    cs
  Curry_Prelude.C_False -> d_C__case_113 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "sup") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_114 x3 x4 x5 l cd
    cs) (d_C__case_114 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_114 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_114 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_114" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_114" (showCons x6))

nd_C__case_114 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_114 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "$_{\\mbox{") (Curry_Prelude.d_OP_plus_plus (nd_C_showLatexExps x5 s0 cd cs)
    (Curry_Prelude.toCurryString "}}$") cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_113 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "sup") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_114 x3 x4 x5 l s
    cd cs) (nd_C__case_114 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_114 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_114 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_114" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_114" (showCons x6))

d_C__case_113 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_113 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "$^{\\mbox{") (Curry_Prelude.d_OP_plus_plus
    (d_C_showLatexExps x5 cd cs) (Curry_Prelude.toCurryString "}}$") cd cs) cd
    cs
  Curry_Prelude.C_False -> d_C__case_112 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "a") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_113 x3 x4 x5 l cd
    cs) (d_C__case_113 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_113 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_113 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_113" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_113" (showCons x6))

nd_C__case_113 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_113 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "$^{\\mbox{") (Curry_Prelude.d_OP_plus_plus (nd_C_showLatexExps x5 s0 cd cs)
    (Curry_Prelude.toCurryString "}}$") cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_112 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "a") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_113 x3 x4 x5 l s
    cd cs) (nd_C__case_113 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_113 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_113 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_113" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_113" (showCons x6))

d_C__case_112 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_112 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus (d_C_showLatexExps x5 cd
    cs) (Curry_Prelude.d_C_maybe Curry_Prelude.OP_List
    d_OP_showLatexExp_dot_uscore_hash_lambda1 (d_C_findHtmlAttr
    (Curry_Prelude.toCurryString "href") x4 cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_111 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "ul") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_112 x3 x4 x5 l cd
    cs) (d_C__case_112 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_112 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_112 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_112" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_112" (showCons x6))

nd_C__case_112 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_112 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_showLatexExps x5 s0
    cd cs) (Curry_Prelude.nd_C_maybe Curry_Prelude.OP_List (wrapDX id
    d_OP_showLatexExp_dot_uscore_hash_lambda1) (d_C_findHtmlAttr
    (Curry_Prelude.toCurryString "href") x4 cd cs) s1 cd cs) cd cs))
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_111 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "ul") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_112 x3 x4 x5 l s
    cd cs) (nd_C__case_112 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_112 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_112 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_112" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_112" (showCons x6))

d_C__case_111 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_111 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_latexEnvironment (Curry_Prelude.toCurryString
    "itemize") (d_C_showLatexExps x5 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_110 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "ol") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_111 x3 x4 x5 l cd
    cs) (d_C__case_111 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_111 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_111 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_111" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_111" (showCons x6))

nd_C__case_111 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_111 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` d_C_latexEnvironment (Curry_Prelude.toCurryString "itemize")
    (nd_C_showLatexExps x5 s0 cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_110 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "ol") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_111 x3 x4 x5 l s
    cd cs) (nd_C__case_111 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_111 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_111 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_111" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_111" (showCons x6))

d_C__case_110 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_110 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_latexEnvironment (Curry_Prelude.toCurryString
    "enumerate") (d_C_showLatexExps x5 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_109 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "li") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_110 x3 x4 x5 l cd
    cs) (d_C__case_110 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_110 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_110 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_110" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_110" (showCons x6))

nd_C__case_110 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_110 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` d_C_latexEnvironment (Curry_Prelude.toCurryString "enumerate")
    (nd_C_showLatexExps x5 s0 cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_109 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "li") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_110 x3 x4 x5 l s
    cd cs) (nd_C__case_110 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_110 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_110 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_110" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_110" (showCons x6))

d_C__case_109 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_109 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\item\n") (Curry_Prelude.d_OP_plus_plus
    (d_C_showLatexExps x5 cd cs) (Curry_Prelude.toCurryString "\n") cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_108 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "dl") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_109 x3 x4 x5 l cd
    cs) (d_C__case_109 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_109 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_109 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_109" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_109" (showCons x6))

nd_C__case_109 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_109 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\item\n") (Curry_Prelude.d_OP_plus_plus (nd_C_showLatexExps x5 s0 cd cs)
    (Curry_Prelude.toCurryString "\n") cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_108 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "dl") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_109 x3 x4 x5 l s
    cd cs) (nd_C__case_109 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_109 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_109 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_109" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_109" (showCons x6))

d_C__case_108 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_108 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_latexEnvironment (Curry_Prelude.toCurryString
    "description") (d_C_showLatexExps x5 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_107 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "dt") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_108 x3 x4 x5 l cd
    cs) (d_C__case_108 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_108 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_108 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_108" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_108" (showCons x6))

nd_C__case_108 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_108 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` d_C_latexEnvironment (Curry_Prelude.toCurryString "description")
    (nd_C_showLatexExps x5 s0 cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_107 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "dt") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_108 x3 x4 x5 l s
    cd cs) (nd_C__case_108 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_108 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_108 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_108" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_108" (showCons x6))

d_C__case_107 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_107 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\item[") (Curry_Prelude.d_OP_plus_plus
    (d_C_showLatexExps x5 cd cs) (Curry_Prelude.toCurryString "]~\\\\\n") cd cs)
    cd cs
  Curry_Prelude.C_False -> d_C__case_106 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "dd") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_107 x3 x4 x5 l cd
    cs) (d_C__case_107 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_107 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_107 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_107" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_107" (showCons x6))

nd_C__case_107 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_107 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\item[") (Curry_Prelude.d_OP_plus_plus (nd_C_showLatexExps x5 s0 cd cs)
    (Curry_Prelude.toCurryString "]~\\\\\n") cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_106 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "dd") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_107 x3 x4 x5 l s
    cd cs) (nd_C__case_107 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_107 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_107 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_107" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_107" (showCons x6))

d_C__case_106 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_106 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_showLatexExps x5 cd cs
  Curry_Prelude.C_False -> d_C__case_105 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "table") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_106 x3 x4 x5 l cd
    cs) (d_C__case_106 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_106 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_106 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_106" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_106" (showCons x6))

nd_C__case_106 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_106 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C_showLatexExps x5 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_105 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "table") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_106 x3 x4 x5 l s
    cd cs) (nd_C__case_106 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_106 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_106 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_106" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_106" (showCons x6))

d_C__case_105 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_105 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_attrLatexEnv (Curry_Prelude.toCurryString
    "longtable") (d_C_latexTabFormat x5 cd cs) (d_C_showLatexTableContents x5 cd
    cs) cd cs
  Curry_Prelude.C_False -> d_C__case_104 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "tr") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_105 x3 x4 x5 l cd
    cs) (d_C__case_105 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_105 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_105 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_105" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_105" (showCons x6))

nd_C__case_105 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_105 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` d_C_attrLatexEnv (Curry_Prelude.toCurryString
    "longtable") (nd_C_latexTabFormat x5 s0 cd cs) (nd_C_showLatexTableContents
    x5 s1 cd cs) cd cs))
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_104 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "tr") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_105 x3 x4 x5 l s
    cd cs) (nd_C__case_105 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_105 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_105 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_105" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_105" (showCons x6))

d_C__case_104 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_104 x3 x4 x5 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> let x6 = Curry_Prelude.d_C_map d_C_showLatexExp x5 cd
                                cs
    in Curry_Prelude.d_OP_plus_plus (Data.Curry_List.d_C_intercalate
    (Curry_Prelude.toCurryString " & ") x6 cd cs) (Curry_Prelude.toCurryString
    "\\\\\n") cd cs
  Curry_Prelude.C_False -> d_C__case_103 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "td") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_104 x3 x4 x5 l cd
    cs) (d_C__case_104 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_104 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_104 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_104" [show x3, show x4, show x5, show x7] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_104" (showCons x7))

nd_C__case_104 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_104 x3 x4 x5 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` (let x6 = Curry_Prelude.nd_C_map (wrapNX id nd_C_showLatexExp)
                       x5 s0 cd cs
    in Curry_Prelude.d_OP_plus_plus (Data.Curry_List.d_C_intercalate
    (Curry_Prelude.toCurryString " & ") x6 cd cs) (Curry_Prelude.toCurryString
    "\\\\\n") cd cs)
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_103 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "td") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_104 x3 x4 x5 l s
    cd cs) (nd_C__case_104 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_104 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_104 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_104" [show x3, show x4, show x5, show x7] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_104" (showCons x7))

d_C__case_103 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_103 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_showLatexExps x5 cd cs
  Curry_Prelude.C_False -> d_C__case_102 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "br") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_103 x3 x4 x5 l cd
    cs) (d_C__case_103 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_103 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_103 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_103" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_103" (showCons x6))

nd_C__case_103 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_103 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C_showLatexExps x5 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_102 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "br") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_103 x3 x4 x5 l s
    cd cs) (nd_C__case_103 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_103 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_103 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_103" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_103" (showCons x6))

d_C__case_102 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_102 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "\\par\n"
  Curry_Prelude.C_False -> d_C__case_101 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "hr") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_102 x3 x4 x5 l cd
    cs) (d_C__case_102 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_102 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_102 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_102" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_102" (showCons x6))

nd_C__case_102 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_102 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "\\par\n"
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_101 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "hr") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_102 x3 x4 x5 l s
    cd cs) (nd_C__case_102 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_102 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_102 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_102" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_102" (showCons x6))

d_C__case_101 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_101 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "\\vspace{2ex}\\hrule\n"
  Curry_Prelude.C_False -> d_C__case_100 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "img") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_101 x3 x4 x5 l cd
    cs) (d_C__case_101 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_101 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_101 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_101" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_101" (showCons x6))

nd_C__case_101 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_101 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "\\vspace{2ex}\\hrule\n"
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_100 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "img") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_101 x3 x4 x5 l s
    cd cs) (nd_C__case_101 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_101 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_101 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_101" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_101" (showCons x6))

d_C__case_100 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_100 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_maybe (Curry_Prelude.toCurryString "{\\tt<IMAGE>}")
    (d_C_specialchars2tex cd cs) (d_C_findHtmlAttr (Curry_Prelude.toCurryString
    "alt") x4 cd cs) cd cs) (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_99 x4 x3 x5 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "input") cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_maybe Curry_Prelude.OP_List Curry_Prelude.d_C_id
    (d_C_findHtmlAttr (Curry_Prelude.toCurryString "type") x4 cd cs) cd cs)
    (Curry_Prelude.toCurryString "hidden") cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_100 x3 x4 x5 l cd
    cs) (d_C__case_100 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_100 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_100 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_100" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_100" (showCons x6))

nd_C__case_100 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_100 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_maybe
    (Curry_Prelude.toCurryString "{\\tt<IMAGE>}") (wrapDX id
    (d_C_specialchars2tex cd cs)) (d_C_findHtmlAttr (Curry_Prelude.toCurryString
    "alt") x4 cd cs) s0 cd cs) (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_99 x4 x3 x5 (let s0 = leftSupply s4
                                                      s3 = rightSupply s4
    in s0 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "input") s0 cd cs) (let s2 = leftSupply s3
                                                            s1 = rightSupply s3
    in s2 `seq` (s1 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.nd_C_maybe Curry_Prelude.OP_List (wrapDX id
    Curry_Prelude.d_C_id) (d_C_findHtmlAttr (Curry_Prelude.toCurryString "type")
    x4 cd cs) s1 cd cs) (Curry_Prelude.toCurryString "hidden") s2 cd cs)) cd
    cs)) s5 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_100 x3 x4 x5 l s
    cd cs) (nd_C__case_100 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_100 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_100 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_100" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_100" (showCons x6))

d_C__case_99 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_99 x4 x3 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> d_C__case_98 x3 x5 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_99 x4 x3 x5 l cd
    cs) (d_C__case_99 x4 x3 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_99 x4
    x3 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_99 x4 x3
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_99" [show x4, show x3, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_99" (showCons x6))

nd_C__case_99 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_99 x4 x3 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_98 x3 x5 (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_99 x4 x3 x5 l s
    cd cs) (nd_C__case_99 x4 x3 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_99 x4
    x3 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_99 x4 x3
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_99" [show x4, show x3, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_99" (showCons x6))

d_C__case_98 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_98 x3 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\tt<") (Curry_Prelude.d_OP_plus_plus x3
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString ">}")
    (Curry_Prelude.d_OP_plus_plus (d_C_showLatexExps x5 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{\\tt</")
    (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.toCurryString ">}") cd cs)
    cd cs) cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_98 x3 x5 l cd cs)
    (d_C__case_98 x3 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_98 x3
    x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_98 x3 x5 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_98" [show x3, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_98" (showCons x6))

nd_C__case_98 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_98 x3 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "{\\tt<") (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString ">}") (Curry_Prelude.d_OP_plus_plus
    (nd_C_showLatexExps x5 s0 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\tt</") (Curry_Prelude.d_OP_plus_plus x3
    (Curry_Prelude.toCurryString ">}") cd cs) cd cs) cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_98 x3 x5 l s cd
    cs) (nd_C__case_98 x3 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_98 x3
    x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_98 x3 x5
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_98" [show x3, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_98" (showCons x6))

d_C__case_97 :: Curry_Prelude.C_Int -> HTML.Curry_Base.C_BaseHtml -> Cover
  -> ConstStore -> Curry_Prelude.C_Int
d_C__case_97 x2 x1 cd cs = case x1 of
  HTML.Curry_Base.C_BaseStruct x3 x4 x5 -> d_C__case_96 x3 x5
    (Curry_Prelude.d_C_eqString x3 (Curry_Prelude.toCurryString "tr") cd cs) cd
    cs
  HTML.Curry_Base.C_BaseText x6 -> x2
  HTML.Curry_Base.C_BaseAction x7 -> x2
  HTML.Curry_Base.Choice_C_BaseHtml d i l r -> narrow d i (d_C__case_97 x2 l cd
    cs) (d_C__case_97 x2 r cd cs)
  HTML.Curry_Base.Choices_C_BaseHtml d i xs -> narrows cs d i (\z ->
    d_C__case_97 x2 z cd cs) xs
  HTML.Curry_Base.Guard_C_BaseHtml d c e -> guardCons d c ((\x -> d_C__case_97
    x2 e cd x) $! addCs c cs)
  HTML.Curry_Base.Fail_C_BaseHtml d info -> failCons d (traceFail
    "HTML.LaTeX._case_97" [show x2, show x1] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_97" (showCons x1))

nd_C__case_97 :: Curry_Prelude.C_Int -> HTML.Curry_Base.C_BaseHtml -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Int
nd_C__case_97 x2 x1 s cd cs = case x1 of
  HTML.Curry_Base.C_BaseStruct x3 x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_96 x3 x5 (Curry_Prelude.d_C_eqString x3
    (Curry_Prelude.toCurryString "tr") cd cs) s0 cd cs
  HTML.Curry_Base.C_BaseText x6 -> x2
  HTML.Curry_Base.C_BaseAction x7 -> x2
  HTML.Curry_Base.Choice_C_BaseHtml d i l r -> narrow d i (nd_C__case_97 x2 l s
    cd cs) (nd_C__case_97 x2 r s cd cs)
  HTML.Curry_Base.Choices_C_BaseHtml d i xs -> narrows cs d i (\z ->
    nd_C__case_97 x2 z s cd cs) xs
  HTML.Curry_Base.Guard_C_BaseHtml d c e -> guardCons d c ((\x -> nd_C__case_97
    x2 e s cd x) $! addCs c cs)
  HTML.Curry_Base.Fail_C_BaseHtml d info -> failCons d (traceFail
    "HTML.LaTeX._case_97" [show x2, show x1] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_97" (showCons x1))

d_C__case_96 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C__case_96 x3 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_length x5 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "getBreadth: no row given") cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_96 x3 x5 l cd cs)
    (d_C__case_96 x3 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_96 x3
    x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_96 x3 x5 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_96" [show x3, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_96" (showCons x6))

nd_C__case_96 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Int
nd_C__case_96 x3 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_length x5 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "getBreadth: no row given") cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_96 x3 x5 l s cd
    cs) (nd_C__case_96 x3 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_96 x3
    x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_96 x3 x5
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_96" [show x3, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_96" (showCons x6))

d_C__case_95 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_95 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_showLatexTableContents x5 cd cs
  Curry_Prelude.C_False -> d_C__case_94 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "head") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_95 x3 x4 x5 l cd
    cs) (d_C__case_95 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_95 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_95 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_95" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_95" (showCons x6))

nd_C__case_95 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_95 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_showLatexTableContents x5 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_94 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "head") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_95 x3 x4 x5 l s
    cd cs) (nd_C__case_95 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_95 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_95 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_95" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_95" (showCons x6))

d_C__case_94 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_94 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> d_C__case_93 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "body") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_94 x3 x4 x5 l cd
    cs) (d_C__case_94 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_94 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_94 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_94" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_94" (showCons x6))

nd_C__case_94 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_94 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_93 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "body") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_94 x3 x4 x5 l s
    cd cs) (nd_C__case_94 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_94 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_94 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_94" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_94" (showCons x6))

d_C__case_93 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_93 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_showLatexTableContents x5 cd cs
  Curry_Prelude.C_False -> d_C__case_92 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "form") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_93 x3 x4 x5 l cd
    cs) (d_C__case_93 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_93 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_93 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_93" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_93" (showCons x6))

nd_C__case_93 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_93 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_showLatexTableContents x5 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_92 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "form") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_93 x3 x4 x5 l s
    cd cs) (nd_C__case_93 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_93 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_93 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_93" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_93" (showCons x6))

d_C__case_92 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_92 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_showLatexTableContents x5 cd cs
  Curry_Prelude.C_False -> d_C__case_91 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "p") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_92 x3 x4 x5 l cd
    cs) (d_C__case_92 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_92 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_92 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_92" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_92" (showCons x6))

nd_C__case_92 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_92 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_showLatexTableContents x5 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_91 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "p") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_92 x3 x4 x5 l s
    cd cs) (nd_C__case_92 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_92 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_92 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_92" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_92" (showCons x6))

d_C__case_91 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_91 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (d_C_showLatexTableContents x5 cd cs) (Curry_Prelude.toCurryString
    "\\par\n") cd cs
  Curry_Prelude.C_False -> d_C__case_90 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "b") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_91 x3 x4 x5 l cd
    cs) (d_C__case_91 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_91 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_91 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_91" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_91" (showCons x6))

nd_C__case_91 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_91 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_showLatexTableContents x5 s0
    cd cs) (Curry_Prelude.toCurryString "\\par\n") cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_90 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "b") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_91 x3 x4 x5 l s
    cd cs) (nd_C__case_91 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_91 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_91 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_91" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_91" (showCons x6))

d_C__case_90 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_90 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\bf ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showLatexTableContents x5 cd cs) (Curry_Prelude.toCurryString "}") cd
    cs) cd cs
  Curry_Prelude.C_False -> d_C__case_89 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "em") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_90 x3 x4 x5 l cd
    cs) (d_C__case_90 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_90 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_90 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_90" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_90" (showCons x6))

nd_C__case_90 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_90 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "{\\bf ") (Curry_Prelude.d_OP_plus_plus (nd_C_showLatexTableContents x5 s0
    cd cs) (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_89 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "em") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_90 x3 x4 x5 l s
    cd cs) (nd_C__case_90 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_90 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_90 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_90" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_90" (showCons x6))

d_C__case_89 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_89 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\emph{") (Curry_Prelude.d_OP_plus_plus
    (d_C_showLatexTableContents x5 cd cs) (Curry_Prelude.toCurryString "}") cd
    cs) cd cs
  Curry_Prelude.C_False -> d_C__case_88 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "i") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_89 x3 x4 x5 l cd
    cs) (d_C__case_89 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_89 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_89 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_89" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_89" (showCons x6))

nd_C__case_89 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_89 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\emph{") (Curry_Prelude.d_OP_plus_plus (nd_C_showLatexTableContents x5 s0
    cd cs) (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_88 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "i") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_89 x3 x4 x5 l s
    cd cs) (nd_C__case_89 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_89 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_89 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_89" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_89" (showCons x6))

d_C__case_88 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_88 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\it ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showLatexTableContents x5 cd cs) (Curry_Prelude.toCurryString "}") cd
    cs) cd cs
  Curry_Prelude.C_False -> d_C__case_87 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "tt") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_88 x3 x4 x5 l cd
    cs) (d_C__case_88 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_88 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_88 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_88" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_88" (showCons x6))

nd_C__case_88 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_88 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "{\\it ") (Curry_Prelude.d_OP_plus_plus (nd_C_showLatexTableContents x5 s0
    cd cs) (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_87 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "tt") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_88 x3 x4 x5 l s
    cd cs) (nd_C__case_88 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_88 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_88 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_88" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_88" (showCons x6))

d_C__case_87 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_87 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\tt ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showLatexTableContents x5 cd cs) (Curry_Prelude.toCurryString "}") cd
    cs) cd cs
  Curry_Prelude.C_False -> d_C__case_86 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "font") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_87 x3 x4 x5 l cd
    cs) (d_C__case_87 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_87 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_87 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_87" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_87" (showCons x6))

nd_C__case_87 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_87 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "{\\tt ") (Curry_Prelude.d_OP_plus_plus (nd_C_showLatexTableContents x5 s0
    cd cs) (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_86 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "font") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_87 x3 x4 x5 l s
    cd cs) (nd_C__case_87 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_87 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_87 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_87" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_87" (showCons x6))

d_C__case_86 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_86 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_showLatexTableContents x5 cd cs
  Curry_Prelude.C_False -> d_C__case_85 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "address") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_86 x3 x4 x5 l cd
    cs) (d_C__case_86 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_86 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_86 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_86" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_86" (showCons x6))

nd_C__case_86 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_86 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_showLatexTableContents x5 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_85 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "address") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_86 x3 x4 x5 l s
    cd cs) (nd_C__case_86 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_86 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_86 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_86" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_86" (showCons x6))

d_C__case_85 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_85 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_showLatexTableContents x5 cd cs
  Curry_Prelude.C_False -> d_C__case_84 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "blink") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_85 x3 x4 x5 l cd
    cs) (d_C__case_85 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_85 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_85 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_85" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_85" (showCons x6))

nd_C__case_85 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_85 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_showLatexTableContents x5 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_84 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "blink") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_85 x3 x4 x5 l s
    cd cs) (nd_C__case_85 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_85 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_85 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_85" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_85" (showCons x6))

d_C__case_84 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_84 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_showLatexTableContents x5 cd cs
  Curry_Prelude.C_False -> d_C__case_83 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "a") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_84 x3 x4 x5 l cd
    cs) (d_C__case_84 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_84 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_84 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_84" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_84" (showCons x6))

nd_C__case_84 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_84 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_showLatexTableContents x5 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_83 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "a") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_84 x3 x4 x5 l s
    cd cs) (nd_C__case_84 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_84 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_84 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_84" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_84" (showCons x6))

d_C__case_83 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_83 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (d_C_showLatexTableContents x5 cd cs) (Curry_Prelude.d_C_maybe
    Curry_Prelude.OP_List d_OP_showLatexTableContent_dot_uscore_hash_lambda3
    (d_C_findHtmlAttr (Curry_Prelude.toCurryString "href") x4 cd cs) cd cs) cd
    cs
  Curry_Prelude.C_False -> d_C__case_82 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "tr") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_83 x3 x4 x5 l cd
    cs) (d_C__case_83 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_83 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_83 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_83" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_83" (showCons x6))

nd_C__case_83 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_83 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus
    (nd_C_showLatexTableContents x5 s0 cd cs) (Curry_Prelude.nd_C_maybe
    Curry_Prelude.OP_List (wrapDX id
    d_OP_showLatexTableContent_dot_uscore_hash_lambda3) (d_C_findHtmlAttr
    (Curry_Prelude.toCurryString "href") x4 cd cs) s1 cd cs) cd cs))
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_82 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "tr") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_83 x3 x4 x5 l s
    cd cs) (nd_C__case_83 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_83 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_83 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_83" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_83" (showCons x6))

d_C__case_82 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_82 x3 x4 x5 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> let x6 = Curry_Prelude.d_C_map
                                d_C_showLatexTableContent x5 cd cs
    in Curry_Prelude.d_OP_plus_plus (Data.Curry_List.d_C_intercalate
    (Curry_Prelude.toCurryString " & ") x6 cd cs) (Curry_Prelude.toCurryString
    "\\\\\n") cd cs
  Curry_Prelude.C_False -> d_C__case_81 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "td") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_82 x3 x4 x5 l cd
    cs) (d_C__case_82 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_82 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_82 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_82" [show x3, show x4, show x5, show x7] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_82" (showCons x7))

nd_C__case_82 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_82 x3 x4 x5 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` (let x6 = Curry_Prelude.nd_C_map (wrapNX id
                       nd_C_showLatexTableContent) x5 s0 cd cs
    in Curry_Prelude.d_OP_plus_plus (Data.Curry_List.d_C_intercalate
    (Curry_Prelude.toCurryString " & ") x6 cd cs) (Curry_Prelude.toCurryString
    "\\\\\n") cd cs)
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_81 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "td") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_82 x3 x4 x5 l s
    cd cs) (nd_C__case_82 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_82 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_82 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_82" [show x3, show x4, show x5, show x7] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_82" (showCons x7))

d_C__case_81 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_81 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_showLatexTableContents x5 cd cs
  Curry_Prelude.C_False -> d_C__case_80 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "br") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_81 x3 x4 x5 l cd
    cs) (d_C__case_81 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_81 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_81 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_81" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_81" (showCons x6))

nd_C__case_81 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_81 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_showLatexTableContents x5 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_80 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "br") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_81 x3 x4 x5 l s
    cd cs) (nd_C__case_81 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_81 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_81 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_81" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_81" (showCons x6))

d_C__case_80 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_80 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "\\par\n"
  Curry_Prelude.C_False -> d_C__case_79 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "hr") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_80 x3 x4 x5 l cd
    cs) (d_C__case_80 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_80 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_80 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_80" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_80" (showCons x6))

nd_C__case_80 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_80 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "\\par\n"
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_79 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "hr") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_80 x3 x4 x5 l s
    cd cs) (nd_C__case_80 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_80 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_80 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_80" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_80" (showCons x6))

d_C__case_79 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_79 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "\\vspace{2ex}\\hrule\n"
  Curry_Prelude.C_False -> d_C__case_78 x3 x4 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "img") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_79 x3 x4 x5 l cd
    cs) (d_C__case_79 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_79 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_79 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_79" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_79" (showCons x6))

nd_C__case_79 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_79 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "\\vspace{2ex}\\hrule\n"
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_78 x3 x4 x5
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "img") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_79 x3 x4 x5 l s
    cd cs) (nd_C__case_79 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_79 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_79 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_79" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_79" (showCons x6))

d_C__case_78 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_78 x3 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_maybe (Curry_Prelude.toCurryString "{\\tt<IMAGE>}")
    (d_C_specialchars2tex cd cs) (d_C_findHtmlAttr (Curry_Prelude.toCurryString
    "alt") x4 cd cs) cd cs) (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_77 x4 x3 x5 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "input") cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_maybe Curry_Prelude.OP_List Curry_Prelude.d_C_id
    (d_C_findHtmlAttr (Curry_Prelude.toCurryString "type") x4 cd cs) cd cs)
    (Curry_Prelude.toCurryString "hidden") cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_78 x3 x4 x5 l cd
    cs) (d_C__case_78 x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_78 x3
    x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_78 x3 x4
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_78" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_78" (showCons x6))

nd_C__case_78 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_78 x3 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_maybe
    (Curry_Prelude.toCurryString "{\\tt<IMAGE>}") (wrapDX id
    (d_C_specialchars2tex cd cs)) (d_C_findHtmlAttr (Curry_Prelude.toCurryString
    "alt") x4 cd cs) s0 cd cs) (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_77 x4 x3 x5 (let s0 = leftSupply s4
                                                      s3 = rightSupply s4
    in s0 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "input") s0 cd cs) (let s2 = leftSupply s3
                                                            s1 = rightSupply s3
    in s2 `seq` (s1 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.nd_C_maybe Curry_Prelude.OP_List (wrapDX id
    Curry_Prelude.d_C_id) (d_C_findHtmlAttr (Curry_Prelude.toCurryString "type")
    x4 cd cs) s1 cd cs) (Curry_Prelude.toCurryString "hidden") s2 cd cs)) cd
    cs)) s5 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_78 x3 x4 x5 l s
    cd cs) (nd_C__case_78 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_78 x3
    x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_78 x3 x4
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_78" [show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_78" (showCons x6))

d_C__case_77 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_77 x4 x3 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> d_C__case_76 x3 x5 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_77 x4 x3 x5 l cd
    cs) (d_C__case_77 x4 x3 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_77 x4
    x3 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_77 x4 x3
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_77" [show x4, show x3, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_77" (showCons x6))

nd_C__case_77 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_77 x4 x3 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_76 x3 x5 (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_77 x4 x3 x5 l s
    cd cs) (nd_C__case_77 x4 x3 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_77 x4
    x3 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_77 x4 x3
    x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_77" [show x4, show x3, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_77" (showCons x6))

d_C__case_76 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_76 x3 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\tt<") (Curry_Prelude.d_OP_plus_plus x3
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString ">}")
    (Curry_Prelude.d_OP_plus_plus (d_C_showLatexTableContents x5 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "{\\tt</")
    (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.toCurryString ">}") cd cs)
    cd cs) cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_76 x3 x5 l cd cs)
    (d_C__case_76 x3 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_76 x3
    x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_76 x3 x5 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_76" [show x3, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_76" (showCons x6))

nd_C__case_76 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_76 x3 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "{\\tt<") (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString ">}") (Curry_Prelude.d_OP_plus_plus
    (nd_C_showLatexTableContents x5 s0 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\tt</") (Curry_Prelude.d_OP_plus_plus x3
    (Curry_Prelude.toCurryString ">}") cd cs) cd cs) cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_76 x3 x5 l s cd
    cs) (nd_C__case_76 x3 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_76 x3
    x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_76 x3 x5
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_76" [show x3, show x5, show x6] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_76" (showCons x6))

d_C__case_75 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_75 x1 x4 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> d_C__case_74 x5 x1 x4 x6
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 x5 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_75 x1 x4 l cd
    cs) (d_C__case_75 x1 x4 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_75
    x1 x4 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_75 x1
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "HTML.LaTeX._case_75" [show x1, show x4, show x3] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_75" (showCons x3))

d_C__case_74 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_74 x5 x1 x4 x6 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.C_Just x6
  Curry_Prelude.C_False -> d_C_findHtmlAttr x1 x4 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_74 x5 x1 x4 x6 l
    cd cs) (d_C__case_74 x5 x1 x4 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_74 x5
    x1 x4 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_74 x5 x1
    x4 x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_74" [show x5, show x1, show x4, show x6, show x7] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_74" (showCons x7))

d_C__case_73 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_73 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\tt\\char94}") (d_C_escapeLaTeXSpecials x3
    cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_72 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '~'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_73 x2 x3 l cd cs)
    (d_C__case_73 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_73 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_73 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_73" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_73" (showCons x4))

d_C__case_72 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_72 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\tt\\char126}") (d_C_escapeLaTeXSpecials x3
    cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_71 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '\\'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_72 x2 x3 l cd cs)
    (d_C__case_72 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_72 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_72 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_72" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_72" (showCons x4))

d_C__case_71 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_71 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\textbackslash}") (d_C_escapeLaTeXSpecials
    x3 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_70 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '<'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_71 x2 x3 l cd cs)
    (d_C__case_71 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_71 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_71 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_71" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_71" (showCons x4))

d_C__case_70 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_70 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\tt\\char60}") (d_C_escapeLaTeXSpecials x3
    cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_69 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '>'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_70 x2 x3 l cd cs)
    (d_C__case_70 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_70 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_70 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_70" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_70" (showCons x4))

d_C__case_69 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_69 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\tt\\char62}") (d_C_escapeLaTeXSpecials x3
    cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_68 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '_'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_69 x2 x3 l cd cs)
    (d_C__case_69 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_69 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_69 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_69" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_69" (showCons x4))

d_C__case_68 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_68 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\_") (d_C_escapeLaTeXSpecials x3 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_67 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '#'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_68 x2 x3 l cd cs)
    (d_C__case_68 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_68 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_68 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_68" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_68" (showCons x4))

d_C__case_67 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_67 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\#") (d_C_escapeLaTeXSpecials x3 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_66 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '$'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_67 x2 x3 l cd cs)
    (d_C__case_67 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_67 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_67 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_67" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_67" (showCons x4))

d_C__case_66 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_66 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\$") (d_C_escapeLaTeXSpecials x3 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_65 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '%'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_66 x2 x3 l cd cs)
    (d_C__case_66 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_66 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_66 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_66" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_66" (showCons x4))

d_C__case_65 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_65 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\%") (d_C_escapeLaTeXSpecials x3 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_64 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '{'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_65 x2 x3 l cd cs)
    (d_C__case_65 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_65 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_65 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_65" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_65" (showCons x4))

d_C__case_64 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_64 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\{") (d_C_escapeLaTeXSpecials x3 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_63 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '}'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_64 x2 x3 l cd cs)
    (d_C__case_64 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_64 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_64 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_64" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_64" (showCons x4))

d_C__case_63 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_63 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\}") (d_C_escapeLaTeXSpecials x3 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_62 x3 x2 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_63 x2 x3 l cd cs)
    (d_C__case_63 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_63 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_63 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_63" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_63" (showCons x4))

d_C__case_62 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_62 x3 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x2 (d_C_escapeLaTeXSpecials x3
    cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_62 x3 x2 l cd cs)
    (d_C__case_62 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_62 x3
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_62 x3 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_62" [show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_62" (showCons x4))

d_C__case_61 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_61 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\\"a}") (d_C_htmlSpecialChars2tex x3 cd cs)
    cd cs
  Curry_Prelude.C_False -> d_C__case_60 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.d_C_chr (Curry_Prelude.C_Int (246)) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_61 x2 x3 l cd cs)
    (d_C__case_61 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_61 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_61 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_61" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_61" (showCons x4))

d_C__case_60 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_60 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\\"o}") (d_C_htmlSpecialChars2tex x3 cd cs)
    cd cs
  Curry_Prelude.C_False -> d_C__case_59 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.d_C_chr (Curry_Prelude.C_Int (252)) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_60 x2 x3 l cd cs)
    (d_C__case_60 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_60 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_60 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_60" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_60" (showCons x4))

d_C__case_59 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_59 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\\"u}") (d_C_htmlSpecialChars2tex x3 cd cs)
    cd cs
  Curry_Prelude.C_False -> d_C__case_58 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.d_C_chr (Curry_Prelude.C_Int (196)) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_59 x2 x3 l cd cs)
    (d_C__case_59 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_59 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_59 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_59" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_59" (showCons x4))

d_C__case_58 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_58 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\\"A}") (d_C_htmlSpecialChars2tex x3 cd cs)
    cd cs
  Curry_Prelude.C_False -> d_C__case_57 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.d_C_chr (Curry_Prelude.C_Int (214)) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_58 x2 x3 l cd cs)
    (d_C__case_58 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_58 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_58 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_58" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_58" (showCons x4))

d_C__case_57 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_57 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\\"O}") (d_C_htmlSpecialChars2tex x3 cd cs)
    cd cs
  Curry_Prelude.C_False -> d_C__case_56 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.d_C_chr (Curry_Prelude.C_Int (220)) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_57 x2 x3 l cd cs)
    (d_C__case_57 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_57 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_57 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_57" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_57" (showCons x4))

d_C__case_56 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_56 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\\"U}") (d_C_htmlSpecialChars2tex x3 cd cs)
    cd cs
  Curry_Prelude.C_False -> d_C__case_55 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.d_C_chr (Curry_Prelude.C_Int (223)) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_56 x2 x3 l cd cs)
    (d_C__case_56 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_56 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_56 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_56" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_56" (showCons x4))

d_C__case_55 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_55 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "{\\ss}") (d_C_htmlSpecialChars2tex x3 cd cs)
    cd cs
  Curry_Prelude.C_False -> d_C__case_54 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '&'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_55 x2 x3 l cd cs)
    (d_C__case_55 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_55 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_55 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_55" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_55" (showCons x4))

d_C__case_54 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_54 x2 x3 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> let x4 = Curry_Prelude.d_C_apply
                                (Curry_Prelude.d_C_break (Curry_Prelude.d_C_flip
                                (acceptCs id
                                Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                (Curry_Prelude.C_Char ';'#)) cd cs) x3 cd cs
                              x5 = d_OP_htmlSpecialChars2tex_dot_uscore_hash_selFP2_hash_special
                                x4 cd cs
                              x6 = d_OP_htmlSpecialChars2tex_dot_uscore_hash_selFP3_hash_rest
                                x4 cd cs
    in d_C__case_53 x6 x5 (Curry_Prelude.d_C_null x6 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_52 x3 x2 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_54 x2 x3 l cd cs)
    (d_C__case_54 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_54 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_54 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_54" [show x2, show x3, show x7] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_54" (showCons x7))

d_C__case_52 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_52 x3 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x2 (d_C_htmlSpecialChars2tex x3
    cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_52 x3 x2 l cd cs)
    (d_C__case_52 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_52 x3
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_52 x3 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_52" [show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_52" (showCons x4))

d_C__case_53 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_53 x6 x5 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\&") (d_C_htmlSpecialChars2tex x5 cd cs) cd
    cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_plus_plus (d_C_htmlspecial2tex x5
    cd cs) (d_C_htmlSpecialChars2tex (Curry_Prelude.d_C_tail x6 cd cs) cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_53 x6 x5 l cd cs)
    (d_C__case_53 x6 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_53 x6
    x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_53 x6 x5 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_53" [show x6, show x5, show x7] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_53" (showCons x7))

d_C__case_51 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_51 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\\"A}"
  Curry_Prelude.C_False -> d_C__case_50 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Euml") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_51 x1 l cd cs)
    (d_C__case_51 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_51 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_51 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_51" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_51" (showCons x2))

d_C__case_50 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_50 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\\"E}"
  Curry_Prelude.C_False -> d_C__case_49 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Iuml") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_50 x1 l cd cs)
    (d_C__case_50 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_50 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_50 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_50" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_50" (showCons x2))

d_C__case_49 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_49 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\\"I}"
  Curry_Prelude.C_False -> d_C__case_48 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Ouml") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_49 x1 l cd cs)
    (d_C__case_49 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_49 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_49 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_49" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_49" (showCons x2))

d_C__case_48 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_48 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\\"O}"
  Curry_Prelude.C_False -> d_C__case_47 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Uuml") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_48 x1 l cd cs)
    (d_C__case_48 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_48 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_48 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_48" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_48" (showCons x2))

d_C__case_47 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_47 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\\"U}"
  Curry_Prelude.C_False -> d_C__case_46 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "auml") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_47 x1 l cd cs)
    (d_C__case_47 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_47 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_47 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_47" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_47" (showCons x2))

d_C__case_46 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_46 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\\"a}"
  Curry_Prelude.C_False -> d_C__case_45 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "euml") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_46 x1 l cd cs)
    (d_C__case_46 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_46 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_46 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_46" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_46" (showCons x2))

d_C__case_45 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_45 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\\"e}"
  Curry_Prelude.C_False -> d_C__case_44 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "iuml") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_45 x1 l cd cs)
    (d_C__case_45 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_45 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_45 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_45" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_45" (showCons x2))

d_C__case_44 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_44 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\\"\\i}"
  Curry_Prelude.C_False -> d_C__case_43 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "ouml") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_44 x1 l cd cs)
    (d_C__case_44 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_44 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_44 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_44" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_44" (showCons x2))

d_C__case_43 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_43 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\\"o}"
  Curry_Prelude.C_False -> d_C__case_42 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "uuml") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_43 x1 l cd cs)
    (d_C__case_43 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_43 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_43 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_43" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_43" (showCons x2))

d_C__case_42 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_42 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\\"u}"
  Curry_Prelude.C_False -> d_C__case_41 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "szlig") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_42 x1 l cd cs)
    (d_C__case_42 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_42 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_42 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_42" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_42" (showCons x2))

d_C__case_41 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_41 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\ss}"
  Curry_Prelude.C_False -> d_C__case_40 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Aacute") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_41 x1 l cd cs)
    (d_C__case_41 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_41 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_41 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_41" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_41" (showCons x2))

d_C__case_40 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_40 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\'A}"
  Curry_Prelude.C_False -> d_C__case_39 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Eacute") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_40 x1 l cd cs)
    (d_C__case_40 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_40 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_40 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_40" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_40" (showCons x2))

d_C__case_39 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_39 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\'E}"
  Curry_Prelude.C_False -> d_C__case_38 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Iacute") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_39 x1 l cd cs)
    (d_C__case_39 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_39 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_39 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_39" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_39" (showCons x2))

d_C__case_38 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_38 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\'I}"
  Curry_Prelude.C_False -> d_C__case_37 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Oacute") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_38 x1 l cd cs)
    (d_C__case_38 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_38 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_38 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_38" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_38" (showCons x2))

d_C__case_37 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_37 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\'O}"
  Curry_Prelude.C_False -> d_C__case_36 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Uacute") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_37 x1 l cd cs)
    (d_C__case_37 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_37 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_37 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_37" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_37" (showCons x2))

d_C__case_36 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_36 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\'U}"
  Curry_Prelude.C_False -> d_C__case_35 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "aacute") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_36 x1 l cd cs)
    (d_C__case_36 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_36 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_36 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_36" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_36" (showCons x2))

d_C__case_35 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_35 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\'a}"
  Curry_Prelude.C_False -> d_C__case_34 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "eacute") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_35 x1 l cd cs)
    (d_C__case_35 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_35 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_35 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_35" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_35" (showCons x2))

d_C__case_34 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_34 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\'e}"
  Curry_Prelude.C_False -> d_C__case_33 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "iacute") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_34 x1 l cd cs)
    (d_C__case_34 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_34 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_34 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_34" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_34" (showCons x2))

d_C__case_33 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_33 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\'\\i}"
  Curry_Prelude.C_False -> d_C__case_32 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "oacute") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_33 x1 l cd cs)
    (d_C__case_33 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_33 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_33 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_33" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_33" (showCons x2))

d_C__case_32 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_32 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\'o}"
  Curry_Prelude.C_False -> d_C__case_31 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "uacute") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_32 x1 l cd cs)
    (d_C__case_32 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_32 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_32 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_32" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_32" (showCons x2))

d_C__case_31 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_31 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\'u}"
  Curry_Prelude.C_False -> d_C__case_30 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Agrave") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_31 x1 l cd cs)
    (d_C__case_31 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_31 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_31 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_31" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_31" (showCons x2))

d_C__case_30 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_30 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\`A}"
  Curry_Prelude.C_False -> d_C__case_29 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Egrave") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_30 x1 l cd cs)
    (d_C__case_30 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_30 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_30 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_30" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_30" (showCons x2))

d_C__case_29 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_29 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\`E}"
  Curry_Prelude.C_False -> d_C__case_28 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Igrave") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_29 x1 l cd cs)
    (d_C__case_29 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_29 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_29 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_29" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_29" (showCons x2))

d_C__case_28 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_28 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\`I}"
  Curry_Prelude.C_False -> d_C__case_27 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Ograve") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_28 x1 l cd cs)
    (d_C__case_28 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_28 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_28 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_28" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_28" (showCons x2))

d_C__case_27 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_27 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\`O}"
  Curry_Prelude.C_False -> d_C__case_26 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Ugrave") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_27 x1 l cd cs)
    (d_C__case_27 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_27 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_27 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_27" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_27" (showCons x2))

d_C__case_26 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_26 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\`U}"
  Curry_Prelude.C_False -> d_C__case_25 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "agrave") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_26 x1 l cd cs)
    (d_C__case_26 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_26 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_26 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_26" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_26" (showCons x2))

d_C__case_25 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_25 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\`a}"
  Curry_Prelude.C_False -> d_C__case_24 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "egrave") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_25 x1 l cd cs)
    (d_C__case_25 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_25 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_25 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_25" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_25" (showCons x2))

d_C__case_24 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_24 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\`e}"
  Curry_Prelude.C_False -> d_C__case_23 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "igrave") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_24 x1 l cd cs)
    (d_C__case_24 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_24 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_24 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_24" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_24" (showCons x2))

d_C__case_23 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_23 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\`\\i}"
  Curry_Prelude.C_False -> d_C__case_22 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "ograve") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_23 x1 l cd cs)
    (d_C__case_23 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_23 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_23 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_23" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_23" (showCons x2))

d_C__case_22 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_22 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\`o}"
  Curry_Prelude.C_False -> d_C__case_21 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "ugrave") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_22 x1 l cd cs)
    (d_C__case_22 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_22 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_22 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_22" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_22" (showCons x2))

d_C__case_21 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_21 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\`u}"
  Curry_Prelude.C_False -> d_C__case_20 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Acirc") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_21 x1 l cd cs)
    (d_C__case_21 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_21 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_21 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_21" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_21" (showCons x2))

d_C__case_20 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_20 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\^A}"
  Curry_Prelude.C_False -> d_C__case_19 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Ecirc") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_20 x1 l cd cs)
    (d_C__case_20 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_20 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_20 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_20" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_20" (showCons x2))

d_C__case_19 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_19 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\^E}"
  Curry_Prelude.C_False -> d_C__case_18 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Icirc") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_19 x1 l cd cs)
    (d_C__case_19 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_19 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_19 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_19" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_19" (showCons x2))

d_C__case_18 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_18 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\^I}"
  Curry_Prelude.C_False -> d_C__case_17 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Ocirc") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_18 x1 l cd cs)
    (d_C__case_18 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_18 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_18 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_18" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_18" (showCons x2))

d_C__case_17 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_17 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\^O}"
  Curry_Prelude.C_False -> d_C__case_16 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Ucirc") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_17 x1 l cd cs)
    (d_C__case_17 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_17 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_17 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_17" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_17" (showCons x2))

d_C__case_16 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_16 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\^U}"
  Curry_Prelude.C_False -> d_C__case_15 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "acirc") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_16 x1 l cd cs)
    (d_C__case_16 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_16 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_16 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_16" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_16" (showCons x2))

d_C__case_15 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_15 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\^a}"
  Curry_Prelude.C_False -> d_C__case_14 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "ecirc") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_15 x1 l cd cs)
    (d_C__case_15 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_15 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_15 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_15" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_15" (showCons x2))

d_C__case_14 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_14 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\^e}"
  Curry_Prelude.C_False -> d_C__case_13 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "icirc") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_14 x1 l cd cs)
    (d_C__case_14 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_14 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_14 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_14" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_14" (showCons x2))

d_C__case_13 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_13 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\^\\i}"
  Curry_Prelude.C_False -> d_C__case_12 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "ocirc") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_13 x1 l cd cs)
    (d_C__case_13 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_13 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_13 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_13" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_13" (showCons x2))

d_C__case_12 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_12 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\^o}"
  Curry_Prelude.C_False -> d_C__case_11 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "ucirc") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_12 x1 l cd cs)
    (d_C__case_12 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_12 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_12 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_12" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_12" (showCons x2))

d_C__case_11 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_11 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\^u}"
  Curry_Prelude.C_False -> d_C__case_10 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "Oslash") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_11 x1 l cd cs)
    (d_C__case_11 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_11 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_11 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_11" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_11" (showCons x2))

d_C__case_10 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_10 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\O}"
  Curry_Prelude.C_False -> d_C__case_9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "oslash") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_10 x1 l cd cs)
    (d_C__case_10 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_10 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_10 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "HTML.LaTeX._case_10" [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_10" (showCons x2))

d_C__case_9 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_9 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\o}"
  Curry_Prelude.C_False -> d_C__case_8 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "amp") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_9 x1 l cd cs)
    (d_C__case_9 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_9 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_9 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "HTML.LaTeX._case_9"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_9" (showCons x2))

d_C__case_8 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_8 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\&}"
  Curry_Prelude.C_False -> d_C__case_7 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "ntilde") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x1 l cd cs)
    (d_C__case_8 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_8 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "HTML.LaTeX._case_8"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_8" (showCons x2))

d_C__case_7 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_7 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\~n}"
  Curry_Prelude.C_False -> d_C__case_6 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "otilde") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x1 l cd cs)
    (d_C__case_7 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_7 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "HTML.LaTeX._case_7"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_7" (showCons x2))

d_C__case_6 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_6 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\~o}"
  Curry_Prelude.C_False -> d_C__case_5 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "ccedil") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x1 l cd cs)
    (d_C__case_6 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "HTML.LaTeX._case_6"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_6" (showCons x2))

d_C__case_5 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_5 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{\\c{c}}"
  Curry_Prelude.C_False -> d_C__case_4 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "nbsp") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x1 l cd cs)
    (d_C__case_5 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "HTML.LaTeX._case_5"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_5" (showCons x2))

d_C__case_4 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_4 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "~"
  Curry_Prelude.C_False -> d_C__case_3 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "quot") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x1 l cd cs)
    (d_C__case_4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "HTML.LaTeX._case_4"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_4" (showCons x2))

d_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_3 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "\""
  Curry_Prelude.C_False -> d_C__case_2 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "lt") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x1 l cd cs)
    (d_C__case_3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "HTML.LaTeX._case_3"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_3" (showCons x2))

d_C__case_2 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_2 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{$<$}"
  Curry_Prelude.C_False -> d_C__case_1 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "gt") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x1 l cd cs)
    (d_C__case_2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "HTML.LaTeX._case_2"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_2" (showCons x2))

d_C__case_1 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_1 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "{$>$}"
  Curry_Prelude.C_False -> d_C__case_0 x1 (Curry_Prelude.d_C_otherwise cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x1 l cd cs)
    (d_C__case_1 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "HTML.LaTeX._case_1"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_1" (showCons x2))

d_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_0 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\&") (Curry_Prelude.d_OP_plus_plus x1
    (Curry_Prelude.toCurryString ";") cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x1 l cd cs)
    (d_C__case_0 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "HTML.LaTeX._case_0"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "HTML.LaTeX._case_0" (showCons x2))

