{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Text.Curry_Markdown
  ( C_MarkdownElem (..)
  , C_SourceMDElem (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_SourceMDElem_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_SourceMDElem_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_SourceMDElem_hash
  , d_C_fromMarkdownText
  , d_C_removeEscapes
  , d_C_markdownEscapeChars
  , d_C_markdownText2HTML
  , nd_C_markdownText2HTML
  , d_C_markdownText2CompleteHTML
  , d_C_markdownText2LaTeX
  , d_C_markdownText2LaTeXWithFormat
  , nd_C_markdownText2LaTeXWithFormat
  , d_C_markdownText2CompleteLaTeX
  , d_C_formatMarkdownInputAsPDF
  , d_C_formatMarkdownFileAsPDF )
  where

import Basics
import qualified Data.Curry_List
import qualified HTML.Curry_Base
import qualified HTML.Curry_LaTeX
import qualified Curry_Prelude
import qualified System.Curry_IO
import qualified System.Curry_Process


data C_MarkdownElem
  = C_Text (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_Emph (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_Strong (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_Code (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_HRef (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char)
  | C_Par (Curry_Prelude.OP_List C_MarkdownElem)
  | C_CodeBlock (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_UList (Curry_Prelude.OP_List (Curry_Prelude.OP_List C_MarkdownElem))
  | C_OList (Curry_Prelude.OP_List (Curry_Prelude.OP_List C_MarkdownElem))
  | C_Quote (Curry_Prelude.OP_List C_MarkdownElem)
  | C_HRule
  | C_Header Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | Choice_C_MarkdownElem Cover ID C_MarkdownElem C_MarkdownElem
  | Choices_C_MarkdownElem Cover ID [C_MarkdownElem]
  | Fail_C_MarkdownElem Cover FailInfo
  | Guard_C_MarkdownElem Cover Constraints C_MarkdownElem

instance Show C_MarkdownElem where
  showsPrec d (Choice_C_MarkdownElem cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_MarkdownElem cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_MarkdownElem cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_MarkdownElem cd info) = showChar '!'
  showsPrec _ (C_Text x1) = showString "(Text" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_Emph x1) = showString "(Emph" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_Strong x1) = showString "(Strong" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_Code x1) = showString "(Code" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_HRef x1 x2) = showString "(HRef" . (showChar ' ' . (shows x1 .
    (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_Par x1) = showString "(Par" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_CodeBlock x1) = showString "(CodeBlock" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (C_UList x1) = showString "(UList" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_OList x1) = showString "(OList" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_Quote x1) = showString "(Quote" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ C_HRule = showString "HRule"
  showsPrec _ (C_Header x1 x2) = showString "(Header" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))

instance Read C_MarkdownElem where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Text x1, r1) | (_, r0) <-
    readQualified "Text.Markdown" "Text" r, (x1, r1) <- readsPrec 11 r0]) s ++
    (readParen ((>) d 10) (\r -> [(C_Emph x1, r1) | (_, r0) <- readQualified
    "Text.Markdown" "Emph" r, (x1, r1) <- readsPrec 11 r0]) s ++ (readParen ((>)
    d 10) (\r -> [(C_Strong x1, r1) | (_, r0) <- readQualified "Text.Markdown"
    "Strong" r, (x1, r1) <- readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r ->
    [(C_Code x1, r1) | (_, r0) <- readQualified "Text.Markdown" "Code" r, (x1
    , r1) <- readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_HRef x1 x2
    , r2) | (_, r0) <- readQualified "Text.Markdown" "HRef" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ (readParen ((>) d 10)
    (\r -> [(C_Par x1, r1) | (_, r0) <- readQualified "Text.Markdown" "Par" r,
    (x1, r1) <- readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r ->
    [(C_CodeBlock x1, r1) | (_, r0) <- readQualified "Text.Markdown" "CodeBlock"
    r, (x1, r1) <- readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_UList
    x1, r1) | (_, r0) <- readQualified "Text.Markdown" "UList" r, (x1, r1) <-
    readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_OList x1, r1) | (_
    , r0) <- readQualified "Text.Markdown" "OList" r, (x1, r1) <- readsPrec 11
    r0]) s ++ (readParen ((>) d 10) (\r -> [(C_Quote x1, r1) | (_, r0) <-
    readQualified "Text.Markdown" "Quote" r, (x1, r1) <- readsPrec 11 r0]) s ++
    (readParen False (\r -> [(C_HRule, r0) | (_, r0) <- readQualified
    "Text.Markdown" "HRule" r]) s ++ readParen ((>) d 10) (\r -> [(C_Header x1
    x2, r2) | (_, r0) <- readQualified "Text.Markdown" "Header" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1]) s))))))))))

instance NonDet C_MarkdownElem where
  choiceCons = Choice_C_MarkdownElem
  choicesCons = Choices_C_MarkdownElem
  failCons = Fail_C_MarkdownElem
  guardCons = Guard_C_MarkdownElem
  try (Choice_C_MarkdownElem cd i x y) = tryChoice cd i x y
  try (Choices_C_MarkdownElem cd i xs) = tryChoices cd i xs
  try (Fail_C_MarkdownElem cd info) = Fail cd info
  try (Guard_C_MarkdownElem cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_MarkdownElem cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_MarkdownElem cd i@(NarrowedID _ _) xs) = f cd i
    xs
  match _ _ f _ _ _ (Choices_C_MarkdownElem cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_MarkdownElem cd i _) = error
    ("Text.Markdown.MarkdownElem.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_MarkdownElem cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_MarkdownElem cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_MarkdownElem where
  generate s c = Choices_C_MarkdownElem c (freeID [1, 1, 1, 1, 2, 1, 1, 1, 1, 1
    , 0, 2] s) [C_Text (generate (leftSupply s) c), C_Emph (generate (leftSupply
    s) c), C_Strong (generate (leftSupply s) c), C_Code (generate (leftSupply s)
    c), C_HRef (generate (leftSupply s) c) (generate (rightSupply s) c), C_Par
    (generate (leftSupply s) c), C_CodeBlock (generate (leftSupply s) c)
    , C_UList (generate (leftSupply s) c), C_OList (generate (leftSupply s) c)
    , C_Quote (generate (leftSupply s) c), C_HRule, C_Header (generate
    (leftSupply s) c) (generate (rightSupply s) c)]

instance NormalForm C_MarkdownElem where
  ($!!) cont (C_Text x1) d cs = ($!!) (\y1 d cs -> cont (C_Text y1) d cs) x1 d
    cs
  ($!!) cont (C_Emph x1) d cs = ($!!) (\y1 d cs -> cont (C_Emph y1) d cs) x1 d
    cs
  ($!!) cont (C_Strong x1) d cs = ($!!) (\y1 d cs -> cont (C_Strong y1) d cs) x1
    d cs
  ($!!) cont (C_Code x1) d cs = ($!!) (\y1 d cs -> cont (C_Code y1) d cs) x1 d
    cs
  ($!!) cont (C_HRef x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_HRef y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_Par x1) d cs = ($!!) (\y1 d cs -> cont (C_Par y1) d cs) x1 d cs
  ($!!) cont (C_CodeBlock x1) d cs = ($!!) (\y1 d cs -> cont (C_CodeBlock y1) d
    cs) x1 d cs
  ($!!) cont (C_UList x1) d cs = ($!!) (\y1 d cs -> cont (C_UList y1) d cs) x1 d
    cs
  ($!!) cont (C_OList x1) d cs = ($!!) (\y1 d cs -> cont (C_OList y1) d cs) x1 d
    cs
  ($!!) cont (C_Quote x1) d cs = ($!!) (\y1 d cs -> cont (C_Quote y1) d cs) x1 d
    cs
  ($!!) cont C_HRule d cs = cont C_HRule d cs
  ($!!) cont (C_Header x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Header y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_MarkdownElem cd i x y) d cs = nfChoice cont cd i x y cd
    cs
  ($!!) cont (Choices_C_MarkdownElem cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_MarkdownElem cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_MarkdownElem cd info) _ _ = failCons cd info
  ($##) cont (C_Text x1) d cs = ($##) (\y1 d cs -> cont (C_Text y1) d cs) x1 d
    cs
  ($##) cont (C_Emph x1) d cs = ($##) (\y1 d cs -> cont (C_Emph y1) d cs) x1 d
    cs
  ($##) cont (C_Strong x1) d cs = ($##) (\y1 d cs -> cont (C_Strong y1) d cs) x1
    d cs
  ($##) cont (C_Code x1) d cs = ($##) (\y1 d cs -> cont (C_Code y1) d cs) x1 d
    cs
  ($##) cont (C_HRef x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_HRef y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_Par x1) d cs = ($##) (\y1 d cs -> cont (C_Par y1) d cs) x1 d cs
  ($##) cont (C_CodeBlock x1) d cs = ($##) (\y1 d cs -> cont (C_CodeBlock y1) d
    cs) x1 d cs
  ($##) cont (C_UList x1) d cs = ($##) (\y1 d cs -> cont (C_UList y1) d cs) x1 d
    cs
  ($##) cont (C_OList x1) d cs = ($##) (\y1 d cs -> cont (C_OList y1) d cs) x1 d
    cs
  ($##) cont (C_Quote x1) d cs = ($##) (\y1 d cs -> cont (C_Quote y1) d cs) x1 d
    cs
  ($##) cont C_HRule d cs = cont C_HRule d cs
  ($##) cont (C_Header x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Header y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_MarkdownElem cd i x y) d cs = gnfChoice cont cd i x y cd
    cs
  ($##) cont (Choices_C_MarkdownElem cd i xs) d cs = gnfChoices cont cd i xs d
    cs
  ($##) cont (Guard_C_MarkdownElem cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_MarkdownElem cd info) _ _ = failCons cd info
  showCons (C_Text _) = "Text.Markdown.Text _"
  showCons (C_Emph _) = "Text.Markdown.Emph _"
  showCons (C_Strong _) = "Text.Markdown.Strong _"
  showCons (C_Code _) = "Text.Markdown.Code _"
  showCons (C_HRef _ _) = "Text.Markdown.HRef _ _"
  showCons (C_Par _) = "Text.Markdown.Par _"
  showCons (C_CodeBlock _) = "Text.Markdown.CodeBlock _"
  showCons (C_UList _) = "Text.Markdown.UList _"
  showCons (C_OList _) = "Text.Markdown.OList _"
  showCons (C_Quote _) = "Text.Markdown.Quote _"
  showCons C_HRule = "Text.Markdown.HRule"
  showCons (C_Header _ _) = "Text.Markdown.Header _ _"
  showCons x = error ("Text.Markdown.MarkdownElem.showCons: no constructor: " ++
    show x)
  searchNF search cont (C_Text x1) = search (\y1 -> cont (C_Text y1)) x1
  searchNF search cont (C_Emph x1) = search (\y1 -> cont (C_Emph y1)) x1
  searchNF search cont (C_Strong x1) = search (\y1 -> cont (C_Strong y1)) x1
  searchNF search cont (C_Code x1) = search (\y1 -> cont (C_Code y1)) x1
  searchNF search cont (C_HRef x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_HRef y1 y2)) x2) x1
  searchNF search cont (C_Par x1) = search (\y1 -> cont (C_Par y1)) x1
  searchNF search cont (C_CodeBlock x1) = search (\y1 -> cont (C_CodeBlock y1))
    x1
  searchNF search cont (C_UList x1) = search (\y1 -> cont (C_UList y1)) x1
  searchNF search cont (C_OList x1) = search (\y1 -> cont (C_OList y1)) x1
  searchNF search cont (C_Quote x1) = search (\y1 -> cont (C_Quote y1)) x1
  searchNF _ cont C_HRule = cont C_HRule
  searchNF search cont (C_Header x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Header y1 y2)) x2) x1
  searchNF _ _ x = error
    ("Text.Markdown.MarkdownElem.searchNF: no constructor: " ++ show x)

instance Unifiable C_MarkdownElem where
  (=.=) (C_Text x1) (C_Text y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Emph x1) (C_Emph y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Strong x1) (C_Strong y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Code x1) (C_Code y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_HRef x1 x2) (C_HRef y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2
    d cs) d cs
  (=.=) (C_Par x1) (C_Par y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_CodeBlock x1) (C_CodeBlock y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_UList x1) (C_UList y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_OList x1) (C_OList y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Quote x1) (C_Quote y1) d cs = (=:=) x1 y1 d cs
  (=.=) C_HRule C_HRule d cs = C_True
  (=.=) (C_Header x1 x2) (C_Header y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=)
    x2 y2 d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Text x1) (C_Text y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Emph x1) (C_Emph y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Strong x1) (C_Strong y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Code x1) (C_Code y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_HRef x1 x2) (C_HRef y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=) x2
    y2 d cs) d cs
  (=.<=) (C_Par x1) (C_Par y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_CodeBlock x1) (C_CodeBlock y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_UList x1) (C_UList y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_OList x1) (C_OList y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Quote x1) (C_Quote y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) C_HRule C_HRule d cs = C_True
  (=.<=) (C_Header x1 x2) (C_Header y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Text x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_Emph x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_Strong x3) = (i :=: ChooseN 2 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_Code x3) = (i :=: ChooseN 3 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_HRef x3 x4) = (i :=: ChooseN 4 2) : concat [bind cd (leftID i) x3
    , bind cd (rightID i) x4]
  bind cd i (C_Par x3) = (i :=: ChooseN 5 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_CodeBlock x3) = (i :=: ChooseN 6 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_UList x3) = (i :=: ChooseN 7 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_OList x3) = (i :=: ChooseN 8 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_Quote x3) = (i :=: ChooseN 9 1) : concat [bind cd (leftID i) x3]
  bind cd i C_HRule = (i :=: ChooseN 10 0) : concat []
  bind cd i (C_Header x3 x4) = (i :=: ChooseN 11 2) : concat [bind cd (leftID i)
    x3, bind cd (rightID i) x4]
  bind d i (Choice_C_MarkdownElem cd j x y) = [ConstraintChoice cd j (bind d i
    x) (bind d i y)]
  bind d i (Choices_C_MarkdownElem cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j
    xs
  bind d i (Choices_C_MarkdownElem cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_MarkdownElem cd i _) = error
    ("Text.Markdown.MarkdownElem.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_MarkdownElem cd info) = [Unsolvable info]
  bind d i (Guard_C_MarkdownElem cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Text x3) = (i :=: ChooseN 0 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Emph x3) = (i :=: ChooseN 1 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Strong x3) = (i :=: ChooseN 2 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Code x3) = (i :=: ChooseN 3 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_HRef x3 x4) = (i :=: ChooseN 4 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (C_Par x3) = (i :=: ChooseN 5 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_CodeBlock x3) = (i :=: ChooseN 6 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_UList x3) = (i :=: ChooseN 7 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_OList x3) = (i :=: ChooseN 8 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Quote x3) = (i :=: ChooseN 9 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i C_HRule = (i :=: ChooseN 10 0) : []
  lazyBind cd i (C_Header x3 x4) = (i :=: ChooseN 11 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind d i (Choice_C_MarkdownElem cd j x y) = [ConstraintChoice cd j
    (lazyBind d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_MarkdownElem cd j@(FreeID _ _) xs) = lazyBindOrNarrow
    d i cd j xs
  lazyBind d i (Choices_C_MarkdownElem cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_MarkdownElem cd i _) = error
    ("Text.Markdown.MarkdownElem.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_MarkdownElem cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_MarkdownElem cd c e) = getConstrList c ++ [i :=:
    LazyBind (lazyBind d i e)]

instance Curry C_MarkdownElem where

data C_SourceMDElem
  = C_SMDText (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_SMDEmph (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_SMDStrong (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_SMDCode (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_SMDHRef (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_SMDPar (Curry_Prelude.OP_List C_MarkdownElem)
  | C_SMDCodeBlock (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_SMDUItem (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_SMDOItem (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_SMDQuote (Curry_Prelude.OP_List C_MarkdownElem)
  | C_SMDHRule
  | C_SMDHeader Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | Choice_C_SourceMDElem Cover ID C_SourceMDElem C_SourceMDElem
  | Choices_C_SourceMDElem Cover ID [C_SourceMDElem]
  | Fail_C_SourceMDElem Cover FailInfo
  | Guard_C_SourceMDElem Cover Constraints C_SourceMDElem

instance Show C_SourceMDElem where
  showsPrec d (Choice_C_SourceMDElem cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_SourceMDElem cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_SourceMDElem cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_SourceMDElem cd info) = showChar '!'
  showsPrec _ (C_SMDText x1) = showString "(SMDText" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_SMDEmph x1) = showString "(SMDEmph" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_SMDStrong x1) = showString "(SMDStrong" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (C_SMDCode x1) = showString "(SMDCode" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_SMDHRef x1 x2) = showString "(SMDHRef" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_SMDPar x1) = showString "(SMDPar" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_SMDCodeBlock x1) = showString "(SMDCodeBlock" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (C_SMDUItem x1) = showString "(SMDUItem" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_SMDOItem x1) = showString "(SMDOItem" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_SMDQuote x1) = showString "(SMDQuote" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ C_SMDHRule = showString "SMDHRule"
  showsPrec _ (C_SMDHeader x1 x2) = showString "(SMDHeader" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))

instance Read C_SourceMDElem where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_SMDText x1, r1) | (_, r0) <-
    readQualified "Text.Markdown" "SMDText" r, (x1, r1) <- readsPrec 11 r0])
    s ++ (readParen ((>) d 10) (\r -> [(C_SMDEmph x1, r1) | (_, r0) <-
    readQualified "Text.Markdown" "SMDEmph" r, (x1, r1) <- readsPrec 11 r0])
    s ++ (readParen ((>) d 10) (\r -> [(C_SMDStrong x1, r1) | (_, r0) <-
    readQualified "Text.Markdown" "SMDStrong" r, (x1, r1) <- readsPrec 11 r0])
    s ++ (readParen ((>) d 10) (\r -> [(C_SMDCode x1, r1) | (_, r0) <-
    readQualified "Text.Markdown" "SMDCode" r, (x1, r1) <- readsPrec 11 r0])
    s ++ (readParen ((>) d 10) (\r -> [(C_SMDHRef x1 x2, r2) | (_, r0) <-
    readQualified "Text.Markdown" "SMDHRef" r, (x1, r1) <- readsPrec 11 r0, (x2
    , r2) <- readsPrec 11 r1]) s ++ (readParen ((>) d 10) (\r -> [(C_SMDPar x1
    , r1) | (_, r0) <- readQualified "Text.Markdown" "SMDPar" r, (x1, r1) <-
    readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_SMDCodeBlock x1
    , r1) | (_, r0) <- readQualified "Text.Markdown" "SMDCodeBlock" r, (x1, r1)
    <- readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_SMDUItem x1
    , r1) | (_, r0) <- readQualified "Text.Markdown" "SMDUItem" r, (x1, r1) <-
    readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_SMDOItem x1
    , r1) | (_, r0) <- readQualified "Text.Markdown" "SMDOItem" r, (x1, r1) <-
    readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_SMDQuote x1
    , r1) | (_, r0) <- readQualified "Text.Markdown" "SMDQuote" r, (x1, r1) <-
    readsPrec 11 r0]) s ++ (readParen False (\r -> [(C_SMDHRule, r0) | (_, r0)
    <- readQualified "Text.Markdown" "SMDHRule" r]) s ++ readParen ((>) d 10)
    (\r -> [(C_SMDHeader x1 x2, r2) | (_, r0) <- readQualified "Text.Markdown"
    "SMDHeader" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1])
    s))))))))))

instance NonDet C_SourceMDElem where
  choiceCons = Choice_C_SourceMDElem
  choicesCons = Choices_C_SourceMDElem
  failCons = Fail_C_SourceMDElem
  guardCons = Guard_C_SourceMDElem
  try (Choice_C_SourceMDElem cd i x y) = tryChoice cd i x y
  try (Choices_C_SourceMDElem cd i xs) = tryChoices cd i xs
  try (Fail_C_SourceMDElem cd info) = Fail cd info
  try (Guard_C_SourceMDElem cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_SourceMDElem cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_SourceMDElem cd i@(NarrowedID _ _) xs) = f cd i
    xs
  match _ _ f _ _ _ (Choices_C_SourceMDElem cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_SourceMDElem cd i _) = error
    ("Text.Markdown.SourceMDElem.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_SourceMDElem cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_SourceMDElem cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_SourceMDElem where
  generate s c = Choices_C_SourceMDElem c (freeID [1, 1, 1, 1, 2, 1, 1, 1, 1, 1
    , 0, 2] s) [C_SMDText (generate (leftSupply s) c), C_SMDEmph (generate
    (leftSupply s) c), C_SMDStrong (generate (leftSupply s) c), C_SMDCode
    (generate (leftSupply s) c), C_SMDHRef (generate (leftSupply s) c) (generate
    (rightSupply s) c), C_SMDPar (generate (leftSupply s) c), C_SMDCodeBlock
    (generate (leftSupply s) c), C_SMDUItem (generate (leftSupply s) c)
    , C_SMDOItem (generate (leftSupply s) c), C_SMDQuote (generate (leftSupply
    s) c), C_SMDHRule, C_SMDHeader (generate (leftSupply s) c) (generate
    (rightSupply s) c)]

instance NormalForm C_SourceMDElem where
  ($!!) cont (C_SMDText x1) d cs = ($!!) (\y1 d cs -> cont (C_SMDText y1) d cs)
    x1 d cs
  ($!!) cont (C_SMDEmph x1) d cs = ($!!) (\y1 d cs -> cont (C_SMDEmph y1) d cs)
    x1 d cs
  ($!!) cont (C_SMDStrong x1) d cs = ($!!) (\y1 d cs -> cont (C_SMDStrong y1) d
    cs) x1 d cs
  ($!!) cont (C_SMDCode x1) d cs = ($!!) (\y1 d cs -> cont (C_SMDCode y1) d cs)
    x1 d cs
  ($!!) cont (C_SMDHRef x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_SMDHRef y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_SMDPar x1) d cs = ($!!) (\y1 d cs -> cont (C_SMDPar y1) d cs) x1
    d cs
  ($!!) cont (C_SMDCodeBlock x1) d cs = ($!!) (\y1 d cs -> cont (C_SMDCodeBlock
    y1) d cs) x1 d cs
  ($!!) cont (C_SMDUItem x1) d cs = ($!!) (\y1 d cs -> cont (C_SMDUItem y1) d
    cs) x1 d cs
  ($!!) cont (C_SMDOItem x1) d cs = ($!!) (\y1 d cs -> cont (C_SMDOItem y1) d
    cs) x1 d cs
  ($!!) cont (C_SMDQuote x1) d cs = ($!!) (\y1 d cs -> cont (C_SMDQuote y1) d
    cs) x1 d cs
  ($!!) cont C_SMDHRule d cs = cont C_SMDHRule d cs
  ($!!) cont (C_SMDHeader x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_SMDHeader y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_SourceMDElem cd i x y) d cs = nfChoice cont cd i x y cd
    cs
  ($!!) cont (Choices_C_SourceMDElem cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_SourceMDElem cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_SourceMDElem cd info) _ _ = failCons cd info
  ($##) cont (C_SMDText x1) d cs = ($##) (\y1 d cs -> cont (C_SMDText y1) d cs)
    x1 d cs
  ($##) cont (C_SMDEmph x1) d cs = ($##) (\y1 d cs -> cont (C_SMDEmph y1) d cs)
    x1 d cs
  ($##) cont (C_SMDStrong x1) d cs = ($##) (\y1 d cs -> cont (C_SMDStrong y1) d
    cs) x1 d cs
  ($##) cont (C_SMDCode x1) d cs = ($##) (\y1 d cs -> cont (C_SMDCode y1) d cs)
    x1 d cs
  ($##) cont (C_SMDHRef x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_SMDHRef y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_SMDPar x1) d cs = ($##) (\y1 d cs -> cont (C_SMDPar y1) d cs) x1
    d cs
  ($##) cont (C_SMDCodeBlock x1) d cs = ($##) (\y1 d cs -> cont (C_SMDCodeBlock
    y1) d cs) x1 d cs
  ($##) cont (C_SMDUItem x1) d cs = ($##) (\y1 d cs -> cont (C_SMDUItem y1) d
    cs) x1 d cs
  ($##) cont (C_SMDOItem x1) d cs = ($##) (\y1 d cs -> cont (C_SMDOItem y1) d
    cs) x1 d cs
  ($##) cont (C_SMDQuote x1) d cs = ($##) (\y1 d cs -> cont (C_SMDQuote y1) d
    cs) x1 d cs
  ($##) cont C_SMDHRule d cs = cont C_SMDHRule d cs
  ($##) cont (C_SMDHeader x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_SMDHeader y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_SourceMDElem cd i x y) d cs = gnfChoice cont cd i x y cd
    cs
  ($##) cont (Choices_C_SourceMDElem cd i xs) d cs = gnfChoices cont cd i xs d
    cs
  ($##) cont (Guard_C_SourceMDElem cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_SourceMDElem cd info) _ _ = failCons cd info
  showCons (C_SMDText _) = "Text.Markdown.SMDText _"
  showCons (C_SMDEmph _) = "Text.Markdown.SMDEmph _"
  showCons (C_SMDStrong _) = "Text.Markdown.SMDStrong _"
  showCons (C_SMDCode _) = "Text.Markdown.SMDCode _"
  showCons (C_SMDHRef _ _) = "Text.Markdown.SMDHRef _ _"
  showCons (C_SMDPar _) = "Text.Markdown.SMDPar _"
  showCons (C_SMDCodeBlock _) = "Text.Markdown.SMDCodeBlock _"
  showCons (C_SMDUItem _) = "Text.Markdown.SMDUItem _"
  showCons (C_SMDOItem _) = "Text.Markdown.SMDOItem _"
  showCons (C_SMDQuote _) = "Text.Markdown.SMDQuote _"
  showCons C_SMDHRule = "Text.Markdown.SMDHRule"
  showCons (C_SMDHeader _ _) = "Text.Markdown.SMDHeader _ _"
  showCons x = error ("Text.Markdown.SourceMDElem.showCons: no constructor: " ++
    show x)
  searchNF search cont (C_SMDText x1) = search (\y1 -> cont (C_SMDText y1)) x1
  searchNF search cont (C_SMDEmph x1) = search (\y1 -> cont (C_SMDEmph y1)) x1
  searchNF search cont (C_SMDStrong x1) = search (\y1 -> cont (C_SMDStrong y1))
    x1
  searchNF search cont (C_SMDCode x1) = search (\y1 -> cont (C_SMDCode y1)) x1
  searchNF search cont (C_SMDHRef x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_SMDHRef y1 y2)) x2) x1
  searchNF search cont (C_SMDPar x1) = search (\y1 -> cont (C_SMDPar y1)) x1
  searchNF search cont (C_SMDCodeBlock x1) = search (\y1 -> cont (C_SMDCodeBlock
    y1)) x1
  searchNF search cont (C_SMDUItem x1) = search (\y1 -> cont (C_SMDUItem y1)) x1
  searchNF search cont (C_SMDOItem x1) = search (\y1 -> cont (C_SMDOItem y1)) x1
  searchNF search cont (C_SMDQuote x1) = search (\y1 -> cont (C_SMDQuote y1)) x1
  searchNF _ cont C_SMDHRule = cont C_SMDHRule
  searchNF search cont (C_SMDHeader x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_SMDHeader y1 y2)) x2) x1
  searchNF _ _ x = error
    ("Text.Markdown.SourceMDElem.searchNF: no constructor: " ++ show x)

instance Unifiable C_SourceMDElem where
  (=.=) (C_SMDText x1) (C_SMDText y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_SMDEmph x1) (C_SMDEmph y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_SMDStrong x1) (C_SMDStrong y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_SMDCode x1) (C_SMDCode y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_SMDHRef x1 x2) (C_SMDHRef y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=)
    x2 y2 d cs) d cs
  (=.=) (C_SMDPar x1) (C_SMDPar y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_SMDCodeBlock x1) (C_SMDCodeBlock y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_SMDUItem x1) (C_SMDUItem y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_SMDOItem x1) (C_SMDOItem y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_SMDQuote x1) (C_SMDQuote y1) d cs = (=:=) x1 y1 d cs
  (=.=) C_SMDHRule C_SMDHRule d cs = C_True
  (=.=) (C_SMDHeader x1 x2) (C_SMDHeader y1 y2) d cs = (&) ((=:=) x1 y1 d cs)
    ((=:=) x2 y2 d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_SMDText x1) (C_SMDText y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_SMDEmph x1) (C_SMDEmph y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_SMDStrong x1) (C_SMDStrong y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_SMDCode x1) (C_SMDCode y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_SMDHRef x1 x2) (C_SMDHRef y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_SMDPar x1) (C_SMDPar y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_SMDCodeBlock x1) (C_SMDCodeBlock y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_SMDUItem x1) (C_SMDUItem y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_SMDOItem x1) (C_SMDOItem y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_SMDQuote x1) (C_SMDQuote y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) C_SMDHRule C_SMDHRule d cs = C_True
  (=.<=) (C_SMDHeader x1 x2) (C_SMDHeader y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_SMDText x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_SMDEmph x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_SMDStrong x3) = (i :=: ChooseN 2 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_SMDCode x3) = (i :=: ChooseN 3 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_SMDHRef x3 x4) = (i :=: ChooseN 4 2) : concat [bind cd (leftID i)
    x3, bind cd (rightID i) x4]
  bind cd i (C_SMDPar x3) = (i :=: ChooseN 5 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_SMDCodeBlock x3) = (i :=: ChooseN 6 1) : concat [bind cd (leftID
    i) x3]
  bind cd i (C_SMDUItem x3) = (i :=: ChooseN 7 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_SMDOItem x3) = (i :=: ChooseN 8 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_SMDQuote x3) = (i :=: ChooseN 9 1) : concat [bind cd (leftID i)
    x3]
  bind cd i C_SMDHRule = (i :=: ChooseN 10 0) : concat []
  bind cd i (C_SMDHeader x3 x4) = (i :=: ChooseN 11 2) : concat [bind cd (leftID
    i) x3, bind cd (rightID i) x4]
  bind d i (Choice_C_SourceMDElem cd j x y) = [ConstraintChoice cd j (bind d i
    x) (bind d i y)]
  bind d i (Choices_C_SourceMDElem cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j
    xs
  bind d i (Choices_C_SourceMDElem cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_SourceMDElem cd i _) = error
    ("Text.Markdown.SourceMDElem.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_SourceMDElem cd info) = [Unsolvable info]
  bind d i (Guard_C_SourceMDElem cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_SMDText x3) = (i :=: ChooseN 0 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_SMDEmph x3) = (i :=: ChooseN 1 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_SMDStrong x3) = (i :=: ChooseN 2 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_SMDCode x3) = (i :=: ChooseN 3 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_SMDHRef x3 x4) = (i :=: ChooseN 4 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (C_SMDPar x3) = (i :=: ChooseN 5 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_SMDCodeBlock x3) = (i :=: ChooseN 6 1) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_SMDUItem x3) = (i :=: ChooseN 7 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_SMDOItem x3) = (i :=: ChooseN 8 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_SMDQuote x3) = (i :=: ChooseN 9 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i C_SMDHRule = (i :=: ChooseN 10 0) : []
  lazyBind cd i (C_SMDHeader x3 x4) = (i :=: ChooseN 11 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind d i (Choice_C_SourceMDElem cd j x y) = [ConstraintChoice cd j
    (lazyBind d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_SourceMDElem cd j@(FreeID _ _) xs) = lazyBindOrNarrow
    d i cd j xs
  lazyBind d i (Choices_C_SourceMDElem cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_SourceMDElem cd i _) = error
    ("Text.Markdown.SourceMDElem.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_SourceMDElem cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_SourceMDElem cd c e) = getConstrList c ++ [i :=:
    LazyBind (lazyBind d i e)]

instance Curry C_SourceMDElem where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_MarkdownElem
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Text.Markdown._inst#Prelude.Data#Text.Markdown.MarkdownElem#" [show x1]
    info)
  _ -> failCons cd (consFail
    "Text.Markdown._inst#Prelude.Data#Text.Markdown.MarkdownElem#" (showCons
    x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash :: C_MarkdownElem
  -> C_MarkdownElem -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash x1 x2 s cd cs =
  case x1 of
  C_Text x3 -> let s0 = s in s0 `seq` nd_C__case_96 x3 x2 s0 cd cs
  C_Emph x17 -> let s0 = s in s0 `seq` nd_C__case_95 x17 x2 s0 cd cs
  C_Strong x31 -> let s0 = s in s0 `seq` nd_C__case_94 x31 x2 s0 cd cs
  C_Code x45 -> let s0 = s in s0 `seq` nd_C__case_93 x45 x2 s0 cd cs
  C_HRef x59 x60 -> let s0 = s in s0 `seq` nd_C__case_92 x60 x59 x2 s0 cd cs
  C_Par x74 -> let s0 = s in s0 `seq` nd_C__case_91 x74 x2 s0 cd cs
  C_CodeBlock x88 -> let s0 = s in s0 `seq` nd_C__case_90 x88 x2 s0 cd cs
  C_UList x102 -> let s0 = s in s0 `seq` nd_C__case_89 x102 x2 s0 cd cs
  C_OList x116 -> let s0 = s in s0 `seq` nd_C__case_88 x116 x2 s0 cd cs
  C_Quote x130 -> let s0 = s in s0 `seq` nd_C__case_87 x130 x2 s0 cd cs
  C_HRule -> d_C__case_86 x2 cd cs
  C_Header x157 x158 -> let s0 = s
    in s0 `seq` nd_C__case_85 x158 x157 x2 s0 cd cs
  Choice_C_MarkdownElem d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash
    r x2 s cd cs)
  Choices_C_MarkdownElem d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash
    z x2 s cd cs) xs
  Guard_C_MarkdownElem d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_MarkdownElem d info -> failCons d (traceFail
    "Text.Markdown._impl#===#Prelude.Data#Text.Markdown.MarkdownElem#" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "Text.Markdown._impl#===#Prelude.Data#Text.Markdown.MarkdownElem#" (showCons
    x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash :: IDSupply
  -> Cover -> ConstStore -> C_MarkdownElem
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash s cd cs =
  let s45 = s
  in s45 `seq` (let s44 = leftSupply s45
                    s46 = rightSupply s45
                    s40 = leftSupply s46
                    s43 = rightSupply s46
  in s44 `seq` (s46 `seq` (s40 `seq` (s43 `seq` choice (let s39 = leftSupply s40
                                                            s37 = rightSupply
                                                              s40
  in s39 `seq` (s37 `seq` choice (let s36 = leftSupply s37
                                      s38 = rightSupply s37
                                      s33 = leftSupply s38
                                      s35 = rightSupply s38
  in s36 `seq` (s38 `seq` (s33 `seq` (s35 `seq` choice (let s32 = leftSupply s33
                                                            s34 = rightSupply
                                                              s33
                                                            s29 = leftSupply s34
                                                            s31 = rightSupply
                                                              s34
  in s32 `seq` (s34 `seq` (s29 `seq` (s31 `seq` choice (let s28 = leftSupply s29
                                                            s30 = rightSupply
                                                              s29
                                                            s25 = leftSupply s30
                                                            s27 = rightSupply
                                                              s30
  in s28 `seq` (s30 `seq` (s25 `seq` (s27 `seq` choice (let s24 = leftSupply s25
                                                            s26 = rightSupply
                                                              s25
                                                            s21 = leftSupply s26
                                                            s23 = rightSupply
                                                              s26
  in s24 `seq` (s26 `seq` (s21 `seq` (s23 `seq` choice (let s20 = leftSupply s21
                                                            s22 = rightSupply
                                                              s21
                                                            s17 = leftSupply s22
                                                            s19 = rightSupply
                                                              s22
  in s20 `seq` (s22 `seq` (s17 `seq` (s19 `seq` choice (let s16 = leftSupply s17
                                                            s18 = rightSupply
                                                              s17
                                                            s11 = leftSupply s18
                                                            s15 = rightSupply
                                                              s18
  in s16 `seq` (s18 `seq` (s11 `seq` (s15 `seq` choice (let s10 = leftSupply s11
                                                            s12 = rightSupply
                                                              s11
                                                            s7 = leftSupply s12
                                                            s9 = rightSupply s12
  in s10 `seq` (s12 `seq` (s7 `seq` (s9 `seq` choice (let s6 = leftSupply s7
                                                          s8 = rightSupply s7
                                                          s3 = leftSupply s8
                                                          s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` choice (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` choice (C_Text
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)) (C_Emph
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s1 cd cs)) s2 cd cs)))) (C_Strong
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s5 cd cs)) s6 cd cs)))) (C_Code
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s9 cd cs)) s10 cd cs)))) (let s13 = leftSupply s15
                                s14 = rightSupply s15
  in s13 `seq` (s14 `seq` C_HRef
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s13 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s14 cd cs))) s16 cd cs)))) (C_Par
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash)
  s19 cd cs)) s20 cd cs)))) (C_CodeBlock
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s23 cd cs)) s24 cd cs)))) (C_UList
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash)))
  s27 cd cs)) s28 cd cs)))) (C_OList
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash)))
  s31 cd cs)) s32 cd cs)))) (C_Quote
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash)
  s35 cd cs)) s36 cd cs)))) C_HRule s39 cd cs)) (let s41 = leftSupply s43
                                                     s42 = rightSupply s43
  in s41 `seq` (s42 `seq` C_Header
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s41 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s42 cd cs))) s44 cd cs))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_SourceMDElem_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_SourceMDElem
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_SourceMDElem_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_SourceMDElem_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_SourceMDElem_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_SourceMDElem_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_SourceMDElem_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_SourceMDElem_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_SourceMDElem_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Text.Markdown._inst#Prelude.Data#Text.Markdown.SourceMDElem#" [show x1]
    info)
  _ -> failCons cd (consFail
    "Text.Markdown._inst#Prelude.Data#Text.Markdown.SourceMDElem#" (showCons
    x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_SourceMDElem_hash :: C_SourceMDElem
  -> C_SourceMDElem -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_SourceMDElem_hash x1 x2 s cd cs =
  case x1 of
  C_SMDText x3 -> let s0 = s in s0 `seq` nd_C__case_84 x3 x2 s0 cd cs
  C_SMDEmph x17 -> let s0 = s in s0 `seq` nd_C__case_83 x17 x2 s0 cd cs
  C_SMDStrong x31 -> let s0 = s in s0 `seq` nd_C__case_82 x31 x2 s0 cd cs
  C_SMDCode x45 -> let s0 = s in s0 `seq` nd_C__case_81 x45 x2 s0 cd cs
  C_SMDHRef x59 x60 -> let s0 = s in s0 `seq` nd_C__case_80 x60 x59 x2 s0 cd cs
  C_SMDPar x74 -> let s0 = s in s0 `seq` nd_C__case_79 x74 x2 s0 cd cs
  C_SMDCodeBlock x88 -> let s0 = s in s0 `seq` nd_C__case_78 x88 x2 s0 cd cs
  C_SMDUItem x102 -> let s0 = s in s0 `seq` nd_C__case_77 x102 x2 s0 cd cs
  C_SMDOItem x116 -> let s0 = s in s0 `seq` nd_C__case_76 x116 x2 s0 cd cs
  C_SMDQuote x130 -> let s0 = s in s0 `seq` nd_C__case_75 x130 x2 s0 cd cs
  C_SMDHRule -> d_C__case_74 x2 cd cs
  C_SMDHeader x157 x158 -> let s0 = s
    in s0 `seq` nd_C__case_73 x158 x157 x2 s0 cd cs
  Choice_C_SourceMDElem d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_SourceMDElem_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_SourceMDElem_hash
    r x2 s cd cs)
  Choices_C_SourceMDElem d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_SourceMDElem_hash
    z x2 s cd cs) xs
  Guard_C_SourceMDElem d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_SourceMDElem_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_SourceMDElem d info -> failCons d (traceFail
    "Text.Markdown._impl#===#Prelude.Data#Text.Markdown.SourceMDElem#" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "Text.Markdown._impl#===#Prelude.Data#Text.Markdown.SourceMDElem#" (showCons
    x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_SourceMDElem_hash :: IDSupply
  -> Cover -> ConstStore -> C_SourceMDElem
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_SourceMDElem_hash s cd cs =
  let s45 = s
  in s45 `seq` (let s44 = leftSupply s45
                    s46 = rightSupply s45
                    s40 = leftSupply s46
                    s43 = rightSupply s46
  in s44 `seq` (s46 `seq` (s40 `seq` (s43 `seq` choice (let s39 = leftSupply s40
                                                            s37 = rightSupply
                                                              s40
  in s39 `seq` (s37 `seq` choice (let s36 = leftSupply s37
                                      s38 = rightSupply s37
                                      s33 = leftSupply s38
                                      s35 = rightSupply s38
  in s36 `seq` (s38 `seq` (s33 `seq` (s35 `seq` choice (let s32 = leftSupply s33
                                                            s34 = rightSupply
                                                              s33
                                                            s29 = leftSupply s34
                                                            s31 = rightSupply
                                                              s34
  in s32 `seq` (s34 `seq` (s29 `seq` (s31 `seq` choice (let s28 = leftSupply s29
                                                            s30 = rightSupply
                                                              s29
                                                            s25 = leftSupply s30
                                                            s27 = rightSupply
                                                              s30
  in s28 `seq` (s30 `seq` (s25 `seq` (s27 `seq` choice (let s24 = leftSupply s25
                                                            s26 = rightSupply
                                                              s25
                                                            s21 = leftSupply s26
                                                            s23 = rightSupply
                                                              s26
  in s24 `seq` (s26 `seq` (s21 `seq` (s23 `seq` choice (let s20 = leftSupply s21
                                                            s22 = rightSupply
                                                              s21
                                                            s17 = leftSupply s22
                                                            s19 = rightSupply
                                                              s22
  in s20 `seq` (s22 `seq` (s17 `seq` (s19 `seq` choice (let s16 = leftSupply s17
                                                            s18 = rightSupply
                                                              s17
                                                            s11 = leftSupply s18
                                                            s15 = rightSupply
                                                              s18
  in s16 `seq` (s18 `seq` (s11 `seq` (s15 `seq` choice (let s10 = leftSupply s11
                                                            s12 = rightSupply
                                                              s11
                                                            s7 = leftSupply s12
                                                            s9 = rightSupply s12
  in s10 `seq` (s12 `seq` (s7 `seq` (s9 `seq` choice (let s6 = leftSupply s7
                                                          s8 = rightSupply s7
                                                          s3 = leftSupply s8
                                                          s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` choice (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` choice (C_SMDText
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)) (C_SMDEmph
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s1 cd cs)) s2 cd cs)))) (C_SMDStrong
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s5 cd cs)) s6 cd cs)))) (C_SMDCode
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s9 cd cs)) s10 cd cs)))) (let s13 = leftSupply s15
                                s14 = rightSupply s15
  in s13 `seq` (s14 `seq` C_SMDHRef
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s13 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s14 cd cs))) s16 cd cs)))) (C_SMDPar
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash)
  s19 cd cs)) s20 cd cs)))) (C_SMDCodeBlock
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s23 cd cs)) s24 cd cs)))) (C_SMDUItem
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s27 cd cs)) s28 cd cs)))) (C_SMDOItem
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s31 cd cs)) s32 cd cs)))) (C_SMDQuote
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash)
  s35 cd cs)) s36 cd cs)))) C_SMDHRule s39 cd cs)) (let s41 = leftSupply s43
                                                        s42 = rightSupply s43
  in s41 `seq` (s42 `seq` C_SMDHeader
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s41 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s42 cd cs))) s44 cd cs))))

d_C_isSMDUItem :: C_SourceMDElem -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isSMDUItem x1 cd cs = let x2 = Curry_Prelude.C_False
  in d_C__case_72 x2 x1 cd cs

d_C_isSMDOItem :: C_SourceMDElem -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isSMDOItem x1 cd cs = let x2 = Curry_Prelude.C_False
  in d_C__case_71 x2 x1 cd cs

d_C_textOfItem :: C_SourceMDElem -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_textOfItem x1 cd cs = let x2 = Curry_Prelude.OP_List
  in d_C__case_70 x2 x1 cd cs

d_C_fromMarkdownText :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_MarkdownElem
d_C_fromMarkdownText cd cs = Curry_Prelude.d_OP_dot d_C_groupMarkDownElems
  d_C_markdownText cd cs

d_C_groupMarkDownElems :: Curry_Prelude.OP_List C_SourceMDElem -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_MarkdownElem
d_C_groupMarkDownElems x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_69 x3 x2 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_groupMarkDownElems l
    cd cs) (d_C_groupMarkDownElems r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_groupMarkDownElems z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_C_groupMarkDownElems e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.Markdown.groupMarkDownElems" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.groupMarkDownElems" (showCons x1))

d_C_joinItems :: (Curry_Prelude.OP_List (Curry_Prelude.OP_List C_MarkdownElem)
  -> Cover -> ConstStore -> C_MarkdownElem) -> (C_SourceMDElem -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  C_SourceMDElem -> Cover -> ConstStore -> Curry_Prelude.OP_List C_MarkdownElem
d_C_joinItems x1 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply x1
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_reverse cd cs)
    (Curry_Prelude.d_C_map (d_C_fromMarkdownText cd cs) x3 cd cs) cd cs) cd cs)
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x5 x6 -> d_C__case_68 x5 x2 x6 x3 x1
    (Curry_Prelude.d_C_apply x2 x5 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_joinItems x1 x2 x3 l
    cd cs) (d_C_joinItems x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_joinItems x1
    x2 x3 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_joinItems x1 x2
    x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.Markdown.joinItems" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Text.Markdown.joinItems" (showCons x4))

nd_C_joinItems :: Func (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  C_MarkdownElem)) C_MarkdownElem -> Func C_SourceMDElem Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List C_SourceMDElem -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_MarkdownElem
nd_C_joinItems x1 x2 x3 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> let s6 = s
    in s6 `seq` Curry_Prelude.OP_Cons (let s5 = leftSupply s6
                                           s3 = rightSupply s6
    in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply x1 (let s2 = leftSupply s3
                                                           s4 = rightSupply s3
                                                           s0 = leftSupply s4
                                                           s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_reverse s0 cd cs) (Curry_Prelude.nd_C_map (wrapDX id
    (d_C_fromMarkdownText cd cs)) x3 s1 cd cs) s2 cd cs)))) s5 cd cs))
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x5 x6 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_68 x5 x2 x6 x3 x1 (Curry_Prelude.nd_C_apply
    x2 x5 s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_joinItems x1 x2 x3 l
    s cd cs) (nd_C_joinItems x1 x2 x3 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_joinItems
    x1 x2 x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_joinItems x1
    x2 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.Markdown.joinItems" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Text.Markdown.joinItems" (showCons x4))

d_C_markdownText :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_SourceMDElem
d_C_markdownText x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> let x4 = Curry_Prelude.d_C_apply
                                       (Curry_Prelude.d_C_break
                                       (Curry_Prelude.d_C_flip (acceptCs id
                                       Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                       (Curry_Prelude.C_Char '\n'#)) cd cs) x1
                                       cd cs
                                     x5 = d_OP_markdownText_dot_uscore_hash_selFP2_hash_fstline
                                       x4 cd cs
                                     x6 = d_OP_markdownText_dot_uscore_hash_selFP3_hash_remtxt
                                       x4 cd cs
    in d_C_markdownLine x5 (d_C_dropFirst x6 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_markdownText l cd cs)
    (d_C_markdownText r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_markdownText
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_markdownText e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.Markdown.markdownText" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.markdownText" (showCons x1))

d_OP_markdownText_dot_uscore_hash_selFP2_hash_fstline :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_markdownText_dot_uscore_hash_selFP2_hash_fstline x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_markdownText_dot_uscore_hash_selFP2_hash_fstline l cd cs)
    (d_OP_markdownText_dot_uscore_hash_selFP2_hash_fstline r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_markdownText_dot_uscore_hash_selFP2_hash_fstline z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_markdownText_dot_uscore_hash_selFP2_hash_fstline e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.markdownText._#selFP2#fstline" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.markdownText._#selFP2#fstline"
    (showCons x1))

d_OP_markdownText_dot_uscore_hash_selFP3_hash_remtxt :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_markdownText_dot_uscore_hash_selFP3_hash_remtxt x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_markdownText_dot_uscore_hash_selFP3_hash_remtxt l cd cs)
    (d_OP_markdownText_dot_uscore_hash_selFP3_hash_remtxt r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_markdownText_dot_uscore_hash_selFP3_hash_remtxt z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_markdownText_dot_uscore_hash_selFP3_hash_remtxt e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.markdownText._#selFP3#remtxt" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.markdownText._#selFP3#remtxt"
    (showCons x1))

d_C_markdownLine :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C_markdownLine x1 x2 cd cs = let x3 = d_C_isCodeLine x1 cd cs
                                   x4 = Curry_Prelude.d_C_apply
                                     (Curry_Prelude.d_C_break
                                     (Curry_Prelude.d_C_flip (acceptCs id
                                     Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                     (Curry_Prelude.C_Char '\n'#)) cd cs) x2 cd
                                     cs
                                   x5 = d_OP_markdownLine_dot_uscore_hash_selFP5_hash_sndline
                                     x4 cd cs
                                   x6 = d_OP_markdownLine_dot_uscore_hash_selFP6_hash_furtherlines
                                     x4 cd cs
                                   x7 = Curry_Prelude.d_OP_amp_amp
                                     (Curry_Prelude.d_C_not
                                     (Curry_Prelude.d_C_null x5 cd cs) cd cs)
                                     (Curry_Prelude.d_C_apply
                                     (Curry_Prelude.d_C_all
                                     (Curry_Prelude.d_C_flip (acceptCs id
                                     Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                     (Curry_Prelude.C_Char '='#)) cd cs) x5 cd
                                     cs) cd cs
                                   x8 = Curry_Prelude.d_OP_amp_amp
                                     (Curry_Prelude.d_C_not
                                     (Curry_Prelude.d_C_null x5 cd cs) cd cs)
                                     (Curry_Prelude.d_C_apply
                                     (Curry_Prelude.d_C_all
                                     (Curry_Prelude.d_C_flip (acceptCs id
                                     Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                     (Curry_Prelude.C_Char '-'#)) cd cs) x5 cd
                                     cs) cd cs
                                   x9 = d_C_isNumberedItemLine x1 cd cs
                                   x10 = d_C_isUnorderedItemLine x1 cd cs
  in d_C__case_67 x1 x3 x7 x8 x10 x9 x2 x6 (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_all Curry_Prelude.d_C_isSpace cd cs) x1 cd cs) cd cs

d_OP_markdownLine_dot_uscore_hash_selFP5_hash_sndline :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_markdownLine_dot_uscore_hash_selFP5_hash_sndline x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_markdownLine_dot_uscore_hash_selFP5_hash_sndline l cd cs)
    (d_OP_markdownLine_dot_uscore_hash_selFP5_hash_sndline r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_markdownLine_dot_uscore_hash_selFP5_hash_sndline z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_markdownLine_dot_uscore_hash_selFP5_hash_sndline e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.markdownLine._#selFP5#sndline" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.markdownLine._#selFP5#sndline"
    (showCons x1))

d_OP_markdownLine_dot_uscore_hash_selFP6_hash_furtherlines :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_markdownLine_dot_uscore_hash_selFP6_hash_furtherlines x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_markdownLine_dot_uscore_hash_selFP6_hash_furtherlines l cd cs)
    (d_OP_markdownLine_dot_uscore_hash_selFP6_hash_furtherlines r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_markdownLine_dot_uscore_hash_selFP6_hash_furtherlines z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_markdownLine_dot_uscore_hash_selFP6_hash_furtherlines e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.markdownLine._#selFP6#furtherlines" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.markdownLine._#selFP6#furtherlines"
    (showCons x1))

d_C_dropFirst :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_dropFirst x1 cd cs = d_C__case_57 x1 (Curry_Prelude.d_C_null x1 cd cs) cd cs

d_C_tryMDHeader :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C_tryMDHeader x1 x2 cd cs = let x3 = Curry_Prelude.d_C_apply
                                    (Curry_Prelude.d_C_break
                                    (Curry_Prelude.d_C_flip (acceptCs id
                                    Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                    (Curry_Prelude.C_Char ' '#)) cd cs) x1 cd cs
                                  x4 = d_OP_tryMDHeader_dot_uscore_hash_selFP8_hash_sharps
                                    x3 cd cs
                                  x5 = d_OP_tryMDHeader_dot_uscore_hash_selFP9_hash_htxt
                                    x3 cd cs
                                  x6 = Curry_Prelude.d_C_length x4 cd cs
  in d_C__case_56 x6 x5 x2 x1 (Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_C_null x5 cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) x6 cd cs) (Curry_Prelude.C_Int (6)) cd cs) cd cs) cd cs

d_OP_tryMDHeader_dot_uscore_hash_selFP8_hash_sharps :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_tryMDHeader_dot_uscore_hash_selFP8_hash_sharps x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tryMDHeader_dot_uscore_hash_selFP8_hash_sharps l cd cs)
    (d_OP_tryMDHeader_dot_uscore_hash_selFP8_hash_sharps r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tryMDHeader_dot_uscore_hash_selFP8_hash_sharps z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_tryMDHeader_dot_uscore_hash_selFP8_hash_sharps e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.tryMDHeader._#selFP8#sharps" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.tryMDHeader._#selFP8#sharps"
    (showCons x1))

d_OP_tryMDHeader_dot_uscore_hash_selFP9_hash_htxt :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_tryMDHeader_dot_uscore_hash_selFP9_hash_htxt x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tryMDHeader_dot_uscore_hash_selFP9_hash_htxt l cd cs)
    (d_OP_tryMDHeader_dot_uscore_hash_selFP9_hash_htxt r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tryMDHeader_dot_uscore_hash_selFP9_hash_htxt z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_tryMDHeader_dot_uscore_hash_selFP9_hash_htxt e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.tryMDHeader._#selFP9#htxt" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.tryMDHeader._#selFP9#htxt" (showCons
    x1))

d_C_isHRule :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isHRule x1 cd cs = Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_OP_amp_amp
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_all
  d_OP_isHRule_dot_uscore_hash_lambda4 cd cs) x1 cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) (Curry_Prelude.d_C_length (Curry_Prelude.d_C_filter
  (Curry_Prelude.d_C_flip (acceptCs id
  Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.C_Char '-'#)) x1 cd cs) cd cs) cd cs) (Curry_Prelude.C_Int (3))
  cd cs) cd cs) (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_all d_OP_isHRule_dot_uscore_hash_lambda5 cd cs) x1 cd cs)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) (Curry_Prelude.d_C_length (Curry_Prelude.d_C_filter
  (Curry_Prelude.d_C_flip (acceptCs id
  Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.C_Char '*'#)) x1 cd cs) cd cs) cd cs) (Curry_Prelude.C_Int (3))
  cd cs) cd cs) cd cs

d_OP_isHRule_dot_uscore_hash_lambda4 :: Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_isHRule_dot_uscore_hash_lambda4 x1 cd cs = Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_C_isSpace x1 cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.C_Char '-'#) cd cs) cd cs

d_OP_isHRule_dot_uscore_hash_lambda5 :: Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_isHRule_dot_uscore_hash_lambda5 x1 cd cs = Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_C_isSpace x1 cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.C_Char '*'#) cd cs) cd cs

d_C_isUnorderedItemLine :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Int
d_C_isUnorderedItemLine x1 cd cs = let x2 = Curry_Prelude.d_C_span
                                         (Curry_Prelude.d_C_flip (acceptCs id
                                         Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                         (Curry_Prelude.C_Char ' '#)) x1 cd cs
                                       x3 = d_OP_isUnorderedItemLine_dot_uscore_hash_selFP11_hash_blanks
                                         x2 cd cs
                                       x4 = d_OP_isUnorderedItemLine_dot_uscore_hash_selFP12_hash_nonblanks
                                         x2 cd cs
  in d_C__case_55 x4 x3 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (2)) x4 cd cs) cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "* ")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "- ")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "+ ")
  Curry_Prelude.OP_List))) cd cs) cd cs

d_OP_isUnorderedItemLine_dot_uscore_hash_selFP11_hash_blanks :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_isUnorderedItemLine_dot_uscore_hash_selFP11_hash_blanks x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_isUnorderedItemLine_dot_uscore_hash_selFP11_hash_blanks l cd cs)
    (d_OP_isUnorderedItemLine_dot_uscore_hash_selFP11_hash_blanks r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_isUnorderedItemLine_dot_uscore_hash_selFP11_hash_blanks z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_isUnorderedItemLine_dot_uscore_hash_selFP11_hash_blanks e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.isUnorderedItemLine._#selFP11#blanks" [show x1] info)
  _ -> failCons cd (consFail
    "Text.Markdown.isUnorderedItemLine._#selFP11#blanks" (showCons x1))

d_OP_isUnorderedItemLine_dot_uscore_hash_selFP12_hash_nonblanks :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_isUnorderedItemLine_dot_uscore_hash_selFP12_hash_nonblanks x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_isUnorderedItemLine_dot_uscore_hash_selFP12_hash_nonblanks l cd cs)
    (d_OP_isUnorderedItemLine_dot_uscore_hash_selFP12_hash_nonblanks r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_isUnorderedItemLine_dot_uscore_hash_selFP12_hash_nonblanks z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_isUnorderedItemLine_dot_uscore_hash_selFP12_hash_nonblanks e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.isUnorderedItemLine._#selFP12#nonblanks" [show x1] info)
  _ -> failCons cd (consFail
    "Text.Markdown.isUnorderedItemLine._#selFP12#nonblanks" (showCons x1))

d_C_isNumberedItemLine :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Int
d_C_isNumberedItemLine x1 cd cs = let x2 = Curry_Prelude.d_C_span
                                        (Curry_Prelude.d_C_flip (acceptCs id
                                        Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                        (Curry_Prelude.C_Char ' '#)) x1 cd cs
                                      x3 = d_OP_isNumberedItemLine_dot_uscore_hash_selFP20_hash_blanks
                                        x2 cd cs
                                      x4 = d_OP_isNumberedItemLine_dot_uscore_hash_selFP21_hash_nonblanks
                                        x2 cd cs
                                      x5 = Curry_Prelude.d_C_length x3 cd cs
  in d_OP_isNumberedItemLine_dot_checkNumber_dot_90 x5 x4 cd cs

d_OP_isNumberedItemLine_dot_checkNumber_dot_90 :: Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_OP_isNumberedItemLine_dot_checkNumber_dot_90 x1 x2 cd cs =
  let x3 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_break
        (Curry_Prelude.d_C_flip (acceptCs id
        Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
        (Curry_Prelude.C_Char ' '#)) cd cs) x2 cd cs
      x4 = d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP17_hash_ns
        x3 cd cs
      x5 = d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP18_hash_brt
        x3 cd cs
      x6 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_break
        (Curry_Prelude.d_C_flip
        (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
        cd cs) (Curry_Prelude.C_Char ' '#)) cd cs) x5 cd cs
      x7 = d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP15_hash_blanks
        x6 cd cs
      x8 = d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP16_hash_rtxt
        x6 cd cs
      x9 = Curry_Prelude.d_C_length x4 cd cs
  in d_C__case_54 x8 x7 x9 x4 x1 (Curry_Prelude.d_OP_amp_amp
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) x9 cd cs) (Curry_Prelude.C_Int (0)) cd cs) (Curry_Prelude.d_OP_amp_amp
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_all Curry_Prelude.d_C_isDigit cd
  cs) (Curry_Prelude.d_C_take
  (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  x9 (Curry_Prelude.C_Int (1)) cd cs) x4 cd cs) cd cs)
  (Curry_Prelude.d_OP_amp_amp
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  (Curry_Prelude.d_OP_bang_bang x4
  (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  x9 (Curry_Prelude.C_Int (1)) cd cs) cd cs) (Curry_Prelude.C_Char '.'#) cd cs)
  (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_not (Curry_Prelude.d_C_null x7
  cd cs) cd cs) (Curry_Prelude.d_C_not (Curry_Prelude.d_C_null x8 cd cs) cd cs)
  cd cs) cd cs) cd cs) cd cs) cd cs

d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP17_hash_ns :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP17_hash_ns x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP17_hash_ns
    l cd cs)
    (d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP17_hash_ns
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP17_hash_ns
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP17_hash_ns
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.isNumberedItemLine.checkNumber.90._#selFP17#ns" [show x1]
    info)
  _ -> failCons cd (consFail
    "Text.Markdown.isNumberedItemLine.checkNumber.90._#selFP17#ns" (showCons
    x1))

d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP18_hash_brt :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP18_hash_brt x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP18_hash_brt
    l cd cs)
    (d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP18_hash_brt
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP18_hash_brt
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP18_hash_brt
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.isNumberedItemLine.checkNumber.90._#selFP18#brt" [show x1]
    info)
  _ -> failCons cd (consFail
    "Text.Markdown.isNumberedItemLine.checkNumber.90._#selFP18#brt" (showCons
    x1))

d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP15_hash_blanks :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP15_hash_blanks x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP15_hash_blanks
    l cd cs)
    (d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP15_hash_blanks
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP15_hash_blanks
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP15_hash_blanks
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.isNumberedItemLine.checkNumber.90._#selFP15#blanks" [show x1]
    info)
  _ -> failCons cd (consFail
    "Text.Markdown.isNumberedItemLine.checkNumber.90._#selFP15#blanks" (showCons
    x1))

d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP16_hash_rtxt :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP16_hash_rtxt x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP16_hash_rtxt
    l cd cs)
    (d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP16_hash_rtxt
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP16_hash_rtxt
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_isNumberedItemLine_dot_checkNumber_dot_90_dot_uscore_hash_selFP16_hash_rtxt
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.isNumberedItemLine.checkNumber.90._#selFP16#rtxt" [show x1]
    info)
  _ -> failCons cd (consFail
    "Text.Markdown.isNumberedItemLine.checkNumber.90._#selFP16#rtxt" (showCons
    x1))

d_OP_isNumberedItemLine_dot_uscore_hash_selFP20_hash_blanks :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_isNumberedItemLine_dot_uscore_hash_selFP20_hash_blanks x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_isNumberedItemLine_dot_uscore_hash_selFP20_hash_blanks l cd cs)
    (d_OP_isNumberedItemLine_dot_uscore_hash_selFP20_hash_blanks r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_isNumberedItemLine_dot_uscore_hash_selFP20_hash_blanks z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_isNumberedItemLine_dot_uscore_hash_selFP20_hash_blanks e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.isNumberedItemLine._#selFP20#blanks" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.isNumberedItemLine._#selFP20#blanks"
    (showCons x1))

d_OP_isNumberedItemLine_dot_uscore_hash_selFP21_hash_nonblanks :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_isNumberedItemLine_dot_uscore_hash_selFP21_hash_nonblanks x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_isNumberedItemLine_dot_uscore_hash_selFP21_hash_nonblanks l cd cs)
    (d_OP_isNumberedItemLine_dot_uscore_hash_selFP21_hash_nonblanks r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_isNumberedItemLine_dot_uscore_hash_selFP21_hash_nonblanks z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_isNumberedItemLine_dot_uscore_hash_selFP21_hash_nonblanks e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.isNumberedItemLine._#selFP21#nonblanks" [show x1] info)
  _ -> failCons cd (consFail
    "Text.Markdown.isNumberedItemLine._#selFP21#nonblanks" (showCons x1))

d_C_isCodeLine :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Int
d_C_isCodeLine x1 cd cs = let x2 = Curry_Prelude.d_C_span
                                (Curry_Prelude.d_C_flip (acceptCs id
                                Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                (Curry_Prelude.C_Char ' '#)) x1 cd cs
                              x3 = d_OP_isCodeLine_dot_uscore_hash_selFP23_hash_blanks
                                x2 cd cs
                              x4 = d_OP_isCodeLine_dot_uscore_hash_selFP24_hash_nonblanks
                                x2 cd cs
                              x5 = Curry_Prelude.d_C_length x3 cd cs
  in d_C__case_53 x5 x4 (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_not
  (Curry_Prelude.d_C_null x4 cd cs) cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) x5 cd cs) (Curry_Prelude.C_Int (4)) cd cs) cd cs) cd cs

d_OP_isCodeLine_dot_uscore_hash_selFP23_hash_blanks :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_isCodeLine_dot_uscore_hash_selFP23_hash_blanks x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_isCodeLine_dot_uscore_hash_selFP23_hash_blanks l cd cs)
    (d_OP_isCodeLine_dot_uscore_hash_selFP23_hash_blanks r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_isCodeLine_dot_uscore_hash_selFP23_hash_blanks z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_isCodeLine_dot_uscore_hash_selFP23_hash_blanks e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.isCodeLine._#selFP23#blanks" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.isCodeLine._#selFP23#blanks"
    (showCons x1))

d_OP_isCodeLine_dot_uscore_hash_selFP24_hash_nonblanks :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_isCodeLine_dot_uscore_hash_selFP24_hash_nonblanks x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_isCodeLine_dot_uscore_hash_selFP24_hash_nonblanks l cd cs)
    (d_OP_isCodeLine_dot_uscore_hash_selFP24_hash_nonblanks r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_isCodeLine_dot_uscore_hash_selFP24_hash_nonblanks z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_isCodeLine_dot_uscore_hash_selFP24_hash_nonblanks e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.isCodeLine._#selFP24#nonblanks" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.isCodeLine._#selFP24#nonblanks"
    (showCons x1))

d_C_markdownPar :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C_markdownPar x1 x2 cd cs = let x3 = Curry_Prelude.d_C_apply
                                    (Curry_Prelude.d_C_break
                                    (Curry_Prelude.d_C_flip (acceptCs id
                                    Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                    (Curry_Prelude.C_Char '\n'#)) cd cs) x2 cd
                                    cs
                                  x4 = d_OP_markdownPar_dot_uscore_hash_selFP26_hash_fstline
                                    x3 cd cs
                                  x5 = d_OP_markdownPar_dot_uscore_hash_selFP27_hash_remtxt
                                    x3 cd cs
                                  x6 = d_C_isNumberedItemLine x4 cd cs
                                  x7 = d_C_isUnorderedItemLine x4 cd cs
  in d_C__case_52 x6 x7 x2 x5 x4 x1 (Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_C_null x2 cd cs) (Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  (Curry_Prelude.d_C_head x2 cd cs) cd cs) (Curry_Prelude.toCurryString "\n") cd
  cs) (Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) x7 cd cs) (Curry_Prelude.C_Int (0)) cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) x6 cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs) cd cs) cd cs) cd cs

d_OP_markdownPar_dot_uscore_hash_selFP26_hash_fstline :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_markdownPar_dot_uscore_hash_selFP26_hash_fstline x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_markdownPar_dot_uscore_hash_selFP26_hash_fstline l cd cs)
    (d_OP_markdownPar_dot_uscore_hash_selFP26_hash_fstline r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_markdownPar_dot_uscore_hash_selFP26_hash_fstline z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_markdownPar_dot_uscore_hash_selFP26_hash_fstline e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.markdownPar._#selFP26#fstline" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.markdownPar._#selFP26#fstline"
    (showCons x1))

d_OP_markdownPar_dot_uscore_hash_selFP27_hash_remtxt :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_markdownPar_dot_uscore_hash_selFP27_hash_remtxt x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_markdownPar_dot_uscore_hash_selFP27_hash_remtxt l cd cs)
    (d_OP_markdownPar_dot_uscore_hash_selFP27_hash_remtxt r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_markdownPar_dot_uscore_hash_selFP27_hash_remtxt z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_markdownPar_dot_uscore_hash_selFP27_hash_remtxt e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.markdownPar._#selFP27#remtxt" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.markdownPar._#selFP27#remtxt"
    (showCons x1))

d_C_markdownQuote :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C_markdownQuote x1 x2 cd cs = let x3 = d_C__case_47 x2
                                      (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
                                      Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
                                      (Curry_Prelude.d_C_take
                                      (Curry_Prelude.C_Int (2)) x2 cd cs)
                                      (Curry_Prelude.toCurryString ">\n") cd cs)
                                      cd cs
  in d_C__case_49 x3 x1
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (2)) x3 cd cs)
  (Curry_Prelude.toCurryString "> ") cd cs) cd cs

d_OP_markdownQuote_dot_uscore_hash_selFP29_hash_fstline :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_markdownQuote_dot_uscore_hash_selFP29_hash_fstline x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_markdownQuote_dot_uscore_hash_selFP29_hash_fstline l cd cs)
    (d_OP_markdownQuote_dot_uscore_hash_selFP29_hash_fstline r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_markdownQuote_dot_uscore_hash_selFP29_hash_fstline z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_markdownQuote_dot_uscore_hash_selFP29_hash_fstline e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.markdownQuote._#selFP29#fstline" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.markdownQuote._#selFP29#fstline"
    (showCons x1))

d_OP_markdownQuote_dot_uscore_hash_selFP30_hash_remtxt :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_markdownQuote_dot_uscore_hash_selFP30_hash_remtxt x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_markdownQuote_dot_uscore_hash_selFP30_hash_remtxt l cd cs)
    (d_OP_markdownQuote_dot_uscore_hash_selFP30_hash_remtxt r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_markdownQuote_dot_uscore_hash_selFP30_hash_remtxt z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_markdownQuote_dot_uscore_hash_selFP30_hash_remtxt e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.markdownQuote._#selFP30#remtxt" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.markdownQuote._#selFP30#remtxt"
    (showCons x1))

d_C_markdownCodeBlock :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_SourceMDElem
d_C_markdownCodeBlock x1 x2 x3 cd cs = d_C__case_46 x3 x1 x2
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_all (Curry_Prelude.d_C_flip
  (acceptCs id
  Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.C_Char ' '#)) cd cs) (Curry_Prelude.d_C_take x1 x3 cd cs) cd
  cs) cd cs

d_OP_markdownCodeBlock_dot_uscore_hash_selFP32_hash_fstline :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_markdownCodeBlock_dot_uscore_hash_selFP32_hash_fstline x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_markdownCodeBlock_dot_uscore_hash_selFP32_hash_fstline l cd cs)
    (d_OP_markdownCodeBlock_dot_uscore_hash_selFP32_hash_fstline r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_markdownCodeBlock_dot_uscore_hash_selFP32_hash_fstline z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_markdownCodeBlock_dot_uscore_hash_selFP32_hash_fstline e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.markdownCodeBlock._#selFP32#fstline" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.markdownCodeBlock._#selFP32#fstline"
    (showCons x1))

d_OP_markdownCodeBlock_dot_uscore_hash_selFP33_hash_remtxt :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_markdownCodeBlock_dot_uscore_hash_selFP33_hash_remtxt x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_markdownCodeBlock_dot_uscore_hash_selFP33_hash_remtxt l cd cs)
    (d_OP_markdownCodeBlock_dot_uscore_hash_selFP33_hash_remtxt r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_markdownCodeBlock_dot_uscore_hash_selFP33_hash_remtxt z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_markdownCodeBlock_dot_uscore_hash_selFP33_hash_remtxt e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.markdownCodeBlock._#selFP33#remtxt" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.markdownCodeBlock._#selFP33#remtxt"
    (showCons x1))

d_C_markdownItem :: (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> C_SourceMDElem) -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_SourceMDElem
d_C_markdownItem x1 x2 x3 x4 cd cs = d_C__case_44 x2 x4 x3 x1
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  (Curry_Prelude.d_C_take x2 x4 cd cs) (Curry_Prelude.d_C_take x2
  (Curry_Prelude.d_C_repeat (Curry_Prelude.C_Char ' '#) cd cs) cd cs) cd cs) cd
  cs

nd_C_markdownItem :: Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  C_SourceMDElem -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List C_SourceMDElem
nd_C_markdownItem x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_44 x2 x4 x3 x1
  (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.d_C_take x2 x4 cd cs) (Curry_Prelude.d_C_take x2
  (Curry_Prelude.d_C_repeat (Curry_Prelude.C_Char ' '#) cd cs) cd cs) s0 cd cs)
  s1 cd cs))

d_OP_markdownItem_dot_uscore_hash_selFP35_hash_fstline :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_markdownItem_dot_uscore_hash_selFP35_hash_fstline x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_markdownItem_dot_uscore_hash_selFP35_hash_fstline l cd cs)
    (d_OP_markdownItem_dot_uscore_hash_selFP35_hash_fstline r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_markdownItem_dot_uscore_hash_selFP35_hash_fstline z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_markdownItem_dot_uscore_hash_selFP35_hash_fstline e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.markdownItem._#selFP35#fstline" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.markdownItem._#selFP35#fstline"
    (showCons x1))

d_OP_markdownItem_dot_uscore_hash_selFP36_hash_remtxt :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_markdownItem_dot_uscore_hash_selFP36_hash_remtxt x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_markdownItem_dot_uscore_hash_selFP36_hash_remtxt l cd cs)
    (d_OP_markdownItem_dot_uscore_hash_selFP36_hash_remtxt r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_markdownItem_dot_uscore_hash_selFP36_hash_remtxt z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_markdownItem_dot_uscore_hash_selFP36_hash_remtxt e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.markdownItem._#selFP36#remtxt" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.markdownItem._#selFP36#remtxt"
    (showCons x1))

d_OP_markdownItem_dot_uscore_hash_selFP38_hash_fstline :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_markdownItem_dot_uscore_hash_selFP38_hash_fstline x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_markdownItem_dot_uscore_hash_selFP38_hash_fstline l cd cs)
    (d_OP_markdownItem_dot_uscore_hash_selFP38_hash_fstline r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_markdownItem_dot_uscore_hash_selFP38_hash_fstline z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_markdownItem_dot_uscore_hash_selFP38_hash_fstline e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.markdownItem._#selFP38#fstline" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.markdownItem._#selFP38#fstline"
    (showCons x1))

d_OP_markdownItem_dot_uscore_hash_selFP39_hash_remtxt :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_markdownItem_dot_uscore_hash_selFP39_hash_remtxt x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_markdownItem_dot_uscore_hash_selFP39_hash_remtxt l cd cs)
    (d_OP_markdownItem_dot_uscore_hash_selFP39_hash_remtxt r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_markdownItem_dot_uscore_hash_selFP39_hash_remtxt z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_markdownItem_dot_uscore_hash_selFP39_hash_remtxt e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.markdownItem._#selFP39#remtxt" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.markdownItem._#selFP39#remtxt"
    (showCons x1))

d_C_removeEscapes :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_removeEscapes x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_40 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '\\'#) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_removeEscapes l cd cs)
    (d_C_removeEscapes r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_removeEscapes z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_removeEscapes e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.Markdown.removeEscapes" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.removeEscapes" (showCons x1))

d_C_markdownEscapeChars :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_markdownEscapeChars cd cs = Curry_Prelude.toCurryString
  "\\`*_{}[]()<>#+-. !"

d_C_outsideMarkdownElem :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C_outsideMarkdownElem x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> d_C_addPrevious x1 Curry_Prelude.OP_List cd cs
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_37 x3 x4 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.C_Char '\\'#) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_outsideMarkdownElem x1
    l cd cs) (d_C_outsideMarkdownElem x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_outsideMarkdownElem x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_C_outsideMarkdownElem x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.Markdown.outsideMarkdownElem" [show x1, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown.outsideMarkdownElem" (showCons x2))

d_OP_outsideMarkdownElem_dot_uscore_hash_selFP41_hash_ticks :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_outsideMarkdownElem_dot_uscore_hash_selFP41_hash_ticks x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_outsideMarkdownElem_dot_uscore_hash_selFP41_hash_ticks l cd cs)
    (d_OP_outsideMarkdownElem_dot_uscore_hash_selFP41_hash_ticks r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_outsideMarkdownElem_dot_uscore_hash_selFP41_hash_ticks z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_outsideMarkdownElem_dot_uscore_hash_selFP41_hash_ticks e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.outsideMarkdownElem._#selFP41#ticks" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.outsideMarkdownElem._#selFP41#ticks"
    (showCons x1))

d_OP_outsideMarkdownElem_dot_uscore_hash_selFP42_hash_cs_tick :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_outsideMarkdownElem_dot_uscore_hash_selFP42_hash_cs_tick x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_outsideMarkdownElem_dot_uscore_hash_selFP42_hash_cs_tick l cd cs)
    (d_OP_outsideMarkdownElem_dot_uscore_hash_selFP42_hash_cs_tick r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_outsideMarkdownElem_dot_uscore_hash_selFP42_hash_cs_tick z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_outsideMarkdownElem_dot_uscore_hash_selFP42_hash_cs_tick e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.outsideMarkdownElem._#selFP42#cs'" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.outsideMarkdownElem._#selFP42#cs'"
    (showCons x1))

d_C_addPrevious :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_SourceMDElem -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C_addPrevious x1 x2 cd cs = d_C__case_25 x1 x2 (Curry_Prelude.d_C_null x1 cd
  cs) cd cs

d_C_tryParseLink :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_SourceMDElem
d_C_tryParseLink x1 cd cs = let x2 = Curry_Prelude.d_C_apply
                                  (Curry_Prelude.d_C_break
                                  (Curry_Prelude.d_C_flip (acceptCs id
                                  Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                  (Curry_Prelude.C_Char ']'#)) cd cs) x1 cd cs
                                x3 = d_OP_tryParseLink_dot_uscore_hash_selFP47_hash_linktxt
                                  x2 cd cs
                                x4 = d_OP_tryParseLink_dot_uscore_hash_selFP48_hash_rtxt
                                  x2 cd cs
  in d_C__case_24 x4 x3 x1 (Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_C_null
  x4 cd cs) (Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_C_null
  (Curry_Prelude.d_C_tail x4 cd cs) cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  cd cs) (Curry_Prelude.d_OP_bang_bang x4 (Curry_Prelude.C_Int (1)) cd cs) cd
  cs) (Curry_Prelude.C_Char '('#) cd cs) cd cs) cd cs) cd cs

d_OP_tryParseLink_dot_uscore_hash_selFP47_hash_linktxt :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_tryParseLink_dot_uscore_hash_selFP47_hash_linktxt x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tryParseLink_dot_uscore_hash_selFP47_hash_linktxt l cd cs)
    (d_OP_tryParseLink_dot_uscore_hash_selFP47_hash_linktxt r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tryParseLink_dot_uscore_hash_selFP47_hash_linktxt z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_tryParseLink_dot_uscore_hash_selFP47_hash_linktxt e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.tryParseLink._#selFP47#linktxt" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.tryParseLink._#selFP47#linktxt"
    (showCons x1))

d_OP_tryParseLink_dot_uscore_hash_selFP48_hash_rtxt :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_tryParseLink_dot_uscore_hash_selFP48_hash_rtxt x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tryParseLink_dot_uscore_hash_selFP48_hash_rtxt l cd cs)
    (d_OP_tryParseLink_dot_uscore_hash_selFP48_hash_rtxt r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tryParseLink_dot_uscore_hash_selFP48_hash_rtxt z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_tryParseLink_dot_uscore_hash_selFP48_hash_rtxt e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.tryParseLink._#selFP48#rtxt" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.tryParseLink._#selFP48#rtxt"
    (showCons x1))

d_OP_tryParseLink_dot_uscore_hash_selFP45_hash_url :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_tryParseLink_dot_uscore_hash_selFP45_hash_url x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tryParseLink_dot_uscore_hash_selFP45_hash_url l cd cs)
    (d_OP_tryParseLink_dot_uscore_hash_selFP45_hash_url r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tryParseLink_dot_uscore_hash_selFP45_hash_url z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_tryParseLink_dot_uscore_hash_selFP45_hash_url e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.tryParseLink._#selFP45#url" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.tryParseLink._#selFP45#url"
    (showCons x1))

d_OP_tryParseLink_dot_uscore_hash_selFP46_hash_mtxt :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_tryParseLink_dot_uscore_hash_selFP46_hash_mtxt x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tryParseLink_dot_uscore_hash_selFP46_hash_mtxt l cd cs)
    (d_OP_tryParseLink_dot_uscore_hash_selFP46_hash_mtxt r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tryParseLink_dot_uscore_hash_selFP46_hash_mtxt z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_tryParseLink_dot_uscore_hash_selFP46_hash_mtxt e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.tryParseLink._#selFP46#mtxt" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.tryParseLink._#selFP46#mtxt"
    (showCons x1))

d_C_markdownHRef :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_SourceMDElem
d_C_markdownHRef x1 cd cs = let x2 = Curry_Prelude.d_C_apply
                                  (Curry_Prelude.d_C_break
                                  (Curry_Prelude.d_C_flip (acceptCs id
                                  Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                  (Curry_Prelude.C_Char '>'#)) cd cs) x1 cd cs
                                x3 = d_OP_markdownHRef_dot_uscore_hash_selFP50_hash_url
                                  x2 cd cs
                                x4 = d_OP_markdownHRef_dot_uscore_hash_selFP51_hash_rtxt
                                  x2 cd cs
  in d_C__case_22 x4 x3 x1 (Curry_Prelude.d_C_null x4 cd cs) cd cs

d_OP_markdownHRef_dot_uscore_hash_selFP50_hash_url :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_markdownHRef_dot_uscore_hash_selFP50_hash_url x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_markdownHRef_dot_uscore_hash_selFP50_hash_url l cd cs)
    (d_OP_markdownHRef_dot_uscore_hash_selFP50_hash_url r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_markdownHRef_dot_uscore_hash_selFP50_hash_url z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_markdownHRef_dot_uscore_hash_selFP50_hash_url e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.markdownHRef._#selFP50#url" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.markdownHRef._#selFP50#url"
    (showCons x1))

d_OP_markdownHRef_dot_uscore_hash_selFP51_hash_rtxt :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_markdownHRef_dot_uscore_hash_selFP51_hash_rtxt x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_markdownHRef_dot_uscore_hash_selFP51_hash_rtxt l cd cs)
    (d_OP_markdownHRef_dot_uscore_hash_selFP51_hash_rtxt r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_markdownHRef_dot_uscore_hash_selFP51_hash_rtxt z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_markdownHRef_dot_uscore_hash_selFP51_hash_rtxt e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Text.Markdown.markdownHRef._#selFP51#rtxt" [show x1] info)
  _ -> failCons cd (consFail "Text.Markdown.markdownHRef._#selFP51#rtxt"
    (showCons x1))

d_C_insideMarkdownElem :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_SourceMDElem
d_C_insideMarkdownElem x1 x2 x3 cd cs = d_C__case_21 x3 x1 x2
  (Data.Curry_List.d_C_isPrefixOf
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 x3 cd cs) cd cs

d_C_text2MDElem :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> C_SourceMDElem
d_C_text2MDElem x1 x2 cd cs = d_C__case_16 x1 x2 (Curry_Prelude.d_C_eqString x1
  (Curry_Prelude.toCurryString "**") cd cs) cd cs

d_C_mdDoc2html :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List C_MarkdownElem -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
d_C_mdDoc2html x1 cd cs = Curry_Prelude.d_C_map (d_C_mdElem2html x1)

nd_C_mdDoc2html :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  C_MarkdownElem) (Curry_Prelude.OP_List t0)
nd_C_mdDoc2html x1 s cd cs = wrapNX id (Curry_Prelude.nd_C_map (wrapNX id
  (nd_C_mdElem2html x1)))

d_C_mdtxt2html :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> t0
d_C_mdtxt2html x1 cd cs = Curry_Prelude.d_OP_dot (HTML.Curry_Base.d_C_htmlText
  x1 cd cs) (Curry_Prelude.d_OP_dot HTML.Curry_Base.d_C_htmlQuote
  d_C_removeEscapes cd cs) cd cs

nd_C_mdtxt2html :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0
nd_C_mdtxt2html x1 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_OP_dot
  (HTML.Curry_Base.nd_C_htmlText x1 s0 cd cs) (Curry_Prelude.nd_OP_dot (wrapDX
  id HTML.Curry_Base.d_C_htmlQuote) (wrapDX id d_C_removeEscapes) s1 cd cs) s2
  cd cs))))

d_C_mdElem2html :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> C_MarkdownElem -> Cover
  -> ConstStore -> t0
d_C_mdElem2html x1 x2 cd cs = case x2 of
  C_Text x3 -> Curry_Prelude.d_C_apply (d_C_mdtxt2html x1 cd cs) x3 cd cs
  C_Emph x4 -> Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_emphasize x1 cd cs)
    (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (d_C_mdtxt2html x1 cd cs) x4
    cd cs) Curry_Prelude.OP_List) cd cs
  C_Strong x5 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_htmlStruct x1 cd cs)
    (Curry_Prelude.toCurryString "strong") cd cs) Curry_Prelude.OP_List cd cs)
    (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (d_C_mdtxt2html x1 cd cs) x5
    cd cs) Curry_Prelude.OP_List) cd cs
  C_HRef x6 x7 -> d_C__case_10 x7 x6 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x6 x7 cd cs) cd cs
  C_Code x8 -> Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_code x1 cd cs)
    (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_htmlText x1 cd cs) (HTML.Curry_Base.d_C_htmlQuote x8 cd
    cs) cd cs) Curry_Prelude.OP_List) cd cs
  C_CodeBlock x9 -> HTML.Curry_Base.d_C_verbatim x1 x9 cd cs
  C_Quote x10 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_htmlStruct x1 cd cs)
    (Curry_Prelude.toCurryString "blockquote") cd cs) Curry_Prelude.OP_List cd
    cs) (Curry_Prelude.d_C_apply (d_C_mdDoc2html x1 cd cs) x10 cd cs) cd cs
  C_Par x11 -> Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_par x1 cd cs)
    (Curry_Prelude.d_C_apply (d_C_mdDoc2html x1 cd cs) x11 cd cs) cd cs
  C_UList x12 -> HTML.Curry_Base.d_C_ulist x1 (Curry_Prelude.d_C_map
    (d_C_mdDoc2htmlWithoutPar x1) x12 cd cs) cd cs
  C_OList x13 -> HTML.Curry_Base.d_C_olist x1 (Curry_Prelude.d_C_map
    (d_C_mdDoc2htmlWithoutPar x1) x13 cd cs) cd cs
  C_HRule -> HTML.Curry_Base.d_C_hrule x1 cd cs
  C_Header x14 x15 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_htmlStruct x1 cd cs)
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x14 cd cs)) cd cs) Curry_Prelude.OP_List cd cs)
    (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (d_C_mdtxt2html x1 cd cs)
    x15 cd cs) Curry_Prelude.OP_List) cd cs
  Choice_C_MarkdownElem d i l r -> narrow d i (d_C_mdElem2html x1 l cd cs)
    (d_C_mdElem2html x1 r cd cs)
  Choices_C_MarkdownElem d i xs -> narrows cs d i (\z -> d_C_mdElem2html x1 z cd
    cs) xs
  Guard_C_MarkdownElem d c e -> guardCons d c ((\x -> d_C_mdElem2html x1 e cd
    x) $! addCs c cs)
  Fail_C_MarkdownElem d info -> failCons d (traceFail
    "Text.Markdown.mdElem2html" [show x1, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown.mdElem2html" (showCons x2))

nd_C_mdElem2html :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> C_MarkdownElem -> IDSupply -> Cover -> ConstStore -> t0
nd_C_mdElem2html x1 x2 s cd cs = case x2 of
  C_Text x3 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_mdtxt2html x1 s0 cd cs)
    x3 s1 cd cs))
  C_Emph x4 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_emphasize x1 s0 cd cs) (Curry_Prelude.OP_Cons
    (let s2 = leftSupply s3
         s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (nd_C_mdtxt2html x1 s1 cd cs)
    x4 s2 cd cs)) Curry_Prelude.OP_List) s4 cd cs))))
  C_Strong x5 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s4 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s4 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
    (let s3 = leftSupply s4
         s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_htmlStruct x1 s0 cd cs) (Curry_Prelude.toCurryString
    "strong") s1 cd cs)) Curry_Prelude.OP_List s3 cd cs)) (Curry_Prelude.OP_Cons
    (let s6 = leftSupply s7
         s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (nd_C_mdtxt2html x1 s5 cd cs)
    x5 s6 cd cs)) Curry_Prelude.OP_List) s8 cd cs))))
  C_HRef x6 x7 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_10 x7 x6 x1
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x6 x7 s0 cd cs) s1 cd cs))
  C_Code x8 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_code x1 s0 cd cs) (Curry_Prelude.OP_Cons
    (let s2 = leftSupply s3
         s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_htmlText x1 s1 cd cs) (HTML.Curry_Base.d_C_htmlQuote
    x8 cd cs) s2 cd cs)) Curry_Prelude.OP_List) s4 cd cs))))
  C_CodeBlock x9 -> let s0 = s
    in s0 `seq` HTML.Curry_Base.nd_C_verbatim x1 x9 s0 cd cs
  C_Quote x10 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s4 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s4 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
    (let s3 = leftSupply s4
         s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_htmlStruct x1 s0 cd cs) (Curry_Prelude.toCurryString
    "blockquote") s1 cd cs)) Curry_Prelude.OP_List s3 cd cs))
    (let s6 = leftSupply s7
         s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (nd_C_mdDoc2html x1 s5 cd cs)
    x10 s6 cd cs)) s8 cd cs))))
  C_Par x11 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_par x1 s0 cd cs) (let s2 = leftSupply s3
                                                s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (nd_C_mdDoc2html x1 s1 cd cs)
    x11 s2 cd cs)) s4 cd cs))))
  C_UList x12 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` HTML.Curry_Base.nd_C_ulist x1 (Curry_Prelude.nd_C_map
    (wrapNX id (nd_C_mdDoc2htmlWithoutPar x1)) x12 s0 cd cs) s1 cd cs))
  C_OList x13 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` HTML.Curry_Base.nd_C_olist x1 (Curry_Prelude.nd_C_map
    (wrapNX id (nd_C_mdDoc2htmlWithoutPar x1)) x13 s0 cd cs) s1 cd cs))
  C_HRule -> let s0 = s in s0 `seq` HTML.Curry_Base.nd_C_hrule x1 s0 cd cs
  C_Header x14 x15 -> let s11 = s
    in s11 `seq` (let s10 = leftSupply s11
                      s12 = rightSupply s11
                      s6 = leftSupply s12
                      s9 = rightSupply s12
    in s10 `seq` (s12 `seq` (s6 `seq` (s9 `seq` Curry_Prelude.nd_C_apply
    (let s5 = leftSupply s6
         s3 = rightSupply s6
    in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_htmlStruct x1 s0 cd cs) (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.nd_C_apply (wrapDX id
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs)) x14 s1 cd cs)) s2 cd cs)))) Curry_Prelude.OP_List s5 cd cs))
    (Curry_Prelude.OP_Cons (let s8 = leftSupply s9
                                s7 = rightSupply s9
    in s8 `seq` (s7 `seq` Curry_Prelude.nd_C_apply (nd_C_mdtxt2html x1 s7 cd cs)
    x15 s8 cd cs)) Curry_Prelude.OP_List) s10 cd cs))))
  Choice_C_MarkdownElem d i l r -> narrow d i (nd_C_mdElem2html x1 l s cd cs)
    (nd_C_mdElem2html x1 r s cd cs)
  Choices_C_MarkdownElem d i xs -> narrows cs d i (\z -> nd_C_mdElem2html x1 z s
    cd cs) xs
  Guard_C_MarkdownElem d c e -> guardCons d c ((\x -> nd_C_mdElem2html x1 e s cd
    x) $! addCs c cs)
  Fail_C_MarkdownElem d info -> failCons d (traceFail
    "Text.Markdown.mdElem2html" [show x1, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown.mdElem2html" (showCons x2))

d_C_mdDoc2htmlWithoutPar :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.OP_List
  C_MarkdownElem -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_mdDoc2htmlWithoutPar x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> let x5 = d_C__case_7 x1 x3 x4 cd cs
    in d_C__case_9 x5 x4 x1 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_mdDoc2htmlWithoutPar
    x1 l cd cs) (d_C_mdDoc2htmlWithoutPar x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_mdDoc2htmlWithoutPar x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_C_mdDoc2htmlWithoutPar x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.Markdown.mdDoc2htmlWithoutPar" [show x1, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown.mdDoc2htmlWithoutPar" (showCons x2))

nd_C_mdDoc2htmlWithoutPar :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List C_MarkdownElem -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C_mdDoc2htmlWithoutPar x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` (let x5 = nd_C__case_7 x1 x3 x4 s0 cd cs
    in nd_C__case_9 x5 x4 x1 x3 s1 cd cs)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_mdDoc2htmlWithoutPar
    x1 l s cd cs) (nd_C_mdDoc2htmlWithoutPar x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_C_mdDoc2htmlWithoutPar x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    nd_C_mdDoc2htmlWithoutPar x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.Markdown.mdDoc2htmlWithoutPar" [show x1, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown.mdDoc2htmlWithoutPar" (showCons x2))

d_C_markdownText2HTML :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C_markdownText2HTML x1 cd cs = Curry_Prelude.d_OP_dot (d_C_mdDoc2html x1 cd
  cs) (d_C_fromMarkdownText cd cs) cd cs

nd_C_markdownText2HTML :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List t0)
nd_C_markdownText2HTML x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (nd_C_mdDoc2html x1 s0 cd cs)
  (wrapDX id (d_C_fromMarkdownText cd cs)) s1 cd cs))

d_C_markdownText2CompleteHTML :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_markdownText2CompleteHTML x1 x2 cd cs = HTML.Curry_Base.d_C_showHtmlPage
  (HTML.Curry_Base.d_C_page x1 (Curry_Prelude.d_C_apply (d_C_markdownText2HTML
  HTML.Curry_Base.d_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_BaseHtml_hash
  cd cs) x2 cd cs) cd cs) cd cs

d_C_mdDoc2latex :: (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_MarkdownElem -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_mdDoc2latex x1 cd cs = Curry_Prelude.d_C_concatMap (d_C_mdElem2latex x1) cd
  cs

nd_C_mdDoc2latex :: Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List C_MarkdownElem)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C_mdDoc2latex x1 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_C_concatMap (wrapNX id (nd_C_mdElem2latex x1)) s0
  cd cs

d_C_mdElem2latex :: (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_MarkdownElem
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_mdElem2latex x1 x2 cd cs = case x2 of
  C_Text x3 -> Curry_Prelude.d_C_apply x1 x3 cd cs
  C_Emph x4 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\emph{") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply x1 x4 cd
    cs) (Curry_Prelude.toCurryString "}") cd cs) cd cs
  C_Strong x5 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\textbf{") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply x1 x5 cd
    cs) (Curry_Prelude.toCurryString "}") cd cs) cd cs
  C_HRef x6 x7 -> d_C__case_6 x7 x6 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x6 x7 cd cs) cd cs
  C_Code x8 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\texttt{") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply x1
    (HTML.Curry_Base.d_C_htmlQuote x8 cd cs) cd cs) (Curry_Prelude.toCurryString
    "}") cd cs) cd cs
  C_CodeBlock x9 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\begin{verbatim}\n") (Curry_Prelude.d_OP_plus_plus x9
    (Curry_Prelude.toCurryString "\n\\end{verbatim}\n") cd cs) cd cs
  C_Quote x10 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\begin{quote}\n") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (d_C_mdDoc2latex x1 cd cs) x10 cd cs) (Curry_Prelude.toCurryString
    "\\end{quote}\n") cd cs) cd cs
  C_Par x11 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (d_C_mdDoc2latex x1 cd cs) x11 cd cs) (Curry_Prelude.toCurryString "\n\n")
    cd cs
  C_UList x12 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\begin{itemize}") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_concatMap (d_OP_mdElem2latex_dot_uscore_hash_lambda11 x1)
    cd cs) x12 cd cs) (Curry_Prelude.toCurryString "\\end{itemize}\n") cd cs) cd
    cs
  C_OList x13 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\begin{enumerate}") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_concatMap (d_OP_mdElem2latex_dot_uscore_hash_lambda12 x1)
    cd cs) x13 cd cs) (Curry_Prelude.toCurryString "\\end{enumerate}\n") cd cs)
    cd cs
  C_HRule -> Curry_Prelude.toCurryString
    "\\begin{center}\\rule{3in}{0.4pt}\\end{center}\n\n"
  C_Header x14 x15 -> d_C__case_5 x14 x15 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x14 (Curry_Prelude.C_Int (1)) cd cs) cd cs
  Choice_C_MarkdownElem d i l r -> narrow d i (d_C_mdElem2latex x1 l cd cs)
    (d_C_mdElem2latex x1 r cd cs)
  Choices_C_MarkdownElem d i xs -> narrows cs d i (\z -> d_C_mdElem2latex x1 z
    cd cs) xs
  Guard_C_MarkdownElem d c e -> guardCons d c ((\x -> d_C_mdElem2latex x1 e cd
    x) $! addCs c cs)
  Fail_C_MarkdownElem d info -> failCons d (traceFail
    "Text.Markdown.mdElem2latex" [show x1, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown.mdElem2latex" (showCons x2))

nd_C_mdElem2latex :: Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_MarkdownElem -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C_mdElem2latex x1 x2 s cd cs = case x2 of
  C_Text x3 -> let s0 = s in s0 `seq` Curry_Prelude.nd_C_apply x1 x3 s0 cd cs
  C_Emph x4 -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\emph{") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_apply x1 x4 s0
    cd cs) (Curry_Prelude.toCurryString "}") cd cs) cd cs
  C_Strong x5 -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\textbf{") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_apply x1 x5
    s0 cd cs) (Curry_Prelude.toCurryString "}") cd cs) cd cs
  C_HRef x6 x7 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_6 x7 x6 x1
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x6 x7 s0 cd cs) s1 cd cs))
  C_Code x8 -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\texttt{") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_apply x1
    (HTML.Curry_Base.d_C_htmlQuote x8 cd cs) s0 cd cs)
    (Curry_Prelude.toCurryString "}") cd cs) cd cs
  C_CodeBlock x9 -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\begin{verbatim}\n") (Curry_Prelude.d_OP_plus_plus x9
    (Curry_Prelude.toCurryString "\n\\end{verbatim}\n") cd cs) cd cs
  C_Quote x10 -> let s2 = s
    in s2 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\begin{quote}\n") (Curry_Prelude.d_OP_plus_plus (let s1 = leftSupply s2
                                                           s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_mdDoc2latex x1 s0 cd
    cs) x10 s1 cd cs)) (Curry_Prelude.toCurryString "\\end{quote}\n") cd cs) cd
    cs
  C_Par x11 -> let s2 = s
    in s2 `seq` Curry_Prelude.d_OP_plus_plus (let s1 = leftSupply s2
                                                  s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_mdDoc2latex x1 s0 cd
    cs) x11 s1 cd cs)) (Curry_Prelude.toCurryString "\n\n") cd cs
  C_UList x12 -> let s2 = s
    in s2 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\begin{itemize}") (Curry_Prelude.d_OP_plus_plus (let s1 = leftSupply s2
                                                           s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_concatMap
    (wrapNX id (nd_OP_mdElem2latex_dot_uscore_hash_lambda11 x1)) s0 cd cs) x12
    s1 cd cs)) (Curry_Prelude.toCurryString "\\end{itemize}\n") cd cs) cd cs
  C_OList x13 -> let s2 = s
    in s2 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\begin{enumerate}") (Curry_Prelude.d_OP_plus_plus (let s1 = leftSupply s2
                                                             s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_concatMap
    (wrapNX id (nd_OP_mdElem2latex_dot_uscore_hash_lambda12 x1)) s0 cd cs) x13
    s1 cd cs)) (Curry_Prelude.toCurryString "\\end{enumerate}\n") cd cs) cd cs
  C_HRule -> Curry_Prelude.toCurryString
    "\\begin{center}\\rule{3in}{0.4pt}\\end{center}\n\n"
  C_Header x14 x15 -> let s0 = s
    in s0 `seq` nd_C__case_5 x14 x15 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x14 (Curry_Prelude.C_Int (1)) cd cs) s0 cd cs
  Choice_C_MarkdownElem d i l r -> narrow d i (nd_C_mdElem2latex x1 l s cd cs)
    (nd_C_mdElem2latex x1 r s cd cs)
  Choices_C_MarkdownElem d i xs -> narrows cs d i (\z -> nd_C_mdElem2latex x1 z
    s cd cs) xs
  Guard_C_MarkdownElem d c e -> guardCons d c ((\x -> nd_C_mdElem2latex x1 e s
    cd x) $! addCs c cs)
  Fail_C_MarkdownElem d info -> failCons d (traceFail
    "Text.Markdown.mdElem2latex" [show x1, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown.mdElem2latex" (showCons x2))

d_OP_mdElem2latex_dot_uscore_hash_lambda11 :: (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List C_MarkdownElem -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_mdElem2latex_dot_uscore_hash_lambda11 x1 x2 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\n\\item\n")
  (Curry_Prelude.d_C_apply (d_C_mdDoc2latex x1 cd cs) x2 cd cs) cd cs

nd_OP_mdElem2latex_dot_uscore_hash_lambda11 :: Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List C_MarkdownElem -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_OP_mdElem2latex_dot_uscore_hash_lambda11 x1 x2 s cd cs = let s2 = s
  in s2 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "\n\\item\n") (let s1 = leftSupply s2
                     s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_mdDoc2latex x1 s0 cd cs)
  x2 s1 cd cs)) cd cs

d_OP_mdElem2latex_dot_uscore_hash_lambda12 :: (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List C_MarkdownElem -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_mdElem2latex_dot_uscore_hash_lambda12 x1 x2 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\n\\item\n")
  (Curry_Prelude.d_C_apply (d_C_mdDoc2latex x1 cd cs) x2 cd cs) cd cs

nd_OP_mdElem2latex_dot_uscore_hash_lambda12 :: Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List C_MarkdownElem -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_OP_mdElem2latex_dot_uscore_hash_lambda12 x1 x2 s cd cs = let s2 = s
  in s2 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "\n\\item\n") (let s1 = leftSupply s2
                     s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_mdDoc2latex x1 s0 cd cs)
  x2 s1 cd cs)) cd cs

d_C_text2latex :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_text2latex cd cs = Curry_Prelude.d_OP_dot HTML.Curry_LaTeX.d_C_showLatexExps
  (Curry_Prelude.d_OP_dot d_OP_text2latex_dot_uscore_hash_lambda14
  d_C_removeEscapes cd cs) cd cs

d_OP_text2latex_dot_uscore_hash_lambda14 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  HTML.Curry_Base.C_BaseHtml
d_OP_text2latex_dot_uscore_hash_lambda14 x1 cd cs = Curry_Prelude.OP_Cons
  (HTML.Curry_Base.d_C_htxt
  HTML.Curry_Base.d_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_BaseHtml_hash
  x1 cd cs) Curry_Prelude.OP_List

nd_OP_text2latex_dot_uscore_hash_lambda14 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List HTML.Curry_Base.C_BaseHtml
nd_OP_text2latex_dot_uscore_hash_lambda14 x1 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.OP_Cons (HTML.Curry_Base.nd_C_htxt (wrapNX id
  HTML.Curry_Base.nd_OP_uscore_inst_hash_HTML_dot_Base_dot_HTML_hash_HTML_dot_Base_dot_BaseHtml_hash)
  x1 s0 cd cs) Curry_Prelude.OP_List

d_C_markdownText2LaTeX :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_markdownText2LaTeX cd cs = Curry_Prelude.d_OP_dot (d_C_mdDoc2latex
  (d_C_text2latex cd cs) cd cs) (d_C_fromMarkdownText cd cs) cd cs

d_C_markdownText2LaTeXWithFormat :: (Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_markdownText2LaTeXWithFormat x1 cd cs = Curry_Prelude.d_OP_dot
  (d_C_mdDoc2latex x1 cd cs) (d_C_fromMarkdownText cd cs) cd cs

nd_C_markdownText2LaTeXWithFormat :: Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply
  -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C_markdownText2LaTeXWithFormat x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (nd_C_mdDoc2latex x1 s0 cd cs)
  (wrapDX id (d_C_fromMarkdownText cd cs)) s1 cd cs))

d_C_markdownText2CompleteLaTeX :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_markdownText2CompleteLaTeX x1 cd cs = Curry_Prelude.d_OP_plus_plus
  (d_C_latexHeader cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (d_C_mdDoc2latex (d_C_text2latex cd cs) cd cs) (Curry_Prelude.d_C_apply
  (d_C_fromMarkdownText cd cs) x1 cd cs) cd cs) (Curry_Prelude.toCurryString
  "\\end{document}\n") cd cs) cd cs

d_C_latexHeader :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_latexHeader cd cs = Curry_Prelude.d_C_unwords (Curry_Prelude.OP_Cons
  (Curry_Prelude.toCurryString "\\documentclass{article}")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString
  "\\usepackage[utf8x]{inputenc}") (Curry_Prelude.OP_Cons
  (Curry_Prelude.toCurryString "\\usepackage{url}") (Curry_Prelude.OP_Cons
  (Curry_Prelude.toCurryString
  "\\usepackage[breaklinks=true,unicode=true]{hyperref}") (Curry_Prelude.OP_Cons
  (Curry_Prelude.toCurryString "\\setlength{\\parindent}{0pt}")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString
  "\\setlength{\\parskip}{6pt plus 2pt minus 1pt}") (Curry_Prelude.OP_Cons
  (Curry_Prelude.toCurryString "\\setcounter{secnumdepth}{0}")
  (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "\\begin{document}")
  Curry_Prelude.OP_List)))))))) cd cs

d_C_formatMarkdownInputAsPDF :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_formatMarkdownInputAsPDF x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_IO.d_C_getContents cd cs) cd cs) (d_C_formatMarkdownAsPDF
  x1) cd cs

d_C_formatMarkdownFileAsPDF :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_formatMarkdownFileAsPDF x1 x2 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_readFile x1 cd cs) cd cs) (d_C_formatMarkdownAsPDF
  x2) cd cs

d_C_formatMarkdownAsPDF :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_formatMarkdownAsPDF x1 x2 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_Process.d_C_getPID cd cs) cd cs)
  (d_OP_formatMarkdownAsPDF_dot_uscore_hash_lambda16 x2 x1) cd cs

d_OP_formatMarkdownAsPDF_dot_uscore_hash_lambda16 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_OP_formatMarkdownAsPDF_dot_uscore_hash_lambda16 x1 x2 x3 cd cs = let x4 = x3
                                                                       x5 = Curry_Prelude.d_OP_plus_plus
                                                                         (Curry_Prelude.toCurryString
                                                                         "tmp_")
                                                                         (Curry_Prelude.d_C_apply
                                                                         (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
                                                                         cd cs)
                                                                         x4 cd
                                                                         cs) cd
                                                                         cs
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_writeFile (Curry_Prelude.d_OP_plus_plus x5
  (Curry_Prelude.toCurryString ".tex") cd cs) (d_C_markdownText2CompleteLaTeX x1
  cd cs) cd cs) cd cs) (d_C_pdflatexFile x5 x2 cd cs) cd cs

d_C_pdflatexFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_pdflatexFile x1 x2 cd cs = let x3 = Curry_Prelude.d_OP_plus_plus x1
                                     (Curry_Prelude.toCurryString ".pdf") cd cs
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar System.Curry_Process.d_C_system
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "pdflatex '\\nonstopmode\\input{") (Curry_Prelude.d_OP_plus_plus x1
  (Curry_Prelude.toCurryString ".tex}'") cd cs) cd cs) cd cs) cd cs)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar System.Curry_Process.d_C_system
  (Curry_Prelude.d_C_unwords (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString
  "/bin/rm -f") (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x1
  (Curry_Prelude.toCurryString ".tex") cd cs) (Curry_Prelude.OP_Cons
  (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString ".aux") cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus x1
  (Curry_Prelude.toCurryString ".log") cd cs) (Curry_Prelude.OP_Cons
  (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString ".out") cd cs)
  Curry_Prelude.OP_List))))) cd cs) cd cs) cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (d_C__case_0 x2 x3 (Curry_Prelude.d_C_null x2 cd cs) cd cs) cd cs)
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) Curry_Prelude.OP_Unit cd cs) cd cs) cd cs) cd cs

nd_C__case_85 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> C_MarkdownElem -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_85 x158 x157 x2 s cd cs = case x2 of
  C_Text x159 -> Curry_Prelude.C_False
  C_Emph x160 -> Curry_Prelude.C_False
  C_Strong x161 -> Curry_Prelude.C_False
  C_Code x162 -> Curry_Prelude.C_False
  C_HRef x163 x164 -> Curry_Prelude.C_False
  C_Par x165 -> Curry_Prelude.C_False
  C_CodeBlock x166 -> Curry_Prelude.C_False
  C_UList x167 -> Curry_Prelude.C_False
  C_OList x168 -> Curry_Prelude.C_False
  C_Quote x169 -> Curry_Prelude.C_False
  C_HRule -> Curry_Prelude.C_False
  C_Header x170 x171 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s1 = leftSupply s2
                                                          s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs)) x157 s0 cd cs) x170 s1 cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x158 x171 s3 cd cs) cd cs))
  Choice_C_MarkdownElem d i l r -> narrow d i (nd_C__case_85 x158 x157 l s cd
    cs) (nd_C__case_85 x158 x157 r s cd cs)
  Choices_C_MarkdownElem d i xs -> narrows cs d i (\z -> nd_C__case_85 x158 x157
    z s cd cs) xs
  Guard_C_MarkdownElem d c e -> guardCons d c ((\x -> nd_C__case_85 x158 x157 e
    s cd x) $! addCs c cs)
  Fail_C_MarkdownElem d info -> failCons d (traceFail "Text.Markdown._case_85"
    [show x158, show x157, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_85" (showCons x2))

d_C__case_86 :: C_MarkdownElem -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_86 x2 cd cs = case x2 of
  C_Text x144 -> Curry_Prelude.C_False
  C_Emph x145 -> Curry_Prelude.C_False
  C_Strong x146 -> Curry_Prelude.C_False
  C_Code x147 -> Curry_Prelude.C_False
  C_HRef x148 x149 -> Curry_Prelude.C_False
  C_Par x150 -> Curry_Prelude.C_False
  C_CodeBlock x151 -> Curry_Prelude.C_False
  C_UList x152 -> Curry_Prelude.C_False
  C_OList x153 -> Curry_Prelude.C_False
  C_Quote x154 -> Curry_Prelude.C_False
  C_HRule -> Curry_Prelude.C_True
  C_Header x155 x156 -> Curry_Prelude.C_False
  Choice_C_MarkdownElem d i l r -> narrow d i (d_C__case_86 l cd cs)
    (d_C__case_86 r cd cs)
  Choices_C_MarkdownElem d i xs -> narrows cs d i (\z -> d_C__case_86 z cd cs)
    xs
  Guard_C_MarkdownElem d c e -> guardCons d c ((\x -> d_C__case_86 e cd x) $!
    addCs c cs)
  Fail_C_MarkdownElem d info -> failCons d (traceFail "Text.Markdown._case_86"
    [show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_86" (showCons x2))

nd_C__case_87 :: Curry_Prelude.OP_List C_MarkdownElem -> C_MarkdownElem
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_87 x130 x2 s cd cs = case x2 of
  C_Text x131 -> Curry_Prelude.C_False
  C_Emph x132 -> Curry_Prelude.C_False
  C_Strong x133 -> Curry_Prelude.C_False
  C_Code x134 -> Curry_Prelude.C_False
  C_HRef x135 x136 -> Curry_Prelude.C_False
  C_Par x137 -> Curry_Prelude.C_False
  C_CodeBlock x138 -> Curry_Prelude.C_False
  C_UList x139 -> Curry_Prelude.C_False
  C_OList x140 -> Curry_Prelude.C_False
  C_Quote x141 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash)
    x130 x141 s0 cd cs
  C_HRule -> Curry_Prelude.C_False
  C_Header x142 x143 -> Curry_Prelude.C_False
  Choice_C_MarkdownElem d i l r -> narrow d i (nd_C__case_87 x130 l s cd cs)
    (nd_C__case_87 x130 r s cd cs)
  Choices_C_MarkdownElem d i xs -> narrows cs d i (\z -> nd_C__case_87 x130 z s
    cd cs) xs
  Guard_C_MarkdownElem d c e -> guardCons d c ((\x -> nd_C__case_87 x130 e s cd
    x) $! addCs c cs)
  Fail_C_MarkdownElem d info -> failCons d (traceFail "Text.Markdown._case_87"
    [show x130, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_87" (showCons x2))

nd_C__case_88 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List C_MarkdownElem)
  -> C_MarkdownElem -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_88 x116 x2 s cd cs = case x2 of
  C_Text x117 -> Curry_Prelude.C_False
  C_Emph x118 -> Curry_Prelude.C_False
  C_Strong x119 -> Curry_Prelude.C_False
  C_Code x120 -> Curry_Prelude.C_False
  C_HRef x121 x122 -> Curry_Prelude.C_False
  C_Par x123 -> Curry_Prelude.C_False
  C_CodeBlock x124 -> Curry_Prelude.C_False
  C_UList x125 -> Curry_Prelude.C_False
  C_OList x126 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash)))
    x116 x126 s0 cd cs
  C_Quote x127 -> Curry_Prelude.C_False
  C_HRule -> Curry_Prelude.C_False
  C_Header x128 x129 -> Curry_Prelude.C_False
  Choice_C_MarkdownElem d i l r -> narrow d i (nd_C__case_88 x116 l s cd cs)
    (nd_C__case_88 x116 r s cd cs)
  Choices_C_MarkdownElem d i xs -> narrows cs d i (\z -> nd_C__case_88 x116 z s
    cd cs) xs
  Guard_C_MarkdownElem d c e -> guardCons d c ((\x -> nd_C__case_88 x116 e s cd
    x) $! addCs c cs)
  Fail_C_MarkdownElem d info -> failCons d (traceFail "Text.Markdown._case_88"
    [show x116, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_88" (showCons x2))

nd_C__case_89 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List C_MarkdownElem)
  -> C_MarkdownElem -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_89 x102 x2 s cd cs = case x2 of
  C_Text x103 -> Curry_Prelude.C_False
  C_Emph x104 -> Curry_Prelude.C_False
  C_Strong x105 -> Curry_Prelude.C_False
  C_Code x106 -> Curry_Prelude.C_False
  C_HRef x107 x108 -> Curry_Prelude.C_False
  C_Par x109 -> Curry_Prelude.C_False
  C_CodeBlock x110 -> Curry_Prelude.C_False
  C_UList x111 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash)))
    x102 x111 s0 cd cs
  C_OList x112 -> Curry_Prelude.C_False
  C_Quote x113 -> Curry_Prelude.C_False
  C_HRule -> Curry_Prelude.C_False
  C_Header x114 x115 -> Curry_Prelude.C_False
  Choice_C_MarkdownElem d i l r -> narrow d i (nd_C__case_89 x102 l s cd cs)
    (nd_C__case_89 x102 r s cd cs)
  Choices_C_MarkdownElem d i xs -> narrows cs d i (\z -> nd_C__case_89 x102 z s
    cd cs) xs
  Guard_C_MarkdownElem d c e -> guardCons d c ((\x -> nd_C__case_89 x102 e s cd
    x) $! addCs c cs)
  Fail_C_MarkdownElem d info -> failCons d (traceFail "Text.Markdown._case_89"
    [show x102, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_89" (showCons x2))

nd_C__case_90 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_MarkdownElem
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_90 x88 x2 s cd cs = case x2 of
  C_Text x89 -> Curry_Prelude.C_False
  C_Emph x90 -> Curry_Prelude.C_False
  C_Strong x91 -> Curry_Prelude.C_False
  C_Code x92 -> Curry_Prelude.C_False
  C_HRef x93 x94 -> Curry_Prelude.C_False
  C_Par x95 -> Curry_Prelude.C_False
  C_CodeBlock x96 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x88 x96 s0 cd cs
  C_UList x97 -> Curry_Prelude.C_False
  C_OList x98 -> Curry_Prelude.C_False
  C_Quote x99 -> Curry_Prelude.C_False
  C_HRule -> Curry_Prelude.C_False
  C_Header x100 x101 -> Curry_Prelude.C_False
  Choice_C_MarkdownElem d i l r -> narrow d i (nd_C__case_90 x88 l s cd cs)
    (nd_C__case_90 x88 r s cd cs)
  Choices_C_MarkdownElem d i xs -> narrows cs d i (\z -> nd_C__case_90 x88 z s
    cd cs) xs
  Guard_C_MarkdownElem d c e -> guardCons d c ((\x -> nd_C__case_90 x88 e s cd
    x) $! addCs c cs)
  Fail_C_MarkdownElem d info -> failCons d (traceFail "Text.Markdown._case_90"
    [show x88, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_90" (showCons x2))

nd_C__case_91 :: Curry_Prelude.OP_List C_MarkdownElem -> C_MarkdownElem
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_91 x74 x2 s cd cs = case x2 of
  C_Text x75 -> Curry_Prelude.C_False
  C_Emph x76 -> Curry_Prelude.C_False
  C_Strong x77 -> Curry_Prelude.C_False
  C_Code x78 -> Curry_Prelude.C_False
  C_HRef x79 x80 -> Curry_Prelude.C_False
  C_Par x81 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash)
    x74 x81 s0 cd cs
  C_CodeBlock x82 -> Curry_Prelude.C_False
  C_UList x83 -> Curry_Prelude.C_False
  C_OList x84 -> Curry_Prelude.C_False
  C_Quote x85 -> Curry_Prelude.C_False
  C_HRule -> Curry_Prelude.C_False
  C_Header x86 x87 -> Curry_Prelude.C_False
  Choice_C_MarkdownElem d i l r -> narrow d i (nd_C__case_91 x74 l s cd cs)
    (nd_C__case_91 x74 r s cd cs)
  Choices_C_MarkdownElem d i xs -> narrows cs d i (\z -> nd_C__case_91 x74 z s
    cd cs) xs
  Guard_C_MarkdownElem d c e -> guardCons d c ((\x -> nd_C__case_91 x74 e s cd
    x) $! addCs c cs)
  Fail_C_MarkdownElem d info -> failCons d (traceFail "Text.Markdown._case_91"
    [show x74, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_91" (showCons x2))

nd_C__case_92 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_MarkdownElem -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_92 x60 x59 x2 s cd cs = case x2 of
  C_Text x61 -> Curry_Prelude.C_False
  C_Emph x62 -> Curry_Prelude.C_False
  C_Strong x63 -> Curry_Prelude.C_False
  C_Code x64 -> Curry_Prelude.C_False
  C_HRef x65 x66 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x59 x65 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x60 x66 s1 cd cs) cd cs))
  C_Par x67 -> Curry_Prelude.C_False
  C_CodeBlock x68 -> Curry_Prelude.C_False
  C_UList x69 -> Curry_Prelude.C_False
  C_OList x70 -> Curry_Prelude.C_False
  C_Quote x71 -> Curry_Prelude.C_False
  C_HRule -> Curry_Prelude.C_False
  C_Header x72 x73 -> Curry_Prelude.C_False
  Choice_C_MarkdownElem d i l r -> narrow d i (nd_C__case_92 x60 x59 l s cd cs)
    (nd_C__case_92 x60 x59 r s cd cs)
  Choices_C_MarkdownElem d i xs -> narrows cs d i (\z -> nd_C__case_92 x60 x59 z
    s cd cs) xs
  Guard_C_MarkdownElem d c e -> guardCons d c ((\x -> nd_C__case_92 x60 x59 e s
    cd x) $! addCs c cs)
  Fail_C_MarkdownElem d info -> failCons d (traceFail "Text.Markdown._case_92"
    [show x60, show x59, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_92" (showCons x2))

nd_C__case_93 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_MarkdownElem
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_93 x45 x2 s cd cs = case x2 of
  C_Text x46 -> Curry_Prelude.C_False
  C_Emph x47 -> Curry_Prelude.C_False
  C_Strong x48 -> Curry_Prelude.C_False
  C_Code x49 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x45 x49 s0 cd cs
  C_HRef x50 x51 -> Curry_Prelude.C_False
  C_Par x52 -> Curry_Prelude.C_False
  C_CodeBlock x53 -> Curry_Prelude.C_False
  C_UList x54 -> Curry_Prelude.C_False
  C_OList x55 -> Curry_Prelude.C_False
  C_Quote x56 -> Curry_Prelude.C_False
  C_HRule -> Curry_Prelude.C_False
  C_Header x57 x58 -> Curry_Prelude.C_False
  Choice_C_MarkdownElem d i l r -> narrow d i (nd_C__case_93 x45 l s cd cs)
    (nd_C__case_93 x45 r s cd cs)
  Choices_C_MarkdownElem d i xs -> narrows cs d i (\z -> nd_C__case_93 x45 z s
    cd cs) xs
  Guard_C_MarkdownElem d c e -> guardCons d c ((\x -> nd_C__case_93 x45 e s cd
    x) $! addCs c cs)
  Fail_C_MarkdownElem d info -> failCons d (traceFail "Text.Markdown._case_93"
    [show x45, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_93" (showCons x2))

nd_C__case_94 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_MarkdownElem
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_94 x31 x2 s cd cs = case x2 of
  C_Text x32 -> Curry_Prelude.C_False
  C_Emph x33 -> Curry_Prelude.C_False
  C_Strong x34 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x31 x34 s0 cd cs
  C_Code x35 -> Curry_Prelude.C_False
  C_HRef x36 x37 -> Curry_Prelude.C_False
  C_Par x38 -> Curry_Prelude.C_False
  C_CodeBlock x39 -> Curry_Prelude.C_False
  C_UList x40 -> Curry_Prelude.C_False
  C_OList x41 -> Curry_Prelude.C_False
  C_Quote x42 -> Curry_Prelude.C_False
  C_HRule -> Curry_Prelude.C_False
  C_Header x43 x44 -> Curry_Prelude.C_False
  Choice_C_MarkdownElem d i l r -> narrow d i (nd_C__case_94 x31 l s cd cs)
    (nd_C__case_94 x31 r s cd cs)
  Choices_C_MarkdownElem d i xs -> narrows cs d i (\z -> nd_C__case_94 x31 z s
    cd cs) xs
  Guard_C_MarkdownElem d c e -> guardCons d c ((\x -> nd_C__case_94 x31 e s cd
    x) $! addCs c cs)
  Fail_C_MarkdownElem d info -> failCons d (traceFail "Text.Markdown._case_94"
    [show x31, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_94" (showCons x2))

nd_C__case_95 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_MarkdownElem
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_95 x17 x2 s cd cs = case x2 of
  C_Text x18 -> Curry_Prelude.C_False
  C_Emph x19 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x17 x19 s0 cd cs
  C_Strong x20 -> Curry_Prelude.C_False
  C_Code x21 -> Curry_Prelude.C_False
  C_HRef x22 x23 -> Curry_Prelude.C_False
  C_Par x24 -> Curry_Prelude.C_False
  C_CodeBlock x25 -> Curry_Prelude.C_False
  C_UList x26 -> Curry_Prelude.C_False
  C_OList x27 -> Curry_Prelude.C_False
  C_Quote x28 -> Curry_Prelude.C_False
  C_HRule -> Curry_Prelude.C_False
  C_Header x29 x30 -> Curry_Prelude.C_False
  Choice_C_MarkdownElem d i l r -> narrow d i (nd_C__case_95 x17 l s cd cs)
    (nd_C__case_95 x17 r s cd cs)
  Choices_C_MarkdownElem d i xs -> narrows cs d i (\z -> nd_C__case_95 x17 z s
    cd cs) xs
  Guard_C_MarkdownElem d c e -> guardCons d c ((\x -> nd_C__case_95 x17 e s cd
    x) $! addCs c cs)
  Fail_C_MarkdownElem d info -> failCons d (traceFail "Text.Markdown._case_95"
    [show x17, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_95" (showCons x2))

nd_C__case_96 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_MarkdownElem
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_96 x3 x2 s cd cs = case x2 of
  C_Text x4 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x4 s0 cd cs
  C_Emph x5 -> Curry_Prelude.C_False
  C_Strong x6 -> Curry_Prelude.C_False
  C_Code x7 -> Curry_Prelude.C_False
  C_HRef x8 x9 -> Curry_Prelude.C_False
  C_Par x10 -> Curry_Prelude.C_False
  C_CodeBlock x11 -> Curry_Prelude.C_False
  C_UList x12 -> Curry_Prelude.C_False
  C_OList x13 -> Curry_Prelude.C_False
  C_Quote x14 -> Curry_Prelude.C_False
  C_HRule -> Curry_Prelude.C_False
  C_Header x15 x16 -> Curry_Prelude.C_False
  Choice_C_MarkdownElem d i l r -> narrow d i (nd_C__case_96 x3 l s cd cs)
    (nd_C__case_96 x3 r s cd cs)
  Choices_C_MarkdownElem d i xs -> narrows cs d i (\z -> nd_C__case_96 x3 z s cd
    cs) xs
  Guard_C_MarkdownElem d c e -> guardCons d c ((\x -> nd_C__case_96 x3 e s cd
    x) $! addCs c cs)
  Fail_C_MarkdownElem d info -> failCons d (traceFail "Text.Markdown._case_96"
    [show x3, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_96" (showCons x2))

nd_C__case_73 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> C_SourceMDElem -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_73 x158 x157 x2 s cd cs = case x2 of
  C_SMDText x159 -> Curry_Prelude.C_False
  C_SMDEmph x160 -> Curry_Prelude.C_False
  C_SMDStrong x161 -> Curry_Prelude.C_False
  C_SMDCode x162 -> Curry_Prelude.C_False
  C_SMDHRef x163 x164 -> Curry_Prelude.C_False
  C_SMDPar x165 -> Curry_Prelude.C_False
  C_SMDCodeBlock x166 -> Curry_Prelude.C_False
  C_SMDUItem x167 -> Curry_Prelude.C_False
  C_SMDOItem x168 -> Curry_Prelude.C_False
  C_SMDQuote x169 -> Curry_Prelude.C_False
  C_SMDHRule -> Curry_Prelude.C_False
  C_SMDHeader x170 x171 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s1 = leftSupply s2
                                                          s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs)) x157 s0 cd cs) x170 s1 cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x158 x171 s3 cd cs) cd cs))
  Choice_C_SourceMDElem d i l r -> narrow d i (nd_C__case_73 x158 x157 l s cd
    cs) (nd_C__case_73 x158 x157 r s cd cs)
  Choices_C_SourceMDElem d i xs -> narrows cs d i (\z -> nd_C__case_73 x158 x157
    z s cd cs) xs
  Guard_C_SourceMDElem d c e -> guardCons d c ((\x -> nd_C__case_73 x158 x157 e
    s cd x) $! addCs c cs)
  Fail_C_SourceMDElem d info -> failCons d (traceFail "Text.Markdown._case_73"
    [show x158, show x157, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_73" (showCons x2))

d_C__case_74 :: C_SourceMDElem -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_74 x2 cd cs = case x2 of
  C_SMDText x144 -> Curry_Prelude.C_False
  C_SMDEmph x145 -> Curry_Prelude.C_False
  C_SMDStrong x146 -> Curry_Prelude.C_False
  C_SMDCode x147 -> Curry_Prelude.C_False
  C_SMDHRef x148 x149 -> Curry_Prelude.C_False
  C_SMDPar x150 -> Curry_Prelude.C_False
  C_SMDCodeBlock x151 -> Curry_Prelude.C_False
  C_SMDUItem x152 -> Curry_Prelude.C_False
  C_SMDOItem x153 -> Curry_Prelude.C_False
  C_SMDQuote x154 -> Curry_Prelude.C_False
  C_SMDHRule -> Curry_Prelude.C_True
  C_SMDHeader x155 x156 -> Curry_Prelude.C_False
  Choice_C_SourceMDElem d i l r -> narrow d i (d_C__case_74 l cd cs)
    (d_C__case_74 r cd cs)
  Choices_C_SourceMDElem d i xs -> narrows cs d i (\z -> d_C__case_74 z cd cs)
    xs
  Guard_C_SourceMDElem d c e -> guardCons d c ((\x -> d_C__case_74 e cd x) $!
    addCs c cs)
  Fail_C_SourceMDElem d info -> failCons d (traceFail "Text.Markdown._case_74"
    [show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_74" (showCons x2))

nd_C__case_75 :: Curry_Prelude.OP_List C_MarkdownElem -> C_SourceMDElem
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_75 x130 x2 s cd cs = case x2 of
  C_SMDText x131 -> Curry_Prelude.C_False
  C_SMDEmph x132 -> Curry_Prelude.C_False
  C_SMDStrong x133 -> Curry_Prelude.C_False
  C_SMDCode x134 -> Curry_Prelude.C_False
  C_SMDHRef x135 x136 -> Curry_Prelude.C_False
  C_SMDPar x137 -> Curry_Prelude.C_False
  C_SMDCodeBlock x138 -> Curry_Prelude.C_False
  C_SMDUItem x139 -> Curry_Prelude.C_False
  C_SMDOItem x140 -> Curry_Prelude.C_False
  C_SMDQuote x141 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash)
    x130 x141 s0 cd cs
  C_SMDHRule -> Curry_Prelude.C_False
  C_SMDHeader x142 x143 -> Curry_Prelude.C_False
  Choice_C_SourceMDElem d i l r -> narrow d i (nd_C__case_75 x130 l s cd cs)
    (nd_C__case_75 x130 r s cd cs)
  Choices_C_SourceMDElem d i xs -> narrows cs d i (\z -> nd_C__case_75 x130 z s
    cd cs) xs
  Guard_C_SourceMDElem d c e -> guardCons d c ((\x -> nd_C__case_75 x130 e s cd
    x) $! addCs c cs)
  Fail_C_SourceMDElem d info -> failCons d (traceFail "Text.Markdown._case_75"
    [show x130, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_75" (showCons x2))

nd_C__case_76 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_SourceMDElem
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_76 x116 x2 s cd cs = case x2 of
  C_SMDText x117 -> Curry_Prelude.C_False
  C_SMDEmph x118 -> Curry_Prelude.C_False
  C_SMDStrong x119 -> Curry_Prelude.C_False
  C_SMDCode x120 -> Curry_Prelude.C_False
  C_SMDHRef x121 x122 -> Curry_Prelude.C_False
  C_SMDPar x123 -> Curry_Prelude.C_False
  C_SMDCodeBlock x124 -> Curry_Prelude.C_False
  C_SMDUItem x125 -> Curry_Prelude.C_False
  C_SMDOItem x126 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x116 x126 s0 cd cs
  C_SMDQuote x127 -> Curry_Prelude.C_False
  C_SMDHRule -> Curry_Prelude.C_False
  C_SMDHeader x128 x129 -> Curry_Prelude.C_False
  Choice_C_SourceMDElem d i l r -> narrow d i (nd_C__case_76 x116 l s cd cs)
    (nd_C__case_76 x116 r s cd cs)
  Choices_C_SourceMDElem d i xs -> narrows cs d i (\z -> nd_C__case_76 x116 z s
    cd cs) xs
  Guard_C_SourceMDElem d c e -> guardCons d c ((\x -> nd_C__case_76 x116 e s cd
    x) $! addCs c cs)
  Fail_C_SourceMDElem d info -> failCons d (traceFail "Text.Markdown._case_76"
    [show x116, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_76" (showCons x2))

nd_C__case_77 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_SourceMDElem
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_77 x102 x2 s cd cs = case x2 of
  C_SMDText x103 -> Curry_Prelude.C_False
  C_SMDEmph x104 -> Curry_Prelude.C_False
  C_SMDStrong x105 -> Curry_Prelude.C_False
  C_SMDCode x106 -> Curry_Prelude.C_False
  C_SMDHRef x107 x108 -> Curry_Prelude.C_False
  C_SMDPar x109 -> Curry_Prelude.C_False
  C_SMDCodeBlock x110 -> Curry_Prelude.C_False
  C_SMDUItem x111 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x102 x111 s0 cd cs
  C_SMDOItem x112 -> Curry_Prelude.C_False
  C_SMDQuote x113 -> Curry_Prelude.C_False
  C_SMDHRule -> Curry_Prelude.C_False
  C_SMDHeader x114 x115 -> Curry_Prelude.C_False
  Choice_C_SourceMDElem d i l r -> narrow d i (nd_C__case_77 x102 l s cd cs)
    (nd_C__case_77 x102 r s cd cs)
  Choices_C_SourceMDElem d i xs -> narrows cs d i (\z -> nd_C__case_77 x102 z s
    cd cs) xs
  Guard_C_SourceMDElem d c e -> guardCons d c ((\x -> nd_C__case_77 x102 e s cd
    x) $! addCs c cs)
  Fail_C_SourceMDElem d info -> failCons d (traceFail "Text.Markdown._case_77"
    [show x102, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_77" (showCons x2))

nd_C__case_78 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_SourceMDElem
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_78 x88 x2 s cd cs = case x2 of
  C_SMDText x89 -> Curry_Prelude.C_False
  C_SMDEmph x90 -> Curry_Prelude.C_False
  C_SMDStrong x91 -> Curry_Prelude.C_False
  C_SMDCode x92 -> Curry_Prelude.C_False
  C_SMDHRef x93 x94 -> Curry_Prelude.C_False
  C_SMDPar x95 -> Curry_Prelude.C_False
  C_SMDCodeBlock x96 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x88 x96 s0 cd cs
  C_SMDUItem x97 -> Curry_Prelude.C_False
  C_SMDOItem x98 -> Curry_Prelude.C_False
  C_SMDQuote x99 -> Curry_Prelude.C_False
  C_SMDHRule -> Curry_Prelude.C_False
  C_SMDHeader x100 x101 -> Curry_Prelude.C_False
  Choice_C_SourceMDElem d i l r -> narrow d i (nd_C__case_78 x88 l s cd cs)
    (nd_C__case_78 x88 r s cd cs)
  Choices_C_SourceMDElem d i xs -> narrows cs d i (\z -> nd_C__case_78 x88 z s
    cd cs) xs
  Guard_C_SourceMDElem d c e -> guardCons d c ((\x -> nd_C__case_78 x88 e s cd
    x) $! addCs c cs)
  Fail_C_SourceMDElem d info -> failCons d (traceFail "Text.Markdown._case_78"
    [show x88, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_78" (showCons x2))

nd_C__case_79 :: Curry_Prelude.OP_List C_MarkdownElem -> C_SourceMDElem
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_79 x74 x2 s cd cs = case x2 of
  C_SMDText x75 -> Curry_Prelude.C_False
  C_SMDEmph x76 -> Curry_Prelude.C_False
  C_SMDStrong x77 -> Curry_Prelude.C_False
  C_SMDCode x78 -> Curry_Prelude.C_False
  C_SMDHRef x79 x80 -> Curry_Prelude.C_False
  C_SMDPar x81 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Text_dot_Markdown_dot_MarkdownElem_hash)
    x74 x81 s0 cd cs
  C_SMDCodeBlock x82 -> Curry_Prelude.C_False
  C_SMDUItem x83 -> Curry_Prelude.C_False
  C_SMDOItem x84 -> Curry_Prelude.C_False
  C_SMDQuote x85 -> Curry_Prelude.C_False
  C_SMDHRule -> Curry_Prelude.C_False
  C_SMDHeader x86 x87 -> Curry_Prelude.C_False
  Choice_C_SourceMDElem d i l r -> narrow d i (nd_C__case_79 x74 l s cd cs)
    (nd_C__case_79 x74 r s cd cs)
  Choices_C_SourceMDElem d i xs -> narrows cs d i (\z -> nd_C__case_79 x74 z s
    cd cs) xs
  Guard_C_SourceMDElem d c e -> guardCons d c ((\x -> nd_C__case_79 x74 e s cd
    x) $! addCs c cs)
  Fail_C_SourceMDElem d info -> failCons d (traceFail "Text.Markdown._case_79"
    [show x74, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_79" (showCons x2))

nd_C__case_80 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_SourceMDElem -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_80 x60 x59 x2 s cd cs = case x2 of
  C_SMDText x61 -> Curry_Prelude.C_False
  C_SMDEmph x62 -> Curry_Prelude.C_False
  C_SMDStrong x63 -> Curry_Prelude.C_False
  C_SMDCode x64 -> Curry_Prelude.C_False
  C_SMDHRef x65 x66 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x59 x65 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x60 x66 s1 cd cs) cd cs))
  C_SMDPar x67 -> Curry_Prelude.C_False
  C_SMDCodeBlock x68 -> Curry_Prelude.C_False
  C_SMDUItem x69 -> Curry_Prelude.C_False
  C_SMDOItem x70 -> Curry_Prelude.C_False
  C_SMDQuote x71 -> Curry_Prelude.C_False
  C_SMDHRule -> Curry_Prelude.C_False
  C_SMDHeader x72 x73 -> Curry_Prelude.C_False
  Choice_C_SourceMDElem d i l r -> narrow d i (nd_C__case_80 x60 x59 l s cd cs)
    (nd_C__case_80 x60 x59 r s cd cs)
  Choices_C_SourceMDElem d i xs -> narrows cs d i (\z -> nd_C__case_80 x60 x59 z
    s cd cs) xs
  Guard_C_SourceMDElem d c e -> guardCons d c ((\x -> nd_C__case_80 x60 x59 e s
    cd x) $! addCs c cs)
  Fail_C_SourceMDElem d info -> failCons d (traceFail "Text.Markdown._case_80"
    [show x60, show x59, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_80" (showCons x2))

nd_C__case_81 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_SourceMDElem
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_81 x45 x2 s cd cs = case x2 of
  C_SMDText x46 -> Curry_Prelude.C_False
  C_SMDEmph x47 -> Curry_Prelude.C_False
  C_SMDStrong x48 -> Curry_Prelude.C_False
  C_SMDCode x49 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x45 x49 s0 cd cs
  C_SMDHRef x50 x51 -> Curry_Prelude.C_False
  C_SMDPar x52 -> Curry_Prelude.C_False
  C_SMDCodeBlock x53 -> Curry_Prelude.C_False
  C_SMDUItem x54 -> Curry_Prelude.C_False
  C_SMDOItem x55 -> Curry_Prelude.C_False
  C_SMDQuote x56 -> Curry_Prelude.C_False
  C_SMDHRule -> Curry_Prelude.C_False
  C_SMDHeader x57 x58 -> Curry_Prelude.C_False
  Choice_C_SourceMDElem d i l r -> narrow d i (nd_C__case_81 x45 l s cd cs)
    (nd_C__case_81 x45 r s cd cs)
  Choices_C_SourceMDElem d i xs -> narrows cs d i (\z -> nd_C__case_81 x45 z s
    cd cs) xs
  Guard_C_SourceMDElem d c e -> guardCons d c ((\x -> nd_C__case_81 x45 e s cd
    x) $! addCs c cs)
  Fail_C_SourceMDElem d info -> failCons d (traceFail "Text.Markdown._case_81"
    [show x45, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_81" (showCons x2))

nd_C__case_82 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_SourceMDElem
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_82 x31 x2 s cd cs = case x2 of
  C_SMDText x32 -> Curry_Prelude.C_False
  C_SMDEmph x33 -> Curry_Prelude.C_False
  C_SMDStrong x34 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x31 x34 s0 cd cs
  C_SMDCode x35 -> Curry_Prelude.C_False
  C_SMDHRef x36 x37 -> Curry_Prelude.C_False
  C_SMDPar x38 -> Curry_Prelude.C_False
  C_SMDCodeBlock x39 -> Curry_Prelude.C_False
  C_SMDUItem x40 -> Curry_Prelude.C_False
  C_SMDOItem x41 -> Curry_Prelude.C_False
  C_SMDQuote x42 -> Curry_Prelude.C_False
  C_SMDHRule -> Curry_Prelude.C_False
  C_SMDHeader x43 x44 -> Curry_Prelude.C_False
  Choice_C_SourceMDElem d i l r -> narrow d i (nd_C__case_82 x31 l s cd cs)
    (nd_C__case_82 x31 r s cd cs)
  Choices_C_SourceMDElem d i xs -> narrows cs d i (\z -> nd_C__case_82 x31 z s
    cd cs) xs
  Guard_C_SourceMDElem d c e -> guardCons d c ((\x -> nd_C__case_82 x31 e s cd
    x) $! addCs c cs)
  Fail_C_SourceMDElem d info -> failCons d (traceFail "Text.Markdown._case_82"
    [show x31, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_82" (showCons x2))

nd_C__case_83 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_SourceMDElem
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_83 x17 x2 s cd cs = case x2 of
  C_SMDText x18 -> Curry_Prelude.C_False
  C_SMDEmph x19 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x17 x19 s0 cd cs
  C_SMDStrong x20 -> Curry_Prelude.C_False
  C_SMDCode x21 -> Curry_Prelude.C_False
  C_SMDHRef x22 x23 -> Curry_Prelude.C_False
  C_SMDPar x24 -> Curry_Prelude.C_False
  C_SMDCodeBlock x25 -> Curry_Prelude.C_False
  C_SMDUItem x26 -> Curry_Prelude.C_False
  C_SMDOItem x27 -> Curry_Prelude.C_False
  C_SMDQuote x28 -> Curry_Prelude.C_False
  C_SMDHRule -> Curry_Prelude.C_False
  C_SMDHeader x29 x30 -> Curry_Prelude.C_False
  Choice_C_SourceMDElem d i l r -> narrow d i (nd_C__case_83 x17 l s cd cs)
    (nd_C__case_83 x17 r s cd cs)
  Choices_C_SourceMDElem d i xs -> narrows cs d i (\z -> nd_C__case_83 x17 z s
    cd cs) xs
  Guard_C_SourceMDElem d c e -> guardCons d c ((\x -> nd_C__case_83 x17 e s cd
    x) $! addCs c cs)
  Fail_C_SourceMDElem d info -> failCons d (traceFail "Text.Markdown._case_83"
    [show x17, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_83" (showCons x2))

nd_C__case_84 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_SourceMDElem
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_84 x3 x2 s cd cs = case x2 of
  C_SMDText x4 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x4 s0 cd cs
  C_SMDEmph x5 -> Curry_Prelude.C_False
  C_SMDStrong x6 -> Curry_Prelude.C_False
  C_SMDCode x7 -> Curry_Prelude.C_False
  C_SMDHRef x8 x9 -> Curry_Prelude.C_False
  C_SMDPar x10 -> Curry_Prelude.C_False
  C_SMDCodeBlock x11 -> Curry_Prelude.C_False
  C_SMDUItem x12 -> Curry_Prelude.C_False
  C_SMDOItem x13 -> Curry_Prelude.C_False
  C_SMDQuote x14 -> Curry_Prelude.C_False
  C_SMDHRule -> Curry_Prelude.C_False
  C_SMDHeader x15 x16 -> Curry_Prelude.C_False
  Choice_C_SourceMDElem d i l r -> narrow d i (nd_C__case_84 x3 l s cd cs)
    (nd_C__case_84 x3 r s cd cs)
  Choices_C_SourceMDElem d i xs -> narrows cs d i (\z -> nd_C__case_84 x3 z s cd
    cs) xs
  Guard_C_SourceMDElem d c e -> guardCons d c ((\x -> nd_C__case_84 x3 e s cd
    x) $! addCs c cs)
  Fail_C_SourceMDElem d info -> failCons d (traceFail "Text.Markdown._case_84"
    [show x3, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_84" (showCons x2))

d_C__case_72 :: Curry_Prelude.C_Bool -> C_SourceMDElem -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_72 x2 x1 cd cs = case x1 of
  C_SMDUItem x3 -> Curry_Prelude.C_True
  C_SMDText x4 -> x2
  C_SMDEmph x5 -> x2
  C_SMDStrong x6 -> x2
  C_SMDCode x7 -> x2
  C_SMDHRef x8 x9 -> x2
  C_SMDPar x10 -> x2
  C_SMDCodeBlock x11 -> x2
  C_SMDOItem x12 -> x2
  C_SMDQuote x13 -> x2
  C_SMDHRule -> x2
  C_SMDHeader x14 x15 -> x2
  Choice_C_SourceMDElem d i l r -> narrow d i (d_C__case_72 x2 l cd cs)
    (d_C__case_72 x2 r cd cs)
  Choices_C_SourceMDElem d i xs -> narrows cs d i (\z -> d_C__case_72 x2 z cd
    cs) xs
  Guard_C_SourceMDElem d c e -> guardCons d c ((\x -> d_C__case_72 x2 e cd x) $!
    addCs c cs)
  Fail_C_SourceMDElem d info -> failCons d (traceFail "Text.Markdown._case_72"
    [show x2, show x1] info)
  _ -> failCons cd (consFail "Text.Markdown._case_72" (showCons x1))

d_C__case_71 :: Curry_Prelude.C_Bool -> C_SourceMDElem -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_71 x2 x1 cd cs = case x1 of
  C_SMDOItem x3 -> Curry_Prelude.C_True
  C_SMDText x4 -> x2
  C_SMDEmph x5 -> x2
  C_SMDStrong x6 -> x2
  C_SMDCode x7 -> x2
  C_SMDHRef x8 x9 -> x2
  C_SMDPar x10 -> x2
  C_SMDCodeBlock x11 -> x2
  C_SMDUItem x12 -> x2
  C_SMDQuote x13 -> x2
  C_SMDHRule -> x2
  C_SMDHeader x14 x15 -> x2
  Choice_C_SourceMDElem d i l r -> narrow d i (d_C__case_71 x2 l cd cs)
    (d_C__case_71 x2 r cd cs)
  Choices_C_SourceMDElem d i xs -> narrows cs d i (\z -> d_C__case_71 x2 z cd
    cs) xs
  Guard_C_SourceMDElem d c e -> guardCons d c ((\x -> d_C__case_71 x2 e cd x) $!
    addCs c cs)
  Fail_C_SourceMDElem d info -> failCons d (traceFail "Text.Markdown._case_71"
    [show x2, show x1] info)
  _ -> failCons cd (consFail "Text.Markdown._case_71" (showCons x1))

d_C__case_70 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_SourceMDElem
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_70 x2 x1 cd cs = case x1 of
  C_SMDUItem x3 -> x3
  C_SMDOItem x4 -> x4
  C_SMDText x5 -> x2
  C_SMDEmph x6 -> x2
  C_SMDStrong x7 -> x2
  C_SMDCode x8 -> x2
  C_SMDHRef x9 x10 -> x2
  C_SMDPar x11 -> x2
  C_SMDCodeBlock x12 -> x2
  C_SMDQuote x13 -> x2
  C_SMDHRule -> x2
  C_SMDHeader x14 x15 -> x2
  Choice_C_SourceMDElem d i l r -> narrow d i (d_C__case_70 x2 l cd cs)
    (d_C__case_70 x2 r cd cs)
  Choices_C_SourceMDElem d i xs -> narrows cs d i (\z -> d_C__case_70 x2 z cd
    cs) xs
  Guard_C_SourceMDElem d c e -> guardCons d c ((\x -> d_C__case_70 x2 e cd x) $!
    addCs c cs)
  Fail_C_SourceMDElem d info -> failCons d (traceFail "Text.Markdown._case_70"
    [show x2, show x1] info)
  _ -> failCons cd (consFail "Text.Markdown._case_70" (showCons x1))

d_C__case_69 :: Curry_Prelude.OP_List C_SourceMDElem -> C_SourceMDElem -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_MarkdownElem
d_C__case_69 x3 x2 cd cs = case x2 of
  C_SMDUItem x4 -> d_C_joinItems (acceptCs id C_UList) d_C_isSMDUItem
    (Curry_Prelude.OP_Cons x4 Curry_Prelude.OP_List) x3 cd cs
  C_SMDOItem x5 -> d_C_joinItems (acceptCs id C_OList) d_C_isSMDOItem
    (Curry_Prelude.OP_Cons x5 Curry_Prelude.OP_List) x3 cd cs
  C_SMDText x6 -> Curry_Prelude.OP_Cons (C_Text x6) (d_C_groupMarkDownElems x3
    cd cs)
  C_SMDEmph x7 -> Curry_Prelude.OP_Cons (C_Emph x7) (d_C_groupMarkDownElems x3
    cd cs)
  C_SMDStrong x8 -> Curry_Prelude.OP_Cons (C_Strong x8) (d_C_groupMarkDownElems
    x3 cd cs)
  C_SMDCode x9 -> Curry_Prelude.OP_Cons (C_Code x9) (d_C_groupMarkDownElems x3
    cd cs)
  C_SMDHRef x10 x11 -> Curry_Prelude.OP_Cons (C_HRef x10 x11)
    (d_C_groupMarkDownElems x3 cd cs)
  C_SMDPar x12 -> Curry_Prelude.OP_Cons (C_Par x12) (d_C_groupMarkDownElems x3
    cd cs)
  C_SMDCodeBlock x13 -> Curry_Prelude.OP_Cons (C_CodeBlock x13)
    (d_C_groupMarkDownElems x3 cd cs)
  C_SMDQuote x14 -> Curry_Prelude.OP_Cons (C_Quote x14) (d_C_groupMarkDownElems
    x3 cd cs)
  C_SMDHRule -> Curry_Prelude.OP_Cons C_HRule (d_C_groupMarkDownElems x3 cd cs)
  C_SMDHeader x15 x16 -> Curry_Prelude.OP_Cons (C_Header x15 x16)
    (d_C_groupMarkDownElems x3 cd cs)
  Choice_C_SourceMDElem d i l r -> narrow d i (d_C__case_69 x3 l cd cs)
    (d_C__case_69 x3 r cd cs)
  Choices_C_SourceMDElem d i xs -> narrows cs d i (\z -> d_C__case_69 x3 z cd
    cs) xs
  Guard_C_SourceMDElem d c e -> guardCons d c ((\x -> d_C__case_69 x3 e cd x) $!
    addCs c cs)
  Fail_C_SourceMDElem d info -> failCons d (traceFail "Text.Markdown._case_69"
    [show x3, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_69" (showCons x2))

d_C__case_68 :: C_SourceMDElem -> (C_SourceMDElem -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List C_SourceMDElem
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> (Curry_Prelude.OP_List (Curry_Prelude.OP_List C_MarkdownElem) -> Cover
  -> ConstStore -> C_MarkdownElem) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_MarkdownElem
d_C__case_68 x5 x2 x6 x3 x1 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> d_C_joinItems x1 x2 (Curry_Prelude.OP_Cons
    (d_C_textOfItem x5 cd cs) x3) x6 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply x1
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_reverse cd cs)
    (Curry_Prelude.d_C_map (d_C_fromMarkdownText cd cs) x3 cd cs) cd cs) cd cs)
    (d_C_groupMarkDownElems (Curry_Prelude.OP_Cons x5 x6) cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_68 x5 x2 x6 x3 x1
    l cd cs) (d_C__case_68 x5 x2 x6 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_68 x5
    x2 x6 x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_68 x5 x2
    x6 x3 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_68" [show x5, show x2, show x6, show x3, show x1, show
    x7] info)
  _ -> failCons cd (consFail "Text.Markdown._case_68" (showCons x7))

nd_C__case_68 :: C_SourceMDElem -> Func C_SourceMDElem Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List C_SourceMDElem -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List C_MarkdownElem)) C_MarkdownElem -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List C_MarkdownElem
nd_C__case_68 x5 x2 x6 x3 x1 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_joinItems x1 x2 (Curry_Prelude.OP_Cons (d_C_textOfItem x5
    cd cs) x3) x6 s0 cd cs
  Curry_Prelude.C_False -> let s6 = s
    in s6 `seq` Curry_Prelude.OP_Cons (let s5 = leftSupply s6
                                           s3 = rightSupply s6
    in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply x1 (let s2 = leftSupply s3
                                                           s4 = rightSupply s3
                                                           s0 = leftSupply s4
                                                           s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_reverse s0 cd cs) (Curry_Prelude.nd_C_map (wrapDX id
    (d_C_fromMarkdownText cd cs)) x3 s1 cd cs) s2 cd cs)))) s5 cd cs))
    (d_C_groupMarkDownElems (Curry_Prelude.OP_Cons x5 x6) cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_68 x5 x2 x6 x3
    x1 l s cd cs) (nd_C__case_68 x5 x2 x6 x3 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_68 x5
    x2 x6 x3 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_68 x5 x2
    x6 x3 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_68" [show x5, show x2, show x6, show x3, show x1, show
    x7] info)
  _ -> failCons cd (consFail "Text.Markdown._case_68" (showCons x7))

d_C__case_67 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_SourceMDElem
d_C__case_67 x1 x3 x7 x8 x10 x9 x2 x6 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> d_C_markdownText x2 cd cs
  Curry_Prelude.C_False -> d_C__case_66 x3 x7 x8 x1 x10 x9 x2 x6
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x3 cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_67 x1 x3 x7 x8
    x10 x9 x2 x6 l cd cs) (d_C__case_67 x1 x3 x7 x8 x10 x9 x2 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_67 x1
    x3 x7 x8 x10 x9 x2 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_67 x1 x3
    x7 x8 x10 x9 x2 x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_67" [show x1, show x3, show x7, show x8, show x10, show
    x9, show x2, show x6, show x11] info)
  _ -> failCons cd (consFail "Text.Markdown._case_67" (showCons x11))

d_C__case_66 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_SourceMDElem
d_C__case_66 x3 x7 x8 x1 x10 x9 x2 x6 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> d_C_markdownCodeBlock x3 (Curry_Prelude.d_C_drop x3 x1
    cd cs) x2 cd cs
  Curry_Prelude.C_False -> d_C__case_65 x8 x1 x10 x9 x2 x6 x7 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_66 x3 x7 x8 x1
    x10 x9 x2 x6 l cd cs) (d_C__case_66 x3 x7 x8 x1 x10 x9 x2 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_66 x3
    x7 x8 x1 x10 x9 x2 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_66 x3 x7
    x8 x1 x10 x9 x2 x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_66" [show x3, show x7, show x8, show x1, show x10, show
    x9, show x2, show x6, show x11] info)
  _ -> failCons cd (consFail "Text.Markdown._case_66" (showCons x11))

d_C__case_65 :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_65 x8 x1 x10 x9 x2 x6 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (C_SMDHeader
    (Curry_Prelude.C_Int (1)) x1) (d_C_markdownText (d_C_dropFirst x6 cd cs) cd
    cs)
  Curry_Prelude.C_False -> d_C__case_64 x1 x10 x9 x2 x6 x8 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_65 x8 x1 x10 x9
    x2 x6 l cd cs) (d_C__case_65 x8 x1 x10 x9 x2 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_65 x8
    x1 x10 x9 x2 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_65 x8 x1
    x10 x9 x2 x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_65" [show x8, show x1, show x10, show x9, show x2, show
    x6, show x7] info)
  _ -> failCons cd (consFail "Text.Markdown._case_65" (showCons x7))

d_C__case_64 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_SourceMDElem
d_C__case_64 x1 x10 x9 x2 x6 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (C_SMDHeader
    (Curry_Prelude.C_Int (2)) x1) (d_C_markdownText (d_C_dropFirst x6 cd cs) cd
    cs)
  Curry_Prelude.C_False -> d_C__case_63 x1 x10 x9 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (1)) x1 cd cs)
    (Curry_Prelude.toCurryString "#") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_64 x1 x10 x9 x2
    x6 l cd cs) (d_C__case_64 x1 x10 x9 x2 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_64 x1
    x10 x9 x2 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_64 x1 x10
    x9 x2 x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_64" [show x1, show x10, show x9, show x2, show x6, show
    x8] info)
  _ -> failCons cd (consFail "Text.Markdown._case_64" (showCons x8))

d_C__case_63 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_63 x1 x10 x9 x2 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> d_C_tryMDHeader x1 x2 cd cs
  Curry_Prelude.C_False -> d_C__case_62 x1 x10 x9 x2 (d_C_isHRule x1 cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_63 x1 x10 x9 x2 l
    cd cs) (d_C__case_63 x1 x10 x9 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_63 x1
    x10 x9 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_63 x1 x10
    x9 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_63" [show x1, show x10, show x9, show x2, show x11]
    info)
  _ -> failCons cd (consFail "Text.Markdown._case_63" (showCons x11))

d_C__case_62 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_62 x1 x10 x9 x2 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons C_SMDHRule (d_C_markdownText x2
    cd cs)
  Curry_Prelude.C_False -> d_C__case_61 x1 x10 x9 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (2)) x1 cd cs)
    (Curry_Prelude.toCurryString "> ") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_62 x1 x10 x9 x2 l
    cd cs) (d_C__case_62 x1 x10 x9 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_62 x1
    x10 x9 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_62 x1 x10
    x9 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_62" [show x1, show x10, show x9, show x2, show x11]
    info)
  _ -> failCons cd (consFail "Text.Markdown._case_62" (showCons x11))

d_C__case_61 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_61 x1 x10 x9 x2 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> d_C_markdownQuote (Curry_Prelude.d_C_drop
    (Curry_Prelude.C_Int (2)) x1 cd cs) x2 cd cs
  Curry_Prelude.C_False -> d_C__case_60 x10 x9 x2 x1 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x10 cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_61 x1 x10 x9 x2 l
    cd cs) (d_C__case_61 x1 x10 x9 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_61 x1
    x10 x9 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_61 x1 x10
    x9 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_61" [show x1, show x10, show x9, show x2, show x11]
    info)
  _ -> failCons cd (consFail "Text.Markdown._case_61" (showCons x11))

d_C__case_60 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_60 x10 x9 x2 x1 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> d_C_markdownItem (acceptCs id C_SMDUItem) x10
    (Curry_Prelude.d_C_drop x10 x1 cd cs) x2 cd cs
  Curry_Prelude.C_False -> d_C__case_59 x9 x2 x1 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x9 cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_60 x10 x9 x2 x1 l
    cd cs) (d_C__case_60 x10 x9 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_60 x10
    x9 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_60 x10 x9
    x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_60" [show x10, show x9, show x2, show x1, show x11]
    info)
  _ -> failCons cd (consFail "Text.Markdown._case_60" (showCons x11))

d_C__case_59 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_SourceMDElem
d_C__case_59 x9 x2 x1 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> d_C_markdownItem (acceptCs id C_SMDOItem) x9
    (Curry_Prelude.d_C_drop x9 x1 cd cs) x2 cd cs
  Curry_Prelude.C_False -> d_C__case_58 x2 x1 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_59 x9 x2 x1 l cd
    cs) (d_C__case_59 x9 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_59 x9
    x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_59 x9 x2
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_59" [show x9, show x2, show x1, show x10] info)
  _ -> failCons cd (consFail "Text.Markdown._case_59" (showCons x10))

d_C__case_58 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_58 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> d_C_markdownPar x1 x2 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_58 x2 x1 l cd cs)
    (d_C__case_58 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_58 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_58 x2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_58" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "Text.Markdown._case_58" (showCons x3))

d_C__case_57 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_57 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.d_C_tail x1 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_57 x1 l cd cs)
    (d_C__case_57 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_57 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_57 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_57" [show x1, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_57" (showCons x2))

d_C__case_56 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_56 x6 x5 x2 x1 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> d_C_markdownPar x1 x2 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (C_SMDHeader x6 (d_C_dropFirst
    x5 cd cs)) (d_C_markdownText x2 cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_56 x6 x5 x2 x1 l
    cd cs) (d_C__case_56 x6 x5 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_56 x6
    x5 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_56 x6 x5
    x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_56" [show x6, show x5, show x2, show x1, show x7] info)
  _ -> failCons cd (consFail "Text.Markdown._case_56" (showCons x7))

d_C__case_55 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_Int
d_C__case_55 x4 x3 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_C_length x3 cd cs) (Curry_Prelude.C_Int (2)) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.C_Int (0)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_55 x4 x3 l cd cs)
    (d_C__case_55 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_55 x4
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_55 x4 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_55" [show x4, show x3, show x5] info)
  _ -> failCons cd (consFail "Text.Markdown._case_55" (showCons x5))

d_C__case_54 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C__case_54 x8 x7 x9 x4 x1 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 x9 cd cs) (Curry_Prelude.d_C_length x7 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.C_Int (0)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_54 x8 x7 x9 x4 x1
    l cd cs) (d_C__case_54 x8 x7 x9 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_54 x8
    x7 x9 x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_54 x8 x7
    x9 x4 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_54" [show x8, show x7, show x9, show x4, show x1, show
    x10] info)
  _ -> failCons cd (consFail "Text.Markdown._case_54" (showCons x10))

d_C__case_53 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_C__case_53 x5 x4 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> x5
  Curry_Prelude.C_False -> Curry_Prelude.C_Int (0)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_53 x5 x4 l cd cs)
    (d_C__case_53 x5 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_53 x5
    x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_53 x5 x4 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_53" [show x5, show x4, show x6] info)
  _ -> failCons cd (consFail "Text.Markdown._case_53" (showCons x6))

d_C__case_52 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_52 x6 x7 x2 x5 x4 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (C_SMDPar
    (d_C_groupMarkDownElems (d_C_outsideMarkdownElem Curry_Prelude.OP_List x1 cd
    cs) cd cs)) (d_C_markdownText x2 cd cs)
  Curry_Prelude.C_False -> d_C__case_51 x5 x4 x1 (Curry_Prelude.d_C_null x5 cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_52 x6 x7 x2 x5 x4
    x1 l cd cs) (d_C__case_52 x6 x7 x2 x5 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_52 x6
    x7 x2 x5 x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_52 x6 x7
    x2 x5 x4 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_52" [show x6, show x7, show x2, show x5, show x4, show
    x1, show x8] info)
  _ -> failCons cd (consFail "Text.Markdown._case_52" (showCons x8))

d_C__case_51 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_51 x5 x4 x1 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (C_SMDPar
    (d_C_groupMarkDownElems (d_C_outsideMarkdownElem Curry_Prelude.OP_List
    (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '\n'#) x4) cd cs) cd cs) cd cs)) Curry_Prelude.OP_List
  Curry_Prelude.C_False -> d_C__case_50 x5 x4 x1 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_51 x5 x4 x1 l cd
    cs) (d_C__case_51 x5 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_51 x5
    x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_51 x5 x4
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_51" [show x5, show x4, show x1, show x6] info)
  _ -> failCons cd (consFail "Text.Markdown._case_51" (showCons x6))

d_C__case_50 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_50 x5 x4 x1 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_markdownPar (Curry_Prelude.d_OP_plus_plus x1
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '\n'#) x4) cd cs)
    (Curry_Prelude.d_C_tail x5 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_50 x5 x4 x1 l cd
    cs) (d_C__case_50 x5 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_50 x5
    x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_50 x5 x4
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_50" [show x5, show x4, show x1, show x6] info)
  _ -> failCons cd (consFail "Text.Markdown._case_50" (showCons x6))

d_C__case_47 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_47 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "> ") (Curry_Prelude.d_C_drop
    (Curry_Prelude.C_Int (1)) x2 cd cs) cd cs
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_47 x2 l cd cs)
    (d_C__case_47 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_47 x2 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_47 x2 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_47" [show x2, show x3] info)
  _ -> failCons cd (consFail "Text.Markdown._case_47" (showCons x3))

d_C__case_49 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_49 x3 x1 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> let x4 = Curry_Prelude.d_C_apply
                                (Curry_Prelude.d_C_break (Curry_Prelude.d_C_flip
                                (acceptCs id
                                Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                (Curry_Prelude.C_Char '\n'#)) cd cs)
                                (Curry_Prelude.d_C_drop (Curry_Prelude.C_Int
                                (2)) x3 cd cs) cd cs
                              x5 = d_OP_markdownQuote_dot_uscore_hash_selFP29_hash_fstline
                                x4 cd cs
                              x6 = d_OP_markdownQuote_dot_uscore_hash_selFP30_hash_remtxt
                                x4 cd cs
    in d_C__case_48 x6 x5 x1 (Curry_Prelude.d_C_null x6 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (C_SMDQuote
    (Curry_Prelude.d_C_apply (d_C_fromMarkdownText cd cs) x1 cd cs))
    (d_C_markdownText x3 cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_49 x3 x1 l cd cs)
    (d_C__case_49 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_49 x3
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_49 x3 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_49" [show x3, show x1, show x7] info)
  _ -> failCons cd (consFail "Text.Markdown._case_49" (showCons x7))

d_C__case_48 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_48 x6 x5 x1 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (C_SMDQuote
    (Curry_Prelude.d_C_apply (d_C_fromMarkdownText cd cs)
    (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '\n'#) x5) cd cs) cd cs)) Curry_Prelude.OP_List
  Curry_Prelude.C_False -> d_C_markdownQuote (Curry_Prelude.d_OP_plus_plus x1
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '\n'#) x5) cd cs)
    (Curry_Prelude.d_C_tail x6 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_48 x6 x5 x1 l cd
    cs) (d_C__case_48 x6 x5 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_48 x6
    x5 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_48 x6 x5
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_48" [show x6, show x5, show x1, show x7] info)
  _ -> failCons cd (consFail "Text.Markdown._case_48" (showCons x7))

d_C__case_46 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_SourceMDElem
d_C__case_46 x3 x1 x2 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> let x4 = Curry_Prelude.d_C_apply
                                (Curry_Prelude.d_C_break (Curry_Prelude.d_C_flip
                                (acceptCs id
                                Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                (Curry_Prelude.C_Char '\n'#)) cd cs)
                                (Curry_Prelude.d_C_drop x1 x3 cd cs) cd cs
                              x5 = d_OP_markdownCodeBlock_dot_uscore_hash_selFP32_hash_fstline
                                x4 cd cs
                              x6 = d_OP_markdownCodeBlock_dot_uscore_hash_selFP33_hash_remtxt
                                x4 cd cs
    in d_C__case_45 x6 x5 x2 x1 (Curry_Prelude.d_C_null x6 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (C_SMDCodeBlock x2)
    (d_C_markdownText x3 cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_46 x3 x1 x2 l cd
    cs) (d_C__case_46 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_46 x3
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_46 x3 x1
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_46" [show x3, show x1, show x2, show x7] info)
  _ -> failCons cd (consFail "Text.Markdown._case_46" (showCons x7))

d_C__case_45 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_45 x6 x5 x2 x1 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (C_SMDCodeBlock
    (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '\n'#) x5) cd cs)) Curry_Prelude.OP_List
  Curry_Prelude.C_False -> d_C_markdownCodeBlock x1
    (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '\n'#) x5) cd cs) (Curry_Prelude.d_C_tail x6 cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_45 x6 x5 x2 x1 l
    cd cs) (d_C__case_45 x6 x5 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_45 x6
    x5 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_45 x6 x5
    x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_45" [show x6, show x5, show x2, show x1, show x7] info)
  _ -> failCons cd (consFail "Text.Markdown._case_45" (showCons x7))

d_C__case_44 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> C_SourceMDElem) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_44 x2 x4 x3 x1 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> let x5 = Curry_Prelude.d_C_apply
                                (Curry_Prelude.d_C_break (Curry_Prelude.d_C_flip
                                (acceptCs id
                                Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                (Curry_Prelude.C_Char '\n'#)) cd cs)
                                (Curry_Prelude.d_C_drop x2 x4 cd cs) cd cs
                              x6 = d_OP_markdownItem_dot_uscore_hash_selFP35_hash_fstline
                                x5 cd cs
                              x7 = d_OP_markdownItem_dot_uscore_hash_selFP36_hash_remtxt
                                x5 cd cs
    in d_C__case_43 x7 x6 x3 x2 x1 (Curry_Prelude.d_C_null x7 cd cs) cd cs
  Curry_Prelude.C_False -> let x8 = Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_break
                                 (Curry_Prelude.d_C_flip (acceptCs id
                                 Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                 (Curry_Prelude.C_Char '\n'#)) cd cs) x4 cd cs
                               x9 = d_OP_markdownItem_dot_uscore_hash_selFP38_hash_fstline
                                 x8 cd cs
                               x10 = d_OP_markdownItem_dot_uscore_hash_selFP39_hash_remtxt
                                 x8 cd cs
    in d_C__case_42 x9 x4 x3 x1 x10 x2 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_all Curry_Prelude.d_C_isSpace cd cs) x9 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_44 x2 x4 x3 x1 l
    cd cs) (d_C__case_44 x2 x4 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_44 x2
    x4 x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_44 x2 x4
    x3 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_44" [show x2, show x4, show x3, show x1, show x11]
    info)
  _ -> failCons cd (consFail "Text.Markdown._case_44" (showCons x11))

nd_C__case_44 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) C_SourceMDElem
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
nd_C__case_44 x2 x4 x3 x1 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` (let x5 = let s1 = leftSupply s2
                                        s0 = rightSupply s2
                                 in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
                                 (Curry_Prelude.nd_C_break (wrapNX id
                                 (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id)
                                 (acceptCs id
                                 Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
                                 (Curry_Prelude.C_Char '\n'#))) s0 cd cs)
                                 (Curry_Prelude.d_C_drop x2 x4 cd cs) s1 cd cs)
                               x6 = d_OP_markdownItem_dot_uscore_hash_selFP35_hash_fstline
                                 x5 cd cs
                               x7 = d_OP_markdownItem_dot_uscore_hash_selFP36_hash_remtxt
                                 x5 cd cs
    in nd_C__case_43 x7 x6 x3 x2 x1 (Curry_Prelude.d_C_null x7 cd cs) s3 cd
    cs)))
  Curry_Prelude.C_False -> let s8 = s
    in s8 `seq` (let s2 = leftSupply s8
                     s7 = rightSupply s8
    in s2 `seq` (s7 `seq` (let x8 = let s1 = leftSupply s2
                                        s0 = rightSupply s2
                                 in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
                                 (Curry_Prelude.nd_C_break (wrapNX id
                                 (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id)
                                 (acceptCs id
                                 Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash))
                                 (Curry_Prelude.C_Char '\n'#))) s0 cd cs) x4 s1
                                 cd cs)
                               x9 = d_OP_markdownItem_dot_uscore_hash_selFP38_hash_fstline
                                 x8 cd cs
                               x10 = d_OP_markdownItem_dot_uscore_hash_selFP39_hash_remtxt
                                 x8 cd cs
    in let s6 = leftSupply s7
           s5 = rightSupply s7
    in s6 `seq` (s5 `seq` nd_C__case_42 x9 x4 x3 x1 x10 x2 (let s4 = leftSupply
                                                                  s5
                                                                s3 = rightSupply
                                                                  s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_all
    (wrapDX id Curry_Prelude.d_C_isSpace) s3 cd cs) x9 s4 cd cs)) s6 cd cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_44 x2 x4 x3 x1 l
    s cd cs) (nd_C__case_44 x2 x4 x3 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_44 x2
    x4 x3 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_44 x2 x4
    x3 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_44" [show x2, show x4, show x3, show x1, show x11]
    info)
  _ -> failCons cd (consFail "Text.Markdown._case_44" (showCons x11))

d_C__case_42 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> C_SourceMDElem) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_42 x9 x4 x3 x1 x10 x2 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> d_C__case_41 x10 x3 x2 x1 (Curry_Prelude.d_C_null x10
    cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply x1 x3
    cd cs) (d_C_markdownText x4 cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_42 x9 x4 x3 x1
    x10 x2 l cd cs) (d_C__case_42 x9 x4 x3 x1 x10 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_42 x9
    x4 x3 x1 x10 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_42 x9 x4
    x3 x1 x10 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_42" [show x9, show x4, show x3, show x1, show x10, show
    x2, show x11] info)
  _ -> failCons cd (consFail "Text.Markdown._case_42" (showCons x11))

nd_C__case_42 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  C_SourceMDElem -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_SourceMDElem
nd_C__case_42 x9 x4 x3 x1 x10 x2 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C__case_41 x10 x3 x2 x1 (Curry_Prelude.d_C_null x10 cd cs) s0
    cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs)
    (d_C_markdownText x4 cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_42 x9 x4 x3 x1
    x10 x2 l s cd cs) (nd_C__case_42 x9 x4 x3 x1 x10 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_42 x9
    x4 x3 x1 x10 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_42 x9 x4
    x3 x1 x10 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_42" [show x9, show x4, show x3, show x1, show x10, show
    x2, show x11] info)
  _ -> failCons cd (consFail "Text.Markdown._case_42" (showCons x11))

d_C__case_41 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> C_SourceMDElem) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_41 x10 x3 x2 x1 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply x1 x3
    cd cs) Curry_Prelude.OP_List
  Curry_Prelude.C_False -> d_C_markdownItem x1 x2 (Curry_Prelude.d_OP_plus_plus
    x3 (Curry_Prelude.toCurryString "\n") cd cs) (Curry_Prelude.d_C_tail x10 cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_41 x10 x3 x2 x1 l
    cd cs) (d_C__case_41 x10 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_41 x10
    x3 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_41 x10 x3
    x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_41" [show x10, show x3, show x2, show x1, show x11]
    info)
  _ -> failCons cd (consFail "Text.Markdown._case_41" (showCons x11))

nd_C__case_41 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) C_SourceMDElem
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
nd_C__case_41 x10 x3 x2 x1 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs)
    Curry_Prelude.OP_List
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C_markdownItem x1 x2 (Curry_Prelude.d_OP_plus_plus x3
    (Curry_Prelude.toCurryString "\n") cd cs) (Curry_Prelude.d_C_tail x10 cd cs)
    s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_41 x10 x3 x2 x1
    l s cd cs) (nd_C__case_41 x10 x3 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_41 x10
    x3 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_41 x10 x3
    x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_41" [show x10, show x3, show x2, show x1, show x11]
    info)
  _ -> failCons cd (consFail "Text.Markdown._case_41" (showCons x11))

d_C__case_43 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> C_SourceMDElem)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_SourceMDElem
d_C__case_43 x7 x6 x3 x2 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply x1
    (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '\n'#) x6) cd cs) cd cs) Curry_Prelude.OP_List
  Curry_Prelude.C_False -> d_C_markdownItem x1 x2 (Curry_Prelude.d_OP_plus_plus
    x3 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '\n'#) x6) cd cs)
    (Curry_Prelude.d_C_tail x7 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_43 x7 x6 x3 x2 x1
    l cd cs) (d_C__case_43 x7 x6 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_43 x7
    x6 x3 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_43 x7 x6
    x3 x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_43" [show x7, show x6, show x3, show x2, show x1, show
    x8] info)
  _ -> failCons cd (consFail "Text.Markdown._case_43" (showCons x8))

nd_C__case_43 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) C_SourceMDElem -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List C_SourceMDElem
nd_C__case_43 x7 x6 x3 x2 x1 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons (Curry_Prelude.nd_C_apply x1
    (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '\n'#) x6) cd cs) s0 cd cs) Curry_Prelude.OP_List
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C_markdownItem x1 x2 (Curry_Prelude.d_OP_plus_plus x3
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '\n'#) x6) cd cs)
    (Curry_Prelude.d_C_tail x7 cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_43 x7 x6 x3 x2
    x1 l s cd cs) (nd_C__case_43 x7 x6 x3 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_43 x7
    x6 x3 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_43 x7 x6
    x3 x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_43" [show x7, show x6, show x3, show x2, show x1, show
    x8] info)
  _ -> failCons cd (consFail "Text.Markdown._case_43" (showCons x8))

d_C__case_40 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_40 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> d_C__case_39 x2 x3 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons x2 (d_C_removeEscapes x3 cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_40 x2 x3 l cd cs)
    (d_C__case_40 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_40 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_40 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_40" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Text.Markdown._case_40" (showCons x4))

d_C__case_39 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_39 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_38 x4 x5 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_elem
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x4 cd cs) (d_C_markdownEscapeChars cd cs) cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons x2 (d_C_removeEscapes x3 cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_39 x2 l cd cs)
    (d_C__case_39 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_39 x2
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_39 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.Markdown._case_39" [show x2, show x3] info)
  _ -> failCons cd (consFail "Text.Markdown._case_39" (showCons x3))

d_C__case_38 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_38 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x4 (d_C_removeEscapes x5 cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '\\'#)
    (d_C_removeEscapes (Curry_Prelude.OP_Cons x4 x5) cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_38 x4 x5 l cd cs)
    (d_C__case_38 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_38 x4
    x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_38 x4 x5 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_38" [show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "Text.Markdown._case_38" (showCons x6))

d_C__case_37 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_SourceMDElem
d_C__case_37 x3 x4 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> d_C__case_36 x1 x3 x4 cd cs
  Curry_Prelude.C_False -> d_C__case_34 x3 x4 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.C_Char '*'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_37 x3 x4 x1 l cd
    cs) (d_C__case_37 x3 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_37 x3
    x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_37 x3 x4
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_37" [show x3, show x4, show x1, show x5] info)
  _ -> failCons cd (consFail "Text.Markdown._case_37" (showCons x5))

d_C__case_34 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_SourceMDElem
d_C__case_34 x3 x4 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> d_C__case_33 x1 x4 cd cs
  Curry_Prelude.C_False -> d_C__case_31 x3 x4 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.C_Char '_'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_34 x3 x4 x1 l cd
    cs) (d_C__case_34 x3 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_34 x3
    x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_34 x3 x4
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_34" [show x3, show x4, show x1, show x5] info)
  _ -> failCons cd (consFail "Text.Markdown._case_34" (showCons x5))

d_C__case_31 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_SourceMDElem
d_C__case_31 x3 x4 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> d_C__case_30 x1 x4 cd cs
  Curry_Prelude.C_False -> d_C__case_28 x3 x4 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.C_Char '`'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_31 x3 x4 x1 l cd
    cs) (d_C__case_31 x3 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_31 x3
    x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_31 x3 x4
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_31" [show x3, show x4, show x1, show x5] info)
  _ -> failCons cd (consFail "Text.Markdown._case_31" (showCons x5))

d_C__case_28 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_SourceMDElem
d_C__case_28 x3 x4 x1 x14 cd cs = case x14 of
  Curry_Prelude.C_True -> let x11 = Curry_Prelude.d_C_span
                                (Curry_Prelude.d_C_flip (acceptCs id
                                Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                (Curry_Prelude.C_Char '`'#)) x4 cd cs
                              x12 = d_OP_outsideMarkdownElem_dot_uscore_hash_selFP41_hash_ticks
                                x11 cd cs
                              x13 = d_OP_outsideMarkdownElem_dot_uscore_hash_selFP42_hash_cs_tick
                                x11 cd cs
    in Curry_Prelude.d_OP_dollar (d_C_addPrevious x1) (d_C_insideMarkdownElem
    (Curry_Prelude.d_C_replicate
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_C_length x12 cd cs) (Curry_Prelude.C_Int (1)) cd cs)
    (Curry_Prelude.C_Char '`'#) cd cs) Curry_Prelude.OP_List x13 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_27 x3 x4 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.C_Char '['#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_28 x3 x4 x1 l cd
    cs) (d_C__case_28 x3 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_28 x3
    x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_28 x3 x4
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_28" [show x3, show x4, show x1, show x14] info)
  _ -> failCons cd (consFail "Text.Markdown._case_28" (showCons x14))

d_C__case_27 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_SourceMDElem
d_C__case_27 x3 x4 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar (d_C_addPrevious x1)
    (d_C_tryParseLink x4 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_26 x3 x4 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.C_Char '<'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_27 x3 x4 x1 l cd
    cs) (d_C__case_27 x3 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_27 x3
    x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_27 x3 x4
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_27" [show x3, show x4, show x1, show x5] info)
  _ -> failCons cd (consFail "Text.Markdown._case_27" (showCons x5))

d_C__case_26 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_SourceMDElem
d_C__case_26 x3 x4 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar (d_C_addPrevious x1)
    (d_C_markdownHRef x4 cd cs) cd cs
  Curry_Prelude.C_False -> d_C_outsideMarkdownElem (Curry_Prelude.OP_Cons x3 x1)
    x4 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_26 x3 x4 x1 l cd
    cs) (d_C__case_26 x3 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_26 x3
    x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_26 x3 x4
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_26" [show x3, show x4, show x1, show x5] info)
  _ -> failCons cd (consFail "Text.Markdown._case_26" (showCons x5))

d_C__case_30 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_30 x1 x4 cd cs = case x4 of
  Curry_Prelude.OP_Cons x9 x10 -> d_C__case_29 x9 x4 x1 x10
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x9 (Curry_Prelude.C_Char '_'#) cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_dollar (d_C_addPrevious x1)
    (d_C_insideMarkdownElem (Curry_Prelude.toCurryString "_")
    Curry_Prelude.OP_List x4 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_30 x1 l cd cs)
    (d_C__case_30 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_30 x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_30 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.Markdown._case_30" [show x1, show x4] info)
  _ -> failCons cd (consFail "Text.Markdown._case_30" (showCons x4))

d_C__case_29 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_29 x9 x4 x1 x10 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar (d_C_addPrevious x1)
    (d_C_insideMarkdownElem (Curry_Prelude.toCurryString "__")
    Curry_Prelude.OP_List x10 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar (d_C_addPrevious x1)
    (d_C_insideMarkdownElem (Curry_Prelude.toCurryString "_")
    Curry_Prelude.OP_List x4 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_29 x9 x4 x1 x10 l
    cd cs) (d_C__case_29 x9 x4 x1 x10 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_29 x9
    x4 x1 x10 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_29 x9 x4
    x1 x10 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_29" [show x9, show x4, show x1, show x10, show x11]
    info)
  _ -> failCons cd (consFail "Text.Markdown._case_29" (showCons x11))

d_C__case_33 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_33 x1 x4 cd cs = case x4 of
  Curry_Prelude.OP_Cons x7 x8 -> d_C__case_32 x7 x4 x1 x8
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x7 (Curry_Prelude.C_Char '*'#) cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_dollar (d_C_addPrevious x1)
    (d_C_insideMarkdownElem (Curry_Prelude.toCurryString "*")
    Curry_Prelude.OP_List x4 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_33 x1 l cd cs)
    (d_C__case_33 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_33 x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_33 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.Markdown._case_33" [show x1, show x4] info)
  _ -> failCons cd (consFail "Text.Markdown._case_33" (showCons x4))

d_C__case_32 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_32 x7 x4 x1 x8 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar (d_C_addPrevious x1)
    (d_C_insideMarkdownElem (Curry_Prelude.toCurryString "**")
    Curry_Prelude.OP_List x8 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar (d_C_addPrevious x1)
    (d_C_insideMarkdownElem (Curry_Prelude.toCurryString "*")
    Curry_Prelude.OP_List x4 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_32 x7 x4 x1 x8 l
    cd cs) (d_C__case_32 x7 x4 x1 x8 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_32 x7
    x4 x1 x8 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_32 x7 x4
    x1 x8 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_32" [show x7, show x4, show x1, show x8, show x9] info)
  _ -> failCons cd (consFail "Text.Markdown._case_32" (showCons x9))

d_C__case_36 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_36 x1 x3 x4 cd cs = case x4 of
  Curry_Prelude.OP_Cons x5 x6 -> d_C__case_35 x5 x6 x1 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_elem
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x5 cd cs) (d_C_markdownEscapeChars cd cs) cd cs) cd cs
  Curry_Prelude.OP_List -> d_C_outsideMarkdownElem (Curry_Prelude.OP_Cons x3 x1)
    x4 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_36 x1 x3 l cd
    cs) (d_C__case_36 x1 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_36 x1
    x3 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_36 x1 x3
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.Markdown._case_36" [show x1, show x3, show x4] info)
  _ -> failCons cd (consFail "Text.Markdown._case_36" (showCons x4))

d_C__case_35 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_SourceMDElem
d_C__case_35 x5 x6 x1 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> d_C_outsideMarkdownElem (Curry_Prelude.OP_Cons x5
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '\\'#) x1)) x6 cd cs
  Curry_Prelude.C_False -> d_C_outsideMarkdownElem (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '\\'#) x1) (Curry_Prelude.OP_Cons x5 x6) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_35 x5 x6 x1 l cd
    cs) (d_C__case_35 x5 x6 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_35 x5
    x6 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_35 x5 x6
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_35" [show x5, show x6, show x1, show x7] info)
  _ -> failCons cd (consFail "Text.Markdown._case_35" (showCons x7))

d_C__case_25 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_SourceMDElem -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_25 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> x2
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (C_SMDText
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_reverse cd cs) x1 cd cs)) x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_25 x1 x2 l cd cs)
    (d_C__case_25 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_25 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_25 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_25" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Text.Markdown._case_25" (showCons x3))

d_C__case_24 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_24 x4 x3 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_C_outsideMarkdownElem (Curry_Prelude.toCurryString
    "[") x1 cd cs
  Curry_Prelude.C_False -> let x5 = Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_break
                                 (Curry_Prelude.d_C_flip (acceptCs id
                                 Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                 (Curry_Prelude.C_Char ')'#)) cd cs)
                                 (Curry_Prelude.d_C_drop (Curry_Prelude.C_Int
                                 (2)) x4 cd cs) cd cs
                               x6 = d_OP_tryParseLink_dot_uscore_hash_selFP45_hash_url
                                 x5 cd cs
                               x7 = d_OP_tryParseLink_dot_uscore_hash_selFP46_hash_mtxt
                                 x5 cd cs
    in d_C__case_23 x7 x6 x3 x1 (Curry_Prelude.d_C_null x7 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_24 x4 x3 x1 l cd
    cs) (d_C__case_24 x4 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_24 x4
    x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_24 x4 x3
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_24" [show x4, show x3, show x1, show x8] info)
  _ -> failCons cd (consFail "Text.Markdown._case_24" (showCons x8))

d_C__case_23 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_SourceMDElem
d_C__case_23 x7 x6 x3 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_C_outsideMarkdownElem (Curry_Prelude.toCurryString
    "[") x1 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (C_SMDHRef x3 x6)
    (d_C_outsideMarkdownElem Curry_Prelude.OP_List (Curry_Prelude.d_C_tail x7 cd
    cs) cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_23 x7 x6 x3 x1 l
    cd cs) (d_C__case_23 x7 x6 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_23 x7
    x6 x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_23 x7 x6
    x3 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_23" [show x7, show x6, show x3, show x1, show x8] info)
  _ -> failCons cd (consFail "Text.Markdown._case_23" (showCons x8))

d_C__case_22 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_22 x4 x3 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> d_C_outsideMarkdownElem (Curry_Prelude.toCurryString
    "<") x1 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (C_SMDHRef x3 x3)
    (d_C_outsideMarkdownElem Curry_Prelude.OP_List (d_C_dropFirst x4 cd cs) cd
    cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_22 x4 x3 x1 l cd
    cs) (d_C__case_22 x4 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_22 x4
    x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_22 x4 x3
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_22" [show x4, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "Text.Markdown._case_22" (showCons x5))

d_C__case_21 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_21 x3 x1 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (d_C_text2MDElem x1
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_reverse cd cs) x2 cd cs) cd cs)
    (d_C_outsideMarkdownElem Curry_Prelude.OP_List (Curry_Prelude.d_C_drop
    (Curry_Prelude.d_C_length x1 cd cs) x3 cd cs) cd cs)
  Curry_Prelude.C_False -> d_C__case_20 x2 x1 x3 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_21 x3 x1 x2 l cd
    cs) (d_C__case_21 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_21 x3
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_21 x3 x1
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_21" [show x3, show x1, show x2, show x4] info)
  _ -> failCons cd (consFail "Text.Markdown._case_21" (showCons x4))

d_C__case_20 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  C_SourceMDElem
d_C__case_20 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons (C_SMDText
    (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_reverse cd cs) x2 cd cs) cd cs)) Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_19 x4 x5 x2 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x4 (Curry_Prelude.C_Char '\\'#) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_20 x2 x1 l cd
    cs) (d_C__case_20 x2 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_20 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_20 x2 x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.Markdown._case_20" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "Text.Markdown._case_20" (showCons x3))

d_C__case_19 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_19 x4 x5 x2 x1 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C__case_18 x2 x4 x1 x5 cd cs
  Curry_Prelude.C_False -> d_C_insideMarkdownElem x1 (Curry_Prelude.OP_Cons x4
    x2) x5 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_19 x4 x5 x2 x1 l
    cd cs) (d_C__case_19 x4 x5 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_19 x4
    x5 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_19 x4 x5
    x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_19" [show x4, show x5, show x2, show x1, show x6] info)
  _ -> failCons cd (consFail "Text.Markdown._case_19" (showCons x6))

d_C__case_18 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_18 x2 x4 x1 x5 cd cs = case x5 of
  Curry_Prelude.OP_Cons x6 x7 -> d_C__case_17 x6 x7 x2 x1
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x6 cd cs) (d_C_markdownEscapeChars cd cs) cd cs) cd cs
  Curry_Prelude.OP_List -> d_C_insideMarkdownElem x1 (Curry_Prelude.OP_Cons x4
    x2) x5 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_18 x2 x4 x1 l cd
    cs) (d_C__case_18 x2 x4 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_18 x2
    x4 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_18 x2 x4
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.Markdown._case_18" [show x2, show x4, show x1, show x5] info)
  _ -> failCons cd (consFail "Text.Markdown._case_18" (showCons x5))

d_C__case_17 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List C_SourceMDElem
d_C__case_17 x6 x7 x2 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_C_insideMarkdownElem x1 (Curry_Prelude.OP_Cons x6
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '\\'#) x2)) x7 cd cs
  Curry_Prelude.C_False -> d_C_insideMarkdownElem x1 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '\\'#) x2) (Curry_Prelude.OP_Cons x6 x7) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_17 x6 x7 x2 x1 l
    cd cs) (d_C__case_17 x6 x7 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_17 x6
    x7 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_17 x6 x7
    x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_17" [show x6, show x7, show x2, show x1, show x8] info)
  _ -> failCons cd (consFail "Text.Markdown._case_17" (showCons x8))

d_C__case_16 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_SourceMDElem
d_C__case_16 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> C_SMDStrong x2
  Curry_Prelude.C_False -> d_C__case_15 x1 x2 (Curry_Prelude.d_C_eqString x1
    (Curry_Prelude.toCurryString "__") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_16 x1 x2 l cd cs)
    (d_C__case_16 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_16 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_16 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_16" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Text.Markdown._case_16" (showCons x3))

d_C__case_15 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_SourceMDElem
d_C__case_15 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> C_SMDStrong x2
  Curry_Prelude.C_False -> d_C__case_14 x1 x2 (Curry_Prelude.d_C_eqString x1
    (Curry_Prelude.toCurryString "*") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_15 x1 x2 l cd cs)
    (d_C__case_15 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_15 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_15 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_15" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Text.Markdown._case_15" (showCons x3))

d_C__case_14 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_SourceMDElem
d_C__case_14 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> C_SMDEmph x2
  Curry_Prelude.C_False -> d_C__case_13 x1 x2 (Curry_Prelude.d_C_eqString x1
    (Curry_Prelude.toCurryString "_") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_14 x1 x2 l cd cs)
    (d_C__case_14 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_14 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_14 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_14" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Text.Markdown._case_14" (showCons x3))

d_C__case_13 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_SourceMDElem
d_C__case_13 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> C_SMDEmph x2
  Curry_Prelude.C_False -> d_C__case_12 x1 x2 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_all (Curry_Prelude.d_C_flip (acceptCs id
    Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.C_Char '`'#)) cd cs) x1 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_13 x1 x2 l cd cs)
    (d_C__case_13 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_13 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_13 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_13" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Text.Markdown._case_13" (showCons x3))

d_C__case_12 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_SourceMDElem
d_C__case_12 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> C_SMDCode x2
  Curry_Prelude.C_False -> d_C__case_11 x1 (Curry_Prelude.d_C_otherwise cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_12 x1 x2 l cd cs)
    (d_C__case_12 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_12 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_12 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_12" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Text.Markdown._case_12" (showCons x3))

d_C__case_11 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_SourceMDElem
d_C__case_11 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_error
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "Markdown.text2MDElem: unknown marker \"") (Curry_Prelude.d_OP_plus_plus x1
    (Curry_Prelude.toCurryString "\"") cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_11 x1 l cd cs)
    (d_C__case_11 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_11 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_11 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_11" [show x1, show x2] info)
  _ -> failCons cd (consFail "Text.Markdown._case_11" (showCons x2))

d_C__case_10 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> t0
d_C__case_10 x7 x6 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1
    x7 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (HTML.Curry_Base.d_C_code x1 cd cs) (Curry_Prelude.OP_Cons
    (Curry_Prelude.d_C_apply (d_C_mdtxt2html x1 cd cs) x6 cd cs)
    Curry_Prelude.OP_List) cd cs) Curry_Prelude.OP_List) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply (HTML.Curry_Base.d_C_href x1
    x7 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (d_C_mdtxt2html x1
    cd cs) x6 cd cs) Curry_Prelude.OP_List) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_10 x7 x6 x1 l cd
    cs) (d_C__case_10 x7 x6 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_10 x7
    x6 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_10 x7 x6
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_10" [show x7, show x6, show x1, show x8] info)
  _ -> failCons cd (consFail "Text.Markdown._case_10" (showCons x8))

nd_C__case_10 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> t0
nd_C__case_10 x7 x6 x1 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s0 = leftSupply s10
                     s6 = rightSupply s10
    in s8 `seq` (s10 `seq` (s0 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_href x1 x7 s0 cd cs) (Curry_Prelude.OP_Cons
    (let s5 = leftSupply s6
         s7 = rightSupply s6
         s1 = leftSupply s7
         s4 = rightSupply s7
    in s5 `seq` (s7 `seq` (s1 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_code x1 s1 cd cs) (Curry_Prelude.OP_Cons
    (let s3 = leftSupply s4
         s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (nd_C_mdtxt2html x1 s2 cd cs)
    x6 s3 cd cs)) Curry_Prelude.OP_List) s5 cd cs)))) Curry_Prelude.OP_List) s8
    cd cs))))
  Curry_Prelude.C_False -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (HTML.Curry_Base.nd_C_href x1 x7 s0 cd cs) (Curry_Prelude.OP_Cons
    (let s2 = leftSupply s3
         s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (nd_C_mdtxt2html x1 s1 cd cs)
    x6 s2 cd cs)) Curry_Prelude.OP_List) s4 cd cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_10 x7 x6 x1 l s
    cd cs) (nd_C__case_10 x7 x6 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_10 x7
    x6 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_10 x7 x6
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_10" [show x7, show x6, show x1, show x8] info)
  _ -> failCons cd (consFail "Text.Markdown._case_10" (showCons x8))

d_C__case_7 :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> C_MarkdownElem -> Curry_Prelude.OP_List C_MarkdownElem -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_7 x1 x3 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons (d_C_mdElem2html x1 x3 cd cs)
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x6 x7 -> Curry_Prelude.OP_Cons (d_C_mdElem2html x1 x3 cd
    cs) (d_C_mdDoc2htmlWithoutPar x1 (Curry_Prelude.OP_Cons x6 x7) cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_7 x1 x3 l cd cs)
    (d_C__case_7 x1 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_7 x1
    x3 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_7 x1 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.Markdown._case_7" [show x1, show x3, show x4] info)
  _ -> failCons cd (consFail "Text.Markdown._case_7" (showCons x4))

nd_C__case_7 :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> C_MarkdownElem -> Curry_Prelude.OP_List C_MarkdownElem -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
nd_C__case_7 x1 x3 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons (nd_C_mdElem2html x1 x3 s0 cd cs)
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x6 x7 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.OP_Cons (nd_C_mdElem2html x1 x3 s0 cd
    cs) (nd_C_mdDoc2htmlWithoutPar x1 (Curry_Prelude.OP_Cons x6 x7) s1 cd cs)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_7 x1 x3 l s cd
    cs) (nd_C__case_7 x1 x3 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_7 x1
    x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_7 x1 x3
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.Markdown._case_7" [show x1, show x3, show x4] info)
  _ -> failCons cd (consFail "Text.Markdown._case_7" (showCons x4))

d_C__case_9 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List C_MarkdownElem -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> C_MarkdownElem -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_9 x5 x4 x1 x3 cd cs = case x3 of
  C_Par x8 -> d_C__case_8 x1 x8 x4 cd cs
  C_Text x11 -> x5
  C_Emph x12 -> x5
  C_Strong x13 -> x5
  C_Code x14 -> x5
  C_HRef x15 x16 -> x5
  C_CodeBlock x17 -> x5
  C_UList x18 -> x5
  C_OList x19 -> x5
  C_Quote x20 -> x5
  C_HRule -> x5
  C_Header x21 x22 -> x5
  Choice_C_MarkdownElem d i l r -> narrow d i (d_C__case_9 x5 x4 x1 l cd cs)
    (d_C__case_9 x5 x4 x1 r cd cs)
  Choices_C_MarkdownElem d i xs -> narrows cs d i (\z -> d_C__case_9 x5 x4 x1 z
    cd cs) xs
  Guard_C_MarkdownElem d c e -> guardCons d c ((\x -> d_C__case_9 x5 x4 x1 e cd
    x) $! addCs c cs)
  Fail_C_MarkdownElem d info -> failCons d (traceFail "Text.Markdown._case_9"
    [show x5, show x4, show x1, show x3] info)
  _ -> failCons cd (consFail "Text.Markdown._case_9" (showCons x3))

nd_C__case_9 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List C_MarkdownElem -> Func Curry_Prelude.OP_Unit
  (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0) -> C_MarkdownElem -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C__case_9 x5 x4 x1 x3 s cd cs = case x3 of
  C_Par x8 -> let s0 = s in s0 `seq` nd_C__case_8 x1 x8 x4 s0 cd cs
  C_Text x11 -> x5
  C_Emph x12 -> x5
  C_Strong x13 -> x5
  C_Code x14 -> x5
  C_HRef x15 x16 -> x5
  C_CodeBlock x17 -> x5
  C_UList x18 -> x5
  C_OList x19 -> x5
  C_Quote x20 -> x5
  C_HRule -> x5
  C_Header x21 x22 -> x5
  Choice_C_MarkdownElem d i l r -> narrow d i (nd_C__case_9 x5 x4 x1 l s cd cs)
    (nd_C__case_9 x5 x4 x1 r s cd cs)
  Choices_C_MarkdownElem d i xs -> narrows cs d i (\z -> nd_C__case_9 x5 x4 x1 z
    s cd cs) xs
  Guard_C_MarkdownElem d c e -> guardCons d c ((\x -> nd_C__case_9 x5 x4 x1 e s
    cd x) $! addCs c cs)
  Fail_C_MarkdownElem d info -> failCons d (traceFail "Text.Markdown._case_9"
    [show x5, show x4, show x1, show x3] info)
  _ -> failCons cd (consFail "Text.Markdown._case_9" (showCons x3))

d_C__case_8 :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List C_MarkdownElem -> Curry_Prelude.OP_List
  C_MarkdownElem -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_8 x1 x8 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_apply (d_C_mdDoc2html x1 cd cs) x8
    cd cs
  Curry_Prelude.OP_Cons x9 x10 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply (d_C_mdDoc2html x1 cd cs) x8 cd cs)
    (Curry_Prelude.OP_Cons (HTML.Curry_Base.d_C_breakline x1 cd cs)
    (d_C_mdDoc2htmlWithoutPar x1 (Curry_Prelude.OP_Cons x9 x10) cd cs)) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_8 x1 x8 l cd cs)
    (d_C__case_8 x1 x8 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_8 x1
    x8 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_8 x1 x8 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.Markdown._case_8" [show x1, show x8, show x4] info)
  _ -> failCons cd (consFail "Text.Markdown._case_8" (showCons x4))

nd_C__case_8 :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (HTML.Curry_Base.OP_uscore_Dict_hash_HTML t0)
  -> Curry_Prelude.OP_List C_MarkdownElem -> Curry_Prelude.OP_List
  C_MarkdownElem -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_C__case_8 x1 x8 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_mdDoc2html x1 s0 cd cs)
    x8 s1 cd cs))
  Curry_Prelude.OP_Cons x9 x10 -> let s6 = s
    in s6 `seq` (let s2 = leftSupply s6
                     s5 = rightSupply s6
    in s2 `seq` (s5 `seq` Curry_Prelude.d_OP_plus_plus (let s1 = leftSupply s2
                                                            s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_mdDoc2html x1 s0 cd cs)
    x8 s1 cd cs)) (let s3 = leftSupply s5
                       s4 = rightSupply s5
    in s3 `seq` (s4 `seq` Curry_Prelude.OP_Cons (HTML.Curry_Base.nd_C_breakline
    x1 s3 cd cs) (nd_C_mdDoc2htmlWithoutPar x1 (Curry_Prelude.OP_Cons x9 x10) s4
    cd cs))) cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_8 x1 x8 l s cd
    cs) (nd_C__case_8 x1 x8 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_8 x1
    x8 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_8 x1 x8
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Text.Markdown._case_8" [show x1, show x8, show x4] info)
  _ -> failCons cd (consFail "Text.Markdown._case_8" (showCons x4))

d_C__case_5 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_5 x14 x15 x1 x16 cd cs = case x16 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\section{") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply x1 x15 cd cs) (Curry_Prelude.toCurryString "}\n\n")
    cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_4 x14 x15 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x14 (Curry_Prelude.C_Int (2)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x14 x15 x1 l cd
    cs) (d_C__case_5 x14 x15 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x14
    x15 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x14 x15
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_5" [show x14, show x15, show x1, show x16] info)
  _ -> failCons cd (consFail "Text.Markdown._case_5" (showCons x16))

nd_C__case_5 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_5 x14 x15 x1 x16 s cd cs = case x16 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\section{") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_apply x1 x15
    s0 cd cs) (Curry_Prelude.toCurryString "}\n\n") cd cs) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_4 x14 x15 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x14 (Curry_Prelude.C_Int (2)) cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_5 x14 x15 x1 l s
    cd cs) (nd_C__case_5 x14 x15 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_5 x14
    x15 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_5 x14 x15
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_5" [show x14, show x15, show x1, show x16] info)
  _ -> failCons cd (consFail "Text.Markdown._case_5" (showCons x16))

d_C__case_4 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_4 x14 x15 x1 x16 cd cs = case x16 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\subsection{") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply x1 x15 cd cs) (Curry_Prelude.toCurryString "}\n\n")
    cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_3 x14 x15 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x14 (Curry_Prelude.C_Int (3)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x14 x15 x1 l cd
    cs) (d_C__case_4 x14 x15 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x14
    x15 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x14 x15
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_4" [show x14, show x15, show x1, show x16] info)
  _ -> failCons cd (consFail "Text.Markdown._case_4" (showCons x16))

nd_C__case_4 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_4 x14 x15 x1 x16 s cd cs = case x16 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\subsection{") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_apply x1
    x15 s0 cd cs) (Curry_Prelude.toCurryString "}\n\n") cd cs) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_3 x14 x15 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x14 (Curry_Prelude.C_Int (3)) cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_4 x14 x15 x1 l s
    cd cs) (nd_C__case_4 x14 x15 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_4 x14
    x15 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_4 x14 x15
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_4" [show x14, show x15, show x1, show x16] info)
  _ -> failCons cd (consFail "Text.Markdown._case_4" (showCons x16))

d_C__case_3 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_3 x14 x15 x1 x16 cd cs = case x16 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\subsubsection{")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply x1 x15 cd cs)
    (Curry_Prelude.toCurryString "}\n\n") cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_2 x14 x15 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x14 (Curry_Prelude.C_Int (4)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x14 x15 x1 l cd
    cs) (d_C__case_3 x14 x15 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x14
    x15 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x14 x15
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_3" [show x14, show x15, show x1, show x16] info)
  _ -> failCons cd (consFail "Text.Markdown._case_3" (showCons x16))

nd_C__case_3 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_3 x14 x15 x1 x16 s cd cs = case x16 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\subsubsection{") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_apply
    x1 x15 s0 cd cs) (Curry_Prelude.toCurryString "}\n\n") cd cs) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_2 x14 x15 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x14 (Curry_Prelude.C_Int (4)) cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_3 x14 x15 x1 l s
    cd cs) (nd_C__case_3 x14 x15 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_3 x14
    x15 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_3 x14 x15
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_3" [show x14, show x15, show x1, show x16] info)
  _ -> failCons cd (consFail "Text.Markdown._case_3" (showCons x16))

d_C__case_2 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_2 x14 x15 x1 x16 cd cs = case x16 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\paragraph{") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply x1 x15 cd cs) (Curry_Prelude.toCurryString "}\n\n")
    cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_1 x14 x15 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x14 (Curry_Prelude.C_Int (5)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x14 x15 x1 l cd
    cs) (d_C__case_2 x14 x15 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x14
    x15 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x14 x15
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_2" [show x14, show x15, show x1, show x16] info)
  _ -> failCons cd (consFail "Text.Markdown._case_2" (showCons x16))

nd_C__case_2 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_2 x14 x15 x1 x16 s cd cs = case x16 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\paragraph{") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_apply x1
    x15 s0 cd cs) (Curry_Prelude.toCurryString "}\n\n") cd cs) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_1 x14 x15 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x14 (Curry_Prelude.C_Int (5)) cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_2 x14 x15 x1 l s
    cd cs) (nd_C__case_2 x14 x15 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_2 x14
    x15 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_2 x14 x15
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_2" [show x14, show x15, show x1, show x16] info)
  _ -> failCons cd (consFail "Text.Markdown._case_2" (showCons x16))

d_C__case_1 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_1 x14 x15 x1 x16 cd cs = case x16 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\textbf{") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply x1 x15 cd cs) (Curry_Prelude.toCurryString "}\n\n")
    cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\emph{") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply x1 x15 cd cs) (Curry_Prelude.toCurryString "}\n\n")
    cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x14 x15 x1 l cd
    cs) (d_C__case_1 x14 x15 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x14
    x15 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x14 x15
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_1" [show x14, show x15, show x1, show x16] info)
  _ -> failCons cd (consFail "Text.Markdown._case_1" (showCons x16))

nd_C__case_1 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_1 x14 x15 x1 x16 s cd cs = case x16 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\textbf{") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_apply x1 x15
    s0 cd cs) (Curry_Prelude.toCurryString "}\n\n") cd cs) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\emph{") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_apply x1 x15 s0
    cd cs) (Curry_Prelude.toCurryString "}\n\n") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_1 x14 x15 x1 l s
    cd cs) (nd_C__case_1 x14 x15 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_1 x14
    x15 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_1 x14 x15
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_1" [show x14, show x15, show x1, show x16] info)
  _ -> failCons cd (consFail "Text.Markdown._case_1" (showCons x16))

d_C__case_6 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_6 x7 x6 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\url{") (Curry_Prelude.d_OP_plus_plus x7
    (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\href{") (Curry_Prelude.d_OP_plus_plus x7
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "}{")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply x1 x6 cd cs)
    (Curry_Prelude.toCurryString "}") cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x7 x6 x1 l cd
    cs) (d_C__case_6 x7 x6 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x7 x6
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x7 x6 x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_6" [show x7, show x6, show x1, show x8] info)
  _ -> failCons cd (consFail "Text.Markdown._case_6" (showCons x8))

nd_C__case_6 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_6 x7 x6 x1 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\\url{") (Curry_Prelude.d_OP_plus_plus x7
    (Curry_Prelude.toCurryString "}") cd cs) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "\\href{") (Curry_Prelude.d_OP_plus_plus x7 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "}{") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.nd_C_apply x1 x6 s0 cd cs) (Curry_Prelude.toCurryString "}")
    cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_6 x7 x6 x1 l s
    cd cs) (nd_C__case_6 x7 x6 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_6 x7
    x6 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_6 x7 x6
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_6" [show x7, show x6, show x1, show x8] info)
  _ -> failCons cd (consFail "Text.Markdown._case_6" (showCons x8))

d_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Int
d_C__case_0 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Curry_Prelude.d_OP_dollar System.Curry_Process.d_C_system
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "evince ") x3 cd
    cs) cd cs) cd cs) (Curry_Prelude.d_OP_dollar System.Curry_Process.d_C_system
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "/bin/rm -f ") x3
    cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar
    System.Curry_Process.d_C_system (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "/bin/mv -f ") (Curry_Prelude.d_OP_plus_plus x3
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ") x2 cd cs) cd
    cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x2 x3 l cd cs)
    (d_C__case_0 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x2 x3
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Text.Markdown._case_0" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Text.Markdown._case_0" (showCons x4))

