{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module CurryDoc.Curry_Read
  ( C_SourceLine (..)
  , C_Category (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_SourceLine_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_SourceLine_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_SourceLine_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_Category_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_Category_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_Category_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
  , d_OP_uscore_impl_hash_compare_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
  , d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
  , d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
  , d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
  , d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
  , d_OP_uscore_impl_hash_min_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
  , d_OP_uscore_impl_hash_max_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
  , d_C_readModuleComment
  , d_C_readComments
  , d_C_readCategory
  , d_C_showCategory
  , d_C_getCategoryID
  , d_C_classifyLine
  , d_C_getFirstId
  , d_C_isIdChar
  , d_C_infixIDs
  , d_C_groupLines
  , d_C_groupProgLines
  , d_C_groupComment
  , d_C_skipFuncDefs
  , d_C_skipDataDefs
  , d_C_getFuncComment
  , d_C_getConsComment
  , d_C_getDataComment
  , d_C_getCommentType
  , nd_C_getCommentType
  , d_C_splitComment
  , d_C_splitCommentMain
  , d_C_splitCommentParams
  , d_C_isFunctionType
  , d_C_skipWhiteSpace
  , d_C_isWhiteSpace
  , d_C_showId
  , d_C_brackets
  , d_C_getLastName )
  where

import Basics
import qualified Data.Curry_List
import qualified FlatCurry.Curry_Types
import qualified Curry_Prelude
import qualified System.Curry_IO


data C_SourceLine
  = C_Comment (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_FuncDef (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_DataDef (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_ModDef
  | C_OtherLine
  | Choice_C_SourceLine Cover ID C_SourceLine C_SourceLine
  | Choices_C_SourceLine Cover ID [C_SourceLine]
  | Fail_C_SourceLine Cover FailInfo
  | Guard_C_SourceLine Cover Constraints C_SourceLine

instance Show C_SourceLine where
  showsPrec d (Choice_C_SourceLine cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_SourceLine cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_SourceLine cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_SourceLine cd info) = showChar '!'
  showsPrec _ (C_Comment x1) = showString "(Comment" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_FuncDef x1) = showString "(FuncDef" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_DataDef x1) = showString "(DataDef" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ C_ModDef = showString "ModDef"
  showsPrec _ C_OtherLine = showString "OtherLine"

instance Read C_SourceLine where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Comment x1, r1) | (_, r0) <-
    readQualified "CurryDoc.Read" "Comment" r, (x1, r1) <- readsPrec 11 r0])
    s ++ (readParen ((>) d 10) (\r -> [(C_FuncDef x1, r1) | (_, r0) <-
    readQualified "CurryDoc.Read" "FuncDef" r, (x1, r1) <- readsPrec 11 r0])
    s ++ (readParen ((>) d 10) (\r -> [(C_DataDef x1, r1) | (_, r0) <-
    readQualified "CurryDoc.Read" "DataDef" r, (x1, r1) <- readsPrec 11 r0])
    s ++ (readParen False (\r -> [(C_ModDef, r0) | (_, r0) <- readQualified
    "CurryDoc.Read" "ModDef" r]) s ++ readParen False (\r -> [(C_OtherLine
    , r0) | (_, r0) <- readQualified "CurryDoc.Read" "OtherLine" r]) s)))

instance NonDet C_SourceLine where
  choiceCons = Choice_C_SourceLine
  choicesCons = Choices_C_SourceLine
  failCons = Fail_C_SourceLine
  guardCons = Guard_C_SourceLine
  try (Choice_C_SourceLine cd i x y) = tryChoice cd i x y
  try (Choices_C_SourceLine cd i xs) = tryChoices cd i xs
  try (Fail_C_SourceLine cd info) = Fail cd info
  try (Guard_C_SourceLine cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_SourceLine cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_SourceLine cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_SourceLine cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_SourceLine cd i _) = error
    ("CurryDoc.Read.SourceLine.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_SourceLine cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_SourceLine cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_SourceLine where
  generate s c = Choices_C_SourceLine c (freeID [1, 1, 1, 0, 0] s) [C_Comment
    (generate (leftSupply s) c), C_FuncDef (generate (leftSupply s) c)
    , C_DataDef (generate (leftSupply s) c), C_ModDef, C_OtherLine]

instance NormalForm C_SourceLine where
  ($!!) cont (C_Comment x1) d cs = ($!!) (\y1 d cs -> cont (C_Comment y1) d cs)
    x1 d cs
  ($!!) cont (C_FuncDef x1) d cs = ($!!) (\y1 d cs -> cont (C_FuncDef y1) d cs)
    x1 d cs
  ($!!) cont (C_DataDef x1) d cs = ($!!) (\y1 d cs -> cont (C_DataDef y1) d cs)
    x1 d cs
  ($!!) cont C_ModDef d cs = cont C_ModDef d cs
  ($!!) cont C_OtherLine d cs = cont C_OtherLine d cs
  ($!!) cont (Choice_C_SourceLine cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_SourceLine cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_SourceLine cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_SourceLine cd info) _ _ = failCons cd info
  ($##) cont (C_Comment x1) d cs = ($##) (\y1 d cs -> cont (C_Comment y1) d cs)
    x1 d cs
  ($##) cont (C_FuncDef x1) d cs = ($##) (\y1 d cs -> cont (C_FuncDef y1) d cs)
    x1 d cs
  ($##) cont (C_DataDef x1) d cs = ($##) (\y1 d cs -> cont (C_DataDef y1) d cs)
    x1 d cs
  ($##) cont C_ModDef d cs = cont C_ModDef d cs
  ($##) cont C_OtherLine d cs = cont C_OtherLine d cs
  ($##) cont (Choice_C_SourceLine cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_SourceLine cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_SourceLine cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_SourceLine cd info) _ _ = failCons cd info
  showCons (C_Comment _) = "CurryDoc.Read.Comment _"
  showCons (C_FuncDef _) = "CurryDoc.Read.FuncDef _"
  showCons (C_DataDef _) = "CurryDoc.Read.DataDef _"
  showCons C_ModDef = "CurryDoc.Read.ModDef"
  showCons C_OtherLine = "CurryDoc.Read.OtherLine"
  showCons x = error ("CurryDoc.Read.SourceLine.showCons: no constructor: " ++
    show x)
  searchNF search cont (C_Comment x1) = search (\y1 -> cont (C_Comment y1)) x1
  searchNF search cont (C_FuncDef x1) = search (\y1 -> cont (C_FuncDef y1)) x1
  searchNF search cont (C_DataDef x1) = search (\y1 -> cont (C_DataDef y1)) x1
  searchNF _ cont C_ModDef = cont C_ModDef
  searchNF _ cont C_OtherLine = cont C_OtherLine
  searchNF _ _ x = error
    ("CurryDoc.Read.SourceLine.searchNF: no constructor: " ++ show x)

instance Unifiable C_SourceLine where
  (=.=) (C_Comment x1) (C_Comment y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_FuncDef x1) (C_FuncDef y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_DataDef x1) (C_DataDef y1) d cs = (=:=) x1 y1 d cs
  (=.=) C_ModDef C_ModDef d cs = C_True
  (=.=) C_OtherLine C_OtherLine d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Comment x1) (C_Comment y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_FuncDef x1) (C_FuncDef y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_DataDef x1) (C_DataDef y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) C_ModDef C_ModDef d cs = C_True
  (=.<=) C_OtherLine C_OtherLine d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Comment x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_FuncDef x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_DataDef x3) = (i :=: ChooseN 2 1) : concat [bind cd (leftID i)
    x3]
  bind cd i C_ModDef = (i :=: ChooseN 3 0) : concat []
  bind cd i C_OtherLine = (i :=: ChooseN 4 0) : concat []
  bind d i (Choice_C_SourceLine cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_SourceLine cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j
    xs
  bind d i (Choices_C_SourceLine cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_SourceLine cd i _) = error
    ("CurryDoc.Read.SourceLine.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_SourceLine cd info) = [Unsolvable info]
  bind d i (Guard_C_SourceLine cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Comment x3) = (i :=: ChooseN 0 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_FuncDef x3) = (i :=: ChooseN 1 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_DataDef x3) = (i :=: ChooseN 2 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i C_ModDef = (i :=: ChooseN 3 0) : []
  lazyBind cd i C_OtherLine = (i :=: ChooseN 4 0) : []
  lazyBind d i (Choice_C_SourceLine cd j x y) = [ConstraintChoice cd j (lazyBind
    d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_SourceLine cd j@(FreeID _ _) xs) = lazyBindOrNarrow d
    i cd j xs
  lazyBind d i (Choices_C_SourceLine cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_SourceLine cd i _) = error
    ("CurryDoc.Read.SourceLine.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_SourceLine cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_SourceLine cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_SourceLine where

data C_Category
  = C_General
  | C_Algorithm
  | C_Database
  | C_Web
  | C_Meta
  | Choice_C_Category Cover ID C_Category C_Category
  | Choices_C_Category Cover ID [C_Category]
  | Fail_C_Category Cover FailInfo
  | Guard_C_Category Cover Constraints C_Category

instance Show C_Category where
  showsPrec d (Choice_C_Category cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Category cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Category cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Category cd info) = showChar '!'
  showsPrec _ C_General = showString "General"
  showsPrec _ C_Algorithm = showString "Algorithm"
  showsPrec _ C_Database = showString "Database"
  showsPrec _ C_Web = showString "Web"
  showsPrec _ C_Meta = showString "Meta"

instance Read C_Category where
  readsPrec _ s = readParen False (\r -> [(C_General, r0) | (_, r0) <-
    readQualified "CurryDoc.Read" "General" r]) s ++ (readParen False (\r ->
    [(C_Algorithm, r0) | (_, r0) <- readQualified "CurryDoc.Read" "Algorithm"
    r]) s ++ (readParen False (\r -> [(C_Database, r0) | (_, r0) <-
    readQualified "CurryDoc.Read" "Database" r]) s ++ (readParen False (\r ->
    [(C_Web, r0) | (_, r0) <- readQualified "CurryDoc.Read" "Web" r]) s ++
    readParen False (\r -> [(C_Meta, r0) | (_, r0) <- readQualified
    "CurryDoc.Read" "Meta" r]) s)))

instance NonDet C_Category where
  choiceCons = Choice_C_Category
  choicesCons = Choices_C_Category
  failCons = Fail_C_Category
  guardCons = Guard_C_Category
  try (Choice_C_Category cd i x y) = tryChoice cd i x y
  try (Choices_C_Category cd i xs) = tryChoices cd i xs
  try (Fail_C_Category cd info) = Fail cd info
  try (Guard_C_Category cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Category cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Category cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Category cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Category cd i _) = error
    ("CurryDoc.Read.Category.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Category cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Category cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Category where
  generate s c = Choices_C_Category c (freeID [0, 0, 0, 0, 0] s) [C_General
    , C_Algorithm, C_Database, C_Web, C_Meta]

instance NormalForm C_Category where
  ($!!) cont C_General d cs = cont C_General d cs
  ($!!) cont C_Algorithm d cs = cont C_Algorithm d cs
  ($!!) cont C_Database d cs = cont C_Database d cs
  ($!!) cont C_Web d cs = cont C_Web d cs
  ($!!) cont C_Meta d cs = cont C_Meta d cs
  ($!!) cont (Choice_C_Category cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Category cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Category cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_Category cd info) _ _ = failCons cd info
  ($##) cont C_General d cs = cont C_General d cs
  ($##) cont C_Algorithm d cs = cont C_Algorithm d cs
  ($##) cont C_Database d cs = cont C_Database d cs
  ($##) cont C_Web d cs = cont C_Web d cs
  ($##) cont C_Meta d cs = cont C_Meta d cs
  ($##) cont (Choice_C_Category cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Category cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Category cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_Category cd info) _ _ = failCons cd info
  showCons C_General = "CurryDoc.Read.General"
  showCons C_Algorithm = "CurryDoc.Read.Algorithm"
  showCons C_Database = "CurryDoc.Read.Database"
  showCons C_Web = "CurryDoc.Read.Web"
  showCons C_Meta = "CurryDoc.Read.Meta"
  showCons x = error ("CurryDoc.Read.Category.showCons: no constructor: " ++
    show x)
  searchNF _ cont C_General = cont C_General
  searchNF _ cont C_Algorithm = cont C_Algorithm
  searchNF _ cont C_Database = cont C_Database
  searchNF _ cont C_Web = cont C_Web
  searchNF _ cont C_Meta = cont C_Meta
  searchNF _ _ x = error ("CurryDoc.Read.Category.searchNF: no constructor: " ++
    show x)

instance Unifiable C_Category where
  (=.=) C_General C_General d cs = C_True
  (=.=) C_Algorithm C_Algorithm d cs = C_True
  (=.=) C_Database C_Database d cs = C_True
  (=.=) C_Web C_Web d cs = C_True
  (=.=) C_Meta C_Meta d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_General C_General d cs = C_True
  (=.<=) C_Algorithm C_Algorithm d cs = C_True
  (=.<=) C_Database C_Database d cs = C_True
  (=.<=) C_Web C_Web d cs = C_True
  (=.<=) C_Meta C_Meta d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_General = (i :=: ChooseN 0 0) : concat []
  bind cd i C_Algorithm = (i :=: ChooseN 1 0) : concat []
  bind cd i C_Database = (i :=: ChooseN 2 0) : concat []
  bind cd i C_Web = (i :=: ChooseN 3 0) : concat []
  bind cd i C_Meta = (i :=: ChooseN 4 0) : concat []
  bind d i (Choice_C_Category cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_Category cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Category cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_Category cd i _) = error
    ("CurryDoc.Read.Category.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Category cd info) = [Unsolvable info]
  bind d i (Guard_C_Category cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_General = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_Algorithm = (i :=: ChooseN 1 0) : []
  lazyBind cd i C_Database = (i :=: ChooseN 2 0) : []
  lazyBind cd i C_Web = (i :=: ChooseN 3 0) : []
  lazyBind cd i C_Meta = (i :=: ChooseN 4 0) : []
  lazyBind d i (Choice_C_Category cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Category cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_Category cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Category cd i _) = error
    ("CurryDoc.Read.Category.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Category cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Category cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Category where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_SourceLine_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_SourceLine
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_SourceLine_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_SourceLine_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CurryDoc.Read._inst#Prelude.Data#CurryDoc.Read.SourceLine#" [show x1] info)
  _ -> failCons cd (consFail
    "CurryDoc.Read._inst#Prelude.Data#CurryDoc.Read.SourceLine#" (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_SourceLine_hash :: C_SourceLine
  -> C_SourceLine -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_SourceLine_hash x1 x2 s cd cs =
  case x1 of
  C_Comment x3 -> let s0 = s in s0 `seq` nd_C__case_62 x3 x2 s0 cd cs
  C_FuncDef x7 -> let s0 = s in s0 `seq` nd_C__case_61 x7 x2 s0 cd cs
  C_DataDef x11 -> let s0 = s in s0 `seq` nd_C__case_60 x11 x2 s0 cd cs
  C_ModDef -> d_C__case_59 x2 cd cs
  C_OtherLine -> d_C__case_58 x2 cd cs
  Choice_C_SourceLine d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    r x2 s cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    z x2 s cd cs) xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail
    "CurryDoc.Read._impl#===#Prelude.Data#CurryDoc.Read.SourceLine#" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "CurryDoc.Read._impl#===#Prelude.Data#CurryDoc.Read.SourceLine#" (showCons
    x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_SourceLine_hash :: IDSupply
  -> Cover -> ConstStore -> C_SourceLine
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_SourceLine_hash s cd cs =
  let s12 = s
  in s12 `seq` (let s11 = leftSupply s12
                    s10 = rightSupply s12
  in s11 `seq` (s10 `seq` choice (let s9 = leftSupply s10
                                      s7 = rightSupply s10
  in s9 `seq` (s7 `seq` choice (let s6 = leftSupply s7
                                    s8 = rightSupply s7
                                    s3 = leftSupply s8
                                    s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` choice (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` choice (C_Comment
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)) (C_FuncDef
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s1 cd cs)) s2 cd cs)))) (C_DataDef
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s5 cd cs)) s6 cd cs)))) C_ModDef s9 cd cs)) C_OtherLine s11 cd cs))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_Category_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Category
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_Category_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_Category_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_Category_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_Category_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_Category_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_Category_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_Category_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CurryDoc.Read._inst#Prelude.Data#CurryDoc.Read.Category#" [show x1] info)
  _ -> failCons cd (consFail
    "CurryDoc.Read._inst#Prelude.Data#CurryDoc.Read.Category#" (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_Category_hash :: C_Category
  -> C_Category -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_Category_hash x1 x2 cd cs =
  case x1 of
  C_General -> d_C__case_57 x2 cd cs
  C_Algorithm -> d_C__case_56 x2 cd cs
  C_Database -> d_C__case_55 x2 cd cs
  C_Web -> d_C__case_54 x2 cd cs
  C_Meta -> d_C__case_53 x2 cd cs
  Choice_C_Category d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_Category_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_Category_hash
    r x2 cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_Category_hash
    z x2 cd cs) xs
  Guard_C_Category d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_Category_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Category d info -> failCons d (traceFail
    "CurryDoc.Read._impl#===#Prelude.Data#CurryDoc.Read.Category#" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "CurryDoc.Read._impl#===#Prelude.Data#CurryDoc.Read.Category#" (showCons
    x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_Category_hash :: IDSupply
  -> Cover -> ConstStore -> C_Category
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CurryDoc_dot_Read_dot_Category_hash s cd cs =
  let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s4 = rightSupply s6
  in s5 `seq` (s4 `seq` choice (let s3 = leftSupply s4
                                    s2 = rightSupply s4
  in s3 `seq` (s2 `seq` choice (let s1 = leftSupply s2
                                    s0 = rightSupply s2
  in s1 `seq` (s0 `seq` choice (choice C_General C_Algorithm s0 cd cs)
  C_Database s1 cd cs)) C_Web s3 cd cs)) C_Meta s5 cd cs))

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_SourceLine
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CurryDoc.Read._inst#Prelude.Eq#CurryDoc.Read.SourceLine#" [show x1] info)
  _ -> failCons cd (consFail
    "CurryDoc.Read._inst#Prelude.Eq#CurryDoc.Read.SourceLine#" (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_SourceLine
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CurryDoc.Read._inst#Prelude.Eq#CurryDoc.Read.SourceLine#" [show x1] info)
  _ -> failCons cd (consFail
    "CurryDoc.Read._inst#Prelude.Eq#CurryDoc.Read.SourceLine#" (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash :: C_SourceLine
  -> C_SourceLine -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash x1 x2 cd cs =
  case x1 of
  C_Comment x3 -> d_C__case_52 x3 x2 cd cs
  C_FuncDef x7 -> d_C__case_51 x7 x2 cd cs
  C_DataDef x11 -> d_C__case_50 x11 x2 cd cs
  C_ModDef -> d_C__case_49 x2 cd cs
  C_OtherLine -> d_C__case_48 x2 cd cs
  Choice_C_SourceLine d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    r x2 cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    z x2 cd cs) xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail
    "CurryDoc.Read._impl#==#Prelude.Eq#CurryDoc.Read.SourceLine#" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "CurryDoc.Read._impl#==#Prelude.Eq#CurryDoc.Read.SourceLine#" (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash :: Cover
  -> ConstStore -> C_SourceLine -> Cover -> ConstStore -> C_SourceLine -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash)

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_Category
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CurryDoc.Read._inst#Prelude.Eq#CurryDoc.Read.Category#" [show x1] info)
  _ -> failCons cd (consFail
    "CurryDoc.Read._inst#Prelude.Eq#CurryDoc.Read.Category#" (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_Category
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CurryDoc.Read._inst#Prelude.Eq#CurryDoc.Read.Category#" [show x1] info)
  _ -> failCons cd (consFail
    "CurryDoc.Read._inst#Prelude.Eq#CurryDoc.Read.Category#" (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash :: C_Category
  -> C_Category -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash x1 x2 cd cs =
  case x1 of
  C_General -> d_C__case_47 x2 cd cs
  C_Algorithm -> d_C__case_46 x2 cd cs
  C_Database -> d_C__case_45 x2 cd cs
  C_Web -> d_C__case_44 x2 cd cs
  C_Meta -> d_C__case_43 x2 cd cs
  Choice_C_Category d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash
    r x2 cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash
    z x2 cd cs) xs
  Guard_C_Category d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Category d info -> failCons d (traceFail
    "CurryDoc.Read._impl#==#Prelude.Eq#CurryDoc.Read.Category#" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "CurryDoc.Read._impl#==#Prelude.Eq#CurryDoc.Read.Category#" (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash :: Cover
  -> ConstStore -> C_Category -> Cover -> ConstStore -> C_Category -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash)

d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord C_Category
d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Ord
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash
    (d_OP_uscore_impl_hash_compare_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    cd cs)
    (d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    cd cs)
    (d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    cd cs) (acceptCs id
    d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash)
    (d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    cd cs)
    (d_OP_uscore_impl_hash_min_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    cd cs)
    (d_OP_uscore_impl_hash_max_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CurryDoc.Read._inst#Prelude.Ord#CurryDoc.Read.Category#" [show x1] info)
  _ -> failCons cd (consFail
    "CurryDoc.Read._inst#Prelude.Ord#CurryDoc.Read.Category#" (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord
  C_Category
nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Ord (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_Category_hash)
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_compare_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    cd cs)) (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    cd cs)) (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    cd cs)) (wrapDX (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    cd cs)) (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_min_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    cd cs)) (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_max_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CurryDoc.Read._inst#Prelude.Ord#CurryDoc.Read.Category#" [show x1] info)
  _ -> failCons cd (consFail
    "CurryDoc.Read._inst#Prelude.Ord#CurryDoc.Read.Category#" (showCons x1))

d_OP_uscore_impl_hash_compare_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash :: Cover
  -> ConstStore -> C_Category -> Cover -> ConstStore -> C_Category -> Cover
  -> ConstStore -> Curry_Prelude.C_Ordering
d_OP_uscore_impl_hash_compare_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_compare_hash_Prelude_dot_Ord
  d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash)

d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash :: Cover
  -> ConstStore -> C_Category -> Cover -> ConstStore -> C_Category -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_lt_hash_Prelude_dot_Ord
  d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash)

d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash :: Cover
  -> ConstStore -> C_Category -> Cover -> ConstStore -> C_Category -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_gt_hash_Prelude_dot_Ord
  d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash)

d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash :: C_Category
  -> C_Category -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash x1 x2 cd cs =
  case x1 of
  C_General -> d_C__case_42 x2 cd cs
  C_Algorithm -> d_C__case_41 x2 cd cs
  C_Database -> d_C__case_40 x2 cd cs
  C_Web -> d_C__case_39 x2 cd cs
  C_Meta -> d_C__case_38 x2 cd cs
  Choice_C_Category d i l r -> narrow d i
    (d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    r x2 cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    z x2 cd cs) xs
  Guard_C_Category d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Category d info -> failCons d (traceFail
    "CurryDoc.Read._impl#<=#Prelude.Ord#CurryDoc.Read.Category#" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "CurryDoc.Read._impl#<=#Prelude.Ord#CurryDoc.Read.Category#" (showCons x1))

d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash :: Cover
  -> ConstStore -> C_Category -> Cover -> ConstStore -> C_Category -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_gt_eq_hash_Prelude_dot_Ord
  d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash)

d_OP_uscore_impl_hash_min_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash :: Cover
  -> ConstStore -> C_Category -> Cover -> ConstStore -> C_Category -> Cover
  -> ConstStore -> C_Category
d_OP_uscore_impl_hash_min_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_min_hash_Prelude_dot_Ord
  d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash)

d_OP_uscore_impl_hash_max_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash :: Cover
  -> ConstStore -> C_Category -> Cover -> ConstStore -> C_Category -> Cover
  -> ConstStore -> C_Category
d_OP_uscore_impl_hash_max_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_max_hash_Prelude_dot_Ord
  d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_CurryDoc_dot_Read_dot_Category_hash)

d_C_readModuleComment :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C_readModuleComment x1 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_IO.d_C_openFile x1 System.Curry_IO.C_ReadMode cd cs) cd
  cs) (d_OP_readModuleComment_dot_readHeader_dot_2 Curry_Prelude.OP_List) cd cs

d_OP_readModuleComment_dot_readHeader_dot_2 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> System.Curry_IO.C_Handle
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_readModuleComment_dot_readHeader_dot_2 x1 x2 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (System.Curry_IO.d_C_hIsEOF x2 cd cs) cd cs)
  (d_OP_readModuleComment_dot_readHeader_dot_2_dot_uscore_hash_lambda2 x2 x1) cd
  cs

d_OP_readModuleComment_dot_readHeader_dot_2_dot_uscore_hash_lambda2 :: System.Curry_IO.C_Handle
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_readModuleComment_dot_readHeader_dot_2_dot_uscore_hash_lambda2 x1 x2 x3 cd cs =
  case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_IO.d_C_hClose x1 cd cs) cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) Curry_Prelude.OP_List cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_IO.d_C_hGetLine x1 cd cs) cd cs)
    (d_OP_readModuleComment_dot_readHeader_dot_2_dot_uscore_hash_lambda2_dot_uscore_hash_lambda5
    x1 x2) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (d_OP_readModuleComment_dot_readHeader_dot_2_dot_uscore_hash_lambda2 x1 x2 l
    cd cs) (d_OP_readModuleComment_dot_readHeader_dot_2_dot_uscore_hash_lambda2
    x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_OP_readModuleComment_dot_readHeader_dot_2_dot_uscore_hash_lambda2 x1 x2 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x ->
    d_OP_readModuleComment_dot_readHeader_dot_2_dot_uscore_hash_lambda2 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read.readModuleComment.readHeader.2._#lambda2" [show x1, show x2
    , show x3] info)
  _ -> failCons cd (consFail
    "CurryDoc.Read.readModuleComment.readHeader.2._#lambda2" (showCons x3))

d_OP_readModuleComment_dot_readHeader_dot_2_dot_uscore_hash_lambda2_dot_uscore_hash_lambda5 :: System.Curry_IO.C_Handle
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_readModuleComment_dot_readHeader_dot_2_dot_uscore_hash_lambda2_dot_uscore_hash_lambda5 x1 x2 x3 cd cs =
  let x4 = x3 in d_C__case_37 x4 x1 x2 (d_C_classifyLine x4 cd cs) cd cs

d_C_readComments :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_SourceLine (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))))
d_C_readComments x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_readFile x1 cd cs) cd cs)
  d_OP_readComments_dot_uscore_hash_lambda9 cd cs

d_OP_readComments_dot_uscore_hash_lambda9 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_SourceLine
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
d_OP_readComments_dot_uscore_hash_lambda9 x1 cd cs = let x2 = x1
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_OP_dot d_C_groupLines
  (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_filter (Curry_Prelude.d_C_flip
  (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
  cd cs) C_OtherLine)) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_map
  d_C_classifyLine) Curry_Prelude.d_C_lines cd cs) cd cs) cd cs) x2 cd cs) cd cs

d_C_readCategory :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> C_Category
d_C_readCategory x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> C_General
  Curry_Prelude.OP_Cons x2 x3 -> let x4 = Curry_Prelude.d_C_span d_C_isIdChar x2
                                       cd cs
                                     x5 = d_OP_readCategory_dot_uscore_hash_selFP2_hash_cat
                                       x4 cd cs
    in d_C__case_36 x5 (Curry_Prelude.d_C_eqString x5
    (Curry_Prelude.toCurryString "general") cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_readCategory l cd cs)
    (d_C_readCategory r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_readCategory
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_readCategory e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CurryDoc.Read.readCategory" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Read.readCategory" (showCons x1))

d_OP_readCategory_dot_uscore_hash_selFP2_hash_cat :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_readCategory_dot_uscore_hash_selFP2_hash_cat x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_readCategory_dot_uscore_hash_selFP2_hash_cat l cd cs)
    (d_OP_readCategory_dot_uscore_hash_selFP2_hash_cat r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_readCategory_dot_uscore_hash_selFP2_hash_cat z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_readCategory_dot_uscore_hash_selFP2_hash_cat e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CurryDoc.Read.readCategory._#selFP2#cat" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Read.readCategory._#selFP2#cat" (showCons
    x1))

d_C_showCategory :: C_Category -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_showCategory x1 cd cs = case x1 of
  C_General -> Curry_Prelude.toCurryString "General libraries"
  C_Algorithm -> Curry_Prelude.toCurryString "Data structures and algorithms"
  C_Database -> Curry_Prelude.toCurryString "Database access and manipulation"
  C_Web -> Curry_Prelude.toCurryString "Libraries for web applications"
  C_Meta -> Curry_Prelude.toCurryString "Libraries for meta-programming"
  Choice_C_Category d i l r -> narrow d i (d_C_showCategory l cd cs)
    (d_C_showCategory r cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z -> d_C_showCategory z cd cs)
    xs
  Guard_C_Category d c e -> guardCons d c ((\x -> d_C_showCategory e cd x) $!
    addCs c cs)
  Fail_C_Category d info -> failCons d (traceFail "CurryDoc.Read.showCategory"
    [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Read.showCategory" (showCons x1))

d_C_getCategoryID :: C_Category -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_getCategoryID x1 cd cs = case x1 of
  C_General -> Curry_Prelude.toCurryString "general"
  C_Algorithm -> Curry_Prelude.toCurryString "algorithm"
  C_Database -> Curry_Prelude.toCurryString "database"
  C_Web -> Curry_Prelude.toCurryString "web"
  C_Meta -> Curry_Prelude.toCurryString "meta"
  Choice_C_Category d i l r -> narrow d i (d_C_getCategoryID l cd cs)
    (d_C_getCategoryID r cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z -> d_C_getCategoryID z cd cs)
    xs
  Guard_C_Category d c e -> guardCons d c ((\x -> d_C_getCategoryID e cd x) $!
    addCs c cs)
  Fail_C_Category d info -> failCons d (traceFail "CurryDoc.Read.getCategoryID"
    [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Read.getCategoryID" (showCons x1))

d_C_classifyLine :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> C_SourceLine
d_C_classifyLine x1 cd cs = let x2 = Curry_Prelude.d_OP_dot
                                  (Curry_Prelude.d_C_takeWhile d_C_isIdChar)
                                  (Curry_Prelude.d_OP_dot
                                  (Curry_Prelude.d_C_dropWhile
                                  (Curry_Prelude.d_C_flip (acceptCs id
                                  Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                  (Curry_Prelude.C_Char ' '#)))
                                  (Curry_Prelude.d_C_dropWhile d_C_isIdChar) cd
                                  cs) cd cs
  in d_C__case_31 x1 x2 (Curry_Prelude.d_OP_amp_amp
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (3)) x1 cd cs)
  (Curry_Prelude.toCurryString "---") cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_all Curry_Prelude.d_C_isSpace cd cs)
  (Curry_Prelude.d_C_drop (Curry_Prelude.C_Int (3)) x1 cd cs) cd cs) cd cs) cd
  cs

d_C_getFirstId :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_getFirstId x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_23 x2 x3 (Curry_Prelude.d_C_isAlpha
    x2 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_getFirstId l cd cs)
    (d_C_getFirstId r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_getFirstId z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_getFirstId e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CurryDoc.Read.getFirstId" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Read.getFirstId" (showCons x1))

d_C_isIdChar :: Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isIdChar x1 cd cs = Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_C_isAlphaNum
  x1 cd cs) (Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.C_Char '_'#) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.C_Char '\''#) cd cs) cd cs) cd cs

d_C_infixIDs :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_infixIDs cd cs = Curry_Prelude.toCurryString "~!@#$%^&*+-=<>?./|\\:"

d_C_groupLines :: Curry_Prelude.OP_List C_SourceLine -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_SourceLine
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_C_groupLines x1 cd cs = let x2 = Curry_Prelude.d_C_apply
                                (Curry_Prelude.d_C_break (Curry_Prelude.d_C_flip
                                (acceptCs id
                                d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash)
                                C_ModDef) cd cs) x1 cd cs
                              x3 = d_OP_groupLines_dot_uscore_hash_selFP4_hash_modcmts
                                x2 cd cs
                              x4 = d_OP_groupLines_dot_uscore_hash_selFP5_hash_progcmts
                                x2 cd cs
  in d_C__case_19 x4 x3 x1
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
  x4 Curry_Prelude.OP_List cd cs) cd cs

d_OP_groupLines_dot_getComment_dot_78 :: C_SourceLine -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_groupLines_dot_getComment_dot_78 x1 cd cs = let x2 = Curry_Prelude.OP_List
  in d_C__case_18 x2 x1 cd cs

d_OP_groupLines_dot_uscore_hash_selFP4_hash_modcmts :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List C_SourceLine) (Curry_Prelude.OP_List C_SourceLine)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List C_SourceLine
d_OP_groupLines_dot_uscore_hash_selFP4_hash_modcmts x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_groupLines_dot_uscore_hash_selFP4_hash_modcmts l cd cs)
    (d_OP_groupLines_dot_uscore_hash_selFP4_hash_modcmts r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_groupLines_dot_uscore_hash_selFP4_hash_modcmts z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_groupLines_dot_uscore_hash_selFP4_hash_modcmts e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CurryDoc.Read.groupLines._#selFP4#modcmts" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Read.groupLines._#selFP4#modcmts"
    (showCons x1))

d_OP_groupLines_dot_uscore_hash_selFP5_hash_progcmts :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List C_SourceLine) (Curry_Prelude.OP_List C_SourceLine)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List C_SourceLine
d_OP_groupLines_dot_uscore_hash_selFP5_hash_progcmts x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_groupLines_dot_uscore_hash_selFP5_hash_progcmts l cd cs)
    (d_OP_groupLines_dot_uscore_hash_selFP5_hash_progcmts r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_groupLines_dot_uscore_hash_selFP5_hash_progcmts z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_groupLines_dot_uscore_hash_selFP5_hash_progcmts e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CurryDoc.Read.groupLines._#selFP5#progcmts" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Read.groupLines._#selFP5#progcmts"
    (showCons x1))

d_C_groupProgLines :: Curry_Prelude.OP_List C_SourceLine -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_SourceLine
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_groupProgLines x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_17 x3 x2 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_groupProgLines l cd
    cs) (d_C_groupProgLines r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_groupProgLines z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_groupProgLines
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CurryDoc.Read.groupProgLines" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Read.groupProgLines" (showCons x1))

d_C_groupComment :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_SourceLine -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_SourceLine
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_groupComment x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_16 x4 x1 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_groupComment x1 l cd
    cs) (d_C_groupComment x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_groupComment
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_groupComment x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CurryDoc.Read.groupComment" [show x1, show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read.groupComment" (showCons x2))

d_C_skipFuncDefs :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_SourceLine -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_SourceLine
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_skipFuncDefs x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_15 x4 x1 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_skipFuncDefs x1 l cd
    cs) (d_C_skipFuncDefs x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_skipFuncDefs
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_skipFuncDefs x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CurryDoc.Read.skipFuncDefs" [show x1, show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read.skipFuncDefs" (showCons x2))

d_C_skipDataDefs :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_SourceLine -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_SourceLine
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_skipDataDefs x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_13 x4 x1 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_skipDataDefs x1 l cd
    cs) (d_C_skipDataDefs x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_skipDataDefs
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_skipDataDefs x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CurryDoc.Read.skipDataDefs" [show x1, show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read.skipDataDefs" (showCons x2))

d_C_getFuncComment :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_SourceLine
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_getFuncComment x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_11 x4 x1 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_getFuncComment x1 l cd
    cs) (d_C_getFuncComment x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_getFuncComment x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_getFuncComment
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CurryDoc.Read.getFuncComment" [show x1, show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read.getFuncComment" (showCons x2))

d_C_getConsComment :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_getConsComment x1 x2 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.C_Nothing
  Curry_Prelude.OP_Cons x3 x4 -> let x5 = Curry_Prelude.d_C_span d_C_isIdChar x3
                                       cd cs
                                     x6 = d_OP_getConsComment_dot_uscore_hash_selFP10_hash_consname
                                       x5 cd cs
                                     x7 = d_OP_getConsComment_dot_uscore_hash_selFP11_hash_rconscmt
                                       x5 cd cs
    in d_C__case_8 x2 x6 x4 x3 x7
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x6 x2 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_getConsComment l x2 cd
    cs) (d_C_getConsComment r x2 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_getConsComment z x2 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_getConsComment
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CurryDoc.Read.getConsComment" [show x1, show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read.getConsComment" (showCons x1))

d_OP_getConsComment_dot_uscore_hash_selFP10_hash_consname :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_getConsComment_dot_uscore_hash_selFP10_hash_consname x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_getConsComment_dot_uscore_hash_selFP10_hash_consname l cd cs)
    (d_OP_getConsComment_dot_uscore_hash_selFP10_hash_consname r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_getConsComment_dot_uscore_hash_selFP10_hash_consname z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_getConsComment_dot_uscore_hash_selFP10_hash_consname e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CurryDoc.Read.getConsComment._#selFP10#consname" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Read.getConsComment._#selFP10#consname"
    (showCons x1))

d_OP_getConsComment_dot_uscore_hash_selFP11_hash_rconscmt :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_getConsComment_dot_uscore_hash_selFP11_hash_rconscmt x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_getConsComment_dot_uscore_hash_selFP11_hash_rconscmt l cd cs)
    (d_OP_getConsComment_dot_uscore_hash_selFP11_hash_rconscmt r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_getConsComment_dot_uscore_hash_selFP11_hash_rconscmt z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_getConsComment_dot_uscore_hash_selFP11_hash_rconscmt e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CurryDoc.Read.getConsComment._#selFP11#rconscmt" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Read.getConsComment._#selFP11#rconscmt"
    (showCons x1))

d_OP_getConsComment_dot_uscore_hash_selFP8_hash_conscall :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_getConsComment_dot_uscore_hash_selFP8_hash_conscall x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_getConsComment_dot_uscore_hash_selFP8_hash_conscall l cd cs)
    (d_OP_getConsComment_dot_uscore_hash_selFP8_hash_conscall r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_getConsComment_dot_uscore_hash_selFP8_hash_conscall z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_getConsComment_dot_uscore_hash_selFP8_hash_conscall e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CurryDoc.Read.getConsComment._#selFP8#conscall" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Read.getConsComment._#selFP8#conscall"
    (showCons x1))

d_OP_getConsComment_dot_uscore_hash_selFP9_hash_callcmt :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_getConsComment_dot_uscore_hash_selFP9_hash_callcmt x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_getConsComment_dot_uscore_hash_selFP9_hash_callcmt l cd cs)
    (d_OP_getConsComment_dot_uscore_hash_selFP9_hash_callcmt r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_getConsComment_dot_uscore_hash_selFP9_hash_callcmt z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_getConsComment_dot_uscore_hash_selFP9_hash_callcmt e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CurryDoc.Read.getConsComment._#selFP9#callcmt" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Read.getConsComment._#selFP9#callcmt"
    (showCons x1))

d_C_getDataComment :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_SourceLine
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_getDataComment x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_6 x4 x1 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_getDataComment x1 l cd
    cs) (d_C_getDataComment x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_getDataComment x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_getDataComment
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CurryDoc.Read.getDataComment" [show x1, show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read.getDataComment" (showCons x2))

d_C_getCommentType :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> t1 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C_getCommentType x1 x2 x3 cd cs = Curry_Prelude.d_C_map Curry_Prelude.d_C_snd
  (Curry_Prelude.d_C_filter (d_OP_getCommentType_dot_uscore_hash_lambda15 x2 x1)
  x3 cd cs) cd cs

nd_C_getCommentType :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> t1 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 t0) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C_getCommentType x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_map (wrapDX id Curry_Prelude.d_C_snd)
  (Curry_Prelude.nd_C_filter (wrapNX id
  (nd_OP_getCommentType_dot_uscore_hash_lambda15 x2 x1)) x3 s0 cd cs) s1 cd cs))

d_OP_getCommentType_dot_uscore_hash_lambda15 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Curry_Prelude.OP_Tuple2 t1 t0
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_getCommentType_dot_uscore_hash_lambda15 x1 x2 x3 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq x2
  cd cs) (Curry_Prelude.d_C_fst x3 cd cs) cd cs) x1 cd cs

nd_OP_getCommentType_dot_uscore_hash_lambda15 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> Curry_Prelude.OP_Tuple2 t1 t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_OP_getCommentType_dot_uscore_hash_lambda15 x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq x2
  s0 cd cs) (Curry_Prelude.d_C_fst x3 cd cs) s1 cd cs)) x1 s3 cd cs))

d_C_splitComment :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))
d_C_splitComment x1 cd cs = d_C_splitCommentMain (Curry_Prelude.d_C_lines x1 cd
  cs) cd cs

d_C_splitCommentMain :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_C_splitCommentMain x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_3 x2 x3 (Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 Curry_Prelude.OP_List cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    cd cs) (Curry_Prelude.d_C_head x2 cd cs) cd cs) (Curry_Prelude.C_Char '@'#)
    cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_splitCommentMain l cd
    cs) (d_C_splitCommentMain r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_splitCommentMain z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_C_splitCommentMain e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CurryDoc.Read.splitCommentMain" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Read.splitCommentMain" (showCons x1))

d_OP_splitCommentMain_dot_uscore_hash_selFP13_hash_maincmt :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_splitCommentMain_dot_uscore_hash_selFP13_hash_maincmt x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_splitCommentMain_dot_uscore_hash_selFP13_hash_maincmt l cd cs)
    (d_OP_splitCommentMain_dot_uscore_hash_selFP13_hash_maincmt r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_splitCommentMain_dot_uscore_hash_selFP13_hash_maincmt z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_splitCommentMain_dot_uscore_hash_selFP13_hash_maincmt e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CurryDoc.Read.splitCommentMain._#selFP13#maincmt" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Read.splitCommentMain._#selFP13#maincmt"
    (showCons x1))

d_OP_splitCommentMain_dot_uscore_hash_selFP14_hash_rest :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_splitCommentMain_dot_uscore_hash_selFP14_hash_rest x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_splitCommentMain_dot_uscore_hash_selFP14_hash_rest l cd cs)
    (d_OP_splitCommentMain_dot_uscore_hash_selFP14_hash_rest r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_splitCommentMain_dot_uscore_hash_selFP14_hash_rest z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_splitCommentMain_dot_uscore_hash_selFP14_hash_rest e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CurryDoc.Read.splitCommentMain._#selFP14#rest" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Read.splitCommentMain._#selFP14#rest"
    (showCons x1))

d_C_splitCommentParams :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_splitCommentParams x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x1
    (Curry_Prelude.d_C_apply (d_C_skipWhiteSpace cd cs) x2 cd cs))
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_2 x4 x5 x2 x1
    (Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x4 Curry_Prelude.OP_List cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    cd cs) (Curry_Prelude.d_C_head x4 cd cs) cd cs) (Curry_Prelude.C_Char '@'#)
    cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_splitCommentParams x1
    x2 l cd cs) (d_C_splitCommentParams x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_splitCommentParams x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_C_splitCommentParams x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CurryDoc.Read.splitCommentParams" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "CurryDoc.Read.splitCommentParams" (showCons x3))

d_C_isFunctionType :: FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isFunctionType x1 cd cs = let x2 = Curry_Prelude.C_False
  in d_C__case_1 x2 x1 cd cs

d_C_skipWhiteSpace :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_skipWhiteSpace cd cs = Curry_Prelude.d_C_dropWhile d_C_isWhiteSpace

d_C_isWhiteSpace :: Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isWhiteSpace x1 cd cs = Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.C_Char ' '#) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.C_Char '\n'#) cd cs) cd cs

d_C_showId :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showId x1 cd cs = d_C__case_0 x1 (Curry_Prelude.d_C_isAlpha
  (Curry_Prelude.d_C_head x1 cd cs) cd cs) cd cs

d_C_brackets :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_brackets x1 x2 cd cs = case x1 of
  Curry_Prelude.C_False -> x2
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(") (Curry_Prelude.d_OP_plus_plus x2
    (Curry_Prelude.toCurryString ")") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C_brackets l x2 cd cs)
    (d_C_brackets r x2 cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C_brackets z x2
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C_brackets e x2 cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read.brackets" [show x1, show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read.brackets" (showCons x1))

d_C_getLastName :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_getLastName cd cs = Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_reverse cd cs)
  (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_takeWhile (Curry_Prelude.d_C_flip
  (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  cd cs) (Curry_Prelude.C_Char '/'#))) (Curry_Prelude.d_C_reverse cd cs) cd cs)
  cd cs

d_C__case_58 :: C_SourceLine -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_58 x2 cd cs = case x2 of
  C_Comment x18 -> Curry_Prelude.C_False
  C_FuncDef x19 -> Curry_Prelude.C_False
  C_DataDef x20 -> Curry_Prelude.C_False
  C_ModDef -> Curry_Prelude.C_False
  C_OtherLine -> Curry_Prelude.C_True
  Choice_C_SourceLine d i l r -> narrow d i (d_C__case_58 l cd cs) (d_C__case_58
    r cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z -> d_C__case_58 z cd cs) xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x -> d_C__case_58 e cd x) $!
    addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail "CurryDoc.Read._case_58"
    [show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_58" (showCons x2))

d_C__case_59 :: C_SourceLine -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_59 x2 cd cs = case x2 of
  C_Comment x15 -> Curry_Prelude.C_False
  C_FuncDef x16 -> Curry_Prelude.C_False
  C_DataDef x17 -> Curry_Prelude.C_False
  C_ModDef -> Curry_Prelude.C_True
  C_OtherLine -> Curry_Prelude.C_False
  Choice_C_SourceLine d i l r -> narrow d i (d_C__case_59 l cd cs) (d_C__case_59
    r cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z -> d_C__case_59 z cd cs) xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x -> d_C__case_59 e cd x) $!
    addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail "CurryDoc.Read._case_59"
    [show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_59" (showCons x2))

nd_C__case_60 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_SourceLine
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_60 x11 x2 s cd cs = case x2 of
  C_Comment x12 -> Curry_Prelude.C_False
  C_FuncDef x13 -> Curry_Prelude.C_False
  C_DataDef x14 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x11 x14 s0 cd cs
  C_ModDef -> Curry_Prelude.C_False
  C_OtherLine -> Curry_Prelude.C_False
  Choice_C_SourceLine d i l r -> narrow d i (nd_C__case_60 x11 l s cd cs)
    (nd_C__case_60 x11 r s cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z -> nd_C__case_60 x11 z s cd
    cs) xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x -> nd_C__case_60 x11 e s cd
    x) $! addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail "CurryDoc.Read._case_60"
    [show x11, show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_60" (showCons x2))

nd_C__case_61 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_SourceLine
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_61 x7 x2 s cd cs = case x2 of
  C_Comment x8 -> Curry_Prelude.C_False
  C_FuncDef x9 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x7 x9 s0 cd cs
  C_DataDef x10 -> Curry_Prelude.C_False
  C_ModDef -> Curry_Prelude.C_False
  C_OtherLine -> Curry_Prelude.C_False
  Choice_C_SourceLine d i l r -> narrow d i (nd_C__case_61 x7 l s cd cs)
    (nd_C__case_61 x7 r s cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z -> nd_C__case_61 x7 z s cd
    cs) xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x -> nd_C__case_61 x7 e s cd
    x) $! addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail "CurryDoc.Read._case_61"
    [show x7, show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_61" (showCons x2))

nd_C__case_62 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_SourceLine
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_62 x3 x2 s cd cs = case x2 of
  C_Comment x4 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x4 s0 cd cs
  C_FuncDef x5 -> Curry_Prelude.C_False
  C_DataDef x6 -> Curry_Prelude.C_False
  C_ModDef -> Curry_Prelude.C_False
  C_OtherLine -> Curry_Prelude.C_False
  Choice_C_SourceLine d i l r -> narrow d i (nd_C__case_62 x3 l s cd cs)
    (nd_C__case_62 x3 r s cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z -> nd_C__case_62 x3 z s cd
    cs) xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x -> nd_C__case_62 x3 e s cd
    x) $! addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail "CurryDoc.Read._case_62"
    [show x3, show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_62" (showCons x2))

d_C__case_53 :: C_Category -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_53 x2 cd cs = case x2 of
  C_General -> Curry_Prelude.C_False
  C_Algorithm -> Curry_Prelude.C_False
  C_Database -> Curry_Prelude.C_False
  C_Web -> Curry_Prelude.C_False
  C_Meta -> Curry_Prelude.C_True
  Choice_C_Category d i l r -> narrow d i (d_C__case_53 l cd cs) (d_C__case_53 r
    cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z -> d_C__case_53 z cd cs) xs
  Guard_C_Category d c e -> guardCons d c ((\x -> d_C__case_53 e cd x) $! addCs
    c cs)
  Fail_C_Category d info -> failCons d (traceFail "CurryDoc.Read._case_53" [show
    x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_53" (showCons x2))

d_C__case_54 :: C_Category -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_54 x2 cd cs = case x2 of
  C_General -> Curry_Prelude.C_False
  C_Algorithm -> Curry_Prelude.C_False
  C_Database -> Curry_Prelude.C_False
  C_Web -> Curry_Prelude.C_True
  C_Meta -> Curry_Prelude.C_False
  Choice_C_Category d i l r -> narrow d i (d_C__case_54 l cd cs) (d_C__case_54 r
    cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z -> d_C__case_54 z cd cs) xs
  Guard_C_Category d c e -> guardCons d c ((\x -> d_C__case_54 e cd x) $! addCs
    c cs)
  Fail_C_Category d info -> failCons d (traceFail "CurryDoc.Read._case_54" [show
    x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_54" (showCons x2))

d_C__case_55 :: C_Category -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_55 x2 cd cs = case x2 of
  C_General -> Curry_Prelude.C_False
  C_Algorithm -> Curry_Prelude.C_False
  C_Database -> Curry_Prelude.C_True
  C_Web -> Curry_Prelude.C_False
  C_Meta -> Curry_Prelude.C_False
  Choice_C_Category d i l r -> narrow d i (d_C__case_55 l cd cs) (d_C__case_55 r
    cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z -> d_C__case_55 z cd cs) xs
  Guard_C_Category d c e -> guardCons d c ((\x -> d_C__case_55 e cd x) $! addCs
    c cs)
  Fail_C_Category d info -> failCons d (traceFail "CurryDoc.Read._case_55" [show
    x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_55" (showCons x2))

d_C__case_56 :: C_Category -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_56 x2 cd cs = case x2 of
  C_General -> Curry_Prelude.C_False
  C_Algorithm -> Curry_Prelude.C_True
  C_Database -> Curry_Prelude.C_False
  C_Web -> Curry_Prelude.C_False
  C_Meta -> Curry_Prelude.C_False
  Choice_C_Category d i l r -> narrow d i (d_C__case_56 l cd cs) (d_C__case_56 r
    cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z -> d_C__case_56 z cd cs) xs
  Guard_C_Category d c e -> guardCons d c ((\x -> d_C__case_56 e cd x) $! addCs
    c cs)
  Fail_C_Category d info -> failCons d (traceFail "CurryDoc.Read._case_56" [show
    x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_56" (showCons x2))

d_C__case_57 :: C_Category -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_57 x2 cd cs = case x2 of
  C_General -> Curry_Prelude.C_True
  C_Algorithm -> Curry_Prelude.C_False
  C_Database -> Curry_Prelude.C_False
  C_Web -> Curry_Prelude.C_False
  C_Meta -> Curry_Prelude.C_False
  Choice_C_Category d i l r -> narrow d i (d_C__case_57 l cd cs) (d_C__case_57 r
    cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z -> d_C__case_57 z cd cs) xs
  Guard_C_Category d c e -> guardCons d c ((\x -> d_C__case_57 e cd x) $! addCs
    c cs)
  Fail_C_Category d info -> failCons d (traceFail "CurryDoc.Read._case_57" [show
    x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_57" (showCons x2))

d_C__case_48 :: C_SourceLine -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_48 x2 cd cs = case x2 of
  C_Comment x18 -> Curry_Prelude.C_False
  C_FuncDef x19 -> Curry_Prelude.C_False
  C_DataDef x20 -> Curry_Prelude.C_False
  C_ModDef -> Curry_Prelude.C_False
  C_OtherLine -> Curry_Prelude.C_True
  Choice_C_SourceLine d i l r -> narrow d i (d_C__case_48 l cd cs) (d_C__case_48
    r cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z -> d_C__case_48 z cd cs) xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x -> d_C__case_48 e cd x) $!
    addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail "CurryDoc.Read._case_48"
    [show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_48" (showCons x2))

d_C__case_49 :: C_SourceLine -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_49 x2 cd cs = case x2 of
  C_Comment x15 -> Curry_Prelude.C_False
  C_FuncDef x16 -> Curry_Prelude.C_False
  C_DataDef x17 -> Curry_Prelude.C_False
  C_ModDef -> Curry_Prelude.C_True
  C_OtherLine -> Curry_Prelude.C_False
  Choice_C_SourceLine d i l r -> narrow d i (d_C__case_49 l cd cs) (d_C__case_49
    r cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z -> d_C__case_49 z cd cs) xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x -> d_C__case_49 e cd x) $!
    addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail "CurryDoc.Read._case_49"
    [show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_49" (showCons x2))

d_C__case_50 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_SourceLine
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_50 x11 x2 cd cs = case x2 of
  C_Comment x12 -> Curry_Prelude.C_False
  C_FuncDef x13 -> Curry_Prelude.C_False
  C_DataDef x14 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x11 x14 cd cs
  C_ModDef -> Curry_Prelude.C_False
  C_OtherLine -> Curry_Prelude.C_False
  Choice_C_SourceLine d i l r -> narrow d i (d_C__case_50 x11 l cd cs)
    (d_C__case_50 x11 r cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z -> d_C__case_50 x11 z cd cs)
    xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x -> d_C__case_50 x11 e cd x) $!
    addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail "CurryDoc.Read._case_50"
    [show x11, show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_50" (showCons x2))

d_C__case_51 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_SourceLine
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_51 x7 x2 cd cs = case x2 of
  C_Comment x8 -> Curry_Prelude.C_False
  C_FuncDef x9 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x7 x9 cd cs
  C_DataDef x10 -> Curry_Prelude.C_False
  C_ModDef -> Curry_Prelude.C_False
  C_OtherLine -> Curry_Prelude.C_False
  Choice_C_SourceLine d i l r -> narrow d i (d_C__case_51 x7 l cd cs)
    (d_C__case_51 x7 r cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z -> d_C__case_51 x7 z cd cs)
    xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x -> d_C__case_51 x7 e cd x) $!
    addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail "CurryDoc.Read._case_51"
    [show x7, show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_51" (showCons x2))

d_C__case_52 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_SourceLine
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_52 x3 x2 cd cs = case x2 of
  C_Comment x4 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 x4 cd cs
  C_FuncDef x5 -> Curry_Prelude.C_False
  C_DataDef x6 -> Curry_Prelude.C_False
  C_ModDef -> Curry_Prelude.C_False
  C_OtherLine -> Curry_Prelude.C_False
  Choice_C_SourceLine d i l r -> narrow d i (d_C__case_52 x3 l cd cs)
    (d_C__case_52 x3 r cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z -> d_C__case_52 x3 z cd cs)
    xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x -> d_C__case_52 x3 e cd x) $!
    addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail "CurryDoc.Read._case_52"
    [show x3, show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_52" (showCons x2))

d_C__case_43 :: C_Category -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_43 x2 cd cs = case x2 of
  C_General -> Curry_Prelude.C_False
  C_Algorithm -> Curry_Prelude.C_False
  C_Database -> Curry_Prelude.C_False
  C_Web -> Curry_Prelude.C_False
  C_Meta -> Curry_Prelude.C_True
  Choice_C_Category d i l r -> narrow d i (d_C__case_43 l cd cs) (d_C__case_43 r
    cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z -> d_C__case_43 z cd cs) xs
  Guard_C_Category d c e -> guardCons d c ((\x -> d_C__case_43 e cd x) $! addCs
    c cs)
  Fail_C_Category d info -> failCons d (traceFail "CurryDoc.Read._case_43" [show
    x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_43" (showCons x2))

d_C__case_44 :: C_Category -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_44 x2 cd cs = case x2 of
  C_General -> Curry_Prelude.C_False
  C_Algorithm -> Curry_Prelude.C_False
  C_Database -> Curry_Prelude.C_False
  C_Web -> Curry_Prelude.C_True
  C_Meta -> Curry_Prelude.C_False
  Choice_C_Category d i l r -> narrow d i (d_C__case_44 l cd cs) (d_C__case_44 r
    cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z -> d_C__case_44 z cd cs) xs
  Guard_C_Category d c e -> guardCons d c ((\x -> d_C__case_44 e cd x) $! addCs
    c cs)
  Fail_C_Category d info -> failCons d (traceFail "CurryDoc.Read._case_44" [show
    x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_44" (showCons x2))

d_C__case_45 :: C_Category -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_45 x2 cd cs = case x2 of
  C_General -> Curry_Prelude.C_False
  C_Algorithm -> Curry_Prelude.C_False
  C_Database -> Curry_Prelude.C_True
  C_Web -> Curry_Prelude.C_False
  C_Meta -> Curry_Prelude.C_False
  Choice_C_Category d i l r -> narrow d i (d_C__case_45 l cd cs) (d_C__case_45 r
    cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z -> d_C__case_45 z cd cs) xs
  Guard_C_Category d c e -> guardCons d c ((\x -> d_C__case_45 e cd x) $! addCs
    c cs)
  Fail_C_Category d info -> failCons d (traceFail "CurryDoc.Read._case_45" [show
    x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_45" (showCons x2))

d_C__case_46 :: C_Category -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_46 x2 cd cs = case x2 of
  C_General -> Curry_Prelude.C_False
  C_Algorithm -> Curry_Prelude.C_True
  C_Database -> Curry_Prelude.C_False
  C_Web -> Curry_Prelude.C_False
  C_Meta -> Curry_Prelude.C_False
  Choice_C_Category d i l r -> narrow d i (d_C__case_46 l cd cs) (d_C__case_46 r
    cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z -> d_C__case_46 z cd cs) xs
  Guard_C_Category d c e -> guardCons d c ((\x -> d_C__case_46 e cd x) $! addCs
    c cs)
  Fail_C_Category d info -> failCons d (traceFail "CurryDoc.Read._case_46" [show
    x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_46" (showCons x2))

d_C__case_47 :: C_Category -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_47 x2 cd cs = case x2 of
  C_General -> Curry_Prelude.C_True
  C_Algorithm -> Curry_Prelude.C_False
  C_Database -> Curry_Prelude.C_False
  C_Web -> Curry_Prelude.C_False
  C_Meta -> Curry_Prelude.C_False
  Choice_C_Category d i l r -> narrow d i (d_C__case_47 l cd cs) (d_C__case_47 r
    cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z -> d_C__case_47 z cd cs) xs
  Guard_C_Category d c e -> guardCons d c ((\x -> d_C__case_47 e cd x) $! addCs
    c cs)
  Fail_C_Category d info -> failCons d (traceFail "CurryDoc.Read._case_47" [show
    x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_47" (showCons x2))

d_C__case_38 :: C_Category -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_38 x2 cd cs = case x2 of
  C_General -> Curry_Prelude.C_False
  C_Algorithm -> Curry_Prelude.C_False
  C_Database -> Curry_Prelude.C_False
  C_Web -> Curry_Prelude.C_False
  C_Meta -> Curry_Prelude.C_True
  Choice_C_Category d i l r -> narrow d i (d_C__case_38 l cd cs) (d_C__case_38 r
    cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z -> d_C__case_38 z cd cs) xs
  Guard_C_Category d c e -> guardCons d c ((\x -> d_C__case_38 e cd x) $! addCs
    c cs)
  Fail_C_Category d info -> failCons d (traceFail "CurryDoc.Read._case_38" [show
    x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_38" (showCons x2))

d_C__case_39 :: C_Category -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_39 x2 cd cs = case x2 of
  C_General -> Curry_Prelude.C_False
  C_Algorithm -> Curry_Prelude.C_False
  C_Database -> Curry_Prelude.C_False
  C_Web -> Curry_Prelude.C_True
  C_Meta -> Curry_Prelude.C_True
  Choice_C_Category d i l r -> narrow d i (d_C__case_39 l cd cs) (d_C__case_39 r
    cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z -> d_C__case_39 z cd cs) xs
  Guard_C_Category d c e -> guardCons d c ((\x -> d_C__case_39 e cd x) $! addCs
    c cs)
  Fail_C_Category d info -> failCons d (traceFail "CurryDoc.Read._case_39" [show
    x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_39" (showCons x2))

d_C__case_40 :: C_Category -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_40 x2 cd cs = case x2 of
  C_General -> Curry_Prelude.C_False
  C_Algorithm -> Curry_Prelude.C_False
  C_Database -> Curry_Prelude.C_True
  C_Web -> Curry_Prelude.C_True
  C_Meta -> Curry_Prelude.C_True
  Choice_C_Category d i l r -> narrow d i (d_C__case_40 l cd cs) (d_C__case_40 r
    cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z -> d_C__case_40 z cd cs) xs
  Guard_C_Category d c e -> guardCons d c ((\x -> d_C__case_40 e cd x) $! addCs
    c cs)
  Fail_C_Category d info -> failCons d (traceFail "CurryDoc.Read._case_40" [show
    x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_40" (showCons x2))

d_C__case_41 :: C_Category -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_41 x2 cd cs = case x2 of
  C_General -> Curry_Prelude.C_False
  C_Algorithm -> Curry_Prelude.C_True
  C_Database -> Curry_Prelude.C_True
  C_Web -> Curry_Prelude.C_True
  C_Meta -> Curry_Prelude.C_True
  Choice_C_Category d i l r -> narrow d i (d_C__case_41 l cd cs) (d_C__case_41 r
    cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z -> d_C__case_41 z cd cs) xs
  Guard_C_Category d c e -> guardCons d c ((\x -> d_C__case_41 e cd x) $! addCs
    c cs)
  Fail_C_Category d info -> failCons d (traceFail "CurryDoc.Read._case_41" [show
    x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_41" (showCons x2))

d_C__case_42 :: C_Category -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_42 x2 cd cs = case x2 of
  C_General -> Curry_Prelude.C_True
  C_Algorithm -> Curry_Prelude.C_True
  C_Database -> Curry_Prelude.C_True
  C_Web -> Curry_Prelude.C_True
  C_Meta -> Curry_Prelude.C_True
  Choice_C_Category d i l r -> narrow d i (d_C__case_42 l cd cs) (d_C__case_42 r
    cd cs)
  Choices_C_Category d i xs -> narrows cs d i (\z -> d_C__case_42 z cd cs) xs
  Guard_C_Category d c e -> guardCons d c ((\x -> d_C__case_42 e cd x) $! addCs
    c cs)
  Fail_C_Category d info -> failCons d (traceFail "CurryDoc.Read._case_42" [show
    x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_42" (showCons x2))

d_C__case_37 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> System.Curry_IO.C_Handle -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> C_SourceLine -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_37 x4 x1 x2 x8 cd cs = case x8 of
  C_ModDef -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_IO.d_C_hClose x1 cd cs) cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_unlines cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_reverse cd cs) x2 cd cs) cd cs)
    cd cs) cd cs
  C_FuncDef x5 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_IO.d_C_hClose x1 cd cs) cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) Curry_Prelude.OP_List cd cs) cd cs
  C_DataDef x6 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (System.Curry_IO.d_C_hClose x1 cd cs) cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) Curry_Prelude.OP_List cd cs) cd cs
  C_OtherLine -> d_OP_readModuleComment_dot_readHeader_dot_2 x2 x1 cd cs
  C_Comment x7 -> d_OP_readModuleComment_dot_readHeader_dot_2
    (Curry_Prelude.OP_Cons x7 x2) x1 cd cs
  Choice_C_SourceLine d i l r -> narrow d i (d_C__case_37 x4 x1 x2 l cd cs)
    (d_C__case_37 x4 x1 x2 r cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z -> d_C__case_37 x4 x1 x2 z
    cd cs) xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x -> d_C__case_37 x4 x1 x2 e cd
    x) $! addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail "CurryDoc.Read._case_37"
    [show x4, show x1, show x2, show x8] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_37" (showCons x8))

d_C__case_36 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Category
d_C__case_36 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> C_General
  Curry_Prelude.C_False -> d_C__case_35 x5 (Curry_Prelude.d_C_eqString x5
    (Curry_Prelude.toCurryString "algorithm") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_36 x5 l cd cs)
    (d_C__case_36 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_36 x5 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_36 x5 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_36" [show x5, show x6] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_36" (showCons x6))

d_C__case_35 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Category
d_C__case_35 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> C_Algorithm
  Curry_Prelude.C_False -> d_C__case_34 x5 (Curry_Prelude.d_C_eqString x5
    (Curry_Prelude.toCurryString "database") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_35 x5 l cd cs)
    (d_C__case_35 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_35 x5 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_35 x5 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_35" [show x5, show x6] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_35" (showCons x6))

d_C__case_34 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Category
d_C__case_34 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> C_Database
  Curry_Prelude.C_False -> d_C__case_33 x5 (Curry_Prelude.d_C_eqString x5
    (Curry_Prelude.toCurryString "web") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_34 x5 l cd cs)
    (d_C__case_34 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_34 x5 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_34 x5 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_34" [show x5, show x6] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_34" (showCons x6))

d_C__case_33 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Category
d_C__case_33 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> C_Web
  Curry_Prelude.C_False -> d_C__case_32 x5 (Curry_Prelude.d_C_eqString x5
    (Curry_Prelude.toCurryString "meta") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_33 x5 l cd cs)
    (d_C__case_33 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_33 x5 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_33 x5 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_33" [show x5, show x6] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_33" (showCons x6))

d_C__case_32 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Category
d_C__case_32 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> C_Meta
  Curry_Prelude.C_False -> C_General
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_32 x5 l cd cs)
    (d_C__case_32 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_32 x5 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_32 x5 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_32" [show x5, show x6] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_32" (showCons x6))

d_C__case_31 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> C_SourceLine
d_C__case_31 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> C_Comment Curry_Prelude.OP_List
  Curry_Prelude.C_False -> d_C__case_30 x1 x2 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (4)) x1 cd cs)
    (Curry_Prelude.toCurryString "--- ") cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    cd cs) (Curry_Prelude.d_C_head (Curry_Prelude.d_C_drop (Curry_Prelude.C_Int
    (4)) x1 cd cs) cd cs) cd cs) (Curry_Prelude.C_Char '-'#) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_31 x1 x2 l cd cs)
    (d_C__case_31 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_31 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_31 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_31" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_31" (showCons x3))

nd_C__case_31 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> C_SourceLine
nd_C__case_31 x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.C_True -> C_Comment Curry_Prelude.OP_List
  Curry_Prelude.C_False -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_30 x1 x2 (let s0 = leftSupply s4
                                                   s3 = rightSupply s4
    in s0 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (4)) x1 cd cs)
    (Curry_Prelude.toCurryString "--- ") s0 cd cs) (let s2 = leftSupply s3
                                                        s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    cd cs)) (Curry_Prelude.d_C_head (Curry_Prelude.d_C_drop (Curry_Prelude.C_Int
    (4)) x1 cd cs) cd cs) s1 cd cs) (Curry_Prelude.C_Char '-'#) s2 cd cs)) cd
    cs)) s5 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_31 x1 x2 l s cd
    cs) (nd_C__case_31 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_31 x1
    x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_31 x1 x2
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_31" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_31" (showCons x3))

d_C__case_30 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> C_SourceLine
d_C__case_30 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> C_Comment (Curry_Prelude.d_C_drop (Curry_Prelude.C_Int
    (4)) x1 cd cs)
  Curry_Prelude.C_False -> d_C__case_29 x1 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (7)) x1 cd cs)
    (Curry_Prelude.toCurryString "module ") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_30 x1 x2 l cd cs)
    (d_C__case_30 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_30 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_30 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_30" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_30" (showCons x3))

nd_C__case_30 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> C_SourceLine
nd_C__case_30 x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.C_True -> C_Comment (Curry_Prelude.d_C_drop (Curry_Prelude.C_Int
    (4)) x1 cd cs)
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_29 x1 x2
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (7)) x1 cd cs)
    (Curry_Prelude.toCurryString "module ") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_30 x1 x2 l s cd
    cs) (nd_C__case_30 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_30 x1
    x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_30 x1 x2
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_30" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_30" (showCons x3))

d_C__case_29 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> C_SourceLine
d_C__case_29 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> C_ModDef
  Curry_Prelude.C_False -> d_C__case_28 x1 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (7)) x1 cd cs)
    (Curry_Prelude.toCurryString "import ") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_29 x1 x2 l cd cs)
    (d_C__case_29 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_29 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_29 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_29" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_29" (showCons x3))

nd_C__case_29 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> C_SourceLine
nd_C__case_29 x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.C_True -> C_ModDef
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_28 x1 x2
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (7)) x1 cd cs)
    (Curry_Prelude.toCurryString "import ") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_29 x1 x2 l s cd
    cs) (nd_C__case_29 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_29 x1
    x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_29 x1 x2
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_29" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_29" (showCons x3))

d_C__case_28 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> C_SourceLine
d_C__case_28 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> C_ModDef
  Curry_Prelude.C_False -> d_C__case_27 x1 x2 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_28 x1 x2 l cd cs)
    (d_C__case_28 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_28 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_28 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_28" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_28" (showCons x3))

nd_C__case_28 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> C_SourceLine
nd_C__case_28 x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.C_True -> C_ModDef
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_27 x1 x2 (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_28 x1 x2 l s cd
    cs) (nd_C__case_28 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_28 x1
    x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_28 x1 x2
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_28" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_28" (showCons x3))

d_C__case_27 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> C_SourceLine
d_C__case_27 x1 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> let x3 = d_C_getFirstId x1 cd cs
    in d_C__case_26 x3 x1 x2 (Curry_Prelude.d_C_null x3 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_27 x1 x2 l cd cs)
    (d_C__case_27 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_27 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_27 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_27" [show x1, show x2, show x4] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_27" (showCons x4))

nd_C__case_27 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> C_SourceLine
nd_C__case_27 x1 x2 x4 s cd cs = case x4 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` (let x3 = d_C_getFirstId x1 cd cs
    in nd_C__case_26 x3 x1 x2 (Curry_Prelude.d_C_null x3 cd cs) s0 cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_27 x1 x2 l s cd
    cs) (nd_C__case_27 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_27 x1
    x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_27 x1 x2
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_27" [show x1, show x2, show x4] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_27" (showCons x4))

d_C__case_26 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> C_SourceLine
d_C__case_26 x3 x1 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> C_OtherLine
  Curry_Prelude.C_False -> d_C__case_25 x3 x1 x2 (Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "data") cd cs) (Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "type") cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "newtype") cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_26 x3 x1 x2 l cd
    cs) (d_C__case_26 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_26 x3
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_26 x3 x1
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_26" [show x3, show x1, show x2, show x4] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_26" (showCons x4))

nd_C__case_26 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> C_SourceLine
nd_C__case_26 x3 x1 x2 x4 s cd cs = case x4 of
  Curry_Prelude.C_True -> C_OtherLine
  Curry_Prelude.C_False -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_25 x3 x1 x2 (let s0 = leftSupply s4
                                                      s3 = rightSupply s4
    in s0 `seq` (s3 `seq` Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "data") s0 cd cs) (let s1 = leftSupply s3
                                                           s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "type") s1 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "newtype") s2 cd cs) cd cs)) cd cs)) s5 cd
    cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_26 x3 x1 x2 l s
    cd cs) (nd_C__case_26 x3 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_26 x3
    x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_26 x3 x1
    x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_26" [show x3, show x1, show x2, show x4] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_26" (showCons x4))

d_C__case_25 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> C_SourceLine
d_C__case_25 x3 x1 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> C_DataDef (Curry_Prelude.d_C_apply x2 x1 cd cs)
  Curry_Prelude.C_False -> d_C__case_24 x3 (Data.Curry_List.d_C_isSuffixOf
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.toCurryString "'default") x3 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_25 x3 x1 x2 l cd
    cs) (d_C__case_25 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_25 x3
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_25 x3 x1
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_25" [show x3, show x1, show x2, show x4] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_25" (showCons x4))

nd_C__case_25 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> C_SourceLine
nd_C__case_25 x3 x1 x2 x4 s cd cs = case x4 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` C_DataDef (Curry_Prelude.nd_C_apply x2 x1 s0 cd cs)
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` d_C__case_24 x3 (Data.Curry_List.nd_C_isSuffixOf (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.toCurryString "'default") x3 s0 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_25 x3 x1 x2 l s
    cd cs) (nd_C__case_25 x3 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_25 x3
    x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_25 x3 x1
    x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_25" [show x3, show x1, show x2, show x4] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_25" (showCons x4))

d_C__case_24 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_SourceLine
d_C__case_24 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> C_OtherLine
  Curry_Prelude.C_False -> C_FuncDef x3
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_24 x3 l cd cs)
    (d_C__case_24 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_24 x3 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_24 x3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_24" [show x3, show x4] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_24" (showCons x4))

d_C__case_23 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_23 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_takeWhile d_C_isIdChar
    (Curry_Prelude.OP_Cons x2 x3) cd cs
  Curry_Prelude.C_False -> d_C__case_22 x2 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.C_Char '('#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_23 x2 x3 l cd cs)
    (d_C__case_23 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_23 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_23 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_23" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_23" (showCons x4))

d_C__case_22 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_22 x2 x3 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> let x4 = Curry_Prelude.d_C_takeWhile
                                (Curry_Prelude.d_C_flip
                                (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
                                cd cs) (Curry_Prelude.C_Char ')'#)) x3 cd cs
    in d_C__case_21 x4 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_all
    (Curry_Prelude.d_C_flip (Curry_Prelude.d_C_elem
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (d_C_infixIDs cd cs)) cd cs) x4 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_20 (Curry_Prelude.d_C_otherwise cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_22 x2 x3 l cd cs)
    (d_C__case_22 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_22 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_22 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_22" [show x2, show x3, show x5] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_22" (showCons x5))

d_C__case_20 :: Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_20 x1 cd cs = case x1 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_20 l cd cs)
    (d_C__case_20 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_20 z cd
    cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_20 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_20" [show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_20" (showCons x1))

d_C__case_21 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_21 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> x4
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_21 x4 l cd cs)
    (d_C__case_21 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_21 x4 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_21 x4 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_21" [show x4, show x5] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_21" (showCons x5))

d_C__case_19 :: Curry_Prelude.OP_List C_SourceLine -> Curry_Prelude.OP_List
  C_SourceLine -> Curry_Prelude.OP_List C_SourceLine -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  C_SourceLine (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_C__case_19 x4 x3 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List
    (d_C_groupProgLines x1 cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_concatMap d_OP_groupLines_dot_getComment_dot_78 cd cs) x3
    cd cs) (d_C_groupProgLines (Curry_Prelude.d_C_filter (Curry_Prelude.d_C_flip
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_CurryDoc_dot_Read_dot_SourceLine_hash
    cd cs) C_ModDef) (Curry_Prelude.d_C_tail x4 cd cs) cd cs) cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_19 x4 x3 x1 l cd
    cs) (d_C__case_19 x4 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_19 x4
    x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_19 x4 x3
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_19" [show x4, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_19" (showCons x5))

d_C__case_18 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_SourceLine
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_18 x2 x1 cd cs = case x1 of
  C_Comment x3 -> Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.toCurryString
    "\n") cd cs
  C_FuncDef x4 -> x2
  C_DataDef x5 -> x2
  C_ModDef -> x2
  C_OtherLine -> x2
  Choice_C_SourceLine d i l r -> narrow d i (d_C__case_18 x2 l cd cs)
    (d_C__case_18 x2 r cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z -> d_C__case_18 x2 z cd cs)
    xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x -> d_C__case_18 x2 e cd x) $!
    addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail "CurryDoc.Read._case_18"
    [show x2, show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_18" (showCons x1))

d_C__case_17 :: Curry_Prelude.OP_List C_SourceLine -> C_SourceLine -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_SourceLine
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_17 x3 x2 cd cs = case x2 of
  C_Comment x4 -> d_C_groupComment x4 x3 cd cs
  C_FuncDef x5 -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (C_FuncDef x5)
    Curry_Prelude.OP_List) (d_C_skipFuncDefs x5 x3 cd cs)
  C_DataDef x6 -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (C_DataDef x6)
    Curry_Prelude.OP_List) (d_C_skipDataDefs x6 x3 cd cs)
  C_ModDef -> d_C_groupProgLines x3 cd cs
  C_OtherLine -> d_C_groupProgLines x3 cd cs
  Choice_C_SourceLine d i l r -> narrow d i (d_C__case_17 x3 l cd cs)
    (d_C__case_17 x3 r cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z -> d_C__case_17 x3 z cd cs)
    xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x -> d_C__case_17 x3 e cd x) $!
    addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail "CurryDoc.Read._case_17"
    [show x3, show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_17" (showCons x2))

d_C__case_16 :: Curry_Prelude.OP_List C_SourceLine -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_SourceLine -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_SourceLine
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_16 x4 x1 x3 cd cs = case x3 of
  C_Comment x5 -> d_C_groupComment (Curry_Prelude.d_OP_plus_plus x1
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\n") x5 cd cs)
    cd cs) x4 cd cs
  C_FuncDef x6 -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (C_FuncDef x6)
    x1) (d_C_skipFuncDefs x6 x4 cd cs)
  C_DataDef x7 -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (C_DataDef x7)
    x1) (d_C_skipDataDefs x7 x4 cd cs)
  C_ModDef -> d_C_groupComment x1 x4 cd cs
  C_OtherLine -> d_C_groupComment x1 x4 cd cs
  Choice_C_SourceLine d i l r -> narrow d i (d_C__case_16 x4 x1 l cd cs)
    (d_C__case_16 x4 x1 r cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z -> d_C__case_16 x4 x1 z cd
    cs) xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x -> d_C__case_16 x4 x1 e cd
    x) $! addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail "CurryDoc.Read._case_16"
    [show x4, show x1, show x3] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_16" (showCons x3))

d_C__case_15 :: Curry_Prelude.OP_List C_SourceLine -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_SourceLine -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_SourceLine
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_15 x4 x1 x3 cd cs = case x3 of
  C_Comment x5 -> d_C_groupProgLines (Curry_Prelude.OP_Cons (C_Comment x5) x4)
    cd cs
  C_DataDef x6 -> d_C_groupProgLines (Curry_Prelude.OP_Cons (C_DataDef x6) x4)
    cd cs
  C_FuncDef x7 -> d_C__case_14 x7 x1 x4
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 x7 cd cs) cd cs
  C_ModDef -> d_C_skipFuncDefs x1 x4 cd cs
  C_OtherLine -> d_C_skipFuncDefs x1 x4 cd cs
  Choice_C_SourceLine d i l r -> narrow d i (d_C__case_15 x4 x1 l cd cs)
    (d_C__case_15 x4 x1 r cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z -> d_C__case_15 x4 x1 z cd
    cs) xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x -> d_C__case_15 x4 x1 e cd
    x) $! addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail "CurryDoc.Read._case_15"
    [show x4, show x1, show x3] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_15" (showCons x3))

d_C__case_14 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  C_SourceLine -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_SourceLine
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_14 x7 x1 x4 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_C_skipFuncDefs x1 x4 cd cs
  Curry_Prelude.C_False -> d_C_groupProgLines (Curry_Prelude.OP_Cons (C_FuncDef
    x7) x4) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_14 x7 x1 x4 l cd
    cs) (d_C__case_14 x7 x1 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_14 x7
    x1 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_14 x7 x1
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_14" [show x7, show x1, show x4, show x8] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_14" (showCons x8))

d_C__case_13 :: Curry_Prelude.OP_List C_SourceLine -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_SourceLine -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_SourceLine
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_13 x4 x1 x3 cd cs = case x3 of
  C_Comment x5 -> d_C_groupProgLines (Curry_Prelude.OP_Cons (C_Comment x5) x4)
    cd cs
  C_FuncDef x6 -> d_C_groupProgLines (Curry_Prelude.OP_Cons (C_FuncDef x6) x4)
    cd cs
  C_DataDef x7 -> d_C__case_12 x7 x1 x4
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 x7 cd cs) cd cs
  C_ModDef -> d_C_skipDataDefs x1 x4 cd cs
  C_OtherLine -> d_C_skipDataDefs x1 x4 cd cs
  Choice_C_SourceLine d i l r -> narrow d i (d_C__case_13 x4 x1 l cd cs)
    (d_C__case_13 x4 x1 r cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z -> d_C__case_13 x4 x1 z cd
    cs) xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x -> d_C__case_13 x4 x1 e cd
    x) $! addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail "CurryDoc.Read._case_13"
    [show x4, show x1, show x3] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_13" (showCons x3))

d_C__case_12 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  C_SourceLine -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_SourceLine
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_12 x7 x1 x4 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_C_skipDataDefs x1 x4 cd cs
  Curry_Prelude.C_False -> d_C_groupProgLines (Curry_Prelude.OP_Cons (C_DataDef
    x7) x4) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_12 x7 x1 x4 l cd
    cs) (d_C__case_12 x7 x1 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_12 x7
    x1 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_12 x7 x1
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_12" [show x7, show x1, show x4, show x8] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_12" (showCons x8))

d_C__case_11 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_SourceLine
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 C_SourceLine
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_11 x4 x1 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> let x7 = d_C_getFuncComment x1 x4 cd cs
    in d_C__case_10 x7 x1 x4 x6 x5 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_11 x4 x1 l cd
    cs) (d_C__case_11 x4 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_11
    x4 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_11 x4
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CurryDoc.Read._case_11" [show x4, show x1, show x3] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_11" (showCons x3))

d_C__case_10 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_SourceLine (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> C_SourceLine -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_10 x7 x1 x4 x6 x5 cd cs = case x5 of
  C_FuncDef x8 -> d_C__case_9 x8 x1 x4 x6
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 x8 cd cs) cd cs
  C_Comment x9 -> x7
  C_DataDef x10 -> x7
  C_ModDef -> x7
  C_OtherLine -> x7
  Choice_C_SourceLine d i l r -> narrow d i (d_C__case_10 x7 x1 x4 x6 l cd cs)
    (d_C__case_10 x7 x1 x4 x6 r cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z -> d_C__case_10 x7 x1 x4 x6
    z cd cs) xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x -> d_C__case_10 x7 x1 x4 x6 e
    cd x) $! addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail "CurryDoc.Read._case_10"
    [show x7, show x1, show x4, show x6, show x5] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_10" (showCons x5))

d_C__case_9 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_SourceLine (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_9 x8 x1 x4 x6 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> x6
  Curry_Prelude.C_False -> d_C_getFuncComment x1 x4 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_9 x8 x1 x4 x6 l
    cd cs) (d_C__case_9 x8 x1 x4 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_9 x8 x1
    x4 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_9 x8 x1 x4
    x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_9" [show x8, show x1, show x4, show x6, show x9] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_9" (showCons x9))

d_C__case_8 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_8 x2 x6 x4 x3 x7 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> let x8 = Curry_Prelude.d_C_apply
                                (Curry_Prelude.d_C_break (Curry_Prelude.d_C_flip
                                (acceptCs id
                                Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
                                (Curry_Prelude.C_Char '-'#)) cd cs) x3 cd cs
                              x9 = d_OP_getConsComment_dot_uscore_hash_selFP8_hash_conscall
                                x8 cd cs
                              x10 = d_OP_getConsComment_dot_uscore_hash_selFP9_hash_callcmt
                                x8 cd cs
    in Curry_Prelude.C_Just (d_C__case_7 x10 x9 x7 x6 (Curry_Prelude.d_C_null
    x10 cd cs) cd cs)
  Curry_Prelude.C_False -> d_C_getConsComment x4 x2 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x2 x6 x4 x3 x7
    l cd cs) (d_C__case_8 x2 x6 x4 x3 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x2 x6
    x4 x3 x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_8 x2 x6 x4
    x3 x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_8" [show x2, show x6, show x4, show x3, show x7, show
    x11] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_8" (showCons x11))

d_C__case_7 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_7 x10 x9 x7 x6 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 x6 x7
  Curry_Prelude.C_False -> Curry_Prelude.OP_Tuple2 x9 x10
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x10 x9 x7 x6 l
    cd cs) (d_C__case_7 x10 x9 x7 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x10
    x9 x7 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_7 x10 x9
    x7 x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_7" [show x10, show x9, show x7, show x6, show x11]
    info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_7" (showCons x11))

d_C__case_6 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_SourceLine
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 C_SourceLine
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_6 x4 x1 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> let x7 = d_C_getDataComment x1 x4 cd cs
    in d_C__case_5 x7 x1 x4 x6 x5 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_6 x4 x1 l cd
    cs) (d_C__case_6 x4 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_6 x4
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_6 x4 x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CurryDoc.Read._case_6" [show x4, show x1, show x3] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_6" (showCons x3))

d_C__case_5 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_SourceLine (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> C_SourceLine -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_5 x7 x1 x4 x6 x5 cd cs = case x5 of
  C_DataDef x8 -> d_C__case_4 x8 x1 x4 x6
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 x8 cd cs) cd cs
  C_Comment x9 -> x7
  C_FuncDef x10 -> x7
  C_ModDef -> x7
  C_OtherLine -> x7
  Choice_C_SourceLine d i l r -> narrow d i (d_C__case_5 x7 x1 x4 x6 l cd cs)
    (d_C__case_5 x7 x1 x4 x6 r cd cs)
  Choices_C_SourceLine d i xs -> narrows cs d i (\z -> d_C__case_5 x7 x1 x4 x6 z
    cd cs) xs
  Guard_C_SourceLine d c e -> guardCons d c ((\x -> d_C__case_5 x7 x1 x4 x6 e cd
    x) $! addCs c cs)
  Fail_C_SourceLine d info -> failCons d (traceFail "CurryDoc.Read._case_5"
    [show x7, show x1, show x4, show x6, show x5] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_5" (showCons x5))

d_C__case_4 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 C_SourceLine (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_4 x8 x1 x4 x6 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> x6
  Curry_Prelude.C_False -> d_C_getDataComment x1 x4 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x8 x1 x4 x6 l
    cd cs) (d_C__case_4 x8 x1 x4 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x8 x1
    x4 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x8 x1 x4
    x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_4" [show x8, show x1, show x4, show x6, show x9] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_4" (showCons x9))

d_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_C__case_3 x2 x3 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> let x4 = d_C_splitCommentMain x3 cd cs
                              x5 = d_OP_splitCommentMain_dot_uscore_hash_selFP13_hash_maincmt
                                x4 cd cs
                              x6 = d_OP_splitCommentMain_dot_uscore_hash_selFP14_hash_rest
                                x4 cd cs
    in Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_OP_plus_plus x2
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '\n'#) x5) cd cs) x6
  Curry_Prelude.C_False -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List
    (d_C_splitCommentParams (Curry_Prelude.d_C_takeWhile
    Curry_Prelude.d_C_isAlpha (Curry_Prelude.d_C_tail x2 cd cs) cd cs)
    (Curry_Prelude.d_C_dropWhile Curry_Prelude.d_C_isAlpha
    (Curry_Prelude.d_C_tail x2 cd cs) cd cs) x3 cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x2 x3 l cd cs)
    (d_C__case_3 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x2 x3
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_3" [show x2, show x3, show x7] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_3" (showCons x7))

d_C__case_2 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_2 x4 x5 x2 x1 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_splitCommentParams x1
    (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '\n'#) x4) cd cs) x5 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x1
    (Curry_Prelude.d_C_apply (d_C_skipWhiteSpace cd cs) x2 cd cs))
    (d_C_splitCommentParams (Curry_Prelude.d_C_takeWhile
    Curry_Prelude.d_C_isAlpha (Curry_Prelude.d_C_tail x4 cd cs) cd cs)
    (Curry_Prelude.d_C_dropWhile Curry_Prelude.d_C_isAlpha
    (Curry_Prelude.d_C_tail x4 cd cs) cd cs) x5 cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x4 x5 x2 x1 l
    cd cs) (d_C__case_2 x4 x5 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x4 x5
    x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x4 x5 x2
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_2" [show x4, show x5, show x2, show x1, show x6] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_2" (showCons x6))

d_C__case_1 :: Curry_Prelude.C_Bool -> FlatCurry.Curry_Types.C_TypeExpr -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_1 x2 x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_FuncType x3 x4 -> Curry_Prelude.C_True
  FlatCurry.Curry_Types.C_TVar x5 -> x2
  FlatCurry.Curry_Types.C_TCons x6 x7 -> x2
  FlatCurry.Curry_Types.C_ForallType x8 x9 -> x2
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i (d_C__case_1 x2
    l cd cs) (d_C__case_1 x2 r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    d_C__case_1 x2 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c ((\x ->
    d_C__case_1 x2 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "CurryDoc.Read._case_1" [show x2, show x1] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_1" (showCons x1))

d_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_0 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> x1
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '('#) x1) (Curry_Prelude.toCurryString ")") cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x1 l cd cs)
    (d_C__case_0 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CurryDoc.Read._case_0" [show x1, show x2] info)
  _ -> failCons cd (consFail "CurryDoc.Read._case_0" (showCons x2))

