{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module CPP.ICode.Curry_ICodeParser
  ( C_L1Token (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ICodeParser_dot_L1Token_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ICodeParser_dot_L1Token_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ICodeParser_dot_L1Token_hash
  , d_C_parse )
  where

import Basics
import qualified CPP.ICode.Curry_ParseMonad
import qualified CPP.ICode.Curry_ParsePos
import qualified CPP.ICode.Curry_ParseTypes
import qualified Curry_Prelude


data C_L1Token
  = C_Normal CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List
    Curry_Prelude.C_Char)
  | C_Exp CPP.ICode.Curry_ParsePos.C_Pos Curry_Prelude.C_Int
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | Choice_C_L1Token Cover ID C_L1Token C_L1Token
  | Choices_C_L1Token Cover ID [C_L1Token]
  | Fail_C_L1Token Cover FailInfo
  | Guard_C_L1Token Cover Constraints C_L1Token

instance Show C_L1Token where
  showsPrec d (Choice_C_L1Token cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_L1Token cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_L1Token cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_L1Token cd info) = showChar '!'
  showsPrec _ (C_Normal x1 x2) = showString "(Normal" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_Exp x1 x2 x3) = showString "(Exp" . (showChar ' ' . (shows x1 .
    (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . showChar ')'))))))

instance Read C_L1Token where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Normal x1 x2, r2) | (_, r0) <-
    readQualified "CPP.ICode.ICodeParser" "Normal" r, (x1, r1) <- readsPrec 11
    r0, (x2, r2) <- readsPrec 11 r1]) s ++ readParen ((>) d 10) (\r -> [(C_Exp
    x1 x2 x3, r3) | (_, r0) <- readQualified "CPP.ICode.ICodeParser" "Exp" r,
    (x1, r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <-
    readsPrec 11 r2]) s

instance NonDet C_L1Token where
  choiceCons = Choice_C_L1Token
  choicesCons = Choices_C_L1Token
  failCons = Fail_C_L1Token
  guardCons = Guard_C_L1Token
  try (Choice_C_L1Token cd i x y) = tryChoice cd i x y
  try (Choices_C_L1Token cd i xs) = tryChoices cd i xs
  try (Fail_C_L1Token cd info) = Fail cd info
  try (Guard_C_L1Token cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_L1Token cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_L1Token cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_L1Token cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_L1Token cd i _) = error
    ("CPP.ICode.ICodeParser.L1Token.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_L1Token cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_L1Token cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_L1Token where
  generate s c = Choices_C_L1Token c (freeID [2, 3] s) [C_Normal (generate
    (leftSupply s) c) (generate (rightSupply s) c), C_Exp (generate (leftSupply
    (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c) (generate
    (rightSupply s) c)]

instance NormalForm C_L1Token where
  ($!!) cont (C_Normal x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Normal y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_Exp x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> ($!!)
    (\y3 d cs -> cont (C_Exp y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_L1Token cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_L1Token cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_L1Token cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_L1Token cd info) _ _ = failCons cd info
  ($##) cont (C_Normal x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Normal y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_Exp x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> ($##)
    (\y3 d cs -> cont (C_Exp y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_L1Token cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_L1Token cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_L1Token cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_L1Token cd info) _ _ = failCons cd info
  showCons (C_Normal _ _) = "CPP.ICode.ICodeParser.Normal _ _"
  showCons (C_Exp _ _ _) = "CPP.ICode.ICodeParser.Exp _ _ _"
  showCons x = error
    ("CPP.ICode.ICodeParser.L1Token.showCons: no constructor: " ++ show x)
  searchNF search cont (C_Normal x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Normal y1 y2)) x2) x1
  searchNF search cont (C_Exp x1 x2 x3) = search (\y1 -> search (\y2 -> search
    (\y3 -> cont (C_Exp y1 y2 y3)) x3) x2) x1
  searchNF _ _ x = error
    ("CPP.ICode.ICodeParser.L1Token.searchNF: no constructor: " ++ show x)

instance Unifiable C_L1Token where
  (=.=) (C_Normal x1 x2) (C_Normal y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=)
    x2 y2 d cs) d cs
  (=.=) (C_Exp x1 x2 x3) (C_Exp y1 y2 y3) d cs = (&) ((=:=) x1 y1 d cs) ((&)
    ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Normal x1 x2) (C_Normal y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_Exp x1 x2 x3) (C_Exp y1 y2 y3) d cs = (&) ((=:<=) x1 y1 d cs) ((&)
    ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Normal x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID i)
    x3, bind cd (rightID i) x4]
  bind cd i (C_Exp x3 x4 x5) = (i :=: ChooseN 1 3) : concat [bind cd (leftID
    (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (rightID i) x5]
  bind d i (Choice_C_L1Token cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_L1Token cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_L1Token cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_L1Token cd i _) = error
    ("CPP.ICode.ICodeParser.L1Token.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_L1Token cd info) = [Unsolvable info]
  bind d i (Guard_C_L1Token cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Normal x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (C_Exp x3 x4 x5) = (i :=: ChooseN 1 3) : [leftID (leftID i) :=:
    LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x5)]
  lazyBind d i (Choice_C_L1Token cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_L1Token cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_L1Token cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_L1Token cd i _) = error
    ("CPP.ICode.ICodeParser.L1Token.lazyBind: Choices with ChoiceID: " ++ show
    i)
  lazyBind _ _ (Fail_C_L1Token cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_L1Token cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_L1Token where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ICodeParser_dot_L1Token_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_L1Token
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ICodeParser_dot_L1Token_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ICodeParser_dot_L1Token_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ICodeParser_dot_L1Token_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ICodeParser_dot_L1Token_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ICodeParser_dot_L1Token_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ICodeParser_dot_L1Token_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ICodeParser_dot_L1Token_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._inst#Prelude.Data#CPP.ICode.ICodeParser.L1Token#"
    [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser._inst#Prelude.Data#CPP.ICode.ICodeParser.L1Token#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ICodeParser_dot_L1Token_hash :: C_L1Token
  -> C_L1Token -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ICodeParser_dot_L1Token_hash x1 x2 s cd cs =
  case x1 of
  C_Normal x3 x4 -> let s0 = s in s0 `seq` nd_C__case_53 x4 x3 x2 s0 cd cs
  C_Exp x10 x11 x12 -> let s0 = s
    in s0 `seq` nd_C__case_52 x12 x11 x10 x2 s0 cd cs
  Choice_C_L1Token d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ICodeParser_dot_L1Token_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ICodeParser_dot_L1Token_hash
    r x2 s cd cs)
  Choices_C_L1Token d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ICodeParser_dot_L1Token_hash
    z x2 s cd cs) xs
  Guard_C_L1Token d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ICodeParser_dot_L1Token_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_L1Token d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._impl#===#Prelude.Data#CPP.ICode.ICodeParser.L1Token#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser._impl#===#Prelude.Data#CPP.ICode.ICodeParser.L1Token#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ICodeParser_dot_L1Token_hash :: IDSupply
  -> Cover -> ConstStore -> C_L1Token
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ICodeParser_dot_L1Token_hash s cd cs =
  let s9 = s
  in s9 `seq` (let s8 = leftSupply s9
                   s10 = rightSupply s9
                   s2 = leftSupply s10
                   s6 = rightSupply s10
  in s8 `seq` (s10 `seq` (s2 `seq` (s6 `seq` choice (let s0 = leftSupply s2
                                                         s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_Normal
  (CPP.ICode.Curry_ParsePos.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s1 cd cs))) (let s3 = leftSupply s6
                   s7 = rightSupply s6
                   s4 = leftSupply s7
                   s5 = rightSupply s7
  in s3 `seq` (s7 `seq` (s4 `seq` (s5 `seq` C_Exp
  (CPP.ICode.Curry_ParsePos.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
  s3 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s4 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s5 cd cs))))) s8 cd cs))))

d_C_s_ident :: Cover -> ConstStore -> Curry_Prelude.C_Char
d_C_s_ident cd cs = Curry_Prelude.C_Char '`'#

d_C_e_ident :: Cover -> ConstStore -> Curry_Prelude.C_Char
d_C_e_ident cd cs = Curry_Prelude.C_Char '\''#

d_C_min_number :: Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_min_number cd cs = Curry_Prelude.C_Int (2)

d_C_s_block_comment :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_s_block_comment cd cs = Curry_Prelude.toCurryString "{-"

d_C_e_block_comment :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_e_block_comment cd cs = Curry_Prelude.toCurryString "-}"

d_C_s_line_comment :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_s_line_comment cd cs = Curry_Prelude.toCurryString "--"

d_C_err_missing_quote :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_err_missing_quote cd cs = Curry_Prelude.toCurryString
  "Missing corresponding closing quote!"

d_C_err_missing_block :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_err_missing_block cd cs = Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString
  "Missing corresponding closing comment block delimiter ")
  (Curry_Prelude.d_OP_plus_plus (d_C_e_block_comment cd cs)
  (Curry_Prelude.toCurryString " !") cd cs) cd cs

d_C_err_missing_integ :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_err_missing_integ cd cs = Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString
  "Integrated code not terminated with correct number ")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "of ")
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (d_C_e_ident cd cs)
  Curry_Prelude.OP_List) (Curry_Prelude.toCurryString " chars") cd cs) cd cs) cd
  cs

d_C_err_no_langtag :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_err_no_langtag cd cs = Curry_Prelude.toCurryString
  "Missing language tag for integrated code!"

d_C_err_layout_code :: Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_err_layout_code cd cs = Curry_Prelude.toCurryString
  "Bad layout. Check amount of white spaces!"

d_C_parse :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  CPP.ICode.Curry_ParseTypes.C_StandardToken))
d_C_parse x1 x2 cd cs = Curry_Prelude.d_OP_dollar
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (CPP.ICode.Curry_ParseMonad.d_C_bindPM (d_C_parserL1
  (CPP.ICode.Curry_ParsePos.d_C_initPos x1 cd cs) x2 cd cs) d_C_parserL2 cd cs)
  cd cs

d_C_parserL1 :: CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM
  (Curry_Prelude.OP_List C_L1Token)
d_C_parserL1 x1 x2 cd cs = d_C_parserL1Iter Curry_Prelude.OP_List x1 x1 x2 cd cs

d_C_parserL1Iter :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List C_L1Token)
d_C_parserL1Iter x1 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> CPP.ICode.Curry_ParseMonad.d_C_cleanPM
    (Curry_Prelude.d_C_ifThenElse (Curry_Prelude.d_C_null x1 cd cs)
    Curry_Prelude.OP_List (Curry_Prelude.OP_Cons (C_Normal x2
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_reverse cd cs) x1 cd cs))
    Curry_Prelude.OP_List) cd cs) cd cs
  Curry_Prelude.OP_Cons x5 x6 -> d_C__case_51 x5 x4 x6 x3 x2 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x5 (Curry_Prelude.C_Char '"'#) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_parserL1Iter x1 x2 x3
    l cd cs) (d_C_parserL1Iter x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_parserL1Iter
    x1 x2 x3 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_parserL1Iter x1
    x2 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parserL1Iter" [show x1, show x2, show x3, show x4]
    info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser.parserL1Iter" (showCons x4))

d_OP_parserL1Iter_dot_passThrough_dot_31 :: forall t0 t1 . (Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => CPP.ICode.Curry_ParsePos.C_Pos
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (CPP.ICode.Curry_ParsePos.C_Pos -> Cover -> ConstStore
  -> t1 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List C_L1Token)) -> t1
  -> t0 -> Cover -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM
  (Curry_Prelude.OP_List C_L1Token)
d_OP_parserL1Iter_dot_passThrough_dot_31 x1 x2 x3 x4 x5 x6 cd cs = d_C__case_45
  x3 x6 x5 x2 x4 x1 (Curry_Prelude.d_C_null x3 cd cs) cd cs

nd_OP_parserL1Iter_dot_passThrough_dot_31 :: forall t0 t1 . (Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => CPP.ICode.Curry_ParsePos.C_Pos
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func CPP.ICode.Curry_ParsePos.C_Pos (Func t1 (Func t0
  (CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List C_L1Token)))) -> t1
  -> t0 -> IDSupply -> Cover -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM
  (Curry_Prelude.OP_List C_L1Token)
nd_OP_parserL1Iter_dot_passThrough_dot_31 x1 x2 x3 x4 x5 x6 s cd cs = let s0 = s
  in s0 `seq` nd_C__case_45 x3 x6 x5 x2 x4 x1 (Curry_Prelude.d_C_null x3 cd cs)
  s0 cd cs

d_OP_parserL1Iter_dot_passThroughInt_dot_31 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => CPP.ICode.Curry_ParsePos.C_Pos -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (CPP.ICode.Curry_ParsePos.C_Pos -> Cover -> ConstStore -> t2 -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List C_L1Token)) -> t2
  -> t1 -> t0 -> Cover -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM
  (Curry_Prelude.OP_List C_L1Token)
d_OP_parserL1Iter_dot_passThroughInt_dot_31 x1 x2 x3 x4 x5 x6 x7 cd cs =
  d_C__case_44 x3 x7 x6 x5 x2 x4 x1 (Curry_Prelude.d_C_null x3 cd cs) cd cs

nd_OP_parserL1Iter_dot_passThroughInt_dot_31 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => CPP.ICode.Curry_ParsePos.C_Pos -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  CPP.ICode.Curry_ParsePos.C_Pos (Func t2 (Func t1 (Func t0
  (CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List C_L1Token))))) -> t2
  -> t1 -> t0 -> IDSupply -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List C_L1Token)
nd_OP_parserL1Iter_dot_passThroughInt_dot_31 x1 x2 x3 x4 x5 x6 x7 s cd cs =
  let s0 = s
  in s0 `seq` nd_C__case_44 x3 x7 x6 x5 x2 x4 x1 (Curry_Prelude.d_C_null x3 cd
  cs) s0 cd cs

d_OP_parserL1Iter_dot_uscore_hash_selFP8_hash_isprefco :: Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Bool (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_parserL1Iter_dot_uscore_hash_selFP8_hash_isprefco x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_parserL1Iter_dot_uscore_hash_selFP8_hash_isprefco l cd cs)
    (d_OP_parserL1Iter_dot_uscore_hash_selFP8_hash_isprefco r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_parserL1Iter_dot_uscore_hash_selFP8_hash_isprefco z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_parserL1Iter_dot_uscore_hash_selFP8_hash_isprefco e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parserL1Iter._#selFP8#isprefco" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.parserL1Iter._#selFP8#isprefco" (showCons x1))

d_OP_parserL1Iter_dot_uscore_hash_selFP9_hash_rstco :: Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Bool (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_parserL1Iter_dot_uscore_hash_selFP9_hash_rstco x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_parserL1Iter_dot_uscore_hash_selFP9_hash_rstco l cd cs)
    (d_OP_parserL1Iter_dot_uscore_hash_selFP9_hash_rstco r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_parserL1Iter_dot_uscore_hash_selFP9_hash_rstco z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_parserL1Iter_dot_uscore_hash_selFP9_hash_rstco e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parserL1Iter._#selFP9#rstco" [show x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser.parserL1Iter._#selFP9#rstco"
    (showCons x1))

d_OP_parserL1Iter_dot_uscore_hash_selFP6_hash_isprefbc :: Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Bool (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_parserL1Iter_dot_uscore_hash_selFP6_hash_isprefbc x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_parserL1Iter_dot_uscore_hash_selFP6_hash_isprefbc l cd cs)
    (d_OP_parserL1Iter_dot_uscore_hash_selFP6_hash_isprefbc r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_parserL1Iter_dot_uscore_hash_selFP6_hash_isprefbc z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_parserL1Iter_dot_uscore_hash_selFP6_hash_isprefbc e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parserL1Iter._#selFP6#isprefbc" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.parserL1Iter._#selFP6#isprefbc" (showCons x1))

d_OP_parserL1Iter_dot_uscore_hash_selFP7_hash_rstbc :: Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Bool (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_parserL1Iter_dot_uscore_hash_selFP7_hash_rstbc x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_parserL1Iter_dot_uscore_hash_selFP7_hash_rstbc l cd cs)
    (d_OP_parserL1Iter_dot_uscore_hash_selFP7_hash_rstbc r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_parserL1Iter_dot_uscore_hash_selFP7_hash_rstbc z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_parserL1Iter_dot_uscore_hash_selFP7_hash_rstbc e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parserL1Iter._#selFP7#rstbc" [show x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser.parserL1Iter._#selFP7#rstbc"
    (showCons x1))

d_OP_parserL1Iter_dot_uscore_hash_selFP4_hash_n :: Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_Int
d_OP_parserL1Iter_dot_uscore_hash_selFP4_hash_n x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_parserL1Iter_dot_uscore_hash_selFP4_hash_n l cd cs)
    (d_OP_parserL1Iter_dot_uscore_hash_selFP4_hash_n r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_parserL1Iter_dot_uscore_hash_selFP4_hash_n z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_parserL1Iter_dot_uscore_hash_selFP4_hash_n e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parserL1Iter._#selFP4#n" [show x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser.parserL1Iter._#selFP4#n"
    (showCons x1))

d_OP_parserL1Iter_dot_uscore_hash_selFP5_hash_r :: Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_parserL1Iter_dot_uscore_hash_selFP5_hash_r x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_parserL1Iter_dot_uscore_hash_selFP5_hash_r l cd cs)
    (d_OP_parserL1Iter_dot_uscore_hash_selFP5_hash_r r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_parserL1Iter_dot_uscore_hash_selFP5_hash_r z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_parserL1Iter_dot_uscore_hash_selFP5_hash_r e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parserL1Iter._#selFP5#r" [show x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser.parserL1Iter._#selFP5#r"
    (showCons x1))

d_C_isPrefixAndDrop :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Bool (Curry_Prelude.OP_List t0)
d_C_isPrefixAndDrop x1 x2 x3 cd cs = case x2 of
  Curry_Prelude.OP_List -> d_C__case_43 x3 cd cs
  Curry_Prelude.OP_Cons x6 x7 -> d_C__case_42 x6 x1 x7 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_isPrefixAndDrop x1 l
    x3 cd cs) (d_C_isPrefixAndDrop x1 r x3 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_isPrefixAndDrop x1 z x3 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_isPrefixAndDrop
    x1 e x3 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.isPrefixAndDrop" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser.isPrefixAndDrop" (showCons
    x2))

nd_C_isPrefixAndDrop :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Bool
  (Curry_Prelude.OP_List t0)
nd_C_isPrefixAndDrop x1 x2 x3 s cd cs = case x2 of
  Curry_Prelude.OP_List -> d_C__case_43 x3 cd cs
  Curry_Prelude.OP_Cons x6 x7 -> let s0 = s
    in s0 `seq` nd_C__case_42 x6 x1 x7 x3 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_isPrefixAndDrop x1 l
    x3 s cd cs) (nd_C_isPrefixAndDrop x1 r x3 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_C_isPrefixAndDrop x1 z x3 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    nd_C_isPrefixAndDrop x1 e x3 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.isPrefixAndDrop" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser.isPrefixAndDrop" (showCons
    x2))

d_C_countAndDrop :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> t0 -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List t0)
d_C_countAndDrop x1 x2 x3 cd cs = d_OP_countAndDrop_dot_countAndDropIter_dot_53
  x2 x1
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.C_Int (0)) x3 cd cs

nd_C_countAndDrop :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> t0
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List t0)
nd_C_countAndDrop x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` nd_OP_countAndDrop_dot_countAndDropIter_dot_53 x2 x1 (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash)
  (Curry_Prelude.C_Int (0)) x3 s0 cd cs

d_OP_countAndDrop_dot_countAndDropIter_dot_53 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Num t0) -> t0
  -> Curry_Prelude.OP_List t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  t0 (Curry_Prelude.OP_List t1)
d_OP_countAndDrop_dot_countAndDropIter_dot_53 x1 x2 x3 x4 x5 cd cs = case x5 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 x4 Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x6 x7 -> d_C__case_39 x6 x1 x2 x7 x4 x3
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq
    x2 cd cs) x1 cd cs) x6 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_countAndDrop_dot_countAndDropIter_dot_53 x1 x2 x3 x4 l cd cs)
    (d_OP_countAndDrop_dot_countAndDropIter_dot_53 x1 x2 x3 x4 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_countAndDrop_dot_countAndDropIter_dot_53 x1 x2 x3 x4 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_countAndDrop_dot_countAndDropIter_dot_53 x1 x2 x3 x4 e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.countAndDrop.countAndDropIter.53" [show x1, show x2
    , show x3, show x4, show x5] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.countAndDrop.countAndDropIter.53" (showCons x5))

nd_OP_countAndDrop_dot_countAndDropIter_dot_53 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Num t0) -> t0
  -> Curry_Prelude.OP_List t1 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List t1)
nd_OP_countAndDrop_dot_countAndDropIter_dot_53 x1 x2 x3 x4 x5 s cd cs =
  case x5 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 x4 Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x6 x7 -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_39 x6 x1 x2 x7 x4 x3 (let s3 = leftSupply
                                                                 s4
                                                               s2 = rightSupply
                                                                 s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq x2
    s0 cd cs) x1 s1 cd cs)) x6 s3 cd cs)) s5 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (nd_OP_countAndDrop_dot_countAndDropIter_dot_53 x1 x2 x3 x4 l s cd cs)
    (nd_OP_countAndDrop_dot_countAndDropIter_dot_53 x1 x2 x3 x4 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_OP_countAndDrop_dot_countAndDropIter_dot_53 x1 x2 x3 x4 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    nd_OP_countAndDrop_dot_countAndDropIter_dot_53 x1 x2 x3 x4 e s cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.countAndDrop.countAndDropIter.53" [show x1, show x2
    , show x3, show x4, show x5] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.countAndDrop.countAndDropIter.53" (showCons x5))

d_C_parseQuotation :: CPP.ICode.Curry_ParsePos.C_Pos
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM
  (Curry_Prelude.OP_List C_L1Token)
d_C_parseQuotation x1 x2 x3 cd cs = let x4 = d_C_findUnescapedChar x2
                                          (Curry_Prelude.C_Char '"'#)
                                          (Curry_Prelude.C_Char '\\'#) x3 cd cs
                                        x5 = d_OP_parseQuotation_dot_uscore_hash_selFP11_hash_qu
                                          x4 cd cs
                                        x6 = d_OP_parseQuotation_dot_uscore_hash_selFP12_hash_rst
                                          x4 cd cs
                                        x7 = d_OP_parseQuotation_dot_uscore_hash_selFP13_hash_fnd
                                          x4 cd cs
                                        x8 = d_OP_parseQuotation_dot_uscore_hash_selFP14_hash_pos
                                          x4 cd cs
  in d_C__case_37 x1 x6 x8 x5 x7 cd cs

d_OP_parseQuotation_dot_uscore_hash_selFP11_hash_qu :: Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_parseQuotation_dot_uscore_hash_selFP11_hash_qu x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> x2
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_parseQuotation_dot_uscore_hash_selFP11_hash_qu l cd cs)
    (d_OP_parseQuotation_dot_uscore_hash_selFP11_hash_qu r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_parseQuotation_dot_uscore_hash_selFP11_hash_qu z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c ((\x ->
    d_OP_parseQuotation_dot_uscore_hash_selFP11_hash_qu e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parseQuotation._#selFP11#qu" [show x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser.parseQuotation._#selFP11#qu"
    (showCons x1))

d_OP_parseQuotation_dot_uscore_hash_selFP12_hash_rst :: Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_parseQuotation_dot_uscore_hash_selFP12_hash_rst x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> x3
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_parseQuotation_dot_uscore_hash_selFP12_hash_rst l cd cs)
    (d_OP_parseQuotation_dot_uscore_hash_selFP12_hash_rst r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_parseQuotation_dot_uscore_hash_selFP12_hash_rst z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c ((\x ->
    d_OP_parseQuotation_dot_uscore_hash_selFP12_hash_rst e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parseQuotation._#selFP12#rst" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.parseQuotation._#selFP12#rst" (showCons x1))

d_OP_parseQuotation_dot_uscore_hash_selFP13_hash_fnd :: Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_parseQuotation_dot_uscore_hash_selFP13_hash_fnd x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> x4
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_parseQuotation_dot_uscore_hash_selFP13_hash_fnd l cd cs)
    (d_OP_parseQuotation_dot_uscore_hash_selFP13_hash_fnd r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_parseQuotation_dot_uscore_hash_selFP13_hash_fnd z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c ((\x ->
    d_OP_parseQuotation_dot_uscore_hash_selFP13_hash_fnd e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parseQuotation._#selFP13#fnd" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.parseQuotation._#selFP13#fnd" (showCons x1))

d_OP_parseQuotation_dot_uscore_hash_selFP14_hash_pos :: Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
  -> Cover -> ConstStore -> CPP.ICode.Curry_ParsePos.C_Pos
d_OP_parseQuotation_dot_uscore_hash_selFP14_hash_pos x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> x5
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_parseQuotation_dot_uscore_hash_selFP14_hash_pos l cd cs)
    (d_OP_parseQuotation_dot_uscore_hash_selFP14_hash_pos r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_parseQuotation_dot_uscore_hash_selFP14_hash_pos z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c ((\x ->
    d_OP_parseQuotation_dot_uscore_hash_selFP14_hash_pos e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parseQuotation._#selFP14#pos" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.parseQuotation._#selFP14#pos" (showCons x1))

d_C_findUnescapedChar :: CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
d_C_findUnescapedChar x1 x2 x3 x4 cd cs =
  d_OP_findUnescapedChar_dot_findUnescapedCharHelper_dot_63 x2 x3 x1
  Curry_Prelude.OP_List x4 cd cs

d_OP_findUnescapedChar_dot_findUnescapedCharHelper_dot_63 :: Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
d_OP_findUnescapedChar_dot_findUnescapedCharHelper_dot_63 x1 x2 x3 x4 x5 cd cs =
  case x5 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_reverse cd cs) x4 cd cs) Curry_Prelude.OP_List
    Curry_Prelude.C_False x3
  Curry_Prelude.OP_Cons x6 x7 -> d_C__case_36 x1 x6 x2 x4 x3 x7 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_findUnescapedChar_dot_findUnescapedCharHelper_dot_63 x1 x2 x3 x4 l cd
    cs) (d_OP_findUnescapedChar_dot_findUnescapedCharHelper_dot_63 x1 x2 x3 x4 r
    cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_findUnescapedChar_dot_findUnescapedCharHelper_dot_63 x1 x2 x3 x4 z cd
    cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_findUnescapedChar_dot_findUnescapedCharHelper_dot_63 x1 x2 x3 x4 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.findUnescapedChar.findUnescapedCharHelper.63" [show
    x1, show x2, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.findUnescapedChar.findUnescapedCharHelper.63"
    (showCons x5))

d_C_parseSingleQuote :: CPP.ICode.Curry_ParsePos.C_Pos
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM
  (Curry_Prelude.OP_List C_L1Token)
d_C_parseSingleQuote x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> CPP.ICode.Curry_ParseMonad.d_C_cleanPM
    (Curry_Prelude.OP_Cons (C_Normal x1 (Curry_Prelude.toCurryString "'"))
    Curry_Prelude.OP_List) cd cs
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_30 x2 x1 x4 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_parseSingleQuote x1 x2
    l cd cs) (d_C_parseSingleQuote x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_parseSingleQuote x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_C_parseSingleQuote x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parseSingleQuote" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser.parseSingleQuote" (showCons
    x3))

d_C_parseLineComment :: CPP.ICode.Curry_ParsePos.C_Pos
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM
  (Curry_Prelude.OP_List C_L1Token)
d_C_parseLineComment x1 x2 x3 cd cs = let x4 = d_C_findSequence x2
                                            (Curry_Prelude.toCurryString "\n")
                                            x3 cd cs
                                          x5 = d_OP_parseLineComment_dot_uscore_hash_selFP16_hash_co
                                            x4 cd cs
                                          x6 = d_OP_parseLineComment_dot_uscore_hash_selFP17_hash_rst
                                            x4 cd cs
                                          x7 = d_OP_parseLineComment_dot_uscore_hash_selFP18_hash_fnd
                                            x4 cd cs
                                          x8 = d_OP_parseLineComment_dot_uscore_hash_selFP19_hash_pos
                                            x4 cd cs
  in d_C__case_21 x5 x1 x6 x8 x7 cd cs

d_OP_parseLineComment_dot_uscore_hash_selFP16_hash_co :: Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_parseLineComment_dot_uscore_hash_selFP16_hash_co x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> x2
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_parseLineComment_dot_uscore_hash_selFP16_hash_co l cd cs)
    (d_OP_parseLineComment_dot_uscore_hash_selFP16_hash_co r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_parseLineComment_dot_uscore_hash_selFP16_hash_co z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c ((\x ->
    d_OP_parseLineComment_dot_uscore_hash_selFP16_hash_co e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parseLineComment._#selFP16#co" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.parseLineComment._#selFP16#co" (showCons x1))

d_OP_parseLineComment_dot_uscore_hash_selFP17_hash_rst :: Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_parseLineComment_dot_uscore_hash_selFP17_hash_rst x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> x3
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_parseLineComment_dot_uscore_hash_selFP17_hash_rst l cd cs)
    (d_OP_parseLineComment_dot_uscore_hash_selFP17_hash_rst r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_parseLineComment_dot_uscore_hash_selFP17_hash_rst z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c ((\x ->
    d_OP_parseLineComment_dot_uscore_hash_selFP17_hash_rst e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parseLineComment._#selFP17#rst" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.parseLineComment._#selFP17#rst" (showCons x1))

d_OP_parseLineComment_dot_uscore_hash_selFP18_hash_fnd :: Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_parseLineComment_dot_uscore_hash_selFP18_hash_fnd x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> x4
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_parseLineComment_dot_uscore_hash_selFP18_hash_fnd l cd cs)
    (d_OP_parseLineComment_dot_uscore_hash_selFP18_hash_fnd r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_parseLineComment_dot_uscore_hash_selFP18_hash_fnd z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c ((\x ->
    d_OP_parseLineComment_dot_uscore_hash_selFP18_hash_fnd e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parseLineComment._#selFP18#fnd" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.parseLineComment._#selFP18#fnd" (showCons x1))

d_OP_parseLineComment_dot_uscore_hash_selFP19_hash_pos :: Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
  -> Cover -> ConstStore -> CPP.ICode.Curry_ParsePos.C_Pos
d_OP_parseLineComment_dot_uscore_hash_selFP19_hash_pos x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> x5
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_parseLineComment_dot_uscore_hash_selFP19_hash_pos l cd cs)
    (d_OP_parseLineComment_dot_uscore_hash_selFP19_hash_pos r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_parseLineComment_dot_uscore_hash_selFP19_hash_pos z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c ((\x ->
    d_OP_parseLineComment_dot_uscore_hash_selFP19_hash_pos e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parseLineComment._#selFP19#pos" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.parseLineComment._#selFP19#pos" (showCons x1))

d_C_parseBlockComment :: CPP.ICode.Curry_ParsePos.C_Pos
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM
  (Curry_Prelude.OP_List C_L1Token)
d_C_parseBlockComment x1 x2 x3 cd cs = let x4 = d_C_findSequence x2
                                             (d_C_e_block_comment cd cs) x3 cd
                                             cs
                                           x5 = d_OP_parseBlockComment_dot_uscore_hash_selFP21_hash_blc
                                             x4 cd cs
                                           x6 = d_OP_parseBlockComment_dot_uscore_hash_selFP22_hash_rst
                                             x4 cd cs
                                           x7 = d_OP_parseBlockComment_dot_uscore_hash_selFP23_hash_fnd
                                             x4 cd cs
                                           x8 = d_OP_parseBlockComment_dot_uscore_hash_selFP24_hash_pos
                                             x4 cd cs
  in d_C__case_20 x1 x6 x8 x5 x7 cd cs

d_OP_parseBlockComment_dot_uscore_hash_selFP21_hash_blc :: Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_parseBlockComment_dot_uscore_hash_selFP21_hash_blc x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> x2
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_parseBlockComment_dot_uscore_hash_selFP21_hash_blc l cd cs)
    (d_OP_parseBlockComment_dot_uscore_hash_selFP21_hash_blc r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_parseBlockComment_dot_uscore_hash_selFP21_hash_blc z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c ((\x ->
    d_OP_parseBlockComment_dot_uscore_hash_selFP21_hash_blc e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parseBlockComment._#selFP21#blc" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.parseBlockComment._#selFP21#blc" (showCons x1))

d_OP_parseBlockComment_dot_uscore_hash_selFP22_hash_rst :: Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_parseBlockComment_dot_uscore_hash_selFP22_hash_rst x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> x3
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_parseBlockComment_dot_uscore_hash_selFP22_hash_rst l cd cs)
    (d_OP_parseBlockComment_dot_uscore_hash_selFP22_hash_rst r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_parseBlockComment_dot_uscore_hash_selFP22_hash_rst z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c ((\x ->
    d_OP_parseBlockComment_dot_uscore_hash_selFP22_hash_rst e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parseBlockComment._#selFP22#rst" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.parseBlockComment._#selFP22#rst" (showCons x1))

d_OP_parseBlockComment_dot_uscore_hash_selFP23_hash_fnd :: Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_parseBlockComment_dot_uscore_hash_selFP23_hash_fnd x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> x4
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_parseBlockComment_dot_uscore_hash_selFP23_hash_fnd l cd cs)
    (d_OP_parseBlockComment_dot_uscore_hash_selFP23_hash_fnd r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_parseBlockComment_dot_uscore_hash_selFP23_hash_fnd z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c ((\x ->
    d_OP_parseBlockComment_dot_uscore_hash_selFP23_hash_fnd e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parseBlockComment._#selFP23#fnd" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.parseBlockComment._#selFP23#fnd" (showCons x1))

d_OP_parseBlockComment_dot_uscore_hash_selFP24_hash_pos :: Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
  -> Cover -> ConstStore -> CPP.ICode.Curry_ParsePos.C_Pos
d_OP_parseBlockComment_dot_uscore_hash_selFP24_hash_pos x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> x5
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_parseBlockComment_dot_uscore_hash_selFP24_hash_pos l cd cs)
    (d_OP_parseBlockComment_dot_uscore_hash_selFP24_hash_pos r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_parseBlockComment_dot_uscore_hash_selFP24_hash_pos z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c ((\x ->
    d_OP_parseBlockComment_dot_uscore_hash_selFP24_hash_pos e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parseBlockComment._#selFP24#pos" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.parseBlockComment._#selFP24#pos" (showCons x1))

d_C_findSequence :: CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
d_C_findSequence x1 x2 x3 cd cs = d_OP_findSequence_dot_findSequenceIter_dot_93
  x2 x1 Curry_Prelude.OP_List x2 x3 cd cs

d_OP_findSequence_dot_findSequenceIter_dot_93 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
d_OP_findSequence_dot_findSequenceIter_dot_93 x1 x2 x3 x4 x5 cd cs = case x4 of
  Curry_Prelude.OP_List -> d_C__case_19 x2 x3 x5 cd cs
  Curry_Prelude.OP_Cons x8 x9 -> d_C__case_18 x8 x1 x3 x2 x9 x5 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_findSequence_dot_findSequenceIter_dot_93 x1 x2 x3 l x5 cd cs)
    (d_OP_findSequence_dot_findSequenceIter_dot_93 x1 x2 x3 r x5 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_findSequence_dot_findSequenceIter_dot_93 x1 x2 x3 z x5 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_findSequence_dot_findSequenceIter_dot_93 x1 x2 x3 e x5 cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.findSequence.findSequenceIter.93" [show x1, show x2
    , show x3, show x4, show x5] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.findSequence.findSequenceIter.93" (showCons x4))

d_C_parseIntegrated :: CPP.ICode.Curry_ParsePos.C_Pos
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List C_L1Token)
d_C_parseIntegrated x1 x2 x3 x4 cd cs = let x5 = d_C_findReplicate x2 x3
                                              (d_C_e_ident cd cs) (d_C_s_ident
                                              cd cs) x4 cd cs
                                            x6 = d_OP_parseIntegrated_dot_uscore_hash_selFP26_hash_exp
                                              x5 cd cs
                                            x7 = d_OP_parseIntegrated_dot_uscore_hash_selFP27_hash_rst
                                              x5 cd cs
                                            x8 = d_OP_parseIntegrated_dot_uscore_hash_selFP28_hash_fnd
                                              x5 cd cs
                                            x9 = d_OP_parseIntegrated_dot_uscore_hash_selFP29_hash_pos
                                              x5 cd cs
  in d_C__case_15 x1 x7 x9 x6 x3 x8 cd cs

d_OP_parseIntegrated_dot_uscore_hash_selFP26_hash_exp :: Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_parseIntegrated_dot_uscore_hash_selFP26_hash_exp x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> x2
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_parseIntegrated_dot_uscore_hash_selFP26_hash_exp l cd cs)
    (d_OP_parseIntegrated_dot_uscore_hash_selFP26_hash_exp r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_parseIntegrated_dot_uscore_hash_selFP26_hash_exp z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c ((\x ->
    d_OP_parseIntegrated_dot_uscore_hash_selFP26_hash_exp e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parseIntegrated._#selFP26#exp" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.parseIntegrated._#selFP26#exp" (showCons x1))

d_OP_parseIntegrated_dot_uscore_hash_selFP27_hash_rst :: Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_parseIntegrated_dot_uscore_hash_selFP27_hash_rst x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> x3
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_parseIntegrated_dot_uscore_hash_selFP27_hash_rst l cd cs)
    (d_OP_parseIntegrated_dot_uscore_hash_selFP27_hash_rst r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_parseIntegrated_dot_uscore_hash_selFP27_hash_rst z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c ((\x ->
    d_OP_parseIntegrated_dot_uscore_hash_selFP27_hash_rst e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parseIntegrated._#selFP27#rst" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.parseIntegrated._#selFP27#rst" (showCons x1))

d_OP_parseIntegrated_dot_uscore_hash_selFP28_hash_fnd :: Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_parseIntegrated_dot_uscore_hash_selFP28_hash_fnd x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> x4
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_parseIntegrated_dot_uscore_hash_selFP28_hash_fnd l cd cs)
    (d_OP_parseIntegrated_dot_uscore_hash_selFP28_hash_fnd r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_parseIntegrated_dot_uscore_hash_selFP28_hash_fnd z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c ((\x ->
    d_OP_parseIntegrated_dot_uscore_hash_selFP28_hash_fnd e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parseIntegrated._#selFP28#fnd" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.parseIntegrated._#selFP28#fnd" (showCons x1))

d_OP_parseIntegrated_dot_uscore_hash_selFP29_hash_pos :: Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
  -> Cover -> ConstStore -> CPP.ICode.Curry_ParsePos.C_Pos
d_OP_parseIntegrated_dot_uscore_hash_selFP29_hash_pos x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> x5
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_parseIntegrated_dot_uscore_hash_selFP29_hash_pos l cd cs)
    (d_OP_parseIntegrated_dot_uscore_hash_selFP29_hash_pos r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_parseIntegrated_dot_uscore_hash_selFP29_hash_pos z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c ((\x ->
    d_OP_parseIntegrated_dot_uscore_hash_selFP29_hash_pos e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parseIntegrated._#selFP29#pos" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.parseIntegrated._#selFP29#pos" (showCons x1))

d_C_findReplicate :: CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
d_C_findReplicate x1 x2 x3 x4 x5 cd cs =
  d_OP_findReplicate_dot_findReplicateIter_dot_109 x1 x3 x4 x2 x5 x1
  Curry_Prelude.OP_List (Curry_Prelude.C_Int (0)) x5 cd cs

d_OP_findReplicate_dot_findReplicateIter_dot_109 :: CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
d_OP_findReplicate_dot_findReplicateIter_dot_109 x1 x2 x3 x4 x5 x6 x7 x8 x9 cd cs =
  case x9 of
  Curry_Prelude.OP_List -> d_C__case_14 x4 x8 x6 x7 x1 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x8
    (Curry_Prelude.d_OP_uscore_impl_hash_negate_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x4 cd cs) cd cs) cd cs
  Curry_Prelude.OP_Cons x10 x11 -> d_C__case_13 x4 x8 x10 x2 x3 x11 x7 x6 x5 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x8 x4 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_findReplicate_dot_findReplicateIter_dot_109 x1 x2 x3 x4 x5 x6 x7 x8 l
    cd cs) (d_OP_findReplicate_dot_findReplicateIter_dot_109 x1 x2 x3 x4 x5 x6
    x7 x8 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_findReplicate_dot_findReplicateIter_dot_109 x1 x2 x3 x4 x5 x6 x7 x8 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_findReplicate_dot_findReplicateIter_dot_109 x1 x2 x3 x4 x5 x6 x7 x8 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.findReplicate.findReplicateIter.109" [show x1, show
    x2, show x3, show x4, show x5, show x6, show x7, show x8, show x9] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.findReplicate.findReplicateIter.109" (showCons x9))

d_C_parserL2 :: Curry_Prelude.OP_List C_L1Token -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  CPP.ICode.Curry_ParseTypes.C_StandardToken)
d_C_parserL2 x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> CPP.ICode.Curry_ParseMonad.d_C_cleanPM
    Curry_Prelude.OP_List cd cs
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_7 x2 x3 (d_C_isNormal x2 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_parserL2 l cd cs)
    (d_C_parserL2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_parserL2 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_parserL2 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.parserL2" [show x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser.parserL2" (showCons x1))

d_OP_parserL2_dot_uscore_hash_lambda2 :: Curry_Prelude.OP_List C_L1Token
  -> CPP.ICode.Curry_ParseTypes.C_StandardToken -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  CPP.ICode.Curry_ParseTypes.C_StandardToken)
d_OP_parserL2_dot_uscore_hash_lambda2 x1 x2 cd cs = Curry_Prelude.d_OP_dollar
  (CPP.ICode.Curry_ParseMonad.d_C_liftPM (acceptCs id (Curry_Prelude.OP_Cons
  x2))) (d_C_parserL2 x1 cd cs) cd cs

d_C_isNormal :: C_L1Token -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isNormal x1 cd cs = case x1 of
  C_Normal x2 x3 -> Curry_Prelude.C_True
  C_Exp x4 x5 x6 -> Curry_Prelude.C_False
  Choice_C_L1Token d i l r -> narrow d i (d_C_isNormal l cd cs) (d_C_isNormal r
    cd cs)
  Choices_C_L1Token d i xs -> narrows cs d i (\z -> d_C_isNormal z cd cs) xs
  Guard_C_L1Token d c e -> guardCons d c ((\x -> d_C_isNormal e cd x) $! addCs c
    cs)
  Fail_C_L1Token d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.isNormal" [show x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser.isNormal" (showCons x1))

d_C_normalToStTk :: C_L1Token -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseTypes.C_StandardToken
d_C_normalToStTk x1 cd cs = case x1 of
  C_Normal x2 x3 -> CPP.ICode.Curry_ParseTypes.C_StTk x2 x2
    Curry_Prelude.C_Nothing x3
  C_Exp x4 x5 x6 -> Curry_Prelude.d_C_failed cd cs
  Choice_C_L1Token d i l r -> narrow d i (d_C_normalToStTk l cd cs)
    (d_C_normalToStTk r cd cs)
  Choices_C_L1Token d i xs -> narrows cs d i (\z -> d_C_normalToStTk z cd cs) xs
  Guard_C_L1Token d c e -> guardCons d c ((\x -> d_C_normalToStTk e cd x) $!
    addCs c cs)
  Fail_C_L1Token d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.normalToStTk" [show x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser.normalToStTk" (showCons x1))

d_C_disassembleIntExp :: C_L1Token -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM CPP.ICode.Curry_ParseTypes.C_StandardToken
d_C_disassembleIntExp x1 cd cs = case x1 of
  C_Exp x2 x3 x4 -> let x5 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_break
                          Curry_Prelude.d_C_isSpace cd cs) x4 cd cs
                        x6 = d_OP_disassembleIntExp_dot_uscore_hash_selFP34_hash_langtag
                          x5 cd cs
                        x7 = d_OP_disassembleIntExp_dot_uscore_hash_selFP35_hash_rest1
                          x5 cd cs
                        x8 = Curry_Prelude.d_C_span Curry_Prelude.d_C_isSpace x7
                          cd cs
                        x9 = d_OP_disassembleIntExp_dot_uscore_hash_selFP32_hash_spaces
                          x8 cd cs
                        x10 = d_OP_disassembleIntExp_dot_uscore_hash_selFP33_hash_dsl
                          x8 cd cs
    in d_C__case_5 x6 x10 x9 x3 x2 (Curry_Prelude.d_C_null x6 cd cs) cd cs
  C_Normal x14 x15 -> Curry_Prelude.d_C_failed cd cs
  Choice_C_L1Token d i l r -> narrow d i (d_C_disassembleIntExp l cd cs)
    (d_C_disassembleIntExp r cd cs)
  Choices_C_L1Token d i xs -> narrows cs d i (\z -> d_C_disassembleIntExp z cd
    cs) xs
  Guard_C_L1Token d c e -> guardCons d c ((\x -> d_C_disassembleIntExp e cd
    x) $! addCs c cs)
  Fail_C_L1Token d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.disassembleIntExp" [show x1] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser.disassembleIntExp" (showCons
    x1))

d_OP_disassembleIntExp_dot_uscore_hash_selFP34_hash_langtag :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_disassembleIntExp_dot_uscore_hash_selFP34_hash_langtag x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_disassembleIntExp_dot_uscore_hash_selFP34_hash_langtag l cd cs)
    (d_OP_disassembleIntExp_dot_uscore_hash_selFP34_hash_langtag r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_disassembleIntExp_dot_uscore_hash_selFP34_hash_langtag z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_disassembleIntExp_dot_uscore_hash_selFP34_hash_langtag e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.disassembleIntExp._#selFP34#langtag" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.disassembleIntExp._#selFP34#langtag" (showCons x1))

d_OP_disassembleIntExp_dot_uscore_hash_selFP35_hash_rest1 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_disassembleIntExp_dot_uscore_hash_selFP35_hash_rest1 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_disassembleIntExp_dot_uscore_hash_selFP35_hash_rest1 l cd cs)
    (d_OP_disassembleIntExp_dot_uscore_hash_selFP35_hash_rest1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_disassembleIntExp_dot_uscore_hash_selFP35_hash_rest1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_disassembleIntExp_dot_uscore_hash_selFP35_hash_rest1 e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.disassembleIntExp._#selFP35#rest1" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.disassembleIntExp._#selFP35#rest1" (showCons x1))

d_OP_disassembleIntExp_dot_uscore_hash_selFP32_hash_spaces :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_disassembleIntExp_dot_uscore_hash_selFP32_hash_spaces x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_disassembleIntExp_dot_uscore_hash_selFP32_hash_spaces l cd cs)
    (d_OP_disassembleIntExp_dot_uscore_hash_selFP32_hash_spaces r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_disassembleIntExp_dot_uscore_hash_selFP32_hash_spaces z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_disassembleIntExp_dot_uscore_hash_selFP32_hash_spaces e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.disassembleIntExp._#selFP32#spaces" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.disassembleIntExp._#selFP32#spaces" (showCons x1))

d_OP_disassembleIntExp_dot_uscore_hash_selFP33_hash_dsl :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_disassembleIntExp_dot_uscore_hash_selFP33_hash_dsl x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_disassembleIntExp_dot_uscore_hash_selFP33_hash_dsl l cd cs)
    (d_OP_disassembleIntExp_dot_uscore_hash_selFP33_hash_dsl r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_disassembleIntExp_dot_uscore_hash_selFP33_hash_dsl z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_disassembleIntExp_dot_uscore_hash_selFP33_hash_dsl e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.disassembleIntExp._#selFP33#dsl" [show x1] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.disassembleIntExp._#selFP33#dsl" (showCons x1))

d_OP_disassembleIntExp_dot_uscore_hash_lambda4 :: CPP.ICode.Curry_ParsePos.C_Pos
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM
  CPP.ICode.Curry_ParseTypes.C_StandardToken
d_OP_disassembleIntExp_dot_uscore_hash_lambda4 x1 x2 x3 x4 cd cs =
  CPP.ICode.Curry_ParseMonad.d_C_cleanPM (CPP.ICode.Curry_ParseTypes.C_StTk x1
  x2 (Curry_Prelude.C_Just x3) x4) cd cs

d_C_removeOffset :: CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C_removeOffset x1 x2 x3 cd cs = let x4 = Curry_Prelude.d_C_lines x3 cd cs
  in d_C__case_4 x2 x1 x4 cd cs

d_C_removeOffsetFromLines :: CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C_removeOffsetFromLines x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> CPP.ICode.Curry_ParseMonad.d_C_cleanPM
    Curry_Prelude.OP_List cd cs
  Curry_Prelude.OP_Cons x4 x5 -> let x6 = d_C_removeOffsetFromLine x1 x2 x4 cd
                                       cs
    in CPP.ICode.Curry_ParseMonad.d_C_bindPM x6
    (d_OP_removeOffsetFromLines_dot_uscore_hash_lambda6 x2 x5) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_removeOffsetFromLines
    x1 x2 l cd cs) (d_C_removeOffsetFromLines x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_C_removeOffsetFromLines x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_C_removeOffsetFromLines x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.removeOffsetFromLines" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser.removeOffsetFromLines"
    (showCons x3))

d_OP_removeOffsetFromLines_dot_uscore_hash_lambda6 :: Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_Tuple2 CPP.ICode.Curry_ParsePos.C_Pos
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_removeOffsetFromLines_dot_uscore_hash_lambda6 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.d_OP_dollar
    (CPP.ICode.Curry_ParseMonad.d_C_liftPM (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '\n'#) x5)))
    (d_C_removeOffsetFromLines (CPP.ICode.Curry_ParsePos.d_C_movePosByChar x4
    (Curry_Prelude.C_Char '\n'#) cd cs) x1 x2 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_removeOffsetFromLines_dot_uscore_hash_lambda6 x1 x2 l cd cs)
    (d_OP_removeOffsetFromLines_dot_uscore_hash_lambda6 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_removeOffsetFromLines_dot_uscore_hash_lambda6 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_removeOffsetFromLines_dot_uscore_hash_lambda6 x1 x2 e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser.removeOffsetFromLines._#lambda6" [show x1, show x2
    , show x3] info)
  _ -> failCons cd (consFail
    "CPP.ICode.ICodeParser.removeOffsetFromLines._#lambda6" (showCons x3))

d_C_removeOffsetFromLine :: CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_Tuple2
  CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_removeOffsetFromLine x1 x2 x3 cd cs =
  d_OP_removeOffsetFromLine_dot_removeOffsetFromLineIter_dot_169 x1 x2 x1 x3 cd
  cs

d_OP_removeOffsetFromLine_dot_removeOffsetFromLineIter_dot_169 :: CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.C_Int -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_Tuple2
  CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_removeOffsetFromLine_dot_removeOffsetFromLineIter_dot_169 x1 x2 x3 x4 cd cs =
  d_C__case_2 x2 x3 x4 x1 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) (CPP.ICode.Curry_ParsePos.d_C_getCol x3 cd cs) cd cs) x2 cd cs) cd cs

d_C_isWhiteSpace :: Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isWhiteSpace x1 cd cs = Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.C_Char ' '#) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.C_Char '\t'#) cd cs) cd cs

nd_C__case_52 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> CPP.ICode.Curry_ParsePos.C_Pos -> C_L1Token
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_52 x12 x11 x10 x2 s cd cs = case x2 of
  C_Normal x13 x14 -> Curry_Prelude.C_False
  C_Exp x15 x16 x17 -> let s6 = s
    in s6 `seq` (let s4 = leftSupply s6
                     s5 = rightSupply s6
    in s4 `seq` (s5 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s4
                                                          s3 = rightSupply s4
    in s0 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp
    (CPP.ICode.Curry_ParsePos.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
    x10 x15 s0 cd cs) (let s2 = leftSupply s3
                           s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs)) x11 s1 cd cs) x16 s2 cd cs)) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x12 x17 s5 cd cs) cd cs))
  Choice_C_L1Token d i l r -> narrow d i (nd_C__case_52 x12 x11 x10 l s cd cs)
    (nd_C__case_52 x12 x11 x10 r s cd cs)
  Choices_C_L1Token d i xs -> narrows cs d i (\z -> nd_C__case_52 x12 x11 x10 z
    s cd cs) xs
  Guard_C_L1Token d c e -> guardCons d c ((\x -> nd_C__case_52 x12 x11 x10 e s
    cd x) $! addCs c cs)
  Fail_C_L1Token d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_52" [show x12, show x11, show x10, show x2]
    info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_52" (showCons x2))

nd_C__case_53 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> C_L1Token -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_53 x4 x3 x2 s cd cs = case x2 of
  C_Normal x5 x6 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (CPP.ICode.Curry_ParsePos.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_CPP_dot_ICode_dot_ParsePos_dot_Pos_hash
    x3 x5 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x4 x6 s1 cd cs) cd cs))
  C_Exp x7 x8 x9 -> Curry_Prelude.C_False
  Choice_C_L1Token d i l r -> narrow d i (nd_C__case_53 x4 x3 l s cd cs)
    (nd_C__case_53 x4 x3 r s cd cs)
  Choices_C_L1Token d i xs -> narrows cs d i (\z -> nd_C__case_53 x4 x3 z s cd
    cs) xs
  Guard_C_L1Token d c e -> guardCons d c ((\x -> nd_C__case_53 x4 x3 e s cd
    x) $! addCs c cs)
  Fail_C_L1Token d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_53" [show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_53" (showCons x2))

d_C__case_51 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  C_L1Token)
d_C__case_51 x5 x4 x6 x3 x2 x1 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> d_OP_parserL1Iter_dot_passThrough_dot_31 x2 x3 x1
    (acceptCs (acceptCs id) d_C_parseQuotation)
    (CPP.ICode.Curry_ParsePos.d_C_movePosByChar x3 (Curry_Prelude.C_Char '"'#)
    cd cs) x6 cd cs
  Curry_Prelude.C_False -> d_C__case_50 x5 x4 x6 x3 x2 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x5 (Curry_Prelude.C_Char '\''#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_51 x5 x4 x6 x3 x2
    x1 l cd cs) (d_C__case_51 x5 x4 x6 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_51 x5
    x4 x6 x3 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_51 x5 x4
    x6 x3 x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_51" [show x5, show x4, show x6, show x3, show
    x2, show x1, show x7] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_51" (showCons x7))

d_C__case_50 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  C_L1Token)
d_C__case_50 x5 x4 x6 x3 x2 x1 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> d_OP_parserL1Iter_dot_passThrough_dot_31 x2 x3 x1
    (acceptCs (acceptCs id) d_C_parseSingleQuote)
    (CPP.ICode.Curry_ParsePos.d_C_movePosByChar x3 (Curry_Prelude.C_Char '\''#)
    cd cs) x6 cd cs
  Curry_Prelude.C_False -> d_C__case_49 x4 x6 x5 x3 x2 x1
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_50 x5 x4 x6 x3 x2
    x1 l cd cs) (d_C__case_50 x5 x4 x6 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_50 x5
    x4 x6 x3 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_50 x5 x4
    x6 x3 x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_50" [show x5, show x4, show x6, show x3, show
    x2, show x1, show x7] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_50" (showCons x7))

d_C__case_49 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  C_L1Token)
d_C__case_49 x4 x6 x5 x3 x2 x1 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> let x7 = d_C_isPrefixAndDrop
                                Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
                                (d_C_s_line_comment cd cs) x4 cd cs
                              x8 = d_OP_parserL1Iter_dot_uscore_hash_selFP8_hash_isprefco
                                x7 cd cs
                              x9 = d_OP_parserL1Iter_dot_uscore_hash_selFP9_hash_rstco
                                x7 cd cs
    in d_C__case_48 x4 x6 x5 x3 x2 x1 x9 x8 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_49 x4 x6 x5 x3 x2
    x1 l cd cs) (d_C__case_49 x4 x6 x5 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_49 x4
    x6 x5 x3 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_49 x4 x6
    x5 x3 x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_49" [show x4, show x6, show x5, show x3, show
    x2, show x1, show x10] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_49" (showCons x10))

d_C__case_48 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List C_L1Token)
d_C__case_48 x4 x6 x5 x3 x2 x1 x9 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_OP_parserL1Iter_dot_passThrough_dot_31 x2 x3 x1
    (acceptCs (acceptCs id) d_C_parseLineComment)
    (CPP.ICode.Curry_ParsePos.d_C_movePosByString x3 (d_C_s_line_comment cd cs)
    cd cs) x9 cd cs
  Curry_Prelude.C_False -> let x10 = d_C_isPrefixAndDrop
                                 Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
                                 (d_C_s_block_comment cd cs) x4 cd cs
                               x11 = d_OP_parserL1Iter_dot_uscore_hash_selFP6_hash_isprefbc
                                 x10 cd cs
                               x12 = d_OP_parserL1Iter_dot_uscore_hash_selFP7_hash_rstbc
                                 x10 cd cs
    in d_C__case_47 x4 x6 x5 x3 x2 x1 x12 x11 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_48 x4 x6 x5 x3 x2
    x1 x9 l cd cs) (d_C__case_48 x4 x6 x5 x3 x2 x1 x9 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_48 x4
    x6 x5 x3 x2 x1 x9 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_48 x4 x6
    x5 x3 x2 x1 x9 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_48" [show x4, show x6, show x5, show x3, show
    x2, show x1, show x9, show x8] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_48" (showCons x8))

d_C__case_47 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List C_L1Token)
d_C__case_47 x4 x6 x5 x3 x2 x1 x12 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> d_OP_parserL1Iter_dot_passThrough_dot_31 x2 x3 x1
    (acceptCs (acceptCs id) d_C_parseBlockComment)
    (CPP.ICode.Curry_ParsePos.d_C_movePosByString x3 (d_C_s_block_comment cd cs)
    cd cs) x12 cd cs
  Curry_Prelude.C_False -> let x13 = d_C_countAndDrop
                                 Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
                                 (d_C_s_ident cd cs) x4 cd cs
                               x14 = d_OP_parserL1Iter_dot_uscore_hash_selFP4_hash_n
                                 x13 cd cs
                               x15 = d_OP_parserL1Iter_dot_uscore_hash_selFP5_hash_r
                                 x13 cd cs
    in d_C__case_46 x14 x6 x5 x3 x2 x1 x15
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    (d_C_min_number cd cs) x14 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_47 x4 x6 x5 x3 x2
    x1 x12 l cd cs) (d_C__case_47 x4 x6 x5 x3 x2 x1 x12 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_47 x4
    x6 x5 x3 x2 x1 x12 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_47 x4 x6
    x5 x3 x2 x1 x12 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_47" [show x4, show x6, show x5, show x3, show
    x2, show x1, show x12, show x11] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_47" (showCons x11))

d_C__case_46 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List C_L1Token)
d_C__case_46 x14 x6 x5 x3 x2 x1 x15 x16 cd cs = case x16 of
  Curry_Prelude.C_True -> d_OP_parserL1Iter_dot_passThroughInt_dot_31 x2 x3 x1
    (acceptCs (acceptCs (acceptCs id)) d_C_parseIntegrated)
    (CPP.ICode.Curry_ParsePos.d_C_movePosByString x3
    (Curry_Prelude.d_C_replicate x14 (d_C_s_ident cd cs) cd cs) cd cs) x14 x15
    cd cs
  Curry_Prelude.C_False -> d_C_parserL1Iter (Curry_Prelude.OP_Cons x5 x1) x2
    (CPP.ICode.Curry_ParsePos.d_C_movePosByChar x3 x5 cd cs) x6 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_46 x14 x6 x5 x3
    x2 x1 x15 l cd cs) (d_C__case_46 x14 x6 x5 x3 x2 x1 x15 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_46 x14
    x6 x5 x3 x2 x1 x15 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_46 x14 x6
    x5 x3 x2 x1 x15 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_46" [show x14, show x6, show x5, show x3, show
    x2, show x1, show x15, show x16] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_46" (showCons x16))

d_C__case_45 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> t0 -> t1
  -> CPP.ICode.Curry_ParsePos.C_Pos -> (CPP.ICode.Curry_ParsePos.C_Pos -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List C_L1Token))
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  C_L1Token)
d_C__case_45 x3 x6 x5 x2 x4 x1 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x4 x2 cd cs) x5 cd cs) x6 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar
    (CPP.ICode.Curry_ParseMonad.d_C_liftPM (acceptCs id (Curry_Prelude.OP_Cons
    (C_Normal x1 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_reverse cd cs) x3
    cd cs))))) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x4 x2 cd cs) x5 cd cs) x6 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_45 x3 x6 x5 x2 x4
    x1 l cd cs) (d_C__case_45 x3 x6 x5 x2 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_45 x3
    x6 x5 x2 x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_45 x3 x6
    x5 x2 x4 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_45" [show x3, show x6, show x5, show x2, show
    x4, show x1, show x7] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_45" (showCons x7))

nd_C__case_45 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> t0 -> t1
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Func CPP.ICode.Curry_ParsePos.C_Pos (Func
  t1 (Func t0 (CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  C_L1Token)))) -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM
  (Curry_Prelude.OP_List C_L1Token)
nd_C__case_45 x3 x6 x5 x2 x4 x1 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x4
    x2 s0 cd cs) x5 s1 cd cs)) x6 s3 cd cs))
  Curry_Prelude.C_False -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s2 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s2 `seq` (s7 `seq` Curry_Prelude.nd_OP_dollar
    (wrapNX id (CPP.ICode.Curry_ParseMonad.nd_C_liftPM (wrapDX id (acceptCs id
    (Curry_Prelude.OP_Cons (C_Normal x1 (let s1 = leftSupply s2
                                             s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_reverse
    s0 cd cs) x3 s1 cd cs)))))))) (let s6 = leftSupply s7
                                       s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                        s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x4
    x2 s3 cd cs) x5 s4 cd cs)) x6 s6 cd cs)) s8 cd cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_45 x3 x6 x5 x2
    x4 x1 l s cd cs) (nd_C__case_45 x3 x6 x5 x2 x4 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_45 x3
    x6 x5 x2 x4 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_45 x3 x6
    x5 x2 x4 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_45" [show x3, show x6, show x5, show x2, show
    x4, show x1, show x7] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_45" (showCons x7))

d_C__case_44 :: forall t0 t1 t2 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t2) => Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> t0 -> t1 -> t2 -> CPP.ICode.Curry_ParsePos.C_Pos
  -> (CPP.ICode.Curry_ParsePos.C_Pos -> Cover -> ConstStore -> t2 -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List C_L1Token))
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  C_L1Token)
d_C__case_44 x3 x7 x6 x5 x2 x4 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x4 x2 cd cs) x5 cd cs) x6
    cd cs) x7 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar
    (CPP.ICode.Curry_ParseMonad.d_C_liftPM (acceptCs id (Curry_Prelude.OP_Cons
    (C_Normal x1 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_reverse cd cs) x3
    cd cs))))) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x4 x2 cd cs) x5 cd cs) x6
    cd cs) x7 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_44 x3 x7 x6 x5 x2
    x4 x1 l cd cs) (d_C__case_44 x3 x7 x6 x5 x2 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_44 x3
    x7 x6 x5 x2 x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_44 x3 x7
    x6 x5 x2 x4 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_44" [show x3, show x7, show x6, show x5, show
    x2, show x4, show x1, show x8] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_44" (showCons x8))

nd_C__case_44 :: forall t0 t1 t2 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t2) => Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> t0 -> t1 -> t2 -> CPP.ICode.Curry_ParsePos.C_Pos -> Func
  CPP.ICode.Curry_ParsePos.C_Pos (Func t2 (Func t1 (Func t0
  (CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List C_L1Token)))))
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  C_L1Token)
nd_C__case_44 x3 x7 x6 x5 x2 x4 x1 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x4
    x2 s0 cd cs) x5 s1 cd cs)) x6 s3 cd cs)) x7 s5 cd cs))
  Curry_Prelude.C_False -> let s11 = s
    in s11 `seq` (let s10 = leftSupply s11
                      s12 = rightSupply s11
                      s2 = leftSupply s12
                      s9 = rightSupply s12
    in s10 `seq` (s12 `seq` (s2 `seq` (s9 `seq` Curry_Prelude.nd_OP_dollar
    (wrapNX id (CPP.ICode.Curry_ParseMonad.nd_C_liftPM (wrapDX id (acceptCs id
    (Curry_Prelude.OP_Cons (C_Normal x1 (let s1 = leftSupply s2
                                             s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_reverse
    s0 cd cs) x3 s1 cd cs)))))))) (let s8 = leftSupply s9
                                       s7 = rightSupply s9
    in s8 `seq` (s7 `seq` Curry_Prelude.nd_C_apply (let s6 = leftSupply s7
                                                        s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                        s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x4
    x2 s3 cd cs) x5 s4 cd cs)) x6 s6 cd cs)) x7 s8 cd cs)) s10 cd cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_44 x3 x7 x6 x5
    x2 x4 x1 l s cd cs) (nd_C__case_44 x3 x7 x6 x5 x2 x4 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_44 x3
    x7 x6 x5 x2 x4 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_44 x3 x7
    x6 x5 x2 x4 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_44" [show x3, show x7, show x6, show x5, show
    x2, show x4, show x1, show x8] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_44" (showCons x8))

d_C__case_42 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Bool (Curry_Prelude.OP_List t0)
d_C__case_42 x6 x1 x7 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_False
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x8 x9 -> d_C__case_41 x8 x6 x1 x9 x7
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq
    x1 cd cs) x6 cd cs) x8 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_42 x6 x1 x7 l cd
    cs) (d_C__case_42 x6 x1 x7 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_42 x6
    x1 x7 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_42 x6 x1
    x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_42" [show x6, show x1, show x7, show x3] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_42" (showCons x3))

nd_C__case_42 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Bool
  (Curry_Prelude.OP_List t0)
nd_C__case_42 x6 x1 x7 x3 s cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_False
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x8 x9 -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_41 x8 x6 x1 x9 x7 (let s3 = leftSupply s4
                                                            s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq x1
    s0 cd cs) x6 s1 cd cs)) x8 s3 cd cs)) s5 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_42 x6 x1 x7 l s
    cd cs) (nd_C__case_42 x6 x1 x7 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_42 x6
    x1 x7 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_42 x6 x1
    x7 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_42" [show x6, show x1, show x7, show x3] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_42" (showCons x3))

d_C__case_41 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Bool (Curry_Prelude.OP_List t0)
d_C__case_41 x8 x6 x1 x9 x7 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> d_C_isPrefixAndDrop x1 x7 x9 cd cs
  Curry_Prelude.C_False -> d_C__case_40 x9 x8 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_41 x8 x6 x1 x9 x7
    l cd cs) (d_C__case_41 x8 x6 x1 x9 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_41 x8
    x6 x1 x9 x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_41 x8 x6
    x1 x9 x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_41" [show x8, show x6, show x1, show x9, show
    x7, show x10] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_41" (showCons x10))

nd_C__case_41 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Bool (Curry_Prelude.OP_List t0)
nd_C__case_41 x8 x6 x1 x9 x7 x10 s cd cs = case x10 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_isPrefixAndDrop x1 x7 x9 s0 cd cs
  Curry_Prelude.C_False -> d_C__case_40 x9 x8 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_41 x8 x6 x1 x9
    x7 l s cd cs) (nd_C__case_41 x8 x6 x1 x9 x7 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_41 x8
    x6 x1 x9 x7 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_41 x8 x6
    x1 x9 x7 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_41" [show x8, show x6, show x1, show x9, show
    x7, show x10] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_41" (showCons x10))

d_C__case_40 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Bool (Curry_Prelude.OP_List t0)
d_C__case_40 x9 x8 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_False
    (Curry_Prelude.OP_Cons x8 x9)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_40 x9 x8 l cd cs)
    (d_C__case_40 x9 x8 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_40 x9
    x8 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_40 x9 x8 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_40" [show x9, show x8, show x10] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_40" (showCons x10))

d_C__case_43 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Bool
  (Curry_Prelude.OP_List t0)
d_C__case_43 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_True
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_True
    (Curry_Prelude.OP_Cons x4 x5)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_43 l cd cs)
    (d_C__case_43 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_43 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_43 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_43" [show x3] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_43" (showCons x3))

d_C__case_39 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Curry_Prelude.OP_List t1 -> t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Num t0) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List t1)
d_C__case_39 x6 x1 x2 x7 x4 x3 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_OP_countAndDrop_dot_countAndDropIter_dot_53 x1 x2 x3
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_plus
    x3 cd cs) x4 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_fromInt x3
    cd cs) (Curry_Prelude.C_Int (1)) cd cs) cd cs) x7 cd cs
  Curry_Prelude.C_False -> d_C__case_38 x7 x6 x4 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_39 x6 x1 x2 x7 x4
    x3 l cd cs) (d_C__case_39 x6 x1 x2 x7 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_39 x6
    x1 x2 x7 x4 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_39 x6 x1
    x2 x7 x4 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_39" [show x6, show x1, show x2, show x7, show
    x4, show x3, show x8] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_39" (showCons x8))

nd_C__case_39 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Curry_Prelude.OP_List t1 -> t0
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Num t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List t1)
nd_C__case_39 x6 x1 x2 x7 x4 x3 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s10 = s
    in s10 `seq` (let s9 = leftSupply s10
                      s7 = rightSupply s10
    in s9 `seq` (s7 `seq` nd_OP_countAndDrop_dot_countAndDropIter_dot_53 x1 x2
    x3 (let s6 = leftSupply s7
            s8 = rightSupply s7
            s2 = leftSupply s8
            s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s2 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_plus x3
    s0 cd cs) x4 s1 cd cs)) (let s4 = leftSupply s5
                                 s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_fromInt
    x3 s3 cd cs) (Curry_Prelude.C_Int (1)) s4 cd cs)) s6 cd cs)))) x7 s9 cd cs))
  Curry_Prelude.C_False -> d_C__case_38 x7 x6 x4 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_39 x6 x1 x2 x7
    x4 x3 l s cd cs) (nd_C__case_39 x6 x1 x2 x7 x4 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_39 x6
    x1 x2 x7 x4 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_39 x6 x1
    x2 x7 x4 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_39" [show x6, show x1, show x2, show x7, show
    x4, show x3, show x8] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_39" (showCons x8))

d_C__case_38 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t1 -> t1 -> t0 -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List t1)
d_C__case_38 x7 x6 x4 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 x4 (Curry_Prelude.OP_Cons x6
    x7)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_38 x7 x6 x4 l cd
    cs) (d_C__case_38 x7 x6 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_38 x7
    x6 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_38 x7 x6
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_38" [show x7, show x6, show x4, show x8] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_38" (showCons x8))

d_C__case_37 :: CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  C_L1Token)
d_C__case_37 x1 x6 x8 x5 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar
    (CPP.ICode.Curry_ParseMonad.d_C_liftPM (acceptCs id (Curry_Prelude.OP_Cons
    (C_Normal x1 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '"'#) x5)))))
    (d_C_parserL1 x8 x6 cd cs) cd cs
  Curry_Prelude.C_False -> CPP.ICode.Curry_ParseMonad.d_C_throwPM x1
    (d_C_err_missing_quote cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_37 x1 x6 x8 x5 l
    cd cs) (d_C__case_37 x1 x6 x8 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_37 x1
    x6 x8 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_37 x1 x6
    x8 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_37" [show x1, show x6, show x8, show x5, show
    x7] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_37" (showCons x7))

d_C__case_36 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
d_C__case_36 x1 x6 x2 x4 x3 x7 cd cs = case x7 of
  Curry_Prelude.OP_List -> d_C__case_35 x1 x6 x3 x4
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x6 x1 cd cs) cd cs
  Curry_Prelude.OP_Cons x8 x9 -> d_C__case_33 x1 x6 x2 x9 x8 x4 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x6 x1 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_36 x1 x6 x2 x4
    x3 l cd cs) (d_C__case_36 x1 x6 x2 x4 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_36 x1
    x6 x2 x4 x3 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_36 x1 x6
    x2 x4 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_36" [show x1, show x6, show x2, show x4, show
    x3, show x7] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_36" (showCons x7))

d_C__case_33 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
d_C__case_33 x1 x6 x2 x9 x8 x4 x3 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_reverse cd cs) (Curry_Prelude.OP_Cons x6 x4) cd cs)
    (Curry_Prelude.OP_Cons x8 x9) Curry_Prelude.C_True
    (CPP.ICode.Curry_ParsePos.d_C_movePosByChar x3 x6 cd cs)
  Curry_Prelude.C_False -> d_C__case_32 x2 x6 x1 x9 x8 x4 x3
    (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    cd cs) x6 cd cs) x1 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x6 x2 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_33 x1 x6 x2 x9 x8
    x4 x3 l cd cs) (d_C__case_33 x1 x6 x2 x9 x8 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_33 x1
    x6 x2 x9 x8 x4 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_33 x1 x6
    x2 x9 x8 x4 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_33" [show x1, show x6, show x2, show x9, show
    x8, show x4, show x3, show x10] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_33" (showCons x10))

d_C__case_32 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
d_C__case_32 x2 x6 x1 x9 x8 x4 x3 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> d_OP_findUnescapedChar_dot_findUnescapedCharHelper_dot_63
    x1 x2 (CPP.ICode.Curry_ParsePos.d_C_movePosByString x3
    (Curry_Prelude.OP_Cons x8 (Curry_Prelude.OP_Cons x6 Curry_Prelude.OP_List))
    cd cs) (Curry_Prelude.OP_Cons x8 (Curry_Prelude.OP_Cons x6 x4)) x9 cd cs
  Curry_Prelude.C_False -> d_C__case_31 x9 x8 x4 x6 x3 x2 x1
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_32 x2 x6 x1 x9 x8
    x4 x3 l cd cs) (d_C__case_32 x2 x6 x1 x9 x8 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_32 x2
    x6 x1 x9 x8 x4 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_32 x2 x6
    x1 x9 x8 x4 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_32" [show x2, show x6, show x1, show x9, show
    x8, show x4, show x3, show x10] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_32" (showCons x10))

d_C__case_31 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
d_C__case_31 x9 x8 x4 x6 x3 x2 x1 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> d_OP_findUnescapedChar_dot_findUnescapedCharHelper_dot_63
    x1 x2 (CPP.ICode.Curry_ParsePos.d_C_movePosByChar x3 x6 cd cs)
    (Curry_Prelude.OP_Cons x6 x4) (Curry_Prelude.OP_Cons x8 x9) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_31 x9 x8 x4 x6 x3
    x2 x1 l cd cs) (d_C__case_31 x9 x8 x4 x6 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_31 x9
    x8 x4 x6 x3 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_31 x9 x8
    x4 x6 x3 x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_31" [show x9, show x8, show x4, show x6, show
    x3, show x2, show x1, show x10] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_31" (showCons x10))

d_C__case_35 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Bool
  CPP.ICode.Curry_ParsePos.C_Pos
d_C__case_35 x1 x6 x3 x4 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_reverse cd cs) (Curry_Prelude.OP_Cons x6 x4) cd cs)
    Curry_Prelude.OP_List Curry_Prelude.C_True
    (CPP.ICode.Curry_ParsePos.d_C_movePosByChar x3 x6 cd cs)
  Curry_Prelude.C_False -> d_C__case_34 x1 x6 x3 x4 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    cd cs) x6 cd cs) x1 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_35 x1 x6 x3 x4 l
    cd cs) (d_C__case_35 x1 x6 x3 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_35 x1
    x6 x3 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_35 x1 x6
    x3 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_35" [show x1, show x6, show x3, show x4, show
    x7] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_35" (showCons x7))

d_C__case_34 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Bool
  CPP.ICode.Curry_ParsePos.C_Pos
d_C__case_34 x1 x6 x3 x4 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_reverse cd cs) (Curry_Prelude.OP_Cons x6 x4) cd cs)
    Curry_Prelude.OP_List Curry_Prelude.C_False
    (CPP.ICode.Curry_ParsePos.d_C_movePosByChar x3 x6 cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_34 x1 x6 x3 x4 l
    cd cs) (d_C__case_34 x1 x6 x3 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_34 x1
    x6 x3 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_34 x1 x6
    x3 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_34" [show x1, show x6, show x3, show x4, show
    x7] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_34" (showCons x7))

d_C__case_30 :: CPP.ICode.Curry_ParsePos.C_Pos -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  C_L1Token)
d_C__case_30 x2 x1 x4 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x6 x7 -> d_C__case_29 x6 x7 x3 x2 x1 x4
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x6 (Curry_Prelude.C_Char '\\'#) cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_dollar
    (CPP.ICode.Curry_ParseMonad.d_C_liftPM (acceptCs id (Curry_Prelude.OP_Cons
    (C_Normal x1 (Curry_Prelude.toCurryString "'"))))) (d_C_parserL1 x2 x3 cd
    cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_30 x2 x1 x4 l cd
    cs) (d_C__case_30 x2 x1 x4 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_30 x2
    x1 x4 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_30 x2 x1
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_30" [show x2, show x1, show x4, show x3] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_30" (showCons x3))

d_C__case_29 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List C_L1Token)
d_C__case_29 x6 x7 x3 x2 x1 x4 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_C__case_28 x3 x2 x1 x4 x7 cd cs
  Curry_Prelude.C_False -> d_C__case_23 x3 x2 x1 x4 x7 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_29 x6 x7 x3 x2 x1
    x4 l cd cs) (d_C__case_29 x6 x7 x3 x2 x1 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_29 x6
    x7 x3 x2 x1 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_29 x6 x7
    x3 x2 x1 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_29" [show x6, show x7, show x3, show x2, show
    x1, show x4, show x8] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_29" (showCons x8))

d_C__case_23 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  C_L1Token)
d_C__case_23 x3 x2 x1 x4 x7 cd cs = case x7 of
  Curry_Prelude.OP_Cons x12 x13 -> d_C__case_22 x12 x3 x2 x1 x13 x4
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x12 (Curry_Prelude.C_Char '\''#) cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_dollar
    (CPP.ICode.Curry_ParseMonad.d_C_liftPM (acceptCs id (Curry_Prelude.OP_Cons
    (C_Normal x1 (Curry_Prelude.toCurryString "'"))))) (d_C_parserL1 x2 x3 cd
    cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_23 x3 x2 x1 x4 l
    cd cs) (d_C__case_23 x3 x2 x1 x4 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_23 x3
    x2 x1 x4 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_23 x3 x2
    x1 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_23" [show x3, show x2, show x1, show x4, show
    x7] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_23" (showCons x7))

d_C__case_22 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  C_L1Token)
d_C__case_22 x12 x3 x2 x1 x13 x4 x14 cd cs = case x14 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar
    (CPP.ICode.Curry_ParseMonad.d_C_liftPM (acceptCs id (Curry_Prelude.OP_Cons
    (C_Normal x1 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '\''#)
    (Curry_Prelude.OP_Cons x4 (Curry_Prelude.toCurryString "'")))))))
    (d_C_parserL1 (CPP.ICode.Curry_ParsePos.d_C_moveAbs
    (CPP.ICode.Curry_ParsePos.d_C_moveCol x2 (Curry_Prelude.C_Int (3)) cd cs)
    (Curry_Prelude.C_Int (3)) cd cs) x13 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar
    (CPP.ICode.Curry_ParseMonad.d_C_liftPM (acceptCs id (Curry_Prelude.OP_Cons
    (C_Normal x1 (Curry_Prelude.toCurryString "'"))))) (d_C_parserL1 x2 x3 cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_22 x12 x3 x2 x1
    x13 x4 l cd cs) (d_C__case_22 x12 x3 x2 x1 x13 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_22 x12
    x3 x2 x1 x13 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_22 x12 x3
    x2 x1 x13 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_22" [show x12, show x3, show x2, show x1, show
    x13, show x4, show x14] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_22" (showCons x14))

d_C__case_28 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  C_L1Token)
d_C__case_28 x3 x2 x1 x4 x7 cd cs = case x7 of
  Curry_Prelude.OP_Cons x8 x9 -> d_C__case_27 x8 x3 x2 x1 x4 x9 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_dollar
    (CPP.ICode.Curry_ParseMonad.d_C_liftPM (acceptCs id (Curry_Prelude.OP_Cons
    (C_Normal x1 (Curry_Prelude.toCurryString "'"))))) (d_C_parserL1 x2 x3 cd
    cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_28 x3 x2 x1 x4 l
    cd cs) (d_C__case_28 x3 x2 x1 x4 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_28 x3
    x2 x1 x4 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_28 x3 x2
    x1 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_28" [show x3, show x2, show x1, show x4, show
    x7] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_28" (showCons x7))

d_C__case_27 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List C_L1Token)
d_C__case_27 x8 x3 x2 x1 x4 x9 cd cs = case x9 of
  Curry_Prelude.OP_Cons x10 x11 -> d_C__case_26 x10 x8 x3 x2 x1 x9 x4 x11
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x10 (Curry_Prelude.C_Char '\''#) cd cs) cd cs
  Curry_Prelude.OP_List -> d_C__case_24 x8 x3 x2 x1 x9 x4
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x8 (Curry_Prelude.C_Char '\''#) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_27 x8 x3 x2 x1
    x4 l cd cs) (d_C__case_27 x8 x3 x2 x1 x4 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_27 x8
    x3 x2 x1 x4 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_27 x8 x3
    x2 x1 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_27" [show x8, show x3, show x2, show x1, show
    x4, show x9] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_27" (showCons x9))

d_C__case_24 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  C_L1Token)
d_C__case_24 x8 x3 x2 x1 x9 x4 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar
    (CPP.ICode.Curry_ParseMonad.d_C_liftPM (acceptCs id (Curry_Prelude.OP_Cons
    (C_Normal x1 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '\''#)
    (Curry_Prelude.OP_Cons x4 (Curry_Prelude.toCurryString "'")))))))
    (d_C_parserL1 (CPP.ICode.Curry_ParsePos.d_C_moveAbs
    (CPP.ICode.Curry_ParsePos.d_C_moveCol x2 (Curry_Prelude.C_Int (3)) cd cs)
    (Curry_Prelude.C_Int (3)) cd cs) x9 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar
    (CPP.ICode.Curry_ParseMonad.d_C_liftPM (acceptCs id (Curry_Prelude.OP_Cons
    (C_Normal x1 (Curry_Prelude.toCurryString "'"))))) (d_C_parserL1 x2 x3 cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_24 x8 x3 x2 x1 x9
    x4 l cd cs) (d_C__case_24 x8 x3 x2 x1 x9 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_24 x8
    x3 x2 x1 x9 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_24 x8 x3
    x2 x1 x9 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_24" [show x8, show x3, show x2, show x1, show
    x9, show x4, show x10] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_24" (showCons x10))

d_C__case_26 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  C_L1Token)
d_C__case_26 x10 x8 x3 x2 x1 x9 x4 x11 x12 cd cs = case x12 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar
    (CPP.ICode.Curry_ParseMonad.d_C_liftPM (acceptCs id (Curry_Prelude.OP_Cons
    (C_Normal x1 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '\''#)
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '\\'#) (Curry_Prelude.OP_Cons
    x8 (Curry_Prelude.toCurryString "'")))))))) (d_C_parserL1
    (CPP.ICode.Curry_ParsePos.d_C_moveAbs (CPP.ICode.Curry_ParsePos.d_C_moveCol
    x2 (Curry_Prelude.C_Int (4)) cd cs) (Curry_Prelude.C_Int (4)) cd cs) x11 cd
    cs) cd cs
  Curry_Prelude.C_False -> d_C__case_25 x8 x3 x2 x1 x9 x4
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x8 (Curry_Prelude.C_Char '\''#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_26 x10 x8 x3 x2
    x1 x9 x4 x11 l cd cs) (d_C__case_26 x10 x8 x3 x2 x1 x9 x4 x11 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_26 x10
    x8 x3 x2 x1 x9 x4 x11 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_26 x10 x8
    x3 x2 x1 x9 x4 x11 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_26" [show x10, show x8, show x3, show x2, show
    x1, show x9, show x4, show x11, show x12] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_26" (showCons x12))

d_C__case_25 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  C_L1Token)
d_C__case_25 x8 x3 x2 x1 x9 x4 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar
    (CPP.ICode.Curry_ParseMonad.d_C_liftPM (acceptCs id (Curry_Prelude.OP_Cons
    (C_Normal x1 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '\''#)
    (Curry_Prelude.OP_Cons x4 (Curry_Prelude.toCurryString "'")))))))
    (d_C_parserL1 (CPP.ICode.Curry_ParsePos.d_C_moveAbs
    (CPP.ICode.Curry_ParsePos.d_C_moveCol x2 (Curry_Prelude.C_Int (3)) cd cs)
    (Curry_Prelude.C_Int (3)) cd cs) x9 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar
    (CPP.ICode.Curry_ParseMonad.d_C_liftPM (acceptCs id (Curry_Prelude.OP_Cons
    (C_Normal x1 (Curry_Prelude.toCurryString "'"))))) (d_C_parserL1 x2 x3 cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_25 x8 x3 x2 x1 x9
    x4 l cd cs) (d_C__case_25 x8 x3 x2 x1 x9 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_25 x8
    x3 x2 x1 x9 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_25 x8 x3
    x2 x1 x9 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_25" [show x8, show x3, show x2, show x1, show
    x9, show x4, show x10] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_25" (showCons x10))

d_C__case_21 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM
  (Curry_Prelude.OP_List C_L1Token)
d_C__case_21 x5 x1 x6 x8 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar
    (CPP.ICode.Curry_ParseMonad.d_C_liftPM (acceptCs id (Curry_Prelude.OP_Cons
    (C_Normal x1 (Curry_Prelude.d_OP_plus_plus (d_C_s_line_comment cd cs) x5 cd
    cs))))) (d_C_parserL1 x8 x6 cd cs) cd cs
  Curry_Prelude.C_False -> CPP.ICode.Curry_ParseMonad.d_C_cleanPM
    (Curry_Prelude.OP_Cons (C_Normal x1 (Curry_Prelude.d_OP_plus_plus
    (d_C_s_line_comment cd cs) x5 cd cs)) Curry_Prelude.OP_List) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_21 x5 x1 x6 x8 l
    cd cs) (d_C__case_21 x5 x1 x6 x8 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_21 x5
    x1 x6 x8 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_21 x5 x1
    x6 x8 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_21" [show x5, show x1, show x6, show x8, show
    x7] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_21" (showCons x7))

d_C__case_20 :: CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  C_L1Token)
d_C__case_20 x1 x6 x8 x5 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar
    (CPP.ICode.Curry_ParseMonad.d_C_liftPM (acceptCs id (Curry_Prelude.OP_Cons
    (C_Normal x1 (Curry_Prelude.d_OP_plus_plus (d_C_s_block_comment cd cs) x5 cd
    cs))))) (d_C_parserL1 x8 x6 cd cs) cd cs
  Curry_Prelude.C_False -> CPP.ICode.Curry_ParseMonad.d_C_throwPM x1
    (d_C_err_missing_block cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_20 x1 x6 x8 x5 l
    cd cs) (d_C__case_20 x1 x6 x8 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_20 x1
    x6 x8 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_20 x1 x6
    x8 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_20" [show x1, show x6, show x8, show x5, show
    x7] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_20" (showCons x7))

d_C__case_18 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
d_C__case_18 x8 x1 x3 x2 x9 x5 cd cs = case x5 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_reverse cd cs) x3 cd cs) Curry_Prelude.OP_List
    Curry_Prelude.C_False x2
  Curry_Prelude.OP_Cons x10 x11 -> d_C__case_17 x10 x8 x11 x1 x3 x2 x9
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x8 x10 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_18 x8 x1 x3 x2
    x9 l cd cs) (d_C__case_18 x8 x1 x3 x2 x9 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_18 x8
    x1 x3 x2 x9 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_18 x8 x1
    x3 x2 x9 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_18" [show x8, show x1, show x3, show x2, show
    x9, show x5] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_18" (showCons x5))

d_C__case_17 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Bool
  CPP.ICode.Curry_ParsePos.C_Pos
d_C__case_17 x10 x8 x11 x1 x3 x2 x9 x12 cd cs = case x12 of
  Curry_Prelude.C_True -> d_OP_findSequence_dot_findSequenceIter_dot_93 x1
    (CPP.ICode.Curry_ParsePos.d_C_movePosByChar x2 x10 cd cs)
    (Curry_Prelude.OP_Cons x10 x3) x9 x11 cd cs
  Curry_Prelude.C_False -> d_C__case_16 x11 x1 x3 x10 x2
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_17 x10 x8 x11 x1
    x3 x2 x9 l cd cs) (d_C__case_17 x10 x8 x11 x1 x3 x2 x9 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_17 x10
    x8 x11 x1 x3 x2 x9 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_17 x10 x8
    x11 x1 x3 x2 x9 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_17" [show x10, show x8, show x11, show x1, show
    x3, show x2, show x9, show x12] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_17" (showCons x12))

d_C__case_16 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
d_C__case_16 x11 x1 x3 x10 x2 x12 cd cs = case x12 of
  Curry_Prelude.C_True -> d_OP_findSequence_dot_findSequenceIter_dot_93 x1
    (CPP.ICode.Curry_ParsePos.d_C_movePosByChar x2 x10 cd cs)
    (Curry_Prelude.OP_Cons x10 x3) x1 x11 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_16 x11 x1 x3 x10
    x2 l cd cs) (d_C__case_16 x11 x1 x3 x10 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_16 x11
    x1 x3 x10 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_16 x11 x1
    x3 x10 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_16" [show x11, show x1, show x3, show x10, show
    x2, show x12] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_16" (showCons x12))

d_C__case_19 :: CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
d_C__case_19 x2 x3 x5 cd cs = case x5 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_reverse cd cs) x3 cd cs) Curry_Prelude.OP_List
    Curry_Prelude.C_True x2
  Curry_Prelude.OP_Cons x6 x7 -> Curry_Prelude.OP_Tuple4
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_reverse cd cs) x3 cd cs)
    (Curry_Prelude.OP_Cons x6 x7) Curry_Prelude.C_True x2
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_19 x2 x3 l cd
    cs) (d_C__case_19 x2 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_19 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_19 x2 x3
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_19" [show x2, show x3, show x5] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_19" (showCons x5))

d_C__case_15 :: CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List C_L1Token)
d_C__case_15 x1 x7 x9 x6 x3 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar
    (CPP.ICode.Curry_ParseMonad.d_C_liftPM (acceptCs id (Curry_Prelude.OP_Cons
    (C_Exp x1 x3 x6)))) (d_C_parserL1 x9 x7 cd cs) cd cs
  Curry_Prelude.C_False -> CPP.ICode.Curry_ParseMonad.d_C_throwPM x1
    (d_C_err_missing_integ cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_15 x1 x7 x9 x6 x3
    l cd cs) (d_C__case_15 x1 x7 x9 x6 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_15 x1
    x7 x9 x6 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_15 x1 x7
    x9 x6 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_15" [show x1, show x7, show x9, show x6, show
    x3, show x8] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_15" (showCons x8))

d_C__case_13 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
d_C__case_13 x4 x8 x10 x2 x3 x11 x7 x6 x5 x1 x12 cd cs = case x12 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_reverse cd cs) (Curry_Prelude.d_C_drop x8 x7 cd cs) cd
    cs) (Curry_Prelude.OP_Cons x10 x11) Curry_Prelude.C_True x6
  Curry_Prelude.C_False -> d_C__case_12 x4 x8 x10 x2 x3 x11 x7 x6 x5 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x8
    (Curry_Prelude.d_OP_uscore_impl_hash_negate_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x4 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_13 x4 x8 x10 x2
    x3 x11 x7 x6 x5 x1 l cd cs) (d_C__case_13 x4 x8 x10 x2 x3 x11 x7 x6 x5 x1 r
    cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_13 x4
    x8 x10 x2 x3 x11 x7 x6 x5 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_13 x4 x8
    x10 x2 x3 x11 x7 x6 x5 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_13" [show x4, show x8, show x10, show x2, show
    x3, show x11, show x7, show x6, show x5, show x1, show x12] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_13" (showCons x12))

d_C__case_12 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
d_C__case_12 x4 x8 x10 x2 x3 x11 x7 x6 x5 x1 x12 cd cs = case x12 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple4 x5 x5 Curry_Prelude.C_False x1
  Curry_Prelude.C_False -> d_C__case_11 x10 x2 x3 x11 x7 x6 x5 x4 x1 x8
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 x10 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_12 x4 x8 x10 x2
    x3 x11 x7 x6 x5 x1 l cd cs) (d_C__case_12 x4 x8 x10 x2 x3 x11 x7 x6 x5 x1 r
    cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_12 x4
    x8 x10 x2 x3 x11 x7 x6 x5 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_12 x4 x8
    x10 x2 x3 x11 x7 x6 x5 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_12" [show x4, show x8, show x10, show x2, show
    x3, show x11, show x7, show x6, show x5, show x1, show x12] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_12" (showCons x12))

d_C__case_11 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Bool
  CPP.ICode.Curry_ParsePos.C_Pos
d_C__case_11 x10 x2 x3 x11 x7 x6 x5 x4 x1 x8 x12 cd cs = case x12 of
  Curry_Prelude.C_True -> d_C__case_10 x8 x11 x7 x10 x6 x5 x4 x3 x2 x1
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x8 cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_9 x10 x3 x11 x7 x6 x5 x4 x2 x1 x8
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 x10 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_11 x10 x2 x3 x11
    x7 x6 x5 x4 x1 x8 l cd cs) (d_C__case_11 x10 x2 x3 x11 x7 x6 x5 x4 x1 x8 r
    cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_11 x10
    x2 x3 x11 x7 x6 x5 x4 x1 x8 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_11 x10 x2
    x3 x11 x7 x6 x5 x4 x1 x8 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_11" [show x10, show x2, show x3, show x11, show
    x7, show x6, show x5, show x4, show x1, show x8, show x12] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_11" (showCons x12))

d_C__case_9 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Bool
  CPP.ICode.Curry_ParsePos.C_Pos
d_C__case_9 x10 x3 x11 x7 x6 x5 x4 x2 x1 x8 x12 cd cs = case x12 of
  Curry_Prelude.C_True -> d_C__case_8 x8 x11 x7 x10 x6 x5 x4 x3 x2 x1
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x8 cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs
  Curry_Prelude.C_False -> d_OP_findReplicate_dot_findReplicateIter_dot_109 x1
    x2 x3 x4 x5 (CPP.ICode.Curry_ParsePos.d_C_movePosByChar x6 x10 cd cs)
    (Curry_Prelude.OP_Cons x10 x7) (Curry_Prelude.C_Int (0)) x11 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_9 x10 x3 x11 x7
    x6 x5 x4 x2 x1 x8 l cd cs) (d_C__case_9 x10 x3 x11 x7 x6 x5 x4 x2 x1 x8 r cd
    cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_9 x10
    x3 x11 x7 x6 x5 x4 x2 x1 x8 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_9 x10 x3
    x11 x7 x6 x5 x4 x2 x1 x8 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_9" [show x10, show x3, show x11, show x7, show
    x6, show x5, show x4, show x2, show x1, show x8, show x12] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_9" (showCons x12))

d_C__case_8 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple4
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
d_C__case_8 x8 x11 x7 x10 x6 x5 x4 x3 x2 x1 x12 cd cs = case x12 of
  Curry_Prelude.C_True -> d_OP_findReplicate_dot_findReplicateIter_dot_109 x1 x2
    x3 x4 x5 (CPP.ICode.Curry_ParsePos.d_C_movePosByChar x6 x10 cd cs)
    (Curry_Prelude.OP_Cons x10 x7)
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x8 (Curry_Prelude.C_Int (1)) cd cs) x11 cd cs
  Curry_Prelude.C_False -> d_OP_findReplicate_dot_findReplicateIter_dot_109 x1
    x2 x3 x4 x5 (CPP.ICode.Curry_ParsePos.d_C_movePosByChar x6 x10 cd cs)
    (Curry_Prelude.OP_Cons x10 x7)
    (Curry_Prelude.d_OP_uscore_impl_hash_negate_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (1)) cd cs) x11 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x8 x11 x7 x10
    x6 x5 x4 x3 x2 x1 l cd cs) (d_C__case_8 x8 x11 x7 x10 x6 x5 x4 x3 x2 x1 r cd
    cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x8
    x11 x7 x10 x6 x5 x4 x3 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_8 x8 x11
    x7 x10 x6 x5 x4 x3 x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_8" [show x8, show x11, show x7, show x10, show
    x6, show x5, show x4, show x3, show x2, show x1, show x12] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_8" (showCons x12))

d_C__case_10 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
d_C__case_10 x8 x11 x7 x10 x6 x5 x4 x3 x2 x1 x12 cd cs = case x12 of
  Curry_Prelude.C_True -> d_OP_findReplicate_dot_findReplicateIter_dot_109 x1 x2
    x3 x4 x5 (CPP.ICode.Curry_ParsePos.d_C_movePosByChar x6 x10 cd cs)
    (Curry_Prelude.OP_Cons x10 x7) (Curry_Prelude.C_Int (1)) x11 cd cs
  Curry_Prelude.C_False -> d_OP_findReplicate_dot_findReplicateIter_dot_109 x1
    x2 x3 x4 x5 (CPP.ICode.Curry_ParsePos.d_C_movePosByChar x6 x10 cd cs)
    (Curry_Prelude.OP_Cons x10 x7)
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x8 (Curry_Prelude.C_Int (1)) cd cs) x11 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_10 x8 x11 x7 x10
    x6 x5 x4 x3 x2 x1 l cd cs) (d_C__case_10 x8 x11 x7 x10 x6 x5 x4 x3 x2 x1 r
    cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_10 x8
    x11 x7 x10 x6 x5 x4 x3 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_10 x8 x11
    x7 x10 x6 x5 x4 x3 x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_10" [show x8, show x11, show x7, show x10, show
    x6, show x5, show x4, show x3, show x2, show x1, show x12] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_10" (showCons x12))

d_C__case_14 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_Prelude.C_Bool CPP.ICode.Curry_ParsePos.C_Pos
d_C__case_14 x4 x8 x6 x7 x1 x5 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple4 x5 x5 Curry_Prelude.C_False x1
  Curry_Prelude.C_False -> Curry_Prelude.OP_Tuple4 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_reverse cd cs) (Curry_Prelude.d_C_drop x8 x7 cd cs) cd
    cs) Curry_Prelude.OP_List
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x8 x4 cd cs) x6
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_14 x4 x8 x6 x7 x1
    x5 l cd cs) (d_C__case_14 x4 x8 x6 x7 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_14 x4
    x8 x6 x7 x1 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_14 x4 x8
    x6 x7 x1 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_14" [show x4, show x8, show x6, show x7, show
    x1, show x5, show x9] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_14" (showCons x9))

d_C__case_7 :: C_L1Token -> Curry_Prelude.OP_List C_L1Token
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  CPP.ICode.Curry_ParseTypes.C_StandardToken)
d_C__case_7 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar
    (CPP.ICode.Curry_ParseMonad.d_C_liftPM (Curry_Prelude.d_OP_dollar (acceptCs
    (acceptCs id) Curry_Prelude.OP_Cons) (d_C_normalToStTk x2 cd cs) cd cs))
    (d_C_parserL2 x3 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_6 x3 x2 (Curry_Prelude.d_C_otherwise cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x2 x3 l cd cs)
    (d_C__case_7 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x2 x3
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_7 x2 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_7" [show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_7" (showCons x4))

d_C__case_6 :: Curry_Prelude.OP_List C_L1Token -> C_L1Token
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  CPP.ICode.Curry_ParseTypes.C_StandardToken)
d_C__case_6 x3 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> CPP.ICode.Curry_ParseMonad.d_C_bindPM
    (d_C_disassembleIntExp x2 cd cs) (d_OP_parserL2_dot_uscore_hash_lambda2 x3)
    cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x3 x2 l cd cs)
    (d_C__case_6 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x3 x2
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x3 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_6" [show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_6" (showCons x4))

d_C__case_5 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM CPP.ICode.Curry_ParseTypes.C_StandardToken
d_C__case_5 x6 x10 x9 x3 x2 x14 cd cs = case x14 of
  Curry_Prelude.C_True -> CPP.ICode.Curry_ParseMonad.d_C_throwPM x2
    (d_C_err_no_langtag cd cs) cd cs
  Curry_Prelude.C_False -> let x11 = CPP.ICode.Curry_ParsePos.d_C_movePosByString
                                 x2 (Curry_Prelude.d_OP_plus_plus
                                 (Curry_Prelude.d_C_replicate x3 (d_C_s_ident cd
                                 cs) cd cs) (Curry_Prelude.d_OP_plus_plus x6 x9
                                 cd cs) cd cs) cd cs
                               x12 = CPP.ICode.Curry_ParsePos.d_C_getCol x11 cd
                                 cs
                               x13 = d_C_removeOffset x11 x12 x10 cd cs
    in CPP.ICode.Curry_ParseMonad.d_C_bindPM x13
    (d_OP_disassembleIntExp_dot_uscore_hash_lambda4 x2 x11 x6) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x6 x10 x9 x3 x2
    l cd cs) (d_C__case_5 x6 x10 x9 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x6
    x10 x9 x3 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x6 x10
    x9 x3 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_5" [show x6, show x10, show x9, show x3, show
    x2, show x14] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_5" (showCons x14))

d_C__case_4 :: Curry_Prelude.C_Int -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_4 x2 x1 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> CPP.ICode.Curry_ParseMonad.d_C_cleanPM
    Curry_Prelude.OP_List cd cs
  Curry_Prelude.OP_Cons x5 x6 -> d_C__case_3 x2 x5 x1 x6 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_4 x2 x1 l cd cs)
    (d_C__case_4 x2 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_4 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_4 x2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_4" [show x2, show x1, show x4] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_4" (showCons x4))

d_C__case_3 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_3 x2 x5 x1 x6 cd cs = case x6 of
  Curry_Prelude.OP_List -> CPP.ICode.Curry_ParseMonad.d_C_cleanPM x5 cd cs
  Curry_Prelude.OP_Cons x7 x8 -> Curry_Prelude.d_OP_dollar
    (CPP.ICode.Curry_ParseMonad.d_C_liftPM (Curry_Prelude.d_OP_plus_plus x5))
    (d_C_removeOffsetFromLines (CPP.ICode.Curry_ParsePos.d_C_movePosByString x1
    (Curry_Prelude.d_OP_plus_plus x5 (Curry_Prelude.toCurryString "\n") cd cs)
    cd cs) x2 x6 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_3 x2 x5 x1 l cd
    cs) (d_C__case_3 x2 x5 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_3 x2
    x5 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_3 x2 x5
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_3" [show x2, show x5, show x1, show x6] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_3" (showCons x6))

d_C__case_2 :: Curry_Prelude.C_Int -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_Tuple2
  CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_2 x2 x3 x4 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> CPP.ICode.Curry_ParseMonad.d_C_cleanPM
    (Curry_Prelude.OP_Tuple2 x3 x4) cd cs
  Curry_Prelude.C_False -> d_C__case_1 x1 x3 x2 x4 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x2 x3 x4 x1 l
    cd cs) (d_C__case_2 x2 x3 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x2 x3
    x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x2 x3 x4
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_2" [show x2, show x3, show x4, show x1, show
    x5] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_2" (showCons x5))

d_C__case_1 :: CPP.ICode.Curry_ParsePos.C_Pos -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_Tuple2
  CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_1 x1 x3 x2 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> CPP.ICode.Curry_ParseMonad.d_C_cleanPM
    (Curry_Prelude.OP_Tuple2 x3 Curry_Prelude.OP_List) cd cs
  Curry_Prelude.OP_Cons x5 x6 -> d_C__case_0 x5 x1 x6 x3 x2 (d_C_isWhiteSpace x5
    cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_1 x1 x3 x2 l cd
    cs) (d_C__case_1 x1 x3 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_1 x1
    x3 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_1 x1 x3
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_1" [show x1, show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_1" (showCons x4))

d_C__case_0 :: Curry_Prelude.C_Char -> CPP.ICode.Curry_ParsePos.C_Pos
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> CPP.ICode.Curry_ParsePos.C_Pos -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> CPP.ICode.Curry_ParseMonad.C_PM (Curry_Prelude.OP_Tuple2
  CPP.ICode.Curry_ParsePos.C_Pos (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_0 x5 x1 x6 x3 x2 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> d_OP_removeOffsetFromLine_dot_removeOffsetFromLineIter_dot_169
    x1 x2 (CPP.ICode.Curry_ParsePos.d_C_movePosByChar x3 x5 cd cs) x6 cd cs
  Curry_Prelude.C_False -> CPP.ICode.Curry_ParseMonad.d_C_throwPM x1
    (d_C_err_layout_code cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x5 x1 x6 x3 x2
    l cd cs) (d_C__case_0 x5 x1 x6 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x5 x1
    x6 x3 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x5 x1 x6
    x3 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "CPP.ICode.ICodeParser._case_0" [show x5, show x1, show x6, show x3, show x2
    , show x7] info)
  _ -> failCons cd (consFail "CPP.ICode.ICodeParser._case_0" (showCons x7))

