{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Database.ERD.Curry_Generic
  ( d_C_showDatabaseKey
  , nd_C_showDatabaseKey
  , d_C_readDatabaseKey
  , nd_C_readDatabaseKey
  , d_C_newEntry
  , nd_C_newEntry
  , d_C_newEntryR
  , nd_C_newEntryR
  , d_C_getEntry
  , nd_C_getEntry
  , d_C_deleteEntryR
  , nd_C_deleteEntryR
  , d_C_existsEntryWithDBKey
  , nd_C_existsEntryWithDBKey
  , d_C_requiredForeignDBKey
  , nd_C_requiredForeignDBKey
  , d_C_getAllEntities
  , nd_C_getAllEntities
  , d_C_duplicateKeyTest
  , nd_C_duplicateKeyTest
  , d_C_duplicatePTest
  , nd_C_duplicatePTest
  , d_C_unique
  , nd_C_unique
  , d_C_uniqueUpdate
  , nd_C_uniqueUpdate
  , d_C_uniqueC
  , nd_C_uniqueC
  , d_C_unique2
  , nd_C_unique2
  , d_C_unique2C
  , nd_C_unique2C
  , d_C_maxPTest
  , d_C_maxTest
  , nd_C_maxTest
  , d_C_maxTestUpdate
  , nd_C_maxTestUpdate
  , d_C_maxTestC
  , nd_C_maxTestC
  , d_C_minTestC
  , nd_C_minTestC
  , d_C_maxTestInsert
  , nd_C_maxTestInsert
  , d_C_minTestDelete
  , nd_C_minTestDelete
  , d_C_saveDBTerms
  , nd_C_saveDBTerms
  , d_C_restoreDBTerms
  , nd_C_restoreDBTerms
  , d_C_restoreDBRelTerms
  , nd_C_restoreDBRelTerms
  , d_C_defaultString )
  where

import Basics
import qualified Data.Curry_List
import qualified Database.Curry_KeyDatabaseSQLite
import qualified Curry_Prelude


d_C_showDatabaseKey :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Int) -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showDatabaseKey x1 x2 x3 cd cs = Curry_Prelude.d_OP_plus_plus x1
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs) (Curry_Prelude.d_C_apply x2 x3 cd cs) cd cs) cd cs

nd_C_showDatabaseKey :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func t0
  Curry_Prelude.C_Int -> t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C_showDatabaseKey x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` Curry_Prelude.d_OP_plus_plus x1 (let s1 = leftSupply s2
                                                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (wrapDX id
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs)) (Curry_Prelude.nd_C_apply x2 x3 s0 cd cs) s1 cd cs)) cd cs

d_C_readDatabaseKey :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.C_Int
  -> Cover -> ConstStore -> t0) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.C_Maybe t0
d_C_readDatabaseKey x1 x2 x3 cd cs = let x4 = Curry_Prelude.d_C_splitAt
                                           (Curry_Prelude.d_C_length x1 cd cs)
                                           x3 cd cs
                                         x5 = d_OP_readDatabaseKey_dot_uscore_hash_selFP2_hash_ens
                                           x4 cd cs
                                         x6 = d_OP_readDatabaseKey_dot_uscore_hash_selFP3_hash_ks
                                           x4 cd cs
  in d_C__case_18 x6 x1 x5 x2 (Curry_Prelude.d_OP_amp_amp
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x5 x1 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_all
  Curry_Prelude.d_C_isDigit cd cs) x6 cd cs) cd cs) cd cs

nd_C_readDatabaseKey :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.C_Int
  t0 -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Maybe t0
nd_C_readDatabaseKey x1 x2 x3 s cd cs = let s6 = s
  in s6 `seq` (let x4 = Curry_Prelude.d_C_splitAt (Curry_Prelude.d_C_length x1
                     cd cs) x3 cd cs
                   x5 = d_OP_readDatabaseKey_dot_uscore_hash_selFP2_hash_ens x4
                     cd cs
                   x6 = d_OP_readDatabaseKey_dot_uscore_hash_selFP3_hash_ks x4
                     cd cs
  in let s5 = leftSupply s6
         s4 = rightSupply s6
  in s5 `seq` (s4 `seq` nd_C__case_18 x6 x1 x5 x2 (let s0 = leftSupply s4
                                                       s3 = rightSupply s4
  in s0 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp
  (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  x5 x1 s0 cd cs) (let s2 = leftSupply s3
                       s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_all (wrapDX
  id Curry_Prelude.d_C_isDigit) s1 cd cs) x6 s2 cd cs)) cd cs)) s5 cd cs))

d_OP_readDatabaseKey_dot_uscore_hash_selFP2_hash_ens :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_readDatabaseKey_dot_uscore_hash_selFP2_hash_ens x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_readDatabaseKey_dot_uscore_hash_selFP2_hash_ens l cd cs)
    (d_OP_readDatabaseKey_dot_uscore_hash_selFP2_hash_ens r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_readDatabaseKey_dot_uscore_hash_selFP2_hash_ens z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_readDatabaseKey_dot_uscore_hash_selFP2_hash_ens e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Database.ERD.Generic.readDatabaseKey._#selFP2#ens" [show x1] info)
  _ -> failCons cd (consFail "Database.ERD.Generic.readDatabaseKey._#selFP2#ens"
    (showCons x1))

d_OP_readDatabaseKey_dot_uscore_hash_selFP3_hash_ks :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_readDatabaseKey_dot_uscore_hash_selFP3_hash_ks x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_readDatabaseKey_dot_uscore_hash_selFP3_hash_ks l cd cs)
    (d_OP_readDatabaseKey_dot_uscore_hash_selFP3_hash_ks r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_readDatabaseKey_dot_uscore_hash_selFP3_hash_ks z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_readDatabaseKey_dot_uscore_hash_selFP3_hash_ks e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Database.ERD.Generic.readDatabaseKey._#selFP3#ks" [show x1] info)
  _ -> failCons cd (consFail "Database.ERD.Generic.readDatabaseKey._#selFP3#ks"
    (showCons x1))

d_C_newEntry :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> (Curry_Prelude.C_Int
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> t1 -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction t0
d_C_newEntry x1 x2 x3 x4 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt_eq
  (Database.Curry_KeyDatabaseSQLite.d_C_newDBEntry x1 x2 x4 cd cs)
  (d_OP_newEntry_dot_uscore_hash_lambda1 x4 x3) cd cs

nd_C_newEntry :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> Func Curry_Prelude.C_Int (Func t1
  Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Func Curry_Prelude.C_Int (Func
  t1 t0) -> t1 -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction t0
nd_C_newEntry x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt_eq
  (Database.Curry_KeyDatabaseSQLite.nd_C_newDBEntry x1 x2 x4 s0 cd cs) (wrapNX
  id (nd_OP_newEntry_dot_uscore_hash_lambda1 x4 x3)) s1 cd cs))

d_OP_newEntry_dot_uscore_hash_lambda1 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t1 -> (Curry_Prelude.C_Int -> Cover -> ConstStore
  -> t1 -> Cover -> ConstStore -> t0) -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction t0
d_OP_newEntry_dot_uscore_hash_lambda1 x1 x2 x3 cd cs = Curry_Prelude.d_C_apply
  (Database.Curry_KeyDatabaseSQLite.d_C_returnT cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply x2 x3 cd cs) x1 cd cs) cd cs

nd_OP_newEntry_dot_uscore_hash_lambda1 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t1 -> Func Curry_Prelude.C_Int (Func t1 t0)
  -> Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction t0
nd_OP_newEntry_dot_uscore_hash_lambda1 x1 x2 x3 s cd cs = let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s0 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (Database.Curry_KeyDatabaseSQLite.nd_C_returnT s0 cd cs) (let s2 = leftSupply
                                                                  s3
                                                                s1 = rightSupply
                                                                  s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2 x3
  s1 cd cs) x1 s2 cd cs)) s4 cd cs))))

d_C_newEntryR :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1
  t0 -> Cover -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> t1
  -> t0 -> Cover -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
d_C_newEntryR x1 x2 x3 x4 x5 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt
  (Database.Curry_KeyDatabaseSQLite.d_C_newDBEntry
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x1 x2) x3 (Curry_Prelude.OP_Tuple2 x4 x5) cd cs)
  (Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs) cd cs

nd_C_newEntryR :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Func Curry_Prelude.C_Int (Func (Curry_Prelude.OP_Tuple2 t1 t0)
  Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> t1 -> t0 -> IDSupply -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
nd_C_newEntryR x1 x2 x3 x4 x5 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt
  (Database.Curry_KeyDatabaseSQLite.nd_C_newDBEntry (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x1 x2)) x3 (Curry_Prelude.OP_Tuple2 x4 x5) s0 cd cs)
  (Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs) s1 cd cs))

d_C_getEntry :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t1 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> (Curry_Prelude.C_Int
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0)
  -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction t0
d_C_getEntry x1 x2 x3 x4 x5 cd cs = Curry_Prelude.d_OP_dollar
  (Curry_Prelude.d_C_seq x3) (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_seq
  x5) (Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt_eq
  (Database.Curry_KeyDatabaseSQLite.d_C_getDB
  (Database.Curry_KeyDatabaseSQLite.d_C_getDBInfo x1 x2 x3 x5 cd cs) cd cs)
  (Curry_Prelude.d_C_maybe (Curry_Prelude.d_C_apply
  (Database.Curry_KeyDatabaseSQLite.d_C_errorT cd cs)
  (Database.Curry_KeyDatabaseSQLite.C_TError
  Database.Curry_KeyDatabaseSQLite.C_KeyNotExistsError
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "database contains no entry for key: ") (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs) x5 cd cs) cd cs)) cd cs) (d_OP_getEntry_dot_uscore_hash_lambda2 x5 x4))
  cd cs) cd cs) cd cs

nd_C_getEntry :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> Func Curry_Prelude.C_Int (Func t1
  Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Func Curry_Prelude.C_Int (Func
  t1 t0) -> Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction t0
nd_C_getEntry x1 x2 x3 x4 x5 s cd cs = let s14 = s
  in s14 `seq` (let s13 = leftSupply s14
                    s12 = rightSupply s14
  in s13 `seq` (s12 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
  (Curry_Prelude.d_C_seq x3)) (let s11 = leftSupply s12
                                   s9 = rightSupply s12
  in s11 `seq` (s9 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
  (Curry_Prelude.d_C_seq x5)) (let s8 = leftSupply s9
                                   s10 = rightSupply s9
                                   s2 = leftSupply s10
                                   s6 = rightSupply s10
  in s8 `seq` (s10 `seq` (s2 `seq` (s6 `seq`
  Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt_eq (let s1 = leftSupply s2
                                                           s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_getDB
  (Database.Curry_KeyDatabaseSQLite.nd_C_getDBInfo x1 x2 x3 x5 s0 cd cs) s1 cd
  cs)) (wrapNX id (Curry_Prelude.nd_C_maybe (let s5 = leftSupply s6
                                                 s7 = rightSupply s6
                                                 s3 = leftSupply s7
                                                 s4 = rightSupply s7
  in s5 `seq` (s7 `seq` (s3 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
  (Database.Curry_KeyDatabaseSQLite.nd_C_errorT s3 cd cs)
  (Database.Curry_KeyDatabaseSQLite.C_TError
  Database.Curry_KeyDatabaseSQLite.C_KeyNotExistsError
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "database contains no entry for key: ") (Curry_Prelude.nd_C_apply (wrapDX id
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs)) x5 s4 cd cs) cd cs)) s5 cd cs)))) (wrapNX id
  (nd_OP_getEntry_dot_uscore_hash_lambda2 x5 x4)))) s8 cd cs)))) s11 cd cs)) s13
  cd cs))

d_OP_getEntry_dot_uscore_hash_lambda2 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Curry_Prelude.C_Int -> (Curry_Prelude.C_Int
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> t1 -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction t0
d_OP_getEntry_dot_uscore_hash_lambda2 x1 x2 x3 cd cs = Curry_Prelude.d_C_apply
  (Database.Curry_KeyDatabaseSQLite.d_C_returnT cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply x2 x1 cd cs) x3 cd cs) cd cs

nd_OP_getEntry_dot_uscore_hash_lambda2 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Curry_Prelude.C_Int -> Func Curry_Prelude.C_Int
  (Func t1 t0) -> t1 -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction t0
nd_OP_getEntry_dot_uscore_hash_lambda2 x1 x2 x3 s cd cs = let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s0 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (Database.Curry_KeyDatabaseSQLite.nd_C_returnT s0 cd cs) (let s2 = leftSupply
                                                                  s3
                                                                s1 = rightSupply
                                                                  s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2 x1
  s1 cd cs) x3 s2 cd cs)) s4 cd cs))))

d_C_deleteEntryR :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1
  t0 -> Cover -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> t1
  -> t0 -> Cover -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
d_C_deleteEntryR x1 x2 x3 x4 x5 x6 x7 x8 x9 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt_eq
  (Database.Curry_KeyDatabaseSQLite.d_C_getDB
  (Database.Curry_KeyDatabaseSQLite.d_C_transformQ (Curry_Prelude.d_OP_dot
  (Curry_Prelude.d_C_map Curry_Prelude.d_C_fst) (Curry_Prelude.d_C_filter
  (d_OP_deleteEntryR_dot_uscore_hash_lambda3 x9 x8 x4 x1)) cd cs)
  (Database.Curry_KeyDatabaseSQLite.d_C_allDBKeyInfos
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x2 x5)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x3 x6) x7 cd cs) cd cs) cd cs) (d_OP_deleteEntryR_dot_uscore_hash_lambda4 x9
  x8 x6 x3 x7) cd cs

nd_C_deleteEntryR :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Func Curry_Prelude.C_Int (Func (Curry_Prelude.OP_Tuple2 t1 t0)
  Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> t1 -> t0 -> IDSupply -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
nd_C_deleteEntryR x1 x2 x3 x4 x5 x6 x7 x8 x9 s cd cs = let s8 = s
  in s8 `seq` (let s7 = leftSupply s8
                   s6 = rightSupply s8
  in s7 `seq` (s6 `seq` Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt_eq
  (let s5 = leftSupply s6
       s3 = rightSupply s6
  in s5 `seq` (s3 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_getDB
  (let s2 = leftSupply s3
       s4 = rightSupply s3
       s0 = leftSupply s4
       s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq`
  Database.Curry_KeyDatabaseSQLite.nd_C_transformQ (Curry_Prelude.nd_OP_dot
  (wrapNX id (Curry_Prelude.nd_C_map (wrapDX id Curry_Prelude.d_C_fst))) (wrapNX
  id (Curry_Prelude.nd_C_filter (wrapNX id
  (nd_OP_deleteEntryR_dot_uscore_hash_lambda3 x9 x8 x4 x1)))) s0 cd cs)
  (Database.Curry_KeyDatabaseSQLite.nd_C_allDBKeyInfos (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x2 x5)) (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x3 x6)) x7 s1 cd cs) s2 cd cs)))) s5 cd cs)) (wrapNX id
  (nd_OP_deleteEntryR_dot_uscore_hash_lambda4 x9 x8 x6 x3 x7)) s7 cd cs))

d_OP_deleteEntryR_dot_uscore_hash_lambda3 :: forall t0 t1 . (Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t1) => t0 -> t1 -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_Tuple2 t1 t0) -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_OP_deleteEntryR_dot_uscore_hash_lambda3 x1 x2 x3 x4 x5 cd cs = case x5 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    x4 x3 x7 (Curry_Prelude.OP_Tuple2 x2 x1) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_deleteEntryR_dot_uscore_hash_lambda3 x1 x2 x3 x4 l cd cs)
    (d_OP_deleteEntryR_dot_uscore_hash_lambda3 x1 x2 x3 x4 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_deleteEntryR_dot_uscore_hash_lambda3 x1 x2 x3 x4 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_deleteEntryR_dot_uscore_hash_lambda3 x1 x2 x3 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Database.ERD.Generic.deleteEntryR._#lambda3" [show x1, show x2, show x3
    , show x4, show x5] info)
  _ -> failCons cd (consFail "Database.ERD.Generic.deleteEntryR._#lambda3"
    (showCons x5))

nd_OP_deleteEntryR_dot_uscore_hash_lambda3 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => t0 -> t1 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_Tuple2 t1 t0)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_deleteEntryR_dot_uscore_hash_lambda3 x1 x2 x3 x4 x5 s cd cs = case x5 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    x4 x3 x7 (Curry_Prelude.OP_Tuple2 x2 x1) s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_deleteEntryR_dot_uscore_hash_lambda3 x1 x2 x3 x4 l s cd cs)
    (nd_OP_deleteEntryR_dot_uscore_hash_lambda3 x1 x2 x3 x4 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_deleteEntryR_dot_uscore_hash_lambda3 x1 x2 x3 x4 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_deleteEntryR_dot_uscore_hash_lambda3 x1 x2 x3 x4 e s cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Database.ERD.Generic.deleteEntryR._#lambda3" [show x1, show x2, show x3
    , show x4, show x5] info)
  _ -> failCons cd (consFail "Database.ERD.Generic.deleteEntryR._#lambda3"
    (showCons x5))

d_OP_deleteEntryR_dot_uscore_hash_lambda4 :: forall t0 t1 . (Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t1) => t0 -> t1 -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t0 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_OP_deleteEntryR_dot_uscore_hash_lambda4 x1 x2 x3 x4 x5 x6 cd cs = d_C__case_17
  x6 x5 x1 x3 x2 x4 (Curry_Prelude.d_C_null x6 cd cs) cd cs

nd_OP_deleteEntryR_dot_uscore_hash_lambda4 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => t0 -> t1 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Func
  Curry_Prelude.C_Int (Func (Curry_Prelude.OP_Tuple2 t1 t0)
  Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_OP_deleteEntryR_dot_uscore_hash_lambda4 x1 x2 x3 x4 x5 x6 s cd cs =
  let s0 = s
  in s0 `seq` nd_C__case_17 x6 x5 x1 x3 x2 x4 (Curry_Prelude.d_C_null x6 cd cs)
  s0 cd cs

d_C_existsEntryWithDBKey :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
d_C_existsEntryWithDBKey x1 x2 x3 x4 x5 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt_eq
  (Database.Curry_KeyDatabaseSQLite.d_C_getDB
  (Database.Curry_KeyDatabaseSQLite.d_C_getDBInfo x1 x2 x4 x5 cd cs) cd cs)
  (Curry_Prelude.d_C_maybe (Curry_Prelude.d_C_apply
  (Database.Curry_KeyDatabaseSQLite.d_C_errorT cd cs)
  (Database.Curry_KeyDatabaseSQLite.C_TError
  Database.Curry_KeyDatabaseSQLite.C_KeyNotExistsError
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "database contains no entry for key: ") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs) x5 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  " in table: ") x3 cd cs) cd cs) cd cs)) cd cs) (Curry_Prelude.d_C_const
  (Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs))) cd cs

nd_C_existsEntryWithDBKey :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.C_Int
  (Func t0 Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Curry_Prelude.C_Int
  -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C_existsEntryWithDBKey x1 x2 x3 x4 x5 s cd cs = let s9 = s
  in s9 `seq` (let s8 = leftSupply s9
                   s10 = rightSupply s9
                   s2 = leftSupply s10
                   s6 = rightSupply s10
  in s8 `seq` (s10 `seq` (s2 `seq` (s6 `seq`
  Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt_eq (let s1 = leftSupply s2
                                                           s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_getDB
  (Database.Curry_KeyDatabaseSQLite.nd_C_getDBInfo x1 x2 x4 x5 s0 cd cs) s1 cd
  cs)) (wrapNX id (Curry_Prelude.nd_C_maybe (let s5 = leftSupply s6
                                                 s7 = rightSupply s6
                                                 s3 = leftSupply s7
                                                 s4 = rightSupply s7
  in s5 `seq` (s7 `seq` (s3 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
  (Database.Curry_KeyDatabaseSQLite.nd_C_errorT s3 cd cs)
  (Database.Curry_KeyDatabaseSQLite.C_TError
  Database.Curry_KeyDatabaseSQLite.C_KeyNotExistsError
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "database contains no entry for key: ") (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.nd_C_apply (wrapDX id
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs)) x5 s4 cd cs) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString " in table: ") x3 cd cs) cd cs) cd cs)) s5 cd
  cs)))) (wrapDX id (Curry_Prelude.d_C_const
  (Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs))))) s8 cd cs))))

d_C_requiredForeignDBKey :: forall t0 t1 t2 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t2)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Dynamic)
  -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t1 -> Cover -> ConstStore
  -> t0) -> (t0 -> Cover -> ConstStore -> t2) -> t2 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_C_requiredForeignDBKey x1 x2 x3 x4 x5 x6 x7 x8 x9 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt_eq
  (Database.Curry_KeyDatabaseSQLite.d_C_getDB (d_C_getAllEntities x1 x2 x6 x7 cd
  cs) cd cs) (d_OP_requiredForeignDBKey_dot_uscore_hash_lambda5 x9 x5 x3 x4 x8)
  cd cs

nd_C_requiredForeignDBKey :: forall t0 t1 t2 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t2) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t2)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.C_Int
  (Func t1 Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Func
  Curry_Prelude.C_Int (Func t1 t0) -> Func t0 t2 -> t2 -> IDSupply -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
nd_C_requiredForeignDBKey x1 x2 x3 x4 x5 x6 x7 x8 x9 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt_eq
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_getDB
  (nd_C_getAllEntities x1 x2 x6 x7 s0 cd cs) s1 cd cs)) (wrapNX id
  (nd_OP_requiredForeignDBKey_dot_uscore_hash_lambda5 x9 x5 x3 x4 x8)) s3 cd
  cs))

d_OP_requiredForeignDBKey_dot_uscore_hash_lambda5 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (t0 -> Cover -> ConstStore
  -> t1) -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_OP_requiredForeignDBKey_dot_uscore_hash_lambda5 x1 x2 x3 x4 x5 x6 cd cs =
  d_C__case_16 x6 x5 x3 x1 x2 x4 (Curry_Prelude.d_C_null
  (Curry_Prelude.d_C_filter
  (d_OP_requiredForeignDBKey_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6 x1
  x3 x5) x6 cd cs) cd cs) cd cs

nd_OP_requiredForeignDBKey_dot_uscore_hash_lambda5 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Func t0 t1
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_OP_requiredForeignDBKey_dot_uscore_hash_lambda5 x1 x2 x3 x4 x5 x6 s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_16 x6 x5 x3 x1 x2 x4 (Curry_Prelude.d_C_null
  (Curry_Prelude.nd_C_filter (wrapNX id
  (nd_OP_requiredForeignDBKey_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6 x1
  x3 x5)) x6 s0 cd cs) cd cs) s1 cd cs))

d_OP_requiredForeignDBKey_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (t0 -> Cover -> ConstStore
  -> t1) -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_requiredForeignDBKey_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6 x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq x2
  cd cs) (Curry_Prelude.d_C_apply x3 x4 cd cs) cd cs) x1 cd cs

nd_OP_requiredForeignDBKey_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func t0 t1
  -> t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_requiredForeignDBKey_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6 x1 x2 x3 x4 s cd cs =
  let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s3 = rightSupply s6
  in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                      s4 = rightSupply s3
                                                      s0 = leftSupply s4
                                                      s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_eq_eq x2 s0 cd cs) (Curry_Prelude.nd_C_apply x3 x4 s1 cd
  cs) s2 cd cs)))) x1 s5 cd cs))

d_C_getAllEntities :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> (Curry_Prelude.C_Int
  -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t1) -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Query
  (Curry_Prelude.OP_List t1)
d_C_getAllEntities x1 x2 x3 x4 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_C_transformQ (Curry_Prelude.d_C_map
  (Curry_Prelude.d_C_uncurry x4))
  (Database.Curry_KeyDatabaseSQLite.d_C_allDBKeyInfos x1 x2 x3 cd cs) cd cs

nd_C_getAllEntities :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Func Curry_Prelude.C_Int (Func
  t0 Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Func Curry_Prelude.C_Int
  (Func t0 t1) -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Query (Curry_Prelude.OP_List t1)
nd_C_getAllEntities x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_transformQ (wrapNX
  id (Curry_Prelude.nd_C_map (wrapNX id (Curry_Prelude.nd_C_uncurry x4))))
  (Database.Curry_KeyDatabaseSQLite.nd_C_allDBKeyInfos x1 x2 x3 s0 cd cs) s1 cd
  cs))

d_C_duplicateKeyTest :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.C_Int -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
d_C_duplicateKeyTest x1 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt_eq
  (Database.Curry_KeyDatabaseSQLite.d_C_getDB
  (Database.Curry_KeyDatabaseSQLite.d_C_allDBKeys x1 cd cs) cd cs)
  d_OP_duplicateKeyTest_dot_uscore_hash_lambda7 cd cs

nd_C_duplicateKeyTest :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.C_Int (Func t0 Database.Curry_KeyDatabaseSQLite.C_Dynamic)
  -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C_duplicateKeyTest x1 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt_eq
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_getDB
  (Database.Curry_KeyDatabaseSQLite.nd_C_allDBKeys x1 s0 cd cs) s1 cd cs))
  (wrapDX id d_OP_duplicateKeyTest_dot_uscore_hash_lambda7) s3 cd cs))

d_OP_duplicateKeyTest_dot_uscore_hash_lambda7 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_OP_duplicateKeyTest_dot_uscore_hash_lambda7 x1 cd cs = d_C__case_15 x1
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_length (Data.Curry_List.d_C_nub
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  x1 cd cs) cd cs) (Curry_Prelude.d_C_length x1 cd cs) cd cs) cd cs

d_C_duplicatePTest :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
d_C_duplicatePTest x1 x2 cd cs = d_C__case_14 x2 x1
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_length (Data.Curry_List.d_C_nub x1 x2 cd cs) cd cs)
  (Curry_Prelude.d_C_length x2 cd cs) cd cs) cd cs

nd_C_duplicatePTest :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C_duplicatePTest x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_14 x2 x1
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_length (Data.Curry_List.nd_C_nub x1 x2 s0 cd cs) cd cs)
  (Curry_Prelude.d_C_length x2 cd cs) cd cs) s1 cd cs))

d_C_unique :: forall t0 t1 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t2) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t2)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> (Curry_Prelude.C_Int
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> (t0 -> Cover
  -> ConstStore -> t2) -> t2 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_C_unique x1 x2 x3 x4 x5 x6 x7 x8 x9 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt_eq
  (Database.Curry_KeyDatabaseSQLite.d_C_getDB
  (Database.Curry_KeyDatabaseSQLite.d_C_allDBKeyInfos x1 x2 x6 cd cs) cd cs)
  (d_OP_unique_dot_uscore_hash_lambda8 x9 x5 x3 x4 x7 x8) cd cs

nd_C_unique :: forall t0 t1 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t2) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func Curry_Prelude.C_Int (Func t1
  Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Func Curry_Prelude.C_Int (Func
  t1 t0) -> Func t0 t2 -> t2 -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C_unique x1 x2 x3 x4 x5 x6 x7 x8 x9 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt_eq
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_getDB
  (Database.Curry_KeyDatabaseSQLite.nd_C_allDBKeyInfos x1 x2 x6 s0 cd cs) s1 cd
  cs)) (wrapNX id (nd_OP_unique_dot_uscore_hash_lambda8 x9 x5 x3 x4 x7 x8)) s3
  cd cs))

d_OP_unique_dot_uscore_hash_lambda8 :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t2
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t2)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> (t0 -> Cover
  -> ConstStore -> t2) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t1) -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_OP_unique_dot_uscore_hash_lambda8 x1 x2 x3 x4 x5 x6 x7 cd cs = d_C__case_13 x7
  x5 x6 x3 x1 x4 x2 (Curry_Prelude.d_C_null (Curry_Prelude.d_C_filter
  (d_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 x1 x3 x6)
  (Curry_Prelude.d_C_map
  (d_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 x5) x7 cd cs) cd
  cs) cd cs) cd cs

nd_OP_unique_dot_uscore_hash_lambda8 :: forall t0 t1 t2 . (Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t2
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t2) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> Func Curry_Prelude.C_Int (Func
  t1 t0) -> Func t0 t2 -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t1) -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_OP_unique_dot_uscore_hash_lambda8 x1 x2 x3 x4 x5 x6 x7 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` nd_C__case_13 x7 x5 x6 x3 x1 x4 x2
  (Curry_Prelude.d_C_null (let s1 = leftSupply s2
                               s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_filter (wrapNX id
  (nd_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 x1 x3 x6))
  (Curry_Prelude.nd_C_map (wrapNX id
  (nd_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 x5)) x7 s0 cd
  cs) s1 cd cs)) cd cs) s3 cd cs))

d_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (t0 -> Cover -> ConstStore
  -> t1) -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq x2
  cd cs) (Curry_Prelude.d_C_apply x3 x4 cd cs) cd cs) x1 cd cs

nd_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func t0 t1
  -> t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 x1 x2 x3 x4 s cd cs =
  let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s3 = rightSupply s6
  in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                      s4 = rightSupply s3
                                                      s0 = leftSupply s4
                                                      s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_eq_eq x2 s0 cd cs) (Curry_Prelude.nd_C_apply x3 x4 s1 cd
  cs) s2 cd cs)))) x1 s5 cd cs))

d_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => (Curry_Prelude.C_Int
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0)
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t1 -> Cover -> ConstStore -> t0
d_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x1 x3 cd cs) x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 x1 l cd cs)
    (d_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 x1 e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Database.ERD.Generic.unique._#lambda8._#lambda10" [show x1, show x2] info)
  _ -> failCons cd (consFail "Database.ERD.Generic.unique._#lambda8._#lambda10"
    (showCons x2))

nd_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.C_Int (Func t1 t0) -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t1 -> IDSupply -> Cover -> ConstStore -> t0
nd_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x3 s0 cd cs) x4 s1 cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 x1 l s cd cs)
    (nd_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 x1 z s cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_unique_dot_uscore_hash_lambda8_dot_uscore_hash_lambda10 x1 e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Database.ERD.Generic.unique._#lambda8._#lambda10" [show x1, show x2] info)
  _ -> failCons cd (consFail "Database.ERD.Generic.unique._#lambda8._#lambda10"
    (showCons x2))

d_C_uniqueUpdate :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t2)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t2
  -> Cover -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Dynamic)
  -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t2 -> Cover -> ConstStore
  -> t1) -> (t1 -> Cover -> ConstStore -> Curry_Prelude.C_Int) -> (t1 -> Cover
  -> ConstStore -> t0) -> t1 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_C_uniqueUpdate x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 cd cs =
  let x11 = Curry_Prelude.d_C_apply x8 x10 cd cs
  in Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt_eq
  (Database.Curry_KeyDatabaseSQLite.d_C_getDB
  (Database.Curry_KeyDatabaseSQLite.d_C_getDBInfo x1 x2 x6 x11 cd cs) cd cs)
  (Curry_Prelude.d_C_maybe (Curry_Prelude.d_C_apply
  (Database.Curry_KeyDatabaseSQLite.d_C_errorT cd cs)
  (Database.Curry_KeyDatabaseSQLite.C_TError
  Database.Curry_KeyDatabaseSQLite.C_KeyNotExistsError
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "database contains no entry for key: ") (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs) x11 cd cs) cd cs)) cd cs) (d_OP_uniqueUpdate_dot_uscore_hash_lambda11
  x11 x10 x5 x3 x1 x4 x2 x6 x7 x9)) cd cs

nd_C_uniqueUpdate :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t2) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.C_Int
  (Func t2 Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Func
  Curry_Prelude.C_Int (Func t2 t1) -> Func t1 Curry_Prelude.C_Int -> Func t1 t0
  -> t1 -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C_uniqueUpdate x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 s cd cs = let s12 = s
  in s12 `seq` (let s0 = leftSupply s12
                    s10 = rightSupply s12
  in s0 `seq` (s10 `seq` (let x11 = Curry_Prelude.nd_C_apply x8 x10 s0 cd cs
  in let s9 = leftSupply s10
         s11 = rightSupply s10
         s3 = leftSupply s11
         s7 = rightSupply s11
  in s9 `seq` (s11 `seq` (s3 `seq` (s7 `seq`
  Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt_eq (let s2 = leftSupply s3
                                                           s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_getDB
  (Database.Curry_KeyDatabaseSQLite.nd_C_getDBInfo x1 x2 x6 x11 s1 cd cs) s2 cd
  cs)) (wrapNX id (Curry_Prelude.nd_C_maybe (let s6 = leftSupply s7
                                                 s8 = rightSupply s7
                                                 s4 = leftSupply s8
                                                 s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s4 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
  (Database.Curry_KeyDatabaseSQLite.nd_C_errorT s4 cd cs)
  (Database.Curry_KeyDatabaseSQLite.C_TError
  Database.Curry_KeyDatabaseSQLite.C_KeyNotExistsError
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "database contains no entry for key: ") (Curry_Prelude.nd_C_apply (wrapDX id
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs)) x11 s5 cd cs) cd cs)) s6 cd cs)))) (wrapNX id
  (nd_OP_uniqueUpdate_dot_uscore_hash_lambda11 x11 x10 x5 x3 x1 x4 x2 x6 x7
  x9)))) s9 cd cs))))))

d_OP_uniqueUpdate_dot_uscore_hash_lambda11 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t2) => Curry_Prelude.C_Int -> t1 -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t2)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t2)
  -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t2 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> (Curry_Prelude.C_Int
  -> Cover -> ConstStore -> t2 -> Cover -> ConstStore -> t1) -> (t1 -> Cover
  -> ConstStore -> t0) -> t2 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_OP_uniqueUpdate_dot_uscore_hash_lambda11 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt_eq
  (Database.Curry_KeyDatabaseSQLite.d_C_getDB
  (Database.Curry_KeyDatabaseSQLite.d_C_allDBKeyInfos x5 x7 x8 cd cs) cd cs)
  (d_OP_uniqueUpdate_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12 x1 x2 x11
  x3 x4 x6 x9 x10) cd cs

nd_OP_uniqueUpdate_dot_uscore_hash_lambda11 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t2) => Curry_Prelude.C_Int -> t1 -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t2)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t2)
  -> Func Curry_Prelude.C_Int (Func t2
  Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Func Curry_Prelude.C_Int (Func
  t2 t1) -> Func t1 t0 -> t2 -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_OP_uniqueUpdate_dot_uscore_hash_lambda11 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 s cd cs =
  let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt_eq
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_getDB
  (Database.Curry_KeyDatabaseSQLite.nd_C_allDBKeyInfos x5 x7 x8 s0 cd cs) s1 cd
  cs)) (wrapNX id
  (nd_OP_uniqueUpdate_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12 x1 x2
  x11 x3 x4 x6 x9 x10)) s3 cd cs))

d_OP_uniqueUpdate_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12 :: forall t0
  t1 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> t1 -> t2 -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t2 -> Cover -> ConstStore
  -> t1) -> (t1 -> Cover -> ConstStore -> t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t2) -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_OP_uniqueUpdate_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12 x1 x2 x3 x4 x5 x6 x7 x8 x9 cd cs =
  let x10 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x7 x1 cd cs) x3 cd
        cs
      x11 = Curry_Prelude.d_C_filter
        (d_OP_uniqueUpdate_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12_dot_uscore_hash_lambda13
        x2 x5 x8) (Curry_Prelude.d_C_map (Curry_Prelude.d_C_uncurry x7) x9 cd
        cs) cd cs
  in d_C__case_12 x2 x8 x10 x5 x11 x6 x4 (Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_C_null x11 cd cs) (Curry_Prelude.d_OP_amp_amp
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_length x11 cd cs) (Curry_Prelude.C_Int (1)) cd cs)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq x5
  cd cs) (Curry_Prelude.d_C_apply x8 x10 cd cs) cd cs) (Curry_Prelude.d_C_apply
  x8 x2 cd cs) cd cs) cd cs) cd cs) cd cs

nd_OP_uniqueUpdate_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12 :: forall t0
  t1 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> t1 -> t2 -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Func Curry_Prelude.C_Int (Func
  t2 t1) -> Func t1 t0 -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t2) -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_OP_uniqueUpdate_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12 x1 x2 x3 x4 x5 x6 x7 x8 x9 s cd cs =
  let s17 = s
  in s17 `seq` (let s2 = leftSupply s17
                    s18 = rightSupply s17
                    s5 = leftSupply s18
                    s16 = rightSupply s18
  in s2 `seq` (s18 `seq` (s5 `seq` (s16 `seq` (let x10 = let s1 = leftSupply s2
                                                             s0 = rightSupply s2
                                                     in s1 `seq` (s0 `seq`
                                                     Curry_Prelude.nd_C_apply
                                                     (Curry_Prelude.nd_C_apply
                                                     x7 x1 s0 cd cs) x3 s1 cd
                                                     cs)
                                                   x11 = let s4 = leftSupply s5
                                                             s3 = rightSupply s5
                                                     in s4 `seq` (s3 `seq`
                                                     Curry_Prelude.nd_C_filter
                                                     (wrapNX id
                                                     (nd_OP_uniqueUpdate_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12_dot_uscore_hash_lambda13
                                                     x2 x5 x8))
                                                     (Curry_Prelude.nd_C_map
                                                     (wrapNX id
                                                     (Curry_Prelude.nd_C_uncurry
                                                     x7)) x9 s3 cd cs) s4 cd cs)
  in let s15 = leftSupply s16
         s13 = rightSupply s16
  in s15 `seq` (s13 `seq` nd_C__case_12 x2 x8 x10 x5 x11 x6 x4
  (Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_C_null x11 cd cs)
  (Curry_Prelude.d_OP_amp_amp
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_length x11 cd cs) (Curry_Prelude.C_Int (1)) cd cs)
  (let s12 = leftSupply s13
       s14 = rightSupply s13
       s9 = leftSupply s14
       s11 = rightSupply s14
  in s12 `seq` (s14 `seq` (s9 `seq` (s11 `seq` Curry_Prelude.nd_C_apply
  (let s8 = leftSupply s9
       s10 = rightSupply s9
       s6 = leftSupply s10
       s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s6 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_eq_eq x5 s6 cd cs) (Curry_Prelude.nd_C_apply x8 x10 s7 cd
  cs) s8 cd cs)))) (Curry_Prelude.nd_C_apply x8 x2 s11 cd cs) s12 cd cs)))) cd
  cs) cd cs) s15 cd cs))))))

d_OP_uniqueUpdate_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12_dot_uscore_hash_lambda13 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> (t1 -> Cover -> ConstStore
  -> t0) -> t1 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uniqueUpdate_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12_dot_uscore_hash_lambda13 x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq x2
  cd cs) (Curry_Prelude.d_C_apply x3 x1 cd cs) cd cs) (Curry_Prelude.d_C_apply
  x3 x4 cd cs) cd cs

nd_OP_uniqueUpdate_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12_dot_uscore_hash_lambda13 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Func t1 t0
  -> t1 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uniqueUpdate_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12_dot_uscore_hash_lambda13 x1 x2 x3 x4 s cd cs =
  let s7 = s
  in s7 `seq` (let s6 = leftSupply s7
                   s8 = rightSupply s7
                   s3 = leftSupply s8
                   s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
  (let s2 = leftSupply s3
       s4 = rightSupply s3
       s0 = leftSupply s4
       s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_eq_eq x2 s0 cd cs) (Curry_Prelude.nd_C_apply x3 x1 s1 cd
  cs) s2 cd cs)))) (Curry_Prelude.nd_C_apply x3 x4 s5 cd cs) s6 cd cs))))

d_C_uniqueC :: forall t0 t1 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t2) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t2)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> (Curry_Prelude.C_Int
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> (t0 -> Cover
  -> ConstStore -> t2) -> t0 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_C_uniqueC x1 x2 x3 x4 x5 x6 x7 x8 x9 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt_eq
  (Database.Curry_KeyDatabaseSQLite.d_C_getDB
  (Database.Curry_KeyDatabaseSQLite.d_C_allDBKeyInfos x1 x2 x6 cd cs) cd cs)
  (d_OP_uniqueC_dot_uscore_hash_lambda14 x9 x5 x3 x4 x7 x8) cd cs

nd_C_uniqueC :: forall t0 t1 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t2) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func Curry_Prelude.C_Int (Func t1
  Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Func Curry_Prelude.C_Int (Func
  t1 t0) -> Func t0 t2 -> t0 -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C_uniqueC x1 x2 x3 x4 x5 x6 x7 x8 x9 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt_eq
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_getDB
  (Database.Curry_KeyDatabaseSQLite.nd_C_allDBKeyInfos x1 x2 x6 s0 cd cs) s1 cd
  cs)) (wrapNX id (nd_OP_uniqueC_dot_uscore_hash_lambda14 x9 x5 x3 x4 x7 x8)) s3
  cd cs))

d_OP_uniqueC_dot_uscore_hash_lambda14 :: forall t0 t1 t2 . (Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t2, Curry_Prelude.Curry t1) => t0
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t2)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> (t0 -> Cover
  -> ConstStore -> t2) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t1) -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_OP_uniqueC_dot_uscore_hash_lambda14 x1 x2 x3 x4 x5 x6 x7 cd cs =
  let x8 = Curry_Prelude.d_C_filter
        (d_OP_uniqueC_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15 x1 x3
        x6) (Curry_Prelude.d_C_map (Curry_Prelude.d_C_uncurry x5) x7 cd cs) cd
        cs
  in d_C__case_11 x8 x1 x6 x4 x2
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_length x8 cd cs) (Curry_Prelude.C_Int (1)) cd cs) cd cs

nd_OP_uniqueC_dot_uscore_hash_lambda14 :: forall t0 t1 t2 . (Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t2, Curry_Prelude.Curry t1) => t0
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t2) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> Func Curry_Prelude.C_Int (Func
  t1 t0) -> Func t0 t2 -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t1) -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_OP_uniqueC_dot_uscore_hash_lambda14 x1 x2 x3 x4 x5 x6 x7 s cd cs = let s4 = s
  in s4 `seq` (let s2 = leftSupply s4
                   s3 = rightSupply s4
  in s2 `seq` (s3 `seq` (let x8 = let s1 = leftSupply s2
                                      s0 = rightSupply s2
                               in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_filter
                               (wrapNX id
                               (nd_OP_uniqueC_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15
                               x1 x3 x6)) (Curry_Prelude.nd_C_map (wrapNX id
                               (Curry_Prelude.nd_C_uncurry x5)) x7 s0 cd cs) s1
                               cd cs)
  in nd_C__case_11 x8 x1 x6 x4 x2
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_length x8 cd cs) (Curry_Prelude.C_Int (1)) cd cs) s3 cd
  cs)))

d_OP_uniqueC_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (t0 -> Cover -> ConstStore
  -> t1) -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uniqueC_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15 x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq x2
  cd cs) (Curry_Prelude.d_C_apply x3 x1 cd cs) cd cs) (Curry_Prelude.d_C_apply
  x3 x4 cd cs) cd cs

nd_OP_uniqueC_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func t0 t1
  -> t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uniqueC_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15 x1 x2 x3 x4 s cd cs =
  let s7 = s
  in s7 `seq` (let s6 = leftSupply s7
                   s8 = rightSupply s7
                   s3 = leftSupply s8
                   s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
  (let s2 = leftSupply s3
       s4 = rightSupply s3
       s0 = leftSupply s4
       s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_eq_eq x2 s0 cd cs) (Curry_Prelude.nd_C_apply x3 x1 s1 cd
  cs) s2 cd cs)))) (Curry_Prelude.nd_C_apply x3 x4 s5 cd cs) s6 cd cs))))

d_C_unique2 :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1
  t0 -> Cover -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> t1
  -> t0 -> Cover -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
d_C_unique2 x1 x2 x3 x4 x5 x6 x7 x8 x9 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt_eq
  (Database.Curry_KeyDatabaseSQLite.d_C_getDB
  (Database.Curry_KeyDatabaseSQLite.d_C_allDBInfos
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x3 x4)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x5 x6) x7 cd cs) cd cs) (d_OP_unique2_dot_uscore_hash_lambda16 x9 x8 x2 x1) cd
  cs

nd_C_unique2 :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Func Curry_Prelude.C_Int (Func (Curry_Prelude.OP_Tuple2 t1 t0)
  Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> t1 -> t0 -> IDSupply -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
nd_C_unique2 x1 x2 x3 x4 x5 x6 x7 x8 x9 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt_eq
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_getDB
  (Database.Curry_KeyDatabaseSQLite.nd_C_allDBInfos (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x3 x4)) (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x5 x6)) x7 s0 cd cs) s1 cd cs)) (wrapNX id
  (nd_OP_unique2_dot_uscore_hash_lambda16 x9 x8 x2 x1)) s3 cd cs))

d_OP_unique2_dot_uscore_hash_lambda16 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => t0 -> t1 -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 t0) -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_OP_unique2_dot_uscore_hash_lambda16 x1 x2 x3 x4 x5 cd cs = d_C__case_10 x5 x1
  x2 x3 x4 (Curry_Prelude.d_C_null (Curry_Prelude.d_C_filter
  (Curry_Prelude.d_C_flip (acceptCs id
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x4 x3)) (Curry_Prelude.OP_Tuple2 x2 x1)) x5 cd cs) cd cs) cd cs

nd_OP_unique2_dot_uscore_hash_lambda16 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => t0 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 t0) -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_OP_unique2_dot_uscore_hash_lambda16 x1 x2 x3 x4 x5 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_10 x5 x1 x2 x3 x4 (Curry_Prelude.d_C_null
  (Curry_Prelude.nd_C_filter (wrapNX id (Curry_Prelude.nd_C_flip (wrapDX (wrapNX
  id) (acceptCs id
  (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x4 x3))) (Curry_Prelude.OP_Tuple2 x2 x1))) x5 s0 cd cs) cd cs) s1 cd cs))

d_C_unique2C :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1
  t0 -> Cover -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> t1
  -> t0 -> Cover -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
d_C_unique2C x1 x2 x3 x4 x5 x6 x7 x8 x9 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt_eq
  (Database.Curry_KeyDatabaseSQLite.d_C_getDB
  (Database.Curry_KeyDatabaseSQLite.d_C_allDBInfos
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x3 x4)
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x5 x6) x7 cd cs) cd cs) (d_OP_unique2C_dot_uscore_hash_lambda17 x9 x8 x2 x1)
  cd cs

nd_C_unique2C :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Func Curry_Prelude.C_Int (Func (Curry_Prelude.OP_Tuple2 t1 t0)
  Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> t1 -> t0 -> IDSupply -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
nd_C_unique2C x1 x2 x3 x4 x5 x6 x7 x8 x9 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt_eq
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_getDB
  (Database.Curry_KeyDatabaseSQLite.nd_C_allDBInfos (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x3 x4)) (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x5 x6)) x7 s0 cd cs) s1 cd cs)) (wrapNX id
  (nd_OP_unique2C_dot_uscore_hash_lambda17 x9 x8 x2 x1)) s3 cd cs))

d_OP_unique2C_dot_uscore_hash_lambda17 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => t0 -> t1 -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 t0) -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_OP_unique2C_dot_uscore_hash_lambda17 x1 x2 x3 x4 x5 cd cs = d_C__case_9 x5 x1
  x2 x3 x4 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) (Curry_Prelude.d_C_length (Curry_Prelude.d_C_filter
  (Curry_Prelude.d_C_flip (acceptCs id
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x4 x3)) (Curry_Prelude.OP_Tuple2 x2 x1)) x5 cd cs) cd cs) cd cs)
  (Curry_Prelude.C_Int (1)) cd cs) cd cs

nd_OP_unique2C_dot_uscore_hash_lambda17 :: forall t0 t1 . (Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t1) => t0 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 t0) -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_OP_unique2C_dot_uscore_hash_lambda17 x1 x2 x3 x4 x5 s cd cs = let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s4 = rightSupply s6
  in s5 `seq` (s4 `seq` nd_C__case_9 x5 x1 x2 x3 x4 (let s3 = leftSupply s4
                                                         s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (wrapDX (wrapDX id)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs)) (Curry_Prelude.d_C_length (Curry_Prelude.nd_C_filter (wrapNX id
  (Curry_Prelude.nd_C_flip (wrapDX (wrapNX id) (acceptCs id
  (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x4 x3))) (Curry_Prelude.OP_Tuple2 x2 x1))) x5 s0 cd cs) cd cs) s1 cd cs))
  (Curry_Prelude.C_Int (1)) s3 cd cs)) s5 cd cs))

d_C_maxPTest :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_C_maxPTest x1 x2 cd cs = d_C__case_8 x1 x2 (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) (Curry_Prelude.d_C_length x2 cd cs) cd cs) x1 cd cs) cd cs

d_C_maxTest :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t2) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t2)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> t2 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> (Curry_Prelude.C_Int
  -> Cover -> ConstStore -> t2 -> Cover -> ConstStore -> t1) -> (t1 -> Cover
  -> ConstStore -> t0) -> Curry_Prelude.C_Int -> t0 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_C_maxTest x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt_eq
  (Database.Curry_KeyDatabaseSQLite.d_C_getDB (d_C_getAllEntities x1 x2 x6 x7 cd
  cs) cd cs) (d_OP_maxTest_dot_uscore_hash_lambda18 x9 x10 x5 x3 x4 x8) cd cs

nd_C_maxTest :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t1) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t2) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func Curry_Prelude.C_Int (Func t2
  Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Func Curry_Prelude.C_Int (Func
  t2 t1) -> Func t1 t0 -> Curry_Prelude.C_Int -> t0 -> IDSupply -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
nd_C_maxTest x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt_eq
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_getDB
  (nd_C_getAllEntities x1 x2 x6 x7 s0 cd cs) s1 cd cs)) (wrapNX id
  (nd_OP_maxTest_dot_uscore_hash_lambda18 x9 x10 x5 x3 x4 x8)) s3 cd cs))

d_OP_maxTest_dot_uscore_hash_lambda18 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Curry_Prelude.C_Int -> t0
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> (t1 -> Cover -> ConstStore
  -> t0) -> Curry_Prelude.OP_List t1 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_OP_maxTest_dot_uscore_hash_lambda18 x1 x2 x3 x4 x5 x6 x7 cd cs =
  let x8 = Curry_Prelude.d_C_filter
        (d_OP_maxTest_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 x2 x4
        x6) x7 cd cs
  in d_C__case_7 x1 x8 x3 x2 x5 (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) (Curry_Prelude.d_C_length x8 cd cs) cd cs) x1 cd cs) cd cs

nd_OP_maxTest_dot_uscore_hash_lambda18 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Curry_Prelude.C_Int -> t0
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Func t1 t0
  -> Curry_Prelude.OP_List t1 -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_OP_maxTest_dot_uscore_hash_lambda18 x1 x2 x3 x4 x5 x6 x7 s cd cs = let s6 = s
  in s6 `seq` (let s0 = leftSupply s6
                   s5 = rightSupply s6
  in s0 `seq` (s5 `seq` (let x8 = Curry_Prelude.nd_C_filter (wrapNX id
                               (nd_OP_maxTest_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19
                               x2 x4 x6)) x7 s0 cd cs
  in let s4 = leftSupply s5
         s3 = rightSupply s5
  in s4 `seq` (s3 `seq` nd_C__case_7 x1 x8 x3 x2 x5 (let s2 = leftSupply s3
                                                         s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
  (wrapDX (wrapDX id)
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs)) (Curry_Prelude.d_C_length x8 cd cs) s1 cd cs) x1 s2 cd cs)) s4 cd
  cs))))

d_OP_maxTest_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> (t1 -> Cover -> ConstStore
  -> t0) -> t1 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_maxTest_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq x2
  cd cs) x1 cd cs) (Curry_Prelude.d_C_apply x3 x4 cd cs) cd cs

nd_OP_maxTest_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Func t1 t0
  -> t1 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_maxTest_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 x1 x2 x3 x4 s cd cs =
  let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s2 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq x2
  s0 cd cs) x1 s1 cd cs)) (Curry_Prelude.nd_C_apply x3 x4 s3 cd cs) s4 cd cs))))

d_C_maxTestUpdate :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t2)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t2
  -> Cover -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Dynamic)
  -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t2 -> Cover -> ConstStore
  -> t0) -> (t0 -> Cover -> ConstStore -> Curry_Prelude.C_Int) -> (t0 -> Cover
  -> ConstStore -> t1) -> Curry_Prelude.C_Int -> t0 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_C_maxTestUpdate x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt_eq
  (Database.Curry_KeyDatabaseSQLite.d_C_getDB (d_C_getAllEntities x1 x2 x6 x7 cd
  cs) cd cs) (d_OP_maxTestUpdate_dot_uscore_hash_lambda20 x10 x11 x5 x3 x1 x4 x2
  x6 x7 x8 x9) cd cs

nd_C_maxTestUpdate :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t2) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.C_Int
  (Func t2 Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Func
  Curry_Prelude.C_Int (Func t2 t0) -> Func t0 Curry_Prelude.C_Int -> Func t0 t1
  -> Curry_Prelude.C_Int -> t0 -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C_maxTestUpdate x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt_eq
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_getDB
  (nd_C_getAllEntities x1 x2 x6 x7 s0 cd cs) s1 cd cs)) (wrapNX id
  (nd_OP_maxTestUpdate_dot_uscore_hash_lambda20 x10 x11 x5 x3 x1 x4 x2 x6 x7 x8
  x9)) s3 cd cs))

d_OP_maxTestUpdate_dot_uscore_hash_lambda20 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2) => Curry_Prelude.C_Int -> t0 -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t2)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t2)
  -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t2 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> (Curry_Prelude.C_Int
  -> Cover -> ConstStore -> t2 -> Cover -> ConstStore -> t0) -> (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Int) -> (t0 -> Cover -> ConstStore -> t1)
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_OP_maxTestUpdate_dot_uscore_hash_lambda20 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 cd cs =
  let x13 = Curry_Prelude.d_C_filter
        (d_OP_maxTestUpdate_dot_uscore_hash_lambda20_dot_uscore_hash_lambda21 x2
        x4 x11) x12 cd cs
  in Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt_eq (d_C_getEntry x5 x7 x8
  x9 (Curry_Prelude.d_C_apply x10 x2 cd cs) cd cs)
  (d_OP_maxTestUpdate_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22 x1 x2 x3
  x13 x4 x6 x11) cd cs

nd_OP_maxTestUpdate_dot_uscore_hash_lambda20 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2) => Curry_Prelude.C_Int -> t0 -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t2)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t2)
  -> Func Curry_Prelude.C_Int (Func t2
  Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Func Curry_Prelude.C_Int (Func
  t2 t0) -> Func t0 Curry_Prelude.C_Int -> Func t0 t1 -> Curry_Prelude.OP_List
  t0 -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_OP_maxTestUpdate_dot_uscore_hash_lambda20 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 s cd cs =
  let s6 = s
  in s6 `seq` (let s0 = leftSupply s6
                   s5 = rightSupply s6
  in s0 `seq` (s5 `seq` (let x13 = Curry_Prelude.nd_C_filter (wrapNX id
                               (nd_OP_maxTestUpdate_dot_uscore_hash_lambda20_dot_uscore_hash_lambda21
                               x2 x4 x11)) x12 s0 cd cs
  in let s4 = leftSupply s5
         s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt_eq
  (let s2 = leftSupply s3
       s1 = rightSupply s3
  in s2 `seq` (s1 `seq` nd_C_getEntry x5 x7 x8 x9 (Curry_Prelude.nd_C_apply x10
  x2 s1 cd cs) s2 cd cs)) (wrapNX id
  (nd_OP_maxTestUpdate_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22 x1 x2
  x3 x13 x4 x6 x11)) s4 cd cs))))

d_OP_maxTestUpdate_dot_uscore_hash_lambda20_dot_uscore_hash_lambda21 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (t0 -> Cover -> ConstStore
  -> t1) -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_maxTestUpdate_dot_uscore_hash_lambda20_dot_uscore_hash_lambda21 x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq x2
  cd cs) (Curry_Prelude.d_C_apply x3 x1 cd cs) cd cs) (Curry_Prelude.d_C_apply
  x3 x4 cd cs) cd cs

nd_OP_maxTestUpdate_dot_uscore_hash_lambda20_dot_uscore_hash_lambda21 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func t0 t1
  -> t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_maxTestUpdate_dot_uscore_hash_lambda20_dot_uscore_hash_lambda21 x1 x2 x3 x4 s cd cs =
  let s7 = s
  in s7 `seq` (let s6 = leftSupply s7
                   s8 = rightSupply s7
                   s3 = leftSupply s8
                   s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
  (let s2 = leftSupply s3
       s4 = rightSupply s3
       s0 = leftSupply s4
       s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_eq_eq x2 s0 cd cs) (Curry_Prelude.nd_C_apply x3 x1 s1 cd
  cs) s2 cd cs)))) (Curry_Prelude.nd_C_apply x3 x4 s5 cd cs) s6 cd cs))))

d_OP_maxTestUpdate_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => Curry_Prelude.C_Int
  -> t0 -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  t0 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (t0 -> Cover
  -> ConstStore -> t1) -> t0 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_OP_maxTestUpdate_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22 x1 x2 x3 x4 x5 x6 x7 x8 cd cs =
  d_C__case_6 x2 x7 x8 x5 x1 x4 x3 x6 (Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) (Curry_Prelude.d_C_length x4 cd cs) cd cs) x1 cd cs)
  (Curry_Prelude.d_OP_amp_amp
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_length x4 cd cs) x1 cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq x5 cd cs)
  (Curry_Prelude.d_C_apply x7 x8 cd cs) cd cs) (Curry_Prelude.d_C_apply x7 x2 cd
  cs) cd cs) cd cs) cd cs) cd cs

nd_OP_maxTestUpdate_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => Curry_Prelude.C_Int
  -> t0 -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  t0 -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> Func t0 t1 -> t0 -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_OP_maxTestUpdate_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22 x1 x2 x3 x4 x5 x6 x7 x8 s cd cs =
  let s14 = s
  in s14 `seq` (let s13 = leftSupply s14
                    s12 = rightSupply s14
  in s13 `seq` (s12 `seq` nd_C__case_6 x2 x7 x8 x5 x1 x4 x3 x6
  (let s2 = leftSupply s12
       s10 = rightSupply s12
  in s2 `seq` (s10 `seq` Curry_Prelude.d_OP_bar_bar (let s1 = leftSupply s2
                                                         s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
  (wrapDX (wrapDX id)
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs)) (Curry_Prelude.d_C_length x4 cd cs) s0 cd cs) x1 s1 cd cs))
  (Curry_Prelude.d_OP_amp_amp
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_length x4 cd cs) x1 cd cs) (let s9 = leftSupply s10
                                                     s11 = rightSupply s10
                                                     s6 = leftSupply s11
                                                     s8 = rightSupply s11
  in s9 `seq` (s11 `seq` (s6 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
  (let s5 = leftSupply s6
       s7 = rightSupply s6
       s3 = leftSupply s7
       s4 = rightSupply s7
  in s5 `seq` (s7 `seq` (s3 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_eq_eq x5 s3 cd cs) (Curry_Prelude.nd_C_apply x7 x8 s4 cd
  cs) s5 cd cs)))) (Curry_Prelude.nd_C_apply x7 x2 s8 cd cs) s9 cd cs)))) cd cs)
  cd cs)) s13 cd cs))

d_C_maxTestC :: forall t0 t1 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t2) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t2)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> (Curry_Prelude.C_Int
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> (t0 -> Cover
  -> ConstStore -> t2) -> Curry_Prelude.C_Int -> t2 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_C_maxTestC x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt_eq
  (Database.Curry_KeyDatabaseSQLite.d_C_getDB (d_C_getAllEntities x1 x2 x6 x7 cd
  cs) cd cs) (d_OP_maxTestC_dot_uscore_hash_lambda23 x9 x10 x5 x3 x4 x8) cd cs

nd_C_maxTestC :: forall t0 t1 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t2) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func Curry_Prelude.C_Int (Func t1
  Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Func Curry_Prelude.C_Int (Func
  t1 t0) -> Func t0 t2 -> Curry_Prelude.C_Int -> t2 -> IDSupply -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
nd_C_maxTestC x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt_eq
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_getDB
  (nd_C_getAllEntities x1 x2 x6 x7 s0 cd cs) s1 cd cs)) (wrapNX id
  (nd_OP_maxTestC_dot_uscore_hash_lambda23 x9 x10 x5 x3 x4 x8)) s3 cd cs))

d_OP_maxTestC_dot_uscore_hash_lambda23 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Curry_Prelude.C_Int -> t1
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (t0 -> Cover -> ConstStore
  -> t1) -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_OP_maxTestC_dot_uscore_hash_lambda23 x1 x2 x3 x4 x5 x6 x7 cd cs = d_C__case_5
  x1 x7 x6 x4 x2 x3 x5
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_length (Curry_Prelude.d_C_filter
  (d_OP_maxTestC_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24 x2 x4 x6) x7
  cd cs) cd cs) x1 cd cs) cd cs

nd_OP_maxTestC_dot_uscore_hash_lambda23 :: forall t0 t1 . (Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Curry_Prelude.C_Int -> t1
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Func t0 t1
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_OP_maxTestC_dot_uscore_hash_lambda23 x1 x2 x3 x4 x5 x6 x7 s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_5 x1 x7 x6 x4 x2 x3 x5
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_length (Curry_Prelude.nd_C_filter (wrapNX id
  (nd_OP_maxTestC_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24 x2 x4 x6))
  x7 s0 cd cs) cd cs) x1 cd cs) s1 cd cs))

d_OP_maxTestC_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (t0 -> Cover -> ConstStore
  -> t1) -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_maxTestC_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24 x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq x2
  cd cs) (Curry_Prelude.d_C_apply x3 x4 cd cs) cd cs) x1 cd cs

nd_OP_maxTestC_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func t0 t1
  -> t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_maxTestC_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24 x1 x2 x3 x4 s cd cs =
  let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s3 = rightSupply s6
  in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                      s4 = rightSupply s3
                                                      s0 = leftSupply s4
                                                      s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_eq_eq x2 s0 cd cs) (Curry_Prelude.nd_C_apply x3 x4 s1 cd
  cs) s2 cd cs)))) x1 s5 cd cs))

d_C_minTestC :: forall t0 t1 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t2) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t2)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> (Curry_Prelude.C_Int
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> (t0 -> Cover
  -> ConstStore -> t2) -> Curry_Prelude.C_Int -> t2 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_C_minTestC x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt_eq
  (Database.Curry_KeyDatabaseSQLite.d_C_getDB (d_C_getAllEntities x1 x2 x6 x7 cd
  cs) cd cs) (d_OP_minTestC_dot_uscore_hash_lambda25 x9 x10 x5 x3 x4 x8) cd cs

nd_C_minTestC :: forall t0 t1 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t2) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func Curry_Prelude.C_Int (Func t1
  Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Func Curry_Prelude.C_Int (Func
  t1 t0) -> Func t0 t2 -> Curry_Prelude.C_Int -> t2 -> IDSupply -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
nd_C_minTestC x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt_eq
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_getDB
  (nd_C_getAllEntities x1 x2 x6 x7 s0 cd cs) s1 cd cs)) (wrapNX id
  (nd_OP_minTestC_dot_uscore_hash_lambda25 x9 x10 x5 x3 x4 x8)) s3 cd cs))

d_OP_minTestC_dot_uscore_hash_lambda25 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Curry_Prelude.C_Int -> t1
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (t0 -> Cover -> ConstStore
  -> t1) -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_OP_minTestC_dot_uscore_hash_lambda25 x1 x2 x3 x4 x5 x6 x7 cd cs = d_C__case_4
  x1 x7 x6 x4 x2 x3 x5 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) (Curry_Prelude.d_C_length (Curry_Prelude.d_C_filter
  (d_OP_minTestC_dot_uscore_hash_lambda25_dot_uscore_hash_lambda26 x2 x4 x6) x7
  cd cs) cd cs) cd cs) x1 cd cs) cd cs

nd_OP_minTestC_dot_uscore_hash_lambda25 :: forall t0 t1 . (Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Curry_Prelude.C_Int -> t1
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Func t0 t1
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_OP_minTestC_dot_uscore_hash_lambda25 x1 x2 x3 x4 x5 x6 x7 s cd cs =
  let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s4 = rightSupply s6
  in s5 `seq` (s4 `seq` nd_C__case_4 x1 x7 x6 x4 x2 x3 x5 (let s3 = leftSupply
                                                                 s4
                                                               s2 = rightSupply
                                                                 s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (wrapDX (wrapDX id)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs)) (Curry_Prelude.d_C_length (Curry_Prelude.nd_C_filter (wrapNX id
  (nd_OP_minTestC_dot_uscore_hash_lambda25_dot_uscore_hash_lambda26 x2 x4 x6))
  x7 s0 cd cs) cd cs) s1 cd cs)) x1 s3 cd cs)) s5 cd cs))

d_OP_minTestC_dot_uscore_hash_lambda25_dot_uscore_hash_lambda26 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (t0 -> Cover -> ConstStore
  -> t1) -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_minTestC_dot_uscore_hash_lambda25_dot_uscore_hash_lambda26 x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq x2
  cd cs) (Curry_Prelude.d_C_apply x3 x4 cd cs) cd cs) x1 cd cs

nd_OP_minTestC_dot_uscore_hash_lambda25_dot_uscore_hash_lambda26 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func t0 t1
  -> t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_minTestC_dot_uscore_hash_lambda25_dot_uscore_hash_lambda26 x1 x2 x3 x4 s cd cs =
  let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s3 = rightSupply s6
  in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                      s4 = rightSupply s3
                                                      s0 = leftSupply s4
                                                      s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_eq_eq x2 s0 cd cs) (Curry_Prelude.nd_C_apply x3 x4 s1 cd
  cs) s2 cd cs)))) x1 s5 cd cs))

d_C_maxTestInsert :: forall t0 t1 t2 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t2)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Dynamic)
  -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t1 -> Cover -> ConstStore
  -> t0) -> (t0 -> Cover -> ConstStore -> t2) -> Curry_Prelude.C_Int -> t2
  -> Cover -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
d_C_maxTestInsert x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt_eq
  (Database.Curry_KeyDatabaseSQLite.d_C_getDB (d_C_getAllEntities x1 x2 x6 x7 cd
  cs) cd cs) (d_OP_maxTestInsert_dot_uscore_hash_lambda27 x9 x10 x5 x3 x4 x8) cd
  cs

nd_C_maxTestInsert :: forall t0 t1 t2 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t2) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t2)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.C_Int
  (Func t1 Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Func
  Curry_Prelude.C_Int (Func t1 t0) -> Func t0 t2 -> Curry_Prelude.C_Int -> t2
  -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C_maxTestInsert x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt_eq
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_getDB
  (nd_C_getAllEntities x1 x2 x6 x7 s0 cd cs) s1 cd cs)) (wrapNX id
  (nd_OP_maxTestInsert_dot_uscore_hash_lambda27 x9 x10 x5 x3 x4 x8)) s3 cd cs))

d_OP_maxTestInsert_dot_uscore_hash_lambda27 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> t1 -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (t0 -> Cover -> ConstStore
  -> t1) -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_OP_maxTestInsert_dot_uscore_hash_lambda27 x1 x2 x3 x4 x5 x6 x7 cd cs =
  d_C__case_3 x1 x7 x6 x4 x2 x3 x5 (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) (Curry_Prelude.d_C_length (Curry_Prelude.d_C_filter
  (d_OP_maxTestInsert_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28 x2 x4
  x6) x7 cd cs) cd cs) cd cs) x1 cd cs) cd cs

nd_OP_maxTestInsert_dot_uscore_hash_lambda27 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> t1 -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Func t0
  t1 -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_OP_maxTestInsert_dot_uscore_hash_lambda27 x1 x2 x3 x4 x5 x6 x7 s cd cs =
  let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s4 = rightSupply s6
  in s5 `seq` (s4 `seq` nd_C__case_3 x1 x7 x6 x4 x2 x3 x5 (let s3 = leftSupply
                                                                 s4
                                                               s2 = rightSupply
                                                                 s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (wrapDX (wrapDX id)
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs)) (Curry_Prelude.d_C_length (Curry_Prelude.nd_C_filter (wrapNX id
  (nd_OP_maxTestInsert_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28 x2 x4
  x6)) x7 s0 cd cs) cd cs) s1 cd cs)) x1 s3 cd cs)) s5 cd cs))

d_OP_maxTestInsert_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (t0 -> Cover -> ConstStore
  -> t1) -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_maxTestInsert_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28 x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq x2
  cd cs) (Curry_Prelude.d_C_apply x3 x4 cd cs) cd cs) x1 cd cs

nd_OP_maxTestInsert_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func t0 t1
  -> t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_maxTestInsert_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28 x1 x2 x3 x4 s cd cs =
  let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s3 = rightSupply s6
  in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                      s4 = rightSupply s3
                                                      s0 = leftSupply s4
                                                      s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_eq_eq x2 s0 cd cs) (Curry_Prelude.nd_C_apply x3 x4 s1 cd
  cs) s2 cd cs)))) x1 s5 cd cs))

d_C_minTestDelete :: forall t0 t1 t2 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t2)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Dynamic)
  -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t1 -> Cover -> ConstStore
  -> t0) -> (t0 -> Cover -> ConstStore -> t2) -> Curry_Prelude.C_Int -> t2
  -> Cover -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
d_C_minTestDelete x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_OP_bar_gt_gt_eq
  (Database.Curry_KeyDatabaseSQLite.d_C_getDB (d_C_getAllEntities x1 x2 x6 x7 cd
  cs) cd cs) (d_OP_minTestDelete_dot_uscore_hash_lambda29 x9 x10 x5 x3 x4 x8) cd
  cs

nd_C_minTestDelete :: forall t0 t1 t2 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t2) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t2)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.C_Int
  (Func t1 Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Func
  Curry_Prelude.C_Int (Func t1 t0) -> Func t0 t2 -> Curry_Prelude.C_Int -> t2
  -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C_minTestDelete x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Database.Curry_KeyDatabaseSQLite.nd_OP_bar_gt_gt_eq
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_getDB
  (nd_C_getAllEntities x1 x2 x6 x7 s0 cd cs) s1 cd cs)) (wrapNX id
  (nd_OP_minTestDelete_dot_uscore_hash_lambda29 x9 x10 x5 x3 x4 x8)) s3 cd cs))

d_OP_minTestDelete_dot_uscore_hash_lambda29 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> t1 -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (t0 -> Cover -> ConstStore
  -> t1) -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_OP_minTestDelete_dot_uscore_hash_lambda29 x1 x2 x3 x4 x5 x6 x7 cd cs =
  d_C__case_2 x1 x7 x6 x4 x2 x3 x5 (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) (Curry_Prelude.d_C_length (Curry_Prelude.d_C_filter
  (d_OP_minTestDelete_dot_uscore_hash_lambda29_dot_uscore_hash_lambda30 x2 x4
  x6) x7 cd cs) cd cs) cd cs) x1 cd cs) cd cs

nd_OP_minTestDelete_dot_uscore_hash_lambda29 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> t1 -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Func t0
  t1 -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_OP_minTestDelete_dot_uscore_hash_lambda29 x1 x2 x3 x4 x5 x6 x7 s cd cs =
  let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s4 = rightSupply s6
  in s5 `seq` (s4 `seq` nd_C__case_2 x1 x7 x6 x4 x2 x3 x5 (let s3 = leftSupply
                                                                 s4
                                                               s2 = rightSupply
                                                                 s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (wrapDX (wrapDX id)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs)) (Curry_Prelude.d_C_length (Curry_Prelude.nd_C_filter (wrapNX id
  (nd_OP_minTestDelete_dot_uscore_hash_lambda29_dot_uscore_hash_lambda30 x2 x4
  x6)) x7 s0 cd cs) cd cs) s1 cd cs)) x1 s3 cd cs)) s5 cd cs))

d_OP_minTestDelete_dot_uscore_hash_lambda29_dot_uscore_hash_lambda30 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (t0 -> Cover -> ConstStore
  -> t1) -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_minTestDelete_dot_uscore_hash_lambda29_dot_uscore_hash_lambda30 x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq x2
  cd cs) (Curry_Prelude.d_C_apply x3 x4 cd cs) cd cs) x1 cd cs

nd_OP_minTestDelete_dot_uscore_hash_lambda29_dot_uscore_hash_lambda30 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func t0 t1
  -> t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_minTestDelete_dot_uscore_hash_lambda29_dot_uscore_hash_lambda30 x1 x2 x3 x4 s cd cs =
  let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s3 = rightSupply s6
  in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                      s4 = rightSupply s3
                                                      s0 = leftSupply s4
                                                      s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_eq_eq x2 s0 cd cs) (Curry_Prelude.nd_C_apply x3 x4 s1 cd
  cs) s2 cd cs)))) x1 s5 cd cs))

d_C_saveDBTerms :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t1 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> (Curry_Prelude.C_Int
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_saveDBTerms x1 x2 x3 x4 x5 x6 x7 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Database.Curry_KeyDatabaseSQLite.d_C_runQ
  (Database.Curry_KeyDatabaseSQLite.d_C_allDBKeyInfos x1 x2 x6 cd cs) cd cs) cd
  cs) (d_OP_saveDBTerms_dot_uscore_hash_lambda32 x5 x4 x3 x7) cd cs

nd_C_saveDBTerms :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func Curry_Prelude.C_Int (Func t1
  Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> Func Curry_Prelude.C_Int (Func
  t1 t0) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
nd_C_saveDBTerms x1 x2 x3 x4 x5 x6 x7 s cd cs = let s8 = s
  in s8 `seq` (let s7 = leftSupply s8
                   s5 = rightSupply s8
  in s7 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                      s6 = rightSupply s5
                                                      s0 = leftSupply s6
                                                      s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (let s2 = leftSupply s3
                 s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_runQ
  (Database.Curry_KeyDatabaseSQLite.nd_C_allDBKeyInfos x1 x2 x6 s1 cd cs) s2 cd
  cs)) s4 cd cs)))) (wrapNX id (nd_OP_saveDBTerms_dot_uscore_hash_lambda32 x5 x4
  x3 x7)) s7 cd cs))

d_OP_saveDBTerms_dot_uscore_hash_lambda32 :: forall t0 t1 . (Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t1) => Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t1 -> Cover -> ConstStore
  -> t0) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  t1) -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_saveDBTerms_dot_uscore_hash_lambda32 x1 x2 x3 x4 x5 cd cs = let x6 = x5
                                                                     x7 = Curry_Prelude.d_OP_plus_plus
                                                                       x2
                                                                       (Curry_Prelude.d_OP_plus_plus
                                                                       (Curry_Prelude.toCurryString
                                                                       "/")
                                                                       (Curry_Prelude.d_OP_plus_plus
                                                                       x1
                                                                       (Curry_Prelude.toCurryString
                                                                       ".terms")
                                                                       cd cs) cd
                                                                       cs) cd cs
                                                                     x8 = Curry_Prelude.d_C_map
                                                                       (Curry_Prelude.d_C_uncurry
                                                                       x4) x6 cd
                                                                       cs
                                                                     x9 = Curry_Prelude.d_C_apply
                                                                       (Curry_Prelude.d_C_unlines
                                                                       cd cs)
                                                                       (Curry_Prelude.d_C_map
                                                                       (Curry_Prelude.d_C_show
                                                                       x3 cd cs)
                                                                       x8 cd cs)
                                                                       cd cs
  in d_C__case_1 x2 x9 x7 (Curry_Prelude.d_C_null x2 cd cs) cd cs

nd_OP_saveDBTerms_dot_uscore_hash_lambda32 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Func
  Curry_Prelude.C_Int (Func t1 t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t1) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_OP_saveDBTerms_dot_uscore_hash_lambda32 x1 x2 x3 x4 x5 s cd cs = let s6 = s
  in s6 `seq` (let s0 = leftSupply s6
                   s5 = rightSupply s6
  in s0 `seq` (s5 `seq` (let x6 = x5
                             x7 = Curry_Prelude.d_OP_plus_plus x2
                               (Curry_Prelude.d_OP_plus_plus
                               (Curry_Prelude.toCurryString "/")
                               (Curry_Prelude.d_OP_plus_plus x1
                               (Curry_Prelude.toCurryString ".terms") cd cs) cd
                               cs) cd cs
                             x8 = Curry_Prelude.nd_C_map (wrapNX id
                               (Curry_Prelude.nd_C_uncurry x4)) x6 s0 cd cs
                             x9 = let s4 = leftSupply s5
                                      s3 = rightSupply s5
                               in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
                               (wrapDX id (Curry_Prelude.d_C_unlines cd cs))
                               (let s2 = leftSupply s3
                                    s1 = rightSupply s3
                               in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_map
                               (Curry_Prelude.nd_C_show x3 s1 cd cs) x8 s2 cd
                               cs)) s4 cd cs)
  in d_C__case_1 x2 x9 x7 (Curry_Prelude.d_C_null x2 cd cs) cd cs)))

d_C_restoreDBTerms :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t0
  -> Cover -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> (t1
  -> Cover -> ConstStore -> Curry_Prelude.C_Int) -> (t1 -> Cover -> ConstStore
  -> t0) -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_restoreDBTerms x1 x2 x3 x4 x5 x6 x7 cd cs =
  let x8 = Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.d_OP_plus_plus
        (Curry_Prelude.toCurryString "/") (Curry_Prelude.d_OP_plus_plus x4
        (Curry_Prelude.toCurryString ".terms") cd cs) cd cs) cd cs
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Restoring from ")
  x8 cd cs) cd cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_readFile x8 cd cs) cd cs) (Curry_Prelude.d_OP_dot
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_map (Curry_Prelude.d_C_read
  x1)) Curry_Prelude.d_C_lines cd cs) cd cs) cd cs) cd cs)
  (d_OP_restoreDBTerms_dot_uscore_hash_lambda35 x2 x5 x6 x7) cd cs) cd cs

nd_C_restoreDBTerms :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  Curry_Prelude.C_Int (Func t0 Database.Curry_KeyDatabaseSQLite.C_Dynamic)
  -> Func t1 Curry_Prelude.C_Int -> Func t1 t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_C_restoreDBTerms x1 x2 x3 x4 x5 x6 x7 s cd cs = let s23 = s
  in s23 `seq` (let x8 = Curry_Prelude.d_OP_plus_plus x3
                      (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
                      "/") (Curry_Prelude.d_OP_plus_plus x4
                      (Curry_Prelude.toCurryString ".terms") cd cs) cd cs) cd cs
  in let s22 = leftSupply s23
         s24 = rightSupply s23
         s3 = leftSupply s24
         s21 = rightSupply s24
  in s22 `seq` (s24 `seq` (s3 `seq` (s21 `seq` Curry_Prelude.nd_C_apply
  (let s2 = leftSupply s3
       s4 = rightSupply s3
       s0 = leftSupply s4
       s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (Curry_Prelude.nd_OP_dollar (wrapDX id Curry_Prelude.d_C_putStrLn)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Restoring from ")
  x8 cd cs) s1 cd cs) s2 cd cs)))) (let s20 = leftSupply s21
                                        s18 = rightSupply s21
  in s20 `seq` (s18 `seq` Curry_Prelude.nd_C_apply (let s17 = leftSupply s18
                                                        s19 = rightSupply s18
                                                        s5 = leftSupply s19
                                                        s15 = rightSupply s19
  in s17 `seq` (s19 `seq` (s5 `seq` (s15 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s5 cd cs) (let s14 = leftSupply s15
                 s16 = rightSupply s15
                 s8 = leftSupply s16
                 s12 = rightSupply s16
  in s14 `seq` (s16 `seq` (s8 `seq` (s12 `seq` Curry_Prelude.nd_C_apply
  (let s7 = leftSupply s8
       s6 = rightSupply s8
  in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s6 cd cs) (Curry_Prelude.d_C_readFile x8 cd cs) s7 cd cs))
  (let s11 = leftSupply s12
       s13 = rightSupply s12
       s9 = leftSupply s13
       s10 = rightSupply s13
  in s11 `seq` (s13 `seq` (s9 `seq` (s10 `seq` Curry_Prelude.nd_OP_dot
  (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s9 cd cs) (Curry_Prelude.nd_OP_dot (wrapNX id (Curry_Prelude.nd_C_map (wrapNX
  id (Curry_Prelude.nd_C_read x1)))) (wrapDX id Curry_Prelude.d_C_lines) s10 cd
  cs) s11 cd cs)))) s14 cd cs)))) s17 cd cs)))) (wrapNX id
  (nd_OP_restoreDBTerms_dot_uscore_hash_lambda35 x2 x5 x6 x7)) s20 cd cs)) s22
  cd cs))))

d_OP_restoreDBTerms_dot_uscore_hash_lambda35 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> (t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Int) -> (t1 -> Cover -> ConstStore -> t0)
  -> Curry_Prelude.OP_List t1 -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_OP_restoreDBTerms_dot_uscore_hash_lambda35 x1 x2 x3 x4 x5 cd cs = let x6 = x5
  in Database.Curry_KeyDatabaseSQLite.d_C_runJustT (Curry_Prelude.d_C_apply
  (Database.Curry_KeyDatabaseSQLite.d_C_mapT_
  (d_OP_restoreDBTerms_dot_uscore_hash_lambda35_dot_uscore_hash_lambda37 x1 x2
  x3 x4) cd cs) x6 cd cs) cd cs

nd_OP_restoreDBTerms_dot_uscore_hash_lambda35 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Func
  Curry_Prelude.C_Int (Func t0 Database.Curry_KeyDatabaseSQLite.C_Dynamic)
  -> Func t1 Curry_Prelude.C_Int -> Func t1 t0 -> Curry_Prelude.OP_List t1
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_OP_restoreDBTerms_dot_uscore_hash_lambda35 x1 x2 x3 x4 x5 s cd cs =
  let s4 = s
  in s4 `seq` (let x6 = x5
  in let s3 = leftSupply s4
         s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_runJustT
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Database.Curry_KeyDatabaseSQLite.nd_C_mapT_ (wrapNX id
  (nd_OP_restoreDBTerms_dot_uscore_hash_lambda35_dot_uscore_hash_lambda37 x1 x2
  x3 x4)) s0 cd cs) x6 s1 cd cs)) s3 cd cs))

d_OP_restoreDBTerms_dot_uscore_hash_lambda35_dot_uscore_hash_lambda37 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> (t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Int) -> (t1 -> Cover -> ConstStore -> t0) -> t1 -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
d_OP_restoreDBTerms_dot_uscore_hash_lambda35_dot_uscore_hash_lambda37 x1 x2 x3 x4 x5 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_C_newDBKeyEntry x1 x2
  (Curry_Prelude.d_C_apply x3 x5 cd cs) (Curry_Prelude.d_C_apply x4 x5 cd cs) cd
  cs

nd_OP_restoreDBTerms_dot_uscore_hash_lambda35_dot_uscore_hash_lambda37 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Func
  Curry_Prelude.C_Int (Func t0 Database.Curry_KeyDatabaseSQLite.C_Dynamic)
  -> Func t1 Curry_Prelude.C_Int -> Func t1 t0 -> t1 -> IDSupply -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
nd_OP_restoreDBTerms_dot_uscore_hash_lambda35_dot_uscore_hash_lambda37 x1 x2 x3 x4 x5 s cd cs =
  let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq`
  Database.Curry_KeyDatabaseSQLite.nd_C_newDBKeyEntry x1 x2
  (Curry_Prelude.nd_C_apply x3 x5 s0 cd cs) (Curry_Prelude.nd_C_apply x4 x5 s1
  cd cs) s2 cd cs))))

d_C_restoreDBRelTerms :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t0
  -> Cover -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> (t1
  -> Cover -> ConstStore -> t0) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_C_restoreDBRelTerms x1 x2 x3 x4 x5 x6 cd cs =
  let x7 = Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.d_OP_plus_plus
        (Curry_Prelude.toCurryString "/") (Curry_Prelude.d_OP_plus_plus x4
        (Curry_Prelude.toCurryString ".terms") cd cs) cd cs) cd cs
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Restoring from ")
  x7 cd cs) cd cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_C_readFile x7 cd cs) cd cs) (Curry_Prelude.d_OP_dot
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  cd cs) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_map (Curry_Prelude.d_C_read
  x1)) Curry_Prelude.d_C_lines cd cs) cd cs) cd cs) cd cs)
  (d_OP_restoreDBRelTerms_dot_uscore_hash_lambda39 x2 x5 x6) cd cs) cd cs

nd_C_restoreDBRelTerms :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  Curry_Prelude.C_Int (Func t0 Database.Curry_KeyDatabaseSQLite.C_Dynamic)
  -> Func t1 t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
nd_C_restoreDBRelTerms x1 x2 x3 x4 x5 x6 s cd cs = let s23 = s
  in s23 `seq` (let x7 = Curry_Prelude.d_OP_plus_plus x3
                      (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
                      "/") (Curry_Prelude.d_OP_plus_plus x4
                      (Curry_Prelude.toCurryString ".terms") cd cs) cd cs) cd cs
  in let s22 = leftSupply s23
         s24 = rightSupply s23
         s3 = leftSupply s24
         s21 = rightSupply s24
  in s22 `seq` (s24 `seq` (s3 `seq` (s21 `seq` Curry_Prelude.nd_C_apply
  (let s2 = leftSupply s3
       s4 = rightSupply s3
       s0 = leftSupply s4
       s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s0 cd cs) (Curry_Prelude.nd_OP_dollar (wrapDX id Curry_Prelude.d_C_putStrLn)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Restoring from ")
  x7 cd cs) s1 cd cs) s2 cd cs)))) (let s20 = leftSupply s21
                                        s18 = rightSupply s21
  in s20 `seq` (s18 `seq` Curry_Prelude.nd_C_apply (let s17 = leftSupply s18
                                                        s19 = rightSupply s18
                                                        s5 = leftSupply s19
                                                        s15 = rightSupply s19
  in s17 `seq` (s19 `seq` (s5 `seq` (s15 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s5 cd cs) (let s14 = leftSupply s15
                 s16 = rightSupply s15
                 s8 = leftSupply s16
                 s12 = rightSupply s16
  in s14 `seq` (s16 `seq` (s8 `seq` (s12 `seq` Curry_Prelude.nd_C_apply
  (let s7 = leftSupply s8
       s6 = rightSupply s8
  in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s6 cd cs) (Curry_Prelude.d_C_readFile x7 cd cs) s7 cd cs))
  (let s11 = leftSupply s12
       s13 = rightSupply s12
       s9 = leftSupply s13
       s10 = rightSupply s13
  in s11 `seq` (s13 `seq` (s9 `seq` (s10 `seq` Curry_Prelude.nd_OP_dot
  (Curry_Prelude.nd_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
  s9 cd cs) (Curry_Prelude.nd_OP_dot (wrapNX id (Curry_Prelude.nd_C_map (wrapNX
  id (Curry_Prelude.nd_C_read x1)))) (wrapDX id Curry_Prelude.d_C_lines) s10 cd
  cs) s11 cd cs)))) s14 cd cs)))) s17 cd cs)))) (wrapNX id
  (nd_OP_restoreDBRelTerms_dot_uscore_hash_lambda39 x2 x5 x6)) s20 cd cs)) s22
  cd cs))))

d_OP_restoreDBRelTerms_dot_uscore_hash_lambda39 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> (t1 -> Cover -> ConstStore
  -> t0) -> Curry_Prelude.OP_List t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_restoreDBRelTerms_dot_uscore_hash_lambda39 x1 x2 x3 x4 cd cs = let x5 = x4
  in Database.Curry_KeyDatabaseSQLite.d_C_runJustT (Curry_Prelude.d_C_apply
  (Database.Curry_KeyDatabaseSQLite.d_C_mapT_
  (d_OP_restoreDBRelTerms_dot_uscore_hash_lambda39_dot_uscore_hash_lambda41 x1
  x2 x3) cd cs) x5 cd cs) cd cs

nd_OP_restoreDBRelTerms_dot_uscore_hash_lambda39 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Func
  Curry_Prelude.C_Int (Func t0 Database.Curry_KeyDatabaseSQLite.C_Dynamic)
  -> Func t1 t0 -> Curry_Prelude.OP_List t1 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_OP_restoreDBRelTerms_dot_uscore_hash_lambda39 x1 x2 x3 x4 s cd cs =
  let s4 = s
  in s4 `seq` (let x5 = x4
  in let s3 = leftSupply s4
         s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_runJustT
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
  (Database.Curry_KeyDatabaseSQLite.nd_C_mapT_ (wrapNX id
  (nd_OP_restoreDBRelTerms_dot_uscore_hash_lambda39_dot_uscore_hash_lambda41 x1
  x2 x3)) s0 cd cs) x5 s1 cd cs)) s3 cd cs))

d_OP_restoreDBRelTerms_dot_uscore_hash_lambda39_dot_uscore_hash_lambda41 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> (t1 -> Cover -> ConstStore
  -> t0) -> t1 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.C_Int
d_OP_restoreDBRelTerms_dot_uscore_hash_lambda39_dot_uscore_hash_lambda41 x1 x2 x3 x4 cd cs =
  Database.Curry_KeyDatabaseSQLite.d_C_newDBEntry x1 x2 (Curry_Prelude.d_C_apply
  x3 x4 cd cs) cd cs

nd_OP_restoreDBRelTerms_dot_uscore_hash_lambda39_dot_uscore_hash_lambda41 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Func
  Curry_Prelude.C_Int (Func t0 Database.Curry_KeyDatabaseSQLite.C_Dynamic)
  -> Func t1 t0 -> t1 -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.C_Int
nd_OP_restoreDBRelTerms_dot_uscore_hash_lambda39_dot_uscore_hash_lambda41 x1 x2 x3 x4 s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_newDBEntry x1 x2
  (Curry_Prelude.nd_C_apply x3 x4 s0 cd cs) s1 cd cs))

d_C_defaultString :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_defaultString x1 x2 cd cs = d_C__case_0 x2 x1 (Curry_Prelude.d_C_null x2 cd
  cs) cd cs

d_C__case_18 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> t0) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe t0
d_C__case_18 x6 x1 x5 x2 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.C_Just (Curry_Prelude.d_C_apply x2
    (Curry_Prelude.d_C_read
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Prelude_dot_Int_hash
    x6 cd cs) cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.C_Nothing
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_18 x6 x1 x5 x2 l
    cd cs) (d_C__case_18 x6 x1 x5 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_18 x6
    x1 x5 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_18 x6 x1
    x5 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_18" [show x6, show x1, show x5, show x2, show
    x7] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_18" (showCons x7))

nd_C__case_18 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.C_Int t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe t0
nd_C__case_18 x6 x1 x5 x2 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` Curry_Prelude.C_Just (let s1 = leftSupply s2
                                          s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply x2 (Curry_Prelude.nd_C_read
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Prelude_dot_Int_hash)
    x6 s0 cd cs) s1 cd cs))
  Curry_Prelude.C_False -> Curry_Prelude.C_Nothing
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_18 x6 x1 x5 x2 l
    s cd cs) (nd_C__case_18 x6 x1 x5 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_18 x6
    x1 x5 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_18 x6 x1
    x5 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_18" [show x6, show x1, show x5, show x2, show
    x7] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_18" (showCons x7))

d_C__case_17 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Int -> (Curry_Prelude.C_Int
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t0 -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> t0 -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> t1
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
d_C__case_17 x6 x5 x1 x3 x2 x4 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply
    (Database.Curry_KeyDatabaseSQLite.d_C_errorT cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_NoRelationshipError
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "relationship for deletion not found for keys: ")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_show x4 cd cs) x2 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " ") (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_show x3 cd cs) x1 cd cs) cd cs) cd cs) cd cs)) cd cs
  Curry_Prelude.C_False -> Database.Curry_KeyDatabaseSQLite.d_C_deleteDBEntries
    x5 x6 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_17 x6 x5 x1 x3 x2
    x4 l cd cs) (d_C__case_17 x6 x5 x1 x3 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_17 x6
    x5 x1 x3 x2 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_17 x6 x5
    x1 x3 x2 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_17" [show x6, show x5, show x1, show x3, show x2
    , show x4, show x7] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_17" (showCons x7))

nd_C__case_17 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Int -> Func Curry_Prelude.C_Int
  (Func (Curry_Prelude.OP_Tuple2 t1 t0)
  Database.Curry_KeyDatabaseSQLite.C_Dynamic) -> t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> t1
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C__case_17 x6 x5 x1 x3 x2 x4 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s0 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s0 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
    (Database.Curry_KeyDatabaseSQLite.nd_C_errorT s0 cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_NoRelationshipError
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "relationship for deletion not found for keys: ") (let s3 = leftSupply s7
                                                           s6 = rightSupply s7
    in s3 `seq` (s6 `seq` Curry_Prelude.d_OP_plus_plus (let s2 = leftSupply s3
                                                            s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x4
    s1 cd cs) x2 s2 cd cs)) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " ") (let s5 = leftSupply s6
                                           s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x3
    s4 cd cs) x1 s5 cd cs)) cd cs) cd cs)) cd cs)) s8 cd cs))))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` Database.Curry_KeyDatabaseSQLite.nd_C_deleteDBEntries x5 x6 s0
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_17 x6 x5 x1 x3
    x2 x4 l s cd cs) (nd_C__case_17 x6 x5 x1 x3 x2 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_17 x6
    x5 x1 x3 x2 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_17 x6 x5
    x1 x3 x2 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_17" [show x6, show x5, show x1, show x3, show x2
    , show x4, show x7] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_17" (showCons x7))

d_C__case_16 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_List t0 -> (t0 -> Cover -> ConstStore -> t1)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> t1 -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
d_C__case_16 x6 x5 x3 x1 x2 x4 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply
    (Database.Curry_KeyDatabaseSQLite.d_C_errorT cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_KeyRequiredError
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "key: ")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_show x4 cd cs) x1 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " required in table: ") x2 cd cs) cd cs) cd
    cs)) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_16 x6 x5 x3 x1 x2
    x4 l cd cs) (d_C__case_16 x6 x5 x3 x1 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_16 x6
    x5 x3 x1 x2 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_16 x6 x5
    x3 x1 x2 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_16" [show x6, show x5, show x3, show x1, show x2
    , show x4, show x7] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_16" (showCons x7))

nd_C__case_16 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_List t0 -> Func t0 t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> t1 -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C__case_16 x6 x5 x3 x1 x2 x4 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Database.Curry_KeyDatabaseSQLite.nd_C_errorT s0 cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_KeyRequiredError
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "key: ")
    (Curry_Prelude.d_OP_plus_plus (let s2 = leftSupply s3
                                       s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x4
    s1 cd cs) x1 s2 cd cs)) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " required in table: ") x2 cd cs) cd cs) cd
    cs)) s4 cd cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_16 x6 x5 x3 x1
    x2 x4 l s cd cs) (nd_C__case_16 x6 x5 x3 x1 x2 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_16 x6
    x5 x3 x1 x2 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_16 x6 x5
    x3 x1 x2 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_16" [show x6, show x5, show x3, show x1, show x2
    , show x4, show x7] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_16" (showCons x7))

d_C__case_15 :: Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_C__case_15 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply
    (Database.Curry_KeyDatabaseSQLite.d_C_errorT cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_DuplicateKeyError
    (Curry_Prelude.toCurryString "database contains duplicate key for table: "))
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_15 x1 l cd cs)
    (d_C__case_15 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_15 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_15 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_15" [show x1, show x2] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_15" (showCons x2))

d_C__case_14 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
d_C__case_14 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply
    (Database.Curry_KeyDatabaseSQLite.d_C_errorT cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_DuplicateKeyError
    (Curry_Prelude.toCurryString "duplicate parameters in new-function")) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_14 x2 x1 l cd cs)
    (d_C__case_14 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_14 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_14 x2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_14" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_14" (showCons x3))

nd_C__case_14 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C__case_14 x2 x1 x3 s cd cs = case x3 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Database.Curry_KeyDatabaseSQLite.nd_C_errorT s0 cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_DuplicateKeyError
    (Curry_Prelude.toCurryString "duplicate parameters in new-function")) s1 cd
    cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_14 x2 x1 l s cd
    cs) (nd_C__case_14 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_14 x2
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_14 x2 x1
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_14" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_14" (showCons x3))

d_C__case_13 :: forall t1 t0 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t2) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t1) -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> t0) -> (t0 -> Cover -> ConstStore -> t2)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t2) -> t2 -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t2)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
d_C__case_13 x7 x5 x6 x3 x1 x4 x2 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply
    (Database.Curry_KeyDatabaseSQLite.d_C_errorT cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_UniqueError (Curry_Prelude.d_OP_plus_plus
    x2 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " entry for unique attribute ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_show x4 cd cs) x1 cd cs)
    (Curry_Prelude.toCurryString " already exists") cd cs) cd cs) cd cs)) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_13 x7 x5 x6 x3 x1
    x4 x2 l cd cs) (d_C__case_13 x7 x5 x6 x3 x1 x4 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_13 x7
    x5 x6 x3 x1 x4 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_13 x7 x5
    x6 x3 x1 x4 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_13" [show x7, show x5, show x6, show x3, show x1
    , show x4, show x2, show x8] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_13" (showCons x8))

nd_C__case_13 :: forall t1 t0 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t2) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t1) -> Func Curry_Prelude.C_Int (Func t1 t0) -> Func t0 t2
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t2) -> t2
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t2)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C__case_13 x7 x5 x6 x3 x1 x4 x2 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Database.Curry_KeyDatabaseSQLite.nd_C_errorT s0 cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_UniqueError (Curry_Prelude.d_OP_plus_plus
    x2 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " entry for unique attribute ") (Curry_Prelude.d_OP_plus_plus
    (let s2 = leftSupply s3
         s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x4
    s1 cd cs) x1 s2 cd cs)) (Curry_Prelude.toCurryString " already exists") cd
    cs) cd cs) cd cs)) s4 cd cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_13 x7 x5 x6 x3
    x1 x4 x2 l s cd cs) (nd_C__case_13 x7 x5 x6 x3 x1 x4 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_13 x7
    x5 x6 x3 x1 x4 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_13 x7 x5
    x6 x3 x1 x4 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_13" [show x7, show x5, show x6, show x3, show x1
    , show x4, show x2, show x8] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_13" (showCons x8))

d_C__case_12 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> (t1 -> Cover -> ConstStore -> t0) -> t1 -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Curry_Prelude.OP_List t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_C__case_12 x2 x8 x10 x5 x11 x6 x4 x12 cd cs = case x12 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply
    (Database.Curry_KeyDatabaseSQLite.d_C_errorT cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_UniqueError (Curry_Prelude.d_OP_plus_plus
    x4 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " entry for unique attribute ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_show x6 cd cs)
    (Curry_Prelude.d_C_apply x8 x2 cd cs) cd cs) (Curry_Prelude.toCurryString
    " already exists") cd cs) cd cs) cd cs)) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_12 x2 x8 x10 x5
    x11 x6 x4 l cd cs) (d_C__case_12 x2 x8 x10 x5 x11 x6 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_12 x2
    x8 x10 x5 x11 x6 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_12 x2 x8
    x10 x5 x11 x6 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_12" [show x2, show x8, show x10, show x5, show
    x11, show x6, show x4, show x12] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_12" (showCons x12))

nd_C__case_12 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> Func t1 t0 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Curry_Prelude.OP_List t1 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C__case_12 x2 x8 x10 x5 x11 x6 x4 x12 s cd cs = case x12 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> let s7 = s
    in s7 `seq` (let s6 = leftSupply s7
                     s8 = rightSupply s7
                     s0 = leftSupply s8
                     s4 = rightSupply s8
    in s6 `seq` (s8 `seq` (s0 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
    (Database.Curry_KeyDatabaseSQLite.nd_C_errorT s0 cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_UniqueError (Curry_Prelude.d_OP_plus_plus
    x4 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " entry for unique attribute ") (Curry_Prelude.d_OP_plus_plus
    (let s3 = leftSupply s4
         s5 = rightSupply s4
         s1 = leftSupply s5
         s2 = rightSupply s5
    in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_show x6 s1 cd cs) (Curry_Prelude.nd_C_apply x8 x2 s2 cd
    cs) s3 cd cs)))) (Curry_Prelude.toCurryString " already exists") cd cs) cd
    cs) cd cs)) s6 cd cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_12 x2 x8 x10 x5
    x11 x6 x4 l s cd cs) (nd_C__case_12 x2 x8 x10 x5 x11 x6 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_12 x2
    x8 x10 x5 x11 x6 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_12 x2 x8
    x10 x5 x11 x6 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_12" [show x2, show x8, show x10, show x5, show
    x11, show x6, show x4, show x12] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_12" (showCons x12))

d_C__case_11 :: forall t0 t2 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t2) => Curry_Prelude.OP_List t0 -> t0 -> (t0 -> Cover -> ConstStore -> t2)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t2) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_C__case_11 x8 x1 x6 x4 x2 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply
    (Database.Curry_KeyDatabaseSQLite.d_C_errorT cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_UniqueError (Curry_Prelude.d_OP_plus_plus
    x2 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " unique attribute ") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_show x4 cd cs) (Curry_Prelude.d_C_apply x6 x1 cd cs) cd
    cs) (Curry_Prelude.toCurryString " is not unique") cd cs) cd cs) cd cs)) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_11 x8 x1 x6 x4 x2
    l cd cs) (d_C__case_11 x8 x1 x6 x4 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_11 x8
    x1 x6 x4 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_11 x8 x1
    x6 x4 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_11" [show x8, show x1, show x6, show x4, show x2
    , show x9] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_11" (showCons x9))

nd_C__case_11 :: forall t0 t2 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t2) => Curry_Prelude.OP_List t0 -> t0 -> Func t0 t2 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t2)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C__case_11 x8 x1 x6 x4 x2 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> let s7 = s
    in s7 `seq` (let s6 = leftSupply s7
                     s8 = rightSupply s7
                     s0 = leftSupply s8
                     s4 = rightSupply s8
    in s6 `seq` (s8 `seq` (s0 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
    (Database.Curry_KeyDatabaseSQLite.nd_C_errorT s0 cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_UniqueError (Curry_Prelude.d_OP_plus_plus
    x2 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " unique attribute ") (Curry_Prelude.d_OP_plus_plus (let s3 = leftSupply s4
                                                             s5 = rightSupply s4
                                                             s1 = leftSupply s5
                                                             s2 = rightSupply s5
    in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_show x4 s1 cd cs) (Curry_Prelude.nd_C_apply x6 x1 s2 cd
    cs) s3 cd cs)))) (Curry_Prelude.toCurryString " is not unique") cd cs) cd
    cs) cd cs)) s6 cd cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_11 x8 x1 x6 x4
    x2 l s cd cs) (nd_C__case_11 x8 x1 x6 x4 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_11 x8
    x1 x6 x4 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_11 x8 x1
    x6 x4 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_11" [show x8, show x1, show x6, show x4, show x2
    , show x9] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_11" (showCons x9))

d_C__case_10 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0) -> t0 -> t1
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_C__case_10 x5 x1 x2 x3 x4 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply
    (Database.Curry_KeyDatabaseSQLite.d_C_errorT cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_UniqueError (Curry_Prelude.toCurryString
    "relationship already exists")) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_10 x5 x1 x2 x3 x4
    l cd cs) (d_C__case_10 x5 x1 x2 x3 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_10 x5
    x1 x2 x3 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_10 x5 x1
    x2 x3 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_10" [show x5, show x1, show x2, show x3, show x4
    , show x6] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_10" (showCons x6))

nd_C__case_10 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0) -> t0 -> t1
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C__case_10 x5 x1 x2 x3 x4 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Database.Curry_KeyDatabaseSQLite.nd_C_errorT s0 cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_UniqueError (Curry_Prelude.toCurryString
    "relationship already exists")) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_10 x5 x1 x2 x3
    x4 l s cd cs) (nd_C__case_10 x5 x1 x2 x3 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_10 x5
    x1 x2 x3 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_10 x5 x1
    x2 x3 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_10" [show x5, show x1, show x2, show x3, show x4
    , show x6] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_10" (showCons x6))

d_C__case_9 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0) -> t0 -> t1
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_C__case_9 x5 x1 x2 x3 x4 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply
    (Database.Curry_KeyDatabaseSQLite.d_C_errorT cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_UniqueError (Curry_Prelude.toCurryString
    "relationship not unique")) cd cs
  Curry_Prelude.C_False -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_9 x5 x1 x2 x3 x4
    l cd cs) (d_C__case_9 x5 x1 x2 x3 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_9 x5 x1
    x2 x3 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_9 x5 x1 x2
    x3 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_9" [show x5, show x1, show x2, show x3, show x4
    , show x6] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_9" (showCons x6))

nd_C__case_9 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0) -> t0 -> t1
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C__case_9 x5 x1 x2 x3 x4 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
    (Database.Curry_KeyDatabaseSQLite.nd_C_errorT s0 cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_UniqueError (Curry_Prelude.toCurryString
    "relationship not unique")) s1 cd cs))
  Curry_Prelude.C_False -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_9 x5 x1 x2 x3 x4
    l s cd cs) (nd_C__case_9 x5 x1 x2 x3 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_9 x5
    x1 x2 x3 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_9 x5 x1
    x2 x3 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_9" [show x5, show x1, show x2, show x3, show x4
    , show x6] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_9" (showCons x6))

d_C__case_8 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_C__case_8 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply
    (Database.Curry_KeyDatabaseSQLite.d_C_errorT cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_MaxError (Curry_Prelude.toCurryString
    "max reached in parameter list in new function")) cd cs
  Curry_Prelude.C_False -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x1 x2 l cd cs)
    (d_C__case_8 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x1 x2
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_8 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_8" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_8" (showCons x3))

d_C__case_7 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.OP_List t1
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> t0 -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
d_C__case_7 x1 x8 x3 x2 x5 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply
    (Database.Curry_KeyDatabaseSQLite.d_C_errorT cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_MaxError (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "max reached for attribute ")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_show x5 cd cs) x2 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " in entity ") x3 cd cs) cd cs) cd cs)) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x1 x8 x3 x2 x5
    l cd cs) (d_C__case_7 x1 x8 x3 x2 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x1 x8
    x3 x2 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_7 x1 x8 x3
    x2 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_7" [show x1, show x8, show x3, show x2, show x5
    , show x9] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_7" (showCons x9))

nd_C__case_7 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.OP_List t1
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C__case_7 x1 x8 x3 x2 x5 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Database.Curry_KeyDatabaseSQLite.nd_C_errorT s0 cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_MaxError (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "max reached for attribute ")
    (Curry_Prelude.d_OP_plus_plus (let s2 = leftSupply s3
                                       s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x5
    s1 cd cs) x2 s2 cd cs)) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " in entity ") x3 cd cs) cd cs) cd cs)) s4 cd
    cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_7 x1 x8 x3 x2 x5
    l s cd cs) (nd_C__case_7 x1 x8 x3 x2 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_7 x1
    x8 x3 x2 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_7 x1 x8
    x3 x2 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_7" [show x1, show x8, show x3, show x2, show x5
    , show x9] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_7" (showCons x9))

d_C__case_6 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => t0 -> (t0 -> Cover -> ConstStore -> t1) -> t0 -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
d_C__case_6 x2 x7 x8 x5 x1 x4 x3 x6 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply
    (Database.Curry_KeyDatabaseSQLite.d_C_errorT cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_MaxError (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "max reached for attribute ")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_show x6 cd cs) (Curry_Prelude.d_C_apply x7 x2 cd cs) cd
    cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " in entity ") x3 cd cs) cd cs) cd cs)) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x2 x7 x8 x5 x1
    x4 x3 x6 l cd cs) (d_C__case_6 x2 x7 x8 x5 x1 x4 x3 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x2 x7
    x8 x5 x1 x4 x3 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x2 x7 x8
    x5 x1 x4 x3 x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_6" [show x2, show x7, show x8, show x5, show x1
    , show x4, show x3, show x6, show x9] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_6" (showCons x9))

nd_C__case_6 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => t0 -> Func t0 t1 -> t0 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C__case_6 x2 x7 x8 x5 x1 x4 x3 x6 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> let s7 = s
    in s7 `seq` (let s6 = leftSupply s7
                     s8 = rightSupply s7
                     s0 = leftSupply s8
                     s4 = rightSupply s8
    in s6 `seq` (s8 `seq` (s0 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
    (Database.Curry_KeyDatabaseSQLite.nd_C_errorT s0 cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_MaxError (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "max reached for attribute ")
    (Curry_Prelude.d_OP_plus_plus (let s3 = leftSupply s4
                                       s5 = rightSupply s4
                                       s1 = leftSupply s5
                                       s2 = rightSupply s5
    in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_show x6 s1 cd cs) (Curry_Prelude.nd_C_apply x7 x2 s2 cd
    cs) s3 cd cs)))) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " in entity ") x3 cd cs) cd cs) cd cs)) s6 cd cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_6 x2 x7 x8 x5 x1
    x4 x3 x6 l s cd cs) (nd_C__case_6 x2 x7 x8 x5 x1 x4 x3 x6 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_6 x2
    x7 x8 x5 x1 x4 x3 x6 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_6 x2 x7
    x8 x5 x1 x4 x3 x6 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_6" [show x2, show x7, show x8, show x5, show x1
    , show x4, show x3, show x6, show x9] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_6" (showCons x9))

d_C__case_5 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0 -> (t0 -> Cover
  -> ConstStore -> t1) -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> t1 -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
d_C__case_5 x1 x7 x6 x4 x2 x3 x5 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply
    (Database.Curry_KeyDatabaseSQLite.d_C_errorT cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_MaxError (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "maximum exceeded for attribute ")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_show x5 cd cs) x2 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " in entity ") x3 cd cs) cd cs) cd cs)) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x1 x7 x6 x4 x2
    x3 x5 l cd cs) (d_C__case_5 x1 x7 x6 x4 x2 x3 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x1 x7
    x6 x4 x2 x3 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x1 x7 x6
    x4 x2 x3 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_5" [show x1, show x7, show x6, show x4, show x2
    , show x3, show x5, show x8] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_5" (showCons x8))

nd_C__case_5 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0 -> Func t0 t1 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> t1
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C__case_5 x1 x7 x6 x4 x2 x3 x5 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Database.Curry_KeyDatabaseSQLite.nd_C_errorT s0 cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_MaxError (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "maximum exceeded for attribute ")
    (Curry_Prelude.d_OP_plus_plus (let s2 = leftSupply s3
                                       s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x5
    s1 cd cs) x2 s2 cd cs)) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " in entity ") x3 cd cs) cd cs) cd cs)) s4 cd
    cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_5 x1 x7 x6 x4 x2
    x3 x5 l s cd cs) (nd_C__case_5 x1 x7 x6 x4 x2 x3 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_5 x1
    x7 x6 x4 x2 x3 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_5 x1 x7
    x6 x4 x2 x3 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_5" [show x1, show x7, show x6, show x4, show x2
    , show x3, show x5, show x8] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_5" (showCons x8))

d_C__case_4 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0 -> (t0 -> Cover
  -> ConstStore -> t1) -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> t1 -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
d_C__case_4 x1 x7 x6 x4 x2 x3 x5 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply
    (Database.Curry_KeyDatabaseSQLite.d_C_errorT cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_MinError (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "below min for attribute ")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_show x5 cd cs) x2 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " in entity ") x3 cd cs) cd cs) cd cs)) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x1 x7 x6 x4 x2
    x3 x5 l cd cs) (d_C__case_4 x1 x7 x6 x4 x2 x3 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x1 x7
    x6 x4 x2 x3 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x1 x7 x6
    x4 x2 x3 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_4" [show x1, show x7, show x6, show x4, show x2
    , show x3, show x5, show x8] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_4" (showCons x8))

nd_C__case_4 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0 -> Func t0 t1 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> t1
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C__case_4 x1 x7 x6 x4 x2 x3 x5 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Database.Curry_KeyDatabaseSQLite.nd_C_errorT s0 cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_MinError (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "below min for attribute ")
    (Curry_Prelude.d_OP_plus_plus (let s2 = leftSupply s3
                                       s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x5
    s1 cd cs) x2 s2 cd cs)) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " in entity ") x3 cd cs) cd cs) cd cs)) s4 cd
    cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_4 x1 x7 x6 x4 x2
    x3 x5 l s cd cs) (nd_C__case_4 x1 x7 x6 x4 x2 x3 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_4 x1
    x7 x6 x4 x2 x3 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_4 x1 x7
    x6 x4 x2 x3 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_4" [show x1, show x7, show x6, show x4, show x2
    , show x3, show x5, show x8] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_4" (showCons x8))

d_C__case_3 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0 -> (t0 -> Cover
  -> ConstStore -> t1) -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> t1 -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
d_C__case_3 x1 x7 x6 x4 x2 x3 x5 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply
    (Database.Curry_KeyDatabaseSQLite.d_C_errorT cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_MaxError (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "maximum reached for attribute ")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_show x5 cd cs) x2 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " in entity ") x3 cd cs) cd cs) cd cs)) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x1 x7 x6 x4 x2
    x3 x5 l cd cs) (d_C__case_3 x1 x7 x6 x4 x2 x3 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x1 x7
    x6 x4 x2 x3 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x1 x7 x6
    x4 x2 x3 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_3" [show x1, show x7, show x6, show x4, show x2
    , show x3, show x5, show x8] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_3" (showCons x8))

nd_C__case_3 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0 -> Func t0 t1 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> t1
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C__case_3 x1 x7 x6 x4 x2 x3 x5 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Database.Curry_KeyDatabaseSQLite.nd_C_errorT s0 cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_MaxError (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "maximum reached for attribute ")
    (Curry_Prelude.d_OP_plus_plus (let s2 = leftSupply s3
                                       s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x5
    s1 cd cs) x2 s2 cd cs)) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " in entity ") x3 cd cs) cd cs) cd cs)) s4 cd
    cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_3 x1 x7 x6 x4 x2
    x3 x5 l s cd cs) (nd_C__case_3 x1 x7 x6 x4 x2 x3 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_3 x1
    x7 x6 x4 x2 x3 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_3 x1 x7
    x6 x4 x2 x3 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_3" [show x1, show x7, show x6, show x4, show x2
    , show x3, show x5, show x8] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_3" (showCons x8))

d_C__case_2 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0 -> (t0 -> Cover
  -> ConstStore -> t1) -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> t1 -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Database.Curry_KeyDatabaseSQLite.C_Transaction
  Curry_Prelude.OP_Unit
d_C__case_2 x1 x7 x6 x4 x2 x3 x5 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply
    (Database.Curry_KeyDatabaseSQLite.d_C_errorT cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_MinError (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "below min for attribute ")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_show x5 cd cs) x2 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " in entity ") x3 cd cs) cd cs) cd cs)) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x1 x7 x6 x4 x2
    x3 x5 l cd cs) (d_C__case_2 x1 x7 x6 x4 x2 x3 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x1 x7
    x6 x4 x2 x3 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x1 x7 x6
    x4 x2 x3 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_2" [show x1, show x7, show x6, show x4, show x2
    , show x3, show x5, show x8] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_2" (showCons x8))

nd_C__case_2 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0 -> Func t0 t1 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> t1
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore
  -> Database.Curry_KeyDatabaseSQLite.C_Transaction Curry_Prelude.OP_Unit
nd_C__case_2 x1 x7 x6 x4 x2 x3 x5 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> Database.Curry_KeyDatabaseSQLite.d_C_doneT cd cs
  Curry_Prelude.C_False -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Database.Curry_KeyDatabaseSQLite.nd_C_errorT s0 cd cs)
    (Database.Curry_KeyDatabaseSQLite.C_TError
    Database.Curry_KeyDatabaseSQLite.C_MinError (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "below min for attribute ")
    (Curry_Prelude.d_OP_plus_plus (let s2 = leftSupply s3
                                       s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x5
    s1 cd cs) x2 s2 cd cs)) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " in entity ") x3 cd cs) cd cs) cd cs)) s4 cd
    cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_2 x1 x7 x6 x4 x2
    x3 x5 l s cd cs) (nd_C__case_2 x1 x7 x6 x4 x2 x3 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_2 x1
    x7 x6 x4 x2 x3 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_2 x1 x7
    x6 x4 x2 x3 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_2" [show x1, show x7, show x6, show x4, show x2
    , show x3, show x5, show x8] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_2" (showCons x8))

d_C__case_1 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C__case_1 x2 x9 x7 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_putStrLn x9 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO_hash
    cd cs) (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Saving into ")
    x7 cd cs) cd cs) cd cs) (Curry_Prelude.d_C_writeFile x7 x9 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x2 x9 x7 l cd
    cs) (d_C__case_1 x2 x9 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x2 x9
    x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x2 x9 x7
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_1" [show x2, show x9, show x7, show x10] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_1" (showCons x10))

d_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_0 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> x1
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x2 x1 l cd cs)
    (d_C__case_0 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x2 x1
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Database.ERD.Generic._case_0" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "Database.ERD.Generic._case_0" (showCons x3))

