{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_XmlConv
  ( C_Repeatable (..)
  , C_NotRepeatable (..)
  , C_Elem (..)
  , C_NoElem (..)
  , C_XmlConv (..)
  , d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash
  , d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash
  , d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash
  , d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash
  , d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash
  , d_C_xmlReads
  , nd_C_xmlReads
  , d_C_xmlShows
  , nd_C_xmlShows
  , d_C_xmlRead
  , nd_C_xmlRead
  , d_C_xmlShow
  , nd_C_xmlShow
  , d_C_int
  , nd_C_int
  , d_C_float
  , nd_C_float
  , d_C_char
  , nd_C_char
  , nd_C_string
  , nd_OP_bang
  , d_C_element
  , nd_C_element
  , d_C_empty
  , nd_C_empty
  , d_C_attr
  , nd_C_attr
  , d_C_adapt
  , nd_C_adapt
  , nd_C_opt
  , nd_C_rep
  , d_C_aInt
  , nd_C_aInt
  , d_C_aFloat
  , nd_C_aFloat
  , d_C_aChar
  , nd_C_aChar
  , d_C_aString
  , nd_C_aString
  , d_C_aBool
  , nd_C_aBool
  , d_C_eInt
  , nd_C_eInt
  , d_C_eFloat
  , nd_C_eFloat
  , d_C_eChar
  , nd_C_eChar
  , nd_C_eString
  , nd_C_eBool
  , d_C_eEmpty
  , nd_C_eEmpty
  , nd_C_eOpt
  , nd_C_eRep
  , nd_C_seq1
  , nd_C_repSeq1
  , nd_C_eSeq1
  , nd_C_eRepSeq1
  , nd_C_seq2
  , nd_C_repSeq2
  , nd_C_eSeq2
  , nd_C_eRepSeq2
  , nd_C_seq3
  , nd_C_repSeq3
  , nd_C_eSeq3
  , nd_C_eRepSeq3
  , nd_C_seq4
  , nd_C_repSeq4
  , nd_C_eSeq4
  , nd_C_eRepSeq4
  , nd_C_seq5
  , nd_C_repSeq5
  , nd_C_eSeq5
  , nd_C_eRepSeq5
  , nd_C_seq6
  , nd_C_repSeq6
  , nd_C_eSeq6
  , nd_C_eRepSeq6 )
  where

import Basics
import qualified Curry_Prelude
import qualified Curry_XML


data C_Repeatable
  = C_Repeatable
  | Choice_C_Repeatable Cover ID C_Repeatable C_Repeatable
  | Choices_C_Repeatable Cover ID [C_Repeatable]
  | Fail_C_Repeatable Cover FailInfo
  | Guard_C_Repeatable Cover Constraints C_Repeatable

instance Show C_Repeatable where
  showsPrec d (Choice_C_Repeatable cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Repeatable cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Repeatable cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Repeatable cd info) = showChar '!'
  showsPrec _ C_Repeatable = showString "Repeatable"

instance Read C_Repeatable where
  readsPrec _ s = readParen False (\r -> [(C_Repeatable, r0) | (_, r0) <-
    readQualified "XmlConv" "Repeatable" r]) s

instance NonDet C_Repeatable where
  choiceCons = Choice_C_Repeatable
  choicesCons = Choices_C_Repeatable
  failCons = Fail_C_Repeatable
  guardCons = Guard_C_Repeatable
  try (Choice_C_Repeatable cd i x y) = tryChoice cd i x y
  try (Choices_C_Repeatable cd i xs) = tryChoices cd i xs
  try (Fail_C_Repeatable cd info) = Fail cd info
  try (Guard_C_Repeatable cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Repeatable cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Repeatable cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Repeatable cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Repeatable cd i _) = error
    ("XmlConv.Repeatable.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Repeatable cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Repeatable cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Repeatable where
  generate s c = Choices_C_Repeatable c (freeID [0] s) [C_Repeatable]

instance NormalForm C_Repeatable where
  ($!!) cont C_Repeatable d cs = cont C_Repeatable d cs
  ($!!) cont (Choice_C_Repeatable cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Repeatable cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Repeatable cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_Repeatable cd info) _ _ = failCons cd info
  ($##) cont C_Repeatable d cs = cont C_Repeatable d cs
  ($##) cont (Choice_C_Repeatable cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Repeatable cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Repeatable cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_Repeatable cd info) _ _ = failCons cd info
  showCons C_Repeatable = "XmlConv.Repeatable"
  showCons x = error ("XmlConv.Repeatable.showCons: no constructor: " ++ show x)
  searchNF _ cont C_Repeatable = cont C_Repeatable
  searchNF _ _ x = error ("XmlConv.Repeatable.searchNF: no constructor: " ++
    show x)

instance Unifiable C_Repeatable where
  (=.=) C_Repeatable C_Repeatable d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_Repeatable C_Repeatable d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_Repeatable = (i :=: ChooseN 0 0) : concat []
  bind d i (Choice_C_Repeatable cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_Repeatable cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j
    xs
  bind d i (Choices_C_Repeatable cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_Repeatable cd i _) = error
    ("XmlConv.Repeatable.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Repeatable cd info) = [Unsolvable info]
  bind d i (Guard_C_Repeatable cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_Repeatable = (i :=: ChooseN 0 0) : []
  lazyBind d i (Choice_C_Repeatable cd j x y) = [ConstraintChoice cd j (lazyBind
    d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Repeatable cd j@(FreeID _ _) xs) = lazyBindOrNarrow d
    i cd j xs
  lazyBind d i (Choices_C_Repeatable cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Repeatable cd i _) = error
    ("XmlConv.Repeatable.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Repeatable cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Repeatable cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Repeatable where

data C_NotRepeatable
  = C_NotRepeatable
  | Choice_C_NotRepeatable Cover ID C_NotRepeatable C_NotRepeatable
  | Choices_C_NotRepeatable Cover ID [C_NotRepeatable]
  | Fail_C_NotRepeatable Cover FailInfo
  | Guard_C_NotRepeatable Cover Constraints C_NotRepeatable

instance Show C_NotRepeatable where
  showsPrec d (Choice_C_NotRepeatable cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_NotRepeatable cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_NotRepeatable cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_NotRepeatable cd info) = showChar '!'
  showsPrec _ C_NotRepeatable = showString "NotRepeatable"

instance Read C_NotRepeatable where
  readsPrec _ s = readParen False (\r -> [(C_NotRepeatable, r0) | (_, r0) <-
    readQualified "XmlConv" "NotRepeatable" r]) s

instance NonDet C_NotRepeatable where
  choiceCons = Choice_C_NotRepeatable
  choicesCons = Choices_C_NotRepeatable
  failCons = Fail_C_NotRepeatable
  guardCons = Guard_C_NotRepeatable
  try (Choice_C_NotRepeatable cd i x y) = tryChoice cd i x y
  try (Choices_C_NotRepeatable cd i xs) = tryChoices cd i xs
  try (Fail_C_NotRepeatable cd info) = Fail cd info
  try (Guard_C_NotRepeatable cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_NotRepeatable cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_NotRepeatable cd i@(NarrowedID _ _) xs) = f cd i
    xs
  match _ _ f _ _ _ (Choices_C_NotRepeatable cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_NotRepeatable cd i _) = error
    ("XmlConv.NotRepeatable.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_NotRepeatable cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_NotRepeatable cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_NotRepeatable where
  generate s c = Choices_C_NotRepeatable c (freeID [0] s) [C_NotRepeatable]

instance NormalForm C_NotRepeatable where
  ($!!) cont C_NotRepeatable d cs = cont C_NotRepeatable d cs
  ($!!) cont (Choice_C_NotRepeatable cd i x y) d cs = nfChoice cont cd i x y cd
    cs
  ($!!) cont (Choices_C_NotRepeatable cd i xs) d cs = nfChoices cont cd i xs d
    cs
  ($!!) cont (Guard_C_NotRepeatable cd c e) d cs = guardCons cd c (($!!) cont e
    d (addCs c cs))
  ($!!) _ (Fail_C_NotRepeatable cd info) _ _ = failCons cd info
  ($##) cont C_NotRepeatable d cs = cont C_NotRepeatable d cs
  ($##) cont (Choice_C_NotRepeatable cd i x y) d cs = gnfChoice cont cd i x y cd
    cs
  ($##) cont (Choices_C_NotRepeatable cd i xs) d cs = gnfChoices cont cd i xs d
    cs
  ($##) cont (Guard_C_NotRepeatable cd c e) d cs = guardCons cd c (($##) cont e
    d (addCs c cs))
  ($##) _ (Fail_C_NotRepeatable cd info) _ _ = failCons cd info
  showCons C_NotRepeatable = "XmlConv.NotRepeatable"
  showCons x = error ("XmlConv.NotRepeatable.showCons: no constructor: " ++ show
    x)
  searchNF _ cont C_NotRepeatable = cont C_NotRepeatable
  searchNF _ _ x = error ("XmlConv.NotRepeatable.searchNF: no constructor: " ++
    show x)

instance Unifiable C_NotRepeatable where
  (=.=) C_NotRepeatable C_NotRepeatable d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_NotRepeatable C_NotRepeatable d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_NotRepeatable = (i :=: ChooseN 0 0) : concat []
  bind d i (Choice_C_NotRepeatable cd j x y) = [ConstraintChoice cd j (bind d i
    x) (bind d i y)]
  bind d i (Choices_C_NotRepeatable cd j@(FreeID _ _) xs) = bindOrNarrow d i cd
    j xs
  bind d i (Choices_C_NotRepeatable cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_NotRepeatable cd i _) = error
    ("XmlConv.NotRepeatable.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_NotRepeatable cd info) = [Unsolvable info]
  bind d i (Guard_C_NotRepeatable cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_NotRepeatable = (i :=: ChooseN 0 0) : []
  lazyBind d i (Choice_C_NotRepeatable cd j x y) = [ConstraintChoice cd j
    (lazyBind d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_NotRepeatable cd j@(FreeID _ _) xs) = lazyBindOrNarrow
    d i cd j xs
  lazyBind d i (Choices_C_NotRepeatable cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_NotRepeatable cd i _) = error
    ("XmlConv.NotRepeatable.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_NotRepeatable cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_NotRepeatable cd c e) = getConstrList c ++ [i :=:
    LazyBind (lazyBind d i e)]

instance Curry C_NotRepeatable where

data C_Elem
  = C_Elem
  | Choice_C_Elem Cover ID C_Elem C_Elem
  | Choices_C_Elem Cover ID [C_Elem]
  | Fail_C_Elem Cover FailInfo
  | Guard_C_Elem Cover Constraints C_Elem

instance Show C_Elem where
  showsPrec d (Choice_C_Elem cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Elem cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Elem cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Elem cd info) = showChar '!'
  showsPrec _ C_Elem = showString "Elem"

instance Read C_Elem where
  readsPrec _ s = readParen False (\r -> [(C_Elem, r0) | (_, r0) <-
    readQualified "XmlConv" "Elem" r]) s

instance NonDet C_Elem where
  choiceCons = Choice_C_Elem
  choicesCons = Choices_C_Elem
  failCons = Fail_C_Elem
  guardCons = Guard_C_Elem
  try (Choice_C_Elem cd i x y) = tryChoice cd i x y
  try (Choices_C_Elem cd i xs) = tryChoices cd i xs
  try (Fail_C_Elem cd info) = Fail cd info
  try (Guard_C_Elem cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Elem cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Elem cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Elem cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Elem cd i _) = error
    ("XmlConv.Elem.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Elem cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Elem cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Elem where
  generate s c = Choices_C_Elem c (freeID [0] s) [C_Elem]

instance NormalForm C_Elem where
  ($!!) cont C_Elem d cs = cont C_Elem d cs
  ($!!) cont (Choice_C_Elem cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Elem cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Elem cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_Elem cd info) _ _ = failCons cd info
  ($##) cont C_Elem d cs = cont C_Elem d cs
  ($##) cont (Choice_C_Elem cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Elem cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Elem cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_Elem cd info) _ _ = failCons cd info
  showCons C_Elem = "XmlConv.Elem"
  showCons x = error ("XmlConv.Elem.showCons: no constructor: " ++ show x)
  searchNF _ cont C_Elem = cont C_Elem
  searchNF _ _ x = error ("XmlConv.Elem.searchNF: no constructor: " ++ show x)

instance Unifiable C_Elem where
  (=.=) C_Elem C_Elem d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_Elem C_Elem d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_Elem = (i :=: ChooseN 0 0) : concat []
  bind d i (Choice_C_Elem cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_Elem cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Elem cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Elem cd i _) = error
    ("XmlConv.Elem.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Elem cd info) = [Unsolvable info]
  bind d i (Guard_C_Elem cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_Elem = (i :=: ChooseN 0 0) : []
  lazyBind d i (Choice_C_Elem cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Elem cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j
    xs
  lazyBind d i (Choices_C_Elem cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Elem cd i _) = error
    ("XmlConv.Elem.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Elem cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Elem cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Elem where

data C_NoElem
  = C_NoElem
  | Choice_C_NoElem Cover ID C_NoElem C_NoElem
  | Choices_C_NoElem Cover ID [C_NoElem]
  | Fail_C_NoElem Cover FailInfo
  | Guard_C_NoElem Cover Constraints C_NoElem

instance Show C_NoElem where
  showsPrec d (Choice_C_NoElem cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_NoElem cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_NoElem cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_NoElem cd info) = showChar '!'
  showsPrec _ C_NoElem = showString "NoElem"

instance Read C_NoElem where
  readsPrec _ s = readParen False (\r -> [(C_NoElem, r0) | (_, r0) <-
    readQualified "XmlConv" "NoElem" r]) s

instance NonDet C_NoElem where
  choiceCons = Choice_C_NoElem
  choicesCons = Choices_C_NoElem
  failCons = Fail_C_NoElem
  guardCons = Guard_C_NoElem
  try (Choice_C_NoElem cd i x y) = tryChoice cd i x y
  try (Choices_C_NoElem cd i xs) = tryChoices cd i xs
  try (Fail_C_NoElem cd info) = Fail cd info
  try (Guard_C_NoElem cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_NoElem cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_NoElem cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_NoElem cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_NoElem cd i _) = error
    ("XmlConv.NoElem.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_NoElem cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_NoElem cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_NoElem where
  generate s c = Choices_C_NoElem c (freeID [0] s) [C_NoElem]

instance NormalForm C_NoElem where
  ($!!) cont C_NoElem d cs = cont C_NoElem d cs
  ($!!) cont (Choice_C_NoElem cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_NoElem cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_NoElem cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_NoElem cd info) _ _ = failCons cd info
  ($##) cont C_NoElem d cs = cont C_NoElem d cs
  ($##) cont (Choice_C_NoElem cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_NoElem cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_NoElem cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_NoElem cd info) _ _ = failCons cd info
  showCons C_NoElem = "XmlConv.NoElem"
  showCons x = error ("XmlConv.NoElem.showCons: no constructor: " ++ show x)
  searchNF _ cont C_NoElem = cont C_NoElem
  searchNF _ _ x = error ("XmlConv.NoElem.searchNF: no constructor: " ++ show x)

instance Unifiable C_NoElem where
  (=.=) C_NoElem C_NoElem d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_NoElem C_NoElem d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_NoElem = (i :=: ChooseN 0 0) : concat []
  bind d i (Choice_C_NoElem cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_NoElem cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_NoElem cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_NoElem cd i _) = error
    ("XmlConv.NoElem.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_NoElem cd info) = [Unsolvable info]
  bind d i (Guard_C_NoElem cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_NoElem = (i :=: ChooseN 0 0) : []
  lazyBind d i (Choice_C_NoElem cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_NoElem cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_NoElem cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_NoElem cd i _) = error
    ("XmlConv.NoElem.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_NoElem cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_NoElem cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_NoElem where

data C_XmlConv t0 t1 t2
  = C_Conv (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
    Curry_XML.C_XmlExp) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t2
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))) (t2
    -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
    Curry_XML.C_XmlExp) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
    (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  | HO_C_Conv (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
    Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
    (Curry_Prelude.OP_List Curry_XML.C_XmlExp)))) (Func t2 (Func
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))))
  | Choice_C_XmlConv Cover ID (C_XmlConv t0 t1 t2) (C_XmlConv t0 t1 t2)
  | Choices_C_XmlConv Cover ID [C_XmlConv t0 t1 t2]
  | Fail_C_XmlConv Cover FailInfo
  | Guard_C_XmlConv Cover Constraints (C_XmlConv t0 t1 t2)

instance (Curry t0, Curry t1, Curry t2) => Show (C_XmlConv t0 t1 t2) where
  showsPrec d (Choice_C_XmlConv cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_XmlConv cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_XmlConv cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_XmlConv cd info) = showChar '!'
  showsPrec _ (C_Conv x1 x2) = showString "(Conv" . (showChar ' ' . (shows x1 .
    (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (HO_C_Conv x1 x2) = showString "(Conv" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))

instance (Curry t0, Curry t1, Curry t2) => Read (C_XmlConv t0 t1 t2) where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Conv x1 x2, r2) | (_, r0) <-
    readQualified "XmlConv" "Conv" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <-
    readsPrec 11 r1]) s

instance NonDet (C_XmlConv t0 t1 t2) where
  choiceCons = Choice_C_XmlConv
  choicesCons = Choices_C_XmlConv
  failCons = Fail_C_XmlConv
  guardCons = Guard_C_XmlConv
  try (Choice_C_XmlConv cd i x y) = tryChoice cd i x y
  try (Choices_C_XmlConv cd i xs) = tryChoices cd i xs
  try (Fail_C_XmlConv cd info) = Fail cd info
  try (Guard_C_XmlConv cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_XmlConv cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_XmlConv cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_XmlConv cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_XmlConv cd i _) = error
    ("XmlConv.XmlConv.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_XmlConv cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_XmlConv cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance (Curry t0, Curry t1, Curry t2) => Generable (C_XmlConv t0 t1 t2) where
  generate s c = Choices_C_XmlConv c (freeID [2] s) [HO_C_Conv (generate
    (leftSupply s) c) (generate (rightSupply s) c)]

instance (Curry t0, Curry t1, Curry t2) => NormalForm (C_XmlConv t0 t1 t2) where
  ($!!) cont (C_Conv x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Conv y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (HO_C_Conv x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (HO_C_Conv y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_XmlConv cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_XmlConv cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_XmlConv cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_XmlConv cd info) _ _ = failCons cd info
  ($##) cont (C_Conv x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Conv y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (HO_C_Conv x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (HO_C_Conv y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_XmlConv cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_XmlConv cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_XmlConv cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_XmlConv cd info) _ _ = failCons cd info
  showCons (C_Conv _ _) = "XmlConv.Conv _ _"
  showCons (HO_C_Conv _ _) = "XmlConv.Conv _ _"
  showCons x = error ("XmlConv.XmlConv.showCons: no constructor: " ++ show x)
  searchNF search cont (C_Conv x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Conv y1 y2)) x2) x1
  searchNF search cont (HO_C_Conv x1 x2) = search (\y1 -> search (\y2 -> cont
    (HO_C_Conv y1 y2)) x2) x1
  searchNF _ _ x = error ("XmlConv.XmlConv.searchNF: no constructor: " ++ show
    x)

instance (Curry t0, Curry t1, Curry t2) => Unifiable (C_XmlConv t0 t1 t2) where
  (=.=) (C_Conv x1 x2) (C_Conv y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2
    d cs) d cs
  (=.=) (HO_C_Conv x1 x2) (HO_C_Conv y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=)
    x2 y2 d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Conv x1 x2) (C_Conv y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=) x2
    y2 d cs) d cs
  (=.<=) (HO_C_Conv x1 x2) (HO_C_Conv y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Conv x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID i) x3
    , bind cd (rightID i) x4]
  bind cd i (HO_C_Conv x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID i)
    x3, bind cd (rightID i) x4]
  bind d i (Choice_C_XmlConv cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_XmlConv cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_XmlConv cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_XmlConv cd i _) = error
    ("XmlConv.XmlConv.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_XmlConv cd info) = [Unsolvable info]
  bind d i (Guard_C_XmlConv cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Conv x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (HO_C_Conv x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind d i (Choice_C_XmlConv cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_XmlConv cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_XmlConv cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_XmlConv cd i _) = error
    ("XmlConv.XmlConv.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_XmlConv cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_XmlConv cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance (Curry t0, Curry t1, Curry t2) => Curry (C_XmlConv t0 t1 t2) where

d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data C_Repeatable
d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Data (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash)
    (d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash l
    cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash r
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash z cd
    cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "XmlConv._inst#Prelude.Data#XmlConv.Repeatable#" [show x1] info)
  _ -> failCons cd (consFail "XmlConv._inst#Prelude.Data#XmlConv.Repeatable#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Repeatable
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash))
    (d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash l
    s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash r
    s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "XmlConv._inst#Prelude.Data#XmlConv.Repeatable#" [show x1] info)
  _ -> failCons cd (consFail "XmlConv._inst#Prelude.Data#XmlConv.Repeatable#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash :: C_Repeatable
  -> C_Repeatable -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash x1 x2 cd cs =
  case x1 of
  C_Repeatable -> d_C__case_46 x2 cd cs
  Choice_C_Repeatable d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash
    r x2 cd cs)
  Choices_C_Repeatable d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash
    z x2 cd cs) xs
  Guard_C_Repeatable d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Repeatable d info -> failCons d (traceFail
    "XmlConv._impl#===#Prelude.Data#XmlConv.Repeatable#" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "XmlConv._impl#===#Prelude.Data#XmlConv.Repeatable#" (showCons x1))

d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash :: Cover
  -> ConstStore -> C_Repeatable
d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_Repeatable_hash cd cs =
  C_Repeatable

d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_NotRepeatable
d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Data (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash)
    (d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash z
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "XmlConv._inst#Prelude.Data#XmlConv.NotRepeatable#" [show x1] info)
  _ -> failCons cd (consFail "XmlConv._inst#Prelude.Data#XmlConv.NotRepeatable#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_NotRepeatable
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash))
    (d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "XmlConv._inst#Prelude.Data#XmlConv.NotRepeatable#" [show x1] info)
  _ -> failCons cd (consFail "XmlConv._inst#Prelude.Data#XmlConv.NotRepeatable#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash :: C_NotRepeatable
  -> C_NotRepeatable -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash x1 x2 cd cs =
  case x1 of
  C_NotRepeatable -> d_C__case_45 x2 cd cs
  Choice_C_NotRepeatable d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash
    r x2 cd cs)
  Choices_C_NotRepeatable d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash
    z x2 cd cs) xs
  Guard_C_NotRepeatable d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_NotRepeatable d info -> failCons d (traceFail
    "XmlConv._impl#===#Prelude.Data#XmlConv.NotRepeatable#" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "XmlConv._impl#===#Prelude.Data#XmlConv.NotRepeatable#" (showCons x1))

d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash :: Cover
  -> ConstStore -> C_NotRepeatable
d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_NotRepeatable_hash cd cs =
  C_NotRepeatable

d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data C_Elem
d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Data (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash)
    (d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash z cd cs)
    xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "XmlConv._inst#Prelude.Data#XmlConv.Elem#" [show x1] info)
  _ -> failCons cd (consFail "XmlConv._inst#Prelude.Data#XmlConv.Elem#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Elem
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash))
    (d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash l s cd
    cs) (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash r s
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash z s cd
    cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "XmlConv._inst#Prelude.Data#XmlConv.Elem#" [show x1] info)
  _ -> failCons cd (consFail "XmlConv._inst#Prelude.Data#XmlConv.Elem#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash :: C_Elem
  -> C_Elem -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash x1 x2 cd cs =
  case x1 of
  C_Elem -> d_C__case_44 x2 cd cs
  Choice_C_Elem d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash
    r x2 cd cs)
  Choices_C_Elem d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash
    z x2 cd cs) xs
  Guard_C_Elem d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Elem d info -> failCons d (traceFail
    "XmlConv._impl#===#Prelude.Data#XmlConv.Elem#" [show x1, show x2] info)
  _ -> failCons cd (consFail "XmlConv._impl#===#Prelude.Data#XmlConv.Elem#"
    (showCons x1))

d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash :: Cover
  -> ConstStore -> C_Elem
d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_Elem_hash cd cs =
  C_Elem

d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data C_NoElem
d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Data (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash)
    (d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash l cd
    cs) (d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash r
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash z cd cs)
    xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "XmlConv._inst#Prelude.Data#XmlConv.NoElem#" [show x1] info)
  _ -> failCons cd (consFail "XmlConv._inst#Prelude.Data#XmlConv.NoElem#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_NoElem
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash))
    (d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash l s cd
    cs) (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash r
    s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash z s cd
    cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "XmlConv._inst#Prelude.Data#XmlConv.NoElem#" [show x1] info)
  _ -> failCons cd (consFail "XmlConv._inst#Prelude.Data#XmlConv.NoElem#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash :: C_NoElem
  -> C_NoElem -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash x1 x2 cd cs =
  case x1 of
  C_NoElem -> d_C__case_43 x2 cd cs
  Choice_C_NoElem d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash
    r x2 cd cs)
  Choices_C_NoElem d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash
    z x2 cd cs) xs
  Guard_C_NoElem d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_NoElem d info -> failCons d (traceFail
    "XmlConv._impl#===#Prelude.Data#XmlConv.NoElem#" [show x1, show x2] info)
  _ -> failCons cd (consFail "XmlConv._impl#===#Prelude.Data#XmlConv.NoElem#"
    (showCons x1))

d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash :: Cover
  -> ConstStore -> C_NoElem
d_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_XmlConv_dot_NoElem_hash cd cs =
  C_NoElem

d_OP_slash_gt_eq :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))) -> (t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_slash_gt_eq x1 x2 cd cs = d_OP_slash_gt_eq_dot_uscore_hash_lambda1 x2 x1

nd_OP_slash_gt_eq :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))) -> Func t0 (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)))) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)))
nd_OP_slash_gt_eq x1 x2 s cd cs = wrapNX id
  (nd_OP_slash_gt_eq_dot_uscore_hash_lambda1 x2 x1)

d_OP_slash_gt_eq_dot_uscore_hash_lambda1 :: forall t0 t1 . (Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t1) => (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))) -> (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp))) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_slash_gt_eq_dot_uscore_hash_lambda1 x1 x2 x3 cd cs = d_C__case_42 x3 x2 x1
  (Curry_Prelude.d_C_apply x2 x3 cd cs) cd cs

nd_OP_slash_gt_eq_dot_uscore_hash_lambda1 :: forall t0 t1 . (Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t1) => Func t0 (Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp)))) -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp))) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp))
nd_OP_slash_gt_eq_dot_uscore_hash_lambda1 x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_42 x3 x2 x1 (Curry_Prelude.nd_C_apply x2 x3
  s0 cd cs) s1 cd cs))

d_C_ret :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp))
d_C_ret x1 x2 cd cs = Curry_Prelude.OP_Tuple2 x1 x2

d_C_xmlReads :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => C_XmlConv t2 t1 t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_C_xmlReads x1 cd cs = case x1 of
  C_Conv x2 x3 -> x2
  Choice_C_XmlConv d i l r -> narrow d i (d_C_xmlReads l cd cs) (d_C_xmlReads r
    cd cs)
  Choices_C_XmlConv d i xs -> narrows cs d i (\z -> d_C_xmlReads z cd cs) xs
  Guard_C_XmlConv d c e -> guardCons d c ((\x -> d_C_xmlReads e cd x) $! addCs c
    cs)
  Fail_C_XmlConv d info -> failCons d (traceFail "XmlConv.xmlReads" [show x1]
    info)
  _ -> failCons cd (consFail "XmlConv.xmlReads" (showCons x1))

nd_C_xmlReads :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => C_XmlConv t2 t1 t0 -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)))
nd_C_xmlReads x1 s cd cs = case x1 of
  HO_C_Conv x2 x3 -> x2
  Choice_C_XmlConv d i l r -> narrow d i (nd_C_xmlReads l s cd cs)
    (nd_C_xmlReads r s cd cs)
  Choices_C_XmlConv d i xs -> narrows cs d i (\z -> nd_C_xmlReads z s cd cs) xs
  Guard_C_XmlConv d c e -> guardCons d c ((\x -> nd_C_xmlReads e s cd x) $!
    addCs c cs)
  Fail_C_XmlConv d info -> failCons d (traceFail "XmlConv.xmlReads" [show x1]
    info)
  _ -> failCons cd (consFail "XmlConv.xmlReads" (showCons x1))

d_C_xmlShows :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => C_XmlConv t2 t1 t0 -> Cover -> ConstStore -> t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
d_C_xmlShows x1 cd cs = case x1 of
  C_Conv x2 x3 -> x3
  Choice_C_XmlConv d i l r -> narrow d i (d_C_xmlShows l cd cs) (d_C_xmlShows r
    cd cs)
  Choices_C_XmlConv d i xs -> narrows cs d i (\z -> d_C_xmlShows z cd cs) xs
  Guard_C_XmlConv d c e -> guardCons d c ((\x -> d_C_xmlShows e cd x) $! addCs c
    cs)
  Fail_C_XmlConv d info -> failCons d (traceFail "XmlConv.xmlShows" [show x1]
    info)
  _ -> failCons cd (consFail "XmlConv.xmlShows" (showCons x1))

nd_C_xmlShows :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => C_XmlConv t2 t1 t0 -> IDSupply -> Cover
  -> ConstStore -> Func t0 (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)))
nd_C_xmlShows x1 s cd cs = case x1 of
  HO_C_Conv x2 x3 -> x3
  Choice_C_XmlConv d i l r -> narrow d i (nd_C_xmlShows l s cd cs)
    (nd_C_xmlShows r s cd cs)
  Choices_C_XmlConv d i xs -> narrows cs d i (\z -> nd_C_xmlShows z s cd cs) xs
  Guard_C_XmlConv d c e -> guardCons d c ((\x -> nd_C_xmlShows e s cd x) $!
    addCs c cs)
  Fail_C_XmlConv d info -> failCons d (traceFail "XmlConv.xmlShows" [show x1]
    info)
  _ -> failCons cd (consFail "XmlConv.xmlShows" (showCons x1))

d_C_xmlRead :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_XmlConv t1 C_Elem t0 -> Curry_XML.C_XmlExp -> Cover -> ConstStore
  -> t0
d_C_xmlRead x1 x2 cd cs = let x3 = Curry_Prelude.d_C_apply (d_C_xmlReads x1 cd
                                cs) (Curry_Prelude.OP_Tuple2
                                Curry_Prelude.OP_List (Curry_Prelude.OP_Cons x2
                                Curry_Prelude.OP_List)) cd cs
  in d_OP_xmlRead_dot_uscore_hash_selFP2_hash_a x3 cd cs

nd_C_xmlRead :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_XmlConv t1 C_Elem t0 -> Curry_XML.C_XmlExp -> IDSupply -> Cover
  -> ConstStore -> t0
nd_C_xmlRead x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let x3 = let s1 = leftSupply s2
                            s0 = rightSupply s2
                     in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
                     (nd_C_xmlReads x1 s0 cd cs) (Curry_Prelude.OP_Tuple2
                     Curry_Prelude.OP_List (Curry_Prelude.OP_Cons x2
                     Curry_Prelude.OP_List)) s1 cd cs)
  in d_OP_xmlRead_dot_uscore_hash_selFP2_hash_a x3 cd cs)

d_OP_xmlRead_dot_uscore_hash_selFP2_hash_a :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)) -> Cover -> ConstStore -> t0
d_OP_xmlRead_dot_uscore_hash_selFP2_hash_a x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_41 x2 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_xmlRead_dot_uscore_hash_selFP2_hash_a l cd cs)
    (d_OP_xmlRead_dot_uscore_hash_selFP2_hash_a r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_xmlRead_dot_uscore_hash_selFP2_hash_a z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_xmlRead_dot_uscore_hash_selFP2_hash_a e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.xmlRead._#selFP2#a" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.xmlRead._#selFP2#a" (showCons x1))

d_C_xmlShow :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => C_XmlConv t0 C_Elem t1 -> t1 -> Cover -> ConstStore
  -> Curry_XML.C_XmlExp
d_C_xmlShow x1 x2 cd cs = let x3 = Curry_Prelude.d_C_apply
                                (Curry_Prelude.d_C_apply (d_C_xmlShows x1 cd cs)
                                x2 cd cs) (Curry_Prelude.OP_Tuple2
                                Curry_Prelude.OP_List Curry_Prelude.OP_List) cd
                                cs
  in d_OP_xmlShow_dot_uscore_hash_selFP4_hash_x x3 cd cs

nd_C_xmlShow :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => C_XmlConv t0 C_Elem t1 -> t1 -> IDSupply -> Cover -> ConstStore
  -> Curry_XML.C_XmlExp
nd_C_xmlShow x1 x2 s cd cs = let s4 = s
  in s4 `seq` (let x3 = let s3 = leftSupply s4
                            s2 = rightSupply s4
                     in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
                     (let s1 = leftSupply s2
                          s0 = rightSupply s2
                     in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
                     (nd_C_xmlShows x1 s0 cd cs) x2 s1 cd cs))
                     (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List
                     Curry_Prelude.OP_List) s3 cd cs)
  in d_OP_xmlShow_dot_uscore_hash_selFP4_hash_x x3 cd cs)

d_OP_xmlShow_dot_uscore_hash_selFP4_hash_x :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover -> ConstStore
  -> Curry_XML.C_XmlExp
d_OP_xmlShow_dot_uscore_hash_selFP4_hash_x x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_38 x3 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_xmlShow_dot_uscore_hash_selFP4_hash_x l cd cs)
    (d_OP_xmlShow_dot_uscore_hash_selFP4_hash_x r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_xmlShow_dot_uscore_hash_selFP4_hash_x z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_xmlShow_dot_uscore_hash_selFP4_hash_x e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.xmlShow._#selFP4#x" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.xmlShow._#selFP4#x" (showCons x1))

d_C_int_ :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_Int) (Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_int_ cd cs = Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_read
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Prelude_dot_Int_hash)
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs)

nd_C_int_ :: IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Int) (Func
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_C_int_ s cd cs = Curry_Prelude.OP_Tuple2 (wrapNX id (Curry_Prelude.nd_C_read
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Prelude_dot_Int_hash)))
  (wrapDX id
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs))

d_C_float_ :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_Float) (Curry_Prelude.C_Float -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_float_ cd cs = Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_read
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Prelude_dot_Float_hash)
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Float_hash
  cd cs)

nd_C_float_ :: IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Float) (Func
  Curry_Prelude.C_Float (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_C_float_ s cd cs = Curry_Prelude.OP_Tuple2 (wrapNX id
  (Curry_Prelude.nd_C_read (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Prelude_dot_Float_hash)))
  (wrapDX id
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Float_hash
  cd cs))

d_C_char_ :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_Char) (Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_char_ cd cs = Curry_Prelude.OP_Tuple2 Curry_Prelude.d_C_head
  (Curry_Prelude.d_C_flip (acceptCs (acceptCs id) Curry_Prelude.OP_Cons)
  Curry_Prelude.OP_List)

nd_C_char_ :: IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Char) (Func
  Curry_Prelude.C_Char (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_C_char_ s cd cs = Curry_Prelude.OP_Tuple2 (wrapDX id Curry_Prelude.d_C_head)
  (wrapNX id (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) Curry_Prelude.OP_Cons)) Curry_Prelude.OP_List))

d_C_string_ :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C_string_ cd cs = Curry_Prelude.OP_Tuple2 Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id

nd_C_string_ :: IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_C_string_ s cd cs = Curry_Prelude.OP_Tuple2 (wrapDX id Curry_Prelude.d_C_id)
  (wrapDX id Curry_Prelude.d_C_id)

d_C_bool_ :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool) (Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_bool_ x1 x2 cd cs = Curry_Prelude.OP_Tuple2
  (d_OP_bool_uscore_dot_readBool_dot_29 x2 x1)
  (d_OP_bool_uscore_dot_showBool_dot_29 x2 x1)

nd_C_bool_ :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) Curry_Prelude.C_Bool) (Func Curry_Prelude.C_Bool
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_C_bool_ x1 x2 s cd cs = Curry_Prelude.OP_Tuple2 (wrapDX id
  (d_OP_bool_uscore_dot_readBool_dot_29 x2 x1)) (wrapDX id
  (d_OP_bool_uscore_dot_showBool_dot_29 x2 x1))

d_OP_bool_uscore_dot_fromJust_dot_29 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Maybe t0 -> Cover -> ConstStore -> t0
d_OP_bool_uscore_dot_fromJust_dot_29 x1 cd cs = case x1 of
  Curry_Prelude.C_Just x2 -> x2
  Curry_Prelude.C_Nothing -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (d_OP_bool_uscore_dot_fromJust_dot_29 l cd cs)
    (d_OP_bool_uscore_dot_fromJust_dot_29 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    d_OP_bool_uscore_dot_fromJust_dot_29 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x ->
    d_OP_bool_uscore_dot_fromJust_dot_29 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "XmlConv.bool_.fromJust.29" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.bool_.fromJust.29" (showCons x1))

d_OP_bool_uscore_dot_readBool_dot_29 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_OP_bool_uscore_dot_readBool_dot_29 x1 x2 x3 cd cs =
  d_OP_bool_uscore_dot_fromJust_dot_29 (Curry_Prelude.d_C_lookup
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  x3 (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x2 Curry_Prelude.C_True)
  (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x1 Curry_Prelude.C_False)
  Curry_Prelude.OP_List)) cd cs) cd cs

d_OP_bool_uscore_dot_showBool_dot_29 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_bool_uscore_dot_showBool_dot_29 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> x2
  Curry_Prelude.C_False -> x1
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (d_OP_bool_uscore_dot_showBool_dot_29 x1 x2 l cd cs)
    (d_OP_bool_uscore_dot_showBool_dot_29 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_OP_bool_uscore_dot_showBool_dot_29 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x ->
    d_OP_bool_uscore_dot_showBool_dot_29 x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "XmlConv.bool_.showBool.29" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "XmlConv.bool_.showBool.29" (showCons x3))

d_C_val_ :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> t0) (t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> C_XmlConv C_NotRepeatable C_NoElem t0
d_C_val_ x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> C_Conv (d_OP_val_uscore_dot_rd_dot_37 x2)
    (acceptCs id (d_OP_val_uscore_dot_sh_dot_37 x3))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_val_ l cd cs)
    (d_C_val_ r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_val_ z cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C_val_ e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "XmlConv.val_"
    [show x1] info)
  _ -> failCons cd (consFail "XmlConv.val_" (showCons x1))

nd_C_val_ :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0) (Func t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv C_NotRepeatable C_NoElem t0
nd_C_val_ x1 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> HO_C_Conv (wrapNX id
    (nd_OP_val_uscore_dot_rd_dot_37 x2)) (wrapDX (wrapNX id) (acceptCs id
    (nd_OP_val_uscore_dot_sh_dot_37 x3)))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_val_ l s cd cs)
    (nd_C_val_ r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_val_ z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C_val_ e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "XmlConv.val_"
    [show x1] info)
  _ -> failCons cd (consFail "XmlConv.val_" (showCons x1))

d_OP_val_uscore_dot_rd_dot_37 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => (Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> t0) -> Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_val_uscore_dot_rd_dot_37 x1 x2 cd cs =
  let x3 = d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP6_hash_attrs x2 cd
        cs
      x4 = d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP7_hash_a x2 cd cs
      x5 = d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP8_hash_elems x2 cd
        cs
  in Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_apply x1 x4 cd cs)
  (Curry_Prelude.OP_Tuple2 x3 x5)

nd_OP_val_uscore_dot_rd_dot_37 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  t0 -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
nd_OP_val_uscore_dot_rd_dot_37 x1 x2 s cd cs = let s0 = s
  in s0 `seq`
  (let x3 = d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP6_hash_attrs x2
         cd cs
       x4 = d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP7_hash_a x2 cd cs
       x5 = d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP8_hash_elems x2
         cd cs
  in Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_apply x1 x4 s0 cd cs)
  (Curry_Prelude.OP_Tuple2 x3 x5))

d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP6_hash_attrs :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> Cover -> ConstStore -> t0
d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP6_hash_attrs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_35 x2 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP6_hash_attrs l cd cs)
    (d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP6_hash_attrs r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP6_hash_attrs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP6_hash_attrs e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.val_.rd.37._#selFP6#attrs" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.val_.rd.37._#selFP6#attrs" (showCons x1))

d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP7_hash_a :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP7_hash_a x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_33 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP7_hash_a l cd cs)
    (d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP7_hash_a r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP7_hash_a z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP7_hash_a e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.val_.rd.37._#selFP7#a" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.val_.rd.37._#selFP7#a" (showCons x1))

d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP8_hash_elems :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_XML.C_XmlExp
d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP8_hash_elems x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_31 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP8_hash_elems l cd cs)
    (d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP8_hash_elems r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP8_hash_elems z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_val_uscore_dot_rd_dot_37_dot_uscore_hash_selFP8_hash_elems e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.val_.rd.37._#selFP8#elems" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.val_.rd.37._#selFP8#elems" (showCons x1))

d_OP_val_uscore_dot_sh_dot_37 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> t1
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)
d_OP_val_uscore_dot_sh_dot_37 x1 x2 x3 cd cs =
  let x4 = d_OP_val_uscore_dot_sh_dot_37_dot_uscore_hash_selFP10_hash_attrs x3
        cd cs
      x5 = d_OP_val_uscore_dot_sh_dot_37_dot_uscore_hash_selFP11_hash_elems x3
        cd cs
  in Curry_Prelude.OP_Tuple2 x4 (Curry_Prelude.OP_Cons (Curry_XML.C_XText
  (Curry_Prelude.d_C_apply x1 x2 cd cs)) x5)

nd_OP_val_uscore_dot_sh_dot_37 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func t1 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> t1 -> Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
nd_OP_val_uscore_dot_sh_dot_37 x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq`
  (let x4 = d_OP_val_uscore_dot_sh_dot_37_dot_uscore_hash_selFP10_hash_attrs x3
         cd cs
       x5 = d_OP_val_uscore_dot_sh_dot_37_dot_uscore_hash_selFP11_hash_elems x3
         cd cs
  in Curry_Prelude.OP_Tuple2 x4 (Curry_Prelude.OP_Cons (Curry_XML.C_XText
  (Curry_Prelude.nd_C_apply x1 x2 s0 cd cs)) x5))

d_OP_val_uscore_dot_sh_dot_37_dot_uscore_hash_selFP10_hash_attrs :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> Cover -> ConstStore -> t0
d_OP_val_uscore_dot_sh_dot_37_dot_uscore_hash_selFP10_hash_attrs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_val_uscore_dot_sh_dot_37_dot_uscore_hash_selFP10_hash_attrs l cd cs)
    (d_OP_val_uscore_dot_sh_dot_37_dot_uscore_hash_selFP10_hash_attrs r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_val_uscore_dot_sh_dot_37_dot_uscore_hash_selFP10_hash_attrs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_val_uscore_dot_sh_dot_37_dot_uscore_hash_selFP10_hash_attrs e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.val_.sh.37._#selFP10#attrs" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.val_.sh.37._#selFP10#attrs" (showCons x1))

d_OP_val_uscore_dot_sh_dot_37_dot_uscore_hash_selFP11_hash_elems :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_XML.C_XmlExp
d_OP_val_uscore_dot_sh_dot_37_dot_uscore_hash_selFP11_hash_elems x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_val_uscore_dot_sh_dot_37_dot_uscore_hash_selFP11_hash_elems l cd cs)
    (d_OP_val_uscore_dot_sh_dot_37_dot_uscore_hash_selFP11_hash_elems r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_val_uscore_dot_sh_dot_37_dot_uscore_hash_selFP11_hash_elems z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_val_uscore_dot_sh_dot_37_dot_uscore_hash_selFP11_hash_elems e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.val_.sh.37._#selFP11#elems" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.val_.sh.37._#selFP11#elems" (showCons x1))

d_C_int :: Cover -> ConstStore -> C_XmlConv C_NotRepeatable C_NoElem
  Curry_Prelude.C_Int
d_C_int cd cs = d_C_val_ (d_C_int_ cd cs) cd cs

nd_C_int :: IDSupply -> Cover -> ConstStore -> C_XmlConv C_NotRepeatable
  C_NoElem Curry_Prelude.C_Int
nd_C_int s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_val_ (nd_C_int_ s0 cd cs) s1 cd cs))

d_C_float :: Cover -> ConstStore -> C_XmlConv C_NotRepeatable C_NoElem
  Curry_Prelude.C_Float
d_C_float cd cs = d_C_val_ (d_C_float_ cd cs) cd cs

nd_C_float :: IDSupply -> Cover -> ConstStore -> C_XmlConv C_NotRepeatable
  C_NoElem Curry_Prelude.C_Float
nd_C_float s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_val_ (nd_C_float_ s0 cd cs) s1 cd cs))

d_C_char :: Cover -> ConstStore -> C_XmlConv C_NotRepeatable C_NoElem
  Curry_Prelude.C_Char
d_C_char cd cs = d_C_val_ (d_C_char_ cd cs) cd cs

nd_C_char :: IDSupply -> Cover -> ConstStore -> C_XmlConv C_NotRepeatable
  C_NoElem Curry_Prelude.C_Char
nd_C_char s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_val_ (nd_C_char_ s0 cd cs) s1 cd cs))

nd_C_string :: IDSupply -> Cover -> ConstStore -> C_XmlConv C_NotRepeatable
  C_NoElem (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C_string s cd cs = HO_C_Conv (wrapNX id nd_OP_string_dot_rd_dot_51) (wrapDX
  (wrapDX id) (acceptCs id d_OP_string_dot_sh_dot_51))

nd_OP_string_dot_rd_dot_51 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
nd_OP_string_dot_rd_dot_51 x1 s cd cs = let s0 = s
  in s0 `seq`
  (let x2 = d_OP_string_dot_rd_dot_51_dot_uscore_hash_selFP13_hash_attrs x1 cd
         cs
       x3 = d_OP_string_dot_rd_dot_51_dot_uscore_hash_selFP14_hash_elems x1 cd
         cs
  in Curry_Prelude.nd_OP_qmark (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List
  x1) (d_C__case_29 x2 x3 cd cs) s0 cd cs)

d_OP_string_dot_rd_dot_51_dot_uscore_hash_selFP13_hash_attrs :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> Cover -> ConstStore -> t0
d_OP_string_dot_rd_dot_51_dot_uscore_hash_selFP13_hash_attrs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_string_dot_rd_dot_51_dot_uscore_hash_selFP13_hash_attrs l cd cs)
    (d_OP_string_dot_rd_dot_51_dot_uscore_hash_selFP13_hash_attrs r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_string_dot_rd_dot_51_dot_uscore_hash_selFP13_hash_attrs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_string_dot_rd_dot_51_dot_uscore_hash_selFP13_hash_attrs e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.string.rd.51._#selFP13#attrs" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.string.rd.51._#selFP13#attrs" (showCons
    x1))

d_OP_string_dot_rd_dot_51_dot_uscore_hash_selFP14_hash_elems :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_XML.C_XmlExp
d_OP_string_dot_rd_dot_51_dot_uscore_hash_selFP14_hash_elems x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_string_dot_rd_dot_51_dot_uscore_hash_selFP14_hash_elems l cd cs)
    (d_OP_string_dot_rd_dot_51_dot_uscore_hash_selFP14_hash_elems r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_string_dot_rd_dot_51_dot_uscore_hash_selFP14_hash_elems z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_string_dot_rd_dot_51_dot_uscore_hash_selFP14_hash_elems e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.string.rd.51._#selFP14#elems" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.string.rd.51._#selFP14#elems" (showCons
    x1))

d_OP_string_dot_sh_dot_51 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
d_OP_string_dot_sh_dot_51 x1 x2 cd cs = case x1 of
  Curry_Prelude.OP_List -> x2
  Curry_Prelude.OP_Cons x3 x4 -> let x5 = d_OP_string_dot_sh_dot_51_dot_uscore_hash_selFP16_hash_attrs
                                       x2 cd cs
                                     x6 = d_OP_string_dot_sh_dot_51_dot_uscore_hash_selFP17_hash_elems
                                       x2 cd cs
    in Curry_Prelude.OP_Tuple2 x5 (Curry_Prelude.OP_Cons (Curry_XML.C_XText x1)
    x6)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_OP_string_dot_sh_dot_51
    l x2 cd cs) (d_OP_string_dot_sh_dot_51 r x2 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_string_dot_sh_dot_51 z x2 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_string_dot_sh_dot_51 e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "XmlConv.string.sh.51" [show x1, show x2] info)
  _ -> failCons cd (consFail "XmlConv.string.sh.51" (showCons x1))

d_OP_string_dot_sh_dot_51_dot_uscore_hash_selFP16_hash_attrs :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> Cover -> ConstStore -> t0
d_OP_string_dot_sh_dot_51_dot_uscore_hash_selFP16_hash_attrs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_string_dot_sh_dot_51_dot_uscore_hash_selFP16_hash_attrs l cd cs)
    (d_OP_string_dot_sh_dot_51_dot_uscore_hash_selFP16_hash_attrs r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_string_dot_sh_dot_51_dot_uscore_hash_selFP16_hash_attrs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_string_dot_sh_dot_51_dot_uscore_hash_selFP16_hash_attrs e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.string.sh.51._#selFP16#attrs" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.string.sh.51._#selFP16#attrs" (showCons
    x1))

d_OP_string_dot_sh_dot_51_dot_uscore_hash_selFP17_hash_elems :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_XML.C_XmlExp
d_OP_string_dot_sh_dot_51_dot_uscore_hash_selFP17_hash_elems x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_string_dot_sh_dot_51_dot_uscore_hash_selFP17_hash_elems l cd cs)
    (d_OP_string_dot_sh_dot_51_dot_uscore_hash_selFP17_hash_elems r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_string_dot_sh_dot_51_dot_uscore_hash_selFP17_hash_elems z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_string_dot_sh_dot_51_dot_uscore_hash_selFP17_hash_elems e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.string.sh.51._#selFP17#elems" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.string.sh.51._#selFP17#elems" (showCons
    x1))

nd_OP_bang :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => C_XmlConv t2 t1 t0 -> C_XmlConv t2 t1 t0
  -> IDSupply -> Cover -> ConstStore -> C_XmlConv t2 t1 t0
nd_OP_bang x1 x2 s cd cs = case x1 of
  HO_C_Conv x3 x4 -> let s0 = s in s0 `seq` nd_C__case_27 x4 x3 x2 s0 cd cs
  Choice_C_XmlConv d i l r -> narrow d i (nd_OP_bang l x2 s cd cs) (nd_OP_bang r
    x2 s cd cs)
  Choices_C_XmlConv d i xs -> narrows cs d i (\z -> nd_OP_bang z x2 s cd cs) xs
  Guard_C_XmlConv d c e -> guardCons d c ((\x -> nd_OP_bang e x2 s cd x) $!
    addCs c cs)
  Fail_C_XmlConv d info -> failCons d (traceFail "XmlConv.!" [show x1, show x2]
    info)
  _ -> failCons cd (consFail "XmlConv.!" (showCons x1))

nd_OP_bang_dot_rd_dot_65 :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp))) -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp))
nd_OP_bang_dot_rd_dot_65 x1 x2 x3 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_OP_qmark
  (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs) (Curry_Prelude.nd_C_apply x2 x3 s1
  cd cs) s2 cd cs))))

nd_OP_bang_dot_sh_dot_65 :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))) -> Func
  t0 (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp))) -> t0 -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
nd_OP_bang_dot_sh_dot_65 x1 x2 x3 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_OP_qmark
  (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs) (Curry_Prelude.nd_C_apply x2 x3 s1
  cd cs) s2 cd cs))))

d_C_element :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> C_XmlConv t2 t1 t0 -> Cover -> ConstStore -> C_XmlConv C_Repeatable C_Elem
  t0
d_C_element x1 x2 cd cs = C_Conv (d_OP_element_dot_rd_dot_71 x1 x2) (acceptCs id
  (d_OP_element_dot_sh_dot_71 x1 x2))

nd_C_element :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> C_XmlConv t2 t1 t0 -> IDSupply -> Cover -> ConstStore -> C_XmlConv
  C_Repeatable C_Elem t0
nd_C_element x1 x2 s cd cs = HO_C_Conv (wrapNX id (nd_OP_element_dot_rd_dot_71
  x1 x2)) (wrapDX (wrapNX id) (acceptCs id (nd_OP_element_dot_sh_dot_71 x1 x2)))

d_OP_element_dot_rd_dot_71 :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t3) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_XmlConv t2 t1 t0
  -> Curry_Prelude.OP_Tuple2 t3 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2
  t3 (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_element_dot_rd_dot_71 x1 x2 x3 cd cs =
  let x4 = d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP19_hash_attrs x3 cd
        cs
      x5 = d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP20_hash_myName x3 cd
        cs
      x6 = d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP21_hash_myAttrs x3 cd
        cs
      x7 = d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP22_hash_myElems x3 cd
        cs
      x8 = d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP23_hash_elems x3 cd
        cs
  in d_C__case_26 x1 x5 x7 x6 x2 x8 x4
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x5 x1 cd cs) cd cs

nd_OP_element_dot_rd_dot_71 :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t3) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_XmlConv t2 t1 t0
  -> Curry_Prelude.OP_Tuple2 t3 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_Tuple2 t3 (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
nd_OP_element_dot_rd_dot_71 x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq`
  (let x4 = d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP19_hash_attrs x3 cd
         cs
       x5 = d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP20_hash_myName x3 cd
         cs
       x6 = d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP21_hash_myAttrs x3
         cd cs
       x7 = d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP22_hash_myElems x3
         cd cs
       x8 = d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP23_hash_elems x3 cd
         cs
  in let s1 = leftSupply s2
         s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_26 x1 x5 x7 x6 x2 x8 x4
  (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  x5 x1 s0 cd cs) s1 cd cs))

d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP19_hash_attrs :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> Cover -> ConstStore -> t0
d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP19_hash_attrs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_21 x2 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP19_hash_attrs l cd cs)
    (d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP19_hash_attrs r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP19_hash_attrs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP19_hash_attrs e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.element.rd.71._#selFP19#attrs" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.element.rd.71._#selFP19#attrs" (showCons
    x1))

d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP20_hash_myName :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP20_hash_myName x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_19 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP20_hash_myName l cd cs)
    (d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP20_hash_myName r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP20_hash_myName z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP20_hash_myName e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.element.rd.71._#selFP20#myName" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.element.rd.71._#selFP20#myName" (showCons
    x1))

d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP21_hash_myAttrs :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP21_hash_myAttrs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_17 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP21_hash_myAttrs l cd cs)
    (d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP21_hash_myAttrs r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP21_hash_myAttrs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP21_hash_myAttrs e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.element.rd.71._#selFP21#myAttrs" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.element.rd.71._#selFP21#myAttrs" (showCons
    x1))

d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP22_hash_myElems :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_XML.C_XmlExp
d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP22_hash_myElems x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_15 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP22_hash_myElems l cd cs)
    (d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP22_hash_myElems r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP22_hash_myElems z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP22_hash_myElems e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.element.rd.71._#selFP22#myElems" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.element.rd.71._#selFP22#myElems" (showCons
    x1))

d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP23_hash_elems :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_XML.C_XmlExp
d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP23_hash_elems x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_13 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP23_hash_elems l cd cs)
    (d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP23_hash_elems r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP23_hash_elems z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_element_dot_rd_dot_71_dot_uscore_hash_selFP23_hash_elems e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.element.rd.71._#selFP23#elems" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.element.rd.71._#selFP23#elems" (showCons
    x1))

d_OP_element_dot_sh_dot_71 :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_XmlConv t3 t2 t1 -> t1
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)
d_OP_element_dot_sh_dot_71 x1 x2 x3 x4 cd cs =
  let x5 = d_OP_element_dot_sh_dot_71_dot_uscore_hash_selFP25_hash_attrs x4 cd
        cs
      x6 = d_OP_element_dot_sh_dot_71_dot_uscore_hash_selFP26_hash_elems x4 cd
        cs
  in d_C__case_11 x3 x2 x6 x1 x5 (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (d_C_xmlShows x2 cd cs) x3 cd cs)
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List Curry_Prelude.OP_List) cd cs)
  cd cs

nd_OP_element_dot_sh_dot_71 :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_XmlConv t3 t2 t1 -> t1
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
nd_OP_element_dot_sh_dot_71 x1 x2 x3 x4 s cd cs = let s6 = s
  in s6 `seq`
  (let x5 = d_OP_element_dot_sh_dot_71_dot_uscore_hash_selFP25_hash_attrs x4 cd
         cs
       x6 = d_OP_element_dot_sh_dot_71_dot_uscore_hash_selFP26_hash_elems x4 cd
         cs
  in let s5 = leftSupply s6
         s4 = rightSupply s6
  in s5 `seq` (s4 `seq` nd_C__case_11 x3 x2 x6 x1 x5 (let s3 = leftSupply s4
                                                          s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x2 s0 cd cs) x3
  s1 cd cs)) (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List
  Curry_Prelude.OP_List) s3 cd cs)) s5 cd cs))

d_OP_element_dot_sh_dot_71_dot_uscore_hash_selFP25_hash_attrs :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> Cover -> ConstStore -> t0
d_OP_element_dot_sh_dot_71_dot_uscore_hash_selFP25_hash_attrs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_element_dot_sh_dot_71_dot_uscore_hash_selFP25_hash_attrs l cd cs)
    (d_OP_element_dot_sh_dot_71_dot_uscore_hash_selFP25_hash_attrs r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_element_dot_sh_dot_71_dot_uscore_hash_selFP25_hash_attrs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_element_dot_sh_dot_71_dot_uscore_hash_selFP25_hash_attrs e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.element.sh.71._#selFP25#attrs" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.element.sh.71._#selFP25#attrs" (showCons
    x1))

d_OP_element_dot_sh_dot_71_dot_uscore_hash_selFP26_hash_elems :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_XML.C_XmlExp
d_OP_element_dot_sh_dot_71_dot_uscore_hash_selFP26_hash_elems x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_element_dot_sh_dot_71_dot_uscore_hash_selFP26_hash_elems l cd cs)
    (d_OP_element_dot_sh_dot_71_dot_uscore_hash_selFP26_hash_elems r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_element_dot_sh_dot_71_dot_uscore_hash_selFP26_hash_elems z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_element_dot_sh_dot_71_dot_uscore_hash_selFP26_hash_elems e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.element.sh.71._#selFP26#elems" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.element.sh.71._#selFP26#elems" (showCons
    x1))

d_C_empty :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> t0
  -> Cover -> ConstStore -> C_XmlConv C_NotRepeatable C_NoElem t0
d_C_empty x1 x2 cd cs = let x3 = d_C_ret x2
  in C_Conv x3 (acceptCs id (d_OP_empty_dot_sh_dot_83 x2))

nd_C_empty :: forall t0 . (Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> t0 -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv C_NotRepeatable C_NoElem t0
nd_C_empty x1 x2 s cd cs = let x3 = wrapDX id (d_C_ret x2)
  in HO_C_Conv x3 (wrapDX (wrapDX id) (acceptCs id (d_OP_empty_dot_sh_dot_83
  x2)))

d_OP_empty_dot_sh_dot_83 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t1 -> t1 -> t0 -> Cover -> ConstStore -> t0
d_OP_empty_dot_sh_dot_83 x1 x2 x3 cd cs = d_C__case_10 x1 x2 x3
  (Curry_Prelude.d_OP_eq_colon_eq x2 x1 cd cs) cd cs

d_C_attr :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> t0) (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> C_XmlConv C_NotRepeatable C_NoElem t0
d_C_attr x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> C_Conv (d_OP_attr_dot_rd_dot_88 x1 x3)
    (acceptCs id (d_OP_attr_dot_sh_dot_88 x1 x4))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_attr x1 l cd cs)
    (d_C_attr x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_attr x1 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C_attr x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "XmlConv.attr"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "XmlConv.attr" (showCons x2))

nd_C_attr :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0) (Func t0 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore -> C_XmlConv
  C_NotRepeatable C_NoElem t0
nd_C_attr x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> HO_C_Conv (wrapNX id
    (nd_OP_attr_dot_rd_dot_88 x1 x3)) (wrapDX (wrapNX id) (acceptCs id
    (nd_OP_attr_dot_sh_dot_88 x1 x4)))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_attr x1 l s cd cs)
    (nd_C_attr x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_attr x1 z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C_attr x1 e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "XmlConv.attr"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "XmlConv.attr" (showCons x2))

d_OP_attr_dot_rd_dot_88 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> t0)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  t0 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) t1)
d_OP_attr_dot_rd_dot_88 x1 x2 x3 cd cs =
  let x4 = d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP31_hash_attrs x3 cd cs
      x5 = d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP32_hash_elems x3 cd cs
      x6 = d_C_exposeBy (Curry_Prelude.d_OP_dot
        (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
        Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
        x1) Curry_Prelude.d_C_fst cd cs) x4 cd cs
      x7 = d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP29_hash_value x6 cd cs
      x8 = d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP30_hash_attrs_tick x6 cd
        cs
  in Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_apply x2 x7 cd cs)
  (Curry_Prelude.OP_Tuple2 x8 x5)

nd_OP_attr_dot_rd_dot_88 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) t1 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) t1)
nd_OP_attr_dot_rd_dot_88 x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s2 = leftSupply s4
                   s3 = rightSupply s4
  in s2 `seq` (s3 `seq`
  (let x4 = d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP31_hash_attrs x3 cd cs
       x5 = d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP32_hash_elems x3 cd cs
       x6 = let s1 = leftSupply s2
                s0 = rightSupply s2
         in s1 `seq` (s0 `seq` nd_C_exposeBy (Curry_Prelude.nd_OP_dot (wrapNX id
         (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
         (wrapNX id
         Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
         x1)) (wrapDX id Curry_Prelude.d_C_fst) s0 cd cs) x4 s1 cd cs)
       x7 = d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP29_hash_value x6 cd cs
       x8 = d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP30_hash_attrs_tick x6
         cd cs
  in Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_apply x2 x7 s3 cd cs)
  (Curry_Prelude.OP_Tuple2 x8 x5))))

d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP31_hash_attrs :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP31_hash_attrs x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP31_hash_attrs l cd cs)
    (d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP31_hash_attrs r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP31_hash_attrs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP31_hash_attrs e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.attr.rd.88._#selFP31#attrs" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.attr.rd.88._#selFP31#attrs" (showCons x1))

d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP32_hash_elems :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) t0 -> Cover -> ConstStore -> t0
d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP32_hash_elems x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP32_hash_elems l cd cs)
    (d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP32_hash_elems r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP32_hash_elems z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP32_hash_elems e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.attr.rd.88._#selFP32#elems" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.attr.rd.88._#selFP32#elems" (showCons x1))

d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP29_hash_value :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP29_hash_value x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_9 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP29_hash_value l cd cs)
    (d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP29_hash_value r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP29_hash_value z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP29_hash_value e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.attr.rd.88._#selFP29#value" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.attr.rd.88._#selFP29#value" (showCons x1))

d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP30_hash_attrs_tick :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP30_hash_attrs_tick x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_8 x3 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP30_hash_attrs_tick l cd cs)
    (d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP30_hash_attrs_tick r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP30_hash_attrs_tick z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_attr_dot_rd_dot_88_dot_uscore_hash_selFP30_hash_attrs_tick e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.attr.rd.88._#selFP30#attrs'" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.attr.rd.88._#selFP30#attrs'" (showCons
    x1))

d_OP_attr_dot_sh_dot_88 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> (t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> t1
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))) t0
d_OP_attr_dot_sh_dot_88 x1 x2 x3 x4 cd cs =
  let x5 = d_OP_attr_dot_sh_dot_88_dot_uscore_hash_selFP34_hash_attrs x4 cd cs
      x6 = d_OP_attr_dot_sh_dot_88_dot_uscore_hash_selFP35_hash_elems x4 cd cs
  in Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x1
  (Curry_Prelude.d_C_apply x2 x3 cd cs)) x5) x6

nd_OP_attr_dot_sh_dot_88 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Func t1 (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> t1
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) t0
nd_OP_attr_dot_sh_dot_88 x1 x2 x3 x4 s cd cs = let s0 = s
  in s0 `seq`
  (let x5 = d_OP_attr_dot_sh_dot_88_dot_uscore_hash_selFP34_hash_attrs x4 cd cs
       x6 = d_OP_attr_dot_sh_dot_88_dot_uscore_hash_selFP35_hash_elems x4 cd cs
  in Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x1
  (Curry_Prelude.nd_C_apply x2 x3 s0 cd cs)) x5) x6)

d_OP_attr_dot_sh_dot_88_dot_uscore_hash_selFP34_hash_attrs :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_attr_dot_sh_dot_88_dot_uscore_hash_selFP34_hash_attrs x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_attr_dot_sh_dot_88_dot_uscore_hash_selFP34_hash_attrs l cd cs)
    (d_OP_attr_dot_sh_dot_88_dot_uscore_hash_selFP34_hash_attrs r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_attr_dot_sh_dot_88_dot_uscore_hash_selFP34_hash_attrs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_attr_dot_sh_dot_88_dot_uscore_hash_selFP34_hash_attrs e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.attr.sh.88._#selFP34#attrs" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.attr.sh.88._#selFP34#attrs" (showCons x1))

d_OP_attr_dot_sh_dot_88_dot_uscore_hash_selFP35_hash_elems :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) t0 -> Cover -> ConstStore -> t0
d_OP_attr_dot_sh_dot_88_dot_uscore_hash_selFP35_hash_elems x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_attr_dot_sh_dot_88_dot_uscore_hash_selFP35_hash_elems l cd cs)
    (d_OP_attr_dot_sh_dot_88_dot_uscore_hash_selFP35_hash_elems r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_attr_dot_sh_dot_88_dot_uscore_hash_selFP35_hash_elems z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_attr_dot_sh_dot_88_dot_uscore_hash_selFP35_hash_elems e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.attr.sh.88._#selFP35#elems" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.attr.sh.88._#selFP35#elems" (showCons x1))

d_C_exposeBy :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List t0)
d_C_exposeBy x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> let x5 = d_C_exposeBy x1 x4 cd cs
                                     x6 = d_OP_exposeBy_dot_uscore_hash_selFP37_hash_y
                                       x5 cd cs
                                     x7 = d_OP_exposeBy_dot_uscore_hash_selFP38_hash_ys
                                       x5 cd cs
    in d_C__case_7 x3 x1 x7 x6 x4 (Curry_Prelude.d_C_apply x1 x3 cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_exposeBy x1 l cd cs)
    (d_C_exposeBy x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_exposeBy x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_exposeBy x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XmlConv.exposeBy"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "XmlConv.exposeBy" (showCons x2))

nd_C_exposeBy :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  Curry_Prelude.C_Bool -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List t0)
nd_C_exposeBy x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> let s4 = s
    in s4 `seq` (let s0 = leftSupply s4
                     s3 = rightSupply s4
    in s0 `seq` (s3 `seq` (let x5 = nd_C_exposeBy x1 x4 s0 cd cs
                               x6 = d_OP_exposeBy_dot_uscore_hash_selFP37_hash_y
                                 x5 cd cs
                               x7 = d_OP_exposeBy_dot_uscore_hash_selFP38_hash_ys
                                 x5 cd cs
    in let s2 = leftSupply s3
           s1 = rightSupply s3
    in s2 `seq` (s1 `seq` nd_C__case_7 x3 x1 x7 x6 x4 (Curry_Prelude.nd_C_apply
    x1 x3 s1 cd cs) s2 cd cs))))
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_exposeBy x1 l s cd
    cs) (nd_C_exposeBy x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_exposeBy x1
    z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_exposeBy x1 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XmlConv.exposeBy"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "XmlConv.exposeBy" (showCons x2))

d_OP_exposeBy_dot_uscore_hash_selFP37_hash_y :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List t0) -> Cover
  -> ConstStore -> t0
d_OP_exposeBy_dot_uscore_hash_selFP37_hash_y x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_exposeBy_dot_uscore_hash_selFP37_hash_y l cd cs)
    (d_OP_exposeBy_dot_uscore_hash_selFP37_hash_y r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_exposeBy_dot_uscore_hash_selFP37_hash_y z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_exposeBy_dot_uscore_hash_selFP37_hash_y e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.exposeBy._#selFP37#y" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.exposeBy._#selFP37#y" (showCons x1))

d_OP_exposeBy_dot_uscore_hash_selFP38_hash_ys :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List t0) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_exposeBy_dot_uscore_hash_selFP38_hash_ys x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_exposeBy_dot_uscore_hash_selFP38_hash_ys l cd cs)
    (d_OP_exposeBy_dot_uscore_hash_selFP38_hash_ys r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_exposeBy_dot_uscore_hash_selFP38_hash_ys z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_exposeBy_dot_uscore_hash_selFP38_hash_ys e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv.exposeBy._#selFP38#ys" [show x1] info)
  _ -> failCons cd (consFail "XmlConv.exposeBy._#selFP38#ys" (showCons x1))

d_C_adapt :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t3, Curry_Prelude.Curry t2) => Curry_Prelude.OP_Tuple2
  (t1 -> Cover -> ConstStore -> t0) (t0 -> Cover -> ConstStore -> t1)
  -> C_XmlConv t3 t2 t1 -> Cover -> ConstStore -> C_XmlConv t3 t2 t0
d_C_adapt x1 x2 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_6 x4 x3 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_adapt l x2 cd cs)
    (d_C_adapt r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_adapt z x2
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C_adapt e x2 cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "XmlConv.adapt"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "XmlConv.adapt" (showCons x1))

nd_C_adapt :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t3, Curry_Prelude.Curry t2) => Curry_Prelude.OP_Tuple2
  (Func t1 t0) (Func t0 t1) -> C_XmlConv t3 t2 t1 -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv t3 t2 t0
nd_C_adapt x1 x2 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s0 = s
    in s0 `seq` nd_C__case_6 x4 x3 x2 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_adapt l x2 s cd cs)
    (nd_C_adapt r x2 s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_adapt z
    x2 s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C_adapt e x2 s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "XmlConv.adapt"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "XmlConv.adapt" (showCons x1))

nd_C_opt :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => C_XmlConv t2 t1 t0 -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv C_NotRepeatable C_NoElem (Curry_Prelude.C_Maybe t0)
nd_C_opt x1 s cd cs = HO_C_Conv (wrapNX id (nd_OP_opt_dot_rd_dot_105 x1))
  (wrapNX id (nd_OP_opt_dot_sh_dot_105 x1))

nd_OP_opt_dot_rd_dot_105 :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => C_XmlConv t2 t1 t0
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Maybe t0)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
nd_OP_opt_dot_rd_dot_105 x1 x2 s cd cs = let s8 = s
  in s8 `seq` (let s7 = leftSupply s8
                   s6 = rightSupply s8
  in s7 `seq` (s6 `seq` Curry_Prelude.nd_OP_qmark (d_C_ret
  Curry_Prelude.C_Nothing x2 cd cs) (let s5 = leftSupply s6
                                         s3 = rightSupply s6
  in s5 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply s3
                                                      s4 = rightSupply s3
                                                      s0 = leftSupply s4
                                                      s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x1
  s0 cd cs) (Curry_Prelude.nd_OP_dot (wrapDX (wrapDX id) (acceptCs id d_C_ret))
  (wrapDX id (acceptCs id Curry_Prelude.C_Just)) s1 cd cs) s2 cd cs)))) x2 s5 cd
  cs)) s7 cd cs))

d_OP_opt_dot_sh_dot_105 :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => C_XmlConv t2 t1 t0
  -> Curry_Prelude.C_Maybe t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
d_OP_opt_dot_sh_dot_105 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.d_C_id
  Curry_Prelude.C_Just x3 -> Curry_Prelude.d_C_apply (d_C_xmlShows x1 cd cs) x3
    cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (d_OP_opt_dot_sh_dot_105 x1
    l cd cs) (d_OP_opt_dot_sh_dot_105 x1 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    d_OP_opt_dot_sh_dot_105 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x ->
    d_OP_opt_dot_sh_dot_105 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "XmlConv.opt.sh.105" [show x1, show x2] info)
  _ -> failCons cd (consFail "XmlConv.opt.sh.105" (showCons x2))

nd_OP_opt_dot_sh_dot_105 :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => C_XmlConv t2 t1 t0
  -> Curry_Prelude.C_Maybe t0 -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
nd_OP_opt_dot_sh_dot_105 x1 x2 s cd cs = case x2 of
  Curry_Prelude.C_Nothing -> wrapDX id Curry_Prelude.d_C_id
  Curry_Prelude.C_Just x3 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x1 s0 cd cs)
    x3 s1 cd cs))
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (nd_OP_opt_dot_sh_dot_105
    x1 l s cd cs) (nd_OP_opt_dot_sh_dot_105 x1 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    nd_OP_opt_dot_sh_dot_105 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x ->
    nd_OP_opt_dot_sh_dot_105 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "XmlConv.opt.sh.105" [show x1, show x2] info)
  _ -> failCons cd (consFail "XmlConv.opt.sh.105" (showCons x2))

nd_C_rep :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_XmlConv C_Repeatable t1 t0 -> IDSupply -> Cover -> ConstStore
  -> C_XmlConv C_NotRepeatable C_NoElem (Curry_Prelude.OP_List t0)
nd_C_rep x1 s cd cs = let s2 = s
  in s2 `seq` (let x2 = let s1 = leftSupply s2
                            s0 = rightSupply s2
                     in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (wrapNX id
                     (Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs id
                     Curry_Prelude.nd_OP_dot)) (wrapDX id
                     Curry_Prelude.d_C_id))) (wrapNX id (Curry_Prelude.nd_C_map
                     (nd_C_xmlShows x1 s0 cd cs))) s1 cd cs)
  in HO_C_Conv (wrapNX id (nd_OP_rep_dot_rd_dot_113 x1)) x2)

nd_OP_rep_dot_rd_dot_113 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => C_XmlConv C_Repeatable t1 t0
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
nd_OP_rep_dot_rd_dot_113 x1 x2 s cd cs = let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_OP_qmark (d_C_ret Curry_Prelude.OP_List
  x2 cd cs) (let s3 = leftSupply s4
                 s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x1 s0 cd cs) (wrapNX id
  (nd_OP_rep_dot_rd_dot_113_dot_uscore_hash_lambda6 x1)) s1 cd cs)) x2 s3 cd
  cs)) s5 cd cs))

nd_OP_rep_dot_rd_dot_113_dot_uscore_hash_lambda6 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => C_XmlConv
  C_Repeatable t1 t0 -> t0 -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)))
nd_OP_rep_dot_rd_dot_113_dot_uscore_hash_lambda6 x1 x2 s cd cs = let s0 = s
  in s0 `seq` nd_OP_slash_gt_eq (wrapNX id (nd_OP_rep_dot_rd_dot_113 x1))
  (wrapDX (wrapDX id)
  (d_OP_rep_dot_rd_dot_113_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7 x2))
  s0 cd cs

d_OP_rep_dot_rd_dot_113_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7 :: forall t0 . (Curry_Prelude.Curry
  t0) => t0 -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_rep_dot_rd_dot_113_dot_uscore_hash_lambda6_dot_uscore_hash_lambda7 x1 x2 cd cs =
  d_C_ret (Curry_Prelude.OP_Cons x1 x2)

d_C_aInt :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> C_XmlConv C_NotRepeatable C_NoElem Curry_Prelude.C_Int
d_C_aInt x1 cd cs = d_C_attr x1 (d_C_int_ cd cs) cd cs

nd_C_aInt :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv C_NotRepeatable C_NoElem Curry_Prelude.C_Int
nd_C_aInt x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_attr x1 (nd_C_int_ s0 cd cs) s1 cd cs))

d_C_aFloat :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> C_XmlConv C_NotRepeatable C_NoElem Curry_Prelude.C_Float
d_C_aFloat x1 cd cs = d_C_attr x1 (d_C_float_ cd cs) cd cs

nd_C_aFloat :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv C_NotRepeatable C_NoElem Curry_Prelude.C_Float
nd_C_aFloat x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_attr x1 (nd_C_float_ s0 cd cs) s1 cd cs))

d_C_aChar :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> C_XmlConv C_NotRepeatable C_NoElem Curry_Prelude.C_Char
d_C_aChar x1 cd cs = d_C_attr x1 (d_C_char_ cd cs) cd cs

nd_C_aChar :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv C_NotRepeatable C_NoElem Curry_Prelude.C_Char
nd_C_aChar x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_attr x1 (nd_C_char_ s0 cd cs) s1 cd cs))

d_C_aString :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> C_XmlConv C_NotRepeatable C_NoElem (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C_aString x1 cd cs = d_C_attr x1 (d_C_string_ cd cs) cd cs

nd_C_aString :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv C_NotRepeatable C_NoElem (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_C_aString x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_attr x1 (nd_C_string_ s0 cd cs) s1 cd cs))

d_C_aBool :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> C_XmlConv C_NotRepeatable C_NoElem Curry_Prelude.C_Bool
d_C_aBool x1 x2 x3 cd cs = d_C_attr x1 (d_C_bool_ x2 x3 cd cs) cd cs

nd_C_aBool :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> C_XmlConv
  C_NotRepeatable C_NoElem Curry_Prelude.C_Bool
nd_C_aBool x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_attr x1 (nd_C_bool_ x2 x3 s0 cd cs) s1 cd cs))

d_C_eInt :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> C_XmlConv C_Repeatable C_Elem Curry_Prelude.C_Int
d_C_eInt x1 cd cs = d_C_element x1 (d_C_int cd cs) cd cs

nd_C_eInt :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv C_Repeatable C_Elem Curry_Prelude.C_Int
nd_C_eInt x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_element x1 (nd_C_int s0 cd cs) s1 cd cs))

d_C_eFloat :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> C_XmlConv C_Repeatable C_Elem Curry_Prelude.C_Float
d_C_eFloat x1 cd cs = d_C_element x1 (d_C_float cd cs) cd cs

nd_C_eFloat :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv C_Repeatable C_Elem Curry_Prelude.C_Float
nd_C_eFloat x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_element x1 (nd_C_float s0 cd cs) s1 cd cs))

d_C_eChar :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> C_XmlConv C_Repeatable C_Elem Curry_Prelude.C_Char
d_C_eChar x1 cd cs = d_C_element x1 (d_C_char cd cs) cd cs

nd_C_eChar :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv C_Repeatable C_Elem Curry_Prelude.C_Char
nd_C_eChar x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_element x1 (nd_C_char s0 cd cs) s1 cd cs))

nd_C_eString :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv C_Repeatable C_Elem (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_C_eString x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_element x1 (nd_C_string s0 cd cs) s1 cd cs))

nd_C_eBool :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv C_Repeatable C_Elem Curry_Prelude.C_Bool
nd_C_eBool x1 x2 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` nd_OP_bang (nd_C_eEmpty (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash)
  x1 Curry_Prelude.C_True s0 cd cs) (nd_C_eEmpty (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash)
  x2 Curry_Prelude.C_False s1 cd cs) s2 cd cs))))

d_C_eEmpty :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> t0 -> Cover -> ConstStore
  -> C_XmlConv C_Repeatable C_Elem t0
d_C_eEmpty x1 x2 x3 cd cs = d_C_element x2 (d_C_empty x1 x3 cd cs) cd cs

nd_C_eEmpty :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> t0 -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv C_Repeatable C_Elem t0
nd_C_eEmpty x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_element x2 (nd_C_empty x1 x3 s0 cd cs) s1 cd cs))

nd_C_eOpt :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> C_XmlConv t2 t1 t0 -> IDSupply -> Cover -> ConstStore -> C_XmlConv
  C_Repeatable C_Elem (Curry_Prelude.C_Maybe t0)
nd_C_eOpt x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_element x1 (nd_C_opt x2 s0 cd cs) s1 cd cs))

nd_C_eRep :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_XmlConv C_Repeatable t1
  t0 -> IDSupply -> Cover -> ConstStore -> C_XmlConv C_Repeatable C_Elem
  (Curry_Prelude.OP_List t0)
nd_C_eRep x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_element x1 (nd_C_rep x2 s0 cd cs) s1 cd cs))

nd_C_seq1 :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t3, Curry_Prelude.Curry t2) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t1) -> Func t0
  t1 -> C_XmlConv t3 t2 t0 -> IDSupply -> Cover -> ConstStore -> C_XmlConv t3
  C_NoElem t1
nd_C_seq1 x1 x2 x3 x4 s cd cs = let s3 = s
  in s3 `seq` (let x5 = let s2 = leftSupply s3
                            s4 = rightSupply s3
                            s0 = leftSupply s4
                            s1 = rightSupply s4
                     in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` nd_OP_slash_gt_eq
                     (nd_C_xmlReads x4 s0 cd cs) (Curry_Prelude.nd_OP_dot
                     (wrapDX (wrapDX id) (acceptCs id d_C_ret)) x3 s1 cd cs) s2
                     cd cs)))
  in HO_C_Conv x5 (wrapNX id (nd_OP_seq1_dot_sh_dot_146 x4 x3)))

nd_OP_seq1_dot_sh_dot_146 :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => C_XmlConv t3 t2 t0 -> Func t0 t1 -> t1 -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp))
nd_OP_seq1_dot_sh_dot_146 x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s0 = leftSupply s4
                   s3 = rightSupply s4
  in s0 `seq` (s3 `seq` (let x4 = generate s0 cd
  in let s2 = leftSupply s3
         s1 = rightSupply s3
  in s2 `seq` (s1 `seq` nd_C__case_5 x3 x4 x2 x1
  (Curry_Prelude.d_OP_eq_colon_lt_eq (Curry_Prelude.nd_C_apply x2 x4 s1 cd cs)
  x3 cd cs) s2 cd cs))))

nd_C_repSeq1 :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t2) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t1) -> Func t2 t1 -> C_XmlConv
  C_Repeatable t0 t2 -> IDSupply -> Cover -> ConstStore -> C_XmlConv
  C_NotRepeatable C_NoElem (Curry_Prelude.OP_List t1)
nd_C_repSeq1 x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_rep (nd_C_seq1 x1 x2 x3 x4 s0 cd cs) s1 cd cs))

nd_C_eSeq1 :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t3) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t2)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func t3 t2 -> C_XmlConv t1 t0
  t3 -> IDSupply -> Cover -> ConstStore -> C_XmlConv C_Repeatable C_Elem t2
nd_C_eSeq1 x1 x2 x3 x4 x5 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_element x3 (nd_C_seq1 x1 x2 x4 x5 s0 cd cs) s1 cd
  cs))

nd_C_eRepSeq1 :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t2) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t1) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func t2 t1 -> C_XmlConv C_Repeatable t0 t2 -> IDSupply
  -> Cover -> ConstStore -> C_XmlConv C_Repeatable C_Elem (Curry_Prelude.OP_List
  t1)
nd_C_eRepSeq1 x1 x2 x3 x4 x5 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_element x3 (nd_C_repSeq1 x1 x2 x4 x5 s0 cd cs) s1
  cd cs))

nd_C_seq2_ :: forall t0 t1 t2 t3 t4 t5 t6 t7 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t3, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t6, Curry_Prelude.Curry t5, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t2) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t3) -> Func t2 (Func t1 t3)
  -> C_XmlConv t7 t6 t2 -> C_XmlConv t5 t4 t1 -> IDSupply -> Cover -> ConstStore
  -> C_XmlConv t0 C_NoElem t3
nd_C_seq2_ x1 x2 x3 x4 x5 x6 s cd cs = let s2 = s
  in s2 `seq` (let x7 = let s1 = leftSupply s2
                            s0 = rightSupply s2
                     in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x5
                     s0 cd cs) (wrapNX id
                     (nd_OP_seq2_uscore_dot_uscore_hash_lambda8 x6 x4)) s1 cd
                     cs)
  in HO_C_Conv x7 (wrapNX id (nd_OP_seq2_uscore_dot_sh_dot_157 x6 x5 x4)))

d_OP_seq2_uscore_dot_uscore_hash_lambda8 :: forall t0 t1 t2 t3
  t4 . (Curry_Prelude.Curry t4, Curry_Prelude.Curry t3, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t2) => C_XmlConv t4 t3 t0 -> (t1
  -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t2) -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_seq2_uscore_dot_uscore_hash_lambda8 x1 x2 x3 cd cs = d_OP_slash_gt_eq
  (d_C_xmlReads x1 cd cs)
  (d_OP_seq2_uscore_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 x3 x2) cd cs

nd_OP_seq2_uscore_dot_uscore_hash_lambda8 :: forall t0 t1 t2 t3
  t4 . (Curry_Prelude.Curry t4, Curry_Prelude.Curry t3, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t2) => C_XmlConv t4 t3 t0
  -> Func t1 (Func t0 t2) -> t1 -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)))
nd_OP_seq2_uscore_dot_uscore_hash_lambda8 x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x1 s0 cd cs) (wrapNX id
  (nd_OP_seq2_uscore_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 x3 x2)) s1
  cd cs))

d_OP_seq2_uscore_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 :: forall t0 t1
  t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t2) => t1 -> (t1 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t2)
  -> t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_seq2_uscore_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 x1 x2 x3 cd cs =
  d_C_ret (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x2 x1 cd cs) x3 cd
  cs)

nd_OP_seq2_uscore_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 :: forall t0
  t1 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t2) => t1 -> Func t1 (Func t0 t2) -> t0 -> IDSupply -> Cover -> ConstStore
  -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 t2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)))
nd_OP_seq2_uscore_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 x1 x2 x3 s cd cs =
  let s2 = s
  in s2 `seq` wrapDX id (d_C_ret (let s1 = leftSupply s2
                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2 x1
  s0 cd cs) x3 s1 cd cs)))

nd_OP_seq2_uscore_dot_sh_dot_157 :: forall t0 t1 t2 t3 t4 t5
  t6 . (Curry_Prelude.Curry t4, Curry_Prelude.Curry t3, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t6, Curry_Prelude.Curry t5, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2) => C_XmlConv t4 t3 t0 -> C_XmlConv t6 t5 t1 -> Func
  t1 (Func t0 t2) -> t2 -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
nd_OP_seq2_uscore_dot_sh_dot_157 x1 x2 x3 x4 s cd cs = let s7 = s
  in s7 `seq` (let s0 = leftSupply s7
                   s8 = rightSupply s7
                   s1 = leftSupply s8
                   s6 = rightSupply s8
  in s0 `seq` (s8 `seq` (s1 `seq` (s6 `seq` (let x5 = generate s0 cd
                                                 x6 = generate s1 cd
  in let s5 = leftSupply s6
         s4 = rightSupply s6
  in s5 `seq` (s4 `seq` nd_C__case_4 x4 x6 x5 x3 x1 x2
  (Curry_Prelude.d_OP_eq_colon_lt_eq (let s3 = leftSupply s4
                                          s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x3 x5
  s2 cd cs) x6 s3 cd cs)) x4 cd cs) s5 cd cs))))))

nd_C_seq2 :: forall t0 t1 t2 t3 t4 t5 t6 . (Curry_Prelude.Curry t6
  , Curry_Prelude.Curry t5, Curry_Prelude.Curry t4, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t6)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t5)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t4)
  -> IDSupply -> Cover -> ConstStore -> Func (Func t6 (Func t5 t4)) (Func
  (C_XmlConv t3 t2 t6) (Func (C_XmlConv t1 t0 t5) (C_XmlConv C_NotRepeatable
  C_NoElem t4)))
nd_C_seq2 x1 x2 x3 s cd cs = wrapDX (wrapDX (wrapNX id)) (acceptCs (acceptCs id)
  (nd_C_seq2_ x1 x2 x3))

nd_C_repSeq2 :: forall t0 t1 t2 t3 t4 . (Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t4) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t3) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t2) -> Func t4 (Func t3 t2)
  -> C_XmlConv C_Repeatable t1 t4 -> C_XmlConv C_Repeatable t0 t3 -> IDSupply
  -> Cover -> ConstStore -> C_XmlConv C_NotRepeatable C_NoElem
  (Curry_Prelude.OP_List t2)
nd_C_repSeq2 x1 x2 x3 x4 x5 x6 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_rep (nd_C_seq2_ x1 x2 x3 x4 x5 x6 s0 cd cs) s1 cd
  cs))

nd_C_eSeq2 :: forall t0 t1 t2 t3 t4 t5 t6 . (Curry_Prelude.Curry t6
  , Curry_Prelude.Curry t5, Curry_Prelude.Curry t4, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t6)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t5)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t4)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func t6 (Func t5 t4)
  -> C_XmlConv t3 t2 t6 -> C_XmlConv t1 t0 t5 -> IDSupply -> Cover -> ConstStore
  -> C_XmlConv C_Repeatable C_Elem t4
nd_C_eSeq2 x1 x2 x3 x4 x5 x6 x7 s cd cs = let s8 = s
  in s8 `seq` (let s7 = leftSupply s8
                   s6 = rightSupply s8
  in s7 `seq` (s6 `seq` nd_C_element x4 (let s5 = leftSupply s6
                                             s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                      s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_seq2 x1 x2 x3 s0 cd cs)
  x5 s1 cd cs)) x6 s3 cd cs)) x7 s5 cd cs)) s7 cd cs))

nd_C_eRepSeq2 :: forall t0 t1 t2 t3 t4 . (Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t4) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t3) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t2) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func t4 (Func t3 t2) -> C_XmlConv C_Repeatable t1 t4
  -> C_XmlConv C_Repeatable t0 t3 -> IDSupply -> Cover -> ConstStore
  -> C_XmlConv C_Repeatable C_Elem (Curry_Prelude.OP_List t2)
nd_C_eRepSeq2 x1 x2 x3 x4 x5 x6 x7 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_element x4 (nd_C_repSeq2 x1 x2 x3 x5 x6 x7 s0 cd
  cs) s1 cd cs))

nd_C_seq3_ :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t10, Curry_Prelude.Curry t9, Curry_Prelude.Curry t8
  , Curry_Prelude.Curry t7, Curry_Prelude.Curry t6, Curry_Prelude.Curry t5
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t3) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t2) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t4) -> Func t3 (Func t2 (Func t1 t4))
  -> C_XmlConv t10 t9 t3 -> C_XmlConv t8 t7 t2 -> C_XmlConv t6 t5 t1 -> IDSupply
  -> Cover -> ConstStore -> C_XmlConv t0 C_NoElem t4
nd_C_seq3_ x1 x2 x3 x4 x5 x6 x7 x8 s cd cs = let s2 = s
  in s2 `seq` (let x9 = let s1 = leftSupply s2
                            s0 = rightSupply s2
                     in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x6
                     s0 cd cs) (wrapNX id
                     (nd_OP_seq3_uscore_dot_uscore_hash_lambda10 x8 x7 x5)) s1
                     cd cs)
  in HO_C_Conv x9 (wrapNX id (nd_OP_seq3_uscore_dot_sh_dot_172 x8 x7 x6 x5)))

d_OP_seq3_uscore_dot_uscore_hash_lambda10 :: forall t0 t1 t2 t3 t4 t5 t6
  t7 . (Curry_Prelude.Curry t5, Curry_Prelude.Curry t4, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t7, Curry_Prelude.Curry t6, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t3) => C_XmlConv t5 t4 t0
  -> C_XmlConv t7 t6 t1 -> (t2 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> t3) -> t2 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t3 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_seq3_uscore_dot_uscore_hash_lambda10 x1 x2 x3 x4 cd cs = d_OP_slash_gt_eq
  (d_C_xmlReads x2 cd cs)
  (d_OP_seq3_uscore_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x4 x1 x3)
  cd cs

nd_OP_seq3_uscore_dot_uscore_hash_lambda10 :: forall t0 t1 t2 t3 t4 t5 t6
  t7 . (Curry_Prelude.Curry t5, Curry_Prelude.Curry t4, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t7, Curry_Prelude.Curry t6, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t3) => C_XmlConv t5 t4 t0
  -> C_XmlConv t7 t6 t1 -> Func t2 (Func t1 (Func t0 t3)) -> t2 -> IDSupply
  -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 t3 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)))
nd_OP_seq3_uscore_dot_uscore_hash_lambda10 x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x2 s0 cd cs) (wrapNX id
  (nd_OP_seq3_uscore_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x4 x1
  x3)) s1 cd cs))

d_OP_seq3_uscore_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 :: forall t0
  t1 t2 t3 t4 t5 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t5
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3) => t2 -> C_XmlConv t5 t4 t0 -> (t2 -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t3)
  -> t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t3
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_seq3_uscore_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x1 x2 x3 x4 cd cs =
  d_OP_slash_gt_eq (d_C_xmlReads x2 cd cs)
  (d_OP_seq3_uscore_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12
  x4 x1 x3) cd cs

nd_OP_seq3_uscore_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 :: forall t0
  t1 t2 t3 t4 t5 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t5
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3) => t2 -> C_XmlConv t5 t4 t0 -> Func t2 (Func t1
  (Func t0 t3)) -> t1 -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 t3 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)))
nd_OP_seq3_uscore_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x1 x2 x3 x4 s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x2 s0 cd cs) (wrapNX id
  (nd_OP_seq3_uscore_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12
  x4 x1 x3)) s1 cd cs))

d_OP_seq3_uscore_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12 :: forall t0
  t1 t2 t3 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t3) => t1 -> t2 -> (t2 -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t3)
  -> t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t3
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_seq3_uscore_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12 x1 x2 x3 x4 cd cs =
  d_C_ret (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply x3 x2 cd cs) x1 cd cs) x4 cd cs)

nd_OP_seq3_uscore_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12 :: forall t0
  t1 t2 t3 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t3) => t1 -> t2 -> Func t2 (Func
  t1 (Func t0 t3)) -> t0 -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 t3 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)))
nd_OP_seq3_uscore_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11_dot_uscore_hash_lambda12 x1 x2 x3 x4 s cd cs =
  let s4 = s
  in s4 `seq` wrapDX id (d_C_ret (let s3 = leftSupply s4
                                      s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x3 x2
  s0 cd cs) x1 s1 cd cs)) x4 s3 cd cs)))

nd_OP_seq3_uscore_dot_sh_dot_172 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8
  t9 . (Curry_Prelude.Curry t5, Curry_Prelude.Curry t4, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t7, Curry_Prelude.Curry t6, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t9, Curry_Prelude.Curry t8, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3) => C_XmlConv t5 t4 t0 -> C_XmlConv t7 t6 t1
  -> C_XmlConv t9 t8 t2 -> Func t2 (Func t1 (Func t0 t3)) -> t3 -> IDSupply
  -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp))
nd_OP_seq3_uscore_dot_sh_dot_172 x1 x2 x3 x4 x5 s cd cs = let s10 = s
  in s10 `seq` (let s11 = leftSupply s10
                    s12 = rightSupply s10
                    s0 = leftSupply s11
                    s1 = rightSupply s11
                    s2 = leftSupply s12
                    s9 = rightSupply s12
  in s11 `seq` (s12 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s9 `seq`
  (let x6 = generate s0 cd
       x7 = generate s1 cd
       x8 = generate s2 cd
  in let s8 = leftSupply s9
         s7 = rightSupply s9
  in s8 `seq` (s7 `seq` nd_C__case_3 x5 x8 x7 x6 x4 x1 x2 x3
  (Curry_Prelude.d_OP_eq_colon_lt_eq (let s6 = leftSupply s7
                                          s5 = rightSupply s7
  in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                      s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x4 x6
  s3 cd cs) x7 s4 cd cs)) x8 s6 cd cs)) x5 cd cs) s8 cd cs))))))))

nd_C_seq3 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 t9 . (Curry_Prelude.Curry t9
  , Curry_Prelude.Curry t8, Curry_Prelude.Curry t7, Curry_Prelude.Curry t6
  , Curry_Prelude.Curry t5, Curry_Prelude.Curry t4, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t9)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t8)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t7)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t6)
  -> IDSupply -> Cover -> ConstStore -> Func (Func t9 (Func t8 (Func t7 t6)))
  (Func (C_XmlConv t5 t4 t9) (Func (C_XmlConv t3 t2 t8) (Func (C_XmlConv t1 t0
  t7) (C_XmlConv C_NotRepeatable C_NoElem t6))))
nd_C_seq3 x1 x2 x3 x4 s cd cs = wrapDX (wrapDX (wrapDX (wrapNX id))) (acceptCs
  (acceptCs (acceptCs id)) (nd_C_seq3_ x1 x2 x3 x4))

nd_C_repSeq3 :: forall t0 t1 t2 t3 t4 t5 t6 . (Curry_Prelude.Curry t6
  , Curry_Prelude.Curry t5, Curry_Prelude.Curry t4, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t6)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t5)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t4)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t3)
  -> Func t6 (Func t5 (Func t4 t3)) -> C_XmlConv C_Repeatable t2 t6 -> C_XmlConv
  C_Repeatable t1 t5 -> C_XmlConv C_Repeatable t0 t4 -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv C_NotRepeatable C_NoElem (Curry_Prelude.OP_List t3)
nd_C_repSeq3 x1 x2 x3 x4 x5 x6 x7 x8 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_rep (nd_C_seq3_ x1 x2 x3 x4 x5 x6 x7 x8 s0 cd cs)
  s1 cd cs))

nd_C_eSeq3 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 t9 . (Curry_Prelude.Curry t9
  , Curry_Prelude.Curry t8, Curry_Prelude.Curry t7, Curry_Prelude.Curry t6
  , Curry_Prelude.Curry t5, Curry_Prelude.Curry t4, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t9)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t8)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t7)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t6)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func t9 (Func t8 (Func t7
  t6)) -> C_XmlConv t5 t4 t9 -> C_XmlConv t3 t2 t8 -> C_XmlConv t1 t0 t7
  -> IDSupply -> Cover -> ConstStore -> C_XmlConv C_Repeatable C_Elem t6
nd_C_eSeq3 x1 x2 x3 x4 x5 x6 x7 x8 x9 s cd cs = let s10 = s
  in s10 `seq` (let s9 = leftSupply s10
                    s8 = rightSupply s10
  in s9 `seq` (s8 `seq` nd_C_element x5 (let s7 = leftSupply s8
                                             s6 = rightSupply s8
  in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                      s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                      s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_seq3 x1 x2 x3 x4 s0 cd
  cs) x6 s1 cd cs)) x7 s3 cd cs)) x8 s5 cd cs)) x9 s7 cd cs)) s9 cd cs))

nd_C_eRepSeq3 :: forall t0 t1 t2 t3 t4 t5 t6 . (Curry_Prelude.Curry t6
  , Curry_Prelude.Curry t5, Curry_Prelude.Curry t4, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t6)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t5)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t4)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t3)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func t6 (Func t5 (Func t4
  t3)) -> C_XmlConv C_Repeatable t2 t6 -> C_XmlConv C_Repeatable t1 t5
  -> C_XmlConv C_Repeatable t0 t4 -> IDSupply -> Cover -> ConstStore
  -> C_XmlConv C_Repeatable C_Elem (Curry_Prelude.OP_List t3)
nd_C_eRepSeq3 x1 x2 x3 x4 x5 x6 x7 x8 x9 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_element x5 (nd_C_repSeq3 x1 x2 x3 x4 x6 x7 x8 x9 s0
  cd cs) s1 cd cs))

nd_C_seq4_ :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12
  t13 . (Curry_Prelude.Curry t4, Curry_Prelude.Curry t3, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t5, Curry_Prelude.Curry t13
  , Curry_Prelude.Curry t12, Curry_Prelude.Curry t11, Curry_Prelude.Curry t10
  , Curry_Prelude.Curry t9, Curry_Prelude.Curry t8, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t6, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t4) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t3) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t2) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t5) -> Func t4
  (Func t3 (Func t2 (Func t1 t5))) -> C_XmlConv t13 t12 t4 -> C_XmlConv t11 t10
  t3 -> C_XmlConv t9 t8 t2 -> C_XmlConv t7 t6 t1 -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv t0 C_NoElem t5
nd_C_seq4_ x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 s cd cs = let s2 = s
  in s2 `seq` (let x11 = let s1 = leftSupply s2
                             s0 = rightSupply s2
                     in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x7
                     s0 cd cs) (wrapNX id
                     (nd_OP_seq4_uscore_dot_uscore_hash_lambda13 x10 x9 x8 x6))
                     s1 cd cs)
  in HO_C_Conv x11 (wrapNX id (nd_OP_seq4_uscore_dot_sh_dot_188 x10 x9 x8 x7
  x6)))

d_OP_seq4_uscore_dot_uscore_hash_lambda13 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8
  t9 t10 . (Curry_Prelude.Curry t6, Curry_Prelude.Curry t5, Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t8, Curry_Prelude.Curry t7, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t10, Curry_Prelude.Curry t9, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t4) => C_XmlConv t6 t5 t0
  -> C_XmlConv t8 t7 t1 -> C_XmlConv t10 t9 t2 -> (t3 -> Cover -> ConstStore
  -> t2 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> t4) -> t3 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t4 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp))
d_OP_seq4_uscore_dot_uscore_hash_lambda13 x1 x2 x3 x4 x5 cd cs =
  d_OP_slash_gt_eq (d_C_xmlReads x3 cd cs)
  (d_OP_seq4_uscore_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14 x5 x1 x2
  x4) cd cs

nd_OP_seq4_uscore_dot_uscore_hash_lambda13 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8
  t9 t10 . (Curry_Prelude.Curry t6, Curry_Prelude.Curry t5, Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t8, Curry_Prelude.Curry t7, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t10, Curry_Prelude.Curry t9, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t4) => C_XmlConv t6 t5 t0
  -> C_XmlConv t8 t7 t1 -> C_XmlConv t10 t9 t2 -> Func t3 (Func t2 (Func t1
  (Func t0 t4))) -> t3 -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 t4 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)))
nd_OP_seq4_uscore_dot_uscore_hash_lambda13 x1 x2 x3 x4 x5 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x3 s0 cd cs) (wrapNX id
  (nd_OP_seq4_uscore_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14 x5 x1 x2
  x4)) s1 cd cs))

d_OP_seq4_uscore_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14 :: forall t0
  t1 t2 t3 t4 t5 t6 t7 t8 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry t6
  , Curry_Prelude.Curry t5, Curry_Prelude.Curry t0, Curry_Prelude.Curry t8
  , Curry_Prelude.Curry t7, Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t4) => t3 -> C_XmlConv t6 t5 t0 -> C_XmlConv t8 t7 t1
  -> (t3 -> Cover -> ConstStore -> t2 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> t4) -> t2 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t4 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_seq4_uscore_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14 x1 x2 x3 x4 x5 cd cs =
  d_OP_slash_gt_eq (d_C_xmlReads x3 cd cs)
  (d_OP_seq4_uscore_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15
  x5 x1 x2 x4) cd cs

nd_OP_seq4_uscore_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14 :: forall t0
  t1 t2 t3 t4 t5 t6 t7 t8 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry t6
  , Curry_Prelude.Curry t5, Curry_Prelude.Curry t0, Curry_Prelude.Curry t8
  , Curry_Prelude.Curry t7, Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t4) => t3 -> C_XmlConv t6 t5 t0 -> C_XmlConv t8 t7 t1
  -> Func t3 (Func t2 (Func t1 (Func t0 t4))) -> t2 -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 t4 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)))
nd_OP_seq4_uscore_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14 x1 x2 x3 x4 x5 s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x3 s0 cd cs) (wrapNX id
  (nd_OP_seq4_uscore_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15
  x5 x1 x2 x4)) s1 cd cs))

d_OP_seq4_uscore_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15 :: forall t0
  t1 t2 t3 t4 t5 t6 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t6, Curry_Prelude.Curry t5, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t4) => t2 -> t3 -> C_XmlConv t6
  t5 t0 -> (t3 -> Cover -> ConstStore -> t2 -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t4) -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t4
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_seq4_uscore_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15 x1 x2 x3 x4 x5 cd cs =
  d_OP_slash_gt_eq (d_C_xmlReads x3 cd cs)
  (d_OP_seq4_uscore_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_lambda16
  x5 x1 x2 x4) cd cs

nd_OP_seq4_uscore_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15 :: forall t0
  t1 t2 t3 t4 t5 t6 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t6, Curry_Prelude.Curry t5, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t4) => t2 -> t3 -> C_XmlConv t6
  t5 t0 -> Func t3 (Func t2 (Func t1 (Func t0 t4))) -> t1 -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 t4 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)))
nd_OP_seq4_uscore_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15 x1 x2 x3 x4 x5 s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x3 s0 cd cs) (wrapNX id
  (nd_OP_seq4_uscore_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_lambda16
  x5 x1 x2 x4)) s1 cd cs))

d_OP_seq4_uscore_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_lambda16 :: forall t0
  t1 t2 t3 t4 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t4) => t1 -> t2 -> t3 -> (t3 -> Cover -> ConstStore -> t2 -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t4)
  -> t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t4
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_seq4_uscore_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_lambda16 x1 x2 x3 x4 x5 cd cs =
  d_C_ret (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x4 x3 cd cs) x2 cd cs) x1 cd
  cs) x5 cd cs)

nd_OP_seq4_uscore_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_lambda16 :: forall t0
  t1 t2 t3 t4 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t4) => t1 -> t2 -> t3 -> Func t3 (Func t2 (Func t1 (Func t0 t4))) -> t0
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 t4
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp)))
nd_OP_seq4_uscore_dot_uscore_hash_lambda13_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15_dot_uscore_hash_lambda16 x1 x2 x3 x4 x5 s cd cs =
  let s6 = s
  in s6 `seq` wrapDX id (d_C_ret (let s5 = leftSupply s6
                                      s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                      s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x4 x3
  s0 cd cs) x2 s1 cd cs)) x1 s3 cd cs)) x5 s5 cd cs)))

nd_OP_seq4_uscore_dot_sh_dot_188 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11
  t12 . (Curry_Prelude.Curry t6, Curry_Prelude.Curry t5, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t8, Curry_Prelude.Curry t7, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t10, Curry_Prelude.Curry t9, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t12, Curry_Prelude.Curry t11, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t4) => C_XmlConv t6 t5 t0 -> C_XmlConv t8 t7 t1
  -> C_XmlConv t10 t9 t2 -> C_XmlConv t12 t11 t3 -> Func t3 (Func t2 (Func t1
  (Func t0 t4))) -> t4 -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
nd_OP_seq4_uscore_dot_sh_dot_188 x1 x2 x3 x4 x5 x6 s cd cs = let s13 = s
  in s13 `seq` (let s14 = leftSupply s13
                    s15 = rightSupply s13
                    s0 = leftSupply s14
                    s1 = rightSupply s14
                    s2 = leftSupply s15
                    s16 = rightSupply s15
                    s3 = leftSupply s16
                    s12 = rightSupply s16
  in s14 `seq` (s15 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s16 `seq` (s3 `seq`
  (s12 `seq` (let x7 = generate s0 cd
                  x8 = generate s1 cd
                  x9 = generate s2 cd
                  x10 = generate s3 cd
  in let s11 = leftSupply s12
         s10 = rightSupply s12
  in s11 `seq` (s10 `seq` nd_C__case_2 x6 x10 x9 x8 x7 x5 x1 x2 x3 x4
  (Curry_Prelude.d_OP_eq_colon_lt_eq (let s9 = leftSupply s10
                                          s8 = rightSupply s10
  in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (let s7 = leftSupply s8
                                                      s6 = rightSupply s8
  in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                      s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x5 x7
  s4 cd cs) x8 s5 cd cs)) x9 s7 cd cs)) x10 s9 cd cs)) x6 cd cs) s11 cd
  cs))))))))))

nd_C_seq4 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11
  t12 . (Curry_Prelude.Curry t12, Curry_Prelude.Curry t11, Curry_Prelude.Curry
  t10, Curry_Prelude.Curry t9, Curry_Prelude.Curry t8, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t6, Curry_Prelude.Curry t5, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t12) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t11) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t10) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t9) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t8) -> IDSupply -> Cover -> ConstStore
  -> Func (Func t12 (Func t11 (Func t10 (Func t9 t8)))) (Func (C_XmlConv t7 t6
  t12) (Func (C_XmlConv t5 t4 t11) (Func (C_XmlConv t3 t2 t10) (Func (C_XmlConv
  t1 t0 t9) (C_XmlConv C_NotRepeatable C_NoElem t8)))))
nd_C_seq4 x1 x2 x3 x4 x5 s cd cs = wrapDX (wrapDX (wrapDX (wrapDX (wrapNX id))))
  (acceptCs (acceptCs (acceptCs (acceptCs id))) (nd_C_seq4_ x1 x2 x3 x4 x5))

nd_C_repSeq4 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 . (Curry_Prelude.Curry t8
  , Curry_Prelude.Curry t7, Curry_Prelude.Curry t6, Curry_Prelude.Curry t5
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t3, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t8) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t7) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t6) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t5) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t4) -> Func t8
  (Func t7 (Func t6 (Func t5 t4))) -> C_XmlConv C_Repeatable t3 t8 -> C_XmlConv
  C_Repeatable t2 t7 -> C_XmlConv C_Repeatable t1 t6 -> C_XmlConv C_Repeatable
  t0 t5 -> IDSupply -> Cover -> ConstStore -> C_XmlConv C_NotRepeatable C_NoElem
  (Curry_Prelude.OP_List t4)
nd_C_repSeq4 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_rep (nd_C_seq4_ x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 s0
  cd cs) s1 cd cs))

nd_C_eSeq4 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11
  t12 . (Curry_Prelude.Curry t12, Curry_Prelude.Curry t11, Curry_Prelude.Curry
  t10, Curry_Prelude.Curry t9, Curry_Prelude.Curry t8, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t6, Curry_Prelude.Curry t5, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t12) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t11) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t10) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t9) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t8) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func t12 (Func t11 (Func t10 (Func t9 t8)))
  -> C_XmlConv t7 t6 t12 -> C_XmlConv t5 t4 t11 -> C_XmlConv t3 t2 t10
  -> C_XmlConv t1 t0 t9 -> IDSupply -> Cover -> ConstStore -> C_XmlConv
  C_Repeatable C_Elem t8
nd_C_eSeq4 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 s cd cs = let s12 = s
  in s12 `seq` (let s11 = leftSupply s12
                    s10 = rightSupply s12
  in s11 `seq` (s10 `seq` nd_C_element x6 (let s9 = leftSupply s10
                                               s8 = rightSupply s10
  in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (let s7 = leftSupply s8
                                                      s6 = rightSupply s8
  in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                      s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                      s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_seq4 x1 x2 x3 x4 x5 s0 cd
  cs) x7 s1 cd cs)) x8 s3 cd cs)) x9 s5 cd cs)) x10 s7 cd cs)) x11 s9 cd cs))
  s11 cd cs))

nd_C_eRepSeq4 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 . (Curry_Prelude.Curry t8
  , Curry_Prelude.Curry t7, Curry_Prelude.Curry t6, Curry_Prelude.Curry t5
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t3, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t8) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t7) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t6) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t5) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t4)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func t8 (Func t7 (Func t6
  (Func t5 t4))) -> C_XmlConv C_Repeatable t3 t8 -> C_XmlConv C_Repeatable t2 t7
  -> C_XmlConv C_Repeatable t1 t6 -> C_XmlConv C_Repeatable t0 t5 -> IDSupply
  -> Cover -> ConstStore -> C_XmlConv C_Repeatable C_Elem (Curry_Prelude.OP_List
  t4)
nd_C_eRepSeq4 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_element x6 (nd_C_repSeq4 x1 x2 x3 x4 x5 x7 x8 x9
  x10 x11 s0 cd cs) s1 cd cs))

nd_C_seq5_ :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15
  t16 . (Curry_Prelude.Curry t5, Curry_Prelude.Curry t4, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry t6
  , Curry_Prelude.Curry t16, Curry_Prelude.Curry t15, Curry_Prelude.Curry t14
  , Curry_Prelude.Curry t13, Curry_Prelude.Curry t12, Curry_Prelude.Curry t11
  , Curry_Prelude.Curry t10, Curry_Prelude.Curry t9, Curry_Prelude.Curry t8
  , Curry_Prelude.Curry t7, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t5) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t4) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t3) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t2) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t6) -> Func t5
  (Func t4 (Func t3 (Func t2 (Func t1 t6)))) -> C_XmlConv t16 t15 t5
  -> C_XmlConv t14 t13 t4 -> C_XmlConv t12 t11 t3 -> C_XmlConv t10 t9 t2
  -> C_XmlConv t8 t7 t1 -> IDSupply -> Cover -> ConstStore -> C_XmlConv t0
  C_NoElem t6
nd_C_seq5_ x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 s cd cs = let s2 = s
  in s2 `seq` (let x13 = let s1 = leftSupply s2
                             s0 = rightSupply s2
                     in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x8
                     s0 cd cs) (wrapNX id
                     (nd_OP_seq5_uscore_dot_uscore_hash_lambda17 x12 x11 x10 x9
                     x7)) s1 cd cs)
  in HO_C_Conv x13 (wrapNX id (nd_OP_seq5_uscore_dot_sh_dot_205 x12 x11 x10 x9
  x8 x7)))

d_OP_seq5_uscore_dot_uscore_hash_lambda17 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8
  t9 t10 t11 t12 t13 . (Curry_Prelude.Curry t7, Curry_Prelude.Curry t6
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t9, Curry_Prelude.Curry t8
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t11, Curry_Prelude.Curry t10
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t13, Curry_Prelude.Curry t12
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t4, Curry_Prelude.Curry
  t5) => C_XmlConv t7 t6 t0 -> C_XmlConv t9 t8 t1 -> C_XmlConv t11 t10 t2
  -> C_XmlConv t13 t12 t3 -> (t4 -> Cover -> ConstStore -> t3 -> Cover
  -> ConstStore -> t2 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0
  -> Cover -> ConstStore -> t5) -> t4 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t5 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_seq5_uscore_dot_uscore_hash_lambda17 x1 x2 x3 x4 x5 x6 cd cs =
  d_OP_slash_gt_eq (d_C_xmlReads x4 cd cs)
  (d_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18 x6 x1 x2
  x3 x5) cd cs

nd_OP_seq5_uscore_dot_uscore_hash_lambda17 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8
  t9 t10 t11 t12 t13 . (Curry_Prelude.Curry t7, Curry_Prelude.Curry t6
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t9, Curry_Prelude.Curry t8
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t11, Curry_Prelude.Curry t10
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t13, Curry_Prelude.Curry t12
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t4, Curry_Prelude.Curry
  t5) => C_XmlConv t7 t6 t0 -> C_XmlConv t9 t8 t1 -> C_XmlConv t11 t10 t2
  -> C_XmlConv t13 t12 t3 -> Func t4 (Func t3 (Func t2 (Func t1 (Func t0 t5))))
  -> t4 -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 t5
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp)))
nd_OP_seq5_uscore_dot_uscore_hash_lambda17 x1 x2 x3 x4 x5 x6 s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x4 s0 cd cs) (wrapNX id
  (nd_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18 x6 x1 x2
  x3 x5)) s1 cd cs))

d_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18 :: forall t0
  t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 . (Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t7, Curry_Prelude.Curry t6, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t9, Curry_Prelude.Curry t8, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t11, Curry_Prelude.Curry t10, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t5) => t4 -> C_XmlConv t7 t6 t0
  -> C_XmlConv t9 t8 t1 -> C_XmlConv t11 t10 t2 -> (t4 -> Cover -> ConstStore
  -> t3 -> Cover -> ConstStore -> t2 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> t5) -> t3 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t5 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18 x1 x2 x3 x4 x5 x6 cd cs =
  d_OP_slash_gt_eq (d_C_xmlReads x4 cd cs)
  (d_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19
  x6 x1 x2 x3 x5) cd cs

nd_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18 :: forall t0
  t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 . (Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t7, Curry_Prelude.Curry t6, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t9, Curry_Prelude.Curry t8, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t11, Curry_Prelude.Curry t10, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t5) => t4 -> C_XmlConv t7 t6 t0
  -> C_XmlConv t9 t8 t1 -> C_XmlConv t11 t10 t2 -> Func t4 (Func t3 (Func t2
  (Func t1 (Func t0 t5)))) -> t3 -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 t5 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)))
nd_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18 x1 x2 x3 x4 x5 x6 s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x4 s0 cd cs) (wrapNX id
  (nd_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19
  x6 x1 x2 x3 x5)) s1 cd cs))

d_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 :: forall t0
  t1 t2 t3 t4 t5 t6 t7 t8 t9 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t7, Curry_Prelude.Curry t6, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t9, Curry_Prelude.Curry t8, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t5) => t3 -> t4 -> C_XmlConv t7
  t6 t0 -> C_XmlConv t9 t8 t1 -> (t4 -> Cover -> ConstStore -> t3 -> Cover
  -> ConstStore -> t2 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0
  -> Cover -> ConstStore -> t5) -> t2 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t5 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 x1 x2 x3 x4 x5 x6 cd cs =
  d_OP_slash_gt_eq (d_C_xmlReads x4 cd cs)
  (d_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19_dot_uscore_hash_lambda20
  x6 x1 x2 x3 x5) cd cs

nd_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 :: forall t0
  t1 t2 t3 t4 t5 t6 t7 t8 t9 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t7, Curry_Prelude.Curry t6, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t9, Curry_Prelude.Curry t8, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t5) => t3 -> t4 -> C_XmlConv t7
  t6 t0 -> C_XmlConv t9 t8 t1 -> Func t4 (Func t3 (Func t2 (Func t1 (Func t0
  t5)))) -> t2 -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 t5 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)))
nd_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 x1 x2 x3 x4 x5 x6 s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x4 s0 cd cs) (wrapNX id
  (nd_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19_dot_uscore_hash_lambda20
  x6 x1 x2 x3 x5)) s1 cd cs))

d_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19_dot_uscore_hash_lambda20 :: forall t0
  t1 t2 t3 t4 t5 t6 t7 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t7, Curry_Prelude.Curry t6
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t5) => t2 -> t3 -> t4 -> C_XmlConv t7 t6 t0 -> (t4 -> Cover -> ConstStore
  -> t3 -> Cover -> ConstStore -> t2 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> t5) -> t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t5 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19_dot_uscore_hash_lambda20 x1 x2 x3 x4 x5 x6 cd cs =
  d_OP_slash_gt_eq (d_C_xmlReads x4 cd cs)
  (d_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19_dot_uscore_hash_lambda20_dot_uscore_hash_lambda21
  x6 x1 x2 x3 x5) cd cs

nd_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19_dot_uscore_hash_lambda20 :: forall t0
  t1 t2 t3 t4 t5 t6 t7 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t7, Curry_Prelude.Curry t6
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t5) => t2 -> t3 -> t4 -> C_XmlConv t7 t6 t0 -> Func t4 (Func t3 (Func t2 (Func
  t1 (Func t0 t5)))) -> t1 -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 t5 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)))
nd_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19_dot_uscore_hash_lambda20 x1 x2 x3 x4 x5 x6 s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x4 s0 cd cs) (wrapNX id
  (nd_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19_dot_uscore_hash_lambda20_dot_uscore_hash_lambda21
  x6 x1 x2 x3 x5)) s1 cd cs))

d_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19_dot_uscore_hash_lambda20_dot_uscore_hash_lambda21 :: forall t0
  t1 t2 t3 t4 t5 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t4, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t5) => t1 -> t2 -> t3 -> t4 -> (t4 -> Cover
  -> ConstStore -> t3 -> Cover -> ConstStore -> t2 -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t5) -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t5
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19_dot_uscore_hash_lambda20_dot_uscore_hash_lambda21 x1 x2 x3 x4 x5 x6 cd cs =
  d_C_ret (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x5
  x4 cd cs) x3 cd cs) x2 cd cs) x1 cd cs) x6 cd cs)

nd_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19_dot_uscore_hash_lambda20_dot_uscore_hash_lambda21 :: forall t0
  t1 t2 t3 t4 t5 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t4, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t5) => t1 -> t2 -> t3 -> t4 -> Func t4 (Func t3 (Func t2
  (Func t1 (Func t0 t5)))) -> t0 -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 t5 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)))
nd_OP_seq5_uscore_dot_uscore_hash_lambda17_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19_dot_uscore_hash_lambda20_dot_uscore_hash_lambda21 x1 x2 x3 x4 x5 x6 s cd cs =
  let s8 = s
  in s8 `seq` wrapDX id (d_C_ret (let s7 = leftSupply s8
                                      s6 = rightSupply s8
  in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                      s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                      s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x5 x4
  s0 cd cs) x3 s1 cd cs)) x2 s3 cd cs)) x1 s5 cd cs)) x6 s7 cd cs)))

nd_OP_seq5_uscore_dot_sh_dot_205 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11
  t12 t13 t14 t15 . (Curry_Prelude.Curry t7, Curry_Prelude.Curry t6
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t9, Curry_Prelude.Curry t8
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t11, Curry_Prelude.Curry t10
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t13, Curry_Prelude.Curry t12
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t15, Curry_Prelude.Curry t14
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t5) => C_XmlConv t7 t6 t0
  -> C_XmlConv t9 t8 t1 -> C_XmlConv t11 t10 t2 -> C_XmlConv t13 t12 t3
  -> C_XmlConv t15 t14 t4 -> Func t4 (Func t3 (Func t2 (Func t1 (Func t0 t5))))
  -> t5 -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
nd_OP_seq5_uscore_dot_sh_dot_205 x1 x2 x3 x4 x5 x6 x7 s cd cs = let s16 = s
  in s16 `seq` (let s17 = leftSupply s16
                    s19 = rightSupply s16
                    s0 = leftSupply s17
                    s18 = rightSupply s17
                    s1 = leftSupply s18
                    s2 = rightSupply s18
                    s3 = leftSupply s19
                    s20 = rightSupply s19
                    s4 = leftSupply s20
                    s15 = rightSupply s20
  in s17 `seq` (s19 `seq` (s0 `seq` (s18 `seq` (s1 `seq` (s2 `seq` (s3 `seq`
  (s20 `seq` (s4 `seq` (s15 `seq` (let x8 = generate s0 cd
                                       x9 = generate s1 cd
                                       x10 = generate s2 cd
                                       x11 = generate s3 cd
                                       x12 = generate s4 cd
  in let s14 = leftSupply s15
         s13 = rightSupply s15
  in s14 `seq` (s13 `seq` nd_C__case_1 x7 x12 x11 x10 x9 x8 x6 x1 x2 x3 x4 x5
  (Curry_Prelude.d_OP_eq_colon_lt_eq (let s12 = leftSupply s13
                                          s11 = rightSupply s13
  in s12 `seq` (s11 `seq` Curry_Prelude.nd_C_apply (let s10 = leftSupply s11
                                                        s9 = rightSupply s11
  in s10 `seq` (s9 `seq` Curry_Prelude.nd_C_apply (let s8 = leftSupply s9
                                                       s7 = rightSupply s9
  in s8 `seq` (s7 `seq` Curry_Prelude.nd_C_apply (let s6 = leftSupply s7
                                                      s5 = rightSupply s7
  in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x6 x8
  s5 cd cs) x9 s6 cd cs)) x10 s8 cd cs)) x11 s10 cd cs)) x12 s12 cd cs)) x7 cd
  cs) s14 cd cs))))))))))))

nd_C_seq5 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14
  t15 . (Curry_Prelude.Curry t15, Curry_Prelude.Curry t14, Curry_Prelude.Curry
  t13, Curry_Prelude.Curry t12, Curry_Prelude.Curry t11, Curry_Prelude.Curry t10
  , Curry_Prelude.Curry t9, Curry_Prelude.Curry t8, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t6, Curry_Prelude.Curry t5, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t15) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t14) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t13) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t12) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t11) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t10) -> IDSupply -> Cover
  -> ConstStore -> Func (Func t15 (Func t14 (Func t13 (Func t12 (Func t11
  t10))))) (Func (C_XmlConv t9 t8 t15) (Func (C_XmlConv t7 t6 t14) (Func
  (C_XmlConv t5 t4 t13) (Func (C_XmlConv t3 t2 t12) (Func (C_XmlConv t1 t0 t11)
  (C_XmlConv C_NotRepeatable C_NoElem t10))))))
nd_C_seq5 x1 x2 x3 x4 x5 x6 s cd cs = wrapDX (wrapDX (wrapDX (wrapDX (wrapDX
  (wrapNX id))))) (acceptCs (acceptCs (acceptCs (acceptCs (acceptCs id))))
  (nd_C_seq5_ x1 x2 x3 x4 x5 x6))

nd_C_repSeq5 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 . (Curry_Prelude.Curry
  t10, Curry_Prelude.Curry t9, Curry_Prelude.Curry t8, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t6, Curry_Prelude.Curry t5, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t10) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t9) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t8) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t7) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t6) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t5) -> Func t10 (Func t9 (Func t8
  (Func t7 (Func t6 t5)))) -> C_XmlConv C_Repeatable t4 t10 -> C_XmlConv
  C_Repeatable t3 t9 -> C_XmlConv C_Repeatable t2 t8 -> C_XmlConv C_Repeatable
  t1 t7 -> C_XmlConv C_Repeatable t0 t6 -> IDSupply -> Cover -> ConstStore
  -> C_XmlConv C_NotRepeatable C_NoElem (Curry_Prelude.OP_List t5)
nd_C_repSeq5 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_rep (nd_C_seq5_ x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11
  x12 s0 cd cs) s1 cd cs))

nd_C_eSeq5 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14
  t15 . (Curry_Prelude.Curry t15, Curry_Prelude.Curry t14, Curry_Prelude.Curry
  t13, Curry_Prelude.Curry t12, Curry_Prelude.Curry t11, Curry_Prelude.Curry t10
  , Curry_Prelude.Curry t9, Curry_Prelude.Curry t8, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t6, Curry_Prelude.Curry t5, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t15) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t14) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t13) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t12) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t11) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t10) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func t15 (Func t14 (Func t13 (Func t12 (Func t11
  t10)))) -> C_XmlConv t9 t8 t15 -> C_XmlConv t7 t6 t14 -> C_XmlConv t5 t4 t13
  -> C_XmlConv t3 t2 t12 -> C_XmlConv t1 t0 t11 -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv C_Repeatable C_Elem t10
nd_C_eSeq5 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 s cd cs = let s14 = s
  in s14 `seq` (let s13 = leftSupply s14
                    s12 = rightSupply s14
  in s13 `seq` (s12 `seq` nd_C_element x7 (let s11 = leftSupply s12
                                               s10 = rightSupply s12
  in s11 `seq` (s10 `seq` Curry_Prelude.nd_C_apply (let s9 = leftSupply s10
                                                        s8 = rightSupply s10
  in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (let s7 = leftSupply s8
                                                      s6 = rightSupply s8
  in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                      s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                      s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_seq5 x1 x2 x3 x4 x5 x6 s0
  cd cs) x8 s1 cd cs)) x9 s3 cd cs)) x10 s5 cd cs)) x11 s7 cd cs)) x12 s9 cd
  cs)) x13 s11 cd cs)) s13 cd cs))

nd_C_eRepSeq5 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 . (Curry_Prelude.Curry
  t10, Curry_Prelude.Curry t9, Curry_Prelude.Curry t8, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t6, Curry_Prelude.Curry t5, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t10) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t9) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t8) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t7) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t6) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t5) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func t10 (Func t9 (Func t8 (Func t7 (Func t6 t5))))
  -> C_XmlConv C_Repeatable t4 t10 -> C_XmlConv C_Repeatable t3 t9 -> C_XmlConv
  C_Repeatable t2 t8 -> C_XmlConv C_Repeatable t1 t7 -> C_XmlConv C_Repeatable
  t0 t6 -> IDSupply -> Cover -> ConstStore -> C_XmlConv C_Repeatable C_Elem
  (Curry_Prelude.OP_List t5)
nd_C_eRepSeq5 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_element x7 (nd_C_repSeq5 x1 x2 x3 x4 x5 x6 x8 x9
  x10 x11 x12 x13 s0 cd cs) s1 cd cs))

nd_C_seq6_ :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16
  t17 t18 t19 . (Curry_Prelude.Curry t6, Curry_Prelude.Curry t5
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t3, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t7, Curry_Prelude.Curry t19
  , Curry_Prelude.Curry t18, Curry_Prelude.Curry t17, Curry_Prelude.Curry t16
  , Curry_Prelude.Curry t15, Curry_Prelude.Curry t14, Curry_Prelude.Curry t13
  , Curry_Prelude.Curry t12, Curry_Prelude.Curry t11, Curry_Prelude.Curry t10
  , Curry_Prelude.Curry t9, Curry_Prelude.Curry t8, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t6)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t5)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t4)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t3)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t2)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t7)
  -> Func t6 (Func t5 (Func t4 (Func t3 (Func t2 (Func t1 t7))))) -> C_XmlConv
  t19 t18 t6 -> C_XmlConv t17 t16 t5 -> C_XmlConv t15 t14 t4 -> C_XmlConv t13
  t12 t3 -> C_XmlConv t11 t10 t2 -> C_XmlConv t9 t8 t1 -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv t0 C_NoElem t7
nd_C_seq6_ x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 s cd cs = let s2 = s
  in s2 `seq` (let x15 = let s1 = leftSupply s2
                             s0 = rightSupply s2
                     in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x9
                     s0 cd cs) (wrapNX id
                     (nd_OP_seq6_uscore_dot_uscore_hash_lambda22 x14 x13 x12 x11
                     x10 x8)) s1 cd cs)
  in HO_C_Conv x15 (wrapNX id (nd_OP_seq6_uscore_dot_sh_dot_223 x14 x13 x12 x11
  x10 x9 x8)))

d_OP_seq6_uscore_dot_uscore_hash_lambda22 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8
  t9 t10 t11 t12 t13 t14 t15 t16 . (Curry_Prelude.Curry t8, Curry_Prelude.Curry
  t7, Curry_Prelude.Curry t0, Curry_Prelude.Curry t10, Curry_Prelude.Curry t9
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t12, Curry_Prelude.Curry t11
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t14, Curry_Prelude.Curry t13
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t16, Curry_Prelude.Curry t15
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t5, Curry_Prelude.Curry
  t6) => C_XmlConv t8 t7 t0 -> C_XmlConv t10 t9 t1 -> C_XmlConv t12 t11 t2
  -> C_XmlConv t14 t13 t3 -> C_XmlConv t16 t15 t4 -> (t5 -> Cover -> ConstStore
  -> t4 -> Cover -> ConstStore -> t3 -> Cover -> ConstStore -> t2 -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t6)
  -> t5 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t6
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_seq6_uscore_dot_uscore_hash_lambda22 x1 x2 x3 x4 x5 x6 x7 cd cs =
  d_OP_slash_gt_eq (d_C_xmlReads x5 cd cs)
  (d_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23 x7 x1 x2
  x3 x4 x6) cd cs

nd_OP_seq6_uscore_dot_uscore_hash_lambda22 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8
  t9 t10 t11 t12 t13 t14 t15 t16 . (Curry_Prelude.Curry t8, Curry_Prelude.Curry
  t7, Curry_Prelude.Curry t0, Curry_Prelude.Curry t10, Curry_Prelude.Curry t9
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t12, Curry_Prelude.Curry t11
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t14, Curry_Prelude.Curry t13
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t16, Curry_Prelude.Curry t15
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t5, Curry_Prelude.Curry
  t6) => C_XmlConv t8 t7 t0 -> C_XmlConv t10 t9 t1 -> C_XmlConv t12 t11 t2
  -> C_XmlConv t14 t13 t3 -> C_XmlConv t16 t15 t4 -> Func t5 (Func t4 (Func t3
  (Func t2 (Func t1 (Func t0 t6))))) -> t5 -> IDSupply -> Cover -> ConstStore
  -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 t6 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)))
nd_OP_seq6_uscore_dot_uscore_hash_lambda22 x1 x2 x3 x4 x5 x6 x7 s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x5 s0 cd cs) (wrapNX id
  (nd_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23 x7 x1 x2
  x3 x4 x6)) s1 cd cs))

d_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23 :: forall t0
  t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 . (Curry_Prelude.Curry t5
  , Curry_Prelude.Curry t8, Curry_Prelude.Curry t7, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t10, Curry_Prelude.Curry t9, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t12, Curry_Prelude.Curry t11, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t14, Curry_Prelude.Curry t13, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t6) => t5 -> C_XmlConv t8 t7 t0
  -> C_XmlConv t10 t9 t1 -> C_XmlConv t12 t11 t2 -> C_XmlConv t14 t13 t3 -> (t5
  -> Cover -> ConstStore -> t4 -> Cover -> ConstStore -> t3 -> Cover
  -> ConstStore -> t2 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0
  -> Cover -> ConstStore -> t6) -> t4 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t6 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23 x1 x2 x3 x4 x5 x6 x7 cd cs =
  d_OP_slash_gt_eq (d_C_xmlReads x5 cd cs)
  (d_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24
  x7 x1 x2 x3 x4 x6) cd cs

nd_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23 :: forall t0
  t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 . (Curry_Prelude.Curry t5
  , Curry_Prelude.Curry t8, Curry_Prelude.Curry t7, Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t10, Curry_Prelude.Curry t9, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t12, Curry_Prelude.Curry t11, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t14, Curry_Prelude.Curry t13, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t6) => t5 -> C_XmlConv t8 t7 t0
  -> C_XmlConv t10 t9 t1 -> C_XmlConv t12 t11 t2 -> C_XmlConv t14 t13 t3 -> Func
  t5 (Func t4 (Func t3 (Func t2 (Func t1 (Func t0 t6))))) -> t4 -> IDSupply
  -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 t6 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)))
nd_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23 x1 x2 x3 x4 x5 x6 x7 s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x5 s0 cd cs) (wrapNX id
  (nd_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24
  x7 x1 x2 x3 x4 x6)) s1 cd cs))

d_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24 :: forall t0
  t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 . (Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t5, Curry_Prelude.Curry t8, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t10, Curry_Prelude.Curry t9
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t12, Curry_Prelude.Curry t11
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t6) => t4 -> t5 -> C_XmlConv t8 t7 t0 -> C_XmlConv t10 t9 t1 -> C_XmlConv t12
  t11 t2 -> (t5 -> Cover -> ConstStore -> t4 -> Cover -> ConstStore -> t3
  -> Cover -> ConstStore -> t2 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> t6) -> t3 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t6 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24 x1 x2 x3 x4 x5 x6 x7 cd cs =
  d_OP_slash_gt_eq (d_C_xmlReads x5 cd cs)
  (d_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25
  x7 x1 x2 x3 x4 x6) cd cs

nd_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24 :: forall t0
  t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 . (Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t5, Curry_Prelude.Curry t8, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t10, Curry_Prelude.Curry t9
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t12, Curry_Prelude.Curry t11
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t6) => t4 -> t5 -> C_XmlConv t8 t7 t0 -> C_XmlConv t10 t9 t1 -> C_XmlConv t12
  t11 t2 -> Func t5 (Func t4 (Func t3 (Func t2 (Func t1 (Func t0 t6))))) -> t3
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 t6
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp)))
nd_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24 x1 x2 x3 x4 x5 x6 x7 s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x5 s0 cd cs) (wrapNX id
  (nd_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25
  x7 x1 x2 x3 x4 x6)) s1 cd cs))

d_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25 :: forall t0
  t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t4, Curry_Prelude.Curry t5, Curry_Prelude.Curry t8, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t10, Curry_Prelude.Curry t9
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t6) => t3 -> t4 -> t5 -> C_XmlConv t8 t7 t0 -> C_XmlConv t10 t9 t1 -> (t5
  -> Cover -> ConstStore -> t4 -> Cover -> ConstStore -> t3 -> Cover
  -> ConstStore -> t2 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0
  -> Cover -> ConstStore -> t6) -> t2 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t6 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25 x1 x2 x3 x4 x5 x6 x7 cd cs =
  d_OP_slash_gt_eq (d_C_xmlReads x5 cd cs)
  (d_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25_dot_uscore_hash_lambda26
  x7 x1 x2 x3 x4 x6) cd cs

nd_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25 :: forall t0
  t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t4, Curry_Prelude.Curry t5, Curry_Prelude.Curry t8, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t10, Curry_Prelude.Curry t9
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t6) => t3 -> t4 -> t5 -> C_XmlConv t8 t7 t0 -> C_XmlConv t10 t9 t1 -> Func t5
  (Func t4 (Func t3 (Func t2 (Func t1 (Func t0 t6))))) -> t2 -> IDSupply
  -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 t6 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)))
nd_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25 x1 x2 x3 x4 x5 x6 x7 s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x5 s0 cd cs) (wrapNX id
  (nd_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25_dot_uscore_hash_lambda26
  x7 x1 x2 x3 x4 x6)) s1 cd cs))

d_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25_dot_uscore_hash_lambda26 :: forall t0
  t1 t2 t3 t4 t5 t6 t7 t8 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t5, Curry_Prelude.Curry t8
  , Curry_Prelude.Curry t7, Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t6) => t2 -> t3 -> t4 -> t5 -> C_XmlConv t8 t7 t0 -> (t5
  -> Cover -> ConstStore -> t4 -> Cover -> ConstStore -> t3 -> Cover
  -> ConstStore -> t2 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0
  -> Cover -> ConstStore -> t6) -> t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t6 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25_dot_uscore_hash_lambda26 x1 x2 x3 x4 x5 x6 x7 cd cs =
  d_OP_slash_gt_eq (d_C_xmlReads x5 cd cs)
  (d_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27
  x7 x1 x2 x3 x4 x6) cd cs

nd_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25_dot_uscore_hash_lambda26 :: forall t0
  t1 t2 t3 t4 t5 t6 t7 t8 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t5, Curry_Prelude.Curry t8
  , Curry_Prelude.Curry t7, Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t6) => t2 -> t3 -> t4 -> t5 -> C_XmlConv t8 t7 t0
  -> Func t5 (Func t4 (Func t3 (Func t2 (Func t1 (Func t0 t6))))) -> t1
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 t6
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp)))
nd_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25_dot_uscore_hash_lambda26 x1 x2 x3 x4 x5 x6 x7 s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq (nd_C_xmlReads x5 s0 cd cs) (wrapNX id
  (nd_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27
  x7 x1 x2 x3 x4 x6)) s1 cd cs))

d_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 :: forall t0
  t1 t2 t3 t4 t5 t6 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t4, Curry_Prelude.Curry t5
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t6) => t1 -> t2 -> t3 -> t4
  -> t5 -> (t5 -> Cover -> ConstStore -> t4 -> Cover -> ConstStore -> t3
  -> Cover -> ConstStore -> t2 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> t6) -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t6 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 x1 x2 x3 x4 x5 x6 x7 cd cs =
  d_C_ret (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply x6 x5 cd cs) x4 cd cs) x3 cd cs) x2 cd cs) x1 cd cs)
  x7 cd cs)

nd_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 :: forall t0
  t1 t2 t3 t4 t5 t6 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t4, Curry_Prelude.Curry t5
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t6) => t1 -> t2 -> t3 -> t4
  -> t5 -> Func t5 (Func t4 (Func t3 (Func t2 (Func t1 (Func t0 t6))))) -> t0
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 t6
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp)))
nd_OP_seq6_uscore_dot_uscore_hash_lambda22_dot_uscore_hash_lambda23_dot_uscore_hash_lambda24_dot_uscore_hash_lambda25_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 x1 x2 x3 x4 x5 x6 x7 s cd cs =
  let s10 = s
  in s10 `seq` wrapDX id (d_C_ret (let s9 = leftSupply s10
                                       s8 = rightSupply s10
  in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (let s7 = leftSupply s8
                                                      s6 = rightSupply s8
  in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                      s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                      s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x6 x5
  s0 cd cs) x4 s1 cd cs)) x3 s3 cd cs)) x2 s5 cd cs)) x1 s7 cd cs)) x7 s9 cd
  cs)))

nd_OP_seq6_uscore_dot_sh_dot_223 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11
  t12 t13 t14 t15 t16 t17 t18 . (Curry_Prelude.Curry t8, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t10, Curry_Prelude.Curry t9
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t12, Curry_Prelude.Curry t11
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t14, Curry_Prelude.Curry t13
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t16, Curry_Prelude.Curry t15
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t18, Curry_Prelude.Curry t17
  , Curry_Prelude.Curry t5, Curry_Prelude.Curry t6) => C_XmlConv t8 t7 t0
  -> C_XmlConv t10 t9 t1 -> C_XmlConv t12 t11 t2 -> C_XmlConv t14 t13 t3
  -> C_XmlConv t16 t15 t4 -> C_XmlConv t18 t17 t5 -> Func t5 (Func t4 (Func t3
  (Func t2 (Func t1 (Func t0 t6))))) -> t6 -> IDSupply -> Cover -> ConstStore
  -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp))
nd_OP_seq6_uscore_dot_sh_dot_223 x1 x2 x3 x4 x5 x6 x7 x8 s cd cs = let s19 = s
  in s19 `seq` (let s20 = leftSupply s19
                    s22 = rightSupply s19
                    s0 = leftSupply s20
                    s21 = rightSupply s20
                    s1 = leftSupply s21
                    s2 = rightSupply s21
                    s23 = leftSupply s22
                    s24 = rightSupply s22
                    s3 = leftSupply s23
                    s4 = rightSupply s23
                    s5 = leftSupply s24
                    s18 = rightSupply s24
  in s20 `seq` (s22 `seq` (s0 `seq` (s21 `seq` (s1 `seq` (s2 `seq` (s23 `seq`
  (s24 `seq` (s3 `seq` (s4 `seq` (s5 `seq` (s18 `seq` (let x9 = generate s0 cd
                                                           x10 = generate s1 cd
                                                           x11 = generate s2 cd
                                                           x12 = generate s3 cd
                                                           x13 = generate s4 cd
                                                           x14 = generate s5 cd
  in let s17 = leftSupply s18
         s16 = rightSupply s18
  in s17 `seq` (s16 `seq` nd_C__case_0 x8 x14 x13 x12 x11 x10 x9 x7 x1 x2 x3 x4
  x5 x6 (Curry_Prelude.d_OP_eq_colon_lt_eq (let s15 = leftSupply s16
                                                s14 = rightSupply s16
  in s15 `seq` (s14 `seq` Curry_Prelude.nd_C_apply (let s13 = leftSupply s14
                                                        s12 = rightSupply s14
  in s13 `seq` (s12 `seq` Curry_Prelude.nd_C_apply (let s11 = leftSupply s12
                                                        s10 = rightSupply s12
  in s11 `seq` (s10 `seq` Curry_Prelude.nd_C_apply (let s9 = leftSupply s10
                                                        s8 = rightSupply s10
  in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (let s7 = leftSupply s8
                                                      s6 = rightSupply s8
  in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x7 x9
  s6 cd cs) x10 s7 cd cs)) x11 s9 cd cs)) x12 s11 cd cs)) x13 s13 cd cs)) x14
  s15 cd cs)) x8 cd cs) s17 cd cs))))))))))))))

nd_C_seq6 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16
  t17 t18 . (Curry_Prelude.Curry t18, Curry_Prelude.Curry t17
  , Curry_Prelude.Curry t16, Curry_Prelude.Curry t15, Curry_Prelude.Curry t14
  , Curry_Prelude.Curry t13, Curry_Prelude.Curry t12, Curry_Prelude.Curry t11
  , Curry_Prelude.Curry t10, Curry_Prelude.Curry t9, Curry_Prelude.Curry t8
  , Curry_Prelude.Curry t7, Curry_Prelude.Curry t6, Curry_Prelude.Curry t5
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t3, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t18) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t17) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t16) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t15) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t14) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t13) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t12) -> IDSupply
  -> Cover -> ConstStore -> Func (Func t18 (Func t17 (Func t16 (Func t15 (Func
  t14 (Func t13 t12)))))) (Func (C_XmlConv t11 t10 t18) (Func (C_XmlConv t9 t8
  t17) (Func (C_XmlConv t7 t6 t16) (Func (C_XmlConv t5 t4 t15) (Func (C_XmlConv
  t3 t2 t14) (Func (C_XmlConv t1 t0 t13) (C_XmlConv C_NotRepeatable C_NoElem
  t12)))))))
nd_C_seq6 x1 x2 x3 x4 x5 x6 x7 s cd cs = wrapDX (wrapDX (wrapDX (wrapDX (wrapDX
  (wrapDX (wrapNX id)))))) (acceptCs (acceptCs (acceptCs (acceptCs (acceptCs
  (acceptCs id))))) (nd_C_seq6_ x1 x2 x3 x4 x5 x6 x7))

nd_C_repSeq6 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11
  t12 . (Curry_Prelude.Curry t12, Curry_Prelude.Curry t11, Curry_Prelude.Curry
  t10, Curry_Prelude.Curry t9, Curry_Prelude.Curry t8, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t6, Curry_Prelude.Curry t5, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t12) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t11) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t10) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t9) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t8) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t7) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t6) -> Func t12 (Func t11 (Func t10
  (Func t9 (Func t8 (Func t7 t6))))) -> C_XmlConv C_Repeatable t5 t12
  -> C_XmlConv C_Repeatable t4 t11 -> C_XmlConv C_Repeatable t3 t10 -> C_XmlConv
  C_Repeatable t2 t9 -> C_XmlConv C_Repeatable t1 t8 -> C_XmlConv C_Repeatable
  t0 t7 -> IDSupply -> Cover -> ConstStore -> C_XmlConv C_NotRepeatable C_NoElem
  (Curry_Prelude.OP_List t6)
nd_C_repSeq6 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_rep (nd_C_seq6_ x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11
  x12 x13 x14 s0 cd cs) s1 cd cs))

nd_C_eSeq6 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16
  t17 t18 . (Curry_Prelude.Curry t18, Curry_Prelude.Curry t17
  , Curry_Prelude.Curry t16, Curry_Prelude.Curry t15, Curry_Prelude.Curry t14
  , Curry_Prelude.Curry t13, Curry_Prelude.Curry t12, Curry_Prelude.Curry t11
  , Curry_Prelude.Curry t10, Curry_Prelude.Curry t9, Curry_Prelude.Curry t8
  , Curry_Prelude.Curry t7, Curry_Prelude.Curry t6, Curry_Prelude.Curry t5
  , Curry_Prelude.Curry t4, Curry_Prelude.Curry t3, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t18) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t17) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t16) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t15) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t14) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t13) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t12)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func t18 (Func t17 (Func t16
  (Func t15 (Func t14 (Func t13 t12))))) -> C_XmlConv t11 t10 t18 -> C_XmlConv
  t9 t8 t17 -> C_XmlConv t7 t6 t16 -> C_XmlConv t5 t4 t15 -> C_XmlConv t3 t2 t14
  -> C_XmlConv t1 t0 t13 -> IDSupply -> Cover -> ConstStore -> C_XmlConv
  C_Repeatable C_Elem t12
nd_C_eSeq6 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 s cd cs =
  let s16 = s
  in s16 `seq` (let s15 = leftSupply s16
                    s14 = rightSupply s16
  in s15 `seq` (s14 `seq` nd_C_element x8 (let s13 = leftSupply s14
                                               s12 = rightSupply s14
  in s13 `seq` (s12 `seq` Curry_Prelude.nd_C_apply (let s11 = leftSupply s12
                                                        s10 = rightSupply s12
  in s11 `seq` (s10 `seq` Curry_Prelude.nd_C_apply (let s9 = leftSupply s10
                                                        s8 = rightSupply s10
  in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (let s7 = leftSupply s8
                                                      s6 = rightSupply s8
  in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                      s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                      s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_seq6 x1 x2 x3 x4 x5 x6 x7
  s0 cd cs) x9 s1 cd cs)) x10 s3 cd cs)) x11 s5 cd cs)) x12 s7 cd cs)) x13 s9 cd
  cs)) x14 s11 cd cs)) x15 s13 cd cs)) s15 cd cs))

nd_C_eRepSeq6 :: forall t0 t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11
  t12 . (Curry_Prelude.Curry t12, Curry_Prelude.Curry t11, Curry_Prelude.Curry
  t10, Curry_Prelude.Curry t9, Curry_Prelude.Curry t8, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t6, Curry_Prelude.Curry t5, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t2, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t12) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t11) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t10) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t9) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t8) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t7) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t6) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Func t12 (Func t11 (Func t10 (Func t9 (Func t8 (Func
  t7 t6))))) -> C_XmlConv C_Repeatable t5 t12 -> C_XmlConv C_Repeatable t4 t11
  -> C_XmlConv C_Repeatable t3 t10 -> C_XmlConv C_Repeatable t2 t9 -> C_XmlConv
  C_Repeatable t1 t8 -> C_XmlConv C_Repeatable t0 t7 -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv C_Repeatable C_Elem (Curry_Prelude.OP_List t6)
nd_C_eRepSeq6 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_element x8 (nd_C_repSeq6 x1 x2 x3 x4 x5 x6 x7 x9
  x10 x11 x12 x13 x14 x15 s0 cd cs) s1 cd cs))

d_C__case_46 :: C_Repeatable -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_46 x2 cd cs = case x2 of
  C_Repeatable -> Curry_Prelude.C_True
  Choice_C_Repeatable d i l r -> narrow d i (d_C__case_46 l cd cs) (d_C__case_46
    r cd cs)
  Choices_C_Repeatable d i xs -> narrows cs d i (\z -> d_C__case_46 z cd cs) xs
  Guard_C_Repeatable d c e -> guardCons d c ((\x -> d_C__case_46 e cd x) $!
    addCs c cs)
  Fail_C_Repeatable d info -> failCons d (traceFail "XmlConv._case_46" [show x2]
    info)
  _ -> failCons cd (consFail "XmlConv._case_46" (showCons x2))

d_C__case_45 :: C_NotRepeatable -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_45 x2 cd cs = case x2 of
  C_NotRepeatable -> Curry_Prelude.C_True
  Choice_C_NotRepeatable d i l r -> narrow d i (d_C__case_45 l cd cs)
    (d_C__case_45 r cd cs)
  Choices_C_NotRepeatable d i xs -> narrows cs d i (\z -> d_C__case_45 z cd cs)
    xs
  Guard_C_NotRepeatable d c e -> guardCons d c ((\x -> d_C__case_45 e cd x) $!
    addCs c cs)
  Fail_C_NotRepeatable d info -> failCons d (traceFail "XmlConv._case_45" [show
    x2] info)
  _ -> failCons cd (consFail "XmlConv._case_45" (showCons x2))

d_C__case_44 :: C_Elem -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_44 x2 cd cs = case x2 of
  C_Elem -> Curry_Prelude.C_True
  Choice_C_Elem d i l r -> narrow d i (d_C__case_44 l cd cs) (d_C__case_44 r cd
    cs)
  Choices_C_Elem d i xs -> narrows cs d i (\z -> d_C__case_44 z cd cs) xs
  Guard_C_Elem d c e -> guardCons d c ((\x -> d_C__case_44 e cd x) $! addCs c
    cs)
  Fail_C_Elem d info -> failCons d (traceFail "XmlConv._case_44" [show x2] info)
  _ -> failCons cd (consFail "XmlConv._case_44" (showCons x2))

d_C__case_43 :: C_NoElem -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_43 x2 cd cs = case x2 of
  C_NoElem -> Curry_Prelude.C_True
  Choice_C_NoElem d i l r -> narrow d i (d_C__case_43 l cd cs) (d_C__case_43 r
    cd cs)
  Choices_C_NoElem d i xs -> narrows cs d i (\z -> d_C__case_43 z cd cs) xs
  Guard_C_NoElem d c e -> guardCons d c ((\x -> d_C__case_43 e cd x) $! addCs c
    cs)
  Fail_C_NoElem d info -> failCons d (traceFail "XmlConv._case_43" [show x2]
    info)
  _ -> failCons cd (consFail "XmlConv._case_43" (showCons x2))

d_C__case_42 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))) -> (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))) -> Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_C__case_42 x3 x2 x1 x6 cd cs = case x6 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x1 x4 cd cs) x5 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_42 x3 x2 x1 l
    cd cs) (d_C__case_42 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_42
    x3 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_42 x3
    x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv._case_42" [show x3, show x2, show x1, show x6] info)
  _ -> failCons cd (consFail "XmlConv._case_42" (showCons x6))

nd_C__case_42 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp))) -> Func t0 (Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))))
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp))
nd_C__case_42 x3 x2 x1 x6 s cd cs = case x6 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x4 s0 cd cs) x5 s1 cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_42 x3 x2 x1 l
    s cd cs) (nd_C__case_42 x3 x2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_42
    x3 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_42 x3
    x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv._case_42" [show x3, show x2, show x1, show x6] info)
  _ -> failCons cd (consFail "XmlConv._case_42" (showCons x6))

d_C__case_41 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> t0
d_C__case_41 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_40 x5 x2 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_41 x2 l cd cs)
    (d_C__case_41 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_41
    x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_41 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv._case_41" [show x2, show x3] info)
  _ -> failCons cd (consFail "XmlConv._case_41" (showCons x3))

d_C__case_40 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_XML.C_XmlExp -> t0 -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> t0
d_C__case_40 x5 x2 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> d_C__case_39 x2 x5 cd cs
  Curry_Prelude.OP_Cons x8 x9 -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_40 x5 x2 l cd
    cs) (d_C__case_40 x5 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_40 x5
    x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_40 x5 x2
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XmlConv._case_40"
    [show x5, show x2, show x4] info)
  _ -> failCons cd (consFail "XmlConv._case_40" (showCons x4))

d_C__case_39 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Cover -> ConstStore -> t0
d_C__case_39 x2 x5 cd cs = case x5 of
  Curry_Prelude.OP_List -> x2
  Curry_Prelude.OP_Cons x6 x7 -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_39 x2 l cd cs)
    (d_C__case_39 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_39 x2
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_39 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XmlConv._case_39"
    [show x2, show x5] info)
  _ -> failCons cd (consFail "XmlConv._case_39" (showCons x5))

d_C__case_38 :: Curry_Prelude.OP_List Curry_XML.C_XmlExp
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_XML.C_XmlExp
d_C__case_38 x3 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> d_C__case_37 x3 cd cs
  Curry_Prelude.OP_Cons x8 x9 -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_38 x3 l cd cs)
    (d_C__case_38 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_38 x3
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_38 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XmlConv._case_38"
    [show x3, show x2] info)
  _ -> failCons cd (consFail "XmlConv._case_38" (showCons x2))

d_C__case_37 :: Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Cover -> ConstStore
  -> Curry_XML.C_XmlExp
d_C__case_37 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_36 x4 x5 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_37 l cd cs)
    (d_C__case_37 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_37 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_37 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XmlConv._case_37"
    [show x3] info)
  _ -> failCons cd (consFail "XmlConv._case_37" (showCons x3))

d_C__case_36 :: Curry_XML.C_XmlExp -> Curry_Prelude.OP_List Curry_XML.C_XmlExp
  -> Cover -> ConstStore -> Curry_XML.C_XmlExp
d_C__case_36 x4 x5 cd cs = case x5 of
  Curry_Prelude.OP_List -> x4
  Curry_Prelude.OP_Cons x6 x7 -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_36 x4 l cd cs)
    (d_C__case_36 x4 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_36 x4
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_36 x4 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XmlConv._case_36"
    [show x4, show x5] info)
  _ -> failCons cd (consFail "XmlConv._case_36" (showCons x5))

d_C__case_35 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Cover -> ConstStore -> t0
d_C__case_35 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_34 x2 x4 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_35 x2 l cd cs)
    (d_C__case_35 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_35 x2
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_35 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XmlConv._case_35"
    [show x2, show x3] info)
  _ -> failCons cd (consFail "XmlConv._case_35" (showCons x3))

d_C__case_34 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Curry_XML.C_XmlExp
  -> Cover -> ConstStore -> t0
d_C__case_34 x2 x4 cd cs = case x4 of
  Curry_XML.C_XText x6 -> x2
  Curry_XML.C_XElem x7 x8 x9 -> Curry_Prelude.d_C_failed cd cs
  Curry_XML.Choice_C_XmlExp d i l r -> narrow d i (d_C__case_34 x2 l cd cs)
    (d_C__case_34 x2 r cd cs)
  Curry_XML.Choices_C_XmlExp d i xs -> narrows cs d i (\z -> d_C__case_34 x2 z
    cd cs) xs
  Curry_XML.Guard_C_XmlExp d c e -> guardCons d c ((\x -> d_C__case_34 x2 e cd
    x) $! addCs c cs)
  Curry_XML.Fail_C_XmlExp d info -> failCons d (traceFail "XmlConv._case_34"
    [show x2, show x4] info)
  _ -> failCons cd (consFail "XmlConv._case_34" (showCons x4))

d_C__case_33 :: Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_33 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_32 x4 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_33 l cd cs)
    (d_C__case_33 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_33 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_33 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XmlConv._case_33"
    [show x3] info)
  _ -> failCons cd (consFail "XmlConv._case_33" (showCons x3))

d_C__case_32 :: Curry_XML.C_XmlExp -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_32 x4 cd cs = case x4 of
  Curry_XML.C_XText x6 -> x6
  Curry_XML.C_XElem x7 x8 x9 -> Curry_Prelude.d_C_failed cd cs
  Curry_XML.Choice_C_XmlExp d i l r -> narrow d i (d_C__case_32 l cd cs)
    (d_C__case_32 r cd cs)
  Curry_XML.Choices_C_XmlExp d i xs -> narrows cs d i (\z -> d_C__case_32 z cd
    cs) xs
  Curry_XML.Guard_C_XmlExp d c e -> guardCons d c ((\x -> d_C__case_32 e cd
    x) $! addCs c cs)
  Curry_XML.Fail_C_XmlExp d info -> failCons d (traceFail "XmlConv._case_32"
    [show x4] info)
  _ -> failCons cd (consFail "XmlConv._case_32" (showCons x4))

d_C__case_31 :: Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_XML.C_XmlExp
d_C__case_31 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_30 x5 x4 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_31 l cd cs)
    (d_C__case_31 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_31 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_31 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XmlConv._case_31"
    [show x3] info)
  _ -> failCons cd (consFail "XmlConv._case_31" (showCons x3))

d_C__case_30 :: Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Curry_XML.C_XmlExp
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_XML.C_XmlExp
d_C__case_30 x5 x4 cd cs = case x4 of
  Curry_XML.C_XText x6 -> x5
  Curry_XML.C_XElem x7 x8 x9 -> Curry_Prelude.d_C_failed cd cs
  Curry_XML.Choice_C_XmlExp d i l r -> narrow d i (d_C__case_30 x5 l cd cs)
    (d_C__case_30 x5 r cd cs)
  Curry_XML.Choices_C_XmlExp d i xs -> narrows cs d i (\z -> d_C__case_30 x5 z
    cd cs) xs
  Curry_XML.Guard_C_XmlExp d c e -> guardCons d c ((\x -> d_C__case_30 x5 e cd
    x) $! addCs c cs)
  Curry_XML.Fail_C_XmlExp d info -> failCons d (traceFail "XmlConv._case_30"
    [show x5, show x4] info)
  _ -> failCons cd (consFail "XmlConv._case_30" (showCons x4))

d_C__case_29 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_C__case_29 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_28 x5 x2 x4 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_29 x2 l cd cs)
    (d_C__case_29 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_29 x2
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_29 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XmlConv._case_29"
    [show x2, show x3] info)
  _ -> failCons cd (consFail "XmlConv._case_29" (showCons x3))

d_C__case_28 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_XML.C_XmlExp -> t0 -> Curry_XML.C_XmlExp -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_C__case_28 x5 x2 x4 cd cs = case x4 of
  Curry_XML.C_XText x6 -> Curry_Prelude.OP_Tuple2 x6 (Curry_Prelude.OP_Tuple2 x2
    x5)
  Curry_XML.C_XElem x7 x8 x9 -> Curry_Prelude.d_C_failed cd cs
  Curry_XML.Choice_C_XmlExp d i l r -> narrow d i (d_C__case_28 x5 x2 l cd cs)
    (d_C__case_28 x5 x2 r cd cs)
  Curry_XML.Choices_C_XmlExp d i xs -> narrows cs d i (\z -> d_C__case_28 x5 x2
    z cd cs) xs
  Curry_XML.Guard_C_XmlExp d c e -> guardCons d c ((\x -> d_C__case_28 x5 x2 e
    cd x) $! addCs c cs)
  Curry_XML.Fail_C_XmlExp d info -> failCons d (traceFail "XmlConv._case_28"
    [show x5, show x2, show x4] info)
  _ -> failCons cd (consFail "XmlConv._case_28" (showCons x4))

nd_C__case_27 :: forall t0 t2 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t1) => Func t0 (Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))) -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp)))
  -> C_XmlConv t2 t1 t0 -> IDSupply -> Cover -> ConstStore -> C_XmlConv t2 t1 t0
nd_C__case_27 x4 x3 x2 s cd cs = case x2 of
  HO_C_Conv x5 x6 -> HO_C_Conv (wrapNX id (nd_OP_bang_dot_rd_dot_65 x3 x5))
    (wrapNX id (nd_OP_bang_dot_sh_dot_65 x4 x6))
  Choice_C_XmlConv d i l r -> narrow d i (nd_C__case_27 x4 x3 l s cd cs)
    (nd_C__case_27 x4 x3 r s cd cs)
  Choices_C_XmlConv d i xs -> narrows cs d i (\z -> nd_C__case_27 x4 x3 z s cd
    cs) xs
  Guard_C_XmlConv d c e -> guardCons d c ((\x -> nd_C__case_27 x4 x3 e s cd
    x) $! addCs c cs)
  Fail_C_XmlConv d info -> failCons d (traceFail "XmlConv._case_27" [show x4
    , show x3, show x2] info)
  _ -> failCons cd (consFail "XmlConv._case_27" (showCons x2))

d_C__case_26 :: forall t2 t1 t0 t3 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t3) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_XML.C_XmlExp
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> C_XmlConv t2 t1 t0 -> Curry_Prelude.OP_List Curry_XML.C_XmlExp -> t3
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_Tuple2 t3 (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_C__case_26 x1 x5 x7 x6 x2 x8 x4 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> d_C__case_25 x7 x6 x2 x8 x4 (Curry_Prelude.d_C_apply
    (d_C_xmlReads x2 cd cs) (Curry_Prelude.OP_Tuple2 x6 x7) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_26 x1 x5 x7 x6 x2
    x8 x4 l cd cs) (d_C__case_26 x1 x5 x7 x6 x2 x8 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_26 x1
    x5 x7 x6 x2 x8 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_26 x1 x5
    x7 x6 x2 x8 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "XmlConv._case_26"
    [show x1, show x5, show x7, show x6, show x2, show x8, show x4, show x9]
    info)
  _ -> failCons cd (consFail "XmlConv._case_26" (showCons x9))

nd_C__case_26 :: forall t2 t1 t0 t3 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t3) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_XML.C_XmlExp
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> C_XmlConv t2 t1 t0 -> Curry_Prelude.OP_List Curry_XML.C_XmlExp -> t3
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 t3
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
nd_C__case_26 x1 x5 x7 x6 x2 x8 x4 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_25 x7 x6 x2 x8 x4 (let s1 = leftSupply s2
                                                            s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlReads x2 s0 cd cs)
    (Curry_Prelude.OP_Tuple2 x6 x7) s1 cd cs)) s3 cd cs))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_26 x1 x5 x7 x6
    x2 x8 x4 l s cd cs) (nd_C__case_26 x1 x5 x7 x6 x2 x8 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_26 x1
    x5 x7 x6 x2 x8 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_26 x1 x5
    x7 x6 x2 x8 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "XmlConv._case_26"
    [show x1, show x5, show x7, show x6, show x2, show x8, show x4, show x9]
    info)
  _ -> failCons cd (consFail "XmlConv._case_26" (showCons x9))

d_C__case_25 :: forall t2 t1 t0 t3 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t3) => Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> C_XmlConv t2 t1 t0
  -> Curry_Prelude.OP_List Curry_XML.C_XmlExp -> t3 -> Curry_Prelude.OP_Tuple2
  t0 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 t3
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_C__case_25 x7 x6 x2 x8 x4 x11 cd cs = case x11 of
  Curry_Prelude.OP_Tuple2 x9 x10 -> d_C__case_24 x8 x4 x9 x10 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_25 x7 x6 x2 x8
    x4 l cd cs) (d_C__case_25 x7 x6 x2 x8 x4 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_25
    x7 x6 x2 x8 x4 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_25 x7
    x6 x2 x8 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv._case_25" [show x7, show x6, show x2, show x8, show x4, show x11]
    info)
  _ -> failCons cd (consFail "XmlConv._case_25" (showCons x11))

nd_C__case_25 :: forall t2 t1 t0 t3 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t3) => Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> C_XmlConv t2 t1 t0
  -> Curry_Prelude.OP_List Curry_XML.C_XmlExp -> t3 -> Curry_Prelude.OP_Tuple2
  t0 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_Tuple2 t3 (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
nd_C__case_25 x7 x6 x2 x8 x4 x11 s cd cs = case x11 of
  Curry_Prelude.OP_Tuple2 x9 x10 -> d_C__case_24 x8 x4 x9 x10 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_25 x7 x6 x2
    x8 x4 l s cd cs) (nd_C__case_25 x7 x6 x2 x8 x4 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_25
    x7 x6 x2 x8 x4 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_25 x7
    x6 x2 x8 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv._case_25" [show x7, show x6, show x2, show x8, show x4, show x11]
    info)
  _ -> failCons cd (consFail "XmlConv._case_25" (showCons x11))

d_C__case_24 :: forall t3 t0 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_XML.C_XmlExp -> t3 -> t0
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 t3
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_C__case_24 x8 x4 x9 x10 cd cs = case x10 of
  Curry_Prelude.OP_Tuple2 x11 x12 -> d_C__case_23 x12 x8 x4 x9 x11 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_24 x8 x4 x9 l
    cd cs) (d_C__case_24 x8 x4 x9 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_24
    x8 x4 x9 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_24 x8
    x4 x9 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv._case_24" [show x8, show x4, show x9, show x10] info)
  _ -> failCons cd (consFail "XmlConv._case_24" (showCons x10))

d_C__case_23 :: forall t3 t0 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Curry_Prelude.OP_List
  Curry_XML.C_XmlExp -> t3 -> t0 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 t3
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_C__case_23 x12 x8 x4 x9 x11 cd cs = case x11 of
  Curry_Prelude.OP_List -> d_C__case_22 x8 x4 x9 x12 cd cs
  Curry_Prelude.OP_Cons x15 x16 -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_23 x12 x8 x4 x9
    l cd cs) (d_C__case_23 x12 x8 x4 x9 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_23 x12
    x8 x4 x9 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_23 x12 x8
    x4 x9 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XmlConv._case_23"
    [show x12, show x8, show x4, show x9, show x11] info)
  _ -> failCons cd (consFail "XmlConv._case_23" (showCons x11))

d_C__case_22 :: forall t3 t0 . (Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_XML.C_XmlExp -> t3 -> t0
  -> Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 t3
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
d_C__case_22 x8 x4 x9 x12 cd cs = case x12 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 x9 (Curry_Prelude.OP_Tuple2
    x4 x8)
  Curry_Prelude.OP_Cons x13 x14 -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_22 x8 x4 x9 l cd
    cs) (d_C__case_22 x8 x4 x9 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_22 x8
    x4 x9 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_22 x8 x4
    x9 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XmlConv._case_22"
    [show x8, show x4, show x9, show x12] info)
  _ -> failCons cd (consFail "XmlConv._case_22" (showCons x12))

d_C__case_21 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Cover -> ConstStore -> t0
d_C__case_21 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_20 x2 x4 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_21 x2 l cd cs)
    (d_C__case_21 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_21 x2
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_21 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XmlConv._case_21"
    [show x2, show x3] info)
  _ -> failCons cd (consFail "XmlConv._case_21" (showCons x3))

d_C__case_20 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Curry_XML.C_XmlExp
  -> Cover -> ConstStore -> t0
d_C__case_20 x2 x4 cd cs = case x4 of
  Curry_XML.C_XElem x6 x7 x8 -> x2
  Curry_XML.C_XText x9 -> Curry_Prelude.d_C_failed cd cs
  Curry_XML.Choice_C_XmlExp d i l r -> narrow d i (d_C__case_20 x2 l cd cs)
    (d_C__case_20 x2 r cd cs)
  Curry_XML.Choices_C_XmlExp d i xs -> narrows cs d i (\z -> d_C__case_20 x2 z
    cd cs) xs
  Curry_XML.Guard_C_XmlExp d c e -> guardCons d c ((\x -> d_C__case_20 x2 e cd
    x) $! addCs c cs)
  Curry_XML.Fail_C_XmlExp d info -> failCons d (traceFail "XmlConv._case_20"
    [show x2, show x4] info)
  _ -> failCons cd (consFail "XmlConv._case_20" (showCons x4))

d_C__case_19 :: Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_19 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_18 x4 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_19 l cd cs)
    (d_C__case_19 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_19 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_19 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XmlConv._case_19"
    [show x3] info)
  _ -> failCons cd (consFail "XmlConv._case_19" (showCons x3))

d_C__case_18 :: Curry_XML.C_XmlExp -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_18 x4 cd cs = case x4 of
  Curry_XML.C_XElem x6 x7 x8 -> x6
  Curry_XML.C_XText x9 -> Curry_Prelude.d_C_failed cd cs
  Curry_XML.Choice_C_XmlExp d i l r -> narrow d i (d_C__case_18 l cd cs)
    (d_C__case_18 r cd cs)
  Curry_XML.Choices_C_XmlExp d i xs -> narrows cs d i (\z -> d_C__case_18 z cd
    cs) xs
  Curry_XML.Guard_C_XmlExp d c e -> guardCons d c ((\x -> d_C__case_18 e cd
    x) $! addCs c cs)
  Curry_XML.Fail_C_XmlExp d info -> failCons d (traceFail "XmlConv._case_18"
    [show x4] info)
  _ -> failCons cd (consFail "XmlConv._case_18" (showCons x4))

d_C__case_17 :: Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_17 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_16 x4 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_17 l cd cs)
    (d_C__case_17 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_17 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_17 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XmlConv._case_17"
    [show x3] info)
  _ -> failCons cd (consFail "XmlConv._case_17" (showCons x3))

d_C__case_16 :: Curry_XML.C_XmlExp -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_16 x4 cd cs = case x4 of
  Curry_XML.C_XElem x6 x7 x8 -> x7
  Curry_XML.C_XText x9 -> Curry_Prelude.d_C_failed cd cs
  Curry_XML.Choice_C_XmlExp d i l r -> narrow d i (d_C__case_16 l cd cs)
    (d_C__case_16 r cd cs)
  Curry_XML.Choices_C_XmlExp d i xs -> narrows cs d i (\z -> d_C__case_16 z cd
    cs) xs
  Curry_XML.Guard_C_XmlExp d c e -> guardCons d c ((\x -> d_C__case_16 e cd
    x) $! addCs c cs)
  Curry_XML.Fail_C_XmlExp d info -> failCons d (traceFail "XmlConv._case_16"
    [show x4] info)
  _ -> failCons cd (consFail "XmlConv._case_16" (showCons x4))

d_C__case_15 :: Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_XML.C_XmlExp
d_C__case_15 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_14 x4 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_15 l cd cs)
    (d_C__case_15 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_15 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_15 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XmlConv._case_15"
    [show x3] info)
  _ -> failCons cd (consFail "XmlConv._case_15" (showCons x3))

d_C__case_14 :: Curry_XML.C_XmlExp -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_XML.C_XmlExp
d_C__case_14 x4 cd cs = case x4 of
  Curry_XML.C_XElem x6 x7 x8 -> x8
  Curry_XML.C_XText x9 -> Curry_Prelude.d_C_failed cd cs
  Curry_XML.Choice_C_XmlExp d i l r -> narrow d i (d_C__case_14 l cd cs)
    (d_C__case_14 r cd cs)
  Curry_XML.Choices_C_XmlExp d i xs -> narrows cs d i (\z -> d_C__case_14 z cd
    cs) xs
  Curry_XML.Guard_C_XmlExp d c e -> guardCons d c ((\x -> d_C__case_14 e cd
    x) $! addCs c cs)
  Curry_XML.Fail_C_XmlExp d info -> failCons d (traceFail "XmlConv._case_14"
    [show x4] info)
  _ -> failCons cd (consFail "XmlConv._case_14" (showCons x4))

d_C__case_13 :: Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_XML.C_XmlExp
d_C__case_13 x3 cd cs = case x3 of
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_12 x5 x4 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_13 l cd cs)
    (d_C__case_13 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_13 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_13 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "XmlConv._case_13"
    [show x3] info)
  _ -> failCons cd (consFail "XmlConv._case_13" (showCons x3))

d_C__case_12 :: Curry_Prelude.OP_List Curry_XML.C_XmlExp -> Curry_XML.C_XmlExp
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_XML.C_XmlExp
d_C__case_12 x5 x4 cd cs = case x4 of
  Curry_XML.C_XElem x6 x7 x8 -> x5
  Curry_XML.C_XText x9 -> Curry_Prelude.d_C_failed cd cs
  Curry_XML.Choice_C_XmlExp d i l r -> narrow d i (d_C__case_12 x5 l cd cs)
    (d_C__case_12 x5 r cd cs)
  Curry_XML.Choices_C_XmlExp d i xs -> narrows cs d i (\z -> d_C__case_12 x5 z
    cd cs) xs
  Curry_XML.Guard_C_XmlExp d c e -> guardCons d c ((\x -> d_C__case_12 x5 e cd
    x) $! addCs c cs)
  Curry_XML.Fail_C_XmlExp d info -> failCons d (traceFail "XmlConv._case_12"
    [show x5, show x4] info)
  _ -> failCons cd (consFail "XmlConv._case_12" (showCons x4))

d_C__case_11 :: forall t1 t3 t2 t0 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0) => t1 -> C_XmlConv t3 t2 t1 -> Curry_Prelude.OP_List Curry_XML.C_XmlExp
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> t0 -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
d_C__case_11 x3 x2 x6 x1 x5 x9 cd cs = case x9 of
  Curry_Prelude.OP_Tuple2 x7 x8 -> Curry_Prelude.OP_Tuple2 x5
    (Curry_Prelude.OP_Cons (Curry_XML.C_XElem x1 x7 x8) x6)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_11 x3 x2 x6 x1
    x5 l cd cs) (d_C__case_11 x3 x2 x6 x1 x5 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_11
    x3 x2 x6 x1 x5 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_11 x3
    x2 x6 x1 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv._case_11" [show x3, show x2, show x6, show x1, show x5, show x9]
    info)
  _ -> failCons cd (consFail "XmlConv._case_11" (showCons x9))

nd_C__case_11 :: forall t1 t3 t2 t0 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t0) => t1 -> C_XmlConv t3 t2 t1 -> Curry_Prelude.OP_List Curry_XML.C_XmlExp
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> t0 -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
nd_C__case_11 x3 x2 x6 x1 x5 x9 s cd cs = case x9 of
  Curry_Prelude.OP_Tuple2 x7 x8 -> Curry_Prelude.OP_Tuple2 x5
    (Curry_Prelude.OP_Cons (Curry_XML.C_XElem x1 x7 x8) x6)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_11 x3 x2 x6
    x1 x5 l s cd cs) (nd_C__case_11 x3 x2 x6 x1 x5 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_11
    x3 x2 x6 x1 x5 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_11 x3
    x2 x6 x1 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "XmlConv._case_11" [show x3, show x2, show x6, show x1, show x5, show x9]
    info)
  _ -> failCons cd (consFail "XmlConv._case_11" (showCons x9))

d_C__case_10 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> t0
d_C__case_10 x1 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> x3
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_10 x1 x2 x3 l cd
    cs) (d_C__case_10 x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_10 x1
    x2 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_10 x1 x2
    x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "XmlConv._case_10"
    [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "XmlConv._case_10" (showCons x4))

d_C__case_9 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_9 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> x5
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_9 l cd cs)
    (d_C__case_9 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_9 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_9 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "XmlConv._case_9"
    [show x2] info)
  _ -> failCons cd (consFail "XmlConv._case_9" (showCons x2))

d_C__case_8 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C__case_8 x3 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_8 x3 l cd cs)
    (d_C__case_8 x3 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_8 x3
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_8 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "XmlConv._case_8"
    [show x3, show x2] info)
  _ -> failCons cd (consFail "XmlConv._case_8" (showCons x2))

d_C__case_7 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0 -> t0
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List t0)
d_C__case_7 x3 x1 x7 x6 x4 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 x3 x4
  Curry_Prelude.C_False -> Curry_Prelude.OP_Tuple2 x6 (Curry_Prelude.OP_Cons x3
    x7)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x3 x1 x7 x6 x4
    l cd cs) (d_C__case_7 x3 x1 x7 x6 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x3 x1
    x7 x6 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_7 x3 x1 x7
    x6 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "XmlConv._case_7"
    [show x3, show x1, show x7, show x6, show x4, show x8] info)
  _ -> failCons cd (consFail "XmlConv._case_7" (showCons x8))

nd_C__case_7 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Func t0
  Curry_Prelude.C_Bool -> Curry_Prelude.OP_List t0 -> t0
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List t0)
nd_C__case_7 x3 x1 x7 x6 x4 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 x3 x4
  Curry_Prelude.C_False -> Curry_Prelude.OP_Tuple2 x6 (Curry_Prelude.OP_Cons x3
    x7)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_7 x3 x1 x7 x6 x4
    l s cd cs) (nd_C__case_7 x3 x1 x7 x6 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_7 x3
    x1 x7 x6 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_7 x3 x1
    x7 x6 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "XmlConv._case_7"
    [show x3, show x1, show x7, show x6, show x4, show x8] info)
  _ -> failCons cd (consFail "XmlConv._case_7" (showCons x8))

d_C__case_6 :: forall t0 t1 t3 t2 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t3, Curry_Prelude.Curry t2) => (t0 -> Cover
  -> ConstStore -> t1) -> (t1 -> Cover -> ConstStore -> t0) -> C_XmlConv t3 t2
  t1 -> Cover -> ConstStore -> C_XmlConv t3 t2 t0
d_C__case_6 x4 x3 x2 cd cs = case x2 of
  C_Conv x5 x6 -> let x7 = d_OP_slash_gt_eq x5 (Curry_Prelude.d_OP_dot (acceptCs
                        id d_C_ret) x3 cd cs) cd cs
                      x8 = Curry_Prelude.d_OP_dot x6 x4 cd cs
    in C_Conv x7 x8
  Choice_C_XmlConv d i l r -> narrow d i (d_C__case_6 x4 x3 l cd cs)
    (d_C__case_6 x4 x3 r cd cs)
  Choices_C_XmlConv d i xs -> narrows cs d i (\z -> d_C__case_6 x4 x3 z cd cs)
    xs
  Guard_C_XmlConv d c e -> guardCons d c ((\x -> d_C__case_6 x4 x3 e cd x) $!
    addCs c cs)
  Fail_C_XmlConv d info -> failCons d (traceFail "XmlConv._case_6" [show x4
    , show x3, show x2] info)
  _ -> failCons cd (consFail "XmlConv._case_6" (showCons x2))

nd_C__case_6 :: forall t0 t1 t3 t2 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t2) => Func t0 t1 -> Func t1 t0 -> C_XmlConv t3 t2 t1 -> IDSupply -> Cover
  -> ConstStore -> C_XmlConv t3 t2 t0
nd_C__case_6 x4 x3 x2 s cd cs = case x2 of
  HO_C_Conv x5 x6 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` (let x7 = let s1 = leftSupply s2
                                        s0 = rightSupply s2
                                 in s1 `seq` (s0 `seq` nd_OP_slash_gt_eq x5
                                 (Curry_Prelude.nd_OP_dot (wrapDX (wrapDX id)
                                 (acceptCs id d_C_ret)) x3 s0 cd cs) s1 cd cs)
                               x8 = Curry_Prelude.nd_OP_dot x6 x4 s3 cd cs
    in HO_C_Conv x7 x8)))
  Choice_C_XmlConv d i l r -> narrow d i (nd_C__case_6 x4 x3 l s cd cs)
    (nd_C__case_6 x4 x3 r s cd cs)
  Choices_C_XmlConv d i xs -> narrows cs d i (\z -> nd_C__case_6 x4 x3 z s cd
    cs) xs
  Guard_C_XmlConv d c e -> guardCons d c ((\x -> nd_C__case_6 x4 x3 e s cd x) $!
    addCs c cs)
  Fail_C_XmlConv d info -> failCons d (traceFail "XmlConv._case_6" [show x4
    , show x3, show x2] info)
  _ -> failCons cd (consFail "XmlConv._case_6" (showCons x2))

d_C__case_5 :: forall t1 t0 t3 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t3, Curry_Prelude.Curry t2) => t1 -> t0 -> (t0
  -> Cover -> ConstStore -> t1) -> C_XmlConv t3 t2 t0 -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
d_C__case_5 x3 x4 x2 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (d_C_xmlShows x1 cd cs) x4 cd
    cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x3 x4 x2 x1 l
    cd cs) (d_C__case_5 x3 x4 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x3 x4
    x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x3 x4 x2
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "XmlConv._case_5"
    [show x3, show x4, show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "XmlConv._case_5" (showCons x5))

nd_C__case_5 :: forall t1 t0 t3 t2 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t2) => t1 -> t0 -> Func t0 t1 -> C_XmlConv t3 t2 t0 -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
nd_C__case_5 x3 x4 x2 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x1 s0 cd cs)
    x4 s1 cd cs))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_5 x3 x4 x2 x1 l
    s cd cs) (nd_C__case_5 x3 x4 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_5 x3
    x4 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_5 x3 x4
    x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "XmlConv._case_5"
    [show x3, show x4, show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "XmlConv._case_5" (showCons x5))

d_C__case_4 :: forall t2 t0 t1 t4 t3 t6 t5 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t6, Curry_Prelude.Curry
  t5) => t2 -> t0 -> t1 -> (t1 -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> t2) -> C_XmlConv t4 t3 t0 -> C_XmlConv t6 t5 t1
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
d_C__case_4 x4 x6 x5 x3 x1 x2 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply
    (d_C_xmlShows x2 cd cs) x5 cd cs) (Curry_Prelude.d_C_apply (d_C_xmlShows x1
    cd cs) x6 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x4 x6 x5 x3 x1
    x2 l cd cs) (d_C__case_4 x4 x6 x5 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x4 x6
    x5 x3 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x4 x6 x5
    x3 x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "XmlConv._case_4"
    [show x4, show x6, show x5, show x3, show x1, show x2, show x7] info)
  _ -> failCons cd (consFail "XmlConv._case_4" (showCons x7))

nd_C__case_4 :: forall t2 t0 t1 t4 t3 t6 t5 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t6, Curry_Prelude.Curry
  t5) => t2 -> t0 -> t1 -> Func t1 (Func t0 t2) -> C_XmlConv t4 t3 t0
  -> C_XmlConv t6 t5 t1 -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp))
nd_C__case_4 x4 x6 x5 x3 x1 x2 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s7 = s
    in s7 `seq` (let s6 = leftSupply s7
                     s8 = rightSupply s7
                     s2 = leftSupply s8
                     s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s2 `seq` (s5 `seq` Curry_Prelude.nd_OP_dot
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x2 s0 cd cs)
    x5 s1 cd cs)) (let s4 = leftSupply s5
                       s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x1 s3 cd cs)
    x6 s4 cd cs)) s6 cd cs))))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_4 x4 x6 x5 x3 x1
    x2 l s cd cs) (nd_C__case_4 x4 x6 x5 x3 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_4 x4
    x6 x5 x3 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_4 x4 x6
    x5 x3 x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "XmlConv._case_4"
    [show x4, show x6, show x5, show x3, show x1, show x2, show x7] info)
  _ -> failCons cd (consFail "XmlConv._case_4" (showCons x7))

d_C__case_3 :: forall t3 t0 t1 t2 t5 t4 t7 t6 t9 t8 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t5, Curry_Prelude.Curry t4, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t6, Curry_Prelude.Curry t9, Curry_Prelude.Curry
  t8) => t3 -> t0 -> t1 -> t2 -> (t2 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> t3) -> C_XmlConv t5 t4 t0
  -> C_XmlConv t7 t6 t1 -> C_XmlConv t9 t8 t2 -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
d_C__case_3 x5 x8 x7 x6 x4 x1 x2 x3 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply
    (d_C_xmlShows x3 cd cs) x6 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_apply (d_C_xmlShows x2 cd cs) x7 cd cs)
    (Curry_Prelude.d_C_apply (d_C_xmlShows x1 cd cs) x8 cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x5 x8 x7 x6 x4
    x1 x2 x3 l cd cs) (d_C__case_3 x5 x8 x7 x6 x4 x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x5 x8
    x7 x6 x4 x1 x2 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x5 x8 x7
    x6 x4 x1 x2 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "XmlConv._case_3"
    [show x5, show x8, show x7, show x6, show x4, show x1, show x2, show x3
    , show x9] info)
  _ -> failCons cd (consFail "XmlConv._case_3" (showCons x9))

nd_C__case_3 :: forall t3 t0 t1 t2 t5 t4 t7 t6 t9 t8 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t1, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t5, Curry_Prelude.Curry t4, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t6, Curry_Prelude.Curry t9, Curry_Prelude.Curry
  t8) => t3 -> t0 -> t1 -> t2 -> Func t2 (Func t1 (Func t0 t3)) -> C_XmlConv t5
  t4 t0 -> C_XmlConv t7 t6 t1 -> C_XmlConv t9 t8 t2 -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
nd_C__case_3 x5 x8 x7 x6 x4 x1 x2 x3 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s13 = s
    in s13 `seq` (let s12 = leftSupply s13
                      s14 = rightSupply s13
                      s2 = leftSupply s14
                      s10 = rightSupply s14
    in s12 `seq` (s14 `seq` (s2 `seq` (s10 `seq` Curry_Prelude.nd_OP_dot
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x3 s0 cd cs)
    x6 s1 cd cs)) (let s9 = leftSupply s10
                       s11 = rightSupply s10
                       s5 = leftSupply s11
                       s8 = rightSupply s11
    in s9 `seq` (s11 `seq` (s5 `seq` (s8 `seq` Curry_Prelude.nd_OP_dot
    (let s4 = leftSupply s5
         s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x2 s3 cd cs)
    x7 s4 cd cs)) (let s7 = leftSupply s8
                       s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x1 s6 cd cs)
    x8 s7 cd cs)) s9 cd cs)))) s12 cd cs))))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_3 x5 x8 x7 x6 x4
    x1 x2 x3 l s cd cs) (nd_C__case_3 x5 x8 x7 x6 x4 x1 x2 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_3 x5
    x8 x7 x6 x4 x1 x2 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_3 x5 x8
    x7 x6 x4 x1 x2 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "XmlConv._case_3"
    [show x5, show x8, show x7, show x6, show x4, show x1, show x2, show x3
    , show x9] info)
  _ -> failCons cd (consFail "XmlConv._case_3" (showCons x9))

d_C__case_2 :: forall t4 t0 t1 t2 t3 t6 t5 t8 t7 t10 t9 t12
  t11 . (Curry_Prelude.Curry t4, Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t3, Curry_Prelude.Curry t6
  , Curry_Prelude.Curry t5, Curry_Prelude.Curry t8, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t10, Curry_Prelude.Curry t9, Curry_Prelude.Curry t12
  , Curry_Prelude.Curry t11) => t4 -> t0 -> t1 -> t2 -> t3 -> (t3 -> Cover
  -> ConstStore -> t2 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0
  -> Cover -> ConstStore -> t4) -> C_XmlConv t6 t5 t0 -> C_XmlConv t8 t7 t1
  -> C_XmlConv t10 t9 t2 -> C_XmlConv t12 t11 t3 -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)
d_C__case_2 x6 x10 x9 x8 x7 x5 x1 x2 x3 x4 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply
    (d_C_xmlShows x4 cd cs) x7 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_apply (d_C_xmlShows x3 cd cs) x8 cd cs)
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply (d_C_xmlShows x2 cd cs) x9
    cd cs) (Curry_Prelude.d_C_apply (d_C_xmlShows x1 cd cs) x10 cd cs) cd cs) cd
    cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x6 x10 x9 x8 x7
    x5 x1 x2 x3 x4 l cd cs) (d_C__case_2 x6 x10 x9 x8 x7 x5 x1 x2 x3 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x6
    x10 x9 x8 x7 x5 x1 x2 x3 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x6 x10
    x9 x8 x7 x5 x1 x2 x3 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "XmlConv._case_2"
    [show x6, show x10, show x9, show x8, show x7, show x5, show x1, show x2
    , show x3, show x4, show x11] info)
  _ -> failCons cd (consFail "XmlConv._case_2" (showCons x11))

nd_C__case_2 :: forall t4 t0 t1 t2 t3 t6 t5 t8 t7 t10 t9 t12
  t11 . (Curry_Prelude.Curry t4, Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t3, Curry_Prelude.Curry t6
  , Curry_Prelude.Curry t5, Curry_Prelude.Curry t8, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t10, Curry_Prelude.Curry t9, Curry_Prelude.Curry t12
  , Curry_Prelude.Curry t11) => t4 -> t0 -> t1 -> t2 -> t3 -> Func t3 (Func t2
  (Func t1 (Func t0 t4))) -> C_XmlConv t6 t5 t0 -> C_XmlConv t8 t7 t1
  -> C_XmlConv t10 t9 t2 -> C_XmlConv t12 t11 t3 -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
nd_C__case_2 x6 x10 x9 x8 x7 x5 x1 x2 x3 x4 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s19 = s
    in s19 `seq` (let s18 = leftSupply s19
                      s20 = rightSupply s19
                      s2 = leftSupply s20
                      s16 = rightSupply s20
    in s18 `seq` (s20 `seq` (s2 `seq` (s16 `seq` Curry_Prelude.nd_OP_dot
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x4 s0 cd cs)
    x7 s1 cd cs)) (let s15 = leftSupply s16
                       s17 = rightSupply s16
                       s5 = leftSupply s17
                       s13 = rightSupply s17
    in s15 `seq` (s17 `seq` (s5 `seq` (s13 `seq` Curry_Prelude.nd_OP_dot
    (let s4 = leftSupply s5
         s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x3 s3 cd cs)
    x8 s4 cd cs)) (let s12 = leftSupply s13
                       s14 = rightSupply s13
                       s8 = leftSupply s14
                       s11 = rightSupply s14
    in s12 `seq` (s14 `seq` (s8 `seq` (s11 `seq` Curry_Prelude.nd_OP_dot
    (let s7 = leftSupply s8
         s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x2 s6 cd cs)
    x9 s7 cd cs)) (let s10 = leftSupply s11
                       s9 = rightSupply s11
    in s10 `seq` (s9 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x1 s9 cd cs)
    x10 s10 cd cs)) s12 cd cs)))) s15 cd cs)))) s18 cd cs))))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_2 x6 x10 x9 x8
    x7 x5 x1 x2 x3 x4 l s cd cs) (nd_C__case_2 x6 x10 x9 x8 x7 x5 x1 x2 x3 x4 r
    s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_2 x6
    x10 x9 x8 x7 x5 x1 x2 x3 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_2 x6 x10
    x9 x8 x7 x5 x1 x2 x3 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "XmlConv._case_2"
    [show x6, show x10, show x9, show x8, show x7, show x5, show x1, show x2
    , show x3, show x4, show x11] info)
  _ -> failCons cd (consFail "XmlConv._case_2" (showCons x11))

d_C__case_1 :: forall t5 t0 t1 t2 t3 t4 t7 t6 t9 t8 t11 t10 t13 t12 t15
  t14 . (Curry_Prelude.Curry t5, Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t3, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t7, Curry_Prelude.Curry t6, Curry_Prelude.Curry t9
  , Curry_Prelude.Curry t8, Curry_Prelude.Curry t11, Curry_Prelude.Curry t10
  , Curry_Prelude.Curry t13, Curry_Prelude.Curry t12, Curry_Prelude.Curry t15
  , Curry_Prelude.Curry t14) => t5 -> t0 -> t1 -> t2 -> t3 -> t4 -> (t4 -> Cover
  -> ConstStore -> t3 -> Cover -> ConstStore -> t2 -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t5) -> C_XmlConv t7 t6
  t0 -> C_XmlConv t9 t8 t1 -> C_XmlConv t11 t10 t2 -> C_XmlConv t13 t12 t3
  -> C_XmlConv t15 t14 t4 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)
d_C__case_1 x7 x12 x11 x10 x9 x8 x6 x1 x2 x3 x4 x5 x13 cd cs = case x13 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply
    (d_C_xmlShows x5 cd cs) x8 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_apply (d_C_xmlShows x4 cd cs) x9 cd cs)
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply (d_C_xmlShows x3 cd cs) x10
    cd cs) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply (d_C_xmlShows x2 cd
    cs) x11 cd cs) (Curry_Prelude.d_C_apply (d_C_xmlShows x1 cd cs) x12 cd cs)
    cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x7 x12 x11 x10
    x9 x8 x6 x1 x2 x3 x4 x5 l cd cs) (d_C__case_1 x7 x12 x11 x10 x9 x8 x6 x1 x2
    x3 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x7
    x12 x11 x10 x9 x8 x6 x1 x2 x3 x4 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x7 x12
    x11 x10 x9 x8 x6 x1 x2 x3 x4 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "XmlConv._case_1"
    [show x7, show x12, show x11, show x10, show x9, show x8, show x6, show x1
    , show x2, show x3, show x4, show x5, show x13] info)
  _ -> failCons cd (consFail "XmlConv._case_1" (showCons x13))

nd_C__case_1 :: forall t5 t0 t1 t2 t3 t4 t7 t6 t9 t8 t11 t10 t13 t12 t15
  t14 . (Curry_Prelude.Curry t5, Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t3, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t7, Curry_Prelude.Curry t6, Curry_Prelude.Curry t9
  , Curry_Prelude.Curry t8, Curry_Prelude.Curry t11, Curry_Prelude.Curry t10
  , Curry_Prelude.Curry t13, Curry_Prelude.Curry t12, Curry_Prelude.Curry t15
  , Curry_Prelude.Curry t14) => t5 -> t0 -> t1 -> t2 -> t3 -> t4 -> Func t4
  (Func t3 (Func t2 (Func t1 (Func t0 t5)))) -> C_XmlConv t7 t6 t0 -> C_XmlConv
  t9 t8 t1 -> C_XmlConv t11 t10 t2 -> C_XmlConv t13 t12 t3 -> C_XmlConv t15 t14
  t4 -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
nd_C__case_1 x7 x12 x11 x10 x9 x8 x6 x1 x2 x3 x4 x5 x13 s cd cs = case x13 of
  Curry_Prelude.C_True -> let s25 = s
    in s25 `seq` (let s24 = leftSupply s25
                      s26 = rightSupply s25
                      s2 = leftSupply s26
                      s22 = rightSupply s26
    in s24 `seq` (s26 `seq` (s2 `seq` (s22 `seq` Curry_Prelude.nd_OP_dot
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x5 s0 cd cs)
    x8 s1 cd cs)) (let s21 = leftSupply s22
                       s23 = rightSupply s22
                       s5 = leftSupply s23
                       s19 = rightSupply s23
    in s21 `seq` (s23 `seq` (s5 `seq` (s19 `seq` Curry_Prelude.nd_OP_dot
    (let s4 = leftSupply s5
         s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x4 s3 cd cs)
    x9 s4 cd cs)) (let s18 = leftSupply s19
                       s20 = rightSupply s19
                       s8 = leftSupply s20
                       s16 = rightSupply s20
    in s18 `seq` (s20 `seq` (s8 `seq` (s16 `seq` Curry_Prelude.nd_OP_dot
    (let s7 = leftSupply s8
         s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x3 s6 cd cs)
    x10 s7 cd cs)) (let s15 = leftSupply s16
                        s17 = rightSupply s16
                        s11 = leftSupply s17
                        s14 = rightSupply s17
    in s15 `seq` (s17 `seq` (s11 `seq` (s14 `seq` Curry_Prelude.nd_OP_dot
    (let s10 = leftSupply s11
         s9 = rightSupply s11
    in s10 `seq` (s9 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x2 s9 cd cs)
    x11 s10 cd cs)) (let s13 = leftSupply s14
                         s12 = rightSupply s14
    in s13 `seq` (s12 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x1 s12 cd
    cs) x12 s13 cd cs)) s15 cd cs)))) s18 cd cs)))) s21 cd cs)))) s24 cd cs))))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_1 x7 x12 x11 x10
    x9 x8 x6 x1 x2 x3 x4 x5 l s cd cs) (nd_C__case_1 x7 x12 x11 x10 x9 x8 x6 x1
    x2 x3 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_1 x7
    x12 x11 x10 x9 x8 x6 x1 x2 x3 x4 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_1 x7 x12
    x11 x10 x9 x8 x6 x1 x2 x3 x4 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "XmlConv._case_1"
    [show x7, show x12, show x11, show x10, show x9, show x8, show x6, show x1
    , show x2, show x3, show x4, show x5, show x13] info)
  _ -> failCons cd (consFail "XmlConv._case_1" (showCons x13))

d_C__case_0 :: forall t6 t0 t1 t2 t3 t4 t5 t8 t7 t10 t9 t12 t11 t14 t13 t16 t15
  t18 t17 . (Curry_Prelude.Curry t6, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry t3, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t5, Curry_Prelude.Curry t8, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t10, Curry_Prelude.Curry t9, Curry_Prelude.Curry t12
  , Curry_Prelude.Curry t11, Curry_Prelude.Curry t14, Curry_Prelude.Curry t13
  , Curry_Prelude.Curry t16, Curry_Prelude.Curry t15, Curry_Prelude.Curry t18
  , Curry_Prelude.Curry t17) => t6 -> t0 -> t1 -> t2 -> t3 -> t4 -> t5 -> (t5
  -> Cover -> ConstStore -> t4 -> Cover -> ConstStore -> t3 -> Cover
  -> ConstStore -> t2 -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t0
  -> Cover -> ConstStore -> t6) -> C_XmlConv t8 t7 t0 -> C_XmlConv t10 t9 t1
  -> C_XmlConv t12 t11 t2 -> C_XmlConv t14 t13 t3 -> C_XmlConv t16 t15 t4
  -> C_XmlConv t18 t17 t5 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_Prelude.OP_List Curry_XML.C_XmlExp) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_Prelude.OP_List
  Curry_XML.C_XmlExp)
d_C__case_0 x8 x14 x13 x12 x11 x10 x9 x7 x1 x2 x3 x4 x5 x6 x15 cd cs =
  case x15 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply
    (d_C_xmlShows x6 cd cs) x9 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_apply (d_C_xmlShows x5 cd cs) x10 cd cs)
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply (d_C_xmlShows x4 cd cs) x11
    cd cs) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply (d_C_xmlShows x3 cd
    cs) x12 cd cs) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply
    (d_C_xmlShows x2 cd cs) x13 cd cs) (Curry_Prelude.d_C_apply (d_C_xmlShows x1
    cd cs) x14 cd cs) cd cs) cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x8 x14 x13 x12
    x11 x10 x9 x7 x1 x2 x3 x4 x5 x6 l cd cs) (d_C__case_0 x8 x14 x13 x12 x11 x10
    x9 x7 x1 x2 x3 x4 x5 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x8
    x14 x13 x12 x11 x10 x9 x7 x1 x2 x3 x4 x5 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x8 x14
    x13 x12 x11 x10 x9 x7 x1 x2 x3 x4 x5 x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "XmlConv._case_0"
    [show x8, show x14, show x13, show x12, show x11, show x10, show x9, show x7
    , show x1, show x2, show x3, show x4, show x5, show x6, show x15] info)
  _ -> failCons cd (consFail "XmlConv._case_0" (showCons x15))

nd_C__case_0 :: forall t6 t0 t1 t2 t3 t4 t5 t8 t7 t10 t9 t12 t11 t14 t13 t16 t15
  t18 t17 . (Curry_Prelude.Curry t6, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t2, Curry_Prelude.Curry t3, Curry_Prelude.Curry t4
  , Curry_Prelude.Curry t5, Curry_Prelude.Curry t8, Curry_Prelude.Curry t7
  , Curry_Prelude.Curry t10, Curry_Prelude.Curry t9, Curry_Prelude.Curry t12
  , Curry_Prelude.Curry t11, Curry_Prelude.Curry t14, Curry_Prelude.Curry t13
  , Curry_Prelude.Curry t16, Curry_Prelude.Curry t15, Curry_Prelude.Curry t18
  , Curry_Prelude.Curry t17) => t6 -> t0 -> t1 -> t2 -> t3 -> t4 -> t5 -> Func
  t5 (Func t4 (Func t3 (Func t2 (Func t1 (Func t0 t6))))) -> C_XmlConv t8 t7 t0
  -> C_XmlConv t10 t9 t1 -> C_XmlConv t12 t11 t2 -> C_XmlConv t14 t13 t3
  -> C_XmlConv t16 t15 t4 -> C_XmlConv t18 t17 t5 -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_Prelude.OP_List Curry_XML.C_XmlExp))
nd_C__case_0 x8 x14 x13 x12 x11 x10 x9 x7 x1 x2 x3 x4 x5 x6 x15 s cd cs =
  case x15 of
  Curry_Prelude.C_True -> let s31 = s
    in s31 `seq` (let s30 = leftSupply s31
                      s32 = rightSupply s31
                      s2 = leftSupply s32
                      s28 = rightSupply s32
    in s30 `seq` (s32 `seq` (s2 `seq` (s28 `seq` Curry_Prelude.nd_OP_dot
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x6 s0 cd cs)
    x9 s1 cd cs)) (let s27 = leftSupply s28
                       s29 = rightSupply s28
                       s5 = leftSupply s29
                       s25 = rightSupply s29
    in s27 `seq` (s29 `seq` (s5 `seq` (s25 `seq` Curry_Prelude.nd_OP_dot
    (let s4 = leftSupply s5
         s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x5 s3 cd cs)
    x10 s4 cd cs)) (let s24 = leftSupply s25
                        s26 = rightSupply s25
                        s8 = leftSupply s26
                        s22 = rightSupply s26
    in s24 `seq` (s26 `seq` (s8 `seq` (s22 `seq` Curry_Prelude.nd_OP_dot
    (let s7 = leftSupply s8
         s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x4 s6 cd cs)
    x11 s7 cd cs)) (let s21 = leftSupply s22
                        s23 = rightSupply s22
                        s11 = leftSupply s23
                        s19 = rightSupply s23
    in s21 `seq` (s23 `seq` (s11 `seq` (s19 `seq` Curry_Prelude.nd_OP_dot
    (let s10 = leftSupply s11
         s9 = rightSupply s11
    in s10 `seq` (s9 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x3 s9 cd cs)
    x12 s10 cd cs)) (let s18 = leftSupply s19
                         s20 = rightSupply s19
                         s14 = leftSupply s20
                         s17 = rightSupply s20
    in s18 `seq` (s20 `seq` (s14 `seq` (s17 `seq` Curry_Prelude.nd_OP_dot
    (let s13 = leftSupply s14
         s12 = rightSupply s14
    in s13 `seq` (s12 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x2 s12 cd
    cs) x13 s13 cd cs)) (let s16 = leftSupply s17
                             s15 = rightSupply s17
    in s16 `seq` (s15 `seq` Curry_Prelude.nd_C_apply (nd_C_xmlShows x1 s15 cd
    cs) x14 s16 cd cs)) s18 cd cs)))) s21 cd cs)))) s24 cd cs)))) s27 cd cs))))
    s30 cd cs))))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_0 x8 x14 x13 x12
    x11 x10 x9 x7 x1 x2 x3 x4 x5 x6 l s cd cs) (nd_C__case_0 x8 x14 x13 x12 x11
    x10 x9 x7 x1 x2 x3 x4 x5 x6 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_0 x8
    x14 x13 x12 x11 x10 x9 x7 x1 x2 x3 x4 x5 x6 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_0 x8 x14
    x13 x12 x11 x10 x9 x7 x1 x2 x3 x4 x5 x6 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "XmlConv._case_0"
    [show x8, show x14, show x13, show x12, show x11, show x10, show x9, show x7
    , show x1, show x2, show x3, show x4, show x5, show x6, show x15] info)
  _ -> failCons cd (consFail "XmlConv._case_0" (showCons x15))

