{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module FlatCurry.Curry_Pretty
  ( C_Options (..)
  , C_QualMode (..)
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_Options_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_Options_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_Options_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
  , d_C_indentWidth
  , d_C_qualMode
  , d_C_currentModule
  , d_C_defaultOptions
  , d_C_ppProg
  , nd_C_ppProg
  , d_C_ppHeader
  , nd_C_ppHeader
  , d_C_ppExports
  , nd_C_ppExports
  , d_C_ppTypeExport
  , nd_C_ppTypeExport
  , d_C_ppConsExports
  , nd_C_ppConsExports
  , d_C_ppFuncExports
  , nd_C_ppFuncExports
  , d_C_ppImports
  , nd_C_ppImports
  , d_C_ppImport
  , nd_C_ppImport
  , d_C_ppOpDecls
  , nd_C_ppOpDecls
  , d_C_ppOpDecl
  , nd_C_ppOpDecl
  , d_C_ppFixity
  , nd_C_ppFixity
  , d_C_ppTypeDecls
  , nd_C_ppTypeDecls
  , d_C_ppTypeDecl
  , nd_C_ppTypeDecl
  , d_C_ppConsDecls
  , nd_C_ppConsDecls
  , d_C_ppConsDecl
  , nd_C_ppConsDecl
  , d_C_ppNewConsDecl
  , nd_C_ppNewConsDecl
  , d_C_ppTypeExp
  , nd_C_ppTypeExp
  , d_C_ppTypeExpr
  , nd_C_ppTypeExpr
  , d_C_ppQuantifiedVars
  , nd_C_ppQuantifiedVars
  , d_C_ppTVarIndex
  , nd_C_ppTVarIndex
  , d_C_ppFuncDecls
  , nd_C_ppFuncDecls
  , d_C_ppFuncDecl
  , nd_C_ppFuncDecl
  , d_C_ppRule
  , nd_C_ppRule
  , d_C_ppExp
  , nd_C_ppExp
  , d_C_ppExpr
  , nd_C_ppExpr
  , d_C_ppVarIndex
  , nd_C_ppVarIndex
  , d_C_ppLiteral
  , nd_C_ppLiteral
  , d_C_ppComb
  , nd_C_ppComb
  , d_C_ppDecls
  , nd_C_ppDecls
  , d_C_ppDecl
  , nd_C_ppDecl
  , d_C_ppCaseType
  , nd_C_ppCaseType
  , d_C_ppBranch
  , nd_C_ppBranch
  , d_C_ppPattern
  , nd_C_ppPattern
  , d_C_ppPrefixQOp
  , nd_C_ppPrefixQOp
  , d_C_ppPrefixOp
  , nd_C_ppPrefixOp
  , d_C_ppInfixQOp
  , nd_C_ppInfixQOp
  , d_C_ppQName
  , nd_C_ppQName
  , d_C_ppName
  , nd_C_ppName
  , d_C_isInfixOp
  , d_C_isConsId
  , d_C_isListId
  , d_C_isTupleId
  , d_C_indent
  , nd_C_indent )
  where

import Basics
import qualified FlatCurry.Curry_Types
import qualified Curry_Prelude
import qualified Text.Curry_Pretty
import qualified Text.Curry_PrettyImpl


data C_Options
  = C_Options Curry_Prelude.C_Int C_QualMode (Curry_Prelude.OP_List
    Curry_Prelude.C_Char)
  | Choice_C_Options Cover ID C_Options C_Options
  | Choices_C_Options Cover ID [C_Options]
  | Fail_C_Options Cover FailInfo
  | Guard_C_Options Cover Constraints C_Options

instance Show C_Options where
  showsPrec d (Choice_C_Options cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Options cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Options cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Options cd info) = showChar '!'
  showsPrec _ (C_Options x1 x2 x3) = showString "(Options" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . showChar
    ')'))))))

instance Read C_Options where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Options x1 x2 x3, r3) | (_
    , r0) <- readQualified "FlatCurry.Pretty" "Options" r, (x1, r1) <- readsPrec
    11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2]) s

instance NonDet C_Options where
  choiceCons = Choice_C_Options
  choicesCons = Choices_C_Options
  failCons = Fail_C_Options
  guardCons = Guard_C_Options
  try (Choice_C_Options cd i x y) = tryChoice cd i x y
  try (Choices_C_Options cd i xs) = tryChoices cd i xs
  try (Fail_C_Options cd info) = Fail cd info
  try (Guard_C_Options cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Options cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Options cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Options cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Options cd i _) = error
    ("FlatCurry.Pretty.Options.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Options cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Options cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Options where
  generate s c = Choices_C_Options c (freeID [3] s) [C_Options (generate
    (leftSupply (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c)
    (generate (rightSupply s) c)]

instance NormalForm C_Options where
  ($!!) cont (C_Options x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> cont (C_Options y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_Options cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Options cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Options cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_Options cd info) _ _ = failCons cd info
  ($##) cont (C_Options x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> cont (C_Options y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_Options cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Options cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Options cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_Options cd info) _ _ = failCons cd info
  showCons (C_Options _ _ _) = "FlatCurry.Pretty.Options _ _ _"
  showCons x = error ("FlatCurry.Pretty.Options.showCons: no constructor: " ++
    show x)
  searchNF search cont (C_Options x1 x2 x3) = search (\y1 -> search (\y2 ->
    search (\y3 -> cont (C_Options y1 y2 y3)) x3) x2) x1
  searchNF _ _ x = error
    ("FlatCurry.Pretty.Options.searchNF: no constructor: " ++ show x)

instance Unifiable C_Options where
  (=.=) (C_Options x1 x2 x3) (C_Options y1 y2 y3) d cs = (&) ((=:=) x1 y1 d cs)
    ((&) ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Options x1 x2 x3) (C_Options y1 y2 y3) d cs = (&) ((=:<=) x1 y1 d
    cs) ((&) ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Options x3 x4 x5) = (i :=: ChooseN 0 3) : concat [bind cd (leftID
    (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (rightID i) x5]
  bind d i (Choice_C_Options cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_Options cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Options cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_Options cd i _) = error
    ("FlatCurry.Pretty.Options.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Options cd info) = [Unsolvable info]
  bind d i (Guard_C_Options cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Options x3 x4 x5) = (i :=: ChooseN 0 3) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x5)]
  lazyBind d i (Choice_C_Options cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Options cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_Options cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Options cd i _) = error
    ("FlatCurry.Pretty.Options.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Options cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Options cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Options where

data C_QualMode
  = C_QualNone
  | C_QualImportsButPrelude
  | C_QualImports
  | C_QualAll
  | Choice_C_QualMode Cover ID C_QualMode C_QualMode
  | Choices_C_QualMode Cover ID [C_QualMode]
  | Fail_C_QualMode Cover FailInfo
  | Guard_C_QualMode Cover Constraints C_QualMode

instance Show C_QualMode where
  showsPrec d (Choice_C_QualMode cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_QualMode cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_QualMode cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_QualMode cd info) = showChar '!'
  showsPrec _ C_QualNone = showString "QualNone"
  showsPrec _ C_QualImportsButPrelude = showString "QualImportsButPrelude"
  showsPrec _ C_QualImports = showString "QualImports"
  showsPrec _ C_QualAll = showString "QualAll"

instance Read C_QualMode where
  readsPrec _ s = readParen False (\r -> [(C_QualNone, r0) | (_, r0) <-
    readQualified "FlatCurry.Pretty" "QualNone" r]) s ++ (readParen False (\r ->
    [(C_QualImportsButPrelude, r0) | (_, r0) <- readQualified "FlatCurry.Pretty"
    "QualImportsButPrelude" r]) s ++ (readParen False (\r -> [(C_QualImports
    , r0) | (_, r0) <- readQualified "FlatCurry.Pretty" "QualImports" r]) s ++
    readParen False (\r -> [(C_QualAll, r0) | (_, r0) <- readQualified
    "FlatCurry.Pretty" "QualAll" r]) s))

instance NonDet C_QualMode where
  choiceCons = Choice_C_QualMode
  choicesCons = Choices_C_QualMode
  failCons = Fail_C_QualMode
  guardCons = Guard_C_QualMode
  try (Choice_C_QualMode cd i x y) = tryChoice cd i x y
  try (Choices_C_QualMode cd i xs) = tryChoices cd i xs
  try (Fail_C_QualMode cd info) = Fail cd info
  try (Guard_C_QualMode cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_QualMode cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_QualMode cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_QualMode cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_QualMode cd i _) = error
    ("FlatCurry.Pretty.QualMode.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_QualMode cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_QualMode cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_QualMode where
  generate s c = Choices_C_QualMode c (freeID [0, 0, 0, 0] s) [C_QualNone
    , C_QualImportsButPrelude, C_QualImports, C_QualAll]

instance NormalForm C_QualMode where
  ($!!) cont C_QualNone d cs = cont C_QualNone d cs
  ($!!) cont C_QualImportsButPrelude d cs = cont C_QualImportsButPrelude d cs
  ($!!) cont C_QualImports d cs = cont C_QualImports d cs
  ($!!) cont C_QualAll d cs = cont C_QualAll d cs
  ($!!) cont (Choice_C_QualMode cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_QualMode cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_QualMode cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_QualMode cd info) _ _ = failCons cd info
  ($##) cont C_QualNone d cs = cont C_QualNone d cs
  ($##) cont C_QualImportsButPrelude d cs = cont C_QualImportsButPrelude d cs
  ($##) cont C_QualImports d cs = cont C_QualImports d cs
  ($##) cont C_QualAll d cs = cont C_QualAll d cs
  ($##) cont (Choice_C_QualMode cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_QualMode cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_QualMode cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_QualMode cd info) _ _ = failCons cd info
  showCons C_QualNone = "FlatCurry.Pretty.QualNone"
  showCons C_QualImportsButPrelude = "FlatCurry.Pretty.QualImportsButPrelude"
  showCons C_QualImports = "FlatCurry.Pretty.QualImports"
  showCons C_QualAll = "FlatCurry.Pretty.QualAll"
  showCons x = error ("FlatCurry.Pretty.QualMode.showCons: no constructor: " ++
    show x)
  searchNF _ cont C_QualNone = cont C_QualNone
  searchNF _ cont C_QualImportsButPrelude = cont C_QualImportsButPrelude
  searchNF _ cont C_QualImports = cont C_QualImports
  searchNF _ cont C_QualAll = cont C_QualAll
  searchNF _ _ x = error
    ("FlatCurry.Pretty.QualMode.searchNF: no constructor: " ++ show x)

instance Unifiable C_QualMode where
  (=.=) C_QualNone C_QualNone d cs = C_True
  (=.=) C_QualImportsButPrelude C_QualImportsButPrelude d cs = C_True
  (=.=) C_QualImports C_QualImports d cs = C_True
  (=.=) C_QualAll C_QualAll d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_QualNone C_QualNone d cs = C_True
  (=.<=) C_QualImportsButPrelude C_QualImportsButPrelude d cs = C_True
  (=.<=) C_QualImports C_QualImports d cs = C_True
  (=.<=) C_QualAll C_QualAll d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_QualNone = (i :=: ChooseN 0 0) : concat []
  bind cd i C_QualImportsButPrelude = (i :=: ChooseN 1 0) : concat []
  bind cd i C_QualImports = (i :=: ChooseN 2 0) : concat []
  bind cd i C_QualAll = (i :=: ChooseN 3 0) : concat []
  bind d i (Choice_C_QualMode cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_QualMode cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_QualMode cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_QualMode cd i _) = error
    ("FlatCurry.Pretty.QualMode.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_QualMode cd info) = [Unsolvable info]
  bind d i (Guard_C_QualMode cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_QualNone = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_QualImportsButPrelude = (i :=: ChooseN 1 0) : []
  lazyBind cd i C_QualImports = (i :=: ChooseN 2 0) : []
  lazyBind cd i C_QualAll = (i :=: ChooseN 3 0) : []
  lazyBind d i (Choice_C_QualMode cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_QualMode cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_QualMode cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_QualMode cd i _) = error
    ("FlatCurry.Pretty.QualMode.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_QualMode cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_QualMode cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_QualMode where

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_QualMode
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "FlatCurry.Pretty._inst#Prelude.Eq#FlatCurry.Pretty.QualMode#" [show x1]
    info)
  _ -> failCons cd (consFail
    "FlatCurry.Pretty._inst#Prelude.Eq#FlatCurry.Pretty.QualMode#" (showCons
    x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_QualMode
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "FlatCurry.Pretty._inst#Prelude.Eq#FlatCurry.Pretty.QualMode#" [show x1]
    info)
  _ -> failCons cd (consFail
    "FlatCurry.Pretty._inst#Prelude.Eq#FlatCurry.Pretty.QualMode#" (showCons
    x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash :: C_QualMode
  -> C_QualMode -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash x1 x2 cd cs =
  case x1 of
  C_QualNone -> let x3 = Curry_Prelude.C_False in d_C__case_56 x3 x2 cd cs
  C_QualImportsButPrelude -> let x4 = Curry_Prelude.C_False
    in d_C__case_55 x4 x2 cd cs
  C_QualImports -> let x5 = Curry_Prelude.C_False in d_C__case_54 x5 x2 cd cs
  C_QualAll -> let x6 = Curry_Prelude.C_False in d_C__case_53 x6 x2 cd cs
  Choice_C_QualMode d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    r x2 cd cs)
  Choices_C_QualMode d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    z x2 cd cs) xs
  Guard_C_QualMode d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_QualMode d info -> failCons d (traceFail
    "FlatCurry.Pretty._impl#==#Prelude.Eq#FlatCurry.Pretty.QualMode#" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Pretty._impl#==#Prelude.Eq#FlatCurry.Pretty.QualMode#" (showCons
    x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash :: Cover
  -> ConstStore -> C_QualMode -> Cover -> ConstStore -> C_QualMode -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash)

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_Options_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Options
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_Options_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_Options_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_Options_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_Options_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_Options_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_Options_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_Options_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "FlatCurry.Pretty._inst#Prelude.Data#FlatCurry.Pretty.Options#" [show x1]
    info)
  _ -> failCons cd (consFail
    "FlatCurry.Pretty._inst#Prelude.Data#FlatCurry.Pretty.Options#" (showCons
    x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_Options_hash :: C_Options
  -> C_Options -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_Options_hash x1 x2 s cd cs =
  case x1 of
  C_Options x3 x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_52 x5 x4 x3 x2 s0 cd cs
  Choice_C_Options d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_Options_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_Options_hash
    r x2 s cd cs)
  Choices_C_Options d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_Options_hash
    z x2 s cd cs) xs
  Guard_C_Options d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_Options_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_Options d info -> failCons d (traceFail
    "FlatCurry.Pretty._impl#===#Prelude.Data#FlatCurry.Pretty.Options#" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Pretty._impl#===#Prelude.Data#FlatCurry.Pretty.Options#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_Options_hash :: IDSupply
  -> Cover -> ConstStore -> C_Options
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_Options_hash s cd cs =
  let s3 = s
  in s3 `seq` (let s0 = leftSupply s3
                   s4 = rightSupply s3
                   s1 = leftSupply s4
                   s2 = rightSupply s4
  in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` C_Options
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s0 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
  s1 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s2 cd cs)))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_QualMode
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "FlatCurry.Pretty._inst#Prelude.Data#FlatCurry.Pretty.QualMode#" [show x1]
    info)
  _ -> failCons cd (consFail
    "FlatCurry.Pretty._inst#Prelude.Data#FlatCurry.Pretty.QualMode#" (showCons
    x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash :: C_QualMode
  -> C_QualMode -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash x1 x2 cd cs =
  case x1 of
  C_QualNone -> d_C__case_51 x2 cd cs
  C_QualImportsButPrelude -> d_C__case_50 x2 cd cs
  C_QualImports -> d_C__case_49 x2 cd cs
  C_QualAll -> d_C__case_48 x2 cd cs
  Choice_C_QualMode d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    r x2 cd cs)
  Choices_C_QualMode d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    z x2 cd cs) xs
  Guard_C_QualMode d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_QualMode d info -> failCons d (traceFail
    "FlatCurry.Pretty._impl#===#Prelude.Data#FlatCurry.Pretty.QualMode#" [show
    x1, show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Pretty._impl#===#Prelude.Data#FlatCurry.Pretty.QualMode#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash :: IDSupply
  -> Cover -> ConstStore -> C_QualMode
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash s cd cs =
  let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` choice (let s1 = leftSupply s2
                                    s0 = rightSupply s2
  in s1 `seq` (s0 `seq` choice (choice C_QualNone C_QualImportsButPrelude s0 cd
  cs) C_QualImports s1 cd cs)) C_QualAll s3 cd cs))

d_C_indentWidth :: C_Options -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_indentWidth x1 cd cs = case x1 of
  C_Options x2 x3 x4 -> x2
  Choice_C_Options d i l r -> narrow d i (d_C_indentWidth l cd cs)
    (d_C_indentWidth r cd cs)
  Choices_C_Options d i xs -> narrows cs d i (\z -> d_C_indentWidth z cd cs) xs
  Guard_C_Options d c e -> guardCons d c ((\x -> d_C_indentWidth e cd x) $!
    addCs c cs)
  Fail_C_Options d info -> failCons d (traceFail "FlatCurry.Pretty.indentWidth"
    [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.indentWidth" (showCons x1))

d_C_qualMode :: C_Options -> Cover -> ConstStore -> C_QualMode
d_C_qualMode x1 cd cs = case x1 of
  C_Options x2 x3 x4 -> x3
  Choice_C_Options d i l r -> narrow d i (d_C_qualMode l cd cs) (d_C_qualMode r
    cd cs)
  Choices_C_Options d i xs -> narrows cs d i (\z -> d_C_qualMode z cd cs) xs
  Guard_C_Options d c e -> guardCons d c ((\x -> d_C_qualMode e cd x) $! addCs c
    cs)
  Fail_C_Options d info -> failCons d (traceFail "FlatCurry.Pretty.qualMode"
    [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.qualMode" (showCons x1))

d_C_currentModule :: C_Options -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_currentModule x1 cd cs = case x1 of
  C_Options x2 x3 x4 -> x4
  Choice_C_Options d i l r -> narrow d i (d_C_currentModule l cd cs)
    (d_C_currentModule r cd cs)
  Choices_C_Options d i xs -> narrows cs d i (\z -> d_C_currentModule z cd cs)
    xs
  Guard_C_Options d c e -> guardCons d c ((\x -> d_C_currentModule e cd x) $!
    addCs c cs)
  Fail_C_Options d info -> failCons d (traceFail
    "FlatCurry.Pretty.currentModule" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.currentModule" (showCons x1))

d_C_defaultOptions :: Cover -> ConstStore -> C_Options
d_C_defaultOptions cd cs = C_Options (Curry_Prelude.C_Int (2))
  C_QualImportsButPrelude Curry_Prelude.OP_List

d_C_ppProg :: C_Options -> FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C_ppProg x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Prog x3 x4 x5 x6 x7 -> let x8 = d_C__case_47 x3 x1 cd
                                                       cs
    in Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_C_vsepBlank cd cs)
    (Curry_Prelude.OP_Cons (d_C_ppHeader x8 x3 x5 x6 cd cs)
    (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (d_C_ppImports x8 cd cs) x4
    cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (d_C_ppOpDecls x8 cd
    cs) x7 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
    (d_C_ppTypeDecls x8 cd cs) x5 cd cs) (Curry_Prelude.OP_Cons
    (Curry_Prelude.d_C_apply (d_C_ppFuncDecls x8 cd cs) x6 cd cs)
    Curry_Prelude.OP_List))))) cd cs
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i (d_C_ppProg x1 l cd
    cs) (d_C_ppProg x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C_ppProg x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c ((\x -> d_C_ppProg
    x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppProg" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppProg" (showCons x2))

nd_C_ppProg :: C_Options -> FlatCurry.Curry_Types.C_Prog -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppProg x1 x2 s cd cs = case x2 of
  FlatCurry.Curry_Types.C_Prog x3 x4 x5 x6 x7 -> let s19 = s
    in s19 `seq` (let x8 = d_C__case_47 x3 x1 cd cs
    in let s18 = leftSupply s19
           s20 = rightSupply s19
           s0 = leftSupply s20
           s17 = rightSupply s20
    in s18 `seq` (s20 `seq` (s0 `seq` (s17 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_vsepBlank s0 cd cs) (let s1 = leftSupply s17
                                                     s16 = rightSupply s17
    in s1 `seq` (s16 `seq` Curry_Prelude.OP_Cons (nd_C_ppHeader x8 x3 x5 x6 s1
    cd cs) (let s4 = leftSupply s16
                s15 = rightSupply s16
    in s4 `seq` (s15 `seq` Curry_Prelude.OP_Cons (let s3 = leftSupply s4
                                                      s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (nd_C_ppImports x8 s2 cd cs)
    x4 s3 cd cs)) (let s7 = leftSupply s15
                       s14 = rightSupply s15
    in s7 `seq` (s14 `seq` Curry_Prelude.OP_Cons (let s6 = leftSupply s7
                                                      s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (nd_C_ppOpDecls x8 s5 cd cs)
    x7 s6 cd cs)) (let s10 = leftSupply s14
                       s13 = rightSupply s14
    in s10 `seq` (s13 `seq` Curry_Prelude.OP_Cons (let s9 = leftSupply s10
                                                       s8 = rightSupply s10
    in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (nd_C_ppTypeDecls x8 s8 cd
    cs) x5 s9 cd cs)) (Curry_Prelude.OP_Cons (let s12 = leftSupply s13
                                                  s11 = rightSupply s13
    in s12 `seq` (s11 `seq` Curry_Prelude.nd_C_apply (nd_C_ppFuncDecls x8 s11 cd
    cs) x6 s12 cd cs)) Curry_Prelude.OP_List))))))))) s18 cd cs))))
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i (nd_C_ppProg x1 l s
    cd cs) (nd_C_ppProg x1 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    nd_C_ppProg x1 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c ((\x -> nd_C_ppProg
    x1 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppProg" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppProg" (showCons x2))

d_C_ppHeader :: C_Options -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeDecl
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_FuncDecl -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppHeader x1 x2 x3 x4 cd cs = Curry_Prelude.d_OP_dollar (d_C_indent x1)
  (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_C_sep cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Text.Curry_Pretty.d_C_text
  (Curry_Prelude.toCurryString "module") cd cs) cd cs)
  (Text.Curry_Pretty.d_C_text x2 cd cs) cd cs) (Curry_Prelude.OP_Cons
  (d_C_ppExports x1 x3 x4 cd cs) (Curry_Prelude.OP_Cons
  (Text.Curry_Pretty.d_C_text (Curry_Prelude.toCurryString "where") cd cs)
  Curry_Prelude.OP_List))) cd cs) cd cs

nd_C_ppHeader :: C_Options -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeDecl
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_FuncDecl -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppHeader x1 x2 x3 x4 s cd cs = let s18 = s
  in s18 `seq` (let s17 = leftSupply s18
                    s15 = rightSupply s18
  in s17 `seq` (s15 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_indent
  x1)) (let s14 = leftSupply s15
            s16 = rightSupply s15
            s0 = leftSupply s16
            s13 = rightSupply s16
  in s14 `seq` (s16 `seq` (s0 `seq` (s13 `seq` Curry_Prelude.nd_C_apply
  (Text.Curry_Pretty.nd_C_sep s0 cd cs) (let s8 = leftSupply s13
                                             s12 = rightSupply s13
  in s8 `seq` (s12 `seq` Curry_Prelude.OP_Cons (let s7 = leftSupply s8
                                                    s9 = rightSupply s8
                                                    s4 = leftSupply s9
                                                    s6 = rightSupply s9
  in s7 `seq` (s9 `seq` (s4 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
  (let s3 = leftSupply s4
       s5 = rightSupply s4
       s1 = leftSupply s5
       s2 = rightSupply s5
  in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
  (Text.Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (Text.Curry_Pretty.nd_C_text
  (Curry_Prelude.toCurryString "module") s2 cd cs) s3 cd cs))))
  (Text.Curry_Pretty.nd_C_text x2 s6 cd cs) s7 cd cs)))) (let s10 = leftSupply
                                                                s12
                                                              s11 = rightSupply
                                                                s12
  in s10 `seq` (s11 `seq` Curry_Prelude.OP_Cons (nd_C_ppExports x1 x3 x4 s10 cd
  cs) (Curry_Prelude.OP_Cons (Text.Curry_Pretty.nd_C_text
  (Curry_Prelude.toCurryString "where") s11 cd cs) Curry_Prelude.OP_List)))))
  s14 cd cs)))) s17 cd cs))

d_C_ppExports :: C_Options -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_FuncDecl -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C_ppExports x1 x2 x3 cd cs = Curry_Prelude.d_C_apply
  (Text.Curry_Pretty.d_C_tupledSpaced cd cs) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.d_C_map (d_C_ppTypeExport x1) x2 cd cs) (d_C_ppFuncExports x1
  x3 cd cs) cd cs) cd cs

nd_C_ppExports :: C_Options -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_FuncDecl -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppExports x1 x2 x3 s cd cs = let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s0 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (Text.Curry_Pretty.nd_C_tupledSpaced s0 cd cs) (let s1 = leftSupply s3
                                                      s2 = rightSupply s3
  in s1 `seq` (s2 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_map
  (wrapNX id (nd_C_ppTypeExport x1)) x2 s1 cd cs) (nd_C_ppFuncExports x1 x3 s2
  cd cs) cd cs)) s4 cd cs))))

d_C_ppTypeExport :: C_Options -> FlatCurry.Curry_Types.C_TypeDecl -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppTypeExport x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Type x3 x4 x5 x6 -> d_C__case_46 x4 x6 x1 x3
    (FlatCurry.Curry_Types.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Types_dot_Visibility_hash
    x4 FlatCurry.Curry_Types.C_Private cd cs) cd cs
  FlatCurry.Curry_Types.C_TypeSyn x7 x8 x9 x10 -> d_C__case_42 x8 x7 x1
    (FlatCurry.Curry_Types.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Types_dot_Visibility_hash
    x8 FlatCurry.Curry_Types.C_Private cd cs) cd cs
  FlatCurry.Curry_Types.C_TypeNew x11 x12 x13 x14 -> d_C__case_40 x12 x11 x1 x14
    cd cs
  FlatCurry.Curry_Types.Choice_C_TypeDecl d i l r -> narrow d i
    (d_C_ppTypeExport x1 l cd cs) (d_C_ppTypeExport x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeDecl d i xs -> narrows cs d i (\z ->
    d_C_ppTypeExport x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeDecl d c e -> guardCons d c ((\x ->
    d_C_ppTypeExport x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeDecl d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppTypeExport" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppTypeExport" (showCons x2))

nd_C_ppTypeExport :: C_Options -> FlatCurry.Curry_Types.C_TypeDecl -> IDSupply
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppTypeExport x1 x2 s cd cs = case x2 of
  FlatCurry.Curry_Types.C_Type x3 x4 x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_46 x4 x6 x1 x3
    (FlatCurry.Curry_Types.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Types_dot_Visibility_hash
    x4 FlatCurry.Curry_Types.C_Private cd cs) s0 cd cs
  FlatCurry.Curry_Types.C_TypeSyn x7 x8 x9 x10 -> let s0 = s
    in s0 `seq` nd_C__case_42 x8 x7 x1
    (FlatCurry.Curry_Types.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Types_dot_Visibility_hash
    x8 FlatCurry.Curry_Types.C_Private cd cs) s0 cd cs
  FlatCurry.Curry_Types.C_TypeNew x11 x12 x13 x14 -> let s0 = s
    in s0 `seq` nd_C__case_40 x12 x11 x1 x14 s0 cd cs
  FlatCurry.Curry_Types.Choice_C_TypeDecl d i l r -> narrow d i
    (nd_C_ppTypeExport x1 l s cd cs) (nd_C_ppTypeExport x1 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeDecl d i xs -> narrows cs d i (\z ->
    nd_C_ppTypeExport x1 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeDecl d c e -> guardCons d c ((\x ->
    nd_C_ppTypeExport x1 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeDecl d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppTypeExport" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppTypeExport" (showCons x2))

d_OP_ppTypeExport_dot_isPublicCons_dot_12 :: FlatCurry.Curry_Types.C_ConsDecl
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_ppTypeExport_dot_isPublicCons_dot_12 x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Cons x2 x3 x4 x5 -> FlatCurry.Curry_Types.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Types_dot_Visibility_hash
    x4 FlatCurry.Curry_Types.C_Public cd cs
  FlatCurry.Curry_Types.Choice_C_ConsDecl d i l r -> narrow d i
    (d_OP_ppTypeExport_dot_isPublicCons_dot_12 l cd cs)
    (d_OP_ppTypeExport_dot_isPublicCons_dot_12 r cd cs)
  FlatCurry.Curry_Types.Choices_C_ConsDecl d i xs -> narrows cs d i (\z ->
    d_OP_ppTypeExport_dot_isPublicCons_dot_12 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_ConsDecl d c e -> guardCons d c ((\x ->
    d_OP_ppTypeExport_dot_isPublicCons_dot_12 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_ConsDecl d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppTypeExport.isPublicCons.12" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppTypeExport.isPublicCons.12"
    (showCons x1))

d_C_ppConsExports :: C_Options -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_ConsDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Text.Curry_PrettyImpl.C_Doc
d_C_ppConsExports x1 x2 cd cs = Curry_Prelude.d_C_foldr (acceptCs id
  (d_OP_ppConsExports_dot_uscore_hash_lambda20 x1)) Curry_Prelude.OP_List x2 cd
  cs

nd_C_ppConsExports :: C_Options -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_ConsDecl -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Text.Curry_PrettyImpl.C_Doc
nd_C_ppConsExports x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs id
  (nd_OP_ppConsExports_dot_uscore_hash_lambda20 x1))) Curry_Prelude.OP_List x2
  s0 cd cs

d_OP_ppConsExports_dot_uscore_hash_lambda20 :: C_Options
  -> FlatCurry.Curry_Types.C_ConsDecl -> Curry_Prelude.OP_List
  Text.Curry_PrettyImpl.C_Doc -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Text.Curry_PrettyImpl.C_Doc
d_OP_ppConsExports_dot_uscore_hash_lambda20 x1 x2 x3 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Cons x4 x5 x6 x7 -> d_C__case_37 x3 x4 x1 x6 cd cs
  FlatCurry.Curry_Types.Choice_C_ConsDecl d i l r -> narrow d i
    (d_OP_ppConsExports_dot_uscore_hash_lambda20 x1 l x3 cd cs)
    (d_OP_ppConsExports_dot_uscore_hash_lambda20 x1 r x3 cd cs)
  FlatCurry.Curry_Types.Choices_C_ConsDecl d i xs -> narrows cs d i (\z ->
    d_OP_ppConsExports_dot_uscore_hash_lambda20 x1 z x3 cd cs) xs
  FlatCurry.Curry_Types.Guard_C_ConsDecl d c e -> guardCons d c ((\x ->
    d_OP_ppConsExports_dot_uscore_hash_lambda20 x1 e x3 cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_ConsDecl d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppConsExports._#lambda20" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppConsExports._#lambda20"
    (showCons x2))

nd_OP_ppConsExports_dot_uscore_hash_lambda20 :: C_Options
  -> FlatCurry.Curry_Types.C_ConsDecl -> Curry_Prelude.OP_List
  Text.Curry_PrettyImpl.C_Doc -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Text.Curry_PrettyImpl.C_Doc
nd_OP_ppConsExports_dot_uscore_hash_lambda20 x1 x2 x3 s cd cs = case x2 of
  FlatCurry.Curry_Types.C_Cons x4 x5 x6 x7 -> let s0 = s
    in s0 `seq` nd_C__case_37 x3 x4 x1 x6 s0 cd cs
  FlatCurry.Curry_Types.Choice_C_ConsDecl d i l r -> narrow d i
    (nd_OP_ppConsExports_dot_uscore_hash_lambda20 x1 l x3 s cd cs)
    (nd_OP_ppConsExports_dot_uscore_hash_lambda20 x1 r x3 s cd cs)
  FlatCurry.Curry_Types.Choices_C_ConsDecl d i xs -> narrows cs d i (\z ->
    nd_OP_ppConsExports_dot_uscore_hash_lambda20 x1 z x3 s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_ConsDecl d c e -> guardCons d c ((\x ->
    nd_OP_ppConsExports_dot_uscore_hash_lambda20 x1 e x3 s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_ConsDecl d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppConsExports._#lambda20" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppConsExports._#lambda20"
    (showCons x2))

d_C_ppFuncExports :: C_Options -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_FuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Text.Curry_PrettyImpl.C_Doc
d_C_ppFuncExports x1 x2 cd cs = Curry_Prelude.d_C_foldr (acceptCs id
  (d_OP_ppFuncExports_dot_uscore_hash_lambda24 x1)) Curry_Prelude.OP_List x2 cd
  cs

nd_C_ppFuncExports :: C_Options -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_FuncDecl -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Text.Curry_PrettyImpl.C_Doc
nd_C_ppFuncExports x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs id
  (nd_OP_ppFuncExports_dot_uscore_hash_lambda24 x1))) Curry_Prelude.OP_List x2
  s0 cd cs

d_OP_ppFuncExports_dot_uscore_hash_lambda24 :: C_Options
  -> FlatCurry.Curry_Types.C_FuncDecl -> Curry_Prelude.OP_List
  Text.Curry_PrettyImpl.C_Doc -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Text.Curry_PrettyImpl.C_Doc
d_OP_ppFuncExports_dot_uscore_hash_lambda24 x1 x2 x3 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Func x4 x5 x6 x7 x8 -> d_C__case_36 x3 x4 x1 x6 cd cs
  FlatCurry.Curry_Types.Choice_C_FuncDecl d i l r -> narrow d i
    (d_OP_ppFuncExports_dot_uscore_hash_lambda24 x1 l x3 cd cs)
    (d_OP_ppFuncExports_dot_uscore_hash_lambda24 x1 r x3 cd cs)
  FlatCurry.Curry_Types.Choices_C_FuncDecl d i xs -> narrows cs d i (\z ->
    d_OP_ppFuncExports_dot_uscore_hash_lambda24 x1 z x3 cd cs) xs
  FlatCurry.Curry_Types.Guard_C_FuncDecl d c e -> guardCons d c ((\x ->
    d_OP_ppFuncExports_dot_uscore_hash_lambda24 x1 e x3 cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_FuncDecl d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppFuncExports._#lambda24" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppFuncExports._#lambda24"
    (showCons x2))

nd_OP_ppFuncExports_dot_uscore_hash_lambda24 :: C_Options
  -> FlatCurry.Curry_Types.C_FuncDecl -> Curry_Prelude.OP_List
  Text.Curry_PrettyImpl.C_Doc -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Text.Curry_PrettyImpl.C_Doc
nd_OP_ppFuncExports_dot_uscore_hash_lambda24 x1 x2 x3 s cd cs = case x2 of
  FlatCurry.Curry_Types.C_Func x4 x5 x6 x7 x8 -> let s0 = s
    in s0 `seq` nd_C__case_36 x3 x4 x1 x6 s0 cd cs
  FlatCurry.Curry_Types.Choice_C_FuncDecl d i l r -> narrow d i
    (nd_OP_ppFuncExports_dot_uscore_hash_lambda24 x1 l x3 s cd cs)
    (nd_OP_ppFuncExports_dot_uscore_hash_lambda24 x1 r x3 s cd cs)
  FlatCurry.Curry_Types.Choices_C_FuncDecl d i xs -> narrows cs d i (\z ->
    nd_OP_ppFuncExports_dot_uscore_hash_lambda24 x1 z x3 s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_FuncDecl d c e -> guardCons d c ((\x ->
    nd_OP_ppFuncExports_dot_uscore_hash_lambda24 x1 e x3 s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_FuncDecl d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppFuncExports._#lambda24" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppFuncExports._#lambda24"
    (showCons x2))

d_C_ppImports :: C_Options -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C_ppImports x1 cd cs = Curry_Prelude.d_OP_dot (Text.Curry_Pretty.d_C_vsep cd
  cs) (Curry_Prelude.d_C_map (d_C_ppImport x1)) cd cs

nd_C_ppImports :: C_Options -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Text.Curry_PrettyImpl.C_Doc
nd_C_ppImports x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (Text.Curry_Pretty.nd_C_vsep s0
  cd cs) (wrapNX id (Curry_Prelude.nd_C_map (wrapNX id (nd_C_ppImport x1)))) s1
  cd cs))

d_C_ppImport :: C_Options -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppImport x1 x2 cd cs = Curry_Prelude.d_OP_dollar (d_C_indent x1)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Text.Curry_Pretty.d_C_text
  (Curry_Prelude.toCurryString "import") cd cs) cd cs)
  (Text.Curry_Pretty.d_C_text x2 cd cs) cd cs) cd cs

nd_C_ppImport :: C_Options -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> IDSupply -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppImport x1 x2 s cd cs = let s10 = s
  in s10 `seq` (let s9 = leftSupply s10
                    s7 = rightSupply s10
  in s9 `seq` (s7 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_indent x1))
  (let s6 = leftSupply s7
       s8 = rightSupply s7
       s3 = leftSupply s8
       s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
  (let s2 = leftSupply s3
       s4 = rightSupply s3
       s0 = leftSupply s4
       s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Text.Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (Text.Curry_Pretty.nd_C_text
  (Curry_Prelude.toCurryString "import") s1 cd cs) s2 cd cs))))
  (Text.Curry_Pretty.nd_C_text x2 s5 cd cs) s6 cd cs)))) s9 cd cs))

d_C_ppOpDecls :: C_Options -> Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C_ppOpDecls x1 cd cs = Curry_Prelude.d_OP_dot (Text.Curry_Pretty.d_C_vsep cd
  cs) (Curry_Prelude.d_C_map (d_C_ppOpDecl x1)) cd cs

nd_C_ppOpDecls :: C_Options -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_OpDecl)
  Text.Curry_PrettyImpl.C_Doc
nd_C_ppOpDecls x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (Text.Curry_Pretty.nd_C_vsep s0
  cd cs) (wrapNX id (Curry_Prelude.nd_C_map (wrapNX id (nd_C_ppOpDecl x1)))) s1
  cd cs))

d_C_ppOpDecl :: C_Options -> FlatCurry.Curry_Types.C_OpDecl -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppOpDecl x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Op x3 x4 x5 -> Curry_Prelude.d_OP_dollar (d_C_indent
    x1) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (d_C_ppFixity x4 cd cs) cd cs) (Text.Curry_Pretty.d_C_int x5 cd cs) cd cs)
    cd cs) (d_C_ppInfixQOp x1 x3 cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_OpDecl d i l r -> narrow d i (d_C_ppOpDecl x1 l
    cd cs) (d_C_ppOpDecl x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_OpDecl d i xs -> narrows cs d i (\z ->
    d_C_ppOpDecl x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_OpDecl d c e -> guardCons d c ((\x ->
    d_C_ppOpDecl x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_OpDecl d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppOpDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppOpDecl" (showCons x2))

nd_C_ppOpDecl :: C_Options -> FlatCurry.Curry_Types.C_OpDecl -> IDSupply
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppOpDecl x1 x2 s cd cs = case x2 of
  FlatCurry.Curry_Types.C_Op x3 x4 x5 -> let s18 = s
    in s18 `seq` (let s17 = leftSupply s18
                      s15 = rightSupply s18
    in s17 `seq` (s15 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_indent
    x1)) (let s14 = leftSupply s15
              s16 = rightSupply s15
              s11 = leftSupply s16
              s13 = rightSupply s16
    in s14 `seq` (s16 `seq` (s11 `seq` (s13 `seq` Curry_Prelude.nd_C_apply
    (let s10 = leftSupply s11
         s12 = rightSupply s11
         s0 = leftSupply s12
         s8 = rightSupply s12
    in s10 `seq` (s12 `seq` (s0 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (let s7 = leftSupply s8
                                                       s9 = rightSupply s8
                                                       s4 = leftSupply s9
                                                       s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s4 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (let s3 = leftSupply s4
         s5 = rightSupply s4
         s1 = leftSupply s5
         s2 = rightSupply s5
    in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (nd_C_ppFixity x4 s2 cd cs) s3
    cd cs)))) (Text.Curry_Pretty.nd_C_int x5 s6 cd cs) s7 cd cs)))) s10 cd
    cs)))) (nd_C_ppInfixQOp x1 x3 s13 cd cs) s14 cd cs)))) s17 cd cs))
  FlatCurry.Curry_Types.Choice_C_OpDecl d i l r -> narrow d i (nd_C_ppOpDecl x1
    l s cd cs) (nd_C_ppOpDecl x1 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_OpDecl d i xs -> narrows cs d i (\z ->
    nd_C_ppOpDecl x1 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_OpDecl d c e -> guardCons d c ((\x ->
    nd_C_ppOpDecl x1 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_OpDecl d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppOpDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppOpDecl" (showCons x2))

d_C_ppFixity :: FlatCurry.Curry_Types.C_Fixity -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C_ppFixity x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_InfixOp -> Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "infix") cd cs
  FlatCurry.Curry_Types.C_InfixlOp -> Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "infixl") cd cs
  FlatCurry.Curry_Types.C_InfixrOp -> Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "infixr") cd cs
  FlatCurry.Curry_Types.Choice_C_Fixity d i l r -> narrow d i (d_C_ppFixity l cd
    cs) (d_C_ppFixity r cd cs)
  FlatCurry.Curry_Types.Choices_C_Fixity d i xs -> narrows cs d i (\z ->
    d_C_ppFixity z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Fixity d c e -> guardCons d c ((\x ->
    d_C_ppFixity e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Fixity d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppFixity" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppFixity" (showCons x1))

nd_C_ppFixity :: FlatCurry.Curry_Types.C_Fixity -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppFixity x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_InfixOp -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString
    "infix") s0 cd cs
  FlatCurry.Curry_Types.C_InfixlOp -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString
    "infixl") s0 cd cs
  FlatCurry.Curry_Types.C_InfixrOp -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString
    "infixr") s0 cd cs
  FlatCurry.Curry_Types.Choice_C_Fixity d i l r -> narrow d i (nd_C_ppFixity l s
    cd cs) (nd_C_ppFixity r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Fixity d i xs -> narrows cs d i (\z ->
    nd_C_ppFixity z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Fixity d c e -> guardCons d c ((\x ->
    nd_C_ppFixity e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Fixity d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppFixity" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppFixity" (showCons x1))

d_C_ppTypeDecls :: C_Options -> Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C_ppTypeDecls x1 cd cs = Curry_Prelude.d_OP_dot
  (Text.Curry_Pretty.d_C_vsepBlank cd cs) (Curry_Prelude.d_C_map (d_C_ppTypeDecl
  x1)) cd cs

nd_C_ppTypeDecls :: C_Options -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeDecl)
  Text.Curry_PrettyImpl.C_Doc
nd_C_ppTypeDecls x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot
  (Text.Curry_Pretty.nd_C_vsepBlank s0 cd cs) (wrapNX id (Curry_Prelude.nd_C_map
  (wrapNX id (nd_C_ppTypeDecl x1)))) s1 cd cs))

d_C_ppTypeDecl :: C_Options -> FlatCurry.Curry_Types.C_TypeDecl -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppTypeDecl x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Type x3 x4 x5 x6 -> Curry_Prelude.d_OP_dollar
    (d_C_indent x1) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_dollar_dollar cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "data") cd cs) cd cs) (d_C_ppName x3 cd cs) cd
    cs) cd cs) (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_C_hsep cd cs)
    (Curry_Prelude.OP_Cons (Text.Curry_Pretty.d_C_empty cd cs)
    (Curry_Prelude.d_C_map (Curry_Prelude.d_OP_dot d_C_ppTVarIndex
    Curry_Prelude.d_C_fst cd cs) x5 cd cs)) cd cs) cd cs) cd cs)
    (d_C_ppConsDecls x1 x6 cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_TypeSyn x7 x8 x9 x10 -> Curry_Prelude.d_OP_dollar
    (d_C_indent x1) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_slash_gt cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "type") cd cs) cd cs) (d_C_ppName x7 cd cs) cd
    cs) cd cs) (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_C_hsep cd cs)
    (Curry_Prelude.OP_Cons (Text.Curry_Pretty.d_C_empty cd cs)
    (Curry_Prelude.d_C_map (Curry_Prelude.d_OP_dot d_C_ppTVarIndex
    Curry_Prelude.d_C_fst cd cs) x9 cd cs)) cd cs) cd cs) cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Text.Curry_Pretty.d_C_equals cd
    cs) cd cs) (Curry_Prelude.d_C_apply (d_C_ppTypeExp x1 cd cs) x10 cd cs) cd
    cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_TypeNew x11 x12 x13 x14 -> Curry_Prelude.d_OP_dollar
    (d_C_indent x1) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_dollar_dollar cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "newtype") cd cs) cd cs) (d_C_ppName x11 cd cs)
    cd cs) cd cs) (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_C_hsep cd cs)
    (Curry_Prelude.OP_Cons (Text.Curry_Pretty.d_C_empty cd cs)
    (Curry_Prelude.d_C_map (Curry_Prelude.d_OP_dot d_C_ppTVarIndex
    Curry_Prelude.d_C_fst cd cs) x13 cd cs)) cd cs) cd cs) cd cs)
    (d_C_ppNewConsDecl x1 x14 cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_TypeDecl d i l r -> narrow d i (d_C_ppTypeDecl
    x1 l cd cs) (d_C_ppTypeDecl x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeDecl d i xs -> narrows cs d i (\z ->
    d_C_ppTypeDecl x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeDecl d c e -> guardCons d c ((\x ->
    d_C_ppTypeDecl x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeDecl d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppTypeDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppTypeDecl" (showCons x2))

nd_C_ppTypeDecl :: C_Options -> FlatCurry.Curry_Types.C_TypeDecl -> IDSupply
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppTypeDecl x1 x2 s cd cs = case x2 of
  FlatCurry.Curry_Types.C_Type x3 x4 x5 x6 -> let s34 = s
    in s34 `seq` (let s33 = leftSupply s34
                      s31 = rightSupply s34
    in s33 `seq` (s31 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_indent
    x1)) (let s30 = leftSupply s31
              s32 = rightSupply s31
              s27 = leftSupply s32
              s29 = rightSupply s32
    in s30 `seq` (s32 `seq` (s27 `seq` (s29 `seq` Curry_Prelude.nd_C_apply
    (let s26 = leftSupply s27
         s28 = rightSupply s27
         s0 = leftSupply s28
         s24 = rightSupply s28
    in s26 `seq` (s28 `seq` (s0 `seq` (s24 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_dollar_dollar s0 cd cs) (let s23 = leftSupply s24
                                                          s25 = rightSupply s24
                                                          s12 = leftSupply s25
                                                          s21 = rightSupply s25
    in s23 `seq` (s25 `seq` (s12 `seq` (s21 `seq` Curry_Prelude.nd_C_apply
    (let s11 = leftSupply s12
         s13 = rightSupply s12
         s1 = leftSupply s13
         s9 = rightSupply s13
    in s11 `seq` (s13 `seq` (s1 `seq` (s9 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (let s8 = leftSupply s9
                                                       s10 = rightSupply s9
                                                       s5 = leftSupply s10
                                                       s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s2 cd cs) (Text.Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "data") s3 cd cs) s4 cd cs)))) (nd_C_ppName x3
    s7 cd cs) s8 cd cs)))) s11 cd cs)))) (let s20 = leftSupply s21
                                              s22 = rightSupply s21
                                              s14 = leftSupply s22
                                              s19 = rightSupply s22
    in s20 `seq` (s22 `seq` (s14 `seq` (s19 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_hsep s14 cd cs) (let s15 = leftSupply s19
                                                 s18 = rightSupply s19
    in s15 `seq` (s18 `seq` Curry_Prelude.OP_Cons (Text.Curry_Pretty.nd_C_empty
    s15 cd cs) (let s17 = leftSupply s18
                    s16 = rightSupply s18
    in s17 `seq` (s16 `seq` Curry_Prelude.nd_C_map (Curry_Prelude.nd_OP_dot
    (wrapNX id nd_C_ppTVarIndex) (wrapDX id Curry_Prelude.d_C_fst) s16 cd cs) x5
    s17 cd cs)))) s20 cd cs)))) s23 cd cs)))) s26 cd cs)))) (nd_C_ppConsDecls x1
    x6 s29 cd cs) s30 cd cs)))) s33 cd cs))
  FlatCurry.Curry_Types.C_TypeSyn x7 x8 x9 x10 -> let s44 = s
    in s44 `seq` (let s43 = leftSupply s44
                      s41 = rightSupply s44
    in s43 `seq` (s41 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_indent
    x1)) (let s40 = leftSupply s41
              s42 = rightSupply s41
              s27 = leftSupply s42
              s38 = rightSupply s42
    in s40 `seq` (s42 `seq` (s27 `seq` (s38 `seq` Curry_Prelude.nd_C_apply
    (let s26 = leftSupply s27
         s28 = rightSupply s27
         s0 = leftSupply s28
         s24 = rightSupply s28
    in s26 `seq` (s28 `seq` (s0 `seq` (s24 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_slash_gt s0 cd cs) (let s23 = leftSupply s24
                                                        s25 = rightSupply s24
                                                        s12 = leftSupply s25
                                                        s21 = rightSupply s25
    in s23 `seq` (s25 `seq` (s12 `seq` (s21 `seq` Curry_Prelude.nd_C_apply
    (let s11 = leftSupply s12
         s13 = rightSupply s12
         s1 = leftSupply s13
         s9 = rightSupply s13
    in s11 `seq` (s13 `seq` (s1 `seq` (s9 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (let s8 = leftSupply s9
                                                       s10 = rightSupply s9
                                                       s5 = leftSupply s10
                                                       s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s2 cd cs) (Text.Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "type") s3 cd cs) s4 cd cs)))) (nd_C_ppName x7
    s7 cd cs) s8 cd cs)))) s11 cd cs)))) (let s20 = leftSupply s21
                                              s22 = rightSupply s21
                                              s14 = leftSupply s22
                                              s19 = rightSupply s22
    in s20 `seq` (s22 `seq` (s14 `seq` (s19 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_hsep s14 cd cs) (let s15 = leftSupply s19
                                                 s18 = rightSupply s19
    in s15 `seq` (s18 `seq` Curry_Prelude.OP_Cons (Text.Curry_Pretty.nd_C_empty
    s15 cd cs) (let s17 = leftSupply s18
                    s16 = rightSupply s18
    in s17 `seq` (s16 `seq` Curry_Prelude.nd_C_map (Curry_Prelude.nd_OP_dot
    (wrapNX id nd_C_ppTVarIndex) (wrapDX id Curry_Prelude.d_C_fst) s16 cd cs) x9
    s17 cd cs)))) s20 cd cs)))) s23 cd cs)))) s26 cd cs))))
    (let s37 = leftSupply s38
         s39 = rightSupply s38
         s32 = leftSupply s39
         s36 = rightSupply s39
    in s37 `seq` (s39 `seq` (s32 `seq` (s36 `seq` Curry_Prelude.nd_C_apply
    (let s31 = leftSupply s32
         s33 = rightSupply s32
         s29 = leftSupply s33
         s30 = rightSupply s33
    in s31 `seq` (s33 `seq` (s29 `seq` (s30 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s29 cd cs)
    (Text.Curry_Pretty.nd_C_equals s30 cd cs) s31 cd cs))))
    (let s35 = leftSupply s36
         s34 = rightSupply s36
    in s35 `seq` (s34 `seq` Curry_Prelude.nd_C_apply (nd_C_ppTypeExp x1 s34 cd
    cs) x10 s35 cd cs)) s37 cd cs)))) s40 cd cs)))) s43 cd cs))
  FlatCurry.Curry_Types.C_TypeNew x11 x12 x13 x14 -> let s34 = s
    in s34 `seq` (let s33 = leftSupply s34
                      s31 = rightSupply s34
    in s33 `seq` (s31 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_indent
    x1)) (let s30 = leftSupply s31
              s32 = rightSupply s31
              s27 = leftSupply s32
              s29 = rightSupply s32
    in s30 `seq` (s32 `seq` (s27 `seq` (s29 `seq` Curry_Prelude.nd_C_apply
    (let s26 = leftSupply s27
         s28 = rightSupply s27
         s0 = leftSupply s28
         s24 = rightSupply s28
    in s26 `seq` (s28 `seq` (s0 `seq` (s24 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_dollar_dollar s0 cd cs) (let s23 = leftSupply s24
                                                          s25 = rightSupply s24
                                                          s12 = leftSupply s25
                                                          s21 = rightSupply s25
    in s23 `seq` (s25 `seq` (s12 `seq` (s21 `seq` Curry_Prelude.nd_C_apply
    (let s11 = leftSupply s12
         s13 = rightSupply s12
         s1 = leftSupply s13
         s9 = rightSupply s13
    in s11 `seq` (s13 `seq` (s1 `seq` (s9 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (let s8 = leftSupply s9
                                                       s10 = rightSupply s9
                                                       s5 = leftSupply s10
                                                       s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s2 cd cs) (Text.Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "newtype") s3 cd cs) s4 cd cs)))) (nd_C_ppName
    x11 s7 cd cs) s8 cd cs)))) s11 cd cs)))) (let s20 = leftSupply s21
                                                  s22 = rightSupply s21
                                                  s14 = leftSupply s22
                                                  s19 = rightSupply s22
    in s20 `seq` (s22 `seq` (s14 `seq` (s19 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_hsep s14 cd cs) (let s15 = leftSupply s19
                                                 s18 = rightSupply s19
    in s15 `seq` (s18 `seq` Curry_Prelude.OP_Cons (Text.Curry_Pretty.nd_C_empty
    s15 cd cs) (let s17 = leftSupply s18
                    s16 = rightSupply s18
    in s17 `seq` (s16 `seq` Curry_Prelude.nd_C_map (Curry_Prelude.nd_OP_dot
    (wrapNX id nd_C_ppTVarIndex) (wrapDX id Curry_Prelude.d_C_fst) s16 cd cs)
    x13 s17 cd cs)))) s20 cd cs)))) s23 cd cs)))) s26 cd cs))))
    (nd_C_ppNewConsDecl x1 x14 s29 cd cs) s30 cd cs)))) s33 cd cs))
  FlatCurry.Curry_Types.Choice_C_TypeDecl d i l r -> narrow d i (nd_C_ppTypeDecl
    x1 l s cd cs) (nd_C_ppTypeDecl x1 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeDecl d i xs -> narrows cs d i (\z ->
    nd_C_ppTypeDecl x1 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeDecl d c e -> guardCons d c ((\x ->
    nd_C_ppTypeDecl x1 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeDecl d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppTypeDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppTypeDecl" (showCons x2))

d_C_ppConsDecls :: C_Options -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_ConsDecl -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C_ppConsDecls x1 x2 cd cs = Curry_Prelude.d_OP_dollar
  (Text.Curry_Pretty.d_C_vsep cd cs) (Curry_Prelude.d_C_zipWith
  (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Prelude.OP_Cons
  (Text.Curry_Pretty.d_C_equals cd cs) (Curry_Prelude.d_C_repeat
  (Text.Curry_Pretty.d_C_bar cd cs) cd cs)) (Curry_Prelude.d_C_map
  (d_C_ppConsDecl x1) x2 cd cs) cd cs) cd cs

nd_C_ppConsDecls :: C_Options -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_ConsDecl -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppConsDecls x1 x2 s cd cs = let s11 = s
  in s11 `seq` (let s10 = leftSupply s11
                    s12 = rightSupply s11
                    s0 = leftSupply s12
                    s7 = rightSupply s12
  in s10 `seq` (s12 `seq` (s0 `seq` (s7 `seq` Curry_Prelude.nd_OP_dollar
  (Text.Curry_Pretty.nd_C_vsep s0 cd cs) (let s8 = leftSupply s7
                                              s9 = rightSupply s7
                                              s6 = leftSupply s8
                                              s1 = rightSupply s8
                                              s4 = leftSupply s9
                                              s5 = rightSupply s9
  in s8 `seq` (s9 `seq` (s6 `seq` (s1 `seq` (s4 `seq` (s5 `seq`
  Curry_Prelude.nd_C_zipWith (Text.Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs)
  (let s2 = leftSupply s4
       s3 = rightSupply s4
  in s2 `seq` (s3 `seq` Curry_Prelude.OP_Cons (Text.Curry_Pretty.nd_C_equals s2
  cd cs) (Curry_Prelude.d_C_repeat (Text.Curry_Pretty.nd_C_bar s3 cd cs) cd
  cs))) (Curry_Prelude.nd_C_map (wrapNX id (nd_C_ppConsDecl x1)) x2 s5 cd cs) s6
  cd cs)))))) s10 cd cs))))

d_C_ppConsDecl :: C_Options -> FlatCurry.Curry_Types.C_ConsDecl -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppConsDecl x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Cons x3 x4 x5 x6 -> Curry_Prelude.d_OP_dollar
    (Text.Curry_Pretty.d_C_hsep cd cs) (Curry_Prelude.OP_Cons (d_C_ppPrefixOp x3
    cd cs) (Curry_Prelude.d_C_map (d_C_ppTypeExpr x1 (Curry_Prelude.C_Int (2)))
    x6 cd cs)) cd cs
  FlatCurry.Curry_Types.Choice_C_ConsDecl d i l r -> narrow d i (d_C_ppConsDecl
    x1 l cd cs) (d_C_ppConsDecl x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_ConsDecl d i xs -> narrows cs d i (\z ->
    d_C_ppConsDecl x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_ConsDecl d c e -> guardCons d c ((\x ->
    d_C_ppConsDecl x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_ConsDecl d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppConsDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppConsDecl" (showCons x2))

nd_C_ppConsDecl :: C_Options -> FlatCurry.Curry_Types.C_ConsDecl -> IDSupply
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppConsDecl x1 x2 s cd cs = case x2 of
  FlatCurry.Curry_Types.C_Cons x3 x4 x5 x6 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_OP_dollar
    (Text.Curry_Pretty.nd_C_hsep s0 cd cs) (let s1 = leftSupply s3
                                                s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixOp x3 s1 cd cs)
    (Curry_Prelude.nd_C_map (wrapNX id (nd_C_ppTypeExpr x1 (Curry_Prelude.C_Int
    (2)))) x6 s2 cd cs))) s4 cd cs))))
  FlatCurry.Curry_Types.Choice_C_ConsDecl d i l r -> narrow d i (nd_C_ppConsDecl
    x1 l s cd cs) (nd_C_ppConsDecl x1 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_ConsDecl d i xs -> narrows cs d i (\z ->
    nd_C_ppConsDecl x1 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_ConsDecl d c e -> guardCons d c ((\x ->
    nd_C_ppConsDecl x1 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_ConsDecl d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppConsDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppConsDecl" (showCons x2))

d_C_ppNewConsDecl :: C_Options -> FlatCurry.Curry_Types.C_NewConsDecl -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppNewConsDecl x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_NewCons x3 x4 x5 -> Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_C_hsep cd cs) (Curry_Prelude.OP_Cons (d_C_ppPrefixOp x3
    cd cs) (Curry_Prelude.OP_Cons (d_C_ppTypeExpr x1 (Curry_Prelude.C_Int (2))
    x5 cd cs) Curry_Prelude.OP_List)) cd cs
  FlatCurry.Curry_Types.Choice_C_NewConsDecl d i l r -> narrow d i
    (d_C_ppNewConsDecl x1 l cd cs) (d_C_ppNewConsDecl x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_NewConsDecl d i xs -> narrows cs d i (\z ->
    d_C_ppNewConsDecl x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_NewConsDecl d c e -> guardCons d c ((\x ->
    d_C_ppNewConsDecl x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_NewConsDecl d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppNewConsDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppNewConsDecl" (showCons x2))

nd_C_ppNewConsDecl :: C_Options -> FlatCurry.Curry_Types.C_NewConsDecl
  -> IDSupply -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppNewConsDecl x1 x2 s cd cs = case x2 of
  FlatCurry.Curry_Types.C_NewCons x3 x4 x5 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_hsep s0 cd cs) (let s1 = leftSupply s3
                                                s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixOp x3 s1 cd cs)
    (Curry_Prelude.OP_Cons (nd_C_ppTypeExpr x1 (Curry_Prelude.C_Int (2)) x5 s2
    cd cs) Curry_Prelude.OP_List))) s4 cd cs))))
  FlatCurry.Curry_Types.Choice_C_NewConsDecl d i l r -> narrow d i
    (nd_C_ppNewConsDecl x1 l s cd cs) (nd_C_ppNewConsDecl x1 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_NewConsDecl d i xs -> narrows cs d i (\z ->
    nd_C_ppNewConsDecl x1 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_NewConsDecl d c e -> guardCons d c ((\x ->
    nd_C_ppNewConsDecl x1 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_NewConsDecl d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppNewConsDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppNewConsDecl" (showCons x2))

d_C_ppTypeExp :: C_Options -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C_ppTypeExp x1 cd cs = d_C_ppTypeExpr x1 (Curry_Prelude.C_Int (0))

nd_C_ppTypeExp :: C_Options -> IDSupply -> Cover -> ConstStore -> Func
  FlatCurry.Curry_Types.C_TypeExpr Text.Curry_PrettyImpl.C_Doc
nd_C_ppTypeExp x1 s cd cs = wrapNX id (nd_C_ppTypeExpr x1 (Curry_Prelude.C_Int
  (0)))

d_C_ppTypeExpr :: C_Options -> Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C_ppTypeExpr x1 x2 x3 cd cs = case x3 of
  FlatCurry.Curry_Types.C_TVar x4 -> d_C_ppTVarIndex x4 cd cs
  FlatCurry.Curry_Types.C_FuncType x5 x6 -> Curry_Prelude.d_OP_dollar
    (Text.Curry_Pretty.d_C_parensIf (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.C_Int (0)) cd cs)) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_OP_lt_slash_gt cd cs)
    (d_C_ppTypeExpr x1 (Curry_Prelude.C_Int (1)) x5 cd cs) cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Text.Curry_Pretty.d_C_rarrow cd
    cs) cd cs) (Curry_Prelude.d_C_apply (d_C_ppTypeExp x1 cd cs) x6 cd cs) cd
    cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_TCons x7 x8 -> d_C__case_35 x8 x7 x1 x2
    (Curry_Prelude.d_OP_amp_amp (d_C_isListId x7 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_C_length x8 cd cs) (Curry_Prelude.C_Int (1)) cd cs) cd cs)
    cd cs
  FlatCurry.Curry_Types.C_ForallType x9 x10 -> d_C__case_32 x9 x10 x1 x2
    (Curry_Prelude.d_C_null x9 cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i (d_C_ppTypeExpr
    x1 x2 l cd cs) (d_C_ppTypeExpr x1 x2 r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    d_C_ppTypeExpr x1 x2 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c ((\x ->
    d_C_ppTypeExpr x1 x2 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppTypeExpr" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppTypeExpr" (showCons x3))

nd_C_ppTypeExpr :: C_Options -> Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppTypeExpr x1 x2 x3 s cd cs = case x3 of
  FlatCurry.Curry_Types.C_TVar x4 -> let s0 = s
    in s0 `seq` nd_C_ppTVarIndex x4 s0 cd cs
  FlatCurry.Curry_Types.C_FuncType x5 x6 -> let s23 = s
    in s23 `seq` (let s22 = leftSupply s23
                      s24 = rightSupply s23
                      s2 = leftSupply s24
                      s20 = rightSupply s24
    in s22 `seq` (s24 `seq` (s2 `seq` (s20 `seq` Curry_Prelude.nd_OP_dollar
    (wrapNX id (Text.Curry_Pretty.nd_C_parensIf (let s1 = leftSupply s2
                                                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs)) x2 s0 cd cs) (Curry_Prelude.C_Int (0)) s1 cd cs))))
    (let s19 = leftSupply s20
         s21 = rightSupply s20
         s6 = leftSupply s21
         s17 = rightSupply s21
    in s19 `seq` (s21 `seq` (s6 `seq` (s17 `seq` Curry_Prelude.nd_C_apply
    (let s5 = leftSupply s6
         s7 = rightSupply s6
         s3 = leftSupply s7
         s4 = rightSupply s7
    in s5 `seq` (s7 `seq` (s3 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_slash_gt s3 cd cs) (nd_C_ppTypeExpr x1
    (Curry_Prelude.C_Int (1)) x5 s4 cd cs) s5 cd cs)))) (let s16 = leftSupply
                                                               s17
                                                             s18 = rightSupply
                                                               s17
                                                             s11 = leftSupply
                                                               s18
                                                             s15 = rightSupply
                                                               s18
    in s16 `seq` (s18 `seq` (s11 `seq` (s15 `seq` Curry_Prelude.nd_C_apply
    (let s10 = leftSupply s11
         s12 = rightSupply s11
         s8 = leftSupply s12
         s9 = rightSupply s12
    in s10 `seq` (s12 `seq` (s8 `seq` (s9 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s8 cd cs) (Text.Curry_Pretty.nd_C_rarrow
    s9 cd cs) s10 cd cs)))) (let s14 = leftSupply s15
                                 s13 = rightSupply s15
    in s14 `seq` (s13 `seq` Curry_Prelude.nd_C_apply (nd_C_ppTypeExp x1 s13 cd
    cs) x6 s14 cd cs)) s16 cd cs)))) s19 cd cs)))) s22 cd cs))))
  FlatCurry.Curry_Types.C_TCons x7 x8 -> let s0 = s
    in s0 `seq` nd_C__case_35 x8 x7 x1 x2 (Curry_Prelude.d_OP_amp_amp
    (d_C_isListId x7 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_C_length x8 cd cs) (Curry_Prelude.C_Int (1)) cd cs) cd cs)
    s0 cd cs
  FlatCurry.Curry_Types.C_ForallType x9 x10 -> let s0 = s
    in s0 `seq` nd_C__case_32 x9 x10 x1 x2 (Curry_Prelude.d_C_null x9 cd cs) s0
    cd cs
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i (nd_C_ppTypeExpr
    x1 x2 l s cd cs) (nd_C_ppTypeExpr x1 x2 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    nd_C_ppTypeExpr x1 x2 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c ((\x ->
    nd_C_ppTypeExpr x1 x2 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppTypeExpr" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppTypeExpr" (showCons x3))

d_C_ppQuantifiedVars :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Kind) -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C_ppQuantifiedVars x1 cd cs = d_C__case_30 x1 (Curry_Prelude.d_C_null x1 cd
  cs) cd cs

nd_C_ppQuantifiedVars :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Kind) -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppQuantifiedVars x1 s cd cs = let s0 = s
  in s0 `seq` nd_C__case_30 x1 (Curry_Prelude.d_C_null x1 cd cs) s0 cd cs

d_C_ppTVarIndex :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C_ppTVarIndex x1 cd cs = let x2 = Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_concatMap
                                 d_OP_ppTVarIndex_dot_uscore_hash_lambda26 cd
                                 cs)
                                 (Curry_Prelude.d_OP_uscore_impl_hash_enumFrom_hash_Prelude_dot_Enum_hash_Prelude_dot_Int_hash
                                 (Curry_Prelude.C_Int (0)) cd cs) cd cs
  in Curry_Prelude.d_OP_dollar Text.Curry_Pretty.d_C_text
  (Curry_Prelude.d_OP_bang_bang x2 x1 cd cs) cd cs

nd_C_ppTVarIndex :: Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppTVarIndex x1 s cd cs = let s4 = s
  in s4 `seq` (let s2 = leftSupply s4
                   s3 = rightSupply s4
  in s2 `seq` (s3 `seq` (let x2 = let s1 = leftSupply s2
                                      s0 = rightSupply s2
                               in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
                               (Curry_Prelude.nd_C_concatMap (wrapDX id
                               d_OP_ppTVarIndex_dot_uscore_hash_lambda26) s0 cd
                               cs)
                               (Curry_Prelude.d_OP_uscore_impl_hash_enumFrom_hash_Prelude_dot_Enum_hash_Prelude_dot_Int_hash
                               (Curry_Prelude.C_Int (0)) cd cs) s1 cd cs)
  in Curry_Prelude.nd_OP_dollar (wrapNX id Text.Curry_Pretty.nd_C_text)
  (Curry_Prelude.d_OP_bang_bang x2 x1 cd cs) s3 cd cs)))

d_OP_ppTVarIndex_dot_uscore_hash_lambda26 :: Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_ppTVarIndex_dot_uscore_hash_lambda26 x1 cd cs = Curry_Prelude.d_C_map
  (d_OP_ppTVarIndex_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 x1)
  (Curry_Prelude.d_OP_uscore_impl_hash_enumFromTo_hash_Prelude_dot_Enum_hash_Prelude_dot_Int_hash
  (Curry_Prelude.d_C_ord (Curry_Prelude.C_Char 'a'#) cd cs)
  (Curry_Prelude.d_C_ord (Curry_Prelude.C_Char 'z'#) cd cs) cd cs) cd cs

d_OP_ppTVarIndex_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 :: Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_ppTVarIndex_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 x1 x2 cd cs =
  Curry_Prelude.OP_Cons (Curry_Prelude.d_C_chr x2 cd cs) (d_C__case_28 x1
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  x1 (Curry_Prelude.C_Int (0)) cd cs) cd cs)

d_C_ppFuncDecls :: C_Options -> Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_FuncDecl -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C_ppFuncDecls x1 cd cs = Curry_Prelude.d_OP_dot
  (Text.Curry_Pretty.d_C_vsepBlank cd cs) (Curry_Prelude.d_C_map (d_C_ppFuncDecl
  x1)) cd cs

nd_C_ppFuncDecls :: C_Options -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_FuncDecl)
  Text.Curry_PrettyImpl.C_Doc
nd_C_ppFuncDecls x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot
  (Text.Curry_Pretty.nd_C_vsepBlank s0 cd cs) (wrapNX id (Curry_Prelude.nd_C_map
  (wrapNX id (nd_C_ppFuncDecl x1)))) s1 cd cs))

d_C_ppFuncDecl :: C_Options -> FlatCurry.Curry_Types.C_FuncDecl -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppFuncDecl x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Func x3 x4 x5 x6 x7 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_OP_dollar_dollar cd cs)
    (d_C_indent x1 (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_C_sep cd cs)
    (Curry_Prelude.OP_Cons (d_C_ppPrefixOp x3 cd cs) (Curry_Prelude.OP_Cons
    (Text.Curry_Pretty.d_C_text (Curry_Prelude.toCurryString "::") cd cs)
    (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (d_C_ppTypeExp x1 cd cs) x6
    cd cs) Curry_Prelude.OP_List))) cd cs) cd cs) cd cs) (d_C_indent x1
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (d_C_ppPrefixOp x3 cd cs) cd cs)
    (d_C_ppRule x1 x7 cd cs) cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_FuncDecl d i l r -> narrow d i (d_C_ppFuncDecl
    x1 l cd cs) (d_C_ppFuncDecl x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_FuncDecl d i xs -> narrows cs d i (\z ->
    d_C_ppFuncDecl x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_FuncDecl d c e -> guardCons d c ((\x ->
    d_C_ppFuncDecl x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_FuncDecl d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppFuncDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppFuncDecl" (showCons x2))

nd_C_ppFuncDecl :: C_Options -> FlatCurry.Curry_Types.C_FuncDecl -> IDSupply
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppFuncDecl x1 x2 s cd cs = case x2 of
  FlatCurry.Curry_Types.C_Func x3 x4 x5 x6 x7 -> let s29 = s
    in s29 `seq` (let s28 = leftSupply s29
                      s30 = rightSupply s29
                      s15 = leftSupply s30
                      s27 = rightSupply s30
    in s28 `seq` (s30 `seq` (s15 `seq` (s27 `seq` Curry_Prelude.nd_C_apply
    (let s14 = leftSupply s15
         s16 = rightSupply s15
         s0 = leftSupply s16
         s13 = rightSupply s16
    in s14 `seq` (s16 `seq` (s0 `seq` (s13 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_dollar_dollar s0 cd cs) (let s12 = leftSupply s13
                                                          s10 = rightSupply s13
    in s12 `seq` (s10 `seq` nd_C_indent x1 (let s9 = leftSupply s10
                                                s11 = rightSupply s10
                                                s1 = leftSupply s11
                                                s8 = rightSupply s11
    in s9 `seq` (s11 `seq` (s1 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_sep s1 cd cs) (let s2 = leftSupply s8
                                               s7 = rightSupply s8
    in s2 `seq` (s7 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixOp x3 s2 cd cs)
    (let s3 = leftSupply s7
         s6 = rightSupply s7
    in s3 `seq` (s6 `seq` Curry_Prelude.OP_Cons (Text.Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "::") s3 cd cs) (Curry_Prelude.OP_Cons
    (let s5 = leftSupply s6
         s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (nd_C_ppTypeExp x1 s4 cd cs)
    x6 s5 cd cs)) Curry_Prelude.OP_List))))) s9 cd cs)))) s12 cd cs)) s14 cd
    cs)))) (let s26 = leftSupply s27
                s24 = rightSupply s27
    in s26 `seq` (s24 `seq` nd_C_indent x1 (let s23 = leftSupply s24
                                                s25 = rightSupply s24
                                                s20 = leftSupply s25
                                                s22 = rightSupply s25
    in s23 `seq` (s25 `seq` (s20 `seq` (s22 `seq` Curry_Prelude.nd_C_apply
    (let s19 = leftSupply s20
         s21 = rightSupply s20
         s17 = leftSupply s21
         s18 = rightSupply s21
    in s19 `seq` (s21 `seq` (s17 `seq` (s18 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s17 cd cs) (nd_C_ppPrefixOp x3 s18 cd
    cs) s19 cd cs)))) (nd_C_ppRule x1 x7 s22 cd cs) s23 cd cs)))) s26 cd cs))
    s28 cd cs))))
  FlatCurry.Curry_Types.Choice_C_FuncDecl d i l r -> narrow d i (nd_C_ppFuncDecl
    x1 l s cd cs) (nd_C_ppFuncDecl x1 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_FuncDecl d i xs -> narrows cs d i (\z ->
    nd_C_ppFuncDecl x1 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_FuncDecl d c e -> guardCons d c ((\x ->
    nd_C_ppFuncDecl x1 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_FuncDecl d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppFuncDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppFuncDecl" (showCons x2))

d_C_ppRule :: C_Options -> FlatCurry.Curry_Types.C_Rule -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C_ppRule x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Rule x3 x4 -> d_C__case_27 x3 x4 x1
    (Curry_Prelude.d_C_null x3 cd cs) cd cs
  FlatCurry.Curry_Types.C_External x5 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (Text.Curry_Pretty.d_C_text (Curry_Prelude.toCurryString "external") cd cs)
    cd cs) (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_C_dquotes cd cs)
    (Text.Curry_Pretty.d_C_text x5 cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Rule d i l r -> narrow d i (d_C_ppRule x1 l cd
    cs) (d_C_ppRule x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Rule d i xs -> narrows cs d i (\z ->
    d_C_ppRule x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Rule d c e -> guardCons d c ((\x -> d_C_ppRule
    x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Rule d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppRule" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppRule" (showCons x2))

nd_C_ppRule :: C_Options -> FlatCurry.Curry_Types.C_Rule -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppRule x1 x2 s cd cs = case x2 of
  FlatCurry.Curry_Types.C_Rule x3 x4 -> let s0 = s
    in s0 `seq` nd_C__case_27 x3 x4 x1 (Curry_Prelude.d_C_null x3 cd cs) s0 cd
    cs
  FlatCurry.Curry_Types.C_External x5 -> let s11 = s
    in s11 `seq` (let s10 = leftSupply s11
                      s12 = rightSupply s11
                      s3 = leftSupply s12
                      s8 = rightSupply s12
    in s10 `seq` (s12 `seq` (s3 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (Text.Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "external") s1 cd cs) s2 cd cs))))
    (let s7 = leftSupply s8
         s9 = rightSupply s8
         s5 = leftSupply s9
         s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s5 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_dquotes s5 cd cs) (Text.Curry_Pretty.nd_C_text x5 s6
    cd cs) s7 cd cs)))) s10 cd cs))))
  FlatCurry.Curry_Types.Choice_C_Rule d i l r -> narrow d i (nd_C_ppRule x1 l s
    cd cs) (nd_C_ppRule x1 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Rule d i xs -> narrows cs d i (\z ->
    nd_C_ppRule x1 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Rule d c e -> guardCons d c ((\x -> nd_C_ppRule
    x1 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Rule d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppRule" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppRule" (showCons x2))

d_C_ppExp :: C_Options -> Cover -> ConstStore -> FlatCurry.Curry_Types.C_Expr
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppExp x1 cd cs = d_C_ppExpr x1 (Curry_Prelude.C_Int (0))

nd_C_ppExp :: C_Options -> IDSupply -> Cover -> ConstStore -> Func
  FlatCurry.Curry_Types.C_Expr Text.Curry_PrettyImpl.C_Doc
nd_C_ppExp x1 s cd cs = wrapNX id (nd_C_ppExpr x1 (Curry_Prelude.C_Int (0)))

d_C_ppExpr :: C_Options -> Curry_Prelude.C_Int -> FlatCurry.Curry_Types.C_Expr
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppExpr x1 x2 x3 cd cs = case x3 of
  FlatCurry.Curry_Types.C_Var x4 -> d_C_ppVarIndex x4 cd cs
  FlatCurry.Curry_Types.C_Lit x5 -> d_C_ppLiteral x5 cd cs
  FlatCurry.Curry_Types.C_Comb x6 x7 x8 -> d_C_ppComb x1 x2 x7 x8 cd cs
  FlatCurry.Curry_Types.C_Free x9 x10 -> d_C__case_25 x9 x10 x1 x2
    (Curry_Prelude.d_C_null x9 cd cs) cd cs
  FlatCurry.Curry_Types.C_Let x11 x12 -> Curry_Prelude.d_OP_dollar
    (Text.Curry_Pretty.d_C_parensIf (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.C_Int (0)) cd cs)) (d_C__case_23 x11 x12 x1
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.d_C_length x11 cd cs) cd cs) (Curry_Prelude.C_Int (1))
    cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_Or x13 x14 -> Curry_Prelude.d_OP_dollar
    (Text.Curry_Pretty.d_C_parensIf (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.C_Int (0)) cd cs)) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (d_C_ppExpr x1
    (Curry_Prelude.C_Int (1)) x13 cd cs) cd cs) (Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "?") cd cs) cd cs) cd cs) (d_C_ppExpr x1
    (Curry_Prelude.C_Int (1)) x14 cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_Case x15 x16 x17 -> Curry_Prelude.d_OP_dollar
    (Text.Curry_Pretty.d_C_parensIf (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.C_Int (0)) cd cs))
    (Curry_Prelude.d_OP_dollar (d_C_indent x1) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_OP_dollar_dollar cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (d_C_ppCaseType x15 cd cs) cd cs) (d_C_ppExpr x1 (Curry_Prelude.C_Int (1))
    x16 cd cs) cd cs) cd cs) (Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "of") cd cs) cd cs) cd cs)
    (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_C_vsep cd cs)
    (Curry_Prelude.d_C_map (d_C_ppBranch x1) x17 cd cs) cd cs) cd cs) cd cs) cd
    cs
  FlatCurry.Curry_Types.C_Typed x18 x19 -> Curry_Prelude.d_OP_dollar
    (Text.Curry_Pretty.d_C_parensIf (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.C_Int (0)) cd cs)) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Prelude.d_C_apply
    (d_C_ppExp x1 cd cs) x18 cd cs) cd cs) (Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "::") cd cs) cd cs) cd cs)
    (Curry_Prelude.d_C_apply (d_C_ppTypeExp x1 cd cs) x19 cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (d_C_ppExpr x1 x2 l
    cd cs) (d_C_ppExpr x1 x2 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    d_C_ppExpr x1 x2 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x -> d_C_ppExpr
    x1 x2 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppExpr" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppExpr" (showCons x3))

nd_C_ppExpr :: C_Options -> Curry_Prelude.C_Int -> FlatCurry.Curry_Types.C_Expr
  -> IDSupply -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppExpr x1 x2 x3 s cd cs = case x3 of
  FlatCurry.Curry_Types.C_Var x4 -> let s0 = s
    in s0 `seq` nd_C_ppVarIndex x4 s0 cd cs
  FlatCurry.Curry_Types.C_Lit x5 -> let s0 = s
    in s0 `seq` nd_C_ppLiteral x5 s0 cd cs
  FlatCurry.Curry_Types.C_Comb x6 x7 x8 -> let s0 = s
    in s0 `seq` nd_C_ppComb x1 x2 x7 x8 s0 cd cs
  FlatCurry.Curry_Types.C_Free x9 x10 -> let s0 = s
    in s0 `seq` nd_C__case_25 x9 x10 x1 x2 (Curry_Prelude.d_C_null x9 cd cs) s0
    cd cs
  FlatCurry.Curry_Types.C_Let x11 x12 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s2 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s2 `seq` (s7 `seq` Curry_Prelude.nd_OP_dollar
    (wrapNX id (Text.Curry_Pretty.nd_C_parensIf (let s1 = leftSupply s2
                                                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs)) x2 s0 cd cs) (Curry_Prelude.C_Int (0)) s1 cd cs))))
    (let s6 = leftSupply s7
         s5 = rightSupply s7
    in s6 `seq` (s5 `seq` nd_C__case_23 x11 x12 x1 (let s4 = leftSupply s5
                                                        s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs)) (Curry_Prelude.d_C_length x11 cd cs) s3 cd cs) (Curry_Prelude.C_Int
    (1)) s4 cd cs)) s6 cd cs)) s8 cd cs))))
  FlatCurry.Curry_Types.C_Or x13 x14 -> let s21 = s
    in s21 `seq` (let s20 = leftSupply s21
                      s22 = rightSupply s21
                      s2 = leftSupply s22
                      s18 = rightSupply s22
    in s20 `seq` (s22 `seq` (s2 `seq` (s18 `seq` Curry_Prelude.nd_OP_dollar
    (wrapNX id (Text.Curry_Pretty.nd_C_parensIf (let s1 = leftSupply s2
                                                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs)) x2 s0 cd cs) (Curry_Prelude.C_Int (0)) s1 cd cs))))
    (let s17 = leftSupply s18
         s19 = rightSupply s18
         s14 = leftSupply s19
         s16 = rightSupply s19
    in s17 `seq` (s19 `seq` (s14 `seq` (s16 `seq` Curry_Prelude.nd_C_apply
    (let s13 = leftSupply s14
         s15 = rightSupply s14
         s3 = leftSupply s15
         s11 = rightSupply s15
    in s13 `seq` (s15 `seq` (s3 `seq` (s11 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s3 cd cs) (let s10 = leftSupply s11
                                                       s12 = rightSupply s11
                                                       s7 = leftSupply s12
                                                       s9 = rightSupply s12
    in s10 `seq` (s12 `seq` (s7 `seq` (s9 `seq` Curry_Prelude.nd_C_apply
    (let s6 = leftSupply s7
         s8 = rightSupply s7
         s4 = leftSupply s8
         s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s4 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s4 cd cs) (nd_C_ppExpr x1
    (Curry_Prelude.C_Int (1)) x13 s5 cd cs) s6 cd cs))))
    (Text.Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString "?") s9 cd cs) s10
    cd cs)))) s13 cd cs)))) (nd_C_ppExpr x1 (Curry_Prelude.C_Int (1)) x14 s16 cd
    cs) s17 cd cs)))) s20 cd cs))))
  FlatCurry.Curry_Types.C_Case x15 x16 x17 -> let s35 = s
    in s35 `seq` (let s34 = leftSupply s35
                      s36 = rightSupply s35
                      s2 = leftSupply s36
                      s33 = rightSupply s36
    in s34 `seq` (s36 `seq` (s2 `seq` (s33 `seq` Curry_Prelude.nd_OP_dollar
    (wrapNX id (Text.Curry_Pretty.nd_C_parensIf (let s1 = leftSupply s2
                                                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs)) x2 s0 cd cs) (Curry_Prelude.C_Int (0)) s1 cd cs))))
    (let s32 = leftSupply s33
         s30 = rightSupply s33
    in s32 `seq` (s30 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_indent
    x1)) (let s29 = leftSupply s30
              s31 = rightSupply s30
              s22 = leftSupply s31
              s27 = rightSupply s31
    in s29 `seq` (s31 `seq` (s22 `seq` (s27 `seq` Curry_Prelude.nd_C_apply
    (let s21 = leftSupply s22
         s23 = rightSupply s22
         s3 = leftSupply s23
         s19 = rightSupply s23
    in s21 `seq` (s23 `seq` (s3 `seq` (s19 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_dollar_dollar s3 cd cs) (let s18 = leftSupply s19
                                                          s20 = rightSupply s19
                                                          s15 = leftSupply s20
                                                          s17 = rightSupply s20
    in s18 `seq` (s20 `seq` (s15 `seq` (s17 `seq` Curry_Prelude.nd_C_apply
    (let s14 = leftSupply s15
         s16 = rightSupply s15
         s4 = leftSupply s16
         s12 = rightSupply s16
    in s14 `seq` (s16 `seq` (s4 `seq` (s12 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s4 cd cs) (let s11 = leftSupply s12
                                                       s13 = rightSupply s12
                                                       s8 = leftSupply s13
                                                       s10 = rightSupply s13
    in s11 `seq` (s13 `seq` (s8 `seq` (s10 `seq` Curry_Prelude.nd_C_apply
    (let s7 = leftSupply s8
         s9 = rightSupply s8
         s5 = leftSupply s9
         s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s5 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s5 cd cs) (nd_C_ppCaseType x15 s6 cd cs)
    s7 cd cs)))) (nd_C_ppExpr x1 (Curry_Prelude.C_Int (1)) x16 s10 cd cs) s11 cd
    cs)))) s14 cd cs)))) (Text.Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "of") s17 cd cs) s18 cd cs)))) s21 cd cs))))
    (let s26 = leftSupply s27
         s28 = rightSupply s27
         s24 = leftSupply s28
         s25 = rightSupply s28
    in s26 `seq` (s28 `seq` (s24 `seq` (s25 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_vsep s24 cd cs) (Curry_Prelude.nd_C_map (wrapNX id
    (nd_C_ppBranch x1)) x17 s25 cd cs) s26 cd cs)))) s29 cd cs)))) s32 cd cs))
    s34 cd cs))))
  FlatCurry.Curry_Types.C_Typed x18 x19 -> let s25 = s
    in s25 `seq` (let s24 = leftSupply s25
                      s26 = rightSupply s25
                      s2 = leftSupply s26
                      s22 = rightSupply s26
    in s24 `seq` (s26 `seq` (s2 `seq` (s22 `seq` Curry_Prelude.nd_OP_dollar
    (wrapNX id (Text.Curry_Pretty.nd_C_parensIf (let s1 = leftSupply s2
                                                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs)) x2 s0 cd cs) (Curry_Prelude.C_Int (0)) s1 cd cs))))
    (let s21 = leftSupply s22
         s23 = rightSupply s22
         s16 = leftSupply s23
         s20 = rightSupply s23
    in s21 `seq` (s23 `seq` (s16 `seq` (s20 `seq` Curry_Prelude.nd_C_apply
    (let s15 = leftSupply s16
         s17 = rightSupply s16
         s3 = leftSupply s17
         s13 = rightSupply s17
    in s15 `seq` (s17 `seq` (s3 `seq` (s13 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s3 cd cs) (let s12 = leftSupply s13
                                                       s14 = rightSupply s13
                                                       s9 = leftSupply s14
                                                       s11 = rightSupply s14
    in s12 `seq` (s14 `seq` (s9 `seq` (s11 `seq` Curry_Prelude.nd_C_apply
    (let s8 = leftSupply s9
         s10 = rightSupply s9
         s4 = leftSupply s10
         s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s4 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s4 cd cs) (let s6 = leftSupply s7
                                                       s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (nd_C_ppExp x1 s5 cd cs) x18
    s6 cd cs)) s8 cd cs)))) (Text.Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "::") s11 cd cs) s12 cd cs)))) s15 cd cs))))
    (let s19 = leftSupply s20
         s18 = rightSupply s20
    in s19 `seq` (s18 `seq` Curry_Prelude.nd_C_apply (nd_C_ppTypeExp x1 s18 cd
    cs) x19 s19 cd cs)) s21 cd cs)))) s24 cd cs))))
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (nd_C_ppExpr x1 x2 l
    s cd cs) (nd_C_ppExpr x1 x2 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    nd_C_ppExpr x1 x2 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x -> nd_C_ppExpr
    x1 x2 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppExpr" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppExpr" (showCons x3))

d_C_ppVarIndex :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C_ppVarIndex x1 cd cs = d_C__case_22 x1 (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) x1 cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs

nd_C_ppVarIndex :: Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppVarIndex x1 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` nd_C__case_22 x1 (let s1 = leftSupply s2
                                              s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
  (wrapDX (wrapDX id)
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs)) x1 s0 cd cs) (Curry_Prelude.C_Int (0)) s1 cd cs)) s3 cd cs))

d_C_ppLiteral :: FlatCurry.Curry_Types.C_Literal -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C_ppLiteral x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Intc x2 -> Text.Curry_Pretty.d_C_int x2 cd cs
  FlatCurry.Curry_Types.C_Floatc x3 -> Text.Curry_Pretty.d_C_float x3 cd cs
  FlatCurry.Curry_Types.C_Charc x4 -> Text.Curry_Pretty.d_C_text
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash
    cd cs) x4 cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Literal d i l r -> narrow d i (d_C_ppLiteral l
    cd cs) (d_C_ppLiteral r cd cs)
  FlatCurry.Curry_Types.Choices_C_Literal d i xs -> narrows cs d i (\z ->
    d_C_ppLiteral z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Literal d c e -> guardCons d c ((\x ->
    d_C_ppLiteral e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Literal d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppLiteral" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppLiteral" (showCons x1))

nd_C_ppLiteral :: FlatCurry.Curry_Types.C_Literal -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppLiteral x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_Intc x2 -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_int x2 s0 cd cs
  FlatCurry.Curry_Types.C_Floatc x3 -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_float x3 s0 cd cs
  FlatCurry.Curry_Types.C_Charc x4 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Text.Curry_Pretty.nd_C_text (Curry_Prelude.nd_C_apply
    (wrapDX id
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash
    cd cs)) x4 s0 cd cs) s1 cd cs))
  FlatCurry.Curry_Types.Choice_C_Literal d i l r -> narrow d i (nd_C_ppLiteral l
    s cd cs) (nd_C_ppLiteral r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Literal d i xs -> narrows cs d i (\z ->
    nd_C_ppLiteral z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Literal d c e -> guardCons d c ((\x ->
    nd_C_ppLiteral e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Literal d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppLiteral" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppLiteral" (showCons x1))

d_C_ppComb :: C_Options -> Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppComb x1 x2 x3 x4 cd cs = d_C__case_20 x4 x3 x1 x2
  (Curry_Prelude.d_OP_amp_amp (d_C_isListId x3 cd cs) (Curry_Prelude.d_C_null x4
  cd cs) cd cs) cd cs

nd_C_ppComb :: C_Options -> Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> IDSupply -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppComb x1 x2 x3 x4 s cd cs = let s0 = s
  in s0 `seq` nd_C__case_20 x4 x3 x1 x2 (Curry_Prelude.d_OP_amp_amp
  (d_C_isListId x3 cd cs) (Curry_Prelude.d_C_null x4 cd cs) cd cs) s0 cd cs

d_C_ppDecls :: C_Options -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Expr)
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppDecls x1 cd cs = Curry_Prelude.d_OP_dot Text.Curry_Pretty.d_C_align
  (Curry_Prelude.d_OP_dot (Text.Curry_Pretty.d_C_vsep cd cs)
  (Curry_Prelude.d_C_map (d_C_ppDecl x1)) cd cs) cd cs

nd_C_ppDecls :: C_Options -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_Expr)) Text.Curry_PrettyImpl.C_Doc
nd_C_ppDecls x1 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dot (wrapNX id
  Text.Curry_Pretty.nd_C_align) (let s1 = leftSupply s2
                                     s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (Text.Curry_Pretty.nd_C_vsep s0
  cd cs) (wrapNX id (Curry_Prelude.nd_C_map (wrapNX id (nd_C_ppDecl x1)))) s1 cd
  cs)) s3 cd cs))

d_C_ppDecl :: C_Options -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C_ppDecl x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (d_C_ppVarIndex x3 cd cs) cd cs)
    (Text.Curry_Pretty.d_C_equals cd cs) cd cs) cd cs) (Curry_Prelude.d_C_apply
    (d_C_ppExp x1 cd cs) x4 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_ppDecl x1 l cd cs)
    (d_C_ppDecl x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_ppDecl x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C_ppDecl x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppDecl" (showCons x2))

nd_C_ppDecl :: C_Options -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppDecl x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s17 = s
    in s17 `seq` (let s16 = leftSupply s17
                      s18 = rightSupply s17
                      s11 = leftSupply s18
                      s15 = rightSupply s18
    in s16 `seq` (s18 `seq` (s11 `seq` (s15 `seq` Curry_Prelude.nd_C_apply
    (let s10 = leftSupply s11
         s12 = rightSupply s11
         s0 = leftSupply s12
         s8 = rightSupply s12
    in s10 `seq` (s12 `seq` (s0 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (let s7 = leftSupply s8
                                                       s9 = rightSupply s8
                                                       s4 = leftSupply s9
                                                       s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s4 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (let s3 = leftSupply s4
         s5 = rightSupply s4
         s1 = leftSupply s5
         s2 = rightSupply s5
    in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (nd_C_ppVarIndex x3 s2 cd cs)
    s3 cd cs)))) (Text.Curry_Pretty.nd_C_equals s6 cd cs) s7 cd cs)))) s10 cd
    cs)))) (let s14 = leftSupply s15
                s13 = rightSupply s15
    in s14 `seq` (s13 `seq` Curry_Prelude.nd_C_apply (nd_C_ppExp x1 s13 cd cs)
    x4 s14 cd cs)) s16 cd cs))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_ppDecl x1 l s cd
    cs) (nd_C_ppDecl x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_ppDecl x1
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C_ppDecl x1 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppDecl" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppDecl" (showCons x2))

d_C_ppCaseType :: FlatCurry.Curry_Types.C_CaseType -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C_ppCaseType x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Rigid -> Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "case") cd cs
  FlatCurry.Curry_Types.C_Flex -> Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "fcase") cd cs
  FlatCurry.Curry_Types.Choice_C_CaseType d i l r -> narrow d i (d_C_ppCaseType
    l cd cs) (d_C_ppCaseType r cd cs)
  FlatCurry.Curry_Types.Choices_C_CaseType d i xs -> narrows cs d i (\z ->
    d_C_ppCaseType z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_CaseType d c e -> guardCons d c ((\x ->
    d_C_ppCaseType e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_CaseType d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppCaseType" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppCaseType" (showCons x1))

nd_C_ppCaseType :: FlatCurry.Curry_Types.C_CaseType -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppCaseType x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_Rigid -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString "case")
    s0 cd cs
  FlatCurry.Curry_Types.C_Flex -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString
    "fcase") s0 cd cs
  FlatCurry.Curry_Types.Choice_C_CaseType d i l r -> narrow d i (nd_C_ppCaseType
    l s cd cs) (nd_C_ppCaseType r s cd cs)
  FlatCurry.Curry_Types.Choices_C_CaseType d i xs -> narrows cs d i (\z ->
    nd_C_ppCaseType z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_CaseType d c e -> guardCons d c ((\x ->
    nd_C_ppCaseType e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_CaseType d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppCaseType" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppCaseType" (showCons x1))

d_C_ppBranch :: C_Options -> FlatCurry.Curry_Types.C_BranchExpr -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppBranch x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Branch x3 x4 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (d_C_ppPattern x1 x3 cd cs) cd cs)
    (Text.Curry_Pretty.d_C_rarrow cd cs) cd cs) cd cs) (d_C_indent x1
    (Curry_Prelude.d_C_apply (d_C_ppExp x1 cd cs) x4 cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_BranchExpr d i l r -> narrow d i (d_C_ppBranch
    x1 l cd cs) (d_C_ppBranch x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_BranchExpr d i xs -> narrows cs d i (\z ->
    d_C_ppBranch x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_BranchExpr d c e -> guardCons d c ((\x ->
    d_C_ppBranch x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_BranchExpr d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppBranch" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppBranch" (showCons x2))

nd_C_ppBranch :: C_Options -> FlatCurry.Curry_Types.C_BranchExpr -> IDSupply
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppBranch x1 x2 s cd cs = case x2 of
  FlatCurry.Curry_Types.C_Branch x3 x4 -> let s19 = s
    in s19 `seq` (let s18 = leftSupply s19
                      s20 = rightSupply s19
                      s11 = leftSupply s20
                      s17 = rightSupply s20
    in s18 `seq` (s20 `seq` (s11 `seq` (s17 `seq` Curry_Prelude.nd_C_apply
    (let s10 = leftSupply s11
         s12 = rightSupply s11
         s0 = leftSupply s12
         s8 = rightSupply s12
    in s10 `seq` (s12 `seq` (s0 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (let s7 = leftSupply s8
                                                       s9 = rightSupply s8
                                                       s4 = leftSupply s9
                                                       s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s4 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (let s3 = leftSupply s4
         s5 = rightSupply s4
         s1 = leftSupply s5
         s2 = rightSupply s5
    in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (nd_C_ppPattern x1 x3 s2 cd
    cs) s3 cd cs)))) (Text.Curry_Pretty.nd_C_rarrow s6 cd cs) s7 cd cs)))) s10
    cd cs)))) (let s16 = leftSupply s17
                   s15 = rightSupply s17
    in s16 `seq` (s15 `seq` nd_C_indent x1 (let s14 = leftSupply s15
                                                s13 = rightSupply s15
    in s14 `seq` (s13 `seq` Curry_Prelude.nd_C_apply (nd_C_ppExp x1 s13 cd cs)
    x4 s14 cd cs)) s16 cd cs)) s18 cd cs))))
  FlatCurry.Curry_Types.Choice_C_BranchExpr d i l r -> narrow d i (nd_C_ppBranch
    x1 l s cd cs) (nd_C_ppBranch x1 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_BranchExpr d i xs -> narrows cs d i (\z ->
    nd_C_ppBranch x1 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_BranchExpr d c e -> guardCons d c ((\x ->
    nd_C_ppBranch x1 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_BranchExpr d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppBranch" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppBranch" (showCons x2))

d_C_ppPattern :: C_Options -> FlatCurry.Curry_Types.C_Pattern -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppPattern x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Pattern x3 x4 -> d_C__case_13 x4 x3 x1
    (Curry_Prelude.d_OP_amp_amp (d_C_isListId x3 cd cs) (Curry_Prelude.d_C_null
    x4 cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_LPattern x11 -> d_C_ppLiteral x11 cd cs
  FlatCurry.Curry_Types.Choice_C_Pattern d i l r -> narrow d i (d_C_ppPattern x1
    l cd cs) (d_C_ppPattern x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Pattern d i xs -> narrows cs d i (\z ->
    d_C_ppPattern x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Pattern d c e -> guardCons d c ((\x ->
    d_C_ppPattern x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Pattern d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppPattern" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppPattern" (showCons x2))

nd_C_ppPattern :: C_Options -> FlatCurry.Curry_Types.C_Pattern -> IDSupply
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppPattern x1 x2 s cd cs = case x2 of
  FlatCurry.Curry_Types.C_Pattern x3 x4 -> let s0 = s
    in s0 `seq` nd_C__case_13 x4 x3 x1 (Curry_Prelude.d_OP_amp_amp (d_C_isListId
    x3 cd cs) (Curry_Prelude.d_C_null x4 cd cs) cd cs) s0 cd cs
  FlatCurry.Curry_Types.C_LPattern x11 -> let s0 = s
    in s0 `seq` nd_C_ppLiteral x11 s0 cd cs
  FlatCurry.Curry_Types.Choice_C_Pattern d i l r -> narrow d i (nd_C_ppPattern
    x1 l s cd cs) (nd_C_ppPattern x1 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Pattern d i xs -> narrows cs d i (\z ->
    nd_C_ppPattern x1 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Pattern d c e -> guardCons d c ((\x ->
    nd_C_ppPattern x1 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Pattern d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppPattern" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppPattern" (showCons x2))

d_C_ppPrefixQOp :: C_Options -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppPrefixQOp x1 x2 cd cs = Text.Curry_Pretty.d_C_parensIf
  (Curry_Prelude.d_C_apply (d_C_isInfixOp cd cs) x2 cd cs) (d_C_ppQName x1 x2 cd
  cs) cd cs

nd_C_ppPrefixQOp :: C_Options -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppPrefixQOp x1 x2 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Text.Curry_Pretty.nd_C_parensIf
  (Curry_Prelude.nd_C_apply (wrapDX id (d_C_isInfixOp cd cs)) x2 s0 cd cs)
  (nd_C_ppQName x1 x2 s1 cd cs) s2 cd cs))))

d_C_ppPrefixOp :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppPrefixOp x1 cd cs = Text.Curry_Pretty.d_C_parensIf
  (Curry_Prelude.d_C_apply (d_C_isInfixOp cd cs) x1 cd cs) (d_C_ppName x1 cd cs)
  cd cs

nd_C_ppPrefixOp :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppPrefixOp x1 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Text.Curry_Pretty.nd_C_parensIf
  (Curry_Prelude.nd_C_apply (wrapDX id (d_C_isInfixOp cd cs)) x1 s0 cd cs)
  (nd_C_ppName x1 s1 cd cs) s2 cd cs))))

d_C_ppInfixQOp :: C_Options -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppInfixQOp x1 x2 cd cs = d_C__case_6 x2 x1 (Curry_Prelude.d_C_apply
  (d_C_isInfixOp cd cs) x2 cd cs) cd cs

nd_C_ppInfixQOp :: C_Options -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppInfixQOp x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_6 x2 x1 (Curry_Prelude.nd_C_apply (wrapDX id
  (d_C_isInfixOp cd cs)) x2 s0 cd cs) s1 cd cs))

d_C_ppQName :: C_Options -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppQName x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let x5 = d_C_qualMode x1 cd cs
                                       x6 = d_C_currentModule x1 cd cs
    in d_C__case_5 x3 x2 x5 x6 x4 (Curry_Prelude.d_C_null x3 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_ppQName x1 l cd cs)
    (d_C_ppQName x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_ppQName x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C_ppQName x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppQName" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppQName" (showCons x2))

nd_C_ppQName :: C_Options -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppQName x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s0 = s
    in s0 `seq` (let x5 = d_C_qualMode x1 cd cs
                     x6 = d_C_currentModule x1 cd cs
    in nd_C__case_5 x3 x2 x5 x6 x4 (Curry_Prelude.d_C_null x3 cd cs) s0 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_ppQName x1 l s cd
    cs) (nd_C_ppQName x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_ppQName
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C_ppQName x1 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppQName" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppQName" (showCons x2))

d_C_ppName :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C_ppName x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Text.Curry_Pretty.d_C_text x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_ppName l cd cs)
    (d_C_ppName r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_ppName z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C_ppName e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppName" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppName" (showCons x1))

nd_C_ppName :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_ppName x1 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_text x3 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_ppName l s cd cs)
    (nd_C_ppName r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_ppName z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C_ppName e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Pretty.ppName" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.ppName" (showCons x1))

d_C_isInfixOp :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isInfixOp cd cs = Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_all
  (Curry_Prelude.d_C_flip (Curry_Prelude.d_C_elem
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
  (Curry_Prelude.toCurryString "~!@#$%^&*+-=<>:?./|\\")) cd cs)
  Curry_Prelude.d_C_snd cd cs

d_C_isConsId :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C_isConsId x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x2 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.OP_Cons Curry_Prelude.OP_List Curry_Prelude.OP_List)) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString ":") cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_isConsId l cd cs)
    (d_C_isConsId r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_isConsId z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C_isConsId e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Pretty.isConsId" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.isConsId" (showCons x1))

d_C_isListId :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C_isListId x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x2 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.OP_Cons Curry_Prelude.OP_List Curry_Prelude.OP_List)) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "[]") cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_isListId l cd cs)
    (d_C_isListId r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_isListId z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C_isListId e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Pretty.isListId" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.isListId" (showCons x1))

d_C_isTupleId :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C_isTupleId x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x2 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.OP_Cons Curry_Prelude.OP_List Curry_Prelude.OP_List)) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (d_OP_isTupleId_dot_mkTuple_dot_182 (Curry_Prelude.d_C_length x3 cd cs)
    cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_isTupleId l cd cs)
    (d_C_isTupleId r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_isTupleId
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C_isTupleId e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Pretty.isTupleId" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty.isTupleId" (showCons x1))

d_OP_isTupleId_dot_mkTuple_dot_182 :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_isTupleId_dot_mkTuple_dot_182 x1 cd cs = Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Char '('#) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.d_C_replicate
  (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  x1 (Curry_Prelude.C_Int (2)) cd cs) (Curry_Prelude.C_Char ','#) cd cs)
  (Curry_Prelude.toCurryString ")") cd cs)

d_C_indent :: C_Options -> Text.Curry_PrettyImpl.C_Doc -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C_indent x1 x2 cd cs = Text.Curry_Pretty.d_C_nest (d_C_indentWidth x1 cd cs)
  x2 cd cs

nd_C_indent :: C_Options -> Text.Curry_PrettyImpl.C_Doc -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C_indent x1 x2 s cd cs = let s0 = s
  in s0 `seq` Text.Curry_Pretty.nd_C_nest (d_C_indentWidth x1 cd cs) x2 s0 cd cs

d_C__case_53 :: Curry_Prelude.C_Bool -> C_QualMode -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_53 x6 x2 cd cs = case x2 of
  C_QualAll -> Curry_Prelude.C_True
  C_QualNone -> x6
  C_QualImportsButPrelude -> x6
  C_QualImports -> x6
  Choice_C_QualMode d i l r -> narrow d i (d_C__case_53 x6 l cd cs)
    (d_C__case_53 x6 r cd cs)
  Choices_C_QualMode d i xs -> narrows cs d i (\z -> d_C__case_53 x6 z cd cs) xs
  Guard_C_QualMode d c e -> guardCons d c ((\x -> d_C__case_53 x6 e cd x) $!
    addCs c cs)
  Fail_C_QualMode d info -> failCons d (traceFail "FlatCurry.Pretty._case_53"
    [show x6, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_53" (showCons x2))

d_C__case_54 :: Curry_Prelude.C_Bool -> C_QualMode -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_54 x5 x2 cd cs = case x2 of
  C_QualImports -> Curry_Prelude.C_True
  C_QualNone -> x5
  C_QualImportsButPrelude -> x5
  C_QualAll -> x5
  Choice_C_QualMode d i l r -> narrow d i (d_C__case_54 x5 l cd cs)
    (d_C__case_54 x5 r cd cs)
  Choices_C_QualMode d i xs -> narrows cs d i (\z -> d_C__case_54 x5 z cd cs) xs
  Guard_C_QualMode d c e -> guardCons d c ((\x -> d_C__case_54 x5 e cd x) $!
    addCs c cs)
  Fail_C_QualMode d info -> failCons d (traceFail "FlatCurry.Pretty._case_54"
    [show x5, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_54" (showCons x2))

d_C__case_55 :: Curry_Prelude.C_Bool -> C_QualMode -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_55 x4 x2 cd cs = case x2 of
  C_QualImportsButPrelude -> Curry_Prelude.C_True
  C_QualNone -> x4
  C_QualImports -> x4
  C_QualAll -> x4
  Choice_C_QualMode d i l r -> narrow d i (d_C__case_55 x4 l cd cs)
    (d_C__case_55 x4 r cd cs)
  Choices_C_QualMode d i xs -> narrows cs d i (\z -> d_C__case_55 x4 z cd cs) xs
  Guard_C_QualMode d c e -> guardCons d c ((\x -> d_C__case_55 x4 e cd x) $!
    addCs c cs)
  Fail_C_QualMode d info -> failCons d (traceFail "FlatCurry.Pretty._case_55"
    [show x4, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_55" (showCons x2))

d_C__case_56 :: Curry_Prelude.C_Bool -> C_QualMode -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_56 x3 x2 cd cs = case x2 of
  C_QualNone -> Curry_Prelude.C_True
  C_QualImportsButPrelude -> x3
  C_QualImports -> x3
  C_QualAll -> x3
  Choice_C_QualMode d i l r -> narrow d i (d_C__case_56 x3 l cd cs)
    (d_C__case_56 x3 r cd cs)
  Choices_C_QualMode d i xs -> narrows cs d i (\z -> d_C__case_56 x3 z cd cs) xs
  Guard_C_QualMode d c e -> guardCons d c ((\x -> d_C__case_56 x3 e cd x) $!
    addCs c cs)
  Fail_C_QualMode d info -> failCons d (traceFail "FlatCurry.Pretty._case_56"
    [show x3, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_56" (showCons x2))

nd_C__case_52 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_QualMode
  -> Curry_Prelude.C_Int -> C_Options -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_52 x5 x4 x3 x2 s cd cs = case x2 of
  C_Options x6 x7 x8 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_amp_amp
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs)) x3 s0 cd cs) x6 s1 cd cs))
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    x4 x7 cd cs) cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x5 x8 s3 cd cs) cd cs))
  Choice_C_Options d i l r -> narrow d i (nd_C__case_52 x5 x4 x3 l s cd cs)
    (nd_C__case_52 x5 x4 x3 r s cd cs)
  Choices_C_Options d i xs -> narrows cs d i (\z -> nd_C__case_52 x5 x4 x3 z s
    cd cs) xs
  Guard_C_Options d c e -> guardCons d c ((\x -> nd_C__case_52 x5 x4 x3 e s cd
    x) $! addCs c cs)
  Fail_C_Options d info -> failCons d (traceFail "FlatCurry.Pretty._case_52"
    [show x5, show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_52" (showCons x2))

d_C__case_48 :: C_QualMode -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_48 x2 cd cs = case x2 of
  C_QualNone -> Curry_Prelude.C_False
  C_QualImportsButPrelude -> Curry_Prelude.C_False
  C_QualImports -> Curry_Prelude.C_False
  C_QualAll -> Curry_Prelude.C_True
  Choice_C_QualMode d i l r -> narrow d i (d_C__case_48 l cd cs) (d_C__case_48 r
    cd cs)
  Choices_C_QualMode d i xs -> narrows cs d i (\z -> d_C__case_48 z cd cs) xs
  Guard_C_QualMode d c e -> guardCons d c ((\x -> d_C__case_48 e cd x) $! addCs
    c cs)
  Fail_C_QualMode d info -> failCons d (traceFail "FlatCurry.Pretty._case_48"
    [show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_48" (showCons x2))

d_C__case_49 :: C_QualMode -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_49 x2 cd cs = case x2 of
  C_QualNone -> Curry_Prelude.C_False
  C_QualImportsButPrelude -> Curry_Prelude.C_False
  C_QualImports -> Curry_Prelude.C_True
  C_QualAll -> Curry_Prelude.C_False
  Choice_C_QualMode d i l r -> narrow d i (d_C__case_49 l cd cs) (d_C__case_49 r
    cd cs)
  Choices_C_QualMode d i xs -> narrows cs d i (\z -> d_C__case_49 z cd cs) xs
  Guard_C_QualMode d c e -> guardCons d c ((\x -> d_C__case_49 e cd x) $! addCs
    c cs)
  Fail_C_QualMode d info -> failCons d (traceFail "FlatCurry.Pretty._case_49"
    [show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_49" (showCons x2))

d_C__case_50 :: C_QualMode -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_50 x2 cd cs = case x2 of
  C_QualNone -> Curry_Prelude.C_False
  C_QualImportsButPrelude -> Curry_Prelude.C_True
  C_QualImports -> Curry_Prelude.C_False
  C_QualAll -> Curry_Prelude.C_False
  Choice_C_QualMode d i l r -> narrow d i (d_C__case_50 l cd cs) (d_C__case_50 r
    cd cs)
  Choices_C_QualMode d i xs -> narrows cs d i (\z -> d_C__case_50 z cd cs) xs
  Guard_C_QualMode d c e -> guardCons d c ((\x -> d_C__case_50 e cd x) $! addCs
    c cs)
  Fail_C_QualMode d info -> failCons d (traceFail "FlatCurry.Pretty._case_50"
    [show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_50" (showCons x2))

d_C__case_51 :: C_QualMode -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_51 x2 cd cs = case x2 of
  C_QualNone -> Curry_Prelude.C_True
  C_QualImportsButPrelude -> Curry_Prelude.C_False
  C_QualImports -> Curry_Prelude.C_False
  C_QualAll -> Curry_Prelude.C_False
  Choice_C_QualMode d i l r -> narrow d i (d_C__case_51 l cd cs) (d_C__case_51 r
    cd cs)
  Choices_C_QualMode d i xs -> narrows cs d i (\z -> d_C__case_51 z cd cs) xs
  Guard_C_QualMode d c e -> guardCons d c ((\x -> d_C__case_51 e cd x) $! addCs
    c cs)
  Fail_C_QualMode d info -> failCons d (traceFail "FlatCurry.Pretty._case_51"
    [show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_51" (showCons x2))

d_C__case_47 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Options -> Cover
  -> ConstStore -> C_Options
d_C__case_47 x3 x1 cd cs = case x1 of
  C_Options x9 x10 x11 -> C_Options x9 x10 x3
  Choice_C_Options d i l r -> narrow d i (d_C__case_47 x3 l cd cs) (d_C__case_47
    x3 r cd cs)
  Choices_C_Options d i xs -> narrows cs d i (\z -> d_C__case_47 x3 z cd cs) xs
  Guard_C_Options d c e -> guardCons d c ((\x -> d_C__case_47 x3 e cd x) $!
    addCs c cs)
  Fail_C_Options d info -> failCons d (traceFail "FlatCurry.Pretty._case_47"
    [show x3, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_47" (showCons x1))

d_C__case_40 :: FlatCurry.Curry_Types.C_Visibility -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> C_Options -> FlatCurry.Curry_Types.C_NewConsDecl
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_40 x12 x11 x1 x14 cd cs = case x14 of
  FlatCurry.Curry_Types.C_NewCons x15 x16 x17 -> d_C__case_39 x16 x12 x11 x1
    (Curry_Prelude.d_OP_bar_bar
    (FlatCurry.Curry_Types.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Types_dot_Visibility_hash
    x12 FlatCurry.Curry_Types.C_Private cd cs)
    (FlatCurry.Curry_Types.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Types_dot_Visibility_hash
    x16 FlatCurry.Curry_Types.C_Private cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_NewConsDecl d i l r -> narrow d i (d_C__case_40
    x12 x11 x1 l cd cs) (d_C__case_40 x12 x11 x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_NewConsDecl d i xs -> narrows cs d i (\z ->
    d_C__case_40 x12 x11 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_NewConsDecl d c e -> guardCons d c ((\x ->
    d_C__case_40 x12 x11 x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_NewConsDecl d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_40" [show x12, show x11, show x1, show x14] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_40" (showCons x14))

nd_C__case_40 :: FlatCurry.Curry_Types.C_Visibility -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> C_Options -> FlatCurry.Curry_Types.C_NewConsDecl
  -> IDSupply -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_40 x12 x11 x1 x14 s cd cs = case x14 of
  FlatCurry.Curry_Types.C_NewCons x15 x16 x17 -> let s0 = s
    in s0 `seq` nd_C__case_39 x16 x12 x11 x1 (Curry_Prelude.d_OP_bar_bar
    (FlatCurry.Curry_Types.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Types_dot_Visibility_hash
    x12 FlatCurry.Curry_Types.C_Private cd cs)
    (FlatCurry.Curry_Types.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Types_dot_Visibility_hash
    x16 FlatCurry.Curry_Types.C_Private cd cs) cd cs) s0 cd cs
  FlatCurry.Curry_Types.Choice_C_NewConsDecl d i l r -> narrow d i
    (nd_C__case_40 x12 x11 x1 l s cd cs) (nd_C__case_40 x12 x11 x1 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_NewConsDecl d i xs -> narrows cs d i (\z ->
    nd_C__case_40 x12 x11 x1 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_NewConsDecl d c e -> guardCons d c ((\x ->
    nd_C__case_40 x12 x11 x1 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_NewConsDecl d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_40" [show x12, show x11, show x1, show x14] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_40" (showCons x14))

d_C__case_39 :: FlatCurry.Curry_Types.C_Visibility
  -> FlatCurry.Curry_Types.C_Visibility -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> C_Options -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_39 x16 x12 x11 x1 x17 cd cs = case x17 of
  Curry_Prelude.C_True -> Text.Curry_Pretty.d_C_empty cd cs
  Curry_Prelude.C_False -> d_C__case_38 x11 x1 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_39 x16 x12 x11 x1
    l cd cs) (d_C__case_39 x16 x12 x11 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_39 x16
    x12 x11 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_39 x16 x12
    x11 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_39" [show x16, show x12, show x11, show x1, show
    x17] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_39" (showCons x17))

nd_C__case_39 :: FlatCurry.Curry_Types.C_Visibility
  -> FlatCurry.Curry_Types.C_Visibility -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> C_Options -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_39 x16 x12 x11 x1 x17 s cd cs = case x17 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_empty s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_38 x11 x1 (Curry_Prelude.d_C_otherwise cd cs) s0 cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_39 x16 x12 x11
    x1 l s cd cs) (nd_C__case_39 x16 x12 x11 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_39 x16
    x12 x11 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_39 x16
    x12 x11 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_39" [show x16, show x12, show x11, show x1, show
    x17] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_39" (showCons x17))

d_C__case_38 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> C_Options -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C__case_38 x11 x1 x12 cd cs = case x12 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (d_C_ppPrefixQOp x1 x11 cd cs) cd
    cs) (Text.Curry_Pretty.d_C_text (Curry_Prelude.toCurryString "(..)") cd cs)
    cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_38 x11 x1 l cd
    cs) (d_C__case_38 x11 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_38 x11
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_38 x11 x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_38" [show x11, show x1, show x12] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_38" (showCons x12))

nd_C__case_38 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> C_Options -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_38 x11 x1 x12 s cd cs = case x12 of
  Curry_Prelude.C_True -> let s7 = s
    in s7 `seq` (let s6 = leftSupply s7
                     s8 = rightSupply s7
                     s3 = leftSupply s8
                     s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (nd_C_ppPrefixQOp x1 x11 s1 cd
    cs) s2 cd cs)))) (Text.Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString
    "(..)") s5 cd cs) s6 cd cs))))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_38 x11 x1 l s cd
    cs) (nd_C__case_38 x11 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_38 x11
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_38 x11 x1
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_38" [show x11, show x1, show x12] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_38" (showCons x12))

d_C__case_42 :: FlatCurry.Curry_Types.C_Visibility -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> C_Options -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_42 x8 x7 x1 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Text.Curry_Pretty.d_C_empty cd cs
  Curry_Prelude.C_False -> d_C__case_41 x7 x1 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_42 x8 x7 x1 l cd
    cs) (d_C__case_42 x8 x7 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_42 x8
    x7 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_42 x8 x7
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_42" [show x8, show x7, show x1, show x9] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_42" (showCons x9))

nd_C__case_42 :: FlatCurry.Curry_Types.C_Visibility -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> C_Options -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_42 x8 x7 x1 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_empty s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_41 x7 x1 (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_42 x8 x7 x1 l s
    cd cs) (nd_C__case_42 x8 x7 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_42 x8
    x7 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_42 x8 x7
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_42" [show x8, show x7, show x1, show x9] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_42" (showCons x9))

d_C__case_41 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> C_Options -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C__case_41 x7 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_C_ppPrefixQOp x1 x7 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_41 x7 x1 l cd cs)
    (d_C__case_41 x7 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_41 x7
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_41 x7 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_41" [show x7, show x1, show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_41" (showCons x8))

nd_C__case_41 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> C_Options -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_41 x7 x1 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C_ppPrefixQOp x1 x7 s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_41 x7 x1 l s cd
    cs) (nd_C__case_41 x7 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_41 x7
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_41 x7 x1
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_41" [show x7, show x1, show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_41" (showCons x8))

d_C__case_46 :: FlatCurry.Curry_Types.C_Visibility -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_ConsDecl -> C_Options -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C__case_46 x4 x6 x1 x3 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Text.Curry_Pretty.d_C_empty cd cs
  Curry_Prelude.C_False -> d_C__case_45 x6 x1 x3 (Curry_Prelude.d_C_null x6 cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_46 x4 x6 x1 x3 l
    cd cs) (d_C__case_46 x4 x6 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_46 x4
    x6 x1 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_46 x4 x6
    x1 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_46" [show x4, show x6, show x1, show x3, show x7]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_46" (showCons x7))

nd_C__case_46 :: FlatCurry.Curry_Types.C_Visibility -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_ConsDecl -> C_Options -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_46 x4 x6 x1 x3 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_empty s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_45 x6 x1 x3 (Curry_Prelude.d_C_null x6 cd cs) s0 cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_46 x4 x6 x1 x3 l
    s cd cs) (nd_C__case_46 x4 x6 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_46 x4
    x6 x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_46 x4 x6
    x1 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_46" [show x4, show x6, show x1, show x3, show x7]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_46" (showCons x7))

d_C__case_45 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_ConsDecl
  -> C_Options -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_45 x6 x1 x3 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> d_C_ppPrefixQOp x1 x3 cd cs
  Curry_Prelude.C_False -> d_C__case_44 x6 x1 x3 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_all d_OP_ppTypeExport_dot_isPublicCons_dot_12 cd cs) x6
    cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_45 x6 x1 x3 l cd
    cs) (d_C__case_45 x6 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_45 x6
    x1 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_45 x6 x1
    x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_45" [show x6, show x1, show x3, show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_45" (showCons x7))

nd_C__case_45 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_ConsDecl
  -> C_Options -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_45 x6 x1 x3 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C_ppPrefixQOp x1 x3 s0 cd cs
  Curry_Prelude.C_False -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_44 x6 x1 x3 (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_all
    (wrapDX id d_OP_ppTypeExport_dot_isPublicCons_dot_12) s0 cd cs) x6 s1 cd
    cs)) s3 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_45 x6 x1 x3 l s
    cd cs) (nd_C__case_45 x6 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_45 x6
    x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_45 x6 x1
    x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_45" [show x6, show x1, show x3, show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_45" (showCons x7))

d_C__case_44 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_ConsDecl
  -> C_Options -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_44 x6 x1 x3 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (d_C_ppPrefixQOp x1 x3 cd cs) cd
    cs) (Text.Curry_Pretty.d_C_text (Curry_Prelude.toCurryString "(..)") cd cs)
    cd cs
  Curry_Prelude.C_False -> d_C__case_43 x6 x1 x3 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_44 x6 x1 x3 l cd
    cs) (d_C__case_44 x6 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_44 x6
    x1 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_44 x6 x1
    x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_44" [show x6, show x1, show x3, show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_44" (showCons x7))

nd_C__case_44 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_ConsDecl
  -> C_Options -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_44 x6 x1 x3 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s7 = s
    in s7 `seq` (let s6 = leftSupply s7
                     s8 = rightSupply s7
                     s3 = leftSupply s8
                     s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (nd_C_ppPrefixQOp x1 x3 s1 cd
    cs) s2 cd cs)))) (Text.Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString
    "(..)") s5 cd cs) s6 cd cs))))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_43 x6 x1 x3 (Curry_Prelude.d_C_otherwise cd cs) s0 cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_44 x6 x1 x3 l s
    cd cs) (nd_C__case_44 x6 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_44 x6
    x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_44 x6 x1
    x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_44" [show x6, show x1, show x3, show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_44" (showCons x7))

d_C__case_43 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_ConsDecl
  -> C_Options -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_43 x6 x1 x3 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (d_C_ppPrefixQOp x1 x3 cd cs) cd
    cs) (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_C_tupled cd cs)
    (d_C_ppConsExports x1 x6 cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_43 x6 x1 x3 l cd
    cs) (d_C__case_43 x6 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_43 x6
    x1 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_43 x6 x1
    x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_43" [show x6, show x1, show x3, show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_43" (showCons x7))

nd_C__case_43 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_ConsDecl
  -> C_Options -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_43 x6 x1 x3 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s11 = s
    in s11 `seq` (let s10 = leftSupply s11
                      s12 = rightSupply s11
                      s3 = leftSupply s12
                      s8 = rightSupply s12
    in s10 `seq` (s12 `seq` (s3 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (nd_C_ppPrefixQOp x1 x3 s1 cd
    cs) s2 cd cs)))) (let s7 = leftSupply s8
                          s9 = rightSupply s8
                          s5 = leftSupply s9
                          s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s5 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_tupled s5 cd cs) (nd_C_ppConsExports x1 x6 s6 cd cs)
    s7 cd cs)))) s10 cd cs))))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_43 x6 x1 x3 l s
    cd cs) (nd_C__case_43 x6 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_43 x6
    x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_43 x6 x1
    x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_43" [show x6, show x1, show x3, show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_43" (showCons x7))

d_C__case_37 :: Curry_Prelude.OP_List Text.Curry_PrettyImpl.C_Doc
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Options
  -> FlatCurry.Curry_Types.C_Visibility -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Text.Curry_PrettyImpl.C_Doc
d_C__case_37 x3 x4 x1 x6 cd cs = case x6 of
  FlatCurry.Curry_Types.C_Public -> Curry_Prelude.OP_Cons (d_C_ppPrefixQOp x1 x4
    cd cs) x3
  FlatCurry.Curry_Types.C_Private -> x3
  FlatCurry.Curry_Types.Choice_C_Visibility d i l r -> narrow d i (d_C__case_37
    x3 x4 x1 l cd cs) (d_C__case_37 x3 x4 x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Visibility d i xs -> narrows cs d i (\z ->
    d_C__case_37 x3 x4 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Visibility d c e -> guardCons d c ((\x ->
    d_C__case_37 x3 x4 x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Visibility d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_37" [show x3, show x4, show x1, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_37" (showCons x6))

nd_C__case_37 :: Curry_Prelude.OP_List Text.Curry_PrettyImpl.C_Doc
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Options
  -> FlatCurry.Curry_Types.C_Visibility -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Text.Curry_PrettyImpl.C_Doc
nd_C__case_37 x3 x4 x1 x6 s cd cs = case x6 of
  FlatCurry.Curry_Types.C_Public -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixQOp x1 x4 s0 cd cs) x3
  FlatCurry.Curry_Types.C_Private -> x3
  FlatCurry.Curry_Types.Choice_C_Visibility d i l r -> narrow d i (nd_C__case_37
    x3 x4 x1 l s cd cs) (nd_C__case_37 x3 x4 x1 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Visibility d i xs -> narrows cs d i (\z ->
    nd_C__case_37 x3 x4 x1 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Visibility d c e -> guardCons d c ((\x ->
    nd_C__case_37 x3 x4 x1 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Visibility d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_37" [show x3, show x4, show x1, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_37" (showCons x6))

d_C__case_36 :: Curry_Prelude.OP_List Text.Curry_PrettyImpl.C_Doc
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Options
  -> FlatCurry.Curry_Types.C_Visibility -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Text.Curry_PrettyImpl.C_Doc
d_C__case_36 x3 x4 x1 x6 cd cs = case x6 of
  FlatCurry.Curry_Types.C_Public -> Curry_Prelude.OP_Cons (d_C_ppPrefixQOp x1 x4
    cd cs) x3
  FlatCurry.Curry_Types.C_Private -> x3
  FlatCurry.Curry_Types.Choice_C_Visibility d i l r -> narrow d i (d_C__case_36
    x3 x4 x1 l cd cs) (d_C__case_36 x3 x4 x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Visibility d i xs -> narrows cs d i (\z ->
    d_C__case_36 x3 x4 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Visibility d c e -> guardCons d c ((\x ->
    d_C__case_36 x3 x4 x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Visibility d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_36" [show x3, show x4, show x1, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_36" (showCons x6))

nd_C__case_36 :: Curry_Prelude.OP_List Text.Curry_PrettyImpl.C_Doc
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Options
  -> FlatCurry.Curry_Types.C_Visibility -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Text.Curry_PrettyImpl.C_Doc
nd_C__case_36 x3 x4 x1 x6 s cd cs = case x6 of
  FlatCurry.Curry_Types.C_Public -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixQOp x1 x4 s0 cd cs) x3
  FlatCurry.Curry_Types.C_Private -> x3
  FlatCurry.Curry_Types.Choice_C_Visibility d i l r -> narrow d i (nd_C__case_36
    x3 x4 x1 l s cd cs) (nd_C__case_36 x3 x4 x1 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Visibility d i xs -> narrows cs d i (\z ->
    nd_C__case_36 x3 x4 x1 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Visibility d c e -> guardCons d c ((\x ->
    nd_C__case_36 x3 x4 x1 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Visibility d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_36" [show x3, show x4, show x1, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_36" (showCons x6))

d_C__case_32 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Kind)
  -> FlatCurry.Curry_Types.C_TypeExpr -> C_Options -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_32 x9 x10 x1 x2 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> d_C_ppTypeExpr x1 x2 x10 cd cs
  Curry_Prelude.C_False -> d_C__case_31 x10 x1 x9 x2
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_32 x9 x10 x1 x2 l
    cd cs) (d_C__case_32 x9 x10 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_32 x9
    x10 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_32 x9 x10
    x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_32" [show x9, show x10, show x1, show x2, show x11]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_32" (showCons x11))

nd_C__case_32 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Kind)
  -> FlatCurry.Curry_Types.C_TypeExpr -> C_Options -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_32 x9 x10 x1 x2 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_ppTypeExpr x1 x2 x10 s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_31 x10 x1 x9 x2 (Curry_Prelude.d_C_otherwise cd cs)
    s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_32 x9 x10 x1 x2
    l s cd cs) (nd_C__case_32 x9 x10 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_32 x9
    x10 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_32 x9 x10
    x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_32" [show x9, show x10, show x1, show x2, show x11]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_32" (showCons x11))

d_C__case_31 :: FlatCurry.Curry_Types.C_TypeExpr -> C_Options
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_Kind) -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_31 x10 x1 x9 x2 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar
    (Text.Curry_Pretty.d_C_parensIf (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.C_Int (0)) cd cs)) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (d_C_ppQuantifiedVars x9 cd cs) cd cs) (d_C_ppTypeExpr x1
    (Curry_Prelude.C_Int (0)) x10 cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_31 x10 x1 x9 x2 l
    cd cs) (d_C__case_31 x10 x1 x9 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_31 x10
    x1 x9 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_31 x10 x1
    x9 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_31" [show x10, show x1, show x9, show x2, show x11]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_31" (showCons x11))

nd_C__case_31 :: FlatCurry.Curry_Types.C_TypeExpr -> C_Options
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_Kind) -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_31 x10 x1 x9 x2 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s13 = s
    in s13 `seq` (let s12 = leftSupply s13
                      s14 = rightSupply s13
                      s2 = leftSupply s14
                      s10 = rightSupply s14
    in s12 `seq` (s14 `seq` (s2 `seq` (s10 `seq` Curry_Prelude.nd_OP_dollar
    (wrapNX id (Text.Curry_Pretty.nd_C_parensIf (let s1 = leftSupply s2
                                                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs)) x2 s0 cd cs) (Curry_Prelude.C_Int (0)) s1 cd cs))))
    (let s9 = leftSupply s10
         s11 = rightSupply s10
         s6 = leftSupply s11
         s8 = rightSupply s11
    in s9 `seq` (s11 `seq` (s6 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (let s5 = leftSupply s6
         s7 = rightSupply s6
         s3 = leftSupply s7
         s4 = rightSupply s7
    in s5 `seq` (s7 `seq` (s3 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s3 cd cs) (nd_C_ppQuantifiedVars x9 s4
    cd cs) s5 cd cs)))) (nd_C_ppTypeExpr x1 (Curry_Prelude.C_Int (0)) x10 s8 cd
    cs) s9 cd cs)))) s12 cd cs))))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_31 x10 x1 x9 x2
    l s cd cs) (nd_C__case_31 x10 x1 x9 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_31 x10
    x1 x9 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_31 x10 x1
    x9 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_31" [show x10, show x1, show x9, show x2, show x11]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_31" (showCons x11))

d_C__case_35 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Options
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C__case_35 x8 x7 x1 x2 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_C_brackets cd cs) (Curry_Prelude.d_C_apply
    (d_C_ppTypeExp x1 cd cs) (Curry_Prelude.d_C_head x8 cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_34 x7 x8 x1 x2 (d_C_isTupleId x7 cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_35 x8 x7 x1 x2 l
    cd cs) (d_C__case_35 x8 x7 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_35 x8
    x7 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_35 x8 x7
    x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_35" [show x8, show x7, show x1, show x2, show x9]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_35" (showCons x9))

nd_C__case_35 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Options
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_35 x8 x7 x1 x2 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_brackets s0 cd cs) (let s2 = leftSupply s3
                                                    s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (nd_C_ppTypeExp x1 s1 cd cs)
    (Curry_Prelude.d_C_head x8 cd cs) s2 cd cs)) s4 cd cs))))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_34 x7 x8 x1 x2 (d_C_isTupleId x7 cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_35 x8 x7 x1 x2 l
    s cd cs) (nd_C__case_35 x8 x7 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_35 x8
    x7 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_35 x8 x7
    x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_35" [show x8, show x7, show x1, show x2, show x9]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_35" (showCons x9))

d_C__case_34 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr -> C_Options
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C__case_34 x7 x8 x1 x2 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_C_tupled
    cd cs) (Curry_Prelude.d_C_map (d_C_ppTypeExp x1 cd cs) x8 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_33 x8 x1 x7 x2 (Curry_Prelude.d_C_otherwise
    cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_34 x7 x8 x1 x2 l
    cd cs) (d_C__case_34 x7 x8 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_34 x7
    x8 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_34 x7 x8
    x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_34" [show x7, show x8, show x1, show x2, show x9]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_34" (showCons x9))

nd_C__case_34 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr -> C_Options
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_34 x7 x8 x1 x2 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_tupled s0 cd cs) (let s2 = leftSupply s3
                                                  s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_map (nd_C_ppTypeExp x1 s1 cd cs) x8
    s2 cd cs)) s4 cd cs))))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_33 x8 x1 x7 x2 (Curry_Prelude.d_C_otherwise cd cs) s0
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_34 x7 x8 x1 x2 l
    s cd cs) (nd_C__case_34 x7 x8 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_34 x7
    x8 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_34 x7 x8
    x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_34" [show x7, show x8, show x1, show x2, show x9]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_34" (showCons x9))

d_C__case_33 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> C_Options -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C__case_33 x8 x1 x7 x2 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar
    (Text.Curry_Pretty.d_C_parensIf (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.C_Int (1)) cd cs) (Curry_Prelude.d_C_not
    (Curry_Prelude.d_C_null x8 cd cs) cd cs) cd cs)) (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_C_sep cd cs) (Curry_Prelude.OP_Cons (d_C_ppPrefixQOp x1
    x7 cd cs) (Curry_Prelude.d_C_map (d_C_ppTypeExpr x1 (Curry_Prelude.C_Int
    (2))) x8 cd cs)) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_33 x8 x1 x7 x2 l
    cd cs) (d_C__case_33 x8 x1 x7 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_33 x8
    x1 x7 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_33 x8 x1
    x7 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_33" [show x8, show x1, show x7, show x2, show x9]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_33" (showCons x9))

nd_C__case_33 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> C_Options -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_33 x8 x1 x7 x2 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s11 = s
    in s11 `seq` (let s10 = leftSupply s11
                      s12 = rightSupply s11
                      s2 = leftSupply s12
                      s8 = rightSupply s12
    in s10 `seq` (s12 `seq` (s2 `seq` (s8 `seq` Curry_Prelude.nd_OP_dollar
    (wrapNX id (Text.Curry_Pretty.nd_C_parensIf (Curry_Prelude.d_OP_amp_amp
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs)) x2 s0 cd cs) (Curry_Prelude.C_Int (1)) s1 cd cs))
    (Curry_Prelude.d_C_not (Curry_Prelude.d_C_null x8 cd cs) cd cs) cd cs)))
    (let s7 = leftSupply s8
         s9 = rightSupply s8
         s3 = leftSupply s9
         s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s3 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_sep s3 cd cs) (let s4 = leftSupply s6
                                               s5 = rightSupply s6
    in s4 `seq` (s5 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixQOp x1 x7 s4 cd
    cs) (Curry_Prelude.nd_C_map (wrapNX id (nd_C_ppTypeExpr x1
    (Curry_Prelude.C_Int (2)))) x8 s5 cd cs))) s7 cd cs)))) s10 cd cs))))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_33 x8 x1 x7 x2 l
    s cd cs) (nd_C__case_33 x8 x1 x7 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_33 x8
    x1 x7 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_33 x8 x1
    x7 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_33" [show x8, show x1, show x7, show x2, show x9]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_33" (showCons x9))

d_C__case_30 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Kind) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_30 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Text.Curry_Pretty.d_C_empty cd cs
  Curry_Prelude.C_False -> d_C__case_29 x1 (Curry_Prelude.d_C_otherwise cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_30 x1 l cd cs)
    (d_C__case_30 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_30 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_30 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_30" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_30" (showCons x2))

nd_C__case_30 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Kind) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_30 x1 x2 s cd cs = case x2 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_empty s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_29 x1 (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_30 x1 l s cd cs)
    (nd_C__case_30 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_30 x1
    z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_30 x1 e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_30" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_30" (showCons x2))

d_C__case_29 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Kind) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_29 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (Text.Curry_Pretty.d_C_text (Curry_Prelude.toCurryString "forall") cd cs) cd
    cs) (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_C_hsep cd cs)
    (Curry_Prelude.d_C_map (Curry_Prelude.d_OP_dot d_C_ppTVarIndex
    Curry_Prelude.d_C_fst cd cs) x1 cd cs) cd cs) cd cs) cd cs)
    (Text.Curry_Pretty.d_C_char (Curry_Prelude.C_Char '.'#) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_29 x1 l cd cs)
    (d_C__case_29 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_29 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_29 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_29" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_29" (showCons x2))

nd_C__case_29 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Kind) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_29 x1 x2 s cd cs = case x2 of
  Curry_Prelude.C_True -> let s21 = s
    in s21 `seq` (let s20 = leftSupply s21
                      s22 = rightSupply s21
                      s17 = leftSupply s22
                      s19 = rightSupply s22
    in s20 `seq` (s22 `seq` (s17 `seq` (s19 `seq` Curry_Prelude.nd_C_apply
    (let s16 = leftSupply s17
         s18 = rightSupply s17
         s0 = leftSupply s18
         s14 = rightSupply s18
    in s16 `seq` (s18 `seq` (s0 `seq` (s14 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (let s13 = leftSupply s14
                                                       s15 = rightSupply s14
                                                       s4 = leftSupply s15
                                                       s11 = rightSupply s15
    in s13 `seq` (s15 `seq` (s4 `seq` (s11 `seq` Curry_Prelude.nd_C_apply
    (let s3 = leftSupply s4
         s5 = rightSupply s4
         s1 = leftSupply s5
         s2 = rightSupply s5
    in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (Text.Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "forall") s2 cd cs) s3 cd cs))))
    (let s10 = leftSupply s11
         s12 = rightSupply s11
         s6 = leftSupply s12
         s9 = rightSupply s12
    in s10 `seq` (s12 `seq` (s6 `seq` (s9 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_hsep s6 cd cs) (let s8 = leftSupply s9
                                                s7 = rightSupply s9
    in s8 `seq` (s7 `seq` Curry_Prelude.nd_C_map (Curry_Prelude.nd_OP_dot
    (wrapNX id nd_C_ppTVarIndex) (wrapDX id Curry_Prelude.d_C_fst) s7 cd cs) x1
    s8 cd cs)) s10 cd cs)))) s13 cd cs)))) s16 cd cs))))
    (Text.Curry_Pretty.nd_C_char (Curry_Prelude.C_Char '.'#) s19 cd cs) s20 cd
    cs))))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_29 x1 l s cd cs)
    (nd_C__case_29 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_29 x1
    z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_29 x1 e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_29" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_29" (showCons x2))

d_C__case_28 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_28 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x1 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_28 x1 l cd cs)
    (d_C__case_28 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_28 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_28 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_28" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_28" (showCons x2))

d_C__case_27 :: Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_Expr -> C_Options -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_27 x3 x4 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Text.Curry_Pretty.d_C_equals cd
    cs) cd cs) (Curry_Prelude.d_C_apply (d_C_ppExp x1 cd cs) x4 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_26 x4 x1 x3 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_27 x3 x4 x1 l cd
    cs) (d_C__case_27 x3 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_27 x3
    x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_27 x3 x4
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_27" [show x3, show x4, show x1, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_27" (showCons x5))

nd_C__case_27 :: Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_Expr -> C_Options -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_27 x3 x4 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s3 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s3 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
    (let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (Text.Curry_Pretty.nd_C_equals
    s1 cd cs) s2 cd cs)))) (let s6 = leftSupply s7
                                s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (nd_C_ppExp x1 s5 cd cs) x4
    s6 cd cs)) s8 cd cs))))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_26 x4 x1 x3 (Curry_Prelude.d_C_otherwise cd cs) s0 cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_27 x3 x4 x1 l s
    cd cs) (nd_C__case_27 x3 x4 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_27 x3
    x4 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_27 x3 x4
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_27" [show x3, show x4, show x1, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_27" (showCons x5))

d_C__case_26 :: FlatCurry.Curry_Types.C_Expr -> C_Options
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_26 x4 x1 x3 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_slash_gt cd cs) (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_C_hsep cd cs) (Curry_Prelude.d_C_map d_C_ppVarIndex x3
    cd cs) cd cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Text.Curry_Pretty.d_C_equals cd
    cs) cd cs) (Curry_Prelude.d_C_apply (d_C_ppExp x1 cd cs) x4 cd cs) cd cs) cd
    cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_26 x4 x1 x3 l cd
    cs) (d_C__case_26 x4 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_26 x4
    x1 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_26 x4 x1
    x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_26" [show x4, show x1, show x3, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_26" (showCons x5))

nd_C__case_26 :: FlatCurry.Curry_Types.C_Expr -> C_Options
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_26 x4 x1 x3 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s21 = s
    in s21 `seq` (let s20 = leftSupply s21
                      s22 = rightSupply s21
                      s7 = leftSupply s22
                      s18 = rightSupply s22
    in s20 `seq` (s22 `seq` (s7 `seq` (s18 `seq` Curry_Prelude.nd_C_apply
    (let s6 = leftSupply s7
         s8 = rightSupply s7
         s0 = leftSupply s8
         s4 = rightSupply s8
    in s6 `seq` (s8 `seq` (s0 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_slash_gt s0 cd cs) (let s3 = leftSupply s4
                                                        s5 = rightSupply s4
                                                        s1 = leftSupply s5
                                                        s2 = rightSupply s5
    in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_hsep s1 cd cs) (Curry_Prelude.nd_C_map (wrapNX id
    nd_C_ppVarIndex) x3 s2 cd cs) s3 cd cs)))) s6 cd cs))))
    (let s17 = leftSupply s18
         s19 = rightSupply s18
         s12 = leftSupply s19
         s16 = rightSupply s19
    in s17 `seq` (s19 `seq` (s12 `seq` (s16 `seq` Curry_Prelude.nd_C_apply
    (let s11 = leftSupply s12
         s13 = rightSupply s12
         s9 = leftSupply s13
         s10 = rightSupply s13
    in s11 `seq` (s13 `seq` (s9 `seq` (s10 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s9 cd cs) (Text.Curry_Pretty.nd_C_equals
    s10 cd cs) s11 cd cs)))) (let s15 = leftSupply s16
                                  s14 = rightSupply s16
    in s15 `seq` (s14 `seq` Curry_Prelude.nd_C_apply (nd_C_ppExp x1 s14 cd cs)
    x4 s15 cd cs)) s17 cd cs)))) s20 cd cs))))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_26 x4 x1 x3 l s
    cd cs) (nd_C__case_26 x4 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_26 x4
    x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_26 x4 x1
    x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_26" [show x4, show x1, show x3, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_26" (showCons x5))

d_C__case_23 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Expr)
  -> FlatCurry.Curry_Types.C_Expr -> C_Options -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_23 x11 x12 x1 x13 cd cs = case x13 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_C_vsep cd
    cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "let") cd cs) cd cs) (Curry_Prelude.d_C_apply
    (d_C_ppDecls x1 cd cs) x11 cd cs) cd cs) (Curry_Prelude.OP_Cons
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "in") cd cs) cd cs) (Curry_Prelude.d_C_apply
    (d_C_ppExp x1 cd cs) x12 cd cs) cd cs) Curry_Prelude.OP_List)) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_C_sep cd
    cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "let") cd cs) cd cs) (Curry_Prelude.d_C_apply
    (d_C_ppDecls x1 cd cs) x11 cd cs) cd cs) (Curry_Prelude.OP_Cons
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "in") cd cs) cd cs) (Curry_Prelude.d_C_apply
    (d_C_ppExp x1 cd cs) x12 cd cs) cd cs) Curry_Prelude.OP_List)) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_23 x11 x12 x1 l
    cd cs) (d_C__case_23 x11 x12 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_23 x11
    x12 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_23 x11 x12
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_23" [show x11, show x12, show x1, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_23" (showCons x13))

nd_C__case_23 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Expr)
  -> FlatCurry.Curry_Types.C_Expr -> C_Options -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_23 x11 x12 x1 x13 s cd cs = case x13 of
  Curry_Prelude.C_True -> let s25 = s
    in s25 `seq` (let s24 = leftSupply s25
                      s26 = rightSupply s25
                      s0 = leftSupply s26
                      s23 = rightSupply s26
    in s24 `seq` (s26 `seq` (s0 `seq` (s23 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_vsep s0 cd cs) (let s10 = leftSupply s23
                                                s21 = rightSupply s23
    in s10 `seq` (s21 `seq` Curry_Prelude.OP_Cons (let s9 = leftSupply s10
                                                       s11 = rightSupply s10
                                                       s4 = leftSupply s11
                                                       s8 = rightSupply s11
    in s9 `seq` (s11 `seq` (s4 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (let s3 = leftSupply s4
         s5 = rightSupply s4
         s1 = leftSupply s5
         s2 = rightSupply s5
    in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (Text.Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "let") s2 cd cs) s3 cd cs))))
    (let s7 = leftSupply s8
         s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (nd_C_ppDecls x1 s6 cd cs)
    x11 s7 cd cs)) s9 cd cs)))) (Curry_Prelude.OP_Cons (let s20 = leftSupply s21
                                                            s22 = rightSupply
                                                              s21
                                                            s15 = leftSupply s22
                                                            s19 = rightSupply
                                                              s22
    in s20 `seq` (s22 `seq` (s15 `seq` (s19 `seq` Curry_Prelude.nd_C_apply
    (let s14 = leftSupply s15
         s16 = rightSupply s15
         s12 = leftSupply s16
         s13 = rightSupply s16
    in s14 `seq` (s16 `seq` (s12 `seq` (s13 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s12 cd cs) (Text.Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "in") s13 cd cs) s14 cd cs))))
    (let s18 = leftSupply s19
         s17 = rightSupply s19
    in s18 `seq` (s17 `seq` Curry_Prelude.nd_C_apply (nd_C_ppExp x1 s17 cd cs)
    x12 s18 cd cs)) s20 cd cs)))) Curry_Prelude.OP_List))) s24 cd cs))))
  Curry_Prelude.C_False -> let s25 = s
    in s25 `seq` (let s24 = leftSupply s25
                      s26 = rightSupply s25
                      s0 = leftSupply s26
                      s23 = rightSupply s26
    in s24 `seq` (s26 `seq` (s0 `seq` (s23 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_sep s0 cd cs) (let s10 = leftSupply s23
                                               s21 = rightSupply s23
    in s10 `seq` (s21 `seq` Curry_Prelude.OP_Cons (let s9 = leftSupply s10
                                                       s11 = rightSupply s10
                                                       s4 = leftSupply s11
                                                       s8 = rightSupply s11
    in s9 `seq` (s11 `seq` (s4 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (let s3 = leftSupply s4
         s5 = rightSupply s4
         s1 = leftSupply s5
         s2 = rightSupply s5
    in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (Text.Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "let") s2 cd cs) s3 cd cs))))
    (let s7 = leftSupply s8
         s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (nd_C_ppDecls x1 s6 cd cs)
    x11 s7 cd cs)) s9 cd cs)))) (Curry_Prelude.OP_Cons (let s20 = leftSupply s21
                                                            s22 = rightSupply
                                                              s21
                                                            s15 = leftSupply s22
                                                            s19 = rightSupply
                                                              s22
    in s20 `seq` (s22 `seq` (s15 `seq` (s19 `seq` Curry_Prelude.nd_C_apply
    (let s14 = leftSupply s15
         s16 = rightSupply s15
         s12 = leftSupply s16
         s13 = rightSupply s16
    in s14 `seq` (s16 `seq` (s12 `seq` (s13 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s12 cd cs) (Text.Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "in") s13 cd cs) s14 cd cs))))
    (let s18 = leftSupply s19
         s17 = rightSupply s19
    in s18 `seq` (s17 `seq` Curry_Prelude.nd_C_apply (nd_C_ppExp x1 s17 cd cs)
    x12 s18 cd cs)) s20 cd cs)))) Curry_Prelude.OP_List))) s24 cd cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_23 x11 x12 x1 l
    s cd cs) (nd_C__case_23 x11 x12 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_23 x11
    x12 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_23 x11
    x12 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_23" [show x11, show x12, show x1, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_23" (showCons x13))

d_C__case_25 :: Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_Expr -> C_Options -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_25 x9 x10 x1 x2 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> d_C_ppExpr x1 x2 x10 cd cs
  Curry_Prelude.C_False -> d_C__case_24 x10 x1 x9 x2
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_25 x9 x10 x1 x2 l
    cd cs) (d_C__case_25 x9 x10 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_25 x9
    x10 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_25 x9 x10
    x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_25" [show x9, show x10, show x1, show x2, show x11]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_25" (showCons x11))

nd_C__case_25 :: Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_Expr -> C_Options -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_25 x9 x10 x1 x2 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C_ppExpr x1 x2 x10 s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_24 x10 x1 x9 x2 (Curry_Prelude.d_C_otherwise cd cs)
    s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_25 x9 x10 x1 x2
    l s cd cs) (nd_C__case_25 x9 x10 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_25 x9
    x10 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_25 x9 x10
    x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_25" [show x9, show x10, show x1, show x2, show x11]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_25" (showCons x11))

d_C__case_24 :: FlatCurry.Curry_Types.C_Expr -> C_Options
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_24 x10 x1 x9 x2 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar
    (Text.Curry_Pretty.d_C_parensIf (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.C_Int (0)) cd cs)) (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_C_sep cd cs) (Curry_Prelude.OP_Cons
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (Text.Curry_Pretty.d_C_text (Curry_Prelude.toCurryString "let") cd cs) cd
    cs) (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_C_sep cd cs)
    (Text.Curry_Pretty.d_C_punctuate (Text.Curry_Pretty.d_C_comma cd cs)
    (Curry_Prelude.d_C_map d_C_ppVarIndex x9 cd cs) cd cs) cd cs) cd cs) cd cs)
    (Text.Curry_Pretty.d_C_text (Curry_Prelude.toCurryString "free") cd cs) cd
    cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_slash_gt cd cs) (Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "in") cd cs) cd cs) (Curry_Prelude.d_C_apply
    (d_C_ppExp x1 cd cs) x10 cd cs) cd cs) Curry_Prelude.OP_List)) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_24 x10 x1 x9 x2 l
    cd cs) (d_C__case_24 x10 x1 x9 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_24 x10
    x1 x9 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_24 x10 x1
    x9 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_24" [show x10, show x1, show x9, show x2, show x11]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_24" (showCons x11))

nd_C__case_24 :: FlatCurry.Curry_Types.C_Expr -> C_Options
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_24 x10 x1 x9 x2 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s45 = s
    in s45 `seq` (let s44 = leftSupply s45
                      s46 = rightSupply s45
                      s2 = leftSupply s46
                      s42 = rightSupply s46
    in s44 `seq` (s46 `seq` (s2 `seq` (s42 `seq` Curry_Prelude.nd_OP_dollar
    (wrapNX id (Text.Curry_Pretty.nd_C_parensIf (let s1 = leftSupply s2
                                                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs)) x2 s0 cd cs) (Curry_Prelude.C_Int (0)) s1 cd cs))))
    (let s41 = leftSupply s42
         s43 = rightSupply s42
         s3 = leftSupply s43
         s40 = rightSupply s43
    in s41 `seq` (s43 `seq` (s3 `seq` (s40 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_sep s3 cd cs) (let s27 = leftSupply s40
                                               s38 = rightSupply s40
    in s27 `seq` (s38 `seq` Curry_Prelude.OP_Cons (let s26 = leftSupply s27
                                                       s28 = rightSupply s27
                                                       s23 = leftSupply s28
                                                       s25 = rightSupply s28
    in s26 `seq` (s28 `seq` (s23 `seq` (s25 `seq` Curry_Prelude.nd_C_apply
    (let s22 = leftSupply s23
         s24 = rightSupply s23
         s4 = leftSupply s24
         s20 = rightSupply s24
    in s22 `seq` (s24 `seq` (s4 `seq` (s20 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s4 cd cs) (let s19 = leftSupply s20
                                                       s21 = rightSupply s20
                                                       s8 = leftSupply s21
                                                       s17 = rightSupply s21
    in s19 `seq` (s21 `seq` (s8 `seq` (s17 `seq` Curry_Prelude.nd_C_apply
    (let s7 = leftSupply s8
         s9 = rightSupply s8
         s5 = leftSupply s9
         s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s5 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s5 cd cs) (Text.Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "let") s6 cd cs) s7 cd cs))))
    (let s16 = leftSupply s17
         s18 = rightSupply s17
         s10 = leftSupply s18
         s14 = rightSupply s18
    in s16 `seq` (s18 `seq` (s10 `seq` (s14 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_sep s10 cd cs) (let s13 = leftSupply s14
                                                s15 = rightSupply s14
                                                s11 = leftSupply s15
                                                s12 = rightSupply s15
    in s13 `seq` (s15 `seq` (s11 `seq` (s12 `seq`
    Text.Curry_Pretty.nd_C_punctuate (Text.Curry_Pretty.nd_C_comma s11 cd cs)
    (Curry_Prelude.nd_C_map (wrapNX id nd_C_ppVarIndex) x9 s12 cd cs) s13 cd
    cs)))) s16 cd cs)))) s19 cd cs)))) s22 cd cs))))
    (Text.Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString "free") s25 cd cs)
    s26 cd cs)))) (Curry_Prelude.OP_Cons (let s37 = leftSupply s38
                                              s39 = rightSupply s38
                                              s32 = leftSupply s39
                                              s36 = rightSupply s39
    in s37 `seq` (s39 `seq` (s32 `seq` (s36 `seq` Curry_Prelude.nd_C_apply
    (let s31 = leftSupply s32
         s33 = rightSupply s32
         s29 = leftSupply s33
         s30 = rightSupply s33
    in s31 `seq` (s33 `seq` (s29 `seq` (s30 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_slash_gt s29 cd cs) (Text.Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "in") s30 cd cs) s31 cd cs))))
    (let s35 = leftSupply s36
         s34 = rightSupply s36
    in s35 `seq` (s34 `seq` Curry_Prelude.nd_C_apply (nd_C_ppExp x1 s34 cd cs)
    x10 s35 cd cs)) s37 cd cs)))) Curry_Prelude.OP_List))) s41 cd cs)))) s44 cd
    cs))))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_24 x10 x1 x9 x2
    l s cd cs) (nd_C__case_24 x10 x1 x9 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_24 x10
    x1 x9 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_24 x10 x1
    x9 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_24" [show x10, show x1, show x9, show x2, show x11]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_24" (showCons x11))

d_C__case_22 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_22 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar Text.Curry_Pretty.d_C_text
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'x'#) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_negate_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 cd cs) cd cs)) cd cs
  Curry_Prelude.C_False -> d_C__case_21 x1 (Curry_Prelude.d_C_otherwise cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_22 x1 l cd cs)
    (d_C__case_22 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_22 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_22 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_22" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_22" (showCons x2))

nd_C__case_22 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_22 x1 x2 s cd cs = case x2 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    Text.Curry_Pretty.nd_C_text) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char
    'x'#) (Curry_Prelude.nd_C_apply (wrapDX id
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs))
    (Curry_Prelude.d_OP_uscore_impl_hash_negate_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 cd cs) s0 cd cs)) s1 cd cs))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_21 x1 (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_22 x1 l s cd cs)
    (nd_C__case_22 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_22 x1
    z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_22 x1 e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_22" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_22" (showCons x2))

d_C__case_21 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_21 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar Text.Curry_Pretty.d_C_text
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'v'#) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x1 cd cs)) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_21 x1 l cd cs)
    (d_C__case_21 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_21 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_21 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_21" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_21" (showCons x2))

nd_C__case_21 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_21 x1 x2 s cd cs = case x2 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    Text.Curry_Pretty.nd_C_text) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char
    'v'#) (Curry_Prelude.nd_C_apply (wrapDX id
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs)) x1 s0 cd cs)) s1 cd cs))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_21 x1 l s cd cs)
    (nd_C__case_21 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_21 x1
    z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_21 x1 e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_21" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_21" (showCons x2))

d_C__case_20 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Options
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C__case_20 x4 x3 x1 x2 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "[]") cd cs
  Curry_Prelude.C_False -> d_C__case_19 x3 x4 x1 x2 (d_C_isTupleId x3 cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_20 x4 x3 x1 x2 l
    cd cs) (d_C__case_20 x4 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_20 x4
    x3 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_20 x4 x3
    x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_20" [show x4, show x3, show x1, show x2, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_20" (showCons x5))

nd_C__case_20 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Options
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_20 x4 x3 x1 x2 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString "[]")
    s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_19 x3 x4 x1 x2 (d_C_isTupleId x3 cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_20 x4 x3 x1 x2 l
    s cd cs) (nd_C__case_20 x4 x3 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_20 x4
    x3 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_20 x4 x3
    x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_20" [show x4, show x3, show x1, show x2, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_20" (showCons x5))

d_C__case_19 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> C_Options
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C__case_19 x3 x4 x1 x2 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_C_tupled
    cd cs) (Curry_Prelude.d_C_map (d_C_ppExp x1 cd cs) x4 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_18 x4 x1 x3 x2 (Curry_Prelude.d_C_otherwise
    cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_19 x3 x4 x1 x2 l
    cd cs) (d_C__case_19 x3 x4 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_19 x3
    x4 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_19 x3 x4
    x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_19" [show x3, show x4, show x1, show x2, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_19" (showCons x5))

nd_C__case_19 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> C_Options
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_19 x3 x4 x1 x2 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_tupled s0 cd cs) (let s2 = leftSupply s3
                                                  s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_map (nd_C_ppExp x1 s1 cd cs) x4 s2
    cd cs)) s4 cd cs))))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_18 x4 x1 x3 x2 (Curry_Prelude.d_C_otherwise cd cs) s0
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_19 x3 x4 x1 x2 l
    s cd cs) (nd_C__case_19 x3 x4 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_19 x3
    x4 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_19 x3 x4
    x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_19" [show x3, show x4, show x1, show x2, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_19" (showCons x5))

d_C__case_18 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> C_Options
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_18 x4 x1 x3 x2 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> d_C__case_17 x1 x3 x2 x4 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_18 x4 x1 x3 x2 l
    cd cs) (d_C__case_18 x4 x1 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_18 x4
    x1 x3 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_18 x4 x1
    x3 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_18" [show x4, show x1, show x3, show x2, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_18" (showCons x5))

nd_C__case_18 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> C_Options
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_18 x4 x1 x3 x2 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C__case_17 x1 x3 x2 x4 s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_18 x4 x1 x3 x2 l
    s cd cs) (nd_C__case_18 x4 x1 x3 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_18 x4
    x1 x3 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_18 x4 x1
    x3 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_18" [show x4, show x1, show x3, show x2, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_18" (showCons x5))

d_C__case_17 :: C_Options -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_17 x1 x3 x2 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> d_C_ppPrefixQOp x1 x3 cd cs
  Curry_Prelude.OP_Cons x5 x6 -> d_C__case_16 x4 x1 x3 x2 x5 x6 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_17 x1 x3 x2 l cd
    cs) (d_C__case_17 x1 x3 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_17 x1
    x3 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_17 x1 x3
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_17" [show x1, show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_17" (showCons x4))

nd_C__case_17 :: C_Options -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> IDSupply -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_17 x1 x3 x2 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` nd_C_ppPrefixQOp x1 x3 s0 cd cs
  Curry_Prelude.OP_Cons x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_16 x4 x1 x3 x2 x5 x6 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_17 x1 x3 x2 l s
    cd cs) (nd_C__case_17 x1 x3 x2 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_17 x1
    x3 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_17 x1 x3
    x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_17" [show x1, show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_17" (showCons x4))

d_C__case_16 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> C_Options
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C__case_16 x4 x1 x3 x2 x5 x6 cd cs = case x6 of
  Curry_Prelude.OP_Cons x7 x8 -> d_C__case_15 x4 x1 x3 x2 x7 x5 x8 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_dollar
    (Text.Curry_Pretty.d_C_parensIf (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.C_Int (0)) cd cs)) (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_C_fillSep cd cs) (Curry_Prelude.OP_Cons
    (d_C_ppPrefixQOp x1 x3 cd cs) (Curry_Prelude.d_C_map (d_C_ppExpr x1
    (Curry_Prelude.C_Int (1))) x4 cd cs)) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_16 x4 x1 x3 x2
    x5 l cd cs) (d_C__case_16 x4 x1 x3 x2 x5 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_16 x4
    x1 x3 x2 x5 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_16 x4 x1
    x3 x2 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_16" [show x4, show x1, show x3, show x2, show x5
    , show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_16" (showCons x6))

nd_C__case_16 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> C_Options
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_16 x4 x1 x3 x2 x5 x6 s cd cs = case x6 of
  Curry_Prelude.OP_Cons x7 x8 -> let s0 = s
    in s0 `seq` nd_C__case_15 x4 x1 x3 x2 x7 x5 x8 s0 cd cs
  Curry_Prelude.OP_List -> let s11 = s
    in s11 `seq` (let s10 = leftSupply s11
                      s12 = rightSupply s11
                      s2 = leftSupply s12
                      s8 = rightSupply s12
    in s10 `seq` (s12 `seq` (s2 `seq` (s8 `seq` Curry_Prelude.nd_OP_dollar
    (wrapNX id (Text.Curry_Pretty.nd_C_parensIf (let s1 = leftSupply s2
                                                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs)) x2 s0 cd cs) (Curry_Prelude.C_Int (0)) s1 cd cs))))
    (let s7 = leftSupply s8
         s9 = rightSupply s8
         s3 = leftSupply s9
         s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s3 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_fillSep s3 cd cs) (let s4 = leftSupply s6
                                                   s5 = rightSupply s6
    in s4 `seq` (s5 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixQOp x1 x3 s4 cd
    cs) (Curry_Prelude.nd_C_map (wrapNX id (nd_C_ppExpr x1 (Curry_Prelude.C_Int
    (1)))) x4 s5 cd cs))) s7 cd cs)))) s10 cd cs))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_16 x4 x1 x3 x2
    x5 l s cd cs) (nd_C__case_16 x4 x1 x3 x2 x5 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_16 x4
    x1 x3 x2 x5 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_16 x4 x1
    x3 x2 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_16" [show x4, show x1, show x3, show x2, show x5
    , show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_16" (showCons x6))

d_C__case_15 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> C_Options
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C__case_15 x4 x1 x3 x2 x7 x5 x8 cd cs = case x8 of
  Curry_Prelude.OP_List -> d_C__case_14 x3 x4 x1 x2 x7 x5
    (Curry_Prelude.d_C_apply (d_C_isInfixOp cd cs) x3 cd cs) cd cs
  Curry_Prelude.OP_Cons x9 x10 -> Curry_Prelude.d_OP_dollar
    (Text.Curry_Pretty.d_C_parensIf (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.C_Int (0)) cd cs)) (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_C_fillSep cd cs) (Curry_Prelude.OP_Cons
    (d_C_ppPrefixQOp x1 x3 cd cs) (Curry_Prelude.d_C_map (d_C_ppExpr x1
    (Curry_Prelude.C_Int (1))) x4 cd cs)) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_15 x4 x1 x3 x2
    x7 x5 l cd cs) (d_C__case_15 x4 x1 x3 x2 x7 x5 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_15 x4
    x1 x3 x2 x7 x5 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_15 x4 x1
    x3 x2 x7 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_15" [show x4, show x1, show x3, show x2, show x7
    , show x5, show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_15" (showCons x8))

nd_C__case_15 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> C_Options
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_15 x4 x1 x3 x2 x7 x5 x8 s cd cs = case x8 of
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_14 x3 x4 x1 x2 x7 x5
    (Curry_Prelude.nd_C_apply (wrapDX id (d_C_isInfixOp cd cs)) x3 s0 cd cs) s1
    cd cs))
  Curry_Prelude.OP_Cons x9 x10 -> let s11 = s
    in s11 `seq` (let s10 = leftSupply s11
                      s12 = rightSupply s11
                      s2 = leftSupply s12
                      s8 = rightSupply s12
    in s10 `seq` (s12 `seq` (s2 `seq` (s8 `seq` Curry_Prelude.nd_OP_dollar
    (wrapNX id (Text.Curry_Pretty.nd_C_parensIf (let s1 = leftSupply s2
                                                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs)) x2 s0 cd cs) (Curry_Prelude.C_Int (0)) s1 cd cs))))
    (let s7 = leftSupply s8
         s9 = rightSupply s8
         s3 = leftSupply s9
         s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s3 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_fillSep s3 cd cs) (let s4 = leftSupply s6
                                                   s5 = rightSupply s6
    in s4 `seq` (s5 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixQOp x1 x3 s4 cd
    cs) (Curry_Prelude.nd_C_map (wrapNX id (nd_C_ppExpr x1 (Curry_Prelude.C_Int
    (1)))) x4 s5 cd cs))) s7 cd cs)))) s10 cd cs))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_15 x4 x1 x3 x2
    x7 x5 l s cd cs) (nd_C__case_15 x4 x1 x3 x2 x7 x5 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_15 x4
    x1 x3 x2 x7 x5 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_15 x4 x1
    x3 x2 x7 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_15" [show x4, show x1, show x3, show x2, show x7
    , show x5, show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_15" (showCons x8))

d_C__case_14 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> C_Options
  -> Curry_Prelude.C_Int -> FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C__case_14 x3 x4 x1 x2 x7 x5 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar
    (Text.Curry_Pretty.d_C_parensIf (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.C_Int (0)) cd cs)) (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_C_fillSep cd cs) (Curry_Prelude.OP_Cons (d_C_ppExpr x1
    (Curry_Prelude.C_Int (1)) x5 cd cs) (Curry_Prelude.OP_Cons (d_C_ppInfixQOp
    x1 x3 cd cs) (Curry_Prelude.OP_Cons (d_C_ppExpr x1 (Curry_Prelude.C_Int (1))
    x7 cd cs) Curry_Prelude.OP_List))) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar
    (Text.Curry_Pretty.d_C_parensIf (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.C_Int (0)) cd cs)) (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_C_fillSep cd cs) (Curry_Prelude.OP_Cons
    (d_C_ppPrefixQOp x1 x3 cd cs) (Curry_Prelude.d_C_map (d_C_ppExpr x1
    (Curry_Prelude.C_Int (1))) x4 cd cs)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_14 x3 x4 x1 x2 x7
    x5 l cd cs) (d_C__case_14 x3 x4 x1 x2 x7 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_14 x3
    x4 x1 x2 x7 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_14 x3 x4
    x1 x2 x7 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_14" [show x3, show x4, show x1, show x2, show x7
    , show x5, show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_14" (showCons x8))

nd_C__case_14 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> C_Options
  -> Curry_Prelude.C_Int -> FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_14 x3 x4 x1 x2 x7 x5 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s13 = s
    in s13 `seq` (let s12 = leftSupply s13
                      s14 = rightSupply s13
                      s2 = leftSupply s14
                      s10 = rightSupply s14
    in s12 `seq` (s14 `seq` (s2 `seq` (s10 `seq` Curry_Prelude.nd_OP_dollar
    (wrapNX id (Text.Curry_Pretty.nd_C_parensIf (let s1 = leftSupply s2
                                                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs)) x2 s0 cd cs) (Curry_Prelude.C_Int (0)) s1 cd cs))))
    (let s9 = leftSupply s10
         s11 = rightSupply s10
         s3 = leftSupply s11
         s8 = rightSupply s11
    in s9 `seq` (s11 `seq` (s3 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_fillSep s3 cd cs) (let s4 = leftSupply s8
                                                   s7 = rightSupply s8
    in s4 `seq` (s7 `seq` Curry_Prelude.OP_Cons (nd_C_ppExpr x1
    (Curry_Prelude.C_Int (1)) x5 s4 cd cs) (let s5 = leftSupply s7
                                                s6 = rightSupply s7
    in s5 `seq` (s6 `seq` Curry_Prelude.OP_Cons (nd_C_ppInfixQOp x1 x3 s5 cd cs)
    (Curry_Prelude.OP_Cons (nd_C_ppExpr x1 (Curry_Prelude.C_Int (1)) x7 s6 cd
    cs) Curry_Prelude.OP_List))))) s9 cd cs)))) s12 cd cs))))
  Curry_Prelude.C_False -> let s11 = s
    in s11 `seq` (let s10 = leftSupply s11
                      s12 = rightSupply s11
                      s2 = leftSupply s12
                      s8 = rightSupply s12
    in s10 `seq` (s12 `seq` (s2 `seq` (s8 `seq` Curry_Prelude.nd_OP_dollar
    (wrapNX id (Text.Curry_Pretty.nd_C_parensIf (let s1 = leftSupply s2
                                                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs)) x2 s0 cd cs) (Curry_Prelude.C_Int (0)) s1 cd cs))))
    (let s7 = leftSupply s8
         s9 = rightSupply s8
         s3 = leftSupply s9
         s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s3 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_fillSep s3 cd cs) (let s4 = leftSupply s6
                                                   s5 = rightSupply s6
    in s4 `seq` (s5 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixQOp x1 x3 s4 cd
    cs) (Curry_Prelude.nd_C_map (wrapNX id (nd_C_ppExpr x1 (Curry_Prelude.C_Int
    (1)))) x4 s5 cd cs))) s7 cd cs)))) s10 cd cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_14 x3 x4 x1 x2
    x7 x5 l s cd cs) (nd_C__case_14 x3 x4 x1 x2 x7 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_14 x3
    x4 x1 x2 x7 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_14 x3 x4
    x1 x2 x7 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_14" [show x3, show x4, show x1, show x2, show x7
    , show x5, show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_14" (showCons x8))

d_C__case_13 :: Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Options
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_13 x4 x3 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Text.Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "[]") cd cs
  Curry_Prelude.C_False -> d_C__case_12 x3 x4 x1 (d_C_isTupleId x3 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_13 x4 x3 x1 l cd
    cs) (d_C__case_13 x4 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_13 x4
    x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_13 x4 x3
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_13" [show x4, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_13" (showCons x5))

nd_C__case_13 :: Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Options
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_13 x4 x3 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString "[]")
    s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_12 x3 x4 x1 (d_C_isTupleId x3 cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_13 x4 x3 x1 l s
    cd cs) (nd_C__case_13 x4 x3 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_13 x4
    x3 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_13 x4 x3
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_13" [show x4, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_13" (showCons x5))

d_C__case_12 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> C_Options
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_12 x3 x4 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_C_tupled
    cd cs) (Curry_Prelude.d_C_map d_C_ppVarIndex x4 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_11 x4 x3 x1 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_12 x3 x4 x1 l cd
    cs) (d_C__case_12 x3 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_12 x3
    x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_12 x3 x4
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_12" [show x3, show x4, show x1, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_12" (showCons x5))

nd_C__case_12 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> C_Options
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_12 x3 x4 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_tupled s0 cd cs) (Curry_Prelude.nd_C_map (wrapNX id
    nd_C_ppVarIndex) x4 s1 cd cs) s2 cd cs))))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_11 x4 x3 x1 (Curry_Prelude.d_C_otherwise cd cs) s0 cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_12 x3 x4 x1 l s
    cd cs) (nd_C__case_12 x3 x4 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_12 x3
    x4 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_12 x3 x4
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_12" [show x3, show x4, show x1, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_12" (showCons x5))

d_C__case_11 :: Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Options
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_11 x4 x3 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> d_C__case_10 x3 x1 x4 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_11 x4 x3 x1 l cd
    cs) (d_C__case_11 x4 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_11 x4
    x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_11 x4 x3
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_11" [show x4, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_11" (showCons x5))

nd_C__case_11 :: Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Options
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_11 x4 x3 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C__case_10 x3 x1 x4 s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_11 x4 x3 x1 l s
    cd cs) (nd_C__case_11 x4 x3 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_11 x4
    x3 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_11 x4 x3
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_11" [show x4, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_11" (showCons x5))

d_C__case_10 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> C_Options -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_10 x3 x1 x4 cd cs = case x4 of
  Curry_Prelude.OP_Cons x5 x6 -> d_C__case_9 x4 x3 x1 x5 x6 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_C_hsep
    cd cs) (Curry_Prelude.OP_Cons (d_C_ppPrefixQOp x1 x3 cd cs)
    (Curry_Prelude.d_C_map d_C_ppVarIndex x4 cd cs)) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_10 x3 x1 l cd
    cs) (d_C__case_10 x3 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_10 x3
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_10 x3 x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_10" [show x3, show x1, show x4] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_10" (showCons x4))

nd_C__case_10 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> C_Options -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_10 x3 x1 x4 s cd cs = case x4 of
  Curry_Prelude.OP_Cons x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_9 x4 x3 x1 x5 x6 s0 cd cs
  Curry_Prelude.OP_List -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_hsep s0 cd cs) (let s1 = leftSupply s3
                                                s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixQOp x1 x3 s1 cd
    cs) (Curry_Prelude.nd_C_map (wrapNX id nd_C_ppVarIndex) x4 s2 cd cs))) s4 cd
    cs))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_10 x3 x1 l s cd
    cs) (nd_C__case_10 x3 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_10 x3
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_10 x3 x1
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_10" [show x3, show x1, show x4] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_10" (showCons x4))

d_C__case_9 :: Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Options
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_9 x4 x3 x1 x5 x6 cd cs = case x6 of
  Curry_Prelude.OP_Cons x7 x8 -> d_C__case_8 x4 x3 x1 x7 x5 x8 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_C_hsep
    cd cs) (Curry_Prelude.OP_Cons (d_C_ppPrefixQOp x1 x3 cd cs)
    (Curry_Prelude.d_C_map d_C_ppVarIndex x4 cd cs)) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_9 x4 x3 x1 x5 l
    cd cs) (d_C__case_9 x4 x3 x1 x5 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_9 x4
    x3 x1 x5 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_9 x4 x3
    x1 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_9" [show x4, show x3, show x1, show x5, show x6]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_9" (showCons x6))

nd_C__case_9 :: Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Options
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> IDSupply -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_9 x4 x3 x1 x5 x6 s cd cs = case x6 of
  Curry_Prelude.OP_Cons x7 x8 -> let s0 = s
    in s0 `seq` nd_C__case_8 x4 x3 x1 x7 x5 x8 s0 cd cs
  Curry_Prelude.OP_List -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_hsep s0 cd cs) (let s1 = leftSupply s3
                                                s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixQOp x1 x3 s1 cd
    cs) (Curry_Prelude.nd_C_map (wrapNX id nd_C_ppVarIndex) x4 s2 cd cs))) s4 cd
    cs))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_9 x4 x3 x1 x5 l
    s cd cs) (nd_C__case_9 x4 x3 x1 x5 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_9 x4
    x3 x1 x5 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_9 x4 x3
    x1 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_9" [show x4, show x3, show x1, show x5, show x6]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_9" (showCons x6))

d_C__case_8 :: Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Options
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_8 x4 x3 x1 x7 x5 x8 cd cs = case x8 of
  Curry_Prelude.OP_List -> d_C__case_7 x3 x4 x1 x7 x5 (Curry_Prelude.d_C_apply
    (d_C_isInfixOp cd cs) x3 cd cs) cd cs
  Curry_Prelude.OP_Cons x9 x10 -> Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_C_hsep cd cs) (Curry_Prelude.OP_Cons (d_C_ppPrefixQOp
    x1 x3 cd cs) (Curry_Prelude.d_C_map d_C_ppVarIndex x4 cd cs)) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_8 x4 x3 x1 x7 x5
    l cd cs) (d_C__case_8 x4 x3 x1 x7 x5 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_8 x4
    x3 x1 x7 x5 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_8 x4 x3
    x1 x7 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_8" [show x4, show x3, show x1, show x7, show x5
    , show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_8" (showCons x8))

nd_C__case_8 :: Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_Options
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_8 x4 x3 x1 x7 x5 x8 s cd cs = case x8 of
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_7 x3 x4 x1 x7 x5 (Curry_Prelude.nd_C_apply
    (wrapDX id (d_C_isInfixOp cd cs)) x3 s0 cd cs) s1 cd cs))
  Curry_Prelude.OP_Cons x9 x10 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_hsep s0 cd cs) (let s1 = leftSupply s3
                                                s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixQOp x1 x3 s1 cd
    cs) (Curry_Prelude.nd_C_map (wrapNX id nd_C_ppVarIndex) x4 s2 cd cs))) s4 cd
    cs))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_8 x4 x3 x1 x7
    x5 l s cd cs) (nd_C__case_8 x4 x3 x1 x7 x5 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_8 x4
    x3 x1 x7 x5 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_8 x4 x3
    x1 x7 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_8" [show x4, show x3, show x1, show x7, show x5
    , show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_8" (showCons x8))

d_C__case_7 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> C_Options
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_7 x3 x4 x1 x7 x5 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (d_C_ppVarIndex x5 cd cs) cd cs) (d_C_ppInfixQOp x1 x3 cd cs) cd cs) cd cs)
    (d_C_ppVarIndex x7 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply (Text.Curry_Pretty.d_C_hsep
    cd cs) (Curry_Prelude.OP_Cons (d_C_ppPrefixQOp x1 x3 cd cs)
    (Curry_Prelude.d_C_map d_C_ppVarIndex x4 cd cs)) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x3 x4 x1 x7 x5
    l cd cs) (d_C__case_7 x3 x4 x1 x7 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x3 x4
    x1 x7 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_7 x3 x4 x1
    x7 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_7" [show x3, show x4, show x1, show x7, show x5
    , show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_7" (showCons x8))

nd_C__case_7 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> C_Options
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_7 x3 x4 x1 x7 x5 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s15 = s
    in s15 `seq` (let s14 = leftSupply s15
                      s16 = rightSupply s15
                      s11 = leftSupply s16
                      s13 = rightSupply s16
    in s14 `seq` (s16 `seq` (s11 `seq` (s13 `seq` Curry_Prelude.nd_C_apply
    (let s10 = leftSupply s11
         s12 = rightSupply s11
         s0 = leftSupply s12
         s8 = rightSupply s12
    in s10 `seq` (s12 `seq` (s0 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (let s7 = leftSupply s8
                                                       s9 = rightSupply s8
                                                       s4 = leftSupply s9
                                                       s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s4 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (let s3 = leftSupply s4
         s5 = rightSupply s4
         s1 = leftSupply s5
         s2 = rightSupply s5
    in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (nd_C_ppVarIndex x5 s2 cd cs)
    s3 cd cs)))) (nd_C_ppInfixQOp x1 x3 s6 cd cs) s7 cd cs)))) s10 cd cs))))
    (nd_C_ppVarIndex x7 s13 cd cs) s14 cd cs))))
  Curry_Prelude.C_False -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_hsep s0 cd cs) (let s1 = leftSupply s3
                                                s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixQOp x1 x3 s1 cd
    cs) (Curry_Prelude.nd_C_map (wrapNX id nd_C_ppVarIndex) x4 s2 cd cs))) s4 cd
    cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_7 x3 x4 x1 x7 x5
    l s cd cs) (nd_C__case_7 x3 x4 x1 x7 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_7 x3
    x4 x1 x7 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_7 x3 x4
    x1 x7 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_7" [show x3, show x4, show x1, show x7, show x5
    , show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_7" (showCons x8))

d_C__case_6 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> C_Options -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C__case_6 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> d_C_ppQName x1 x2 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply
    (Text.Curry_Pretty.d_C_bquotes cd cs) (d_C_ppQName x1 x2 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x2 x1 l cd cs)
    (d_C__case_6 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x2 x1
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_6" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_6" (showCons x3))

nd_C__case_6 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> C_Options -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_6 x2 x1 x3 s cd cs = case x3 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C_ppQName x1 x2 s0 cd cs
  Curry_Prelude.C_False -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Text.Curry_Pretty.nd_C_bquotes s0 cd cs) (nd_C_ppQName x1 x2 s1 cd cs) s2
    cd cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_6 x2 x1 l s cd
    cs) (nd_C__case_6 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_6 x2
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_6 x2 x1 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_6" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_6" (showCons x3))

d_C__case_5 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_QualMode
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C__case_5 x3 x2 x5 x6 x4 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Text.Curry_Pretty.d_C_text x4 cd cs
  Curry_Prelude.C_False -> d_C__case_4 x2 x5 x3 x6 x4
    (Curry_Prelude.d_OP_bar_bar (d_C_isConsId x2 cd cs)
    (Curry_Prelude.d_OP_bar_bar (d_C_isListId x2 cd cs) (d_C_isTupleId x2 cd cs)
    cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x3 x2 x5 x6 x4
    l cd cs) (d_C__case_5 x3 x2 x5 x6 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x3 x2
    x5 x6 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x3 x2 x5
    x6 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_5" [show x3, show x2, show x5, show x6, show x4
    , show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_5" (showCons x7))

nd_C__case_5 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_QualMode
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_5 x3 x2 x5 x6 x4 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_text x4 s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_4 x2 x5 x3 x6 x4 (Curry_Prelude.d_OP_bar_bar
    (d_C_isConsId x2 cd cs) (Curry_Prelude.d_OP_bar_bar (d_C_isListId x2 cd cs)
    (d_C_isTupleId x2 cd cs) cd cs) cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_5 x3 x2 x5 x6 x4
    l s cd cs) (nd_C__case_5 x3 x2 x5 x6 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_5 x3
    x2 x5 x6 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_5 x3 x2
    x5 x6 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_5" [show x3, show x2, show x5, show x6, show x4
    , show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_5" (showCons x7))

d_C__case_4 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> C_QualMode -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C__case_4 x2 x5 x3 x6 x4 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Text.Curry_Pretty.d_C_text x4 cd cs
  Curry_Prelude.C_False -> d_C__case_3 x5 x3 x6 x4
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    x5 C_QualNone cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x2 x5 x3 x6 x4
    l cd cs) (d_C__case_4 x2 x5 x3 x6 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x2 x5
    x3 x6 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x2 x5 x3
    x6 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_4" [show x2, show x5, show x3, show x6, show x4
    , show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_4" (showCons x7))

nd_C__case_4 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> C_QualMode -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_4 x2 x5 x3 x6 x4 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_text x4 s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_3 x5 x3 x6 x4
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    x5 C_QualNone cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_4 x2 x5 x3 x6 x4
    l s cd cs) (nd_C__case_4 x2 x5 x3 x6 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_4 x2
    x5 x3 x6 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_4 x2 x5
    x3 x6 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_4" [show x2, show x5, show x3, show x6, show x4
    , show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_4" (showCons x7))

d_C__case_3 :: C_QualMode -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Text.Curry_PrettyImpl.C_Doc
d_C__case_3 x5 x3 x6 x4 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Text.Curry_Pretty.d_C_text x4 cd cs
  Curry_Prelude.C_False -> d_C__case_2 x3 x6 x5 x4 (Curry_Prelude.d_OP_amp_amp
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    x5 C_QualImportsButPrelude cd cs) (Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 x6 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "Prelude") cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x5 x3 x6 x4 l
    cd cs) (d_C__case_3 x5 x3 x6 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x5 x3
    x6 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x5 x3 x6
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_3" [show x5, show x3, show x6, show x4, show x7]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_3" (showCons x7))

nd_C__case_3 :: C_QualMode -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_3 x5 x3 x6 x4 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_text x4 s0 cd cs
  Curry_Prelude.C_False -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_2 x3 x6 x5 x4 (Curry_Prelude.d_OP_amp_amp
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    x5 C_QualImportsButPrelude cd cs) (let s0 = leftSupply s2
                                           s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 x6 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 (Curry_Prelude.toCurryString "Prelude") s1 cd cs) cd cs)) cd cs) s3 cd
    cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_3 x5 x3 x6 x4 l
    s cd cs) (nd_C__case_3 x5 x3 x6 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_3 x5
    x3 x6 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_3 x5 x3
    x6 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_3" [show x5, show x3, show x6, show x4, show x7]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_3" (showCons x7))

d_C__case_2 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_QualMode
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_2 x3 x6 x5 x4 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Text.Curry_Pretty.d_C_text x4 cd cs
  Curry_Prelude.C_False -> d_C__case_1 x6 x3 x5 x4 (Curry_Prelude.d_OP_amp_amp
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    x5 C_QualImports cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 x6 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x3 x6 x5 x4 l
    cd cs) (d_C__case_2 x3 x6 x5 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x3 x6
    x5 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x3 x6 x5
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_2" [show x3, show x6, show x5, show x4, show x7]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_2" (showCons x7))

nd_C__case_2 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_QualMode
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_2 x3 x6 x5 x4 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_text x4 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_1 x6 x3 x5 x4 (Curry_Prelude.d_OP_amp_amp
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Pretty_dot_QualMode_hash
    x5 C_QualImports cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x3 x6 s0 cd cs) cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_2 x3 x6 x5 x4 l
    s cd cs) (nd_C__case_2 x3 x6 x5 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_2 x3
    x6 x5 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_2 x3 x6
    x5 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_2" [show x3, show x6, show x5, show x4, show x7]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_2" (showCons x7))

d_C__case_1 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_QualMode
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_1 x6 x3 x5 x4 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Text.Curry_Pretty.d_C_text x4 cd cs
  Curry_Prelude.C_False -> d_C__case_0 x4 x3 (Curry_Prelude.d_C_otherwise cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x6 x3 x5 x4 l
    cd cs) (d_C__case_1 x6 x3 x5 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x6 x3
    x5 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x6 x3 x5
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_1" [show x6, show x3, show x5, show x4, show x7]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_1" (showCons x7))

nd_C__case_1 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_QualMode
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_1 x6 x3 x5 x4 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Text.Curry_Pretty.nd_C_text x4 s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_0 x4 x3 (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_1 x6 x3 x5 x4 l
    s cd cs) (nd_C__case_1 x6 x3 x5 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_1 x6
    x3 x5 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_1 x6 x3
    x5 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_1" [show x6, show x3, show x5, show x4, show x7]
    info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_1" (showCons x7))

d_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
d_C__case_0 x4 x3 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar Text.Curry_Pretty.d_C_text
    (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '.'#) x4) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x4 x3 l cd cs)
    (d_C__case_0 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x4 x3
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x4 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_0" [show x4, show x3, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_0" (showCons x5))

nd_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Text.Curry_PrettyImpl.C_Doc
nd_C__case_0 x4 x3 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    Text.Curry_Pretty.nd_C_text) (Curry_Prelude.d_OP_plus_plus x3
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '.'#) x4) cd cs) s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_0 x4 x3 l s cd
    cs) (nd_C__case_0 x4 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_0 x4
    x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_0 x4 x3 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Pretty._case_0" [show x4, show x3, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Pretty._case_0" (showCons x5))

