{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module FlatCurry.Curry_Show
  ( d_C_showFlatProg
  , d_C_showFlatType
  , d_C_showFlatFunc
  , d_C_showCurryType
  , nd_C_showCurryType
  , d_C_isClassContext
  , d_C_showCurryExpr
  , nd_C_showCurryExpr
  , d_C_showCurryVar
  , nd_C_showCurryVar
  , d_C_showCurryId )
  where

import Basics
import qualified Data.Curry_List
import qualified FlatCurry.Curry_Types
import qualified Curry_Prelude


d_C_showFlatProg :: FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showFlatProg x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Prog x2 x3 x4 x5 x6 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " (Prog ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash
    cd cs) x2 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C__case_74 x3
    (Curry_Prelude.d_C_null x3 cd cs) cd cs) (Curry_Prelude.d_OP_plus_plus
    (d_C__case_73 x4 (Curry_Prelude.d_C_null x4 cd cs) cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\n  [")
    (Curry_Prelude.d_OP_plus_plus (d_C_showFlatListElems d_C_showFlatFunc x5 cd
    cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\n  ]")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\n ")
    (Curry_Prelude.d_OP_plus_plus (d_C_showFlatList d_C_showFlatOp x6 cd cs)
    (Curry_Prelude.toCurryString "\n )\n") cd cs) cd cs) cd cs) cd cs) cd cs) cd
    cs) cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i (d_C_showFlatProg l
    cd cs) (d_C_showFlatProg r cd cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C_showFlatProg z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c ((\x ->
    d_C_showFlatProg e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "FlatCurry.Show.showFlatProg" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showFlatProg" (showCons x1))

d_C_showFlatVisibility :: FlatCurry.Curry_Types.C_Visibility -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showFlatVisibility x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Public -> Curry_Prelude.toCurryString " Public "
  FlatCurry.Curry_Types.C_Private -> Curry_Prelude.toCurryString " Private "
  FlatCurry.Curry_Types.Choice_C_Visibility d i l r -> narrow d i
    (d_C_showFlatVisibility l cd cs) (d_C_showFlatVisibility r cd cs)
  FlatCurry.Curry_Types.Choices_C_Visibility d i xs -> narrows cs d i (\z ->
    d_C_showFlatVisibility z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Visibility d c e -> guardCons d c ((\x ->
    d_C_showFlatVisibility e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Visibility d info -> failCons d (traceFail
    "FlatCurry.Show.showFlatVisibility" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showFlatVisibility" (showCons x1))

d_C_showFlatFixity :: FlatCurry.Curry_Types.C_Fixity -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showFlatFixity x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_InfixOp -> Curry_Prelude.toCurryString " InfixOp "
  FlatCurry.Curry_Types.C_InfixlOp -> Curry_Prelude.toCurryString " InfixlOp "
  FlatCurry.Curry_Types.C_InfixrOp -> Curry_Prelude.toCurryString " InfixrOp "
  FlatCurry.Curry_Types.Choice_C_Fixity d i l r -> narrow d i
    (d_C_showFlatFixity l cd cs) (d_C_showFlatFixity r cd cs)
  FlatCurry.Curry_Types.Choices_C_Fixity d i xs -> narrows cs d i (\z ->
    d_C_showFlatFixity z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Fixity d c e -> guardCons d c ((\x ->
    d_C_showFlatFixity e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Fixity d info -> failCons d (traceFail
    "FlatCurry.Show.showFlatFixity" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showFlatFixity" (showCons x1))

d_C_showFlatOp :: FlatCurry.Curry_Types.C_OpDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showFlatOp x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Op x2 x3 x4 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(Op ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    cd cs) x2 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatFixity x3 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x4 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs) cd cs) cd
    cs
  FlatCurry.Curry_Types.Choice_C_OpDecl d i l r -> narrow d i (d_C_showFlatOp l
    cd cs) (d_C_showFlatOp r cd cs)
  FlatCurry.Curry_Types.Choices_C_OpDecl d i xs -> narrows cs d i (\z ->
    d_C_showFlatOp z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_OpDecl d c e -> guardCons d c ((\x ->
    d_C_showFlatOp e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_OpDecl d info -> failCons d (traceFail
    "FlatCurry.Show.showFlatOp" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showFlatOp" (showCons x1))

d_C_showFlatType :: FlatCurry.Curry_Types.C_TypeDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showFlatType x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Type x2 x3 x4 x5 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\n  (Type ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    cd cs) x2 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatVisibility x3 cd
    cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatList
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    FlatCurry.Curry_Types.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_Types_dot_Kind_hash
    cd cs) x4 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatList
    d_C_showFlatCons x5 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs)
    cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_TypeSyn x6 x7 x8 x9 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\n  (TypeSyn ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    cd cs) x6 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatVisibility x7 cd
    cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatList
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    FlatCurry.Curry_Types.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_Types_dot_Kind_hash
    cd cs) x8 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatTypeExpr x9 cd
    cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs) cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_TypeNew x10 x11 x12 x13 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\n  (TypeNew ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    cd cs) x10 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatVisibility x11
    cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatList
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    FlatCurry.Curry_Types.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_Types_dot_Kind_hash
    cd cs) x12 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatNewCons x13 cd
    cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs) cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_TypeDecl d i l r -> narrow d i
    (d_C_showFlatType l cd cs) (d_C_showFlatType r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeDecl d i xs -> narrows cs d i (\z ->
    d_C_showFlatType z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeDecl d c e -> guardCons d c ((\x ->
    d_C_showFlatType e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeDecl d info -> failCons d (traceFail
    "FlatCurry.Show.showFlatType" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showFlatType" (showCons x1))

d_C_showFlatCons :: FlatCurry.Curry_Types.C_ConsDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showFlatCons x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Cons x2 x3 x4 x5 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(Cons ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    cd cs) x2 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " ") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x3 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatVisibility x4 cd
    cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatList d_C_showFlatTypeExpr x5
    cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs) cd cs) cd cs) cd cs)
    cd cs
  FlatCurry.Curry_Types.Choice_C_ConsDecl d i l r -> narrow d i
    (d_C_showFlatCons l cd cs) (d_C_showFlatCons r cd cs)
  FlatCurry.Curry_Types.Choices_C_ConsDecl d i xs -> narrows cs d i (\z ->
    d_C_showFlatCons z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_ConsDecl d c e -> guardCons d c ((\x ->
    d_C_showFlatCons e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_ConsDecl d info -> failCons d (traceFail
    "FlatCurry.Show.showFlatCons" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showFlatCons" (showCons x1))

d_C_showFlatNewCons :: FlatCurry.Curry_Types.C_NewConsDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showFlatNewCons x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_NewCons x2 x3 x4 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(NewCons ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    cd cs) x2 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatVisibility x3 cd
    cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatTypeExpr x4 cd cs)
    (Curry_Prelude.toCurryString ")") cd cs) cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_NewConsDecl d i l r -> narrow d i
    (d_C_showFlatNewCons l cd cs) (d_C_showFlatNewCons r cd cs)
  FlatCurry.Curry_Types.Choices_C_NewConsDecl d i xs -> narrows cs d i (\z ->
    d_C_showFlatNewCons z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_NewConsDecl d c e -> guardCons d c ((\x ->
    d_C_showFlatNewCons e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_NewConsDecl d info -> failCons d (traceFail
    "FlatCurry.Show.showFlatNewCons" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showFlatNewCons" (showCons x1))

d_C_showFlatFunc :: FlatCurry.Curry_Types.C_FuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showFlatFunc x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Func x2 x3 x4 x5 x6 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\n  (Func ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    cd cs) x2 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " ") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x3 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " ") (Curry_Prelude.d_OP_plus_plus (d_C_showFlatVisibility x4 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\n        ")
    (Curry_Prelude.d_OP_plus_plus (d_C_showFlatTypeExpr x5 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\n       ")
    (Curry_Prelude.d_OP_plus_plus (d_C_showFlatRule x6 cd cs)
    (Curry_Prelude.toCurryString ")") cd cs) cd cs) cd cs) cd cs) cd cs) cd cs)
    cd cs) cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_FuncDecl d i l r -> narrow d i
    (d_C_showFlatFunc l cd cs) (d_C_showFlatFunc r cd cs)
  FlatCurry.Curry_Types.Choices_C_FuncDecl d i xs -> narrows cs d i (\z ->
    d_C_showFlatFunc z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_FuncDecl d c e -> guardCons d c ((\x ->
    d_C_showFlatFunc e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_FuncDecl d info -> failCons d (traceFail
    "FlatCurry.Show.showFlatFunc" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showFlatFunc" (showCons x1))

d_C_showFlatRule :: FlatCurry.Curry_Types.C_Rule -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showFlatRule x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Rule x2 x3 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " (Rule ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showFlatList
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatExpr x3 cd cs)
    (Curry_Prelude.toCurryString ")") cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_External x4 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " (External ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash
    cd cs) x4 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Rule d i l r -> narrow d i (d_C_showFlatRule l
    cd cs) (d_C_showFlatRule r cd cs)
  FlatCurry.Curry_Types.Choices_C_Rule d i xs -> narrows cs d i (\z ->
    d_C_showFlatRule z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Rule d c e -> guardCons d c ((\x ->
    d_C_showFlatRule e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Rule d info -> failCons d (traceFail
    "FlatCurry.Show.showFlatRule" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showFlatRule" (showCons x1))

d_C_showFlatTypeExpr :: FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showFlatTypeExpr x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_FuncType x2 x3 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(FuncType ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showFlatTypeExpr x2 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showFlatTypeExpr x3 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd
    cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_TCons x4 x5 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(TCons ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    cd cs) x4 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatList
    d_C_showFlatTypeExpr x5 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd
    cs) cd cs
  FlatCurry.Curry_Types.C_TVar x6 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(TVar ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x6 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs
  FlatCurry.Curry_Types.C_ForallType x7 x8 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(ForallType ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showFlatList
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    FlatCurry.Curry_Types.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_Types_dot_Kind_hash
    cd cs) x7 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatTypeExpr x8 cd
    cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i
    (d_C_showFlatTypeExpr l cd cs) (d_C_showFlatTypeExpr r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    d_C_showFlatTypeExpr z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c ((\x ->
    d_C_showFlatTypeExpr e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Show.showFlatTypeExpr" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showFlatTypeExpr" (showCons x1))

d_C_showFlatCombType :: FlatCurry.Curry_Types.C_CombType -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showFlatCombType x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_FuncCall -> Curry_Prelude.toCurryString "FuncCall"
  FlatCurry.Curry_Types.C_ConsCall -> Curry_Prelude.toCurryString "ConsCall"
  FlatCurry.Curry_Types.C_FuncPartCall x2 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(FuncPartCall ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs
  FlatCurry.Curry_Types.C_ConsPartCall x3 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(ConsPartCall ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x3 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_CombType d i l r -> narrow d i
    (d_C_showFlatCombType l cd cs) (d_C_showFlatCombType r cd cs)
  FlatCurry.Curry_Types.Choices_C_CombType d i xs -> narrows cs d i (\z ->
    d_C_showFlatCombType z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_CombType d c e -> guardCons d c ((\x ->
    d_C_showFlatCombType e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_CombType d info -> failCons d (traceFail
    "FlatCurry.Show.showFlatCombType" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showFlatCombType" (showCons x1))

d_C_showFlatExpr :: FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showFlatExpr x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Var x2 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(Var ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs
  FlatCurry.Curry_Types.C_Lit x3 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(Lit ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showFlatLit x3 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs
  FlatCurry.Curry_Types.C_Comb x4 x5 x6 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(Comb ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showFlatCombType x4 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    cd cs) x5 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatList
    d_C_showFlatExpr x6 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs)
    cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_Let x7 x8 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(Let ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showFlatList (d_OP_showFlatExpr_dot_showFlatBinding_dot_54
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)
    x7 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatExpr x8 cd cs)
    (Curry_Prelude.toCurryString ")") cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_Free x9 x10 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(Free ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showFlatList
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x9 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatExpr x10 cd cs)
    (Curry_Prelude.toCurryString ")") cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_Or x11 x12 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(Or ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showFlatExpr x11 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showFlatExpr x12 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs)
    cd cs) cd cs
  FlatCurry.Curry_Types.C_Case x13 x14 x15 -> d_C__case_72 x15 x14 x13 cd cs
  FlatCurry.Curry_Types.C_Typed x16 x17 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(Typed ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showFlatExpr x16 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char
    ' '#) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatTypeExpr x17 cd cs)
    (Curry_Prelude.toCurryString ")") cd cs)) cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (d_C_showFlatExpr l
    cd cs) (d_C_showFlatExpr r cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    d_C_showFlatExpr z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x ->
    d_C_showFlatExpr e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "FlatCurry.Show.showFlatExpr" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showFlatExpr" (showCons x1))

d_OP_showFlatExpr_dot_showFlatBinding_dot_54 :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.OP_Tuple2 t0
  FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_showFlatExpr_dot_showFlatBinding_dot_54 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_show x1 cd cs) x3 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString ",")
    (Curry_Prelude.d_OP_plus_plus (d_C_showFlatExpr x4 cd cs)
    (Curry_Prelude.toCurryString ")") cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_showFlatExpr_dot_showFlatBinding_dot_54 x1 l cd cs)
    (d_OP_showFlatExpr_dot_showFlatBinding_dot_54 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_showFlatExpr_dot_showFlatBinding_dot_54 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_showFlatExpr_dot_showFlatBinding_dot_54 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Show.showFlatExpr.showFlatBinding.54" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showFlatExpr.showFlatBinding.54"
    (showCons x2))

nd_OP_showFlatExpr_dot_showFlatBinding_dot_54 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_Tuple2 t0 FlatCurry.Curry_Types.C_Expr -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_OP_showFlatExpr_dot_showFlatBinding_dot_54 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s2 = s
    in s2 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "(")
    (Curry_Prelude.d_OP_plus_plus (let s1 = leftSupply s2
                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x1
    s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString ",") (Curry_Prelude.d_OP_plus_plus
    (d_C_showFlatExpr x4 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs)
    cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_showFlatExpr_dot_showFlatBinding_dot_54 x1 l s cd cs)
    (nd_OP_showFlatExpr_dot_showFlatBinding_dot_54 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_showFlatExpr_dot_showFlatBinding_dot_54 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_showFlatExpr_dot_showFlatBinding_dot_54 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Show.showFlatExpr.showFlatBinding.54" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showFlatExpr.showFlatBinding.54"
    (showCons x2))

d_C_showFlatLit :: FlatCurry.Curry_Types.C_Literal -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showFlatLit x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Intc x2 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(Intc ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs
  FlatCurry.Curry_Types.C_Floatc x3 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(Floatc ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Float_hash
    cd cs) x3 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs
  FlatCurry.Curry_Types.C_Charc x4 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(Charc ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash
    cd cs) x4 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Literal d i l r -> narrow d i (d_C_showFlatLit
    l cd cs) (d_C_showFlatLit r cd cs)
  FlatCurry.Curry_Types.Choices_C_Literal d i xs -> narrows cs d i (\z ->
    d_C_showFlatLit z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Literal d c e -> guardCons d c ((\x ->
    d_C_showFlatLit e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Literal d info -> failCons d (traceFail
    "FlatCurry.Show.showFlatLit" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showFlatLit" (showCons x1))

d_C_showFlatBranch :: FlatCurry.Curry_Types.C_BranchExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showFlatBranch x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Branch x2 x3 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(Branch ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showFlatPattern x2 cd cs) (Curry_Prelude.d_OP_plus_plus
    (d_C_showFlatExpr x3 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs)
    cd cs
  FlatCurry.Curry_Types.Choice_C_BranchExpr d i l r -> narrow d i
    (d_C_showFlatBranch l cd cs) (d_C_showFlatBranch r cd cs)
  FlatCurry.Curry_Types.Choices_C_BranchExpr d i xs -> narrows cs d i (\z ->
    d_C_showFlatBranch z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_BranchExpr d c e -> guardCons d c ((\x ->
    d_C_showFlatBranch e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_BranchExpr d info -> failCons d (traceFail
    "FlatCurry.Show.showFlatBranch" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showFlatBranch" (showCons x1))

d_C_showFlatPattern :: FlatCurry.Curry_Types.C_Pattern -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showFlatPattern x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Pattern x2 x3 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(Pattern ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash)
    cd cs) x2 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatList
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x3 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_LPattern x4 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(LPattern ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showFlatLit x4 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Pattern d i l r -> narrow d i
    (d_C_showFlatPattern l cd cs) (d_C_showFlatPattern r cd cs)
  FlatCurry.Curry_Types.Choices_C_Pattern d i xs -> narrows cs d i (\z ->
    d_C_showFlatPattern z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Pattern d c e -> guardCons d c ((\x ->
    d_C_showFlatPattern e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Pattern d info -> failCons d (traceFail
    "FlatCurry.Show.showFlatPattern" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showFlatPattern" (showCons x1))

d_C_showFlatList :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_showFlatList x1 x2 cd cs = Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString " [") (Curry_Prelude.d_OP_plus_plus
  (d_C_showFlatListElems x1 x2 cd cs) (Curry_Prelude.toCurryString "] ") cd cs)
  cd cs

nd_C_showFlatList :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C_showFlatList x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " [")
  (Curry_Prelude.d_OP_plus_plus (nd_C_showFlatListElems x1 x2 s0 cd cs)
  (Curry_Prelude.toCurryString "] ") cd cs) cd cs

d_C_showFlatListElems :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_showFlatListElems x1 x2 cd cs = Data.Curry_List.d_C_intercalate
  (Curry_Prelude.toCurryString ",") (Curry_Prelude.d_C_map x1 x2 cd cs) cd cs

nd_C_showFlatListElems :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C_showFlatListElems x1 x2 s cd cs = let s0 = s
  in s0 `seq` Data.Curry_List.d_C_intercalate (Curry_Prelude.toCurryString ",")
  (Curry_Prelude.nd_C_map x1 x2 s0 cd cs) cd cs

d_C_showCurryType :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showCurryType x1 x2 cd cs = d_OP_showCurryType_dot_showTypeWithClass_dot_84
  x2 x1 Curry_Prelude.OP_List

nd_C_showCurryType :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Func FlatCurry.Curry_Types.C_TypeExpr
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C_showCurryType x1 x2 s cd cs = wrapNX id
  (nd_OP_showCurryType_dot_showTypeWithClass_dot_84 x2 x1 Curry_Prelude.OP_List)

d_OP_showCurryType_dot_showClassedType_dot_84 :: Curry_Prelude.C_Bool
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr))
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showCurryType_dot_showClassedType_dot_84 x1 x2 x3 x4 cd cs = d_C__case_71
  x3 x4 x2 x1 (Curry_Prelude.d_C_null x3 cd cs) cd cs

nd_OP_showCurryType_dot_showClassedType_dot_84 :: Curry_Prelude.C_Bool -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr)) -> FlatCurry.Curry_Types.C_TypeExpr
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_OP_showCurryType_dot_showClassedType_dot_84 x1 x2 x3 x4 s cd cs = let s0 = s
  in s0 `seq` nd_C__case_71 x3 x4 x2 x1 (Curry_Prelude.d_C_null x3 cd cs) s0 cd
  cs

d_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3 :: (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3 x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.d_OP_dollar
    Curry_Prelude.d_C_unwords (Curry_Prelude.OP_Cons x3 (Curry_Prelude.d_C_map
    (d_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4
    x1) x4 cd cs)) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3 x1 l
    cd cs)
    (d_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3 x1 r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3 x1 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Show.showCurryType.showClassedType.84._#lambda3" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Show.showCurryType.showClassedType.84._#lambda3" (showCons x2))

nd_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3 :: Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3 x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Curry_Prelude.d_C_unwords) (Curry_Prelude.OP_Cons x3 (Curry_Prelude.nd_C_map
    (wrapNX id
    (nd_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4
    x1)) x4 s0 cd cs)) s1 cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3 x1 l
    s cd cs)
    (nd_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3 x1 r
    s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3 x1 z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3 x1 e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Show.showCurryType.showClassedType.84._#lambda3" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Show.showCurryType.showClassedType.84._#lambda3" (showCons x2))

d_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 :: (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 x1 x2 cd cs =
  d_C_showCurryType_ x1 Curry_Prelude.C_True x2 cd cs

nd_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 :: Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3_dot_uscore_hash_lambda4 x1 x2 s cd cs =
  let s0 = s in s0 `seq` nd_C_showCurryType_ x1 Curry_Prelude.C_True x2 s0 cd cs

d_OP_showCurryType_dot_showTypeWithClass_dot_84 :: Curry_Prelude.C_Bool
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr))
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showCurryType_dot_showTypeWithClass_dot_84 x1 x2 x3 x4 cd cs =
  let x5 = d_OP_showCurryType_dot_showClassedType_dot_84 x1 x2 x3 x4 cd cs
  in d_C__case_69 x5 x2 x3 x1 x4 cd cs

nd_OP_showCurryType_dot_showTypeWithClass_dot_84 :: Curry_Prelude.C_Bool -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr)) -> FlatCurry.Curry_Types.C_TypeExpr
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_OP_showCurryType_dot_showTypeWithClass_dot_84 x1 x2 x3 x4 s cd cs =
  let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` (let x5 = nd_OP_showCurryType_dot_showClassedType_dot_84
                               x1 x2 x3 x4 s0 cd cs
  in nd_C__case_69 x5 x2 x3 x1 x4 s1 cd cs)))

d_OP_showCurryType_dot_showTypeWithClass_dot_84_dot_uscore_hash_lambda2 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr)) -> (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showCurryType_dot_showTypeWithClass_dot_84_dot_uscore_hash_lambda2 x1 x2 x3 x4 x5 cd cs =
  case x5 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> d_OP_showCurryType_dot_showTypeWithClass_dot_84
    x2 x4 (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 x6 x7) Curry_Prelude.OP_List) cd cs) x1 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_showCurryType_dot_showTypeWithClass_dot_84_dot_uscore_hash_lambda2 x1
    x2 x3 x4 l cd cs)
    (d_OP_showCurryType_dot_showTypeWithClass_dot_84_dot_uscore_hash_lambda2 x1
    x2 x3 x4 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_showCurryType_dot_showTypeWithClass_dot_84_dot_uscore_hash_lambda2 x1
    x2 x3 x4 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_showCurryType_dot_showTypeWithClass_dot_84_dot_uscore_hash_lambda2 x1
    x2 x3 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Show.showCurryType.showTypeWithClass.84._#lambda2" [show x1, show
    x2, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail
    "FlatCurry.Show.showCurryType.showTypeWithClass.84._#lambda2" (showCons x5))

nd_OP_showCurryType_dot_showTypeWithClass_dot_84_dot_uscore_hash_lambda2 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr)) -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_OP_showCurryType_dot_showTypeWithClass_dot_84_dot_uscore_hash_lambda2 x1 x2 x3 x4 x5 s cd cs =
  case x5 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s0 = s
    in s0 `seq` nd_OP_showCurryType_dot_showTypeWithClass_dot_84 x2 x4
    (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 x6 x7) Curry_Prelude.OP_List) cd cs) x1 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_showCurryType_dot_showTypeWithClass_dot_84_dot_uscore_hash_lambda2 x1
    x2 x3 x4 l s cd cs)
    (nd_OP_showCurryType_dot_showTypeWithClass_dot_84_dot_uscore_hash_lambda2 x1
    x2 x3 x4 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_showCurryType_dot_showTypeWithClass_dot_84_dot_uscore_hash_lambda2 x1
    x2 x3 x4 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_showCurryType_dot_showTypeWithClass_dot_84_dot_uscore_hash_lambda2 x1
    x2 x3 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Show.showCurryType.showTypeWithClass.84._#lambda2" [show x1, show
    x2, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail
    "FlatCurry.Show.showCurryType.showTypeWithClass.84._#lambda2" (showCons x5))

d_C_isClassContext :: FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr))
d_C_isClassContext x1 cd cs = let x2 = Curry_Prelude.C_Nothing
  in d_C__case_68 x2 x1 cd cs

d_OP_isClassContext_dot_checkDictCons_dot_101 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0)
d_OP_isClassContext_dot_checkDictCons_dot_101 x1 x2 cd cs = d_C__case_61 x1 x2
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (6)) x1 cd cs)
  (Curry_Prelude.toCurryString "_Dict#") cd cs) cd cs

d_C_showCurryType_ :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> FlatCurry.Curry_Types.C_TypeExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showCurryType_ x1 x2 x3 cd cs = case x3 of
  FlatCurry.Curry_Types.C_TVar x4 -> d_C__case_59 x4 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x4 cd cs) (Curry_Prelude.C_Int (5)) cd cs) cd cs
  FlatCurry.Curry_Types.C_FuncType x5 x6 -> d_C_showBracketsIf x2
    (Curry_Prelude.d_OP_plus_plus (d_C_showCurryType_ x1 (d_C_isFuncType x5 cd
    cs) x5 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " -> ") (d_C_showCurryType_ x1 Curry_Prelude.C_False x6 cd cs) cd cs) cd cs)
    cd cs
  FlatCurry.Curry_Types.C_TCons x7 x8 -> d_C__case_58 x8 x7 x1 x2
    (Curry_Prelude.d_C_null x8 cd cs) cd cs
  FlatCurry.Curry_Types.C_ForallType x9 x10 -> d_C_showBracketsIf x2
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_unwords
    (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "forall")
    (Curry_Prelude.d_C_map (Curry_Prelude.d_OP_dot (d_C_showCurryType_ x1
    Curry_Prelude.C_False) (Curry_Prelude.d_OP_dot (acceptCs id
    FlatCurry.Curry_Types.C_TVar) Curry_Prelude.d_C_fst cd cs) cd cs) x9 cd cs))
    cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " . ")
    (d_C_showCurryType_ x1 Curry_Prelude.C_False x10 cd cs) cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i
    (d_C_showCurryType_ x1 x2 l cd cs) (d_C_showCurryType_ x1 x2 r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    d_C_showCurryType_ x1 x2 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c ((\x ->
    d_C_showCurryType_ x1 x2 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Show.showCurryType_" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showCurryType_" (showCons x3))

nd_C_showCurryType_ :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C_showCurryType_ x1 x2 x3 s cd cs = case x3 of
  FlatCurry.Curry_Types.C_TVar x4 -> let s2 = s
    in s2 `seq` d_C__case_59 x4 (let s1 = leftSupply s2
                                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs)) x4 s0 cd cs) (Curry_Prelude.C_Int (5)) s1 cd cs)) cd cs
  FlatCurry.Curry_Types.C_FuncType x5 x6 -> let s2 = s
    in s2 `seq` d_C_showBracketsIf x2 (let s0 = leftSupply s2
                                           s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_showCurryType_ x1
    (d_C_isFuncType x5 cd cs) x5 s0 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " -> ") (nd_C_showCurryType_ x1
    Curry_Prelude.C_False x6 s1 cd cs) cd cs) cd cs)) cd cs
  FlatCurry.Curry_Types.C_TCons x7 x8 -> let s0 = s
    in s0 `seq` nd_C__case_58 x8 x7 x1 x2 (Curry_Prelude.d_C_null x8 cd cs) s0
    cd cs
  FlatCurry.Curry_Types.C_ForallType x9 x10 -> let s6 = s
    in s6 `seq` d_C_showBracketsIf x2 (let s4 = leftSupply s6
                                           s5 = rightSupply s6
    in s4 `seq` (s5 `seq` Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_unwords (Curry_Prelude.OP_Cons
    (Curry_Prelude.toCurryString "forall") (let s3 = leftSupply s4
                                                s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_map (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (wrapNX id
    (nd_C_showCurryType_ x1 Curry_Prelude.C_False)) (Curry_Prelude.nd_OP_dot
    (wrapDX id (acceptCs id FlatCurry.Curry_Types.C_TVar)) (wrapDX id
    Curry_Prelude.d_C_fst) s0 cd cs) s1 cd cs)) x9 s3 cd cs))) cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " . ")
    (nd_C_showCurryType_ x1 Curry_Prelude.C_False x10 s5 cd cs) cd cs) cd cs))
    cd cs
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i
    (nd_C_showCurryType_ x1 x2 l s cd cs) (nd_C_showCurryType_ x1 x2 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    nd_C_showCurryType_ x1 x2 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c ((\x ->
    nd_C_showCurryType_ x1 x2 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Show.showCurryType_" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showCurryType_" (showCons x3))

d_OP_showCurryType_uscore_dot_uscore_hash_lambda7 :: (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showCurryType_uscore_dot_uscore_hash_lambda7 x1 x2 cd cs =
  Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (d_C_showCurryType_ x1
  Curry_Prelude.C_True x2 cd cs)

nd_OP_showCurryType_uscore_dot_uscore_hash_lambda7 :: Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_OP_showCurryType_uscore_dot_uscore_hash_lambda7 x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#)
  (nd_C_showCurryType_ x1 Curry_Prelude.C_True x2 s0 cd cs)

d_C_isFuncType :: FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isFuncType x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_TVar x2 -> Curry_Prelude.C_False
  FlatCurry.Curry_Types.C_FuncType x3 x4 -> Curry_Prelude.C_True
  FlatCurry.Curry_Types.C_TCons x5 x6 -> Curry_Prelude.C_False
  FlatCurry.Curry_Types.C_ForallType x7 x8 -> d_C_isFuncType x8 cd cs
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i (d_C_isFuncType
    l cd cs) (d_C_isFuncType r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    d_C_isFuncType z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c ((\x ->
    d_C_isFuncType e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Show.isFuncType" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show.isFuncType" (showCons x1))

d_C_showCurryExpr :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Int -> FlatCurry.Curry_Types.C_Expr
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showCurryExpr x1 x2 x3 x4 cd cs = case x4 of
  FlatCurry.Curry_Types.C_Var x5 -> d_C_showCurryVar
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    x5 cd cs
  FlatCurry.Curry_Types.C_Lit x6 -> d_C_showCurryLit x6 cd cs
  FlatCurry.Curry_Types.C_Comb x7 x8 x9 -> d_C__case_53 x8 x3 x1 x2 x7 x9 cd cs
  FlatCurry.Curry_Types.C_Let x16 x17 -> d_C_showBracketsIf x2
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\n")
    (Curry_Prelude.d_OP_plus_plus (d_C_sceBlanks x3 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "let ")
    (Curry_Prelude.d_OP_plus_plus (Data.Curry_List.d_C_intercalate
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\n    ")
    (d_C_sceBlanks x3 cd cs) cd cs) (Curry_Prelude.d_C_map
    (d_OP_showCurryExpr_dot_uscore_hash_lambda8 x3 x1) x16 cd cs) cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\n") (Curry_Prelude.d_OP_plus_plus
    (d_C_sceBlanks x3 cd cs) (Curry_Prelude.toCurryString " in ") cd cs) cd cs)
    (d_C_showCurryExpr x1 Curry_Prelude.C_False
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x3 (Curry_Prelude.C_Int (4)) cd cs) x17 cd cs) cd cs) cd cs) cd cs) cd cs)
    cd cs) cd cs
  FlatCurry.Curry_Types.C_Free x18 x19 -> d_C__case_41 x19 x3 x1 x2 x18 cd cs
  FlatCurry.Curry_Types.C_Or x22 x23 -> d_C_showBracketsIf x2
    (Curry_Prelude.d_OP_plus_plus (d_C_showCurryExpr x1 Curry_Prelude.C_True x3
    x22 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ? ")
    (d_C_showCurryExpr x1 Curry_Prelude.C_True x3 x23 cd cs) cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_Case x24 x25 x26 -> d_C_showBracketsIf x2
    (Curry_Prelude.d_OP_plus_plus (d_C__case_40 x24 cd cs)
    (Curry_Prelude.d_OP_plus_plus (d_C_showCurryExpr x1 Curry_Prelude.C_True x3
    x25 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " of\n ") (Curry_Prelude.d_OP_plus_plus (d_C_showCurryElems
    (d_C_showCurryCase x1
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x3 (Curry_Prelude.C_Int (2)) cd cs)) x26 cd cs) (d_C_sceBlanks x3 cd cs) cd
    cs) cd cs) cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_Typed x27 x28 -> d_C_showBracketsIf x2
    (Curry_Prelude.d_OP_plus_plus (d_C_showCurryExpr x1 Curry_Prelude.C_True x3
    x27 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " :: ") (Curry_Prelude.d_C_apply (d_C_showCurryType x1 Curry_Prelude.C_False
    cd cs) x28 cd cs) cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (d_C_showCurryExpr
    x1 x2 x3 l cd cs) (d_C_showCurryExpr x1 x2 x3 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    d_C_showCurryExpr x1 x2 x3 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x ->
    d_C_showCurryExpr x1 x2 x3 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "FlatCurry.Show.showCurryExpr" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showCurryExpr" (showCons x4))

nd_C_showCurryExpr :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Int -> FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C_showCurryExpr x1 x2 x3 x4 s cd cs = case x4 of
  FlatCurry.Curry_Types.C_Var x5 -> let s0 = s
    in s0 `seq` nd_C_showCurryVar (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)
    x5 s0 cd cs
  FlatCurry.Curry_Types.C_Lit x6 -> d_C_showCurryLit x6 cd cs
  FlatCurry.Curry_Types.C_Comb x7 x8 x9 -> let s0 = s
    in s0 `seq` nd_C__case_53 x8 x3 x1 x2 x7 x9 s0 cd cs
  FlatCurry.Curry_Types.C_Let x16 x17 -> let s2 = s
    in s2 `seq` d_C_showBracketsIf x2 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\n") (Curry_Prelude.d_OP_plus_plus
    (d_C_sceBlanks x3 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "let ") (let s0 = leftSupply s2
                                              s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus
    (Data.Curry_List.d_C_intercalate (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\n    ") (d_C_sceBlanks x3 cd cs) cd cs)
    (Curry_Prelude.nd_C_map (wrapNX id
    (nd_OP_showCurryExpr_dot_uscore_hash_lambda8 x3 x1)) x16 s0 cd cs) cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\n") (Curry_Prelude.d_OP_plus_plus
    (d_C_sceBlanks x3 cd cs) (Curry_Prelude.toCurryString " in ") cd cs) cd cs)
    (nd_C_showCurryExpr x1 Curry_Prelude.C_False
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x3 (Curry_Prelude.C_Int (4)) cd cs) x17 s1 cd cs) cd cs) cd cs)) cd cs) cd
    cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_Free x18 x19 -> let s0 = s
    in s0 `seq` nd_C__case_41 x19 x3 x1 x2 x18 s0 cd cs
  FlatCurry.Curry_Types.C_Or x22 x23 -> let s2 = s
    in s2 `seq` d_C_showBracketsIf x2 (let s0 = leftSupply s2
                                           s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_showCurryExpr x1
    Curry_Prelude.C_True x3 x22 s0 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " ? ") (nd_C_showCurryExpr x1
    Curry_Prelude.C_True x3 x23 s1 cd cs) cd cs) cd cs)) cd cs
  FlatCurry.Curry_Types.C_Case x24 x25 x26 -> let s2 = s
    in s2 `seq` d_C_showBracketsIf x2 (Curry_Prelude.d_OP_plus_plus
    (d_C__case_40 x24 cd cs) (let s0 = leftSupply s2
                                  s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_showCurryExpr x1
    Curry_Prelude.C_True x3 x25 s0 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " of\n ") (Curry_Prelude.d_OP_plus_plus
    (nd_C_showCurryElems (wrapNX id (nd_C_showCurryCase x1
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x3 (Curry_Prelude.C_Int (2)) cd cs))) x26 s1 cd cs) (d_C_sceBlanks x3 cd cs)
    cd cs) cd cs) cd cs)) cd cs) cd cs
  FlatCurry.Curry_Types.C_Typed x27 x28 -> let s4 = s
    in s4 `seq` d_C_showBracketsIf x2 (let s0 = leftSupply s4
                                           s3 = rightSupply s4
    in s0 `seq` (s3 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_showCurryExpr x1
    Curry_Prelude.C_True x3 x27 s0 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " :: ") (let s2 = leftSupply s3
                                              s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (nd_C_showCurryType x1
    Curry_Prelude.C_False s1 cd cs) x28 s2 cd cs)) cd cs) cd cs)) cd cs
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (nd_C_showCurryExpr
    x1 x2 x3 l s cd cs) (nd_C_showCurryExpr x1 x2 x3 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    nd_C_showCurryExpr x1 x2 x3 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x ->
    nd_C_showCurryExpr x1 x2 x3 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "FlatCurry.Show.showCurryExpr" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showCurryExpr" (showCons x4))

d_OP_showCurryExpr_dot_uscore_hash_lambda8 :: Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showCurryExpr_dot_uscore_hash_lambda8 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.d_OP_plus_plus
    (d_C_showCurryVar
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    x4 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " = ")
    (d_C_showCurryExpr x2 Curry_Prelude.C_False
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 (Curry_Prelude.C_Int (4)) cd cs) x5 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_showCurryExpr_dot_uscore_hash_lambda8 x1 x2 l cd cs)
    (d_OP_showCurryExpr_dot_uscore_hash_lambda8 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_showCurryExpr_dot_uscore_hash_lambda8 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_showCurryExpr_dot_uscore_hash_lambda8 x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Show.showCurryExpr._#lambda8" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showCurryExpr._#lambda8" (showCons
    x3))

nd_OP_showCurryExpr_dot_uscore_hash_lambda8 :: Curry_Prelude.C_Int -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_OP_showCurryExpr_dot_uscore_hash_lambda8 x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_showCurryVar
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)
    x4 s0 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " = ") (nd_C_showCurryExpr x2 Curry_Prelude.C_False
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 (Curry_Prelude.C_Int (4)) cd cs) x5 s1 cd cs) cd cs) cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_showCurryExpr_dot_uscore_hash_lambda8 x1 x2 l s cd cs)
    (nd_OP_showCurryExpr_dot_uscore_hash_lambda8 x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_showCurryExpr_dot_uscore_hash_lambda8 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_showCurryExpr_dot_uscore_hash_lambda8 x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Show.showCurryExpr._#lambda8" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showCurryExpr._#lambda8" (showCons
    x3))

d_C_showCurryVar :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showCurryVar x1 x2 cd cs = Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "v") (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_show x1 cd cs) x2 cd cs) cd cs

nd_C_showCurryVar :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C_showCurryVar x1 x2 s cd cs = let s2 = s
  in s2 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "v")
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x1 s0
  cd cs) x2 s1 cd cs)) cd cs

d_C_showCurryId :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showCurryId x1 cd cs = d_C__case_39 x1 (Curry_Prelude.d_C_isAlpha
  (Curry_Prelude.d_C_head x1 cd cs) cd cs) cd cs

d_C_showCurryLit :: FlatCurry.Curry_Types.C_Literal -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showCurryLit x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Intc x2 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs
  FlatCurry.Curry_Types.C_Floatc x3 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Float_hash
    cd cs) x3 cd cs
  FlatCurry.Curry_Types.C_Charc x4 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash
    cd cs) x4 cd cs
  FlatCurry.Curry_Types.Choice_C_Literal d i l r -> narrow d i (d_C_showCurryLit
    l cd cs) (d_C_showCurryLit r cd cs)
  FlatCurry.Curry_Types.Choices_C_Literal d i xs -> narrows cs d i (\z ->
    d_C_showCurryLit z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Literal d c e -> guardCons d c ((\x ->
    d_C_showCurryLit e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Literal d info -> failCons d (traceFail
    "FlatCurry.Show.showCurryLit" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showCurryLit" (showCons x1))

d_C_showCurryCase :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Int -> FlatCurry.Curry_Types.C_BranchExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showCurryCase x1 x2 x3 cd cs = case x3 of
  FlatCurry.Curry_Types.C_Branch x4 x5 -> d_C__case_36 x5 x2 x1 x4 cd cs
  FlatCurry.Curry_Types.Choice_C_BranchExpr d i l r -> narrow d i
    (d_C_showCurryCase x1 x2 l cd cs) (d_C_showCurryCase x1 x2 r cd cs)
  FlatCurry.Curry_Types.Choices_C_BranchExpr d i xs -> narrows cs d i (\z ->
    d_C_showCurryCase x1 x2 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_BranchExpr d c e -> guardCons d c ((\x ->
    d_C_showCurryCase x1 x2 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_BranchExpr d info -> failCons d (traceFail
    "FlatCurry.Show.showCurryCase" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showCurryCase" (showCons x3))

nd_C_showCurryCase :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_BranchExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C_showCurryCase x1 x2 x3 s cd cs = case x3 of
  FlatCurry.Curry_Types.C_Branch x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_36 x5 x2 x1 x4 s0 cd cs
  FlatCurry.Curry_Types.Choice_C_BranchExpr d i l r -> narrow d i
    (nd_C_showCurryCase x1 x2 l s cd cs) (nd_C_showCurryCase x1 x2 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_BranchExpr d i xs -> narrows cs d i (\z ->
    nd_C_showCurryCase x1 x2 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_BranchExpr d c e -> guardCons d c ((\x ->
    nd_C_showCurryCase x1 x2 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_BranchExpr d info -> failCons d (traceFail
    "FlatCurry.Show.showCurryCase" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showCurryCase" (showCons x3))

d_OP_showCurryCase_dot_showPattern_dot_189 :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showCurryCase_dot_showPattern_dot_189 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> x2
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_35 x2 x4 x1 x5 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_showCurryCase_dot_showPattern_dot_189 x1 x2 l cd cs)
    (d_OP_showCurryCase_dot_showPattern_dot_189 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_showCurryCase_dot_showPattern_dot_189 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_showCurryCase_dot_showPattern_dot_189 x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show.showCurryCase.showPattern.189" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show.showCurryCase.showPattern.189"
    (showCons x3))

nd_OP_showCurryCase_dot_showPattern_dot_189 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_OP_showCurryCase_dot_showPattern_dot_189 x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_List -> x2
  Curry_Prelude.OP_Cons x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_35 x2 x4 x1 x5 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (nd_OP_showCurryCase_dot_showPattern_dot_189 x1 x2 l s cd cs)
    (nd_OP_showCurryCase_dot_showPattern_dot_189 x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_OP_showCurryCase_dot_showPattern_dot_189 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    nd_OP_showCurryCase_dot_showPattern_dot_189 x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show.showCurryCase.showPattern.189" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show.showCurryCase.showPattern.189"
    (showCons x3))

d_C_showCurryFiniteList :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Int -> FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_showCurryFiniteList x1 x2 x3 cd cs = let x4 = Curry_Prelude.d_C_error
                                               (Curry_Prelude.toCurryString
                                               "Internal error in FlatCurry.Show.showCurryFiniteList")
                                               cd cs
  in d_C__case_30 x4 x2 x1 x3 cd cs

nd_C_showCurryFiniteList :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C_showCurryFiniteList x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` (let x4 = Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
                     "Internal error in FlatCurry.Show.showCurryFiniteList") cd
                     cs
  in nd_C__case_30 x4 x2 x1 x3 s0 cd cs)

d_C_showCurryStringConstant :: FlatCurry.Curry_Types.C_Expr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showCurryStringConstant x1 cd cs = let x2 = Curry_Prelude.d_C_error
                                             (Curry_Prelude.toCurryString
                                             "Internal error in FlatCurry.Show.showCurryStringConstant")
                                             cd cs
  in d_C__case_21 x2 x1 cd cs

d_OP_showCurryStringConstant_dot_showChar_dot_212 :: Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showCurryStringConstant_dot_showChar_dot_212 x1 cd cs =
  let x2 = Curry_Prelude.d_C_ord x1 cd cs
  in d_C__case_10 x1 x2
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x1 (Curry_Prelude.C_Char '"'#) cd cs) cd cs

d_C_showCurryElems :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_showCurryElems x1 x2 cd cs = Data.Curry_List.d_C_intercalate
  (Curry_Prelude.toCurryString " ") (Curry_Prelude.d_C_map x1 x2 cd cs) cd cs

nd_C_showCurryElems :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C_showCurryElems x1 x2 s cd cs = let s0 = s
  in s0 `seq` Data.Curry_List.d_C_intercalate (Curry_Prelude.toCurryString " ")
  (Curry_Prelude.nd_C_map x1 x2 s0 cd cs) cd cs

d_C_showBracketsIf :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_showBracketsIf x1 x2 cd cs = case x1 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#)
    (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.toCurryString ")") cd cs)
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C_showBracketsIf l x2 cd
    cs) (d_C_showBracketsIf r x2 cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_C_showBracketsIf z x2 cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C_showBracketsIf e
    x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show.showBracketsIf" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Show.showBracketsIf" (showCons x1))

d_C_sceBlanks :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_sceBlanks x1 cd cs = Curry_Prelude.d_C_take x1 (Curry_Prelude.d_C_repeat
  (Curry_Prelude.C_Char ' '#) cd cs) cd cs

d_C_isFiniteList :: FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isFiniteList x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Var x2 -> Curry_Prelude.C_False
  FlatCurry.Curry_Types.C_Lit x3 -> Curry_Prelude.C_False
  FlatCurry.Curry_Types.C_Comb x4 x5 x6 -> d_C__case_5 x6 x5
    (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x5 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString "[]")) cd cs) (Curry_Prelude.d_C_null x6 cd cs)
    cd cs) cd cs
  FlatCurry.Curry_Types.C_Let x7 x8 -> Curry_Prelude.C_False
  FlatCurry.Curry_Types.C_Free x9 x10 -> Curry_Prelude.C_False
  FlatCurry.Curry_Types.C_Or x11 x12 -> Curry_Prelude.C_False
  FlatCurry.Curry_Types.C_Case x13 x14 x15 -> Curry_Prelude.C_False
  FlatCurry.Curry_Types.C_Typed x16 x17 -> d_C_isFiniteList x16 cd cs
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (d_C_isFiniteList l
    cd cs) (d_C_isFiniteList r cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    d_C_isFiniteList z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x ->
    d_C_isFiniteList e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "FlatCurry.Show.isFiniteList" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show.isFiniteList" (showCons x1))

d_C_isStringConstant :: FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isStringConstant x1 cd cs = let x2 = Curry_Prelude.C_False
  in d_C__case_2 x2 x1 cd cs

d_C_isCharConstant :: FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isCharConstant x1 cd cs = let x2 = Curry_Prelude.C_False
  in d_C__case_1 x2 x1 cd cs

d_C__case_73 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeDecl
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_73 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "\n  []"
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\n  [") (Curry_Prelude.d_OP_plus_plus
    (d_C_showFlatListElems d_C_showFlatType x4 cd cs)
    (Curry_Prelude.toCurryString "\n ]") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_73 x4 l cd cs)
    (d_C__case_73 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_73 x4 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_73 x4 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_73" [show x4, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_73" (showCons x5))

d_C__case_74 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_74 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "\n  []"
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\n  [") (Curry_Prelude.d_OP_plus_plus
    (d_C_showFlatListElems
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Char_hash
    cd cs) x3 cd cs) (Curry_Prelude.toCurryString "]") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_74 x3 l cd cs)
    (d_C__case_74 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_74 x3 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_74 x3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_74" [show x3, show x4] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_74" (showCons x4))

d_C__case_72 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_BranchExpr
  -> FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_CaseType -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_72 x15 x14 x13 cd cs = case x13 of
  FlatCurry.Curry_Types.C_Rigid -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(Case Rigid ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showFlatExpr x14 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatList
    d_C_showFlatBranch x15 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd
    cs) cd cs
  FlatCurry.Curry_Types.C_Flex -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(Case Flex ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showFlatExpr x14 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showFlatList
    d_C_showFlatBranch x15 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd
    cs) cd cs
  FlatCurry.Curry_Types.Choice_C_CaseType d i l r -> narrow d i (d_C__case_72
    x15 x14 l cd cs) (d_C__case_72 x15 x14 r cd cs)
  FlatCurry.Curry_Types.Choices_C_CaseType d i xs -> narrows cs d i (\z ->
    d_C__case_72 x15 x14 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_CaseType d c e -> guardCons d c ((\x ->
    d_C__case_72 x15 x14 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_CaseType d info -> failCons d (traceFail
    "FlatCurry.Show._case_72" [show x15, show x14, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_72" (showCons x13))

d_C__case_71 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr)) -> FlatCurry.Curry_Types.C_TypeExpr
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_71 x3 x4 x2 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> d_C_showCurryType_ x2 x1 x4 cd cs
  Curry_Prelude.C_False -> d_C__case_70 x4 x2 x3 x1 (Curry_Prelude.d_C_otherwise
    cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_71 x3 x4 x2 x1 l
    cd cs) (d_C__case_71 x3 x4 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_71 x3
    x4 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_71 x3 x4
    x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_71" [show x3, show x4, show x2, show x1, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_71" (showCons x5))

nd_C__case_71 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr)) -> FlatCurry.Curry_Types.C_TypeExpr -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_71 x3 x4 x2 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_showCurryType_ x2 x1 x4 s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_70 x4 x2 x3 x1 (Curry_Prelude.d_C_otherwise cd cs) s0
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_71 x3 x4 x2 x1 l
    s cd cs) (nd_C__case_71 x3 x4 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_71 x3
    x4 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_71 x3 x4
    x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_71" [show x3, show x4, show x2, show x1, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_71" (showCons x5))

d_C__case_70 :: FlatCurry.Curry_Types.C_TypeExpr -> (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr)) -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_70 x4 x2 x3 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar (d_C_showBracketsIf x1)
    (Curry_Prelude.d_OP_plus_plus (d_C_showBracketsIf (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.d_C_length x3 cd cs) cd cs) (Curry_Prelude.C_Int (1))
    cd cs) (Data.Curry_List.d_C_intercalate (Curry_Prelude.toCurryString ", ")
    (Curry_Prelude.d_C_map
    (d_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3 x2)
    x3 cd cs) cd cs) cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " => ") (d_C_showCurryType_ x2
    Curry_Prelude.C_False x4 cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_70 x4 x2 x3 x1 l
    cd cs) (d_C__case_70 x4 x2 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_70 x4
    x2 x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_70 x4 x2
    x3 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_70" [show x4, show x2, show x3, show x1, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_70" (showCons x5))

nd_C__case_70 :: FlatCurry.Curry_Types.C_TypeExpr -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr)) -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_70 x4 x2 x3 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    (d_C_showBracketsIf x1)) (let s4 = leftSupply s6
                                  s5 = rightSupply s6
    in s4 `seq` (s5 `seq` Curry_Prelude.d_OP_plus_plus (let s2 = leftSupply s4
                                                            s3 = rightSupply s4
    in s2 `seq` (s3 `seq` d_C_showBracketsIf (let s1 = leftSupply s2
                                                  s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs)) (Curry_Prelude.d_C_length x3 cd cs) s0 cd cs) (Curry_Prelude.C_Int
    (1)) s1 cd cs)) (Data.Curry_List.d_C_intercalate
    (Curry_Prelude.toCurryString ", ") (Curry_Prelude.nd_C_map (wrapNX id
    (nd_OP_showCurryType_dot_showClassedType_dot_84_dot_uscore_hash_lambda3 x2))
    x3 s3 cd cs) cd cs) cd cs)) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " => ") (nd_C_showCurryType_ x2
    Curry_Prelude.C_False x4 s5 cd cs) cd cs) cd cs)) s7 cd cs))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_70 x4 x2 x3 x1 l
    s cd cs) (nd_C__case_70 x4 x2 x3 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_70 x4
    x2 x3 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_70 x4 x2
    x3 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_70" [show x4, show x2, show x3, show x1, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_70" (showCons x5))

d_C__case_69 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr))
  -> Curry_Prelude.C_Bool -> FlatCurry.Curry_Types.C_TypeExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_69 x5 x2 x3 x1 x4 cd cs = case x4 of
  FlatCurry.Curry_Types.C_ForallType x6 x7 -> d_OP_showCurryType_dot_showTypeWithClass_dot_84
    x1 x2 x3 x7 cd cs
  FlatCurry.Curry_Types.C_FuncType x8 x9 -> Curry_Prelude.d_C_maybe
    (d_OP_showCurryType_dot_showClassedType_dot_84 x1 x2 x3 x4 cd cs)
    (d_OP_showCurryType_dot_showTypeWithClass_dot_84_dot_uscore_hash_lambda2 x9
    x1 x3 x2) (d_C_isClassContext x8 cd cs) cd cs
  FlatCurry.Curry_Types.C_TVar x10 -> x5
  FlatCurry.Curry_Types.C_TCons x11 x12 -> x5
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i (d_C__case_69 x5
    x2 x3 x1 l cd cs) (d_C__case_69 x5 x2 x3 x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    d_C__case_69 x5 x2 x3 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c ((\x ->
    d_C__case_69 x5 x2 x3 x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Show._case_69" [show x5, show x2, show x3, show x1, show x4]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_69" (showCons x4))

nd_C__case_69 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr)) -> Curry_Prelude.C_Bool
  -> FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_69 x5 x2 x3 x1 x4 s cd cs = case x4 of
  FlatCurry.Curry_Types.C_ForallType x6 x7 -> let s0 = s
    in s0 `seq` nd_OP_showCurryType_dot_showTypeWithClass_dot_84 x1 x2 x3 x7 s0
    cd cs
  FlatCurry.Curry_Types.C_FuncType x8 x9 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_maybe
    (nd_OP_showCurryType_dot_showClassedType_dot_84 x1 x2 x3 x4 s0 cd cs)
    (wrapNX id
    (nd_OP_showCurryType_dot_showTypeWithClass_dot_84_dot_uscore_hash_lambda2 x9
    x1 x3 x2)) (d_C_isClassContext x8 cd cs) s1 cd cs))
  FlatCurry.Curry_Types.C_TVar x10 -> x5
  FlatCurry.Curry_Types.C_TCons x11 x12 -> x5
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i (nd_C__case_69
    x5 x2 x3 x1 l s cd cs) (nd_C__case_69 x5 x2 x3 x1 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    nd_C__case_69 x5 x2 x3 x1 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c ((\x ->
    nd_C__case_69 x5 x2 x3 x1 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Show._case_69" [show x5, show x2, show x3, show x1, show x4]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_69" (showCons x4))

d_C__case_68 :: Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr)) -> FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr))
d_C__case_68 x2 x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_TCons x3 x4 -> d_C__case_67 x4 x3 cd cs
  FlatCurry.Curry_Types.C_FuncType x7 x8 -> let x9 = Curry_Prelude.C_Nothing
    in d_C__case_66 x9 x8 x7 cd cs
  FlatCurry.Curry_Types.C_TVar x29 -> x2
  FlatCurry.Curry_Types.C_ForallType x30 x31 -> x2
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i (d_C__case_68 x2
    l cd cs) (d_C__case_68 x2 r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    d_C__case_68 x2 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c ((\x ->
    d_C__case_68 x2 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Show._case_68" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_68" (showCons x1))

d_C__case_66 :: Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr)) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr))
d_C__case_66 x9 x8 x7 cd cs = case x7 of
  FlatCurry.Curry_Types.C_TCons x10 x11 -> d_C__case_65 x8 x10 x11 cd cs
  FlatCurry.Curry_Types.C_TVar x24 -> x9
  FlatCurry.Curry_Types.C_FuncType x25 x26 -> x9
  FlatCurry.Curry_Types.C_ForallType x27 x28 -> x9
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i (d_C__case_66 x9
    x8 l cd cs) (d_C__case_66 x9 x8 r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    d_C__case_66 x9 x8 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c ((\x ->
    d_C__case_66 x9 x8 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Show._case_66" [show x9, show x8, show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_66" (showCons x7))

d_C__case_65 :: FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr))
d_C__case_65 x8 x10 x11 cd cs = case x11 of
  Curry_Prelude.OP_List -> let x12 = Curry_Prelude.C_Nothing
    in d_C__case_64 x12 x10 x8 cd cs
  Curry_Prelude.OP_Cons x22 x23 -> Curry_Prelude.C_Nothing
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_65 x8 x10 l cd
    cs) (d_C__case_65 x8 x10 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_65 x8
    x10 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_65 x8 x10
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_65" [show x8, show x10, show x11] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_65" (showCons x11))

d_C__case_64 :: Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr -> Cover
  -> ConstStore -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr))
d_C__case_64 x12 x10 x8 cd cs = case x8 of
  FlatCurry.Curry_Types.C_TCons x13 x14 -> d_C__case_63 x10 x14 x13 cd cs
  FlatCurry.Curry_Types.C_TVar x17 -> x12
  FlatCurry.Curry_Types.C_FuncType x18 x19 -> x12
  FlatCurry.Curry_Types.C_ForallType x20 x21 -> x12
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i (d_C__case_64
    x12 x10 l cd cs) (d_C__case_64 x12 x10 r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    d_C__case_64 x12 x10 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c ((\x ->
    d_C__case_64 x12 x10 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Show._case_64" [show x12, show x10, show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_64" (showCons x8))

d_C__case_63 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr))
d_C__case_63 x10 x14 x13 cd cs = case x13 of
  Curry_Prelude.OP_Tuple2 x15 x16 -> d_C__case_62 x10 x14 x16
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x10 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString "()")) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_63 x10 x14 l
    cd cs) (d_C__case_63 x10 x14 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_63
    x10 x14 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_63 x10
    x14 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Show._case_63" [show x10, show x14, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_63" (showCons x13))

d_C__case_62 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr))
d_C__case_62 x10 x14 x16 x17 cd cs = case x17 of
  Curry_Prelude.C_True -> d_OP_isClassContext_dot_checkDictCons_dot_101 x16 x14
    cd cs
  Curry_Prelude.C_False -> Curry_Prelude.C_Nothing
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_62 x10 x14 x16 l
    cd cs) (d_C__case_62 x10 x14 x16 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_62 x10
    x14 x16 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_62 x10 x14
    x16 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_62" [show x10, show x14, show x16, show x17] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_62" (showCons x17))

d_C__case_67 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr))
d_C__case_67 x4 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> d_OP_isClassContext_dot_checkDictCons_dot_101
    x6 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_67 x4 l cd cs)
    (d_C__case_67 x4 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_67
    x4 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_67 x4 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Show._case_67" [show x4, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_67" (showCons x3))

d_C__case_61 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0)
d_C__case_61 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.C_Just (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_C_drop (Curry_Prelude.C_Int (6)) x1 cd cs) x2)
  Curry_Prelude.C_False -> d_C__case_60 (Curry_Prelude.d_C_otherwise cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_61 x1 x2 l cd cs)
    (d_C__case_61 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_61 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_61 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_61" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_61" (showCons x3))

d_C__case_60 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0)
d_C__case_60 x1 cd cs = case x1 of
  Curry_Prelude.C_True -> Curry_Prelude.C_Nothing
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_60 l cd cs)
    (d_C__case_60 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_60 z cd
    cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_60 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_60" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_60" (showCons x1))

d_C__case_58 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_58 x8 x7 x1 x2 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply x1 x7 cd cs
  Curry_Prelude.C_False -> d_C__case_57 x8 x7 x1 x2 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x7 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString "[]")) cd cs)
    (FlatCurry.Curry_Types.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Types_dot_TypeExpr_hash
    (Curry_Prelude.d_C_head x8 cd cs) (FlatCurry.Curry_Types.C_TCons
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString "Char")) Curry_Prelude.OP_List) cd cs) cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_58 x8 x7 x1 x2 l
    cd cs) (d_C__case_58 x8 x7 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_58 x8
    x7 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_58 x8 x7
    x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_58" [show x8, show x7, show x1, show x2, show x9]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_58" (showCons x9))

nd_C__case_58 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_58 x8 x7 x1 x2 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x1 x7 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_57 x8 x7 x1 x2 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)))
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)))
    x7 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString "[]")) s0 cd cs)
    (FlatCurry.Curry_Types.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Types_dot_TypeExpr_hash
    (Curry_Prelude.d_C_head x8 cd cs) (FlatCurry.Curry_Types.C_TCons
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString "Char")) Curry_Prelude.OP_List) cd cs) cd cs)
    s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_58 x8 x7 x1 x2 l
    s cd cs) (nd_C__case_58 x8 x7 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_58 x8
    x7 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_58 x8 x7
    x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_58" [show x8, show x7, show x1, show x2, show x9]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_58" (showCons x9))

d_C__case_57 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_57 x8 x7 x1 x2 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "String"
  Curry_Prelude.C_False -> d_C__case_56 x7 x8 x1 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x7 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString "[]")) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_57 x8 x7 x1 x2 l
    cd cs) (d_C__case_57 x8 x7 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_57 x8
    x7 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_57 x8 x7
    x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_57" [show x8, show x7, show x1, show x2, show x9]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_57" (showCons x9))

nd_C__case_57 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_57 x8 x7 x1 x2 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "String"
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_56 x7 x8 x1 x2
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)))
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)))
    x7 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString "[]")) s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_57 x8 x7 x1 x2 l
    s cd cs) (nd_C__case_57 x8 x7 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_57 x8
    x7 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_57 x8 x7
    x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_57" [show x8, show x7, show x1, show x2, show x9]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_57" (showCons x9))

d_C__case_56 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_56 x7 x8 x1 x2 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "[") (Curry_Prelude.d_OP_plus_plus
    (d_C_showCurryType_ x1 Curry_Prelude.C_False (Curry_Prelude.d_C_head x8 cd
    cs) cd cs) (Curry_Prelude.toCurryString "]") cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_55 x7 x8 x1 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (2)) (Curry_Prelude.d_C_snd x7
    cd cs) cd cs) (Curry_Prelude.toCurryString "(,") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_56 x7 x8 x1 x2 l
    cd cs) (d_C__case_56 x7 x8 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_56 x7
    x8 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_56 x7 x8
    x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_56" [show x7, show x8, show x1, show x2, show x9]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_56" (showCons x9))

nd_C__case_56 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_56 x7 x8 x1 x2 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "[")
    (Curry_Prelude.d_OP_plus_plus (nd_C_showCurryType_ x1 Curry_Prelude.C_False
    (Curry_Prelude.d_C_head x8 cd cs) s0 cd cs) (Curry_Prelude.toCurryString
    "]") cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_55 x7 x8 x1 x2
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (2)) (Curry_Prelude.d_C_snd x7
    cd cs) cd cs) (Curry_Prelude.toCurryString "(,") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_56 x7 x8 x1 x2 l
    s cd cs) (nd_C__case_56 x7 x8 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_56 x7
    x8 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_56 x7 x8
    x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_56" [show x7, show x8, show x1, show x2, show x9]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_56" (showCons x9))

d_C__case_55 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_55 x7 x8 x1 x2 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(") (Curry_Prelude.d_OP_plus_plus
    (Data.Curry_List.d_C_intercalate (Curry_Prelude.toCurryString ",")
    (Curry_Prelude.d_C_map (d_C_showCurryType_ x1 Curry_Prelude.C_False) x8 cd
    cs) cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_54 x8 x1 x7 x2 (Curry_Prelude.d_C_otherwise
    cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_55 x7 x8 x1 x2 l
    cd cs) (d_C__case_55 x7 x8 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_55 x7
    x8 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_55 x7 x8
    x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_55" [show x7, show x8, show x1, show x2, show x9]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_55" (showCons x9))

nd_C__case_55 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_55 x7 x8 x1 x2 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "(")
    (Curry_Prelude.d_OP_plus_plus (Data.Curry_List.d_C_intercalate
    (Curry_Prelude.toCurryString ",") (Curry_Prelude.nd_C_map (wrapNX id
    (nd_C_showCurryType_ x1 Curry_Prelude.C_False)) x8 s0 cd cs) cd cs)
    (Curry_Prelude.toCurryString ")") cd cs) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_54 x8 x1 x7 x2 (Curry_Prelude.d_C_otherwise cd cs) s0
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_55 x7 x8 x1 x2 l
    s cd cs) (nd_C__case_55 x7 x8 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_55 x7
    x8 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_55 x7 x8
    x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_55" [show x7, show x8, show x1, show x2, show x9]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_55" (showCons x9))

d_C__case_54 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_54 x8 x1 x7 x2 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> d_C_showBracketsIf x2 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply x1 x7 cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_concatMap
    (d_OP_showCurryType_uscore_dot_uscore_hash_lambda7 x1) cd cs) x8 cd cs) cd
    cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_54 x8 x1 x7 x2 l
    cd cs) (d_C__case_54 x8 x1 x7 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_54 x8
    x1 x7 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_54 x8 x1
    x7 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_54" [show x8, show x1, show x7, show x2, show x9]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_54" (showCons x9))

nd_C__case_54 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_54 x8 x1 x7 x2 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s4 = s
    in s4 `seq` d_C_showBracketsIf x2 (let s0 = leftSupply s4
                                           s3 = rightSupply s4
    in s0 `seq` (s3 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_apply
    x1 x7 s0 cd cs) (let s2 = leftSupply s3
                         s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_concatMap
    (wrapNX id (nd_OP_showCurryType_uscore_dot_uscore_hash_lambda7 x1)) s1 cd
    cs) x8 s2 cd cs)) cd cs)) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_54 x8 x1 x7 x2 l
    s cd cs) (nd_C__case_54 x8 x1 x7 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_54 x8
    x1 x7 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_54 x8 x1
    x7 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_54" [show x8, show x1, show x7, show x2, show x9]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_54" (showCons x9))

d_C__case_59 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_59 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.d_C_chr
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (97)) x4 cd cs) cd cs) Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#)
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x4 cd cs)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_59 x4 l cd cs)
    (d_C__case_59 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_59 x4 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_59 x4 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_59" [show x4, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_59" (showCons x5))

d_C__case_40 :: FlatCurry.Curry_Types.C_CaseType -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_40 x24 cd cs = case x24 of
  FlatCurry.Curry_Types.C_Rigid -> Curry_Prelude.toCurryString "case "
  FlatCurry.Curry_Types.C_Flex -> Curry_Prelude.toCurryString "fcase "
  FlatCurry.Curry_Types.Choice_C_CaseType d i l r -> narrow d i (d_C__case_40 l
    cd cs) (d_C__case_40 r cd cs)
  FlatCurry.Curry_Types.Choices_C_CaseType d i xs -> narrows cs d i (\z ->
    d_C__case_40 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_CaseType d c e -> guardCons d c ((\x ->
    d_C__case_40 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_CaseType d info -> failCons d (traceFail
    "FlatCurry.Show._case_40" [show x24] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_40" (showCons x24))

d_C__case_41 :: FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_41 x19 x3 x1 x2 x18 cd cs = case x18 of
  Curry_Prelude.OP_List -> d_C_showCurryExpr x1 x2 x3 x19 cd cs
  Curry_Prelude.OP_Cons x20 x21 -> d_C_showBracketsIf x2
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "let ")
    (Curry_Prelude.d_OP_plus_plus (Data.Curry_List.d_C_intercalate
    (Curry_Prelude.toCurryString ",") (Curry_Prelude.d_C_map (d_C_showCurryVar
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)
    (Curry_Prelude.OP_Cons x20 x21) cd cs) cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " free in ") (d_C_showCurryExpr x1
    Curry_Prelude.C_False x3 x19 cd cs) cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_41 x19 x3 x1 x2
    l cd cs) (d_C__case_41 x19 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_41 x19
    x3 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_41 x19 x3
    x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_41" [show x19, show x3, show x1, show x2, show x18]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_41" (showCons x18))

nd_C__case_41 :: FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_41 x19 x3 x1 x2 x18 s cd cs = case x18 of
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` nd_C_showCurryExpr x1 x2 x3 x19 s0 cd cs
  Curry_Prelude.OP_Cons x20 x21 -> let s2 = s
    in s2 `seq` d_C_showBracketsIf x2 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "let ") (let s0 = leftSupply s2
                                              s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus
    (Data.Curry_List.d_C_intercalate (Curry_Prelude.toCurryString ",")
    (Curry_Prelude.nd_C_map (wrapNX id (nd_C_showCurryVar (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)))
    (Curry_Prelude.OP_Cons x20 x21) s0 cd cs) cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " free in ")
    (nd_C_showCurryExpr x1 Curry_Prelude.C_False x3 x19 s1 cd cs) cd cs) cd cs))
    cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_41 x19 x3 x1 x2
    l s cd cs) (nd_C__case_41 x19 x3 x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_41
    x19 x3 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_41 x19
    x3 x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_41" [show x19, show x3, show x1, show x2, show x18]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_41" (showCons x18))

d_C__case_53 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Int -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_53 x8 x3 x1 x2 x7 x9 cd cs = case x9 of
  Curry_Prelude.OP_List -> d_C_showCurryId (Curry_Prelude.d_C_apply x1 x8 cd cs)
    cd cs
  Curry_Prelude.OP_Cons x10 x11 -> d_C__case_52 x8 x10 x3 x1 x2 x7 x11 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_53 x8 x3 x1 x2
    x7 l cd cs) (d_C__case_53 x8 x3 x1 x2 x7 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_53 x8
    x3 x1 x2 x7 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_53 x8 x3
    x1 x2 x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_53" [show x8, show x3, show x1, show x2, show x7, show
    x9] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_53" (showCons x9))

nd_C__case_53 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Int -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_53 x8 x3 x1 x2 x7 x9 s cd cs = case x9 of
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` d_C_showCurryId (Curry_Prelude.nd_C_apply x1 x8 s0 cd cs) cd cs
  Curry_Prelude.OP_Cons x10 x11 -> let s0 = s
    in s0 `seq` nd_C__case_52 x8 x10 x3 x1 x2 x7 x11 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_53 x8 x3 x1 x2
    x7 l s cd cs) (nd_C__case_53 x8 x3 x1 x2 x7 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_53 x8
    x3 x1 x2 x7 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_53 x8 x3
    x1 x2 x7 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_53" [show x8, show x3, show x1, show x2, show x7, show
    x9] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_53" (showCons x9))

d_C__case_52 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_52 x8 x10 x3 x1 x2 x7 x11 cd cs = case x11 of
  Curry_Prelude.OP_List -> d_C_showBracketsIf x2 (Curry_Prelude.d_OP_plus_plus
    (d_C_showCurryId (Curry_Prelude.d_C_apply x1 x8 cd cs) cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ")
    (d_C_showCurryExpr x1 Curry_Prelude.C_True x3 x10 cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.OP_Cons x12 x13 -> d_C__case_51 x8 x12 x10 x3 x1 x2 x7 x13 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_52 x8 x10 x3 x1
    x2 x7 l cd cs) (d_C__case_52 x8 x10 x3 x1 x2 x7 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_52 x8
    x10 x3 x1 x2 x7 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_52 x8 x10
    x3 x1 x2 x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_52" [show x8, show x10, show x3, show x1, show x2
    , show x7, show x11] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_52" (showCons x11))

nd_C__case_52 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_52 x8 x10 x3 x1 x2 x7 x11 s cd cs = case x11 of
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` d_C_showBracketsIf x2 (let s0 = leftSupply s2
                                           s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus (d_C_showCurryId
    (Curry_Prelude.nd_C_apply x1 x8 s0 cd cs) cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ")
    (nd_C_showCurryExpr x1 Curry_Prelude.C_True x3 x10 s1 cd cs) cd cs) cd cs))
    cd cs
  Curry_Prelude.OP_Cons x12 x13 -> let s0 = s
    in s0 `seq` nd_C__case_51 x8 x12 x10 x3 x1 x2 x7 x13 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_52 x8 x10 x3 x1
    x2 x7 l s cd cs) (nd_C__case_52 x8 x10 x3 x1 x2 x7 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_52 x8
    x10 x3 x1 x2 x7 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_52 x8
    x10 x3 x1 x2 x7 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_52" [show x8, show x10, show x3, show x1, show x2
    , show x7, show x11] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_52" (showCons x11))

d_C__case_51 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.C_Int -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_51 x8 x12 x10 x3 x1 x2 x7 x13 cd cs = case x13 of
  Curry_Prelude.OP_List -> d_C__case_50 x8 x12 x10 x7 x3 x1 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x8 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString "apply")) cd cs) cd cs
  Curry_Prelude.OP_Cons x14 x15 -> d_C__case_44 x15 x8 x14 x12 x10 x3 x1 x2
    (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x8 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString "if_then_else")) cd cs) (Curry_Prelude.d_C_null
    x15 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_51 x8 x12 x10 x3
    x1 x2 x7 l cd cs) (d_C__case_51 x8 x12 x10 x3 x1 x2 x7 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_51 x8
    x12 x10 x3 x1 x2 x7 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_51 x8 x12
    x10 x3 x1 x2 x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_51" [show x8, show x12, show x10, show x3, show x1
    , show x2, show x7, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_51" (showCons x13))

nd_C__case_51 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.C_Int -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_51 x8 x12 x10 x3 x1 x2 x7 x13 s cd cs = case x13 of
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_50 x8 x12 x10 x7 x3 x1 x2
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)))
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)))
    x8 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString "apply")) s0 cd cs) s1 cd cs))
  Curry_Prelude.OP_Cons x14 x15 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_44 x15 x8 x14 x12 x10 x3 x1 x2
    (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)))
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)))
    x8 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString "if_then_else")) s0 cd cs)
    (Curry_Prelude.d_C_null x15 cd cs) cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_51 x8 x12 x10
    x3 x1 x2 x7 l s cd cs) (nd_C__case_51 x8 x12 x10 x3 x1 x2 x7 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_51 x8
    x12 x10 x3 x1 x2 x7 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_51 x8
    x12 x10 x3 x1 x2 x7 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_51" [show x8, show x12, show x10, show x3, show x1
    , show x2, show x7, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_51" (showCons x13))

d_C__case_44 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.C_Int -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_44 x15 x8 x14 x12 x10 x3 x1 x2 x16 cd cs = case x16 of
  Curry_Prelude.C_True -> d_C_showBracketsIf x2 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\n") (Curry_Prelude.d_OP_plus_plus
    (d_C_sceBlanks x3 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " if ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showCurryExpr x1 Curry_Prelude.C_False
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x3 (Curry_Prelude.C_Int (2)) cd cs) x10 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\n") (Curry_Prelude.d_OP_plus_plus
    (d_C_sceBlanks x3 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " then ") (Curry_Prelude.d_OP_plus_plus
    (d_C_showCurryExpr x1 Curry_Prelude.C_False
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x3 (Curry_Prelude.C_Int (2)) cd cs) x12 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\n") (Curry_Prelude.d_OP_plus_plus
    (d_C_sceBlanks x3 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " else ") (d_C_showCurryExpr x1
    Curry_Prelude.C_False
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x3 (Curry_Prelude.C_Int (2)) cd cs) x14 cd cs) cd cs) cd cs) cd cs) cd cs)
    cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_43 x8 x15 x14 x12 x10 x3 x1 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (2)) (Curry_Prelude.d_C_snd x8
    cd cs) cd cs) (Curry_Prelude.toCurryString "(,") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_44 x15 x8 x14 x12
    x10 x3 x1 x2 l cd cs) (d_C__case_44 x15 x8 x14 x12 x10 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_44 x15
    x8 x14 x12 x10 x3 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_44 x15 x8
    x14 x12 x10 x3 x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_44" [show x15, show x8, show x14, show x12, show x10
    , show x3, show x1, show x2, show x16] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_44" (showCons x16))

nd_C__case_44 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.C_Int -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_44 x15 x8 x14 x12 x10 x3 x1 x2 x16 s cd cs = case x16 of
  Curry_Prelude.C_True -> let s4 = s
    in s4 `seq` d_C_showBracketsIf x2 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\n") (Curry_Prelude.d_OP_plus_plus
    (d_C_sceBlanks x3 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " if ") (let s0 = leftSupply s4
                                              s3 = rightSupply s4
    in s0 `seq` (s3 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_showCurryExpr x1
    Curry_Prelude.C_False
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x3 (Curry_Prelude.C_Int (2)) cd cs) x10 s0 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\n")
    (Curry_Prelude.d_OP_plus_plus (d_C_sceBlanks x3 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " then ")
    (let s1 = leftSupply s3
         s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_showCurryExpr x1
    Curry_Prelude.C_False
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x3 (Curry_Prelude.C_Int (2)) cd cs) x12 s1 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "\n")
    (Curry_Prelude.d_OP_plus_plus (d_C_sceBlanks x3 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " else ")
    (nd_C_showCurryExpr x1 Curry_Prelude.C_False
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x3 (Curry_Prelude.C_Int (2)) cd cs) x14 s2 cd cs) cd cs) cd cs) cd cs) cd
    cs)) cd cs) cd cs) cd cs) cd cs)) cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_43 x8 x15 x14 x12 x10 x3 x1 x2
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (2)) (Curry_Prelude.d_C_snd x8
    cd cs) cd cs) (Curry_Prelude.toCurryString "(,") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_44 x15 x8 x14
    x12 x10 x3 x1 x2 l s cd cs) (nd_C__case_44 x15 x8 x14 x12 x10 x3 x1 x2 r s
    cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_44 x15
    x8 x14 x12 x10 x3 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_44 x15 x8
    x14 x12 x10 x3 x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_44" [show x15, show x8, show x14, show x12, show x10
    , show x3, show x1, show x2, show x16] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_44" (showCons x16))

d_C__case_43 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_43 x8 x15 x14 x12 x10 x3 x1 x2 x16 cd cs = case x16 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(") (Curry_Prelude.d_OP_plus_plus
    (Data.Curry_List.d_C_intercalate (Curry_Prelude.toCurryString ",")
    (Curry_Prelude.d_C_map (d_C_showCurryExpr x1 Curry_Prelude.C_False x3)
    (Curry_Prelude.OP_Cons x10 (Curry_Prelude.OP_Cons x12 (Curry_Prelude.OP_Cons
    x14 x15))) cd cs) cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_42 x15 x14 x12 x10 x3 x1 x8 x2
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_43 x8 x15 x14 x12
    x10 x3 x1 x2 l cd cs) (d_C__case_43 x8 x15 x14 x12 x10 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_43 x8
    x15 x14 x12 x10 x3 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_43 x8 x15
    x14 x12 x10 x3 x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_43" [show x8, show x15, show x14, show x12, show x10
    , show x3, show x1, show x2, show x16] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_43" (showCons x16))

nd_C__case_43 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_43 x8 x15 x14 x12 x10 x3 x1 x2 x16 s cd cs = case x16 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "(")
    (Curry_Prelude.d_OP_plus_plus (Data.Curry_List.d_C_intercalate
    (Curry_Prelude.toCurryString ",") (Curry_Prelude.nd_C_map (wrapNX id
    (nd_C_showCurryExpr x1 Curry_Prelude.C_False x3)) (Curry_Prelude.OP_Cons x10
    (Curry_Prelude.OP_Cons x12 (Curry_Prelude.OP_Cons x14 x15))) s0 cd cs) cd
    cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_42 x15 x14 x12 x10 x3 x1 x8 x2
    (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_43 x8 x15 x14
    x12 x10 x3 x1 x2 l s cd cs) (nd_C__case_43 x8 x15 x14 x12 x10 x3 x1 x2 r s
    cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_43 x8
    x15 x14 x12 x10 x3 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_43 x8 x15
    x14 x12 x10 x3 x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_43" [show x8, show x15, show x14, show x12, show x10
    , show x3, show x1, show x2, show x16] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_43" (showCons x16))

d_C__case_42 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_42 x15 x14 x12 x10 x3 x1 x8 x2 x16 cd cs = case x16 of
  Curry_Prelude.C_True -> d_C_showBracketsIf x2 (Curry_Prelude.d_OP_plus_plus
    (d_C_showCurryId (Curry_Prelude.d_C_apply x1 x8 cd cs) cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ")
    (d_C_showCurryElems (d_C_showCurryExpr x1 Curry_Prelude.C_True x3)
    (Curry_Prelude.OP_Cons x10 (Curry_Prelude.OP_Cons x12 (Curry_Prelude.OP_Cons
    x14 x15))) cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_42 x15 x14 x12
    x10 x3 x1 x8 x2 l cd cs) (d_C__case_42 x15 x14 x12 x10 x3 x1 x8 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_42 x15
    x14 x12 x10 x3 x1 x8 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_42 x15 x14
    x12 x10 x3 x1 x8 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_42" [show x15, show x14, show x12, show x10, show x3
    , show x1, show x8, show x2, show x16] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_42" (showCons x16))

nd_C__case_42 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_42 x15 x14 x12 x10 x3 x1 x8 x2 x16 s cd cs = case x16 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` d_C_showBracketsIf x2 (let s0 = leftSupply s2
                                           s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus (d_C_showCurryId
    (Curry_Prelude.nd_C_apply x1 x8 s0 cd cs) cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ")
    (nd_C_showCurryElems (wrapNX id (nd_C_showCurryExpr x1 Curry_Prelude.C_True
    x3)) (Curry_Prelude.OP_Cons x10 (Curry_Prelude.OP_Cons x12
    (Curry_Prelude.OP_Cons x14 x15))) s1 cd cs) cd cs) cd cs)) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_42 x15 x14 x12
    x10 x3 x1 x8 x2 l s cd cs) (nd_C__case_42 x15 x14 x12 x10 x3 x1 x8 x2 r s cd
    cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_42 x15
    x14 x12 x10 x3 x1 x8 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_42 x15
    x14 x12 x10 x3 x1 x8 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_42" [show x15, show x14, show x12, show x10, show x3
    , show x1, show x8, show x2, show x16] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_42" (showCons x16))

d_C__case_50 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_50 x8 x12 x10 x7 x3 x1 x2 x13 cd cs = case x13 of
  Curry_Prelude.C_True -> d_C_showBracketsIf x2 (Curry_Prelude.d_OP_plus_plus
    (d_C_showCurryExpr x1 Curry_Prelude.C_True x3 x10 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ")
    (d_C_showCurryExpr x1 Curry_Prelude.C_True x3 x12 cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_49 x8 x12 x10 x7 x3 x1 x2
    (Curry_Prelude.d_C_isAlpha (Curry_Prelude.d_C_head (Curry_Prelude.d_C_snd x8
    cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_50 x8 x12 x10 x7
    x3 x1 x2 l cd cs) (d_C__case_50 x8 x12 x10 x7 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_50 x8
    x12 x10 x7 x3 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_50 x8 x12
    x10 x7 x3 x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_50" [show x8, show x12, show x10, show x7, show x3
    , show x1, show x2, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_50" (showCons x13))

nd_C__case_50 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.C_Int -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_50 x8 x12 x10 x7 x3 x1 x2 x13 s cd cs = case x13 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` d_C_showBracketsIf x2 (let s0 = leftSupply s2
                                           s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_showCurryExpr x1
    Curry_Prelude.C_True x3 x10 s0 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " ") (nd_C_showCurryExpr x1
    Curry_Prelude.C_True x3 x12 s1 cd cs) cd cs) cd cs)) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_49 x8 x12 x10 x7 x3 x1 x2 (Curry_Prelude.d_C_isAlpha
    (Curry_Prelude.d_C_head (Curry_Prelude.d_C_snd x8 cd cs) cd cs) cd cs) s0 cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_50 x8 x12 x10 x7
    x3 x1 x2 l s cd cs) (nd_C__case_50 x8 x12 x10 x7 x3 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_50 x8
    x12 x10 x7 x3 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_50 x8 x12
    x10 x7 x3 x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_50" [show x8, show x12, show x10, show x7, show x3
    , show x1, show x2, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_50" (showCons x13))

d_C__case_49 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_49 x8 x12 x10 x7 x3 x1 x2 x13 cd cs = case x13 of
  Curry_Prelude.C_True -> d_C_showBracketsIf x2 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply x1 x8 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " ") (d_C_showCurryElems (d_C_showCurryExpr x1
    Curry_Prelude.C_True x3) (Curry_Prelude.OP_Cons x10 (Curry_Prelude.OP_Cons
    x12 Curry_Prelude.OP_List)) cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_48 x12 x10 x8 x7 x3 x1 x2 (d_C_isFiniteList
    (FlatCurry.Curry_Types.C_Comb x7 x8 (Curry_Prelude.OP_Cons x10
    (Curry_Prelude.OP_Cons x12 Curry_Prelude.OP_List))) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_49 x8 x12 x10 x7
    x3 x1 x2 l cd cs) (d_C__case_49 x8 x12 x10 x7 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_49 x8
    x12 x10 x7 x3 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_49 x8 x12
    x10 x7 x3 x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_49" [show x8, show x12, show x10, show x7, show x3
    , show x1, show x2, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_49" (showCons x13))

nd_C__case_49 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.C_Int -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_49 x8 x12 x10 x7 x3 x1 x2 x13 s cd cs = case x13 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` d_C_showBracketsIf x2 (let s0 = leftSupply s2
                                           s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_apply
    x1 x8 s0 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " ") (nd_C_showCurryElems (wrapNX id (nd_C_showCurryExpr x1
    Curry_Prelude.C_True x3)) (Curry_Prelude.OP_Cons x10 (Curry_Prelude.OP_Cons
    x12 Curry_Prelude.OP_List)) s1 cd cs) cd cs) cd cs)) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_48 x12 x10 x8 x7 x3 x1 x2 (d_C_isFiniteList
    (FlatCurry.Curry_Types.C_Comb x7 x8 (Curry_Prelude.OP_Cons x10
    (Curry_Prelude.OP_Cons x12 Curry_Prelude.OP_List))) cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_49 x8 x12 x10 x7
    x3 x1 x2 l s cd cs) (nd_C__case_49 x8 x12 x10 x7 x3 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_49 x8
    x12 x10 x7 x3 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_49 x8 x12
    x10 x7 x3 x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_49" [show x8, show x12, show x10, show x7, show x3
    , show x1, show x2, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_49" (showCons x13))

d_C__case_48 :: FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_48 x12 x10 x8 x7 x3 x1 x2 x13 cd cs = case x13 of
  Curry_Prelude.C_True -> d_C__case_47 x12 x10 x8 x7 x3 x1 (d_C_isStringConstant
    (FlatCurry.Curry_Types.C_Comb x7 x8 (Curry_Prelude.OP_Cons x10
    (Curry_Prelude.OP_Cons x12 Curry_Prelude.OP_List))) cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_46 x8 x12 x3 x1 x10 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_snd x8 cd cs) (Curry_Prelude.toCurryString "(,)") cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_48 x12 x10 x8 x7
    x3 x1 x2 l cd cs) (d_C__case_48 x12 x10 x8 x7 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_48 x12
    x10 x8 x7 x3 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_48 x12 x10
    x8 x7 x3 x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_48" [show x12, show x10, show x8, show x7, show x3
    , show x1, show x2, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_48" (showCons x13))

nd_C__case_48 :: FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.C_Int -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_48 x12 x10 x8 x7 x3 x1 x2 x13 s cd cs = case x13 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C__case_47 x12 x10 x8 x7 x3 x1 (d_C_isStringConstant
    (FlatCurry.Curry_Types.C_Comb x7 x8 (Curry_Prelude.OP_Cons x10
    (Curry_Prelude.OP_Cons x12 Curry_Prelude.OP_List))) cd cs) s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_46 x8 x12 x3 x1 x10 x2
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_C_snd x8 cd cs) (Curry_Prelude.toCurryString "(,)") s0 cd
    cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_48 x12 x10 x8 x7
    x3 x1 x2 l s cd cs) (nd_C__case_48 x12 x10 x8 x7 x3 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_48 x12
    x10 x8 x7 x3 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_48 x12
    x10 x8 x7 x3 x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_48" [show x12, show x10, show x8, show x7, show x3
    , show x1, show x2, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_48" (showCons x13))

d_C__case_46 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_46 x8 x12 x3 x1 x10 x2 x13 cd cs = case x13 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(") (Curry_Prelude.d_OP_plus_plus
    (d_C_showCurryExpr x1 Curry_Prelude.C_False x3 x10 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString ",")
    (Curry_Prelude.d_OP_plus_plus (d_C_showCurryExpr x1 Curry_Prelude.C_False x3
    x12 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_45 x12 x3 x1 x8 x10 x2
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_46 x8 x12 x3 x1
    x10 x2 l cd cs) (d_C__case_46 x8 x12 x3 x1 x10 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_46 x8
    x12 x3 x1 x10 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_46 x8 x12
    x3 x1 x10 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_46" [show x8, show x12, show x3, show x1, show x10
    , show x2, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_46" (showCons x13))

nd_C__case_46 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_46 x8 x12 x3 x1 x10 x2 x13 s cd cs = case x13 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "(")
    (let s0 = leftSupply s2
         s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_showCurryExpr x1
    Curry_Prelude.C_False x3 x10 s0 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString ",") (Curry_Prelude.d_OP_plus_plus
    (nd_C_showCurryExpr x1 Curry_Prelude.C_False x3 x12 s1 cd cs)
    (Curry_Prelude.toCurryString ")") cd cs) cd cs) cd cs)) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_45 x12 x3 x1 x8 x10 x2 (Curry_Prelude.d_C_otherwise
    cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_46 x8 x12 x3 x1
    x10 x2 l s cd cs) (nd_C__case_46 x8 x12 x3 x1 x10 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_46 x8
    x12 x3 x1 x10 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_46 x8 x12
    x3 x1 x10 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_46" [show x8, show x12, show x3, show x1, show x10
    , show x2, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_46" (showCons x13))

d_C__case_45 :: FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_45 x12 x3 x1 x8 x10 x2 x13 cd cs = case x13 of
  Curry_Prelude.C_True -> d_C_showBracketsIf x2 (Curry_Prelude.d_OP_plus_plus
    (d_C_showCurryExpr x1 Curry_Prelude.C_True x3 x10 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply x1 x8 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ")
    (d_C_showCurryExpr x1 Curry_Prelude.C_True x3 x12 cd cs) cd cs) cd cs) cd
    cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_45 x12 x3 x1 x8
    x10 x2 l cd cs) (d_C__case_45 x12 x3 x1 x8 x10 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_45 x12
    x3 x1 x8 x10 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_45 x12 x3
    x1 x8 x10 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_45" [show x12, show x3, show x1, show x8, show x10
    , show x2, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_45" (showCons x13))

nd_C__case_45 :: FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_45 x12 x3 x1 x8 x10 x2 x13 s cd cs = case x13 of
  Curry_Prelude.C_True -> let s4 = s
    in s4 `seq` d_C_showBracketsIf x2 (let s0 = leftSupply s4
                                           s3 = rightSupply s4
    in s0 `seq` (s3 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_showCurryExpr x1
    Curry_Prelude.C_True x3 x10 s0 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " ") (let s1 = leftSupply s3
                                           s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_apply
    x1 x8 s1 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " ") (nd_C_showCurryExpr x1 Curry_Prelude.C_True x3 x12 s2 cd cs) cd cs) cd
    cs)) cd cs) cd cs)) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_45 x12 x3 x1 x8
    x10 x2 l s cd cs) (nd_C__case_45 x12 x3 x1 x8 x10 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_45 x12
    x3 x1 x8 x10 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_45 x12 x3
    x1 x8 x10 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_45" [show x12, show x3, show x1, show x8, show x10
    , show x2, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_45" (showCons x13))

d_C__case_47 :: FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_47 x12 x10 x8 x7 x3 x1 x13 cd cs = case x13 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\"") (Curry_Prelude.d_OP_plus_plus
    (d_C_showCurryStringConstant (FlatCurry.Curry_Types.C_Comb x7 x8
    (Curry_Prelude.OP_Cons x10 (Curry_Prelude.OP_Cons x12
    Curry_Prelude.OP_List))) cd cs) (Curry_Prelude.toCurryString "\"") cd cs) cd
    cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "[") (Curry_Prelude.d_OP_plus_plus
    (Data.Curry_List.d_C_intercalate (Curry_Prelude.toCurryString ",")
    (d_C_showCurryFiniteList x1 x3 (FlatCurry.Curry_Types.C_Comb x7 x8
    (Curry_Prelude.OP_Cons x10 (Curry_Prelude.OP_Cons x12
    Curry_Prelude.OP_List))) cd cs) cd cs) (Curry_Prelude.toCurryString "]") cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_47 x12 x10 x8 x7
    x3 x1 l cd cs) (d_C__case_47 x12 x10 x8 x7 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_47 x12
    x10 x8 x7 x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_47 x12 x10
    x8 x7 x3 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_47" [show x12, show x10, show x8, show x7, show x3
    , show x1, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_47" (showCons x13))

nd_C__case_47 :: FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.C_Int -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_47 x12 x10 x8 x7 x3 x1 x13 s cd cs = case x13 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "\"") (Curry_Prelude.d_OP_plus_plus
    (d_C_showCurryStringConstant (FlatCurry.Curry_Types.C_Comb x7 x8
    (Curry_Prelude.OP_Cons x10 (Curry_Prelude.OP_Cons x12
    Curry_Prelude.OP_List))) cd cs) (Curry_Prelude.toCurryString "\"") cd cs) cd
    cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "[")
    (Curry_Prelude.d_OP_plus_plus (Data.Curry_List.d_C_intercalate
    (Curry_Prelude.toCurryString ",") (nd_C_showCurryFiniteList x1 x3
    (FlatCurry.Curry_Types.C_Comb x7 x8 (Curry_Prelude.OP_Cons x10
    (Curry_Prelude.OP_Cons x12 Curry_Prelude.OP_List))) s0 cd cs) cd cs)
    (Curry_Prelude.toCurryString "]") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_47 x12 x10 x8 x7
    x3 x1 l s cd cs) (nd_C__case_47 x12 x10 x8 x7 x3 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_47 x12
    x10 x8 x7 x3 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_47 x12
    x10 x8 x7 x3 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_47" [show x12, show x10, show x8, show x7, show x3
    , show x1, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_47" (showCons x13))

d_C__case_39 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_39 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> x1
  Curry_Prelude.C_False -> d_C__case_38 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.toCurryString "[]") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_39 x1 l cd cs)
    (d_C__case_39 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_39 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_39 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_39" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_39" (showCons x2))

d_C__case_38 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_38 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> x1
  Curry_Prelude.C_False -> d_C__case_37 x1 (Curry_Prelude.d_C_otherwise cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_38 x1 l cd cs)
    (d_C__case_38 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_38 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_38 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_38" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_38" (showCons x2))

d_C__case_37 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_37 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '('#) x1) (Curry_Prelude.toCurryString ")") cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_37 x1 l cd cs)
    (d_C__case_37 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_37 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_37 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_37" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_37" (showCons x2))

d_C__case_36 :: FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Pattern -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_36 x5 x2 x1 x4 cd cs = case x4 of
  FlatCurry.Curry_Types.C_Pattern x6 x7 -> Curry_Prelude.d_OP_plus_plus
    (d_C_sceBlanks x2 cd cs) (Curry_Prelude.d_OP_plus_plus
    (d_OP_showCurryCase_dot_showPattern_dot_189
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_C_apply x1 x6 cd cs) x7 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " -> ")
    (Curry_Prelude.d_OP_plus_plus (d_C_showCurryExpr x1 Curry_Prelude.C_False x2
    x5 cd cs) (Curry_Prelude.toCurryString "\n") cd cs) cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_LPattern x8 -> Curry_Prelude.d_OP_plus_plus
    (d_C_sceBlanks x2 cd cs) (Curry_Prelude.d_OP_plus_plus (d_C_showCurryLit x8
    cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " -> ")
    (Curry_Prelude.d_OP_plus_plus (d_C_showCurryExpr x1 Curry_Prelude.C_False x2
    x5 cd cs) (Curry_Prelude.toCurryString "\n") cd cs) cd cs) cd cs) cd cs) cd
    cs
  FlatCurry.Curry_Types.Choice_C_Pattern d i l r -> narrow d i (d_C__case_36 x5
    x2 x1 l cd cs) (d_C__case_36 x5 x2 x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Pattern d i xs -> narrows cs d i (\z ->
    d_C__case_36 x5 x2 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Pattern d c e -> guardCons d c ((\x ->
    d_C__case_36 x5 x2 x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Pattern d info -> failCons d (traceFail
    "FlatCurry.Show._case_36" [show x5, show x2, show x1, show x4] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_36" (showCons x4))

nd_C__case_36 :: FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_Pattern -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_36 x5 x2 x1 x4 s cd cs = case x4 of
  FlatCurry.Curry_Types.C_Pattern x6 x7 -> let s4 = s
    in s4 `seq` Curry_Prelude.d_OP_plus_plus (d_C_sceBlanks x2 cd cs)
    (let s2 = leftSupply s4
         s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_plus_plus (let s1 = leftSupply s2
                                                            s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_OP_showCurryCase_dot_showPattern_dot_189 (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash)
    (Curry_Prelude.nd_C_apply x1 x6 s0 cd cs) x7 s1 cd cs))
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " -> ")
    (Curry_Prelude.d_OP_plus_plus (nd_C_showCurryExpr x1 Curry_Prelude.C_False
    x2 x5 s3 cd cs) (Curry_Prelude.toCurryString "\n") cd cs) cd cs) cd cs)) cd
    cs
  FlatCurry.Curry_Types.C_LPattern x8 -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (d_C_sceBlanks x2 cd cs)
    (Curry_Prelude.d_OP_plus_plus (d_C_showCurryLit x8 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " -> ")
    (Curry_Prelude.d_OP_plus_plus (nd_C_showCurryExpr x1 Curry_Prelude.C_False
    x2 x5 s0 cd cs) (Curry_Prelude.toCurryString "\n") cd cs) cd cs) cd cs) cd
    cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Pattern d i l r -> narrow d i (nd_C__case_36 x5
    x2 x1 l s cd cs) (nd_C__case_36 x5 x2 x1 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Pattern d i xs -> narrows cs d i (\z ->
    nd_C__case_36 x5 x2 x1 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Pattern d c e -> guardCons d c ((\x ->
    nd_C__case_36 x5 x2 x1 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Pattern d info -> failCons d (traceFail
    "FlatCurry.Show._case_36" [show x5, show x2, show x1, show x4] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_36" (showCons x4))

d_C__case_35 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> t0 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_35 x2 x4 x1 x5 cd cs = case x5 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_plus_plus x2
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ")
    (d_C_showCurryVar x1 x4 cd cs) cd cs) cd cs
  Curry_Prelude.OP_Cons x6 x7 -> d_C__case_34 x2 x6 x4 x1 x7 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_35 x2 x4 x1 l cd
    cs) (d_C__case_35 x2 x4 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_35 x2
    x4 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_35 x2 x4
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_35" [show x2, show x4, show x1, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_35" (showCons x5))

nd_C__case_35 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> t0 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_35 x2 x4 x1 x5 s cd cs = case x5 of
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " ") (nd_C_showCurryVar x1 x4 s0 cd cs) cd cs)
    cd cs
  Curry_Prelude.OP_Cons x6 x7 -> let s0 = s
    in s0 `seq` nd_C__case_34 x2 x6 x4 x1 x7 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_35 x2 x4 x1 l s
    cd cs) (nd_C__case_35 x2 x4 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_35 x2
    x4 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_35 x2 x4
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_35" [show x2, show x4, show x1, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_35" (showCons x5))

d_C__case_34 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> t0 -> t0 -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_34 x2 x6 x4 x1 x7 cd cs = case x7 of
  Curry_Prelude.OP_List -> d_C__case_33 x2 x6 x1 x4 (Curry_Prelude.d_C_isAlpha
    (Curry_Prelude.d_C_head x2 cd cs) cd cs) cd cs
  Curry_Prelude.OP_Cons x8 x9 -> d_C__case_31 x2 x9 x8 x6 x4 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (2)) x2 cd cs)
    (Curry_Prelude.toCurryString "(,") cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_34 x2 x6 x4 x1 l
    cd cs) (d_C__case_34 x2 x6 x4 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_34 x2
    x6 x4 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_34 x2 x6
    x4 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_34" [show x2, show x6, show x4, show x1, show x7]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_34" (showCons x7))

nd_C__case_34 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> t0 -> t0 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_34 x2 x6 x4 x1 x7 s cd cs = case x7 of
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` nd_C__case_33 x2 x6 x1 x4 (Curry_Prelude.d_C_isAlpha
    (Curry_Prelude.d_C_head x2 cd cs) cd cs) s0 cd cs
  Curry_Prelude.OP_Cons x8 x9 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_31 x2 x9 x8 x6 x4 x1
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (2)) x2 cd cs)
    (Curry_Prelude.toCurryString "(,") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_34 x2 x6 x4 x1
    l s cd cs) (nd_C__case_34 x2 x6 x4 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_34 x2
    x6 x4 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_34 x2 x6
    x4 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_34" [show x2, show x6, show x4, show x1, show x7]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_34" (showCons x7))

d_C__case_31 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> t0 -> t0 -> t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_31 x2 x9 x8 x6 x4 x1 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(") (Curry_Prelude.d_OP_plus_plus
    (Data.Curry_List.d_C_intercalate (Curry_Prelude.toCurryString ",")
    (Curry_Prelude.d_C_map (d_C_showCurryVar x1) (Curry_Prelude.OP_Cons x4
    (Curry_Prelude.OP_Cons x6 (Curry_Prelude.OP_Cons x8 x9))) cd cs) cd cs)
    (Curry_Prelude.toCurryString ")") cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_plus_plus x2
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ")
    (d_C_showCurryElems (d_C_showCurryVar x1) (Curry_Prelude.OP_Cons x4
    (Curry_Prelude.OP_Cons x6 (Curry_Prelude.OP_Cons x8 x9))) cd cs) cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_31 x2 x9 x8 x6 x4
    x1 l cd cs) (d_C__case_31 x2 x9 x8 x6 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_31 x2
    x9 x8 x6 x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_31 x2 x9
    x8 x6 x4 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_31" [show x2, show x9, show x8, show x6, show x4, show
    x1, show x10] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_31" (showCons x10))

nd_C__case_31 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List t0 -> t0 -> t0 -> t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_31 x2 x9 x8 x6 x4 x1 x10 s cd cs = case x10 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "(")
    (Curry_Prelude.d_OP_plus_plus (Data.Curry_List.d_C_intercalate
    (Curry_Prelude.toCurryString ",") (Curry_Prelude.nd_C_map (wrapNX id
    (nd_C_showCurryVar x1)) (Curry_Prelude.OP_Cons x4 (Curry_Prelude.OP_Cons x6
    (Curry_Prelude.OP_Cons x8 x9))) s0 cd cs) cd cs)
    (Curry_Prelude.toCurryString ")") cd cs) cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " ") (nd_C_showCurryElems (wrapNX id
    (nd_C_showCurryVar x1)) (Curry_Prelude.OP_Cons x4 (Curry_Prelude.OP_Cons x6
    (Curry_Prelude.OP_Cons x8 x9))) s0 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_31 x2 x9 x8 x6
    x4 x1 l s cd cs) (nd_C__case_31 x2 x9 x8 x6 x4 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_31 x2
    x9 x8 x6 x4 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_31 x2 x9
    x8 x6 x4 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_31" [show x2, show x9, show x8, show x6, show x4, show
    x1, show x10] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_31" (showCons x10))

d_C__case_33 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> t0 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> t0 -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_33 x2 x6 x1 x4 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus x2
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ")
    (Curry_Prelude.d_OP_plus_plus (d_C_showCurryVar x1 x4 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ")
    (d_C_showCurryVar x1 x6 cd cs) cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_32 x2 x6 x1 x4
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x2 (Curry_Prelude.toCurryString "(,)") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_33 x2 x6 x1 x4 l
    cd cs) (d_C__case_33 x2 x6 x1 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_33 x2
    x6 x1 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_33 x2 x6
    x1 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_33" [show x2, show x6, show x1, show x4, show x7]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_33" (showCons x7))

nd_C__case_33 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> t0 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> t0 -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_33 x2 x6 x1 x4 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " ") (let s0 = leftSupply s2
                                           s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_showCurryVar x1 x4
    s0 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ")
    (nd_C_showCurryVar x1 x6 s1 cd cs) cd cs) cd cs)) cd cs) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_32 x2 x6 x1 x4
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x2 (Curry_Prelude.toCurryString "(,)") s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_33 x2 x6 x1 x4 l
    s cd cs) (nd_C__case_33 x2 x6 x1 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_33 x2
    x6 x1 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_33 x2 x6
    x1 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_33" [show x2, show x6, show x1, show x4, show x7]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_33" (showCons x7))

d_C__case_32 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> t0 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> t0 -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_32 x2 x6 x1 x4 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "(") (Curry_Prelude.d_OP_plus_plus
    (d_C_showCurryVar x1 x4 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString ",") (Curry_Prelude.d_OP_plus_plus
    (d_C_showCurryVar x1 x6 cd cs) (Curry_Prelude.toCurryString ")") cd cs) cd
    cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_plus_plus (d_C_showCurryVar x1 x4
    cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ")
    (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " ") (d_C_showCurryVar x1 x6 cd cs) cd cs) cd
    cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_32 x2 x6 x1 x4 l
    cd cs) (d_C__case_32 x2 x6 x1 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_32 x2
    x6 x1 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_32 x2 x6
    x1 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_32" [show x2, show x6, show x1, show x4, show x7]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_32" (showCons x7))

nd_C__case_32 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> t0 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> t0 -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
nd_C__case_32 x2 x6 x1 x4 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "(")
    (let s0 = leftSupply s2
         s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_showCurryVar x1 x4
    s0 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString ",")
    (Curry_Prelude.d_OP_plus_plus (nd_C_showCurryVar x1 x6 s1 cd cs)
    (Curry_Prelude.toCurryString ")") cd cs) cd cs) cd cs)) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_showCurryVar x1 x4
    s0 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " ")
    (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " ") (nd_C_showCurryVar x1 x6 s1 cd cs) cd cs)
    cd cs) cd cs) cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_32 x2 x6 x1 x4 l
    s cd cs) (nd_C__case_32 x2 x6 x1 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_32 x2
    x6 x1 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_32 x2 x6
    x1 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_32" [show x2, show x6, show x1, show x4, show x7]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_32" (showCons x7))

d_C__case_30 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int -> (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_30 x4 x2 x1 x3 cd cs = case x3 of
  FlatCurry.Curry_Types.C_Comb x5 x6 x7 -> d_C__case_29 x7 x2 x1 x6 cd cs
  FlatCurry.Curry_Types.C_Var x18 -> x4
  FlatCurry.Curry_Types.C_Lit x19 -> x4
  FlatCurry.Curry_Types.C_Let x20 x21 -> x4
  FlatCurry.Curry_Types.C_Free x22 x23 -> x4
  FlatCurry.Curry_Types.C_Or x24 x25 -> x4
  FlatCurry.Curry_Types.C_Case x26 x27 x28 -> x4
  FlatCurry.Curry_Types.C_Typed x29 x30 -> x4
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (d_C__case_30 x4 x2
    x1 l cd cs) (d_C__case_30 x4 x2 x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    d_C__case_30 x4 x2 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x -> d_C__case_30
    x4 x2 x1 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "FlatCurry.Show._case_30" [show x4, show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_30" (showCons x3))

nd_C__case_30 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C__case_30 x4 x2 x1 x3 s cd cs = case x3 of
  FlatCurry.Curry_Types.C_Comb x5 x6 x7 -> let s0 = s
    in s0 `seq` nd_C__case_29 x7 x2 x1 x6 s0 cd cs
  FlatCurry.Curry_Types.C_Var x18 -> x4
  FlatCurry.Curry_Types.C_Lit x19 -> x4
  FlatCurry.Curry_Types.C_Let x20 x21 -> x4
  FlatCurry.Curry_Types.C_Free x22 x23 -> x4
  FlatCurry.Curry_Types.C_Or x24 x25 -> x4
  FlatCurry.Curry_Types.C_Case x26 x27 x28 -> x4
  FlatCurry.Curry_Types.C_Typed x29 x30 -> x4
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (nd_C__case_30 x4 x2
    x1 l s cd cs) (nd_C__case_30 x4 x2 x1 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    nd_C__case_30 x4 x2 x1 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x ->
    nd_C__case_30 x4 x2 x1 e s cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "FlatCurry.Show._case_30" [show x4, show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_30" (showCons x3))

d_C__case_29 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.C_Int -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_29 x7 x2 x1 x6 cd cs = case x6 of
  Curry_Prelude.OP_Tuple2 x8 x9 -> d_C__case_28 x8 x9 x7 x2 x1
    (Curry_Prelude.d_C_eqString x8 (Curry_Prelude.toCurryString "Prelude") cd
    cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_29 x7 x2 x1 l
    cd cs) (d_C__case_29 x7 x2 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_29
    x7 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_29 x7
    x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Show._case_29" [show x7, show x2, show x1, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_29" (showCons x6))

nd_C__case_29 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.C_Int -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C__case_29 x7 x2 x1 x6 s cd cs = case x6 of
  Curry_Prelude.OP_Tuple2 x8 x9 -> let s0 = s
    in s0 `seq` nd_C__case_28 x8 x9 x7 x2 x1 (Curry_Prelude.d_C_eqString x8
    (Curry_Prelude.toCurryString "Prelude") cd cs) s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_29 x7 x2 x1 l
    s cd cs) (nd_C__case_29 x7 x2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_29
    x7 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_29 x7
    x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Show._case_29" [show x7, show x2, show x1, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_29" (showCons x6))

d_C__case_28 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_28 x8 x9 x7 x2 x1 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> d_C__case_27 x9 x7 x2 x1 (Curry_Prelude.d_C_eqString
    x9 (Curry_Prelude.toCurryString "[]") cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Internal error in FlatCurry.Show.showCurryFiniteList") cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_28 x8 x9 x7 x2 x1
    l cd cs) (d_C__case_28 x8 x9 x7 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_28 x8
    x9 x7 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_28 x8 x9
    x7 x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_28" [show x8, show x9, show x7, show x2, show x1, show
    x10] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_28" (showCons x10))

nd_C__case_28 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_C__case_28 x8 x9 x7 x2 x1 x10 s cd cs = case x10 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C__case_27 x9 x7 x2 x1 (Curry_Prelude.d_C_eqString x9
    (Curry_Prelude.toCurryString "[]") cd cs) s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Internal error in FlatCurry.Show.showCurryFiniteList") cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_28 x8 x9 x7 x2
    x1 l s cd cs) (nd_C__case_28 x8 x9 x7 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_28 x8
    x9 x7 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_28 x8 x9
    x7 x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_28" [show x8, show x9, show x7, show x2, show x1, show
    x10] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_28" (showCons x10))

d_C__case_27 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_27 x9 x7 x2 x1 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> d_C__case_26 x7 cd cs
  Curry_Prelude.C_False -> d_C__case_25 x9 x7 x2 x1 (Curry_Prelude.d_C_eqString
    x9 (Curry_Prelude.toCurryString ":") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_27 x9 x7 x2 x1 l
    cd cs) (d_C__case_27 x9 x7 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_27 x9
    x7 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_27 x9 x7
    x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_27" [show x9, show x7, show x2, show x1, show x10]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_27" (showCons x10))

nd_C__case_27 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int
  -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_C__case_27 x9 x7 x2 x1 x10 s cd cs = case x10 of
  Curry_Prelude.C_True -> d_C__case_26 x7 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_25 x9 x7 x2 x1 (Curry_Prelude.d_C_eqString x9
    (Curry_Prelude.toCurryString ":") cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_27 x9 x7 x2 x1 l
    s cd cs) (nd_C__case_27 x9 x7 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_27 x9
    x7 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_27 x9 x7
    x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_27" [show x9, show x7, show x2, show x1, show x10]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_27" (showCons x10))

d_C__case_25 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_25 x9 x7 x2 x1 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> d_C__case_24 x2 x1 x7 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Internal error in FlatCurry.Show.showCurryFiniteList") cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_25 x9 x7 x2 x1 l
    cd cs) (d_C__case_25 x9 x7 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_25 x9
    x7 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_25 x9 x7
    x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_25" [show x9, show x7, show x2, show x1, show x10]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_25" (showCons x10))

nd_C__case_25 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int
  -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_C__case_25 x9 x7 x2 x1 x10 s cd cs = case x10 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C__case_24 x2 x1 x7 s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Internal error in FlatCurry.Show.showCurryFiniteList") cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_25 x9 x7 x2 x1 l
    s cd cs) (nd_C__case_25 x9 x7 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_25 x9
    x7 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_25 x9 x7
    x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_25" [show x9, show x7, show x2, show x1, show x10]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_25" (showCons x10))

d_C__case_24 :: Curry_Prelude.C_Int -> (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_24 x2 x1 x7 cd cs = case x7 of
  Curry_Prelude.OP_Cons x12 x13 -> d_C__case_23 x2 x1 x12 x13 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Internal error in FlatCurry.Show.showCurryFiniteList") cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_24 x2 x1 l cd
    cs) (d_C__case_24 x2 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_24 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_24 x2 x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_24" [show x2, show x1, show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_24" (showCons x7))

nd_C__case_24 :: Curry_Prelude.C_Int -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_C__case_24 x2 x1 x7 s cd cs = case x7 of
  Curry_Prelude.OP_Cons x12 x13 -> let s0 = s
    in s0 `seq` nd_C__case_23 x2 x1 x12 x13 s0 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Internal error in FlatCurry.Show.showCurryFiniteList") cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_24 x2 x1 l s cd
    cs) (nd_C__case_24 x2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_24 x2
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_24 x2 x1
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_24" [show x2, show x1, show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_24" (showCons x7))

d_C__case_23 :: Curry_Prelude.C_Int -> (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_23 x2 x1 x12 x13 cd cs = case x13 of
  Curry_Prelude.OP_Cons x14 x15 -> d_C__case_22 x14 x2 x1 x12 x15 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Internal error in FlatCurry.Show.showCurryFiniteList") cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_23 x2 x1 x12 l
    cd cs) (d_C__case_23 x2 x1 x12 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_23 x2
    x1 x12 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_23 x2 x1
    x12 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_23" [show x2, show x1, show x12, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_23" (showCons x13))

nd_C__case_23 :: Curry_Prelude.C_Int -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C__case_23 x2 x1 x12 x13 s cd cs = case x13 of
  Curry_Prelude.OP_Cons x14 x15 -> let s0 = s
    in s0 `seq` nd_C__case_22 x14 x2 x1 x12 x15 s0 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Internal error in FlatCurry.Show.showCurryFiniteList") cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_23 x2 x1 x12 l
    s cd cs) (nd_C__case_23 x2 x1 x12 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_23 x2
    x1 x12 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_23 x2 x1
    x12 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_23" [show x2, show x1, show x12, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_23" (showCons x13))

d_C__case_22 :: FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_22 x14 x2 x1 x12 x15 cd cs = case x15 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons (d_C_showCurryExpr x1
    Curry_Prelude.C_False x2 x12 cd cs) (d_C_showCurryFiniteList x1 x2 x14 cd
    cs)
  Curry_Prelude.OP_Cons x16 x17 -> Curry_Prelude.d_C_error
    (Curry_Prelude.toCurryString
    "Internal error in FlatCurry.Show.showCurryFiniteList") cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_22 x14 x2 x1 x12
    l cd cs) (d_C__case_22 x14 x2 x1 x12 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_22 x14
    x2 x1 x12 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_22 x14 x2
    x1 x12 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_22" [show x14, show x2, show x1, show x12, show x15]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_22" (showCons x15))

nd_C__case_22 :: FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Int -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C__case_22 x14 x2 x1 x12 x15 s cd cs = case x15 of
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.OP_Cons (nd_C_showCurryExpr x1
    Curry_Prelude.C_False x2 x12 s0 cd cs) (nd_C_showCurryFiniteList x1 x2 x14
    s1 cd cs)))
  Curry_Prelude.OP_Cons x16 x17 -> Curry_Prelude.d_C_error
    (Curry_Prelude.toCurryString
    "Internal error in FlatCurry.Show.showCurryFiniteList") cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_22 x14 x2 x1
    x12 l s cd cs) (nd_C__case_22 x14 x2 x1 x12 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_22
    x14 x2 x1 x12 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_22 x14
    x2 x1 x12 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_22" [show x14, show x2, show x1, show x12, show x15]
    info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_22" (showCons x15))

d_C__case_26 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C__case_26 x7 cd cs = case x7 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x10 x11 -> Curry_Prelude.d_C_error
    (Curry_Prelude.toCurryString
    "Internal error in FlatCurry.Show.showCurryFiniteList") cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_26 l cd cs)
    (d_C__case_26 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_26 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_26 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_26" [show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_26" (showCons x7))

d_C__case_21 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_21 x2 x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Comb x3 x4 x5 -> d_C__case_20 x5 x4 cd cs
  FlatCurry.Curry_Types.C_Var x37 -> x2
  FlatCurry.Curry_Types.C_Lit x38 -> x2
  FlatCurry.Curry_Types.C_Let x39 x40 -> x2
  FlatCurry.Curry_Types.C_Free x41 x42 -> x2
  FlatCurry.Curry_Types.C_Or x43 x44 -> x2
  FlatCurry.Curry_Types.C_Case x45 x46 x47 -> x2
  FlatCurry.Curry_Types.C_Typed x48 x49 -> x2
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (d_C__case_21 x2 l
    cd cs) (d_C__case_21 x2 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    d_C__case_21 x2 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x -> d_C__case_21
    x2 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "FlatCurry.Show._case_21" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_21" (showCons x1))

d_C__case_20 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_20 x5 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> d_C__case_19 x6 x7 x5
    (Curry_Prelude.d_C_eqString x6 (Curry_Prelude.toCurryString "Prelude") cd
    cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_20 x5 l cd cs)
    (d_C__case_20 x5 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_20
    x5 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_20 x5 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Show._case_20" [show x5, show x4] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_20" (showCons x4))

d_C__case_19 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_19 x6 x7 x5 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_C__case_18 x7 x5 (Curry_Prelude.d_C_eqString x7
    (Curry_Prelude.toCurryString "[]") cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Internal error in FlatCurry.Show.showCurryStringConstant") cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_19 x6 x7 x5 l cd
    cs) (d_C__case_19 x6 x7 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_19 x6
    x7 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_19 x6 x7
    x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_19" [show x6, show x7, show x5, show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_19" (showCons x8))

d_C__case_18 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_18 x7 x5 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_C__case_17 x5 cd cs
  Curry_Prelude.C_False -> d_C__case_16 x7 x5 (Curry_Prelude.d_C_eqString x7
    (Curry_Prelude.toCurryString ":") cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_18 x7 x5 l cd cs)
    (d_C__case_18 x7 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_18 x7
    x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_18 x7 x5 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_18" [show x7, show x5, show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_18" (showCons x8))

d_C__case_16 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_16 x7 x5 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_C__case_15 x5 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Internal error in FlatCurry.Show.showCurryStringConstant") cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_16 x7 x5 l cd cs)
    (d_C__case_16 x7 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_16 x7
    x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_16 x7 x5 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_16" [show x7, show x5, show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_16" (showCons x8))

d_C__case_15 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_15 x5 cd cs = case x5 of
  Curry_Prelude.OP_Cons x10 x11 -> let x12 = Curry_Prelude.d_C_error
                                         (Curry_Prelude.toCurryString
                                         "Internal error in FlatCurry.Show.showCurryStringConstant")
                                         cd cs
    in d_C__case_14 x12 x11 x10 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Internal error in FlatCurry.Show.showCurryStringConstant") cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_15 l cd cs)
    (d_C__case_15 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_15 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_15 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_15" [show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_15" (showCons x5))

d_C__case_14 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_14 x12 x11 x10 cd cs = case x10 of
  FlatCurry.Curry_Types.C_Lit x13 -> let x14 = Curry_Prelude.d_C_error
                                           (Curry_Prelude.toCurryString
                                           "Internal error in FlatCurry.Show.showCurryStringConstant")
                                           cd cs
    in d_C__case_13 x14 x11 x13 cd cs
  FlatCurry.Curry_Types.C_Var x22 -> x12
  FlatCurry.Curry_Types.C_Comb x23 x24 x25 -> x12
  FlatCurry.Curry_Types.C_Let x26 x27 -> x12
  FlatCurry.Curry_Types.C_Free x28 x29 -> x12
  FlatCurry.Curry_Types.C_Or x30 x31 -> x12
  FlatCurry.Curry_Types.C_Case x32 x33 x34 -> x12
  FlatCurry.Curry_Types.C_Typed x35 x36 -> x12
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (d_C__case_14 x12
    x11 l cd cs) (d_C__case_14 x12 x11 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    d_C__case_14 x12 x11 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x -> d_C__case_14
    x12 x11 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "FlatCurry.Show._case_14" [show x12, show x11, show x10] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_14" (showCons x10))

d_C__case_13 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_Literal -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_13 x14 x11 x13 cd cs = case x13 of
  FlatCurry.Curry_Types.C_Charc x15 -> d_C__case_12 x15 x11 cd cs
  FlatCurry.Curry_Types.C_Intc x20 -> x14
  FlatCurry.Curry_Types.C_Floatc x21 -> x14
  FlatCurry.Curry_Types.Choice_C_Literal d i l r -> narrow d i (d_C__case_13 x14
    x11 l cd cs) (d_C__case_13 x14 x11 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Literal d i xs -> narrows cs d i (\z ->
    d_C__case_13 x14 x11 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Literal d c e -> guardCons d c ((\x ->
    d_C__case_13 x14 x11 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Literal d info -> failCons d (traceFail
    "FlatCurry.Show._case_13" [show x14, show x11, show x13] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_13" (showCons x13))

d_C__case_12 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_12 x15 x11 cd cs = case x11 of
  Curry_Prelude.OP_Cons x16 x17 -> d_C__case_11 x16 x15 x17 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Internal error in FlatCurry.Show.showCurryStringConstant") cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_12 x15 l cd cs)
    (d_C__case_12 x15 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_12 x15
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_12 x15 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_12" [show x15, show x11] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_12" (showCons x11))

d_C__case_11 :: FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_11 x16 x15 x17 cd cs = case x17 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_plus_plus
    (d_OP_showCurryStringConstant_dot_showChar_dot_212 x15 cd cs)
    (d_C_showCurryStringConstant x16 cd cs) cd cs
  Curry_Prelude.OP_Cons x18 x19 -> Curry_Prelude.d_C_error
    (Curry_Prelude.toCurryString
    "Internal error in FlatCurry.Show.showCurryStringConstant") cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_11 x16 x15 l cd
    cs) (d_C__case_11 x16 x15 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_11 x16
    x15 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_11 x16
    x15 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_11" [show x16, show x15, show x17] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_11" (showCons x17))

d_C__case_17 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_17 x5 cd cs = case x5 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x8 x9 -> Curry_Prelude.d_C_error
    (Curry_Prelude.toCurryString
    "Internal error in FlatCurry.Show.showCurryStringConstant") cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_17 l cd cs)
    (d_C__case_17 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_17 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_17 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Show._case_17" [show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_17" (showCons x5))

d_C__case_10 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_10 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "\\\""
  Curry_Prelude.C_False -> d_C__case_9 x1 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '\''#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_10 x1 x2 l cd cs)
    (d_C__case_10 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_10 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_10 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_10" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_10" (showCons x3))

d_C__case_9 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_9 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "\\'"
  Curry_Prelude.C_False -> d_C__case_8 x1 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char '\n'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_9 x1 x2 l cd cs)
    (d_C__case_9 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_9 x1 x2
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_9 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_9" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_9" (showCons x3))

d_C__case_8 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_8 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "\\n"
  Curry_Prelude.C_False -> d_C__case_7 x2 x1 (Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.C_Int (32)) cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.C_Int (126)) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x1 x2 l cd cs)
    (d_C__case_8 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x1 x2
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_8 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_8" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_8" (showCons x3))

d_C__case_7 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_7 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '\\'#)
    (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_chr
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_div_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.C_Int (100)) cd cs) (Curry_Prelude.C_Int
    (48)) cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_chr
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_div_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_mod_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.C_Int (100)) cd cs) cd cs)
    (Curry_Prelude.C_Int (10)) cd cs) (Curry_Prelude.C_Int (48)) cd cs) cd cs)
    (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_chr
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_mod_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.C_Int (10)) cd cs) (Curry_Prelude.C_Int
    (48)) cd cs) cd cs) Curry_Prelude.OP_List)))
  Curry_Prelude.C_False -> d_C__case_6 x1 (Curry_Prelude.d_C_otherwise cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x2 x1 l cd cs)
    (d_C__case_7 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x2 x1
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_7 x2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_7" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_7" (showCons x3))

d_C__case_6 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_6 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x1 l cd cs)
    (d_C__case_6 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_6" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_6" (showCons x2))

d_C__case_5 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_5 x6 x5 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.C_True
  Curry_Prelude.C_False -> d_C__case_4 x6 x5 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x5 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString ":")) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_C_length x6 cd cs) (Curry_Prelude.C_Int (2)) cd cs) cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x6 x5 l cd cs)
    (d_C__case_5 x6 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x6 x5
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x6 x5 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_5" [show x6, show x5, show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_5" (showCons x7))

d_C__case_4 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_4 x6 x5 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> d_C_isFiniteList (Curry_Prelude.d_OP_bang_bang x6
    (Curry_Prelude.C_Int (1)) cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_3 (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x6 x5 l cd cs)
    (d_C__case_4 x6 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x6 x5
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x6 x5 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_4" [show x6, show x5, show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_4" (showCons x7))

d_C__case_3 :: Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_3 x1 cd cs = case x1 of
  Curry_Prelude.C_True -> Curry_Prelude.C_False
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 l cd cs)
    (d_C__case_3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 z cd
    cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Show._case_3" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_3" (showCons x1))

d_C__case_2 :: Curry_Prelude.C_Bool -> FlatCurry.Curry_Types.C_Expr -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_2 x2 x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Comb x3 x4 x5 -> Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x4 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString "[]")) cd cs) (Curry_Prelude.d_C_null x5 cd cs)
    cd cs) (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash)
    x4 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString ":")) cd cs) (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_C_length x5 cd cs) (Curry_Prelude.C_Int (2)) cd cs)
    (Curry_Prelude.d_OP_amp_amp (d_C_isCharConstant (Curry_Prelude.d_C_head x5
    cd cs) cd cs) (d_C_isStringConstant (Curry_Prelude.d_OP_bang_bang x5
    (Curry_Prelude.C_Int (1)) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_Var x6 -> x2
  FlatCurry.Curry_Types.C_Lit x7 -> x2
  FlatCurry.Curry_Types.C_Let x8 x9 -> x2
  FlatCurry.Curry_Types.C_Free x10 x11 -> x2
  FlatCurry.Curry_Types.C_Or x12 x13 -> x2
  FlatCurry.Curry_Types.C_Case x14 x15 x16 -> x2
  FlatCurry.Curry_Types.C_Typed x17 x18 -> x2
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (d_C__case_2 x2 l cd
    cs) (d_C__case_2 x2 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    d_C__case_2 x2 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x -> d_C__case_2
    x2 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "FlatCurry.Show._case_2" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_2" (showCons x1))

d_C__case_1 :: Curry_Prelude.C_Bool -> FlatCurry.Curry_Types.C_Expr -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_1 x2 x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Lit x3 -> let x4 = Curry_Prelude.C_False
    in d_C__case_0 x4 x3 cd cs
  FlatCurry.Curry_Types.C_Var x8 -> x2
  FlatCurry.Curry_Types.C_Comb x9 x10 x11 -> x2
  FlatCurry.Curry_Types.C_Let x12 x13 -> x2
  FlatCurry.Curry_Types.C_Free x14 x15 -> x2
  FlatCurry.Curry_Types.C_Or x16 x17 -> x2
  FlatCurry.Curry_Types.C_Case x18 x19 x20 -> x2
  FlatCurry.Curry_Types.C_Typed x21 x22 -> x2
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (d_C__case_1 x2 l cd
    cs) (d_C__case_1 x2 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    d_C__case_1 x2 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c ((\x -> d_C__case_1
    x2 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "FlatCurry.Show._case_1" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_1" (showCons x1))

d_C__case_0 :: Curry_Prelude.C_Bool -> FlatCurry.Curry_Types.C_Literal -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_0 x4 x3 cd cs = case x3 of
  FlatCurry.Curry_Types.C_Charc x5 -> Curry_Prelude.C_True
  FlatCurry.Curry_Types.C_Intc x6 -> x4
  FlatCurry.Curry_Types.C_Floatc x7 -> x4
  FlatCurry.Curry_Types.Choice_C_Literal d i l r -> narrow d i (d_C__case_0 x4 l
    cd cs) (d_C__case_0 x4 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Literal d i xs -> narrows cs d i (\z ->
    d_C__case_0 x4 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Literal d c e -> guardCons d c ((\x ->
    d_C__case_0 x4 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Literal d info -> failCons d (traceFail
    "FlatCurry.Show._case_0" [show x4, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Show._case_0" (showCons x3))

