{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module FlatCurry.Typed.Curry_Goodies
  ( d_C_trTProg
  , nd_C_trTProg
  , d_C_tProgName
  , d_C_tProgImports
  , d_C_tProgTypes
  , d_C_tProgTFuncs
  , d_C_tProgOps
  , d_C_updTProg
  , nd_C_updTProg
  , d_C_updTProgName
  , nd_C_updTProgName
  , d_C_updTProgImports
  , nd_C_updTProgImports
  , d_C_updTProgTypes
  , nd_C_updTProgTypes
  , d_C_updTProgTFuncs
  , nd_C_updTProgTFuncs
  , d_C_updTProgOps
  , nd_C_updTProgOps
  , d_C_allVarsInTProg
  , d_C_updTProgTExps
  , nd_C_updTProgTExps
  , d_C_rnmAllVarsInTProg
  , nd_C_rnmAllVarsInTProg
  , d_C_updQNamesInTProg
  , nd_C_updQNamesInTProg
  , d_C_rnmTProg
  , d_C_trTFunc
  , nd_C_trTFunc
  , d_C_tFuncName
  , d_C_tFuncArity
  , d_C_tFuncVisibility
  , d_C_tFuncType
  , d_C_tFuncTRule
  , d_C_updTFunc
  , nd_C_updTFunc
  , d_C_updTFuncName
  , nd_C_updTFuncName
  , d_C_updTFuncArity
  , nd_C_updTFuncArity
  , d_C_updTFuncVisibility
  , nd_C_updTFuncVisibility
  , d_C_updFuncType
  , nd_C_updFuncType
  , d_C_updTFuncTRule
  , nd_C_updTFuncTRule
  , d_C_isPublicTFunc
  , d_C_isExternal
  , d_C_allVarsInTFunc
  , d_C_tFuncArgs
  , d_C_tFuncBody
  , d_C_tFuncRHS
  , d_C_rnmAllVarsInTFunc
  , nd_C_rnmAllVarsInTFunc
  , d_C_updQNamesInTFunc
  , nd_C_updQNamesInTFunc
  , d_C_updTFuncArgs
  , nd_C_updTFuncArgs
  , d_C_updTFuncBody
  , nd_C_updTFuncBody
  , d_C_trTRule
  , nd_C_trTRule
  , d_C_tRuleArgs
  , d_C_tRuleBody
  , d_C_tRuleExtDecl
  , d_C_isTRuleExternal
  , d_C_updTRule
  , nd_C_updTRule
  , d_C_updTRuleType
  , nd_C_updTRuleType
  , d_C_updTRuleArgs
  , nd_C_updTRuleArgs
  , d_C_updTRuleBody
  , nd_C_updTRuleBody
  , d_C_updTRuleExtDecl
  , nd_C_updTRuleExtDecl
  , d_C_allVarsInTRule
  , d_C_rnmAllVarsInTRule
  , nd_C_rnmAllVarsInTRule
  , d_C_updQNamesInTRule
  , nd_C_updQNamesInTRule
  , d_C_varNr
  , d_C_literal
  , d_C_combType
  , d_C_combName
  , d_C_combArgs
  , d_C_missingCombArgs
  , d_C_letBinds
  , d_C_letBody
  , d_C_freeVars
  , d_C_freeExpr
  , d_C_orExps
  , d_C_caseType
  , d_C_caseExpr
  , d_C_caseBranches
  , d_C_isTVarE
  , d_C_isTLit
  , d_C_isTComb
  , d_C_isTLet
  , d_C_isTFree
  , d_C_isTOr
  , d_C_isTCase
  , d_C_trTExpr
  , nd_C_trTExpr
  , d_C_updVars
  , nd_C_updVars
  , d_C_updLiterals
  , nd_C_updLiterals
  , d_C_updCombs
  , nd_C_updCombs
  , d_C_updLets
  , nd_C_updLets
  , d_C_updFrees
  , nd_C_updFrees
  , d_C_updOrs
  , nd_C_updOrs
  , d_C_updCases
  , nd_C_updCases
  , d_C_updBranches
  , nd_C_updBranches
  , d_C_updTypeds
  , nd_C_updTypeds
  , d_C_isFuncCall
  , d_C_isFuncPartCall
  , d_C_isConsCall
  , d_C_isConsPartCall
  , d_C_isGround
  , d_C_allVars
  , d_C_rnmAllVars
  , nd_C_rnmAllVars
  , d_C_updQNames
  , nd_C_updQNames
  , d_C_trTBranch
  , nd_C_trTBranch
  , d_C_tBranchTPattern
  , d_C_tBranchTExpr
  , d_C_updTBranch
  , nd_C_updTBranch
  , d_C_updTBranchTPattern
  , nd_C_updTBranchTPattern
  , d_C_updTBranchTExpr
  , nd_C_updTBranchTExpr
  , d_C_trTPattern
  , nd_C_trTPattern
  , d_C_tPatCons
  , d_C_tPatArgs
  , d_C_tPatLiteral
  , d_C_isConsPattern
  , d_C_updTPattern
  , nd_C_updTPattern
  , d_C_updTPatType
  , nd_C_updTPatType
  , d_C_updTPatCons
  , nd_C_updTPatCons
  , d_C_updTPatArgs
  , nd_C_updTPatArgs
  , d_C_updTPatLiteral
  , nd_C_updTPatLiteral
  , d_C_tPatExpr )
  where

import Basics
import qualified FlatCurry.Curry_Goodies
import qualified FlatCurry.Typed.Curry_Types
import qualified FlatCurry.Curry_Types
import qualified Curry_Prelude


d_C_trTProg :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List FlatCurry.Typed.Curry_Types.C_TFuncDecl
  -> Cover -> ConstStore -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_OpDecl
  -> Cover -> ConstStore -> t0) -> FlatCurry.Typed.Curry_Types.C_TProg -> Cover
  -> ConstStore -> t0
d_C_trTProg x1 x2 cd cs = case x2 of
  FlatCurry.Typed.Curry_Types.C_TProg x3 x4 x5 x6 x7 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x1 x3 cd cs) x4 cd cs) x5 cd cs) x6 cd cs) x7 cd cs
  FlatCurry.Typed.Curry_Types.Choice_C_TProg d i l r -> narrow d i (d_C_trTProg
    x1 l cd cs) (d_C_trTProg x1 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TProg d i xs -> narrows cs d i (\z ->
    d_C_trTProg x1 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TProg d c e -> guardCons d c ((\x ->
    d_C_trTProg x1 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TProg d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.trTProg" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.trTProg" (showCons x2))

nd_C_trTProg :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl) (Func (Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TFuncDecl) (Func (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl) t0)))) -> FlatCurry.Typed.Curry_Types.C_TProg
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_trTProg x1 x2 s cd cs = case x2 of
  FlatCurry.Typed.Curry_Types.C_TProg x3 x4 x5 x6 x7 -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                        s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x3 s0 cd cs) x4 s1 cd cs)) x5 s3 cd cs)) x6 s5 cd cs)) x7 s7 cd cs))
  FlatCurry.Typed.Curry_Types.Choice_C_TProg d i l r -> narrow d i (nd_C_trTProg
    x1 l s cd cs) (nd_C_trTProg x1 r s cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TProg d i xs -> narrows cs d i (\z ->
    nd_C_trTProg x1 z s cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TProg d c e -> guardCons d c ((\x ->
    nd_C_trTProg x1 e s cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TProg d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.trTProg" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.trTProg" (showCons x2))

d_C_tProgName :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TProg
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_tProgName cd cs = d_C_trTProg (acceptCs (acceptCs (acceptCs (acceptCs id)))
  d_OP_tProgName_dot_uscore_hash_lambda1)

d_OP_tProgName_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl -> Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_tProgName_dot_uscore_hash_lambda1 x1 x2 x3 x4 x5 cd cs = x1

d_C_tProgImports :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TProg
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C_tProgImports cd cs = d_C_trTProg (acceptCs (acceptCs (acceptCs (acceptCs
  id))) d_OP_tProgImports_dot_uscore_hash_lambda2)

d_OP_tProgImports_dot_uscore_hash_lambda2 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl -> Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_tProgImports_dot_uscore_hash_lambda2 x1 x2 x3 x4 x5 cd cs = x2

d_C_tProgTypes :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TProg
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl
d_C_tProgTypes cd cs = d_C_trTProg (acceptCs (acceptCs (acceptCs (acceptCs id)))
  d_OP_tProgTypes_dot_uscore_hash_lambda3)

d_OP_tProgTypes_dot_uscore_hash_lambda3 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl -> Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl -> Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl
d_OP_tProgTypes_dot_uscore_hash_lambda3 x1 x2 x3 x4 x5 cd cs = x3

d_C_tProgTFuncs :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TProg
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TFuncDecl
d_C_tProgTFuncs cd cs = d_C_trTProg (acceptCs (acceptCs (acceptCs (acceptCs
  id))) d_OP_tProgTFuncs_dot_uscore_hash_lambda4)

d_OP_tProgTFuncs_dot_uscore_hash_lambda4 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl -> Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl -> Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TFuncDecl
d_OP_tProgTFuncs_dot_uscore_hash_lambda4 x1 x2 x3 x4 x5 cd cs = x4

d_C_tProgOps :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TProg
  -> Cover -> ConstStore -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_OpDecl
d_C_tProgOps cd cs = d_C_trTProg (acceptCs (acceptCs (acceptCs (acceptCs id)))
  d_OP_tProgOps_dot_uscore_hash_lambda5)

d_OP_tProgOps_dot_uscore_hash_lambda5 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl -> Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl -> Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl
d_OP_tProgOps_dot_uscore_hash_lambda5 x1 x2 x3 x4 x5 cd cs = x5

d_C_updTProg :: (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeDecl)
  -> (Curry_Prelude.OP_List FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TFuncDecl) -> (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl -> Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TProg -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TProg
d_C_updTProg x1 x2 x3 x4 x5 cd cs = d_C_trTProg (acceptCs (acceptCs (acceptCs
  (acceptCs id))) (d_OP_updTProg_dot_prog_dot_39 x4 x5 x3 x1 x2))

nd_C_updTProg :: Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Func (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl) -> Func (Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TFuncDecl) (Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TFuncDecl) -> Func (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl) -> IDSupply -> Cover -> ConstStore -> Func
  FlatCurry.Typed.Curry_Types.C_TProg FlatCurry.Typed.Curry_Types.C_TProg
nd_C_updTProg x1 x2 x3 x4 x5 s cd cs = wrapNX id (nd_C_trTProg (wrapDX (wrapDX
  (wrapDX (wrapDX (wrapNX id)))) (acceptCs (acceptCs (acceptCs (acceptCs id)))
  (nd_OP_updTProg_dot_prog_dot_39 x4 x5 x3 x1 x2))))

d_OP_updTProg_dot_prog_dot_39 :: (Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List FlatCurry.Typed.Curry_Types.C_TFuncDecl)
  -> (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_OpDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_OpDecl)
  -> (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeDecl)
  -> (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl -> Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TProg
d_OP_updTProg_dot_prog_dot_39 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 cd cs =
  FlatCurry.Typed.Curry_Types.C_TProg (Curry_Prelude.d_C_apply x4 x6 cd cs)
  (Curry_Prelude.d_C_apply x5 x7 cd cs) (Curry_Prelude.d_C_apply x3 x8 cd cs)
  (Curry_Prelude.d_C_apply x1 x9 cd cs) (Curry_Prelude.d_C_apply x2 x10 cd cs)

nd_OP_updTProg_dot_prog_dot_39 :: Func (Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TFuncDecl) (Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TFuncDecl) -> Func (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl) -> Func (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl) -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl -> Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl -> IDSupply -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TProg
nd_OP_updTProg_dot_prog_dot_39 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 s cd cs =
  let s5 = s
  in s5 `seq` (let s6 = leftSupply s5
                   s7 = rightSupply s5
                   s0 = leftSupply s6
                   s1 = rightSupply s6
                   s2 = leftSupply s7
                   s8 = rightSupply s7
                   s3 = leftSupply s8
                   s4 = rightSupply s8
  in s6 `seq` (s7 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s8 `seq` (s3 `seq`
  (s4 `seq` FlatCurry.Typed.Curry_Types.C_TProg (Curry_Prelude.nd_C_apply x4 x6
  s0 cd cs) (Curry_Prelude.nd_C_apply x5 x7 s1 cd cs) (Curry_Prelude.nd_C_apply
  x3 x8 s2 cd cs) (Curry_Prelude.nd_C_apply x1 x9 s3 cd cs)
  (Curry_Prelude.nd_C_apply x2 x10 s4 cd cs)))))))))

d_C_updTProgName :: (Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TProg -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TProg
d_C_updTProgName x1 cd cs = d_C_updTProg x1 Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id Curry_Prelude.d_C_id cd cs

nd_C_updTProgName :: Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover
  -> ConstStore -> Func FlatCurry.Typed.Curry_Types.C_TProg
  FlatCurry.Typed.Curry_Types.C_TProg
nd_C_updTProgName x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updTProg x1 (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) s0 cd cs

d_C_updTProgImports :: (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TProg -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TProg
d_C_updTProgImports x1 cd cs = d_C_updTProg Curry_Prelude.d_C_id x1
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id Curry_Prelude.d_C_id cd cs

nd_C_updTProgImports :: Func (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore -> Func
  FlatCurry.Typed.Curry_Types.C_TProg FlatCurry.Typed.Curry_Types.C_TProg
nd_C_updTProgImports x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updTProg (wrapDX id Curry_Prelude.d_C_id) x1 (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) s0 cd cs

d_C_updTProgTypes :: (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeDecl
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TProg -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TProg
d_C_updTProgTypes x1 cd cs = d_C_updTProg Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id x1 Curry_Prelude.d_C_id Curry_Prelude.d_C_id cd cs

nd_C_updTProgTypes :: Func (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl) -> IDSupply -> Cover -> ConstStore -> Func
  FlatCurry.Typed.Curry_Types.C_TProg FlatCurry.Typed.Curry_Types.C_TProg
nd_C_updTProgTypes x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updTProg (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) x1 (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) s0 cd cs

d_C_updTProgTFuncs :: (Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List FlatCurry.Typed.Curry_Types.C_TFuncDecl) -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TProg -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TProg
d_C_updTProgTFuncs x1 cd cs = d_C_updTProg Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id x1 Curry_Prelude.d_C_id cd cs

nd_C_updTProgTFuncs :: Func (Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TFuncDecl) (Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TFuncDecl) -> IDSupply -> Cover -> ConstStore
  -> Func FlatCurry.Typed.Curry_Types.C_TProg
  FlatCurry.Typed.Curry_Types.C_TProg
nd_C_updTProgTFuncs x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updTProg (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) x1 (wrapDX id
  Curry_Prelude.d_C_id) s0 cd cs

d_C_updTProgOps :: Cover -> ConstStore -> (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl -> Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TProg -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TProg
d_C_updTProgOps cd cs = d_C_updTProg Curry_Prelude.d_C_id Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id

nd_C_updTProgOps :: IDSupply -> Cover -> ConstStore -> Func (Func
  (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_OpDecl) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl)) (Func FlatCurry.Typed.Curry_Types.C_TProg
  FlatCurry.Typed.Curry_Types.C_TProg)
nd_C_updTProgOps s cd cs = wrapNX id (nd_C_updTProg (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id))

d_C_allVarsInTProg :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TProg
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
d_C_allVarsInTProg cd cs = Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_concatMap
  (d_C_allVarsInTFunc cd cs) cd cs) (d_C_tProgTFuncs cd cs) cd cs

d_C_updTProgTExps :: Cover -> ConstStore -> (FlatCurry.Typed.Curry_Types.C_TExpr
  -> Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TExpr) -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TProg -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TProg
d_C_updTProgTExps cd cs = Curry_Prelude.d_OP_dot d_C_updTProgTFuncs
  (Curry_Prelude.d_OP_dot (acceptCs id Curry_Prelude.d_C_map) (d_C_updTFuncBody
  cd cs) cd cs) cd cs

nd_C_updTProgTExps :: IDSupply -> Cover -> ConstStore -> Func (Func
  FlatCurry.Typed.Curry_Types.C_TExpr FlatCurry.Typed.Curry_Types.C_TExpr) (Func
  FlatCurry.Typed.Curry_Types.C_TProg FlatCurry.Typed.Curry_Types.C_TProg)
nd_C_updTProgTExps s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dot (wrapNX id nd_C_updTProgTFuncs)
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX (wrapNX id) (acceptCs id
  Curry_Prelude.nd_C_map)) (nd_C_updTFuncBody s0 cd cs) s1 cd cs)) s3 cd cs))

d_C_rnmAllVarsInTProg :: Cover -> ConstStore -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TProg -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TProg
d_C_rnmAllVarsInTProg cd cs = Curry_Prelude.d_OP_dot d_C_updTProgTFuncs
  (Curry_Prelude.d_OP_dot (acceptCs id Curry_Prelude.d_C_map)
  (d_C_rnmAllVarsInTFunc cd cs) cd cs) cd cs

nd_C_rnmAllVarsInTProg :: IDSupply -> Cover -> ConstStore -> Func (Func
  Curry_Prelude.C_Int Curry_Prelude.C_Int) (Func
  FlatCurry.Typed.Curry_Types.C_TProg FlatCurry.Typed.Curry_Types.C_TProg)
nd_C_rnmAllVarsInTProg s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dot (wrapNX id nd_C_updTProgTFuncs)
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX (wrapNX id) (acceptCs id
  Curry_Prelude.nd_C_map)) (nd_C_rnmAllVarsInTFunc s0 cd cs) s1 cd cs)) s3 cd
  cs))

d_C_updQNamesInTProg :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TProg -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TProg
d_C_updQNamesInTProg x1 cd cs = d_C_updTProg Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id (Curry_Prelude.d_C_map
  (FlatCurry.Curry_Goodies.d_C_updQNamesInType x1 cd cs)) (Curry_Prelude.d_C_map
  (d_C_updQNamesInTFunc x1 cd cs)) (Curry_Prelude.d_C_map
  (FlatCurry.Curry_Goodies.d_C_updOpName x1 cd cs)) cd cs

nd_C_updQNamesInTProg :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Func FlatCurry.Typed.Curry_Types.C_TProg
  FlatCurry.Typed.Curry_Types.C_TProg
nd_C_updQNamesInTProg x1 s cd cs = let s4 = s
  in s4 `seq` (let s5 = leftSupply s4
                   s6 = rightSupply s4
                   s3 = leftSupply s5
                   s0 = rightSupply s5
                   s1 = leftSupply s6
                   s2 = rightSupply s6
  in s5 `seq` (s6 `seq` (s3 `seq` (s0 `seq` (s1 `seq` (s2 `seq` nd_C_updTProg
  (wrapDX id Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) (wrapNX id
  (Curry_Prelude.nd_C_map (FlatCurry.Curry_Goodies.nd_C_updQNamesInType x1 s0 cd
  cs))) (wrapNX id (Curry_Prelude.nd_C_map (nd_C_updQNamesInTFunc x1 s1 cd cs)))
  (wrapNX id (Curry_Prelude.nd_C_map (FlatCurry.Curry_Goodies.nd_C_updOpName x1
  s2 cd cs))) s3 cd cs))))))

d_C_rnmTProg :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> FlatCurry.Typed.Curry_Types.C_TProg -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TProg
d_C_rnmTProg x1 x2 cd cs = Curry_Prelude.d_C_apply (d_C_updTProgName
  (Curry_Prelude.d_C_const x1) cd cs) (Curry_Prelude.d_C_apply
  (d_C_updQNamesInTProg (d_OP_rnmTProg_dot_rnm_dot_61 x2 x1) cd cs) x2 cd cs) cd
  cs

d_OP_rnmTProg_dot_rnm_dot_61 :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Typed.Curry_Types.C_TProg -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0
d_OP_rnmTProg_dot_rnm_dot_61 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_32 x1 x4 x5 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x4 (Curry_Prelude.d_C_apply (d_C_tProgName cd cs) x1 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_rnmTProg_dot_rnm_dot_61 x1 x2 l cd cs) (d_OP_rnmTProg_dot_rnm_dot_61
    x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_rnmTProg_dot_rnm_dot_61 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_rnmTProg_dot_rnm_dot_61 x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.rnmTProg.rnm.61" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.rnmTProg.rnm.61" (showCons
    x3))

d_C_trTFunc :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> FlatCurry.Curry_Types.C_Visibility -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule -> Cover -> ConstStore -> t0)
  -> FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Cover -> ConstStore -> t0
d_C_trTFunc x1 x2 cd cs = case x2 of
  FlatCurry.Typed.Curry_Types.C_TFunc x3 x4 x5 x6 x7 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x1 x3 cd cs) x4 cd cs) x5 cd cs) x6 cd cs) x7 cd cs
  FlatCurry.Typed.Curry_Types.Choice_C_TFuncDecl d i l r -> narrow d i
    (d_C_trTFunc x1 l cd cs) (d_C_trTFunc x1 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TFuncDecl d i xs -> narrows cs d i
    (\z -> d_C_trTFunc x1 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TFuncDecl d c e -> guardCons d c ((\x ->
    d_C_trTFunc x1 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TFuncDecl d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.trTFunc" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.trTFunc" (showCons x2))

nd_C_trTFunc :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func Curry_Prelude.C_Int (Func
  FlatCurry.Curry_Types.C_Visibility (Func FlatCurry.Curry_Types.C_TypeExpr
  (Func FlatCurry.Typed.Curry_Types.C_TRule t0))))
  -> FlatCurry.Typed.Curry_Types.C_TFuncDecl -> IDSupply -> Cover -> ConstStore
  -> t0
nd_C_trTFunc x1 x2 s cd cs = case x2 of
  FlatCurry.Typed.Curry_Types.C_TFunc x3 x4 x5 x6 x7 -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (let s5 = leftSupply s6
                                                        s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x3 s0 cd cs) x4 s1 cd cs)) x5 s3 cd cs)) x6 s5 cd cs)) x7 s7 cd cs))
  FlatCurry.Typed.Curry_Types.Choice_C_TFuncDecl d i l r -> narrow d i
    (nd_C_trTFunc x1 l s cd cs) (nd_C_trTFunc x1 r s cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TFuncDecl d i xs -> narrows cs d i
    (\z -> nd_C_trTFunc x1 z s cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TFuncDecl d c e -> guardCons d c ((\x ->
    nd_C_trTFunc x1 e s cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TFuncDecl d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.trTFunc" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.trTFunc" (showCons x2))

d_C_tFuncName :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TFuncDecl
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_tFuncName cd cs = d_C_trTFunc (acceptCs (acceptCs (acceptCs (acceptCs id)))
  d_OP_tFuncName_dot_uscore_hash_lambda6)

d_OP_tFuncName_dot_uscore_hash_lambda6 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_Visibility -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Typed.Curry_Types.C_TRule -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_tFuncName_dot_uscore_hash_lambda6 x1 x2 x3 x4 x5 cd cs = x1

d_C_tFuncArity :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TFuncDecl
  -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_tFuncArity cd cs = d_C_trTFunc (acceptCs (acceptCs (acceptCs (acceptCs id)))
  d_OP_tFuncArity_dot_uscore_hash_lambda7)

d_OP_tFuncArity_dot_uscore_hash_lambda7 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_Visibility -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Typed.Curry_Types.C_TRule -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_OP_tFuncArity_dot_uscore_hash_lambda7 x1 x2 x3 x4 x5 cd cs = x2

d_C_tFuncVisibility :: Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Visibility
d_C_tFuncVisibility cd cs = d_C_trTFunc (acceptCs (acceptCs (acceptCs (acceptCs
  id))) d_OP_tFuncVisibility_dot_uscore_hash_lambda8)

d_OP_tFuncVisibility_dot_uscore_hash_lambda8 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_Visibility -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Typed.Curry_Types.C_TRule -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Visibility
d_OP_tFuncVisibility_dot_uscore_hash_lambda8 x1 x2 x3 x4 x5 cd cs = x3

d_C_tFuncType :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TFuncDecl
  -> Cover -> ConstStore -> FlatCurry.Curry_Types.C_TypeExpr
d_C_tFuncType cd cs = d_C_trTFunc (acceptCs (acceptCs (acceptCs (acceptCs id)))
  d_OP_tFuncType_dot_uscore_hash_lambda9)

d_OP_tFuncType_dot_uscore_hash_lambda9 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_Visibility -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Typed.Curry_Types.C_TRule -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeExpr
d_OP_tFuncType_dot_uscore_hash_lambda9 x1 x2 x3 x4 x5 cd cs = x4

d_C_tFuncTRule :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TFuncDecl
  -> Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TRule
d_C_tFuncTRule cd cs = d_C_trTFunc (acceptCs (acceptCs (acceptCs (acceptCs id)))
  d_OP_tFuncTRule_dot_uscore_hash_lambda10)

d_OP_tFuncTRule_dot_uscore_hash_lambda10 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_Visibility -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Typed.Curry_Types.C_TRule -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule
d_OP_tFuncTRule_dot_uscore_hash_lambda10 x1 x2 x3 x4 x5 cd cs = x5

d_C_updTFunc :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_Int)
  -> (FlatCurry.Curry_Types.C_Visibility -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Visibility) -> (FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> FlatCurry.Curry_Types.C_TypeExpr)
  -> (FlatCurry.Typed.Curry_Types.C_TRule -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TFuncDecl
d_C_updTFunc x1 x2 x3 x4 x5 cd cs = d_C_trTFunc (acceptCs (acceptCs (acceptCs
  (acceptCs id))) (d_OP_updTFunc_dot_func_dot_102 x5 x4 x3 x2 x1))

nd_C_updTFunc :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Func Curry_Prelude.C_Int
  Curry_Prelude.C_Int -> Func FlatCurry.Curry_Types.C_Visibility
  FlatCurry.Curry_Types.C_Visibility -> Func FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Func FlatCurry.Typed.Curry_Types.C_TRule
  FlatCurry.Typed.Curry_Types.C_TRule -> IDSupply -> Cover -> ConstStore -> Func
  FlatCurry.Typed.Curry_Types.C_TFuncDecl
  FlatCurry.Typed.Curry_Types.C_TFuncDecl
nd_C_updTFunc x1 x2 x3 x4 x5 s cd cs = wrapNX id (nd_C_trTFunc (wrapDX (wrapDX
  (wrapDX (wrapDX (wrapNX id)))) (acceptCs (acceptCs (acceptCs (acceptCs id)))
  (nd_OP_updTFunc_dot_func_dot_102 x5 x4 x3 x2 x1))))

d_OP_updTFunc_dot_func_dot_102 :: (FlatCurry.Typed.Curry_Types.C_TRule -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TRule)
  -> (FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeExpr) -> (FlatCurry.Curry_Types.C_Visibility
  -> Cover -> ConstStore -> FlatCurry.Curry_Types.C_Visibility)
  -> (Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_Int)
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_Visibility -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Typed.Curry_Types.C_TRule -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TFuncDecl
d_OP_updTFunc_dot_func_dot_102 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 cd cs =
  FlatCurry.Typed.Curry_Types.C_TFunc (Curry_Prelude.d_C_apply x5 x6 cd cs)
  (Curry_Prelude.d_C_apply x4 x7 cd cs) (Curry_Prelude.d_C_apply x3 x8 cd cs)
  (Curry_Prelude.d_C_apply x2 x9 cd cs) (Curry_Prelude.d_C_apply x1 x10 cd cs)

nd_OP_updTFunc_dot_func_dot_102 :: Func FlatCurry.Typed.Curry_Types.C_TRule
  FlatCurry.Typed.Curry_Types.C_TRule -> Func FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Func FlatCurry.Curry_Types.C_Visibility
  FlatCurry.Curry_Types.C_Visibility -> Func Curry_Prelude.C_Int
  Curry_Prelude.C_Int -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_Visibility -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Typed.Curry_Types.C_TRule -> IDSupply -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TFuncDecl
nd_OP_updTFunc_dot_func_dot_102 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 s cd cs =
  let s5 = s
  in s5 `seq` (let s6 = leftSupply s5
                   s7 = rightSupply s5
                   s0 = leftSupply s6
                   s1 = rightSupply s6
                   s2 = leftSupply s7
                   s8 = rightSupply s7
                   s3 = leftSupply s8
                   s4 = rightSupply s8
  in s6 `seq` (s7 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s8 `seq` (s3 `seq`
  (s4 `seq` FlatCurry.Typed.Curry_Types.C_TFunc (Curry_Prelude.nd_C_apply x5 x6
  s0 cd cs) (Curry_Prelude.nd_C_apply x4 x7 s1 cd cs) (Curry_Prelude.nd_C_apply
  x3 x8 s2 cd cs) (Curry_Prelude.nd_C_apply x2 x9 s3 cd cs)
  (Curry_Prelude.nd_C_apply x1 x10 s4 cd cs)))))))))

d_C_updTFuncName :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TFuncDecl
d_C_updTFuncName x1 cd cs = d_C_updTFunc x1 Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id Curry_Prelude.d_C_id cd cs

nd_C_updTFuncName :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Func FlatCurry.Typed.Curry_Types.C_TFuncDecl
  FlatCurry.Typed.Curry_Types.C_TFuncDecl
nd_C_updTFuncName x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updTFunc x1 (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) s0 cd cs

d_C_updTFuncArity :: (Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TFuncDecl
d_C_updTFuncArity x1 cd cs = d_C_updTFunc Curry_Prelude.d_C_id x1
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id Curry_Prelude.d_C_id cd cs

nd_C_updTFuncArity :: Func Curry_Prelude.C_Int Curry_Prelude.C_Int -> IDSupply
  -> Cover -> ConstStore -> Func FlatCurry.Typed.Curry_Types.C_TFuncDecl
  FlatCurry.Typed.Curry_Types.C_TFuncDecl
nd_C_updTFuncArity x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updTFunc (wrapDX id Curry_Prelude.d_C_id) x1 (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) s0 cd cs

d_C_updTFuncVisibility :: (FlatCurry.Curry_Types.C_Visibility -> Cover
  -> ConstStore -> FlatCurry.Curry_Types.C_Visibility) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TFuncDecl
d_C_updTFuncVisibility x1 cd cs = d_C_updTFunc Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id x1 Curry_Prelude.d_C_id Curry_Prelude.d_C_id cd cs

nd_C_updTFuncVisibility :: Func FlatCurry.Curry_Types.C_Visibility
  FlatCurry.Curry_Types.C_Visibility -> IDSupply -> Cover -> ConstStore -> Func
  FlatCurry.Typed.Curry_Types.C_TFuncDecl
  FlatCurry.Typed.Curry_Types.C_TFuncDecl
nd_C_updTFuncVisibility x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updTFunc (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) x1 (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) s0 cd cs

d_C_updFuncType :: (FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TFuncDecl
d_C_updFuncType x1 cd cs = d_C_updTFunc Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id x1 Curry_Prelude.d_C_id cd cs

nd_C_updFuncType :: Func FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  FlatCurry.Typed.Curry_Types.C_TFuncDecl
  FlatCurry.Typed.Curry_Types.C_TFuncDecl
nd_C_updFuncType x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updTFunc (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) x1 (wrapDX id
  Curry_Prelude.d_C_id) s0 cd cs

d_C_updTFuncTRule :: Cover -> ConstStore -> (FlatCurry.Typed.Curry_Types.C_TRule
  -> Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TRule) -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TFuncDecl
d_C_updTFuncTRule cd cs = d_C_updTFunc Curry_Prelude.d_C_id Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id

nd_C_updTFuncTRule :: IDSupply -> Cover -> ConstStore -> Func (Func
  FlatCurry.Typed.Curry_Types.C_TRule FlatCurry.Typed.Curry_Types.C_TRule) (Func
  FlatCurry.Typed.Curry_Types.C_TFuncDecl
  FlatCurry.Typed.Curry_Types.C_TFuncDecl)
nd_C_updTFuncTRule s cd cs = wrapNX id (nd_C_updTFunc (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id))

d_C_isPublicTFunc :: Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isPublicTFunc cd cs = Curry_Prelude.d_OP_dot
  d_OP_isPublicTFunc_dot_isPublic_dot_116 (d_C_tFuncVisibility cd cs) cd cs

d_OP_isPublicTFunc_dot_isPublic_dot_116 :: FlatCurry.Curry_Types.C_Visibility
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_isPublicTFunc_dot_isPublic_dot_116 x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Public -> Curry_Prelude.C_True
  FlatCurry.Curry_Types.C_Private -> Curry_Prelude.C_False
  FlatCurry.Curry_Types.Choice_C_Visibility d i l r -> narrow d i
    (d_OP_isPublicTFunc_dot_isPublic_dot_116 l cd cs)
    (d_OP_isPublicTFunc_dot_isPublic_dot_116 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Visibility d i xs -> narrows cs d i (\z ->
    d_OP_isPublicTFunc_dot_isPublic_dot_116 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Visibility d c e -> guardCons d c ((\x ->
    d_OP_isPublicTFunc_dot_isPublic_dot_116 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Visibility d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.isPublicTFunc.isPublic.116" [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Typed.Goodies.isPublicTFunc.isPublic.116" (showCons x1))

d_C_isExternal :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TFuncDecl
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isExternal cd cs = Curry_Prelude.d_OP_dot (d_C_isTRuleExternal cd cs)
  (d_C_tFuncTRule cd cs) cd cs

d_C_allVarsInTFunc :: Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
d_C_allVarsInTFunc cd cs = Curry_Prelude.d_OP_dot (d_C_allVarsInTRule cd cs)
  (d_C_tFuncTRule cd cs) cd cs

d_C_tFuncArgs :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TFuncDecl
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
d_C_tFuncArgs cd cs = Curry_Prelude.d_OP_dot (d_C_tRuleArgs cd cs)
  (d_C_tFuncTRule cd cs) cd cs

d_C_tFuncBody :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TFuncDecl
  -> Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C_tFuncBody cd cs = Curry_Prelude.d_OP_dot (d_C_tRuleBody cd cs)
  (d_C_tFuncTRule cd cs) cd cs

d_C_tFuncRHS :: FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List FlatCurry.Typed.Curry_Types.C_TExpr
d_C_tFuncRHS x1 cd cs = d_C__case_30 x1 (Curry_Prelude.d_C_not
  (Curry_Prelude.d_C_apply (d_C_isExternal cd cs) x1 cd cs) cd cs) cd cs

d_OP_tFuncRHS_dot_orCase_dot_130 :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List FlatCurry.Typed.Curry_Types.C_TExpr
d_OP_tFuncRHS_dot_orCase_dot_130 x1 cd cs = d_C__case_28 x1 (d_C_isTOr x1 cd cs)
  cd cs

d_C_rnmAllVarsInTFunc :: Cover -> ConstStore -> (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TFuncDecl
d_C_rnmAllVarsInTFunc cd cs = Curry_Prelude.d_OP_dot (d_C_updTFunc
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id) d_C_rnmAllVarsInTRule cd cs

nd_C_rnmAllVarsInTFunc :: IDSupply -> Cover -> ConstStore -> Func (Func
  Curry_Prelude.C_Int Curry_Prelude.C_Int) (Func
  FlatCurry.Typed.Curry_Types.C_TFuncDecl
  FlatCurry.Typed.Curry_Types.C_TFuncDecl)
nd_C_rnmAllVarsInTFunc s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapNX id (nd_C_updTFunc (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id))) (wrapNX id
  nd_C_rnmAllVarsInTRule) s0 cd cs

d_C_updQNamesInTFunc :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TFuncDecl
d_C_updQNamesInTFunc x1 cd cs = d_C_updTFunc x1 Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id (FlatCurry.Curry_Goodies.d_C_updQNamesInTypeExpr x1 cd
  cs) (Curry_Prelude.d_C_apply (d_C_updQNamesInTRule cd cs) x1 cd cs) cd cs

nd_C_updQNamesInTFunc :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Func FlatCurry.Typed.Curry_Types.C_TFuncDecl
  FlatCurry.Typed.Curry_Types.C_TFuncDecl
nd_C_updQNamesInTFunc x1 s cd cs = let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s0 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` nd_C_updTFunc x1 (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id)
  (FlatCurry.Curry_Goodies.nd_C_updQNamesInTypeExpr x1 s0 cd cs)
  (let s2 = leftSupply s3
       s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (nd_C_updQNamesInTRule s1 cd
  cs) x1 s2 cd cs)) s4 cd cs))))

d_C_updTFuncArgs :: Cover -> ConstStore -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TFuncDecl
d_C_updTFuncArgs cd cs = Curry_Prelude.d_OP_dot (d_C_updTFuncTRule cd cs)
  d_C_updTRuleArgs cd cs

nd_C_updTFuncArgs :: IDSupply -> Cover -> ConstStore -> Func (Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))) (Func
  FlatCurry.Typed.Curry_Types.C_TFuncDecl
  FlatCurry.Typed.Curry_Types.C_TFuncDecl)
nd_C_updTFuncArgs s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (nd_C_updTFuncTRule s0 cd cs)
  (wrapNX id nd_C_updTRuleArgs) s1 cd cs))

d_C_updTFuncBody :: Cover -> ConstStore -> (FlatCurry.Typed.Curry_Types.C_TExpr
  -> Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TExpr) -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TFuncDecl
d_C_updTFuncBody cd cs = Curry_Prelude.d_OP_dot (d_C_updTFuncTRule cd cs)
  d_C_updTRuleBody cd cs

nd_C_updTFuncBody :: IDSupply -> Cover -> ConstStore -> Func (Func
  FlatCurry.Typed.Curry_Types.C_TExpr FlatCurry.Typed.Curry_Types.C_TExpr) (Func
  FlatCurry.Typed.Curry_Types.C_TFuncDecl
  FlatCurry.Typed.Curry_Types.C_TFuncDecl)
nd_C_updTFuncBody s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (nd_C_updTFuncTRule s0 cd cs)
  (wrapNX id nd_C_updTRuleBody) s1 cd cs))

d_C_trTRule :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover
  -> ConstStore -> t0) -> (FlatCurry.Curry_Types.C_TypeExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> t0) -> FlatCurry.Typed.Curry_Types.C_TRule -> Cover
  -> ConstStore -> t0
d_C_trTRule x1 x2 x3 cd cs = case x3 of
  FlatCurry.Typed.Curry_Types.C_TRule x4 x5 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x1 x4 cd cs) x5 cd cs
  FlatCurry.Typed.Curry_Types.C_TExternal x6 x7 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x2 x6 cd cs) x7 cd cs
  FlatCurry.Typed.Curry_Types.Choice_C_TRule d i l r -> narrow d i (d_C_trTRule
    x1 x2 l cd cs) (d_C_trTRule x1 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TRule d i xs -> narrows cs d i (\z ->
    d_C_trTRule x1 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TRule d c e -> guardCons d c ((\x ->
    d_C_trTRule x1 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TRule d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.trTRule" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.trTRule" (showCons x3))

nd_C_trTRule :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Func FlatCurry.Typed.Curry_Types.C_TExpr
  t0) -> Func FlatCurry.Curry_Types.C_TypeExpr (Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0) -> FlatCurry.Typed.Curry_Types.C_TRule -> IDSupply
  -> Cover -> ConstStore -> t0
nd_C_trTRule x1 x2 x3 s cd cs = case x3 of
  FlatCurry.Typed.Curry_Types.C_TRule x4 x5 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x4 s0 cd cs) x5 s1 cd cs))
  FlatCurry.Typed.Curry_Types.C_TExternal x6 x7 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2
    x6 s0 cd cs) x7 s1 cd cs))
  FlatCurry.Typed.Curry_Types.Choice_C_TRule d i l r -> narrow d i (nd_C_trTRule
    x1 x2 l s cd cs) (nd_C_trTRule x1 x2 r s cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TRule d i xs -> narrows cs d i (\z ->
    nd_C_trTRule x1 x2 z s cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TRule d c e -> guardCons d c ((\x ->
    nd_C_trTRule x1 x2 e s cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TRule d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.trTRule" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.trTRule" (showCons x3))

d_C_tRuleArgs :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TRule
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
d_C_tRuleArgs cd cs = d_C_trTRule (acceptCs id Curry_Prelude.d_C_const)
  (Curry_Prelude.d_C_error (Curry_Prelude.toCurryString "undefined") cd cs)

d_C_tRuleBody :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TRule
  -> Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C_tRuleBody cd cs = d_C_trTRule (acceptCs id
  d_OP_tRuleBody_dot_uscore_hash_lambda11) (Curry_Prelude.d_C_error
  (Curry_Prelude.toCurryString "undefined") cd cs)

d_OP_tRuleBody_dot_uscore_hash_lambda11 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_OP_tRuleBody_dot_uscore_hash_lambda11 x1 x2 cd cs = x2

d_C_tRuleExtDecl :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TRule
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_tRuleExtDecl cd cs = d_C_trTRule (Curry_Prelude.d_C_error
  (Curry_Prelude.toCurryString "undefined") cd cs) (acceptCs id
  d_OP_tRuleExtDecl_dot_uscore_hash_lambda12)

d_OP_tRuleExtDecl_dot_uscore_hash_lambda12 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_tRuleExtDecl_dot_uscore_hash_lambda12 x1 x2 cd cs = x2

d_C_isTRuleExternal :: Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isTRuleExternal cd cs = d_C_trTRule (acceptCs id
  d_OP_isTRuleExternal_dot_uscore_hash_lambda13) (acceptCs id
  d_OP_isTRuleExternal_dot_uscore_hash_lambda14)

d_OP_isTRuleExternal_dot_uscore_hash_lambda13 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_OP_isTRuleExternal_dot_uscore_hash_lambda13 x1 x2 cd cs =
  Curry_Prelude.C_False

d_OP_isTRuleExternal_dot_uscore_hash_lambda14 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_OP_isTRuleExternal_dot_uscore_hash_lambda14 x1 x2 cd cs = Curry_Prelude.C_True

d_C_updTRule :: (FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeExpr) -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
  -> (FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr) -> (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule
d_C_updTRule x1 x2 x3 x4 cd cs = d_C_trTRule (acceptCs id
  (d_OP_updTRule_dot_rule_dot_166 x3 x2)) (acceptCs id
  (d_OP_updTRule_dot_ext_dot_166 x1 x4))

nd_C_updTRule :: Func FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) -> Func FlatCurry.Typed.Curry_Types.C_TExpr
  FlatCurry.Typed.Curry_Types.C_TExpr -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply
  -> Cover -> ConstStore -> Func FlatCurry.Typed.Curry_Types.C_TRule
  FlatCurry.Typed.Curry_Types.C_TRule
nd_C_updTRule x1 x2 x3 x4 s cd cs = wrapNX id (nd_C_trTRule (wrapDX (wrapNX id)
  (acceptCs id (nd_OP_updTRule_dot_rule_dot_166 x3 x2))) (wrapDX (wrapNX id)
  (acceptCs id (nd_OP_updTRule_dot_ext_dot_166 x1 x4))))

d_OP_updTRule_dot_rule_dot_166 :: (FlatCurry.Typed.Curry_Types.C_TExpr -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TExpr)
  -> (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule
d_OP_updTRule_dot_rule_dot_166 x1 x2 x3 x4 cd cs =
  FlatCurry.Typed.Curry_Types.C_TRule (Curry_Prelude.d_C_apply x2 x3 cd cs)
  (Curry_Prelude.d_C_apply x1 x4 cd cs)

nd_OP_updTRule_dot_rule_dot_166 :: Func FlatCurry.Typed.Curry_Types.C_TExpr
  FlatCurry.Typed.Curry_Types.C_TExpr -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> IDSupply -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule
nd_OP_updTRule_dot_rule_dot_166 x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` FlatCurry.Typed.Curry_Types.C_TRule
  (Curry_Prelude.nd_C_apply x2 x3 s0 cd cs) (Curry_Prelude.nd_C_apply x1 x4 s1
  cd cs)))

d_OP_updTRule_dot_ext_dot_166 :: (FlatCurry.Curry_Types.C_TypeExpr -> Cover
  -> ConstStore -> FlatCurry.Curry_Types.C_TypeExpr) -> (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule
d_OP_updTRule_dot_ext_dot_166 x1 x2 x3 x4 cd cs =
  FlatCurry.Typed.Curry_Types.C_TExternal (Curry_Prelude.d_C_apply x1 x3 cd cs)
  (Curry_Prelude.d_C_apply x2 x4 cd cs)

nd_OP_updTRule_dot_ext_dot_166 :: Func FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Func (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule
nd_OP_updTRule_dot_ext_dot_166 x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` FlatCurry.Typed.Curry_Types.C_TExternal
  (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs) (Curry_Prelude.nd_C_apply x2 x4 s1
  cd cs)))

d_C_updTRuleType :: (FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule
d_C_updTRuleType x1 cd cs = d_C_updTRule x1 Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id cd cs

nd_C_updTRuleType :: Func FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  FlatCurry.Typed.Curry_Types.C_TRule FlatCurry.Typed.Curry_Types.C_TRule
nd_C_updTRuleType x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updTRule x1 (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) s0 cd cs

d_C_updTRuleArgs :: (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule
d_C_updTRuleArgs x1 cd cs = d_C_updTRule Curry_Prelude.d_C_id x1
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id cd cs

nd_C_updTRuleArgs :: Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) -> IDSupply -> Cover -> ConstStore -> Func
  FlatCurry.Typed.Curry_Types.C_TRule FlatCurry.Typed.Curry_Types.C_TRule
nd_C_updTRuleArgs x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updTRule (wrapDX id Curry_Prelude.d_C_id) x1 (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) s0 cd cs

d_C_updTRuleBody :: (FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule
d_C_updTRuleBody x1 cd cs = d_C_updTRule Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id x1 Curry_Prelude.d_C_id cd cs

nd_C_updTRuleBody :: Func FlatCurry.Typed.Curry_Types.C_TExpr
  FlatCurry.Typed.Curry_Types.C_TExpr -> IDSupply -> Cover -> ConstStore -> Func
  FlatCurry.Typed.Curry_Types.C_TRule FlatCurry.Typed.Curry_Types.C_TRule
nd_C_updTRuleBody x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updTRule (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) x1 (wrapDX id Curry_Prelude.d_C_id) s0 cd cs

d_C_updTRuleExtDecl :: Cover -> ConstStore -> (Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule
d_C_updTRuleExtDecl cd cs = d_C_updTRule Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id

nd_C_updTRuleExtDecl :: IDSupply -> Cover -> ConstStore -> Func (Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Func FlatCurry.Typed.Curry_Types.C_TRule
  FlatCurry.Typed.Curry_Types.C_TRule)
nd_C_updTRuleExtDecl s cd cs = wrapNX id (nd_C_updTRule (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id))

d_C_allVarsInTRule :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TRule
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
d_C_allVarsInTRule cd cs = d_C_trTRule (acceptCs id
  d_OP_allVarsInTRule_dot_uscore_hash_lambda15) (acceptCs id
  d_OP_allVarsInTRule_dot_uscore_hash_lambda16)

d_OP_allVarsInTRule_dot_uscore_hash_lambda15 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
d_OP_allVarsInTRule_dot_uscore_hash_lambda15 x1 x2 cd cs =
  Curry_Prelude.d_OP_plus_plus x1 (d_C_allVars x2 cd cs) cd cs

d_OP_allVarsInTRule_dot_uscore_hash_lambda16 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
d_OP_allVarsInTRule_dot_uscore_hash_lambda16 x1 x2 cd cs = Curry_Prelude.OP_List

d_C_rnmAllVarsInTRule :: (Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule
d_C_rnmAllVarsInTRule x1 cd cs = d_C_updTRule Curry_Prelude.d_C_id
  (Curry_Prelude.d_C_map (d_OP_rnmAllVarsInTRule_dot_uscore_hash_lambda17 x1))
  (d_C_rnmAllVars x1 cd cs) Curry_Prelude.d_C_id cd cs

nd_C_rnmAllVarsInTRule :: Func Curry_Prelude.C_Int Curry_Prelude.C_Int
  -> IDSupply -> Cover -> ConstStore -> Func FlatCurry.Typed.Curry_Types.C_TRule
  FlatCurry.Typed.Curry_Types.C_TRule
nd_C_rnmAllVarsInTRule x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_updTRule (wrapDX id Curry_Prelude.d_C_id) (wrapNX
  id (Curry_Prelude.nd_C_map (wrapNX id
  (nd_OP_rnmAllVarsInTRule_dot_uscore_hash_lambda17 x1)))) (nd_C_rnmAllVars x1
  s0 cd cs) (wrapDX id Curry_Prelude.d_C_id) s1 cd cs))

d_OP_rnmAllVarsInTRule_dot_uscore_hash_lambda17 :: (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.C_Int) -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr
d_OP_rnmAllVarsInTRule_dot_uscore_hash_lambda17 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_C_apply x1 x3 cd cs) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_rnmAllVarsInTRule_dot_uscore_hash_lambda17 x1 l cd cs)
    (d_OP_rnmAllVarsInTRule_dot_uscore_hash_lambda17 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_rnmAllVarsInTRule_dot_uscore_hash_lambda17 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_rnmAllVarsInTRule_dot_uscore_hash_lambda17 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.rnmAllVarsInTRule._#lambda17" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "FlatCurry.Typed.Goodies.rnmAllVarsInTRule._#lambda17" (showCons x2))

nd_OP_rnmAllVarsInTRule_dot_uscore_hash_lambda17 :: Func Curry_Prelude.C_Int
  Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr
nd_OP_rnmAllVarsInTRule_dot_uscore_hash_lambda17 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_apply x1 x3 s0 cd
    cs) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_rnmAllVarsInTRule_dot_uscore_hash_lambda17 x1 l s cd cs)
    (nd_OP_rnmAllVarsInTRule_dot_uscore_hash_lambda17 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_rnmAllVarsInTRule_dot_uscore_hash_lambda17 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_rnmAllVarsInTRule_dot_uscore_hash_lambda17 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.rnmAllVarsInTRule._#lambda17" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "FlatCurry.Typed.Goodies.rnmAllVarsInTRule._#lambda17" (showCons x2))

d_C_updQNamesInTRule :: Cover -> ConstStore -> (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TRule
d_C_updQNamesInTRule cd cs = Curry_Prelude.d_OP_dot d_C_updTRuleBody
  d_C_updQNames cd cs

nd_C_updQNamesInTRule :: IDSupply -> Cover -> ConstStore -> Func (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Func FlatCurry.Typed.Curry_Types.C_TRule
  FlatCurry.Typed.Curry_Types.C_TRule)
nd_C_updQNamesInTRule s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapNX id nd_C_updTRuleBody) (wrapNX id
  nd_C_updQNames) s0 cd cs

d_C_varNr :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_C_varNr x1 cd cs = let x2 = Curry_Prelude.d_C_error
                           (Curry_Prelude.toCurryString
                           "FlatCurry.Typed.Goodies.varNr: no variable") cd cs
  in d_C__case_25 x2 x1 cd cs

d_C_literal :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Literal
d_C_literal x1 cd cs = let x2 = Curry_Prelude.d_C_error
                             (Curry_Prelude.toCurryString
                             "FlatCurry.Typed.Goodies.literal: no literal") cd
                             cs
  in d_C__case_24 x2 x1 cd cs

d_C_combType :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_CombType
d_C_combType x1 cd cs = let x2 = Curry_Prelude.d_OP_dollar
                              Curry_Prelude.d_C_error
                              (Curry_Prelude.d_OP_plus_plus
                              (Curry_Prelude.toCurryString
                              "FlatCurry.Typed.Goodies.combType: ")
                              (Curry_Prelude.toCurryString
                              "no combined expression") cd cs) cd cs
  in d_C__case_23 x2 x1 cd cs

d_C_combName :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_combName x1 cd cs = let x2 = Curry_Prelude.d_OP_dollar
                              Curry_Prelude.d_C_error
                              (Curry_Prelude.d_OP_plus_plus
                              (Curry_Prelude.toCurryString
                              "FlatCurry.Typed.Goodies.combName: ")
                              (Curry_Prelude.toCurryString
                              "no combined expression") cd cs) cd cs
  in d_C__case_22 x2 x1 cd cs

d_C_combArgs :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List FlatCurry.Typed.Curry_Types.C_TExpr
d_C_combArgs x1 cd cs = let x2 = Curry_Prelude.d_OP_dollar
                              Curry_Prelude.d_C_error
                              (Curry_Prelude.d_OP_plus_plus
                              (Curry_Prelude.toCurryString
                              "FlatCurry.Typed.Goodies.combArgs: ")
                              (Curry_Prelude.toCurryString
                              "no combined expression") cd cs) cd cs
  in d_C__case_21 x2 x1 cd cs

d_C_missingCombArgs :: Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_C_missingCombArgs cd cs = let x1 = FlatCurry.Curry_Goodies.d_C_trCombType
                                  (Curry_Prelude.C_Int (0)) Curry_Prelude.d_C_id
                                  (Curry_Prelude.C_Int (0)) Curry_Prelude.d_C_id
  in Curry_Prelude.d_OP_dot x1 d_C_combType cd cs

d_C_letBinds :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  FlatCurry.Typed.Curry_Types.C_TExpr)
d_C_letBinds x1 cd cs = let x2 = Curry_Prelude.d_OP_dollar
                              Curry_Prelude.d_C_error
                              (Curry_Prelude.d_OP_plus_plus
                              (Curry_Prelude.toCurryString
                              "FlatCurry.Typed.Goodies.letBinds: ")
                              (Curry_Prelude.toCurryString "no let expression")
                              cd cs) cd cs
  in d_C__case_20 x2 x1 cd cs

d_C_letBody :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C_letBody x1 cd cs = let x2 = Curry_Prelude.d_OP_dollar
                             Curry_Prelude.d_C_error
                             (Curry_Prelude.d_OP_plus_plus
                             (Curry_Prelude.toCurryString
                             "FlatCurry.Typed.Goodies.letBody: ")
                             (Curry_Prelude.toCurryString "no let expression")
                             cd cs) cd cs
  in d_C__case_19 x2 x1 cd cs

d_C_freeVars :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
d_C_freeVars x1 cd cs = let x2 = Curry_Prelude.d_OP_dollar
                              Curry_Prelude.d_C_error
                              (Curry_Prelude.d_OP_plus_plus
                              (Curry_Prelude.toCurryString
                              "FlatCurry.Typed.Goodies.freeVars: ")
                              (Curry_Prelude.toCurryString
                              "no declaration of free variables") cd cs) cd cs
  in d_C__case_18 x2 x1 cd cs

d_C_freeExpr :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C_freeExpr x1 cd cs = let x2 = Curry_Prelude.d_OP_dollar
                              Curry_Prelude.d_C_error
                              (Curry_Prelude.d_OP_plus_plus
                              (Curry_Prelude.toCurryString
                              "FlatCurry.Typed.Goodies.freeExpr: ")
                              (Curry_Prelude.toCurryString
                              "no declaration of free variables") cd cs) cd cs
  in d_C__case_17 x2 x1 cd cs

d_C_orExps :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List FlatCurry.Typed.Curry_Types.C_TExpr
d_C_orExps x1 cd cs = let x2 = Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_error
                            (Curry_Prelude.d_OP_plus_plus
                            (Curry_Prelude.toCurryString
                            "FlatCurry.Typed.Goodies.orExps: ")
                            (Curry_Prelude.toCurryString "no or expression") cd
                            cs) cd cs
  in d_C__case_16 x2 x1 cd cs

d_C_caseType :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_CaseType
d_C_caseType x1 cd cs = let x2 = Curry_Prelude.d_OP_dollar
                              Curry_Prelude.d_C_error
                              (Curry_Prelude.d_OP_plus_plus
                              (Curry_Prelude.toCurryString
                              "FlatCurry.Typed.Goodies.caseType: ")
                              (Curry_Prelude.toCurryString "no case expression")
                              cd cs) cd cs
  in d_C__case_15 x2 x1 cd cs

d_C_caseExpr :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C_caseExpr x1 cd cs = let x2 = Curry_Prelude.d_OP_dollar
                              Curry_Prelude.d_C_error
                              (Curry_Prelude.d_OP_plus_plus
                              (Curry_Prelude.toCurryString
                              "FlatCurry.Typed.Goodies.caseExpr: ")
                              (Curry_Prelude.toCurryString "no case expression")
                              cd cs) cd cs
  in d_C__case_14 x2 x1 cd cs

d_C_caseBranches :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List FlatCurry.Typed.Curry_Types.C_TBranchExpr
d_C_caseBranches x1 cd cs = let x2 = Curry_Prelude.d_OP_dollar
                                  Curry_Prelude.d_C_error
                                  (Curry_Prelude.d_OP_plus_plus
                                  (Curry_Prelude.toCurryString
                                  "FlatCurry.Typed.Goodies.caseBranches: ")
                                  (Curry_Prelude.toCurryString
                                  "no case expression") cd cs) cd cs
  in d_C__case_13 x2 x1 cd cs

d_C_isTVarE :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isTVarE x1 cd cs = let x2 = Curry_Prelude.C_False
  in d_C__case_12 x2 x1 cd cs

d_C_isTLit :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isTLit x1 cd cs = let x2 = Curry_Prelude.C_False in d_C__case_11 x2 x1 cd cs

d_C_isTComb :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isTComb x1 cd cs = let x2 = Curry_Prelude.C_False
  in d_C__case_10 x2 x1 cd cs

d_C_isTLet :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isTLet x1 cd cs = let x2 = Curry_Prelude.C_False in d_C__case_9 x2 x1 cd cs

d_C_isTFree :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isTFree x1 cd cs = let x2 = Curry_Prelude.C_False in d_C__case_8 x2 x1 cd cs

d_C_isTOr :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isTOr x1 cd cs = let x2 = Curry_Prelude.C_False in d_C__case_7 x2 x1 cd cs

d_C_isTCase :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isTCase x1 cd cs = let x2 = Curry_Prelude.C_False in d_C__case_6 x2 x1 cd cs

d_C_trTExpr :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> t1)
  -> (FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Literal -> Cover -> ConstStore -> t1)
  -> (FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_CombType -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t1 -> Cover -> ConstStore -> t1)
  -> (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) t1) -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t1) -> (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t1) -> (t1 -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t1)
  -> (FlatCurry.Curry_Types.C_CaseType -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t1)
  -> (FlatCurry.Typed.Curry_Types.C_TPattern -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> t0) -> (t1 -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore -> t1)
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore -> t1
d_C_trTExpr x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 cd cs = let x11 = d_C_trTExpr x1 x2
                                                         x3 x4 x5 x6 x7 x8 x9
  in d_C__case_5 x11 x9 x8 x7 x6 x5 x4 x3 x2 x1 x10 cd cs

nd_C_trTExpr :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func FlatCurry.Curry_Types.C_TypeExpr (Func Curry_Prelude.C_Int t1)
  -> Func FlatCurry.Curry_Types.C_TypeExpr (Func FlatCurry.Curry_Types.C_Literal
  t1) -> Func FlatCurry.Curry_Types.C_TypeExpr (Func
  FlatCurry.Curry_Types.C_CombType (Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Func (Curry_Prelude.OP_List t1) t1))) -> Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) t1)) (Func t1 t1)
  -> Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Func t1 t1) -> Func t1 (Func t1 t1)
  -> Func FlatCurry.Curry_Types.C_CaseType (Func t1 (Func (Curry_Prelude.OP_List
  t0) t1)) -> Func FlatCurry.Typed.Curry_Types.C_TPattern (Func t1 t0) -> Func
  t1 (Func FlatCurry.Curry_Types.C_TypeExpr t1)
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> IDSupply -> Cover -> ConstStore
  -> t1
nd_C_trTExpr x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 s cd cs = let s0 = s
  in s0 `seq` (let x11 = wrapNX id (nd_C_trTExpr x1 x2 x3 x4 x5 x6 x7 x8 x9)
  in nd_C__case_5 x11 x9 x8 x7 x6 x5 x4 x3 x2 x1 x10 s0 cd cs)

d_OP_trTExpr_dot_uscore_hash_lambda39 :: forall t0 . (Curry_Prelude.Curry
  t0) => (FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore -> t0)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) FlatCurry.Typed.Curry_Types.C_TExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) t0
d_OP_trTExpr_dot_uscore_hash_lambda39 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2 x3
    (Curry_Prelude.d_C_apply x1 x4 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_trTExpr_dot_uscore_hash_lambda39 x1 l cd cs)
    (d_OP_trTExpr_dot_uscore_hash_lambda39 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_trTExpr_dot_uscore_hash_lambda39 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_trTExpr_dot_uscore_hash_lambda39 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.trTExpr._#lambda39" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.trTExpr._#lambda39"
    (showCons x2))

nd_OP_trTExpr_dot_uscore_hash_lambda39 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func FlatCurry.Typed.Curry_Types.C_TExpr t0 -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  FlatCurry.Typed.Curry_Types.C_TExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) t0
nd_OP_trTExpr_dot_uscore_hash_lambda39 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 x3 (Curry_Prelude.nd_C_apply x1 x4 s0 cd
    cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_trTExpr_dot_uscore_hash_lambda39 x1 l s cd cs)
    (nd_OP_trTExpr_dot_uscore_hash_lambda39 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_trTExpr_dot_uscore_hash_lambda39 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_trTExpr_dot_uscore_hash_lambda39 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.trTExpr._#lambda39" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.trTExpr._#lambda39"
    (showCons x2))

d_OP_trTExpr_dot_uscore_hash_lambda40 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (FlatCurry.Typed.Curry_Types.C_TExpr -> Cover
  -> ConstStore -> t1) -> (FlatCurry.Typed.Curry_Types.C_TPattern -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0)
  -> FlatCurry.Typed.Curry_Types.C_TBranchExpr -> Cover -> ConstStore -> t0
d_OP_trTExpr_dot_uscore_hash_lambda40 x1 x2 x3 cd cs = case x3 of
  FlatCurry.Typed.Curry_Types.C_TBranch x4 x5 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x2 x4 cd cs) (Curry_Prelude.d_C_apply x1 x5 cd cs)
    cd cs
  FlatCurry.Typed.Curry_Types.Choice_C_TBranchExpr d i l r -> narrow d i
    (d_OP_trTExpr_dot_uscore_hash_lambda40 x1 x2 l cd cs)
    (d_OP_trTExpr_dot_uscore_hash_lambda40 x1 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TBranchExpr d i xs -> narrows cs d i
    (\z -> d_OP_trTExpr_dot_uscore_hash_lambda40 x1 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TBranchExpr d c e -> guardCons d c ((\x ->
    d_OP_trTExpr_dot_uscore_hash_lambda40 x1 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TBranchExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.trTExpr._#lambda40" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.trTExpr._#lambda40"
    (showCons x3))

nd_OP_trTExpr_dot_uscore_hash_lambda40 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func FlatCurry.Typed.Curry_Types.C_TExpr t1
  -> Func FlatCurry.Typed.Curry_Types.C_TPattern (Func t1 t0)
  -> FlatCurry.Typed.Curry_Types.C_TBranchExpr -> IDSupply -> Cover
  -> ConstStore -> t0
nd_OP_trTExpr_dot_uscore_hash_lambda40 x1 x2 x3 s cd cs = case x3 of
  FlatCurry.Typed.Curry_Types.C_TBranch x4 x5 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_apply x2 x4 s0 cd cs) (Curry_Prelude.nd_C_apply x1 x5 s1
    cd cs) s2 cd cs))))
  FlatCurry.Typed.Curry_Types.Choice_C_TBranchExpr d i l r -> narrow d i
    (nd_OP_trTExpr_dot_uscore_hash_lambda40 x1 x2 l s cd cs)
    (nd_OP_trTExpr_dot_uscore_hash_lambda40 x1 x2 r s cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TBranchExpr d i xs -> narrows cs d i
    (\z -> nd_OP_trTExpr_dot_uscore_hash_lambda40 x1 x2 z s cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TBranchExpr d c e -> guardCons d c ((\x ->
    nd_OP_trTExpr_dot_uscore_hash_lambda40 x1 x2 e s cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TBranchExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.trTExpr._#lambda40" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.trTExpr._#lambda40"
    (showCons x3))

d_C_updVars :: (FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C_updVars x1 cd cs = d_C_trTExpr x1 (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLit) (acceptCs (acceptCs (acceptCs (acceptCs
  id))) FlatCurry.Typed.Curry_Types.C_TComb) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLet) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TFree) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TOr) (acceptCs (acceptCs (acceptCs id))
  FlatCurry.Typed.Curry_Types.C_TCase) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TBranch) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TTyped)

nd_C_updVars :: Func FlatCurry.Curry_Types.C_TypeExpr (Func Curry_Prelude.C_Int
  FlatCurry.Typed.Curry_Types.C_TExpr) -> IDSupply -> Cover -> ConstStore
  -> Func FlatCurry.Typed.Curry_Types.C_TExpr
  FlatCurry.Typed.Curry_Types.C_TExpr
nd_C_updVars x1 s cd cs = wrapNX id (nd_C_trTExpr x1 (wrapDX (wrapDX id)
  (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TLit)) (wrapDX (wrapDX
  (wrapDX (wrapDX id))) (acceptCs (acceptCs (acceptCs (acceptCs id)))
  FlatCurry.Typed.Curry_Types.C_TComb)) (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Typed.Curry_Types.C_TLet)) (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TFree)) (wrapDX (wrapDX id)
  (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TOr)) (wrapDX (wrapDX
  (wrapDX id)) (acceptCs (acceptCs (acceptCs id))
  FlatCurry.Typed.Curry_Types.C_TCase)) (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Typed.Curry_Types.C_TBranch)) (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TTyped)))

d_C_updLiterals :: (FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Literal -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C_updLiterals x1 cd cs = d_C_trTExpr (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TVarE) x1 (acceptCs (acceptCs (acceptCs
  (acceptCs id))) FlatCurry.Typed.Curry_Types.C_TComb) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLet) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TFree) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TOr) (acceptCs (acceptCs (acceptCs id))
  FlatCurry.Typed.Curry_Types.C_TCase) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TBranch) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TTyped)

nd_C_updLiterals :: Func FlatCurry.Curry_Types.C_TypeExpr (Func
  FlatCurry.Curry_Types.C_Literal FlatCurry.Typed.Curry_Types.C_TExpr)
  -> IDSupply -> Cover -> ConstStore -> Func FlatCurry.Typed.Curry_Types.C_TExpr
  FlatCurry.Typed.Curry_Types.C_TExpr
nd_C_updLiterals x1 s cd cs = wrapNX id (nd_C_trTExpr (wrapDX (wrapDX id)
  (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TVarE)) x1 (wrapDX
  (wrapDX (wrapDX (wrapDX id))) (acceptCs (acceptCs (acceptCs (acceptCs id)))
  FlatCurry.Typed.Curry_Types.C_TComb)) (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Typed.Curry_Types.C_TLet)) (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TFree)) (wrapDX (wrapDX id)
  (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TOr)) (wrapDX (wrapDX
  (wrapDX id)) (acceptCs (acceptCs (acceptCs id))
  FlatCurry.Typed.Curry_Types.C_TCase)) (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Typed.Curry_Types.C_TBranch)) (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TTyped)))

d_C_updCombs :: (FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_CombType -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List FlatCurry.Typed.Curry_Types.C_TExpr -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TExpr) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C_updCombs x1 cd cs = d_C_trTExpr (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TVarE) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLit) x1 (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLet) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TFree) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TOr) (acceptCs (acceptCs (acceptCs id))
  FlatCurry.Typed.Curry_Types.C_TCase) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TBranch) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TTyped)

nd_C_updCombs :: Func FlatCurry.Curry_Types.C_TypeExpr (Func
  FlatCurry.Curry_Types.C_CombType (Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Func (Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TExpr) FlatCurry.Typed.Curry_Types.C_TExpr)))
  -> IDSupply -> Cover -> ConstStore -> Func FlatCurry.Typed.Curry_Types.C_TExpr
  FlatCurry.Typed.Curry_Types.C_TExpr
nd_C_updCombs x1 s cd cs = wrapNX id (nd_C_trTExpr (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TVarE)) (wrapDX (wrapDX id)
  (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TLit)) x1 (wrapDX
  (wrapDX id) (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TLet))
  (wrapDX (wrapDX id) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TFree)) (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Typed.Curry_Types.C_TOr)) (wrapDX (wrapDX (wrapDX id)) (acceptCs
  (acceptCs (acceptCs id)) FlatCurry.Typed.Curry_Types.C_TCase)) (wrapDX (wrapDX
  id) (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TBranch)) (wrapDX
  (wrapDX id) (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TTyped)))

d_C_updLets :: (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  FlatCurry.Typed.Curry_Types.C_TExpr) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C_updLets x1 cd cs = d_C_trTExpr (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TVarE) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLit) (acceptCs (acceptCs (acceptCs (acceptCs
  id))) FlatCurry.Typed.Curry_Types.C_TComb) x1 (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TFree) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TOr) (acceptCs (acceptCs (acceptCs id))
  FlatCurry.Typed.Curry_Types.C_TCase) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TBranch) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TTyped)

nd_C_updLets :: Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  FlatCurry.Typed.Curry_Types.C_TExpr)) (Func
  FlatCurry.Typed.Curry_Types.C_TExpr FlatCurry.Typed.Curry_Types.C_TExpr)
  -> IDSupply -> Cover -> ConstStore -> Func FlatCurry.Typed.Curry_Types.C_TExpr
  FlatCurry.Typed.Curry_Types.C_TExpr
nd_C_updLets x1 s cd cs = wrapNX id (nd_C_trTExpr (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TVarE)) (wrapDX (wrapDX id)
  (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TLit)) (wrapDX (wrapDX
  (wrapDX (wrapDX id))) (acceptCs (acceptCs (acceptCs (acceptCs id)))
  FlatCurry.Typed.Curry_Types.C_TComb)) x1 (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TFree)) (wrapDX (wrapDX id)
  (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TOr)) (wrapDX (wrapDX
  (wrapDX id)) (acceptCs (acceptCs (acceptCs id))
  FlatCurry.Typed.Curry_Types.C_TCase)) (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Typed.Curry_Types.C_TBranch)) (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TTyped)))

d_C_updFrees :: (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C_updFrees x1 cd cs = d_C_trTExpr (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TVarE) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLit) (acceptCs (acceptCs (acceptCs (acceptCs
  id))) FlatCurry.Typed.Curry_Types.C_TComb) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLet) x1 (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TOr) (acceptCs (acceptCs (acceptCs id))
  FlatCurry.Typed.Curry_Types.C_TCase) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TBranch) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TTyped)

nd_C_updFrees :: Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)) (Func
  FlatCurry.Typed.Curry_Types.C_TExpr FlatCurry.Typed.Curry_Types.C_TExpr)
  -> IDSupply -> Cover -> ConstStore -> Func FlatCurry.Typed.Curry_Types.C_TExpr
  FlatCurry.Typed.Curry_Types.C_TExpr
nd_C_updFrees x1 s cd cs = wrapNX id (nd_C_trTExpr (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TVarE)) (wrapDX (wrapDX id)
  (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TLit)) (wrapDX (wrapDX
  (wrapDX (wrapDX id))) (acceptCs (acceptCs (acceptCs (acceptCs id)))
  FlatCurry.Typed.Curry_Types.C_TComb)) (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Typed.Curry_Types.C_TLet)) x1 (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TOr)) (wrapDX (wrapDX (wrapDX id))
  (acceptCs (acceptCs (acceptCs id)) FlatCurry.Typed.Curry_Types.C_TCase))
  (wrapDX (wrapDX id) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TBranch)) (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TTyped)))

d_C_updOrs :: (FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C_updOrs x1 cd cs = d_C_trTExpr (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TVarE) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLit) (acceptCs (acceptCs (acceptCs (acceptCs
  id))) FlatCurry.Typed.Curry_Types.C_TComb) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLet) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TFree) x1 (acceptCs (acceptCs (acceptCs id))
  FlatCurry.Typed.Curry_Types.C_TCase) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TBranch) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TTyped)

nd_C_updOrs :: Func FlatCurry.Typed.Curry_Types.C_TExpr (Func
  FlatCurry.Typed.Curry_Types.C_TExpr FlatCurry.Typed.Curry_Types.C_TExpr)
  -> IDSupply -> Cover -> ConstStore -> Func FlatCurry.Typed.Curry_Types.C_TExpr
  FlatCurry.Typed.Curry_Types.C_TExpr
nd_C_updOrs x1 s cd cs = wrapNX id (nd_C_trTExpr (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TVarE)) (wrapDX (wrapDX id)
  (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TLit)) (wrapDX (wrapDX
  (wrapDX (wrapDX id))) (acceptCs (acceptCs (acceptCs (acceptCs id)))
  FlatCurry.Typed.Curry_Types.C_TComb)) (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Typed.Curry_Types.C_TLet)) (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TFree)) x1 (wrapDX (wrapDX (wrapDX
  id)) (acceptCs (acceptCs (acceptCs id)) FlatCurry.Typed.Curry_Types.C_TCase))
  (wrapDX (wrapDX id) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TBranch)) (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TTyped)))

d_C_updCases :: (FlatCurry.Curry_Types.C_CaseType -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List FlatCurry.Typed.Curry_Types.C_TBranchExpr -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TExpr) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C_updCases x1 cd cs = d_C_trTExpr (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TVarE) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLit) (acceptCs (acceptCs (acceptCs (acceptCs
  id))) FlatCurry.Typed.Curry_Types.C_TComb) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLet) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TFree) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TOr) x1 (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TBranch) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TTyped)

nd_C_updCases :: Func FlatCurry.Curry_Types.C_CaseType (Func
  FlatCurry.Typed.Curry_Types.C_TExpr (Func (Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TBranchExpr)
  FlatCurry.Typed.Curry_Types.C_TExpr)) -> IDSupply -> Cover -> ConstStore
  -> Func FlatCurry.Typed.Curry_Types.C_TExpr
  FlatCurry.Typed.Curry_Types.C_TExpr
nd_C_updCases x1 s cd cs = wrapNX id (nd_C_trTExpr (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TVarE)) (wrapDX (wrapDX id)
  (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TLit)) (wrapDX (wrapDX
  (wrapDX (wrapDX id))) (acceptCs (acceptCs (acceptCs (acceptCs id)))
  FlatCurry.Typed.Curry_Types.C_TComb)) (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Typed.Curry_Types.C_TLet)) (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TFree)) (wrapDX (wrapDX id)
  (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TOr)) x1 (wrapDX (wrapDX
  id) (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TBranch)) (wrapDX
  (wrapDX id) (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TTyped)))

d_C_updBranches :: (FlatCurry.Typed.Curry_Types.C_TPattern -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TBranchExpr) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C_updBranches x1 cd cs = d_C_trTExpr (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TVarE) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLit) (acceptCs (acceptCs (acceptCs (acceptCs
  id))) FlatCurry.Typed.Curry_Types.C_TComb) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLet) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TFree) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TOr) (acceptCs (acceptCs (acceptCs id))
  FlatCurry.Typed.Curry_Types.C_TCase) x1 (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TTyped)

nd_C_updBranches :: Func FlatCurry.Typed.Curry_Types.C_TPattern (Func
  FlatCurry.Typed.Curry_Types.C_TExpr FlatCurry.Typed.Curry_Types.C_TBranchExpr)
  -> IDSupply -> Cover -> ConstStore -> Func FlatCurry.Typed.Curry_Types.C_TExpr
  FlatCurry.Typed.Curry_Types.C_TExpr
nd_C_updBranches x1 s cd cs = wrapNX id (nd_C_trTExpr (wrapDX (wrapDX id)
  (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TVarE)) (wrapDX (wrapDX
  id) (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TLit)) (wrapDX
  (wrapDX (wrapDX (wrapDX id))) (acceptCs (acceptCs (acceptCs (acceptCs id)))
  FlatCurry.Typed.Curry_Types.C_TComb)) (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Typed.Curry_Types.C_TLet)) (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TFree)) (wrapDX (wrapDX id)
  (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TOr)) (wrapDX (wrapDX
  (wrapDX id)) (acceptCs (acceptCs (acceptCs id))
  FlatCurry.Typed.Curry_Types.C_TCase)) x1 (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TTyped)))

d_C_updTypeds :: Cover -> ConstStore -> (FlatCurry.Typed.Curry_Types.C_TExpr
  -> Cover -> ConstStore -> FlatCurry.Curry_Types.C_TypeExpr -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TExpr) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C_updTypeds cd cs = acceptCs id (d_C_trTExpr (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TVarE) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLit) (acceptCs (acceptCs (acceptCs (acceptCs
  id))) FlatCurry.Typed.Curry_Types.C_TComb) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLet) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TFree) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TOr) (acceptCs (acceptCs (acceptCs id))
  FlatCurry.Typed.Curry_Types.C_TCase) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TBranch))

nd_C_updTypeds :: IDSupply -> Cover -> ConstStore -> Func (Func
  FlatCurry.Typed.Curry_Types.C_TExpr (Func FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Typed.Curry_Types.C_TExpr)) (Func
  FlatCurry.Typed.Curry_Types.C_TExpr FlatCurry.Typed.Curry_Types.C_TExpr)
nd_C_updTypeds s cd cs = wrapDX (wrapNX id) (acceptCs id (nd_C_trTExpr (wrapDX
  (wrapDX id) (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TVarE))
  (wrapDX (wrapDX id) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLit)) (wrapDX (wrapDX (wrapDX (wrapDX id)))
  (acceptCs (acceptCs (acceptCs (acceptCs id)))
  FlatCurry.Typed.Curry_Types.C_TComb)) (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Typed.Curry_Types.C_TLet)) (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TFree)) (wrapDX (wrapDX id)
  (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TOr)) (wrapDX (wrapDX
  (wrapDX id)) (acceptCs (acceptCs (acceptCs id))
  FlatCurry.Typed.Curry_Types.C_TCase)) (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Typed.Curry_Types.C_TBranch))))

d_C_isFuncCall :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isFuncCall x1 cd cs = Curry_Prelude.d_OP_amp_amp (d_C_isTComb x1 cd cs)
  (Curry_Prelude.d_C_apply (FlatCurry.Curry_Goodies.d_C_isCombTypeFuncCall cd
  cs) (d_C_combType x1 cd cs) cd cs) cd cs

d_C_isFuncPartCall :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isFuncPartCall x1 cd cs = Curry_Prelude.d_OP_amp_amp (d_C_isTComb x1 cd cs)
  (Curry_Prelude.d_C_apply (FlatCurry.Curry_Goodies.d_C_isCombTypeFuncPartCall
  cd cs) (d_C_combType x1 cd cs) cd cs) cd cs

d_C_isConsCall :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isConsCall x1 cd cs = Curry_Prelude.d_OP_amp_amp (d_C_isTComb x1 cd cs)
  (Curry_Prelude.d_C_apply (FlatCurry.Curry_Goodies.d_C_isCombTypeConsCall cd
  cs) (d_C_combType x1 cd cs) cd cs) cd cs

d_C_isConsPartCall :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isConsPartCall x1 cd cs = Curry_Prelude.d_OP_amp_amp (d_C_isTComb x1 cd cs)
  (Curry_Prelude.d_C_apply (FlatCurry.Curry_Goodies.d_C_isCombTypeConsPartCall
  cd cs) (d_C_combType x1 cd cs) cd cs) cd cs

d_C_isGround :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isGround x1 cd cs = let x2 = d_C_isTLit x1 cd cs in d_C__case_4 x2 x1 cd cs

d_C_allVars :: FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
d_C_allVars x1 cd cs = let x2 = Curry_Prelude.d_C_const (Curry_Prelude.d_C_const
                             Curry_Prelude.d_C_id)
  in Curry_Prelude.d_C_apply (d_C_trTExpr (acceptCs id
  d_OP_allVars_dot_var_dot_428) x2 (acceptCs (acceptCs id)
  d_OP_allVars_dot_comb_dot_428) (acceptCs id d_OP_allVars_dot_lt_dot_428)
  (acceptCs id d_OP_allVars_dot_fr_dot_428) (acceptCs id Curry_Prelude.d_OP_dot)
  (acceptCs (acceptCs id) d_OP_allVars_dot_cas_dot_428) (acceptCs id
  d_OP_allVars_dot_branch_dot_428) (acceptCs id Curry_Prelude.d_C_const) x1 cd
  cs) Curry_Prelude.OP_List cd cs

d_OP_allVars_dot_var_dot_428 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t1 -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 t1) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 t1)
d_OP_allVars_dot_var_dot_428 x1 x2 cd cs = acceptCs id (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 x2 x1))

d_OP_allVars_dot_comb_dot_428 :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t3 -> t2 -> t1 -> Cover -> ConstStore -> Curry_Prelude.OP_List (t0
  -> Cover -> ConstStore -> t0) -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> t0
d_OP_allVars_dot_comb_dot_428 x1 x2 x3 cd cs = Curry_Prelude.d_C_foldr (acceptCs
  id Curry_Prelude.d_OP_dot) Curry_Prelude.d_C_id

nd_OP_allVars_dot_comb_dot_428 :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t3 -> t2 -> t1 -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List (Func t0 t0)) (Func t0 t0)
nd_OP_allVars_dot_comb_dot_428 x1 x2 x3 s cd cs = wrapNX id
  (Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs id
  Curry_Prelude.nd_OP_dot)) (wrapDX id Curry_Prelude.d_C_id))

d_OP_allVars_dot_lt_dot_428 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0))
  -> (Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t1) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t1
d_OP_allVars_dot_lt_dot_428 x1 x2 cd cs = Curry_Prelude.d_OP_dot x2
  (Curry_Prelude.d_C_foldr (acceptCs id Curry_Prelude.d_OP_dot)
  Curry_Prelude.d_C_id (Curry_Prelude.d_C_map
  d_OP_allVars_dot_lt_dot_428_dot_uscore_hash_lambda42 x1 cd cs) cd cs) cd cs

nd_OP_allVars_dot_lt_dot_428 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0
  (Func (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0))) -> Func
  (Curry_Prelude.OP_List t0) t1 -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List t0) t1
nd_OP_allVars_dot_lt_dot_428 x1 x2 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dot x2 (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs
  id Curry_Prelude.nd_OP_dot)) (wrapDX id Curry_Prelude.d_C_id)
  (Curry_Prelude.nd_C_map (wrapNX id
  nd_OP_allVars_dot_lt_dot_428_dot_uscore_hash_lambda42) x1 s0 cd cs) s1 cd cs))
  s3 cd cs))

d_OP_allVars_dot_lt_dot_428_dot_uscore_hash_lambda42 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_allVars_dot_lt_dot_428_dot_uscore_hash_lambda42 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_OP_dot (acceptCs id
    (Curry_Prelude.OP_Cons x2)) x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_allVars_dot_lt_dot_428_dot_uscore_hash_lambda42 l cd cs)
    (d_OP_allVars_dot_lt_dot_428_dot_uscore_hash_lambda42 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_allVars_dot_lt_dot_428_dot_uscore_hash_lambda42 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_allVars_dot_lt_dot_428_dot_uscore_hash_lambda42 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.allVars.<.428._#lambda42" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.allVars.<.428._#lambda42"
    (showCons x1))

nd_OP_allVars_dot_lt_dot_428_dot_uscore_hash_lambda42 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Func (Curry_Prelude.OP_List t0)
  (Curry_Prelude.OP_List t0)) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0)
nd_OP_allVars_dot_lt_dot_428_dot_uscore_hash_lambda42 x1 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX id (acceptCs id
    (Curry_Prelude.OP_Cons x2))) x3 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_allVars_dot_lt_dot_428_dot_uscore_hash_lambda42 l s cd cs)
    (nd_OP_allVars_dot_lt_dot_428_dot_uscore_hash_lambda42 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_allVars_dot_lt_dot_428_dot_uscore_hash_lambda42 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_allVars_dot_lt_dot_428_dot_uscore_hash_lambda42 e s cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.allVars.<.428._#lambda42" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.allVars.<.428._#lambda42"
    (showCons x1))

d_OP_allVars_dot_fr_dot_428 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Curry_Prelude.OP_List t0 -> (t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_allVars_dot_fr_dot_428 x1 x2 cd cs = Curry_Prelude.d_OP_dot
  (Curry_Prelude.d_OP_plus_plus x1) x2 cd cs

nd_OP_allVars_dot_fr_dot_428 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Curry_Prelude.OP_List t0 -> Func t1
  (Curry_Prelude.OP_List t0) -> IDSupply -> Cover -> ConstStore -> Func t1
  (Curry_Prelude.OP_List t0)
nd_OP_allVars_dot_fr_dot_428 x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX id (Curry_Prelude.d_OP_plus_plus
  x1)) x2 s0 cd cs

d_OP_allVars_dot_cas_dot_428 :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => t2 -> (t0 -> Cover
  -> ConstStore -> t1) -> Curry_Prelude.OP_List (t0 -> Cover -> ConstStore
  -> t0) -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t1
d_OP_allVars_dot_cas_dot_428 x1 x2 x3 cd cs = Curry_Prelude.d_OP_dot x2
  (Curry_Prelude.d_C_foldr (acceptCs id Curry_Prelude.d_OP_dot)
  Curry_Prelude.d_C_id x3 cd cs) cd cs

nd_OP_allVars_dot_cas_dot_428 :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => t2 -> Func t0 t1
  -> Curry_Prelude.OP_List (Func t0 t0) -> IDSupply -> Cover -> ConstStore
  -> Func t0 t1
nd_OP_allVars_dot_cas_dot_428 x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot x2 (Curry_Prelude.nd_C_foldr
  (wrapDX (wrapNX id) (acceptCs id Curry_Prelude.nd_OP_dot)) (wrapDX id
  Curry_Prelude.d_C_id) x3 s0 cd cs) s1 cd cs))

d_OP_allVars_dot_args_dot_428 :: FlatCurry.Typed.Curry_Types.C_TPattern -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
d_OP_allVars_dot_args_dot_428 x1 cd cs = d_C__case_2 x1 (Curry_Prelude.d_C_apply
  (d_C_isConsPattern cd cs) x1 cd cs) cd cs

d_OP_allVars_dot_branch_dot_428 :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Typed.Curry_Types.C_TPattern -> (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
d_OP_allVars_dot_branch_dot_428 x1 x2 cd cs = Curry_Prelude.d_OP_dot
  (Curry_Prelude.d_OP_plus_plus (d_OP_allVars_dot_args_dot_428 x1 cd cs)) x2 cd
  cs

nd_OP_allVars_dot_branch_dot_428 :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Typed.Curry_Types.C_TPattern -> Func t0
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) -> IDSupply -> Cover -> ConstStore -> Func
  t0 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))
nd_OP_allVars_dot_branch_dot_428 x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX id (Curry_Prelude.d_OP_plus_plus
  (d_OP_allVars_dot_args_dot_428 x1 cd cs))) x2 s0 cd cs

d_C_rnmAllVars :: (Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C_rnmAllVars x1 cd cs = let x2 = Curry_Prelude.d_OP_dot (acceptCs (acceptCs
                                id) FlatCurry.Typed.Curry_Types.C_TLet)
                                (Curry_Prelude.d_C_map
                                (d_OP_rnmAllVars_dot_uscore_hash_lambda43 x1))
                                cd cs
                              x3 = Curry_Prelude.d_OP_dot (acceptCs (acceptCs
                                id) FlatCurry.Typed.Curry_Types.C_TFree)
                                (Curry_Prelude.d_C_map
                                (d_OP_rnmAllVars_dot_uscore_hash_lambda44 x1))
                                cd cs
                              x4 = Curry_Prelude.d_OP_dot (acceptCs (acceptCs
                                id) FlatCurry.Typed.Curry_Types.C_TBranch)
                                (d_C_updTPatArgs (Curry_Prelude.d_C_map
                                (d_OP_rnmAllVars_dot_uscore_hash_lambda45 x1))
                                cd cs) cd cs
  in d_C_trTExpr (d_OP_rnmAllVars_dot_var_dot_451 x1) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLit) (acceptCs (acceptCs (acceptCs (acceptCs
  id))) FlatCurry.Typed.Curry_Types.C_TComb) x2 x3 (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TOr) (acceptCs (acceptCs (acceptCs id))
  FlatCurry.Typed.Curry_Types.C_TCase) x4 (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TTyped)

nd_C_rnmAllVars :: Func Curry_Prelude.C_Int Curry_Prelude.C_Int -> IDSupply
  -> Cover -> ConstStore -> Func FlatCurry.Typed.Curry_Types.C_TExpr
  FlatCurry.Typed.Curry_Types.C_TExpr
nd_C_rnmAllVars x1 s cd cs = let s5 = s
  in s5 `seq` (let s0 = leftSupply s5
                   s6 = rightSupply s5
                   s1 = leftSupply s6
                   s4 = rightSupply s6
  in s0 `seq` (s6 `seq` (s1 `seq` (s4 `seq` (let x2 = Curry_Prelude.nd_OP_dot
                                                   (wrapDX (wrapDX id) (acceptCs
                                                   (acceptCs id)
                                                   FlatCurry.Typed.Curry_Types.C_TLet))
                                                   (wrapNX id
                                                   (Curry_Prelude.nd_C_map
                                                   (wrapNX id
                                                   (nd_OP_rnmAllVars_dot_uscore_hash_lambda43
                                                   x1)))) s0 cd cs
                                                 x3 = Curry_Prelude.nd_OP_dot
                                                   (wrapDX (wrapDX id) (acceptCs
                                                   (acceptCs id)
                                                   FlatCurry.Typed.Curry_Types.C_TFree))
                                                   (wrapNX id
                                                   (Curry_Prelude.nd_C_map
                                                   (wrapNX id
                                                   (nd_OP_rnmAllVars_dot_uscore_hash_lambda44
                                                   x1)))) s1 cd cs
                                                 x4 = let s3 = leftSupply s4
                                                          s2 = rightSupply s4
                                                   in s3 `seq` (s2 `seq`
                                                   Curry_Prelude.nd_OP_dot
                                                   (wrapDX (wrapDX id) (acceptCs
                                                   (acceptCs id)
                                                   FlatCurry.Typed.Curry_Types.C_TBranch))
                                                   (nd_C_updTPatArgs (wrapNX id
                                                   (Curry_Prelude.nd_C_map
                                                   (wrapNX id
                                                   (nd_OP_rnmAllVars_dot_uscore_hash_lambda45
                                                   x1)))) s2 cd cs) s3 cd cs)
  in wrapNX id (nd_C_trTExpr (wrapNX id (nd_OP_rnmAllVars_dot_var_dot_451 x1))
  (wrapDX (wrapDX id) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLit)) (wrapDX (wrapDX (wrapDX (wrapDX id)))
  (acceptCs (acceptCs (acceptCs (acceptCs id)))
  FlatCurry.Typed.Curry_Types.C_TComb)) x2 x3 (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TOr)) (wrapDX (wrapDX (wrapDX id))
  (acceptCs (acceptCs (acceptCs id)) FlatCurry.Typed.Curry_Types.C_TCase)) x4
  (wrapDX (wrapDX id) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TTyped))))))))

d_OP_rnmAllVars_dot_var_dot_451 :: (Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_Int) -> FlatCurry.Curry_Types.C_TypeExpr -> Cover
  -> ConstStore -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_OP_rnmAllVars_dot_var_dot_451 x1 x2 cd cs = Curry_Prelude.d_OP_dot (acceptCs
  id (FlatCurry.Typed.Curry_Types.C_TVarE x2)) x1 cd cs

nd_OP_rnmAllVars_dot_var_dot_451 :: Func Curry_Prelude.C_Int Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  Curry_Prelude.C_Int FlatCurry.Typed.Curry_Types.C_TExpr
nd_OP_rnmAllVars_dot_var_dot_451 x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX id (acceptCs id
  (FlatCurry.Typed.Curry_Types.C_TVarE x2))) x1 s0 cd cs

d_OP_rnmAllVars_dot_uscore_hash_lambda43 :: (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.C_Int) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) FlatCurry.Typed.Curry_Types.C_TExpr
d_OP_rnmAllVars_dot_uscore_hash_lambda43 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_0 x4 x1 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_rnmAllVars_dot_uscore_hash_lambda43 x1 l cd cs)
    (d_OP_rnmAllVars_dot_uscore_hash_lambda43 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_rnmAllVars_dot_uscore_hash_lambda43 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_rnmAllVars_dot_uscore_hash_lambda43 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.rnmAllVars._#lambda43" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.rnmAllVars._#lambda43"
    (showCons x2))

nd_OP_rnmAllVars_dot_uscore_hash_lambda43 :: Func Curry_Prelude.C_Int
  Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  FlatCurry.Typed.Curry_Types.C_TExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) FlatCurry.Typed.Curry_Types.C_TExpr
nd_OP_rnmAllVars_dot_uscore_hash_lambda43 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s0 = s
    in s0 `seq` nd_C__case_0 x4 x1 x3 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_rnmAllVars_dot_uscore_hash_lambda43 x1 l s cd cs)
    (nd_OP_rnmAllVars_dot_uscore_hash_lambda43 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_rnmAllVars_dot_uscore_hash_lambda43 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_rnmAllVars_dot_uscore_hash_lambda43 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.rnmAllVars._#lambda43" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.rnmAllVars._#lambda43"
    (showCons x2))

d_OP_rnmAllVars_dot_uscore_hash_lambda44 :: (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.C_Int) -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr
d_OP_rnmAllVars_dot_uscore_hash_lambda44 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_C_apply x1 x3 cd cs) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_rnmAllVars_dot_uscore_hash_lambda44 x1 l cd cs)
    (d_OP_rnmAllVars_dot_uscore_hash_lambda44 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_rnmAllVars_dot_uscore_hash_lambda44 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_rnmAllVars_dot_uscore_hash_lambda44 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.rnmAllVars._#lambda44" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.rnmAllVars._#lambda44"
    (showCons x2))

nd_OP_rnmAllVars_dot_uscore_hash_lambda44 :: Func Curry_Prelude.C_Int
  Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr
nd_OP_rnmAllVars_dot_uscore_hash_lambda44 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_apply x1 x3 s0 cd
    cs) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_rnmAllVars_dot_uscore_hash_lambda44 x1 l s cd cs)
    (nd_OP_rnmAllVars_dot_uscore_hash_lambda44 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_rnmAllVars_dot_uscore_hash_lambda44 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_rnmAllVars_dot_uscore_hash_lambda44 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.rnmAllVars._#lambda44" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.rnmAllVars._#lambda44"
    (showCons x2))

d_OP_rnmAllVars_dot_uscore_hash_lambda45 :: (Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.C_Int) -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr
d_OP_rnmAllVars_dot_uscore_hash_lambda45 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_C_apply x1 x3 cd cs) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_rnmAllVars_dot_uscore_hash_lambda45 x1 l cd cs)
    (d_OP_rnmAllVars_dot_uscore_hash_lambda45 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_rnmAllVars_dot_uscore_hash_lambda45 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_rnmAllVars_dot_uscore_hash_lambda45 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.rnmAllVars._#lambda45" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.rnmAllVars._#lambda45"
    (showCons x2))

nd_OP_rnmAllVars_dot_uscore_hash_lambda45 :: Func Curry_Prelude.C_Int
  Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr
nd_OP_rnmAllVars_dot_uscore_hash_lambda45 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_apply x1 x3 s0 cd
    cs) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_rnmAllVars_dot_uscore_hash_lambda45 x1 l s cd cs)
    (nd_OP_rnmAllVars_dot_uscore_hash_lambda45 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_rnmAllVars_dot_uscore_hash_lambda45 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_rnmAllVars_dot_uscore_hash_lambda45 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.rnmAllVars._#lambda45" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.rnmAllVars._#lambda45"
    (showCons x2))

d_C_updQNames :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C_updQNames x1 cd cs = let x2 = Curry_Prelude.d_OP_dot (acceptCs (acceptCs id)
                               FlatCurry.Typed.Curry_Types.C_TBranch)
                               (d_C_updTPatCons x1 cd cs) cd cs
  in d_C_trTExpr (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TVarE)
  (acceptCs (acceptCs id) FlatCurry.Typed.Curry_Types.C_TLit) (acceptCs
  (acceptCs (acceptCs id)) (d_OP_updQNames_dot_comb_dot_461 x1)) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TLet) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TFree) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TOr) (acceptCs (acceptCs (acceptCs id))
  FlatCurry.Typed.Curry_Types.C_TCase) x2 (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TTyped)

nd_C_updQNames :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Func FlatCurry.Typed.Curry_Types.C_TExpr
  FlatCurry.Typed.Curry_Types.C_TExpr
nd_C_updQNames x1 s cd cs = let s2 = s
  in s2 `seq` (let x2 = let s1 = leftSupply s2
                            s0 = rightSupply s2
                     in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX
                     (wrapDX id) (acceptCs (acceptCs id)
                     FlatCurry.Typed.Curry_Types.C_TBranch)) (nd_C_updTPatCons
                     x1 s0 cd cs) s1 cd cs)
  in wrapNX id (nd_C_trTExpr (wrapDX (wrapDX id) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TVarE)) (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Typed.Curry_Types.C_TLit)) (wrapDX (wrapDX (wrapDX (wrapNX id)))
  (acceptCs (acceptCs (acceptCs id)) (nd_OP_updQNames_dot_comb_dot_461 x1)))
  (wrapDX (wrapDX id) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLet)) (wrapDX (wrapDX id) (acceptCs (acceptCs
  id) FlatCurry.Typed.Curry_Types.C_TFree)) (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TOr)) (wrapDX (wrapDX (wrapDX id))
  (acceptCs (acceptCs (acceptCs id)) FlatCurry.Typed.Curry_Types.C_TCase)) x2
  (wrapDX (wrapDX id) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TTyped))))

d_OP_updQNames_dot_comb_dot_461 :: (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_OP_updQNames_dot_comb_dot_461 x1 x2 x3 x4 x5 cd cs =
  FlatCurry.Typed.Curry_Types.C_TComb x2 x3 (Curry_Prelude.d_C_apply x1 x4 cd
  cs) x5

nd_OP_updQNames_dot_comb_dot_461 :: Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TExpr -> IDSupply -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
nd_OP_updQNames_dot_comb_dot_461 x1 x2 x3 x4 x5 s cd cs = let s0 = s
  in s0 `seq` FlatCurry.Typed.Curry_Types.C_TComb x2 x3
  (Curry_Prelude.nd_C_apply x1 x4 s0 cd cs) x5

d_C_trTBranch :: forall t0 . (Curry_Prelude.Curry
  t0) => (FlatCurry.Typed.Curry_Types.C_TPattern -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore -> t0)
  -> FlatCurry.Typed.Curry_Types.C_TBranchExpr -> Cover -> ConstStore -> t0
d_C_trTBranch x1 x2 cd cs = case x2 of
  FlatCurry.Typed.Curry_Types.C_TBranch x3 x4 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x1 x3 cd cs) x4 cd cs
  FlatCurry.Typed.Curry_Types.Choice_C_TBranchExpr d i l r -> narrow d i
    (d_C_trTBranch x1 l cd cs) (d_C_trTBranch x1 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TBranchExpr d i xs -> narrows cs d i
    (\z -> d_C_trTBranch x1 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TBranchExpr d c e -> guardCons d c ((\x ->
    d_C_trTBranch x1 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TBranchExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.trTBranch" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.trTBranch" (showCons x2))

nd_C_trTBranch :: forall t0 . (Curry_Prelude.Curry t0) => Func
  FlatCurry.Typed.Curry_Types.C_TPattern (Func
  FlatCurry.Typed.Curry_Types.C_TExpr t0)
  -> FlatCurry.Typed.Curry_Types.C_TBranchExpr -> IDSupply -> Cover
  -> ConstStore -> t0
nd_C_trTBranch x1 x2 s cd cs = case x2 of
  FlatCurry.Typed.Curry_Types.C_TBranch x3 x4 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x3 s0 cd cs) x4 s1 cd cs))
  FlatCurry.Typed.Curry_Types.Choice_C_TBranchExpr d i l r -> narrow d i
    (nd_C_trTBranch x1 l s cd cs) (nd_C_trTBranch x1 r s cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TBranchExpr d i xs -> narrows cs d i
    (\z -> nd_C_trTBranch x1 z s cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TBranchExpr d c e -> guardCons d c ((\x ->
    nd_C_trTBranch x1 e s cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TBranchExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.trTBranch" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.trTBranch" (showCons x2))

d_C_tBranchTPattern :: Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TBranchExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TPattern
d_C_tBranchTPattern cd cs = d_C_trTBranch (acceptCs id Curry_Prelude.d_C_const)

d_C_tBranchTExpr :: Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TBranchExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C_tBranchTExpr cd cs = d_C_trTBranch (acceptCs id
  d_OP_tBranchTExpr_dot_uscore_hash_lambda46)

d_OP_tBranchTExpr_dot_uscore_hash_lambda46 :: FlatCurry.Typed.Curry_Types.C_TPattern
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_OP_tBranchTExpr_dot_uscore_hash_lambda46 x1 x2 cd cs = x2

d_C_updTBranch :: (FlatCurry.Typed.Curry_Types.C_TPattern -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TPattern)
  -> (FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TBranchExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TBranchExpr
d_C_updTBranch x1 x2 cd cs = d_C_trTBranch (acceptCs id
  (d_OP_updTBranch_dot_branch_dot_474 x2 x1))

nd_C_updTBranch :: Func FlatCurry.Typed.Curry_Types.C_TPattern
  FlatCurry.Typed.Curry_Types.C_TPattern -> Func
  FlatCurry.Typed.Curry_Types.C_TExpr FlatCurry.Typed.Curry_Types.C_TExpr
  -> IDSupply -> Cover -> ConstStore -> Func
  FlatCurry.Typed.Curry_Types.C_TBranchExpr
  FlatCurry.Typed.Curry_Types.C_TBranchExpr
nd_C_updTBranch x1 x2 s cd cs = wrapNX id (nd_C_trTBranch (wrapDX (wrapNX id)
  (acceptCs id (nd_OP_updTBranch_dot_branch_dot_474 x2 x1))))

d_OP_updTBranch_dot_branch_dot_474 :: (FlatCurry.Typed.Curry_Types.C_TExpr
  -> Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TExpr)
  -> (FlatCurry.Typed.Curry_Types.C_TPattern -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TPattern)
  -> FlatCurry.Typed.Curry_Types.C_TPattern
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TBranchExpr
d_OP_updTBranch_dot_branch_dot_474 x1 x2 x3 x4 cd cs =
  FlatCurry.Typed.Curry_Types.C_TBranch (Curry_Prelude.d_C_apply x2 x3 cd cs)
  (Curry_Prelude.d_C_apply x1 x4 cd cs)

nd_OP_updTBranch_dot_branch_dot_474 :: Func FlatCurry.Typed.Curry_Types.C_TExpr
  FlatCurry.Typed.Curry_Types.C_TExpr -> Func
  FlatCurry.Typed.Curry_Types.C_TPattern FlatCurry.Typed.Curry_Types.C_TPattern
  -> FlatCurry.Typed.Curry_Types.C_TPattern
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> IDSupply -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TBranchExpr
nd_OP_updTBranch_dot_branch_dot_474 x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` FlatCurry.Typed.Curry_Types.C_TBranch
  (Curry_Prelude.nd_C_apply x2 x3 s0 cd cs) (Curry_Prelude.nd_C_apply x1 x4 s1
  cd cs)))

d_C_updTBranchTPattern :: (FlatCurry.Typed.Curry_Types.C_TPattern -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TPattern) -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TBranchExpr -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TBranchExpr
d_C_updTBranchTPattern x1 cd cs = d_C_updTBranch x1 Curry_Prelude.d_C_id cd cs

nd_C_updTBranchTPattern :: Func FlatCurry.Typed.Curry_Types.C_TPattern
  FlatCurry.Typed.Curry_Types.C_TPattern -> IDSupply -> Cover -> ConstStore
  -> Func FlatCurry.Typed.Curry_Types.C_TBranchExpr
  FlatCurry.Typed.Curry_Types.C_TBranchExpr
nd_C_updTBranchTPattern x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updTBranch x1 (wrapDX id Curry_Prelude.d_C_id) s0 cd cs

d_C_updTBranchTExpr :: Cover -> ConstStore
  -> (FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TBranchExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TBranchExpr
d_C_updTBranchTExpr cd cs = d_C_updTBranch Curry_Prelude.d_C_id

nd_C_updTBranchTExpr :: IDSupply -> Cover -> ConstStore -> Func (Func
  FlatCurry.Typed.Curry_Types.C_TExpr FlatCurry.Typed.Curry_Types.C_TExpr) (Func
  FlatCurry.Typed.Curry_Types.C_TBranchExpr
  FlatCurry.Typed.Curry_Types.C_TBranchExpr)
nd_C_updTBranchTExpr s cd cs = wrapNX id (nd_C_updTBranch (wrapDX id
  Curry_Prelude.d_C_id))

d_C_trTPattern :: forall t0 . (Curry_Prelude.Curry
  t0) => (FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore -> t0)
  -> (FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Literal -> Cover -> ConstStore -> t0)
  -> FlatCurry.Typed.Curry_Types.C_TPattern -> Cover -> ConstStore -> t0
d_C_trTPattern x1 x2 x3 cd cs = case x3 of
  FlatCurry.Typed.Curry_Types.C_TPattern x4 x5 x6 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x1 x4 cd cs) x5 cd cs) x6
    cd cs
  FlatCurry.Typed.Curry_Types.C_TLPattern x7 x8 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x2 x7 cd cs) x8 cd cs
  FlatCurry.Typed.Curry_Types.Choice_C_TPattern d i l r -> narrow d i
    (d_C_trTPattern x1 x2 l cd cs) (d_C_trTPattern x1 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TPattern d i xs -> narrows cs d i (\z ->
    d_C_trTPattern x1 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TPattern d c e -> guardCons d c ((\x ->
    d_C_trTPattern x1 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TPattern d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.trTPattern" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.trTPattern" (showCons x3))

nd_C_trTPattern :: forall t0 . (Curry_Prelude.Curry t0) => Func
  FlatCurry.Curry_Types.C_TypeExpr (Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)) t0)) -> Func
  FlatCurry.Curry_Types.C_TypeExpr (Func FlatCurry.Curry_Types.C_Literal t0)
  -> FlatCurry.Typed.Curry_Types.C_TPattern -> IDSupply -> Cover -> ConstStore
  -> t0
nd_C_trTPattern x1 x2 x3 s cd cs = case x3 of
  FlatCurry.Typed.Curry_Types.C_TPattern x4 x5 x6 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x4 s0 cd cs) x5 s1 cd cs)) x6 s3 cd cs))
  FlatCurry.Typed.Curry_Types.C_TLPattern x7 x8 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2
    x7 s0 cd cs) x8 s1 cd cs))
  FlatCurry.Typed.Curry_Types.Choice_C_TPattern d i l r -> narrow d i
    (nd_C_trTPattern x1 x2 l s cd cs) (nd_C_trTPattern x1 x2 r s cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TPattern d i xs -> narrows cs d i (\z ->
    nd_C_trTPattern x1 x2 z s cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TPattern d c e -> guardCons d c ((\x ->
    nd_C_trTPattern x1 x2 e s cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TPattern d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies.trTPattern" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies.trTPattern" (showCons x3))

d_C_tPatCons :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TPattern
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_tPatCons cd cs = d_C_trTPattern (acceptCs (acceptCs id)
  d_OP_tPatCons_dot_uscore_hash_lambda47) (Curry_Prelude.d_C_error
  (Curry_Prelude.toCurryString "undefined") cd cs)

d_OP_tPatCons_dot_uscore_hash_lambda47 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_tPatCons_dot_uscore_hash_lambda47 x1 x2 x3 cd cs = x2

d_C_tPatArgs :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TPattern
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
d_C_tPatArgs cd cs = d_C_trTPattern (acceptCs (acceptCs id)
  d_OP_tPatArgs_dot_uscore_hash_lambda48) (Curry_Prelude.d_C_error
  (Curry_Prelude.toCurryString "undefined") cd cs)

d_OP_tPatArgs_dot_uscore_hash_lambda48 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
d_OP_tPatArgs_dot_uscore_hash_lambda48 x1 x2 x3 cd cs = x3

d_C_tPatLiteral :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TPattern
  -> Cover -> ConstStore -> FlatCurry.Curry_Types.C_Literal
d_C_tPatLiteral cd cs = d_C_trTPattern (Curry_Prelude.d_C_error
  (Curry_Prelude.toCurryString "undefined") cd cs) (Curry_Prelude.d_C_const
  Curry_Prelude.d_C_id)

d_C_isConsPattern :: Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TPattern -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isConsPattern cd cs = d_C_trTPattern (acceptCs (acceptCs id)
  d_OP_isConsPattern_dot_uscore_hash_lambda49) (acceptCs id
  d_OP_isConsPattern_dot_uscore_hash_lambda50)

d_OP_isConsPattern_dot_uscore_hash_lambda49 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_isConsPattern_dot_uscore_hash_lambda49 x1 x2 x3 cd cs =
  Curry_Prelude.C_True

d_OP_isConsPattern_dot_uscore_hash_lambda50 :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_Literal -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_OP_isConsPattern_dot_uscore_hash_lambda50 x1 x2 cd cs = Curry_Prelude.C_False

d_C_updTPattern :: (FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeExpr) -> (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) -> (FlatCurry.Curry_Types.C_Literal
  -> Cover -> ConstStore -> FlatCurry.Curry_Types.C_Literal) -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TPattern -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TPattern
d_C_updTPattern x1 x2 x3 x4 cd cs = d_C_trTPattern (acceptCs (acceptCs id)
  (d_OP_updTPattern_dot_pattern_dot_509 x1 x3 x2)) (acceptCs id
  (d_OP_updTPattern_dot_lpattern_dot_509 x4 x1))

nd_C_updTPattern :: Func FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) -> Func FlatCurry.Curry_Types.C_Literal
  FlatCurry.Curry_Types.C_Literal -> IDSupply -> Cover -> ConstStore -> Func
  FlatCurry.Typed.Curry_Types.C_TPattern FlatCurry.Typed.Curry_Types.C_TPattern
nd_C_updTPattern x1 x2 x3 x4 s cd cs = wrapNX id (nd_C_trTPattern (wrapDX
  (wrapDX (wrapNX id)) (acceptCs (acceptCs id)
  (nd_OP_updTPattern_dot_pattern_dot_509 x1 x3 x2))) (wrapDX (wrapNX id)
  (acceptCs id (nd_OP_updTPattern_dot_lpattern_dot_509 x4 x1))))

d_OP_updTPattern_dot_pattern_dot_509 :: (FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> FlatCurry.Curry_Types.C_TypeExpr)
  -> (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) -> (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TPattern
d_OP_updTPattern_dot_pattern_dot_509 x1 x2 x3 x4 x5 x6 cd cs =
  FlatCurry.Typed.Curry_Types.C_TPattern (Curry_Prelude.d_C_apply x1 x4 cd cs)
  (Curry_Prelude.d_C_apply x3 x5 cd cs) (Curry_Prelude.d_C_apply x2 x6 cd cs)

nd_OP_updTPattern_dot_pattern_dot_509 :: Func FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) -> IDSupply -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TPattern
nd_OP_updTPattern_dot_pattern_dot_509 x1 x2 x3 x4 x5 x6 s cd cs = let s3 = s
  in s3 `seq` (let s0 = leftSupply s3
                   s4 = rightSupply s3
                   s1 = leftSupply s4
                   s2 = rightSupply s4
  in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq`
  FlatCurry.Typed.Curry_Types.C_TPattern (Curry_Prelude.nd_C_apply x1 x4 s0 cd
  cs) (Curry_Prelude.nd_C_apply x3 x5 s1 cd cs) (Curry_Prelude.nd_C_apply x2 x6
  s2 cd cs)))))

d_OP_updTPattern_dot_lpattern_dot_509 :: (FlatCurry.Curry_Types.C_Literal
  -> Cover -> ConstStore -> FlatCurry.Curry_Types.C_Literal)
  -> (FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeExpr) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_Literal -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TPattern
d_OP_updTPattern_dot_lpattern_dot_509 x1 x2 x3 x4 cd cs =
  FlatCurry.Typed.Curry_Types.C_TLPattern (Curry_Prelude.d_C_apply x2 x3 cd cs)
  (Curry_Prelude.d_C_apply x1 x4 cd cs)

nd_OP_updTPattern_dot_lpattern_dot_509 :: Func FlatCurry.Curry_Types.C_Literal
  FlatCurry.Curry_Types.C_Literal -> Func FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_Literal -> IDSupply -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TPattern
nd_OP_updTPattern_dot_lpattern_dot_509 x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` FlatCurry.Typed.Curry_Types.C_TLPattern
  (Curry_Prelude.nd_C_apply x2 x3 s0 cd cs) (Curry_Prelude.nd_C_apply x1 x4 s1
  cd cs)))

d_C_updTPatType :: (FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TPattern -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TPattern
d_C_updTPatType x1 cd cs = d_C_updTPattern x1 Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id cd cs

nd_C_updTPatType :: Func FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  FlatCurry.Typed.Curry_Types.C_TPattern FlatCurry.Typed.Curry_Types.C_TPattern
nd_C_updTPatType x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updTPattern x1 (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) s0 cd cs

d_C_updTPatCons :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TPattern -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TPattern
d_C_updTPatCons x1 cd cs = d_C_updTPattern Curry_Prelude.d_C_id x1
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id cd cs

nd_C_updTPatCons :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Func FlatCurry.Typed.Curry_Types.C_TPattern
  FlatCurry.Typed.Curry_Types.C_TPattern
nd_C_updTPatCons x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updTPattern (wrapDX id Curry_Prelude.d_C_id) x1 (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) s0 cd cs

d_C_updTPatArgs :: (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TPattern -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TPattern
d_C_updTPatArgs x1 cd cs = d_C_updTPattern Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id x1 Curry_Prelude.d_C_id cd cs

nd_C_updTPatArgs :: Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) -> IDSupply -> Cover -> ConstStore -> Func
  FlatCurry.Typed.Curry_Types.C_TPattern FlatCurry.Typed.Curry_Types.C_TPattern
nd_C_updTPatArgs x1 s cd cs = let s0 = s
  in s0 `seq` nd_C_updTPattern (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id) x1 (wrapDX id Curry_Prelude.d_C_id) s0 cd cs

d_C_updTPatLiteral :: Cover -> ConstStore -> (FlatCurry.Curry_Types.C_Literal
  -> Cover -> ConstStore -> FlatCurry.Curry_Types.C_Literal) -> Cover
  -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TPattern -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TPattern
d_C_updTPatLiteral cd cs = d_C_updTPattern Curry_Prelude.d_C_id
  Curry_Prelude.d_C_id Curry_Prelude.d_C_id

nd_C_updTPatLiteral :: IDSupply -> Cover -> ConstStore -> Func (Func
  FlatCurry.Curry_Types.C_Literal FlatCurry.Curry_Types.C_Literal) (Func
  FlatCurry.Typed.Curry_Types.C_TPattern FlatCurry.Typed.Curry_Types.C_TPattern)
nd_C_updTPatLiteral s cd cs = wrapNX id (nd_C_updTPattern (wrapDX id
  Curry_Prelude.d_C_id) (wrapDX id Curry_Prelude.d_C_id) (wrapDX id
  Curry_Prelude.d_C_id))

d_C_tPatExpr :: Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TPattern
  -> Cover -> ConstStore -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C_tPatExpr cd cs = d_C_trTPattern (acceptCs id
  d_OP_tPatExpr_dot_uscore_hash_lambda51) (acceptCs (acceptCs id)
  FlatCurry.Typed.Curry_Types.C_TLit)

d_OP_tPatExpr_dot_uscore_hash_lambda51 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_OP_tPatExpr_dot_uscore_hash_lambda51 x1 x2 cd cs = Curry_Prelude.d_OP_dot
  (acceptCs id (FlatCurry.Typed.Curry_Types.C_TComb x1
  FlatCurry.Curry_Types.C_ConsCall x2)) (Curry_Prelude.d_C_map
  (Curry_Prelude.d_C_uncurry (acceptCs id (Curry_Prelude.d_C_flip (acceptCs
  (acceptCs id) FlatCurry.Typed.Curry_Types.C_TVarE))))) cd cs

d_C__case_32 :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Typed.Curry_Types.C_TProg -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> t0 -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0
d_C__case_32 x1 x4 x5 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 x2 x5
  Curry_Prelude.C_False -> d_C__case_31 x5 x4 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_32 x1 x4 x5 x2 l
    cd cs) (d_C__case_32 x1 x4 x5 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_32 x1
    x4 x5 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_32 x1 x4
    x5 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_32" [show x1, show x4, show x5, show x2, show
    x6] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_32" (showCons x6))

d_C__case_31 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0
d_C__case_31 x5 x4 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 x4 x5
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_31 x5 x4 l cd cs)
    (d_C__case_31 x5 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_31 x5
    x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_31 x5 x4 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_31" [show x5, show x4, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_31" (showCons x6))

d_C__case_30 :: FlatCurry.Typed.Curry_Types.C_TFuncDecl -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TExpr
d_C__case_30 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> d_OP_tFuncRHS_dot_orCase_dot_130
    (Curry_Prelude.d_C_apply (d_C_tFuncBody cd cs) x1 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_29 (Curry_Prelude.d_C_otherwise cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_30 x1 l cd cs)
    (d_C__case_30 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_30 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_30 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_30" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_30" (showCons x2))

d_C__case_29 :: Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List FlatCurry.Typed.Curry_Types.C_TExpr
d_C__case_29 x1 cd cs = case x1 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_29 l cd cs)
    (d_C__case_29 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_29 z cd
    cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_29 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_29" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_29" (showCons x1))

d_C__case_28 :: FlatCurry.Typed.Curry_Types.C_TExpr -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TExpr
d_C__case_28 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap
    d_OP_tFuncRHS_dot_orCase_dot_130 cd cs) (d_C_orExps x1 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_27 x1 (d_C_isTCase x1 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_28 x1 l cd cs)
    (d_C__case_28 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_28 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_28 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_28" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_28" (showCons x2))

d_C__case_27 :: FlatCurry.Typed.Curry_Types.C_TExpr -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TExpr
d_C__case_27 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap
    (Curry_Prelude.d_OP_dot d_OP_tFuncRHS_dot_orCase_dot_130 (d_C_tBranchTExpr
    cd cs) cd cs) cd cs) (d_C_caseBranches x1 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_26 x1 (Curry_Prelude.d_C_otherwise cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_27 x1 l cd cs)
    (d_C__case_27 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_27 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_27 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_27" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_27" (showCons x2))

d_C__case_26 :: FlatCurry.Typed.Curry_Types.C_TExpr -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TExpr
d_C__case_26 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_26 x1 l cd cs)
    (d_C__case_26 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_26 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_26 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_26" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_26" (showCons x2))

d_C__case_25 :: Curry_Prelude.C_Int -> FlatCurry.Typed.Curry_Types.C_TExpr
  -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C__case_25 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TVarE x3 x4 -> x4
  FlatCurry.Typed.Curry_Types.C_TLit x5 x6 -> x2
  FlatCurry.Typed.Curry_Types.C_TComb x7 x8 x9 x10 -> x2
  FlatCurry.Typed.Curry_Types.C_TLet x11 x12 -> x2
  FlatCurry.Typed.Curry_Types.C_TFree x13 x14 -> x2
  FlatCurry.Typed.Curry_Types.C_TOr x15 x16 -> x2
  FlatCurry.Typed.Curry_Types.C_TCase x17 x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_25
    x2 l cd cs) (d_C__case_25 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_25 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_25 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_25" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_25" (showCons x1))

d_C__case_24 :: FlatCurry.Curry_Types.C_Literal
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Literal
d_C__case_24 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TLit x3 x4 -> x4
  FlatCurry.Typed.Curry_Types.C_TVarE x5 x6 -> x2
  FlatCurry.Typed.Curry_Types.C_TComb x7 x8 x9 x10 -> x2
  FlatCurry.Typed.Curry_Types.C_TLet x11 x12 -> x2
  FlatCurry.Typed.Curry_Types.C_TFree x13 x14 -> x2
  FlatCurry.Typed.Curry_Types.C_TOr x15 x16 -> x2
  FlatCurry.Typed.Curry_Types.C_TCase x17 x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_24
    x2 l cd cs) (d_C__case_24 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_24 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_24 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_24" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_24" (showCons x1))

d_C__case_23 :: FlatCurry.Curry_Types.C_CombType
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_CombType
d_C__case_23 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TComb x3 x4 x5 x6 -> x4
  FlatCurry.Typed.Curry_Types.C_TVarE x7 x8 -> x2
  FlatCurry.Typed.Curry_Types.C_TLit x9 x10 -> x2
  FlatCurry.Typed.Curry_Types.C_TLet x11 x12 -> x2
  FlatCurry.Typed.Curry_Types.C_TFree x13 x14 -> x2
  FlatCurry.Typed.Curry_Types.C_TOr x15 x16 -> x2
  FlatCurry.Typed.Curry_Types.C_TCase x17 x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_23
    x2 l cd cs) (d_C__case_23 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_23 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_23 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_23" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_23" (showCons x1))

d_C__case_22 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_22 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TComb x3 x4 x5 x6 -> x5
  FlatCurry.Typed.Curry_Types.C_TVarE x7 x8 -> x2
  FlatCurry.Typed.Curry_Types.C_TLit x9 x10 -> x2
  FlatCurry.Typed.Curry_Types.C_TLet x11 x12 -> x2
  FlatCurry.Typed.Curry_Types.C_TFree x13 x14 -> x2
  FlatCurry.Typed.Curry_Types.C_TOr x15 x16 -> x2
  FlatCurry.Typed.Curry_Types.C_TCase x17 x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_22
    x2 l cd cs) (d_C__case_22 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_22 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_22 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_22" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_22" (showCons x1))

d_C__case_21 :: Curry_Prelude.OP_List FlatCurry.Typed.Curry_Types.C_TExpr
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List FlatCurry.Typed.Curry_Types.C_TExpr
d_C__case_21 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TComb x3 x4 x5 x6 -> x6
  FlatCurry.Typed.Curry_Types.C_TVarE x7 x8 -> x2
  FlatCurry.Typed.Curry_Types.C_TLit x9 x10 -> x2
  FlatCurry.Typed.Curry_Types.C_TLet x11 x12 -> x2
  FlatCurry.Typed.Curry_Types.C_TFree x13 x14 -> x2
  FlatCurry.Typed.Curry_Types.C_TOr x15 x16 -> x2
  FlatCurry.Typed.Curry_Types.C_TCase x17 x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_21
    x2 l cd cs) (d_C__case_21 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_21 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_21 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_21" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_21" (showCons x1))

d_C__case_20 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  FlatCurry.Typed.Curry_Types.C_TExpr) -> FlatCurry.Typed.Curry_Types.C_TExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  FlatCurry.Typed.Curry_Types.C_TExpr)
d_C__case_20 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TLet x3 x4 -> x3
  FlatCurry.Typed.Curry_Types.C_TVarE x5 x6 -> x2
  FlatCurry.Typed.Curry_Types.C_TLit x7 x8 -> x2
  FlatCurry.Typed.Curry_Types.C_TComb x9 x10 x11 x12 -> x2
  FlatCurry.Typed.Curry_Types.C_TFree x13 x14 -> x2
  FlatCurry.Typed.Curry_Types.C_TOr x15 x16 -> x2
  FlatCurry.Typed.Curry_Types.C_TCase x17 x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_20
    x2 l cd cs) (d_C__case_20 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_20 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_20 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_20" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_20" (showCons x1))

d_C__case_19 :: FlatCurry.Typed.Curry_Types.C_TExpr
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C__case_19 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TLet x3 x4 -> x4
  FlatCurry.Typed.Curry_Types.C_TVarE x5 x6 -> x2
  FlatCurry.Typed.Curry_Types.C_TLit x7 x8 -> x2
  FlatCurry.Typed.Curry_Types.C_TComb x9 x10 x11 x12 -> x2
  FlatCurry.Typed.Curry_Types.C_TFree x13 x14 -> x2
  FlatCurry.Typed.Curry_Types.C_TOr x15 x16 -> x2
  FlatCurry.Typed.Curry_Types.C_TCase x17 x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_19
    x2 l cd cs) (d_C__case_19 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_19 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_19 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_19" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_19" (showCons x1))

d_C__case_18 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
d_C__case_18 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TFree x3 x4 -> x3
  FlatCurry.Typed.Curry_Types.C_TVarE x5 x6 -> x2
  FlatCurry.Typed.Curry_Types.C_TLit x7 x8 -> x2
  FlatCurry.Typed.Curry_Types.C_TComb x9 x10 x11 x12 -> x2
  FlatCurry.Typed.Curry_Types.C_TLet x13 x14 -> x2
  FlatCurry.Typed.Curry_Types.C_TOr x15 x16 -> x2
  FlatCurry.Typed.Curry_Types.C_TCase x17 x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_18
    x2 l cd cs) (d_C__case_18 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_18 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_18 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_18" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_18" (showCons x1))

d_C__case_17 :: FlatCurry.Typed.Curry_Types.C_TExpr
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C__case_17 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TFree x3 x4 -> x4
  FlatCurry.Typed.Curry_Types.C_TVarE x5 x6 -> x2
  FlatCurry.Typed.Curry_Types.C_TLit x7 x8 -> x2
  FlatCurry.Typed.Curry_Types.C_TComb x9 x10 x11 x12 -> x2
  FlatCurry.Typed.Curry_Types.C_TLet x13 x14 -> x2
  FlatCurry.Typed.Curry_Types.C_TOr x15 x16 -> x2
  FlatCurry.Typed.Curry_Types.C_TCase x17 x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_17
    x2 l cd cs) (d_C__case_17 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_17 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_17 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_17" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_17" (showCons x1))

d_C__case_16 :: Curry_Prelude.OP_List FlatCurry.Typed.Curry_Types.C_TExpr
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List FlatCurry.Typed.Curry_Types.C_TExpr
d_C__case_16 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TOr x3 x4 -> Curry_Prelude.OP_Cons x3
    (Curry_Prelude.OP_Cons x4 Curry_Prelude.OP_List)
  FlatCurry.Typed.Curry_Types.C_TVarE x5 x6 -> x2
  FlatCurry.Typed.Curry_Types.C_TLit x7 x8 -> x2
  FlatCurry.Typed.Curry_Types.C_TComb x9 x10 x11 x12 -> x2
  FlatCurry.Typed.Curry_Types.C_TLet x13 x14 -> x2
  FlatCurry.Typed.Curry_Types.C_TFree x15 x16 -> x2
  FlatCurry.Typed.Curry_Types.C_TCase x17 x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_16
    x2 l cd cs) (d_C__case_16 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_16 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_16 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_16" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_16" (showCons x1))

d_C__case_15 :: FlatCurry.Curry_Types.C_CaseType
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_CaseType
d_C__case_15 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TCase x3 x4 x5 -> x3
  FlatCurry.Typed.Curry_Types.C_TVarE x6 x7 -> x2
  FlatCurry.Typed.Curry_Types.C_TLit x8 x9 -> x2
  FlatCurry.Typed.Curry_Types.C_TComb x10 x11 x12 x13 -> x2
  FlatCurry.Typed.Curry_Types.C_TLet x14 x15 -> x2
  FlatCurry.Typed.Curry_Types.C_TFree x16 x17 -> x2
  FlatCurry.Typed.Curry_Types.C_TOr x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_15
    x2 l cd cs) (d_C__case_15 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_15 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_15 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_15" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_15" (showCons x1))

d_C__case_14 :: FlatCurry.Typed.Curry_Types.C_TExpr
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> FlatCurry.Typed.Curry_Types.C_TExpr
d_C__case_14 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TCase x3 x4 x5 -> x4
  FlatCurry.Typed.Curry_Types.C_TVarE x6 x7 -> x2
  FlatCurry.Typed.Curry_Types.C_TLit x8 x9 -> x2
  FlatCurry.Typed.Curry_Types.C_TComb x10 x11 x12 x13 -> x2
  FlatCurry.Typed.Curry_Types.C_TLet x14 x15 -> x2
  FlatCurry.Typed.Curry_Types.C_TFree x16 x17 -> x2
  FlatCurry.Typed.Curry_Types.C_TOr x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_14
    x2 l cd cs) (d_C__case_14 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_14 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_14 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_14" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_14" (showCons x1))

d_C__case_13 :: Curry_Prelude.OP_List FlatCurry.Typed.Curry_Types.C_TBranchExpr
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List FlatCurry.Typed.Curry_Types.C_TBranchExpr
d_C__case_13 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TCase x3 x4 x5 -> x5
  FlatCurry.Typed.Curry_Types.C_TVarE x6 x7 -> x2
  FlatCurry.Typed.Curry_Types.C_TLit x8 x9 -> x2
  FlatCurry.Typed.Curry_Types.C_TComb x10 x11 x12 x13 -> x2
  FlatCurry.Typed.Curry_Types.C_TLet x14 x15 -> x2
  FlatCurry.Typed.Curry_Types.C_TFree x16 x17 -> x2
  FlatCurry.Typed.Curry_Types.C_TOr x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_13
    x2 l cd cs) (d_C__case_13 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_13 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_13 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_13" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_13" (showCons x1))

d_C__case_12 :: Curry_Prelude.C_Bool -> FlatCurry.Typed.Curry_Types.C_TExpr
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_12 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TVarE x3 x4 -> Curry_Prelude.C_True
  FlatCurry.Typed.Curry_Types.C_TLit x5 x6 -> x2
  FlatCurry.Typed.Curry_Types.C_TComb x7 x8 x9 x10 -> x2
  FlatCurry.Typed.Curry_Types.C_TLet x11 x12 -> x2
  FlatCurry.Typed.Curry_Types.C_TFree x13 x14 -> x2
  FlatCurry.Typed.Curry_Types.C_TOr x15 x16 -> x2
  FlatCurry.Typed.Curry_Types.C_TCase x17 x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_12
    x2 l cd cs) (d_C__case_12 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_12 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_12 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_12" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_12" (showCons x1))

d_C__case_11 :: Curry_Prelude.C_Bool -> FlatCurry.Typed.Curry_Types.C_TExpr
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_11 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TLit x3 x4 -> Curry_Prelude.C_True
  FlatCurry.Typed.Curry_Types.C_TVarE x5 x6 -> x2
  FlatCurry.Typed.Curry_Types.C_TComb x7 x8 x9 x10 -> x2
  FlatCurry.Typed.Curry_Types.C_TLet x11 x12 -> x2
  FlatCurry.Typed.Curry_Types.C_TFree x13 x14 -> x2
  FlatCurry.Typed.Curry_Types.C_TOr x15 x16 -> x2
  FlatCurry.Typed.Curry_Types.C_TCase x17 x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_11
    x2 l cd cs) (d_C__case_11 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_11 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_11 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_11" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_11" (showCons x1))

d_C__case_10 :: Curry_Prelude.C_Bool -> FlatCurry.Typed.Curry_Types.C_TExpr
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_10 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TComb x3 x4 x5 x6 -> Curry_Prelude.C_True
  FlatCurry.Typed.Curry_Types.C_TVarE x7 x8 -> x2
  FlatCurry.Typed.Curry_Types.C_TLit x9 x10 -> x2
  FlatCurry.Typed.Curry_Types.C_TLet x11 x12 -> x2
  FlatCurry.Typed.Curry_Types.C_TFree x13 x14 -> x2
  FlatCurry.Typed.Curry_Types.C_TOr x15 x16 -> x2
  FlatCurry.Typed.Curry_Types.C_TCase x17 x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_10
    x2 l cd cs) (d_C__case_10 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_10 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_10 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_10" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_10" (showCons x1))

d_C__case_9 :: Curry_Prelude.C_Bool -> FlatCurry.Typed.Curry_Types.C_TExpr
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_9 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TLet x3 x4 -> Curry_Prelude.C_True
  FlatCurry.Typed.Curry_Types.C_TVarE x5 x6 -> x2
  FlatCurry.Typed.Curry_Types.C_TLit x7 x8 -> x2
  FlatCurry.Typed.Curry_Types.C_TComb x9 x10 x11 x12 -> x2
  FlatCurry.Typed.Curry_Types.C_TFree x13 x14 -> x2
  FlatCurry.Typed.Curry_Types.C_TOr x15 x16 -> x2
  FlatCurry.Typed.Curry_Types.C_TCase x17 x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_9
    x2 l cd cs) (d_C__case_9 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_9 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_9 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_9" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_9" (showCons x1))

d_C__case_8 :: Curry_Prelude.C_Bool -> FlatCurry.Typed.Curry_Types.C_TExpr
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_8 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TFree x3 x4 -> Curry_Prelude.C_True
  FlatCurry.Typed.Curry_Types.C_TVarE x5 x6 -> x2
  FlatCurry.Typed.Curry_Types.C_TLit x7 x8 -> x2
  FlatCurry.Typed.Curry_Types.C_TComb x9 x10 x11 x12 -> x2
  FlatCurry.Typed.Curry_Types.C_TLet x13 x14 -> x2
  FlatCurry.Typed.Curry_Types.C_TOr x15 x16 -> x2
  FlatCurry.Typed.Curry_Types.C_TCase x17 x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_8
    x2 l cd cs) (d_C__case_8 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_8 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_8 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_8" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_8" (showCons x1))

d_C__case_7 :: Curry_Prelude.C_Bool -> FlatCurry.Typed.Curry_Types.C_TExpr
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_7 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TOr x3 x4 -> Curry_Prelude.C_True
  FlatCurry.Typed.Curry_Types.C_TVarE x5 x6 -> x2
  FlatCurry.Typed.Curry_Types.C_TLit x7 x8 -> x2
  FlatCurry.Typed.Curry_Types.C_TComb x9 x10 x11 x12 -> x2
  FlatCurry.Typed.Curry_Types.C_TLet x13 x14 -> x2
  FlatCurry.Typed.Curry_Types.C_TFree x15 x16 -> x2
  FlatCurry.Typed.Curry_Types.C_TCase x17 x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_7
    x2 l cd cs) (d_C__case_7 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_7 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_7 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_7" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_7" (showCons x1))

d_C__case_6 :: Curry_Prelude.C_Bool -> FlatCurry.Typed.Curry_Types.C_TExpr
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_6 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TCase x3 x4 x5 -> Curry_Prelude.C_True
  FlatCurry.Typed.Curry_Types.C_TVarE x6 x7 -> x2
  FlatCurry.Typed.Curry_Types.C_TLit x8 x9 -> x2
  FlatCurry.Typed.Curry_Types.C_TComb x10 x11 x12 x13 -> x2
  FlatCurry.Typed.Curry_Types.C_TLet x14 x15 -> x2
  FlatCurry.Typed.Curry_Types.C_TFree x16 x17 -> x2
  FlatCurry.Typed.Curry_Types.C_TOr x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x20 x21 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_6
    x2 l cd cs) (d_C__case_6 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_6 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_6 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_6" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_6" (showCons x1))

d_C__case_5 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore -> t1)
  -> (t1 -> Cover -> ConstStore -> FlatCurry.Curry_Types.C_TypeExpr -> Cover
  -> ConstStore -> t1) -> (FlatCurry.Typed.Curry_Types.C_TPattern -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0)
  -> (FlatCurry.Curry_Types.C_CaseType -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> t1) -> (t1
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t1)
  -> (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> t1) -> (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  t1) -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> t1)
  -> (FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_CombType -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t1 -> Cover -> ConstStore -> t1)
  -> (FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Literal -> Cover -> ConstStore -> t1)
  -> (FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> t1)
  -> FlatCurry.Typed.Curry_Types.C_TExpr -> Cover -> ConstStore -> t1
d_C__case_5 x11 x9 x8 x7 x6 x5 x4 x3 x2 x1 x10 cd cs = case x10 of
  FlatCurry.Typed.Curry_Types.C_TVarE x12 x13 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x1 x12 cd cs) x13 cd cs
  FlatCurry.Typed.Curry_Types.C_TLit x14 x15 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x2 x14 cd cs) x15 cd cs
  FlatCurry.Typed.Curry_Types.C_TComb x16 x17 x18 x19 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    x3 x16 cd cs) x17 cd cs) x18 cd cs) (Curry_Prelude.d_C_map x11 x19 cd cs) cd
    cs
  FlatCurry.Typed.Curry_Types.C_TLet x20 x21 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x4 (Curry_Prelude.d_C_map
    (d_OP_trTExpr_dot_uscore_hash_lambda39 x11) x20 cd cs) cd cs)
    (Curry_Prelude.d_C_apply x11 x21 cd cs) cd cs
  FlatCurry.Typed.Curry_Types.C_TFree x22 x23 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x5 x22 cd cs) (Curry_Prelude.d_C_apply x11 x23 cd
    cs) cd cs
  FlatCurry.Typed.Curry_Types.C_TOr x24 x25 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x6 (Curry_Prelude.d_C_apply x11 x24 cd cs) cd cs)
    (Curry_Prelude.d_C_apply x11 x25 cd cs) cd cs
  FlatCurry.Typed.Curry_Types.C_TCase x26 x27 x28 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x7 x26 cd cs)
    (Curry_Prelude.d_C_apply x11 x27 cd cs) cd cs) (Curry_Prelude.d_C_map
    (d_OP_trTExpr_dot_uscore_hash_lambda40 x11 x8) x28 cd cs) cd cs
  FlatCurry.Typed.Curry_Types.C_TTyped x29 x30 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x9 (Curry_Prelude.d_C_apply x11 x29 cd cs) cd cs)
    x30 cd cs
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_5
    x11 x9 x8 x7 x6 x5 x4 x3 x2 x1 l cd cs) (d_C__case_5 x11 x9 x8 x7 x6 x5 x4
    x3 x2 x1 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_5 x11 x9 x8 x7 x6 x5 x4 x3 x2 x1 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_5 x11 x9 x8 x7 x6 x5 x4 x3 x2 x1 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_5" [show x11, show x9, show x8, show x7, show
    x6, show x5, show x4, show x3, show x2, show x1, show x10] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_5" (showCons x10))

nd_C__case_5 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func FlatCurry.Typed.Curry_Types.C_TExpr t1 -> Func t1 (Func
  FlatCurry.Curry_Types.C_TypeExpr t1) -> Func
  FlatCurry.Typed.Curry_Types.C_TPattern (Func t1 t0) -> Func
  FlatCurry.Curry_Types.C_CaseType (Func t1 (Func (Curry_Prelude.OP_List t0)
  t1)) -> Func t1 (Func t1 t1) -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Func t1 t1) -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) t1)) (Func t1 t1) -> Func
  FlatCurry.Curry_Types.C_TypeExpr (Func FlatCurry.Curry_Types.C_CombType (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Func (Curry_Prelude.OP_List t1)
  t1))) -> Func FlatCurry.Curry_Types.C_TypeExpr (Func
  FlatCurry.Curry_Types.C_Literal t1) -> Func FlatCurry.Curry_Types.C_TypeExpr
  (Func Curry_Prelude.C_Int t1) -> FlatCurry.Typed.Curry_Types.C_TExpr
  -> IDSupply -> Cover -> ConstStore -> t1
nd_C__case_5 x11 x9 x8 x7 x6 x5 x4 x3 x2 x1 x10 s cd cs = case x10 of
  FlatCurry.Typed.Curry_Types.C_TVarE x12 x13 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x12 s0 cd cs) x13 s1 cd cs))
  FlatCurry.Typed.Curry_Types.C_TLit x14 x15 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2
    x14 s0 cd cs) x15 s1 cd cs))
  FlatCurry.Typed.Curry_Types.C_TComb x16 x17 x18 x19 -> let s7 = s
    in s7 `seq` (let s6 = leftSupply s7
                     s8 = rightSupply s7
                     s4 = leftSupply s8
                     s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s4 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (let s3 = leftSupply s4
         s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x3
    x16 s0 cd cs) x17 s1 cd cs)) x18 s3 cd cs)) (Curry_Prelude.nd_C_map x11 x19
    s5 cd cs) s6 cd cs))))
  FlatCurry.Typed.Curry_Types.C_TLet x20 x21 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s2 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply x4 (Curry_Prelude.nd_C_map
    (wrapNX id (nd_OP_trTExpr_dot_uscore_hash_lambda39 x11)) x20 s0 cd cs) s1 cd
    cs)) (Curry_Prelude.nd_C_apply x11 x21 s3 cd cs) s4 cd cs))))
  FlatCurry.Typed.Curry_Types.C_TFree x22 x23 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_apply x5 x22 s0 cd cs) (Curry_Prelude.nd_C_apply x11 x23
    s1 cd cs) s2 cd cs))))
  FlatCurry.Typed.Curry_Types.C_TOr x24 x25 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s2 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply x6 (Curry_Prelude.nd_C_apply
    x11 x24 s0 cd cs) s1 cd cs)) (Curry_Prelude.nd_C_apply x11 x25 s3 cd cs) s4
    cd cs))))
  FlatCurry.Typed.Curry_Types.C_TCase x26 x27 x28 -> let s7 = s
    in s7 `seq` (let s6 = leftSupply s7
                     s8 = rightSupply s7
                     s3 = leftSupply s8
                     s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_apply x7 x26 s0 cd cs) (Curry_Prelude.nd_C_apply x11 x27
    s1 cd cs) s2 cd cs)))) (Curry_Prelude.nd_C_map (wrapNX id
    (nd_OP_trTExpr_dot_uscore_hash_lambda40 x11 x8)) x28 s5 cd cs) s6 cd cs))))
  FlatCurry.Typed.Curry_Types.C_TTyped x29 x30 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply x9 (Curry_Prelude.nd_C_apply
    x11 x29 s0 cd cs) s1 cd cs)) x30 s3 cd cs))
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (nd_C__case_5
    x11 x9 x8 x7 x6 x5 x4 x3 x2 x1 l s cd cs) (nd_C__case_5 x11 x9 x8 x7 x6 x5
    x4 x3 x2 x1 r s cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    nd_C__case_5 x11 x9 x8 x7 x6 x5 x4 x3 x2 x1 z s cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    nd_C__case_5 x11 x9 x8 x7 x6 x5 x4 x3 x2 x1 e s cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_5" [show x11, show x9, show x8, show x7, show
    x6, show x5, show x4, show x3, show x2, show x1, show x10] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_5" (showCons x10))

d_C__case_4 :: Curry_Prelude.C_Bool -> FlatCurry.Typed.Curry_Types.C_TExpr
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_4 x2 x1 cd cs = case x1 of
  FlatCurry.Typed.Curry_Types.C_TComb x3 x4 x5 x6 -> let x7 = d_C_isTLit x1 cd
                                                           cs
    in d_C__case_3 x7 x6 x4 cd cs
  FlatCurry.Typed.Curry_Types.C_TVarE x10 x11 -> x2
  FlatCurry.Typed.Curry_Types.C_TLit x12 x13 -> x2
  FlatCurry.Typed.Curry_Types.C_TLet x14 x15 -> x2
  FlatCurry.Typed.Curry_Types.C_TFree x16 x17 -> x2
  FlatCurry.Typed.Curry_Types.C_TOr x18 x19 -> x2
  FlatCurry.Typed.Curry_Types.C_TCase x20 x21 x22 -> x2
  FlatCurry.Typed.Curry_Types.C_TTyped x23 x24 -> x2
  FlatCurry.Typed.Curry_Types.Choice_C_TExpr d i l r -> narrow d i (d_C__case_4
    x2 l cd cs) (d_C__case_4 x2 r cd cs)
  FlatCurry.Typed.Curry_Types.Choices_C_TExpr d i xs -> narrows cs d i (\z ->
    d_C__case_4 x2 z cd cs) xs
  FlatCurry.Typed.Curry_Types.Guard_C_TExpr d c e -> guardCons d c ((\x ->
    d_C__case_4 x2 e cd x) $! addCs c cs)
  FlatCurry.Typed.Curry_Types.Fail_C_TExpr d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_4" [show x2, show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_4" (showCons x1))

d_C__case_3 :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  FlatCurry.Typed.Curry_Types.C_TExpr -> FlatCurry.Curry_Types.C_CombType
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_3 x7 x6 x4 cd cs = case x4 of
  FlatCurry.Curry_Types.C_ConsCall -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_all d_C_isGround cd cs) x6 cd cs
  FlatCurry.Curry_Types.C_FuncCall -> x7
  FlatCurry.Curry_Types.C_FuncPartCall x8 -> x7
  FlatCurry.Curry_Types.C_ConsPartCall x9 -> x7
  FlatCurry.Curry_Types.Choice_C_CombType d i l r -> narrow d i (d_C__case_3 x7
    x6 l cd cs) (d_C__case_3 x7 x6 r cd cs)
  FlatCurry.Curry_Types.Choices_C_CombType d i xs -> narrows cs d i (\z ->
    d_C__case_3 x7 x6 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_CombType d c e -> guardCons d c ((\x ->
    d_C__case_3 x7 x6 e cd x) $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_CombType d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_3" [show x7, show x6, show x4] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_3" (showCons x4))

d_C__case_2 :: FlatCurry.Typed.Curry_Types.C_TPattern -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
d_C__case_2 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (d_C_tPatArgs cd cs) x1 cd cs
  Curry_Prelude.C_False -> d_C__case_1 (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x1 l cd cs)
    (d_C__case_2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_2" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_2" (showCons x2))

d_C__case_1 :: Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
d_C__case_1 x1 cd cs = case x1 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 l cd cs)
    (d_C__case_1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 z cd
    cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_1" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_1" (showCons x1))

d_C__case_0 :: FlatCurry.Typed.Curry_Types.C_TExpr -> (Curry_Prelude.C_Int
  -> Cover -> ConstStore -> Curry_Prelude.C_Int) -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) FlatCurry.Typed.Curry_Types.C_TExpr
d_C__case_0 x4 x1 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_apply x1 x5 cd cs) x6) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_0 x4 x1 l cd
    cs) (d_C__case_0 x4 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_0 x4
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_0 x4 x1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_0" [show x4, show x1, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_0" (showCons x3))

nd_C__case_0 :: FlatCurry.Typed.Curry_Types.C_TExpr -> Func Curry_Prelude.C_Int
  Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) FlatCurry.Typed.Curry_Types.C_TExpr
nd_C__case_0 x4 x1 x3 s cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
    (Curry_Prelude.nd_C_apply x1 x5 s0 cd cs) x6) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_0 x4 x1 l s
    cd cs) (nd_C__case_0 x4 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_0
    x4 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_0 x4
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Typed.Goodies._case_0" [show x4, show x1, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Typed.Goodies._case_0" (showCons x3))

