{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Language.Go.Curry_Types
  ( C_GoExpr (..)
  , C_GoStat (..)
  , C_GoExprBranch (..)
  , C_GoProg (..)
  , C_GoTopLevelDecl (..)
  , C_GoFuncDecl (..)
  , C_GoParam (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoProg_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoProg_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoProg_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash )
  where

import Basics
import qualified Curry_Prelude


data C_GoExpr
  = C_GoBoolLit Curry_Prelude.C_Bool
  | C_GoIntLit Curry_Prelude.C_Int
  | C_GoFloatLit Curry_Prelude.C_Float
  | C_GoStringLit (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_GoByteLit Curry_Prelude.C_Char
  | C_GoCompositeLit (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List C_GoExpr)
  | C_GoOpName (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_GoOpExpr C_GoExpr
  | C_GoConversion (Curry_Prelude.OP_List Curry_Prelude.C_Char) C_GoExpr
  | C_GoSelector C_GoExpr (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_GoIndex C_GoExpr C_GoExpr
  | C_GoSlice C_GoExpr C_GoExpr C_GoExpr
  | C_GoVariadic C_GoExpr
  | C_GoCall C_GoExpr (Curry_Prelude.OP_List C_GoExpr)
  | C_GoUnaryExpr (Curry_Prelude.OP_List Curry_Prelude.C_Char) C_GoExpr
  | C_GoBinaryExpr C_GoExpr (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    C_GoExpr
  | Choice_C_GoExpr Cover ID C_GoExpr C_GoExpr
  | Choices_C_GoExpr Cover ID [C_GoExpr]
  | Fail_C_GoExpr Cover FailInfo
  | Guard_C_GoExpr Cover Constraints C_GoExpr

instance Show C_GoExpr where
  showsPrec d (Choice_C_GoExpr cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_GoExpr cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_GoExpr cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_GoExpr cd info) = showChar '!'
  showsPrec _ (C_GoBoolLit x1) = showString "(GoBoolLit" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (C_GoIntLit x1) = showString "(GoIntLit" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_GoFloatLit x1) = showString "(GoFloatLit" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (C_GoStringLit x1) = showString "(GoStringLit" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (C_GoByteLit x1) = showString "(GoByteLit" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (C_GoCompositeLit x1 x2) = showString "(GoCompositeLit" .
    (showChar ' ' . (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_GoOpName x1) = showString "(GoOpName" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_GoOpExpr x1) = showString "(GoOpExpr" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_GoConversion x1 x2) = showString "(GoConversion" . (showChar
    ' ' . (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_GoSelector x1 x2) = showString "(GoSelector" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_GoIndex x1 x2) = showString "(GoIndex" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_GoSlice x1 x2 x3) = showString "(GoSlice" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . showChar
    ')'))))))
  showsPrec _ (C_GoVariadic x1) = showString "(GoVariadic" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (C_GoCall x1 x2) = showString "(GoCall" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_GoUnaryExpr x1 x2) = showString "(GoUnaryExpr" . (showChar
    ' ' . (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_GoBinaryExpr x1 x2 x3) = showString "(GoBinaryExpr" . (showChar
    ' ' . (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 .
    showChar ')'))))))

instance Read C_GoExpr where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_GoBoolLit x1, r1) | (_, r0) <-
    readQualified "Language.Go.Types" "GoBoolLit" r, (x1, r1) <- readsPrec 11
    r0]) s ++ (readParen ((>) d 10) (\r -> [(C_GoIntLit x1, r1) | (_, r0) <-
    readQualified "Language.Go.Types" "GoIntLit" r, (x1, r1) <- readsPrec 11
    r0]) s ++ (readParen ((>) d 10) (\r -> [(C_GoFloatLit x1, r1) | (_, r0) <-
    readQualified "Language.Go.Types" "GoFloatLit" r, (x1, r1) <- readsPrec 11
    r0]) s ++ (readParen ((>) d 10) (\r -> [(C_GoStringLit x1, r1) | (_, r0) <-
    readQualified "Language.Go.Types" "GoStringLit" r, (x1, r1) <- readsPrec 11
    r0]) s ++ (readParen ((>) d 10) (\r -> [(C_GoByteLit x1, r1) | (_, r0) <-
    readQualified "Language.Go.Types" "GoByteLit" r, (x1, r1) <- readsPrec 11
    r0]) s ++ (readParen ((>) d 10) (\r -> [(C_GoCompositeLit x1 x2, r2) | (_
    , r0) <- readQualified "Language.Go.Types" "GoCompositeLit" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ (readParen ((>) d 10)
    (\r -> [(C_GoOpName x1, r1) | (_, r0) <- readQualified "Language.Go.Types"
    "GoOpName" r, (x1, r1) <- readsPrec 11 r0]) s ++ (readParen ((>) d 10)
    (\r -> [(C_GoOpExpr x1, r1) | (_, r0) <- readQualified "Language.Go.Types"
    "GoOpExpr" r, (x1, r1) <- readsPrec 11 r0]) s ++ (readParen ((>) d 10)
    (\r -> [(C_GoConversion x1 x2, r2) | (_, r0) <- readQualified
    "Language.Go.Types" "GoConversion" r, (x1, r1) <- readsPrec 11 r0, (x2, r2)
    <- readsPrec 11 r1]) s ++ (readParen ((>) d 10) (\r -> [(C_GoSelector x1 x2
    , r2) | (_, r0) <- readQualified "Language.Go.Types" "GoSelector" r, (x1
    , r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ (readParen ((>)
    d 10) (\r -> [(C_GoIndex x1 x2, r2) | (_, r0) <- readQualified
    "Language.Go.Types" "GoIndex" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <-
    readsPrec 11 r1]) s ++ (readParen ((>) d 10) (\r -> [(C_GoSlice x1 x2 x3
    , r3) | (_, r0) <- readQualified "Language.Go.Types" "GoSlice" r, (x1, r1)
    <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11
    r2]) s ++ (readParen ((>) d 10) (\r -> [(C_GoVariadic x1, r1) | (_, r0) <-
    readQualified "Language.Go.Types" "GoVariadic" r, (x1, r1) <- readsPrec 11
    r0]) s ++ (readParen ((>) d 10) (\r -> [(C_GoCall x1 x2, r2) | (_, r0) <-
    readQualified "Language.Go.Types" "GoCall" r, (x1, r1) <- readsPrec 11 r0,
    (x2, r2) <- readsPrec 11 r1]) s ++ (readParen ((>) d 10) (\r ->
    [(C_GoUnaryExpr x1 x2, r2) | (_, r0) <- readQualified "Language.Go.Types"
    "GoUnaryExpr" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1])
    s ++ readParen ((>) d 10) (\r -> [(C_GoBinaryExpr x1 x2 x3, r3) | (_, r0) <-
    readQualified "Language.Go.Types" "GoBinaryExpr" r, (x1, r1) <- readsPrec 11
    r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2])
    s))))))))))))))

instance NonDet C_GoExpr where
  choiceCons = Choice_C_GoExpr
  choicesCons = Choices_C_GoExpr
  failCons = Fail_C_GoExpr
  guardCons = Guard_C_GoExpr
  try (Choice_C_GoExpr cd i x y) = tryChoice cd i x y
  try (Choices_C_GoExpr cd i xs) = tryChoices cd i xs
  try (Fail_C_GoExpr cd info) = Fail cd info
  try (Guard_C_GoExpr cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_GoExpr cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_GoExpr cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_GoExpr cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_GoExpr cd i _) = error
    ("Language.Go.Types.GoExpr.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_GoExpr cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_GoExpr cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_GoExpr where
  generate s c = Choices_C_GoExpr c (freeID [1, 1, 1, 1, 1, 2, 1, 1, 2, 2, 2, 3
    , 1, 2, 2, 3] s) [C_GoBoolLit (generate (leftSupply s) c), C_GoIntLit
    (generate (leftSupply s) c), C_GoFloatLit (generate (leftSupply s) c)
    , C_GoStringLit (generate (leftSupply s) c), C_GoByteLit (generate
    (leftSupply s) c), C_GoCompositeLit (generate (leftSupply s) c) (generate
    (rightSupply s) c), C_GoOpName (generate (leftSupply s) c), C_GoOpExpr
    (generate (leftSupply s) c), C_GoConversion (generate (leftSupply s) c)
    (generate (rightSupply s) c), C_GoSelector (generate (leftSupply s) c)
    (generate (rightSupply s) c), C_GoIndex (generate (leftSupply s) c)
    (generate (rightSupply s) c), C_GoSlice (generate (leftSupply (leftSupply
    s)) c) (generate (rightSupply (leftSupply s)) c) (generate (rightSupply s)
    c), C_GoVariadic (generate (leftSupply s) c), C_GoCall (generate (leftSupply
    s) c) (generate (rightSupply s) c), C_GoUnaryExpr (generate (leftSupply s)
    c) (generate (rightSupply s) c), C_GoBinaryExpr (generate (leftSupply
    (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c) (generate
    (rightSupply s) c)]

instance NormalForm C_GoExpr where
  ($!!) cont (C_GoBoolLit x1) d cs = ($!!) (\y1 d cs -> cont (C_GoBoolLit y1) d
    cs) x1 d cs
  ($!!) cont (C_GoIntLit x1) d cs = ($!!) (\y1 d cs -> cont (C_GoIntLit y1) d
    cs) x1 d cs
  ($!!) cont (C_GoFloatLit x1) d cs = ($!!) (\y1 d cs -> cont (C_GoFloatLit y1)
    d cs) x1 d cs
  ($!!) cont (C_GoStringLit x1) d cs = ($!!) (\y1 d cs -> cont (C_GoStringLit
    y1) d cs) x1 d cs
  ($!!) cont (C_GoByteLit x1) d cs = ($!!) (\y1 d cs -> cont (C_GoByteLit y1) d
    cs) x1 d cs
  ($!!) cont (C_GoCompositeLit x1 x2) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> cont (C_GoCompositeLit y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_GoOpName x1) d cs = ($!!) (\y1 d cs -> cont (C_GoOpName y1) d
    cs) x1 d cs
  ($!!) cont (C_GoOpExpr x1) d cs = ($!!) (\y1 d cs -> cont (C_GoOpExpr y1) d
    cs) x1 d cs
  ($!!) cont (C_GoConversion x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_GoConversion y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_GoSelector x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_GoSelector y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_GoIndex x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_GoIndex y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_GoSlice x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> cont (C_GoSlice y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (C_GoVariadic x1) d cs = ($!!) (\y1 d cs -> cont (C_GoVariadic y1)
    d cs) x1 d cs
  ($!!) cont (C_GoCall x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_GoCall y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_GoUnaryExpr x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_GoUnaryExpr y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_GoBinaryExpr x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> ($!!) (\y3 d cs -> cont (C_GoBinaryExpr y1 y2 y3) d cs) x3 d
    cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_GoExpr cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_GoExpr cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_GoExpr cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_GoExpr cd info) _ _ = failCons cd info
  ($##) cont (C_GoBoolLit x1) d cs = ($##) (\y1 d cs -> cont (C_GoBoolLit y1) d
    cs) x1 d cs
  ($##) cont (C_GoIntLit x1) d cs = ($##) (\y1 d cs -> cont (C_GoIntLit y1) d
    cs) x1 d cs
  ($##) cont (C_GoFloatLit x1) d cs = ($##) (\y1 d cs -> cont (C_GoFloatLit y1)
    d cs) x1 d cs
  ($##) cont (C_GoStringLit x1) d cs = ($##) (\y1 d cs -> cont (C_GoStringLit
    y1) d cs) x1 d cs
  ($##) cont (C_GoByteLit x1) d cs = ($##) (\y1 d cs -> cont (C_GoByteLit y1) d
    cs) x1 d cs
  ($##) cont (C_GoCompositeLit x1 x2) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> cont (C_GoCompositeLit y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_GoOpName x1) d cs = ($##) (\y1 d cs -> cont (C_GoOpName y1) d
    cs) x1 d cs
  ($##) cont (C_GoOpExpr x1) d cs = ($##) (\y1 d cs -> cont (C_GoOpExpr y1) d
    cs) x1 d cs
  ($##) cont (C_GoConversion x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_GoConversion y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_GoSelector x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_GoSelector y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_GoIndex x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_GoIndex y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_GoSlice x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> cont (C_GoSlice y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (C_GoVariadic x1) d cs = ($##) (\y1 d cs -> cont (C_GoVariadic y1)
    d cs) x1 d cs
  ($##) cont (C_GoCall x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_GoCall y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_GoUnaryExpr x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_GoUnaryExpr y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_GoBinaryExpr x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> ($##) (\y3 d cs -> cont (C_GoBinaryExpr y1 y2 y3) d cs) x3 d
    cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_GoExpr cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_GoExpr cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_GoExpr cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_GoExpr cd info) _ _ = failCons cd info
  showCons (C_GoBoolLit _) = "Language.Go.Types.GoBoolLit _"
  showCons (C_GoIntLit _) = "Language.Go.Types.GoIntLit _"
  showCons (C_GoFloatLit _) = "Language.Go.Types.GoFloatLit _"
  showCons (C_GoStringLit _) = "Language.Go.Types.GoStringLit _"
  showCons (C_GoByteLit _) = "Language.Go.Types.GoByteLit _"
  showCons (C_GoCompositeLit _ _) = "Language.Go.Types.GoCompositeLit _ _"
  showCons (C_GoOpName _) = "Language.Go.Types.GoOpName _"
  showCons (C_GoOpExpr _) = "Language.Go.Types.GoOpExpr _"
  showCons (C_GoConversion _ _) = "Language.Go.Types.GoConversion _ _"
  showCons (C_GoSelector _ _) = "Language.Go.Types.GoSelector _ _"
  showCons (C_GoIndex _ _) = "Language.Go.Types.GoIndex _ _"
  showCons (C_GoSlice _ _ _) = "Language.Go.Types.GoSlice _ _ _"
  showCons (C_GoVariadic _) = "Language.Go.Types.GoVariadic _"
  showCons (C_GoCall _ _) = "Language.Go.Types.GoCall _ _"
  showCons (C_GoUnaryExpr _ _) = "Language.Go.Types.GoUnaryExpr _ _"
  showCons (C_GoBinaryExpr _ _ _) = "Language.Go.Types.GoBinaryExpr _ _ _"
  showCons x = error ("Language.Go.Types.GoExpr.showCons: no constructor: " ++
    show x)
  searchNF search cont (C_GoBoolLit x1) = search (\y1 -> cont (C_GoBoolLit y1))
    x1
  searchNF search cont (C_GoIntLit x1) = search (\y1 -> cont (C_GoIntLit y1)) x1
  searchNF search cont (C_GoFloatLit x1) = search (\y1 -> cont (C_GoFloatLit
    y1)) x1
  searchNF search cont (C_GoStringLit x1) = search (\y1 -> cont (C_GoStringLit
    y1)) x1
  searchNF search cont (C_GoByteLit x1) = search (\y1 -> cont (C_GoByteLit y1))
    x1
  searchNF search cont (C_GoCompositeLit x1 x2) = search (\y1 -> search (\y2 ->
    cont (C_GoCompositeLit y1 y2)) x2) x1
  searchNF search cont (C_GoOpName x1) = search (\y1 -> cont (C_GoOpName y1)) x1
  searchNF search cont (C_GoOpExpr x1) = search (\y1 -> cont (C_GoOpExpr y1)) x1
  searchNF search cont (C_GoConversion x1 x2) = search (\y1 -> search (\y2 ->
    cont (C_GoConversion y1 y2)) x2) x1
  searchNF search cont (C_GoSelector x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_GoSelector y1 y2)) x2) x1
  searchNF search cont (C_GoIndex x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_GoIndex y1 y2)) x2) x1
  searchNF search cont (C_GoSlice x1 x2 x3) = search (\y1 -> search (\y2 ->
    search (\y3 -> cont (C_GoSlice y1 y2 y3)) x3) x2) x1
  searchNF search cont (C_GoVariadic x1) = search (\y1 -> cont (C_GoVariadic
    y1)) x1
  searchNF search cont (C_GoCall x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_GoCall y1 y2)) x2) x1
  searchNF search cont (C_GoUnaryExpr x1 x2) = search (\y1 -> search (\y2 ->
    cont (C_GoUnaryExpr y1 y2)) x2) x1
  searchNF search cont (C_GoBinaryExpr x1 x2 x3) = search (\y1 -> search (\y2 ->
    search (\y3 -> cont (C_GoBinaryExpr y1 y2 y3)) x3) x2) x1
  searchNF _ _ x = error
    ("Language.Go.Types.GoExpr.searchNF: no constructor: " ++ show x)

instance Unifiable C_GoExpr where
  (=.=) (C_GoBoolLit x1) (C_GoBoolLit y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_GoIntLit x1) (C_GoIntLit y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_GoFloatLit x1) (C_GoFloatLit y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_GoStringLit x1) (C_GoStringLit y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_GoByteLit x1) (C_GoByteLit y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_GoCompositeLit x1 x2) (C_GoCompositeLit y1 y2) d cs = (&) ((=:=) x1
    y1 d cs) ((=:=) x2 y2 d cs) d cs
  (=.=) (C_GoOpName x1) (C_GoOpName y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_GoOpExpr x1) (C_GoOpExpr y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_GoConversion x1 x2) (C_GoConversion y1 y2) d cs = (&) ((=:=) x1 y1 d
    cs) ((=:=) x2 y2 d cs) d cs
  (=.=) (C_GoSelector x1 x2) (C_GoSelector y1 y2) d cs = (&) ((=:=) x1 y1 d cs)
    ((=:=) x2 y2 d cs) d cs
  (=.=) (C_GoIndex x1 x2) (C_GoIndex y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=)
    x2 y2 d cs) d cs
  (=.=) (C_GoSlice x1 x2 x3) (C_GoSlice y1 y2 y3) d cs = (&) ((=:=) x1 y1 d cs)
    ((&) ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) (C_GoVariadic x1) (C_GoVariadic y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_GoCall x1 x2) (C_GoCall y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=)
    x2 y2 d cs) d cs
  (=.=) (C_GoUnaryExpr x1 x2) (C_GoUnaryExpr y1 y2) d cs = (&) ((=:=) x1 y1 d
    cs) ((=:=) x2 y2 d cs) d cs
  (=.=) (C_GoBinaryExpr x1 x2 x3) (C_GoBinaryExpr y1 y2 y3) d cs = (&) ((=:=) x1
    y1 d cs) ((&) ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_GoBoolLit x1) (C_GoBoolLit y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_GoIntLit x1) (C_GoIntLit y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_GoFloatLit x1) (C_GoFloatLit y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_GoStringLit x1) (C_GoStringLit y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_GoByteLit x1) (C_GoByteLit y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_GoCompositeLit x1 x2) (C_GoCompositeLit y1 y2) d cs = (&) ((=:<=) x1
    y1 d cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_GoOpName x1) (C_GoOpName y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_GoOpExpr x1) (C_GoOpExpr y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_GoConversion x1 x2) (C_GoConversion y1 y2) d cs = (&) ((=:<=) x1 y1
    d cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_GoSelector x1 x2) (C_GoSelector y1 y2) d cs = (&) ((=:<=) x1 y1 d
    cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_GoIndex x1 x2) (C_GoIndex y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_GoSlice x1 x2 x3) (C_GoSlice y1 y2 y3) d cs = (&) ((=:<=) x1 y1 d
    cs) ((&) ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d cs
  (=.<=) (C_GoVariadic x1) (C_GoVariadic y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_GoCall x1 x2) (C_GoCall y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_GoUnaryExpr x1 x2) (C_GoUnaryExpr y1 y2) d cs = (&) ((=:<=) x1 y1 d
    cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_GoBinaryExpr x1 x2 x3) (C_GoBinaryExpr y1 y2 y3) d cs = (&) ((=:<=)
    x1 y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_GoBoolLit x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_GoIntLit x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_GoFloatLit x3) = (i :=: ChooseN 2 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_GoStringLit x3) = (i :=: ChooseN 3 1) : concat [bind cd (leftID
    i) x3]
  bind cd i (C_GoByteLit x3) = (i :=: ChooseN 4 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_GoCompositeLit x3 x4) = (i :=: ChooseN 5 2) : concat [bind cd
    (leftID i) x3, bind cd (rightID i) x4]
  bind cd i (C_GoOpName x3) = (i :=: ChooseN 6 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_GoOpExpr x3) = (i :=: ChooseN 7 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_GoConversion x3 x4) = (i :=: ChooseN 8 2) : concat [bind cd
    (leftID i) x3, bind cd (rightID i) x4]
  bind cd i (C_GoSelector x3 x4) = (i :=: ChooseN 9 2) : concat [bind cd (leftID
    i) x3, bind cd (rightID i) x4]
  bind cd i (C_GoIndex x3 x4) = (i :=: ChooseN 10 2) : concat [bind cd (leftID
    i) x3, bind cd (rightID i) x4]
  bind cd i (C_GoSlice x3 x4 x5) = (i :=: ChooseN 11 3) : concat [bind cd
    (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (rightID i)
    x5]
  bind cd i (C_GoVariadic x3) = (i :=: ChooseN 12 1) : concat [bind cd (leftID
    i) x3]
  bind cd i (C_GoCall x3 x4) = (i :=: ChooseN 13 2) : concat [bind cd (leftID i)
    x3, bind cd (rightID i) x4]
  bind cd i (C_GoUnaryExpr x3 x4) = (i :=: ChooseN 14 2) : concat [bind cd
    (leftID i) x3, bind cd (rightID i) x4]
  bind cd i (C_GoBinaryExpr x3 x4 x5) = (i :=: ChooseN 15 3) : concat [bind cd
    (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (rightID i)
    x5]
  bind d i (Choice_C_GoExpr cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_GoExpr cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_GoExpr cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_GoExpr cd i _) = error
    ("Language.Go.Types.GoExpr.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_GoExpr cd info) = [Unsolvable info]
  bind d i (Guard_C_GoExpr cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_GoBoolLit x3) = (i :=: ChooseN 0 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_GoIntLit x3) = (i :=: ChooseN 1 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_GoFloatLit x3) = (i :=: ChooseN 2 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_GoStringLit x3) = (i :=: ChooseN 3 1) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_GoByteLit x3) = (i :=: ChooseN 4 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_GoCompositeLit x3 x4) = (i :=: ChooseN 5 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind cd i (C_GoOpName x3) = (i :=: ChooseN 6 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_GoOpExpr x3) = (i :=: ChooseN 7 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_GoConversion x3 x4) = (i :=: ChooseN 8 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind cd i (C_GoSelector x3 x4) = (i :=: ChooseN 9 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind cd i (C_GoIndex x3 x4) = (i :=: ChooseN 10 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind cd i (C_GoSlice x3 x4 x5) = (i :=: ChooseN 11 3) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x5)]
  lazyBind cd i (C_GoVariadic x3) = (i :=: ChooseN 12 1) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_GoCall x3 x4) = (i :=: ChooseN 13 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (C_GoUnaryExpr x3 x4) = (i :=: ChooseN 14 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind cd i (C_GoBinaryExpr x3 x4 x5) = (i :=: ChooseN 15 3) : [leftID
    (leftID i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID
    (leftID i) :=: LazyBind (lazyBind cd (rightID (leftID i)) x4), rightID i :=:
    LazyBind (lazyBind cd (rightID i) x5)]
  lazyBind d i (Choice_C_GoExpr cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_GoExpr cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_GoExpr cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_GoExpr cd i _) = error
    ("Language.Go.Types.GoExpr.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_GoExpr cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_GoExpr cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_GoExpr where

data C_GoStat
  = C_GoConstDecl (Curry_Prelude.OP_List (Curry_Prelude.OP_List
    Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List C_GoExpr)
  | C_GoVarDecl (Curry_Prelude.OP_List (Curry_Prelude.OP_List
    Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List C_GoExpr)
  | C_GoShortVarDecl (Curry_Prelude.OP_List (Curry_Prelude.OP_List
    Curry_Prelude.C_Char)) (Curry_Prelude.OP_List C_GoExpr)
  | C_GoExprStat C_GoExpr
  | C_GoAssign (Curry_Prelude.OP_List C_GoExpr) (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) (Curry_Prelude.OP_List C_GoExpr)
  | C_GoEmpty
  | C_GoReturn (Curry_Prelude.OP_List C_GoExpr)
  | C_GoBreak
  | C_GoContinue
  | C_GoBlock (Curry_Prelude.OP_List C_GoStat)
  | C_GoIf C_GoExpr (Curry_Prelude.OP_List C_GoStat) (Curry_Prelude.OP_List
    C_GoStat)
  | C_GoExprSwitch C_GoExpr (Curry_Prelude.OP_List C_GoExprBranch)
  | Choice_C_GoStat Cover ID C_GoStat C_GoStat
  | Choices_C_GoStat Cover ID [C_GoStat]
  | Fail_C_GoStat Cover FailInfo
  | Guard_C_GoStat Cover Constraints C_GoStat

instance Show C_GoStat where
  showsPrec d (Choice_C_GoStat cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_GoStat cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_GoStat cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_GoStat cd info) = showChar '!'
  showsPrec _ (C_GoConstDecl x1 x2 x3) = showString "(GoConstDecl" . (showChar
    ' ' . (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 .
    showChar ')'))))))
  showsPrec _ (C_GoVarDecl x1 x2 x3) = showString "(GoVarDecl" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . showChar
    ')'))))))
  showsPrec _ (C_GoShortVarDecl x1 x2) = showString "(GoShortVarDecl" .
    (showChar ' ' . (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_GoExprStat x1) = showString "(GoExprStat" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (C_GoAssign x1 x2 x3) = showString "(GoAssign" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . showChar
    ')'))))))
  showsPrec _ C_GoEmpty = showString "GoEmpty"
  showsPrec _ (C_GoReturn x1) = showString "(GoReturn" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ C_GoBreak = showString "GoBreak"
  showsPrec _ C_GoContinue = showString "GoContinue"
  showsPrec _ (C_GoBlock x1) = showString "(GoBlock" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_GoIf x1 x2 x3) = showString "(GoIf" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . showChar
    ')'))))))
  showsPrec _ (C_GoExprSwitch x1 x2) = showString "(GoExprSwitch" . (showChar
    ' ' . (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))

instance Read C_GoStat where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_GoConstDecl x1 x2 x3, r3) | (_
    , r0) <- readQualified "Language.Go.Types" "GoConstDecl" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2])
    s ++ (readParen ((>) d 10) (\r -> [(C_GoVarDecl x1 x2 x3, r3) | (_, r0) <-
    readQualified "Language.Go.Types" "GoVarDecl" r, (x1, r1) <- readsPrec 11
    r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2]) s ++
    (readParen ((>) d 10) (\r -> [(C_GoShortVarDecl x1 x2, r2) | (_, r0) <-
    readQualified "Language.Go.Types" "GoShortVarDecl" r, (x1, r1) <- readsPrec
    11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ (readParen ((>) d 10) (\r ->
    [(C_GoExprStat x1, r1) | (_, r0) <- readQualified "Language.Go.Types"
    "GoExprStat" r, (x1, r1) <- readsPrec 11 r0]) s ++ (readParen ((>) d 10)
    (\r -> [(C_GoAssign x1 x2 x3, r3) | (_, r0) <- readQualified
    "Language.Go.Types" "GoAssign" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <-
    readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2]) s ++ (readParen False (\r ->
    [(C_GoEmpty, r0) | (_, r0) <- readQualified "Language.Go.Types" "GoEmpty"
    r]) s ++ (readParen ((>) d 10) (\r -> [(C_GoReturn x1, r1) | (_, r0) <-
    readQualified "Language.Go.Types" "GoReturn" r, (x1, r1) <- readsPrec 11
    r0]) s ++ (readParen False (\r -> [(C_GoBreak, r0) | (_, r0) <-
    readQualified "Language.Go.Types" "GoBreak" r]) s ++ (readParen False (\r ->
    [(C_GoContinue, r0) | (_, r0) <- readQualified "Language.Go.Types"
    "GoContinue" r]) s ++ (readParen ((>) d 10) (\r -> [(C_GoBlock x1, r1) | (_
    , r0) <- readQualified "Language.Go.Types" "GoBlock" r, (x1, r1) <-
    readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_GoIf x1 x2 x3
    , r3) | (_, r0) <- readQualified "Language.Go.Types" "GoIf" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2])
    s ++ readParen ((>) d 10) (\r -> [(C_GoExprSwitch x1 x2, r2) | (_, r0) <-
    readQualified "Language.Go.Types" "GoExprSwitch" r, (x1, r1) <- readsPrec 11
    r0, (x2, r2) <- readsPrec 11 r1]) s))))))))))

instance NonDet C_GoStat where
  choiceCons = Choice_C_GoStat
  choicesCons = Choices_C_GoStat
  failCons = Fail_C_GoStat
  guardCons = Guard_C_GoStat
  try (Choice_C_GoStat cd i x y) = tryChoice cd i x y
  try (Choices_C_GoStat cd i xs) = tryChoices cd i xs
  try (Fail_C_GoStat cd info) = Fail cd info
  try (Guard_C_GoStat cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_GoStat cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_GoStat cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_GoStat cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_GoStat cd i _) = error
    ("Language.Go.Types.GoStat.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_GoStat cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_GoStat cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_GoStat where
  generate s c = Choices_C_GoStat c (freeID [3, 3, 2, 1, 3, 0, 1, 0, 0, 1, 3, 2]
    s) [C_GoConstDecl (generate (leftSupply (leftSupply s)) c) (generate
    (rightSupply (leftSupply s)) c) (generate (rightSupply s) c), C_GoVarDecl
    (generate (leftSupply (leftSupply s)) c) (generate (rightSupply (leftSupply
    s)) c) (generate (rightSupply s) c), C_GoShortVarDecl (generate (leftSupply
    s) c) (generate (rightSupply s) c), C_GoExprStat (generate (leftSupply s) c)
    , C_GoAssign (generate (leftSupply (leftSupply s)) c) (generate (rightSupply
    (leftSupply s)) c) (generate (rightSupply s) c), C_GoEmpty, C_GoReturn
    (generate (leftSupply s) c), C_GoBreak, C_GoContinue, C_GoBlock (generate
    (leftSupply s) c), C_GoIf (generate (leftSupply (leftSupply s)) c) (generate
    (rightSupply (leftSupply s)) c) (generate (rightSupply s) c), C_GoExprSwitch
    (generate (leftSupply s) c) (generate (rightSupply s) c)]

instance NormalForm C_GoStat where
  ($!!) cont (C_GoConstDecl x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> ($!!) (\y3 d cs -> cont (C_GoConstDecl y1 y2 y3) d cs) x3 d cs)
    x2 d cs) x1 d cs
  ($!!) cont (C_GoVarDecl x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> cont (C_GoVarDecl y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d
    cs
  ($!!) cont (C_GoShortVarDecl x1 x2) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> cont (C_GoShortVarDecl y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_GoExprStat x1) d cs = ($!!) (\y1 d cs -> cont (C_GoExprStat y1)
    d cs) x1 d cs
  ($!!) cont (C_GoAssign x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> cont (C_GoAssign y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d
    cs
  ($!!) cont C_GoEmpty d cs = cont C_GoEmpty d cs
  ($!!) cont (C_GoReturn x1) d cs = ($!!) (\y1 d cs -> cont (C_GoReturn y1) d
    cs) x1 d cs
  ($!!) cont C_GoBreak d cs = cont C_GoBreak d cs
  ($!!) cont C_GoContinue d cs = cont C_GoContinue d cs
  ($!!) cont (C_GoBlock x1) d cs = ($!!) (\y1 d cs -> cont (C_GoBlock y1) d cs)
    x1 d cs
  ($!!) cont (C_GoIf x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> cont (C_GoIf y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (C_GoExprSwitch x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_GoExprSwitch y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_GoStat cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_GoStat cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_GoStat cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_GoStat cd info) _ _ = failCons cd info
  ($##) cont (C_GoConstDecl x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> ($##) (\y3 d cs -> cont (C_GoConstDecl y1 y2 y3) d cs) x3 d cs)
    x2 d cs) x1 d cs
  ($##) cont (C_GoVarDecl x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> cont (C_GoVarDecl y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d
    cs
  ($##) cont (C_GoShortVarDecl x1 x2) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> cont (C_GoShortVarDecl y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_GoExprStat x1) d cs = ($##) (\y1 d cs -> cont (C_GoExprStat y1)
    d cs) x1 d cs
  ($##) cont (C_GoAssign x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> cont (C_GoAssign y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d
    cs
  ($##) cont C_GoEmpty d cs = cont C_GoEmpty d cs
  ($##) cont (C_GoReturn x1) d cs = ($##) (\y1 d cs -> cont (C_GoReturn y1) d
    cs) x1 d cs
  ($##) cont C_GoBreak d cs = cont C_GoBreak d cs
  ($##) cont C_GoContinue d cs = cont C_GoContinue d cs
  ($##) cont (C_GoBlock x1) d cs = ($##) (\y1 d cs -> cont (C_GoBlock y1) d cs)
    x1 d cs
  ($##) cont (C_GoIf x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> cont (C_GoIf y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (C_GoExprSwitch x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_GoExprSwitch y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_GoStat cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_GoStat cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_GoStat cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_GoStat cd info) _ _ = failCons cd info
  showCons (C_GoConstDecl _ _ _) = "Language.Go.Types.GoConstDecl _ _ _"
  showCons (C_GoVarDecl _ _ _) = "Language.Go.Types.GoVarDecl _ _ _"
  showCons (C_GoShortVarDecl _ _) = "Language.Go.Types.GoShortVarDecl _ _"
  showCons (C_GoExprStat _) = "Language.Go.Types.GoExprStat _"
  showCons (C_GoAssign _ _ _) = "Language.Go.Types.GoAssign _ _ _"
  showCons C_GoEmpty = "Language.Go.Types.GoEmpty"
  showCons (C_GoReturn _) = "Language.Go.Types.GoReturn _"
  showCons C_GoBreak = "Language.Go.Types.GoBreak"
  showCons C_GoContinue = "Language.Go.Types.GoContinue"
  showCons (C_GoBlock _) = "Language.Go.Types.GoBlock _"
  showCons (C_GoIf _ _ _) = "Language.Go.Types.GoIf _ _ _"
  showCons (C_GoExprSwitch _ _) = "Language.Go.Types.GoExprSwitch _ _"
  showCons x = error ("Language.Go.Types.GoStat.showCons: no constructor: " ++
    show x)
  searchNF search cont (C_GoConstDecl x1 x2 x3) = search (\y1 -> search (\y2 ->
    search (\y3 -> cont (C_GoConstDecl y1 y2 y3)) x3) x2) x1
  searchNF search cont (C_GoVarDecl x1 x2 x3) = search (\y1 -> search (\y2 ->
    search (\y3 -> cont (C_GoVarDecl y1 y2 y3)) x3) x2) x1
  searchNF search cont (C_GoShortVarDecl x1 x2) = search (\y1 -> search (\y2 ->
    cont (C_GoShortVarDecl y1 y2)) x2) x1
  searchNF search cont (C_GoExprStat x1) = search (\y1 -> cont (C_GoExprStat
    y1)) x1
  searchNF search cont (C_GoAssign x1 x2 x3) = search (\y1 -> search (\y2 ->
    search (\y3 -> cont (C_GoAssign y1 y2 y3)) x3) x2) x1
  searchNF _ cont C_GoEmpty = cont C_GoEmpty
  searchNF search cont (C_GoReturn x1) = search (\y1 -> cont (C_GoReturn y1)) x1
  searchNF _ cont C_GoBreak = cont C_GoBreak
  searchNF _ cont C_GoContinue = cont C_GoContinue
  searchNF search cont (C_GoBlock x1) = search (\y1 -> cont (C_GoBlock y1)) x1
  searchNF search cont (C_GoIf x1 x2 x3) = search (\y1 -> search (\y2 -> search
    (\y3 -> cont (C_GoIf y1 y2 y3)) x3) x2) x1
  searchNF search cont (C_GoExprSwitch x1 x2) = search (\y1 -> search (\y2 ->
    cont (C_GoExprSwitch y1 y2)) x2) x1
  searchNF _ _ x = error
    ("Language.Go.Types.GoStat.searchNF: no constructor: " ++ show x)

instance Unifiable C_GoStat where
  (=.=) (C_GoConstDecl x1 x2 x3) (C_GoConstDecl y1 y2 y3) d cs = (&) ((=:=) x1
    y1 d cs) ((&) ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) (C_GoVarDecl x1 x2 x3) (C_GoVarDecl y1 y2 y3) d cs = (&) ((=:=) x1 y1 d
    cs) ((&) ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) (C_GoShortVarDecl x1 x2) (C_GoShortVarDecl y1 y2) d cs = (&) ((=:=) x1
    y1 d cs) ((=:=) x2 y2 d cs) d cs
  (=.=) (C_GoExprStat x1) (C_GoExprStat y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_GoAssign x1 x2 x3) (C_GoAssign y1 y2 y3) d cs = (&) ((=:=) x1 y1 d
    cs) ((&) ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) C_GoEmpty C_GoEmpty d cs = C_True
  (=.=) (C_GoReturn x1) (C_GoReturn y1) d cs = (=:=) x1 y1 d cs
  (=.=) C_GoBreak C_GoBreak d cs = C_True
  (=.=) C_GoContinue C_GoContinue d cs = C_True
  (=.=) (C_GoBlock x1) (C_GoBlock y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_GoIf x1 x2 x3) (C_GoIf y1 y2 y3) d cs = (&) ((=:=) x1 y1 d cs) ((&)
    ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) (C_GoExprSwitch x1 x2) (C_GoExprSwitch y1 y2) d cs = (&) ((=:=) x1 y1 d
    cs) ((=:=) x2 y2 d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_GoConstDecl x1 x2 x3) (C_GoConstDecl y1 y2 y3) d cs = (&) ((=:<=) x1
    y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d cs
  (=.<=) (C_GoVarDecl x1 x2 x3) (C_GoVarDecl y1 y2 y3) d cs = (&) ((=:<=) x1 y1
    d cs) ((&) ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d cs
  (=.<=) (C_GoShortVarDecl x1 x2) (C_GoShortVarDecl y1 y2) d cs = (&) ((=:<=) x1
    y1 d cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_GoExprStat x1) (C_GoExprStat y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_GoAssign x1 x2 x3) (C_GoAssign y1 y2 y3) d cs = (&) ((=:<=) x1 y1 d
    cs) ((&) ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d cs
  (=.<=) C_GoEmpty C_GoEmpty d cs = C_True
  (=.<=) (C_GoReturn x1) (C_GoReturn y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) C_GoBreak C_GoBreak d cs = C_True
  (=.<=) C_GoContinue C_GoContinue d cs = C_True
  (=.<=) (C_GoBlock x1) (C_GoBlock y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_GoIf x1 x2 x3) (C_GoIf y1 y2 y3) d cs = (&) ((=:<=) x1 y1 d cs) ((&)
    ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d cs
  (=.<=) (C_GoExprSwitch x1 x2) (C_GoExprSwitch y1 y2) d cs = (&) ((=:<=) x1 y1
    d cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_GoConstDecl x3 x4 x5) = (i :=: ChooseN 0 3) : concat [bind cd
    (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (rightID i)
    x5]
  bind cd i (C_GoVarDecl x3 x4 x5) = (i :=: ChooseN 1 3) : concat [bind cd
    (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (rightID i)
    x5]
  bind cd i (C_GoShortVarDecl x3 x4) = (i :=: ChooseN 2 2) : concat [bind cd
    (leftID i) x3, bind cd (rightID i) x4]
  bind cd i (C_GoExprStat x3) = (i :=: ChooseN 3 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_GoAssign x3 x4 x5) = (i :=: ChooseN 4 3) : concat [bind cd
    (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (rightID i)
    x5]
  bind cd i C_GoEmpty = (i :=: ChooseN 5 0) : concat []
  bind cd i (C_GoReturn x3) = (i :=: ChooseN 6 1) : concat [bind cd (leftID i)
    x3]
  bind cd i C_GoBreak = (i :=: ChooseN 7 0) : concat []
  bind cd i C_GoContinue = (i :=: ChooseN 8 0) : concat []
  bind cd i (C_GoBlock x3) = (i :=: ChooseN 9 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_GoIf x3 x4 x5) = (i :=: ChooseN 10 3) : concat [bind cd (leftID
    (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (rightID i) x5]
  bind cd i (C_GoExprSwitch x3 x4) = (i :=: ChooseN 11 2) : concat [bind cd
    (leftID i) x3, bind cd (rightID i) x4]
  bind d i (Choice_C_GoStat cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_GoStat cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_GoStat cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_GoStat cd i _) = error
    ("Language.Go.Types.GoStat.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_GoStat cd info) = [Unsolvable info]
  bind d i (Guard_C_GoStat cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_GoConstDecl x3 x4 x5) = (i :=: ChooseN 0 3) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x5)]
  lazyBind cd i (C_GoVarDecl x3 x4 x5) = (i :=: ChooseN 1 3) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x5)]
  lazyBind cd i (C_GoShortVarDecl x3 x4) = (i :=: ChooseN 2 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind cd i (C_GoExprStat x3) = (i :=: ChooseN 3 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_GoAssign x3 x4 x5) = (i :=: ChooseN 4 3) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x5)]
  lazyBind cd i C_GoEmpty = (i :=: ChooseN 5 0) : []
  lazyBind cd i (C_GoReturn x3) = (i :=: ChooseN 6 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i C_GoBreak = (i :=: ChooseN 7 0) : []
  lazyBind cd i C_GoContinue = (i :=: ChooseN 8 0) : []
  lazyBind cd i (C_GoBlock x3) = (i :=: ChooseN 9 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_GoIf x3 x4 x5) = (i :=: ChooseN 10 3) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x5)]
  lazyBind cd i (C_GoExprSwitch x3 x4) = (i :=: ChooseN 11 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind d i (Choice_C_GoStat cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_GoStat cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_GoStat cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_GoStat cd i _) = error
    ("Language.Go.Types.GoStat.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_GoStat cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_GoStat cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_GoStat where

data C_GoExprBranch
  = C_GoExprBranch (Curry_Prelude.OP_List C_GoExpr) (Curry_Prelude.OP_List
    C_GoStat)
  | C_GoExprDefault (Curry_Prelude.OP_List C_GoStat)
  | Choice_C_GoExprBranch Cover ID C_GoExprBranch C_GoExprBranch
  | Choices_C_GoExprBranch Cover ID [C_GoExprBranch]
  | Fail_C_GoExprBranch Cover FailInfo
  | Guard_C_GoExprBranch Cover Constraints C_GoExprBranch

instance Show C_GoExprBranch where
  showsPrec d (Choice_C_GoExprBranch cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_GoExprBranch cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_GoExprBranch cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_GoExprBranch cd info) = showChar '!'
  showsPrec _ (C_GoExprBranch x1 x2) = showString "(GoExprBranch" . (showChar
    ' ' . (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_GoExprDefault x1) = showString "(GoExprDefault" . (showChar
    ' ' . (shows x1 . showChar ')'))

instance Read C_GoExprBranch where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_GoExprBranch x1 x2, r2) | (_
    , r0) <- readQualified "Language.Go.Types" "GoExprBranch" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ readParen ((>) d 10)
    (\r -> [(C_GoExprDefault x1, r1) | (_, r0) <- readQualified
    "Language.Go.Types" "GoExprDefault" r, (x1, r1) <- readsPrec 11 r0]) s

instance NonDet C_GoExprBranch where
  choiceCons = Choice_C_GoExprBranch
  choicesCons = Choices_C_GoExprBranch
  failCons = Fail_C_GoExprBranch
  guardCons = Guard_C_GoExprBranch
  try (Choice_C_GoExprBranch cd i x y) = tryChoice cd i x y
  try (Choices_C_GoExprBranch cd i xs) = tryChoices cd i xs
  try (Fail_C_GoExprBranch cd info) = Fail cd info
  try (Guard_C_GoExprBranch cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_GoExprBranch cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_GoExprBranch cd i@(NarrowedID _ _) xs) = f cd i
    xs
  match _ _ f _ _ _ (Choices_C_GoExprBranch cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_GoExprBranch cd i _) = error
    ("Language.Go.Types.GoExprBranch.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_GoExprBranch cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_GoExprBranch cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_GoExprBranch where
  generate s c = Choices_C_GoExprBranch c (freeID [2, 1] s) [C_GoExprBranch
    (generate (leftSupply s) c) (generate (rightSupply s) c), C_GoExprDefault
    (generate (leftSupply s) c)]

instance NormalForm C_GoExprBranch where
  ($!!) cont (C_GoExprBranch x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_GoExprBranch y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_GoExprDefault x1) d cs = ($!!) (\y1 d cs -> cont
    (C_GoExprDefault y1) d cs) x1 d cs
  ($!!) cont (Choice_C_GoExprBranch cd i x y) d cs = nfChoice cont cd i x y cd
    cs
  ($!!) cont (Choices_C_GoExprBranch cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_GoExprBranch cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_GoExprBranch cd info) _ _ = failCons cd info
  ($##) cont (C_GoExprBranch x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_GoExprBranch y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_GoExprDefault x1) d cs = ($##) (\y1 d cs -> cont
    (C_GoExprDefault y1) d cs) x1 d cs
  ($##) cont (Choice_C_GoExprBranch cd i x y) d cs = gnfChoice cont cd i x y cd
    cs
  ($##) cont (Choices_C_GoExprBranch cd i xs) d cs = gnfChoices cont cd i xs d
    cs
  ($##) cont (Guard_C_GoExprBranch cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_GoExprBranch cd info) _ _ = failCons cd info
  showCons (C_GoExprBranch _ _) = "Language.Go.Types.GoExprBranch _ _"
  showCons (C_GoExprDefault _) = "Language.Go.Types.GoExprDefault _"
  showCons x = error
    ("Language.Go.Types.GoExprBranch.showCons: no constructor: " ++ show x)
  searchNF search cont (C_GoExprBranch x1 x2) = search (\y1 -> search (\y2 ->
    cont (C_GoExprBranch y1 y2)) x2) x1
  searchNF search cont (C_GoExprDefault x1) = search (\y1 -> cont
    (C_GoExprDefault y1)) x1
  searchNF _ _ x = error
    ("Language.Go.Types.GoExprBranch.searchNF: no constructor: " ++ show x)

instance Unifiable C_GoExprBranch where
  (=.=) (C_GoExprBranch x1 x2) (C_GoExprBranch y1 y2) d cs = (&) ((=:=) x1 y1 d
    cs) ((=:=) x2 y2 d cs) d cs
  (=.=) (C_GoExprDefault x1) (C_GoExprDefault y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_GoExprBranch x1 x2) (C_GoExprBranch y1 y2) d cs = (&) ((=:<=) x1 y1
    d cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_GoExprDefault x1) (C_GoExprDefault y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_GoExprBranch x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd
    (leftID i) x3, bind cd (rightID i) x4]
  bind cd i (C_GoExprDefault x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID
    i) x3]
  bind d i (Choice_C_GoExprBranch cd j x y) = [ConstraintChoice cd j (bind d i
    x) (bind d i y)]
  bind d i (Choices_C_GoExprBranch cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j
    xs
  bind d i (Choices_C_GoExprBranch cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_GoExprBranch cd i _) = error
    ("Language.Go.Types.GoExprBranch.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_GoExprBranch cd info) = [Unsolvable info]
  bind d i (Guard_C_GoExprBranch cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_GoExprBranch x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind cd i (C_GoExprDefault x3) = (i :=: ChooseN 1 1) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_GoExprBranch cd j x y) = [ConstraintChoice cd j
    (lazyBind d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_GoExprBranch cd j@(FreeID _ _) xs) = lazyBindOrNarrow
    d i cd j xs
  lazyBind d i (Choices_C_GoExprBranch cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_GoExprBranch cd i _) = error
    ("Language.Go.Types.GoExprBranch.lazyBind: Choices with ChoiceID: " ++ show
    i)
  lazyBind _ _ (Fail_C_GoExprBranch cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_GoExprBranch cd c e) = getConstrList c ++ [i :=:
    LazyBind (lazyBind d i e)]

instance Curry C_GoExprBranch where

data C_GoProg
  = C_GoProg (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
    C_GoTopLevelDecl)
  | Choice_C_GoProg Cover ID C_GoProg C_GoProg
  | Choices_C_GoProg Cover ID [C_GoProg]
  | Fail_C_GoProg Cover FailInfo
  | Guard_C_GoProg Cover Constraints C_GoProg

instance Show C_GoProg where
  showsPrec d (Choice_C_GoProg cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_GoProg cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_GoProg cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_GoProg cd info) = showChar '!'
  showsPrec _ (C_GoProg x1 x2 x3) = showString "(GoProg" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . showChar
    ')'))))))

instance Read C_GoProg where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_GoProg x1 x2 x3, r3) | (_, r0)
    <- readQualified "Language.Go.Types" "GoProg" r, (x1, r1) <- readsPrec 11
    r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2]) s

instance NonDet C_GoProg where
  choiceCons = Choice_C_GoProg
  choicesCons = Choices_C_GoProg
  failCons = Fail_C_GoProg
  guardCons = Guard_C_GoProg
  try (Choice_C_GoProg cd i x y) = tryChoice cd i x y
  try (Choices_C_GoProg cd i xs) = tryChoices cd i xs
  try (Fail_C_GoProg cd info) = Fail cd info
  try (Guard_C_GoProg cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_GoProg cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_GoProg cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_GoProg cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_GoProg cd i _) = error
    ("Language.Go.Types.GoProg.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_GoProg cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_GoProg cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_GoProg where
  generate s c = Choices_C_GoProg c (freeID [3] s) [C_GoProg (generate
    (leftSupply (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c)
    (generate (rightSupply s) c)]

instance NormalForm C_GoProg where
  ($!!) cont (C_GoProg x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> cont (C_GoProg y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_GoProg cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_GoProg cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_GoProg cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_GoProg cd info) _ _ = failCons cd info
  ($##) cont (C_GoProg x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> cont (C_GoProg y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_GoProg cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_GoProg cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_GoProg cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_GoProg cd info) _ _ = failCons cd info
  showCons (C_GoProg _ _ _) = "Language.Go.Types.GoProg _ _ _"
  showCons x = error ("Language.Go.Types.GoProg.showCons: no constructor: " ++
    show x)
  searchNF search cont (C_GoProg x1 x2 x3) = search (\y1 -> search (\y2 ->
    search (\y3 -> cont (C_GoProg y1 y2 y3)) x3) x2) x1
  searchNF _ _ x = error
    ("Language.Go.Types.GoProg.searchNF: no constructor: " ++ show x)

instance Unifiable C_GoProg where
  (=.=) (C_GoProg x1 x2 x3) (C_GoProg y1 y2 y3) d cs = (&) ((=:=) x1 y1 d cs)
    ((&) ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_GoProg x1 x2 x3) (C_GoProg y1 y2 y3) d cs = (&) ((=:<=) x1 y1 d cs)
    ((&) ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_GoProg x3 x4 x5) = (i :=: ChooseN 0 3) : concat [bind cd (leftID
    (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (rightID i) x5]
  bind d i (Choice_C_GoProg cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_GoProg cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_GoProg cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_GoProg cd i _) = error
    ("Language.Go.Types.GoProg.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_GoProg cd info) = [Unsolvable info]
  bind d i (Guard_C_GoProg cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_GoProg x3 x4 x5) = (i :=: ChooseN 0 3) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x5)]
  lazyBind d i (Choice_C_GoProg cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_GoProg cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_GoProg cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_GoProg cd i _) = error
    ("Language.Go.Types.GoProg.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_GoProg cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_GoProg cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_GoProg where

data C_GoTopLevelDecl
  = C_GoTopLevelDecl C_GoStat
  | C_GoTopLevelFuncDecl C_GoFuncDecl
  | Choice_C_GoTopLevelDecl Cover ID C_GoTopLevelDecl C_GoTopLevelDecl
  | Choices_C_GoTopLevelDecl Cover ID [C_GoTopLevelDecl]
  | Fail_C_GoTopLevelDecl Cover FailInfo
  | Guard_C_GoTopLevelDecl Cover Constraints C_GoTopLevelDecl

instance Show C_GoTopLevelDecl where
  showsPrec d (Choice_C_GoTopLevelDecl cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_GoTopLevelDecl cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_GoTopLevelDecl cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_GoTopLevelDecl cd info) = showChar '!'
  showsPrec _ (C_GoTopLevelDecl x1) = showString "(GoTopLevelDecl" . (showChar
    ' ' . (shows x1 . showChar ')'))
  showsPrec _ (C_GoTopLevelFuncDecl x1) = showString "(GoTopLevelFuncDecl" .
    (showChar ' ' . (shows x1 . showChar ')'))

instance Read C_GoTopLevelDecl where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_GoTopLevelDecl x1, r1) | (_
    , r0) <- readQualified "Language.Go.Types" "GoTopLevelDecl" r, (x1, r1) <-
    readsPrec 11 r0]) s ++ readParen ((>) d 10) (\r -> [(C_GoTopLevelFuncDecl x1
    , r1) | (_, r0) <- readQualified "Language.Go.Types" "GoTopLevelFuncDecl" r,
    (x1, r1) <- readsPrec 11 r0]) s

instance NonDet C_GoTopLevelDecl where
  choiceCons = Choice_C_GoTopLevelDecl
  choicesCons = Choices_C_GoTopLevelDecl
  failCons = Fail_C_GoTopLevelDecl
  guardCons = Guard_C_GoTopLevelDecl
  try (Choice_C_GoTopLevelDecl cd i x y) = tryChoice cd i x y
  try (Choices_C_GoTopLevelDecl cd i xs) = tryChoices cd i xs
  try (Fail_C_GoTopLevelDecl cd info) = Fail cd info
  try (Guard_C_GoTopLevelDecl cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_GoTopLevelDecl cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_GoTopLevelDecl cd i@(NarrowedID _ _) xs) = f cd i
    xs
  match _ _ f _ _ _ (Choices_C_GoTopLevelDecl cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_GoTopLevelDecl cd i _) = error
    ("Language.Go.Types.GoTopLevelDecl.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_GoTopLevelDecl cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_GoTopLevelDecl cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_GoTopLevelDecl where
  generate s c = Choices_C_GoTopLevelDecl c (freeID [1, 1] s) [C_GoTopLevelDecl
    (generate (leftSupply s) c), C_GoTopLevelFuncDecl (generate (leftSupply s)
    c)]

instance NormalForm C_GoTopLevelDecl where
  ($!!) cont (C_GoTopLevelDecl x1) d cs = ($!!) (\y1 d cs -> cont
    (C_GoTopLevelDecl y1) d cs) x1 d cs
  ($!!) cont (C_GoTopLevelFuncDecl x1) d cs = ($!!) (\y1 d cs -> cont
    (C_GoTopLevelFuncDecl y1) d cs) x1 d cs
  ($!!) cont (Choice_C_GoTopLevelDecl cd i x y) d cs = nfChoice cont cd i x y cd
    cs
  ($!!) cont (Choices_C_GoTopLevelDecl cd i xs) d cs = nfChoices cont cd i xs d
    cs
  ($!!) cont (Guard_C_GoTopLevelDecl cd c e) d cs = guardCons cd c (($!!) cont e
    d (addCs c cs))
  ($!!) _ (Fail_C_GoTopLevelDecl cd info) _ _ = failCons cd info
  ($##) cont (C_GoTopLevelDecl x1) d cs = ($##) (\y1 d cs -> cont
    (C_GoTopLevelDecl y1) d cs) x1 d cs
  ($##) cont (C_GoTopLevelFuncDecl x1) d cs = ($##) (\y1 d cs -> cont
    (C_GoTopLevelFuncDecl y1) d cs) x1 d cs
  ($##) cont (Choice_C_GoTopLevelDecl cd i x y) d cs = gnfChoice cont cd i x y
    cd cs
  ($##) cont (Choices_C_GoTopLevelDecl cd i xs) d cs = gnfChoices cont cd i xs d
    cs
  ($##) cont (Guard_C_GoTopLevelDecl cd c e) d cs = guardCons cd c (($##) cont e
    d (addCs c cs))
  ($##) _ (Fail_C_GoTopLevelDecl cd info) _ _ = failCons cd info
  showCons (C_GoTopLevelDecl _) = "Language.Go.Types.GoTopLevelDecl _"
  showCons (C_GoTopLevelFuncDecl _) = "Language.Go.Types.GoTopLevelFuncDecl _"
  showCons x = error
    ("Language.Go.Types.GoTopLevelDecl.showCons: no constructor: " ++ show x)
  searchNF search cont (C_GoTopLevelDecl x1) = search (\y1 -> cont
    (C_GoTopLevelDecl y1)) x1
  searchNF search cont (C_GoTopLevelFuncDecl x1) = search (\y1 -> cont
    (C_GoTopLevelFuncDecl y1)) x1
  searchNF _ _ x = error
    ("Language.Go.Types.GoTopLevelDecl.searchNF: no constructor: " ++ show x)

instance Unifiable C_GoTopLevelDecl where
  (=.=) (C_GoTopLevelDecl x1) (C_GoTopLevelDecl y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_GoTopLevelFuncDecl x1) (C_GoTopLevelFuncDecl y1) d cs = (=:=) x1 y1 d
    cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_GoTopLevelDecl x1) (C_GoTopLevelDecl y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_GoTopLevelFuncDecl x1) (C_GoTopLevelFuncDecl y1) d cs = (=:<=) x1 y1
    d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_GoTopLevelDecl x3) = (i :=: ChooseN 0 1) : concat [bind cd
    (leftID i) x3]
  bind cd i (C_GoTopLevelFuncDecl x3) = (i :=: ChooseN 1 1) : concat [bind cd
    (leftID i) x3]
  bind d i (Choice_C_GoTopLevelDecl cd j x y) = [ConstraintChoice cd j (bind d i
    x) (bind d i y)]
  bind d i (Choices_C_GoTopLevelDecl cd j@(FreeID _ _) xs) = bindOrNarrow d i cd
    j xs
  bind d i (Choices_C_GoTopLevelDecl cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_GoTopLevelDecl cd i _) = error
    ("Language.Go.Types.GoTopLevelDecl.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_GoTopLevelDecl cd info) = [Unsolvable info]
  bind d i (Guard_C_GoTopLevelDecl cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_GoTopLevelDecl x3) = (i :=: ChooseN 0 1) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_GoTopLevelFuncDecl x3) = (i :=: ChooseN 1 1) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_GoTopLevelDecl cd j x y) = [ConstraintChoice cd j
    (lazyBind d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_GoTopLevelDecl cd j@(FreeID _ _) xs) =
    lazyBindOrNarrow d i cd j xs
  lazyBind d i (Choices_C_GoTopLevelDecl cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_GoTopLevelDecl cd i _) = error
    ("Language.Go.Types.GoTopLevelDecl.lazyBind: Choices with ChoiceID: " ++
    show i)
  lazyBind _ _ (Fail_C_GoTopLevelDecl cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_GoTopLevelDecl cd c e) = getConstrList c ++ [i :=:
    LazyBind (lazyBind d i e)]

instance Curry C_GoTopLevelDecl where

data C_GoFuncDecl
  = C_GoFuncDecl (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List C_GoParam) (Curry_Prelude.OP_List C_GoParam)
    (Curry_Prelude.OP_List C_GoStat)
  | Choice_C_GoFuncDecl Cover ID C_GoFuncDecl C_GoFuncDecl
  | Choices_C_GoFuncDecl Cover ID [C_GoFuncDecl]
  | Fail_C_GoFuncDecl Cover FailInfo
  | Guard_C_GoFuncDecl Cover Constraints C_GoFuncDecl

instance Show C_GoFuncDecl where
  showsPrec d (Choice_C_GoFuncDecl cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_GoFuncDecl cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_GoFuncDecl cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_GoFuncDecl cd info) = showChar '!'
  showsPrec _ (C_GoFuncDecl x1 x2 x3 x4) = showString "(GoFuncDecl" . (showChar
    ' ' . (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 .
    (showChar ' ' . (shows x4 . showChar ')'))))))))

instance Read C_GoFuncDecl where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_GoFuncDecl x1 x2 x3 x4
    , r4) | (_, r0) <- readQualified "Language.Go.Types" "GoFuncDecl" r, (x1
    , r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec
    11 r2, (x4, r4) <- readsPrec 11 r3]) s

instance NonDet C_GoFuncDecl where
  choiceCons = Choice_C_GoFuncDecl
  choicesCons = Choices_C_GoFuncDecl
  failCons = Fail_C_GoFuncDecl
  guardCons = Guard_C_GoFuncDecl
  try (Choice_C_GoFuncDecl cd i x y) = tryChoice cd i x y
  try (Choices_C_GoFuncDecl cd i xs) = tryChoices cd i xs
  try (Fail_C_GoFuncDecl cd info) = Fail cd info
  try (Guard_C_GoFuncDecl cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_GoFuncDecl cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_GoFuncDecl cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_GoFuncDecl cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_GoFuncDecl cd i _) = error
    ("Language.Go.Types.GoFuncDecl.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_GoFuncDecl cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_GoFuncDecl cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_GoFuncDecl where
  generate s c = Choices_C_GoFuncDecl c (freeID [4] s) [C_GoFuncDecl (generate
    (leftSupply (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c)
    (generate (leftSupply (rightSupply s)) c) (generate (rightSupply
    (rightSupply s)) c)]

instance NormalForm C_GoFuncDecl where
  ($!!) cont (C_GoFuncDecl x1 x2 x3 x4) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> cont (C_GoFuncDecl y1 y2
    y3 y4) d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_GoFuncDecl cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_GoFuncDecl cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_GoFuncDecl cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_GoFuncDecl cd info) _ _ = failCons cd info
  ($##) cont (C_GoFuncDecl x1 x2 x3 x4) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> ($##) (\y3 d cs -> ($##) (\y4 d cs -> cont (C_GoFuncDecl y1 y2
    y3 y4) d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_GoFuncDecl cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_GoFuncDecl cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_GoFuncDecl cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_GoFuncDecl cd info) _ _ = failCons cd info
  showCons (C_GoFuncDecl _ _ _ _) = "Language.Go.Types.GoFuncDecl _ _ _ _"
  showCons x = error
    ("Language.Go.Types.GoFuncDecl.showCons: no constructor: " ++ show x)
  searchNF search cont (C_GoFuncDecl x1 x2 x3 x4) = search (\y1 -> search
    (\y2 -> search (\y3 -> search (\y4 -> cont (C_GoFuncDecl y1 y2 y3 y4)) x4)
    x3) x2) x1
  searchNF _ _ x = error
    ("Language.Go.Types.GoFuncDecl.searchNF: no constructor: " ++ show x)

instance Unifiable C_GoFuncDecl where
  (=.=) (C_GoFuncDecl x1 x2 x3 x4) (C_GoFuncDecl y1 y2 y3 y4) d cs = (&) ((=:=)
    x1 y1 d cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((=:=) x4 y4 d
    cs) d cs) d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_GoFuncDecl x1 x2 x3 x4) (C_GoFuncDecl y1 y2 y3 y4) d cs = (&)
    ((=:<=) x1 y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs)
    ((=:<=) x4 y4 d cs) d cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_GoFuncDecl x3 x4 x5 x6) = (i :=: ChooseN 0 4) : concat [bind cd
    (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (leftID
    (rightID i)) x5, bind cd (rightID (rightID i)) x6]
  bind d i (Choice_C_GoFuncDecl cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_GoFuncDecl cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j
    xs
  bind d i (Choices_C_GoFuncDecl cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_GoFuncDecl cd i _) = error
    ("Language.Go.Types.GoFuncDecl.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_GoFuncDecl cd info) = [Unsolvable info]
  bind d i (Guard_C_GoFuncDecl cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_GoFuncDecl x3 x4 x5 x6) = (i :=: ChooseN 0 4) : [leftID
    (leftID i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID
    (leftID i) :=: LazyBind (lazyBind cd (rightID (leftID i)) x4), leftID
    (rightID i) :=: LazyBind (lazyBind cd (leftID (rightID i)) x5), rightID
    (rightID i) :=: LazyBind (lazyBind cd (rightID (rightID i)) x6)]
  lazyBind d i (Choice_C_GoFuncDecl cd j x y) = [ConstraintChoice cd j (lazyBind
    d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_GoFuncDecl cd j@(FreeID _ _) xs) = lazyBindOrNarrow d
    i cd j xs
  lazyBind d i (Choices_C_GoFuncDecl cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_GoFuncDecl cd i _) = error
    ("Language.Go.Types.GoFuncDecl.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_GoFuncDecl cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_GoFuncDecl cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_GoFuncDecl where

data C_GoParam
  = C_GoParam (Curry_Prelude.OP_List (Curry_Prelude.OP_List
    Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | Choice_C_GoParam Cover ID C_GoParam C_GoParam
  | Choices_C_GoParam Cover ID [C_GoParam]
  | Fail_C_GoParam Cover FailInfo
  | Guard_C_GoParam Cover Constraints C_GoParam

instance Show C_GoParam where
  showsPrec d (Choice_C_GoParam cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_GoParam cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_GoParam cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_GoParam cd info) = showChar '!'
  showsPrec _ (C_GoParam x1 x2) = showString "(GoParam" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))

instance Read C_GoParam where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_GoParam x1 x2, r2) | (_, r0)
    <- readQualified "Language.Go.Types" "GoParam" r, (x1, r1) <- readsPrec 11
    r0, (x2, r2) <- readsPrec 11 r1]) s

instance NonDet C_GoParam where
  choiceCons = Choice_C_GoParam
  choicesCons = Choices_C_GoParam
  failCons = Fail_C_GoParam
  guardCons = Guard_C_GoParam
  try (Choice_C_GoParam cd i x y) = tryChoice cd i x y
  try (Choices_C_GoParam cd i xs) = tryChoices cd i xs
  try (Fail_C_GoParam cd info) = Fail cd info
  try (Guard_C_GoParam cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_GoParam cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_GoParam cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_GoParam cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_GoParam cd i _) = error
    ("Language.Go.Types.GoParam.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_GoParam cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_GoParam cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_GoParam where
  generate s c = Choices_C_GoParam c (freeID [2] s) [C_GoParam (generate
    (leftSupply s) c) (generate (rightSupply s) c)]

instance NormalForm C_GoParam where
  ($!!) cont (C_GoParam x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_GoParam y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_GoParam cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_GoParam cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_GoParam cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_GoParam cd info) _ _ = failCons cd info
  ($##) cont (C_GoParam x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_GoParam y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_GoParam cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_GoParam cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_GoParam cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_GoParam cd info) _ _ = failCons cd info
  showCons (C_GoParam _ _) = "Language.Go.Types.GoParam _ _"
  showCons x = error ("Language.Go.Types.GoParam.showCons: no constructor: " ++
    show x)
  searchNF search cont (C_GoParam x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_GoParam y1 y2)) x2) x1
  searchNF _ _ x = error
    ("Language.Go.Types.GoParam.searchNF: no constructor: " ++ show x)

instance Unifiable C_GoParam where
  (=.=) (C_GoParam x1 x2) (C_GoParam y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=)
    x2 y2 d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_GoParam x1 x2) (C_GoParam y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_GoParam x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID i)
    x3, bind cd (rightID i) x4]
  bind d i (Choice_C_GoParam cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_GoParam cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_GoParam cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_GoParam cd i _) = error
    ("Language.Go.Types.GoParam.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_GoParam cd info) = [Unsolvable info]
  bind d i (Guard_C_GoParam cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_GoParam x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind d i (Choice_C_GoParam cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_GoParam cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_GoParam cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_GoParam cd i _) = error
    ("Language.Go.Types.GoParam.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_GoParam cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_GoParam cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_GoParam where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_GoExpr
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Go.Types._inst#Prelude.Data#Language.Go.Types.GoExpr#" [show x1]
    info)
  _ -> failCons cd (consFail
    "Language.Go.Types._inst#Prelude.Data#Language.Go.Types.GoExpr#" (showCons
    x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash :: C_GoExpr
  -> C_GoExpr -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash x1 x2 s cd cs =
  case x1 of
  C_GoBoolLit x3 -> d_C__case_34 x3 x2 cd cs
  C_GoIntLit x30 -> d_C__case_33 x30 x2 cd cs
  C_GoFloatLit x57 -> d_C__case_32 x57 x2 cd cs
  C_GoStringLit x84 -> let s0 = s in s0 `seq` nd_C__case_31 x84 x2 s0 cd cs
  C_GoByteLit x111 -> d_C__case_30 x111 x2 cd cs
  C_GoCompositeLit x138 x139 -> let s0 = s
    in s0 `seq` nd_C__case_29 x139 x138 x2 s0 cd cs
  C_GoOpName x166 -> let s0 = s in s0 `seq` nd_C__case_28 x166 x2 s0 cd cs
  C_GoOpExpr x193 -> let s0 = s in s0 `seq` nd_C__case_27 x193 x2 s0 cd cs
  C_GoConversion x220 x221 -> let s0 = s
    in s0 `seq` nd_C__case_26 x221 x220 x2 s0 cd cs
  C_GoSelector x248 x249 -> let s0 = s
    in s0 `seq` nd_C__case_25 x249 x248 x2 s0 cd cs
  C_GoIndex x276 x277 -> let s0 = s
    in s0 `seq` nd_C__case_24 x277 x276 x2 s0 cd cs
  C_GoSlice x304 x305 x306 -> let s0 = s
    in s0 `seq` nd_C__case_23 x306 x305 x304 x2 s0 cd cs
  C_GoVariadic x333 -> let s0 = s in s0 `seq` nd_C__case_22 x333 x2 s0 cd cs
  C_GoCall x360 x361 -> let s0 = s
    in s0 `seq` nd_C__case_21 x361 x360 x2 s0 cd cs
  C_GoUnaryExpr x388 x389 -> let s0 = s
    in s0 `seq` nd_C__case_20 x389 x388 x2 s0 cd cs
  C_GoBinaryExpr x416 x417 x418 -> let s0 = s
    in s0 `seq` nd_C__case_19 x418 x417 x416 x2 s0 cd cs
  Choice_C_GoExpr d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    r x2 s cd cs)
  Choices_C_GoExpr d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    z x2 s cd cs) xs
  Guard_C_GoExpr d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_GoExpr d info -> failCons d (traceFail
    "Language.Go.Types._impl#===#Prelude.Data#Language.Go.Types.GoExpr#" [show
    x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.Go.Types._impl#===#Prelude.Data#Language.Go.Types.GoExpr#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash :: IDSupply
  -> Cover -> ConstStore -> C_GoExpr
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash s cd cs =
  let s79 = s
  in s79 `seq` (let s78 = leftSupply s79
                    s80 = rightSupply s79
                    s71 = leftSupply s80
                    s76 = rightSupply s80
  in s78 `seq` (s80 `seq` (s71 `seq` (s76 `seq` choice (let s70 = leftSupply s71
                                                            s72 = rightSupply
                                                              s71
                                                            s65 = leftSupply s72
                                                            s69 = rightSupply
                                                              s72
  in s70 `seq` (s72 `seq` (s65 `seq` (s69 `seq` choice (let s64 = leftSupply s65
                                                            s66 = rightSupply
                                                              s65
                                                            s59 = leftSupply s66
                                                            s63 = rightSupply
                                                              s66
  in s64 `seq` (s66 `seq` (s59 `seq` (s63 `seq` choice (let s58 = leftSupply s59
                                                            s60 = rightSupply
                                                              s59
                                                            s55 = leftSupply s60
                                                            s57 = rightSupply
                                                              s60
  in s58 `seq` (s60 `seq` (s55 `seq` (s57 `seq` choice (let s54 = leftSupply s55
                                                            s56 = rightSupply
                                                              s55
                                                            s47 = leftSupply s56
                                                            s52 = rightSupply
                                                              s56
  in s54 `seq` (s56 `seq` (s47 `seq` (s52 `seq` choice (let s46 = leftSupply s47
                                                            s48 = rightSupply
                                                              s47
                                                            s41 = leftSupply s48
                                                            s45 = rightSupply
                                                              s48
  in s46 `seq` (s48 `seq` (s41 `seq` (s45 `seq` choice (let s40 = leftSupply s41
                                                            s42 = rightSupply
                                                              s41
                                                            s35 = leftSupply s42
                                                            s39 = rightSupply
                                                              s42
  in s40 `seq` (s42 `seq` (s35 `seq` (s39 `seq` choice (let s34 = leftSupply s35
                                                            s36 = rightSupply
                                                              s35
                                                            s29 = leftSupply s36
                                                            s33 = rightSupply
                                                              s36
  in s34 `seq` (s36 `seq` (s29 `seq` (s33 `seq` choice (let s28 = leftSupply s29
                                                            s30 = rightSupply
                                                              s29
                                                            s25 = leftSupply s30
                                                            s27 = rightSupply
                                                              s30
  in s28 `seq` (s30 `seq` (s25 `seq` (s27 `seq` choice (let s24 = leftSupply s25
                                                            s26 = rightSupply
                                                              s25
                                                            s21 = leftSupply s26
                                                            s23 = rightSupply
                                                              s26
  in s24 `seq` (s26 `seq` (s21 `seq` (s23 `seq` choice (let s20 = leftSupply s21
                                                            s22 = rightSupply
                                                              s21
                                                            s15 = leftSupply s22
                                                            s19 = rightSupply
                                                              s22
  in s20 `seq` (s22 `seq` (s15 `seq` (s19 `seq` choice (let s14 = leftSupply s15
                                                            s16 = rightSupply
                                                              s15
                                                            s11 = leftSupply s16
                                                            s13 = rightSupply
                                                              s16
  in s14 `seq` (s16 `seq` (s11 `seq` (s13 `seq` choice (let s10 = leftSupply s11
                                                            s12 = rightSupply
                                                              s11
                                                            s7 = leftSupply s12
                                                            s9 = rightSupply s12
  in s10 `seq` (s12 `seq` (s7 `seq` (s9 `seq` choice (let s6 = leftSupply s7
                                                          s8 = rightSupply s7
                                                          s3 = leftSupply s8
                                                          s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` choice (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` choice (C_GoBoolLit
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
  s0 cd cs)) (C_GoIntLit
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s1 cd cs)) s2 cd cs)))) (C_GoFloatLit
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Float_hash
  s5 cd cs)) s6 cd cs)))) (C_GoStringLit
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s9 cd cs)) s10 cd cs)))) (C_GoByteLit
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash
  s13 cd cs)) s14 cd cs)))) (let s17 = leftSupply s19
                                 s18 = rightSupply s19
  in s17 `seq` (s18 `seq` C_GoCompositeLit
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s17 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash)
  s18 cd cs))) s20 cd cs)))) (C_GoOpName
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s23 cd cs)) s24 cd cs)))) (C_GoOpExpr
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
  s27 cd cs)) s28 cd cs)))) (let s31 = leftSupply s33
                                 s32 = rightSupply s33
  in s31 `seq` (s32 `seq` C_GoConversion
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s31 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
  s32 cd cs))) s34 cd cs)))) (let s37 = leftSupply s39
                                  s38 = rightSupply s39
  in s37 `seq` (s38 `seq` C_GoSelector
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
  s37 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s38 cd cs))) s40 cd cs)))) (let s43 = leftSupply s45
                                  s44 = rightSupply s45
  in s43 `seq` (s44 `seq` C_GoIndex
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
  s43 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
  s44 cd cs))) s46 cd cs)))) (let s49 = leftSupply s52
                                  s53 = rightSupply s52
                                  s50 = leftSupply s53
                                  s51 = rightSupply s53
  in s49 `seq` (s53 `seq` (s50 `seq` (s51 `seq` C_GoSlice
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
  s49 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
  s50 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
  s51 cd cs))))) s54 cd cs)))) (C_GoVariadic
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
  s57 cd cs)) s58 cd cs)))) (let s61 = leftSupply s63
                                 s62 = rightSupply s63
  in s61 `seq` (s62 `seq` C_GoCall
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
  s61 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash)
  s62 cd cs))) s64 cd cs)))) (let s67 = leftSupply s69
                                  s68 = rightSupply s69
  in s67 `seq` (s68 `seq` C_GoUnaryExpr
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s67 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
  s68 cd cs))) s70 cd cs)))) (let s73 = leftSupply s76
                                  s77 = rightSupply s76
                                  s74 = leftSupply s77
                                  s75 = rightSupply s77
  in s73 `seq` (s77 `seq` (s74 `seq` (s75 `seq` C_GoBinaryExpr
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
  s73 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s74 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
  s75 cd cs))))) s78 cd cs))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_GoStat
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Go.Types._inst#Prelude.Data#Language.Go.Types.GoStat#" [show x1]
    info)
  _ -> failCons cd (consFail
    "Language.Go.Types._inst#Prelude.Data#Language.Go.Types.GoStat#" (showCons
    x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash :: C_GoStat
  -> C_GoStat -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash x1 x2 s cd cs =
  case x1 of
  C_GoConstDecl x3 x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_18 x5 x4 x3 x2 s0 cd cs
  C_GoVarDecl x25 x26 x27 -> let s0 = s
    in s0 `seq` nd_C__case_17 x27 x26 x25 x2 s0 cd cs
  C_GoShortVarDecl x47 x48 -> let s0 = s
    in s0 `seq` nd_C__case_16 x48 x47 x2 s0 cd cs
  C_GoExprStat x68 -> let s0 = s in s0 `seq` nd_C__case_15 x68 x2 s0 cd cs
  C_GoAssign x88 x89 x90 -> let s0 = s
    in s0 `seq` nd_C__case_14 x90 x89 x88 x2 s0 cd cs
  C_GoEmpty -> d_C__case_13 x2 cd cs
  C_GoReturn x129 -> let s0 = s in s0 `seq` nd_C__case_12 x129 x2 s0 cd cs
  C_GoBreak -> d_C__case_11 x2 cd cs
  C_GoContinue -> d_C__case_10 x2 cd cs
  C_GoBlock x187 -> let s0 = s in s0 `seq` nd_C__case_9 x187 x2 s0 cd cs
  C_GoIf x207 x208 x209 -> let s0 = s
    in s0 `seq` nd_C__case_8 x209 x208 x207 x2 s0 cd cs
  C_GoExprSwitch x229 x230 -> let s0 = s
    in s0 `seq` nd_C__case_7 x230 x229 x2 s0 cd cs
  Choice_C_GoStat d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash
    r x2 s cd cs)
  Choices_C_GoStat d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash
    z x2 s cd cs) xs
  Guard_C_GoStat d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_GoStat d info -> failCons d (traceFail
    "Language.Go.Types._impl#===#Prelude.Data#Language.Go.Types.GoStat#" [show
    x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.Go.Types._impl#===#Prelude.Data#Language.Go.Types.GoStat#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash :: IDSupply
  -> Cover -> ConstStore -> C_GoStat
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash s cd cs =
  let s57 = s
  in s57 `seq` (let s56 = leftSupply s57
                    s58 = rightSupply s57
                    s51 = leftSupply s58
                    s55 = rightSupply s58
  in s56 `seq` (s58 `seq` (s51 `seq` (s55 `seq` choice (let s50 = leftSupply s51
                                                            s52 = rightSupply
                                                              s51
                                                            s43 = leftSupply s52
                                                            s48 = rightSupply
                                                              s52
  in s50 `seq` (s52 `seq` (s43 `seq` (s48 `seq` choice (let s42 = leftSupply s43
                                                            s44 = rightSupply
                                                              s43
                                                            s40 = leftSupply s44
                                                            s41 = rightSupply
                                                              s44
  in s42 `seq` (s44 `seq` (s40 `seq` (s41 `seq` choice (let s39 = leftSupply s40
                                                            s38 = rightSupply
                                                              s40
  in s39 `seq` (s38 `seq` choice (let s37 = leftSupply s38
                                      s35 = rightSupply s38
  in s37 `seq` (s35 `seq` choice (let s34 = leftSupply s35
                                      s36 = rightSupply s35
                                      s32 = leftSupply s36
                                      s33 = rightSupply s36
  in s34 `seq` (s36 `seq` (s32 `seq` (s33 `seq` choice (let s31 = leftSupply s32
                                                            s29 = rightSupply
                                                              s32
  in s31 `seq` (s29 `seq` choice (let s28 = leftSupply s29
                                      s30 = rightSupply s29
                                      s21 = leftSupply s30
                                      s26 = rightSupply s30
  in s28 `seq` (s30 `seq` (s21 `seq` (s26 `seq` choice (let s20 = leftSupply s21
                                                            s22 = rightSupply
                                                              s21
                                                            s17 = leftSupply s22
                                                            s19 = rightSupply
                                                              s22
  in s20 `seq` (s22 `seq` (s17 `seq` (s19 `seq` choice (let s16 = leftSupply s17
                                                            s18 = rightSupply
                                                              s17
                                                            s11 = leftSupply s18
                                                            s15 = rightSupply
                                                              s18
  in s16 `seq` (s18 `seq` (s11 `seq` (s15 `seq` choice (let s10 = leftSupply s11
                                                            s12 = rightSupply
                                                              s11
                                                            s3 = leftSupply s12
                                                            s8 = rightSupply s12
  in s10 `seq` (s12 `seq` (s3 `seq` (s8 `seq` choice (let s0 = leftSupply s3
                                                          s4 = rightSupply s3
                                                          s1 = leftSupply s4
                                                          s2 = rightSupply s4
  in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` C_GoConstDecl
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s1 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash)
  s2 cd cs))))) (let s5 = leftSupply s8
                     s9 = rightSupply s8
                     s6 = leftSupply s9
                     s7 = rightSupply s9
  in s5 `seq` (s9 `seq` (s6 `seq` (s7 `seq` C_GoVarDecl
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s5 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s6 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash)
  s7 cd cs))))) s10 cd cs)))) (let s13 = leftSupply s15
                                   s14 = rightSupply s15
  in s13 `seq` (s14 `seq` C_GoShortVarDecl
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s13 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash)
  s14 cd cs))) s16 cd cs)))) (C_GoExprStat
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
  s19 cd cs)) s20 cd cs)))) (let s23 = leftSupply s26
                                 s27 = rightSupply s26
                                 s24 = leftSupply s27
                                 s25 = rightSupply s27
  in s23 `seq` (s27 `seq` (s24 `seq` (s25 `seq` C_GoAssign
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash)
  s23 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s24 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash)
  s25 cd cs))))) s28 cd cs)))) C_GoEmpty s31 cd cs)) (C_GoReturn
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash)
  s33 cd cs)) s34 cd cs)))) C_GoBreak s37 cd cs)) C_GoContinue s39 cd cs))
  (C_GoBlock
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash)
  s41 cd cs)) s42 cd cs)))) (let s45 = leftSupply s48
                                 s49 = rightSupply s48
                                 s46 = leftSupply s49
                                 s47 = rightSupply s49
  in s45 `seq` (s49 `seq` (s46 `seq` (s47 `seq` C_GoIf
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
  s45 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash)
  s46 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash)
  s47 cd cs))))) s50 cd cs)))) (let s53 = leftSupply s55
                                    s54 = rightSupply s55
  in s53 `seq` (s54 `seq` C_GoExprSwitch
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
  s53 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash)
  s54 cd cs))) s56 cd cs))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_GoExprBranch
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Go.Types._inst#Prelude.Data#Language.Go.Types.GoExprBranch#" [show
    x1] info)
  _ -> failCons cd (consFail
    "Language.Go.Types._inst#Prelude.Data#Language.Go.Types.GoExprBranch#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash :: C_GoExprBranch
  -> C_GoExprBranch -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash x1 x2 s cd cs =
  case x1 of
  C_GoExprBranch x3 x4 -> let s0 = s in s0 `seq` nd_C__case_6 x4 x3 x2 s0 cd cs
  C_GoExprDefault x8 -> let s0 = s in s0 `seq` nd_C__case_5 x8 x2 s0 cd cs
  Choice_C_GoExprBranch d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash
    r x2 s cd cs)
  Choices_C_GoExprBranch d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash
    z x2 s cd cs) xs
  Guard_C_GoExprBranch d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_GoExprBranch d info -> failCons d (traceFail
    "Language.Go.Types._impl#===#Prelude.Data#Language.Go.Types.GoExprBranch#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.Go.Types._impl#===#Prelude.Data#Language.Go.Types.GoExprBranch#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash :: IDSupply
  -> Cover -> ConstStore -> C_GoExprBranch
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash s cd cs =
  let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s2 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` choice (let s0 = leftSupply s2
                                                        s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_GoExprBranch
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash)
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash)
  s1 cd cs))) (C_GoExprDefault
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash)
  s3 cd cs)) s4 cd cs))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoProg_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_GoProg
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoProg_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoProg_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoProg_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoProg_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoProg_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoProg_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoProg_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Go.Types._inst#Prelude.Data#Language.Go.Types.GoProg#" [show x1]
    info)
  _ -> failCons cd (consFail
    "Language.Go.Types._inst#Prelude.Data#Language.Go.Types.GoProg#" (showCons
    x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoProg_hash :: C_GoProg
  -> C_GoProg -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoProg_hash x1 x2 s cd cs =
  case x1 of
  C_GoProg x3 x4 x5 -> let s0 = s in s0 `seq` nd_C__case_4 x5 x4 x3 x2 s0 cd cs
  Choice_C_GoProg d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoProg_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoProg_hash
    r x2 s cd cs)
  Choices_C_GoProg d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoProg_hash
    z x2 s cd cs) xs
  Guard_C_GoProg d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoProg_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_GoProg d info -> failCons d (traceFail
    "Language.Go.Types._impl#===#Prelude.Data#Language.Go.Types.GoProg#" [show
    x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.Go.Types._impl#===#Prelude.Data#Language.Go.Types.GoProg#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoProg_hash :: IDSupply
  -> Cover -> ConstStore -> C_GoProg
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoProg_hash s cd cs =
  let s3 = s
  in s3 `seq` (let s0 = leftSupply s3
                   s4 = rightSupply s3
                   s1 = leftSupply s4
                   s2 = rightSupply s4
  in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` C_GoProg
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s1 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash)
  s2 cd cs)))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_GoTopLevelDecl
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Go.Types._inst#Prelude.Data#Language.Go.Types.GoTopLevelDecl#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.Go.Types._inst#Prelude.Data#Language.Go.Types.GoTopLevelDecl#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash :: C_GoTopLevelDecl
  -> C_GoTopLevelDecl -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash x1 x2 s cd cs =
  case x1 of
  C_GoTopLevelDecl x3 -> let s0 = s in s0 `seq` nd_C__case_3 x3 x2 s0 cd cs
  C_GoTopLevelFuncDecl x6 -> let s0 = s in s0 `seq` nd_C__case_2 x6 x2 s0 cd cs
  Choice_C_GoTopLevelDecl d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash
    r x2 s cd cs)
  Choices_C_GoTopLevelDecl d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash
    z x2 s cd cs) xs
  Guard_C_GoTopLevelDecl d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_GoTopLevelDecl d info -> failCons d (traceFail
    "Language.Go.Types._impl#===#Prelude.Data#Language.Go.Types.GoTopLevelDecl#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.Go.Types._impl#===#Prelude.Data#Language.Go.Types.GoTopLevelDecl#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash :: IDSupply
  -> Cover -> ConstStore -> C_GoTopLevelDecl
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash s cd cs =
  let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` choice (C_GoTopLevelDecl
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash
  s0 cd cs)) (C_GoTopLevelFuncDecl
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash
  s1 cd cs)) s2 cd cs))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_GoFuncDecl
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Go.Types._inst#Prelude.Data#Language.Go.Types.GoFuncDecl#" [show
    x1] info)
  _ -> failCons cd (consFail
    "Language.Go.Types._inst#Prelude.Data#Language.Go.Types.GoFuncDecl#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash :: C_GoFuncDecl
  -> C_GoFuncDecl -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash x1 x2 s cd cs =
  case x1 of
  C_GoFuncDecl x3 x4 x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_1 x6 x5 x4 x3 x2 s0 cd cs
  Choice_C_GoFuncDecl d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash
    r x2 s cd cs)
  Choices_C_GoFuncDecl d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash
    z x2 s cd cs) xs
  Guard_C_GoFuncDecl d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_GoFuncDecl d info -> failCons d (traceFail
    "Language.Go.Types._impl#===#Prelude.Data#Language.Go.Types.GoFuncDecl#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.Go.Types._impl#===#Prelude.Data#Language.Go.Types.GoFuncDecl#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash :: IDSupply
  -> Cover -> ConstStore -> C_GoFuncDecl
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash s cd cs =
  let s4 = s
  in s4 `seq` (let s5 = leftSupply s4
                   s6 = rightSupply s4
                   s0 = leftSupply s5
                   s1 = rightSupply s5
                   s2 = leftSupply s6
                   s3 = rightSupply s6
  in s5 `seq` (s6 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s3 `seq` C_GoFuncDecl
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash)
  s1 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash)
  s2 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash)
  s3 cd cs)))))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_GoParam
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.Go.Types._inst#Prelude.Data#Language.Go.Types.GoParam#" [show x1]
    info)
  _ -> failCons cd (consFail
    "Language.Go.Types._inst#Prelude.Data#Language.Go.Types.GoParam#" (showCons
    x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash :: C_GoParam
  -> C_GoParam -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash x1 x2 s cd cs =
  case x1 of
  C_GoParam x3 x4 -> let s0 = s in s0 `seq` nd_C__case_0 x4 x3 x2 s0 cd cs
  Choice_C_GoParam d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash
    r x2 s cd cs)
  Choices_C_GoParam d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash
    z x2 s cd cs) xs
  Guard_C_GoParam d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_GoParam d info -> failCons d (traceFail
    "Language.Go.Types._impl#===#Prelude.Data#Language.Go.Types.GoParam#" [show
    x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.Go.Types._impl#===#Prelude.Data#Language.Go.Types.GoParam#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash :: IDSupply
  -> Cover -> ConstStore -> C_GoParam
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash s cd cs =
  let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_GoParam
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s1 cd cs)))

nd_C__case_19 :: C_GoExpr -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> C_GoExpr -> C_GoExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_19 x418 x417 x416 x2 s cd cs = case x2 of
  C_GoBoolLit x419 -> Curry_Prelude.C_False
  C_GoIntLit x420 -> Curry_Prelude.C_False
  C_GoFloatLit x421 -> Curry_Prelude.C_False
  C_GoStringLit x422 -> Curry_Prelude.C_False
  C_GoByteLit x423 -> Curry_Prelude.C_False
  C_GoCompositeLit x424 x425 -> Curry_Prelude.C_False
  C_GoOpName x426 -> Curry_Prelude.C_False
  C_GoOpExpr x427 -> Curry_Prelude.C_False
  C_GoConversion x428 x429 -> Curry_Prelude.C_False
  C_GoSelector x430 x431 -> Curry_Prelude.C_False
  C_GoIndex x432 x433 -> Curry_Prelude.C_False
  C_GoSlice x434 x435 x436 -> Curry_Prelude.C_False
  C_GoVariadic x437 -> Curry_Prelude.C_False
  C_GoCall x438 x439 -> Curry_Prelude.C_False
  C_GoUnaryExpr x440 x441 -> Curry_Prelude.C_False
  C_GoBinaryExpr x442 x443 x444 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    x416 x442 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x417 x443 s1 cd cs) cd cs))
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    x418 x444 s3 cd cs) cd cs))
  Choice_C_GoExpr d i l r -> narrow d i (nd_C__case_19 x418 x417 x416 l s cd cs)
    (nd_C__case_19 x418 x417 x416 r s cd cs)
  Choices_C_GoExpr d i xs -> narrows cs d i (\z -> nd_C__case_19 x418 x417 x416
    z s cd cs) xs
  Guard_C_GoExpr d c e -> guardCons d c ((\x -> nd_C__case_19 x418 x417 x416 e s
    cd x) $! addCs c cs)
  Fail_C_GoExpr d info -> failCons d (traceFail "Language.Go.Types._case_19"
    [show x418, show x417, show x416, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_19" (showCons x2))

nd_C__case_20 :: C_GoExpr -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> C_GoExpr -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_20 x389 x388 x2 s cd cs = case x2 of
  C_GoBoolLit x390 -> Curry_Prelude.C_False
  C_GoIntLit x391 -> Curry_Prelude.C_False
  C_GoFloatLit x392 -> Curry_Prelude.C_False
  C_GoStringLit x393 -> Curry_Prelude.C_False
  C_GoByteLit x394 -> Curry_Prelude.C_False
  C_GoCompositeLit x395 x396 -> Curry_Prelude.C_False
  C_GoOpName x397 -> Curry_Prelude.C_False
  C_GoOpExpr x398 -> Curry_Prelude.C_False
  C_GoConversion x399 x400 -> Curry_Prelude.C_False
  C_GoSelector x401 x402 -> Curry_Prelude.C_False
  C_GoIndex x403 x404 -> Curry_Prelude.C_False
  C_GoSlice x405 x406 x407 -> Curry_Prelude.C_False
  C_GoVariadic x408 -> Curry_Prelude.C_False
  C_GoCall x409 x410 -> Curry_Prelude.C_False
  C_GoUnaryExpr x411 x412 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x388 x411 s0 cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    x389 x412 s1 cd cs) cd cs))
  C_GoBinaryExpr x413 x414 x415 -> Curry_Prelude.C_False
  Choice_C_GoExpr d i l r -> narrow d i (nd_C__case_20 x389 x388 l s cd cs)
    (nd_C__case_20 x389 x388 r s cd cs)
  Choices_C_GoExpr d i xs -> narrows cs d i (\z -> nd_C__case_20 x389 x388 z s
    cd cs) xs
  Guard_C_GoExpr d c e -> guardCons d c ((\x -> nd_C__case_20 x389 x388 e s cd
    x) $! addCs c cs)
  Fail_C_GoExpr d info -> failCons d (traceFail "Language.Go.Types._case_20"
    [show x389, show x388, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_20" (showCons x2))

nd_C__case_21 :: Curry_Prelude.OP_List C_GoExpr -> C_GoExpr -> C_GoExpr
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_21 x361 x360 x2 s cd cs = case x2 of
  C_GoBoolLit x362 -> Curry_Prelude.C_False
  C_GoIntLit x363 -> Curry_Prelude.C_False
  C_GoFloatLit x364 -> Curry_Prelude.C_False
  C_GoStringLit x365 -> Curry_Prelude.C_False
  C_GoByteLit x366 -> Curry_Prelude.C_False
  C_GoCompositeLit x367 x368 -> Curry_Prelude.C_False
  C_GoOpName x369 -> Curry_Prelude.C_False
  C_GoOpExpr x370 -> Curry_Prelude.C_False
  C_GoConversion x371 x372 -> Curry_Prelude.C_False
  C_GoSelector x373 x374 -> Curry_Prelude.C_False
  C_GoIndex x375 x376 -> Curry_Prelude.C_False
  C_GoSlice x377 x378 x379 -> Curry_Prelude.C_False
  C_GoVariadic x380 -> Curry_Prelude.C_False
  C_GoCall x381 x382 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    x360 x381 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash)
    x361 x382 s1 cd cs) cd cs))
  C_GoUnaryExpr x383 x384 -> Curry_Prelude.C_False
  C_GoBinaryExpr x385 x386 x387 -> Curry_Prelude.C_False
  Choice_C_GoExpr d i l r -> narrow d i (nd_C__case_21 x361 x360 l s cd cs)
    (nd_C__case_21 x361 x360 r s cd cs)
  Choices_C_GoExpr d i xs -> narrows cs d i (\z -> nd_C__case_21 x361 x360 z s
    cd cs) xs
  Guard_C_GoExpr d c e -> guardCons d c ((\x -> nd_C__case_21 x361 x360 e s cd
    x) $! addCs c cs)
  Fail_C_GoExpr d info -> failCons d (traceFail "Language.Go.Types._case_21"
    [show x361, show x360, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_21" (showCons x2))

nd_C__case_22 :: C_GoExpr -> C_GoExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_22 x333 x2 s cd cs = case x2 of
  C_GoBoolLit x334 -> Curry_Prelude.C_False
  C_GoIntLit x335 -> Curry_Prelude.C_False
  C_GoFloatLit x336 -> Curry_Prelude.C_False
  C_GoStringLit x337 -> Curry_Prelude.C_False
  C_GoByteLit x338 -> Curry_Prelude.C_False
  C_GoCompositeLit x339 x340 -> Curry_Prelude.C_False
  C_GoOpName x341 -> Curry_Prelude.C_False
  C_GoOpExpr x342 -> Curry_Prelude.C_False
  C_GoConversion x343 x344 -> Curry_Prelude.C_False
  C_GoSelector x345 x346 -> Curry_Prelude.C_False
  C_GoIndex x347 x348 -> Curry_Prelude.C_False
  C_GoSlice x349 x350 x351 -> Curry_Prelude.C_False
  C_GoVariadic x352 -> let s0 = s
    in s0 `seq`
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    x333 x352 s0 cd cs
  C_GoCall x353 x354 -> Curry_Prelude.C_False
  C_GoUnaryExpr x355 x356 -> Curry_Prelude.C_False
  C_GoBinaryExpr x357 x358 x359 -> Curry_Prelude.C_False
  Choice_C_GoExpr d i l r -> narrow d i (nd_C__case_22 x333 l s cd cs)
    (nd_C__case_22 x333 r s cd cs)
  Choices_C_GoExpr d i xs -> narrows cs d i (\z -> nd_C__case_22 x333 z s cd cs)
    xs
  Guard_C_GoExpr d c e -> guardCons d c ((\x -> nd_C__case_22 x333 e s cd x) $!
    addCs c cs)
  Fail_C_GoExpr d info -> failCons d (traceFail "Language.Go.Types._case_22"
    [show x333, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_22" (showCons x2))

nd_C__case_23 :: C_GoExpr -> C_GoExpr -> C_GoExpr -> C_GoExpr -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_23 x306 x305 x304 x2 s cd cs = case x2 of
  C_GoBoolLit x307 -> Curry_Prelude.C_False
  C_GoIntLit x308 -> Curry_Prelude.C_False
  C_GoFloatLit x309 -> Curry_Prelude.C_False
  C_GoStringLit x310 -> Curry_Prelude.C_False
  C_GoByteLit x311 -> Curry_Prelude.C_False
  C_GoCompositeLit x312 x313 -> Curry_Prelude.C_False
  C_GoOpName x314 -> Curry_Prelude.C_False
  C_GoOpExpr x315 -> Curry_Prelude.C_False
  C_GoConversion x316 x317 -> Curry_Prelude.C_False
  C_GoSelector x318 x319 -> Curry_Prelude.C_False
  C_GoIndex x320 x321 -> Curry_Prelude.C_False
  C_GoSlice x322 x323 x324 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    x304 x322 s0 cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    x305 x323 s1 cd cs) cd cs))
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    x306 x324 s3 cd cs) cd cs))
  C_GoVariadic x325 -> Curry_Prelude.C_False
  C_GoCall x326 x327 -> Curry_Prelude.C_False
  C_GoUnaryExpr x328 x329 -> Curry_Prelude.C_False
  C_GoBinaryExpr x330 x331 x332 -> Curry_Prelude.C_False
  Choice_C_GoExpr d i l r -> narrow d i (nd_C__case_23 x306 x305 x304 l s cd cs)
    (nd_C__case_23 x306 x305 x304 r s cd cs)
  Choices_C_GoExpr d i xs -> narrows cs d i (\z -> nd_C__case_23 x306 x305 x304
    z s cd cs) xs
  Guard_C_GoExpr d c e -> guardCons d c ((\x -> nd_C__case_23 x306 x305 x304 e s
    cd x) $! addCs c cs)
  Fail_C_GoExpr d info -> failCons d (traceFail "Language.Go.Types._case_23"
    [show x306, show x305, show x304, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_23" (showCons x2))

nd_C__case_24 :: C_GoExpr -> C_GoExpr -> C_GoExpr -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_24 x277 x276 x2 s cd cs = case x2 of
  C_GoBoolLit x278 -> Curry_Prelude.C_False
  C_GoIntLit x279 -> Curry_Prelude.C_False
  C_GoFloatLit x280 -> Curry_Prelude.C_False
  C_GoStringLit x281 -> Curry_Prelude.C_False
  C_GoByteLit x282 -> Curry_Prelude.C_False
  C_GoCompositeLit x283 x284 -> Curry_Prelude.C_False
  C_GoOpName x285 -> Curry_Prelude.C_False
  C_GoOpExpr x286 -> Curry_Prelude.C_False
  C_GoConversion x287 x288 -> Curry_Prelude.C_False
  C_GoSelector x289 x290 -> Curry_Prelude.C_False
  C_GoIndex x291 x292 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    x276 x291 s0 cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    x277 x292 s1 cd cs) cd cs))
  C_GoSlice x293 x294 x295 -> Curry_Prelude.C_False
  C_GoVariadic x296 -> Curry_Prelude.C_False
  C_GoCall x297 x298 -> Curry_Prelude.C_False
  C_GoUnaryExpr x299 x300 -> Curry_Prelude.C_False
  C_GoBinaryExpr x301 x302 x303 -> Curry_Prelude.C_False
  Choice_C_GoExpr d i l r -> narrow d i (nd_C__case_24 x277 x276 l s cd cs)
    (nd_C__case_24 x277 x276 r s cd cs)
  Choices_C_GoExpr d i xs -> narrows cs d i (\z -> nd_C__case_24 x277 x276 z s
    cd cs) xs
  Guard_C_GoExpr d c e -> guardCons d c ((\x -> nd_C__case_24 x277 x276 e s cd
    x) $! addCs c cs)
  Fail_C_GoExpr d info -> failCons d (traceFail "Language.Go.Types._case_24"
    [show x277, show x276, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_24" (showCons x2))

nd_C__case_25 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_GoExpr
  -> C_GoExpr -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_25 x249 x248 x2 s cd cs = case x2 of
  C_GoBoolLit x250 -> Curry_Prelude.C_False
  C_GoIntLit x251 -> Curry_Prelude.C_False
  C_GoFloatLit x252 -> Curry_Prelude.C_False
  C_GoStringLit x253 -> Curry_Prelude.C_False
  C_GoByteLit x254 -> Curry_Prelude.C_False
  C_GoCompositeLit x255 x256 -> Curry_Prelude.C_False
  C_GoOpName x257 -> Curry_Prelude.C_False
  C_GoOpExpr x258 -> Curry_Prelude.C_False
  C_GoConversion x259 x260 -> Curry_Prelude.C_False
  C_GoSelector x261 x262 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    x248 x261 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x249 x262 s1 cd cs) cd cs))
  C_GoIndex x263 x264 -> Curry_Prelude.C_False
  C_GoSlice x265 x266 x267 -> Curry_Prelude.C_False
  C_GoVariadic x268 -> Curry_Prelude.C_False
  C_GoCall x269 x270 -> Curry_Prelude.C_False
  C_GoUnaryExpr x271 x272 -> Curry_Prelude.C_False
  C_GoBinaryExpr x273 x274 x275 -> Curry_Prelude.C_False
  Choice_C_GoExpr d i l r -> narrow d i (nd_C__case_25 x249 x248 l s cd cs)
    (nd_C__case_25 x249 x248 r s cd cs)
  Choices_C_GoExpr d i xs -> narrows cs d i (\z -> nd_C__case_25 x249 x248 z s
    cd cs) xs
  Guard_C_GoExpr d c e -> guardCons d c ((\x -> nd_C__case_25 x249 x248 e s cd
    x) $! addCs c cs)
  Fail_C_GoExpr d info -> failCons d (traceFail "Language.Go.Types._case_25"
    [show x249, show x248, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_25" (showCons x2))

nd_C__case_26 :: C_GoExpr -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> C_GoExpr -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_26 x221 x220 x2 s cd cs = case x2 of
  C_GoBoolLit x222 -> Curry_Prelude.C_False
  C_GoIntLit x223 -> Curry_Prelude.C_False
  C_GoFloatLit x224 -> Curry_Prelude.C_False
  C_GoStringLit x225 -> Curry_Prelude.C_False
  C_GoByteLit x226 -> Curry_Prelude.C_False
  C_GoCompositeLit x227 x228 -> Curry_Prelude.C_False
  C_GoOpName x229 -> Curry_Prelude.C_False
  C_GoOpExpr x230 -> Curry_Prelude.C_False
  C_GoConversion x231 x232 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x220 x231 s0 cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    x221 x232 s1 cd cs) cd cs))
  C_GoSelector x233 x234 -> Curry_Prelude.C_False
  C_GoIndex x235 x236 -> Curry_Prelude.C_False
  C_GoSlice x237 x238 x239 -> Curry_Prelude.C_False
  C_GoVariadic x240 -> Curry_Prelude.C_False
  C_GoCall x241 x242 -> Curry_Prelude.C_False
  C_GoUnaryExpr x243 x244 -> Curry_Prelude.C_False
  C_GoBinaryExpr x245 x246 x247 -> Curry_Prelude.C_False
  Choice_C_GoExpr d i l r -> narrow d i (nd_C__case_26 x221 x220 l s cd cs)
    (nd_C__case_26 x221 x220 r s cd cs)
  Choices_C_GoExpr d i xs -> narrows cs d i (\z -> nd_C__case_26 x221 x220 z s
    cd cs) xs
  Guard_C_GoExpr d c e -> guardCons d c ((\x -> nd_C__case_26 x221 x220 e s cd
    x) $! addCs c cs)
  Fail_C_GoExpr d info -> failCons d (traceFail "Language.Go.Types._case_26"
    [show x221, show x220, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_26" (showCons x2))

nd_C__case_27 :: C_GoExpr -> C_GoExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_27 x193 x2 s cd cs = case x2 of
  C_GoBoolLit x194 -> Curry_Prelude.C_False
  C_GoIntLit x195 -> Curry_Prelude.C_False
  C_GoFloatLit x196 -> Curry_Prelude.C_False
  C_GoStringLit x197 -> Curry_Prelude.C_False
  C_GoByteLit x198 -> Curry_Prelude.C_False
  C_GoCompositeLit x199 x200 -> Curry_Prelude.C_False
  C_GoOpName x201 -> Curry_Prelude.C_False
  C_GoOpExpr x202 -> let s0 = s
    in s0 `seq`
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    x193 x202 s0 cd cs
  C_GoConversion x203 x204 -> Curry_Prelude.C_False
  C_GoSelector x205 x206 -> Curry_Prelude.C_False
  C_GoIndex x207 x208 -> Curry_Prelude.C_False
  C_GoSlice x209 x210 x211 -> Curry_Prelude.C_False
  C_GoVariadic x212 -> Curry_Prelude.C_False
  C_GoCall x213 x214 -> Curry_Prelude.C_False
  C_GoUnaryExpr x215 x216 -> Curry_Prelude.C_False
  C_GoBinaryExpr x217 x218 x219 -> Curry_Prelude.C_False
  Choice_C_GoExpr d i l r -> narrow d i (nd_C__case_27 x193 l s cd cs)
    (nd_C__case_27 x193 r s cd cs)
  Choices_C_GoExpr d i xs -> narrows cs d i (\z -> nd_C__case_27 x193 z s cd cs)
    xs
  Guard_C_GoExpr d c e -> guardCons d c ((\x -> nd_C__case_27 x193 e s cd x) $!
    addCs c cs)
  Fail_C_GoExpr d info -> failCons d (traceFail "Language.Go.Types._case_27"
    [show x193, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_27" (showCons x2))

nd_C__case_28 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_GoExpr
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_28 x166 x2 s cd cs = case x2 of
  C_GoBoolLit x167 -> Curry_Prelude.C_False
  C_GoIntLit x168 -> Curry_Prelude.C_False
  C_GoFloatLit x169 -> Curry_Prelude.C_False
  C_GoStringLit x170 -> Curry_Prelude.C_False
  C_GoByteLit x171 -> Curry_Prelude.C_False
  C_GoCompositeLit x172 x173 -> Curry_Prelude.C_False
  C_GoOpName x174 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x166 x174 s0 cd cs
  C_GoOpExpr x175 -> Curry_Prelude.C_False
  C_GoConversion x176 x177 -> Curry_Prelude.C_False
  C_GoSelector x178 x179 -> Curry_Prelude.C_False
  C_GoIndex x180 x181 -> Curry_Prelude.C_False
  C_GoSlice x182 x183 x184 -> Curry_Prelude.C_False
  C_GoVariadic x185 -> Curry_Prelude.C_False
  C_GoCall x186 x187 -> Curry_Prelude.C_False
  C_GoUnaryExpr x188 x189 -> Curry_Prelude.C_False
  C_GoBinaryExpr x190 x191 x192 -> Curry_Prelude.C_False
  Choice_C_GoExpr d i l r -> narrow d i (nd_C__case_28 x166 l s cd cs)
    (nd_C__case_28 x166 r s cd cs)
  Choices_C_GoExpr d i xs -> narrows cs d i (\z -> nd_C__case_28 x166 z s cd cs)
    xs
  Guard_C_GoExpr d c e -> guardCons d c ((\x -> nd_C__case_28 x166 e s cd x) $!
    addCs c cs)
  Fail_C_GoExpr d info -> failCons d (traceFail "Language.Go.Types._case_28"
    [show x166, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_28" (showCons x2))

nd_C__case_29 :: Curry_Prelude.OP_List C_GoExpr -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_GoExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_29 x139 x138 x2 s cd cs = case x2 of
  C_GoBoolLit x140 -> Curry_Prelude.C_False
  C_GoIntLit x141 -> Curry_Prelude.C_False
  C_GoFloatLit x142 -> Curry_Prelude.C_False
  C_GoStringLit x143 -> Curry_Prelude.C_False
  C_GoByteLit x144 -> Curry_Prelude.C_False
  C_GoCompositeLit x145 x146 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x138 x145 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash)
    x139 x146 s1 cd cs) cd cs))
  C_GoOpName x147 -> Curry_Prelude.C_False
  C_GoOpExpr x148 -> Curry_Prelude.C_False
  C_GoConversion x149 x150 -> Curry_Prelude.C_False
  C_GoSelector x151 x152 -> Curry_Prelude.C_False
  C_GoIndex x153 x154 -> Curry_Prelude.C_False
  C_GoSlice x155 x156 x157 -> Curry_Prelude.C_False
  C_GoVariadic x158 -> Curry_Prelude.C_False
  C_GoCall x159 x160 -> Curry_Prelude.C_False
  C_GoUnaryExpr x161 x162 -> Curry_Prelude.C_False
  C_GoBinaryExpr x163 x164 x165 -> Curry_Prelude.C_False
  Choice_C_GoExpr d i l r -> narrow d i (nd_C__case_29 x139 x138 l s cd cs)
    (nd_C__case_29 x139 x138 r s cd cs)
  Choices_C_GoExpr d i xs -> narrows cs d i (\z -> nd_C__case_29 x139 x138 z s
    cd cs) xs
  Guard_C_GoExpr d c e -> guardCons d c ((\x -> nd_C__case_29 x139 x138 e s cd
    x) $! addCs c cs)
  Fail_C_GoExpr d info -> failCons d (traceFail "Language.Go.Types._case_29"
    [show x139, show x138, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_29" (showCons x2))

d_C__case_30 :: Curry_Prelude.C_Char -> C_GoExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_30 x111 x2 cd cs = case x2 of
  C_GoBoolLit x112 -> Curry_Prelude.C_False
  C_GoIntLit x113 -> Curry_Prelude.C_False
  C_GoFloatLit x114 -> Curry_Prelude.C_False
  C_GoStringLit x115 -> Curry_Prelude.C_False
  C_GoByteLit x116 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash
    cd cs) x111 cd cs) x116 cd cs
  C_GoCompositeLit x117 x118 -> Curry_Prelude.C_False
  C_GoOpName x119 -> Curry_Prelude.C_False
  C_GoOpExpr x120 -> Curry_Prelude.C_False
  C_GoConversion x121 x122 -> Curry_Prelude.C_False
  C_GoSelector x123 x124 -> Curry_Prelude.C_False
  C_GoIndex x125 x126 -> Curry_Prelude.C_False
  C_GoSlice x127 x128 x129 -> Curry_Prelude.C_False
  C_GoVariadic x130 -> Curry_Prelude.C_False
  C_GoCall x131 x132 -> Curry_Prelude.C_False
  C_GoUnaryExpr x133 x134 -> Curry_Prelude.C_False
  C_GoBinaryExpr x135 x136 x137 -> Curry_Prelude.C_False
  Choice_C_GoExpr d i l r -> narrow d i (d_C__case_30 x111 l cd cs)
    (d_C__case_30 x111 r cd cs)
  Choices_C_GoExpr d i xs -> narrows cs d i (\z -> d_C__case_30 x111 z cd cs) xs
  Guard_C_GoExpr d c e -> guardCons d c ((\x -> d_C__case_30 x111 e cd x) $!
    addCs c cs)
  Fail_C_GoExpr d info -> failCons d (traceFail "Language.Go.Types._case_30"
    [show x111, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_30" (showCons x2))

nd_C__case_31 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_GoExpr
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_31 x84 x2 s cd cs = case x2 of
  C_GoBoolLit x85 -> Curry_Prelude.C_False
  C_GoIntLit x86 -> Curry_Prelude.C_False
  C_GoFloatLit x87 -> Curry_Prelude.C_False
  C_GoStringLit x88 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x84 x88 s0 cd cs
  C_GoByteLit x89 -> Curry_Prelude.C_False
  C_GoCompositeLit x90 x91 -> Curry_Prelude.C_False
  C_GoOpName x92 -> Curry_Prelude.C_False
  C_GoOpExpr x93 -> Curry_Prelude.C_False
  C_GoConversion x94 x95 -> Curry_Prelude.C_False
  C_GoSelector x96 x97 -> Curry_Prelude.C_False
  C_GoIndex x98 x99 -> Curry_Prelude.C_False
  C_GoSlice x100 x101 x102 -> Curry_Prelude.C_False
  C_GoVariadic x103 -> Curry_Prelude.C_False
  C_GoCall x104 x105 -> Curry_Prelude.C_False
  C_GoUnaryExpr x106 x107 -> Curry_Prelude.C_False
  C_GoBinaryExpr x108 x109 x110 -> Curry_Prelude.C_False
  Choice_C_GoExpr d i l r -> narrow d i (nd_C__case_31 x84 l s cd cs)
    (nd_C__case_31 x84 r s cd cs)
  Choices_C_GoExpr d i xs -> narrows cs d i (\z -> nd_C__case_31 x84 z s cd cs)
    xs
  Guard_C_GoExpr d c e -> guardCons d c ((\x -> nd_C__case_31 x84 e s cd x) $!
    addCs c cs)
  Fail_C_GoExpr d info -> failCons d (traceFail "Language.Go.Types._case_31"
    [show x84, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_31" (showCons x2))

d_C__case_32 :: Curry_Prelude.C_Float -> C_GoExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_32 x57 x2 cd cs = case x2 of
  C_GoBoolLit x58 -> Curry_Prelude.C_False
  C_GoIntLit x59 -> Curry_Prelude.C_False
  C_GoFloatLit x60 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Float_hash
    cd cs) x57 cd cs) x60 cd cs
  C_GoStringLit x61 -> Curry_Prelude.C_False
  C_GoByteLit x62 -> Curry_Prelude.C_False
  C_GoCompositeLit x63 x64 -> Curry_Prelude.C_False
  C_GoOpName x65 -> Curry_Prelude.C_False
  C_GoOpExpr x66 -> Curry_Prelude.C_False
  C_GoConversion x67 x68 -> Curry_Prelude.C_False
  C_GoSelector x69 x70 -> Curry_Prelude.C_False
  C_GoIndex x71 x72 -> Curry_Prelude.C_False
  C_GoSlice x73 x74 x75 -> Curry_Prelude.C_False
  C_GoVariadic x76 -> Curry_Prelude.C_False
  C_GoCall x77 x78 -> Curry_Prelude.C_False
  C_GoUnaryExpr x79 x80 -> Curry_Prelude.C_False
  C_GoBinaryExpr x81 x82 x83 -> Curry_Prelude.C_False
  Choice_C_GoExpr d i l r -> narrow d i (d_C__case_32 x57 l cd cs) (d_C__case_32
    x57 r cd cs)
  Choices_C_GoExpr d i xs -> narrows cs d i (\z -> d_C__case_32 x57 z cd cs) xs
  Guard_C_GoExpr d c e -> guardCons d c ((\x -> d_C__case_32 x57 e cd x) $!
    addCs c cs)
  Fail_C_GoExpr d info -> failCons d (traceFail "Language.Go.Types._case_32"
    [show x57, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_32" (showCons x2))

d_C__case_33 :: Curry_Prelude.C_Int -> C_GoExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_33 x30 x2 cd cs = case x2 of
  C_GoBoolLit x31 -> Curry_Prelude.C_False
  C_GoIntLit x32 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs) x30 cd cs) x32 cd cs
  C_GoFloatLit x33 -> Curry_Prelude.C_False
  C_GoStringLit x34 -> Curry_Prelude.C_False
  C_GoByteLit x35 -> Curry_Prelude.C_False
  C_GoCompositeLit x36 x37 -> Curry_Prelude.C_False
  C_GoOpName x38 -> Curry_Prelude.C_False
  C_GoOpExpr x39 -> Curry_Prelude.C_False
  C_GoConversion x40 x41 -> Curry_Prelude.C_False
  C_GoSelector x42 x43 -> Curry_Prelude.C_False
  C_GoIndex x44 x45 -> Curry_Prelude.C_False
  C_GoSlice x46 x47 x48 -> Curry_Prelude.C_False
  C_GoVariadic x49 -> Curry_Prelude.C_False
  C_GoCall x50 x51 -> Curry_Prelude.C_False
  C_GoUnaryExpr x52 x53 -> Curry_Prelude.C_False
  C_GoBinaryExpr x54 x55 x56 -> Curry_Prelude.C_False
  Choice_C_GoExpr d i l r -> narrow d i (d_C__case_33 x30 l cd cs) (d_C__case_33
    x30 r cd cs)
  Choices_C_GoExpr d i xs -> narrows cs d i (\z -> d_C__case_33 x30 z cd cs) xs
  Guard_C_GoExpr d c e -> guardCons d c ((\x -> d_C__case_33 x30 e cd x) $!
    addCs c cs)
  Fail_C_GoExpr d info -> failCons d (traceFail "Language.Go.Types._case_33"
    [show x30, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_33" (showCons x2))

d_C__case_34 :: Curry_Prelude.C_Bool -> C_GoExpr -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_34 x3 x2 cd cs = case x2 of
  C_GoBoolLit x4 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
    x3 x4 cd cs
  C_GoIntLit x5 -> Curry_Prelude.C_False
  C_GoFloatLit x6 -> Curry_Prelude.C_False
  C_GoStringLit x7 -> Curry_Prelude.C_False
  C_GoByteLit x8 -> Curry_Prelude.C_False
  C_GoCompositeLit x9 x10 -> Curry_Prelude.C_False
  C_GoOpName x11 -> Curry_Prelude.C_False
  C_GoOpExpr x12 -> Curry_Prelude.C_False
  C_GoConversion x13 x14 -> Curry_Prelude.C_False
  C_GoSelector x15 x16 -> Curry_Prelude.C_False
  C_GoIndex x17 x18 -> Curry_Prelude.C_False
  C_GoSlice x19 x20 x21 -> Curry_Prelude.C_False
  C_GoVariadic x22 -> Curry_Prelude.C_False
  C_GoCall x23 x24 -> Curry_Prelude.C_False
  C_GoUnaryExpr x25 x26 -> Curry_Prelude.C_False
  C_GoBinaryExpr x27 x28 x29 -> Curry_Prelude.C_False
  Choice_C_GoExpr d i l r -> narrow d i (d_C__case_34 x3 l cd cs) (d_C__case_34
    x3 r cd cs)
  Choices_C_GoExpr d i xs -> narrows cs d i (\z -> d_C__case_34 x3 z cd cs) xs
  Guard_C_GoExpr d c e -> guardCons d c ((\x -> d_C__case_34 x3 e cd x) $! addCs
    c cs)
  Fail_C_GoExpr d info -> failCons d (traceFail "Language.Go.Types._case_34"
    [show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_34" (showCons x2))

nd_C__case_7 :: Curry_Prelude.OP_List C_GoExprBranch -> C_GoExpr -> C_GoStat
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_7 x230 x229 x2 s cd cs = case x2 of
  C_GoConstDecl x231 x232 x233 -> Curry_Prelude.C_False
  C_GoVarDecl x234 x235 x236 -> Curry_Prelude.C_False
  C_GoShortVarDecl x237 x238 -> Curry_Prelude.C_False
  C_GoExprStat x239 -> Curry_Prelude.C_False
  C_GoAssign x240 x241 x242 -> Curry_Prelude.C_False
  C_GoEmpty -> Curry_Prelude.C_False
  C_GoReturn x243 -> Curry_Prelude.C_False
  C_GoBreak -> Curry_Prelude.C_False
  C_GoContinue -> Curry_Prelude.C_False
  C_GoBlock x244 -> Curry_Prelude.C_False
  C_GoIf x245 x246 x247 -> Curry_Prelude.C_False
  C_GoExprSwitch x248 x249 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    x229 x248 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExprBranch_hash)
    x230 x249 s1 cd cs) cd cs))
  Choice_C_GoStat d i l r -> narrow d i (nd_C__case_7 x230 x229 l s cd cs)
    (nd_C__case_7 x230 x229 r s cd cs)
  Choices_C_GoStat d i xs -> narrows cs d i (\z -> nd_C__case_7 x230 x229 z s cd
    cs) xs
  Guard_C_GoStat d c e -> guardCons d c ((\x -> nd_C__case_7 x230 x229 e s cd
    x) $! addCs c cs)
  Fail_C_GoStat d info -> failCons d (traceFail "Language.Go.Types._case_7"
    [show x230, show x229, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_7" (showCons x2))

nd_C__case_8 :: Curry_Prelude.OP_List C_GoStat -> Curry_Prelude.OP_List C_GoStat
  -> C_GoExpr -> C_GoStat -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_8 x209 x208 x207 x2 s cd cs = case x2 of
  C_GoConstDecl x210 x211 x212 -> Curry_Prelude.C_False
  C_GoVarDecl x213 x214 x215 -> Curry_Prelude.C_False
  C_GoShortVarDecl x216 x217 -> Curry_Prelude.C_False
  C_GoExprStat x218 -> Curry_Prelude.C_False
  C_GoAssign x219 x220 x221 -> Curry_Prelude.C_False
  C_GoEmpty -> Curry_Prelude.C_False
  C_GoReturn x222 -> Curry_Prelude.C_False
  C_GoBreak -> Curry_Prelude.C_False
  C_GoContinue -> Curry_Prelude.C_False
  C_GoBlock x223 -> Curry_Prelude.C_False
  C_GoIf x224 x225 x226 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    x207 x224 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash)
    x208 x225 s1 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash)
    x209 x226 s3 cd cs) cd cs))
  C_GoExprSwitch x227 x228 -> Curry_Prelude.C_False
  Choice_C_GoStat d i l r -> narrow d i (nd_C__case_8 x209 x208 x207 l s cd cs)
    (nd_C__case_8 x209 x208 x207 r s cd cs)
  Choices_C_GoStat d i xs -> narrows cs d i (\z -> nd_C__case_8 x209 x208 x207 z
    s cd cs) xs
  Guard_C_GoStat d c e -> guardCons d c ((\x -> nd_C__case_8 x209 x208 x207 e s
    cd x) $! addCs c cs)
  Fail_C_GoStat d info -> failCons d (traceFail "Language.Go.Types._case_8"
    [show x209, show x208, show x207, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_8" (showCons x2))

nd_C__case_9 :: Curry_Prelude.OP_List C_GoStat -> C_GoStat -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_9 x187 x2 s cd cs = case x2 of
  C_GoConstDecl x188 x189 x190 -> Curry_Prelude.C_False
  C_GoVarDecl x191 x192 x193 -> Curry_Prelude.C_False
  C_GoShortVarDecl x194 x195 -> Curry_Prelude.C_False
  C_GoExprStat x196 -> Curry_Prelude.C_False
  C_GoAssign x197 x198 x199 -> Curry_Prelude.C_False
  C_GoEmpty -> Curry_Prelude.C_False
  C_GoReturn x200 -> Curry_Prelude.C_False
  C_GoBreak -> Curry_Prelude.C_False
  C_GoContinue -> Curry_Prelude.C_False
  C_GoBlock x201 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash)
    x187 x201 s0 cd cs
  C_GoIf x202 x203 x204 -> Curry_Prelude.C_False
  C_GoExprSwitch x205 x206 -> Curry_Prelude.C_False
  Choice_C_GoStat d i l r -> narrow d i (nd_C__case_9 x187 l s cd cs)
    (nd_C__case_9 x187 r s cd cs)
  Choices_C_GoStat d i xs -> narrows cs d i (\z -> nd_C__case_9 x187 z s cd cs)
    xs
  Guard_C_GoStat d c e -> guardCons d c ((\x -> nd_C__case_9 x187 e s cd x) $!
    addCs c cs)
  Fail_C_GoStat d info -> failCons d (traceFail "Language.Go.Types._case_9"
    [show x187, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_9" (showCons x2))

d_C__case_10 :: C_GoStat -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_10 x2 cd cs = case x2 of
  C_GoConstDecl x168 x169 x170 -> Curry_Prelude.C_False
  C_GoVarDecl x171 x172 x173 -> Curry_Prelude.C_False
  C_GoShortVarDecl x174 x175 -> Curry_Prelude.C_False
  C_GoExprStat x176 -> Curry_Prelude.C_False
  C_GoAssign x177 x178 x179 -> Curry_Prelude.C_False
  C_GoEmpty -> Curry_Prelude.C_False
  C_GoReturn x180 -> Curry_Prelude.C_False
  C_GoBreak -> Curry_Prelude.C_False
  C_GoContinue -> Curry_Prelude.C_True
  C_GoBlock x181 -> Curry_Prelude.C_False
  C_GoIf x182 x183 x184 -> Curry_Prelude.C_False
  C_GoExprSwitch x185 x186 -> Curry_Prelude.C_False
  Choice_C_GoStat d i l r -> narrow d i (d_C__case_10 l cd cs) (d_C__case_10 r
    cd cs)
  Choices_C_GoStat d i xs -> narrows cs d i (\z -> d_C__case_10 z cd cs) xs
  Guard_C_GoStat d c e -> guardCons d c ((\x -> d_C__case_10 e cd x) $! addCs c
    cs)
  Fail_C_GoStat d info -> failCons d (traceFail "Language.Go.Types._case_10"
    [show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_10" (showCons x2))

d_C__case_11 :: C_GoStat -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_11 x2 cd cs = case x2 of
  C_GoConstDecl x149 x150 x151 -> Curry_Prelude.C_False
  C_GoVarDecl x152 x153 x154 -> Curry_Prelude.C_False
  C_GoShortVarDecl x155 x156 -> Curry_Prelude.C_False
  C_GoExprStat x157 -> Curry_Prelude.C_False
  C_GoAssign x158 x159 x160 -> Curry_Prelude.C_False
  C_GoEmpty -> Curry_Prelude.C_False
  C_GoReturn x161 -> Curry_Prelude.C_False
  C_GoBreak -> Curry_Prelude.C_True
  C_GoContinue -> Curry_Prelude.C_False
  C_GoBlock x162 -> Curry_Prelude.C_False
  C_GoIf x163 x164 x165 -> Curry_Prelude.C_False
  C_GoExprSwitch x166 x167 -> Curry_Prelude.C_False
  Choice_C_GoStat d i l r -> narrow d i (d_C__case_11 l cd cs) (d_C__case_11 r
    cd cs)
  Choices_C_GoStat d i xs -> narrows cs d i (\z -> d_C__case_11 z cd cs) xs
  Guard_C_GoStat d c e -> guardCons d c ((\x -> d_C__case_11 e cd x) $! addCs c
    cs)
  Fail_C_GoStat d info -> failCons d (traceFail "Language.Go.Types._case_11"
    [show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_11" (showCons x2))

nd_C__case_12 :: Curry_Prelude.OP_List C_GoExpr -> C_GoStat -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_12 x129 x2 s cd cs = case x2 of
  C_GoConstDecl x130 x131 x132 -> Curry_Prelude.C_False
  C_GoVarDecl x133 x134 x135 -> Curry_Prelude.C_False
  C_GoShortVarDecl x136 x137 -> Curry_Prelude.C_False
  C_GoExprStat x138 -> Curry_Prelude.C_False
  C_GoAssign x139 x140 x141 -> Curry_Prelude.C_False
  C_GoEmpty -> Curry_Prelude.C_False
  C_GoReturn x142 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash)
    x129 x142 s0 cd cs
  C_GoBreak -> Curry_Prelude.C_False
  C_GoContinue -> Curry_Prelude.C_False
  C_GoBlock x143 -> Curry_Prelude.C_False
  C_GoIf x144 x145 x146 -> Curry_Prelude.C_False
  C_GoExprSwitch x147 x148 -> Curry_Prelude.C_False
  Choice_C_GoStat d i l r -> narrow d i (nd_C__case_12 x129 l s cd cs)
    (nd_C__case_12 x129 r s cd cs)
  Choices_C_GoStat d i xs -> narrows cs d i (\z -> nd_C__case_12 x129 z s cd cs)
    xs
  Guard_C_GoStat d c e -> guardCons d c ((\x -> nd_C__case_12 x129 e s cd x) $!
    addCs c cs)
  Fail_C_GoStat d info -> failCons d (traceFail "Language.Go.Types._case_12"
    [show x129, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_12" (showCons x2))

d_C__case_13 :: C_GoStat -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_13 x2 cd cs = case x2 of
  C_GoConstDecl x110 x111 x112 -> Curry_Prelude.C_False
  C_GoVarDecl x113 x114 x115 -> Curry_Prelude.C_False
  C_GoShortVarDecl x116 x117 -> Curry_Prelude.C_False
  C_GoExprStat x118 -> Curry_Prelude.C_False
  C_GoAssign x119 x120 x121 -> Curry_Prelude.C_False
  C_GoEmpty -> Curry_Prelude.C_True
  C_GoReturn x122 -> Curry_Prelude.C_False
  C_GoBreak -> Curry_Prelude.C_False
  C_GoContinue -> Curry_Prelude.C_False
  C_GoBlock x123 -> Curry_Prelude.C_False
  C_GoIf x124 x125 x126 -> Curry_Prelude.C_False
  C_GoExprSwitch x127 x128 -> Curry_Prelude.C_False
  Choice_C_GoStat d i l r -> narrow d i (d_C__case_13 l cd cs) (d_C__case_13 r
    cd cs)
  Choices_C_GoStat d i xs -> narrows cs d i (\z -> d_C__case_13 z cd cs) xs
  Guard_C_GoStat d c e -> guardCons d c ((\x -> d_C__case_13 e cd x) $! addCs c
    cs)
  Fail_C_GoStat d info -> failCons d (traceFail "Language.Go.Types._case_13"
    [show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_13" (showCons x2))

nd_C__case_14 :: Curry_Prelude.OP_List C_GoExpr -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List C_GoExpr -> C_GoStat -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_14 x90 x89 x88 x2 s cd cs = case x2 of
  C_GoConstDecl x91 x92 x93 -> Curry_Prelude.C_False
  C_GoVarDecl x94 x95 x96 -> Curry_Prelude.C_False
  C_GoShortVarDecl x97 x98 -> Curry_Prelude.C_False
  C_GoExprStat x99 -> Curry_Prelude.C_False
  C_GoAssign x100 x101 x102 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash)
    x88 x100 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x89 x101 s1 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash)
    x90 x102 s3 cd cs) cd cs))
  C_GoEmpty -> Curry_Prelude.C_False
  C_GoReturn x103 -> Curry_Prelude.C_False
  C_GoBreak -> Curry_Prelude.C_False
  C_GoContinue -> Curry_Prelude.C_False
  C_GoBlock x104 -> Curry_Prelude.C_False
  C_GoIf x105 x106 x107 -> Curry_Prelude.C_False
  C_GoExprSwitch x108 x109 -> Curry_Prelude.C_False
  Choice_C_GoStat d i l r -> narrow d i (nd_C__case_14 x90 x89 x88 l s cd cs)
    (nd_C__case_14 x90 x89 x88 r s cd cs)
  Choices_C_GoStat d i xs -> narrows cs d i (\z -> nd_C__case_14 x90 x89 x88 z s
    cd cs) xs
  Guard_C_GoStat d c e -> guardCons d c ((\x -> nd_C__case_14 x90 x89 x88 e s cd
    x) $! addCs c cs)
  Fail_C_GoStat d info -> failCons d (traceFail "Language.Go.Types._case_14"
    [show x90, show x89, show x88, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_14" (showCons x2))

nd_C__case_15 :: C_GoExpr -> C_GoStat -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_15 x68 x2 s cd cs = case x2 of
  C_GoConstDecl x69 x70 x71 -> Curry_Prelude.C_False
  C_GoVarDecl x72 x73 x74 -> Curry_Prelude.C_False
  C_GoShortVarDecl x75 x76 -> Curry_Prelude.C_False
  C_GoExprStat x77 -> let s0 = s
    in s0 `seq`
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash
    x68 x77 s0 cd cs
  C_GoAssign x78 x79 x80 -> Curry_Prelude.C_False
  C_GoEmpty -> Curry_Prelude.C_False
  C_GoReturn x81 -> Curry_Prelude.C_False
  C_GoBreak -> Curry_Prelude.C_False
  C_GoContinue -> Curry_Prelude.C_False
  C_GoBlock x82 -> Curry_Prelude.C_False
  C_GoIf x83 x84 x85 -> Curry_Prelude.C_False
  C_GoExprSwitch x86 x87 -> Curry_Prelude.C_False
  Choice_C_GoStat d i l r -> narrow d i (nd_C__case_15 x68 l s cd cs)
    (nd_C__case_15 x68 r s cd cs)
  Choices_C_GoStat d i xs -> narrows cs d i (\z -> nd_C__case_15 x68 z s cd cs)
    xs
  Guard_C_GoStat d c e -> guardCons d c ((\x -> nd_C__case_15 x68 e s cd x) $!
    addCs c cs)
  Fail_C_GoStat d info -> failCons d (traceFail "Language.Go.Types._case_15"
    [show x68, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_15" (showCons x2))

nd_C__case_16 :: Curry_Prelude.OP_List C_GoExpr -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> C_GoStat -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_16 x48 x47 x2 s cd cs = case x2 of
  C_GoConstDecl x49 x50 x51 -> Curry_Prelude.C_False
  C_GoVarDecl x52 x53 x54 -> Curry_Prelude.C_False
  C_GoShortVarDecl x55 x56 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    x47 x55 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash)
    x48 x56 s1 cd cs) cd cs))
  C_GoExprStat x57 -> Curry_Prelude.C_False
  C_GoAssign x58 x59 x60 -> Curry_Prelude.C_False
  C_GoEmpty -> Curry_Prelude.C_False
  C_GoReturn x61 -> Curry_Prelude.C_False
  C_GoBreak -> Curry_Prelude.C_False
  C_GoContinue -> Curry_Prelude.C_False
  C_GoBlock x62 -> Curry_Prelude.C_False
  C_GoIf x63 x64 x65 -> Curry_Prelude.C_False
  C_GoExprSwitch x66 x67 -> Curry_Prelude.C_False
  Choice_C_GoStat d i l r -> narrow d i (nd_C__case_16 x48 x47 l s cd cs)
    (nd_C__case_16 x48 x47 r s cd cs)
  Choices_C_GoStat d i xs -> narrows cs d i (\z -> nd_C__case_16 x48 x47 z s cd
    cs) xs
  Guard_C_GoStat d c e -> guardCons d c ((\x -> nd_C__case_16 x48 x47 e s cd
    x) $! addCs c cs)
  Fail_C_GoStat d info -> failCons d (traceFail "Language.Go.Types._case_16"
    [show x48, show x47, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_16" (showCons x2))

nd_C__case_17 :: Curry_Prelude.OP_List C_GoExpr -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> C_GoStat -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_17 x27 x26 x25 x2 s cd cs = case x2 of
  C_GoConstDecl x28 x29 x30 -> Curry_Prelude.C_False
  C_GoVarDecl x31 x32 x33 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    x25 x31 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x26 x32 s1 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash)
    x27 x33 s3 cd cs) cd cs))
  C_GoShortVarDecl x34 x35 -> Curry_Prelude.C_False
  C_GoExprStat x36 -> Curry_Prelude.C_False
  C_GoAssign x37 x38 x39 -> Curry_Prelude.C_False
  C_GoEmpty -> Curry_Prelude.C_False
  C_GoReturn x40 -> Curry_Prelude.C_False
  C_GoBreak -> Curry_Prelude.C_False
  C_GoContinue -> Curry_Prelude.C_False
  C_GoBlock x41 -> Curry_Prelude.C_False
  C_GoIf x42 x43 x44 -> Curry_Prelude.C_False
  C_GoExprSwitch x45 x46 -> Curry_Prelude.C_False
  Choice_C_GoStat d i l r -> narrow d i (nd_C__case_17 x27 x26 x25 l s cd cs)
    (nd_C__case_17 x27 x26 x25 r s cd cs)
  Choices_C_GoStat d i xs -> narrows cs d i (\z -> nd_C__case_17 x27 x26 x25 z s
    cd cs) xs
  Guard_C_GoStat d c e -> guardCons d c ((\x -> nd_C__case_17 x27 x26 x25 e s cd
    x) $! addCs c cs)
  Fail_C_GoStat d info -> failCons d (traceFail "Language.Go.Types._case_17"
    [show x27, show x26, show x25, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_17" (showCons x2))

nd_C__case_18 :: Curry_Prelude.OP_List C_GoExpr -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> C_GoStat -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_18 x5 x4 x3 x2 s cd cs = case x2 of
  C_GoConstDecl x6 x7 x8 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    x3 x6 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x4 x7 s1 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash)
    x5 x8 s3 cd cs) cd cs))
  C_GoVarDecl x9 x10 x11 -> Curry_Prelude.C_False
  C_GoShortVarDecl x12 x13 -> Curry_Prelude.C_False
  C_GoExprStat x14 -> Curry_Prelude.C_False
  C_GoAssign x15 x16 x17 -> Curry_Prelude.C_False
  C_GoEmpty -> Curry_Prelude.C_False
  C_GoReturn x18 -> Curry_Prelude.C_False
  C_GoBreak -> Curry_Prelude.C_False
  C_GoContinue -> Curry_Prelude.C_False
  C_GoBlock x19 -> Curry_Prelude.C_False
  C_GoIf x20 x21 x22 -> Curry_Prelude.C_False
  C_GoExprSwitch x23 x24 -> Curry_Prelude.C_False
  Choice_C_GoStat d i l r -> narrow d i (nd_C__case_18 x5 x4 x3 l s cd cs)
    (nd_C__case_18 x5 x4 x3 r s cd cs)
  Choices_C_GoStat d i xs -> narrows cs d i (\z -> nd_C__case_18 x5 x4 x3 z s cd
    cs) xs
  Guard_C_GoStat d c e -> guardCons d c ((\x -> nd_C__case_18 x5 x4 x3 e s cd
    x) $! addCs c cs)
  Fail_C_GoStat d info -> failCons d (traceFail "Language.Go.Types._case_18"
    [show x5, show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_18" (showCons x2))

nd_C__case_5 :: Curry_Prelude.OP_List C_GoStat -> C_GoExprBranch -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_5 x8 x2 s cd cs = case x2 of
  C_GoExprBranch x9 x10 -> Curry_Prelude.C_False
  C_GoExprDefault x11 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash)
    x8 x11 s0 cd cs
  Choice_C_GoExprBranch d i l r -> narrow d i (nd_C__case_5 x8 l s cd cs)
    (nd_C__case_5 x8 r s cd cs)
  Choices_C_GoExprBranch d i xs -> narrows cs d i (\z -> nd_C__case_5 x8 z s cd
    cs) xs
  Guard_C_GoExprBranch d c e -> guardCons d c ((\x -> nd_C__case_5 x8 e s cd
    x) $! addCs c cs)
  Fail_C_GoExprBranch d info -> failCons d (traceFail
    "Language.Go.Types._case_5" [show x8, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_5" (showCons x2))

nd_C__case_6 :: Curry_Prelude.OP_List C_GoStat -> Curry_Prelude.OP_List C_GoExpr
  -> C_GoExprBranch -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_6 x4 x3 x2 s cd cs = case x2 of
  C_GoExprBranch x5 x6 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoExpr_hash)
    x3 x5 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash)
    x4 x6 s1 cd cs) cd cs))
  C_GoExprDefault x7 -> Curry_Prelude.C_False
  Choice_C_GoExprBranch d i l r -> narrow d i (nd_C__case_6 x4 x3 l s cd cs)
    (nd_C__case_6 x4 x3 r s cd cs)
  Choices_C_GoExprBranch d i xs -> narrows cs d i (\z -> nd_C__case_6 x4 x3 z s
    cd cs) xs
  Guard_C_GoExprBranch d c e -> guardCons d c ((\x -> nd_C__case_6 x4 x3 e s cd
    x) $! addCs c cs)
  Fail_C_GoExprBranch d info -> failCons d (traceFail
    "Language.Go.Types._case_6" [show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_6" (showCons x2))

nd_C__case_4 :: Curry_Prelude.OP_List C_GoTopLevelDecl -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_GoProg -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_4 x5 x4 x3 x2 s cd cs = case x2 of
  C_GoProg x6 x7 x8 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x6 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    x4 x7 s1 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoTopLevelDecl_hash)
    x5 x8 s3 cd cs) cd cs))
  Choice_C_GoProg d i l r -> narrow d i (nd_C__case_4 x5 x4 x3 l s cd cs)
    (nd_C__case_4 x5 x4 x3 r s cd cs)
  Choices_C_GoProg d i xs -> narrows cs d i (\z -> nd_C__case_4 x5 x4 x3 z s cd
    cs) xs
  Guard_C_GoProg d c e -> guardCons d c ((\x -> nd_C__case_4 x5 x4 x3 e s cd
    x) $! addCs c cs)
  Fail_C_GoProg d info -> failCons d (traceFail "Language.Go.Types._case_4"
    [show x5, show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_4" (showCons x2))

nd_C__case_2 :: C_GoFuncDecl -> C_GoTopLevelDecl -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_2 x6 x2 s cd cs = case x2 of
  C_GoTopLevelDecl x7 -> Curry_Prelude.C_False
  C_GoTopLevelFuncDecl x8 -> let s0 = s
    in s0 `seq`
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoFuncDecl_hash
    x6 x8 s0 cd cs
  Choice_C_GoTopLevelDecl d i l r -> narrow d i (nd_C__case_2 x6 l s cd cs)
    (nd_C__case_2 x6 r s cd cs)
  Choices_C_GoTopLevelDecl d i xs -> narrows cs d i (\z -> nd_C__case_2 x6 z s
    cd cs) xs
  Guard_C_GoTopLevelDecl d c e -> guardCons d c ((\x -> nd_C__case_2 x6 e s cd
    x) $! addCs c cs)
  Fail_C_GoTopLevelDecl d info -> failCons d (traceFail
    "Language.Go.Types._case_2" [show x6, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_2" (showCons x2))

nd_C__case_3 :: C_GoStat -> C_GoTopLevelDecl -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_3 x3 x2 s cd cs = case x2 of
  C_GoTopLevelDecl x4 -> let s0 = s
    in s0 `seq`
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash
    x3 x4 s0 cd cs
  C_GoTopLevelFuncDecl x5 -> Curry_Prelude.C_False
  Choice_C_GoTopLevelDecl d i l r -> narrow d i (nd_C__case_3 x3 l s cd cs)
    (nd_C__case_3 x3 r s cd cs)
  Choices_C_GoTopLevelDecl d i xs -> narrows cs d i (\z -> nd_C__case_3 x3 z s
    cd cs) xs
  Guard_C_GoTopLevelDecl d c e -> guardCons d c ((\x -> nd_C__case_3 x3 e s cd
    x) $! addCs c cs)
  Fail_C_GoTopLevelDecl d info -> failCons d (traceFail
    "Language.Go.Types._case_3" [show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_3" (showCons x2))

nd_C__case_1 :: Curry_Prelude.OP_List C_GoStat -> Curry_Prelude.OP_List
  C_GoParam -> Curry_Prelude.OP_List C_GoParam -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_GoFuncDecl -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_1 x6 x5 x4 x3 x2 s cd cs = case x2 of
  C_GoFuncDecl x7 x8 x9 x10 -> let s6 = s
    in s6 `seq` (let s4 = leftSupply s6
                     s5 = rightSupply s6
    in s4 `seq` (s5 `seq` Curry_Prelude.d_OP_amp_amp (let s2 = leftSupply s4
                                                          s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x7 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash)
    x4 x8 s1 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoParam_hash)
    x5 x9 s3 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_Go_dot_Types_dot_GoStat_hash)
    x6 x10 s5 cd cs) cd cs))
  Choice_C_GoFuncDecl d i l r -> narrow d i (nd_C__case_1 x6 x5 x4 x3 l s cd cs)
    (nd_C__case_1 x6 x5 x4 x3 r s cd cs)
  Choices_C_GoFuncDecl d i xs -> narrows cs d i (\z -> nd_C__case_1 x6 x5 x4 x3
    z s cd cs) xs
  Guard_C_GoFuncDecl d c e -> guardCons d c ((\x -> nd_C__case_1 x6 x5 x4 x3 e s
    cd x) $! addCs c cs)
  Fail_C_GoFuncDecl d info -> failCons d (traceFail "Language.Go.Types._case_1"
    [show x6, show x5, show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_1" (showCons x2))

nd_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> C_GoParam -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_0 x4 x3 x2 s cd cs = case x2 of
  C_GoParam x5 x6 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)))
    x3 x5 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x4 x6 s1 cd cs) cd cs))
  Choice_C_GoParam d i l r -> narrow d i (nd_C__case_0 x4 x3 l s cd cs)
    (nd_C__case_0 x4 x3 r s cd cs)
  Choices_C_GoParam d i xs -> narrows cs d i (\z -> nd_C__case_0 x4 x3 z s cd
    cs) xs
  Guard_C_GoParam d c e -> guardCons d c ((\x -> nd_C__case_0 x4 x3 e s cd x) $!
    addCs c cs)
  Fail_C_GoParam d info -> failCons d (traceFail "Language.Go.Types._case_0"
    [show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Language.Go.Types._case_0" (showCons x2))

