{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Language.JavaScript.Curry_Types
  ( C_JSExp (..)
  , C_JSStat (..)
  , C_JSBranch (..)
  , C_JSFDecl (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
  , d_C_jsConsTerm )
  where

import Basics
import qualified Curry_Prelude


data C_JSExp
  = C_JSString (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  | C_JSInt Curry_Prelude.C_Int
  | C_JSBool Curry_Prelude.C_Bool
  | C_JSIVar Curry_Prelude.C_Int
  | C_JSIArrayIdx Curry_Prelude.C_Int Curry_Prelude.C_Int
  | C_JSOp (Curry_Prelude.OP_List Curry_Prelude.C_Char) C_JSExp C_JSExp
  | C_JSFCall (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List C_JSExp)
  | C_JSApply C_JSExp C_JSExp
  | C_JSLambda (Curry_Prelude.OP_List Curry_Prelude.C_Int)
    (Curry_Prelude.OP_List C_JSStat)
  | Choice_C_JSExp Cover ID C_JSExp C_JSExp
  | Choices_C_JSExp Cover ID [C_JSExp]
  | Fail_C_JSExp Cover FailInfo
  | Guard_C_JSExp Cover Constraints C_JSExp

instance Show C_JSExp where
  showsPrec d (Choice_C_JSExp cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_JSExp cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_JSExp cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_JSExp cd info) = showChar '!'
  showsPrec _ (C_JSString x1) = showString "(JSString" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_JSInt x1) = showString "(JSInt" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_JSBool x1) = showString "(JSBool" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_JSIVar x1) = showString "(JSIVar" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_JSIArrayIdx x1 x2) = showString "(JSIArrayIdx" . (showChar
    ' ' . (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_JSOp x1 x2 x3) = showString "(JSOp" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . showChar
    ')'))))))
  showsPrec _ (C_JSFCall x1 x2) = showString "(JSFCall" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_JSApply x1 x2) = showString "(JSApply" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_JSLambda x1 x2) = showString "(JSLambda" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))

instance Read C_JSExp where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_JSString x1, r1) | (_, r0) <-
    readQualified "Language.JavaScript.Types" "JSString" r, (x1, r1) <-
    readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_JSInt x1, r1) | (_
    , r0) <- readQualified "Language.JavaScript.Types" "JSInt" r, (x1, r1) <-
    readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_JSBool x1, r1) | (_
    , r0) <- readQualified "Language.JavaScript.Types" "JSBool" r, (x1, r1) <-
    readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_JSIVar x1, r1) | (_
    , r0) <- readQualified "Language.JavaScript.Types" "JSIVar" r, (x1, r1) <-
    readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_JSIArrayIdx x1 x2
    , r2) | (_, r0) <- readQualified "Language.JavaScript.Types" "JSIArrayIdx"
    r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1]) s ++
    (readParen ((>) d 10) (\r -> [(C_JSOp x1 x2 x3, r3) | (_, r0) <-
    readQualified "Language.JavaScript.Types" "JSOp" r, (x1, r1) <- readsPrec 11
    r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2]) s ++
    (readParen ((>) d 10) (\r -> [(C_JSFCall x1 x2, r2) | (_, r0) <-
    readQualified "Language.JavaScript.Types" "JSFCall" r, (x1, r1) <- readsPrec
    11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ (readParen ((>) d 10) (\r ->
    [(C_JSApply x1 x2, r2) | (_, r0) <- readQualified
    "Language.JavaScript.Types" "JSApply" r, (x1, r1) <- readsPrec 11 r0, (x2
    , r2) <- readsPrec 11 r1]) s ++ readParen ((>) d 10) (\r -> [(C_JSLambda x1
    x2, r2) | (_, r0) <- readQualified "Language.JavaScript.Types" "JSLambda" r,
    (x1, r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1]) s)))))))

instance NonDet C_JSExp where
  choiceCons = Choice_C_JSExp
  choicesCons = Choices_C_JSExp
  failCons = Fail_C_JSExp
  guardCons = Guard_C_JSExp
  try (Choice_C_JSExp cd i x y) = tryChoice cd i x y
  try (Choices_C_JSExp cd i xs) = tryChoices cd i xs
  try (Fail_C_JSExp cd info) = Fail cd info
  try (Guard_C_JSExp cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_JSExp cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_JSExp cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_JSExp cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_JSExp cd i _) = error
    ("Language.JavaScript.Types.JSExp.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_JSExp cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_JSExp cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_JSExp where
  generate s c = Choices_C_JSExp c (freeID [1, 1, 1, 1, 2, 3, 2, 2, 2] s)
    [C_JSString (generate (leftSupply s) c), C_JSInt (generate (leftSupply s) c)
    , C_JSBool (generate (leftSupply s) c), C_JSIVar (generate (leftSupply s) c)
    , C_JSIArrayIdx (generate (leftSupply s) c) (generate (rightSupply s) c)
    , C_JSOp (generate (leftSupply (leftSupply s)) c) (generate (rightSupply
    (leftSupply s)) c) (generate (rightSupply s) c), C_JSFCall (generate
    (leftSupply s) c) (generate (rightSupply s) c), C_JSApply (generate
    (leftSupply s) c) (generate (rightSupply s) c), C_JSLambda (generate
    (leftSupply s) c) (generate (rightSupply s) c)]

instance NormalForm C_JSExp where
  ($!!) cont (C_JSString x1) d cs = ($!!) (\y1 d cs -> cont (C_JSString y1) d
    cs) x1 d cs
  ($!!) cont (C_JSInt x1) d cs = ($!!) (\y1 d cs -> cont (C_JSInt y1) d cs) x1 d
    cs
  ($!!) cont (C_JSBool x1) d cs = ($!!) (\y1 d cs -> cont (C_JSBool y1) d cs) x1
    d cs
  ($!!) cont (C_JSIVar x1) d cs = ($!!) (\y1 d cs -> cont (C_JSIVar y1) d cs) x1
    d cs
  ($!!) cont (C_JSIArrayIdx x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_JSIArrayIdx y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_JSOp x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> cont (C_JSOp y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (C_JSFCall x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_JSFCall y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_JSApply x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_JSApply y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_JSLambda x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_JSLambda y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_JSExp cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_JSExp cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_JSExp cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_JSExp cd info) _ _ = failCons cd info
  ($##) cont (C_JSString x1) d cs = ($##) (\y1 d cs -> cont (C_JSString y1) d
    cs) x1 d cs
  ($##) cont (C_JSInt x1) d cs = ($##) (\y1 d cs -> cont (C_JSInt y1) d cs) x1 d
    cs
  ($##) cont (C_JSBool x1) d cs = ($##) (\y1 d cs -> cont (C_JSBool y1) d cs) x1
    d cs
  ($##) cont (C_JSIVar x1) d cs = ($##) (\y1 d cs -> cont (C_JSIVar y1) d cs) x1
    d cs
  ($##) cont (C_JSIArrayIdx x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_JSIArrayIdx y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_JSOp x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> cont (C_JSOp y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (C_JSFCall x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_JSFCall y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_JSApply x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_JSApply y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_JSLambda x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_JSLambda y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_JSExp cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_JSExp cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_JSExp cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_JSExp cd info) _ _ = failCons cd info
  showCons (C_JSString _) = "Language.JavaScript.Types.JSString _"
  showCons (C_JSInt _) = "Language.JavaScript.Types.JSInt _"
  showCons (C_JSBool _) = "Language.JavaScript.Types.JSBool _"
  showCons (C_JSIVar _) = "Language.JavaScript.Types.JSIVar _"
  showCons (C_JSIArrayIdx _ _) = "Language.JavaScript.Types.JSIArrayIdx _ _"
  showCons (C_JSOp _ _ _) = "Language.JavaScript.Types.JSOp _ _ _"
  showCons (C_JSFCall _ _) = "Language.JavaScript.Types.JSFCall _ _"
  showCons (C_JSApply _ _) = "Language.JavaScript.Types.JSApply _ _"
  showCons (C_JSLambda _ _) = "Language.JavaScript.Types.JSLambda _ _"
  showCons x = error
    ("Language.JavaScript.Types.JSExp.showCons: no constructor: " ++ show x)
  searchNF search cont (C_JSString x1) = search (\y1 -> cont (C_JSString y1)) x1
  searchNF search cont (C_JSInt x1) = search (\y1 -> cont (C_JSInt y1)) x1
  searchNF search cont (C_JSBool x1) = search (\y1 -> cont (C_JSBool y1)) x1
  searchNF search cont (C_JSIVar x1) = search (\y1 -> cont (C_JSIVar y1)) x1
  searchNF search cont (C_JSIArrayIdx x1 x2) = search (\y1 -> search (\y2 ->
    cont (C_JSIArrayIdx y1 y2)) x2) x1
  searchNF search cont (C_JSOp x1 x2 x3) = search (\y1 -> search (\y2 -> search
    (\y3 -> cont (C_JSOp y1 y2 y3)) x3) x2) x1
  searchNF search cont (C_JSFCall x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_JSFCall y1 y2)) x2) x1
  searchNF search cont (C_JSApply x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_JSApply y1 y2)) x2) x1
  searchNF search cont (C_JSLambda x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_JSLambda y1 y2)) x2) x1
  searchNF _ _ x = error
    ("Language.JavaScript.Types.JSExp.searchNF: no constructor: " ++ show x)

instance Unifiable C_JSExp where
  (=.=) (C_JSString x1) (C_JSString y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JSInt x1) (C_JSInt y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JSBool x1) (C_JSBool y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JSIVar x1) (C_JSIVar y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JSIArrayIdx x1 x2) (C_JSIArrayIdx y1 y2) d cs = (&) ((=:=) x1 y1 d
    cs) ((=:=) x2 y2 d cs) d cs
  (=.=) (C_JSOp x1 x2 x3) (C_JSOp y1 y2 y3) d cs = (&) ((=:=) x1 y1 d cs) ((&)
    ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) (C_JSFCall x1 x2) (C_JSFCall y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=)
    x2 y2 d cs) d cs
  (=.=) (C_JSApply x1 x2) (C_JSApply y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=)
    x2 y2 d cs) d cs
  (=.=) (C_JSLambda x1 x2) (C_JSLambda y1 y2) d cs = (&) ((=:=) x1 y1 d cs)
    ((=:=) x2 y2 d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_JSString x1) (C_JSString y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JSInt x1) (C_JSInt y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JSBool x1) (C_JSBool y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JSIVar x1) (C_JSIVar y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JSIArrayIdx x1 x2) (C_JSIArrayIdx y1 y2) d cs = (&) ((=:<=) x1 y1 d
    cs) ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_JSOp x1 x2 x3) (C_JSOp y1 y2 y3) d cs = (&) ((=:<=) x1 y1 d cs) ((&)
    ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d cs
  (=.<=) (C_JSFCall x1 x2) (C_JSFCall y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_JSApply x1 x2) (C_JSApply y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_JSLambda x1 x2) (C_JSLambda y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_JSString x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_JSInt x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_JSBool x3) = (i :=: ChooseN 2 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_JSIVar x3) = (i :=: ChooseN 3 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_JSIArrayIdx x3 x4) = (i :=: ChooseN 4 2) : concat [bind cd
    (leftID i) x3, bind cd (rightID i) x4]
  bind cd i (C_JSOp x3 x4 x5) = (i :=: ChooseN 5 3) : concat [bind cd (leftID
    (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (rightID i) x5]
  bind cd i (C_JSFCall x3 x4) = (i :=: ChooseN 6 2) : concat [bind cd (leftID i)
    x3, bind cd (rightID i) x4]
  bind cd i (C_JSApply x3 x4) = (i :=: ChooseN 7 2) : concat [bind cd (leftID i)
    x3, bind cd (rightID i) x4]
  bind cd i (C_JSLambda x3 x4) = (i :=: ChooseN 8 2) : concat [bind cd (leftID
    i) x3, bind cd (rightID i) x4]
  bind d i (Choice_C_JSExp cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_JSExp cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_JSExp cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_JSExp cd i _) = error
    ("Language.JavaScript.Types.JSExp.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_JSExp cd info) = [Unsolvable info]
  bind d i (Guard_C_JSExp cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_JSString x3) = (i :=: ChooseN 0 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JSInt x3) = (i :=: ChooseN 1 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JSBool x3) = (i :=: ChooseN 2 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JSIVar x3) = (i :=: ChooseN 3 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JSIArrayIdx x3 x4) = (i :=: ChooseN 4 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind cd i (C_JSOp x3 x4 x5) = (i :=: ChooseN 5 3) : [leftID (leftID i) :=:
    LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x5)]
  lazyBind cd i (C_JSFCall x3 x4) = (i :=: ChooseN 6 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (C_JSApply x3 x4) = (i :=: ChooseN 7 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (C_JSLambda x3 x4) = (i :=: ChooseN 8 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind d i (Choice_C_JSExp cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_JSExp cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_JSExp cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_JSExp cd i _) = error
    ("Language.JavaScript.Types.JSExp.lazyBind: Choices with ChoiceID: " ++ show
    i)
  lazyBind _ _ (Fail_C_JSExp cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_JSExp cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_JSExp where

data C_JSStat
  = C_JSAssign C_JSExp C_JSExp
  | C_JSIf C_JSExp (Curry_Prelude.OP_List C_JSStat) (Curry_Prelude.OP_List
    C_JSStat)
  | C_JSSwitch C_JSExp (Curry_Prelude.OP_List C_JSBranch)
  | C_JSPCall (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List C_JSExp)
  | C_JSReturn C_JSExp
  | C_JSVarDecl Curry_Prelude.C_Int
  | Choice_C_JSStat Cover ID C_JSStat C_JSStat
  | Choices_C_JSStat Cover ID [C_JSStat]
  | Fail_C_JSStat Cover FailInfo
  | Guard_C_JSStat Cover Constraints C_JSStat

instance Show C_JSStat where
  showsPrec d (Choice_C_JSStat cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_JSStat cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_JSStat cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_JSStat cd info) = showChar '!'
  showsPrec _ (C_JSAssign x1 x2) = showString "(JSAssign" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_JSIf x1 x2 x3) = showString "(JSIf" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . showChar
    ')'))))))
  showsPrec _ (C_JSSwitch x1 x2) = showString "(JSSwitch" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_JSPCall x1 x2) = showString "(JSPCall" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_JSReturn x1) = showString "(JSReturn" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_JSVarDecl x1) = showString "(JSVarDecl" . (showChar ' ' .
    (shows x1 . showChar ')'))

instance Read C_JSStat where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_JSAssign x1 x2, r2) | (_, r0)
    <- readQualified "Language.JavaScript.Types" "JSAssign" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ (readParen ((>) d 10)
    (\r -> [(C_JSIf x1 x2 x3, r3) | (_, r0) <- readQualified
    "Language.JavaScript.Types" "JSIf" r, (x1, r1) <- readsPrec 11 r0, (x2, r2)
    <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2]) s ++ (readParen ((>) d 10)
    (\r -> [(C_JSSwitch x1 x2, r2) | (_, r0) <- readQualified
    "Language.JavaScript.Types" "JSSwitch" r, (x1, r1) <- readsPrec 11 r0, (x2
    , r2) <- readsPrec 11 r1]) s ++ (readParen ((>) d 10) (\r -> [(C_JSPCall x1
    x2, r2) | (_, r0) <- readQualified "Language.JavaScript.Types" "JSPCall" r,
    (x1, r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ (readParen
    ((>) d 10) (\r -> [(C_JSReturn x1, r1) | (_, r0) <- readQualified
    "Language.JavaScript.Types" "JSReturn" r, (x1, r1) <- readsPrec 11 r0]) s ++
    readParen ((>) d 10) (\r -> [(C_JSVarDecl x1, r1) | (_, r0) <- readQualified
    "Language.JavaScript.Types" "JSVarDecl" r, (x1, r1) <- readsPrec 11 r0])
    s))))

instance NonDet C_JSStat where
  choiceCons = Choice_C_JSStat
  choicesCons = Choices_C_JSStat
  failCons = Fail_C_JSStat
  guardCons = Guard_C_JSStat
  try (Choice_C_JSStat cd i x y) = tryChoice cd i x y
  try (Choices_C_JSStat cd i xs) = tryChoices cd i xs
  try (Fail_C_JSStat cd info) = Fail cd info
  try (Guard_C_JSStat cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_JSStat cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_JSStat cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_JSStat cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_JSStat cd i _) = error
    ("Language.JavaScript.Types.JSStat.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_JSStat cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_JSStat cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_JSStat where
  generate s c = Choices_C_JSStat c (freeID [2, 3, 2, 2, 1, 1] s) [C_JSAssign
    (generate (leftSupply s) c) (generate (rightSupply s) c), C_JSIf (generate
    (leftSupply (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c)
    (generate (rightSupply s) c), C_JSSwitch (generate (leftSupply s) c)
    (generate (rightSupply s) c), C_JSPCall (generate (leftSupply s) c)
    (generate (rightSupply s) c), C_JSReturn (generate (leftSupply s) c)
    , C_JSVarDecl (generate (leftSupply s) c)]

instance NormalForm C_JSStat where
  ($!!) cont (C_JSAssign x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_JSAssign y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_JSIf x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> cont (C_JSIf y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (C_JSSwitch x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_JSSwitch y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_JSPCall x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_JSPCall y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_JSReturn x1) d cs = ($!!) (\y1 d cs -> cont (C_JSReturn y1) d
    cs) x1 d cs
  ($!!) cont (C_JSVarDecl x1) d cs = ($!!) (\y1 d cs -> cont (C_JSVarDecl y1) d
    cs) x1 d cs
  ($!!) cont (Choice_C_JSStat cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_JSStat cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_JSStat cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_JSStat cd info) _ _ = failCons cd info
  ($##) cont (C_JSAssign x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_JSAssign y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_JSIf x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> cont (C_JSIf y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (C_JSSwitch x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_JSSwitch y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_JSPCall x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_JSPCall y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_JSReturn x1) d cs = ($##) (\y1 d cs -> cont (C_JSReturn y1) d
    cs) x1 d cs
  ($##) cont (C_JSVarDecl x1) d cs = ($##) (\y1 d cs -> cont (C_JSVarDecl y1) d
    cs) x1 d cs
  ($##) cont (Choice_C_JSStat cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_JSStat cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_JSStat cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_JSStat cd info) _ _ = failCons cd info
  showCons (C_JSAssign _ _) = "Language.JavaScript.Types.JSAssign _ _"
  showCons (C_JSIf _ _ _) = "Language.JavaScript.Types.JSIf _ _ _"
  showCons (C_JSSwitch _ _) = "Language.JavaScript.Types.JSSwitch _ _"
  showCons (C_JSPCall _ _) = "Language.JavaScript.Types.JSPCall _ _"
  showCons (C_JSReturn _) = "Language.JavaScript.Types.JSReturn _"
  showCons (C_JSVarDecl _) = "Language.JavaScript.Types.JSVarDecl _"
  showCons x = error
    ("Language.JavaScript.Types.JSStat.showCons: no constructor: " ++ show x)
  searchNF search cont (C_JSAssign x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_JSAssign y1 y2)) x2) x1
  searchNF search cont (C_JSIf x1 x2 x3) = search (\y1 -> search (\y2 -> search
    (\y3 -> cont (C_JSIf y1 y2 y3)) x3) x2) x1
  searchNF search cont (C_JSSwitch x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_JSSwitch y1 y2)) x2) x1
  searchNF search cont (C_JSPCall x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_JSPCall y1 y2)) x2) x1
  searchNF search cont (C_JSReturn x1) = search (\y1 -> cont (C_JSReturn y1)) x1
  searchNF search cont (C_JSVarDecl x1) = search (\y1 -> cont (C_JSVarDecl y1))
    x1
  searchNF _ _ x = error
    ("Language.JavaScript.Types.JSStat.searchNF: no constructor: " ++ show x)

instance Unifiable C_JSStat where
  (=.=) (C_JSAssign x1 x2) (C_JSAssign y1 y2) d cs = (&) ((=:=) x1 y1 d cs)
    ((=:=) x2 y2 d cs) d cs
  (=.=) (C_JSIf x1 x2 x3) (C_JSIf y1 y2 y3) d cs = (&) ((=:=) x1 y1 d cs) ((&)
    ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) (C_JSSwitch x1 x2) (C_JSSwitch y1 y2) d cs = (&) ((=:=) x1 y1 d cs)
    ((=:=) x2 y2 d cs) d cs
  (=.=) (C_JSPCall x1 x2) (C_JSPCall y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=)
    x2 y2 d cs) d cs
  (=.=) (C_JSReturn x1) (C_JSReturn y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_JSVarDecl x1) (C_JSVarDecl y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_JSAssign x1 x2) (C_JSAssign y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_JSIf x1 x2 x3) (C_JSIf y1 y2 y3) d cs = (&) ((=:<=) x1 y1 d cs) ((&)
    ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d cs
  (=.<=) (C_JSSwitch x1 x2) (C_JSSwitch y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_JSPCall x1 x2) (C_JSPCall y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_JSReturn x1) (C_JSReturn y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_JSVarDecl x1) (C_JSVarDecl y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_JSAssign x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID
    i) x3, bind cd (rightID i) x4]
  bind cd i (C_JSIf x3 x4 x5) = (i :=: ChooseN 1 3) : concat [bind cd (leftID
    (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (rightID i) x5]
  bind cd i (C_JSSwitch x3 x4) = (i :=: ChooseN 2 2) : concat [bind cd (leftID
    i) x3, bind cd (rightID i) x4]
  bind cd i (C_JSPCall x3 x4) = (i :=: ChooseN 3 2) : concat [bind cd (leftID i)
    x3, bind cd (rightID i) x4]
  bind cd i (C_JSReturn x3) = (i :=: ChooseN 4 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_JSVarDecl x3) = (i :=: ChooseN 5 1) : concat [bind cd (leftID i)
    x3]
  bind d i (Choice_C_JSStat cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_JSStat cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_JSStat cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_JSStat cd i _) = error
    ("Language.JavaScript.Types.JSStat.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_JSStat cd info) = [Unsolvable info]
  bind d i (Guard_C_JSStat cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_JSAssign x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind cd i (C_JSIf x3 x4 x5) = (i :=: ChooseN 1 3) : [leftID (leftID i) :=:
    LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x5)]
  lazyBind cd i (C_JSSwitch x3 x4) = (i :=: ChooseN 2 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind cd i (C_JSPCall x3 x4) = (i :=: ChooseN 3 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (C_JSReturn x3) = (i :=: ChooseN 4 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_JSVarDecl x3) = (i :=: ChooseN 5 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_JSStat cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_JSStat cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_JSStat cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_JSStat cd i _) = error
    ("Language.JavaScript.Types.JSStat.lazyBind: Choices with ChoiceID: " ++
    show i)
  lazyBind _ _ (Fail_C_JSStat cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_JSStat cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_JSStat where

data C_JSBranch
  = C_JSCase (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
    C_JSStat)
  | C_JSDefault (Curry_Prelude.OP_List C_JSStat)
  | Choice_C_JSBranch Cover ID C_JSBranch C_JSBranch
  | Choices_C_JSBranch Cover ID [C_JSBranch]
  | Fail_C_JSBranch Cover FailInfo
  | Guard_C_JSBranch Cover Constraints C_JSBranch

instance Show C_JSBranch where
  showsPrec d (Choice_C_JSBranch cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_JSBranch cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_JSBranch cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_JSBranch cd info) = showChar '!'
  showsPrec _ (C_JSCase x1 x2) = showString "(JSCase" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_JSDefault x1) = showString "(JSDefault" . (showChar ' ' .
    (shows x1 . showChar ')'))

instance Read C_JSBranch where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_JSCase x1 x2, r2) | (_, r0) <-
    readQualified "Language.JavaScript.Types" "JSCase" r, (x1, r1) <- readsPrec
    11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ readParen ((>) d 10) (\r ->
    [(C_JSDefault x1, r1) | (_, r0) <- readQualified "Language.JavaScript.Types"
    "JSDefault" r, (x1, r1) <- readsPrec 11 r0]) s

instance NonDet C_JSBranch where
  choiceCons = Choice_C_JSBranch
  choicesCons = Choices_C_JSBranch
  failCons = Fail_C_JSBranch
  guardCons = Guard_C_JSBranch
  try (Choice_C_JSBranch cd i x y) = tryChoice cd i x y
  try (Choices_C_JSBranch cd i xs) = tryChoices cd i xs
  try (Fail_C_JSBranch cd info) = Fail cd info
  try (Guard_C_JSBranch cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_JSBranch cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_JSBranch cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_JSBranch cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_JSBranch cd i _) = error
    ("Language.JavaScript.Types.JSBranch.match: Choices with ChoiceID " ++ show
    i)
  match _ _ _ f _ _ (Fail_C_JSBranch cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_JSBranch cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_JSBranch where
  generate s c = Choices_C_JSBranch c (freeID [2, 1] s) [C_JSCase (generate
    (leftSupply s) c) (generate (rightSupply s) c), C_JSDefault (generate
    (leftSupply s) c)]

instance NormalForm C_JSBranch where
  ($!!) cont (C_JSCase x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_JSCase y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_JSDefault x1) d cs = ($!!) (\y1 d cs -> cont (C_JSDefault y1) d
    cs) x1 d cs
  ($!!) cont (Choice_C_JSBranch cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_JSBranch cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_JSBranch cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_JSBranch cd info) _ _ = failCons cd info
  ($##) cont (C_JSCase x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_JSCase y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_JSDefault x1) d cs = ($##) (\y1 d cs -> cont (C_JSDefault y1) d
    cs) x1 d cs
  ($##) cont (Choice_C_JSBranch cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_JSBranch cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_JSBranch cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_JSBranch cd info) _ _ = failCons cd info
  showCons (C_JSCase _ _) = "Language.JavaScript.Types.JSCase _ _"
  showCons (C_JSDefault _) = "Language.JavaScript.Types.JSDefault _"
  showCons x = error
    ("Language.JavaScript.Types.JSBranch.showCons: no constructor: " ++ show x)
  searchNF search cont (C_JSCase x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_JSCase y1 y2)) x2) x1
  searchNF search cont (C_JSDefault x1) = search (\y1 -> cont (C_JSDefault y1))
    x1
  searchNF _ _ x = error
    ("Language.JavaScript.Types.JSBranch.searchNF: no constructor: " ++ show x)

instance Unifiable C_JSBranch where
  (=.=) (C_JSCase x1 x2) (C_JSCase y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=)
    x2 y2 d cs) d cs
  (=.=) (C_JSDefault x1) (C_JSDefault y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_JSCase x1 x2) (C_JSCase y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) (C_JSDefault x1) (C_JSDefault y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_JSCase x3 x4) = (i :=: ChooseN 0 2) : concat [bind cd (leftID i)
    x3, bind cd (rightID i) x4]
  bind cd i (C_JSDefault x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID i)
    x3]
  bind d i (Choice_C_JSBranch cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_JSBranch cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_JSBranch cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_JSBranch cd i _) = error
    ("Language.JavaScript.Types.JSBranch.bind: Choices with ChoiceID: " ++ show
    i)
  bind _ _ (Fail_C_JSBranch cd info) = [Unsolvable info]
  bind d i (Guard_C_JSBranch cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_JSCase x3 x4) = (i :=: ChooseN 0 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (C_JSDefault x3) = (i :=: ChooseN 1 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_JSBranch cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_JSBranch cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_JSBranch cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_JSBranch cd i _) = error
    ("Language.JavaScript.Types.JSBranch.lazyBind: Choices with ChoiceID: " ++
    show i)
  lazyBind _ _ (Fail_C_JSBranch cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_JSBranch cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_JSBranch where

data C_JSFDecl
  = C_JSFDecl (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List Curry_Prelude.C_Int) (Curry_Prelude.OP_List C_JSStat)
  | Choice_C_JSFDecl Cover ID C_JSFDecl C_JSFDecl
  | Choices_C_JSFDecl Cover ID [C_JSFDecl]
  | Fail_C_JSFDecl Cover FailInfo
  | Guard_C_JSFDecl Cover Constraints C_JSFDecl

instance Show C_JSFDecl where
  showsPrec d (Choice_C_JSFDecl cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_JSFDecl cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_JSFDecl cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_JSFDecl cd info) = showChar '!'
  showsPrec _ (C_JSFDecl x1 x2 x3) = showString "(JSFDecl" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . showChar
    ')'))))))

instance Read C_JSFDecl where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_JSFDecl x1 x2 x3, r3) | (_
    , r0) <- readQualified "Language.JavaScript.Types" "JSFDecl" r, (x1, r1) <-
    readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2])
    s

instance NonDet C_JSFDecl where
  choiceCons = Choice_C_JSFDecl
  choicesCons = Choices_C_JSFDecl
  failCons = Fail_C_JSFDecl
  guardCons = Guard_C_JSFDecl
  try (Choice_C_JSFDecl cd i x y) = tryChoice cd i x y
  try (Choices_C_JSFDecl cd i xs) = tryChoices cd i xs
  try (Fail_C_JSFDecl cd info) = Fail cd info
  try (Guard_C_JSFDecl cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_JSFDecl cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_JSFDecl cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_JSFDecl cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_JSFDecl cd i _) = error
    ("Language.JavaScript.Types.JSFDecl.match: Choices with ChoiceID " ++ show
    i)
  match _ _ _ f _ _ (Fail_C_JSFDecl cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_JSFDecl cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_JSFDecl where
  generate s c = Choices_C_JSFDecl c (freeID [3] s) [C_JSFDecl (generate
    (leftSupply (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c)
    (generate (rightSupply s) c)]

instance NormalForm C_JSFDecl where
  ($!!) cont (C_JSFDecl x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> cont (C_JSFDecl y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_JSFDecl cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_JSFDecl cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_JSFDecl cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_JSFDecl cd info) _ _ = failCons cd info
  ($##) cont (C_JSFDecl x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> cont (C_JSFDecl y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_JSFDecl cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_JSFDecl cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_JSFDecl cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_JSFDecl cd info) _ _ = failCons cd info
  showCons (C_JSFDecl _ _ _) = "Language.JavaScript.Types.JSFDecl _ _ _"
  showCons x = error
    ("Language.JavaScript.Types.JSFDecl.showCons: no constructor: " ++ show x)
  searchNF search cont (C_JSFDecl x1 x2 x3) = search (\y1 -> search (\y2 ->
    search (\y3 -> cont (C_JSFDecl y1 y2 y3)) x3) x2) x1
  searchNF _ _ x = error
    ("Language.JavaScript.Types.JSFDecl.searchNF: no constructor: " ++ show x)

instance Unifiable C_JSFDecl where
  (=.=) (C_JSFDecl x1 x2 x3) (C_JSFDecl y1 y2 y3) d cs = (&) ((=:=) x1 y1 d cs)
    ((&) ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_JSFDecl x1 x2 x3) (C_JSFDecl y1 y2 y3) d cs = (&) ((=:<=) x1 y1 d
    cs) ((&) ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_JSFDecl x3 x4 x5) = (i :=: ChooseN 0 3) : concat [bind cd (leftID
    (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (rightID i) x5]
  bind d i (Choice_C_JSFDecl cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_JSFDecl cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_JSFDecl cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_JSFDecl cd i _) = error
    ("Language.JavaScript.Types.JSFDecl.bind: Choices with ChoiceID: " ++ show
    i)
  bind _ _ (Fail_C_JSFDecl cd info) = [Unsolvable info]
  bind d i (Guard_C_JSFDecl cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_JSFDecl x3 x4 x5) = (i :=: ChooseN 0 3) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x5)]
  lazyBind d i (Choice_C_JSFDecl cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_JSFDecl cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_JSFDecl cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_JSFDecl cd i _) = error
    ("Language.JavaScript.Types.JSFDecl.lazyBind: Choices with ChoiceID: " ++
    show i)
  lazyBind _ _ (Fail_C_JSFDecl cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_JSFDecl cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_JSFDecl where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_JSExp
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.JavaScript.Types._inst#Prelude.Data#Language.JavaScript.Types.JSExp#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._inst#Prelude.Data#Language.JavaScript.Types.JSExp#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash :: C_JSExp
  -> C_JSExp -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash x1 x2 s cd cs =
  case x1 of
  C_JSString x3 -> let s0 = s in s0 `seq` nd_C__case_35 x3 x2 s0 cd cs
  C_JSInt x19 -> d_C__case_34 x19 x2 cd cs
  C_JSBool x35 -> d_C__case_33 x35 x2 cd cs
  C_JSIVar x51 -> d_C__case_32 x51 x2 cd cs
  C_JSIArrayIdx x67 x68 -> d_C__case_31 x68 x67 x2 cd cs
  C_JSOp x84 x85 x86 -> let s0 = s
    in s0 `seq` nd_C__case_30 x86 x85 x84 x2 s0 cd cs
  C_JSFCall x102 x103 -> let s0 = s
    in s0 `seq` nd_C__case_29 x103 x102 x2 s0 cd cs
  C_JSApply x119 x120 -> let s0 = s
    in s0 `seq` nd_C__case_28 x120 x119 x2 s0 cd cs
  C_JSLambda x136 x137 -> let s0 = s
    in s0 `seq` nd_C__case_27 x137 x136 x2 s0 cd cs
  Choice_C_JSExp d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    r x2 s cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    z x2 s cd cs) xs
  Guard_C_JSExp d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._impl#===#Prelude.Data#Language.JavaScript.Types.JSExp#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._impl#===#Prelude.Data#Language.JavaScript.Types.JSExp#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash :: IDSupply
  -> Cover -> ConstStore -> C_JSExp
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash s cd cs =
  let s43 = s
  in s43 `seq` (let s42 = leftSupply s43
                    s44 = rightSupply s43
                    s37 = leftSupply s44
                    s41 = rightSupply s44
  in s42 `seq` (s44 `seq` (s37 `seq` (s41 `seq` choice (let s36 = leftSupply s37
                                                            s38 = rightSupply
                                                              s37
                                                            s31 = leftSupply s38
                                                            s35 = rightSupply
                                                              s38
  in s36 `seq` (s38 `seq` (s31 `seq` (s35 `seq` choice (let s30 = leftSupply s31
                                                            s32 = rightSupply
                                                              s31
                                                            s25 = leftSupply s32
                                                            s29 = rightSupply
                                                              s32
  in s30 `seq` (s32 `seq` (s25 `seq` (s29 `seq` choice (let s24 = leftSupply s25
                                                            s26 = rightSupply
                                                              s25
                                                            s17 = leftSupply s26
                                                            s22 = rightSupply
                                                              s26
  in s24 `seq` (s26 `seq` (s17 `seq` (s22 `seq` choice (let s16 = leftSupply s17
                                                            s18 = rightSupply
                                                              s17
                                                            s11 = leftSupply s18
                                                            s15 = rightSupply
                                                              s18
  in s16 `seq` (s18 `seq` (s11 `seq` (s15 `seq` choice (let s10 = leftSupply s11
                                                            s12 = rightSupply
                                                              s11
                                                            s7 = leftSupply s12
                                                            s9 = rightSupply s12
  in s10 `seq` (s12 `seq` (s7 `seq` (s9 `seq` choice (let s6 = leftSupply s7
                                                          s8 = rightSupply s7
                                                          s3 = leftSupply s8
                                                          s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` choice (let s2 = leftSupply s3
                                                        s4 = rightSupply s3
                                                        s0 = leftSupply s4
                                                        s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` choice (C_JSString
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)) (C_JSInt
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s1 cd cs)) s2 cd cs)))) (C_JSBool
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
  s5 cd cs)) s6 cd cs)))) (C_JSIVar
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s9 cd cs)) s10 cd cs)))) (let s13 = leftSupply s15
                                s14 = rightSupply s15
  in s13 `seq` (s14 `seq` C_JSIArrayIdx
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s13 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s14 cd cs))) s16 cd cs)))) (let s19 = leftSupply s22
                                  s23 = rightSupply s22
                                  s20 = leftSupply s23
                                  s21 = rightSupply s23
  in s19 `seq` (s23 `seq` (s20 `seq` (s21 `seq` C_JSOp
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s19 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
  s20 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
  s21 cd cs))))) s24 cd cs)))) (let s27 = leftSupply s29
                                    s28 = rightSupply s29
  in s27 `seq` (s28 `seq` C_JSFCall
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s27 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash)
  s28 cd cs))) s30 cd cs)))) (let s33 = leftSupply s35
                                  s34 = rightSupply s35
  in s33 `seq` (s34 `seq` C_JSApply
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
  s33 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
  s34 cd cs))) s36 cd cs)))) (let s39 = leftSupply s41
                                  s40 = rightSupply s41
  in s39 `seq` (s40 `seq` C_JSLambda
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  s39 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash)
  s40 cd cs))) s42 cd cs))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_JSStat
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.JavaScript.Types._inst#Prelude.Data#Language.JavaScript.Types.JSStat#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._inst#Prelude.Data#Language.JavaScript.Types.JSStat#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash :: C_JSStat
  -> C_JSStat -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash x1 x2 s cd cs =
  case x1 of
  C_JSAssign x3 x4 -> let s0 = s in s0 `seq` nd_C__case_26 x4 x3 x2 s0 cd cs
  C_JSIf x16 x17 x18 -> let s0 = s
    in s0 `seq` nd_C__case_25 x18 x17 x16 x2 s0 cd cs
  C_JSSwitch x30 x31 -> let s0 = s in s0 `seq` nd_C__case_24 x31 x30 x2 s0 cd cs
  C_JSPCall x43 x44 -> let s0 = s in s0 `seq` nd_C__case_23 x44 x43 x2 s0 cd cs
  C_JSReturn x56 -> let s0 = s in s0 `seq` nd_C__case_22 x56 x2 s0 cd cs
  C_JSVarDecl x68 -> d_C__case_21 x68 x2 cd cs
  Choice_C_JSStat d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    r x2 s cd cs)
  Choices_C_JSStat d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    z x2 s cd cs) xs
  Guard_C_JSStat d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_JSStat d info -> failCons d (traceFail
    "Language.JavaScript.Types._impl#===#Prelude.Data#Language.JavaScript.Types.JSStat#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._impl#===#Prelude.Data#Language.JavaScript.Types.JSStat#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash :: IDSupply
  -> Cover -> ConstStore -> C_JSStat
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash s cd cs =
  let s29 = s
  in s29 `seq` (let s28 = leftSupply s29
                    s30 = rightSupply s29
                    s25 = leftSupply s30
                    s27 = rightSupply s30
  in s28 `seq` (s30 `seq` (s25 `seq` (s27 `seq` choice (let s24 = leftSupply s25
                                                            s26 = rightSupply
                                                              s25
                                                            s21 = leftSupply s26
                                                            s23 = rightSupply
                                                              s26
  in s24 `seq` (s26 `seq` (s21 `seq` (s23 `seq` choice (let s20 = leftSupply s21
                                                            s22 = rightSupply
                                                              s21
                                                            s15 = leftSupply s22
                                                            s19 = rightSupply
                                                              s22
  in s20 `seq` (s22 `seq` (s15 `seq` (s19 `seq` choice (let s14 = leftSupply s15
                                                            s16 = rightSupply
                                                              s15
                                                            s9 = leftSupply s16
                                                            s13 = rightSupply
                                                              s16
  in s14 `seq` (s16 `seq` (s9 `seq` (s13 `seq` choice (let s8 = leftSupply s9
                                                           s10 = rightSupply s9
                                                           s2 = leftSupply s10
                                                           s6 = rightSupply s10
  in s8 `seq` (s10 `seq` (s2 `seq` (s6 `seq` choice (let s0 = leftSupply s2
                                                         s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_JSAssign
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
  s0 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
  s1 cd cs))) (let s3 = leftSupply s6
                   s7 = rightSupply s6
                   s4 = leftSupply s7
                   s5 = rightSupply s7
  in s3 `seq` (s7 `seq` (s4 `seq` (s5 `seq` C_JSIf
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
  s3 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash)
  s4 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash)
  s5 cd cs))))) s8 cd cs)))) (let s11 = leftSupply s13
                                  s12 = rightSupply s13
  in s11 `seq` (s12 `seq` C_JSSwitch
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
  s11 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash)
  s12 cd cs))) s14 cd cs)))) (let s17 = leftSupply s19
                                  s18 = rightSupply s19
  in s17 `seq` (s18 `seq` C_JSPCall
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s17 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash)
  s18 cd cs))) s20 cd cs)))) (C_JSReturn
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
  s23 cd cs)) s24 cd cs)))) (C_JSVarDecl
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s27 cd cs)) s28 cd cs))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_JSBranch
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.JavaScript.Types._inst#Prelude.Data#Language.JavaScript.Types.JSBranch#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._inst#Prelude.Data#Language.JavaScript.Types.JSBranch#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash :: C_JSBranch
  -> C_JSBranch -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash x1 x2 s cd cs =
  case x1 of
  C_JSCase x3 x4 -> let s0 = s in s0 `seq` nd_C__case_20 x4 x3 x2 s0 cd cs
  C_JSDefault x8 -> let s0 = s in s0 `seq` nd_C__case_19 x8 x2 s0 cd cs
  Choice_C_JSBranch d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    r x2 s cd cs)
  Choices_C_JSBranch d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    z x2 s cd cs) xs
  Guard_C_JSBranch d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_JSBranch d info -> failCons d (traceFail
    "Language.JavaScript.Types._impl#===#Prelude.Data#Language.JavaScript.Types.JSBranch#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._impl#===#Prelude.Data#Language.JavaScript.Types.JSBranch#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash :: IDSupply
  -> Cover -> ConstStore -> C_JSBranch
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash s cd cs =
  let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s2 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` choice (let s0 = leftSupply s2
                                                        s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_JSCase
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash)
  s1 cd cs))) (C_JSDefault
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash)
  s3 cd cs)) s4 cd cs))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_JSFDecl
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.JavaScript.Types._inst#Prelude.Data#Language.JavaScript.Types.JSFDecl#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._inst#Prelude.Data#Language.JavaScript.Types.JSFDecl#"
    (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash :: C_JSFDecl
  -> C_JSFDecl -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash x1 x2 s cd cs =
  case x1 of
  C_JSFDecl x3 x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_18 x5 x4 x3 x2 s0 cd cs
  Choice_C_JSFDecl d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    r x2 s cd cs)
  Choices_C_JSFDecl d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    z x2 s cd cs) xs
  Guard_C_JSFDecl d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_JSFDecl d info -> failCons d (traceFail
    "Language.JavaScript.Types._impl#===#Prelude.Data#Language.JavaScript.Types.JSFDecl#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._impl#===#Prelude.Data#Language.JavaScript.Types.JSFDecl#"
    (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash :: IDSupply
  -> Cover -> ConstStore -> C_JSFDecl
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash s cd cs =
  let s3 = s
  in s3 `seq` (let s0 = leftSupply s3
                   s4 = rightSupply s3
                   s1 = leftSupply s4
                   s2 = rightSupply s4
  in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` C_JSFDecl
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  s1 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash)
  s2 cd cs)))))

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_JSExp
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.JavaScript.Types._inst#Prelude.Eq#Language.JavaScript.Types.JSExp#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._inst#Prelude.Eq#Language.JavaScript.Types.JSExp#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_JSExp
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.JavaScript.Types._inst#Prelude.Eq#Language.JavaScript.Types.JSExp#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._inst#Prelude.Eq#Language.JavaScript.Types.JSExp#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash :: C_JSExp
  -> C_JSExp -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash x1 x2 cd cs =
  case x1 of
  C_JSString x3 -> d_C__case_17 x3 x2 cd cs
  C_JSInt x19 -> d_C__case_16 x19 x2 cd cs
  C_JSBool x35 -> d_C__case_15 x35 x2 cd cs
  C_JSIVar x51 -> d_C__case_14 x51 x2 cd cs
  C_JSIArrayIdx x67 x68 -> d_C__case_13 x68 x67 x2 cd cs
  C_JSOp x84 x85 x86 -> d_C__case_12 x86 x85 x84 x2 cd cs
  C_JSFCall x102 x103 -> d_C__case_11 x103 x102 x2 cd cs
  C_JSApply x119 x120 -> d_C__case_10 x120 x119 x2 cd cs
  C_JSLambda x136 x137 -> d_C__case_9 x137 x136 x2 cd cs
  Choice_C_JSExp d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    r x2 cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    z x2 cd cs) xs
  Guard_C_JSExp d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._impl#==#Prelude.Eq#Language.JavaScript.Types.JSExp#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._impl#==#Prelude.Eq#Language.JavaScript.Types.JSExp#"
    (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash :: Cover
  -> ConstStore -> C_JSExp -> Cover -> ConstStore -> C_JSExp -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash)

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_JSStat
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.JavaScript.Types._inst#Prelude.Eq#Language.JavaScript.Types.JSStat#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._inst#Prelude.Eq#Language.JavaScript.Types.JSStat#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_JSStat
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.JavaScript.Types._inst#Prelude.Eq#Language.JavaScript.Types.JSStat#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._inst#Prelude.Eq#Language.JavaScript.Types.JSStat#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash :: C_JSStat
  -> C_JSStat -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash x1 x2 cd cs =
  case x1 of
  C_JSAssign x3 x4 -> d_C__case_8 x4 x3 x2 cd cs
  C_JSIf x16 x17 x18 -> d_C__case_7 x18 x17 x16 x2 cd cs
  C_JSSwitch x30 x31 -> d_C__case_6 x31 x30 x2 cd cs
  C_JSPCall x43 x44 -> d_C__case_5 x44 x43 x2 cd cs
  C_JSReturn x56 -> d_C__case_4 x56 x2 cd cs
  C_JSVarDecl x68 -> d_C__case_3 x68 x2 cd cs
  Choice_C_JSStat d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    r x2 cd cs)
  Choices_C_JSStat d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    z x2 cd cs) xs
  Guard_C_JSStat d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_JSStat d info -> failCons d (traceFail
    "Language.JavaScript.Types._impl#==#Prelude.Eq#Language.JavaScript.Types.JSStat#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._impl#==#Prelude.Eq#Language.JavaScript.Types.JSStat#"
    (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash :: Cover
  -> ConstStore -> C_JSStat -> Cover -> ConstStore -> C_JSStat -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash)

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_JSBranch
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.JavaScript.Types._inst#Prelude.Eq#Language.JavaScript.Types.JSBranch#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._inst#Prelude.Eq#Language.JavaScript.Types.JSBranch#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_JSBranch
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.JavaScript.Types._inst#Prelude.Eq#Language.JavaScript.Types.JSBranch#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._inst#Prelude.Eq#Language.JavaScript.Types.JSBranch#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash :: C_JSBranch
  -> C_JSBranch -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash x1 x2 cd cs =
  case x1 of
  C_JSCase x3 x4 -> d_C__case_2 x4 x3 x2 cd cs
  C_JSDefault x8 -> d_C__case_1 x8 x2 cd cs
  Choice_C_JSBranch d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    r x2 cd cs)
  Choices_C_JSBranch d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    z x2 cd cs) xs
  Guard_C_JSBranch d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_JSBranch d info -> failCons d (traceFail
    "Language.JavaScript.Types._impl#==#Prelude.Eq#Language.JavaScript.Types.JSBranch#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._impl#==#Prelude.Eq#Language.JavaScript.Types.JSBranch#"
    (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash :: Cover
  -> ConstStore -> C_JSBranch -> Cover -> ConstStore -> C_JSBranch -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash)

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_JSFDecl
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.JavaScript.Types._inst#Prelude.Eq#Language.JavaScript.Types.JSFDecl#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._inst#Prelude.Eq#Language.JavaScript.Types.JSFDecl#"
    (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_JSFDecl
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Language.JavaScript.Types._inst#Prelude.Eq#Language.JavaScript.Types.JSFDecl#"
    [show x1] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._inst#Prelude.Eq#Language.JavaScript.Types.JSFDecl#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash :: C_JSFDecl
  -> C_JSFDecl -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash x1 x2 cd cs =
  case x1 of
  C_JSFDecl x3 x4 x5 -> d_C__case_0 x5 x4 x3 x2 cd cs
  Choice_C_JSFDecl d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    r x2 cd cs)
  Choices_C_JSFDecl d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    z x2 cd cs) xs
  Guard_C_JSFDecl d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_JSFDecl d info -> failCons d (traceFail
    "Language.JavaScript.Types._impl#==#Prelude.Eq#Language.JavaScript.Types.JSFDecl#"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Language.JavaScript.Types._impl#==#Prelude.Eq#Language.JavaScript.Types.JSFDecl#"
    (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash :: Cover
  -> ConstStore -> C_JSFDecl -> Cover -> ConstStore -> C_JSFDecl -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSFDecl_hash)

d_C_jsConsTerm :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List C_JSExp -> Cover -> ConstStore -> C_JSExp
d_C_jsConsTerm x1 x2 cd cs = C_JSFCall (Curry_Prelude.toCurryString "new Array")
  (Curry_Prelude.OP_Cons (C_JSString x1) x2)

nd_C__case_27 :: Curry_Prelude.OP_List C_JSStat -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> C_JSExp -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_27 x137 x136 x2 s cd cs = case x2 of
  C_JSString x138 -> Curry_Prelude.C_False
  C_JSInt x139 -> Curry_Prelude.C_False
  C_JSBool x140 -> Curry_Prelude.C_False
  C_JSIVar x141 -> Curry_Prelude.C_False
  C_JSIArrayIdx x142 x143 -> Curry_Prelude.C_False
  C_JSOp x144 x145 x146 -> Curry_Prelude.C_False
  C_JSFCall x147 x148 -> Curry_Prelude.C_False
  C_JSApply x149 x150 -> Curry_Prelude.C_False
  C_JSLambda x151 x152 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
    x136 x151 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash)
    x137 x152 s1 cd cs) cd cs))
  Choice_C_JSExp d i l r -> narrow d i (nd_C__case_27 x137 x136 l s cd cs)
    (nd_C__case_27 x137 x136 r s cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z -> nd_C__case_27 x137 x136 z s cd
    cs) xs
  Guard_C_JSExp d c e -> guardCons d c ((\x -> nd_C__case_27 x137 x136 e s cd
    x) $! addCs c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_27" [show x137, show x136, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_27" (showCons x2))

nd_C__case_28 :: C_JSExp -> C_JSExp -> C_JSExp -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_28 x120 x119 x2 s cd cs = case x2 of
  C_JSString x121 -> Curry_Prelude.C_False
  C_JSInt x122 -> Curry_Prelude.C_False
  C_JSBool x123 -> Curry_Prelude.C_False
  C_JSIVar x124 -> Curry_Prelude.C_False
  C_JSIArrayIdx x125 x126 -> Curry_Prelude.C_False
  C_JSOp x127 x128 x129 -> Curry_Prelude.C_False
  C_JSFCall x130 x131 -> Curry_Prelude.C_False
  C_JSApply x132 x133 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x119 x132 s0 cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x120 x133 s1 cd cs) cd cs))
  C_JSLambda x134 x135 -> Curry_Prelude.C_False
  Choice_C_JSExp d i l r -> narrow d i (nd_C__case_28 x120 x119 l s cd cs)
    (nd_C__case_28 x120 x119 r s cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z -> nd_C__case_28 x120 x119 z s cd
    cs) xs
  Guard_C_JSExp d c e -> guardCons d c ((\x -> nd_C__case_28 x120 x119 e s cd
    x) $! addCs c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_28" [show x120, show x119, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_28" (showCons x2))

nd_C__case_29 :: Curry_Prelude.OP_List C_JSExp -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_JSExp -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_29 x103 x102 x2 s cd cs = case x2 of
  C_JSString x104 -> Curry_Prelude.C_False
  C_JSInt x105 -> Curry_Prelude.C_False
  C_JSBool x106 -> Curry_Prelude.C_False
  C_JSIVar x107 -> Curry_Prelude.C_False
  C_JSIArrayIdx x108 x109 -> Curry_Prelude.C_False
  C_JSOp x110 x111 x112 -> Curry_Prelude.C_False
  C_JSFCall x113 x114 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x102 x113 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash)
    x103 x114 s1 cd cs) cd cs))
  C_JSApply x115 x116 -> Curry_Prelude.C_False
  C_JSLambda x117 x118 -> Curry_Prelude.C_False
  Choice_C_JSExp d i l r -> narrow d i (nd_C__case_29 x103 x102 l s cd cs)
    (nd_C__case_29 x103 x102 r s cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z -> nd_C__case_29 x103 x102 z s cd
    cs) xs
  Guard_C_JSExp d c e -> guardCons d c ((\x -> nd_C__case_29 x103 x102 e s cd
    x) $! addCs c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_29" [show x103, show x102, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_29" (showCons x2))

nd_C__case_30 :: C_JSExp -> C_JSExp -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_JSExp -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_30 x86 x85 x84 x2 s cd cs = case x2 of
  C_JSString x87 -> Curry_Prelude.C_False
  C_JSInt x88 -> Curry_Prelude.C_False
  C_JSBool x89 -> Curry_Prelude.C_False
  C_JSIVar x90 -> Curry_Prelude.C_False
  C_JSIArrayIdx x91 x92 -> Curry_Prelude.C_False
  C_JSOp x93 x94 x95 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x84 x93 s0 cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x85 x94 s1 cd cs) cd cs))
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x86 x95 s3 cd cs) cd cs))
  C_JSFCall x96 x97 -> Curry_Prelude.C_False
  C_JSApply x98 x99 -> Curry_Prelude.C_False
  C_JSLambda x100 x101 -> Curry_Prelude.C_False
  Choice_C_JSExp d i l r -> narrow d i (nd_C__case_30 x86 x85 x84 l s cd cs)
    (nd_C__case_30 x86 x85 x84 r s cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z -> nd_C__case_30 x86 x85 x84 z s
    cd cs) xs
  Guard_C_JSExp d c e -> guardCons d c ((\x -> nd_C__case_30 x86 x85 x84 e s cd
    x) $! addCs c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_30" [show x86, show x85, show x84, show x2]
    info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_30" (showCons x2))

d_C__case_31 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> C_JSExp -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_31 x68 x67 x2 cd cs = case x2 of
  C_JSString x69 -> Curry_Prelude.C_False
  C_JSInt x70 -> Curry_Prelude.C_False
  C_JSBool x71 -> Curry_Prelude.C_False
  C_JSIVar x72 -> Curry_Prelude.C_False
  C_JSIArrayIdx x73 x74 -> Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs) x67 cd cs) x73 cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs) x68 cd cs) x74 cd cs) cd cs
  C_JSOp x75 x76 x77 -> Curry_Prelude.C_False
  C_JSFCall x78 x79 -> Curry_Prelude.C_False
  C_JSApply x80 x81 -> Curry_Prelude.C_False
  C_JSLambda x82 x83 -> Curry_Prelude.C_False
  Choice_C_JSExp d i l r -> narrow d i (d_C__case_31 x68 x67 l cd cs)
    (d_C__case_31 x68 x67 r cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z -> d_C__case_31 x68 x67 z cd cs)
    xs
  Guard_C_JSExp d c e -> guardCons d c ((\x -> d_C__case_31 x68 x67 e cd x) $!
    addCs c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_31" [show x68, show x67, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_31" (showCons x2))

d_C__case_32 :: Curry_Prelude.C_Int -> C_JSExp -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_32 x51 x2 cd cs = case x2 of
  C_JSString x52 -> Curry_Prelude.C_False
  C_JSInt x53 -> Curry_Prelude.C_False
  C_JSBool x54 -> Curry_Prelude.C_False
  C_JSIVar x55 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs) x51 cd cs) x55 cd cs
  C_JSIArrayIdx x56 x57 -> Curry_Prelude.C_False
  C_JSOp x58 x59 x60 -> Curry_Prelude.C_False
  C_JSFCall x61 x62 -> Curry_Prelude.C_False
  C_JSApply x63 x64 -> Curry_Prelude.C_False
  C_JSLambda x65 x66 -> Curry_Prelude.C_False
  Choice_C_JSExp d i l r -> narrow d i (d_C__case_32 x51 l cd cs) (d_C__case_32
    x51 r cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z -> d_C__case_32 x51 z cd cs) xs
  Guard_C_JSExp d c e -> guardCons d c ((\x -> d_C__case_32 x51 e cd x) $! addCs
    c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_32" [show x51, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_32" (showCons x2))

d_C__case_33 :: Curry_Prelude.C_Bool -> C_JSExp -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_33 x35 x2 cd cs = case x2 of
  C_JSString x36 -> Curry_Prelude.C_False
  C_JSInt x37 -> Curry_Prelude.C_False
  C_JSBool x38 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
    x35 x38 cd cs
  C_JSIVar x39 -> Curry_Prelude.C_False
  C_JSIArrayIdx x40 x41 -> Curry_Prelude.C_False
  C_JSOp x42 x43 x44 -> Curry_Prelude.C_False
  C_JSFCall x45 x46 -> Curry_Prelude.C_False
  C_JSApply x47 x48 -> Curry_Prelude.C_False
  C_JSLambda x49 x50 -> Curry_Prelude.C_False
  Choice_C_JSExp d i l r -> narrow d i (d_C__case_33 x35 l cd cs) (d_C__case_33
    x35 r cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z -> d_C__case_33 x35 z cd cs) xs
  Guard_C_JSExp d c e -> guardCons d c ((\x -> d_C__case_33 x35 e cd x) $! addCs
    c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_33" [show x35, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_33" (showCons x2))

d_C__case_34 :: Curry_Prelude.C_Int -> C_JSExp -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_34 x19 x2 cd cs = case x2 of
  C_JSString x20 -> Curry_Prelude.C_False
  C_JSInt x21 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs) x19 cd cs) x21 cd cs
  C_JSBool x22 -> Curry_Prelude.C_False
  C_JSIVar x23 -> Curry_Prelude.C_False
  C_JSIArrayIdx x24 x25 -> Curry_Prelude.C_False
  C_JSOp x26 x27 x28 -> Curry_Prelude.C_False
  C_JSFCall x29 x30 -> Curry_Prelude.C_False
  C_JSApply x31 x32 -> Curry_Prelude.C_False
  C_JSLambda x33 x34 -> Curry_Prelude.C_False
  Choice_C_JSExp d i l r -> narrow d i (d_C__case_34 x19 l cd cs) (d_C__case_34
    x19 r cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z -> d_C__case_34 x19 z cd cs) xs
  Guard_C_JSExp d c e -> guardCons d c ((\x -> d_C__case_34 x19 e cd x) $! addCs
    c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_34" [show x19, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_34" (showCons x2))

nd_C__case_35 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_JSExp
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_35 x3 x2 s cd cs = case x2 of
  C_JSString x4 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x4 s0 cd cs
  C_JSInt x5 -> Curry_Prelude.C_False
  C_JSBool x6 -> Curry_Prelude.C_False
  C_JSIVar x7 -> Curry_Prelude.C_False
  C_JSIArrayIdx x8 x9 -> Curry_Prelude.C_False
  C_JSOp x10 x11 x12 -> Curry_Prelude.C_False
  C_JSFCall x13 x14 -> Curry_Prelude.C_False
  C_JSApply x15 x16 -> Curry_Prelude.C_False
  C_JSLambda x17 x18 -> Curry_Prelude.C_False
  Choice_C_JSExp d i l r -> narrow d i (nd_C__case_35 x3 l s cd cs)
    (nd_C__case_35 x3 r s cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z -> nd_C__case_35 x3 z s cd cs) xs
  Guard_C_JSExp d c e -> guardCons d c ((\x -> nd_C__case_35 x3 e s cd x) $!
    addCs c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_35" [show x3, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_35" (showCons x2))

d_C__case_21 :: Curry_Prelude.C_Int -> C_JSStat -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_21 x68 x2 cd cs = case x2 of
  C_JSAssign x69 x70 -> Curry_Prelude.C_False
  C_JSIf x71 x72 x73 -> Curry_Prelude.C_False
  C_JSSwitch x74 x75 -> Curry_Prelude.C_False
  C_JSPCall x76 x77 -> Curry_Prelude.C_False
  C_JSReturn x78 -> Curry_Prelude.C_False
  C_JSVarDecl x79 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs) x68 cd cs) x79 cd cs
  Choice_C_JSStat d i l r -> narrow d i (d_C__case_21 x68 l cd cs) (d_C__case_21
    x68 r cd cs)
  Choices_C_JSStat d i xs -> narrows cs d i (\z -> d_C__case_21 x68 z cd cs) xs
  Guard_C_JSStat d c e -> guardCons d c ((\x -> d_C__case_21 x68 e cd x) $!
    addCs c cs)
  Fail_C_JSStat d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_21" [show x68, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_21" (showCons x2))

nd_C__case_22 :: C_JSExp -> C_JSStat -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_22 x56 x2 s cd cs = case x2 of
  C_JSAssign x57 x58 -> Curry_Prelude.C_False
  C_JSIf x59 x60 x61 -> Curry_Prelude.C_False
  C_JSSwitch x62 x63 -> Curry_Prelude.C_False
  C_JSPCall x64 x65 -> Curry_Prelude.C_False
  C_JSReturn x66 -> let s0 = s
    in s0 `seq`
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x56 x66 s0 cd cs
  C_JSVarDecl x67 -> Curry_Prelude.C_False
  Choice_C_JSStat d i l r -> narrow d i (nd_C__case_22 x56 l s cd cs)
    (nd_C__case_22 x56 r s cd cs)
  Choices_C_JSStat d i xs -> narrows cs d i (\z -> nd_C__case_22 x56 z s cd cs)
    xs
  Guard_C_JSStat d c e -> guardCons d c ((\x -> nd_C__case_22 x56 e s cd x) $!
    addCs c cs)
  Fail_C_JSStat d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_22" [show x56, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_22" (showCons x2))

nd_C__case_23 :: Curry_Prelude.OP_List C_JSExp -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_JSStat -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_23 x44 x43 x2 s cd cs = case x2 of
  C_JSAssign x45 x46 -> Curry_Prelude.C_False
  C_JSIf x47 x48 x49 -> Curry_Prelude.C_False
  C_JSSwitch x50 x51 -> Curry_Prelude.C_False
  C_JSPCall x52 x53 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x43 x52 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash)
    x44 x53 s1 cd cs) cd cs))
  C_JSReturn x54 -> Curry_Prelude.C_False
  C_JSVarDecl x55 -> Curry_Prelude.C_False
  Choice_C_JSStat d i l r -> narrow d i (nd_C__case_23 x44 x43 l s cd cs)
    (nd_C__case_23 x44 x43 r s cd cs)
  Choices_C_JSStat d i xs -> narrows cs d i (\z -> nd_C__case_23 x44 x43 z s cd
    cs) xs
  Guard_C_JSStat d c e -> guardCons d c ((\x -> nd_C__case_23 x44 x43 e s cd
    x) $! addCs c cs)
  Fail_C_JSStat d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_23" [show x44, show x43, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_23" (showCons x2))

nd_C__case_24 :: Curry_Prelude.OP_List C_JSBranch -> C_JSExp -> C_JSStat
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_24 x31 x30 x2 s cd cs = case x2 of
  C_JSAssign x32 x33 -> Curry_Prelude.C_False
  C_JSIf x34 x35 x36 -> Curry_Prelude.C_False
  C_JSSwitch x37 x38 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x30 x37 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash)
    x31 x38 s1 cd cs) cd cs))
  C_JSPCall x39 x40 -> Curry_Prelude.C_False
  C_JSReturn x41 -> Curry_Prelude.C_False
  C_JSVarDecl x42 -> Curry_Prelude.C_False
  Choice_C_JSStat d i l r -> narrow d i (nd_C__case_24 x31 x30 l s cd cs)
    (nd_C__case_24 x31 x30 r s cd cs)
  Choices_C_JSStat d i xs -> narrows cs d i (\z -> nd_C__case_24 x31 x30 z s cd
    cs) xs
  Guard_C_JSStat d c e -> guardCons d c ((\x -> nd_C__case_24 x31 x30 e s cd
    x) $! addCs c cs)
  Fail_C_JSStat d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_24" [show x31, show x30, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_24" (showCons x2))

nd_C__case_25 :: Curry_Prelude.OP_List C_JSStat -> Curry_Prelude.OP_List
  C_JSStat -> C_JSExp -> C_JSStat -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_25 x18 x17 x16 x2 s cd cs = case x2 of
  C_JSAssign x19 x20 -> Curry_Prelude.C_False
  C_JSIf x21 x22 x23 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x16 x21 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash)
    x17 x22 s1 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash)
    x18 x23 s3 cd cs) cd cs))
  C_JSSwitch x24 x25 -> Curry_Prelude.C_False
  C_JSPCall x26 x27 -> Curry_Prelude.C_False
  C_JSReturn x28 -> Curry_Prelude.C_False
  C_JSVarDecl x29 -> Curry_Prelude.C_False
  Choice_C_JSStat d i l r -> narrow d i (nd_C__case_25 x18 x17 x16 l s cd cs)
    (nd_C__case_25 x18 x17 x16 r s cd cs)
  Choices_C_JSStat d i xs -> narrows cs d i (\z -> nd_C__case_25 x18 x17 x16 z s
    cd cs) xs
  Guard_C_JSStat d c e -> guardCons d c ((\x -> nd_C__case_25 x18 x17 x16 e s cd
    x) $! addCs c cs)
  Fail_C_JSStat d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_25" [show x18, show x17, show x16, show x2]
    info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_25" (showCons x2))

nd_C__case_26 :: C_JSExp -> C_JSExp -> C_JSStat -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_26 x4 x3 x2 s cd cs = case x2 of
  C_JSAssign x5 x6 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x3 x5 s0 cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x4 x6 s1 cd cs) cd cs))
  C_JSIf x7 x8 x9 -> Curry_Prelude.C_False
  C_JSSwitch x10 x11 -> Curry_Prelude.C_False
  C_JSPCall x12 x13 -> Curry_Prelude.C_False
  C_JSReturn x14 -> Curry_Prelude.C_False
  C_JSVarDecl x15 -> Curry_Prelude.C_False
  Choice_C_JSStat d i l r -> narrow d i (nd_C__case_26 x4 x3 l s cd cs)
    (nd_C__case_26 x4 x3 r s cd cs)
  Choices_C_JSStat d i xs -> narrows cs d i (\z -> nd_C__case_26 x4 x3 z s cd
    cs) xs
  Guard_C_JSStat d c e -> guardCons d c ((\x -> nd_C__case_26 x4 x3 e s cd x) $!
    addCs c cs)
  Fail_C_JSStat d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_26" [show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_26" (showCons x2))

nd_C__case_19 :: Curry_Prelude.OP_List C_JSStat -> C_JSBranch -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_19 x8 x2 s cd cs = case x2 of
  C_JSCase x9 x10 -> Curry_Prelude.C_False
  C_JSDefault x11 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash)
    x8 x11 s0 cd cs
  Choice_C_JSBranch d i l r -> narrow d i (nd_C__case_19 x8 l s cd cs)
    (nd_C__case_19 x8 r s cd cs)
  Choices_C_JSBranch d i xs -> narrows cs d i (\z -> nd_C__case_19 x8 z s cd cs)
    xs
  Guard_C_JSBranch d c e -> guardCons d c ((\x -> nd_C__case_19 x8 e s cd x) $!
    addCs c cs)
  Fail_C_JSBranch d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_19" [show x8, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_19" (showCons x2))

nd_C__case_20 :: Curry_Prelude.OP_List C_JSStat -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_JSBranch -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_20 x4 x3 x2 s cd cs = case x2 of
  C_JSCase x5 x6 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x5 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash)
    x4 x6 s1 cd cs) cd cs))
  C_JSDefault x7 -> Curry_Prelude.C_False
  Choice_C_JSBranch d i l r -> narrow d i (nd_C__case_20 x4 x3 l s cd cs)
    (nd_C__case_20 x4 x3 r s cd cs)
  Choices_C_JSBranch d i xs -> narrows cs d i (\z -> nd_C__case_20 x4 x3 z s cd
    cs) xs
  Guard_C_JSBranch d c e -> guardCons d c ((\x -> nd_C__case_20 x4 x3 e s cd
    x) $! addCs c cs)
  Fail_C_JSBranch d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_20" [show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_20" (showCons x2))

nd_C__case_18 :: Curry_Prelude.OP_List C_JSStat -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_JSFDecl
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_18 x5 x4 x3 x2 s cd cs = case x2 of
  C_JSFDecl x6 x7 x8 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x3 x6 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
    x4 x7 s1 cd cs) cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash)
    x5 x8 s3 cd cs) cd cs))
  Choice_C_JSFDecl d i l r -> narrow d i (nd_C__case_18 x5 x4 x3 l s cd cs)
    (nd_C__case_18 x5 x4 x3 r s cd cs)
  Choices_C_JSFDecl d i xs -> narrows cs d i (\z -> nd_C__case_18 x5 x4 x3 z s
    cd cs) xs
  Guard_C_JSFDecl d c e -> guardCons d c ((\x -> nd_C__case_18 x5 x4 x3 e s cd
    x) $! addCs c cs)
  Fail_C_JSFDecl d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_18" [show x5, show x4, show x3, show x2]
    info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_18" (showCons x2))

d_C__case_9 :: Curry_Prelude.OP_List C_JSStat -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> C_JSExp -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_9 x137 x136 x2 cd cs = case x2 of
  C_JSString x138 -> Curry_Prelude.C_False
  C_JSInt x139 -> Curry_Prelude.C_False
  C_JSBool x140 -> Curry_Prelude.C_False
  C_JSIVar x141 -> Curry_Prelude.C_False
  C_JSIArrayIdx x142 x143 -> Curry_Prelude.C_False
  C_JSOp x144 x145 x146 -> Curry_Prelude.C_False
  C_JSFCall x147 x148 -> Curry_Prelude.C_False
  C_JSApply x149 x150 -> Curry_Prelude.C_False
  C_JSLambda x151 x152 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x136 x151 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    x137 x152 cd cs) cd cs
  Choice_C_JSExp d i l r -> narrow d i (d_C__case_9 x137 x136 l cd cs)
    (d_C__case_9 x137 x136 r cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z -> d_C__case_9 x137 x136 z cd cs)
    xs
  Guard_C_JSExp d c e -> guardCons d c ((\x -> d_C__case_9 x137 x136 e cd x) $!
    addCs c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_9" [show x137, show x136, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_9" (showCons x2))

d_C__case_10 :: C_JSExp -> C_JSExp -> C_JSExp -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_10 x120 x119 x2 cd cs = case x2 of
  C_JSString x121 -> Curry_Prelude.C_False
  C_JSInt x122 -> Curry_Prelude.C_False
  C_JSBool x123 -> Curry_Prelude.C_False
  C_JSIVar x124 -> Curry_Prelude.C_False
  C_JSIArrayIdx x125 x126 -> Curry_Prelude.C_False
  C_JSOp x127 x128 x129 -> Curry_Prelude.C_False
  C_JSFCall x130 x131 -> Curry_Prelude.C_False
  C_JSApply x132 x133 -> Curry_Prelude.d_OP_amp_amp
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x119 x132 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x120 x133 cd cs) cd cs
  C_JSLambda x134 x135 -> Curry_Prelude.C_False
  Choice_C_JSExp d i l r -> narrow d i (d_C__case_10 x120 x119 l cd cs)
    (d_C__case_10 x120 x119 r cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z -> d_C__case_10 x120 x119 z cd
    cs) xs
  Guard_C_JSExp d c e -> guardCons d c ((\x -> d_C__case_10 x120 x119 e cd x) $!
    addCs c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_10" [show x120, show x119, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_10" (showCons x2))

d_C__case_11 :: Curry_Prelude.OP_List C_JSExp -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_JSExp -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_11 x103 x102 x2 cd cs = case x2 of
  C_JSString x104 -> Curry_Prelude.C_False
  C_JSInt x105 -> Curry_Prelude.C_False
  C_JSBool x106 -> Curry_Prelude.C_False
  C_JSIVar x107 -> Curry_Prelude.C_False
  C_JSIArrayIdx x108 x109 -> Curry_Prelude.C_False
  C_JSOp x110 x111 x112 -> Curry_Prelude.C_False
  C_JSFCall x113 x114 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x102 x113 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x103 x114 cd cs) cd cs
  C_JSApply x115 x116 -> Curry_Prelude.C_False
  C_JSLambda x117 x118 -> Curry_Prelude.C_False
  Choice_C_JSExp d i l r -> narrow d i (d_C__case_11 x103 x102 l cd cs)
    (d_C__case_11 x103 x102 r cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z -> d_C__case_11 x103 x102 z cd
    cs) xs
  Guard_C_JSExp d c e -> guardCons d c ((\x -> d_C__case_11 x103 x102 e cd x) $!
    addCs c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_11" [show x103, show x102, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_11" (showCons x2))

d_C__case_12 :: C_JSExp -> C_JSExp -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> C_JSExp -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_12 x86 x85 x84 x2 cd cs = case x2 of
  C_JSString x87 -> Curry_Prelude.C_False
  C_JSInt x88 -> Curry_Prelude.C_False
  C_JSBool x89 -> Curry_Prelude.C_False
  C_JSIVar x90 -> Curry_Prelude.C_False
  C_JSIArrayIdx x91 x92 -> Curry_Prelude.C_False
  C_JSOp x93 x94 x95 -> Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x84 x93 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x85 x94 cd cs) cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x86 x95 cd cs) cd cs
  C_JSFCall x96 x97 -> Curry_Prelude.C_False
  C_JSApply x98 x99 -> Curry_Prelude.C_False
  C_JSLambda x100 x101 -> Curry_Prelude.C_False
  Choice_C_JSExp d i l r -> narrow d i (d_C__case_12 x86 x85 x84 l cd cs)
    (d_C__case_12 x86 x85 x84 r cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z -> d_C__case_12 x86 x85 x84 z cd
    cs) xs
  Guard_C_JSExp d c e -> guardCons d c ((\x -> d_C__case_12 x86 x85 x84 e cd
    x) $! addCs c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_12" [show x86, show x85, show x84, show x2]
    info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_12" (showCons x2))

d_C__case_13 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> C_JSExp -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_13 x68 x67 x2 cd cs = case x2 of
  C_JSString x69 -> Curry_Prelude.C_False
  C_JSInt x70 -> Curry_Prelude.C_False
  C_JSBool x71 -> Curry_Prelude.C_False
  C_JSIVar x72 -> Curry_Prelude.C_False
  C_JSIArrayIdx x73 x74 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x67 x73 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x68 x74 cd cs) cd cs
  C_JSOp x75 x76 x77 -> Curry_Prelude.C_False
  C_JSFCall x78 x79 -> Curry_Prelude.C_False
  C_JSApply x80 x81 -> Curry_Prelude.C_False
  C_JSLambda x82 x83 -> Curry_Prelude.C_False
  Choice_C_JSExp d i l r -> narrow d i (d_C__case_13 x68 x67 l cd cs)
    (d_C__case_13 x68 x67 r cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z -> d_C__case_13 x68 x67 z cd cs)
    xs
  Guard_C_JSExp d c e -> guardCons d c ((\x -> d_C__case_13 x68 x67 e cd x) $!
    addCs c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_13" [show x68, show x67, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_13" (showCons x2))

d_C__case_14 :: Curry_Prelude.C_Int -> C_JSExp -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_14 x51 x2 cd cs = case x2 of
  C_JSString x52 -> Curry_Prelude.C_False
  C_JSInt x53 -> Curry_Prelude.C_False
  C_JSBool x54 -> Curry_Prelude.C_False
  C_JSIVar x55 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x51 x55 cd cs
  C_JSIArrayIdx x56 x57 -> Curry_Prelude.C_False
  C_JSOp x58 x59 x60 -> Curry_Prelude.C_False
  C_JSFCall x61 x62 -> Curry_Prelude.C_False
  C_JSApply x63 x64 -> Curry_Prelude.C_False
  C_JSLambda x65 x66 -> Curry_Prelude.C_False
  Choice_C_JSExp d i l r -> narrow d i (d_C__case_14 x51 l cd cs) (d_C__case_14
    x51 r cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z -> d_C__case_14 x51 z cd cs) xs
  Guard_C_JSExp d c e -> guardCons d c ((\x -> d_C__case_14 x51 e cd x) $! addCs
    c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_14" [show x51, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_14" (showCons x2))

d_C__case_15 :: Curry_Prelude.C_Bool -> C_JSExp -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_15 x35 x2 cd cs = case x2 of
  C_JSString x36 -> Curry_Prelude.C_False
  C_JSInt x37 -> Curry_Prelude.C_False
  C_JSBool x38 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Bool_hash
    x35 x38 cd cs
  C_JSIVar x39 -> Curry_Prelude.C_False
  C_JSIArrayIdx x40 x41 -> Curry_Prelude.C_False
  C_JSOp x42 x43 x44 -> Curry_Prelude.C_False
  C_JSFCall x45 x46 -> Curry_Prelude.C_False
  C_JSApply x47 x48 -> Curry_Prelude.C_False
  C_JSLambda x49 x50 -> Curry_Prelude.C_False
  Choice_C_JSExp d i l r -> narrow d i (d_C__case_15 x35 l cd cs) (d_C__case_15
    x35 r cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z -> d_C__case_15 x35 z cd cs) xs
  Guard_C_JSExp d c e -> guardCons d c ((\x -> d_C__case_15 x35 e cd x) $! addCs
    c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_15" [show x35, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_15" (showCons x2))

d_C__case_16 :: Curry_Prelude.C_Int -> C_JSExp -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_16 x19 x2 cd cs = case x2 of
  C_JSString x20 -> Curry_Prelude.C_False
  C_JSInt x21 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x19 x21 cd cs
  C_JSBool x22 -> Curry_Prelude.C_False
  C_JSIVar x23 -> Curry_Prelude.C_False
  C_JSIArrayIdx x24 x25 -> Curry_Prelude.C_False
  C_JSOp x26 x27 x28 -> Curry_Prelude.C_False
  C_JSFCall x29 x30 -> Curry_Prelude.C_False
  C_JSApply x31 x32 -> Curry_Prelude.C_False
  C_JSLambda x33 x34 -> Curry_Prelude.C_False
  Choice_C_JSExp d i l r -> narrow d i (d_C__case_16 x19 l cd cs) (d_C__case_16
    x19 r cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z -> d_C__case_16 x19 z cd cs) xs
  Guard_C_JSExp d c e -> guardCons d c ((\x -> d_C__case_16 x19 e cd x) $! addCs
    c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_16" [show x19, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_16" (showCons x2))

d_C__case_17 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_JSExp -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_17 x3 x2 cd cs = case x2 of
  C_JSString x4 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 x4 cd cs
  C_JSInt x5 -> Curry_Prelude.C_False
  C_JSBool x6 -> Curry_Prelude.C_False
  C_JSIVar x7 -> Curry_Prelude.C_False
  C_JSIArrayIdx x8 x9 -> Curry_Prelude.C_False
  C_JSOp x10 x11 x12 -> Curry_Prelude.C_False
  C_JSFCall x13 x14 -> Curry_Prelude.C_False
  C_JSApply x15 x16 -> Curry_Prelude.C_False
  C_JSLambda x17 x18 -> Curry_Prelude.C_False
  Choice_C_JSExp d i l r -> narrow d i (d_C__case_17 x3 l cd cs) (d_C__case_17
    x3 r cd cs)
  Choices_C_JSExp d i xs -> narrows cs d i (\z -> d_C__case_17 x3 z cd cs) xs
  Guard_C_JSExp d c e -> guardCons d c ((\x -> d_C__case_17 x3 e cd x) $! addCs
    c cs)
  Fail_C_JSExp d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_17" [show x3, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_17" (showCons x2))

d_C__case_3 :: Curry_Prelude.C_Int -> C_JSStat -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_3 x68 x2 cd cs = case x2 of
  C_JSAssign x69 x70 -> Curry_Prelude.C_False
  C_JSIf x71 x72 x73 -> Curry_Prelude.C_False
  C_JSSwitch x74 x75 -> Curry_Prelude.C_False
  C_JSPCall x76 x77 -> Curry_Prelude.C_False
  C_JSReturn x78 -> Curry_Prelude.C_False
  C_JSVarDecl x79 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x68 x79 cd cs
  Choice_C_JSStat d i l r -> narrow d i (d_C__case_3 x68 l cd cs) (d_C__case_3
    x68 r cd cs)
  Choices_C_JSStat d i xs -> narrows cs d i (\z -> d_C__case_3 x68 z cd cs) xs
  Guard_C_JSStat d c e -> guardCons d c ((\x -> d_C__case_3 x68 e cd x) $! addCs
    c cs)
  Fail_C_JSStat d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_3" [show x68, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_3" (showCons x2))

d_C__case_4 :: C_JSExp -> C_JSStat -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_4 x56 x2 cd cs = case x2 of
  C_JSAssign x57 x58 -> Curry_Prelude.C_False
  C_JSIf x59 x60 x61 -> Curry_Prelude.C_False
  C_JSSwitch x62 x63 -> Curry_Prelude.C_False
  C_JSPCall x64 x65 -> Curry_Prelude.C_False
  C_JSReturn x66 -> d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x56 x66 cd cs
  C_JSVarDecl x67 -> Curry_Prelude.C_False
  Choice_C_JSStat d i l r -> narrow d i (d_C__case_4 x56 l cd cs) (d_C__case_4
    x56 r cd cs)
  Choices_C_JSStat d i xs -> narrows cs d i (\z -> d_C__case_4 x56 z cd cs) xs
  Guard_C_JSStat d c e -> guardCons d c ((\x -> d_C__case_4 x56 e cd x) $! addCs
    c cs)
  Fail_C_JSStat d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_4" [show x56, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_4" (showCons x2))

d_C__case_5 :: Curry_Prelude.OP_List C_JSExp -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_JSStat -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_5 x44 x43 x2 cd cs = case x2 of
  C_JSAssign x45 x46 -> Curry_Prelude.C_False
  C_JSIf x47 x48 x49 -> Curry_Prelude.C_False
  C_JSSwitch x50 x51 -> Curry_Prelude.C_False
  C_JSPCall x52 x53 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x43 x52 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x44 x53 cd cs) cd cs
  C_JSReturn x54 -> Curry_Prelude.C_False
  C_JSVarDecl x55 -> Curry_Prelude.C_False
  Choice_C_JSStat d i l r -> narrow d i (d_C__case_5 x44 x43 l cd cs)
    (d_C__case_5 x44 x43 r cd cs)
  Choices_C_JSStat d i xs -> narrows cs d i (\z -> d_C__case_5 x44 x43 z cd cs)
    xs
  Guard_C_JSStat d c e -> guardCons d c ((\x -> d_C__case_5 x44 x43 e cd x) $!
    addCs c cs)
  Fail_C_JSStat d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_5" [show x44, show x43, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_5" (showCons x2))

d_C__case_6 :: Curry_Prelude.OP_List C_JSBranch -> C_JSExp -> C_JSStat -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_6 x31 x30 x2 cd cs = case x2 of
  C_JSAssign x32 x33 -> Curry_Prelude.C_False
  C_JSIf x34 x35 x36 -> Curry_Prelude.C_False
  C_JSSwitch x37 x38 -> Curry_Prelude.d_OP_amp_amp
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x30 x37 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSBranch_hash
    x31 x38 cd cs) cd cs
  C_JSPCall x39 x40 -> Curry_Prelude.C_False
  C_JSReturn x41 -> Curry_Prelude.C_False
  C_JSVarDecl x42 -> Curry_Prelude.C_False
  Choice_C_JSStat d i l r -> narrow d i (d_C__case_6 x31 x30 l cd cs)
    (d_C__case_6 x31 x30 r cd cs)
  Choices_C_JSStat d i xs -> narrows cs d i (\z -> d_C__case_6 x31 x30 z cd cs)
    xs
  Guard_C_JSStat d c e -> guardCons d c ((\x -> d_C__case_6 x31 x30 e cd x) $!
    addCs c cs)
  Fail_C_JSStat d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_6" [show x31, show x30, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_6" (showCons x2))

d_C__case_7 :: Curry_Prelude.OP_List C_JSStat -> Curry_Prelude.OP_List C_JSStat
  -> C_JSExp -> C_JSStat -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_7 x18 x17 x16 x2 cd cs = case x2 of
  C_JSAssign x19 x20 -> Curry_Prelude.C_False
  C_JSIf x21 x22 x23 -> Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_amp_amp
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x16 x21 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    x17 x22 cd cs) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    x18 x23 cd cs) cd cs
  C_JSSwitch x24 x25 -> Curry_Prelude.C_False
  C_JSPCall x26 x27 -> Curry_Prelude.C_False
  C_JSReturn x28 -> Curry_Prelude.C_False
  C_JSVarDecl x29 -> Curry_Prelude.C_False
  Choice_C_JSStat d i l r -> narrow d i (d_C__case_7 x18 x17 x16 l cd cs)
    (d_C__case_7 x18 x17 x16 r cd cs)
  Choices_C_JSStat d i xs -> narrows cs d i (\z -> d_C__case_7 x18 x17 x16 z cd
    cs) xs
  Guard_C_JSStat d c e -> guardCons d c ((\x -> d_C__case_7 x18 x17 x16 e cd
    x) $! addCs c cs)
  Fail_C_JSStat d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_7" [show x18, show x17, show x16, show x2]
    info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_7" (showCons x2))

d_C__case_8 :: C_JSExp -> C_JSExp -> C_JSStat -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_8 x4 x3 x2 cd cs = case x2 of
  C_JSAssign x5 x6 -> Curry_Prelude.d_OP_amp_amp
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x3 x5 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSExp_hash
    x4 x6 cd cs) cd cs
  C_JSIf x7 x8 x9 -> Curry_Prelude.C_False
  C_JSSwitch x10 x11 -> Curry_Prelude.C_False
  C_JSPCall x12 x13 -> Curry_Prelude.C_False
  C_JSReturn x14 -> Curry_Prelude.C_False
  C_JSVarDecl x15 -> Curry_Prelude.C_False
  Choice_C_JSStat d i l r -> narrow d i (d_C__case_8 x4 x3 l cd cs) (d_C__case_8
    x4 x3 r cd cs)
  Choices_C_JSStat d i xs -> narrows cs d i (\z -> d_C__case_8 x4 x3 z cd cs) xs
  Guard_C_JSStat d c e -> guardCons d c ((\x -> d_C__case_8 x4 x3 e cd x) $!
    addCs c cs)
  Fail_C_JSStat d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_8" [show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_8" (showCons x2))

d_C__case_1 :: Curry_Prelude.OP_List C_JSStat -> C_JSBranch -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_1 x8 x2 cd cs = case x2 of
  C_JSCase x9 x10 -> Curry_Prelude.C_False
  C_JSDefault x11 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    x8 x11 cd cs
  Choice_C_JSBranch d i l r -> narrow d i (d_C__case_1 x8 l cd cs) (d_C__case_1
    x8 r cd cs)
  Choices_C_JSBranch d i xs -> narrows cs d i (\z -> d_C__case_1 x8 z cd cs) xs
  Guard_C_JSBranch d c e -> guardCons d c ((\x -> d_C__case_1 x8 e cd x) $!
    addCs c cs)
  Fail_C_JSBranch d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_1" [show x8, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_1" (showCons x2))

d_C__case_2 :: Curry_Prelude.OP_List C_JSStat -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_JSBranch -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_2 x4 x3 x2 cd cs = case x2 of
  C_JSCase x5 x6 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 x5 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    x4 x6 cd cs) cd cs
  C_JSDefault x7 -> Curry_Prelude.C_False
  Choice_C_JSBranch d i l r -> narrow d i (d_C__case_2 x4 x3 l cd cs)
    (d_C__case_2 x4 x3 r cd cs)
  Choices_C_JSBranch d i xs -> narrows cs d i (\z -> d_C__case_2 x4 x3 z cd cs)
    xs
  Guard_C_JSBranch d c e -> guardCons d c ((\x -> d_C__case_2 x4 x3 e cd x) $!
    addCs c cs)
  Fail_C_JSBranch d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_2" [show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_2" (showCons x2))

d_C__case_0 :: Curry_Prelude.OP_List C_JSStat -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_JSFDecl
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_0 x5 x4 x3 x2 cd cs = case x2 of
  C_JSFDecl x6 x7 x8 -> Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 x6 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x4 x7 cd cs) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Language_dot_JavaScript_dot_Types_dot_JSStat_hash
    x5 x8 cd cs) cd cs
  Choice_C_JSFDecl d i l r -> narrow d i (d_C__case_0 x5 x4 x3 l cd cs)
    (d_C__case_0 x5 x4 x3 r cd cs)
  Choices_C_JSFDecl d i xs -> narrows cs d i (\z -> d_C__case_0 x5 x4 x3 z cd
    cs) xs
  Guard_C_JSFDecl d c e -> guardCons d c ((\x -> d_C__case_0 x5 x4 x3 e cd x) $!
    addCs c cs)
  Fail_C_JSFDecl d info -> failCons d (traceFail
    "Language.JavaScript.Types._case_0" [show x5, show x4, show x3, show x2]
    info)
  _ -> failCons cd (consFail "Language.JavaScript.Types._case_0" (showCons x2))

