{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Data.Curry_Format
  ( C_Floater (..)
  , C_Sign (..)
  , C_Flags (..)
  , C_Alignment (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Floater_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Floater_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Floater_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Flags_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Flags_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Flags_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Alignment_hash
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Alignment_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Alignment_hash
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash
  , d_C_showChar
  , d_C_showInt
  , d_C_showFloat
  , d_C_showString )
  where

import Basics
import qualified Data.Curry_Char
import qualified Data.Curry_List
import qualified Curry_Numeric
import qualified Curry_Prelude


data C_Floater
  = C_Floater C_Sign (Curry_Prelude.OP_List Curry_Prelude.C_Char)
    (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Int
  | Choice_C_Floater Cover ID C_Floater C_Floater
  | Choices_C_Floater Cover ID [C_Floater]
  | Fail_C_Floater Cover FailInfo
  | Guard_C_Floater Cover Constraints C_Floater

instance Show C_Floater where
  showsPrec d (Choice_C_Floater cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Floater cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Floater cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Floater cd info) = showChar '!'
  showsPrec _ (C_Floater x1 x2 x3 x4) = showString "(Floater" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 .
    (showChar ' ' . (shows x4 . showChar ')'))))))))

instance Read C_Floater where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Floater x1 x2 x3 x4, r4) | (_
    , r0) <- readQualified "Data.Format" "Floater" r, (x1, r1) <- readsPrec 11
    r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2, (x4, r4) <-
    readsPrec 11 r3]) s

instance NonDet C_Floater where
  choiceCons = Choice_C_Floater
  choicesCons = Choices_C_Floater
  failCons = Fail_C_Floater
  guardCons = Guard_C_Floater
  try (Choice_C_Floater cd i x y) = tryChoice cd i x y
  try (Choices_C_Floater cd i xs) = tryChoices cd i xs
  try (Fail_C_Floater cd info) = Fail cd info
  try (Guard_C_Floater cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Floater cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Floater cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Floater cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Floater cd i _) = error
    ("Data.Format.Floater.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Floater cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Floater cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Floater where
  generate s c = Choices_C_Floater c (freeID [4] s) [C_Floater (generate
    (leftSupply (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c)
    (generate (leftSupply (rightSupply s)) c) (generate (rightSupply
    (rightSupply s)) c)]

instance NormalForm C_Floater where
  ($!!) cont (C_Floater x1 x2 x3 x4) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> cont (C_Floater y1 y2 y3
    y4) d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_Floater cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Floater cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Floater cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_Floater cd info) _ _ = failCons cd info
  ($##) cont (C_Floater x1 x2 x3 x4) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> ($##) (\y3 d cs -> ($##) (\y4 d cs -> cont (C_Floater y1 y2 y3
    y4) d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_Floater cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Floater cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Floater cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_Floater cd info) _ _ = failCons cd info
  showCons (C_Floater _ _ _ _) = "Data.Format.Floater _ _ _ _"
  showCons x = error ("Data.Format.Floater.showCons: no constructor: " ++ show
    x)
  searchNF search cont (C_Floater x1 x2 x3 x4) = search (\y1 -> search (\y2 ->
    search (\y3 -> search (\y4 -> cont (C_Floater y1 y2 y3 y4)) x4) x3) x2) x1
  searchNF _ _ x = error ("Data.Format.Floater.searchNF: no constructor: " ++
    show x)

instance Unifiable C_Floater where
  (=.=) (C_Floater x1 x2 x3 x4) (C_Floater y1 y2 y3 y4) d cs = (&) ((=:=) x1 y1
    d cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((=:=) x4 y4 d cs) d
    cs) d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Floater x1 x2 x3 x4) (C_Floater y1 y2 y3 y4) d cs = (&) ((=:<=) x1
    y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs) ((=:<=) x4 y4 d
    cs) d cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Floater x3 x4 x5 x6) = (i :=: ChooseN 0 4) : concat [bind cd
    (leftID (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (leftID
    (rightID i)) x5, bind cd (rightID (rightID i)) x6]
  bind d i (Choice_C_Floater cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_Floater cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Floater cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_Floater cd i _) = error
    ("Data.Format.Floater.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Floater cd info) = [Unsolvable info]
  bind d i (Guard_C_Floater cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Floater x3 x4 x5 x6) = (i :=: ChooseN 0 4) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), leftID (rightID i) :=:
    LazyBind (lazyBind cd (leftID (rightID i)) x5), rightID (rightID i) :=:
    LazyBind (lazyBind cd (rightID (rightID i)) x6)]
  lazyBind d i (Choice_C_Floater cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Floater cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_Floater cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Floater cd i _) = error
    ("Data.Format.Floater.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Floater cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Floater cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Floater where

data C_Sign
  = C_Positive
  | C_Negative
  | Choice_C_Sign Cover ID C_Sign C_Sign
  | Choices_C_Sign Cover ID [C_Sign]
  | Fail_C_Sign Cover FailInfo
  | Guard_C_Sign Cover Constraints C_Sign

instance Show C_Sign where
  showsPrec d (Choice_C_Sign cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Sign cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Sign cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Sign cd info) = showChar '!'
  showsPrec _ C_Positive = showString "Positive"
  showsPrec _ C_Negative = showString "Negative"

instance Read C_Sign where
  readsPrec _ s = readParen False (\r -> [(C_Positive, r0) | (_, r0) <-
    readQualified "Data.Format" "Positive" r]) s ++ readParen False (\r ->
    [(C_Negative, r0) | (_, r0) <- readQualified "Data.Format" "Negative" r]) s

instance NonDet C_Sign where
  choiceCons = Choice_C_Sign
  choicesCons = Choices_C_Sign
  failCons = Fail_C_Sign
  guardCons = Guard_C_Sign
  try (Choice_C_Sign cd i x y) = tryChoice cd i x y
  try (Choices_C_Sign cd i xs) = tryChoices cd i xs
  try (Fail_C_Sign cd info) = Fail cd info
  try (Guard_C_Sign cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Sign cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Sign cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Sign cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Sign cd i _) = error
    ("Data.Format.Sign.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Sign cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Sign cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Sign where
  generate s c = Choices_C_Sign c (freeID [0, 0] s) [C_Positive, C_Negative]

instance NormalForm C_Sign where
  ($!!) cont C_Positive d cs = cont C_Positive d cs
  ($!!) cont C_Negative d cs = cont C_Negative d cs
  ($!!) cont (Choice_C_Sign cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Sign cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Sign cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_Sign cd info) _ _ = failCons cd info
  ($##) cont C_Positive d cs = cont C_Positive d cs
  ($##) cont C_Negative d cs = cont C_Negative d cs
  ($##) cont (Choice_C_Sign cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Sign cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Sign cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_Sign cd info) _ _ = failCons cd info
  showCons C_Positive = "Data.Format.Positive"
  showCons C_Negative = "Data.Format.Negative"
  showCons x = error ("Data.Format.Sign.showCons: no constructor: " ++ show x)
  searchNF _ cont C_Positive = cont C_Positive
  searchNF _ cont C_Negative = cont C_Negative
  searchNF _ _ x = error ("Data.Format.Sign.searchNF: no constructor: " ++ show
    x)

instance Unifiable C_Sign where
  (=.=) C_Positive C_Positive d cs = C_True
  (=.=) C_Negative C_Negative d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_Positive C_Positive d cs = C_True
  (=.<=) C_Negative C_Negative d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_Positive = (i :=: ChooseN 0 0) : concat []
  bind cd i C_Negative = (i :=: ChooseN 1 0) : concat []
  bind d i (Choice_C_Sign cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_Sign cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Sign cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Sign cd i _) = error
    ("Data.Format.Sign.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Sign cd info) = [Unsolvable info]
  bind d i (Guard_C_Sign cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_Positive = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_Negative = (i :=: ChooseN 1 0) : []
  lazyBind d i (Choice_C_Sign cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Sign cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j
    xs
  lazyBind d i (Choices_C_Sign cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Sign cd i _) = error
    ("Data.Format.Sign.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Sign cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Sign cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Sign where

data C_Flags
  = C_Flags Curry_Prelude.C_Bool Curry_Prelude.C_Bool Curry_Prelude.C_Bool
    Curry_Prelude.C_Bool Curry_Prelude.C_Bool
  | Choice_C_Flags Cover ID C_Flags C_Flags
  | Choices_C_Flags Cover ID [C_Flags]
  | Fail_C_Flags Cover FailInfo
  | Guard_C_Flags Cover Constraints C_Flags

instance Show C_Flags where
  showsPrec d (Choice_C_Flags cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Flags cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Flags cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Flags cd info) = showChar '!'
  showsPrec _ (C_Flags x1 x2 x3 x4 x5) = showString "(Flags" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 .
    (showChar ' ' . (shows x4 . (showChar ' ' . (shows x5 . showChar
    ')'))))))))))

instance Read C_Flags where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Flags x1 x2 x3 x4 x5, r5) | (_
    , r0) <- readQualified "Data.Format" "Flags" r, (x1, r1) <- readsPrec 11 r0,
    (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2, (x4, r4) <-
    readsPrec 11 r3, (x5, r5) <- readsPrec 11 r4]) s

instance NonDet C_Flags where
  choiceCons = Choice_C_Flags
  choicesCons = Choices_C_Flags
  failCons = Fail_C_Flags
  guardCons = Guard_C_Flags
  try (Choice_C_Flags cd i x y) = tryChoice cd i x y
  try (Choices_C_Flags cd i xs) = tryChoices cd i xs
  try (Fail_C_Flags cd info) = Fail cd info
  try (Guard_C_Flags cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Flags cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Flags cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Flags cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Flags cd i _) = error
    ("Data.Format.Flags.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Flags cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Flags cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Flags where
  generate s c = Choices_C_Flags c (freeID [5] s) [C_Flags (generate (leftSupply
    (leftSupply (leftSupply s))) c) (generate (rightSupply (leftSupply
    (leftSupply s))) c) (generate (rightSupply (leftSupply s)) c) (generate
    (leftSupply (rightSupply s)) c) (generate (rightSupply (rightSupply s)) c)]

instance NormalForm C_Flags where
  ($!!) cont (C_Flags x1 x2 x3 x4 x5) d cs = ($!!) (\y1 d cs -> ($!!)
    (\y2 d cs -> ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> ($!!) (\y5 d cs -> cont
    (C_Flags y1 y2 y3 y4 y5) d cs) x5 d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_Flags cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Flags cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Flags cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_Flags cd info) _ _ = failCons cd info
  ($##) cont (C_Flags x1 x2 x3 x4 x5) d cs = ($##) (\y1 d cs -> ($##)
    (\y2 d cs -> ($##) (\y3 d cs -> ($##) (\y4 d cs -> ($##) (\y5 d cs -> cont
    (C_Flags y1 y2 y3 y4 y5) d cs) x5 d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_Flags cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Flags cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Flags cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_Flags cd info) _ _ = failCons cd info
  showCons (C_Flags _ _ _ _ _) = "Data.Format.Flags _ _ _ _ _"
  showCons x = error ("Data.Format.Flags.showCons: no constructor: " ++ show x)
  searchNF search cont (C_Flags x1 x2 x3 x4 x5) = search (\y1 -> search (\y2 ->
    search (\y3 -> search (\y4 -> search (\y5 -> cont (C_Flags y1 y2 y3 y4 y5))
    x5) x4) x3) x2) x1
  searchNF _ _ x = error ("Data.Format.Flags.searchNF: no constructor: " ++ show
    x)

instance Unifiable C_Flags where
  (=.=) (C_Flags x1 x2 x3 x4 x5) (C_Flags y1 y2 y3 y4 y5) d cs = (&) ((=:=) x1
    y1 d cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((&) ((=:=) x4 y4 d
    cs) ((=:=) x5 y5 d cs) d cs) d cs) d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Flags x1 x2 x3 x4 x5) (C_Flags y1 y2 y3 y4 y5) d cs = (&) ((=:<=) x1
    y1 d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs) ((&) ((=:<=) x4
    y4 d cs) ((=:<=) x5 y5 d cs) d cs) d cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Flags x3 x4 x5 x6 x7) = (i :=: ChooseN 0 5) : concat [bind cd
    (leftID (leftID (leftID i))) x3, bind cd (rightID (leftID (leftID i))) x4
    , bind cd (rightID (leftID i)) x5, bind cd (leftID (rightID i)) x6, bind cd
    (rightID (rightID i)) x7]
  bind d i (Choice_C_Flags cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_Flags cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Flags cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Flags cd i _) = error
    ("Data.Format.Flags.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Flags cd info) = [Unsolvable info]
  bind d i (Guard_C_Flags cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Flags x3 x4 x5 x6 x7) = (i :=: ChooseN 0 5) : [leftID (leftID
    (leftID i)) :=: LazyBind (lazyBind cd (leftID (leftID (leftID i))) x3)
    , rightID (leftID (leftID i)) :=: LazyBind (lazyBind cd (rightID (leftID
    (leftID i))) x4), rightID (leftID i) :=: LazyBind (lazyBind cd (rightID
    (leftID i)) x5), leftID (rightID i) :=: LazyBind (lazyBind cd (leftID
    (rightID i)) x6), rightID (rightID i) :=: LazyBind (lazyBind cd (rightID
    (rightID i)) x7)]
  lazyBind d i (Choice_C_Flags cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Flags cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_Flags cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Flags cd i _) = error
    ("Data.Format.Flags.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Flags cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Flags cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Flags where

data C_Alignment
  = C_LeftAlign
  | C_RightAlign
  | Choice_C_Alignment Cover ID C_Alignment C_Alignment
  | Choices_C_Alignment Cover ID [C_Alignment]
  | Fail_C_Alignment Cover FailInfo
  | Guard_C_Alignment Cover Constraints C_Alignment

instance Show C_Alignment where
  showsPrec d (Choice_C_Alignment cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Alignment cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Alignment cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Alignment cd info) = showChar '!'
  showsPrec _ C_LeftAlign = showString "LeftAlign"
  showsPrec _ C_RightAlign = showString "RightAlign"

instance Read C_Alignment where
  readsPrec _ s = readParen False (\r -> [(C_LeftAlign, r0) | (_, r0) <-
    readQualified "Data.Format" "LeftAlign" r]) s ++ readParen False (\r ->
    [(C_RightAlign, r0) | (_, r0) <- readQualified "Data.Format" "RightAlign"
    r]) s

instance NonDet C_Alignment where
  choiceCons = Choice_C_Alignment
  choicesCons = Choices_C_Alignment
  failCons = Fail_C_Alignment
  guardCons = Guard_C_Alignment
  try (Choice_C_Alignment cd i x y) = tryChoice cd i x y
  try (Choices_C_Alignment cd i xs) = tryChoices cd i xs
  try (Fail_C_Alignment cd info) = Fail cd info
  try (Guard_C_Alignment cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Alignment cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Alignment cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Alignment cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Alignment cd i _) = error
    ("Data.Format.Alignment.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Alignment cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Alignment cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Alignment where
  generate s c = Choices_C_Alignment c (freeID [0, 0] s) [C_LeftAlign
    , C_RightAlign]

instance NormalForm C_Alignment where
  ($!!) cont C_LeftAlign d cs = cont C_LeftAlign d cs
  ($!!) cont C_RightAlign d cs = cont C_RightAlign d cs
  ($!!) cont (Choice_C_Alignment cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Alignment cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Alignment cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_Alignment cd info) _ _ = failCons cd info
  ($##) cont C_LeftAlign d cs = cont C_LeftAlign d cs
  ($##) cont C_RightAlign d cs = cont C_RightAlign d cs
  ($##) cont (Choice_C_Alignment cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Alignment cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Alignment cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_Alignment cd info) _ _ = failCons cd info
  showCons C_LeftAlign = "Data.Format.LeftAlign"
  showCons C_RightAlign = "Data.Format.RightAlign"
  showCons x = error ("Data.Format.Alignment.showCons: no constructor: " ++ show
    x)
  searchNF _ cont C_LeftAlign = cont C_LeftAlign
  searchNF _ cont C_RightAlign = cont C_RightAlign
  searchNF _ _ x = error ("Data.Format.Alignment.searchNF: no constructor: " ++
    show x)

instance Unifiable C_Alignment where
  (=.=) C_LeftAlign C_LeftAlign d cs = C_True
  (=.=) C_RightAlign C_RightAlign d cs = C_True
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_LeftAlign C_LeftAlign d cs = C_True
  (=.<=) C_RightAlign C_RightAlign d cs = C_True
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_LeftAlign = (i :=: ChooseN 0 0) : concat []
  bind cd i C_RightAlign = (i :=: ChooseN 1 0) : concat []
  bind d i (Choice_C_Alignment cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_Alignment cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Alignment cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (bind d i) xs)]
  bind _ _ (Choices_C_Alignment cd i _) = error
    ("Data.Format.Alignment.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Alignment cd info) = [Unsolvable info]
  bind d i (Guard_C_Alignment cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_LeftAlign = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_RightAlign = (i :=: ChooseN 1 0) : []
  lazyBind d i (Choice_C_Alignment cd j x y) = [ConstraintChoice cd j (lazyBind
    d i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Alignment cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_Alignment cd j@(NarrowedID _ _) xs) =
    [ConstraintChoices cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Alignment cd i _) = error
    ("Data.Format.Alignment.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Alignment cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Alignment cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Alignment where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Floater_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Floater
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Floater_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Floater_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Floater_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Floater_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Floater_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Floater_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Floater_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Format._inst#Prelude.Data#Data.Format.Floater#" [show x1] info)
  _ -> failCons cd (consFail
    "Data.Format._inst#Prelude.Data#Data.Format.Floater#" (showCons x1))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Floater_hash :: C_Floater
  -> C_Floater -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Floater_hash x1 x2 s cd cs =
  case x1 of
  C_Floater x3 x4 x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_82 x6 x5 x4 x3 x2 s0 cd cs
  Choice_C_Floater d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Floater_hash
    l x2 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Floater_hash
    r x2 s cd cs)
  Choices_C_Floater d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Floater_hash
    z x2 s cd cs) xs
  Guard_C_Floater d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Floater_hash
    e x2 s cd x) $! addCs c cs)
  Fail_C_Floater d info -> failCons d (traceFail
    "Data.Format._impl#===#Prelude.Data#Data.Format.Floater#" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "Data.Format._impl#===#Prelude.Data#Data.Format.Floater#" (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Floater_hash :: IDSupply
  -> Cover -> ConstStore -> C_Floater
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Floater_hash s cd cs =
  let s4 = s
  in s4 `seq` (let s5 = leftSupply s4
                   s6 = rightSupply s4
                   s0 = leftSupply s5
                   s1 = rightSupply s5
                   s2 = leftSupply s6
                   s3 = rightSupply s6
  in s5 `seq` (s6 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s3 `seq` C_Floater
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s1 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
  s2 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s3 cd cs)))))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Sign
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash e
    s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Format._inst#Prelude.Data#Data.Format.Sign#" [show x1] info)
  _ -> failCons cd (consFail "Data.Format._inst#Prelude.Data#Data.Format.Sign#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash :: C_Sign
  -> C_Sign -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash x1 x2 cd cs =
  case x1 of
  C_Positive -> d_C__case_81 x2 cd cs
  C_Negative -> d_C__case_80 x2 cd cs
  Choice_C_Sign d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash
    r x2 cd cs)
  Choices_C_Sign d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash
    z x2 cd cs) xs
  Guard_C_Sign d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Sign d info -> failCons d (traceFail
    "Data.Format._impl#===#Prelude.Data#Data.Format.Sign#" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "Data.Format._impl#===#Prelude.Data#Data.Format.Sign#" (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash :: IDSupply
  -> Cover -> ConstStore -> C_Sign
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash s cd cs =
  let s0 = s in s0 `seq` choice C_Positive C_Negative s0 cd cs

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Flags_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Flags
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Flags_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Flags_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Flags_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Flags_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Flags_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Flags_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Flags_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Format._inst#Prelude.Data#Data.Format.Flags#" [show x1] info)
  _ -> failCons cd (consFail "Data.Format._inst#Prelude.Data#Data.Format.Flags#"
    (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Flags_hash :: C_Flags
  -> C_Flags -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Flags_hash x1 x2 cd cs =
  case x1 of
  C_Flags x3 x4 x5 x6 x7 -> d_C__case_79 x7 x6 x5 x4 x3 x2 cd cs
  Choice_C_Flags d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Flags_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Flags_hash
    r x2 cd cs)
  Choices_C_Flags d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Flags_hash
    z x2 cd cs) xs
  Guard_C_Flags d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Flags_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Flags d info -> failCons d (traceFail
    "Data.Format._impl#===#Prelude.Data#Data.Format.Flags#" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "Data.Format._impl#===#Prelude.Data#Data.Format.Flags#" (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Flags_hash :: IDSupply
  -> Cover -> ConstStore -> C_Flags
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Flags_hash s cd cs =
  let s5 = s
  in s5 `seq` (let s6 = leftSupply s5
                   s7 = rightSupply s5
                   s0 = leftSupply s6
                   s1 = rightSupply s6
                   s2 = leftSupply s7
                   s8 = rightSupply s7
                   s3 = leftSupply s8
                   s4 = rightSupply s8
  in s6 `seq` (s7 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s8 `seq` (s3 `seq`
  (s4 `seq` C_Flags
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
  s0 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
  s1 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
  s2 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
  s3 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
  s4 cd cs)))))))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Alignment_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data
  C_Alignment
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Alignment_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapDX id)
    (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Alignment_hash))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Alignment_hash
    s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Alignment_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Alignment_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Alignment_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Alignment_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Format._inst#Prelude.Data#Data.Format.Alignment#" [show x1] info)
  _ -> failCons cd (consFail
    "Data.Format._inst#Prelude.Data#Data.Format.Alignment#" (showCons x1))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Alignment_hash :: C_Alignment
  -> C_Alignment -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Alignment_hash x1 x2 cd cs =
  case x1 of
  C_LeftAlign -> d_C__case_78 x2 cd cs
  C_RightAlign -> d_C__case_77 x2 cd cs
  Choice_C_Alignment d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Alignment_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Alignment_hash
    r x2 cd cs)
  Choices_C_Alignment d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Alignment_hash
    z x2 cd cs) xs
  Guard_C_Alignment d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Alignment_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Alignment d info -> failCons d (traceFail
    "Data.Format._impl#===#Prelude.Data#Data.Format.Alignment#" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "Data.Format._impl#===#Prelude.Data#Data.Format.Alignment#" (showCons x1))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Alignment_hash :: IDSupply
  -> Cover -> ConstStore -> C_Alignment
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Alignment_hash s cd cs =
  let s0 = s in s0 `seq` choice C_LeftAlign C_RightAlign s0 cd cs

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash :: Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq C_Alignment
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash
    cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash
    l cd cs)
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash
    z cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Format._inst#Prelude.Eq#Data.Format.Alignment#" [show x1] info)
  _ -> failCons cd (consFail
    "Data.Format._inst#Prelude.Eq#Data.Format.Alignment#" (showCons x1))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash :: Curry_Prelude.OP_Unit
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq
  C_Alignment
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX
    (wrapDX id) (acceptCs id
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash))
    (wrapDX (wrapDX id)
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash
    cd cs))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash
    l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash
    r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Format._inst#Prelude.Eq#Data.Format.Alignment#" [show x1] info)
  _ -> failCons cd (consFail
    "Data.Format._inst#Prelude.Eq#Data.Format.Alignment#" (showCons x1))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash :: C_Alignment
  -> C_Alignment -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash x1 x2 cd cs =
  case x1 of
  C_LeftAlign -> d_C__case_76 x2 cd cs
  C_RightAlign -> d_C__case_75 x2 cd cs
  Choice_C_Alignment d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash
    l x2 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash
    r x2 cd cs)
  Choices_C_Alignment d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash
    z x2 cd cs) xs
  Guard_C_Alignment d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash
    e x2 cd x) $! addCs c cs)
  Fail_C_Alignment d info -> failCons d (traceFail
    "Data.Format._impl#==#Prelude.Eq#Data.Format.Alignment#" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "Data.Format._impl#==#Prelude.Eq#Data.Format.Alignment#" (showCons x1))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash :: Cover
  -> ConstStore -> C_Alignment -> Cover -> ConstStore -> C_Alignment -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash)

d_C_showChar :: Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Maybe
  Curry_Prelude.C_Int -> Curry_Prelude.C_Maybe Curry_Prelude.C_Int
  -> Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_showChar x1 x2 x3 x4 x5 cd cs = let x6 = Curry_Prelude.d_C_apply
                                          (d_C_convertFlags cd cs) x2 cd cs
                                        x7 = Curry_Prelude.d_C_apply
                                          (d_C_convertWidth cd cs) x3 cd cs
                                        x8 = d_C_getMinusFlag x6 cd cs
                                        x9 = Curry_Prelude.OP_Cons x5
                                          Curry_Prelude.OP_List
  in d_C__case_74 x9 x7 x8 cd cs

d_C_showInt :: Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Maybe
  Curry_Prelude.C_Int -> Curry_Prelude.C_Maybe Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_showInt x1 x2 x3 x4 x5 cd cs = let x6 = Curry_Prelude.d_C_apply
                                         (d_C_convertFlags cd cs) x2 cd cs
                                       x7 = Curry_Prelude.d_C_apply
                                         (d_C_convertWidth cd cs) x3 cd cs
                                       x8 = Curry_Prelude.d_C_apply
                                         (d_C_convertPrecision cd cs) x4 cd cs
                                       x9 = Curry_Prelude.d_C_maybe
                                         Curry_Prelude.C_False
                                         d_OP_showInt_dot_uscore_hash_lambda1 x4
                                         cd cs
                                       x10 = d_C_getMinusFlag x6 cd cs
                                       x11 = d_C_getPlusFlag x6 cd cs
                                       x12 = d_C_getZeroFlag x6 cd cs
                                       x13 = d_C_getSpaceFlag x6 cd cs
                                       x14 = d_C_getHashFlag x6 cd cs
                                       x15 = d_C__case_71 x1 x5
                                         (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
                                         x1 (Curry_Prelude.C_Char 'i'#) cd cs)
                                         cd cs
                                       x16 = Curry_Prelude.d_C_apply
                                         (Curry_Prelude.d_C_apply
                                         (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
                                         cd cs) (Curry_Prelude.d_C_head x15 cd
                                         cs) cd cs) (Curry_Prelude.C_Char '-'#)
                                         cd cs
                                       x17 = Curry_Prelude.d_OP_bar_bar
                                         (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
                                         x1 (Curry_Prelude.C_Char 'i'#) cd cs)
                                         (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
                                         x1 (Curry_Prelude.C_Char 'd'#) cd cs)
                                         cd cs
                                       x18 = d_C__case_66 x15 x16 cd cs
                                       x19 = Curry_Prelude.d_C_apply
                                         (Curry_Prelude.d_C_apply
                                         (Curry_Prelude.d_C_apply
                                         (d_C_fillWithCharsRightAlign cd cs) x8
                                         cd cs) (Curry_Prelude.C_Char '0'#) cd
                                         cs) x18 cd cs
                                       x20 = d_C__case_65 x19 x16 cd cs
                                       x21 = d_C__case_64 x16 x17 x11 x20
                                         (Curry_Prelude.d_OP_amp_amp x11
                                         (Curry_Prelude.d_OP_amp_amp x17 x16 cd
                                         cs) cd cs) cd cs
                                       x22 = d_C__case_63 x5 x14 x17 x21 x1
                                         (Curry_Prelude.d_OP_amp_amp
                                         (Curry_Prelude.d_C_not x17 cd cs)
                                         (Curry_Prelude.d_OP_amp_amp x14
                                         (Curry_Prelude.d_C_apply
                                         (Curry_Prelude.d_C_apply
                                         (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
                                         cd cs) x5 cd cs) (Curry_Prelude.C_Int
                                         (0)) cd cs) cd cs) cd cs) cd cs
                                       x23 = d_C__case_59 x11 x16 x17 x13 x22
                                         (Curry_Prelude.d_OP_amp_amp x13
                                         (Curry_Prelude.d_OP_amp_amp x17
                                         (Curry_Prelude.d_OP_amp_amp x16
                                         (Curry_Prelude.d_C_not x11 cd cs) cd
                                         cs) cd cs) cd cs) cd cs
  in d_C__case_73 x9 x12 x23 x7 x10 cd cs

d_OP_showInt_dot_uscore_hash_lambda1 :: Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_showInt_dot_uscore_hash_lambda1 x1 cd cs = Curry_Prelude.C_True

d_C_showFloat :: Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Maybe
  Curry_Prelude.C_Int -> Curry_Prelude.C_Maybe Curry_Prelude.C_Int
  -> Curry_Prelude.C_Float -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_showFloat x1 x2 x3 x4 x5 cd cs = let x6 = Curry_Prelude.d_C_apply
                                           (d_C_convertFlags cd cs) x2 cd cs
                                         x7 = Curry_Prelude.d_C_apply
                                           (d_C_convertWidth cd cs) x3 cd cs
                                         x8 = Curry_Prelude.d_C_apply
                                           (d_C_convertPrecision cd cs) x4 cd cs
                                         x9 = d_C_getMinusFlag x6 cd cs
                                         x10 = d_C_getPlusFlag x6 cd cs
                                         x11 = d_C_getZeroFlag x6 cd cs
                                         x12 = d_C_getSpaceFlag x6 cd cs
                                         x13 = d_C_getHashFlag x6 cd cs
                                         x14 = Curry_Prelude.d_C_apply
                                           (Curry_Prelude.d_C_apply
                                           (Curry_Prelude.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Float_hash
                                           cd cs) x5 cd cs)
                                           (Curry_Prelude.C_Float 0.0##) cd cs
                                         x15 = d_C_floatToFloater x5 cd cs
                                         x16 = d_C__case_56 x1 x15
                                           (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
                                           x1 (Curry_Prelude.C_Char 'f'#) cd cs)
                                           cd cs
                                         x17 = d_C_roundFloater x8 x16 cd cs
                                         x18 = d_C__case_53 x5 x10 x17
                                           (Curry_Prelude.d_OP_amp_amp x10
                                           (Curry_Prelude.d_C_apply
                                           (Curry_Prelude.d_C_apply
                                           (Curry_Prelude.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Float_hash
                                           cd cs) x5 cd cs)
                                           (Curry_Prelude.C_Float 0.0##) cd cs)
                                           cd cs) cd cs
                                         x19 = d_C__case_52 x8 x13 x18
                                           (Curry_Prelude.d_OP_bar_bar
                                           (Curry_Prelude.d_C_not
                                           (Data.Curry_List.d_C_isPrefixOf
                                           Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
                                           (d_C_getMantissaAfterPoint x18 cd cs)
                                           (Curry_Prelude.d_C_repeat
                                           (Curry_Prelude.C_Char '0'#) cd cs) cd
                                           cs) cd cs)
                                           (Curry_Prelude.d_OP_bar_bar x13
                                           (Curry_Prelude.d_C_apply
                                           (Curry_Prelude.d_C_apply
                                           (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
                                           cd cs) x8 cd cs) (Curry_Prelude.C_Int
                                           (0)) cd cs) cd cs) cd cs) cd cs
                                         x20 = d_C__case_51 x14 x10 x12 x19
                                           (Curry_Prelude.d_OP_amp_amp x12
                                           (Curry_Prelude.d_OP_amp_amp
                                           (Curry_Prelude.d_C_not x10 cd cs) x14
                                           cd cs) cd cs) cd cs
                                         x21 = d_C__case_49 x1 x20
                                           (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
                                           x1 (Curry_Prelude.C_Char 'f'#) cd cs)
                                           cd cs
  in d_C__case_58 x11 x21 x7 x9 cd cs

d_C_showString :: Curry_Prelude.C_Char -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Maybe
  Curry_Prelude.C_Int -> Curry_Prelude.C_Maybe Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showString x1 x2 x3 x4 x5 cd cs = let x6 = Curry_Prelude.d_C_apply
                                            (d_C_convertFlags cd cs) x2 cd cs
                                          x7 = Curry_Prelude.d_C_apply
                                            (d_C_convertWidth cd cs) x3 cd cs
                                          x8 = d_C_getMinusFlag x6 cd cs
                                          x9 = Curry_Prelude.d_C_maybe x5
                                            (Curry_Prelude.d_C_flip (acceptCs id
                                            Curry_Prelude.d_C_take) x5) x4 cd cs
  in d_C__case_46 x9 x7 x8 cd cs

d_C_floater :: Cover -> ConstStore -> C_Sign -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> C_Floater
d_C_floater cd cs = acceptCs (acceptCs (acceptCs (acceptCs id))) C_Floater

d_C_floaterCreator :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> C_Floater
d_C_floaterCreator x1 x2 cd cs = d_C_setExponent (d_C_setMantissaSigned
  (d_C_zeroFloater cd cs) x1 cd cs) x2 cd cs

d_C_zeroFloater :: Cover -> ConstStore -> C_Floater
d_C_zeroFloater cd cs = C_Floater C_Positive (Curry_Prelude.toCurryString "0")
  Curry_Prelude.OP_List (Curry_Prelude.C_Int (0))

d_C_floatToFloater :: Curry_Prelude.C_Float -> Cover -> ConstStore -> C_Floater
d_C_floatToFloater x1 cd cs = let x2 = Curry_Prelude.d_C_apply
                                    (Curry_Prelude.d_C_break
                                    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
                                    (Curry_Prelude.C_Char 'e'#)) cd cs)
                                    (Curry_Prelude.d_C_apply
                                    (d_C_consistentShowFloat cd cs) x1 cd cs) cd
                                    cs
                                  x3 = d_OP_floatToFloater_dot_uscore_hash_selFP2_hash_mantissa
                                    x2 cd cs
                                  x4 = d_OP_floatToFloater_dot_uscore_hash_selFP3_hash_exp
                                    x2 cd cs
  in d_C__case_45 x4 x3
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
  x4 Curry_Prelude.OP_List cd cs) cd cs

d_OP_floatToFloater_dot_uscore_hash_selFP2_hash_mantissa :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_floatToFloater_dot_uscore_hash_selFP2_hash_mantissa x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_floatToFloater_dot_uscore_hash_selFP2_hash_mantissa l cd cs)
    (d_OP_floatToFloater_dot_uscore_hash_selFP2_hash_mantissa r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_floatToFloater_dot_uscore_hash_selFP2_hash_mantissa z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_floatToFloater_dot_uscore_hash_selFP2_hash_mantissa e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Format.floatToFloater._#selFP2#mantissa" [show x1] info)
  _ -> failCons cd (consFail "Data.Format.floatToFloater._#selFP2#mantissa"
    (showCons x1))

d_OP_floatToFloater_dot_uscore_hash_selFP3_hash_exp :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_floatToFloater_dot_uscore_hash_selFP3_hash_exp x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_floatToFloater_dot_uscore_hash_selFP3_hash_exp l cd cs)
    (d_OP_floatToFloater_dot_uscore_hash_selFP3_hash_exp r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_floatToFloater_dot_uscore_hash_selFP3_hash_exp z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_floatToFloater_dot_uscore_hash_selFP3_hash_exp e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Format.floatToFloater._#selFP3#exp" [show x1] info)
  _ -> failCons cd (consFail "Data.Format.floatToFloater._#selFP3#exp" (showCons
    x1))

d_C_getSign :: C_Floater -> Cover -> ConstStore -> C_Sign
d_C_getSign x1 cd cs = case x1 of
  C_Floater x2 x3 x4 x5 -> x2
  Choice_C_Floater d i l r -> narrow d i (d_C_getSign l cd cs) (d_C_getSign r cd
    cs)
  Choices_C_Floater d i xs -> narrows cs d i (\z -> d_C_getSign z cd cs) xs
  Guard_C_Floater d c e -> guardCons d c ((\x -> d_C_getSign e cd x) $! addCs c
    cs)
  Fail_C_Floater d info -> failCons d (traceFail "Data.Format.getSign" [show x1]
    info)
  _ -> failCons cd (consFail "Data.Format.getSign" (showCons x1))

d_C_setSign :: C_Floater -> C_Sign -> Cover -> ConstStore -> C_Floater
d_C_setSign x1 x2 cd cs = case x1 of
  C_Floater x3 x4 x5 x6 -> C_Floater x2 x4 x5 x6
  Choice_C_Floater d i l r -> narrow d i (d_C_setSign l x2 cd cs) (d_C_setSign r
    x2 cd cs)
  Choices_C_Floater d i xs -> narrows cs d i (\z -> d_C_setSign z x2 cd cs) xs
  Guard_C_Floater d c e -> guardCons d c ((\x -> d_C_setSign e x2 cd x) $! addCs
    c cs)
  Fail_C_Floater d info -> failCons d (traceFail "Data.Format.setSign" [show x1
    , show x2] info)
  _ -> failCons cd (consFail "Data.Format.setSign" (showCons x1))

d_C_getMantissaBeforePoint :: C_Floater -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_getMantissaBeforePoint x1 cd cs = case x1 of
  C_Floater x2 x3 x4 x5 -> x3
  Choice_C_Floater d i l r -> narrow d i (d_C_getMantissaBeforePoint l cd cs)
    (d_C_getMantissaBeforePoint r cd cs)
  Choices_C_Floater d i xs -> narrows cs d i (\z -> d_C_getMantissaBeforePoint z
    cd cs) xs
  Guard_C_Floater d c e -> guardCons d c ((\x -> d_C_getMantissaBeforePoint e cd
    x) $! addCs c cs)
  Fail_C_Floater d info -> failCons d (traceFail
    "Data.Format.getMantissaBeforePoint" [show x1] info)
  _ -> failCons cd (consFail "Data.Format.getMantissaBeforePoint" (showCons x1))

d_C_setMantissaBeforePoint :: C_Floater -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> C_Floater
d_C_setMantissaBeforePoint x1 x2 cd cs = case x1 of
  C_Floater x3 x4 x5 x6 -> C_Floater x3 x2 x5 x6
  Choice_C_Floater d i l r -> narrow d i (d_C_setMantissaBeforePoint l x2 cd cs)
    (d_C_setMantissaBeforePoint r x2 cd cs)
  Choices_C_Floater d i xs -> narrows cs d i (\z -> d_C_setMantissaBeforePoint z
    x2 cd cs) xs
  Guard_C_Floater d c e -> guardCons d c ((\x -> d_C_setMantissaBeforePoint e x2
    cd x) $! addCs c cs)
  Fail_C_Floater d info -> failCons d (traceFail
    "Data.Format.setMantissaBeforePoint" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Format.setMantissaBeforePoint" (showCons x1))

d_C_getMantissaAfterPoint :: C_Floater -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_getMantissaAfterPoint x1 cd cs = case x1 of
  C_Floater x2 x3 x4 x5 -> x4
  Choice_C_Floater d i l r -> narrow d i (d_C_getMantissaAfterPoint l cd cs)
    (d_C_getMantissaAfterPoint r cd cs)
  Choices_C_Floater d i xs -> narrows cs d i (\z -> d_C_getMantissaAfterPoint z
    cd cs) xs
  Guard_C_Floater d c e -> guardCons d c ((\x -> d_C_getMantissaAfterPoint e cd
    x) $! addCs c cs)
  Fail_C_Floater d info -> failCons d (traceFail
    "Data.Format.getMantissaAfterPoint" [show x1] info)
  _ -> failCons cd (consFail "Data.Format.getMantissaAfterPoint" (showCons x1))

d_C_setMantissaAfterPoint :: C_Floater -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> C_Floater
d_C_setMantissaAfterPoint x1 x2 cd cs = case x1 of
  C_Floater x3 x4 x5 x6 -> C_Floater x3 x4 x2 x6
  Choice_C_Floater d i l r -> narrow d i (d_C_setMantissaAfterPoint l x2 cd cs)
    (d_C_setMantissaAfterPoint r x2 cd cs)
  Choices_C_Floater d i xs -> narrows cs d i (\z -> d_C_setMantissaAfterPoint z
    x2 cd cs) xs
  Guard_C_Floater d c e -> guardCons d c ((\x -> d_C_setMantissaAfterPoint e x2
    cd x) $! addCs c cs)
  Fail_C_Floater d info -> failCons d (traceFail
    "Data.Format.setMantissaAfterPoint" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Format.setMantissaAfterPoint" (showCons x1))

d_C_getMantissa :: C_Floater -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_getMantissa x1 cd cs = case x1 of
  C_Floater x2 x3 x4 x5 -> Curry_Prelude.d_OP_plus_plus x3
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '.'#) x4) cd cs
  Choice_C_Floater d i l r -> narrow d i (d_C_getMantissa l cd cs)
    (d_C_getMantissa r cd cs)
  Choices_C_Floater d i xs -> narrows cs d i (\z -> d_C_getMantissa z cd cs) xs
  Guard_C_Floater d c e -> guardCons d c ((\x -> d_C_getMantissa e cd x) $!
    addCs c cs)
  Fail_C_Floater d info -> failCons d (traceFail "Data.Format.getMantissa" [show
    x1] info)
  _ -> failCons cd (consFail "Data.Format.getMantissa" (showCons x1))

d_C_setMantissa :: C_Floater -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> C_Floater
d_C_setMantissa x1 x2 cd cs = case x1 of
  C_Floater x3 x4 x5 x6 -> let x7 = Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_break
                                 (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
                                 (Curry_Prelude.C_Char '.'#)) cd cs) x2 cd cs
                               x8 = d_OP_setMantissa_dot_uscore_hash_selFP5_hash_bP
                                 x7 cd cs
                               x9 = d_OP_setMantissa_dot_uscore_hash_selFP6_hash_aP
                                 x7 cd cs
    in C_Floater x3 x8 (Curry_Prelude.d_C_tail x9 cd cs) x6
  Choice_C_Floater d i l r -> narrow d i (d_C_setMantissa l x2 cd cs)
    (d_C_setMantissa r x2 cd cs)
  Choices_C_Floater d i xs -> narrows cs d i (\z -> d_C_setMantissa z x2 cd cs)
    xs
  Guard_C_Floater d c e -> guardCons d c ((\x -> d_C_setMantissa e x2 cd x) $!
    addCs c cs)
  Fail_C_Floater d info -> failCons d (traceFail "Data.Format.setMantissa" [show
    x1, show x2] info)
  _ -> failCons cd (consFail "Data.Format.setMantissa" (showCons x1))

d_OP_setMantissa_dot_uscore_hash_selFP5_hash_bP :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_setMantissa_dot_uscore_hash_selFP5_hash_bP x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_setMantissa_dot_uscore_hash_selFP5_hash_bP l cd cs)
    (d_OP_setMantissa_dot_uscore_hash_selFP5_hash_bP r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_setMantissa_dot_uscore_hash_selFP5_hash_bP z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_setMantissa_dot_uscore_hash_selFP5_hash_bP e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Format.setMantissa._#selFP5#bP" [show x1] info)
  _ -> failCons cd (consFail "Data.Format.setMantissa._#selFP5#bP" (showCons
    x1))

d_OP_setMantissa_dot_uscore_hash_selFP6_hash_aP :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_setMantissa_dot_uscore_hash_selFP6_hash_aP x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_setMantissa_dot_uscore_hash_selFP6_hash_aP l cd cs)
    (d_OP_setMantissa_dot_uscore_hash_selFP6_hash_aP r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_setMantissa_dot_uscore_hash_selFP6_hash_aP z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_setMantissa_dot_uscore_hash_selFP6_hash_aP e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Format.setMantissa._#selFP6#aP" [show x1] info)
  _ -> failCons cd (consFail "Data.Format.setMantissa._#selFP6#aP" (showCons
    x1))

d_C_setMantissaSigned :: C_Floater -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> C_Floater
d_C_setMantissaSigned x1 x2 cd cs = case x1 of
  C_Floater x3 x4 x5 x6 -> let x7 = Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_break
                                 (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
                                 (Curry_Prelude.C_Char '.'#)) cd cs) x2 cd cs
                               x8 = d_OP_setMantissaSigned_dot_uscore_hash_selFP8_hash_bP
                                 x7 cd cs
                               x9 = d_OP_setMantissaSigned_dot_uscore_hash_selFP9_hash_aP
                                 x7 cd cs
    in d_C__case_41 x8 x6 x9
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_head x8 cd cs) (Curry_Prelude.C_Char '-'#) cd cs) cd cs
  Choice_C_Floater d i l r -> narrow d i (d_C_setMantissaSigned l x2 cd cs)
    (d_C_setMantissaSigned r x2 cd cs)
  Choices_C_Floater d i xs -> narrows cs d i (\z -> d_C_setMantissaSigned z x2
    cd cs) xs
  Guard_C_Floater d c e -> guardCons d c ((\x -> d_C_setMantissaSigned e x2 cd
    x) $! addCs c cs)
  Fail_C_Floater d info -> failCons d (traceFail "Data.Format.setMantissaSigned"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Format.setMantissaSigned" (showCons x1))

d_OP_setMantissaSigned_dot_uscore_hash_selFP8_hash_bP :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_setMantissaSigned_dot_uscore_hash_selFP8_hash_bP x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_setMantissaSigned_dot_uscore_hash_selFP8_hash_bP l cd cs)
    (d_OP_setMantissaSigned_dot_uscore_hash_selFP8_hash_bP r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_setMantissaSigned_dot_uscore_hash_selFP8_hash_bP z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_setMantissaSigned_dot_uscore_hash_selFP8_hash_bP e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Format.setMantissaSigned._#selFP8#bP" [show x1] info)
  _ -> failCons cd (consFail "Data.Format.setMantissaSigned._#selFP8#bP"
    (showCons x1))

d_OP_setMantissaSigned_dot_uscore_hash_selFP9_hash_aP :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_setMantissaSigned_dot_uscore_hash_selFP9_hash_aP x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_setMantissaSigned_dot_uscore_hash_selFP9_hash_aP l cd cs)
    (d_OP_setMantissaSigned_dot_uscore_hash_selFP9_hash_aP r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_setMantissaSigned_dot_uscore_hash_selFP9_hash_aP z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_setMantissaSigned_dot_uscore_hash_selFP9_hash_aP e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Format.setMantissaSigned._#selFP9#aP" [show x1] info)
  _ -> failCons cd (consFail "Data.Format.setMantissaSigned._#selFP9#aP"
    (showCons x1))

d_C_getExponent :: C_Floater -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_getExponent x1 cd cs = case x1 of
  C_Floater x2 x3 x4 x5 -> x5
  Choice_C_Floater d i l r -> narrow d i (d_C_getExponent l cd cs)
    (d_C_getExponent r cd cs)
  Choices_C_Floater d i xs -> narrows cs d i (\z -> d_C_getExponent z cd cs) xs
  Guard_C_Floater d c e -> guardCons d c ((\x -> d_C_getExponent e cd x) $!
    addCs c cs)
  Fail_C_Floater d info -> failCons d (traceFail "Data.Format.getExponent" [show
    x1] info)
  _ -> failCons cd (consFail "Data.Format.getExponent" (showCons x1))

d_C_setExponent :: C_Floater -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> C_Floater
d_C_setExponent x1 x2 cd cs = case x1 of
  C_Floater x3 x4 x5 x6 -> C_Floater x3 x4 x5 x2
  Choice_C_Floater d i l r -> narrow d i (d_C_setExponent l x2 cd cs)
    (d_C_setExponent r x2 cd cs)
  Choices_C_Floater d i xs -> narrows cs d i (\z -> d_C_setExponent z x2 cd cs)
    xs
  Guard_C_Floater d c e -> guardCons d c ((\x -> d_C_setExponent e x2 cd x) $!
    addCs c cs)
  Fail_C_Floater d info -> failCons d (traceFail "Data.Format.setExponent" [show
    x1, show x2] info)
  _ -> failCons cd (consFail "Data.Format.setExponent" (showCons x1))

d_C_showExponent :: C_Floater -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_showExponent x1 cd cs = case x1 of
  C_Floater x2 x3 x4 x5 -> let x6 = Curry_Prelude.d_C_apply
                                 (d_C_consistentShowInt cd cs) x5 cd cs
    in d_C__case_40 x5 x6 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x5 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_negate_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (10)) cd cs) cd cs) cd cs
  Choice_C_Floater d i l r -> narrow d i (d_C_showExponent l cd cs)
    (d_C_showExponent r cd cs)
  Choices_C_Floater d i xs -> narrows cs d i (\z -> d_C_showExponent z cd cs) xs
  Guard_C_Floater d c e -> guardCons d c ((\x -> d_C_showExponent e cd x) $!
    addCs c cs)
  Fail_C_Floater d info -> failCons d (traceFail "Data.Format.showExponent"
    [show x1] info)
  _ -> failCons cd (consFail "Data.Format.showExponent" (showCons x1))

d_C_eliminateExponent :: C_Floater -> Cover -> ConstStore -> C_Floater
d_C_eliminateExponent x1 cd cs = case x1 of
  C_Floater x2 x3 x4 x5 -> d_C__case_37 x5 x3 x4 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x5 (Curry_Prelude.C_Int (0)) cd cs) cd cs
  Choice_C_Floater d i l r -> narrow d i (d_C_eliminateExponent l cd cs)
    (d_C_eliminateExponent r cd cs)
  Choices_C_Floater d i xs -> narrows cs d i (\z -> d_C_eliminateExponent z cd
    cs) xs
  Guard_C_Floater d c e -> guardCons d c ((\x -> d_C_eliminateExponent e cd
    x) $! addCs c cs)
  Fail_C_Floater d info -> failCons d (traceFail "Data.Format.eliminateExponent"
    [show x1] info)
  _ -> failCons cd (consFail "Data.Format.eliminateExponent" (showCons x1))

d_C_onePrePoint :: C_Floater -> Cover -> ConstStore -> C_Floater
d_C_onePrePoint x1 cd cs = case x1 of
  C_Floater x2 x3 x4 x5 -> d_C__case_32 x4 x3 x5 x2 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "0") cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x4 Curry_Prelude.OP_List cd cs) cd cs) cd cs
  Choice_C_Floater d i l r -> narrow d i (d_C_onePrePoint l cd cs)
    (d_C_onePrePoint r cd cs)
  Choices_C_Floater d i xs -> narrows cs d i (\z -> d_C_onePrePoint z cd cs) xs
  Guard_C_Floater d c e -> guardCons d c ((\x -> d_C_onePrePoint e cd x) $!
    addCs c cs)
  Fail_C_Floater d info -> failCons d (traceFail "Data.Format.onePrePoint" [show
    x1] info)
  _ -> failCons cd (consFail "Data.Format.onePrePoint" (showCons x1))

d_C_roundFloater :: Curry_Prelude.C_Int -> C_Floater -> Cover -> ConstStore
  -> C_Floater
d_C_roundFloater x1 x2 cd cs = case x2 of
  C_Floater x3 x4 x5 x6 -> d_C__case_28 x1 x5 x6 x4 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_C_length x5 cd cs) x1 cd cs) cd cs
  Choice_C_Floater d i l r -> narrow d i (d_C_roundFloater x1 l cd cs)
    (d_C_roundFloater x1 r cd cs)
  Choices_C_Floater d i xs -> narrows cs d i (\z -> d_C_roundFloater x1 z cd cs)
    xs
  Guard_C_Floater d c e -> guardCons d c ((\x -> d_C_roundFloater x1 e cd x) $!
    addCs c cs)
  Fail_C_Floater d info -> failCons d (traceFail "Data.Format.roundFloater"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Format.roundFloater" (showCons x2))

d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_Prelude.C_Bool
d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172 x1 x2 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List x2
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_26 x3 x4 x2 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172 l x2 cd cs)
    (d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172 r x2 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172 z x2 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172 e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.Format.roundFloater.roundBigEndianStrUp.172" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Format.roundFloater.roundBigEndianStrUp.172"
    (showCons x1))

d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172_dot_uscore_hash_selFP11_hash_rs :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172_dot_uscore_hash_selFP11_hash_rs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172_dot_uscore_hash_selFP11_hash_rs
    l cd cs)
    (d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172_dot_uscore_hash_selFP11_hash_rs
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172_dot_uscore_hash_selFP11_hash_rs
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172_dot_uscore_hash_selFP11_hash_rs
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Format.roundFloater.roundBigEndianStrUp.172._#selFP11#rs" [show x1]
    info)
  _ -> failCons cd (consFail
    "Data.Format.roundFloater.roundBigEndianStrUp.172._#selFP11#rs" (showCons
    x1))

d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172_dot_uscore_hash_selFP12_hash_overflow :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172_dot_uscore_hash_selFP12_hash_overflow x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172_dot_uscore_hash_selFP12_hash_overflow
    l cd cs)
    (d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172_dot_uscore_hash_selFP12_hash_overflow
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172_dot_uscore_hash_selFP12_hash_overflow
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172_dot_uscore_hash_selFP12_hash_overflow
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Format.roundFloater.roundBigEndianStrUp.172._#selFP12#overflow" [show
    x1] info)
  _ -> failCons cd (consFail
    "Data.Format.roundFloater.roundBigEndianStrUp.172._#selFP12#overflow"
    (showCons x1))

d_OP_roundFloater_dot_roundStringUp_dot_172 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Bool
d_OP_roundFloater_dot_roundStringUp_dot_172 x1 cd cs =
  let x2 = d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172
        (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_reverse cd cs) x1 cd cs)
        Curry_Prelude.C_True cd cs
      x3 = d_OP_roundFloater_dot_roundStringUp_dot_172_dot_uscore_hash_selFP14_hash_res
        x2 cd cs
      x4 = d_OP_roundFloater_dot_roundStringUp_dot_172_dot_uscore_hash_selFP15_hash_overflow
        x2 cd cs
  in Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_reverse
  cd cs) x3 cd cs) x4

d_OP_roundFloater_dot_roundStringUp_dot_172_dot_uscore_hash_selFP14_hash_res :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_roundFloater_dot_roundStringUp_dot_172_dot_uscore_hash_selFP14_hash_res x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_roundFloater_dot_roundStringUp_dot_172_dot_uscore_hash_selFP14_hash_res
    l cd cs)
    (d_OP_roundFloater_dot_roundStringUp_dot_172_dot_uscore_hash_selFP14_hash_res
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_roundFloater_dot_roundStringUp_dot_172_dot_uscore_hash_selFP14_hash_res
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_roundFloater_dot_roundStringUp_dot_172_dot_uscore_hash_selFP14_hash_res
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Format.roundFloater.roundStringUp.172._#selFP14#res" [show x1] info)
  _ -> failCons cd (consFail
    "Data.Format.roundFloater.roundStringUp.172._#selFP14#res" (showCons x1))

d_OP_roundFloater_dot_roundStringUp_dot_172_dot_uscore_hash_selFP15_hash_overflow :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_roundFloater_dot_roundStringUp_dot_172_dot_uscore_hash_selFP15_hash_overflow x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_roundFloater_dot_roundStringUp_dot_172_dot_uscore_hash_selFP15_hash_overflow
    l cd cs)
    (d_OP_roundFloater_dot_roundStringUp_dot_172_dot_uscore_hash_selFP15_hash_overflow
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_roundFloater_dot_roundStringUp_dot_172_dot_uscore_hash_selFP15_hash_overflow
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_roundFloater_dot_roundStringUp_dot_172_dot_uscore_hash_selFP15_hash_overflow
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Format.roundFloater.roundStringUp.172._#selFP15#overflow" [show x1]
    info)
  _ -> failCons cd (consFail
    "Data.Format.roundFloater.roundStringUp.172._#selFP15#overflow" (showCons
    x1))

d_OP_roundFloater_dot_roundUp_dot_172 :: C_Floater -> Cover -> ConstStore
  -> C_Floater
d_OP_roundFloater_dot_roundUp_dot_172 x1 cd cs = case x1 of
  C_Floater x2 x3 x4 x5 -> let x6 = d_OP_roundFloater_dot_roundStringUp_dot_172
                                 x4 cd cs
                               x7 = d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP20_hash_m2Result
                                 x6 cd cs
                               x8 = d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP21_hash_m2Overflow
                                 x6 cd cs
                               x9 = d_C__case_24 x3 x8 cd cs
                               x10 = d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP18_hash_m1Rounded
                                 x9 cd cs
                               x11 = d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP19_hash_m1Overflow
                                 x9 cd cs
                               x12 = d_C__case_23 x10 x11 cd cs
    in C_Floater x2 x12 x7 x5
  Choice_C_Floater d i l r -> narrow d i (d_OP_roundFloater_dot_roundUp_dot_172
    l cd cs) (d_OP_roundFloater_dot_roundUp_dot_172 r cd cs)
  Choices_C_Floater d i xs -> narrows cs d i (\z ->
    d_OP_roundFloater_dot_roundUp_dot_172 z cd cs) xs
  Guard_C_Floater d c e -> guardCons d c ((\x ->
    d_OP_roundFloater_dot_roundUp_dot_172 e cd x) $! addCs c cs)
  Fail_C_Floater d info -> failCons d (traceFail
    "Data.Format.roundFloater.roundUp.172" [show x1] info)
  _ -> failCons cd (consFail "Data.Format.roundFloater.roundUp.172" (showCons
    x1))

d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP20_hash_m2Result :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP20_hash_m2Result x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP20_hash_m2Result
    l cd cs)
    (d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP20_hash_m2Result
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP20_hash_m2Result
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP20_hash_m2Result
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Format.roundFloater.roundUp.172._#selFP20#m2Result" [show x1] info)
  _ -> failCons cd (consFail
    "Data.Format.roundFloater.roundUp.172._#selFP20#m2Result" (showCons x1))

d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP21_hash_m2Overflow :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP21_hash_m2Overflow x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP21_hash_m2Overflow
    l cd cs)
    (d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP21_hash_m2Overflow
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP21_hash_m2Overflow
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP21_hash_m2Overflow
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Format.roundFloater.roundUp.172._#selFP21#m2Overflow" [show x1] info)
  _ -> failCons cd (consFail
    "Data.Format.roundFloater.roundUp.172._#selFP21#m2Overflow" (showCons x1))

d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP18_hash_m1Rounded :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP18_hash_m1Rounded x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP18_hash_m1Rounded
    l cd cs)
    (d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP18_hash_m1Rounded
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP18_hash_m1Rounded
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP18_hash_m1Rounded
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Format.roundFloater.roundUp.172._#selFP18#m1Rounded" [show x1] info)
  _ -> failCons cd (consFail
    "Data.Format.roundFloater.roundUp.172._#selFP18#m1Rounded" (showCons x1))

d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP19_hash_m1Overflow :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP19_hash_m1Overflow x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP19_hash_m1Overflow
    l cd cs)
    (d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP19_hash_m1Overflow
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP19_hash_m1Overflow
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_roundFloater_dot_roundUp_dot_172_dot_uscore_hash_selFP19_hash_m1Overflow
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Format.roundFloater.roundUp.172._#selFP19#m1Overflow" [show x1] info)
  _ -> failCons cd (consFail
    "Data.Format.roundFloater.roundUp.172._#selFP19#m1Overflow" (showCons x1))

d_C_getMinusFlag :: C_Flags -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_getMinusFlag x1 cd cs = case x1 of
  C_Flags x2 x3 x4 x5 x6 -> x2
  Choice_C_Flags d i l r -> narrow d i (d_C_getMinusFlag l cd cs)
    (d_C_getMinusFlag r cd cs)
  Choices_C_Flags d i xs -> narrows cs d i (\z -> d_C_getMinusFlag z cd cs) xs
  Guard_C_Flags d c e -> guardCons d c ((\x -> d_C_getMinusFlag e cd x) $! addCs
    c cs)
  Fail_C_Flags d info -> failCons d (traceFail "Data.Format.getMinusFlag" [show
    x1] info)
  _ -> failCons cd (consFail "Data.Format.getMinusFlag" (showCons x1))

d_C_getPlusFlag :: C_Flags -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_getPlusFlag x1 cd cs = case x1 of
  C_Flags x2 x3 x4 x5 x6 -> x3
  Choice_C_Flags d i l r -> narrow d i (d_C_getPlusFlag l cd cs)
    (d_C_getPlusFlag r cd cs)
  Choices_C_Flags d i xs -> narrows cs d i (\z -> d_C_getPlusFlag z cd cs) xs
  Guard_C_Flags d c e -> guardCons d c ((\x -> d_C_getPlusFlag e cd x) $! addCs
    c cs)
  Fail_C_Flags d info -> failCons d (traceFail "Data.Format.getPlusFlag" [show
    x1] info)
  _ -> failCons cd (consFail "Data.Format.getPlusFlag" (showCons x1))

d_C_getZeroFlag :: C_Flags -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_getZeroFlag x1 cd cs = case x1 of
  C_Flags x2 x3 x4 x5 x6 -> x4
  Choice_C_Flags d i l r -> narrow d i (d_C_getZeroFlag l cd cs)
    (d_C_getZeroFlag r cd cs)
  Choices_C_Flags d i xs -> narrows cs d i (\z -> d_C_getZeroFlag z cd cs) xs
  Guard_C_Flags d c e -> guardCons d c ((\x -> d_C_getZeroFlag e cd x) $! addCs
    c cs)
  Fail_C_Flags d info -> failCons d (traceFail "Data.Format.getZeroFlag" [show
    x1] info)
  _ -> failCons cd (consFail "Data.Format.getZeroFlag" (showCons x1))

d_C_getSpaceFlag :: C_Flags -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_getSpaceFlag x1 cd cs = case x1 of
  C_Flags x2 x3 x4 x5 x6 -> x5
  Choice_C_Flags d i l r -> narrow d i (d_C_getSpaceFlag l cd cs)
    (d_C_getSpaceFlag r cd cs)
  Choices_C_Flags d i xs -> narrows cs d i (\z -> d_C_getSpaceFlag z cd cs) xs
  Guard_C_Flags d c e -> guardCons d c ((\x -> d_C_getSpaceFlag e cd x) $! addCs
    c cs)
  Fail_C_Flags d info -> failCons d (traceFail "Data.Format.getSpaceFlag" [show
    x1] info)
  _ -> failCons cd (consFail "Data.Format.getSpaceFlag" (showCons x1))

d_C_getHashFlag :: C_Flags -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_getHashFlag x1 cd cs = case x1 of
  C_Flags x2 x3 x4 x5 x6 -> x6
  Choice_C_Flags d i l r -> narrow d i (d_C_getHashFlag l cd cs)
    (d_C_getHashFlag r cd cs)
  Choices_C_Flags d i xs -> narrows cs d i (\z -> d_C_getHashFlag z cd cs) xs
  Guard_C_Flags d c e -> guardCons d c ((\x -> d_C_getHashFlag e cd x) $! addCs
    c cs)
  Fail_C_Flags d info -> failCons d (traceFail "Data.Format.getHashFlag" [show
    x1] info)
  _ -> failCons cd (consFail "Data.Format.getHashFlag" (showCons x1))

d_C_convertFlags :: Cover -> ConstStore -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> C_Flags
d_C_convertFlags cd cs = Curry_Prelude.d_C_maybe (C_Flags Curry_Prelude.C_False
  Curry_Prelude.C_False Curry_Prelude.C_False Curry_Prelude.C_False
  Curry_Prelude.C_False) (d_OP_convertFlags_dot_convFlags_dot_223 (C_Flags
  Curry_Prelude.C_False Curry_Prelude.C_False Curry_Prelude.C_False
  Curry_Prelude.C_False Curry_Prelude.C_False))

d_OP_convertFlags_dot_convFlags_dot_223 :: C_Flags -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> C_Flags
d_OP_convertFlags_dot_convFlags_dot_223 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> x1
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_22 x3 x4 x1 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_convertFlags_dot_convFlags_dot_223 x1 l cd cs)
    (d_OP_convertFlags_dot_convFlags_dot_223 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_convertFlags_dot_convFlags_dot_223 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_convertFlags_dot_convFlags_dot_223 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.Format.convertFlags.convFlags.223" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Format.convertFlags.convFlags.223" (showCons
    x2))

d_C_convertWidth :: Cover -> ConstStore -> Curry_Prelude.C_Maybe
  Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_convertWidth cd cs = Curry_Prelude.d_C_maybe (Curry_Prelude.C_Int (0))
  Curry_Prelude.d_C_id

d_C_convertPrecision :: Cover -> ConstStore -> Curry_Prelude.C_Maybe
  Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_convertPrecision cd cs = Curry_Prelude.d_C_maybe (Curry_Prelude.C_Int (1))
  Curry_Prelude.d_C_id

d_C_fillWithCharsLeftAlign :: Cover -> ConstStore -> Curry_Prelude.C_Int
  -> Cover -> ConstStore -> Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_fillWithCharsLeftAlign cd cs = acceptCs (acceptCs id) (d_C_fillWithChars
  C_LeftAlign)

d_C_fillWithCharsRightAlign :: Cover -> ConstStore -> Curry_Prelude.C_Int
  -> Cover -> ConstStore -> Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_fillWithCharsRightAlign cd cs = acceptCs (acceptCs id) (d_C_fillWithChars
  C_RightAlign)

d_C_fillWithChars :: C_Alignment -> Curry_Prelude.C_Int -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_fillWithChars x1 x2 x3 x4 cd cs =
  let x5 = Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
        x2 (Curry_Prelude.d_C_length x4 cd cs) cd cs
  in d_C__case_16 x5 x4 x1 x3 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) x5 cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs

d_C_consistentShowInt :: Cover -> ConstStore -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_consistentShowInt cd cs = Curry_Prelude.d_OP_dot (d_C_showWithoutParantheses
  (Curry_Prelude.C_Char '('#) (Curry_Prelude.C_Char ')'#))
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
  cd cs) cd cs

d_C_consistentShowFloat :: Cover -> ConstStore -> Curry_Prelude.C_Float -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_consistentShowFloat cd cs = Curry_Prelude.d_OP_dot
  (d_C_showWithoutParantheses (Curry_Prelude.C_Char '('#) (Curry_Prelude.C_Char
  ')'#))
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Float_hash
  cd cs) cd cs

d_C_showWithoutParantheses :: Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showWithoutParantheses x1 x2 x3 cd cs = let x4 = Curry_Prelude.d_C_length x3
                                                  cd cs
  in d_C__case_14 x4 x3 x2 x1 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) x4 cd cs) (Curry_Prelude.C_Int (2)) cd cs) cd cs

d_OP_showWithoutParantheses_dot_uscore_hash_selFP26_hash_h :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_showWithoutParantheses_dot_uscore_hash_selFP26_hash_h x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_showWithoutParantheses_dot_uscore_hash_selFP26_hash_h l cd cs)
    (d_OP_showWithoutParantheses_dot_uscore_hash_selFP26_hash_h r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_showWithoutParantheses_dot_uscore_hash_selFP26_hash_h z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_showWithoutParantheses_dot_uscore_hash_selFP26_hash_h e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Format.showWithoutParantheses._#selFP26#h" [show x1] info)
  _ -> failCons cd (consFail "Data.Format.showWithoutParantheses._#selFP26#h"
    (showCons x1))

d_OP_showWithoutParantheses_dot_uscore_hash_selFP27_hash_t :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_showWithoutParantheses_dot_uscore_hash_selFP27_hash_t x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_showWithoutParantheses_dot_uscore_hash_selFP27_hash_t l cd cs)
    (d_OP_showWithoutParantheses_dot_uscore_hash_selFP27_hash_t r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_showWithoutParantheses_dot_uscore_hash_selFP27_hash_t z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_showWithoutParantheses_dot_uscore_hash_selFP27_hash_t e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Format.showWithoutParantheses._#selFP27#t" [show x1] info)
  _ -> failCons cd (consFail "Data.Format.showWithoutParantheses._#selFP27#t"
    (showCons x1))

d_OP_showWithoutParantheses_dot_uscore_hash_selFP24_hash_r :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_showWithoutParantheses_dot_uscore_hash_selFP24_hash_r x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_showWithoutParantheses_dot_uscore_hash_selFP24_hash_r l cd cs)
    (d_OP_showWithoutParantheses_dot_uscore_hash_selFP24_hash_r r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_showWithoutParantheses_dot_uscore_hash_selFP24_hash_r z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_showWithoutParantheses_dot_uscore_hash_selFP24_hash_r e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Format.showWithoutParantheses._#selFP24#r" [show x1] info)
  _ -> failCons cd (consFail "Data.Format.showWithoutParantheses._#selFP24#r"
    (showCons x1))

d_OP_showWithoutParantheses_dot_uscore_hash_selFP25_hash_l :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_showWithoutParantheses_dot_uscore_hash_selFP25_hash_l x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_showWithoutParantheses_dot_uscore_hash_selFP25_hash_l l cd cs)
    (d_OP_showWithoutParantheses_dot_uscore_hash_selFP25_hash_l r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_showWithoutParantheses_dot_uscore_hash_selFP25_hash_l z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_showWithoutParantheses_dot_uscore_hash_selFP25_hash_l e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Format.showWithoutParantheses._#selFP25#l" [show x1] info)
  _ -> failCons cd (consFail "Data.Format.showWithoutParantheses._#selFP25#l"
    (showCons x1))

d_C_showIntAsOct :: Cover -> ConstStore -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showIntAsOct cd cs = d_C_convertToBase (Curry_Prelude.C_Int (8))

d_C_showIntAsHex :: Cover -> ConstStore -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showIntAsHex cd cs = d_C_convertToBase (Curry_Prelude.C_Int (16))

d_C_convertToBase :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_convertToBase x1 x2 cd cs = d_C__case_12 x1 x2 (Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) x1 cd cs) (Curry_Prelude.C_Int (2)) cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
  cd cs) x1 cd cs) (Curry_Prelude.C_Int (16)) cd cs) cd cs) cd cs

d_OP_convertToBase_dot_cTB_dot_266 :: Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_convertToBase_dot_cTB_dot_266 x1 x2 x3 x4 cd cs = d_C__case_8 x4 x3 x1 x2
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  x4 (Curry_Prelude.C_Int (0)) cd cs) cd cs

d_C_bitNot :: Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_bitNot x1 cd cs = d_OP_bitNot_dot_aux_dot_289
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
  (Curry_Prelude.C_Int (32)) x1 cd cs

d_OP_bitNot_dot_aux_dot_289 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Integral t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Num t1) -> t1 -> t0 -> Cover
  -> ConstStore -> t0
d_OP_bitNot_dot_aux_dot_289 x1 x2 x3 x4 x5 cd cs = d_C__case_0 x3 x4 x1 x2 x5
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq x1
  cd cs) x4 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_fromInt x3 cd cs)
  (Curry_Prelude.C_Int (0)) cd cs) cd cs) cd cs

nd_OP_bitNot_dot_aux_dot_289 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Integral t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Num t1) -> t1 -> t0 -> IDSupply -> Cover
  -> ConstStore -> t0
nd_OP_bitNot_dot_aux_dot_289 x1 x2 x3 x4 x5 s cd cs = let s10 = s
  in s10 `seq` (let s9 = leftSupply s10
                    s7 = rightSupply s10
  in s9 `seq` (s7 `seq` nd_C__case_0 x3 x4 x1 x2 x5 (let s6 = leftSupply s7
                                                         s8 = rightSupply s7
                                                         s2 = leftSupply s8
                                                         s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s2 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq x1
  s0 cd cs) x4 s1 cd cs)) (let s4 = leftSupply s5
                               s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_fromInt x3
  s3 cd cs) (Curry_Prelude.C_Int (0)) s4 cd cs)) s6 cd cs)))) s9 cd cs))

nd_C__case_82 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Sign
  -> C_Floater -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_82 x6 x5 x4 x3 x2 s cd cs = case x2 of
  C_Floater x7 x8 x9 x10 -> let s6 = s
    in s6 `seq` (let s2 = leftSupply s6
                     s5 = rightSupply s6
    in s2 `seq` (s5 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_amp_amp
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Format_dot_Sign_hash
    x3 x7 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x4 x8 s0 cd cs) cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Char_hash)
    x5 x9 s1 cd cs) cd cs)) (let s4 = leftSupply s5
                                 s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs)) x6 s3 cd cs) x10 s4 cd cs)) cd cs))
  Choice_C_Floater d i l r -> narrow d i (nd_C__case_82 x6 x5 x4 x3 l s cd cs)
    (nd_C__case_82 x6 x5 x4 x3 r s cd cs)
  Choices_C_Floater d i xs -> narrows cs d i (\z -> nd_C__case_82 x6 x5 x4 x3 z
    s cd cs) xs
  Guard_C_Floater d c e -> guardCons d c ((\x -> nd_C__case_82 x6 x5 x4 x3 e s
    cd x) $! addCs c cs)
  Fail_C_Floater d info -> failCons d (traceFail "Data.Format._case_82" [show x6
    , show x5, show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Data.Format._case_82" (showCons x2))

d_C__case_80 :: C_Sign -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_80 x2 cd cs = case x2 of
  C_Positive -> Curry_Prelude.C_False
  C_Negative -> Curry_Prelude.C_True
  Choice_C_Sign d i l r -> narrow d i (d_C__case_80 l cd cs) (d_C__case_80 r cd
    cs)
  Choices_C_Sign d i xs -> narrows cs d i (\z -> d_C__case_80 z cd cs) xs
  Guard_C_Sign d c e -> guardCons d c ((\x -> d_C__case_80 e cd x) $! addCs c
    cs)
  Fail_C_Sign d info -> failCons d (traceFail "Data.Format._case_80" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Format._case_80" (showCons x2))

d_C__case_81 :: C_Sign -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_81 x2 cd cs = case x2 of
  C_Positive -> Curry_Prelude.C_True
  C_Negative -> Curry_Prelude.C_False
  Choice_C_Sign d i l r -> narrow d i (d_C__case_81 l cd cs) (d_C__case_81 r cd
    cs)
  Choices_C_Sign d i xs -> narrows cs d i (\z -> d_C__case_81 z cd cs) xs
  Guard_C_Sign d c e -> guardCons d c ((\x -> d_C__case_81 e cd x) $! addCs c
    cs)
  Fail_C_Sign d info -> failCons d (traceFail "Data.Format._case_81" [show x2]
    info)
  _ -> failCons cd (consFail "Data.Format._case_81" (showCons x2))

d_C__case_79 :: Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> C_Flags -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_79 x7 x6 x5 x4 x3 x2 cd cs = case x2 of
  C_Flags x8 x9 x10 x11 x12 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
    x3 x8 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
    x4 x9 cd cs) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
    x5 x10 cd cs) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
    x6 x11 cd cs) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Bool_hash
    x7 x12 cd cs) cd cs
  Choice_C_Flags d i l r -> narrow d i (d_C__case_79 x7 x6 x5 x4 x3 l cd cs)
    (d_C__case_79 x7 x6 x5 x4 x3 r cd cs)
  Choices_C_Flags d i xs -> narrows cs d i (\z -> d_C__case_79 x7 x6 x5 x4 x3 z
    cd cs) xs
  Guard_C_Flags d c e -> guardCons d c ((\x -> d_C__case_79 x7 x6 x5 x4 x3 e cd
    x) $! addCs c cs)
  Fail_C_Flags d info -> failCons d (traceFail "Data.Format._case_79" [show x7
    , show x6, show x5, show x4, show x3, show x2] info)
  _ -> failCons cd (consFail "Data.Format._case_79" (showCons x2))

d_C__case_77 :: C_Alignment -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_77 x2 cd cs = case x2 of
  C_LeftAlign -> Curry_Prelude.C_False
  C_RightAlign -> Curry_Prelude.C_True
  Choice_C_Alignment d i l r -> narrow d i (d_C__case_77 l cd cs) (d_C__case_77
    r cd cs)
  Choices_C_Alignment d i xs -> narrows cs d i (\z -> d_C__case_77 z cd cs) xs
  Guard_C_Alignment d c e -> guardCons d c ((\x -> d_C__case_77 e cd x) $! addCs
    c cs)
  Fail_C_Alignment d info -> failCons d (traceFail "Data.Format._case_77" [show
    x2] info)
  _ -> failCons cd (consFail "Data.Format._case_77" (showCons x2))

d_C__case_78 :: C_Alignment -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_78 x2 cd cs = case x2 of
  C_LeftAlign -> Curry_Prelude.C_True
  C_RightAlign -> Curry_Prelude.C_False
  Choice_C_Alignment d i l r -> narrow d i (d_C__case_78 l cd cs) (d_C__case_78
    r cd cs)
  Choices_C_Alignment d i xs -> narrows cs d i (\z -> d_C__case_78 z cd cs) xs
  Guard_C_Alignment d c e -> guardCons d c ((\x -> d_C__case_78 e cd x) $! addCs
    c cs)
  Fail_C_Alignment d info -> failCons d (traceFail "Data.Format._case_78" [show
    x2] info)
  _ -> failCons cd (consFail "Data.Format._case_78" (showCons x2))

d_C__case_75 :: C_Alignment -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_75 x2 cd cs = case x2 of
  C_LeftAlign -> Curry_Prelude.C_False
  C_RightAlign -> Curry_Prelude.C_True
  Choice_C_Alignment d i l r -> narrow d i (d_C__case_75 l cd cs) (d_C__case_75
    r cd cs)
  Choices_C_Alignment d i xs -> narrows cs d i (\z -> d_C__case_75 z cd cs) xs
  Guard_C_Alignment d c e -> guardCons d c ((\x -> d_C__case_75 e cd x) $! addCs
    c cs)
  Fail_C_Alignment d info -> failCons d (traceFail "Data.Format._case_75" [show
    x2] info)
  _ -> failCons cd (consFail "Data.Format._case_75" (showCons x2))

d_C__case_76 :: C_Alignment -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_76 x2 cd cs = case x2 of
  C_LeftAlign -> Curry_Prelude.C_True
  C_RightAlign -> Curry_Prelude.C_False
  Choice_C_Alignment d i l r -> narrow d i (d_C__case_76 l cd cs) (d_C__case_76
    r cd cs)
  Choices_C_Alignment d i xs -> narrows cs d i (\z -> d_C__case_76 z cd cs) xs
  Guard_C_Alignment d c e -> guardCons d c ((\x -> d_C__case_76 e cd x) $! addCs
    c cs)
  Fail_C_Alignment d info -> failCons d (traceFail "Data.Format._case_76" [show
    x2] info)
  _ -> failCons cd (consFail "Data.Format._case_76" (showCons x2))

d_C__case_74 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_74 x9 x7 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (d_C_fillWithCharsLeftAlign cd cs) x7 cd cs)
    (Curry_Prelude.C_Char ' '#) cd cs) x9 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (d_C_fillWithCharsRightAlign cd cs) x7 cd cs)
    (Curry_Prelude.C_Char ' '#) cd cs) x9 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_74 x9 x7 l cd cs)
    (d_C__case_74 x9 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_74 x9
    x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_74 x9 x7 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_74" [show x9, show x7, show x8] info)
  _ -> failCons cd (consFail "Data.Format._case_74" (showCons x8))

d_C__case_59 :: Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_59 x11 x16 x17 x13 x22 x23 cd cs = case x23 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) x22
  Curry_Prelude.C_False -> x22
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_59 x11 x16 x17
    x13 x22 l cd cs) (d_C__case_59 x11 x16 x17 x13 x22 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_59 x11
    x16 x17 x13 x22 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_59 x11 x16
    x17 x13 x22 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_59" [show x11, show x16, show x17, show x13, show x22
    , show x23] info)
  _ -> failCons cd (consFail "Data.Format._case_59" (showCons x23))

d_C__case_63 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_63 x5 x14 x17 x21 x1 x22 cd cs = case x22 of
  Curry_Prelude.C_True -> d_C__case_62 x1 x21
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char 'o'#) cd cs) cd cs
  Curry_Prelude.C_False -> x21
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_63 x5 x14 x17 x21
    x1 l cd cs) (d_C__case_63 x5 x14 x17 x21 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_63 x5
    x14 x17 x21 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_63 x5 x14
    x17 x21 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_63" [show x5, show x14, show x17, show x21, show x1, show
    x22] info)
  _ -> failCons cd (consFail "Data.Format._case_63" (showCons x22))

d_C__case_62 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_62 x1 x21 x22 cd cs = case x22 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '0'#) x21
  Curry_Prelude.C_False -> d_C__case_61 x1 x21
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char 'x'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_62 x1 x21 l cd
    cs) (d_C__case_62 x1 x21 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_62 x1
    x21 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_62 x1 x21
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_62" [show x1, show x21, show x22] info)
  _ -> failCons cd (consFail "Data.Format._case_62" (showCons x22))

d_C__case_61 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_61 x1 x21 x22 cd cs = case x22 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '0'#)
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'x'#) x21)
  Curry_Prelude.C_False -> d_C__case_60 x1 x21
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char 'X'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_61 x1 x21 l cd
    cs) (d_C__case_61 x1 x21 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_61 x1
    x21 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_61 x1 x21
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_61" [show x1, show x21, show x22] info)
  _ -> failCons cd (consFail "Data.Format._case_61" (showCons x22))

d_C__case_60 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_60 x1 x21 x22 cd cs = case x22 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '0'#)
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'X'#) x21)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_60 x1 x21 l cd
    cs) (d_C__case_60 x1 x21 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_60 x1
    x21 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_60 x1 x21
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_60" [show x1, show x21, show x22] info)
  _ -> failCons cd (consFail "Data.Format._case_60" (showCons x22))

d_C__case_64 :: Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_64 x16 x17 x11 x20 x21 cd cs = case x21 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '+'#) x20
  Curry_Prelude.C_False -> x20
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_64 x16 x17 x11
    x20 l cd cs) (d_C__case_64 x16 x17 x11 x20 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_64 x16
    x17 x11 x20 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_64 x16 x17
    x11 x20 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_64" [show x16, show x17, show x11, show x20, show x21]
    info)
  _ -> failCons cd (consFail "Data.Format._case_64" (showCons x21))

d_C__case_65 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_65 x19 x16 cd cs = case x16 of
  Curry_Prelude.C_True -> x19
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '-'#) x19
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_65 x19 l cd cs)
    (d_C__case_65 x19 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_65 x19
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_65 x19 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_65" [show x19, show x16] info)
  _ -> failCons cd (consFail "Data.Format._case_65" (showCons x16))

d_C__case_66 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_66 x15 x16 cd cs = case x16 of
  Curry_Prelude.C_True -> x15
  Curry_Prelude.C_False -> Curry_Prelude.d_C_tail x15 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_66 x15 l cd cs)
    (d_C__case_66 x15 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_66 x15
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_66 x15 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_66" [show x15, show x16] info)
  _ -> failCons cd (consFail "Data.Format._case_66" (showCons x16))

d_C__case_71 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_71 x1 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (d_C_consistentShowInt cd cs)
    x5 cd cs
  Curry_Prelude.C_False -> d_C__case_70 x1 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char 'd'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_71 x1 x5 l cd cs)
    (d_C__case_71 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_71 x1
    x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_71 x1 x5 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_71" [show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "Data.Format._case_71" (showCons x6))

d_C__case_70 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_70 x1 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (d_C_consistentShowInt cd cs)
    x5 cd cs
  Curry_Prelude.C_False -> d_C__case_69 x1 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char 'o'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_70 x1 x5 l cd cs)
    (d_C__case_70 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_70 x1
    x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_70 x1 x5 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_70" [show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "Data.Format._case_70" (showCons x6))

d_C__case_69 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_69 x1 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (d_C_showIntAsOct cd cs) x5 cd
    cs
  Curry_Prelude.C_False -> d_C__case_68 x1 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char 'x'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_69 x1 x5 l cd cs)
    (d_C__case_69 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_69 x1
    x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_69 x1 x5 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_69" [show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "Data.Format._case_69" (showCons x6))

d_C__case_68 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_68 x1 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (d_C_showIntAsHex cd cs) x5 cd
    cs
  Curry_Prelude.C_False -> d_C__case_67 x1 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char 'X'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_68 x1 x5 l cd cs)
    (d_C__case_68 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_68 x1
    x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_68 x1 x5 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_68" [show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "Data.Format._case_68" (showCons x6))

d_C__case_67 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_67 x1 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_map Data.Curry_Char.d_C_toUpper
    (Curry_Prelude.d_C_apply (d_C_showIntAsHex cd cs) x5 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_67 x1 x5 l cd cs)
    (d_C__case_67 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_67 x1
    x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_67 x1 x5 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_67" [show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "Data.Format._case_67" (showCons x6))

d_C__case_73 :: Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_73 x9 x12 x23 x7 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (d_C_fillWithCharsLeftAlign cd cs) x7 cd cs)
    (Curry_Prelude.C_Char ' '#) cd cs) x23 cd cs
  Curry_Prelude.C_False -> let x24 = d_C__case_72 x9 x12
                                 (Curry_Prelude.d_OP_amp_amp x12
                                 (Curry_Prelude.d_C_not x9 cd cs) cd cs) cd cs
    in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (d_C_fillWithCharsRightAlign cd cs) x7 cd cs) x24 cd cs) x23 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_73 x9 x12 x23 x7
    l cd cs) (d_C__case_73 x9 x12 x23 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_73 x9
    x12 x23 x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_73 x9 x12
    x23 x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_73" [show x9, show x12, show x23, show x7, show x10]
    info)
  _ -> failCons cd (consFail "Data.Format._case_73" (showCons x10))

d_C__case_72 :: Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_Char
d_C__case_72 x9 x12 x13 cd cs = case x13 of
  Curry_Prelude.C_True -> Curry_Prelude.C_Char '0'#
  Curry_Prelude.C_False -> Curry_Prelude.C_Char ' '#
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_72 x9 x12 l cd
    cs) (d_C__case_72 x9 x12 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_72 x9
    x12 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_72 x9 x12
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_72" [show x9, show x12, show x13] info)
  _ -> failCons cd (consFail "Data.Format._case_72" (showCons x13))

d_C__case_49 :: Curry_Prelude.C_Char -> C_Floater -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_49 x1 x20 x21 cd cs = case x21 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (d_C_getMantissaBeforePoint x20 cd cs) (d_C_getMantissaAfterPoint x20 cd cs)
    cd cs
  Curry_Prelude.C_False -> d_C__case_48 x1 x20
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char 'e'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_49 x1 x20 l cd
    cs) (d_C__case_49 x1 x20 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_49 x1
    x20 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_49 x1 x20
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_49" [show x1, show x20, show x21] info)
  _ -> failCons cd (consFail "Data.Format._case_49" (showCons x21))

d_C__case_48 :: Curry_Prelude.C_Char -> C_Floater -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_48 x1 x20 x21 cd cs = case x21 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (d_C_getMantissaBeforePoint x20 cd cs) (Curry_Prelude.d_OP_plus_plus
    (d_C_getMantissaAfterPoint x20 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "e") (d_C_showExponent x20 cd cs) cd cs) cd cs)
    cd cs
  Curry_Prelude.C_False -> d_C__case_47 x1 x20
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char 'E'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_48 x1 x20 l cd
    cs) (d_C__case_48 x1 x20 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_48 x1
    x20 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_48 x1 x20
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_48" [show x1, show x20, show x21] info)
  _ -> failCons cd (consFail "Data.Format._case_48" (showCons x21))

d_C__case_47 :: Curry_Prelude.C_Char -> C_Floater -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_47 x1 x20 x21 cd cs = case x21 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (d_C_getMantissaBeforePoint x20 cd cs) (Curry_Prelude.d_OP_plus_plus
    (d_C_getMantissaAfterPoint x20 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "E") (d_C_showExponent x20 cd cs) cd cs) cd cs)
    cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_47 x1 x20 l cd
    cs) (d_C__case_47 x1 x20 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_47 x1
    x20 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_47 x1 x20
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_47" [show x1, show x20, show x21] info)
  _ -> failCons cd (consFail "Data.Format._case_47" (showCons x21))

d_C__case_51 :: Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> C_Floater -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Floater
d_C__case_51 x14 x10 x12 x19 x20 cd cs = case x20 of
  Curry_Prelude.C_True -> d_C_setMantissaBeforePoint x19 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char ' '#) (d_C_getMantissaBeforePoint x19 cd cs)) cd cs
  Curry_Prelude.C_False -> d_C__case_50 x14 x19 (Curry_Prelude.d_C_not x14 cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_51 x14 x10 x12
    x19 l cd cs) (d_C__case_51 x14 x10 x12 x19 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_51 x14
    x10 x12 x19 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_51 x14 x10
    x12 x19 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_51" [show x14, show x10, show x12, show x19, show x20]
    info)
  _ -> failCons cd (consFail "Data.Format._case_51" (showCons x20))

d_C__case_50 :: Curry_Prelude.C_Bool -> C_Floater -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> C_Floater
d_C__case_50 x14 x19 x20 cd cs = case x20 of
  Curry_Prelude.C_True -> d_C_setMantissaBeforePoint x19 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '-'#) (d_C_getMantissaBeforePoint x19 cd cs)) cd cs
  Curry_Prelude.C_False -> x19
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_50 x14 x19 l cd
    cs) (d_C__case_50 x14 x19 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_50 x14
    x19 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_50 x14 x19
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_50" [show x14, show x19, show x20] info)
  _ -> failCons cd (consFail "Data.Format._case_50" (showCons x20))

d_C__case_52 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> C_Floater
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Floater
d_C__case_52 x8 x13 x18 x19 cd cs = case x19 of
  Curry_Prelude.C_True -> d_C_setMantissaAfterPoint x18 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '.'#) (d_C_getMantissaAfterPoint x18 cd cs)) cd cs
  Curry_Prelude.C_False -> x18
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_52 x8 x13 x18 l
    cd cs) (d_C__case_52 x8 x13 x18 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_52 x8
    x13 x18 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_52 x8 x13
    x18 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_52" [show x8, show x13, show x18, show x19] info)
  _ -> failCons cd (consFail "Data.Format._case_52" (showCons x19))

d_C__case_53 :: Curry_Prelude.C_Float -> Curry_Prelude.C_Bool -> C_Floater
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Floater
d_C__case_53 x5 x10 x17 x18 cd cs = case x18 of
  Curry_Prelude.C_True -> d_C_setMantissaBeforePoint x17 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '+'#) (d_C_getMantissaBeforePoint x17 cd cs)) cd cs
  Curry_Prelude.C_False -> x17
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_53 x5 x10 x17 l
    cd cs) (d_C__case_53 x5 x10 x17 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_53 x5
    x10 x17 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_53 x5 x10
    x17 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_53" [show x5, show x10, show x17, show x18] info)
  _ -> failCons cd (consFail "Data.Format._case_53" (showCons x18))

d_C__case_56 :: Curry_Prelude.C_Char -> C_Floater -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> C_Floater
d_C__case_56 x1 x15 x16 cd cs = case x16 of
  Curry_Prelude.C_True -> d_C_eliminateExponent x15 cd cs
  Curry_Prelude.C_False -> d_C__case_55 x1 x15
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char 'e'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_56 x1 x15 l cd
    cs) (d_C__case_56 x1 x15 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_56 x1
    x15 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_56 x1 x15
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_56" [show x1, show x15, show x16] info)
  _ -> failCons cd (consFail "Data.Format._case_56" (showCons x16))

d_C__case_55 :: Curry_Prelude.C_Char -> C_Floater -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> C_Floater
d_C__case_55 x1 x15 x16 cd cs = case x16 of
  Curry_Prelude.C_True -> d_C_onePrePoint x15 cd cs
  Curry_Prelude.C_False -> d_C__case_54 x1 x15
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x1 (Curry_Prelude.C_Char 'E'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_55 x1 x15 l cd
    cs) (d_C__case_55 x1 x15 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_55 x1
    x15 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_55 x1 x15
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_55" [show x1, show x15, show x16] info)
  _ -> failCons cd (consFail "Data.Format._case_55" (showCons x16))

d_C__case_54 :: Curry_Prelude.C_Char -> C_Floater -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> C_Floater
d_C__case_54 x1 x15 x16 cd cs = case x16 of
  Curry_Prelude.C_True -> d_C_onePrePoint x15 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_54 x1 x15 l cd
    cs) (d_C__case_54 x1 x15 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_54 x1
    x15 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_54 x1 x15
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_54" [show x1, show x15, show x16] info)
  _ -> failCons cd (consFail "Data.Format._case_54" (showCons x16))

d_C__case_58 :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_58 x11 x21 x7 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (d_C_fillWithCharsLeftAlign cd cs) x7 cd cs)
    (Curry_Prelude.C_Char ' '#) cd cs) x21 cd cs
  Curry_Prelude.C_False -> let x22 = d_C__case_57 x11 cd cs
    in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (d_C_fillWithCharsRightAlign cd cs) x7 cd cs) x22 cd cs) x21 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_58 x11 x21 x7 l
    cd cs) (d_C__case_58 x11 x21 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_58 x11
    x21 x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_58 x11 x21
    x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_58" [show x11, show x21, show x7, show x9] info)
  _ -> failCons cd (consFail "Data.Format._case_58" (showCons x9))

d_C__case_57 :: Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_Char
d_C__case_57 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> Curry_Prelude.C_Char '0'#
  Curry_Prelude.C_False -> Curry_Prelude.C_Char ' '#
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_57 l cd cs)
    (d_C__case_57 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_57 z cd
    cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_57 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_57" [show x11] info)
  _ -> failCons cd (consFail "Data.Format._case_57" (showCons x11))

d_C__case_46 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_46 x9 x7 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (d_C_fillWithCharsLeftAlign cd cs) x7 cd cs)
    (Curry_Prelude.C_Char ' '#) cd cs) x9 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (d_C_fillWithCharsRightAlign cd cs) x7 cd cs)
    (Curry_Prelude.C_Char ' '#) cd cs) x9 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_46 x9 x7 l cd cs)
    (d_C__case_46 x9 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_46 x9
    x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_46 x9 x7 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_46" [show x9, show x7, show x8] info)
  _ -> failCons cd (consFail "Data.Format._case_46" (showCons x8))

d_C__case_45 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Floater
d_C__case_45 x4 x3 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> d_C_floaterCreator x3 (Curry_Prelude.C_Int (0)) cd cs
  Curry_Prelude.C_False -> d_C_floaterCreator x3 (d_C__case_44 x4
    (Curry_Numeric.d_C_readInt (Curry_Prelude.d_C_tail x4 cd cs) cd cs) cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_45 x4 x3 l cd cs)
    (d_C__case_45 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_45 x4
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_45 x4 x3 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_45" [show x4, show x3, show x5] info)
  _ -> failCons cd (consFail "Data.Format._case_45" (showCons x5))

d_C__case_44 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_C__case_44 x4 x7 cd cs = case x7 of
  Curry_Prelude.OP_Cons x5 x6 -> d_C__case_43 x6 x5 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_44 x4 l cd cs)
    (d_C__case_44 x4 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_44 x4
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_44 x4 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.Format._case_44" [show x4, show x7] info)
  _ -> failCons cd (consFail "Data.Format._case_44" (showCons x7))

d_C__case_43 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C__case_43 x6 x5 cd cs = case x5 of
  Curry_Prelude.OP_Tuple2 x7 x8 -> d_C__case_42 x7 x6 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_43 x6 l cd cs)
    (d_C__case_43 x6 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_43
    x6 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_43 x6 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Format._case_43" [show x6, show x5] info)
  _ -> failCons cd (consFail "Data.Format._case_43" (showCons x5))

d_C__case_42 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C__case_42 x7 x6 cd cs = case x6 of
  Curry_Prelude.OP_List -> x7
  Curry_Prelude.OP_Cons x9 x10 -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_42 x7 l cd cs)
    (d_C__case_42 x7 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_42 x7
    z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_42 x7 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.Format._case_42" [show x7, show x6] info)
  _ -> failCons cd (consFail "Data.Format._case_42" (showCons x6))

d_C__case_41 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Floater
d_C__case_41 x8 x6 x9 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> C_Floater C_Negative (Curry_Prelude.d_C_tail x8 cd cs)
    (Curry_Prelude.d_C_tail x9 cd cs) x6
  Curry_Prelude.C_False -> C_Floater C_Positive x8 (Curry_Prelude.d_C_tail x9 cd
    cs) x6
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_41 x8 x6 x9 l cd
    cs) (d_C__case_41 x8 x6 x9 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_41 x8
    x6 x9 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_41 x8 x6
    x9 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_41" [show x8, show x6, show x9, show x10] info)
  _ -> failCons cd (consFail "Data.Format._case_41" (showCons x10))

d_C__case_40 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_40 x5 x6 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> x6
  Curry_Prelude.C_False -> d_C__case_39 x5 x6 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x5 cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_40 x5 x6 l cd cs)
    (d_C__case_40 x5 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_40 x5
    x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_40 x5 x6 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_40" [show x5, show x6, show x7] info)
  _ -> failCons cd (consFail "Data.Format._case_40" (showCons x7))

d_C__case_39 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_39 x5 x6 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '-'#)
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '0'#) (Curry_Prelude.d_C_tail
    x6 cd cs))
  Curry_Prelude.C_False -> d_C__case_38 x5 x6 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x5 cd cs) (Curry_Prelude.C_Int (10)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_39 x5 x6 l cd cs)
    (d_C__case_39 x5 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_39 x5
    x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_39 x5 x6 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_39" [show x5, show x6, show x7] info)
  _ -> failCons cd (consFail "Data.Format._case_39" (showCons x7))

d_C__case_38 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_38 x5 x6 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '+'#)
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '0'#) x6)
  Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '+'#) x6
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_38 x5 x6 l cd cs)
    (d_C__case_38 x5 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_38 x5
    x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_38 x5 x6 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_38" [show x5, show x6, show x7] info)
  _ -> failCons cd (consFail "Data.Format._case_38" (showCons x7))

d_C__case_37 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Sign
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Floater
d_C__case_37 x5 x3 x4 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> C_Floater x2 x3 x4 x5
  Curry_Prelude.C_False -> d_C__case_36 x5 x3 x4 x2 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x5 cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_37 x5 x3 x4 x2 l
    cd cs) (d_C__case_37 x5 x3 x4 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_37 x5
    x3 x4 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_37 x5 x3
    x4 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_37" [show x5, show x3, show x4, show x2, show x6] info)
  _ -> failCons cd (consFail "Data.Format._case_37" (showCons x6))

d_C__case_36 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Sign
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Floater
d_C__case_36 x5 x3 x4 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C__case_35 x4 x5 x3 x2 (Curry_Prelude.d_C_null x4 cd
    cs) cd cs
  Curry_Prelude.C_False -> d_C__case_34 x5 x3 x4 x2 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x5 cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_36 x5 x3 x4 x2 l
    cd cs) (d_C__case_36 x5 x3 x4 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_36 x5
    x3 x4 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_36 x5 x3
    x4 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_36" [show x5, show x3, show x4, show x2, show x6] info)
  _ -> failCons cd (consFail "Data.Format._case_36" (showCons x6))

d_C__case_34 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Sign
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Floater
d_C__case_34 x5 x3 x4 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C__case_33 x3 x5 x4 x2 (Curry_Prelude.d_C_null x3 cd
    cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_34 x5 x3 x4 x2 l
    cd cs) (d_C__case_34 x5 x3 x4 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_34 x5
    x3 x4 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_34 x5 x3
    x4 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_34" [show x5, show x3, show x4, show x2, show x6] info)
  _ -> failCons cd (consFail "Data.Format._case_34" (showCons x6))

d_C__case_33 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Sign
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Floater
d_C__case_33 x3 x5 x4 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_eliminateExponent (C_Floater x2
    Curry_Prelude.OP_List (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "0") x4 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x5 (Curry_Prelude.C_Int (1)) cd cs)) cd cs
  Curry_Prelude.C_False -> d_C_eliminateExponent (C_Floater x2
    (Data.Curry_List.d_C_init x3 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.OP_Cons (Data.Curry_List.d_C_last x3 cd cs)
    Curry_Prelude.OP_List) x4 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x5 (Curry_Prelude.C_Int (1)) cd cs)) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_33 x3 x5 x4 x2 l
    cd cs) (d_C__case_33 x3 x5 x4 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_33 x3
    x5 x4 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_33 x3 x5
    x4 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_33" [show x3, show x5, show x4, show x2, show x6] info)
  _ -> failCons cd (consFail "Data.Format._case_33" (showCons x6))

d_C__case_35 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Sign
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Floater
d_C__case_35 x4 x5 x3 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_eliminateExponent (C_Floater x2
    (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.toCurryString "0") cd cs)
    Curry_Prelude.OP_List
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x5 (Curry_Prelude.C_Int (1)) cd cs)) cd cs
  Curry_Prelude.C_False -> d_C_eliminateExponent (C_Floater x2
    (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.OP_Cons
    (Curry_Prelude.d_C_head x4 cd cs) Curry_Prelude.OP_List) cd cs)
    (Curry_Prelude.d_C_tail x4 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x5 (Curry_Prelude.C_Int (1)) cd cs)) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_35 x4 x5 x3 x2 l
    cd cs) (d_C__case_35 x4 x5 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_35 x4
    x5 x3 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_35 x4 x5
    x3 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_35" [show x4, show x5, show x3, show x2, show x6] info)
  _ -> failCons cd (consFail "Data.Format._case_35" (showCons x6))

d_C__case_32 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> C_Sign
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Floater
d_C__case_32 x4 x3 x5 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> C_Floater x2 x3 x4 x5
  Curry_Prelude.C_False -> d_C__case_31 x4 x3 x5 x2 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.toCurryString "0") cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    cd cs) x4 cd cs) Curry_Prelude.OP_List cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_32 x4 x3 x5 x2 l
    cd cs) (d_C__case_32 x4 x3 x5 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_32 x4
    x3 x5 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_32 x4 x3
    x5 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_32" [show x4, show x3, show x5, show x2, show x6] info)
  _ -> failCons cd (consFail "Data.Format._case_32" (showCons x6))

d_C__case_31 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> C_Sign
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Floater
d_C__case_31 x4 x3 x5 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_onePrePoint (C_Floater x2 (Curry_Prelude.OP_Cons
    (Curry_Prelude.d_C_head x4 cd cs) Curry_Prelude.OP_List)
    (Curry_Prelude.d_C_tail x4 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x5 (Curry_Prelude.C_Int (1)) cd cs)) cd cs
  Curry_Prelude.C_False -> d_C__case_30 x3 x5 x4 x2 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    cd cs) x3 cd cs) (Curry_Prelude.toCurryString "0") cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    (Curry_Prelude.d_C_length x3 cd cs) (Curry_Prelude.C_Int (1)) cd cs) cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_31 x4 x3 x5 x2 l
    cd cs) (d_C__case_31 x4 x3 x5 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_31 x4
    x3 x5 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_31 x4 x3
    x5 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_31" [show x4, show x3, show x5, show x2, show x6] info)
  _ -> failCons cd (consFail "Data.Format._case_31" (showCons x6))

d_C__case_30 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Sign
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Floater
d_C__case_30 x3 x5 x4 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> C_Floater x2 x3 x4 x5
  Curry_Prelude.C_False -> d_C__case_29 x3 x5 x4 x2 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    cd cs) x3 cd cs) (Curry_Prelude.toCurryString "0") cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_eq_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Curry_Prelude.d_C_length x3 cd cs) cd cs) (Curry_Prelude.C_Int (1))
    cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_30 x3 x5 x4 x2 l
    cd cs) (d_C__case_30 x3 x5 x4 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_30 x3
    x5 x4 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_30 x3 x5
    x4 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_30" [show x3, show x5, show x4, show x2, show x6] info)
  _ -> failCons cd (consFail "Data.Format._case_30" (showCons x6))

d_C__case_29 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Sign
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Floater
d_C__case_29 x3 x5 x4 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_onePrePoint (C_Floater x2
    (Data.Curry_List.d_C_init x3 cd cs) (Curry_Prelude.OP_Cons
    (Data.Curry_List.d_C_last x3 cd cs) x4)
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x5 (Curry_Prelude.C_Int (1)) cd cs)) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_29 x3 x5 x4 x2 l
    cd cs) (d_C__case_29 x3 x5 x4 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_29 x3
    x5 x4 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_29 x3 x5
    x4 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_29" [show x3, show x5, show x4, show x2, show x6] info)
  _ -> failCons cd (consFail "Data.Format._case_29" (showCons x6))

d_C__case_28 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_Sign -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> C_Floater
d_C__case_28 x1 x5 x6 x4 x3 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> C_Floater x3 x4 (Curry_Prelude.d_OP_plus_plus x5
    (Curry_Prelude.d_C_replicate
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x1 (Curry_Prelude.d_C_length x5 cd cs) cd cs) (Curry_Prelude.C_Char '0'#) cd
    cs) cd cs) x6
  Curry_Prelude.C_False -> d_C__case_27 x1 x5 x6 x4 x3 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) (Data.Curry_Char.d_C_digitToInt (Curry_Prelude.d_OP_bang_bang x5 x1
    cd cs) cd cs) cd cs) (Curry_Prelude.C_Int (5)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_28 x1 x5 x6 x4 x3
    l cd cs) (d_C__case_28 x1 x5 x6 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_28 x1
    x5 x6 x4 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_28 x1 x5
    x6 x4 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_28" [show x1, show x5, show x6, show x4, show x3, show
    x7] info)
  _ -> failCons cd (consFail "Data.Format._case_28" (showCons x7))

d_C__case_27 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_Sign -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> C_Floater
d_C__case_27 x1 x5 x6 x4 x3 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> C_Floater x3 x4 (Curry_Prelude.d_C_take x1 x5 cd cs)
    x6
  Curry_Prelude.C_False -> d_OP_roundFloater_dot_roundUp_dot_172 (C_Floater x3
    x4 (Curry_Prelude.d_C_take x1 x5 cd cs) x6) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_27 x1 x5 x6 x4 x3
    l cd cs) (d_C__case_27 x1 x5 x6 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_27 x1
    x5 x6 x4 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_27 x1 x5
    x6 x4 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_27" [show x1, show x5, show x6, show x4, show x3, show
    x7] info)
  _ -> failCons cd (consFail "Data.Format._case_27" (showCons x7))

d_C__case_26 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_Prelude.C_Bool
d_C__case_26 x3 x4 x2 cd cs = case x2 of
  Curry_Prelude.C_False -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons x3 x4)
    Curry_Prelude.C_False
  Curry_Prelude.C_True -> let x5 = Data.Curry_Char.d_C_digitToInt x3 cd cs
    in d_C__case_25 x5 x4
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x5 (Curry_Prelude.C_Int (9)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_26 x3 x4 l cd cs)
    (d_C__case_26 x3 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_26 x3
    x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_26 x3 x4 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_26" [show x3, show x4, show x2] info)
  _ -> failCons cd (consFail "Data.Format._case_26" (showCons x2))

d_C__case_25 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  Curry_Prelude.C_Bool
d_C__case_25 x5 x4 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> let x6 = d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172
                                x4 Curry_Prelude.C_True cd cs
                              x7 = d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172_dot_uscore_hash_selFP11_hash_rs
                                x6 cd cs
                              x8 = d_OP_roundFloater_dot_roundBigEndianStrUp_dot_172_dot_uscore_hash_selFP12_hash_overflow
                                x6 cd cs
    in Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char
    '0'#) x7) x8
  Curry_Prelude.C_False -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x5 (Curry_Prelude.C_Int (1)) cd cs) cd cs) x4 cd cs) Curry_Prelude.C_False
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_25 x5 x4 l cd cs)
    (d_C__case_25 x5 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_25 x5
    x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_25 x5 x4 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_25" [show x5, show x4, show x9] info)
  _ -> failCons cd (consFail "Data.Format._case_25" (showCons x9))

d_C__case_23 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_23 x10 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "1") x10 cd cs
  Curry_Prelude.C_False -> x10
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_23 x10 l cd cs)
    (d_C__case_23 x10 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_23 x10
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_23 x10 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_23" [show x10, show x11] info)
  _ -> failCons cd (consFail "Data.Format._case_23" (showCons x11))

d_C__case_24 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_Prelude.C_Bool
d_C__case_24 x3 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_OP_roundFloater_dot_roundStringUp_dot_172 x3 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.OP_Tuple2 x3 Curry_Prelude.C_False
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_24 x3 l cd cs)
    (d_C__case_24 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_24 x3 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_24 x3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_24" [show x3, show x8] info)
  _ -> failCons cd (consFail "Data.Format._case_24" (showCons x8))

d_C__case_22 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_Flags -> Cover -> ConstStore -> C_Flags
d_C__case_22 x3 x4 x1 cd cs = case x1 of
  C_Flags x5 x6 x7 x8 x9 -> d_C__case_21 x3 x4 x8 x7 x6 x5 x9
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.C_Char '-'#) cd cs) cd cs
  Choice_C_Flags d i l r -> narrow d i (d_C__case_22 x3 x4 l cd cs)
    (d_C__case_22 x3 x4 r cd cs)
  Choices_C_Flags d i xs -> narrows cs d i (\z -> d_C__case_22 x3 x4 z cd cs) xs
  Guard_C_Flags d c e -> guardCons d c ((\x -> d_C__case_22 x3 x4 e cd x) $!
    addCs c cs)
  Fail_C_Flags d info -> failCons d (traceFail "Data.Format._case_22" [show x3
    , show x4, show x1] info)
  _ -> failCons cd (consFail "Data.Format._case_22" (showCons x1))

d_C__case_21 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Flags
d_C__case_21 x3 x4 x8 x7 x6 x5 x9 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> d_OP_convertFlags_dot_convFlags_dot_223 (C_Flags
    Curry_Prelude.C_True x6 x7 x8 x9) x4 cd cs
  Curry_Prelude.C_False -> d_C__case_20 x3 x4 x8 x7 x6 x5 x9
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.C_Char '+'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_21 x3 x4 x8 x7 x6
    x5 x9 l cd cs) (d_C__case_21 x3 x4 x8 x7 x6 x5 x9 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_21 x3
    x4 x8 x7 x6 x5 x9 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_21 x3 x4
    x8 x7 x6 x5 x9 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_21" [show x3, show x4, show x8, show x7, show x6, show x5
    , show x9, show x10] info)
  _ -> failCons cd (consFail "Data.Format._case_21" (showCons x10))

d_C__case_20 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Flags
d_C__case_20 x3 x4 x8 x7 x6 x5 x9 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> d_OP_convertFlags_dot_convFlags_dot_223 (C_Flags x5
    Curry_Prelude.C_True x7 x8 x9) x4 cd cs
  Curry_Prelude.C_False -> d_C__case_19 x3 x4 x8 x7 x6 x5 x9
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.C_Char '0'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_20 x3 x4 x8 x7 x6
    x5 x9 l cd cs) (d_C__case_20 x3 x4 x8 x7 x6 x5 x9 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_20 x3
    x4 x8 x7 x6 x5 x9 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_20 x3 x4
    x8 x7 x6 x5 x9 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_20" [show x3, show x4, show x8, show x7, show x6, show x5
    , show x9, show x10] info)
  _ -> failCons cd (consFail "Data.Format._case_20" (showCons x10))

d_C__case_19 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Flags
d_C__case_19 x3 x4 x8 x7 x6 x5 x9 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> d_OP_convertFlags_dot_convFlags_dot_223 (C_Flags x5 x6
    Curry_Prelude.C_True x8 x9) x4 cd cs
  Curry_Prelude.C_False -> d_C__case_18 x3 x4 x8 x7 x6 x5 x9
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.C_Char ' '#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_19 x3 x4 x8 x7 x6
    x5 x9 l cd cs) (d_C__case_19 x3 x4 x8 x7 x6 x5 x9 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_19 x3
    x4 x8 x7 x6 x5 x9 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_19 x3 x4
    x8 x7 x6 x5 x9 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_19" [show x3, show x4, show x8, show x7, show x6, show x5
    , show x9, show x10] info)
  _ -> failCons cd (consFail "Data.Format._case_19" (showCons x10))

d_C__case_18 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Flags
d_C__case_18 x3 x4 x8 x7 x6 x5 x9 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> d_OP_convertFlags_dot_convFlags_dot_223 (C_Flags x5 x6
    x7 Curry_Prelude.C_True x9) x4 cd cs
  Curry_Prelude.C_False -> d_C__case_17 x3 x4 x8 x7 x6 x5
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    x3 (Curry_Prelude.C_Char '#'#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_18 x3 x4 x8 x7 x6
    x5 x9 l cd cs) (d_C__case_18 x3 x4 x8 x7 x6 x5 x9 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_18 x3
    x4 x8 x7 x6 x5 x9 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_18 x3 x4
    x8 x7 x6 x5 x9 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_18" [show x3, show x4, show x8, show x7, show x6, show x5
    , show x9, show x10] info)
  _ -> failCons cd (consFail "Data.Format._case_18" (showCons x10))

d_C__case_17 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> C_Flags
d_C__case_17 x3 x4 x8 x7 x6 x5 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> d_OP_convertFlags_dot_convFlags_dot_223 (C_Flags x5 x6
    x7 x8 Curry_Prelude.C_True) x4 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_17 x3 x4 x8 x7 x6
    x5 l cd cs) (d_C__case_17 x3 x4 x8 x7 x6 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_17 x3
    x4 x8 x7 x6 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_17 x3 x4
    x8 x7 x6 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_17" [show x3, show x4, show x8, show x7, show x6, show x5
    , show x9] info)
  _ -> failCons cd (consFail "Data.Format._case_17" (showCons x9))

d_C__case_16 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> C_Alignment -> Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_16 x5 x4 x1 x3 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C__case_15 x1 x3 x5 x4
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Format_dot_Alignment_hash
    x1 C_RightAlign cd cs) cd cs
  Curry_Prelude.C_False -> x4
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_16 x5 x4 x1 x3 l
    cd cs) (d_C__case_16 x5 x4 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_16 x5
    x4 x1 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_16 x5 x4
    x1 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_16" [show x5, show x4, show x1, show x3, show x6] info)
  _ -> failCons cd (consFail "Data.Format._case_16" (showCons x6))

d_C__case_15 :: C_Alignment -> Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_15 x1 x3 x5 x4 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_replicate x5 x3 cd cs) x4 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_plus_plus x4
    (Curry_Prelude.d_C_replicate x5 x3 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_15 x1 x3 x5 x4 l
    cd cs) (d_C__case_15 x1 x3 x5 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_15 x1
    x3 x5 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_15 x1 x3
    x5 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_15" [show x1, show x3, show x5, show x4, show x6] info)
  _ -> failCons cd (consFail "Data.Format._case_15" (showCons x6))

d_C__case_14 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_14 x4 x3 x2 x1 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> let x5 = Curry_Prelude.d_C_splitAt
                                (Curry_Prelude.C_Int (1)) x3 cd cs
                              x6 = d_OP_showWithoutParantheses_dot_uscore_hash_selFP26_hash_h
                                x5 cd cs
                              x7 = d_OP_showWithoutParantheses_dot_uscore_hash_selFP27_hash_t
                                x5 cd cs
                              x8 = Curry_Prelude.d_C_splitAt
                                (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
                                x4 (Curry_Prelude.C_Int (2)) cd cs) x7 cd cs
                              x9 = d_OP_showWithoutParantheses_dot_uscore_hash_selFP24_hash_r
                                x8 cd cs
                              x10 = d_OP_showWithoutParantheses_dot_uscore_hash_selFP25_hash_l
                                x8 cd cs
    in d_C__case_13 x2 x10 x1 x6 x3 x9 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_head x6 cd cs) x1 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char_hash
    (Curry_Prelude.d_C_head x10 cd cs) x2 cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> x3
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_14 x4 x3 x2 x1 l
    cd cs) (d_C__case_14 x4 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_14 x4
    x3 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_14 x4 x3
    x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_14" [show x4, show x3, show x2, show x1, show x11] info)
  _ -> failCons cd (consFail "Data.Format._case_14" (showCons x11))

d_C__case_13 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_13 x2 x10 x1 x6 x3 x9 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> x9
  Curry_Prelude.C_False -> x3
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_13 x2 x10 x1 x6
    x3 x9 l cd cs) (d_C__case_13 x2 x10 x1 x6 x3 x9 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_13 x2
    x10 x1 x6 x3 x9 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_13 x2 x10
    x1 x6 x3 x9 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_13" [show x2, show x10, show x1, show x6, show x3, show
    x9, show x11] info)
  _ -> failCons cd (consFail "Data.Format._case_13" (showCons x11))

d_C__case_12 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_12 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_error
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "Can't handle base ") (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x1 cd cs) (Curry_Prelude.toCurryString
    ". Can only handle bases between 2 and 16.") cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_11 x2 x1 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_negate_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    (Curry_Prelude.C_Int (2147483647)) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_12 x1 x2 l cd cs)
    (d_C__case_12 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_12 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_12 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_12" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Format._case_12" (showCons x3))

d_C__case_11 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_11 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_error
    (Curry_Prelude.toCurryString "Can only handle integers geq -2147483648.") cd
    cs
  Curry_Prelude.C_False -> d_C__case_10 x2 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x2 (Curry_Prelude.C_Int (0)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_11 x2 x1 l cd cs)
    (d_C__case_11 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_11 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_11 x2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_11" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "Data.Format._case_11" (showCons x3))

d_C__case_10 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_10 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "0"
  Curry_Prelude.C_False -> d_C__case_9 x2 x1 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs) x2 cd cs) (Curry_Prelude.C_Int (0)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_10 x2 x1 l cd cs)
    (d_C__case_10 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_10 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_10 x2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_10" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "Data.Format._case_10" (showCons x3))

d_C__case_9 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_9 x2 x1 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> let x3 = d_C_bitNot
                                (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
                                (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
                                x2
                                (Curry_Prelude.d_OP_uscore_impl_hash_negate_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
                                (Curry_Prelude.C_Int (1)) cd cs) cd cs)
                                (Curry_Prelude.C_Int (1)) cd cs) cd cs
    in d_OP_convertToBase_dot_cTB_dot_266 x1 Curry_Prelude.OP_List x1 x3 cd cs
  Curry_Prelude.C_False -> d_OP_convertToBase_dot_cTB_dot_266 x1
    Curry_Prelude.OP_List x1 x2 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_9 x2 x1 l cd cs)
    (d_C__case_9 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_9 x2 x1
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_9 x2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_9" [show x2, show x1, show x4] info)
  _ -> failCons cd (consFail "Data.Format._case_9" (showCons x4))

d_C__case_8 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_8 x4 x3 x1 x2 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> x2
  Curry_Prelude.C_False -> let x5 = Curry_Prelude.OP_Tuple2
                                 (Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_OP_uscore_impl_hash_div_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
                                 cd cs) x4 cd cs) x3 cd cs)
                                 (Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_OP_uscore_impl_hash_mod_hash_Prelude_dot_Integral_hash_Prelude_dot_Int_hash
                                 cd cs) x4 cd cs) x3 cd cs)
                               x6 = Curry_Prelude.d_C_fst x5 cd cs
                               x7 = Curry_Prelude.d_C_snd x5 cd cs
                               x8 = d_C__case_7 x7 (Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
                                 cd cs) x7 cd cs) (Curry_Prelude.C_Int (10)) cd
                                 cs) cd cs
    in d_OP_convertToBase_dot_cTB_dot_266 x1 (Curry_Prelude.d_OP_plus_plus x8 x2
    cd cs) x1 x6 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x4 x3 x1 x2 l
    cd cs) (d_C__case_8 x4 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x4 x3
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_8 x4 x3 x1
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_8" [show x4, show x3, show x1, show x2, show x9] info)
  _ -> failCons cd (consFail "Data.Format._case_8" (showCons x9))

d_C__case_7 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_7 x7 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int_hash
    cd cs) x7 cd cs
  Curry_Prelude.C_False -> d_C__case_6 x7
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x7 (Curry_Prelude.C_Int (10)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x7 l cd cs)
    (d_C__case_7 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x7 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_7 x7 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_7" [show x7, show x8] info)
  _ -> failCons cd (consFail "Data.Format._case_7" (showCons x8))

d_C__case_6 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_6 x7 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "a"
  Curry_Prelude.C_False -> d_C__case_5 x7
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x7 (Curry_Prelude.C_Int (11)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x7 l cd cs)
    (d_C__case_6 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x7 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x7 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_6" [show x7, show x8] info)
  _ -> failCons cd (consFail "Data.Format._case_6" (showCons x8))

d_C__case_5 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_5 x7 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "b"
  Curry_Prelude.C_False -> d_C__case_4 x7
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x7 (Curry_Prelude.C_Int (12)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x7 l cd cs)
    (d_C__case_5 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x7 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x7 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_5" [show x7, show x8] info)
  _ -> failCons cd (consFail "Data.Format._case_5" (showCons x8))

d_C__case_4 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_4 x7 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "c"
  Curry_Prelude.C_False -> d_C__case_3 x7
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x7 (Curry_Prelude.C_Int (13)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x7 l cd cs)
    (d_C__case_4 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x7 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x7 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_4" [show x7, show x8] info)
  _ -> failCons cd (consFail "Data.Format._case_4" (showCons x8))

d_C__case_3 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_3 x7 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "d"
  Curry_Prelude.C_False -> d_C__case_2 x7
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x7 (Curry_Prelude.C_Int (14)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x7 l cd cs)
    (d_C__case_3 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x7 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_3 x7 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_3" [show x7, show x8] info)
  _ -> failCons cd (consFail "Data.Format._case_3" (showCons x8))

d_C__case_2 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_2 x7 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "e"
  Curry_Prelude.C_False -> d_C__case_1 x7
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x7 (Curry_Prelude.C_Int (15)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x7 l cd cs)
    (d_C__case_2 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x7 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x7 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_2" [show x7, show x8] info)
  _ -> failCons cd (consFail "Data.Format._case_2" (showCons x8))

d_C__case_1 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_1 x7 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "f"
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x7 l cd cs)
    (d_C__case_1 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x7 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x7 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_1" [show x7, show x8] info)
  _ -> failCons cd (consFail "Data.Format._case_1" (showCons x8))

d_C__case_0 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Num t1) -> t1 -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Integral t0) -> t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> t0
d_C__case_0 x3 x4 x1 x2 x5 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_fromInt
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x2 cd cs) cd cs) cd cs) (Curry_Prelude.C_Int (0)) cd cs
  Curry_Prelude.C_False -> let x6 = Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_OP_star
                                 (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
                                 (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
                                 x2 cd cs) cd cs) cd cs)
                                 (Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_fromInt
                                 (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
                                 (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
                                 x2 cd cs) cd cs) cd cs) (Curry_Prelude.C_Int
                                 (2)) cd cs) cd cs) (d_OP_bitNot_dot_aux_dot_289
                                 x1 x2 x3 (Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_OP_minus x3 cd cs) x4 cd cs)
                                 (Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_fromInt x3 cd cs)
                                 (Curry_Prelude.C_Int (1)) cd cs) cd cs)
                                 (Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_div
                                 x2 cd cs) x5 cd cs) (Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_fromInt
                                 (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
                                 (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
                                 x2 cd cs) cd cs) cd cs) (Curry_Prelude.C_Int
                                 (2)) cd cs) cd cs) cd cs) cd cs
                               x7 = Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_OP_minus
                                 (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
                                 (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
                                 x2 cd cs) cd cs) cd cs)
                                 (Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_fromInt
                                 (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
                                 (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
                                 x2 cd cs) cd cs) cd cs) (Curry_Prelude.C_Int
                                 (1)) cd cs) cd cs) (Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_mod
                                 x2 cd cs) x5 cd cs) (Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_fromInt
                                 (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
                                 (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
                                 x2 cd cs) cd cs) cd cs) (Curry_Prelude.C_Int
                                 (2)) cd cs) cd cs) cd cs
    in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_plus
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x2 cd cs) cd cs) cd cs) x6 cd cs) x7 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x3 x4 x1 x2 x5
    l cd cs) (d_C__case_0 x3 x4 x1 x2 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x3 x4
    x1 x2 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x3 x4 x1
    x2 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_0" [show x3, show x4, show x1, show x2, show x5, show x8]
    info)
  _ -> failCons cd (consFail "Data.Format._case_0" (showCons x8))

nd_C__case_0 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Num t1)
  -> t1 -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Integral t0)
  -> t0 -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> t0
nd_C__case_0 x3 x4 x1 x2 x5 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_fromInt (let s1 = leftSupply s2
                                                          s0 = rightSupply s2
    in s1 `seq` (s0 `seq`
    Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x2 s0 cd cs) s1 cd cs)) s3 cd cs)) (Curry_Prelude.C_Int (0)) s5 cd cs))
  Curry_Prelude.C_False -> let s83 = s
    in s83 `seq` (let s41 = leftSupply s83
                      s84 = rightSupply s83
                      s72 = leftSupply s84
                      s82 = rightSupply s84
    in s41 `seq` (s84 `seq` (s72 `seq` (s82 `seq` (let x6 = let s40 = leftSupply
                                                                  s41
                                                                s42 = rightSupply
                                                                  s41
                                                                s13 = leftSupply
                                                                  s42
                                                                s38 = rightSupply
                                                                  s42
                                                         in s40 `seq` (s42 `seq`
                                                         (s13 `seq` (s38 `seq`
                                                         Curry_Prelude.nd_C_apply
                                                         (let s12 = leftSupply
                                                                s13
                                                              s14 = rightSupply
                                                                s13
                                                              s4 = leftSupply
                                                                s14
                                                              s11 = rightSupply
                                                                s14
                                                         in s12 `seq` (s14 `seq`
                                                         (s4 `seq` (s11 `seq`
                                                         Curry_Prelude.nd_C_apply
                                                         (let s3 = leftSupply s4
                                                              s2 = rightSupply
                                                                s4
                                                         in s3 `seq` (s2 `seq`
                                                         Curry_Prelude.nd_OP_star
                                                         (let s1 = leftSupply s2
                                                              s0 = rightSupply
                                                                s2
                                                         in s1 `seq` (s0 `seq`
                                                         Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
                                                         (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
                                                         x2 s0 cd cs) s1 cd cs))
                                                         s3 cd cs))
                                                         (let s10 = leftSupply
                                                                s11
                                                              s9 = rightSupply
                                                                s11
                                                         in s10 `seq` (s9 `seq`
                                                         Curry_Prelude.nd_C_apply
                                                         (let s8 = leftSupply s9
                                                              s7 = rightSupply
                                                                s9
                                                         in s8 `seq` (s7 `seq`
                                                         Curry_Prelude.nd_C_fromInt
                                                         (let s6 = leftSupply s7
                                                              s5 = rightSupply
                                                                s7
                                                         in s6 `seq` (s5 `seq`
                                                         Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
                                                         (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
                                                         x2 s5 cd cs) s6 cd cs))
                                                         s8 cd cs))
                                                         (Curry_Prelude.C_Int
                                                         (2)) s10 cd cs)) s12 cd
                                                         cs))))
                                                         (let s37 = leftSupply
                                                                s38
                                                              s39 = rightSupply
                                                                s38
                                                              s22 = leftSupply
                                                                s39
                                                              s35 = rightSupply
                                                                s39
                                                         in s37 `seq` (s39 `seq`
                                                         (s22 `seq` (s35 `seq`
                                                         nd_OP_bitNot_dot_aux_dot_289
                                                         x1 x2 x3
                                                         (let s21 = leftSupply
                                                                s22
                                                              s23 = rightSupply
                                                                s22
                                                              s17 = leftSupply
                                                                s23
                                                              s20 = rightSupply
                                                                s23
                                                         in s21 `seq` (s23 `seq`
                                                         (s17 `seq` (s20 `seq`
                                                         Curry_Prelude.nd_C_apply
                                                         (let s16 = leftSupply
                                                                s17
                                                              s15 = rightSupply
                                                                s17
                                                         in s16 `seq` (s15 `seq`
                                                         Curry_Prelude.nd_C_apply
                                                         (Curry_Prelude.nd_OP_minus
                                                         x3 s15 cd cs) x4 s16 cd
                                                         cs))
                                                         (let s19 = leftSupply
                                                                s20
                                                              s18 = rightSupply
                                                                s20
                                                         in s19 `seq` (s18 `seq`
                                                         Curry_Prelude.nd_C_apply
                                                         (Curry_Prelude.nd_C_fromInt
                                                         x3 s18 cd cs)
                                                         (Curry_Prelude.C_Int
                                                         (1)) s19 cd cs)) s21 cd
                                                         cs))))
                                                         (let s34 = leftSupply
                                                                s35
                                                              s36 = rightSupply
                                                                s35
                                                              s26 = leftSupply
                                                                s36
                                                              s33 = rightSupply
                                                                s36
                                                         in s34 `seq` (s36 `seq`
                                                         (s26 `seq` (s33 `seq`
                                                         Curry_Prelude.nd_C_apply
                                                         (let s25 = leftSupply
                                                                s26
                                                              s24 = rightSupply
                                                                s26
                                                         in s25 `seq` (s24 `seq`
                                                         Curry_Prelude.nd_C_apply
                                                         (Curry_Prelude.nd_C_div
                                                         x2 s24 cd cs) x5 s25 cd
                                                         cs))
                                                         (let s32 = leftSupply
                                                                s33
                                                              s31 = rightSupply
                                                                s33
                                                         in s32 `seq` (s31 `seq`
                                                         Curry_Prelude.nd_C_apply
                                                         (let s30 = leftSupply
                                                                s31
                                                              s29 = rightSupply
                                                                s31
                                                         in s30 `seq` (s29 `seq`
                                                         Curry_Prelude.nd_C_fromInt
                                                         (let s28 = leftSupply
                                                                s29
                                                              s27 = rightSupply
                                                                s29
                                                         in s28 `seq` (s27 `seq`
                                                         Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
                                                         (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
                                                         x2 s27 cd cs) s28 cd
                                                         cs)) s30 cd cs))
                                                         (Curry_Prelude.C_Int
                                                         (2)) s32 cd cs)) s34 cd
                                                         cs)))) s37 cd cs))))
                                                         s40 cd cs)))
                                                       x7 = let s71 = leftSupply
                                                                  s72
                                                                s73 = rightSupply
                                                                  s72
                                                                s56 = leftSupply
                                                                  s73
                                                                s69 = rightSupply
                                                                  s73
                                                         in s71 `seq` (s73 `seq`
                                                         (s56 `seq` (s69 `seq`
                                                         Curry_Prelude.nd_C_apply
                                                         (let s55 = leftSupply
                                                                s56
                                                              s57 = rightSupply
                                                                s56
                                                              s47 = leftSupply
                                                                s57
                                                              s54 = rightSupply
                                                                s57
                                                         in s55 `seq` (s57 `seq`
                                                         (s47 `seq` (s54 `seq`
                                                         Curry_Prelude.nd_C_apply
                                                         (let s46 = leftSupply
                                                                s47
                                                              s45 = rightSupply
                                                                s47
                                                         in s46 `seq` (s45 `seq`
                                                         Curry_Prelude.nd_OP_minus
                                                         (let s44 = leftSupply
                                                                s45
                                                              s43 = rightSupply
                                                                s45
                                                         in s44 `seq` (s43 `seq`
                                                         Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
                                                         (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
                                                         x2 s43 cd cs) s44 cd
                                                         cs)) s46 cd cs))
                                                         (let s53 = leftSupply
                                                                s54
                                                              s52 = rightSupply
                                                                s54
                                                         in s53 `seq` (s52 `seq`
                                                         Curry_Prelude.nd_C_apply
                                                         (let s51 = leftSupply
                                                                s52
                                                              s50 = rightSupply
                                                                s52
                                                         in s51 `seq` (s50 `seq`
                                                         Curry_Prelude.nd_C_fromInt
                                                         (let s49 = leftSupply
                                                                s50
                                                              s48 = rightSupply
                                                                s50
                                                         in s49 `seq` (s48 `seq`
                                                         Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
                                                         (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
                                                         x2 s48 cd cs) s49 cd
                                                         cs)) s51 cd cs))
                                                         (Curry_Prelude.C_Int
                                                         (1)) s53 cd cs)) s55 cd
                                                         cs))))
                                                         (let s68 = leftSupply
                                                                s69
                                                              s70 = rightSupply
                                                                s69
                                                              s60 = leftSupply
                                                                s70
                                                              s67 = rightSupply
                                                                s70
                                                         in s68 `seq` (s70 `seq`
                                                         (s60 `seq` (s67 `seq`
                                                         Curry_Prelude.nd_C_apply
                                                         (let s59 = leftSupply
                                                                s60
                                                              s58 = rightSupply
                                                                s60
                                                         in s59 `seq` (s58 `seq`
                                                         Curry_Prelude.nd_C_apply
                                                         (Curry_Prelude.nd_C_mod
                                                         x2 s58 cd cs) x5 s59 cd
                                                         cs))
                                                         (let s66 = leftSupply
                                                                s67
                                                              s65 = rightSupply
                                                                s67
                                                         in s66 `seq` (s65 `seq`
                                                         Curry_Prelude.nd_C_apply
                                                         (let s64 = leftSupply
                                                                s65
                                                              s63 = rightSupply
                                                                s65
                                                         in s64 `seq` (s63 `seq`
                                                         Curry_Prelude.nd_C_fromInt
                                                         (let s62 = leftSupply
                                                                s63
                                                              s61 = rightSupply
                                                                s63
                                                         in s62 `seq` (s61 `seq`
                                                         Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
                                                         (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
                                                         x2 s61 cd cs) s62 cd
                                                         cs)) s64 cd cs))
                                                         (Curry_Prelude.C_Int
                                                         (2)) s66 cd cs)) s68 cd
                                                         cs)))) s71 cd cs)))
    in let s81 = leftSupply s82
           s80 = rightSupply s82
    in s81 `seq` (s80 `seq` Curry_Prelude.nd_C_apply (let s79 = leftSupply s80
                                                          s78 = rightSupply s80
    in s79 `seq` (s78 `seq` Curry_Prelude.nd_C_apply (let s77 = leftSupply s78
                                                          s76 = rightSupply s78
    in s77 `seq` (s76 `seq` Curry_Prelude.nd_OP_plus (let s75 = leftSupply s76
                                                          s74 = rightSupply s76
    in s75 `seq` (s74 `seq`
    Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Real_hash_Prelude_dot_Num_hash_0_hash
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Integral_hash_Prelude_dot_Real_hash_0_hash
    x2 s74 cd cs) s75 cd cs)) s77 cd cs)) x6 s79 cd cs)) x7 s81 cd cs))))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_0 x3 x4 x1 x2 x5
    l s cd cs) (nd_C__case_0 x3 x4 x1 x2 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_0 x3
    x4 x1 x2 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_0 x3 x4
    x1 x2 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.Format._case_0" [show x3, show x4, show x1, show x2, show x5, show x8]
    info)
  _ -> failCons cd (consFail "Data.Format._case_0" (showCons x8))

