{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_RegExp
  ( C_ORegExp (..)
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
  , d_C_eps
  , d_C_literal
  , d_C_alt
  , d_C_conc
  , d_C_rep
  , d_C_pl
  , d_C_anyL
  , d_C_bracket
  , d_C_negBracket
  , d_C_start
  , d_C_end
  , d_C_times
  , d_C_captureG
  , nd_C_grepPos
  , nd_C_grep
  , nd_C_grepShow
  , nd_C_grepShowUnique
  , nd_C_match
  , nd_C_capture )
  where

import Basics
import qualified Control.Search.Curry_Unsafe
import qualified Data.Curry_List
import qualified Curry_Prelude


data C_ORegExp t0
  = C_Nil
  | C_Literal t0
  | C_Xor (Curry_Prelude.OP_List (C_ORegExp t0)) (Curry_Prelude.OP_List
    (C_ORegExp t0))
  | C_Star (Curry_Prelude.OP_List (C_ORegExp t0))
  | C_Plus (Curry_Prelude.OP_List (C_ORegExp t0))
  | C_AnyLiteral
  | C_Bracket (Curry_Prelude.OP_List (Curry_Prelude.C_Either t0
    (Curry_Prelude.OP_Tuple2 t0 t0)))
  | C_NegBracket (Curry_Prelude.OP_List (Curry_Prelude.C_Either t0
    (Curry_Prelude.OP_Tuple2 t0 t0)))
  | C_Start (Curry_Prelude.OP_List (C_ORegExp t0))
  | C_End (Curry_Prelude.OP_List (C_ORegExp t0))
  | C_Times (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_Prelude.C_Int)
    (Curry_Prelude.OP_List (C_ORegExp t0))
  | C_Capture Curry_Prelude.C_Int (Curry_Prelude.OP_List (C_ORegExp t0))
  | Choice_C_ORegExp Cover ID (C_ORegExp t0) (C_ORegExp t0)
  | Choices_C_ORegExp Cover ID [C_ORegExp t0]
  | Fail_C_ORegExp Cover FailInfo
  | Guard_C_ORegExp Cover Constraints (C_ORegExp t0)

instance (Curry t0) => Show (C_ORegExp t0) where
  showsPrec d (Choice_C_ORegExp cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_ORegExp cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_ORegExp cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_ORegExp cd info) = showChar '!'
  showsPrec _ C_Nil = showString "Nil"
  showsPrec _ (C_Literal x1) = showString "(Literal" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_Xor x1 x2) = showString "(Xor" . (showChar ' ' . (shows x1 .
    (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_Star x1) = showString "(Star" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_Plus x1) = showString "(Plus" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ C_AnyLiteral = showString "AnyLiteral"
  showsPrec _ (C_Bracket x1) = showString "(Bracket" . (showChar ' ' . (shows
    x1 . showChar ')'))
  showsPrec _ (C_NegBracket x1) = showString "(NegBracket" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (C_Start x1) = showString "(Start" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_End x1) = showString "(End" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (C_Times x1 x2) = showString "(Times" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))
  showsPrec _ (C_Capture x1 x2) = showString "(Capture" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . showChar ')'))))

instance (Curry t0) => Read (C_ORegExp t0) where
  readsPrec d s = readParen False (\r -> [(C_Nil, r0) | (_, r0) <- readQualified
    "RegExp" "Nil" r]) s ++ (readParen ((>) d 10) (\r -> [(C_Literal x1
    , r1) | (_, r0) <- readQualified "RegExp" "Literal" r, (x1, r1) <- readsPrec
    11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_Xor x1 x2, r2) | (_, r0) <-
    readQualified "RegExp" "Xor" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <-
    readsPrec 11 r1]) s ++ (readParen ((>) d 10) (\r -> [(C_Star x1, r1) | (_
    , r0) <- readQualified "RegExp" "Star" r, (x1, r1) <- readsPrec 11 r0]) s ++
    (readParen ((>) d 10) (\r -> [(C_Plus x1, r1) | (_, r0) <- readQualified
    "RegExp" "Plus" r, (x1, r1) <- readsPrec 11 r0]) s ++ (readParen False
    (\r -> [(C_AnyLiteral, r0) | (_, r0) <- readQualified "RegExp" "AnyLiteral"
    r]) s ++ (readParen ((>) d 10) (\r -> [(C_Bracket x1, r1) | (_, r0) <-
    readQualified "RegExp" "Bracket" r, (x1, r1) <- readsPrec 11 r0]) s ++
    (readParen ((>) d 10) (\r -> [(C_NegBracket x1, r1) | (_, r0) <-
    readQualified "RegExp" "NegBracket" r, (x1, r1) <- readsPrec 11 r0]) s ++
    (readParen ((>) d 10) (\r -> [(C_Start x1, r1) | (_, r0) <- readQualified
    "RegExp" "Start" r, (x1, r1) <- readsPrec 11 r0]) s ++ (readParen ((>) d 10)
    (\r -> [(C_End x1, r1) | (_, r0) <- readQualified "RegExp" "End" r, (x1, r1)
    <- readsPrec 11 r0]) s ++ (readParen ((>) d 10) (\r -> [(C_Times x1 x2
    , r2) | (_, r0) <- readQualified "RegExp" "Times" r, (x1, r1) <- readsPrec
    11 r0, (x2, r2) <- readsPrec 11 r1]) s ++ readParen ((>) d 10) (\r ->
    [(C_Capture x1 x2, r2) | (_, r0) <- readQualified "RegExp" "Capture" r, (x1
    , r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1]) s))))))))))

instance NonDet (C_ORegExp t0) where
  choiceCons = Choice_C_ORegExp
  choicesCons = Choices_C_ORegExp
  failCons = Fail_C_ORegExp
  guardCons = Guard_C_ORegExp
  try (Choice_C_ORegExp cd i x y) = tryChoice cd i x y
  try (Choices_C_ORegExp cd i xs) = tryChoices cd i xs
  try (Fail_C_ORegExp cd info) = Fail cd info
  try (Guard_C_ORegExp cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_ORegExp cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_ORegExp cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_ORegExp cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_ORegExp cd i _) = error
    ("RegExp.ORegExp.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_ORegExp cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_ORegExp cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance (Curry t0) => Generable (C_ORegExp t0) where
  generate s c = Choices_C_ORegExp c (freeID [0, 1, 2, 1, 1, 0, 1, 1, 1, 1, 2
    , 2] s) [C_Nil, C_Literal (generate (leftSupply s) c), C_Xor (generate
    (leftSupply s) c) (generate (rightSupply s) c), C_Star (generate (leftSupply
    s) c), C_Plus (generate (leftSupply s) c), C_AnyLiteral, C_Bracket (generate
    (leftSupply s) c), C_NegBracket (generate (leftSupply s) c), C_Start
    (generate (leftSupply s) c), C_End (generate (leftSupply s) c), C_Times
    (generate (leftSupply s) c) (generate (rightSupply s) c), C_Capture
    (generate (leftSupply s) c) (generate (rightSupply s) c)]

instance (Curry t0) => NormalForm (C_ORegExp t0) where
  ($!!) cont C_Nil d cs = cont C_Nil d cs
  ($!!) cont (C_Literal x1) d cs = ($!!) (\y1 d cs -> cont (C_Literal y1) d cs)
    x1 d cs
  ($!!) cont (C_Xor x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Xor y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_Star x1) d cs = ($!!) (\y1 d cs -> cont (C_Star y1) d cs) x1 d
    cs
  ($!!) cont (C_Plus x1) d cs = ($!!) (\y1 d cs -> cont (C_Plus y1) d cs) x1 d
    cs
  ($!!) cont C_AnyLiteral d cs = cont C_AnyLiteral d cs
  ($!!) cont (C_Bracket x1) d cs = ($!!) (\y1 d cs -> cont (C_Bracket y1) d cs)
    x1 d cs
  ($!!) cont (C_NegBracket x1) d cs = ($!!) (\y1 d cs -> cont (C_NegBracket y1)
    d cs) x1 d cs
  ($!!) cont (C_Start x1) d cs = ($!!) (\y1 d cs -> cont (C_Start y1) d cs) x1 d
    cs
  ($!!) cont (C_End x1) d cs = ($!!) (\y1 d cs -> cont (C_End y1) d cs) x1 d cs
  ($!!) cont (C_Times x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Times y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (C_Capture x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs -> cont
    (C_Capture y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_ORegExp cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_ORegExp cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_ORegExp cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_ORegExp cd info) _ _ = failCons cd info
  ($##) cont C_Nil d cs = cont C_Nil d cs
  ($##) cont (C_Literal x1) d cs = ($##) (\y1 d cs -> cont (C_Literal y1) d cs)
    x1 d cs
  ($##) cont (C_Xor x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Xor y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_Star x1) d cs = ($##) (\y1 d cs -> cont (C_Star y1) d cs) x1 d
    cs
  ($##) cont (C_Plus x1) d cs = ($##) (\y1 d cs -> cont (C_Plus y1) d cs) x1 d
    cs
  ($##) cont C_AnyLiteral d cs = cont C_AnyLiteral d cs
  ($##) cont (C_Bracket x1) d cs = ($##) (\y1 d cs -> cont (C_Bracket y1) d cs)
    x1 d cs
  ($##) cont (C_NegBracket x1) d cs = ($##) (\y1 d cs -> cont (C_NegBracket y1)
    d cs) x1 d cs
  ($##) cont (C_Start x1) d cs = ($##) (\y1 d cs -> cont (C_Start y1) d cs) x1 d
    cs
  ($##) cont (C_End x1) d cs = ($##) (\y1 d cs -> cont (C_End y1) d cs) x1 d cs
  ($##) cont (C_Times x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Times y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (C_Capture x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs -> cont
    (C_Capture y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_ORegExp cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_ORegExp cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_ORegExp cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_ORegExp cd info) _ _ = failCons cd info
  showCons C_Nil = "RegExp.Nil"
  showCons (C_Literal _) = "RegExp.Literal _"
  showCons (C_Xor _ _) = "RegExp.Xor _ _"
  showCons (C_Star _) = "RegExp.Star _"
  showCons (C_Plus _) = "RegExp.Plus _"
  showCons C_AnyLiteral = "RegExp.AnyLiteral"
  showCons (C_Bracket _) = "RegExp.Bracket _"
  showCons (C_NegBracket _) = "RegExp.NegBracket _"
  showCons (C_Start _) = "RegExp.Start _"
  showCons (C_End _) = "RegExp.End _"
  showCons (C_Times _ _) = "RegExp.Times _ _"
  showCons (C_Capture _ _) = "RegExp.Capture _ _"
  showCons x = error ("RegExp.ORegExp.showCons: no constructor: " ++ show x)
  searchNF _ cont C_Nil = cont C_Nil
  searchNF search cont (C_Literal x1) = search (\y1 -> cont (C_Literal y1)) x1
  searchNF search cont (C_Xor x1 x2) = search (\y1 -> search (\y2 -> cont (C_Xor
    y1 y2)) x2) x1
  searchNF search cont (C_Star x1) = search (\y1 -> cont (C_Star y1)) x1
  searchNF search cont (C_Plus x1) = search (\y1 -> cont (C_Plus y1)) x1
  searchNF _ cont C_AnyLiteral = cont C_AnyLiteral
  searchNF search cont (C_Bracket x1) = search (\y1 -> cont (C_Bracket y1)) x1
  searchNF search cont (C_NegBracket x1) = search (\y1 -> cont (C_NegBracket
    y1)) x1
  searchNF search cont (C_Start x1) = search (\y1 -> cont (C_Start y1)) x1
  searchNF search cont (C_End x1) = search (\y1 -> cont (C_End y1)) x1
  searchNF search cont (C_Times x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Times y1 y2)) x2) x1
  searchNF search cont (C_Capture x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Capture y1 y2)) x2) x1
  searchNF _ _ x = error ("RegExp.ORegExp.searchNF: no constructor: " ++ show x)

instance (Curry t0) => Unifiable (C_ORegExp t0) where
  (=.=) C_Nil C_Nil d cs = C_True
  (=.=) (C_Literal x1) (C_Literal y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Xor x1 x2) (C_Xor y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2 y2 d
    cs) d cs
  (=.=) (C_Star x1) (C_Star y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Plus x1) (C_Plus y1) d cs = (=:=) x1 y1 d cs
  (=.=) C_AnyLiteral C_AnyLiteral d cs = C_True
  (=.=) (C_Bracket x1) (C_Bracket y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_NegBracket x1) (C_NegBracket y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Start x1) (C_Start y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_End x1) (C_End y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Times x1 x2) (C_Times y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=) x2
    y2 d cs) d cs
  (=.=) (C_Capture x1 x2) (C_Capture y1 y2) d cs = (&) ((=:=) x1 y1 d cs) ((=:=)
    x2 y2 d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_Nil C_Nil d cs = C_True
  (=.<=) (C_Literal x1) (C_Literal y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Xor x1 x2) (C_Xor y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=) x2
    y2 d cs) d cs
  (=.<=) (C_Star x1) (C_Star y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Plus x1) (C_Plus y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) C_AnyLiteral C_AnyLiteral d cs = C_True
  (=.<=) (C_Bracket x1) (C_Bracket y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_NegBracket x1) (C_NegBracket y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Start x1) (C_Start y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_End x1) (C_End y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Times x1 x2) (C_Times y1 y2) d cs = (&) ((=:<=) x1 y1 d cs) ((=:<=)
    x2 y2 d cs) d cs
  (=.<=) (C_Capture x1 x2) (C_Capture y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_Nil = (i :=: ChooseN 0 0) : concat []
  bind cd i (C_Literal x3) = (i :=: ChooseN 1 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_Xor x3 x4) = (i :=: ChooseN 2 2) : concat [bind cd (leftID i) x3
    , bind cd (rightID i) x4]
  bind cd i (C_Star x3) = (i :=: ChooseN 3 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_Plus x3) = (i :=: ChooseN 4 1) : concat [bind cd (leftID i) x3]
  bind cd i C_AnyLiteral = (i :=: ChooseN 5 0) : concat []
  bind cd i (C_Bracket x3) = (i :=: ChooseN 6 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_NegBracket x3) = (i :=: ChooseN 7 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_Start x3) = (i :=: ChooseN 8 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_End x3) = (i :=: ChooseN 9 1) : concat [bind cd (leftID i) x3]
  bind cd i (C_Times x3 x4) = (i :=: ChooseN 10 2) : concat [bind cd (leftID i)
    x3, bind cd (rightID i) x4]
  bind cd i (C_Capture x3 x4) = (i :=: ChooseN 11 2) : concat [bind cd (leftID
    i) x3, bind cd (rightID i) x4]
  bind d i (Choice_C_ORegExp cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_ORegExp cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_ORegExp cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (bind d i) xs)]
  bind _ _ (Choices_C_ORegExp cd i _) = error
    ("RegExp.ORegExp.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_ORegExp cd info) = [Unsolvable info]
  bind d i (Guard_C_ORegExp cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_Nil = (i :=: ChooseN 0 0) : []
  lazyBind cd i (C_Literal x3) = (i :=: ChooseN 1 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Xor x3 x4) = (i :=: ChooseN 2 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (C_Star x3) = (i :=: ChooseN 3 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Plus x3) = (i :=: ChooseN 4 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i C_AnyLiteral = (i :=: ChooseN 5 0) : []
  lazyBind cd i (C_Bracket x3) = (i :=: ChooseN 6 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_NegBracket x3) = (i :=: ChooseN 7 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Start x3) = (i :=: ChooseN 8 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_End x3) = (i :=: ChooseN 9 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Times x3 x4) = (i :=: ChooseN 10 2) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd (rightID i)
    x4)]
  lazyBind cd i (C_Capture x3 x4) = (i :=: ChooseN 11 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind d i (Choice_C_ORegExp cd j x y) = [ConstraintChoice cd j (lazyBind d
    i x) (lazyBind d i y)]
  lazyBind d i (Choices_C_ORegExp cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i
    cd j xs
  lazyBind d i (Choices_C_ORegExp cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_ORegExp cd i _) = error
    ("RegExp.ORegExp.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_ORegExp cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_ORegExp cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance (Curry t0) => Curry (C_ORegExp t0) where

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_Unit -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data (C_ORegExp t0)
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
    x1)))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
    x1 s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
    x1 l s cd cs)
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
    x1 r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "RegExp._inst#Prelude.Data#RegExp.ORegExp#0##" [show x1, show x2] info)
  _ -> failCons cd (consFail "RegExp._inst#Prelude.Data#RegExp.ORegExp#0##"
    (showCons x2))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> C_ORegExp t0 -> C_ORegExp t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash x1 x2 x3 s cd cs =
  case x2 of
  C_Nil -> d_C__case_65 x3 cd cs
  C_Literal x17 -> let s0 = s in s0 `seq` nd_C__case_64 x17 x1 x3 s0 cd cs
  C_Xor x31 x32 -> let s0 = s in s0 `seq` nd_C__case_63 x32 x1 x31 x3 s0 cd cs
  C_Star x46 -> let s0 = s in s0 `seq` nd_C__case_62 x46 x1 x3 s0 cd cs
  C_Plus x60 -> let s0 = s in s0 `seq` nd_C__case_61 x60 x1 x3 s0 cd cs
  C_AnyLiteral -> d_C__case_60 x3 cd cs
  C_Bracket x87 -> let s0 = s in s0 `seq` nd_C__case_59 x87 x1 x3 s0 cd cs
  C_NegBracket x101 -> let s0 = s in s0 `seq` nd_C__case_58 x101 x1 x3 s0 cd cs
  C_Start x115 -> let s0 = s in s0 `seq` nd_C__case_57 x115 x1 x3 s0 cd cs
  C_End x129 -> let s0 = s in s0 `seq` nd_C__case_56 x129 x1 x3 s0 cd cs
  C_Times x143 x144 -> let s0 = s
    in s0 `seq` nd_C__case_55 x144 x1 x143 x3 s0 cd cs
  C_Capture x158 x159 -> let s0 = s
    in s0 `seq` nd_C__case_54 x159 x1 x158 x3 s0 cd cs
  Choice_C_ORegExp d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
    x1 l x3 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
    x1 r x3 s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
    x1 z x3 s cd cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
    x1 e x3 s cd x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail
    "RegExp._impl#===#Prelude.Data#RegExp.ORegExp#0##" [show x1, show x2, show
    x3] info)
  _ -> failCons cd (consFail "RegExp._impl#===#Prelude.Data#RegExp.ORegExp#0##"
    (showCons x2))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> IDSupply -> Cover -> ConstStore -> C_ORegExp t0
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash x1 s cd cs =
  let s45 = s
  in s45 `seq` (let s44 = leftSupply s45
                    s46 = rightSupply s45
                    s39 = leftSupply s46
                    s43 = rightSupply s46
  in s44 `seq` (s46 `seq` (s39 `seq` (s43 `seq` choice (let s38 = leftSupply s39
                                                            s40 = rightSupply
                                                              s39
                                                            s33 = leftSupply s40
                                                            s37 = rightSupply
                                                              s40
  in s38 `seq` (s40 `seq` (s33 `seq` (s37 `seq` choice (let s32 = leftSupply s33
                                                            s34 = rightSupply
                                                              s33
                                                            s29 = leftSupply s34
                                                            s31 = rightSupply
                                                              s34
  in s32 `seq` (s34 `seq` (s29 `seq` (s31 `seq` choice (let s28 = leftSupply s29
                                                            s30 = rightSupply
                                                              s29
                                                            s25 = leftSupply s30
                                                            s27 = rightSupply
                                                              s30
  in s28 `seq` (s30 `seq` (s25 `seq` (s27 `seq` choice (let s24 = leftSupply s25
                                                            s26 = rightSupply
                                                              s25
                                                            s21 = leftSupply s26
                                                            s23 = rightSupply
                                                              s26
  in s24 `seq` (s26 `seq` (s21 `seq` (s23 `seq` choice (let s20 = leftSupply s21
                                                            s22 = rightSupply
                                                              s21
                                                            s18 = leftSupply s22
                                                            s19 = rightSupply
                                                              s22
  in s20 `seq` (s22 `seq` (s18 `seq` (s19 `seq` choice (let s17 = leftSupply s18
                                                            s15 = rightSupply
                                                              s18
  in s17 `seq` (s15 `seq` choice (let s14 = leftSupply s15
                                      s16 = rightSupply s15
                                      s11 = leftSupply s16
                                      s13 = rightSupply s16
  in s14 `seq` (s16 `seq` (s11 `seq` (s13 `seq` choice (let s10 = leftSupply s11
                                                            s12 = rightSupply
                                                              s11
                                                            s7 = leftSupply s12
                                                            s9 = rightSupply s12
  in s10 `seq` (s12 `seq` (s7 `seq` (s9 `seq` choice (let s6 = leftSupply s7
                                                          s8 = rightSupply s7
                                                          s2 = leftSupply s8
                                                          s5 = rightSupply s8
  in s6 `seq` (s8 `seq` (s2 `seq` (s5 `seq` choice (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
  in s1 `seq` (s0 `seq` choice C_Nil (C_Literal (Curry_Prelude.nd_C_aValue x1 s0
  cd cs)) s1 cd cs)) (let s3 = leftSupply s5
                          s4 = rightSupply s5
  in s3 `seq` (s4 `seq` C_Xor
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
  x1)) s3 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
  x1)) s4 cd cs))) s6 cd cs)))) (C_Star
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
  x1)) s9 cd cs)) s10 cd cs)))) (C_Plus
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
  x1)) s13 cd cs)) s14 cd cs)))) C_AnyLiteral s17 cd cs)) (C_Bracket
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Either_hash_0_hash_hash_1_hash_hash
  x1 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x1 x1)))) s19 cd cs)) s20 cd cs)))) (C_NegBracket
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Either_hash_0_hash_hash_1_hash_hash
  x1 (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  x1 x1)))) s23 cd cs)) s24 cd cs)))) (C_Start
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
  x1)) s27 cd cs)) s28 cd cs)))) (C_End
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
  x1)) s31 cd cs)) s32 cd cs)))) (let s35 = leftSupply s37
                                      s36 = rightSupply s37
  in s35 `seq` (s36 `seq` C_Times
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
  s35 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
  x1)) s36 cd cs))) s38 cd cs)))) (let s41 = leftSupply s43
                                       s42 = rightSupply s43
  in s41 `seq` (s42 `seq` C_Capture
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
  s41 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  (wrapNX id
  (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
  x1)) s42 cd cs))) s44 cd cs))))

d_C_eps :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_List (C_ORegExp
  t0)
d_C_eps x1 cd cs = Curry_Prelude.OP_Cons C_Nil Curry_Prelude.OP_List

d_C_literal :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (C_ORegExp t0)
d_C_literal x1 x2 cd cs = Curry_Prelude.OP_Cons (C_Literal x2)
  Curry_Prelude.OP_List

d_C_alt :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Curry_Prelude.OP_List (C_ORegExp t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (C_ORegExp t0)
d_C_alt x1 x2 x3 cd cs = Curry_Prelude.OP_Cons (C_Xor x2 x3)
  Curry_Prelude.OP_List

d_C_conc :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Curry_Prelude.OP_List (C_ORegExp t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (C_ORegExp t0)
d_C_conc x1 x2 x3 cd cs = Curry_Prelude.d_OP_plus_plus x2 x3 cd cs

d_C_rep :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Curry_Prelude.OP_List (C_ORegExp t0) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (C_ORegExp t0)
d_C_rep x1 x2 cd cs = Curry_Prelude.OP_Cons (C_Star x2) Curry_Prelude.OP_List

d_C_pl :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Curry_Prelude.OP_List (C_ORegExp t0) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (C_ORegExp t0)
d_C_pl x1 x2 cd cs = Curry_Prelude.OP_Cons (C_Plus x2) Curry_Prelude.OP_List

d_C_anyL :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_List (C_ORegExp
  t0)
d_C_anyL x1 cd cs = Curry_Prelude.OP_Cons C_AnyLiteral Curry_Prelude.OP_List

d_C_bracket :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Curry_Prelude.OP_List (Curry_Prelude.C_Either t0
  (Curry_Prelude.OP_Tuple2 t0 t0)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (C_ORegExp t0)
d_C_bracket x1 x2 cd cs = Curry_Prelude.OP_Cons (C_Bracket x2)
  Curry_Prelude.OP_List

d_C_negBracket :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Curry_Prelude.OP_List (Curry_Prelude.C_Either t0
  (Curry_Prelude.OP_Tuple2 t0 t0)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (C_ORegExp t0)
d_C_negBracket x1 x2 cd cs = Curry_Prelude.OP_Cons (C_NegBracket x2)
  Curry_Prelude.OP_List

d_C_start :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Curry_Prelude.OP_List (C_ORegExp t0)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (C_ORegExp t0)
d_C_start x1 x2 x3 cd cs = Curry_Prelude.OP_Cons (C_Start x2)
  Curry_Prelude.OP_List

d_C_end :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Curry_Prelude.OP_List (C_ORegExp t0)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (C_ORegExp t0)
d_C_end x1 x2 x3 cd cs = Curry_Prelude.OP_Cons (C_End x2) Curry_Prelude.OP_List

d_C_times :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (C_ORegExp t0)
d_C_times x1 x2 x3 x4 cd cs = Curry_Prelude.OP_Cons (C_Times
  (Curry_Prelude.OP_Tuple2 x2 x3) x4) Curry_Prelude.OP_List

d_C_captureG :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (C_ORegExp t0)
d_C_captureG x1 x2 cd cs = Curry_Prelude.OP_Cons (C_Capture x1 x2)
  Curry_Prelude.OP_List

nd_C_grepPos :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Int
nd_C_grepPos x1 x2 x3 x4 s cd cs = let s0 = s
  in s0 `seq` nd_OP_grepPos_dot_grepPos_tick_dot_42 x1 (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash)
  x2 x3 x4 (Curry_Prelude.C_Int (0)) s0 cd cs

nd_OP_grepPos_dot_grepPos_tick_dot_42 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Num t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Curry_Prelude.OP_List (C_ORegExp
  t0) -> Curry_Prelude.OP_List t0 -> t1 -> IDSupply -> Cover -> ConstStore -> t1
nd_OP_grepPos_dot_grepPos_tick_dot_42 x1 x2 x3 x4 x5 x6 s cd cs = case x5 of
  Curry_Prelude.OP_List -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_negate x2 s0 cd cs) (let s2 = leftSupply s3
                                                 s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_fromInt
    x2 s1 cd cs) (Curry_Prelude.C_Int (1)) s2 cd cs)) s4 cd cs))))
  Curry_Prelude.OP_Cons x7 x8 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_53 x8 x7 x4 x3 x1 x2 x6 (nd_C_match x1 x3
    (Curry_Prelude.d_OP_plus_plus x4 (Curry_Prelude.OP_Cons (C_Star
    (Curry_Prelude.OP_Cons C_AnyLiteral Curry_Prelude.OP_List))
    Curry_Prelude.OP_List) cd cs) (Curry_Prelude.OP_Cons x7 x8) s0 cd cs) s1 cd
    cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (nd_OP_grepPos_dot_grepPos_tick_dot_42 x1 x2 x3 x4 l x6 s cd cs)
    (nd_OP_grepPos_dot_grepPos_tick_dot_42 x1 x2 x3 x4 r x6 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_OP_grepPos_dot_grepPos_tick_dot_42 x1 x2 x3 x4 z x6 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    nd_OP_grepPos_dot_grepPos_tick_dot_42 x1 x2 x3 x4 e x6 s cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "RegExp.grepPos.grepPos'.42" [show x1, show x2, show x3, show x4, show x5
    , show x6] info)
  _ -> failCons cd (consFail "RegExp.grepPos.grepPos'.42" (showCons x5))

nd_C_grep :: forall t0 . (Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Curry_Prelude.OP_List (C_ORegExp
  t0) -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int
nd_C_grep x1 x2 x3 x4 s cd cs = let s0 = s
  in s0 `seq` nd_OP_grep_dot_grep_tick_dot_50 x1 (wrapNX id
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash)
  x2 x3 x4 (Curry_Prelude.C_Int (0)) s0 cd cs

nd_OP_grep_dot_grep_tick_dot_50 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t1) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Num t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> Curry_Prelude.OP_List (C_ORegExp
  t1) -> Curry_Prelude.OP_List t1 -> t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_OP_grep_dot_grep_tick_dot_50 x1 x2 x3 x4 x5 x6 s cd cs = case x5 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x7 x8 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_52 x8 x7 x4 x3 x1 x2 x6 (nd_C_match x1 x3
    (Curry_Prelude.d_OP_plus_plus x4 (Curry_Prelude.OP_Cons (C_Star
    (Curry_Prelude.OP_Cons C_AnyLiteral Curry_Prelude.OP_List))
    Curry_Prelude.OP_List) cd cs) (Curry_Prelude.OP_Cons x7 x8) s0 cd cs) s1 cd
    cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (nd_OP_grep_dot_grep_tick_dot_50 x1 x2 x3 x4 l x6 s cd cs)
    (nd_OP_grep_dot_grep_tick_dot_50 x1 x2 x3 x4 r x6 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_OP_grep_dot_grep_tick_dot_50 x1 x2 x3 x4 z x6 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    nd_OP_grep_dot_grep_tick_dot_50 x1 x2 x3 x4 e x6 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "RegExp.grep.grep'.50" [show x1, show x2, show x3, show x4, show x5, show
    x6] info)
  _ -> failCons cd (consFail "RegExp.grep.grep'.50" (showCons x5))

nd_C_grepShow :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)
nd_C_grepShow x1 x2 x3 x4 s cd cs = let s0 = s
  in s0 `seq` Control.Search.Curry_Unsafe.d_C_allValues
  (nd_OP_grepShow_dot_grepShow_tick_dot_58 x1 x2 x3 x4 s0 cd cs) cd cs

nd_OP_grepShow_dot_grepShow_tick_dot_58 :: forall t0 . (Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
nd_OP_grepShow_dot_grepShow_tick_dot_58 x1 x2 x3 x4 s cd cs = let s8 = s
  in s8 `seq` (let s0 = leftSupply s8
                   s7 = rightSupply s8
  in s0 `seq` (s7 `seq` (let x5 = generate s0 cd
  in let s6 = leftSupply s7
         s5 = rightSupply s7
  in s6 `seq` (s5 `seq` nd_C__case_51 x5 x3 x2 x1 x4 (let s3 = leftSupply s5
                                                          s4 = rightSupply s5
  in s3 `seq` (s4 `seq` Curry_Prelude.d_OP_amp_amp
  (Curry_Prelude.d_OP_eq_colon_eq x4 (let s1 = leftSupply s3
                                          s2 = rightSupply s3
  in s1 `seq` (s2 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_unknown
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  x1)) s1 cd cs) (Curry_Prelude.d_OP_plus_plus x5 (Curry_Prelude.nd_C_unknown
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
  x1)) s2 cd cs) cd cs) cd cs)) cd cs) (nd_C_match x1 x2 x3 x5 s4 cd cs) cd cs))
  s6 cd cs))))

nd_C_grepShowUnique :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)
nd_C_grepShowUnique x1 x2 x3 x4 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Data.Curry_List.nd_C_nub (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
  (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq_hash_0_hash
  x2 s0 cd cs))) (nd_C_grepShow x1 x2 x3 x4 s1 cd cs) s2 cd cs))))

nd_C_match :: forall t0 . (Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Curry_Prelude.OP_List (C_ORegExp
  t0) -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C_match x1 x2 x3 x4 s cd cs = case x3 of
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket_hash_0_hash_hash
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq_hash_0_hash
    x2 s0 cd cs) x4 Curry_Prelude.OP_List s1 cd cs))
  Curry_Prelude.OP_Cons x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_50 x4 x6 x2 x1 x5 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_match x1 x2 l x4 s cd
    cs) (nd_C_match x1 x2 r x4 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_match x1 x2
    z x4 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_match x1 x2 e
    x4 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp.match"
    [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "RegExp.match" (showCons x3))

nd_C_matchstart :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C_matchstart x1 x2 x3 x4 s cd cs = case x3 of
  Curry_Prelude.OP_Cons x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_40 x6 x2 x1 x4 x5 s0 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_matchstart x1 x2 l x4
    s cd cs) (nd_C_matchstart x1 x2 r x4 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_matchstart
    x1 x2 z x4 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_matchstart x1
    x2 e x4 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp.matchstart"
    [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "RegExp.matchstart" (showCons x3))

nd_C_matchend :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> C_ORegExp
  t0 -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C_matchend x1 x2 x3 x4 s cd cs = case x3 of
  C_End x5 -> let s4 = s
    in s4 `seq` (let s0 = leftSupply s4
                     s3 = rightSupply s4
    in s0 `seq` (s3 `seq` (let x6 = generate s0 cd
    in let s1 = leftSupply s3
           s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_eq_colon_eq (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.nd_C_unknown (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    x1)) s1 cd cs) x6 cd cs) x4 cd cs) (nd_C_match x1 x2 x5 x6 s2 cd cs) cd
    cs))))
  C_Nil -> Curry_Prelude.d_C_failed cd cs
  C_Literal x7 -> Curry_Prelude.d_C_failed cd cs
  C_Xor x8 x9 -> Curry_Prelude.d_C_failed cd cs
  C_Star x10 -> Curry_Prelude.d_C_failed cd cs
  C_Plus x11 -> Curry_Prelude.d_C_failed cd cs
  C_AnyLiteral -> Curry_Prelude.d_C_failed cd cs
  C_Bracket x12 -> Curry_Prelude.d_C_failed cd cs
  C_NegBracket x13 -> Curry_Prelude.d_C_failed cd cs
  C_Start x14 -> Curry_Prelude.d_C_failed cd cs
  C_Times x15 x16 -> Curry_Prelude.d_C_failed cd cs
  C_Capture x17 x18 -> Curry_Prelude.d_C_failed cd cs
  Choice_C_ORegExp d i l r -> narrow d i (nd_C_matchend x1 x2 l x4 s cd cs)
    (nd_C_matchend x1 x2 r x4 s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C_matchend x1 x2 z x4 s
    cd cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C_matchend x1 x2 e x4 s cd
    x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp.matchend" [show x1
    , show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "RegExp.matchend" (showCons x3))

nd_C_matchstar :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List (C_ORegExp
  t0) -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C_matchstar x1 x2 x3 x4 x5 s cd cs = let s4 = s
  in s4 `seq` (let s0 = leftSupply s4
                   s3 = rightSupply s4
  in s0 `seq` (s3 `seq` Curry_Prelude.d_OP_bar_bar (nd_C_match x1 x2 x4 x5 s0 cd
  cs) (let s2 = leftSupply s3
           s1 = rightSupply s3
  in s2 `seq` (s1 `seq` nd_C_tryeach x1 x2 (Curry_Prelude.nd_C_map (wrapNX id
  (nd_OP_matchstar_dot_uscore_hash_lambda6 x3 x1 x2)) (Data.Curry_List.d_C_inits
  x5 cd cs) s1 cd cs) (Data.Curry_List.d_C_tails x5 cd cs) x3 x4 s2 cd cs)) cd
  cs))

nd_OP_matchstar_dot_uscore_hash_lambda6 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_matchstar_dot_uscore_hash_lambda6 x1 x2 x3 x4 s cd cs = let s0 = s
  in s0 `seq` nd_C_match x2 x3 x1 x4 s0 cd cs

nd_C_tryeach :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0) -> Curry_Prelude.OP_List (C_ORegExp t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C_tryeach x1 x2 x3 x4 x5 x6 s cd cs = case x3 of
  Curry_Prelude.OP_List -> d_C__case_38 x4 cd cs
  Curry_Prelude.OP_Cons x9 x10 -> let s0 = s
    in s0 `seq` nd_C__case_37 x6 x5 x10 x2 x1 x9 x4 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_tryeach x1 x2 l x4 x5
    x6 s cd cs) (nd_C_tryeach x1 x2 r x4 x5 x6 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_tryeach x1
    x2 z x4 x5 x6 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_tryeach x1 x2
    e x4 x5 x6 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp.tryeach"
    [show x1, show x2, show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "RegExp.tryeach" (showCons x3))

nd_C_matchplus :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List (C_ORegExp
  t0) -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C_matchplus x1 x2 x3 x4 x5 s cd cs = let s2 = s
  in s2 `seq` (let x6 = Curry_Prelude.d_C_tail (Data.Curry_List.d_C_inits x5 cd
                     cs) cd cs
                   x7 = Curry_Prelude.d_C_tail (Data.Curry_List.d_C_tails x5 cd
                     cs) cd cs
  in let s1 = leftSupply s2
         s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_tryeach x1 x2 (Curry_Prelude.nd_C_map (wrapNX id
  (nd_OP_matchplus_dot_uscore_hash_lambda7 x3 x1 x2)) x6 s0 cd cs) x7 x3 x4 s1
  cd cs))

nd_OP_matchplus_dot_uscore_hash_lambda7 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_matchplus_dot_uscore_hash_lambda7 x1 x2 x3 x4 s cd cs = let s0 = s
  in s0 `seq` nd_C_match x2 x3 x1 x4 s0 cd cs

d_C_matchbracket :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2
  t0 t0)) -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_matchbracket x1 x2 x3 x4 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.C_False
  Curry_Prelude.OP_Cons x5 x6 -> d_C__case_35 x4 x6 x2 x1 x5 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_matchbracket x1 x2 l
    x4 cd cs) (d_C_matchbracket x1 x2 r x4 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_matchbracket
    x1 x2 z x4 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_matchbracket x1
    x2 e x4 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "RegExp.matchbracket" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "RegExp.matchbracket" (showCons x3))

nd_C_matchbracket :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2
  t0 t0)) -> t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C_matchbracket x1 x2 x3 x4 s cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.C_False
  Curry_Prelude.OP_Cons x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_35 x4 x6 x2 x1 x5 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_matchbracket x1 x2 l
    x4 s cd cs) (nd_C_matchbracket x1 x2 r x4 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_C_matchbracket x1 x2 z x4 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_matchbracket
    x1 x2 e x4 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "RegExp.matchbracket" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "RegExp.matchbracket" (showCons x3))

nd_C_matchtimes :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List (C_ORegExp
  t0) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C_matchtimes x1 x2 x3 x4 x5 x6 x7 s cd cs = let s4 = s
  in s4 `seq` (let s2 = leftSupply s4
                   s3 = rightSupply s4
  in s2 `seq` (s3 `seq` (let x8 = let s1 = leftSupply s2
                                      s0 = rightSupply s2
                               in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
                               (Curry_Prelude.nd_C_concat s0 cd cs)
                               (Curry_Prelude.d_C_replicate x4 x6 cd cs) s1 cd
                               cs)
  in nd_C__case_31 x5 x7 x6 x3 x2 x1 x8 x4
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
  x5 (Curry_Prelude.C_Int (0)) cd cs) s3 cd cs)))

nd_OP_matchtimes_dot_uscore_hash_lambda8 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_matchtimes_dot_uscore_hash_lambda8 x1 x2 x3 x4 s cd cs = let s0 = s
  in s0 `seq` nd_C_match x2 x3 x1 x4 s0 cd cs

nd_C_tryeachRestricted :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0) -> Curry_Prelude.OP_List
  (C_ORegExp t0) -> Curry_Prelude.OP_List (C_ORegExp t0) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C_tryeachRestricted x1 x2 x3 x4 x5 x6 x7 s cd cs = case x4 of
  Curry_Prelude.OP_List -> d_C__case_29 x5 cd cs
  Curry_Prelude.OP_Cons x10 x11 -> let s0 = s
    in s0 `seq` nd_C__case_28 x7 x6 x11 x3 x2 x1 x10 x5 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_tryeachRestricted x1
    x2 x3 l x5 x6 x7 s cd cs) (nd_C_tryeachRestricted x1 x2 x3 r x5 x6 x7 s cd
    cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_C_tryeachRestricted x1 x2 x3 z x5 x6 x7 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    nd_C_tryeachRestricted x1 x2 x3 e x5 x6 x7 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "RegExp.tryeachRestricted" [show x1, show x2, show x3, show x4, show x5
    , show x6, show x7] info)
  _ -> failCons cd (consFail "RegExp.tryeachRestricted" (showCons x4))

nd_C_capture :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
nd_C_capture x1 x2 x3 x4 s cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_26 x4 x6 x2 x1 x5 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_capture x1 x2 l x4 s
    cd cs) (nd_C_capture x1 x2 r x4 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_capture x1
    x2 z x4 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_capture x1 x2
    e x4 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp.capture"
    [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "RegExp.capture" (showCons x3))

nd_C_captureStar :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
nd_C_captureStar x1 x2 x3 x4 s cd cs = case x3 of
  Curry_Prelude.OP_Cons x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_13 x6 x2 x1 x4 x5 s0 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_captureStar x1 x2 l
    x4 s cd cs) (nd_C_captureStar x1 x2 r x4 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_captureStar
    x1 x2 z x4 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_captureStar x1
    x2 e x4 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "RegExp.captureStar" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "RegExp.captureStar" (showCons x3))

nd_C_captureStart :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
nd_C_captureStart x1 x2 x3 x4 s cd cs = case x3 of
  Curry_Prelude.OP_Cons x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_11 x6 x2 x1 x4 x5 s0 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_captureStart x1 x2 l
    x4 s cd cs) (nd_C_captureStart x1 x2 r x4 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_C_captureStart x1 x2 z x4 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_captureStart
    x1 x2 e x4 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "RegExp.captureStart" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "RegExp.captureStart" (showCons x3))

nd_C_captureEnd :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> C_ORegExp
  t0 -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))
nd_C_captureEnd x1 x2 x3 x4 s cd cs = case x3 of
  C_End x5 -> let s6 = s
    in s6 `seq` (let s0 = leftSupply s6
                     s5 = rightSupply s6
    in s0 `seq` (s5 `seq` (let x6 = generate s0 cd
    in let s4 = leftSupply s5
           s3 = rightSupply s5
    in s4 `seq` (s3 `seq` nd_C__case_7 x6 x5 x2 x1 x4 (let s1 = leftSupply s3
                                                           s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_eq_colon_eq x4 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.nd_C_unknown (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    x1)) s1 cd cs) x6 cd cs) cd cs) (nd_C_match x1 x2 x5 x6 s2 cd cs) cd cs)) s4
    cd cs))))
  C_Nil -> Curry_Prelude.d_C_failed cd cs
  C_Literal x7 -> Curry_Prelude.d_C_failed cd cs
  C_Xor x8 x9 -> Curry_Prelude.d_C_failed cd cs
  C_Star x10 -> Curry_Prelude.d_C_failed cd cs
  C_Plus x11 -> Curry_Prelude.d_C_failed cd cs
  C_AnyLiteral -> Curry_Prelude.d_C_failed cd cs
  C_Bracket x12 -> Curry_Prelude.d_C_failed cd cs
  C_NegBracket x13 -> Curry_Prelude.d_C_failed cd cs
  C_Start x14 -> Curry_Prelude.d_C_failed cd cs
  C_Times x15 x16 -> Curry_Prelude.d_C_failed cd cs
  C_Capture x17 x18 -> Curry_Prelude.d_C_failed cd cs
  Choice_C_ORegExp d i l r -> narrow d i (nd_C_captureEnd x1 x2 l x4 s cd cs)
    (nd_C_captureEnd x1 x2 r x4 s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C_captureEnd x1 x2 z x4 s
    cd cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C_captureEnd x1 x2 e x4 s cd
    x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp.captureEnd" [show x1
    , show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "RegExp.captureEnd" (showCons x3))

nd_C_captureTimes :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
nd_C_captureTimes x1 x2 x3 x4 s cd cs = case x3 of
  Curry_Prelude.OP_Cons x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_6 x6 x2 x1 x4 x5 s0 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_captureTimes x1 x2 l
    x4 s cd cs) (nd_C_captureTimes x1 x2 r x4 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_C_captureTimes x1 x2 z x4 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_captureTimes
    x1 x2 e x4 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "RegExp.captureTimes" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "RegExp.captureTimes" (showCons x3))

nd_C_captureCapture :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
nd_C_captureCapture x1 x2 x3 x4 s cd cs = case x3 of
  Curry_Prelude.OP_Cons x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_3 x6 x2 x1 x4 x5 s0 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_captureCapture x1 x2
    l x4 s cd cs) (nd_C_captureCapture x1 x2 r x4 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_C_captureCapture x1 x2 z x4 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_captureCapture
    x1 x2 e x4 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "RegExp.captureCapture" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "RegExp.captureCapture" (showCons x3))

d_C_con :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))
d_C_con x1 x2 x3 cd cs = d_C_comprime x1 x2 (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_concat cd cs) x3 cd cs) cd cs

nd_C_con :: forall t0 . (Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))
nd_C_con x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` nd_C_comprime x1 x2 (let s1 = leftSupply s2
                                                 s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_concat s0
  cd cs) x3 s1 cd cs)) s3 cd cs))

d_C_comprime :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0))) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
d_C_comprime x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> d_C__case_1 x5 x2 x1 x4 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_comprime x1 x2 l cd
    cs) (d_C_comprime x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_comprime x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C_comprime x1 x2
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp.comprime"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "RegExp.comprime" (showCons x3))

nd_C_comprime :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0))) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))
nd_C_comprime x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_1 x5 x2 x1 x4 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C_comprime x1 x2 l s cd
    cs) (nd_C_comprime x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C_comprime x1
    x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C_comprime x1 x2
    e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp.comprime"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "RegExp.comprime" (showCons x3))

d_OP_comprime_dot_uscore_hash_lambda15 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)) -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_OP_comprime_dot_uscore_hash_lambda15 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x1 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_comprime_dot_uscore_hash_lambda15 x1 l cd cs)
    (d_OP_comprime_dot_uscore_hash_lambda15 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_comprime_dot_uscore_hash_lambda15 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_comprime_dot_uscore_hash_lambda15 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "RegExp.comprime._#lambda15" [show x1, show x2] info)
  _ -> failCons cd (consFail "RegExp.comprime._#lambda15" (showCons x2))

d_OP_comprime_dot_uscore_hash_lambda17 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)) -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_OP_comprime_dot_uscore_hash_lambda17 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.d_C_not
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int_hash
    x1 x3 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_comprime_dot_uscore_hash_lambda17 x1 l cd cs)
    (d_OP_comprime_dot_uscore_hash_lambda17 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_comprime_dot_uscore_hash_lambda17 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_comprime_dot_uscore_hash_lambda17 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "RegExp.comprime._#lambda17" [show x1, show x2] info)
  _ -> failCons cd (consFail "RegExp.comprime._#lambda17" (showCons x2))

nd_C__case_54 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.C_Int
  -> C_ORegExp t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_54 x159 x1 x158 x3 s cd cs = case x3 of
  C_Nil -> Curry_Prelude.C_False
  C_Literal x160 -> Curry_Prelude.C_False
  C_Xor x161 x162 -> Curry_Prelude.C_False
  C_Star x163 -> Curry_Prelude.C_False
  C_Plus x164 -> Curry_Prelude.C_False
  C_AnyLiteral -> Curry_Prelude.C_False
  C_Bracket x165 -> Curry_Prelude.C_False
  C_NegBracket x166 -> Curry_Prelude.C_False
  C_Start x167 -> Curry_Prelude.C_False
  C_End x168 -> Curry_Prelude.C_False
  C_Times x169 x170 -> Curry_Prelude.C_False
  C_Capture x171 x172 -> let s4 = s
    in s4 `seq` (let s2 = leftSupply s4
                     s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (let s1 = leftSupply s2
                                                          s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash
    cd cs)) x158 s0 cd cs) x171 s1 cd cs))
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
    x1)) x159 x172 s3 cd cs) cd cs))
  Choice_C_ORegExp d i l r -> narrow d i (nd_C__case_54 x159 x1 x158 l s cd cs)
    (nd_C__case_54 x159 x1 x158 r s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C__case_54 x159 x1 x158 z
    s cd cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C__case_54 x159 x1 x158 e s
    cd x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_54" [show x159
    , show x1, show x158, show x3] info)
  _ -> failCons cd (consFail "RegExp._case_54" (showCons x3))

nd_C__case_55 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int Curry_Prelude.C_Int -> C_ORegExp t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_55 x144 x1 x143 x3 s cd cs = case x3 of
  C_Nil -> Curry_Prelude.C_False
  C_Literal x145 -> Curry_Prelude.C_False
  C_Xor x146 x147 -> Curry_Prelude.C_False
  C_Star x148 -> Curry_Prelude.C_False
  C_Plus x149 -> Curry_Prelude.C_False
  C_AnyLiteral -> Curry_Prelude.C_False
  C_Bracket x150 -> Curry_Prelude.C_False
  C_NegBracket x151 -> Curry_Prelude.C_False
  C_Start x152 -> Curry_Prelude.C_False
  C_End x153 -> Curry_Prelude.C_False
  C_Times x154 x155 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
    (wrapNX id
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Int_hash)
    x143 x154 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
    x1)) x144 x155 s1 cd cs) cd cs))
  C_Capture x156 x157 -> Curry_Prelude.C_False
  Choice_C_ORegExp d i l r -> narrow d i (nd_C__case_55 x144 x1 x143 l s cd cs)
    (nd_C__case_55 x144 x1 x143 r s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C__case_55 x144 x1 x143 z
    s cd cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C__case_55 x144 x1 x143 e s
    cd x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_55" [show x144
    , show x1, show x143, show x3] info)
  _ -> failCons cd (consFail "RegExp._case_55" (showCons x3))

nd_C__case_56 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_ORegExp t0 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_56 x129 x1 x3 s cd cs = case x3 of
  C_Nil -> Curry_Prelude.C_False
  C_Literal x130 -> Curry_Prelude.C_False
  C_Xor x131 x132 -> Curry_Prelude.C_False
  C_Star x133 -> Curry_Prelude.C_False
  C_Plus x134 -> Curry_Prelude.C_False
  C_AnyLiteral -> Curry_Prelude.C_False
  C_Bracket x135 -> Curry_Prelude.C_False
  C_NegBracket x136 -> Curry_Prelude.C_False
  C_Start x137 -> Curry_Prelude.C_False
  C_End x138 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
    x1)) x129 x138 s0 cd cs
  C_Times x139 x140 -> Curry_Prelude.C_False
  C_Capture x141 x142 -> Curry_Prelude.C_False
  Choice_C_ORegExp d i l r -> narrow d i (nd_C__case_56 x129 x1 l s cd cs)
    (nd_C__case_56 x129 x1 r s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C__case_56 x129 x1 z s cd
    cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C__case_56 x129 x1 e s cd
    x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_56" [show x129
    , show x1, show x3] info)
  _ -> failCons cd (consFail "RegExp._case_56" (showCons x3))

nd_C__case_57 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_ORegExp t0 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_57 x115 x1 x3 s cd cs = case x3 of
  C_Nil -> Curry_Prelude.C_False
  C_Literal x116 -> Curry_Prelude.C_False
  C_Xor x117 x118 -> Curry_Prelude.C_False
  C_Star x119 -> Curry_Prelude.C_False
  C_Plus x120 -> Curry_Prelude.C_False
  C_AnyLiteral -> Curry_Prelude.C_False
  C_Bracket x121 -> Curry_Prelude.C_False
  C_NegBracket x122 -> Curry_Prelude.C_False
  C_Start x123 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
    x1)) x115 x123 s0 cd cs
  C_End x124 -> Curry_Prelude.C_False
  C_Times x125 x126 -> Curry_Prelude.C_False
  C_Capture x127 x128 -> Curry_Prelude.C_False
  Choice_C_ORegExp d i l r -> narrow d i (nd_C__case_57 x115 x1 l s cd cs)
    (nd_C__case_57 x115 x1 r s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C__case_57 x115 x1 z s cd
    cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C__case_57 x115 x1 e s cd
    x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_57" [show x115
    , show x1, show x3] info)
  _ -> failCons cd (consFail "RegExp._case_57" (showCons x3))

nd_C__case_58 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 t0 t0)) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_ORegExp
  t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_58 x101 x1 x3 s cd cs = case x3 of
  C_Nil -> Curry_Prelude.C_False
  C_Literal x102 -> Curry_Prelude.C_False
  C_Xor x103 x104 -> Curry_Prelude.C_False
  C_Star x105 -> Curry_Prelude.C_False
  C_Plus x106 -> Curry_Prelude.C_False
  C_AnyLiteral -> Curry_Prelude.C_False
  C_Bracket x107 -> Curry_Prelude.C_False
  C_NegBracket x108 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Either_hash_0_hash_hash_1_hash_hash
    x1 (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    x1 x1)))) x101 x108 s0 cd cs
  C_Start x109 -> Curry_Prelude.C_False
  C_End x110 -> Curry_Prelude.C_False
  C_Times x111 x112 -> Curry_Prelude.C_False
  C_Capture x113 x114 -> Curry_Prelude.C_False
  Choice_C_ORegExp d i l r -> narrow d i (nd_C__case_58 x101 x1 l s cd cs)
    (nd_C__case_58 x101 x1 r s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C__case_58 x101 x1 z s cd
    cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C__case_58 x101 x1 e s cd
    x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_58" [show x101
    , show x1, show x3] info)
  _ -> failCons cd (consFail "RegExp._case_58" (showCons x3))

nd_C__case_59 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 t0 t0)) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_ORegExp
  t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_59 x87 x1 x3 s cd cs = case x3 of
  C_Nil -> Curry_Prelude.C_False
  C_Literal x88 -> Curry_Prelude.C_False
  C_Xor x89 x90 -> Curry_Prelude.C_False
  C_Star x91 -> Curry_Prelude.C_False
  C_Plus x92 -> Curry_Prelude.C_False
  C_AnyLiteral -> Curry_Prelude.C_False
  C_Bracket x93 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Prelude_dot_Either_hash_0_hash_hash_1_hash_hash
    x1 (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lparen_comma_rparen_hash_0_hash_hash_1_hash_hash
    x1 x1)))) x87 x93 s0 cd cs
  C_NegBracket x94 -> Curry_Prelude.C_False
  C_Start x95 -> Curry_Prelude.C_False
  C_End x96 -> Curry_Prelude.C_False
  C_Times x97 x98 -> Curry_Prelude.C_False
  C_Capture x99 x100 -> Curry_Prelude.C_False
  Choice_C_ORegExp d i l r -> narrow d i (nd_C__case_59 x87 x1 l s cd cs)
    (nd_C__case_59 x87 x1 r s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C__case_59 x87 x1 z s cd
    cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C__case_59 x87 x1 e s cd
    x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_59" [show x87
    , show x1, show x3] info)
  _ -> failCons cd (consFail "RegExp._case_59" (showCons x3))

d_C__case_60 :: forall t0 . (Curry_Prelude.Curry t0) => C_ORegExp t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_60 x3 cd cs = case x3 of
  C_Nil -> Curry_Prelude.C_False
  C_Literal x74 -> Curry_Prelude.C_False
  C_Xor x75 x76 -> Curry_Prelude.C_False
  C_Star x77 -> Curry_Prelude.C_False
  C_Plus x78 -> Curry_Prelude.C_False
  C_AnyLiteral -> Curry_Prelude.C_True
  C_Bracket x79 -> Curry_Prelude.C_False
  C_NegBracket x80 -> Curry_Prelude.C_False
  C_Start x81 -> Curry_Prelude.C_False
  C_End x82 -> Curry_Prelude.C_False
  C_Times x83 x84 -> Curry_Prelude.C_False
  C_Capture x85 x86 -> Curry_Prelude.C_False
  Choice_C_ORegExp d i l r -> narrow d i (d_C__case_60 l cd cs) (d_C__case_60 r
    cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> d_C__case_60 z cd cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> d_C__case_60 e cd x) $! addCs c
    cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_60" [show x3]
    info)
  _ -> failCons cd (consFail "RegExp._case_60" (showCons x3))

nd_C__case_61 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_ORegExp t0 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_61 x60 x1 x3 s cd cs = case x3 of
  C_Nil -> Curry_Prelude.C_False
  C_Literal x61 -> Curry_Prelude.C_False
  C_Xor x62 x63 -> Curry_Prelude.C_False
  C_Star x64 -> Curry_Prelude.C_False
  C_Plus x65 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
    x1)) x60 x65 s0 cd cs
  C_AnyLiteral -> Curry_Prelude.C_False
  C_Bracket x66 -> Curry_Prelude.C_False
  C_NegBracket x67 -> Curry_Prelude.C_False
  C_Start x68 -> Curry_Prelude.C_False
  C_End x69 -> Curry_Prelude.C_False
  C_Times x70 x71 -> Curry_Prelude.C_False
  C_Capture x72 x73 -> Curry_Prelude.C_False
  Choice_C_ORegExp d i l r -> narrow d i (nd_C__case_61 x60 x1 l s cd cs)
    (nd_C__case_61 x60 x1 r s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C__case_61 x60 x1 z s cd
    cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C__case_61 x60 x1 e s cd
    x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_61" [show x60
    , show x1, show x3] info)
  _ -> failCons cd (consFail "RegExp._case_61" (showCons x3))

nd_C__case_62 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_ORegExp t0 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_62 x46 x1 x3 s cd cs = case x3 of
  C_Nil -> Curry_Prelude.C_False
  C_Literal x47 -> Curry_Prelude.C_False
  C_Xor x48 x49 -> Curry_Prelude.C_False
  C_Star x50 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
    x1)) x46 x50 s0 cd cs
  C_Plus x51 -> Curry_Prelude.C_False
  C_AnyLiteral -> Curry_Prelude.C_False
  C_Bracket x52 -> Curry_Prelude.C_False
  C_NegBracket x53 -> Curry_Prelude.C_False
  C_Start x54 -> Curry_Prelude.C_False
  C_End x55 -> Curry_Prelude.C_False
  C_Times x56 x57 -> Curry_Prelude.C_False
  C_Capture x58 x59 -> Curry_Prelude.C_False
  Choice_C_ORegExp d i l r -> narrow d i (nd_C__case_62 x46 x1 l s cd cs)
    (nd_C__case_62 x46 x1 r s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C__case_62 x46 x1 z s cd
    cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C__case_62 x46 x1 e s cd
    x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_62" [show x46
    , show x1, show x3] info)
  _ -> failCons cd (consFail "RegExp._case_62" (showCons x3))

nd_C__case_63 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List
  (C_ORegExp t0) -> C_ORegExp t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_63 x32 x1 x31 x3 s cd cs = case x3 of
  C_Nil -> Curry_Prelude.C_False
  C_Literal x33 -> Curry_Prelude.C_False
  C_Xor x34 x35 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
    x1)) x31 x34 s0 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    (wrapNX id
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_RegExp_dot_ORegExp_hash_0_hash_hash
    x1)) x32 x35 s1 cd cs) cd cs))
  C_Star x36 -> Curry_Prelude.C_False
  C_Plus x37 -> Curry_Prelude.C_False
  C_AnyLiteral -> Curry_Prelude.C_False
  C_Bracket x38 -> Curry_Prelude.C_False
  C_NegBracket x39 -> Curry_Prelude.C_False
  C_Start x40 -> Curry_Prelude.C_False
  C_End x41 -> Curry_Prelude.C_False
  C_Times x42 x43 -> Curry_Prelude.C_False
  C_Capture x44 x45 -> Curry_Prelude.C_False
  Choice_C_ORegExp d i l r -> narrow d i (nd_C__case_63 x32 x1 x31 l s cd cs)
    (nd_C__case_63 x32 x1 x31 r s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C__case_63 x32 x1 x31 z s
    cd cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C__case_63 x32 x1 x31 e s cd
    x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_63" [show x32
    , show x1, show x31, show x3] info)
  _ -> failCons cd (consFail "RegExp._case_63" (showCons x3))

d_C__case_64 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_ORegExp t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_64 x17 x1 x3 cd cs = case x3 of
  C_Nil -> Curry_Prelude.C_False
  C_Literal x18 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_eq_eq_eq x1 cd cs) x17 cd cs) x18 cd cs
  C_Xor x19 x20 -> Curry_Prelude.C_False
  C_Star x21 -> Curry_Prelude.C_False
  C_Plus x22 -> Curry_Prelude.C_False
  C_AnyLiteral -> Curry_Prelude.C_False
  C_Bracket x23 -> Curry_Prelude.C_False
  C_NegBracket x24 -> Curry_Prelude.C_False
  C_Start x25 -> Curry_Prelude.C_False
  C_End x26 -> Curry_Prelude.C_False
  C_Times x27 x28 -> Curry_Prelude.C_False
  C_Capture x29 x30 -> Curry_Prelude.C_False
  Choice_C_ORegExp d i l r -> narrow d i (d_C__case_64 x17 x1 l cd cs)
    (d_C__case_64 x17 x1 r cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> d_C__case_64 x17 x1 z cd cs)
    xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> d_C__case_64 x17 x1 e cd x) $!
    addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_64" [show x17
    , show x1, show x3] info)
  _ -> failCons cd (consFail "RegExp._case_64" (showCons x3))

nd_C__case_64 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_ORegExp
  t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_64 x17 x1 x3 s cd cs = case x3 of
  C_Nil -> Curry_Prelude.C_False
  C_Literal x18 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq_eq
    x1 s0 cd cs) x17 s1 cd cs)) x18 s3 cd cs))
  C_Xor x19 x20 -> Curry_Prelude.C_False
  C_Star x21 -> Curry_Prelude.C_False
  C_Plus x22 -> Curry_Prelude.C_False
  C_AnyLiteral -> Curry_Prelude.C_False
  C_Bracket x23 -> Curry_Prelude.C_False
  C_NegBracket x24 -> Curry_Prelude.C_False
  C_Start x25 -> Curry_Prelude.C_False
  C_End x26 -> Curry_Prelude.C_False
  C_Times x27 x28 -> Curry_Prelude.C_False
  C_Capture x29 x30 -> Curry_Prelude.C_False
  Choice_C_ORegExp d i l r -> narrow d i (nd_C__case_64 x17 x1 l s cd cs)
    (nd_C__case_64 x17 x1 r s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C__case_64 x17 x1 z s cd
    cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C__case_64 x17 x1 e s cd
    x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_64" [show x17
    , show x1, show x3] info)
  _ -> failCons cd (consFail "RegExp._case_64" (showCons x3))

d_C__case_65 :: forall t0 . (Curry_Prelude.Curry t0) => C_ORegExp t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_65 x3 cd cs = case x3 of
  C_Nil -> Curry_Prelude.C_True
  C_Literal x4 -> Curry_Prelude.C_False
  C_Xor x5 x6 -> Curry_Prelude.C_False
  C_Star x7 -> Curry_Prelude.C_False
  C_Plus x8 -> Curry_Prelude.C_False
  C_AnyLiteral -> Curry_Prelude.C_False
  C_Bracket x9 -> Curry_Prelude.C_False
  C_NegBracket x10 -> Curry_Prelude.C_False
  C_Start x11 -> Curry_Prelude.C_False
  C_End x12 -> Curry_Prelude.C_False
  C_Times x13 x14 -> Curry_Prelude.C_False
  C_Capture x15 x16 -> Curry_Prelude.C_False
  Choice_C_ORegExp d i l r -> narrow d i (d_C__case_65 l cd cs) (d_C__case_65 r
    cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> d_C__case_65 z cd cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> d_C__case_65 e cd x) $! addCs c
    cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_65" [show x3]
    info)
  _ -> failCons cd (consFail "RegExp._case_65" (showCons x3))

nd_C__case_53 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_List t0 -> t0 -> Curry_Prelude.OP_List (C_ORegExp t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Num t1) -> t1
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> t1
nd_C__case_53 x8 x7 x4 x3 x1 x2 x6 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> x6
  Curry_Prelude.C_False -> let s10 = s
    in s10 `seq` (let s9 = leftSupply s10
                      s7 = rightSupply s10
    in s9 `seq` (s7 `seq` nd_OP_grepPos_dot_grepPos_tick_dot_42 x1 x2 x3 x4 x8
    (let s6 = leftSupply s7
         s8 = rightSupply s7
         s2 = leftSupply s8
         s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s2 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_plus x2
    s0 cd cs) x6 s1 cd cs)) (let s4 = leftSupply s5
                                 s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_fromInt
    x2 s3 cd cs) (Curry_Prelude.C_Int (1)) s4 cd cs)) s6 cd cs)))) s9 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_53 x8 x7 x4 x3
    x1 x2 x6 l s cd cs) (nd_C__case_53 x8 x7 x4 x3 x1 x2 x6 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_53 x8
    x7 x4 x3 x1 x2 x6 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_53 x8 x7
    x4 x3 x1 x2 x6 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_53"
    [show x8, show x7, show x4, show x3, show x1, show x2, show x6, show x9]
    info)
  _ -> failCons cd (consFail "RegExp._case_53" (showCons x9))

nd_C__case_52 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t1 -> t1 -> Curry_Prelude.OP_List (C_ORegExp t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t1)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Num t0) -> t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C__case_52 x8 x7 x4 x3 x1 x2 x6 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s10 = s
    in s10 `seq` Curry_Prelude.OP_Cons x6 (let s9 = leftSupply s10
                                               s7 = rightSupply s10
    in s9 `seq` (s7 `seq` nd_OP_grep_dot_grep_tick_dot_50 x1 x2 x3 x4 x8
    (let s6 = leftSupply s7
         s8 = rightSupply s7
         s2 = leftSupply s8
         s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s2 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_plus x2
    s0 cd cs) x6 s1 cd cs)) (let s4 = leftSupply s5
                                 s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_fromInt
    x2 s3 cd cs) (Curry_Prelude.C_Int (1)) s4 cd cs)) s6 cd cs)))) s9 cd cs))
  Curry_Prelude.C_False -> let s10 = s
    in s10 `seq` (let s9 = leftSupply s10
                      s7 = rightSupply s10
    in s9 `seq` (s7 `seq` nd_OP_grep_dot_grep_tick_dot_50 x1 x2 x3 x4 x8
    (let s6 = leftSupply s7
         s8 = rightSupply s7
         s2 = leftSupply s8
         s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s2 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_plus x2
    s0 cd cs) x6 s1 cd cs)) (let s4 = leftSupply s5
                                 s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_fromInt
    x2 s3 cd cs) (Curry_Prelude.C_Int (1)) s4 cd cs)) s6 cd cs)))) s9 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_52 x8 x7 x4 x3
    x1 x2 x6 l s cd cs) (nd_C__case_52 x8 x7 x4 x3 x1 x2 x6 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_52 x8
    x7 x4 x3 x1 x2 x6 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_52 x8 x7
    x4 x3 x1 x2 x6 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_52"
    [show x8, show x7, show x4, show x3, show x1, show x2, show x6, show x9]
    info)
  _ -> failCons cd (consFail "RegExp._case_52" (showCons x9))

d_C__case_51 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C__case_51 x5 x3 x2 x1 x4 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> x5
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_51 x5 x3 x2 x1 x4
    l cd cs) (d_C__case_51 x5 x3 x2 x1 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_51 x5
    x3 x2 x1 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_51 x5 x3
    x2 x1 x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_51"
    [show x5, show x3, show x2, show x1, show x4, show x6] info)
  _ -> failCons cd (consFail "RegExp._case_51" (showCons x6))

nd_C__case_51 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> Curry_Prelude.OP_List (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C__case_51 x5 x3 x2 x1 x4 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> x5
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_51 x5 x3 x2 x1
    x4 l s cd cs) (nd_C__case_51 x5 x3 x2 x1 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_51 x5
    x3 x2 x1 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_51 x5 x3
    x2 x1 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_51"
    [show x5, show x3, show x2, show x1, show x4, show x6] info)
  _ -> failCons cd (consFail "RegExp._case_51" (showCons x6))

nd_C__case_50 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> Curry_Prelude.OP_List (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_ORegExp t0 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_50 x4 x6 x2 x1 x5 s cd cs = case x5 of
  C_Nil -> let s0 = s in s0 `seq` nd_C_match x1 x2 x6 x4 s0 cd cs
  C_Xor x7 x8 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_bar_bar (nd_C_match x1 x2
    (Curry_Prelude.d_OP_plus_plus x7 x6 cd cs) x4 s0 cd cs) (nd_C_match x1 x2
    (Curry_Prelude.d_OP_plus_plus x8 x6 cd cs) x4 s1 cd cs) cd cs))
  C_Literal x9 -> let s0 = s in s0 `seq` nd_C__case_49 x9 x2 x6 x1 x4 s0 cd cs
  C_Star x12 -> let s0 = s in s0 `seq` nd_C_matchstar x1 x2 x12 x6 x4 s0 cd cs
  C_Plus x13 -> let s0 = s in s0 `seq` nd_C_matchplus x1 x2 x13 x6 x4 s0 cd cs
  C_AnyLiteral -> let s0 = s in s0 `seq` nd_C__case_47 x6 x2 x1 x4 s0 cd cs
  C_Bracket x16 -> let s0 = s in s0 `seq` nd_C__case_46 x6 x2 x1 x16 x4 s0 cd cs
  C_NegBracket x19 -> let s0 = s
    in s0 `seq` nd_C__case_45 x6 x2 x1 x19 x4 s0 cd cs
  C_Start x22 -> let s7 = s
    in s7 `seq` (let s6 = leftSupply s7
                     s8 = rightSupply s7
                     s4 = leftSupply s8
                     s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s4 `seq` (s5 `seq` Curry_Prelude.nd_OP_dollar
    (let s3 = leftSupply s4
         s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    Curry_Prelude.d_C_not) (let s1 = leftSupply s2
                                s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    Curry_Prelude.d_C_null) (Curry_Prelude.nd_OP_dot (wrapNX id
    (Curry_Prelude.nd_C_filter (wrapDX id Curry_Prelude.d_C_id))) (wrapDX id
    Control.Search.Curry_Unsafe.d_C_allValues) s0 cd cs) s1 cd cs)) s3 cd cs))
    (nd_C_matchstart x1 x2 (Curry_Prelude.OP_Cons (C_Start x22) x6) x4 s5 cd cs)
    s6 cd cs))))
  C_End x23 -> let s0 = s in s0 `seq` nd_C__case_44 x4 x23 x2 x1 x6 s0 cd cs
  C_Times x42 x43 -> let s0 = s
    in s0 `seq` nd_C__case_41 x6 x43 x4 x2 x1 x42 s0 cd cs
  C_Capture x46 x47 -> let s0 = s
    in s0 `seq` nd_C_match x1 x2 (Curry_Prelude.d_OP_plus_plus x47 x6 cd cs) x4
    s0 cd cs
  Choice_C_ORegExp d i l r -> narrow d i (nd_C__case_50 x4 x6 x2 x1 l s cd cs)
    (nd_C__case_50 x4 x6 x2 x1 r s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C__case_50 x4 x6 x2 x1 z
    s cd cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C__case_50 x4 x6 x2 x1 e s
    cd x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_50" [show x4
    , show x6, show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "RegExp._case_50" (showCons x5))

nd_C__case_41 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Curry_Prelude.OP_List (C_ORegExp t0)
  -> Curry_Prelude.OP_List t0 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_41 x6 x43 x4 x2 x1 x42 s cd cs = case x42 of
  Curry_Prelude.OP_Tuple2 x44 x45 -> let s0 = s
    in s0 `seq` nd_C_matchtimes x1 x2 x4 x44 x45 x43 x6 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_41 x6 x43 x4
    x2 x1 l s cd cs) (nd_C__case_41 x6 x43 x4 x2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_41
    x6 x43 x4 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_41 x6
    x43 x4 x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "RegExp._case_41"
    [show x6, show x43, show x4, show x2, show x1, show x42] info)
  _ -> failCons cd (consFail "RegExp._case_41" (showCons x42))

nd_C__case_44 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> Curry_Prelude.OP_List (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List
  (C_ORegExp t0) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_44 x4 x23 x2 x1 x6 s cd cs = case x6 of
  Curry_Prelude.OP_List -> let s7 = s
    in s7 `seq` (let s6 = leftSupply s7
                     s8 = rightSupply s7
                     s4 = leftSupply s8
                     s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s4 `seq` (s5 `seq` Curry_Prelude.nd_OP_dollar
    (let s3 = leftSupply s4
         s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    Curry_Prelude.d_C_not) (let s1 = leftSupply s2
                                s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    Curry_Prelude.d_C_null) (Curry_Prelude.nd_OP_dot (wrapNX id
    (Curry_Prelude.nd_C_filter (wrapDX id Curry_Prelude.d_C_id))) (wrapDX id
    Control.Search.Curry_Unsafe.d_C_allValues) s0 cd cs) s1 cd cs)) s3 cd cs))
    (nd_C_matchend x1 x2 (C_End x23) x4 s5 cd cs) s6 cd cs))))
  Curry_Prelude.OP_Cons x24 x25 -> let s0 = s
    in s0 `seq` (let x26 = Curry_Prelude.C_False
    in nd_C__case_43 x26 x25 x4 x23 x2 x1 x24 s0 cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_44 x4 x23 x2 x1
    l s cd cs) (nd_C__case_44 x4 x23 x2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_44 x4
    x23 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_44 x4
    x23 x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_44"
    [show x4, show x23, show x2, show x1, show x6] info)
  _ -> failCons cd (consFail "RegExp._case_44" (showCons x6))

nd_C__case_43 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_ORegExp t0 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_43 x26 x25 x4 x23 x2 x1 x24 s cd cs = case x24 of
  C_Nil -> let s0 = s in s0 `seq` nd_C__case_42 x4 x23 x2 x1 x25 s0 cd cs
  C_Literal x29 -> x26
  C_Xor x30 x31 -> x26
  C_Star x32 -> x26
  C_Plus x33 -> x26
  C_AnyLiteral -> x26
  C_Bracket x34 -> x26
  C_NegBracket x35 -> x26
  C_Start x36 -> x26
  C_End x37 -> x26
  C_Times x38 x39 -> x26
  C_Capture x40 x41 -> x26
  Choice_C_ORegExp d i l r -> narrow d i (nd_C__case_43 x26 x25 x4 x23 x2 x1 l s
    cd cs) (nd_C__case_43 x26 x25 x4 x23 x2 x1 r s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C__case_43 x26 x25 x4 x23
    x2 x1 z s cd cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C__case_43 x26 x25 x4 x23 x2
    x1 e s cd x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_43" [show x26
    , show x25, show x4, show x23, show x2, show x1, show x24] info)
  _ -> failCons cd (consFail "RegExp._case_43" (showCons x24))

nd_C__case_42 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> Curry_Prelude.OP_List (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List
  (C_ORegExp t0) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_42 x4 x23 x2 x1 x25 s cd cs = case x25 of
  Curry_Prelude.OP_List -> let s7 = s
    in s7 `seq` (let s6 = leftSupply s7
                     s8 = rightSupply s7
                     s4 = leftSupply s8
                     s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s4 `seq` (s5 `seq` Curry_Prelude.nd_OP_dollar
    (let s3 = leftSupply s4
         s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    Curry_Prelude.d_C_not) (let s1 = leftSupply s2
                                s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    Curry_Prelude.d_C_null) (Curry_Prelude.nd_OP_dot (wrapNX id
    (Curry_Prelude.nd_C_filter (wrapDX id Curry_Prelude.d_C_id))) (wrapDX id
    Control.Search.Curry_Unsafe.d_C_allValues) s0 cd cs) s1 cd cs)) s3 cd cs))
    (nd_C_matchend x1 x2 (C_End x23) x4 s5 cd cs) s6 cd cs))))
  Curry_Prelude.OP_Cons x27 x28 -> Curry_Prelude.C_False
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_42 x4 x23 x2 x1
    l s cd cs) (nd_C__case_42 x4 x23 x2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_42 x4
    x23 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_42 x4
    x23 x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_42"
    [show x4, show x23, show x2, show x1, show x25] info)
  _ -> failCons cd (consFail "RegExp._case_42" (showCons x25))

nd_C__case_45 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 t0 t0))
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_45 x6 x2 x1 x19 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.C_False
  Curry_Prelude.OP_Cons x20 x21 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_not
    (nd_C_matchbracket x1 x2 x19 x20 s0 cd cs) cd cs) (nd_C_match x1 x2 x6 x21
    s1 cd cs) cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_45 x6 x2 x1 x19
    l s cd cs) (nd_C__case_45 x6 x2 x1 x19 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_45 x6
    x2 x1 x19 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_45 x6 x2
    x1 x19 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_45"
    [show x6, show x2, show x1, show x19, show x4] info)
  _ -> failCons cd (consFail "RegExp._case_45" (showCons x4))

nd_C__case_46 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 t0 t0))
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_46 x6 x2 x1 x16 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.C_False
  Curry_Prelude.OP_Cons x17 x18 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp (nd_C_matchbracket x1 x2
    x16 x17 s0 cd cs) (nd_C_match x1 x2 x6 x18 s1 cd cs) cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_46 x6 x2 x1 x16
    l s cd cs) (nd_C__case_46 x6 x2 x1 x16 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_46 x6
    x2 x1 x16 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_46 x6 x2
    x1 x16 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_46"
    [show x6, show x2, show x1, show x16, show x4] info)
  _ -> failCons cd (consFail "RegExp._case_46" (showCons x4))

nd_C__case_47 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_47 x6 x2 x1 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.C_False
  Curry_Prelude.OP_Cons x14 x15 -> let s0 = s
    in s0 `seq` nd_C_match x1 x2 x6 x15 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_47 x6 x2 x1 l s
    cd cs) (nd_C__case_47 x6 x2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_47 x6
    x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_47 x6 x2
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_47"
    [show x6, show x2, show x1, show x4] info)
  _ -> failCons cd (consFail "RegExp._case_47" (showCons x4))

nd_C__case_49 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_49 x9 x2 x6 x1 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.C_False
  Curry_Prelude.OP_Cons x10 x11 -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s6 = rightSupply s8
    in s7 `seq` (s6 `seq` nd_C__case_48 x9 x10 x2 x11 x6 x1 (let s5 = leftSupply
                                                                   s6
                                                                 s4 = rightSupply
                                                                   s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_eq_eq
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq_hash_0_hash
    x2 s0 cd cs) s1 cd cs)) x10 s3 cd cs)) x9 s5 cd cs)) s7 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_49 x9 x2 x6 x1
    l s cd cs) (nd_C__case_49 x9 x2 x6 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_49 x9
    x2 x6 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_49 x9 x2
    x6 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_49"
    [show x9, show x2, show x6, show x1, show x4] info)
  _ -> failCons cd (consFail "RegExp._case_49" (showCons x4))

nd_C__case_48 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List (C_ORegExp t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_48 x9 x10 x2 x11 x6 x1 x12 s cd cs = case x12 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_match x1 x2 x6 x11 s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.C_False
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_48 x9 x10 x2 x11
    x6 x1 l s cd cs) (nd_C__case_48 x9 x10 x2 x11 x6 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_48 x9
    x10 x2 x11 x6 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_48 x9 x10
    x2 x11 x6 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_48"
    [show x9, show x10, show x2, show x11, show x6, show x1, show x12] info)
  _ -> failCons cd (consFail "RegExp._case_48" (showCons x12))

nd_C__case_40 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List t0
  -> C_ORegExp t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_40 x6 x2 x1 x4 x5 s cd cs = case x5 of
  C_Start x7 -> let s0 = s in s0 `seq` nd_C__case_39 x2 x1 x7 x4 x6 s0 cd cs
  C_Nil -> Curry_Prelude.d_C_failed cd cs
  C_Literal x13 -> Curry_Prelude.d_C_failed cd cs
  C_Xor x14 x15 -> Curry_Prelude.d_C_failed cd cs
  C_Star x16 -> Curry_Prelude.d_C_failed cd cs
  C_Plus x17 -> Curry_Prelude.d_C_failed cd cs
  C_AnyLiteral -> Curry_Prelude.d_C_failed cd cs
  C_Bracket x18 -> Curry_Prelude.d_C_failed cd cs
  C_NegBracket x19 -> Curry_Prelude.d_C_failed cd cs
  C_End x20 -> Curry_Prelude.d_C_failed cd cs
  C_Times x21 x22 -> Curry_Prelude.d_C_failed cd cs
  C_Capture x23 x24 -> Curry_Prelude.d_C_failed cd cs
  Choice_C_ORegExp d i l r -> narrow d i (nd_C__case_40 x6 x2 x1 x4 l s cd cs)
    (nd_C__case_40 x6 x2 x1 x4 r s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C__case_40 x6 x2 x1 x4 z
    s cd cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C__case_40 x6 x2 x1 x4 e s
    cd x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_40" [show x6
    , show x2, show x1, show x4, show x5] info)
  _ -> failCons cd (consFail "RegExp._case_40" (showCons x5))

nd_C__case_39 :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_39 x2 x1 x7 x4 x6 s cd cs = case x6 of
  Curry_Prelude.OP_List -> let s4 = s
    in s4 `seq` (let s0 = leftSupply s4
                     s3 = rightSupply s4
    in s0 `seq` (s3 `seq` (let x8 = generate s0 cd
    in let s1 = leftSupply s3
           s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_eq_colon_eq (Curry_Prelude.d_OP_plus_plus x8
    (Curry_Prelude.nd_C_unknown (wrapNX id
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_lbracket_rbracket_hash_0_hash_hash
    x1)) s1 cd cs) cd cs) x4 cd cs) (nd_C_match x1 x2 x7 x8 s2 cd cs) cd cs))))
  Curry_Prelude.OP_Cons x9 x10 -> let s5 = s
    in s5 `seq` (let s0 = leftSupply s5
                     s6 = rightSupply s5
                     s1 = leftSupply s6
                     s4 = rightSupply s6
    in s0 `seq` (s6 `seq` (s1 `seq` (s4 `seq` (let x11 = generate s0 cd
                                                   x12 = generate s1 cd
    in Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_eq_colon_eq
    (Curry_Prelude.d_OP_plus_plus x11 x12 cd cs) x4 cd cs) (let s2 = leftSupply
                                                                  s4
                                                                s3 = rightSupply
                                                                  s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (nd_C_match x1 x2 x7 x11 s2
    cd cs) (nd_C_match x1 x2 x6 x12 s3 cd cs) cd cs)) cd cs)))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_39 x2 x1 x7 x4
    l s cd cs) (nd_C__case_39 x2 x1 x7 x4 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_39 x2
    x1 x7 x4 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_39 x2 x1
    x7 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_39"
    [show x2, show x1, show x7, show x4, show x6] info)
  _ -> failCons cd (consFail "RegExp._case_39" (showCons x6))

nd_C__case_37 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Curry_Prelude.OP_List (C_ORegExp t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Bool -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_37 x6 x5 x10 x2 x1 x9 x4 s cd cs = case x4 of
  Curry_Prelude.OP_Cons x11 x12 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_bar_bar (nd_C__case_36 x11 x6 x5 x2
    x1 x9 s0 cd cs) (nd_C_tryeach x1 x2 x10 x12 x5 x6 s1 cd cs) cd cs))
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_37 x6 x5 x10 x2
    x1 x9 l s cd cs) (nd_C__case_37 x6 x5 x10 x2 x1 x9 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_37 x6
    x5 x10 x2 x1 x9 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_37 x6 x5
    x10 x2 x1 x9 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_37"
    [show x6, show x5, show x10, show x2, show x1, show x9, show x4] info)
  _ -> failCons cd (consFail "RegExp._case_37" (showCons x4))

nd_C__case_36 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List (C_ORegExp
  t0) -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_36 x11 x6 x5 x2 x1 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_bar_bar (nd_C_match x1 x2 x6 x11 s0
    cd cs) (nd_C_matchstar x1 x2 x5 x6 x11 s1 cd cs) cd cs))
  Curry_Prelude.C_False -> Curry_Prelude.C_False
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_36 x11 x6 x5 x2
    x1 l s cd cs) (nd_C__case_36 x11 x6 x5 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_36 x11
    x6 x5 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_36 x11 x6
    x5 x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_36"
    [show x11, show x6, show x5, show x2, show x1, show x9] info)
  _ -> failCons cd (consFail "RegExp._case_36" (showCons x9))

d_C__case_38 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_38 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.C_False
  Curry_Prelude.OP_Cons x7 x8 -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_38 l cd cs)
    (d_C__case_38 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_38 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_38 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_38"
    [show x4] info)
  _ -> failCons cd (consFail "RegExp._case_38" (showCons x4))

d_C__case_35 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2
  t0 t0)) -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 t0 t0) -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_35 x4 x6 x2 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_Left x7 -> d_C__case_34 x4 x7 x2 x6 x1
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq_hash_0_hash
    x2 cd cs) cd cs) x7 cd cs) x4 cd cs) cd cs
  Curry_Prelude.C_Right x8 -> d_C__case_32 x4 x6 x2 x1 x8 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C__case_35 x4 x6 x2 x1
    l cd cs) (d_C__case_35 x4 x6 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C__case_35 x4
    x6 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c ((\x -> d_C__case_35 x4 x6
    x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail "RegExp._case_35"
    [show x4, show x6, show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "RegExp._case_35" (showCons x5))

nd_C__case_35 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2
  t0 t0)) -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord
  t0) -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 t0 t0) -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_35 x4 x6 x2 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_Left x7 -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s6 = rightSupply s8
    in s7 `seq` (s6 `seq` nd_C__case_34 x4 x7 x2 x6 x1 (let s5 = leftSupply s6
                                                            s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_eq_eq
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq_hash_0_hash
    x2 s0 cd cs) s1 cd cs)) x7 s3 cd cs)) x4 s5 cd cs)) s7 cd cs))
  Curry_Prelude.C_Right x8 -> let s0 = s
    in s0 `seq` nd_C__case_32 x4 x6 x2 x1 x8 s0 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (nd_C__case_35 x4 x6 x2 x1
    l s cd cs) (nd_C__case_35 x4 x6 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> nd_C__case_35
    x4 x6 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c ((\x -> nd_C__case_35 x4
    x6 x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail "RegExp._case_35"
    [show x4, show x6, show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "RegExp._case_35" (showCons x5))

d_C__case_32 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2
  t0 t0)) -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_Tuple2 t0 t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_32 x4 x6 x2 x1 x8 cd cs = case x8 of
  Curry_Prelude.OP_Tuple2 x9 x10 -> Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_gt_eq x2 cd cs) x4 cd cs) x9 cd
    cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_lt_eq x2 cd cs) x4 cd cs) x10 cd cs) cd cs)
    (d_C_matchbracket x1 x2 x6 x4 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_32 x4 x6 x2 x1
    l cd cs) (d_C__case_32 x4 x6 x2 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_32
    x4 x6 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_32 x4
    x6 x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "RegExp._case_32"
    [show x4, show x6, show x2, show x1, show x8] info)
  _ -> failCons cd (consFail "RegExp._case_32" (showCons x8))

nd_C__case_32 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2
  t0 t0)) -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord
  t0) -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_Tuple2 t0 t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_32 x4 x6 x2 x1 x8 s cd cs = case x8 of
  Curry_Prelude.OP_Tuple2 x9 x10 -> let s12 = s
    in s12 `seq` (let s10 = leftSupply s12
                      s11 = rightSupply s12
    in s10 `seq` (s11 `seq` Curry_Prelude.d_OP_bar_bar (let s4 = leftSupply s10
                                                            s9 = rightSupply s10
    in s4 `seq` (s9 `seq` Curry_Prelude.d_OP_amp_amp (let s3 = leftSupply s4
                                                          s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_gt_eq x2
    s0 cd cs) x4 s1 cd cs)) x9 s3 cd cs)) (let s8 = leftSupply s9
                                               s7 = rightSupply s9
    in s8 `seq` (s7 `seq` Curry_Prelude.nd_C_apply (let s6 = leftSupply s7
                                                        s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_lt_eq x2
    s5 cd cs) x4 s6 cd cs)) x10 s8 cd cs)) cd cs)) (nd_C_matchbracket x1 x2 x6
    x4 s11 cd cs) cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_32 x4 x6 x2
    x1 l s cd cs) (nd_C__case_32 x4 x6 x2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_32
    x4 x6 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_32 x4
    x6 x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "RegExp._case_32"
    [show x4, show x6, show x2, show x1, show x8] info)
  _ -> failCons cd (consFail "RegExp._case_32" (showCons x8))

d_C__case_34 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 t0 t0))
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_34 x4 x7 x2 x6 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.C_True
  Curry_Prelude.C_False -> d_C__case_33 x4 x7 x2 x6 x1 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_slash_eq
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq_hash_0_hash
    x2 cd cs) cd cs) x7 cd cs) x4 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_34 x4 x7 x2 x6 x1
    l cd cs) (d_C__case_34 x4 x7 x2 x6 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_34 x4
    x7 x2 x6 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_34 x4 x7
    x2 x6 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_34"
    [show x4, show x7, show x2, show x6, show x1, show x8] info)
  _ -> failCons cd (consFail "RegExp._case_34" (showCons x8))

nd_C__case_34 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2
  t0 t0)) -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data
  t0) -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_34 x4 x7 x2 x6 x1 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.C_True
  Curry_Prelude.C_False -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s6 = rightSupply s8
    in s7 `seq` (s6 `seq` nd_C__case_33 x4 x7 x2 x6 x1 (let s5 = leftSupply s6
                                                            s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_slash_eq
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq_hash_0_hash
    x2 s0 cd cs) s1 cd cs)) x7 s3 cd cs)) x4 s5 cd cs)) s7 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_34 x4 x7 x2 x6
    x1 l s cd cs) (nd_C__case_34 x4 x7 x2 x6 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_34 x4
    x7 x2 x6 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_34 x4 x7
    x2 x6 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_34"
    [show x4, show x7, show x2, show x6, show x1, show x8] info)
  _ -> failCons cd (consFail "RegExp._case_34" (showCons x8))

d_C__case_33 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 t0 t0))
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_33 x4 x7 x2 x6 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> d_C_matchbracket x1 x2 x6 x4 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_33 x4 x7 x2 x6 x1
    l cd cs) (d_C__case_33 x4 x7 x2 x6 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_33 x4
    x7 x2 x6 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_33 x4 x7
    x2 x6 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_33"
    [show x4, show x7, show x2, show x6, show x1, show x8] info)
  _ -> failCons cd (consFail "RegExp._case_33" (showCons x8))

nd_C__case_33 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2
  t0 t0)) -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data
  t0) -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_33 x4 x7 x2 x6 x1 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_matchbracket x1 x2 x6 x4 s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_33 x4 x7 x2 x6
    x1 l s cd cs) (nd_C__case_33 x4 x7 x2 x6 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_33 x4
    x7 x2 x6 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_33 x4 x7
    x2 x6 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_33"
    [show x4, show x7, show x2, show x6, show x1, show x8] info)
  _ -> failCons cd (consFail "RegExp._case_33" (showCons x8))

nd_C__case_31 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List (C_ORegExp
  t0) -> Curry_Prelude.OP_List t0 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List
  (C_ORegExp t0) -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_31 x5 x7 x6 x3 x2 x1 x8 x4 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C_match x1 x2 x7 x3 s0 cd cs
  Curry_Prelude.C_False -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_30 x5 x7 x6 x3 x2 x1 x8 x4
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int_hash
    cd cs)) x5 s0 cd cs) (Curry_Prelude.C_Int (0)) s1 cd cs)) s3 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_31 x5 x7 x6 x3
    x2 x1 x8 x4 l s cd cs) (nd_C__case_31 x5 x7 x6 x3 x2 x1 x8 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_31 x5
    x7 x6 x3 x2 x1 x8 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_31 x5 x7
    x6 x3 x2 x1 x8 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_31"
    [show x5, show x7, show x6, show x3, show x2, show x1, show x8, show x4
    , show x9] info)
  _ -> failCons cd (consFail "RegExp._case_31" (showCons x9))

nd_C__case_30 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List (C_ORegExp
  t0) -> Curry_Prelude.OP_List t0 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List
  (C_ORegExp t0) -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_30 x5 x7 x6 x3 x2 x1 x8 x4 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C_tryeachRestricted x1 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_minus_hash_Prelude_dot_Num_hash_Prelude_dot_Int_hash
    x5 x4 cd cs) (Curry_Prelude.nd_C_map (wrapNX id
    (nd_OP_matchtimes_dot_uscore_hash_lambda8 x8 x1 x2))
    (Data.Curry_List.d_C_inits x3 cd cs) s0 cd cs) (Data.Curry_List.d_C_tails x3
    cd cs) x6 x7 s1 cd cs))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_30 x5 x7 x6 x3
    x2 x1 x8 x4 l s cd cs) (nd_C__case_30 x5 x7 x6 x3 x2 x1 x8 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_30 x5
    x7 x6 x3 x2 x1 x8 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_30 x5 x7
    x6 x3 x2 x1 x8 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_30"
    [show x5, show x7, show x6, show x3, show x2, show x1, show x8, show x4
    , show x9] info)
  _ -> failCons cd (consFail "RegExp._case_30" (showCons x9))

nd_C__case_28 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Curry_Prelude.OP_List (C_ORegExp t0)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Bool -> Curry_Prelude.C_Int -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_28 x7 x6 x11 x3 x2 x1 x10 x5 s cd cs = case x5 of
  Curry_Prelude.OP_Cons x12 x13 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_bar_bar (nd_C__case_27 x7 x6 x3 x12
    x2 x1 x10 s0 cd cs) (nd_C_tryeachRestricted x1 x2 x3 x11 x13 x6 x7 s1 cd cs)
    cd cs))
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_28 x7 x6 x11 x3
    x2 x1 x10 l s cd cs) (nd_C__case_28 x7 x6 x11 x3 x2 x1 x10 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_28 x7
    x6 x11 x3 x2 x1 x10 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_28 x7 x6
    x11 x3 x2 x1 x10 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_28"
    [show x7, show x6, show x11, show x3, show x2, show x1, show x10, show x5]
    info)
  _ -> failCons cd (consFail "RegExp._case_28" (showCons x5))

nd_C__case_27 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List t0 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_27 x7 x6 x3 x12 x2 x1 x10 s cd cs = case x10 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_bar_bar (nd_C_match x1 x2 x7 x12 s0
    cd cs) (nd_C_matchtimes x1 x2 x12 (Curry_Prelude.C_Int (1)) x3 x6 x7 s1 cd
    cs) cd cs))
  Curry_Prelude.C_False -> Curry_Prelude.C_False
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_27 x7 x6 x3 x12
    x2 x1 l s cd cs) (nd_C__case_27 x7 x6 x3 x12 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_27 x7
    x6 x3 x12 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_27 x7 x6
    x3 x12 x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_27"
    [show x7, show x6, show x3, show x12, show x2, show x1, show x10] info)
  _ -> failCons cd (consFail "RegExp._case_27" (showCons x10))

d_C__case_29 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_29 x5 cd cs = case x5 of
  Curry_Prelude.OP_List -> Curry_Prelude.C_False
  Curry_Prelude.OP_Cons x8 x9 -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_29 l cd cs)
    (d_C__case_29 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_29 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_29 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_29"
    [show x5] info)
  _ -> failCons cd (consFail "RegExp._case_29" (showCons x5))

nd_C__case_26 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> Curry_Prelude.OP_List (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_ORegExp t0 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))
nd_C__case_26 x4 x6 x2 x1 x5 s cd cs = case x5 of
  C_Nil -> let s0 = s in s0 `seq` nd_C_capture x1 x2 x6 x4 s0 cd cs
  C_Xor x7 x8 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_25 x4 x6 x7 x2 x1 x8 (nd_C_match x1 x2
    (Curry_Prelude.d_OP_plus_plus x7 x6 cd cs) x4 s0 cd cs) s1 cd cs))
  C_Literal x9 -> let s0 = s in s0 `seq` nd_C__case_24 x9 x2 x6 x1 x4 s0 cd cs
  C_Star x12 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_con x1
    x2)) (let s1 = leftSupply s2
              s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Control.Search.Curry_Unsafe.d_C_allValues) (nd_C_captureStar x1 x2
    (Curry_Prelude.OP_Cons (C_Star x12) x6) x4 s0 cd cs) s1 cd cs)) s3 cd cs))
  C_Plus x13 -> let s0 = s
    in s0 `seq` nd_C_capture x1 x2 (Curry_Prelude.d_OP_plus_plus x13
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (C_Star x13)
    Curry_Prelude.OP_List) x6 cd cs) cd cs) x4 s0 cd cs
  C_AnyLiteral -> let s0 = s in s0 `seq` nd_C__case_22 x6 x2 x1 x4 s0 cd cs
  C_Bracket x16 -> let s0 = s in s0 `seq` nd_C__case_21 x16 x2 x1 x6 x4 s0 cd cs
  C_NegBracket x19 -> let s0 = s
    in s0 `seq` nd_C__case_19 x19 x2 x1 x6 x4 s0 cd cs
  C_Start x22 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_con x1
    x2)) (let s1 = leftSupply s2
              s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Control.Search.Curry_Unsafe.d_C_allValues) (nd_C_captureStart x1 x2
    (Curry_Prelude.OP_Cons (C_Start x22) x6) x4 s0 cd cs) s1 cd cs)) s3 cd cs))
  C_End x23 -> let s0 = s in s0 `seq` nd_C__case_17 x4 x23 x2 x1 x6 s0 cd cs
  C_Times x42 x43 -> let s0 = s
    in s0 `seq` nd_C__case_14 x4 x6 x43 x2 x1 x42 s0 cd cs
  C_Capture x46 x47 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_con x1
    x2)) (let s1 = leftSupply s2
              s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Control.Search.Curry_Unsafe.d_C_allValues) (nd_C_captureCapture x1 x2
    (Curry_Prelude.OP_Cons (C_Capture x46 x47) x6) x4 s0 cd cs) s1 cd cs)) s3 cd
    cs))
  Choice_C_ORegExp d i l r -> narrow d i (nd_C__case_26 x4 x6 x2 x1 l s cd cs)
    (nd_C__case_26 x4 x6 x2 x1 r s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C__case_26 x4 x6 x2 x1 z
    s cd cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C__case_26 x4 x6 x2 x1 e s
    cd x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_26" [show x4
    , show x6, show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "RegExp._case_26" (showCons x5))

nd_C__case_14 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List (C_ORegExp
  t0) -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_Prelude.C_Int -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))
nd_C__case_14 x4 x6 x43 x2 x1 x42 s cd cs = case x42 of
  Curry_Prelude.OP_Tuple2 x44 x45 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_con x1
    x2)) (let s1 = leftSupply s2
              s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Control.Search.Curry_Unsafe.d_C_allValues) (nd_C_captureTimes x1 x2
    (Curry_Prelude.OP_Cons (C_Times (Curry_Prelude.OP_Tuple2 x44 x45) x43) x6)
    x4 s0 cd cs) s1 cd cs)) s3 cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_14 x4 x6 x43
    x2 x1 l s cd cs) (nd_C__case_14 x4 x6 x43 x2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_14
    x4 x6 x43 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_14 x4
    x6 x43 x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "RegExp._case_14"
    [show x4, show x6, show x43, show x2, show x1, show x42] info)
  _ -> failCons cd (consFail "RegExp._case_14" (showCons x42))

nd_C__case_17 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> Curry_Prelude.OP_List (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List
  (C_ORegExp t0) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
nd_C__case_17 x4 x23 x2 x1 x6 s cd cs = case x6 of
  Curry_Prelude.OP_List -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_con x1
    x2)) (let s1 = leftSupply s2
              s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Control.Search.Curry_Unsafe.d_C_allValues) (nd_C_captureEnd x1 x2 (C_End
    x23) x4 s0 cd cs) s1 cd cs)) s3 cd cs))
  Curry_Prelude.OP_Cons x24 x25 -> let s0 = s
    in s0 `seq` (let x26 = Curry_Prelude.OP_List
    in nd_C__case_16 x26 x25 x4 x23 x2 x1 x24 s0 cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_17 x4 x23 x2 x1
    l s cd cs) (nd_C__case_17 x4 x23 x2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_17 x4
    x23 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_17 x4
    x23 x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_17"
    [show x4, show x23, show x2, show x1, show x6] info)
  _ -> failCons cd (consFail "RegExp._case_17" (showCons x6))

nd_C__case_16 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0))) -> Curry_Prelude.OP_List (C_ORegExp t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List (C_ORegExp t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_ORegExp
  t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
nd_C__case_16 x26 x25 x4 x23 x2 x1 x24 s cd cs = case x24 of
  C_Nil -> let s0 = s in s0 `seq` nd_C__case_15 x4 x23 x2 x1 x25 s0 cd cs
  C_Literal x29 -> x26
  C_Xor x30 x31 -> x26
  C_Star x32 -> x26
  C_Plus x33 -> x26
  C_AnyLiteral -> x26
  C_Bracket x34 -> x26
  C_NegBracket x35 -> x26
  C_Start x36 -> x26
  C_End x37 -> x26
  C_Times x38 x39 -> x26
  C_Capture x40 x41 -> x26
  Choice_C_ORegExp d i l r -> narrow d i (nd_C__case_16 x26 x25 x4 x23 x2 x1 l s
    cd cs) (nd_C__case_16 x26 x25 x4 x23 x2 x1 r s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C__case_16 x26 x25 x4 x23
    x2 x1 z s cd cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C__case_16 x26 x25 x4 x23 x2
    x1 e s cd x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_16" [show x26
    , show x25, show x4, show x23, show x2, show x1, show x24] info)
  _ -> failCons cd (consFail "RegExp._case_16" (showCons x24))

nd_C__case_15 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> Curry_Prelude.OP_List (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List
  (C_ORegExp t0) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
nd_C__case_15 x4 x23 x2 x1 x25 s cd cs = case x25 of
  Curry_Prelude.OP_List -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_con x1
    x2)) (let s1 = leftSupply s2
              s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Control.Search.Curry_Unsafe.d_C_allValues) (nd_C_captureEnd x1 x2 (C_End
    x23) x4 s0 cd cs) s1 cd cs)) s3 cd cs))
  Curry_Prelude.OP_Cons x27 x28 -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_15 x4 x23 x2 x1
    l s cd cs) (nd_C__case_15 x4 x23 x2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_15 x4
    x23 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_15 x4
    x23 x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_15"
    [show x4, show x23, show x2, show x1, show x25] info)
  _ -> failCons cd (consFail "RegExp._case_15" (showCons x25))

nd_C__case_19 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 t0 t0)) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
nd_C__case_19 x19 x2 x1 x6 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x20 x21 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_18 x20 x19 x2 x1 x21 x6
    (Curry_Prelude.d_C_not (nd_C_matchbracket x1 x2 x19 x20 s0 cd cs) cd cs) s1
    cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_19 x19 x2 x1 x6
    l s cd cs) (nd_C__case_19 x19 x2 x1 x6 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_19
    x19 x2 x1 x6 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_19 x19
    x2 x1 x6 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_19"
    [show x19, show x2, show x1, show x6, show x4] info)
  _ -> failCons cd (consFail "RegExp._case_19" (showCons x4))

nd_C__case_18 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2
  t0 t0)) -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord
  t0) -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List (C_ORegExp t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))
nd_C__case_18 x20 x19 x2 x1 x21 x6 x22 s cd cs = case x22 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_capture x1 x2 x6 x21 s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_18 x20 x19 x2 x1
    x21 x6 l s cd cs) (nd_C__case_18 x20 x19 x2 x1 x21 x6 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_18 x20
    x19 x2 x1 x21 x6 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_18 x20
    x19 x2 x1 x21 x6 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_18"
    [show x20, show x19, show x2, show x1, show x21, show x6, show x22] info)
  _ -> failCons cd (consFail "RegExp._case_18" (showCons x22))

nd_C__case_21 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 t0 t0)) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
nd_C__case_21 x16 x2 x1 x6 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x17 x18 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_20 x17 x16 x2 x1 x18 x6 (nd_C_matchbracket
    x1 x2 x16 x17 s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_21 x16 x2 x1 x6
    l s cd cs) (nd_C__case_21 x16 x2 x1 x6 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_21
    x16 x2 x1 x6 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_21 x16
    x2 x1 x6 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_21"
    [show x16, show x2, show x1, show x6, show x4] info)
  _ -> failCons cd (consFail "RegExp._case_21" (showCons x4))

nd_C__case_20 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2
  t0 t0)) -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord
  t0) -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List (C_ORegExp t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))
nd_C__case_20 x17 x16 x2 x1 x18 x6 x19 s cd cs = case x19 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_capture x1 x2 x6 x18 s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_20 x17 x16 x2 x1
    x18 x6 l s cd cs) (nd_C__case_20 x17 x16 x2 x1 x18 x6 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_20 x17
    x16 x2 x1 x18 x6 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_20 x17
    x16 x2 x1 x18 x6 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_20"
    [show x17, show x16, show x2, show x1, show x18, show x6, show x19] info)
  _ -> failCons cd (consFail "RegExp._case_20" (showCons x19))

nd_C__case_22 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
nd_C__case_22 x6 x2 x1 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x14 x15 -> let s0 = s
    in s0 `seq` nd_C_capture x1 x2 x6 x15 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_22 x6 x2 x1 l s
    cd cs) (nd_C__case_22 x6 x2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_22 x6
    x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_22 x6 x2
    x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_22"
    [show x6, show x2, show x1, show x4] info)
  _ -> failCons cd (consFail "RegExp._case_22" (showCons x4))

nd_C__case_24 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
nd_C__case_24 x9 x2 x6 x1 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x10 x11 -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s6 = rightSupply s8
    in s7 `seq` (s6 `seq` nd_C__case_23 x9 x10 x2 x11 x6 x1 (let s5 = leftSupply
                                                                   s6
                                                                 s4 = rightSupply
                                                                   s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_eq_eq
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq_hash_0_hash
    x2 s0 cd cs) s1 cd cs)) x10 s3 cd cs)) x9 s5 cd cs)) s7 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_24 x9 x2 x6 x1
    l s cd cs) (nd_C__case_24 x9 x2 x6 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_24 x9
    x2 x6 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_24 x9 x2
    x6 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_24"
    [show x9, show x2, show x6, show x1, show x4] info)
  _ -> failCons cd (consFail "RegExp._case_24" (showCons x4))

nd_C__case_23 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List (C_ORegExp t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))
nd_C__case_23 x9 x10 x2 x11 x6 x1 x12 s cd cs = case x12 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_capture x1 x2 x6 x11 s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_23 x9 x10 x2 x11
    x6 x1 l s cd cs) (nd_C__case_23 x9 x10 x2 x11 x6 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_23 x9
    x10 x2 x11 x6 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_23 x9 x10
    x2 x11 x6 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_23"
    [show x9, show x10, show x2, show x11, show x6, show x1, show x12] info)
  _ -> failCons cd (consFail "RegExp._case_23" (showCons x12))

nd_C__case_25 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List (C_ORegExp
  t0) -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))
nd_C__case_25 x4 x6 x7 x2 x1 x8 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_capture x1 x2 (Curry_Prelude.d_OP_plus_plus x7 x6 cd cs) x4
    s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C_capture x1 x2 (Curry_Prelude.d_OP_plus_plus x8 x6 cd cs) x4
    s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_25 x4 x6 x7 x2
    x1 x8 l s cd cs) (nd_C__case_25 x4 x6 x7 x2 x1 x8 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_25 x4
    x6 x7 x2 x1 x8 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_25 x4 x6
    x7 x2 x1 x8 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_25"
    [show x4, show x6, show x7, show x2, show x1, show x8, show x9] info)
  _ -> failCons cd (consFail "RegExp._case_25" (showCons x9))

nd_C__case_13 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List t0
  -> C_ORegExp t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
nd_C__case_13 x6 x2 x1 x4 x5 s cd cs = case x5 of
  C_Star x7 -> let s7 = s
    in s7 `seq` (let s0 = leftSupply s7
                     s8 = rightSupply s7
                     s1 = leftSupply s8
                     s6 = rightSupply s8
    in s0 `seq` (s8 `seq` (s1 `seq` (s6 `seq` (let x8 = generate s0 cd
                                                   x9 = generate s1 cd
    in let s5 = leftSupply s6
           s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_12 x9 x6 x2 x1 x8 x7 x4
    (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_eq_colon_eq x4
    (Curry_Prelude.d_OP_plus_plus x8 x9 cd cs) cd cs) (let s2 = leftSupply s4
                                                           s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (nd_C_match x1 x2
    (Curry_Prelude.OP_Cons (C_Star x7) Curry_Prelude.OP_List) x8 s2 cd cs)
    (nd_C_match x1 x2 x6 x9 s3 cd cs) cd cs)) cd cs) s5 cd cs))))))
  C_Nil -> Curry_Prelude.d_C_failed cd cs
  C_Literal x10 -> Curry_Prelude.d_C_failed cd cs
  C_Xor x11 x12 -> Curry_Prelude.d_C_failed cd cs
  C_Plus x13 -> Curry_Prelude.d_C_failed cd cs
  C_AnyLiteral -> Curry_Prelude.d_C_failed cd cs
  C_Bracket x14 -> Curry_Prelude.d_C_failed cd cs
  C_NegBracket x15 -> Curry_Prelude.d_C_failed cd cs
  C_Start x16 -> Curry_Prelude.d_C_failed cd cs
  C_End x17 -> Curry_Prelude.d_C_failed cd cs
  C_Times x18 x19 -> Curry_Prelude.d_C_failed cd cs
  C_Capture x20 x21 -> Curry_Prelude.d_C_failed cd cs
  Choice_C_ORegExp d i l r -> narrow d i (nd_C__case_13 x6 x2 x1 x4 l s cd cs)
    (nd_C__case_13 x6 x2 x1 x4 r s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C__case_13 x6 x2 x1 x4 z
    s cd cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C__case_13 x6 x2 x1 x4 e s
    cd x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_13" [show x6
    , show x2, show x1, show x4, show x5] info)
  _ -> failCons cd (consFail "RegExp._case_13" (showCons x5))

nd_C__case_12 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> Curry_Prelude.OP_List (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))
nd_C__case_12 x9 x6 x2 x1 x8 x7 x4 x10 s cd cs = case x10 of
  Curry_Prelude.C_True -> let s8 = s
    in s8 `seq` (let s5 = leftSupply s8
                     s7 = rightSupply s8
    in s5 `seq` (s7 `seq` Curry_Prelude.d_OP_plus_plus (let s4 = leftSupply s5
                                                            s6 = rightSupply s5
                                                            s0 = leftSupply s6
                                                            s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_concat s0 cd cs) (let s2 = leftSupply s3
                                              s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_map (wrapNX id (nd_C_capture x1 x2
    x7)) (nd_C_grepShow x1 x2 x7 x8 s1 cd cs) s2 cd cs)) s4 cd cs))))
    (nd_C_capture x1 x2 x6 x9 s7 cd cs) cd cs))
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_12 x9 x6 x2 x1
    x8 x7 x4 l s cd cs) (nd_C__case_12 x9 x6 x2 x1 x8 x7 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_12 x9
    x6 x2 x1 x8 x7 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_12 x9 x6
    x2 x1 x8 x7 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_12"
    [show x9, show x6, show x2, show x1, show x8, show x7, show x4, show x10]
    info)
  _ -> failCons cd (consFail "RegExp._case_12" (showCons x10))

nd_C__case_11 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List t0
  -> C_ORegExp t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
nd_C__case_11 x6 x2 x1 x4 x5 s cd cs = case x5 of
  C_Start x7 -> let s0 = s in s0 `seq` nd_C__case_10 x2 x1 x4 x7 x6 s0 cd cs
  C_Nil -> Curry_Prelude.d_C_failed cd cs
  C_Literal x12 -> Curry_Prelude.d_C_failed cd cs
  C_Xor x13 x14 -> Curry_Prelude.d_C_failed cd cs
  C_Star x15 -> Curry_Prelude.d_C_failed cd cs
  C_Plus x16 -> Curry_Prelude.d_C_failed cd cs
  C_AnyLiteral -> Curry_Prelude.d_C_failed cd cs
  C_Bracket x17 -> Curry_Prelude.d_C_failed cd cs
  C_NegBracket x18 -> Curry_Prelude.d_C_failed cd cs
  C_End x19 -> Curry_Prelude.d_C_failed cd cs
  C_Times x20 x21 -> Curry_Prelude.d_C_failed cd cs
  C_Capture x22 x23 -> Curry_Prelude.d_C_failed cd cs
  Choice_C_ORegExp d i l r -> narrow d i (nd_C__case_11 x6 x2 x1 x4 l s cd cs)
    (nd_C__case_11 x6 x2 x1 x4 r s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C__case_11 x6 x2 x1 x4 z
    s cd cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C__case_11 x6 x2 x1 x4 e s
    cd x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_11" [show x6
    , show x2, show x1, show x4, show x5] info)
  _ -> failCons cd (consFail "RegExp._case_11" (showCons x5))

nd_C__case_10 :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List (C_ORegExp t0)
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))
nd_C__case_10 x2 x1 x4 x7 x6 s cd cs = case x6 of
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_9 x4 x7 x2 x1 (nd_C_match x1 x2
    (Curry_Prelude.OP_Cons (C_Start x7) Curry_Prelude.OP_List) x4 s0 cd cs) s1
    cd cs))
  Curry_Prelude.OP_Cons x8 x9 -> let s7 = s
    in s7 `seq` (let s0 = leftSupply s7
                     s8 = rightSupply s7
                     s1 = leftSupply s8
                     s6 = rightSupply s8
    in s0 `seq` (s8 `seq` (s1 `seq` (s6 `seq` (let x10 = generate s0 cd
                                                   x11 = generate s1 cd
    in let s5 = leftSupply s6
           s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_8 x11 x6 x2 x1 x4 x7 x10
    (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_eq_colon_eq x4
    (Curry_Prelude.d_OP_plus_plus x10 x11 cd cs) cd cs) (let s2 = leftSupply s4
                                                             s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (nd_C_match x1 x2
    (Curry_Prelude.OP_Cons (C_Start x7) x6) x4 s2 cd cs) (nd_C_match x1 x2 x6
    x11 s3 cd cs) cd cs)) cd cs) s5 cd cs))))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_10 x2 x1 x4 x7
    l s cd cs) (nd_C__case_10 x2 x1 x4 x7 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_10 x2
    x1 x4 x7 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_10 x2 x1
    x4 x7 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_10"
    [show x2, show x1, show x4, show x7, show x6] info)
  _ -> failCons cd (consFail "RegExp._case_10" (showCons x6))

nd_C__case_8 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))
nd_C__case_8 x11 x6 x2 x1 x4 x7 x10 x12 s cd cs = case x12 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_capture x1 x2 x7
    x10 s0 cd cs) (nd_C_capture x1 x2 x6 x11 s1 cd cs) cd cs))
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_8 x11 x6 x2 x1
    x4 x7 x10 l s cd cs) (nd_C__case_8 x11 x6 x2 x1 x4 x7 x10 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_8 x11
    x6 x2 x1 x4 x7 x10 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_8 x11 x6
    x2 x1 x4 x7 x10 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_8"
    [show x11, show x6, show x2, show x1, show x4, show x7, show x10, show x12]
    info)
  _ -> failCons cd (consFail "RegExp._case_8" (showCons x12))

nd_C__case_9 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
nd_C__case_9 x4 x7 x2 x1 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C_capture x1 x2 x7 (Curry_Prelude.d_C_head
    (nd_C_grepShow x1 x2 x7 x4 s0 cd cs) cd cs) s1 cd cs))
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_9 x4 x7 x2 x1 l
    s cd cs) (nd_C__case_9 x4 x7 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_9 x4
    x7 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_9 x4 x7
    x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_9"
    [show x4, show x7, show x2, show x1, show x8] info)
  _ -> failCons cd (consFail "RegExp._case_9" (showCons x8))

nd_C__case_7 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))
nd_C__case_7 x6 x5 x2 x1 x4 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_capture x1 x2 x5 x6 s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_7 x6 x5 x2 x1 x4
    l s cd cs) (nd_C__case_7 x6 x5 x2 x1 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_7 x6
    x5 x2 x1 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_7 x6 x5
    x2 x1 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_7"
    [show x6, show x5, show x2, show x1, show x4, show x7] info)
  _ -> failCons cd (consFail "RegExp._case_7" (showCons x7))

nd_C__case_6 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List t0
  -> C_ORegExp t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
nd_C__case_6 x6 x2 x1 x4 x5 s cd cs = case x5 of
  C_Times x7 x8 -> let s0 = s
    in s0 `seq` nd_C__case_5 x6 x2 x1 x8 x4 x7 s0 cd cs
  C_Nil -> Curry_Prelude.d_C_failed cd cs
  C_Literal x13 -> Curry_Prelude.d_C_failed cd cs
  C_Xor x14 x15 -> Curry_Prelude.d_C_failed cd cs
  C_Star x16 -> Curry_Prelude.d_C_failed cd cs
  C_Plus x17 -> Curry_Prelude.d_C_failed cd cs
  C_AnyLiteral -> Curry_Prelude.d_C_failed cd cs
  C_Bracket x18 -> Curry_Prelude.d_C_failed cd cs
  C_NegBracket x19 -> Curry_Prelude.d_C_failed cd cs
  C_Start x20 -> Curry_Prelude.d_C_failed cd cs
  C_End x21 -> Curry_Prelude.d_C_failed cd cs
  C_Capture x22 x23 -> Curry_Prelude.d_C_failed cd cs
  Choice_C_ORegExp d i l r -> narrow d i (nd_C__case_6 x6 x2 x1 x4 l s cd cs)
    (nd_C__case_6 x6 x2 x1 x4 r s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C__case_6 x6 x2 x1 x4 z s
    cd cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C__case_6 x6 x2 x1 x4 e s cd
    x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_6" [show x6, show
    x2, show x1, show x4, show x5] info)
  _ -> failCons cd (consFail "RegExp._case_6" (showCons x5))

nd_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List
  (C_ORegExp t0) -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))
nd_C__case_5 x6 x2 x1 x8 x4 x7 s cd cs = case x7 of
  Curry_Prelude.OP_Tuple2 x9 x10 -> let s7 = s
    in s7 `seq` (let s0 = leftSupply s7
                     s8 = rightSupply s7
                     s1 = leftSupply s8
                     s6 = rightSupply s8
    in s0 `seq` (s8 `seq` (s1 `seq` (s6 `seq` (let x11 = generate s0 cd
                                                   x12 = generate s1 cd
    in let s5 = leftSupply s6
           s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_4 x12 x6 x2 x1 x11 x8 x10 x9 x4
    (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_eq_colon_eq x4
    (Curry_Prelude.d_OP_plus_plus x11 x12 cd cs) cd cs) (let s2 = leftSupply s4
                                                             s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (nd_C_match x1 x2
    (Curry_Prelude.OP_Cons (C_Times (Curry_Prelude.OP_Tuple2 x9 x10) x8)
    Curry_Prelude.OP_List) x11 s2 cd cs) (nd_C_match x1 x2 x6 x12 s3 cd cs) cd
    cs)) cd cs) s5 cd cs))))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_5 x6 x2 x1 x8
    x4 l s cd cs) (nd_C__case_5 x6 x2 x1 x8 x4 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_5
    x6 x2 x1 x8 x4 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_5 x6
    x2 x1 x8 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "RegExp._case_5"
    [show x6, show x2, show x1, show x8, show x4, show x7] info)
  _ -> failCons cd (consFail "RegExp._case_5" (showCons x7))

nd_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
nd_C__case_4 x12 x6 x2 x1 x11 x8 x10 x9 x4 x13 s cd cs = case x13 of
  Curry_Prelude.C_True -> let s8 = s
    in s8 `seq` (let s5 = leftSupply s8
                     s7 = rightSupply s8
    in s5 `seq` (s7 `seq` Curry_Prelude.d_OP_plus_plus (let s4 = leftSupply s5
                                                            s6 = rightSupply s5
                                                            s0 = leftSupply s6
                                                            s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Curry_Prelude.nd_C_concat s0 cd cs) (let s2 = leftSupply s3
                                              s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_map (wrapNX id (nd_C_capture x1 x2
    x8)) (nd_C_grepShow x1 x2 x8 x11 s1 cd cs) s2 cd cs)) s4 cd cs))))
    (nd_C_capture x1 x2 x6 x12 s7 cd cs) cd cs))
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_4 x12 x6 x2 x1
    x11 x8 x10 x9 x4 l s cd cs) (nd_C__case_4 x12 x6 x2 x1 x11 x8 x10 x9 x4 r s
    cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_4 x12
    x6 x2 x1 x11 x8 x10 x9 x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_4 x12 x6
    x2 x1 x11 x8 x10 x9 x4 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_4"
    [show x12, show x6, show x2, show x1, show x11, show x8, show x10, show x9
    , show x4, show x13] info)
  _ -> failCons cd (consFail "RegExp._case_4" (showCons x13))

nd_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List t0
  -> C_ORegExp t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
nd_C__case_3 x6 x2 x1 x4 x5 s cd cs = case x5 of
  C_Capture x7 x8 -> let s7 = s
    in s7 `seq` (let s0 = leftSupply s7
                     s8 = rightSupply s7
                     s1 = leftSupply s8
                     s6 = rightSupply s8
    in s0 `seq` (s8 `seq` (s1 `seq` (s6 `seq` (let x9 = generate s0 cd
                                                   x10 = generate s1 cd
    in let s5 = leftSupply s6
           s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_2 x10 x6 x2 x1 x9 x8 x4 x7
    (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_eq_colon_eq x4
    (Curry_Prelude.d_OP_plus_plus x9 x10 cd cs) cd cs) (let s2 = leftSupply s4
                                                            s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.d_OP_amp_amp (nd_C_match x1 x2 x8 x9 s2
    cd cs) (nd_C_match x1 x2 x6 x10 s3 cd cs) cd cs)) cd cs) s5 cd cs))))))
  C_Nil -> Curry_Prelude.d_C_failed cd cs
  C_Literal x11 -> Curry_Prelude.d_C_failed cd cs
  C_Xor x12 x13 -> Curry_Prelude.d_C_failed cd cs
  C_Star x14 -> Curry_Prelude.d_C_failed cd cs
  C_Plus x15 -> Curry_Prelude.d_C_failed cd cs
  C_AnyLiteral -> Curry_Prelude.d_C_failed cd cs
  C_Bracket x16 -> Curry_Prelude.d_C_failed cd cs
  C_NegBracket x17 -> Curry_Prelude.d_C_failed cd cs
  C_Start x18 -> Curry_Prelude.d_C_failed cd cs
  C_End x19 -> Curry_Prelude.d_C_failed cd cs
  C_Times x20 x21 -> Curry_Prelude.d_C_failed cd cs
  Choice_C_ORegExp d i l r -> narrow d i (nd_C__case_3 x6 x2 x1 x4 l s cd cs)
    (nd_C__case_3 x6 x2 x1 x4 r s cd cs)
  Choices_C_ORegExp d i xs -> narrows cs d i (\z -> nd_C__case_3 x6 x2 x1 x4 z s
    cd cs) xs
  Guard_C_ORegExp d c e -> guardCons d c ((\x -> nd_C__case_3 x6 x2 x1 x4 e s cd
    x) $! addCs c cs)
  Fail_C_ORegExp d info -> failCons d (traceFail "RegExp._case_3" [show x6, show
    x2, show x1, show x4, show x5] info)
  _ -> failCons cd (consFail "RegExp._case_3" (showCons x5))

nd_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List (C_ORegExp t0) -> Curry_Prelude.OP_List t0
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))
nd_C__case_2 x10 x6 x2 x1 x9 x8 x4 x7 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 x7 (Curry_Prelude.OP_Cons x9
    Curry_Prelude.OP_List)) Curry_Prelude.OP_List) (let s0 = leftSupply s2
                                                        s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus (nd_C_capture x1 x2 x8 x9
    s0 cd cs) (nd_C_capture x1 x2 x6 x10 s1 cd cs) cd cs)) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_2 x10 x6 x2 x1
    x9 x8 x4 x7 l s cd cs) (nd_C__case_2 x10 x6 x2 x1 x9 x8 x4 x7 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_2 x10
    x6 x2 x1 x9 x8 x4 x7 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_2 x10 x6
    x2 x1 x9 x8 x4 x7 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "RegExp._case_2"
    [show x10, show x6, show x2, show x1, show x9, show x8, show x4, show x7
    , show x11] info)
  _ -> failCons cd (consFail "RegExp._case_2" (showCons x11))

d_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0))) -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
d_C__case_1 x5 x2 x1 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let x8 = Curry_Prelude.d_C_filter
                                         (d_OP_comprime_dot_uscore_hash_lambda15
                                         x6) x5 cd cs
    in d_C__case_0 x5 x6 x2 x1 x7 x8 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_1 x5 x2 x1 l
    cd cs) (d_C__case_1 x5 x2 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_1 x5
    x2 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_1 x5 x2
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "RegExp._case_1"
    [show x5, show x2, show x1, show x4] info)
  _ -> failCons cd (consFail "RegExp._case_1" (showCons x4))

nd_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0))) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0))
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0)))
nd_C__case_1 x5 x2 x1 x4 s cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` (let x8 = Curry_Prelude.nd_C_filter (wrapDX id
                                 (d_OP_comprime_dot_uscore_hash_lambda15 x6)) x5
                                 s0 cd cs
    in nd_C__case_0 x5 x6 x2 x1 x7 x8 s1 cd cs)))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_1 x5 x2 x1 l
    s cd cs) (nd_C__case_1 x5 x2 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_1
    x5 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> nd_C__case_1 x5
    x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "RegExp._case_1"
    [show x5, show x2, show x1, show x4] info)
  _ -> failCons cd (consFail "RegExp._case_1" (showCons x4))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0))) -> Curry_Prelude.C_Int -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))
d_C__case_0 x5 x6 x2 x1 x7 x8 cd cs = case x8 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x6 x7)
    (d_C_comprime x1 x2 x5 cd cs)
  Curry_Prelude.OP_Cons x9 x10 -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    x6 (Curry_Prelude.d_OP_plus_plus x7 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_concatMap Curry_Prelude.d_C_snd cd cs) x8 cd cs) cd cs))
    (d_C_comprime x1 x2 (Curry_Prelude.d_C_filter
    (d_OP_comprime_dot_uscore_hash_lambda17 x6) x5 cd cs) cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_0 x5 x6 x2 x1 x7
    l cd cs) (d_C__case_0 x5 x6 x2 x1 x7 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_0 x5
    x6 x2 x1 x7 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_0 x5 x6
    x2 x1 x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_0"
    [show x5, show x6, show x2, show x1, show x7, show x8] info)
  _ -> failCons cd (consFail "RegExp._case_0" (showCons x8))

nd_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0))) -> Curry_Prelude.C_Int -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0))) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)))
nd_C__case_0 x5 x6 x2 x1 x7 x8 s cd cs = case x8 of
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x6 x7)
    (nd_C_comprime x1 x2 x5 s0 cd cs)
  Curry_Prelude.OP_Cons x9 x10 -> let s6 = s
    in s6 `seq` (let s2 = leftSupply s6
                     s5 = rightSupply s6
    in s2 `seq` (s5 `seq` Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x6
    (Curry_Prelude.d_OP_plus_plus x7 (let s1 = leftSupply s2
                                          s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_concatMap
    (wrapDX id Curry_Prelude.d_C_snd) s0 cd cs) x8 s1 cd cs)) cd cs))
    (let s4 = leftSupply s5
         s3 = rightSupply s5
    in s4 `seq` (s3 `seq` nd_C_comprime x1 x2 (Curry_Prelude.nd_C_filter (wrapDX
    id (d_OP_comprime_dot_uscore_hash_lambda17 x6)) x5 s3 cd cs) s4 cd cs))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_0 x5 x6 x2 x1
    x7 l s cd cs) (nd_C__case_0 x5 x6 x2 x1 x7 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_0 x5
    x6 x2 x1 x7 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> nd_C__case_0 x5 x6
    x2 x1 x7 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "RegExp._case_0"
    [show x5, show x6, show x2, show x1, show x7, show x8] info)
  _ -> failCons cd (consFail "RegExp._case_0" (showCons x8))

